deferred class
	S_DIRENT

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	scandir (a_dir: CE_POINTER [INTEGER_8]; a_namelist: CE_POINTER [CE_POINTER [CE_POINTER [SD_DIRENT]]]; a_selector: CE_ROUTINE; a_cmp: CE_ROUTINE): INTEGER_32
		do
			Result := c_scandir (a_dir.c_pointer, a_namelist.c_pointer, a_selector.c_pointer, a_cmp.c_pointer)
		end

	c_scandir (a_dir: POINTER; a_namelist: POINTER; a_selector: POINTER; a_cmp: POINTER): INTEGER_32
		external
			"C inline use <micro_httpd.h>"
		alias
			"return scandir($a_dir, $a_namelist, $a_selector, $a_cmp);"
		end

	alphasort (a_e1: CE_POINTER [CE_POINTER [SD_DIRENT]]; a_e2: CE_POINTER [CE_POINTER [SD_DIRENT]]): INTEGER_32
		do
			Result := c_alphasort (a_e1.c_pointer, a_e2.c_pointer)
		end

	c_alphasort (a_e1: POINTER; a_e2: POINTER): INTEGER_32
		external
			"C inline use <micro_httpd.h>"
		alias
			"return alphasort($a_e1, $a_e2);"
		end

	alphasort_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent alphasort)
		end

end
