deferred class
	S_STRING

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	strcmp (a_s1: CE_POINTER [INTEGER_8]; a_s2: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_strcmp (a_s1.c_pointer, a_s2.c_pointer)
		end

	c_strcmp (a_s1: POINTER; a_s2: POINTER): INTEGER_32
		external
			"C inline use <micro_httpd.h>"
		alias
			"return strcmp($a_s1, $a_s2);"
		end

	strncmp (a_s1: CE_POINTER [INTEGER_8]; a_s2: CE_POINTER [INTEGER_8]; a_n: NATURAL_32): INTEGER_32
		do
			Result := c_strncmp (a_s1.c_pointer, a_s2.c_pointer, a_n)
		end

	c_strncmp (a_s1: POINTER; a_s2: POINTER; a_n: NATURAL_32): INTEGER_32
		external
			"C inline use <micro_httpd.h>"
		alias
			"return strncmp($a_s1, $a_s2, $a_n);"
		end

	strchr (a_s: CE_POINTER [INTEGER_8]; a_c: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strchr (a_s.c_pointer, a_c))
		end

	c_strchr (a_s: POINTER; a_c: INTEGER_32): POINTER
		external
			"C inline use <micro_httpd.h>"
		alias
			"return strchr($a_s, $a_c);"
		end

	strrchr (a_s: CE_POINTER [INTEGER_8]; a_c: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strrchr (a_s.c_pointer, a_c))
		end

	c_strrchr (a_s: POINTER; a_c: INTEGER_32): POINTER
		external
			"C inline use <micro_httpd.h>"
		alias
			"return strrchr($a_s, $a_c);"
		end

	strstr (a_haystack: CE_POINTER [INTEGER_8]; a_needle: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strstr (a_haystack.c_pointer, a_needle.c_pointer))
		end

	c_strstr (a_haystack: POINTER; a_needle: POINTER): POINTER
		external
			"C inline use <micro_httpd.h>"
		alias
			"return strstr($a_haystack, $a_needle);"
		end

	strlen (a_s: CE_POINTER [INTEGER_8]): NATURAL_32
		do
			Result := c_strlen (a_s.c_pointer)
		end

	c_strlen (a_s: POINTER): NATURAL_32
		external
			"C inline use <micro_httpd.h>"
		alias
			"return strlen($a_s);"
		end

	strcasecmp (a_s1: CE_POINTER [INTEGER_8]; a_s2: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_strcasecmp (a_s1.c_pointer, a_s2.c_pointer)
		end

	c_strcasecmp (a_s1: POINTER; a_s2: POINTER): INTEGER_32
		external
			"C inline use <micro_httpd.h>"
		alias
			"return strcasecmp($a_s1, $a_s2);"
		end

end
