deferred class
	S_SYS_STAT

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	stat (a_file: CE_POINTER [INTEGER_8]; a_buf: CE_POINTER [SD_STAT]): INTEGER_32
		do
			Result := c_stat (a_file.c_pointer, a_buf.c_pointer)
		end

	c_stat (a_file: POINTER; a_buf: POINTER): INTEGER_32
		external
			"C inline use <micro_httpd.h>"
		alias
			"return stat($a_file, $a_buf);"
		end

	lstat (a_file: CE_POINTER [INTEGER_8]; a_buf: CE_POINTER [SD_STAT]): INTEGER_32
		do
			Result := c_lstat (a_file.c_pointer, a_buf.c_pointer)
		end

	c_lstat (a_file: POINTER; a_buf: POINTER): INTEGER_32
		external
			"C inline use <micro_httpd.h>"
		alias
			"return lstat($a_file, $a_buf);"
		end

end
