class
	PD_TRANSFORM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	mx: REAL_64 assign set_mx
		do
			Result := c_mx (c_pointer)
		end

	bx: REAL_64 assign set_bx
		do
			Result := c_bx (c_pointer)
		end

	my: REAL_64 assign set_my
		do
			Result := c_my (c_pointer)
		end

	by: REAL_64 assign set_by
		do
			Result := c_by (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_mx (a_mx: REAL_64)
		do
			c_set_mx (c_pointer, a_mx)
		end

	set_bx (a_bx: REAL_64)
		do
			c_set_bx (c_pointer, a_bx)
		end

	set_my (a_my: REAL_64)
		do
			c_set_my (c_pointer, a_my)
		end

	set_by (a_by: REAL_64)
		do
			c_set_by (c_pointer, a_by)
		end

feature {NONE} -- C getters

	c_mx (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct _transform *)$tmp)->mx;"
		end

	c_bx (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct _transform *)$tmp)->bx;"
		end

	c_my (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct _transform *)$tmp)->my;"
		end

	c_by (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct _transform *)$tmp)->by;"
		end

feature {NONE} -- C setters

	c_set_mx (tmp: POINTER; a_mx: REAL_64)
		external
			"C inline"
		alias
			"((struct _transform *)$tmp)->mx = $a_mx;"
		end

	c_set_bx (tmp: POINTER; a_bx: REAL_64)
		external
			"C inline"
		alias
			"((struct _transform *)$tmp)->bx = $a_bx;"
		end

	c_set_my (tmp: POINTER; a_my: REAL_64)
		external
			"C inline"
		alias
			"((struct _transform *)$tmp)->my = $a_my;"
		end

	c_set_by (tmp: POINTER; a_by: REAL_64)
		external
			"C inline"
		alias
			"((struct _transform *)$tmp)->by = $a_by;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return sizeof(struct _transform);"
		end

end
