#ifndef XEYES_H
#define XEYES_H

#include <ffi.h>
#include <X11/Xlib.h>
#include <X11/Xresource.h>
#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <X11/CoreP.h>
#include <libio.h>
#include <X11/StringDefs.h>
#include <X11/Xmu/Converters.h>
#include <math.h>
#include <X11/extensions/shape.h>
#include <X11/Shell.h>
#include <stdlib.h>

#undef number
#undef next
#undef free_private
#undef private_data
#undef function
#undef plane_mask
#undef foreground
#undef background
#undef line_width
#undef line_style
#undef cap_style
#undef join_style
#undef fill_style
#undef fill_rule
#undef arc_mode
#undef tile
#undef stipple
#undef ts_x_origin
#undef ts_y_origin
#undef font
#undef subwindow_mode
#undef graphics_exposures
#undef clip_x_origin
#undef clip_y_origin
#undef clip_mask
#undef dash_offset
#undef dashes
#undef ext_data
#undef visualid
#undef class2
#undef red_mask
#undef green_mask
#undef blue_mask
#undef bits_per_rgb
#undef map_entries
#undef depth
#undef nvisuals
#undef visuals
#undef display
#undef root
#undef width
#undef height
#undef mwidth
#undef mheight
#undef ndepths
#undef depths
#undef root_depth
#undef root_visual
#undef default_gc
#undef cmap
#undef white_pixel
#undef black_pixel
#undef max_maps
#undef min_maps
#undef backing_store
#undef save_unders
#undef root_input_mask
#undef background_pixmap
#undef background_pixel
#undef border_pixmap
#undef border_pixel
#undef bit_gravity
#undef win_gravity
#undef backing_planes
#undef backing_pixel
#undef save_under
#undef event_mask
#undef do_not_propagate_mask
#undef override_redirect
#undef colormap
#undef cursor
#undef x
#undef y
#undef type
#undef serial
#undef send_event
#undef window
#undef subwindow
#undef time
#undef x_root
#undef y_root
#undef state
#undef keycode
#undef same_screen
#undef button
#undef is_hint
#undef mode
#undef detail
#undef focus
#undef key_vector
#undef count
#undef drawable
#undef major_code
#undef minor_code
#undef parent
#undef border_width
#undef event
#undef from_configure
#undef above
#undef value_mask
#undef place
#undef atom
#undef selection
#undef owner
#undef requestor
#undef target
#undef property
#undef new
#undef b
#undef s
#undef l
#undef message_type
#undef format
#undef data
#undef request
#undef first_keycode
#undef resourceid
#undef error_code
#undef request_code
#undef xany
#undef xkey
#undef xbutton
#undef xmotion
#undef xcrossing
#undef xfocus
#undef xexpose
#undef xgraphicsexpose
#undef xnoexpose
#undef xvisibility
#undef xcreatewindow
#undef xdestroywindow
#undef xunmap
#undef xmap
#undef xmaprequest
#undef xreparent
#undef xconfigure
#undef xgravity
#undef xresizerequest
#undef xconfigurerequest
#undef xcirculate
#undef xcirculaterequest
#undef xproperty
#undef xselectionclear
#undef xselectionrequest
#undef xselection
#undef xcolormap
#undef xclient
#undef xmapping
#undef xerror
#undef xkeymap
#undef pad
#undef size
#undef addr
#undef string
#undef proc
#undef address_mode
#undef address_id
#undef request_mode
#undef sibling
#undef stack_mode
#undef name
#undef value
#undef callback
#undef closure
#undef resource_name
#undef resource_class
#undef resource_type
#undef resource_size
#undef resource_offset
#undef default_type
#undef default_addr
#undef translations
#undef proc_table
#undef current_state
#undef lastEventTime
#undef self
#undef widget_class
#undef xrm_name
#undef being_destroyed
#undef destroy_callbacks
#undef constraints
#undef managed
#undef sensitive
#undef ancestor_sensitive
#undef event_table
#undef tm
#undef accelerators
#undef popup_list
#undef num_popups
#undef screen
#undef visible
#undef mapped_when_managed
#undef core
#undef superclass
#undef class_name
#undef widget_size
#undef class_initialize
#undef class_part_initialize
#undef class_inited
#undef initialize
#undef initialize_hook
#undef realize
#undef actions
#undef num_actions
#undef resources
#undef num_resources
#undef xrm_class
#undef compress_motion
#undef compress_exposure
#undef compress_enterleave
#undef visible_interest
#undef destroy
#undef resize
#undef expose
#undef set_values
#undef set_values_hook
#undef set_values_almost
#undef get_values_hook
#undef accept_focus
#undef version
#undef callback_private
#undef tm_table
#undef query_geometry
#undef display_accelerator
#undef extension
#undef core_class
#undef mx
#undef bx
#undef my
#undef by
#undef puppixel
#undef outline
#undef center
#undef outGC
#undef pupGC
#undef centerGC
#undef shapeGC
#undef reverse_video
#undef shape_window
#undef update
#undef mouse
#undef pupil
#undef t
#undef maskt
#undef interval_id
#undef shape_mask
#undef eyes
#undef dummy
#undef eyes_class
#undef option
#undef specifier
#undef argKind
#undef sbuf
#undef pos
#undef flags
#undef IO_read_ptr
#undef IO_read_end
#undef IO_read_base
#undef IO_write_base
#undef IO_write_ptr
#undef IO_write_end
#undef IO_buf_base
#undef IO_buf_end
#undef IO_save_base
#undef IO_backup_base
#undef IO_save_end
#undef markers
#undef chain
#undef fileno
#undef flags2
#undef old_offset
#undef cur_column
#undef vtable_offset
#undef shortbuf
#undef lock
#undef offset
#undef pad1
#undef pad2
#undef pad3
#undef pad4
#undef pad5
#undef unused2
#undef XCreateGC
#undef XCreatePixmap
#undef XClearWindow
#undef XFillRectangle
#undef XFreePixmap
#undef XQueryPointer
#undef XSetForeground
#undef XtAddConverter
#undef XtAppAddTimeOut
#undef XtRemoveTimeOut
#undef XtWindowOfObject
#undef XtWidgetToApplicationContext
#undef XtGetGC
#undef XtReleaseGC
#undef XtInherit
#undef XtCreateWindow
#undef XmuCvtStringToBackingStore
#undef args
#undef num_args
#undef fromVal
#undef toVal
#undef atan2
#undef __y
#undef __x
#undef cos
#undef sin
#undef hypot
#undef XShapeQueryExtension
#undef XShapeCombineMask
#undef XFillArc
#undef XInternAtom
#undef XCreateBitmapFromData
#undef XSetWMProtocols
#undef XBell
#undef XtParseTranslationTable
#undef XtOverrideTranslations
#undef XtAppAddActions
#undef XtAppMainLoop
#undef XtRealizeWidget
#undef XtDisplay
#undef XtScreen
#undef XtWindow
#undef XtCreateManagedWidget
#undef XtSetLanguageProc
#undef XtAppInitialize
#undef XtDestroyApplicationContext
#undef XtSetValues
#undef exit
#undef __status

struct __anonstruct_XGCValues_25;
struct __anonstruct_Visual_26;
struct __anonstruct_Depth_27;
struct __anonstruct_Screen_28;
struct __anonstruct_XSetWindowAttributes_30;
struct __anonstruct_XPoint_37;
struct __anonstruct_XKeyEvent_45;
struct __anonstruct_XButtonEvent_46;
struct __anonstruct_XMotionEvent_47;
struct __anonstruct_XCrossingEvent_48;
struct __anonstruct_XFocusChangeEvent_49;
struct __anonstruct_XKeymapEvent_50;
struct __anonstruct_XExposeEvent_51;
struct __anonstruct_XGraphicsExposeEvent_52;
struct __anonstruct_XNoExposeEvent_53;
struct __anonstruct_XVisibilityEvent_54;
struct __anonstruct_XCreateWindowEvent_55;
struct __anonstruct_XDestroyWindowEvent_56;
struct __anonstruct_XUnmapEvent_57;
struct __anonstruct_XMapEvent_58;
struct __anonstruct_XMapRequestEvent_59;
struct __anonstruct_XReparentEvent_60;
struct __anonstruct_XConfigureEvent_61;
struct __anonstruct_XGravityEvent_62;
struct __anonstruct_XResizeRequestEvent_63;
struct __anonstruct_XConfigureRequestEvent_64;
struct __anonstruct_XCirculateEvent_65;
struct __anonstruct_XCirculateRequestEvent_66;
struct __anonstruct_XPropertyEvent_67;
struct __anonstruct_XSelectionClearEvent_68;
struct __anonstruct_XSelectionRequestEvent_69;
struct __anonstruct_XSelectionEvent_70;
struct __anonstruct_XColormapEvent_71;
union __anonunion_data_73;
struct __anonstruct_XClientMessageEvent_72;
struct __anonstruct_XMappingEvent_74;
struct __anonstruct_XErrorEvent_75;
struct __anonstruct_XAnyEvent_76;
struct __anonstruct_XrmValue_112;
struct __anonstruct_XtConvertArgRec_116;
struct __anonstruct_XtWidgetGeometry_117;
struct __anonstruct_Arg_119;
struct _transform;
struct _TPoint;
struct __anonstruct_EyesPart_138;
struct _EyesRec;
struct __anonstruct_EyesClassPart_139;
struct _EyesClassRec;
struct __anonstruct_XrmOptionDescRec_107;

typedef struct __anonstruct_EyesPart_138 EyesPart;
typedef struct __anonstruct_EyesClassPart_139 EyesClassPart;

struct __anonstruct_XGCValues_25 {
	int function;
	unsigned long plane_mask;
	unsigned long foreground;
	unsigned long background;
	int line_width;
	int line_style;
	int cap_style;
	int join_style;
	int fill_style;
	int fill_rule;
	int arc_mode;
	unsigned long tile;
	unsigned long stipple;
	int ts_x_origin;
	int ts_y_origin;
	unsigned long font;
	int subwindow_mode;
	int graphics_exposures;
	int clip_x_origin;
	int clip_y_origin;
	unsigned long clip_mask;
	int dash_offset;
	char dashes;
};
struct __anonstruct_Visual_26 {
	struct _XExtData * ext_data;
	unsigned long visualid;
	int class;
	unsigned long red_mask;
	unsigned long green_mask;
	unsigned long blue_mask;
	int bits_per_rgb;
	int map_entries;
};
struct __anonstruct_Depth_27 {
	int depth;
	int nvisuals;
	Visual * visuals;
};
struct __anonstruct_Screen_28 {
	struct _XExtData * ext_data;
	void * display;
	unsigned long root;
	int width;
	int height;
	int mwidth;
	int mheight;
	int ndepths;
	Depth * depths;
	int root_depth;
	Visual * root_visual;
	void * default_gc;
	unsigned long cmap;
	unsigned long white_pixel;
	unsigned long black_pixel;
	int max_maps;
	int min_maps;
	int backing_store;
	int save_unders;
	long root_input_mask;
};
struct __anonstruct_XSetWindowAttributes_30 {
	unsigned long background_pixmap;
	unsigned long background_pixel;
	unsigned long border_pixmap;
	unsigned long border_pixel;
	int bit_gravity;
	int win_gravity;
	int backing_store;
	unsigned long backing_planes;
	unsigned long backing_pixel;
	int save_under;
	long event_mask;
	long do_not_propagate_mask;
	int override_redirect;
	unsigned long colormap;
	unsigned long cursor;
};
struct __anonstruct_XPoint_37 {
	short x;
	short y;
};
struct __anonstruct_XKeyEvent_45 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long window;
	unsigned long root;
	unsigned long subwindow;
	unsigned long time;
	int x;
	int y;
	int x_root;
	int y_root;
	unsigned int state;
	unsigned int keycode;
	int same_screen;
};
struct __anonstruct_XButtonEvent_46 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long window;
	unsigned long root;
	unsigned long subwindow;
	unsigned long time;
	int x;
	int y;
	int x_root;
	int y_root;
	unsigned int state;
	unsigned int button;
	int same_screen;
};
struct __anonstruct_XMotionEvent_47 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long window;
	unsigned long root;
	unsigned long subwindow;
	unsigned long time;
	int x;
	int y;
	int x_root;
	int y_root;
	unsigned int state;
	char is_hint;
	int same_screen;
};
struct __anonstruct_XCrossingEvent_48 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long window;
	unsigned long root;
	unsigned long subwindow;
	unsigned long time;
	int x;
	int y;
	int x_root;
	int y_root;
	int mode;
	int detail;
	int same_screen;
	int focus;
	unsigned int state;
};
struct __anonstruct_XFocusChangeEvent_49 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long window;
	int mode;
	int detail;
};
struct __anonstruct_XKeymapEvent_50 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long window;
	char key_vector[32];
};
struct __anonstruct_XExposeEvent_51 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long window;
	int x;
	int y;
	int width;
	int height;
	int count;
};
struct __anonstruct_XGraphicsExposeEvent_52 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long drawable;
	int x;
	int y;
	int width;
	int height;
	int count;
	int major_code;
	int minor_code;
};
struct __anonstruct_XNoExposeEvent_53 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long drawable;
	int major_code;
	int minor_code;
};
struct __anonstruct_XVisibilityEvent_54 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long window;
	int state;
};
struct __anonstruct_XCreateWindowEvent_55 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long parent;
	unsigned long window;
	int x;
	int y;
	int width;
	int height;
	int border_width;
	int override_redirect;
};
struct __anonstruct_XDestroyWindowEvent_56 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long event;
	unsigned long window;
};
struct __anonstruct_XUnmapEvent_57 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long event;
	unsigned long window;
	int from_configure;
};
struct __anonstruct_XMapEvent_58 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long event;
	unsigned long window;
	int override_redirect;
};
struct __anonstruct_XMapRequestEvent_59 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long parent;
	unsigned long window;
};
struct __anonstruct_XReparentEvent_60 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long event;
	unsigned long window;
	unsigned long parent;
	int x;
	int y;
	int override_redirect;
};
struct __anonstruct_XConfigureEvent_61 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long event;
	unsigned long window;
	int x;
	int y;
	int width;
	int height;
	int border_width;
	unsigned long above;
	int override_redirect;
};
struct __anonstruct_XGravityEvent_62 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long event;
	unsigned long window;
	int x;
	int y;
};
struct __anonstruct_XResizeRequestEvent_63 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long window;
	int width;
	int height;
};
struct __anonstruct_XConfigureRequestEvent_64 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long parent;
	unsigned long window;
	int x;
	int y;
	int width;
	int height;
	int border_width;
	unsigned long above;
	int detail;
	unsigned long value_mask;
};
struct __anonstruct_XCirculateEvent_65 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long event;
	unsigned long window;
	int place;
};
struct __anonstruct_XCirculateRequestEvent_66 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long parent;
	unsigned long window;
	int place;
};
struct __anonstruct_XPropertyEvent_67 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long window;
	unsigned long atom;
	unsigned long time;
	int state;
};
struct __anonstruct_XSelectionClearEvent_68 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long window;
	unsigned long selection;
	unsigned long time;
};
struct __anonstruct_XSelectionRequestEvent_69 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long owner;
	unsigned long requestor;
	unsigned long selection;
	unsigned long target;
	unsigned long property;
	unsigned long time;
};
struct __anonstruct_XSelectionEvent_70 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long requestor;
	unsigned long selection;
	unsigned long target;
	unsigned long property;
	unsigned long time;
};
struct __anonstruct_XColormapEvent_71 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long window;
	unsigned long colormap;
	int new;
	int state;
};
union __anonunion_data_73 {
	char b[20];
	short s[10];
	long l[5];
};
struct __anonstruct_XClientMessageEvent_72 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long window;
	unsigned long message_type;
	int format;
	union __anonunion_data_73 data;
};
struct __anonstruct_XMappingEvent_74 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long window;
	int request;
	int first_keycode;
	int count;
};
struct __anonstruct_XErrorEvent_75 {
	int type;
	void * display;
	unsigned long resourceid;
	unsigned long serial;
	unsigned char error_code;
	unsigned char request_code;
	unsigned char minor_code;
};
struct __anonstruct_XAnyEvent_76 {
	int type;
	unsigned long serial;
	int send_event;
	void * display;
	unsigned long window;
};
struct __anonstruct_XrmValue_112 {
	unsigned int size;
	char * addr;
};
struct __anonstruct_XtConvertArgRec_116 {
	int address_mode;
	void * address_id;
	unsigned int size;
};
struct __anonstruct_XtWidgetGeometry_117 {
	unsigned int request_mode;
	short x;
	short y;
	unsigned short width;
	unsigned short height;
	unsigned short border_width;
	struct _WidgetRec * sibling;
	int stack_mode;
};
struct __anonstruct_Arg_119 {
	char * name;
	long value;
};
struct _transform {
	double mx;
	double bx;
	double my;
	double by;
};
struct _TPoint {
	double x;
	double y;
};
struct __anonstruct_EyesPart_138 {
	unsigned long puppixel;
	unsigned long outline;
	unsigned long center;
	void * outGC;
	void * pupGC;
	void * centerGC;
	void * shapeGC;
	int backing_store;
	char reverse_video;
	char shape_window;
	int update;
	struct _TPoint mouse;
	struct _TPoint pupil[2];
	struct _transform t;
	struct _transform maskt;
	unsigned long interval_id;
	unsigned long shape_mask;
};
struct _EyesRec {
	struct _CorePart core;
	EyesPart eyes;
};
struct __anonstruct_EyesClassPart_139 {
	int dummy;
};
struct _EyesClassRec {
	struct _CoreClassPart core_class;
	EyesClassPart eyes_class;
};
struct __anonstruct_XrmOptionDescRec_107 {
	char * option;
	char * specifier;
	int argKind;
	char * value;
};

#endif
