class
	SD_CORECLASSPART

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	superclass: CE_POINTER [SD_WIDGETCLASSREC] assign set_superclass
		do
			create Result.make_shared (c_superclass (c_pointer))
		end

	class_name: CE_POINTER [INTEGER_8] assign set_class_name
		do
			create Result.make_shared (c_class_name (c_pointer))
		end

	widget_size: NATURAL_32 assign set_widget_size
		do
			Result := c_widget_size (c_pointer)
		end

	class_initialize: CE_ROUTINE assign set_class_initialize
		do
			create Result.make_shared (c_class_initialize (c_pointer))
		end

	class_part_initialize: CE_ROUTINE assign set_class_part_initialize
		do
			create Result.make_shared (c_class_part_initialize (c_pointer))
		end

	class_inited: NATURAL_8 assign set_class_inited
		do
			Result := c_class_inited (c_pointer)
		end

	initialize: CE_ROUTINE assign set_initialize
		do
			create Result.make_shared (c_initialize (c_pointer))
		end

	initialize_hook: CE_ROUTINE assign set_initialize_hook
		do
			create Result.make_shared (c_initialize_hook (c_pointer))
		end

	realize: CE_ROUTINE assign set_realize
		do
			create Result.make_shared (c_realize (c_pointer))
		end

	actions: CE_POINTER [SD_XTACTIONSREC] assign set_actions
		do
			create Result.make_shared (c_actions (c_pointer))
		end

	num_actions: NATURAL_32 assign set_num_actions
		do
			Result := c_num_actions (c_pointer)
		end

	resources: CE_POINTER [SD_XTRESOURCE] assign set_resources
		do
			create Result.make_shared (c_resources (c_pointer))
		end

	num_resources: NATURAL_32 assign set_num_resources
		do
			Result := c_num_resources (c_pointer)
		end

	xrm_class: INTEGER_32 assign set_xrm_class
		do
			Result := c_xrm_class (c_pointer)
		end

	compress_motion: INTEGER_8 assign set_compress_motion
		do
			Result := c_compress_motion (c_pointer)
		end

	compress_exposure: NATURAL_8 assign set_compress_exposure
		do
			Result := c_compress_exposure (c_pointer)
		end

	compress_enterleave: INTEGER_8 assign set_compress_enterleave
		do
			Result := c_compress_enterleave (c_pointer)
		end

	visible_interest: INTEGER_8 assign set_visible_interest
		do
			Result := c_visible_interest (c_pointer)
		end

	destroy: CE_ROUTINE assign set_destroy
		do
			create Result.make_shared (c_destroy (c_pointer))
		end

	resize: CE_ROUTINE assign set_resize
		do
			create Result.make_shared (c_resize (c_pointer))
		end

	expose: CE_ROUTINE assign set_expose
		do
			create Result.make_shared (c_expose (c_pointer))
		end

	set_values: CE_ROUTINE assign set_set_values
		do
			create Result.make_shared (c_set_values (c_pointer))
		end

	set_values_hook: CE_ROUTINE assign set_set_values_hook
		do
			create Result.make_shared (c_set_values_hook (c_pointer))
		end

	set_values_almost: CE_ROUTINE assign set_set_values_almost
		do
			create Result.make_shared (c_set_values_almost (c_pointer))
		end

	get_values_hook: CE_ROUTINE assign set_get_values_hook
		do
			create Result.make_shared (c_get_values_hook (c_pointer))
		end

	accept_focus: CE_ROUTINE assign set_accept_focus
		do
			create Result.make_shared (c_accept_focus (c_pointer))
		end

	version: NATURAL_32 assign set_version
		do
			Result := c_version (c_pointer)
		end

	callback_private: CE_POINTER [ANY] assign set_callback_private
		do
			create Result.make_shared (c_callback_private (c_pointer))
		end

	tm_table: CE_POINTER [INTEGER_8] assign set_tm_table
		do
			create Result.make_shared (c_tm_table (c_pointer))
		end

	query_geometry: CE_ROUTINE assign set_query_geometry
		do
			create Result.make_shared (c_query_geometry (c_pointer))
		end

	display_accelerator: CE_ROUTINE assign set_display_accelerator
		do
			create Result.make_shared (c_display_accelerator (c_pointer))
		end

	extension: CE_POINTER [ANY] assign set_extension
		do
			create Result.make_shared (c_extension (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_superclass (a_superclass: CE_POINTER [SD_WIDGETCLASSREC])
		do
			c_set_superclass (c_pointer, a_superclass.c_pointer)
		end

	set_class_name (a_class_name: CE_POINTER [INTEGER_8])
		do
			c_set_class_name (c_pointer, a_class_name.c_pointer)
		end

	set_widget_size (a_widget_size: NATURAL_32)
		do
			c_set_widget_size (c_pointer, a_widget_size)
		end

	set_class_initialize (a_class_initialize: CE_ROUTINE)
		do
			c_set_class_initialize (c_pointer, a_class_initialize.c_pointer)
		end

	set_class_part_initialize (a_class_part_initialize: CE_ROUTINE)
		do
			c_set_class_part_initialize (c_pointer, a_class_part_initialize.c_pointer)
		end

	set_class_inited (a_class_inited: NATURAL_8)
		do
			c_set_class_inited (c_pointer, a_class_inited)
		end

	set_initialize (a_initialize: CE_ROUTINE)
		do
			c_set_initialize (c_pointer, a_initialize.c_pointer)
		end

	set_initialize_hook (a_initialize_hook: CE_ROUTINE)
		do
			c_set_initialize_hook (c_pointer, a_initialize_hook.c_pointer)
		end

	set_realize (a_realize: CE_ROUTINE)
		do
			c_set_realize (c_pointer, a_realize.c_pointer)
		end

	set_actions (a_actions: CE_POINTER [SD_XTACTIONSREC])
		do
			c_set_actions (c_pointer, a_actions.c_pointer)
		end

	set_num_actions (a_num_actions: NATURAL_32)
		do
			c_set_num_actions (c_pointer, a_num_actions)
		end

	set_resources (a_resources: CE_POINTER [SD_XTRESOURCE])
		do
			c_set_resources (c_pointer, a_resources.c_pointer)
		end

	set_num_resources (a_num_resources: NATURAL_32)
		do
			c_set_num_resources (c_pointer, a_num_resources)
		end

	set_xrm_class (a_xrm_class: INTEGER_32)
		do
			c_set_xrm_class (c_pointer, a_xrm_class)
		end

	set_compress_motion (a_compress_motion: INTEGER_8)
		do
			c_set_compress_motion (c_pointer, a_compress_motion)
		end

	set_compress_exposure (a_compress_exposure: NATURAL_8)
		do
			c_set_compress_exposure (c_pointer, a_compress_exposure)
		end

	set_compress_enterleave (a_compress_enterleave: INTEGER_8)
		do
			c_set_compress_enterleave (c_pointer, a_compress_enterleave)
		end

	set_visible_interest (a_visible_interest: INTEGER_8)
		do
			c_set_visible_interest (c_pointer, a_visible_interest)
		end

	set_destroy (a_destroy: CE_ROUTINE)
		do
			c_set_destroy (c_pointer, a_destroy.c_pointer)
		end

	set_resize (a_resize: CE_ROUTINE)
		do
			c_set_resize (c_pointer, a_resize.c_pointer)
		end

	set_expose (a_expose: CE_ROUTINE)
		do
			c_set_expose (c_pointer, a_expose.c_pointer)
		end

	set_set_values (a_set_values: CE_ROUTINE)
		do
			c_set_set_values (c_pointer, a_set_values.c_pointer)
		end

	set_set_values_hook (a_set_values_hook: CE_ROUTINE)
		do
			c_set_set_values_hook (c_pointer, a_set_values_hook.c_pointer)
		end

	set_set_values_almost (a_set_values_almost: CE_ROUTINE)
		do
			c_set_set_values_almost (c_pointer, a_set_values_almost.c_pointer)
		end

	set_get_values_hook (a_get_values_hook: CE_ROUTINE)
		do
			c_set_get_values_hook (c_pointer, a_get_values_hook.c_pointer)
		end

	set_accept_focus (a_accept_focus: CE_ROUTINE)
		do
			c_set_accept_focus (c_pointer, a_accept_focus.c_pointer)
		end

	set_version (a_version: NATURAL_32)
		do
			c_set_version (c_pointer, a_version)
		end

	set_callback_private (a_callback_private: CE_POINTER [ANY])
		do
			c_set_callback_private (c_pointer, a_callback_private.c_pointer)
		end

	set_tm_table (a_tm_table: CE_POINTER [INTEGER_8])
		do
			c_set_tm_table (c_pointer, a_tm_table.c_pointer)
		end

	set_query_geometry (a_query_geometry: CE_ROUTINE)
		do
			c_set_query_geometry (c_pointer, a_query_geometry.c_pointer)
		end

	set_display_accelerator (a_display_accelerator: CE_ROUTINE)
		do
			c_set_display_accelerator (c_pointer, a_display_accelerator.c_pointer)
		end

	set_extension (a_extension: CE_POINTER [ANY])
		do
			c_set_extension (c_pointer, a_extension.c_pointer)
		end

feature {NONE} -- C getters

	c_superclass (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _WidgetClassRec *)((struct _CoreClassPart *)$tmp)->superclass;"
		end

	c_class_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _CoreClassPart *)$tmp)->class_name;"
		end

	c_widget_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _CoreClassPart *)$tmp)->widget_size;"
		end

	c_class_initialize (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)())((struct _CoreClassPart *)$tmp)->class_initialize;"
		end

	c_class_part_initialize (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _WidgetClassRec *))((struct _CoreClassPart *)$tmp)->class_part_initialize;"
		end

	c_class_inited (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct _CoreClassPart *)$tmp)->class_inited;"
		end

	c_initialize (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _WidgetRec *, struct _WidgetRec *, Arg *, unsigned int *))((struct _CoreClassPart *)$tmp)->initialize;"
		end

	c_initialize_hook (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _WidgetRec *, Arg *, unsigned int *))((struct _CoreClassPart *)$tmp)->initialize_hook;"
		end

	c_realize (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _WidgetRec *, unsigned long *, XSetWindowAttributes *))((struct _CoreClassPart *)$tmp)->realize;"
		end

	c_actions (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _XtActionsRec *)((struct _CoreClassPart *)$tmp)->actions;"
		end

	c_num_actions (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _CoreClassPart *)$tmp)->num_actions;"
		end

	c_resources (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _XtResource *)((struct _CoreClassPart *)$tmp)->resources;"
		end

	c_num_resources (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _CoreClassPart *)$tmp)->num_resources;"
		end

	c_xrm_class (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _CoreClassPart *)$tmp)->xrm_class;"
		end

	c_compress_motion (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct _CoreClassPart *)$tmp)->compress_motion;"
		end

	c_compress_exposure (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct _CoreClassPart *)$tmp)->compress_exposure;"
		end

	c_compress_enterleave (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct _CoreClassPart *)$tmp)->compress_enterleave;"
		end

	c_visible_interest (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct _CoreClassPart *)$tmp)->visible_interest;"
		end

	c_destroy (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _WidgetRec *))((struct _CoreClassPart *)$tmp)->destroy;"
		end

	c_resize (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _WidgetRec *))((struct _CoreClassPart *)$tmp)->resize;"
		end

	c_expose (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _WidgetRec *, union _XEvent *, void *))((struct _CoreClassPart *)$tmp)->expose;"
		end

	c_set_values (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char( *)(struct _WidgetRec *, struct _WidgetRec *, struct _WidgetRec *, Arg *, unsigned int *))((struct _CoreClassPart *)$tmp)->set_values;"
		end

	c_set_values_hook (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char( *)(struct _WidgetRec *, Arg *, unsigned int *))((struct _CoreClassPart *)$tmp)->set_values_hook;"
		end

	c_set_values_almost (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _WidgetRec *, struct _WidgetRec *, XtWidgetGeometry *, XtWidgetGeometry *))((struct _CoreClassPart *)$tmp)->set_values_almost;"
		end

	c_get_values_hook (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _WidgetRec *, Arg *, unsigned int *))((struct _CoreClassPart *)$tmp)->get_values_hook;"
		end

	c_accept_focus (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char( *)(struct _WidgetRec *, unsigned long *))((struct _CoreClassPart *)$tmp)->accept_focus;"
		end

	c_version (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct _CoreClassPart *)$tmp)->version;"
		end

	c_callback_private (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _CoreClassPart *)$tmp)->callback_private;"
		end

	c_tm_table (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _CoreClassPart *)$tmp)->tm_table;"
		end

	c_query_geometry (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct _WidgetRec *, XtWidgetGeometry *, XtWidgetGeometry *))((struct _CoreClassPart *)$tmp)->query_geometry;"
		end

	c_display_accelerator (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _WidgetRec *, char *))((struct _CoreClassPart *)$tmp)->display_accelerator;"
		end

	c_extension (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _CoreClassPart *)$tmp)->extension;"
		end

feature {NONE} -- C setters

	c_set_superclass (tmp: POINTER; a_superclass: POINTER)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->superclass = (struct _WidgetClassRec *)$a_superclass;"
		end

	c_set_class_name (tmp: POINTER; a_class_name: POINTER)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->class_name = (char *)$a_class_name;"
		end

	c_set_widget_size (tmp: POINTER; a_widget_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->widget_size = $a_widget_size;"
		end

	c_set_class_initialize (tmp: POINTER; a_class_initialize: POINTER)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->class_initialize = (void( *)())$a_class_initialize;"
		end

	c_set_class_part_initialize (tmp: POINTER; a_class_part_initialize: POINTER)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->class_part_initialize = (void( *)(struct _WidgetClassRec *))$a_class_part_initialize;"
		end

	c_set_class_inited (tmp: POINTER; a_class_inited: NATURAL_8)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->class_inited = $a_class_inited;"
		end

	c_set_initialize (tmp: POINTER; a_initialize: POINTER)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->initialize = (void( *)(struct _WidgetRec *, struct _WidgetRec *, Arg *, unsigned int *))$a_initialize;"
		end

	c_set_initialize_hook (tmp: POINTER; a_initialize_hook: POINTER)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->initialize_hook = (void( *)(struct _WidgetRec *, Arg *, unsigned int *))$a_initialize_hook;"
		end

	c_set_realize (tmp: POINTER; a_realize: POINTER)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->realize = (void( *)(struct _WidgetRec *, unsigned long *, XSetWindowAttributes *))$a_realize;"
		end

	c_set_actions (tmp: POINTER; a_actions: POINTER)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->actions = (struct _XtActionsRec *)$a_actions;"
		end

	c_set_num_actions (tmp: POINTER; a_num_actions: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->num_actions = $a_num_actions;"
		end

	c_set_resources (tmp: POINTER; a_resources: POINTER)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->resources = (struct _XtResource *)$a_resources;"
		end

	c_set_num_resources (tmp: POINTER; a_num_resources: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->num_resources = $a_num_resources;"
		end

	c_set_xrm_class (tmp: POINTER; a_xrm_class: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->xrm_class = $a_xrm_class;"
		end

	c_set_compress_motion (tmp: POINTER; a_compress_motion: INTEGER_8)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->compress_motion = $a_compress_motion;"
		end

	c_set_compress_exposure (tmp: POINTER; a_compress_exposure: NATURAL_8)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->compress_exposure = $a_compress_exposure;"
		end

	c_set_compress_enterleave (tmp: POINTER; a_compress_enterleave: INTEGER_8)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->compress_enterleave = $a_compress_enterleave;"
		end

	c_set_visible_interest (tmp: POINTER; a_visible_interest: INTEGER_8)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->visible_interest = $a_visible_interest;"
		end

	c_set_destroy (tmp: POINTER; a_destroy: POINTER)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->destroy = (void( *)(struct _WidgetRec *))$a_destroy;"
		end

	c_set_resize (tmp: POINTER; a_resize: POINTER)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->resize = (void( *)(struct _WidgetRec *))$a_resize;"
		end

	c_set_expose (tmp: POINTER; a_expose: POINTER)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->expose = (void( *)(struct _WidgetRec *, union _XEvent *, void *))$a_expose;"
		end

	c_set_set_values (tmp: POINTER; a_set_values: POINTER)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->set_values = (char( *)(struct _WidgetRec *, struct _WidgetRec *, struct _WidgetRec *, Arg *, unsigned int *))$a_set_values;"
		end

	c_set_set_values_hook (tmp: POINTER; a_set_values_hook: POINTER)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->set_values_hook = (char( *)(struct _WidgetRec *, Arg *, unsigned int *))$a_set_values_hook;"
		end

	c_set_set_values_almost (tmp: POINTER; a_set_values_almost: POINTER)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->set_values_almost = (void( *)(struct _WidgetRec *, struct _WidgetRec *, XtWidgetGeometry *, XtWidgetGeometry *))$a_set_values_almost;"
		end

	c_set_get_values_hook (tmp: POINTER; a_get_values_hook: POINTER)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->get_values_hook = (void( *)(struct _WidgetRec *, Arg *, unsigned int *))$a_get_values_hook;"
		end

	c_set_accept_focus (tmp: POINTER; a_accept_focus: POINTER)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->accept_focus = (char( *)(struct _WidgetRec *, unsigned long *))$a_accept_focus;"
		end

	c_set_version (tmp: POINTER; a_version: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->version = $a_version;"
		end

	c_set_callback_private (tmp: POINTER; a_callback_private: POINTER)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->callback_private = (void *)$a_callback_private;"
		end

	c_set_tm_table (tmp: POINTER; a_tm_table: POINTER)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->tm_table = (char *)$a_tm_table;"
		end

	c_set_query_geometry (tmp: POINTER; a_query_geometry: POINTER)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->query_geometry = (int( *)(struct _WidgetRec *, XtWidgetGeometry *, XtWidgetGeometry *))$a_query_geometry;"
		end

	c_set_display_accelerator (tmp: POINTER; a_display_accelerator: POINTER)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->display_accelerator = (void( *)(struct _WidgetRec *, char *))$a_display_accelerator;"
		end

	c_set_extension (tmp: POINTER; a_extension: POINTER)
		external
			"C inline"
		alias
			"((struct _CoreClassPart *)$tmp)->extension = (void *)$a_extension;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return sizeof(struct _CoreClassPart);"
		end

end
