class
	SD_DEPTH

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	depth: INTEGER_32 assign set_depth
		do
			Result := c_depth (c_pointer)
		end

	nvisuals: INTEGER_32 assign set_nvisuals
		do
			Result := c_nvisuals (c_pointer)
		end

	visuals: CE_POINTER [SD_VISUAL] assign set_visuals
		do
			create Result.make_shared (c_visuals (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_depth (a_depth: INTEGER_32)
		do
			c_set_depth (c_pointer, a_depth)
		end

	set_nvisuals (a_nvisuals: INTEGER_32)
		do
			c_set_nvisuals (c_pointer, a_nvisuals)
		end

	set_visuals (a_visuals: CE_POINTER [SD_VISUAL])
		do
			c_set_visuals (c_pointer, a_visuals.c_pointer)
		end

feature {NONE} -- C getters

	c_depth (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_Depth_27 *)$tmp)->depth;"
		end

	c_nvisuals (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_Depth_27 *)$tmp)->nvisuals;"
		end

	c_visuals (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (Visual *)((struct __anonstruct_Depth_27 *)$tmp)->visuals;"
		end

feature {NONE} -- C setters

	c_set_depth (tmp: POINTER; a_depth: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_Depth_27 *)$tmp)->depth = $a_depth;"
		end

	c_set_nvisuals (tmp: POINTER; a_nvisuals: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_Depth_27 *)$tmp)->nvisuals = $a_nvisuals;"
		end

	c_set_visuals (tmp: POINTER; a_visuals: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_Depth_27 *)$tmp)->visuals = (Visual *)$a_visuals;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return sizeof(struct __anonstruct_Depth_27);"
		end

end
