class
	SD_WIDGETREC

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	core: SD_COREPART assign set_core
		do
			create Result.make_shared (c_core (c_pointer))
		end

	core_offset: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return (int)offsetof(struct _WidgetRec, core);"
		end

feature {ANY} -- Eiffel setters

	set_core (a_core: SD_COREPART)
		do
			core.ce_gets (a_core)
		end

feature {NONE} -- C getters

	c_core (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _CorePart *)&((struct _WidgetRec *)$tmp)->core;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return sizeof(struct _WidgetRec);"
		end

end
