class
	SD_XCLIENTMESSAGEEVENT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	serial: NATURAL_32 assign set_serial
		do
			Result := c_serial (c_pointer)
		end

	send_event: INTEGER_32 assign set_send_event
		do
			Result := c_send_event (c_pointer)
		end

	display: CE_POINTER [ANY] assign set_display
		do
			create Result.make_shared (c_display (c_pointer))
		end

	window: NATURAL_32 assign set_window
		do
			Result := c_window (c_pointer)
		end

	message_type: NATURAL_32 assign set_message_type
		do
			Result := c_message_type (c_pointer)
		end

	format: INTEGER_32 assign set_format
		do
			Result := c_format (c_pointer)
		end

	data: SD_DATA assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_serial (a_serial: NATURAL_32)
		do
			c_set_serial (c_pointer, a_serial)
		end

	set_send_event (a_send_event: INTEGER_32)
		do
			c_set_send_event (c_pointer, a_send_event)
		end

	set_display (a_display: CE_POINTER [ANY])
		do
			c_set_display (c_pointer, a_display.c_pointer)
		end

	set_window (a_window: NATURAL_32)
		do
			c_set_window (c_pointer, a_window)
		end

	set_message_type (a_message_type: NATURAL_32)
		do
			c_set_message_type (c_pointer, a_message_type)
		end

	set_format (a_format: INTEGER_32)
		do
			c_set_format (c_pointer, a_format)
		end

	set_data (a_data: SD_DATA)
		do
			data.ce_gets (a_data)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XClientMessageEvent_72 *)$tmp)->type;"
		end

	c_serial (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XClientMessageEvent_72 *)$tmp)->serial;"
		end

	c_send_event (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XClientMessageEvent_72 *)$tmp)->send_event;"
		end

	c_display (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_XClientMessageEvent_72 *)$tmp)->display;"
		end

	c_window (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XClientMessageEvent_72 *)$tmp)->window;"
		end

	c_message_type (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XClientMessageEvent_72 *)$tmp)->message_type;"
		end

	c_format (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XClientMessageEvent_72 *)$tmp)->format;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_data_73 *)&((struct __anonstruct_XClientMessageEvent_72 *)$tmp)->data;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XClientMessageEvent_72 *)$tmp)->type = $a_type;"
		end

	c_set_serial (tmp: POINTER; a_serial: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XClientMessageEvent_72 *)$tmp)->serial = $a_serial;"
		end

	c_set_send_event (tmp: POINTER; a_send_event: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XClientMessageEvent_72 *)$tmp)->send_event = $a_send_event;"
		end

	c_set_display (tmp: POINTER; a_display: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_XClientMessageEvent_72 *)$tmp)->display = (void *)$a_display;"
		end

	c_set_window (tmp: POINTER; a_window: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XClientMessageEvent_72 *)$tmp)->window = $a_window;"
		end

	c_set_message_type (tmp: POINTER; a_message_type: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XClientMessageEvent_72 *)$tmp)->message_type = $a_message_type;"
		end

	c_set_format (tmp: POINTER; a_format: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XClientMessageEvent_72 *)$tmp)->format = $a_format;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return sizeof(struct __anonstruct_XClientMessageEvent_72);"
		end

end
