class
	SD_XCOLORMAPEVENT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	serial: NATURAL_32 assign set_serial
		do
			Result := c_serial (c_pointer)
		end

	send_event: INTEGER_32 assign set_send_event
		do
			Result := c_send_event (c_pointer)
		end

	display: CE_POINTER [ANY] assign set_display
		do
			create Result.make_shared (c_display (c_pointer))
		end

	window: NATURAL_32 assign set_window
		do
			Result := c_window (c_pointer)
		end

	colormap: NATURAL_32 assign set_colormap
		do
			Result := c_colormap (c_pointer)
		end

	new: INTEGER_32 assign set_new
		do
			Result := c_new (c_pointer)
		end

	state: INTEGER_32 assign set_state
		do
			Result := c_state (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_serial (a_serial: NATURAL_32)
		do
			c_set_serial (c_pointer, a_serial)
		end

	set_send_event (a_send_event: INTEGER_32)
		do
			c_set_send_event (c_pointer, a_send_event)
		end

	set_display (a_display: CE_POINTER [ANY])
		do
			c_set_display (c_pointer, a_display.c_pointer)
		end

	set_window (a_window: NATURAL_32)
		do
			c_set_window (c_pointer, a_window)
		end

	set_colormap (a_colormap: NATURAL_32)
		do
			c_set_colormap (c_pointer, a_colormap)
		end

	set_new (a_new: INTEGER_32)
		do
			c_set_new (c_pointer, a_new)
		end

	set_state (a_state: INTEGER_32)
		do
			c_set_state (c_pointer, a_state)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XColormapEvent_71 *)$tmp)->type;"
		end

	c_serial (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XColormapEvent_71 *)$tmp)->serial;"
		end

	c_send_event (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XColormapEvent_71 *)$tmp)->send_event;"
		end

	c_display (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_XColormapEvent_71 *)$tmp)->display;"
		end

	c_window (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XColormapEvent_71 *)$tmp)->window;"
		end

	c_colormap (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XColormapEvent_71 *)$tmp)->colormap;"
		end

	c_new (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XColormapEvent_71 *)$tmp)->new;"
		end

	c_state (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XColormapEvent_71 *)$tmp)->state;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XColormapEvent_71 *)$tmp)->type = $a_type;"
		end

	c_set_serial (tmp: POINTER; a_serial: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XColormapEvent_71 *)$tmp)->serial = $a_serial;"
		end

	c_set_send_event (tmp: POINTER; a_send_event: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XColormapEvent_71 *)$tmp)->send_event = $a_send_event;"
		end

	c_set_display (tmp: POINTER; a_display: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_XColormapEvent_71 *)$tmp)->display = (void *)$a_display;"
		end

	c_set_window (tmp: POINTER; a_window: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XColormapEvent_71 *)$tmp)->window = $a_window;"
		end

	c_set_colormap (tmp: POINTER; a_colormap: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XColormapEvent_71 *)$tmp)->colormap = $a_colormap;"
		end

	c_set_new (tmp: POINTER; a_new: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XColormapEvent_71 *)$tmp)->new = $a_new;"
		end

	c_set_state (tmp: POINTER; a_state: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XColormapEvent_71 *)$tmp)->state = $a_state;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return sizeof(struct __anonstruct_XColormapEvent_71);"
		end

end
