class
	SD_XCROSSINGEVENT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	serial: NATURAL_32 assign set_serial
		do
			Result := c_serial (c_pointer)
		end

	send_event: INTEGER_32 assign set_send_event
		do
			Result := c_send_event (c_pointer)
		end

	display: CE_POINTER [ANY] assign set_display
		do
			create Result.make_shared (c_display (c_pointer))
		end

	window: NATURAL_32 assign set_window
		do
			Result := c_window (c_pointer)
		end

	root: NATURAL_32 assign set_root
		do
			Result := c_root (c_pointer)
		end

	subwindow: NATURAL_32 assign set_subwindow
		do
			Result := c_subwindow (c_pointer)
		end

	time: NATURAL_32 assign set_time
		do
			Result := c_time (c_pointer)
		end

	x: INTEGER_32 assign set_x
		do
			Result := c_x (c_pointer)
		end

	y: INTEGER_32 assign set_y
		do
			Result := c_y (c_pointer)
		end

	x_root: INTEGER_32 assign set_x_root
		do
			Result := c_x_root (c_pointer)
		end

	y_root: INTEGER_32 assign set_y_root
		do
			Result := c_y_root (c_pointer)
		end

	mode: INTEGER_32 assign set_mode
		do
			Result := c_mode (c_pointer)
		end

	detail: INTEGER_32 assign set_detail
		do
			Result := c_detail (c_pointer)
		end

	same_screen: INTEGER_32 assign set_same_screen
		do
			Result := c_same_screen (c_pointer)
		end

	focus: INTEGER_32 assign set_focus
		do
			Result := c_focus (c_pointer)
		end

	state: NATURAL_32 assign set_state
		do
			Result := c_state (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_serial (a_serial: NATURAL_32)
		do
			c_set_serial (c_pointer, a_serial)
		end

	set_send_event (a_send_event: INTEGER_32)
		do
			c_set_send_event (c_pointer, a_send_event)
		end

	set_display (a_display: CE_POINTER [ANY])
		do
			c_set_display (c_pointer, a_display.c_pointer)
		end

	set_window (a_window: NATURAL_32)
		do
			c_set_window (c_pointer, a_window)
		end

	set_root (a_root: NATURAL_32)
		do
			c_set_root (c_pointer, a_root)
		end

	set_subwindow (a_subwindow: NATURAL_32)
		do
			c_set_subwindow (c_pointer, a_subwindow)
		end

	set_time (a_time: NATURAL_32)
		do
			c_set_time (c_pointer, a_time)
		end

	set_x (a_x: INTEGER_32)
		do
			c_set_x (c_pointer, a_x)
		end

	set_y (a_y: INTEGER_32)
		do
			c_set_y (c_pointer, a_y)
		end

	set_x_root (a_x_root: INTEGER_32)
		do
			c_set_x_root (c_pointer, a_x_root)
		end

	set_y_root (a_y_root: INTEGER_32)
		do
			c_set_y_root (c_pointer, a_y_root)
		end

	set_mode (a_mode: INTEGER_32)
		do
			c_set_mode (c_pointer, a_mode)
		end

	set_detail (a_detail: INTEGER_32)
		do
			c_set_detail (c_pointer, a_detail)
		end

	set_same_screen (a_same_screen: INTEGER_32)
		do
			c_set_same_screen (c_pointer, a_same_screen)
		end

	set_focus (a_focus: INTEGER_32)
		do
			c_set_focus (c_pointer, a_focus)
		end

	set_state (a_state: NATURAL_32)
		do
			c_set_state (c_pointer, a_state)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XCrossingEvent_48 *)$tmp)->type;"
		end

	c_serial (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XCrossingEvent_48 *)$tmp)->serial;"
		end

	c_send_event (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XCrossingEvent_48 *)$tmp)->send_event;"
		end

	c_display (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_XCrossingEvent_48 *)$tmp)->display;"
		end

	c_window (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XCrossingEvent_48 *)$tmp)->window;"
		end

	c_root (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XCrossingEvent_48 *)$tmp)->root;"
		end

	c_subwindow (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XCrossingEvent_48 *)$tmp)->subwindow;"
		end

	c_time (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XCrossingEvent_48 *)$tmp)->time;"
		end

	c_x (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XCrossingEvent_48 *)$tmp)->x;"
		end

	c_y (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XCrossingEvent_48 *)$tmp)->y;"
		end

	c_x_root (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XCrossingEvent_48 *)$tmp)->x_root;"
		end

	c_y_root (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XCrossingEvent_48 *)$tmp)->y_root;"
		end

	c_mode (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XCrossingEvent_48 *)$tmp)->mode;"
		end

	c_detail (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XCrossingEvent_48 *)$tmp)->detail;"
		end

	c_same_screen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XCrossingEvent_48 *)$tmp)->same_screen;"
		end

	c_focus (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XCrossingEvent_48 *)$tmp)->focus;"
		end

	c_state (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_XCrossingEvent_48 *)$tmp)->state;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XCrossingEvent_48 *)$tmp)->type = $a_type;"
		end

	c_set_serial (tmp: POINTER; a_serial: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XCrossingEvent_48 *)$tmp)->serial = $a_serial;"
		end

	c_set_send_event (tmp: POINTER; a_send_event: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XCrossingEvent_48 *)$tmp)->send_event = $a_send_event;"
		end

	c_set_display (tmp: POINTER; a_display: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_XCrossingEvent_48 *)$tmp)->display = (void *)$a_display;"
		end

	c_set_window (tmp: POINTER; a_window: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XCrossingEvent_48 *)$tmp)->window = $a_window;"
		end

	c_set_root (tmp: POINTER; a_root: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XCrossingEvent_48 *)$tmp)->root = $a_root;"
		end

	c_set_subwindow (tmp: POINTER; a_subwindow: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XCrossingEvent_48 *)$tmp)->subwindow = $a_subwindow;"
		end

	c_set_time (tmp: POINTER; a_time: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XCrossingEvent_48 *)$tmp)->time = $a_time;"
		end

	c_set_x (tmp: POINTER; a_x: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XCrossingEvent_48 *)$tmp)->x = $a_x;"
		end

	c_set_y (tmp: POINTER; a_y: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XCrossingEvent_48 *)$tmp)->y = $a_y;"
		end

	c_set_x_root (tmp: POINTER; a_x_root: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XCrossingEvent_48 *)$tmp)->x_root = $a_x_root;"
		end

	c_set_y_root (tmp: POINTER; a_y_root: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XCrossingEvent_48 *)$tmp)->y_root = $a_y_root;"
		end

	c_set_mode (tmp: POINTER; a_mode: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XCrossingEvent_48 *)$tmp)->mode = $a_mode;"
		end

	c_set_detail (tmp: POINTER; a_detail: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XCrossingEvent_48 *)$tmp)->detail = $a_detail;"
		end

	c_set_same_screen (tmp: POINTER; a_same_screen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XCrossingEvent_48 *)$tmp)->same_screen = $a_same_screen;"
		end

	c_set_focus (tmp: POINTER; a_focus: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XCrossingEvent_48 *)$tmp)->focus = $a_focus;"
		end

	c_set_state (tmp: POINTER; a_state: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XCrossingEvent_48 *)$tmp)->state = $a_state;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return sizeof(struct __anonstruct_XCrossingEvent_48);"
		end

end
