class
	SD_XGCVALUES

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	function: INTEGER_32 assign set_function
		do
			Result := c_function (c_pointer)
		end

	plane_mask: NATURAL_32 assign set_plane_mask
		do
			Result := c_plane_mask (c_pointer)
		end

	foreground: NATURAL_32 assign set_foreground
		do
			Result := c_foreground (c_pointer)
		end

	background: NATURAL_32 assign set_background
		do
			Result := c_background (c_pointer)
		end

	line_width: INTEGER_32 assign set_line_width
		do
			Result := c_line_width (c_pointer)
		end

	line_style: INTEGER_32 assign set_line_style
		do
			Result := c_line_style (c_pointer)
		end

	cap_style: INTEGER_32 assign set_cap_style
		do
			Result := c_cap_style (c_pointer)
		end

	join_style: INTEGER_32 assign set_join_style
		do
			Result := c_join_style (c_pointer)
		end

	fill_style: INTEGER_32 assign set_fill_style
		do
			Result := c_fill_style (c_pointer)
		end

	fill_rule: INTEGER_32 assign set_fill_rule
		do
			Result := c_fill_rule (c_pointer)
		end

	arc_mode: INTEGER_32 assign set_arc_mode
		do
			Result := c_arc_mode (c_pointer)
		end

	tile: NATURAL_32 assign set_tile
		do
			Result := c_tile (c_pointer)
		end

	stipple: NATURAL_32 assign set_stipple
		do
			Result := c_stipple (c_pointer)
		end

	ts_x_origin: INTEGER_32 assign set_ts_x_origin
		do
			Result := c_ts_x_origin (c_pointer)
		end

	ts_y_origin: INTEGER_32 assign set_ts_y_origin
		do
			Result := c_ts_y_origin (c_pointer)
		end

	font: NATURAL_32 assign set_font
		do
			Result := c_font (c_pointer)
		end

	subwindow_mode: INTEGER_32 assign set_subwindow_mode
		do
			Result := c_subwindow_mode (c_pointer)
		end

	graphics_exposures: INTEGER_32 assign set_graphics_exposures
		do
			Result := c_graphics_exposures (c_pointer)
		end

	clip_x_origin: INTEGER_32 assign set_clip_x_origin
		do
			Result := c_clip_x_origin (c_pointer)
		end

	clip_y_origin: INTEGER_32 assign set_clip_y_origin
		do
			Result := c_clip_y_origin (c_pointer)
		end

	clip_mask: NATURAL_32 assign set_clip_mask
		do
			Result := c_clip_mask (c_pointer)
		end

	dash_offset: INTEGER_32 assign set_dash_offset
		do
			Result := c_dash_offset (c_pointer)
		end

	dashes: INTEGER_8 assign set_dashes
		do
			Result := c_dashes (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_function (a_function: INTEGER_32)
		do
			c_set_function (c_pointer, a_function)
		end

	set_plane_mask (a_plane_mask: NATURAL_32)
		do
			c_set_plane_mask (c_pointer, a_plane_mask)
		end

	set_foreground (a_foreground: NATURAL_32)
		do
			c_set_foreground (c_pointer, a_foreground)
		end

	set_background (a_background: NATURAL_32)
		do
			c_set_background (c_pointer, a_background)
		end

	set_line_width (a_line_width: INTEGER_32)
		do
			c_set_line_width (c_pointer, a_line_width)
		end

	set_line_style (a_line_style: INTEGER_32)
		do
			c_set_line_style (c_pointer, a_line_style)
		end

	set_cap_style (a_cap_style: INTEGER_32)
		do
			c_set_cap_style (c_pointer, a_cap_style)
		end

	set_join_style (a_join_style: INTEGER_32)
		do
			c_set_join_style (c_pointer, a_join_style)
		end

	set_fill_style (a_fill_style: INTEGER_32)
		do
			c_set_fill_style (c_pointer, a_fill_style)
		end

	set_fill_rule (a_fill_rule: INTEGER_32)
		do
			c_set_fill_rule (c_pointer, a_fill_rule)
		end

	set_arc_mode (a_arc_mode: INTEGER_32)
		do
			c_set_arc_mode (c_pointer, a_arc_mode)
		end

	set_tile (a_tile: NATURAL_32)
		do
			c_set_tile (c_pointer, a_tile)
		end

	set_stipple (a_stipple: NATURAL_32)
		do
			c_set_stipple (c_pointer, a_stipple)
		end

	set_ts_x_origin (a_ts_x_origin: INTEGER_32)
		do
			c_set_ts_x_origin (c_pointer, a_ts_x_origin)
		end

	set_ts_y_origin (a_ts_y_origin: INTEGER_32)
		do
			c_set_ts_y_origin (c_pointer, a_ts_y_origin)
		end

	set_font (a_font: NATURAL_32)
		do
			c_set_font (c_pointer, a_font)
		end

	set_subwindow_mode (a_subwindow_mode: INTEGER_32)
		do
			c_set_subwindow_mode (c_pointer, a_subwindow_mode)
		end

	set_graphics_exposures (a_graphics_exposures: INTEGER_32)
		do
			c_set_graphics_exposures (c_pointer, a_graphics_exposures)
		end

	set_clip_x_origin (a_clip_x_origin: INTEGER_32)
		do
			c_set_clip_x_origin (c_pointer, a_clip_x_origin)
		end

	set_clip_y_origin (a_clip_y_origin: INTEGER_32)
		do
			c_set_clip_y_origin (c_pointer, a_clip_y_origin)
		end

	set_clip_mask (a_clip_mask: NATURAL_32)
		do
			c_set_clip_mask (c_pointer, a_clip_mask)
		end

	set_dash_offset (a_dash_offset: INTEGER_32)
		do
			c_set_dash_offset (c_pointer, a_dash_offset)
		end

	set_dashes (a_dashes: INTEGER_8)
		do
			c_set_dashes (c_pointer, a_dashes)
		end

feature {NONE} -- C getters

	c_function (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XGCValues_25 *)$tmp)->function;"
		end

	c_plane_mask (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XGCValues_25 *)$tmp)->plane_mask;"
		end

	c_foreground (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XGCValues_25 *)$tmp)->foreground;"
		end

	c_background (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XGCValues_25 *)$tmp)->background;"
		end

	c_line_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XGCValues_25 *)$tmp)->line_width;"
		end

	c_line_style (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XGCValues_25 *)$tmp)->line_style;"
		end

	c_cap_style (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XGCValues_25 *)$tmp)->cap_style;"
		end

	c_join_style (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XGCValues_25 *)$tmp)->join_style;"
		end

	c_fill_style (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XGCValues_25 *)$tmp)->fill_style;"
		end

	c_fill_rule (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XGCValues_25 *)$tmp)->fill_rule;"
		end

	c_arc_mode (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XGCValues_25 *)$tmp)->arc_mode;"
		end

	c_tile (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XGCValues_25 *)$tmp)->tile;"
		end

	c_stipple (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XGCValues_25 *)$tmp)->stipple;"
		end

	c_ts_x_origin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XGCValues_25 *)$tmp)->ts_x_origin;"
		end

	c_ts_y_origin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XGCValues_25 *)$tmp)->ts_y_origin;"
		end

	c_font (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XGCValues_25 *)$tmp)->font;"
		end

	c_subwindow_mode (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XGCValues_25 *)$tmp)->subwindow_mode;"
		end

	c_graphics_exposures (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XGCValues_25 *)$tmp)->graphics_exposures;"
		end

	c_clip_x_origin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XGCValues_25 *)$tmp)->clip_x_origin;"
		end

	c_clip_y_origin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XGCValues_25 *)$tmp)->clip_y_origin;"
		end

	c_clip_mask (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XGCValues_25 *)$tmp)->clip_mask;"
		end

	c_dash_offset (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XGCValues_25 *)$tmp)->dash_offset;"
		end

	c_dashes (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct __anonstruct_XGCValues_25 *)$tmp)->dashes;"
		end

feature {NONE} -- C setters

	c_set_function (tmp: POINTER; a_function: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGCValues_25 *)$tmp)->function = $a_function;"
		end

	c_set_plane_mask (tmp: POINTER; a_plane_mask: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGCValues_25 *)$tmp)->plane_mask = $a_plane_mask;"
		end

	c_set_foreground (tmp: POINTER; a_foreground: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGCValues_25 *)$tmp)->foreground = $a_foreground;"
		end

	c_set_background (tmp: POINTER; a_background: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGCValues_25 *)$tmp)->background = $a_background;"
		end

	c_set_line_width (tmp: POINTER; a_line_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGCValues_25 *)$tmp)->line_width = $a_line_width;"
		end

	c_set_line_style (tmp: POINTER; a_line_style: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGCValues_25 *)$tmp)->line_style = $a_line_style;"
		end

	c_set_cap_style (tmp: POINTER; a_cap_style: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGCValues_25 *)$tmp)->cap_style = $a_cap_style;"
		end

	c_set_join_style (tmp: POINTER; a_join_style: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGCValues_25 *)$tmp)->join_style = $a_join_style;"
		end

	c_set_fill_style (tmp: POINTER; a_fill_style: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGCValues_25 *)$tmp)->fill_style = $a_fill_style;"
		end

	c_set_fill_rule (tmp: POINTER; a_fill_rule: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGCValues_25 *)$tmp)->fill_rule = $a_fill_rule;"
		end

	c_set_arc_mode (tmp: POINTER; a_arc_mode: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGCValues_25 *)$tmp)->arc_mode = $a_arc_mode;"
		end

	c_set_tile (tmp: POINTER; a_tile: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGCValues_25 *)$tmp)->tile = $a_tile;"
		end

	c_set_stipple (tmp: POINTER; a_stipple: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGCValues_25 *)$tmp)->stipple = $a_stipple;"
		end

	c_set_ts_x_origin (tmp: POINTER; a_ts_x_origin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGCValues_25 *)$tmp)->ts_x_origin = $a_ts_x_origin;"
		end

	c_set_ts_y_origin (tmp: POINTER; a_ts_y_origin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGCValues_25 *)$tmp)->ts_y_origin = $a_ts_y_origin;"
		end

	c_set_font (tmp: POINTER; a_font: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGCValues_25 *)$tmp)->font = $a_font;"
		end

	c_set_subwindow_mode (tmp: POINTER; a_subwindow_mode: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGCValues_25 *)$tmp)->subwindow_mode = $a_subwindow_mode;"
		end

	c_set_graphics_exposures (tmp: POINTER; a_graphics_exposures: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGCValues_25 *)$tmp)->graphics_exposures = $a_graphics_exposures;"
		end

	c_set_clip_x_origin (tmp: POINTER; a_clip_x_origin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGCValues_25 *)$tmp)->clip_x_origin = $a_clip_x_origin;"
		end

	c_set_clip_y_origin (tmp: POINTER; a_clip_y_origin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGCValues_25 *)$tmp)->clip_y_origin = $a_clip_y_origin;"
		end

	c_set_clip_mask (tmp: POINTER; a_clip_mask: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGCValues_25 *)$tmp)->clip_mask = $a_clip_mask;"
		end

	c_set_dash_offset (tmp: POINTER; a_dash_offset: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGCValues_25 *)$tmp)->dash_offset = $a_dash_offset;"
		end

	c_set_dashes (tmp: POINTER; a_dashes: INTEGER_8)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGCValues_25 *)$tmp)->dashes = $a_dashes;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return sizeof(struct __anonstruct_XGCValues_25);"
		end

end
