class
	SD_XNOEXPOSEEVENT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	serial: NATURAL_32 assign set_serial
		do
			Result := c_serial (c_pointer)
		end

	send_event: INTEGER_32 assign set_send_event
		do
			Result := c_send_event (c_pointer)
		end

	display: CE_POINTER [ANY] assign set_display
		do
			create Result.make_shared (c_display (c_pointer))
		end

	drawable: NATURAL_32 assign set_drawable
		do
			Result := c_drawable (c_pointer)
		end

	major_code: INTEGER_32 assign set_major_code
		do
			Result := c_major_code (c_pointer)
		end

	minor_code: INTEGER_32 assign set_minor_code
		do
			Result := c_minor_code (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_serial (a_serial: NATURAL_32)
		do
			c_set_serial (c_pointer, a_serial)
		end

	set_send_event (a_send_event: INTEGER_32)
		do
			c_set_send_event (c_pointer, a_send_event)
		end

	set_display (a_display: CE_POINTER [ANY])
		do
			c_set_display (c_pointer, a_display.c_pointer)
		end

	set_drawable (a_drawable: NATURAL_32)
		do
			c_set_drawable (c_pointer, a_drawable)
		end

	set_major_code (a_major_code: INTEGER_32)
		do
			c_set_major_code (c_pointer, a_major_code)
		end

	set_minor_code (a_minor_code: INTEGER_32)
		do
			c_set_minor_code (c_pointer, a_minor_code)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XNoExposeEvent_53 *)$tmp)->type;"
		end

	c_serial (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XNoExposeEvent_53 *)$tmp)->serial;"
		end

	c_send_event (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XNoExposeEvent_53 *)$tmp)->send_event;"
		end

	c_display (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_XNoExposeEvent_53 *)$tmp)->display;"
		end

	c_drawable (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XNoExposeEvent_53 *)$tmp)->drawable;"
		end

	c_major_code (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XNoExposeEvent_53 *)$tmp)->major_code;"
		end

	c_minor_code (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XNoExposeEvent_53 *)$tmp)->minor_code;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XNoExposeEvent_53 *)$tmp)->type = $a_type;"
		end

	c_set_serial (tmp: POINTER; a_serial: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XNoExposeEvent_53 *)$tmp)->serial = $a_serial;"
		end

	c_set_send_event (tmp: POINTER; a_send_event: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XNoExposeEvent_53 *)$tmp)->send_event = $a_send_event;"
		end

	c_set_display (tmp: POINTER; a_display: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_XNoExposeEvent_53 *)$tmp)->display = (void *)$a_display;"
		end

	c_set_drawable (tmp: POINTER; a_drawable: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XNoExposeEvent_53 *)$tmp)->drawable = $a_drawable;"
		end

	c_set_major_code (tmp: POINTER; a_major_code: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XNoExposeEvent_53 *)$tmp)->major_code = $a_major_code;"
		end

	c_set_minor_code (tmp: POINTER; a_minor_code: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XNoExposeEvent_53 *)$tmp)->minor_code = $a_minor_code;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return sizeof(struct __anonstruct_XNoExposeEvent_53);"
		end

end
