class
	SD_XRMVALUE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	size: NATURAL_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	addr: CE_POINTER [INTEGER_8] assign set_addr
		do
			create Result.make_shared (c_addr (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_size (a_size: NATURAL_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_addr (a_addr: CE_POINTER [INTEGER_8])
		do
			c_set_addr (c_pointer, a_addr.c_pointer)
		end

feature {NONE} -- C getters

	c_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_XrmValue_112 *)$tmp)->size;"
		end

	c_addr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_XrmValue_112 *)$tmp)->addr;"
		end

feature {NONE} -- C setters

	c_set_size (tmp: POINTER; a_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XrmValue_112 *)$tmp)->size = $a_size;"
		end

	c_set_addr (tmp: POINTER; a_addr: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_XrmValue_112 *)$tmp)->addr = (char *)$a_addr;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return sizeof(struct __anonstruct_XrmValue_112);"
		end

end
