class
	SD_XTACTIONSREC

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	string: CE_POINTER [INTEGER_8] assign set_string
		do
			create Result.make_shared (c_string (c_pointer))
		end

	proc: CE_ROUTINE assign set_proc
		do
			create Result.make_shared (c_proc (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_string (a_string: CE_POINTER [INTEGER_8])
		do
			c_set_string (c_pointer, a_string.c_pointer)
		end

	set_proc (a_proc: CE_ROUTINE)
		do
			c_set_proc (c_pointer, a_proc.c_pointer)
		end

feature {NONE} -- C getters

	c_string (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _XtActionsRec *)$tmp)->string;"
		end

	c_proc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _WidgetRec *, union _XEvent *, char * *, unsigned int *))((struct _XtActionsRec *)$tmp)->proc;"
		end

feature {NONE} -- C setters

	c_set_string (tmp: POINTER; a_string: POINTER)
		external
			"C inline"
		alias
			"((struct _XtActionsRec *)$tmp)->string = (char *)$a_string;"
		end

	c_set_proc (tmp: POINTER; a_proc: POINTER)
		external
			"C inline"
		alias
			"((struct _XtActionsRec *)$tmp)->proc = (void( *)(struct _WidgetRec *, union _XEvent *, char * *, unsigned int *))$a_proc;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return sizeof(struct _XtActionsRec);"
		end

end
