class
	PD_CHARSET

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	p_flag: CE_POINTER [INTEGER_32] assign set_p_flag
		do
			create Result.make_shared (c_p_flag (c_pointer))
		end

	desc: CE_POINTER [INTEGER_8] assign set_desc
		do
			create Result.make_shared (c_desc (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_p_flag (a_p_flag: CE_POINTER [INTEGER_32])
		do
			c_set_p_flag (c_pointer, a_p_flag.c_pointer)
		end

	set_desc (a_desc: CE_POINTER [INTEGER_8])
		do
			c_set_desc (c_pointer, a_desc.c_pointer)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct charset *)$tmp)->name;"
		end

	c_p_flag (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int *)((struct charset *)$tmp)->p_flag;"
		end

	c_desc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct charset *)$tmp)->desc;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct charset *)$tmp)->name = (char *)$a_name;"
		end

	c_set_p_flag (tmp: POINTER; a_p_flag: POINTER)
		external
			"C inline"
		alias
			"((struct charset *)$tmp)->p_flag = (int *)$a_p_flag;"
		end

	c_set_desc (tmp: POINTER; a_desc: POINTER)
		external
			"C inline"
		alias
			"((struct charset *)$tmp)->desc = (char *)$a_desc;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return sizeof(struct charset);"
		end

end
