class
	PD_HILITE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	hl_next: CE_POINTER [PD_HILITE] assign set_hl_next
		do
			create Result.make_shared (c_hl_next (c_pointer))
		end

	hl_startpos: INTEGER_32 assign set_hl_startpos
		do
			Result := c_hl_startpos (c_pointer)
		end

	hl_endpos: INTEGER_32 assign set_hl_endpos
		do
			Result := c_hl_endpos (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_hl_next (a_hl_next: CE_POINTER [PD_HILITE])
		do
			c_set_hl_next (c_pointer, a_hl_next.c_pointer)
		end

	set_hl_startpos (a_hl_startpos: INTEGER_32)
		do
			c_set_hl_startpos (c_pointer, a_hl_startpos)
		end

	set_hl_endpos (a_hl_endpos: INTEGER_32)
		do
			c_set_hl_endpos (c_pointer, a_hl_endpos)
		end

feature {NONE} -- C getters

	c_hl_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct hilite *)((struct hilite *)$tmp)->hl_next;"
		end

	c_hl_startpos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct hilite *)$tmp)->hl_startpos;"
		end

	c_hl_endpos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct hilite *)$tmp)->hl_endpos;"
		end

feature {NONE} -- C setters

	c_set_hl_next (tmp: POINTER; a_hl_next: POINTER)
		external
			"C inline"
		alias
			"((struct hilite *)$tmp)->hl_next = (struct hilite *)$a_hl_next;"
		end

	c_set_hl_startpos (tmp: POINTER; a_hl_startpos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct hilite *)$tmp)->hl_startpos = $a_hl_startpos;"
		end

	c_set_hl_endpos (tmp: POINTER; a_hl_endpos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct hilite *)$tmp)->hl_endpos = $a_hl_endpos;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return sizeof(struct hilite);"
		end

end
