class
	PD_OPTNAME

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	oname: CE_POINTER [INTEGER_8] assign set_oname
		do
			create Result.make_shared (c_oname (c_pointer))
		end

	onext: CE_POINTER [PD_OPTNAME] assign set_onext
		do
			create Result.make_shared (c_onext (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_oname (a_oname: CE_POINTER [INTEGER_8])
		do
			c_set_oname (c_pointer, a_oname.c_pointer)
		end

	set_onext (a_onext: CE_POINTER [PD_OPTNAME])
		do
			c_set_onext (c_pointer, a_onext.c_pointer)
		end

feature {NONE} -- C getters

	c_oname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct optname *)$tmp)->oname;"
		end

	c_onext (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct optname *)((struct optname *)$tmp)->onext;"
		end

feature {NONE} -- C setters

	c_set_oname (tmp: POINTER; a_oname: POINTER)
		external
			"C inline"
		alias
			"((struct optname *)$tmp)->oname = (char *)$a_oname;"
		end

	c_set_onext (tmp: POINTER; a_onext: POINTER)
		external
			"C inline"
		alias
			"((struct optname *)$tmp)->onext = (struct optname *)$a_onext;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return sizeof(struct optname);"
		end

end
