frozen class
	LESS_INITIALIZER_SLICE3

inherit
	LESS_DATA
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {LESS_INITIALIZER}

	initialize
		do
			opttbl_inst.option[19].otype := 8
			opttbl_inst.option[19].odefault := 0
			opttbl_inst.option[19].ovar := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			opttbl_inst.option[19].ofunc := (optfunc_inst.opt__O_address)
			opttbl_inst.option[19].odesc[0] := ce_string ("Log file: ")
			opttbl_inst.option[19].odesc[1] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[19].odesc[2] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[20].oletter := (('p').code).to_integer_8
			opttbl_inst.option[20].onames := opttbl_inst.p_optname.address
			opttbl_inst.option[20].otype := 328
			opttbl_inst.option[20].odefault := 0
			opttbl_inst.option[20].ovar := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			opttbl_inst.option[20].ofunc := (optfunc_inst.opt_p_address)
			opttbl_inst.option[20].odesc[0] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[20].odesc[1] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[20].odesc[2] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[21].oletter := (('P').code).to_integer_8
			opttbl_inst.option[21].onames := opttbl_inst.P__optname.address
			opttbl_inst.option[21].otype := 8
			opttbl_inst.option[21].odefault := 0
			opttbl_inst.option[21].ovar := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			opttbl_inst.option[21].ofunc := (optfunc_inst.opt__P_address)
			opttbl_inst.option[21].odesc[0] := ce_string ("prompt: ")
			opttbl_inst.option[21].odesc[1] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[21].odesc[2] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[22].oletter := (('q').code).to_integer_8
			opttbl_inst.option[22].onames := opttbl_inst.q_optname.address
			opttbl_inst.option[22].otype := 2
			opttbl_inst.option[22].odefault := 0
			opttbl_inst.option[22].ovar := screen_inst.quiet_address
			opttbl_inst.option[22].ofunc := create {CE_ROUTINE}.make_shared (default_pointer)
			opttbl_inst.option[22].odesc[0] := ce_string ("Ring the bell for errors AND at eof/bof")
			opttbl_inst.option[22].odesc[1] := ce_string ("Ring the bell for errors but not at eof/bof")
			opttbl_inst.option[22].odesc[2] := ce_string ("Never ring the bell")
			opttbl_inst.option[23].oletter := (('r').code).to_integer_8
			opttbl_inst.option[23].onames := opttbl_inst.r_optname.address
			opttbl_inst.option[23].otype := 34
			opttbl_inst.option[23].odefault := 0
			opttbl_inst.option[23].ovar := line_inst.ctldisp_address
			opttbl_inst.option[23].ofunc := create {CE_ROUTINE}.make_shared (default_pointer)
			opttbl_inst.option[23].odesc[0] := ce_string ("Display control characters as ^X")
			opttbl_inst.option[23].odesc[1] := ce_string ("Display control characters directly")
			opttbl_inst.option[23].odesc[2] := ce_string ("Display control characters directly, processing ANSI sequences")
			opttbl_inst.option[24].oletter := (('s').code).to_integer_8
			opttbl_inst.option[24].onames := opttbl_inst.s_optname.address
			opttbl_inst.option[24].otype := 33
			opttbl_inst.option[24].odefault := 0
			opttbl_inst.option[24].ovar := input_inst.squeeze_address
			opttbl_inst.option[24].ofunc := create {CE_ROUTINE}.make_shared (default_pointer)
			opttbl_inst.option[24].odesc[0] := ce_string ("Display all blank lines")
			opttbl_inst.option[24].odesc[1] := ce_string ("Squeeze multiple blank lines")
			opttbl_inst.option[24].odesc[2] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[25].oletter := (('S').code).to_integer_8
			opttbl_inst.option[25].onames := opttbl_inst.S__optname.address
			opttbl_inst.option[25].otype := 33
			opttbl_inst.option[25].odefault := 0
			opttbl_inst.option[25].ovar := input_inst.chopline_address
			opttbl_inst.option[25].ofunc := create {CE_ROUTINE}.make_shared (default_pointer)
			opttbl_inst.option[25].odesc[0] := ce_string ("Fold long lines")
			opttbl_inst.option[25].odesc[1] := ce_string ("Chop long lines")
			opttbl_inst.option[25].odesc[2] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[26].oletter := (('t').code).to_integer_8
			opttbl_inst.option[26].onames := opttbl_inst.t_optname.address
			opttbl_inst.option[26].otype := 264
			opttbl_inst.option[26].odefault := 0
			opttbl_inst.option[26].ovar := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			opttbl_inst.option[26].ofunc := (optfunc_inst.opt_t_address)
			opttbl_inst.option[26].odesc[0] := ce_string ("tag: ")
			opttbl_inst.option[26].odesc[1] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[26].odesc[2] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[27].oletter := (('T').code).to_integer_8
			opttbl_inst.option[27].onames := opttbl_inst.T__optname.address
			opttbl_inst.option[27].otype := 8
			opttbl_inst.option[27].odefault := 0
			opttbl_inst.option[27].ovar := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			opttbl_inst.option[27].ofunc := (optfunc_inst.opt__T_address)
			opttbl_inst.option[27].odesc[0] := ce_string ("tags file: ")
			opttbl_inst.option[27].odesc[1] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[27].odesc[2] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[28].oletter := (('u').code).to_integer_8
			opttbl_inst.option[28].onames := opttbl_inst.u_optname.address
			opttbl_inst.option[28].otype := 34
			opttbl_inst.option[28].odefault := 0
			opttbl_inst.option[28].ovar := line_inst.bs_mode_address
			opttbl_inst.option[28].ofunc := create {CE_ROUTINE}.make_shared (default_pointer)
			opttbl_inst.option[28].odesc[0] := ce_string ("Display underlined text in underline mode")
			opttbl_inst.option[28].odesc[1] := ce_string ("Backspaces cause overstrike")
			opttbl_inst.option[28].odesc[2] := ce_string ("Print backspace as ^H")
			opttbl_inst.option[29].oletter := (('V').code).to_integer_8
			opttbl_inst.option[29].onames := opttbl_inst.V__optname.address
			opttbl_inst.option[29].otype := 16
			opttbl_inst.option[29].odefault := 0
			opttbl_inst.option[29].ovar := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			opttbl_inst.option[29].ofunc := (optfunc_inst.opt__V_address)
			opttbl_inst.option[29].odesc[0] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[29].odesc[1] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[29].odesc[2] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[30].oletter := (('w').code).to_integer_8
			opttbl_inst.option[30].onames := opttbl_inst.w_optname.address
			opttbl_inst.option[30].otype := 34
			opttbl_inst.option[30].odefault := 0
			opttbl_inst.option[30].ovar := command_inst.show_attn_address
			opttbl_inst.option[30].ofunc := create {CE_ROUTINE}.make_shared (default_pointer)
			opttbl_inst.option[30].odesc[0] := ce_string ("Don%'t highlight first unread line")
			opttbl_inst.option[30].odesc[1] := ce_string ("Highlight first unread line after forward-screen")
			opttbl_inst.option[30].odesc[2] := ce_string ("Highlight first unread line after any forward movement")
			opttbl_inst.option[31].oletter := (('x').code).to_integer_8
			opttbl_inst.option[31].onames := opttbl_inst.x_optname.address
			opttbl_inst.option[31].otype := 40
			opttbl_inst.option[31].odefault := 0
			opttbl_inst.option[31].ovar := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			opttbl_inst.option[31].ofunc := (optfunc_inst.opt_x_address)
			opttbl_inst.option[31].odesc[0] := ce_string ("Tab stops: ")
			opttbl_inst.option[31].odesc[1] := ce_string ("0123456789,")
			opttbl_inst.option[31].odesc[2] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[32].oletter := (('X').code).to_integer_8
			opttbl_inst.option[32].onames := opttbl_inst.X__optname.address
			opttbl_inst.option[32].otype := 65
			opttbl_inst.option[32].odefault := 0
			opttbl_inst.option[32].ovar := screen_inst.no_init_address
			opttbl_inst.option[32].ofunc := create {CE_ROUTINE}.make_shared (default_pointer)
			opttbl_inst.option[32].odesc[0] := ce_string ("Send init/deinit strings to terminal")
			opttbl_inst.option[32].odesc[1] := ce_string ("Don%'t use init/deinit strings")
			opttbl_inst.option[32].odesc[2] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[33].oletter := (('y').code).to_integer_8
			opttbl_inst.option[33].onames := opttbl_inst.y_optname.address
			opttbl_inst.option[33].otype := 4
			opttbl_inst.option[33].odefault := -1
			opttbl_inst.option[33].ovar := forwback_inst.forw_scroll_address
			opttbl_inst.option[33].ofunc := create {CE_ROUTINE}.make_shared (default_pointer)
			opttbl_inst.option[33].odesc[0] := ce_string ("Forward scroll limit: ")
			opttbl_inst.option[33].odesc[1] := ce_string ("Forward scroll limit is %%d lines")
			opttbl_inst.option[33].odesc[2] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[34].oletter := (('z').code).to_integer_8
			opttbl_inst.option[34].onames := opttbl_inst.z_optname.address
			opttbl_inst.option[34].otype := 4
			opttbl_inst.option[34].odefault := -1
			opttbl_inst.option[34].ovar := command_inst.swindow_address
			opttbl_inst.option[34].ofunc := create {CE_ROUTINE}.make_shared (default_pointer)
			opttbl_inst.option[34].odesc[0] := ce_string ("Scroll window size: ")
			opttbl_inst.option[34].odesc[1] := ce_string ("Scroll window size is %%d lines")
			opttbl_inst.option[34].odesc[2] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[35].oletter := (('%"').code).to_integer_8
			opttbl_inst.option[35].onames := opttbl_inst.quote_optname.address
			opttbl_inst.option[35].otype := 8
			opttbl_inst.option[35].odefault := 0
			opttbl_inst.option[35].ovar := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			opttbl_inst.option[35].ofunc := (optfunc_inst.opt_quote_address)
			opttbl_inst.option[35].odesc[0] := ce_string ("quotes: ")
			opttbl_inst.option[35].odesc[1] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[35].odesc[2] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[36].oletter := (('~').code).to_integer_8
			opttbl_inst.option[36].onames := opttbl_inst.tilde_optname.address
			opttbl_inst.option[36].otype := 33
			opttbl_inst.option[36].odefault := 1
			opttbl_inst.option[36].ovar := line_inst.twiddle_address
			opttbl_inst.option[36].ofunc := create {CE_ROUTINE}.make_shared (default_pointer)
			opttbl_inst.option[36].odesc[0] := ce_string ("Don%'t show tildes after end of file")
			opttbl_inst.option[36].odesc[1] := ce_string ("Show tildes after end of file")
			opttbl_inst.option[36].odesc[2] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[37].oletter := (('?').code).to_integer_8
			opttbl_inst.option[37].onames := opttbl_inst.query_optname.address
			opttbl_inst.option[37].otype := 16
			opttbl_inst.option[37].odefault := 0
			opttbl_inst.option[37].ovar := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			opttbl_inst.option[37].ofunc := (optfunc_inst.opt_query_address)
			opttbl_inst.option[37].odesc[0] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[37].odesc[1] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[37].odesc[2] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[38].oletter := (('#').code).to_integer_8
			opttbl_inst.option[38].onames := opttbl_inst.pound_optname.address
			opttbl_inst.option[38].otype := 4
			opttbl_inst.option[38].odefault := 0
			opttbl_inst.option[38].ovar := command_inst.shift_count_address
			opttbl_inst.option[38].ofunc := create {CE_ROUTINE}.make_shared (default_pointer)
			opttbl_inst.option[38].odesc[0] := ce_string ("Horizontal shift: ")
			opttbl_inst.option[38].odesc[1] := ce_string ("Horizontal shift %%d positions")
			opttbl_inst.option[38].odesc[2] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[39].oletter := (('.').code).to_integer_8
			opttbl_inst.option[39].onames := opttbl_inst.keypad_optname.address
			opttbl_inst.option[39].otype := 65
			opttbl_inst.option[39].odefault := 0
			opttbl_inst.option[39].ovar := screen_inst.no_keypad_address
			opttbl_inst.option[39].ofunc := create {CE_ROUTINE}.make_shared (default_pointer)
			opttbl_inst.option[39].odesc[0] := ce_string ("Use keypad mode")
			opttbl_inst.option[39].odesc[1] := ce_string ("Don%'t use keypad mode")
			opttbl_inst.option[39].odesc[2] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[40].oletter := (('%/0/').code).to_integer_8
			opttbl_inst.option[40].onames := create {CE_POINTER [PD_OPTNAME]}.make_shared (default_pointer)
			opttbl_inst.option[40].otype := 16
			opttbl_inst.option[40].odefault := 0
			opttbl_inst.option[40].ovar := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			opttbl_inst.option[40].ofunc := create {CE_ROUTINE}.make_shared (default_pointer)
			opttbl_inst.option[40].odesc[0] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[40].odesc[1] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			opttbl_inst.option[40].odesc[2] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			os_inst.consecutive_nulls := 0
			output_inst.ob.ce_gets (output_inst.obuf)
			across "  (press RETURN)%/0/" as c loop output_inst.return_to_continue[c.target_index - 1] := c.item.code.to_integer_8 end
			across "... (interrupt to abort)%/0/" as c loop output_inst.intr_to_abort[c.target_index - 1] := c.item.code.to_integer_8 end
			position_inst.table.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
			across "?n?f%%f .?m(%%T %%i of %%m) ..?e(END) ?x- Next\: %%x..%%t%/0/" as c loop prompt_inst.s_proto[c.target_index - 1] := c.item.code.to_integer_8 end
			across "?n?f%%f .?m(%%T %%i of %%m) ..?e(END) ?x- Next\: %%x.:?pB%%pB\%%:byte %%bB?s/%%s...%%t%/0/" as c loop prompt_inst.m_proto[c.target_index - 1] := c.item.code.to_integer_8 end
			across "?f%%f .?n?m(%%T %%i of %%m) ..?ltlines %%lt-%%lb?L/%%L. :byte %%bB?s/%%s. .?e(END) ?x- Next\: %%x.:?pB%%pB\%%..%%t%/0/" as c loop prompt_inst.M_proto2[c.target_index - 1] := c.item.code.to_integer_8 end
			across "?f%%f .?m(%%T %%i of %%m) .?ltlines %%lt-%%lb?L/%%L. .byte %%bB?s/%%s. ?e(END) :?pB%%pB\%%..%%t%/0/" as c loop prompt_inst.e_proto[c.target_index - 1] := c.item.code.to_integer_8 end
			across "HELP -- ?eEND -- Press g to see it again:Press RETURN for more., or q when done%/0/" as c loop prompt_inst.h_proto[c.target_index - 1] := c.item.code.to_integer_8 end
			across "Waiting for data%/0/" as c loop prompt_inst.w_proto[c.target_index - 1] := c.item.code.to_integer_8 end
			prompt_inst.eqproto.ce_gets (prompt_inst.e_proto)
			prompt_inst.hproto.ce_gets (prompt_inst.h_proto)
			prompt_inst.wproto.ce_gets (prompt_inst.w_proto)
			search_inst.hilite_anchor.hl_next := create {CE_POINTER [PD_HILITE]}.make_shared (default_pointer)
			search_inst.hilite_anchor.hl_startpos := (-1).to_integer_32
			search_inst.hilite_anchor.hl_endpos := (-1).to_integer_32
			search_inst.regpattern.ce_gets (create {CE_POINTER [SD_RE_PATTERN_BUFFER]}.make_shared (default_pointer))
			search_inst.last_pattern.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
			tags_inst.tags.ce_gets (ce_string ("tags"))
			tags_inst.taglist.tl_first := create {CE_POINTER [PD_TAG]}.make_cast ((tags_inst.taglist.address))
			tags_inst.taglist.tl_last := create {CE_POINTER [PD_TAG]}.make_cast ((tags_inst.taglist.address))
			tags_inst.circular := 0
			across "382%/0/" as c loop version_inst.version[c.target_index - 1] := c.item.code.to_integer_8 end
		end

end
