class
	P_SCREEN

inherit
	LESS_DATA
		redefine
			default_create
		end
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {NONE} -- Initialization

	default_create
		do
			create sc_pad.make
			create sc_home.make
			create sc_addline.make
			create sc_lower_left.make
			create sc_move.make
			create sc_clear.make
			create sc_eol_clear.make
			create sc_eos_clear.make
			create sc_s_in.make
			create sc_s_out.make
			create sc_u_in.make
			create sc_u_out.make
			create sc_b_in.make
			create sc_b_out.make
			create sc_bl_in.make
			create sc_bl_out.make
			create sc_visual_bell.make
			create sc_backspace.make
			create sc_s_keypad.make
			create sc_e_keypad.make
			create sc_init.make
			create sc_deinit.make
			create save_term.make
			create tbuf.make (<<40>>)
			create sbuf.make (<<1024>>)
		end

feature {ANY} -- attributes

	sc_pad: CE_POINTER [INTEGER_8]

	sc_home: CE_POINTER [INTEGER_8]

	sc_addline: CE_POINTER [INTEGER_8]

	sc_lower_left: CE_POINTER [INTEGER_8]

	sc_move: CE_POINTER [INTEGER_8]

	sc_clear: CE_POINTER [INTEGER_8]

	sc_eol_clear: CE_POINTER [INTEGER_8]

	sc_eos_clear: CE_POINTER [INTEGER_8]

	sc_s_in: CE_POINTER [INTEGER_8]

	sc_s_out: CE_POINTER [INTEGER_8]

	sc_u_in: CE_POINTER [INTEGER_8]

	sc_u_out: CE_POINTER [INTEGER_8]

	sc_b_in: CE_POINTER [INTEGER_8]

	sc_b_out: CE_POINTER [INTEGER_8]

	sc_bl_in: CE_POINTER [INTEGER_8]

	sc_bl_out: CE_POINTER [INTEGER_8]

	sc_visual_bell: CE_POINTER [INTEGER_8]

	sc_backspace: CE_POINTER [INTEGER_8]

	sc_s_keypad: CE_POINTER [INTEGER_8]

	sc_e_keypad: CE_POINTER [INTEGER_8]

	sc_init: CE_POINTER [INTEGER_8]

	sc_deinit: CE_POINTER [INTEGER_8]

	init_done: INTEGER_32 assign set_init_done

	set_init_done (a_init_done: INTEGER_32)
		do
			init_done := a_init_done
		end

	auto_wrap: INTEGER_32 assign set_auto_wrap

	set_auto_wrap (a_auto_wrap: INTEGER_32)
		do
			auto_wrap := a_auto_wrap
		end

	ignaw: INTEGER_32 assign set_ignaw

	set_ignaw (a_ignaw: INTEGER_32)
		do
			ignaw := a_ignaw
		end

	erase_char: INTEGER_32 assign set_erase_char

	set_erase_char (a_erase_char: INTEGER_32)
		do
			erase_char := a_erase_char
		end

	kill_char: INTEGER_32 assign set_kill_char

	set_kill_char (a_kill_char: INTEGER_32)
		do
			kill_char := a_kill_char
		end

	werase_char: INTEGER_32 assign set_werase_char

	set_werase_char (a_werase_char: INTEGER_32)
		do
			werase_char := a_werase_char
		end

	sc_width: INTEGER_32 assign set_sc_width

	set_sc_width (a_sc_width: INTEGER_32)
		do
			sc_width := a_sc_width
		end

	sc_height: INTEGER_32 assign set_sc_height

	set_sc_height (a_sc_height: INTEGER_32)
		do
			sc_height := a_sc_height
		end

	bo_s_width: INTEGER_32 assign set_bo_s_width

	set_bo_s_width (a_bo_s_width: INTEGER_32)
		do
			bo_s_width := a_bo_s_width
		end

	bo_e_width: INTEGER_32 assign set_bo_e_width

	set_bo_e_width (a_bo_e_width: INTEGER_32)
		do
			bo_e_width := a_bo_e_width
		end

	ul_s_width: INTEGER_32 assign set_ul_s_width

	set_ul_s_width (a_ul_s_width: INTEGER_32)
		do
			ul_s_width := a_ul_s_width
		end

	ul_e_width: INTEGER_32 assign set_ul_e_width

	set_ul_e_width (a_ul_e_width: INTEGER_32)
		do
			ul_e_width := a_ul_e_width
		end

	so_s_width: INTEGER_32 assign set_so_s_width

	set_so_s_width (a_so_s_width: INTEGER_32)
		do
			so_s_width := a_so_s_width
		end

	so_e_width: INTEGER_32 assign set_so_e_width

	set_so_e_width (a_so_e_width: INTEGER_32)
		do
			so_e_width := a_so_e_width
		end

	bl_s_width: INTEGER_32 assign set_bl_s_width

	set_bl_s_width (a_bl_s_width: INTEGER_32)
		do
			bl_s_width := a_bl_s_width
		end

	bl_e_width: INTEGER_32 assign set_bl_e_width

	set_bl_e_width (a_bl_e_width: INTEGER_32)
		do
			bl_e_width := a_bl_e_width
		end

	above_mem: INTEGER_32 assign set_above_mem

	set_above_mem (a_above_mem: INTEGER_32)
		do
			above_mem := a_above_mem
		end

	below_mem: INTEGER_32 assign set_below_mem

	set_below_mem (a_below_mem: INTEGER_32)
		do
			below_mem := a_below_mem
		end

	can_goto_line: INTEGER_32 assign set_can_goto_line

	set_can_goto_line (a_can_goto_line: INTEGER_32)
		do
			can_goto_line := a_can_goto_line
		end

	clear_bg: INTEGER_32 assign set_clear_bg

	set_clear_bg (a_clear_bg: INTEGER_32)
		do
			clear_bg := a_clear_bg
		end

	missing_cap: INTEGER_32 assign set_missing_cap

	set_missing_cap (a_missing_cap: INTEGER_32)
		do
			missing_cap := a_missing_cap
		end

	attrmode: INTEGER_32 assign set_attrmode

	set_attrmode (a_attrmode: INTEGER_32)
		do
			attrmode := a_attrmode
		end

	quiet: INTEGER_32 assign set_quiet
		do
			Result := quiet_address[0]
		end

	set_quiet (a_quiet: INTEGER_32)
		do
			quiet_address[0] := a_quiet
		end

	quiet_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	no_init: INTEGER_32 assign set_no_init
		do
			Result := no_init_address[0]
		end

	set_no_init (a_no_init: INTEGER_32)
		do
			no_init_address[0] := a_no_init
		end

	no_init_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	no_keypad: INTEGER_32 assign set_no_keypad
		do
			Result := no_keypad_address[0]
		end

	set_no_keypad (a_no_keypad: INTEGER_32)
		do
			no_keypad_address[0] := a_no_keypad
		end

	no_keypad_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	tty: INTEGER_32 assign set_tty

	set_tty (a_tty: INTEGER_32)
		do
			tty := a_tty
		end

	hilite_search: INTEGER_32 assign set_hilite_search
		do
			Result := hilite_search_address[0]
		end

	set_hilite_search (a_hilite_search: INTEGER_32)
		do
			hilite_search_address[0] := a_hilite_search
		end

	hilite_search_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	curr_on: INTEGER_32 assign set_curr_on

	set_curr_on (a_curr_on: INTEGER_32)
		do
			curr_on := a_curr_on
		end

	save_term: SD_TERMIOS

	saved_term: INTEGER_32 assign set_saved_term

	set_saved_term (a_saved_term: INTEGER_32)
		do
			saved_term := a_saved_term
		end

	hardcopy: INTEGER_32 assign set_hardcopy

	set_hardcopy (a_hardcopy: INTEGER_32)
		do
			hardcopy := a_hardcopy
		end

	tbuf: CE_ARRAY [INTEGER_8]

	sbuf: CE_ARRAY [INTEGER_8]

	costcount: INTEGER_32 assign set_costcount

	set_costcount (a_costcount: INTEGER_32)
		do
			costcount := a_costcount
		end

feature {ANY} -- routines

	raw_mode (a_on: INTEGER_32)
		local
			l_s: SD_TERMIOS
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_on = curr_on then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 26 -- skip if block
					end
				when 1 then -- if:
						if not (a_on.to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 2 then -- if:
						tcgetattr (tty, l_s.address).do_nothing
						if not saved_term.to_boolean then
							save_term.ce_gets (l_s)
							saved_term := 1
						end
						inspect (cfgetospeed ((l_s.address))).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 3
						when 1 then l_pos := -1 + 4
						when 2 then l_pos := -1 + 5
						when 3 then l_pos := -1 + 6
						when 4 then l_pos := -1 + 7
						when 5 then l_pos := -1 + 8
						when 6 then l_pos := -1 + 9
						when 7 then l_pos := -1 + 10
						when 8 then l_pos := -1 + 11
						when 9 then l_pos := -1 + 12
						when 10 then l_pos := -1 + 13
						when 11 then l_pos := -1 + 14
						when 12 then l_pos := -1 + 15
						when 13 then l_pos := -1 + 16
						when 14 then l_pos := -1 + 17
						when 15 then l_pos := -1 + 18
						when 4097 then l_pos := -1 + 19
						when 4098 then l_pos := -1 + 20
						else l_pos := -1 + 21
						end
				when 3 then -- switch 1, case 0
						Current.ospeed := (0).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 4 then -- switch 1, case 1
						Current.ospeed := (1).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 5 then -- switch 1, case 2
						Current.ospeed := (2).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 6 then -- switch 1, case 3
						Current.ospeed := (3).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 7 then -- switch 1, case 4
						Current.ospeed := (4).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 8 then -- switch 1, case 5
						Current.ospeed := (5).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 9 then -- switch 1, case 6
						Current.ospeed := (6).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 10 then -- switch 1, case 7
						Current.ospeed := (7).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 11 then -- switch 1, case 8
						Current.ospeed := (8).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 12 then -- switch 1, case 9
						Current.ospeed := (9).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 13 then -- switch 1, case 10
						Current.ospeed := (10).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 14 then -- switch 1, case 11
						Current.ospeed := (11).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 15 then -- switch 1, case 12
						Current.ospeed := (12).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 16 then -- switch 1, case 13
						Current.ospeed := (13).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 17 then -- switch 1, case 14
						Current.ospeed := (14).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 18 then -- switch 1, case 15
						Current.ospeed := (15).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 19 then -- switch 1, case 4097
						Current.ospeed := (16).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 20 then -- switch 1, case 4098
						Current.ospeed := (17).to_natural_32
						l_pos := -1 + 22 -- switch 1; break
				when 21 then -- switch 1, default:
						
				when 22 then -- switch 1, done:
						erase_char := (l_s.c2_cc[2]).to_integer_32
						kill_char := (l_s.c2_cc[3]).to_integer_32
						werase_char := (l_s.c2_cc[14]).to_integer_32
						l_s.c2_lflag := (l_s.c2_lflag).bit_and (({NATURAL_32} 4294967173))
						l_s.c2_oflag := (l_s.c2_oflag).bit_or (({NATURAL_32} 6149))
						l_s.c2_oflag := (l_s.c2_oflag).bit_and (({NATURAL_32} 4294967239))
						l_s.c2_cc[6] := (1).to_natural_8
						l_s.c2_cc[5] := (0).to_natural_8
						l_s.c2_cc[15] := (0).to_natural_8
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else:
						l_s.ce_gets (save_term)
				when 25 then -- if done
						fsync (tty).do_nothing
						tcsetattr (tty, 1, (l_s.address)).do_nothing
						curr_on := a_on
				when 26 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ltget_env (a_capname: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_name: CE_ARRAY [INTEGER_8]
		do
			create l_name.make (<<16>>)

			strcpy (l_name, ce_string ("LESS_TERMCAP_")).do_nothing
			strcat (l_name, a_capname).do_nothing
			Result := (decode_inst.lgetenv (l_name))
		end

	ltgetflag (a_capname: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_s: CE_POINTER [INTEGER_8]
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make

			l_s.ce_gets (ltget_env (a_capname))
			if (l_s.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (l_s[0]).to_integer_32 /= 0 then
					if (l_s[0]).to_integer_32 /= 48 then
						l_tmp := 1
					else
						l_tmp := 0
					end
				else
					l_tmp := 0
				end
				Result := l_tmp
				js.return
			end
			if not js.return_called and then (hardcopy.to_boolean) then
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := (tgetflag (a_capname))
			end
		end

	ltgetnum (a_capname: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_s: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_s.make

			l_s.ce_gets (ltget_env (a_capname))
			if (l_s.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				Result := (atoi (l_s))
				js.return
			end
			if not js.return_called and then (hardcopy.to_boolean) then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				Result := (tgetnum (a_capname))
			end
		end

	ltgetstr (a_capname: CE_POINTER [INTEGER_8]; a_pp: CE_POINTER [CE_POINTER [INTEGER_8]]): CE_POINTER [INTEGER_8]
		local
			l_s: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_s.make

			l_s.ce_gets (ltget_env (a_capname))
			if (l_s.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				Result := l_s
				js.return
			end
			if not js.return_called and then (hardcopy.to_boolean) then
				Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				Result := (tgetstr (a_capname, a_pp))
			end
		end

	scrsize
		local
			l_s: CE_POINTER [INTEGER_8]
			l_sys_height: INTEGER_32
			l_sys_width: INTEGER_32
			l_n: INTEGER_32
			l_w: SD_WINSIZE
		do
			create l_s.make
			create l_w.make

			l_sys_height := 0
			l_sys_width := l_sys_height
			if (ioctl ([2, {NATURAL_32} 21523, l_w.address])) = 0 then
				if (l_w.ws_row).to_integer_32 > 0 then
					l_sys_height := (l_w.ws_row).to_integer_32
				end
				if (l_w.ws_col).to_integer_32 > 0 then
					l_sys_width := (l_w.ws_col).to_integer_32
				end
			end
			if l_sys_height > 0 then
				sc_height := l_sys_height
			else
				l_s.ce_gets (decode_inst.lgetenv (ce_string ("LINES")))
				if (l_s.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					sc_height := atoi (l_s)
				else
					l_n := ltgetnum (ce_string ("li"))
					if l_n > 0 then
						sc_height := l_n
					else
						sc_height := 24
					end
				end
			end
			if l_sys_width > 0 then
				sc_width := l_sys_width
			else
				l_s.ce_gets (decode_inst.lgetenv (ce_string ("COLUMNS")))
				if (l_s.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					sc_width := atoi (l_s)
				else
					l_n := ltgetnum (ce_string ("co"))
					if l_n > 0 then
						sc_width := l_n
					else
						sc_width := 80
					end
				end
			end
		end

	special_key_str (a_key: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_s: CE_POINTER [INTEGER_8]
			l_sp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_sp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sp.ce_gets (tbuf)
					inspect a_key -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					when 4 then l_pos := -1 + 4
					when 5 then l_pos := -1 + 5
					when 6 then l_pos := -1 + 6
					when 7 then l_pos := -1 + 7
					when 8 then l_pos := -1 + 8
					when 9 then l_pos := -1 + 9
					when 40 then l_pos := -1 + 10
					else l_pos := -1 + 11
					end
				when 1 then -- switch 1, case 1
					l_s.ce_gets (ltgetstr (ce_string ("kr"), l_sp.address))
					l_pos := -1 + 12 -- switch 1; break
				when 2 then -- switch 1, case 2
					l_s.ce_gets (ltgetstr (ce_string ("kl"), l_sp.address))
					l_pos := -1 + 12 -- switch 1; break
				when 3 then -- switch 1, case 3
					l_s.ce_gets (ltgetstr (ce_string ("ku"), l_sp.address))
					l_pos := -1 + 12 -- switch 1; break
				when 4 then -- switch 1, case 4
					l_s.ce_gets (ltgetstr (ce_string ("kd"), l_sp.address))
					l_pos := -1 + 12 -- switch 1; break
				when 5 then -- switch 1, case 5
					l_s.ce_gets (ltgetstr (ce_string ("kP"), l_sp.address))
					l_pos := -1 + 12 -- switch 1; break
				when 6 then -- switch 1, case 6
					l_s.ce_gets (ltgetstr (ce_string ("kN"), l_sp.address))
					l_pos := -1 + 12 -- switch 1; break
				when 7 then -- switch 1, case 7
					l_s.ce_gets (ltgetstr (ce_string ("kh"), l_sp.address))
					l_pos := -1 + 12 -- switch 1; break
				when 8 then -- switch 1, case 8
					l_s.ce_gets (ltgetstr (ce_string ("@7"), l_sp.address))
					l_pos := -1 + 12 -- switch 1; break
				when 9 then -- switch 1, case 9
					l_s.ce_gets (ltgetstr (ce_string ("kD"), l_sp.address))
					if (l_s.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						tbuf[0] := (('%/127/').code).to_integer_8
						tbuf[1] := (('%/0/').code).to_integer_8
						l_s.ce_gets (tbuf)
					end
					l_pos := -1 + 12 -- switch 1; break
				when 10 then -- switch 1, case 40
					tbuf[0] := (11).to_integer_8
					tbuf[1] := (('%/0/').code).to_integer_8
					l_s.ce_gets (tbuf)
					l_pos := -1 + 12 -- switch 1; break
				when 11 then -- switch 1, default:
					Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					js.return
				when 12 then -- switch 1, done:
					if not js.return_called then
						Result := l_s
					end
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_term
		local
			l_sp: CE_POINTER [INTEGER_8]
			l_t1: CE_POINTER [INTEGER_8]
			l_t2: CE_POINTER [INTEGER_8]
			l_term: CE_POINTER [INTEGER_8]
			l_termbuf: CE_ARRAY [INTEGER_8]
		do
			create l_sp.make
			create l_t1.make
			create l_t2.make
			create l_term.make
			create l_termbuf.make (<<2048>>)

			l_term.ce_gets (decode_inst.lgetenv (ce_string ("TERM")))
			if (l_term.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_term.ce_gets (ce_string ("unknown"))
			end
			hardcopy := 0
			if (tgetent (l_termbuf, l_term)) <= 0 then
				hardcopy := 1
			end
			if (ltgetflag (ce_string ("hc"))).to_boolean then
				hardcopy := 1
			end
			scrsize
			position_inst.pos_init
			auto_wrap := ltgetflag (ce_string ("am"))
			ignaw := ltgetflag (ce_string ("xn"))
			above_mem := ltgetflag (ce_string ("da"))
			below_mem := ltgetflag (ce_string ("db"))
			clear_bg := ltgetflag (ce_string ("ut"))
			so_s_width := ltgetnum (ce_string ("sg"))
			if so_s_width < 0 then
				so_s_width := 0
			end
			so_e_width := so_s_width
			bo_e_width := so_s_width
			bo_s_width := bo_e_width
			ul_e_width := so_s_width
			ul_s_width := ul_e_width
			bl_e_width := so_s_width
			bl_s_width := bl_e_width
			if so_s_width > 0 then
				Current.hilite_search := 0
			elseif so_e_width > 0 then
				Current.hilite_search := 0
			end
			l_sp.ce_gets (sbuf)
			sc_pad.ce_gets (ltgetstr (ce_string ("pc"), l_sp.address))
			if (sc_pad.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				Current.PC := sc_pad[0]
			end
			sc_s_keypad.ce_gets (ltgetstr (ce_string ("ks"), l_sp.address))
			if (sc_s_keypad.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				sc_s_keypad.ce_gets (ce_string (""))
			end
			sc_e_keypad.ce_gets (ltgetstr (ce_string ("ke"), l_sp.address))
			if (sc_e_keypad.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				sc_e_keypad.ce_gets (ce_string (""))
			end
			sc_init.ce_gets (ltgetstr (ce_string ("ti"), l_sp.address))
			if (sc_init.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				sc_init.ce_gets (ce_string (""))
			end
			sc_deinit.ce_gets (ltgetstr (ce_string ("te"), l_sp.address))
			if (sc_deinit.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				sc_deinit.ce_gets (ce_string (""))
			end
			sc_eol_clear.ce_gets (ltgetstr (ce_string ("ce"), l_sp.address))
			if (sc_eol_clear.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				missing_cap := 1
				sc_eol_clear.ce_gets (ce_string (""))
			elseif (sc_eol_clear[0]).to_integer_32 = 0 then
				missing_cap := 1
				sc_eol_clear.ce_gets (ce_string (""))
			end
			sc_eos_clear.ce_gets (ltgetstr (ce_string ("cd"), l_sp.address))
			if below_mem.to_boolean then
				if (sc_eos_clear.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					missing_cap := 1
					sc_eol_clear.ce_gets (ce_string (""))
				elseif (sc_eos_clear[0]).to_integer_32 = 0 then
					missing_cap := 1
					sc_eol_clear.ce_gets (ce_string (""))
				end
			end
			sc_clear.ce_gets (ltgetstr (ce_string ("cl"), l_sp.address))
			if (sc_clear.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				missing_cap := 1
				sc_clear.ce_gets (ce_string ("%N%N"))
			elseif (sc_clear[0]).to_integer_32 = 0 then
				missing_cap := 1
				sc_clear.ce_gets (ce_string ("%N%N"))
			end
			sc_move.ce_gets (ltgetstr (ce_string ("cm"), l_sp.address))
			if (sc_move.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				sc_move.ce_gets (ce_string (""))
				can_goto_line := 0
			elseif (sc_move[0]).to_integer_32 = 0 then
				sc_move.ce_gets (ce_string (""))
				can_goto_line := 0
			else
				can_goto_line := 1
			end
			tmodes (ce_string ("so"), ce_string ("se"), sc_s_in.address, sc_s_out.address, ce_string (""), ce_string (""), l_sp.address)
			tmodes (ce_string ("us"), ce_string ("ue"), sc_u_in.address, sc_u_out.address, sc_s_in, sc_s_out, l_sp.address)
			tmodes (ce_string ("md"), ce_string ("me"), sc_b_in.address, sc_b_out.address, sc_s_in, sc_s_out, l_sp.address)
			tmodes (ce_string ("mb"), ce_string ("me"), sc_bl_in.address, sc_bl_out.address, sc_s_in, sc_s_out, l_sp.address)
			sc_visual_bell.ce_gets (ltgetstr (ce_string ("vb"), l_sp.address))
			if (sc_visual_bell.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				sc_visual_bell.ce_gets (ce_string (""))
			end
			if (ltgetflag (ce_string ("bs"))).to_boolean then
				sc_backspace.ce_gets (ce_string ("%B"))
			else
				sc_backspace.ce_gets (ltgetstr (ce_string ("bc"), l_sp.address))
				if (sc_backspace.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					sc_backspace.ce_gets (ce_string ("%B"))
				elseif (sc_backspace[0]).to_integer_32 = 0 then
					sc_backspace.ce_gets (ce_string ("%B"))
				end
			end
			l_t1.ce_gets (ltgetstr (ce_string ("ho"), l_sp.address))
			if (l_t1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_t1.ce_gets (ce_string (""))
			end
			if (sc_move[0]).to_integer_32 = 0 then
				l_t2.ce_gets (ce_string (""))
			else
				strcpy (l_sp, (tgoto (sc_move, 0, 0))).do_nothing
				l_t2.ce_gets (l_sp)
				l_sp.ce_gets (l_sp + ((strlen (l_sp)) + {NATURAL_32} 1).to_integer_32)
			end
			sc_home.ce_gets (cheaper (l_t1, l_t2, ce_string ("|%B^")))
			l_t1.ce_gets (ltgetstr (ce_string ("ll"), l_sp.address))
			if (l_t1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_t1.ce_gets (ce_string (""))
			end
			if (sc_move[0]).to_integer_32 = 0 then
				l_t2.ce_gets (ce_string (""))
			else
				strcpy (l_sp, (tgoto (sc_move, 0, sc_height - 1))).do_nothing
				l_t2.ce_gets (l_sp)
				l_sp.ce_gets (l_sp + ((strlen (l_sp)) + {NATURAL_32} 1).to_integer_32)
			end
			sc_lower_left.ce_gets (cheaper (l_t1, l_t2, ce_string ("%R")))
			l_t1.ce_gets (ltgetstr (ce_string ("al"), l_sp.address))
			if (l_t1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_t1.ce_gets (ce_string (""))
			end
			l_t2.ce_gets (ltgetstr (ce_string ("sr"), l_sp.address))
			if (l_t2.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_t2.ce_gets (ce_string (""))
			end
			if above_mem.to_boolean then
				sc_addline.ce_gets (l_t1)
			else
				sc_addline.ce_gets (cheaper (l_t1, l_t2, ce_string ("")))
			end
			if (sc_addline[0]).to_integer_32 = 0 then
				forwback_inst.no_back_scroll := 1
			end
		end

	inc_costcount (a_c: INTEGER_32): INTEGER_32
		do
			costcount := costcount + 1
			Result := a_c
		end

	inc_costcount_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent inc_costcount)
		end

	cost (a_t: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			costcount := 0
			tputs (a_t, sc_height, inc_costcount_address).do_nothing
			Result := costcount
		end

	cheaper (a_t1: CE_POINTER [INTEGER_8]; a_t2: CE_POINTER [INTEGER_8]; a_def: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			if (a_t1[0]).to_integer_32 = 0 then
				if (a_t2[0]).to_integer_32 = 0 then
					missing_cap := 1
					Result := a_def
					js.return
				end
			end
			if not js.return_called and then ((a_t1[0]).to_integer_32 = 0) then
				Result := a_t2
				js.return
			end
			if not js.return_called and then ((a_t2[0]).to_integer_32 = 0) then
				Result := a_t1
				js.return
			end
			if not js.return_called then
				l_tmp := cost (a_t1)
				if l_tmp < (cost (a_t2)) then
					Result := a_t1
					js.return
				end
			end
			if not js.return_called then
				Result := a_t2
			end
		end

	tmodes (a_incap: CE_POINTER [INTEGER_8]; a_outcap: CE_POINTER [INTEGER_8]; a_instr: CE_POINTER [CE_POINTER [INTEGER_8]]; a_outstr: CE_POINTER [CE_POINTER [INTEGER_8]]; a_def_instr: CE_POINTER [INTEGER_8]; a_def_outstr: CE_POINTER [INTEGER_8]; a_spp: CE_POINTER [CE_POINTER [INTEGER_8]])
		local
			js: JUMP_STATE
		do
			a_instr.item := ltgetstr (a_incap, a_spp)
			if ((a_instr.item).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				a_instr.item := a_def_instr
				a_outstr.item := a_def_outstr
				js.return
			end
			if not js.return_called then
				a_outstr.item := ltgetstr (a_outcap, a_spp)
				if ((a_outstr.item).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					a_outstr.item := ltgetstr (ce_string ("me"), a_spp)
				end
				if ((a_outstr.item).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					a_outstr.item := ce_string ("")
				end
			end
		end

	init
		do
			if not no_init.to_boolean then
				tputs (sc_init, sc_height, output_inst.putchr_address).do_nothing
			end
			if not no_keypad.to_boolean then
				tputs (sc_s_keypad, sc_height, output_inst.putchr_address).do_nothing
			end
			init_done := 1
		end

	deinit
		local
			js: JUMP_STATE
		do
			if not init_done.to_boolean then
				js.return
			end
			if not js.return_called then
				if not no_keypad.to_boolean then
					tputs (sc_e_keypad, sc_height, output_inst.putchr_address).do_nothing
				end
				if not no_init.to_boolean then
					tputs (sc_deinit, sc_height, output_inst.putchr_address).do_nothing
				end
				init_done := 0
			end
		end

	home
		do
			tputs (sc_home, 1, output_inst.putchr_address).do_nothing
		end

	add_line
		do
			tputs (sc_addline, sc_height, output_inst.putchr_address).do_nothing
		end

	lower_left
		do
			tputs (sc_lower_left, 1, output_inst.putchr_address).do_nothing
		end

	check_winch
		do
		end

	goto_line (a_slinenum: INTEGER_32)
		do
			tputs ((tgoto (sc_move, 0, a_slinenum)), 1, output_inst.putchr_address).do_nothing
		end

	vbell
		local
			js: JUMP_STATE
		do
			if (sc_visual_bell[0]).to_integer_32 = 0 then
				js.return
			end
			if not js.return_called then
				tputs (sc_visual_bell, sc_height, output_inst.putchr_address).do_nothing
			end
		end

	beep
		do
			output_inst.putchr (7).do_nothing
		end

	bell
		do
			if quiet = 2 then
				vbell
			else
				beep
			end
		end

	clear
		do
			tputs (sc_clear, sc_height, output_inst.putchr_address).do_nothing
		end

	clear_eol
		do
			tputs (sc_eol_clear, 1, output_inst.putchr_address).do_nothing
		end

	clear_eol_bot
		do
			if below_mem.to_boolean then
				tputs (sc_eos_clear, 1, output_inst.putchr_address).do_nothing
			else
				tputs (sc_eol_clear, 1, output_inst.putchr_address).do_nothing
			end
		end

	clear_bot
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					lower_left
					inspect attrmode -- switch 1 head
					when 5 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					when 3 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 5
					so_exit
					clear_eol_bot
					so_enter
					l_pos := -1 + 6 -- switch 1; break
				when 2 then -- switch 1, case 1
					ul_exit
					clear_eol_bot
					ul_enter
					l_pos := -1 + 6 -- switch 1; break
				when 3 then -- switch 1, case 2
					bo_exit
					clear_eol_bot
					bo_enter
					l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 3
					bl_exit
					clear_eol_bot
					bl_enter
					l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, default:
					clear_eol_bot
					l_pos := -1 + 6 -- switch 1; break
				when 6 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	so_enter
		do
			tputs (sc_s_in, 1, output_inst.putchr_address).do_nothing
			attrmode := 5
		end

	so_exit
		do
			tputs (sc_s_out, 1, output_inst.putchr_address).do_nothing
			attrmode := 0
		end

	ul_enter
		do
			tputs (sc_u_in, 1, output_inst.putchr_address).do_nothing
			attrmode := 1
		end

	ul_exit
		do
			tputs (sc_u_out, 1, output_inst.putchr_address).do_nothing
			attrmode := 0
		end

	bo_enter
		do
			tputs (sc_b_in, 1, output_inst.putchr_address).do_nothing
			attrmode := 2
		end

	bo_exit
		do
			tputs (sc_b_out, 1, output_inst.putchr_address).do_nothing
			attrmode := 0
		end

	bl_enter
		do
			tputs (sc_bl_in, 1, output_inst.putchr_address).do_nothing
			attrmode := 3
		end

	bl_exit
		do
			tputs (sc_bl_out, 1, output_inst.putchr_address).do_nothing
			attrmode := 0
		end

	putbs
		do
			tputs (sc_backspace, 1, output_inst.putchr_address).do_nothing
		end

end
