class
	SD_REGMATCH_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	rm_so: INTEGER_32 assign set_rm_so
		do
			Result := c_rm_so (c_pointer)
		end

	rm_eo: INTEGER_32 assign set_rm_eo
		do
			Result := c_rm_eo (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_rm_so (a_rm_so: INTEGER_32)
		do
			c_set_rm_so (c_pointer, a_rm_so)
		end

	set_rm_eo (a_rm_eo: INTEGER_32)
		do
			c_set_rm_eo (c_pointer, a_rm_eo)
		end

feature {NONE} -- C getters

	c_rm_so (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_regmatch_t_32 *)$tmp)->rm_so;"
		end

	c_rm_eo (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_regmatch_t_32 *)$tmp)->rm_eo;"
		end

feature {NONE} -- C setters

	c_set_rm_so (tmp: POINTER; a_rm_so: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_regmatch_t_32 *)$tmp)->rm_so = $a_rm_so;"
		end

	c_set_rm_eo (tmp: POINTER; a_rm_eo: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_regmatch_t_32 *)$tmp)->rm_eo = $a_rm_eo;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return sizeof(struct __anonstruct_regmatch_t_32);"
		end

end
