deferred class
	S_REGEX

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	regcomp (a_preg: CE_POINTER [SD_RE_PATTERN_BUFFER]; a_pattern: CE_POINTER [INTEGER_8]; a_cflags: INTEGER_32): INTEGER_32
		do
			Result := c_regcomp (a_preg.c_pointer, a_pattern.c_pointer, a_cflags)
		end

	c_regcomp (a_preg: POINTER; a_pattern: POINTER; a_cflags: INTEGER_32): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return regcomp($a_preg, $a_pattern, $a_cflags);"
		end

	regexec (a_preg: CE_POINTER [SD_RE_PATTERN_BUFFER]; a_string: CE_POINTER [INTEGER_8]; a_nmatch: NATURAL_32; a_pmatch: CE_POINTER [SD_REGMATCH_T]; a_eflags: INTEGER_32): INTEGER_32
		do
			Result := c_regexec (a_preg.c_pointer, a_string.c_pointer, a_nmatch, a_pmatch.c_pointer, a_eflags)
		end

	c_regexec (a_preg: POINTER; a_string: POINTER; a_nmatch: NATURAL_32; a_pmatch: POINTER; a_eflags: INTEGER_32): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return regexec($a_preg, $a_string, $a_nmatch, $a_pmatch, $a_eflags);"
		end

	regfree (a_preg: CE_POINTER [SD_RE_PATTERN_BUFFER])
		do
			c_regfree (a_preg.c_pointer)
		end

	c_regfree (a_preg: POINTER)
		external
			"C inline use <less.h>"
		alias
			"regfree($a_preg);"
		end

end
