deferred class
	S_SIGNAL

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	signal (a_sig: INTEGER_32; a_handler: CE_ROUTINE): CE_ROUTINE
		do
			create Result.make_shared (c_signal (a_sig, a_handler.c_pointer))
		end

	c_signal (a_sig: INTEGER_32; a_handler: POINTER): POINTER
		external
			"C inline use <less.h>"
		alias
			"return signal($a_sig, $a_handler);"
		end

	sigsetmask (a_mask: INTEGER_32): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return sigsetmask($a_mask);"
		end

	kill (a_pid: INTEGER_32; a_sig: INTEGER_32): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return kill($a_pid, $a_sig);"
		end

end
