class
	PD_ANONYMOUS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	c: INTEGER_8 assign set_c
		do
			Result := c_c (c_pointer)
		end

	x: NATURAL_32 assign set_x
		do
			Result := c_x (c_pointer)
		end

	x_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct __anonstruct_28, x);"
		end

feature {ANY} -- Eiffel setters

	set_c (a_c: INTEGER_8)
		do
			c_set_c (c_pointer, a_c)
		end

	set_x (a_x: NATURAL_32)
		do
			c_set_x (c_pointer, a_x)
		end

feature {NONE} -- C getters

	c_c (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct __anonstruct_28 *)$tmp)->c;"
		end

	c_x (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_28 *)$tmp)->x;"
		end

feature {NONE} -- C setters

	c_set_c (tmp: POINTER; a_c: INTEGER_8)
		external
			"C inline"
		alias
			"((struct __anonstruct_28 *)$tmp)->c = $a_c;"
		end

	c_set_x (tmp: POINTER; a_x: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_28 *)$tmp)->x = $a_x;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct __anonstruct_28);"
		end

end
