class
	PD_COMMANDS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	place: CE_POINTER [ANY] assign set_place
		do
			create Result.make_shared (c_place (c_pointer))
		end

	action: CE_ROUTINE assign set_action
		do
			create Result.make_shared (c_action (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_place (a_place: CE_POINTER [ANY])
		do
			c_set_place (c_pointer, a_place.c_pointer)
		end

	set_action (a_action: CE_ROUTINE)
		do
			c_set_action (c_pointer, a_action.c_pointer)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_commands_54 *)$tmp)->name;"
		end

	c_place (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_commands_54 *)$tmp)->place;"
		end

	c_action (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (_Bool( *)(char *, char *, void *))((struct __anonstruct_commands_54 *)$tmp)->action;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_commands_54 *)$tmp)->name = (char const *)$a_name;"
		end

	c_set_place (tmp: POINTER; a_place: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_commands_54 *)$tmp)->place = (void *)$a_place;"
		end

	c_set_action (tmp: POINTER; a_action: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_commands_54 *)$tmp)->action = (_Bool( *)(char const *, char const *, void *))$a_action;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct __anonstruct_commands_54);"
		end

end
