class
	PD_DATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	d4: SD_IN_ADDR assign set_d4
		do
			create Result.make_shared (c_d4 (c_pointer))
		end

	d6: SD_IN6_ADDR assign set_d6
		do
			create Result.make_shared (c_d6 (c_pointer))
		end

	d6_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(union __anonunion_data_49, d6);"
		end

feature {ANY} -- Eiffel setters

	set_d4 (a_d4: SD_IN_ADDR)
		do
			d4.ce_gets (a_d4)
		end

	set_d6 (a_d6: SD_IN6_ADDR)
		do
			d6.ce_gets (a_d6)
		end

feature {NONE} -- C getters

	c_d4 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct in_addr *)&((union __anonunion_data_49 *)$tmp)->d4;"
		end

	c_d6 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct in6_addr *)&((union __anonunion_data_49 *)$tmp)->d6;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(union __anonunion_data_49);"
		end

end
