class
	PD_DECODE_ITEM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	code: INTEGER_32 assign set_code
		do
			Result := c_code (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_code (a_code: INTEGER_32)
		do
			c_set_code (c_pointer, a_code)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct decode_item *)$tmp)->name;"
		end

	c_code (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct decode_item *)$tmp)->code;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct decode_item *)$tmp)->name = (char const *)$a_name;"
		end

	c_set_code (tmp: POINTER; a_code: INTEGER_32)
		external
			"C inline"
		alias
			"((struct decode_item *)$tmp)->code = $a_code;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct decode_item);"
		end

end
