class
	PD_DOT_PROGRESS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	initial_length: INTEGER_64 assign set_initial_length
		do
			Result := c_initial_length (c_pointer)
		end

	total_length: INTEGER_64 assign set_total_length
		do
			Result := c_total_length (c_pointer)
		end

	accumulated: INTEGER_32 assign set_accumulated
		do
			Result := c_accumulated (c_pointer)
		end

	rows: INTEGER_32 assign set_rows
		do
			Result := c_rows (c_pointer)
		end

	dots: INTEGER_32 assign set_dots
		do
			Result := c_dots (c_pointer)
		end

	last_timer_value: REAL_64 assign set_last_timer_value
		do
			Result := c_last_timer_value (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_initial_length (a_initial_length: INTEGER_64)
		do
			c_set_initial_length (c_pointer, a_initial_length)
		end

	set_total_length (a_total_length: INTEGER_64)
		do
			c_set_total_length (c_pointer, a_total_length)
		end

	set_accumulated (a_accumulated: INTEGER_32)
		do
			c_set_accumulated (c_pointer, a_accumulated)
		end

	set_rows (a_rows: INTEGER_32)
		do
			c_set_rows (c_pointer, a_rows)
		end

	set_dots (a_dots: INTEGER_32)
		do
			c_set_dots (c_pointer, a_dots)
		end

	set_last_timer_value (a_last_timer_value: REAL_64)
		do
			c_set_last_timer_value (c_pointer, a_last_timer_value)
		end

feature {NONE} -- C getters

	c_initial_length (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct dot_progress *)$tmp)->initial_length;"
		end

	c_total_length (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct dot_progress *)$tmp)->total_length;"
		end

	c_accumulated (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dot_progress *)$tmp)->accumulated;"
		end

	c_rows (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dot_progress *)$tmp)->rows;"
		end

	c_dots (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dot_progress *)$tmp)->dots;"
		end

	c_last_timer_value (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct dot_progress *)$tmp)->last_timer_value;"
		end

feature {NONE} -- C setters

	c_set_initial_length (tmp: POINTER; a_initial_length: INTEGER_64)
		external
			"C inline"
		alias
			"((struct dot_progress *)$tmp)->initial_length = $a_initial_length;"
		end

	c_set_total_length (tmp: POINTER; a_total_length: INTEGER_64)
		external
			"C inline"
		alias
			"((struct dot_progress *)$tmp)->total_length = $a_total_length;"
		end

	c_set_accumulated (tmp: POINTER; a_accumulated: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dot_progress *)$tmp)->accumulated = $a_accumulated;"
		end

	c_set_rows (tmp: POINTER; a_rows: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dot_progress *)$tmp)->rows = $a_rows;"
		end

	c_set_dots (tmp: POINTER; a_dots: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dot_progress *)$tmp)->dots = $a_dots;"
		end

	c_set_last_timer_value (tmp: POINTER; a_last_timer_value: REAL_64)
		external
			"C inline"
		alias
			"((struct dot_progress *)$tmp)->last_timer_value = $a_last_timer_value;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct dot_progress);"
		end

end
