class
	PD_GEN_MD5_CONTEXT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	imp: PD_MD5_CTX assign set_imp
		do
			create Result.make_shared (c_imp (c_pointer))
		end

	imp_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct gen_md5_context, imp);"
		end

feature {ANY} -- Eiffel setters

	set_imp (a_imp: PD_MD5_CTX)
		do
			imp.ce_gets (a_imp)
		end

feature {NONE} -- C getters

	c_imp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct md5_ctx *)&((struct gen_md5_context *)$tmp)->imp;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct gen_md5_context);"
		end

end
