class
	PD_KNOWN_TAG

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	tagid: INTEGER_32 assign set_tagid
		do
			Result := c_tagid (c_pointer)
		end

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	handler: CE_ROUTINE assign set_handler
		do
			create Result.make_shared (c_handler (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_tagid (a_tagid: INTEGER_32)
		do
			c_set_tagid (c_pointer, a_tagid)
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_handler (a_handler: CE_ROUTINE)
		do
			c_set_handler (c_pointer, a_handler.c_pointer)
		end

feature {NONE} -- C getters

	c_tagid (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct known_tag *)$tmp)->tagid;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct known_tag *)$tmp)->name;"
		end

	c_handler (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(int, struct taginfo *, struct map_context *))((struct known_tag *)$tmp)->handler;"
		end

feature {NONE} -- C setters

	c_set_tagid (tmp: POINTER; a_tagid: INTEGER_32)
		external
			"C inline"
		alias
			"((struct known_tag *)$tmp)->tagid = $a_tagid;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct known_tag *)$tmp)->name = (char const *)$a_name;"
		end

	c_set_handler (tmp: POINTER; a_handler: POINTER)
		external
			"C inline"
		alias
			"((struct known_tag *)$tmp)->handler = (void( *)(int, struct taginfo *, struct map_context *))$a_handler;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct known_tag);"
		end

end
