class
	PD_LOGVPRINTF_STATE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	bigmsg: CE_POINTER [INTEGER_8] assign set_bigmsg
		do
			create Result.make_shared (c_bigmsg (c_pointer))
		end

	expected_size: INTEGER_32 assign set_expected_size
		do
			Result := c_expected_size (c_pointer)
		end

	allocated: INTEGER_32 assign set_allocated
		do
			Result := c_allocated (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_bigmsg (a_bigmsg: CE_POINTER [INTEGER_8])
		do
			c_set_bigmsg (c_pointer, a_bigmsg.c_pointer)
		end

	set_expected_size (a_expected_size: INTEGER_32)
		do
			c_set_expected_size (c_pointer, a_expected_size)
		end

	set_allocated (a_allocated: INTEGER_32)
		do
			c_set_allocated (c_pointer, a_allocated)
		end

feature {NONE} -- C getters

	c_bigmsg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct logvprintf_state *)$tmp)->bigmsg;"
		end

	c_expected_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct logvprintf_state *)$tmp)->expected_size;"
		end

	c_allocated (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct logvprintf_state *)$tmp)->allocated;"
		end

feature {NONE} -- C setters

	c_set_bigmsg (tmp: POINTER; a_bigmsg: POINTER)
		external
			"C inline"
		alias
			"((struct logvprintf_state *)$tmp)->bigmsg = (char *)$a_bigmsg;"
		end

	c_set_expected_size (tmp: POINTER; a_expected_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct logvprintf_state *)$tmp)->expected_size = $a_expected_size;"
		end

	c_set_allocated (tmp: POINTER; a_allocated: INTEGER_32)
		external
			"C inline"
		alias
			"((struct logvprintf_state *)$tmp)->allocated = $a_allocated;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct logvprintf_state);"
		end

end
