class
	PD_OPTIONS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	verbose: INTEGER_32 assign set_verbose
		do
			Result := c_verbose (c_pointer)
		end

	quiet: BOOLEAN assign set_quiet
		do
			Result := c_quiet (c_pointer)
		end

	quiet_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, quiet);"
		end

	ntry: INTEGER_32 assign set_ntry
		do
			Result := c_ntry (c_pointer)
		end

	ntry_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, ntry);"
		end

	retry_connrefused: BOOLEAN assign set_retry_connrefused
		do
			Result := c_retry_connrefused (c_pointer)
		end

	retry_connrefused_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, retry_connrefused);"
		end

	background: BOOLEAN assign set_background
		do
			Result := c_background (c_pointer)
		end

	background_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, background);"
		end

	ignore_length: BOOLEAN assign set_ignore_length
		do
			Result := c_ignore_length (c_pointer)
		end

	ignore_length_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, ignore_length);"
		end

	recursive: BOOLEAN assign set_recursive
		do
			Result := c_recursive (c_pointer)
		end

	recursive_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, recursive);"
		end

	spanhost: BOOLEAN assign set_spanhost
		do
			Result := c_spanhost (c_pointer)
		end

	spanhost_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, spanhost);"
		end

	max_redirect: INTEGER_32 assign set_max_redirect
		do
			Result := c_max_redirect (c_pointer)
		end

	max_redirect_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, max_redirect);"
		end

	relative_only: BOOLEAN assign set_relative_only
		do
			Result := c_relative_only (c_pointer)
		end

	relative_only_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, relative_only);"
		end

	no_parent: BOOLEAN assign set_no_parent
		do
			Result := c_no_parent (c_pointer)
		end

	no_parent_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, no_parent);"
		end

	reclevel: INTEGER_32 assign set_reclevel
		do
			Result := c_reclevel (c_pointer)
		end

	reclevel_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, reclevel);"
		end

	dirstruct: BOOLEAN assign set_dirstruct
		do
			Result := c_dirstruct (c_pointer)
		end

	dirstruct_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, dirstruct);"
		end

	no_dirstruct: BOOLEAN assign set_no_dirstruct
		do
			Result := c_no_dirstruct (c_pointer)
		end

	cut_dirs: INTEGER_32 assign set_cut_dirs
		do
			Result := c_cut_dirs (c_pointer)
		end

	cut_dirs_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, cut_dirs);"
		end

	add_hostdir: BOOLEAN assign set_add_hostdir
		do
			Result := c_add_hostdir (c_pointer)
		end

	add_hostdir_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, add_hostdir);"
		end

	protocol_directories: BOOLEAN assign set_protocol_directories
		do
			Result := c_protocol_directories (c_pointer)
		end

	protocol_directories_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, protocol_directories);"
		end

	noclobber: BOOLEAN assign set_noclobber
		do
			Result := c_noclobber (c_pointer)
		end

	noclobber_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, noclobber);"
		end

	dir_prefix: CE_POINTER [INTEGER_8] assign set_dir_prefix
		do
			create Result.make_shared (c_dir_prefix (c_pointer))
		end

	dir_prefix_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, dir_prefix);"
		end

	lfilename: CE_POINTER [INTEGER_8] assign set_lfilename
		do
			create Result.make_shared (c_lfilename (c_pointer))
		end

	lfilename_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, lfilename);"
		end

	input_filename: CE_POINTER [INTEGER_8] assign set_input_filename
		do
			create Result.make_shared (c_input_filename (c_pointer))
		end

	input_filename_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, input_filename);"
		end

	force_html: BOOLEAN assign set_force_html
		do
			Result := c_force_html (c_pointer)
		end

	force_html_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, force_html);"
		end

	default_page: CE_POINTER [INTEGER_8] assign set_default_page
		do
			create Result.make_shared (c_default_page (c_pointer))
		end

	default_page_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, default_page);"
		end

	spider: BOOLEAN assign set_spider
		do
			Result := c_spider (c_pointer)
		end

	spider_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, spider);"
		end

	accepts: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_accepts
		do
			create Result.make_shared (c_accepts (c_pointer))
		end

	accepts_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, accepts);"
		end

	rejects: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_rejects
		do
			create Result.make_shared (c_rejects (c_pointer))
		end

	rejects_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, rejects);"
		end

	excludes: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_excludes
		do
			create Result.make_shared (c_excludes (c_pointer))
		end

	excludes_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, excludes);"
		end

	includes: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_includes
		do
			create Result.make_shared (c_includes (c_pointer))
		end

	includes_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, includes);"
		end

	ignore_case: BOOLEAN assign set_ignore_case
		do
			Result := c_ignore_case (c_pointer)
		end

	ignore_case_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, ignore_case);"
		end

	domains: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_domains
		do
			create Result.make_shared (c_domains (c_pointer))
		end

	domains_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, domains);"
		end

	exclude_domains: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_exclude_domains
		do
			create Result.make_shared (c_exclude_domains (c_pointer))
		end

	exclude_domains_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, exclude_domains);"
		end

	dns_cache: BOOLEAN assign set_dns_cache
		do
			Result := c_dns_cache (c_pointer)
		end

	dns_cache_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, dns_cache);"
		end

	follow_tags: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_follow_tags
		do
			create Result.make_shared (c_follow_tags (c_pointer))
		end

	follow_tags_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, follow_tags);"
		end

	ignore_tags: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_ignore_tags
		do
			create Result.make_shared (c_ignore_tags (c_pointer))
		end

	ignore_tags_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, ignore_tags);"
		end

	follow_ftp: BOOLEAN assign set_follow_ftp
		do
			Result := c_follow_ftp (c_pointer)
		end

	follow_ftp_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, follow_ftp);"
		end

	retr_symlinks: BOOLEAN assign set_retr_symlinks
		do
			Result := c_retr_symlinks (c_pointer)
		end

	retr_symlinks_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, retr_symlinks);"
		end

	output_document: CE_POINTER [INTEGER_8] assign set_output_document
		do
			create Result.make_shared (c_output_document (c_pointer))
		end

	output_document_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, output_document);"
		end

	user: CE_POINTER [INTEGER_8] assign set_user
		do
			create Result.make_shared (c_user (c_pointer))
		end

	user_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, user);"
		end

	passwd: CE_POINTER [INTEGER_8] assign set_passwd
		do
			create Result.make_shared (c_passwd (c_pointer))
		end

	passwd_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, passwd);"
		end

	ask_passwd: BOOLEAN assign set_ask_passwd
		do
			Result := c_ask_passwd (c_pointer)
		end

	ask_passwd_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, ask_passwd);"
		end

	always_rest: BOOLEAN assign set_always_rest
		do
			Result := c_always_rest (c_pointer)
		end

	always_rest_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, always_rest);"
		end

	ftp_user: CE_POINTER [INTEGER_8] assign set_ftp_user
		do
			create Result.make_shared (c_ftp_user (c_pointer))
		end

	ftp_user_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, ftp_user);"
		end

	ftp_passwd: CE_POINTER [INTEGER_8] assign set_ftp_passwd
		do
			create Result.make_shared (c_ftp_passwd (c_pointer))
		end

	ftp_passwd_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, ftp_passwd);"
		end

	netrc: BOOLEAN assign set_netrc
		do
			Result := c_netrc (c_pointer)
		end

	netrc_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, netrc);"
		end

	ftp_glob: BOOLEAN assign set_ftp_glob
		do
			Result := c_ftp_glob (c_pointer)
		end

	ftp_glob_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, ftp_glob);"
		end

	ftp_pasv: BOOLEAN assign set_ftp_pasv
		do
			Result := c_ftp_pasv (c_pointer)
		end

	ftp_pasv_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, ftp_pasv);"
		end

	http_user: CE_POINTER [INTEGER_8] assign set_http_user
		do
			create Result.make_shared (c_http_user (c_pointer))
		end

	http_user_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, http_user);"
		end

	http_passwd: CE_POINTER [INTEGER_8] assign set_http_passwd
		do
			create Result.make_shared (c_http_passwd (c_pointer))
		end

	http_passwd_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, http_passwd);"
		end

	user_headers: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_user_headers
		do
			create Result.make_shared (c_user_headers (c_pointer))
		end

	http_keep_alive: BOOLEAN assign set_http_keep_alive
		do
			Result := c_http_keep_alive (c_pointer)
		end

	http_keep_alive_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, http_keep_alive);"
		end

	use_proxy: BOOLEAN assign set_use_proxy
		do
			Result := c_use_proxy (c_pointer)
		end

	use_proxy_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, use_proxy);"
		end

	allow_cache: BOOLEAN assign set_allow_cache
		do
			Result := c_allow_cache (c_pointer)
		end

	allow_cache_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, allow_cache);"
		end

	http_proxy: CE_POINTER [INTEGER_8] assign set_http_proxy
		do
			create Result.make_shared (c_http_proxy (c_pointer))
		end

	http_proxy_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, http_proxy);"
		end

	ftp_proxy: CE_POINTER [INTEGER_8] assign set_ftp_proxy
		do
			create Result.make_shared (c_ftp_proxy (c_pointer))
		end

	ftp_proxy_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, ftp_proxy);"
		end

	https_proxy: CE_POINTER [INTEGER_8] assign set_https_proxy
		do
			create Result.make_shared (c_https_proxy (c_pointer))
		end

	https_proxy_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, https_proxy);"
		end

	no_proxy: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_no_proxy
		do
			create Result.make_shared (c_no_proxy (c_pointer))
		end

	no_proxy_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, no_proxy);"
		end

	base_href: CE_POINTER [INTEGER_8] assign set_base_href
		do
			create Result.make_shared (c_base_href (c_pointer))
		end

	base_href_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, base_href);"
		end

	progress_type: CE_POINTER [INTEGER_8] assign set_progress_type
		do
			create Result.make_shared (c_progress_type (c_pointer))
		end

	progress_type_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, progress_type);"
		end

	proxy_user: CE_POINTER [INTEGER_8] assign set_proxy_user
		do
			create Result.make_shared (c_proxy_user (c_pointer))
		end

	proxy_user_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, proxy_user);"
		end

	proxy_passwd: CE_POINTER [INTEGER_8] assign set_proxy_passwd
		do
			create Result.make_shared (c_proxy_passwd (c_pointer))
		end

	proxy_passwd_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, proxy_passwd);"
		end

	read_timeout: REAL_64 assign set_read_timeout
		do
			Result := c_read_timeout (c_pointer)
		end

	read_timeout_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, read_timeout);"
		end

	dns_timeout: REAL_64 assign set_dns_timeout
		do
			Result := c_dns_timeout (c_pointer)
		end

	dns_timeout_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, dns_timeout);"
		end

	connect_timeout: REAL_64 assign set_connect_timeout
		do
			Result := c_connect_timeout (c_pointer)
		end

	connect_timeout_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, connect_timeout);"
		end

	random_wait: BOOLEAN assign set_random_wait
		do
			Result := c_random_wait (c_pointer)
		end

	random_wait_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, random_wait);"
		end

	wait: REAL_64 assign set_wait
		do
			Result := c_wait (c_pointer)
		end

	wait_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, wait);"
		end

	waitretry: REAL_64 assign set_waitretry
		do
			Result := c_waitretry (c_pointer)
		end

	waitretry_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, waitretry);"
		end

	use_robots: BOOLEAN assign set_use_robots
		do
			Result := c_use_robots (c_pointer)
		end

	use_robots_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, use_robots);"
		end

	limit_rate: INTEGER_64 assign set_limit_rate
		do
			Result := c_limit_rate (c_pointer)
		end

	limit_rate_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, limit_rate);"
		end

	quota: INTEGER_64 assign set_quota
		do
			Result := c_quota (c_pointer)
		end

	quota_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, quota);"
		end

	server_response: BOOLEAN assign set_server_response
		do
			Result := c_server_response (c_pointer)
		end

	server_response_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, server_response);"
		end

	save_headers: BOOLEAN assign set_save_headers
		do
			Result := c_save_headers (c_pointer)
		end

	save_headers_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, save_headers);"
		end

	debug2: BOOLEAN assign set_debug2
		do
			Result := c_debug2 (c_pointer)
		end

	debug2_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, debug);"
		end

	timestamping: BOOLEAN assign set_timestamping
		do
			Result := c_timestamping (c_pointer)
		end

	timestamping_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, timestamping);"
		end

	backup_converted: BOOLEAN assign set_backup_converted
		do
			Result := c_backup_converted (c_pointer)
		end

	backup_converted_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, backup_converted);"
		end

	backups: BOOLEAN assign set_backups
		do
			Result := c_backups (c_pointer)
		end

	backups_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, backups);"
		end

	useragent: CE_POINTER [INTEGER_8] assign set_useragent
		do
			create Result.make_shared (c_useragent (c_pointer))
		end

	referer: CE_POINTER [INTEGER_8] assign set_referer
		do
			create Result.make_shared (c_referer (c_pointer))
		end

	referer_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, referer);"
		end

	convert_links: BOOLEAN assign set_convert_links
		do
			Result := c_convert_links (c_pointer)
		end

	convert_links_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, convert_links);"
		end

	remove_listing: BOOLEAN assign set_remove_listing
		do
			Result := c_remove_listing (c_pointer)
		end

	remove_listing_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, remove_listing);"
		end

	htmlify: BOOLEAN assign set_htmlify
		do
			Result := c_htmlify (c_pointer)
		end

	htmlify_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, htmlify);"
		end

	dot_style: CE_POINTER [INTEGER_8] assign set_dot_style
		do
			create Result.make_shared (c_dot_style (c_pointer))
		end

	dot_style_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, dot_style);"
		end

	dot_bytes: INTEGER_64 assign set_dot_bytes
		do
			Result := c_dot_bytes (c_pointer)
		end

	dot_bytes_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, dot_bytes);"
		end

	dots_in_line: INTEGER_32 assign set_dots_in_line
		do
			Result := c_dots_in_line (c_pointer)
		end

	dots_in_line_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, dots_in_line);"
		end

	dot_spacing: INTEGER_32 assign set_dot_spacing
		do
			Result := c_dot_spacing (c_pointer)
		end

	dot_spacing_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, dot_spacing);"
		end

	delete_after: BOOLEAN assign set_delete_after
		do
			Result := c_delete_after (c_pointer)
		end

	delete_after_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, delete_after);"
		end

	adjust_extension: BOOLEAN assign set_adjust_extension
		do
			Result := c_adjust_extension (c_pointer)
		end

	adjust_extension_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, adjust_extension);"
		end

	page_requisites: BOOLEAN assign set_page_requisites
		do
			Result := c_page_requisites (c_pointer)
		end

	page_requisites_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, page_requisites);"
		end

	bind_address: CE_POINTER [INTEGER_8] assign set_bind_address
		do
			create Result.make_shared (c_bind_address (c_pointer))
		end

	bind_address_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, bind_address);"
		end

	cookies: BOOLEAN assign set_cookies
		do
			Result := c_cookies (c_pointer)
		end

	cookies_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, cookies);"
		end

	cookies_input: CE_POINTER [INTEGER_8] assign set_cookies_input
		do
			create Result.make_shared (c_cookies_input (c_pointer))
		end

	cookies_input_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, cookies_input);"
		end

	cookies_output: CE_POINTER [INTEGER_8] assign set_cookies_output
		do
			create Result.make_shared (c_cookies_output (c_pointer))
		end

	cookies_output_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, cookies_output);"
		end

	keep_session_cookies: BOOLEAN assign set_keep_session_cookies
		do
			Result := c_keep_session_cookies (c_pointer)
		end

	keep_session_cookies_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, keep_session_cookies);"
		end

	post_data: CE_POINTER [INTEGER_8] assign set_post_data
		do
			create Result.make_shared (c_post_data (c_pointer))
		end

	post_data_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, post_data);"
		end

	post_file_name: CE_POINTER [INTEGER_8] assign set_post_file_name
		do
			create Result.make_shared (c_post_file_name (c_pointer))
		end

	post_file_name_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, post_file_name);"
		end

	restrict_files_os: INTEGER_32 assign set_restrict_files_os
		do
			Result := c_restrict_files_os (c_pointer)
		end

	restrict_files_ctrl: BOOLEAN assign set_restrict_files_ctrl
		do
			Result := c_restrict_files_ctrl (c_pointer)
		end

	restrict_files_nonascii: BOOLEAN assign set_restrict_files_nonascii
		do
			Result := c_restrict_files_nonascii (c_pointer)
		end

	restrict_files_case: INTEGER_32 assign set_restrict_files_case
		do
			Result := c_restrict_files_case (c_pointer)
		end

	strict_comments: BOOLEAN assign set_strict_comments
		do
			Result := c_strict_comments (c_pointer)
		end

	strict_comments_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, strict_comments);"
		end

	preserve_perm: BOOLEAN assign set_preserve_perm
		do
			Result := c_preserve_perm (c_pointer)
		end

	preserve_perm_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, preserve_perm);"
		end

	ipv4_only: BOOLEAN assign set_ipv4_only
		do
			Result := c_ipv4_only (c_pointer)
		end

	ipv4_only_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, ipv4_only);"
		end

	ipv6_only: BOOLEAN assign set_ipv6_only
		do
			Result := c_ipv6_only (c_pointer)
		end

	ipv6_only_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, ipv6_only);"
		end

	prefer_family: INTEGER_32 assign set_prefer_family
		do
			Result := c_prefer_family (c_pointer)
		end

	content_disposition: BOOLEAN assign set_content_disposition
		do
			Result := c_content_disposition (c_pointer)
		end

	content_disposition_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, content_disposition);"
		end

	auth_without_challenge: BOOLEAN assign set_auth_without_challenge
		do
			Result := c_auth_without_challenge (c_pointer)
		end

	auth_without_challenge_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, auth_without_challenge);"
		end

	enable_iri: BOOLEAN assign set_enable_iri
		do
			Result := c_enable_iri (c_pointer)
		end

	enable_iri_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, enable_iri);"
		end

	encoding_remote: CE_POINTER [INTEGER_8] assign set_encoding_remote
		do
			create Result.make_shared (c_encoding_remote (c_pointer))
		end

	encoding_remote_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, encoding_remote);"
		end

	locale: CE_POINTER [INTEGER_8] assign set_locale
		do
			create Result.make_shared (c_locale (c_pointer))
		end

	locale_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct options, locale);"
		end

feature {ANY} -- Eiffel setters

	set_verbose (a_verbose: INTEGER_32)
		do
			c_set_verbose (c_pointer, a_verbose)
		end

	set_quiet (a_quiet: BOOLEAN)
		do
			c_set_quiet (c_pointer, a_quiet)
		end

	set_ntry (a_ntry: INTEGER_32)
		do
			c_set_ntry (c_pointer, a_ntry)
		end

	set_retry_connrefused (a_retry_connrefused: BOOLEAN)
		do
			c_set_retry_connrefused (c_pointer, a_retry_connrefused)
		end

	set_background (a_background: BOOLEAN)
		do
			c_set_background (c_pointer, a_background)
		end

	set_ignore_length (a_ignore_length: BOOLEAN)
		do
			c_set_ignore_length (c_pointer, a_ignore_length)
		end

	set_recursive (a_recursive: BOOLEAN)
		do
			c_set_recursive (c_pointer, a_recursive)
		end

	set_spanhost (a_spanhost: BOOLEAN)
		do
			c_set_spanhost (c_pointer, a_spanhost)
		end

	set_max_redirect (a_max_redirect: INTEGER_32)
		do
			c_set_max_redirect (c_pointer, a_max_redirect)
		end

	set_relative_only (a_relative_only: BOOLEAN)
		do
			c_set_relative_only (c_pointer, a_relative_only)
		end

	set_no_parent (a_no_parent: BOOLEAN)
		do
			c_set_no_parent (c_pointer, a_no_parent)
		end

	set_reclevel (a_reclevel: INTEGER_32)
		do
			c_set_reclevel (c_pointer, a_reclevel)
		end

	set_dirstruct (a_dirstruct: BOOLEAN)
		do
			c_set_dirstruct (c_pointer, a_dirstruct)
		end

	set_no_dirstruct (a_no_dirstruct: BOOLEAN)
		do
			c_set_no_dirstruct (c_pointer, a_no_dirstruct)
		end

	set_cut_dirs (a_cut_dirs: INTEGER_32)
		do
			c_set_cut_dirs (c_pointer, a_cut_dirs)
		end

	set_add_hostdir (a_add_hostdir: BOOLEAN)
		do
			c_set_add_hostdir (c_pointer, a_add_hostdir)
		end

	set_protocol_directories (a_protocol_directories: BOOLEAN)
		do
			c_set_protocol_directories (c_pointer, a_protocol_directories)
		end

	set_noclobber (a_noclobber: BOOLEAN)
		do
			c_set_noclobber (c_pointer, a_noclobber)
		end

	set_dir_prefix (a_dir_prefix: CE_POINTER [INTEGER_8])
		do
			c_set_dir_prefix (c_pointer, a_dir_prefix.c_pointer)
		end

	set_lfilename (a_lfilename: CE_POINTER [INTEGER_8])
		do
			c_set_lfilename (c_pointer, a_lfilename.c_pointer)
		end

	set_input_filename (a_input_filename: CE_POINTER [INTEGER_8])
		do
			c_set_input_filename (c_pointer, a_input_filename.c_pointer)
		end

	set_force_html (a_force_html: BOOLEAN)
		do
			c_set_force_html (c_pointer, a_force_html)
		end

	set_default_page (a_default_page: CE_POINTER [INTEGER_8])
		do
			c_set_default_page (c_pointer, a_default_page.c_pointer)
		end

	set_spider (a_spider: BOOLEAN)
		do
			c_set_spider (c_pointer, a_spider)
		end

	set_accepts (a_accepts: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			c_set_accepts (c_pointer, a_accepts.c_pointer)
		end

	set_rejects (a_rejects: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			c_set_rejects (c_pointer, a_rejects.c_pointer)
		end

	set_excludes (a_excludes: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			c_set_excludes (c_pointer, a_excludes.c_pointer)
		end

	set_includes (a_includes: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			c_set_includes (c_pointer, a_includes.c_pointer)
		end

	set_ignore_case (a_ignore_case: BOOLEAN)
		do
			c_set_ignore_case (c_pointer, a_ignore_case)
		end

	set_domains (a_domains: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			c_set_domains (c_pointer, a_domains.c_pointer)
		end

	set_exclude_domains (a_exclude_domains: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			c_set_exclude_domains (c_pointer, a_exclude_domains.c_pointer)
		end

	set_dns_cache (a_dns_cache: BOOLEAN)
		do
			c_set_dns_cache (c_pointer, a_dns_cache)
		end

	set_follow_tags (a_follow_tags: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			c_set_follow_tags (c_pointer, a_follow_tags.c_pointer)
		end

	set_ignore_tags (a_ignore_tags: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			c_set_ignore_tags (c_pointer, a_ignore_tags.c_pointer)
		end

	set_follow_ftp (a_follow_ftp: BOOLEAN)
		do
			c_set_follow_ftp (c_pointer, a_follow_ftp)
		end

	set_retr_symlinks (a_retr_symlinks: BOOLEAN)
		do
			c_set_retr_symlinks (c_pointer, a_retr_symlinks)
		end

	set_output_document (a_output_document: CE_POINTER [INTEGER_8])
		do
			c_set_output_document (c_pointer, a_output_document.c_pointer)
		end

	set_user (a_user: CE_POINTER [INTEGER_8])
		do
			c_set_user (c_pointer, a_user.c_pointer)
		end

	set_passwd (a_passwd: CE_POINTER [INTEGER_8])
		do
			c_set_passwd (c_pointer, a_passwd.c_pointer)
		end

	set_ask_passwd (a_ask_passwd: BOOLEAN)
		do
			c_set_ask_passwd (c_pointer, a_ask_passwd)
		end

	set_always_rest (a_always_rest: BOOLEAN)
		do
			c_set_always_rest (c_pointer, a_always_rest)
		end

	set_ftp_user (a_ftp_user: CE_POINTER [INTEGER_8])
		do
			c_set_ftp_user (c_pointer, a_ftp_user.c_pointer)
		end

	set_ftp_passwd (a_ftp_passwd: CE_POINTER [INTEGER_8])
		do
			c_set_ftp_passwd (c_pointer, a_ftp_passwd.c_pointer)
		end

	set_netrc (a_netrc: BOOLEAN)
		do
			c_set_netrc (c_pointer, a_netrc)
		end

	set_ftp_glob (a_ftp_glob: BOOLEAN)
		do
			c_set_ftp_glob (c_pointer, a_ftp_glob)
		end

	set_ftp_pasv (a_ftp_pasv: BOOLEAN)
		do
			c_set_ftp_pasv (c_pointer, a_ftp_pasv)
		end

	set_http_user (a_http_user: CE_POINTER [INTEGER_8])
		do
			c_set_http_user (c_pointer, a_http_user.c_pointer)
		end

	set_http_passwd (a_http_passwd: CE_POINTER [INTEGER_8])
		do
			c_set_http_passwd (c_pointer, a_http_passwd.c_pointer)
		end

	set_user_headers (a_user_headers: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			c_set_user_headers (c_pointer, a_user_headers.c_pointer)
		end

	set_http_keep_alive (a_http_keep_alive: BOOLEAN)
		do
			c_set_http_keep_alive (c_pointer, a_http_keep_alive)
		end

	set_use_proxy (a_use_proxy: BOOLEAN)
		do
			c_set_use_proxy (c_pointer, a_use_proxy)
		end

	set_allow_cache (a_allow_cache: BOOLEAN)
		do
			c_set_allow_cache (c_pointer, a_allow_cache)
		end

	set_http_proxy (a_http_proxy: CE_POINTER [INTEGER_8])
		do
			c_set_http_proxy (c_pointer, a_http_proxy.c_pointer)
		end

	set_ftp_proxy (a_ftp_proxy: CE_POINTER [INTEGER_8])
		do
			c_set_ftp_proxy (c_pointer, a_ftp_proxy.c_pointer)
		end

	set_https_proxy (a_https_proxy: CE_POINTER [INTEGER_8])
		do
			c_set_https_proxy (c_pointer, a_https_proxy.c_pointer)
		end

	set_no_proxy (a_no_proxy: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			c_set_no_proxy (c_pointer, a_no_proxy.c_pointer)
		end

	set_base_href (a_base_href: CE_POINTER [INTEGER_8])
		do
			c_set_base_href (c_pointer, a_base_href.c_pointer)
		end

	set_progress_type (a_progress_type: CE_POINTER [INTEGER_8])
		do
			c_set_progress_type (c_pointer, a_progress_type.c_pointer)
		end

	set_proxy_user (a_proxy_user: CE_POINTER [INTEGER_8])
		do
			c_set_proxy_user (c_pointer, a_proxy_user.c_pointer)
		end

	set_proxy_passwd (a_proxy_passwd: CE_POINTER [INTEGER_8])
		do
			c_set_proxy_passwd (c_pointer, a_proxy_passwd.c_pointer)
		end

	set_read_timeout (a_read_timeout: REAL_64)
		do
			c_set_read_timeout (c_pointer, a_read_timeout)
		end

	set_dns_timeout (a_dns_timeout: REAL_64)
		do
			c_set_dns_timeout (c_pointer, a_dns_timeout)
		end

	set_connect_timeout (a_connect_timeout: REAL_64)
		do
			c_set_connect_timeout (c_pointer, a_connect_timeout)
		end

	set_random_wait (a_random_wait: BOOLEAN)
		do
			c_set_random_wait (c_pointer, a_random_wait)
		end

	set_wait (a_wait: REAL_64)
		do
			c_set_wait (c_pointer, a_wait)
		end

	set_waitretry (a_waitretry: REAL_64)
		do
			c_set_waitretry (c_pointer, a_waitretry)
		end

	set_use_robots (a_use_robots: BOOLEAN)
		do
			c_set_use_robots (c_pointer, a_use_robots)
		end

	set_limit_rate (a_limit_rate: INTEGER_64)
		do
			c_set_limit_rate (c_pointer, a_limit_rate)
		end

	set_quota (a_quota: INTEGER_64)
		do
			c_set_quota (c_pointer, a_quota)
		end

	set_server_response (a_server_response: BOOLEAN)
		do
			c_set_server_response (c_pointer, a_server_response)
		end

	set_save_headers (a_save_headers: BOOLEAN)
		do
			c_set_save_headers (c_pointer, a_save_headers)
		end

	set_debug2 (a_debug2: BOOLEAN)
		do
			c_set_debug2 (c_pointer, a_debug2)
		end

	set_timestamping (a_timestamping: BOOLEAN)
		do
			c_set_timestamping (c_pointer, a_timestamping)
		end

	set_backup_converted (a_backup_converted: BOOLEAN)
		do
			c_set_backup_converted (c_pointer, a_backup_converted)
		end

	set_backups (a_backups: BOOLEAN)
		do
			c_set_backups (c_pointer, a_backups)
		end

	set_useragent (a_useragent: CE_POINTER [INTEGER_8])
		do
			c_set_useragent (c_pointer, a_useragent.c_pointer)
		end

	set_referer (a_referer: CE_POINTER [INTEGER_8])
		do
			c_set_referer (c_pointer, a_referer.c_pointer)
		end

	set_convert_links (a_convert_links: BOOLEAN)
		do
			c_set_convert_links (c_pointer, a_convert_links)
		end

	set_remove_listing (a_remove_listing: BOOLEAN)
		do
			c_set_remove_listing (c_pointer, a_remove_listing)
		end

	set_htmlify (a_htmlify: BOOLEAN)
		do
			c_set_htmlify (c_pointer, a_htmlify)
		end

	set_dot_style (a_dot_style: CE_POINTER [INTEGER_8])
		do
			c_set_dot_style (c_pointer, a_dot_style.c_pointer)
		end

	set_dot_bytes (a_dot_bytes: INTEGER_64)
		do
			c_set_dot_bytes (c_pointer, a_dot_bytes)
		end

	set_dots_in_line (a_dots_in_line: INTEGER_32)
		do
			c_set_dots_in_line (c_pointer, a_dots_in_line)
		end

	set_dot_spacing (a_dot_spacing: INTEGER_32)
		do
			c_set_dot_spacing (c_pointer, a_dot_spacing)
		end

	set_delete_after (a_delete_after: BOOLEAN)
		do
			c_set_delete_after (c_pointer, a_delete_after)
		end

	set_adjust_extension (a_adjust_extension: BOOLEAN)
		do
			c_set_adjust_extension (c_pointer, a_adjust_extension)
		end

	set_page_requisites (a_page_requisites: BOOLEAN)
		do
			c_set_page_requisites (c_pointer, a_page_requisites)
		end

	set_bind_address (a_bind_address: CE_POINTER [INTEGER_8])
		do
			c_set_bind_address (c_pointer, a_bind_address.c_pointer)
		end

	set_cookies (a_cookies: BOOLEAN)
		do
			c_set_cookies (c_pointer, a_cookies)
		end

	set_cookies_input (a_cookies_input: CE_POINTER [INTEGER_8])
		do
			c_set_cookies_input (c_pointer, a_cookies_input.c_pointer)
		end

	set_cookies_output (a_cookies_output: CE_POINTER [INTEGER_8])
		do
			c_set_cookies_output (c_pointer, a_cookies_output.c_pointer)
		end

	set_keep_session_cookies (a_keep_session_cookies: BOOLEAN)
		do
			c_set_keep_session_cookies (c_pointer, a_keep_session_cookies)
		end

	set_post_data (a_post_data: CE_POINTER [INTEGER_8])
		do
			c_set_post_data (c_pointer, a_post_data.c_pointer)
		end

	set_post_file_name (a_post_file_name: CE_POINTER [INTEGER_8])
		do
			c_set_post_file_name (c_pointer, a_post_file_name.c_pointer)
		end

	set_restrict_files_os (a_restrict_files_os: INTEGER_32)
		do
			c_set_restrict_files_os (c_pointer, a_restrict_files_os)
		end

	set_restrict_files_ctrl (a_restrict_files_ctrl: BOOLEAN)
		do
			c_set_restrict_files_ctrl (c_pointer, a_restrict_files_ctrl)
		end

	set_restrict_files_nonascii (a_restrict_files_nonascii: BOOLEAN)
		do
			c_set_restrict_files_nonascii (c_pointer, a_restrict_files_nonascii)
		end

	set_restrict_files_case (a_restrict_files_case: INTEGER_32)
		do
			c_set_restrict_files_case (c_pointer, a_restrict_files_case)
		end

	set_strict_comments (a_strict_comments: BOOLEAN)
		do
			c_set_strict_comments (c_pointer, a_strict_comments)
		end

	set_preserve_perm (a_preserve_perm: BOOLEAN)
		do
			c_set_preserve_perm (c_pointer, a_preserve_perm)
		end

	set_ipv4_only (a_ipv4_only: BOOLEAN)
		do
			c_set_ipv4_only (c_pointer, a_ipv4_only)
		end

	set_ipv6_only (a_ipv6_only: BOOLEAN)
		do
			c_set_ipv6_only (c_pointer, a_ipv6_only)
		end

	set_prefer_family (a_prefer_family: INTEGER_32)
		do
			c_set_prefer_family (c_pointer, a_prefer_family)
		end

	set_content_disposition (a_content_disposition: BOOLEAN)
		do
			c_set_content_disposition (c_pointer, a_content_disposition)
		end

	set_auth_without_challenge (a_auth_without_challenge: BOOLEAN)
		do
			c_set_auth_without_challenge (c_pointer, a_auth_without_challenge)
		end

	set_enable_iri (a_enable_iri: BOOLEAN)
		do
			c_set_enable_iri (c_pointer, a_enable_iri)
		end

	set_encoding_remote (a_encoding_remote: CE_POINTER [INTEGER_8])
		do
			c_set_encoding_remote (c_pointer, a_encoding_remote.c_pointer)
		end

	set_locale (a_locale: CE_POINTER [INTEGER_8])
		do
			c_set_locale (c_pointer, a_locale.c_pointer)
		end

feature {NONE} -- C getters

	c_verbose (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct options *)$tmp)->verbose;"
		end

	c_quiet (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->quiet;"
		end

	c_ntry (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct options *)$tmp)->ntry;"
		end

	c_retry_connrefused (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->retry_connrefused;"
		end

	c_background (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->background;"
		end

	c_ignore_length (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->ignore_length;"
		end

	c_recursive (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->recursive;"
		end

	c_spanhost (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->spanhost;"
		end

	c_max_redirect (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct options *)$tmp)->max_redirect;"
		end

	c_relative_only (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->relative_only;"
		end

	c_no_parent (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->no_parent;"
		end

	c_reclevel (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct options *)$tmp)->reclevel;"
		end

	c_dirstruct (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->dirstruct;"
		end

	c_no_dirstruct (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->no_dirstruct;"
		end

	c_cut_dirs (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct options *)$tmp)->cut_dirs;"
		end

	c_add_hostdir (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->add_hostdir;"
		end

	c_protocol_directories (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->protocol_directories;"
		end

	c_noclobber (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->noclobber;"
		end

	c_dir_prefix (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->dir_prefix;"
		end

	c_lfilename (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->lfilename;"
		end

	c_input_filename (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->input_filename;"
		end

	c_force_html (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->force_html;"
		end

	c_default_page (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->default_page;"
		end

	c_spider (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->spider;"
		end

	c_accepts (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char * *)((struct options *)$tmp)->accepts;"
		end

	c_rejects (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char * *)((struct options *)$tmp)->rejects;"
		end

	c_excludes (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char * *)((struct options *)$tmp)->excludes;"
		end

	c_includes (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char * *)((struct options *)$tmp)->includes;"
		end

	c_ignore_case (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->ignore_case;"
		end

	c_domains (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char * *)((struct options *)$tmp)->domains;"
		end

	c_exclude_domains (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char * *)((struct options *)$tmp)->exclude_domains;"
		end

	c_dns_cache (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->dns_cache;"
		end

	c_follow_tags (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char * *)((struct options *)$tmp)->follow_tags;"
		end

	c_ignore_tags (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char * *)((struct options *)$tmp)->ignore_tags;"
		end

	c_follow_ftp (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->follow_ftp;"
		end

	c_retr_symlinks (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->retr_symlinks;"
		end

	c_output_document (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->output_document;"
		end

	c_user (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->user;"
		end

	c_passwd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->passwd;"
		end

	c_ask_passwd (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->ask_passwd;"
		end

	c_always_rest (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->always_rest;"
		end

	c_ftp_user (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->ftp_user;"
		end

	c_ftp_passwd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->ftp_passwd;"
		end

	c_netrc (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->netrc;"
		end

	c_ftp_glob (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->ftp_glob;"
		end

	c_ftp_pasv (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->ftp_pasv;"
		end

	c_http_user (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->http_user;"
		end

	c_http_passwd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->http_passwd;"
		end

	c_user_headers (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char * *)((struct options *)$tmp)->user_headers;"
		end

	c_http_keep_alive (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->http_keep_alive;"
		end

	c_use_proxy (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->use_proxy;"
		end

	c_allow_cache (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->allow_cache;"
		end

	c_http_proxy (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->http_proxy;"
		end

	c_ftp_proxy (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->ftp_proxy;"
		end

	c_https_proxy (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->https_proxy;"
		end

	c_no_proxy (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char * *)((struct options *)$tmp)->no_proxy;"
		end

	c_base_href (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->base_href;"
		end

	c_progress_type (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->progress_type;"
		end

	c_proxy_user (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->proxy_user;"
		end

	c_proxy_passwd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->proxy_passwd;"
		end

	c_read_timeout (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct options *)$tmp)->read_timeout;"
		end

	c_dns_timeout (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct options *)$tmp)->dns_timeout;"
		end

	c_connect_timeout (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct options *)$tmp)->connect_timeout;"
		end

	c_random_wait (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->random_wait;"
		end

	c_wait (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct options *)$tmp)->wait;"
		end

	c_waitretry (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct options *)$tmp)->waitretry;"
		end

	c_use_robots (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->use_robots;"
		end

	c_limit_rate (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct options *)$tmp)->limit_rate;"
		end

	c_quota (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct options *)$tmp)->quota;"
		end

	c_server_response (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->server_response;"
		end

	c_save_headers (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->save_headers;"
		end

	c_debug2 (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->debug;"
		end

	c_timestamping (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->timestamping;"
		end

	c_backup_converted (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->backup_converted;"
		end

	c_backups (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->backups;"
		end

	c_useragent (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->useragent;"
		end

	c_referer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->referer;"
		end

	c_convert_links (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->convert_links;"
		end

	c_remove_listing (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->remove_listing;"
		end

	c_htmlify (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->htmlify;"
		end

	c_dot_style (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->dot_style;"
		end

	c_dot_bytes (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct options *)$tmp)->dot_bytes;"
		end

	c_dots_in_line (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct options *)$tmp)->dots_in_line;"
		end

	c_dot_spacing (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct options *)$tmp)->dot_spacing;"
		end

	c_delete_after (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->delete_after;"
		end

	c_adjust_extension (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->adjust_extension;"
		end

	c_page_requisites (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->page_requisites;"
		end

	c_bind_address (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->bind_address;"
		end

	c_cookies (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->cookies;"
		end

	c_cookies_input (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->cookies_input;"
		end

	c_cookies_output (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->cookies_output;"
		end

	c_keep_session_cookies (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->keep_session_cookies;"
		end

	c_post_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->post_data;"
		end

	c_post_file_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->post_file_name;"
		end

	c_restrict_files_os (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct options *)$tmp)->restrict_files_os;"
		end

	c_restrict_files_ctrl (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->restrict_files_ctrl;"
		end

	c_restrict_files_nonascii (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->restrict_files_nonascii;"
		end

	c_restrict_files_case (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct options *)$tmp)->restrict_files_case;"
		end

	c_strict_comments (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->strict_comments;"
		end

	c_preserve_perm (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->preserve_perm;"
		end

	c_ipv4_only (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->ipv4_only;"
		end

	c_ipv6_only (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->ipv6_only;"
		end

	c_prefer_family (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct options *)$tmp)->prefer_family;"
		end

	c_content_disposition (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->content_disposition;"
		end

	c_auth_without_challenge (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->auth_without_challenge;"
		end

	c_enable_iri (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct options *)$tmp)->enable_iri;"
		end

	c_encoding_remote (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->encoding_remote;"
		end

	c_locale (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct options *)$tmp)->locale;"
		end

feature {NONE} -- C setters

	c_set_verbose (tmp: POINTER; a_verbose: INTEGER_32)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->verbose = $a_verbose;"
		end

	c_set_quiet (tmp: POINTER; a_quiet: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->quiet = $a_quiet;"
		end

	c_set_ntry (tmp: POINTER; a_ntry: INTEGER_32)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->ntry = $a_ntry;"
		end

	c_set_retry_connrefused (tmp: POINTER; a_retry_connrefused: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->retry_connrefused = $a_retry_connrefused;"
		end

	c_set_background (tmp: POINTER; a_background: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->background = $a_background;"
		end

	c_set_ignore_length (tmp: POINTER; a_ignore_length: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->ignore_length = $a_ignore_length;"
		end

	c_set_recursive (tmp: POINTER; a_recursive: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->recursive = $a_recursive;"
		end

	c_set_spanhost (tmp: POINTER; a_spanhost: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->spanhost = $a_spanhost;"
		end

	c_set_max_redirect (tmp: POINTER; a_max_redirect: INTEGER_32)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->max_redirect = $a_max_redirect;"
		end

	c_set_relative_only (tmp: POINTER; a_relative_only: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->relative_only = $a_relative_only;"
		end

	c_set_no_parent (tmp: POINTER; a_no_parent: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->no_parent = $a_no_parent;"
		end

	c_set_reclevel (tmp: POINTER; a_reclevel: INTEGER_32)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->reclevel = $a_reclevel;"
		end

	c_set_dirstruct (tmp: POINTER; a_dirstruct: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->dirstruct = $a_dirstruct;"
		end

	c_set_no_dirstruct (tmp: POINTER; a_no_dirstruct: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->no_dirstruct = $a_no_dirstruct;"
		end

	c_set_cut_dirs (tmp: POINTER; a_cut_dirs: INTEGER_32)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->cut_dirs = $a_cut_dirs;"
		end

	c_set_add_hostdir (tmp: POINTER; a_add_hostdir: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->add_hostdir = $a_add_hostdir;"
		end

	c_set_protocol_directories (tmp: POINTER; a_protocol_directories: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->protocol_directories = $a_protocol_directories;"
		end

	c_set_noclobber (tmp: POINTER; a_noclobber: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->noclobber = $a_noclobber;"
		end

	c_set_dir_prefix (tmp: POINTER; a_dir_prefix: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->dir_prefix = (char *)$a_dir_prefix;"
		end

	c_set_lfilename (tmp: POINTER; a_lfilename: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->lfilename = (char *)$a_lfilename;"
		end

	c_set_input_filename (tmp: POINTER; a_input_filename: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->input_filename = (char *)$a_input_filename;"
		end

	c_set_force_html (tmp: POINTER; a_force_html: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->force_html = $a_force_html;"
		end

	c_set_default_page (tmp: POINTER; a_default_page: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->default_page = (char *)$a_default_page;"
		end

	c_set_spider (tmp: POINTER; a_spider: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->spider = $a_spider;"
		end

	c_set_accepts (tmp: POINTER; a_accepts: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->accepts = (char * *)$a_accepts;"
		end

	c_set_rejects (tmp: POINTER; a_rejects: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->rejects = (char * *)$a_rejects;"
		end

	c_set_excludes (tmp: POINTER; a_excludes: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->excludes = (char * *)$a_excludes;"
		end

	c_set_includes (tmp: POINTER; a_includes: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->includes = (char * *)$a_includes;"
		end

	c_set_ignore_case (tmp: POINTER; a_ignore_case: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->ignore_case = $a_ignore_case;"
		end

	c_set_domains (tmp: POINTER; a_domains: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->domains = (char * *)$a_domains;"
		end

	c_set_exclude_domains (tmp: POINTER; a_exclude_domains: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->exclude_domains = (char * *)$a_exclude_domains;"
		end

	c_set_dns_cache (tmp: POINTER; a_dns_cache: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->dns_cache = $a_dns_cache;"
		end

	c_set_follow_tags (tmp: POINTER; a_follow_tags: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->follow_tags = (char * *)$a_follow_tags;"
		end

	c_set_ignore_tags (tmp: POINTER; a_ignore_tags: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->ignore_tags = (char * *)$a_ignore_tags;"
		end

	c_set_follow_ftp (tmp: POINTER; a_follow_ftp: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->follow_ftp = $a_follow_ftp;"
		end

	c_set_retr_symlinks (tmp: POINTER; a_retr_symlinks: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->retr_symlinks = $a_retr_symlinks;"
		end

	c_set_output_document (tmp: POINTER; a_output_document: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->output_document = (char *)$a_output_document;"
		end

	c_set_user (tmp: POINTER; a_user: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->user = (char *)$a_user;"
		end

	c_set_passwd (tmp: POINTER; a_passwd: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->passwd = (char *)$a_passwd;"
		end

	c_set_ask_passwd (tmp: POINTER; a_ask_passwd: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->ask_passwd = $a_ask_passwd;"
		end

	c_set_always_rest (tmp: POINTER; a_always_rest: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->always_rest = $a_always_rest;"
		end

	c_set_ftp_user (tmp: POINTER; a_ftp_user: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->ftp_user = (char *)$a_ftp_user;"
		end

	c_set_ftp_passwd (tmp: POINTER; a_ftp_passwd: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->ftp_passwd = (char *)$a_ftp_passwd;"
		end

	c_set_netrc (tmp: POINTER; a_netrc: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->netrc = $a_netrc;"
		end

	c_set_ftp_glob (tmp: POINTER; a_ftp_glob: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->ftp_glob = $a_ftp_glob;"
		end

	c_set_ftp_pasv (tmp: POINTER; a_ftp_pasv: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->ftp_pasv = $a_ftp_pasv;"
		end

	c_set_http_user (tmp: POINTER; a_http_user: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->http_user = (char *)$a_http_user;"
		end

	c_set_http_passwd (tmp: POINTER; a_http_passwd: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->http_passwd = (char *)$a_http_passwd;"
		end

	c_set_user_headers (tmp: POINTER; a_user_headers: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->user_headers = (char * *)$a_user_headers;"
		end

	c_set_http_keep_alive (tmp: POINTER; a_http_keep_alive: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->http_keep_alive = $a_http_keep_alive;"
		end

	c_set_use_proxy (tmp: POINTER; a_use_proxy: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->use_proxy = $a_use_proxy;"
		end

	c_set_allow_cache (tmp: POINTER; a_allow_cache: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->allow_cache = $a_allow_cache;"
		end

	c_set_http_proxy (tmp: POINTER; a_http_proxy: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->http_proxy = (char *)$a_http_proxy;"
		end

	c_set_ftp_proxy (tmp: POINTER; a_ftp_proxy: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->ftp_proxy = (char *)$a_ftp_proxy;"
		end

	c_set_https_proxy (tmp: POINTER; a_https_proxy: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->https_proxy = (char *)$a_https_proxy;"
		end

	c_set_no_proxy (tmp: POINTER; a_no_proxy: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->no_proxy = (char * *)$a_no_proxy;"
		end

	c_set_base_href (tmp: POINTER; a_base_href: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->base_href = (char *)$a_base_href;"
		end

	c_set_progress_type (tmp: POINTER; a_progress_type: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->progress_type = (char *)$a_progress_type;"
		end

	c_set_proxy_user (tmp: POINTER; a_proxy_user: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->proxy_user = (char *)$a_proxy_user;"
		end

	c_set_proxy_passwd (tmp: POINTER; a_proxy_passwd: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->proxy_passwd = (char *)$a_proxy_passwd;"
		end

	c_set_read_timeout (tmp: POINTER; a_read_timeout: REAL_64)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->read_timeout = $a_read_timeout;"
		end

	c_set_dns_timeout (tmp: POINTER; a_dns_timeout: REAL_64)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->dns_timeout = $a_dns_timeout;"
		end

	c_set_connect_timeout (tmp: POINTER; a_connect_timeout: REAL_64)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->connect_timeout = $a_connect_timeout;"
		end

	c_set_random_wait (tmp: POINTER; a_random_wait: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->random_wait = $a_random_wait;"
		end

	c_set_wait (tmp: POINTER; a_wait: REAL_64)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->wait = $a_wait;"
		end

	c_set_waitretry (tmp: POINTER; a_waitretry: REAL_64)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->waitretry = $a_waitretry;"
		end

	c_set_use_robots (tmp: POINTER; a_use_robots: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->use_robots = $a_use_robots;"
		end

	c_set_limit_rate (tmp: POINTER; a_limit_rate: INTEGER_64)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->limit_rate = $a_limit_rate;"
		end

	c_set_quota (tmp: POINTER; a_quota: INTEGER_64)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->quota = $a_quota;"
		end

	c_set_server_response (tmp: POINTER; a_server_response: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->server_response = $a_server_response;"
		end

	c_set_save_headers (tmp: POINTER; a_save_headers: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->save_headers = $a_save_headers;"
		end

	c_set_debug2 (tmp: POINTER; a_debug2: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->debug = $a_debug2;"
		end

	c_set_timestamping (tmp: POINTER; a_timestamping: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->timestamping = $a_timestamping;"
		end

	c_set_backup_converted (tmp: POINTER; a_backup_converted: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->backup_converted = $a_backup_converted;"
		end

	c_set_backups (tmp: POINTER; a_backups: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->backups = $a_backups;"
		end

	c_set_useragent (tmp: POINTER; a_useragent: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->useragent = (char *)$a_useragent;"
		end

	c_set_referer (tmp: POINTER; a_referer: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->referer = (char *)$a_referer;"
		end

	c_set_convert_links (tmp: POINTER; a_convert_links: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->convert_links = $a_convert_links;"
		end

	c_set_remove_listing (tmp: POINTER; a_remove_listing: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->remove_listing = $a_remove_listing;"
		end

	c_set_htmlify (tmp: POINTER; a_htmlify: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->htmlify = $a_htmlify;"
		end

	c_set_dot_style (tmp: POINTER; a_dot_style: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->dot_style = (char *)$a_dot_style;"
		end

	c_set_dot_bytes (tmp: POINTER; a_dot_bytes: INTEGER_64)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->dot_bytes = $a_dot_bytes;"
		end

	c_set_dots_in_line (tmp: POINTER; a_dots_in_line: INTEGER_32)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->dots_in_line = $a_dots_in_line;"
		end

	c_set_dot_spacing (tmp: POINTER; a_dot_spacing: INTEGER_32)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->dot_spacing = $a_dot_spacing;"
		end

	c_set_delete_after (tmp: POINTER; a_delete_after: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->delete_after = $a_delete_after;"
		end

	c_set_adjust_extension (tmp: POINTER; a_adjust_extension: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->adjust_extension = $a_adjust_extension;"
		end

	c_set_page_requisites (tmp: POINTER; a_page_requisites: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->page_requisites = $a_page_requisites;"
		end

	c_set_bind_address (tmp: POINTER; a_bind_address: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->bind_address = (char *)$a_bind_address;"
		end

	c_set_cookies (tmp: POINTER; a_cookies: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->cookies = $a_cookies;"
		end

	c_set_cookies_input (tmp: POINTER; a_cookies_input: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->cookies_input = (char *)$a_cookies_input;"
		end

	c_set_cookies_output (tmp: POINTER; a_cookies_output: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->cookies_output = (char *)$a_cookies_output;"
		end

	c_set_keep_session_cookies (tmp: POINTER; a_keep_session_cookies: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->keep_session_cookies = $a_keep_session_cookies;"
		end

	c_set_post_data (tmp: POINTER; a_post_data: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->post_data = (char *)$a_post_data;"
		end

	c_set_post_file_name (tmp: POINTER; a_post_file_name: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->post_file_name = (char *)$a_post_file_name;"
		end

	c_set_restrict_files_os (tmp: POINTER; a_restrict_files_os: INTEGER_32)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->restrict_files_os = $a_restrict_files_os;"
		end

	c_set_restrict_files_ctrl (tmp: POINTER; a_restrict_files_ctrl: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->restrict_files_ctrl = $a_restrict_files_ctrl;"
		end

	c_set_restrict_files_nonascii (tmp: POINTER; a_restrict_files_nonascii: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->restrict_files_nonascii = $a_restrict_files_nonascii;"
		end

	c_set_restrict_files_case (tmp: POINTER; a_restrict_files_case: INTEGER_32)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->restrict_files_case = $a_restrict_files_case;"
		end

	c_set_strict_comments (tmp: POINTER; a_strict_comments: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->strict_comments = $a_strict_comments;"
		end

	c_set_preserve_perm (tmp: POINTER; a_preserve_perm: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->preserve_perm = $a_preserve_perm;"
		end

	c_set_ipv4_only (tmp: POINTER; a_ipv4_only: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->ipv4_only = $a_ipv4_only;"
		end

	c_set_ipv6_only (tmp: POINTER; a_ipv6_only: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->ipv6_only = $a_ipv6_only;"
		end

	c_set_prefer_family (tmp: POINTER; a_prefer_family: INTEGER_32)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->prefer_family = $a_prefer_family;"
		end

	c_set_content_disposition (tmp: POINTER; a_content_disposition: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->content_disposition = $a_content_disposition;"
		end

	c_set_auth_without_challenge (tmp: POINTER; a_auth_without_challenge: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->auth_without_challenge = $a_auth_without_challenge;"
		end

	c_set_enable_iri (tmp: POINTER; a_enable_iri: BOOLEAN)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->enable_iri = $a_enable_iri;"
		end

	c_set_encoding_remote (tmp: POINTER; a_encoding_remote: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->encoding_remote = (char *)$a_encoding_remote;"
		end

	c_set_locale (tmp: POINTER; a_locale: POINTER)
		external
			"C inline"
		alias
			"((struct options *)$tmp)->locale = (char *)$a_locale;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct options);"
		end

end
