class
	PD_OPTIONS2

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	variable: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_variable
		do
			create Result.make_shared (c_variable (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_variable (a_variable: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			c_set_variable (c_pointer, a_variable.c_pointer)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_options_61 *)$tmp)->name;"
		end

	c_variable (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char * *)((struct __anonstruct_options_61 *)$tmp)->variable;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_options_61 *)$tmp)->name = (char const *)$a_name;"
		end

	c_set_variable (tmp: POINTER; a_variable: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_options_61 *)$tmp)->variable = (char * *)$a_variable;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct __anonstruct_options_61);"
		end

end
