class
	PD_PARAM_TOKEN

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	b: CE_POINTER [INTEGER_8] assign set_b
		do
			create Result.make_shared (c_b (c_pointer))
		end

	e: CE_POINTER [INTEGER_8] assign set_e
		do
			create Result.make_shared (c_e (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_b (a_b: CE_POINTER [INTEGER_8])
		do
			c_set_b (c_pointer, a_b.c_pointer)
		end

	set_e (a_e: CE_POINTER [INTEGER_8])
		do
			c_set_e (c_pointer, a_e.c_pointer)
		end

feature {NONE} -- C getters

	c_b (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_param_token_35 *)$tmp)->b;"
		end

	c_e (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_param_token_35 *)$tmp)->e;"
		end

feature {NONE} -- C setters

	c_set_b (tmp: POINTER; a_b: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_param_token_35 *)$tmp)->b = (char const *)$a_b;"
		end

	c_set_e (tmp: POINTER; a_e: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_param_token_35 *)$tmp)->e = (char const *)$a_e;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct __anonstruct_param_token_35);"
		end

end
