class
	PD_URLPOS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	url: CE_POINTER [PD_URL] assign set_url
		do
			create Result.make_shared (c_url (c_pointer))
		end

	local_name: CE_POINTER [INTEGER_8] assign set_local_name
		do
			create Result.make_shared (c_local_name (c_pointer))
		end

	ignore_when_downloading: NATURAL_32 assign set_ignore_when_downloading
		do
			Result := c_ignore_when_downloading (c_pointer)
		end

	link_relative_p: NATURAL_32 assign set_link_relative_p
		do
			Result := c_link_relative_p (c_pointer)
		end

	link_complete_p: NATURAL_32 assign set_link_complete_p
		do
			Result := c_link_complete_p (c_pointer)
		end

	link_base_p: NATURAL_32 assign set_link_base_p
		do
			Result := c_link_base_p (c_pointer)
		end

	link_inline_p: NATURAL_32 assign set_link_inline_p
		do
			Result := c_link_inline_p (c_pointer)
		end

	link_css_p: NATURAL_32 assign set_link_css_p
		do
			Result := c_link_css_p (c_pointer)
		end

	link_expect_html: NATURAL_32 assign set_link_expect_html
		do
			Result := c_link_expect_html (c_pointer)
		end

	link_expect_css: NATURAL_32 assign set_link_expect_css
		do
			Result := c_link_expect_css (c_pointer)
		end

	link_refresh_p: NATURAL_32 assign set_link_refresh_p
		do
			Result := c_link_refresh_p (c_pointer)
		end

	refresh_timeout: INTEGER_32 assign set_refresh_timeout
		do
			Result := c_refresh_timeout (c_pointer)
		end

	convert2: INTEGER_32 assign set_convert2
		do
			Result := c_convert2 (c_pointer)
		end

	pos: INTEGER_32 assign set_pos
		do
			Result := c_pos (c_pointer)
		end

	size: INTEGER_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	next: CE_POINTER [PD_URLPOS] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_url (a_url: CE_POINTER [PD_URL])
		do
			c_set_url (c_pointer, a_url.c_pointer)
		end

	set_local_name (a_local_name: CE_POINTER [INTEGER_8])
		do
			c_set_local_name (c_pointer, a_local_name.c_pointer)
		end

	set_ignore_when_downloading (a_ignore_when_downloading: NATURAL_32)
		do
			c_set_ignore_when_downloading (c_pointer, a_ignore_when_downloading)
		end

	set_link_relative_p (a_link_relative_p: NATURAL_32)
		do
			c_set_link_relative_p (c_pointer, a_link_relative_p)
		end

	set_link_complete_p (a_link_complete_p: NATURAL_32)
		do
			c_set_link_complete_p (c_pointer, a_link_complete_p)
		end

	set_link_base_p (a_link_base_p: NATURAL_32)
		do
			c_set_link_base_p (c_pointer, a_link_base_p)
		end

	set_link_inline_p (a_link_inline_p: NATURAL_32)
		do
			c_set_link_inline_p (c_pointer, a_link_inline_p)
		end

	set_link_css_p (a_link_css_p: NATURAL_32)
		do
			c_set_link_css_p (c_pointer, a_link_css_p)
		end

	set_link_expect_html (a_link_expect_html: NATURAL_32)
		do
			c_set_link_expect_html (c_pointer, a_link_expect_html)
		end

	set_link_expect_css (a_link_expect_css: NATURAL_32)
		do
			c_set_link_expect_css (c_pointer, a_link_expect_css)
		end

	set_link_refresh_p (a_link_refresh_p: NATURAL_32)
		do
			c_set_link_refresh_p (c_pointer, a_link_refresh_p)
		end

	set_refresh_timeout (a_refresh_timeout: INTEGER_32)
		do
			c_set_refresh_timeout (c_pointer, a_refresh_timeout)
		end

	set_convert2 (a_convert2: INTEGER_32)
		do
			c_set_convert2 (c_pointer, a_convert2)
		end

	set_pos (a_pos: INTEGER_32)
		do
			c_set_pos (c_pointer, a_pos)
		end

	set_size (a_size: INTEGER_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_next (a_next: CE_POINTER [PD_URLPOS])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

feature {NONE} -- C getters

	c_url (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct url *)((struct urlpos *)$tmp)->url;"
		end

	c_local_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct urlpos *)$tmp)->local_name;"
		end

	c_ignore_when_downloading (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct urlpos *)$tmp)->ignore_when_downloading;"
		end

	c_link_relative_p (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct urlpos *)$tmp)->link_relative_p;"
		end

	c_link_complete_p (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct urlpos *)$tmp)->link_complete_p;"
		end

	c_link_base_p (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct urlpos *)$tmp)->link_base_p;"
		end

	c_link_inline_p (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct urlpos *)$tmp)->link_inline_p;"
		end

	c_link_css_p (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct urlpos *)$tmp)->link_css_p;"
		end

	c_link_expect_html (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct urlpos *)$tmp)->link_expect_html;"
		end

	c_link_expect_css (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct urlpos *)$tmp)->link_expect_css;"
		end

	c_link_refresh_p (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct urlpos *)$tmp)->link_refresh_p;"
		end

	c_refresh_timeout (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct urlpos *)$tmp)->refresh_timeout;"
		end

	c_convert2 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct urlpos *)$tmp)->convert;"
		end

	c_pos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct urlpos *)$tmp)->pos;"
		end

	c_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct urlpos *)$tmp)->size;"
		end

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct urlpos *)((struct urlpos *)$tmp)->next;"
		end

feature {NONE} -- C setters

	c_set_url (tmp: POINTER; a_url: POINTER)
		external
			"C inline"
		alias
			"((struct urlpos *)$tmp)->url = (struct url *)$a_url;"
		end

	c_set_local_name (tmp: POINTER; a_local_name: POINTER)
		external
			"C inline"
		alias
			"((struct urlpos *)$tmp)->local_name = (char *)$a_local_name;"
		end

	c_set_ignore_when_downloading (tmp: POINTER; a_ignore_when_downloading: NATURAL_32)
		external
			"C inline"
		alias
			"((struct urlpos *)$tmp)->ignore_when_downloading = $a_ignore_when_downloading;"
		end

	c_set_link_relative_p (tmp: POINTER; a_link_relative_p: NATURAL_32)
		external
			"C inline"
		alias
			"((struct urlpos *)$tmp)->link_relative_p = $a_link_relative_p;"
		end

	c_set_link_complete_p (tmp: POINTER; a_link_complete_p: NATURAL_32)
		external
			"C inline"
		alias
			"((struct urlpos *)$tmp)->link_complete_p = $a_link_complete_p;"
		end

	c_set_link_base_p (tmp: POINTER; a_link_base_p: NATURAL_32)
		external
			"C inline"
		alias
			"((struct urlpos *)$tmp)->link_base_p = $a_link_base_p;"
		end

	c_set_link_inline_p (tmp: POINTER; a_link_inline_p: NATURAL_32)
		external
			"C inline"
		alias
			"((struct urlpos *)$tmp)->link_inline_p = $a_link_inline_p;"
		end

	c_set_link_css_p (tmp: POINTER; a_link_css_p: NATURAL_32)
		external
			"C inline"
		alias
			"((struct urlpos *)$tmp)->link_css_p = $a_link_css_p;"
		end

	c_set_link_expect_html (tmp: POINTER; a_link_expect_html: NATURAL_32)
		external
			"C inline"
		alias
			"((struct urlpos *)$tmp)->link_expect_html = $a_link_expect_html;"
		end

	c_set_link_expect_css (tmp: POINTER; a_link_expect_css: NATURAL_32)
		external
			"C inline"
		alias
			"((struct urlpos *)$tmp)->link_expect_css = $a_link_expect_css;"
		end

	c_set_link_refresh_p (tmp: POINTER; a_link_refresh_p: NATURAL_32)
		external
			"C inline"
		alias
			"((struct urlpos *)$tmp)->link_refresh_p = $a_link_refresh_p;"
		end

	c_set_refresh_timeout (tmp: POINTER; a_refresh_timeout: INTEGER_32)
		external
			"C inline"
		alias
			"((struct urlpos *)$tmp)->refresh_timeout = $a_refresh_timeout;"
		end

	c_set_convert2 (tmp: POINTER; a_convert2: INTEGER_32)
		external
			"C inline"
		alias
			"((struct urlpos *)$tmp)->convert = $a_convert2;"
		end

	c_set_pos (tmp: POINTER; a_pos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct urlpos *)$tmp)->pos = $a_pos;"
		end

	c_set_size (tmp: POINTER; a_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct urlpos *)$tmp)->size = $a_size;"
		end

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct urlpos *)$tmp)->next = (struct urlpos *)$a_next;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct urlpos);"
		end

end
