class
	P_EXITS

inherit
	WGET_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {NONE} -- Initialization

	default_create
		do
		end

feature {ANY} -- attributes

	final_exit_status: INTEGER_32 assign set_final_exit_status

	set_final_exit_status (a_final_exit_status: INTEGER_32)
		do
			final_exit_status := a_final_exit_status
		end

feature {ANY} -- routines

	get_status_for_err (a_err: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_err -- switch 1 head
					when 31 then l_pos := -1 + 1
					when 24 then l_pos := -1 + 2
					when 25 then l_pos := -1 + 2
					when 26 then l_pos := -1 + 2
					when 52 then l_pos := -1 + 2
					when 0 then l_pos := -1 + 3
					when 1 then l_pos := -1 + 3
					when 2 then l_pos := -1 + 3
					when 3 then l_pos := -1 + 3
					when 4 then l_pos := -1 + 3
					when 5 then l_pos := -1 + 3
					when 18 then l_pos := -1 + 3
					when 35 then l_pos := -1 + 3
					when 40 then l_pos := -1 + 3
					when 41 then l_pos := -1 + 3
					when 54 then l_pos := -1 + 4
					when 11 then l_pos := -1 + 5
					when 12 then l_pos := -1 + 5
					when 50 then l_pos := -1 + 5
					when 29 then l_pos := -1 + 6
					when 30 then l_pos := -1 + 6
					when 34 then l_pos := -1 + 7
					when 13 then l_pos := -1 + 7
					when 14 then l_pos := -1 + 7
					when 15 then l_pos := -1 + 7
					when 17 then l_pos := -1 + 7
					when 20 then l_pos := -1 + 7
					when 21 then l_pos := -1 + 7
					when 22 then l_pos := -1 + 7
					when 36 then l_pos := -1 + 7
					when 37 then l_pos := -1 + 7
					when 44 then l_pos := -1 + 7
					when 45 then l_pos := -1 + 7
					when 49 then l_pos := -1 + 7
					else l_pos := -1 + 8
					end
				when 1 then -- switch 1, case 31
					Result := 0
					js.return
				when 2 then -- switch 1, case 24 | switch 1, case 25 | switch 1, case 26 | switch 1, case 52
					if not js.return_called then
						Result := 3
						js.return
					end
				when 3 then -- switch 1, case 0 | switch 1, case 1 | switch 1, case 2 | switch 1, case 3 | switch 1, case 4 | switch 1, case 5 | switch 1, case 18 | switch 1, case 35 | switch 1, case 40 | switch 1, case 41
					if not js.return_called then
						Result := 4
						js.return
					end
				when 4 then -- switch 1, case 54
					if not js.return_called then
						Result := 5
						js.return
					end
				when 5 then -- switch 1, case 11 | switch 1, case 12 | switch 1, case 50
					if not js.return_called then
						Result := 6
						js.return
					end
				when 6 then -- switch 1, case 29 | switch 1, case 30
					if not js.return_called then
						Result := 7
						js.return
					end
				when 7 then -- switch 1, case 34 | switch 1, case 13 | switch 1, case 14 | switch 1, case 15 | switch 1, case 17 | switch 1, case 20 | switch 1, case 21 | switch 1, case 22 | switch 1, case 36 | switch 1, case 37 | switch 1, case 44 | switch 1, case 45 | switch 1, case 49
					if not js.return_called then
						Result := 8
						js.return
					end
				when 8 then -- switch 1, default:
					if not js.return_called then
						Result := 9
					end
				when 9 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	inform_exit_status (a_err: INTEGER_32)
		local
			l_new_status: INTEGER_32
		do
			l_new_status := (get_status_for_err (a_err))
			if l_new_status /= 0 then
				if final_exit_status = 0 then
					final_exit_status := l_new_status
				elseif l_new_status < final_exit_status then
					final_exit_status := l_new_status
				end
			end
		end

	get_exit_status: INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if final_exit_status = 9 then
				l_tmp := 1
			else
				l_tmp := final_exit_status
			end
			Result := l_tmp
		end

end
