class
	P_FTP_OPIE

inherit
	WGET_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {NONE} -- Initialization

	default_create
		do
			create Wp.make (<<2048, 4>>)
			create english.make (<<30>>)
		end

feature {ANY} -- attributes

	Wp: CE_ARRAY [CE_ARRAY [INTEGER_8]]

	english: CE_ARRAY [INTEGER_8]

feature {ANY} -- routines

	extract (a_s: CE_POINTER [NATURAL_8]; a_start: INTEGER_32; a_length: INTEGER_32): NATURAL_32
		local
			l_cl: NATURAL_8
			l_cc: NATURAL_8
			l_cr: NATURAL_8
			l_x: NATURAL_32
		do
			l_cl := a_s[a_start // 8]
			l_cc := a_s[(a_start // 8 + 1)]
			l_cr := a_s[(a_start // 8 + 2)]
			l_x := (((((((l_cl.to_integer_32).bit_shift_left (8))).bit_or (l_cc.to_integer_32)).to_natural_32).bit_shift_left (8))).bit_or (l_cr.to_natural_32)
			l_x := (l_x).bit_shift_right ((24 - (a_length + a_start \\ 8)))
			l_x := (l_x).bit_and (((65535).bit_shift_right ((16 - a_length))).to_natural_32)
			Result := l_x
		end

	btoe (a_store: CE_POINTER [INTEGER_8]; a_c: CE_POINTER [NATURAL_8]): CE_POINTER [INTEGER_8]
		local
			l_store: CE_POINTER [INTEGER_8]
			l_cp: CE_ARRAY [NATURAL_8]
			l_p___0: INTEGER_32
			l_i: INTEGER_32
			l_store_beg: CE_POINTER [INTEGER_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_tmp___19: CE_POINTER [INTEGER_8]
			l_tmp___21: INTEGER_32
			l_tmp___22: INTEGER_32
			l_tmp___23: INTEGER_32
			l_tmp___24: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_store.make
			create l_cp.make (<<10>>)
			create l_store_beg.make
			create l_tmp___4.make
			create l_tmp___9.make
			create l_tmp___14.make
			create l_tmp___19.make
			create l_tmp___24.make

			l_store.ce_gets (a_store)
			l_store_beg.ce_gets (l_store)
			l_store[0] := (('%/0/').code).to_integer_8
			memset (create {CE_POINTER [ANY]}.make_cast ((l_cp.address)), ('%/0/').code, (Natural_8_bytes.to_natural_32 * (10).to_natural_32)).do_nothing
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_cp), create {CE_POINTER [ANY]}.make_cast (a_c), (8).to_natural_32).do_nothing
			l_p___0 := 0
			l_i := 0
			from
			until
				not (l_i < 64)
			loop
				l_p___0 := (l_p___0.to_natural_32 + (extract (create {CE_POINTER [NATURAL_8]}.make_cast (l_cp), l_i, 2))).to_integer_32
				l_i := l_i + (2)
			end
			l_cp[8] := (((l_p___0.to_integer_8).to_integer_32).bit_shift_left (6)).to_natural_8
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_store), create {CE_POINTER [ANY]}.make_cast ((Wp[(extract (create {CE_POINTER [NATURAL_8]}.make_cast (l_cp), 0, 11)).to_integer_32] + 0)), (4).to_natural_32).do_nothing
			if not (l_store[1]).to_boolean then
				l_tmp___3 := 1
			else
				if not (l_store[2]).to_boolean then
					l_tmp___2 := 2
				else
					if not (l_store[3]).to_boolean then
						l_tmp___1 := 3
					else
						l_tmp___1 := 4
					end
					l_tmp___2 := l_tmp___1
				end
				l_tmp___3 := l_tmp___2
			end
			l_store.ce_gets (l_store + l_tmp___3)
			l_tmp___4.ce_gets (l_store)
			l_store.ce_gets (l_store + 1)
			l_tmp___4[0] := ((' ').code).to_integer_8
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_store), create {CE_POINTER [ANY]}.make_cast ((Wp[(extract (create {CE_POINTER [NATURAL_8]}.make_cast (l_cp), 11, 11)).to_integer_32] + 0)), (4).to_natural_32).do_nothing
			if not (l_store[1]).to_boolean then
				l_tmp___8 := 1
			else
				if not (l_store[2]).to_boolean then
					l_tmp___7 := 2
				else
					if not (l_store[3]).to_boolean then
						l_tmp___6 := 3
					else
						l_tmp___6 := 4
					end
					l_tmp___7 := l_tmp___6
				end
				l_tmp___8 := l_tmp___7
			end
			l_store.ce_gets (l_store + l_tmp___8)
			l_tmp___9.ce_gets (l_store)
			l_store.ce_gets (l_store + 1)
			l_tmp___9[0] := ((' ').code).to_integer_8
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_store), create {CE_POINTER [ANY]}.make_cast ((Wp[(extract (create {CE_POINTER [NATURAL_8]}.make_cast (l_cp), 22, 11)).to_integer_32] + 0)), (4).to_natural_32).do_nothing
			if not (l_store[1]).to_boolean then
				l_tmp___13 := 1
			else
				if not (l_store[2]).to_boolean then
					l_tmp___12 := 2
				else
					if not (l_store[3]).to_boolean then
						l_tmp___11 := 3
					else
						l_tmp___11 := 4
					end
					l_tmp___12 := l_tmp___11
				end
				l_tmp___13 := l_tmp___12
			end
			l_store.ce_gets (l_store + l_tmp___13)
			l_tmp___14.ce_gets (l_store)
			l_store.ce_gets (l_store + 1)
			l_tmp___14[0] := ((' ').code).to_integer_8
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_store), create {CE_POINTER [ANY]}.make_cast ((Wp[(extract (create {CE_POINTER [NATURAL_8]}.make_cast (l_cp), 33, 11)).to_integer_32] + 0)), (4).to_natural_32).do_nothing
			if not (l_store[1]).to_boolean then
				l_tmp___18 := 1
			else
				if not (l_store[2]).to_boolean then
					l_tmp___17 := 2
				else
					if not (l_store[3]).to_boolean then
						l_tmp___16 := 3
					else
						l_tmp___16 := 4
					end
					l_tmp___17 := l_tmp___16
				end
				l_tmp___18 := l_tmp___17
			end
			l_store.ce_gets (l_store + l_tmp___18)
			l_tmp___19.ce_gets (l_store)
			l_store.ce_gets (l_store + 1)
			l_tmp___19[0] := ((' ').code).to_integer_8
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_store), create {CE_POINTER [ANY]}.make_cast ((Wp[(extract (create {CE_POINTER [NATURAL_8]}.make_cast (l_cp), 44, 11)).to_integer_32] + 0)), (4).to_natural_32).do_nothing
			if not (l_store[1]).to_boolean then
				l_tmp___23 := 1
			else
				if not (l_store[2]).to_boolean then
					l_tmp___22 := 2
				else
					if not (l_store[3]).to_boolean then
						l_tmp___21 := 3
					else
						l_tmp___21 := 4
					end
					l_tmp___22 := l_tmp___21
				end
				l_tmp___23 := l_tmp___22
			end
			l_store.ce_gets (l_store + l_tmp___23)
			l_tmp___24.ce_gets (l_store)
			l_store.ce_gets (l_store + 1)
			l_tmp___24[0] := ((' ').code).to_integer_8
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_store), create {CE_POINTER [ANY]}.make_cast ((Wp[(extract (create {CE_POINTER [NATURAL_8]}.make_cast (l_cp), 55, 11)).to_integer_32] + 0)), (4).to_natural_32).do_nothing
			l_store[4] := (('%/0/').code).to_integer_8
			from
			until
				js.loop_left
			loop
				js.reset
				if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
					log_inst.debug_logprintf ([ce_string ("wrote %%s to STORE%N"), (quote_inst.quote (l_store_beg))])
				end
				js.break
			end
			js.reset
			Result := l_store_beg
		end

	skey_response (a_sequence: INTEGER_32; a_seed: CE_POINTER [INTEGER_8]; a_pass: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_sequence: INTEGER_32
			l_key: CE_ARRAY [NATURAL_8]
			l_md5_ctx: CE_POINTER [PD_GEN_MD5_CONTEXT]
			l_checksum: CE_ARRAY [NATURAL_32]
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_key.make (<<8>>)
			create l_md5_ctx.make
			create l_checksum.make (<<4>>)

			l_sequence := a_sequence
			l_md5_ctx.ce_gets (create {CE_POINTER [PD_GEN_MD5_CONTEXT]}.make_cast ((l_aaf.new ((gen_md5_inst.gen_md5_context_size).to_natural_32))))
			gen_md5_inst.gen_md5_init (l_md5_ctx)
			gen_md5_inst.gen_md5_update (create {CE_POINTER [NATURAL_8]}.make_cast (a_seed), (strlen (a_seed)).to_integer_32, l_md5_ctx)
			gen_md5_inst.gen_md5_update (create {CE_POINTER [NATURAL_8]}.make_cast (a_pass), (strlen (a_pass)).to_integer_32, l_md5_ctx)
			gen_md5_inst.gen_md5_finish (l_md5_ctx, create {CE_POINTER [NATURAL_8]}.make_cast (l_checksum))
			l_checksum[0] := (l_checksum[0]).bit_xor ((l_checksum[2]))
			l_checksum[1] := (l_checksum[1]).bit_xor ((l_checksum[3]))
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_key), create {CE_POINTER [ANY]}.make_cast (l_checksum), (8).to_natural_32).do_nothing
			from
			until
				js.loop_left
			loop
				js.reset
				l_tmp___3 := l_sequence
				l_sequence := l_sequence - 1
				if not (l_tmp___3 > 0) then
					js.break
				end
				if not js.loop_jumped then
					gen_md5_inst.gen_md5_init (l_md5_ctx)
					gen_md5_inst.gen_md5_update (create {CE_POINTER [NATURAL_8]}.make_cast (l_key), 8, l_md5_ctx)
					gen_md5_inst.gen_md5_finish (l_md5_ctx, create {CE_POINTER [NATURAL_8]}.make_cast (l_checksum))
					l_checksum[0] := (l_checksum[0]).bit_xor ((l_checksum[2]))
					l_checksum[1] := (l_checksum[1]).bit_xor ((l_checksum[3]))
					memcpy (create {CE_POINTER [ANY]}.make_cast (l_key), create {CE_POINTER [ANY]}.make_cast (l_checksum), (8).to_natural_32).do_nothing
				end
			end
			js.reset
			Result := (btoe (english, create {CE_POINTER [NATURAL_8]}.make_cast (l_key)))
		end

end
