class
	P_HOST

inherit
	WGET_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {NONE} -- Initialization

	default_create
		do
			create buf.make (<<64>>)
			create host_name_addresses_map.make
		end

feature {ANY} -- attributes

	buf: CE_ARRAY [INTEGER_8]

	host_name_addresses_map: CE_POINTER [PD_HASH_TABLE]

feature {ANY} -- routines

	address_list_get_bounds (a_al: CE_POINTER [PD_ADDRESS_LIST]; a_start: CE_POINTER [INTEGER_32]; a_end: CE_POINTER [INTEGER_32])
		do
			a_start.item := a_al.item.faulty
			a_end.item := a_al.item.count
		end

	address_list_address_at (a_al: CE_POINTER [PD_ADDRESS_LIST]; a_pos: INTEGER_32): CE_POINTER [PD_IP_ADDRESS]
		do
			if a_pos >= a_al.item.faulty then
				if not (a_pos < a_al.item.count) then
					assert_fail (ce_string ("pos >= al->faulty && pos < al->count"), ce_string ("host.c"), {NATURAL_32} 101, ce_string ("address_list_address_at"))
				end
			else
				assert_fail (ce_string ("pos >= al->faulty && pos < al->count"), ce_string ("host.c"), {NATURAL_32} 101, ce_string ("address_list_address_at"))
			end
			Result := (a_al.item.addresses + a_pos)
		end

	address_list_contains (a_al: CE_POINTER [PD_ADDRESS_LIST]; a_ip___0: CE_POINTER [PD_IP_ADDRESS]): BOOLEAN
		local
			l_i: INTEGER_32
			l_cur: CE_POINTER [PD_IP_ADDRESS]
			l_cur___0: CE_POINTER [PD_IP_ADDRESS]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_cur.make
			create l_cur___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_ip___0.item.family -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 10 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 2
					l_i := 0
					from
					until
						not (not js.loop_left and then (l_i < a_al.item.count))
					loop
						l_cur.ce_gets ((a_al.item.addresses + l_i))
						if l_cur.item.family = 2 then
							if l_cur.item.data.d4.s_addr = a_ip___0.item.data.d4.s_addr then
								Result := (1).to_boolean
								js.return
							end
						end
						if not js.return_called then
							l_i := l_i + 1
						end
					end
					if not js.return_called then
						Result := (0).to_boolean
						js.return
					end
				when 2 then -- switch 1, case 10
					if not js.return_called then
						l_i := 0
						from
						until
							not (not js.loop_left and then (l_i < a_al.item.count))
						loop
							l_cur___0.ce_gets ((a_al.item.addresses + l_i))
							if l_cur___0.item.family = 10 then
								if l_cur___0.item.ipv6_scope = a_ip___0.item.ipv6_scope then
									if create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [SD_IN6_ADDR]}.make_shared (l_cur___0.c_pointer + {PD_IP_ADDRESS}.data_offset + {PD_DATA}.d6_offset)))[0] = create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [SD_IN6_ADDR]}.make_shared (a_ip___0.c_pointer + {PD_IP_ADDRESS}.data_offset + {PD_DATA}.d6_offset)))[0] then
										if create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [SD_IN6_ADDR]}.make_shared (l_cur___0.c_pointer + {PD_IP_ADDRESS}.data_offset + {PD_DATA}.d6_offset)))[1] = create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [SD_IN6_ADDR]}.make_shared (a_ip___0.c_pointer + {PD_IP_ADDRESS}.data_offset + {PD_DATA}.d6_offset)))[1] then
											if create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [SD_IN6_ADDR]}.make_shared (l_cur___0.c_pointer + {PD_IP_ADDRESS}.data_offset + {PD_DATA}.d6_offset)))[2] = create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [SD_IN6_ADDR]}.make_shared (a_ip___0.c_pointer + {PD_IP_ADDRESS}.data_offset + {PD_DATA}.d6_offset)))[2] then
												if create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [SD_IN6_ADDR]}.make_shared (l_cur___0.c_pointer + {PD_IP_ADDRESS}.data_offset + {PD_DATA}.d6_offset)))[3] = create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [SD_IN6_ADDR]}.make_shared (a_ip___0.c_pointer + {PD_IP_ADDRESS}.data_offset + {PD_DATA}.d6_offset)))[3] then
													Result := (1).to_boolean
													js.return
												end
											end
										end
									end
								end
							end
							if not js.return_called then
								l_i := l_i + 1
							end
						end
					end
					if not js.return_called then
						Result := (0).to_boolean
						js.return
					end
				when 3 then -- switch 1, default:
					if not js.return_called then
						abort
					end
				when 4 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	address_list_set_faulty (a_al: CE_POINTER [PD_ADDRESS_LIST]; a_index___0: INTEGER_32)
		do
			if a_index___0 /= a_al.item.faulty then
				assert_fail (ce_string ("index == al->faulty"), ce_string ("host.c"), {NATURAL_32} 150, ce_string ("address_list_set_faulty"))
			end
			a_al.item.faulty := (a_al.item.faulty) + 1
			if a_al.item.faulty >= a_al.item.count then
				a_al.item.faulty := 0
			end
		end

	address_list_set_connected (a_al: CE_POINTER [PD_ADDRESS_LIST])
		do
			a_al.item.connected := (1).to_boolean
		end

	address_list_connected_p (a_al: CE_POINTER [PD_ADDRESS_LIST]): BOOLEAN
		do
			Result := (a_al.item.connected)
		end

	address_list_from_addrinfo (a_ai: CE_POINTER [SD_ADDRINFO]): CE_POINTER [PD_ADDRESS_LIST]
		local
			l_al: CE_POINTER [PD_ADDRESS_LIST]
			l_ptr: CE_POINTER [SD_ADDRINFO]
			l_cnt: INTEGER_32
			l_ip___0: CE_POINTER [PD_IP_ADDRESS]
			l_sin6: CE_POINTER [SD_SOCKADDR_IN6]
			l_sin: CE_POINTER [SD_SOCKADDR_IN]
			js: JUMP_STATE
		do
			create l_al.make
			create l_ptr.make
			create l_ip___0.make
			create l_sin6.make
			create l_sin.make

			l_cnt := 0
			l_ptr.ce_gets (a_ai)
			from
			until
				(l_ptr.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
			loop
				if l_ptr.item.ai_family = 2 then
					l_cnt := l_cnt + 1
				elseif l_ptr.item.ai_family = 10 then
					l_cnt := l_cnt + 1
				end
				l_ptr.ce_gets (l_ptr.item.ai_next)
			end
			if l_cnt = 0 then
				Result := (create {CE_POINTER [PD_ADDRESS_LIST]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_al.ce_gets (create {CE_POINTER [PD_ADDRESS_LIST]}.make_cast ((xmalloc_inst.xcalloc ((1).to_natural_32, {PD_ADDRESS_LIST}.sizeof.to_natural_32))))
				l_al.item.addresses := create {CE_POINTER [PD_IP_ADDRESS]}.make_cast ((xmalloc_inst.xmalloc (l_cnt.to_natural_32 * {PD_IP_ADDRESS}.sizeof.to_natural_32)))
				l_al.item.count := l_cnt
				l_al.item.refcount := 1
				l_ip___0.ce_gets (l_al.item.addresses)
				l_ptr.ce_gets (a_ai)
				from
				until
					(l_ptr.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
				loop
					if l_ptr.item.ai_family = 10 then
						l_sin6.ce_gets (create {CE_POINTER [SD_SOCKADDR_IN6]}.make_cast (l_ptr.item.ai_addr))
						l_ip___0.item.family := 10
						l_ip___0.item.data.d6 := l_sin6.item.sin6_addr
						l_ip___0.item.ipv6_scope := (l_sin6.item.sin6_scope_id).to_integer_32
						l_ip___0.ce_gets (l_ip___0 + 1)
					elseif l_ptr.item.ai_family = 2 then
						l_sin.ce_gets (create {CE_POINTER [SD_SOCKADDR_IN]}.make_cast (l_ptr.item.ai_addr))
						l_ip___0.item.family := 2
						l_ip___0.item.data.d4 := l_sin.item.sin_addr
						l_ip___0.ce_gets (l_ip___0 + 1)
					end
					l_ptr.ce_gets (l_ptr.item.ai_next)
				end
				if l_ip___0.distance ((l_al.item.addresses)) /= l_cnt then
					assert_fail (ce_string ("ip - al->addresses == cnt"), ce_string ("host.c"), {NATURAL_32} 224, ce_string ("address_list_from_addrinfo"))
				end
				Result := l_al
			end
		end

	cmp_prefer_ipv4 (a_addr1: CE_POINTER [ANY]; a_addr2: CE_POINTER [ANY]): INTEGER_32
		do
			Result := (((create {CE_POINTER [PD_IP_ADDRESS]}.make_cast (a_addr1)).item.family /= 2).to_integer - ((create {CE_POINTER [PD_IP_ADDRESS]}.make_cast (a_addr2)).item.family /= 2).to_integer)
		end

	cmp_prefer_ipv4_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmp_prefer_ipv4)
		end

	cmp_prefer_ipv6 (a_addr1: CE_POINTER [ANY]; a_addr2: CE_POINTER [ANY]): INTEGER_32
		do
			Result := (((create {CE_POINTER [PD_IP_ADDRESS]}.make_cast (a_addr1)).item.family /= 10).to_integer - ((create {CE_POINTER [PD_IP_ADDRESS]}.make_cast (a_addr2)).item.family /= 10).to_integer)
		end

	cmp_prefer_ipv6_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmp_prefer_ipv6)
		end

	address_list_delete (a_al: CE_POINTER [PD_ADDRESS_LIST])
		do
			free (create {CE_POINTER [ANY]}.make_cast (a_al.item.addresses))
			free (create {CE_POINTER [ANY]}.make_cast (a_al))
		end

	address_list_release (a_al: CE_POINTER [PD_ADDRESS_LIST])
		local
			js: JUMP_STATE
		do
			a_al.item.refcount := (a_al.item.refcount) - 1
			from
			until
				js.loop_left
			loop
				js.reset
				if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
					log_inst.debug_logprintf ([ce_string ("Releasing 0x%%0*lx (new refcount %%d).%N"), ({NATURAL_32} 2 * Pointer_bytes.to_natural_32).to_integer_32, (a_al.c_pointer.to_integer_32).to_natural_32, a_al.item.refcount])
				end
				js.break
			end
			js.reset
			if a_al.item.refcount <= 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
						log_inst.debug_logprintf ([ce_string ("Deleting unused 0x%%0*lx.%N"), ({NATURAL_32} 2 * Pointer_bytes.to_natural_32).to_integer_32, (a_al.c_pointer.to_integer_32).to_natural_32])
					end
					js.break
				end
				js.reset
				address_list_delete (a_al)
			end
		end

	getaddrinfo_with_timeout_callback (a_arg: CE_POINTER [ANY])
		local
			l_ctx: CE_POINTER [PD_GAIWT_CONTEXT]
		do
			create l_ctx.make

			l_ctx.ce_gets (create {CE_POINTER [PD_GAIWT_CONTEXT]}.make_cast (a_arg))
			l_ctx.item.exit_code := getaddrinfo (l_ctx.item.node, l_ctx.item.service, l_ctx.item.hints, l_ctx.item.res)
		end

	getaddrinfo_with_timeout_callback_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent getaddrinfo_with_timeout_callback)
		end

	getaddrinfo_with_timeout (a_node: CE_POINTER [INTEGER_8]; a_service: CE_POINTER [INTEGER_8]; a_hints: CE_POINTER [SD_ADDRINFO]; a_res___0: CE_POINTER [CE_POINTER [SD_ADDRINFO]]; a_timeout: REAL_64): INTEGER_32
		local
			l_ctx: PD_GAIWT_CONTEXT
			js: JUMP_STATE
		do
			create l_ctx.make

			l_ctx.node := a_node
			l_ctx.service := a_service
			l_ctx.hints := a_hints
			l_ctx.res := a_res___0
			if (utils_inst.run_with_timeout (a_timeout, getaddrinfo_with_timeout_callback_address, create {CE_POINTER [ANY]}.make_cast ((l_ctx.address)))) then
				(errno_location).item := 110
				Result := (-11)
				js.return
			end
			if not js.return_called then
				Result := (l_ctx.exit_code)
			end
		end

	print_address (a_addr: CE_POINTER [PD_IP_ADDRESS]): CE_POINTER [INTEGER_8]
		do
			if ((inet_ntop (a_addr.item.family, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_DATA]}.make_shared (a_addr.c_pointer + {PD_IP_ADDRESS}.data_offset))), buf, (Integer_8_bytes.to_natural_32 * (64).to_natural_32)))).c_pointer = default_pointer then
				snprintf ([buf, (Integer_8_bytes.to_natural_32 * (64).to_natural_32), ce_string ("<error: %%s>"), (strerror ((errno_location).item))]).do_nothing
			end
			Result := buf
		end

	is_valid_ipv4_address (a_str: CE_POINTER [INTEGER_8]; a_end: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_str: CE_POINTER [INTEGER_8]
			l_saw_digit: BOOLEAN
			l_octets: INTEGER_32
			l_val: INTEGER_32
			l_ch: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_str.make
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_str.ce_gets (a_str)
					l_saw_digit := (0).to_boolean
					l_octets := 0
					l_val := 0
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_str.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32)) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						l_tmp.ce_gets (l_str)
						l_str.ce_gets (l_str + 1)
						l_ch := (l_tmp[0]).to_integer_32
						if not (l_ch >= 48) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if l_ch <= 57 then
							l_val := l_val * 10 + (l_ch - 48)
							if l_val > 255 then
								Result := (0).to_boolean
								js.return
							end
							if not js.return_called and then (not l_saw_digit) then
								l_octets := l_octets + 1
								if l_octets > 4 then
									Result := (0).to_boolean
									js.return
								end
								if not js.return_called then
									l_saw_digit := (1).to_boolean
								end
							end
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if l_ch = 46 then
							if l_saw_digit then
								if l_octets = 4 then
									Result := (0).to_boolean
									js.return
								end
								if not js.return_called then
									l_val := 0
									l_saw_digit := (0).to_boolean
								end
							else
								Result := (0).to_boolean
								js.return
							end
						else
							Result := (0).to_boolean
							js.return
						end
				when 6 then
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					if not js.return_called and then (l_octets < 4) then
						Result := (0).to_boolean
						js.return
					end
					if not js.return_called then
						Result := (1).to_boolean
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	is_valid_ipv6_address (a_str: CE_POINTER [INTEGER_8]; a_end: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_str: CE_POINTER [INTEGER_8]
			l_curtok: CE_POINTER [INTEGER_8]
			l_tp: INTEGER_32
			l_colonp: CE_POINTER [INTEGER_8]
			l_saw_xdigit: BOOLEAN
			l_val: NATURAL_32
			l_ch: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_str.make
			create l_curtok.make
			create l_colonp.make
			create l_tmp.make

			l_str.ce_gets (a_str)
			l_tp := 0
			l_colonp.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
			if (l_str.c_pointer.to_integer_32).to_natural_32 = (a_end.c_pointer.to_integer_32).to_natural_32 then
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called and then ((l_str[0]).to_integer_32 = 58) then
				l_str.ce_gets (l_str + 1)
				if (l_str.c_pointer.to_integer_32).to_natural_32 = (a_end.c_pointer.to_integer_32).to_natural_32 then
					Result := (0).to_boolean
					js.return
				elseif (l_str[0]).to_integer_32 /= 58 then
					Result := (0).to_boolean
					js.return
				end
			end
			if not js.return_called then
				l_curtok.ce_gets (l_str)
				l_saw_xdigit := (0).to_boolean
				l_val := {NATURAL_32} 0
				from
				until
					not (not js.loop_left and then ((l_str.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32))
				loop
					js.reset
					l_tmp.ce_gets (l_str)
					l_str.ce_gets (l_str + 1)
					l_ch := (l_tmp[0]).to_integer_32
					if (c_ctype_inst.c2_isxdigit (l_ch)) then
						l_val := (l_val).bit_shift_left ((4))
						if l_ch < 65 then
							l_tmp___1 := l_ch - 48
						else
							l_tmp___1 := ((c_ctype_inst.c2_toupper (l_ch)) - 65) + 10
						end
						l_val := (l_val).bit_or (l_tmp___1.to_natural_32)
						if l_val > {NATURAL_32} 65535 then
							Result := (0).to_boolean
							js.return
						end
						if not js.return_called then
							l_saw_xdigit := (1).to_boolean
							js.continue
						end
					end
					if not js.loop_jumped and then (l_ch = 58) then
						l_curtok.ce_gets (l_str)
						if not l_saw_xdigit then
							if (l_colonp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								Result := (0).to_boolean
								js.return
							end
							if not js.return_called then
								l_colonp.ce_gets (l_str + l_tp)
								js.continue
							end
						elseif (l_str.c_pointer.to_integer_32).to_natural_32 = (a_end.c_pointer.to_integer_32).to_natural_32 then
							Result := (0).to_boolean
							js.return
						end
						if not js.loop_jumped then
							if l_tp > 14 then
								Result := (0).to_boolean
								js.return
							end
							if not js.return_called then
								l_tp := l_tp + (2)
								l_saw_xdigit := (0).to_boolean
								l_val := {NATURAL_32} 0
								js.continue
							end
						end
					end
					if not js.loop_jumped and then (l_ch = 46) then
						if l_tp <= 12 then
							if (is_valid_ipv4_address (l_curtok, a_end)).to_integer = 1 then
								l_tp := l_tp + (4)
								l_saw_xdigit := (0).to_boolean
								js.break
							end
						end
					end
					if not js.loop_jumped then
						Result := (0).to_boolean
						js.return
					end
				end
				js.reset
			end
			if not js.return_called and then l_saw_xdigit then
				if l_tp > 14 then
					Result := (0).to_boolean
					js.return
				end
				if not js.return_called then
					l_tp := l_tp + (2)
				end
			end
			if not js.return_called and then ((l_colonp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32) then
				if l_tp = 16 then
					Result := (0).to_boolean
					js.return
				end
				if not js.return_called then
					l_tp := 16
				end
			end
			if not js.return_called and then (l_tp /= 16) then
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called then
				Result := (1).to_boolean
			end
		end

	cache_query (a_host: CE_POINTER [INTEGER_8]): CE_POINTER [PD_ADDRESS_LIST]
		local
			l_al: CE_POINTER [PD_ADDRESS_LIST]
			js: JUMP_STATE
		do
			create l_al.make

			if (host_name_addresses_map).c_pointer = default_pointer then
				Result := (create {CE_POINTER [PD_ADDRESS_LIST]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_al.ce_gets (create {CE_POINTER [PD_ADDRESS_LIST]}.make_cast ((hash_inst.hash_table_get (host_name_addresses_map, create {CE_POINTER [ANY]}.make_cast (a_host)))))
				if ((l_al).c_pointer /= default_pointer) then
					from
					until
						js.loop_left
					loop
						js.reset
						if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
							log_inst.debug_logprintf ([ce_string ("Found %%s in host_name_addresses_map (%%p)%N"), a_host, l_al])
						end
						js.break
					end
					js.reset
					l_al.item.refcount := (l_al.item.refcount) + 1
					Result := l_al
					js.return
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [PD_ADDRESS_LIST]}.make_shared (default_pointer))
			end
		end

	cache_store (a_host: CE_POINTER [INTEGER_8]; a_al: CE_POINTER [PD_ADDRESS_LIST])
		local
			l_i: INTEGER_32
		do
			if (host_name_addresses_map).c_pointer = default_pointer then
				host_name_addresses_map.ce_gets (hash_inst.make_nocase_string_hash_table (0))
			end
			a_al.item.refcount := (a_al.item.refcount) + 1
			hash_inst.hash_table_put (host_name_addresses_map, create {CE_POINTER [ANY]}.make_cast ((utils_inst.xstrdup_lower (a_host))), create {CE_POINTER [ANY]}.make_cast (a_al))
			if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
				log_inst.debug_logprintf ([ce_string ("Caching %%s =>"), a_host])
				l_i := 0
				from
				until
					not (l_i < a_al.item.count)
				loop
					log_inst.debug_logprintf ([ce_string (" %%s"), (print_address ((a_al.item.addresses + l_i)))])
					l_i := l_i + 1
				end
				log_inst.debug_logprintf ([ce_string ("%N")])
			end
		end

	cache_remove (a_host: CE_POINTER [INTEGER_8])
		local
			l_al: CE_POINTER [PD_ADDRESS_LIST]
			js: JUMP_STATE
		do
			create l_al.make

			if (host_name_addresses_map).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				l_al.ce_gets (create {CE_POINTER [PD_ADDRESS_LIST]}.make_cast ((hash_inst.hash_table_get (host_name_addresses_map, create {CE_POINTER [ANY]}.make_cast (a_host)))))
				if ((l_al).c_pointer /= default_pointer) then
					address_list_release (l_al)
					hash_inst.hash_table_remove (host_name_addresses_map, create {CE_POINTER [ANY]}.make_cast (a_host)).do_nothing
				end
			end
		end

	lookup_host (a_host: CE_POINTER [INTEGER_8]; a_flags: INTEGER_32): CE_POINTER [PD_ADDRESS_LIST]
		local
			l_al: CE_POINTER [PD_ADDRESS_LIST]
			l_silent: BOOLEAN
			l_use_cache: BOOLEAN
			l_numeric_address: BOOLEAN
			l_timeout: REAL_64
			l_end: CE_POINTER [INTEGER_8]
			l_str: CE_POINTER [INTEGER_8]
			l_name: CE_POINTER [INTEGER_8]
			l_len: INTEGER_32
			l_tmp___2: NATURAL_32
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_err: INTEGER_32
			l_hints: SD_ADDRINFO
			l_res___0: CE_POINTER [SD_ADDRINFO]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___14: CE_ROUTINE
			l_i: INTEGER_32
			l_printmax: INTEGER_32
			l_tmp___15: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_al.make
			create l_end.make
			create l_str.make
			create l_name.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_hints.make
			create l_res___0.make
			create l_tmp___11.make
			create l_tmp___14.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_silent := (((a_flags).bit_and (1)).to_boolean)
					l_numeric_address := (0).to_boolean
					l_timeout := options_inst.opt.dns_timeout
					l_end.ce_gets (a_host + (strlen (a_host)).to_integer_32)
					if (is_valid_ipv4_address (a_host, l_end)) then
						l_numeric_address := (1).to_boolean
					elseif (is_valid_ipv6_address (a_host, l_end)) then
						l_numeric_address := (1).to_boolean
					end
					l_use_cache := options_inst.opt.dns_cache
					if ((a_flags).bit_and (2)).to_boolean then
						l_use_cache := (0).to_boolean
					elseif l_numeric_address then
						l_use_cache := (0).to_boolean
					end
					if l_use_cache then
						if not ((a_flags).bit_and (4)).to_boolean then
							l_al.ce_gets (cache_query (a_host))
							if ((l_al).c_pointer /= default_pointer) then
								Result := l_al
								js.return
							end
						else
							cache_remove (a_host)
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not l_silent then
							if not l_numeric_address then
								l_str.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								if options_inst.opt.enable_iri then
									l_name.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
									if (l_name.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										l_tmp___2 := strlen (a_host)
										l_len := ((l_tmp___2 + (strlen (l_name))) + {NATURAL_32} 4).to_integer_32
										l_str.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc (l_len.to_natural_32))))
										snprintf ([l_str, l_len.to_natural_32, ce_string ("%%s (%%s)"), l_name, a_host]).do_nothing
										l_str[(l_len - 1)] := (('%/0/').code).to_integer_8
										free (create {CE_POINTER [ANY]}.make_cast (l_name))
									end
								end
								if ((l_str).c_pointer /= default_pointer) then
									l_tmp___5.ce_gets (l_str)
								else
									l_tmp___5.ce_gets (a_host)
								end
								l_tmp___6.ce_gets (quotearg_inst.quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_tmp___5))
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Resolving %%s... "))), l_tmp___6])
								if ((l_str).c_pointer /= default_pointer) then
									free (create {CE_POINTER [ANY]}.make_cast (l_str))
								end
							end
						end
						memset (create {CE_POINTER [ANY]}.make_cast ((l_hints.address)), ('%/0/').code, {SD_ADDRINFO}.sizeof.to_natural_32).do_nothing
						l_hints.ai_socktype := 1
						if options_inst.opt.ipv4_only then
							l_hints.ai_family := 2
						elseif options_inst.opt.ipv6_only then
							l_hints.ai_family := 10
						else
							l_hints.ai_family := 0
						end
						if ((a_flags).bit_and (2)).to_boolean then
							l_hints.ai_flags := (l_hints.ai_flags).bit_or ((1))
						end
						if l_numeric_address then
							l_hints.ai_flags := (l_hints.ai_flags).bit_or ((4))
							l_timeout := (0).to_double
						end
						l_err := getaddrinfo_with_timeout (a_host, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), (l_hints.address), l_res___0.address, l_timeout)
						if l_err = 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if (l_res___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if not l_silent then
							if l_err /= -11 then
								l_tmp___11.ce_gets ((gai_strerror (l_err)))
							else
								l_tmp___11.ce_gets ((strerror ((errno_location).item)))
							end
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("failed: %%s.%N"))), l_tmp___11])
						end
						Result := (create {CE_POINTER [PD_ADDRESS_LIST]}.make_shared (default_pointer))
						js.return
				when 6 then -- if done | if done
						if not js.return_called then
							l_al.ce_gets (address_list_from_addrinfo (l_res___0))
							freeaddrinfo (l_res___0)
							if (l_al).c_pointer = default_pointer then
								log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("failed: No IPv4/IPv6 addresses for host.%N")))])
								Result := (create {CE_POINTER [PD_ADDRESS_LIST]}.make_shared (default_pointer))
								js.return
							end
						end
						if not js.return_called then
							if l_al.item.count > 1 then
								if (options_inst.opt.prefer_family).to_natural_32 /= {NATURAL_32} 2 then
									if (options_inst.opt.prefer_family).to_natural_32 = {NATURAL_32} 0 then
										l_tmp___14.ce_gets (cmp_prefer_ipv4_address)
									else
										l_tmp___14.ce_gets (cmp_prefer_ipv6_address)
									end
									utils_inst.stable_sort (create {CE_POINTER [ANY]}.make_cast (l_al.item.addresses), (l_al.item.count).to_natural_32, {PD_IP_ADDRESS}.sizeof.to_natural_32, l_tmp___14)
								end
							end
							if not l_silent then
								if not l_numeric_address then
									if l_al.item.count <= 3 then
										l_tmp___15 := l_al.item.count
									else
										l_tmp___15 := 3
									end
									l_printmax := l_tmp___15
									l_i := 0
									from
									until
										not (l_i < l_printmax)
									loop
										log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (print_address ((l_al.item.addresses + l_i))))
										if l_i < l_printmax - 1 then
											log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string (", "))
										end
										l_i := l_i + 1
									end
									if l_printmax /= l_al.item.count then
										log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string (", ..."))
									end
									log_inst.logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
								end
							end
							if l_use_cache then
								cache_store (a_host, l_al)
							end
							Result := l_al
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	accept_domain (a_u: CE_POINTER [PD_URL]): BOOLEAN
		local
			js: JUMP_STATE
		do
			if ((a_u.item.host).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				assert_fail (ce_string ("u->host != ((void *)0)"), ce_string ("host.c"), {NATURAL_32} 850, ce_string ("accept_domain"))
			end
			if ((options_inst.opt.domains).c_pointer /= default_pointer) then
				if not (sufmatch (options_inst.opt.domains, a_u.item.host)) then
					Result := (0).to_boolean
					js.return
				end
			end
			if not js.return_called and then ((options_inst.opt.exclude_domains).c_pointer /= default_pointer) then
				if (sufmatch (options_inst.opt.exclude_domains, a_u.item.host)) then
					Result := (0).to_boolean
					js.return
				end
			end
			if not js.return_called then
				Result := (1).to_boolean
			end
		end

	sufmatch (a_list: CE_POINTER [CE_POINTER [INTEGER_8]]; a_what: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_lw: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			l_lw := (strlen (a_what)).to_integer_32
			l_i := 0
			from
			until
				not (not js.loop_left and then ((a_list[l_i]).c_pointer /= default_pointer))
			loop
				l_j := (strlen (a_list[l_i])).to_integer_32
				l_k := l_lw
				from
				until
					js.loop_left
				loop
					js.reset
					if l_j >= 0 then
						if not (l_k >= 0) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_tmp___1 := c_ctype_inst.c2_tolower (((a_list[l_i])[l_j]).to_integer_32)
						if l_tmp___1 /= (c_ctype_inst.c2_tolower ((a_what[l_k]).to_integer_32)) then
							js.break
						end
					end
					if not js.loop_jumped then
						l_j := l_j - 1
						l_k := l_k - 1
					end
				end
				js.reset
				if l_j = -1 then
					Result := (1).to_boolean
					js.return
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := (0).to_boolean
			end
		end

	host_cleanup
		local
			l_iter: PD_HASH_TABLE_ITERATOR
			l_host: CE_POINTER [INTEGER_8]
			l_al: CE_POINTER [PD_ADDRESS_LIST]
			js: JUMP_STATE
		do
			create l_iter.make
			create l_host.make
			create l_al.make

			if ((host_name_addresses_map).c_pointer /= default_pointer) then
				hash_inst.hash_table_iterate (host_name_addresses_map, l_iter.address)
				from
				until
					js.loop_left
				loop
					js.reset
					if not (hash_inst.hash_table_iter_next (l_iter.address)).to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_host.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (l_iter.key))
						l_al.ce_gets (create {CE_POINTER [PD_ADDRESS_LIST]}.make_cast (l_iter.value))
						free (create {CE_POINTER [ANY]}.make_cast (l_host))
						if l_al.item.refcount /= 1 then
							assert_fail (ce_string ("al->refcount == 1"), ce_string ("host.c"), {NATURAL_32} 900, ce_string ("host_cleanup"))
						end
						address_list_delete (l_al)
					end
				end
				js.reset
				hash_inst.hash_table_destroy (host_name_addresses_map)
				host_name_addresses_map.ce_gets (create {CE_POINTER [PD_HASH_TABLE]}.make_shared (default_pointer))
			end
		end

end
