class
	SD_IN6_ADDR

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	in6_u: SD_IN6_U assign set_in6_u
		do
			create Result.make_shared (c_in6_u (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_in6_u (a_in6_u: SD_IN6_U)
		do
			in6_u.ce_gets (a_in6_u)
		end

feature {NONE} -- C getters

	c_in6_u (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion___in6_u_44 *)&((struct in6_addr *)$tmp)->__in6_u;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct in6_addr);"
		end

end
