class
	SD_IN_ADDR

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	s_addr: NATURAL_32 assign set_s_addr
		do
			Result := c_s_addr (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_s_addr (a_s_addr: NATURAL_32)
		do
			c_set_s_addr (c_pointer, a_s_addr)
		end

feature {NONE} -- C getters

	c_s_addr (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct in_addr *)$tmp)->s_addr;"
		end

feature {NONE} -- C setters

	c_set_s_addr (tmp: POINTER; a_s_addr: NATURAL_32)
		external
			"C inline"
		alias
			"((struct in_addr *)$tmp)->s_addr = $a_s_addr;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct in_addr);"
		end

end
