class
	SD_ITIMERVAL

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	it_interval: SD_TIMEVAL assign set_it_interval
		do
			create Result.make_shared (c_it_interval (c_pointer))
		end

	it_value: SD_TIMEVAL assign set_it_value
		do
			create Result.make_shared (c_it_value (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_it_interval (a_it_interval: SD_TIMEVAL)
		do
			it_interval.ce_gets (a_it_interval)
		end

	set_it_value (a_it_value: SD_TIMEVAL)
		do
			it_value.ce_gets (a_it_value)
		end

feature {NONE} -- C getters

	c_it_interval (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct timeval *)&((struct itimerval *)$tmp)->it_interval;"
		end

	c_it_value (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct timeval *)&((struct itimerval *)$tmp)->it_value;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct itimerval);"
		end

end
