class
	SD_LCONV

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	decimal_point: CE_POINTER [INTEGER_8] assign set_decimal_point
		do
			create Result.make_shared (c_decimal_point (c_pointer))
		end

	thousands_sep: CE_POINTER [INTEGER_8] assign set_thousands_sep
		do
			create Result.make_shared (c_thousands_sep (c_pointer))
		end

	grouping: CE_POINTER [INTEGER_8] assign set_grouping
		do
			create Result.make_shared (c_grouping (c_pointer))
		end

	int_curr_symbol: CE_POINTER [INTEGER_8] assign set_int_curr_symbol
		do
			create Result.make_shared (c_int_curr_symbol (c_pointer))
		end

	currency_symbol: CE_POINTER [INTEGER_8] assign set_currency_symbol
		do
			create Result.make_shared (c_currency_symbol (c_pointer))
		end

	mon_decimal_point: CE_POINTER [INTEGER_8] assign set_mon_decimal_point
		do
			create Result.make_shared (c_mon_decimal_point (c_pointer))
		end

	mon_thousands_sep: CE_POINTER [INTEGER_8] assign set_mon_thousands_sep
		do
			create Result.make_shared (c_mon_thousands_sep (c_pointer))
		end

	mon_grouping: CE_POINTER [INTEGER_8] assign set_mon_grouping
		do
			create Result.make_shared (c_mon_grouping (c_pointer))
		end

	positive_sign: CE_POINTER [INTEGER_8] assign set_positive_sign
		do
			create Result.make_shared (c_positive_sign (c_pointer))
		end

	negative_sign: CE_POINTER [INTEGER_8] assign set_negative_sign
		do
			create Result.make_shared (c_negative_sign (c_pointer))
		end

	int_frac_digits: INTEGER_8 assign set_int_frac_digits
		do
			Result := c_int_frac_digits (c_pointer)
		end

	frac_digits: INTEGER_8 assign set_frac_digits
		do
			Result := c_frac_digits (c_pointer)
		end

	p_cs_precedes: INTEGER_8 assign set_p_cs_precedes
		do
			Result := c_p_cs_precedes (c_pointer)
		end

	p_sep_by_space: INTEGER_8 assign set_p_sep_by_space
		do
			Result := c_p_sep_by_space (c_pointer)
		end

	n_cs_precedes: INTEGER_8 assign set_n_cs_precedes
		do
			Result := c_n_cs_precedes (c_pointer)
		end

	n_sep_by_space: INTEGER_8 assign set_n_sep_by_space
		do
			Result := c_n_sep_by_space (c_pointer)
		end

	p_sign_posn: INTEGER_8 assign set_p_sign_posn
		do
			Result := c_p_sign_posn (c_pointer)
		end

	n_sign_posn: INTEGER_8 assign set_n_sign_posn
		do
			Result := c_n_sign_posn (c_pointer)
		end

	int_p_cs_precedes: INTEGER_8 assign set_int_p_cs_precedes
		do
			Result := c_int_p_cs_precedes (c_pointer)
		end

	int_p_sep_by_space: INTEGER_8 assign set_int_p_sep_by_space
		do
			Result := c_int_p_sep_by_space (c_pointer)
		end

	int_n_cs_precedes: INTEGER_8 assign set_int_n_cs_precedes
		do
			Result := c_int_n_cs_precedes (c_pointer)
		end

	int_n_sep_by_space: INTEGER_8 assign set_int_n_sep_by_space
		do
			Result := c_int_n_sep_by_space (c_pointer)
		end

	int_p_sign_posn: INTEGER_8 assign set_int_p_sign_posn
		do
			Result := c_int_p_sign_posn (c_pointer)
		end

	int_n_sign_posn: INTEGER_8 assign set_int_n_sign_posn
		do
			Result := c_int_n_sign_posn (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_decimal_point (a_decimal_point: CE_POINTER [INTEGER_8])
		do
			c_set_decimal_point (c_pointer, a_decimal_point.c_pointer)
		end

	set_thousands_sep (a_thousands_sep: CE_POINTER [INTEGER_8])
		do
			c_set_thousands_sep (c_pointer, a_thousands_sep.c_pointer)
		end

	set_grouping (a_grouping: CE_POINTER [INTEGER_8])
		do
			c_set_grouping (c_pointer, a_grouping.c_pointer)
		end

	set_int_curr_symbol (a_int_curr_symbol: CE_POINTER [INTEGER_8])
		do
			c_set_int_curr_symbol (c_pointer, a_int_curr_symbol.c_pointer)
		end

	set_currency_symbol (a_currency_symbol: CE_POINTER [INTEGER_8])
		do
			c_set_currency_symbol (c_pointer, a_currency_symbol.c_pointer)
		end

	set_mon_decimal_point (a_mon_decimal_point: CE_POINTER [INTEGER_8])
		do
			c_set_mon_decimal_point (c_pointer, a_mon_decimal_point.c_pointer)
		end

	set_mon_thousands_sep (a_mon_thousands_sep: CE_POINTER [INTEGER_8])
		do
			c_set_mon_thousands_sep (c_pointer, a_mon_thousands_sep.c_pointer)
		end

	set_mon_grouping (a_mon_grouping: CE_POINTER [INTEGER_8])
		do
			c_set_mon_grouping (c_pointer, a_mon_grouping.c_pointer)
		end

	set_positive_sign (a_positive_sign: CE_POINTER [INTEGER_8])
		do
			c_set_positive_sign (c_pointer, a_positive_sign.c_pointer)
		end

	set_negative_sign (a_negative_sign: CE_POINTER [INTEGER_8])
		do
			c_set_negative_sign (c_pointer, a_negative_sign.c_pointer)
		end

	set_int_frac_digits (a_int_frac_digits: INTEGER_8)
		do
			c_set_int_frac_digits (c_pointer, a_int_frac_digits)
		end

	set_frac_digits (a_frac_digits: INTEGER_8)
		do
			c_set_frac_digits (c_pointer, a_frac_digits)
		end

	set_p_cs_precedes (a_p_cs_precedes: INTEGER_8)
		do
			c_set_p_cs_precedes (c_pointer, a_p_cs_precedes)
		end

	set_p_sep_by_space (a_p_sep_by_space: INTEGER_8)
		do
			c_set_p_sep_by_space (c_pointer, a_p_sep_by_space)
		end

	set_n_cs_precedes (a_n_cs_precedes: INTEGER_8)
		do
			c_set_n_cs_precedes (c_pointer, a_n_cs_precedes)
		end

	set_n_sep_by_space (a_n_sep_by_space: INTEGER_8)
		do
			c_set_n_sep_by_space (c_pointer, a_n_sep_by_space)
		end

	set_p_sign_posn (a_p_sign_posn: INTEGER_8)
		do
			c_set_p_sign_posn (c_pointer, a_p_sign_posn)
		end

	set_n_sign_posn (a_n_sign_posn: INTEGER_8)
		do
			c_set_n_sign_posn (c_pointer, a_n_sign_posn)
		end

	set_int_p_cs_precedes (a_int_p_cs_precedes: INTEGER_8)
		do
			c_set_int_p_cs_precedes (c_pointer, a_int_p_cs_precedes)
		end

	set_int_p_sep_by_space (a_int_p_sep_by_space: INTEGER_8)
		do
			c_set_int_p_sep_by_space (c_pointer, a_int_p_sep_by_space)
		end

	set_int_n_cs_precedes (a_int_n_cs_precedes: INTEGER_8)
		do
			c_set_int_n_cs_precedes (c_pointer, a_int_n_cs_precedes)
		end

	set_int_n_sep_by_space (a_int_n_sep_by_space: INTEGER_8)
		do
			c_set_int_n_sep_by_space (c_pointer, a_int_n_sep_by_space)
		end

	set_int_p_sign_posn (a_int_p_sign_posn: INTEGER_8)
		do
			c_set_int_p_sign_posn (c_pointer, a_int_p_sign_posn)
		end

	set_int_n_sign_posn (a_int_n_sign_posn: INTEGER_8)
		do
			c_set_int_n_sign_posn (c_pointer, a_int_n_sign_posn)
		end

feature {NONE} -- C getters

	c_decimal_point (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct lconv *)$tmp)->decimal_point;"
		end

	c_thousands_sep (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct lconv *)$tmp)->thousands_sep;"
		end

	c_grouping (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct lconv *)$tmp)->grouping;"
		end

	c_int_curr_symbol (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct lconv *)$tmp)->int_curr_symbol;"
		end

	c_currency_symbol (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct lconv *)$tmp)->currency_symbol;"
		end

	c_mon_decimal_point (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct lconv *)$tmp)->mon_decimal_point;"
		end

	c_mon_thousands_sep (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct lconv *)$tmp)->mon_thousands_sep;"
		end

	c_mon_grouping (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct lconv *)$tmp)->mon_grouping;"
		end

	c_positive_sign (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct lconv *)$tmp)->positive_sign;"
		end

	c_negative_sign (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct lconv *)$tmp)->negative_sign;"
		end

	c_int_frac_digits (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct lconv *)$tmp)->int_frac_digits;"
		end

	c_frac_digits (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct lconv *)$tmp)->frac_digits;"
		end

	c_p_cs_precedes (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct lconv *)$tmp)->p_cs_precedes;"
		end

	c_p_sep_by_space (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct lconv *)$tmp)->p_sep_by_space;"
		end

	c_n_cs_precedes (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct lconv *)$tmp)->n_cs_precedes;"
		end

	c_n_sep_by_space (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct lconv *)$tmp)->n_sep_by_space;"
		end

	c_p_sign_posn (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct lconv *)$tmp)->p_sign_posn;"
		end

	c_n_sign_posn (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct lconv *)$tmp)->n_sign_posn;"
		end

	c_int_p_cs_precedes (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct lconv *)$tmp)->int_p_cs_precedes;"
		end

	c_int_p_sep_by_space (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct lconv *)$tmp)->int_p_sep_by_space;"
		end

	c_int_n_cs_precedes (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct lconv *)$tmp)->int_n_cs_precedes;"
		end

	c_int_n_sep_by_space (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct lconv *)$tmp)->int_n_sep_by_space;"
		end

	c_int_p_sign_posn (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct lconv *)$tmp)->int_p_sign_posn;"
		end

	c_int_n_sign_posn (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct lconv *)$tmp)->int_n_sign_posn;"
		end

feature {NONE} -- C setters

	c_set_decimal_point (tmp: POINTER; a_decimal_point: POINTER)
		external
			"C inline"
		alias
			"((struct lconv *)$tmp)->decimal_point = (char *)$a_decimal_point;"
		end

	c_set_thousands_sep (tmp: POINTER; a_thousands_sep: POINTER)
		external
			"C inline"
		alias
			"((struct lconv *)$tmp)->thousands_sep = (char *)$a_thousands_sep;"
		end

	c_set_grouping (tmp: POINTER; a_grouping: POINTER)
		external
			"C inline"
		alias
			"((struct lconv *)$tmp)->grouping = (char *)$a_grouping;"
		end

	c_set_int_curr_symbol (tmp: POINTER; a_int_curr_symbol: POINTER)
		external
			"C inline"
		alias
			"((struct lconv *)$tmp)->int_curr_symbol = (char *)$a_int_curr_symbol;"
		end

	c_set_currency_symbol (tmp: POINTER; a_currency_symbol: POINTER)
		external
			"C inline"
		alias
			"((struct lconv *)$tmp)->currency_symbol = (char *)$a_currency_symbol;"
		end

	c_set_mon_decimal_point (tmp: POINTER; a_mon_decimal_point: POINTER)
		external
			"C inline"
		alias
			"((struct lconv *)$tmp)->mon_decimal_point = (char *)$a_mon_decimal_point;"
		end

	c_set_mon_thousands_sep (tmp: POINTER; a_mon_thousands_sep: POINTER)
		external
			"C inline"
		alias
			"((struct lconv *)$tmp)->mon_thousands_sep = (char *)$a_mon_thousands_sep;"
		end

	c_set_mon_grouping (tmp: POINTER; a_mon_grouping: POINTER)
		external
			"C inline"
		alias
			"((struct lconv *)$tmp)->mon_grouping = (char *)$a_mon_grouping;"
		end

	c_set_positive_sign (tmp: POINTER; a_positive_sign: POINTER)
		external
			"C inline"
		alias
			"((struct lconv *)$tmp)->positive_sign = (char *)$a_positive_sign;"
		end

	c_set_negative_sign (tmp: POINTER; a_negative_sign: POINTER)
		external
			"C inline"
		alias
			"((struct lconv *)$tmp)->negative_sign = (char *)$a_negative_sign;"
		end

	c_set_int_frac_digits (tmp: POINTER; a_int_frac_digits: INTEGER_8)
		external
			"C inline"
		alias
			"((struct lconv *)$tmp)->int_frac_digits = $a_int_frac_digits;"
		end

	c_set_frac_digits (tmp: POINTER; a_frac_digits: INTEGER_8)
		external
			"C inline"
		alias
			"((struct lconv *)$tmp)->frac_digits = $a_frac_digits;"
		end

	c_set_p_cs_precedes (tmp: POINTER; a_p_cs_precedes: INTEGER_8)
		external
			"C inline"
		alias
			"((struct lconv *)$tmp)->p_cs_precedes = $a_p_cs_precedes;"
		end

	c_set_p_sep_by_space (tmp: POINTER; a_p_sep_by_space: INTEGER_8)
		external
			"C inline"
		alias
			"((struct lconv *)$tmp)->p_sep_by_space = $a_p_sep_by_space;"
		end

	c_set_n_cs_precedes (tmp: POINTER; a_n_cs_precedes: INTEGER_8)
		external
			"C inline"
		alias
			"((struct lconv *)$tmp)->n_cs_precedes = $a_n_cs_precedes;"
		end

	c_set_n_sep_by_space (tmp: POINTER; a_n_sep_by_space: INTEGER_8)
		external
			"C inline"
		alias
			"((struct lconv *)$tmp)->n_sep_by_space = $a_n_sep_by_space;"
		end

	c_set_p_sign_posn (tmp: POINTER; a_p_sign_posn: INTEGER_8)
		external
			"C inline"
		alias
			"((struct lconv *)$tmp)->p_sign_posn = $a_p_sign_posn;"
		end

	c_set_n_sign_posn (tmp: POINTER; a_n_sign_posn: INTEGER_8)
		external
			"C inline"
		alias
			"((struct lconv *)$tmp)->n_sign_posn = $a_n_sign_posn;"
		end

	c_set_int_p_cs_precedes (tmp: POINTER; a_int_p_cs_precedes: INTEGER_8)
		external
			"C inline"
		alias
			"((struct lconv *)$tmp)->int_p_cs_precedes = $a_int_p_cs_precedes;"
		end

	c_set_int_p_sep_by_space (tmp: POINTER; a_int_p_sep_by_space: INTEGER_8)
		external
			"C inline"
		alias
			"((struct lconv *)$tmp)->int_p_sep_by_space = $a_int_p_sep_by_space;"
		end

	c_set_int_n_cs_precedes (tmp: POINTER; a_int_n_cs_precedes: INTEGER_8)
		external
			"C inline"
		alias
			"((struct lconv *)$tmp)->int_n_cs_precedes = $a_int_n_cs_precedes;"
		end

	c_set_int_n_sep_by_space (tmp: POINTER; a_int_n_sep_by_space: INTEGER_8)
		external
			"C inline"
		alias
			"((struct lconv *)$tmp)->int_n_sep_by_space = $a_int_n_sep_by_space;"
		end

	c_set_int_p_sign_posn (tmp: POINTER; a_int_p_sign_posn: INTEGER_8)
		external
			"C inline"
		alias
			"((struct lconv *)$tmp)->int_p_sign_posn = $a_int_p_sign_posn;"
		end

	c_set_int_n_sign_posn (tmp: POINTER; a_int_n_sign_posn: INTEGER_8)
		external
			"C inline"
		alias
			"((struct lconv *)$tmp)->int_n_sign_posn = $a_int_n_sign_posn;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct lconv);"
		end

end
