class
	SD_MBSTATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	count: INTEGER_32 assign set_count
		do
			Result := c_count (c_pointer)
		end

	value: SD_VALUE assign set_value
		do
			create Result.make_shared (c_value (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_count (a_count: INTEGER_32)
		do
			c_set_count (c_pointer, a_count)
		end

	set_value (a_value: SD_VALUE)
		do
			value.ce_gets (a_value)
		end

feature {NONE} -- C getters

	c_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct___mbstate_t_24 *)$tmp)->__count;"
		end

	c_value (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion___value_25 *)&((struct __anonstruct___mbstate_t_24 *)$tmp)->__value;"
		end

feature {NONE} -- C setters

	c_set_count (tmp: POINTER; a_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct___mbstate_t_24 *)$tmp)->__count = $a_count;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct __anonstruct___mbstate_t_24);"
		end

end
