deferred class
	S_ARPA_INET

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	inet_ntop (a_af: INTEGER_32; a_cp: CE_POINTER [ANY]; a_buf: CE_POINTER [INTEGER_8]; a_len: NATURAL_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_inet_ntop (a_af, a_cp.c_pointer, a_buf.c_pointer, a_len))
		end

	c_inet_ntop (a_af: INTEGER_32; a_cp: POINTER; a_buf: POINTER; a_len: NATURAL_32): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return inet_ntop($a_af, $a_cp, $a_buf, $a_len);"
		end

end
