deferred class
	S_GETOPT

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- attributes

	optarg: CE_POINTER [INTEGER_8] assign set_optarg
		do
			create Result.make_shared (c_optarg)
		end

			c_optarg: POINTER
		external
			"C inline use <wget.h>"
		alias
			"return optarg;"
		end

	set_optarg (a_optarg: CE_POINTER [INTEGER_8])
		do
			c_set_optarg (a_optarg.c_pointer)
		end

	c_set_optarg (a_optarg: POINTER)
		external
			"C inline"
		alias
			"optarg = (char *)$a_optarg;"
		end

	optind: INTEGER_32 assign set_optind
		external
			"C inline use <wget.h>"
		alias
			"return optind;"
		end

	set_optind (a_optind: INTEGER_32)
		external
			"C inline"
		alias
			"optind = $a_optind;"
		end

feature {ANY} -- routines

	getopt_long (a_argc: INTEGER_32; a_argv: CE_POINTER [CE_POINTER [INTEGER_8]]; a_shortopts: CE_POINTER [INTEGER_8]; a_longopts: CE_POINTER [SD_OPTION]; a_longind: CE_POINTER [INTEGER_32]): INTEGER_32
		do
			Result := c_getopt_long (a_argc, a_argv.c_pointer, a_shortopts.c_pointer, a_longopts.c_pointer, a_longind.c_pointer)
		end

	c_getopt_long (a_argc: INTEGER_32; a_argv: POINTER; a_shortopts: POINTER; a_longopts: POINTER; a_longind: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return getopt_long($a_argc, $a_argv, $a_shortopts, $a_longopts, $a_longind);"
		end

end
