deferred class
	S_LIBINTL

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	gettext (a_msgid: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_gettext (a_msgid.c_pointer))
		end

	c_gettext (a_msgid: POINTER): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return gettext($a_msgid);"
		end

	textdomain (a_domainname: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_textdomain (a_domainname.c_pointer))
		end

	c_textdomain (a_domainname: POINTER): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return textdomain($a_domainname);"
		end

	bindtextdomain (a_domainname: CE_POINTER [INTEGER_8]; a_dirname: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_bindtextdomain (a_domainname.c_pointer, a_dirname.c_pointer))
		end

	c_bindtextdomain (a_domainname: POINTER; a_dirname: POINTER): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return bindtextdomain($a_domainname, $a_dirname);"
		end

	ngettext (a_msgid1: CE_POINTER [INTEGER_8]; a_msgid2: CE_POINTER [INTEGER_8]; a_n: NATURAL_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_ngettext (a_msgid1.c_pointer, a_msgid2.c_pointer, a_n))
		end

	c_ngettext (a_msgid1: POINTER; a_msgid2: POINTER; a_n: NATURAL_32): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return ngettext($a_msgid1, $a_msgid2, $a_n);"
		end

end
