deferred class
	S_SYS_MMAN

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	mmap (a_addr: CE_POINTER [ANY]; a_len: NATURAL_32; a_prot: INTEGER_32; a_flags: INTEGER_32; a_fd: INTEGER_32; a_offset: INTEGER_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_mmap (a_addr.c_pointer, a_len, a_prot, a_flags, a_fd, a_offset))
		end

	c_mmap (a_addr: POINTER; a_len: NATURAL_32; a_prot: INTEGER_32; a_flags: INTEGER_32; a_fd: INTEGER_32; a_offset: INTEGER_32): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return mmap($a_addr, $a_len, $a_prot, $a_flags, $a_fd, $a_offset);"
		end

	munmap (a_addr: CE_POINTER [ANY]; a_len: NATURAL_32): INTEGER_32
		do
			Result := c_munmap (a_addr.c_pointer, a_len)
		end

	c_munmap (a_addr: POINTER; a_len: NATURAL_32): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return munmap($a_addr, $a_len);"
		end

end
