class
	PD_FORM_CONTROL

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_FORM_CONTROL] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_FORM_CONTROL] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	form_num: INTEGER_32 assign set_form_num
		do
			Result := c_form_num (c_pointer)
		end

	ctrl_num: INTEGER_32 assign set_ctrl_num
		do
			Result := c_ctrl_num (c_pointer)
		end

	g_ctrl_num: INTEGER_32 assign set_g_ctrl_num
		do
			Result := c_g_ctrl_num (c_pointer)
		end

	position: INTEGER_32 assign set_position
		do
			Result := c_position (c_pointer)
		end

	method: INTEGER_32 assign set_method
		do
			Result := c_method (c_pointer)
		end

	action: CE_POINTER [NATURAL_8] assign set_action
		do
			create Result.make_shared (c_action (c_pointer))
		end

	target: CE_POINTER [NATURAL_8] assign set_target
		do
			create Result.make_shared (c_target (c_pointer))
		end

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	name: CE_POINTER [NATURAL_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	alt: CE_POINTER [NATURAL_8] assign set_alt
		do
			create Result.make_shared (c_alt (c_pointer))
		end

	ro: INTEGER_32 assign set_ro
		do
			Result := c_ro (c_pointer)
		end

	default_value: CE_POINTER [NATURAL_8] assign set_default_value
		do
			create Result.make_shared (c_default_value (c_pointer))
		end

	default_state: INTEGER_32 assign set_default_state
		do
			Result := c_default_state (c_pointer)
		end

	size: INTEGER_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	cols: INTEGER_32 assign set_cols
		do
			Result := c_cols (c_pointer)
		end

	rows: INTEGER_32 assign set_rows
		do
			Result := c_rows (c_pointer)
		end

	wrap: INTEGER_32 assign set_wrap
		do
			Result := c_wrap (c_pointer)
		end

	maxlength: INTEGER_32 assign set_maxlength
		do
			Result := c_maxlength (c_pointer)
		end

	nvalues: INTEGER_32 assign set_nvalues
		do
			Result := c_nvalues (c_pointer)
		end

	values: CE_POINTER [CE_POINTER [NATURAL_8]] assign set_values
		do
			create Result.make_shared (c_values (c_pointer))
		end

	labels: CE_POINTER [CE_POINTER [NATURAL_8]] assign set_labels
		do
			create Result.make_shared (c_labels (c_pointer))
		end

	menu: CE_POINTER [PD_MENU_ITEM] assign set_menu
		do
			create Result.make_shared (c_menu (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_FORM_CONTROL])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_FORM_CONTROL])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_form_num (a_form_num: INTEGER_32)
		do
			c_set_form_num (c_pointer, a_form_num)
		end

	set_ctrl_num (a_ctrl_num: INTEGER_32)
		do
			c_set_ctrl_num (c_pointer, a_ctrl_num)
		end

	set_g_ctrl_num (a_g_ctrl_num: INTEGER_32)
		do
			c_set_g_ctrl_num (c_pointer, a_g_ctrl_num)
		end

	set_position (a_position: INTEGER_32)
		do
			c_set_position (c_pointer, a_position)
		end

	set_method (a_method: INTEGER_32)
		do
			c_set_method (c_pointer, a_method)
		end

	set_action (a_action: CE_POINTER [NATURAL_8])
		do
			c_set_action (c_pointer, a_action.c_pointer)
		end

	set_target (a_target: CE_POINTER [NATURAL_8])
		do
			c_set_target (c_pointer, a_target.c_pointer)
		end

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_alt (a_alt: CE_POINTER [NATURAL_8])
		do
			c_set_alt (c_pointer, a_alt.c_pointer)
		end

	set_ro (a_ro: INTEGER_32)
		do
			c_set_ro (c_pointer, a_ro)
		end

	set_default_value (a_default_value: CE_POINTER [NATURAL_8])
		do
			c_set_default_value (c_pointer, a_default_value.c_pointer)
		end

	set_default_state (a_default_state: INTEGER_32)
		do
			c_set_default_state (c_pointer, a_default_state)
		end

	set_size (a_size: INTEGER_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_cols (a_cols: INTEGER_32)
		do
			c_set_cols (c_pointer, a_cols)
		end

	set_rows (a_rows: INTEGER_32)
		do
			c_set_rows (c_pointer, a_rows)
		end

	set_wrap (a_wrap: INTEGER_32)
		do
			c_set_wrap (c_pointer, a_wrap)
		end

	set_maxlength (a_maxlength: INTEGER_32)
		do
			c_set_maxlength (c_pointer, a_maxlength)
		end

	set_nvalues (a_nvalues: INTEGER_32)
		do
			c_set_nvalues (c_pointer, a_nvalues)
		end

	set_values (a_values: CE_POINTER [CE_POINTER [NATURAL_8]])
		do
			c_set_values (c_pointer, a_values.c_pointer)
		end

	set_labels (a_labels: CE_POINTER [CE_POINTER [NATURAL_8]])
		do
			c_set_labels (c_pointer, a_labels.c_pointer)
		end

	set_menu (a_menu: CE_POINTER [PD_MENU_ITEM])
		do
			c_set_menu (c_pointer, a_menu.c_pointer)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct form_control *)((struct form_control *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct form_control *)((struct form_control *)$tmp)->prev;"
		end

	c_form_num (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct form_control *)$tmp)->form_num;"
		end

	c_ctrl_num (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct form_control *)$tmp)->ctrl_num;"
		end

	c_g_ctrl_num (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct form_control *)$tmp)->g_ctrl_num;"
		end

	c_position (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct form_control *)$tmp)->position;"
		end

	c_method (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct form_control *)$tmp)->method;"
		end

	c_action (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct form_control *)$tmp)->action;"
		end

	c_target (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct form_control *)$tmp)->target;"
		end

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct form_control *)$tmp)->type;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct form_control *)$tmp)->name;"
		end

	c_alt (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct form_control *)$tmp)->alt;"
		end

	c_ro (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct form_control *)$tmp)->ro;"
		end

	c_default_value (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct form_control *)$tmp)->default_value;"
		end

	c_default_state (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct form_control *)$tmp)->default_state;"
		end

	c_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct form_control *)$tmp)->size;"
		end

	c_cols (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct form_control *)$tmp)->cols;"
		end

	c_rows (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct form_control *)$tmp)->rows;"
		end

	c_wrap (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct form_control *)$tmp)->wrap;"
		end

	c_maxlength (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct form_control *)$tmp)->maxlength;"
		end

	c_nvalues (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct form_control *)$tmp)->nvalues;"
		end

	c_values (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char * *)((struct form_control *)$tmp)->values;"
		end

	c_labels (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char * *)((struct form_control *)$tmp)->labels;"
		end

	c_menu (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct menu_item *)((struct form_control *)$tmp)->menu;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct form_control *)$tmp)->next = (struct form_control *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct form_control *)$tmp)->prev = (struct form_control *)$a_prev;"
		end

	c_set_form_num (tmp: POINTER; a_form_num: INTEGER_32)
		external
			"C inline"
		alias
			"((struct form_control *)$tmp)->form_num = $a_form_num;"
		end

	c_set_ctrl_num (tmp: POINTER; a_ctrl_num: INTEGER_32)
		external
			"C inline"
		alias
			"((struct form_control *)$tmp)->ctrl_num = $a_ctrl_num;"
		end

	c_set_g_ctrl_num (tmp: POINTER; a_g_ctrl_num: INTEGER_32)
		external
			"C inline"
		alias
			"((struct form_control *)$tmp)->g_ctrl_num = $a_g_ctrl_num;"
		end

	c_set_position (tmp: POINTER; a_position: INTEGER_32)
		external
			"C inline"
		alias
			"((struct form_control *)$tmp)->position = $a_position;"
		end

	c_set_method (tmp: POINTER; a_method: INTEGER_32)
		external
			"C inline"
		alias
			"((struct form_control *)$tmp)->method = $a_method;"
		end

	c_set_action (tmp: POINTER; a_action: POINTER)
		external
			"C inline"
		alias
			"((struct form_control *)$tmp)->action = (unsigned char *)$a_action;"
		end

	c_set_target (tmp: POINTER; a_target: POINTER)
		external
			"C inline"
		alias
			"((struct form_control *)$tmp)->target = (unsigned char *)$a_target;"
		end

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct form_control *)$tmp)->type = $a_type;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct form_control *)$tmp)->name = (unsigned char *)$a_name;"
		end

	c_set_alt (tmp: POINTER; a_alt: POINTER)
		external
			"C inline"
		alias
			"((struct form_control *)$tmp)->alt = (unsigned char *)$a_alt;"
		end

	c_set_ro (tmp: POINTER; a_ro: INTEGER_32)
		external
			"C inline"
		alias
			"((struct form_control *)$tmp)->ro = $a_ro;"
		end

	c_set_default_value (tmp: POINTER; a_default_value: POINTER)
		external
			"C inline"
		alias
			"((struct form_control *)$tmp)->default_value = (unsigned char *)$a_default_value;"
		end

	c_set_default_state (tmp: POINTER; a_default_state: INTEGER_32)
		external
			"C inline"
		alias
			"((struct form_control *)$tmp)->default_state = $a_default_state;"
		end

	c_set_size (tmp: POINTER; a_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct form_control *)$tmp)->size = $a_size;"
		end

	c_set_cols (tmp: POINTER; a_cols: INTEGER_32)
		external
			"C inline"
		alias
			"((struct form_control *)$tmp)->cols = $a_cols;"
		end

	c_set_rows (tmp: POINTER; a_rows: INTEGER_32)
		external
			"C inline"
		alias
			"((struct form_control *)$tmp)->rows = $a_rows;"
		end

	c_set_wrap (tmp: POINTER; a_wrap: INTEGER_32)
		external
			"C inline"
		alias
			"((struct form_control *)$tmp)->wrap = $a_wrap;"
		end

	c_set_maxlength (tmp: POINTER; a_maxlength: INTEGER_32)
		external
			"C inline"
		alias
			"((struct form_control *)$tmp)->maxlength = $a_maxlength;"
		end

	c_set_nvalues (tmp: POINTER; a_nvalues: INTEGER_32)
		external
			"C inline"
		alias
			"((struct form_control *)$tmp)->nvalues = $a_nvalues;"
		end

	c_set_values (tmp: POINTER; a_values: POINTER)
		external
			"C inline"
		alias
			"((struct form_control *)$tmp)->values = (unsigned char * *)$a_values;"
		end

	c_set_labels (tmp: POINTER; a_labels: POINTER)
		external
			"C inline"
		alias
			"((struct form_control *)$tmp)->labels = (unsigned char * *)$a_labels;"
		end

	c_set_menu (tmp: POINTER; a_menu: POINTER)
		external
			"C inline"
		alias
			"((struct form_control *)$tmp)->menu = (struct menu_item *)$a_menu;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct form_control);"
		end

end
