class
	PD_FRAMESET_PARAM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	parent: CE_POINTER [PD_FRAMESET_DESC] assign set_parent
		do
			create Result.make_shared (c_parent (c_pointer))
		end

	x: INTEGER_32 assign set_x
		do
			Result := c_x (c_pointer)
		end

	x_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct frameset_param, x);"
		end

	y: INTEGER_32 assign set_y
		do
			Result := c_y (c_pointer)
		end

	y_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct frameset_param, y);"
		end

	xw: CE_POINTER [INTEGER_32] assign set_xw
		do
			create Result.make_shared (c_xw (c_pointer))
		end

	xw_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct frameset_param, xw);"
		end

	yw: CE_POINTER [INTEGER_32] assign set_yw
		do
			create Result.make_shared (c_yw (c_pointer))
		end

	yw_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct frameset_param, yw);"
		end

feature {ANY} -- Eiffel setters

	set_parent (a_parent: CE_POINTER [PD_FRAMESET_DESC])
		do
			c_set_parent (c_pointer, a_parent.c_pointer)
		end

	set_x (a_x: INTEGER_32)
		do
			c_set_x (c_pointer, a_x)
		end

	set_y (a_y: INTEGER_32)
		do
			c_set_y (c_pointer, a_y)
		end

	set_xw (a_xw: CE_POINTER [INTEGER_32])
		do
			c_set_xw (c_pointer, a_xw.c_pointer)
		end

	set_yw (a_yw: CE_POINTER [INTEGER_32])
		do
			c_set_yw (c_pointer, a_yw.c_pointer)
		end

feature {NONE} -- C getters

	c_parent (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct frameset_desc *)((struct frameset_param *)$tmp)->parent;"
		end

	c_x (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct frameset_param *)$tmp)->x;"
		end

	c_y (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct frameset_param *)$tmp)->y;"
		end

	c_xw (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int *)((struct frameset_param *)$tmp)->xw;"
		end

	c_yw (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int *)((struct frameset_param *)$tmp)->yw;"
		end

feature {NONE} -- C setters

	c_set_parent (tmp: POINTER; a_parent: POINTER)
		external
			"C inline"
		alias
			"((struct frameset_param *)$tmp)->parent = (struct frameset_desc *)$a_parent;"
		end

	c_set_x (tmp: POINTER; a_x: INTEGER_32)
		external
			"C inline"
		alias
			"((struct frameset_param *)$tmp)->x = $a_x;"
		end

	c_set_y (tmp: POINTER; a_y: INTEGER_32)
		external
			"C inline"
		alias
			"((struct frameset_param *)$tmp)->y = $a_y;"
		end

	c_set_xw (tmp: POINTER; a_xw: POINTER)
		external
			"C inline"
		alias
			"((struct frameset_param *)$tmp)->xw = (int *)$a_xw;"
		end

	c_set_yw (tmp: POINTER; a_yw: POINTER)
		external
			"C inline"
		alias
			"((struct frameset_param *)$tmp)->yw = (int *)$a_yw;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct frameset_param);"
		end

end
