class
	PD_H_CONN

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_H_CONN] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_H_CONN] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	host: CE_POINTER [NATURAL_8] assign set_host
		do
			create Result.make_shared (c_host (c_pointer))
		end

	conn: INTEGER_32 assign set_conn
		do
			Result := c_conn (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_H_CONN])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_H_CONN])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_host (a_host: CE_POINTER [NATURAL_8])
		do
			c_set_host (c_pointer, a_host.c_pointer)
		end

	set_conn (a_conn: INTEGER_32)
		do
			c_set_conn (c_pointer, a_conn)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct h_conn *)((struct h_conn *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct h_conn *)((struct h_conn *)$tmp)->prev;"
		end

	c_host (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct h_conn *)$tmp)->host;"
		end

	c_conn (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct h_conn *)$tmp)->conn;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct h_conn *)$tmp)->next = (struct h_conn *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct h_conn *)$tmp)->prev = (struct h_conn *)$a_prev;"
		end

	c_set_host (tmp: POINTER; a_host: POINTER)
		external
			"C inline"
		alias
			"((struct h_conn *)$tmp)->host = (unsigned char *)$a_host;"
		end

	c_set_conn (tmp: POINTER; a_conn: INTEGER_32)
		external
			"C inline"
		alias
			"((struct h_conn *)$tmp)->conn = $a_conn;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct h_conn);"
		end

end
