class
	PD_HISTORY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	n: INTEGER_32 assign set_n
		do
			Result := c_n (c_pointer)
		end

	items: PD_LIST_HEAD assign set_items
		do
			create Result.make_shared (c_items (c_pointer))
		end

	items_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct history, items);"
		end

feature {ANY} -- Eiffel setters

	set_n (a_n: INTEGER_32)
		do
			c_set_n (c_pointer, a_n)
		end

	set_items (a_items: PD_LIST_HEAD)
		do
			items.ce_gets (a_items)
		end

feature {NONE} -- C getters

	c_n (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct history *)$tmp)->n;"
		end

	c_items (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct list_head *)&((struct history *)$tmp)->items;"
		end

feature {NONE} -- C setters

	c_set_n (tmp: POINTER; a_n: INTEGER_32)
		external
			"C inline"
		alias
			"((struct history *)$tmp)->n = $a_n;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct history);"
		end

end
