class
	PD_HTTP_CONNECTION_INFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	bl_flags: INTEGER_32 assign set_bl_flags
		do
			Result := c_bl_flags (c_pointer)
		end

	http10: INTEGER_32 assign set_http10
		do
			Result := c_http10 (c_pointer)
		end

	close: INTEGER_32 assign set_close
		do
			Result := c_close (c_pointer)
		end

	length: INTEGER_32 assign set_length
		do
			Result := c_length (c_pointer)
		end

	version: INTEGER_32 assign set_version
		do
			Result := c_version (c_pointer)
		end

	chunk_remaining: INTEGER_32 assign set_chunk_remaining
		do
			Result := c_chunk_remaining (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_bl_flags (a_bl_flags: INTEGER_32)
		do
			c_set_bl_flags (c_pointer, a_bl_flags)
		end

	set_http10 (a_http10: INTEGER_32)
		do
			c_set_http10 (c_pointer, a_http10)
		end

	set_close (a_close: INTEGER_32)
		do
			c_set_close (c_pointer, a_close)
		end

	set_length (a_length: INTEGER_32)
		do
			c_set_length (c_pointer, a_length)
		end

	set_version (a_version: INTEGER_32)
		do
			c_set_version (c_pointer, a_version)
		end

	set_chunk_remaining (a_chunk_remaining: INTEGER_32)
		do
			c_set_chunk_remaining (c_pointer, a_chunk_remaining)
		end

feature {NONE} -- C getters

	c_bl_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct http_connection_info *)$tmp)->bl_flags;"
		end

	c_http10 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct http_connection_info *)$tmp)->http10;"
		end

	c_close (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct http_connection_info *)$tmp)->close;"
		end

	c_length (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct http_connection_info *)$tmp)->length;"
		end

	c_version (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct http_connection_info *)$tmp)->version;"
		end

	c_chunk_remaining (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct http_connection_info *)$tmp)->chunk_remaining;"
		end

feature {NONE} -- C setters

	c_set_bl_flags (tmp: POINTER; a_bl_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct http_connection_info *)$tmp)->bl_flags = $a_bl_flags;"
		end

	c_set_http10 (tmp: POINTER; a_http10: INTEGER_32)
		external
			"C inline"
		alias
			"((struct http_connection_info *)$tmp)->http10 = $a_http10;"
		end

	c_set_close (tmp: POINTER; a_close: INTEGER_32)
		external
			"C inline"
		alias
			"((struct http_connection_info *)$tmp)->close = $a_close;"
		end

	c_set_length (tmp: POINTER; a_length: INTEGER_32)
		external
			"C inline"
		alias
			"((struct http_connection_info *)$tmp)->length = $a_length;"
		end

	c_set_version (tmp: POINTER; a_version: INTEGER_32)
		external
			"C inline"
		alias
			"((struct http_connection_info *)$tmp)->version = $a_version;"
		end

	c_set_chunk_remaining (tmp: POINTER; a_chunk_remaining: INTEGER_32)
		external
			"C inline"
		alias
			"((struct http_connection_info *)$tmp)->chunk_remaining = $a_chunk_remaining;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct http_connection_info);"
		end

end
