class
	PD_KBDPREFIX

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	rep: INTEGER_32 assign set_rep
		do
			Result := c_rep (c_pointer)
		end

	rep_num: INTEGER_32 assign set_rep_num
		do
			Result := c_rep_num (c_pointer)
		end

	prefix2: INTEGER_32 assign set_prefix2
		do
			Result := c_prefix2 (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_rep (a_rep: INTEGER_32)
		do
			c_set_rep (c_pointer, a_rep)
		end

	set_rep_num (a_rep_num: INTEGER_32)
		do
			c_set_rep_num (c_pointer, a_rep_num)
		end

	set_prefix2 (a_prefix2: INTEGER_32)
		do
			c_set_prefix2 (c_pointer, a_prefix2)
		end

feature {NONE} -- C getters

	c_rep (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct kbdprefix *)$tmp)->rep;"
		end

	c_rep_num (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct kbdprefix *)$tmp)->rep_num;"
		end

	c_prefix2 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct kbdprefix *)$tmp)->prefix;"
		end

feature {NONE} -- C setters

	c_set_rep (tmp: POINTER; a_rep: INTEGER_32)
		external
			"C inline"
		alias
			"((struct kbdprefix *)$tmp)->rep = $a_rep;"
		end

	c_set_rep_num (tmp: POINTER; a_rep_num: INTEGER_32)
		external
			"C inline"
		alias
			"((struct kbdprefix *)$tmp)->rep_num = $a_rep_num;"
		end

	c_set_prefix2 (tmp: POINTER; a_prefix2: INTEGER_32)
		external
			"C inline"
		alias
			"((struct kbdprefix *)$tmp)->prefix = $a_prefix2;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct kbdprefix);"
		end

end
