class
	PD_PUSH_DEL_BUTTON_HOP_STRUCT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	dlg: CE_POINTER [PD_DIALOG] assign set_dlg
		do
			create Result.make_shared (c_dlg (c_pointer))
		end

	box: CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX] assign set_box
		do
			create Result.make_shared (c_box (c_pointer))
		end

	id: INTEGER_32 assign set_id
		do
			Result := c_id (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_dlg (a_dlg: CE_POINTER [PD_DIALOG])
		do
			c_set_dlg (c_pointer, a_dlg.c_pointer)
		end

	set_box (a_box: CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX])
		do
			c_set_box (c_pointer, a_box.c_pointer)
		end

	set_id (a_id: INTEGER_32)
		do
			c_set_id (c_pointer, a_id)
		end

feature {NONE} -- C getters

	c_dlg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dialog *)((struct push_del_button_hop_struct *)$tmp)->dlg;"
		end

	c_box (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dlg_data_item_data_box *)((struct push_del_button_hop_struct *)$tmp)->box;"
		end

	c_id (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct push_del_button_hop_struct *)$tmp)->id;"
		end

feature {NONE} -- C setters

	c_set_dlg (tmp: POINTER; a_dlg: POINTER)
		external
			"C inline"
		alias
			"((struct push_del_button_hop_struct *)$tmp)->dlg = (struct dialog *)$a_dlg;"
		end

	c_set_box (tmp: POINTER; a_box: POINTER)
		external
			"C inline"
		alias
			"((struct push_del_button_hop_struct *)$tmp)->box = (struct dlg_data_item_data_box *)$a_box;"
		end

	c_set_id (tmp: POINTER; a_id: INTEGER_32)
		external
			"C inline"
		alias
			"((struct push_del_button_hop_struct *)$tmp)->id = $a_id;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct push_del_button_hop_struct);"
		end

end
