class
	PD_S_E

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	s: CE_POINTER [NATURAL_8] assign set_s
		do
			create Result.make_shared (c_s (c_pointer))
		end

	e: CE_POINTER [NATURAL_8] assign set_e
		do
			create Result.make_shared (c_e (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_s (a_s: CE_POINTER [NATURAL_8])
		do
			c_set_s (c_pointer, a_s.c_pointer)
		end

	set_e (a_e: CE_POINTER [NATURAL_8])
		do
			c_set_e (c_pointer, a_e.c_pointer)
		end

feature {NONE} -- C getters

	c_s (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct s_e *)$tmp)->s;"
		end

	c_e (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct s_e *)$tmp)->e;"
		end

feature {NONE} -- C setters

	c_set_s (tmp: POINTER; a_s: POINTER)
		external
			"C inline"
		alias
			"((struct s_e *)$tmp)->s = (unsigned char *)$a_s;"
		end

	c_set_e (tmp: POINTER; a_e: POINTER)
		external
			"C inline"
		alias
			"((struct s_e *)$tmp)->e = (unsigned char *)$a_e;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct s_e);"
		end

end
