class
	PD_SEARCH

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	c: NATURAL_8 assign set_c
		do
			Result := c_c (c_pointer)
		end

	n: INTEGER_32 assign set_n
		do
			Result := c_n (c_pointer)
		end

	x: INTEGER_32 assign set_x
		do
			Result := c_x (c_pointer)
		end

	y: INTEGER_32 assign set_y
		do
			Result := c_y (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_c (a_c: NATURAL_8)
		do
			c_set_c (c_pointer, a_c)
		end

	set_n (a_n: INTEGER_32)
		do
			c_set_n (c_pointer, a_n)
		end

	set_x (a_x: INTEGER_32)
		do
			c_set_x (c_pointer, a_x)
		end

	set_y (a_y: INTEGER_32)
		do
			c_set_y (c_pointer, a_y)
		end

feature {NONE} -- C getters

	c_c (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct search *)$tmp)->c;"
		end

	c_n (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct search *)$tmp)->n;"
		end

	c_x (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct search *)$tmp)->x;"
		end

	c_y (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct search *)$tmp)->y;"
		end

feature {NONE} -- C setters

	c_set_c (tmp: POINTER; a_c: NATURAL_8)
		external
			"C inline"
		alias
			"((struct search *)$tmp)->c = $a_c;"
		end

	c_set_n (tmp: POINTER; a_n: INTEGER_32)
		external
			"C inline"
		alias
			"((struct search *)$tmp)->n = $a_n;"
		end

	c_set_x (tmp: POINTER; a_x: INTEGER_32)
		external
			"C inline"
		alias
			"((struct search *)$tmp)->x = $a_x;"
		end

	c_set_y (tmp: POINTER; a_y: INTEGER_32)
		external
			"C inline"
		alias
			"((struct search *)$tmp)->y = $a_y;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct search);"
		end

end
