class
	PD_TABLE_COLUMN

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	group: INTEGER_32 assign set_group
		do
			Result := c_group (c_pointer)
		end

	align: INTEGER_32 assign set_align
		do
			Result := c_align (c_pointer)
		end

	valign: INTEGER_32 assign set_valign
		do
			Result := c_valign (c_pointer)
		end

	width: INTEGER_32 assign set_width
		do
			Result := c_width (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_group (a_group: INTEGER_32)
		do
			c_set_group (c_pointer, a_group)
		end

	set_align (a_align: INTEGER_32)
		do
			c_set_align (c_pointer, a_align)
		end

	set_valign (a_valign: INTEGER_32)
		do
			c_set_valign (c_pointer, a_valign)
		end

	set_width (a_width: INTEGER_32)
		do
			c_set_width (c_pointer, a_width)
		end

feature {NONE} -- C getters

	c_group (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_column *)$tmp)->group;"
		end

	c_align (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_column *)$tmp)->align;"
		end

	c_valign (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_column *)$tmp)->valign;"
		end

	c_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_column *)$tmp)->width;"
		end

feature {NONE} -- C setters

	c_set_group (tmp: POINTER; a_group: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_column *)$tmp)->group = $a_group;"
		end

	c_set_align (tmp: POINTER; a_align: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_column *)$tmp)->align = $a_align;"
		end

	c_set_valign (tmp: POINTER; a_valign: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_column *)$tmp)->valign = $a_valign;"
		end

	c_set_width (tmp: POINTER; a_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_column *)$tmp)->width = $a_width;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct table_column);"
		end

end
