class
	PD_TEXT_ATTRIB

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	attr: INTEGER_32 assign set_attr
		do
			Result := c_attr (c_pointer)
		end

	fg: PD_RGB assign set_fg
		do
			create Result.make_shared (c_fg (c_pointer))
		end

	fg_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct text_attrib, fg);"
		end

	bg: PD_RGB assign set_bg
		do
			create Result.make_shared (c_bg (c_pointer))
		end

	bg_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct text_attrib, bg);"
		end

	fontsize: INTEGER_32 assign set_fontsize
		do
			Result := c_fontsize (c_pointer)
		end

	link: CE_POINTER [NATURAL_8] assign set_link
		do
			create Result.make_shared (c_link (c_pointer))
		end

	target: CE_POINTER [NATURAL_8] assign set_target
		do
			create Result.make_shared (c_target (c_pointer))
		end

	image: CE_POINTER [NATURAL_8] assign set_image
		do
			create Result.make_shared (c_image (c_pointer))
		end

	form: CE_POINTER [PD_FORM_CONTROL] assign set_form
		do
			create Result.make_shared (c_form (c_pointer))
		end

	clink: PD_RGB assign set_clink
		do
			create Result.make_shared (c_clink (c_pointer))
		end

	clink_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct text_attrib, clink);"
		end

	vlink: PD_RGB assign set_vlink
		do
			create Result.make_shared (c_vlink (c_pointer))
		end

	vlink_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct text_attrib, vlink);"
		end

	href_base: CE_POINTER [NATURAL_8] assign set_href_base
		do
			create Result.make_shared (c_href_base (c_pointer))
		end

	target_base: CE_POINTER [NATURAL_8] assign set_target_base
		do
			create Result.make_shared (c_target_base (c_pointer))
		end

	select2: CE_POINTER [NATURAL_8] assign set_select2
		do
			create Result.make_shared (c_select2 (c_pointer))
		end

	select_disabled: INTEGER_32 assign set_select_disabled
		do
			Result := c_select_disabled (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_attr (a_attr: INTEGER_32)
		do
			c_set_attr (c_pointer, a_attr)
		end

	set_fg (a_fg: PD_RGB)
		do
			fg.ce_gets (a_fg)
		end

	set_bg (a_bg: PD_RGB)
		do
			bg.ce_gets (a_bg)
		end

	set_fontsize (a_fontsize: INTEGER_32)
		do
			c_set_fontsize (c_pointer, a_fontsize)
		end

	set_link (a_link: CE_POINTER [NATURAL_8])
		do
			c_set_link (c_pointer, a_link.c_pointer)
		end

	set_target (a_target: CE_POINTER [NATURAL_8])
		do
			c_set_target (c_pointer, a_target.c_pointer)
		end

	set_image (a_image: CE_POINTER [NATURAL_8])
		do
			c_set_image (c_pointer, a_image.c_pointer)
		end

	set_form (a_form: CE_POINTER [PD_FORM_CONTROL])
		do
			c_set_form (c_pointer, a_form.c_pointer)
		end

	set_clink (a_clink: PD_RGB)
		do
			clink.ce_gets (a_clink)
		end

	set_vlink (a_vlink: PD_RGB)
		do
			vlink.ce_gets (a_vlink)
		end

	set_href_base (a_href_base: CE_POINTER [NATURAL_8])
		do
			c_set_href_base (c_pointer, a_href_base.c_pointer)
		end

	set_target_base (a_target_base: CE_POINTER [NATURAL_8])
		do
			c_set_target_base (c_pointer, a_target_base.c_pointer)
		end

	set_select2 (a_select2: CE_POINTER [NATURAL_8])
		do
			c_set_select2 (c_pointer, a_select2.c_pointer)
		end

	set_select_disabled (a_select_disabled: INTEGER_32)
		do
			c_set_select_disabled (c_pointer, a_select_disabled)
		end

feature {NONE} -- C getters

	c_attr (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct text_attrib *)$tmp)->attr;"
		end

	c_fg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct rgb *)&((struct text_attrib *)$tmp)->fg;"
		end

	c_bg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct rgb *)&((struct text_attrib *)$tmp)->bg;"
		end

	c_fontsize (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct text_attrib *)$tmp)->fontsize;"
		end

	c_link (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct text_attrib *)$tmp)->link;"
		end

	c_target (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct text_attrib *)$tmp)->target;"
		end

	c_image (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct text_attrib *)$tmp)->image;"
		end

	c_form (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct form_control *)((struct text_attrib *)$tmp)->form;"
		end

	c_clink (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct rgb *)&((struct text_attrib *)$tmp)->clink;"
		end

	c_vlink (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct rgb *)&((struct text_attrib *)$tmp)->vlink;"
		end

	c_href_base (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct text_attrib *)$tmp)->href_base;"
		end

	c_target_base (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct text_attrib *)$tmp)->target_base;"
		end

	c_select2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct text_attrib *)$tmp)->select;"
		end

	c_select_disabled (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct text_attrib *)$tmp)->select_disabled;"
		end

feature {NONE} -- C setters

	c_set_attr (tmp: POINTER; a_attr: INTEGER_32)
		external
			"C inline"
		alias
			"((struct text_attrib *)$tmp)->attr = $a_attr;"
		end

	c_set_fontsize (tmp: POINTER; a_fontsize: INTEGER_32)
		external
			"C inline"
		alias
			"((struct text_attrib *)$tmp)->fontsize = $a_fontsize;"
		end

	c_set_link (tmp: POINTER; a_link: POINTER)
		external
			"C inline"
		alias
			"((struct text_attrib *)$tmp)->link = (unsigned char *)$a_link;"
		end

	c_set_target (tmp: POINTER; a_target: POINTER)
		external
			"C inline"
		alias
			"((struct text_attrib *)$tmp)->target = (unsigned char *)$a_target;"
		end

	c_set_image (tmp: POINTER; a_image: POINTER)
		external
			"C inline"
		alias
			"((struct text_attrib *)$tmp)->image = (unsigned char *)$a_image;"
		end

	c_set_form (tmp: POINTER; a_form: POINTER)
		external
			"C inline"
		alias
			"((struct text_attrib *)$tmp)->form = (struct form_control *)$a_form;"
		end

	c_set_href_base (tmp: POINTER; a_href_base: POINTER)
		external
			"C inline"
		alias
			"((struct text_attrib *)$tmp)->href_base = (unsigned char *)$a_href_base;"
		end

	c_set_target_base (tmp: POINTER; a_target_base: POINTER)
		external
			"C inline"
		alias
			"((struct text_attrib *)$tmp)->target_base = (unsigned char *)$a_target_base;"
		end

	c_set_select2 (tmp: POINTER; a_select2: POINTER)
		external
			"C inline"
		alias
			"((struct text_attrib *)$tmp)->select = (unsigned char *)$a_select2;"
		end

	c_set_select_disabled (tmp: POINTER; a_select_disabled: INTEGER_32)
		external
			"C inline"
		alias
			"((struct text_attrib *)$tmp)->select_disabled = $a_select_disabled;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct text_attrib);"
		end

end
