class
	PD_TEXT_ATTRIB_BEGINNING

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	attr: INTEGER_32 assign set_attr
		do
			Result := c_attr (c_pointer)
		end

	fg: PD_RGB assign set_fg
		do
			create Result.make_shared (c_fg (c_pointer))
		end

	bg: PD_RGB assign set_bg
		do
			create Result.make_shared (c_bg (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_attr (a_attr: INTEGER_32)
		do
			c_set_attr (c_pointer, a_attr)
		end

	set_fg (a_fg: PD_RGB)
		do
			fg.ce_gets (a_fg)
		end

	set_bg (a_bg: PD_RGB)
		do
			bg.ce_gets (a_bg)
		end

feature {NONE} -- C getters

	c_attr (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct text_attrib_beginning *)$tmp)->attr;"
		end

	c_fg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct rgb *)&((struct text_attrib_beginning *)$tmp)->fg;"
		end

	c_bg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct rgb *)&((struct text_attrib_beginning *)$tmp)->bg;"
		end

feature {NONE} -- C setters

	c_set_attr (tmp: POINTER; a_attr: INTEGER_32)
		external
			"C inline"
		alias
			"((struct text_attrib_beginning *)$tmp)->attr = $a_attr;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct text_attrib_beginning);"
		end

end
