class
	PD_TRANSLATION_DESC

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	t: CE_POINTER [PD_TRANSLATION] assign set_t
		do
			create Result.make_shared (c_t (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_t (a_t: CE_POINTER [PD_TRANSLATION])
		do
			c_set_t (c_pointer, a_t.c_pointer)
		end

feature {NONE} -- C getters

	c_t (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct translation *)((struct translation_desc *)$tmp)->t;"
		end

feature {NONE} -- C setters

	c_set_t (tmp: POINTER; a_t: POINTER)
		external
			"C inline"
		alias
			"((struct translation_desc *)$tmp)->t = (struct translation *)$a_t;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct translation_desc);"
		end

end
