#ifndef LINKS_H
#define LINKS_H

#include <ffi.h>
#include <time.h>
#include <sys/select.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <libio.h>
#include <netinet/in.h>
#include <sys/stat.h>
#include <sys/utsname.h>
#include <netdb.h>
#include <pwd.h>
#include <grp.h>
#include <dirent.h>
#include <termios.h>
#include <sys/ioctl.h>
#include <bits/sigset.h>
#include <sys/time.h>
#include <signal.h>
#include <utime.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <bits/errno.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys/wait.h>

#undef tv_sec
#undef tv_usec
#undef fds_bits
#undef sa_family
#undef sa_data
#undef next
#undef prev
#undef ev
#undef x
#undef y
#undef b
#undef handler
#undef data
#undef xp
#undef yp
#undef term
#undef master
#undef fdin
#undef fdout
#undef environment
#undef cwd
#undef screen
#undef last_screen
#undef spec
#undef cx
#undef cy
#undef lcx
#undef lcy
#undef dirty
#undef redrawing
#undef blocked
#undef input_queue
#undef qlen
#undef windows
#undef title
#undef mode
#undef m11_hack
#undef restrict_852
#undef block_cursor
#undef col
#undef charset
#undef sun_family
#undef sun_path
#undef n
#undef p
#undef text
#undef rtext
#undef hotkey
#undef func
#undef in_m
#undef free_i
#undef selected
#undef view
#undef xw
#undef yw
#undef ni
#undef win
#undef items
#undef sp
#undef d
#undef type
#undef gid
#undef gnum
#undef fn
#undef history
#undef dlen
#undef udata
#undef l
#undef vpos
#undef cpos
#undef checked
#undef item
#undef cur_hist
#undef cdata
#undef handle_event
#undef abort
#undef udata2
#undef align
#undef refresh
#undef refresh_data
#undef dlg
#undef ml
#undef sel
#undef box_top
#undef list_len
#undef on_hilight
#undef on_selected
#undef sbuf
#undef pos
#undef flags
#undef IO_read_ptr
#undef IO_read_end
#undef IO_read_base
#undef IO_write_base
#undef IO_write_ptr
#undef IO_write_end
#undef IO_buf_base
#undef IO_buf_end
#undef IO_save_base
#undef IO_backup_base
#undef IO_save_end
#undef markers
#undef chain
#undef fileno
#undef flags2
#undef old_offset
#undef cur_column
#undef vtable_offset
#undef shortbuf
#undef lock
#undef offset
#undef pad1
#undef pad2
#undef pad3
#undef pad4
#undef pad5
#undef unused2
#undef url
#undef head
#undef redirect
#undef redirect_get
#undef length
#undef incomplete
#undef tgc
#undef last_modified
#undef data_size
#undef frag
#undef count
#undef refcount
#undef valid
#undef size
#undef loaded
#undef last_loaded
#undef cur_loaded
#undef elapsed
#undef last_time
#undef dis_b
#undef data_in_secs
#undef timer
#undef running
#undef state
#undef prev_error
#undef from2
#undef pri
#undef no_cache
#undef sock1
#undef sock2
#undef dnsquery
#undef pid
#undef tries
#undef statuss
#undef info
#undef buffer
#undef conn_func
#undef cache
#undef received
#undef est_length
#undef unrestartable
#undef prg
#undef detached
#undef c
#undef ce
#undef end2
#undef cnt
#undef ext
#undef ct
#undef form_num
#undef ctrl_num
#undef g_ctrl_num
#undef position
#undef method
#undef action
#undef target
#undef name
#undef alt
#undef ro
#undef default_value
#undef default_state
#undef cols
#undef rows
#undef wrap
#undef maxlength
#undef nvalues
#undef values
#undef labels
#undef menu
#undef value
#undef vypos
#undef num
#undef where
#undef where_img
#undef form
#undef sel_color
#undef r
#undef g
#undef pad
#undef assume_cp
#undef hard_assume
#undef tables
#undef frames
#undef images
#undef margin
#undef num_links
#undef table_order
#undef cp
#undef plain
#undef default_fg
#undef default_bg
#undef default_link
#undef default_vlink
#undef framename
#undef real_cp
#undef subframe
#undef line
#undef f
#undef opt
#undef ass
#undef time_to_get
#undef use_tag
#undef frame
#undef frame_desc
#undef bg
#undef links
#undef nlinks
#undef lines1
#undef lines2
#undef forms
#undef tags
#undef nodes
#undef search
#undef nsearch
#undef slines1
#undef slines2
#undef used
#undef f_data
#undef xl
#undef yl
#undef link_bg
#undef link_bg_n
#undef search_word
#undef vs
#undef depth
#undef view_pos
#undef view_posx
#undef orig_view_pos
#undef orig_view_posx
#undef current_link
#undef orig_link
#undef goto_position
#undef goto_position_end
#undef form_info
#undef form_info_len
#undef rep
#undef rep_num
#undef prefix2
#undef id
#undef scrn_frames
#undef loading
#undef wtd
#undef wtd_target
#undef loading_url
#undef display_timer
#undef more_files
#undef imgmap_href_base
#undef imgmap_target_base
#undef ds
#undef kbdprefix
#undef reloadlevel
#undef redirect_cnt
#undef tq
#undef tq_url
#undef tq_ce
#undef tq_goto_position
#undef tq_prog
#undef tq_prog_flags
#undef dn_url
#undef last_search_word
#undef search_direction
#undef exit_query
#undef type_data
#undef box
#undef real_length
#undef str
#undef tbl
#undef t
#undef u
#undef aliases
#undef table_dirty_workaround_for_name_clash_with_libraries_on_macos
#undef s
#undef lo
#undef up
#undef s_addr
#undef sin_family
#undef sin_port
#undef sin_addr
#undef sin_zero
#undef sock
#undef len
#undef close
#undef done
#undef sa
#undef addr
#undef port
#undef server
#undef path
#undef domain
#undef expires
#undef secure
#undef accept
#undef tv_nsec
#undef st_dev
#undef st_ino
#undef st_mode
#undef st_nlink
#undef st_uid
#undef st_gid
#undef st_rdev
#undef st_size
#undef st_blksize
#undef st_blocks
#undef st_atim
#undef st_mtim
#undef st_ctim
#undef unused4
#undef unused5
#undef sysname
#undef nodename
#undef release
#undef version
#undef machine
#undef domainname
#undef label
#undef prog
#undef cons
#undef xwin
#undef block
#undef ask
#undef system
#undef rd_cmd
#undef rd_cfg
#undef wr_cfg
#undef min
#undef max
#undef ptr
#undef cfg_name
#undef cmd_name
#undef http10
#undef allow_blacklist
#undef bug_302_redirect
#undef bug_post_no_keepalive
#undef no_accept_charset
#undef anon_pass
#undef fast_ftp
#undef passive_ftp
#undef set_tos
#undef h_name
#undef h_aliases
#undef h_addrtype
#undef h_length
#undef h_addr_list
#undef get_time
#undef xfn
#undef h
#undef file
#undef comment
#undef pw_name
#undef pw_passwd
#undef pw_uid
#undef pw_gid
#undef pw_gecos
#undef pw_dir
#undef pw_shell
#undef gr_name
#undef gr_passwd
#undef gr_gid
#undef gr_mem
#undef tm_sec
#undef tm_min
#undef tm_hour
#undef tm_mday
#undef tm_mon
#undef tm_year
#undef tm_wday
#undef tm_yday
#undef tm_isdst
#undef tm_gmtoff
#undef tm_zone
#undef d_ino
#undef d_off
#undef d_reclen
#undef d_type
#undef d_name
#undef pending_commands
#undef opc
#undef pasv
#undef dir
#undef rest_sent
#undef conn_st
#undef dpos
#undef buf_pos
#undef ftp_buffer
#undef cmdbuf
#undef link
#undef attr
#undef fg
#undef fontsize
#undef image
#undef clink
#undef vlink
#undef href_base
#undef target_base
#undef select2
#undef select_disabled
#undef leftmargin
#undef rightmargin
#undef width
#undef list_level
#undef list_number
#undef dd_margin
#undef bgcolor
#undef parattr
#undef invisible
#undef namelen
#undef options
#undef linebreak
#undef dontkill
#undef frameset
#undef parent
#undef rgb
#undef nopair
#undef stat
#undef xmax
#undef xa
#undef spaces
#undef spl
#undef link_num
#undef uf
#undef color
#undef hash_next
#undef start
#undef m
#undef xs
#undef spanned
#undef mx
#undef my
#undef valign
#undef group
#undef colspan
#undef rowspan
#undef min_width
#undef max_width
#undef x_width
#undef height
#undef xpos
#undef ypos
#undef rx
#undef ry
#undef border
#undef cellpd
#undef vcellpd
#undef cellsp
#undef rules
#undef wf
#undef min_c
#undef max_c
#undef w_c
#undef rw
#undef min_t
#undef max_t
#undef cells
#undef rc
#undef xc
#undef xcols
#undef r_heights
#undef rh
#undef e
#undef bl_flags
#undef chunk_remaining
#undef bugs
#undef c2_iflag
#undef c2_oflag
#undef c2_cflag
#undef c2_lflag
#undef c2_line
#undef c2_cc
#undef c2_ispeed
#undef c2_ospeed
#undef std_in
#undef std_out
#undef sock_in
#undef sock_out
#undef ctl_in
#undef kqueue
#undef tm
#undef ev_queue
#undef eqlen
#undef mouse_h
#undef orig_title
#undef act
#undef code
#undef last_pos
#undef handle
#undef prog_flags
#undef remotetime
#undef ses
#undef hk
#undef protocol
#undef host
#undef conn
#undef timeout
#undef add_time
#undef ws_row
#undef ws_col
#undef ws_xpixel
#undef ws_ypixel
#undef env
#undef msg
#undef val
#undef tz_minuteswest
#undef tz_dsttime
#undef sival_int
#undef sival_ptr
#undef si_pid
#undef si_uid
#undef si_tid
#undef si_overrun
#undef si_sigval
#undef si_status
#undef si_utime
#undef si_stime
#undef si_addr
#undef si_band
#undef si_fd
#undef kill
#undef rt
#undef sigchld
#undef sigfault
#undef sigpoll
#undef si_signo
#undef si_errno
#undef si_code
#undef sifields
#undef sa_handler
#undef sa_sigaction
#undef sigaction_handler
#undef sa_mask
#undef sa_flags
#undef sa_restorer
#undef read_func
#undef write_func
#undef error_func
#undef interval
#undef critical
#undef actime
#undef modtime
#undef req_sent
#undef client
#undef list
#undef cl
#undef ntext
#undef prot
#undef nc_func
#undef free_syntax
#undef need_slashes
#undef need_slash_after_host
#undef allow_post
#undef st
#undef en
#undef file_content
#undef fc_len
#undef __nfds
#undef __readfds
#undef __writefds
#undef __exceptfds
#undef __timeout
#undef exit
#undef __status
#undef __fd
#undef unlink
#undef __name
#undef memcpy
#undef __dest
#undef __src
#undef __n
#undef memset
#undef __s
#undef __c
#undef strcpy
#undef strcat
#undef strlen
#undef errno_location
#undef socket
#undef __domain
#undef __type
#undef __protocol
#undef bind
#undef __addr
#undef __len
#undef connect
#undef setsockopt
#undef __level
#undef __optname
#undef __optval
#undef __optlen
#undef listen
#undef __addr_len
#undef strtol
#undef __nptr
#undef __endptr
#undef __base
#undef memmove
#undef strncpy
#undef strcmp
#undef __s1
#undef __s2
#undef strncmp
#undef strchr
#undef remove
#undef __filename
#undef rename2
#undef __old
#undef __new
#undef fclose
#undef __stream
#undef fopen
#undef __modes
#undef fputc
#undef fgets
#undef fputs
#undef ferror
#undef getpagesize
#undef memcmp
#undef read
#undef __buf
#undef __nbytes
#undef write
#undef fcntl
#undef __cmd
#undef getsockname
#undef getsockopt
#undef htons
#undef __hostshort
#undef strcasecmp
#undef fflush
#undef fprintf
#undef __format
#undef fread
#undef __ptr
#undef __size
#undef popen
#undef __command
#undef pclose
#undef getenv
#undef sleep
#undef __seconds
#undef __file
#undef chmod
#undef __mode
#undef mkdir
#undef __path
#undef open
#undef __oflag
#undef uname
#undef herror
#undef __str
#undef malloc
#undef free
#undef gethostbyaddr
#undef gethostbyname
#undef sprintf
#undef vfprintf
#undef __arg
#undef realloc
#undef raise
#undef __sig
#undef getpwuid
#undef __uid
#undef getgrgid
#undef __gid
#undef qsort
#undef __nmemb
#undef __compar
#undef readlink
#undef time
#undef __timer
#undef strftime
#undef __maxsize
#undef __tp
#undef localtime
#undef lstat
#undef opendir
#undef closedir
#undef __dirp
#undef readdir
#undef strtoul
#undef strtoll
#undef strstr
#undef __haystack
#undef __needle
#undef getpeername
#undef ntohl
#undef __netlong
#undef htonl
#undef __hostlong
#undef atoi
#undef tcgetattr
#undef __termios_p
#undef tcsetattr
#undef __optional_actions
#undef getpid
#undef fork
#undef strerror
#undef __errnum
#undef __pid
#undef pipe
#undef __pipedes
#undef exit2
#undef signal
#undef __handler
#undef cfmakeraw
#undef ioctl
#undef __request
#undef chdir
#undef gettimeofday
#undef __tv
#undef __tz
#undef sigfillset
#undef __set
#undef sigaction
#undef __act
#undef __oact
#undef waitpid
#undef __stat_loc
#undef __options
#undef tempnam
#undef __dir
#undef __pfx
#undef mktime
#undef utime
#undef __file_times
#undef dup2
#undef __fd2
#undef execvp
#undef __argv
#undef getcwd
#undef setpgid
#undef __pgid
#undef memchr
#undef strcspn
#undef __reject

enum PC_BOX_ITEM_FREE {
	NOTHING = 0,
	TEXT = 1,
	DATA = 2
};

struct __anonstruct_fd_set_14;
struct list_head;
struct event;
struct window;
struct terminal;
struct term_spec;
struct xlist_head;
struct memory_list;
struct menu_item;
struct menu;
struct mainmenu;
struct history_item;
struct history;
struct dialog_item;
struct dialog_item_data;
struct dialog;
struct dialog_data;
struct dlg_data_item_data_box;
struct box_item;
struct cache_entry;
struct remaining_info;
struct connection;
struct status;
struct extension;
struct line;
struct point;
struct form_control;
struct form_state;
struct link;
struct link_bg;
struct rgb;
struct document_setup;
struct document_options;
struct search;
struct frame_desc;
struct frameset_desc;
struct f_data;
struct f_data_c;
struct view_state;
struct kbdprefix;
struct session;
struct bookmark;
struct push_del_button_hop_struct;
struct fragment;
union __anonunion_u_65;
struct conv_table;
struct table_entry;
struct codepage_desc;
struct __anonstruct_unicode_7b_67;
struct __anonstruct_entities_68;
struct __anonstruct_unicode_upcase_69;
struct read_buffer;
struct conn_info;
struct write_buffer;
struct cookie;
struct c_domain;
struct c_server;
struct assoc;
struct protocol_program;
struct option_dirty_workaround_for_name_clash_with_include_on_cygwin;
struct http_bugs;
struct ftp_options;
struct dnsentry;
struct dnsquery;
struct alloc_header;
struct dirs;
struct ftp_connection_info;
struct link_def;
struct form;
struct text_attrib;
struct par_attrib;
struct html_element;
struct frameset_param;
struct frame_param;
struct __anonstruct_roman_tbl_67;
struct color_spec;
struct element_info;
struct tag;
struct node;
struct frame;
struct location;
struct text_attrib_beginning;
struct part;
struct rgb_cache_entry;
struct table_cache_entry;
struct table_cell;
struct table_column;
struct table_dirty_workaround_for_name_clash_with_libraries_on_macos;
struct s_e;
struct http_connection_info;
struct __anonstruct_buggy_servers_67;
struct itrm;
struct key;
struct keybinding;
struct str2num;
struct default_kb;
struct translation;
struct translation_desc;
struct download;
struct refresh;
struct open_in_new;
struct k_conn;
struct __anonstruct_oinw_67;
struct s_msg_dsc;
struct h_conn;
struct blacklist_entry;
struct __anonstruct___sigset_t_13;
struct __anonstruct__kill_32;
struct __anonstruct__timer_33;
struct __anonstruct__rt_34;
struct __anonstruct__sigchld_35;
struct __anonstruct__sigfault_36;
struct __anonstruct__sigpoll_37;
union __anonunion__sifields_31;
union __anonunion___sigaction_handler_49;
struct thread;
struct timer;
struct bottom_half;
struct signal_handler;
struct file_to_load;
struct strerror_val;
struct wtd_data;
struct smb_connection_info;
struct ewd;
struct __anonstruct_protocols_67;
struct line_info;
struct submitted_value;

struct __anonstruct_fd_set_14 {
	long fds_bits[1024 / (8 * (int)sizeof(long))];
};
struct list_head {
	void * next;
	void * prev;
};
struct event {
	long ev;
	long x;
	long y;
	long b;
};
struct window {
	struct window * next;
	struct window * prev;
	void( * handler)(struct window *, struct event *, int fwd);
	void * data;
	int xp;
	int yp;
	struct terminal * term;
};
struct terminal {
	struct terminal * next;
	struct terminal * prev;
	int master;
	int fdin;
	int fdout;
	int x;
	int y;
	int environment;
	unsigned char term[32];
	unsigned char cwd[256];
	unsigned int * screen;
	unsigned int * last_screen;
	struct term_spec * spec;
	int cx;
	int cy;
	int lcx;
	int lcy;
	int dirty;
	int redrawing;
	int blocked;
	unsigned char * input_queue;
	int qlen;
	struct list_head windows;
	unsigned char * title;
};
struct term_spec {
	struct term_spec * next;
	struct term_spec * prev;
	unsigned char term[32];
	int mode;
	int m11_hack;
	int restrict_852;
	int block_cursor;
	int col;
	int charset;
};
struct xlist_head {
	struct xlist_head * next;
	struct xlist_head * prev;
};
struct memory_list {
	int n;
	void * p[1];
};
struct menu_item {
	unsigned char * text;
	unsigned char * rtext;
	unsigned char * hotkey;
	void( * func)(struct terminal *, void *, void *);
	void * data;
	int in_m;
	int free_i;
};
struct menu {
	int selected;
	int view;
	int xp;
	int yp;
	int x;
	int y;
	int xw;
	int yw;
	int ni;
	void * data;
	struct window * win;
	struct menu_item * items;
};
struct mainmenu {
	int selected;
	int sp;
	int ni;
	void * data;
	struct window * win;
	struct menu_item * items;
};
struct history_item {
	struct history_item * next;
	struct history_item * prev;
	unsigned char d[1];
};
struct history {
	int n;
	struct list_head items;
};
struct dialog_item {
	int type;
	int gid;
	int gnum;
	int( * fn)(struct dialog_data *, struct dialog_item_data *);
	struct history * history;
	int dlen;
	unsigned char * data;
	void * udata;
	unsigned char * text;
};
struct dialog_item_data {
	int x;
	int y;
	int l;
	int vpos;
	int cpos;
	int checked;
	struct dialog_item * item;
	struct list_head history;
	struct history_item * cur_hist;
	unsigned char * cdata;
};
struct dialog {
	unsigned char * title;
	void( * fn)(struct dialog_data *);
	int( * handle_event)(struct dialog_data *, struct event *);
	void( * abort)(struct dialog_data *);
	void * udata;
	void * udata2;
	int align;
	void( * refresh)(void *);
	void * refresh_data;
	struct dialog_item items[1];
};
struct dialog_data {
	struct window * win;
	struct dialog * dlg;
	int x;
	int y;
	int xw;
	int yw;
	int n;
	int selected;
	struct memory_list * ml;
	struct dialog_item_data items[1];
};
struct dlg_data_item_data_box {
	int sel;
	int box_top;
	struct list_head items;
	int list_len;
};
struct box_item {
	struct box_item * next;
	struct box_item * prev;
	unsigned char * text;
	void( * on_hilight)(struct terminal *, struct dlg_data_item_data_box *, struct box_item *);
	int( * on_selected)(struct terminal *, struct dlg_data_item_data_box *, struct box_item *);
	void * data;
	int free_i;
};
struct cache_entry {
	struct cache_entry * next;
	struct cache_entry * prev;
	unsigned char * url;
	unsigned char * head;
	unsigned char * redirect;
	int redirect_get;
	long length;
	int incomplete;
	int tgc;
	unsigned char * last_modified;
	long data_size;
	struct list_head frag;
	unsigned int count;
	int refcount;
};
struct remaining_info {
	int valid;
	long size;
	long loaded;
	long last_loaded;
	long cur_loaded;
	long pos;
	long elapsed;
	long last_time;
	long dis_b;
	int data_in_secs[50];
	int timer;
};
struct connection {
	struct connection * next;
	struct connection * prev;
	unsigned int count;
	unsigned char * url;
	int running;
	int state;
	int prev_error;
	long from;
	int pri[6];
	int no_cache;
	int sock1;
	int sock2;
	void * dnsquery;
	int pid;
	int tries;
	struct list_head statuss;
	void * info;
	void * buffer;
	void( * conn_func)(void *);
	struct cache_entry * cache;
	long received;
	long est_length;
	int unrestartable;
	struct remaining_info prg;
	int timer;
	int detached;
};
struct status {
	struct status * next;
	struct status * prev;
	struct connection * c;
	struct cache_entry * ce;
	int state;
	int prev_error;
	int pri;
	void( * end)(struct status *, void *);
	void * data;
	struct remaining_info * prg;
};
struct extension {
	struct extension * next;
	struct extension * prev;
	unsigned int cnt;
	unsigned char * ext;
	unsigned char * ct;
};
struct line {
	int l;
	unsigned short c;
	unsigned short * d;
};
struct point {
	int x;
	int y;
};
struct form_control {
	struct form_control * next;
	struct form_control * prev;
	int form_num;
	int ctrl_num;
	int g_ctrl_num;
	int position;
	int method;
	unsigned char * action;
	unsigned char * target;
	int type;
	unsigned char * name;
	unsigned char * alt;
	int ro;
	unsigned char * default_value;
	int default_state;
	int size;
	int cols;
	int rows;
	int wrap;
	int maxlength;
	int nvalues;
	unsigned char * * values;
	unsigned char * * labels;
	struct menu_item * menu;
};
struct form_state {
	int form_num;
	int ctrl_num;
	int g_ctrl_num;
	int position;
	int type;
	unsigned char * value;
	int state;
	int vpos;
	int vypos;
};
struct link {
	int type;
	int num;
	unsigned char * where;
	unsigned char * target;
	unsigned char * where_img;
	struct form_control * form;
	unsigned int sel_color;
	int n;
	struct point * pos;
};
struct link_bg {
	int x;
	int y;
	unsigned int c;
};
struct rgb {
	unsigned char r;
	unsigned char g;
	unsigned char b;
	unsigned char pad;
};
struct document_setup {
	int assume_cp;
	int hard_assume;
	int tables;
	int frames;
	int images;
	int margin;
	int num_links;
	int table_order;
};
struct document_options {
	int xw;
	int yw;
	int xp;
	int yp;
	int col;
	int cp;
	int assume_cp;
	int hard_assume;
	int tables;
	int frames;
	int images;
	int margin;
	int plain;
	int num_links;
	int table_order;
	struct rgb default_fg;
	struct rgb default_bg;
	struct rgb default_link;
	struct rgb default_vlink;
	unsigned char * framename;
	int real_cp;
};
struct search {
	unsigned char c;
	int n : 24;
	int x;
	int y;
};
struct frame_desc {
	struct frameset_desc * subframe;
	unsigned char * name;
	unsigned char * url;
	int line;
	int xw;
	int yw;
};
struct frameset_desc {
	int n;
	int x;
	int y;
	int xp;
	int yp;
	struct frame_desc f[1];
};
struct f_data {
	struct f_data * next;
	struct f_data * prev;
	int refcount;
	unsigned char * url;
	struct document_options opt;
	unsigned char * title;
	int cp;
	int ass;
	int x;
	int y;
	long time_to_get;
	unsigned int use_tag;
	int frame;
	struct frameset_desc * frame_desc;
	int bg;
	struct line * data;
	struct link * links;
	int nlinks;
	struct link * * lines1;
	struct link * * lines2;
	struct list_head forms;
	struct list_head tags;
	struct list_head nodes;
	struct search * search;
	int nsearch;
	struct search * * slines1;
	struct search * * slines2;
};
struct f_data_c {
	struct f_data_c * next;
	struct f_data_c * prev;
	int used;
	unsigned char * name;
	struct f_data * f_data;
	int xw;
	int yw;
	int xp;
	int yp;
	int xl;
	int yl;
	struct link_bg * link_bg;
	int link_bg_n;
	unsigned char * * search_word;
	struct view_state * vs;
	int depth;
};
struct view_state {
	int view_pos;
	int view_posx;
	int orig_view_pos;
	int orig_view_posx;
	int current_link;
	int orig_link;
	int plain;
	unsigned char * goto_position;
	unsigned char * goto_position_end;
	struct form_state * form_info;
	int form_info_len;
	unsigned char url[1];
};
struct kbdprefix {
	int rep;
	int rep_num;
	int prefix;
};
struct session {
	struct session * next;
	struct session * prev;
	struct list_head history;
	struct terminal * term;
	struct window * win;
	int id;
	struct f_data_c * screen;
	struct list_head scrn_frames;
	struct status loading;
	int wtd;
	unsigned char * wtd_target;
	unsigned char * loading_url;
	int display_timer;
	struct list_head more_files;
	unsigned char * goto_position;
	unsigned char * imgmap_href_base;
	unsigned char * imgmap_target_base;
	struct document_setup ds;
	struct kbdprefix kbdprefix;
	int reloadlevel;
	int redirect_cnt;
	struct status tq;
	unsigned char * tq_url;
	struct cache_entry * tq_ce;
	unsigned char * tq_goto_position;
	unsigned char * tq_prog;
	int tq_prog_flags;
	unsigned char * dn_url;
	unsigned char * search_word;
	unsigned char * last_search_word;
	int search_direction;
	int exit_query;
};
struct bookmark {
	struct bookmark * next;
	struct bookmark * prev;
	int id;
	unsigned char * title;
	unsigned char * url;
	unsigned int type;
	void * type_data;
};
struct push_del_button_hop_struct {
	struct dialog * dlg;
	struct dlg_data_item_data_box * box;
	int id;
};
struct fragment {
	struct fragment * next;
	struct fragment * prev;
	long offset;
	long length;
	long real_length;
	unsigned char data[1];
};
union __anonunion_u_65 {
	unsigned char * str;
	struct conv_table * tbl;
};
struct conv_table {
	int t;
	union __anonunion_u_65 u;
};
struct table_entry {
	unsigned char c;
	int u;
};
struct codepage_desc {
	unsigned char * name;
	unsigned char * * aliases;
	struct table_entry * table_dirty_workaround_for_name_clash_with_libraries_on_macos;
};
struct __anonstruct_unicode_7b_67 {
	int x;
	unsigned char * s;
};
struct __anonstruct_entities_68 {
	char * s;
	int c;
};
struct __anonstruct_unicode_upcase_69 {
	int lo;
	int up;
};
struct read_buffer {
	int sock;
	int len;
	int close;
	void( * done)(struct connection *, struct read_buffer *);
	unsigned char data[1];
};
struct conn_info {
	void( * func)(struct connection *);
	struct sockaddr_in sa;
	unsigned int addr;
	int port;
	int * sock;
};
struct write_buffer {
	int sock;
	int len;
	int pos;
	void( * done)(struct connection *);
	unsigned char data[1];
};
struct cookie {
	struct cookie * next;
	struct cookie * prev;
	unsigned char * name;
	unsigned char * value;
	unsigned char * server;
	unsigned char * path;
	unsigned char * domain;
	long expires;
	int secure;
	int id;
};
struct c_domain {
	struct c_domain * next;
	struct c_domain * prev;
	unsigned char domain[1];
};
struct c_server {
	struct c_server * next;
	struct c_server * prev;
	int accept;
	unsigned char server[1];
};
struct assoc {
	struct assoc * next;
	struct assoc * prev;
	unsigned int cnt;
	unsigned char * label;
	unsigned char * ct;
	unsigned char * prog;
	int cons;
	int xwin;
	int block;
	int ask;
	int system;
};
struct protocol_program {
	struct protocol_program * next;
	struct protocol_program * prev;
	unsigned char * prog;
	int system;
};
struct option_dirty_workaround_for_name_clash_with_include_on_cygwin {
	int p;
	unsigned char *( * rd_cmd)(struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *, unsigned char * * *, int *);
	unsigned char *( * rd_cfg)(struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *, unsigned char *);
	void( * wr_cfg)(struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *, unsigned char * *, int *);
	int min;
	int max;
	void * ptr;
	unsigned char * cfg_name;
	unsigned char * cmd_name;
};
struct http_bugs {
	int http10;
	int allow_blacklist;
	int bug_302_redirect;
	int bug_post_no_keepalive;
	int no_accept_charset;
};
struct ftp_options {
	unsigned char anon_pass[1024];
	int fast_ftp;
	int passive_ftp;
	int set_tos;
};
struct dnsentry {
	struct dnsentry * next;
	struct dnsentry * prev;
	long get_time;
	unsigned int addr;
	char name[1];
};
struct dnsquery {
	void( * fn)(void *, int);
	void * data;
	void( * xfn)(struct dnsquery *, int);
	int h;
	struct dnsquery * * s;
	unsigned int * addr;
	char name[1];
};
struct alloc_header {
	struct alloc_header * next;
	struct alloc_header * prev;
	int size;
	int line;
	unsigned char * file;
	unsigned char * comment;
};
struct dirs {
	unsigned char * s;
	unsigned char * f;
};
struct ftp_connection_info {
	int pending_commands;
	int opc;
	int pasv;
	int dir;
	int rest_sent;
	int conn_st;
	int d;
	int dpos;
	int buf_pos;
	unsigned char ftp_buffer[16384];
	unsigned char cmdbuf[1];
};
struct link_def {
	unsigned char * link;
	unsigned char * target;
};
struct form {
	unsigned char * action;
	unsigned char * target;
	int method;
	int num;
};
struct text_attrib {
	int attr;
	struct rgb fg;
	struct rgb bg;
	int fontsize;
	unsigned char * link;
	unsigned char * target;
	unsigned char * image;
	struct form_control * form;
	struct rgb clink;
	struct rgb vlink;
	unsigned char * href_base;
	unsigned char * target_base;
	unsigned char * select;
	int select_disabled;
};
struct par_attrib {
	int align;
	int leftmargin;
	int rightmargin;
	int width;
	int list_level;
	unsigned int list_number;
	int dd_margin;
	int flags;
	struct rgb bgcolor;
};
struct html_element {
	struct html_element * next;
	struct html_element * prev;
	struct text_attrib attr;
	struct par_attrib parattr;
	int invisible;
	unsigned char * name;
	int namelen;
	unsigned char * options;
	int linebreak;
	int dontkill;
	struct frameset_desc * frameset;
};
struct frameset_param {
	struct frameset_desc * parent;
	int x;
	int y;
	int * xw;
	int * yw;
};
struct frame_param {
	struct frameset_desc * parent;
	unsigned char * name;
	unsigned char * url;
};
struct __anonstruct_roman_tbl_67 {
	unsigned short n;
	char * s;
};
struct color_spec {
	char * name;
	int rgb;
};
struct element_info {
	char * name;
	void( * func)(unsigned char *);
	int linebreak;
	int nopair;
};
struct tag {
	struct tag * next;
	struct tag * prev;
	int x;
	int y;
	unsigned char name[1];
};
struct node {
	struct node * next;
	struct node * prev;
	int x;
	int y;
	int xw;
	int yw;
};
struct frame {
	struct frame * next;
	struct frame * prev;
	unsigned char * name;
	int redirect_cnt;
	struct view_state vs;
};
struct location {
	struct location * next;
	struct location * prev;
	struct list_head frames;
	struct status stat;
	struct view_state vs;
};
struct text_attrib_beginning {
	int attr;
	struct rgb fg;
	struct rgb bg;
};
struct part {
	int x;
	int y;
	int xp;
	int yp;
	int xmax;
	int xa;
	int cx;
	int cy;
	struct f_data * data;
	int bgcolor;
	unsigned char * spaces;
	int spl;
	int link_num;
	struct list_head uf;
};
struct rgb_cache_entry {
	int color;
	int l;
	struct rgb rgb;
};
struct table_cache_entry {
	struct table_cache_entry * next;
	struct table_cache_entry * prev;
	struct table_cache_entry * hash_next;
	unsigned char * start;
	unsigned char * end;
	int align;
	int m;
	int width;
	int xs;
	int link_num;
	struct part p;
};
struct table_cell {
	int used;
	int spanned;
	int mx;
	int my;
	unsigned char * start;
	unsigned char * end;
	int align;
	int valign;
	int b;
	struct rgb bgcolor;
	int group;
	int colspan;
	int rowspan;
	int min_width;
	int max_width;
	int x_width;
	int height;
	int xpos;
	int ypos;
	int xw;
	int yw;
	int link_num;
};
struct table_column {
	int group;
	int align;
	int valign;
	int width;
};
struct table_dirty_workaround_for_name_clash_with_libraries_on_macos {
	struct part * p;
	int x;
	int y;
	int rx;
	int ry;
	int border;
	int cellpd;
	int vcellpd;
	int cellsp;
	int frame;
	int rules;
	int width;
	int wf;
	int * min_c;
	int * max_c;
	int * w_c;
	int rw;
	int min_t;
	int max_t;
	struct table_cell * cells;
	int c;
	int rc;
	struct table_column * cols;
	int xc;
	int * xcols;
	int * r_heights;
	int rh;
	int link_num;
};
struct s_e {
	unsigned char * s;
	unsigned char * e;
};
struct http_connection_info {
	int bl_flags;
	int http10;
	int close;
	int length;
	int version;
	int chunk_remaining;
};
struct __anonstruct_buggy_servers_67 {
	unsigned char * name;
	int bugs;
};
struct itrm {
	int std_in;
	int std_out;
	int sock_in;
	int sock_out;
	int ctl_in;
	int blocked;
	struct termios t;
	int flags;
	unsigned char kqueue[16];
	int qlen;
	int tm;
	unsigned char * ev_queue;
	int eqlen;
	void * mouse_h;
	unsigned char * orig_title;
};
struct key {
	int x;
	int y;
};
struct keybinding {
	struct keybinding * next;
	struct keybinding * prev;
	int act;
	long x;
	long y;
};
struct str2num {
	unsigned char * str;
	long num;
};
struct default_kb {
	int act;
	long x;
	long y;
};
struct translation {
	int code;
	unsigned char * name;
};
struct translation_desc {
	struct translation * t;
};
struct download {
	struct download * next;
	struct download * prev;
	unsigned char * url;
	struct status stat;
	unsigned char * file;
	long last_pos;
	int handle;
	int redirect_cnt;
	unsigned char * prog;
	int prog_flags;
	long remotetime;
	struct session * ses;
	struct window * win;
	struct window * ask;
};
struct refresh {
	struct terminal * term;
	struct window * win;
	struct session * ses;
	void( * fn)(struct terminal * term, void * d, struct session * ses);
	void * data;
	int timer;
};
struct open_in_new {
	unsigned char * text;
	unsigned char * hk;
	void( * fn)(struct terminal * term, unsigned char *, unsigned char *);
};
struct k_conn {
	struct k_conn * next;
	struct k_conn * prev;
	void( * protocol)(struct connection *);
	unsigned char * host;
	int port;
	int conn;
	long timeout;
	long add_time;
};
struct __anonstruct_oinw_67 {
	int env;
	void( * fn)(struct terminal * term, unsigned char *, unsigned char *);
	unsigned char * text;
	unsigned char * hk;
};
struct s_msg_dsc {
	int n;
	unsigned char * msg;
};
struct h_conn {
	struct h_conn * next;
	struct h_conn * prev;
	unsigned char * host;
	int conn;
};
struct blacklist_entry {
	struct blacklist_entry * next;
	struct blacklist_entry * prev;
	int flags;
	unsigned char host[1];
};
struct __anonstruct___sigset_t_13 {
	unsigned long __val[1024u / (8u * sizeof(unsigned long))];
};
struct __anonstruct__kill_32 {
	int si_pid;
	unsigned int si_uid;
};
struct __anonstruct__timer_33 {
	int si_tid;
	int si_overrun;
	union sigval si_sigval;
};
struct __anonstruct__rt_34 {
	int si_pid;
	unsigned int si_uid;
	union sigval si_sigval;
};
struct __anonstruct__sigchld_35 {
	int si_pid;
	unsigned int si_uid;
	int si_status;
	long si_utime;
	long si_stime;
};
struct __anonstruct__sigfault_36 {
	void * si_addr;
};
struct __anonstruct__sigpoll_37 {
	long si_band;
	int si_fd;
};
union __anonunion__sifields_31 {
	int _pad[128u / sizeof(int) - 3u];
	struct __anonstruct__kill_32 _kill;
	struct __anonstruct__timer_33 _timer;
	struct __anonstruct__rt_34 _rt;
	struct __anonstruct__sigchld_35 _sigchld;
	struct __anonstruct__sigfault_36 _sigfault;
	struct __anonstruct__sigpoll_37 _sigpoll;
};
union __anonunion___sigaction_handler_49 {
	void( * sa_handler)(int);
	void( * sa_sigaction)(int, struct siginfo *, void *);
};
struct thread {
	void( * read_func)(void *);
	void( * write_func)(void *);
	void( * error_func)(void *);
	void * data;
};
struct timer {
	struct timer * next;
	struct timer * prev;
	long interval;
	void( * func)(void *);
	void * data;
	int id;
};
struct bottom_half {
	struct bottom_half * next;
	struct bottom_half * prev;
	void( * fn)(void *);
	void * data;
};
struct signal_handler {
	void( * fn)(void *);
	void * data;
	int critical;
};
struct file_to_load {
	struct file_to_load * next;
	struct file_to_load * prev;
	struct session * ses;
	int req_sent;
	int pri;
	struct cache_entry * ce;
	unsigned char * url;
	struct status stat;
};
struct strerror_val {
	struct strerror_val * next;
	struct strerror_val * prev;
	unsigned char msg[1];
};
struct wtd_data {
	struct session * ses;
	unsigned char * url;
	int pri;
	int cache;
	int wtd;
	unsigned char * target;
	unsigned char * pos;
	void( * fn)(struct status *, struct session *);
};
struct smb_connection_info {
	int client;
	int list;
	int cl;
	int ntext;
	unsigned char text[1];
};
struct ewd {
	void( * fn)(void *);
	void * data;
	int b;
};
struct __anonstruct_protocols_67 {
	unsigned char * prot;
	int port;
	void( * func)(struct connection *);
	void( * nc_func)(struct session *, unsigned char *);
	int free_syntax;
	int need_slashes;
	int need_slash_after_host;
	int allow_post;
};
struct line_info {
	unsigned char * st;
	unsigned char * en;
};
struct submitted_value {
	struct submitted_value * next;
	struct submitted_value * prev;
	int type;
	unsigned char * name;
	unsigned char * value;
	void * file_content;
	int fc_len;
	int position;
};

#endif
