frozen class
	LINKS_INITIALIZER_SLICE32

inherit
	LINKS_DATA
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {LINKS_INITIALIZER}

	initialize
		do
			html_inst.color_specs[46].name := ce_string ("gainsboro")
			html_inst.color_specs[46].rgb := 14474460
			html_inst.color_specs[47].name := ce_string ("ghostwhite")
			html_inst.color_specs[47].rgb := 16316671
			html_inst.color_specs[48].name := ce_string ("gold")
			html_inst.color_specs[48].rgb := 16766720
			html_inst.color_specs[49].name := ce_string ("goldenrod")
			html_inst.color_specs[49].rgb := 14329120
			html_inst.color_specs[50].name := ce_string ("gray")
			html_inst.color_specs[50].rgb := 8421504
			html_inst.color_specs[51].name := ce_string ("green")
			html_inst.color_specs[51].rgb := 32768
			html_inst.color_specs[52].name := ce_string ("greenyellow")
			html_inst.color_specs[52].rgb := 11403055
			html_inst.color_specs[53].name := ce_string ("honeydew")
			html_inst.color_specs[53].rgb := 15794160
			html_inst.color_specs[54].name := ce_string ("hotpink")
			html_inst.color_specs[54].rgb := 16738740
			html_inst.color_specs[55].name := ce_string ("indianred")
			html_inst.color_specs[55].rgb := 13458524
			html_inst.color_specs[56].name := ce_string ("indigo")
			html_inst.color_specs[56].rgb := 4915330
			html_inst.color_specs[57].name := ce_string ("ivory")
			html_inst.color_specs[57].rgb := 16777200
			html_inst.color_specs[58].name := ce_string ("khaki")
			html_inst.color_specs[58].rgb := 15787660
			html_inst.color_specs[59].name := ce_string ("lavender")
			html_inst.color_specs[59].rgb := 15132410
			html_inst.color_specs[60].name := ce_string ("lavenderblush")
			html_inst.color_specs[60].rgb := 16773365
			html_inst.color_specs[61].name := ce_string ("lawngreen")
			html_inst.color_specs[61].rgb := 8190976
			html_inst.color_specs[62].name := ce_string ("lemonchiffon")
			html_inst.color_specs[62].rgb := 16775885
			html_inst.color_specs[63].name := ce_string ("lightblue")
			html_inst.color_specs[63].rgb := 11393254
			html_inst.color_specs[64].name := ce_string ("lightcoral")
			html_inst.color_specs[64].rgb := 15761536
			html_inst.color_specs[65].name := ce_string ("lightcyan")
			html_inst.color_specs[65].rgb := 14745599
			html_inst.color_specs[66].name := ce_string ("lightgoldenrodyellow")
			html_inst.color_specs[66].rgb := 16448210
			html_inst.color_specs[67].name := ce_string ("lightgreen")
			html_inst.color_specs[67].rgb := 9498256
			html_inst.color_specs[68].name := ce_string ("lightgrey")
			html_inst.color_specs[68].rgb := 13882323
			html_inst.color_specs[69].name := ce_string ("lightpink")
			html_inst.color_specs[69].rgb := 16758465
			html_inst.color_specs[70].name := ce_string ("lightsalmon")
			html_inst.color_specs[70].rgb := 16752762
			html_inst.color_specs[71].name := ce_string ("lightseagreen")
			html_inst.color_specs[71].rgb := 2142890
			html_inst.color_specs[72].name := ce_string ("lightskyblue")
			html_inst.color_specs[72].rgb := 8900346
			html_inst.color_specs[73].name := ce_string ("lightslategray")
			html_inst.color_specs[73].rgb := 7833753
			html_inst.color_specs[74].name := ce_string ("lightsteelblue")
			html_inst.color_specs[74].rgb := 11584734
			html_inst.color_specs[75].name := ce_string ("lightyellow")
			html_inst.color_specs[75].rgb := 16777184
			html_inst.color_specs[76].name := ce_string ("lime")
			html_inst.color_specs[76].rgb := 65280
			html_inst.color_specs[77].name := ce_string ("limegreen")
			html_inst.color_specs[77].rgb := 3329330
			html_inst.color_specs[78].name := ce_string ("linen")
			html_inst.color_specs[78].rgb := 16445670
			html_inst.color_specs[79].name := ce_string ("magenta")
			html_inst.color_specs[79].rgb := 16711935
			html_inst.color_specs[80].name := ce_string ("maroon")
			html_inst.color_specs[80].rgb := 8388608
			html_inst.color_specs[81].name := ce_string ("mediumaquamarine")
			html_inst.color_specs[81].rgb := 6737322
			html_inst.color_specs[82].name := ce_string ("mediumblue")
			html_inst.color_specs[82].rgb := 205
			html_inst.color_specs[83].name := ce_string ("mediumorchid")
			html_inst.color_specs[83].rgb := 12211667
			html_inst.color_specs[84].name := ce_string ("mediumpurple")
			html_inst.color_specs[84].rgb := 9662683
			html_inst.color_specs[85].name := ce_string ("mediumseagreen")
			html_inst.color_specs[85].rgb := 3978097
			html_inst.color_specs[86].name := ce_string ("mediumslateblue")
			html_inst.color_specs[86].rgb := 8087790
			html_inst.color_specs[87].name := ce_string ("mediumspringgreen")
			html_inst.color_specs[87].rgb := 64154
			html_inst.color_specs[88].name := ce_string ("mediumturquoise")
			html_inst.color_specs[88].rgb := 4772300
			html_inst.color_specs[89].name := ce_string ("mediumvioletred")
			html_inst.color_specs[89].rgb := 13047173
			html_inst.color_specs[90].name := ce_string ("midnightblue")
			html_inst.color_specs[90].rgb := 1644912
			html_inst.color_specs[91].name := ce_string ("mintcream")
			html_inst.color_specs[91].rgb := 16121850
			html_inst.color_specs[92].name := ce_string ("mistyrose")
			html_inst.color_specs[92].rgb := 16770273
			html_inst.color_specs[93].name := ce_string ("moccasin")
			html_inst.color_specs[93].rgb := 16770229
			html_inst.color_specs[94].name := ce_string ("navajowhite")
			html_inst.color_specs[94].rgb := 16768685
			html_inst.color_specs[95].name := ce_string ("navy")
			html_inst.color_specs[95].rgb := 128
			html_inst.color_specs[96].name := ce_string ("oldlace")
			html_inst.color_specs[96].rgb := 16643558
			html_inst.color_specs[97].name := ce_string ("olive")
			html_inst.color_specs[97].rgb := 8421376
			html_inst.color_specs[98].name := ce_string ("olivedrab")
			html_inst.color_specs[98].rgb := 7048739
			html_inst.color_specs[99].name := ce_string ("orange")
			html_inst.color_specs[99].rgb := 16753920
			html_inst.color_specs[100].name := ce_string ("orangered")
			html_inst.color_specs[100].rgb := 16729344
			html_inst.color_specs[101].name := ce_string ("orchid")
			html_inst.color_specs[101].rgb := 14315734
			html_inst.color_specs[102].name := ce_string ("palegoldenrod")
			html_inst.color_specs[102].rgb := 15657130
			html_inst.color_specs[103].name := ce_string ("palegreen")
			html_inst.color_specs[103].rgb := 10025880
			html_inst.color_specs[104].name := ce_string ("paleturquoise")
			html_inst.color_specs[104].rgb := 11529966
			html_inst.color_specs[105].name := ce_string ("palevioletred")
			html_inst.color_specs[105].rgb := 14381203
			html_inst.color_specs[106].name := ce_string ("papayawhip")
			html_inst.color_specs[106].rgb := 16773077
			html_inst.color_specs[107].name := ce_string ("peachpuff")
			html_inst.color_specs[107].rgb := 16767673
			html_inst.color_specs[108].name := ce_string ("peru")
			html_inst.color_specs[108].rgb := 13468991
			html_inst.color_specs[109].name := ce_string ("pink")
			html_inst.color_specs[109].rgb := 16761035
			html_inst.color_specs[110].name := ce_string ("plum")
			html_inst.color_specs[110].rgb := 14524637
			html_inst.color_specs[111].name := ce_string ("powderblue")
			html_inst.color_specs[111].rgb := 11591910
			html_inst.color_specs[112].name := ce_string ("purple")
			html_inst.color_specs[112].rgb := 8388736
			html_inst.color_specs[113].name := ce_string ("red")
			html_inst.color_specs[113].rgb := 16711680
			html_inst.color_specs[114].name := ce_string ("rosybrown")
			html_inst.color_specs[114].rgb := 12357519
			html_inst.color_specs[115].name := ce_string ("royalblue")
			html_inst.color_specs[115].rgb := 4286945
			html_inst.color_specs[116].name := ce_string ("saddlebrown")
			html_inst.color_specs[116].rgb := 9127187
			html_inst.color_specs[117].name := ce_string ("salmon")
			html_inst.color_specs[117].rgb := 16416882
			html_inst.color_specs[118].name := ce_string ("sandybrown")
			html_inst.color_specs[118].rgb := 16032864
			html_inst.color_specs[119].name := ce_string ("seagreen")
			html_inst.color_specs[119].rgb := 3050327
			html_inst.color_specs[120].name := ce_string ("seashell")
			html_inst.color_specs[120].rgb := 16774638
			html_inst.color_specs[121].name := ce_string ("sienna")
			html_inst.color_specs[121].rgb := 10506797
			html_inst.color_specs[122].name := ce_string ("silver")
			html_inst.color_specs[122].rgb := 12632256
			html_inst.color_specs[123].name := ce_string ("skyblue")
			html_inst.color_specs[123].rgb := 8900331
			html_inst.color_specs[124].name := ce_string ("slateblue")
			html_inst.color_specs[124].rgb := 6970061
			html_inst.color_specs[125].name := ce_string ("slategray")
			html_inst.color_specs[125].rgb := 7372944
			html_inst.color_specs[126].name := ce_string ("snow")
			html_inst.color_specs[126].rgb := 16775930
			html_inst.color_specs[127].name := ce_string ("springgreen")
			html_inst.color_specs[127].rgb := 65407
			html_inst.color_specs[128].name := ce_string ("steelblue")
			html_inst.color_specs[128].rgb := 4620980
			html_inst.color_specs[129].name := ce_string ("tan")
			html_inst.color_specs[129].rgb := 13808780
			html_inst.color_specs[130].name := ce_string ("teal")
			html_inst.color_specs[130].rgb := 32896
			html_inst.color_specs[131].name := ce_string ("thistle")
			html_inst.color_specs[131].rgb := 14204888
			html_inst.color_specs[132].name := ce_string ("tomato")
			html_inst.color_specs[132].rgb := 16737095
			html_inst.color_specs[133].name := ce_string ("turquoise")
			html_inst.color_specs[133].rgb := 4251856
			html_inst.color_specs[134].name := ce_string ("violet")
			html_inst.color_specs[134].rgb := 15631086
			html_inst.color_specs[135].name := ce_string ("wheat")
			html_inst.color_specs[135].rgb := 16113331
			html_inst.color_specs[136].name := ce_string ("white")
			html_inst.color_specs[136].rgb := 16777215
			html_inst.color_specs[137].name := ce_string ("whitesmoke")
			html_inst.color_specs[137].rgb := 16119285
			html_inst.color_specs[138].name := ce_string ("yellow")
			html_inst.color_specs[138].rgb := 16776960
			html_inst.color_specs[139].name := ce_string ("yellowgreen")
			html_inst.color_specs[139].rgb := 10145074
			html_inst.form.action := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			html_inst.form.target := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			html_inst.form.method := 0
			html_inst.form.num := 0
			html_inst.elements[0].name := ce_string ("SPAN")
			html_inst.elements[0].func := html_inst.html_span_address
			html_inst.elements[0].linebreak := 0
			html_inst.elements[0].nopair := 0
			html_inst.elements[1].name := ce_string ("B")
			html_inst.elements[1].func := html_inst.html_bold_address
			html_inst.elements[1].linebreak := 0
			html_inst.elements[1].nopair := 0
			html_inst.elements[2].name := ce_string ("STRONG")
			html_inst.elements[2].func := html_inst.html_bold_address
			html_inst.elements[2].linebreak := 0
			html_inst.elements[2].nopair := 0
			html_inst.elements[3].name := ce_string ("DFN")
			html_inst.elements[3].func := html_inst.html_bold_address
			html_inst.elements[3].linebreak := 0
			html_inst.elements[3].nopair := 0
			html_inst.elements[4].name := ce_string ("I")
			html_inst.elements[4].func := html_inst.html_italic_address
			html_inst.elements[4].linebreak := 0
			html_inst.elements[4].nopair := 0
			html_inst.elements[5].name := ce_string ("Q")
			html_inst.elements[5].func := html_inst.html_italic_address
			html_inst.elements[5].linebreak := 0
			html_inst.elements[5].nopair := 0
			html_inst.elements[6].name := ce_string ("CITE")
			html_inst.elements[6].func := html_inst.html_italic_address
			html_inst.elements[6].linebreak := 0
			html_inst.elements[6].nopair := 0
			html_inst.elements[7].name := ce_string ("EM")
			html_inst.elements[7].func := html_inst.html_italic_address
			html_inst.elements[7].linebreak := 0
			html_inst.elements[7].nopair := 0
			html_inst.elements[8].name := ce_string ("ABBR")
			html_inst.elements[8].func := html_inst.html_italic_address
			html_inst.elements[8].linebreak := 0
			html_inst.elements[8].nopair := 0
			html_inst.elements[9].name := ce_string ("U")
			html_inst.elements[9].func := html_inst.html_underline_address
			html_inst.elements[9].linebreak := 0
			html_inst.elements[9].nopair := 0
			html_inst.elements[10].name := ce_string ("S")
			html_inst.elements[10].func := html_inst.html_underline_address
			html_inst.elements[10].linebreak := 0
			html_inst.elements[10].nopair := 0
			html_inst.elements[11].name := ce_string ("STRIKE")
			html_inst.elements[11].func := html_inst.html_underline_address
			html_inst.elements[11].linebreak := 0
			html_inst.elements[11].nopair := 0
			html_inst.elements[12].name := ce_string ("FIXED")
			html_inst.elements[12].func := html_inst.html_fixed_address
			html_inst.elements[12].linebreak := 0
			html_inst.elements[12].nopair := 0
			html_inst.elements[13].name := ce_string ("CODE")
			html_inst.elements[13].func := html_inst.html_fixed_address
			html_inst.elements[13].linebreak := 0
			html_inst.elements[13].nopair := 0
			html_inst.elements[14].name := ce_string ("FONT")
			html_inst.elements[14].func := html_inst.html_font_address
			html_inst.elements[14].linebreak := 0
			html_inst.elements[14].nopair := 0
			html_inst.elements[15].name := ce_string ("A")
			html_inst.elements[15].func := html_inst.html_a_address
			html_inst.elements[15].linebreak := 0
			html_inst.elements[15].nopair := 2
			html_inst.elements[16].name := ce_string ("IMG")
			html_inst.elements[16].func := html_inst.html_img_address
			html_inst.elements[16].linebreak := 0
			html_inst.elements[16].nopair := 1
			html_inst.elements[17].name := ce_string ("BASE")
			html_inst.elements[17].func := html_inst.html_base_address
			html_inst.elements[17].linebreak := 0
			html_inst.elements[17].nopair := 1
			html_inst.elements[18].name := ce_string ("BASEFONT")
			html_inst.elements[18].func := html_inst.html_font_address
			html_inst.elements[18].linebreak := 0
			html_inst.elements[18].nopair := 1
			html_inst.elements[19].name := ce_string ("BODY")
			html_inst.elements[19].func := html_inst.html_body_address
			html_inst.elements[19].linebreak := 0
			html_inst.elements[19].nopair := 0
			html_inst.elements[20].name := ce_string ("TITLE")
			html_inst.elements[20].func := html_inst.html_title_address
			html_inst.elements[20].linebreak := 0
			html_inst.elements[20].nopair := 0
			html_inst.elements[21].name := ce_string ("SCRIPT")
			html_inst.elements[21].func := html_inst.html_skip_address
			html_inst.elements[21].linebreak := 0
			html_inst.elements[21].nopair := 0
			html_inst.elements[22].name := ce_string ("STYLE")
			html_inst.elements[22].func := html_inst.html_skip_address
			html_inst.elements[22].linebreak := 0
			html_inst.elements[22].nopair := 0
			html_inst.elements[23].name := ce_string ("BR")
			html_inst.elements[23].func := html_inst.html_br_address
			html_inst.elements[23].linebreak := 1
			html_inst.elements[23].nopair := 1
			html_inst.elements[24].name := ce_string ("DIV")
			html_inst.elements[24].func := html_inst.html_linebrk_address
			html_inst.elements[24].linebreak := 1
			html_inst.elements[24].nopair := 0
			html_inst.elements[25].name := ce_string ("CENTER")
			html_inst.elements[25].func := html_inst.html_center_address
			html_inst.elements[25].linebreak := 1
			html_inst.elements[25].nopair := 0
			html_inst.elements[26].name := ce_string ("CAPTION")
			html_inst.elements[26].func := html_inst.html_center_address
			html_inst.elements[26].linebreak := 1
			html_inst.elements[26].nopair := 0
			html_inst.elements[27].name := ce_string ("P")
			html_inst.elements[27].func := html_inst.html_p_address
			html_inst.elements[27].linebreak := 2
			html_inst.elements[27].nopair := 2
			html_inst.elements[28].name := ce_string ("HR")
			html_inst.elements[28].func := html_inst.html_hr_address
			html_inst.elements[28].linebreak := 2
			html_inst.elements[28].nopair := 1
			html_inst.elements[29].name := ce_string ("H1")
			html_inst.elements[29].func := html_inst.html_center_address
			html_inst.elements[29].linebreak := 2
			html_inst.elements[29].nopair := 2
			html_inst.elements[30].name := ce_string ("H2")
			html_inst.elements[30].func := html_inst.html_h2_address
			html_inst.elements[30].linebreak := 2
			html_inst.elements[30].nopair := 2
			html_inst.elements[31].name := ce_string ("H3")
			html_inst.elements[31].func := html_inst.html_h3_address
			html_inst.elements[31].linebreak := 2
			html_inst.elements[31].nopair := 2
			html_inst.elements[32].name := ce_string ("H4")
			html_inst.elements[32].func := html_inst.html_h4_address
			html_inst.elements[32].linebreak := 2
			html_inst.elements[32].nopair := 2
			html_inst.elements[33].name := ce_string ("H5")
			html_inst.elements[33].func := html_inst.html_h5_address
			html_inst.elements[33].linebreak := 2
			html_inst.elements[33].nopair := 2
			html_inst.elements[34].name := ce_string ("H6")
			html_inst.elements[34].func := html_inst.html_h6_address
			html_inst.elements[34].linebreak := 2
			html_inst.elements[34].nopair := 2
			html_inst.elements[35].name := ce_string ("BLOCKQUOTE")
			html_inst.elements[35].func := html_inst.html_blockquote_address
			html_inst.elements[35].linebreak := 2
			html_inst.elements[35].nopair := 0
			html_inst.elements[36].name := ce_string ("ADDRESS")
			html_inst.elements[36].func := html_inst.html_address_address
			html_inst.elements[36].linebreak := 2
			html_inst.elements[36].nopair := 0
			html_inst.elements[37].name := ce_string ("PRE")
			html_inst.elements[37].func := html_inst.html_pre_address
			html_inst.elements[37].linebreak := 2
			html_inst.elements[37].nopair := 0
			html_inst.elements[38].name := ce_string ("LISTING")
			html_inst.elements[38].func := html_inst.html_pre_address
			html_inst.elements[38].linebreak := 2
			html_inst.elements[38].nopair := 0
			html_inst.elements[39].name := ce_string ("UL")
			html_inst.elements[39].func := html_inst.html_ul_address
			html_inst.elements[39].linebreak := 1
			html_inst.elements[39].nopair := 0
			html_inst.elements[40].name := ce_string ("DIR")
			html_inst.elements[40].func := html_inst.html_ul_address
			html_inst.elements[40].linebreak := 1
			html_inst.elements[40].nopair := 0
			html_inst.elements[41].name := ce_string ("MENU")
			html_inst.elements[41].func := html_inst.html_ul_address
			html_inst.elements[41].linebreak := 1
			html_inst.elements[41].nopair := 0
			html_inst.elements[42].name := ce_string ("OL")
			html_inst.elements[42].func := html_inst.html_ol_address
			html_inst.elements[42].linebreak := 1
			html_inst.elements[42].nopair := 0
			html_inst.elements[43].name := ce_string ("LI")
			html_inst.elements[43].func := html_inst.html_li_address
			html_inst.elements[43].linebreak := 1
			html_inst.elements[43].nopair := 3
			html_inst.elements[44].name := ce_string ("DL")
			html_inst.elements[44].func := html_inst.html_dl_address
			html_inst.elements[44].linebreak := 1
			html_inst.elements[44].nopair := 0
			html_inst.elements[45].name := ce_string ("DT")
			html_inst.elements[45].func := html_inst.html_dt_address
			html_inst.elements[45].linebreak := 1
			html_inst.elements[45].nopair := 1
			html_inst.elements[46].name := ce_string ("DD")
			html_inst.elements[46].func := html_inst.html_dd_address
			html_inst.elements[46].linebreak := 1
			html_inst.elements[46].nopair := 1
			html_inst.elements[47].name := ce_string ("TABLE")
			html_inst.elements[47].func := html_inst.html_table_address
			html_inst.elements[47].linebreak := 2
			html_inst.elements[47].nopair := 0
			html_inst.elements[48].name := ce_string ("TR")
			html_inst.elements[48].func := html_inst.html_tr_address
			html_inst.elements[48].linebreak := 1
			html_inst.elements[48].nopair := 0
			html_inst.elements[49].name := ce_string ("TD")
			html_inst.elements[49].func := html_inst.html_td_address
			html_inst.elements[49].linebreak := 0
			html_inst.elements[49].nopair := 0
			html_inst.elements[50].name := ce_string ("TH")
			html_inst.elements[50].func := html_inst.html_th_address
			html_inst.elements[50].linebreak := 0
			html_inst.elements[50].nopair := 0
			html_inst.elements[51].name := ce_string ("FORM")
			html_inst.elements[51].func := html_inst.html_form_address
			html_inst.elements[51].linebreak := 1
			html_inst.elements[51].nopair := 0
			html_inst.elements[52].name := ce_string ("INPUT")
			html_inst.elements[52].func := html_inst.html_input_address
			html_inst.elements[52].linebreak := 0
			html_inst.elements[52].nopair := 1
			html_inst.elements[53].name := ce_string ("TEXTAREA")
			html_inst.elements[53].func := html_inst.html_textarea_address
			html_inst.elements[53].linebreak := 0
			html_inst.elements[53].nopair := 1
			html_inst.elements[54].name := ce_string ("SELECT")
			html_inst.elements[54].func := html_inst.html_select_address
			html_inst.elements[54].linebreak := 0
			html_inst.elements[54].nopair := 0
			html_inst.elements[55].name := ce_string ("OPTION")
			html_inst.elements[55].func := html_inst.html_option_address
			html_inst.elements[55].linebreak := 1
			html_inst.elements[55].nopair := 1
			html_inst.elements[56].name := ce_string ("BUTTON")
			html_inst.elements[56].func := html_inst.html_button_address
			html_inst.elements[56].linebreak := 0
			html_inst.elements[56].nopair := 0
			html_inst.elements[57].name := ce_string ("LINK")
			html_inst.elements[57].func := html_inst.html_link_address
			html_inst.elements[57].linebreak := 1
			html_inst.elements[57].nopair := 1
			html_inst.elements[58].name := ce_string ("IFRAME")
			html_inst.elements[58].func := html_inst.html_iframe_address
			html_inst.elements[58].linebreak := 1
			html_inst.elements[58].nopair := 1
			html_inst.elements[59].name := ce_string ("FRAME")
			html_inst.elements[59].func := html_inst.html_frame_address
			html_inst.elements[59].linebreak := 1
			html_inst.elements[59].nopair := 1
			html_inst.elements[60].name := ce_string ("FRAMESET")
			html_inst.elements[60].func := html_inst.html_frameset_address
			html_inst.elements[60].linebreak := 1
			html_inst.elements[60].nopair := 0
			html_inst.elements[61].name := ce_string ("NOFRAMES")
			html_inst.elements[61].func := html_inst.html_noframes_address
			html_inst.elements[61].linebreak := 0
			html_inst.elements[61].nopair := 0
			html_inst.elements[62].name := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			html_inst.elements[62].func := create {CE_ROUTINE}.make_shared (default_pointer)
			html_inst.elements[62].linebreak := 0
			html_inst.elements[62].nopair := 0
			html_r_inst.palette[0].r := (0).to_natural_8
			html_r_inst.palette[0].g := (0).to_natural_8
			html_r_inst.palette[0].b := (0).to_natural_8
			html_r_inst.palette[0].pad := (0).to_natural_8
			html_r_inst.palette[1].r := (128).to_natural_8
			html_r_inst.palette[1].g := (0).to_natural_8
			html_r_inst.palette[1].b := (0).to_natural_8
			html_r_inst.palette[1].pad := (0).to_natural_8
			html_r_inst.palette[2].r := (0).to_natural_8
			html_r_inst.palette[2].g := (128).to_natural_8
			html_r_inst.palette[2].b := (0).to_natural_8
			html_r_inst.palette[2].pad := (0).to_natural_8
			html_r_inst.palette[3].r := (170).to_natural_8
			html_r_inst.palette[3].g := (85).to_natural_8
			html_r_inst.palette[3].b := (0).to_natural_8
			html_r_inst.palette[3].pad := (0).to_natural_8
			html_r_inst.palette[4].r := (0).to_natural_8
			html_r_inst.palette[4].g := (0).to_natural_8
			html_r_inst.palette[4].b := (128).to_natural_8
			html_r_inst.palette[4].pad := (0).to_natural_8
			html_r_inst.palette[5].r := (128).to_natural_8
			html_r_inst.palette[5].g := (0).to_natural_8
			html_r_inst.palette[5].b := (128).to_natural_8
			html_r_inst.palette[5].pad := (0).to_natural_8
			html_r_inst.palette[6].r := (0).to_natural_8
			html_r_inst.palette[6].g := (128).to_natural_8
			html_r_inst.palette[6].b := (128).to_natural_8
			html_r_inst.palette[6].pad := (0).to_natural_8
			html_r_inst.palette[7].r := (170).to_natural_8
			html_r_inst.palette[7].g := (170).to_natural_8
			html_r_inst.palette[7].b := (170).to_natural_8
			html_r_inst.palette[7].pad := (0).to_natural_8
			html_r_inst.palette[8].r := (85).to_natural_8
			html_r_inst.palette[8].g := (85).to_natural_8
			html_r_inst.palette[8].b := (85).to_natural_8
			html_r_inst.palette[8].pad := (0).to_natural_8
			html_r_inst.palette[9].r := (255).to_natural_8
			html_r_inst.palette[9].g := (85).to_natural_8
			html_r_inst.palette[9].b := (85).to_natural_8
			html_r_inst.palette[9].pad := (0).to_natural_8
			html_r_inst.palette[10].r := (85).to_natural_8
			html_r_inst.palette[10].g := (255).to_natural_8
			html_r_inst.palette[10].b := (85).to_natural_8
			html_r_inst.palette[10].pad := (0).to_natural_8
			html_r_inst.palette[11].r := (255).to_natural_8
			html_r_inst.palette[11].g := (255).to_natural_8
			html_r_inst.palette[11].b := (85).to_natural_8
			html_r_inst.palette[11].pad := (0).to_natural_8
			html_r_inst.palette[12].r := (85).to_natural_8
			html_r_inst.palette[12].g := (85).to_natural_8
			html_r_inst.palette[12].b := (255).to_natural_8
			html_r_inst.palette[12].pad := (0).to_natural_8
			html_r_inst.palette[13].r := (255).to_natural_8
			html_r_inst.palette[13].g := (85).to_natural_8
			html_r_inst.palette[13].b := (255).to_natural_8
			html_r_inst.palette[13].pad := (0).to_natural_8
		end

end
