frozen class
	LINKS_INITIALIZER_SLICE46

inherit
	LINKS_DATA
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {LINKS_INITIALIZER}

	initialize
		do
			language_inst.translation_danish[120].code := 120
			language_inst.translation_danish[120].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Venter i k%/248/"))
			language_inst.translation_danish[121].code := 121
			language_inst.translation_danish[121].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Lokaliserer v%/230/rt"))
			language_inst.translation_danish[122].code := 122
			language_inst.translation_danish[122].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Forbinder"))
			language_inst.translation_danish[123].code := 123
			language_inst.translation_danish[123].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("SSL forhandling"))
			language_inst.translation_danish[124].code := 124
			language_inst.translation_danish[124].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Foresp%/248/rgsel sent"))
			language_inst.translation_danish[125].code := 125
			language_inst.translation_danish[125].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Logger p%/229/"))
			language_inst.translation_danish[126].code := 126
			language_inst.translation_danish[126].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Henter dokumenthoved"))
			language_inst.translation_danish[127].code := 127
			language_inst.translation_danish[127].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Serveren behandler foresp%/248/rgsel"))
			language_inst.translation_danish[128].code := 128
			language_inst.translation_danish[128].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Overf%/248/rer"))
			language_inst.translation_danish[129].code := 129
			language_inst.translation_danish[129].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Venter p%/229/ bekr%/230/ftelse p%/229/ omdirigering"))
			language_inst.translation_danish[130].code := 130
			language_inst.translation_danish[130].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Afbrudt"))
			language_inst.translation_danish[131].code := 131
			language_inst.translation_danish[131].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Sokkelfejl"))
			language_inst.translation_danish[132].code := 132
			language_inst.translation_danish[132].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Intern fejl"))
			language_inst.translation_danish[133].code := 133
			language_inst.translation_danish[133].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Hukommelse opbrugt"))
			language_inst.translation_danish[134].code := 134
			language_inst.translation_danish[134].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("V%/230/rtsmaskinen kan ikke lokaliseres"))
			language_inst.translation_danish[135].code := 135
			language_inst.translation_danish[135].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Fejl ved skrivning til sokkel"))
			language_inst.translation_danish[136].code := 136
			language_inst.translation_danish[136].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Fejl ved l%/230/sning fra sokkel"))
			language_inst.translation_danish[137].code := 137
			language_inst.translation_danish[137].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Data %/230/ndret"))
			language_inst.translation_danish[138].code := 138
			language_inst.translation_danish[138].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Fejl i URL-syntaks"))
			language_inst.translation_danish[139].code := 139
			language_inst.translation_danish[139].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ventetid udl%/248/bet for overf%/248/rsel"))
			language_inst.translation_danish[140].code := 140
			language_inst.translation_danish[140].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Foresp%/248/rgsel skal genstartes"))
			language_inst.translation_danish[141].code := 141
			language_inst.translation_danish[141].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Kan ikke afl%/230/se sokkeltilstand"))
			language_inst.translation_danish[142].code := 142
			language_inst.translation_danish[142].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_danish[143].code := 143
			language_inst.translation_danish[143].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Fejl i HTTP-svar"))
			language_inst.translation_danish[144].code := 144
			language_inst.translation_danish[144].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("HTTP 100 (???)"))
			language_inst.translation_danish[145].code := 145
			language_inst.translation_danish[145].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Intet indhold"))
			language_inst.translation_danish[146].code := 146
			language_inst.translation_danish[146].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ukendt filtype"))
			language_inst.translation_danish[147].code := 147
			language_inst.translation_danish[147].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Fejl ved %/229/bning af fil"))
			language_inst.translation_danish[148].code := 148
			language_inst.translation_danish[148].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Fejl i FTP-svar"))
			language_inst.translation_danish[149].code := 149
			language_inst.translation_danish[149].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("FTP-tjeneste ikke tilg%/230/ngelig"))
			language_inst.translation_danish[150].code := 150
			language_inst.translation_danish[150].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Fejlagtig FTP-indlogning"))
			language_inst.translation_danish[151].code := 151
			language_inst.translation_danish[151].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("FTP PORT kommando mislykkedes"))
			language_inst.translation_danish[152].code := 152
			language_inst.translation_danish[152].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Filen findes ikke"))
			language_inst.translation_danish[153].code := 153
			language_inst.translation_danish[153].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("FTP filfejl"))
			language_inst.translation_danish[154].code := 154
			language_inst.translation_danish[154].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ukendt fejl"))
			language_inst.translation_danish[155].code := 155
			language_inst.translation_danish[155].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Modtog"))
			language_inst.translation_danish[156].code := 156
			language_inst.translation_danish[156].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("af"))
			language_inst.translation_danish[157].code := 157
			language_inst.translation_danish[157].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("gennemsnitlig"))
			language_inst.translation_danish[158].code := 158
			language_inst.translation_danish[158].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("nuv%/230/rende"))
			language_inst.translation_danish[159].code := 159
			language_inst.translation_danish[159].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Gennemsnitlig hastighed"))
			language_inst.translation_danish[160].code := 160
			language_inst.translation_danish[160].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Hastighed"))
			language_inst.translation_danish[161].code := 161
			language_inst.translation_danish[161].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("nuv%/230/rende hastighed"))
			language_inst.translation_danish[162].code := 162
			language_inst.translation_danish[162].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Forl%/248/bet tid"))
			language_inst.translation_danish[163].code := 163
			language_inst.translation_danish[163].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("beregnet tid"))
			language_inst.translation_danish[164].code := 164
			language_inst.translation_danish[164].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Baggrund"))
			language_inst.translation_danish[165].code := 165
			language_inst.translation_danish[165].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Afbryd"))
			language_inst.translation_danish[166].code := 166
			language_inst.translation_danish[166].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ja"))
			language_inst.translation_danish[167].code := 167
			language_inst.translation_danish[167].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Nej"))
			language_inst.translation_danish[168].code := 168
			language_inst.translation_danish[168].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Overf%/248/rselsfejl"))
			language_inst.translation_danish[169].code := 169
			language_inst.translation_danish[169].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Kunne ikke skrive til fil"))
			language_inst.translation_danish[170].code := 170
			language_inst.translation_danish[170].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Fejl ved overf%/248/rsel af"))
			language_inst.translation_danish[171].code := 171
			language_inst.translation_danish[171].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Kunne ikke oprette fil"))
			language_inst.translation_danish[172].code := 172
			language_inst.translation_danish[172].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_danish[173].code := 173
			language_inst.translation_danish[173].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ukendt type"))
			language_inst.translation_danish[174].code := 174
			language_inst.translation_danish[174].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Indholdstype er"))
			language_inst.translation_danish[175].code := 175
			language_inst.translation_danish[175].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Vil du gemme eller vise filen?"))
			language_inst.translation_danish[176].code := 176
			language_inst.translation_danish[176].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Gem"))
			language_inst.translation_danish[177].code := 177
			language_inst.translation_danish[177].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Vis"))
			language_inst.translation_danish[178].code := 178
			language_inst.translation_danish[178].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Hvad skaljeg g%/248/re?"))
			language_inst.translation_danish[179].code := 179
			language_inst.translation_danish[179].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Vil du %/229/bne filen med"))
			language_inst.translation_danish[180].code := 180
			language_inst.translation_danish[180].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("gemme den, eller vise den?"))
			language_inst.translation_danish[181].code := 181
			language_inst.translation_danish[181].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/197/ben"))
			language_inst.translation_danish[182].code := 182
			language_inst.translation_danish[182].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Vil du f%/248/lge omdirigering og sende formulardata til URL"))
			language_inst.translation_danish[183].code := 183
			language_inst.translation_danish[183].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Vil du sende formulardata til URL"))
			language_inst.translation_danish[184].code := 184
			language_inst.translation_danish[184].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Vil du sende formulardata til URL igen"))
			language_inst.translation_danish[185].code := 185
			language_inst.translation_danish[185].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Advarsel"))
			language_inst.translation_danish[186].code := 186
			language_inst.translation_danish[186].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Fejl"))
			language_inst.translation_danish[187].code := 187
			language_inst.translation_danish[187].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Velkommen"))
			language_inst.translation_danish[188].code := 188
			language_inst.translation_danish[188].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Velkommen til links!"))
			language_inst.translation_danish[189].code := 189
			language_inst.translation_danish[189].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Tryk ESC for menu. V%/230/lg Hj%/230/lp->Brugervejledning for mere vejledning"))
			language_inst.translation_danish[190].code := 190
			language_inst.translation_danish[190].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("M%/230/rkat"))
			language_inst.translation_danish[191].code := 191
			language_inst.translation_danish[191].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Indholdstyper"))
			language_inst.translation_danish[192].code := 192
			language_inst.translation_danish[192].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Program (%'%%%' erstattes med filnavn)"))
			language_inst.translation_danish[193].code := 193
			language_inst.translation_danish[193].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Bloker terminalen mens programmet k%/248/rer"))
			language_inst.translation_danish[194].code := 194
			language_inst.translation_danish[194].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("K%/248/r i terminal"))
			language_inst.translation_danish[195].code := 195
			language_inst.translation_danish[195].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("K%/248/r i X-vindue"))
			language_inst.translation_danish[196].code := 196
			language_inst.translation_danish[196].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Sp%/248/rg f%/248/r der %/229/bnes"))
			language_inst.translation_danish[197].code := 197
			language_inst.translation_danish[197].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Slet association"))
			language_inst.translation_danish[198].code := 198
			language_inst.translation_danish[198].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Association"))
			language_inst.translation_danish[199].code := 199
			language_inst.translation_danish[199].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Filendelser"))
			language_inst.translation_danish[200].code := 200
			language_inst.translation_danish[200].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Indeholdtype"))
			language_inst.translation_danish[201].code := 201
			language_inst.translation_danish[201].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ingen associationer"))
			language_inst.translation_danish[202].code := 202
			language_inst.translation_danish[202].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Slet filendelse"))
			language_inst.translation_danish[203].code := 203
			language_inst.translation_danish[203].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Filendelse"))
			language_inst.translation_danish[204].code := 204
			language_inst.translation_danish[204].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ingen filendelser"))
			language_inst.translation_danish[205].code := 205
			language_inst.translation_danish[205].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Fejl under afsendelse af formular"))
			language_inst.translation_danish[206].code := 206
			language_inst.translation_danish[206].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Kunne ikke hente fil"))
			language_inst.translation_danish[207].code := 207
			language_inst.translation_danish[207].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ingen tidligere s%/248/gning"))
			language_inst.translation_danish[208].code := 208
			language_inst.translation_danish[208].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S%/248/gningen gav intet resultat"))
			language_inst.translation_danish[209].code := 209
			language_inst.translation_danish[209].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Fejl ved skrivning"))
			language_inst.translation_danish[210].code := 210
			language_inst.translation_danish[210].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Fejl ved skrivning til fil"))
			language_inst.translation_danish[211].code := 211
			language_inst.translation_danish[211].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Vis usemap"))
			language_inst.translation_danish[212].code := 212
			language_inst.translation_danish[212].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F%/248/lg l%/230/nke"))
			language_inst.translation_danish[213].code := 213
			language_inst.translation_danish[213].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/197/ben i nyt vindue"))
			language_inst.translation_danish[214].code := 214
			language_inst.translation_danish[214].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Hent l%/230/nke"))
			language_inst.translation_danish[215].code := 215
			language_inst.translation_danish[215].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Nulstil formular"))
			language_inst.translation_danish[216].code := 216
			language_inst.translation_danish[216].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Send formular"))
			language_inst.translation_danish[217].code := 217
			language_inst.translation_danish[217].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Send formular og %/229/ben i nyt vindue"))
			language_inst.translation_danish[218].code := 218
			language_inst.translation_danish[218].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Send formular og overf%/248/r fil"))
			language_inst.translation_danish[219].code := 219
			language_inst.translation_danish[219].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Vis billede"))
			language_inst.translation_danish[220].code := 220
			language_inst.translation_danish[220].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Hent billede"))
			language_inst.translation_danish[221].code := 221
			language_inst.translation_danish[221].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ingen l%/230/nker valgt"))
			language_inst.translation_danish[222].code := 222
			language_inst.translation_danish[222].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Billede"))
			language_inst.translation_danish[223].code := 223
			language_inst.translation_danish[223].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Usemap"))
			language_inst.translation_danish[224].code := 224
			language_inst.translation_danish[224].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Send formular til"))
			language_inst.translation_danish[225].code := 225
			language_inst.translation_danish[225].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Send formular til"))
			language_inst.translation_danish[226].code := 226
			language_inst.translation_danish[226].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Radioknap"))
			language_inst.translation_danish[227].code := 227
			language_inst.translation_danish[227].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Afkrysningsboks"))
			language_inst.translation_danish[228].code := 228
			language_inst.translation_danish[228].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("V%/230/lg felt"))
			language_inst.translation_danish[229].code := 229
			language_inst.translation_danish[229].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Tekstfelt"))
			language_inst.translation_danish[230].code := 230
			language_inst.translation_danish[230].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Tekstomr%/229/de"))
			language_inst.translation_danish[231].code := 231
			language_inst.translation_danish[231].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Filopl%/230/sning"))
			language_inst.translation_danish[232].code := 232
			language_inst.translation_danish[232].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Adgangskodefelt"))
			language_inst.translation_danish[233].code := 233
			language_inst.translation_danish[233].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Navn"))
			language_inst.translation_danish[234].code := 234
			language_inst.translation_danish[234].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("V%/230/rdi"))
			language_inst.translation_danish[235].code := 235
			language_inst.translation_danish[235].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("tryk [Linieskift] for at"))
			language_inst.translation_danish[236].code := 236
			language_inst.translation_danish[236].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("send til"))
			language_inst.translation_danish[237].code := 237
			language_inst.translation_danish[237].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("send til"))
			language_inst.translation_danish[238].code := 238
			language_inst.translation_danish[238].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Info"))
			language_inst.translation_danish[239].code := 239
			language_inst.translation_danish[239].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Info om sidehoved"))
			language_inst.translation_danish[240].code := 240
			language_inst.translation_danish[240].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Du er ingen steder!"))
			language_inst.translation_danish[241].code := 241
			language_inst.translation_danish[241].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("URL"))
			language_inst.translation_danish[242].code := 242
			language_inst.translation_danish[242].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("St%/248/rrelse"))
			language_inst.translation_danish[243].code := 243
			language_inst.translation_danish[243].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ufuldst%/230/ndig"))
			language_inst.translation_danish[244].code := 244
			language_inst.translation_danish[244].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("tegnops%/230/tning"))
			language_inst.translation_danish[245].code := 245
			language_inst.translation_danish[245].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("antaget"))
			language_inst.translation_danish[246].code := 246
			language_inst.translation_danish[246].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ignorer serverindstilling"))
			language_inst.translation_danish[247].code := 247
			language_inst.translation_danish[247].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Server"))
			language_inst.translation_danish[248].code := 248
			language_inst.translation_danish[248].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Dato"))
			language_inst.translation_danish[249].code := 249
			language_inst.translation_danish[249].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Sidst opdateret"))
			language_inst.translation_danish[250].code := 250
			language_inst.translation_danish[250].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Sprog"))
			language_inst.translation_danish[251].code := 251
			language_inst.translation_danish[251].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Xterm"))
			language_inst.translation_danish[252].code := 252
			language_inst.translation_danish[252].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Twterm"))
			language_inst.translation_danish[253].code := 253
			language_inst.translation_danish[253].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Sk%/230/rm"))
			language_inst.translation_danish[254].code := 254
			language_inst.translation_danish[254].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Vindue"))
			language_inst.translation_danish[255].code := 255
			language_inst.translation_danish[255].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Maximer sk%/230/rm"))
			language_inst.translation_danish[256].code := 256
			language_inst.translation_danish[256].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("BeOS-terminal"))
			language_inst.translation_danish[257].code := 257
			language_inst.translation_danish[257].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Nyt vindue"))
			language_inst.translation_danish[258].code := 258
			language_inst.translation_danish[258].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("G%/229/ til l%/230/nke"))
			language_inst.translation_danish[259].code := 259
			language_inst.translation_danish[259].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Skriv nummer p%/229/ l%/230/nke"))
			language_inst.translation_danish[260].code := 260
			language_inst.translation_danish[260].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/198/ndre terminalst%/248/rrelse"))
			language_inst.translation_danish[261].code := 261
			language_inst.translation_danish[261].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S%/248/jler"))
			language_inst.translation_danish[262].code := 262
			language_inst.translation_danish[262].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("R%/230/kker"))
			language_inst.translation_danish[263].code := 263
			language_inst.translation_danish[263].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Bogm%/230/rke"))
			language_inst.translation_danish[264].code := 264
			language_inst.translation_danish[264].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Tilf%/248/j bogm%/230/rke"))
			language_inst.translation_danish[265].code := 265
			language_inst.translation_danish[265].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("G%/229/ til"))
			language_inst.translation_danish[266].code := 266
			language_inst.translation_danish[266].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Rediger"))
			language_inst.translation_danish[267].code := 267
			language_inst.translation_danish[267].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Luk"))
			language_inst.translation_danish[268].code := 268
			language_inst.translation_danish[268].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Titel p%/229/ bogm%/230/rke"))
			language_inst.translation_danish[269].code := 269
			language_inst.translation_danish[269].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Rediger bogm%/230/rke"))
			language_inst.translation_danish[270].code := 270
			language_inst.translation_danish[270].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Slet bokm%/230/rke"))
			language_inst.translation_danish[271].code := 271
			language_inst.translation_danish[271].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Bogm%/230/rkeh%/229/ndtering"))
			language_inst.translation_danish[272].code := 272
			language_inst.translation_danish[272].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url"))
			language_inst.translation_danish[273].code := 273
			language_inst.translation_danish[273].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Navn"))
			language_inst.translation_danish[274].code := 274
			language_inst.translation_danish[274].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Afslut links"))
			language_inst.translation_danish[275].code := 275
			language_inst.translation_danish[275].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Vil du virkelig afslutte links?"))
			language_inst.translation_danish[276].code := 276
			language_inst.translation_danish[276].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Vil du virkelig afslutte links og afbryde alle filoverf%/248/rsler?"))
			language_inst.translation_danish[277].code := 277
			language_inst.translation_danish[277].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("HTTP-indstillinger"))
			language_inst.translation_danish[278].code := 278
			language_inst.translation_danish[278].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("FTP-indstillinger"))
			language_inst.translation_danish[279].code := 279
			language_inst.translation_danish[279].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Korrigering af HTTP-fejl"))
			language_inst.translation_danish[280].code := 280
			language_inst.translation_danish[280].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Anvend HTTP/1.0"))
			language_inst.translation_danish[281].code := 281
			language_inst.translation_danish[281].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Tillad frasortering af fejlbeh%/230/ftede servere"))
			language_inst.translation_danish[282].code := 282
			language_inst.translation_danish[282].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Fejl ved omdirigering 302 (overtr%/230/der RFC, men er kompatibel med Netscape)"))
			language_inst.translation_danish[283].code := 283
			language_inst.translation_danish[283].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Afbryd forbindelsen efter POST-foresp%/248/rgsler (n%/248/dvendig for visse fejlbeh%/230/ftede PHP-databaser)"))
			language_inst.translation_danish[284].code := 284
			language_inst.translation_danish[284].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_danish[285].code := 285
			language_inst.translation_danish[285].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Adgangskode for anonym indlogning"))
			language_inst.translation_danish[286].code := 286
			language_inst.translation_danish[286].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_danish[287].code := 287
			language_inst.translation_danish[287].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_danish[288].code := 288
			language_inst.translation_danish[288].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_danish[289].code := 289
			language_inst.translation_danish[289].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Brugervejledning"))
			language_inst.translation_danish[290].code := 290
			language_inst.translation_danish[290].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Epostprogram (%% erstattes med adresse)"))
			language_inst.translation_danish[291].code := 291
			language_inst.translation_danish[291].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Program til fjernlogin (%% erstattes med %"v%/230/rt%" eller %"v%/230/rt port%")"))
			language_inst.translation_danish[292].code := 292
			language_inst.translation_danish[292].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Tn3270-program (%% erstattes med %"v%/230/rt%" eller %"v%/230/rt port%")"))
			language_inst.translation_danish[293].code := 293
			language_inst.translation_danish[293].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_danish[294].code := 294
			language_inst.translation_danish[294].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Program til epost og fjernlogin"))
			language_inst.translation_danish[295].code := 295
			language_inst.translation_danish[295].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Intet program"))
			language_inst.translation_danish[296].code := 296
			language_inst.translation_danish[296].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Intet program angivet for"))
			language_inst.translation_danish[297].code := 297
			language_inst.translation_danish[297].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("epost"))
			language_inst.translation_danish[298].code := 298
			language_inst.translation_danish[298].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("telnet"))
			language_inst.translation_danish[299].code := 299
			language_inst.translation_danish[299].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("tn3270"))
			language_inst.translation_danish[300].code := 300
			language_inst.translation_danish[300].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_danish[301].code := 301
			language_inst.translation_danish[301].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Fejl i mailto URL"))
			language_inst.translation_danish[302].code := 302
			language_inst.translation_danish[302].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Fejl i telnet URL"))
			language_inst.translation_danish[303].code := 303
			language_inst.translation_danish[303].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Fejl i tn3270 URL"))
			language_inst.translation_danish[304].code := 304
			language_inst.translation_danish[304].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_danish[305].code := 305
			language_inst.translation_danish[305].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Brugernavn"))
			language_inst.translation_danish[306].code := 306
			language_inst.translation_danish[306].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Adgangskode"))
			language_inst.translation_danish[307].code := 307
			language_inst.translation_danish[307].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Indtast brugernavn og adgangskode for "))
			language_inst.translation_danish[308].code := 308
			language_inst.translation_danish[308].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" p%/229/ "))
			language_inst.translation_danish[309].code := 309
			language_inst.translation_danish[309].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("SSL-fejl"))
			language_inst.translation_danish[310].code := 310
			language_inst.translation_danish[310].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Denne version af Links underst%/248/tter ikke SSL/TLS"))
			language_inst.translation_danish[311].code := 311
			language_inst.translation_danish[311].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_danish[312].code := 312
			language_inst.translation_danish[312].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("A"))
			language_inst.translation_danish[313].code := 313
			language_inst.translation_danish[313].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S"))
			language_inst.translation_danish[314].code := 314
			language_inst.translation_danish[314].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("G"))
			language_inst.translation_danish[315].code := 315
			language_inst.translation_danish[315].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("B"))
			language_inst.translation_danish[316].code := 316
			language_inst.translation_danish[316].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("H"))
			language_inst.translation_danish[317].code := 317
			language_inst.translation_danish[317].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("R"))
			language_inst.translation_danish[318].code := 318
			language_inst.translation_danish[318].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("V"))
			language_inst.translation_danish[319].code := 319
			language_inst.translation_danish[319].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("U"))
			language_inst.translation_danish[320].code := 320
			language_inst.translation_danish[320].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("D"))
			language_inst.translation_danish[321].code := 321
			language_inst.translation_danish[321].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("K"))
			language_inst.translation_danish[322].code := 322
			language_inst.translation_danish[322].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F"))
			language_inst.translation_danish[323].code := 323
			language_inst.translation_danish[323].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("I"))
			language_inst.translation_danish[324].code := 324
			language_inst.translation_danish[324].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("C"))
			language_inst.translation_danish[325].code := 325
			language_inst.translation_danish[325].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("M"))
			language_inst.translation_danish[326].code := 326
			language_inst.translation_danish[326].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("M"))
			language_inst.translation_danish[327].code := 327
			language_inst.translation_danish[327].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("O"))
			language_inst.translation_danish[328].code := 328
			language_inst.translation_danish[328].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("T"))
			language_inst.translation_danish[329].code := 329
			language_inst.translation_danish[329].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("X"))
			language_inst.translation_danish[330].code := 330
			language_inst.translation_danish[330].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S"))
			language_inst.translation_danish[331].code := 331
			language_inst.translation_danish[331].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("B"))
			language_inst.translation_danish[332].code := 332
			language_inst.translation_danish[332].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("N"))
			language_inst.translation_danish[333].code := 333
			language_inst.translation_danish[333].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("P"))
			language_inst.translation_danish[334].code := 334
			language_inst.translation_danish[334].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("H"))
			language_inst.translation_danish[335].code := 335
			language_inst.translation_danish[335].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("I"))
			language_inst.translation_danish[336].code := 336
			language_inst.translation_danish[336].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_danish[337].code := 337
			language_inst.translation_danish[337].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F"))
			language_inst.translation_danish[338].code := 338
			language_inst.translation_danish[338].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("O"))
			language_inst.translation_danish[339].code := 339
			language_inst.translation_danish[339].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("A"))
			language_inst.translation_danish[340].code := 340
			language_inst.translation_danish[340].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("A"))
			language_inst.translation_danish[341].code := 341
			language_inst.translation_danish[341].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("K"))
			language_inst.translation_danish[342].code := 342
			language_inst.translation_danish[342].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("C"))
			language_inst.translation_danish[343].code := 343
			language_inst.translation_danish[343].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("M"))
			language_inst.translation_danish[344].code := 344
			language_inst.translation_danish[344].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("A"))
			language_inst.translation_danish[345].code := 345
			language_inst.translation_danish[345].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("M"))
			language_inst.translation_danish[346].code := 346
			language_inst.translation_danish[346].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("D"))
			language_inst.translation_danish[347].code := 347
			language_inst.translation_danish[347].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("L"))
			language_inst.translation_danish[348].code := 348
			language_inst.translation_danish[348].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("H"))
			language_inst.translation_danish[349].code := 349
			language_inst.translation_danish[349].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("T"))
			language_inst.translation_danish[350].code := 350
			language_inst.translation_danish[350].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("N"))
			language_inst.translation_danish[351].code := 351
			language_inst.translation_danish[351].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("C"))
			language_inst.translation_danish[352].code := 352
			language_inst.translation_danish[352].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("A"))
			language_inst.translation_danish[353].code := 353
			language_inst.translation_danish[353].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E"))
			language_inst.translation_danish[354].code := 354
			language_inst.translation_danish[354].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S"))
			language_inst.translation_danish[355].code := 355
			language_inst.translation_danish[355].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F"))
			language_inst.translation_danish[356].code := 356
			language_inst.translation_danish[356].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("V"))
			language_inst.translation_danish[357].code := 357
			language_inst.translation_danish[357].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("L"))
			language_inst.translation_danish[358].code := 358
			language_inst.translation_danish[358].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("D"))
			language_inst.translation_danish[359].code := 359
			language_inst.translation_danish[359].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S"))
			language_inst.translation_danish[360].code := 360
			language_inst.translation_danish[360].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("H"))
			language_inst.translation_danish[361].code := 361
			language_inst.translation_danish[361].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("U"))
			language_inst.translation_danish[362].code := 362
			language_inst.translation_danish[362].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F"))
			language_inst.translation_danish[363].code := 363
			language_inst.translation_danish[363].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("W"))
			language_inst.translation_danish[364].code := 364
			language_inst.translation_danish[364].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("D"))
			language_inst.translation_danish[365].code := 365
			language_inst.translation_danish[365].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("R"))
			language_inst.translation_danish[366].code := 366
			language_inst.translation_danish[366].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S"))
			language_inst.translation_danish[367].code := 367
			language_inst.translation_danish[367].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("W"))
			language_inst.translation_danish[368].code := 368
			language_inst.translation_danish[368].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("D"))
			language_inst.translation_danish[369].code := 369
			language_inst.translation_danish[369].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("I"))
		end

end
