class
	LINKS_ASSEMBLER

feature {NONE}

	asm1 (op1: CE_POINTER [INTEGER_32]; op2: CE_POINTER [INTEGER_32]; op3: CE_POINTER [SD_FD_SET])
		do
			c_asm1 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm1 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <links.h>"
		alias
			"[
				int __d0 = *(int *)$op1;
				int __d1 = *(int *)$op2;
				fd_set dummy = *(fd_set *)$op3;

				__asm__ volatile ("cld; rep; stosl"
						: "=c" (__d0), "=D" (__d1)
						: "a" (0), "0" (sizeof(struct __anonstruct_fd_set_14) / sizeof(long)), "1" (&dummy.fds_bits[0])
						: "memory"
					);

				*(int *)$op1 = __d0;
				*(int *)$op2 = __d1;
				*(fd_set *)$op3 = dummy;
			]"
		end

	asm2 (op1: CE_POINTER [INTEGER_32]; op2: CE_POINTER [INTEGER_32]; op3: CE_POINTER [SD_FD_SET])
		do
			c_asm2 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm2 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <links.h>"
		alias
			"[
				int __d0 = *(int *)$op1;
				int __d1 = *(int *)$op2;
				fd_set fds = *(fd_set *)$op3;

				__asm__ volatile ("cld; rep; stosl"
						: "=c" (__d0), "=D" (__d1)
						: "a" (0), "0" (sizeof(struct __anonstruct_fd_set_14) / sizeof(long)), "1" (&fds.fds_bits[0])
						: "memory"
					);

				*(int *)$op1 = __d0;
				*(int *)$op2 = __d1;
				*(fd_set *)$op3 = fds;
			]"
		end

	asm3 (op1: CE_POINTER [SD_FD_SET]; op2: CE_POINTER [INTEGER_32])
		do
			c_asm3 (op1.c_pointer, op2.c_pointer)
		end

	c_asm3 (op1: POINTER; op2: POINTER)
		external
			"C inline use <links.h>"
		alias
			"[
				fd_set fds = *(fd_set *)$op1;
				int fd = *(int *)$op2;

				__asm__ volatile ("btsl %1,%0"
						: "=m" (fds.fds_bits[(unsigned int)fd / (8u * sizeof(unsigned long))])
						: "r" ((unsigned int)fd % (8u * sizeof(unsigned long)))
						: "cc", "memory"
					);

				*(fd_set *)$op1 = fds;
				*(int *)$op2 = fd;
			]"
		end

	asm4 (op1: CE_POINTER [INTEGER_32]; op2: CE_POINTER [INTEGER_32]; op3: CE_POINTER [SD_FD_SET])
		do
			c_asm4 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm4 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <links.h>"
		alias
			"[
				int __d0 = *(int *)$op1;
				int __d1 = *(int *)$op2;
				fd_set fds = *(fd_set *)$op3;

				__asm__ volatile ("cld; rep; stosl"
						: "=c" (__d0), "=D" (__d1)
						: "a" (0), "0" (sizeof(struct __anonstruct_fd_set_14) / sizeof(long)), "1" (&fds.fds_bits[0])
						: "memory"
					);

				*(int *)$op1 = __d0;
				*(int *)$op2 = __d1;
				*(fd_set *)$op3 = fds;
			]"
		end

	asm5 (op1: CE_POINTER [SD_FD_SET]; op2: CE_POINTER [INTEGER_32])
		do
			c_asm5 (op1.c_pointer, op2.c_pointer)
		end

	c_asm5 (op1: POINTER; op2: POINTER)
		external
			"C inline use <links.h>"
		alias
			"[
				fd_set fds = *(fd_set *)$op1;
				int fd = *(int *)$op2;

				__asm__ volatile ("btsl %1,%0"
						: "=m" (fds.fds_bits[(unsigned int)fd / (8u * sizeof(unsigned long))])
						: "r" ((unsigned int)fd % (8u * sizeof(unsigned long)))
						: "cc", "memory"
					);

				*(fd_set *)$op1 = fds;
				*(int *)$op2 = fd;
			]"
		end

	asm6 (op1: CE_POINTER [SD_FD_SET]; op2: CE_POINTER [INTEGER_32])
		do
			c_asm6 (op1.c_pointer, op2.c_pointer)
		end

	c_asm6 (op1: POINTER; op2: POINTER)
		external
			"C inline use <links.h>"
		alias
			"[
				fd_set w_read = *(fd_set *)$op1;
				int fd = *(int *)$op2;

				__asm__ volatile ("btsl %1,%0"
						: "=m" (w_read.fds_bits[(unsigned int)fd / (8u * sizeof(unsigned long))])
						: "r" ((unsigned int)fd % (8u * sizeof(unsigned long)))
						: "cc", "memory"
					);

				*(fd_set *)$op1 = w_read;
				*(int *)$op2 = fd;
			]"
		end

	asm7 (op1: CE_POINTER [SD_FD_SET]; op2: CE_POINTER [INTEGER_32])
		do
			c_asm7 (op1.c_pointer, op2.c_pointer)
		end

	c_asm7 (op1: POINTER; op2: POINTER)
		external
			"C inline use <links.h>"
		alias
			"[
				fd_set w_read = *(fd_set *)$op1;
				int fd = *(int *)$op2;

				__asm__ volatile ("btrl %1,%0"
						: "=m" (w_read.fds_bits[(unsigned int)fd / (8u * sizeof(unsigned long))])
						: "r" ((unsigned int)fd % (8u * sizeof(unsigned long)))
						: "cc", "memory"
					);

				*(fd_set *)$op1 = w_read;
				*(int *)$op2 = fd;
			]"
		end

	asm8 (op1: CE_POINTER [SD_FD_SET]; op2: CE_POINTER [INTEGER_32])
		do
			c_asm8 (op1.c_pointer, op2.c_pointer)
		end

	c_asm8 (op1: POINTER; op2: POINTER)
		external
			"C inline use <links.h>"
		alias
			"[
				fd_set x_read = *(fd_set *)$op1;
				int fd = *(int *)$op2;

				__asm__ volatile ("btrl %1,%0"
						: "=m" (x_read.fds_bits[(unsigned int)fd / (8u * sizeof(unsigned long))])
						: "r" ((unsigned int)fd % (8u * sizeof(unsigned long)))
						: "cc", "memory"
					);

				*(fd_set *)$op1 = x_read;
				*(int *)$op2 = fd;
			]"
		end

	asm9 (op1: CE_POINTER [SD_FD_SET]; op2: CE_POINTER [INTEGER_32])
		do
			c_asm9 (op1.c_pointer, op2.c_pointer)
		end

	c_asm9 (op1: POINTER; op2: POINTER)
		external
			"C inline use <links.h>"
		alias
			"[
				fd_set w_write = *(fd_set *)$op1;
				int fd = *(int *)$op2;

				__asm__ volatile ("btsl %1,%0"
						: "=m" (w_write.fds_bits[(unsigned int)fd / (8u * sizeof(unsigned long))])
						: "r" ((unsigned int)fd % (8u * sizeof(unsigned long)))
						: "cc", "memory"
					);

				*(fd_set *)$op1 = w_write;
				*(int *)$op2 = fd;
			]"
		end

	asm10 (op1: CE_POINTER [SD_FD_SET]; op2: CE_POINTER [INTEGER_32])
		do
			c_asm10 (op1.c_pointer, op2.c_pointer)
		end

	c_asm10 (op1: POINTER; op2: POINTER)
		external
			"C inline use <links.h>"
		alias
			"[
				fd_set w_write = *(fd_set *)$op1;
				int fd = *(int *)$op2;

				__asm__ volatile ("btrl %1,%0"
						: "=m" (w_write.fds_bits[(unsigned int)fd / (8u * sizeof(unsigned long))])
						: "r" ((unsigned int)fd % (8u * sizeof(unsigned long)))
						: "cc", "memory"
					);

				*(fd_set *)$op1 = w_write;
				*(int *)$op2 = fd;
			]"
		end

	asm11 (op1: CE_POINTER [SD_FD_SET]; op2: CE_POINTER [INTEGER_32])
		do
			c_asm11 (op1.c_pointer, op2.c_pointer)
		end

	c_asm11 (op1: POINTER; op2: POINTER)
		external
			"C inline use <links.h>"
		alias
			"[
				fd_set x_write = *(fd_set *)$op1;
				int fd = *(int *)$op2;

				__asm__ volatile ("btrl %1,%0"
						: "=m" (x_write.fds_bits[(unsigned int)fd / (8u * sizeof(unsigned long))])
						: "r" ((unsigned int)fd % (8u * sizeof(unsigned long)))
						: "cc", "memory"
					);

				*(fd_set *)$op1 = x_write;
				*(int *)$op2 = fd;
			]"
		end

	asm12 (op1: CE_POINTER [SD_FD_SET]; op2: CE_POINTER [INTEGER_32])
		do
			c_asm12 (op1.c_pointer, op2.c_pointer)
		end

	c_asm12 (op1: POINTER; op2: POINTER)
		external
			"C inline use <links.h>"
		alias
			"[
				fd_set w_error = *(fd_set *)$op1;
				int fd = *(int *)$op2;

				__asm__ volatile ("btsl %1,%0"
						: "=m" (w_error.fds_bits[(unsigned int)fd / (8u * sizeof(unsigned long))])
						: "r" ((unsigned int)fd % (8u * sizeof(unsigned long)))
						: "cc", "memory"
					);

				*(fd_set *)$op1 = w_error;
				*(int *)$op2 = fd;
			]"
		end

	asm13 (op1: CE_POINTER [SD_FD_SET]; op2: CE_POINTER [INTEGER_32])
		do
			c_asm13 (op1.c_pointer, op2.c_pointer)
		end

	c_asm13 (op1: POINTER; op2: POINTER)
		external
			"C inline use <links.h>"
		alias
			"[
				fd_set w_error = *(fd_set *)$op1;
				int fd = *(int *)$op2;

				__asm__ volatile ("btrl %1,%0"
						: "=m" (w_error.fds_bits[(unsigned int)fd / (8u * sizeof(unsigned long))])
						: "r" ((unsigned int)fd % (8u * sizeof(unsigned long)))
						: "cc", "memory"
					);

				*(fd_set *)$op1 = w_error;
				*(int *)$op2 = fd;
			]"
		end

	asm14 (op1: CE_POINTER [SD_FD_SET]; op2: CE_POINTER [INTEGER_32])
		do
			c_asm14 (op1.c_pointer, op2.c_pointer)
		end

	c_asm14 (op1: POINTER; op2: POINTER)
		external
			"C inline use <links.h>"
		alias
			"[
				fd_set x_error = *(fd_set *)$op1;
				int fd = *(int *)$op2;

				__asm__ volatile ("btrl %1,%0"
						: "=m" (x_error.fds_bits[(unsigned int)fd / (8u * sizeof(unsigned long))])
						: "r" ((unsigned int)fd % (8u * sizeof(unsigned long)))
						: "cc", "memory"
					);

				*(fd_set *)$op1 = x_error;
				*(int *)$op2 = fd;
			]"
		end

	asm15 (op1: CE_POINTER [INTEGER_8]; op2: CE_POINTER [INTEGER_32]; op3: CE_POINTER [SD_FD_SET])
		do
			c_asm15 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm15 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <links.h>"
		alias
			"[
				register char __result = *(char *)$op1;
				int i = *(int *)$op2;
				fd_set w_read = *(fd_set *)$op3;

				__asm__ volatile ("btl %1,%2 ; setcb %b0"
						: "=q" (__result)
						: "r" ((unsigned int)i % (8u * sizeof(unsigned long))), "m" (w_read.fds_bits[(unsigned int)i / (8u * sizeof(unsigned long))])
						: "cc"
					);

				*(char *)$op1 = __result;
				*(int *)$op2 = i;
				*(fd_set *)$op3 = w_read;
			]"
		end

	asm16 (op1: CE_POINTER [INTEGER_8]; op2: CE_POINTER [INTEGER_32]; op3: CE_POINTER [SD_FD_SET])
		do
			c_asm16 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm16 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <links.h>"
		alias
			"[
				register char __result___0 = *(char *)$op1;
				int i = *(int *)$op2;
				fd_set w_write = *(fd_set *)$op3;

				__asm__ volatile ("btl %1,%2 ; setcb %b0"
						: "=q" (__result___0)
						: "r" ((unsigned int)i % (8u * sizeof(unsigned long))), "m" (w_write.fds_bits[(unsigned int)i / (8u * sizeof(unsigned long))])
						: "cc"
					);

				*(char *)$op1 = __result___0;
				*(int *)$op2 = i;
				*(fd_set *)$op3 = w_write;
			]"
		end

	asm17 (op1: CE_POINTER [INTEGER_8]; op2: CE_POINTER [INTEGER_32]; op3: CE_POINTER [SD_FD_SET])
		do
			c_asm17 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm17 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <links.h>"
		alias
			"[
				register char __result___1 = *(char *)$op1;
				int i = *(int *)$op2;
				fd_set w_error = *(fd_set *)$op3;

				__asm__ volatile ("btl %1,%2 ; setcb %b0"
						: "=q" (__result___1)
						: "r" ((unsigned int)i % (8u * sizeof(unsigned long))), "m" (w_error.fds_bits[(unsigned int)i / (8u * sizeof(unsigned long))])
						: "cc"
					);

				*(char *)$op1 = __result___1;
				*(int *)$op2 = i;
				*(fd_set *)$op3 = w_error;
			]"
		end

	asm18 (op1: CE_POINTER [INTEGER_32]; op2: CE_POINTER [INTEGER_32]; op3: CE_POINTER [SD_FD_SET])
		do
			c_asm18 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm18 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <links.h>"
		alias
			"[
				int __d0 = *(int *)$op1;
				int __d1 = *(int *)$op2;
				fd_set w_read = *(fd_set *)$op3;

				__asm__ volatile ("cld; rep; stosl"
						: "=c" (__d0), "=D" (__d1)
						: "a" (0), "0" (sizeof(struct __anonstruct_fd_set_14) / sizeof(long)), "1" (&w_read.fds_bits[0])
						: "memory"
					);

				*(int *)$op1 = __d0;
				*(int *)$op2 = __d1;
				*(fd_set *)$op3 = w_read;
			]"
		end

	asm19 (op1: CE_POINTER [INTEGER_32]; op2: CE_POINTER [INTEGER_32]; op3: CE_POINTER [SD_FD_SET])
		do
			c_asm19 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm19 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <links.h>"
		alias
			"[
				int __d0___0 = *(int *)$op1;
				int __d1___0 = *(int *)$op2;
				fd_set w_write = *(fd_set *)$op3;

				__asm__ volatile ("cld; rep; stosl"
						: "=c" (__d0___0), "=D" (__d1___0)
						: "a" (0), "0" (sizeof(struct __anonstruct_fd_set_14) / sizeof(long)), "1" (&w_write.fds_bits[0])
						: "memory"
					);

				*(int *)$op1 = __d0___0;
				*(int *)$op2 = __d1___0;
				*(fd_set *)$op3 = w_write;
			]"
		end

	asm20 (op1: CE_POINTER [INTEGER_32]; op2: CE_POINTER [INTEGER_32]; op3: CE_POINTER [SD_FD_SET])
		do
			c_asm20 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm20 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <links.h>"
		alias
			"[
				int __d0___1 = *(int *)$op1;
				int __d1___1 = *(int *)$op2;
				fd_set w_error = *(fd_set *)$op3;

				__asm__ volatile ("cld; rep; stosl"
						: "=c" (__d0___1), "=D" (__d1___1)
						: "a" (0), "0" (sizeof(struct __anonstruct_fd_set_14) / sizeof(long)), "1" (&w_error.fds_bits[0])
						: "memory"
					);

				*(int *)$op1 = __d0___1;
				*(int *)$op2 = __d1___1;
				*(fd_set *)$op3 = w_error;
			]"
		end

	asm21 (op1: CE_POINTER [INTEGER_8]; op2: CE_POINTER [INTEGER_32]; op3: CE_POINTER [SD_FD_SET])
		do
			c_asm21 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm21 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <links.h>"
		alias
			"[
				register char __result = *(char *)$op1;
				int i = *(int *)$op2;
				fd_set x_read = *(fd_set *)$op3;

				__asm__ volatile ("btl %1,%2 ; setcb %b0"
						: "=q" (__result)
						: "r" ((unsigned int)i % (8u * sizeof(unsigned long))), "m" (x_read.fds_bits[(unsigned int)i / (8u * sizeof(unsigned long))])
						: "cc"
					);

				*(char *)$op1 = __result;
				*(int *)$op2 = i;
				*(fd_set *)$op3 = x_read;
			]"
		end

	asm22 (op1: CE_POINTER [INTEGER_8]; op2: CE_POINTER [INTEGER_32]; op3: CE_POINTER [SD_FD_SET])
		do
			c_asm22 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm22 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <links.h>"
		alias
			"[
				register char __result___0 = *(char *)$op1;
				int i = *(int *)$op2;
				fd_set x_write = *(fd_set *)$op3;

				__asm__ volatile ("btl %1,%2 ; setcb %b0"
						: "=q" (__result___0)
						: "r" ((unsigned int)i % (8u * sizeof(unsigned long))), "m" (x_write.fds_bits[(unsigned int)i / (8u * sizeof(unsigned long))])
						: "cc"
					);

				*(char *)$op1 = __result___0;
				*(int *)$op2 = i;
				*(fd_set *)$op3 = x_write;
			]"
		end

	asm23 (op1: CE_POINTER [INTEGER_8]; op2: CE_POINTER [INTEGER_32]; op3: CE_POINTER [SD_FD_SET])
		do
			c_asm23 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm23 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <links.h>"
		alias
			"[
				register char __result___1 = *(char *)$op1;
				int i = *(int *)$op2;
				fd_set x_error = *(fd_set *)$op3;

				__asm__ volatile ("btl %1,%2 ; setcb %b0"
						: "=q" (__result___1)
						: "r" ((unsigned int)i % (8u * sizeof(unsigned long))), "m" (x_error.fds_bits[(unsigned int)i / (8u * sizeof(unsigned long))])
						: "cc"
					);

				*(char *)$op1 = __result___1;
				*(int *)$op2 = i;
				*(fd_set *)$op3 = x_error;
			]"
		end

end
