class
	P_BFU

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
		end

feature {ANY} -- attributes

	m_bar: NATURAL_8 assign set_m_bar
		do
			Result := m_bar_address[0]
		end

	set_m_bar (a_m_bar: NATURAL_8)
		do
			m_bar_address[0] := a_m_bar
		end

	m_bar_address: CE_POINTER [NATURAL_8]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Natural_8_bytes))
		end

feature {ANY} -- routines

	getml (a_args: TUPLE [a_p: CE_POINTER [ANY]]): CE_POINTER [PD_MEMORY_LIST]
		local
			l_ml: CE_POINTER [PD_MEMORY_LIST]
			l_ap: CE_VA_LIST
			l_n: INTEGER_32
			l_q: CE_POINTER [ANY]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_ml.make
			create l_q.make

			l_n := 0
			l_q.ce_gets (a_args.a_p)
			create l_ap.make (a_args, 2)
			from
			until
				not (not js.loop_left and then ((l_q).c_pointer /= default_pointer))
			loop
				if l_n = 2147483647 then
					from
					until
						False
					loop
						error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 11])
						kbd_inst.fatal_tty_exit
						exit (4)
					end
				end
				l_n := l_n + 1
				l_q.ce_gets ((create {CE_POINTER [ANY]}.make_cast (l_ap.pointer_item)))
			end
			if l_n.to_natural_32 > ({NATURAL_32} 2147483647 - {PD_MEMORY_LIST}.sizeof.to_natural_32) // Pointer_bytes.to_natural_32 then
				from
				until
					False
				loop
					error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 14])
					kbd_inst.fatal_tty_exit
					exit (4)
				end
			end
			l_ml.ce_gets (create {CE_POINTER [PD_MEMORY_LIST]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 15, {PD_MEMORY_LIST}.sizeof.to_natural_32 + l_n.to_natural_32 * Pointer_bytes.to_natural_32))))
			l_ml.item.n := l_n
			l_n := 0
			l_q.ce_gets (a_args.a_p)
			create l_ap.make (a_args, 2)
			from
			until
				(l_q).c_pointer = default_pointer
			loop
				l_tmp___0 := l_n
				l_n := l_n + 1
				l_ml.item.p[l_tmp___0] := l_q
				l_q.ce_gets ((create {CE_POINTER [ANY]}.make_cast (l_ap.pointer_item)))
			end
			Result := l_ml
		end

	add_to_ml (a_args: TUPLE [a_ml: CE_POINTER [CE_POINTER [PD_MEMORY_LIST]]])
		local
			l_nml: CE_POINTER [PD_MEMORY_LIST]
			l_ap: CE_VA_LIST
			l_n: INTEGER_32
			l_q: CE_POINTER [ANY]
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_nml.make
			create l_q.make

			l_n := 0
			if (a_args.a_ml.item).c_pointer = default_pointer then
				a_args.a_ml.item := create {CE_POINTER [PD_MEMORY_LIST]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 33, {PD_MEMORY_LIST}.sizeof.to_natural_32)));
				(a_args.a_ml.item).item.n := 0
			end
			create l_ap.make (a_args, 2)
			from
			until
				js.loop_left
			loop
				js.reset
				l_q.ce_gets ((create {CE_POINTER [ANY]}.make_cast (l_ap.pointer_item)))
				if (l_q).c_pointer = default_pointer then
					js.break
				end
				if not js.loop_jumped then
					if l_n = 2147483647 then
						from
						until
							False
						loop
							error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 38])
							kbd_inst.fatal_tty_exit
							exit (4)
						end
					end
					l_n := l_n + 1
				end
			end
			js.reset
			if l_n.to_natural_32 + ((a_args.a_ml.item).item.n).to_natural_32 > ({NATURAL_32} 2147483647 - {PD_MEMORY_LIST}.sizeof.to_natural_32) // Pointer_bytes.to_natural_32 then
				from
				until
					False
				loop
					error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 41])
					kbd_inst.fatal_tty_exit
					exit (4)
				end
			end
			l_nml.ce_gets (create {CE_POINTER [PD_MEMORY_LIST]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 42, create {CE_POINTER [ANY]}.make_cast (a_args.a_ml.item), {PD_MEMORY_LIST}.sizeof.to_natural_32 + (l_n + (a_args.a_ml.item).item.n).to_natural_32 * Pointer_bytes.to_natural_32))))
			create l_ap.make (a_args, 2)
			from
			until
				js.loop_left
			loop
				js.reset
				l_q.ce_gets ((create {CE_POINTER [ANY]}.make_cast (l_ap.pointer_item)))
				if (l_q).c_pointer = default_pointer then
					js.break
				end
				if not js.loop_jumped then
					l_tmp___1 := l_nml.item.n
					l_nml.item.n := (l_nml.item.n) + 1
					l_nml.item.p[l_tmp___1] := l_q
				end
			end
			js.reset
			a_args.a_ml.item := l_nml
		end

	freeml (a_ml: CE_POINTER [PD_MEMORY_LIST])
		local
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			if (a_ml).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				l_i := 0
				from
				until
					not (l_i < a_ml.item.n)
				loop
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 54, a_ml.item.p[l_i])
					l_i := l_i + 1
				end
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 55, create {CE_POINTER [ANY]}.make_cast (a_ml))
			end
		end

	freeml_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent freeml)
		end

	do_menu_selected (a_term: CE_POINTER [PD_TERMINAL]; a_items: CE_POINTER [PD_MENU_ITEM]; a_data: CE_POINTER [ANY]; a_selected: INTEGER_32)
		local
			l_menu: CE_POINTER [PD_MENU]
		do
			create l_menu.make

			l_menu.ce_gets (create {CE_POINTER [PD_MENU]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 67, {PD_MENU}.sizeof.to_natural_32))))
			l_menu.item.selected := a_selected
			l_menu.item.view := 0
			l_menu.item.items := a_items
			l_menu.item.data := a_data
			terminal_inst.add_window (a_term, menu_func_address, create {CE_POINTER [ANY]}.make_cast (l_menu))
		end

	do_menu (a_term: CE_POINTER [PD_TERMINAL]; a_items: CE_POINTER [PD_MENU_ITEM]; a_data: CE_POINTER [ANY])
		do
			do_menu_selected (a_term, a_items, a_data, 0)
		end

	do_menu_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent do_menu)
		end

	select_menu (a_term: CE_POINTER [PD_TERMINAL]; a_menu: CE_POINTER [PD_MENU])
		local
			l_it: CE_POINTER [PD_MENU_ITEM]
			l_func: CE_ROUTINE
			l_data1: CE_POINTER [ANY]
			l_data2: CE_POINTER [ANY]
			l_win: CE_POINTER [PD_WINDOW]
			l_win1: CE_POINTER [PD_WINDOW]
			js: JUMP_STATE
		do
			create l_it.make
			create l_func.make
			create l_data1.make
			create l_data2.make
			create l_win.make
			create l_win1.make

			l_it.ce_gets (a_menu.item.items + a_menu.item.selected)
			l_func.ce_gets (l_it.item.func)
			l_data1.ce_gets (l_it.item.data)
			l_data2.ce_gets (a_menu.item.data)
			if a_menu.item.selected < 0 then
				js.return
			elseif a_menu.item.selected >= a_menu.item.ni then
				js.return
			elseif ((l_it.item.hotkey).c_pointer.to_integer_32).to_natural_32 = ((m_bar_address).c_pointer.to_integer_32).to_natural_32 then
				js.return
			end
			if not js.return_called then
				if not (l_it.item.in_m).to_boolean then
					l_win.ce_gets (create {CE_POINTER [PD_WINDOW]}.make_cast (a_term.item.windows.next))
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_win.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_term.c_pointer + {PD_TERMINAL}.windows_offset)).c_pointer.to_integer_32).to_natural_32 then
							if ((l_win.item.handler).c_pointer.to_integer_32).to_natural_32 /= ((menu_func_address).c_pointer.to_integer_32).to_natural_32 then
								if ((l_win.item.handler).c_pointer.to_integer_32).to_natural_32 /= ((mainmenu_func_address).c_pointer.to_integer_32).to_natural_32 then
									js.break
								end
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_win1.ce_gets (l_win.item.next)
							terminal_inst.delete_window (l_win)
							l_win.ce_gets (l_win1)
						end
					end
					js.reset
				end
				l_func.call ([a_term, l_data1, l_data2])
			end
		end

	count_menu_size (a_term: CE_POINTER [PD_TERMINAL]; a_menu: CE_POINTER [PD_MENU])
		local
			l_sx: INTEGER_32
			l_sy: INTEGER_32
			l_mx: INTEGER_32
			l_my: INTEGER_32
			l_s: INTEGER_32
			l_tmp___0: NATURAL_32
			l_tmp___2: NATURAL_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
		do
			l_sx := a_term.item.x
			l_sy := a_term.item.y
			l_mx := 4
			l_my := 0
			from
			until
				((a_menu.item.items + l_my).item.text).c_pointer = default_pointer
			loop
				l_tmp___0 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((language_inst.get_text_translation ((a_menu.item.items + l_my).item.text, a_term))))
				l_tmp___2 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((language_inst.get_text_translation ((a_menu.item.items + l_my).item.rtext, a_term))))
				l_s := (((l_tmp___0 + l_tmp___2) + (2 * (((language_inst.get_text_translation ((a_menu.item.items + l_my).item.rtext, a_term))[0]).to_integer_32 /= 0).to_integer).to_natural_32) + {NATURAL_32} 4).to_integer_32
				if l_s > l_mx then
					l_mx := l_s
				end
				l_my := l_my + 1
			end
			a_menu.item.ni := l_my
			l_my := l_my + (2)
			if l_mx > l_sx then
				l_mx := l_sx
			end
			if l_my > l_sy then
				l_my := l_sy
			end
			a_menu.item.xw := l_mx
			a_menu.item.yw := l_my
			l_tmp___4 := a_menu.item.xp
			a_menu.item.x := l_tmp___4
			if l_tmp___4 < 0 then
				a_menu.item.x := 0
			end
			l_tmp___5 := a_menu.item.yp
			a_menu.item.y := l_tmp___5
			if l_tmp___5 < 0 then
				a_menu.item.y := 0
			end
			if a_menu.item.x + l_mx > l_sx then
				a_menu.item.x := l_sx - l_mx
			end
			if a_menu.item.y + l_my > l_sy then
				a_menu.item.y := l_sy - l_my
			end
		end

	scroll_menu (a_menu: CE_POINTER [PD_MENU]; a_d: INTEGER_32)
		local
			l_c: INTEGER_32
			l_w: INTEGER_32
			l_scr_i: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			l_c := 0
			l_w := a_menu.item.yw - 2
			if 2 > (l_w - 1) // 2 then
				l_tmp := (l_w - 1) // 2
			else
				l_tmp := 2
			end
			l_scr_i := l_tmp
			if l_scr_i < 0 then
				l_scr_i := 0
			end
			if l_w < 0 then
				l_w := 0
			end
			a_menu.item.selected := a_menu.item.selected + a_d
			from
			until
				js.loop_left
			loop
				js.reset
				l_tmp___0 := l_c
				l_c := l_c + 1
				if l_tmp___0 > a_menu.item.ni then
					a_menu.item.selected := -1
					a_menu.item.view := 0
					js.return
				end
				if not js.return_called then
					if a_menu.item.selected < 0 then
						a_menu.item.selected := 0
					end
					if a_menu.item.selected >= a_menu.item.ni then
						a_menu.item.selected := a_menu.item.ni - 1
					end
					if (a_menu.item.ni).to_boolean then
						if (((a_menu.item.items + a_menu.item.selected).item.hotkey).c_pointer.to_integer_32).to_natural_32 /= ((m_bar_address).c_pointer.to_integer_32).to_natural_32 then
							js.break
						end
					end
					if not js.loop_jumped then
						a_menu.item.selected := a_menu.item.selected + a_d
					end
				end
			end
			js.reset
			if not js.return_called then
				if a_menu.item.selected < a_menu.item.view + l_scr_i then
					a_menu.item.view := a_menu.item.selected - l_scr_i
				end
				if a_menu.item.selected >= ((a_menu.item.view + l_w) - l_scr_i) - 1 then
					a_menu.item.view := ((a_menu.item.selected - l_w) + l_scr_i) + 1
				end
				if a_menu.item.view > a_menu.item.ni - l_w then
					a_menu.item.view := a_menu.item.ni - l_w
				end
				if a_menu.item.view < 0 then
					a_menu.item.view := 0
				end
			end
		end

	display_menu (a_term: CE_POINTER [PD_TERMINAL]; a_menu: CE_POINTER [PD_MENU])
		local
			l_p: INTEGER_32
			l_s: INTEGER_32
			l_x: INTEGER_32
			l_h: INTEGER_32
			l_c: NATURAL_8
			l_tmptext: CE_POINTER [NATURAL_8]
			l_co: INTEGER_32
			l_tmp___0: INTEGER_32
			l_l: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: NATURAL_8
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_tmptext.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					terminal_inst.fill_area (a_term, a_menu.item.x + 1, a_menu.item.y + 1, a_menu.item.xw - 2, a_menu.item.yw - 2, {NATURAL_32} 14336)
					terminal_inst.draw_frame (a_term, a_menu.item.x, a_menu.item.y, a_menu.item.xw, a_menu.item.yw, {NATURAL_32} 14336, 1)
					l_p := a_menu.item.view
					l_s := a_menu.item.y + 1
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 15 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if l_p < a_menu.item.ni then
							if not (l_p < (a_menu.item.view + a_menu.item.yw) - 2) then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 14 -- skip if block
						end
				when 3 then -- if:
						l_h := 0
						l_tmptext.ce_gets ((language_inst.get_text_translation ((a_menu.item.items + l_p).item.text, a_term)))
						if l_p = a_menu.item.selected then
							l_h := 1
							l_tmp___0 := 1792
						else
							l_tmp___0 := 14336
						end
						l_co := l_tmp___0
						if l_h.to_boolean then
							terminal_inst.set_cursor (a_term, a_menu.item.x + 1, l_s, a_term.item.x - 1, a_term.item.y - 1)
							terminal_inst.set_window_ptr (a_menu.item.win, a_menu.item.x + a_menu.item.xw, l_s)
							terminal_inst.fill_area (a_term, a_menu.item.x + 1, l_s, a_menu.item.xw - 2, 1, l_co.to_natural_32)
						end
						if (((a_menu.item.items + l_p).item.hotkey).c_pointer.to_integer_32).to_natural_32 = ((m_bar_address).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if (l_tmptext).c_pointer = default_pointer then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
						if not ((l_tmptext[0]).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L:
						l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((language_inst.get_text_translation ((a_menu.item.items + l_p).item.rtext, a_term))))).to_integer_32
						l_x := l_l - 1
						from
						until
							js.loop_left
						loop
							js.reset
							if l_x >= 0 then
								if a_menu.item.xw - 4 >= l_l - l_x then
									l_c := (language_inst.get_text_translation ((a_menu.item.items + l_p).item.rtext, a_term))[l_x]
									if not l_c.to_boolean then
										js.break
									end
								else
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								terminal_inst.set_char (a_term, (((a_menu.item.x + a_menu.item.xw) - 2) - l_l) + l_x, l_s, ((l_c.to_integer_32).bit_or (l_co)).to_natural_32)
								l_x := l_x - 1
							end
						end
						js.reset
						l_x := 0
						from
						until
							js.loop_left
						loop
							js.reset
							if l_x < a_menu.item.xw - 4 then
								l_c := l_tmptext[l_x]
								if not l_c.to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								if not l_h.to_boolean then
									l_tmp___8 := links_inst.upcase (l_c)
									if (((strchr (create {CE_POINTER [INTEGER_8]}.make_cast ((language_inst.get_text_translation ((a_menu.item.items + l_p).item.hotkey, a_term))), l_tmp___8.to_integer_32))).c_pointer /= default_pointer) then
										l_h := 1
										l_tmp___7 := (1792).bit_or (l_c.to_integer_32)
									else
										l_tmp___7 := (l_co).bit_or (l_c.to_integer_32)
									end
								else
									l_tmp___7 := (l_co).bit_or (l_c.to_integer_32)
								end
								terminal_inst.set_char (a_term, (a_menu.item.x + l_x) + 2, l_s, l_tmp___7.to_natural_32)
								l_x := l_x + 1
							end
						end
						js.reset
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						terminal_inst.set_char (a_term, a_menu.item.x, l_s, {NATURAL_32} 47299)
						terminal_inst.fill_area (a_term, a_menu.item.x + 1, l_s, a_menu.item.xw - 2, 1, {NATURAL_32} 47300)
						terminal_inst.set_char (a_term, (a_menu.item.x + a_menu.item.xw) - 1, l_s, {NATURAL_32} 47284)
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						terminal_inst.set_char (a_term, a_menu.item.x, l_s, {NATURAL_32} 47299)
						terminal_inst.fill_area (a_term, a_menu.item.x + 1, l_s, a_menu.item.xw - 2, 1, {NATURAL_32} 47300)
						terminal_inst.set_char (a_term, (a_menu.item.x + a_menu.item.xw) - 1, l_s, {NATURAL_32} 47284)
				when 13 then -- if done
						l_p := l_p + 1
						l_s := l_s + 1
				when 14 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 15 then -- loop done
					js.reset
					terminal_inst.redraw_from_window (a_menu.item.win)
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	menu_func (a_win: CE_POINTER [PD_WINDOW]; a_ev: CE_POINTER [PD_EVENT]; a_fwd: INTEGER_32)
		local
			l_s: INTEGER_32
			l_menu: CE_POINTER [PD_MENU]
			l_w1: CE_POINTER [PD_WINDOW]
			l_m1: CE_POINTER [PD_MENU]
			l_s___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: CE_POINTER [PD_EVENT]
			l_i: INTEGER_32
			l_tmp___6: NATURAL_8
			l_i___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_menu.make
			create l_w1.make
			create l_m1.make
			create l_tmp___5.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := 0
					l_menu.ce_gets (create {CE_POINTER [PD_MENU]}.make_cast (a_win.item.data))
					l_menu.item.win := a_win
					inspect (a_ev.item.ev).to_integer_32 -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 4 then l_pos := -1 + 1
					when 3 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 1 then l_pos := -1 + 28
					when 5 then l_pos := -1 + 54
					else l_pos := -1 + 55
					end
				when 1 then -- switch 1, case 0 | switch 1, case 4 | switch 1, case 3
					terminal_inst.get_parent_ptr (a_win, create {CE_POINTER [INTEGER_32]}.make_shared (l_menu.c_pointer + {PD_MENU}.xp_offset), create {CE_POINTER [INTEGER_32]}.make_shared (l_menu.c_pointer + {PD_MENU}.yp_offset))
					count_menu_size (a_win.item.term, l_menu)
					l_menu.item.selected := (l_menu.item.selected) - 1
					scroll_menu (l_menu, 1)
					display_menu (a_win.item.term, l_menu)
					l_pos := -1 + 55 -- switch 1; break
				when 2 then -- switch 1, case 2
					if not (a_ev.item.x < (l_menu.item.x).to_integer_32) then
						l_pos := -1 + 5 -- skip if block
					end
				when 3 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 5 then -- else:
						if not (a_ev.item.x >= (l_menu.item.x + l_menu.item.xw).to_integer_32) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 8 then -- else:
						if not (a_ev.item.y < (l_menu.item.y).to_integer_32) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 11 then -- else:
						if not (a_ev.item.y >= (l_menu.item.y + l_menu.item.yw).to_integer_32) then
							l_pos := -1 + 26 -- skip if block
						end
				when 12 then -- if: | _L:
						if ((a_ev.item.b).bit_and (12)) /= 0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if: | del:
						terminal_inst.delete_window_ev (a_win, a_ev)
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 15 then -- else:
						l_w1.ce_gets (a_win)
				when 16 then -- loop condition:
						if not (not js.loop_left and then ((l_w1.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared ((a_win.item.term).c_pointer + {PD_TERMINAL}.windows_offset)).c_pointer.to_integer_32).to_natural_32)) then
							l_pos := -1 + 24 -- skip loop
						end
				when 17 then -- loop body:
						js.reset
						if ((l_w1.item.handler).c_pointer.to_integer_32).to_natural_32 /= ((mainmenu_func_address).c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						if not (a_ev.item.y).to_boolean then
							l_pos := -1 + 13 -- goto del
						end
				when 19 then
						js.break
				when 20 then -- if done
						if not js.loop_jumped and then (((l_w1.item.handler).c_pointer.to_integer_32).to_natural_32 /= ((menu_func_address).c_pointer.to_integer_32).to_natural_32) then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_m1.ce_gets (create {CE_POINTER [PD_MENU]}.make_cast (l_w1.item.data))
						if a_ev.item.x > (l_m1.item.x).to_integer_32 then
							if a_ev.item.x < ((l_m1.item.x + l_m1.item.xw) - 1).to_integer_32 then
								if a_ev.item.y > (l_m1.item.y).to_integer_32 then
									if a_ev.item.y < ((l_m1.item.y + l_m1.item.yw) - 1).to_integer_32 then
										l_pos := -1 + 13 -- goto del
									end
								end
							end
						end
				when 22 then
						l_w1.ce_gets (l_w1.item.next)
				when 23 then -- if done
						l_pos := -1 + 16 -- back to loop condition
				when 24 then -- loop done
						js.reset
				when 25 then -- if done | if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:
						if not (a_ev.item.x < (l_menu.item.x).to_integer_32) then
							if not (a_ev.item.x >= (l_menu.item.x + l_menu.item.xw).to_integer_32) then
								if not (a_ev.item.y < (l_menu.item.y + 1).to_integer_32) then
									if not (a_ev.item.y >= ((l_menu.item.y + l_menu.item.yw) - 1).to_integer_32) then
										l_s___0 := (((a_ev.item.y - (l_menu.item.y).to_integer_32) - 1) + (l_menu.item.view).to_integer_32).to_integer_32
										if l_s___0 >= 0 then
											if l_s___0 < l_menu.item.ni then
												if (((l_menu.item.items + l_s___0).item.hotkey).c_pointer.to_integer_32).to_natural_32 /= ((m_bar_address).c_pointer.to_integer_32).to_natural_32 then
													l_menu.item.selected := l_s___0
													scroll_menu (l_menu, 0)
													display_menu (a_win.item.term, l_menu)
													if ((a_ev.item.b).bit_and (12)) = 4 then
														select_menu (a_win.item.term, l_menu)
													end
												end
											end
										end
									end
								end
							end
						end
				when 27 then -- if done | if done | if done
						l_pos := -1 + 55 -- switch 1; break
				when 28 then -- switch 1, case 1
						inspect (kbdbind_inst.kbd_action (2, a_ev)) -- switch 2 head
						when 23 then l_pos := -1 + 29
						when 35 then l_pos := -1 + 29
						when 45 then l_pos := -1 + 32
						when 9 then l_pos := -1 + 33
						when 20 then l_pos := -1 + 34
						when 11 then l_pos := -1 + 35
						when 29 then l_pos := -1 + 36
						when 28 then l_pos := -1 + 37
						else l_pos := -1 + 38
						end
				when 29 then -- switch 2, case 23 | switch 2, case 35
						if ((a_win.item.next).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared ((a_win.item.term).c_pointer + {PD_TERMINAL}.windows_offset)).c_pointer.to_integer_32).to_natural_32 then
							if (((a_win.item.next).item.handler).c_pointer.to_integer_32).to_natural_32 = ((mainmenu_func_address).c_pointer.to_integer_32).to_natural_32 then
								l_pos := -1 + 42 -- goto mm
							end
						end
				when 30 then
						if (kbdbind_inst.kbd_action (2, a_ev)) = 35 then
							l_pos := -1 + 52 -- goto enter
						end
				when 31 then
						terminal_inst.delete_window (a_win)
						l_pos := -1 + 53 -- goto break2
				when 32 then -- switch 2, case 45
						scroll_menu (l_menu, -1)
						l_pos := -1 + 45 -- switch 2; break
				when 33 then -- switch 2, case 9
						scroll_menu (l_menu, 1)
						l_pos := -1 + 45 -- switch 2; break
				when 34 then -- switch 2, case 20
						l_menu.item.selected := -1
						scroll_menu (l_menu, 1)
						l_pos := -1 + 45 -- switch 2; break
				when 35 then -- switch 2, case 11
						l_menu.item.selected := l_menu.item.ni
						scroll_menu (l_menu, -1)
						l_pos := -1 + 45 -- switch 2; break
				when 36 then -- switch 2, case 29
						l_tmp___1 := l_menu.item.selected - (l_menu.item.yw - 3)
						l_menu.item.selected := l_tmp___1
						if l_tmp___1 < -1 then
							l_menu.item.selected := -1
						end
						l_tmp___2 := l_menu.item.view - (l_menu.item.yw - 2)
						l_menu.item.view := l_tmp___2
						if l_tmp___2 < 0 then
							l_menu.item.view := 0
						end
						scroll_menu (l_menu, -1)
						l_pos := -1 + 45 -- switch 2; break
				when 37 then -- switch 2, case 28
						l_tmp___3 := l_menu.item.selected + (l_menu.item.yw - 3)
						l_menu.item.selected := l_tmp___3
						if l_tmp___3 > l_menu.item.ni then
							l_menu.item.selected := l_menu.item.ni
						end
						l_tmp___4 := l_menu.item.view + (l_menu.item.yw - 2)
						l_menu.item.view := l_tmp___4
						if l_tmp___4 >= (l_menu.item.ni - l_menu.item.yw) + 2 then
							l_menu.item.view := (l_menu.item.ni - l_menu.item.yw) + 2
						end
						scroll_menu (l_menu, 1)
						l_pos := -1 + 45 -- switch 2; break
				when 38 then -- switch 2, default:
						if not (a_ev.item.x >= 288) then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if:
							if a_ev.item.x <= 299 then
								l_pos := -1 + 42 -- goto mm
							else
								l_pos := -1 + 41 -- goto _L___1
							end
				when 40 then -- if block done, skip else block:
							l_pos := -1 + 43
				when 41 then -- else: | _L___1:
							if a_ev.item.y /= 4 then
								l_pos := -1 + 43 -- skip if block
							end
				when 42 then -- if: | mm:
							terminal_inst.delete_window_ev (a_win, a_ev)
							l_pos := -1 + 53 -- goto break2
				when 43 then -- if done
							if a_ev.item.x = 259 then
								if ((a_win.item.next).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared ((a_win.item.term).c_pointer + {PD_TERMINAL}.windows_offset)).c_pointer.to_integer_32).to_natural_32 then
									if (((a_win.item.next).item.handler).c_pointer.to_integer_32).to_natural_32 = ((mainmenu_func_address).c_pointer.to_integer_32).to_natural_32 then
										l_tmp___5.ce_gets (a_ev)
									else
										l_tmp___5.ce_gets (create {CE_POINTER [PD_EVENT]}.make_shared (default_pointer))
									end
								else
									l_tmp___5.ce_gets (create {CE_POINTER [PD_EVENT]}.make_shared (default_pointer))
								end
								terminal_inst.delete_window_ev (a_win, l_tmp___5)
								l_pos := -1 + 53 -- goto break2
							end
				when 44 then
							if a_ev.item.x > 32 then
								if a_ev.item.x < 256 then
									l_i := 0
									from
									until
										not (l_i < l_menu.item.ni)
									loop
										l_tmp___6 := links_inst.upcase ((a_ev.item.x).to_natural_8)
										if (((strchr (create {CE_POINTER [INTEGER_8]}.make_cast ((language_inst.get_text_translation ((l_menu.item.items + l_i).item.hotkey, a_win.item.term))), l_tmp___6.to_integer_32))).c_pointer /= default_pointer) then
											l_menu.item.selected := l_i
											scroll_menu (l_menu, 0)
											l_s := 1
										end
										l_i := l_i + 1
									end
								end
							end
							l_pos := -1 + 45 -- switch 2; break
				when 45 then -- switch 2, done:
							display_menu (a_win.item.term, l_menu)
							if not (l_s.to_boolean) then
								l_pos := -1 + 48 -- skip if block
							end
				when 46 then -- if:
								l_pos := -1 + 52 -- goto enter
				when 47 then -- if block done, skip else block:
								l_pos := -1 + 53
				when 48 then -- else:
								if a_ev.item.x /= 256 then
									l_pos := -1 + 51 -- skip if block
								end
				when 49 then -- if:
								l_pos := -1 + 52 -- goto enter
				when 50 then -- if block done, skip else block:
								l_pos := -1 + 53
				when 51 then -- else:
								if a_ev.item.x /= 32 then
									l_pos := -1 + 53 -- skip if block
								end
				when 52 then -- if: | enter:
								select_menu (a_win.item.term, l_menu)
				when 53 then -- if done | if done | break2:
								l_pos := -1 + 55 -- switch 1; break
				when 54 then -- switch 1, case 5
								if ((l_menu.item.items).item.free_i).to_boolean then
									l_i___0 := 0
									from
									until
										((l_menu.item.items + l_i___0).item.text).c_pointer = default_pointer
									loop
										if (((l_menu.item.items + l_i___0).item.free_i).bit_and (2)).to_boolean then
											error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 279, create {CE_POINTER [ANY]}.make_cast ((l_menu.item.items + l_i___0).item.text))
										end
										if (((l_menu.item.items + l_i___0).item.free_i).bit_and (4)).to_boolean then
											error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 280, create {CE_POINTER [ANY]}.make_cast ((l_menu.item.items + l_i___0).item.rtext))
										end
										l_i___0 := l_i___0 + 1
									end
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 282, create {CE_POINTER [ANY]}.make_cast (l_menu.item.items))
								end
								l_pos := -1 + 55 -- switch 1; break
				when 55 then -- switch 1, done:
								l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
					end

	menu_func_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_func)
		end

	do_mainmenu (a_term: CE_POINTER [PD_TERMINAL]; a_items: CE_POINTER [PD_MENU_ITEM]; a_data: CE_POINTER [ANY]; a_sel: INTEGER_32)
		local
			l_menu: CE_POINTER [PD_MAINMENU]
			l_ev: PD_EVENT
			l_win: CE_POINTER [PD_WINDOW]
		do
			create l_menu.make
			create l_ev.make
			create l_win.make

			l_menu.ce_gets (create {CE_POINTER [PD_MAINMENU]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 291, {PD_MAINMENU}.sizeof.to_natural_32))))
			if a_sel = -1 then
				l_menu.item.selected := 0
			else
				l_menu.item.selected := a_sel
			end
			l_menu.item.items := a_items
			l_menu.item.data := a_data
			terminal_inst.add_window (a_term, mainmenu_func_address, create {CE_POINTER [ANY]}.make_cast (l_menu))
			if a_sel /= -1 then
				l_ev.ev := 1
				l_ev.x := 256
				l_ev.y := 0
				l_ev.b := 0
				l_win.ce_gets (create {CE_POINTER [PD_WINDOW]}.make_cast (a_term.item.windows.next));
				(l_win.item.handler).call ([l_win, l_ev.address, 0])
			end
		end

	display_mainmenu (a_term: CE_POINTER [PD_TERMINAL]; a_menu: CE_POINTER [PD_MAINMENU])
		local
			l_i: INTEGER_32
			l_p: INTEGER_32
			l_s: INTEGER_32
			l_j: INTEGER_32
			l_c: NATURAL_8
			l_tmptext: CE_POINTER [NATURAL_8]
			l_co: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: NATURAL_8
			js: JUMP_STATE
		do
			create l_tmptext.make

			l_p := 2
			terminal_inst.fill_area (a_term, 0, 0, a_term.item.x, 1, {NATURAL_32} 14368)
			l_i := 0
			from
			until
				not (not js.loop_left and then (((a_menu.item.items + l_i).item.text).c_pointer /= default_pointer))
			loop
				l_s := 0
				l_tmptext.ce_gets ((language_inst.get_text_translation ((a_menu.item.items + l_i).item.text, a_term)))
				if l_i = a_menu.item.selected then
					l_s := 1
					l_tmp___0 := 1792
				else
					l_tmp___0 := 14336
				end
				l_co := l_tmp___0
				if l_s.to_boolean then
					terminal_inst.fill_area (a_term, l_p, 0, 2, 1, l_co.to_natural_32)
					terminal_inst.fill_area (a_term, ((l_p.to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmptext)))) + {NATURAL_32} 2).to_integer_32, 0, 2, 1, l_co.to_natural_32)
					a_menu.item.sp := l_p
					terminal_inst.set_cursor (a_term, l_p, 0, a_term.item.x - 1, a_term.item.y - 1)
					terminal_inst.set_window_ptr (a_menu.item.win, l_p, 1)
				end
				l_p := l_p + (2)
				l_j := 0
				from
				until
					js.loop_left
				loop
					js.reset
					l_c := l_tmptext[l_j]
					if not l_c.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						if not l_s.to_boolean then
							l_tmp___6 := links_inst.upcase (l_c)
							if (((strchr (create {CE_POINTER [INTEGER_8]}.make_cast ((language_inst.get_text_translation ((a_menu.item.items + l_i).item.hotkey, a_term))), l_tmp___6.to_integer_32))).c_pointer /= default_pointer) then
								l_s := 1
								l_tmp___5 := 14336
							else
								l_tmp___5 := l_co
							end
						else
							l_tmp___5 := l_co
						end
						terminal_inst.set_char (a_term, l_p, 0, ((l_tmp___5).bit_or (l_c.to_integer_32)).to_natural_32)
						l_j := l_j + 1
						l_p := l_p + 1
					end
				end
				js.reset
				l_p := l_p + (2)
				l_i := l_i + 1
			end
			a_menu.item.ni := l_i
			terminal_inst.redraw_from_window (a_menu.item.win)
		end

	select_mainmenu (a_term: CE_POINTER [PD_TERMINAL]; a_menu: CE_POINTER [PD_MAINMENU])
		local
			l_it: CE_POINTER [PD_MENU_ITEM]
			l_win: CE_POINTER [PD_WINDOW]
			l_win1: CE_POINTER [PD_WINDOW]
			js: JUMP_STATE
		do
			create l_it.make
			create l_win.make
			create l_win1.make

			l_it.ce_gets (a_menu.item.items + a_menu.item.selected)
			if a_menu.item.selected < 0 then
				js.return
			elseif a_menu.item.selected >= a_menu.item.ni then
				js.return
			elseif ((l_it.item.hotkey).c_pointer.to_integer_32).to_natural_32 = ((m_bar_address).c_pointer.to_integer_32).to_natural_32 then
				js.return
			end
			if not js.return_called then
				if not (l_it.item.in_m).to_boolean then
					l_win.ce_gets (create {CE_POINTER [PD_WINDOW]}.make_cast (a_term.item.windows.next))
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_win.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_term.c_pointer + {PD_TERMINAL}.windows_offset)).c_pointer.to_integer_32).to_natural_32 then
							if ((l_win.item.handler).c_pointer.to_integer_32).to_natural_32 /= ((menu_func_address).c_pointer.to_integer_32).to_natural_32 then
								if ((l_win.item.handler).c_pointer.to_integer_32).to_natural_32 /= ((mainmenu_func_address).c_pointer.to_integer_32).to_natural_32 then
									js.break
								end
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_win1.ce_gets (l_win.item.next)
							terminal_inst.delete_window (l_win)
							l_win.ce_gets (l_win1)
						end
					end
					js.reset
				end
				(l_it.item.func).call ([a_term, l_it.item.data, a_menu.item.data])
			end
		end

	mainmenu_func (a_win: CE_POINTER [PD_WINDOW]; a_ev: CE_POINTER [PD_EVENT]; a_fwd: INTEGER_32)
		local
			l_s: INTEGER_32
			l_menu: CE_POINTER [PD_MAINMENU]
			l_i: INTEGER_32
			l_p: INTEGER_32
			l_o: INTEGER_32
			l_tmp___1: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp___2: NATURAL_8
			l_tmp___5: CE_POINTER [PD_EVENT]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_menu.make
			create l_tmp___5.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := 0
					l_menu.ce_gets (create {CE_POINTER [PD_MAINMENU]}.make_cast (a_win.item.data))
					l_menu.item.win := a_win
					inspect (a_ev.item.ev).to_integer_32 -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 4 then l_pos := -1 + 1
					when 3 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 1 then l_pos := -1 + 7
					when 5 then l_pos := -1 + 23
					else l_pos := -1 + 24
					end
				when 1 then -- switch 1, case 0 | switch 1, case 4 | switch 1, case 3
					display_mainmenu (a_win.item.term, l_menu)
					l_pos := -1 + 24 -- switch 1; break
				when 2 then -- switch 1, case 2
					if ((a_ev.item.b).bit_and (12)) /= 0 then
						l_pos := -1 + 5 -- skip if block
					end
				when 3 then -- if:
						if (a_ev.item.y).to_boolean then
							terminal_inst.delete_window_ev (a_win, a_ev)
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if not (a_ev.item.y).to_boolean then
							l_p := 2
							l_i := 0
							from
							until
								not (not js.loop_left and then (l_i < l_menu.item.ni))
							loop
								js.reset
								l_o := l_p
								l_p := (l_p.to_natural_32 + ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((language_inst.get_text_translation ((l_menu.item.items + l_i).item.text, a_win.item.term))))) + {NATURAL_32} 4)).to_integer_32
								if a_ev.item.x >= l_o.to_integer_32 then
									if a_ev.item.x < l_p.to_integer_32 then
										l_menu.item.selected := l_i
										display_mainmenu (a_win.item.term, l_menu)
										if ((a_ev.item.b).bit_and (12)) = 4 then
											select_mainmenu (a_win.item.term, l_menu)
										elseif ((l_menu.item.items + l_s).item.in_m).to_boolean then
											select_mainmenu (a_win.item.term, l_menu)
										end
										js.break
									end
								end
								if not js.loop_jumped then
									l_i := l_i + 1
								end
							end
							js.reset
						end
				when 6 then
					l_pos := -1 + 24 -- switch 1; break
				when 7 then -- switch 1, case 1
					if a_ev.item.x = 32 then
						select_mainmenu (a_win.item.term, l_menu)
						l_pos := -1 + 24 -- switch 1; break
					elseif a_ev.item.x = 256 then
						select_mainmenu (a_win.item.term, l_menu)
						l_pos := -1 + 24 -- switch 1; break
					elseif a_ev.item.x = 263 then
						select_mainmenu (a_win.item.term, l_menu)
						l_pos := -1 + 24 -- switch 1; break
					elseif a_ev.item.x = 262 then
						select_mainmenu (a_win.item.term, l_menu)
						l_pos := -1 + 24 -- switch 1; break
					elseif a_ev.item.x = 269 then
						select_mainmenu (a_win.item.term, l_menu)
						l_pos := -1 + 24 -- switch 1; break
					elseif a_ev.item.x = 268 then
						select_mainmenu (a_win.item.term, l_menu)
						l_pos := -1 + 24 -- switch 1; break
					end
				when 8 then
					if a_ev.item.x = 260 then
						l_tmp___1 := l_menu.item.selected
						l_menu.item.selected := (l_menu.item.selected) - 1
						if not l_tmp___1.to_boolean then
							l_menu.item.selected := l_menu.item.ni - 1
						end
						l_s := 1
					end
					if a_ev.item.x = 261 then
						l_menu.item.selected := (l_menu.item.selected) + 1
						if l_menu.item.selected >= l_menu.item.ni then
							l_menu.item.selected := 0
						end
						l_s := 1
					end
					if a_ev.item.x = 266 then
						l_menu.item.selected := 0
						l_s := 1
					end
					if a_ev.item.x = 267 then
						l_menu.item.selected := l_menu.item.ni - 1
						l_s := 1
					end
					if a_ev.item.x /= 260 then
						l_pos := -1 + 11 -- skip if block
					end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L___0
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if a_ev.item.x /= 261 then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L___0:
						if a_fwd.to_boolean then
							display_mainmenu (a_win.item.term, l_menu)
							select_mainmenu (a_win.item.term, l_menu)
							l_pos := -1 + 24 -- switch 1; break
						end
				when 13 then -- if done
						if not (a_ev.item.x > 32) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
							if a_ev.item.x < 256 then
								l_s := 1
								l_i___0 := 0
								from
								until
									not (l_i___0 < l_menu.item.ni)
								loop
									l_tmp___2 := links_inst.upcase ((a_ev.item.x).to_natural_8)
									if (((strchr (create {CE_POINTER [INTEGER_8]}.make_cast ((language_inst.get_text_translation ((l_menu.item.items + l_i___0).item.hotkey, a_win.item.term))), l_tmp___2.to_integer_32))).c_pointer /= default_pointer) then
										l_menu.item.selected := l_i___0
										l_s := 2
									end
									l_i___0 := l_i___0 + 1
								end
							else
								l_pos := -1 + 16 -- goto _L___2
							end
				when 15 then -- if block done, skip else block:
							l_pos := -1 + 22
				when 16 then -- else: | _L___2:
							if l_s.to_boolean then
								l_pos := -1 + 22 -- skip if block
							end
				when 17 then -- if:
							if not (a_ev.item.x >= 288) then
								l_pos := -1 + 20 -- skip if block
							end
				when 18 then -- if:
							if a_ev.item.x <= 299 then
								l_tmp___5.ce_gets (a_ev)
							else
								l_pos := -1 + 20 -- goto _L___1
							end
				when 19 then -- if block done, skip else block:
							l_pos := -1 + 21
				when 20 then -- else: | _L___1:
							if ((a_ev.item.y).bit_and (4)).to_boolean then
								l_tmp___5.ce_gets (a_ev)
							else
								l_tmp___5.ce_gets (create {CE_POINTER [PD_EVENT]}.make_shared (default_pointer))
							end
				when 21 then
							terminal_inst.delete_window_ev (a_win, l_tmp___5)
							l_pos := -1 + 24 -- switch 1; break
				when 22 then -- if done
							display_mainmenu (a_win.item.term, l_menu)
							if l_s = 2 then
								select_mainmenu (a_win.item.term, l_menu)
							end
							l_pos := -1 + 24 -- switch 1; break
				when 23 then -- switch 1, case 5
							l_pos := -1 + 24 -- switch 1; break
				when 24 then -- switch 1, done:
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	mainmenu_func_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent mainmenu_func)
		end

	new_menu (a_free_i: INTEGER_32): CE_POINTER [PD_MENU_ITEM]
		local
			l_mi: CE_POINTER [PD_MENU_ITEM]
		do
			create l_mi.make

			l_mi.ce_gets (create {CE_POINTER [PD_MENU_ITEM]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 419, {PD_MENU_ITEM}.sizeof.to_natural_32))))
			memset (create {CE_POINTER [ANY]}.make_cast (l_mi), 0, {PD_MENU_ITEM}.sizeof.to_natural_32).do_nothing
			l_mi.item.free_i := a_free_i
			Result := l_mi
		end

	add_to_menu (a_mi: CE_POINTER [CE_POINTER [PD_MENU_ITEM]]; a_text: CE_POINTER [NATURAL_8]; a_rtext: CE_POINTER [NATURAL_8]; a_hotkey: CE_POINTER [NATURAL_8]; a_func: CE_ROUTINE; a_data: CE_POINTER [ANY]; a_in_m: INTEGER_32)
		local
			l_mii: CE_POINTER [PD_MENU_ITEM]
			l_n: INTEGER_32
			js: JUMP_STATE
		do
			create l_mii.make

			l_n := 0
			from
			until
				not (not js.loop_left and then (((a_mi.item + l_n).item.text).c_pointer /= default_pointer))
			loop
				if l_n = 2147483647 then
					from
					until
						False
					loop
						error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 429])
						kbd_inst.fatal_tty_exit
						exit (4)
					end
				end
				l_n := l_n + 1
			end
			if l_n.to_natural_32 + {NATURAL_32} 2 > {NATURAL_32} 2147483647 // {PD_MENU_ITEM}.sizeof.to_natural_32 then
				from
				until
					False
				loop
					error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 430])
					kbd_inst.fatal_tty_exit
					exit (4)
				end
			end
			l_mii.ce_gets (create {CE_POINTER [PD_MENU_ITEM]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 431, create {CE_POINTER [ANY]}.make_cast (a_mi.item), (l_n + 2).to_natural_32 * {PD_MENU_ITEM}.sizeof.to_natural_32))))
			a_mi.item := l_mii
			memcpy (create {CE_POINTER [ANY]}.make_cast (((l_mii + l_n) + 1)), create {CE_POINTER [ANY]}.make_cast ((l_mii + l_n)), {PD_MENU_ITEM}.sizeof.to_natural_32).do_nothing;
			(l_mii + l_n).item.text := a_text;
			(l_mii + l_n).item.rtext := a_rtext;
			(l_mii + l_n).item.hotkey := a_hotkey;
			(l_mii + l_n).item.func := a_func;
			(l_mii + l_n).item.data := a_data;
			(l_mii + l_n).item.in_m := a_in_m
		end

	do_dialog (a_term: CE_POINTER [PD_TERMINAL]; a_dlg: CE_POINTER [PD_DIALOG]; a_ml: CE_POINTER [PD_MEMORY_LIST])
		local
			l_dd: CE_POINTER [PD_DIALOG_DATA]
			l_d: CE_POINTER [PD_DIALOG_ITEM]
			l_n: INTEGER_32
			js: JUMP_STATE
		do
			create l_dd.make
			create l_d.make

			l_n := 0
			l_d.ce_gets (a_dlg.item.items)
			from
			until
				not (not js.loop_left and then (l_d.item.type /= 0))
			loop
				if l_n = 2147483647 then
					from
					until
						False
					loop
						error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 448])
						kbd_inst.fatal_tty_exit
						exit (4)
					end
				end
				l_n := l_n + 1
				l_d.ce_gets (l_d + 1)
			end
			if l_n.to_natural_32 > ({NATURAL_32} 2147483647 - {PD_DIALOG_DATA}.sizeof.to_natural_32) // {PD_DIALOG_ITEM_DATA}.sizeof.to_natural_32 then
				from
				until
					False
				loop
					error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 451])
					kbd_inst.fatal_tty_exit
					exit (4)
				end
			end
			l_dd.ce_gets (create {CE_POINTER [PD_DIALOG_DATA]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 452, {PD_DIALOG_DATA}.sizeof.to_natural_32 + {PD_DIALOG_ITEM_DATA}.sizeof.to_natural_32 * l_n.to_natural_32))))
			l_dd.item.dlg := a_dlg
			l_dd.item.n := l_n
			l_dd.item.ml := a_ml
			terminal_inst.add_window (a_term, dialog_func_address, create {CE_POINTER [ANY]}.make_cast (l_dd))
		end

	display_dlg_item (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_sel: INTEGER_32)
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_co: INTEGER_32
			l_text: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_tmp___5: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_term.make
			create l_text.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_term.ce_gets ((a_dlg.item.win).item.term)
					inspect (a_di.item.item).item.type -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 3 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 2
					when 4 then l_pos := -1 + 3
					when 5 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 1
					if (a_di.item.checked).to_boolean then
						terminal_inst.print_text (l_term, a_di.item.x, a_di.item.y, 3, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("[X]")), {NATURAL_32} 14336)
					else
						terminal_inst.print_text (l_term, a_di.item.x, a_di.item.y, 3, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("[ ]")), {NATURAL_32} 14336)
					end
					if a_sel.to_boolean then
						terminal_inst.set_cursor (l_term, a_di.item.x + 1, a_di.item.y, a_di.item.x + 1, a_di.item.y)
						terminal_inst.set_window_ptr (a_dlg.item.win, a_di.item.x, a_di.item.y)
					end
					l_pos := -1 + 6 -- switch 1; break
				when 2 then -- switch 1, case 3 | switch 1, case 2
					if a_di.item.vpos + a_di.item.l <= a_di.item.cpos then
						a_di.item.vpos := (a_di.item.cpos - a_di.item.l) + 1
					end
					if a_di.item.vpos > a_di.item.cpos then
						a_di.item.vpos := a_di.item.cpos
					end
					if a_di.item.vpos < 0 then
						a_di.item.vpos := 0
					end
					terminal_inst.fill_area (l_term, a_di.item.x, a_di.item.y, a_di.item.l, 1, {NATURAL_32} 1792)
					if (a_di.item.item).item.type = 2 then
						if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((a_di.item.cdata + a_di.item.vpos)))) <= (a_di.item.l).to_natural_32 then
							l_tmp___1 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((a_di.item.cdata + a_di.item.vpos)))).to_integer_32
						else
							l_tmp___1 := a_di.item.l
						end
						terminal_inst.print_text (l_term, a_di.item.x, a_di.item.y, l_tmp___1, a_di.item.cdata + a_di.item.vpos, {NATURAL_32} 1792)
					else
						if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((a_di.item.cdata + a_di.item.vpos)))) <= (a_di.item.l).to_natural_32 then
							l_tmp___5 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((a_di.item.cdata + a_di.item.vpos)))).to_integer_32
						else
							l_tmp___5 := a_di.item.l
						end
						terminal_inst.fill_area (l_term, a_di.item.x, a_di.item.y, l_tmp___5, 1, {NATURAL_32} 1834)
					end
					if a_sel.to_boolean then
						terminal_inst.set_cursor (l_term, (a_di.item.x + a_di.item.cpos) - a_di.item.vpos, a_di.item.y, (a_di.item.x + a_di.item.cpos) - a_di.item.vpos, a_di.item.y)
						terminal_inst.set_window_ptr (a_dlg.item.win, a_di.item.x, a_di.item.y)
					end
					l_pos := -1 + 6 -- switch 1; break
				when 3 then -- switch 1, case 4
					if a_sel.to_boolean then
						l_co := 18176
					else
						l_co := 14336
					end
					l_text.ce_gets (language_inst.get_text_translation ((a_di.item.item).item.text, l_term))
					terminal_inst.print_text (l_term, a_di.item.x, a_di.item.y, 2, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("[ ")), l_co.to_natural_32)
					terminal_inst.print_text (l_term, a_di.item.x + 2, a_di.item.y, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_text))).to_integer_32, l_text, l_co.to_natural_32)
					terminal_inst.print_text (l_term, ((a_di.item.x + 2).to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_text)))).to_integer_32, a_di.item.y, 2, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ]")), l_co.to_natural_32)
					if a_sel.to_boolean then
						terminal_inst.set_cursor (l_term, a_di.item.x + 2, a_di.item.y, a_di.item.x + 2, a_di.item.y)
						terminal_inst.set_window_ptr (a_dlg.item.win, a_di.item.x, a_di.item.y)
					end
					l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 5
					show_dlg_item_box (a_dlg, a_di)
					l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, default:
					from
					until
						False
					loop
						links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")))
						links_inst.errline := 505
						error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Tried to draw unknown"))])
					end
				when 6 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	dlg_select_item (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA])
		local
			l_tmp: INTEGER_32
			l_i: INTEGER_32
		do
			if (a_di.item.item).item.type = 1 then
				if not ((a_di.item.item).item.gid).to_boolean then
					l_tmp := (not ((create {CE_POINTER [INTEGER_32]}.make_cast (a_di.item.cdata)).item).to_boolean).to_integer;
					(create {CE_POINTER [INTEGER_32]}.make_cast (a_di.item.cdata)).item := l_tmp
					a_di.item.checked := l_tmp
				else
					l_i := 0
					from
					until
						not (l_i < a_dlg.item.n)
					loop
						if (a_dlg.item.items[l_i].item).item.type = 1 then
							if (a_dlg.item.items[l_i].item).item.gid = (a_di.item.item).item.gid then
								(create {CE_POINTER [INTEGER_32]}.make_cast (a_dlg.item.items[l_i].cdata)).item := (a_di.item.item).item.gnum
								a_dlg.item.items[l_i].checked := 0
								display_dlg_item (a_dlg, a_dlg.item.items + l_i, 0)
							end
						end
						l_i := l_i + 1
					end
					a_di.item.checked := 1
				end
				display_dlg_item (a_dlg, a_di, 1)
			elseif (a_di.item.item).item.type = 4 then
				((a_di.item.item).item.fn).call ([a_dlg, a_di])
			end
		end

	dlg_set_history (a_di: CE_POINTER [PD_DIALOG_ITEM_DATA])
		local
			l_s: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
		do
			create l_s.make

			l_s.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
			if ((a_di.item.cur_hist).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_di.c_pointer + {PD_DIALOG_ITEM_DATA}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
				l_s.ce_gets ((a_di.item.cur_hist).item.d)
			end
			l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s))).to_integer_32
			if l_l > (a_di.item.item).item.dlen then
				l_l := (a_di.item.item).item.dlen - 1
			end
			memcpy (create {CE_POINTER [ANY]}.make_cast (a_di.item.cdata), create {CE_POINTER [ANY]}.make_cast (l_s), l_l.to_natural_32).do_nothing
			a_di.item.cdata[l_l] := (0).to_natural_8
			a_di.item.cpos := l_l
			a_di.item.vpos := 0
		end

	dlg_mouse (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_ev: CE_POINTER [PD_EVENT]): INTEGER_32
		local
			l_tmp___2: INTEGER_32
			l_offset: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect (a_di.item.item).item.type -- switch 1 head
					when 4 then l_pos := -1 + 1
					when 3 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 2
					when 1 then l_pos := -1 + 3
					when 5 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 4
					if a_ev.item.y /= (a_di.item.y).to_integer_32 then
						Result := 0
						js.return
					elseif a_ev.item.x < (a_di.item.x).to_integer_32 then
						Result := 0
						js.return
					elseif (a_ev.item.x).to_natural_32 >= ((a_di.item.x).to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((language_inst.get_text_translation ((a_di.item.item).item.text, (a_dlg.item.win).item.term)))))) + {NATURAL_32} 4 then
						Result := 0
						js.return
					end
					if not js.return_called then
						display_dlg_item (a_dlg, a_dlg.item.items + a_dlg.item.selected, 0)
						a_dlg.item.selected := a_di.distance ((a_dlg.item.items))
						display_dlg_item (a_dlg, a_di, 1)
						if ((a_ev.item.b).bit_and (12)) = 4 then
							dlg_select_item (a_dlg, a_di)
						end
						Result := 1
						js.return
					end
				when 2 then -- switch 1, case 3 | switch 1, case 2
					if not js.return_called then
						if a_ev.item.y /= (a_di.item.y).to_integer_32 then
							Result := 0
							js.return
						elseif a_ev.item.x < (a_di.item.x).to_integer_32 then
							Result := 0
							js.return
						elseif a_ev.item.x >= (a_di.item.x + a_di.item.l).to_integer_32 then
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						l_tmp___2 := (((a_di.item.vpos).to_integer_32 + a_ev.item.x) - (a_di.item.x).to_integer_32).to_integer_32
						a_di.item.cpos := l_tmp___2
						if l_tmp___2.to_natural_32 > (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_di.item.cdata))) then
							a_di.item.cpos := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_di.item.cdata))).to_integer_32
						end
						display_dlg_item (a_dlg, a_dlg.item.items + a_dlg.item.selected, 0)
						a_dlg.item.selected := a_di.distance ((a_dlg.item.items))
						display_dlg_item (a_dlg, a_di, 1)
						Result := 1
						js.return
					end
				when 3 then -- switch 1, case 1
					if not js.return_called then
						if a_ev.item.y /= (a_di.item.y).to_integer_32 then
							Result := 0
							js.return
						elseif a_ev.item.x < (a_di.item.x).to_integer_32 then
							Result := 0
							js.return
						elseif a_ev.item.x >= (a_di.item.x + 3).to_integer_32 then
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						display_dlg_item (a_dlg, a_dlg.item.items + a_dlg.item.selected, 0)
						a_dlg.item.selected := a_di.distance ((a_dlg.item.items))
						display_dlg_item (a_dlg, a_di, 1)
						if ((a_ev.item.b).bit_and (12)) = 4 then
							dlg_select_item (a_dlg, a_di)
						end
						Result := 1
						js.return
					end
				when 4 then -- switch 1, case 5
					if not js.return_called and then (((a_ev.item.b).bit_and (12)) = 4) then
						if a_ev.item.y >= (a_di.item.y).to_integer_32 then
							if a_ev.item.x >= (a_di.item.x).to_integer_32 then
								if a_ev.item.x <= (a_di.item.l + a_di.item.x).to_integer_32 then
									l_offset := (a_ev.item.y - (a_di.item.y).to_integer_32).to_integer_32
									box_sel_set_visible (a_di, l_offset)
									display_dlg_item (a_dlg, a_di, 1)
									Result := 1
									js.return
								end
							end
						end
					end
				when 5 then -- switch 1, done:
					if not js.return_called then
						Result := 0
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	redraw_dialog (a_dlg: CE_POINTER [PD_DIALOG_DATA])
		local
			l_i: INTEGER_32
			l_term: CE_POINTER [PD_TERMINAL]
		do
			create l_term.make

			l_term.ce_gets ((a_dlg.item.win).item.term)
			terminal_inst.draw_frame (l_term, a_dlg.item.x + 3, a_dlg.item.y + 1, a_dlg.item.xw - 6, a_dlg.item.yw - 2, {NATURAL_32} 14336, 2)
			l_i := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((language_inst.get_text_translation ((a_dlg.item.dlg).item.title, l_term))))).to_integer_32
			terminal_inst.print_text (l_term, ((a_dlg.item.xw - l_i) // 2 + a_dlg.item.x) - 1, a_dlg.item.y + 1, 1, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")), {NATURAL_32} 1792)
			terminal_inst.print_text (l_term, (a_dlg.item.xw - l_i) // 2 + a_dlg.item.x, a_dlg.item.y + 1, l_i, (language_inst.get_text_translation ((a_dlg.item.dlg).item.title, l_term)), {NATURAL_32} 1792)
			terminal_inst.print_text (l_term, ((a_dlg.item.xw - l_i) // 2 + a_dlg.item.x) + l_i, a_dlg.item.y + 1, 1, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")), {NATURAL_32} 1792)
			l_i := 0
			from
			until
				not (l_i < a_dlg.item.n)
			loop
				display_dlg_item (a_dlg, a_dlg.item.items + l_i, (l_i = a_dlg.item.selected).to_integer)
				l_i := l_i + 1
			end
			terminal_inst.redraw_from_window (a_dlg.item.win)
		end

	tab_compl (a_term: CE_POINTER [PD_TERMINAL]; a_item: CE_POINTER [NATURAL_8]; a_win: CE_POINTER [PD_WINDOW])
		local
			l_ev: PD_EVENT
			l_di: CE_POINTER [PD_DIALOG_ITEM_DATA]
			l_l: INTEGER_32
		do
			create l_ev.make
			create l_di.make

			l_ev.ev := 3
			l_ev.x := 0
			l_ev.y := 0
			l_ev.b := 0
			l_di.ce_gets ((create {CE_POINTER [PD_DIALOG_DATA]}.make_cast (a_win.item.data)).item.items + (create {CE_POINTER [PD_DIALOG_DATA]}.make_cast (a_win.item.data)).item.selected)
			l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_item))).to_integer_32
			if l_l >= (l_di.item.item).item.dlen then
				l_l := (l_di.item.item).item.dlen - 1
			end
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_di.item.cdata), create {CE_POINTER [ANY]}.make_cast (a_item), l_l.to_natural_32).do_nothing
			l_di.item.cdata[l_l] := (0).to_natural_8
			l_di.item.cpos := l_l
			l_di.item.vpos := 0
			l_ev.x := (a_term.item.x).to_integer_32
			l_ev.y := (a_term.item.y).to_integer_32
			dialog_func (a_win, l_ev.address, 0)
		end

	tab_compl_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent tab_compl)
		end

	do_tab_compl (a_term: CE_POINTER [PD_TERMINAL]; a_history: CE_POINTER [PD_LIST_HEAD]; a_win: CE_POINTER [PD_WINDOW])
		local
			l_cdata: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_n: INTEGER_32
			l_hi: CE_POINTER [PD_HISTORY_ITEM]
			l_items: CE_POINTER [PD_MENU_ITEM]
			js: JUMP_STATE
		do
			create l_cdata.make
			create l_hi.make
			create l_items.make

			l_cdata.ce_gets ((create {CE_POINTER [PD_DIALOG_DATA]}.make_cast (a_win.item.data)).item.items[(create {CE_POINTER [PD_DIALOG_DATA]}.make_cast (a_win.item.data)).item.selected].cdata)
			l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_cdata))).to_integer_32
			l_n := 0
			l_items.ce_gets (create {CE_POINTER [PD_MENU_ITEM]}.make_shared (default_pointer + -1))
			l_hi.ce_gets (create {CE_POINTER [PD_HISTORY_ITEM]}.make_cast (a_history.item.next))
			from
			until
				not (not js.loop_left and then ((l_hi.c_pointer.to_integer_32).to_natural_32 /= (a_history.c_pointer.to_integer_32).to_natural_32))
			loop
				if not (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_cdata), create {CE_POINTER [INTEGER_8]}.make_cast ((l_hi.item.d)), l_l.to_natural_32)).to_boolean then
					if not ((l_n).bit_and (63)).to_boolean then
						if l_n.to_natural_32 > ({NATURAL_32} 2147483647 // {PD_MENU_ITEM}.sizeof.to_natural_32 - {NATURAL_32} 64) - {NATURAL_32} 1 then
							from
							until
								False
							loop
								error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 619])
								kbd_inst.fatal_tty_exit
								exit (4)
							end
						end
						l_items.ce_gets (create {CE_POINTER [PD_MENU_ITEM]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 620, create {CE_POINTER [ANY]}.make_cast (l_items), ((l_n + 64) + 1).to_natural_32 * {PD_MENU_ITEM}.sizeof.to_natural_32))))
					end
					(l_items + l_n).item.text := l_hi.item.d;
					(l_items + l_n).item.rtext := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""));
					(l_items + l_n).item.hotkey := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""));
					(l_items + l_n).item.func := (tab_compl_address);
					(l_items + l_n).item.rtext := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""));
					(l_items + l_n).item.data := create {CE_POINTER [ANY]}.make_cast ((l_hi.item.d));
					(l_items + l_n).item.in_m := 0;
					(l_items + l_n).item.free_i := 1
					if l_n = 2147483647 then
						from
						until
							False
						loop
							error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 630])
							kbd_inst.fatal_tty_exit
							exit (4)
						end
					end
					l_n := l_n + 1
				end
				l_hi.ce_gets (l_hi.item.next)
			end
			if l_n = 1 then
				tab_compl (a_term, create {CE_POINTER [NATURAL_8]}.make_cast (l_items.item.data), a_win)
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 635, create {CE_POINTER [ANY]}.make_cast (l_items))
				js.return
			end
			if not js.return_called and then (l_n.to_boolean) then
				memset (create {CE_POINTER [ANY]}.make_cast ((l_items + l_n)), 0, {PD_MENU_ITEM}.sizeof.to_natural_32).do_nothing
				do_menu_selected (a_term, l_items, create {CE_POINTER [ANY]}.make_cast (a_win), l_n - 1)
			end
		end

	dialog_func (a_win: CE_POINTER [PD_WINDOW]; a_ev: CE_POINTER [PD_EVENT]; a_fwd: INTEGER_32)
		local
			l_i: INTEGER_32
			l_term: CE_POINTER [PD_TERMINAL]
			l_dlg: CE_POINTER [PD_DIALOG_DATA]
			l_di: CE_POINTER [PD_DIALOG_ITEM_DATA]
			l_di___0: CE_POINTER [PD_DIALOG_ITEM_DATA]
			l_j: CE_POINTER [PD_HISTORY_ITEM]
			l_hi: CE_POINTER [PD_HISTORY_ITEM]
			l_clipboard: CE_POINTER [NATURAL_8]
			l_tmp___16: INTEGER_32
			l_tmp___19: NATURAL_8
			l_di___1: CE_POINTER [PD_DIALOG_ITEM_DATA]
			l_a__: CE_POINTER [PD_XLIST_HEAD]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_term.make
			create l_dlg.make
			create l_di.make
			create l_di___0.make
			create l_j.make
			create l_hi.make
			create l_clipboard.make
			create l_di___1.make
			create l_a__.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_term.ce_gets (a_win.item.term)
					l_dlg.ce_gets (create {CE_POINTER [PD_DIALOG_DATA]}.make_cast (a_win.item.data))
					l_dlg.item.win := a_win
					if (((l_dlg.item.dlg).item.handle_event).c_pointer /= default_pointer) then
						if (((l_dlg.item.dlg).item.handle_event).integer_32_item ([l_dlg, a_ev])) = 0 then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 78 -- skip if block
					end
				when 1 then -- if:
						inspect (a_ev.item.ev).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 2
						when 4 then l_pos := -1 + 11
						when 3 then l_pos := -1 + 11
						when 2 then l_pos := -1 + 12
						when 1 then l_pos := -1 + 13
						when 5 then l_pos := -1 + 76
						else l_pos := -1 + 77
						end
				when 2 then -- switch 1, case 0
						l_i := 0
				when 3 then -- loop condition:
						if not (not js.loop_left and then (l_i < l_dlg.item.n)) then
							l_pos := -1 + 10 -- skip loop
						end
				when 4 then -- loop body:
						l_di___0.ce_gets (l_dlg.item.items + l_i)
						memset (create {CE_POINTER [ANY]}.make_cast (l_di___0), 0, {PD_DIALOG_ITEM_DATA}.sizeof.to_natural_32).do_nothing
						l_di___0.item.item := (l_dlg.item.dlg).item.items + l_i
						l_di___0.item.cdata := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 664, ((l_di___0.item.item).item.dlen).to_natural_32)))
						memcpy (create {CE_POINTER [ANY]}.make_cast (l_di___0.item.cdata), create {CE_POINTER [ANY]}.make_cast ((l_di___0.item.item).item.data), ((l_di___0.item.item).item.dlen).to_natural_32).do_nothing
						if (l_di___0.item.item).item.type = 1 then
							if ((l_di___0.item.item).item.gid).to_boolean then
								if (create {CE_POINTER [INTEGER_32]}.make_cast (l_di___0.item.cdata)).item = (l_di___0.item.item).item.gnum then
									l_di___0.item.checked := 1
								end
							elseif ((create {CE_POINTER [INTEGER_32]}.make_cast (l_di___0.item.cdata)).item).to_boolean then
								l_di___0.item.checked := 1
							end
						end
						if (l_di___0.item.item).item.type = 5 then
							l_di___0.item.cdata := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 673, {PD_DLG_DATA_ITEM_DATA_BOX}.sizeof.to_natural_32)));
							(create {CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast (l_di___0.item.cdata)).item.sel := -1;
							(create {CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast (l_di___0.item.cdata)).item.box_top := 0;
							(create {CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast (l_di___0.item.cdata)).item.list_len := -1
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared ((create {CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast (l_di___0.item.cdata)).c_pointer + {PD_DLG_DATA_ITEM_DATA_BOX}.items_offset))));
							(create {CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast (l_di___0.item.cdata)).item.items.next := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared ((create {CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast (l_di___0.item.cdata)).c_pointer + {PD_DLG_DATA_ITEM_DATA_BOX}.items_offset)));
							(create {CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast (l_di___0.item.cdata)).item.items.prev := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared ((create {CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast (l_di___0.item.cdata)).c_pointer + {PD_DLG_DATA_ITEM_DATA_BOX}.items_offset)))
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared ((create {CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast (l_di___0.item.cdata)).c_pointer + {PD_DLG_DATA_ITEM_DATA_BOX}.items_offset))))
						end
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_di___0.c_pointer + {PD_DIALOG_ITEM_DATA}.history_offset))))
						l_di___0.item.history.next := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_di___0.c_pointer + {PD_DIALOG_ITEM_DATA}.history_offset)))
						l_di___0.item.history.prev := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_di___0.c_pointer + {PD_DIALOG_ITEM_DATA}.history_offset)))
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_di___0.c_pointer + {PD_DIALOG_ITEM_DATA}.history_offset))))
						l_di___0.item.cur_hist := create {CE_POINTER [PD_HISTORY_ITEM]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_di___0.c_pointer + {PD_DIALOG_ITEM_DATA}.history_offset)))
						if (l_di___0.item.item).item.type /= 2 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if (l_di___0.item.item).item.type /= 3 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if (((l_di___0.item.item).item.history).c_pointer /= default_pointer) then
							l_j.ce_gets (create {CE_POINTER [PD_HISTORY_ITEM]}.make_cast (((l_di___0.item.item).item.history).item.items.next))
							from
							until
								not (not js.loop_left and then ((l_j.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (((l_di___0.item.item).item.history).c_pointer + {PD_HISTORY}.items_offset)).c_pointer.to_integer_32).to_natural_32))
							loop
								l_hi.ce_gets (create {CE_POINTER [PD_HISTORY_ITEM]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 688, ({PD_HISTORY_ITEM}.sizeof.to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_j.item.d))))) + {NATURAL_32} 1))))
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_hi.item.d)), create {CE_POINTER [INTEGER_8]}.make_cast ((l_j.item.d))).do_nothing
								from
								until
									js.loop_left
								loop
									js.reset
									error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_di___0.c_pointer + {PD_DIALOG_ITEM_DATA}.history_offset))))
									l_hi.item.next := (create {CE_POINTER [PD_HISTORY_ITEM]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_di___0.c_pointer + {PD_DIALOG_ITEM_DATA}.history_offset)))).item.next
									l_hi.item.prev := create {CE_POINTER [PD_HISTORY_ITEM]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_di___0.c_pointer + {PD_DIALOG_ITEM_DATA}.history_offset)));
									(create {CE_POINTER [PD_HISTORY_ITEM]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_di___0.c_pointer + {PD_DIALOG_ITEM_DATA}.history_offset)))).item.next := l_hi;
									(l_hi.item.next).item.prev := l_hi
									error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_di___0.c_pointer + {PD_DIALOG_ITEM_DATA}.history_offset))))
									js.break
								end
								js.reset
								l_j.ce_gets (l_j.item.next)
							end
						end
						l_di___0.item.cpos := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_di___0.item.cdata))).to_integer_32
				when 9 then -- if done
						l_i := l_i + 1
						l_pos := -1 + 3 -- back to loop condition
				when 10 then -- loop done
						l_dlg.item.selected := 0
				when 11 then -- switch 1, case 4 | switch 1, case 3;
						((l_dlg.item.dlg).item.fn).call ([l_dlg])
						redraw_dialog (l_dlg)
						l_pos := -1 + 77 -- switch 1; break
				when 12 then -- switch 1, case 2
						l_i := 0
						from
						until
							not (not js.loop_left and then (l_i < l_dlg.item.n))
						loop
							js.reset
							if (dlg_mouse (l_dlg, l_dlg.item.items + l_i, a_ev)).to_boolean then
								js.break
							end
							if not js.loop_jumped then
								l_i := l_i + 1
							end
						end
						js.reset
						l_pos := -1 + 77 -- switch 1; break
				when 13 then -- switch 1, case 1
						l_di.ce_gets (l_dlg.item.items + l_dlg.item.selected)
						if (l_di.item.item).item.type /= 2 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___0
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 16 then -- else:
						if (l_di.item.item).item.type /= 3 then
							l_pos := -1 + 37 -- skip if block
						end
				when 17 then -- if: | _L___0:
						inspect (kbdbind_inst.kbd_action (1, a_ev)) -- switch 2 head
						when 45 then l_pos := -1 + 18
						when 9 then l_pos := -1 + 20
						when 35 then l_pos := -1 + 22
						when 23 then l_pos := -1 + 23
						when 20 then l_pos := -1 + 24
						when 11 then l_pos := -1 + 25
						when 3 then l_pos := -1 + 26
						when 7 then l_pos := -1 + 27
						when 21 then l_pos := -1 + 28
						when 22 then l_pos := -1 + 29
						when 5 then l_pos := -1 + 30
						when 6 then l_pos := -1 + 31
						when 30 then l_pos := -1 + 32
						when 1 then l_pos := -1 + 33
						else l_pos := -1 + 34
						end
				when 18 then -- switch 2, case 45
						if (((l_di.item.cur_hist).item.prev).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_di.c_pointer + {PD_DIALOG_ITEM_DATA}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
							l_di.item.cur_hist := (l_di.item.cur_hist).item.prev
							dlg_set_history (l_di)
							l_pos := -1 + 36 -- goto dsp_f
						end
				when 19 then
						l_pos := -1 + 35 -- switch 2; break
				when 20 then -- switch 2, case 9
						if ((l_di.item.cur_hist).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_di.c_pointer + {PD_DIALOG_ITEM_DATA}.history_offset)).c_pointer.to_integer_32).to_natural_32 then
							l_di.item.cur_hist := (l_di.item.cur_hist).item.next
							dlg_set_history (l_di)
							l_pos := -1 + 36 -- goto dsp_f
						end
				when 21 then
						l_pos := -1 + 35 -- switch 2; break
				when 22 then -- switch 2, case 35
						if (l_di.item.cpos).to_natural_32 < (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_di.item.cdata))) then
							l_di.item.cpos := (l_di.item.cpos) + 1
						end
						l_pos := -1 + 36 -- goto dsp_f
				when 23 then -- switch 2, case 23
						if l_di.item.cpos > 0 then
							l_di.item.cpos := (l_di.item.cpos) - 1
						end
						l_pos := -1 + 36 -- goto dsp_f
				when 24 then -- switch 2, case 20
						l_di.item.cpos := 0
						l_pos := -1 + 36 -- goto dsp_f
				when 25 then -- switch 2, case 11
						l_di.item.cpos := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_di.item.cdata))).to_integer_32
						l_pos := -1 + 36 -- goto dsp_f
				when 26 then -- switch 2, case 3
						if (l_di.item.cpos).to_boolean then
							memmove (create {CE_POINTER [ANY]}.make_cast (((l_di.item.cdata + l_di.item.cpos) - 1)), create {CE_POINTER [ANY]}.make_cast ((l_di.item.cdata + l_di.item.cpos)), ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_di.item.cdata))) - (l_di.item.cpos).to_natural_32) + {NATURAL_32} 1).do_nothing
							l_di.item.cpos := (l_di.item.cpos) - 1
						end
						l_pos := -1 + 36 -- goto dsp_f
				when 27 then -- switch 2, case 7
						if (l_di.item.cpos).to_natural_32 < (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_di.item.cdata))) then
							memmove (create {CE_POINTER [ANY]}.make_cast ((l_di.item.cdata + l_di.item.cpos)), create {CE_POINTER [ANY]}.make_cast (((l_di.item.cdata + l_di.item.cpos) + 1)), ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_di.item.cdata))) - (l_di.item.cpos).to_natural_32) + {NATURAL_32} 1).do_nothing
						end
						l_pos := -1 + 36 -- goto dsp_f
				when 28 then -- switch 2, case 21
						memmove (create {CE_POINTER [ANY]}.make_cast (l_di.item.cdata), create {CE_POINTER [ANY]}.make_cast ((l_di.item.cdata + l_di.item.cpos)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_di.item.cdata + l_di.item.cpos)))) + {NATURAL_32} 1).do_nothing
						l_di.item.cpos := 0
						l_pos := -1 + 36 -- goto dsp_f
				when 29 then -- switch 2, case 22
						l_di.item.cdata[l_di.item.cpos] := (0).to_natural_8
						l_pos := -1 + 36 -- goto dsp_f
				when 30 then -- switch 2, case 5
						os_dep_inst.set_clipboard_text (create {CE_POINTER [INTEGER_8]}.make_cast (l_di.item.cdata))
						l_pos := -1 + 35 -- switch 2; break
				when 31 then -- switch 2, case 6
						os_dep_inst.set_clipboard_text (create {CE_POINTER [INTEGER_8]}.make_cast (l_di.item.cdata))
						l_di.item.cdata[0] := (0).to_natural_8
						l_di.item.cpos := 0
						l_pos := -1 + 36 -- goto dsp_f
				when 32 then -- switch 2, case 30
						l_clipboard.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((os_dep_inst.get_clipboard_text)))
						if ((l_clipboard).c_pointer /= default_pointer) then
							strncpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_di.item.cdata), create {CE_POINTER [INTEGER_8]}.make_cast (l_clipboard), ((l_di.item.item).item.dlen).to_natural_32).do_nothing
							l_di.item.cdata[((l_di.item.item).item.dlen - 1)] := (0).to_natural_8
							l_di.item.cpos := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_di.item.cdata))).to_integer_32
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 769, create {CE_POINTER [ANY]}.make_cast (l_clipboard))
						end
						l_pos := -1 + 36 -- goto dsp_f
				when 33 then -- switch 2, case 1
						do_tab_compl (l_term, create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_di.c_pointer + {PD_DIALOG_ITEM_DATA}.history_offset), a_win)
						l_pos := -1 + 36 -- goto dsp_f
				when 34 then -- switch 2, default:
						if a_ev.item.x >= 32 then
							if a_ev.item.x < 256 then
								if not (a_ev.item.y).to_boolean then
									if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_di.item.cdata))) + {NATURAL_32} 1 < ((l_di.item.item).item.dlen).to_natural_32 then
										memmove (create {CE_POINTER [ANY]}.make_cast (((l_di.item.cdata + l_di.item.cpos) + 1)), create {CE_POINTER [ANY]}.make_cast ((l_di.item.cdata + l_di.item.cpos)), ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_di.item.cdata))) - (l_di.item.cpos).to_natural_32) + {NATURAL_32} 1).do_nothing
										l_tmp___16 := l_di.item.cpos
										l_di.item.cpos := (l_di.item.cpos) + 1
										l_di.item.cdata[l_tmp___16] := (a_ev.item.x).to_natural_8
									end
									l_pos := -1 + 36 -- goto dsp_f
								end
							end
						end
				when 35 then -- switch 2, done:
						l_pos := -1 + 41 -- goto gh
				when 36 then -- dsp_f:
						display_dlg_item (l_dlg, l_di, 1)
						terminal_inst.redraw_from_window (l_dlg.item.win)
						l_pos := -1 + 77 -- switch 1; break
				when 37 then -- if done
						if a_ev.item.x /= 256 then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						if (l_di.item.item).item.type = 4 then
							dlg_select_item (l_dlg, l_di)
							l_pos := -1 + 77 -- switch 1; break
						else
							l_pos := -1 + 40 -- goto _L___1
						end
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 40 then -- else: | _L___1:
						if a_ev.item.x = 32 then
							dlg_select_item (l_dlg, l_di)
							l_pos := -1 + 77 -- switch 1; break
						end
				when 41 then -- gh:
						if not (a_ev.item.x > 32) then
							l_pos := -1 + 49 -- skip if block
						end
				when 42 then -- if:
						if not (a_ev.item.x < 256) then
							l_pos := -1 + 49 -- skip if block
						end
				when 43 then -- if:
						l_i := 0
				when 44 then -- loop condition:
						if not (l_i < l_dlg.item.n) then
							l_pos := -1 + 49 -- skip loop
						end
				when 45 then -- loop body:
						if (l_dlg.item.dlg).item.items[l_i].type /= 4 then
							l_pos := -1 + 48 -- skip if block
						end
				when 46 then -- if:
						l_tmp___19 := links_inst.upcase ((language_inst.get_text_translation ((l_dlg.item.dlg).item.items[l_i].text, l_term))[0])
						if l_tmp___19.to_integer_32 /= (links_inst.upcase ((a_ev.item.x).to_natural_8)).to_integer_32 then
							l_pos := -1 + 48 -- skip if block
						end
				when 47 then -- if: | sel:
						if l_dlg.item.selected /= l_i then
							display_dlg_item (l_dlg, l_dlg.item.items + l_dlg.item.selected, 0)
							display_dlg_item (l_dlg, l_dlg.item.items + l_i, 1)
							l_dlg.item.selected := l_i
						end
						dlg_select_item (l_dlg, l_dlg.item.items + l_i)
						l_pos := -1 + 77 -- goto bla
				when 48 then -- if done
						l_i := l_i + 1
						l_pos := -1 + 44 -- back to loop condition
				when 49 then -- loop done | if done | if done
						if a_ev.item.x /= 256 then
							l_pos := -1 + 54 -- skip if block
						end
				when 50 then -- if:
						l_i := 0
				when 51 then -- loop condition:
						if not (l_i < l_dlg.item.n) then
							l_pos := -1 + 54 -- skip loop
						end
				when 52 then -- loop body:
						if (l_dlg.item.dlg).item.items[l_i].type = 4 then
							if (((l_dlg.item.dlg).item.items[l_i].gid).bit_and (1)).to_boolean then
								l_pos := -1 + 47 -- goto sel
							end
						end
				when 53 then
						l_i := l_i + 1
						l_pos := -1 + 51 -- back to loop condition
				when 54 then -- loop done | if done
						if a_ev.item.x /= 259 then
							l_pos := -1 + 59 -- skip if block
						end
				when 55 then -- if:
						l_i := 0
				when 56 then -- loop condition:
						if not (l_i < l_dlg.item.n) then
							l_pos := -1 + 59 -- skip loop
						end
				when 57 then -- loop body:
						if (l_dlg.item.dlg).item.items[l_i].type = 4 then
							if (((l_dlg.item.dlg).item.items[l_i].gid).bit_and (2)).to_boolean then
								l_pos := -1 + 47 -- goto sel
							end
						end
				when 58 then
						l_i := l_i + 1
						l_pos := -1 + 56 -- back to loop condition
				when 59 then -- loop done | if done
						if a_ev.item.x /= 258 then
							l_pos := -1 + 62 -- skip if block
						end
				when 60 then -- if:
						if not (a_ev.item.y).to_boolean then
							l_pos := -1 + 66 -- goto _L___2
						else
							l_pos := -1 + 62 -- goto _L___3
						end
				when 61 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 62 then -- else: | _L___3:
						if a_ev.item.x /= 263 then
							l_pos := -1 + 65 -- skip if block
						end
				when 63 then -- if:
						l_pos := -1 + 66 -- goto _L___2
				when 64 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 65 then -- else:
						if a_ev.item.x /= 261 then
							l_pos := -1 + 67 -- skip if block
						end
				when 66 then -- if: | _L___2:
						display_dlg_item (l_dlg, l_dlg.item.items + l_dlg.item.selected, 0)
						l_dlg.item.selected := (l_dlg.item.selected) + 1
						if l_dlg.item.selected >= l_dlg.item.n then
							l_dlg.item.selected := 0
						end
						display_dlg_item (l_dlg, l_dlg.item.items + l_dlg.item.selected, 1)
						terminal_inst.redraw_from_window (l_dlg.item.win)
						l_pos := -1 + 77 -- switch 1; break
				when 67 then -- if done | if done
						if a_ev.item.x /= 258 then
							l_pos := -1 + 70 -- skip if block
						end
				when 68 then -- if:
						if (a_ev.item.y).to_boolean then
							l_pos := -1 + 74 -- goto _L___4
						else
							l_pos := -1 + 70 -- goto _L___5
						end
				when 69 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 70 then -- else: | _L___5:
						if a_ev.item.x /= 262 then
							l_pos := -1 + 73 -- skip if block
						end
				when 71 then -- if:
						l_pos := -1 + 74 -- goto _L___4
				when 72 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 73 then -- else:
						if a_ev.item.x /= 260 then
							l_pos := -1 + 75 -- skip if block
						end
				when 74 then -- if: | _L___4:
						display_dlg_item (l_dlg, l_dlg.item.items + l_dlg.item.selected, 0)
						l_dlg.item.selected := (l_dlg.item.selected) - 1
						if l_dlg.item.selected < 0 then
							l_dlg.item.selected := l_dlg.item.n - 1
						end
						display_dlg_item (l_dlg, l_dlg.item.items + l_dlg.item.selected, 1)
						terminal_inst.redraw_from_window (l_dlg.item.win)
						l_pos := -1 + 77 -- switch 1; break
				when 75 then -- if done | if done
						l_pos := -1 + 77 -- switch 1; break
				when 76 then -- switch 1, case 5
						if (((l_dlg.item.dlg).item.abort).c_pointer /= default_pointer) then
							((l_dlg.item.dlg).item.abort).call ([l_dlg])
						end
						l_i := 0
						from
						until
							not (not js.loop_left and then (l_i < l_dlg.item.n))
						loop
							l_di___1.ce_gets (l_dlg.item.items + l_i)
							if ((l_di___1.item.cdata).c_pointer /= default_pointer) then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 832, create {CE_POINTER [ANY]}.make_cast (l_di___1.item.cdata))
							end
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_di___1.c_pointer + {PD_DIALOG_ITEM_DATA}.history_offset))))
							l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (l_di___1.item.history.next))
							from
							until
								(l_a__.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_di___1.c_pointer + {PD_DIALOG_ITEM_DATA}.history_offset)).c_pointer.to_integer_32).to_natural_32
							loop
								error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
								l_a__.ce_gets (l_a__.item.next)
							end
							l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (l_di___1.item.history.prev))
							from
							until
								(l_a__.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_di___1.c_pointer + {PD_DIALOG_ITEM_DATA}.history_offset)).c_pointer.to_integer_32).to_natural_32
							loop
								error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
								l_a__.ce_gets (l_a__.item.prev)
							end
							from
							until
								((l_di___1.item.history.next).c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_di___1.c_pointer + {PD_DIALOG_ITEM_DATA}.history_offset)).c_pointer.to_integer_32).to_natural_32
							loop
								l_a__.ce_gets (create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (l_di___1.item.history.next))
								error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__));
								(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a__.item.prev);
								(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a__.item.next)
								error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 833, create {CE_POINTER [ANY]}.make_cast (l_a__))
							end
							error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_di___1.c_pointer + {PD_DIALOG_ITEM_DATA}.history_offset))))
							l_i := l_i + 1
						end
						freeml (l_dlg.item.ml)
				when 77 then -- switch 1, done: | bla:
						
				when 78 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	dialog_func_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dialog_func)
		end

	check_number (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		local
			l_end: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			js: JUMP_STATE
		do
			create l_end.make

			l_l := (strtol (create {CE_POINTER [INTEGER_8]}.make_cast (a_di.item.cdata), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast ((l_end.address)), 10))
			if not ((a_di.item.cdata).item).to_boolean then
				msg_box ([(a_dlg.item.win).item.term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 4, 1, links_inst.dummyarray + 5, create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 6, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
				Result := 1
				js.return
			elseif (l_end.item).to_boolean then
				msg_box ([(a_dlg.item.win).item.term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 4, 1, links_inst.dummyarray + 5, create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 6, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
				Result := 1
				js.return
			end
			if not js.return_called then
				if l_l < ((a_di.item.item).item.gid).to_integer_32 then
					msg_box ([(a_dlg.item.win).item.term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 4, 1, links_inst.dummyarray + 7, create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 6, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
					Result := 1
					js.return
				elseif l_l > ((a_di.item.item).item.gnum).to_integer_32 then
					msg_box ([(a_dlg.item.win).item.term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 4, 1, links_inst.dummyarray + 7, create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 6, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	check_number_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent check_number)
		end

	check_nonempty (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		local
			l_p: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p.make

			l_p.ce_gets (a_di.item.cdata)
			from
			until
				not (not js.loop_left and then ((l_p.item).to_boolean))
			loop
				if (l_p.item).to_integer_32 > 32 then
					Result := 0
					js.return
				end
				if not js.return_called then
					l_p.ce_gets (l_p + 1)
				end
			end
			if not js.return_called then
				msg_box ([(a_dlg.item.win).item.term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 8, 1, links_inst.dummyarray + 9, create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 6, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
				Result := 1
			end
		end

	check_nonempty_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent check_nonempty)
		end

	cancel_dialog (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		do
			terminal_inst.delete_window (a_dlg.item.win)
			Result := 0
		end

	cancel_dialog_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cancel_dialog)
		end

	check_dialog (a_dlg: CE_POINTER [PD_DIALOG_DATA]): INTEGER_32
		local
			l_i: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_i := 0
				when 1 then -- loop condition:
					if not (not js.loop_left and then (l_i < a_dlg.item.n)) then
						l_pos := -1 + 11 -- skip loop
					end
				when 2 then -- loop body:
						if (a_dlg.item.dlg).item.items[l_i].type /= 1 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 5 then -- else:
						if (a_dlg.item.dlg).item.items[l_i].type /= 2 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if (a_dlg.item.dlg).item.items[l_i].type /= 3 then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						if (((a_dlg.item.dlg).item.items[l_i].fn).c_pointer /= default_pointer) then
							if (((a_dlg.item.dlg).item.items[l_i].fn).integer_32_item ([a_dlg, a_dlg.item.items + l_i])).to_boolean then
								a_dlg.item.selected := l_i
								redraw_dialog (a_dlg)
								Result := 1
								js.return
							end
						end
				when 10 then -- if done | if done
						if not js.return_called then
							l_i := l_i + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 11 then -- loop done
					if not js.return_called then
						Result := 0
					end
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ok_dialog (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		local
			l_i: INTEGER_32
			l_fn: CE_ROUTINE
			l_data: CE_POINTER [ANY]
			js: JUMP_STATE
		do
			create l_fn.make
			create l_data.make

			l_fn.ce_gets ((a_dlg.item.dlg).item.refresh)
			l_data.ce_gets ((a_dlg.item.dlg).item.refresh_data)
			if (check_dialog (a_dlg)).to_boolean then
				Result := 1
				js.return
			end
			if not js.return_called then
				l_i := 0
				from
				until
					not (l_i < a_dlg.item.n)
				loop
					memcpy (create {CE_POINTER [ANY]}.make_cast ((a_dlg.item.dlg).item.items[l_i].data), create {CE_POINTER [ANY]}.make_cast (a_dlg.item.items[l_i].cdata), ((a_dlg.item.dlg).item.items[l_i].dlen).to_natural_32).do_nothing
					l_i := l_i + 1
				end
				if ((l_fn).c_pointer /= default_pointer) then
					l_fn.call ([l_data])
				end
				l_i := cancel_dialog (a_dlg, a_di)
				Result := l_i
			end
		end

	ok_dialog_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ok_dialog)
		end

	center_dlg (a_dlg: CE_POINTER [PD_DIALOG_DATA])
		do
			a_dlg.item.x := (((a_dlg.item.win).item.term).item.x - a_dlg.item.xw) // 2
			a_dlg.item.y := (((a_dlg.item.win).item.term).item.y - a_dlg.item.yw) // 2
		end

	draw_dlg (a_dlg: CE_POINTER [PD_DIALOG_DATA])
		do
			terminal_inst.fill_area ((a_dlg.item.win).item.term, a_dlg.item.x, a_dlg.item.y, a_dlg.item.xw, a_dlg.item.yw, {NATURAL_32} 14336)
		end

	max_text_width (a_term: CE_POINTER [PD_TERMINAL]; a_text: CE_POINTER [NATURAL_8]; a_width: CE_POINTER [INTEGER_32])
		local
			l_text: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_text.make
			create l_tmp.make

			l_text.ce_gets (a_text)
			l_text.ce_gets (language_inst.get_text_translation (l_text, a_term))
			from
			until
				js.loop_left
			loop
				js.reset
				l_c := 0
				from
				until
					js.loop_left
				loop
					js.reset
					if (l_text.item).to_boolean then
						if (l_text.item).to_integer_32 = 10 then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_text.ce_gets (l_text + 1)
						l_c := l_c + 1
					end
				end
				js.reset
				if l_c > a_width.item then
					a_width.item := l_c
				end
				l_tmp.ce_gets (l_text)
				l_text.ce_gets (l_text + 1)
				if not (l_tmp.item).to_boolean then
					js.break
				end
			end
			js.reset
		end

	max_text_width_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent max_text_width)
		end

	min_text_width (a_term: CE_POINTER [PD_TERMINAL]; a_text: CE_POINTER [NATURAL_8]; a_width: CE_POINTER [INTEGER_32])
		local
			l_text: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_text.make
			create l_tmp.make

			l_text.ce_gets (a_text)
			l_text.ce_gets (language_inst.get_text_translation (l_text, a_term))
			from
			until
				js.loop_left
			loop
				js.reset
				l_c := 0
				from
				until
					js.loop_left
				loop
					js.reset
					if (l_text.item).to_boolean then
						if (l_text.item).to_integer_32 /= 10 then
							if (l_text.item).to_integer_32 = 32 then
								js.break
							end
						else
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_text.ce_gets (l_text + 1)
						l_c := l_c + 1
					end
				end
				js.reset
				if l_c > a_width.item then
					a_width.item := l_c
				end
				l_tmp.ce_gets (l_text)
				l_text.ce_gets (l_text + 1)
				if not (l_tmp.item).to_boolean then
					js.break
				end
			end
			js.reset
		end

	min_text_width_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent min_text_width)
		end

	dlg_format_text (a_term: CE_POINTER [PD_TERMINAL]; a_t2: CE_POINTER [PD_TERMINAL]; a_text: CE_POINTER [NATURAL_8]; a_x: INTEGER_32; a_y: CE_POINTER [INTEGER_32]; a_w: INTEGER_32; a_rw: CE_POINTER [INTEGER_32]; a_co: INTEGER_32; a_align: INTEGER_32)
		local
			l_text: CE_POINTER [NATURAL_8]
			l_rw: CE_POINTER [INTEGER_32]
			l_tx: CE_POINTER [NATURAL_8]
			l_tt: CE_POINTER [NATURAL_8]
			l_s: INTEGER_32
			l_xx: INTEGER_32
			js: JUMP_STATE
		do
			create l_text.make
			create l_rw.make
			create l_tx.make
			create l_tt.make

			l_text.ce_gets (a_text)
			l_rw.ce_gets (a_rw)
			l_text.ce_gets (language_inst.get_text_translation (l_text, a_t2))
			from
			until
				js.loop_left
			loop
				js.reset
				l_tt.ce_gets (l_text)
				l_xx := a_x
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						if (l_text.item).to_boolean then
							if (l_text.item).to_integer_32 /= 10 then
								if (l_text.item).to_integer_32 = 32 then
									js.break
								end
							else
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_text.ce_gets (l_text + 1)
							l_xx := l_xx + 1
						end
					end
					js.reset
					l_text.ce_gets (l_text + 1)
					l_tx.ce_gets (l_text)
					l_xx := l_xx + 1
					if (l_text[-1]).to_integer_32 /= 32 then
						js.break
					end
					if not js.loop_jumped then
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_tx.item).to_boolean then
								if (l_tx.item).to_integer_32 /= 10 then
									if (l_tx.item).to_integer_32 = 32 then
										js.break
									end
								else
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_tx.ce_gets (l_tx + 1)
							end
						end
						js.reset
						if not (((l_tx.distance (l_text)) + l_xx) - a_x <= a_w) then
							js.break
						end
					end
				end
				js.reset
				if ((a_align).bit_and (127)) = 1 then
					l_s := (a_w - ((l_xx - 1) - a_x)) // 2
				else
					l_s := 0
				end
				if l_s < 0 then
					l_s := 0
				end
				from
				until
					not ((l_tt.c_pointer.to_integer_32).to_natural_32 < ((l_text - 1).c_pointer.to_integer_32).to_natural_32)
				loop
					if l_s >= a_w then
						l_s := 0
						a_y.item := (a_y.item) + 1
						if ((l_rw).c_pointer /= default_pointer) then
							l_rw.item := a_w
						end
						l_rw.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
					end
					if ((a_term).c_pointer /= default_pointer) then
						terminal_inst.set_char (a_term, a_x + l_s, a_y.item, ((a_co).bit_or ((l_tt.item).to_integer_32)).to_natural_32)
					end
					l_s := l_s + 1
					l_tt.ce_gets (l_tt + 1)
				end
				if ((l_rw).c_pointer /= default_pointer) then
					if (l_xx - 1) - a_x > l_rw.item then
						l_rw.item := (l_xx - 1) - a_x
					end
				end
				a_y.item := (a_y.item) + 1
				if not (l_text[-1]).to_boolean then
					js.break
				end
			end
			js.reset
		end

	max_buttons_width (a_term: CE_POINTER [PD_TERMINAL]; a_butt: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_n: INTEGER_32; a_width: CE_POINTER [INTEGER_32])
		local
			l_butt: CE_POINTER [PD_DIALOG_ITEM_DATA]
			l_w: INTEGER_32
			l_i: INTEGER_32
			l_tmp: CE_POINTER [PD_DIALOG_ITEM_DATA]
		do
			create l_butt.make
			create l_tmp.make

			l_butt.ce_gets (a_butt)
			l_w := -2
			l_i := 0
			from
			until
				not (l_i < a_n)
			loop
				l_tmp.ce_gets (l_butt)
				l_butt.ce_gets (l_butt + 1)
				l_w := (l_w.to_natural_32 + ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((language_inst.get_text_translation ((l_tmp.item.item).item.text, a_term))))) + {NATURAL_32} 6)).to_integer_32
				l_i := l_i + 1
			end
			if l_w > a_width.item then
				a_width.item := l_w
			end
		end

	min_buttons_width (a_term: CE_POINTER [PD_TERMINAL]; a_butt: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_n: INTEGER_32; a_width: CE_POINTER [INTEGER_32])
		local
			l_butt: CE_POINTER [PD_DIALOG_ITEM_DATA]
			l_i: INTEGER_32
			l_w: INTEGER_32
			l_tmp: CE_POINTER [PD_DIALOG_ITEM_DATA]
		do
			create l_butt.make
			create l_tmp.make

			l_butt.ce_gets (a_butt)
			l_i := 0
			from
			until
				not (l_i < a_n)
			loop
				l_tmp.ce_gets (l_butt)
				l_butt.ce_gets (l_butt + 1)
				l_w := ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((language_inst.get_text_translation ((l_tmp.item.item).item.text, a_term))))) + {NATURAL_32} 4).to_integer_32
				if l_w > a_width.item then
					a_width.item := l_w
				end
				l_i := l_i + 1
			end
		end

	dlg_format_buttons (a_term: CE_POINTER [PD_TERMINAL]; a_t2: CE_POINTER [PD_TERMINAL]; a_butt: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_n: INTEGER_32; a_x: INTEGER_32; a_y: CE_POINTER [INTEGER_32]; a_w: INTEGER_32; a_rw: CE_POINTER [INTEGER_32]; a_align: INTEGER_32)
		local
			l_i1: INTEGER_32
			l_i2: INTEGER_32
			l_mw: INTEGER_32
			l_tmp: INTEGER_32
			l_i: INTEGER_32
			l_p: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			l_i1 := 0
			from
			until
				not (not js.loop_left and then (l_i1 < a_n))
			loop
				l_i2 := l_i1 + 1
				from
				until
					not (not js.loop_left and then (l_i2 < a_n))
				loop
					js.reset
					l_mw := 0
					max_buttons_width (a_t2, a_butt + l_i1, (l_i2 - l_i1) + 1, create {CE_POINTER [INTEGER_32]}.make_shared ($l_mw))
					if l_mw <= a_w then
						l_i2 := l_i2 + 1
					else
						js.break
					end
				end
				js.reset
				l_mw := 0
				max_buttons_width (a_t2, a_butt + l_i1, l_i2 - l_i1, create {CE_POINTER [INTEGER_32]}.make_shared ($l_mw))
				if ((a_rw).c_pointer /= default_pointer) then
					if l_mw > a_rw.item then
						l_tmp := l_mw
						a_rw.item := l_tmp
						if l_tmp > a_w then
							a_rw.item := a_w
						end
					end
				end
				if ((a_term).c_pointer /= default_pointer) then
					if ((a_align).bit_and (127)) = 1 then
						l_tmp___0 := (a_w - l_mw) // 2
					else
						l_tmp___0 := 0
					end
					l_p := a_x + l_tmp___0
					l_i := l_i1
					from
					until
						not (l_i < l_i2)
					loop
						(a_butt + l_i).item.x := l_p;
						(a_butt + l_i).item.y := a_y.item
						l_tmp___1 := ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((language_inst.get_text_translation (((a_butt + l_i).item.item).item.text, a_t2))))) + {NATURAL_32} 4).to_integer_32;
						(a_butt + l_i).item.l := l_tmp___1
						l_p := l_p + (l_tmp___1 + 2)
						l_i := l_i + 1
					end
				end
				a_y.item := a_y.item + (2)
				l_i1 := l_i2
			end
		end

	dlg_format_checkbox (a_term: CE_POINTER [PD_TERMINAL]; a_t2: CE_POINTER [PD_TERMINAL]; a_chkb: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_x: INTEGER_32; a_y: CE_POINTER [INTEGER_32]; a_w: INTEGER_32; a_rw: CE_POINTER [INTEGER_32]; a_text: CE_POINTER [NATURAL_8])
		do
			if ((a_term).c_pointer /= default_pointer) then
				a_chkb.item.x := a_x
				a_chkb.item.y := a_y.item
			end
			if ((a_rw).c_pointer /= default_pointer) then
				a_rw.item := a_rw.item - (4)
			end
			dlg_format_text (a_term, a_t2, a_text, a_x + 4, a_y, a_w - 4, a_rw, 14336, 0)
			if ((a_rw).c_pointer /= default_pointer) then
				a_rw.item := a_rw.item + (4)
			end
		end

	dlg_format_checkboxes (a_term: CE_POINTER [PD_TERMINAL]; a_t2: CE_POINTER [PD_TERMINAL]; a_chkb: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_n: INTEGER_32; a_x: INTEGER_32; a_y: CE_POINTER [INTEGER_32]; a_w: INTEGER_32; a_rw: CE_POINTER [INTEGER_32]; a_texts: CE_POINTER [CE_POINTER [NATURAL_8]])
		local
			l_chkb: CE_POINTER [PD_DIALOG_ITEM_DATA]
			l_n: INTEGER_32
			l_texts: CE_POINTER [CE_POINTER [NATURAL_8]]
		do
			create l_chkb.make
			create l_texts.make

			l_chkb.ce_gets (a_chkb)
			l_n := a_n
			l_texts.ce_gets (a_texts)
			from
			until
				not (l_n.to_boolean)
			loop
				dlg_format_checkbox (a_term, a_t2, l_chkb, a_x, a_y, a_w, a_rw, (language_inst.get_text_translation (l_texts[0], a_t2)))
				l_texts.ce_gets (l_texts + 1)
				l_chkb.ce_gets (l_chkb + 1)
				l_n := l_n - 1
			end
		end

	checkboxes_width (a_term: CE_POINTER [PD_TERMINAL]; a_texts: CE_POINTER [CE_POINTER [NATURAL_8]]; a_w: CE_POINTER [INTEGER_32]; a_fn: CE_ROUTINE)
		local
			l_texts: CE_POINTER [CE_POINTER [NATURAL_8]]
		do
			create l_texts.make

			l_texts.ce_gets (a_texts)
			from
			until
				(l_texts[0]).c_pointer = default_pointer
			loop
				a_w.item := a_w.item - (4)
				a_fn.call ([a_term, (language_inst.get_text_translation (l_texts[0], a_term)), a_w])
				a_w.item := a_w.item + (4)
				l_texts.ce_gets (l_texts + 1)
			end
		end

	dlg_format_field (a_term: CE_POINTER [PD_TERMINAL]; a_t2: CE_POINTER [PD_TERMINAL]; a_item: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_x: INTEGER_32; a_y: CE_POINTER [INTEGER_32]; a_w: INTEGER_32; a_rw: CE_POINTER [INTEGER_32]; a_align: INTEGER_32)
		local
			l_tmp: INTEGER_32
		do
			a_item.item.x := a_x
			a_item.item.y := a_y.item
			a_item.item.l := a_w
			if ((a_rw).c_pointer /= default_pointer) then
				if a_item.item.l > a_rw.item then
					l_tmp := a_item.item.l
					a_rw.item := l_tmp
					if l_tmp > a_w then
						a_rw.item := a_w
					end
				end
			end
			a_y.item := (a_y.item) + 1
		end

	dlg_format_box (a_term: CE_POINTER [PD_TERMINAL]; a_t2: CE_POINTER [PD_TERMINAL]; a_item: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_x: INTEGER_32; a_y: CE_POINTER [INTEGER_32]; a_w: INTEGER_32; a_rw: CE_POINTER [INTEGER_32]; a_align: INTEGER_32)
		local
			l_tmp: INTEGER_32
		do
			a_item.item.x := a_x
			a_item.item.y := a_y.item
			a_item.item.l := a_w
			if ((a_rw).c_pointer /= default_pointer) then
				if a_item.item.l > a_rw.item then
					l_tmp := a_item.item.l
					a_rw.item := l_tmp
					if l_tmp > a_w then
						a_rw.item := a_w
					end
				end
			end
			a_y.item := a_y.item + ((a_item.item.item).item.gid)
		end

	max_group_width (a_term: CE_POINTER [PD_TERMINAL]; a_texts: CE_POINTER [CE_POINTER [NATURAL_8]]; a_item: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_n: INTEGER_32; a_w: CE_POINTER [INTEGER_32])
		local
			l_texts: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_item: CE_POINTER [PD_DIALOG_ITEM_DATA]
			l_n: INTEGER_32
			l_ww: INTEGER_32
			l_wx: INTEGER_32
			l_tmp___1: NATURAL_32
			l_tmp___2: NATURAL_32
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
		do
			create l_texts.make
			create l_item.make

			l_texts.ce_gets (a_texts)
			l_item.ce_gets (a_item)
			l_n := a_n
			l_ww := 0
			from
			until
				js.loop_left
			loop
				js.reset
				l_tmp___5 := l_n
				l_n := l_n - 1
				if not l_tmp___5.to_boolean then
					js.break
				end
				if not js.loop_jumped then
					if (l_item.item.item).item.type = 1 then
						l_tmp___2 := (4).to_natural_32
					else
						if (l_item.item.item).item.type = 4 then
							l_tmp___1 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((language_inst.get_text_translation ((l_item.item.item).item.text, a_term))))) + {NATURAL_32} 5
						else
							l_tmp___1 := ((l_item.item.item).item.dlen).to_natural_32 + {NATURAL_32} 1
						end
						l_tmp___2 := l_tmp___1
					end
					l_wx := l_tmp___2.to_integer_32
					l_wx := (l_wx.to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((language_inst.get_text_translation (l_texts[0], a_term)))))).to_integer_32
					if l_n.to_boolean then
						l_wx := l_wx + 1
					end
					l_ww := l_ww + l_wx
					l_texts.ce_gets (l_texts + 1)
					l_item.ce_gets (l_item + 1)
				end
			end
			js.reset
			if l_ww > a_w.item then
				a_w.item := l_ww
			end
		end

	min_group_width (a_term: CE_POINTER [PD_TERMINAL]; a_texts: CE_POINTER [CE_POINTER [NATURAL_8]]; a_item: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_n: INTEGER_32; a_w: CE_POINTER [INTEGER_32])
		local
			l_texts: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_item: CE_POINTER [PD_DIALOG_ITEM_DATA]
			l_n: INTEGER_32
			l_wx: INTEGER_32
			l_tmp___1: NATURAL_32
			l_tmp___2: NATURAL_32
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
		do
			create l_texts.make
			create l_item.make

			l_texts.ce_gets (a_texts)
			l_item.ce_gets (a_item)
			l_n := a_n
			from
			until
				js.loop_left
			loop
				js.reset
				l_tmp___5 := l_n
				l_n := l_n - 1
				if not l_tmp___5.to_boolean then
					js.break
				end
				if not js.loop_jumped then
					if (l_item.item.item).item.type = 1 then
						l_tmp___2 := (4).to_natural_32
					else
						if (l_item.item.item).item.type = 4 then
							l_tmp___1 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((language_inst.get_text_translation ((l_item.item.item).item.text, a_term))))) + {NATURAL_32} 5
						else
							l_tmp___1 := ((l_item.item.item).item.dlen).to_natural_32 + {NATURAL_32} 1
						end
						l_tmp___2 := l_tmp___1
					end
					l_wx := l_tmp___2.to_integer_32
					l_wx := (l_wx.to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((language_inst.get_text_translation (l_texts[0], a_term)))))).to_integer_32
					if l_wx > a_w.item then
						a_w.item := l_wx
					end
					l_texts.ce_gets (l_texts + 1)
					l_item.ce_gets (l_item + 1)
				end
			end
			js.reset
		end

	dlg_format_group (a_term: CE_POINTER [PD_TERMINAL]; a_t2: CE_POINTER [PD_TERMINAL]; a_texts: CE_POINTER [CE_POINTER [NATURAL_8]]; a_item: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_n: INTEGER_32; a_x: INTEGER_32; a_y: CE_POINTER [INTEGER_32]; a_w: INTEGER_32; a_rw: CE_POINTER [INTEGER_32])
		local
			l_texts: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_item: CE_POINTER [PD_DIALOG_ITEM_DATA]
			l_n: INTEGER_32
			l_nx: INTEGER_32
			l_sl: INTEGER_32
			l_wx: INTEGER_32
			l_tmp___1: NATURAL_32
			l_tmp___2: NATURAL_32
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			js: JUMP_STATE
		do
			create l_texts.make
			create l_item.make
			create l_tmp___6.make

			l_texts.ce_gets (a_texts)
			l_item.ce_gets (a_item)
			l_n := a_n
			l_nx := 0
			from
			until
				js.loop_left
			loop
				js.reset
				l_tmp___10 := l_n
				l_n := l_n - 1
				if not l_tmp___10.to_boolean then
					js.break
				end
				if not js.loop_jumped then
					if (l_item.item.item).item.type = 1 then
						l_tmp___2 := (4).to_natural_32
					else
						if (l_item.item.item).item.type = 4 then
							l_tmp___1 := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((language_inst.get_text_translation ((l_item.item.item).item.text, a_t2))))) + {NATURAL_32} 5
						else
							l_tmp___1 := ((l_item.item.item).item.dlen).to_natural_32 + {NATURAL_32} 1
						end
						l_tmp___2 := l_tmp___1
					end
					l_wx := l_tmp___2.to_integer_32
					if ((language_inst.get_text_translation (l_texts[0], a_t2))[0]).to_boolean then
						l_sl := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((language_inst.get_text_translation (l_texts[0], a_t2))))).to_integer_32
					else
						l_sl := -1
					end
					l_wx := l_wx + l_sl
					if l_nx.to_boolean then
						if l_nx + l_wx > a_w then
							l_nx := 0
							a_y.item := a_y.item + (2)
						end
					end
					if ((a_term).c_pointer /= default_pointer) then
						l_tmp___6.ce_gets (language_inst.get_text_translation (l_texts[0], a_t2))
						terminal_inst.print_text (a_term, (a_x + l_nx) + 4 * ((l_item.item.item).item.type = 1).to_integer, a_y.item, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((language_inst.get_text_translation (l_texts[0], a_t2))))).to_integer_32, l_tmp___6, {NATURAL_32} 14336)
						l_item.item.x := (a_x + l_nx) + (l_sl + 1) * ((l_item.item.item).item.type /= 1).to_integer
						l_item.item.y := a_y.item
						if (l_item.item.item).item.type = 2 then
							l_item.item.l := (l_item.item.item).item.dlen
						elseif (l_item.item.item).item.type = 3 then
							l_item.item.l := (l_item.item.item).item.dlen
						end
					end
					if ((a_rw).c_pointer /= default_pointer) then
						if l_nx + l_wx > a_rw.item then
							l_tmp___9 := l_nx + l_wx
							a_rw.item := l_tmp___9
							if l_tmp___9 > a_w then
								a_rw.item := a_w
							end
						end
					end
					l_nx := l_nx + (l_wx + 1)
					l_texts.ce_gets (l_texts + 1)
					l_item.ce_gets (l_item + 1)
				end
			end
			js.reset
			a_y.item := (a_y.item) + 1
		end

	checkbox_list_fn (a_dlg: CE_POINTER [PD_DIALOG_DATA])
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_max: INTEGER_32
			l_min: INTEGER_32
			l_w: INTEGER_32
			l_rw: INTEGER_32
			l_y: INTEGER_32
		do
			create l_term.make

			l_term.ce_gets ((a_dlg.item.win).item.term)
			l_max := 0
			l_min := 0
			l_y := 0
			checkboxes_width (l_term, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((a_dlg.item.dlg).item.udata), create {CE_POINTER [INTEGER_32]}.make_shared ($l_max), max_text_width_address)
			checkboxes_width (l_term, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((a_dlg.item.dlg).item.udata), create {CE_POINTER [INTEGER_32]}.make_shared ($l_min), min_text_width_address)
			max_buttons_width (l_term, (a_dlg.item.items + a_dlg.item.n) - 2, 2, create {CE_POINTER [INTEGER_32]}.make_shared ($l_max))
			min_buttons_width (l_term, (a_dlg.item.items + a_dlg.item.n) - 2, 2, create {CE_POINTER [INTEGER_32]}.make_shared ($l_min))
			l_w := (l_term.item.x * 9) // 10 - 12
			if l_w > l_max then
				l_w := l_max
			end
			if l_w < l_min then
				l_w := l_min
			end
			if l_w > l_term.item.x - 12 then
				l_w := l_term.item.x - 12
			end
			if l_w < 5 then
				l_w := 5
			end
			l_rw := 0
			dlg_format_checkboxes (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, a_dlg.item.items, a_dlg.item.n - 2, 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rw), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((a_dlg.item.dlg).item.udata))
			l_y := l_y + 1
			dlg_format_buttons (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, (a_dlg.item.items + a_dlg.item.n) - 2, 2, 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rw), 1)
			l_w := l_rw
			a_dlg.item.xw := l_rw + 12
			a_dlg.item.yw := l_y + 4
			center_dlg (a_dlg)
			draw_dlg (a_dlg)
			l_y := (a_dlg.item.y + 2) + 1
			dlg_format_checkboxes (l_term, l_term, a_dlg.item.items, a_dlg.item.n - 2, a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((a_dlg.item.dlg).item.udata))
			l_y := l_y + 1
			dlg_format_buttons (l_term, l_term, (a_dlg.item.items + a_dlg.item.n) - 2, 2, a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rw), 1)
		end

	checkbox_list_fn_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent checkbox_list_fn)
		end

	group_fn (a_dlg: CE_POINTER [PD_DIALOG_DATA])
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_max: INTEGER_32
			l_min: INTEGER_32
			l_w: INTEGER_32
			l_rw: INTEGER_32
			l_y: INTEGER_32
		do
			create l_term.make

			l_term.ce_gets ((a_dlg.item.win).item.term)
			l_max := 0
			l_min := 0
			l_y := 0
			max_group_width (l_term, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((a_dlg.item.dlg).item.udata), a_dlg.item.items, a_dlg.item.n - 2, create {CE_POINTER [INTEGER_32]}.make_shared ($l_max))
			min_group_width (l_term, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((a_dlg.item.dlg).item.udata), a_dlg.item.items, a_dlg.item.n - 2, create {CE_POINTER [INTEGER_32]}.make_shared ($l_min))
			max_buttons_width (l_term, (a_dlg.item.items + a_dlg.item.n) - 2, 2, create {CE_POINTER [INTEGER_32]}.make_shared ($l_max))
			min_buttons_width (l_term, (a_dlg.item.items + a_dlg.item.n) - 2, 2, create {CE_POINTER [INTEGER_32]}.make_shared ($l_min))
			l_w := (l_term.item.x * 9) // 10 - 12
			if l_w > l_max then
				l_w := l_max
			end
			if l_w < l_min then
				l_w := l_min
			end
			if l_w > l_term.item.x - 12 then
				l_w := l_term.item.x - 12
			end
			if l_w < 1 then
				l_w := 1
			end
			l_rw := 0
			dlg_format_group (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((a_dlg.item.dlg).item.udata), a_dlg.item.items, a_dlg.item.n - 2, 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rw))
			l_y := l_y + 1
			dlg_format_buttons (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, (a_dlg.item.items + a_dlg.item.n) - 2, 2, 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rw), 1)
			l_w := l_rw
			a_dlg.item.xw := l_rw + 12
			a_dlg.item.yw := l_y + 4
			center_dlg (a_dlg)
			draw_dlg (a_dlg)
			l_y := (a_dlg.item.y + 2) + 1
			dlg_format_group (l_term, l_term, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((a_dlg.item.dlg).item.udata), a_dlg.item.items, a_dlg.item.n - 2, a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
			l_y := l_y + 1
			dlg_format_buttons (l_term, l_term, (a_dlg.item.items + a_dlg.item.n) - 2, 2, a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rw), 1)
		end

	group_fn_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent group_fn)
		end

	msg_box_fn (a_dlg: CE_POINTER [PD_DIALOG_DATA])
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_max: INTEGER_32
			l_min: INTEGER_32
			l_w: INTEGER_32
			l_rw: INTEGER_32
			l_y: INTEGER_32
			l_ptr: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_text: CE_POINTER [NATURAL_8]
			l_textl: INTEGER_32
		do
			create l_term.make
			create l_ptr.make
			create l_text.make

			l_term.ce_gets ((a_dlg.item.win).item.term)
			l_max := 0
			l_min := 0
			l_y := 0
			l_text.ce_gets ((links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 1175)))
			l_textl := 0
			l_ptr.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((a_dlg.item.dlg).item.udata))
			from
			until
				(l_ptr.item).c_pointer = default_pointer
			loop
				links_inst.add_to_str (l_text.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_textl), (language_inst.get_text_translation (l_ptr.item, l_term)))
				l_ptr.ce_gets (l_ptr + 1)
			end
			max_text_width (l_term, l_text, create {CE_POINTER [INTEGER_32]}.make_shared ($l_max))
			min_text_width (l_term, l_text, create {CE_POINTER [INTEGER_32]}.make_shared ($l_min))
			max_buttons_width (l_term, a_dlg.item.items, a_dlg.item.n, create {CE_POINTER [INTEGER_32]}.make_shared ($l_max))
			min_buttons_width (l_term, a_dlg.item.items, a_dlg.item.n, create {CE_POINTER [INTEGER_32]}.make_shared ($l_min))
			l_w := (l_term.item.x * 9) // 10 - 12
			if l_w > l_max then
				l_w := l_max
			end
			if l_w < l_min then
				l_w := l_min
			end
			if l_w > l_term.item.x - 12 then
				l_w := l_term.item.x - 12
			end
			if l_w < 1 then
				l_w := 1
			end
			l_rw := 0
			dlg_format_text (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, l_text, 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rw), 14336, (a_dlg.item.dlg).item.align)
			l_y := l_y + 1
			dlg_format_buttons (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, a_dlg.item.items, a_dlg.item.n, 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rw), 1)
			l_w := l_rw
			a_dlg.item.xw := l_rw + 12
			a_dlg.item.yw := l_y + 4
			center_dlg (a_dlg)
			draw_dlg (a_dlg)
			l_y := (a_dlg.item.y + 2) + 1
			dlg_format_text (l_term, l_term, l_text, a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 14336, (a_dlg.item.dlg).item.align)
			l_y := l_y + 1
			dlg_format_buttons (l_term, l_term, a_dlg.item.items, a_dlg.item.n, a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 1)
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 1200, create {CE_POINTER [ANY]}.make_cast (l_text))
		end

	msg_box_fn_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent msg_box_fn)
		end

	msg_box_button (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		local
			l_fn: CE_ROUTINE
			l_data: CE_POINTER [ANY]
		do
			create l_fn.make
			create l_data.make

			l_fn.ce_gets (create {CE_ROUTINE}.make_cast ((a_di.item.item).item.udata))
			l_data.ce_gets ((a_dlg.item.dlg).item.udata2)
			if ((l_fn).c_pointer /= default_pointer) then
				l_fn.call ([l_data])
			end
			cancel_dialog (a_dlg, a_di).do_nothing
			Result := 0
		end

	msg_box_button_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent msg_box_button)
		end

	msg_box (a_args: TUPLE [a_term: CE_POINTER [PD_TERMINAL]; a_ml: CE_POINTER [PD_MEMORY_LIST]; a_title: CE_POINTER [NATURAL_8]; a_align: INTEGER_32])
		local
			l_ml: CE_POINTER [PD_MEMORY_LIST]
			l_dlg: CE_POINTER [PD_DIALOG]
			l_i: INTEGER_32
			l_n: INTEGER_32
			l_text: CE_POINTER [NATURAL_8]
			l_udata: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_udata2: CE_POINTER [ANY]
			l_udatan: INTEGER_32
			l_ap: CE_VA_LIST
			l_m: CE_POINTER [NATURAL_8]
			l_fn: CE_ROUTINE
			l_flags: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ml.make
			create l_dlg.make
			create l_text.make
			create l_udata.make
			create l_udata2.make
			create l_m.make
			create l_fn.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ml.ce_gets (a_args.a_ml)
					create l_ap.make (a_args, 5)
					l_udata.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer + -1))
					l_udatan := 0
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 5 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_text.ce_gets ((create {CE_POINTER [NATURAL_8]}.make_cast (l_ap.pointer_item)))
				when 3 then -- na_kovarne__to_je_narez:
						l_udatan := l_udatan + 1
						if l_udatan.to_natural_32 > {NATURAL_32} 2147483647 // Pointer_bytes.to_natural_32 then
							from
							until
								False
							loop
								error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 1230])
								kbd_inst.fatal_tty_exit
								exit (4)
							end
						end
						l_udata.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 1231, create {CE_POINTER [ANY]}.make_cast (l_udata), l_udatan.to_natural_32 * Pointer_bytes.to_natural_32))))
						l_udata[(l_udatan - 1)] := l_text
						if ((l_text).c_pointer /= default_pointer) then
							if not ((a_args.a_align).bit_and (128)).to_boolean then
								l_text.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								l_pos := -1 + 3 -- goto na_kovarne__to_je_narez
							end
						end
				when 4 then
						if (l_text).c_pointer = default_pointer then
							js.break
						end
						l_pos := -1 + 1 -- back to loop condition
				when 5 then -- loop done
					js.reset
					l_udata2.ce_gets ((create {CE_POINTER [ANY]}.make_cast (l_ap.pointer_item)))
					l_n := l_ap.integer_32_item
					if l_n.to_natural_32 > ({NATURAL_32} 2147483647 - {PD_DIALOG}.sizeof.to_natural_32) // {PD_DIALOG_ITEM}.sizeof.to_natural_32 - {NATURAL_32} 1 then
						from
						until
							False
						loop
							error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 1240])
							kbd_inst.fatal_tty_exit
							exit (4)
						end
					end
					l_dlg.ce_gets (create {CE_POINTER [PD_DIALOG]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 1241, {PD_DIALOG}.sizeof.to_natural_32 + (l_n + 1).to_natural_32 * {PD_DIALOG_ITEM}.sizeof.to_natural_32))))
					memset (create {CE_POINTER [ANY]}.make_cast (l_dlg), 0, {PD_DIALOG}.sizeof.to_natural_32 + (l_n + 1).to_natural_32 * {PD_DIALOG_ITEM}.sizeof.to_natural_32).do_nothing
					l_dlg.item.title := a_args.a_title
					l_dlg.item.fn := msg_box_fn_address
					l_dlg.item.udata := create {CE_POINTER [ANY]}.make_cast (l_udata)
					l_dlg.item.udata2 := l_udata2
					l_dlg.item.align := a_args.a_align
					l_i := 0
					from
					until
						not (l_i < l_n)
					loop
						js.reset
						l_m.ce_gets ((create {CE_POINTER [NATURAL_8]}.make_cast (l_ap.pointer_item)))
						l_fn.ce_gets ((create {CE_POINTER [ANY]}.make_cast (l_ap.pointer_item)))
						l_flags := l_ap.integer_32_item
						if (l_m).c_pointer = default_pointer then
							l_i := l_i - 1
							l_n := l_n - 1
							js.continue
						end
						if not js.loop_jumped then
							l_dlg.item.items[l_i].type := 4
							l_dlg.item.items[l_i].gid := l_flags
							l_dlg.item.items[l_i].fn := msg_box_button_address
							l_dlg.item.items[l_i].dlen := 0
							l_dlg.item.items[l_i].text := l_m
							l_dlg.item.items[l_i].udata := create {CE_POINTER [ANY]}.make_cast (l_fn)
						end
						l_i := l_i + 1
					end
					l_dlg.item.items[l_i].type := 0
					add_to_ml ([l_ml.address, l_dlg, l_udata, create {CE_POINTER [ANY]}.make_shared (default_pointer)])
					do_dialog (a_args.a_term, l_dlg, l_ml)
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	add_to_history (a_h: CE_POINTER [PD_HISTORY]; a_t: CE_POINTER [NATURAL_8])
		local
			l_hi: CE_POINTER [PD_HISTORY_ITEM]
			l_hs: CE_POINTER [PD_HISTORY_ITEM]
			l_l: NATURAL_32
			l_hd: CE_POINTER [PD_HISTORY_ITEM]
			l_hd___0: CE_POINTER [PD_HISTORY_ITEM]
			js: JUMP_STATE
		do
			create l_hi.make
			create l_hs.make
			create l_hd.make
			create l_hd___0.make

			if (a_h).c_pointer = default_pointer then
				js.return
			elseif (a_t).c_pointer = default_pointer then
				js.return
			elseif not (a_t.item).to_boolean then
				js.return
			end
			if not js.return_called then
				l_l := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_t))) + {NATURAL_32} 1
				if l_l > {NATURAL_32} 2147483647 - {PD_HISTORY_ITEM}.sizeof.to_natural_32 then
					from
					until
						False
					loop
						error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 1278])
						kbd_inst.fatal_tty_exit
						exit (4)
					end
				end
				l_hi.ce_gets (create {CE_POINTER [PD_HISTORY_ITEM]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 1279, {PD_HISTORY_ITEM}.sizeof.to_natural_32 + l_l))))
				memcpy (create {CE_POINTER [ANY]}.make_cast ((l_hi.item.d)), create {CE_POINTER [ANY]}.make_cast (a_t), l_l).do_nothing
				l_hs.ce_gets (create {CE_POINTER [PD_HISTORY_ITEM]}.make_cast (a_h.item.items.next))
				from
				until
					(l_hs.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_h.c_pointer + {PD_HISTORY}.items_offset)).c_pointer.to_integer_32).to_natural_32
				loop
					if not (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_hs.item.d)), create {CE_POINTER [INTEGER_8]}.make_cast (a_t))).to_boolean then
						l_hd.ce_gets (l_hs)
						l_hs.ce_gets (l_hs.item.prev)
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_hd));
						(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_hd.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_hd.item.prev);
						(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_hd.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_hd.item.next)
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_hd))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 1285, create {CE_POINTER [ANY]}.make_cast (l_hd))
						a_h.item.n := (a_h.item.n) - 1
					end
					l_hs.ce_gets (l_hs.item.next)
				end
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_h.c_pointer + {PD_HISTORY}.items_offset))))
					l_hi.item.next := (create {CE_POINTER [PD_HISTORY_ITEM]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_h.c_pointer + {PD_HISTORY}.items_offset)))).item.next
					l_hi.item.prev := create {CE_POINTER [PD_HISTORY_ITEM]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_h.c_pointer + {PD_HISTORY}.items_offset)));
					(create {CE_POINTER [PD_HISTORY_ITEM]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_h.c_pointer + {PD_HISTORY}.items_offset)))).item.next := l_hi;
					(l_hi.item.next).item.prev := l_hi
					error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_h.c_pointer + {PD_HISTORY}.items_offset))))
					js.break
				end
				js.reset
				a_h.item.n := (a_h.item.n) + 1
				from
				until
					not (not js.loop_left and then (a_h.item.n > 4096))
				loop
					l_hd___0.ce_gets (create {CE_POINTER [PD_HISTORY_ITEM]}.make_cast (a_h.item.items.prev))
					if (l_hd___0.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_h.c_pointer + {PD_HISTORY}.items_offset)).c_pointer.to_integer_32).to_natural_32 then
						from
						until
							False
						loop
							links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")))
							links_inst.errline := 1293
							error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("history is empty"))])
						end
						a_h.item.n := 0
						js.return
					end
					if not js.return_called then
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_hd___0));
						(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_hd___0.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_hd___0.item.prev);
						(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_hd___0.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_hd___0.item.next)
						error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_hd___0))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 1298, create {CE_POINTER [ANY]}.make_cast (l_hd___0))
						a_h.item.n := (a_h.item.n) - 1
					end
				end
			end
			if not js.return_called then
			end
		end

	input_field_cancel (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		local
			l_fn: CE_ROUTINE
			l_data: CE_POINTER [ANY]
		do
			create l_fn.make
			create l_data.make

			l_fn.ce_gets (create {CE_ROUTINE}.make_cast ((a_di.item.item).item.udata))
			l_data.ce_gets ((a_dlg.item.dlg).item.udata2)
			if ((l_fn).c_pointer /= default_pointer) then
				l_fn.call ([l_data])
			end
			cancel_dialog (a_dlg, a_di).do_nothing
			Result := 0
		end

	input_field_cancel_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent input_field_cancel)
		end

	input_field_ok (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		local
			l_fn: CE_ROUTINE
			l_data: CE_POINTER [ANY]
			l_text: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_fn.make
			create l_data.make
			create l_text.make

			l_fn.ce_gets (create {CE_ROUTINE}.make_cast ((a_di.item.item).item.udata))
			l_data.ce_gets ((a_dlg.item.dlg).item.udata2)
			l_text.ce_gets (a_dlg.item.items[0].cdata)
			if (check_dialog (a_dlg)).to_boolean then
				Result := 1
				js.return
			end
			if not js.return_called then
				add_to_history ((a_dlg.item.dlg).item.items[0].history, l_text)
				if ((l_fn).c_pointer /= default_pointer) then
					l_fn.call ([l_data, l_text])
				end
				ok_dialog (a_dlg, a_di).do_nothing
				Result := 0
			end
		end

	input_field_ok_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent input_field_ok)
		end

	input_field_fn (a_dlg: CE_POINTER [PD_DIALOG_DATA])
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_max: INTEGER_32
			l_min: INTEGER_32
			l_w: INTEGER_32
			l_rw: INTEGER_32
			l_y: INTEGER_32
		do
			create l_term.make

			l_term.ce_gets ((a_dlg.item.win).item.term)
			l_max := 0
			l_min := 0
			l_y := -1
			max_text_width (l_term, create {CE_POINTER [NATURAL_8]}.make_cast ((a_dlg.item.dlg).item.udata), create {CE_POINTER [INTEGER_32]}.make_shared ($l_max))
			min_text_width (l_term, create {CE_POINTER [NATURAL_8]}.make_cast ((a_dlg.item.dlg).item.udata), create {CE_POINTER [INTEGER_32]}.make_shared ($l_min))
			max_buttons_width (l_term, a_dlg.item.items + 1, 2, create {CE_POINTER [INTEGER_32]}.make_shared ($l_max))
			min_buttons_width (l_term, a_dlg.item.items + 1, 2, create {CE_POINTER [INTEGER_32]}.make_shared ($l_min))
			if l_max < (a_dlg.item.dlg).item.items[0].dlen then
				l_max := (a_dlg.item.dlg).item.items[0].dlen
			end
			l_w := (l_term.item.x * 9) // 10 - 12
			if l_w > l_max then
				l_w := l_max
			end
			if l_w < l_min then
				l_w := l_min
			end
			l_rw := 0
			dlg_format_text (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, create {CE_POINTER [NATURAL_8]}.make_cast ((a_dlg.item.dlg).item.udata), 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rw), 14336, 0)
			dlg_format_field (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, a_dlg.item.items, 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rw), 0)
			l_y := l_y + 1
			dlg_format_buttons (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, a_dlg.item.items + 1, 2, 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rw), 1)
			l_w := l_rw
			a_dlg.item.xw := l_rw + 12
			a_dlg.item.yw := l_y + 4
			center_dlg (a_dlg)
			draw_dlg (a_dlg)
			l_y := a_dlg.item.y + 2
			dlg_format_text (l_term, l_term, create {CE_POINTER [NATURAL_8]}.make_cast ((a_dlg.item.dlg).item.udata), a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 14336, 0)
			dlg_format_field (l_term, l_term, a_dlg.item.items, a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0)
			l_y := l_y + 1
			dlg_format_buttons (l_term, l_term, a_dlg.item.items + 1, 2, a_dlg.item.x + 6, create {CE_POINTER [INTEGER_32]}.make_shared ($l_y), l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 1)
		end

	input_field_fn_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent input_field_fn)
		end

	input_field (a_term: CE_POINTER [PD_TERMINAL]; a_ml: CE_POINTER [PD_MEMORY_LIST]; a_title: CE_POINTER [NATURAL_8]; a_text: CE_POINTER [NATURAL_8]; a_okbutton: CE_POINTER [NATURAL_8]; a_cancelbutton: CE_POINTER [NATURAL_8]; a_data: CE_POINTER [ANY]; a_history: CE_POINTER [PD_HISTORY]; a_l: INTEGER_32; a_def: CE_POINTER [NATURAL_8]; a_min: INTEGER_32; a_max: INTEGER_32; a_check: CE_ROUTINE; a_fn: CE_ROUTINE; a_cancelfn: CE_ROUTINE)
		local
			l_ml: CE_POINTER [PD_MEMORY_LIST]
			l_dlg: CE_POINTER [PD_DIALOG]
			l_field: CE_POINTER [NATURAL_8]
		do
			create l_ml.make
			create l_dlg.make
			create l_field.make

			l_ml.ce_gets (a_ml)
			if a_l.to_natural_32 > ({NATURAL_32} 2147483647 - {PD_DIALOG}.sizeof.to_natural_32) + {NATURAL_32} 4 * {PD_DIALOG_ITEM}.sizeof.to_natural_32 then
				from
				until
					False
				loop
					error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 1359])
					kbd_inst.fatal_tty_exit
					exit (4)
				end
			end
			l_dlg.ce_gets (create {CE_POINTER [PD_DIALOG]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")), 1360, ({PD_DIALOG}.sizeof.to_natural_32 + {NATURAL_32} 4 * {PD_DIALOG_ITEM}.sizeof.to_natural_32) + a_l.to_natural_32))))
			memset (create {CE_POINTER [ANY]}.make_cast (l_dlg), 0, ({PD_DIALOG}.sizeof.to_natural_32 + {NATURAL_32} 4 * {PD_DIALOG_ITEM}.sizeof.to_natural_32) + a_l.to_natural_32).do_nothing
			l_field.ce_gets ((create {CE_POINTER [NATURAL_8]}.make_cast (l_dlg) + ({PD_DIALOG}.sizeof.to_natural_32).to_integer_32) + ({NATURAL_32} 4 * {PD_DIALOG_ITEM}.sizeof.to_natural_32).to_integer_32)
			l_field.item := (0).to_natural_8
			if ((a_def).c_pointer /= default_pointer) then
				if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_def))) + {NATURAL_32} 1 > a_l.to_natural_32 then
					memcpy (create {CE_POINTER [ANY]}.make_cast (l_field), create {CE_POINTER [ANY]}.make_cast (a_def), (a_l - 1).to_natural_32).do_nothing
				else
					strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_field), create {CE_POINTER [INTEGER_8]}.make_cast (a_def)).do_nothing
				end
			end
			l_dlg.item.title := a_title
			l_dlg.item.fn := input_field_fn_address
			l_dlg.item.udata := create {CE_POINTER [ANY]}.make_cast (a_text)
			l_dlg.item.udata2 := a_data
			l_dlg.item.items[0].type := 2
			l_dlg.item.items[0].gid := a_min
			l_dlg.item.items[0].gnum := a_max
			l_dlg.item.items[0].fn := a_check
			l_dlg.item.items[0].history := a_history
			l_dlg.item.items[0].dlen := a_l
			l_dlg.item.items[0].data := l_field
			l_dlg.item.items[1].type := 4
			l_dlg.item.items[1].gid := 1
			l_dlg.item.items[1].fn := input_field_ok_address
			l_dlg.item.items[1].dlen := 0
			l_dlg.item.items[1].text := a_okbutton
			l_dlg.item.items[1].udata := create {CE_POINTER [ANY]}.make_cast (a_fn)
			l_dlg.item.items[2].type := 4
			l_dlg.item.items[2].gid := 2
			l_dlg.item.items[2].fn := input_field_cancel_address
			l_dlg.item.items[2].dlen := 0
			l_dlg.item.items[2].text := a_cancelbutton
			l_dlg.item.items[2].udata := create {CE_POINTER [ANY]}.make_cast (a_cancelfn)
			l_dlg.item.items[3].type := 0
			add_to_ml ([l_ml.address, l_dlg, create {CE_POINTER [ANY]}.make_shared (default_pointer)])
			do_dialog (a_term, l_dlg, l_ml)
		end

	box_sel_set_visible (a_box_item_data: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_offset: INTEGER_32)
		local
			l_box: CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]
			l_sel: INTEGER_32
			js: JUMP_STATE
		do
			create l_box.make

			l_box.ce_gets (create {CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast ((a_box_item_data.item.item).item.data))
			if a_offset > (a_box_item_data.item.item).item.gid then
				js.return
			elseif a_offset < 0 then
				js.return
			end
			if not js.return_called then
				l_sel := l_box.item.box_top + a_offset
				if l_sel > l_box.item.list_len then
					l_box.item.sel := l_box.item.list_len - 1
				else
					l_box.item.sel := l_sel
				end
			end
		end

	box_sel_move (a_box_item_data: CE_POINTER [PD_DIALOG_ITEM_DATA]; a_dist: INTEGER_32)
		local
			l_box: CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]
			l_new_sel: INTEGER_32
			l_new_top: INTEGER_32
		do
			create l_box.make

			l_box.ce_gets (create {CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast ((a_box_item_data.item.item).item.data))
			l_new_sel := l_box.item.sel + a_dist
			l_new_top := l_box.item.box_top
			if l_new_sel < 0 then
				l_new_sel := 0
			elseif l_new_sel >= l_box.item.list_len then
				l_new_sel := l_box.item.list_len - 1
			end
			if l_new_sel >= l_new_top + (a_box_item_data.item.item).item.gid then
				l_new_top := (l_new_sel - (a_box_item_data.item.item).item.gid) + 1
				if l_new_top < 0 then
					links_inst.errfile.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfu.c")))
					links_inst.errline := 1439
					error_inst.debug_msg ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Newly calculated box_top is an extremely wrong value (%%d). It should not be below zero.")), l_new_top])
				end
			elseif l_new_sel < l_new_top then
				l_new_top := l_new_sel
			end
			l_box.item.sel := l_new_sel
			l_box.item.box_top := l_new_top
		end

	show_dlg_item_box (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_box_item_data: CE_POINTER [PD_DIALOG_ITEM_DATA])
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_box: CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]
			l_citem: CE_POINTER [PD_BOX_ITEM]
			l_n: INTEGER_32
			l_len: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			create l_term.make
			create l_box.make
			create l_citem.make

			l_term.ce_gets ((a_dlg.item.win).item.term)
			l_box.ce_gets (create {CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX]}.make_cast ((a_box_item_data.item.item).item.data))
			l_n := 0
			terminal_inst.fill_area (l_term, a_box_item_data.item.x, a_box_item_data.item.y, a_box_item_data.item.l, (a_box_item_data.item.item).item.gid, {NATURAL_32} 1792)
			l_citem.ce_gets (create {CE_POINTER [PD_BOX_ITEM]}.make_cast (l_box.item.items.next))
			from
			until
				(l_citem.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (l_box.c_pointer + {PD_DLG_DATA_ITEM_DATA_BOX}.items_offset)).c_pointer.to_integer_32).to_natural_32
			loop
				l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_citem.item.text))).to_integer_32
				if l_len > a_box_item_data.item.l then
					l_len := a_box_item_data.item.l
				end
				if l_n >= l_box.item.box_top then
					if l_n < l_box.item.box_top + (a_box_item_data.item.item).item.gid then
						if l_n = l_box.item.sel then
							l_tmp___0 := 18176
						else
							l_tmp___0 := 1792
						end
						terminal_inst.print_text (l_term, a_box_item_data.item.x, (a_box_item_data.item.y + l_n) - l_box.item.box_top, l_len, l_citem.item.text, l_tmp___0.to_natural_32)
					end
				end
				l_n := l_n + 1
				l_citem.ce_gets (l_citem.item.next)
			end
			l_box.item.list_len := l_n
		end

end
