class
	SD_SIGFAULT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	si_addr: CE_POINTER [ANY] assign set_si_addr
		do
			create Result.make_shared (c_si_addr (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_si_addr (a_si_addr: CE_POINTER [ANY])
		do
			c_set_si_addr (c_pointer, a_si_addr.c_pointer)
		end

feature {NONE} -- C getters

	c_si_addr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct__sigfault_36 *)$tmp)->si_addr;"
		end

feature {NONE} -- C setters

	c_set_si_addr (tmp: POINTER; a_si_addr: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct__sigfault_36 *)$tmp)->si_addr = (void *)$a_si_addr;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct __anonstruct__sigfault_36);"
		end

end
