class
	SD_SIGSET_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	val: CE_ARRAY [NATURAL_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_val (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {NONE} -- C getters

	c_val (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct___sigset_t_13 *tmp = (struct __anonstruct___sigset_t_13 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->__val) / sizeof(tmp->__val[0]);
				return tmp->__val;
			]"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct __anonstruct___sigset_t_13);"
		end

end
