class
	SD_TIMEZONE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	tz_minuteswest: INTEGER_32 assign set_tz_minuteswest
		do
			Result := c_tz_minuteswest (c_pointer)
		end

	tz_dsttime: INTEGER_32 assign set_tz_dsttime
		do
			Result := c_tz_dsttime (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_tz_minuteswest (a_tz_minuteswest: INTEGER_32)
		do
			c_set_tz_minuteswest (c_pointer, a_tz_minuteswest)
		end

	set_tz_dsttime (a_tz_dsttime: INTEGER_32)
		do
			c_set_tz_dsttime (c_pointer, a_tz_dsttime)
		end

feature {NONE} -- C getters

	c_tz_minuteswest (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct timezone *)$tmp)->tz_minuteswest;"
		end

	c_tz_dsttime (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct timezone *)$tmp)->tz_dsttime;"
		end

feature {NONE} -- C setters

	c_set_tz_minuteswest (tmp: POINTER; a_tz_minuteswest: INTEGER_32)
		external
			"C inline"
		alias
			"((struct timezone *)$tmp)->tz_minuteswest = $a_tz_minuteswest;"
		end

	c_set_tz_dsttime (tmp: POINTER; a_tz_dsttime: INTEGER_32)
		external
			"C inline"
		alias
			"((struct timezone *)$tmp)->tz_dsttime = $a_tz_dsttime;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct timezone);"
		end

end
