class
	PD_AE_U

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	term: PD_TERM assign set_term
		do
			create Result.make_shared (c_term (c_pointer))
		end

	cterm: PD_CTERM assign set_cterm
		do
			create Result.make_shared (c_cterm (c_pointer))
		end

	gui: PD_GUI2 assign set_gui
		do
			create Result.make_shared (c_gui (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_term (a_term: PD_TERM)
		do
			term.ce_gets (a_term)
		end

	set_cterm (a_cterm: PD_CTERM)
		do
			cterm.ce_gets (a_cterm)
		end

	set_gui (a_gui: PD_GUI2)
		do
			gui.ce_gets (a_gui)
		end

feature {NONE} -- C getters

	c_term (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct __anonstruct_term_525 *)&((union __anonunion_ae_u_524 *)$tmp)->term;"
		end

	c_cterm (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct __anonstruct_cterm_526 *)&((union __anonunion_ae_u_524 *)$tmp)->cterm;"
		end

	c_gui (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct __anonstruct_gui_527 *)&((union __anonunion_ae_u_524 *)$tmp)->gui;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(union __anonunion_ae_u_524);"
		end

end
