class
	PD_AFFFILE_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	af_enc: CE_POINTER [NATURAL_8] assign set_af_enc
		do
			create Result.make_shared (c_af_enc (c_pointer))
		end

	af_flagtype: INTEGER_32 assign set_af_flagtype
		do
			Result := c_af_flagtype (c_pointer)
		end

	af_rare: NATURAL_32 assign set_af_rare
		do
			Result := c_af_rare (c_pointer)
		end

	af_keepcase: NATURAL_32 assign set_af_keepcase
		do
			Result := c_af_keepcase (c_pointer)
		end

	af_bad: NATURAL_32 assign set_af_bad
		do
			Result := c_af_bad (c_pointer)
		end

	af_needaffix: NATURAL_32 assign set_af_needaffix
		do
			Result := c_af_needaffix (c_pointer)
		end

	af_circumfix: NATURAL_32 assign set_af_circumfix
		do
			Result := c_af_circumfix (c_pointer)
		end

	af_needcomp: NATURAL_32 assign set_af_needcomp
		do
			Result := c_af_needcomp (c_pointer)
		end

	af_comproot: NATURAL_32 assign set_af_comproot
		do
			Result := c_af_comproot (c_pointer)
		end

	af_compforbid: NATURAL_32 assign set_af_compforbid
		do
			Result := c_af_compforbid (c_pointer)
		end

	af_comppermit: NATURAL_32 assign set_af_comppermit
		do
			Result := c_af_comppermit (c_pointer)
		end

	af_nosuggest: NATURAL_32 assign set_af_nosuggest
		do
			Result := c_af_nosuggest (c_pointer)
		end

	af_pfxpostpone: INTEGER_32 assign set_af_pfxpostpone
		do
			Result := c_af_pfxpostpone (c_pointer)
		end

	af_pref: PD_HASHTABLE_S assign set_af_pref
		do
			create Result.make_shared (c_af_pref (c_pointer))
		end

	af_pref_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct afffile_S, af_pref);"
		end

	af_suff: PD_HASHTABLE_S assign set_af_suff
		do
			create Result.make_shared (c_af_suff (c_pointer))
		end

	af_suff_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct afffile_S, af_suff);"
		end

	af_comp: PD_HASHTABLE_S assign set_af_comp
		do
			create Result.make_shared (c_af_comp (c_pointer))
		end

	af_comp_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct afffile_S, af_comp);"
		end

feature {ANY} -- Eiffel setters

	set_af_enc (a_af_enc: CE_POINTER [NATURAL_8])
		do
			c_set_af_enc (c_pointer, a_af_enc.c_pointer)
		end

	set_af_flagtype (a_af_flagtype: INTEGER_32)
		do
			c_set_af_flagtype (c_pointer, a_af_flagtype)
		end

	set_af_rare (a_af_rare: NATURAL_32)
		do
			c_set_af_rare (c_pointer, a_af_rare)
		end

	set_af_keepcase (a_af_keepcase: NATURAL_32)
		do
			c_set_af_keepcase (c_pointer, a_af_keepcase)
		end

	set_af_bad (a_af_bad: NATURAL_32)
		do
			c_set_af_bad (c_pointer, a_af_bad)
		end

	set_af_needaffix (a_af_needaffix: NATURAL_32)
		do
			c_set_af_needaffix (c_pointer, a_af_needaffix)
		end

	set_af_circumfix (a_af_circumfix: NATURAL_32)
		do
			c_set_af_circumfix (c_pointer, a_af_circumfix)
		end

	set_af_needcomp (a_af_needcomp: NATURAL_32)
		do
			c_set_af_needcomp (c_pointer, a_af_needcomp)
		end

	set_af_comproot (a_af_comproot: NATURAL_32)
		do
			c_set_af_comproot (c_pointer, a_af_comproot)
		end

	set_af_compforbid (a_af_compforbid: NATURAL_32)
		do
			c_set_af_compforbid (c_pointer, a_af_compforbid)
		end

	set_af_comppermit (a_af_comppermit: NATURAL_32)
		do
			c_set_af_comppermit (c_pointer, a_af_comppermit)
		end

	set_af_nosuggest (a_af_nosuggest: NATURAL_32)
		do
			c_set_af_nosuggest (c_pointer, a_af_nosuggest)
		end

	set_af_pfxpostpone (a_af_pfxpostpone: INTEGER_32)
		do
			c_set_af_pfxpostpone (c_pointer, a_af_pfxpostpone)
		end

	set_af_pref (a_af_pref: PD_HASHTABLE_S)
		do
			af_pref.ce_gets (a_af_pref)
		end

	set_af_suff (a_af_suff: PD_HASHTABLE_S)
		do
			af_suff.ce_gets (a_af_suff)
		end

	set_af_comp (a_af_comp: PD_HASHTABLE_S)
		do
			af_comp.ce_gets (a_af_comp)
		end

feature {NONE} -- C getters

	c_af_enc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct afffile_S *)$tmp)->af_enc;"
		end

	c_af_flagtype (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct afffile_S *)$tmp)->af_flagtype;"
		end

	c_af_rare (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct afffile_S *)$tmp)->af_rare;"
		end

	c_af_keepcase (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct afffile_S *)$tmp)->af_keepcase;"
		end

	c_af_bad (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct afffile_S *)$tmp)->af_bad;"
		end

	c_af_needaffix (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct afffile_S *)$tmp)->af_needaffix;"
		end

	c_af_circumfix (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct afffile_S *)$tmp)->af_circumfix;"
		end

	c_af_needcomp (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct afffile_S *)$tmp)->af_needcomp;"
		end

	c_af_comproot (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct afffile_S *)$tmp)->af_comproot;"
		end

	c_af_compforbid (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct afffile_S *)$tmp)->af_compforbid;"
		end

	c_af_comppermit (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct afffile_S *)$tmp)->af_comppermit;"
		end

	c_af_nosuggest (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct afffile_S *)$tmp)->af_nosuggest;"
		end

	c_af_pfxpostpone (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct afffile_S *)$tmp)->af_pfxpostpone;"
		end

	c_af_pref (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct hashtable_S *)&((struct afffile_S *)$tmp)->af_pref;"
		end

	c_af_suff (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct hashtable_S *)&((struct afffile_S *)$tmp)->af_suff;"
		end

	c_af_comp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct hashtable_S *)&((struct afffile_S *)$tmp)->af_comp;"
		end

feature {NONE} -- C setters

	c_set_af_enc (tmp: POINTER; a_af_enc: POINTER)
		external
			"C inline"
		alias
			"((struct afffile_S *)$tmp)->af_enc = (unsigned char *)$a_af_enc;"
		end

	c_set_af_flagtype (tmp: POINTER; a_af_flagtype: INTEGER_32)
		external
			"C inline"
		alias
			"((struct afffile_S *)$tmp)->af_flagtype = $a_af_flagtype;"
		end

	c_set_af_rare (tmp: POINTER; a_af_rare: NATURAL_32)
		external
			"C inline"
		alias
			"((struct afffile_S *)$tmp)->af_rare = $a_af_rare;"
		end

	c_set_af_keepcase (tmp: POINTER; a_af_keepcase: NATURAL_32)
		external
			"C inline"
		alias
			"((struct afffile_S *)$tmp)->af_keepcase = $a_af_keepcase;"
		end

	c_set_af_bad (tmp: POINTER; a_af_bad: NATURAL_32)
		external
			"C inline"
		alias
			"((struct afffile_S *)$tmp)->af_bad = $a_af_bad;"
		end

	c_set_af_needaffix (tmp: POINTER; a_af_needaffix: NATURAL_32)
		external
			"C inline"
		alias
			"((struct afffile_S *)$tmp)->af_needaffix = $a_af_needaffix;"
		end

	c_set_af_circumfix (tmp: POINTER; a_af_circumfix: NATURAL_32)
		external
			"C inline"
		alias
			"((struct afffile_S *)$tmp)->af_circumfix = $a_af_circumfix;"
		end

	c_set_af_needcomp (tmp: POINTER; a_af_needcomp: NATURAL_32)
		external
			"C inline"
		alias
			"((struct afffile_S *)$tmp)->af_needcomp = $a_af_needcomp;"
		end

	c_set_af_comproot (tmp: POINTER; a_af_comproot: NATURAL_32)
		external
			"C inline"
		alias
			"((struct afffile_S *)$tmp)->af_comproot = $a_af_comproot;"
		end

	c_set_af_compforbid (tmp: POINTER; a_af_compforbid: NATURAL_32)
		external
			"C inline"
		alias
			"((struct afffile_S *)$tmp)->af_compforbid = $a_af_compforbid;"
		end

	c_set_af_comppermit (tmp: POINTER; a_af_comppermit: NATURAL_32)
		external
			"C inline"
		alias
			"((struct afffile_S *)$tmp)->af_comppermit = $a_af_comppermit;"
		end

	c_set_af_nosuggest (tmp: POINTER; a_af_nosuggest: NATURAL_32)
		external
			"C inline"
		alias
			"((struct afffile_S *)$tmp)->af_nosuggest = $a_af_nosuggest;"
		end

	c_set_af_pfxpostpone (tmp: POINTER; a_af_pfxpostpone: INTEGER_32)
		external
			"C inline"
		alias
			"((struct afffile_S *)$tmp)->af_pfxpostpone = $a_af_pfxpostpone;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct afffile_S);"
		end

end
