class
	PD_AFFHEADER_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ah_key: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_ah_key (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	ah_flag: NATURAL_32 assign set_ah_flag
		do
			Result := c_ah_flag (c_pointer)
		end

	ah_newID: INTEGER_32 assign set_ah_newID
		do
			Result := c_ah_newID (c_pointer)
		end

	ah_combine: INTEGER_32 assign set_ah_combine
		do
			Result := c_ah_combine (c_pointer)
		end

	ah_follows: INTEGER_32 assign set_ah_follows
		do
			Result := c_ah_follows (c_pointer)
		end

	ah_first: CE_POINTER [PD_AFFENTRY_S] assign set_ah_first
		do
			create Result.make_shared (c_ah_first (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_ah_flag (a_ah_flag: NATURAL_32)
		do
			c_set_ah_flag (c_pointer, a_ah_flag)
		end

	set_ah_newID (a_ah_newID: INTEGER_32)
		do
			c_set_ah_newID (c_pointer, a_ah_newID)
		end

	set_ah_combine (a_ah_combine: INTEGER_32)
		do
			c_set_ah_combine (c_pointer, a_ah_combine)
		end

	set_ah_follows (a_ah_follows: INTEGER_32)
		do
			c_set_ah_follows (c_pointer, a_ah_follows)
		end

	set_ah_first (a_ah_first: CE_POINTER [PD_AFFENTRY_S])
		do
			c_set_ah_first (c_pointer, a_ah_first.c_pointer)
		end

feature {NONE} -- C getters

	c_ah_key (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct affheader_S *tmp = (struct affheader_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->ah_key) / sizeof(tmp->ah_key[0]);
				return tmp->ah_key;
			]"
		end

	c_ah_flag (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct affheader_S *)$tmp)->ah_flag;"
		end

	c_ah_newID (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct affheader_S *)$tmp)->ah_newID;"
		end

	c_ah_combine (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct affheader_S *)$tmp)->ah_combine;"
		end

	c_ah_follows (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct affheader_S *)$tmp)->ah_follows;"
		end

	c_ah_first (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct affentry_S *)((struct affheader_S *)$tmp)->ah_first;"
		end

feature {NONE} -- C setters

	c_set_ah_flag (tmp: POINTER; a_ah_flag: NATURAL_32)
		external
			"C inline"
		alias
			"((struct affheader_S *)$tmp)->ah_flag = $a_ah_flag;"
		end

	c_set_ah_newID (tmp: POINTER; a_ah_newID: INTEGER_32)
		external
			"C inline"
		alias
			"((struct affheader_S *)$tmp)->ah_newID = $a_ah_newid;"
		end

	c_set_ah_combine (tmp: POINTER; a_ah_combine: INTEGER_32)
		external
			"C inline"
		alias
			"((struct affheader_S *)$tmp)->ah_combine = $a_ah_combine;"
		end

	c_set_ah_follows (tmp: POINTER; a_ah_follows: INTEGER_32)
		external
			"C inline"
		alias
			"((struct affheader_S *)$tmp)->ah_follows = $a_ah_follows;"
		end

	c_set_ah_first (tmp: POINTER; a_ah_first: POINTER)
		external
			"C inline"
		alias
			"((struct affheader_S *)$tmp)->ah_first = (struct affentry_S *)$a_ah_first;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct affheader_S);"
		end

end
