class
	PD_ANONYMOUS2

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	in: INTEGER_32 assign set_in
		do
			Result := c_in (c_pointer)
		end

	i: INTEGER_32 assign set_i
		do
			Result := c_i (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_in (a_in: INTEGER_32)
		do
			c_set_in (c_pointer, a_in)
		end

	set_i (a_i: INTEGER_32)
		do
			c_set_i (c_pointer, a_i)
		end

feature {NONE} -- C getters

	c_in (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((union __anonunion_580 *)$tmp)->__in;"
		end

	c_i (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((union __anonunion_580 *)$tmp)->__i;"
		end

feature {NONE} -- C setters

	c_set_in (tmp: POINTER; a_in: INTEGER_32)
		external
			"C inline"
		alias
			"((union __anonunion_580 *)$tmp)->__in = $a_in;"
		end

	c_set_i (tmp: POINTER; a_i: INTEGER_32)
		external
			"C inline"
		alias
			"((union __anonunion_580 *)$tmp)->__i = $a_i;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(union __anonunion_580);"
		end

end
