class
	PD_ATTR_ENTRY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ae_attr: INTEGER_16 assign set_ae_attr
		do
			Result := c_ae_attr (c_pointer)
		end

	ae_u: PD_AE_U assign set_ae_u
		do
			create Result.make_shared (c_ae_u (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_ae_attr (a_ae_attr: INTEGER_16)
		do
			c_set_ae_attr (c_pointer, a_ae_attr)
		end

	set_ae_u (a_ae_u: PD_AE_U)
		do
			ae_u.ce_gets (a_ae_u)
		end

feature {NONE} -- C getters

	c_ae_attr (tmp: POINTER): INTEGER_16
		external
			"C inline"
		alias
			"return (short)((struct attr_entry *)$tmp)->ae_attr;"
		end

	c_ae_u (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_ae_u_524 *)&((struct attr_entry *)$tmp)->ae_u;"
		end

feature {NONE} -- C setters

	c_set_ae_attr (tmp: POINTER; a_ae_attr: INTEGER_16)
		external
			"C inline"
		alias
			"((struct attr_entry *)$tmp)->ae_attr = $a_ae_attr;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct attr_entry);"
		end

end
