class
	PD_BALLOONEVALSTRUCT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	target: CE_POINTER [SD_GTKWIDGET] assign set_target
		do
			create Result.make_shared (c_target (c_pointer))
		end

	balloonShell: CE_POINTER [SD_GTKWIDGET] assign set_balloonShell
		do
			create Result.make_shared (c_balloonShell (c_pointer))
		end

	balloonLabel: CE_POINTER [SD_GTKWIDGET] assign set_balloonLabel
		do
			create Result.make_shared (c_balloonLabel (c_pointer))
		end

	timerID: NATURAL_32 assign set_timerID
		do
			Result := c_timerID (c_pointer)
		end

	showState: INTEGER_32 assign set_showState
		do
			Result := c_showState (c_pointer)
		end

	x: INTEGER_32 assign set_x
		do
			Result := c_x (c_pointer)
		end

	y: INTEGER_32 assign set_y
		do
			Result := c_y (c_pointer)
		end

	state: NATURAL_32 assign set_state
		do
			Result := c_state (c_pointer)
		end

	ts: INTEGER_32 assign set_ts
		do
			Result := c_ts (c_pointer)
		end

	msg: CE_POINTER [NATURAL_8] assign set_msg
		do
			create Result.make_shared (c_msg (c_pointer))
		end

	msgCB: CE_ROUTINE assign set_msgCB
		do
			create Result.make_shared (c_msgCB (c_pointer))
		end

	clientData: CE_POINTER [ANY] assign set_clientData
		do
			create Result.make_shared (c_clientData (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_target (a_target: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_target (c_pointer, a_target.c_pointer)
		end

	set_balloonShell (a_balloonShell: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_balloonShell (c_pointer, a_balloonShell.c_pointer)
		end

	set_balloonLabel (a_balloonLabel: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_balloonLabel (c_pointer, a_balloonLabel.c_pointer)
		end

	set_timerID (a_timerID: NATURAL_32)
		do
			c_set_timerID (c_pointer, a_timerID)
		end

	set_showState (a_showState: INTEGER_32)
		do
			c_set_showState (c_pointer, a_showState)
		end

	set_x (a_x: INTEGER_32)
		do
			c_set_x (c_pointer, a_x)
		end

	set_y (a_y: INTEGER_32)
		do
			c_set_y (c_pointer, a_y)
		end

	set_state (a_state: NATURAL_32)
		do
			c_set_state (c_pointer, a_state)
		end

	set_ts (a_ts: INTEGER_32)
		do
			c_set_ts (c_pointer, a_ts)
		end

	set_msg (a_msg: CE_POINTER [NATURAL_8])
		do
			c_set_msg (c_pointer, a_msg.c_pointer)
		end

	set_msgCB (a_msgCB: CE_ROUTINE)
		do
			c_set_msgCB (c_pointer, a_msgCB.c_pointer)
		end

	set_clientData (a_clientData: CE_POINTER [ANY])
		do
			c_set_clientData (c_pointer, a_clientData.c_pointer)
		end

feature {NONE} -- C getters

	c_target (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct BalloonEvalStruct *)$tmp)->target;"
		end

	c_balloonShell (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct BalloonEvalStruct *)$tmp)->balloonShell;"
		end

	c_balloonLabel (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct BalloonEvalStruct *)$tmp)->balloonLabel;"
		end

	c_timerID (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct BalloonEvalStruct *)$tmp)->timerID;"
		end

	c_showState (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct BalloonEvalStruct *)$tmp)->showState;"
		end

	c_x (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct BalloonEvalStruct *)$tmp)->x;"
		end

	c_y (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct BalloonEvalStruct *)$tmp)->y;"
		end

	c_state (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct BalloonEvalStruct *)$tmp)->state;"
		end

	c_ts (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct BalloonEvalStruct *)$tmp)->ts;"
		end

	c_msg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct BalloonEvalStruct *)$tmp)->msg;"
		end

	c_msgCB (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct BalloonEvalStruct *, int))((struct BalloonEvalStruct *)$tmp)->msgCB;"
		end

	c_clientData (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct BalloonEvalStruct *)$tmp)->clientData;"
		end

feature {NONE} -- C setters

	c_set_target (tmp: POINTER; a_target: POINTER)
		external
			"C inline"
		alias
			"((struct BalloonEvalStruct *)$tmp)->target = (struct _GtkWidget *)$a_target;"
		end

	c_set_balloonShell (tmp: POINTER; a_balloonShell: POINTER)
		external
			"C inline"
		alias
			"((struct BalloonEvalStruct *)$tmp)->balloonShell = (struct _GtkWidget *)$a_balloonshell;"
		end

	c_set_balloonLabel (tmp: POINTER; a_balloonLabel: POINTER)
		external
			"C inline"
		alias
			"((struct BalloonEvalStruct *)$tmp)->balloonLabel = (struct _GtkWidget *)$a_balloonlabel;"
		end

	c_set_timerID (tmp: POINTER; a_timerID: NATURAL_32)
		external
			"C inline"
		alias
			"((struct BalloonEvalStruct *)$tmp)->timerID = $a_timerid;"
		end

	c_set_showState (tmp: POINTER; a_showState: INTEGER_32)
		external
			"C inline"
		alias
			"((struct BalloonEvalStruct *)$tmp)->showState = $a_showstate;"
		end

	c_set_x (tmp: POINTER; a_x: INTEGER_32)
		external
			"C inline"
		alias
			"((struct BalloonEvalStruct *)$tmp)->x = $a_x;"
		end

	c_set_y (tmp: POINTER; a_y: INTEGER_32)
		external
			"C inline"
		alias
			"((struct BalloonEvalStruct *)$tmp)->y = $a_y;"
		end

	c_set_state (tmp: POINTER; a_state: NATURAL_32)
		external
			"C inline"
		alias
			"((struct BalloonEvalStruct *)$tmp)->state = $a_state;"
		end

	c_set_ts (tmp: POINTER; a_ts: INTEGER_32)
		external
			"C inline"
		alias
			"((struct BalloonEvalStruct *)$tmp)->ts = $a_ts;"
		end

	c_set_msg (tmp: POINTER; a_msg: POINTER)
		external
			"C inline"
		alias
			"((struct BalloonEvalStruct *)$tmp)->msg = (unsigned char *)$a_msg;"
		end

	c_set_msgCB (tmp: POINTER; a_msgCB: POINTER)
		external
			"C inline"
		alias
			"((struct BalloonEvalStruct *)$tmp)->msgCB = (void( *)(struct BalloonEvalStruct *, int))$a_msgcb;"
		end

	c_set_clientData (tmp: POINTER; a_clientData: POINTER)
		external
			"C inline"
		alias
			"((struct BalloonEvalStruct *)$tmp)->clientData = (void *)$a_clientdata;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct BalloonEvalStruct);"
		end

end
