class
	PD_BLOCK8

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ul: CE_ARRAY [NATURAL_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_ul (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	uc: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_uc (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {NONE} -- C getters

	c_ul (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				union __anonunion_block8_543 *tmp = (union __anonunion_block8_543 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->ul) / sizeof(tmp->ul[0]);
				return tmp->ul;
			]"
		end

	c_uc (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				union __anonunion_block8_543 *tmp = (union __anonunion_block8_543 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->uc) / sizeof(tmp->uc[0]);
				return tmp->uc;
			]"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(union __anonunion_block8_543);"
		end

end
