class
	PD_CMDLINE_INFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	cmdbuff: CE_POINTER [NATURAL_8] assign set_cmdbuff
		do
			create Result.make_shared (c_cmdbuff (c_pointer))
		end

	cmdbufflen: INTEGER_32 assign set_cmdbufflen
		do
			Result := c_cmdbufflen (c_pointer)
		end

	cmdlen: INTEGER_32 assign set_cmdlen
		do
			Result := c_cmdlen (c_pointer)
		end

	cmdpos: INTEGER_32 assign set_cmdpos
		do
			Result := c_cmdpos (c_pointer)
		end

	cmdspos: INTEGER_32 assign set_cmdspos
		do
			Result := c_cmdspos (c_pointer)
		end

	cmdfirstc: INTEGER_32 assign set_cmdfirstc
		do
			Result := c_cmdfirstc (c_pointer)
		end

	cmdindent: INTEGER_32 assign set_cmdindent
		do
			Result := c_cmdindent (c_pointer)
		end

	cmdprompt: CE_POINTER [NATURAL_8] assign set_cmdprompt
		do
			create Result.make_shared (c_cmdprompt (c_pointer))
		end

	cmdattr: INTEGER_32 assign set_cmdattr
		do
			Result := c_cmdattr (c_pointer)
		end

	overstrike: INTEGER_32 assign set_overstrike
		do
			Result := c_overstrike (c_pointer)
		end

	xpc: CE_POINTER [PD_EXPAND] assign set_xpc
		do
			create Result.make_shared (c_xpc (c_pointer))
		end

	xp_context: INTEGER_32 assign set_xp_context
		do
			Result := c_xp_context (c_pointer)
		end

	xp_arg: CE_POINTER [NATURAL_8] assign set_xp_arg
		do
			create Result.make_shared (c_xp_arg (c_pointer))
		end

	input_fn: INTEGER_32 assign set_input_fn
		do
			Result := c_input_fn (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_cmdbuff (a_cmdbuff: CE_POINTER [NATURAL_8])
		do
			c_set_cmdbuff (c_pointer, a_cmdbuff.c_pointer)
		end

	set_cmdbufflen (a_cmdbufflen: INTEGER_32)
		do
			c_set_cmdbufflen (c_pointer, a_cmdbufflen)
		end

	set_cmdlen (a_cmdlen: INTEGER_32)
		do
			c_set_cmdlen (c_pointer, a_cmdlen)
		end

	set_cmdpos (a_cmdpos: INTEGER_32)
		do
			c_set_cmdpos (c_pointer, a_cmdpos)
		end

	set_cmdspos (a_cmdspos: INTEGER_32)
		do
			c_set_cmdspos (c_pointer, a_cmdspos)
		end

	set_cmdfirstc (a_cmdfirstc: INTEGER_32)
		do
			c_set_cmdfirstc (c_pointer, a_cmdfirstc)
		end

	set_cmdindent (a_cmdindent: INTEGER_32)
		do
			c_set_cmdindent (c_pointer, a_cmdindent)
		end

	set_cmdprompt (a_cmdprompt: CE_POINTER [NATURAL_8])
		do
			c_set_cmdprompt (c_pointer, a_cmdprompt.c_pointer)
		end

	set_cmdattr (a_cmdattr: INTEGER_32)
		do
			c_set_cmdattr (c_pointer, a_cmdattr)
		end

	set_overstrike (a_overstrike: INTEGER_32)
		do
			c_set_overstrike (c_pointer, a_overstrike)
		end

	set_xpc (a_xpc: CE_POINTER [PD_EXPAND])
		do
			c_set_xpc (c_pointer, a_xpc.c_pointer)
		end

	set_xp_context (a_xp_context: INTEGER_32)
		do
			c_set_xp_context (c_pointer, a_xp_context)
		end

	set_xp_arg (a_xp_arg: CE_POINTER [NATURAL_8])
		do
			c_set_xp_arg (c_pointer, a_xp_arg.c_pointer)
		end

	set_input_fn (a_input_fn: INTEGER_32)
		do
			c_set_input_fn (c_pointer, a_input_fn)
		end

feature {NONE} -- C getters

	c_cmdbuff (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct cmdline_info *)$tmp)->cmdbuff;"
		end

	c_cmdbufflen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cmdline_info *)$tmp)->cmdbufflen;"
		end

	c_cmdlen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cmdline_info *)$tmp)->cmdlen;"
		end

	c_cmdpos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cmdline_info *)$tmp)->cmdpos;"
		end

	c_cmdspos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cmdline_info *)$tmp)->cmdspos;"
		end

	c_cmdfirstc (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cmdline_info *)$tmp)->cmdfirstc;"
		end

	c_cmdindent (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cmdline_info *)$tmp)->cmdindent;"
		end

	c_cmdprompt (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct cmdline_info *)$tmp)->cmdprompt;"
		end

	c_cmdattr (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cmdline_info *)$tmp)->cmdattr;"
		end

	c_overstrike (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cmdline_info *)$tmp)->overstrike;"
		end

	c_xpc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct expand *)((struct cmdline_info *)$tmp)->xpc;"
		end

	c_xp_context (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cmdline_info *)$tmp)->xp_context;"
		end

	c_xp_arg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct cmdline_info *)$tmp)->xp_arg;"
		end

	c_input_fn (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cmdline_info *)$tmp)->input_fn;"
		end

feature {NONE} -- C setters

	c_set_cmdbuff (tmp: POINTER; a_cmdbuff: POINTER)
		external
			"C inline"
		alias
			"((struct cmdline_info *)$tmp)->cmdbuff = (unsigned char *)$a_cmdbuff;"
		end

	c_set_cmdbufflen (tmp: POINTER; a_cmdbufflen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cmdline_info *)$tmp)->cmdbufflen = $a_cmdbufflen;"
		end

	c_set_cmdlen (tmp: POINTER; a_cmdlen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cmdline_info *)$tmp)->cmdlen = $a_cmdlen;"
		end

	c_set_cmdpos (tmp: POINTER; a_cmdpos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cmdline_info *)$tmp)->cmdpos = $a_cmdpos;"
		end

	c_set_cmdspos (tmp: POINTER; a_cmdspos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cmdline_info *)$tmp)->cmdspos = $a_cmdspos;"
		end

	c_set_cmdfirstc (tmp: POINTER; a_cmdfirstc: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cmdline_info *)$tmp)->cmdfirstc = $a_cmdfirstc;"
		end

	c_set_cmdindent (tmp: POINTER; a_cmdindent: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cmdline_info *)$tmp)->cmdindent = $a_cmdindent;"
		end

	c_set_cmdprompt (tmp: POINTER; a_cmdprompt: POINTER)
		external
			"C inline"
		alias
			"((struct cmdline_info *)$tmp)->cmdprompt = (unsigned char *)$a_cmdprompt;"
		end

	c_set_cmdattr (tmp: POINTER; a_cmdattr: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cmdline_info *)$tmp)->cmdattr = $a_cmdattr;"
		end

	c_set_overstrike (tmp: POINTER; a_overstrike: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cmdline_info *)$tmp)->overstrike = $a_overstrike;"
		end

	c_set_xpc (tmp: POINTER; a_xpc: POINTER)
		external
			"C inline"
		alias
			"((struct cmdline_info *)$tmp)->xpc = (struct expand *)$a_xpc;"
		end

	c_set_xp_context (tmp: POINTER; a_xp_context: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cmdline_info *)$tmp)->xp_context = $a_xp_context;"
		end

	c_set_xp_arg (tmp: POINTER; a_xp_arg: POINTER)
		external
			"C inline"
		alias
			"((struct cmdline_info *)$tmp)->xp_arg = (unsigned char *)$a_xp_arg;"
		end

	c_set_input_fn (tmp: POINTER; a_input_fn: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cmdline_info *)$tmp)->input_fn = $a_input_fn;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct cmdline_info);"
		end

end
