class
	PD_CMDMOD

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	minlen: INTEGER_32 assign set_minlen
		do
			Result := c_minlen (c_pointer)
		end

	has_count: INTEGER_32 assign set_has_count
		do
			Result := c_has_count (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_minlen (a_minlen: INTEGER_32)
		do
			c_set_minlen (c_pointer, a_minlen)
		end

	set_has_count (a_has_count: INTEGER_32)
		do
			c_set_has_count (c_pointer, a_has_count)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct cmdmod *)$tmp)->name;"
		end

	c_minlen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cmdmod *)$tmp)->minlen;"
		end

	c_has_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cmdmod *)$tmp)->has_count;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct cmdmod *)$tmp)->name = (char *)$a_name;"
		end

	c_set_minlen (tmp: POINTER; a_minlen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cmdmod *)$tmp)->minlen = $a_minlen;"
		end

	c_set_has_count (tmp: POINTER; a_has_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cmdmod *)$tmp)->has_count = $a_has_count;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct cmdmod);"
		end

end
