class
	PD_COMMAND_COMPLETE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	expand: INTEGER_32 assign set_expand
		do
			Result := c_expand (c_pointer)
		end

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_expand (a_expand: INTEGER_32)
		do
			c_set_expand (c_pointer, a_expand)
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

feature {NONE} -- C getters

	c_expand (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_command_complete_544 *)$tmp)->expand;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_command_complete_544 *)$tmp)->name;"
		end

feature {NONE} -- C setters

	c_set_expand (tmp: POINTER; a_expand: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_command_complete_544 *)$tmp)->expand = $a_expand;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_command_complete_544 *)$tmp)->name = (char *)$a_name;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_command_complete_544);"
		end

end
