class
	PD_CONTEXT_SHA256_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	total: CE_ARRAY [NATURAL_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_total (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	state: CE_ARRAY [NATURAL_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_state (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	buffer: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_buffer (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {NONE} -- C getters

	c_total (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_context_sha256_T_542 *tmp = (struct __anonstruct_context_sha256_T_542 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->total) / sizeof(tmp->total[0]);
				return tmp->total;
			]"
		end

	c_state (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_context_sha256_T_542 *tmp = (struct __anonstruct_context_sha256_T_542 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->state) / sizeof(tmp->state[0]);
				return tmp->state;
			]"
		end

	c_buffer (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_context_sha256_T_542 *tmp = (struct __anonstruct_context_sha256_T_542 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->buffer) / sizeof(tmp->buffer[0]);
				return tmp->buffer;
			]"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_context_sha256_T_542);"
		end

end
