class
	PD_CS_PEND

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	csp_rv: CE_ARRAY [CE_POINTER [ANY]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_csp_rv (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	csp_ex: CE_ARRAY [CE_POINTER [ANY]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_csp_ex (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {NONE} -- C getters

	c_csp_rv (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				union __anonunion_cs_pend_522 *tmp = (union __anonunion_cs_pend_522 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->csp_rv) / sizeof(tmp->csp_rv[0]);
				return tmp->csp_rv;
			]"
		end

	c_csp_ex (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				union __anonunion_cs_pend_522 *tmp = (union __anonunion_cs_pend_522 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->csp_ex) / sizeof(tmp->csp_ex[0]);
				return tmp->csp_ex;
			]"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(union __anonunion_cs_pend_522);"
		end

end
