class
	PD_CTERM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	fg_color: NATURAL_16 assign set_fg_color
		do
			Result := c_fg_color (c_pointer)
		end

	bg_color: NATURAL_16 assign set_bg_color
		do
			Result := c_bg_color (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_fg_color (a_fg_color: NATURAL_16)
		do
			c_set_fg_color (c_pointer, a_fg_color)
		end

	set_bg_color (a_bg_color: NATURAL_16)
		do
			c_set_bg_color (c_pointer, a_bg_color)
		end

feature {NONE} -- C getters

	c_fg_color (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct __anonstruct_cterm_526 *)$tmp)->fg_color;"
		end

	c_bg_color (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct __anonstruct_cterm_526 *)$tmp)->bg_color;"
		end

feature {NONE} -- C setters

	c_set_fg_color (tmp: POINTER; a_fg_color: NATURAL_16)
		external
			"C inline"
		alias
			"((struct __anonstruct_cterm_526 *)$tmp)->fg_color = $a_fg_color;"
		end

	c_set_bg_color (tmp: POINTER; a_bg_color: NATURAL_16)
		external
			"C inline"
		alias
			"((struct __anonstruct_cterm_526 *)$tmp)->bg_color = $a_bg_color;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_cterm_526);"
		end

end
