class
	PD_DIGRAPH

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	char1: NATURAL_8 assign set_char1
		do
			Result := c_char1 (c_pointer)
		end

	char2: NATURAL_8 assign set_char2
		do
			Result := c_char2 (c_pointer)
		end

	result2: INTEGER_32 assign set_result2
		do
			Result := c_result2 (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_char1 (a_char1: NATURAL_8)
		do
			c_set_char1 (c_pointer, a_char1)
		end

	set_char2 (a_char2: NATURAL_8)
		do
			c_set_char2 (c_pointer, a_char2)
		end

	set_result2 (a_result2: INTEGER_32)
		do
			c_set_result2 (c_pointer, a_result2)
		end

feature {NONE} -- C getters

	c_char1 (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct digraph *)$tmp)->char1;"
		end

	c_char2 (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct digraph *)$tmp)->char2;"
		end

	c_result2 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct digraph *)$tmp)->result;"
		end

feature {NONE} -- C setters

	c_set_char1 (tmp: POINTER; a_char1: NATURAL_8)
		external
			"C inline"
		alias
			"((struct digraph *)$tmp)->char1 = $a_char1;"
		end

	c_set_char2 (tmp: POINTER; a_char2: NATURAL_8)
		external
			"C inline"
		alias
			"((struct digraph *)$tmp)->char2 = $a_char2;"
		end

	c_set_result2 (tmp: POINTER; a_result2: INTEGER_32)
		external
			"C inline"
		alias
			"((struct digraph *)$tmp)->result = $a_result2;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct digraph);"
		end

end
