class
	PD_ENC_CANON_TABLE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	prop: INTEGER_32 assign set_prop
		do
			Result := c_prop (c_pointer)
		end

	codepage: INTEGER_32 assign set_codepage
		do
			Result := c_codepage (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_prop (a_prop: INTEGER_32)
		do
			c_set_prop (c_pointer, a_prop)
		end

	set_codepage (a_codepage: INTEGER_32)
		do
			c_set_codepage (c_pointer, a_codepage)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_enc_canon_table_543 *)$tmp)->name;"
		end

	c_prop (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_enc_canon_table_543 *)$tmp)->prop;"
		end

	c_codepage (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_enc_canon_table_543 *)$tmp)->codepage;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_enc_canon_table_543 *)$tmp)->name = (char *)$a_name;"
		end

	c_set_prop (tmp: POINTER; a_prop: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_enc_canon_table_543 *)$tmp)->prop = $a_prop;"
		end

	c_set_codepage (tmp: POINTER; a_codepage: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_enc_canon_table_543 *)$tmp)->codepage = $a_codepage;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_enc_canon_table_543);"
		end

end
