class
	PD_FF_SEARCH_CTX_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ffsc_stack_ptr: CE_POINTER [PD_FF_STACK] assign set_ffsc_stack_ptr
		do
			create Result.make_shared (c_ffsc_stack_ptr (c_pointer))
		end

	ffsc_visited_list: CE_POINTER [PD_FF_VISITED_LIST_HDR] assign set_ffsc_visited_list
		do
			create Result.make_shared (c_ffsc_visited_list (c_pointer))
		end

	ffsc_dir_visited_list: CE_POINTER [PD_FF_VISITED_LIST_HDR] assign set_ffsc_dir_visited_list
		do
			create Result.make_shared (c_ffsc_dir_visited_list (c_pointer))
		end

	ffsc_visited_lists_list: CE_POINTER [PD_FF_VISITED_LIST_HDR] assign set_ffsc_visited_lists_list
		do
			create Result.make_shared (c_ffsc_visited_lists_list (c_pointer))
		end

	ffsc_visited_lists_list_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct ff_search_ctx_T, ffsc_visited_lists_list);"
		end

	ffsc_dir_visited_lists_list: CE_POINTER [PD_FF_VISITED_LIST_HDR] assign set_ffsc_dir_visited_lists_list
		do
			create Result.make_shared (c_ffsc_dir_visited_lists_list (c_pointer))
		end

	ffsc_dir_visited_lists_list_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct ff_search_ctx_T, ffsc_dir_visited_lists_list);"
		end

	ffsc_file_to_search: CE_POINTER [NATURAL_8] assign set_ffsc_file_to_search
		do
			create Result.make_shared (c_ffsc_file_to_search (c_pointer))
		end

	ffsc_start_dir: CE_POINTER [NATURAL_8] assign set_ffsc_start_dir
		do
			create Result.make_shared (c_ffsc_start_dir (c_pointer))
		end

	ffsc_fix_path: CE_POINTER [NATURAL_8] assign set_ffsc_fix_path
		do
			create Result.make_shared (c_ffsc_fix_path (c_pointer))
		end

	ffsc_wc_path: CE_POINTER [NATURAL_8] assign set_ffsc_wc_path
		do
			create Result.make_shared (c_ffsc_wc_path (c_pointer))
		end

	ffsc_level: INTEGER_32 assign set_ffsc_level
		do
			Result := c_ffsc_level (c_pointer)
		end

	ffsc_stopdirs_v: CE_POINTER [CE_POINTER [NATURAL_8]] assign set_ffsc_stopdirs_v
		do
			create Result.make_shared (c_ffsc_stopdirs_v (c_pointer))
		end

	ffsc_find_what: INTEGER_32 assign set_ffsc_find_what
		do
			Result := c_ffsc_find_what (c_pointer)
		end

	ffsc_tagfile: INTEGER_32 assign set_ffsc_tagfile
		do
			Result := c_ffsc_tagfile (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_ffsc_stack_ptr (a_ffsc_stack_ptr: CE_POINTER [PD_FF_STACK])
		do
			c_set_ffsc_stack_ptr (c_pointer, a_ffsc_stack_ptr.c_pointer)
		end

	set_ffsc_visited_list (a_ffsc_visited_list: CE_POINTER [PD_FF_VISITED_LIST_HDR])
		do
			c_set_ffsc_visited_list (c_pointer, a_ffsc_visited_list.c_pointer)
		end

	set_ffsc_dir_visited_list (a_ffsc_dir_visited_list: CE_POINTER [PD_FF_VISITED_LIST_HDR])
		do
			c_set_ffsc_dir_visited_list (c_pointer, a_ffsc_dir_visited_list.c_pointer)
		end

	set_ffsc_visited_lists_list (a_ffsc_visited_lists_list: CE_POINTER [PD_FF_VISITED_LIST_HDR])
		do
			c_set_ffsc_visited_lists_list (c_pointer, a_ffsc_visited_lists_list.c_pointer)
		end

	set_ffsc_dir_visited_lists_list (a_ffsc_dir_visited_lists_list: CE_POINTER [PD_FF_VISITED_LIST_HDR])
		do
			c_set_ffsc_dir_visited_lists_list (c_pointer, a_ffsc_dir_visited_lists_list.c_pointer)
		end

	set_ffsc_file_to_search (a_ffsc_file_to_search: CE_POINTER [NATURAL_8])
		do
			c_set_ffsc_file_to_search (c_pointer, a_ffsc_file_to_search.c_pointer)
		end

	set_ffsc_start_dir (a_ffsc_start_dir: CE_POINTER [NATURAL_8])
		do
			c_set_ffsc_start_dir (c_pointer, a_ffsc_start_dir.c_pointer)
		end

	set_ffsc_fix_path (a_ffsc_fix_path: CE_POINTER [NATURAL_8])
		do
			c_set_ffsc_fix_path (c_pointer, a_ffsc_fix_path.c_pointer)
		end

	set_ffsc_wc_path (a_ffsc_wc_path: CE_POINTER [NATURAL_8])
		do
			c_set_ffsc_wc_path (c_pointer, a_ffsc_wc_path.c_pointer)
		end

	set_ffsc_level (a_ffsc_level: INTEGER_32)
		do
			c_set_ffsc_level (c_pointer, a_ffsc_level)
		end

	set_ffsc_stopdirs_v (a_ffsc_stopdirs_v: CE_POINTER [CE_POINTER [NATURAL_8]])
		do
			c_set_ffsc_stopdirs_v (c_pointer, a_ffsc_stopdirs_v.c_pointer)
		end

	set_ffsc_find_what (a_ffsc_find_what: INTEGER_32)
		do
			c_set_ffsc_find_what (c_pointer, a_ffsc_find_what)
		end

	set_ffsc_tagfile (a_ffsc_tagfile: INTEGER_32)
		do
			c_set_ffsc_tagfile (c_pointer, a_ffsc_tagfile)
		end

feature {NONE} -- C getters

	c_ffsc_stack_ptr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct ff_stack *)((struct ff_search_ctx_T *)$tmp)->ffsc_stack_ptr;"
		end

	c_ffsc_visited_list (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct ff_visited_list_hdr *)((struct ff_search_ctx_T *)$tmp)->ffsc_visited_list;"
		end

	c_ffsc_dir_visited_list (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct ff_visited_list_hdr *)((struct ff_search_ctx_T *)$tmp)->ffsc_dir_visited_list;"
		end

	c_ffsc_visited_lists_list (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct ff_visited_list_hdr *)((struct ff_search_ctx_T *)$tmp)->ffsc_visited_lists_list;"
		end

	c_ffsc_dir_visited_lists_list (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct ff_visited_list_hdr *)((struct ff_search_ctx_T *)$tmp)->ffsc_dir_visited_lists_list;"
		end

	c_ffsc_file_to_search (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct ff_search_ctx_T *)$tmp)->ffsc_file_to_search;"
		end

	c_ffsc_start_dir (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct ff_search_ctx_T *)$tmp)->ffsc_start_dir;"
		end

	c_ffsc_fix_path (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct ff_search_ctx_T *)$tmp)->ffsc_fix_path;"
		end

	c_ffsc_wc_path (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct ff_search_ctx_T *)$tmp)->ffsc_wc_path;"
		end

	c_ffsc_level (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ff_search_ctx_T *)$tmp)->ffsc_level;"
		end

	c_ffsc_stopdirs_v (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char * *)((struct ff_search_ctx_T *)$tmp)->ffsc_stopdirs_v;"
		end

	c_ffsc_find_what (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ff_search_ctx_T *)$tmp)->ffsc_find_what;"
		end

	c_ffsc_tagfile (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ff_search_ctx_T *)$tmp)->ffsc_tagfile;"
		end

feature {NONE} -- C setters

	c_set_ffsc_stack_ptr (tmp: POINTER; a_ffsc_stack_ptr: POINTER)
		external
			"C inline"
		alias
			"((struct ff_search_ctx_T *)$tmp)->ffsc_stack_ptr = (struct ff_stack *)$a_ffsc_stack_ptr;"
		end

	c_set_ffsc_visited_list (tmp: POINTER; a_ffsc_visited_list: POINTER)
		external
			"C inline"
		alias
			"((struct ff_search_ctx_T *)$tmp)->ffsc_visited_list = (struct ff_visited_list_hdr *)$a_ffsc_visited_list;"
		end

	c_set_ffsc_dir_visited_list (tmp: POINTER; a_ffsc_dir_visited_list: POINTER)
		external
			"C inline"
		alias
			"((struct ff_search_ctx_T *)$tmp)->ffsc_dir_visited_list = (struct ff_visited_list_hdr *)$a_ffsc_dir_visited_list;"
		end

	c_set_ffsc_visited_lists_list (tmp: POINTER; a_ffsc_visited_lists_list: POINTER)
		external
			"C inline"
		alias
			"((struct ff_search_ctx_T *)$tmp)->ffsc_visited_lists_list = (struct ff_visited_list_hdr *)$a_ffsc_visited_lists_list;"
		end

	c_set_ffsc_dir_visited_lists_list (tmp: POINTER; a_ffsc_dir_visited_lists_list: POINTER)
		external
			"C inline"
		alias
			"((struct ff_search_ctx_T *)$tmp)->ffsc_dir_visited_lists_list = (struct ff_visited_list_hdr *)$a_ffsc_dir_visited_lists_list;"
		end

	c_set_ffsc_file_to_search (tmp: POINTER; a_ffsc_file_to_search: POINTER)
		external
			"C inline"
		alias
			"((struct ff_search_ctx_T *)$tmp)->ffsc_file_to_search = (unsigned char *)$a_ffsc_file_to_search;"
		end

	c_set_ffsc_start_dir (tmp: POINTER; a_ffsc_start_dir: POINTER)
		external
			"C inline"
		alias
			"((struct ff_search_ctx_T *)$tmp)->ffsc_start_dir = (unsigned char *)$a_ffsc_start_dir;"
		end

	c_set_ffsc_fix_path (tmp: POINTER; a_ffsc_fix_path: POINTER)
		external
			"C inline"
		alias
			"((struct ff_search_ctx_T *)$tmp)->ffsc_fix_path = (unsigned char *)$a_ffsc_fix_path;"
		end

	c_set_ffsc_wc_path (tmp: POINTER; a_ffsc_wc_path: POINTER)
		external
			"C inline"
		alias
			"((struct ff_search_ctx_T *)$tmp)->ffsc_wc_path = (unsigned char *)$a_ffsc_wc_path;"
		end

	c_set_ffsc_level (tmp: POINTER; a_ffsc_level: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ff_search_ctx_T *)$tmp)->ffsc_level = $a_ffsc_level;"
		end

	c_set_ffsc_stopdirs_v (tmp: POINTER; a_ffsc_stopdirs_v: POINTER)
		external
			"C inline"
		alias
			"((struct ff_search_ctx_T *)$tmp)->ffsc_stopdirs_v = (unsigned char * *)$a_ffsc_stopdirs_v;"
		end

	c_set_ffsc_find_what (tmp: POINTER; a_ffsc_find_what: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ff_search_ctx_T *)$tmp)->ffsc_find_what = $a_ffsc_find_what;"
		end

	c_set_ffsc_tagfile (tmp: POINTER; a_ffsc_tagfile: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ff_search_ctx_T *)$tmp)->ffsc_tagfile = $a_ffsc_tagfile;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct ff_search_ctx_T);"
		end

end
