class
	PD_FST

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	f_name: CE_POINTER [INTEGER_8] assign set_f_name
		do
			create Result.make_shared (c_f_name (c_pointer))
		end

	f_min_argc: INTEGER_8 assign set_f_min_argc
		do
			Result := c_f_min_argc (c_pointer)
		end

	f_max_argc: INTEGER_8 assign set_f_max_argc
		do
			Result := c_f_max_argc (c_pointer)
		end

	f_func: CE_ROUTINE assign set_f_func
		do
			create Result.make_shared (c_f_func (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_f_name (a_f_name: CE_POINTER [INTEGER_8])
		do
			c_set_f_name (c_pointer, a_f_name.c_pointer)
		end

	set_f_min_argc (a_f_min_argc: INTEGER_8)
		do
			c_set_f_min_argc (c_pointer, a_f_min_argc)
		end

	set_f_max_argc (a_f_max_argc: INTEGER_8)
		do
			c_set_f_max_argc (c_pointer, a_f_max_argc)
		end

	set_f_func (a_f_func: CE_ROUTINE)
		do
			c_set_f_func (c_pointer, a_f_func.c_pointer)
		end

feature {NONE} -- C getters

	c_f_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct fst *)$tmp)->f_name;"
		end

	c_f_min_argc (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct fst *)$tmp)->f_min_argc;"
		end

	c_f_max_argc (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct fst *)$tmp)->f_max_argc;"
		end

	c_f_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(typval_T * args, typval_T * rvar))((struct fst *)$tmp)->f_func;"
		end

feature {NONE} -- C setters

	c_set_f_name (tmp: POINTER; a_f_name: POINTER)
		external
			"C inline"
		alias
			"((struct fst *)$tmp)->f_name = (char *)$a_f_name;"
		end

	c_set_f_min_argc (tmp: POINTER; a_f_min_argc: INTEGER_8)
		external
			"C inline"
		alias
			"((struct fst *)$tmp)->f_min_argc = $a_f_min_argc;"
		end

	c_set_f_max_argc (tmp: POINTER; a_f_max_argc: INTEGER_8)
		external
			"C inline"
		alias
			"((struct fst *)$tmp)->f_max_argc = $a_f_max_argc;"
		end

	c_set_f_func (tmp: POINTER; a_f_func: POINTER)
		external
			"C inline"
		alias
			"((struct fst *)$tmp)->f_func = (void( *)(typval_T * args, typval_T * rvar))$a_f_func;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct fst);"
		end

end
