class
	PD_FUNCDICT_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	fd_dict: CE_POINTER [PD_DICTVAR_S] assign set_fd_dict
		do
			create Result.make_shared (c_fd_dict (c_pointer))
		end

	fd_newkey: CE_POINTER [NATURAL_8] assign set_fd_newkey
		do
			create Result.make_shared (c_fd_newkey (c_pointer))
		end

	fd_di: CE_POINTER [PD_DICTITEM_S] assign set_fd_di
		do
			create Result.make_shared (c_fd_di (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_fd_dict (a_fd_dict: CE_POINTER [PD_DICTVAR_S])
		do
			c_set_fd_dict (c_pointer, a_fd_dict.c_pointer)
		end

	set_fd_newkey (a_fd_newkey: CE_POINTER [NATURAL_8])
		do
			c_set_fd_newkey (c_pointer, a_fd_newkey.c_pointer)
		end

	set_fd_di (a_fd_di: CE_POINTER [PD_DICTITEM_S])
		do
			c_set_fd_di (c_pointer, a_fd_di.c_pointer)
		end

feature {NONE} -- C getters

	c_fd_dict (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dictvar_S *)((struct __anonstruct_funcdict_T_548 *)$tmp)->fd_dict;"
		end

	c_fd_newkey (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_funcdict_T_548 *)$tmp)->fd_newkey;"
		end

	c_fd_di (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dictitem_S *)((struct __anonstruct_funcdict_T_548 *)$tmp)->fd_di;"
		end

feature {NONE} -- C setters

	c_set_fd_dict (tmp: POINTER; a_fd_dict: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_funcdict_T_548 *)$tmp)->fd_dict = (struct dictvar_S *)$a_fd_dict;"
		end

	c_set_fd_newkey (tmp: POINTER; a_fd_newkey: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_funcdict_T_548 *)$tmp)->fd_newkey = (unsigned char *)$a_fd_newkey;"
		end

	c_set_fd_di (tmp: POINTER; a_fd_di: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_funcdict_T_548 *)$tmp)->fd_di = (struct dictitem_S *)$a_fd_di;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_funcdict_T_548);"
		end

end
