class
	PD_GTKFORMCLASS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	parent_class: SD_GTKCONTAINERCLASS assign set_parent_class
		do
			create Result.make_shared (c_parent_class (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_parent_class (a_parent_class: SD_GTKCONTAINERCLASS)
		do
			parent_class.ce_gets (a_parent_class)
		end

feature {NONE} -- C getters

	c_parent_class (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkContainerClass *)&((struct _GtkFormClass *)$tmp)->parent_class;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkFormClass);"
		end

end
