class
	PD_GUI2

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	fg_color: INTEGER_32 assign set_fg_color
		do
			Result := c_fg_color (c_pointer)
		end

	bg_color: INTEGER_32 assign set_bg_color
		do
			Result := c_bg_color (c_pointer)
		end

	sp_color: INTEGER_32 assign set_sp_color
		do
			Result := c_sp_color (c_pointer)
		end

	font: CE_POINTER [ANY] assign set_font
		do
			create Result.make_shared (c_font (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_fg_color (a_fg_color: INTEGER_32)
		do
			c_set_fg_color (c_pointer, a_fg_color)
		end

	set_bg_color (a_bg_color: INTEGER_32)
		do
			c_set_bg_color (c_pointer, a_bg_color)
		end

	set_sp_color (a_sp_color: INTEGER_32)
		do
			c_set_sp_color (c_pointer, a_sp_color)
		end

	set_font (a_font: CE_POINTER [ANY])
		do
			c_set_font (c_pointer, a_font.c_pointer)
		end

feature {NONE} -- C getters

	c_fg_color (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_gui_527 *)$tmp)->fg_color;"
		end

	c_bg_color (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_gui_527 *)$tmp)->bg_color;"
		end

	c_sp_color (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_gui_527 *)$tmp)->sp_color;"
		end

	c_font (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_gui_527 *)$tmp)->font;"
		end

feature {NONE} -- C setters

	c_set_fg_color (tmp: POINTER; a_fg_color: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gui_527 *)$tmp)->fg_color = $a_fg_color;"
		end

	c_set_bg_color (tmp: POINTER; a_bg_color: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gui_527 *)$tmp)->bg_color = $a_bg_color;"
		end

	c_set_sp_color (tmp: POINTER; a_sp_color: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gui_527 *)$tmp)->sp_color = $a_sp_color;"
		end

	c_set_font (tmp: POINTER; a_font: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gui_527 *)$tmp)->font = (void *)$a_font;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_gui_527);"
		end

end
