class
	PD_GUISCROLLBAR

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ident: INTEGER_32 assign set_ident
		do
			Result := c_ident (c_pointer)
		end

	wp: CE_POINTER [PD_WINDOW_S] assign set_wp
		do
			create Result.make_shared (c_wp (c_pointer))
		end

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	value: INTEGER_32 assign set_value
		do
			Result := c_value (c_pointer)
		end

	size: INTEGER_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	max: INTEGER_32 assign set_max
		do
			Result := c_max (c_pointer)
		end

	top: INTEGER_32 assign set_top
		do
			Result := c_top (c_pointer)
		end

	height: INTEGER_32 assign set_height
		do
			Result := c_height (c_pointer)
		end

	width: INTEGER_32 assign set_width
		do
			Result := c_width (c_pointer)
		end

	status_height: INTEGER_32 assign set_status_height
		do
			Result := c_status_height (c_pointer)
		end

	id: CE_POINTER [SD_GTKWIDGET] assign set_id
		do
			create Result.make_shared (c_id (c_pointer))
		end

	handler_id: NATURAL_32 assign set_handler_id
		do
			Result := c_handler_id (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_ident (a_ident: INTEGER_32)
		do
			c_set_ident (c_pointer, a_ident)
		end

	set_wp (a_wp: CE_POINTER [PD_WINDOW_S])
		do
			c_set_wp (c_pointer, a_wp.c_pointer)
		end

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_value (a_value: INTEGER_32)
		do
			c_set_value (c_pointer, a_value)
		end

	set_size (a_size: INTEGER_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_max (a_max: INTEGER_32)
		do
			c_set_max (c_pointer, a_max)
		end

	set_top (a_top: INTEGER_32)
		do
			c_set_top (c_pointer, a_top)
		end

	set_height (a_height: INTEGER_32)
		do
			c_set_height (c_pointer, a_height)
		end

	set_width (a_width: INTEGER_32)
		do
			c_set_width (c_pointer, a_width)
		end

	set_status_height (a_status_height: INTEGER_32)
		do
			c_set_status_height (c_pointer, a_status_height)
		end

	set_id (a_id: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_id (c_pointer, a_id.c_pointer)
		end

	set_handler_id (a_handler_id: NATURAL_32)
		do
			c_set_handler_id (c_pointer, a_handler_id)
		end

feature {NONE} -- C getters

	c_ident (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct GuiScrollbar *)$tmp)->ident;"
		end

	c_wp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct window_S *)((struct GuiScrollbar *)$tmp)->wp;"
		end

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct GuiScrollbar *)$tmp)->type;"
		end

	c_value (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct GuiScrollbar *)$tmp)->value;"
		end

	c_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct GuiScrollbar *)$tmp)->size;"
		end

	c_max (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct GuiScrollbar *)$tmp)->max;"
		end

	c_top (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct GuiScrollbar *)$tmp)->top;"
		end

	c_height (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct GuiScrollbar *)$tmp)->height;"
		end

	c_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct GuiScrollbar *)$tmp)->width;"
		end

	c_status_height (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct GuiScrollbar *)$tmp)->status_height;"
		end

	c_id (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct GuiScrollbar *)$tmp)->id;"
		end

	c_handler_id (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct GuiScrollbar *)$tmp)->handler_id;"
		end

feature {NONE} -- C setters

	c_set_ident (tmp: POINTER; a_ident: INTEGER_32)
		external
			"C inline"
		alias
			"((struct GuiScrollbar *)$tmp)->ident = $a_ident;"
		end

	c_set_wp (tmp: POINTER; a_wp: POINTER)
		external
			"C inline"
		alias
			"((struct GuiScrollbar *)$tmp)->wp = (struct window_S *)$a_wp;"
		end

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct GuiScrollbar *)$tmp)->type = $a_type;"
		end

	c_set_value (tmp: POINTER; a_value: INTEGER_32)
		external
			"C inline"
		alias
			"((struct GuiScrollbar *)$tmp)->value = $a_value;"
		end

	c_set_size (tmp: POINTER; a_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct GuiScrollbar *)$tmp)->size = $a_size;"
		end

	c_set_max (tmp: POINTER; a_max: INTEGER_32)
		external
			"C inline"
		alias
			"((struct GuiScrollbar *)$tmp)->max = $a_max;"
		end

	c_set_top (tmp: POINTER; a_top: INTEGER_32)
		external
			"C inline"
		alias
			"((struct GuiScrollbar *)$tmp)->top = $a_top;"
		end

	c_set_height (tmp: POINTER; a_height: INTEGER_32)
		external
			"C inline"
		alias
			"((struct GuiScrollbar *)$tmp)->height = $a_height;"
		end

	c_set_width (tmp: POINTER; a_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct GuiScrollbar *)$tmp)->width = $a_width;"
		end

	c_set_status_height (tmp: POINTER; a_status_height: INTEGER_32)
		external
			"C inline"
		alias
			"((struct GuiScrollbar *)$tmp)->status_height = $a_status_height;"
		end

	c_set_id (tmp: POINTER; a_id: POINTER)
		external
			"C inline"
		alias
			"((struct GuiScrollbar *)$tmp)->id = (struct _GtkWidget *)$a_id;"
		end

	c_set_handler_id (tmp: POINTER; a_handler_id: NATURAL_32)
		external
			"C inline"
		alias
			"((struct GuiScrollbar *)$tmp)->handler_id = $a_handler_id;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct GuiScrollbar);"
		end

end
