class
	PD_HIST_ENTRY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	hisnum: INTEGER_32 assign set_hisnum
		do
			Result := c_hisnum (c_pointer)
		end

	hisstr: CE_POINTER [NATURAL_8] assign set_hisstr
		do
			create Result.make_shared (c_hisstr (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_hisnum (a_hisnum: INTEGER_32)
		do
			c_set_hisnum (c_pointer, a_hisnum)
		end

	set_hisstr (a_hisstr: CE_POINTER [NATURAL_8])
		do
			c_set_hisstr (c_pointer, a_hisstr.c_pointer)
		end

feature {NONE} -- C getters

	c_hisnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct hist_entry *)$tmp)->hisnum;"
		end

	c_hisstr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct hist_entry *)$tmp)->hisstr;"
		end

feature {NONE} -- C setters

	c_set_hisnum (tmp: POINTER; a_hisnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct hist_entry *)$tmp)->hisnum = $a_hisnum;"
		end

	c_set_hisstr (tmp: POINTER; a_hisstr: POINTER)
		external
			"C inline"
		alias
			"((struct hist_entry *)$tmp)->hisstr = (unsigned char *)$a_hisstr;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct hist_entry);"
		end

end
