class
	PD_INFO_POINTER

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ip_bnum: INTEGER_32 assign set_ip_bnum
		do
			Result := c_ip_bnum (c_pointer)
		end

	ip_low: INTEGER_32 assign set_ip_low
		do
			Result := c_ip_low (c_pointer)
		end

	ip_high: INTEGER_32 assign set_ip_high
		do
			Result := c_ip_high (c_pointer)
		end

	ip_index: INTEGER_32 assign set_ip_index
		do
			Result := c_ip_index (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_ip_bnum (a_ip_bnum: INTEGER_32)
		do
			c_set_ip_bnum (c_pointer, a_ip_bnum)
		end

	set_ip_low (a_ip_low: INTEGER_32)
		do
			c_set_ip_low (c_pointer, a_ip_low)
		end

	set_ip_high (a_ip_high: INTEGER_32)
		do
			c_set_ip_high (c_pointer, a_ip_high)
		end

	set_ip_index (a_ip_index: INTEGER_32)
		do
			c_set_ip_index (c_pointer, a_ip_index)
		end

feature {NONE} -- C getters

	c_ip_bnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct info_pointer *)$tmp)->ip_bnum;"
		end

	c_ip_low (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct info_pointer *)$tmp)->ip_low;"
		end

	c_ip_high (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct info_pointer *)$tmp)->ip_high;"
		end

	c_ip_index (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct info_pointer *)$tmp)->ip_index;"
		end

feature {NONE} -- C setters

	c_set_ip_bnum (tmp: POINTER; a_ip_bnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct info_pointer *)$tmp)->ip_bnum = $a_ip_bnum;"
		end

	c_set_ip_low (tmp: POINTER; a_ip_low: INTEGER_32)
		external
			"C inline"
		alias
			"((struct info_pointer *)$tmp)->ip_low = $a_ip_low;"
		end

	c_set_ip_high (tmp: POINTER; a_ip_high: INTEGER_32)
		external
			"C inline"
		alias
			"((struct info_pointer *)$tmp)->ip_high = $a_ip_high;"
		end

	c_set_ip_index (tmp: POINTER; a_ip_index: INTEGER_32)
		external
			"C inline"
		alias
			"((struct info_pointer *)$tmp)->ip_index = $a_ip_index;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct info_pointer);"
		end

end
