class
	PD_INTERVAL

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	first: INTEGER_32 assign set_first
		do
			Result := c_first (c_pointer)
		end

	last: INTEGER_32 assign set_last
		do
			Result := c_last (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_first (a_first: INTEGER_32)
		do
			c_set_first (c_pointer, a_first)
		end

	set_last (a_last: INTEGER_32)
		do
			c_set_last (c_pointer, a_last)
		end

feature {NONE} -- C getters

	c_first (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct interval *)$tmp)->first;"
		end

	c_last (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct interval *)$tmp)->last;"
		end

feature {NONE} -- C setters

	c_set_first (tmp: POINTER; a_first: INTEGER_32)
		external
			"C inline"
		alias
			"((struct interval *)$tmp)->first = $a_first;"
		end

	c_set_last (tmp: POINTER; a_last: INTEGER_32)
		external
			"C inline"
		alias
			"((struct interval *)$tmp)->last = $a_last;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct interval);"
		end

end
