class
	PD_KEY_NAME_ENTRY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	key: INTEGER_32 assign set_key
		do
			Result := c_key (c_pointer)
		end

	name: CE_POINTER [NATURAL_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_key (a_key: INTEGER_32)
		do
			c_set_key (c_pointer, a_key)
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

feature {NONE} -- C getters

	c_key (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct key_name_entry *)$tmp)->key;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct key_name_entry *)$tmp)->name;"
		end

feature {NONE} -- C setters

	c_set_key (tmp: POINTER; a_key: INTEGER_32)
		external
			"C inline"
		alias
			"((struct key_name_entry *)$tmp)->key = $a_key;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct key_name_entry *)$tmp)->name = (unsigned char *)$a_name;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct key_name_entry);"
		end

end
