class
	PD_LINEOFF_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	lnum: INTEGER_32 assign set_lnum
		do
			Result := c_lnum (c_pointer)
		end

	lnum_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_lineoff_T_543, lnum);"
		end

	fill: INTEGER_32 assign set_fill
		do
			Result := c_fill (c_pointer)
		end

	height: INTEGER_32 assign set_height
		do
			Result := c_height (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_lnum (a_lnum: INTEGER_32)
		do
			c_set_lnum (c_pointer, a_lnum)
		end

	set_fill (a_fill: INTEGER_32)
		do
			c_set_fill (c_pointer, a_fill)
		end

	set_height (a_height: INTEGER_32)
		do
			c_set_height (c_pointer, a_height)
		end

feature {NONE} -- C getters

	c_lnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_lineoff_T_543 *)$tmp)->lnum;"
		end

	c_fill (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_lineoff_T_543 *)$tmp)->fill;"
		end

	c_height (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_lineoff_T_543 *)$tmp)->height;"
		end

feature {NONE} -- C setters

	c_set_lnum (tmp: POINTER; a_lnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_lineoff_T_543 *)$tmp)->lnum = $a_lnum;"
		end

	c_set_fill (tmp: POINTER; a_fill: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_lineoff_T_543 *)$tmp)->fill = $a_fill;"
		end

	c_set_height (tmp: POINTER; a_height: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_lineoff_T_543 *)$tmp)->height = $a_height;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_lineoff_T_543);"
		end

end
