class
	PD_LISTITEM_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	li_next: CE_POINTER [PD_LISTITEM_S] assign set_li_next
		do
			create Result.make_shared (c_li_next (c_pointer))
		end

	li_prev: CE_POINTER [PD_LISTITEM_S] assign set_li_prev
		do
			create Result.make_shared (c_li_prev (c_pointer))
		end

	li_tv: PD_TYPVAL_T assign set_li_tv
		do
			create Result.make_shared (c_li_tv (c_pointer))
		end

	li_tv_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct listitem_S, li_tv);"
		end

feature {ANY} -- Eiffel setters

	set_li_next (a_li_next: CE_POINTER [PD_LISTITEM_S])
		do
			c_set_li_next (c_pointer, a_li_next.c_pointer)
		end

	set_li_prev (a_li_prev: CE_POINTER [PD_LISTITEM_S])
		do
			c_set_li_prev (c_pointer, a_li_prev.c_pointer)
		end

	set_li_tv (a_li_tv: PD_TYPVAL_T)
		do
			li_tv.ce_gets (a_li_tv)
		end

feature {NONE} -- C getters

	c_li_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct listitem_S *)((struct listitem_S *)$tmp)->li_next;"
		end

	c_li_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct listitem_S *)((struct listitem_S *)$tmp)->li_prev;"
		end

	c_li_tv (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (typval_T *)&((struct listitem_S *)$tmp)->li_tv;"
		end

feature {NONE} -- C setters

	c_set_li_next (tmp: POINTER; a_li_next: POINTER)
		external
			"C inline"
		alias
			"((struct listitem_S *)$tmp)->li_next = (struct listitem_S *)$a_li_next;"
		end

	c_set_li_prev (tmp: POINTER; a_li_prev: POINTER)
		external
			"C inline"
		alias
			"((struct listitem_S *)$tmp)->li_prev = (struct listitem_S *)$a_li_prev;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct listitem_S);"
		end

end
