class
	PD_LISTWATCH_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	lw_item: CE_POINTER [PD_LISTITEM_S] assign set_lw_item
		do
			create Result.make_shared (c_lw_item (c_pointer))
		end

	lw_next: CE_POINTER [PD_LISTWATCH_S] assign set_lw_next
		do
			create Result.make_shared (c_lw_next (c_pointer))
		end

	lw_next_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct listwatch_S, lw_next);"
		end

feature {ANY} -- Eiffel setters

	set_lw_item (a_lw_item: CE_POINTER [PD_LISTITEM_S])
		do
			c_set_lw_item (c_pointer, a_lw_item.c_pointer)
		end

	set_lw_next (a_lw_next: CE_POINTER [PD_LISTWATCH_S])
		do
			c_set_lw_next (c_pointer, a_lw_next.c_pointer)
		end

feature {NONE} -- C getters

	c_lw_item (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct listitem_S *)((struct listwatch_S *)$tmp)->lw_item;"
		end

	c_lw_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct listwatch_S *)((struct listwatch_S *)$tmp)->lw_next;"
		end

feature {NONE} -- C setters

	c_set_lw_item (tmp: POINTER; a_lw_item: POINTER)
		external
			"C inline"
		alias
			"((struct listwatch_S *)$tmp)->lw_item = (struct listitem_S *)$a_lw_item;"
		end

	c_set_lw_next (tmp: POINTER; a_lw_next: POINTER)
		external
			"C inline"
		alias
			"((struct listwatch_S *)$tmp)->lw_next = (struct listwatch_S *)$a_lw_next;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct listwatch_S);"
		end

end
