class
	PD_LVAL_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ll_name: CE_POINTER [NATURAL_8] assign set_ll_name
		do
			create Result.make_shared (c_ll_name (c_pointer))
		end

	ll_exp_name: CE_POINTER [NATURAL_8] assign set_ll_exp_name
		do
			create Result.make_shared (c_ll_exp_name (c_pointer))
		end

	ll_tv: CE_POINTER [PD_TYPVAL_T] assign set_ll_tv
		do
			create Result.make_shared (c_ll_tv (c_pointer))
		end

	ll_li: CE_POINTER [PD_LISTITEM_S] assign set_ll_li
		do
			create Result.make_shared (c_ll_li (c_pointer))
		end

	ll_list: CE_POINTER [PD_LISTVAR_S] assign set_ll_list
		do
			create Result.make_shared (c_ll_list (c_pointer))
		end

	ll_range: INTEGER_32 assign set_ll_range
		do
			Result := c_ll_range (c_pointer)
		end

	ll_n1: INTEGER_32 assign set_ll_n1
		do
			Result := c_ll_n1 (c_pointer)
		end

	ll_n2: INTEGER_32 assign set_ll_n2
		do
			Result := c_ll_n2 (c_pointer)
		end

	ll_empty2: INTEGER_32 assign set_ll_empty2
		do
			Result := c_ll_empty2 (c_pointer)
		end

	ll_dict: CE_POINTER [PD_DICTVAR_S] assign set_ll_dict
		do
			create Result.make_shared (c_ll_dict (c_pointer))
		end

	ll_di: CE_POINTER [PD_DICTITEM_S] assign set_ll_di
		do
			create Result.make_shared (c_ll_di (c_pointer))
		end

	ll_newkey: CE_POINTER [NATURAL_8] assign set_ll_newkey
		do
			create Result.make_shared (c_ll_newkey (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_ll_name (a_ll_name: CE_POINTER [NATURAL_8])
		do
			c_set_ll_name (c_pointer, a_ll_name.c_pointer)
		end

	set_ll_exp_name (a_ll_exp_name: CE_POINTER [NATURAL_8])
		do
			c_set_ll_exp_name (c_pointer, a_ll_exp_name.c_pointer)
		end

	set_ll_tv (a_ll_tv: CE_POINTER [PD_TYPVAL_T])
		do
			c_set_ll_tv (c_pointer, a_ll_tv.c_pointer)
		end

	set_ll_li (a_ll_li: CE_POINTER [PD_LISTITEM_S])
		do
			c_set_ll_li (c_pointer, a_ll_li.c_pointer)
		end

	set_ll_list (a_ll_list: CE_POINTER [PD_LISTVAR_S])
		do
			c_set_ll_list (c_pointer, a_ll_list.c_pointer)
		end

	set_ll_range (a_ll_range: INTEGER_32)
		do
			c_set_ll_range (c_pointer, a_ll_range)
		end

	set_ll_n1 (a_ll_n1: INTEGER_32)
		do
			c_set_ll_n1 (c_pointer, a_ll_n1)
		end

	set_ll_n2 (a_ll_n2: INTEGER_32)
		do
			c_set_ll_n2 (c_pointer, a_ll_n2)
		end

	set_ll_empty2 (a_ll_empty2: INTEGER_32)
		do
			c_set_ll_empty2 (c_pointer, a_ll_empty2)
		end

	set_ll_dict (a_ll_dict: CE_POINTER [PD_DICTVAR_S])
		do
			c_set_ll_dict (c_pointer, a_ll_dict.c_pointer)
		end

	set_ll_di (a_ll_di: CE_POINTER [PD_DICTITEM_S])
		do
			c_set_ll_di (c_pointer, a_ll_di.c_pointer)
		end

	set_ll_newkey (a_ll_newkey: CE_POINTER [NATURAL_8])
		do
			c_set_ll_newkey (c_pointer, a_ll_newkey.c_pointer)
		end

feature {NONE} -- C getters

	c_ll_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct lval_S *)$tmp)->ll_name;"
		end

	c_ll_exp_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct lval_S *)$tmp)->ll_exp_name;"
		end

	c_ll_tv (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (typval_T *)((struct lval_S *)$tmp)->ll_tv;"
		end

	c_ll_li (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct listitem_S *)((struct lval_S *)$tmp)->ll_li;"
		end

	c_ll_list (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct listvar_S *)((struct lval_S *)$tmp)->ll_list;"
		end

	c_ll_range (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct lval_S *)$tmp)->ll_range;"
		end

	c_ll_n1 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct lval_S *)$tmp)->ll_n1;"
		end

	c_ll_n2 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct lval_S *)$tmp)->ll_n2;"
		end

	c_ll_empty2 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct lval_S *)$tmp)->ll_empty2;"
		end

	c_ll_dict (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dictvar_S *)((struct lval_S *)$tmp)->ll_dict;"
		end

	c_ll_di (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dictitem_S *)((struct lval_S *)$tmp)->ll_di;"
		end

	c_ll_newkey (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct lval_S *)$tmp)->ll_newkey;"
		end

feature {NONE} -- C setters

	c_set_ll_name (tmp: POINTER; a_ll_name: POINTER)
		external
			"C inline"
		alias
			"((struct lval_S *)$tmp)->ll_name = (unsigned char *)$a_ll_name;"
		end

	c_set_ll_exp_name (tmp: POINTER; a_ll_exp_name: POINTER)
		external
			"C inline"
		alias
			"((struct lval_S *)$tmp)->ll_exp_name = (unsigned char *)$a_ll_exp_name;"
		end

	c_set_ll_tv (tmp: POINTER; a_ll_tv: POINTER)
		external
			"C inline"
		alias
			"((struct lval_S *)$tmp)->ll_tv = (typval_T *)$a_ll_tv;"
		end

	c_set_ll_li (tmp: POINTER; a_ll_li: POINTER)
		external
			"C inline"
		alias
			"((struct lval_S *)$tmp)->ll_li = (struct listitem_S *)$a_ll_li;"
		end

	c_set_ll_list (tmp: POINTER; a_ll_list: POINTER)
		external
			"C inline"
		alias
			"((struct lval_S *)$tmp)->ll_list = (struct listvar_S *)$a_ll_list;"
		end

	c_set_ll_range (tmp: POINTER; a_ll_range: INTEGER_32)
		external
			"C inline"
		alias
			"((struct lval_S *)$tmp)->ll_range = $a_ll_range;"
		end

	c_set_ll_n1 (tmp: POINTER; a_ll_n1: INTEGER_32)
		external
			"C inline"
		alias
			"((struct lval_S *)$tmp)->ll_n1 = $a_ll_n1;"
		end

	c_set_ll_n2 (tmp: POINTER; a_ll_n2: INTEGER_32)
		external
			"C inline"
		alias
			"((struct lval_S *)$tmp)->ll_n2 = $a_ll_n2;"
		end

	c_set_ll_empty2 (tmp: POINTER; a_ll_empty2: INTEGER_32)
		external
			"C inline"
		alias
			"((struct lval_S *)$tmp)->ll_empty2 = $a_ll_empty2;"
		end

	c_set_ll_dict (tmp: POINTER; a_ll_dict: POINTER)
		external
			"C inline"
		alias
			"((struct lval_S *)$tmp)->ll_dict = (struct dictvar_S *)$a_ll_dict;"
		end

	c_set_ll_di (tmp: POINTER; a_ll_di: POINTER)
		external
			"C inline"
		alias
			"((struct lval_S *)$tmp)->ll_di = (struct dictitem_S *)$a_ll_di;"
		end

	c_set_ll_newkey (tmp: POINTER; a_ll_newkey: POINTER)
		external
			"C inline"
		alias
			"((struct lval_S *)$tmp)->ll_newkey = (unsigned char *)$a_ll_newkey;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct lval_S);"
		end

end
