class
	PD_MATCH_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	rm: PD_REGMMATCH_T assign set_rm
		do
			create Result.make_shared (c_rm (c_pointer))
		end

	rm_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_match_T_535, rm);"
		end

	buf: CE_POINTER [PD_FILE_BUFFER] assign set_buf
		do
			create Result.make_shared (c_buf (c_pointer))
		end

	lnum: INTEGER_32 assign set_lnum
		do
			Result := c_lnum (c_pointer)
		end

	attr: INTEGER_32 assign set_attr
		do
			Result := c_attr (c_pointer)
		end

	attr_cur: INTEGER_32 assign set_attr_cur
		do
			Result := c_attr_cur (c_pointer)
		end

	first_lnum: INTEGER_32 assign set_first_lnum
		do
			Result := c_first_lnum (c_pointer)
		end

	startcol: INTEGER_32 assign set_startcol
		do
			Result := c_startcol (c_pointer)
		end

	endcol: INTEGER_32 assign set_endcol
		do
			Result := c_endcol (c_pointer)
		end

	tm: SD_TIMEVAL assign set_tm
		do
			create Result.make_shared (c_tm (c_pointer))
		end

	tm_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_match_T_535, tm);"
		end

feature {ANY} -- Eiffel setters

	set_rm (a_rm: PD_REGMMATCH_T)
		do
			rm.ce_gets (a_rm)
		end

	set_buf (a_buf: CE_POINTER [PD_FILE_BUFFER])
		do
			c_set_buf (c_pointer, a_buf.c_pointer)
		end

	set_lnum (a_lnum: INTEGER_32)
		do
			c_set_lnum (c_pointer, a_lnum)
		end

	set_attr (a_attr: INTEGER_32)
		do
			c_set_attr (c_pointer, a_attr)
		end

	set_attr_cur (a_attr_cur: INTEGER_32)
		do
			c_set_attr_cur (c_pointer, a_attr_cur)
		end

	set_first_lnum (a_first_lnum: INTEGER_32)
		do
			c_set_first_lnum (c_pointer, a_first_lnum)
		end

	set_startcol (a_startcol: INTEGER_32)
		do
			c_set_startcol (c_pointer, a_startcol)
		end

	set_endcol (a_endcol: INTEGER_32)
		do
			c_set_endcol (c_pointer, a_endcol)
		end

	set_tm (a_tm: SD_TIMEVAL)
		do
			tm.ce_gets (a_tm)
		end

feature {NONE} -- C getters

	c_rm (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (regmmatch_T *)&((struct __anonstruct_match_T_535 *)$tmp)->rm;"
		end

	c_buf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct file_buffer *)((struct __anonstruct_match_T_535 *)$tmp)->buf;"
		end

	c_lnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_match_T_535 *)$tmp)->lnum;"
		end

	c_attr (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_match_T_535 *)$tmp)->attr;"
		end

	c_attr_cur (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_match_T_535 *)$tmp)->attr_cur;"
		end

	c_first_lnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_match_T_535 *)$tmp)->first_lnum;"
		end

	c_startcol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_match_T_535 *)$tmp)->startcol;"
		end

	c_endcol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_match_T_535 *)$tmp)->endcol;"
		end

	c_tm (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct timeval *)&((struct __anonstruct_match_T_535 *)$tmp)->tm;"
		end

feature {NONE} -- C setters

	c_set_buf (tmp: POINTER; a_buf: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_match_T_535 *)$tmp)->buf = (struct file_buffer *)$a_buf;"
		end

	c_set_lnum (tmp: POINTER; a_lnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_match_T_535 *)$tmp)->lnum = $a_lnum;"
		end

	c_set_attr (tmp: POINTER; a_attr: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_match_T_535 *)$tmp)->attr = $a_attr;"
		end

	c_set_attr_cur (tmp: POINTER; a_attr_cur: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_match_T_535 *)$tmp)->attr_cur = $a_attr_cur;"
		end

	c_set_first_lnum (tmp: POINTER; a_first_lnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_match_T_535 *)$tmp)->first_lnum = $a_first_lnum;"
		end

	c_set_startcol (tmp: POINTER; a_startcol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_match_T_535 *)$tmp)->startcol = $a_startcol;"
		end

	c_set_endcol (tmp: POINTER; a_endcol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_match_T_535 *)$tmp)->endcol = $a_endcol;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_match_T_535);"
		end

end
