class
	PD_MATCHINF_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	mi_lp: CE_POINTER [PD_LANGP_S] assign set_mi_lp
		do
			create Result.make_shared (c_mi_lp (c_pointer))
		end

	mi_word: CE_POINTER [NATURAL_8] assign set_mi_word
		do
			create Result.make_shared (c_mi_word (c_pointer))
		end

	mi_end: CE_POINTER [NATURAL_8] assign set_mi_end
		do
			create Result.make_shared (c_mi_end (c_pointer))
		end

	mi_fend: CE_POINTER [NATURAL_8] assign set_mi_fend
		do
			create Result.make_shared (c_mi_fend (c_pointer))
		end

	mi_cend: CE_POINTER [NATURAL_8] assign set_mi_cend
		do
			create Result.make_shared (c_mi_cend (c_pointer))
		end

	mi_fword: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_mi_fword (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	mi_fwordlen: INTEGER_32 assign set_mi_fwordlen
		do
			Result := c_mi_fwordlen (c_pointer)
		end

	mi_prefarridx: INTEGER_32 assign set_mi_prefarridx
		do
			Result := c_mi_prefarridx (c_pointer)
		end

	mi_prefcnt: INTEGER_32 assign set_mi_prefcnt
		do
			Result := c_mi_prefcnt (c_pointer)
		end

	mi_prefixlen: INTEGER_32 assign set_mi_prefixlen
		do
			Result := c_mi_prefixlen (c_pointer)
		end

	mi_cprefixlen: INTEGER_32 assign set_mi_cprefixlen
		do
			Result := c_mi_cprefixlen (c_pointer)
		end

	mi_compoff: INTEGER_32 assign set_mi_compoff
		do
			Result := c_mi_compoff (c_pointer)
		end

	mi_compflags: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_mi_compflags (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	mi_complen: INTEGER_32 assign set_mi_complen
		do
			Result := c_mi_complen (c_pointer)
		end

	mi_compextra: INTEGER_32 assign set_mi_compextra
		do
			Result := c_mi_compextra (c_pointer)
		end

	mi_result: INTEGER_32 assign set_mi_result
		do
			Result := c_mi_result (c_pointer)
		end

	mi_capflags: INTEGER_32 assign set_mi_capflags
		do
			Result := c_mi_capflags (c_pointer)
		end

	mi_win: CE_POINTER [PD_WINDOW_S] assign set_mi_win
		do
			create Result.make_shared (c_mi_win (c_pointer))
		end

	mi_result2: INTEGER_32 assign set_mi_result2
		do
			Result := c_mi_result2 (c_pointer)
		end

	mi_end2: CE_POINTER [NATURAL_8] assign set_mi_end2
		do
			create Result.make_shared (c_mi_end2 (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_mi_lp (a_mi_lp: CE_POINTER [PD_LANGP_S])
		do
			c_set_mi_lp (c_pointer, a_mi_lp.c_pointer)
		end

	set_mi_word (a_mi_word: CE_POINTER [NATURAL_8])
		do
			c_set_mi_word (c_pointer, a_mi_word.c_pointer)
		end

	set_mi_end (a_mi_end: CE_POINTER [NATURAL_8])
		do
			c_set_mi_end (c_pointer, a_mi_end.c_pointer)
		end

	set_mi_fend (a_mi_fend: CE_POINTER [NATURAL_8])
		do
			c_set_mi_fend (c_pointer, a_mi_fend.c_pointer)
		end

	set_mi_cend (a_mi_cend: CE_POINTER [NATURAL_8])
		do
			c_set_mi_cend (c_pointer, a_mi_cend.c_pointer)
		end

	set_mi_fwordlen (a_mi_fwordlen: INTEGER_32)
		do
			c_set_mi_fwordlen (c_pointer, a_mi_fwordlen)
		end

	set_mi_prefarridx (a_mi_prefarridx: INTEGER_32)
		do
			c_set_mi_prefarridx (c_pointer, a_mi_prefarridx)
		end

	set_mi_prefcnt (a_mi_prefcnt: INTEGER_32)
		do
			c_set_mi_prefcnt (c_pointer, a_mi_prefcnt)
		end

	set_mi_prefixlen (a_mi_prefixlen: INTEGER_32)
		do
			c_set_mi_prefixlen (c_pointer, a_mi_prefixlen)
		end

	set_mi_cprefixlen (a_mi_cprefixlen: INTEGER_32)
		do
			c_set_mi_cprefixlen (c_pointer, a_mi_cprefixlen)
		end

	set_mi_compoff (a_mi_compoff: INTEGER_32)
		do
			c_set_mi_compoff (c_pointer, a_mi_compoff)
		end

	set_mi_complen (a_mi_complen: INTEGER_32)
		do
			c_set_mi_complen (c_pointer, a_mi_complen)
		end

	set_mi_compextra (a_mi_compextra: INTEGER_32)
		do
			c_set_mi_compextra (c_pointer, a_mi_compextra)
		end

	set_mi_result (a_mi_result: INTEGER_32)
		do
			c_set_mi_result (c_pointer, a_mi_result)
		end

	set_mi_capflags (a_mi_capflags: INTEGER_32)
		do
			c_set_mi_capflags (c_pointer, a_mi_capflags)
		end

	set_mi_win (a_mi_win: CE_POINTER [PD_WINDOW_S])
		do
			c_set_mi_win (c_pointer, a_mi_win.c_pointer)
		end

	set_mi_result2 (a_mi_result2: INTEGER_32)
		do
			c_set_mi_result2 (c_pointer, a_mi_result2)
		end

	set_mi_end2 (a_mi_end2: CE_POINTER [NATURAL_8])
		do
			c_set_mi_end2 (c_pointer, a_mi_end2.c_pointer)
		end

feature {NONE} -- C getters

	c_mi_lp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct langp_S *)((struct matchinf_S *)$tmp)->mi_lp;"
		end

	c_mi_word (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct matchinf_S *)$tmp)->mi_word;"
		end

	c_mi_end (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct matchinf_S *)$tmp)->mi_end;"
		end

	c_mi_fend (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct matchinf_S *)$tmp)->mi_fend;"
		end

	c_mi_cend (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct matchinf_S *)$tmp)->mi_cend;"
		end

	c_mi_fword (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct matchinf_S *tmp = (struct matchinf_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->mi_fword) / sizeof(tmp->mi_fword[0]);
				return tmp->mi_fword;
			]"
		end

	c_mi_fwordlen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct matchinf_S *)$tmp)->mi_fwordlen;"
		end

	c_mi_prefarridx (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct matchinf_S *)$tmp)->mi_prefarridx;"
		end

	c_mi_prefcnt (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct matchinf_S *)$tmp)->mi_prefcnt;"
		end

	c_mi_prefixlen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct matchinf_S *)$tmp)->mi_prefixlen;"
		end

	c_mi_cprefixlen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct matchinf_S *)$tmp)->mi_cprefixlen;"
		end

	c_mi_compoff (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct matchinf_S *)$tmp)->mi_compoff;"
		end

	c_mi_compflags (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct matchinf_S *tmp = (struct matchinf_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->mi_compflags) / sizeof(tmp->mi_compflags[0]);
				return tmp->mi_compflags;
			]"
		end

	c_mi_complen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct matchinf_S *)$tmp)->mi_complen;"
		end

	c_mi_compextra (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct matchinf_S *)$tmp)->mi_compextra;"
		end

	c_mi_result (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct matchinf_S *)$tmp)->mi_result;"
		end

	c_mi_capflags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct matchinf_S *)$tmp)->mi_capflags;"
		end

	c_mi_win (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct window_S *)((struct matchinf_S *)$tmp)->mi_win;"
		end

	c_mi_result2 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct matchinf_S *)$tmp)->mi_result2;"
		end

	c_mi_end2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct matchinf_S *)$tmp)->mi_end2;"
		end

feature {NONE} -- C setters

	c_set_mi_lp (tmp: POINTER; a_mi_lp: POINTER)
		external
			"C inline"
		alias
			"((struct matchinf_S *)$tmp)->mi_lp = (struct langp_S *)$a_mi_lp;"
		end

	c_set_mi_word (tmp: POINTER; a_mi_word: POINTER)
		external
			"C inline"
		alias
			"((struct matchinf_S *)$tmp)->mi_word = (unsigned char *)$a_mi_word;"
		end

	c_set_mi_end (tmp: POINTER; a_mi_end: POINTER)
		external
			"C inline"
		alias
			"((struct matchinf_S *)$tmp)->mi_end = (unsigned char *)$a_mi_end;"
		end

	c_set_mi_fend (tmp: POINTER; a_mi_fend: POINTER)
		external
			"C inline"
		alias
			"((struct matchinf_S *)$tmp)->mi_fend = (unsigned char *)$a_mi_fend;"
		end

	c_set_mi_cend (tmp: POINTER; a_mi_cend: POINTER)
		external
			"C inline"
		alias
			"((struct matchinf_S *)$tmp)->mi_cend = (unsigned char *)$a_mi_cend;"
		end

	c_set_mi_fwordlen (tmp: POINTER; a_mi_fwordlen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct matchinf_S *)$tmp)->mi_fwordlen = $a_mi_fwordlen;"
		end

	c_set_mi_prefarridx (tmp: POINTER; a_mi_prefarridx: INTEGER_32)
		external
			"C inline"
		alias
			"((struct matchinf_S *)$tmp)->mi_prefarridx = $a_mi_prefarridx;"
		end

	c_set_mi_prefcnt (tmp: POINTER; a_mi_prefcnt: INTEGER_32)
		external
			"C inline"
		alias
			"((struct matchinf_S *)$tmp)->mi_prefcnt = $a_mi_prefcnt;"
		end

	c_set_mi_prefixlen (tmp: POINTER; a_mi_prefixlen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct matchinf_S *)$tmp)->mi_prefixlen = $a_mi_prefixlen;"
		end

	c_set_mi_cprefixlen (tmp: POINTER; a_mi_cprefixlen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct matchinf_S *)$tmp)->mi_cprefixlen = $a_mi_cprefixlen;"
		end

	c_set_mi_compoff (tmp: POINTER; a_mi_compoff: INTEGER_32)
		external
			"C inline"
		alias
			"((struct matchinf_S *)$tmp)->mi_compoff = $a_mi_compoff;"
		end

	c_set_mi_complen (tmp: POINTER; a_mi_complen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct matchinf_S *)$tmp)->mi_complen = $a_mi_complen;"
		end

	c_set_mi_compextra (tmp: POINTER; a_mi_compextra: INTEGER_32)
		external
			"C inline"
		alias
			"((struct matchinf_S *)$tmp)->mi_compextra = $a_mi_compextra;"
		end

	c_set_mi_result (tmp: POINTER; a_mi_result: INTEGER_32)
		external
			"C inline"
		alias
			"((struct matchinf_S *)$tmp)->mi_result = $a_mi_result;"
		end

	c_set_mi_capflags (tmp: POINTER; a_mi_capflags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct matchinf_S *)$tmp)->mi_capflags = $a_mi_capflags;"
		end

	c_set_mi_win (tmp: POINTER; a_mi_win: POINTER)
		external
			"C inline"
		alias
			"((struct matchinf_S *)$tmp)->mi_win = (struct window_S *)$a_mi_win;"
		end

	c_set_mi_result2 (tmp: POINTER; a_mi_result2: INTEGER_32)
		external
			"C inline"
		alias
			"((struct matchinf_S *)$tmp)->mi_result2 = $a_mi_result2;"
		end

	c_set_mi_end2 (tmp: POINTER; a_mi_end2: POINTER)
		external
			"C inline"
		alias
			"((struct matchinf_S *)$tmp)->mi_end2 = (unsigned char *)$a_mi_end2;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct matchinf_S);"
		end

end
