class
	PD_MENUTRANS_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	from2: CE_POINTER [NATURAL_8] assign set_from2
		do
			create Result.make_shared (c_from2 (c_pointer))
		end

	from_noamp: CE_POINTER [NATURAL_8] assign set_from_noamp
		do
			create Result.make_shared (c_from_noamp (c_pointer))
		end

	to: CE_POINTER [NATURAL_8] assign set_to
		do
			create Result.make_shared (c_to (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_from2 (a_from2: CE_POINTER [NATURAL_8])
		do
			c_set_from2 (c_pointer, a_from2.c_pointer)
		end

	set_from_noamp (a_from_noamp: CE_POINTER [NATURAL_8])
		do
			c_set_from_noamp (c_pointer, a_from_noamp.c_pointer)
		end

	set_to (a_to: CE_POINTER [NATURAL_8])
		do
			c_set_to (c_pointer, a_to.c_pointer)
		end

feature {NONE} -- C getters

	c_from2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_menutrans_T_543 *)$tmp)->from;"
		end

	c_from_noamp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_menutrans_T_543 *)$tmp)->from_noamp;"
		end

	c_to (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_menutrans_T_543 *)$tmp)->to;"
		end

feature {NONE} -- C setters

	c_set_from2 (tmp: POINTER; a_from2: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_menutrans_T_543 *)$tmp)->from = (unsigned char *)$a_from2;"
		end

	c_set_from_noamp (tmp: POINTER; a_from_noamp: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_menutrans_T_543 *)$tmp)->from_noamp = (unsigned char *)$a_from_noamp;"
		end

	c_set_to (tmp: POINTER; a_to: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_menutrans_T_543 *)$tmp)->to = (unsigned char *)$a_to;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_menutrans_T_543);"
		end

end
