class
	PD_ML_CHUNKSIZE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	mlcs_numlines: INTEGER_32 assign set_mlcs_numlines
		do
			Result := c_mlcs_numlines (c_pointer)
		end

	mlcs_totalsize: INTEGER_32 assign set_mlcs_totalsize
		do
			Result := c_mlcs_totalsize (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_mlcs_numlines (a_mlcs_numlines: INTEGER_32)
		do
			c_set_mlcs_numlines (c_pointer, a_mlcs_numlines)
		end

	set_mlcs_totalsize (a_mlcs_totalsize: INTEGER_32)
		do
			c_set_mlcs_totalsize (c_pointer, a_mlcs_totalsize)
		end

feature {NONE} -- C getters

	c_mlcs_numlines (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ml_chunksize *)$tmp)->mlcs_numlines;"
		end

	c_mlcs_totalsize (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct ml_chunksize *)$tmp)->mlcs_totalsize;"
		end

feature {NONE} -- C setters

	c_set_mlcs_numlines (tmp: POINTER; a_mlcs_numlines: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ml_chunksize *)$tmp)->mlcs_numlines = $a_mlcs_numlines;"
		end

	c_set_mlcs_totalsize (tmp: POINTER; a_mlcs_totalsize: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ml_chunksize *)$tmp)->mlcs_totalsize = $a_mlcs_totalsize;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct ml_chunksize);"
		end

end
