class
	PD_MODMASKTABLE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	mod_mask: INTEGER_16 assign set_mod_mask
		do
			Result := c_mod_mask (c_pointer)
		end

	mod_flag: INTEGER_16 assign set_mod_flag
		do
			Result := c_mod_flag (c_pointer)
		end

	name: NATURAL_8 assign set_name
		do
			Result := c_name (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_mod_mask (a_mod_mask: INTEGER_16)
		do
			c_set_mod_mask (c_pointer, a_mod_mask)
		end

	set_mod_flag (a_mod_flag: INTEGER_16)
		do
			c_set_mod_flag (c_pointer, a_mod_flag)
		end

	set_name (a_name: NATURAL_8)
		do
			c_set_name (c_pointer, a_name)
		end

feature {NONE} -- C getters

	c_mod_mask (tmp: POINTER): INTEGER_16
		external
			"C inline"
		alias
			"return (short)((struct modmasktable *)$tmp)->mod_mask;"
		end

	c_mod_flag (tmp: POINTER): INTEGER_16
		external
			"C inline"
		alias
			"return (short)((struct modmasktable *)$tmp)->mod_flag;"
		end

	c_name (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct modmasktable *)$tmp)->name;"
		end

feature {NONE} -- C setters

	c_set_mod_mask (tmp: POINTER; a_mod_mask: INTEGER_16)
		external
			"C inline"
		alias
			"((struct modmasktable *)$tmp)->mod_mask = $a_mod_mask;"
		end

	c_set_mod_flag (tmp: POINTER; a_mod_flag: INTEGER_16)
		external
			"C inline"
		alias
			"((struct modmasktable *)$tmp)->mod_flag = $a_mod_flag;"
		end

	c_set_name (tmp: POINTER; a_name: NATURAL_8)
		external
			"C inline"
		alias
			"((struct modmasktable *)$tmp)->name = $a_name;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct modmasktable);"
		end

end
