class
	PD_MOUSETABLE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	pseudo_code: INTEGER_32 assign set_pseudo_code
		do
			Result := c_pseudo_code (c_pointer)
		end

	button: INTEGER_32 assign set_button
		do
			Result := c_button (c_pointer)
		end

	is_click: INTEGER_32 assign set_is_click
		do
			Result := c_is_click (c_pointer)
		end

	is_drag: INTEGER_32 assign set_is_drag
		do
			Result := c_is_drag (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_pseudo_code (a_pseudo_code: INTEGER_32)
		do
			c_set_pseudo_code (c_pointer, a_pseudo_code)
		end

	set_button (a_button: INTEGER_32)
		do
			c_set_button (c_pointer, a_button)
		end

	set_is_click (a_is_click: INTEGER_32)
		do
			c_set_is_click (c_pointer, a_is_click)
		end

	set_is_drag (a_is_drag: INTEGER_32)
		do
			c_set_is_drag (c_pointer, a_is_drag)
		end

feature {NONE} -- C getters

	c_pseudo_code (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct mousetable *)$tmp)->pseudo_code;"
		end

	c_button (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct mousetable *)$tmp)->button;"
		end

	c_is_click (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct mousetable *)$tmp)->is_click;"
		end

	c_is_drag (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct mousetable *)$tmp)->is_drag;"
		end

feature {NONE} -- C setters

	c_set_pseudo_code (tmp: POINTER; a_pseudo_code: INTEGER_32)
		external
			"C inline"
		alias
			"((struct mousetable *)$tmp)->pseudo_code = $a_pseudo_code;"
		end

	c_set_button (tmp: POINTER; a_button: INTEGER_32)
		external
			"C inline"
		alias
			"((struct mousetable *)$tmp)->button = $a_button;"
		end

	c_set_is_click (tmp: POINTER; a_is_click: INTEGER_32)
		external
			"C inline"
		alias
			"((struct mousetable *)$tmp)->is_click = $a_is_click;"
		end

	c_set_is_drag (tmp: POINTER; a_is_drag: INTEGER_32)
		external
			"C inline"
		alias
			"((struct mousetable *)$tmp)->is_drag = $a_is_drag;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct mousetable);"
		end

end
