class
	PD_MSG_HIST

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_MSG_HIST] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	msg: CE_POINTER [NATURAL_8] assign set_msg
		do
			create Result.make_shared (c_msg (c_pointer))
		end

	attr: INTEGER_32 assign set_attr
		do
			Result := c_attr (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_MSG_HIST])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_msg (a_msg: CE_POINTER [NATURAL_8])
		do
			c_set_msg (c_pointer, a_msg.c_pointer)
		end

	set_attr (a_attr: INTEGER_32)
		do
			c_set_attr (c_pointer, a_attr)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct msg_hist *)((struct msg_hist *)$tmp)->next;"
		end

	c_msg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct msg_hist *)$tmp)->msg;"
		end

	c_attr (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct msg_hist *)$tmp)->attr;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct msg_hist *)$tmp)->next = (struct msg_hist *)$a_next;"
		end

	c_set_msg (tmp: POINTER; a_msg: POINTER)
		external
			"C inline"
		alias
			"((struct msg_hist *)$tmp)->msg = (unsigned char *)$a_msg;"
		end

	c_set_attr (tmp: POINTER; a_attr: INTEGER_32)
		external
			"C inline"
		alias
			"((struct msg_hist *)$tmp)->attr = $a_attr;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct msg_hist);"
		end

end
