class
	PD_NAME_LIST

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	flag: INTEGER_32 assign set_flag
		do
			Result := c_flag (c_pointer)
		end

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_flag (a_flag: INTEGER_32)
		do
			c_set_flag (c_pointer, a_flag)
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

feature {NONE} -- C getters

	c_flag (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct name_list *)$tmp)->flag;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct name_list *)$tmp)->name;"
		end

feature {NONE} -- C setters

	c_set_flag (tmp: POINTER; a_flag: INTEGER_32)
		external
			"C inline"
		alias
			"((struct name_list *)$tmp)->flag = $a_flag;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct name_list *)$tmp)->name = (char *)$a_name;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct name_list);"
		end

end
