class
	PD_PENDINGCOMMAND

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	serial: INTEGER_32 assign set_serial
		do
			Result := c_serial (c_pointer)
		end

	code: INTEGER_32 assign set_code
		do
			Result := c_code (c_pointer)
		end

	result2: CE_POINTER [NATURAL_8] assign set_result2
		do
			create Result.make_shared (c_result2 (c_pointer))
		end

	nextPtr: CE_POINTER [PD_PENDINGCOMMAND] assign set_nextPtr
		do
			create Result.make_shared (c_nextPtr (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_serial (a_serial: INTEGER_32)
		do
			c_set_serial (c_pointer, a_serial)
		end

	set_code (a_code: INTEGER_32)
		do
			c_set_code (c_pointer, a_code)
		end

	set_result2 (a_result2: CE_POINTER [NATURAL_8])
		do
			c_set_result2 (c_pointer, a_result2.c_pointer)
		end

	set_nextPtr (a_nextPtr: CE_POINTER [PD_PENDINGCOMMAND])
		do
			c_set_nextPtr (c_pointer, a_nextPtr.c_pointer)
		end

feature {NONE} -- C getters

	c_serial (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct PendingCommand *)$tmp)->serial;"
		end

	c_code (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct PendingCommand *)$tmp)->code;"
		end

	c_result2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct PendingCommand *)$tmp)->result;"
		end

	c_nextPtr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct PendingCommand *)((struct PendingCommand *)$tmp)->nextPtr;"
		end

feature {NONE} -- C setters

	c_set_serial (tmp: POINTER; a_serial: INTEGER_32)
		external
			"C inline"
		alias
			"((struct PendingCommand *)$tmp)->serial = $a_serial;"
		end

	c_set_code (tmp: POINTER; a_code: INTEGER_32)
		external
			"C inline"
		alias
			"((struct PendingCommand *)$tmp)->code = $a_code;"
		end

	c_set_result2 (tmp: POINTER; a_result2: POINTER)
		external
			"C inline"
		alias
			"((struct PendingCommand *)$tmp)->result = (unsigned char *)$a_result2;"
		end

	c_set_nextPtr (tmp: POINTER; a_nextPtr: POINTER)
		external
			"C inline"
		alias
			"((struct PendingCommand *)$tmp)->nextPtr = (struct PendingCommand *)$a_nextptr;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct PendingCommand);"
		end

end
