class
	PD_PRT_DSC_LINE_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	string: CE_POINTER [NATURAL_8] assign set_string
		do
			create Result.make_shared (c_string (c_pointer))
		end

	len: INTEGER_32 assign set_len
		do
			Result := c_len (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_string (a_string: CE_POINTER [NATURAL_8])
		do
			c_set_string (c_pointer, a_string.c_pointer)
		end

	set_len (a_len: INTEGER_32)
		do
			c_set_len (c_pointer, a_len)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct prt_dsc_line_S *)$tmp)->type;"
		end

	c_string (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct prt_dsc_line_S *)$tmp)->string;"
		end

	c_len (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct prt_dsc_line_S *)$tmp)->len;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct prt_dsc_line_S *)$tmp)->type = $a_type;"
		end

	c_set_string (tmp: POINTER; a_string: POINTER)
		external
			"C inline"
		alias
			"((struct prt_dsc_line_S *)$tmp)->string = (unsigned char *)$a_string;"
		end

	c_set_len (tmp: POINTER; a_len: INTEGER_32)
		external
			"C inline"
		alias
			"((struct prt_dsc_line_S *)$tmp)->len = $a_len;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct prt_dsc_line_S);"
		end

end
