class
	PD_PRT_POS_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	lead_spaces: INTEGER_32 assign set_lead_spaces
		do
			Result := c_lead_spaces (c_pointer)
		end

	print_pos: INTEGER_32 assign set_print_pos
		do
			Result := c_print_pos (c_pointer)
		end

	column: INTEGER_32 assign set_column
		do
			Result := c_column (c_pointer)
		end

	file_line: INTEGER_32 assign set_file_line
		do
			Result := c_file_line (c_pointer)
		end

	bytes_printed: NATURAL_32 assign set_bytes_printed
		do
			Result := c_bytes_printed (c_pointer)
		end

	ff: INTEGER_32 assign set_ff
		do
			Result := c_ff (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_lead_spaces (a_lead_spaces: INTEGER_32)
		do
			c_set_lead_spaces (c_pointer, a_lead_spaces)
		end

	set_print_pos (a_print_pos: INTEGER_32)
		do
			c_set_print_pos (c_pointer, a_print_pos)
		end

	set_column (a_column: INTEGER_32)
		do
			c_set_column (c_pointer, a_column)
		end

	set_file_line (a_file_line: INTEGER_32)
		do
			c_set_file_line (c_pointer, a_file_line)
		end

	set_bytes_printed (a_bytes_printed: NATURAL_32)
		do
			c_set_bytes_printed (c_pointer, a_bytes_printed)
		end

	set_ff (a_ff: INTEGER_32)
		do
			c_set_ff (c_pointer, a_ff)
		end

feature {NONE} -- C getters

	c_lead_spaces (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_prt_pos_T_543 *)$tmp)->lead_spaces;"
		end

	c_print_pos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_prt_pos_T_543 *)$tmp)->print_pos;"
		end

	c_column (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_prt_pos_T_543 *)$tmp)->column;"
		end

	c_file_line (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_prt_pos_T_543 *)$tmp)->file_line;"
		end

	c_bytes_printed (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_prt_pos_T_543 *)$tmp)->bytes_printed;"
		end

	c_ff (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_prt_pos_T_543 *)$tmp)->ff;"
		end

feature {NONE} -- C setters

	c_set_lead_spaces (tmp: POINTER; a_lead_spaces: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_prt_pos_T_543 *)$tmp)->lead_spaces = $a_lead_spaces;"
		end

	c_set_print_pos (tmp: POINTER; a_print_pos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_prt_pos_T_543 *)$tmp)->print_pos = $a_print_pos;"
		end

	c_set_column (tmp: POINTER; a_column: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_prt_pos_T_543 *)$tmp)->column = $a_column;"
		end

	c_set_file_line (tmp: POINTER; a_file_line: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_prt_pos_T_543 *)$tmp)->file_line = $a_file_line;"
		end

	c_set_bytes_printed (tmp: POINTER; a_bytes_printed: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_prt_pos_T_543 *)$tmp)->bytes_printed = $a_bytes_printed;"
		end

	c_set_ff (tmp: POINTER; a_ff: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_prt_pos_T_543 *)$tmp)->ff = $a_ff;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_prt_pos_T_543);"
		end

end
