class
	PD_PUMITEM_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	pum_text: CE_POINTER [NATURAL_8] assign set_pum_text
		do
			create Result.make_shared (c_pum_text (c_pointer))
		end

	pum_kind: CE_POINTER [NATURAL_8] assign set_pum_kind
		do
			create Result.make_shared (c_pum_kind (c_pointer))
		end

	pum_extra: CE_POINTER [NATURAL_8] assign set_pum_extra
		do
			create Result.make_shared (c_pum_extra (c_pointer))
		end

	pum_info: CE_POINTER [NATURAL_8] assign set_pum_info
		do
			create Result.make_shared (c_pum_info (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_pum_text (a_pum_text: CE_POINTER [NATURAL_8])
		do
			c_set_pum_text (c_pointer, a_pum_text.c_pointer)
		end

	set_pum_kind (a_pum_kind: CE_POINTER [NATURAL_8])
		do
			c_set_pum_kind (c_pointer, a_pum_kind.c_pointer)
		end

	set_pum_extra (a_pum_extra: CE_POINTER [NATURAL_8])
		do
			c_set_pum_extra (c_pointer, a_pum_extra.c_pointer)
		end

	set_pum_info (a_pum_info: CE_POINTER [NATURAL_8])
		do
			c_set_pum_info (c_pointer, a_pum_info.c_pointer)
		end

feature {NONE} -- C getters

	c_pum_text (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_pumitem_T_540 *)$tmp)->pum_text;"
		end

	c_pum_kind (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_pumitem_T_540 *)$tmp)->pum_kind;"
		end

	c_pum_extra (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_pumitem_T_540 *)$tmp)->pum_extra;"
		end

	c_pum_info (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_pumitem_T_540 *)$tmp)->pum_info;"
		end

feature {NONE} -- C setters

	c_set_pum_text (tmp: POINTER; a_pum_text: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_pumitem_T_540 *)$tmp)->pum_text = (unsigned char *)$a_pum_text;"
		end

	c_set_pum_kind (tmp: POINTER; a_pum_kind: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_pumitem_T_540 *)$tmp)->pum_kind = (unsigned char *)$a_pum_kind;"
		end

	c_set_pum_extra (tmp: POINTER; a_pum_extra: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_pumitem_T_540 *)$tmp)->pum_extra = (unsigned char *)$a_pum_extra;"
		end

	c_set_pum_info (tmp: POINTER; a_pum_info: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_pumitem_T_540 *)$tmp)->pum_info = (unsigned char *)$a_pum_info;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_pumitem_T_540);"
		end

end
