class
	PD_QF_LIST_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	qf_start: CE_POINTER [PD_QFLINE_S] assign set_qf_start
		do
			create Result.make_shared (c_qf_start (c_pointer))
		end

	qf_ptr: CE_POINTER [PD_QFLINE_S] assign set_qf_ptr
		do
			create Result.make_shared (c_qf_ptr (c_pointer))
		end

	qf_count: INTEGER_32 assign set_qf_count
		do
			Result := c_qf_count (c_pointer)
		end

	qf_index: INTEGER_32 assign set_qf_index
		do
			Result := c_qf_index (c_pointer)
		end

	qf_nonevalid: INTEGER_32 assign set_qf_nonevalid
		do
			Result := c_qf_nonevalid (c_pointer)
		end

	qf_title: CE_POINTER [NATURAL_8] assign set_qf_title
		do
			create Result.make_shared (c_qf_title (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_qf_start (a_qf_start: CE_POINTER [PD_QFLINE_S])
		do
			c_set_qf_start (c_pointer, a_qf_start.c_pointer)
		end

	set_qf_ptr (a_qf_ptr: CE_POINTER [PD_QFLINE_S])
		do
			c_set_qf_ptr (c_pointer, a_qf_ptr.c_pointer)
		end

	set_qf_count (a_qf_count: INTEGER_32)
		do
			c_set_qf_count (c_pointer, a_qf_count)
		end

	set_qf_index (a_qf_index: INTEGER_32)
		do
			c_set_qf_index (c_pointer, a_qf_index)
		end

	set_qf_nonevalid (a_qf_nonevalid: INTEGER_32)
		do
			c_set_qf_nonevalid (c_pointer, a_qf_nonevalid)
		end

	set_qf_title (a_qf_title: CE_POINTER [NATURAL_8])
		do
			c_set_qf_title (c_pointer, a_qf_title.c_pointer)
		end

feature {NONE} -- C getters

	c_qf_start (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct qfline_S *)((struct qf_list_S *)$tmp)->qf_start;"
		end

	c_qf_ptr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct qfline_S *)((struct qf_list_S *)$tmp)->qf_ptr;"
		end

	c_qf_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct qf_list_S *)$tmp)->qf_count;"
		end

	c_qf_index (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct qf_list_S *)$tmp)->qf_index;"
		end

	c_qf_nonevalid (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct qf_list_S *)$tmp)->qf_nonevalid;"
		end

	c_qf_title (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct qf_list_S *)$tmp)->qf_title;"
		end

feature {NONE} -- C setters

	c_set_qf_start (tmp: POINTER; a_qf_start: POINTER)
		external
			"C inline"
		alias
			"((struct qf_list_S *)$tmp)->qf_start = (struct qfline_S *)$a_qf_start;"
		end

	c_set_qf_ptr (tmp: POINTER; a_qf_ptr: POINTER)
		external
			"C inline"
		alias
			"((struct qf_list_S *)$tmp)->qf_ptr = (struct qfline_S *)$a_qf_ptr;"
		end

	c_set_qf_count (tmp: POINTER; a_qf_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct qf_list_S *)$tmp)->qf_count = $a_qf_count;"
		end

	c_set_qf_index (tmp: POINTER; a_qf_index: INTEGER_32)
		external
			"C inline"
		alias
			"((struct qf_list_S *)$tmp)->qf_index = $a_qf_index;"
		end

	c_set_qf_nonevalid (tmp: POINTER; a_qf_nonevalid: INTEGER_32)
		external
			"C inline"
		alias
			"((struct qf_list_S *)$tmp)->qf_nonevalid = $a_qf_nonevalid;"
		end

	c_set_qf_title (tmp: POINTER; a_qf_title: POINTER)
		external
			"C inline"
		alias
			"((struct qf_list_S *)$tmp)->qf_title = (unsigned char *)$a_qf_title;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct qf_list_S);"
		end

end
