class
	PD_QFLINE_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	qf_next: CE_POINTER [PD_QFLINE_S] assign set_qf_next
		do
			create Result.make_shared (c_qf_next (c_pointer))
		end

	qf_prev: CE_POINTER [PD_QFLINE_S] assign set_qf_prev
		do
			create Result.make_shared (c_qf_prev (c_pointer))
		end

	qf_lnum: INTEGER_32 assign set_qf_lnum
		do
			Result := c_qf_lnum (c_pointer)
		end

	qf_fnum: INTEGER_32 assign set_qf_fnum
		do
			Result := c_qf_fnum (c_pointer)
		end

	qf_col: INTEGER_32 assign set_qf_col
		do
			Result := c_qf_col (c_pointer)
		end

	qf_nr: INTEGER_32 assign set_qf_nr
		do
			Result := c_qf_nr (c_pointer)
		end

	qf_pattern: CE_POINTER [NATURAL_8] assign set_qf_pattern
		do
			create Result.make_shared (c_qf_pattern (c_pointer))
		end

	qf_text: CE_POINTER [NATURAL_8] assign set_qf_text
		do
			create Result.make_shared (c_qf_text (c_pointer))
		end

	qf_viscol: NATURAL_8 assign set_qf_viscol
		do
			Result := c_qf_viscol (c_pointer)
		end

	qf_cleared: NATURAL_8 assign set_qf_cleared
		do
			Result := c_qf_cleared (c_pointer)
		end

	qf_type: NATURAL_8 assign set_qf_type
		do
			Result := c_qf_type (c_pointer)
		end

	qf_valid: NATURAL_8 assign set_qf_valid
		do
			Result := c_qf_valid (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_qf_next (a_qf_next: CE_POINTER [PD_QFLINE_S])
		do
			c_set_qf_next (c_pointer, a_qf_next.c_pointer)
		end

	set_qf_prev (a_qf_prev: CE_POINTER [PD_QFLINE_S])
		do
			c_set_qf_prev (c_pointer, a_qf_prev.c_pointer)
		end

	set_qf_lnum (a_qf_lnum: INTEGER_32)
		do
			c_set_qf_lnum (c_pointer, a_qf_lnum)
		end

	set_qf_fnum (a_qf_fnum: INTEGER_32)
		do
			c_set_qf_fnum (c_pointer, a_qf_fnum)
		end

	set_qf_col (a_qf_col: INTEGER_32)
		do
			c_set_qf_col (c_pointer, a_qf_col)
		end

	set_qf_nr (a_qf_nr: INTEGER_32)
		do
			c_set_qf_nr (c_pointer, a_qf_nr)
		end

	set_qf_pattern (a_qf_pattern: CE_POINTER [NATURAL_8])
		do
			c_set_qf_pattern (c_pointer, a_qf_pattern.c_pointer)
		end

	set_qf_text (a_qf_text: CE_POINTER [NATURAL_8])
		do
			c_set_qf_text (c_pointer, a_qf_text.c_pointer)
		end

	set_qf_viscol (a_qf_viscol: NATURAL_8)
		do
			c_set_qf_viscol (c_pointer, a_qf_viscol)
		end

	set_qf_cleared (a_qf_cleared: NATURAL_8)
		do
			c_set_qf_cleared (c_pointer, a_qf_cleared)
		end

	set_qf_type (a_qf_type: NATURAL_8)
		do
			c_set_qf_type (c_pointer, a_qf_type)
		end

	set_qf_valid (a_qf_valid: NATURAL_8)
		do
			c_set_qf_valid (c_pointer, a_qf_valid)
		end

feature {NONE} -- C getters

	c_qf_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct qfline_S *)((struct qfline_S *)$tmp)->qf_next;"
		end

	c_qf_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct qfline_S *)((struct qfline_S *)$tmp)->qf_prev;"
		end

	c_qf_lnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct qfline_S *)$tmp)->qf_lnum;"
		end

	c_qf_fnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct qfline_S *)$tmp)->qf_fnum;"
		end

	c_qf_col (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct qfline_S *)$tmp)->qf_col;"
		end

	c_qf_nr (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct qfline_S *)$tmp)->qf_nr;"
		end

	c_qf_pattern (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct qfline_S *)$tmp)->qf_pattern;"
		end

	c_qf_text (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct qfline_S *)$tmp)->qf_text;"
		end

	c_qf_viscol (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct qfline_S *)$tmp)->qf_viscol;"
		end

	c_qf_cleared (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct qfline_S *)$tmp)->qf_cleared;"
		end

	c_qf_type (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct qfline_S *)$tmp)->qf_type;"
		end

	c_qf_valid (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct qfline_S *)$tmp)->qf_valid;"
		end

feature {NONE} -- C setters

	c_set_qf_next (tmp: POINTER; a_qf_next: POINTER)
		external
			"C inline"
		alias
			"((struct qfline_S *)$tmp)->qf_next = (struct qfline_S *)$a_qf_next;"
		end

	c_set_qf_prev (tmp: POINTER; a_qf_prev: POINTER)
		external
			"C inline"
		alias
			"((struct qfline_S *)$tmp)->qf_prev = (struct qfline_S *)$a_qf_prev;"
		end

	c_set_qf_lnum (tmp: POINTER; a_qf_lnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct qfline_S *)$tmp)->qf_lnum = $a_qf_lnum;"
		end

	c_set_qf_fnum (tmp: POINTER; a_qf_fnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct qfline_S *)$tmp)->qf_fnum = $a_qf_fnum;"
		end

	c_set_qf_col (tmp: POINTER; a_qf_col: INTEGER_32)
		external
			"C inline"
		alias
			"((struct qfline_S *)$tmp)->qf_col = $a_qf_col;"
		end

	c_set_qf_nr (tmp: POINTER; a_qf_nr: INTEGER_32)
		external
			"C inline"
		alias
			"((struct qfline_S *)$tmp)->qf_nr = $a_qf_nr;"
		end

	c_set_qf_pattern (tmp: POINTER; a_qf_pattern: POINTER)
		external
			"C inline"
		alias
			"((struct qfline_S *)$tmp)->qf_pattern = (unsigned char *)$a_qf_pattern;"
		end

	c_set_qf_text (tmp: POINTER; a_qf_text: POINTER)
		external
			"C inline"
		alias
			"((struct qfline_S *)$tmp)->qf_text = (unsigned char *)$a_qf_text;"
		end

	c_set_qf_viscol (tmp: POINTER; a_qf_viscol: NATURAL_8)
		external
			"C inline"
		alias
			"((struct qfline_S *)$tmp)->qf_viscol = $a_qf_viscol;"
		end

	c_set_qf_cleared (tmp: POINTER; a_qf_cleared: NATURAL_8)
		external
			"C inline"
		alias
			"((struct qfline_S *)$tmp)->qf_cleared = $a_qf_cleared;"
		end

	c_set_qf_type (tmp: POINTER; a_qf_type: NATURAL_8)
		external
			"C inline"
		alias
			"((struct qfline_S *)$tmp)->qf_type = $a_qf_type;"
		end

	c_set_qf_valid (tmp: POINTER; a_qf_valid: NATURAL_8)
		external
			"C inline"
		alias
			"((struct qfline_S *)$tmp)->qf_valid = $a_qf_valid;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct qfline_S);"
		end

end
