class
	PD_REG_EXTMATCH_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	refcnt: INTEGER_16 assign set_refcnt
		do
			Result := c_refcnt (c_pointer)
		end

	matches: CE_ARRAY [CE_POINTER [NATURAL_8]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_matches (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_refcnt (a_refcnt: INTEGER_16)
		do
			c_set_refcnt (c_pointer, a_refcnt)
		end

feature {NONE} -- C getters

	c_refcnt (tmp: POINTER): INTEGER_16
		external
			"C inline"
		alias
			"return (short)((struct __anonstruct_reg_extmatch_T_68 *)$tmp)->refcnt;"
		end

	c_matches (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_reg_extmatch_T_68 *tmp = (struct __anonstruct_reg_extmatch_T_68 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->matches) / sizeof(tmp->matches[0]);
				return tmp->matches;
			]"
		end

feature {NONE} -- C setters

	c_set_refcnt (tmp: POINTER; a_refcnt: INTEGER_16)
		external
			"C inline"
		alias
			"((struct __anonstruct_reg_extmatch_T_68 *)$tmp)->refcnt = $a_refcnt;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_reg_extmatch_T_68);"
		end

end
