class
	PD_REGMATCH_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	regprog: CE_POINTER [PD_REGPROG_T] assign set_regprog
		do
			create Result.make_shared (c_regprog (c_pointer))
		end

	startp: CE_ARRAY [CE_POINTER [NATURAL_8]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_startp (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	endp: CE_ARRAY [CE_POINTER [NATURAL_8]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_endp (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	rm_ic: INTEGER_32 assign set_rm_ic
		do
			Result := c_rm_ic (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_regprog (a_regprog: CE_POINTER [PD_REGPROG_T])
		do
			c_set_regprog (c_pointer, a_regprog.c_pointer)
		end

	set_rm_ic (a_rm_ic: INTEGER_32)
		do
			c_set_rm_ic (c_pointer, a_rm_ic)
		end

feature {NONE} -- C getters

	c_regprog (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (regprog_T *)((struct __anonstruct_regmatch_T_66 *)$tmp)->regprog;"
		end

	c_startp (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_regmatch_T_66 *tmp = (struct __anonstruct_regmatch_T_66 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->startp) / sizeof(tmp->startp[0]);
				return tmp->startp;
			]"
		end

	c_endp (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_regmatch_T_66 *tmp = (struct __anonstruct_regmatch_T_66 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->endp) / sizeof(tmp->endp[0]);
				return tmp->endp;
			]"
		end

	c_rm_ic (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_regmatch_T_66 *)$tmp)->rm_ic;"
		end

feature {NONE} -- C setters

	c_set_regprog (tmp: POINTER; a_regprog: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_regmatch_T_66 *)$tmp)->regprog = (regprog_T *)$a_regprog;"
		end

	c_set_rm_ic (tmp: POINTER; a_rm_ic: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_regmatch_T_66 *)$tmp)->rm_ic = $a_rm_ic;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_regmatch_T_66);"
		end

end
