class
	PD_REGMMATCH_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	regprog: CE_POINTER [PD_REGPROG_T] assign set_regprog
		do
			create Result.make_shared (c_regprog (c_pointer))
		end

	startpos: CE_ARRAY [PD_LPOS_T]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_startpos (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	endpos: CE_ARRAY [PD_LPOS_T]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_endpos (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	rmm_ic: INTEGER_32 assign set_rmm_ic
		do
			Result := c_rmm_ic (c_pointer)
		end

	rmm_maxcol: INTEGER_32 assign set_rmm_maxcol
		do
			Result := c_rmm_maxcol (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_regprog (a_regprog: CE_POINTER [PD_REGPROG_T])
		do
			c_set_regprog (c_pointer, a_regprog.c_pointer)
		end

	set_rmm_ic (a_rmm_ic: INTEGER_32)
		do
			c_set_rmm_ic (c_pointer, a_rmm_ic)
		end

	set_rmm_maxcol (a_rmm_maxcol: INTEGER_32)
		do
			c_set_rmm_maxcol (c_pointer, a_rmm_maxcol)
		end

feature {NONE} -- C getters

	c_regprog (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (regprog_T *)((struct __anonstruct_regmmatch_T_67 *)$tmp)->regprog;"
		end

	c_startpos (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_regmmatch_T_67 *tmp = (struct __anonstruct_regmmatch_T_67 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->startpos) / sizeof(tmp->startpos[0]);
				return tmp->startpos;
			]"
		end

	c_endpos (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_regmmatch_T_67 *tmp = (struct __anonstruct_regmmatch_T_67 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->endpos) / sizeof(tmp->endpos[0]);
				return tmp->endpos;
			]"
		end

	c_rmm_ic (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_regmmatch_T_67 *)$tmp)->rmm_ic;"
		end

	c_rmm_maxcol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_regmmatch_T_67 *)$tmp)->rmm_maxcol;"
		end

feature {NONE} -- C setters

	c_set_regprog (tmp: POINTER; a_regprog: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_regmmatch_T_67 *)$tmp)->regprog = (regprog_T *)$a_regprog;"
		end

	c_set_rmm_ic (tmp: POINTER; a_rmm_ic: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_regmmatch_T_67 *)$tmp)->rmm_ic = $a_rmm_ic;"
		end

	c_set_rmm_maxcol (tmp: POINTER; a_rmm_maxcol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_regmmatch_T_67 *)$tmp)->rmm_maxcol = $a_rmm_maxcol;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_regmmatch_T_67);"
		end

end
