class
	PD_RS_UN

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sesave: PD_SAVE_SE_T assign set_sesave
		do
			create Result.make_shared (c_sesave (c_pointer))
		end

	sesave_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(union __anonunion_rs_un_547, sesave);"
		end

	regsave: PD_REGSAVE_T assign set_regsave
		do
			create Result.make_shared (c_regsave (c_pointer))
		end

	regsave_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(union __anonunion_rs_un_547, regsave);"
		end

feature {ANY} -- Eiffel setters

	set_sesave (a_sesave: PD_SAVE_SE_T)
		do
			sesave.ce_gets (a_sesave)
		end

	set_regsave (a_regsave: PD_REGSAVE_T)
		do
			regsave.ce_gets (a_regsave)
		end

feature {NONE} -- C getters

	c_sesave (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (save_se_T *)&((union __anonunion_rs_un_547 *)$tmp)->sesave;"
		end

	c_regsave (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (regsave_T *)&((union __anonunion_rs_un_547 *)$tmp)->regsave;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(union __anonunion_rs_un_547);"
		end

end
