class
	PD_SALITEM_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sm_lead: CE_POINTER [NATURAL_8] assign set_sm_lead
		do
			create Result.make_shared (c_sm_lead (c_pointer))
		end

	sm_leadlen: INTEGER_32 assign set_sm_leadlen
		do
			Result := c_sm_leadlen (c_pointer)
		end

	sm_oneof: CE_POINTER [NATURAL_8] assign set_sm_oneof
		do
			create Result.make_shared (c_sm_oneof (c_pointer))
		end

	sm_rules: CE_POINTER [NATURAL_8] assign set_sm_rules
		do
			create Result.make_shared (c_sm_rules (c_pointer))
		end

	sm_to: CE_POINTER [NATURAL_8] assign set_sm_to
		do
			create Result.make_shared (c_sm_to (c_pointer))
		end

	sm_lead_w: CE_POINTER [INTEGER_32] assign set_sm_lead_w
		do
			create Result.make_shared (c_sm_lead_w (c_pointer))
		end

	sm_oneof_w: CE_POINTER [INTEGER_32] assign set_sm_oneof_w
		do
			create Result.make_shared (c_sm_oneof_w (c_pointer))
		end

	sm_to_w: CE_POINTER [INTEGER_32] assign set_sm_to_w
		do
			create Result.make_shared (c_sm_to_w (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_sm_lead (a_sm_lead: CE_POINTER [NATURAL_8])
		do
			c_set_sm_lead (c_pointer, a_sm_lead.c_pointer)
		end

	set_sm_leadlen (a_sm_leadlen: INTEGER_32)
		do
			c_set_sm_leadlen (c_pointer, a_sm_leadlen)
		end

	set_sm_oneof (a_sm_oneof: CE_POINTER [NATURAL_8])
		do
			c_set_sm_oneof (c_pointer, a_sm_oneof.c_pointer)
		end

	set_sm_rules (a_sm_rules: CE_POINTER [NATURAL_8])
		do
			c_set_sm_rules (c_pointer, a_sm_rules.c_pointer)
		end

	set_sm_to (a_sm_to: CE_POINTER [NATURAL_8])
		do
			c_set_sm_to (c_pointer, a_sm_to.c_pointer)
		end

	set_sm_lead_w (a_sm_lead_w: CE_POINTER [INTEGER_32])
		do
			c_set_sm_lead_w (c_pointer, a_sm_lead_w.c_pointer)
		end

	set_sm_oneof_w (a_sm_oneof_w: CE_POINTER [INTEGER_32])
		do
			c_set_sm_oneof_w (c_pointer, a_sm_oneof_w.c_pointer)
		end

	set_sm_to_w (a_sm_to_w: CE_POINTER [INTEGER_32])
		do
			c_set_sm_to_w (c_pointer, a_sm_to_w.c_pointer)
		end

feature {NONE} -- C getters

	c_sm_lead (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct salitem_S *)$tmp)->sm_lead;"
		end

	c_sm_leadlen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct salitem_S *)$tmp)->sm_leadlen;"
		end

	c_sm_oneof (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct salitem_S *)$tmp)->sm_oneof;"
		end

	c_sm_rules (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct salitem_S *)$tmp)->sm_rules;"
		end

	c_sm_to (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct salitem_S *)$tmp)->sm_to;"
		end

	c_sm_lead_w (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int *)((struct salitem_S *)$tmp)->sm_lead_w;"
		end

	c_sm_oneof_w (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int *)((struct salitem_S *)$tmp)->sm_oneof_w;"
		end

	c_sm_to_w (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int *)((struct salitem_S *)$tmp)->sm_to_w;"
		end

feature {NONE} -- C setters

	c_set_sm_lead (tmp: POINTER; a_sm_lead: POINTER)
		external
			"C inline"
		alias
			"((struct salitem_S *)$tmp)->sm_lead = (unsigned char *)$a_sm_lead;"
		end

	c_set_sm_leadlen (tmp: POINTER; a_sm_leadlen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct salitem_S *)$tmp)->sm_leadlen = $a_sm_leadlen;"
		end

	c_set_sm_oneof (tmp: POINTER; a_sm_oneof: POINTER)
		external
			"C inline"
		alias
			"((struct salitem_S *)$tmp)->sm_oneof = (unsigned char *)$a_sm_oneof;"
		end

	c_set_sm_rules (tmp: POINTER; a_sm_rules: POINTER)
		external
			"C inline"
		alias
			"((struct salitem_S *)$tmp)->sm_rules = (unsigned char *)$a_sm_rules;"
		end

	c_set_sm_to (tmp: POINTER; a_sm_to: POINTER)
		external
			"C inline"
		alias
			"((struct salitem_S *)$tmp)->sm_to = (unsigned char *)$a_sm_to;"
		end

	c_set_sm_lead_w (tmp: POINTER; a_sm_lead_w: POINTER)
		external
			"C inline"
		alias
			"((struct salitem_S *)$tmp)->sm_lead_w = (int *)$a_sm_lead_w;"
		end

	c_set_sm_oneof_w (tmp: POINTER; a_sm_oneof_w: POINTER)
		external
			"C inline"
		alias
			"((struct salitem_S *)$tmp)->sm_oneof_w = (int *)$a_sm_oneof_w;"
		end

	c_set_sm_to_w (tmp: POINTER; a_sm_to_w: POINTER)
		external
			"C inline"
		alias
			"((struct salitem_S *)$tmp)->sm_to_w = (int *)$a_sm_to_w;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct salitem_S);"
		end

end
