class
	PD_SCRIPTITEM_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sn_name: CE_POINTER [NATURAL_8] assign set_sn_name
		do
			create Result.make_shared (c_sn_name (c_pointer))
		end

	sn_dev_valid: INTEGER_32 assign set_sn_dev_valid
		do
			Result := c_sn_dev_valid (c_pointer)
		end

	sn_dev: NATURAL_64 assign set_sn_dev
		do
			Result := c_sn_dev (c_pointer)
		end

	sn_ino: NATURAL_32 assign set_sn_ino
		do
			Result := c_sn_ino (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_sn_name (a_sn_name: CE_POINTER [NATURAL_8])
		do
			c_set_sn_name (c_pointer, a_sn_name.c_pointer)
		end

	set_sn_dev_valid (a_sn_dev_valid: INTEGER_32)
		do
			c_set_sn_dev_valid (c_pointer, a_sn_dev_valid)
		end

	set_sn_dev (a_sn_dev: NATURAL_64)
		do
			c_set_sn_dev (c_pointer, a_sn_dev)
		end

	set_sn_ino (a_sn_ino: NATURAL_32)
		do
			c_set_sn_ino (c_pointer, a_sn_ino)
		end

feature {NONE} -- C getters

	c_sn_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct scriptitem_S *)$tmp)->sn_name;"
		end

	c_sn_dev_valid (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct scriptitem_S *)$tmp)->sn_dev_valid;"
		end

	c_sn_dev (tmp: POINTER): NATURAL_64
		external
			"C inline"
		alias
			"return (unsigned long long)((struct scriptitem_S *)$tmp)->sn_dev;"
		end

	c_sn_ino (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct scriptitem_S *)$tmp)->sn_ino;"
		end

feature {NONE} -- C setters

	c_set_sn_name (tmp: POINTER; a_sn_name: POINTER)
		external
			"C inline"
		alias
			"((struct scriptitem_S *)$tmp)->sn_name = (unsigned char *)$a_sn_name;"
		end

	c_set_sn_dev_valid (tmp: POINTER; a_sn_dev_valid: INTEGER_32)
		external
			"C inline"
		alias
			"((struct scriptitem_S *)$tmp)->sn_dev_valid = $a_sn_dev_valid;"
		end

	c_set_sn_dev (tmp: POINTER; a_sn_dev: NATURAL_64)
		external
			"C inline"
		alias
			"((struct scriptitem_S *)$tmp)->sn_dev = $a_sn_dev;"
		end

	c_set_sn_ino (tmp: POINTER; a_sn_ino: NATURAL_32)
		external
			"C inline"
		alias
			"((struct scriptitem_S *)$tmp)->sn_ino = $a_sn_ino;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct scriptitem_S);"
		end

end
