class
	PD_SE_U

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ptr: CE_POINTER [NATURAL_8] assign set_ptr
		do
			create Result.make_shared (c_ptr (c_pointer))
		end

	pos: PD_LPOS_T assign set_pos
		do
			create Result.make_shared (c_pos (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_ptr (a_ptr: CE_POINTER [NATURAL_8])
		do
			c_set_ptr (c_pointer, a_ptr.c_pointer)
		end

	set_pos (a_pos: PD_LPOS_T)
		do
			pos.ce_gets (a_pos)
		end

feature {NONE} -- C getters

	c_ptr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((union __anonunion_se_u_546 *)$tmp)->ptr;"
		end

	c_pos (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (lpos_T *)&((union __anonunion_se_u_546 *)$tmp)->pos;"
		end

feature {NONE} -- C setters

	c_set_ptr (tmp: POINTER; a_ptr: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_se_u_546 *)$tmp)->ptr = (unsigned char *)$a_ptr;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(union __anonunion_se_u_546);"
		end

end
