class
	PD_SERVERREPLY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	id: NATURAL_32 assign set_id
		do
			Result := c_id (c_pointer)
		end

	strings: PD_GROWARRAY assign set_strings
		do
			create Result.make_shared (c_strings (c_pointer))
		end

	strings_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct ServerReply, strings);"
		end

feature {ANY} -- Eiffel setters

	set_id (a_id: NATURAL_32)
		do
			c_set_id (c_pointer, a_id)
		end

	set_strings (a_strings: PD_GROWARRAY)
		do
			strings.ce_gets (a_strings)
		end

feature {NONE} -- C getters

	c_id (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct ServerReply *)$tmp)->id;"
		end

	c_strings (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct growarray *)&((struct ServerReply *)$tmp)->strings;"
		end

feature {NONE} -- C setters

	c_set_id (tmp: POINTER; a_id: NATURAL_32)
		external
			"C inline"
		alias
			"((struct ServerReply *)$tmp)->id = $a_id;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct ServerReply);"
		end

end
