class
	PD_SFTWORD_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sft_score: INTEGER_16 assign set_sft_score
		do
			Result := c_sft_score (c_pointer)
		end

	sft_word: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_sft_word (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_sft_score (a_sft_score: INTEGER_16)
		do
			c_set_sft_score (c_pointer, a_sft_score)
		end

feature {NONE} -- C getters

	c_sft_score (tmp: POINTER): INTEGER_16
		external
			"C inline"
		alias
			"return (short)((struct __anonstruct_sftword_T_546 *)$tmp)->sft_score;"
		end

	c_sft_word (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_sftword_T_546 *tmp = (struct __anonstruct_sftword_T_546 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->sft_word) / sizeof(tmp->sft_word[0]);
				return tmp->sft_word;
			]"
		end

feature {NONE} -- C setters

	c_set_sft_score (tmp: POINTER; a_sft_score: INTEGER_16)
		external
			"C inline"
		alias
			"((struct __anonstruct_sftword_T_546 *)$tmp)->sft_score = $a_sft_score;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_sftword_T_546);"
		end

end
