class
	PD_SHAREDFINDREPLACE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	dialog: CE_POINTER [SD_GTKWIDGET] assign set_dialog
		do
			create Result.make_shared (c_dialog (c_pointer))
		end

	wword: CE_POINTER [SD_GTKWIDGET] assign set_wword
		do
			create Result.make_shared (c_wword (c_pointer))
		end

	mcase: CE_POINTER [SD_GTKWIDGET] assign set_mcase
		do
			create Result.make_shared (c_mcase (c_pointer))
		end

	up: CE_POINTER [SD_GTKWIDGET] assign set_up
		do
			create Result.make_shared (c_up (c_pointer))
		end

	down: CE_POINTER [SD_GTKWIDGET] assign set_down
		do
			create Result.make_shared (c_down (c_pointer))
		end

	what: CE_POINTER [SD_GTKWIDGET] assign set_what
		do
			create Result.make_shared (c_what (c_pointer))
		end

	with: CE_POINTER [SD_GTKWIDGET] assign set_with
		do
			create Result.make_shared (c_with (c_pointer))
		end

	find: CE_POINTER [SD_GTKWIDGET] assign set_find
		do
			create Result.make_shared (c_find (c_pointer))
		end

	replace: CE_POINTER [SD_GTKWIDGET] assign set_replace
		do
			create Result.make_shared (c_replace (c_pointer))
		end

	all2: CE_POINTER [SD_GTKWIDGET] assign set_all2
		do
			create Result.make_shared (c_all2 (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_dialog (a_dialog: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_dialog (c_pointer, a_dialog.c_pointer)
		end

	set_wword (a_wword: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_wword (c_pointer, a_wword.c_pointer)
		end

	set_mcase (a_mcase: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_mcase (c_pointer, a_mcase.c_pointer)
		end

	set_up (a_up: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_up (c_pointer, a_up.c_pointer)
		end

	set_down (a_down: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_down (c_pointer, a_down.c_pointer)
		end

	set_what (a_what: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_what (c_pointer, a_what.c_pointer)
		end

	set_with (a_with: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_with (c_pointer, a_with.c_pointer)
		end

	set_find (a_find: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_find (c_pointer, a_find.c_pointer)
		end

	set_replace (a_replace: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_replace (c_pointer, a_replace.c_pointer)
		end

	set_all2 (a_all2: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_all2 (c_pointer, a_all2.c_pointer)
		end

feature {NONE} -- C getters

	c_dialog (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _SharedFindReplace *)$tmp)->dialog;"
		end

	c_wword (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _SharedFindReplace *)$tmp)->wword;"
		end

	c_mcase (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _SharedFindReplace *)$tmp)->mcase;"
		end

	c_up (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _SharedFindReplace *)$tmp)->up;"
		end

	c_down (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _SharedFindReplace *)$tmp)->down;"
		end

	c_what (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _SharedFindReplace *)$tmp)->what;"
		end

	c_with (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _SharedFindReplace *)$tmp)->with;"
		end

	c_find (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _SharedFindReplace *)$tmp)->find;"
		end

	c_replace (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _SharedFindReplace *)$tmp)->replace;"
		end

	c_all2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _SharedFindReplace *)$tmp)->all;"
		end

feature {NONE} -- C setters

	c_set_dialog (tmp: POINTER; a_dialog: POINTER)
		external
			"C inline"
		alias
			"((struct _SharedFindReplace *)$tmp)->dialog = (struct _GtkWidget *)$a_dialog;"
		end

	c_set_wword (tmp: POINTER; a_wword: POINTER)
		external
			"C inline"
		alias
			"((struct _SharedFindReplace *)$tmp)->wword = (struct _GtkWidget *)$a_wword;"
		end

	c_set_mcase (tmp: POINTER; a_mcase: POINTER)
		external
			"C inline"
		alias
			"((struct _SharedFindReplace *)$tmp)->mcase = (struct _GtkWidget *)$a_mcase;"
		end

	c_set_up (tmp: POINTER; a_up: POINTER)
		external
			"C inline"
		alias
			"((struct _SharedFindReplace *)$tmp)->up = (struct _GtkWidget *)$a_up;"
		end

	c_set_down (tmp: POINTER; a_down: POINTER)
		external
			"C inline"
		alias
			"((struct _SharedFindReplace *)$tmp)->down = (struct _GtkWidget *)$a_down;"
		end

	c_set_what (tmp: POINTER; a_what: POINTER)
		external
			"C inline"
		alias
			"((struct _SharedFindReplace *)$tmp)->what = (struct _GtkWidget *)$a_what;"
		end

	c_set_with (tmp: POINTER; a_with: POINTER)
		external
			"C inline"
		alias
			"((struct _SharedFindReplace *)$tmp)->with = (struct _GtkWidget *)$a_with;"
		end

	c_set_find (tmp: POINTER; a_find: POINTER)
		external
			"C inline"
		alias
			"((struct _SharedFindReplace *)$tmp)->find = (struct _GtkWidget *)$a_find;"
		end

	c_set_replace (tmp: POINTER; a_replace: POINTER)
		external
			"C inline"
		alias
			"((struct _SharedFindReplace *)$tmp)->replace = (struct _GtkWidget *)$a_replace;"
		end

	c_set_all2 (tmp: POINTER; a_all2: POINTER)
		external
			"C inline"
		alias
			"((struct _SharedFindReplace *)$tmp)->all = (struct _GtkWidget *)$a_all2;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _SharedFindReplace);"
		end

end
