class
	PD_SIGNALINFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sig: INTEGER_32 assign set_sig
		do
			Result := c_sig (c_pointer)
		end

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	deadly: INTEGER_8 assign set_deadly
		do
			Result := c_deadly (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_sig (a_sig: INTEGER_32)
		do
			c_set_sig (c_pointer, a_sig)
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_deadly (a_deadly: INTEGER_8)
		do
			c_set_deadly (c_pointer, a_deadly)
		end

feature {NONE} -- C getters

	c_sig (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct signalinfo *)$tmp)->sig;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct signalinfo *)$tmp)->name;"
		end

	c_deadly (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct signalinfo *)$tmp)->deadly;"
		end

feature {NONE} -- C setters

	c_set_sig (tmp: POINTER; a_sig: INTEGER_32)
		external
			"C inline"
		alias
			"((struct signalinfo *)$tmp)->sig = $a_sig;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct signalinfo *)$tmp)->name = (char *)$a_name;"
		end

	c_set_deadly (tmp: POINTER; a_deadly: INTEGER_8)
		external
			"C inline"
		alias
			"((struct signalinfo *)$tmp)->deadly = $a_deadly;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct signalinfo);"
		end

end
