class
	PD_SORTI_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	lnum: INTEGER_32 assign set_lnum
		do
			Result := c_lnum (c_pointer)
		end

	start_col_nr: INTEGER_32 assign set_start_col_nr
		do
			Result := c_start_col_nr (c_pointer)
		end

	start_col_nr_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_sorti_T_543, start_col_nr);"
		end

	end_col_nr: INTEGER_32 assign set_end_col_nr
		do
			Result := c_end_col_nr (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_lnum (a_lnum: INTEGER_32)
		do
			c_set_lnum (c_pointer, a_lnum)
		end

	set_start_col_nr (a_start_col_nr: INTEGER_32)
		do
			c_set_start_col_nr (c_pointer, a_start_col_nr)
		end

	set_end_col_nr (a_end_col_nr: INTEGER_32)
		do
			c_set_end_col_nr (c_pointer, a_end_col_nr)
		end

feature {NONE} -- C getters

	c_lnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_sorti_T_543 *)$tmp)->lnum;"
		end

	c_start_col_nr (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_sorti_T_543 *)$tmp)->start_col_nr;"
		end

	c_end_col_nr (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_sorti_T_543 *)$tmp)->end_col_nr;"
		end

feature {NONE} -- C setters

	c_set_lnum (tmp: POINTER; a_lnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_sorti_T_543 *)$tmp)->lnum = $a_lnum;"
		end

	c_set_start_col_nr (tmp: POINTER; a_start_col_nr: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_sorti_T_543 *)$tmp)->start_col_nr = $a_start_col_nr;"
		end

	c_set_end_col_nr (tmp: POINTER; a_end_col_nr: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_sorti_T_543 *)$tmp)->end_col_nr = $a_end_col_nr;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_sorti_T_543);"
		end

end
