class
	PD_SP_SYN

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	inc_tag: INTEGER_32 assign set_inc_tag
		do
			Result := c_inc_tag (c_pointer)
		end

	id: INTEGER_16 assign set_id
		do
			Result := c_id (c_pointer)
		end

	cont_in_list: CE_POINTER [INTEGER_16] assign set_cont_in_list
		do
			create Result.make_shared (c_cont_in_list (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_inc_tag (a_inc_tag: INTEGER_32)
		do
			c_set_inc_tag (c_pointer, a_inc_tag)
		end

	set_id (a_id: INTEGER_16)
		do
			c_set_id (c_pointer, a_id)
		end

	set_cont_in_list (a_cont_in_list: CE_POINTER [INTEGER_16])
		do
			c_set_cont_in_list (c_pointer, a_cont_in_list.c_pointer)
		end

feature {NONE} -- C getters

	c_inc_tag (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct sp_syn *)$tmp)->inc_tag;"
		end

	c_id (tmp: POINTER): INTEGER_16
		external
			"C inline"
		alias
			"return (short)((struct sp_syn *)$tmp)->id;"
		end

	c_cont_in_list (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (short *)((struct sp_syn *)$tmp)->cont_in_list;"
		end

feature {NONE} -- C setters

	c_set_inc_tag (tmp: POINTER; a_inc_tag: INTEGER_32)
		external
			"C inline"
		alias
			"((struct sp_syn *)$tmp)->inc_tag = $a_inc_tag;"
		end

	c_set_id (tmp: POINTER; a_id: INTEGER_16)
		external
			"C inline"
		alias
			"((struct sp_syn *)$tmp)->id = $a_id;"
		end

	c_set_cont_in_list (tmp: POINTER; a_cont_in_list: POINTER)
		external
			"C inline"
		alias
			"((struct sp_syn *)$tmp)->cont_in_list = (short *)$a_cont_in_list;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct sp_syn);"
		end

end
