class
	PD_SPECIAL_KEY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	key_sym: NATURAL_32 assign set_key_sym
		do
			Result := c_key_sym (c_pointer)
		end

	code0: NATURAL_8 assign set_code0
		do
			Result := c_code0 (c_pointer)
		end

	code1: NATURAL_8 assign set_code1
		do
			Result := c_code1 (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_key_sym (a_key_sym: NATURAL_32)
		do
			c_set_key_sym (c_pointer, a_key_sym)
		end

	set_code0 (a_code0: NATURAL_8)
		do
			c_set_code0 (c_pointer, a_code0)
		end

	set_code1 (a_code1: NATURAL_8)
		do
			c_set_code1 (c_pointer, a_code1)
		end

feature {NONE} -- C getters

	c_key_sym (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct special_key *)$tmp)->key_sym;"
		end

	c_code0 (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct special_key *)$tmp)->code0;"
		end

	c_code1 (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct special_key *)$tmp)->code1;"
		end

feature {NONE} -- C setters

	c_set_key_sym (tmp: POINTER; a_key_sym: NATURAL_32)
		external
			"C inline"
		alias
			"((struct special_key *)$tmp)->key_sym = $a_key_sym;"
		end

	c_set_code0 (tmp: POINTER; a_code0: NATURAL_8)
		external
			"C inline"
		alias
			"((struct special_key *)$tmp)->code0 = $a_code0;"
		end

	c_set_code1 (tmp: POINTER; a_code1: NATURAL_8)
		external
			"C inline"
		alias
			"((struct special_key *)$tmp)->code1 = $a_code1;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct special_key);"
		end

end
