class
	PD_SPELLTAB_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	st_isw: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_st_isw (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	st_isu: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_st_isu (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	st_fold: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_st_fold (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	st_upper: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_st_upper (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {NONE} -- C getters

	c_st_isw (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct spelltab_S *tmp = (struct spelltab_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->st_isw) / sizeof(tmp->st_isw[0]);
				return tmp->st_isw;
			]"
		end

	c_st_isu (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct spelltab_S *tmp = (struct spelltab_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->st_isu) / sizeof(tmp->st_isu[0]);
				return tmp->st_isu;
			]"
		end

	c_st_fold (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct spelltab_S *tmp = (struct spelltab_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->st_fold) / sizeof(tmp->st_fold[0]);
				return tmp->st_fold;
			]"
		end

	c_st_upper (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct spelltab_S *tmp = (struct spelltab_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->st_upper) / sizeof(tmp->st_upper[0]);
				return tmp->st_upper;
			]"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct spelltab_S);"
		end

end
