class
	PD_STL_HLREC

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	start: CE_POINTER [NATURAL_8] assign set_start
		do
			create Result.make_shared (c_start (c_pointer))
		end

	userhl: INTEGER_32 assign set_userhl
		do
			Result := c_userhl (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_start (a_start: CE_POINTER [NATURAL_8])
		do
			c_set_start (c_pointer, a_start.c_pointer)
		end

	set_userhl (a_userhl: INTEGER_32)
		do
			c_set_userhl (c_pointer, a_userhl)
		end

feature {NONE} -- C getters

	c_start (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct stl_hlrec *)$tmp)->start;"
		end

	c_userhl (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct stl_hlrec *)$tmp)->userhl;"
		end

feature {NONE} -- C setters

	c_set_start (tmp: POINTER; a_start: POINTER)
		external
			"C inline"
		alias
			"((struct stl_hlrec *)$tmp)->start = (unsigned char *)$a_start;"
		end

	c_set_userhl (tmp: POINTER; a_userhl: INTEGER_32)
		external
			"C inline"
		alias
			"((struct stl_hlrec *)$tmp)->userhl = $a_userhl;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct stl_hlrec);"
		end

end
