class
	PD_STRUCT_BF_TEST_DATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	password: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_password (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	salt: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_salt (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	plaintxt: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_plaintxt (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	cryptxt: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_cryptxt (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	badcryptxt: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_badcryptxt (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	keysum: NATURAL_32 assign set_keysum
		do
			Result := c_keysum (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_keysum (a_keysum: NATURAL_32)
		do
			c_set_keysum (c_pointer, a_keysum)
		end

feature {NONE} -- C getters

	c_password (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_struct_bf_test_data_544 *tmp = (struct __anonstruct_struct_bf_test_data_544 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->password) / sizeof(tmp->password[0]);
				return tmp->password;
			]"
		end

	c_salt (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_struct_bf_test_data_544 *tmp = (struct __anonstruct_struct_bf_test_data_544 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->salt) / sizeof(tmp->salt[0]);
				return tmp->salt;
			]"
		end

	c_plaintxt (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_struct_bf_test_data_544 *tmp = (struct __anonstruct_struct_bf_test_data_544 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->plaintxt) / sizeof(tmp->plaintxt[0]);
				return tmp->plaintxt;
			]"
		end

	c_cryptxt (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_struct_bf_test_data_544 *tmp = (struct __anonstruct_struct_bf_test_data_544 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->cryptxt) / sizeof(tmp->cryptxt[0]);
				return tmp->cryptxt;
			]"
		end

	c_badcryptxt (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_struct_bf_test_data_544 *tmp = (struct __anonstruct_struct_bf_test_data_544 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->badcryptxt) / sizeof(tmp->badcryptxt[0]);
				return tmp->badcryptxt;
			]"
		end

	c_keysum (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_struct_bf_test_data_544 *)$tmp)->keysum;"
		end

feature {NONE} -- C setters

	c_set_keysum (tmp: POINTER; a_keysum: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_struct_bf_test_data_544 *)$tmp)->keysum = $a_keysum;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_struct_bf_test_data_544);"
		end

end
