class
	PD_SUGGEST_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	st_word: CE_POINTER [NATURAL_8] assign set_st_word
		do
			create Result.make_shared (c_st_word (c_pointer))
		end

	st_wordlen: INTEGER_32 assign set_st_wordlen
		do
			Result := c_st_wordlen (c_pointer)
		end

	st_orglen: INTEGER_32 assign set_st_orglen
		do
			Result := c_st_orglen (c_pointer)
		end

	st_score: INTEGER_32 assign set_st_score
		do
			Result := c_st_score (c_pointer)
		end

	st_altscore: INTEGER_32 assign set_st_altscore
		do
			Result := c_st_altscore (c_pointer)
		end

	st_salscore: INTEGER_32 assign set_st_salscore
		do
			Result := c_st_salscore (c_pointer)
		end

	st_had_bonus: INTEGER_32 assign set_st_had_bonus
		do
			Result := c_st_had_bonus (c_pointer)
		end

	st_slang: CE_POINTER [PD_SLANG_S] assign set_st_slang
		do
			create Result.make_shared (c_st_slang (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_st_word (a_st_word: CE_POINTER [NATURAL_8])
		do
			c_set_st_word (c_pointer, a_st_word.c_pointer)
		end

	set_st_wordlen (a_st_wordlen: INTEGER_32)
		do
			c_set_st_wordlen (c_pointer, a_st_wordlen)
		end

	set_st_orglen (a_st_orglen: INTEGER_32)
		do
			c_set_st_orglen (c_pointer, a_st_orglen)
		end

	set_st_score (a_st_score: INTEGER_32)
		do
			c_set_st_score (c_pointer, a_st_score)
		end

	set_st_altscore (a_st_altscore: INTEGER_32)
		do
			c_set_st_altscore (c_pointer, a_st_altscore)
		end

	set_st_salscore (a_st_salscore: INTEGER_32)
		do
			c_set_st_salscore (c_pointer, a_st_salscore)
		end

	set_st_had_bonus (a_st_had_bonus: INTEGER_32)
		do
			c_set_st_had_bonus (c_pointer, a_st_had_bonus)
		end

	set_st_slang (a_st_slang: CE_POINTER [PD_SLANG_S])
		do
			c_set_st_slang (c_pointer, a_st_slang.c_pointer)
		end

feature {NONE} -- C getters

	c_st_word (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct suggest_S *)$tmp)->st_word;"
		end

	c_st_wordlen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct suggest_S *)$tmp)->st_wordlen;"
		end

	c_st_orglen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct suggest_S *)$tmp)->st_orglen;"
		end

	c_st_score (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct suggest_S *)$tmp)->st_score;"
		end

	c_st_altscore (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct suggest_S *)$tmp)->st_altscore;"
		end

	c_st_salscore (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct suggest_S *)$tmp)->st_salscore;"
		end

	c_st_had_bonus (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct suggest_S *)$tmp)->st_had_bonus;"
		end

	c_st_slang (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct slang_S *)((struct suggest_S *)$tmp)->st_slang;"
		end

feature {NONE} -- C setters

	c_set_st_word (tmp: POINTER; a_st_word: POINTER)
		external
			"C inline"
		alias
			"((struct suggest_S *)$tmp)->st_word = (unsigned char *)$a_st_word;"
		end

	c_set_st_wordlen (tmp: POINTER; a_st_wordlen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct suggest_S *)$tmp)->st_wordlen = $a_st_wordlen;"
		end

	c_set_st_orglen (tmp: POINTER; a_st_orglen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct suggest_S *)$tmp)->st_orglen = $a_st_orglen;"
		end

	c_set_st_score (tmp: POINTER; a_st_score: INTEGER_32)
		external
			"C inline"
		alias
			"((struct suggest_S *)$tmp)->st_score = $a_st_score;"
		end

	c_set_st_altscore (tmp: POINTER; a_st_altscore: INTEGER_32)
		external
			"C inline"
		alias
			"((struct suggest_S *)$tmp)->st_altscore = $a_st_altscore;"
		end

	c_set_st_salscore (tmp: POINTER; a_st_salscore: INTEGER_32)
		external
			"C inline"
		alias
			"((struct suggest_S *)$tmp)->st_salscore = $a_st_salscore;"
		end

	c_set_st_had_bonus (tmp: POINTER; a_st_had_bonus: INTEGER_32)
		external
			"C inline"
		alias
			"((struct suggest_S *)$tmp)->st_had_bonus = $a_st_had_bonus;"
		end

	c_set_st_slang (tmp: POINTER; a_st_slang: POINTER)
		external
			"C inline"
		alias
			"((struct suggest_S *)$tmp)->st_slang = (struct slang_S *)$a_st_slang;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct suggest_S);"
		end

end
