class
	PD_SYN_OPT_ARG_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	flags: INTEGER_32 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

	flags_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_syn_opt_arg_T_543, flags);"
		end

	keyword: INTEGER_32 assign set_keyword
		do
			Result := c_keyword (c_pointer)
		end

	sync_idx: CE_POINTER [INTEGER_32] assign set_sync_idx
		do
			create Result.make_shared (c_sync_idx (c_pointer))
		end

	has_cont_list: INTEGER_8 assign set_has_cont_list
		do
			Result := c_has_cont_list (c_pointer)
		end

	cont_list: CE_POINTER [INTEGER_16] assign set_cont_list
		do
			create Result.make_shared (c_cont_list (c_pointer))
		end

	cont_list_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_syn_opt_arg_T_543, cont_list);"
		end

	cont_in_list: CE_POINTER [INTEGER_16] assign set_cont_in_list
		do
			create Result.make_shared (c_cont_in_list (c_pointer))
		end

	cont_in_list_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_syn_opt_arg_T_543, cont_in_list);"
		end

	next_list: CE_POINTER [INTEGER_16] assign set_next_list
		do
			create Result.make_shared (c_next_list (c_pointer))
		end

	next_list_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_syn_opt_arg_T_543, next_list);"
		end

feature {ANY} -- Eiffel setters

	set_flags (a_flags: INTEGER_32)
		do
			c_set_flags (c_pointer, a_flags)
		end

	set_keyword (a_keyword: INTEGER_32)
		do
			c_set_keyword (c_pointer, a_keyword)
		end

	set_sync_idx (a_sync_idx: CE_POINTER [INTEGER_32])
		do
			c_set_sync_idx (c_pointer, a_sync_idx.c_pointer)
		end

	set_has_cont_list (a_has_cont_list: INTEGER_8)
		do
			c_set_has_cont_list (c_pointer, a_has_cont_list)
		end

	set_cont_list (a_cont_list: CE_POINTER [INTEGER_16])
		do
			c_set_cont_list (c_pointer, a_cont_list.c_pointer)
		end

	set_cont_in_list (a_cont_in_list: CE_POINTER [INTEGER_16])
		do
			c_set_cont_in_list (c_pointer, a_cont_in_list.c_pointer)
		end

	set_next_list (a_next_list: CE_POINTER [INTEGER_16])
		do
			c_set_next_list (c_pointer, a_next_list.c_pointer)
		end

feature {NONE} -- C getters

	c_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_syn_opt_arg_T_543 *)$tmp)->flags;"
		end

	c_keyword (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_syn_opt_arg_T_543 *)$tmp)->keyword;"
		end

	c_sync_idx (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int *)((struct __anonstruct_syn_opt_arg_T_543 *)$tmp)->sync_idx;"
		end

	c_has_cont_list (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct __anonstruct_syn_opt_arg_T_543 *)$tmp)->has_cont_list;"
		end

	c_cont_list (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (short *)((struct __anonstruct_syn_opt_arg_T_543 *)$tmp)->cont_list;"
		end

	c_cont_in_list (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (short *)((struct __anonstruct_syn_opt_arg_T_543 *)$tmp)->cont_in_list;"
		end

	c_next_list (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (short *)((struct __anonstruct_syn_opt_arg_T_543 *)$tmp)->next_list;"
		end

feature {NONE} -- C setters

	c_set_flags (tmp: POINTER; a_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_syn_opt_arg_T_543 *)$tmp)->flags = $a_flags;"
		end

	c_set_keyword (tmp: POINTER; a_keyword: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_syn_opt_arg_T_543 *)$tmp)->keyword = $a_keyword;"
		end

	c_set_sync_idx (tmp: POINTER; a_sync_idx: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_syn_opt_arg_T_543 *)$tmp)->sync_idx = (int *)$a_sync_idx;"
		end

	c_set_has_cont_list (tmp: POINTER; a_has_cont_list: INTEGER_8)
		external
			"C inline"
		alias
			"((struct __anonstruct_syn_opt_arg_T_543 *)$tmp)->has_cont_list = $a_has_cont_list;"
		end

	c_set_cont_list (tmp: POINTER; a_cont_list: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_syn_opt_arg_T_543 *)$tmp)->cont_list = (short *)$a_cont_list;"
		end

	c_set_cont_in_list (tmp: POINTER; a_cont_in_list: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_syn_opt_arg_T_543 *)$tmp)->cont_in_list = (short *)$a_cont_in_list;"
		end

	c_set_next_list (tmp: POINTER; a_next_list: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_syn_opt_arg_T_543 *)$tmp)->next_list = (short *)$a_next_list;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_syn_opt_arg_T_543);"
		end

end
