class
	PD_SYNBLOCK_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	b_keywtab: PD_HASHTABLE_S assign set_b_keywtab
		do
			create Result.make_shared (c_b_keywtab (c_pointer))
		end

	b_keywtab_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_synblock_T_534, b_keywtab);"
		end

	b_keywtab_ic: PD_HASHTABLE_S assign set_b_keywtab_ic
		do
			create Result.make_shared (c_b_keywtab_ic (c_pointer))
		end

	b_keywtab_ic_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_synblock_T_534, b_keywtab_ic);"
		end

	b_syn_error: INTEGER_32 assign set_b_syn_error
		do
			Result := c_b_syn_error (c_pointer)
		end

	b_syn_ic: INTEGER_32 assign set_b_syn_ic
		do
			Result := c_b_syn_ic (c_pointer)
		end

	b_syn_spell: INTEGER_32 assign set_b_syn_spell
		do
			Result := c_b_syn_spell (c_pointer)
		end

	b_syn_patterns: PD_GROWARRAY assign set_b_syn_patterns
		do
			create Result.make_shared (c_b_syn_patterns (c_pointer))
		end

	b_syn_patterns_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_synblock_T_534, b_syn_patterns);"
		end

	b_syn_clusters: PD_GROWARRAY assign set_b_syn_clusters
		do
			create Result.make_shared (c_b_syn_clusters (c_pointer))
		end

	b_syn_clusters_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_synblock_T_534, b_syn_clusters);"
		end

	b_spell_cluster_id: INTEGER_32 assign set_b_spell_cluster_id
		do
			Result := c_b_spell_cluster_id (c_pointer)
		end

	b_nospell_cluster_id: INTEGER_32 assign set_b_nospell_cluster_id
		do
			Result := c_b_nospell_cluster_id (c_pointer)
		end

	b_syn_containedin: INTEGER_32 assign set_b_syn_containedin
		do
			Result := c_b_syn_containedin (c_pointer)
		end

	b_syn_sync_flags: INTEGER_32 assign set_b_syn_sync_flags
		do
			Result := c_b_syn_sync_flags (c_pointer)
		end

	b_syn_sync_id: INTEGER_16 assign set_b_syn_sync_id
		do
			Result := c_b_syn_sync_id (c_pointer)
		end

	b_syn_sync_minlines: INTEGER_32 assign set_b_syn_sync_minlines
		do
			Result := c_b_syn_sync_minlines (c_pointer)
		end

	b_syn_sync_maxlines: INTEGER_32 assign set_b_syn_sync_maxlines
		do
			Result := c_b_syn_sync_maxlines (c_pointer)
		end

	b_syn_sync_linebreaks: INTEGER_32 assign set_b_syn_sync_linebreaks
		do
			Result := c_b_syn_sync_linebreaks (c_pointer)
		end

	b_syn_linecont_pat: CE_POINTER [NATURAL_8] assign set_b_syn_linecont_pat
		do
			create Result.make_shared (c_b_syn_linecont_pat (c_pointer))
		end

	b_syn_linecont_prog: CE_POINTER [PD_REGPROG_T] assign set_b_syn_linecont_prog
		do
			create Result.make_shared (c_b_syn_linecont_prog (c_pointer))
		end

	b_syn_linecont_ic: INTEGER_32 assign set_b_syn_linecont_ic
		do
			Result := c_b_syn_linecont_ic (c_pointer)
		end

	b_syn_topgrp: INTEGER_32 assign set_b_syn_topgrp
		do
			Result := c_b_syn_topgrp (c_pointer)
		end

	b_syn_folditems: INTEGER_32 assign set_b_syn_folditems
		do
			Result := c_b_syn_folditems (c_pointer)
		end

	b_sst_array: CE_POINTER [PD_SYN_STATE] assign set_b_sst_array
		do
			create Result.make_shared (c_b_sst_array (c_pointer))
		end

	b_sst_len: INTEGER_32 assign set_b_sst_len
		do
			Result := c_b_sst_len (c_pointer)
		end

	b_sst_first: CE_POINTER [PD_SYN_STATE] assign set_b_sst_first
		do
			create Result.make_shared (c_b_sst_first (c_pointer))
		end

	b_sst_firstfree: CE_POINTER [PD_SYN_STATE] assign set_b_sst_firstfree
		do
			create Result.make_shared (c_b_sst_firstfree (c_pointer))
		end

	b_sst_freecount: INTEGER_32 assign set_b_sst_freecount
		do
			Result := c_b_sst_freecount (c_pointer)
		end

	b_sst_check_lnum: INTEGER_32 assign set_b_sst_check_lnum
		do
			Result := c_b_sst_check_lnum (c_pointer)
		end

	b_sst_lasttick: NATURAL_16 assign set_b_sst_lasttick
		do
			Result := c_b_sst_lasttick (c_pointer)
		end

	b_langp: PD_GROWARRAY assign set_b_langp
		do
			create Result.make_shared (c_b_langp (c_pointer))
		end

	b_langp_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_synblock_T_534, b_langp);"
		end

	b_spell_ismw: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_b_spell_ismw (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	b_spell_ismw_mb: CE_POINTER [NATURAL_8] assign set_b_spell_ismw_mb
		do
			create Result.make_shared (c_b_spell_ismw_mb (c_pointer))
		end

	b_p_spc: CE_POINTER [NATURAL_8] assign set_b_p_spc
		do
			create Result.make_shared (c_b_p_spc (c_pointer))
		end

	b_p_spc_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_synblock_T_534, b_p_spc);"
		end

	b_cap_prog: CE_POINTER [PD_REGPROG_T] assign set_b_cap_prog
		do
			create Result.make_shared (c_b_cap_prog (c_pointer))
		end

	b_p_spf: CE_POINTER [NATURAL_8] assign set_b_p_spf
		do
			create Result.make_shared (c_b_p_spf (c_pointer))
		end

	b_p_spf_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_synblock_T_534, b_p_spf);"
		end

	b_p_spl: CE_POINTER [NATURAL_8] assign set_b_p_spl
		do
			create Result.make_shared (c_b_p_spl (c_pointer))
		end

	b_p_spl_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_synblock_T_534, b_p_spl);"
		end

feature {ANY} -- Eiffel setters

	set_b_keywtab (a_b_keywtab: PD_HASHTABLE_S)
		do
			b_keywtab.ce_gets (a_b_keywtab)
		end

	set_b_keywtab_ic (a_b_keywtab_ic: PD_HASHTABLE_S)
		do
			b_keywtab_ic.ce_gets (a_b_keywtab_ic)
		end

	set_b_syn_error (a_b_syn_error: INTEGER_32)
		do
			c_set_b_syn_error (c_pointer, a_b_syn_error)
		end

	set_b_syn_ic (a_b_syn_ic: INTEGER_32)
		do
			c_set_b_syn_ic (c_pointer, a_b_syn_ic)
		end

	set_b_syn_spell (a_b_syn_spell: INTEGER_32)
		do
			c_set_b_syn_spell (c_pointer, a_b_syn_spell)
		end

	set_b_syn_patterns (a_b_syn_patterns: PD_GROWARRAY)
		do
			b_syn_patterns.ce_gets (a_b_syn_patterns)
		end

	set_b_syn_clusters (a_b_syn_clusters: PD_GROWARRAY)
		do
			b_syn_clusters.ce_gets (a_b_syn_clusters)
		end

	set_b_spell_cluster_id (a_b_spell_cluster_id: INTEGER_32)
		do
			c_set_b_spell_cluster_id (c_pointer, a_b_spell_cluster_id)
		end

	set_b_nospell_cluster_id (a_b_nospell_cluster_id: INTEGER_32)
		do
			c_set_b_nospell_cluster_id (c_pointer, a_b_nospell_cluster_id)
		end

	set_b_syn_containedin (a_b_syn_containedin: INTEGER_32)
		do
			c_set_b_syn_containedin (c_pointer, a_b_syn_containedin)
		end

	set_b_syn_sync_flags (a_b_syn_sync_flags: INTEGER_32)
		do
			c_set_b_syn_sync_flags (c_pointer, a_b_syn_sync_flags)
		end

	set_b_syn_sync_id (a_b_syn_sync_id: INTEGER_16)
		do
			c_set_b_syn_sync_id (c_pointer, a_b_syn_sync_id)
		end

	set_b_syn_sync_minlines (a_b_syn_sync_minlines: INTEGER_32)
		do
			c_set_b_syn_sync_minlines (c_pointer, a_b_syn_sync_minlines)
		end

	set_b_syn_sync_maxlines (a_b_syn_sync_maxlines: INTEGER_32)
		do
			c_set_b_syn_sync_maxlines (c_pointer, a_b_syn_sync_maxlines)
		end

	set_b_syn_sync_linebreaks (a_b_syn_sync_linebreaks: INTEGER_32)
		do
			c_set_b_syn_sync_linebreaks (c_pointer, a_b_syn_sync_linebreaks)
		end

	set_b_syn_linecont_pat (a_b_syn_linecont_pat: CE_POINTER [NATURAL_8])
		do
			c_set_b_syn_linecont_pat (c_pointer, a_b_syn_linecont_pat.c_pointer)
		end

	set_b_syn_linecont_prog (a_b_syn_linecont_prog: CE_POINTER [PD_REGPROG_T])
		do
			c_set_b_syn_linecont_prog (c_pointer, a_b_syn_linecont_prog.c_pointer)
		end

	set_b_syn_linecont_ic (a_b_syn_linecont_ic: INTEGER_32)
		do
			c_set_b_syn_linecont_ic (c_pointer, a_b_syn_linecont_ic)
		end

	set_b_syn_topgrp (a_b_syn_topgrp: INTEGER_32)
		do
			c_set_b_syn_topgrp (c_pointer, a_b_syn_topgrp)
		end

	set_b_syn_folditems (a_b_syn_folditems: INTEGER_32)
		do
			c_set_b_syn_folditems (c_pointer, a_b_syn_folditems)
		end

	set_b_sst_array (a_b_sst_array: CE_POINTER [PD_SYN_STATE])
		do
			c_set_b_sst_array (c_pointer, a_b_sst_array.c_pointer)
		end

	set_b_sst_len (a_b_sst_len: INTEGER_32)
		do
			c_set_b_sst_len (c_pointer, a_b_sst_len)
		end

	set_b_sst_first (a_b_sst_first: CE_POINTER [PD_SYN_STATE])
		do
			c_set_b_sst_first (c_pointer, a_b_sst_first.c_pointer)
		end

	set_b_sst_firstfree (a_b_sst_firstfree: CE_POINTER [PD_SYN_STATE])
		do
			c_set_b_sst_firstfree (c_pointer, a_b_sst_firstfree.c_pointer)
		end

	set_b_sst_freecount (a_b_sst_freecount: INTEGER_32)
		do
			c_set_b_sst_freecount (c_pointer, a_b_sst_freecount)
		end

	set_b_sst_check_lnum (a_b_sst_check_lnum: INTEGER_32)
		do
			c_set_b_sst_check_lnum (c_pointer, a_b_sst_check_lnum)
		end

	set_b_sst_lasttick (a_b_sst_lasttick: NATURAL_16)
		do
			c_set_b_sst_lasttick (c_pointer, a_b_sst_lasttick)
		end

	set_b_langp (a_b_langp: PD_GROWARRAY)
		do
			b_langp.ce_gets (a_b_langp)
		end

	set_b_spell_ismw_mb (a_b_spell_ismw_mb: CE_POINTER [NATURAL_8])
		do
			c_set_b_spell_ismw_mb (c_pointer, a_b_spell_ismw_mb.c_pointer)
		end

	set_b_p_spc (a_b_p_spc: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_spc (c_pointer, a_b_p_spc.c_pointer)
		end

	set_b_cap_prog (a_b_cap_prog: CE_POINTER [PD_REGPROG_T])
		do
			c_set_b_cap_prog (c_pointer, a_b_cap_prog.c_pointer)
		end

	set_b_p_spf (a_b_p_spf: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_spf (c_pointer, a_b_p_spf.c_pointer)
		end

	set_b_p_spl (a_b_p_spl: CE_POINTER [NATURAL_8])
		do
			c_set_b_p_spl (c_pointer, a_b_p_spl.c_pointer)
		end

feature {NONE} -- C getters

	c_b_keywtab (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct hashtable_S *)&((struct __anonstruct_synblock_T_534 *)$tmp)->b_keywtab;"
		end

	c_b_keywtab_ic (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct hashtable_S *)&((struct __anonstruct_synblock_T_534 *)$tmp)->b_keywtab_ic;"
		end

	c_b_syn_error (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_error;"
		end

	c_b_syn_ic (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_ic;"
		end

	c_b_syn_spell (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_spell;"
		end

	c_b_syn_patterns (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct growarray *)&((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_patterns;"
		end

	c_b_syn_clusters (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct growarray *)&((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_clusters;"
		end

	c_b_spell_cluster_id (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_synblock_T_534 *)$tmp)->b_spell_cluster_id;"
		end

	c_b_nospell_cluster_id (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_synblock_T_534 *)$tmp)->b_nospell_cluster_id;"
		end

	c_b_syn_containedin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_containedin;"
		end

	c_b_syn_sync_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_sync_flags;"
		end

	c_b_syn_sync_id (tmp: POINTER): INTEGER_16
		external
			"C inline"
		alias
			"return (short)((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_sync_id;"
		end

	c_b_syn_sync_minlines (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_sync_minlines;"
		end

	c_b_syn_sync_maxlines (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_sync_maxlines;"
		end

	c_b_syn_sync_linebreaks (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_sync_linebreaks;"
		end

	c_b_syn_linecont_pat (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_linecont_pat;"
		end

	c_b_syn_linecont_prog (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (regprog_T *)((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_linecont_prog;"
		end

	c_b_syn_linecont_ic (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_linecont_ic;"
		end

	c_b_syn_topgrp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_topgrp;"
		end

	c_b_syn_folditems (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_folditems;"
		end

	c_b_sst_array (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct syn_state *)((struct __anonstruct_synblock_T_534 *)$tmp)->b_sst_array;"
		end

	c_b_sst_len (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_synblock_T_534 *)$tmp)->b_sst_len;"
		end

	c_b_sst_first (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct syn_state *)((struct __anonstruct_synblock_T_534 *)$tmp)->b_sst_first;"
		end

	c_b_sst_firstfree (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct syn_state *)((struct __anonstruct_synblock_T_534 *)$tmp)->b_sst_firstfree;"
		end

	c_b_sst_freecount (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_synblock_T_534 *)$tmp)->b_sst_freecount;"
		end

	c_b_sst_check_lnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_synblock_T_534 *)$tmp)->b_sst_check_lnum;"
		end

	c_b_sst_lasttick (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct __anonstruct_synblock_T_534 *)$tmp)->b_sst_lasttick;"
		end

	c_b_langp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct growarray *)&((struct __anonstruct_synblock_T_534 *)$tmp)->b_langp;"
		end

	c_b_spell_ismw (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_synblock_T_534 *tmp = (struct __anonstruct_synblock_T_534 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->b_spell_ismw) / sizeof(tmp->b_spell_ismw[0]);
				return tmp->b_spell_ismw;
			]"
		end

	c_b_spell_ismw_mb (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_synblock_T_534 *)$tmp)->b_spell_ismw_mb;"
		end

	c_b_p_spc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_synblock_T_534 *)$tmp)->b_p_spc;"
		end

	c_b_cap_prog (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (regprog_T *)((struct __anonstruct_synblock_T_534 *)$tmp)->b_cap_prog;"
		end

	c_b_p_spf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_synblock_T_534 *)$tmp)->b_p_spf;"
		end

	c_b_p_spl (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_synblock_T_534 *)$tmp)->b_p_spl;"
		end

feature {NONE} -- C setters

	c_set_b_syn_error (tmp: POINTER; a_b_syn_error: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_error = $a_b_syn_error;"
		end

	c_set_b_syn_ic (tmp: POINTER; a_b_syn_ic: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_ic = $a_b_syn_ic;"
		end

	c_set_b_syn_spell (tmp: POINTER; a_b_syn_spell: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_spell = $a_b_syn_spell;"
		end

	c_set_b_spell_cluster_id (tmp: POINTER; a_b_spell_cluster_id: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_spell_cluster_id = $a_b_spell_cluster_id;"
		end

	c_set_b_nospell_cluster_id (tmp: POINTER; a_b_nospell_cluster_id: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_nospell_cluster_id = $a_b_nospell_cluster_id;"
		end

	c_set_b_syn_containedin (tmp: POINTER; a_b_syn_containedin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_containedin = $a_b_syn_containedin;"
		end

	c_set_b_syn_sync_flags (tmp: POINTER; a_b_syn_sync_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_sync_flags = $a_b_syn_sync_flags;"
		end

	c_set_b_syn_sync_id (tmp: POINTER; a_b_syn_sync_id: INTEGER_16)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_sync_id = $a_b_syn_sync_id;"
		end

	c_set_b_syn_sync_minlines (tmp: POINTER; a_b_syn_sync_minlines: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_sync_minlines = $a_b_syn_sync_minlines;"
		end

	c_set_b_syn_sync_maxlines (tmp: POINTER; a_b_syn_sync_maxlines: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_sync_maxlines = $a_b_syn_sync_maxlines;"
		end

	c_set_b_syn_sync_linebreaks (tmp: POINTER; a_b_syn_sync_linebreaks: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_sync_linebreaks = $a_b_syn_sync_linebreaks;"
		end

	c_set_b_syn_linecont_pat (tmp: POINTER; a_b_syn_linecont_pat: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_linecont_pat = (unsigned char *)$a_b_syn_linecont_pat;"
		end

	c_set_b_syn_linecont_prog (tmp: POINTER; a_b_syn_linecont_prog: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_linecont_prog = (regprog_T *)$a_b_syn_linecont_prog;"
		end

	c_set_b_syn_linecont_ic (tmp: POINTER; a_b_syn_linecont_ic: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_linecont_ic = $a_b_syn_linecont_ic;"
		end

	c_set_b_syn_topgrp (tmp: POINTER; a_b_syn_topgrp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_topgrp = $a_b_syn_topgrp;"
		end

	c_set_b_syn_folditems (tmp: POINTER; a_b_syn_folditems: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_syn_folditems = $a_b_syn_folditems;"
		end

	c_set_b_sst_array (tmp: POINTER; a_b_sst_array: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_sst_array = (struct syn_state *)$a_b_sst_array;"
		end

	c_set_b_sst_len (tmp: POINTER; a_b_sst_len: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_sst_len = $a_b_sst_len;"
		end

	c_set_b_sst_first (tmp: POINTER; a_b_sst_first: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_sst_first = (struct syn_state *)$a_b_sst_first;"
		end

	c_set_b_sst_firstfree (tmp: POINTER; a_b_sst_firstfree: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_sst_firstfree = (struct syn_state *)$a_b_sst_firstfree;"
		end

	c_set_b_sst_freecount (tmp: POINTER; a_b_sst_freecount: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_sst_freecount = $a_b_sst_freecount;"
		end

	c_set_b_sst_check_lnum (tmp: POINTER; a_b_sst_check_lnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_sst_check_lnum = $a_b_sst_check_lnum;"
		end

	c_set_b_sst_lasttick (tmp: POINTER; a_b_sst_lasttick: NATURAL_16)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_sst_lasttick = $a_b_sst_lasttick;"
		end

	c_set_b_spell_ismw_mb (tmp: POINTER; a_b_spell_ismw_mb: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_spell_ismw_mb = (unsigned char *)$a_b_spell_ismw_mb;"
		end

	c_set_b_p_spc (tmp: POINTER; a_b_p_spc: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_p_spc = (unsigned char *)$a_b_p_spc;"
		end

	c_set_b_cap_prog (tmp: POINTER; a_b_cap_prog: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_cap_prog = (regprog_T *)$a_b_cap_prog;"
		end

	c_set_b_p_spf (tmp: POINTER; a_b_p_spf: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_p_spf = (unsigned char *)$a_b_p_spf;"
		end

	c_set_b_p_spl (tmp: POINTER; a_b_p_spl: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_synblock_T_534 *)$tmp)->b_p_spl = (unsigned char *)$a_b_p_spl;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_synblock_T_534);"
		end

end
