class
	PD_TAG_POINTERS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	tagname: CE_POINTER [NATURAL_8] assign set_tagname
		do
			create Result.make_shared (c_tagname (c_pointer))
		end

	tagname_end: CE_POINTER [NATURAL_8] assign set_tagname_end
		do
			create Result.make_shared (c_tagname_end (c_pointer))
		end

	fname: CE_POINTER [NATURAL_8] assign set_fname
		do
			create Result.make_shared (c_fname (c_pointer))
		end

	fname_end: CE_POINTER [NATURAL_8] assign set_fname_end
		do
			create Result.make_shared (c_fname_end (c_pointer))
		end

	command: CE_POINTER [NATURAL_8] assign set_command
		do
			create Result.make_shared (c_command (c_pointer))
		end

	command_end: CE_POINTER [NATURAL_8] assign set_command_end
		do
			create Result.make_shared (c_command_end (c_pointer))
		end

	tag_fname: CE_POINTER [NATURAL_8] assign set_tag_fname
		do
			create Result.make_shared (c_tag_fname (c_pointer))
		end

	tagkind: CE_POINTER [NATURAL_8] assign set_tagkind
		do
			create Result.make_shared (c_tagkind (c_pointer))
		end

	tagkind_end: CE_POINTER [NATURAL_8] assign set_tagkind_end
		do
			create Result.make_shared (c_tagkind_end (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_tagname (a_tagname: CE_POINTER [NATURAL_8])
		do
			c_set_tagname (c_pointer, a_tagname.c_pointer)
		end

	set_tagname_end (a_tagname_end: CE_POINTER [NATURAL_8])
		do
			c_set_tagname_end (c_pointer, a_tagname_end.c_pointer)
		end

	set_fname (a_fname: CE_POINTER [NATURAL_8])
		do
			c_set_fname (c_pointer, a_fname.c_pointer)
		end

	set_fname_end (a_fname_end: CE_POINTER [NATURAL_8])
		do
			c_set_fname_end (c_pointer, a_fname_end.c_pointer)
		end

	set_command (a_command: CE_POINTER [NATURAL_8])
		do
			c_set_command (c_pointer, a_command.c_pointer)
		end

	set_command_end (a_command_end: CE_POINTER [NATURAL_8])
		do
			c_set_command_end (c_pointer, a_command_end.c_pointer)
		end

	set_tag_fname (a_tag_fname: CE_POINTER [NATURAL_8])
		do
			c_set_tag_fname (c_pointer, a_tag_fname.c_pointer)
		end

	set_tagkind (a_tagkind: CE_POINTER [NATURAL_8])
		do
			c_set_tagkind (c_pointer, a_tagkind.c_pointer)
		end

	set_tagkind_end (a_tagkind_end: CE_POINTER [NATURAL_8])
		do
			c_set_tagkind_end (c_pointer, a_tagkind_end.c_pointer)
		end

feature {NONE} -- C getters

	c_tagname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct tag_pointers *)$tmp)->tagname;"
		end

	c_tagname_end (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct tag_pointers *)$tmp)->tagname_end;"
		end

	c_fname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct tag_pointers *)$tmp)->fname;"
		end

	c_fname_end (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct tag_pointers *)$tmp)->fname_end;"
		end

	c_command (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct tag_pointers *)$tmp)->command;"
		end

	c_command_end (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct tag_pointers *)$tmp)->command_end;"
		end

	c_tag_fname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct tag_pointers *)$tmp)->tag_fname;"
		end

	c_tagkind (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct tag_pointers *)$tmp)->tagkind;"
		end

	c_tagkind_end (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct tag_pointers *)$tmp)->tagkind_end;"
		end

feature {NONE} -- C setters

	c_set_tagname (tmp: POINTER; a_tagname: POINTER)
		external
			"C inline"
		alias
			"((struct tag_pointers *)$tmp)->tagname = (unsigned char *)$a_tagname;"
		end

	c_set_tagname_end (tmp: POINTER; a_tagname_end: POINTER)
		external
			"C inline"
		alias
			"((struct tag_pointers *)$tmp)->tagname_end = (unsigned char *)$a_tagname_end;"
		end

	c_set_fname (tmp: POINTER; a_fname: POINTER)
		external
			"C inline"
		alias
			"((struct tag_pointers *)$tmp)->fname = (unsigned char *)$a_fname;"
		end

	c_set_fname_end (tmp: POINTER; a_fname_end: POINTER)
		external
			"C inline"
		alias
			"((struct tag_pointers *)$tmp)->fname_end = (unsigned char *)$a_fname_end;"
		end

	c_set_command (tmp: POINTER; a_command: POINTER)
		external
			"C inline"
		alias
			"((struct tag_pointers *)$tmp)->command = (unsigned char *)$a_command;"
		end

	c_set_command_end (tmp: POINTER; a_command_end: POINTER)
		external
			"C inline"
		alias
			"((struct tag_pointers *)$tmp)->command_end = (unsigned char *)$a_command_end;"
		end

	c_set_tag_fname (tmp: POINTER; a_tag_fname: POINTER)
		external
			"C inline"
		alias
			"((struct tag_pointers *)$tmp)->tag_fname = (unsigned char *)$a_tag_fname;"
		end

	c_set_tagkind (tmp: POINTER; a_tagkind: POINTER)
		external
			"C inline"
		alias
			"((struct tag_pointers *)$tmp)->tagkind = (unsigned char *)$a_tagkind;"
		end

	c_set_tagkind_end (tmp: POINTER; a_tagkind_end: POINTER)
		external
			"C inline"
		alias
			"((struct tag_pointers *)$tmp)->tagkind_end = (unsigned char *)$a_tagkind_end;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct tag_pointers);"
		end

end
