class
	PD_TAG_SEARCH_INFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	low_offset: INTEGER_32 assign set_low_offset
		do
			Result := c_low_offset (c_pointer)
		end

	high_offset: INTEGER_32 assign set_high_offset
		do
			Result := c_high_offset (c_pointer)
		end

	curr_offset: INTEGER_32 assign set_curr_offset
		do
			Result := c_curr_offset (c_pointer)
		end

	curr_offset_used: INTEGER_32 assign set_curr_offset_used
		do
			Result := c_curr_offset_used (c_pointer)
		end

	match_offset: INTEGER_32 assign set_match_offset
		do
			Result := c_match_offset (c_pointer)
		end

	low_char: INTEGER_32 assign set_low_char
		do
			Result := c_low_char (c_pointer)
		end

	high_char: INTEGER_32 assign set_high_char
		do
			Result := c_high_char (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_low_offset (a_low_offset: INTEGER_32)
		do
			c_set_low_offset (c_pointer, a_low_offset)
		end

	set_high_offset (a_high_offset: INTEGER_32)
		do
			c_set_high_offset (c_pointer, a_high_offset)
		end

	set_curr_offset (a_curr_offset: INTEGER_32)
		do
			c_set_curr_offset (c_pointer, a_curr_offset)
		end

	set_curr_offset_used (a_curr_offset_used: INTEGER_32)
		do
			c_set_curr_offset_used (c_pointer, a_curr_offset_used)
		end

	set_match_offset (a_match_offset: INTEGER_32)
		do
			c_set_match_offset (c_pointer, a_match_offset)
		end

	set_low_char (a_low_char: INTEGER_32)
		do
			c_set_low_char (c_pointer, a_low_char)
		end

	set_high_char (a_high_char: INTEGER_32)
		do
			c_set_high_char (c_pointer, a_high_char)
		end

feature {NONE} -- C getters

	c_low_offset (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct tag_search_info *)$tmp)->low_offset;"
		end

	c_high_offset (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct tag_search_info *)$tmp)->high_offset;"
		end

	c_curr_offset (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct tag_search_info *)$tmp)->curr_offset;"
		end

	c_curr_offset_used (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct tag_search_info *)$tmp)->curr_offset_used;"
		end

	c_match_offset (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct tag_search_info *)$tmp)->match_offset;"
		end

	c_low_char (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct tag_search_info *)$tmp)->low_char;"
		end

	c_high_char (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct tag_search_info *)$tmp)->high_char;"
		end

feature {NONE} -- C setters

	c_set_low_offset (tmp: POINTER; a_low_offset: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tag_search_info *)$tmp)->low_offset = $a_low_offset;"
		end

	c_set_high_offset (tmp: POINTER; a_high_offset: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tag_search_info *)$tmp)->high_offset = $a_high_offset;"
		end

	c_set_curr_offset (tmp: POINTER; a_curr_offset: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tag_search_info *)$tmp)->curr_offset = $a_curr_offset;"
		end

	c_set_curr_offset_used (tmp: POINTER; a_curr_offset_used: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tag_search_info *)$tmp)->curr_offset_used = $a_curr_offset_used;"
		end

	c_set_match_offset (tmp: POINTER; a_match_offset: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tag_search_info *)$tmp)->match_offset = $a_match_offset;"
		end

	c_set_low_char (tmp: POINTER; a_low_char: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tag_search_info *)$tmp)->low_char = $a_low_char;"
		end

	c_set_high_char (tmp: POINTER; a_high_char: INTEGER_32)
		external
			"C inline"
		alias
			"((struct tag_search_info *)$tmp)->high_char = $a_high_char;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct tag_search_info);"
		end

end
