class
	PD_TASAVE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	save_typebuf: PD_TYPEBUF_T assign set_save_typebuf
		do
			create Result.make_shared (c_save_typebuf (c_pointer))
		end

	typebuf_valid: INTEGER_32 assign set_typebuf_valid
		do
			Result := c_typebuf_valid (c_pointer)
		end

	old_char: INTEGER_32 assign set_old_char
		do
			Result := c_old_char (c_pointer)
		end

	old_mod_mask: INTEGER_32 assign set_old_mod_mask
		do
			Result := c_old_mod_mask (c_pointer)
		end

	save_stuffbuff: PD_BUFFHEADER assign set_save_stuffbuff
		do
			create Result.make_shared (c_save_stuffbuff (c_pointer))
		end

	save_inputbuf: CE_POINTER [NATURAL_8] assign set_save_inputbuf
		do
			create Result.make_shared (c_save_inputbuf (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_save_typebuf (a_save_typebuf: PD_TYPEBUF_T)
		do
			save_typebuf.ce_gets (a_save_typebuf)
		end

	set_typebuf_valid (a_typebuf_valid: INTEGER_32)
		do
			c_set_typebuf_valid (c_pointer, a_typebuf_valid)
		end

	set_old_char (a_old_char: INTEGER_32)
		do
			c_set_old_char (c_pointer, a_old_char)
		end

	set_old_mod_mask (a_old_mod_mask: INTEGER_32)
		do
			c_set_old_mod_mask (c_pointer, a_old_mod_mask)
		end

	set_save_stuffbuff (a_save_stuffbuff: PD_BUFFHEADER)
		do
			save_stuffbuff.ce_gets (a_save_stuffbuff)
		end

	set_save_inputbuf (a_save_inputbuf: CE_POINTER [NATURAL_8])
		do
			c_set_save_inputbuf (c_pointer, a_save_inputbuf.c_pointer)
		end

feature {NONE} -- C getters

	c_save_typebuf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (typebuf_T *)&((struct __anonstruct_tasave_T_529 *)$tmp)->save_typebuf;"
		end

	c_typebuf_valid (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_tasave_T_529 *)$tmp)->typebuf_valid;"
		end

	c_old_char (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_tasave_T_529 *)$tmp)->old_char;"
		end

	c_old_mod_mask (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_tasave_T_529 *)$tmp)->old_mod_mask;"
		end

	c_save_stuffbuff (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct buffheader *)&((struct __anonstruct_tasave_T_529 *)$tmp)->save_stuffbuff;"
		end

	c_save_inputbuf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_tasave_T_529 *)$tmp)->save_inputbuf;"
		end

feature {NONE} -- C setters

	c_set_typebuf_valid (tmp: POINTER; a_typebuf_valid: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_tasave_T_529 *)$tmp)->typebuf_valid = $a_typebuf_valid;"
		end

	c_set_old_char (tmp: POINTER; a_old_char: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_tasave_T_529 *)$tmp)->old_char = $a_old_char;"
		end

	c_set_old_mod_mask (tmp: POINTER; a_old_mod_mask: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_tasave_T_529 *)$tmp)->old_mod_mask = $a_old_mod_mask;"
		end

	c_set_save_inputbuf (tmp: POINTER; a_save_inputbuf: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_tasave_T_529 *)$tmp)->save_inputbuf = (unsigned char *)$a_save_inputbuf;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_tasave_T_529);"
		end

end
