class
	PD_TYPVAL_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	v_type: INTEGER_8 assign set_v_type
		do
			Result := c_v_type (c_pointer)
		end

	v_lock: INTEGER_8 assign set_v_lock
		do
			Result := c_v_lock (c_pointer)
		end

	vval: PD_VVAL assign set_vval
		do
			create Result.make_shared (c_vval (c_pointer))
		end

	vval_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_typval_T_532, vval);"
		end

feature {ANY} -- Eiffel setters

	set_v_type (a_v_type: INTEGER_8)
		do
			c_set_v_type (c_pointer, a_v_type)
		end

	set_v_lock (a_v_lock: INTEGER_8)
		do
			c_set_v_lock (c_pointer, a_v_lock)
		end

	set_vval (a_vval: PD_VVAL)
		do
			vval.ce_gets (a_vval)
		end

feature {NONE} -- C getters

	c_v_type (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct __anonstruct_typval_T_532 *)$tmp)->v_type;"
		end

	c_v_lock (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct __anonstruct_typval_T_532 *)$tmp)->v_lock;"
		end

	c_vval (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_vval_533 *)&((struct __anonstruct_typval_T_532 *)$tmp)->vval;"
		end

feature {NONE} -- C setters

	c_set_v_type (tmp: POINTER; a_v_type: INTEGER_8)
		external
			"C inline"
		alias
			"((struct __anonstruct_typval_T_532 *)$tmp)->v_type = $a_v_type;"
		end

	c_set_v_lock (tmp: POINTER; a_v_lock: INTEGER_8)
		external
			"C inline"
		alias
			"((struct __anonstruct_typval_T_532 *)$tmp)->v_lock = $a_v_lock;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_typval_T_532);"
		end

end
