class
	PD_UCMD

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	uc_name: CE_POINTER [NATURAL_8] assign set_uc_name
		do
			create Result.make_shared (c_uc_name (c_pointer))
		end

	uc_argt: NATURAL_32 assign set_uc_argt
		do
			Result := c_uc_argt (c_pointer)
		end

	uc_rep: CE_POINTER [NATURAL_8] assign set_uc_rep
		do
			create Result.make_shared (c_uc_rep (c_pointer))
		end

	uc_def: INTEGER_32 assign set_uc_def
		do
			Result := c_uc_def (c_pointer)
		end

	uc_compl: INTEGER_32 assign set_uc_compl
		do
			Result := c_uc_compl (c_pointer)
		end

	uc_scriptID: INTEGER_32 assign set_uc_scriptID
		do
			Result := c_uc_scriptID (c_pointer)
		end

	uc_compl_arg: CE_POINTER [NATURAL_8] assign set_uc_compl_arg
		do
			create Result.make_shared (c_uc_compl_arg (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_uc_name (a_uc_name: CE_POINTER [NATURAL_8])
		do
			c_set_uc_name (c_pointer, a_uc_name.c_pointer)
		end

	set_uc_argt (a_uc_argt: NATURAL_32)
		do
			c_set_uc_argt (c_pointer, a_uc_argt)
		end

	set_uc_rep (a_uc_rep: CE_POINTER [NATURAL_8])
		do
			c_set_uc_rep (c_pointer, a_uc_rep.c_pointer)
		end

	set_uc_def (a_uc_def: INTEGER_32)
		do
			c_set_uc_def (c_pointer, a_uc_def)
		end

	set_uc_compl (a_uc_compl: INTEGER_32)
		do
			c_set_uc_compl (c_pointer, a_uc_compl)
		end

	set_uc_scriptID (a_uc_scriptID: INTEGER_32)
		do
			c_set_uc_scriptID (c_pointer, a_uc_scriptID)
		end

	set_uc_compl_arg (a_uc_compl_arg: CE_POINTER [NATURAL_8])
		do
			c_set_uc_compl_arg (c_pointer, a_uc_compl_arg.c_pointer)
		end

feature {NONE} -- C getters

	c_uc_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct ucmd *)$tmp)->uc_name;"
		end

	c_uc_argt (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct ucmd *)$tmp)->uc_argt;"
		end

	c_uc_rep (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct ucmd *)$tmp)->uc_rep;"
		end

	c_uc_def (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct ucmd *)$tmp)->uc_def;"
		end

	c_uc_compl (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ucmd *)$tmp)->uc_compl;"
		end

	c_uc_scriptID (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ucmd *)$tmp)->uc_scriptID;"
		end

	c_uc_compl_arg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct ucmd *)$tmp)->uc_compl_arg;"
		end

feature {NONE} -- C setters

	c_set_uc_name (tmp: POINTER; a_uc_name: POINTER)
		external
			"C inline"
		alias
			"((struct ucmd *)$tmp)->uc_name = (unsigned char *)$a_uc_name;"
		end

	c_set_uc_argt (tmp: POINTER; a_uc_argt: NATURAL_32)
		external
			"C inline"
		alias
			"((struct ucmd *)$tmp)->uc_argt = $a_uc_argt;"
		end

	c_set_uc_rep (tmp: POINTER; a_uc_rep: POINTER)
		external
			"C inline"
		alias
			"((struct ucmd *)$tmp)->uc_rep = (unsigned char *)$a_uc_rep;"
		end

	c_set_uc_def (tmp: POINTER; a_uc_def: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ucmd *)$tmp)->uc_def = $a_uc_def;"
		end

	c_set_uc_compl (tmp: POINTER; a_uc_compl: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ucmd *)$tmp)->uc_compl = $a_uc_compl;"
		end

	c_set_uc_scriptID (tmp: POINTER; a_uc_scriptID: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ucmd *)$tmp)->uc_scriptID = $a_uc_scriptid;"
		end

	c_set_uc_compl_arg (tmp: POINTER; a_uc_compl_arg: POINTER)
		external
			"C inline"
		alias
			"((struct ucmd *)$tmp)->uc_compl_arg = (unsigned char *)$a_uc_compl_arg;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct ucmd);"
		end

end
