class
	PD_UH_ALT_NEXT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ptr: CE_POINTER [PD_U_HEADER] assign set_ptr
		do
			create Result.make_shared (c_ptr (c_pointer))
		end

	seq: INTEGER_32 assign set_seq
		do
			Result := c_seq (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_ptr (a_ptr: CE_POINTER [PD_U_HEADER])
		do
			c_set_ptr (c_pointer, a_ptr.c_pointer)
		end

	set_seq (a_seq: INTEGER_32)
		do
			c_set_seq (c_pointer, a_seq)
		end

feature {NONE} -- C getters

	c_ptr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct u_header *)((union __anonunion_uh_alt_next_519 *)$tmp)->ptr;"
		end

	c_seq (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((union __anonunion_uh_alt_next_519 *)$tmp)->seq;"
		end

feature {NONE} -- C setters

	c_set_ptr (tmp: POINTER; a_ptr: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_uh_alt_next_519 *)$tmp)->ptr = (struct u_header *)$a_ptr;"
		end

	c_set_seq (tmp: POINTER; a_seq: INTEGER_32)
		external
			"C inline"
		alias
			"((union __anonunion_uh_alt_next_519 *)$tmp)->seq = $a_seq;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(union __anonunion_uh_alt_next_519);"
		end

end
