class
	PD_VIMCONV_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	vc_type: INTEGER_32 assign set_vc_type
		do
			Result := c_vc_type (c_pointer)
		end

	vc_factor: INTEGER_32 assign set_vc_factor
		do
			Result := c_vc_factor (c_pointer)
		end

	vc_fd: CE_POINTER [ANY] assign set_vc_fd
		do
			create Result.make_shared (c_vc_fd (c_pointer))
		end

	vc_fail: INTEGER_32 assign set_vc_fail
		do
			Result := c_vc_fail (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_vc_type (a_vc_type: INTEGER_32)
		do
			c_set_vc_type (c_pointer, a_vc_type)
		end

	set_vc_factor (a_vc_factor: INTEGER_32)
		do
			c_set_vc_factor (c_pointer, a_vc_factor)
		end

	set_vc_fd (a_vc_fd: CE_POINTER [ANY])
		do
			c_set_vc_fd (c_pointer, a_vc_fd.c_pointer)
		end

	set_vc_fail (a_vc_fail: INTEGER_32)
		do
			c_set_vc_fail (c_pointer, a_vc_fail)
		end

feature {NONE} -- C getters

	c_vc_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_vimconv_T_530 *)$tmp)->vc_type;"
		end

	c_vc_factor (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_vimconv_T_530 *)$tmp)->vc_factor;"
		end

	c_vc_fd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_vimconv_T_530 *)$tmp)->vc_fd;"
		end

	c_vc_fail (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_vimconv_T_530 *)$tmp)->vc_fail;"
		end

feature {NONE} -- C setters

	c_set_vc_type (tmp: POINTER; a_vc_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_vimconv_T_530 *)$tmp)->vc_type = $a_vc_type;"
		end

	c_set_vc_factor (tmp: POINTER; a_vc_factor: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_vimconv_T_530 *)$tmp)->vc_factor = $a_vc_factor;"
		end

	c_set_vc_fd (tmp: POINTER; a_vc_fd: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_vimconv_T_530 *)$tmp)->vc_fd = (void *)$a_vc_fd;"
		end

	c_set_vc_fail (tmp: POINTER; a_vc_fail: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_vimconv_T_530 *)$tmp)->vc_fail = $a_vc_fail;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_vimconv_T_530);"
		end

end
