class
	PD_VIR_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	vir_line: CE_POINTER [NATURAL_8] assign set_vir_line
		do
			create Result.make_shared (c_vir_line (c_pointer))
		end

	vir_fd: CE_POINTER [SD_IO_FILE] assign set_vir_fd
		do
			create Result.make_shared (c_vir_fd (c_pointer))
		end

	vir_conv: PD_VIMCONV_T assign set_vir_conv
		do
			create Result.make_shared (c_vir_conv (c_pointer))
		end

	vir_conv_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_vir_T_531, vir_conv);"
		end

feature {ANY} -- Eiffel setters

	set_vir_line (a_vir_line: CE_POINTER [NATURAL_8])
		do
			c_set_vir_line (c_pointer, a_vir_line.c_pointer)
		end

	set_vir_fd (a_vir_fd: CE_POINTER [SD_IO_FILE])
		do
			c_set_vir_fd (c_pointer, a_vir_fd.c_pointer)
		end

	set_vir_conv (a_vir_conv: PD_VIMCONV_T)
		do
			vir_conv.ce_gets (a_vir_conv)
		end

feature {NONE} -- C getters

	c_vir_line (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_vir_T_531 *)$tmp)->vir_line;"
		end

	c_vir_fd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _IO_FILE *)((struct __anonstruct_vir_T_531 *)$tmp)->vir_fd;"
		end

	c_vir_conv (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (vimconv_T *)&((struct __anonstruct_vir_T_531 *)$tmp)->vir_conv;"
		end

feature {NONE} -- C setters

	c_set_vir_line (tmp: POINTER; a_vir_line: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_vir_T_531 *)$tmp)->vir_line = (unsigned char *)$a_vir_line;"
		end

	c_set_vir_fd (tmp: POINTER; a_vir_fd: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_vir_T_531 *)$tmp)->vir_fd = (struct _IO_FILE *)$a_vir_fd;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_vir_T_531);"
		end

end
