class
	PD_W_LINE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	wl_lnum: INTEGER_32 assign set_wl_lnum
		do
			Result := c_wl_lnum (c_pointer)
		end

	wl_size: NATURAL_16 assign set_wl_size
		do
			Result := c_wl_size (c_pointer)
		end

	wl_valid: INTEGER_8 assign set_wl_valid
		do
			Result := c_wl_valid (c_pointer)
		end

	wl_folded: INTEGER_8 assign set_wl_folded
		do
			Result := c_wl_folded (c_pointer)
		end

	wl_lastlnum: INTEGER_32 assign set_wl_lastlnum
		do
			Result := c_wl_lastlnum (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_wl_lnum (a_wl_lnum: INTEGER_32)
		do
			c_set_wl_lnum (c_pointer, a_wl_lnum)
		end

	set_wl_size (a_wl_size: NATURAL_16)
		do
			c_set_wl_size (c_pointer, a_wl_size)
		end

	set_wl_valid (a_wl_valid: INTEGER_8)
		do
			c_set_wl_valid (c_pointer, a_wl_valid)
		end

	set_wl_folded (a_wl_folded: INTEGER_8)
		do
			c_set_wl_folded (c_pointer, a_wl_folded)
		end

	set_wl_lastlnum (a_wl_lastlnum: INTEGER_32)
		do
			c_set_wl_lastlnum (c_pointer, a_wl_lastlnum)
		end

feature {NONE} -- C getters

	c_wl_lnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct w_line *)$tmp)->wl_lnum;"
		end

	c_wl_size (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct w_line *)$tmp)->wl_size;"
		end

	c_wl_valid (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct w_line *)$tmp)->wl_valid;"
		end

	c_wl_folded (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct w_line *)$tmp)->wl_folded;"
		end

	c_wl_lastlnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct w_line *)$tmp)->wl_lastlnum;"
		end

feature {NONE} -- C setters

	c_set_wl_lnum (tmp: POINTER; a_wl_lnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct w_line *)$tmp)->wl_lnum = $a_wl_lnum;"
		end

	c_set_wl_size (tmp: POINTER; a_wl_size: NATURAL_16)
		external
			"C inline"
		alias
			"((struct w_line *)$tmp)->wl_size = $a_wl_size;"
		end

	c_set_wl_valid (tmp: POINTER; a_wl_valid: INTEGER_8)
		external
			"C inline"
		alias
			"((struct w_line *)$tmp)->wl_valid = $a_wl_valid;"
		end

	c_set_wl_folded (tmp: POINTER; a_wl_folded: INTEGER_8)
		external
			"C inline"
		alias
			"((struct w_line *)$tmp)->wl_folded = $a_wl_folded;"
		end

	c_set_wl_lastlnum (tmp: POINTER; a_wl_lastlnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct w_line *)$tmp)->wl_lastlnum = $a_wl_lastlnum;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct w_line);"
		end

end
