class
	PD_WCMD_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	line: CE_POINTER [NATURAL_8] assign set_line
		do
			create Result.make_shared (c_line (c_pointer))
		end

	lnum: INTEGER_32 assign set_lnum
		do
			Result := c_lnum (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_line (a_line: CE_POINTER [NATURAL_8])
		do
			c_set_line (c_pointer, a_line.c_pointer)
		end

	set_lnum (a_lnum: INTEGER_32)
		do
			c_set_lnum (c_pointer, a_lnum)
		end

feature {NONE} -- C getters

	c_line (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_wcmd_T_543 *)$tmp)->line;"
		end

	c_lnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_wcmd_T_543 *)$tmp)->lnum;"
		end

feature {NONE} -- C setters

	c_set_line (tmp: POINTER; a_line: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_wcmd_T_543 *)$tmp)->line = (unsigned char *)$a_line;"
		end

	c_set_lnum (tmp: POINTER; a_lnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_wcmd_T_543 *)$tmp)->lnum = $a_lnum;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_wcmd_T_543);"
		end

end
