class
	PD_WORDNODE_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	wn_u1: PD_WN_U1 assign set_wn_u1
		do
			create Result.make_shared (c_wn_u1 (c_pointer))
		end

	wn_u2: PD_WN_U2 assign set_wn_u2
		do
			create Result.make_shared (c_wn_u2 (c_pointer))
		end

	wn_child: CE_POINTER [PD_WORDNODE_S] assign set_wn_child
		do
			create Result.make_shared (c_wn_child (c_pointer))
		end

	wn_child_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct wordnode_S, wn_child);"
		end

	wn_sibling: CE_POINTER [PD_WORDNODE_S] assign set_wn_sibling
		do
			create Result.make_shared (c_wn_sibling (c_pointer))
		end

	wn_sibling_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct wordnode_S, wn_sibling);"
		end

	wn_refs: INTEGER_32 assign set_wn_refs
		do
			Result := c_wn_refs (c_pointer)
		end

	wn_byte: NATURAL_8 assign set_wn_byte
		do
			Result := c_wn_byte (c_pointer)
		end

	wn_affixID: NATURAL_8 assign set_wn_affixID
		do
			Result := c_wn_affixID (c_pointer)
		end

	wn_flags: NATURAL_16 assign set_wn_flags
		do
			Result := c_wn_flags (c_pointer)
		end

	wn_region: INTEGER_16 assign set_wn_region
		do
			Result := c_wn_region (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_wn_u1 (a_wn_u1: PD_WN_U1)
		do
			wn_u1.ce_gets (a_wn_u1)
		end

	set_wn_u2 (a_wn_u2: PD_WN_U2)
		do
			wn_u2.ce_gets (a_wn_u2)
		end

	set_wn_child (a_wn_child: CE_POINTER [PD_WORDNODE_S])
		do
			c_set_wn_child (c_pointer, a_wn_child.c_pointer)
		end

	set_wn_sibling (a_wn_sibling: CE_POINTER [PD_WORDNODE_S])
		do
			c_set_wn_sibling (c_pointer, a_wn_sibling.c_pointer)
		end

	set_wn_refs (a_wn_refs: INTEGER_32)
		do
			c_set_wn_refs (c_pointer, a_wn_refs)
		end

	set_wn_byte (a_wn_byte: NATURAL_8)
		do
			c_set_wn_byte (c_pointer, a_wn_byte)
		end

	set_wn_affixID (a_wn_affixID: NATURAL_8)
		do
			c_set_wn_affixID (c_pointer, a_wn_affixID)
		end

	set_wn_flags (a_wn_flags: NATURAL_16)
		do
			c_set_wn_flags (c_pointer, a_wn_flags)
		end

	set_wn_region (a_wn_region: INTEGER_16)
		do
			c_set_wn_region (c_pointer, a_wn_region)
		end

feature {NONE} -- C getters

	c_wn_u1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_wn_u1_544 *)&((struct wordnode_S *)$tmp)->wn_u1;"
		end

	c_wn_u2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_wn_u2_545 *)&((struct wordnode_S *)$tmp)->wn_u2;"
		end

	c_wn_child (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct wordnode_S *)((struct wordnode_S *)$tmp)->wn_child;"
		end

	c_wn_sibling (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct wordnode_S *)((struct wordnode_S *)$tmp)->wn_sibling;"
		end

	c_wn_refs (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct wordnode_S *)$tmp)->wn_refs;"
		end

	c_wn_byte (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct wordnode_S *)$tmp)->wn_byte;"
		end

	c_wn_affixID (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct wordnode_S *)$tmp)->wn_affixID;"
		end

	c_wn_flags (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct wordnode_S *)$tmp)->wn_flags;"
		end

	c_wn_region (tmp: POINTER): INTEGER_16
		external
			"C inline"
		alias
			"return (short)((struct wordnode_S *)$tmp)->wn_region;"
		end

feature {NONE} -- C setters

	c_set_wn_child (tmp: POINTER; a_wn_child: POINTER)
		external
			"C inline"
		alias
			"((struct wordnode_S *)$tmp)->wn_child = (struct wordnode_S *)$a_wn_child;"
		end

	c_set_wn_sibling (tmp: POINTER; a_wn_sibling: POINTER)
		external
			"C inline"
		alias
			"((struct wordnode_S *)$tmp)->wn_sibling = (struct wordnode_S *)$a_wn_sibling;"
		end

	c_set_wn_refs (tmp: POINTER; a_wn_refs: INTEGER_32)
		external
			"C inline"
		alias
			"((struct wordnode_S *)$tmp)->wn_refs = $a_wn_refs;"
		end

	c_set_wn_byte (tmp: POINTER; a_wn_byte: NATURAL_8)
		external
			"C inline"
		alias
			"((struct wordnode_S *)$tmp)->wn_byte = $a_wn_byte;"
		end

	c_set_wn_affixID (tmp: POINTER; a_wn_affixID: NATURAL_8)
		external
			"C inline"
		alias
			"((struct wordnode_S *)$tmp)->wn_affixID = $a_wn_affixid;"
		end

	c_set_wn_flags (tmp: POINTER; a_wn_flags: NATURAL_16)
		external
			"C inline"
		alias
			"((struct wordnode_S *)$tmp)->wn_flags = $a_wn_flags;"
		end

	c_set_wn_region (tmp: POINTER; a_wn_region: INTEGER_16)
		external
			"C inline"
		alias
			"((struct wordnode_S *)$tmp)->wn_region = $a_wn_region;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct wordnode_S);"
		end

end
