class
	PD_XSMP_CONFIG_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	smcconn: CE_POINTER [ANY] assign set_smcconn
		do
			create Result.make_shared (c_smcconn (c_pointer))
		end

	iceconn: CE_POINTER [ANY] assign set_iceconn
		do
			create Result.make_shared (c_iceconn (c_pointer))
		end

	clientid: CE_POINTER [INTEGER_8] assign set_clientid
		do
			create Result.make_shared (c_clientid (c_pointer))
		end

	clientid_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_xsmp_config_T_578, clientid);"
		end

	save_yourself: INTEGER_32 assign set_save_yourself
		do
			Result := c_save_yourself (c_pointer)
		end

	shutdown: INTEGER_32 assign set_shutdown
		do
			Result := c_shutdown (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_smcconn (a_smcconn: CE_POINTER [ANY])
		do
			c_set_smcconn (c_pointer, a_smcconn.c_pointer)
		end

	set_iceconn (a_iceconn: CE_POINTER [ANY])
		do
			c_set_iceconn (c_pointer, a_iceconn.c_pointer)
		end

	set_clientid (a_clientid: CE_POINTER [INTEGER_8])
		do
			c_set_clientid (c_pointer, a_clientid.c_pointer)
		end

	set_save_yourself (a_save_yourself: INTEGER_32)
		do
			c_set_save_yourself (c_pointer, a_save_yourself)
		end

	set_shutdown (a_shutdown: INTEGER_32)
		do
			c_set_shutdown (c_pointer, a_shutdown)
		end

feature {NONE} -- C getters

	c_smcconn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_xsmp_config_T_578 *)$tmp)->smcconn;"
		end

	c_iceconn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_xsmp_config_T_578 *)$tmp)->iceconn;"
		end

	c_clientid (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_xsmp_config_T_578 *)$tmp)->clientid;"
		end

	c_save_yourself (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_xsmp_config_T_578 *)$tmp)->save_yourself;"
		end

	c_shutdown (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_xsmp_config_T_578 *)$tmp)->shutdown;"
		end

feature {NONE} -- C setters

	c_set_smcconn (tmp: POINTER; a_smcconn: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_xsmp_config_T_578 *)$tmp)->smcconn = (void *)$a_smcconn;"
		end

	c_set_iceconn (tmp: POINTER; a_iceconn: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_xsmp_config_T_578 *)$tmp)->iceconn = (void *)$a_iceconn;"
		end

	c_set_clientid (tmp: POINTER; a_clientid: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_xsmp_config_T_578 *)$tmp)->clientid = (char *)$a_clientid;"
		end

	c_set_save_yourself (tmp: POINTER; a_save_yourself: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_xsmp_config_T_578 *)$tmp)->save_yourself = $a_save_yourself;"
		end

	c_set_shutdown (tmp: POINTER; a_shutdown: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_xsmp_config_T_578 *)$tmp)->shutdown = $a_shutdown;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_xsmp_config_T_578);"
		end

end
