frozen class
	VIM_INITIALIZER_SLICE1

inherit
	VIM_DATA
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {VIM_INITIALIZER}

	initialize
		do
			buffer_inst.msg_loclist.ce_gets (ce_string ("[Location List]"))
			buffer_inst.msg_qflist.ce_gets (ce_string ("[Quickfix List]"))
			buffer_inst.top_file_num := 1
			buffer_inst.no_position.lnum := (1).to_integer_32
			buffer_inst.no_position.col := 0
			buffer_inst.no_position.coladd := 0
			buffer_inst.lasttitle.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			buffer_inst.lasticon.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			buffer_inst.entered := 0
			blowfish_inst.ipa[0] := {NATURAL_32} 608135816
			blowfish_inst.ipa[1] := {NATURAL_32} 2242054355
			blowfish_inst.ipa[2] := {NATURAL_32} 320440878
			blowfish_inst.ipa[3] := {NATURAL_32} 57701188
			blowfish_inst.ipa[4] := {NATURAL_32} 2752067618
			blowfish_inst.ipa[5] := {NATURAL_32} 698298832
			blowfish_inst.ipa[6] := {NATURAL_32} 137296536
			blowfish_inst.ipa[7] := {NATURAL_32} 3964562569
			blowfish_inst.ipa[8] := {NATURAL_32} 1160258022
			blowfish_inst.ipa[9] := {NATURAL_32} 953160567
			blowfish_inst.ipa[10] := {NATURAL_32} 3193202383
			blowfish_inst.ipa[11] := {NATURAL_32} 887688300
			blowfish_inst.ipa[12] := {NATURAL_32} 3232508343
			blowfish_inst.ipa[13] := {NATURAL_32} 3380367581
			blowfish_inst.ipa[14] := {NATURAL_32} 1065670069
			blowfish_inst.ipa[15] := {NATURAL_32} 3041331479
			blowfish_inst.ipa[16] := {NATURAL_32} 2450970073
			blowfish_inst.ipa[17] := {NATURAL_32} 2306472731;
			(blowfish_inst.sbi[0])[0] := {NATURAL_32} 3509652390;
			(blowfish_inst.sbi[0])[1] := {NATURAL_32} 2564797868;
			(blowfish_inst.sbi[0])[2] := {NATURAL_32} 805139163;
			(blowfish_inst.sbi[0])[3] := {NATURAL_32} 3491422135;
			(blowfish_inst.sbi[0])[4] := {NATURAL_32} 3101798381;
			(blowfish_inst.sbi[0])[5] := {NATURAL_32} 1780907670;
			(blowfish_inst.sbi[0])[6] := {NATURAL_32} 3128725573;
			(blowfish_inst.sbi[0])[7] := {NATURAL_32} 4046225305;
			(blowfish_inst.sbi[0])[8] := {NATURAL_32} 614570311;
			(blowfish_inst.sbi[0])[9] := {NATURAL_32} 3012652279;
			(blowfish_inst.sbi[0])[10] := {NATURAL_32} 134345442;
			(blowfish_inst.sbi[0])[11] := {NATURAL_32} 2240740374;
			(blowfish_inst.sbi[0])[12] := {NATURAL_32} 1667834072;
			(blowfish_inst.sbi[0])[13] := {NATURAL_32} 1901547113;
			(blowfish_inst.sbi[0])[14] := {NATURAL_32} 2757295779;
			(blowfish_inst.sbi[0])[15] := {NATURAL_32} 4103290238;
			(blowfish_inst.sbi[0])[16] := {NATURAL_32} 227898511;
			(blowfish_inst.sbi[0])[17] := {NATURAL_32} 1921955416;
			(blowfish_inst.sbi[0])[18] := {NATURAL_32} 1904987480;
			(blowfish_inst.sbi[0])[19] := {NATURAL_32} 2182433518;
			(blowfish_inst.sbi[0])[20] := {NATURAL_32} 2069144605;
			(blowfish_inst.sbi[0])[21] := {NATURAL_32} 3260701109;
			(blowfish_inst.sbi[0])[22] := {NATURAL_32} 2620446009;
			(blowfish_inst.sbi[0])[23] := {NATURAL_32} 720527379;
			(blowfish_inst.sbi[0])[24] := {NATURAL_32} 3318853667;
			(blowfish_inst.sbi[0])[25] := {NATURAL_32} 677414384;
			(blowfish_inst.sbi[0])[26] := {NATURAL_32} 3393288472;
			(blowfish_inst.sbi[0])[27] := {NATURAL_32} 3101374703;
			(blowfish_inst.sbi[0])[28] := {NATURAL_32} 2390351024;
			(blowfish_inst.sbi[0])[29] := {NATURAL_32} 1614419982;
			(blowfish_inst.sbi[0])[30] := {NATURAL_32} 1822297739;
			(blowfish_inst.sbi[0])[31] := {NATURAL_32} 2954791486;
			(blowfish_inst.sbi[0])[32] := {NATURAL_32} 3608508353;
			(blowfish_inst.sbi[0])[33] := {NATURAL_32} 3174124327;
			(blowfish_inst.sbi[0])[34] := {NATURAL_32} 2024746970;
			(blowfish_inst.sbi[0])[35] := {NATURAL_32} 1432378464;
			(blowfish_inst.sbi[0])[36] := {NATURAL_32} 3864339955;
			(blowfish_inst.sbi[0])[37] := {NATURAL_32} 2857741204;
			(blowfish_inst.sbi[0])[38] := {NATURAL_32} 1464375394;
			(blowfish_inst.sbi[0])[39] := {NATURAL_32} 1676153920;
			(blowfish_inst.sbi[0])[40] := {NATURAL_32} 1439316330;
			(blowfish_inst.sbi[0])[41] := {NATURAL_32} 715854006;
			(blowfish_inst.sbi[0])[42] := {NATURAL_32} 3033291828;
			(blowfish_inst.sbi[0])[43] := {NATURAL_32} 289532110;
			(blowfish_inst.sbi[0])[44] := {NATURAL_32} 2706671279;
			(blowfish_inst.sbi[0])[45] := {NATURAL_32} 2087905683;
			(blowfish_inst.sbi[0])[46] := {NATURAL_32} 3018724369;
			(blowfish_inst.sbi[0])[47] := {NATURAL_32} 1668267050;
			(blowfish_inst.sbi[0])[48] := {NATURAL_32} 732546397;
			(blowfish_inst.sbi[0])[49] := {NATURAL_32} 1947742710;
			(blowfish_inst.sbi[0])[50] := {NATURAL_32} 3462151702;
			(blowfish_inst.sbi[0])[51] := {NATURAL_32} 2609353502;
			(blowfish_inst.sbi[0])[52] := {NATURAL_32} 2950085171;
			(blowfish_inst.sbi[0])[53] := {NATURAL_32} 1814351708;
			(blowfish_inst.sbi[0])[54] := {NATURAL_32} 2050118529;
			(blowfish_inst.sbi[0])[55] := {NATURAL_32} 680887927;
			(blowfish_inst.sbi[0])[56] := {NATURAL_32} 999245976;
			(blowfish_inst.sbi[0])[57] := {NATURAL_32} 1800124847;
			(blowfish_inst.sbi[0])[58] := {NATURAL_32} 3300911131;
			(blowfish_inst.sbi[0])[59] := {NATURAL_32} 1713906067;
			(blowfish_inst.sbi[0])[60] := {NATURAL_32} 1641548236;
			(blowfish_inst.sbi[0])[61] := {NATURAL_32} 4213287313;
			(blowfish_inst.sbi[0])[62] := {NATURAL_32} 1216130144;
			(blowfish_inst.sbi[0])[63] := {NATURAL_32} 1575780402;
			(blowfish_inst.sbi[0])[64] := {NATURAL_32} 4018429277;
			(blowfish_inst.sbi[0])[65] := {NATURAL_32} 3917837745;
			(blowfish_inst.sbi[0])[66] := {NATURAL_32} 3693486850;
			(blowfish_inst.sbi[0])[67] := {NATURAL_32} 3949271944;
			(blowfish_inst.sbi[0])[68] := {NATURAL_32} 596196993;
			(blowfish_inst.sbi[0])[69] := {NATURAL_32} 3549867205;
			(blowfish_inst.sbi[0])[70] := {NATURAL_32} 258830323;
			(blowfish_inst.sbi[0])[71] := {NATURAL_32} 2213823033;
			(blowfish_inst.sbi[0])[72] := {NATURAL_32} 772490370;
			(blowfish_inst.sbi[0])[73] := {NATURAL_32} 2760122372;
			(blowfish_inst.sbi[0])[74] := {NATURAL_32} 1774776394;
			(blowfish_inst.sbi[0])[75] := {NATURAL_32} 2652871518;
			(blowfish_inst.sbi[0])[76] := {NATURAL_32} 566650946;
			(blowfish_inst.sbi[0])[77] := {NATURAL_32} 4142492826;
			(blowfish_inst.sbi[0])[78] := {NATURAL_32} 1728879713;
			(blowfish_inst.sbi[0])[79] := {NATURAL_32} 2882767088;
			(blowfish_inst.sbi[0])[80] := {NATURAL_32} 1783734482;
			(blowfish_inst.sbi[0])[81] := {NATURAL_32} 3629395816;
			(blowfish_inst.sbi[0])[82] := {NATURAL_32} 2517608232;
			(blowfish_inst.sbi[0])[83] := {NATURAL_32} 2874225571;
			(blowfish_inst.sbi[0])[84] := {NATURAL_32} 1861159788;
			(blowfish_inst.sbi[0])[85] := {NATURAL_32} 326777828;
			(blowfish_inst.sbi[0])[86] := {NATURAL_32} 3124490320;
			(blowfish_inst.sbi[0])[87] := {NATURAL_32} 2130389656;
			(blowfish_inst.sbi[0])[88] := {NATURAL_32} 2716951837;
			(blowfish_inst.sbi[0])[89] := {NATURAL_32} 967770486;
			(blowfish_inst.sbi[0])[90] := {NATURAL_32} 1724537150;
			(blowfish_inst.sbi[0])[91] := {NATURAL_32} 2185432712;
			(blowfish_inst.sbi[0])[92] := {NATURAL_32} 2364442137;
			(blowfish_inst.sbi[0])[93] := {NATURAL_32} 1164943284;
			(blowfish_inst.sbi[0])[94] := {NATURAL_32} 2105845187;
			(blowfish_inst.sbi[0])[95] := {NATURAL_32} 998989502;
			(blowfish_inst.sbi[0])[96] := {NATURAL_32} 3765401048;
			(blowfish_inst.sbi[0])[97] := {NATURAL_32} 2244026483;
			(blowfish_inst.sbi[0])[98] := {NATURAL_32} 1075463327;
			(blowfish_inst.sbi[0])[99] := {NATURAL_32} 1455516326;
			(blowfish_inst.sbi[0])[100] := {NATURAL_32} 1322494562;
			(blowfish_inst.sbi[0])[101] := {NATURAL_32} 910128902;
			(blowfish_inst.sbi[0])[102] := {NATURAL_32} 469688178;
			(blowfish_inst.sbi[0])[103] := {NATURAL_32} 1117454909;
			(blowfish_inst.sbi[0])[104] := {NATURAL_32} 936433444;
			(blowfish_inst.sbi[0])[105] := {NATURAL_32} 3490320968;
			(blowfish_inst.sbi[0])[106] := {NATURAL_32} 3675253459;
			(blowfish_inst.sbi[0])[107] := {NATURAL_32} 1240580251;
			(blowfish_inst.sbi[0])[108] := {NATURAL_32} 122909385;
			(blowfish_inst.sbi[0])[109] := {NATURAL_32} 2157517691;
			(blowfish_inst.sbi[0])[110] := {NATURAL_32} 634681816;
			(blowfish_inst.sbi[0])[111] := {NATURAL_32} 4142456567;
			(blowfish_inst.sbi[0])[112] := {NATURAL_32} 3825094682;
			(blowfish_inst.sbi[0])[113] := {NATURAL_32} 3061402683;
			(blowfish_inst.sbi[0])[114] := {NATURAL_32} 2540495037;
			(blowfish_inst.sbi[0])[115] := {NATURAL_32} 79693498;
			(blowfish_inst.sbi[0])[116] := {NATURAL_32} 3249098678;
			(blowfish_inst.sbi[0])[117] := {NATURAL_32} 1084186820;
			(blowfish_inst.sbi[0])[118] := {NATURAL_32} 1583128258;
			(blowfish_inst.sbi[0])[119] := {NATURAL_32} 426386531;
			(blowfish_inst.sbi[0])[120] := {NATURAL_32} 1761308591;
			(blowfish_inst.sbi[0])[121] := {NATURAL_32} 1047286709;
			(blowfish_inst.sbi[0])[122] := {NATURAL_32} 322548459;
			(blowfish_inst.sbi[0])[123] := {NATURAL_32} 995290223;
			(blowfish_inst.sbi[0])[124] := {NATURAL_32} 1845252383;
			(blowfish_inst.sbi[0])[125] := {NATURAL_32} 2603652396;
			(blowfish_inst.sbi[0])[126] := {NATURAL_32} 3431023940;
			(blowfish_inst.sbi[0])[127] := {NATURAL_32} 2942221577;
			(blowfish_inst.sbi[0])[128] := {NATURAL_32} 3202600964;
			(blowfish_inst.sbi[0])[129] := {NATURAL_32} 3727903485;
			(blowfish_inst.sbi[0])[130] := {NATURAL_32} 1712269319;
			(blowfish_inst.sbi[0])[131] := {NATURAL_32} 422464435;
			(blowfish_inst.sbi[0])[132] := {NATURAL_32} 3234572375;
			(blowfish_inst.sbi[0])[133] := {NATURAL_32} 1170764815;
			(blowfish_inst.sbi[0])[134] := {NATURAL_32} 3523960633;
			(blowfish_inst.sbi[0])[135] := {NATURAL_32} 3117677531;
			(blowfish_inst.sbi[0])[136] := {NATURAL_32} 1434042557;
			(blowfish_inst.sbi[0])[137] := {NATURAL_32} 442511882;
			(blowfish_inst.sbi[0])[138] := {NATURAL_32} 3600875718;
			(blowfish_inst.sbi[0])[139] := {NATURAL_32} 1076654713;
			(blowfish_inst.sbi[0])[140] := {NATURAL_32} 1738483198;
			(blowfish_inst.sbi[0])[141] := {NATURAL_32} 4213154764;
			(blowfish_inst.sbi[0])[142] := {NATURAL_32} 2393238008;
			(blowfish_inst.sbi[0])[143] := {NATURAL_32} 3677496056;
			(blowfish_inst.sbi[0])[144] := {NATURAL_32} 1014306527;
			(blowfish_inst.sbi[0])[145] := {NATURAL_32} 4251020053;
			(blowfish_inst.sbi[0])[146] := {NATURAL_32} 793779912;
			(blowfish_inst.sbi[0])[147] := {NATURAL_32} 2902807211;
			(blowfish_inst.sbi[0])[148] := {NATURAL_32} 842905082;
			(blowfish_inst.sbi[0])[149] := {NATURAL_32} 4246964064;
			(blowfish_inst.sbi[0])[150] := {NATURAL_32} 1395751752;
			(blowfish_inst.sbi[0])[151] := {NATURAL_32} 1040244610;
			(blowfish_inst.sbi[0])[152] := {NATURAL_32} 2656851899;
			(blowfish_inst.sbi[0])[153] := {NATURAL_32} 3396308128;
			(blowfish_inst.sbi[0])[154] := {NATURAL_32} 445077038;
			(blowfish_inst.sbi[0])[155] := {NATURAL_32} 3742853595;
			(blowfish_inst.sbi[0])[156] := {NATURAL_32} 3577915638;
			(blowfish_inst.sbi[0])[157] := {NATURAL_32} 679411651;
			(blowfish_inst.sbi[0])[158] := {NATURAL_32} 2892444358;
			(blowfish_inst.sbi[0])[159] := {NATURAL_32} 2354009459;
			(blowfish_inst.sbi[0])[160] := {NATURAL_32} 1767581616;
			(blowfish_inst.sbi[0])[161] := {NATURAL_32} 3150600392;
			(blowfish_inst.sbi[0])[162] := {NATURAL_32} 3791627101;
			(blowfish_inst.sbi[0])[163] := {NATURAL_32} 3102740896;
			(blowfish_inst.sbi[0])[164] := {NATURAL_32} 284835224;
			(blowfish_inst.sbi[0])[165] := {NATURAL_32} 4246832056;
			(blowfish_inst.sbi[0])[166] := {NATURAL_32} 1258075500;
			(blowfish_inst.sbi[0])[167] := {NATURAL_32} 768725851;
			(blowfish_inst.sbi[0])[168] := {NATURAL_32} 2589189241;
			(blowfish_inst.sbi[0])[169] := {NATURAL_32} 3069724005;
			(blowfish_inst.sbi[0])[170] := {NATURAL_32} 3532540348;
			(blowfish_inst.sbi[0])[171] := {NATURAL_32} 1274779536;
			(blowfish_inst.sbi[0])[172] := {NATURAL_32} 3789419226;
			(blowfish_inst.sbi[0])[173] := {NATURAL_32} 2764799539;
			(blowfish_inst.sbi[0])[174] := {NATURAL_32} 1660621633;
			(blowfish_inst.sbi[0])[175] := {NATURAL_32} 3471099624;
			(blowfish_inst.sbi[0])[176] := {NATURAL_32} 4011903706;
			(blowfish_inst.sbi[0])[177] := {NATURAL_32} 913787905;
			(blowfish_inst.sbi[0])[178] := {NATURAL_32} 3497959166;
			(blowfish_inst.sbi[0])[179] := {NATURAL_32} 737222580;
			(blowfish_inst.sbi[0])[180] := {NATURAL_32} 2514213453;
			(blowfish_inst.sbi[0])[181] := {NATURAL_32} 2928710040;
			(blowfish_inst.sbi[0])[182] := {NATURAL_32} 3937242737;
			(blowfish_inst.sbi[0])[183] := {NATURAL_32} 1804850592;
			(blowfish_inst.sbi[0])[184] := {NATURAL_32} 3499020752;
			(blowfish_inst.sbi[0])[185] := {NATURAL_32} 2949064160;
			(blowfish_inst.sbi[0])[186] := {NATURAL_32} 2386320175;
			(blowfish_inst.sbi[0])[187] := {NATURAL_32} 2390070455;
			(blowfish_inst.sbi[0])[188] := {NATURAL_32} 2415321851;
			(blowfish_inst.sbi[0])[189] := {NATURAL_32} 4061277028;
			(blowfish_inst.sbi[0])[190] := {NATURAL_32} 2290661394;
			(blowfish_inst.sbi[0])[191] := {NATURAL_32} 2416832540;
			(blowfish_inst.sbi[0])[192] := {NATURAL_32} 1336762016;
			(blowfish_inst.sbi[0])[193] := {NATURAL_32} 1754252060;
			(blowfish_inst.sbi[0])[194] := {NATURAL_32} 3520065937;
			(blowfish_inst.sbi[0])[195] := {NATURAL_32} 3014181293;
			(blowfish_inst.sbi[0])[196] := {NATURAL_32} 791618072;
			(blowfish_inst.sbi[0])[197] := {NATURAL_32} 3188594551;
			(blowfish_inst.sbi[0])[198] := {NATURAL_32} 3933548030;
			(blowfish_inst.sbi[0])[199] := {NATURAL_32} 2332172193;
			(blowfish_inst.sbi[0])[200] := {NATURAL_32} 3852520463;
			(blowfish_inst.sbi[0])[201] := {NATURAL_32} 3043980520;
			(blowfish_inst.sbi[0])[202] := {NATURAL_32} 413987798;
			(blowfish_inst.sbi[0])[203] := {NATURAL_32} 3465142937;
			(blowfish_inst.sbi[0])[204] := {NATURAL_32} 3030929376;
			(blowfish_inst.sbi[0])[205] := {NATURAL_32} 4245938359;
			(blowfish_inst.sbi[0])[206] := {NATURAL_32} 2093235073;
			(blowfish_inst.sbi[0])[207] := {NATURAL_32} 3534596313;
			(blowfish_inst.sbi[0])[208] := {NATURAL_32} 375366246;
			(blowfish_inst.sbi[0])[209] := {NATURAL_32} 2157278981;
			(blowfish_inst.sbi[0])[210] := {NATURAL_32} 2479649556;
			(blowfish_inst.sbi[0])[211] := {NATURAL_32} 555357303;
			(blowfish_inst.sbi[0])[212] := {NATURAL_32} 3870105701;
			(blowfish_inst.sbi[0])[213] := {NATURAL_32} 2008414854;
			(blowfish_inst.sbi[0])[214] := {NATURAL_32} 3344188149;
			(blowfish_inst.sbi[0])[215] := {NATURAL_32} 4221384143;
			(blowfish_inst.sbi[0])[216] := {NATURAL_32} 3956125452;
			(blowfish_inst.sbi[0])[217] := {NATURAL_32} 2067696032;
			(blowfish_inst.sbi[0])[218] := {NATURAL_32} 3594591187;
			(blowfish_inst.sbi[0])[219] := {NATURAL_32} 2921233993;
			(blowfish_inst.sbi[0])[220] := {NATURAL_32} 2428461;
			(blowfish_inst.sbi[0])[221] := {NATURAL_32} 544322398;
			(blowfish_inst.sbi[0])[222] := {NATURAL_32} 577241275;
			(blowfish_inst.sbi[0])[223] := {NATURAL_32} 1471733935;
			(blowfish_inst.sbi[0])[224] := {NATURAL_32} 610547355;
			(blowfish_inst.sbi[0])[225] := {NATURAL_32} 4027169054;
			(blowfish_inst.sbi[0])[226] := {NATURAL_32} 1432588573;
			(blowfish_inst.sbi[0])[227] := {NATURAL_32} 1507829418;
			(blowfish_inst.sbi[0])[228] := {NATURAL_32} 2025931657;
			(blowfish_inst.sbi[0])[229] := {NATURAL_32} 3646575487;
			(blowfish_inst.sbi[0])[230] := {NATURAL_32} 545086370;
			(blowfish_inst.sbi[0])[231] := {NATURAL_32} 48609733;
			(blowfish_inst.sbi[0])[232] := {NATURAL_32} 2200306550;
			(blowfish_inst.sbi[0])[233] := {NATURAL_32} 1653985193;
			(blowfish_inst.sbi[0])[234] := {NATURAL_32} 298326376;
			(blowfish_inst.sbi[0])[235] := {NATURAL_32} 1316178497;
			(blowfish_inst.sbi[0])[236] := {NATURAL_32} 3007786442;
			(blowfish_inst.sbi[0])[237] := {NATURAL_32} 2064951626;
			(blowfish_inst.sbi[0])[238] := {NATURAL_32} 458293330;
			(blowfish_inst.sbi[0])[239] := {NATURAL_32} 2589141269;
			(blowfish_inst.sbi[0])[240] := {NATURAL_32} 3591329599;
			(blowfish_inst.sbi[0])[241] := {NATURAL_32} 3164325604;
			(blowfish_inst.sbi[0])[242] := {NATURAL_32} 727753846;
			(blowfish_inst.sbi[0])[243] := {NATURAL_32} 2179363840;
			(blowfish_inst.sbi[0])[244] := {NATURAL_32} 146436021;
			(blowfish_inst.sbi[0])[245] := {NATURAL_32} 1461446943;
			(blowfish_inst.sbi[0])[246] := {NATURAL_32} 4069977195;
			(blowfish_inst.sbi[0])[247] := {NATURAL_32} 705550613;
			(blowfish_inst.sbi[0])[248] := {NATURAL_32} 3059967265;
			(blowfish_inst.sbi[0])[249] := {NATURAL_32} 3887724982;
			(blowfish_inst.sbi[0])[250] := {NATURAL_32} 4281599278;
			(blowfish_inst.sbi[0])[251] := {NATURAL_32} 3313849956;
			(blowfish_inst.sbi[0])[252] := {NATURAL_32} 1404054877;
			(blowfish_inst.sbi[0])[253] := {NATURAL_32} 2845806497;
			(blowfish_inst.sbi[0])[254] := {NATURAL_32} 146425753;
			(blowfish_inst.sbi[0])[255] := {NATURAL_32} 1854211946;
			(blowfish_inst.sbi[1])[0] := {NATURAL_32} 1266315497;
			(blowfish_inst.sbi[1])[1] := {NATURAL_32} 3048417604;
			(blowfish_inst.sbi[1])[2] := {NATURAL_32} 3681880366;
			(blowfish_inst.sbi[1])[3] := {NATURAL_32} 3289982499;
			(blowfish_inst.sbi[1])[4] := {NATURAL_32} 2909710000;
			(blowfish_inst.sbi[1])[5] := {NATURAL_32} 1235738493;
			(blowfish_inst.sbi[1])[6] := {NATURAL_32} 2632868024;
			(blowfish_inst.sbi[1])[7] := {NATURAL_32} 2414719590;
			(blowfish_inst.sbi[1])[8] := {NATURAL_32} 3970600049;
			(blowfish_inst.sbi[1])[9] := {NATURAL_32} 1771706367;
			(blowfish_inst.sbi[1])[10] := {NATURAL_32} 1449415276;
			(blowfish_inst.sbi[1])[11] := {NATURAL_32} 3266420449;
			(blowfish_inst.sbi[1])[12] := {NATURAL_32} 422970021;
			(blowfish_inst.sbi[1])[13] := {NATURAL_32} 1963543593;
			(blowfish_inst.sbi[1])[14] := {NATURAL_32} 2690192192;
			(blowfish_inst.sbi[1])[15] := {NATURAL_32} 3826793022;
			(blowfish_inst.sbi[1])[16] := {NATURAL_32} 1062508698;
			(blowfish_inst.sbi[1])[17] := {NATURAL_32} 1531092325;
			(blowfish_inst.sbi[1])[18] := {NATURAL_32} 1804592342;
			(blowfish_inst.sbi[1])[19] := {NATURAL_32} 2583117782;
			(blowfish_inst.sbi[1])[20] := {NATURAL_32} 2714934279;
			(blowfish_inst.sbi[1])[21] := {NATURAL_32} 4024971509;
			(blowfish_inst.sbi[1])[22] := {NATURAL_32} 1294809318;
			(blowfish_inst.sbi[1])[23] := {NATURAL_32} 4028980673;
			(blowfish_inst.sbi[1])[24] := {NATURAL_32} 1289560198;
			(blowfish_inst.sbi[1])[25] := {NATURAL_32} 2221992742;
			(blowfish_inst.sbi[1])[26] := {NATURAL_32} 1669523910;
			(blowfish_inst.sbi[1])[27] := {NATURAL_32} 35572830;
			(blowfish_inst.sbi[1])[28] := {NATURAL_32} 157838143;
			(blowfish_inst.sbi[1])[29] := {NATURAL_32} 1052438473;
			(blowfish_inst.sbi[1])[30] := {NATURAL_32} 1016535060;
			(blowfish_inst.sbi[1])[31] := {NATURAL_32} 1802137761;
			(blowfish_inst.sbi[1])[32] := {NATURAL_32} 1753167236;
			(blowfish_inst.sbi[1])[33] := {NATURAL_32} 1386275462;
			(blowfish_inst.sbi[1])[34] := {NATURAL_32} 3080475397;
			(blowfish_inst.sbi[1])[35] := {NATURAL_32} 2857371447;
			(blowfish_inst.sbi[1])[36] := {NATURAL_32} 1040679964;
			(blowfish_inst.sbi[1])[37] := {NATURAL_32} 2145300060;
			(blowfish_inst.sbi[1])[38] := {NATURAL_32} 2390574316;
			(blowfish_inst.sbi[1])[39] := {NATURAL_32} 1461121720;
			(blowfish_inst.sbi[1])[40] := {NATURAL_32} 2956646967;
			(blowfish_inst.sbi[1])[41] := {NATURAL_32} 4031777805;
			(blowfish_inst.sbi[1])[42] := {NATURAL_32} 4028374788;
			(blowfish_inst.sbi[1])[43] := {NATURAL_32} 33600511;
			(blowfish_inst.sbi[1])[44] := {NATURAL_32} 2920084762;
			(blowfish_inst.sbi[1])[45] := {NATURAL_32} 1018524850;
			(blowfish_inst.sbi[1])[46] := {NATURAL_32} 629373528;
			(blowfish_inst.sbi[1])[47] := {NATURAL_32} 3691585981;
			(blowfish_inst.sbi[1])[48] := {NATURAL_32} 3515945977;
			(blowfish_inst.sbi[1])[49] := {NATURAL_32} 2091462646;
			(blowfish_inst.sbi[1])[50] := {NATURAL_32} 2486323059;
			(blowfish_inst.sbi[1])[51] := {NATURAL_32} 586499841;
			(blowfish_inst.sbi[1])[52] := {NATURAL_32} 988145025;
			(blowfish_inst.sbi[1])[53] := {NATURAL_32} 935516892;
			(blowfish_inst.sbi[1])[54] := {NATURAL_32} 3367335476;
			(blowfish_inst.sbi[1])[55] := {NATURAL_32} 2599673255;
			(blowfish_inst.sbi[1])[56] := {NATURAL_32} 2839830854;
			(blowfish_inst.sbi[1])[57] := {NATURAL_32} 265290510;
			(blowfish_inst.sbi[1])[58] := {NATURAL_32} 3972581182;
			(blowfish_inst.sbi[1])[59] := {NATURAL_32} 2759138881;
			(blowfish_inst.sbi[1])[60] := {NATURAL_32} 3795373465;
			(blowfish_inst.sbi[1])[61] := {NATURAL_32} 1005194799;
			(blowfish_inst.sbi[1])[62] := {NATURAL_32} 847297441;
			(blowfish_inst.sbi[1])[63] := {NATURAL_32} 406762289;
			(blowfish_inst.sbi[1])[64] := {NATURAL_32} 1314163512;
			(blowfish_inst.sbi[1])[65] := {NATURAL_32} 1332590856;
			(blowfish_inst.sbi[1])[66] := {NATURAL_32} 1866599683;
			(blowfish_inst.sbi[1])[67] := {NATURAL_32} 4127851711;
			(blowfish_inst.sbi[1])[68] := {NATURAL_32} 750260880;
			(blowfish_inst.sbi[1])[69] := {NATURAL_32} 613907577;
			(blowfish_inst.sbi[1])[70] := {NATURAL_32} 1450815602;
			(blowfish_inst.sbi[1])[71] := {NATURAL_32} 3165620655;
			(blowfish_inst.sbi[1])[72] := {NATURAL_32} 3734664991;
			(blowfish_inst.sbi[1])[73] := {NATURAL_32} 3650291728;
			(blowfish_inst.sbi[1])[74] := {NATURAL_32} 3012275730;
			(blowfish_inst.sbi[1])[75] := {NATURAL_32} 3704569646;
			(blowfish_inst.sbi[1])[76] := {NATURAL_32} 1427272223;
			(blowfish_inst.sbi[1])[77] := {NATURAL_32} 778793252;
			(blowfish_inst.sbi[1])[78] := {NATURAL_32} 1343938022;
			(blowfish_inst.sbi[1])[79] := {NATURAL_32} 2676280711;
			(blowfish_inst.sbi[1])[80] := {NATURAL_32} 2052605720;
			(blowfish_inst.sbi[1])[81] := {NATURAL_32} 1946737175;
			(blowfish_inst.sbi[1])[82] := {NATURAL_32} 3164576444;
			(blowfish_inst.sbi[1])[83] := {NATURAL_32} 3914038668;
			(blowfish_inst.sbi[1])[84] := {NATURAL_32} 3967478842;
			(blowfish_inst.sbi[1])[85] := {NATURAL_32} 3682934266;
			(blowfish_inst.sbi[1])[86] := {NATURAL_32} 1661551462;
			(blowfish_inst.sbi[1])[87] := {NATURAL_32} 3294938066;
			(blowfish_inst.sbi[1])[88] := {NATURAL_32} 4011595847;
			(blowfish_inst.sbi[1])[89] := {NATURAL_32} 840292616;
			(blowfish_inst.sbi[1])[90] := {NATURAL_32} 3712170807;
			(blowfish_inst.sbi[1])[91] := {NATURAL_32} 616741398;
			(blowfish_inst.sbi[1])[92] := {NATURAL_32} 312560963;
			(blowfish_inst.sbi[1])[93] := {NATURAL_32} 711312465;
			(blowfish_inst.sbi[1])[94] := {NATURAL_32} 1351876610;
			(blowfish_inst.sbi[1])[95] := {NATURAL_32} 322626781;
			(blowfish_inst.sbi[1])[96] := {NATURAL_32} 1910503582;
			(blowfish_inst.sbi[1])[97] := {NATURAL_32} 271666773;
			(blowfish_inst.sbi[1])[98] := {NATURAL_32} 2175563734;
			(blowfish_inst.sbi[1])[99] := {NATURAL_32} 1594956187;
			(blowfish_inst.sbi[1])[100] := {NATURAL_32} 70604529;
			(blowfish_inst.sbi[1])[101] := {NATURAL_32} 3617834859;
			(blowfish_inst.sbi[1])[102] := {NATURAL_32} 1007753275;
			(blowfish_inst.sbi[1])[103] := {NATURAL_32} 1495573769;
			(blowfish_inst.sbi[1])[104] := {NATURAL_32} 4069517037;
			(blowfish_inst.sbi[1])[105] := {NATURAL_32} 2549218298;
			(blowfish_inst.sbi[1])[106] := {NATURAL_32} 2663038764;
			(blowfish_inst.sbi[1])[107] := {NATURAL_32} 504708206;
			(blowfish_inst.sbi[1])[108] := {NATURAL_32} 2263041392;
			(blowfish_inst.sbi[1])[109] := {NATURAL_32} 3941167025;
			(blowfish_inst.sbi[1])[110] := {NATURAL_32} 2249088522;
			(blowfish_inst.sbi[1])[111] := {NATURAL_32} 1514023603;
			(blowfish_inst.sbi[1])[112] := {NATURAL_32} 1998579484;
			(blowfish_inst.sbi[1])[113] := {NATURAL_32} 1312622330;
			(blowfish_inst.sbi[1])[114] := {NATURAL_32} 694541497;
			(blowfish_inst.sbi[1])[115] := {NATURAL_32} 2582060303;
			(blowfish_inst.sbi[1])[116] := {NATURAL_32} 2151582166;
			(blowfish_inst.sbi[1])[117] := {NATURAL_32} 1382467621;
			(blowfish_inst.sbi[1])[118] := {NATURAL_32} 776784248;
			(blowfish_inst.sbi[1])[119] := {NATURAL_32} 2618340202;
			(blowfish_inst.sbi[1])[120] := {NATURAL_32} 3323268794;
			(blowfish_inst.sbi[1])[121] := {NATURAL_32} 2497899128;
			(blowfish_inst.sbi[1])[122] := {NATURAL_32} 2784771155;
			(blowfish_inst.sbi[1])[123] := {NATURAL_32} 503983604;
			(blowfish_inst.sbi[1])[124] := {NATURAL_32} 4076293799;
			(blowfish_inst.sbi[1])[125] := {NATURAL_32} 907881277;
			(blowfish_inst.sbi[1])[126] := {NATURAL_32} 423175695;
			(blowfish_inst.sbi[1])[127] := {NATURAL_32} 432175456;
			(blowfish_inst.sbi[1])[128] := {NATURAL_32} 1378068232;
			(blowfish_inst.sbi[1])[129] := {NATURAL_32} 4145222326;
			(blowfish_inst.sbi[1])[130] := {NATURAL_32} 3954048622;
			(blowfish_inst.sbi[1])[131] := {NATURAL_32} 3938656102;
			(blowfish_inst.sbi[1])[132] := {NATURAL_32} 3820766613;
			(blowfish_inst.sbi[1])[133] := {NATURAL_32} 2793130115;
			(blowfish_inst.sbi[1])[134] := {NATURAL_32} 2977904593;
			(blowfish_inst.sbi[1])[135] := {NATURAL_32} 26017576;
			(blowfish_inst.sbi[1])[136] := {NATURAL_32} 3274890735;
			(blowfish_inst.sbi[1])[137] := {NATURAL_32} 3194772133;
			(blowfish_inst.sbi[1])[138] := {NATURAL_32} 1700274565;
			(blowfish_inst.sbi[1])[139] := {NATURAL_32} 1756076034;
			(blowfish_inst.sbi[1])[140] := {NATURAL_32} 4006520079;
			(blowfish_inst.sbi[1])[141] := {NATURAL_32} 3677328699;
			(blowfish_inst.sbi[1])[142] := {NATURAL_32} 720338349;
			(blowfish_inst.sbi[1])[143] := {NATURAL_32} 1533947780;
			(blowfish_inst.sbi[1])[144] := {NATURAL_32} 354530856;
			(blowfish_inst.sbi[1])[145] := {NATURAL_32} 688349552;
			(blowfish_inst.sbi[1])[146] := {NATURAL_32} 3973924725;
			(blowfish_inst.sbi[1])[147] := {NATURAL_32} 1637815568;
			(blowfish_inst.sbi[1])[148] := {NATURAL_32} 332179504;
			(blowfish_inst.sbi[1])[149] := {NATURAL_32} 3949051286;
			(blowfish_inst.sbi[1])[150] := {NATURAL_32} 53804574;
			(blowfish_inst.sbi[1])[151] := {NATURAL_32} 2852348879;
			(blowfish_inst.sbi[1])[152] := {NATURAL_32} 3044236432;
			(blowfish_inst.sbi[1])[153] := {NATURAL_32} 1282449977;
			(blowfish_inst.sbi[1])[154] := {NATURAL_32} 3583942155;
			(blowfish_inst.sbi[1])[155] := {NATURAL_32} 3416972820;
			(blowfish_inst.sbi[1])[156] := {NATURAL_32} 4006381244;
			(blowfish_inst.sbi[1])[157] := {NATURAL_32} 1617046695;
			(blowfish_inst.sbi[1])[158] := {NATURAL_32} 2628476075;
			(blowfish_inst.sbi[1])[159] := {NATURAL_32} 3002303598;
			(blowfish_inst.sbi[1])[160] := {NATURAL_32} 1686838959;
			(blowfish_inst.sbi[1])[161] := {NATURAL_32} 431878346;
			(blowfish_inst.sbi[1])[162] := {NATURAL_32} 2686675385;
			(blowfish_inst.sbi[1])[163] := {NATURAL_32} 1700445008;
			(blowfish_inst.sbi[1])[164] := {NATURAL_32} 1080580658;
			(blowfish_inst.sbi[1])[165] := {NATURAL_32} 1009431731;
			(blowfish_inst.sbi[1])[166] := {NATURAL_32} 832498133;
			(blowfish_inst.sbi[1])[167] := {NATURAL_32} 3223435511;
			(blowfish_inst.sbi[1])[168] := {NATURAL_32} 2605976345;
			(blowfish_inst.sbi[1])[169] := {NATURAL_32} 2271191193;
			(blowfish_inst.sbi[1])[170] := {NATURAL_32} 2516031870;
			(blowfish_inst.sbi[1])[171] := {NATURAL_32} 1648197032;
			(blowfish_inst.sbi[1])[172] := {NATURAL_32} 4164389018;
			(blowfish_inst.sbi[1])[173] := {NATURAL_32} 2548247927;
			(blowfish_inst.sbi[1])[174] := {NATURAL_32} 300782431;
			(blowfish_inst.sbi[1])[175] := {NATURAL_32} 375919233;
			(blowfish_inst.sbi[1])[176] := {NATURAL_32} 238389289;
			(blowfish_inst.sbi[1])[177] := {NATURAL_32} 3353747414;
			(blowfish_inst.sbi[1])[178] := {NATURAL_32} 2531188641;
			(blowfish_inst.sbi[1])[179] := {NATURAL_32} 2019080857;
			(blowfish_inst.sbi[1])[180] := {NATURAL_32} 1475708069;
			(blowfish_inst.sbi[1])[181] := {NATURAL_32} 455242339;
			(blowfish_inst.sbi[1])[182] := {NATURAL_32} 2609103871;
			(blowfish_inst.sbi[1])[183] := {NATURAL_32} 448939670;
			(blowfish_inst.sbi[1])[184] := {NATURAL_32} 3451063019;
			(blowfish_inst.sbi[1])[185] := {NATURAL_32} 1395535956;
			(blowfish_inst.sbi[1])[186] := {NATURAL_32} 2413381860;
			(blowfish_inst.sbi[1])[187] := {NATURAL_32} 1841049896;
			(blowfish_inst.sbi[1])[188] := {NATURAL_32} 1491858159;
			(blowfish_inst.sbi[1])[189] := {NATURAL_32} 885456874;
			(blowfish_inst.sbi[1])[190] := {NATURAL_32} 4264095073;
			(blowfish_inst.sbi[1])[191] := {NATURAL_32} 4001119347;
			(blowfish_inst.sbi[1])[192] := {NATURAL_32} 1565136089;
			(blowfish_inst.sbi[1])[193] := {NATURAL_32} 3898914787;
			(blowfish_inst.sbi[1])[194] := {NATURAL_32} 1108368660;
			(blowfish_inst.sbi[1])[195] := {NATURAL_32} 540939232;
			(blowfish_inst.sbi[1])[196] := {NATURAL_32} 1173283510;
			(blowfish_inst.sbi[1])[197] := {NATURAL_32} 2745871338;
			(blowfish_inst.sbi[1])[198] := {NATURAL_32} 3681308437;
			(blowfish_inst.sbi[1])[199] := {NATURAL_32} 4207628240;
			(blowfish_inst.sbi[1])[200] := {NATURAL_32} 3343053890;
			(blowfish_inst.sbi[1])[201] := {NATURAL_32} 4016749493;
			(blowfish_inst.sbi[1])[202] := {NATURAL_32} 1699691293;
			(blowfish_inst.sbi[1])[203] := {NATURAL_32} 1103962373;
			(blowfish_inst.sbi[1])[204] := {NATURAL_32} 3625875870;
			(blowfish_inst.sbi[1])[205] := {NATURAL_32} 2256883143;
			(blowfish_inst.sbi[1])[206] := {NATURAL_32} 3830138730;
			(blowfish_inst.sbi[1])[207] := {NATURAL_32} 1031889488;
			(blowfish_inst.sbi[1])[208] := {NATURAL_32} 3479347698;
			(blowfish_inst.sbi[1])[209] := {NATURAL_32} 1535977030;
			(blowfish_inst.sbi[1])[210] := {NATURAL_32} 4236805024;
			(blowfish_inst.sbi[1])[211] := {NATURAL_32} 3251091107;
			(blowfish_inst.sbi[1])[212] := {NATURAL_32} 2132092099;
			(blowfish_inst.sbi[1])[213] := {NATURAL_32} 1774941330;
			(blowfish_inst.sbi[1])[214] := {NATURAL_32} 1199868427;
			(blowfish_inst.sbi[1])[215] := {NATURAL_32} 1452454533;
			(blowfish_inst.sbi[1])[216] := {NATURAL_32} 157007616
		end

end
