frozen class
	VIM_INITIALIZER_SLICE16

inherit
	VIM_DATA
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {VIM_INITIALIZER}

	initialize
		do
			eval_inst.av[0] := ce_string ("keep")
			eval_inst.av[1] := ce_string ("force")
			eval_inst.av[2] := ce_string ("error")
			eval_inst.has_list[0] := ce_string ("unix")
			eval_inst.has_list[1] := ce_string ("fname_case")
			eval_inst.has_list[2] := ce_string ("autocmd")
			eval_inst.has_list[3] := ce_string ("balloon_eval")
			eval_inst.has_list[4] := ce_string ("balloon_multiline")
			eval_inst.has_list[5] := ce_string ("builtin_terms")
			eval_inst.has_list[6] := ce_string ("byte_offset")
			eval_inst.has_list[7] := ce_string ("cindent")
			eval_inst.has_list[8] := ce_string ("clientserver")
			eval_inst.has_list[9] := ce_string ("clipboard")
			eval_inst.has_list[10] := ce_string ("cmdline_compl")
			eval_inst.has_list[11] := ce_string ("cmdline_hist")
			eval_inst.has_list[12] := ce_string ("comments")
			eval_inst.has_list[13] := ce_string ("cryptv")
			eval_inst.has_list[14] := ce_string ("cursorbind")
			eval_inst.has_list[15] := ce_string ("cursorshape")
			eval_inst.has_list[16] := ce_string ("dialog_con")
			eval_inst.has_list[17] := ce_string ("dialog_gui")
			eval_inst.has_list[18] := ce_string ("diff")
			eval_inst.has_list[19] := ce_string ("digraphs")
			eval_inst.has_list[20] := ce_string ("dnd")
			eval_inst.has_list[21] := ce_string ("eval")
			eval_inst.has_list[22] := ce_string ("ex_extra")
			eval_inst.has_list[23] := ce_string ("extra_search")
			eval_inst.has_list[24] := ce_string ("file_in_path")
			eval_inst.has_list[25] := ce_string ("filterpipe")
			eval_inst.has_list[26] := ce_string ("find_in_path")
			eval_inst.has_list[27] := ce_string ("float")
			eval_inst.has_list[28] := ce_string ("folding")
			eval_inst.has_list[29] := ce_string ("fork")
			eval_inst.has_list[30] := ce_string ("gettext")
			eval_inst.has_list[31] := ce_string ("gui")
			eval_inst.has_list[32] := ce_string ("gui_gtk")
			eval_inst.has_list[33] := ce_string ("gui_gtk2")
			eval_inst.has_list[34] := ce_string ("iconv")
			eval_inst.has_list[35] := ce_string ("insert_expand")
			eval_inst.has_list[36] := ce_string ("jumplist")
			eval_inst.has_list[37] := ce_string ("libcall")
			eval_inst.has_list[38] := ce_string ("linebreak")
			eval_inst.has_list[39] := ce_string ("lispindent")
			eval_inst.has_list[40] := ce_string ("listcmds")
			eval_inst.has_list[41] := ce_string ("localmap")
			eval_inst.has_list[42] := ce_string ("menu")
			eval_inst.has_list[43] := ce_string ("mksession")
			eval_inst.has_list[44] := ce_string ("modify_fname")
			eval_inst.has_list[45] := ce_string ("mouse")
			eval_inst.has_list[46] := ce_string ("mouseshape")
			eval_inst.has_list[47] := ce_string ("mouse_xterm")
			eval_inst.has_list[48] := ce_string ("multi_byte")
			eval_inst.has_list[49] := ce_string ("multi_lang")
			eval_inst.has_list[50] := ce_string ("path_extra")
			eval_inst.has_list[51] := ce_string ("persistent_undo")
			eval_inst.has_list[52] := ce_string ("postscript")
			eval_inst.has_list[53] := ce_string ("printer")
			eval_inst.has_list[54] := ce_string ("reltime")
			eval_inst.has_list[55] := ce_string ("quickfix")
			eval_inst.has_list[56] := ce_string ("scrollbind")
			eval_inst.has_list[57] := ce_string ("showcmd")
			eval_inst.has_list[58] := ce_string ("cmdline_info")
			eval_inst.has_list[59] := ce_string ("signs")
			eval_inst.has_list[60] := ce_string ("smartindent")
			eval_inst.has_list[61] := ce_string ("startuptime")
			eval_inst.has_list[62] := ce_string ("statusline")
			eval_inst.has_list[63] := ce_string ("netbeans_intg")
			eval_inst.has_list[64] := ce_string ("spell")
			eval_inst.has_list[65] := ce_string ("syntax")
			eval_inst.has_list[66] := ce_string ("tag_binary")
			eval_inst.has_list[67] := ce_string ("tag_old_static")
			eval_inst.has_list[68] := ce_string ("terminfo")
			eval_inst.has_list[69] := ce_string ("termresponse")
			eval_inst.has_list[70] := ce_string ("textobjects")
			eval_inst.has_list[71] := ce_string ("tgetent")
			eval_inst.has_list[72] := ce_string ("title")
			eval_inst.has_list[73] := ce_string ("toolbar")
			eval_inst.has_list[74] := ce_string ("user-commands")
			eval_inst.has_list[75] := ce_string ("user_commands")
			eval_inst.has_list[76] := ce_string ("viminfo")
			eval_inst.has_list[77] := ce_string ("vertsplit")
			eval_inst.has_list[78] := ce_string ("virtualedit")
			eval_inst.has_list[79] := ce_string ("visual")
			eval_inst.has_list[80] := ce_string ("visualextra")
			eval_inst.has_list[81] := ce_string ("vreplace")
			eval_inst.has_list[82] := ce_string ("wildignore")
			eval_inst.has_list[83] := ce_string ("wildmenu")
			eval_inst.has_list[84] := ce_string ("windows")
			eval_inst.has_list[85] := ce_string ("winaltkeys")
			eval_inst.has_list[86] := ce_string ("writebackup")
			eval_inst.has_list[87] := ce_string ("xim")
			eval_inst.has_list[88] := ce_string ("xsmp")
			eval_inst.has_list[89] := ce_string ("xsmp_interact")
			eval_inst.has_list[90] := ce_string ("xterm_clipboard")
			eval_inst.has_list[91] := ce_string ("X11")
			eval_inst.has_list[92] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			eval_inst.inputsecret_flag := 0
			eval_inst.ga_userinput.ga_len := 0
			eval_inst.ga_userinput.ga_maxlen := 0
			eval_inst.ga_userinput.ga_itemsize := ({PD_TASAVE_T}.sizeof.to_natural_32).to_integer_32
			eval_inst.ga_userinput.ga_growsize := 4
			eval_inst.ga_userinput.ga_data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			eval_inst.x := ('A').code
			eval_inst.recurse___1 := 0
			eval_inst.func_nr := 0
			eval_inst.depth := 0
			ex_cmds_inst.prevcmd.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			ex_cmds_inst.append_indent := 0
			ex_cmds_inst.old_sub.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			ex_cmds_inst.do_all := 0
			ex_cmds_inst.do_ask := 0
			ex_cmds_inst.do_count := 0
			ex_cmds_inst.do_error := 1
			ex_cmds_inst.do_print := 0
			ex_cmds_inst.do_list := 0
			ex_cmds_inst.do_number := 0
			ex_cmds_inst.do_ic := 0
			ex_cmds_inst.mtable[0] := ce_string ("*")
			ex_cmds_inst.mtable[1] := ce_string ("g*")
			ex_cmds_inst.mtable[2] := ce_string ("[*")
			ex_cmds_inst.mtable[3] := ce_string ("]*")
			ex_cmds_inst.mtable[4] := ce_string (":*")
			ex_cmds_inst.mtable[5] := ce_string ("/*")
			ex_cmds_inst.mtable[6] := ce_string ("/\*")
			ex_cmds_inst.mtable[7] := ce_string ("%"*")
			ex_cmds_inst.mtable[8] := ce_string ("**")
			ex_cmds_inst.mtable[9] := ce_string ("/\(\)")
			ex_cmds_inst.mtable[10] := ce_string ("?")
			ex_cmds_inst.mtable[11] := ce_string (":?")
			ex_cmds_inst.mtable[12] := ce_string ("?<CR>")
			ex_cmds_inst.mtable[13] := ce_string ("g?")
			ex_cmds_inst.mtable[14] := ce_string ("g?g?")
			ex_cmds_inst.mtable[15] := ce_string ("g??")
			ex_cmds_inst.mtable[16] := ce_string ("z?")
			ex_cmds_inst.mtable[17] := ce_string ("/\?")
			ex_cmds_inst.mtable[18] := ce_string ("/\z(\)")
			ex_cmds_inst.mtable[19] := ce_string ("\=")
			ex_cmds_inst.mtable[20] := ce_string (":s\=")
			ex_cmds_inst.mtable[21] := ce_string ("[count]")
			ex_cmds_inst.mtable[22] := ce_string ("[quotex]")
			ex_cmds_inst.mtable[23] := ce_string ("[range]")
			ex_cmds_inst.mtable[24] := ce_string ("[pattern]")
			ex_cmds_inst.mtable[25] := ce_string ("\|")
			ex_cmds_inst.mtable[26] := ce_string ("\%%$")
			ex_cmds_inst.rtable[0] := ce_string ("star")
			ex_cmds_inst.rtable[1] := ce_string ("gstar")
			ex_cmds_inst.rtable[2] := ce_string ("[star")
			ex_cmds_inst.rtable[3] := ce_string ("]star")
			ex_cmds_inst.rtable[4] := ce_string (":star")
			ex_cmds_inst.rtable[5] := ce_string ("/star")
			ex_cmds_inst.rtable[6] := ce_string ("/\\star")
			ex_cmds_inst.rtable[7] := ce_string ("quotestar")
			ex_cmds_inst.rtable[8] := ce_string ("starstar")
			ex_cmds_inst.rtable[9] := ce_string ("/\\(\\)")
			ex_cmds_inst.rtable[10] := ce_string ("?")
			ex_cmds_inst.rtable[11] := ce_string (":?")
			ex_cmds_inst.rtable[12] := ce_string ("?<CR>")
			ex_cmds_inst.rtable[13] := ce_string ("g?")
			ex_cmds_inst.rtable[14] := ce_string ("g?g?")
			ex_cmds_inst.rtable[15] := ce_string ("g??")
			ex_cmds_inst.rtable[16] := ce_string ("z?")
			ex_cmds_inst.rtable[17] := ce_string ("/\\?")
			ex_cmds_inst.rtable[18] := ce_string ("/\\z(\\)")
			ex_cmds_inst.rtable[19] := ce_string ("\\=")
			ex_cmds_inst.rtable[20] := ce_string (":s\\=")
			ex_cmds_inst.rtable[21] := ce_string ("\[count]")
			ex_cmds_inst.rtable[22] := ce_string ("\[quotex]")
			ex_cmds_inst.rtable[23] := ce_string ("\[range]")
			ex_cmds_inst.rtable[24] := ce_string ("\[pattern]")
			ex_cmds_inst.rtable[25] := ce_string ("\\bar")
			ex_cmds_inst.rtable[26] := ce_string ("/\\%%\$")
			ex_cmds_inst.first_sign.ce_gets (create {CE_POINTER [PD_SIGN]}.make_shared (default_pointer))
			ex_cmds_inst.last_sign_typenr := 65535
			ex_cmds_inst.cmds[0] := ce_string ("define")
			ex_cmds_inst.cmds[1] := ce_string ("undefine")
			ex_cmds_inst.cmds[2] := ce_string ("list")
			ex_cmds_inst.cmds[3] := ce_string ("place")
			ex_cmds_inst.cmds[4] := ce_string ("unplace")
			ex_cmds_inst.cmds[5] := ce_string ("jump")
			ex_cmds_inst.cmds[6] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			ex_cmds2_inst.script_items.ga_len := 0
			ex_cmds2_inst.script_items.ga_maxlen := 0
			ex_cmds2_inst.script_items.ga_itemsize := ({PD_SCRIPTITEM_S}.sizeof.to_natural_32).to_integer_32
			ex_cmds2_inst.script_items.ga_growsize := 4
			ex_cmds2_inst.script_items.ga_data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			ex_cmds2_inst.debug_greedy := 0
			ex_cmds2_inst.last_cmd := 0
			ex_cmds2_inst.debug_breakpoint_name.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			ex_cmds2_inst.dbg_breakp.ga_len := 0
			ex_cmds2_inst.dbg_breakp.ga_maxlen := 0
			ex_cmds2_inst.dbg_breakp.ga_itemsize := ({PD_DEBUGGY}.sizeof.to_natural_32).to_integer_32
			ex_cmds2_inst.dbg_breakp.ga_growsize := 4
			ex_cmds2_inst.dbg_breakp.ga_data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			ex_cmds2_inst.last_breakp := 0
			ex_cmds2_inst.last_current_SID := 0
			ex_docmd_inst.quitmore := 0
			ex_docmd_inst.ex_pressedreturn := 0
			ex_docmd_inst.ucmds.ga_len := 0
			ex_docmd_inst.ucmds.ga_maxlen := 0
			ex_docmd_inst.ucmds.ga_itemsize := ({PD_UCMD}.sizeof.to_natural_32).to_integer_32
			ex_docmd_inst.ucmds.ga_growsize := 4
			ex_docmd_inst.ucmds.ga_data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			ex_cmds_inst.cmdnames[0].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("append"))
			ex_cmds_inst.cmdnames[0].cmd_func := ex_cmds_inst.ex_append_address
			ex_cmds_inst.cmdnames[0].cmd_argt := (3150083).to_natural_32
			ex_cmds_inst.cmdnames[1].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("abbreviate"))
			ex_cmds_inst.cmdnames[1].cmd_func := ex_docmd_inst.ex_abbreviate_address
			ex_cmds_inst.cmdnames[1].cmd_argt := (1059076).to_natural_32
			ex_cmds_inst.cmdnames[2].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("abclear"))
			ex_cmds_inst.cmdnames[2].cmd_func := ex_docmd_inst.ex_abclear_address
			ex_cmds_inst.cmdnames[2].cmd_argt := (1048836).to_natural_32
			ex_cmds_inst.cmdnames[3].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("aboveleft"))
			ex_cmds_inst.cmdnames[3].cmd_func := ex_docmd_inst.ex_wrongmodifier_address
			ex_cmds_inst.cmdnames[3].cmd_argt := (2180).to_natural_32
			ex_cmds_inst.cmdnames[4].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("all"))
			ex_cmds_inst.cmdnames[4].cmd_func := ex_docmd_inst.ex_all_address
			ex_cmds_inst.cmdnames[4].cmd_argt := (17665).to_natural_32
			ex_cmds_inst.cmdnames[5].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("amenu"))
			ex_cmds_inst.cmdnames[5].cmd_func := menu_inst.ex_menu_address
			ex_cmds_inst.cmdnames[5].cmd_argt := (1079557).to_natural_32
			ex_cmds_inst.cmdnames[6].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("anoremenu"))
			ex_cmds_inst.cmdnames[6].cmd_func := menu_inst.ex_menu_address
			ex_cmds_inst.cmdnames[6].cmd_argt := (1079557).to_natural_32
			ex_cmds_inst.cmdnames[7].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("args"))
			ex_cmds_inst.cmdnames[7].cmd_func := ex_cmds2_inst.ex_args_address
			ex_cmds_inst.cmdnames[7].cmd_argt := (295182).to_natural_32
			ex_cmds_inst.cmdnames[8].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("argadd"))
			ex_cmds_inst.cmdnames[8].cmd_func := ex_cmds2_inst.ex_argadd_address
			ex_cmds_inst.cmdnames[8].cmd_argt := (20879).to_natural_32
			ex_cmds_inst.cmdnames[9].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("argdelete"))
			ex_cmds_inst.cmdnames[9].cmd_func := ex_cmds2_inst.ex_argdelete_address
			ex_cmds_inst.cmdnames[9].cmd_argt := (16655).to_natural_32
			ex_cmds_inst.cmdnames[10].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("argdo"))
			ex_cmds_inst.cmdnames[10].cmd_func := ex_cmds2_inst.ex_listdo_address
			ex_cmds_inst.cmdnames[10].cmd_argt := (2182).to_natural_32
			ex_cmds_inst.cmdnames[11].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("argedit"))
			ex_cmds_inst.cmdnames[11].cmd_func := ex_cmds2_inst.ex_argedit_address
			ex_cmds_inst.cmdnames[11].cmd_argt := (311711).to_natural_32
			ex_cmds_inst.cmdnames[12].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("argglobal"))
			ex_cmds_inst.cmdnames[12].cmd_func := ex_cmds2_inst.ex_args_address
			ex_cmds_inst.cmdnames[12].cmd_argt := (295182).to_natural_32
			ex_cmds_inst.cmdnames[13].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("arglocal"))
			ex_cmds_inst.cmdnames[13].cmd_func := ex_cmds2_inst.ex_args_address
			ex_cmds_inst.cmdnames[13].cmd_argt := (295182).to_natural_32
			ex_cmds_inst.cmdnames[14].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("argument"))
			ex_cmds_inst.cmdnames[14].cmd_func := ex_cmds2_inst.ex_argument_address
			ex_cmds_inst.cmdnames[14].cmd_argt := (312583).to_natural_32
			ex_cmds_inst.cmdnames[15].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ascii"))
			ex_cmds_inst.cmdnames[15].cmd_func := ex_cmds_inst.do_ascii_address
			ex_cmds_inst.cmdnames[15].cmd_argt := (1573120).to_natural_32
			ex_cmds_inst.cmdnames[16].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("autocmd"))
			ex_cmds_inst.cmdnames[16].cmd_func := ex_docmd_inst.ex_autocmd_address
			ex_cmds_inst.cmdnames[16].cmd_argt := (1058822).to_natural_32
			ex_cmds_inst.cmdnames[17].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("augroup"))
			ex_cmds_inst.cmdnames[17].cmd_func := ex_docmd_inst.ex_autocmd_address
			ex_cmds_inst.cmdnames[17].cmd_argt := (1048854).to_natural_32
			ex_cmds_inst.cmdnames[18].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("aunmenu"))
			ex_cmds_inst.cmdnames[18].cmd_func := menu_inst.ex_menu_address
			ex_cmds_inst.cmdnames[18].cmd_argt := (1059076).to_natural_32
			ex_cmds_inst.cmdnames[19].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("buffer"))
			ex_cmds_inst.cmdnames[19].cmd_func := ex_docmd_inst.ex_buffer_address
			ex_cmds_inst.cmdnames[19].cmd_argt := (214279).to_natural_32
			ex_cmds_inst.cmdnames[20].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bNext"))
			ex_cmds_inst.cmdnames[20].cmd_func := ex_docmd_inst.ex_bprevious_address
			ex_cmds_inst.cmdnames[20].cmd_argt := (17667).to_natural_32
			ex_cmds_inst.cmdnames[21].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ball"))
			ex_cmds_inst.cmdnames[21].cmd_func := buffer_inst.ex_buffer_all_address
			ex_cmds_inst.cmdnames[21].cmd_argt := (17665).to_natural_32
			ex_cmds_inst.cmdnames[22].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("badd"))
			ex_cmds_inst.cmdnames[22].cmd_func := ex_docmd_inst.ex_edit_address
			ex_cmds_inst.cmdnames[22].cmd_argt := (1081756).to_natural_32
			ex_cmds_inst.cmdnames[23].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bdelete"))
			ex_cmds_inst.cmdnames[23].cmd_func := ex_docmd_inst.ex_bunload_address
			ex_cmds_inst.cmdnames[23].cmd_argt := (83207).to_natural_32
			ex_cmds_inst.cmdnames[24].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("behave"))
			ex_cmds_inst.cmdnames[24].cmd_func := ex_docmd_inst.ex_behave_address
			ex_cmds_inst.cmdnames[24].cmd_argt := (1048980).to_natural_32
			ex_cmds_inst.cmdnames[25].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("belowright"))
			ex_cmds_inst.cmdnames[25].cmd_func := ex_docmd_inst.ex_wrongmodifier_address
			ex_cmds_inst.cmdnames[25].cmd_argt := (2180).to_natural_32
			ex_cmds_inst.cmdnames[26].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bfirst"))
			ex_cmds_inst.cmdnames[26].cmd_func := ex_docmd_inst.ex_brewind_address
			ex_cmds_inst.cmdnames[26].cmd_argt := (16643).to_natural_32
			ex_cmds_inst.cmdnames[27].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("blast"))
			ex_cmds_inst.cmdnames[27].cmd_func := ex_docmd_inst.ex_blast_address
			ex_cmds_inst.cmdnames[27].cmd_argt := (16643).to_natural_32
			ex_cmds_inst.cmdnames[28].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bmodified"))
			ex_cmds_inst.cmdnames[28].cmd_func := ex_docmd_inst.ex_bmodified_address
			ex_cmds_inst.cmdnames[28].cmd_argt := (17667).to_natural_32
			ex_cmds_inst.cmdnames[29].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bnext"))
			ex_cmds_inst.cmdnames[29].cmd_func := ex_docmd_inst.ex_bnext_address
			ex_cmds_inst.cmdnames[29].cmd_argt := (17667).to_natural_32
			ex_cmds_inst.cmdnames[30].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("botright"))
			ex_cmds_inst.cmdnames[30].cmd_func := ex_docmd_inst.ex_wrongmodifier_address
			ex_cmds_inst.cmdnames[30].cmd_argt := (2180).to_natural_32
			ex_cmds_inst.cmdnames[31].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bprevious"))
			ex_cmds_inst.cmdnames[31].cmd_func := ex_docmd_inst.ex_bprevious_address
			ex_cmds_inst.cmdnames[31].cmd_argt := (17667).to_natural_32
			ex_cmds_inst.cmdnames[32].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("brewind"))
			ex_cmds_inst.cmdnames[32].cmd_func := ex_docmd_inst.ex_brewind_address
			ex_cmds_inst.cmdnames[32].cmd_argt := (16643).to_natural_32
			ex_cmds_inst.cmdnames[33].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("break"))
			ex_cmds_inst.cmdnames[33].cmd_func := ex_eval_inst.ex_break_address
			ex_cmds_inst.cmdnames[33].cmd_argt := (1573120).to_natural_32
			ex_cmds_inst.cmdnames[34].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("breakadd"))
			ex_cmds_inst.cmdnames[34].cmd_func := ex_cmds2_inst.ex_breakadd_address
			ex_cmds_inst.cmdnames[34].cmd_argt := (1048836).to_natural_32
			ex_cmds_inst.cmdnames[35].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("breakdel"))
			ex_cmds_inst.cmdnames[35].cmd_func := ex_cmds2_inst.ex_breakdel_address
			ex_cmds_inst.cmdnames[35].cmd_argt := (1048836).to_natural_32
			ex_cmds_inst.cmdnames[36].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("breaklist"))
			ex_cmds_inst.cmdnames[36].cmd_func := ex_cmds2_inst.ex_breaklist_address
			ex_cmds_inst.cmdnames[36].cmd_argt := (1048836).to_natural_32
			ex_cmds_inst.cmdnames[37].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("browse"))
			ex_cmds_inst.cmdnames[37].cmd_func := ex_docmd_inst.ex_wrongmodifier_address
			ex_cmds_inst.cmdnames[37].cmd_argt := (1050756).to_natural_32
			ex_cmds_inst.cmdnames[38].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("buffers"))
			ex_cmds_inst.cmdnames[38].cmd_func := buffer_inst.buflist_list_address
			ex_cmds_inst.cmdnames[38].cmd_argt := (1048834).to_natural_32
			ex_cmds_inst.cmdnames[39].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bufdo"))
			ex_cmds_inst.cmdnames[39].cmd_func := ex_cmds2_inst.ex_listdo_address
			ex_cmds_inst.cmdnames[39].cmd_argt := (2182).to_natural_32
			ex_cmds_inst.cmdnames[40].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bunload"))
			ex_cmds_inst.cmdnames[40].cmd_func := ex_docmd_inst.ex_bunload_address
			ex_cmds_inst.cmdnames[40].cmd_argt := (83207).to_natural_32
			ex_cmds_inst.cmdnames[41].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bwipeout"))
			ex_cmds_inst.cmdnames[41].cmd_func := ex_docmd_inst.ex_bunload_address
			ex_cmds_inst.cmdnames[41].cmd_argt := (214279).to_natural_32
			ex_cmds_inst.cmdnames[42].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("change"))
			ex_cmds_inst.cmdnames[42].cmd_func := ex_cmds_inst.ex_change_address
			ex_cmds_inst.cmdnames[42].cmd_argt := (3147075).to_natural_32
			ex_cmds_inst.cmdnames[43].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cNext"))
			ex_cmds_inst.cmdnames[43].cmd_func := quickfix_inst.ex_cnext_address
			ex_cmds_inst.cmdnames[43].cmd_argt := (17667).to_natural_32
			ex_cmds_inst.cmdnames[44].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cNfile"))
			ex_cmds_inst.cmdnames[44].cmd_func := quickfix_inst.ex_cnext_address
			ex_cmds_inst.cmdnames[44].cmd_argt := (17667).to_natural_32
			ex_cmds_inst.cmdnames[45].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cabbrev"))
			ex_cmds_inst.cmdnames[45].cmd_func := ex_docmd_inst.ex_abbreviate_address
			ex_cmds_inst.cmdnames[45].cmd_argt := (1059076).to_natural_32
			ex_cmds_inst.cmdnames[46].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cabclear"))
			ex_cmds_inst.cmdnames[46].cmd_func := ex_docmd_inst.ex_abclear_address
			ex_cmds_inst.cmdnames[46].cmd_argt := (1048836).to_natural_32
			ex_cmds_inst.cmdnames[47].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("caddbuffer"))
			ex_cmds_inst.cmdnames[47].cmd_func := quickfix_inst.ex_cbuffer_address
			ex_cmds_inst.cmdnames[47].cmd_argt := (16661).to_natural_32
			ex_cmds_inst.cmdnames[48].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("caddexpr"))
			ex_cmds_inst.cmdnames[48].cmd_func := quickfix_inst.ex_cexpr_address
			ex_cmds_inst.cmdnames[48].cmd_argt := (2452).to_natural_32
			ex_cmds_inst.cmdnames[49].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("caddfile"))
			ex_cmds_inst.cmdnames[49].cmd_func := quickfix_inst.ex_cfile_address
			ex_cmds_inst.cmdnames[49].cmd_argt := (284).to_natural_32
			ex_cmds_inst.cmdnames[50].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("call"))
			ex_cmds_inst.cmdnames[50].cmd_func := eval_inst.ex_call_address
			ex_cmds_inst.cmdnames[50].cmd_argt := (1575045).to_natural_32
			ex_cmds_inst.cmdnames[51].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("catch"))
			ex_cmds_inst.cmdnames[51].cmd_func := ex_eval_inst.ex_catch_address
			ex_cmds_inst.cmdnames[51].cmd_argt := (1572868).to_natural_32
			ex_cmds_inst.cmdnames[52].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cbuffer"))
			ex_cmds_inst.cmdnames[52].cmd_func := quickfix_inst.ex_cbuffer_address
			ex_cmds_inst.cmdnames[52].cmd_argt := (16663).to_natural_32
			ex_cmds_inst.cmdnames[53].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cc"))
			ex_cmds_inst.cmdnames[53].cmd_func := quickfix_inst.ex_cc_address
			ex_cmds_inst.cmdnames[53].cmd_argt := (17667).to_natural_32
			ex_cmds_inst.cmdnames[54].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cclose"))
			ex_cmds_inst.cmdnames[54].cmd_func := quickfix_inst.ex_cclose_address
			ex_cmds_inst.cmdnames[54].cmd_argt := (17665).to_natural_32
			ex_cmds_inst.cmdnames[55].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cd"))
			ex_cmds_inst.cmdnames[55].cmd_func := ex_docmd_inst.ex_cd_address
			ex_cmds_inst.cmdnames[55].cmd_argt := (1048862).to_natural_32
			ex_cmds_inst.cmdnames[56].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("center"))
			ex_cmds_inst.cmdnames[56].cmd_func := ex_cmds_inst.ex_align_address
			ex_cmds_inst.cmdnames[56].cmd_argt := (3146053).to_natural_32
			ex_cmds_inst.cmdnames[57].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cexpr"))
			ex_cmds_inst.cmdnames[57].cmd_func := quickfix_inst.ex_cexpr_address
			ex_cmds_inst.cmdnames[57].cmd_argt := (2454).to_natural_32
			ex_cmds_inst.cmdnames[58].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cfile"))
			ex_cmds_inst.cmdnames[58].cmd_func := quickfix_inst.ex_cfile_address
			ex_cmds_inst.cmdnames[58].cmd_argt := (286).to_natural_32
			ex_cmds_inst.cmdnames[59].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cfirst"))
			ex_cmds_inst.cmdnames[59].cmd_func := quickfix_inst.ex_cc_address
			ex_cmds_inst.cmdnames[59].cmd_argt := (17667).to_natural_32
			ex_cmds_inst.cmdnames[60].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cgetfile"))
			ex_cmds_inst.cmdnames[60].cmd_func := quickfix_inst.ex_cfile_address
			ex_cmds_inst.cmdnames[60].cmd_argt := (284).to_natural_32
			ex_cmds_inst.cmdnames[61].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cgetbuffer"))
			ex_cmds_inst.cmdnames[61].cmd_func := quickfix_inst.ex_cbuffer_address
			ex_cmds_inst.cmdnames[61].cmd_argt := (16661).to_natural_32
			ex_cmds_inst.cmdnames[62].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cgetexpr"))
			ex_cmds_inst.cmdnames[62].cmd_func := quickfix_inst.ex_cexpr_address
			ex_cmds_inst.cmdnames[62].cmd_argt := (2452).to_natural_32
			ex_cmds_inst.cmdnames[63].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("chdir"))
			ex_cmds_inst.cmdnames[63].cmd_func := ex_docmd_inst.ex_cd_address
			ex_cmds_inst.cmdnames[63].cmd_argt := (1048862).to_natural_32
			ex_cmds_inst.cmdnames[64].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("changes"))
			ex_cmds_inst.cmdnames[64].cmd_func := mark_inst.ex_changes_address
			ex_cmds_inst.cmdnames[64].cmd_argt := (1048832).to_natural_32
			ex_cmds_inst.cmdnames[65].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("checkpath"))
			ex_cmds_inst.cmdnames[65].cmd_func := ex_docmd_inst.ex_checkpath_address
			ex_cmds_inst.cmdnames[65].cmd_argt := (1048834).to_natural_32
			ex_cmds_inst.cmdnames[66].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("checktime"))
			ex_cmds_inst.cmdnames[66].cmd_func := ex_cmds2_inst.ex_checktime_address
			ex_cmds_inst.cmdnames[66].cmd_argt := (83205).to_natural_32
			ex_cmds_inst.cmdnames[67].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("clist"))
			ex_cmds_inst.cmdnames[67].cmd_func := quickfix_inst.qf_list_address
			ex_cmds_inst.cmdnames[67].cmd_argt := (1048838).to_natural_32
			ex_cmds_inst.cmdnames[68].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("clast"))
			ex_cmds_inst.cmdnames[68].cmd_func := quickfix_inst.ex_cc_address
			ex_cmds_inst.cmdnames[68].cmd_argt := (17667).to_natural_32
			ex_cmds_inst.cmdnames[69].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("close"))
			ex_cmds_inst.cmdnames[69].cmd_func := ex_docmd_inst.ex_close_address
			ex_cmds_inst.cmdnames[69].cmd_argt := (1048834).to_natural_32
			ex_cmds_inst.cmdnames[70].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cmap"))
			ex_cmds_inst.cmdnames[70].cmd_func := ex_docmd_inst.ex_map_address
			ex_cmds_inst.cmdnames[70].cmd_argt := (1059076).to_natural_32
			ex_cmds_inst.cmdnames[71].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cmapclear"))
			ex_cmds_inst.cmdnames[71].cmd_func := ex_docmd_inst.ex_mapclear_address
			ex_cmds_inst.cmdnames[71].cmd_argt := (1048836).to_natural_32
			ex_cmds_inst.cmdnames[72].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cmenu"))
			ex_cmds_inst.cmdnames[72].cmd_func := menu_inst.ex_menu_address
			ex_cmds_inst.cmdnames[72].cmd_argt := (1079557).to_natural_32
			ex_cmds_inst.cmdnames[73].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cnext"))
			ex_cmds_inst.cmdnames[73].cmd_func := quickfix_inst.ex_cnext_address
			ex_cmds_inst.cmdnames[73].cmd_argt := (17667).to_natural_32
			ex_cmds_inst.cmdnames[74].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cnewer"))
			ex_cmds_inst.cmdnames[74].cmd_func := quickfix_inst.qf_age_address
			ex_cmds_inst.cmdnames[74].cmd_argt := (17665).to_natural_32
			ex_cmds_inst.cmdnames[75].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cnfile"))
			ex_cmds_inst.cmdnames[75].cmd_func := quickfix_inst.ex_cnext_address
			ex_cmds_inst.cmdnames[75].cmd_argt := (17667).to_natural_32
			ex_cmds_inst.cmdnames[76].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cnoremap"))
			ex_cmds_inst.cmdnames[76].cmd_func := ex_docmd_inst.ex_map_address
			ex_cmds_inst.cmdnames[76].cmd_argt := (1059076).to_natural_32
			ex_cmds_inst.cmdnames[77].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cnoreabbrev"))
			ex_cmds_inst.cmdnames[77].cmd_func := ex_docmd_inst.ex_abbreviate_address
			ex_cmds_inst.cmdnames[77].cmd_argt := (1059076).to_natural_32
			ex_cmds_inst.cmdnames[78].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cnoremenu"))
			ex_cmds_inst.cmdnames[78].cmd_func := menu_inst.ex_menu_address
			ex_cmds_inst.cmdnames[78].cmd_argt := (1079557).to_natural_32
			ex_cmds_inst.cmdnames[79].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("copy"))
			ex_cmds_inst.cmdnames[79].cmd_func := ex_docmd_inst.ex_copymove_address
			ex_cmds_inst.cmdnames[79].cmd_argt := (3146053).to_natural_32
			ex_cmds_inst.cmdnames[80].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("colder"))
			ex_cmds_inst.cmdnames[80].cmd_func := quickfix_inst.qf_age_address
			ex_cmds_inst.cmdnames[80].cmd_argt := (17665).to_natural_32
			ex_cmds_inst.cmdnames[81].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("colorscheme"))
			ex_cmds_inst.cmdnames[81].cmd_func := ex_docmd_inst.ex_colorscheme_address
			ex_cmds_inst.cmdnames[81].cmd_argt := (1048852).to_natural_32
			ex_cmds_inst.cmdnames[82].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("command"))
			ex_cmds_inst.cmdnames[82].cmd_func := ex_docmd_inst.ex_command_address
			ex_cmds_inst.cmdnames[82].cmd_argt := (1058822).to_natural_32
			ex_cmds_inst.cmdnames[83].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("comclear"))
			ex_cmds_inst.cmdnames[83].cmd_func := ex_docmd_inst.ex_comclear_address
			ex_cmds_inst.cmdnames[83].cmd_argt := (1048832).to_natural_32
			ex_cmds_inst.cmdnames[84].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("compiler"))
			ex_cmds_inst.cmdnames[84].cmd_func := ex_cmds2_inst.ex_compiler_address
			ex_cmds_inst.cmdnames[84].cmd_argt := (1048854).to_natural_32
			ex_cmds_inst.cmdnames[85].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("continue"))
			ex_cmds_inst.cmdnames[85].cmd_func := ex_eval_inst.ex_continue_address
			ex_cmds_inst.cmdnames[85].cmd_argt := (1573120).to_natural_32
			ex_cmds_inst.cmdnames[86].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("confirm"))
			ex_cmds_inst.cmdnames[86].cmd_func := ex_docmd_inst.ex_wrongmodifier_address
			ex_cmds_inst.cmdnames[86].cmd_argt := (1050756).to_natural_32
			ex_cmds_inst.cmdnames[87].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("copen"))
			ex_cmds_inst.cmdnames[87].cmd_func := quickfix_inst.ex_copen_address
			ex_cmds_inst.cmdnames[87].cmd_argt := (17665).to_natural_32
			ex_cmds_inst.cmdnames[88].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cprevious"))
			ex_cmds_inst.cmdnames[88].cmd_func := quickfix_inst.ex_cnext_address
			ex_cmds_inst.cmdnames[88].cmd_argt := (17667).to_natural_32
			ex_cmds_inst.cmdnames[89].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cpfile"))
			ex_cmds_inst.cmdnames[89].cmd_func := quickfix_inst.ex_cnext_address
			ex_cmds_inst.cmdnames[89].cmd_argt := (17667).to_natural_32
			ex_cmds_inst.cmdnames[90].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cquit"))
			ex_cmds_inst.cmdnames[90].cmd_func := ex_docmd_inst.ex_cquit_address
			ex_cmds_inst.cmdnames[90].cmd_argt := (258).to_natural_32
			ex_cmds_inst.cmdnames[91].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("crewind"))
			ex_cmds_inst.cmdnames[91].cmd_func := quickfix_inst.ex_cc_address
			ex_cmds_inst.cmdnames[91].cmd_argt := (17667).to_natural_32
			ex_cmds_inst.cmdnames[92].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cscope"))
			ex_cmds_inst.cmdnames[92].cmd_func := ex_docmd_inst.ex_ni_address
			ex_cmds_inst.cmdnames[92].cmd_argt := (2060).to_natural_32
			ex_cmds_inst.cmdnames[93].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cstag"))
			ex_cmds_inst.cmdnames[93].cmd_func := ex_docmd_inst.ex_ni_address
			ex_cmds_inst.cmdnames[93].cmd_argt := (278).to_natural_32
			ex_cmds_inst.cmdnames[94].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cunmap"))
			ex_cmds_inst.cmdnames[94].cmd_func := ex_docmd_inst.ex_unmap_address
			ex_cmds_inst.cmdnames[94].cmd_argt := (1059076).to_natural_32
			ex_cmds_inst.cmdnames[95].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cunabbrev"))
			ex_cmds_inst.cmdnames[95].cmd_func := ex_docmd_inst.ex_abbreviate_address
			ex_cmds_inst.cmdnames[95].cmd_argt := (1059076).to_natural_32
			ex_cmds_inst.cmdnames[96].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cunmenu"))
			ex_cmds_inst.cmdnames[96].cmd_func := menu_inst.ex_menu_address
			ex_cmds_inst.cmdnames[96].cmd_argt := (1059076).to_natural_32
			ex_cmds_inst.cmdnames[97].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cwindow"))
			ex_cmds_inst.cmdnames[97].cmd_func := quickfix_inst.ex_cwindow_address
			ex_cmds_inst.cmdnames[97].cmd_argt := (17665).to_natural_32
			ex_cmds_inst.cmdnames[98].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("delete"))
			ex_cmds_inst.cmdnames[98].cmd_func := ex_docmd_inst.ex_operators_address
			ex_cmds_inst.cmdnames[98].cmd_argt := (3147585).to_natural_32
			ex_cmds_inst.cmdnames[99].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("delmarks"))
		end

end
