frozen class
	VIM_INITIALIZER_SLICE20

inherit
	VIM_DATA
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {VIM_INITIALIZER}

	initialize
		do
			ex_getln_inst.tab[11].ic := 0
			ex_getln_inst.tab[12].context := 12
			ex_getln_inst.tab[12].func := syntax_inst.get_syntax_name_address
			ex_getln_inst.tab[12].ic := 1
			ex_getln_inst.tab[13].context := 13
			ex_getln_inst.tab[13].func := syntax_inst.get_highlight_name_address
			ex_getln_inst.tab[13].ic := 1
			ex_getln_inst.tab[14].context := 10
			ex_getln_inst.tab[14].func := fileio_inst.get_event_name_address
			ex_getln_inst.tab[14].ic := 1
			ex_getln_inst.tab[15].context := 14
			ex_getln_inst.tab[15].func := fileio_inst.get_augroup_name_address
			ex_getln_inst.tab[15].ic := 1
			ex_getln_inst.tab[16].context := 34
			ex_getln_inst.tab[16].func := ex_cmds_inst.get_sign_name_address
			ex_getln_inst.tab[16].ic := 1
			ex_getln_inst.tab[17].context := 27
			ex_getln_inst.tab[17].func := ex_cmds2_inst.get_lang_arg_address
			ex_getln_inst.tab[17].ic := 1
			ex_getln_inst.tab[18].context := 26
			ex_getln_inst.tab[18].func := misc1_inst.get_env_name_address
			ex_getln_inst.tab[18].ic := 1
			ex_getln_inst.history_names[0] := ce_string ("cmd")
			ex_getln_inst.history_names[1] := ce_string ("search")
			ex_getln_inst.history_names[2] := ce_string ("expr")
			ex_getln_inst.history_names[3] := ce_string ("input")
			ex_getln_inst.history_names[4] := ce_string ("debug")
			ex_getln_inst.history_names[5] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			ex_getln_inst.last_maptick := -1
			ex_getln_inst.viminfo_history[0] := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
			ex_getln_inst.viminfo_history[1] := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
			ex_getln_inst.viminfo_history[2] := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
			ex_getln_inst.viminfo_history[3] := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
			ex_getln_inst.viminfo_history[4] := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
			ex_getln_inst.viminfo_hisidx[0] := 0
			ex_getln_inst.viminfo_hisidx[1] := 0
			ex_getln_inst.viminfo_hisidx[2] := 0
			ex_getln_inst.viminfo_hisidx[3] := 0
			ex_getln_inst.viminfo_hisidx[4] := 0
			ex_getln_inst.viminfo_hislen[0] := 0
			ex_getln_inst.viminfo_hislen[1] := 0
			ex_getln_inst.viminfo_hislen[2] := 0
			ex_getln_inst.viminfo_hislen[3] := 0
			ex_getln_inst.viminfo_hislen[4] := 0
			ex_getln_inst.viminfo_add_at_front := 0
			fileio_inst.crypt_magic[0] := ce_string ("VimCrypt~01!")
			fileio_inst.crypt_magic[1] := ce_string ("VimCrypt~02!")
			across "VimCrypt~%/0/" as c loop fileio_inst.crypt_magic_head[c.target_index - 1] := c.item.code.to_integer_8 end
			fileio_inst.crypt_salt_len[0] := 0
			fileio_inst.crypt_salt_len[1] := 8
			fileio_inst.crypt_seed_len[0] := 0
			fileio_inst.crypt_seed_len[1] := 8
			fileio_inst.e_auchangedbuf.ce_gets (ce_string ("E812: Autocommands changed buffer or buffer name"))
			fileio_inst.err_readonly.ce_gets (ce_string ("is read-only (cannot override: %"W%" in %'cpoptions%')"))
			fileio_inst.already_warned := 0
			fileio_inst.busy := 0
			fileio_inst.temp_count := 0
			fileio_inst.tempdirs[0] := ce_string ("$TMPDIR")
			fileio_inst.tempdirs[1] := ce_string ("/tmp")
			fileio_inst.tempdirs[2] := ce_string (".")
			fileio_inst.tempdirs[3] := ce_string ("$HOME")
			fileio_inst.event_names[0].name := ce_string ("BufAdd")
			fileio_inst.event_names[0].event := {PC_AUTO_EVENT}.EVENT_BUFADD
			fileio_inst.event_names[1].name := ce_string ("BufCreate")
			fileio_inst.event_names[1].event := {PC_AUTO_EVENT}.EVENT_BUFADD
			fileio_inst.event_names[2].name := ce_string ("BufDelete")
			fileio_inst.event_names[2].event := {PC_AUTO_EVENT}.EVENT_BUFDELETE
			fileio_inst.event_names[3].name := ce_string ("BufEnter")
			fileio_inst.event_names[3].event := {PC_AUTO_EVENT}.EVENT_BUFENTER
			fileio_inst.event_names[4].name := ce_string ("BufFilePost")
			fileio_inst.event_names[4].event := {PC_AUTO_EVENT}.EVENT_BUFFILEPOST
			fileio_inst.event_names[5].name := ce_string ("BufFilePre")
			fileio_inst.event_names[5].event := {PC_AUTO_EVENT}.EVENT_BUFFILEPRE
			fileio_inst.event_names[6].name := ce_string ("BufHidden")
			fileio_inst.event_names[6].event := {PC_AUTO_EVENT}.EVENT_BUFHIDDEN
			fileio_inst.event_names[7].name := ce_string ("BufLeave")
			fileio_inst.event_names[7].event := {PC_AUTO_EVENT}.EVENT_BUFLEAVE
			fileio_inst.event_names[8].name := ce_string ("BufNew")
			fileio_inst.event_names[8].event := {PC_AUTO_EVENT}.EVENT_BUFNEW
			fileio_inst.event_names[9].name := ce_string ("BufNewFile")
			fileio_inst.event_names[9].event := {PC_AUTO_EVENT}.EVENT_BUFNEWFILE
			fileio_inst.event_names[10].name := ce_string ("BufRead")
			fileio_inst.event_names[10].event := {PC_AUTO_EVENT}.EVENT_BUFREADPOST
			fileio_inst.event_names[11].name := ce_string ("BufReadCmd")
			fileio_inst.event_names[11].event := {PC_AUTO_EVENT}.EVENT_BUFREADCMD
			fileio_inst.event_names[12].name := ce_string ("BufReadPost")
			fileio_inst.event_names[12].event := {PC_AUTO_EVENT}.EVENT_BUFREADPOST
			fileio_inst.event_names[13].name := ce_string ("BufReadPre")
			fileio_inst.event_names[13].event := {PC_AUTO_EVENT}.EVENT_BUFREADPRE
			fileio_inst.event_names[14].name := ce_string ("BufUnload")
			fileio_inst.event_names[14].event := {PC_AUTO_EVENT}.EVENT_BUFUNLOAD
			fileio_inst.event_names[15].name := ce_string ("BufWinEnter")
			fileio_inst.event_names[15].event := {PC_AUTO_EVENT}.EVENT_BUFWINENTER
			fileio_inst.event_names[16].name := ce_string ("BufWinLeave")
			fileio_inst.event_names[16].event := {PC_AUTO_EVENT}.EVENT_BUFWINLEAVE
			fileio_inst.event_names[17].name := ce_string ("BufWipeout")
			fileio_inst.event_names[17].event := {PC_AUTO_EVENT}.EVENT_BUFWIPEOUT
			fileio_inst.event_names[18].name := ce_string ("BufWrite")
			fileio_inst.event_names[18].event := {PC_AUTO_EVENT}.EVENT_BUFWRITEPRE
			fileio_inst.event_names[19].name := ce_string ("BufWritePost")
			fileio_inst.event_names[19].event := {PC_AUTO_EVENT}.EVENT_BUFWRITEPOST
			fileio_inst.event_names[20].name := ce_string ("BufWritePre")
			fileio_inst.event_names[20].event := {PC_AUTO_EVENT}.EVENT_BUFWRITEPRE
			fileio_inst.event_names[21].name := ce_string ("BufWriteCmd")
			fileio_inst.event_names[21].event := {PC_AUTO_EVENT}.EVENT_BUFWRITECMD
			fileio_inst.event_names[22].name := ce_string ("CmdwinEnter")
			fileio_inst.event_names[22].event := {PC_AUTO_EVENT}.EVENT_CMDWINENTER
			fileio_inst.event_names[23].name := ce_string ("CmdwinLeave")
			fileio_inst.event_names[23].event := {PC_AUTO_EVENT}.EVENT_CMDWINLEAVE
			fileio_inst.event_names[24].name := ce_string ("ColorScheme")
			fileio_inst.event_names[24].event := {PC_AUTO_EVENT}.EVENT_COLORSCHEME
			fileio_inst.event_names[25].name := ce_string ("CursorHold")
			fileio_inst.event_names[25].event := {PC_AUTO_EVENT}.EVENT_CURSORHOLD
			fileio_inst.event_names[26].name := ce_string ("CursorHoldI")
			fileio_inst.event_names[26].event := {PC_AUTO_EVENT}.EVENT_CURSORHOLDI
			fileio_inst.event_names[27].name := ce_string ("CursorMoved")
			fileio_inst.event_names[27].event := {PC_AUTO_EVENT}.EVENT_CURSORMOVED
			fileio_inst.event_names[28].name := ce_string ("CursorMovedI")
			fileio_inst.event_names[28].event := {PC_AUTO_EVENT}.EVENT_CURSORMOVEDI
			fileio_inst.event_names[29].name := ce_string ("EncodingChanged")
			fileio_inst.event_names[29].event := {PC_AUTO_EVENT}.EVENT_ENCODINGCHANGED
			fileio_inst.event_names[30].name := ce_string ("FileEncoding")
			fileio_inst.event_names[30].event := {PC_AUTO_EVENT}.EVENT_ENCODINGCHANGED
			fileio_inst.event_names[31].name := ce_string ("FileAppendPost")
			fileio_inst.event_names[31].event := {PC_AUTO_EVENT}.EVENT_FILEAPPENDPOST
			fileio_inst.event_names[32].name := ce_string ("FileAppendPre")
			fileio_inst.event_names[32].event := {PC_AUTO_EVENT}.EVENT_FILEAPPENDPRE
			fileio_inst.event_names[33].name := ce_string ("FileAppendCmd")
			fileio_inst.event_names[33].event := {PC_AUTO_EVENT}.EVENT_FILEAPPENDCMD
			fileio_inst.event_names[34].name := ce_string ("FileChangedShell")
			fileio_inst.event_names[34].event := {PC_AUTO_EVENT}.EVENT_FILECHANGEDSHELL
			fileio_inst.event_names[35].name := ce_string ("FileChangedShellPost")
			fileio_inst.event_names[35].event := {PC_AUTO_EVENT}.EVENT_FILECHANGEDSHELLPOST
			fileio_inst.event_names[36].name := ce_string ("FileChangedRO")
			fileio_inst.event_names[36].event := {PC_AUTO_EVENT}.EVENT_FILECHANGEDRO
			fileio_inst.event_names[37].name := ce_string ("FileReadPost")
			fileio_inst.event_names[37].event := {PC_AUTO_EVENT}.EVENT_FILEREADPOST
			fileio_inst.event_names[38].name := ce_string ("FileReadPre")
			fileio_inst.event_names[38].event := {PC_AUTO_EVENT}.EVENT_FILEREADPRE
			fileio_inst.event_names[39].name := ce_string ("FileReadCmd")
			fileio_inst.event_names[39].event := {PC_AUTO_EVENT}.EVENT_FILEREADCMD
			fileio_inst.event_names[40].name := ce_string ("FileType")
			fileio_inst.event_names[40].event := {PC_AUTO_EVENT}.EVENT_FILETYPE
			fileio_inst.event_names[41].name := ce_string ("FileWritePost")
			fileio_inst.event_names[41].event := {PC_AUTO_EVENT}.EVENT_FILEWRITEPOST
			fileio_inst.event_names[42].name := ce_string ("FileWritePre")
			fileio_inst.event_names[42].event := {PC_AUTO_EVENT}.EVENT_FILEWRITEPRE
			fileio_inst.event_names[43].name := ce_string ("FileWriteCmd")
			fileio_inst.event_names[43].event := {PC_AUTO_EVENT}.EVENT_FILEWRITECMD
			fileio_inst.event_names[44].name := ce_string ("FilterReadPost")
			fileio_inst.event_names[44].event := {PC_AUTO_EVENT}.EVENT_FILTERREADPOST
			fileio_inst.event_names[45].name := ce_string ("FilterReadPre")
			fileio_inst.event_names[45].event := {PC_AUTO_EVENT}.EVENT_FILTERREADPRE
			fileio_inst.event_names[46].name := ce_string ("FilterWritePost")
			fileio_inst.event_names[46].event := {PC_AUTO_EVENT}.EVENT_FILTERWRITEPOST
			fileio_inst.event_names[47].name := ce_string ("FilterWritePre")
			fileio_inst.event_names[47].event := {PC_AUTO_EVENT}.EVENT_FILTERWRITEPRE
			fileio_inst.event_names[48].name := ce_string ("FocusGained")
			fileio_inst.event_names[48].event := {PC_AUTO_EVENT}.EVENT_FOCUSGAINED
			fileio_inst.event_names[49].name := ce_string ("FocusLost")
			fileio_inst.event_names[49].event := {PC_AUTO_EVENT}.EVENT_FOCUSLOST
			fileio_inst.event_names[50].name := ce_string ("FuncUndefined")
			fileio_inst.event_names[50].event := {PC_AUTO_EVENT}.EVENT_FUNCUNDEFINED
			fileio_inst.event_names[51].name := ce_string ("GUIEnter")
			fileio_inst.event_names[51].event := {PC_AUTO_EVENT}.EVENT_GUIENTER
			fileio_inst.event_names[52].name := ce_string ("GUIFailed")
			fileio_inst.event_names[52].event := {PC_AUTO_EVENT}.EVENT_GUIFAILED
			fileio_inst.event_names[53].name := ce_string ("InsertChange")
			fileio_inst.event_names[53].event := {PC_AUTO_EVENT}.EVENT_INSERTCHANGE
			fileio_inst.event_names[54].name := ce_string ("InsertEnter")
			fileio_inst.event_names[54].event := {PC_AUTO_EVENT}.EVENT_INSERTENTER
			fileio_inst.event_names[55].name := ce_string ("InsertLeave")
			fileio_inst.event_names[55].event := {PC_AUTO_EVENT}.EVENT_INSERTLEAVE
			fileio_inst.event_names[56].name := ce_string ("MenuPopup")
			fileio_inst.event_names[56].event := {PC_AUTO_EVENT}.EVENT_MENUPOPUP
			fileio_inst.event_names[57].name := ce_string ("QuickFixCmdPost")
			fileio_inst.event_names[57].event := {PC_AUTO_EVENT}.EVENT_QUICKFIXCMDPOST
			fileio_inst.event_names[58].name := ce_string ("QuickFixCmdPre")
			fileio_inst.event_names[58].event := {PC_AUTO_EVENT}.EVENT_QUICKFIXCMDPRE
			fileio_inst.event_names[59].name := ce_string ("RemoteReply")
			fileio_inst.event_names[59].event := {PC_AUTO_EVENT}.EVENT_REMOTEREPLY
			fileio_inst.event_names[60].name := ce_string ("SessionLoadPost")
			fileio_inst.event_names[60].event := {PC_AUTO_EVENT}.EVENT_SESSIONLOADPOST
			fileio_inst.event_names[61].name := ce_string ("ShellCmdPost")
			fileio_inst.event_names[61].event := {PC_AUTO_EVENT}.EVENT_SHELLCMDPOST
			fileio_inst.event_names[62].name := ce_string ("ShellFilterPost")
			fileio_inst.event_names[62].event := {PC_AUTO_EVENT}.EVENT_SHELLFILTERPOST
			fileio_inst.event_names[63].name := ce_string ("SourcePre")
			fileio_inst.event_names[63].event := {PC_AUTO_EVENT}.EVENT_SOURCEPRE
			fileio_inst.event_names[64].name := ce_string ("SourceCmd")
			fileio_inst.event_names[64].event := {PC_AUTO_EVENT}.EVENT_SOURCECMD
			fileio_inst.event_names[65].name := ce_string ("SpellFileMissing")
			fileio_inst.event_names[65].event := {PC_AUTO_EVENT}.EVENT_SPELLFILEMISSING
			fileio_inst.event_names[66].name := ce_string ("StdinReadPost")
			fileio_inst.event_names[66].event := {PC_AUTO_EVENT}.EVENT_STDINREADPOST
			fileio_inst.event_names[67].name := ce_string ("StdinReadPre")
			fileio_inst.event_names[67].event := {PC_AUTO_EVENT}.EVENT_STDINREADPRE
			fileio_inst.event_names[68].name := ce_string ("SwapExists")
			fileio_inst.event_names[68].event := {PC_AUTO_EVENT}.EVENT_SWAPEXISTS
			fileio_inst.event_names[69].name := ce_string ("Syntax")
			fileio_inst.event_names[69].event := {PC_AUTO_EVENT}.EVENT_SYNTAX
			fileio_inst.event_names[70].name := ce_string ("TabEnter")
			fileio_inst.event_names[70].event := {PC_AUTO_EVENT}.EVENT_TABENTER
			fileio_inst.event_names[71].name := ce_string ("TabLeave")
			fileio_inst.event_names[71].event := {PC_AUTO_EVENT}.EVENT_TABLEAVE
			fileio_inst.event_names[72].name := ce_string ("TermChanged")
			fileio_inst.event_names[72].event := {PC_AUTO_EVENT}.EVENT_TERMCHANGED
			fileio_inst.event_names[73].name := ce_string ("TermResponse")
			fileio_inst.event_names[73].event := {PC_AUTO_EVENT}.EVENT_TERMRESPONSE
			fileio_inst.event_names[74].name := ce_string ("User")
			fileio_inst.event_names[74].event := {PC_AUTO_EVENT}.EVENT_USER
			fileio_inst.event_names[75].name := ce_string ("VimEnter")
			fileio_inst.event_names[75].event := {PC_AUTO_EVENT}.EVENT_VIMENTER
			fileio_inst.event_names[76].name := ce_string ("VimLeave")
			fileio_inst.event_names[76].event := {PC_AUTO_EVENT}.EVENT_VIMLEAVE
			fileio_inst.event_names[77].name := ce_string ("VimLeavePre")
			fileio_inst.event_names[77].event := {PC_AUTO_EVENT}.EVENT_VIMLEAVEPRE
			fileio_inst.event_names[78].name := ce_string ("WinEnter")
			fileio_inst.event_names[78].event := {PC_AUTO_EVENT}.EVENT_WINENTER
			fileio_inst.event_names[79].name := ce_string ("WinLeave")
			fileio_inst.event_names[79].event := {PC_AUTO_EVENT}.EVENT_WINLEAVE
			fileio_inst.event_names[80].name := ce_string ("VimResized")
			fileio_inst.event_names[80].event := {PC_AUTO_EVENT}.EVENT_VIMRESIZED
			fileio_inst.event_names[81].name := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			fileio_inst.event_names[81].event := {PC_AUTO_EVENT}.EVENT_BUFADD
			fileio_inst.first_autopat[0] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[1] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[2] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[3] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[4] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[5] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[6] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[7] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[8] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[9] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[10] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[11] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[12] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[13] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[14] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[15] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[16] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[17] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[18] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[19] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[20] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[21] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[22] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[23] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[24] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[25] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[26] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[27] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[28] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[29] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[30] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[31] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[32] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[33] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[34] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[35] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[36] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[37] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[38] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[39] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[40] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[41] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[42] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[43] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[44] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[45] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[46] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[47] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[48] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[49] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[50] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[51] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[52] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[53] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[54] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[55] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[56] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[57] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.first_autopat[58] := create {CE_POINTER [PD_AUTOPAT]}.make_shared (default_pointer)
			fileio_inst.active_apc_list.ce_gets (create {CE_POINTER [PD_AUTOPATCMD]}.make_shared (default_pointer))
			fileio_inst.augroups.ga_len := 0
			fileio_inst.augroups.ga_maxlen := 0
			fileio_inst.augroups.ga_itemsize := (Pointer_bytes.to_natural_32).to_integer_32
			fileio_inst.augroups.ga_growsize := 10
			fileio_inst.augroups.ga_data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			fileio_inst.current_augroup := -1
			fileio_inst.au_need_clean := 0
			fileio_inst.autocmd_blocked := 0
			fileio_inst.autocmd_nested := 0
			fileio_inst.nesting := 0
			fileio_inst.filechangeshell_busy := 0
			fileio_inst.old_termresponse.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			fileio_inst.include_groups := 0
			fold_inst.e_nofold.ce_gets (ce_string ("E490: No fold found"))
			fold_inst.invalid_top := (0).to_integer_32
			fold_inst.invalid_bot := (0).to_integer_32
			fold_inst.prev_lnum___0 := (0).to_integer_32
			fold_inst.prev_lnum_lvl := -1
			getchar_inst.redobuff.bh_first.b_next := create {CE_POINTER [PD_BUFFBLOCK]}.make_shared (default_pointer)
			getchar_inst.redobuff.bh_first.b_str[0] := (('%/0/').code).to_natural_8
			getchar_inst.redobuff.bh_curr := create {CE_POINTER [PD_BUFFBLOCK]}.make_shared (default_pointer)
			getchar_inst.redobuff.bh_index := 0
			getchar_inst.redobuff.bh_space := 0
			getchar_inst.old_redobuff.bh_first.b_next := create {CE_POINTER [PD_BUFFBLOCK]}.make_shared (default_pointer)
			getchar_inst.old_redobuff.bh_first.b_str[0] := (('%/0/').code).to_natural_8
			getchar_inst.old_redobuff.bh_curr := create {CE_POINTER [PD_BUFFBLOCK]}.make_shared (default_pointer)
			getchar_inst.old_redobuff.bh_index := 0
			getchar_inst.old_redobuff.bh_space := 0
			getchar_inst.save_redobuff.bh_first.b_next := create {CE_POINTER [PD_BUFFBLOCK]}.make_shared (default_pointer)
			getchar_inst.save_redobuff.bh_first.b_str[0] := (('%/0/').code).to_natural_8
			getchar_inst.save_redobuff.bh_curr := create {CE_POINTER [PD_BUFFBLOCK]}.make_shared (default_pointer)
			getchar_inst.save_redobuff.bh_index := 0
			getchar_inst.save_redobuff.bh_space := 0
			getchar_inst.save_old_redobuff.bh_first.b_next := create {CE_POINTER [PD_BUFFBLOCK]}.make_shared (default_pointer)
			getchar_inst.save_old_redobuff.bh_first.b_str[0] := (('%/0/').code).to_natural_8
			getchar_inst.save_old_redobuff.bh_curr := create {CE_POINTER [PD_BUFFBLOCK]}.make_shared (default_pointer)
			getchar_inst.save_old_redobuff.bh_index := 0
			getchar_inst.save_old_redobuff.bh_space := 0
			getchar_inst.recordbuff.bh_first.b_next := create {CE_POINTER [PD_BUFFBLOCK]}.make_shared (default_pointer)
			getchar_inst.recordbuff.bh_first.b_str[0] := (('%/0/').code).to_natural_8
			getchar_inst.recordbuff.bh_curr := create {CE_POINTER [PD_BUFFBLOCK]}.make_shared (default_pointer)
			getchar_inst.recordbuff.bh_index := 0
			getchar_inst.recordbuff.bh_space := 0
			getchar_inst.typeahead_char := 0
			getchar_inst.block_redo := 0
			getchar_inst.maphash_valid := 0
			getchar_inst.first_abbr.ce_gets (create {CE_POINTER [PD_MAPBLOCK]}.make_shared (default_pointer))
			getchar_inst.KeyNoremap := 0
			getchar_inst.last_recorded_len := 0
			getchar_inst.save_level := 0
			getchar_inst.old_char := -1
			getchar_inst.count___0 := 0
			getchar_inst.tc := 0
			getchar_inst.expand_mapmodes := 0
			getchar_inst.expand_isabbrev := 0
			getchar_inst.expand_buffer := 0
			hardcopy_inst.cterm_color_8[0] := (0).to_natural_32
			hardcopy_inst.cterm_color_8[1] := (16711680).to_natural_32
			hardcopy_inst.cterm_color_8[2] := (65280).to_natural_32
			hardcopy_inst.cterm_color_8[3] := (16776960).to_natural_32
			hardcopy_inst.cterm_color_8[4] := (255).to_natural_32
			hardcopy_inst.cterm_color_8[5] := (16711935).to_natural_32
			hardcopy_inst.cterm_color_8[6] := (65535).to_natural_32
			hardcopy_inst.cterm_color_8[7] := (16777215).to_natural_32
			hardcopy_inst.cterm_color_16[0] := (0).to_natural_32
			hardcopy_inst.cterm_color_16[1] := (192).to_natural_32
			hardcopy_inst.cterm_color_16[2] := (32768).to_natural_32
			hardcopy_inst.cterm_color_16[3] := (16512).to_natural_32
			hardcopy_inst.cterm_color_16[4] := (12582912).to_natural_32
			hardcopy_inst.cterm_color_16[5] := (12583104).to_natural_32
			hardcopy_inst.cterm_color_16[6] := (8421376).to_natural_32
			hardcopy_inst.cterm_color_16[7] := (12632256).to_natural_32
			hardcopy_inst.cterm_color_16[8] := (8421504).to_natural_32
			hardcopy_inst.cterm_color_16[9] := (6316287).to_natural_32
			hardcopy_inst.cterm_color_16[10] := (65280).to_natural_32
			hardcopy_inst.cterm_color_16[11] := (65535).to_natural_32
			hardcopy_inst.cterm_color_16[12] := (16744576).to_natural_32
			hardcopy_inst.cterm_color_16[13] := (16728319).to_natural_32
			hardcopy_inst.cterm_color_16[14] := (16776960).to_natural_32
			hardcopy_inst.cterm_color_16[15] := (16777215).to_natural_32
			hardcopy_inst.mbfont_opts[0].name := ce_string ("c")
			hardcopy_inst.mbfont_opts[0].hasnum := 0
			hardcopy_inst.mbfont_opts[0].number := 0
			hardcopy_inst.mbfont_opts[0].string := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			hardcopy_inst.mbfont_opts[0].strlen := 0
			hardcopy_inst.mbfont_opts[0].present := 0
			hardcopy_inst.mbfont_opts[1].name := ce_string ("a")
			hardcopy_inst.mbfont_opts[1].hasnum := 0
			hardcopy_inst.mbfont_opts[1].number := 0
			hardcopy_inst.mbfont_opts[1].string := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			hardcopy_inst.mbfont_opts[1].strlen := 0
			hardcopy_inst.mbfont_opts[1].present := 0
			hardcopy_inst.mbfont_opts[2].name := ce_string ("r")
			hardcopy_inst.mbfont_opts[2].hasnum := 0
			hardcopy_inst.mbfont_opts[2].number := 0
			hardcopy_inst.mbfont_opts[2].string := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			hardcopy_inst.mbfont_opts[2].strlen := 0
			hardcopy_inst.mbfont_opts[2].present := 0
			hardcopy_inst.mbfont_opts[3].name := ce_string ("b")
			hardcopy_inst.mbfont_opts[3].hasnum := 0
			hardcopy_inst.mbfont_opts[3].number := 0
			hardcopy_inst.mbfont_opts[3].string := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			hardcopy_inst.mbfont_opts[3].strlen := 0
			hardcopy_inst.mbfont_opts[3].present := 0
			hardcopy_inst.mbfont_opts[4].name := ce_string ("i")
			hardcopy_inst.mbfont_opts[4].hasnum := 0
			hardcopy_inst.mbfont_opts[4].number := 0
			hardcopy_inst.mbfont_opts[4].string := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			hardcopy_inst.mbfont_opts[4].strlen := 0
			hardcopy_inst.mbfont_opts[4].present := 0
			hardcopy_inst.mbfont_opts[5].name := ce_string ("o")
			hardcopy_inst.mbfont_opts[5].hasnum := 0
			hardcopy_inst.mbfont_opts[5].number := 0
			hardcopy_inst.mbfont_opts[5].string := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			hardcopy_inst.mbfont_opts[5].strlen := 0
			hardcopy_inst.mbfont_opts[5].present := 0
			hardcopy_inst.units[0] := ce_string ("pc")
			hardcopy_inst.units[1] := ce_string ("in")
			hardcopy_inst.units[2] := ce_string ("mm")
			hardcopy_inst.units[3] := ce_string ("pt")
			hardcopy_inst.prt_mediasize[0].name := ce_string ("A4")
			hardcopy_inst.prt_mediasize[0].width := (595.0).truncated_to_real
			hardcopy_inst.prt_mediasize[0].height := (842.0).truncated_to_real
			hardcopy_inst.prt_mediasize[1].name := ce_string ("letter")
			hardcopy_inst.prt_mediasize[1].width := (612.0).truncated_to_real
			hardcopy_inst.prt_mediasize[1].height := (792.0).truncated_to_real
			hardcopy_inst.prt_mediasize[2].name := ce_string ("10x14")
			hardcopy_inst.prt_mediasize[2].width := (720.0).truncated_to_real
			hardcopy_inst.prt_mediasize[2].height := (1008.0).truncated_to_real
			hardcopy_inst.prt_mediasize[3].name := ce_string ("A3")
			hardcopy_inst.prt_mediasize[3].width := (842.0).truncated_to_real
			hardcopy_inst.prt_mediasize[3].height := (1191.0).truncated_to_real
			hardcopy_inst.prt_mediasize[4].name := ce_string ("A5")
			hardcopy_inst.prt_mediasize[4].width := (420.0).truncated_to_real
			hardcopy_inst.prt_mediasize[4].height := (595.0).truncated_to_real
			hardcopy_inst.prt_mediasize[5].name := ce_string ("B4")
			hardcopy_inst.prt_mediasize[5].width := (729.0).truncated_to_real
			hardcopy_inst.prt_mediasize[5].height := (1032.0).truncated_to_real
			hardcopy_inst.prt_mediasize[6].name := ce_string ("B5")
			hardcopy_inst.prt_mediasize[6].width := (516.0).truncated_to_real
			hardcopy_inst.prt_mediasize[6].height := (729.0).truncated_to_real
			hardcopy_inst.prt_mediasize[7].name := ce_string ("executive")
			hardcopy_inst.prt_mediasize[7].width := (522.0).truncated_to_real
			hardcopy_inst.prt_mediasize[7].height := (756.0).truncated_to_real
			hardcopy_inst.prt_mediasize[8].name := ce_string ("folio")
			hardcopy_inst.prt_mediasize[8].width := (595.0).truncated_to_real
			hardcopy_inst.prt_mediasize[8].height := (935.0).truncated_to_real
			hardcopy_inst.prt_mediasize[9].name := ce_string ("ledger")
			hardcopy_inst.prt_mediasize[9].width := (1224.0).truncated_to_real
			hardcopy_inst.prt_mediasize[9].height := (792.0).truncated_to_real
			hardcopy_inst.prt_mediasize[10].name := ce_string ("legal")
			hardcopy_inst.prt_mediasize[10].width := (612.0).truncated_to_real
			hardcopy_inst.prt_mediasize[10].height := (1008.0).truncated_to_real
			hardcopy_inst.prt_mediasize[11].name := ce_string ("quarto")
			hardcopy_inst.prt_mediasize[11].width := (610.0).truncated_to_real
			hardcopy_inst.prt_mediasize[11].height := (780.0).truncated_to_real
			hardcopy_inst.prt_mediasize[12].name := ce_string ("statement")
			hardcopy_inst.prt_mediasize[12].width := (396.0).truncated_to_real
			hardcopy_inst.prt_mediasize[12].height := (612.0).truncated_to_real
			hardcopy_inst.prt_mediasize[13].name := ce_string ("tabloid")
			hardcopy_inst.prt_mediasize[13].width := (792.0).truncated_to_real
			hardcopy_inst.prt_mediasize[13].height := (1224.0).truncated_to_real
			hardcopy_inst.prt_ps_courier_font.wx := 600
			hardcopy_inst.prt_ps_courier_font.uline_offset := -100
			hardcopy_inst.prt_ps_courier_font.uline_width := 50
			hardcopy_inst.prt_ps_courier_font.bbox_min_y := -250
			hardcopy_inst.prt_ps_courier_font.bbox_max_y := 805
			hardcopy_inst.prt_ps_courier_font.ps_fontname[0] := ce_string ("Courier")
			hardcopy_inst.prt_ps_courier_font.ps_fontname[1] := ce_string ("Courier-Bold")
			hardcopy_inst.prt_ps_courier_font.ps_fontname[2] := ce_string ("Courier-Oblique")
			hardcopy_inst.prt_ps_courier_font.ps_fontname[3] := ce_string ("Courier-BoldOblique")
			hardcopy_inst.prt_ps_mb_font.wx := 1000
			hardcopy_inst.prt_ps_mb_font.uline_offset := -100
			hardcopy_inst.prt_ps_mb_font.uline_width := 50
			hardcopy_inst.prt_ps_mb_font.bbox_min_y := -250
			hardcopy_inst.prt_ps_mb_font.bbox_max_y := 805
			hardcopy_inst.prt_ps_mb_font.ps_fontname[0] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			hardcopy_inst.prt_ps_mb_font.ps_fontname[1] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			hardcopy_inst.prt_ps_mb_font.ps_fontname[2] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			hardcopy_inst.prt_ps_mb_font.ps_fontname[3] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			hardcopy_inst.j_encodings[0].encoding := ce_string ("iso-2022-jp")
			hardcopy_inst.j_encodings[0].cmap_encoding := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			hardcopy_inst.j_encodings[0].needs_charset := 15
			hardcopy_inst.j_encodings[1].encoding := ce_string ("euc-jp")
			hardcopy_inst.j_encodings[1].cmap_encoding := ce_string ("EUC")
			hardcopy_inst.j_encodings[1].needs_charset := 7
			hardcopy_inst.j_encodings[2].encoding := ce_string ("sjis")
			hardcopy_inst.j_encodings[2].cmap_encoding := ce_string ("RKSJ")
			hardcopy_inst.j_encodings[2].needs_charset := 211
			hardcopy_inst.j_encodings[3].encoding := ce_string ("cp932")
			hardcopy_inst.j_encodings[3].cmap_encoding := ce_string ("RKSJ")
			hardcopy_inst.j_encodings[3].needs_charset := 2
			hardcopy_inst.j_encodings[4].encoding := ce_string ("ucs-2")
			hardcopy_inst.j_encodings[4].cmap_encoding := ce_string ("UCS2")
			hardcopy_inst.j_encodings[4].needs_charset := 4
			hardcopy_inst.j_encodings[5].encoding := ce_string ("utf-8")
			hardcopy_inst.j_encodings[5].cmap_encoding := ce_string ("UTF8")
			hardcopy_inst.j_encodings[5].needs_charset := 4
			hardcopy_inst.j_charsets[0].charset := ce_string ("JIS_C_1978")
			hardcopy_inst.j_charsets[0].cmap_charset := ce_string ("78")
			hardcopy_inst.j_charsets[0].has_charset := 1
			hardcopy_inst.j_charsets[1].charset := ce_string ("JIS_X_1983")
			hardcopy_inst.j_charsets[1].cmap_charset := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			hardcopy_inst.j_charsets[1].has_charset := 2
			hardcopy_inst.j_charsets[2].charset := ce_string ("JIS_X_1990")
			hardcopy_inst.j_charsets[2].cmap_charset := ce_string ("Hojo")
			hardcopy_inst.j_charsets[2].has_charset := 4
			hardcopy_inst.j_charsets[3].charset := ce_string ("NEC")
			hardcopy_inst.j_charsets[3].cmap_charset := ce_string ("Ext")
			hardcopy_inst.j_charsets[3].has_charset := 8
			hardcopy_inst.j_charsets[4].charset := ce_string ("MSWINDOWS")
			hardcopy_inst.j_charsets[4].cmap_charset := ce_string ("90ms")
			hardcopy_inst.j_charsets[4].has_charset := 16
			hardcopy_inst.j_charsets[5].charset := ce_string ("CP932")
			hardcopy_inst.j_charsets[5].cmap_charset := ce_string ("90ms")
		end

end
