frozen class
	VIM_INITIALIZER_SLICE22

inherit
	VIM_DATA
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {VIM_INITIALIZER}

	initialize
		do
			globals_inst.wild_menu_showing := 0
			globals_inst.globaldir.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			globals_inst.lcs_eol := ('$').code
			globals_inst.lcs_ext := ('%/0/').code
			globals_inst.lcs_prec := ('%/0/').code
			globals_inst.lcs_nbsp := ('%/0/').code
			globals_inst.lcs_tab1 := ('%/0/').code
			globals_inst.lcs_tab2 := ('%/0/').code
			globals_inst.lcs_trail := ('%/0/').code
			globals_inst.fill_stl := (' ').code
			globals_inst.fill_stlnc := (' ').code
			globals_inst.fill_vert := (' ').code
			globals_inst.fill_fold := ('-').code
			globals_inst.fill_diff := ('-').code
			globals_inst.km_stopsel := 0
			globals_inst.km_startsel := 0
			globals_inst.cedit_key := -1
			globals_inst.cmdwin_type := 0
			globals_inst.cmdwin_result := 0
			globals_inst.no_lines_msg[0] := (('-').code).to_natural_8
			globals_inst.no_lines_msg[1] := (('-').code).to_natural_8
			globals_inst.no_lines_msg[2] := (('N').code).to_natural_8
			globals_inst.no_lines_msg[3] := (('o').code).to_natural_8
			globals_inst.no_lines_msg[4] := ((' ').code).to_natural_8
			globals_inst.no_lines_msg[5] := (('l').code).to_natural_8
			globals_inst.no_lines_msg[6] := (('i').code).to_natural_8
			globals_inst.no_lines_msg[7] := (('n').code).to_natural_8
			globals_inst.no_lines_msg[8] := (('e').code).to_natural_8
			globals_inst.no_lines_msg[9] := (('s').code).to_natural_8
			globals_inst.no_lines_msg[10] := ((' ').code).to_natural_8
			globals_inst.no_lines_msg[11] := (('i').code).to_natural_8
			globals_inst.no_lines_msg[12] := (('n').code).to_natural_8
			globals_inst.no_lines_msg[13] := ((' ').code).to_natural_8
			globals_inst.no_lines_msg[14] := (('b').code).to_natural_8
			globals_inst.no_lines_msg[15] := (('u').code).to_natural_8
			globals_inst.no_lines_msg[16] := (('f').code).to_natural_8
			globals_inst.no_lines_msg[17] := (('f').code).to_natural_8
			globals_inst.no_lines_msg[18] := (('e').code).to_natural_8
			globals_inst.no_lines_msg[19] := (('r').code).to_natural_8
			globals_inst.no_lines_msg[20] := (('-').code).to_natural_8
			globals_inst.no_lines_msg[21] := (('-').code).to_natural_8
			globals_inst.no_lines_msg[22] := (('%/0/').code).to_natural_8
			globals_inst.stl_syntax := 0
			globals_inst.no_hlsearch := 0
			globals_inst.balloonEval.ce_gets (create {CE_POINTER [PD_BALLOONEVALSTRUCT]}.make_shared (default_pointer))
			globals_inst.bevalServers := 0
			globals_inst.printer_opts[0].name := ce_string ("top")
			globals_inst.printer_opts[0].hasnum := 1
			globals_inst.printer_opts[0].number := 0
			globals_inst.printer_opts[0].string := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.printer_opts[0].strlen := 0
			globals_inst.printer_opts[0].present := 0
			globals_inst.printer_opts[1].name := ce_string ("bottom")
			globals_inst.printer_opts[1].hasnum := 1
			globals_inst.printer_opts[1].number := 0
			globals_inst.printer_opts[1].string := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.printer_opts[1].strlen := 0
			globals_inst.printer_opts[1].present := 0
			globals_inst.printer_opts[2].name := ce_string ("left")
			globals_inst.printer_opts[2].hasnum := 1
			globals_inst.printer_opts[2].number := 0
			globals_inst.printer_opts[2].string := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.printer_opts[2].strlen := 0
			globals_inst.printer_opts[2].present := 0
			globals_inst.printer_opts[3].name := ce_string ("right")
			globals_inst.printer_opts[3].hasnum := 1
			globals_inst.printer_opts[3].number := 0
			globals_inst.printer_opts[3].string := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.printer_opts[3].strlen := 0
			globals_inst.printer_opts[3].present := 0
			globals_inst.printer_opts[4].name := ce_string ("header")
			globals_inst.printer_opts[4].hasnum := 1
			globals_inst.printer_opts[4].number := 0
			globals_inst.printer_opts[4].string := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.printer_opts[4].strlen := 0
			globals_inst.printer_opts[4].present := 0
			globals_inst.printer_opts[5].name := ce_string ("syntax")
			globals_inst.printer_opts[5].hasnum := 0
			globals_inst.printer_opts[5].number := 0
			globals_inst.printer_opts[5].string := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.printer_opts[5].strlen := 0
			globals_inst.printer_opts[5].present := 0
			globals_inst.printer_opts[6].name := ce_string ("number")
			globals_inst.printer_opts[6].hasnum := 0
			globals_inst.printer_opts[6].number := 0
			globals_inst.printer_opts[6].string := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.printer_opts[6].strlen := 0
			globals_inst.printer_opts[6].present := 0
			globals_inst.printer_opts[7].name := ce_string ("wrap")
			globals_inst.printer_opts[7].hasnum := 0
			globals_inst.printer_opts[7].number := 0
			globals_inst.printer_opts[7].string := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.printer_opts[7].strlen := 0
			globals_inst.printer_opts[7].present := 0
			globals_inst.printer_opts[8].name := ce_string ("duplex")
			globals_inst.printer_opts[8].hasnum := 0
			globals_inst.printer_opts[8].number := 0
			globals_inst.printer_opts[8].string := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.printer_opts[8].strlen := 0
			globals_inst.printer_opts[8].present := 0
			globals_inst.printer_opts[9].name := ce_string ("portrait")
			globals_inst.printer_opts[9].hasnum := 0
			globals_inst.printer_opts[9].number := 0
			globals_inst.printer_opts[9].string := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.printer_opts[9].strlen := 0
			globals_inst.printer_opts[9].present := 0
			globals_inst.printer_opts[10].name := ce_string ("paper")
			globals_inst.printer_opts[10].hasnum := 0
			globals_inst.printer_opts[10].number := 0
			globals_inst.printer_opts[10].string := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.printer_opts[10].strlen := 0
			globals_inst.printer_opts[10].present := 0
			globals_inst.printer_opts[11].name := ce_string ("collate")
			globals_inst.printer_opts[11].hasnum := 0
			globals_inst.printer_opts[11].number := 0
			globals_inst.printer_opts[11].string := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.printer_opts[11].strlen := 0
			globals_inst.printer_opts[11].present := 0
			globals_inst.printer_opts[12].name := ce_string ("jobsplit")
			globals_inst.printer_opts[12].hasnum := 0
			globals_inst.printer_opts[12].number := 0
			globals_inst.printer_opts[12].string := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.printer_opts[12].strlen := 0
			globals_inst.printer_opts[12].present := 0
			globals_inst.printer_opts[13].name := ce_string ("formfeed")
			globals_inst.printer_opts[13].hasnum := 0
			globals_inst.printer_opts[13].number := 0
			globals_inst.printer_opts[13].string := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.printer_opts[13].strlen := 0
			globals_inst.printer_opts[13].present := 0
			globals_inst.xterm_display.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
			globals_inst.xterm_dpy.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer))
			globals_inst.app_context.ce_gets (create {CE_POINTER [ANY]}.make_shared (default_pointer))
			globals_inst.gtk_socket_id := (0).to_natural_32
			globals_inst.echo_wid_arg := 0
			globals_inst.typebuf_was_filled := 0
			globals_inst.serverName.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			globals_inst.commWindow := (0).to_natural_32
			globals_inst.clientWindow := (0).to_natural_32
			globals_inst.commProperty := (0).to_natural_32
			globals_inst.serverDelayedStartName.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			globals_inst.term_is_xterm := 0
			globals_inst.virtual_op := 2
			globals_inst.display_tick := (0).to_natural_16
			globals_inst.spell_redraw_lnum := (0).to_integer_32
			globals_inst.error_ga.ga_len := 0
			globals_inst.error_ga.ga_maxlen := 0
			globals_inst.error_ga.ga_itemsize := 0
			globals_inst.error_ga.ga_growsize := 0
			globals_inst.error_ga.ga_data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			globals_inst.netbeansArg.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
			globals_inst.netbeansFireChanges := 1
			globals_inst.netbeansForcedQuit := 0
			globals_inst.netbeansReadFile := 1
			globals_inst.netbeansSuppressNoLines := 0
			globals_inst.e_abort[0] := (('E').code).to_natural_8
			globals_inst.e_abort[1] := (('4').code).to_natural_8
			globals_inst.e_abort[2] := (('7').code).to_natural_8
			globals_inst.e_abort[3] := (('0').code).to_natural_8
			globals_inst.e_abort[4] := ((':').code).to_natural_8
			globals_inst.e_abort[5] := ((' ').code).to_natural_8
			globals_inst.e_abort[6] := (('C').code).to_natural_8
			globals_inst.e_abort[7] := (('o').code).to_natural_8
			globals_inst.e_abort[8] := (('m').code).to_natural_8
			globals_inst.e_abort[9] := (('m').code).to_natural_8
			globals_inst.e_abort[10] := (('a').code).to_natural_8
			globals_inst.e_abort[11] := (('n').code).to_natural_8
			globals_inst.e_abort[12] := (('d').code).to_natural_8
			globals_inst.e_abort[13] := ((' ').code).to_natural_8
			globals_inst.e_abort[14] := (('a').code).to_natural_8
			globals_inst.e_abort[15] := (('b').code).to_natural_8
			globals_inst.e_abort[16] := (('o').code).to_natural_8
			globals_inst.e_abort[17] := (('r').code).to_natural_8
			globals_inst.e_abort[18] := (('t').code).to_natural_8
			globals_inst.e_abort[19] := (('e').code).to_natural_8
			globals_inst.e_abort[20] := (('d').code).to_natural_8
			globals_inst.e_abort[21] := (('%/0/').code).to_natural_8
			globals_inst.e_argreq[0] := (('E').code).to_natural_8
			globals_inst.e_argreq[1] := (('4').code).to_natural_8
			globals_inst.e_argreq[2] := (('7').code).to_natural_8
			globals_inst.e_argreq[3] := (('1').code).to_natural_8
			globals_inst.e_argreq[4] := ((':').code).to_natural_8
			globals_inst.e_argreq[5] := ((' ').code).to_natural_8
			globals_inst.e_argreq[6] := (('A').code).to_natural_8
			globals_inst.e_argreq[7] := (('r').code).to_natural_8
			globals_inst.e_argreq[8] := (('g').code).to_natural_8
			globals_inst.e_argreq[9] := (('u').code).to_natural_8
			globals_inst.e_argreq[10] := (('m').code).to_natural_8
			globals_inst.e_argreq[11] := (('e').code).to_natural_8
			globals_inst.e_argreq[12] := (('n').code).to_natural_8
			globals_inst.e_argreq[13] := (('t').code).to_natural_8
			globals_inst.e_argreq[14] := ((' ').code).to_natural_8
			globals_inst.e_argreq[15] := (('r').code).to_natural_8
			globals_inst.e_argreq[16] := (('e').code).to_natural_8
			globals_inst.e_argreq[17] := (('q').code).to_natural_8
			globals_inst.e_argreq[18] := (('u').code).to_natural_8
			globals_inst.e_argreq[19] := (('i').code).to_natural_8
			globals_inst.e_argreq[20] := (('r').code).to_natural_8
			globals_inst.e_argreq[21] := (('e').code).to_natural_8
			globals_inst.e_argreq[22] := (('d').code).to_natural_8
			globals_inst.e_argreq[23] := (('%/0/').code).to_natural_8
			globals_inst.e_backslash[0] := (('E').code).to_natural_8
			globals_inst.e_backslash[1] := (('1').code).to_natural_8
			globals_inst.e_backslash[2] := (('0').code).to_natural_8
			globals_inst.e_backslash[3] := ((':').code).to_natural_8
			globals_inst.e_backslash[4] := ((' ').code).to_natural_8
			globals_inst.e_backslash[5] := (('\').code).to_natural_8
			globals_inst.e_backslash[6] := ((' ').code).to_natural_8
			globals_inst.e_backslash[7] := (('s').code).to_natural_8
			globals_inst.e_backslash[8] := (('h').code).to_natural_8
			globals_inst.e_backslash[9] := (('o').code).to_natural_8
			globals_inst.e_backslash[10] := (('u').code).to_natural_8
			globals_inst.e_backslash[11] := (('l').code).to_natural_8
			globals_inst.e_backslash[12] := (('d').code).to_natural_8
			globals_inst.e_backslash[13] := ((' ').code).to_natural_8
			globals_inst.e_backslash[14] := (('b').code).to_natural_8
			globals_inst.e_backslash[15] := (('e').code).to_natural_8
			globals_inst.e_backslash[16] := ((' ').code).to_natural_8
			globals_inst.e_backslash[17] := (('f').code).to_natural_8
			globals_inst.e_backslash[18] := (('o').code).to_natural_8
			globals_inst.e_backslash[19] := (('l').code).to_natural_8
			globals_inst.e_backslash[20] := (('l').code).to_natural_8
			globals_inst.e_backslash[21] := (('o').code).to_natural_8
			globals_inst.e_backslash[22] := (('w').code).to_natural_8
			globals_inst.e_backslash[23] := (('e').code).to_natural_8
			globals_inst.e_backslash[24] := (('d').code).to_natural_8
			globals_inst.e_backslash[25] := ((' ').code).to_natural_8
			globals_inst.e_backslash[26] := (('b').code).to_natural_8
			globals_inst.e_backslash[27] := (('y').code).to_natural_8
			globals_inst.e_backslash[28] := ((' ').code).to_natural_8
			globals_inst.e_backslash[29] := (('/').code).to_natural_8
			globals_inst.e_backslash[30] := ((',').code).to_natural_8
			globals_inst.e_backslash[31] := ((' ').code).to_natural_8
			globals_inst.e_backslash[32] := (('?').code).to_natural_8
			globals_inst.e_backslash[33] := ((' ').code).to_natural_8
			globals_inst.e_backslash[34] := (('o').code).to_natural_8
			globals_inst.e_backslash[35] := (('r').code).to_natural_8
			globals_inst.e_backslash[36] := ((' ').code).to_natural_8
			globals_inst.e_backslash[37] := (('&').code).to_natural_8
			globals_inst.e_backslash[38] := (('%/0/').code).to_natural_8
			globals_inst.e_cmdwin[0] := (('E').code).to_natural_8
			globals_inst.e_cmdwin[1] := (('1').code).to_natural_8
			globals_inst.e_cmdwin[2] := (('1').code).to_natural_8
			globals_inst.e_cmdwin[3] := ((':').code).to_natural_8
			globals_inst.e_cmdwin[4] := ((' ').code).to_natural_8
			globals_inst.e_cmdwin[5] := (('I').code).to_natural_8
			globals_inst.e_cmdwin[6] := (('n').code).to_natural_8
			globals_inst.e_cmdwin[7] := (('v').code).to_natural_8
			globals_inst.e_cmdwin[8] := (('a').code).to_natural_8
			globals_inst.e_cmdwin[9] := (('l').code).to_natural_8
			globals_inst.e_cmdwin[10] := (('i').code).to_natural_8
			globals_inst.e_cmdwin[11] := (('d').code).to_natural_8
			globals_inst.e_cmdwin[12] := ((' ').code).to_natural_8
			globals_inst.e_cmdwin[13] := (('i').code).to_natural_8
			globals_inst.e_cmdwin[14] := (('n').code).to_natural_8
			globals_inst.e_cmdwin[15] := ((' ').code).to_natural_8
			globals_inst.e_cmdwin[16] := (('c').code).to_natural_8
			globals_inst.e_cmdwin[17] := (('o').code).to_natural_8
			globals_inst.e_cmdwin[18] := (('m').code).to_natural_8
			globals_inst.e_cmdwin[19] := (('m').code).to_natural_8
			globals_inst.e_cmdwin[20] := (('a').code).to_natural_8
			globals_inst.e_cmdwin[21] := (('n').code).to_natural_8
			globals_inst.e_cmdwin[22] := (('d').code).to_natural_8
			globals_inst.e_cmdwin[23] := (('-').code).to_natural_8
			globals_inst.e_cmdwin[24] := (('l').code).to_natural_8
			globals_inst.e_cmdwin[25] := (('i').code).to_natural_8
			globals_inst.e_cmdwin[26] := (('n').code).to_natural_8
			globals_inst.e_cmdwin[27] := (('e').code).to_natural_8
			globals_inst.e_cmdwin[28] := ((' ').code).to_natural_8
			globals_inst.e_cmdwin[29] := (('w').code).to_natural_8
			globals_inst.e_cmdwin[30] := (('i').code).to_natural_8
			globals_inst.e_cmdwin[31] := (('n').code).to_natural_8
			globals_inst.e_cmdwin[32] := (('d').code).to_natural_8
			globals_inst.e_cmdwin[33] := (('o').code).to_natural_8
			globals_inst.e_cmdwin[34] := (('w').code).to_natural_8
			globals_inst.e_cmdwin[35] := ((';').code).to_natural_8
			globals_inst.e_cmdwin[36] := ((' ').code).to_natural_8
			globals_inst.e_cmdwin[37] := (('<').code).to_natural_8
			globals_inst.e_cmdwin[38] := (('C').code).to_natural_8
			globals_inst.e_cmdwin[39] := (('R').code).to_natural_8
			globals_inst.e_cmdwin[40] := (('>').code).to_natural_8
			globals_inst.e_cmdwin[41] := ((' ').code).to_natural_8
			globals_inst.e_cmdwin[42] := (('e').code).to_natural_8
			globals_inst.e_cmdwin[43] := (('x').code).to_natural_8
			globals_inst.e_cmdwin[44] := (('e').code).to_natural_8
			globals_inst.e_cmdwin[45] := (('c').code).to_natural_8
			globals_inst.e_cmdwin[46] := (('u').code).to_natural_8
			globals_inst.e_cmdwin[47] := (('t').code).to_natural_8
			globals_inst.e_cmdwin[48] := (('e').code).to_natural_8
			globals_inst.e_cmdwin[49] := (('s').code).to_natural_8
			globals_inst.e_cmdwin[50] := ((',').code).to_natural_8
			globals_inst.e_cmdwin[51] := ((' ').code).to_natural_8
			globals_inst.e_cmdwin[52] := (('C').code).to_natural_8
			globals_inst.e_cmdwin[53] := (('T').code).to_natural_8
			globals_inst.e_cmdwin[54] := (('R').code).to_natural_8
			globals_inst.e_cmdwin[55] := (('L').code).to_natural_8
			globals_inst.e_cmdwin[56] := (('-').code).to_natural_8
			globals_inst.e_cmdwin[57] := (('C').code).to_natural_8
			globals_inst.e_cmdwin[58] := ((' ').code).to_natural_8
			globals_inst.e_cmdwin[59] := (('q').code).to_natural_8
			globals_inst.e_cmdwin[60] := (('u').code).to_natural_8
			globals_inst.e_cmdwin[61] := (('i').code).to_natural_8
			globals_inst.e_cmdwin[62] := (('t').code).to_natural_8
			globals_inst.e_cmdwin[63] := (('s').code).to_natural_8
			globals_inst.e_cmdwin[64] := (('%/0/').code).to_natural_8
			globals_inst.e_curdir[0] := (('E').code).to_natural_8
			globals_inst.e_curdir[1] := (('1').code).to_natural_8
			globals_inst.e_curdir[2] := (('2').code).to_natural_8
			globals_inst.e_curdir[3] := ((':').code).to_natural_8
			globals_inst.e_curdir[4] := ((' ').code).to_natural_8
			globals_inst.e_curdir[5] := (('C').code).to_natural_8
			globals_inst.e_curdir[6] := (('o').code).to_natural_8
			globals_inst.e_curdir[7] := (('m').code).to_natural_8
			globals_inst.e_curdir[8] := (('m').code).to_natural_8
			globals_inst.e_curdir[9] := (('a').code).to_natural_8
			globals_inst.e_curdir[10] := (('n').code).to_natural_8
			globals_inst.e_curdir[11] := (('d').code).to_natural_8
			globals_inst.e_curdir[12] := ((' ').code).to_natural_8
			globals_inst.e_curdir[13] := (('n').code).to_natural_8
			globals_inst.e_curdir[14] := (('o').code).to_natural_8
			globals_inst.e_curdir[15] := (('t').code).to_natural_8
			globals_inst.e_curdir[16] := ((' ').code).to_natural_8
			globals_inst.e_curdir[17] := (('a').code).to_natural_8
			globals_inst.e_curdir[18] := (('l').code).to_natural_8
			globals_inst.e_curdir[19] := (('l').code).to_natural_8
			globals_inst.e_curdir[20] := (('o').code).to_natural_8
			globals_inst.e_curdir[21] := (('w').code).to_natural_8
			globals_inst.e_curdir[22] := (('e').code).to_natural_8
			globals_inst.e_curdir[23] := (('d').code).to_natural_8
			globals_inst.e_curdir[24] := ((' ').code).to_natural_8
			globals_inst.e_curdir[25] := (('f').code).to_natural_8
			globals_inst.e_curdir[26] := (('r').code).to_natural_8
			globals_inst.e_curdir[27] := (('o').code).to_natural_8
			globals_inst.e_curdir[28] := (('m').code).to_natural_8
			globals_inst.e_curdir[29] := ((' ').code).to_natural_8
			globals_inst.e_curdir[30] := (('e').code).to_natural_8
			globals_inst.e_curdir[31] := (('x').code).to_natural_8
			globals_inst.e_curdir[32] := (('r').code).to_natural_8
			globals_inst.e_curdir[33] := (('c').code).to_natural_8
			globals_inst.e_curdir[34] := (('/').code).to_natural_8
			globals_inst.e_curdir[35] := (('v').code).to_natural_8
			globals_inst.e_curdir[36] := (('i').code).to_natural_8
			globals_inst.e_curdir[37] := (('m').code).to_natural_8
			globals_inst.e_curdir[38] := (('r').code).to_natural_8
			globals_inst.e_curdir[39] := (('c').code).to_natural_8
			globals_inst.e_curdir[40] := ((' ').code).to_natural_8
			globals_inst.e_curdir[41] := (('i').code).to_natural_8
			globals_inst.e_curdir[42] := (('n').code).to_natural_8
			globals_inst.e_curdir[43] := ((' ').code).to_natural_8
			globals_inst.e_curdir[44] := (('c').code).to_natural_8
			globals_inst.e_curdir[45] := (('u').code).to_natural_8
			globals_inst.e_curdir[46] := (('r').code).to_natural_8
			globals_inst.e_curdir[47] := (('r').code).to_natural_8
			globals_inst.e_curdir[48] := (('e').code).to_natural_8
			globals_inst.e_curdir[49] := (('n').code).to_natural_8
			globals_inst.e_curdir[50] := (('t').code).to_natural_8
			globals_inst.e_curdir[51] := ((' ').code).to_natural_8
			globals_inst.e_curdir[52] := (('d').code).to_natural_8
			globals_inst.e_curdir[53] := (('i').code).to_natural_8
			globals_inst.e_curdir[54] := (('r').code).to_natural_8
			globals_inst.e_curdir[55] := ((' ').code).to_natural_8
			globals_inst.e_curdir[56] := (('o').code).to_natural_8
			globals_inst.e_curdir[57] := (('r').code).to_natural_8
			globals_inst.e_curdir[58] := ((' ').code).to_natural_8
			globals_inst.e_curdir[59] := (('t').code).to_natural_8
			globals_inst.e_curdir[60] := (('a').code).to_natural_8
			globals_inst.e_curdir[61] := (('g').code).to_natural_8
			globals_inst.e_curdir[62] := ((' ').code).to_natural_8
			globals_inst.e_curdir[63] := (('s').code).to_natural_8
			globals_inst.e_curdir[64] := (('e').code).to_natural_8
			globals_inst.e_curdir[65] := (('a').code).to_natural_8
			globals_inst.e_curdir[66] := (('r').code).to_natural_8
			globals_inst.e_curdir[67] := (('c').code).to_natural_8
			globals_inst.e_curdir[68] := (('h').code).to_natural_8
			globals_inst.e_curdir[69] := (('%/0/').code).to_natural_8
			globals_inst.e_endif[0] := (('E').code).to_natural_8
			globals_inst.e_endif[1] := (('1').code).to_natural_8
			globals_inst.e_endif[2] := (('7').code).to_natural_8
			globals_inst.e_endif[3] := (('1').code).to_natural_8
			globals_inst.e_endif[4] := ((':').code).to_natural_8
			globals_inst.e_endif[5] := ((' ').code).to_natural_8
			globals_inst.e_endif[6] := (('M').code).to_natural_8
			globals_inst.e_endif[7] := (('i').code).to_natural_8
			globals_inst.e_endif[8] := (('s').code).to_natural_8
			globals_inst.e_endif[9] := (('s').code).to_natural_8
			globals_inst.e_endif[10] := (('i').code).to_natural_8
			globals_inst.e_endif[11] := (('n').code).to_natural_8
			globals_inst.e_endif[12] := (('g').code).to_natural_8
			globals_inst.e_endif[13] := ((' ').code).to_natural_8
			globals_inst.e_endif[14] := ((':').code).to_natural_8
			globals_inst.e_endif[15] := (('e').code).to_natural_8
			globals_inst.e_endif[16] := (('n').code).to_natural_8
			globals_inst.e_endif[17] := (('d').code).to_natural_8
			globals_inst.e_endif[18] := (('i').code).to_natural_8
			globals_inst.e_endif[19] := (('f').code).to_natural_8
			globals_inst.e_endif[20] := (('%/0/').code).to_natural_8
			globals_inst.e_endtry[0] := (('E').code).to_natural_8
			globals_inst.e_endtry[1] := (('6').code).to_natural_8
			globals_inst.e_endtry[2] := (('0').code).to_natural_8
			globals_inst.e_endtry[3] := (('0').code).to_natural_8
			globals_inst.e_endtry[4] := ((':').code).to_natural_8
			globals_inst.e_endtry[5] := ((' ').code).to_natural_8
			globals_inst.e_endtry[6] := (('M').code).to_natural_8
			globals_inst.e_endtry[7] := (('i').code).to_natural_8
			globals_inst.e_endtry[8] := (('s').code).to_natural_8
			globals_inst.e_endtry[9] := (('s').code).to_natural_8
			globals_inst.e_endtry[10] := (('i').code).to_natural_8
			globals_inst.e_endtry[11] := (('n').code).to_natural_8
			globals_inst.e_endtry[12] := (('g').code).to_natural_8
			globals_inst.e_endtry[13] := ((' ').code).to_natural_8
			globals_inst.e_endtry[14] := ((':').code).to_natural_8
			globals_inst.e_endtry[15] := (('e').code).to_natural_8
			globals_inst.e_endtry[16] := (('n').code).to_natural_8
			globals_inst.e_endtry[17] := (('d').code).to_natural_8
			globals_inst.e_endtry[18] := (('t').code).to_natural_8
			globals_inst.e_endtry[19] := (('r').code).to_natural_8
			globals_inst.e_endtry[20] := (('y').code).to_natural_8
			globals_inst.e_endtry[21] := (('%/0/').code).to_natural_8
			globals_inst.e_endwhile[0] := (('E').code).to_natural_8
			globals_inst.e_endwhile[1] := (('1').code).to_natural_8
			globals_inst.e_endwhile[2] := (('7').code).to_natural_8
			globals_inst.e_endwhile[3] := (('0').code).to_natural_8
			globals_inst.e_endwhile[4] := ((':').code).to_natural_8
			globals_inst.e_endwhile[5] := ((' ').code).to_natural_8
			globals_inst.e_endwhile[6] := (('M').code).to_natural_8
			globals_inst.e_endwhile[7] := (('i').code).to_natural_8
			globals_inst.e_endwhile[8] := (('s').code).to_natural_8
			globals_inst.e_endwhile[9] := (('s').code).to_natural_8
			globals_inst.e_endwhile[10] := (('i').code).to_natural_8
			globals_inst.e_endwhile[11] := (('n').code).to_natural_8
			globals_inst.e_endwhile[12] := (('g').code).to_natural_8
			globals_inst.e_endwhile[13] := ((' ').code).to_natural_8
			globals_inst.e_endwhile[14] := ((':').code).to_natural_8
			globals_inst.e_endwhile[15] := (('e').code).to_natural_8
			globals_inst.e_endwhile[16] := (('n').code).to_natural_8
			globals_inst.e_endwhile[17] := (('d').code).to_natural_8
			globals_inst.e_endwhile[18] := (('w').code).to_natural_8
			globals_inst.e_endwhile[19] := (('h').code).to_natural_8
			globals_inst.e_endwhile[20] := (('i').code).to_natural_8
			globals_inst.e_endwhile[21] := (('l').code).to_natural_8
			globals_inst.e_endwhile[22] := (('e').code).to_natural_8
			globals_inst.e_endwhile[23] := (('%/0/').code).to_natural_8
			globals_inst.e_endfor[0] := (('E').code).to_natural_8
			globals_inst.e_endfor[1] := (('1').code).to_natural_8
			globals_inst.e_endfor[2] := (('7').code).to_natural_8
			globals_inst.e_endfor[3] := (('0').code).to_natural_8
			globals_inst.e_endfor[4] := ((':').code).to_natural_8
			globals_inst.e_endfor[5] := ((' ').code).to_natural_8
			globals_inst.e_endfor[6] := (('M').code).to_natural_8
			globals_inst.e_endfor[7] := (('i').code).to_natural_8
			globals_inst.e_endfor[8] := (('s').code).to_natural_8
			globals_inst.e_endfor[9] := (('s').code).to_natural_8
			globals_inst.e_endfor[10] := (('i').code).to_natural_8
			globals_inst.e_endfor[11] := (('n').code).to_natural_8
			globals_inst.e_endfor[12] := (('g').code).to_natural_8
			globals_inst.e_endfor[13] := ((' ').code).to_natural_8
			globals_inst.e_endfor[14] := ((':').code).to_natural_8
			globals_inst.e_endfor[15] := (('e').code).to_natural_8
			globals_inst.e_endfor[16] := (('n').code).to_natural_8
			globals_inst.e_endfor[17] := (('d').code).to_natural_8
			globals_inst.e_endfor[18] := (('f').code).to_natural_8
			globals_inst.e_endfor[19] := (('o').code).to_natural_8
			globals_inst.e_endfor[20] := (('r').code).to_natural_8
			globals_inst.e_endfor[21] := (('%/0/').code).to_natural_8
			globals_inst.e_while[0] := (('E').code).to_natural_8
			globals_inst.e_while[1] := (('5').code).to_natural_8
			globals_inst.e_while[2] := (('8').code).to_natural_8
			globals_inst.e_while[3] := (('8').code).to_natural_8
			globals_inst.e_while[4] := ((':').code).to_natural_8
			globals_inst.e_while[5] := ((' ').code).to_natural_8
			globals_inst.e_while[6] := ((':').code).to_natural_8
			globals_inst.e_while[7] := (('e').code).to_natural_8
			globals_inst.e_while[8] := (('n').code).to_natural_8
			globals_inst.e_while[9] := (('d').code).to_natural_8
			globals_inst.e_while[10] := (('w').code).to_natural_8
			globals_inst.e_while[11] := (('h').code).to_natural_8
			globals_inst.e_while[12] := (('i').code).to_natural_8
			globals_inst.e_while[13] := (('l').code).to_natural_8
			globals_inst.e_while[14] := (('e').code).to_natural_8
			globals_inst.e_while[15] := ((' ').code).to_natural_8
			globals_inst.e_while[16] := (('w').code).to_natural_8
			globals_inst.e_while[17] := (('i').code).to_natural_8
			globals_inst.e_while[18] := (('t').code).to_natural_8
			globals_inst.e_while[19] := (('h').code).to_natural_8
			globals_inst.e_while[20] := (('o').code).to_natural_8
			globals_inst.e_while[21] := (('u').code).to_natural_8
			globals_inst.e_while[22] := (('t').code).to_natural_8
			globals_inst.e_while[23] := ((' ').code).to_natural_8
			globals_inst.e_while[24] := ((':').code).to_natural_8
			globals_inst.e_while[25] := (('w').code).to_natural_8
			globals_inst.e_while[26] := (('h').code).to_natural_8
			globals_inst.e_while[27] := (('i').code).to_natural_8
			globals_inst.e_while[28] := (('l').code).to_natural_8
			globals_inst.e_while[29] := (('e').code).to_natural_8
			globals_inst.e_while[30] := (('%/0/').code).to_natural_8
			globals_inst.e_for[0] := (('E').code).to_natural_8
			globals_inst.e_for[1] := (('5').code).to_natural_8
			globals_inst.e_for[2] := (('8').code).to_natural_8
			globals_inst.e_for[3] := (('8').code).to_natural_8
			globals_inst.e_for[4] := ((':').code).to_natural_8
		end

end
