frozen class
	VIM_INITIALIZER_SLICE32

inherit
	VIM_DATA
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {VIM_INITIALIZER}

	initialize
		do
			mbyte_inst.enc_alias_table[27].name := ce_string ("ucs4")
			mbyte_inst.enc_alias_table[27].canon := 21
			mbyte_inst.enc_alias_table[28].name := ce_string ("ucs4be")
			mbyte_inst.enc_alias_table[28].canon := 21
			mbyte_inst.enc_alias_table[29].name := ce_string ("ucs-4be")
			mbyte_inst.enc_alias_table[29].canon := 21
			mbyte_inst.enc_alias_table[30].name := ce_string ("ucs4le")
			mbyte_inst.enc_alias_table[30].canon := 22
			mbyte_inst.enc_alias_table[31].name := ce_string ("utf32")
			mbyte_inst.enc_alias_table[31].canon := 21
			mbyte_inst.enc_alias_table[32].name := ce_string ("utf-32")
			mbyte_inst.enc_alias_table[32].canon := 21
			mbyte_inst.enc_alias_table[33].name := ce_string ("utf32be")
			mbyte_inst.enc_alias_table[33].canon := 21
			mbyte_inst.enc_alias_table[34].name := ce_string ("utf-32be")
			mbyte_inst.enc_alias_table[34].canon := 21
			mbyte_inst.enc_alias_table[35].name := ce_string ("utf32le")
			mbyte_inst.enc_alias_table[35].canon := 22
			mbyte_inst.enc_alias_table[36].name := ce_string ("utf-32le")
			mbyte_inst.enc_alias_table[36].canon := 22
			mbyte_inst.enc_alias_table[37].name := ce_string ("932")
			mbyte_inst.enc_alias_table[37].canon := 45
			mbyte_inst.enc_alias_table[38].name := ce_string ("949")
			mbyte_inst.enc_alias_table[38].canon := 47
			mbyte_inst.enc_alias_table[39].name := ce_string ("936")
			mbyte_inst.enc_alias_table[39].canon := 46
			mbyte_inst.enc_alias_table[40].name := ce_string ("gbk")
			mbyte_inst.enc_alias_table[40].canon := 46
			mbyte_inst.enc_alias_table[41].name := ce_string ("950")
			mbyte_inst.enc_alias_table[41].canon := 48
			mbyte_inst.enc_alias_table[42].name := ce_string ("eucjp")
			mbyte_inst.enc_alias_table[42].canon := 24
			mbyte_inst.enc_alias_table[43].name := ce_string ("unix-jis")
			mbyte_inst.enc_alias_table[43].canon := 24
			mbyte_inst.enc_alias_table[44].name := ce_string ("ujis")
			mbyte_inst.enc_alias_table[44].canon := 24
			mbyte_inst.enc_alias_table[45].name := ce_string ("shift-jis")
			mbyte_inst.enc_alias_table[45].canon := 25
			mbyte_inst.enc_alias_table[46].name := ce_string ("euckr")
			mbyte_inst.enc_alias_table[46].canon := 26
			mbyte_inst.enc_alias_table[47].name := ce_string ("5601")
			mbyte_inst.enc_alias_table[47].canon := 26
			mbyte_inst.enc_alias_table[48].name := ce_string ("euccn")
			mbyte_inst.enc_alias_table[48].canon := 27
			mbyte_inst.enc_alias_table[49].name := ce_string ("gb2312")
			mbyte_inst.enc_alias_table[49].canon := 27
			mbyte_inst.enc_alias_table[50].name := ce_string ("euctw")
			mbyte_inst.enc_alias_table[50].canon := 28
			mbyte_inst.enc_alias_table[51].name := ce_string ("japan")
			mbyte_inst.enc_alias_table[51].canon := 24
			mbyte_inst.enc_alias_table[52].name := ce_string ("korea")
			mbyte_inst.enc_alias_table[52].canon := 26
			mbyte_inst.enc_alias_table[53].name := ce_string ("prc")
			mbyte_inst.enc_alias_table[53].canon := 27
			mbyte_inst.enc_alias_table[54].name := ce_string ("chinese")
			mbyte_inst.enc_alias_table[54].canon := 27
			mbyte_inst.enc_alias_table[55].name := ce_string ("taiwan")
			mbyte_inst.enc_alias_table[55].canon := 28
			mbyte_inst.enc_alias_table[56].name := ce_string ("cp950")
			mbyte_inst.enc_alias_table[56].canon := 29
			mbyte_inst.enc_alias_table[57].name := ce_string ("950")
			mbyte_inst.enc_alias_table[57].canon := 29
			mbyte_inst.enc_alias_table[58].name := ce_string ("mac")
			mbyte_inst.enc_alias_table[58].canon := 57
			mbyte_inst.enc_alias_table[59].name := ce_string ("mac-roman")
			mbyte_inst.enc_alias_table[59].canon := 57
			mbyte_inst.enc_alias_table[60].name := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			mbyte_inst.enc_alias_table[60].canon := 0
			mbyte_inst.doublewidth[0].first := 4352
			mbyte_inst.doublewidth[0].last := 4447
			mbyte_inst.doublewidth[1].first := 4515
			mbyte_inst.doublewidth[1].last := 4519
			mbyte_inst.doublewidth[2].first := 4602
			mbyte_inst.doublewidth[2].last := 4607
			mbyte_inst.doublewidth[3].first := 9001
			mbyte_inst.doublewidth[3].last := 9002
			mbyte_inst.doublewidth[4].first := 11904
			mbyte_inst.doublewidth[4].last := 11929
			mbyte_inst.doublewidth[5].first := 11931
			mbyte_inst.doublewidth[5].last := 12019
			mbyte_inst.doublewidth[6].first := 12032
			mbyte_inst.doublewidth[6].last := 12245
			mbyte_inst.doublewidth[7].first := 12272
			mbyte_inst.doublewidth[7].last := 12283
			mbyte_inst.doublewidth[8].first := 12288
			mbyte_inst.doublewidth[8].last := 12329
			mbyte_inst.doublewidth[9].first := 12336
			mbyte_inst.doublewidth[9].last := 12350
			mbyte_inst.doublewidth[10].first := 12353
			mbyte_inst.doublewidth[10].last := 12438
			mbyte_inst.doublewidth[11].first := 12443
			mbyte_inst.doublewidth[11].last := 12543
			mbyte_inst.doublewidth[12].first := 12549
			mbyte_inst.doublewidth[12].last := 12589
			mbyte_inst.doublewidth[13].first := 12593
			mbyte_inst.doublewidth[13].last := 12686
			mbyte_inst.doublewidth[14].first := 12688
			mbyte_inst.doublewidth[14].last := 12727
			mbyte_inst.doublewidth[15].first := 12736
			mbyte_inst.doublewidth[15].last := 12771
			mbyte_inst.doublewidth[16].first := 12784
			mbyte_inst.doublewidth[16].last := 12830
			mbyte_inst.doublewidth[17].first := 12832
			mbyte_inst.doublewidth[17].last := 12871
			mbyte_inst.doublewidth[18].first := 12880
			mbyte_inst.doublewidth[18].last := 13054
			mbyte_inst.doublewidth[19].first := 13056
			mbyte_inst.doublewidth[19].last := 19903
			mbyte_inst.doublewidth[20].first := 19968
			mbyte_inst.doublewidth[20].last := 42124
			mbyte_inst.doublewidth[21].first := 42128
			mbyte_inst.doublewidth[21].last := 42182
			mbyte_inst.doublewidth[22].first := 43360
			mbyte_inst.doublewidth[22].last := 43388
			mbyte_inst.doublewidth[23].first := 44032
			mbyte_inst.doublewidth[23].last := 55203
			mbyte_inst.doublewidth[24].first := 55216
			mbyte_inst.doublewidth[24].last := 55238
			mbyte_inst.doublewidth[25].first := 55243
			mbyte_inst.doublewidth[25].last := 55291
			mbyte_inst.doublewidth[26].first := 63744
			mbyte_inst.doublewidth[26].last := 64255
			mbyte_inst.doublewidth[27].first := 65040
			mbyte_inst.doublewidth[27].last := 65049
			mbyte_inst.doublewidth[28].first := 65072
			mbyte_inst.doublewidth[28].last := 65106
			mbyte_inst.doublewidth[29].first := 65108
			mbyte_inst.doublewidth[29].last := 65126
			mbyte_inst.doublewidth[30].first := 65128
			mbyte_inst.doublewidth[30].last := 65131
			mbyte_inst.doublewidth[31].first := 65281
			mbyte_inst.doublewidth[31].last := 65376
			mbyte_inst.doublewidth[32].first := 65504
			mbyte_inst.doublewidth[32].last := 65510
			mbyte_inst.doublewidth[33].first := 127488
			mbyte_inst.doublewidth[33].last := 127488
			mbyte_inst.doublewidth[34].first := 127504
			mbyte_inst.doublewidth[34].last := 127537
			mbyte_inst.doublewidth[35].first := 127552
			mbyte_inst.doublewidth[35].last := 127560
			mbyte_inst.doublewidth[36].first := 131072
			mbyte_inst.doublewidth[36].last := 196605
			mbyte_inst.doublewidth[37].first := 196608
			mbyte_inst.doublewidth[37].last := 262141
			mbyte_inst.ambiguous[0].first := 161
			mbyte_inst.ambiguous[0].last := 161
			mbyte_inst.ambiguous[1].first := 164
			mbyte_inst.ambiguous[1].last := 164
			mbyte_inst.ambiguous[2].first := 167
			mbyte_inst.ambiguous[2].last := 168
			mbyte_inst.ambiguous[3].first := 170
			mbyte_inst.ambiguous[3].last := 170
			mbyte_inst.ambiguous[4].first := 173
			mbyte_inst.ambiguous[4].last := 174
			mbyte_inst.ambiguous[5].first := 176
			mbyte_inst.ambiguous[5].last := 180
			mbyte_inst.ambiguous[6].first := 182
			mbyte_inst.ambiguous[6].last := 186
			mbyte_inst.ambiguous[7].first := 188
			mbyte_inst.ambiguous[7].last := 191
			mbyte_inst.ambiguous[8].first := 198
			mbyte_inst.ambiguous[8].last := 198
			mbyte_inst.ambiguous[9].first := 208
			mbyte_inst.ambiguous[9].last := 208
			mbyte_inst.ambiguous[10].first := 215
			mbyte_inst.ambiguous[10].last := 216
			mbyte_inst.ambiguous[11].first := 222
			mbyte_inst.ambiguous[11].last := 225
			mbyte_inst.ambiguous[12].first := 230
			mbyte_inst.ambiguous[12].last := 230
			mbyte_inst.ambiguous[13].first := 232
			mbyte_inst.ambiguous[13].last := 234
			mbyte_inst.ambiguous[14].first := 236
			mbyte_inst.ambiguous[14].last := 237
			mbyte_inst.ambiguous[15].first := 240
			mbyte_inst.ambiguous[15].last := 240
			mbyte_inst.ambiguous[16].first := 242
			mbyte_inst.ambiguous[16].last := 243
			mbyte_inst.ambiguous[17].first := 247
			mbyte_inst.ambiguous[17].last := 250
			mbyte_inst.ambiguous[18].first := 252
			mbyte_inst.ambiguous[18].last := 252
			mbyte_inst.ambiguous[19].first := 254
			mbyte_inst.ambiguous[19].last := 254
			mbyte_inst.ambiguous[20].first := 257
			mbyte_inst.ambiguous[20].last := 257
			mbyte_inst.ambiguous[21].first := 273
			mbyte_inst.ambiguous[21].last := 273
			mbyte_inst.ambiguous[22].first := 275
			mbyte_inst.ambiguous[22].last := 275
			mbyte_inst.ambiguous[23].first := 283
			mbyte_inst.ambiguous[23].last := 283
			mbyte_inst.ambiguous[24].first := 294
			mbyte_inst.ambiguous[24].last := 295
			mbyte_inst.ambiguous[25].first := 299
			mbyte_inst.ambiguous[25].last := 299
			mbyte_inst.ambiguous[26].first := 305
			mbyte_inst.ambiguous[26].last := 307
			mbyte_inst.ambiguous[27].first := 312
			mbyte_inst.ambiguous[27].last := 312
			mbyte_inst.ambiguous[28].first := 319
			mbyte_inst.ambiguous[28].last := 322
			mbyte_inst.ambiguous[29].first := 324
			mbyte_inst.ambiguous[29].last := 324
			mbyte_inst.ambiguous[30].first := 328
			mbyte_inst.ambiguous[30].last := 331
			mbyte_inst.ambiguous[31].first := 333
			mbyte_inst.ambiguous[31].last := 333
			mbyte_inst.ambiguous[32].first := 338
			mbyte_inst.ambiguous[32].last := 339
			mbyte_inst.ambiguous[33].first := 358
			mbyte_inst.ambiguous[33].last := 359
			mbyte_inst.ambiguous[34].first := 363
			mbyte_inst.ambiguous[34].last := 363
			mbyte_inst.ambiguous[35].first := 462
			mbyte_inst.ambiguous[35].last := 462
			mbyte_inst.ambiguous[36].first := 464
			mbyte_inst.ambiguous[36].last := 464
			mbyte_inst.ambiguous[37].first := 466
			mbyte_inst.ambiguous[37].last := 466
			mbyte_inst.ambiguous[38].first := 468
			mbyte_inst.ambiguous[38].last := 468
			mbyte_inst.ambiguous[39].first := 470
			mbyte_inst.ambiguous[39].last := 470
			mbyte_inst.ambiguous[40].first := 472
			mbyte_inst.ambiguous[40].last := 472
			mbyte_inst.ambiguous[41].first := 474
			mbyte_inst.ambiguous[41].last := 474
			mbyte_inst.ambiguous[42].first := 476
			mbyte_inst.ambiguous[42].last := 476
			mbyte_inst.ambiguous[43].first := 593
			mbyte_inst.ambiguous[43].last := 593
			mbyte_inst.ambiguous[44].first := 609
			mbyte_inst.ambiguous[44].last := 609
			mbyte_inst.ambiguous[45].first := 708
			mbyte_inst.ambiguous[45].last := 708
			mbyte_inst.ambiguous[46].first := 711
			mbyte_inst.ambiguous[46].last := 711
			mbyte_inst.ambiguous[47].first := 713
			mbyte_inst.ambiguous[47].last := 715
			mbyte_inst.ambiguous[48].first := 717
			mbyte_inst.ambiguous[48].last := 717
			mbyte_inst.ambiguous[49].first := 720
			mbyte_inst.ambiguous[49].last := 720
			mbyte_inst.ambiguous[50].first := 728
			mbyte_inst.ambiguous[50].last := 731
			mbyte_inst.ambiguous[51].first := 733
			mbyte_inst.ambiguous[51].last := 733
			mbyte_inst.ambiguous[52].first := 735
			mbyte_inst.ambiguous[52].last := 735
			mbyte_inst.ambiguous[53].first := 913
			mbyte_inst.ambiguous[53].last := 929
			mbyte_inst.ambiguous[54].first := 931
			mbyte_inst.ambiguous[54].last := 937
			mbyte_inst.ambiguous[55].first := 945
			mbyte_inst.ambiguous[55].last := 961
			mbyte_inst.ambiguous[56].first := 963
			mbyte_inst.ambiguous[56].last := 969
			mbyte_inst.ambiguous[57].first := 1025
			mbyte_inst.ambiguous[57].last := 1025
			mbyte_inst.ambiguous[58].first := 1040
			mbyte_inst.ambiguous[58].last := 1103
			mbyte_inst.ambiguous[59].first := 1105
			mbyte_inst.ambiguous[59].last := 1105
			mbyte_inst.ambiguous[60].first := 8208
			mbyte_inst.ambiguous[60].last := 8208
			mbyte_inst.ambiguous[61].first := 8211
			mbyte_inst.ambiguous[61].last := 8214
			mbyte_inst.ambiguous[62].first := 8216
			mbyte_inst.ambiguous[62].last := 8217
			mbyte_inst.ambiguous[63].first := 8220
			mbyte_inst.ambiguous[63].last := 8221
			mbyte_inst.ambiguous[64].first := 8224
			mbyte_inst.ambiguous[64].last := 8226
			mbyte_inst.ambiguous[65].first := 8228
			mbyte_inst.ambiguous[65].last := 8231
			mbyte_inst.ambiguous[66].first := 8240
			mbyte_inst.ambiguous[66].last := 8240
			mbyte_inst.ambiguous[67].first := 8242
			mbyte_inst.ambiguous[67].last := 8243
			mbyte_inst.ambiguous[68].first := 8245
			mbyte_inst.ambiguous[68].last := 8245
			mbyte_inst.ambiguous[69].first := 8251
			mbyte_inst.ambiguous[69].last := 8251
			mbyte_inst.ambiguous[70].first := 8254
			mbyte_inst.ambiguous[70].last := 8254
			mbyte_inst.ambiguous[71].first := 8308
			mbyte_inst.ambiguous[71].last := 8308
			mbyte_inst.ambiguous[72].first := 8319
			mbyte_inst.ambiguous[72].last := 8319
			mbyte_inst.ambiguous[73].first := 8321
			mbyte_inst.ambiguous[73].last := 8324
			mbyte_inst.ambiguous[74].first := 8364
			mbyte_inst.ambiguous[74].last := 8364
			mbyte_inst.ambiguous[75].first := 8451
			mbyte_inst.ambiguous[75].last := 8451
			mbyte_inst.ambiguous[76].first := 8453
			mbyte_inst.ambiguous[76].last := 8453
			mbyte_inst.ambiguous[77].first := 8457
			mbyte_inst.ambiguous[77].last := 8457
			mbyte_inst.ambiguous[78].first := 8467
			mbyte_inst.ambiguous[78].last := 8467
			mbyte_inst.ambiguous[79].first := 8470
			mbyte_inst.ambiguous[79].last := 8470
			mbyte_inst.ambiguous[80].first := 8481
			mbyte_inst.ambiguous[80].last := 8482
			mbyte_inst.ambiguous[81].first := 8486
			mbyte_inst.ambiguous[81].last := 8486
			mbyte_inst.ambiguous[82].first := 8491
			mbyte_inst.ambiguous[82].last := 8491
			mbyte_inst.ambiguous[83].first := 8531
			mbyte_inst.ambiguous[83].last := 8532
			mbyte_inst.ambiguous[84].first := 8539
			mbyte_inst.ambiguous[84].last := 8542
			mbyte_inst.ambiguous[85].first := 8544
			mbyte_inst.ambiguous[85].last := 8555
			mbyte_inst.ambiguous[86].first := 8560
			mbyte_inst.ambiguous[86].last := 8569
			mbyte_inst.ambiguous[87].first := 8585
			mbyte_inst.ambiguous[87].last := 8585
			mbyte_inst.ambiguous[88].first := 8592
			mbyte_inst.ambiguous[88].last := 8601
			mbyte_inst.ambiguous[89].first := 8632
			mbyte_inst.ambiguous[89].last := 8633
			mbyte_inst.ambiguous[90].first := 8658
			mbyte_inst.ambiguous[90].last := 8658
			mbyte_inst.ambiguous[91].first := 8660
			mbyte_inst.ambiguous[91].last := 8660
			mbyte_inst.ambiguous[92].first := 8679
			mbyte_inst.ambiguous[92].last := 8679
			mbyte_inst.ambiguous[93].first := 8704
			mbyte_inst.ambiguous[93].last := 8704
			mbyte_inst.ambiguous[94].first := 8706
			mbyte_inst.ambiguous[94].last := 8707
			mbyte_inst.ambiguous[95].first := 8711
			mbyte_inst.ambiguous[95].last := 8712
			mbyte_inst.ambiguous[96].first := 8715
			mbyte_inst.ambiguous[96].last := 8715
			mbyte_inst.ambiguous[97].first := 8719
			mbyte_inst.ambiguous[97].last := 8719
			mbyte_inst.ambiguous[98].first := 8721
			mbyte_inst.ambiguous[98].last := 8721
			mbyte_inst.ambiguous[99].first := 8725
			mbyte_inst.ambiguous[99].last := 8725
			mbyte_inst.ambiguous[100].first := 8730
			mbyte_inst.ambiguous[100].last := 8730
			mbyte_inst.ambiguous[101].first := 8733
			mbyte_inst.ambiguous[101].last := 8736
			mbyte_inst.ambiguous[102].first := 8739
			mbyte_inst.ambiguous[102].last := 8739
			mbyte_inst.ambiguous[103].first := 8741
			mbyte_inst.ambiguous[103].last := 8741
			mbyte_inst.ambiguous[104].first := 8743
			mbyte_inst.ambiguous[104].last := 8748
			mbyte_inst.ambiguous[105].first := 8750
			mbyte_inst.ambiguous[105].last := 8750
			mbyte_inst.ambiguous[106].first := 8756
			mbyte_inst.ambiguous[106].last := 8759
			mbyte_inst.ambiguous[107].first := 8764
			mbyte_inst.ambiguous[107].last := 8765
			mbyte_inst.ambiguous[108].first := 8776
			mbyte_inst.ambiguous[108].last := 8776
			mbyte_inst.ambiguous[109].first := 8780
			mbyte_inst.ambiguous[109].last := 8780
			mbyte_inst.ambiguous[110].first := 8786
			mbyte_inst.ambiguous[110].last := 8786
			mbyte_inst.ambiguous[111].first := 8800
			mbyte_inst.ambiguous[111].last := 8801
			mbyte_inst.ambiguous[112].first := 8804
			mbyte_inst.ambiguous[112].last := 8807
			mbyte_inst.ambiguous[113].first := 8810
			mbyte_inst.ambiguous[113].last := 8811
			mbyte_inst.ambiguous[114].first := 8814
			mbyte_inst.ambiguous[114].last := 8815
			mbyte_inst.ambiguous[115].first := 8834
			mbyte_inst.ambiguous[115].last := 8835
			mbyte_inst.ambiguous[116].first := 8838
			mbyte_inst.ambiguous[116].last := 8839
			mbyte_inst.ambiguous[117].first := 8853
			mbyte_inst.ambiguous[117].last := 8853
			mbyte_inst.ambiguous[118].first := 8857
			mbyte_inst.ambiguous[118].last := 8857
			mbyte_inst.ambiguous[119].first := 8869
			mbyte_inst.ambiguous[119].last := 8869
			mbyte_inst.ambiguous[120].first := 8895
			mbyte_inst.ambiguous[120].last := 8895
			mbyte_inst.ambiguous[121].first := 8978
			mbyte_inst.ambiguous[121].last := 8978
			mbyte_inst.ambiguous[122].first := 9312
			mbyte_inst.ambiguous[122].last := 9449
			mbyte_inst.ambiguous[123].first := 9451
			mbyte_inst.ambiguous[123].last := 9547
			mbyte_inst.ambiguous[124].first := 9552
			mbyte_inst.ambiguous[124].last := 9587
			mbyte_inst.ambiguous[125].first := 9600
			mbyte_inst.ambiguous[125].last := 9615
			mbyte_inst.ambiguous[126].first := 9618
			mbyte_inst.ambiguous[126].last := 9621
			mbyte_inst.ambiguous[127].first := 9632
			mbyte_inst.ambiguous[127].last := 9633
			mbyte_inst.ambiguous[128].first := 9635
			mbyte_inst.ambiguous[128].last := 9641
			mbyte_inst.ambiguous[129].first := 9650
			mbyte_inst.ambiguous[129].last := 9651
			mbyte_inst.ambiguous[130].first := 9654
			mbyte_inst.ambiguous[130].last := 9655
			mbyte_inst.ambiguous[131].first := 9660
			mbyte_inst.ambiguous[131].last := 9661
			mbyte_inst.ambiguous[132].first := 9664
			mbyte_inst.ambiguous[132].last := 9665
			mbyte_inst.ambiguous[133].first := 9670
			mbyte_inst.ambiguous[133].last := 9672
			mbyte_inst.ambiguous[134].first := 9675
			mbyte_inst.ambiguous[134].last := 9675
			mbyte_inst.ambiguous[135].first := 9678
			mbyte_inst.ambiguous[135].last := 9681
			mbyte_inst.ambiguous[136].first := 9698
			mbyte_inst.ambiguous[136].last := 9701
			mbyte_inst.ambiguous[137].first := 9711
			mbyte_inst.ambiguous[137].last := 9711
			mbyte_inst.ambiguous[138].first := 9733
			mbyte_inst.ambiguous[138].last := 9734
			mbyte_inst.ambiguous[139].first := 9737
			mbyte_inst.ambiguous[139].last := 9737
			mbyte_inst.ambiguous[140].first := 9742
			mbyte_inst.ambiguous[140].last := 9743
			mbyte_inst.ambiguous[141].first := 9748
			mbyte_inst.ambiguous[141].last := 9749
			mbyte_inst.ambiguous[142].first := 9756
			mbyte_inst.ambiguous[142].last := 9756
			mbyte_inst.ambiguous[143].first := 9758
			mbyte_inst.ambiguous[143].last := 9758
			mbyte_inst.ambiguous[144].first := 9792
			mbyte_inst.ambiguous[144].last := 9792
			mbyte_inst.ambiguous[145].first := 9794
			mbyte_inst.ambiguous[145].last := 9794
			mbyte_inst.ambiguous[146].first := 9824
			mbyte_inst.ambiguous[146].last := 9825
			mbyte_inst.ambiguous[147].first := 9827
			mbyte_inst.ambiguous[147].last := 9829
			mbyte_inst.ambiguous[148].first := 9831
			mbyte_inst.ambiguous[148].last := 9834
			mbyte_inst.ambiguous[149].first := 9836
			mbyte_inst.ambiguous[149].last := 9837
			mbyte_inst.ambiguous[150].first := 9839
			mbyte_inst.ambiguous[150].last := 9839
			mbyte_inst.ambiguous[151].first := 9886
			mbyte_inst.ambiguous[151].last := 9887
			mbyte_inst.ambiguous[152].first := 9918
			mbyte_inst.ambiguous[152].last := 9919
			mbyte_inst.ambiguous[153].first := 9924
			mbyte_inst.ambiguous[153].last := 9933
			mbyte_inst.ambiguous[154].first := 9935
			mbyte_inst.ambiguous[154].last := 9953
			mbyte_inst.ambiguous[155].first := 9955
			mbyte_inst.ambiguous[155].last := 9955
			mbyte_inst.ambiguous[156].first := 9960
			mbyte_inst.ambiguous[156].last := 9983
			mbyte_inst.ambiguous[157].first := 10045
			mbyte_inst.ambiguous[157].last := 10045
			mbyte_inst.ambiguous[158].first := 10071
			mbyte_inst.ambiguous[158].last := 10071
			mbyte_inst.ambiguous[159].first := 10102
			mbyte_inst.ambiguous[159].last := 10111
			mbyte_inst.ambiguous[160].first := 11093
			mbyte_inst.ambiguous[160].last := 11097
			mbyte_inst.ambiguous[161].first := 12872
			mbyte_inst.ambiguous[161].last := 12879
			mbyte_inst.ambiguous[162].first := 57344
			mbyte_inst.ambiguous[162].last := 63743
			mbyte_inst.ambiguous[163].first := 65533
			mbyte_inst.ambiguous[163].last := 65533
			mbyte_inst.ambiguous[164].first := 127232
			mbyte_inst.ambiguous[164].last := 127242
			mbyte_inst.ambiguous[165].first := 127248
			mbyte_inst.ambiguous[165].last := 127277
			mbyte_inst.ambiguous[166].first := 127281
			mbyte_inst.ambiguous[166].last := 127281
			mbyte_inst.ambiguous[167].first := 127293
			mbyte_inst.ambiguous[167].last := 127293
			mbyte_inst.ambiguous[168].first := 127295
			mbyte_inst.ambiguous[168].last := 127295
			mbyte_inst.ambiguous[169].first := 127298
			mbyte_inst.ambiguous[169].last := 127298
			mbyte_inst.ambiguous[170].first := 127302
			mbyte_inst.ambiguous[170].last := 127302
			mbyte_inst.ambiguous[171].first := 127306
			mbyte_inst.ambiguous[171].last := 127310
			mbyte_inst.ambiguous[172].first := 127319
			mbyte_inst.ambiguous[172].last := 127319
			mbyte_inst.ambiguous[173].first := 127327
			mbyte_inst.ambiguous[173].last := 127327
			mbyte_inst.ambiguous[174].first := 127353
			mbyte_inst.ambiguous[174].last := 127353
			mbyte_inst.ambiguous[175].first := 127355
			mbyte_inst.ambiguous[175].last := 127356
			mbyte_inst.ambiguous[176].first := 127359
			mbyte_inst.ambiguous[176].last := 127359
			mbyte_inst.ambiguous[177].first := 127370
			mbyte_inst.ambiguous[177].last := 127373
		end

end
