frozen class
	VIM_INITIALIZER_SLICE45

inherit
	VIM_DATA
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {VIM_INITIALIZER}

	initialize
		do
			option_inst.options[330].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_udf_address))
			option_inst.options[330].indir := 16453
			option_inst.options[330].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[330].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[330].scriptID := 0
			option_inst.options[331].fullname := ce_string ("undolevels")
			option_inst.options[331].shortname := ce_string ("ul")
			option_inst.options[331].flags := (1026).to_natural_32
			option_inst.options[331].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_ul_address))
			option_inst.options[331].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[331].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 1000)
			option_inst.options[331].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[331].scriptID := 0
			option_inst.options[332].fullname := ce_string ("undoreload")
			option_inst.options[332].shortname := ce_string ("ur")
			option_inst.options[332].flags := (1026).to_natural_32
			option_inst.options[332].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_ur_address))
			option_inst.options[332].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[332].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 10000)
			option_inst.options[332].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[332].scriptID := 0
			option_inst.options[333].fullname := ce_string ("updatecount")
			option_inst.options[333].shortname := ce_string ("uc")
			option_inst.options[333].flags := (1026).to_natural_32
			option_inst.options[333].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_uc_address))
			option_inst.options[333].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[333].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 200)
			option_inst.options[333].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[333].scriptID := 0
			option_inst.options[334].fullname := ce_string ("updatetime")
			option_inst.options[334].shortname := ce_string ("ut")
			option_inst.options[334].flags := (1026).to_natural_32
			option_inst.options[334].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_ut_address))
			option_inst.options[334].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[334].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 4000)
			option_inst.options[334].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[334].scriptID := 0
			option_inst.options[335].fullname := ce_string ("verbose")
			option_inst.options[335].shortname := ce_string ("vbs")
			option_inst.options[335].flags := (1026).to_natural_32
			option_inst.options[335].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_verbose_address))
			option_inst.options[335].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[335].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[335].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[335].scriptID := 0
			option_inst.options[336].fullname := ce_string ("verbosefile")
			option_inst.options[336].shortname := ce_string ("vfile")
			option_inst.options[336].flags := (263188).to_natural_32
			option_inst.options[336].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_vfile.address))
			option_inst.options[336].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[336].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[336].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[336].scriptID := 0
			option_inst.options[337].fullname := ce_string ("viewdir")
			option_inst.options[337].shortname := ce_string ("vdir")
			option_inst.options[337].flags := (263188).to_natural_32
			option_inst.options[337].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_vdir.address))
			option_inst.options[337].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[337].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("$HOME/.vim/view"))
			option_inst.options[337].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[337].scriptID := 0
			option_inst.options[338].fullname := ce_string ("viewoptions")
			option_inst.options[338].shortname := ce_string ("vop")
			option_inst.options[338].flags := (99332).to_natural_32
			option_inst.options[338].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_vop.address))
			option_inst.options[338].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[338].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("folds,options,cursor"))
			option_inst.options[338].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[338].scriptID := 0
			option_inst.options[339].fullname := ce_string ("viminfo")
			option_inst.options[339].shortname := ce_string ("vi")
			option_inst.options[339].flags := (360452).to_natural_32
			option_inst.options[339].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_viminfo.address))
			option_inst.options[339].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[339].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[339].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%'100,<50,s10,h"))
			option_inst.options[339].scriptID := 0
			option_inst.options[340].fullname := ce_string ("virtualedit")
			option_inst.options[340].shortname := ce_string ("ve")
			option_inst.options[340].flags := (101380).to_natural_32
			option_inst.options[340].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_ve.address))
			option_inst.options[340].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[340].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[340].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[340].scriptID := 0
			option_inst.options[341].fullname := ce_string ("visualbell")
			option_inst.options[341].shortname := ce_string ("vb")
			option_inst.options[341].flags := (1025).to_natural_32
			option_inst.options[341].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_vb_address))
			option_inst.options[341].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[341].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[341].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[341].scriptID := 0
			option_inst.options[342].fullname := ce_string ("w300")
			option_inst.options[342].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[342].flags := (1026).to_natural_32
			option_inst.options[342].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[342].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[342].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[342].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[342].scriptID := 0
			option_inst.options[343].fullname := ce_string ("w1200")
			option_inst.options[343].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[343].flags := (1026).to_natural_32
			option_inst.options[343].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[343].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[343].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[343].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[343].scriptID := 0
			option_inst.options[344].fullname := ce_string ("w9600")
			option_inst.options[344].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[344].flags := (1026).to_natural_32
			option_inst.options[344].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[344].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[344].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[344].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[344].scriptID := 0
			option_inst.options[345].fullname := ce_string ("warn")
			option_inst.options[345].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[345].flags := (1025).to_natural_32
			option_inst.options[345].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_warn_address))
			option_inst.options[345].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[345].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 1)
			option_inst.options[345].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[345].scriptID := 0
			option_inst.options[346].fullname := ce_string ("weirdinvert")
			option_inst.options[346].shortname := ce_string ("wiv")
			option_inst.options[346].flags := (29697).to_natural_32
			option_inst.options[346].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_wiv_address))
			option_inst.options[346].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[346].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[346].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[346].scriptID := 0
			option_inst.options[347].fullname := ce_string ("whichwrap")
			option_inst.options[347].shortname := ce_string ("ww")
			option_inst.options[347].flags := (165892).to_natural_32
			option_inst.options[347].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_ww.address))
			option_inst.options[347].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[347].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[347].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("b,s"))
			option_inst.options[347].scriptID := 0
			option_inst.options[348].fullname := ce_string ("wildchar")
			option_inst.options[348].shortname := ce_string ("wc")
			option_inst.options[348].flags := (2050).to_natural_32
			option_inst.options[348].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_wc_address))
			option_inst.options[348].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[348].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 5)
			option_inst.options[348].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + ('%T').code)
			option_inst.options[348].scriptID := 0
			option_inst.options[349].fullname := ce_string ("wildcharm")
			option_inst.options[349].shortname := ce_string ("wcm")
			option_inst.options[349].flags := (1026).to_natural_32
			option_inst.options[349].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_wcm_address))
			option_inst.options[349].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[349].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[349].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[349].scriptID := 0
			option_inst.options[350].fullname := ce_string ("wildignore")
			option_inst.options[350].shortname := ce_string ("wig")
			option_inst.options[350].flags := (99332).to_natural_32
			option_inst.options[350].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_wig.address))
			option_inst.options[350].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[350].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[350].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[350].scriptID := 0
			option_inst.options[351].fullname := ce_string ("wildmenu")
			option_inst.options[351].shortname := ce_string ("wmnu")
			option_inst.options[351].flags := (1025).to_natural_32
			option_inst.options[351].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_wmnu_address))
			option_inst.options[351].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[351].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[351].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[351].scriptID := 0
			option_inst.options[352].fullname := ce_string ("wildmode")
			option_inst.options[352].shortname := ce_string ("wim")
			option_inst.options[352].flags := (99332).to_natural_32
			option_inst.options[352].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_wim.address))
			option_inst.options[352].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[352].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("full"))
			option_inst.options[352].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[352].scriptID := 0
			option_inst.options[353].fullname := ce_string ("wildoptions")
			option_inst.options[353].shortname := ce_string ("wop")
			option_inst.options[353].flags := (1028).to_natural_32
			option_inst.options[353].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_wop.address))
			option_inst.options[353].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[353].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[353].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[353].scriptID := 0
			option_inst.options[354].fullname := ce_string ("winaltkeys")
			option_inst.options[354].shortname := ce_string ("wak")
			option_inst.options[354].flags := (1028).to_natural_32
			option_inst.options[354].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_wak.address))
			option_inst.options[354].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[354].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu"))
			option_inst.options[354].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[354].scriptID := 0
			option_inst.options[355].fullname := ce_string ("window")
			option_inst.options[355].shortname := ce_string ("wi")
			option_inst.options[355].flags := (1026).to_natural_32
			option_inst.options[355].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_window_address))
			option_inst.options[355].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[355].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[355].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[355].scriptID := 0
			option_inst.options[356].fullname := ce_string ("winheight")
			option_inst.options[356].shortname := ce_string ("wh")
			option_inst.options[356].flags := (1026).to_natural_32
			option_inst.options[356].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_wh_address))
			option_inst.options[356].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[356].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 1)
			option_inst.options[356].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[356].scriptID := 0
			option_inst.options[357].fullname := ce_string ("winfixheight")
			option_inst.options[357].shortname := ce_string ("wfh")
			option_inst.options[357].flags := (5121).to_natural_32
			option_inst.options[357].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + -1)
			option_inst.options[357].indir := 8217
			option_inst.options[357].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[357].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[357].scriptID := 0
			option_inst.options[358].fullname := ce_string ("winfixwidth")
			option_inst.options[358].shortname := ce_string ("wfw")
			option_inst.options[358].flags := (5121).to_natural_32
			option_inst.options[358].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + -1)
			option_inst.options[358].indir := 8218
			option_inst.options[358].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[358].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[358].scriptID := 0
			option_inst.options[359].fullname := ce_string ("winminheight")
			option_inst.options[359].shortname := ce_string ("wmh")
			option_inst.options[359].flags := (1026).to_natural_32
			option_inst.options[359].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_wmh_address))
			option_inst.options[359].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[359].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 1)
			option_inst.options[359].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[359].scriptID := 0
			option_inst.options[360].fullname := ce_string ("winminwidth")
			option_inst.options[360].shortname := ce_string ("wmw")
			option_inst.options[360].flags := (1026).to_natural_32
			option_inst.options[360].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_wmw_address))
			option_inst.options[360].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[360].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 1)
			option_inst.options[360].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[360].scriptID := 0
			option_inst.options[361].fullname := ce_string ("winwidth")
			option_inst.options[361].shortname := ce_string ("wiw")
			option_inst.options[361].flags := (1026).to_natural_32
			option_inst.options[361].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_wiw_address))
			option_inst.options[361].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[361].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 20)
			option_inst.options[361].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[361].scriptID := 0
			option_inst.options[362].fullname := ce_string ("wrap")
			option_inst.options[362].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[362].flags := (9217).to_natural_32
			option_inst.options[362].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + -1)
			option_inst.options[362].indir := 8219
			option_inst.options[362].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 1)
			option_inst.options[362].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[362].scriptID := 0
			option_inst.options[363].fullname := ce_string ("wrapmargin")
			option_inst.options[363].shortname := ce_string ("wm")
			option_inst.options[363].flags := (1026).to_natural_32
			option_inst.options[363].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_wm_address))
			option_inst.options[363].indir := 16454
			option_inst.options[363].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[363].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[363].scriptID := 0
			option_inst.options[364].fullname := ce_string ("wrapscan")
			option_inst.options[364].shortname := ce_string ("ws")
			option_inst.options[364].flags := (1025).to_natural_32
			option_inst.options[364].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_ws_address))
			option_inst.options[364].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[364].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 1)
			option_inst.options[364].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[364].scriptID := 0
			option_inst.options[365].fullname := ce_string ("write")
			option_inst.options[365].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[365].flags := (1025).to_natural_32
			option_inst.options[365].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_write_address))
			option_inst.options[365].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[365].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 1)
			option_inst.options[365].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[365].scriptID := 0
			option_inst.options[366].fullname := ce_string ("writeany")
			option_inst.options[366].shortname := ce_string ("wa")
			option_inst.options[366].flags := (1025).to_natural_32
			option_inst.options[366].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_wa_address))
			option_inst.options[366].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[366].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[366].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[366].scriptID := 0
			option_inst.options[367].fullname := ce_string ("writebackup")
			option_inst.options[367].shortname := ce_string ("wb")
			option_inst.options[367].flags := (3073).to_natural_32
			option_inst.options[367].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_wb_address))
			option_inst.options[367].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[367].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 1)
			option_inst.options[367].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[367].scriptID := 0
			option_inst.options[368].fullname := ce_string ("writedelay")
			option_inst.options[368].shortname := ce_string ("wd")
			option_inst.options[368].flags := (1026).to_natural_32
			option_inst.options[368].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_wd_address))
			option_inst.options[368].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[368].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[368].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[368].scriptID := 0
			option_inst.options[369].fullname := ce_string ("t_AB")
			option_inst.options[369].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[369].flags := (287748).to_natural_32
			option_inst.options[369].var := create {CE_POINTER [NATURAL_8]}.make_cast ((term_inst.term_strings + 43))
			option_inst.options[369].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[369].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[369].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[369].scriptID := 0
			option_inst.options[370].fullname := ce_string ("t_AF")
			option_inst.options[370].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[370].flags := (287748).to_natural_32
			option_inst.options[370].var := create {CE_POINTER [NATURAL_8]}.make_cast ((term_inst.term_strings + 42))
			option_inst.options[370].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[370].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[370].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[370].scriptID := 0
			option_inst.options[371].fullname := ce_string ("t_AL")
			option_inst.options[371].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[371].flags := (287748).to_natural_32
			option_inst.options[371].var := create {CE_POINTER [NATURAL_8]}.make_cast ((term_inst.term_strings + 3))
			option_inst.options[371].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[371].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[371].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[371].scriptID := 0
			option_inst.options[372].fullname := ce_string ("t_al")
			option_inst.options[372].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[372].flags := (287748).to_natural_32
			option_inst.options[372].var := create {CE_POINTER [NATURAL_8]}.make_cast ((term_inst.term_strings + 2))
			option_inst.options[372].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[372].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[372].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[372].scriptID := 0
			option_inst.options[373].fullname := ce_string ("t_bc")
			option_inst.options[373].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[373].flags := (287748).to_natural_32
			option_inst.options[373].var := create {CE_POINTER [NATURAL_8]}.make_cast ((term_inst.term_strings + 35))
			option_inst.options[373].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[373].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[373].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[373].scriptID := 0
			option_inst.options[374].fullname := ce_string ("t_cd")
			option_inst.options[374].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[374].flags := (287748).to_natural_32
			option_inst.options[374].var := create {CE_POINTER [NATURAL_8]}.make_cast ((term_inst.term_strings + 8))
			option_inst.options[374].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[374].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[374].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[374].scriptID := 0
			option_inst.options[375].fullname := ce_string ("t_ce")
			option_inst.options[375].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[375].flags := (287748).to_natural_32
			option_inst.options[375].var := create {CE_POINTER [NATURAL_8]}.make_cast ((term_inst.term_strings + 1))
			option_inst.options[375].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[375].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[375].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[375].scriptID := 0
			option_inst.options[376].fullname := ce_string ("t_cl")
			option_inst.options[376].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[376].flags := (287748).to_natural_32
			option_inst.options[376].var := create {CE_POINTER [NATURAL_8]}.make_cast ((term_inst.term_strings + 7))
			option_inst.options[376].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[376].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[376].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[376].scriptID := 0
			option_inst.options[377].fullname := ce_string ("t_cm")
			option_inst.options[377].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[377].flags := (287748).to_natural_32
			option_inst.options[377].var := create {CE_POINTER [NATURAL_8]}.make_cast ((term_inst.term_strings + 27))
			option_inst.options[377].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[377].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[377].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[377].scriptID := 0
			option_inst.options[378].fullname := ce_string ("t_Co")
			option_inst.options[378].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[378].flags := (287748).to_natural_32
			option_inst.options[378].var := create {CE_POINTER [NATURAL_8]}.make_cast ((term_inst.term_strings + 37))
			option_inst.options[378].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[378].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[378].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[378].scriptID := 0
			option_inst.options[379].fullname := ce_string ("t_CS")
			option_inst.options[379].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[379].flags := (287748).to_natural_32
			option_inst.options[379].var := create {CE_POINTER [NATURAL_8]}.make_cast ((term_inst.term_strings + 36))
			option_inst.options[379].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[379].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[379].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[379].scriptID := 0
			option_inst.options[380].fullname := ce_string ("t_cs")
			option_inst.options[380].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[380].flags := (287748).to_natural_32
			option_inst.options[380].var := create {CE_POINTER [NATURAL_8]}.make_cast ((term_inst.term_strings + 6))
			option_inst.options[380].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[380].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[380].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[380].scriptID := 0
			option_inst.options[381].fullname := ce_string ("t_CV")
			option_inst.options[381].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[381].flags := (287748).to_natural_32
			option_inst.options[381].var := create {CE_POINTER [NATURAL_8]}.make_cast ((term_inst.term_strings + 55))
			option_inst.options[381].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[381].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[381].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[381].scriptID := 0
			option_inst.options[382].fullname := ce_string ("t_ut")
			option_inst.options[382].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[382].flags := (287748).to_natural_32
			option_inst.options[382].var := create {CE_POINTER [NATURAL_8]}.make_cast ((term_inst.term_strings + 9))
			option_inst.options[382].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[382].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[382].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[382].scriptID := 0
			option_inst.options[383].fullname := ce_string ("t_da")
			option_inst.options[383].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[383].flags := (287748).to_natural_32
			option_inst.options[383].var := create {CE_POINTER [NATURAL_8]}.make_cast ((term_inst.term_strings + 10))
			option_inst.options[383].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[383].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[383].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[383].scriptID := 0
			option_inst.options[384].fullname := ce_string ("t_db")
			option_inst.options[384].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[384].flags := (287748).to_natural_32
			option_inst.options[384].var := create {CE_POINTER [NATURAL_8]}.make_cast ((term_inst.term_strings + 11))
			option_inst.options[384].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[384].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[384].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[384].scriptID := 0
			option_inst.options[385].fullname := ce_string ("t_DL")
			option_inst.options[385].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[385].flags := (287748).to_natural_32
			option_inst.options[385].var := create {CE_POINTER [NATURAL_8]}.make_cast ((term_inst.term_strings + 5))
			option_inst.options[385].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[385].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[385].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[385].scriptID := 0
			option_inst.options[386].fullname := ce_string ("t_dl")
			option_inst.options[386].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[386].flags := (287748).to_natural_32
			option_inst.options[386].var := create {CE_POINTER [NATURAL_8]}.make_cast ((term_inst.term_strings + 4))
			option_inst.options[386].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[386].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[386].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[386].scriptID := 0
			option_inst.options[387].fullname := ce_string ("t_fs")
			option_inst.options[387].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[387].flags := (287748).to_natural_32
			option_inst.options[387].var := create {CE_POINTER [NATURAL_8]}.make_cast ((term_inst.term_strings + 49))
			option_inst.options[387].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[387].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[387].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[387].scriptID := 0
			option_inst.options[388].fullname := ce_string ("t_IE")
			option_inst.options[388].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[388].flags := (287748).to_natural_32
			option_inst.options[388].var := create {CE_POINTER [NATURAL_8]}.make_cast ((term_inst.term_strings + 47))
			option_inst.options[388].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[388].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[388].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[388].scriptID := 0
			option_inst.options[389].fullname := ce_string ("t_IS")
			option_inst.options[389].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[389].flags := (287748).to_natural_32
			option_inst.options[389].var := create {CE_POINTER [NATURAL_8]}.make_cast ((term_inst.term_strings + 46))
			option_inst.options[389].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[389].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[389].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[389].scriptID := 0
			option_inst.options[390].fullname := ce_string ("t_ke")
			option_inst.options[390].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[390].flags := (287748).to_natural_32
			option_inst.options[390].var := create {CE_POINTER [NATURAL_8]}.make_cast ((term_inst.term_strings + 32))
			option_inst.options[390].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[390].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[390].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[390].scriptID := 0
			option_inst.options[391].fullname := ce_string ("t_ks")
			option_inst.options[391].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[391].flags := (287748).to_natural_32
			option_inst.options[391].var := create {CE_POINTER [NATURAL_8]}.make_cast ((term_inst.term_strings + 31))
			option_inst.options[391].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[391].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[391].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[391].scriptID := 0
			option_inst.options[392].fullname := ce_string ("t_le")
			option_inst.options[392].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[392].flags := (287748).to_natural_32
			option_inst.options[392].var := create {CE_POINTER [NATURAL_8]}.make_cast ((term_inst.term_strings + 44))
			option_inst.options[392].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[392].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[392].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
		end

end
