frozen class
	VIM_INITIALIZER_SLICE48

inherit
	VIM_DATA
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {VIM_INITIALIZER}

	initialize
		do
			syntax_inst.hl_attr_table[3] := 16
			syntax_inst.hl_attr_table[4] := 4
			syntax_inst.hl_attr_table[5] := 1
			syntax_inst.hl_attr_table[6] := 1
			syntax_inst.hl_attr_table[7] := 0
			syntax_inst.spo_name_tab[0] := ce_string ("ms=")
			syntax_inst.spo_name_tab[1] := ce_string ("me=")
			syntax_inst.spo_name_tab[2] := ce_string ("hs=")
			syntax_inst.spo_name_tab[3] := ce_string ("he=")
			syntax_inst.spo_name_tab[4] := ce_string ("rs=")
			syntax_inst.spo_name_tab[5] := ce_string ("re=")
			syntax_inst.spo_name_tab[6] := ce_string ("lc=")
			syntax_inst.current_attr := 0
			syntax_inst.current_id := 0
			syntax_inst.current_trans_id := 0
			syntax_inst.current_syn_inc_tag := 0
			syntax_inst.running_syn_inc_tag := 0
			syntax_inst.keepend_level := -1
			syntax_inst.next_match_extmatch.ce_gets (create {CE_POINTER [PD_REG_EXTMATCH_T]}.make_shared (default_pointer))
			syntax_inst.current_lnum := (0).to_integer_32
			syntax_inst.current_col := 0
			syntax_inst.current_state_stored := 0
			syntax_inst.current_finished := 0
			syntax_inst.current_state.ga_len := 0
			syntax_inst.current_state.ga_maxlen := 0
			syntax_inst.current_state.ga_itemsize := 0
			syntax_inst.current_state.ga_growsize := 0
			syntax_inst.current_state.ga_data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			syntax_inst.current_next_list.ce_gets (create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer))
			syntax_inst.current_next_flags := 0
			syntax_inst.current_line_id := 0
			syntax_inst.changedtick___0 := 0
			syntax_inst.try_next_column := 0
			syntax_inst.namelist1[0].flag := 4096
			syntax_inst.namelist1[0].name := ce_string ("display")
			syntax_inst.namelist1[1].flag := 1
			syntax_inst.namelist1[1].name := ce_string ("contained")
			syntax_inst.namelist1[2].flag := 4
			syntax_inst.namelist1[2].name := ce_string ("oneline")
			syntax_inst.namelist1[3].flag := 1024
			syntax_inst.namelist1[3].name := ce_string ("keepend")
			syntax_inst.namelist1[4].flag := 16384
			syntax_inst.namelist1[4].name := ce_string ("extend")
			syntax_inst.namelist1[5].flag := 2048
			syntax_inst.namelist1[5].name := ce_string ("excludenl")
			syntax_inst.namelist1[6].flag := 2
			syntax_inst.namelist1[6].name := ce_string ("transparent")
			syntax_inst.namelist1[7].flag := 8192
			syntax_inst.namelist1[7].name := ce_string ("fold")
			syntax_inst.namelist1[8].flag := 0
			syntax_inst.namelist1[8].name := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			syntax_inst.namelist2[0].flag := 256
			syntax_inst.namelist2[0].name := ce_string ("skipwhite")
			syntax_inst.namelist2[1].flag := 128
			syntax_inst.namelist2[1].name := ce_string ("skipnl")
			syntax_inst.namelist2[2].flag := 512
			syntax_inst.namelist2[2].name := ce_string ("skipempty")
			syntax_inst.namelist2[3].flag := 0
			syntax_inst.namelist2[3].name := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			syntax_inst.sepchars.ce_gets (ce_string ("/+=-#@%"|%'^&"))
			syntax_inst.flagtab[0].name := ce_string ("cCoOnNtTaAiInNeEdD")
			syntax_inst.flagtab[0].argtype := 0
			syntax_inst.flagtab[0].flags := 1
			syntax_inst.flagtab[1].name := ce_string ("oOnNeElLiInNeE")
			syntax_inst.flagtab[1].argtype := 0
			syntax_inst.flagtab[1].flags := 4
			syntax_inst.flagtab[2].name := ce_string ("kKeEeEpPeEnNdD")
			syntax_inst.flagtab[2].argtype := 0
			syntax_inst.flagtab[2].flags := 1024
			syntax_inst.flagtab[3].name := ce_string ("eExXtTeEnNdD")
			syntax_inst.flagtab[3].argtype := 0
			syntax_inst.flagtab[3].flags := 16384
			syntax_inst.flagtab[4].name := ce_string ("eExXcClLuUdDeEnNlL")
			syntax_inst.flagtab[4].argtype := 0
			syntax_inst.flagtab[4].flags := 2048
			syntax_inst.flagtab[5].name := ce_string ("tTrRaAnNsSpPaArReEnNtT")
			syntax_inst.flagtab[5].argtype := 0
			syntax_inst.flagtab[5].flags := 2
			syntax_inst.flagtab[6].name := ce_string ("sSkKiIpPnNlL")
			syntax_inst.flagtab[6].argtype := 0
			syntax_inst.flagtab[6].flags := 128
			syntax_inst.flagtab[7].name := ce_string ("sSkKiIpPwWhHiItTeE")
			syntax_inst.flagtab[7].argtype := 0
			syntax_inst.flagtab[7].flags := 256
			syntax_inst.flagtab[8].name := ce_string ("sSkKiIpPeEmMpPtTyY")
			syntax_inst.flagtab[8].argtype := 0
			syntax_inst.flagtab[8].flags := 512
			syntax_inst.flagtab[9].name := ce_string ("gGrRoOuUpPhHeErReE")
			syntax_inst.flagtab[9].argtype := 0
			syntax_inst.flagtab[9].flags := 16
			syntax_inst.flagtab[10].name := ce_string ("gGrRoOuUpPtThHeErReE")
			syntax_inst.flagtab[10].argtype := 0
			syntax_inst.flagtab[10].flags := 32
			syntax_inst.flagtab[11].name := ce_string ("dDiIsSpPlLaAyY")
			syntax_inst.flagtab[11].argtype := 0
			syntax_inst.flagtab[11].flags := 4096
			syntax_inst.flagtab[12].name := ce_string ("fFoOlLdD")
			syntax_inst.flagtab[12].argtype := 0
			syntax_inst.flagtab[12].flags := 8192
			syntax_inst.flagtab[13].name := ce_string ("cCoOnNcCeEaAlL")
			syntax_inst.flagtab[13].argtype := 0
			syntax_inst.flagtab[13].flags := 131072
			syntax_inst.flagtab[14].name := ce_string ("cCoOnNcCeEaAlLeEnNdDsS")
			syntax_inst.flagtab[14].argtype := 0
			syntax_inst.flagtab[14].flags := 262144
			syntax_inst.flagtab[15].name := ce_string ("cCcChHaArR")
			syntax_inst.flagtab[15].argtype := 11
			syntax_inst.flagtab[15].flags := 0
			syntax_inst.flagtab[16].name := ce_string ("cCoOnNtTaAiInNsS")
			syntax_inst.flagtab[16].argtype := 1
			syntax_inst.flagtab[16].flags := 0
			syntax_inst.flagtab[17].name := ce_string ("cCoOnNtTaAiInNeEdDiInN")
			syntax_inst.flagtab[17].argtype := 2
			syntax_inst.flagtab[17].flags := 0
			syntax_inst.flagtab[18].name := ce_string ("nNeExXtTgGrRoOuUpP")
			syntax_inst.flagtab[18].argtype := 3
			syntax_inst.flagtab[18].flags := 0
			syntax_inst.first_letters.ce_gets (ce_string ("cCoOkKeEtTsSgGdDfFnN"))
			syntax_inst.depth___0 := 0
			syntax_inst.subcommands[0].name := ce_string ("case")
			syntax_inst.subcommands[0].func := syntax_inst.syn_cmd_case_address
			syntax_inst.subcommands[1].name := ce_string ("clear")
			syntax_inst.subcommands[1].func := syntax_inst.syn_cmd_clear_address
			syntax_inst.subcommands[2].name := ce_string ("cluster")
			syntax_inst.subcommands[2].func := syntax_inst.syn_cmd_cluster_address
			syntax_inst.subcommands[3].name := ce_string ("conceal")
			syntax_inst.subcommands[3].func := syntax_inst.syn_cmd_conceal_address
			syntax_inst.subcommands[4].name := ce_string ("enable")
			syntax_inst.subcommands[4].func := syntax_inst.syn_cmd_enable_address
			syntax_inst.subcommands[5].name := ce_string ("include")
			syntax_inst.subcommands[5].func := syntax_inst.syn_cmd_include_address
			syntax_inst.subcommands[6].name := ce_string ("keyword")
			syntax_inst.subcommands[6].func := syntax_inst.syn_cmd_keyword_address
			syntax_inst.subcommands[7].name := ce_string ("list")
			syntax_inst.subcommands[7].func := syntax_inst.syn_cmd_list_address
			syntax_inst.subcommands[8].name := ce_string ("manual")
			syntax_inst.subcommands[8].func := syntax_inst.syn_cmd_manual_address
			syntax_inst.subcommands[9].name := ce_string ("match")
			syntax_inst.subcommands[9].func := syntax_inst.syn_cmd_match_address
			syntax_inst.subcommands[10].name := ce_string ("on")
			syntax_inst.subcommands[10].func := syntax_inst.syn_cmd_on_address
			syntax_inst.subcommands[11].name := ce_string ("off")
			syntax_inst.subcommands[11].func := syntax_inst.syn_cmd_off_address
			syntax_inst.subcommands[12].name := ce_string ("region")
			syntax_inst.subcommands[12].func := syntax_inst.syn_cmd_region_address
			syntax_inst.subcommands[13].name := ce_string ("reset")
			syntax_inst.subcommands[13].func := syntax_inst.syn_cmd_reset_address
			syntax_inst.subcommands[14].name := ce_string ("spell")
			syntax_inst.subcommands[14].func := syntax_inst.syn_cmd_spell_address
			syntax_inst.subcommands[15].name := ce_string ("sync")
			syntax_inst.subcommands[15].func := syntax_inst.syn_cmd_sync_address
			syntax_inst.subcommands[16].name := ce_string ("")
			syntax_inst.subcommands[16].func := syntax_inst.syn_cmd_list_address
			syntax_inst.subcommands[17].name := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			syntax_inst.subcommands[17].func := create {CE_ROUTINE}.make_shared (default_pointer)
			syntax_inst.case_args[0] := ce_string ("match")
			syntax_inst.case_args[1] := ce_string ("ignore")
			syntax_inst.case_args[2] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			syntax_inst.highlight_init_both[0] := ce_string ("ErrorMsg term=standout ctermbg=DarkRed ctermfg=White guibg=Red guifg=White")
			syntax_inst.highlight_init_both[1] := ce_string ("IncSearch term=reverse cterm=reverse gui=reverse")
			syntax_inst.highlight_init_both[2] := ce_string ("ModeMsg term=bold cterm=bold gui=bold")
			syntax_inst.highlight_init_both[3] := ce_string ("NonText term=bold ctermfg=Blue gui=bold guifg=Blue")
			syntax_inst.highlight_init_both[4] := ce_string ("StatusLine term=reverse,bold cterm=reverse,bold gui=reverse,bold")
			syntax_inst.highlight_init_both[5] := ce_string ("StatusLineNC term=reverse cterm=reverse gui=reverse")
			syntax_inst.highlight_init_both[6] := ce_string ("VertSplit term=reverse cterm=reverse gui=reverse")
			syntax_inst.highlight_init_both[7] := ce_string ("VisualNOS term=underline,bold cterm=underline,bold gui=underline,bold")
			syntax_inst.highlight_init_both[8] := ce_string ("DiffText term=reverse cterm=bold ctermbg=Red gui=bold guibg=Red")
			syntax_inst.highlight_init_both[9] := ce_string ("PmenuThumb cterm=reverse gui=reverse")
			syntax_inst.highlight_init_both[10] := ce_string ("PmenuSbar ctermbg=Grey guibg=Grey")
			syntax_inst.highlight_init_both[11] := ce_string ("TabLineSel term=bold cterm=bold gui=bold")
			syntax_inst.highlight_init_both[12] := ce_string ("TabLineFill term=reverse cterm=reverse gui=reverse")
			syntax_inst.highlight_init_both[13] := ce_string ("Cursor guibg=fg guifg=bg")
			syntax_inst.highlight_init_both[14] := ce_string ("lCursor guibg=fg guifg=bg")
			syntax_inst.highlight_init_both[15] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			syntax_inst.highlight_init_light[0] := ce_string ("Directory term=bold ctermfg=DarkBlue guifg=Blue")
			syntax_inst.highlight_init_light[1] := ce_string ("LineNr term=underline ctermfg=Brown guifg=Brown")
			syntax_inst.highlight_init_light[2] := ce_string ("MoreMsg term=bold ctermfg=DarkGreen gui=bold guifg=SeaGreen")
			syntax_inst.highlight_init_light[3] := ce_string ("Question term=standout ctermfg=DarkGreen gui=bold guifg=SeaGreen")
			syntax_inst.highlight_init_light[4] := ce_string ("Search term=reverse ctermbg=Yellow ctermfg=NONE guibg=Yellow guifg=NONE")
			syntax_inst.highlight_init_light[5] := ce_string ("SpellBad term=reverse ctermbg=LightRed guisp=Red gui=undercurl")
			syntax_inst.highlight_init_light[6] := ce_string ("SpellCap term=reverse ctermbg=LightBlue guisp=Blue gui=undercurl")
			syntax_inst.highlight_init_light[7] := ce_string ("SpellRare term=reverse ctermbg=LightMagenta guisp=Magenta gui=undercurl")
			syntax_inst.highlight_init_light[8] := ce_string ("SpellLocal term=underline ctermbg=Cyan guisp=DarkCyan gui=undercurl")
			syntax_inst.highlight_init_light[9] := ce_string ("Pmenu ctermbg=LightMagenta guibg=LightMagenta")
			syntax_inst.highlight_init_light[10] := ce_string ("PmenuSel ctermbg=LightGrey guibg=Grey")
			syntax_inst.highlight_init_light[11] := ce_string ("SpecialKey term=bold ctermfg=DarkBlue guifg=Blue")
			syntax_inst.highlight_init_light[12] := ce_string ("Title term=bold ctermfg=DarkMagenta gui=bold guifg=Magenta")
			syntax_inst.highlight_init_light[13] := ce_string ("WarningMsg term=standout ctermfg=DarkRed guifg=Red")
			syntax_inst.highlight_init_light[14] := ce_string ("WildMenu term=standout ctermbg=Yellow ctermfg=Black guibg=Yellow guifg=Black")
			syntax_inst.highlight_init_light[15] := ce_string ("Folded term=standout ctermbg=Grey ctermfg=DarkBlue guibg=LightGrey guifg=DarkBlue")
			syntax_inst.highlight_init_light[16] := ce_string ("FoldColumn term=standout ctermbg=Grey ctermfg=DarkBlue guibg=Grey guifg=DarkBlue")
			syntax_inst.highlight_init_light[17] := ce_string ("SignColumn term=standout ctermbg=Grey ctermfg=DarkBlue guibg=Grey guifg=DarkBlue")
			syntax_inst.highlight_init_light[18] := ce_string ("Visual term=reverse guibg=LightGrey")
			syntax_inst.highlight_init_light[19] := ce_string ("DiffAdd term=bold ctermbg=LightBlue guibg=LightBlue")
			syntax_inst.highlight_init_light[20] := ce_string ("DiffChange term=bold ctermbg=LightMagenta guibg=LightMagenta")
			syntax_inst.highlight_init_light[21] := ce_string ("DiffDelete term=bold ctermfg=Blue ctermbg=LightCyan gui=bold guifg=Blue guibg=LightCyan")
			syntax_inst.highlight_init_light[22] := ce_string ("TabLine term=underline cterm=underline ctermfg=black ctermbg=LightGrey gui=underline guibg=LightGrey")
			syntax_inst.highlight_init_light[23] := ce_string ("CursorColumn term=reverse ctermbg=LightGrey guibg=Grey90")
			syntax_inst.highlight_init_light[24] := ce_string ("CursorLine term=underline cterm=underline guibg=Grey90")
			syntax_inst.highlight_init_light[25] := ce_string ("ColorColumn term=reverse ctermbg=LightRed guibg=LightRed")
			syntax_inst.highlight_init_light[26] := ce_string ("MatchParen term=reverse ctermbg=Cyan guibg=Cyan")
			syntax_inst.highlight_init_light[27] := ce_string ("Normal gui=NONE")
			syntax_inst.highlight_init_light[28] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			syntax_inst.highlight_init_dark[0] := ce_string ("Directory term=bold ctermfg=LightCyan guifg=Cyan")
			syntax_inst.highlight_init_dark[1] := ce_string ("LineNr term=underline ctermfg=Yellow guifg=Yellow")
			syntax_inst.highlight_init_dark[2] := ce_string ("MoreMsg term=bold ctermfg=LightGreen gui=bold guifg=SeaGreen")
			syntax_inst.highlight_init_dark[3] := ce_string ("Question term=standout ctermfg=LightGreen gui=bold guifg=Green")
			syntax_inst.highlight_init_dark[4] := ce_string ("Search term=reverse ctermbg=Yellow ctermfg=Black guibg=Yellow guifg=Black")
			syntax_inst.highlight_init_dark[5] := ce_string ("SpecialKey term=bold ctermfg=LightBlue guifg=Cyan")
			syntax_inst.highlight_init_dark[6] := ce_string ("SpellBad term=reverse ctermbg=Red guisp=Red gui=undercurl")
			syntax_inst.highlight_init_dark[7] := ce_string ("SpellCap term=reverse ctermbg=Blue guisp=Blue gui=undercurl")
			syntax_inst.highlight_init_dark[8] := ce_string ("SpellRare term=reverse ctermbg=Magenta guisp=Magenta gui=undercurl")
			syntax_inst.highlight_init_dark[9] := ce_string ("SpellLocal term=underline ctermbg=Cyan guisp=Cyan gui=undercurl")
			syntax_inst.highlight_init_dark[10] := ce_string ("Pmenu ctermbg=Magenta guibg=Magenta")
			syntax_inst.highlight_init_dark[11] := ce_string ("PmenuSel ctermbg=DarkGrey guibg=DarkGrey")
			syntax_inst.highlight_init_dark[12] := ce_string ("Title term=bold ctermfg=LightMagenta gui=bold guifg=Magenta")
			syntax_inst.highlight_init_dark[13] := ce_string ("WarningMsg term=standout ctermfg=LightRed guifg=Red")
			syntax_inst.highlight_init_dark[14] := ce_string ("WildMenu term=standout ctermbg=Yellow ctermfg=Black guibg=Yellow guifg=Black")
			syntax_inst.highlight_init_dark[15] := ce_string ("Folded term=standout ctermbg=DarkGrey ctermfg=Cyan guibg=DarkGrey guifg=Cyan")
			syntax_inst.highlight_init_dark[16] := ce_string ("FoldColumn term=standout ctermbg=DarkGrey ctermfg=Cyan guibg=Grey guifg=Cyan")
			syntax_inst.highlight_init_dark[17] := ce_string ("SignColumn term=standout ctermbg=DarkGrey ctermfg=Cyan guibg=Grey guifg=Cyan")
			syntax_inst.highlight_init_dark[18] := ce_string ("Visual term=reverse guibg=DarkGrey")
			syntax_inst.highlight_init_dark[19] := ce_string ("DiffAdd term=bold ctermbg=DarkBlue guibg=DarkBlue")
			syntax_inst.highlight_init_dark[20] := ce_string ("DiffChange term=bold ctermbg=DarkMagenta guibg=DarkMagenta")
			syntax_inst.highlight_init_dark[21] := ce_string ("DiffDelete term=bold ctermfg=Blue ctermbg=DarkCyan gui=bold guifg=Blue guibg=DarkCyan")
			syntax_inst.highlight_init_dark[22] := ce_string ("TabLine term=underline cterm=underline ctermfg=white ctermbg=DarkGrey gui=underline guibg=DarkGrey")
			syntax_inst.highlight_init_dark[23] := ce_string ("CursorColumn term=reverse ctermbg=DarkGrey guibg=Grey40")
			syntax_inst.highlight_init_dark[24] := ce_string ("CursorLine term=underline cterm=underline guibg=Grey40")
			syntax_inst.highlight_init_dark[25] := ce_string ("ColorColumn term=reverse ctermbg=DarkRed guibg=DarkRed")
			syntax_inst.highlight_init_dark[26] := ce_string ("MatchParen term=reverse ctermbg=DarkCyan guibg=DarkCyan")
			syntax_inst.highlight_init_dark[27] := ce_string ("Normal gui=NONE")
			syntax_inst.highlight_init_dark[28] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			syntax_inst.had_both := 0
			syntax_inst.recursive___6 := 0
			syntax_inst.recursive___7 := 0
			syntax_inst.color_names[0] := ce_string ("Black")
			syntax_inst.color_names[1] := ce_string ("DarkBlue")
			syntax_inst.color_names[2] := ce_string ("DarkGreen")
			syntax_inst.color_names[3] := ce_string ("DarkCyan")
			syntax_inst.color_names[4] := ce_string ("DarkRed")
			syntax_inst.color_names[5] := ce_string ("DarkMagenta")
			syntax_inst.color_names[6] := ce_string ("Brown")
			syntax_inst.color_names[7] := ce_string ("DarkYellow")
			syntax_inst.color_names[8] := ce_string ("Gray")
			syntax_inst.color_names[9] := ce_string ("Grey")
			syntax_inst.color_names[10] := ce_string ("LightGray")
			syntax_inst.color_names[11] := ce_string ("LightGrey")
			syntax_inst.color_names[12] := ce_string ("DarkGray")
			syntax_inst.color_names[13] := ce_string ("DarkGrey")
			syntax_inst.color_names[14] := ce_string ("Blue")
			syntax_inst.color_names[15] := ce_string ("LightBlue")
			syntax_inst.color_names[16] := ce_string ("Green")
			syntax_inst.color_names[17] := ce_string ("LightGreen")
			syntax_inst.color_names[18] := ce_string ("Cyan")
			syntax_inst.color_names[19] := ce_string ("LightCyan")
			syntax_inst.color_names[20] := ce_string ("Red")
			syntax_inst.color_names[21] := ce_string ("LightRed")
			syntax_inst.color_names[22] := ce_string ("Magenta")
			syntax_inst.color_names[23] := ce_string ("LightMagenta")
			syntax_inst.color_names[24] := ce_string ("Yellow")
			syntax_inst.color_names[25] := ce_string ("LightYellow")
			syntax_inst.color_names[26] := ce_string ("White")
			syntax_inst.color_names[27] := ce_string ("NONE")
			syntax_inst.color_numbers_16[0] := 0
			syntax_inst.color_numbers_16[1] := 1
			syntax_inst.color_numbers_16[2] := 2
			syntax_inst.color_numbers_16[3] := 3
			syntax_inst.color_numbers_16[4] := 4
			syntax_inst.color_numbers_16[5] := 5
			syntax_inst.color_numbers_16[6] := 6
			syntax_inst.color_numbers_16[7] := 6
			syntax_inst.color_numbers_16[8] := 7
			syntax_inst.color_numbers_16[9] := 7
			syntax_inst.color_numbers_16[10] := 7
			syntax_inst.color_numbers_16[11] := 7
			syntax_inst.color_numbers_16[12] := 8
			syntax_inst.color_numbers_16[13] := 8
			syntax_inst.color_numbers_16[14] := 9
			syntax_inst.color_numbers_16[15] := 9
			syntax_inst.color_numbers_16[16] := 10
			syntax_inst.color_numbers_16[17] := 10
			syntax_inst.color_numbers_16[18] := 11
			syntax_inst.color_numbers_16[19] := 11
			syntax_inst.color_numbers_16[20] := 12
			syntax_inst.color_numbers_16[21] := 12
			syntax_inst.color_numbers_16[22] := 13
			syntax_inst.color_numbers_16[23] := 13
			syntax_inst.color_numbers_16[24] := 14
			syntax_inst.color_numbers_16[25] := 14
			syntax_inst.color_numbers_16[26] := 15
			syntax_inst.color_numbers_16[27] := -1
			syntax_inst.color_numbers_88[0] := 0
			syntax_inst.color_numbers_88[1] := 4
			syntax_inst.color_numbers_88[2] := 2
			syntax_inst.color_numbers_88[3] := 6
			syntax_inst.color_numbers_88[4] := 1
			syntax_inst.color_numbers_88[5] := 5
			syntax_inst.color_numbers_88[6] := 32
			syntax_inst.color_numbers_88[7] := 72
			syntax_inst.color_numbers_88[8] := 84
			syntax_inst.color_numbers_88[9] := 84
			syntax_inst.color_numbers_88[10] := 7
			syntax_inst.color_numbers_88[11] := 7
			syntax_inst.color_numbers_88[12] := 82
			syntax_inst.color_numbers_88[13] := 82
			syntax_inst.color_numbers_88[14] := 12
			syntax_inst.color_numbers_88[15] := 43
			syntax_inst.color_numbers_88[16] := 10
			syntax_inst.color_numbers_88[17] := 61
			syntax_inst.color_numbers_88[18] := 14
			syntax_inst.color_numbers_88[19] := 63
			syntax_inst.color_numbers_88[20] := 9
			syntax_inst.color_numbers_88[21] := 74
			syntax_inst.color_numbers_88[22] := 13
			syntax_inst.color_numbers_88[23] := 75
			syntax_inst.color_numbers_88[24] := 11
			syntax_inst.color_numbers_88[25] := 78
			syntax_inst.color_numbers_88[26] := 15
			syntax_inst.color_numbers_88[27] := -1
			syntax_inst.color_numbers_256[0] := 0
			syntax_inst.color_numbers_256[1] := 4
			syntax_inst.color_numbers_256[2] := 2
			syntax_inst.color_numbers_256[3] := 6
			syntax_inst.color_numbers_256[4] := 1
			syntax_inst.color_numbers_256[5] := 5
			syntax_inst.color_numbers_256[6] := 130
			syntax_inst.color_numbers_256[7] := 130
			syntax_inst.color_numbers_256[8] := 248
			syntax_inst.color_numbers_256[9] := 248
			syntax_inst.color_numbers_256[10] := 7
			syntax_inst.color_numbers_256[11] := 7
			syntax_inst.color_numbers_256[12] := 242
			syntax_inst.color_numbers_256[13] := 242
			syntax_inst.color_numbers_256[14] := 12
			syntax_inst.color_numbers_256[15] := 81
			syntax_inst.color_numbers_256[16] := 10
			syntax_inst.color_numbers_256[17] := 121
			syntax_inst.color_numbers_256[18] := 14
			syntax_inst.color_numbers_256[19] := 159
			syntax_inst.color_numbers_256[20] := 9
			syntax_inst.color_numbers_256[21] := 224
			syntax_inst.color_numbers_256[22] := 13
			syntax_inst.color_numbers_256[23] := 225
			syntax_inst.color_numbers_256[24] := 11
			syntax_inst.color_numbers_256[25] := 229
			syntax_inst.color_numbers_256[26] := 15
			syntax_inst.color_numbers_256[27] := -1
			syntax_inst.color_numbers_8[0] := 0
			syntax_inst.color_numbers_8[1] := 4
			syntax_inst.color_numbers_8[2] := 2
			syntax_inst.color_numbers_8[3] := 6
			syntax_inst.color_numbers_8[4] := 1
			syntax_inst.color_numbers_8[5] := 5
			syntax_inst.color_numbers_8[6] := 3
			syntax_inst.color_numbers_8[7] := 3
			syntax_inst.color_numbers_8[8] := 7
			syntax_inst.color_numbers_8[9] := 7
			syntax_inst.color_numbers_8[10] := 7
			syntax_inst.color_numbers_8[11] := 7
			syntax_inst.color_numbers_8[12] := 8
			syntax_inst.color_numbers_8[13] := 8
			syntax_inst.color_numbers_8[14] := 12
			syntax_inst.color_numbers_8[15] := 12
			syntax_inst.color_numbers_8[16] := 10
			syntax_inst.color_numbers_8[17] := 10
			syntax_inst.color_numbers_8[18] := 14
			syntax_inst.color_numbers_8[19] := 14
			syntax_inst.color_numbers_8[20] := 9
			syntax_inst.color_numbers_8[21] := 9
			syntax_inst.color_numbers_8[22] := 13
			syntax_inst.color_numbers_8[23] := 13
			syntax_inst.color_numbers_8[24] := 11
			syntax_inst.color_numbers_8[25] := 11
			syntax_inst.color_numbers_8[26] := 15
			syntax_inst.color_numbers_8[27] := -1
			syntax_inst.term_attr_table.ga_len := 0
			syntax_inst.term_attr_table.ga_maxlen := 0
			syntax_inst.term_attr_table.ga_itemsize := 0
			syntax_inst.term_attr_table.ga_growsize := 0
			syntax_inst.term_attr_table.ga_data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			syntax_inst.cterm_attr_table.ga_len := 0
			syntax_inst.cterm_attr_table.ga_maxlen := 0
			syntax_inst.cterm_attr_table.ga_itemsize := 0
			syntax_inst.cterm_attr_table.ga_growsize := 0
			syntax_inst.cterm_attr_table.ga_data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			syntax_inst.gui_attr_table.ga_len := 0
			syntax_inst.gui_attr_table.ga_maxlen := 0
			syntax_inst.gui_attr_table.ga_itemsize := 0
			syntax_inst.gui_attr_table.ga_growsize := 0
			syntax_inst.gui_attr_table.ga_data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			syntax_inst.recursive___8 := 0
			syntax_inst.hl_flags[0] := ('8').code
			syntax_inst.hl_flags[1] := ('@').code
			syntax_inst.hl_flags[2] := ('d').code
			syntax_inst.hl_flags[3] := ('e').code
			syntax_inst.hl_flags[4] := ('h').code
			syntax_inst.hl_flags[5] := ('i').code
			syntax_inst.hl_flags[6] := ('l').code
			syntax_inst.hl_flags[7] := ('m').code
			syntax_inst.hl_flags[8] := ('M').code
			syntax_inst.hl_flags[9] := ('n').code
			syntax_inst.hl_flags[10] := ('r').code
			syntax_inst.hl_flags[11] := ('s').code
			syntax_inst.hl_flags[12] := ('S').code
			syntax_inst.hl_flags[13] := ('c').code
			syntax_inst.hl_flags[14] := ('t').code
			syntax_inst.hl_flags[15] := ('v').code
			syntax_inst.hl_flags[16] := ('V').code
			syntax_inst.hl_flags[17] := ('w').code
			syntax_inst.hl_flags[18] := ('W').code
			syntax_inst.hl_flags[19] := ('f').code
			syntax_inst.hl_flags[20] := ('F').code
			syntax_inst.hl_flags[21] := ('A').code
			syntax_inst.hl_flags[22] := ('C').code
			syntax_inst.hl_flags[23] := ('D').code
			syntax_inst.hl_flags[24] := ('T').code
			syntax_inst.hl_flags[25] := ('-').code
			syntax_inst.hl_flags[26] := ('>').code
			syntax_inst.hl_flags[27] := ('B').code
			syntax_inst.hl_flags[28] := ('P').code
			syntax_inst.hl_flags[29] := ('R').code
			syntax_inst.hl_flags[30] := ('L').code
			syntax_inst.hl_flags[31] := ('+').code
			syntax_inst.hl_flags[32] := ('=').code
			syntax_inst.hl_flags[33] := ('x').code
			syntax_inst.hl_flags[34] := ('X').code
			syntax_inst.hl_flags[35] := ('*').code
			syntax_inst.hl_flags[36] := ('#').code
			syntax_inst.hl_flags[37] := ('_').code
			syntax_inst.hl_flags[38] := ('!').code
			syntax_inst.hl_flags[39] := ('.').code
			syntax_inst.hl_flags[40] := ('o').code
			tag_inst.mt_names[0] := ce_string ("FSC")
			tag_inst.mt_names[1] := ce_string ("F C")
			tag_inst.mt_names[2] := ce_string ("F  ")
			tag_inst.mt_names[3] := ce_string ("FS ")
			tag_inst.mt_names[4] := ce_string (" SC")
			tag_inst.mt_names[5] := ce_string ("  C")
			tag_inst.mt_names[6] := ce_string ("   ")
			tag_inst.mt_names[7] := ce_string (" S ")
			tag_inst.nofile_fname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			tag_inst.bottommsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E555: at bottom of tag stack")))
			tag_inst.topmsg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E556: at top of tag stack")))
			tag_inst.tagmatchname.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			tag_inst.ptag_entry.tagname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			tag_inst.ptag_entry.fmark.mark.lnum := (0).to_integer_32
			tag_inst.ptag_entry.fmark.mark.col := 0
			tag_inst.ptag_entry.fmark.mark.coladd := 0
			tag_inst.ptag_entry.fmark.fnum := 0
			tag_inst.ptag_entry.cur_match := 0
			tag_inst.ptag_entry.cur_fnum := 0
			tag_inst.num_matches := 0
			tag_inst.max_num_matches := 0
			tag_inst.matches.ce_gets (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))
			tag_inst.tag_fnames.ga_len := 0
			tag_inst.tag_fnames.ga_maxlen := 0
			tag_inst.tag_fnames.ga_itemsize := 0
			tag_inst.tag_fnames.ga_growsize := 0
			tag_inst.tag_fnames.ga_data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			term_inst.crv_status := 1
			term_inst.detected_8bit := 0
			term_inst.builtin_termcaps[0].bt_entry := 0
			term_inst.builtin_termcaps[0].bt_string := ce_string ("gui")
			term_inst.builtin_termcaps[1].bt_entry := 1
			term_inst.builtin_termcaps[1].bt_string := ce_string ("%/27/|$")
			term_inst.builtin_termcaps[2].bt_entry := 2
			term_inst.builtin_termcaps[2].bt_string := ce_string ("%/27/|i")
			term_inst.builtin_termcaps[3].bt_entry := 3
			term_inst.builtin_termcaps[3].bt_string := ce_string ("%/27/|%%p1%%dI")
			term_inst.builtin_termcaps[4].bt_entry := 4
			term_inst.builtin_termcaps[4].bt_string := ce_string ("%/27/|d")
			term_inst.builtin_termcaps[5].bt_entry := 5
			term_inst.builtin_termcaps[5].bt_string := ce_string ("%/27/|%%p1%%dD")
			term_inst.builtin_termcaps[6].bt_entry := 6
			term_inst.builtin_termcaps[6].bt_string := ce_string ("%/27/|%%p1%%d;%%p2%%dR")
			term_inst.builtin_termcaps[7].bt_entry := 55
			term_inst.builtin_termcaps[7].bt_string := ce_string ("%/27/|%%p1%%d;%%p2%%dV")
			term_inst.builtin_termcaps[8].bt_entry := 7
			term_inst.builtin_termcaps[8].bt_string := ce_string ("%/27/|C")
			term_inst.builtin_termcaps[9].bt_entry := 15
			term_inst.builtin_termcaps[9].bt_string := ce_string ("%/27/|31H")
			term_inst.builtin_termcaps[10].bt_entry := 16
			term_inst.builtin_termcaps[10].bt_string := ce_string ("%/27/|1h")
			term_inst.builtin_termcaps[11].bt_entry := 17
			term_inst.builtin_termcaps[11].bt_string := ce_string ("%/27/|2h")
			term_inst.builtin_termcaps[12].bt_entry := 18
			term_inst.builtin_termcaps[12].bt_string := ce_string ("%/27/|16H")
			term_inst.builtin_termcaps[13].bt_entry := 19
			term_inst.builtin_termcaps[13].bt_string := ce_string ("%/27/|16h")
			term_inst.builtin_termcaps[14].bt_entry := 22
			term_inst.builtin_termcaps[14].bt_string := ce_string ("%/27/|8H")
			term_inst.builtin_termcaps[15].bt_entry := 23
			term_inst.builtin_termcaps[15].bt_string := ce_string ("%/27/|8h")
			term_inst.builtin_termcaps[16].bt_entry := 24
			term_inst.builtin_termcaps[16].bt_string := ce_string ("%/27/|8C")
			term_inst.builtin_termcaps[17].bt_entry := 25
			term_inst.builtin_termcaps[17].bt_string := ce_string ("%/27/|8c")
			term_inst.builtin_termcaps[18].bt_entry := 21
			term_inst.builtin_termcaps[18].bt_string := ce_string ("%/27/|4H")
			term_inst.builtin_termcaps[19].bt_entry := 20
		end

end
