frozen class
	VIM_INITIALIZER_SLICE50

inherit
	VIM_DATA
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {VIM_INITIALIZER}

	initialize
		do
			term_inst.string_names[32].name := ce_string ("Sb")
			term_inst.string_names[33].dest := {PC_SPECIALKEY}.KS_CSF
			term_inst.string_names[33].name := ce_string ("Sf")
			term_inst.string_names[34].dest := {PC_SPECIALKEY}.KS_CAB
			term_inst.string_names[34].name := ce_string ("AB")
			term_inst.string_names[35].dest := {PC_SPECIALKEY}.KS_CAF
			term_inst.string_names[35].name := ce_string ("AF")
			term_inst.string_names[36].dest := {PC_SPECIALKEY}.KS_LE
			term_inst.string_names[36].name := ce_string ("le")
			term_inst.string_names[37].dest := {PC_SPECIALKEY}.KS_ND
			term_inst.string_names[37].name := ce_string ("nd")
			term_inst.string_names[38].dest := {PC_SPECIALKEY}.KS_OP
			term_inst.string_names[38].name := ce_string ("op")
			term_inst.string_names[39].dest := {PC_SPECIALKEY}.KS_CRV
			term_inst.string_names[39].name := ce_string ("RV")
			term_inst.string_names[40].dest := {PC_SPECIALKEY}.KS_CIS
			term_inst.string_names[40].name := ce_string ("IS")
			term_inst.string_names[41].dest := {PC_SPECIALKEY}.KS_CIE
			term_inst.string_names[41].name := ce_string ("IE")
			term_inst.string_names[42].dest := {PC_SPECIALKEY}.KS_TS
			term_inst.string_names[42].name := ce_string ("ts")
			term_inst.string_names[43].dest := {PC_SPECIALKEY}.KS_FS
			term_inst.string_names[43].name := ce_string ("fs")
			term_inst.string_names[44].dest := {PC_SPECIALKEY}.KS_CWP
			term_inst.string_names[44].name := ce_string ("WP")
			term_inst.string_names[45].dest := {PC_SPECIALKEY}.KS_CWS
			term_inst.string_names[45].name := ce_string ("WS")
			term_inst.string_names[46].dest := {PC_SPECIALKEY}.KS_CSI
			term_inst.string_names[46].name := ce_string ("SI")
			term_inst.string_names[47].dest := {PC_SPECIALKEY}.KS_CEI
			term_inst.string_names[47].name := ce_string ("EI")
			term_inst.string_names[48].dest := {PC_SPECIALKEY}.KS_NAME
			term_inst.string_names[48].name := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			term_inst.has_mouse_termcode := 0
			term_inst.out_pos := 0
			term_inst.old_Rows := 0
			term_inst.old_Columns := 0
			term_inst.busy___2 := 0
			term_inst.cursor_is_off := 0
			term_inst.showing_insert_mode := 2
			term_inst.termcodes.ce_gets (create {CE_POINTER [PD_TERMCODE]}.make_shared (default_pointer))
			term_inst.tc_max_len := 0
			term_inst.tc_len := 0
			term_inst.orig_topline := (0).to_integer_32
			term_inst.orig_topfill := 0
			term_inst.held_button := 3
			term_inst.orig_num_clicks := 1
			term_inst.orig_mouse_code := 0
			term_inst.orig_mouse_col := 0
			term_inst.orig_mouse_row := 0
			term_inst.orig_mouse_time.tv_sec := (0).to_integer_32
			term_inst.orig_mouse_time.tv_usec := (0).to_integer_32
			term_inst.xt_index_in := 0
			term_inst.xt_index_out := 0
			ui_inst.ta_str.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			ui_inst.count___1 := 0
			ui_inst.inbufcount := 0
			ui_inst.did_read_something := 0
			ui_inst.rest.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			ui_inst.restlen := 0
			ui_inst.on_status_line := 0
			ui_inst.on_sep_line := 0
			ui_inst.prev_row___0 := -1
			ui_inst.prev_col___0 := -1
			ui_inst.dragwin.ce_gets (create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
			ui_inst.did_drag := 0
			ui_inst.last_time := (0).to_integer_32
			undo_inst.undo_undoes := 0
			undo_inst.lastmark := 0
			undo_inst.e_not_open[0] := (('E').code).to_natural_8
			undo_inst.e_not_open[1] := (('8').code).to_natural_8
			undo_inst.e_not_open[2] := (('2').code).to_natural_8
			undo_inst.e_not_open[3] := (('8').code).to_natural_8
			undo_inst.e_not_open[4] := ((':').code).to_natural_8
			undo_inst.e_not_open[5] := ((' ').code).to_natural_8
			undo_inst.e_not_open[6] := (('C').code).to_natural_8
			undo_inst.e_not_open[7] := (('a').code).to_natural_8
			undo_inst.e_not_open[8] := (('n').code).to_natural_8
			undo_inst.e_not_open[9] := (('n').code).to_natural_8
			undo_inst.e_not_open[10] := (('o').code).to_natural_8
			undo_inst.e_not_open[11] := (('t').code).to_natural_8
			undo_inst.e_not_open[12] := ((' ').code).to_natural_8
			undo_inst.e_not_open[13] := (('o').code).to_natural_8
			undo_inst.e_not_open[14] := (('p').code).to_natural_8
			undo_inst.e_not_open[15] := (('e').code).to_natural_8
			undo_inst.e_not_open[16] := (('n').code).to_natural_8
			undo_inst.e_not_open[17] := ((' ').code).to_natural_8
			undo_inst.e_not_open[18] := (('u').code).to_natural_8
			undo_inst.e_not_open[19] := (('n').code).to_natural_8
			undo_inst.e_not_open[20] := (('d').code).to_natural_8
			undo_inst.e_not_open[21] := (('o').code).to_natural_8
			undo_inst.e_not_open[22] := ((' ').code).to_natural_8
			undo_inst.e_not_open[23] := (('f').code).to_natural_8
			undo_inst.e_not_open[24] := (('i').code).to_natural_8
			undo_inst.e_not_open[25] := (('l').code).to_natural_8
			undo_inst.e_not_open[26] := (('e').code).to_natural_8
			undo_inst.e_not_open[27] := ((' ').code).to_natural_8
			undo_inst.e_not_open[28] := (('f').code).to_natural_8
			undo_inst.e_not_open[29] := (('o').code).to_natural_8
			undo_inst.e_not_open[30] := (('r').code).to_natural_8
			undo_inst.e_not_open[31] := ((' ').code).to_natural_8
			undo_inst.e_not_open[32] := (('w').code).to_natural_8
			undo_inst.e_not_open[33] := (('r').code).to_natural_8
			undo_inst.e_not_open[34] := (('i').code).to_natural_8
			undo_inst.e_not_open[35] := (('t').code).to_natural_8
			undo_inst.e_not_open[36] := (('i').code).to_natural_8
			undo_inst.e_not_open[37] := (('n').code).to_natural_8
			undo_inst.e_not_open[38] := (('g').code).to_natural_8
			undo_inst.e_not_open[39] := ((':').code).to_natural_8
			undo_inst.e_not_open[40] := ((' ').code).to_natural_8
			undo_inst.e_not_open[41] := (('%%').code).to_natural_8
			undo_inst.e_not_open[42] := (('s').code).to_natural_8
			undo_inst.e_not_open[43] := (('%/0/').code).to_natural_8
			window_inst.m_onlyone.ce_gets (ce_string ("Already only one window"))
			gui_inst.can_update_cursor := 1
			gui_inst.recursive___9 := 0
			gui_inst.result___0 := 2
			gui_inst.recursive___10 := 0
			gui_inst.busy___3 := 0
			gui_inst.old_curwin___0.ce_gets (create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
			gui_inst.prev_row___1 := 0
			gui_inst.prev_col___1 := 0
			gui_inst.prev_button := -1
			gui_inst.num_clicks := 1
			gui_inst.prev_menu_is_active := -1
			gui_inst.prev_toolbar := -1
			gui_inst.prev_tearoff := -1
			gui_inst.sbar_ident := 0
			gui_inst.prev_curwin.ce_gets (create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
			gui_inst.longest_lnum := (0).to_integer_32
			gui_inst.busy___4 := 0
			gui_inst.entered___5 := 0
			gui_gtk_inst.menu_stock_ids[0] := ce_string ("gtk-new")
			gui_gtk_inst.menu_stock_ids[1] := ce_string ("gtk-open")
			gui_gtk_inst.menu_stock_ids[2] := ce_string ("gtk-save")
			gui_gtk_inst.menu_stock_ids[3] := ce_string ("gtk-undo")
			gui_gtk_inst.menu_stock_ids[4] := ce_string ("gtk-redo")
			gui_gtk_inst.menu_stock_ids[5] := ce_string ("gtk-cut")
			gui_gtk_inst.menu_stock_ids[6] := ce_string ("gtk-copy")
			gui_gtk_inst.menu_stock_ids[7] := ce_string ("gtk-paste")
			gui_gtk_inst.menu_stock_ids[8] := ce_string ("gtk-print")
			gui_gtk_inst.menu_stock_ids[9] := ce_string ("gtk-help")
			gui_gtk_inst.menu_stock_ids[10] := ce_string ("gtk-find")
			gui_gtk_inst.menu_stock_ids[11] := ce_string ("vim-save-all")
			gui_gtk_inst.menu_stock_ids[12] := ce_string ("vim-session-save")
			gui_gtk_inst.menu_stock_ids[13] := ce_string ("vim-session-new")
			gui_gtk_inst.menu_stock_ids[14] := ce_string ("vim-session-load")
			gui_gtk_inst.menu_stock_ids[15] := ce_string ("gtk-execute")
			gui_gtk_inst.menu_stock_ids[16] := ce_string ("gtk-find-and-replace")
			gui_gtk_inst.menu_stock_ids[17] := ce_string ("gtk-close")
			gui_gtk_inst.menu_stock_ids[18] := ce_string ("vim-window-maximize")
			gui_gtk_inst.menu_stock_ids[19] := ce_string ("vim-window-minimize")
			gui_gtk_inst.menu_stock_ids[20] := ce_string ("vim-window-split")
			gui_gtk_inst.menu_stock_ids[21] := ce_string ("vim-shell")
			gui_gtk_inst.menu_stock_ids[22] := ce_string ("gtk-go-back")
			gui_gtk_inst.menu_stock_ids[23] := ce_string ("gtk-go-forward")
			gui_gtk_inst.menu_stock_ids[24] := ce_string ("vim-find-help")
			gui_gtk_inst.menu_stock_ids[25] := ce_string ("gtk-convert")
			gui_gtk_inst.menu_stock_ids[26] := ce_string ("gtk-jump-to")
			gui_gtk_inst.menu_stock_ids[27] := ce_string ("vim-build-tags")
			gui_gtk_inst.menu_stock_ids[28] := ce_string ("vim-window-split-vertical")
			gui_gtk_inst.menu_stock_ids[29] := ce_string ("vim-window-maximize-width")
			gui_gtk_inst.menu_stock_ids[30] := ce_string ("vim-window-minimize-width")
			gui_gtk_inst.menu_stock_ids[31] := ce_string ("gtk-quit")
			across "png%/0/" as c loop (gui_gtk_inst.suffixes[0])[c.target_index - 1] := c.item.code.to_integer_8 end
			across "xpm%/0/" as c loop (gui_gtk_inst.suffixes[1])[c.target_index - 1] := c.item.code.to_integer_8 end
			across "bmp%/0/" as c loop (gui_gtk_inst.suffixes[2])[c.target_index - 1] := c.item.code.to_integer_8 end
			pixmaps_stock_icons_inst.stock_vim_build_tags[0] := (('G').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[1] := (('d').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[2] := (('k').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[3] := (('P').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[4] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[5] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[6] := (('%T').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[7] := (('%/24/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[8] := (('%/1/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[9] := (('%/1/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[10] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[11] := (('%/2/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[12] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[13] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[14] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[15] := (('`').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[16] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[17] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[18] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[19] := (('%/24/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[20] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[21] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[22] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[23] := (('%/24/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[24] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[25] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[26] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[27] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[28] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[29] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[30] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[31] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[32] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[33] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[34] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[35] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[36] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[37] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[38] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[39] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[40] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[41] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[42] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[43] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[44] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[45] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[46] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[47] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[48] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[49] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[50] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[51] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[52] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[53] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[54] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[55] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[56] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[57] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[58] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[59] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[60] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[61] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[62] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[63] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[64] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[65] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[66] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[67] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[68] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[69] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[70] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[71] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[72] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[73] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[74] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[75] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[76] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[77] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[78] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[79] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[80] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[81] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[82] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[83] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[84] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[85] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[86] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[87] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[88] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[89] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[90] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[91] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[92] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[93] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[94] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[95] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[96] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[97] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[98] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[99] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[100] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[101] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[102] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[103] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[104] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[105] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[106] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[107] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[108] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[109] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[110] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[111] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[112] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[113] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[114] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[115] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[116] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[117] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[118] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[119] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[120] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[121] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[122] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[123] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[124] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[125] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[126] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[127] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[128] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[129] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[130] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[131] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[132] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[133] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[134] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[135] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[136] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[137] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[138] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[139] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[140] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[141] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[142] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[143] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[144] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[145] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[146] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[147] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[148] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[149] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[150] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[151] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[152] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[153] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[154] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[155] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[156] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[157] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[158] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[159] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[160] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[161] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[162] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[163] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[164] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[165] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[166] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[167] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[168] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[169] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[170] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[171] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[172] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[173] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[174] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[175] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[176] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[177] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[178] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[179] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[180] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[181] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[182] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[183] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[184] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[185] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[186] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[187] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[188] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[189] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[190] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[191] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[192] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[193] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[194] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[195] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[196] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[197] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[198] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[199] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[200] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[201] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[202] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[203] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[204] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[205] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[206] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[207] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[208] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[209] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[210] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[211] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[212] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[213] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[214] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[215] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[216] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[217] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[218] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[219] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[220] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[221] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[222] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[223] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[224] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[225] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[226] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[227] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[228] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[229] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[230] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[231] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[232] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[233] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[234] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[235] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[236] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[237] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[238] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[239] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[240] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[241] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[242] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[243] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[244] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[245] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[246] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[247] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[248] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[249] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[250] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[251] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[252] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[253] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[254] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[255] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[256] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[257] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[258] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[259] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[260] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[261] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[262] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[263] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[264] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[265] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[266] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[267] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[268] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[269] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[270] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[271] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[272] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[273] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[274] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[275] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[276] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[277] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[278] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[279] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[280] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[281] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[282] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[283] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[284] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[285] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[286] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[287] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[288] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[289] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[290] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[291] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[292] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[293] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[294] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[295] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[296] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[297] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[298] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[299] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[300] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[301] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[302] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[303] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[304] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[305] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[306] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[307] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[308] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[309] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[310] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[311] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[312] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[313] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[314] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[315] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[316] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[317] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[318] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[319] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[320] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[321] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[322] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[323] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[324] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[325] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[326] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[327] := (('%/255/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[328] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[329] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[330] := (('%/0/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[331] := (('%/255/').code).to_natural_8
			pixmaps_stock_icons_inst.stock_vim_build_tags[332] := (('%/0/').code).to_natural_8
		end

end
