class
	P_GLOBALS

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create ScreenLines.make
			create ScreenAttrs.make
			create LineOffset.make
			create LineWraps.make
			create ScreenLinesUC.make
			create ScreenLinesC.make (<<6>>)
			create ScreenLines2.make
			create TabPageIdxs.make
			create keep_msg.make
			create sourcing_name.make
			create current_exception.make
			create msg_list.make
			create caught_stack.make
			create highlight_attr.make (<<41>>)
			create highlight_user.make (<<9>>)
			create highlight_stlnc.make (<<9>>)
			create use_gvimrc.make
			create au_new_curbuf.make
			create root_menu.make
			create current_menu.make
			create font_argument.make
			create background_argument.make
			create foreground_argument.make
			create clip_star.make
			create clip_plus.make
			create clip_exclude_prog.make
			create firstwin.make
			create lastwin.make
			create prevwin.make
			create curwin.make
			create aucmd_win.make
			create topframe.make
			create first_tabpage.make
			create curtab.make
			create firstbuf.make
			create lastbuf.make
			create curbuf.make
			create global_alist.make
			create vim_tempdir.make
			create VIsual.make
			create where_paste_started.make
			create saved_cursor.make
			create Insstart.make
			create mb_bytelen_tab.make (<<256>>)
			create input_conv.make
			create output_conv.make
			create mb_ptr2len.make
			create mb_ptr2len_len.make
			create mb_char2len.make
			create mb_char2bytes.make
			create mb_ptr2cells.make
			create mb_ptr2cells_len.make
			create mb_char2cells.make
			create mb_off2cells.make
			create mb_ptr2char.make
			create mb_head_off.make
			create xic.make
			create edit_submode.make
			create edit_submode_pre.make
			create edit_submode_extra.make
			create cmdmod.make
			create IObuff.make
			create NameBuff.make
			create msg_buf.make (<<480>>)
			create stuffbuff.make
			create typebuf.make
			create chartab.make (<<256>>)
			create use_viminfo.make
			create scriptin.make (<<15>>)
			create scriptout.make
			create re_extmatch_in.make
			create re_extmatch_out.make
			create last_cmdline.make
			create repeat_cmdline.make
			create new_last_cmdline.make
			create autocmd_fname.make
			create autocmd_match.make
			create last_cursormoved.make
			create escape_chars.make
			create empty_option.make
			create redir_fd.make
			create breakat_flags.make (<<256>>)
			create globaldir.make
			create no_lines_msg.make (<<23>>)
			create wim_flags.make (<<4>>)
			create balloonEval.make
			create printer_opts.make (<<14>>)
			create xterm_display.make
			create xterm_dpy.make
			create app_context.make
			create serverName.make
			create serverDelayedStartName.make
			create error_ga.make
			create netbeansArg.make
			create e_abort.make (<<22>>)
			create e_argreq.make (<<24>>)
			create e_backslash.make (<<39>>)
			create e_cmdwin.make (<<65>>)
			create e_curdir.make (<<70>>)
			create e_endif.make (<<21>>)
			create e_endtry.make (<<22>>)
			create e_endwhile.make (<<24>>)
			create e_endfor.make (<<22>>)
			create e_while.make (<<31>>)
			create e_for.make (<<27>>)
			create e_exists.make (<<37>>)
			create e_failed.make (<<21>>)
			create e_font.make (<<23>>)
			create e_internal.make (<<21>>)
			create e_interr.make (<<12>>)
			create e_invaddr.make (<<21>>)
			create e_invarg.make (<<23>>)
			create e_invarg2.make (<<27>>)
			create e_invexpr2.make (<<28>>)
			create e_invrange.make (<<19>>)
			create e_invcmd.make (<<22>>)
			create e_isadir2.make (<<25>>)
			create e_libcall.make (<<37>>)
			create e_markinval.make (<<34>>)
			create e_marknotset.make (<<18>>)
			create e_modifiable.make (<<46>>)
			create e_nesting.make (<<29>>)
			create e_noalt.make (<<23>>)
			create e_noabbr.make (<<26>>)
			create e_nobang.make (<<19>>)
			create e_nohebrew.make (<<57>>)
			create e_nofarsi.make (<<56>>)
			create e_noarabic.make (<<58>>)
			create e_nogroup.make (<<38>>)
			create e_noinstext.make (<<26>>)
			create e_nolastcmd.make (<<30>>)
			create e_nomap.make (<<21>>)
			create e_nomatch.make (<<15>>)
			create e_nomatch2.make (<<19>>)
			create e_noname.make (<<18>>)
			create e_nopresub.make (<<47>>)
			create e_noprev.make (<<25>>)
			create e_noprevre.make (<<36>>)
			create e_norange.make (<<23>>)
			create e_noroom.make (<<21>>)
			create e_noserver.make (<<38>>)
			create e_notcreate.make (<<27>>)
			create e_notmp.make (<<31>>)
			create e_notopen.make (<<25>>)
			create e_notread.make (<<25>>)
			create e_nowrtmsg.make (<<52>>)
			create e_null.make (<<19>>)
			create e_number_exp.make (<<21>>)
			create e_openerrf.make (<<29>>)
			create e_opendisp.make (<<26>>)
			create e_outofmem.make (<<20>>)
			create e_patnotf.make (<<18>>)
			create e_patnotf2.make (<<28>>)
			create e_positive.make (<<32>>)
			create e_prev_dir.make (<<43>>)
			create e_quickfix.make (<<15>>)
			create e_loclist.make (<<23>>)
			create e_re_damg.make (<<26>>)
			create e_re_corr.make (<<30>>)
			create e_readonly.make (<<50>>)
			create e_readonlyvar.make (<<43>>)
			create e_readonlysbx.make (<<47>>)
			create e_readerrf.make (<<35>>)
			create e_sandbox.make (<<28>>)
			create e_secure.make (<<23>>)
			create e_screenmode.make (<<40>>)
			create e_scroll.make (<<25>>)
			create e_shellempty.make (<<29>>)
			create e_swapclose.make (<<30>>)
			create e_tagstack.make (<<21>>)
			create e_toocompl.make (<<25>>)
			create e_longname.make (<<19>>)
			create e_toomsbra.make (<<16>>)
			create e_toomany.make (<<25>>)
			create e_trailing.make (<<26>>)
			create e_umark.make (<<18>>)
			create e_wildexpand.make (<<29>>)
			create e_winheight.make (<<56>>)
			create e_winwidth.make (<<54>>)
			create e_write.make (<<25>>)
			create e_zerocount.make (<<11>>)
			create e_usingsid.make (<<41>>)
			create e_invexprmsg.make (<<34>>)
			create e_guarded.make (<<39>>)
			create e_nbreadonly.make (<<57>>)
			create e_intern2.make (<<25>>)
			create e_maxmempat.make (<<52>>)
			create e_emptybuf.make (<<19>>)
			create e_invalpat.make (<<42>>)
			create e_bufloaded.make (<<39>>)
			create e_notset.make (<<29>>)
			create top_bot_msg.make (<<37>>)
			create bot_top_msg.make (<<37>>)
			create need_key_msg.make (<<29>>)
			create time_fd.make
			create ignoredp.make
		end

feature {ANY} -- attributes

	Rows: INTEGER_32 assign set_Rows
		do
			Result := Rows_address[0]
		end

	set_Rows (a_Rows: INTEGER_32)
		do
			Rows_address[0] := a_Rows
		end

	Rows_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	Columns: INTEGER_32 assign set_Columns
		do
			Result := Columns_address[0]
		end

	set_Columns (a_Columns: INTEGER_32)
		do
			Columns_address[0] := a_Columns
		end

	Columns_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	ScreenLines: CE_POINTER [NATURAL_8]

	ScreenAttrs: CE_POINTER [NATURAL_16]

	LineOffset: CE_POINTER [NATURAL_32]

	LineWraps: CE_POINTER [NATURAL_8]

	ScreenLinesUC: CE_POINTER [NATURAL_32]

	ScreenLinesC: CE_ARRAY [CE_POINTER [NATURAL_32]]

	Screen_mco: INTEGER_32 assign set_Screen_mco

	set_Screen_mco (a_Screen_mco: INTEGER_32)
		do
			Screen_mco := a_Screen_mco
		end

	ScreenLines2: CE_POINTER [NATURAL_8]

	TabPageIdxs: CE_POINTER [INTEGER_16]

	screen_Rows: INTEGER_32 assign set_screen_Rows

	set_screen_Rows (a_screen_Rows: INTEGER_32)
		do
			screen_Rows := a_screen_Rows
		end

	screen_Columns: INTEGER_32 assign set_screen_Columns

	set_screen_Columns (a_screen_Columns: INTEGER_32)
		do
			screen_Columns := a_screen_Columns
		end

	mod_mask: INTEGER_32 assign set_mod_mask
		do
			Result := mod_mask_address[0]
		end

	set_mod_mask (a_mod_mask: INTEGER_32)
		do
			mod_mask_address[0] := a_mod_mask
		end

	mod_mask_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	cmdline_row: INTEGER_32 assign set_cmdline_row

	set_cmdline_row (a_cmdline_row: INTEGER_32)
		do
			cmdline_row := a_cmdline_row
		end

	redraw_cmdline: INTEGER_32 assign set_redraw_cmdline

	set_redraw_cmdline (a_redraw_cmdline: INTEGER_32)
		do
			redraw_cmdline := a_redraw_cmdline
		end

	clear_cmdline: INTEGER_32 assign set_clear_cmdline

	set_clear_cmdline (a_clear_cmdline: INTEGER_32)
		do
			clear_cmdline := a_clear_cmdline
		end

	mode_displayed: INTEGER_32 assign set_mode_displayed

	set_mode_displayed (a_mode_displayed: INTEGER_32)
		do
			mode_displayed := a_mode_displayed
		end

	cmdline_star: INTEGER_32 assign set_cmdline_star

	set_cmdline_star (a_cmdline_star: INTEGER_32)
		do
			cmdline_star := a_cmdline_star
		end

	exec_from_reg: INTEGER_32 assign set_exec_from_reg

	set_exec_from_reg (a_exec_from_reg: INTEGER_32)
		do
			exec_from_reg := a_exec_from_reg
		end

	screen_cleared: INTEGER_32 assign set_screen_cleared

	set_screen_cleared (a_screen_cleared: INTEGER_32)
		do
			screen_cleared := a_screen_cleared
		end

	use_crypt_method: INTEGER_32 assign set_use_crypt_method

	set_use_crypt_method (a_use_crypt_method: INTEGER_32)
		do
			use_crypt_method := a_use_crypt_method
		end

	dollar_vcol: INTEGER_32 assign set_dollar_vcol

	set_dollar_vcol (a_dollar_vcol: INTEGER_32)
		do
			dollar_vcol := a_dollar_vcol
		end

	compl_length: INTEGER_32 assign set_compl_length

	set_compl_length (a_compl_length: INTEGER_32)
		do
			compl_length := a_compl_length
		end

	compl_interrupted: INTEGER_32 assign set_compl_interrupted

	set_compl_interrupted (a_compl_interrupted: INTEGER_32)
		do
			compl_interrupted := a_compl_interrupted
		end

	compl_cont_status: INTEGER_32 assign set_compl_cont_status

	set_compl_cont_status (a_compl_cont_status: INTEGER_32)
		do
			compl_cont_status := a_compl_cont_status
		end

	msg_col: INTEGER_32 assign set_msg_col

	set_msg_col (a_msg_col: INTEGER_32)
		do
			msg_col := a_msg_col
		end

	msg_row: INTEGER_32 assign set_msg_row

	set_msg_row (a_msg_row: INTEGER_32)
		do
			msg_row := a_msg_row
		end

	msg_scrolled: INTEGER_32 assign set_msg_scrolled

	set_msg_scrolled (a_msg_scrolled: INTEGER_32)
		do
			msg_scrolled := a_msg_scrolled
		end

	msg_scrolled_ign: INTEGER_32 assign set_msg_scrolled_ign

	set_msg_scrolled_ign (a_msg_scrolled_ign: INTEGER_32)
		do
			msg_scrolled_ign := a_msg_scrolled_ign
		end

	keep_msg: CE_POINTER [NATURAL_8]

	keep_msg_attr: INTEGER_32 assign set_keep_msg_attr

	set_keep_msg_attr (a_keep_msg_attr: INTEGER_32)
		do
			keep_msg_attr := a_keep_msg_attr
		end

	keep_msg_more: INTEGER_32 assign set_keep_msg_more

	set_keep_msg_more (a_keep_msg_more: INTEGER_32)
		do
			keep_msg_more := a_keep_msg_more
		end

	need_fileinfo: INTEGER_32 assign set_need_fileinfo

	set_need_fileinfo (a_need_fileinfo: INTEGER_32)
		do
			need_fileinfo := a_need_fileinfo
		end

	msg_scroll: INTEGER_32 assign set_msg_scroll

	set_msg_scroll (a_msg_scroll: INTEGER_32)
		do
			msg_scroll := a_msg_scroll
		end

	msg_didout: INTEGER_32 assign set_msg_didout

	set_msg_didout (a_msg_didout: INTEGER_32)
		do
			msg_didout := a_msg_didout
		end

	msg_didany: INTEGER_32 assign set_msg_didany

	set_msg_didany (a_msg_didany: INTEGER_32)
		do
			msg_didany := a_msg_didany
		end

	msg_nowait: INTEGER_32 assign set_msg_nowait

	set_msg_nowait (a_msg_nowait: INTEGER_32)
		do
			msg_nowait := a_msg_nowait
		end

	emsg_off: INTEGER_32 assign set_emsg_off

	set_emsg_off (a_emsg_off: INTEGER_32)
		do
			emsg_off := a_emsg_off
		end

	info_message: INTEGER_32 assign set_info_message

	set_info_message (a_info_message: INTEGER_32)
		do
			info_message := a_info_message
		end

	msg_hist_off: INTEGER_32 assign set_msg_hist_off

	set_msg_hist_off (a_msg_hist_off: INTEGER_32)
		do
			msg_hist_off := a_msg_hist_off
		end

	need_clr_eos: INTEGER_32 assign set_need_clr_eos

	set_need_clr_eos (a_need_clr_eos: INTEGER_32)
		do
			need_clr_eos := a_need_clr_eos
		end

	emsg_skip: INTEGER_32 assign set_emsg_skip

	set_emsg_skip (a_emsg_skip: INTEGER_32)
		do
			emsg_skip := a_emsg_skip
		end

	emsg_severe: INTEGER_32 assign set_emsg_severe

	set_emsg_severe (a_emsg_severe: INTEGER_32)
		do
			emsg_severe := a_emsg_severe
		end

	did_endif: INTEGER_32 assign set_did_endif

	set_did_endif (a_did_endif: INTEGER_32)
		do
			did_endif := a_did_endif
		end

	did_emsg: INTEGER_32 assign set_did_emsg

	set_did_emsg (a_did_emsg: INTEGER_32)
		do
			did_emsg := a_did_emsg
		end

	called_emsg: INTEGER_32 assign set_called_emsg

	set_called_emsg (a_called_emsg: INTEGER_32)
		do
			called_emsg := a_called_emsg
		end

	ex_exitval: INTEGER_32 assign set_ex_exitval

	set_ex_exitval (a_ex_exitval: INTEGER_32)
		do
			ex_exitval := a_ex_exitval
		end

	emsg_on_display: INTEGER_32 assign set_emsg_on_display

	set_emsg_on_display (a_emsg_on_display: INTEGER_32)
		do
			emsg_on_display := a_emsg_on_display
		end

	rc_did_emsg: INTEGER_32 assign set_rc_did_emsg

	set_rc_did_emsg (a_rc_did_emsg: INTEGER_32)
		do
			rc_did_emsg := a_rc_did_emsg
		end

	no_wait_return: INTEGER_32 assign set_no_wait_return

	set_no_wait_return (a_no_wait_return: INTEGER_32)
		do
			no_wait_return := a_no_wait_return
		end

	need_wait_return: INTEGER_32 assign set_need_wait_return

	set_need_wait_return (a_need_wait_return: INTEGER_32)
		do
			need_wait_return := a_need_wait_return
		end

	did_wait_return: INTEGER_32 assign set_did_wait_return

	set_did_wait_return (a_did_wait_return: INTEGER_32)
		do
			did_wait_return := a_did_wait_return
		end

	need_maketitle: INTEGER_32 assign set_need_maketitle

	set_need_maketitle (a_need_maketitle: INTEGER_32)
		do
			need_maketitle := a_need_maketitle
		end

	quit_more: INTEGER_32 assign set_quit_more

	set_quit_more (a_quit_more: INTEGER_32)
		do
			quit_more := a_quit_more
		end

	newline_on_exit: INTEGER_32 assign set_newline_on_exit

	set_newline_on_exit (a_newline_on_exit: INTEGER_32)
		do
			newline_on_exit := a_newline_on_exit
		end

	intr_char: INTEGER_32 assign set_intr_char

	set_intr_char (a_intr_char: INTEGER_32)
		do
			intr_char := a_intr_char
		end

	x_no_connect: INTEGER_32 assign set_x_no_connect

	set_x_no_connect (a_x_no_connect: INTEGER_32)
		do
			x_no_connect := a_x_no_connect
		end

	x_force_connect: INTEGER_32 assign set_x_force_connect

	set_x_force_connect (a_x_force_connect: INTEGER_32)
		do
			x_force_connect := a_x_force_connect
		end

	ex_keep_indent: INTEGER_32 assign set_ex_keep_indent

	set_ex_keep_indent (a_ex_keep_indent: INTEGER_32)
		do
			ex_keep_indent := a_ex_keep_indent
		end

	vgetc_busy: INTEGER_32 assign set_vgetc_busy

	set_vgetc_busy (a_vgetc_busy: INTEGER_32)
		do
			vgetc_busy := a_vgetc_busy
		end

	didset_vim: INTEGER_32 assign set_didset_vim

	set_didset_vim (a_didset_vim: INTEGER_32)
		do
			didset_vim := a_didset_vim
		end

	didset_vimruntime: INTEGER_32 assign set_didset_vimruntime

	set_didset_vimruntime (a_didset_vimruntime: INTEGER_32)
		do
			didset_vimruntime := a_didset_vimruntime
		end

	lines_left: INTEGER_32 assign set_lines_left

	set_lines_left (a_lines_left: INTEGER_32)
		do
			lines_left := a_lines_left
		end

	msg_no_more: INTEGER_32 assign set_msg_no_more

	set_msg_no_more (a_msg_no_more: INTEGER_32)
		do
			msg_no_more := a_msg_no_more
		end

	sourcing_name: CE_POINTER [NATURAL_8]

	sourcing_lnum: INTEGER_32 assign set_sourcing_lnum

	set_sourcing_lnum (a_sourcing_lnum: INTEGER_32)
		do
			sourcing_lnum := a_sourcing_lnum
		end

	ex_nesting_level: INTEGER_32 assign set_ex_nesting_level

	set_ex_nesting_level (a_ex_nesting_level: INTEGER_32)
		do
			ex_nesting_level := a_ex_nesting_level
		end

	debug_break_level: INTEGER_32 assign set_debug_break_level

	set_debug_break_level (a_debug_break_level: INTEGER_32)
		do
			debug_break_level := a_debug_break_level
		end

	debug_did_msg: INTEGER_32 assign set_debug_did_msg

	set_debug_did_msg (a_debug_did_msg: INTEGER_32)
		do
			debug_did_msg := a_debug_did_msg
		end

	debug_tick: INTEGER_32 assign set_debug_tick

	set_debug_tick (a_debug_tick: INTEGER_32)
		do
			debug_tick := a_debug_tick
		end

	current_exception: CE_POINTER [PD_VIM_EXCEPTION]

	did_throw: INTEGER_32 assign set_did_throw

	set_did_throw (a_did_throw: INTEGER_32)
		do
			did_throw := a_did_throw
		end

	need_rethrow: INTEGER_32 assign set_need_rethrow

	set_need_rethrow (a_need_rethrow: INTEGER_32)
		do
			need_rethrow := a_need_rethrow
		end

	check_cstack: INTEGER_32 assign set_check_cstack

	set_check_cstack (a_check_cstack: INTEGER_32)
		do
			check_cstack := a_check_cstack
		end

	trylevel: INTEGER_32 assign set_trylevel

	set_trylevel (a_trylevel: INTEGER_32)
		do
			trylevel := a_trylevel
		end

	force_abort: INTEGER_32 assign set_force_abort

	set_force_abort (a_force_abort: INTEGER_32)
		do
			force_abort := a_force_abort
		end

	msg_list: CE_POINTER [CE_POINTER [PD_MSGLIST]]

	suppress_errthrow: INTEGER_32 assign set_suppress_errthrow

	set_suppress_errthrow (a_suppress_errthrow: INTEGER_32)
		do
			suppress_errthrow := a_suppress_errthrow
		end

	caught_stack: CE_POINTER [PD_VIM_EXCEPTION]

	may_garbage_collect: INTEGER_32 assign set_may_garbage_collect

	set_may_garbage_collect (a_may_garbage_collect: INTEGER_32)
		do
			may_garbage_collect := a_may_garbage_collect
		end

	want_garbage_collect: INTEGER_32 assign set_want_garbage_collect

	set_want_garbage_collect (a_want_garbage_collect: INTEGER_32)
		do
			want_garbage_collect := a_want_garbage_collect
		end

	garbage_collect_at_exit: INTEGER_32 assign set_garbage_collect_at_exit

	set_garbage_collect_at_exit (a_garbage_collect_at_exit: INTEGER_32)
		do
			garbage_collect_at_exit := a_garbage_collect_at_exit
		end

	current_SID: INTEGER_32 assign set_current_SID

	set_current_SID (a_current_SID: INTEGER_32)
		do
			current_SID := a_current_SID
		end

	hash_removed: NATURAL_8 assign set_hash_removed
		do
			Result := hash_removed_address[0]
		end

	set_hash_removed (a_hash_removed: NATURAL_8)
		do
			hash_removed_address[0] := a_hash_removed
		end

	hash_removed_address: CE_POINTER [NATURAL_8]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Natural_8_bytes))
		end

	scroll_region: INTEGER_32 assign set_scroll_region

	set_scroll_region (a_scroll_region: INTEGER_32)
		do
			scroll_region := a_scroll_region
		end

	t_colors: INTEGER_32 assign set_t_colors

	set_t_colors (a_t_colors: INTEGER_32)
		do
			t_colors := a_t_colors
		end

	highlight_match: INTEGER_32 assign set_highlight_match

	set_highlight_match (a_highlight_match: INTEGER_32)
		do
			highlight_match := a_highlight_match
		end

	search_match_lines: INTEGER_32 assign set_search_match_lines

	set_search_match_lines (a_search_match_lines: INTEGER_32)
		do
			search_match_lines := a_search_match_lines
		end

	search_match_endcol: INTEGER_32 assign set_search_match_endcol

	set_search_match_endcol (a_search_match_endcol: INTEGER_32)
		do
			search_match_endcol := a_search_match_endcol
		end

	no_smartcase: INTEGER_32 assign set_no_smartcase

	set_no_smartcase (a_no_smartcase: INTEGER_32)
		do
			no_smartcase := a_no_smartcase
		end

	need_check_timestamps: INTEGER_32 assign set_need_check_timestamps

	set_need_check_timestamps (a_need_check_timestamps: INTEGER_32)
		do
			need_check_timestamps := a_need_check_timestamps
		end

	did_check_timestamps: INTEGER_32 assign set_did_check_timestamps

	set_did_check_timestamps (a_did_check_timestamps: INTEGER_32)
		do
			did_check_timestamps := a_did_check_timestamps
		end

	no_check_timestamps: INTEGER_32 assign set_no_check_timestamps

	set_no_check_timestamps (a_no_check_timestamps: INTEGER_32)
		do
			no_check_timestamps := a_no_check_timestamps
		end

	highlight_attr: CE_ARRAY [INTEGER_32]

	highlight_user: CE_ARRAY [INTEGER_32]

	highlight_stlnc: CE_ARRAY [INTEGER_32]

	use_gvimrc: CE_POINTER [NATURAL_8]

	cterm_normal_fg_color: INTEGER_32 assign set_cterm_normal_fg_color

	set_cterm_normal_fg_color (a_cterm_normal_fg_color: INTEGER_32)
		do
			cterm_normal_fg_color := a_cterm_normal_fg_color
		end

	cterm_normal_fg_bold: INTEGER_32 assign set_cterm_normal_fg_bold

	set_cterm_normal_fg_bold (a_cterm_normal_fg_bold: INTEGER_32)
		do
			cterm_normal_fg_bold := a_cterm_normal_fg_bold
		end

	cterm_normal_bg_color: INTEGER_32 assign set_cterm_normal_bg_color

	set_cterm_normal_bg_color (a_cterm_normal_bg_color: INTEGER_32)
		do
			cterm_normal_bg_color := a_cterm_normal_bg_color
		end

	autocmd_busy: INTEGER_32 assign set_autocmd_busy

	set_autocmd_busy (a_autocmd_busy: INTEGER_32)
		do
			autocmd_busy := a_autocmd_busy
		end

	autocmd_no_enter: INTEGER_32 assign set_autocmd_no_enter

	set_autocmd_no_enter (a_autocmd_no_enter: INTEGER_32)
		do
			autocmd_no_enter := a_autocmd_no_enter
		end

	autocmd_no_leave: INTEGER_32 assign set_autocmd_no_leave

	set_autocmd_no_leave (a_autocmd_no_leave: INTEGER_32)
		do
			autocmd_no_leave := a_autocmd_no_leave
		end

	modified_was_set: INTEGER_32 assign set_modified_was_set

	set_modified_was_set (a_modified_was_set: INTEGER_32)
		do
			modified_was_set := a_modified_was_set
		end

	did_filetype: INTEGER_32 assign set_did_filetype

	set_did_filetype (a_did_filetype: INTEGER_32)
		do
			did_filetype := a_did_filetype
		end

	keep_filetype: INTEGER_32 assign set_keep_filetype

	set_keep_filetype (a_keep_filetype: INTEGER_32)
		do
			keep_filetype := a_keep_filetype
		end

	au_new_curbuf: CE_POINTER [PD_FILE_BUFFER]

	mouse_row: INTEGER_32 assign set_mouse_row

	set_mouse_row (a_mouse_row: INTEGER_32)
		do
			mouse_row := a_mouse_row
		end

	mouse_col: INTEGER_32 assign set_mouse_col

	set_mouse_col (a_mouse_col: INTEGER_32)
		do
			mouse_col := a_mouse_col
		end

	mouse_past_bottom: INTEGER_32 assign set_mouse_past_bottom

	set_mouse_past_bottom (a_mouse_past_bottom: INTEGER_32)
		do
			mouse_past_bottom := a_mouse_past_bottom
		end

	mouse_past_eol: INTEGER_32 assign set_mouse_past_eol

	set_mouse_past_eol (a_mouse_past_eol: INTEGER_32)
		do
			mouse_past_eol := a_mouse_past_eol
		end

	mouse_dragging: INTEGER_32 assign set_mouse_dragging

	set_mouse_dragging (a_mouse_dragging: INTEGER_32)
		do
			mouse_dragging := a_mouse_dragging
		end

	need_mouse_correct: INTEGER_32 assign set_need_mouse_correct

	set_need_mouse_correct (a_need_mouse_correct: INTEGER_32)
		do
			need_mouse_correct := a_need_mouse_correct
		end

	gui_prev_topline: INTEGER_32 assign set_gui_prev_topline

	set_gui_prev_topline (a_gui_prev_topline: INTEGER_32)
		do
			gui_prev_topline := a_gui_prev_topline
		end

	gui_prev_topfill: INTEGER_32 assign set_gui_prev_topfill

	set_gui_prev_topfill (a_gui_prev_topfill: INTEGER_32)
		do
			gui_prev_topfill := a_gui_prev_topfill
		end

	drag_status_line: INTEGER_32 assign set_drag_status_line

	set_drag_status_line (a_drag_status_line: INTEGER_32)
		do
			drag_status_line := a_drag_status_line
		end

	postponed_mouseshape: INTEGER_32 assign set_postponed_mouseshape

	set_postponed_mouseshape (a_postponed_mouseshape: INTEGER_32)
		do
			postponed_mouseshape := a_postponed_mouseshape
		end

	drag_sep_line: INTEGER_32 assign set_drag_sep_line

	set_drag_sep_line (a_drag_sep_line: INTEGER_32)
		do
			drag_sep_line := a_drag_sep_line
		end

	diff_context: INTEGER_32 assign set_diff_context

	set_diff_context (a_diff_context: INTEGER_32)
		do
			diff_context := a_diff_context
		end

	diff_foldcolumn: INTEGER_32 assign set_diff_foldcolumn

	set_diff_foldcolumn (a_diff_foldcolumn: INTEGER_32)
		do
			diff_foldcolumn := a_diff_foldcolumn
		end

	diff_need_scrollbind: INTEGER_32 assign set_diff_need_scrollbind

	set_diff_need_scrollbind (a_diff_need_scrollbind: INTEGER_32)
		do
			diff_need_scrollbind := a_diff_need_scrollbind
		end

	root_menu: CE_POINTER [PD_VIMMENU]

	sys_menu: INTEGER_32 assign set_sys_menu

	set_sys_menu (a_sys_menu: INTEGER_32)
		do
			sys_menu := a_sys_menu
		end

	updating_screen: INTEGER_32 assign set_updating_screen

	set_updating_screen (a_updating_screen: INTEGER_32)
		do
			updating_screen := a_updating_screen
		end

	current_menu: CE_POINTER [PD_VIMMENU]

	force_menu_update: INTEGER_32 assign set_force_menu_update

	set_force_menu_update (a_force_menu_update: INTEGER_32)
		do
			force_menu_update := a_force_menu_update
		end

	current_tab: INTEGER_32 assign set_current_tab

	set_current_tab (a_current_tab: INTEGER_32)
		do
			current_tab := a_current_tab
		end

	current_tabmenu: INTEGER_32 assign set_current_tabmenu

	set_current_tabmenu (a_current_tabmenu: INTEGER_32)
		do
			current_tabmenu := a_current_tabmenu
		end

	current_scrollbar: INTEGER_32 assign set_current_scrollbar

	set_current_scrollbar (a_current_scrollbar: INTEGER_32)
		do
			current_scrollbar := a_current_scrollbar
		end

	scrollbar_value: NATURAL_32 assign set_scrollbar_value

	set_scrollbar_value (a_scrollbar_value: NATURAL_32)
		do
			scrollbar_value := a_scrollbar_value
		end

	found_reverse_arg: INTEGER_32 assign set_found_reverse_arg

	set_found_reverse_arg (a_found_reverse_arg: INTEGER_32)
		do
			found_reverse_arg := a_found_reverse_arg
		end

	font_argument: CE_POINTER [INTEGER_8]

	background_argument: CE_POINTER [INTEGER_8]

	foreground_argument: CE_POINTER [INTEGER_8]

	hold_gui_events: INTEGER_32 assign set_hold_gui_events

	set_hold_gui_events (a_hold_gui_events: INTEGER_32)
		do
			hold_gui_events := a_hold_gui_events
		end

	new_pixel_width: INTEGER_32 assign set_new_pixel_width

	set_new_pixel_width (a_new_pixel_width: INTEGER_32)
		do
			new_pixel_width := a_new_pixel_width
		end

	new_pixel_height: INTEGER_32 assign set_new_pixel_height

	set_new_pixel_height (a_new_pixel_height: INTEGER_32)
		do
			new_pixel_height := a_new_pixel_height
		end

	gui_win_x: INTEGER_32 assign set_gui_win_x

	set_gui_win_x (a_gui_win_x: INTEGER_32)
		do
			gui_win_x := a_gui_win_x
		end

	gui_win_y: INTEGER_32 assign set_gui_win_y

	set_gui_win_y (a_gui_win_y: INTEGER_32)
		do
			gui_win_y := a_gui_win_y
		end

	clip_star: PD_VIMCLIPBOARD

	clip_plus: PD_VIMCLIPBOARD

	clip_unnamed: INTEGER_32 assign set_clip_unnamed

	set_clip_unnamed (a_clip_unnamed: INTEGER_32)
		do
			clip_unnamed := a_clip_unnamed
		end

	clip_autoselect: INTEGER_32 assign set_clip_autoselect

	set_clip_autoselect (a_clip_autoselect: INTEGER_32)
		do
			clip_autoselect := a_clip_autoselect
		end

	clip_autoselectml: INTEGER_32 assign set_clip_autoselectml

	set_clip_autoselectml (a_clip_autoselectml: INTEGER_32)
		do
			clip_autoselectml := a_clip_autoselectml
		end

	clip_html: INTEGER_32 assign set_clip_html

	set_clip_html (a_clip_html: INTEGER_32)
		do
			clip_html := a_clip_html
		end

	clip_exclude_prog: CE_POINTER [PD_REGPROG_T]

	firstwin: CE_POINTER [PD_WINDOW_S]

	lastwin: CE_POINTER [PD_WINDOW_S]

	prevwin: CE_POINTER [PD_WINDOW_S]

	curwin: CE_POINTER [PD_WINDOW_S]

	aucmd_win: CE_POINTER [PD_WINDOW_S]

	aucmd_win_used: INTEGER_32 assign set_aucmd_win_used

	set_aucmd_win_used (a_aucmd_win_used: INTEGER_32)
		do
			aucmd_win_used := a_aucmd_win_used
		end

	topframe: CE_POINTER [PD_FRAME_S]

	first_tabpage: CE_POINTER [PD_TABPAGE_S]

	curtab: CE_POINTER [PD_TABPAGE_S]

	redraw_tabline: INTEGER_32 assign set_redraw_tabline

	set_redraw_tabline (a_redraw_tabline: INTEGER_32)
		do
			redraw_tabline := a_redraw_tabline
		end

	firstbuf: CE_POINTER [PD_FILE_BUFFER]

	lastbuf: CE_POINTER [PD_FILE_BUFFER]

	curbuf: CE_POINTER [PD_FILE_BUFFER]

	mf_dont_release: INTEGER_32 assign set_mf_dont_release

	set_mf_dont_release (a_mf_dont_release: INTEGER_32)
		do
			mf_dont_release := a_mf_dont_release
		end

	global_alist: PD_ARGLIST

	arg_had_last: INTEGER_32 assign set_arg_had_last

	set_arg_had_last (a_arg_had_last: INTEGER_32)
		do
			arg_had_last := a_arg_had_last
		end

	ru_col: INTEGER_32 assign set_ru_col

	set_ru_col (a_ru_col: INTEGER_32)
		do
			ru_col := a_ru_col
		end

	ru_wid: INTEGER_32 assign set_ru_wid

	set_ru_wid (a_ru_wid: INTEGER_32)
		do
			ru_wid := a_ru_wid
		end

	sc_col: INTEGER_32 assign set_sc_col

	set_sc_col (a_sc_col: INTEGER_32)
		do
			sc_col := a_sc_col
		end

	vim_tempdir: CE_POINTER [NATURAL_8]

	starting: INTEGER_32 assign set_starting

	set_starting (a_starting: INTEGER_32)
		do
			starting := a_starting
		end

	exiting: INTEGER_32 assign set_exiting

	set_exiting (a_exiting: INTEGER_32)
		do
			exiting := a_exiting
		end

	really_exiting: INTEGER_32 assign set_really_exiting

	set_really_exiting (a_really_exiting: INTEGER_32)
		do
			really_exiting := a_really_exiting
		end

	full_screen: INTEGER_32 assign set_full_screen

	set_full_screen (a_full_screen: INTEGER_32)
		do
			full_screen := a_full_screen
		end

	restricted: INTEGER_32 assign set_restricted

	set_restricted (a_restricted: INTEGER_32)
		do
			restricted := a_restricted
		end

	secure: INTEGER_32 assign set_secure

	set_secure (a_secure: INTEGER_32)
		do
			secure := a_secure
		end

	textlock: INTEGER_32 assign set_textlock

	set_textlock (a_textlock: INTEGER_32)
		do
			textlock := a_textlock
		end

	curbuf_lock: INTEGER_32 assign set_curbuf_lock

	set_curbuf_lock (a_curbuf_lock: INTEGER_32)
		do
			curbuf_lock := a_curbuf_lock
		end

	allbuf_lock: INTEGER_32 assign set_allbuf_lock

	set_allbuf_lock (a_allbuf_lock: INTEGER_32)
		do
			allbuf_lock := a_allbuf_lock
		end

	sandbox: INTEGER_32 assign set_sandbox

	set_sandbox (a_sandbox: INTEGER_32)
		do
			sandbox := a_sandbox
		end

	silent_mode: INTEGER_32 assign set_silent_mode

	set_silent_mode (a_silent_mode: INTEGER_32)
		do
			silent_mode := a_silent_mode
		end

	VIsual: PD_POS_T

	VIsual_active: INTEGER_32 assign set_VIsual_active

	set_VIsual_active (a_VIsual_active: INTEGER_32)
		do
			VIsual_active := a_VIsual_active
		end

	VIsual_select: INTEGER_32 assign set_VIsual_select

	set_VIsual_select (a_VIsual_select: INTEGER_32)
		do
			VIsual_select := a_VIsual_select
		end

	VIsual_reselect: INTEGER_32 assign set_VIsual_reselect

	set_VIsual_reselect (a_VIsual_reselect: INTEGER_32)
		do
			VIsual_reselect := a_VIsual_reselect
		end

	VIsual_mode: INTEGER_32 assign set_VIsual_mode

	set_VIsual_mode (a_VIsual_mode: INTEGER_32)
		do
			VIsual_mode := a_VIsual_mode
		end

	redo_VIsual_busy: INTEGER_32 assign set_redo_VIsual_busy

	set_redo_VIsual_busy (a_redo_VIsual_busy: INTEGER_32)
		do
			redo_VIsual_busy := a_redo_VIsual_busy
		end

	where_paste_started: PD_POS_T

	did_ai: INTEGER_32 assign set_did_ai

	set_did_ai (a_did_ai: INTEGER_32)
		do
			did_ai := a_did_ai
		end

	ai_col: INTEGER_32 assign set_ai_col

	set_ai_col (a_ai_col: INTEGER_32)
		do
			ai_col := a_ai_col
		end

	end_comment_pending: INTEGER_32 assign set_end_comment_pending

	set_end_comment_pending (a_end_comment_pending: INTEGER_32)
		do
			end_comment_pending := a_end_comment_pending
		end

	did_syncbind: INTEGER_32 assign set_did_syncbind

	set_did_syncbind (a_did_syncbind: INTEGER_32)
		do
			did_syncbind := a_did_syncbind
		end

	did_si: INTEGER_32 assign set_did_si

	set_did_si (a_did_si: INTEGER_32)
		do
			did_si := a_did_si
		end

	can_si: INTEGER_32 assign set_can_si

	set_can_si (a_can_si: INTEGER_32)
		do
			can_si := a_can_si
		end

	can_si_back: INTEGER_32 assign set_can_si_back

	set_can_si_back (a_can_si_back: INTEGER_32)
		do
			can_si_back := a_can_si_back
		end

	saved_cursor: PD_POS_T

	Insstart: PD_POS_T

	orig_line_count: INTEGER_32 assign set_orig_line_count

	set_orig_line_count (a_orig_line_count: INTEGER_32)
		do
			orig_line_count := a_orig_line_count
		end

	vr_lines_changed: INTEGER_32 assign set_vr_lines_changed

	set_vr_lines_changed (a_vr_lines_changed: INTEGER_32)
		do
			vr_lines_changed := a_vr_lines_changed
		end

	x_jump_env: CE_EXCEPTION assign set_x_jump_env

	set_x_jump_env (a_x_jump_env: CE_EXCEPTION)
		do
			x_jump_env := a_x_jump_env
		end

	lc_jump_env: CE_EXCEPTION assign set_lc_jump_env

	set_lc_jump_env (a_lc_jump_env: CE_EXCEPTION)
		do
			lc_jump_env := a_lc_jump_env
		end

	lc_signal: INTEGER_32 assign set_lc_signal

	set_lc_signal (a_lc_signal: INTEGER_32)
		do
			lc_signal := a_lc_signal
		end

	lc_active: INTEGER_32 assign set_lc_active

	set_lc_active (a_lc_active: INTEGER_32)
		do
			lc_active := a_lc_active
		end

	enc_dbcs: INTEGER_32 assign set_enc_dbcs

	set_enc_dbcs (a_enc_dbcs: INTEGER_32)
		do
			enc_dbcs := a_enc_dbcs
		end

	enc_unicode: INTEGER_32 assign set_enc_unicode

	set_enc_unicode (a_enc_unicode: INTEGER_32)
		do
			enc_unicode := a_enc_unicode
		end

	enc_utf8: INTEGER_32 assign set_enc_utf8

	set_enc_utf8 (a_enc_utf8: INTEGER_32)
		do
			enc_utf8 := a_enc_utf8
		end

	enc_latin1like: INTEGER_32 assign set_enc_latin1like

	set_enc_latin1like (a_enc_latin1like: INTEGER_32)
		do
			enc_latin1like := a_enc_latin1like
		end

	has_mbyte: INTEGER_32 assign set_has_mbyte

	set_has_mbyte (a_has_mbyte: INTEGER_32)
		do
			has_mbyte := a_has_mbyte
		end

	mb_bytelen_tab: CE_ARRAY [INTEGER_8]

	input_conv: PD_VIMCONV_T

	output_conv: PD_VIMCONV_T

	mb_ptr2len: CE_ROUTINE

	mb_ptr2len_len: CE_ROUTINE

	mb_char2len: CE_ROUTINE

	mb_char2bytes: CE_ROUTINE

	mb_ptr2cells: CE_ROUTINE

	mb_ptr2cells_len: CE_ROUTINE

	mb_char2cells: CE_ROUTINE

	mb_off2cells: CE_ROUTINE

	mb_ptr2char: CE_ROUTINE

	mb_head_off: CE_ROUTINE

	xic: CE_POINTER [SD_GTKIMCONTEXT]

	preedit_start_col: INTEGER_32 assign set_preedit_start_col
		do
			Result := preedit_start_col_address[0]
		end

	set_preedit_start_col (a_preedit_start_col: INTEGER_32)
		do
			preedit_start_col_address[0] := a_preedit_start_col
		end

	preedit_start_col_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	preedit_end_col: INTEGER_32 assign set_preedit_end_col

	set_preedit_end_col (a_preedit_end_col: INTEGER_32)
		do
			preedit_end_col := a_preedit_end_col
		end

	xim_changed_while_preediting: INTEGER_32 assign set_xim_changed_while_preediting

	set_xim_changed_while_preediting (a_xim_changed_while_preediting: INTEGER_32)
		do
			xim_changed_while_preediting := a_xim_changed_while_preediting
		end

	xim_fg_color: INTEGER_32 assign set_xim_fg_color

	set_xim_fg_color (a_xim_fg_color: INTEGER_32)
		do
			xim_fg_color := a_xim_fg_color
		end

	xim_bg_color: INTEGER_32 assign set_xim_bg_color

	set_xim_bg_color (a_xim_bg_color: INTEGER_32)
		do
			xim_bg_color := a_xim_bg_color
		end

	State: INTEGER_32 assign set_State

	set_State (a_State: INTEGER_32)
		do
			State := a_State
		end

	finish_op: INTEGER_32 assign set_finish_op

	set_finish_op (a_finish_op: INTEGER_32)
		do
			finish_op := a_finish_op
		end

	opcount: INTEGER_32 assign set_opcount

	set_opcount (a_opcount: INTEGER_32)
		do
			opcount := a_opcount
		end

	exmode_active: INTEGER_32 assign set_exmode_active

	set_exmode_active (a_exmode_active: INTEGER_32)
		do
			exmode_active := a_exmode_active
		end

	ex_no_reprint: INTEGER_32 assign set_ex_no_reprint

	set_ex_no_reprint (a_ex_no_reprint: INTEGER_32)
		do
			ex_no_reprint := a_ex_no_reprint
		end

	Recording: INTEGER_32 assign set_Recording

	set_Recording (a_Recording: INTEGER_32)
		do
			Recording := a_Recording
		end

	Exec_reg: INTEGER_32 assign set_Exec_reg

	set_Exec_reg (a_Exec_reg: INTEGER_32)
		do
			Exec_reg := a_Exec_reg
		end

	no_mapping: INTEGER_32 assign set_no_mapping

	set_no_mapping (a_no_mapping: INTEGER_32)
		do
			no_mapping := a_no_mapping
		end

	no_zero_mapping: INTEGER_32 assign set_no_zero_mapping

	set_no_zero_mapping (a_no_zero_mapping: INTEGER_32)
		do
			no_zero_mapping := a_no_zero_mapping
		end

	allow_keys: INTEGER_32 assign set_allow_keys

	set_allow_keys (a_allow_keys: INTEGER_32)
		do
			allow_keys := a_allow_keys
		end

	no_u_sync: INTEGER_32 assign set_no_u_sync

	set_no_u_sync (a_no_u_sync: INTEGER_32)
		do
			no_u_sync := a_no_u_sync
		end

	restart_edit: INTEGER_32 assign set_restart_edit

	set_restart_edit (a_restart_edit: INTEGER_32)
		do
			restart_edit := a_restart_edit
		end

	arrow_used: INTEGER_32 assign set_arrow_used

	set_arrow_used (a_arrow_used: INTEGER_32)
		do
			arrow_used := a_arrow_used
		end

	ins_at_eol: INTEGER_32 assign set_ins_at_eol

	set_ins_at_eol (a_ins_at_eol: INTEGER_32)
		do
			ins_at_eol := a_ins_at_eol
		end

	edit_submode: CE_POINTER [NATURAL_8]

	edit_submode_pre: CE_POINTER [NATURAL_8]

	edit_submode_extra: CE_POINTER [NATURAL_8]

	edit_submode_highl: INTEGER_32 assign set_edit_submode_highl

	set_edit_submode_highl (a_edit_submode_highl: INTEGER_32)
		do
			edit_submode_highl := a_edit_submode_highl
		end

	ctrl_x_mode: INTEGER_32 assign set_ctrl_x_mode

	set_ctrl_x_mode (a_ctrl_x_mode: INTEGER_32)
		do
			ctrl_x_mode := a_ctrl_x_mode
		end

	no_abbr: INTEGER_32 assign set_no_abbr

	set_no_abbr (a_no_abbr: INTEGER_32)
		do
			no_abbr := a_no_abbr
		end

	dont_scroll: INTEGER_32 assign set_dont_scroll

	set_dont_scroll (a_dont_scroll: INTEGER_32)
		do
			dont_scroll := a_dont_scroll
		end

	mapped_ctrl_c: INTEGER_32 assign set_mapped_ctrl_c

	set_mapped_ctrl_c (a_mapped_ctrl_c: INTEGER_32)
		do
			mapped_ctrl_c := a_mapped_ctrl_c
		end

	ctrl_c_interrupts: INTEGER_32 assign set_ctrl_c_interrupts

	set_ctrl_c_interrupts (a_ctrl_c_interrupts: INTEGER_32)
		do
			ctrl_c_interrupts := a_ctrl_c_interrupts
		end

	cmdmod: PD_CMDMOD_T

	msg_silent: INTEGER_32 assign set_msg_silent

	set_msg_silent (a_msg_silent: INTEGER_32)
		do
			msg_silent := a_msg_silent
		end

	emsg_silent: INTEGER_32 assign set_emsg_silent

	set_emsg_silent (a_emsg_silent: INTEGER_32)
		do
			emsg_silent := a_emsg_silent
		end

	cmd_silent: INTEGER_32 assign set_cmd_silent

	set_cmd_silent (a_cmd_silent: INTEGER_32)
		do
			cmd_silent := a_cmd_silent
		end

	swap_exists_action: INTEGER_32 assign set_swap_exists_action

	set_swap_exists_action (a_swap_exists_action: INTEGER_32)
		do
			swap_exists_action := a_swap_exists_action
		end

	swap_exists_did_quit: INTEGER_32 assign set_swap_exists_did_quit

	set_swap_exists_did_quit (a_swap_exists_did_quit: INTEGER_32)
		do
			swap_exists_did_quit := a_swap_exists_did_quit
		end

	IObuff: CE_POINTER [NATURAL_8]

	NameBuff: CE_POINTER [NATURAL_8]

	msg_buf: CE_ARRAY [NATURAL_8]

	RedrawingDisabled: INTEGER_32 assign set_RedrawingDisabled

	set_RedrawingDisabled (a_RedrawingDisabled: INTEGER_32)
		do
			RedrawingDisabled := a_RedrawingDisabled
		end

	readonlymode: INTEGER_32 assign set_readonlymode

	set_readonlymode (a_readonlymode: INTEGER_32)
		do
			readonlymode := a_readonlymode
		end

	recoverymode: INTEGER_32 assign set_recoverymode

	set_recoverymode (a_recoverymode: INTEGER_32)
		do
			recoverymode := a_recoverymode
		end

	stuffbuff: PD_BUFFHEADER

	typebuf: PD_TYPEBUF_T

	ex_normal_busy: INTEGER_32 assign set_ex_normal_busy

	set_ex_normal_busy (a_ex_normal_busy: INTEGER_32)
		do
			ex_normal_busy := a_ex_normal_busy
		end

	ex_normal_lock: INTEGER_32 assign set_ex_normal_lock

	set_ex_normal_lock (a_ex_normal_lock: INTEGER_32)
		do
			ex_normal_lock := a_ex_normal_lock
		end

	ignore_script: INTEGER_32 assign set_ignore_script

	set_ignore_script (a_ignore_script: INTEGER_32)
		do
			ignore_script := a_ignore_script
		end

	stop_insert_mode: INTEGER_32 assign set_stop_insert_mode

	set_stop_insert_mode (a_stop_insert_mode: INTEGER_32)
		do
			stop_insert_mode := a_stop_insert_mode
		end

	KeyTyped: INTEGER_32 assign set_KeyTyped

	set_KeyTyped (a_KeyTyped: INTEGER_32)
		do
			KeyTyped := a_KeyTyped
		end

	KeyStuffed: INTEGER_32 assign set_KeyStuffed

	set_KeyStuffed (a_KeyStuffed: INTEGER_32)
		do
			KeyStuffed := a_KeyStuffed
		end

	vgetc_im_active: INTEGER_32 assign set_vgetc_im_active

	set_vgetc_im_active (a_vgetc_im_active: INTEGER_32)
		do
			vgetc_im_active := a_vgetc_im_active
		end

	maptick: INTEGER_32 assign set_maptick

	set_maptick (a_maptick: INTEGER_32)
		do
			maptick := a_maptick
		end

	chartab: CE_ARRAY [NATURAL_8]

	must_redraw: INTEGER_32 assign set_must_redraw

	set_must_redraw (a_must_redraw: INTEGER_32)
		do
			must_redraw := a_must_redraw
		end

	skip_redraw: INTEGER_32 assign set_skip_redraw

	set_skip_redraw (a_skip_redraw: INTEGER_32)
		do
			skip_redraw := a_skip_redraw
		end

	do_redraw: INTEGER_32 assign set_do_redraw

	set_do_redraw (a_do_redraw: INTEGER_32)
		do
			do_redraw := a_do_redraw
		end

	need_highlight_changed: INTEGER_32 assign set_need_highlight_changed

	set_need_highlight_changed (a_need_highlight_changed: INTEGER_32)
		do
			need_highlight_changed := a_need_highlight_changed
		end

	use_viminfo: CE_POINTER [NATURAL_8]

	scriptin: CE_ARRAY [CE_POINTER [SD_IO_FILE]]

	curscript: INTEGER_32 assign set_curscript

	set_curscript (a_curscript: INTEGER_32)
		do
			curscript := a_curscript
		end

	scriptout: CE_POINTER [SD_IO_FILE]

	read_cmd_fd: INTEGER_32 assign set_read_cmd_fd

	set_read_cmd_fd (a_read_cmd_fd: INTEGER_32)
		do
			read_cmd_fd := a_read_cmd_fd
		end

	got_int: INTEGER_32 assign set_got_int

	set_got_int (a_got_int: INTEGER_32)
		do
			got_int := a_got_int
		end

	termcap_active: INTEGER_32 assign set_termcap_active

	set_termcap_active (a_termcap_active: INTEGER_32)
		do
			termcap_active := a_termcap_active
		end

	cur_tmode: INTEGER_32 assign set_cur_tmode

	set_cur_tmode (a_cur_tmode: INTEGER_32)
		do
			cur_tmode := a_cur_tmode
		end

	bangredo: INTEGER_32 assign set_bangredo

	set_bangredo (a_bangredo: INTEGER_32)
		do
			bangredo := a_bangredo
		end

	searchcmdlen: INTEGER_32 assign set_searchcmdlen

	set_searchcmdlen (a_searchcmdlen: INTEGER_32)
		do
			searchcmdlen := a_searchcmdlen
		end

	reg_do_extmatch: INTEGER_32 assign set_reg_do_extmatch

	set_reg_do_extmatch (a_reg_do_extmatch: INTEGER_32)
		do
			reg_do_extmatch := a_reg_do_extmatch
		end

	re_extmatch_in: CE_POINTER [PD_REG_EXTMATCH_T]

	re_extmatch_out: CE_POINTER [PD_REG_EXTMATCH_T]

	did_outofmem_msg: INTEGER_32 assign set_did_outofmem_msg

	set_did_outofmem_msg (a_did_outofmem_msg: INTEGER_32)
		do
			did_outofmem_msg := a_did_outofmem_msg
		end

	did_swapwrite_msg: INTEGER_32 assign set_did_swapwrite_msg

	set_did_swapwrite_msg (a_did_swapwrite_msg: INTEGER_32)
		do
			did_swapwrite_msg := a_did_swapwrite_msg
		end

	undo_off: INTEGER_32 assign set_undo_off

	set_undo_off (a_undo_off: INTEGER_32)
		do
			undo_off := a_undo_off
		end

	global_busy: INTEGER_32 assign set_global_busy

	set_global_busy (a_global_busy: INTEGER_32)
		do
			global_busy := a_global_busy
		end

	listcmd_busy: INTEGER_32 assign set_listcmd_busy

	set_listcmd_busy (a_listcmd_busy: INTEGER_32)
		do
			listcmd_busy := a_listcmd_busy
		end

	need_start_insertmode: INTEGER_32 assign set_need_start_insertmode

	set_need_start_insertmode (a_need_start_insertmode: INTEGER_32)
		do
			need_start_insertmode := a_need_start_insertmode
		end

	last_cmdline: CE_POINTER [NATURAL_8]

	repeat_cmdline: CE_POINTER [NATURAL_8]

	new_last_cmdline: CE_POINTER [NATURAL_8]

	autocmd_fname: CE_POINTER [NATURAL_8]

	autocmd_fname_full: INTEGER_32 assign set_autocmd_fname_full

	set_autocmd_fname_full (a_autocmd_fname_full: INTEGER_32)
		do
			autocmd_fname_full := a_autocmd_fname_full
		end

	autocmd_bufnr: INTEGER_32 assign set_autocmd_bufnr

	set_autocmd_bufnr (a_autocmd_bufnr: INTEGER_32)
		do
			autocmd_bufnr := a_autocmd_bufnr
		end

	autocmd_match: CE_POINTER [NATURAL_8]

	did_cursorhold: INTEGER_32 assign set_did_cursorhold

	set_did_cursorhold (a_did_cursorhold: INTEGER_32)
		do
			did_cursorhold := a_did_cursorhold
		end

	last_cursormoved: PD_POS_T

	write_no_eol_lnum: INTEGER_32 assign set_write_no_eol_lnum

	set_write_no_eol_lnum (a_write_no_eol_lnum: INTEGER_32)
		do
			write_no_eol_lnum := a_write_no_eol_lnum
		end

	postponed_split: INTEGER_32 assign set_postponed_split

	set_postponed_split (a_postponed_split: INTEGER_32)
		do
			postponed_split := a_postponed_split
		end

	postponed_split_flags: INTEGER_32 assign set_postponed_split_flags

	set_postponed_split_flags (a_postponed_split_flags: INTEGER_32)
		do
			postponed_split_flags := a_postponed_split_flags
		end

	postponed_split_tab: INTEGER_32 assign set_postponed_split_tab

	set_postponed_split_tab (a_postponed_split_tab: INTEGER_32)
		do
			postponed_split_tab := a_postponed_split_tab
		end

	g_do_tagpreview: INTEGER_32 assign set_g_do_tagpreview

	set_g_do_tagpreview (a_g_do_tagpreview: INTEGER_32)
		do
			g_do_tagpreview := a_g_do_tagpreview
		end

	replace_offset: INTEGER_32 assign set_replace_offset

	set_replace_offset (a_replace_offset: INTEGER_32)
		do
			replace_offset := a_replace_offset
		end

	escape_chars: CE_POINTER [NATURAL_8]

	keep_help_flag: INTEGER_32 assign set_keep_help_flag

	set_keep_help_flag (a_keep_help_flag: INTEGER_32)
		do
			keep_help_flag := a_keep_help_flag
		end

	empty_option: CE_POINTER [NATURAL_8]

	redir_off: INTEGER_32 assign set_redir_off

	set_redir_off (a_redir_off: INTEGER_32)
		do
			redir_off := a_redir_off
		end

	redir_fd: CE_POINTER [SD_IO_FILE]

	redir_reg: INTEGER_32 assign set_redir_reg

	set_redir_reg (a_redir_reg: INTEGER_32)
		do
			redir_reg := a_redir_reg
		end

	redir_vname: INTEGER_32 assign set_redir_vname

	set_redir_vname (a_redir_vname: INTEGER_32)
		do
			redir_vname := a_redir_vname
		end

	save_p_ls: INTEGER_32 assign set_save_p_ls

	set_save_p_ls (a_save_p_ls: INTEGER_32)
		do
			save_p_ls := a_save_p_ls
		end

	save_p_wmh: INTEGER_32 assign set_save_p_wmh

	set_save_p_wmh (a_save_p_wmh: INTEGER_32)
		do
			save_p_wmh := a_save_p_wmh
		end

	wild_menu_showing: INTEGER_32 assign set_wild_menu_showing

	set_wild_menu_showing (a_wild_menu_showing: INTEGER_32)
		do
			wild_menu_showing := a_wild_menu_showing
		end

	breakat_flags: CE_ARRAY [INTEGER_8]

	globaldir: CE_POINTER [NATURAL_8]

	lcs_eol: INTEGER_32 assign set_lcs_eol
		do
			Result := lcs_eol_address[0]
		end

	set_lcs_eol (a_lcs_eol: INTEGER_32)
		do
			lcs_eol_address[0] := a_lcs_eol
		end

	lcs_eol_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	lcs_ext: INTEGER_32 assign set_lcs_ext
		do
			Result := lcs_ext_address[0]
		end

	set_lcs_ext (a_lcs_ext: INTEGER_32)
		do
			lcs_ext_address[0] := a_lcs_ext
		end

	lcs_ext_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	lcs_prec: INTEGER_32 assign set_lcs_prec
		do
			Result := lcs_prec_address[0]
		end

	set_lcs_prec (a_lcs_prec: INTEGER_32)
		do
			lcs_prec_address[0] := a_lcs_prec
		end

	lcs_prec_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	lcs_nbsp: INTEGER_32 assign set_lcs_nbsp
		do
			Result := lcs_nbsp_address[0]
		end

	set_lcs_nbsp (a_lcs_nbsp: INTEGER_32)
		do
			lcs_nbsp_address[0] := a_lcs_nbsp
		end

	lcs_nbsp_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	lcs_tab1: INTEGER_32 assign set_lcs_tab1

	set_lcs_tab1 (a_lcs_tab1: INTEGER_32)
		do
			lcs_tab1 := a_lcs_tab1
		end

	lcs_tab2: INTEGER_32 assign set_lcs_tab2
		do
			Result := lcs_tab2_address[0]
		end

	set_lcs_tab2 (a_lcs_tab2: INTEGER_32)
		do
			lcs_tab2_address[0] := a_lcs_tab2
		end

	lcs_tab2_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	lcs_trail: INTEGER_32 assign set_lcs_trail
		do
			Result := lcs_trail_address[0]
		end

	set_lcs_trail (a_lcs_trail: INTEGER_32)
		do
			lcs_trail_address[0] := a_lcs_trail
		end

	lcs_trail_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	fill_stl: INTEGER_32 assign set_fill_stl
		do
			Result := fill_stl_address[0]
		end

	set_fill_stl (a_fill_stl: INTEGER_32)
		do
			fill_stl_address[0] := a_fill_stl
		end

	fill_stl_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	fill_stlnc: INTEGER_32 assign set_fill_stlnc
		do
			Result := fill_stlnc_address[0]
		end

	set_fill_stlnc (a_fill_stlnc: INTEGER_32)
		do
			fill_stlnc_address[0] := a_fill_stlnc
		end

	fill_stlnc_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	fill_vert: INTEGER_32 assign set_fill_vert
		do
			Result := fill_vert_address[0]
		end

	set_fill_vert (a_fill_vert: INTEGER_32)
		do
			fill_vert_address[0] := a_fill_vert
		end

	fill_vert_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	fill_fold: INTEGER_32 assign set_fill_fold
		do
			Result := fill_fold_address[0]
		end

	set_fill_fold (a_fill_fold: INTEGER_32)
		do
			fill_fold_address[0] := a_fill_fold
		end

	fill_fold_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	fill_diff: INTEGER_32 assign set_fill_diff
		do
			Result := fill_diff_address[0]
		end

	set_fill_diff (a_fill_diff: INTEGER_32)
		do
			fill_diff_address[0] := a_fill_diff
		end

	fill_diff_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	km_stopsel: INTEGER_32 assign set_km_stopsel

	set_km_stopsel (a_km_stopsel: INTEGER_32)
		do
			km_stopsel := a_km_stopsel
		end

	km_startsel: INTEGER_32 assign set_km_startsel

	set_km_startsel (a_km_startsel: INTEGER_32)
		do
			km_startsel := a_km_startsel
		end

	cedit_key: INTEGER_32 assign set_cedit_key

	set_cedit_key (a_cedit_key: INTEGER_32)
		do
			cedit_key := a_cedit_key
		end

	cmdwin_type: INTEGER_32 assign set_cmdwin_type

	set_cmdwin_type (a_cmdwin_type: INTEGER_32)
		do
			cmdwin_type := a_cmdwin_type
		end

	cmdwin_result: INTEGER_32 assign set_cmdwin_result

	set_cmdwin_result (a_cmdwin_result: INTEGER_32)
		do
			cmdwin_result := a_cmdwin_result
		end

	no_lines_msg: CE_ARRAY [NATURAL_8]

	sub_nsubs: INTEGER_32 assign set_sub_nsubs

	set_sub_nsubs (a_sub_nsubs: INTEGER_32)
		do
			sub_nsubs := a_sub_nsubs
		end

	sub_nlines: INTEGER_32 assign set_sub_nlines

	set_sub_nlines (a_sub_nlines: INTEGER_32)
		do
			sub_nlines := a_sub_nlines
		end

	wim_flags: CE_ARRAY [NATURAL_8]

	stl_syntax: INTEGER_32 assign set_stl_syntax

	set_stl_syntax (a_stl_syntax: INTEGER_32)
		do
			stl_syntax := a_stl_syntax
		end

	no_hlsearch: INTEGER_32 assign set_no_hlsearch

	set_no_hlsearch (a_no_hlsearch: INTEGER_32)
		do
			no_hlsearch := a_no_hlsearch
		end

	balloonEval: CE_POINTER [PD_BALLOONEVALSTRUCT]

	bevalServers: INTEGER_32 assign set_bevalServers

	set_bevalServers (a_bevalServers: INTEGER_32)
		do
			bevalServers := a_bevalServers
		end

	printer_opts: CE_ARRAY [PD_OPTION_TABLE_T]

	printer_page_num: INTEGER_32 assign set_printer_page_num

	set_printer_page_num (a_printer_page_num: INTEGER_32)
		do
			printer_page_num := a_printer_page_num
		end

	xterm_display: CE_POINTER [INTEGER_8]

	xterm_dpy: CE_POINTER [ANY]

	app_context: CE_POINTER [ANY]

	gtk_socket_id: NATURAL_32 assign set_gtk_socket_id

	set_gtk_socket_id (a_gtk_socket_id: NATURAL_32)
		do
			gtk_socket_id := a_gtk_socket_id
		end

	echo_wid_arg: INTEGER_32 assign set_echo_wid_arg

	set_echo_wid_arg (a_echo_wid_arg: INTEGER_32)
		do
			echo_wid_arg := a_echo_wid_arg
		end

	typebuf_was_filled: INTEGER_32 assign set_typebuf_was_filled

	set_typebuf_was_filled (a_typebuf_was_filled: INTEGER_32)
		do
			typebuf_was_filled := a_typebuf_was_filled
		end

	serverName: CE_POINTER [NATURAL_8]

	commWindow: NATURAL_32 assign set_commWindow

	set_commWindow (a_commWindow: NATURAL_32)
		do
			commWindow := a_commWindow
		end

	clientWindow: NATURAL_32 assign set_clientWindow

	set_clientWindow (a_clientWindow: NATURAL_32)
		do
			clientWindow := a_clientWindow
		end

	commProperty: NATURAL_32 assign set_commProperty

	set_commProperty (a_commProperty: NATURAL_32)
		do
			commProperty := a_commProperty
		end

	serverDelayedStartName: CE_POINTER [NATURAL_8]

	term_is_xterm: INTEGER_32 assign set_term_is_xterm

	set_term_is_xterm (a_term_is_xterm: INTEGER_32)
		do
			term_is_xterm := a_term_is_xterm
		end

	virtual_op: INTEGER_32 assign set_virtual_op

	set_virtual_op (a_virtual_op: INTEGER_32)
		do
			virtual_op := a_virtual_op
		end

	display_tick: NATURAL_16 assign set_display_tick

	set_display_tick (a_display_tick: NATURAL_16)
		do
			display_tick := a_display_tick
		end

	spell_redraw_lnum: INTEGER_32 assign set_spell_redraw_lnum

	set_spell_redraw_lnum (a_spell_redraw_lnum: INTEGER_32)
		do
			spell_redraw_lnum := a_spell_redraw_lnum
		end

	error_ga: PD_GROWARRAY

	netbeansArg: CE_POINTER [INTEGER_8]

	netbeansFireChanges: INTEGER_32 assign set_netbeansFireChanges

	set_netbeansFireChanges (a_netbeansFireChanges: INTEGER_32)
		do
			netbeansFireChanges := a_netbeansFireChanges
		end

	netbeansForcedQuit: INTEGER_32 assign set_netbeansForcedQuit

	set_netbeansForcedQuit (a_netbeansForcedQuit: INTEGER_32)
		do
			netbeansForcedQuit := a_netbeansForcedQuit
		end

	netbeansReadFile: INTEGER_32 assign set_netbeansReadFile

	set_netbeansReadFile (a_netbeansReadFile: INTEGER_32)
		do
			netbeansReadFile := a_netbeansReadFile
		end

	netbeansSuppressNoLines: INTEGER_32 assign set_netbeansSuppressNoLines

	set_netbeansSuppressNoLines (a_netbeansSuppressNoLines: INTEGER_32)
		do
			netbeansSuppressNoLines := a_netbeansSuppressNoLines
		end

	e_abort: CE_ARRAY [NATURAL_8]

	e_argreq: CE_ARRAY [NATURAL_8]

	e_backslash: CE_ARRAY [NATURAL_8]

	e_cmdwin: CE_ARRAY [NATURAL_8]

	e_curdir: CE_ARRAY [NATURAL_8]

	e_endif: CE_ARRAY [NATURAL_8]

	e_endtry: CE_ARRAY [NATURAL_8]

	e_endwhile: CE_ARRAY [NATURAL_8]

	e_endfor: CE_ARRAY [NATURAL_8]

	e_while: CE_ARRAY [NATURAL_8]

	e_for: CE_ARRAY [NATURAL_8]

	e_exists: CE_ARRAY [NATURAL_8]

	e_failed: CE_ARRAY [NATURAL_8]

	e_font: CE_ARRAY [NATURAL_8]

	e_internal: CE_ARRAY [NATURAL_8]

	e_interr: CE_ARRAY [NATURAL_8]

	e_invaddr: CE_ARRAY [NATURAL_8]

	e_invarg: CE_ARRAY [NATURAL_8]

	e_invarg2: CE_ARRAY [NATURAL_8]

	e_invexpr2: CE_ARRAY [NATURAL_8]

	e_invrange: CE_ARRAY [NATURAL_8]

	e_invcmd: CE_ARRAY [NATURAL_8]

	e_isadir2: CE_ARRAY [NATURAL_8]

	e_libcall: CE_ARRAY [NATURAL_8]

	e_markinval: CE_ARRAY [NATURAL_8]

	e_marknotset: CE_ARRAY [NATURAL_8]

	e_modifiable: CE_ARRAY [NATURAL_8]

	e_nesting: CE_ARRAY [NATURAL_8]

	e_noalt: CE_ARRAY [NATURAL_8]

	e_noabbr: CE_ARRAY [NATURAL_8]

	e_nobang: CE_ARRAY [NATURAL_8]

	e_nohebrew: CE_ARRAY [NATURAL_8]

	e_nofarsi: CE_ARRAY [NATURAL_8]

	e_noarabic: CE_ARRAY [NATURAL_8]

	e_nogroup: CE_ARRAY [NATURAL_8]

	e_noinstext: CE_ARRAY [NATURAL_8]

	e_nolastcmd: CE_ARRAY [NATURAL_8]

	e_nomap: CE_ARRAY [NATURAL_8]

	e_nomatch: CE_ARRAY [NATURAL_8]

	e_nomatch2: CE_ARRAY [NATURAL_8]

	e_noname: CE_ARRAY [NATURAL_8]

	e_nopresub: CE_ARRAY [NATURAL_8]

	e_noprev: CE_ARRAY [NATURAL_8]

	e_noprevre: CE_ARRAY [NATURAL_8]

	e_norange: CE_ARRAY [NATURAL_8]

	e_noroom: CE_ARRAY [NATURAL_8]

	e_noserver: CE_ARRAY [NATURAL_8]

	e_notcreate: CE_ARRAY [NATURAL_8]

	e_notmp: CE_ARRAY [NATURAL_8]

	e_notopen: CE_ARRAY [NATURAL_8]

	e_notread: CE_ARRAY [NATURAL_8]

	e_nowrtmsg: CE_ARRAY [NATURAL_8]

	e_null: CE_ARRAY [NATURAL_8]

	e_number_exp: CE_ARRAY [NATURAL_8]

	e_openerrf: CE_ARRAY [NATURAL_8]

	e_opendisp: CE_ARRAY [NATURAL_8]

	e_outofmem: CE_ARRAY [NATURAL_8]

	e_patnotf: CE_ARRAY [NATURAL_8]

	e_patnotf2: CE_ARRAY [NATURAL_8]

	e_positive: CE_ARRAY [NATURAL_8]

	e_prev_dir: CE_ARRAY [NATURAL_8]

	e_quickfix: CE_ARRAY [NATURAL_8]

	e_loclist: CE_ARRAY [NATURAL_8]

	e_re_damg: CE_ARRAY [NATURAL_8]

	e_re_corr: CE_ARRAY [NATURAL_8]

	e_readonly: CE_ARRAY [NATURAL_8]

	e_readonlyvar: CE_ARRAY [NATURAL_8]

	e_readonlysbx: CE_ARRAY [NATURAL_8]

	e_readerrf: CE_ARRAY [NATURAL_8]

	e_sandbox: CE_ARRAY [NATURAL_8]

	e_secure: CE_ARRAY [NATURAL_8]

	e_screenmode: CE_ARRAY [NATURAL_8]

	e_scroll: CE_ARRAY [NATURAL_8]

	e_shellempty: CE_ARRAY [NATURAL_8]

	e_swapclose: CE_ARRAY [NATURAL_8]

	e_tagstack: CE_ARRAY [NATURAL_8]

	e_toocompl: CE_ARRAY [NATURAL_8]

	e_longname: CE_ARRAY [NATURAL_8]

	e_toomsbra: CE_ARRAY [NATURAL_8]

	e_toomany: CE_ARRAY [NATURAL_8]

	e_trailing: CE_ARRAY [NATURAL_8]

	e_umark: CE_ARRAY [NATURAL_8]

	e_wildexpand: CE_ARRAY [NATURAL_8]

	e_winheight: CE_ARRAY [NATURAL_8]

	e_winwidth: CE_ARRAY [NATURAL_8]

	e_write: CE_ARRAY [NATURAL_8]

	e_zerocount: CE_ARRAY [NATURAL_8]

	e_usingsid: CE_ARRAY [NATURAL_8]

	e_invexprmsg: CE_ARRAY [NATURAL_8]

	e_guarded: CE_ARRAY [NATURAL_8]

	e_nbreadonly: CE_ARRAY [NATURAL_8]

	e_intern2: CE_ARRAY [NATURAL_8]

	e_maxmempat: CE_ARRAY [NATURAL_8]

	e_emptybuf: CE_ARRAY [NATURAL_8]

	e_invalpat: CE_ARRAY [NATURAL_8]

	e_bufloaded: CE_ARRAY [NATURAL_8]

	e_notset: CE_ARRAY [NATURAL_8]

	top_bot_msg: CE_ARRAY [INTEGER_8]

	bot_top_msg: CE_ARRAY [INTEGER_8]

	need_key_msg: CE_ARRAY [INTEGER_8]

	xsmp_icefd: INTEGER_32 assign set_xsmp_icefd
		do
			Result := xsmp_icefd_address[0]
		end

	set_xsmp_icefd (a_xsmp_icefd: INTEGER_32)
		do
			xsmp_icefd_address[0] := a_xsmp_icefd
		end

	xsmp_icefd_address: CE_POINTER [INTEGER_32]
		once ("OBJECT")
			create Result.make_shared (default_pointer.memory_calloc (1, Integer_32_bytes))
		end

	starttime: INTEGER_32 assign set_starttime

	set_starttime (a_starttime: INTEGER_32)
		do
			starttime := a_starttime
		end

	time_fd: CE_POINTER [SD_IO_FILE]

	ignored: INTEGER_32 assign set_ignored

	set_ignored (a_ignored: INTEGER_32)
		do
			ignored := a_ignored
		end

	ignoredp: CE_POINTER [INTEGER_8]

end
