class
	P_GUI_GTK_F

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create parent_class.make
		end

feature {ANY} -- attributes

	parent_class: CE_POINTER [SD_GTKWIDGETCLASS]

	form_type: NATURAL_32 assign set_form_type

	set_form_type (a_form_type: NATURAL_32)
		do
			form_type := a_form_type
		end

feature {ANY} -- routines

	gtk_form_new: CE_POINTER [SD_GTKWIDGET]
		local
			l_form: CE_POINTER [PD_GTKFORM]
		do
			create l_form.make

			l_form.ce_gets (create {CE_POINTER [PD_GTKFORM]}.make_cast ((gtk_type_new ((gtk_form_get_type)))))
			Result := (create {CE_POINTER [SD_GTKWIDGET]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_form), (gtk_widget_get_type)))))
		end

	gtk_form_put (a_form: CE_POINTER [PD_GTKFORM]; a_child_widget: CE_POINTER [SD_GTKWIDGET]; a_x___0: INTEGER_32; a_y: INTEGER_32)
		local
			l_child: CE_POINTER [PD_GTKFORMCHILD]
			l_inst: CE_POINTER [SD_GTYPEINSTANCE]
			l_t: NATURAL_32
			l_r: INTEGER_32
			js: JUMP_STATE
		do
			create l_child.make
			create l_inst.make

			from
			until
				js.loop_left
			loop
				js.reset
				l_inst.ce_gets (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_form))
				l_t := (gtk_form_get_type)
				if (l_inst).c_pointer = default_pointer then
					l_r := 0
				elseif ((l_inst.item.g_class).c_pointer /= default_pointer) then
					if (l_inst.item.g_class).item.g_type = l_t then
						l_r := 1
					else
						l_r := g_type_check_instance_is_a (l_inst, l_t)
					end
				else
					l_r := g_type_check_instance_is_a (l_inst, l_t)
				end
				if not l_r.to_boolean then
					g_return_if_fail_warning (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("gtk_form_put"), ce_string ("GTK_IS_FORM(form)"))
					js.return
				end
				if not js.return_called then
					js.break
				end
			end
			js.reset
			if not js.return_called then
				l_child.ce_gets (create {CE_POINTER [PD_GTKFORMCHILD]}.make_cast ((g_malloc_n ((1).to_natural_32, {PD_GTKFORMCHILD}.sizeof.to_natural_32))))
				l_child.item.widget := a_child_widget
				l_child.item.window := create {CE_POINTER [SD_GDKDRAWABLE]}.make_shared (default_pointer)
				l_child.item.x := a_x___0
				l_child.item.y := a_y;
				(l_child.item.widget).item.requisition.width := 0;
				(l_child.item.widget).item.requisition.height := 0
				l_child.item.mapped := 0
				a_form.item.children := g_list_append (a_form.item.children, create {CE_POINTER [ANY]}.make_cast (l_child))
				if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_form), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 64)) /= {NATURAL_32} 0 then
					gtk_form_attach_child_window (a_form, l_child)
				end
				gtk_widget_set_parent (a_child_widget, create {CE_POINTER [SD_GTKWIDGET]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_form), (gtk_widget_get_type)))))
				gtk_widget_size_request (l_child.item.widget, create {CE_POINTER [SD_GTKREQUISITION]}.make_shared (default_pointer))
				if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_form), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 64)) /= {NATURAL_32} 0 then
					if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_child_widget), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 64)) = {NATURAL_32} 0 then
						gtk_form_realize_child (a_form, l_child)
					end
				end
				gtk_form_position_child (a_form, l_child, 1)
			end
		end

	gtk_form_move (a_form: CE_POINTER [PD_GTKFORM]; a_child_widget: CE_POINTER [SD_GTKWIDGET]; a_x___0: INTEGER_32; a_y: INTEGER_32)
		local
			l_tmp_list: CE_POINTER [SD_GLIST]
			l_child: CE_POINTER [PD_GTKFORMCHILD]
			l_inst: CE_POINTER [SD_GTYPEINSTANCE]
			l_t: NATURAL_32
			l_r: INTEGER_32
			js: JUMP_STATE
		do
			create l_tmp_list.make
			create l_child.make
			create l_inst.make

			from
			until
				js.loop_left
			loop
				js.reset
				l_inst.ce_gets (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_form))
				l_t := (gtk_form_get_type)
				if (l_inst).c_pointer = default_pointer then
					l_r := 0
				elseif ((l_inst.item.g_class).c_pointer /= default_pointer) then
					if (l_inst.item.g_class).item.g_type = l_t then
						l_r := 1
					else
						l_r := g_type_check_instance_is_a (l_inst, l_t)
					end
				else
					l_r := g_type_check_instance_is_a (l_inst, l_t)
				end
				if not l_r.to_boolean then
					g_return_if_fail_warning (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("gtk_form_move"), ce_string ("GTK_IS_FORM(form)"))
					js.return
				end
				if not js.return_called then
					js.break
				end
			end
			js.reset
			if not js.return_called then
				l_tmp_list.ce_gets (a_form.item.children)
				from
				until
					not (not js.loop_left and then ((l_tmp_list).c_pointer /= default_pointer))
				loop
					l_child.ce_gets (create {CE_POINTER [PD_GTKFORMCHILD]}.make_cast (l_tmp_list.item.data))
					if ((l_child.item.widget).c_pointer.to_integer_32).to_natural_32 = (a_child_widget.c_pointer.to_integer_32).to_natural_32 then
						l_child.item.x := a_x___0
						l_child.item.y := a_y
						gtk_form_position_child (a_form, l_child, 1)
						js.return
					end
					if not js.return_called then
						l_tmp_list.ce_gets (l_tmp_list.item.next)
					end
				end
			end
			if not js.return_called then
			end
		end

	gtk_form_freeze (a_form: CE_POINTER [PD_GTKFORM])
		local
			l_inst: CE_POINTER [SD_GTYPEINSTANCE]
			l_t: NATURAL_32
			l_r: INTEGER_32
			js: JUMP_STATE
		do
			create l_inst.make

			from
			until
				js.loop_left
			loop
				js.reset
				l_inst.ce_gets (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_form))
				l_t := (gtk_form_get_type)
				if (l_inst).c_pointer = default_pointer then
					l_r := 0
				elseif ((l_inst.item.g_class).c_pointer /= default_pointer) then
					if (l_inst.item.g_class).item.g_type = l_t then
						l_r := 1
					else
						l_r := g_type_check_instance_is_a (l_inst, l_t)
					end
				else
					l_r := g_type_check_instance_is_a (l_inst, l_t)
				end
				if not l_r.to_boolean then
					g_return_if_fail_warning (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("gtk_form_freeze"), ce_string ("GTK_IS_FORM(form)"))
					js.return
				end
				if not js.return_called then
					js.break
				end
			end
			js.reset
			if not js.return_called then
				a_form.item.freeze_count := (a_form.item.freeze_count) + 1
			end
		end

	gtk_form_thaw (a_form: CE_POINTER [PD_GTKFORM])
		local
			l_inst: CE_POINTER [SD_GTYPEINSTANCE]
			l_t: NATURAL_32
			l_r: INTEGER_32
			js: JUMP_STATE
		do
			create l_inst.make

			from
			until
				js.loop_left
			loop
				js.reset
				l_inst.ce_gets (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_form))
				l_t := (gtk_form_get_type)
				if (l_inst).c_pointer = default_pointer then
					l_r := 0
				elseif ((l_inst.item.g_class).c_pointer /= default_pointer) then
					if (l_inst.item.g_class).item.g_type = l_t then
						l_r := 1
					else
						l_r := g_type_check_instance_is_a (l_inst, l_t)
					end
				else
					l_r := g_type_check_instance_is_a (l_inst, l_t)
				end
				if not l_r.to_boolean then
					g_return_if_fail_warning (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("gtk_form_thaw"), ce_string ("GTK_IS_FORM(form)"))
					js.return
				end
				if not js.return_called then
					js.break
				end
			end
			js.reset
			if not js.return_called and then ((a_form.item.freeze_count).to_boolean) then
				a_form.item.freeze_count := (a_form.item.freeze_count) - 1
				if not (a_form.item.freeze_count).to_boolean then
					gtk_form_position_children (a_form)
					gtk_widget_queue_draw (create {CE_POINTER [SD_GTKWIDGET]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_form), (gtk_widget_get_type)))))
				end
			end
		end

	gtk_form_get_type: NATURAL_32
		local
			l_form_info: SD_GTKTYPEINFO
		do
			create l_form_info.make

			if not form_type.to_boolean then
				memset (create {CE_POINTER [ANY]}.make_cast ((l_form_info.address)), 0, {SD_GTKTYPEINFO}.sizeof.to_natural_32).do_nothing
				l_form_info.type_name := ce_string ("GtkForm")
				l_form_info.object_size := {PD_GTKFORM}.sizeof.to_natural_32
				l_form_info.class_size := {PD_GTKFORMCLASS}.sizeof.to_natural_32
				l_form_info.class_init_func := (gtk_form_class_init_address)
				l_form_info.object_init_func := (gtk_form_init_address)
				form_type := gtk_type_unique ((gtk_container_get_type), (l_form_info.address))
			end
			Result := form_type
		end

	gtk_form_class_init (a_klass: CE_POINTER [PD_GTKFORMCLASS])
		local
			l_widget_class: CE_POINTER [SD_GTKWIDGETCLASS]
			l_container_class: CE_POINTER [SD_GTKCONTAINERCLASS]
		do
			create l_widget_class.make
			create l_container_class.make

			l_widget_class.ce_gets (create {CE_POINTER [SD_GTKWIDGETCLASS]}.make_cast (a_klass))
			l_container_class.ce_gets (create {CE_POINTER [SD_GTKCONTAINERCLASS]}.make_cast (a_klass))
			parent_class.ce_gets (create {CE_POINTER [SD_GTKWIDGETCLASS]}.make_cast ((gtk_type_class ((gtk_container_get_type)))))
			l_widget_class.item.realize := gtk_form_realize_address
			l_widget_class.item.unrealize := gtk_form_unrealize_address
			l_widget_class.item.map := gtk_form_map_address
			l_widget_class.item.size_request := gtk_form_size_request_address
			l_widget_class.item.size_allocate := gtk_form_size_allocate_address
			l_widget_class.item.expose_event := gtk_form_expose_address
			l_container_class.item.remove := gtk_form_remove_address
			l_container_class.item.forall := gtk_form_forall_address
		end

	gtk_form_class_init_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gtk_form_class_init)
		end

	gtk_form_init (a_form: CE_POINTER [PD_GTKFORM])
		do
			a_form.item.children := create {CE_POINTER [SD_GLIST]}.make_shared (default_pointer)
			a_form.item.width := (1).to_natural_32
			a_form.item.height := (1).to_natural_32
			a_form.item.bin_window := create {CE_POINTER [SD_GDKDRAWABLE]}.make_shared (default_pointer)
			a_form.item.configure_serial := (0).to_natural_32
			a_form.item.visibility := {SC_GDKVISIBILITYSTATE}.GDK_VISIBILITY_PARTIAL
			a_form.item.freeze_count := 0
		end

	gtk_form_init_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gtk_form_init)
		end

	gtk_form_realize (a_widget: CE_POINTER [SD_GTKWIDGET])
		local
			l_tmp_list: CE_POINTER [SD_GLIST]
			l_form: CE_POINTER [PD_GTKFORM]
			l_attributes: SD_GDKWINDOWATTR
			l_attributes_mask: INTEGER_32
			l_inst: CE_POINTER [SD_GTYPEINSTANCE]
			l_t: NATURAL_32
			l_r: INTEGER_32
			l_tmp___3: CE_POINTER [SD_GTYPEINSTANCE]
			l_child: CE_POINTER [PD_GTKFORMCHILD]
			js: JUMP_STATE
		do
			create l_tmp_list.make
			create l_form.make
			create l_attributes.make
			create l_inst.make
			create l_tmp___3.make
			create l_child.make

			from
			until
				js.loop_left
			loop
				js.reset
				l_inst.ce_gets (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_widget))
				l_t := (gtk_form_get_type)
				if (l_inst).c_pointer = default_pointer then
					l_r := 0
				elseif ((l_inst.item.g_class).c_pointer /= default_pointer) then
					if (l_inst.item.g_class).item.g_type = l_t then
						l_r := 1
					else
						l_r := g_type_check_instance_is_a (l_inst, l_t)
					end
				else
					l_r := g_type_check_instance_is_a (l_inst, l_t)
				end
				if not l_r.to_boolean then
					g_return_if_fail_warning (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("gtk_form_realize"), ce_string ("GTK_IS_FORM(widget)"))
					js.return
				end
				if not js.return_called then
					js.break
				end
			end
			js.reset
			if not js.return_called then
				l_form.ce_gets (create {CE_POINTER [PD_GTKFORM]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_widget), (gtk_form_get_type)))))
				from
				until
					js.loop_left
				loop
					js.reset
					l_tmp___3.ce_gets (g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_form), (gtk_object_get_type)));
					(create {CE_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___3)).item.flags := ((create {CE_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___3)).item.flags).bit_or (({NATURAL_32} 64))
					js.break
				end
				js.reset
				l_attributes.window_type := {SC_GDKWINDOWTYPE}.GDK_WINDOW_CHILD
				l_attributes.x := a_widget.item.allocation.x
				l_attributes.y := a_widget.item.allocation.y
				l_attributes.width := a_widget.item.allocation.width
				l_attributes.height := a_widget.item.allocation.height
				l_attributes.wclass := {SC_GDKWINDOWCLASS}.GDK_INPUT_OUTPUT
				l_attributes.visual := gtk_widget_get_visual (a_widget)
				l_attributes.colormap := gtk_widget_get_colormap (a_widget)
				l_attributes.event_mask := 131072
				l_attributes_mask := 108
				a_widget.item.window := gdk_window_new ((gtk_widget_get_parent_window (a_widget)), l_attributes.address, l_attributes_mask)
				gdk_window_set_user_data (a_widget.item.window, create {CE_POINTER [ANY]}.make_cast (a_widget))
				l_attributes.x := 0
				l_attributes.y := 0
				l_attributes.event_mask := gtk_widget_get_events (a_widget)
				l_form.item.bin_window := gdk_window_new (a_widget.item.window, l_attributes.address, l_attributes_mask)
				gdk_window_set_user_data (l_form.item.bin_window, create {CE_POINTER [ANY]}.make_cast (a_widget))
				gtk_form_set_static_gravity (l_form.item.bin_window, 1)
				a_widget.item.style := gtk_style_attach (a_widget.item.style, a_widget.item.window)
				gtk_style_set_background (a_widget.item.style, a_widget.item.window, {SC_GTKSTATETYPE}.GTK_STATE_NORMAL)
				gtk_style_set_background (a_widget.item.style, l_form.item.bin_window, {SC_GTKSTATETYPE}.GTK_STATE_NORMAL)
				gdk_window_add_filter (a_widget.item.window, gtk_form_main_filter_address, create {CE_POINTER [ANY]}.make_cast (l_form))
				gdk_window_add_filter (l_form.item.bin_window, gtk_form_filter_address, create {CE_POINTER [ANY]}.make_cast (l_form))
				l_tmp_list.ce_gets (l_form.item.children)
				from
				until
					(l_tmp_list).c_pointer = default_pointer
				loop
					l_child.ce_gets (create {CE_POINTER [PD_GTKFORMCHILD]}.make_cast (l_tmp_list.item.data))
					gtk_form_attach_child_window (l_form, l_child)
					if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_child.item.widget), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 256)) /= {NATURAL_32} 0 then
						gtk_form_realize_child (l_form, l_child)
					end
					l_tmp_list.ce_gets (l_tmp_list.item.next)
				end
			end
		end

	gtk_form_realize_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gtk_form_realize)
		end

	gtk_form_map (a_widget: CE_POINTER [SD_GTKWIDGET])
		local
			l_tmp_list: CE_POINTER [SD_GLIST]
			l_form: CE_POINTER [PD_GTKFORM]
			l_inst: CE_POINTER [SD_GTYPEINSTANCE]
			l_t: NATURAL_32
			l_r: INTEGER_32
			l_tmp___3: CE_POINTER [SD_GTYPEINSTANCE]
			l_child: CE_POINTER [PD_GTKFORMCHILD]
			js: JUMP_STATE
		do
			create l_tmp_list.make
			create l_form.make
			create l_inst.make
			create l_tmp___3.make
			create l_child.make

			from
			until
				js.loop_left
			loop
				js.reset
				l_inst.ce_gets (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_widget))
				l_t := (gtk_form_get_type)
				if (l_inst).c_pointer = default_pointer then
					l_r := 0
				elseif ((l_inst.item.g_class).c_pointer /= default_pointer) then
					if (l_inst.item.g_class).item.g_type = l_t then
						l_r := 1
					else
						l_r := g_type_check_instance_is_a (l_inst, l_t)
					end
				else
					l_r := g_type_check_instance_is_a (l_inst, l_t)
				end
				if not l_r.to_boolean then
					g_return_if_fail_warning (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("gtk_form_map"), ce_string ("GTK_IS_FORM(widget)"))
					js.return
				end
				if not js.return_called then
					js.break
				end
			end
			js.reset
			if not js.return_called then
				l_form.ce_gets (create {CE_POINTER [PD_GTKFORM]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_widget), (gtk_form_get_type)))))
				from
				until
					js.loop_left
				loop
					js.reset
					l_tmp___3.ce_gets (g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_widget), (gtk_object_get_type)));
					(create {CE_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___3)).item.flags := ((create {CE_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___3)).item.flags).bit_or (({NATURAL_32} 128))
					js.break
				end
				js.reset
				gdk_window_show (a_widget.item.window)
				gdk_window_show (l_form.item.bin_window)
				l_tmp_list.ce_gets (l_form.item.children)
				from
				until
					(l_tmp_list).c_pointer = default_pointer
				loop
					l_child.ce_gets (create {CE_POINTER [PD_GTKFORMCHILD]}.make_cast (l_tmp_list.item.data))
					if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_child.item.widget), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 256)) /= {NATURAL_32} 0 then
						if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_child.item.widget), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 128)) = {NATURAL_32} 0 then
							gtk_widget_map (l_child.item.widget)
						end
					end
					l_tmp_list.ce_gets (l_tmp_list.item.next)
				end
			end
		end

	gtk_form_map_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gtk_form_map)
		end

	gtk_form_unrealize (a_widget: CE_POINTER [SD_GTKWIDGET])
		local
			l_tmp_list: CE_POINTER [SD_GLIST]
			l_form: CE_POINTER [PD_GTKFORM]
			l_inst: CE_POINTER [SD_GTYPEINSTANCE]
			l_t: NATURAL_32
			l_r: INTEGER_32
			l_child: CE_POINTER [PD_GTKFORMCHILD]
			js: JUMP_STATE
		do
			create l_tmp_list.make
			create l_form.make
			create l_inst.make
			create l_child.make

			from
			until
				js.loop_left
			loop
				js.reset
				l_inst.ce_gets (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_widget))
				l_t := (gtk_form_get_type)
				if (l_inst).c_pointer = default_pointer then
					l_r := 0
				elseif ((l_inst.item.g_class).c_pointer /= default_pointer) then
					if (l_inst.item.g_class).item.g_type = l_t then
						l_r := 1
					else
						l_r := g_type_check_instance_is_a (l_inst, l_t)
					end
				else
					l_r := g_type_check_instance_is_a (l_inst, l_t)
				end
				if not l_r.to_boolean then
					g_return_if_fail_warning (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("gtk_form_unrealize"), ce_string ("GTK_IS_FORM(widget)"))
					js.return
				end
				if not js.return_called then
					js.break
				end
			end
			js.reset
			if not js.return_called then
				l_form.ce_gets (create {CE_POINTER [PD_GTKFORM]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_widget), (gtk_form_get_type)))))
				l_tmp_list.ce_gets (l_form.item.children)
				gdk_window_set_user_data (l_form.item.bin_window, create {CE_POINTER [ANY]}.make_shared (default_pointer))
				gdk_window_destroy (l_form.item.bin_window)
				l_form.item.bin_window := create {CE_POINTER [SD_GDKDRAWABLE]}.make_shared (default_pointer)
				from
				until
					(l_tmp_list).c_pointer = default_pointer
				loop
					l_child.ce_gets (create {CE_POINTER [PD_GTKFORMCHILD]}.make_cast (l_tmp_list.item.data))
					if ((l_child.item.window).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						gtk_signal_compat_matched (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_child.item.widget), (gtk_object_get_type)))), (gtk_form_child_map_address), create {CE_POINTER [ANY]}.make_cast (l_child), 24, (0).to_natural_32)
						gtk_signal_compat_matched (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_child.item.widget), (gtk_object_get_type)))), (gtk_form_child_unmap_address), create {CE_POINTER [ANY]}.make_cast (l_child), 24, (0).to_natural_32)
						gdk_window_set_user_data (l_child.item.window, create {CE_POINTER [ANY]}.make_shared (default_pointer))
						gdk_window_destroy (l_child.item.window)
						l_child.item.window := create {CE_POINTER [SD_GDKDRAWABLE]}.make_shared (default_pointer)
					end
					l_tmp_list.ce_gets (l_tmp_list.item.next)
				end
				if (((create {CE_POINTER [SD_GTKWIDGETCLASS]}.make_cast ((g_type_check_class_cast (create {CE_POINTER [SD_GTYPECLASS]}.make_cast (parent_class), (gtk_widget_get_type))))).item.unrealize).c_pointer /= default_pointer) then
					((create {CE_POINTER [SD_GTKWIDGETCLASS]}.make_cast ((g_type_check_class_cast (create {CE_POINTER [SD_GTYPECLASS]}.make_cast (parent_class), (gtk_widget_get_type))))).item.unrealize).call ([a_widget])
				end
			end
		end

	gtk_form_unrealize_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gtk_form_unrealize)
		end

	gtk_form_size_request (a_widget: CE_POINTER [SD_GTKWIDGET]; a_requisition: CE_POINTER [SD_GTKREQUISITION])
		local
			l_tmp_list: CE_POINTER [SD_GLIST]
			l_form: CE_POINTER [PD_GTKFORM]
			l_inst: CE_POINTER [SD_GTYPEINSTANCE]
			l_t: NATURAL_32
			l_r: INTEGER_32
			l_child: CE_POINTER [PD_GTKFORMCHILD]
			js: JUMP_STATE
		do
			create l_tmp_list.make
			create l_form.make
			create l_inst.make
			create l_child.make

			from
			until
				js.loop_left
			loop
				js.reset
				l_inst.ce_gets (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_widget))
				l_t := (gtk_form_get_type)
				if (l_inst).c_pointer = default_pointer then
					l_r := 0
				elseif ((l_inst.item.g_class).c_pointer /= default_pointer) then
					if (l_inst.item.g_class).item.g_type = l_t then
						l_r := 1
					else
						l_r := g_type_check_instance_is_a (l_inst, l_t)
					end
				else
					l_r := g_type_check_instance_is_a (l_inst, l_t)
				end
				if not l_r.to_boolean then
					g_return_if_fail_warning (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("gtk_form_size_request"), ce_string ("GTK_IS_FORM(widget)"))
					js.return
				end
				if not js.return_called then
					js.break
				end
			end
			js.reset
			if not js.return_called then
				l_form.ce_gets (create {CE_POINTER [PD_GTKFORM]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_widget), (gtk_form_get_type)))))
				a_requisition.item.width := (l_form.item.width).to_integer_32
				a_requisition.item.height := (l_form.item.height).to_integer_32
				l_tmp_list.ce_gets (l_form.item.children)
				from
				until
					(l_tmp_list).c_pointer = default_pointer
				loop
					l_child.ce_gets (create {CE_POINTER [PD_GTKFORMCHILD]}.make_cast (l_tmp_list.item.data))
					gtk_widget_size_request (l_child.item.widget, create {CE_POINTER [SD_GTKREQUISITION]}.make_shared (default_pointer))
					l_tmp_list.ce_gets (l_tmp_list.item.next)
				end
			end
		end

	gtk_form_size_request_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gtk_form_size_request)
		end

	gtk_form_size_allocate (a_widget: CE_POINTER [SD_GTKWIDGET]; a_allocation: CE_POINTER [SD_GDKRECTANGLE])
		local
			l_tmp_list: CE_POINTER [SD_GLIST]
			l_form: CE_POINTER [PD_GTKFORM]
			l_need_reposition: INTEGER_32
			l_inst: CE_POINTER [SD_GTYPEINSTANCE]
			l_t: NATURAL_32
			l_r: INTEGER_32
			l_tmp___0: INTEGER_32
			l_child: CE_POINTER [PD_GTKFORMCHILD]
			js: JUMP_STATE
		do
			create l_tmp_list.make
			create l_form.make
			create l_inst.make
			create l_child.make

			from
			until
				js.loop_left
			loop
				js.reset
				l_inst.ce_gets (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_widget))
				l_t := (gtk_form_get_type)
				if (l_inst).c_pointer = default_pointer then
					l_r := 0
				elseif ((l_inst.item.g_class).c_pointer /= default_pointer) then
					if (l_inst.item.g_class).item.g_type = l_t then
						l_r := 1
					else
						l_r := g_type_check_instance_is_a (l_inst, l_t)
					end
				else
					l_r := g_type_check_instance_is_a (l_inst, l_t)
				end
				if not l_r.to_boolean then
					g_return_if_fail_warning (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("gtk_form_size_allocate"), ce_string ("GTK_IS_FORM(widget)"))
					js.return
				end
				if not js.return_called then
					js.break
				end
			end
			js.reset
			if not js.return_called and then (a_widget.item.allocation.x = a_allocation.item.x) then
				if a_widget.item.allocation.y = a_allocation.item.y then
					if a_widget.item.allocation.width = a_allocation.item.width then
						if a_widget.item.allocation.height = a_allocation.item.height then
							js.return
						end
					end
				end
			end
			if not js.return_called then
				if a_widget.item.allocation.width /= a_allocation.item.width then
					l_tmp___0 := 1
				elseif a_widget.item.allocation.height /= a_allocation.item.height then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
				l_need_reposition := l_tmp___0
				l_form.ce_gets (create {CE_POINTER [PD_GTKFORM]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_widget), (gtk_form_get_type)))))
				if l_need_reposition.to_boolean then
					l_tmp_list.ce_gets (l_form.item.children)
					from
					until
						(l_tmp_list).c_pointer = default_pointer
					loop
						l_child.ce_gets (create {CE_POINTER [PD_GTKFORMCHILD]}.make_cast (l_tmp_list.item.data))
						gtk_form_position_child (l_form, l_child, 1)
						l_tmp_list.ce_gets (l_tmp_list.item.next)
					end
				end
				if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_widget), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 64)) /= {NATURAL_32} 0 then
					gdk_window_move_resize (a_widget.item.window, a_allocation.item.x, a_allocation.item.y, a_allocation.item.width, a_allocation.item.height)
					gdk_window_move_resize ((create {CE_POINTER [PD_GTKFORM]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_widget), (gtk_form_get_type))))).item.bin_window, 0, 0, a_allocation.item.width, a_allocation.item.height)
				end
				a_widget.item.allocation := a_allocation.item
				if l_need_reposition.to_boolean then
					gtk_form_send_configure (l_form)
				end
			end
		end

	gtk_form_size_allocate_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gtk_form_size_allocate)
		end

	gtk_form_expose (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENTEXPOSE]): INTEGER_32
		local
			l_tmp_list: CE_POINTER [SD_GLIST]
			l_form: CE_POINTER [PD_GTKFORM]
			l_inst: CE_POINTER [SD_GTYPEINSTANCE]
			l_t: NATURAL_32
			l_r: INTEGER_32
			l_formchild: CE_POINTER [PD_GTKFORMCHILD]
			l_child: CE_POINTER [SD_GTKWIDGET]
			l_child_event: SD_GDKEVENTEXPOSE
			js: JUMP_STATE
		do
			create l_tmp_list.make
			create l_form.make
			create l_inst.make
			create l_formchild.make
			create l_child.make
			create l_child_event.make

			from
			until
				js.loop_left
			loop
				js.reset
				l_inst.ce_gets (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_widget))
				l_t := (gtk_form_get_type)
				if (l_inst).c_pointer = default_pointer then
					l_r := 0
				elseif ((l_inst.item.g_class).c_pointer /= default_pointer) then
					if (l_inst.item.g_class).item.g_type = l_t then
						l_r := 1
					else
						l_r := g_type_check_instance_is_a (l_inst, l_t)
					end
				else
					l_r := g_type_check_instance_is_a (l_inst, l_t)
				end
				if not l_r.to_boolean then
					g_return_if_fail_warning (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("gtk_form_expose"), ce_string ("GTK_IS_FORM(widget)"))
					Result := 0
					js.return
				end
				if not js.return_called then
					js.break
				end
			end
			js.reset
			if not js.return_called then
				l_form.ce_gets (create {CE_POINTER [PD_GTKFORM]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_widget), (gtk_form_get_type)))))
				if ((a_event.item.window).c_pointer.to_integer_32).to_natural_32 = ((l_form.item.bin_window).c_pointer.to_integer_32).to_natural_32 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_tmp_list.ce_gets (l_form.item.children)
				from
				until
					(l_tmp_list).c_pointer = default_pointer
				loop
					l_formchild.ce_gets (create {CE_POINTER [PD_GTKFORMCHILD]}.make_cast (l_tmp_list.item.data))
					l_child.ce_gets (l_formchild.item.widget)
					if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_child), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 256)) /= {NATURAL_32} 0 then
						if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_child), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 128)) /= {NATURAL_32} 0 then
							if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_child), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 32)) /= {NATURAL_32} 0 then
								if ((l_child.item.window).c_pointer.to_integer_32).to_natural_32 = ((a_event.item.window).c_pointer.to_integer_32).to_natural_32 then
									l_child_event.ce_gets (a_event.item)
									l_child_event.region := gtk_widget_region_intersect (l_child, a_event.item.region)
									if not (gdk_region_empty (l_child_event.region)).to_boolean then
										gdk_region_get_clipbox (l_child_event.region, create {CE_POINTER [SD_GDKRECTANGLE]}.make_shared (l_child_event.c_pointer + {SD_GDKEVENTEXPOSE}.area_offset))
										gtk_widget_send_expose (l_child, create {CE_POINTER [SD_GDKEVENT]}.make_cast ((l_child_event.address))).do_nothing
									end
								end
							end
						end
					end
					l_tmp_list.ce_gets (l_tmp_list.item.next)
				end
				Result := 0
			end
		end

	gtk_form_expose_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gtk_form_expose)
		end

	gtk_form_remove (a_container: CE_POINTER [SD_GTKCONTAINER]; a_widget: CE_POINTER [SD_GTKWIDGET])
		local
			l_tmp_list: CE_POINTER [SD_GLIST]
			l_form: CE_POINTER [PD_GTKFORM]
			l_child: CE_POINTER [PD_GTKFORMCHILD]
			l_inst: CE_POINTER [SD_GTYPEINSTANCE]
			l_t: NATURAL_32
			l_r: INTEGER_32
			js: JUMP_STATE
		do
			create l_tmp_list.make
			create l_form.make
			create l_child.make
			create l_inst.make

			l_child.ce_gets (create {CE_POINTER [PD_GTKFORMCHILD]}.make_shared (default_pointer))
			from
			until
				js.loop_left
			loop
				js.reset
				l_inst.ce_gets (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_container))
				l_t := (gtk_form_get_type)
				if (l_inst).c_pointer = default_pointer then
					l_r := 0
				elseif ((l_inst.item.g_class).c_pointer /= default_pointer) then
					if (l_inst.item.g_class).item.g_type = l_t then
						l_r := 1
					else
						l_r := g_type_check_instance_is_a (l_inst, l_t)
					end
				else
					l_r := g_type_check_instance_is_a (l_inst, l_t)
				end
				if not l_r.to_boolean then
					g_return_if_fail_warning (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("gtk_form_remove"), ce_string ("GTK_IS_FORM(container)"))
					js.return
				end
				if not js.return_called then
					js.break
				end
			end
			js.reset
			if not js.return_called then
				l_form.ce_gets (create {CE_POINTER [PD_GTKFORM]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_container), (gtk_form_get_type)))))
				l_tmp_list.ce_gets (l_form.item.children)
				from
				until
					not (not js.loop_left and then ((l_tmp_list).c_pointer /= default_pointer))
				loop
					js.reset
					l_child.ce_gets (create {CE_POINTER [PD_GTKFORMCHILD]}.make_cast (l_tmp_list.item.data))
					if ((l_child.item.widget).c_pointer.to_integer_32).to_natural_32 = (a_widget.c_pointer.to_integer_32).to_natural_32 then
						js.break
					end
					if not js.loop_jumped then
						l_tmp_list.ce_gets (l_tmp_list.item.next)
					end
				end
				js.reset
				if ((l_tmp_list).c_pointer /= default_pointer) then
					if ((l_child.item.window).c_pointer /= default_pointer) then
						gtk_signal_compat_matched (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_child.item.widget), (gtk_object_get_type)))), (gtk_form_child_map_address), create {CE_POINTER [ANY]}.make_cast (l_child), 24, (0).to_natural_32)
						gtk_signal_compat_matched (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_child.item.widget), (gtk_object_get_type)))), (gtk_form_child_unmap_address), create {CE_POINTER [ANY]}.make_cast (l_child), 24, (0).to_natural_32)
						gdk_window_set_user_data (l_child.item.window, create {CE_POINTER [ANY]}.make_shared (default_pointer))
						gdk_window_destroy (l_child.item.window)
					end
					gtk_widget_unparent (a_widget)
					l_form.item.children := g_list_remove_link (l_form.item.children, l_tmp_list)
					g_list_free_1 (l_tmp_list)
					g_free (create {CE_POINTER [ANY]}.make_cast (l_child))
				end
			end
		end

	gtk_form_remove_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gtk_form_remove)
		end

	gtk_form_forall (a_container: CE_POINTER [SD_GTKCONTAINER]; a_include_internals: INTEGER_32; a_callback: CE_ROUTINE; a_callback_data: CE_POINTER [ANY])
		local
			l_form: CE_POINTER [PD_GTKFORM]
			l_child: CE_POINTER [PD_GTKFORMCHILD]
			l_tmp_list: CE_POINTER [SD_GLIST]
			l_inst: CE_POINTER [SD_GTYPEINSTANCE]
			l_t: NATURAL_32
			l_r: INTEGER_32
			js: JUMP_STATE
		do
			create l_form.make
			create l_child.make
			create l_tmp_list.make
			create l_inst.make

			from
			until
				js.loop_left
			loop
				js.reset
				l_inst.ce_gets (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_container))
				l_t := (gtk_form_get_type)
				if (l_inst).c_pointer = default_pointer then
					l_r := 0
				elseif ((l_inst.item.g_class).c_pointer /= default_pointer) then
					if (l_inst.item.g_class).item.g_type = l_t then
						l_r := 1
					else
						l_r := g_type_check_instance_is_a (l_inst, l_t)
					end
				else
					l_r := g_type_check_instance_is_a (l_inst, l_t)
				end
				if not l_r.to_boolean then
					g_return_if_fail_warning (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("gtk_form_forall"), ce_string ("GTK_IS_FORM(container)"))
					js.return
				end
				if not js.return_called then
					js.break
				end
			end
			js.reset
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					if (a_callback.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						g_return_if_fail_warning (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("gtk_form_forall"), ce_string ("callback != NULL"))
						js.return
					end
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_form.ce_gets (create {CE_POINTER [PD_GTKFORM]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_container), (gtk_form_get_type)))))
				l_tmp_list.ce_gets (l_form.item.children)
				from
				until
					(l_tmp_list).c_pointer = default_pointer
				loop
					l_child.ce_gets (create {CE_POINTER [PD_GTKFORMCHILD]}.make_cast (l_tmp_list.item.data))
					l_tmp_list.ce_gets (l_tmp_list.item.next)
					a_callback.call ([l_child.item.widget, a_callback_data])
				end
			end
		end

	gtk_form_forall_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gtk_form_forall)
		end

	gtk_form_attach_child_window (a_form: CE_POINTER [PD_GTKFORM]; a_child: CE_POINTER [PD_GTKFORMCHILD])
		local
			l_widget: CE_POINTER [SD_GTKWIDGET]
			l_attributes: SD_GDKWINDOWATTR
			l_attributes_mask: INTEGER_32
			js: JUMP_STATE
		do
			create l_widget.make
			create l_attributes.make

			if ((a_child.item.window).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_child.item.widget), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 32)) /= {NATURAL_32} 0 then
					l_widget.ce_gets (create {CE_POINTER [SD_GTKWIDGET]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_form), (gtk_widget_get_type)))))
					l_attributes.window_type := {SC_GDKWINDOWTYPE}.GDK_WINDOW_CHILD
					l_attributes.x := a_child.item.x
					l_attributes.y := a_child.item.y
					l_attributes.width := (a_child.item.widget).item.requisition.width
					l_attributes.height := (a_child.item.widget).item.requisition.height
					l_attributes.wclass := {SC_GDKWINDOWCLASS}.GDK_INPUT_OUTPUT
					l_attributes.visual := gtk_widget_get_visual (l_widget)
					l_attributes.colormap := gtk_widget_get_colormap (l_widget)
					l_attributes.event_mask := 2
					l_attributes_mask := 108
					a_child.item.window := gdk_window_new (a_form.item.bin_window, l_attributes.address, l_attributes_mask)
					gdk_window_set_user_data (a_child.item.window, create {CE_POINTER [ANY]}.make_cast (l_widget))
					gtk_style_set_background (l_widget.item.style, a_child.item.window, {SC_GTKSTATETYPE}.GTK_STATE_NORMAL)
					gtk_widget_set_parent_window (a_child.item.widget, a_child.item.window)
					gtk_form_set_static_gravity (a_child.item.window, 1)
					gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_child.item.widget), (gtk_object_get_type)))), ce_string ("map"), (gtk_form_child_map_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_cast (a_child), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
					gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_child.item.widget), (gtk_object_get_type)))), ce_string ("unmap"), (gtk_form_child_unmap_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_cast (a_child), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
				elseif (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_child.item.widget), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 64)) = {NATURAL_32} 0 then
					gtk_widget_set_parent_window (a_child.item.widget, a_form.item.bin_window)
				end
			end
		end

	gtk_form_realize_child (a_form: CE_POINTER [PD_GTKFORM]; a_child: CE_POINTER [PD_GTKFORMCHILD])
		do
			gtk_form_attach_child_window (a_form, a_child)
			gtk_widget_realize (a_child.item.widget)
			if ((a_child.item.window).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				gtk_form_set_static_gravity ((a_child.item.widget).item.window, 1)
			end
		end

	gtk_form_position_child (a_form: CE_POINTER [PD_GTKFORM]; a_child: CE_POINTER [PD_GTKFORMCHILD]; a_force_allocate: INTEGER_32)
		local
			l_force_allocate: INTEGER_32
			l_x___0: INTEGER_32
			l_y: INTEGER_32
			l_allocation: SD_GDKRECTANGLE
			l_pos: INTEGER_32
		do
			create l_allocation.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_force_allocate := a_force_allocate
					l_x___0 := a_child.item.x
					l_y := a_child.item.y
					if not (l_x___0 >= -32768) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_x___0 <= 32767 then
							if l_y >= -32768 then
								if l_y <= 32767 then
									if not (a_child.item.mapped).to_boolean then
										if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_form), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 128)) /= {NATURAL_32} 0 then
											if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_child.item.widget), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 256)) /= {NATURAL_32} 0 then
												if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_child.item.widget), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 128)) = {NATURAL_32} 0 then
													gtk_widget_map (a_child.item.widget)
												end
												a_child.item.mapped := 1
												l_force_allocate := 1
											end
										end
									end
									if l_force_allocate.to_boolean then
										if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_child.item.widget), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 32)) /= {NATURAL_32} 0 then
											if ((a_child.item.window).c_pointer /= default_pointer) then
												gdk_window_move_resize (a_child.item.window, l_x___0, l_y, (a_child.item.widget).item.requisition.width, (a_child.item.widget).item.requisition.height)
											end
											l_allocation.x := 0
											l_allocation.y := 0
										else
											l_allocation.x := l_x___0
											l_allocation.y := l_y
										end
										l_allocation.width := (a_child.item.widget).item.requisition.width
										l_allocation.height := (a_child.item.widget).item.requisition.height
										gtk_widget_size_allocate (a_child.item.widget, l_allocation.address)
									end
								else
									l_pos := -1 + 3 -- goto _L___1
								end
							else
								l_pos := -1 + 3 -- goto _L___1
							end
						else
							l_pos := -1 + 3 -- goto _L___1
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L___1:
						if (a_child.item.mapped).to_boolean then
							a_child.item.mapped := 0
							if (((create {CE_POINTER [SD_GTKOBJECT]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_child.item.widget), (gtk_object_get_type))))).item.flags).bit_and ({NATURAL_32} 128)) /= {NATURAL_32} 0 then
								gtk_widget_unmap (a_child.item.widget)
							end
						end
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gtk_form_position_children (a_form: CE_POINTER [PD_GTKFORM])
		local
			l_tmp_list: CE_POINTER [SD_GLIST]
		do
			create l_tmp_list.make

			l_tmp_list.ce_gets (a_form.item.children)
			from
			until
				(l_tmp_list).c_pointer = default_pointer
			loop
				gtk_form_position_child (a_form, create {CE_POINTER [PD_GTKFORMCHILD]}.make_cast (l_tmp_list.item.data), 0)
				l_tmp_list.ce_gets (l_tmp_list.item.next)
			end
		end

	gtk_form_filter (a_gdk_xevent: CE_POINTER [ANY]; a_event: CE_POINTER [SD_GDKEVENT]; a_data: CE_POINTER [ANY]): INTEGER_32
		local
			l_xevent: CE_POINTER [SD_XEVENT]
			l_form: CE_POINTER [PD_GTKFORM]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_xevent.make
			create l_form.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_xevent.ce_gets (create {CE_POINTER [SD_XEVENT]}.make_cast (a_gdk_xevent))
					l_form.ce_gets (create {CE_POINTER [PD_GTKFORM]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_data), (gtk_form_get_type)))))
					inspect l_xevent.item.type -- switch 1 head
					when 12 then l_pos := -1 + 1
					when 22 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 12
					if l_xevent.item.xexpose.serial = l_form.item.configure_serial then
						if (l_form.item.visibility).to_natural_32 = {NATURAL_32} 0 then
							Result := ({SC_GDKFILTERRETURN}.GDK_FILTER_REMOVE)
							js.return
						else
							l_pos := -1 + 4 -- switch 1; break
						end
					end
				when 2 then
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, case 22
					if l_xevent.item.xconfigure.x /= 0 then
						l_form.item.configure_serial := l_xevent.item.xconfigure.serial
					elseif l_xevent.item.xconfigure.y /= 0 then
						l_form.item.configure_serial := l_xevent.item.xconfigure.serial
					end
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					if not js.return_called then
						Result := ({SC_GDKFILTERRETURN}.GDK_FILTER_CONTINUE)
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gtk_form_filter_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gtk_form_filter)
		end

	gtk_form_main_filter (a_gdk_xevent: CE_POINTER [ANY]; a_event: CE_POINTER [SD_GDKEVENT]; a_data: CE_POINTER [ANY]): INTEGER_32
		local
			l_xevent: CE_POINTER [SD_XEVENT]
			l_form: CE_POINTER [PD_GTKFORM]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_xevent.make
			create l_form.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_xevent.ce_gets (create {CE_POINTER [SD_XEVENT]}.make_cast (a_gdk_xevent))
					l_form.ce_gets (create {CE_POINTER [PD_GTKFORM]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_data), (gtk_form_get_type)))))
					if l_xevent.item.type /= 15 then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						inspect l_xevent.item.xvisibility.state -- switch 1 head
						when 2 then l_pos := -1 + 2
						when 1 then l_pos := -1 + 3
						when 0 then l_pos := -1 + 4
						else l_pos := -1 + 5
						end
				when 2 then -- switch 1, case 2
						l_form.item.visibility := {SC_GDKVISIBILITYSTATE}.GDK_VISIBILITY_FULLY_OBSCURED
						l_pos := -1 + 5 -- switch 1; break
				when 3 then -- switch 1, case 1
						l_form.item.visibility := {SC_GDKVISIBILITYSTATE}.GDK_VISIBILITY_PARTIAL
						l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, case 0
						l_form.item.visibility := {SC_GDKVISIBILITYSTATE}.GDK_VISIBILITY_UNOBSCURED
						l_pos := -1 + 5 -- switch 1; break
				when 5 then -- switch 1, done:
						Result := ({SC_GDKFILTERRETURN}.GDK_FILTER_REMOVE)
						js.return
				when 6 then -- if done
					if not js.return_called then
						Result := ({SC_GDKFILTERRETURN}.GDK_FILTER_CONTINUE)
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gtk_form_main_filter_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gtk_form_main_filter)
		end

	gtk_form_set_static_gravity (a_window: CE_POINTER [SD_GDKDRAWABLE]; a_use_static: INTEGER_32)
		do
			gdk_window_set_static_gravities (a_window, a_use_static).do_nothing
		end

	gtk_form_move_resize (a_form: CE_POINTER [PD_GTKFORM]; a_widget: CE_POINTER [SD_GTKWIDGET]; a_x___0: INTEGER_32; a_y: INTEGER_32; a_w: INTEGER_32; a_h: INTEGER_32)
		do
			a_widget.item.requisition.width := a_w
			a_widget.item.requisition.height := a_h
			gtk_form_move (a_form, a_widget, a_x___0, a_y)
		end

	gtk_form_send_configure (a_form: CE_POINTER [PD_GTKFORM])
		local
			l_widget: CE_POINTER [SD_GTKWIDGET]
			l_event: SD_GDKEVENTCONFIGURE
		do
			create l_widget.make
			create l_event.make

			l_widget.ce_gets (create {CE_POINTER [SD_GTKWIDGET]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_form), (gtk_widget_get_type)))))
			l_event.type := {SC_GDKEVENTTYPE}.GDK_CONFIGURE
			l_event.window := l_widget.item.window
			l_event.x := l_widget.item.allocation.x
			l_event.y := l_widget.item.allocation.y
			l_event.width := l_widget.item.allocation.width
			l_event.height := l_widget.item.allocation.height
			gtk_main_do_event (create {CE_POINTER [SD_GDKEVENT]}.make_cast ((l_event.address)))
		end

	gtk_form_child_map (a_widget: CE_POINTER [SD_GTKWIDGET]; a_user_data: CE_POINTER [ANY])
		local
			l_child: CE_POINTER [PD_GTKFORMCHILD]
		do
			create l_child.make

			l_child.ce_gets (create {CE_POINTER [PD_GTKFORMCHILD]}.make_cast (a_user_data))
			l_child.item.mapped := 1
			gdk_window_show (l_child.item.window)
		end

	gtk_form_child_map_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gtk_form_child_map)
		end

	gtk_form_child_unmap (a_widget: CE_POINTER [SD_GTKWIDGET]; a_user_data: CE_POINTER [ANY])
		local
			l_child: CE_POINTER [PD_GTKFORMCHILD]
		do
			create l_child.make

			l_child.ce_gets (create {CE_POINTER [PD_GTKFORMCHILD]}.make_cast (a_user_data))
			l_child.item.mapped := 0
			gdk_window_hide (l_child.item.window)
		end

	gtk_form_child_unmap_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gtk_form_child_unmap)
		end

end
