class
	P_MEMFILE

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
		end

feature {ANY} -- attributes

	total_mem_used: NATURAL_32 assign set_total_mem_used

	set_total_mem_used (a_total_mem_used: NATURAL_32)
		do
			total_mem_used := a_total_mem_used
		end

feature {ANY} -- routines

	mf_open (a_fname: CE_POINTER [NATURAL_8]; a_flags___0: INTEGER_32): CE_POINTER [PD_MEMFILE]
		local
			l_mfp: CE_POINTER [PD_MEMFILE]
			l_i___0: INTEGER_32
			l_size: INTEGER_32
			l_stf: SD_STAT
			l_shift: INTEGER_32
			l_page_size: NATURAL_32
			js: JUMP_STATE
		do
			create l_mfp.make
			create l_stf.make

			l_mfp.ce_gets (create {CE_POINTER [PD_MEMFILE]}.make_cast ((misc2_inst.alloc ({PD_MEMFILE}.sizeof.to_natural_32))))
			if (l_mfp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := (create {CE_POINTER [PD_MEMFILE]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				if (a_fname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					l_mfp.item.mf_fname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_mfp.item.mf_ffname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_mfp.item.mf_fd := -1
				else
					mf_do_open (l_mfp, a_fname, a_flags___0)
					if l_mfp.item.mf_fd < 0 then
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_mfp))
						Result := (create {CE_POINTER [PD_MEMFILE]}.make_shared (default_pointer))
						js.return
					end
				end
			end
			if not js.return_called then
				l_mfp.item.mf_free_first := create {CE_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer)
				l_mfp.item.mf_used_first := create {CE_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer)
				l_mfp.item.mf_used_last := create {CE_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer)
				l_mfp.item.mf_dirty := 0
				l_mfp.item.mf_used_count := {NATURAL_32} 0
				l_i___0 := 0
				from
				until
					not (l_i___0 < 64)
				loop
					l_mfp.item.mf_hash[l_i___0] := create {CE_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer)
					l_mfp.item.mf_trans[l_i___0] := create {CE_POINTER [PD_NR_TRANS]}.make_shared (default_pointer)
					l_i___0 := l_i___0 + 1
				end
				l_mfp.item.mf_page_size := {NATURAL_32} 4096
				l_mfp.item.mf_old_key := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				if l_mfp.item.mf_fd >= 0 then
					if (fstat (l_mfp.item.mf_fd, l_stf.address)) = 0 then
						if l_stf.st_blksize >= 1048 then
							if l_stf.st_blksize <= 50000 then
								l_mfp.item.mf_page_size := (l_stf.st_blksize).to_natural_32
							end
						end
					end
				end
				if l_mfp.item.mf_fd < 0 then
					l_mfp.item.mf_blocknr_max := (0).to_integer_32
				elseif ((a_flags___0).bit_and (640)).to_boolean then
					l_mfp.item.mf_blocknr_max := (0).to_integer_32
				else
					l_size := lseek (l_mfp.item.mf_fd, 0, 2)
					if l_size <= 0 then
						l_mfp.item.mf_blocknr_max := (0).to_integer_32
					else
						l_mfp.item.mf_blocknr_max := (((l_size.to_natural_32 + (l_mfp.item.mf_page_size).to_natural_32) - {NATURAL_32} 1) // (l_mfp.item.mf_page_size).to_natural_32).to_integer_32
					end
				end
				l_mfp.item.mf_blocknr_min := (-1).to_integer_32
				l_mfp.item.mf_neg_count := (0).to_integer_32
				l_mfp.item.mf_infile_count := l_mfp.item.mf_blocknr_max
				l_shift := 10
				l_page_size := l_mfp.item.mf_page_size
				from
				until
					js.loop_left
				loop
					js.reset
					if l_shift > 0 then
						if ((l_page_size).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_page_size := (l_page_size).bit_shift_right ((1))
						l_shift := l_shift - 1
					end
				end
				js.reset
				l_mfp.item.mf_used_count_max := (((option_inst.p_mm).bit_shift_left (l_shift)).to_natural_32 // l_page_size.to_natural_32).to_natural_32
				if l_mfp.item.mf_used_count_max < {NATURAL_32} 10 then
					l_mfp.item.mf_used_count_max := {NATURAL_32} 10
				end
				Result := l_mfp
			end
		end

	mf_open_file (a_mfp: CE_POINTER [PD_MEMFILE]; a_fname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			js: JUMP_STATE
		do
			mf_do_open (a_mfp, a_fname, 194)
			if a_mfp.item.mf_fd < 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				a_mfp.item.mf_dirty := 1
				Result := 1
			end
		end

	mf_close (a_mfp: CE_POINTER [PD_MEMFILE]; a_del_file: INTEGER_32)
		local
			l_hp: CE_POINTER [PD_BLOCK_HDR]
			l_nextp: CE_POINTER [PD_BLOCK_HDR]
			l_tp: CE_POINTER [PD_NR_TRANS]
			l_tpnext: CE_POINTER [PD_NR_TRANS]
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_hp.make
			create l_nextp.make
			create l_tp.make
			create l_tpnext.make

			if (a_mfp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				if a_mfp.item.mf_fd >= 0 then
					if (close (a_mfp.item.mf_fd)) < 0 then
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_swapclose))))).do_nothing
					end
				end
				if a_del_file.to_boolean then
					if ((a_mfp.item.mf_fname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						unlink (create {CE_POINTER [INTEGER_8]}.make_cast (a_mfp.item.mf_fname)).do_nothing
					end
				end
				l_hp.ce_gets (a_mfp.item.mf_used_first)
				from
				until
					(l_hp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
				loop
					total_mem_used := total_mem_used - ((l_hp.item.bh_page_count).to_natural_32 * a_mfp.item.mf_page_size).to_natural_32
					l_nextp.ce_gets (l_hp.item.bh_next)
					mf_free_bhdr (l_hp)
					l_hp.ce_gets (l_nextp)
				end
				from
				until
					((a_mfp.item.mf_free_first).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
				loop
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((mf_rem_free (a_mfp))))
				end
				l_i___0 := 0
				from
				until
					not (not js.loop_left and then (l_i___0 < 64))
				loop
					l_tp.ce_gets (a_mfp.item.mf_trans[l_i___0])
					from
					until
						(l_tp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
					loop
						l_tpnext.ce_gets (l_tp.item.nt_next)
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tp))
						l_tp.ce_gets (l_tpnext)
					end
					l_i___0 := l_i___0 + 1
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_mfp.item.mf_fname))
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_mfp.item.mf_ffname))
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_mfp))
			end
		end

	mf_close_file (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_getlines: INTEGER_32)
		local
			l_mfp: CE_POINTER [PD_MEMFILE]
			l_lnum: INTEGER_32
			js: JUMP_STATE
		do
			create l_mfp.make

			l_mfp.ce_gets (a_buf___6.item.b_ml.ml_mfp)
			if (l_mfp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			elseif l_mfp.item.mf_fd < 0 then
				js.return
			end
			if not js.return_called then
				if a_getlines.to_boolean then
					globals_inst.mf_dont_release := 1
					l_lnum := (1).to_integer_32
					from
					until
						not (l_lnum <= a_buf___6.item.b_ml.ml_line_count)
					loop
						memline_inst.ml_get_buf (a_buf___6, l_lnum, 0).do_nothing
						l_lnum := l_lnum + 1
					end
					globals_inst.mf_dont_release := 0
				end
				if (close (l_mfp.item.mf_fd)) < 0 then
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_swapclose))))).do_nothing
				end
				l_mfp.item.mf_fd := -1
				if ((l_mfp.item.mf_fname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					unlink (create {CE_POINTER [INTEGER_8]}.make_cast (l_mfp.item.mf_fname)).do_nothing
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_mfp.item.mf_fname))
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_mfp.item.mf_ffname))
					l_mfp.item.mf_fname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_mfp.item.mf_ffname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				end
			end
		end

	mf_new_page_size (a_mfp: CE_POINTER [PD_MEMFILE]; a_new_size: NATURAL_32)
		do
			total_mem_used := total_mem_used + (a_new_size - a_mfp.item.mf_page_size).to_natural_32
			a_mfp.item.mf_page_size := a_new_size
		end

	mf_new (a_mfp: CE_POINTER [PD_MEMFILE]; a_negative: INTEGER_32; a_page_count___0: INTEGER_32): CE_POINTER [PD_BLOCK_HDR]
		local
			l_hp: CE_POINTER [PD_BLOCK_HDR]
			l_freep: CE_POINTER [PD_BLOCK_HDR]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_hp.make
			create l_freep.make
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_hp.ce_gets (mf_release (a_mfp, a_page_count___0))
					l_freep.ce_gets (a_mfp.item.mf_free_first)
					if a_negative.to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (l_freep.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							if l_freep.item.bh_page_count >= a_page_count___0 then
								if l_freep.item.bh_page_count > a_page_count___0 then
									if (l_hp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										l_hp.ce_gets (mf_alloc_bhdr (a_mfp, a_page_count___0))
										if (l_hp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
											Result := (create {CE_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
											js.return
										end
									end
									if not js.return_called then
										l_hp.item.bh_bnum := l_freep.item.bh_bnum
										l_freep.item.bh_bnum := l_freep.item.bh_bnum + a_page_count___0.to_integer_32
										l_freep.item.bh_page_count := l_freep.item.bh_page_count - a_page_count___0
									end
								elseif (l_hp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_p___0.ce_gets ((misc2_inst.alloc (a_mfp.item.mf_page_size * a_page_count___0.to_natural_32)))
									if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
										Result := (create {CE_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
										js.return
									end
									if not js.return_called then
										l_hp.ce_gets (mf_rem_free (a_mfp))
										l_hp.item.bh_data := l_p___0
									end
								else
									l_freep.ce_gets (mf_rem_free (a_mfp))
									l_hp.item.bh_bnum := l_freep.item.bh_bnum
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_freep))
								end
							else
								l_pos := -1 + 3 -- goto _L___0
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L___0:
						if (l_hp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_hp.ce_gets (mf_alloc_bhdr (a_mfp, a_page_count___0))
							if (l_hp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								Result := (create {CE_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
								js.return
							end
						end
						if not js.return_called then
							if a_negative.to_boolean then
								l_tmp___0 := a_mfp.item.mf_blocknr_min
								a_mfp.item.mf_blocknr_min := (a_mfp.item.mf_blocknr_min) - 1
								l_hp.item.bh_bnum := l_tmp___0
								a_mfp.item.mf_neg_count := (a_mfp.item.mf_neg_count) + 1
							else
								l_hp.item.bh_bnum := a_mfp.item.mf_blocknr_max
								a_mfp.item.mf_blocknr_max := a_mfp.item.mf_blocknr_max + a_page_count___0.to_integer_32
							end
						end
				when 4 then
					if not js.return_called then
						l_hp.item.bh_flags := (3).to_integer_8
						a_mfp.item.mf_dirty := 1
						l_hp.item.bh_page_count := a_page_count___0
						mf_ins_used (a_mfp, l_hp)
						mf_ins_hash (a_mfp, l_hp)
						memset (create {CE_POINTER [ANY]}.make_cast (l_hp.item.bh_data), 0, a_mfp.item.mf_page_size * a_page_count___0.to_natural_32).do_nothing
						Result := l_hp
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mf_get (a_mfp: CE_POINTER [PD_MEMFILE]; a_nr: INTEGER_32; a_page_count___0: INTEGER_32): CE_POINTER [PD_BLOCK_HDR]
		local
			l_hp: CE_POINTER [PD_BLOCK_HDR]
			js: JUMP_STATE
		do
			create l_hp.make

			if a_nr >= a_mfp.item.mf_blocknr_max then
				Result := (create {CE_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
				js.return
			elseif a_nr <= a_mfp.item.mf_blocknr_min then
				Result := (create {CE_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_hp.ce_gets (mf_find_hash (a_mfp, a_nr))
				if (l_hp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					if a_nr < 0 then
						Result := (create {CE_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
						js.return
					elseif a_nr >= a_mfp.item.mf_infile_count then
						Result := (create {CE_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						l_hp.ce_gets (mf_release (a_mfp, a_page_count___0))
						if (l_hp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_hp.ce_gets (mf_alloc_bhdr (a_mfp, a_page_count___0))
							if (l_hp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								Result := (create {CE_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
								js.return
							end
						end
					end
					if not js.return_called then
						l_hp.item.bh_bnum := a_nr
						l_hp.item.bh_flags := (0).to_integer_8
						l_hp.item.bh_page_count := a_page_count___0
						if (mf_read (a_mfp, l_hp)) = 0 then
							mf_free_bhdr (l_hp)
							Result := (create {CE_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
							js.return
						end
					end
				else
					mf_rem_used (a_mfp, l_hp)
					mf_rem_hash (a_mfp, l_hp)
				end
			end
			if not js.return_called then
				l_hp.item.bh_flags := (((l_hp.item.bh_flags).to_integer_32).bit_or (2)).to_integer_8
				mf_ins_used (a_mfp, l_hp)
				mf_ins_hash (a_mfp, l_hp)
				Result := l_hp
			end
		end

	mf_put (a_mfp: CE_POINTER [PD_MEMFILE]; a_hp: CE_POINTER [PD_BLOCK_HDR]; a_dirty: INTEGER_32; a_infile: INTEGER_32)
		local
			l_flags___0: INTEGER_32
		do
			l_flags___0 := (a_hp.item.bh_flags).to_integer_32
			if ((l_flags___0).bit_and (2)) = 0 then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E293: block was not locked"))))).do_nothing
			end
			l_flags___0 := (l_flags___0).bit_and ((-3))
			if a_dirty.to_boolean then
				l_flags___0 := (l_flags___0).bit_or ((1))
				a_mfp.item.mf_dirty := 1
			end
			a_hp.item.bh_flags := l_flags___0.to_integer_8
			if a_infile.to_boolean then
				mf_trans_add (a_mfp, a_hp).do_nothing
			end
		end

	mf_free (a_mfp: CE_POINTER [PD_MEMFILE]; a_hp: CE_POINTER [PD_BLOCK_HDR])
		do
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_hp.item.bh_data))
			mf_rem_hash (a_mfp, a_hp)
			mf_rem_used (a_mfp, a_hp)
			if a_hp.item.bh_bnum < 0 then
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_hp))
				a_mfp.item.mf_neg_count := (a_mfp.item.mf_neg_count) - 1
			else
				mf_ins_free (a_mfp, a_hp)
			end
		end

	mf_sync (a_mfp: CE_POINTER [PD_MEMFILE]; a_flags___0: INTEGER_32): INTEGER_32
		local
			l_status: INTEGER_32
			l_hp: CE_POINTER [PD_BLOCK_HDR]
			l_got_int_save: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_hp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_got_int_save := globals_inst.got_int
					if a_mfp.item.mf_fd < 0 then
						a_mfp.item.mf_dirty := 0
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:
						globals_inst.got_int := 0
						l_status := 1
						l_hp.ce_gets (a_mfp.item.mf_used_last)
				when 2 then -- loop condition:
						if not (not js.loop_left and then ((l_hp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32)) then
							l_pos := -1 + 15 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if not (((a_flags___0).bit_and (1)).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 6 then -- else:
						if not (l_hp.item.bh_bnum >= 0) then
							l_pos := -1 + 14 -- skip if block
						end
				when 7 then -- if: | _L___0:
						if not ((((l_hp.item.bh_flags).to_integer_32).bit_and (1)).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 8 then -- if:
						if l_status /= 1 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 11 then -- else:
						if not (l_hp.item.bh_bnum >= 0) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if not (l_hp.item.bh_bnum < a_mfp.item.mf_infile_count) then
							l_pos := -1 + 14 -- skip if block
						end
				when 13 then -- if: | _L:
						if ((a_flags___0).bit_and (8)).to_boolean then
							if l_hp.item.bh_bnum /= 0 then
								js.continue
							end
						end
						if not js.loop_jumped then
							if (mf_write (a_mfp, l_hp)) = 0 then
								if l_status = 0 then
									js.break
								end
								if not js.loop_jumped then
									l_status := 0
								end
							end
						end
						if not js.loop_jumped then
							if ((a_flags___0).bit_and (2)).to_boolean then
								if (ui_inst.ui_char_avail).to_boolean then
									js.break
								end
							else
								ui_inst.ui_breakcheck
							end
						end
						if not js.loop_jumped and then (globals_inst.got_int.to_boolean) then
							js.break
						end
				when 14 then -- if done | if done | if done | if done | if done
						if not js.loop_left then
							l_hp.ce_gets (l_hp.item.bh_prev)
						end
						l_pos := -1 + 2 -- back to loop condition
				when 15 then -- loop done
						js.reset
						if (l_hp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							a_mfp.item.mf_dirty := 0
						elseif l_status = 0 then
							a_mfp.item.mf_dirty := 0
						end
						if ((a_flags___0).bit_and (4)).to_boolean then
							if (option_inst.p_sws.item).to_integer_32 /= 0 then
								if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (option_inst.p_sws), ce_string ("fsync"))) = 0 then
									if (fsync (a_mfp.item.mf_fd)).to_boolean then
										l_status := 0
									end
								else
									sync
								end
							end
						end
						globals_inst.got_int := (globals_inst.got_int).bit_or (l_got_int_save)
						Result := l_status
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mf_set_dirty (a_mfp: CE_POINTER [PD_MEMFILE])
		local
			l_hp: CE_POINTER [PD_BLOCK_HDR]
		do
			create l_hp.make

			l_hp.ce_gets (a_mfp.item.mf_used_last)
			from
			until
				(l_hp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
			loop
				if l_hp.item.bh_bnum > 0 then
					l_hp.item.bh_flags := (((l_hp.item.bh_flags).to_integer_32).bit_or (1)).to_integer_8
				end
				l_hp.ce_gets (l_hp.item.bh_prev)
			end
			a_mfp.item.mf_dirty := 1
		end

	mf_ins_hash (a_mfp: CE_POINTER [PD_MEMFILE]; a_hp: CE_POINTER [PD_BLOCK_HDR])
		local
			l_hhp: CE_POINTER [PD_BLOCK_HDR]
			l_hash: INTEGER_32
		do
			create l_hhp.make

			l_hash := ((a_hp.item.bh_bnum).bit_and (63)).to_integer_32
			l_hhp.ce_gets (a_mfp.item.mf_hash[l_hash])
			a_hp.item.bh_hash_next := l_hhp
			a_hp.item.bh_hash_prev := create {CE_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer)
			if (l_hhp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_hhp.item.bh_hash_prev := a_hp
			end
			a_mfp.item.mf_hash[l_hash] := a_hp
		end

	mf_rem_hash (a_mfp: CE_POINTER [PD_MEMFILE]; a_hp: CE_POINTER [PD_BLOCK_HDR])
		do
			if ((a_hp.item.bh_hash_prev).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				a_mfp.item.mf_hash[(a_hp.item.bh_bnum).bit_and (63)] := a_hp.item.bh_hash_next
			else
				(a_hp.item.bh_hash_prev).item.bh_hash_next := a_hp.item.bh_hash_next
			end
			if ((a_hp.item.bh_hash_next).c_pointer /= default_pointer) then
				(a_hp.item.bh_hash_next).item.bh_hash_prev := a_hp.item.bh_hash_prev
			end
		end

	mf_find_hash (a_mfp: CE_POINTER [PD_MEMFILE]; a_nr: INTEGER_32): CE_POINTER [PD_BLOCK_HDR]
		local
			l_hp: CE_POINTER [PD_BLOCK_HDR]
			js: JUMP_STATE
		do
			create l_hp.make

			l_hp.ce_gets (a_mfp.item.mf_hash[(a_nr).bit_and (63)])
			from
			until
				not (not js.loop_left and then ((l_hp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
			loop
				js.reset
				if l_hp.item.bh_bnum = a_nr then
					js.break
				end
				if not js.loop_jumped then
					l_hp.ce_gets (l_hp.item.bh_hash_next)
				end
			end
			js.reset
			Result := l_hp
		end

	mf_ins_used (a_mfp: CE_POINTER [PD_MEMFILE]; a_hp: CE_POINTER [PD_BLOCK_HDR])
		do
			a_hp.item.bh_next := a_mfp.item.mf_used_first
			a_mfp.item.mf_used_first := a_hp
			a_hp.item.bh_prev := create {CE_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer)
			if ((a_hp.item.bh_next).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				a_mfp.item.mf_used_last := a_hp
			else
				(a_hp.item.bh_next).item.bh_prev := a_hp
			end
			a_mfp.item.mf_used_count := a_mfp.item.mf_used_count + (a_hp.item.bh_page_count).to_natural_32
			total_mem_used := total_mem_used + ((a_hp.item.bh_page_count).to_natural_32 * a_mfp.item.mf_page_size).to_natural_32
		end

	mf_rem_used (a_mfp: CE_POINTER [PD_MEMFILE]; a_hp: CE_POINTER [PD_BLOCK_HDR])
		do
			if ((a_hp.item.bh_next).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				a_mfp.item.mf_used_last := a_hp.item.bh_prev
			else
				(a_hp.item.bh_next).item.bh_prev := a_hp.item.bh_prev
			end
			if ((a_hp.item.bh_prev).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				a_mfp.item.mf_used_first := a_hp.item.bh_next
			else
				(a_hp.item.bh_prev).item.bh_next := a_hp.item.bh_next
			end
			a_mfp.item.mf_used_count := a_mfp.item.mf_used_count - (a_hp.item.bh_page_count).to_natural_32
			total_mem_used := total_mem_used - ((a_hp.item.bh_page_count).to_natural_32 * a_mfp.item.mf_page_size).to_natural_32
		end

	mf_release (a_mfp: CE_POINTER [PD_MEMFILE]; a_page_count___0: INTEGER_32): CE_POINTER [PD_BLOCK_HDR]
		local
			l_hp: CE_POINTER [PD_BLOCK_HDR]
			l_need_release: INTEGER_32
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_tmp: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_hp.make
			create l_buf___6.make
			create l_tmp___1.make

			if globals_inst.mf_dont_release.to_boolean then
				Result := (create {CE_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				if a_mfp.item.mf_used_count >= a_mfp.item.mf_used_count_max then
					l_tmp := 1
				elseif (total_mem_used).bit_shift_right (10) >= option_inst.p_mmt.to_natural_32 then
					l_tmp := 1
				else
					l_tmp := 0
				end
				l_need_release := l_tmp
				if a_mfp.item.mf_fd < 0 then
					if l_need_release.to_boolean then
						if option_inst.p_uc.to_boolean then
							l_buf___6.ce_gets (globals_inst.firstbuf)
							from
							until
								not (not js.loop_left and then ((l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
							loop
								js.reset
								if ((l_buf___6.item.b_ml.ml_mfp).c_pointer.to_integer_32).to_natural_32 = (a_mfp.c_pointer.to_integer_32).to_natural_32 then
									js.break
								end
								if not js.loop_jumped then
									l_buf___6.ce_gets (l_buf___6.item.b_next)
								end
							end
							js.reset
							if (l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if (l_buf___6.item.b_may_swap).to_boolean then
									memline_inst.ml_open_file (l_buf___6)
								end
							end
						end
					end
				end
				if a_mfp.item.mf_fd < 0 then
					Result := (create {CE_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
					js.return
				elseif not l_need_release.to_boolean then
					Result := (create {CE_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				l_hp.ce_gets (a_mfp.item.mf_used_last)
				from
				until
					not (not js.loop_left and then ((l_hp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
				loop
					js.reset
					if not (((l_hp.item.bh_flags).to_integer_32).bit_and (2)).to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_hp.ce_gets (l_hp.item.bh_prev)
					end
				end
				js.reset
				if (l_hp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					Result := (create {CE_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called and then ((((l_hp.item.bh_flags).to_integer_32).bit_and (1)).to_boolean) then
				if (mf_write (a_mfp, l_hp)) = 0 then
					Result := (create {CE_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				mf_rem_used (a_mfp, l_hp)
				mf_rem_hash (a_mfp, l_hp)
				if l_hp.item.bh_page_count /= a_page_count___0 then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_hp.item.bh_data))
					l_tmp___1.ce_gets (misc2_inst.alloc (a_mfp.item.mf_page_size * a_page_count___0.to_natural_32))
					l_hp.item.bh_data := l_tmp___1
					if (l_tmp___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_hp))
						Result := (create {CE_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						l_hp.item.bh_page_count := a_page_count___0
					end
				end
			end
			if not js.return_called then
				Result := l_hp
			end
		end

	mf_release_all: INTEGER_32
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_mfp: CE_POINTER [PD_MEMFILE]
			l_hp: CE_POINTER [PD_BLOCK_HDR]
			l_retval: INTEGER_32
			js: JUMP_STATE
		do
			create l_buf___6.make
			create l_mfp.make
			create l_hp.make

			l_retval := 0
			l_buf___6.ce_gets (globals_inst.firstbuf)
			from
			until
				not (not js.loop_left and then ((l_buf___6.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
			loop
				l_mfp.ce_gets (l_buf___6.item.b_ml.ml_mfp)
				if (l_mfp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if l_mfp.item.mf_fd < 0 then
						if (l_buf___6.item.b_may_swap).to_boolean then
							memline_inst.ml_open_file (l_buf___6)
						end
					end
					if l_mfp.item.mf_fd >= 0 then
						l_hp.ce_gets (l_mfp.item.mf_used_last)
						from
						until
							(l_hp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
						loop
							if not (((l_hp.item.bh_flags).to_integer_32).bit_and (2)).to_boolean then
								if not (((l_hp.item.bh_flags).to_integer_32).bit_and (1)).to_boolean then
									mf_rem_used (l_mfp, l_hp)
									mf_rem_hash (l_mfp, l_hp)
									mf_free_bhdr (l_hp)
									l_hp.ce_gets (l_mfp.item.mf_used_last)
									l_retval := 1
								elseif (mf_write (l_mfp, l_hp)) /= 0 then
									mf_rem_used (l_mfp, l_hp)
									mf_rem_hash (l_mfp, l_hp)
									mf_free_bhdr (l_hp)
									l_hp.ce_gets (l_mfp.item.mf_used_last)
									l_retval := 1
								else
									l_hp.ce_gets (l_hp.item.bh_prev)
								end
							else
								l_hp.ce_gets (l_hp.item.bh_prev)
							end
						end
					end
				end
				l_buf___6.ce_gets (l_buf___6.item.b_next)
			end
			Result := l_retval
		end

	mf_alloc_bhdr (a_mfp: CE_POINTER [PD_MEMFILE]; a_page_count___0: INTEGER_32): CE_POINTER [PD_BLOCK_HDR]
		local
			l_hp: CE_POINTER [PD_BLOCK_HDR]
			l_tmp: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_hp.make
			create l_tmp.make

			l_hp.ce_gets (create {CE_POINTER [PD_BLOCK_HDR]}.make_cast ((misc2_inst.alloc ({PD_BLOCK_HDR}.sizeof.to_natural_32))))
			if (l_hp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_tmp.ce_gets ((misc2_inst.alloc (a_mfp.item.mf_page_size * a_page_count___0.to_natural_32)))
				l_hp.item.bh_data := l_tmp
				if (l_tmp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_hp))
					Result := (create {CE_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer))
					js.return
				end
				if not js.return_called then
					l_hp.item.bh_page_count := a_page_count___0
				end
			end
			if not js.return_called then
				Result := l_hp
			end
		end

	mf_free_bhdr (a_hp: CE_POINTER [PD_BLOCK_HDR])
		do
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_hp.item.bh_data))
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_hp))
		end

	mf_ins_free (a_mfp: CE_POINTER [PD_MEMFILE]; a_hp: CE_POINTER [PD_BLOCK_HDR])
		do
			a_hp.item.bh_next := a_mfp.item.mf_free_first
			a_mfp.item.mf_free_first := a_hp
		end

	mf_rem_free (a_mfp: CE_POINTER [PD_MEMFILE]): CE_POINTER [PD_BLOCK_HDR]
		local
			l_hp: CE_POINTER [PD_BLOCK_HDR]
		do
			create l_hp.make

			l_hp.ce_gets (a_mfp.item.mf_free_first)
			a_mfp.item.mf_free_first := l_hp.item.bh_next
			Result := l_hp
		end

	mf_read (a_mfp: CE_POINTER [PD_MEMFILE]; a_hp: CE_POINTER [PD_BLOCK_HDR]): INTEGER_32
		local
			l_offset: INTEGER_32
			l_page_size: NATURAL_32
			l_size: NATURAL_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_tmp___0.make
			create l_tmp___4.make

			if a_mfp.item.mf_fd < 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_page_size := a_mfp.item.mf_page_size
				l_offset := l_page_size.to_integer_32 * a_hp.item.bh_bnum
				l_size := l_page_size * (a_hp.item.bh_page_count).to_natural_32
				if (lseek (a_mfp.item.mf_fd, l_offset, 0)) /= l_offset then
					l_tmp___0.ce_gets (strerror ((errno_location).item))
					misc2_inst.emsg3 (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%%s: %%s")), create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E294: Seek error in swap file read")))), create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___0)).do_nothing
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if (read (a_mfp.item.mf_fd, create {CE_POINTER [ANY]}.make_cast (a_hp.item.bh_data), l_size)).to_natural_32 /= l_size then
					l_tmp___4.ce_gets (strerror ((errno_location).item))
					misc2_inst.emsg3 (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%%s: %%s")), create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E295: Read error in swap file")))), create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___4)).do_nothing
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if (((a_mfp.item.mf_buffer).item.b_p_key).item).to_integer_32 /= 0 then
					memline_inst.ml_decrypt_data (a_mfp, a_hp.item.bh_data, l_offset, l_size)
				end
				Result := 1
			end
		end

	mf_write (a_mfp: CE_POINTER [PD_MEMFILE]; a_hp: CE_POINTER [PD_BLOCK_HDR]): INTEGER_32
		local
			l_offset: INTEGER_32
			l_nr: INTEGER_32
			l_hp2: CE_POINTER [PD_BLOCK_HDR]
			l_page_size: NATURAL_32
			l_page_count___0: NATURAL_32
			l_size: NATURAL_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [PD_BLOCK_HDR]
			js: JUMP_STATE
		do
			create l_hp2.make
			create l_tmp___1.make
			create l_tmp___5.make

			if a_mfp.item.mf_fd < 0 then
				Result := 0
				js.return
			end
			if not js.return_called and then (a_hp.item.bh_bnum < 0) then
				if (mf_trans_add (a_mfp, a_hp)) = 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_page_size := a_mfp.item.mf_page_size
				from
				until
					js.loop_left
				loop
					js.reset
					l_nr := a_hp.item.bh_bnum
					if l_nr > a_mfp.item.mf_infile_count then
						l_nr := a_mfp.item.mf_infile_count
						l_hp2.ce_gets (mf_find_hash (a_mfp, l_nr))
					else
						l_hp2.ce_gets (a_hp)
					end
					l_offset := l_page_size.to_integer_32 * l_nr
					if (lseek (a_mfp.item.mf_fd, l_offset, 0)) /= l_offset then
						l_tmp___1.ce_gets (strerror ((errno_location).item))
						misc2_inst.emsg3 (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%%s: %%s")), create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E296: Seek error in swap file write")))), create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___1)).do_nothing
						Result := 0
						js.return
					end
					if not js.return_called then
						if (l_hp2.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_page_count___0 := {NATURAL_32} 1
						else
							l_page_count___0 := (l_hp2.item.bh_page_count).to_natural_32
						end
						l_size := l_page_size * l_page_count___0
						if (l_hp2.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_tmp___5.ce_gets (a_hp)
						else
							l_tmp___5.ce_gets (l_hp2)
						end
						if (mf_write_block (a_mfp, l_tmp___5, l_offset, l_size)) = 0 then
							if not globals_inst.did_swapwrite_msg.to_boolean then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E297: Write error in swap file"))))).do_nothing
							end
							globals_inst.did_swapwrite_msg := 1
							Result := 0
							js.return
						end
					end
					if not js.return_called then
						globals_inst.did_swapwrite_msg := 0
						if (l_hp2.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_hp2.item.bh_flags := (((l_hp2.item.bh_flags).to_integer_32).bit_and (-2)).to_integer_8
						end
						if l_nr + l_page_count___0.to_integer_32 > a_mfp.item.mf_infile_count then
							a_mfp.item.mf_infile_count := (l_nr.to_natural_32 + l_page_count___0.to_natural_32).to_integer_32
						end
						if l_nr = a_hp.item.bh_bnum then
							js.break
						end
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 1
			end
		end

	mf_write_block (a_mfp: CE_POINTER [PD_MEMFILE]; a_hp: CE_POINTER [PD_BLOCK_HDR]; a_offset: INTEGER_32; a_size: NATURAL_32): INTEGER_32
		local
			l_data: CE_POINTER [NATURAL_8]
			l_result___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_data.make

			l_data.ce_gets (a_hp.item.bh_data)
			l_result___2 := 1
			if (((a_mfp.item.mf_buffer).item.b_p_key).item).to_integer_32 /= 0 then
				l_data.ce_gets (memline_inst.ml_encrypt_data (a_mfp, l_data, a_offset, a_size))
				if (l_data.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if (write (a_mfp.item.mf_fd, create {CE_POINTER [ANY]}.make_cast (l_data), a_size)).to_natural_32 /= a_size then
					l_result___2 := 0
				end
				if (l_data.c_pointer.to_integer_32).to_natural_32 /= ((a_hp.item.bh_data).c_pointer.to_integer_32).to_natural_32 then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_data))
				end
				Result := l_result___2
			end
		end

	mf_trans_add (a_mfp: CE_POINTER [PD_MEMFILE]; a_hp: CE_POINTER [PD_BLOCK_HDR]): INTEGER_32
		local
			l_freep: CE_POINTER [PD_BLOCK_HDR]
			l_new_bnum: INTEGER_32
			l_hash: INTEGER_32
			l_np: CE_POINTER [PD_NR_TRANS]
			l_page_count___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_freep.make
			create l_np.make

			if a_hp.item.bh_bnum >= 0 then
				Result := 1
				js.return
			end
			if not js.return_called then
				l_np.ce_gets (create {CE_POINTER [PD_NR_TRANS]}.make_cast ((misc2_inst.alloc ({PD_NR_TRANS}.sizeof.to_natural_32))))
				if (l_np.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_freep.ce_gets (a_mfp.item.mf_free_first)
				l_page_count___0 := a_hp.item.bh_page_count
				if (l_freep.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if l_freep.item.bh_page_count >= l_page_count___0 then
						l_new_bnum := l_freep.item.bh_bnum
						if l_freep.item.bh_page_count > l_page_count___0 then
							l_freep.item.bh_bnum := l_freep.item.bh_bnum + l_page_count___0.to_integer_32
							l_freep.item.bh_page_count := l_freep.item.bh_page_count - l_page_count___0
						else
							l_freep.ce_gets (mf_rem_free (a_mfp))
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_freep))
						end
					else
						l_new_bnum := a_mfp.item.mf_blocknr_max
						a_mfp.item.mf_blocknr_max := a_mfp.item.mf_blocknr_max + l_page_count___0.to_integer_32
					end
				else
					l_new_bnum := a_mfp.item.mf_blocknr_max
					a_mfp.item.mf_blocknr_max := a_mfp.item.mf_blocknr_max + l_page_count___0.to_integer_32
				end
				l_np.item.nt_old_bnum := a_hp.item.bh_bnum
				l_np.item.nt_new_bnum := l_new_bnum
				mf_rem_hash (a_mfp, a_hp)
				a_hp.item.bh_bnum := l_new_bnum
				mf_ins_hash (a_mfp, a_hp)
				l_hash := ((l_np.item.nt_old_bnum).bit_and (63)).to_integer_32
				l_np.item.nt_next := a_mfp.item.mf_trans[l_hash]
				a_mfp.item.mf_trans[l_hash] := l_np
				if ((l_np.item.nt_next).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					(l_np.item.nt_next).item.nt_prev := l_np
				end
				l_np.item.nt_prev := create {CE_POINTER [PD_NR_TRANS]}.make_shared (default_pointer)
				Result := 1
			end
		end

	mf_trans_del (a_mfp: CE_POINTER [PD_MEMFILE]; a_old_nr: INTEGER_32): INTEGER_32
		local
			l_hash: INTEGER_32
			l_np: CE_POINTER [PD_NR_TRANS]
			l_new_bnum: INTEGER_32
			js: JUMP_STATE
		do
			create l_np.make

			l_hash := ((a_old_nr).bit_and (63)).to_integer_32
			l_np.ce_gets (a_mfp.item.mf_trans[l_hash])
			from
			until
				not (not js.loop_left and then ((l_np.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
			loop
				js.reset
				if l_np.item.nt_old_bnum = a_old_nr then
					js.break
				end
				if not js.loop_jumped then
					l_np.ce_gets (l_np.item.nt_next)
				end
			end
			js.reset
			if (l_np.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				Result := a_old_nr
				js.return
			end
			if not js.return_called then
				a_mfp.item.mf_neg_count := (a_mfp.item.mf_neg_count) - 1
				l_new_bnum := l_np.item.nt_new_bnum
				if ((l_np.item.nt_prev).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					(l_np.item.nt_prev).item.nt_next := l_np.item.nt_next
				else
					a_mfp.item.mf_trans[l_hash] := l_np.item.nt_next
				end
				if ((l_np.item.nt_next).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					(l_np.item.nt_next).item.nt_prev := l_np.item.nt_prev
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_np))
				Result := l_new_bnum
			end
		end

	mf_set_ffname (a_mfp: CE_POINTER [PD_MEMFILE])
		do
			a_mfp.item.mf_ffname := misc1_inst.FullName_save (a_mfp.item.mf_fname, 0)
		end

	mf_fullname (a_mfp: CE_POINTER [PD_MEMFILE])
		do
			if (a_mfp.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if ((a_mfp.item.mf_fname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if ((a_mfp.item.mf_ffname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_mfp.item.mf_fname))
						a_mfp.item.mf_fname := a_mfp.item.mf_ffname
						a_mfp.item.mf_ffname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					end
				end
			end
		end

	mf_need_trans (a_mfp: CE_POINTER [PD_MEMFILE]): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if ((a_mfp.item.mf_fname).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if a_mfp.item.mf_neg_count > 0 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	mf_do_open (a_mfp: CE_POINTER [PD_MEMFILE]; a_fname: CE_POINTER [NATURAL_8]; a_flags___0: INTEGER_32)
		local
			l_flags___0: INTEGER_32
			l_sb: SD_STAT
			l_fdflags: INTEGER_32
		do
			create l_sb.make

			l_flags___0 := a_flags___0
			a_mfp.item.mf_fname := a_fname
			mf_set_ffname (a_mfp)
			if ((l_flags___0).bit_and (64)).to_boolean then
				if (lstat (create {CE_POINTER [INTEGER_8]}.make_cast (a_mfp.item.mf_fname), (l_sb.address))) >= 0 then
					a_mfp.item.mf_fd := -1
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E300: Swap file already exists (symlink attack?)"))))).do_nothing
				else
					l_flags___0 := (l_flags___0).bit_or ((131072))
					a_mfp.item.mf_fd := open ([create {CE_POINTER [INTEGER_8]}.make_cast (a_mfp.item.mf_fname), l_flags___0, (384).to_natural_32])
				end
			else
				l_flags___0 := (l_flags___0).bit_or ((131072))
				a_mfp.item.mf_fd := open ([create {CE_POINTER [INTEGER_8]}.make_cast (a_mfp.item.mf_fname), l_flags___0, (384).to_natural_32])
			end
			if a_mfp.item.mf_fd < 0 then
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_mfp.item.mf_fname))
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_mfp.item.mf_ffname))
				a_mfp.item.mf_fname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				a_mfp.item.mf_ffname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			else
				l_fdflags := (fcntl ([a_mfp.item.mf_fd, 1]))
				if l_fdflags >= 0 then
					if ((l_fdflags).bit_and (1)) = 0 then
						fcntl ([a_mfp.item.mf_fd, 2, (l_fdflags).bit_or (1)]).do_nothing
					end
				end
				os_unix_inst.mch_hide (a_mfp.item.mf_fname)
			end
		end

end
