class
	SD_ATKRELATIONSET

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	parent: SD_GOBJECT assign set_parent
		do
			create Result.make_shared (c_parent (c_pointer))
		end

	relations: CE_POINTER [SD_GPTRARRAY] assign set_relations
		do
			create Result.make_shared (c_relations (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_parent (a_parent: SD_GOBJECT)
		do
			parent.ce_gets (a_parent)
		end

	set_relations (a_relations: CE_POINTER [SD_GPTRARRAY])
		do
			c_set_relations (c_pointer, a_relations.c_pointer)
		end

feature {NONE} -- C getters

	c_parent (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GObject *)&((struct _AtkRelationSet *)$tmp)->parent;"
		end

	c_relations (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GPtrArray *)((struct _AtkRelationSet *)$tmp)->relations;"
		end

feature {NONE} -- C setters

	c_set_relations (tmp: POINTER; a_relations: POINTER)
		external
			"C inline"
		alias
			"((struct _AtkRelationSet *)$tmp)->relations = (struct _GPtrArray *)$a_relations;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _AtkRelationSet);"
		end

end
