class
	SD_DATA4

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	pixmap: SD_GTKIMAGEPIXMAPDATA assign set_pixmap
		do
			create Result.make_shared (c_pixmap (c_pointer))
		end

	image: SD_GTKIMAGEIMAGEDATA assign set_image
		do
			create Result.make_shared (c_image (c_pointer))
		end

	pixbuf: SD_GTKIMAGEPIXBUFDATA assign set_pixbuf
		do
			create Result.make_shared (c_pixbuf (c_pointer))
		end

	stock: SD_GTKIMAGESTOCKDATA assign set_stock
		do
			create Result.make_shared (c_stock (c_pointer))
		end

	icon_set: SD_GTKIMAGEICONSETDATA assign set_icon_set
		do
			create Result.make_shared (c_icon_set (c_pointer))
		end

	anim: SD_GTKIMAGEANIMATIONDATA assign set_anim
		do
			create Result.make_shared (c_anim (c_pointer))
		end

	name: SD_GTKIMAGEICONNAMEDATA assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	gicon: SD_GTKIMAGEGICONDATA assign set_gicon
		do
			create Result.make_shared (c_gicon (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_pixmap (a_pixmap: SD_GTKIMAGEPIXMAPDATA)
		do
			pixmap.ce_gets (a_pixmap)
		end

	set_image (a_image: SD_GTKIMAGEIMAGEDATA)
		do
			image.ce_gets (a_image)
		end

	set_pixbuf (a_pixbuf: SD_GTKIMAGEPIXBUFDATA)
		do
			pixbuf.ce_gets (a_pixbuf)
		end

	set_stock (a_stock: SD_GTKIMAGESTOCKDATA)
		do
			stock.ce_gets (a_stock)
		end

	set_icon_set (a_icon_set: SD_GTKIMAGEICONSETDATA)
		do
			icon_set.ce_gets (a_icon_set)
		end

	set_anim (a_anim: SD_GTKIMAGEANIMATIONDATA)
		do
			anim.ce_gets (a_anim)
		end

	set_name (a_name: SD_GTKIMAGEICONNAMEDATA)
		do
			name.ce_gets (a_name)
		end

	set_gicon (a_gicon: SD_GTKIMAGEGICONDATA)
		do
			gicon.ce_gets (a_gicon)
		end

feature {NONE} -- C getters

	c_pixmap (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkImagePixmapData *)&((union __anonunion_data_461 *)$tmp)->pixmap;"
		end

	c_image (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkImageImageData *)&((union __anonunion_data_461 *)$tmp)->image;"
		end

	c_pixbuf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkImagePixbufData *)&((union __anonunion_data_461 *)$tmp)->pixbuf;"
		end

	c_stock (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkImageStockData *)&((union __anonunion_data_461 *)$tmp)->stock;"
		end

	c_icon_set (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkImageIconSetData *)&((union __anonunion_data_461 *)$tmp)->icon_set;"
		end

	c_anim (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkImageAnimationData *)&((union __anonunion_data_461 *)$tmp)->anim;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkImageIconNameData *)&((union __anonunion_data_461 *)$tmp)->name;"
		end

	c_gicon (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkImageGIconData *)&((union __anonunion_data_461 *)$tmp)->gicon;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(union __anonunion_data_461);"
		end

end
