class
	SD_GDKCURSOR

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	ref_count: NATURAL_32 assign set_ref_count
		do
			Result := c_ref_count (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_ref_count (a_ref_count: NATURAL_32)
		do
			c_set_ref_count (c_pointer, a_ref_count)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkCursor *)$tmp)->type;"
		end

	c_ref_count (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkCursor *)$tmp)->ref_count;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkCursor *)$tmp)->type = $a_type;"
		end

	c_set_ref_count (tmp: POINTER; a_ref_count: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkCursor *)$tmp)->ref_count = $a_ref_count;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkCursor);"
		end

end
