class
	SD_GDKDEVICEKEY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	keyval: NATURAL_32 assign set_keyval
		do
			Result := c_keyval (c_pointer)
		end

	modifiers: INTEGER_32 assign set_modifiers
		do
			Result := c_modifiers (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_keyval (a_keyval: NATURAL_32)
		do
			c_set_keyval (c_pointer, a_keyval)
		end

	set_modifiers (a_modifiers: INTEGER_32)
		do
			c_set_modifiers (c_pointer, a_modifiers)
		end

feature {NONE} -- C getters

	c_keyval (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkDeviceKey *)$tmp)->keyval;"
		end

	c_modifiers (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkDeviceKey *)$tmp)->modifiers;"
		end

feature {NONE} -- C setters

	c_set_keyval (tmp: POINTER; a_keyval: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkDeviceKey *)$tmp)->keyval = $a_keyval;"
		end

	c_set_modifiers (tmp: POINTER; a_modifiers: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkDeviceKey *)$tmp)->modifiers = $a_modifiers;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkDeviceKey);"
		end

end
