class
	SD_GDKDRAGCONTEXT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	parent_instance: SD_GOBJECT assign set_parent_instance
		do
			create Result.make_shared (c_parent_instance (c_pointer))
		end

	protocol: INTEGER_32 assign set_protocol
		do
			Result := c_protocol (c_pointer)
		end

	is_source: INTEGER_32 assign set_is_source
		do
			Result := c_is_source (c_pointer)
		end

	source_window: CE_POINTER [SD_GDKDRAWABLE] assign set_source_window
		do
			create Result.make_shared (c_source_window (c_pointer))
		end

	dest_window: CE_POINTER [SD_GDKDRAWABLE] assign set_dest_window
		do
			create Result.make_shared (c_dest_window (c_pointer))
		end

	targets: CE_POINTER [SD_GLIST] assign set_targets
		do
			create Result.make_shared (c_targets (c_pointer))
		end

	actions: INTEGER_32 assign set_actions
		do
			Result := c_actions (c_pointer)
		end

	suggested_action: INTEGER_32 assign set_suggested_action
		do
			Result := c_suggested_action (c_pointer)
		end

	action: INTEGER_32 assign set_action
		do
			Result := c_action (c_pointer)
		end

	start_time: NATURAL_32 assign set_start_time
		do
			Result := c_start_time (c_pointer)
		end

	windowing_data: CE_POINTER [ANY] assign set_windowing_data
		do
			create Result.make_shared (c_windowing_data (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_parent_instance (a_parent_instance: SD_GOBJECT)
		do
			parent_instance.ce_gets (a_parent_instance)
		end

	set_protocol (a_protocol: INTEGER_32)
		do
			c_set_protocol (c_pointer, a_protocol)
		end

	set_is_source (a_is_source: INTEGER_32)
		do
			c_set_is_source (c_pointer, a_is_source)
		end

	set_source_window (a_source_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_source_window (c_pointer, a_source_window.c_pointer)
		end

	set_dest_window (a_dest_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_dest_window (c_pointer, a_dest_window.c_pointer)
		end

	set_targets (a_targets: CE_POINTER [SD_GLIST])
		do
			c_set_targets (c_pointer, a_targets.c_pointer)
		end

	set_actions (a_actions: INTEGER_32)
		do
			c_set_actions (c_pointer, a_actions)
		end

	set_suggested_action (a_suggested_action: INTEGER_32)
		do
			c_set_suggested_action (c_pointer, a_suggested_action)
		end

	set_action (a_action: INTEGER_32)
		do
			c_set_action (c_pointer, a_action)
		end

	set_start_time (a_start_time: NATURAL_32)
		do
			c_set_start_time (c_pointer, a_start_time)
		end

	set_windowing_data (a_windowing_data: CE_POINTER [ANY])
		do
			c_set_windowing_data (c_pointer, a_windowing_data.c_pointer)
		end

feature {NONE} -- C getters

	c_parent_instance (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GObject *)&((struct _GdkDragContext *)$tmp)->parent_instance;"
		end

	c_protocol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkDragContext *)$tmp)->protocol;"
		end

	c_is_source (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkDragContext *)$tmp)->is_source;"
		end

	c_source_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GdkDragContext *)$tmp)->source_window;"
		end

	c_dest_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GdkDragContext *)$tmp)->dest_window;"
		end

	c_targets (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GList *)((struct _GdkDragContext *)$tmp)->targets;"
		end

	c_actions (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkDragContext *)$tmp)->actions;"
		end

	c_suggested_action (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkDragContext *)$tmp)->suggested_action;"
		end

	c_action (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkDragContext *)$tmp)->action;"
		end

	c_start_time (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkDragContext *)$tmp)->start_time;"
		end

	c_windowing_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GdkDragContext *)$tmp)->windowing_data;"
		end

feature {NONE} -- C setters

	c_set_protocol (tmp: POINTER; a_protocol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkDragContext *)$tmp)->protocol = $a_protocol;"
		end

	c_set_is_source (tmp: POINTER; a_is_source: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkDragContext *)$tmp)->is_source = $a_is_source;"
		end

	c_set_source_window (tmp: POINTER; a_source_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkDragContext *)$tmp)->source_window = (struct _GdkDrawable *)$a_source_window;"
		end

	c_set_dest_window (tmp: POINTER; a_dest_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkDragContext *)$tmp)->dest_window = (struct _GdkDrawable *)$a_dest_window;"
		end

	c_set_targets (tmp: POINTER; a_targets: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkDragContext *)$tmp)->targets = (struct _GList *)$a_targets;"
		end

	c_set_actions (tmp: POINTER; a_actions: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkDragContext *)$tmp)->actions = $a_actions;"
		end

	c_set_suggested_action (tmp: POINTER; a_suggested_action: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkDragContext *)$tmp)->suggested_action = $a_suggested_action;"
		end

	c_set_action (tmp: POINTER; a_action: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkDragContext *)$tmp)->action = $a_action;"
		end

	c_set_start_time (tmp: POINTER; a_start_time: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkDragContext *)$tmp)->start_time = $a_start_time;"
		end

	c_set_windowing_data (tmp: POINTER; a_windowing_data: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkDragContext *)$tmp)->windowing_data = (void *)$a_windowing_data;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkDragContext);"
		end

end
