class
	SD_GDKEVENT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	any: SD_GDKEVENTANY assign set_any
		do
			create Result.make_shared (c_any (c_pointer))
		end

	expose: SD_GDKEVENTEXPOSE assign set_expose
		do
			create Result.make_shared (c_expose (c_pointer))
		end

	no_expose: SD_GDKEVENTNOEXPOSE assign set_no_expose
		do
			create Result.make_shared (c_no_expose (c_pointer))
		end

	visibility: SD_GDKEVENTVISIBILITY assign set_visibility
		do
			create Result.make_shared (c_visibility (c_pointer))
		end

	motion: SD_GDKEVENTMOTION assign set_motion
		do
			create Result.make_shared (c_motion (c_pointer))
		end

	button: SD_GDKEVENTBUTTON assign set_button
		do
			create Result.make_shared (c_button (c_pointer))
		end

	scroll: SD_GDKEVENTSCROLL assign set_scroll
		do
			create Result.make_shared (c_scroll (c_pointer))
		end

	key: SD_GDKEVENTKEY assign set_key
		do
			create Result.make_shared (c_key (c_pointer))
		end

	crossing: SD_GDKEVENTCROSSING assign set_crossing
		do
			create Result.make_shared (c_crossing (c_pointer))
		end

	focus_change: SD_GDKEVENTFOCUS assign set_focus_change
		do
			create Result.make_shared (c_focus_change (c_pointer))
		end

	configure: SD_GDKEVENTCONFIGURE assign set_configure
		do
			create Result.make_shared (c_configure (c_pointer))
		end

	property: SD_GDKEVENTPROPERTY assign set_property
		do
			create Result.make_shared (c_property (c_pointer))
		end

	selection: SD_GDKEVENTSELECTION assign set_selection
		do
			create Result.make_shared (c_selection (c_pointer))
		end

	owner_change: SD_GDKEVENTOWNERCHANGE assign set_owner_change
		do
			create Result.make_shared (c_owner_change (c_pointer))
		end

	proximity: SD_GDKEVENTPROXIMITY assign set_proximity
		do
			create Result.make_shared (c_proximity (c_pointer))
		end

	client: SD_GDKEVENTCLIENT assign set_client
		do
			create Result.make_shared (c_client (c_pointer))
		end

	dnd: SD_GDKEVENTDND assign set_dnd
		do
			create Result.make_shared (c_dnd (c_pointer))
		end

	window_state: SD_GDKEVENTWINDOWSTATE assign set_window_state
		do
			create Result.make_shared (c_window_state (c_pointer))
		end

	setting: SD_GDKEVENTSETTING assign set_setting
		do
			create Result.make_shared (c_setting (c_pointer))
		end

	grab_broken: SD_GDKEVENTGRABBROKEN assign set_grab_broken
		do
			create Result.make_shared (c_grab_broken (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_any (a_any: SD_GDKEVENTANY)
		do
			any.ce_gets (a_any)
		end

	set_expose (a_expose: SD_GDKEVENTEXPOSE)
		do
			expose.ce_gets (a_expose)
		end

	set_no_expose (a_no_expose: SD_GDKEVENTNOEXPOSE)
		do
			no_expose.ce_gets (a_no_expose)
		end

	set_visibility (a_visibility: SD_GDKEVENTVISIBILITY)
		do
			visibility.ce_gets (a_visibility)
		end

	set_motion (a_motion: SD_GDKEVENTMOTION)
		do
			motion.ce_gets (a_motion)
		end

	set_button (a_button: SD_GDKEVENTBUTTON)
		do
			button.ce_gets (a_button)
		end

	set_scroll (a_scroll: SD_GDKEVENTSCROLL)
		do
			scroll.ce_gets (a_scroll)
		end

	set_key (a_key: SD_GDKEVENTKEY)
		do
			key.ce_gets (a_key)
		end

	set_crossing (a_crossing: SD_GDKEVENTCROSSING)
		do
			crossing.ce_gets (a_crossing)
		end

	set_focus_change (a_focus_change: SD_GDKEVENTFOCUS)
		do
			focus_change.ce_gets (a_focus_change)
		end

	set_configure (a_configure: SD_GDKEVENTCONFIGURE)
		do
			configure.ce_gets (a_configure)
		end

	set_property (a_property: SD_GDKEVENTPROPERTY)
		do
			property.ce_gets (a_property)
		end

	set_selection (a_selection: SD_GDKEVENTSELECTION)
		do
			selection.ce_gets (a_selection)
		end

	set_owner_change (a_owner_change: SD_GDKEVENTOWNERCHANGE)
		do
			owner_change.ce_gets (a_owner_change)
		end

	set_proximity (a_proximity: SD_GDKEVENTPROXIMITY)
		do
			proximity.ce_gets (a_proximity)
		end

	set_client (a_client: SD_GDKEVENTCLIENT)
		do
			client.ce_gets (a_client)
		end

	set_dnd (a_dnd: SD_GDKEVENTDND)
		do
			dnd.ce_gets (a_dnd)
		end

	set_window_state (a_window_state: SD_GDKEVENTWINDOWSTATE)
		do
			window_state.ce_gets (a_window_state)
		end

	set_setting (a_setting: SD_GDKEVENTSETTING)
		do
			setting.ce_gets (a_setting)
		end

	set_grab_broken (a_grab_broken: SD_GDKEVENTGRABBROKEN)
		do
			grab_broken.ce_gets (a_grab_broken)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((union _GdkEvent *)$tmp)->type;"
		end

	c_any (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkEventAny *)&((union _GdkEvent *)$tmp)->any;"
		end

	c_expose (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkEventExpose *)&((union _GdkEvent *)$tmp)->expose;"
		end

	c_no_expose (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkEventNoExpose *)&((union _GdkEvent *)$tmp)->no_expose;"
		end

	c_visibility (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkEventVisibility *)&((union _GdkEvent *)$tmp)->visibility;"
		end

	c_motion (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkEventMotion *)&((union _GdkEvent *)$tmp)->motion;"
		end

	c_button (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkEventButton *)&((union _GdkEvent *)$tmp)->button;"
		end

	c_scroll (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkEventScroll *)&((union _GdkEvent *)$tmp)->scroll;"
		end

	c_key (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkEventKey *)&((union _GdkEvent *)$tmp)->key;"
		end

	c_crossing (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkEventCrossing *)&((union _GdkEvent *)$tmp)->crossing;"
		end

	c_focus_change (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkEventFocus *)&((union _GdkEvent *)$tmp)->focus_change;"
		end

	c_configure (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkEventConfigure *)&((union _GdkEvent *)$tmp)->configure;"
		end

	c_property (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkEventProperty *)&((union _GdkEvent *)$tmp)->property;"
		end

	c_selection (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkEventSelection *)&((union _GdkEvent *)$tmp)->selection;"
		end

	c_owner_change (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkEventOwnerChange *)&((union _GdkEvent *)$tmp)->owner_change;"
		end

	c_proximity (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkEventProximity *)&((union _GdkEvent *)$tmp)->proximity;"
		end

	c_client (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkEventClient *)&((union _GdkEvent *)$tmp)->client;"
		end

	c_dnd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkEventDND *)&((union _GdkEvent *)$tmp)->dnd;"
		end

	c_window_state (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkEventWindowState *)&((union _GdkEvent *)$tmp)->window_state;"
		end

	c_setting (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkEventSetting *)&((union _GdkEvent *)$tmp)->setting;"
		end

	c_grab_broken (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkEventGrabBroken *)&((union _GdkEvent *)$tmp)->grab_broken;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((union _GdkEvent *)$tmp)->type = $a_type;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(union _GdkEvent);"
		end

end
