class
	SD_GDKEVENTCLIENT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window
		do
			create Result.make_shared (c_window (c_pointer))
		end

	send_event: INTEGER_8 assign set_send_event
		do
			Result := c_send_event (c_pointer)
		end

	message_type: CE_POINTER [ANY] assign set_message_type
		do
			create Result.make_shared (c_message_type (c_pointer))
		end

	data_format: NATURAL_16 assign set_data_format
		do
			Result := c_data_format (c_pointer)
		end

	data: SD_DATA3 assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_window (c_pointer, a_window.c_pointer)
		end

	set_send_event (a_send_event: INTEGER_8)
		do
			c_set_send_event (c_pointer, a_send_event)
		end

	set_message_type (a_message_type: CE_POINTER [ANY])
		do
			c_set_message_type (c_pointer, a_message_type.c_pointer)
		end

	set_data_format (a_data_format: NATURAL_16)
		do
			c_set_data_format (c_pointer, a_data_format)
		end

	set_data (a_data: SD_DATA3)
		do
			data.ce_gets (a_data)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkEventClient *)$tmp)->type;"
		end

	c_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GdkEventClient *)$tmp)->window;"
		end

	c_send_event (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct _GdkEventClient *)$tmp)->send_event;"
		end

	c_message_type (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GdkEventClient *)$tmp)->message_type;"
		end

	c_data_format (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GdkEventClient *)$tmp)->data_format;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_data_237 *)&((struct _GdkEventClient *)$tmp)->data;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkEventClient *)$tmp)->type = $a_type;"
		end

	c_set_window (tmp: POINTER; a_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkEventClient *)$tmp)->window = (struct _GdkDrawable *)$a_window;"
		end

	c_set_send_event (tmp: POINTER; a_send_event: INTEGER_8)
		external
			"C inline"
		alias
			"((struct _GdkEventClient *)$tmp)->send_event = $a_send_event;"
		end

	c_set_message_type (tmp: POINTER; a_message_type: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkEventClient *)$tmp)->message_type = (void *)$a_message_type;"
		end

	c_set_data_format (tmp: POINTER; a_data_format: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GdkEventClient *)$tmp)->data_format = $a_data_format;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkEventClient);"
		end

end
