class
	SD_GDKEVENTGRABBROKEN

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window
		do
			create Result.make_shared (c_window (c_pointer))
		end

	send_event: INTEGER_8 assign set_send_event
		do
			Result := c_send_event (c_pointer)
		end

	keyboard: INTEGER_32 assign set_keyboard
		do
			Result := c_keyboard (c_pointer)
		end

	implicit: INTEGER_32 assign set_implicit
		do
			Result := c_implicit (c_pointer)
		end

	grab_window: CE_POINTER [SD_GDKDRAWABLE] assign set_grab_window
		do
			create Result.make_shared (c_grab_window (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_window (c_pointer, a_window.c_pointer)
		end

	set_send_event (a_send_event: INTEGER_8)
		do
			c_set_send_event (c_pointer, a_send_event)
		end

	set_keyboard (a_keyboard: INTEGER_32)
		do
			c_set_keyboard (c_pointer, a_keyboard)
		end

	set_implicit (a_implicit: INTEGER_32)
		do
			c_set_implicit (c_pointer, a_implicit)
		end

	set_grab_window (a_grab_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_grab_window (c_pointer, a_grab_window.c_pointer)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkEventGrabBroken *)$tmp)->type;"
		end

	c_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GdkEventGrabBroken *)$tmp)->window;"
		end

	c_send_event (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct _GdkEventGrabBroken *)$tmp)->send_event;"
		end

	c_keyboard (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkEventGrabBroken *)$tmp)->keyboard;"
		end

	c_implicit (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkEventGrabBroken *)$tmp)->implicit;"
		end

	c_grab_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GdkEventGrabBroken *)$tmp)->grab_window;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkEventGrabBroken *)$tmp)->type = $a_type;"
		end

	c_set_window (tmp: POINTER; a_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkEventGrabBroken *)$tmp)->window = (struct _GdkDrawable *)$a_window;"
		end

	c_set_send_event (tmp: POINTER; a_send_event: INTEGER_8)
		external
			"C inline"
		alias
			"((struct _GdkEventGrabBroken *)$tmp)->send_event = $a_send_event;"
		end

	c_set_keyboard (tmp: POINTER; a_keyboard: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkEventGrabBroken *)$tmp)->keyboard = $a_keyboard;"
		end

	c_set_implicit (tmp: POINTER; a_implicit: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkEventGrabBroken *)$tmp)->implicit = $a_implicit;"
		end

	c_set_grab_window (tmp: POINTER; a_grab_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkEventGrabBroken *)$tmp)->grab_window = (struct _GdkDrawable *)$a_grab_window;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkEventGrabBroken);"
		end

end
