class
	SD_GDKEVENTMOTION

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window
		do
			create Result.make_shared (c_window (c_pointer))
		end

	send_event: INTEGER_8 assign set_send_event
		do
			Result := c_send_event (c_pointer)
		end

	time: NATURAL_32 assign set_time
		do
			Result := c_time (c_pointer)
		end

	x: REAL_64 assign set_x
		do
			Result := c_x (c_pointer)
		end

	y: REAL_64 assign set_y
		do
			Result := c_y (c_pointer)
		end

	axes: CE_POINTER [REAL_64] assign set_axes
		do
			create Result.make_shared (c_axes (c_pointer))
		end

	state: NATURAL_32 assign set_state
		do
			Result := c_state (c_pointer)
		end

	is_hint: INTEGER_16 assign set_is_hint
		do
			Result := c_is_hint (c_pointer)
		end

	device: CE_POINTER [SD_GDKDEVICE] assign set_device
		do
			create Result.make_shared (c_device (c_pointer))
		end

	x_root: REAL_64 assign set_x_root
		do
			Result := c_x_root (c_pointer)
		end

	y_root: REAL_64 assign set_y_root
		do
			Result := c_y_root (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_window (c_pointer, a_window.c_pointer)
		end

	set_send_event (a_send_event: INTEGER_8)
		do
			c_set_send_event (c_pointer, a_send_event)
		end

	set_time (a_time: NATURAL_32)
		do
			c_set_time (c_pointer, a_time)
		end

	set_x (a_x: REAL_64)
		do
			c_set_x (c_pointer, a_x)
		end

	set_y (a_y: REAL_64)
		do
			c_set_y (c_pointer, a_y)
		end

	set_axes (a_axes: CE_POINTER [REAL_64])
		do
			c_set_axes (c_pointer, a_axes.c_pointer)
		end

	set_state (a_state: NATURAL_32)
		do
			c_set_state (c_pointer, a_state)
		end

	set_is_hint (a_is_hint: INTEGER_16)
		do
			c_set_is_hint (c_pointer, a_is_hint)
		end

	set_device (a_device: CE_POINTER [SD_GDKDEVICE])
		do
			c_set_device (c_pointer, a_device.c_pointer)
		end

	set_x_root (a_x_root: REAL_64)
		do
			c_set_x_root (c_pointer, a_x_root)
		end

	set_y_root (a_y_root: REAL_64)
		do
			c_set_y_root (c_pointer, a_y_root)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkEventMotion *)$tmp)->type;"
		end

	c_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GdkEventMotion *)$tmp)->window;"
		end

	c_send_event (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct _GdkEventMotion *)$tmp)->send_event;"
		end

	c_time (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkEventMotion *)$tmp)->time;"
		end

	c_x (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct _GdkEventMotion *)$tmp)->x;"
		end

	c_y (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct _GdkEventMotion *)$tmp)->y;"
		end

	c_axes (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct _GdkEventMotion *)$tmp)->axes;"
		end

	c_state (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkEventMotion *)$tmp)->state;"
		end

	c_is_hint (tmp: POINTER): INTEGER_16
		external
			"C inline"
		alias
			"return (short)((struct _GdkEventMotion *)$tmp)->is_hint;"
		end

	c_device (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDevice *)((struct _GdkEventMotion *)$tmp)->device;"
		end

	c_x_root (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct _GdkEventMotion *)$tmp)->x_root;"
		end

	c_y_root (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct _GdkEventMotion *)$tmp)->y_root;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkEventMotion *)$tmp)->type = $a_type;"
		end

	c_set_window (tmp: POINTER; a_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkEventMotion *)$tmp)->window = (struct _GdkDrawable *)$a_window;"
		end

	c_set_send_event (tmp: POINTER; a_send_event: INTEGER_8)
		external
			"C inline"
		alias
			"((struct _GdkEventMotion *)$tmp)->send_event = $a_send_event;"
		end

	c_set_time (tmp: POINTER; a_time: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkEventMotion *)$tmp)->time = $a_time;"
		end

	c_set_x (tmp: POINTER; a_x: REAL_64)
		external
			"C inline"
		alias
			"((struct _GdkEventMotion *)$tmp)->x = $a_x;"
		end

	c_set_y (tmp: POINTER; a_y: REAL_64)
		external
			"C inline"
		alias
			"((struct _GdkEventMotion *)$tmp)->y = $a_y;"
		end

	c_set_axes (tmp: POINTER; a_axes: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkEventMotion *)$tmp)->axes = (double *)$a_axes;"
		end

	c_set_state (tmp: POINTER; a_state: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkEventMotion *)$tmp)->state = $a_state;"
		end

	c_set_is_hint (tmp: POINTER; a_is_hint: INTEGER_16)
		external
			"C inline"
		alias
			"((struct _GdkEventMotion *)$tmp)->is_hint = $a_is_hint;"
		end

	c_set_device (tmp: POINTER; a_device: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkEventMotion *)$tmp)->device = (struct _GdkDevice *)$a_device;"
		end

	c_set_x_root (tmp: POINTER; a_x_root: REAL_64)
		external
			"C inline"
		alias
			"((struct _GdkEventMotion *)$tmp)->x_root = $a_x_root;"
		end

	c_set_y_root (tmp: POINTER; a_y_root: REAL_64)
		external
			"C inline"
		alias
			"((struct _GdkEventMotion *)$tmp)->y_root = $a_y_root;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkEventMotion);"
		end

end
