class
	SD_GDKEVENTPROXIMITY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window
		do
			create Result.make_shared (c_window (c_pointer))
		end

	send_event: INTEGER_8 assign set_send_event
		do
			Result := c_send_event (c_pointer)
		end

	time: NATURAL_32 assign set_time
		do
			Result := c_time (c_pointer)
		end

	device: CE_POINTER [SD_GDKDEVICE] assign set_device
		do
			create Result.make_shared (c_device (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_window (c_pointer, a_window.c_pointer)
		end

	set_send_event (a_send_event: INTEGER_8)
		do
			c_set_send_event (c_pointer, a_send_event)
		end

	set_time (a_time: NATURAL_32)
		do
			c_set_time (c_pointer, a_time)
		end

	set_device (a_device: CE_POINTER [SD_GDKDEVICE])
		do
			c_set_device (c_pointer, a_device.c_pointer)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkEventProximity *)$tmp)->type;"
		end

	c_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GdkEventProximity *)$tmp)->window;"
		end

	c_send_event (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct _GdkEventProximity *)$tmp)->send_event;"
		end

	c_time (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkEventProximity *)$tmp)->time;"
		end

	c_device (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDevice *)((struct _GdkEventProximity *)$tmp)->device;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkEventProximity *)$tmp)->type = $a_type;"
		end

	c_set_window (tmp: POINTER; a_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkEventProximity *)$tmp)->window = (struct _GdkDrawable *)$a_window;"
		end

	c_set_send_event (tmp: POINTER; a_send_event: INTEGER_8)
		external
			"C inline"
		alias
			"((struct _GdkEventProximity *)$tmp)->send_event = $a_send_event;"
		end

	c_set_time (tmp: POINTER; a_time: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkEventProximity *)$tmp)->time = $a_time;"
		end

	c_set_device (tmp: POINTER; a_device: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkEventProximity *)$tmp)->device = (struct _GdkDevice *)$a_device;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkEventProximity);"
		end

end
