class
	SD_GDKEVENTSELECTION

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window
		do
			create Result.make_shared (c_window (c_pointer))
		end

	send_event: INTEGER_8 assign set_send_event
		do
			Result := c_send_event (c_pointer)
		end

	selection: CE_POINTER [ANY] assign set_selection
		do
			create Result.make_shared (c_selection (c_pointer))
		end

	target: CE_POINTER [ANY] assign set_target
		do
			create Result.make_shared (c_target (c_pointer))
		end

	property: CE_POINTER [ANY] assign set_property
		do
			create Result.make_shared (c_property (c_pointer))
		end

	time: NATURAL_32 assign set_time
		do
			Result := c_time (c_pointer)
		end

	requestor: NATURAL_32 assign set_requestor
		do
			Result := c_requestor (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_window (c_pointer, a_window.c_pointer)
		end

	set_send_event (a_send_event: INTEGER_8)
		do
			c_set_send_event (c_pointer, a_send_event)
		end

	set_selection (a_selection: CE_POINTER [ANY])
		do
			c_set_selection (c_pointer, a_selection.c_pointer)
		end

	set_target (a_target: CE_POINTER [ANY])
		do
			c_set_target (c_pointer, a_target.c_pointer)
		end

	set_property (a_property: CE_POINTER [ANY])
		do
			c_set_property (c_pointer, a_property.c_pointer)
		end

	set_time (a_time: NATURAL_32)
		do
			c_set_time (c_pointer, a_time)
		end

	set_requestor (a_requestor: NATURAL_32)
		do
			c_set_requestor (c_pointer, a_requestor)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkEventSelection *)$tmp)->type;"
		end

	c_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GdkEventSelection *)$tmp)->window;"
		end

	c_send_event (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct _GdkEventSelection *)$tmp)->send_event;"
		end

	c_selection (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GdkEventSelection *)$tmp)->selection;"
		end

	c_target (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GdkEventSelection *)$tmp)->target;"
		end

	c_property (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GdkEventSelection *)$tmp)->property;"
		end

	c_time (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkEventSelection *)$tmp)->time;"
		end

	c_requestor (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkEventSelection *)$tmp)->requestor;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkEventSelection *)$tmp)->type = $a_type;"
		end

	c_set_window (tmp: POINTER; a_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkEventSelection *)$tmp)->window = (struct _GdkDrawable *)$a_window;"
		end

	c_set_send_event (tmp: POINTER; a_send_event: INTEGER_8)
		external
			"C inline"
		alias
			"((struct _GdkEventSelection *)$tmp)->send_event = $a_send_event;"
		end

	c_set_selection (tmp: POINTER; a_selection: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkEventSelection *)$tmp)->selection = (void *)$a_selection;"
		end

	c_set_target (tmp: POINTER; a_target: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkEventSelection *)$tmp)->target = (void *)$a_target;"
		end

	c_set_property (tmp: POINTER; a_property: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkEventSelection *)$tmp)->property = (void *)$a_property;"
		end

	c_set_time (tmp: POINTER; a_time: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkEventSelection *)$tmp)->time = $a_time;"
		end

	c_set_requestor (tmp: POINTER; a_requestor: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkEventSelection *)$tmp)->requestor = $a_requestor;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkEventSelection);"
		end

end
