class
	SD_GDKGCVALUES

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	foreground: SD_GDKCOLOR assign set_foreground
		do
			create Result.make_shared (c_foreground (c_pointer))
		end

	background: SD_GDKCOLOR assign set_background
		do
			create Result.make_shared (c_background (c_pointer))
		end

	font: CE_POINTER [SD_GDKFONT] assign set_font
		do
			create Result.make_shared (c_font (c_pointer))
		end

	function: INTEGER_32 assign set_function
		do
			Result := c_function (c_pointer)
		end

	fill: INTEGER_32 assign set_fill
		do
			Result := c_fill (c_pointer)
		end

	tile: CE_POINTER [SD_GDKDRAWABLE] assign set_tile
		do
			create Result.make_shared (c_tile (c_pointer))
		end

	stipple: CE_POINTER [SD_GDKDRAWABLE] assign set_stipple
		do
			create Result.make_shared (c_stipple (c_pointer))
		end

	clip_mask: CE_POINTER [SD_GDKDRAWABLE] assign set_clip_mask
		do
			create Result.make_shared (c_clip_mask (c_pointer))
		end

	subwindow_mode: INTEGER_32 assign set_subwindow_mode
		do
			Result := c_subwindow_mode (c_pointer)
		end

	ts_x_origin: INTEGER_32 assign set_ts_x_origin
		do
			Result := c_ts_x_origin (c_pointer)
		end

	ts_y_origin: INTEGER_32 assign set_ts_y_origin
		do
			Result := c_ts_y_origin (c_pointer)
		end

	clip_x_origin: INTEGER_32 assign set_clip_x_origin
		do
			Result := c_clip_x_origin (c_pointer)
		end

	clip_y_origin: INTEGER_32 assign set_clip_y_origin
		do
			Result := c_clip_y_origin (c_pointer)
		end

	graphics_exposures: INTEGER_32 assign set_graphics_exposures
		do
			Result := c_graphics_exposures (c_pointer)
		end

	line_width: INTEGER_32 assign set_line_width
		do
			Result := c_line_width (c_pointer)
		end

	line_style: INTEGER_32 assign set_line_style
		do
			Result := c_line_style (c_pointer)
		end

	cap_style: INTEGER_32 assign set_cap_style
		do
			Result := c_cap_style (c_pointer)
		end

	join_style: INTEGER_32 assign set_join_style
		do
			Result := c_join_style (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_foreground (a_foreground: SD_GDKCOLOR)
		do
			foreground.ce_gets (a_foreground)
		end

	set_background (a_background: SD_GDKCOLOR)
		do
			background.ce_gets (a_background)
		end

	set_font (a_font: CE_POINTER [SD_GDKFONT])
		do
			c_set_font (c_pointer, a_font.c_pointer)
		end

	set_function (a_function: INTEGER_32)
		do
			c_set_function (c_pointer, a_function)
		end

	set_fill (a_fill: INTEGER_32)
		do
			c_set_fill (c_pointer, a_fill)
		end

	set_tile (a_tile: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_tile (c_pointer, a_tile.c_pointer)
		end

	set_stipple (a_stipple: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_stipple (c_pointer, a_stipple.c_pointer)
		end

	set_clip_mask (a_clip_mask: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_clip_mask (c_pointer, a_clip_mask.c_pointer)
		end

	set_subwindow_mode (a_subwindow_mode: INTEGER_32)
		do
			c_set_subwindow_mode (c_pointer, a_subwindow_mode)
		end

	set_ts_x_origin (a_ts_x_origin: INTEGER_32)
		do
			c_set_ts_x_origin (c_pointer, a_ts_x_origin)
		end

	set_ts_y_origin (a_ts_y_origin: INTEGER_32)
		do
			c_set_ts_y_origin (c_pointer, a_ts_y_origin)
		end

	set_clip_x_origin (a_clip_x_origin: INTEGER_32)
		do
			c_set_clip_x_origin (c_pointer, a_clip_x_origin)
		end

	set_clip_y_origin (a_clip_y_origin: INTEGER_32)
		do
			c_set_clip_y_origin (c_pointer, a_clip_y_origin)
		end

	set_graphics_exposures (a_graphics_exposures: INTEGER_32)
		do
			c_set_graphics_exposures (c_pointer, a_graphics_exposures)
		end

	set_line_width (a_line_width: INTEGER_32)
		do
			c_set_line_width (c_pointer, a_line_width)
		end

	set_line_style (a_line_style: INTEGER_32)
		do
			c_set_line_style (c_pointer, a_line_style)
		end

	set_cap_style (a_cap_style: INTEGER_32)
		do
			c_set_cap_style (c_pointer, a_cap_style)
		end

	set_join_style (a_join_style: INTEGER_32)
		do
			c_set_join_style (c_pointer, a_join_style)
		end

feature {NONE} -- C getters

	c_foreground (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkColor *)&((struct _GdkGCValues *)$tmp)->foreground;"
		end

	c_background (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkColor *)&((struct _GdkGCValues *)$tmp)->background;"
		end

	c_font (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkFont *)((struct _GdkGCValues *)$tmp)->font;"
		end

	c_function (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkGCValues *)$tmp)->function;"
		end

	c_fill (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkGCValues *)$tmp)->fill;"
		end

	c_tile (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GdkGCValues *)$tmp)->tile;"
		end

	c_stipple (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GdkGCValues *)$tmp)->stipple;"
		end

	c_clip_mask (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GdkGCValues *)$tmp)->clip_mask;"
		end

	c_subwindow_mode (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkGCValues *)$tmp)->subwindow_mode;"
		end

	c_ts_x_origin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkGCValues *)$tmp)->ts_x_origin;"
		end

	c_ts_y_origin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkGCValues *)$tmp)->ts_y_origin;"
		end

	c_clip_x_origin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkGCValues *)$tmp)->clip_x_origin;"
		end

	c_clip_y_origin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkGCValues *)$tmp)->clip_y_origin;"
		end

	c_graphics_exposures (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkGCValues *)$tmp)->graphics_exposures;"
		end

	c_line_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkGCValues *)$tmp)->line_width;"
		end

	c_line_style (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkGCValues *)$tmp)->line_style;"
		end

	c_cap_style (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkGCValues *)$tmp)->cap_style;"
		end

	c_join_style (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkGCValues *)$tmp)->join_style;"
		end

feature {NONE} -- C setters

	c_set_font (tmp: POINTER; a_font: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkGCValues *)$tmp)->font = (struct _GdkFont *)$a_font;"
		end

	c_set_function (tmp: POINTER; a_function: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkGCValues *)$tmp)->function = $a_function;"
		end

	c_set_fill (tmp: POINTER; a_fill: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkGCValues *)$tmp)->fill = $a_fill;"
		end

	c_set_tile (tmp: POINTER; a_tile: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkGCValues *)$tmp)->tile = (struct _GdkDrawable *)$a_tile;"
		end

	c_set_stipple (tmp: POINTER; a_stipple: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkGCValues *)$tmp)->stipple = (struct _GdkDrawable *)$a_stipple;"
		end

	c_set_clip_mask (tmp: POINTER; a_clip_mask: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkGCValues *)$tmp)->clip_mask = (struct _GdkDrawable *)$a_clip_mask;"
		end

	c_set_subwindow_mode (tmp: POINTER; a_subwindow_mode: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkGCValues *)$tmp)->subwindow_mode = $a_subwindow_mode;"
		end

	c_set_ts_x_origin (tmp: POINTER; a_ts_x_origin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkGCValues *)$tmp)->ts_x_origin = $a_ts_x_origin;"
		end

	c_set_ts_y_origin (tmp: POINTER; a_ts_y_origin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkGCValues *)$tmp)->ts_y_origin = $a_ts_y_origin;"
		end

	c_set_clip_x_origin (tmp: POINTER; a_clip_x_origin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkGCValues *)$tmp)->clip_x_origin = $a_clip_x_origin;"
		end

	c_set_clip_y_origin (tmp: POINTER; a_clip_y_origin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkGCValues *)$tmp)->clip_y_origin = $a_clip_y_origin;"
		end

	c_set_graphics_exposures (tmp: POINTER; a_graphics_exposures: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkGCValues *)$tmp)->graphics_exposures = $a_graphics_exposures;"
		end

	c_set_line_width (tmp: POINTER; a_line_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkGCValues *)$tmp)->line_width = $a_line_width;"
		end

	c_set_line_style (tmp: POINTER; a_line_style: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkGCValues *)$tmp)->line_style = $a_line_style;"
		end

	c_set_cap_style (tmp: POINTER; a_cap_style: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkGCValues *)$tmp)->cap_style = $a_cap_style;"
		end

	c_set_join_style (tmp: POINTER; a_join_style: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkGCValues *)$tmp)->join_style = $a_join_style;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkGCValues);"
		end

end
