class
	SD_GOBJECTCONSTRUCTPARAM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	pspec: CE_POINTER [SD_GPARAMSPEC] assign set_pspec
		do
			create Result.make_shared (c_pspec (c_pointer))
		end

	value: CE_POINTER [SD_GVALUE] assign set_value
		do
			create Result.make_shared (c_value (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_pspec (a_pspec: CE_POINTER [SD_GPARAMSPEC])
		do
			c_set_pspec (c_pointer, a_pspec.c_pointer)
		end

	set_value (a_value: CE_POINTER [SD_GVALUE])
		do
			c_set_value (c_pointer, a_value.c_pointer)
		end

feature {NONE} -- C getters

	c_pspec (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GParamSpec *)((struct _GObjectConstructParam *)$tmp)->pspec;"
		end

	c_value (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GValue *)((struct _GObjectConstructParam *)$tmp)->value;"
		end

feature {NONE} -- C setters

	c_set_pspec (tmp: POINTER; a_pspec: POINTER)
		external
			"C inline"
		alias
			"((struct _GObjectConstructParam *)$tmp)->pspec = (struct _GParamSpec *)$a_pspec;"
		end

	c_set_value (tmp: POINTER; a_value: POINTER)
		external
			"C inline"
		alias
			"((struct _GObjectConstructParam *)$tmp)->value = (struct _GValue *)$a_value;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GObjectConstructParam);"
		end

end
