class
	SD_GTKADJUSTMENT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	parent_instance: SD_GTKOBJECT assign set_parent_instance
		do
			create Result.make_shared (c_parent_instance (c_pointer))
		end

	lower: REAL_64 assign set_lower
		do
			Result := c_lower (c_pointer)
		end

	upper: REAL_64 assign set_upper
		do
			Result := c_upper (c_pointer)
		end

	value: REAL_64 assign set_value
		do
			Result := c_value (c_pointer)
		end

	step_increment: REAL_64 assign set_step_increment
		do
			Result := c_step_increment (c_pointer)
		end

	page_increment: REAL_64 assign set_page_increment
		do
			Result := c_page_increment (c_pointer)
		end

	page_size: REAL_64 assign set_page_size
		do
			Result := c_page_size (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_parent_instance (a_parent_instance: SD_GTKOBJECT)
		do
			parent_instance.ce_gets (a_parent_instance)
		end

	set_lower (a_lower: REAL_64)
		do
			c_set_lower (c_pointer, a_lower)
		end

	set_upper (a_upper: REAL_64)
		do
			c_set_upper (c_pointer, a_upper)
		end

	set_value (a_value: REAL_64)
		do
			c_set_value (c_pointer, a_value)
		end

	set_step_increment (a_step_increment: REAL_64)
		do
			c_set_step_increment (c_pointer, a_step_increment)
		end

	set_page_increment (a_page_increment: REAL_64)
		do
			c_set_page_increment (c_pointer, a_page_increment)
		end

	set_page_size (a_page_size: REAL_64)
		do
			c_set_page_size (c_pointer, a_page_size)
		end

feature {NONE} -- C getters

	c_parent_instance (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkObject *)&((struct _GtkAdjustment *)$tmp)->parent_instance;"
		end

	c_lower (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct _GtkAdjustment *)$tmp)->lower;"
		end

	c_upper (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct _GtkAdjustment *)$tmp)->upper;"
		end

	c_value (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct _GtkAdjustment *)$tmp)->value;"
		end

	c_step_increment (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct _GtkAdjustment *)$tmp)->step_increment;"
		end

	c_page_increment (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct _GtkAdjustment *)$tmp)->page_increment;"
		end

	c_page_size (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct _GtkAdjustment *)$tmp)->page_size;"
		end

feature {NONE} -- C setters

	c_set_lower (tmp: POINTER; a_lower: REAL_64)
		external
			"C inline"
		alias
			"((struct _GtkAdjustment *)$tmp)->lower = $a_lower;"
		end

	c_set_upper (tmp: POINTER; a_upper: REAL_64)
		external
			"C inline"
		alias
			"((struct _GtkAdjustment *)$tmp)->upper = $a_upper;"
		end

	c_set_value (tmp: POINTER; a_value: REAL_64)
		external
			"C inline"
		alias
			"((struct _GtkAdjustment *)$tmp)->value = $a_value;"
		end

	c_set_step_increment (tmp: POINTER; a_step_increment: REAL_64)
		external
			"C inline"
		alias
			"((struct _GtkAdjustment *)$tmp)->step_increment = $a_step_increment;"
		end

	c_set_page_increment (tmp: POINTER; a_page_increment: REAL_64)
		external
			"C inline"
		alias
			"((struct _GtkAdjustment *)$tmp)->page_increment = $a_page_increment;"
		end

	c_set_page_size (tmp: POINTER; a_page_size: REAL_64)
		external
			"C inline"
		alias
			"((struct _GtkAdjustment *)$tmp)->page_size = $a_page_size;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkAdjustment);"
		end

end
