class
	SD_GTKBUTTON

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	bin: SD_GTKBIN assign set_bin
		do
			create Result.make_shared (c_bin (c_pointer))
		end

	event_window: CE_POINTER [SD_GDKDRAWABLE] assign set_event_window
		do
			create Result.make_shared (c_event_window (c_pointer))
		end

	label_text: CE_POINTER [INTEGER_8] assign set_label_text
		do
			create Result.make_shared (c_label_text (c_pointer))
		end

	activate_timeout: NATURAL_32 assign set_activate_timeout
		do
			Result := c_activate_timeout (c_pointer)
		end

	constructed: NATURAL_32 assign set_constructed
		do
			Result := c_constructed (c_pointer)
		end

	in_button: NATURAL_32 assign set_in_button
		do
			Result := c_in_button (c_pointer)
		end

	button_down: NATURAL_32 assign set_button_down
		do
			Result := c_button_down (c_pointer)
		end

	relief: NATURAL_32 assign set_relief
		do
			Result := c_relief (c_pointer)
		end

	use_underline: NATURAL_32 assign set_use_underline
		do
			Result := c_use_underline (c_pointer)
		end

	use_stock: NATURAL_32 assign set_use_stock
		do
			Result := c_use_stock (c_pointer)
		end

	depressed: NATURAL_32 assign set_depressed
		do
			Result := c_depressed (c_pointer)
		end

	depress_on_activate: NATURAL_32 assign set_depress_on_activate
		do
			Result := c_depress_on_activate (c_pointer)
		end

	focus_on_click: NATURAL_32 assign set_focus_on_click
		do
			Result := c_focus_on_click (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_bin (a_bin: SD_GTKBIN)
		do
			bin.ce_gets (a_bin)
		end

	set_event_window (a_event_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_event_window (c_pointer, a_event_window.c_pointer)
		end

	set_label_text (a_label_text: CE_POINTER [INTEGER_8])
		do
			c_set_label_text (c_pointer, a_label_text.c_pointer)
		end

	set_activate_timeout (a_activate_timeout: NATURAL_32)
		do
			c_set_activate_timeout (c_pointer, a_activate_timeout)
		end

	set_constructed (a_constructed: NATURAL_32)
		do
			c_set_constructed (c_pointer, a_constructed)
		end

	set_in_button (a_in_button: NATURAL_32)
		do
			c_set_in_button (c_pointer, a_in_button)
		end

	set_button_down (a_button_down: NATURAL_32)
		do
			c_set_button_down (c_pointer, a_button_down)
		end

	set_relief (a_relief: NATURAL_32)
		do
			c_set_relief (c_pointer, a_relief)
		end

	set_use_underline (a_use_underline: NATURAL_32)
		do
			c_set_use_underline (c_pointer, a_use_underline)
		end

	set_use_stock (a_use_stock: NATURAL_32)
		do
			c_set_use_stock (c_pointer, a_use_stock)
		end

	set_depressed (a_depressed: NATURAL_32)
		do
			c_set_depressed (c_pointer, a_depressed)
		end

	set_depress_on_activate (a_depress_on_activate: NATURAL_32)
		do
			c_set_depress_on_activate (c_pointer, a_depress_on_activate)
		end

	set_focus_on_click (a_focus_on_click: NATURAL_32)
		do
			c_set_focus_on_click (c_pointer, a_focus_on_click)
		end

feature {NONE} -- C getters

	c_bin (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkBin *)&((struct _GtkButton *)$tmp)->bin;"
		end

	c_event_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GtkButton *)$tmp)->event_window;"
		end

	c_label_text (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GtkButton *)$tmp)->label_text;"
		end

	c_activate_timeout (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkButton *)$tmp)->activate_timeout;"
		end

	c_constructed (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkButton *)$tmp)->constructed;"
		end

	c_in_button (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkButton *)$tmp)->in_button;"
		end

	c_button_down (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkButton *)$tmp)->button_down;"
		end

	c_relief (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkButton *)$tmp)->relief;"
		end

	c_use_underline (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkButton *)$tmp)->use_underline;"
		end

	c_use_stock (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkButton *)$tmp)->use_stock;"
		end

	c_depressed (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkButton *)$tmp)->depressed;"
		end

	c_depress_on_activate (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkButton *)$tmp)->depress_on_activate;"
		end

	c_focus_on_click (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkButton *)$tmp)->focus_on_click;"
		end

feature {NONE} -- C setters

	c_set_event_window (tmp: POINTER; a_event_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkButton *)$tmp)->event_window = (struct _GdkDrawable *)$a_event_window;"
		end

	c_set_label_text (tmp: POINTER; a_label_text: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkButton *)$tmp)->label_text = (char *)$a_label_text;"
		end

	c_set_activate_timeout (tmp: POINTER; a_activate_timeout: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkButton *)$tmp)->activate_timeout = $a_activate_timeout;"
		end

	c_set_constructed (tmp: POINTER; a_constructed: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkButton *)$tmp)->constructed = $a_constructed;"
		end

	c_set_in_button (tmp: POINTER; a_in_button: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkButton *)$tmp)->in_button = $a_in_button;"
		end

	c_set_button_down (tmp: POINTER; a_button_down: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkButton *)$tmp)->button_down = $a_button_down;"
		end

	c_set_relief (tmp: POINTER; a_relief: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkButton *)$tmp)->relief = $a_relief;"
		end

	c_set_use_underline (tmp: POINTER; a_use_underline: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkButton *)$tmp)->use_underline = $a_use_underline;"
		end

	c_set_use_stock (tmp: POINTER; a_use_stock: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkButton *)$tmp)->use_stock = $a_use_stock;"
		end

	c_set_depressed (tmp: POINTER; a_depressed: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkButton *)$tmp)->depressed = $a_depressed;"
		end

	c_set_depress_on_activate (tmp: POINTER; a_depress_on_activate: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkButton *)$tmp)->depress_on_activate = $a_depress_on_activate;"
		end

	c_set_focus_on_click (tmp: POINTER; a_focus_on_click: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkButton *)$tmp)->focus_on_click = $a_focus_on_click;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkButton);"
		end

end
