class
	SD_GTKCONTAINERCLASS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	parent_class: SD_GTKWIDGETCLASS assign set_parent_class
		do
			create Result.make_shared (c_parent_class (c_pointer))
		end

	add: CE_ROUTINE assign set_add
		do
			create Result.make_shared (c_add (c_pointer))
		end

	remove: CE_ROUTINE assign set_remove
		do
			create Result.make_shared (c_remove (c_pointer))
		end

	check_resize: CE_ROUTINE assign set_check_resize
		do
			create Result.make_shared (c_check_resize (c_pointer))
		end

	forall: CE_ROUTINE assign set_forall
		do
			create Result.make_shared (c_forall (c_pointer))
		end

	set_focus_child: CE_ROUTINE assign set_set_focus_child
		do
			create Result.make_shared (c_set_focus_child (c_pointer))
		end

	child_type: CE_ROUTINE assign set_child_type
		do
			create Result.make_shared (c_child_type (c_pointer))
		end

	composite_name: CE_ROUTINE assign set_composite_name
		do
			create Result.make_shared (c_composite_name (c_pointer))
		end

	set_child_property: CE_ROUTINE assign set_set_child_property
		do
			create Result.make_shared (c_set_child_property (c_pointer))
		end

	get_child_property: CE_ROUTINE assign set_get_child_property
		do
			create Result.make_shared (c_get_child_property (c_pointer))
		end

	gtk_reserved1: CE_ROUTINE assign set_gtk_reserved1
		do
			create Result.make_shared (c_gtk_reserved1 (c_pointer))
		end

	gtk_reserved2: CE_ROUTINE assign set_gtk_reserved2
		do
			create Result.make_shared (c_gtk_reserved2 (c_pointer))
		end

	gtk_reserved3: CE_ROUTINE assign set_gtk_reserved3
		do
			create Result.make_shared (c_gtk_reserved3 (c_pointer))
		end

	gtk_reserved4: CE_ROUTINE assign set_gtk_reserved4
		do
			create Result.make_shared (c_gtk_reserved4 (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_parent_class (a_parent_class: SD_GTKWIDGETCLASS)
		do
			parent_class.ce_gets (a_parent_class)
		end

	set_add (a_add: CE_ROUTINE)
		do
			c_set_add (c_pointer, a_add.c_pointer)
		end

	set_remove (a_remove: CE_ROUTINE)
		do
			c_set_remove (c_pointer, a_remove.c_pointer)
		end

	set_check_resize (a_check_resize: CE_ROUTINE)
		do
			c_set_check_resize (c_pointer, a_check_resize.c_pointer)
		end

	set_forall (a_forall: CE_ROUTINE)
		do
			c_set_forall (c_pointer, a_forall.c_pointer)
		end

	set_set_focus_child (a_set_focus_child: CE_ROUTINE)
		do
			c_set_set_focus_child (c_pointer, a_set_focus_child.c_pointer)
		end

	set_child_type (a_child_type: CE_ROUTINE)
		do
			c_set_child_type (c_pointer, a_child_type.c_pointer)
		end

	set_composite_name (a_composite_name: CE_ROUTINE)
		do
			c_set_composite_name (c_pointer, a_composite_name.c_pointer)
		end

	set_set_child_property (a_set_child_property: CE_ROUTINE)
		do
			c_set_set_child_property (c_pointer, a_set_child_property.c_pointer)
		end

	set_get_child_property (a_get_child_property: CE_ROUTINE)
		do
			c_set_get_child_property (c_pointer, a_get_child_property.c_pointer)
		end

	set_gtk_reserved1 (a_gtk_reserved1: CE_ROUTINE)
		do
			c_set_gtk_reserved1 (c_pointer, a_gtk_reserved1.c_pointer)
		end

	set_gtk_reserved2 (a_gtk_reserved2: CE_ROUTINE)
		do
			c_set_gtk_reserved2 (c_pointer, a_gtk_reserved2.c_pointer)
		end

	set_gtk_reserved3 (a_gtk_reserved3: CE_ROUTINE)
		do
			c_set_gtk_reserved3 (c_pointer, a_gtk_reserved3.c_pointer)
		end

	set_gtk_reserved4 (a_gtk_reserved4: CE_ROUTINE)
		do
			c_set_gtk_reserved4 (c_pointer, a_gtk_reserved4.c_pointer)
		end

feature {NONE} -- C getters

	c_parent_class (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidgetClass *)&((struct _GtkContainerClass *)$tmp)->parent_class;"
		end

	c_add (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _GtkContainer * container, struct _GtkWidget * widget))((struct _GtkContainerClass *)$tmp)->add;"
		end

	c_remove (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _GtkContainer * container, struct _GtkWidget * widget))((struct _GtkContainerClass *)$tmp)->remove;"
		end

	c_check_resize (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _GtkContainer * container))((struct _GtkContainerClass *)$tmp)->check_resize;"
		end

	c_forall (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _GtkContainer * container, int include_internals, void( * callback)(struct _GtkWidget * widget, void * data), void * callback_data))((struct _GtkContainerClass *)$tmp)->forall;"
		end

	c_set_focus_child (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _GtkContainer * container, struct _GtkWidget * widget))((struct _GtkContainerClass *)$tmp)->set_focus_child;"
		end

	c_child_type (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned int( *)(struct _GtkContainer * container))((struct _GtkContainerClass *)$tmp)->child_type;"
		end

	c_composite_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *( *)(struct _GtkContainer * container, struct _GtkWidget * child))((struct _GtkContainerClass *)$tmp)->composite_name;"
		end

	c_set_child_property (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _GtkContainer * container, struct _GtkWidget * child, unsigned int property_id, struct _GValue * value, struct _GParamSpec * pspec))((struct _GtkContainerClass *)$tmp)->set_child_property;"
		end

	c_get_child_property (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _GtkContainer * container, struct _GtkWidget * child, unsigned int property_id, struct _GValue * value, struct _GParamSpec * pspec))((struct _GtkContainerClass *)$tmp)->get_child_property;"
		end

	c_gtk_reserved1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)())((struct _GtkContainerClass *)$tmp)->_gtk_reserved1;"
		end

	c_gtk_reserved2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)())((struct _GtkContainerClass *)$tmp)->_gtk_reserved2;"
		end

	c_gtk_reserved3 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)())((struct _GtkContainerClass *)$tmp)->_gtk_reserved3;"
		end

	c_gtk_reserved4 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)())((struct _GtkContainerClass *)$tmp)->_gtk_reserved4;"
		end

feature {NONE} -- C setters

	c_set_add (tmp: POINTER; a_add: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkContainerClass *)$tmp)->add = (void( *)(struct _GtkContainer * container, struct _GtkWidget * widget))$a_add;"
		end

	c_set_remove (tmp: POINTER; a_remove: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkContainerClass *)$tmp)->remove = (void( *)(struct _GtkContainer * container, struct _GtkWidget * widget))$a_remove;"
		end

	c_set_check_resize (tmp: POINTER; a_check_resize: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkContainerClass *)$tmp)->check_resize = (void( *)(struct _GtkContainer * container))$a_check_resize;"
		end

	c_set_forall (tmp: POINTER; a_forall: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkContainerClass *)$tmp)->forall = (void( *)(struct _GtkContainer * container, int include_internals, void( * callback)(struct _GtkWidget * widget, void * data), void * callback_data))$a_forall;"
		end

	c_set_set_focus_child (tmp: POINTER; a_set_focus_child: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkContainerClass *)$tmp)->set_focus_child = (void( *)(struct _GtkContainer * container, struct _GtkWidget * widget))$a_set_focus_child;"
		end

	c_set_child_type (tmp: POINTER; a_child_type: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkContainerClass *)$tmp)->child_type = (unsigned int( *)(struct _GtkContainer * container))$a_child_type;"
		end

	c_set_composite_name (tmp: POINTER; a_composite_name: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkContainerClass *)$tmp)->composite_name = (char *( *)(struct _GtkContainer * container, struct _GtkWidget * child))$a_composite_name;"
		end

	c_set_set_child_property (tmp: POINTER; a_set_child_property: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkContainerClass *)$tmp)->set_child_property = (void( *)(struct _GtkContainer * container, struct _GtkWidget * child, unsigned int property_id, struct _GValue * value, struct _GParamSpec * pspec))$a_set_child_property;"
		end

	c_set_get_child_property (tmp: POINTER; a_get_child_property: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkContainerClass *)$tmp)->get_child_property = (void( *)(struct _GtkContainer * container, struct _GtkWidget * child, unsigned int property_id, struct _GValue * value, struct _GParamSpec * pspec))$a_get_child_property;"
		end

	c_set_gtk_reserved1 (tmp: POINTER; a_gtk_reserved1: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkContainerClass *)$tmp)->_gtk_reserved1 = (void( *)())$a_gtk_reserved1;"
		end

	c_set_gtk_reserved2 (tmp: POINTER; a_gtk_reserved2: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkContainerClass *)$tmp)->_gtk_reserved2 = (void( *)())$a_gtk_reserved2;"
		end

	c_set_gtk_reserved3 (tmp: POINTER; a_gtk_reserved3: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkContainerClass *)$tmp)->_gtk_reserved3 = (void( *)())$a_gtk_reserved3;"
		end

	c_set_gtk_reserved4 (tmp: POINTER; a_gtk_reserved4: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkContainerClass *)$tmp)->_gtk_reserved4 = (void( *)())$a_gtk_reserved4;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkContainerClass);"
		end

end
