class
	SD_GTKENTRY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	widget: SD_GTKWIDGET assign set_widget
		do
			create Result.make_shared (c_widget (c_pointer))
		end

	text: CE_POINTER [INTEGER_8] assign set_text
		do
			create Result.make_shared (c_text (c_pointer))
		end

	editable: NATURAL_32 assign set_editable
		do
			Result := c_editable (c_pointer)
		end

	visible: NATURAL_32 assign set_visible
		do
			Result := c_visible (c_pointer)
		end

	overwrite_mode: NATURAL_32 assign set_overwrite_mode
		do
			Result := c_overwrite_mode (c_pointer)
		end

	in_drag: NATURAL_32 assign set_in_drag
		do
			Result := c_in_drag (c_pointer)
		end

	text_length: NATURAL_16 assign set_text_length
		do
			Result := c_text_length (c_pointer)
		end

	text_max_length: NATURAL_16 assign set_text_max_length
		do
			Result := c_text_max_length (c_pointer)
		end

	text_area: CE_POINTER [SD_GDKDRAWABLE] assign set_text_area
		do
			create Result.make_shared (c_text_area (c_pointer))
		end

	im_context: CE_POINTER [SD_GTKIMCONTEXT] assign set_im_context
		do
			create Result.make_shared (c_im_context (c_pointer))
		end

	popup_menu: CE_POINTER [SD_GTKWIDGET] assign set_popup_menu
		do
			create Result.make_shared (c_popup_menu (c_pointer))
		end

	current_pos: INTEGER_32 assign set_current_pos
		do
			Result := c_current_pos (c_pointer)
		end

	selection_bound: INTEGER_32 assign set_selection_bound
		do
			Result := c_selection_bound (c_pointer)
		end

	cached_layout: CE_POINTER [ANY] assign set_cached_layout
		do
			create Result.make_shared (c_cached_layout (c_pointer))
		end

	cache_includes_preedit: NATURAL_32 assign set_cache_includes_preedit
		do
			Result := c_cache_includes_preedit (c_pointer)
		end

	need_im_reset: NATURAL_32 assign set_need_im_reset
		do
			Result := c_need_im_reset (c_pointer)
		end

	has_frame: NATURAL_32 assign set_has_frame
		do
			Result := c_has_frame (c_pointer)
		end

	activates_default: NATURAL_32 assign set_activates_default
		do
			Result := c_activates_default (c_pointer)
		end

	cursor_visible: NATURAL_32 assign set_cursor_visible
		do
			Result := c_cursor_visible (c_pointer)
		end

	in_click: NATURAL_32 assign set_in_click
		do
			Result := c_in_click (c_pointer)
		end

	is_cell_renderer: NATURAL_32 assign set_is_cell_renderer
		do
			Result := c_is_cell_renderer (c_pointer)
		end

	editing_canceled: NATURAL_32 assign set_editing_canceled
		do
			Result := c_editing_canceled (c_pointer)
		end

	mouse_cursor_obscured: NATURAL_32 assign set_mouse_cursor_obscured
		do
			Result := c_mouse_cursor_obscured (c_pointer)
		end

	select_words: NATURAL_32 assign set_select_words
		do
			Result := c_select_words (c_pointer)
		end

	select_lines: NATURAL_32 assign set_select_lines
		do
			Result := c_select_lines (c_pointer)
		end

	resolved_dir: NATURAL_32 assign set_resolved_dir
		do
			Result := c_resolved_dir (c_pointer)
		end

	truncate_multiline: NATURAL_32 assign set_truncate_multiline
		do
			Result := c_truncate_multiline (c_pointer)
		end

	button: NATURAL_32 assign set_button
		do
			Result := c_button (c_pointer)
		end

	blink_timeout: NATURAL_32 assign set_blink_timeout
		do
			Result := c_blink_timeout (c_pointer)
		end

	recompute_idle: NATURAL_32 assign set_recompute_idle
		do
			Result := c_recompute_idle (c_pointer)
		end

	scroll_offset: INTEGER_32 assign set_scroll_offset
		do
			Result := c_scroll_offset (c_pointer)
		end

	ascent: INTEGER_32 assign set_ascent
		do
			Result := c_ascent (c_pointer)
		end

	descent: INTEGER_32 assign set_descent
		do
			Result := c_descent (c_pointer)
		end

	x_text_size: NATURAL_16 assign set_x_text_size
		do
			Result := c_x_text_size (c_pointer)
		end

	x_n_bytes: NATURAL_16 assign set_x_n_bytes
		do
			Result := c_x_n_bytes (c_pointer)
		end

	preedit_length: NATURAL_16 assign set_preedit_length
		do
			Result := c_preedit_length (c_pointer)
		end

	preedit_cursor: NATURAL_16 assign set_preedit_cursor
		do
			Result := c_preedit_cursor (c_pointer)
		end

	dnd_position: INTEGER_32 assign set_dnd_position
		do
			Result := c_dnd_position (c_pointer)
		end

	drag_start_x: INTEGER_32 assign set_drag_start_x
		do
			Result := c_drag_start_x (c_pointer)
		end

	drag_start_y: INTEGER_32 assign set_drag_start_y
		do
			Result := c_drag_start_y (c_pointer)
		end

	invisible_char: NATURAL_32 assign set_invisible_char
		do
			Result := c_invisible_char (c_pointer)
		end

	width_chars: INTEGER_32 assign set_width_chars
		do
			Result := c_width_chars (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_widget (a_widget: SD_GTKWIDGET)
		do
			widget.ce_gets (a_widget)
		end

	set_text (a_text: CE_POINTER [INTEGER_8])
		do
			c_set_text (c_pointer, a_text.c_pointer)
		end

	set_editable (a_editable: NATURAL_32)
		do
			c_set_editable (c_pointer, a_editable)
		end

	set_visible (a_visible: NATURAL_32)
		do
			c_set_visible (c_pointer, a_visible)
		end

	set_overwrite_mode (a_overwrite_mode: NATURAL_32)
		do
			c_set_overwrite_mode (c_pointer, a_overwrite_mode)
		end

	set_in_drag (a_in_drag: NATURAL_32)
		do
			c_set_in_drag (c_pointer, a_in_drag)
		end

	set_text_length (a_text_length: NATURAL_16)
		do
			c_set_text_length (c_pointer, a_text_length)
		end

	set_text_max_length (a_text_max_length: NATURAL_16)
		do
			c_set_text_max_length (c_pointer, a_text_max_length)
		end

	set_text_area (a_text_area: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_text_area (c_pointer, a_text_area.c_pointer)
		end

	set_im_context (a_im_context: CE_POINTER [SD_GTKIMCONTEXT])
		do
			c_set_im_context (c_pointer, a_im_context.c_pointer)
		end

	set_popup_menu (a_popup_menu: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_popup_menu (c_pointer, a_popup_menu.c_pointer)
		end

	set_current_pos (a_current_pos: INTEGER_32)
		do
			c_set_current_pos (c_pointer, a_current_pos)
		end

	set_selection_bound (a_selection_bound: INTEGER_32)
		do
			c_set_selection_bound (c_pointer, a_selection_bound)
		end

	set_cached_layout (a_cached_layout: CE_POINTER [ANY])
		do
			c_set_cached_layout (c_pointer, a_cached_layout.c_pointer)
		end

	set_cache_includes_preedit (a_cache_includes_preedit: NATURAL_32)
		do
			c_set_cache_includes_preedit (c_pointer, a_cache_includes_preedit)
		end

	set_need_im_reset (a_need_im_reset: NATURAL_32)
		do
			c_set_need_im_reset (c_pointer, a_need_im_reset)
		end

	set_has_frame (a_has_frame: NATURAL_32)
		do
			c_set_has_frame (c_pointer, a_has_frame)
		end

	set_activates_default (a_activates_default: NATURAL_32)
		do
			c_set_activates_default (c_pointer, a_activates_default)
		end

	set_cursor_visible (a_cursor_visible: NATURAL_32)
		do
			c_set_cursor_visible (c_pointer, a_cursor_visible)
		end

	set_in_click (a_in_click: NATURAL_32)
		do
			c_set_in_click (c_pointer, a_in_click)
		end

	set_is_cell_renderer (a_is_cell_renderer: NATURAL_32)
		do
			c_set_is_cell_renderer (c_pointer, a_is_cell_renderer)
		end

	set_editing_canceled (a_editing_canceled: NATURAL_32)
		do
			c_set_editing_canceled (c_pointer, a_editing_canceled)
		end

	set_mouse_cursor_obscured (a_mouse_cursor_obscured: NATURAL_32)
		do
			c_set_mouse_cursor_obscured (c_pointer, a_mouse_cursor_obscured)
		end

	set_select_words (a_select_words: NATURAL_32)
		do
			c_set_select_words (c_pointer, a_select_words)
		end

	set_select_lines (a_select_lines: NATURAL_32)
		do
			c_set_select_lines (c_pointer, a_select_lines)
		end

	set_resolved_dir (a_resolved_dir: NATURAL_32)
		do
			c_set_resolved_dir (c_pointer, a_resolved_dir)
		end

	set_truncate_multiline (a_truncate_multiline: NATURAL_32)
		do
			c_set_truncate_multiline (c_pointer, a_truncate_multiline)
		end

	set_button (a_button: NATURAL_32)
		do
			c_set_button (c_pointer, a_button)
		end

	set_blink_timeout (a_blink_timeout: NATURAL_32)
		do
			c_set_blink_timeout (c_pointer, a_blink_timeout)
		end

	set_recompute_idle (a_recompute_idle: NATURAL_32)
		do
			c_set_recompute_idle (c_pointer, a_recompute_idle)
		end

	set_scroll_offset (a_scroll_offset: INTEGER_32)
		do
			c_set_scroll_offset (c_pointer, a_scroll_offset)
		end

	set_ascent (a_ascent: INTEGER_32)
		do
			c_set_ascent (c_pointer, a_ascent)
		end

	set_descent (a_descent: INTEGER_32)
		do
			c_set_descent (c_pointer, a_descent)
		end

	set_x_text_size (a_x_text_size: NATURAL_16)
		do
			c_set_x_text_size (c_pointer, a_x_text_size)
		end

	set_x_n_bytes (a_x_n_bytes: NATURAL_16)
		do
			c_set_x_n_bytes (c_pointer, a_x_n_bytes)
		end

	set_preedit_length (a_preedit_length: NATURAL_16)
		do
			c_set_preedit_length (c_pointer, a_preedit_length)
		end

	set_preedit_cursor (a_preedit_cursor: NATURAL_16)
		do
			c_set_preedit_cursor (c_pointer, a_preedit_cursor)
		end

	set_dnd_position (a_dnd_position: INTEGER_32)
		do
			c_set_dnd_position (c_pointer, a_dnd_position)
		end

	set_drag_start_x (a_drag_start_x: INTEGER_32)
		do
			c_set_drag_start_x (c_pointer, a_drag_start_x)
		end

	set_drag_start_y (a_drag_start_y: INTEGER_32)
		do
			c_set_drag_start_y (c_pointer, a_drag_start_y)
		end

	set_invisible_char (a_invisible_char: NATURAL_32)
		do
			c_set_invisible_char (c_pointer, a_invisible_char)
		end

	set_width_chars (a_width_chars: INTEGER_32)
		do
			c_set_width_chars (c_pointer, a_width_chars)
		end

feature {NONE} -- C getters

	c_widget (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)&((struct _GtkEntry *)$tmp)->widget;"
		end

	c_text (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GtkEntry *)$tmp)->text;"
		end

	c_editable (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkEntry *)$tmp)->editable;"
		end

	c_visible (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkEntry *)$tmp)->visible;"
		end

	c_overwrite_mode (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkEntry *)$tmp)->overwrite_mode;"
		end

	c_in_drag (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkEntry *)$tmp)->in_drag;"
		end

	c_text_length (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GtkEntry *)$tmp)->text_length;"
		end

	c_text_max_length (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GtkEntry *)$tmp)->text_max_length;"
		end

	c_text_area (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GtkEntry *)$tmp)->text_area;"
		end

	c_im_context (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkIMContext *)((struct _GtkEntry *)$tmp)->im_context;"
		end

	c_popup_menu (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkEntry *)$tmp)->popup_menu;"
		end

	c_current_pos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkEntry *)$tmp)->current_pos;"
		end

	c_selection_bound (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkEntry *)$tmp)->selection_bound;"
		end

	c_cached_layout (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkEntry *)$tmp)->cached_layout;"
		end

	c_cache_includes_preedit (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkEntry *)$tmp)->cache_includes_preedit;"
		end

	c_need_im_reset (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkEntry *)$tmp)->need_im_reset;"
		end

	c_has_frame (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkEntry *)$tmp)->has_frame;"
		end

	c_activates_default (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkEntry *)$tmp)->activates_default;"
		end

	c_cursor_visible (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkEntry *)$tmp)->cursor_visible;"
		end

	c_in_click (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkEntry *)$tmp)->in_click;"
		end

	c_is_cell_renderer (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkEntry *)$tmp)->is_cell_renderer;"
		end

	c_editing_canceled (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkEntry *)$tmp)->editing_canceled;"
		end

	c_mouse_cursor_obscured (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkEntry *)$tmp)->mouse_cursor_obscured;"
		end

	c_select_words (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkEntry *)$tmp)->select_words;"
		end

	c_select_lines (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkEntry *)$tmp)->select_lines;"
		end

	c_resolved_dir (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkEntry *)$tmp)->resolved_dir;"
		end

	c_truncate_multiline (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkEntry *)$tmp)->truncate_multiline;"
		end

	c_button (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkEntry *)$tmp)->button;"
		end

	c_blink_timeout (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkEntry *)$tmp)->blink_timeout;"
		end

	c_recompute_idle (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkEntry *)$tmp)->recompute_idle;"
		end

	c_scroll_offset (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkEntry *)$tmp)->scroll_offset;"
		end

	c_ascent (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkEntry *)$tmp)->ascent;"
		end

	c_descent (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkEntry *)$tmp)->descent;"
		end

	c_x_text_size (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GtkEntry *)$tmp)->x_text_size;"
		end

	c_x_n_bytes (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GtkEntry *)$tmp)->x_n_bytes;"
		end

	c_preedit_length (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GtkEntry *)$tmp)->preedit_length;"
		end

	c_preedit_cursor (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GtkEntry *)$tmp)->preedit_cursor;"
		end

	c_dnd_position (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkEntry *)$tmp)->dnd_position;"
		end

	c_drag_start_x (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkEntry *)$tmp)->drag_start_x;"
		end

	c_drag_start_y (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkEntry *)$tmp)->drag_start_y;"
		end

	c_invisible_char (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkEntry *)$tmp)->invisible_char;"
		end

	c_width_chars (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkEntry *)$tmp)->width_chars;"
		end

feature {NONE} -- C setters

	c_set_text (tmp: POINTER; a_text: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->text = (char *)$a_text;"
		end

	c_set_editable (tmp: POINTER; a_editable: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->editable = $a_editable;"
		end

	c_set_visible (tmp: POINTER; a_visible: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->visible = $a_visible;"
		end

	c_set_overwrite_mode (tmp: POINTER; a_overwrite_mode: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->overwrite_mode = $a_overwrite_mode;"
		end

	c_set_in_drag (tmp: POINTER; a_in_drag: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->in_drag = $a_in_drag;"
		end

	c_set_text_length (tmp: POINTER; a_text_length: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->text_length = $a_text_length;"
		end

	c_set_text_max_length (tmp: POINTER; a_text_max_length: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->text_max_length = $a_text_max_length;"
		end

	c_set_text_area (tmp: POINTER; a_text_area: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->text_area = (struct _GdkDrawable *)$a_text_area;"
		end

	c_set_im_context (tmp: POINTER; a_im_context: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->im_context = (struct _GtkIMContext *)$a_im_context;"
		end

	c_set_popup_menu (tmp: POINTER; a_popup_menu: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->popup_menu = (struct _GtkWidget *)$a_popup_menu;"
		end

	c_set_current_pos (tmp: POINTER; a_current_pos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->current_pos = $a_current_pos;"
		end

	c_set_selection_bound (tmp: POINTER; a_selection_bound: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->selection_bound = $a_selection_bound;"
		end

	c_set_cached_layout (tmp: POINTER; a_cached_layout: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->cached_layout = (void *)$a_cached_layout;"
		end

	c_set_cache_includes_preedit (tmp: POINTER; a_cache_includes_preedit: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->cache_includes_preedit = $a_cache_includes_preedit;"
		end

	c_set_need_im_reset (tmp: POINTER; a_need_im_reset: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->need_im_reset = $a_need_im_reset;"
		end

	c_set_has_frame (tmp: POINTER; a_has_frame: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->has_frame = $a_has_frame;"
		end

	c_set_activates_default (tmp: POINTER; a_activates_default: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->activates_default = $a_activates_default;"
		end

	c_set_cursor_visible (tmp: POINTER; a_cursor_visible: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->cursor_visible = $a_cursor_visible;"
		end

	c_set_in_click (tmp: POINTER; a_in_click: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->in_click = $a_in_click;"
		end

	c_set_is_cell_renderer (tmp: POINTER; a_is_cell_renderer: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->is_cell_renderer = $a_is_cell_renderer;"
		end

	c_set_editing_canceled (tmp: POINTER; a_editing_canceled: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->editing_canceled = $a_editing_canceled;"
		end

	c_set_mouse_cursor_obscured (tmp: POINTER; a_mouse_cursor_obscured: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->mouse_cursor_obscured = $a_mouse_cursor_obscured;"
		end

	c_set_select_words (tmp: POINTER; a_select_words: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->select_words = $a_select_words;"
		end

	c_set_select_lines (tmp: POINTER; a_select_lines: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->select_lines = $a_select_lines;"
		end

	c_set_resolved_dir (tmp: POINTER; a_resolved_dir: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->resolved_dir = $a_resolved_dir;"
		end

	c_set_truncate_multiline (tmp: POINTER; a_truncate_multiline: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->truncate_multiline = $a_truncate_multiline;"
		end

	c_set_button (tmp: POINTER; a_button: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->button = $a_button;"
		end

	c_set_blink_timeout (tmp: POINTER; a_blink_timeout: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->blink_timeout = $a_blink_timeout;"
		end

	c_set_recompute_idle (tmp: POINTER; a_recompute_idle: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->recompute_idle = $a_recompute_idle;"
		end

	c_set_scroll_offset (tmp: POINTER; a_scroll_offset: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->scroll_offset = $a_scroll_offset;"
		end

	c_set_ascent (tmp: POINTER; a_ascent: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->ascent = $a_ascent;"
		end

	c_set_descent (tmp: POINTER; a_descent: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->descent = $a_descent;"
		end

	c_set_x_text_size (tmp: POINTER; a_x_text_size: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->x_text_size = $a_x_text_size;"
		end

	c_set_x_n_bytes (tmp: POINTER; a_x_n_bytes: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->x_n_bytes = $a_x_n_bytes;"
		end

	c_set_preedit_length (tmp: POINTER; a_preedit_length: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->preedit_length = $a_preedit_length;"
		end

	c_set_preedit_cursor (tmp: POINTER; a_preedit_cursor: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->preedit_cursor = $a_preedit_cursor;"
		end

	c_set_dnd_position (tmp: POINTER; a_dnd_position: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->dnd_position = $a_dnd_position;"
		end

	c_set_drag_start_x (tmp: POINTER; a_drag_start_x: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->drag_start_x = $a_drag_start_x;"
		end

	c_set_drag_start_y (tmp: POINTER; a_drag_start_y: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->drag_start_y = $a_drag_start_y;"
		end

	c_set_invisible_char (tmp: POINTER; a_invisible_char: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->invisible_char = $a_invisible_char;"
		end

	c_set_width_chars (tmp: POINTER; a_width_chars: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkEntry *)$tmp)->width_chars = $a_width_chars;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkEntry);"
		end

end
