class
	SD_GTKIMAGE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	misc: SD_GTKMISC assign set_misc
		do
			create Result.make_shared (c_misc (c_pointer))
		end

	storage_type: INTEGER_32 assign set_storage_type
		do
			Result := c_storage_type (c_pointer)
		end

	data: SD_DATA4 assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	mask: CE_POINTER [SD_GDKDRAWABLE] assign set_mask
		do
			create Result.make_shared (c_mask (c_pointer))
		end

	icon_size: INTEGER_32 assign set_icon_size
		do
			Result := c_icon_size (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_misc (a_misc: SD_GTKMISC)
		do
			misc.ce_gets (a_misc)
		end

	set_storage_type (a_storage_type: INTEGER_32)
		do
			c_set_storage_type (c_pointer, a_storage_type)
		end

	set_data (a_data: SD_DATA4)
		do
			data.ce_gets (a_data)
		end

	set_mask (a_mask: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_mask (c_pointer, a_mask.c_pointer)
		end

	set_icon_size (a_icon_size: INTEGER_32)
		do
			c_set_icon_size (c_pointer, a_icon_size)
		end

feature {NONE} -- C getters

	c_misc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkMisc *)&((struct _GtkImage *)$tmp)->misc;"
		end

	c_storage_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkImage *)$tmp)->storage_type;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_data_461 *)&((struct _GtkImage *)$tmp)->data;"
		end

	c_mask (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GtkImage *)$tmp)->mask;"
		end

	c_icon_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkImage *)$tmp)->icon_size;"
		end

feature {NONE} -- C setters

	c_set_storage_type (tmp: POINTER; a_storage_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkImage *)$tmp)->storage_type = $a_storage_type;"
		end

	c_set_mask (tmp: POINTER; a_mask: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkImage *)$tmp)->mask = (struct _GdkDrawable *)$a_mask;"
		end

	c_set_icon_size (tmp: POINTER; a_icon_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkImage *)$tmp)->icon_size = $a_icon_size;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkImage);"
		end

end
