class
	SD_GTKIMAGEICONNAMEDATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	icon_name: CE_POINTER [INTEGER_8] assign set_icon_name
		do
			create Result.make_shared (c_icon_name (c_pointer))
		end

	pixbuf: CE_POINTER [ANY] assign set_pixbuf
		do
			create Result.make_shared (c_pixbuf (c_pointer))
		end

	theme_change_id: NATURAL_32 assign set_theme_change_id
		do
			Result := c_theme_change_id (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_icon_name (a_icon_name: CE_POINTER [INTEGER_8])
		do
			c_set_icon_name (c_pointer, a_icon_name.c_pointer)
		end

	set_pixbuf (a_pixbuf: CE_POINTER [ANY])
		do
			c_set_pixbuf (c_pointer, a_pixbuf.c_pointer)
		end

	set_theme_change_id (a_theme_change_id: NATURAL_32)
		do
			c_set_theme_change_id (c_pointer, a_theme_change_id)
		end

feature {NONE} -- C getters

	c_icon_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GtkImageIconNameData *)$tmp)->icon_name;"
		end

	c_pixbuf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkImageIconNameData *)$tmp)->pixbuf;"
		end

	c_theme_change_id (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkImageIconNameData *)$tmp)->theme_change_id;"
		end

feature {NONE} -- C setters

	c_set_icon_name (tmp: POINTER; a_icon_name: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkImageIconNameData *)$tmp)->icon_name = (char *)$a_icon_name;"
		end

	c_set_pixbuf (tmp: POINTER; a_pixbuf: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkImageIconNameData *)$tmp)->pixbuf = (void *)$a_pixbuf;"
		end

	c_set_theme_change_id (tmp: POINTER; a_theme_change_id: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkImageIconNameData *)$tmp)->theme_change_id = $a_theme_change_id;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkImageIconNameData);"
		end

end
