class
	SD_GTKIMAGEPIXBUFDATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	pixbuf: CE_POINTER [ANY] assign set_pixbuf
		do
			create Result.make_shared (c_pixbuf (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_pixbuf (a_pixbuf: CE_POINTER [ANY])
		do
			c_set_pixbuf (c_pointer, a_pixbuf.c_pointer)
		end

feature {NONE} -- C getters

	c_pixbuf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkImagePixbufData *)$tmp)->pixbuf;"
		end

feature {NONE} -- C setters

	c_set_pixbuf (tmp: POINTER; a_pixbuf: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkImagePixbufData *)$tmp)->pixbuf = (void *)$a_pixbuf;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkImagePixbufData);"
		end

end
