class
	SD_GTKIMAGESTOCKDATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	stock_id: CE_POINTER [INTEGER_8] assign set_stock_id
		do
			create Result.make_shared (c_stock_id (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_stock_id (a_stock_id: CE_POINTER [INTEGER_8])
		do
			c_set_stock_id (c_pointer, a_stock_id.c_pointer)
		end

feature {NONE} -- C getters

	c_stock_id (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GtkImageStockData *)$tmp)->stock_id;"
		end

feature {NONE} -- C setters

	c_set_stock_id (tmp: POINTER; a_stock_id: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkImageStockData *)$tmp)->stock_id = (char *)$a_stock_id;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkImageStockData);"
		end

end
