class
	SD_GTKIMMULTICONTEXT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	object: SD_GTKIMCONTEXT assign set_object
		do
			create Result.make_shared (c_object (c_pointer))
		end

	slave: CE_POINTER [SD_GTKIMCONTEXT] assign set_slave
		do
			create Result.make_shared (c_slave (c_pointer))
		end

	priv: CE_POINTER [ANY] assign set_priv
		do
			create Result.make_shared (c_priv (c_pointer))
		end

	context_id: CE_POINTER [INTEGER_8] assign set_context_id
		do
			create Result.make_shared (c_context_id (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_object (a_object: SD_GTKIMCONTEXT)
		do
			object.ce_gets (a_object)
		end

	set_slave (a_slave: CE_POINTER [SD_GTKIMCONTEXT])
		do
			c_set_slave (c_pointer, a_slave.c_pointer)
		end

	set_priv (a_priv: CE_POINTER [ANY])
		do
			c_set_priv (c_pointer, a_priv.c_pointer)
		end

	set_context_id (a_context_id: CE_POINTER [INTEGER_8])
		do
			c_set_context_id (c_pointer, a_context_id.c_pointer)
		end

feature {NONE} -- C getters

	c_object (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkIMContext *)&((struct _GtkIMMulticontext *)$tmp)->object;"
		end

	c_slave (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkIMContext *)((struct _GtkIMMulticontext *)$tmp)->slave;"
		end

	c_priv (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkIMMulticontext *)$tmp)->priv;"
		end

	c_context_id (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GtkIMMulticontext *)$tmp)->context_id;"
		end

feature {NONE} -- C setters

	c_set_slave (tmp: POINTER; a_slave: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkIMMulticontext *)$tmp)->slave = (struct _GtkIMContext *)$a_slave;"
		end

	c_set_priv (tmp: POINTER; a_priv: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkIMMulticontext *)$tmp)->priv = (void *)$a_priv;"
		end

	c_set_context_id (tmp: POINTER; a_context_id: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkIMMulticontext *)$tmp)->context_id = (char *)$a_context_id;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkIMMulticontext);"
		end

end
