class
	SD_GTKITEM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	bin: SD_GTKBIN assign set_bin
		do
			create Result.make_shared (c_bin (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_bin (a_bin: SD_GTKBIN)
		do
			bin.ce_gets (a_bin)
		end

feature {NONE} -- C getters

	c_bin (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkBin *)&((struct _GtkItem *)$tmp)->bin;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkItem);"
		end

end
