class
	SD_GTKMENU

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	menu_shell: SD_GTKMENUSHELL assign set_menu_shell
		do
			create Result.make_shared (c_menu_shell (c_pointer))
		end

	parent_menu_item: CE_POINTER [SD_GTKWIDGET] assign set_parent_menu_item
		do
			create Result.make_shared (c_parent_menu_item (c_pointer))
		end

	old_active_menu_item: CE_POINTER [SD_GTKWIDGET] assign set_old_active_menu_item
		do
			create Result.make_shared (c_old_active_menu_item (c_pointer))
		end

	accel_group: CE_POINTER [SD_GTKACCELGROUP] assign set_accel_group
		do
			create Result.make_shared (c_accel_group (c_pointer))
		end

	accel_path: CE_POINTER [INTEGER_8] assign set_accel_path
		do
			create Result.make_shared (c_accel_path (c_pointer))
		end

	position_func: CE_ROUTINE assign set_position_func
		do
			create Result.make_shared (c_position_func (c_pointer))
		end

	position_func_data: CE_POINTER [ANY] assign set_position_func_data
		do
			create Result.make_shared (c_position_func_data (c_pointer))
		end

	toggle_size: NATURAL_32 assign set_toggle_size
		do
			Result := c_toggle_size (c_pointer)
		end

	toplevel: CE_POINTER [SD_GTKWIDGET] assign set_toplevel
		do
			create Result.make_shared (c_toplevel (c_pointer))
		end

	tearoff_window: CE_POINTER [SD_GTKWIDGET] assign set_tearoff_window
		do
			create Result.make_shared (c_tearoff_window (c_pointer))
		end

	tearoff_hbox: CE_POINTER [SD_GTKWIDGET] assign set_tearoff_hbox
		do
			create Result.make_shared (c_tearoff_hbox (c_pointer))
		end

	tearoff_scrollbar: CE_POINTER [SD_GTKWIDGET] assign set_tearoff_scrollbar
		do
			create Result.make_shared (c_tearoff_scrollbar (c_pointer))
		end

	tearoff_adjustment: CE_POINTER [SD_GTKADJUSTMENT] assign set_tearoff_adjustment
		do
			create Result.make_shared (c_tearoff_adjustment (c_pointer))
		end

	view_window: CE_POINTER [SD_GDKDRAWABLE] assign set_view_window
		do
			create Result.make_shared (c_view_window (c_pointer))
		end

	bin_window: CE_POINTER [SD_GDKDRAWABLE] assign set_bin_window
		do
			create Result.make_shared (c_bin_window (c_pointer))
		end

	scroll_offset: INTEGER_32 assign set_scroll_offset
		do
			Result := c_scroll_offset (c_pointer)
		end

	saved_scroll_offset: INTEGER_32 assign set_saved_scroll_offset
		do
			Result := c_saved_scroll_offset (c_pointer)
		end

	scroll_step: INTEGER_32 assign set_scroll_step
		do
			Result := c_scroll_step (c_pointer)
		end

	timeout_id: NATURAL_32 assign set_timeout_id
		do
			Result := c_timeout_id (c_pointer)
		end

	navigation_region: CE_POINTER [ANY] assign set_navigation_region
		do
			create Result.make_shared (c_navigation_region (c_pointer))
		end

	navigation_timeout: NATURAL_32 assign set_navigation_timeout
		do
			Result := c_navigation_timeout (c_pointer)
		end

	needs_destruction_ref_count: NATURAL_32 assign set_needs_destruction_ref_count
		do
			Result := c_needs_destruction_ref_count (c_pointer)
		end

	torn_off: NATURAL_32 assign set_torn_off
		do
			Result := c_torn_off (c_pointer)
		end

	tearoff_active: NATURAL_32 assign set_tearoff_active
		do
			Result := c_tearoff_active (c_pointer)
		end

	scroll_fast: NATURAL_32 assign set_scroll_fast
		do
			Result := c_scroll_fast (c_pointer)
		end

	upper_arrow_visible: NATURAL_32 assign set_upper_arrow_visible
		do
			Result := c_upper_arrow_visible (c_pointer)
		end

	lower_arrow_visible: NATURAL_32 assign set_lower_arrow_visible
		do
			Result := c_lower_arrow_visible (c_pointer)
		end

	upper_arrow_prelight: NATURAL_32 assign set_upper_arrow_prelight
		do
			Result := c_upper_arrow_prelight (c_pointer)
		end

	lower_arrow_prelight: NATURAL_32 assign set_lower_arrow_prelight
		do
			Result := c_lower_arrow_prelight (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_menu_shell (a_menu_shell: SD_GTKMENUSHELL)
		do
			menu_shell.ce_gets (a_menu_shell)
		end

	set_parent_menu_item (a_parent_menu_item: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_parent_menu_item (c_pointer, a_parent_menu_item.c_pointer)
		end

	set_old_active_menu_item (a_old_active_menu_item: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_old_active_menu_item (c_pointer, a_old_active_menu_item.c_pointer)
		end

	set_accel_group (a_accel_group: CE_POINTER [SD_GTKACCELGROUP])
		do
			c_set_accel_group (c_pointer, a_accel_group.c_pointer)
		end

	set_accel_path (a_accel_path: CE_POINTER [INTEGER_8])
		do
			c_set_accel_path (c_pointer, a_accel_path.c_pointer)
		end

	set_position_func (a_position_func: CE_ROUTINE)
		do
			c_set_position_func (c_pointer, a_position_func.c_pointer)
		end

	set_position_func_data (a_position_func_data: CE_POINTER [ANY])
		do
			c_set_position_func_data (c_pointer, a_position_func_data.c_pointer)
		end

	set_toggle_size (a_toggle_size: NATURAL_32)
		do
			c_set_toggle_size (c_pointer, a_toggle_size)
		end

	set_toplevel (a_toplevel: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_toplevel (c_pointer, a_toplevel.c_pointer)
		end

	set_tearoff_window (a_tearoff_window: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_tearoff_window (c_pointer, a_tearoff_window.c_pointer)
		end

	set_tearoff_hbox (a_tearoff_hbox: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_tearoff_hbox (c_pointer, a_tearoff_hbox.c_pointer)
		end

	set_tearoff_scrollbar (a_tearoff_scrollbar: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_tearoff_scrollbar (c_pointer, a_tearoff_scrollbar.c_pointer)
		end

	set_tearoff_adjustment (a_tearoff_adjustment: CE_POINTER [SD_GTKADJUSTMENT])
		do
			c_set_tearoff_adjustment (c_pointer, a_tearoff_adjustment.c_pointer)
		end

	set_view_window (a_view_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_view_window (c_pointer, a_view_window.c_pointer)
		end

	set_bin_window (a_bin_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_bin_window (c_pointer, a_bin_window.c_pointer)
		end

	set_scroll_offset (a_scroll_offset: INTEGER_32)
		do
			c_set_scroll_offset (c_pointer, a_scroll_offset)
		end

	set_saved_scroll_offset (a_saved_scroll_offset: INTEGER_32)
		do
			c_set_saved_scroll_offset (c_pointer, a_saved_scroll_offset)
		end

	set_scroll_step (a_scroll_step: INTEGER_32)
		do
			c_set_scroll_step (c_pointer, a_scroll_step)
		end

	set_timeout_id (a_timeout_id: NATURAL_32)
		do
			c_set_timeout_id (c_pointer, a_timeout_id)
		end

	set_navigation_region (a_navigation_region: CE_POINTER [ANY])
		do
			c_set_navigation_region (c_pointer, a_navigation_region.c_pointer)
		end

	set_navigation_timeout (a_navigation_timeout: NATURAL_32)
		do
			c_set_navigation_timeout (c_pointer, a_navigation_timeout)
		end

	set_needs_destruction_ref_count (a_needs_destruction_ref_count: NATURAL_32)
		do
			c_set_needs_destruction_ref_count (c_pointer, a_needs_destruction_ref_count)
		end

	set_torn_off (a_torn_off: NATURAL_32)
		do
			c_set_torn_off (c_pointer, a_torn_off)
		end

	set_tearoff_active (a_tearoff_active: NATURAL_32)
		do
			c_set_tearoff_active (c_pointer, a_tearoff_active)
		end

	set_scroll_fast (a_scroll_fast: NATURAL_32)
		do
			c_set_scroll_fast (c_pointer, a_scroll_fast)
		end

	set_upper_arrow_visible (a_upper_arrow_visible: NATURAL_32)
		do
			c_set_upper_arrow_visible (c_pointer, a_upper_arrow_visible)
		end

	set_lower_arrow_visible (a_lower_arrow_visible: NATURAL_32)
		do
			c_set_lower_arrow_visible (c_pointer, a_lower_arrow_visible)
		end

	set_upper_arrow_prelight (a_upper_arrow_prelight: NATURAL_32)
		do
			c_set_upper_arrow_prelight (c_pointer, a_upper_arrow_prelight)
		end

	set_lower_arrow_prelight (a_lower_arrow_prelight: NATURAL_32)
		do
			c_set_lower_arrow_prelight (c_pointer, a_lower_arrow_prelight)
		end

feature {NONE} -- C getters

	c_menu_shell (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkMenuShell *)&((struct _GtkMenu *)$tmp)->menu_shell;"
		end

	c_parent_menu_item (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkMenu *)$tmp)->parent_menu_item;"
		end

	c_old_active_menu_item (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkMenu *)$tmp)->old_active_menu_item;"
		end

	c_accel_group (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkAccelGroup *)((struct _GtkMenu *)$tmp)->accel_group;"
		end

	c_accel_path (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GtkMenu *)$tmp)->accel_path;"
		end

	c_position_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _GtkMenu * menu, int * x, int * y, int * push_in, void * user_data))((struct _GtkMenu *)$tmp)->position_func;"
		end

	c_position_func_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkMenu *)$tmp)->position_func_data;"
		end

	c_toggle_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenu *)$tmp)->toggle_size;"
		end

	c_toplevel (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkMenu *)$tmp)->toplevel;"
		end

	c_tearoff_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkMenu *)$tmp)->tearoff_window;"
		end

	c_tearoff_hbox (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkMenu *)$tmp)->tearoff_hbox;"
		end

	c_tearoff_scrollbar (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkMenu *)$tmp)->tearoff_scrollbar;"
		end

	c_tearoff_adjustment (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkAdjustment *)((struct _GtkMenu *)$tmp)->tearoff_adjustment;"
		end

	c_view_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GtkMenu *)$tmp)->view_window;"
		end

	c_bin_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GtkMenu *)$tmp)->bin_window;"
		end

	c_scroll_offset (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkMenu *)$tmp)->scroll_offset;"
		end

	c_saved_scroll_offset (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkMenu *)$tmp)->saved_scroll_offset;"
		end

	c_scroll_step (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkMenu *)$tmp)->scroll_step;"
		end

	c_timeout_id (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenu *)$tmp)->timeout_id;"
		end

	c_navigation_region (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkMenu *)$tmp)->navigation_region;"
		end

	c_navigation_timeout (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenu *)$tmp)->navigation_timeout;"
		end

	c_needs_destruction_ref_count (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenu *)$tmp)->needs_destruction_ref_count;"
		end

	c_torn_off (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenu *)$tmp)->torn_off;"
		end

	c_tearoff_active (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenu *)$tmp)->tearoff_active;"
		end

	c_scroll_fast (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenu *)$tmp)->scroll_fast;"
		end

	c_upper_arrow_visible (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenu *)$tmp)->upper_arrow_visible;"
		end

	c_lower_arrow_visible (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenu *)$tmp)->lower_arrow_visible;"
		end

	c_upper_arrow_prelight (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenu *)$tmp)->upper_arrow_prelight;"
		end

	c_lower_arrow_prelight (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkMenu *)$tmp)->lower_arrow_prelight;"
		end

feature {NONE} -- C setters

	c_set_parent_menu_item (tmp: POINTER; a_parent_menu_item: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->parent_menu_item = (struct _GtkWidget *)$a_parent_menu_item;"
		end

	c_set_old_active_menu_item (tmp: POINTER; a_old_active_menu_item: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->old_active_menu_item = (struct _GtkWidget *)$a_old_active_menu_item;"
		end

	c_set_accel_group (tmp: POINTER; a_accel_group: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->accel_group = (struct _GtkAccelGroup *)$a_accel_group;"
		end

	c_set_accel_path (tmp: POINTER; a_accel_path: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->accel_path = (char *)$a_accel_path;"
		end

	c_set_position_func (tmp: POINTER; a_position_func: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->position_func = (void( *)(struct _GtkMenu * menu, int * x, int * y, int * push_in, void * user_data))$a_position_func;"
		end

	c_set_position_func_data (tmp: POINTER; a_position_func_data: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->position_func_data = (void *)$a_position_func_data;"
		end

	c_set_toggle_size (tmp: POINTER; a_toggle_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->toggle_size = $a_toggle_size;"
		end

	c_set_toplevel (tmp: POINTER; a_toplevel: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->toplevel = (struct _GtkWidget *)$a_toplevel;"
		end

	c_set_tearoff_window (tmp: POINTER; a_tearoff_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->tearoff_window = (struct _GtkWidget *)$a_tearoff_window;"
		end

	c_set_tearoff_hbox (tmp: POINTER; a_tearoff_hbox: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->tearoff_hbox = (struct _GtkWidget *)$a_tearoff_hbox;"
		end

	c_set_tearoff_scrollbar (tmp: POINTER; a_tearoff_scrollbar: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->tearoff_scrollbar = (struct _GtkWidget *)$a_tearoff_scrollbar;"
		end

	c_set_tearoff_adjustment (tmp: POINTER; a_tearoff_adjustment: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->tearoff_adjustment = (struct _GtkAdjustment *)$a_tearoff_adjustment;"
		end

	c_set_view_window (tmp: POINTER; a_view_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->view_window = (struct _GdkDrawable *)$a_view_window;"
		end

	c_set_bin_window (tmp: POINTER; a_bin_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->bin_window = (struct _GdkDrawable *)$a_bin_window;"
		end

	c_set_scroll_offset (tmp: POINTER; a_scroll_offset: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->scroll_offset = $a_scroll_offset;"
		end

	c_set_saved_scroll_offset (tmp: POINTER; a_saved_scroll_offset: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->saved_scroll_offset = $a_saved_scroll_offset;"
		end

	c_set_scroll_step (tmp: POINTER; a_scroll_step: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->scroll_step = $a_scroll_step;"
		end

	c_set_timeout_id (tmp: POINTER; a_timeout_id: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->timeout_id = $a_timeout_id;"
		end

	c_set_navigation_region (tmp: POINTER; a_navigation_region: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->navigation_region = (void *)$a_navigation_region;"
		end

	c_set_navigation_timeout (tmp: POINTER; a_navigation_timeout: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->navigation_timeout = $a_navigation_timeout;"
		end

	c_set_needs_destruction_ref_count (tmp: POINTER; a_needs_destruction_ref_count: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->needs_destruction_ref_count = $a_needs_destruction_ref_count;"
		end

	c_set_torn_off (tmp: POINTER; a_torn_off: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->torn_off = $a_torn_off;"
		end

	c_set_tearoff_active (tmp: POINTER; a_tearoff_active: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->tearoff_active = $a_tearoff_active;"
		end

	c_set_scroll_fast (tmp: POINTER; a_scroll_fast: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->scroll_fast = $a_scroll_fast;"
		end

	c_set_upper_arrow_visible (tmp: POINTER; a_upper_arrow_visible: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->upper_arrow_visible = $a_upper_arrow_visible;"
		end

	c_set_lower_arrow_visible (tmp: POINTER; a_lower_arrow_visible: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->lower_arrow_visible = $a_lower_arrow_visible;"
		end

	c_set_upper_arrow_prelight (tmp: POINTER; a_upper_arrow_prelight: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->upper_arrow_prelight = $a_upper_arrow_prelight;"
		end

	c_set_lower_arrow_prelight (tmp: POINTER; a_lower_arrow_prelight: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMenu *)$tmp)->lower_arrow_prelight = $a_lower_arrow_prelight;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkMenu);"
		end

end
