class
	SD_GTKRADIOBUTTON

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	check_button: SD_GTKCHECKBUTTON assign set_check_button
		do
			create Result.make_shared (c_check_button (c_pointer))
		end

	group: CE_POINTER [SD_GSLIST] assign set_group
		do
			create Result.make_shared (c_group (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_check_button (a_check_button: SD_GTKCHECKBUTTON)
		do
			check_button.ce_gets (a_check_button)
		end

	set_group (a_group: CE_POINTER [SD_GSLIST])
		do
			c_set_group (c_pointer, a_group.c_pointer)
		end

feature {NONE} -- C getters

	c_check_button (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkCheckButton *)&((struct _GtkRadioButton *)$tmp)->check_button;"
		end

	c_group (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GSList *)((struct _GtkRadioButton *)$tmp)->group;"
		end

feature {NONE} -- C setters

	c_set_group (tmp: POINTER; a_group: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkRadioButton *)$tmp)->group = (struct _GSList *)$a_group;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkRadioButton);"
		end

end
