class
	SD_GTKSTYLE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	parent_instance: SD_GOBJECT assign set_parent_instance
		do
			create Result.make_shared (c_parent_instance (c_pointer))
		end

	fg: CE_ARRAY [SD_GDKCOLOR]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_fg (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	bg: CE_ARRAY [SD_GDKCOLOR]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_bg (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	light: CE_ARRAY [SD_GDKCOLOR]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_light (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	dark: CE_ARRAY [SD_GDKCOLOR]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_dark (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	mid: CE_ARRAY [SD_GDKCOLOR]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_mid (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	text: CE_ARRAY [SD_GDKCOLOR]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_text (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	base: CE_ARRAY [SD_GDKCOLOR]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_base (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	text_aa: CE_ARRAY [SD_GDKCOLOR]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_text_aa (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	black: SD_GDKCOLOR assign set_black
		do
			create Result.make_shared (c_black (c_pointer))
		end

	white: SD_GDKCOLOR assign set_white
		do
			create Result.make_shared (c_white (c_pointer))
		end

	font_desc: CE_POINTER [ANY] assign set_font_desc
		do
			create Result.make_shared (c_font_desc (c_pointer))
		end

	xthickness: INTEGER_32 assign set_xthickness
		do
			Result := c_xthickness (c_pointer)
		end

	ythickness: INTEGER_32 assign set_ythickness
		do
			Result := c_ythickness (c_pointer)
		end

	fg_gc: CE_ARRAY [CE_POINTER [SD_GDKGC]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_fg_gc (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	bg_gc: CE_ARRAY [CE_POINTER [SD_GDKGC]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_bg_gc (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	light_gc: CE_ARRAY [CE_POINTER [SD_GDKGC]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_light_gc (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	dark_gc: CE_ARRAY [CE_POINTER [SD_GDKGC]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_dark_gc (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	mid_gc: CE_ARRAY [CE_POINTER [SD_GDKGC]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_mid_gc (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	text_gc: CE_ARRAY [CE_POINTER [SD_GDKGC]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_text_gc (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	base_gc: CE_ARRAY [CE_POINTER [SD_GDKGC]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_base_gc (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	text_aa_gc: CE_ARRAY [CE_POINTER [SD_GDKGC]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_text_aa_gc (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	black_gc: CE_POINTER [SD_GDKGC] assign set_black_gc
		do
			create Result.make_shared (c_black_gc (c_pointer))
		end

	white_gc: CE_POINTER [SD_GDKGC] assign set_white_gc
		do
			create Result.make_shared (c_white_gc (c_pointer))
		end

	bg_pixmap: CE_ARRAY [CE_POINTER [SD_GDKDRAWABLE]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_bg_pixmap (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	attach_count: INTEGER_32 assign set_attach_count
		do
			Result := c_attach_count (c_pointer)
		end

	depth: INTEGER_32 assign set_depth
		do
			Result := c_depth (c_pointer)
		end

	colormap: CE_POINTER [SD_GDKCOLORMAP] assign set_colormap
		do
			create Result.make_shared (c_colormap (c_pointer))
		end

	private_font: CE_POINTER [SD_GDKFONT] assign set_private_font
		do
			create Result.make_shared (c_private_font (c_pointer))
		end

	private_font_desc: CE_POINTER [ANY] assign set_private_font_desc
		do
			create Result.make_shared (c_private_font_desc (c_pointer))
		end

	rc_style: CE_POINTER [SD_GTKRCSTYLE] assign set_rc_style
		do
			create Result.make_shared (c_rc_style (c_pointer))
		end

	styles: CE_POINTER [SD_GSLIST] assign set_styles
		do
			create Result.make_shared (c_styles (c_pointer))
		end

	property_cache: CE_POINTER [SD_GARRAY] assign set_property_cache
		do
			create Result.make_shared (c_property_cache (c_pointer))
		end

	icon_factories: CE_POINTER [SD_GSLIST] assign set_icon_factories
		do
			create Result.make_shared (c_icon_factories (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_parent_instance (a_parent_instance: SD_GOBJECT)
		do
			parent_instance.ce_gets (a_parent_instance)
		end

	set_black (a_black: SD_GDKCOLOR)
		do
			black.ce_gets (a_black)
		end

	set_white (a_white: SD_GDKCOLOR)
		do
			white.ce_gets (a_white)
		end

	set_font_desc (a_font_desc: CE_POINTER [ANY])
		do
			c_set_font_desc (c_pointer, a_font_desc.c_pointer)
		end

	set_xthickness (a_xthickness: INTEGER_32)
		do
			c_set_xthickness (c_pointer, a_xthickness)
		end

	set_ythickness (a_ythickness: INTEGER_32)
		do
			c_set_ythickness (c_pointer, a_ythickness)
		end

	set_black_gc (a_black_gc: CE_POINTER [SD_GDKGC])
		do
			c_set_black_gc (c_pointer, a_black_gc.c_pointer)
		end

	set_white_gc (a_white_gc: CE_POINTER [SD_GDKGC])
		do
			c_set_white_gc (c_pointer, a_white_gc.c_pointer)
		end

	set_attach_count (a_attach_count: INTEGER_32)
		do
			c_set_attach_count (c_pointer, a_attach_count)
		end

	set_depth (a_depth: INTEGER_32)
		do
			c_set_depth (c_pointer, a_depth)
		end

	set_colormap (a_colormap: CE_POINTER [SD_GDKCOLORMAP])
		do
			c_set_colormap (c_pointer, a_colormap.c_pointer)
		end

	set_private_font (a_private_font: CE_POINTER [SD_GDKFONT])
		do
			c_set_private_font (c_pointer, a_private_font.c_pointer)
		end

	set_private_font_desc (a_private_font_desc: CE_POINTER [ANY])
		do
			c_set_private_font_desc (c_pointer, a_private_font_desc.c_pointer)
		end

	set_rc_style (a_rc_style: CE_POINTER [SD_GTKRCSTYLE])
		do
			c_set_rc_style (c_pointer, a_rc_style.c_pointer)
		end

	set_styles (a_styles: CE_POINTER [SD_GSLIST])
		do
			c_set_styles (c_pointer, a_styles.c_pointer)
		end

	set_property_cache (a_property_cache: CE_POINTER [SD_GARRAY])
		do
			c_set_property_cache (c_pointer, a_property_cache.c_pointer)
		end

	set_icon_factories (a_icon_factories: CE_POINTER [SD_GSLIST])
		do
			c_set_icon_factories (c_pointer, a_icon_factories.c_pointer)
		end

feature {NONE} -- C getters

	c_parent_instance (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GObject *)&((struct _GtkStyle *)$tmp)->parent_instance;"
		end

	c_fg (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GtkStyle *tmp = (struct _GtkStyle *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->fg) / sizeof(tmp->fg[0]);
				return tmp->fg;
			]"
		end

	c_bg (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GtkStyle *tmp = (struct _GtkStyle *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->bg) / sizeof(tmp->bg[0]);
				return tmp->bg;
			]"
		end

	c_light (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GtkStyle *tmp = (struct _GtkStyle *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->light) / sizeof(tmp->light[0]);
				return tmp->light;
			]"
		end

	c_dark (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GtkStyle *tmp = (struct _GtkStyle *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->dark) / sizeof(tmp->dark[0]);
				return tmp->dark;
			]"
		end

	c_mid (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GtkStyle *tmp = (struct _GtkStyle *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->mid) / sizeof(tmp->mid[0]);
				return tmp->mid;
			]"
		end

	c_text (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GtkStyle *tmp = (struct _GtkStyle *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->text) / sizeof(tmp->text[0]);
				return tmp->text;
			]"
		end

	c_base (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GtkStyle *tmp = (struct _GtkStyle *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->base) / sizeof(tmp->base[0]);
				return tmp->base;
			]"
		end

	c_text_aa (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GtkStyle *tmp = (struct _GtkStyle *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->text_aa) / sizeof(tmp->text_aa[0]);
				return tmp->text_aa;
			]"
		end

	c_black (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkColor *)&((struct _GtkStyle *)$tmp)->black;"
		end

	c_white (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkColor *)&((struct _GtkStyle *)$tmp)->white;"
		end

	c_font_desc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkStyle *)$tmp)->font_desc;"
		end

	c_xthickness (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkStyle *)$tmp)->xthickness;"
		end

	c_ythickness (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkStyle *)$tmp)->ythickness;"
		end

	c_fg_gc (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GtkStyle *tmp = (struct _GtkStyle *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->fg_gc) / sizeof(tmp->fg_gc[0]);
				return tmp->fg_gc;
			]"
		end

	c_bg_gc (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GtkStyle *tmp = (struct _GtkStyle *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->bg_gc) / sizeof(tmp->bg_gc[0]);
				return tmp->bg_gc;
			]"
		end

	c_light_gc (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GtkStyle *tmp = (struct _GtkStyle *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->light_gc) / sizeof(tmp->light_gc[0]);
				return tmp->light_gc;
			]"
		end

	c_dark_gc (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GtkStyle *tmp = (struct _GtkStyle *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->dark_gc) / sizeof(tmp->dark_gc[0]);
				return tmp->dark_gc;
			]"
		end

	c_mid_gc (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GtkStyle *tmp = (struct _GtkStyle *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->mid_gc) / sizeof(tmp->mid_gc[0]);
				return tmp->mid_gc;
			]"
		end

	c_text_gc (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GtkStyle *tmp = (struct _GtkStyle *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->text_gc) / sizeof(tmp->text_gc[0]);
				return tmp->text_gc;
			]"
		end

	c_base_gc (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GtkStyle *tmp = (struct _GtkStyle *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->base_gc) / sizeof(tmp->base_gc[0]);
				return tmp->base_gc;
			]"
		end

	c_text_aa_gc (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GtkStyle *tmp = (struct _GtkStyle *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->text_aa_gc) / sizeof(tmp->text_aa_gc[0]);
				return tmp->text_aa_gc;
			]"
		end

	c_black_gc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkGC *)((struct _GtkStyle *)$tmp)->black_gc;"
		end

	c_white_gc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkGC *)((struct _GtkStyle *)$tmp)->white_gc;"
		end

	c_bg_pixmap (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct _GtkStyle *tmp = (struct _GtkStyle *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->bg_pixmap) / sizeof(tmp->bg_pixmap[0]);
				return tmp->bg_pixmap;
			]"
		end

	c_attach_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkStyle *)$tmp)->attach_count;"
		end

	c_depth (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkStyle *)$tmp)->depth;"
		end

	c_colormap (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkColormap *)((struct _GtkStyle *)$tmp)->colormap;"
		end

	c_private_font (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkFont *)((struct _GtkStyle *)$tmp)->private_font;"
		end

	c_private_font_desc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkStyle *)$tmp)->private_font_desc;"
		end

	c_rc_style (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkRcStyle *)((struct _GtkStyle *)$tmp)->rc_style;"
		end

	c_styles (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GSList *)((struct _GtkStyle *)$tmp)->styles;"
		end

	c_property_cache (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GArray *)((struct _GtkStyle *)$tmp)->property_cache;"
		end

	c_icon_factories (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GSList *)((struct _GtkStyle *)$tmp)->icon_factories;"
		end

feature {NONE} -- C setters

	c_set_font_desc (tmp: POINTER; a_font_desc: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkStyle *)$tmp)->font_desc = (void *)$a_font_desc;"
		end

	c_set_xthickness (tmp: POINTER; a_xthickness: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkStyle *)$tmp)->xthickness = $a_xthickness;"
		end

	c_set_ythickness (tmp: POINTER; a_ythickness: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkStyle *)$tmp)->ythickness = $a_ythickness;"
		end

	c_set_black_gc (tmp: POINTER; a_black_gc: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkStyle *)$tmp)->black_gc = (struct _GdkGC *)$a_black_gc;"
		end

	c_set_white_gc (tmp: POINTER; a_white_gc: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkStyle *)$tmp)->white_gc = (struct _GdkGC *)$a_white_gc;"
		end

	c_set_attach_count (tmp: POINTER; a_attach_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkStyle *)$tmp)->attach_count = $a_attach_count;"
		end

	c_set_depth (tmp: POINTER; a_depth: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkStyle *)$tmp)->depth = $a_depth;"
		end

	c_set_colormap (tmp: POINTER; a_colormap: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkStyle *)$tmp)->colormap = (struct _GdkColormap *)$a_colormap;"
		end

	c_set_private_font (tmp: POINTER; a_private_font: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkStyle *)$tmp)->private_font = (struct _GdkFont *)$a_private_font;"
		end

	c_set_private_font_desc (tmp: POINTER; a_private_font_desc: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkStyle *)$tmp)->private_font_desc = (void *)$a_private_font_desc;"
		end

	c_set_rc_style (tmp: POINTER; a_rc_style: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkStyle *)$tmp)->rc_style = (struct _GtkRcStyle *)$a_rc_style;"
		end

	c_set_styles (tmp: POINTER; a_styles: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkStyle *)$tmp)->styles = (struct _GSList *)$a_styles;"
		end

	c_set_property_cache (tmp: POINTER; a_property_cache: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkStyle *)$tmp)->property_cache = (struct _GArray *)$a_property_cache;"
		end

	c_set_icon_factories (tmp: POINTER; a_icon_factories: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkStyle *)$tmp)->icon_factories = (struct _GSList *)$a_icon_factories;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkStyle);"
		end

end
