class
	SD_GTKTABLEROWCOL

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	requisition: NATURAL_16 assign set_requisition
		do
			Result := c_requisition (c_pointer)
		end

	allocation: NATURAL_16 assign set_allocation
		do
			Result := c_allocation (c_pointer)
		end

	spacing: NATURAL_16 assign set_spacing
		do
			Result := c_spacing (c_pointer)
		end

	need_expand: NATURAL_32 assign set_need_expand
		do
			Result := c_need_expand (c_pointer)
		end

	need_shrink: NATURAL_32 assign set_need_shrink
		do
			Result := c_need_shrink (c_pointer)
		end

	expand: NATURAL_32 assign set_expand
		do
			Result := c_expand (c_pointer)
		end

	shrink: NATURAL_32 assign set_shrink
		do
			Result := c_shrink (c_pointer)
		end

	empty: NATURAL_32 assign set_empty
		do
			Result := c_empty (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_requisition (a_requisition: NATURAL_16)
		do
			c_set_requisition (c_pointer, a_requisition)
		end

	set_allocation (a_allocation: NATURAL_16)
		do
			c_set_allocation (c_pointer, a_allocation)
		end

	set_spacing (a_spacing: NATURAL_16)
		do
			c_set_spacing (c_pointer, a_spacing)
		end

	set_need_expand (a_need_expand: NATURAL_32)
		do
			c_set_need_expand (c_pointer, a_need_expand)
		end

	set_need_shrink (a_need_shrink: NATURAL_32)
		do
			c_set_need_shrink (c_pointer, a_need_shrink)
		end

	set_expand (a_expand: NATURAL_32)
		do
			c_set_expand (c_pointer, a_expand)
		end

	set_shrink (a_shrink: NATURAL_32)
		do
			c_set_shrink (c_pointer, a_shrink)
		end

	set_empty (a_empty: NATURAL_32)
		do
			c_set_empty (c_pointer, a_empty)
		end

feature {NONE} -- C getters

	c_requisition (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GtkTableRowCol *)$tmp)->requisition;"
		end

	c_allocation (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GtkTableRowCol *)$tmp)->allocation;"
		end

	c_spacing (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GtkTableRowCol *)$tmp)->spacing;"
		end

	c_need_expand (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkTableRowCol *)$tmp)->need_expand;"
		end

	c_need_shrink (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkTableRowCol *)$tmp)->need_shrink;"
		end

	c_expand (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkTableRowCol *)$tmp)->expand;"
		end

	c_shrink (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkTableRowCol *)$tmp)->shrink;"
		end

	c_empty (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkTableRowCol *)$tmp)->empty;"
		end

feature {NONE} -- C setters

	c_set_requisition (tmp: POINTER; a_requisition: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GtkTableRowCol *)$tmp)->requisition = $a_requisition;"
		end

	c_set_allocation (tmp: POINTER; a_allocation: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GtkTableRowCol *)$tmp)->allocation = $a_allocation;"
		end

	c_set_spacing (tmp: POINTER; a_spacing: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GtkTableRowCol *)$tmp)->spacing = $a_spacing;"
		end

	c_set_need_expand (tmp: POINTER; a_need_expand: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkTableRowCol *)$tmp)->need_expand = $a_need_expand;"
		end

	c_set_need_shrink (tmp: POINTER; a_need_shrink: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkTableRowCol *)$tmp)->need_shrink = $a_need_shrink;"
		end

	c_set_expand (tmp: POINTER; a_expand: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkTableRowCol *)$tmp)->expand = $a_expand;"
		end

	c_set_shrink (tmp: POINTER; a_shrink: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkTableRowCol *)$tmp)->shrink = $a_shrink;"
		end

	c_set_empty (tmp: POINTER; a_empty: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkTableRowCol *)$tmp)->empty = $a_empty;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkTableRowCol);"
		end

end
