class
	SD_GTKTARGETENTRY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	target: CE_POINTER [INTEGER_8] assign set_target
		do
			create Result.make_shared (c_target (c_pointer))
		end

	flags: NATURAL_32 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

	info: NATURAL_32 assign set_info
		do
			Result := c_info (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_target (a_target: CE_POINTER [INTEGER_8])
		do
			c_set_target (c_pointer, a_target.c_pointer)
		end

	set_flags (a_flags: NATURAL_32)
		do
			c_set_flags (c_pointer, a_flags)
		end

	set_info (a_info: NATURAL_32)
		do
			c_set_info (c_pointer, a_info)
		end

feature {NONE} -- C getters

	c_target (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GtkTargetEntry *)$tmp)->target;"
		end

	c_flags (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkTargetEntry *)$tmp)->flags;"
		end

	c_info (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkTargetEntry *)$tmp)->info;"
		end

feature {NONE} -- C setters

	c_set_target (tmp: POINTER; a_target: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkTargetEntry *)$tmp)->target = (char *)$a_target;"
		end

	c_set_flags (tmp: POINTER; a_flags: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkTargetEntry *)$tmp)->flags = $a_flags;"
		end

	c_set_info (tmp: POINTER; a_info: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkTargetEntry *)$tmp)->info = $a_info;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkTargetEntry);"
		end

end
