class
	SD_GTKTOGGLEBUTTON

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	button: SD_GTKBUTTON assign set_button
		do
			create Result.make_shared (c_button (c_pointer))
		end

	active: NATURAL_32 assign set_active
		do
			Result := c_active (c_pointer)
		end

	draw_indicator: NATURAL_32 assign set_draw_indicator
		do
			Result := c_draw_indicator (c_pointer)
		end

	inconsistent: NATURAL_32 assign set_inconsistent
		do
			Result := c_inconsistent (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_button (a_button: SD_GTKBUTTON)
		do
			button.ce_gets (a_button)
		end

	set_active (a_active: NATURAL_32)
		do
			c_set_active (c_pointer, a_active)
		end

	set_draw_indicator (a_draw_indicator: NATURAL_32)
		do
			c_set_draw_indicator (c_pointer, a_draw_indicator)
		end

	set_inconsistent (a_inconsistent: NATURAL_32)
		do
			c_set_inconsistent (c_pointer, a_inconsistent)
		end

feature {NONE} -- C getters

	c_button (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkButton *)&((struct _GtkToggleButton *)$tmp)->button;"
		end

	c_active (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkToggleButton *)$tmp)->active;"
		end

	c_draw_indicator (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkToggleButton *)$tmp)->draw_indicator;"
		end

	c_inconsistent (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkToggleButton *)$tmp)->inconsistent;"
		end

feature {NONE} -- C setters

	c_set_active (tmp: POINTER; a_active: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkToggleButton *)$tmp)->active = $a_active;"
		end

	c_set_draw_indicator (tmp: POINTER; a_draw_indicator: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkToggleButton *)$tmp)->draw_indicator = $a_draw_indicator;"
		end

	c_set_inconsistent (tmp: POINTER; a_inconsistent: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkToggleButton *)$tmp)->inconsistent = $a_inconsistent;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkToggleButton);"
		end

end
