class
	SD_GTKTOOLBAR

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	container: SD_GTKCONTAINER assign set_container
		do
			create Result.make_shared (c_container (c_pointer))
		end

	num_children: INTEGER_32 assign set_num_children
		do
			Result := c_num_children (c_pointer)
		end

	children: CE_POINTER [SD_GLIST] assign set_children
		do
			create Result.make_shared (c_children (c_pointer))
		end

	orientation: INTEGER_32 assign set_orientation
		do
			Result := c_orientation (c_pointer)
		end

	style: INTEGER_32 assign set_style
		do
			Result := c_style (c_pointer)
		end

	icon_size: INTEGER_32 assign set_icon_size
		do
			Result := c_icon_size (c_pointer)
		end

	tooltips: CE_POINTER [SD_GTKTOOLTIPS] assign set_tooltips
		do
			create Result.make_shared (c_tooltips (c_pointer))
		end

	button_maxw: INTEGER_32 assign set_button_maxw
		do
			Result := c_button_maxw (c_pointer)
		end

	button_maxh: INTEGER_32 assign set_button_maxh
		do
			Result := c_button_maxh (c_pointer)
		end

	gtk_reserved1: NATURAL_32 assign set_gtk_reserved1
		do
			Result := c_gtk_reserved1 (c_pointer)
		end

	gtk_reserved2: NATURAL_32 assign set_gtk_reserved2
		do
			Result := c_gtk_reserved2 (c_pointer)
		end

	style_set: NATURAL_32 assign set_style_set
		do
			Result := c_style_set (c_pointer)
		end

	icon_size_set: NATURAL_32 assign set_icon_size_set
		do
			Result := c_icon_size_set (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_container (a_container: SD_GTKCONTAINER)
		do
			container.ce_gets (a_container)
		end

	set_num_children (a_num_children: INTEGER_32)
		do
			c_set_num_children (c_pointer, a_num_children)
		end

	set_children (a_children: CE_POINTER [SD_GLIST])
		do
			c_set_children (c_pointer, a_children.c_pointer)
		end

	set_orientation (a_orientation: INTEGER_32)
		do
			c_set_orientation (c_pointer, a_orientation)
		end

	set_style (a_style: INTEGER_32)
		do
			c_set_style (c_pointer, a_style)
		end

	set_icon_size (a_icon_size: INTEGER_32)
		do
			c_set_icon_size (c_pointer, a_icon_size)
		end

	set_tooltips (a_tooltips: CE_POINTER [SD_GTKTOOLTIPS])
		do
			c_set_tooltips (c_pointer, a_tooltips.c_pointer)
		end

	set_button_maxw (a_button_maxw: INTEGER_32)
		do
			c_set_button_maxw (c_pointer, a_button_maxw)
		end

	set_button_maxh (a_button_maxh: INTEGER_32)
		do
			c_set_button_maxh (c_pointer, a_button_maxh)
		end

	set_gtk_reserved1 (a_gtk_reserved1: NATURAL_32)
		do
			c_set_gtk_reserved1 (c_pointer, a_gtk_reserved1)
		end

	set_gtk_reserved2 (a_gtk_reserved2: NATURAL_32)
		do
			c_set_gtk_reserved2 (c_pointer, a_gtk_reserved2)
		end

	set_style_set (a_style_set: NATURAL_32)
		do
			c_set_style_set (c_pointer, a_style_set)
		end

	set_icon_size_set (a_icon_size_set: NATURAL_32)
		do
			c_set_icon_size_set (c_pointer, a_icon_size_set)
		end

feature {NONE} -- C getters

	c_container (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkContainer *)&((struct _GtkToolbar *)$tmp)->container;"
		end

	c_num_children (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkToolbar *)$tmp)->num_children;"
		end

	c_children (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GList *)((struct _GtkToolbar *)$tmp)->children;"
		end

	c_orientation (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkToolbar *)$tmp)->orientation;"
		end

	c_style (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkToolbar *)$tmp)->style;"
		end

	c_icon_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkToolbar *)$tmp)->icon_size;"
		end

	c_tooltips (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkTooltips *)((struct _GtkToolbar *)$tmp)->tooltips;"
		end

	c_button_maxw (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkToolbar *)$tmp)->button_maxw;"
		end

	c_button_maxh (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkToolbar *)$tmp)->button_maxh;"
		end

	c_gtk_reserved1 (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkToolbar *)$tmp)->_gtk_reserved1;"
		end

	c_gtk_reserved2 (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkToolbar *)$tmp)->_gtk_reserved2;"
		end

	c_style_set (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkToolbar *)$tmp)->style_set;"
		end

	c_icon_size_set (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkToolbar *)$tmp)->icon_size_set;"
		end

feature {NONE} -- C setters

	c_set_num_children (tmp: POINTER; a_num_children: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkToolbar *)$tmp)->num_children = $a_num_children;"
		end

	c_set_children (tmp: POINTER; a_children: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkToolbar *)$tmp)->children = (struct _GList *)$a_children;"
		end

	c_set_orientation (tmp: POINTER; a_orientation: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkToolbar *)$tmp)->orientation = $a_orientation;"
		end

	c_set_style (tmp: POINTER; a_style: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkToolbar *)$tmp)->style = $a_style;"
		end

	c_set_icon_size (tmp: POINTER; a_icon_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkToolbar *)$tmp)->icon_size = $a_icon_size;"
		end

	c_set_tooltips (tmp: POINTER; a_tooltips: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkToolbar *)$tmp)->tooltips = (struct _GtkTooltips *)$a_tooltips;"
		end

	c_set_button_maxw (tmp: POINTER; a_button_maxw: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkToolbar *)$tmp)->button_maxw = $a_button_maxw;"
		end

	c_set_button_maxh (tmp: POINTER; a_button_maxh: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkToolbar *)$tmp)->button_maxh = $a_button_maxh;"
		end

	c_set_gtk_reserved1 (tmp: POINTER; a_gtk_reserved1: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkToolbar *)$tmp)->_gtk_reserved1 = $a_gtk_reserved1;"
		end

	c_set_gtk_reserved2 (tmp: POINTER; a_gtk_reserved2: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkToolbar *)$tmp)->_gtk_reserved2 = $a_gtk_reserved2;"
		end

	c_set_style_set (tmp: POINTER; a_style_set: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkToolbar *)$tmp)->style_set = $a_style_set;"
		end

	c_set_icon_size_set (tmp: POINTER; a_icon_size_set: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkToolbar *)$tmp)->icon_size_set = $a_icon_size_set;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkToolbar);"
		end

end
