class
	SD_GTKWINDOW

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	bin: SD_GTKBIN assign set_bin
		do
			create Result.make_shared (c_bin (c_pointer))
		end

	title: CE_POINTER [INTEGER_8] assign set_title
		do
			create Result.make_shared (c_title (c_pointer))
		end

	wmclass_name: CE_POINTER [INTEGER_8] assign set_wmclass_name
		do
			create Result.make_shared (c_wmclass_name (c_pointer))
		end

	wmclass_class: CE_POINTER [INTEGER_8] assign set_wmclass_class
		do
			create Result.make_shared (c_wmclass_class (c_pointer))
		end

	wm_role: CE_POINTER [INTEGER_8] assign set_wm_role
		do
			create Result.make_shared (c_wm_role (c_pointer))
		end

	focus_widget: CE_POINTER [SD_GTKWIDGET] assign set_focus_widget
		do
			create Result.make_shared (c_focus_widget (c_pointer))
		end

	default_widget: CE_POINTER [SD_GTKWIDGET] assign set_default_widget
		do
			create Result.make_shared (c_default_widget (c_pointer))
		end

	transient_parent: CE_POINTER [SD_GTKWINDOW] assign set_transient_parent
		do
			create Result.make_shared (c_transient_parent (c_pointer))
		end

	geometry_info: CE_POINTER [ANY] assign set_geometry_info
		do
			create Result.make_shared (c_geometry_info (c_pointer))
		end

	frame: CE_POINTER [SD_GDKDRAWABLE] assign set_frame
		do
			create Result.make_shared (c_frame (c_pointer))
		end

	group: CE_POINTER [SD_GTKWINDOWGROUP] assign set_group
		do
			create Result.make_shared (c_group (c_pointer))
		end

	configure_request_count: NATURAL_16 assign set_configure_request_count
		do
			Result := c_configure_request_count (c_pointer)
		end

	allow_shrink: NATURAL_32 assign set_allow_shrink
		do
			Result := c_allow_shrink (c_pointer)
		end

	allow_grow: NATURAL_32 assign set_allow_grow
		do
			Result := c_allow_grow (c_pointer)
		end

	configure_notify_received: NATURAL_32 assign set_configure_notify_received
		do
			Result := c_configure_notify_received (c_pointer)
		end

	need_default_position: NATURAL_32 assign set_need_default_position
		do
			Result := c_need_default_position (c_pointer)
		end

	need_default_size: NATURAL_32 assign set_need_default_size
		do
			Result := c_need_default_size (c_pointer)
		end

	position: NATURAL_32 assign set_position
		do
			Result := c_position (c_pointer)
		end

	type: NATURAL_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	has_user_ref_count: NATURAL_32 assign set_has_user_ref_count
		do
			Result := c_has_user_ref_count (c_pointer)
		end

	has_focus: NATURAL_32 assign set_has_focus
		do
			Result := c_has_focus (c_pointer)
		end

	modal: NATURAL_32 assign set_modal
		do
			Result := c_modal (c_pointer)
		end

	destroy_with_parent: NATURAL_32 assign set_destroy_with_parent
		do
			Result := c_destroy_with_parent (c_pointer)
		end

	has_frame: NATURAL_32 assign set_has_frame
		do
			Result := c_has_frame (c_pointer)
		end

	iconify_initially: NATURAL_32 assign set_iconify_initially
		do
			Result := c_iconify_initially (c_pointer)
		end

	stick_initially: NATURAL_32 assign set_stick_initially
		do
			Result := c_stick_initially (c_pointer)
		end

	maximize_initially: NATURAL_32 assign set_maximize_initially
		do
			Result := c_maximize_initially (c_pointer)
		end

	decorated: NATURAL_32 assign set_decorated
		do
			Result := c_decorated (c_pointer)
		end

	type_hint: NATURAL_32 assign set_type_hint
		do
			Result := c_type_hint (c_pointer)
		end

	gravity: NATURAL_32 assign set_gravity
		do
			Result := c_gravity (c_pointer)
		end

	is_active: NATURAL_32 assign set_is_active
		do
			Result := c_is_active (c_pointer)
		end

	has_toplevel_focus: NATURAL_32 assign set_has_toplevel_focus
		do
			Result := c_has_toplevel_focus (c_pointer)
		end

	frame_left: NATURAL_32 assign set_frame_left
		do
			Result := c_frame_left (c_pointer)
		end

	frame_top: NATURAL_32 assign set_frame_top
		do
			Result := c_frame_top (c_pointer)
		end

	frame_right: NATURAL_32 assign set_frame_right
		do
			Result := c_frame_right (c_pointer)
		end

	frame_bottom: NATURAL_32 assign set_frame_bottom
		do
			Result := c_frame_bottom (c_pointer)
		end

	keys_changed_handler: NATURAL_32 assign set_keys_changed_handler
		do
			Result := c_keys_changed_handler (c_pointer)
		end

	mnemonic_modifier: INTEGER_32 assign set_mnemonic_modifier
		do
			Result := c_mnemonic_modifier (c_pointer)
		end

	screen: CE_POINTER [SD_GDKSCREEN] assign set_screen
		do
			create Result.make_shared (c_screen (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_bin (a_bin: SD_GTKBIN)
		do
			bin.ce_gets (a_bin)
		end

	set_title (a_title: CE_POINTER [INTEGER_8])
		do
			c_set_title (c_pointer, a_title.c_pointer)
		end

	set_wmclass_name (a_wmclass_name: CE_POINTER [INTEGER_8])
		do
			c_set_wmclass_name (c_pointer, a_wmclass_name.c_pointer)
		end

	set_wmclass_class (a_wmclass_class: CE_POINTER [INTEGER_8])
		do
			c_set_wmclass_class (c_pointer, a_wmclass_class.c_pointer)
		end

	set_wm_role (a_wm_role: CE_POINTER [INTEGER_8])
		do
			c_set_wm_role (c_pointer, a_wm_role.c_pointer)
		end

	set_focus_widget (a_focus_widget: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_focus_widget (c_pointer, a_focus_widget.c_pointer)
		end

	set_default_widget (a_default_widget: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_default_widget (c_pointer, a_default_widget.c_pointer)
		end

	set_transient_parent (a_transient_parent: CE_POINTER [SD_GTKWINDOW])
		do
			c_set_transient_parent (c_pointer, a_transient_parent.c_pointer)
		end

	set_geometry_info (a_geometry_info: CE_POINTER [ANY])
		do
			c_set_geometry_info (c_pointer, a_geometry_info.c_pointer)
		end

	set_frame (a_frame: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_frame (c_pointer, a_frame.c_pointer)
		end

	set_group (a_group: CE_POINTER [SD_GTKWINDOWGROUP])
		do
			c_set_group (c_pointer, a_group.c_pointer)
		end

	set_configure_request_count (a_configure_request_count: NATURAL_16)
		do
			c_set_configure_request_count (c_pointer, a_configure_request_count)
		end

	set_allow_shrink (a_allow_shrink: NATURAL_32)
		do
			c_set_allow_shrink (c_pointer, a_allow_shrink)
		end

	set_allow_grow (a_allow_grow: NATURAL_32)
		do
			c_set_allow_grow (c_pointer, a_allow_grow)
		end

	set_configure_notify_received (a_configure_notify_received: NATURAL_32)
		do
			c_set_configure_notify_received (c_pointer, a_configure_notify_received)
		end

	set_need_default_position (a_need_default_position: NATURAL_32)
		do
			c_set_need_default_position (c_pointer, a_need_default_position)
		end

	set_need_default_size (a_need_default_size: NATURAL_32)
		do
			c_set_need_default_size (c_pointer, a_need_default_size)
		end

	set_position (a_position: NATURAL_32)
		do
			c_set_position (c_pointer, a_position)
		end

	set_type (a_type: NATURAL_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_has_user_ref_count (a_has_user_ref_count: NATURAL_32)
		do
			c_set_has_user_ref_count (c_pointer, a_has_user_ref_count)
		end

	set_has_focus (a_has_focus: NATURAL_32)
		do
			c_set_has_focus (c_pointer, a_has_focus)
		end

	set_modal (a_modal: NATURAL_32)
		do
			c_set_modal (c_pointer, a_modal)
		end

	set_destroy_with_parent (a_destroy_with_parent: NATURAL_32)
		do
			c_set_destroy_with_parent (c_pointer, a_destroy_with_parent)
		end

	set_has_frame (a_has_frame: NATURAL_32)
		do
			c_set_has_frame (c_pointer, a_has_frame)
		end

	set_iconify_initially (a_iconify_initially: NATURAL_32)
		do
			c_set_iconify_initially (c_pointer, a_iconify_initially)
		end

	set_stick_initially (a_stick_initially: NATURAL_32)
		do
			c_set_stick_initially (c_pointer, a_stick_initially)
		end

	set_maximize_initially (a_maximize_initially: NATURAL_32)
		do
			c_set_maximize_initially (c_pointer, a_maximize_initially)
		end

	set_decorated (a_decorated: NATURAL_32)
		do
			c_set_decorated (c_pointer, a_decorated)
		end

	set_type_hint (a_type_hint: NATURAL_32)
		do
			c_set_type_hint (c_pointer, a_type_hint)
		end

	set_gravity (a_gravity: NATURAL_32)
		do
			c_set_gravity (c_pointer, a_gravity)
		end

	set_is_active (a_is_active: NATURAL_32)
		do
			c_set_is_active (c_pointer, a_is_active)
		end

	set_has_toplevel_focus (a_has_toplevel_focus: NATURAL_32)
		do
			c_set_has_toplevel_focus (c_pointer, a_has_toplevel_focus)
		end

	set_frame_left (a_frame_left: NATURAL_32)
		do
			c_set_frame_left (c_pointer, a_frame_left)
		end

	set_frame_top (a_frame_top: NATURAL_32)
		do
			c_set_frame_top (c_pointer, a_frame_top)
		end

	set_frame_right (a_frame_right: NATURAL_32)
		do
			c_set_frame_right (c_pointer, a_frame_right)
		end

	set_frame_bottom (a_frame_bottom: NATURAL_32)
		do
			c_set_frame_bottom (c_pointer, a_frame_bottom)
		end

	set_keys_changed_handler (a_keys_changed_handler: NATURAL_32)
		do
			c_set_keys_changed_handler (c_pointer, a_keys_changed_handler)
		end

	set_mnemonic_modifier (a_mnemonic_modifier: INTEGER_32)
		do
			c_set_mnemonic_modifier (c_pointer, a_mnemonic_modifier)
		end

	set_screen (a_screen: CE_POINTER [SD_GDKSCREEN])
		do
			c_set_screen (c_pointer, a_screen.c_pointer)
		end

feature {NONE} -- C getters

	c_bin (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkBin *)&((struct _GtkWindow *)$tmp)->bin;"
		end

	c_title (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GtkWindow *)$tmp)->title;"
		end

	c_wmclass_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GtkWindow *)$tmp)->wmclass_name;"
		end

	c_wmclass_class (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GtkWindow *)$tmp)->wmclass_class;"
		end

	c_wm_role (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GtkWindow *)$tmp)->wm_role;"
		end

	c_focus_widget (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkWindow *)$tmp)->focus_widget;"
		end

	c_default_widget (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkWindow *)$tmp)->default_widget;"
		end

	c_transient_parent (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWindow *)((struct _GtkWindow *)$tmp)->transient_parent;"
		end

	c_geometry_info (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkWindow *)$tmp)->geometry_info;"
		end

	c_frame (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GtkWindow *)$tmp)->frame;"
		end

	c_group (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWindowGroup *)((struct _GtkWindow *)$tmp)->group;"
		end

	c_configure_request_count (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GtkWindow *)$tmp)->configure_request_count;"
		end

	c_allow_shrink (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkWindow *)$tmp)->allow_shrink;"
		end

	c_allow_grow (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkWindow *)$tmp)->allow_grow;"
		end

	c_configure_notify_received (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkWindow *)$tmp)->configure_notify_received;"
		end

	c_need_default_position (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkWindow *)$tmp)->need_default_position;"
		end

	c_need_default_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkWindow *)$tmp)->need_default_size;"
		end

	c_position (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkWindow *)$tmp)->position;"
		end

	c_type (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkWindow *)$tmp)->type;"
		end

	c_has_user_ref_count (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkWindow *)$tmp)->has_user_ref_count;"
		end

	c_has_focus (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkWindow *)$tmp)->has_focus;"
		end

	c_modal (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkWindow *)$tmp)->modal;"
		end

	c_destroy_with_parent (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkWindow *)$tmp)->destroy_with_parent;"
		end

	c_has_frame (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkWindow *)$tmp)->has_frame;"
		end

	c_iconify_initially (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkWindow *)$tmp)->iconify_initially;"
		end

	c_stick_initially (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkWindow *)$tmp)->stick_initially;"
		end

	c_maximize_initially (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkWindow *)$tmp)->maximize_initially;"
		end

	c_decorated (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkWindow *)$tmp)->decorated;"
		end

	c_type_hint (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkWindow *)$tmp)->type_hint;"
		end

	c_gravity (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkWindow *)$tmp)->gravity;"
		end

	c_is_active (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkWindow *)$tmp)->is_active;"
		end

	c_has_toplevel_focus (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkWindow *)$tmp)->has_toplevel_focus;"
		end

	c_frame_left (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkWindow *)$tmp)->frame_left;"
		end

	c_frame_top (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkWindow *)$tmp)->frame_top;"
		end

	c_frame_right (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkWindow *)$tmp)->frame_right;"
		end

	c_frame_bottom (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkWindow *)$tmp)->frame_bottom;"
		end

	c_keys_changed_handler (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkWindow *)$tmp)->keys_changed_handler;"
		end

	c_mnemonic_modifier (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkWindow *)$tmp)->mnemonic_modifier;"
		end

	c_screen (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkScreen *)((struct _GtkWindow *)$tmp)->screen;"
		end

feature {NONE} -- C setters

	c_set_title (tmp: POINTER; a_title: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->title = (char *)$a_title;"
		end

	c_set_wmclass_name (tmp: POINTER; a_wmclass_name: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->wmclass_name = (char *)$a_wmclass_name;"
		end

	c_set_wmclass_class (tmp: POINTER; a_wmclass_class: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->wmclass_class = (char *)$a_wmclass_class;"
		end

	c_set_wm_role (tmp: POINTER; a_wm_role: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->wm_role = (char *)$a_wm_role;"
		end

	c_set_focus_widget (tmp: POINTER; a_focus_widget: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->focus_widget = (struct _GtkWidget *)$a_focus_widget;"
		end

	c_set_default_widget (tmp: POINTER; a_default_widget: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->default_widget = (struct _GtkWidget *)$a_default_widget;"
		end

	c_set_transient_parent (tmp: POINTER; a_transient_parent: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->transient_parent = (struct _GtkWindow *)$a_transient_parent;"
		end

	c_set_geometry_info (tmp: POINTER; a_geometry_info: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->geometry_info = (void *)$a_geometry_info;"
		end

	c_set_frame (tmp: POINTER; a_frame: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->frame = (struct _GdkDrawable *)$a_frame;"
		end

	c_set_group (tmp: POINTER; a_group: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->group = (struct _GtkWindowGroup *)$a_group;"
		end

	c_set_configure_request_count (tmp: POINTER; a_configure_request_count: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->configure_request_count = $a_configure_request_count;"
		end

	c_set_allow_shrink (tmp: POINTER; a_allow_shrink: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->allow_shrink = $a_allow_shrink;"
		end

	c_set_allow_grow (tmp: POINTER; a_allow_grow: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->allow_grow = $a_allow_grow;"
		end

	c_set_configure_notify_received (tmp: POINTER; a_configure_notify_received: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->configure_notify_received = $a_configure_notify_received;"
		end

	c_set_need_default_position (tmp: POINTER; a_need_default_position: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->need_default_position = $a_need_default_position;"
		end

	c_set_need_default_size (tmp: POINTER; a_need_default_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->need_default_size = $a_need_default_size;"
		end

	c_set_position (tmp: POINTER; a_position: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->position = $a_position;"
		end

	c_set_type (tmp: POINTER; a_type: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->type = $a_type;"
		end

	c_set_has_user_ref_count (tmp: POINTER; a_has_user_ref_count: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->has_user_ref_count = $a_has_user_ref_count;"
		end

	c_set_has_focus (tmp: POINTER; a_has_focus: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->has_focus = $a_has_focus;"
		end

	c_set_modal (tmp: POINTER; a_modal: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->modal = $a_modal;"
		end

	c_set_destroy_with_parent (tmp: POINTER; a_destroy_with_parent: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->destroy_with_parent = $a_destroy_with_parent;"
		end

	c_set_has_frame (tmp: POINTER; a_has_frame: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->has_frame = $a_has_frame;"
		end

	c_set_iconify_initially (tmp: POINTER; a_iconify_initially: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->iconify_initially = $a_iconify_initially;"
		end

	c_set_stick_initially (tmp: POINTER; a_stick_initially: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->stick_initially = $a_stick_initially;"
		end

	c_set_maximize_initially (tmp: POINTER; a_maximize_initially: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->maximize_initially = $a_maximize_initially;"
		end

	c_set_decorated (tmp: POINTER; a_decorated: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->decorated = $a_decorated;"
		end

	c_set_type_hint (tmp: POINTER; a_type_hint: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->type_hint = $a_type_hint;"
		end

	c_set_gravity (tmp: POINTER; a_gravity: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->gravity = $a_gravity;"
		end

	c_set_is_active (tmp: POINTER; a_is_active: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->is_active = $a_is_active;"
		end

	c_set_has_toplevel_focus (tmp: POINTER; a_has_toplevel_focus: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->has_toplevel_focus = $a_has_toplevel_focus;"
		end

	c_set_frame_left (tmp: POINTER; a_frame_left: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->frame_left = $a_frame_left;"
		end

	c_set_frame_top (tmp: POINTER; a_frame_top: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->frame_top = $a_frame_top;"
		end

	c_set_frame_right (tmp: POINTER; a_frame_right: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->frame_right = $a_frame_right;"
		end

	c_set_frame_bottom (tmp: POINTER; a_frame_bottom: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->frame_bottom = $a_frame_bottom;"
		end

	c_set_keys_changed_handler (tmp: POINTER; a_keys_changed_handler: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->keys_changed_handler = $a_keys_changed_handler;"
		end

	c_set_mnemonic_modifier (tmp: POINTER; a_mnemonic_modifier: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->mnemonic_modifier = $a_mnemonic_modifier;"
		end

	c_set_screen (tmp: POINTER; a_screen: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkWindow *)$tmp)->screen = (struct _GdkScreen *)$a_screen;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkWindow);"
		end

end
