class
	SD_GTKWINDOWGROUP

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	parent_instance: SD_GOBJECT assign set_parent_instance
		do
			create Result.make_shared (c_parent_instance (c_pointer))
		end

	grabs: CE_POINTER [SD_GSLIST] assign set_grabs
		do
			create Result.make_shared (c_grabs (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_parent_instance (a_parent_instance: SD_GOBJECT)
		do
			parent_instance.ce_gets (a_parent_instance)
		end

	set_grabs (a_grabs: CE_POINTER [SD_GSLIST])
		do
			c_set_grabs (c_pointer, a_grabs.c_pointer)
		end

feature {NONE} -- C getters

	c_parent_instance (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GObject *)&((struct _GtkWindowGroup *)$tmp)->parent_instance;"
		end

	c_grabs (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GSList *)((struct _GtkWindowGroup *)$tmp)->grabs;"
		end

feature {NONE} -- C setters

	c_set_grabs (tmp: POINTER; a_grabs: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkWindowGroup *)$tmp)->grabs = (struct _GSList *)$a_grabs;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkWindowGroup);"
		end

end
