class
	SD_GTYPECLASS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	g_type: NATURAL_32 assign set_g_type
		do
			Result := c_g_type (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_g_type (a_g_type: NATURAL_32)
		do
			c_set_g_type (c_pointer, a_g_type)
		end

feature {NONE} -- C getters

	c_g_type (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GTypeClass *)$tmp)->g_type;"
		end

feature {NONE} -- C setters

	c_set_g_type (tmp: POINTER; a_g_type: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GTypeClass *)$tmp)->g_type = $a_g_type;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GTypeClass);"
		end

end
