class
	SD_GTYPEINSTANCE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	g_class: CE_POINTER [SD_GTYPECLASS] assign set_g_class
		do
			create Result.make_shared (c_g_class (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_g_class (a_g_class: CE_POINTER [SD_GTYPECLASS])
		do
			c_set_g_class (c_pointer, a_g_class.c_pointer)
		end

feature {NONE} -- C getters

	c_g_class (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GTypeClass *)((struct _GTypeInstance *)$tmp)->g_class;"
		end

feature {NONE} -- C setters

	c_set_g_class (tmp: POINTER; a_g_class: POINTER)
		external
			"C inline"
		alias
			"((struct _GTypeInstance *)$tmp)->g_class = (struct _GTypeClass *)$a_g_class;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GTypeInstance);"
		end

end
