class
	SD_ICEREPLYWAITINFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sequence_of_request: NATURAL_32 assign set_sequence_of_request
		do
			Result := c_sequence_of_request (c_pointer)
		end

	major_opcode_of_request: INTEGER_32 assign set_major_opcode_of_request
		do
			Result := c_major_opcode_of_request (c_pointer)
		end

	minor_opcode_of_request: INTEGER_32 assign set_minor_opcode_of_request
		do
			Result := c_minor_opcode_of_request (c_pointer)
		end

	reply: CE_POINTER [ANY] assign set_reply
		do
			create Result.make_shared (c_reply (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_sequence_of_request (a_sequence_of_request: NATURAL_32)
		do
			c_set_sequence_of_request (c_pointer, a_sequence_of_request)
		end

	set_major_opcode_of_request (a_major_opcode_of_request: INTEGER_32)
		do
			c_set_major_opcode_of_request (c_pointer, a_major_opcode_of_request)
		end

	set_minor_opcode_of_request (a_minor_opcode_of_request: INTEGER_32)
		do
			c_set_minor_opcode_of_request (c_pointer, a_minor_opcode_of_request)
		end

	set_reply (a_reply: CE_POINTER [ANY])
		do
			c_set_reply (c_pointer, a_reply.c_pointer)
		end

feature {NONE} -- C getters

	c_sequence_of_request (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_IceReplyWaitInfo_556 *)$tmp)->sequence_of_request;"
		end

	c_major_opcode_of_request (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_IceReplyWaitInfo_556 *)$tmp)->major_opcode_of_request;"
		end

	c_minor_opcode_of_request (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_IceReplyWaitInfo_556 *)$tmp)->minor_opcode_of_request;"
		end

	c_reply (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_IceReplyWaitInfo_556 *)$tmp)->reply;"
		end

feature {NONE} -- C setters

	c_set_sequence_of_request (tmp: POINTER; a_sequence_of_request: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_IceReplyWaitInfo_556 *)$tmp)->sequence_of_request = $a_sequence_of_request;"
		end

	c_set_major_opcode_of_request (tmp: POINTER; a_major_opcode_of_request: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_IceReplyWaitInfo_556 *)$tmp)->major_opcode_of_request = $a_major_opcode_of_request;"
		end

	c_set_minor_opcode_of_request (tmp: POINTER; a_minor_opcode_of_request: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_IceReplyWaitInfo_556 *)$tmp)->minor_opcode_of_request = $a_minor_opcode_of_request;"
		end

	c_set_reply (tmp: POINTER; a_reply: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_IceReplyWaitInfo_556 *)$tmp)->reply = (void *)$a_reply;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_IceReplyWaitInfo_556);"
		end

end
