class
	SD_KILL

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	si_pid: INTEGER_32 assign set_si_pid
		do
			Result := c_si_pid (c_pointer)
		end

	si_uid: NATURAL_32 assign set_si_uid
		do
			Result := c_si_uid (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_si_pid (a_si_pid: INTEGER_32)
		do
			c_set_si_pid (c_pointer, a_si_pid)
		end

	set_si_uid (a_si_uid: NATURAL_32)
		do
			c_set_si_uid (c_pointer, a_si_uid)
		end

feature {NONE} -- C getters

	c_si_pid (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct__kill_33 *)$tmp)->si_pid;"
		end

	c_si_uid (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct__kill_33 *)$tmp)->si_uid;"
		end

feature {NONE} -- C setters

	c_set_si_pid (tmp: POINTER; a_si_pid: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__kill_33 *)$tmp)->si_pid = $a_si_pid;"
		end

	c_set_si_uid (tmp: POINTER; a_si_uid: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__kill_33 *)$tmp)->si_uid = $a_si_uid;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct__kill_33);"
		end

end
