class
	SD_PANGOATTRINT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	attr: SD_PANGOATTRIBUTE assign set_attr
		do
			create Result.make_shared (c_attr (c_pointer))
		end

	value: INTEGER_32 assign set_value
		do
			Result := c_value (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_attr (a_attr: SD_PANGOATTRIBUTE)
		do
			attr.ce_gets (a_attr)
		end

	set_value (a_value: INTEGER_32)
		do
			c_set_value (c_pointer, a_value)
		end

feature {NONE} -- C getters

	c_attr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _PangoAttribute *)&((struct _PangoAttrInt *)$tmp)->attr;"
		end

	c_value (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _PangoAttrInt *)$tmp)->value;"
		end

feature {NONE} -- C setters

	c_set_value (tmp: POINTER; a_value: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _PangoAttrInt *)$tmp)->value = $a_value;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _PangoAttrInt);"
		end

end
