class
	SD_PANGOCOLOR

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	red: NATURAL_16 assign set_red
		do
			Result := c_red (c_pointer)
		end

	green: NATURAL_16 assign set_green
		do
			Result := c_green (c_pointer)
		end

	blue: NATURAL_16 assign set_blue
		do
			Result := c_blue (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_red (a_red: NATURAL_16)
		do
			c_set_red (c_pointer, a_red)
		end

	set_green (a_green: NATURAL_16)
		do
			c_set_green (c_pointer, a_green)
		end

	set_blue (a_blue: NATURAL_16)
		do
			c_set_blue (c_pointer, a_blue)
		end

feature {NONE} -- C getters

	c_red (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _PangoColor *)$tmp)->red;"
		end

	c_green (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _PangoColor *)$tmp)->green;"
		end

	c_blue (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _PangoColor *)$tmp)->blue;"
		end

feature {NONE} -- C setters

	c_set_red (tmp: POINTER; a_red: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _PangoColor *)$tmp)->red = $a_red;"
		end

	c_set_green (tmp: POINTER; a_green: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _PangoColor *)$tmp)->green = $a_green;"
		end

	c_set_blue (tmp: POINTER; a_blue: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _PangoColor *)$tmp)->blue = $a_blue;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _PangoColor);"
		end

end
