class
	SD_RLIMIT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	rlim_cur: NATURAL_32 assign set_rlim_cur
		do
			Result := c_rlim_cur (c_pointer)
		end

	rlim_max: NATURAL_32 assign set_rlim_max
		do
			Result := c_rlim_max (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_rlim_cur (a_rlim_cur: NATURAL_32)
		do
			c_set_rlim_cur (c_pointer, a_rlim_cur)
		end

	set_rlim_max (a_rlim_max: NATURAL_32)
		do
			c_set_rlim_max (c_pointer, a_rlim_max)
		end

feature {NONE} -- C getters

	c_rlim_cur (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct rlimit *)$tmp)->rlim_cur;"
		end

	c_rlim_max (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct rlimit *)$tmp)->rlim_max;"
		end

feature {NONE} -- C setters

	c_set_rlim_cur (tmp: POINTER; a_rlim_cur: NATURAL_32)
		external
			"C inline"
		alias
			"((struct rlimit *)$tmp)->rlim_cur = $a_rlim_cur;"
		end

	c_set_rlim_max (tmp: POINTER; a_rlim_max: NATURAL_32)
		external
			"C inline"
		alias
			"((struct rlimit *)$tmp)->rlim_max = $a_rlim_max;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct rlimit);"
		end

end
