class
	SD_SAVE_COMPLETE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	callback: CE_ROUTINE assign set_callback
		do
			create Result.make_shared (c_callback (c_pointer))
		end

	client_data: CE_POINTER [ANY] assign set_client_data
		do
			create Result.make_shared (c_client_data (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_callback (a_callback: CE_ROUTINE)
		do
			c_set_callback (c_pointer, a_callback.c_pointer)
		end

	set_client_data (a_client_data: CE_POINTER [ANY])
		do
			c_set_client_data (c_pointer, a_client_data.c_pointer)
		end

feature {NONE} -- C getters

	c_callback (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void *, void *))((struct __anonstruct_save_complete_565 *)$tmp)->callback;"
		end

	c_client_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_save_complete_565 *)$tmp)->client_data;"
		end

feature {NONE} -- C setters

	c_set_callback (tmp: POINTER; a_callback: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_save_complete_565 *)$tmp)->callback = (void( *)(void *, void *))$a_callback;"
		end

	c_set_client_data (tmp: POINTER; a_client_data: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_save_complete_565 *)$tmp)->client_data = (void *)$a_client_data;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_save_complete_565);"
		end

end
