class
	SD_SCREENFORMAT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ext_data: CE_POINTER [SD_XEXTDATA] assign set_ext_data
		do
			create Result.make_shared (c_ext_data (c_pointer))
		end

	depth: INTEGER_32 assign set_depth
		do
			Result := c_depth (c_pointer)
		end

	bits_per_pixel: INTEGER_32 assign set_bits_per_pixel
		do
			Result := c_bits_per_pixel (c_pointer)
		end

	scanline_pad: INTEGER_32 assign set_scanline_pad
		do
			Result := c_scanline_pad (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_ext_data (a_ext_data: CE_POINTER [SD_XEXTDATA])
		do
			c_set_ext_data (c_pointer, a_ext_data.c_pointer)
		end

	set_depth (a_depth: INTEGER_32)
		do
			c_set_depth (c_pointer, a_depth)
		end

	set_bits_per_pixel (a_bits_per_pixel: INTEGER_32)
		do
			c_set_bits_per_pixel (c_pointer, a_bits_per_pixel)
		end

	set_scanline_pad (a_scanline_pad: INTEGER_32)
		do
			c_set_scanline_pad (c_pointer, a_scanline_pad)
		end

feature {NONE} -- C getters

	c_ext_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _XExtData *)((struct __anonstruct_ScreenFormat_352 *)$tmp)->ext_data;"
		end

	c_depth (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_ScreenFormat_352 *)$tmp)->depth;"
		end

	c_bits_per_pixel (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_ScreenFormat_352 *)$tmp)->bits_per_pixel;"
		end

	c_scanline_pad (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_ScreenFormat_352 *)$tmp)->scanline_pad;"
		end

feature {NONE} -- C setters

	c_set_ext_data (tmp: POINTER; a_ext_data: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_ScreenFormat_352 *)$tmp)->ext_data = (struct _XExtData *)$a_ext_data;"
		end

	c_set_depth (tmp: POINTER; a_depth: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_ScreenFormat_352 *)$tmp)->depth = $a_depth;"
		end

	c_set_bits_per_pixel (tmp: POINTER; a_bits_per_pixel: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_ScreenFormat_352 *)$tmp)->bits_per_pixel = $a_bits_per_pixel;"
		end

	c_set_scanline_pad (tmp: POINTER; a_scanline_pad: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_ScreenFormat_352 *)$tmp)->scanline_pad = $a_scanline_pad;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_ScreenFormat_352);"
		end

end
