class
	SD_SIGNAL_DATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	f: CE_ROUTINE assign set_f
		do
			create Result.make_shared (c_f (c_pointer))
		end

	d: CE_POINTER [ANY] assign set_d
		do
			create Result.make_shared (c_d (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_f (a_f: CE_ROUTINE)
		do
			c_set_f (c_pointer, a_f.c_pointer)
		end

	set_d (a_d: CE_POINTER [ANY])
		do
			c_set_d (c_pointer, a_d.c_pointer)
		end

feature {NONE} -- C getters

	c_f (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)())((struct __anonstruct_signal_data_307 *)$tmp)->f;"
		end

	c_d (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_signal_data_307 *)$tmp)->d;"
		end

feature {NONE} -- C setters

	c_set_f (tmp: POINTER; a_f: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_signal_data_307 *)$tmp)->f = (void( *)())$a_f;"
		end

	c_set_d (tmp: POINTER; a_d: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_signal_data_307 *)$tmp)->d = (void *)$a_d;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_signal_data_307);"
		end

end
