class
	SD_SMCCALLBACKS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	save_yourself: SD_SAVE_YOURSELF assign set_save_yourself
		do
			create Result.make_shared (c_save_yourself (c_pointer))
		end

	die: SD_DIE assign set_die
		do
			create Result.make_shared (c_die (c_pointer))
		end

	save_complete: SD_SAVE_COMPLETE assign set_save_complete
		do
			create Result.make_shared (c_save_complete (c_pointer))
		end

	shutdown_cancelled: SD_SHUTDOWN_CANCELLED assign set_shutdown_cancelled
		do
			create Result.make_shared (c_shutdown_cancelled (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_save_yourself (a_save_yourself: SD_SAVE_YOURSELF)
		do
			save_yourself.ce_gets (a_save_yourself)
		end

	set_die (a_die: SD_DIE)
		do
			die.ce_gets (a_die)
		end

	set_save_complete (a_save_complete: SD_SAVE_COMPLETE)
		do
			save_complete.ce_gets (a_save_complete)
		end

	set_shutdown_cancelled (a_shutdown_cancelled: SD_SHUTDOWN_CANCELLED)
		do
			shutdown_cancelled.ce_gets (a_shutdown_cancelled)
		end

feature {NONE} -- C getters

	c_save_yourself (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct __anonstruct_save_yourself_563 *)&((struct __anonstruct_SmcCallbacks_562 *)$tmp)->save_yourself;"
		end

	c_die (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct __anonstruct_die_564 *)&((struct __anonstruct_SmcCallbacks_562 *)$tmp)->die;"
		end

	c_save_complete (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct __anonstruct_save_complete_565 *)&((struct __anonstruct_SmcCallbacks_562 *)$tmp)->save_complete;"
		end

	c_shutdown_cancelled (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct __anonstruct_shutdown_cancelled_566 *)&((struct __anonstruct_SmcCallbacks_562 *)$tmp)->shutdown_cancelled;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_SmcCallbacks_562);"
		end

end
