class
	SD_UTIMBUF

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	actime: INTEGER_32 assign set_actime
		do
			Result := c_actime (c_pointer)
		end

	modtime: INTEGER_32 assign set_modtime
		do
			Result := c_modtime (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_actime (a_actime: INTEGER_32)
		do
			c_set_actime (c_pointer, a_actime)
		end

	set_modtime (a_modtime: INTEGER_32)
		do
			c_set_modtime (c_pointer, a_modtime)
		end

feature {NONE} -- C getters

	c_actime (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct utimbuf *)$tmp)->actime;"
		end

	c_modtime (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct utimbuf *)$tmp)->modtime;"
		end

feature {NONE} -- C setters

	c_set_actime (tmp: POINTER; a_actime: INTEGER_32)
		external
			"C inline"
		alias
			"((struct utimbuf *)$tmp)->actime = $a_actime;"
		end

	c_set_modtime (tmp: POINTER; a_modtime: INTEGER_32)
		external
			"C inline"
		alias
			"((struct utimbuf *)$tmp)->modtime = $a_modtime;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct utimbuf);"
		end

end
