class
	SD_XCONFIGUREEVENT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	serial: NATURAL_32 assign set_serial
		do
			Result := c_serial (c_pointer)
		end

	send_event: INTEGER_32 assign set_send_event
		do
			Result := c_send_event (c_pointer)
		end

	display: CE_POINTER [ANY] assign set_display
		do
			create Result.make_shared (c_display (c_pointer))
		end

	event: NATURAL_32 assign set_event
		do
			Result := c_event (c_pointer)
		end

	window: NATURAL_32 assign set_window
		do
			Result := c_window (c_pointer)
		end

	x: INTEGER_32 assign set_x
		do
			Result := c_x (c_pointer)
		end

	y: INTEGER_32 assign set_y
		do
			Result := c_y (c_pointer)
		end

	width: INTEGER_32 assign set_width
		do
			Result := c_width (c_pointer)
		end

	height: INTEGER_32 assign set_height
		do
			Result := c_height (c_pointer)
		end

	border_width: INTEGER_32 assign set_border_width
		do
			Result := c_border_width (c_pointer)
		end

	above: NATURAL_32 assign set_above
		do
			Result := c_above (c_pointer)
		end

	override_redirect: INTEGER_32 assign set_override_redirect
		do
			Result := c_override_redirect (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_serial (a_serial: NATURAL_32)
		do
			c_set_serial (c_pointer, a_serial)
		end

	set_send_event (a_send_event: INTEGER_32)
		do
			c_set_send_event (c_pointer, a_send_event)
		end

	set_display (a_display: CE_POINTER [ANY])
		do
			c_set_display (c_pointer, a_display.c_pointer)
		end

	set_event (a_event: NATURAL_32)
		do
			c_set_event (c_pointer, a_event)
		end

	set_window (a_window: NATURAL_32)
		do
			c_set_window (c_pointer, a_window)
		end

	set_x (a_x: INTEGER_32)
		do
			c_set_x (c_pointer, a_x)
		end

	set_y (a_y: INTEGER_32)
		do
			c_set_y (c_pointer, a_y)
		end

	set_width (a_width: INTEGER_32)
		do
			c_set_width (c_pointer, a_width)
		end

	set_height (a_height: INTEGER_32)
		do
			c_set_height (c_pointer, a_height)
		end

	set_border_width (a_border_width: INTEGER_32)
		do
			c_set_border_width (c_pointer, a_border_width)
		end

	set_above (a_above: NATURAL_32)
		do
			c_set_above (c_pointer, a_above)
		end

	set_override_redirect (a_override_redirect: INTEGER_32)
		do
			c_set_override_redirect (c_pointer, a_override_redirect)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XConfigureEvent_384 *)$tmp)->type;"
		end

	c_serial (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XConfigureEvent_384 *)$tmp)->serial;"
		end

	c_send_event (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XConfigureEvent_384 *)$tmp)->send_event;"
		end

	c_display (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_XConfigureEvent_384 *)$tmp)->display;"
		end

	c_event (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XConfigureEvent_384 *)$tmp)->event;"
		end

	c_window (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XConfigureEvent_384 *)$tmp)->window;"
		end

	c_x (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XConfigureEvent_384 *)$tmp)->x;"
		end

	c_y (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XConfigureEvent_384 *)$tmp)->y;"
		end

	c_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XConfigureEvent_384 *)$tmp)->width;"
		end

	c_height (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XConfigureEvent_384 *)$tmp)->height;"
		end

	c_border_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XConfigureEvent_384 *)$tmp)->border_width;"
		end

	c_above (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XConfigureEvent_384 *)$tmp)->above;"
		end

	c_override_redirect (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XConfigureEvent_384 *)$tmp)->override_redirect;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XConfigureEvent_384 *)$tmp)->type = $a_type;"
		end

	c_set_serial (tmp: POINTER; a_serial: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XConfigureEvent_384 *)$tmp)->serial = $a_serial;"
		end

	c_set_send_event (tmp: POINTER; a_send_event: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XConfigureEvent_384 *)$tmp)->send_event = $a_send_event;"
		end

	c_set_display (tmp: POINTER; a_display: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_XConfigureEvent_384 *)$tmp)->display = (void *)$a_display;"
		end

	c_set_event (tmp: POINTER; a_event: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XConfigureEvent_384 *)$tmp)->event = $a_event;"
		end

	c_set_window (tmp: POINTER; a_window: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XConfigureEvent_384 *)$tmp)->window = $a_window;"
		end

	c_set_x (tmp: POINTER; a_x: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XConfigureEvent_384 *)$tmp)->x = $a_x;"
		end

	c_set_y (tmp: POINTER; a_y: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XConfigureEvent_384 *)$tmp)->y = $a_y;"
		end

	c_set_width (tmp: POINTER; a_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XConfigureEvent_384 *)$tmp)->width = $a_width;"
		end

	c_set_height (tmp: POINTER; a_height: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XConfigureEvent_384 *)$tmp)->height = $a_height;"
		end

	c_set_border_width (tmp: POINTER; a_border_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XConfigureEvent_384 *)$tmp)->border_width = $a_border_width;"
		end

	c_set_above (tmp: POINTER; a_above: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XConfigureEvent_384 *)$tmp)->above = $a_above;"
		end

	c_set_override_redirect (tmp: POINTER; a_override_redirect: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XConfigureEvent_384 *)$tmp)->override_redirect = $a_override_redirect;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_XConfigureEvent_384);"
		end

end
