class
	SD_XGENERICEVENT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	serial: NATURAL_32 assign set_serial
		do
			Result := c_serial (c_pointer)
		end

	send_event: INTEGER_32 assign set_send_event
		do
			Result := c_send_event (c_pointer)
		end

	display: CE_POINTER [ANY] assign set_display
		do
			create Result.make_shared (c_display (c_pointer))
		end

	extension: INTEGER_32 assign set_extension
		do
			Result := c_extension (c_pointer)
		end

	evtype: INTEGER_32 assign set_evtype
		do
			Result := c_evtype (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_serial (a_serial: NATURAL_32)
		do
			c_set_serial (c_pointer, a_serial)
		end

	set_send_event (a_send_event: INTEGER_32)
		do
			c_set_send_event (c_pointer, a_send_event)
		end

	set_display (a_display: CE_POINTER [ANY])
		do
			c_set_display (c_pointer, a_display.c_pointer)
		end

	set_extension (a_extension: INTEGER_32)
		do
			c_set_extension (c_pointer, a_extension)
		end

	set_evtype (a_evtype: INTEGER_32)
		do
			c_set_evtype (c_pointer, a_evtype)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XGenericEvent_400 *)$tmp)->type;"
		end

	c_serial (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XGenericEvent_400 *)$tmp)->serial;"
		end

	c_send_event (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XGenericEvent_400 *)$tmp)->send_event;"
		end

	c_display (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_XGenericEvent_400 *)$tmp)->display;"
		end

	c_extension (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XGenericEvent_400 *)$tmp)->extension;"
		end

	c_evtype (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XGenericEvent_400 *)$tmp)->evtype;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGenericEvent_400 *)$tmp)->type = $a_type;"
		end

	c_set_serial (tmp: POINTER; a_serial: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGenericEvent_400 *)$tmp)->serial = $a_serial;"
		end

	c_set_send_event (tmp: POINTER; a_send_event: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGenericEvent_400 *)$tmp)->send_event = $a_send_event;"
		end

	c_set_display (tmp: POINTER; a_display: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGenericEvent_400 *)$tmp)->display = (void *)$a_display;"
		end

	c_set_extension (tmp: POINTER; a_extension: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGenericEvent_400 *)$tmp)->extension = $a_extension;"
		end

	c_set_evtype (tmp: POINTER; a_evtype: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XGenericEvent_400 *)$tmp)->evtype = $a_evtype;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_XGenericEvent_400);"
		end

end
