class
	SD_XRMOPTIONDESCREC

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	option: CE_POINTER [INTEGER_8] assign set_option
		do
			create Result.make_shared (c_option (c_pointer))
		end

	specifier: CE_POINTER [INTEGER_8] assign set_specifier
		do
			create Result.make_shared (c_specifier (c_pointer))
		end

	argKind: INTEGER_32 assign set_argKind
		do
			Result := c_argKind (c_pointer)
		end

	value: CE_POINTER [INTEGER_8] assign set_value
		do
			create Result.make_shared (c_value (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_option (a_option: CE_POINTER [INTEGER_8])
		do
			c_set_option (c_pointer, a_option.c_pointer)
		end

	set_specifier (a_specifier: CE_POINTER [INTEGER_8])
		do
			c_set_specifier (c_pointer, a_specifier.c_pointer)
		end

	set_argKind (a_argKind: INTEGER_32)
		do
			c_set_argKind (c_pointer, a_argKind)
		end

	set_value (a_value: CE_POINTER [INTEGER_8])
		do
			c_set_value (c_pointer, a_value.c_pointer)
		end

feature {NONE} -- C getters

	c_option (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_XrmOptionDescRec_438 *)$tmp)->option;"
		end

	c_specifier (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_XrmOptionDescRec_438 *)$tmp)->specifier;"
		end

	c_argKind (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XrmOptionDescRec_438 *)$tmp)->argKind;"
		end

	c_value (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_XrmOptionDescRec_438 *)$tmp)->value;"
		end

feature {NONE} -- C setters

	c_set_option (tmp: POINTER; a_option: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_XrmOptionDescRec_438 *)$tmp)->option = (char *)$a_option;"
		end

	c_set_specifier (tmp: POINTER; a_specifier: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_XrmOptionDescRec_438 *)$tmp)->specifier = (char *)$a_specifier;"
		end

	c_set_argKind (tmp: POINTER; a_argKind: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XrmOptionDescRec_438 *)$tmp)->argKind = $a_argkind;"
		end

	c_set_value (tmp: POINTER; a_value: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_XrmOptionDescRec_438 *)$tmp)->value = (char *)$a_value;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_XrmOptionDescRec_438);"
		end

end
