class
	SD_XSELECTIONREQUESTEVENT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	serial: NATURAL_32 assign set_serial
		do
			Result := c_serial (c_pointer)
		end

	send_event: INTEGER_32 assign set_send_event
		do
			Result := c_send_event (c_pointer)
		end

	display: CE_POINTER [ANY] assign set_display
		do
			create Result.make_shared (c_display (c_pointer))
		end

	owner: NATURAL_32 assign set_owner
		do
			Result := c_owner (c_pointer)
		end

	requestor: NATURAL_32 assign set_requestor
		do
			Result := c_requestor (c_pointer)
		end

	selection: NATURAL_32 assign set_selection
		do
			Result := c_selection (c_pointer)
		end

	target: NATURAL_32 assign set_target
		do
			Result := c_target (c_pointer)
		end

	property: NATURAL_32 assign set_property
		do
			Result := c_property (c_pointer)
		end

	time: NATURAL_32 assign set_time
		do
			Result := c_time (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_serial (a_serial: NATURAL_32)
		do
			c_set_serial (c_pointer, a_serial)
		end

	set_send_event (a_send_event: INTEGER_32)
		do
			c_set_send_event (c_pointer, a_send_event)
		end

	set_display (a_display: CE_POINTER [ANY])
		do
			c_set_display (c_pointer, a_display.c_pointer)
		end

	set_owner (a_owner: NATURAL_32)
		do
			c_set_owner (c_pointer, a_owner)
		end

	set_requestor (a_requestor: NATURAL_32)
		do
			c_set_requestor (c_pointer, a_requestor)
		end

	set_selection (a_selection: NATURAL_32)
		do
			c_set_selection (c_pointer, a_selection)
		end

	set_target (a_target: NATURAL_32)
		do
			c_set_target (c_pointer, a_target)
		end

	set_property (a_property: NATURAL_32)
		do
			c_set_property (c_pointer, a_property)
		end

	set_time (a_time: NATURAL_32)
		do
			c_set_time (c_pointer, a_time)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XSelectionRequestEvent_392 *)$tmp)->type;"
		end

	c_serial (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XSelectionRequestEvent_392 *)$tmp)->serial;"
		end

	c_send_event (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XSelectionRequestEvent_392 *)$tmp)->send_event;"
		end

	c_display (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_XSelectionRequestEvent_392 *)$tmp)->display;"
		end

	c_owner (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XSelectionRequestEvent_392 *)$tmp)->owner;"
		end

	c_requestor (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XSelectionRequestEvent_392 *)$tmp)->requestor;"
		end

	c_selection (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XSelectionRequestEvent_392 *)$tmp)->selection;"
		end

	c_target (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XSelectionRequestEvent_392 *)$tmp)->target;"
		end

	c_property (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XSelectionRequestEvent_392 *)$tmp)->property;"
		end

	c_time (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XSelectionRequestEvent_392 *)$tmp)->time;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSelectionRequestEvent_392 *)$tmp)->type = $a_type;"
		end

	c_set_serial (tmp: POINTER; a_serial: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSelectionRequestEvent_392 *)$tmp)->serial = $a_serial;"
		end

	c_set_send_event (tmp: POINTER; a_send_event: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSelectionRequestEvent_392 *)$tmp)->send_event = $a_send_event;"
		end

	c_set_display (tmp: POINTER; a_display: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSelectionRequestEvent_392 *)$tmp)->display = (void *)$a_display;"
		end

	c_set_owner (tmp: POINTER; a_owner: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSelectionRequestEvent_392 *)$tmp)->owner = $a_owner;"
		end

	c_set_requestor (tmp: POINTER; a_requestor: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSelectionRequestEvent_392 *)$tmp)->requestor = $a_requestor;"
		end

	c_set_selection (tmp: POINTER; a_selection: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSelectionRequestEvent_392 *)$tmp)->selection = $a_selection;"
		end

	c_set_target (tmp: POINTER; a_target: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSelectionRequestEvent_392 *)$tmp)->target = $a_target;"
		end

	c_set_property (tmp: POINTER; a_property: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSelectionRequestEvent_392 *)$tmp)->property = $a_property;"
		end

	c_set_time (tmp: POINTER; a_time: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSelectionRequestEvent_392 *)$tmp)->time = $a_time;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_XSelectionRequestEvent_392);"
		end

end
