class
	SD_XTEXTPROPERTY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	value: CE_POINTER [NATURAL_8] assign set_value
		do
			create Result.make_shared (c_value (c_pointer))
		end

	encoding: NATURAL_32 assign set_encoding
		do
			Result := c_encoding (c_pointer)
		end

	format: INTEGER_32 assign set_format
		do
			Result := c_format (c_pointer)
		end

	nitems: NATURAL_32 assign set_nitems
		do
			Result := c_nitems (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_value (a_value: CE_POINTER [NATURAL_8])
		do
			c_set_value (c_pointer, a_value.c_pointer)
		end

	set_encoding (a_encoding: NATURAL_32)
		do
			c_set_encoding (c_pointer, a_encoding)
		end

	set_format (a_format: INTEGER_32)
		do
			c_set_format (c_pointer, a_format)
		end

	set_nitems (a_nitems: NATURAL_32)
		do
			c_set_nitems (c_pointer, a_nitems)
		end

feature {NONE} -- C getters

	c_value (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_XTextProperty_429 *)$tmp)->value;"
		end

	c_encoding (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XTextProperty_429 *)$tmp)->encoding;"
		end

	c_format (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XTextProperty_429 *)$tmp)->format;"
		end

	c_nitems (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XTextProperty_429 *)$tmp)->nitems;"
		end

feature {NONE} -- C setters

	c_set_value (tmp: POINTER; a_value: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_XTextProperty_429 *)$tmp)->value = (unsigned char *)$a_value;"
		end

	c_set_encoding (tmp: POINTER; a_encoding: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XTextProperty_429 *)$tmp)->encoding = $a_encoding;"
		end

	c_set_format (tmp: POINTER; a_format: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XTextProperty_429 *)$tmp)->format = $a_format;"
		end

	c_set_nitems (tmp: POINTER; a_nitems: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XTextProperty_429 *)$tmp)->nitems = $a_nitems;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_XTextProperty_429);"
		end

end
