class
	SD_XWMHINTS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	flags: INTEGER_32 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

	input: INTEGER_32 assign set_input
		do
			Result := c_input (c_pointer)
		end

	initial_state: INTEGER_32 assign set_initial_state
		do
			Result := c_initial_state (c_pointer)
		end

	icon_pixmap: NATURAL_32 assign set_icon_pixmap
		do
			Result := c_icon_pixmap (c_pointer)
		end

	icon_window: NATURAL_32 assign set_icon_window
		do
			Result := c_icon_window (c_pointer)
		end

	icon_x: INTEGER_32 assign set_icon_x
		do
			Result := c_icon_x (c_pointer)
		end

	icon_y: INTEGER_32 assign set_icon_y
		do
			Result := c_icon_y (c_pointer)
		end

	icon_mask: NATURAL_32 assign set_icon_mask
		do
			Result := c_icon_mask (c_pointer)
		end

	window_group: NATURAL_32 assign set_window_group
		do
			Result := c_window_group (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_flags (a_flags: INTEGER_32)
		do
			c_set_flags (c_pointer, a_flags)
		end

	set_input (a_input: INTEGER_32)
		do
			c_set_input (c_pointer, a_input)
		end

	set_initial_state (a_initial_state: INTEGER_32)
		do
			c_set_initial_state (c_pointer, a_initial_state)
		end

	set_icon_pixmap (a_icon_pixmap: NATURAL_32)
		do
			c_set_icon_pixmap (c_pointer, a_icon_pixmap)
		end

	set_icon_window (a_icon_window: NATURAL_32)
		do
			c_set_icon_window (c_pointer, a_icon_window)
		end

	set_icon_x (a_icon_x: INTEGER_32)
		do
			c_set_icon_x (c_pointer, a_icon_x)
		end

	set_icon_y (a_icon_y: INTEGER_32)
		do
			c_set_icon_y (c_pointer, a_icon_y)
		end

	set_icon_mask (a_icon_mask: NATURAL_32)
		do
			c_set_icon_mask (c_pointer, a_icon_mask)
		end

	set_window_group (a_window_group: NATURAL_32)
		do
			c_set_window_group (c_pointer, a_window_group)
		end

feature {NONE} -- C getters

	c_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_XWMHints_428 *)$tmp)->flags;"
		end

	c_input (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XWMHints_428 *)$tmp)->input;"
		end

	c_initial_state (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XWMHints_428 *)$tmp)->initial_state;"
		end

	c_icon_pixmap (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XWMHints_428 *)$tmp)->icon_pixmap;"
		end

	c_icon_window (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XWMHints_428 *)$tmp)->icon_window;"
		end

	c_icon_x (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XWMHints_428 *)$tmp)->icon_x;"
		end

	c_icon_y (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XWMHints_428 *)$tmp)->icon_y;"
		end

	c_icon_mask (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XWMHints_428 *)$tmp)->icon_mask;"
		end

	c_window_group (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XWMHints_428 *)$tmp)->window_group;"
		end

feature {NONE} -- C setters

	c_set_flags (tmp: POINTER; a_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XWMHints_428 *)$tmp)->flags = $a_flags;"
		end

	c_set_input (tmp: POINTER; a_input: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XWMHints_428 *)$tmp)->input = $a_input;"
		end

	c_set_initial_state (tmp: POINTER; a_initial_state: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XWMHints_428 *)$tmp)->initial_state = $a_initial_state;"
		end

	c_set_icon_pixmap (tmp: POINTER; a_icon_pixmap: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XWMHints_428 *)$tmp)->icon_pixmap = $a_icon_pixmap;"
		end

	c_set_icon_window (tmp: POINTER; a_icon_window: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XWMHints_428 *)$tmp)->icon_window = $a_icon_window;"
		end

	c_set_icon_x (tmp: POINTER; a_icon_x: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XWMHints_428 *)$tmp)->icon_x = $a_icon_x;"
		end

	c_set_icon_y (tmp: POINTER; a_icon_y: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XWMHints_428 *)$tmp)->icon_y = $a_icon_y;"
		end

	c_set_icon_mask (tmp: POINTER; a_icon_mask: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XWMHints_428 *)$tmp)->icon_mask = $a_icon_mask;"
		end

	c_set_window_group (tmp: POINTER; a_window_group: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XWMHints_428 *)$tmp)->window_group = $a_window_group;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_XWMHints_428);"
		end

end
