deferred class
	S_DIRENT

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	opendir (a_name: CE_POINTER [INTEGER_8]): CE_POINTER [ANY]
		do
			create Result.make_shared (c_opendir (a_name.c_pointer))
		end

	c_opendir (a_name: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return opendir($a_name);"
		end

	closedir (a_dirp: CE_POINTER [ANY]): INTEGER_32
		do
			Result := c_closedir (a_dirp.c_pointer)
		end

	c_closedir (a_dirp: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return closedir($a_dirp);"
		end

	readdir (a_dirp: CE_POINTER [ANY]): CE_POINTER [SD_DIRENT]
		do
			create Result.make_shared (c_readdir (a_dirp.c_pointer))
		end

	c_readdir (a_dirp: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return readdir($a_dirp);"
		end

end
