deferred class
	S_ICONV

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	iconv (a_cd: CE_POINTER [ANY]; a_inbuf: CE_POINTER [CE_POINTER [INTEGER_8]]; a_inbytesleft: CE_POINTER [NATURAL_32]; a_outbuf: CE_POINTER [CE_POINTER [INTEGER_8]]; a_outbytesleft: CE_POINTER [NATURAL_32]): NATURAL_32
		do
			Result := c_iconv (a_cd.c_pointer, a_inbuf.c_pointer, a_inbytesleft.c_pointer, a_outbuf.c_pointer, a_outbytesleft.c_pointer)
		end

	c_iconv (a_cd: POINTER; a_inbuf: POINTER; a_inbytesleft: POINTER; a_outbuf: POINTER; a_outbytesleft: POINTER): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return iconv($a_cd, $a_inbuf, $a_inbytesleft, $a_outbuf, $a_outbytesleft);"
		end

	iconv_close (a_cd: CE_POINTER [ANY]): INTEGER_32
		do
			Result := c_iconv_close (a_cd.c_pointer)
		end

	c_iconv_close (a_cd: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return iconv_close($a_cd);"
		end

	iconv_open (a_tocode: CE_POINTER [INTEGER_8]; a_fromcode: CE_POINTER [INTEGER_8]): CE_POINTER [ANY]
		do
			create Result.make_shared (c_iconv_open (a_tocode.c_pointer, a_fromcode.c_pointer))
		end

	c_iconv_open (a_tocode: POINTER; a_fromcode: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return iconv_open($a_tocode, $a_fromcode);"
		end

end
