deferred class
	S_MATH

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	acos (a_x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return acos($a_x);"
		end

	asin (a_x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return asin($a_x);"
		end

	atan (a_x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return atan($a_x);"
		end

	atan2 (a_y: REAL_64; a_x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return atan2($a_y, $a_x);"
		end

	cos (a_x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return cos($a_x);"
		end

	sin (a_x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return sin($a_x);"
		end

	tan (a_x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return tan($a_x);"
		end

	cosh (a_x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return cosh($a_x);"
		end

	sinh (a_x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return sinh($a_x);"
		end

	tanh (a_x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return tanh($a_x);"
		end

	exp (a_x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return exp($a_x);"
		end

	log (a_x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return log($a_x);"
		end

	log10 (a_x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return log10($a_x);"
		end

	pow (a_x: REAL_64; a_y: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return pow($a_x, $a_y);"
		end

	sqrt (a_x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return sqrt($a_x);"
		end

	ceil (a_x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return ceil($a_x);"
		end

	fabs (a_x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return fabs($a_x);"
		end

	floor (a_x: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return floor($a_x);"
		end

	fmod (a_x: REAL_64; a_y: REAL_64): REAL_64
		external
			"C inline use <vim.h>"
		alias
			"return fmod($a_x, $a_y);"
		end

end
