deferred class
	S_SYS_STAT

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	stat (a_file: CE_POINTER [INTEGER_8]; a_buf: CE_POINTER [SD_STAT]): INTEGER_32
		do
			Result := c_stat (a_file.c_pointer, a_buf.c_pointer)
		end

	c_stat (a_file: POINTER; a_buf: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return stat($a_file, $a_buf);"
		end

	lstat (a_file: CE_POINTER [INTEGER_8]; a_buf: CE_POINTER [SD_STAT]): INTEGER_32
		do
			Result := c_lstat (a_file.c_pointer, a_buf.c_pointer)
		end

	c_lstat (a_file: POINTER; a_buf: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return lstat($a_file, $a_buf);"
		end

	umask (a_mask: NATURAL_32): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return umask($a_mask);"
		end

	mkdir (a_path: CE_POINTER [INTEGER_8]; a_mode: NATURAL_32): INTEGER_32
		do
			Result := c_mkdir (a_path.c_pointer, a_mode)
		end

	c_mkdir (a_path: POINTER; a_mode: NATURAL_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return mkdir($a_path, $a_mode);"
		end

	fstat (a_fd: INTEGER_32; a_buf: CE_POINTER [SD_STAT]): INTEGER_32
		do
			Result := c_fstat (a_fd, a_buf.c_pointer)
		end

	c_fstat (a_fd: INTEGER_32; a_buf: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return fstat($a_fd, $a_buf);"
		end

	chmod (a_file: CE_POINTER [INTEGER_8]; a_mode: NATURAL_32): INTEGER_32
		do
			Result := c_chmod (a_file.c_pointer, a_mode)
		end

	c_chmod (a_file: POINTER; a_mode: NATURAL_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return chmod($a_file, $a_mode);"
		end

end
