class
	VIM_ASSEMBLER

feature {NONE}

	asm1 (op1: CE_POINTER [INTEGER_32]; op2: CE_POINTER [INTEGER_32]; op3: CE_POINTER [SD_FD_SET])
		do
			c_asm1 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm1 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"[
				int __d0 = *(int *)$op1;
				int __d1 = *(int *)$op2;
				fd_set fds = *(fd_set *)$op3;

				__asm__ volatile ("cld; rep; stosl"
						: "=c" (__d0), "=D" (__d1)
						: "a" (0), "0" (sizeof(struct __anonstruct_fd_set_9) / sizeof(long)), "1" (&fds.fds_bits[0])
						: "memory"
					);

				*(int *)$op1 = __d0;
				*(int *)$op2 = __d1;
				*(fd_set *)$op3 = fds;
			]"
		end

	asm2 (op1: CE_POINTER [SD_FD_SET]; op2: CE_POINTER [CE_POINTER [ANY]])
		do
			c_asm2 (op1.c_pointer, op2.c_pointer)
		end

	c_asm2 (op1: POINTER; op2: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"[
				fd_set fds = *(fd_set *)$op1;
				void * dpy = *(void * *)$op2;

				__asm__ volatile ("btsl %1,%0"
						: "=m" (fds.fds_bits[(unsigned int)((struct __anonstruct__XPrivDisplay_367 *)dpy)->fd / (8u * sizeof(unsigned long))])
						: "r" ((unsigned int)((struct __anonstruct__XPrivDisplay_367 *)dpy)->fd % (8u * sizeof(unsigned long)))
						: "cc", "memory"
					);

				*(fd_set *)$op1 = fds;
				*(void * *)$op2 = dpy;
			]"
		end

	asm3 (op1: CE_POINTER [INTEGER_32]; op2: CE_POINTER [INTEGER_32]; op3: CE_POINTER [SD_FD_SET])
		do
			c_asm3 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm3 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"[
				int __d0 = *(int *)$op1;
				int __d1 = *(int *)$op2;
				fd_set rfds = *(fd_set *)$op3;

				__asm__ volatile ("cld; rep; stosl"
						: "=c" (__d0), "=D" (__d1)
						: "a" (0), "0" (sizeof(struct __anonstruct_fd_set_9) / sizeof(long)), "1" (&rfds.fds_bits[0])
						: "memory"
					);

				*(int *)$op1 = __d0;
				*(int *)$op2 = __d1;
				*(fd_set *)$op3 = rfds;
			]"
		end

	asm4 (op1: CE_POINTER [INTEGER_32]; op2: CE_POINTER [INTEGER_32]; op3: CE_POINTER [SD_FD_SET])
		do
			c_asm4 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm4 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"[
				int __d0___0 = *(int *)$op1;
				int __d1___0 = *(int *)$op2;
				fd_set efds = *(fd_set *)$op3;

				__asm__ volatile ("cld; rep; stosl"
						: "=c" (__d0___0), "=D" (__d1___0)
						: "a" (0), "0" (sizeof(struct __anonstruct_fd_set_9) / sizeof(long)), "1" (&efds.fds_bits[0])
						: "memory"
					);

				*(int *)$op1 = __d0___0;
				*(int *)$op2 = __d1___0;
				*(fd_set *)$op3 = efds;
			]"
		end

	asm5 (op1: CE_POINTER [SD_FD_SET]; op2: CE_POINTER [INTEGER_32])
		do
			c_asm5 (op1.c_pointer, op2.c_pointer)
		end

	c_asm5 (op1: POINTER; op2: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"[
				fd_set rfds = *(fd_set *)$op1;
				int fd = *(int *)$op2;

				__asm__ volatile ("btsl %1,%0"
						: "=m" (rfds.fds_bits[(unsigned int)fd / (8u * sizeof(unsigned long))])
						: "r" ((unsigned int)fd % (8u * sizeof(unsigned long)))
						: "cc", "memory"
					);

				*(fd_set *)$op1 = rfds;
				*(int *)$op2 = fd;
			]"
		end

	asm6 (op1: CE_POINTER [SD_FD_SET]; op2: CE_POINTER [INTEGER_32])
		do
			c_asm6 (op1.c_pointer, op2.c_pointer)
		end

	c_asm6 (op1: POINTER; op2: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"[
				fd_set efds = *(fd_set *)$op1;
				int fd = *(int *)$op2;

				__asm__ volatile ("btsl %1,%0"
						: "=m" (efds.fds_bits[(unsigned int)fd / (8u * sizeof(unsigned long))])
						: "r" ((unsigned int)fd % (8u * sizeof(unsigned long)))
						: "cc", "memory"
					);

				*(fd_set *)$op1 = efds;
				*(int *)$op2 = fd;
			]"
		end

	asm7 (op1: CE_POINTER [SD_FD_SET]; op2: CE_POINTER [CE_POINTER [ANY]])
		do
			c_asm7 (op1.c_pointer, op2.c_pointer)
		end

	c_asm7 (op1: POINTER; op2: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"[
				fd_set rfds = *(fd_set *)$op1;
				void * xterm_dpy = *(void * *)$op2;

				__asm__ volatile ("btsl %1,%0"
						: "=m" (rfds.fds_bits[(unsigned int)((struct __anonstruct__XPrivDisplay_367 *)xterm_dpy)->fd / (8u * sizeof(unsigned long))])
						: "r" ((unsigned int)((struct __anonstruct__XPrivDisplay_367 *)xterm_dpy)->fd % (8u * sizeof(unsigned long)))
						: "cc", "memory"
					);

				*(fd_set *)$op1 = rfds;
				*(void * *)$op2 = xterm_dpy;
			]"
		end

	asm8 (op1: CE_POINTER [SD_FD_SET]; op2: CE_POINTER [INTEGER_32])
		do
			c_asm8 (op1.c_pointer, op2.c_pointer)
		end

	c_asm8 (op1: POINTER; op2: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"[
				fd_set rfds = *(fd_set *)$op1;
				int xsmp_icefd = *(int *)$op2;

				__asm__ volatile ("btsl %1,%0"
						: "=m" (rfds.fds_bits[(unsigned int)xsmp_icefd / (8u * sizeof(unsigned long))])
						: "r" ((unsigned int)xsmp_icefd % (8u * sizeof(unsigned long)))
						: "cc", "memory"
					);

				*(fd_set *)$op1 = rfds;
				*(int *)$op2 = xsmp_icefd;
			]"
		end

	asm9 (op1: CE_POINTER [SD_FD_SET]; op2: CE_POINTER [INTEGER_32])
		do
			c_asm9 (op1.c_pointer, op2.c_pointer)
		end

	c_asm9 (op1: POINTER; op2: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"[
				fd_set efds = *(fd_set *)$op1;
				int xsmp_icefd = *(int *)$op2;

				__asm__ volatile ("btsl %1,%0"
						: "=m" (efds.fds_bits[(unsigned int)xsmp_icefd / (8u * sizeof(unsigned long))])
						: "r" ((unsigned int)xsmp_icefd % (8u * sizeof(unsigned long)))
						: "cc", "memory"
					);

				*(fd_set *)$op1 = efds;
				*(int *)$op2 = xsmp_icefd;
			]"
		end

	asm10 (op1: CE_POINTER [SD_FD_SET]; op2: CE_POINTER [INTEGER_32])
		do
			c_asm10 (op1.c_pointer, op2.c_pointer)
		end

	c_asm10 (op1: POINTER; op2: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"[
				fd_set rfds = *(fd_set *)$op1;
				int nb_fd = *(int *)$op2;

				__asm__ volatile ("btsl %1,%0"
						: "=m" (rfds.fds_bits[(unsigned int)nb_fd / (8u * sizeof(unsigned long))])
						: "r" ((unsigned int)nb_fd % (8u * sizeof(unsigned long)))
						: "cc", "memory"
					);

				*(fd_set *)$op1 = rfds;
				*(int *)$op2 = nb_fd;
			]"
		end

	asm11 (op1: CE_POINTER [INTEGER_8]; op2: CE_POINTER [CE_POINTER [ANY]]; op3: CE_POINTER [SD_FD_SET])
		do
			c_asm11 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm11 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"[
				register char __result = *(char *)$op1;
				void * xterm_dpy = *(void * *)$op2;
				fd_set rfds = *(fd_set *)$op3;

				__asm__ volatile ("btl %1,%2 ; setcb %b0"
						: "=q" (__result)
						: "r" ((unsigned int)((struct __anonstruct__XPrivDisplay_367 *)xterm_dpy)->fd % (8u * sizeof(unsigned long))), "m" (rfds.fds_bits[(unsigned int)((struct __anonstruct__XPrivDisplay_367 *)xterm_dpy)->fd / (8u * sizeof(unsigned long))])
						: "cc"
					);

				*(char *)$op1 = __result;
				*(void * *)$op2 = xterm_dpy;
				*(fd_set *)$op3 = rfds;
			]"
		end

	asm12 (op1: CE_POINTER [INTEGER_8]; op2: CE_POINTER [INTEGER_32]; op3: CE_POINTER [SD_FD_SET])
		do
			c_asm12 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm12 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"[
				register char __result___1 = *(char *)$op1;
				int xsmp_icefd = *(int *)$op2;
				fd_set efds = *(fd_set *)$op3;

				__asm__ volatile ("btl %1,%2 ; setcb %b0"
						: "=q" (__result___1)
						: "r" ((unsigned int)xsmp_icefd % (8u * sizeof(unsigned long))), "m" (efds.fds_bits[(unsigned int)xsmp_icefd / (8u * sizeof(unsigned long))])
						: "cc"
					);

				*(char *)$op1 = __result___1;
				*(int *)$op2 = xsmp_icefd;
				*(fd_set *)$op3 = efds;
			]"
		end

	asm13 (op1: CE_POINTER [INTEGER_8]; op2: CE_POINTER [INTEGER_32]; op3: CE_POINTER [SD_FD_SET])
		do
			c_asm13 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm13 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"[
				register char __result___0 = *(char *)$op1;
				int xsmp_icefd = *(int *)$op2;
				fd_set rfds = *(fd_set *)$op3;

				__asm__ volatile ("btl %1,%2 ; setcb %b0"
						: "=q" (__result___0)
						: "r" ((unsigned int)xsmp_icefd % (8u * sizeof(unsigned long))), "m" (rfds.fds_bits[(unsigned int)xsmp_icefd / (8u * sizeof(unsigned long))])
						: "cc"
					);

				*(char *)$op1 = __result___0;
				*(int *)$op2 = xsmp_icefd;
				*(fd_set *)$op3 = rfds;
			]"
		end

	asm14 (op1: CE_POINTER [INTEGER_8]; op2: CE_POINTER [INTEGER_32]; op3: CE_POINTER [SD_FD_SET])
		do
			c_asm14 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm14 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"[
				register char __result___2 = *(char *)$op1;
				int nb_fd = *(int *)$op2;
				fd_set rfds = *(fd_set *)$op3;

				__asm__ volatile ("btl %1,%2 ; setcb %b0"
						: "=q" (__result___2)
						: "r" ((unsigned int)nb_fd % (8u * sizeof(unsigned long))), "m" (rfds.fds_bits[(unsigned int)nb_fd / (8u * sizeof(unsigned long))])
						: "cc"
					);

				*(char *)$op1 = __result___2;
				*(int *)$op2 = nb_fd;
				*(fd_set *)$op3 = rfds;
			]"
		end

	asm15 (op1: CE_POINTER [INTEGER_32]; op2: CE_POINTER [INTEGER_32]; op3: CE_POINTER [SD_FD_SET])
		do
			c_asm15 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm15 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"[
				int __d0 = *(int *)$op1;
				int __d1 = *(int *)$op2;
				fd_set rfds = *(fd_set *)$op3;

				__asm__ volatile ("cld; rep; stosl"
						: "=c" (__d0), "=D" (__d1)
						: "a" (0), "0" (sizeof(struct __anonstruct_fd_set_9) / sizeof(long)), "1" (&rfds.fds_bits[0])
						: "memory"
					);

				*(int *)$op1 = __d0;
				*(int *)$op2 = __d1;
				*(fd_set *)$op3 = rfds;
			]"
		end

	asm16 (op1: CE_POINTER [SD_FD_SET]; op2: CE_POINTER [INTEGER_32])
		do
			c_asm16 (op1.c_pointer, op2.c_pointer)
		end

	c_asm16 (op1: POINTER; op2: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"[
				fd_set rfds = *(fd_set *)$op1;
				int nbsock = *(int *)$op2;

				__asm__ volatile ("btsl %1,%0"
						: "=m" (rfds.fds_bits[(unsigned int)nbsock / (8u * sizeof(unsigned long))])
						: "r" ((unsigned int)nbsock % (8u * sizeof(unsigned long)))
						: "cc", "memory"
					);

				*(fd_set *)$op1 = rfds;
				*(int *)$op2 = nbsock;
			]"
		end

end
