class
	PD_CONNECTBITS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	close: BOOLEAN assign set_close
		do
			Result := c_close (c_pointer)
		end

	reuse: BOOLEAN assign set_reuse
		do
			Result := c_reuse (c_pointer)
		end

	proxy: BOOLEAN assign set_proxy
		do
			Result := c_proxy (c_pointer)
		end

	httpproxy: BOOLEAN assign set_httpproxy
		do
			Result := c_httpproxy (c_pointer)
		end

	user_passwd: BOOLEAN assign set_user_passwd
		do
			Result := c_user_passwd (c_pointer)
		end

	proxy_user_passwd: BOOLEAN assign set_proxy_user_passwd
		do
			Result := c_proxy_user_passwd (c_pointer)
		end

	ipv6_ip: BOOLEAN assign set_ipv6_ip
		do
			Result := c_ipv6_ip (c_pointer)
		end

	ipv6: BOOLEAN assign set_ipv6
		do
			Result := c_ipv6 (c_pointer)
		end

	do_more: BOOLEAN assign set_do_more
		do
			Result := c_do_more (c_pointer)
		end

	tcpconnect: BOOLEAN assign set_tcpconnect
		do
			Result := c_tcpconnect (c_pointer)
		end

	protoconnstart: BOOLEAN assign set_protoconnstart
		do
			Result := c_protoconnstart (c_pointer)
		end

	retry2: BOOLEAN assign set_retry2
		do
			Result := c_retry2 (c_pointer)
		end

	tunnel_proxy: BOOLEAN assign set_tunnel_proxy
		do
			Result := c_tunnel_proxy (c_pointer)
		end

	tunnel_connecting: BOOLEAN assign set_tunnel_connecting
		do
			Result := c_tunnel_connecting (c_pointer)
		end

	authneg: BOOLEAN assign set_authneg
		do
			Result := c_authneg (c_pointer)
		end

	rewindaftersend: BOOLEAN assign set_rewindaftersend
		do
			Result := c_rewindaftersend (c_pointer)
		end

	ftp_use_epsv: BOOLEAN assign set_ftp_use_epsv
		do
			Result := c_ftp_use_epsv (c_pointer)
		end

	ftp_use_eprt: BOOLEAN assign set_ftp_use_eprt
		do
			Result := c_ftp_use_eprt (c_pointer)
		end

	netrc: BOOLEAN assign set_netrc
		do
			Result := c_netrc (c_pointer)
		end

	userpwd_in_url: BOOLEAN assign set_userpwd_in_url
		do
			Result := c_userpwd_in_url (c_pointer)
		end

	done: BOOLEAN assign set_done
		do
			Result := c_done (c_pointer)
		end

	stream_was_rewound: BOOLEAN assign set_stream_was_rewound
		do
			Result := c_stream_was_rewound (c_pointer)
		end

	proxy_connect_closed: BOOLEAN assign set_proxy_connect_closed
		do
			Result := c_proxy_connect_closed (c_pointer)
		end

	bound: BOOLEAN assign set_bound
		do
			Result := c_bound (c_pointer)
		end

	type_set: BOOLEAN assign set_type_set
		do
			Result := c_type_set (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_close (a_close: BOOLEAN)
		do
			c_set_close (c_pointer, a_close)
		end

	set_reuse (a_reuse: BOOLEAN)
		do
			c_set_reuse (c_pointer, a_reuse)
		end

	set_proxy (a_proxy: BOOLEAN)
		do
			c_set_proxy (c_pointer, a_proxy)
		end

	set_httpproxy (a_httpproxy: BOOLEAN)
		do
			c_set_httpproxy (c_pointer, a_httpproxy)
		end

	set_user_passwd (a_user_passwd: BOOLEAN)
		do
			c_set_user_passwd (c_pointer, a_user_passwd)
		end

	set_proxy_user_passwd (a_proxy_user_passwd: BOOLEAN)
		do
			c_set_proxy_user_passwd (c_pointer, a_proxy_user_passwd)
		end

	set_ipv6_ip (a_ipv6_ip: BOOLEAN)
		do
			c_set_ipv6_ip (c_pointer, a_ipv6_ip)
		end

	set_ipv6 (a_ipv6: BOOLEAN)
		do
			c_set_ipv6 (c_pointer, a_ipv6)
		end

	set_do_more (a_do_more: BOOLEAN)
		do
			c_set_do_more (c_pointer, a_do_more)
		end

	set_tcpconnect (a_tcpconnect: BOOLEAN)
		do
			c_set_tcpconnect (c_pointer, a_tcpconnect)
		end

	set_protoconnstart (a_protoconnstart: BOOLEAN)
		do
			c_set_protoconnstart (c_pointer, a_protoconnstart)
		end

	set_retry2 (a_retry2: BOOLEAN)
		do
			c_set_retry2 (c_pointer, a_retry2)
		end

	set_tunnel_proxy (a_tunnel_proxy: BOOLEAN)
		do
			c_set_tunnel_proxy (c_pointer, a_tunnel_proxy)
		end

	set_tunnel_connecting (a_tunnel_connecting: BOOLEAN)
		do
			c_set_tunnel_connecting (c_pointer, a_tunnel_connecting)
		end

	set_authneg (a_authneg: BOOLEAN)
		do
			c_set_authneg (c_pointer, a_authneg)
		end

	set_rewindaftersend (a_rewindaftersend: BOOLEAN)
		do
			c_set_rewindaftersend (c_pointer, a_rewindaftersend)
		end

	set_ftp_use_epsv (a_ftp_use_epsv: BOOLEAN)
		do
			c_set_ftp_use_epsv (c_pointer, a_ftp_use_epsv)
		end

	set_ftp_use_eprt (a_ftp_use_eprt: BOOLEAN)
		do
			c_set_ftp_use_eprt (c_pointer, a_ftp_use_eprt)
		end

	set_netrc (a_netrc: BOOLEAN)
		do
			c_set_netrc (c_pointer, a_netrc)
		end

	set_userpwd_in_url (a_userpwd_in_url: BOOLEAN)
		do
			c_set_userpwd_in_url (c_pointer, a_userpwd_in_url)
		end

	set_done (a_done: BOOLEAN)
		do
			c_set_done (c_pointer, a_done)
		end

	set_stream_was_rewound (a_stream_was_rewound: BOOLEAN)
		do
			c_set_stream_was_rewound (c_pointer, a_stream_was_rewound)
		end

	set_proxy_connect_closed (a_proxy_connect_closed: BOOLEAN)
		do
			c_set_proxy_connect_closed (c_pointer, a_proxy_connect_closed)
		end

	set_bound (a_bound: BOOLEAN)
		do
			c_set_bound (c_pointer, a_bound)
		end

	set_type_set (a_type_set: BOOLEAN)
		do
			c_set_type_set (c_pointer, a_type_set)
		end

feature {NONE} -- C getters

	c_close (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ConnectBits *)$tmp)->close;"
		end

	c_reuse (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ConnectBits *)$tmp)->reuse;"
		end

	c_proxy (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ConnectBits *)$tmp)->proxy;"
		end

	c_httpproxy (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ConnectBits *)$tmp)->httpproxy;"
		end

	c_user_passwd (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ConnectBits *)$tmp)->user_passwd;"
		end

	c_proxy_user_passwd (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ConnectBits *)$tmp)->proxy_user_passwd;"
		end

	c_ipv6_ip (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ConnectBits *)$tmp)->ipv6_ip;"
		end

	c_ipv6 (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ConnectBits *)$tmp)->ipv6;"
		end

	c_do_more (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ConnectBits *)$tmp)->do_more;"
		end

	c_tcpconnect (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ConnectBits *)$tmp)->tcpconnect;"
		end

	c_protoconnstart (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ConnectBits *)$tmp)->protoconnstart;"
		end

	c_retry2 (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ConnectBits *)$tmp)->retry;"
		end

	c_tunnel_proxy (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ConnectBits *)$tmp)->tunnel_proxy;"
		end

	c_tunnel_connecting (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ConnectBits *)$tmp)->tunnel_connecting;"
		end

	c_authneg (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ConnectBits *)$tmp)->authneg;"
		end

	c_rewindaftersend (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ConnectBits *)$tmp)->rewindaftersend;"
		end

	c_ftp_use_epsv (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ConnectBits *)$tmp)->ftp_use_epsv;"
		end

	c_ftp_use_eprt (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ConnectBits *)$tmp)->ftp_use_eprt;"
		end

	c_netrc (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ConnectBits *)$tmp)->netrc;"
		end

	c_userpwd_in_url (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ConnectBits *)$tmp)->userpwd_in_url;"
		end

	c_done (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ConnectBits *)$tmp)->done;"
		end

	c_stream_was_rewound (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ConnectBits *)$tmp)->stream_was_rewound;"
		end

	c_proxy_connect_closed (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ConnectBits *)$tmp)->proxy_connect_closed;"
		end

	c_bound (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ConnectBits *)$tmp)->bound;"
		end

	c_type_set (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ConnectBits *)$tmp)->type_set;"
		end

feature {NONE} -- C setters

	c_set_close (tmp: POINTER; a_close: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ConnectBits *)$tmp)->close = $a_close;"
		end

	c_set_reuse (tmp: POINTER; a_reuse: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ConnectBits *)$tmp)->reuse = $a_reuse;"
		end

	c_set_proxy (tmp: POINTER; a_proxy: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ConnectBits *)$tmp)->proxy = $a_proxy;"
		end

	c_set_httpproxy (tmp: POINTER; a_httpproxy: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ConnectBits *)$tmp)->httpproxy = $a_httpproxy;"
		end

	c_set_user_passwd (tmp: POINTER; a_user_passwd: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ConnectBits *)$tmp)->user_passwd = $a_user_passwd;"
		end

	c_set_proxy_user_passwd (tmp: POINTER; a_proxy_user_passwd: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ConnectBits *)$tmp)->proxy_user_passwd = $a_proxy_user_passwd;"
		end

	c_set_ipv6_ip (tmp: POINTER; a_ipv6_ip: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ConnectBits *)$tmp)->ipv6_ip = $a_ipv6_ip;"
		end

	c_set_ipv6 (tmp: POINTER; a_ipv6: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ConnectBits *)$tmp)->ipv6 = $a_ipv6;"
		end

	c_set_do_more (tmp: POINTER; a_do_more: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ConnectBits *)$tmp)->do_more = $a_do_more;"
		end

	c_set_tcpconnect (tmp: POINTER; a_tcpconnect: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ConnectBits *)$tmp)->tcpconnect = $a_tcpconnect;"
		end

	c_set_protoconnstart (tmp: POINTER; a_protoconnstart: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ConnectBits *)$tmp)->protoconnstart = $a_protoconnstart;"
		end

	c_set_retry2 (tmp: POINTER; a_retry2: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ConnectBits *)$tmp)->retry = $a_retry2;"
		end

	c_set_tunnel_proxy (tmp: POINTER; a_tunnel_proxy: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ConnectBits *)$tmp)->tunnel_proxy = $a_tunnel_proxy;"
		end

	c_set_tunnel_connecting (tmp: POINTER; a_tunnel_connecting: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ConnectBits *)$tmp)->tunnel_connecting = $a_tunnel_connecting;"
		end

	c_set_authneg (tmp: POINTER; a_authneg: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ConnectBits *)$tmp)->authneg = $a_authneg;"
		end

	c_set_rewindaftersend (tmp: POINTER; a_rewindaftersend: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ConnectBits *)$tmp)->rewindaftersend = $a_rewindaftersend;"
		end

	c_set_ftp_use_epsv (tmp: POINTER; a_ftp_use_epsv: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ConnectBits *)$tmp)->ftp_use_epsv = $a_ftp_use_epsv;"
		end

	c_set_ftp_use_eprt (tmp: POINTER; a_ftp_use_eprt: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ConnectBits *)$tmp)->ftp_use_eprt = $a_ftp_use_eprt;"
		end

	c_set_netrc (tmp: POINTER; a_netrc: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ConnectBits *)$tmp)->netrc = $a_netrc;"
		end

	c_set_userpwd_in_url (tmp: POINTER; a_userpwd_in_url: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ConnectBits *)$tmp)->userpwd_in_url = $a_userpwd_in_url;"
		end

	c_set_done (tmp: POINTER; a_done: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ConnectBits *)$tmp)->done = $a_done;"
		end

	c_set_stream_was_rewound (tmp: POINTER; a_stream_was_rewound: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ConnectBits *)$tmp)->stream_was_rewound = $a_stream_was_rewound;"
		end

	c_set_proxy_connect_closed (tmp: POINTER; a_proxy_connect_closed: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ConnectBits *)$tmp)->proxy_connect_closed = $a_proxy_connect_closed;"
		end

	c_set_bound (tmp: POINTER; a_bound: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ConnectBits *)$tmp)->bound = $a_bound;"
		end

	c_set_type_set (tmp: POINTER; a_type_set: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ConnectBits *)$tmp)->type_set = $a_type_set;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct ConnectBits);"
		end

end
