class
	PD_CURL_FORMS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	option: INTEGER_32 assign set_option
		do
			Result := c_option (c_pointer)
		end

	value: CE_POINTER [INTEGER_8] assign set_value
		do
			create Result.make_shared (c_value (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_option (a_option: INTEGER_32)
		do
			c_set_option (c_pointer, a_option)
		end

	set_value (a_value: CE_POINTER [INTEGER_8])
		do
			c_set_value (c_pointer, a_value.c_pointer)
		end

feature {NONE} -- C getters

	c_option (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct curl_forms *)$tmp)->option;"
		end

	c_value (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct curl_forms *)$tmp)->value;"
		end

feature {NONE} -- C setters

	c_set_option (tmp: POINTER; a_option: INTEGER_32)
		external
			"C inline"
		alias
			"((struct curl_forms *)$tmp)->option = $a_option;"
		end

	c_set_value (tmp: POINTER; a_value: POINTER)
		external
			"C inline"
		alias
			"((struct curl_forms *)$tmp)->value = (char const *)$a_value;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct curl_forms);"
		end

end
