class
	PD_CURL_HTTPPOST

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_CURL_HTTPPOST] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	namelength: INTEGER_32 assign set_namelength
		do
			Result := c_namelength (c_pointer)
		end

	contents: CE_POINTER [INTEGER_8] assign set_contents
		do
			create Result.make_shared (c_contents (c_pointer))
		end

	contentslength: INTEGER_32 assign set_contentslength
		do
			Result := c_contentslength (c_pointer)
		end

	buffer: CE_POINTER [INTEGER_8] assign set_buffer
		do
			create Result.make_shared (c_buffer (c_pointer))
		end

	bufferlength: INTEGER_32 assign set_bufferlength
		do
			Result := c_bufferlength (c_pointer)
		end

	contenttype: CE_POINTER [INTEGER_8] assign set_contenttype
		do
			create Result.make_shared (c_contenttype (c_pointer))
		end

	contentheader: CE_POINTER [PD_CURL_SLIST] assign set_contentheader
		do
			create Result.make_shared (c_contentheader (c_pointer))
		end

	more: CE_POINTER [PD_CURL_HTTPPOST] assign set_more
		do
			create Result.make_shared (c_more (c_pointer))
		end

	flags: INTEGER_32 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

	showfilename: CE_POINTER [INTEGER_8] assign set_showfilename
		do
			create Result.make_shared (c_showfilename (c_pointer))
		end

	userp: CE_POINTER [ANY] assign set_userp
		do
			create Result.make_shared (c_userp (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_CURL_HTTPPOST])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_namelength (a_namelength: INTEGER_32)
		do
			c_set_namelength (c_pointer, a_namelength)
		end

	set_contents (a_contents: CE_POINTER [INTEGER_8])
		do
			c_set_contents (c_pointer, a_contents.c_pointer)
		end

	set_contentslength (a_contentslength: INTEGER_32)
		do
			c_set_contentslength (c_pointer, a_contentslength)
		end

	set_buffer (a_buffer: CE_POINTER [INTEGER_8])
		do
			c_set_buffer (c_pointer, a_buffer.c_pointer)
		end

	set_bufferlength (a_bufferlength: INTEGER_32)
		do
			c_set_bufferlength (c_pointer, a_bufferlength)
		end

	set_contenttype (a_contenttype: CE_POINTER [INTEGER_8])
		do
			c_set_contenttype (c_pointer, a_contenttype.c_pointer)
		end

	set_contentheader (a_contentheader: CE_POINTER [PD_CURL_SLIST])
		do
			c_set_contentheader (c_pointer, a_contentheader.c_pointer)
		end

	set_more (a_more: CE_POINTER [PD_CURL_HTTPPOST])
		do
			c_set_more (c_pointer, a_more.c_pointer)
		end

	set_flags (a_flags: INTEGER_32)
		do
			c_set_flags (c_pointer, a_flags)
		end

	set_showfilename (a_showfilename: CE_POINTER [INTEGER_8])
		do
			c_set_showfilename (c_pointer, a_showfilename.c_pointer)
		end

	set_userp (a_userp: CE_POINTER [ANY])
		do
			c_set_userp (c_pointer, a_userp.c_pointer)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_httppost *)((struct curl_httppost *)$tmp)->next;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct curl_httppost *)$tmp)->name;"
		end

	c_namelength (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct curl_httppost *)$tmp)->namelength;"
		end

	c_contents (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct curl_httppost *)$tmp)->contents;"
		end

	c_contentslength (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct curl_httppost *)$tmp)->contentslength;"
		end

	c_buffer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct curl_httppost *)$tmp)->buffer;"
		end

	c_bufferlength (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct curl_httppost *)$tmp)->bufferlength;"
		end

	c_contenttype (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct curl_httppost *)$tmp)->contenttype;"
		end

	c_contentheader (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_slist *)((struct curl_httppost *)$tmp)->contentheader;"
		end

	c_more (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_httppost *)((struct curl_httppost *)$tmp)->more;"
		end

	c_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct curl_httppost *)$tmp)->flags;"
		end

	c_showfilename (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct curl_httppost *)$tmp)->showfilename;"
		end

	c_userp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct curl_httppost *)$tmp)->userp;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct curl_httppost *)$tmp)->next = (struct curl_httppost *)$a_next;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct curl_httppost *)$tmp)->name = (char *)$a_name;"
		end

	c_set_namelength (tmp: POINTER; a_namelength: INTEGER_32)
		external
			"C inline"
		alias
			"((struct curl_httppost *)$tmp)->namelength = $a_namelength;"
		end

	c_set_contents (tmp: POINTER; a_contents: POINTER)
		external
			"C inline"
		alias
			"((struct curl_httppost *)$tmp)->contents = (char *)$a_contents;"
		end

	c_set_contentslength (tmp: POINTER; a_contentslength: INTEGER_32)
		external
			"C inline"
		alias
			"((struct curl_httppost *)$tmp)->contentslength = $a_contentslength;"
		end

	c_set_buffer (tmp: POINTER; a_buffer: POINTER)
		external
			"C inline"
		alias
			"((struct curl_httppost *)$tmp)->buffer = (char *)$a_buffer;"
		end

	c_set_bufferlength (tmp: POINTER; a_bufferlength: INTEGER_32)
		external
			"C inline"
		alias
			"((struct curl_httppost *)$tmp)->bufferlength = $a_bufferlength;"
		end

	c_set_contenttype (tmp: POINTER; a_contenttype: POINTER)
		external
			"C inline"
		alias
			"((struct curl_httppost *)$tmp)->contenttype = (char *)$a_contenttype;"
		end

	c_set_contentheader (tmp: POINTER; a_contentheader: POINTER)
		external
			"C inline"
		alias
			"((struct curl_httppost *)$tmp)->contentheader = (struct curl_slist *)$a_contentheader;"
		end

	c_set_more (tmp: POINTER; a_more: POINTER)
		external
			"C inline"
		alias
			"((struct curl_httppost *)$tmp)->more = (struct curl_httppost *)$a_more;"
		end

	c_set_flags (tmp: POINTER; a_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct curl_httppost *)$tmp)->flags = $a_flags;"
		end

	c_set_showfilename (tmp: POINTER; a_showfilename: POINTER)
		external
			"C inline"
		alias
			"((struct curl_httppost *)$tmp)->showfilename = (char *)$a_showfilename;"
		end

	c_set_userp (tmp: POINTER; a_userp: POINTER)
		external
			"C inline"
		alias
			"((struct curl_httppost *)$tmp)->userp = (void *)$a_userp;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct curl_httppost);"
		end

end
