class
	PD_CURL_LLIST_ELEMENT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ptr: CE_POINTER [ANY] assign set_ptr
		do
			create Result.make_shared (c_ptr (c_pointer))
		end

	prev: CE_POINTER [PD_CURL_LLIST_ELEMENT] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	next: CE_POINTER [PD_CURL_LLIST_ELEMENT] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_ptr (a_ptr: CE_POINTER [ANY])
		do
			c_set_ptr (c_pointer, a_ptr.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_CURL_LLIST_ELEMENT])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_next (a_next: CE_POINTER [PD_CURL_LLIST_ELEMENT])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

feature {NONE} -- C getters

	c_ptr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct curl_llist_element *)$tmp)->ptr;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_llist_element *)((struct curl_llist_element *)$tmp)->prev;"
		end

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_llist_element *)((struct curl_llist_element *)$tmp)->next;"
		end

feature {NONE} -- C setters

	c_set_ptr (tmp: POINTER; a_ptr: POINTER)
		external
			"C inline"
		alias
			"((struct curl_llist_element *)$tmp)->ptr = (void *)$a_ptr;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct curl_llist_element *)$tmp)->prev = (struct curl_llist_element *)$a_prev;"
		end

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct curl_llist_element *)$tmp)->next = (struct curl_llist_element *)$a_next;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct curl_llist_element);"
		end

end
