class
	PD_CURL_SOCKADDR_STORAGE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	buffer: SD_SOCKADDR_STORAGE assign set_buffer
		do
			create Result.make_shared (c_buffer (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_buffer (a_buffer: SD_SOCKADDR_STORAGE)
		do
			buffer.ce_gets (a_buffer)
		end

feature {NONE} -- C getters

	c_buffer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct sockaddr_storage *)&((struct Curl_sockaddr_storage *)$tmp)->buffer;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct Curl_sockaddr_storage);"
		end

end
