class
	PD_FTP_WC_TMPDATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	parser: CE_POINTER [PD_FTP_PARSELIST_DATA] assign set_parser
		do
			create Result.make_shared (c_parser (c_pointer))
		end

	parser_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct ftp_wc_tmpdata, parser);"
		end

	backup: PD_BACKUP assign set_backup
		do
			create Result.make_shared (c_backup (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_parser (a_parser: CE_POINTER [PD_FTP_PARSELIST_DATA])
		do
			c_set_parser (c_pointer, a_parser.c_pointer)
		end

	set_backup (a_backup: PD_BACKUP)
		do
			backup.ce_gets (a_backup)
		end

feature {NONE} -- C getters

	c_parser (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct ftp_parselist_data *)((struct ftp_wc_tmpdata *)$tmp)->parser;"
		end

	c_backup (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct __anonstruct_backup_81 *)&((struct ftp_wc_tmpdata *)$tmp)->backup;"
		end

feature {NONE} -- C setters

	c_set_parser (tmp: POINTER; a_parser: POINTER)
		external
			"C inline"
		alias
			"((struct ftp_wc_tmpdata *)$tmp)->parser = (struct ftp_parselist_data *)$a_parser;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct ftp_wc_tmpdata);"
		end

end
