class
	PD_HMAC_PARAMS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	hmac_hinit: CE_ROUTINE assign set_hmac_hinit
		do
			create Result.make_shared (c_hmac_hinit (c_pointer))
		end

	hmac_hupdate: CE_ROUTINE assign set_hmac_hupdate
		do
			create Result.make_shared (c_hmac_hupdate (c_pointer))
		end

	hmac_hfinal: CE_ROUTINE assign set_hmac_hfinal
		do
			create Result.make_shared (c_hmac_hfinal (c_pointer))
		end

	hmac_ctxtsize: NATURAL_32 assign set_hmac_ctxtsize
		do
			Result := c_hmac_ctxtsize (c_pointer)
		end

	hmac_maxkeylen: NATURAL_32 assign set_hmac_maxkeylen
		do
			Result := c_hmac_maxkeylen (c_pointer)
		end

	hmac_resultlen: NATURAL_32 assign set_hmac_resultlen
		do
			Result := c_hmac_resultlen (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_hmac_hinit (a_hmac_hinit: CE_ROUTINE)
		do
			c_set_hmac_hinit (c_pointer, a_hmac_hinit.c_pointer)
		end

	set_hmac_hupdate (a_hmac_hupdate: CE_ROUTINE)
		do
			c_set_hmac_hupdate (c_pointer, a_hmac_hupdate.c_pointer)
		end

	set_hmac_hfinal (a_hmac_hfinal: CE_ROUTINE)
		do
			c_set_hmac_hfinal (c_pointer, a_hmac_hfinal.c_pointer)
		end

	set_hmac_ctxtsize (a_hmac_ctxtsize: NATURAL_32)
		do
			c_set_hmac_ctxtsize (c_pointer, a_hmac_ctxtsize)
		end

	set_hmac_maxkeylen (a_hmac_maxkeylen: NATURAL_32)
		do
			c_set_hmac_maxkeylen (c_pointer, a_hmac_maxkeylen)
		end

	set_hmac_resultlen (a_hmac_resultlen: NATURAL_32)
		do
			c_set_hmac_resultlen (c_pointer, a_hmac_resultlen)
		end

feature {NONE} -- C getters

	c_hmac_hinit (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void * context))((struct __anonstruct_HMAC_params_34 *)$tmp)->hmac_hinit;"
		end

	c_hmac_hupdate (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void * context, unsigned char * data, unsigned int len))((struct __anonstruct_HMAC_params_34 *)$tmp)->hmac_hupdate;"
		end

	c_hmac_hfinal (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(unsigned char * result, void * context))((struct __anonstruct_HMAC_params_34 *)$tmp)->hmac_hfinal;"
		end

	c_hmac_ctxtsize (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_HMAC_params_34 *)$tmp)->hmac_ctxtsize;"
		end

	c_hmac_maxkeylen (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_HMAC_params_34 *)$tmp)->hmac_maxkeylen;"
		end

	c_hmac_resultlen (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_HMAC_params_34 *)$tmp)->hmac_resultlen;"
		end

feature {NONE} -- C setters

	c_set_hmac_hinit (tmp: POINTER; a_hmac_hinit: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_HMAC_params_34 *)$tmp)->hmac_hinit = (void( *)(void * context))$a_hmac_hinit;"
		end

	c_set_hmac_hupdate (tmp: POINTER; a_hmac_hupdate: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_HMAC_params_34 *)$tmp)->hmac_hupdate = (void( *)(void * context, unsigned char const * data, unsigned int len))$a_hmac_hupdate;"
		end

	c_set_hmac_hfinal (tmp: POINTER; a_hmac_hfinal: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_HMAC_params_34 *)$tmp)->hmac_hfinal = (void( *)(unsigned char * result, void * context))$a_hmac_hfinal;"
		end

	c_set_hmac_ctxtsize (tmp: POINTER; a_hmac_ctxtsize: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_HMAC_params_34 *)$tmp)->hmac_ctxtsize = $a_hmac_ctxtsize;"
		end

	c_set_hmac_maxkeylen (tmp: POINTER; a_hmac_maxkeylen: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_HMAC_params_34 *)$tmp)->hmac_maxkeylen = $a_hmac_maxkeylen;"
		end

	c_set_hmac_resultlen (tmp: POINTER; a_hmac_resultlen: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_HMAC_params_34 *)$tmp)->hmac_resultlen = $a_hmac_resultlen;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct __anonstruct_HMAC_params_34);"
		end

end
