class
	PD_MY_TM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	tm_sec: INTEGER_32 assign set_tm_sec
		do
			Result := c_tm_sec (c_pointer)
		end

	tm_min: INTEGER_32 assign set_tm_min
		do
			Result := c_tm_min (c_pointer)
		end

	tm_hour: INTEGER_32 assign set_tm_hour
		do
			Result := c_tm_hour (c_pointer)
		end

	tm_mday: INTEGER_32 assign set_tm_mday
		do
			Result := c_tm_mday (c_pointer)
		end

	tm_mon: INTEGER_32 assign set_tm_mon
		do
			Result := c_tm_mon (c_pointer)
		end

	tm_year: INTEGER_32 assign set_tm_year
		do
			Result := c_tm_year (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_tm_sec (a_tm_sec: INTEGER_32)
		do
			c_set_tm_sec (c_pointer, a_tm_sec)
		end

	set_tm_min (a_tm_min: INTEGER_32)
		do
			c_set_tm_min (c_pointer, a_tm_min)
		end

	set_tm_hour (a_tm_hour: INTEGER_32)
		do
			c_set_tm_hour (c_pointer, a_tm_hour)
		end

	set_tm_mday (a_tm_mday: INTEGER_32)
		do
			c_set_tm_mday (c_pointer, a_tm_mday)
		end

	set_tm_mon (a_tm_mon: INTEGER_32)
		do
			c_set_tm_mon (c_pointer, a_tm_mon)
		end

	set_tm_year (a_tm_year: INTEGER_32)
		do
			c_set_tm_year (c_pointer, a_tm_year)
		end

feature {NONE} -- C getters

	c_tm_sec (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct my_tm *)$tmp)->tm_sec;"
		end

	c_tm_min (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct my_tm *)$tmp)->tm_min;"
		end

	c_tm_hour (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct my_tm *)$tmp)->tm_hour;"
		end

	c_tm_mday (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct my_tm *)$tmp)->tm_mday;"
		end

	c_tm_mon (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct my_tm *)$tmp)->tm_mon;"
		end

	c_tm_year (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct my_tm *)$tmp)->tm_year;"
		end

feature {NONE} -- C setters

	c_set_tm_sec (tmp: POINTER; a_tm_sec: INTEGER_32)
		external
			"C inline"
		alias
			"((struct my_tm *)$tmp)->tm_sec = $a_tm_sec;"
		end

	c_set_tm_min (tmp: POINTER; a_tm_min: INTEGER_32)
		external
			"C inline"
		alias
			"((struct my_tm *)$tmp)->tm_min = $a_tm_min;"
		end

	c_set_tm_hour (tmp: POINTER; a_tm_hour: INTEGER_32)
		external
			"C inline"
		alias
			"((struct my_tm *)$tmp)->tm_hour = $a_tm_hour;"
		end

	c_set_tm_mday (tmp: POINTER; a_tm_mday: INTEGER_32)
		external
			"C inline"
		alias
			"((struct my_tm *)$tmp)->tm_mday = $a_tm_mday;"
		end

	c_set_tm_mon (tmp: POINTER; a_tm_mon: INTEGER_32)
		external
			"C inline"
		alias
			"((struct my_tm *)$tmp)->tm_mon = $a_tm_mon;"
		end

	c_set_tm_year (tmp: POINTER; a_tm_year: INTEGER_32)
		external
			"C inline"
		alias
			"((struct my_tm *)$tmp)->tm_year = $a_tm_year;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct my_tm);"
		end

end
