class
	PD_NAMES

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	hostcache: CE_POINTER [PD_CURL_HASH] assign set_hostcache
		do
			create Result.make_shared (c_hostcache (c_pointer))
		end

	hostcachetype: INTEGER_32 assign set_hostcachetype
		do
			Result := c_hostcachetype (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_hostcache (a_hostcache: CE_POINTER [PD_CURL_HASH])
		do
			c_set_hostcache (c_pointer, a_hostcache.c_pointer)
		end

	set_hostcachetype (a_hostcachetype: INTEGER_32)
		do
			c_set_hostcachetype (c_pointer, a_hostcachetype)
		end

feature {NONE} -- C getters

	c_hostcache (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_hash *)((struct Names *)$tmp)->hostcache;"
		end

	c_hostcachetype (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct Names *)$tmp)->hostcachetype;"
		end

feature {NONE} -- C setters

	c_set_hostcache (tmp: POINTER; a_hostcache: POINTER)
		external
			"C inline"
		alias
			"((struct Names *)$tmp)->hostcache = (struct curl_hash *)$a_hostcache;"
		end

	c_set_hostcachetype (tmp: POINTER; a_hostcachetype: INTEGER_32)
		external
			"C inline"
		alias
			"((struct Names *)$tmp)->hostcachetype = $a_hostcachetype;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct Names);"
		end

end
