class
	PD_NUM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	as_signed: INTEGER_64 assign set_as_signed
		do
			Result := c_as_signed (c_pointer)
		end

	as_unsigned: NATURAL_64 assign set_as_unsigned
		do
			Result := c_as_unsigned (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_as_signed (a_as_signed: INTEGER_64)
		do
			c_set_as_signed (c_pointer, a_as_signed)
		end

	set_as_unsigned (a_as_unsigned: NATURAL_64)
		do
			c_set_as_unsigned (c_pointer, a_as_unsigned)
		end

feature {NONE} -- C getters

	c_as_signed (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((union __anonunion_num_70 *)$tmp)->as_signed;"
		end

	c_as_unsigned (tmp: POINTER): NATURAL_64
		external
			"C inline"
		alias
			"return (unsigned long long)((union __anonunion_num_70 *)$tmp)->as_unsigned;"
		end

feature {NONE} -- C setters

	c_set_as_signed (tmp: POINTER; a_as_signed: INTEGER_64)
		external
			"C inline"
		alias
			"((union __anonunion_num_70 *)$tmp)->as_signed = $a_as_signed;"
		end

	c_set_as_unsigned (tmp: POINTER; a_as_unsigned: NATURAL_64)
		external
			"C inline"
		alias
			"((union __anonunion_num_70 *)$tmp)->as_unsigned = $a_as_unsigned;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(union __anonunion_num_70);"
		end

end
