class
	PD_OFFSETS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	filename: NATURAL_32 assign set_filename
		do
			Result := c_filename (c_pointer)
		end

	user: NATURAL_32 assign set_user
		do
			Result := c_user (c_pointer)
		end

	group: NATURAL_32 assign set_group
		do
			Result := c_group (c_pointer)
		end

	time: NATURAL_32 assign set_time
		do
			Result := c_time (c_pointer)
		end

	perm: NATURAL_32 assign set_perm
		do
			Result := c_perm (c_pointer)
		end

	symlink_target: NATURAL_32 assign set_symlink_target
		do
			Result := c_symlink_target (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_filename (a_filename: NATURAL_32)
		do
			c_set_filename (c_pointer, a_filename)
		end

	set_user (a_user: NATURAL_32)
		do
			c_set_user (c_pointer, a_user)
		end

	set_group (a_group: NATURAL_32)
		do
			c_set_group (c_pointer, a_group)
		end

	set_time (a_time: NATURAL_32)
		do
			c_set_time (c_pointer, a_time)
		end

	set_perm (a_perm: NATURAL_32)
		do
			c_set_perm (c_pointer, a_perm)
		end

	set_symlink_target (a_symlink_target: NATURAL_32)
		do
			c_set_symlink_target (c_pointer, a_symlink_target)
		end

feature {NONE} -- C getters

	c_filename (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_offsets_114 *)$tmp)->filename;"
		end

	c_user (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_offsets_114 *)$tmp)->user;"
		end

	c_group (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_offsets_114 *)$tmp)->group;"
		end

	c_time (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_offsets_114 *)$tmp)->time;"
		end

	c_perm (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_offsets_114 *)$tmp)->perm;"
		end

	c_symlink_target (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_offsets_114 *)$tmp)->symlink_target;"
		end

feature {NONE} -- C setters

	c_set_filename (tmp: POINTER; a_filename: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_offsets_114 *)$tmp)->filename = $a_filename;"
		end

	c_set_user (tmp: POINTER; a_user: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_offsets_114 *)$tmp)->user = $a_user;"
		end

	c_set_group (tmp: POINTER; a_group: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_offsets_114 *)$tmp)->group = $a_group;"
		end

	c_set_time (tmp: POINTER; a_time: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_offsets_114 *)$tmp)->time = $a_time;"
		end

	c_set_perm (tmp: POINTER; a_perm: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_offsets_114 *)$tmp)->perm = $a_perm;"
		end

	c_set_symlink_target (tmp: POINTER; a_symlink_target: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_offsets_114 *)$tmp)->symlink_target = $a_symlink_target;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct __anonstruct_offsets_114);"
		end

end
