class
	PD_SSHPROTO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	path: CE_POINTER [INTEGER_8] assign set_path
		do
			create Result.make_shared (c_path (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_path (a_path: CE_POINTER [INTEGER_8])
		do
			c_set_path (c_pointer, a_path.c_pointer)
		end

feature {NONE} -- C getters

	c_path (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct SSHPROTO *)$tmp)->path;"
		end

feature {NONE} -- C setters

	c_set_path (tmp: POINTER; a_path: POINTER)
		external
			"C inline"
		alias
			"((struct SSHPROTO *)$tmp)->path = (char *)$a_path;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct SSHPROTO);"
		end

end
