class
	PD_TELNET

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	please_negotiate: INTEGER_32 assign set_please_negotiate
		do
			Result := c_please_negotiate (c_pointer)
		end

	already_negotiated: INTEGER_32 assign set_already_negotiated
		do
			Result := c_already_negotiated (c_pointer)
		end

	us: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_us (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	usq: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_usq (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	us_preferred: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_us_preferred (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	him: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_him (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	himq: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_himq (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	him_preferred: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_him_preferred (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	subopt_ttype: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_subopt_ttype (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	subopt_xdisploc: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_subopt_xdisploc (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	telnet_vars: CE_POINTER [PD_CURL_SLIST] assign set_telnet_vars
		do
			create Result.make_shared (c_telnet_vars (c_pointer))
		end

	subbuffer: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_subbuffer (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	subpointer: CE_POINTER [NATURAL_8] assign set_subpointer
		do
			create Result.make_shared (c_subpointer (c_pointer))
		end

	subend: CE_POINTER [NATURAL_8] assign set_subend
		do
			create Result.make_shared (c_subend (c_pointer))
		end

	telrcv_state: INTEGER_32 assign set_telrcv_state
		do
			Result := c_telrcv_state (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_please_negotiate (a_please_negotiate: INTEGER_32)
		do
			c_set_please_negotiate (c_pointer, a_please_negotiate)
		end

	set_already_negotiated (a_already_negotiated: INTEGER_32)
		do
			c_set_already_negotiated (c_pointer, a_already_negotiated)
		end

	set_telnet_vars (a_telnet_vars: CE_POINTER [PD_CURL_SLIST])
		do
			c_set_telnet_vars (c_pointer, a_telnet_vars.c_pointer)
		end

	set_subpointer (a_subpointer: CE_POINTER [NATURAL_8])
		do
			c_set_subpointer (c_pointer, a_subpointer.c_pointer)
		end

	set_subend (a_subend: CE_POINTER [NATURAL_8])
		do
			c_set_subend (c_pointer, a_subend.c_pointer)
		end

	set_telrcv_state (a_telrcv_state: INTEGER_32)
		do
			c_set_telrcv_state (c_pointer, a_telrcv_state)
		end

feature {NONE} -- C getters

	c_please_negotiate (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct TELNET *)$tmp)->please_negotiate;"
		end

	c_already_negotiated (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct TELNET *)$tmp)->already_negotiated;"
		end

	c_us (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct TELNET *tmp = (struct TELNET *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->us) / sizeof(tmp->us[0]);
				return tmp->us;
			]"
		end

	c_usq (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct TELNET *tmp = (struct TELNET *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->usq) / sizeof(tmp->usq[0]);
				return tmp->usq;
			]"
		end

	c_us_preferred (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct TELNET *tmp = (struct TELNET *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->us_preferred) / sizeof(tmp->us_preferred[0]);
				return tmp->us_preferred;
			]"
		end

	c_him (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct TELNET *tmp = (struct TELNET *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->him) / sizeof(tmp->him[0]);
				return tmp->him;
			]"
		end

	c_himq (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct TELNET *tmp = (struct TELNET *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->himq) / sizeof(tmp->himq[0]);
				return tmp->himq;
			]"
		end

	c_him_preferred (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct TELNET *tmp = (struct TELNET *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->him_preferred) / sizeof(tmp->him_preferred[0]);
				return tmp->him_preferred;
			]"
		end

	c_subopt_ttype (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct TELNET *tmp = (struct TELNET *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->subopt_ttype) / sizeof(tmp->subopt_ttype[0]);
				return tmp->subopt_ttype;
			]"
		end

	c_subopt_xdisploc (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct TELNET *tmp = (struct TELNET *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->subopt_xdisploc) / sizeof(tmp->subopt_xdisploc[0]);
				return tmp->subopt_xdisploc;
			]"
		end

	c_telnet_vars (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_slist *)((struct TELNET *)$tmp)->telnet_vars;"
		end

	c_subbuffer (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct TELNET *tmp = (struct TELNET *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->subbuffer) / sizeof(tmp->subbuffer[0]);
				return tmp->subbuffer;
			]"
		end

	c_subpointer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct TELNET *)$tmp)->subpointer;"
		end

	c_subend (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct TELNET *)$tmp)->subend;"
		end

	c_telrcv_state (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct TELNET *)$tmp)->telrcv_state;"
		end

feature {NONE} -- C setters

	c_set_please_negotiate (tmp: POINTER; a_please_negotiate: INTEGER_32)
		external
			"C inline"
		alias
			"((struct TELNET *)$tmp)->please_negotiate = $a_please_negotiate;"
		end

	c_set_already_negotiated (tmp: POINTER; a_already_negotiated: INTEGER_32)
		external
			"C inline"
		alias
			"((struct TELNET *)$tmp)->already_negotiated = $a_already_negotiated;"
		end

	c_set_telnet_vars (tmp: POINTER; a_telnet_vars: POINTER)
		external
			"C inline"
		alias
			"((struct TELNET *)$tmp)->telnet_vars = (struct curl_slist *)$a_telnet_vars;"
		end

	c_set_subpointer (tmp: POINTER; a_subpointer: POINTER)
		external
			"C inline"
		alias
			"((struct TELNET *)$tmp)->subpointer = (unsigned char *)$a_subpointer;"
		end

	c_set_subend (tmp: POINTER; a_subend: POINTER)
		external
			"C inline"
		alias
			"((struct TELNET *)$tmp)->subend = (unsigned char *)$a_subend;"
		end

	c_set_telrcv_state (tmp: POINTER; a_telrcv_state: INTEGER_32)
		external
			"C inline"
		alias
			"((struct TELNET *)$tmp)->telrcv_state = $a_telrcv_state;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct TELNET);"
		end

end
