class
	PD_TFTP_PACKET

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	data: CE_POINTER [NATURAL_8] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_data (a_data: CE_POINTER [NATURAL_8])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

feature {NONE} -- C getters

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct tftp_packet *)$tmp)->data;"
		end

feature {NONE} -- C setters

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct tftp_packet *)$tmp)->data = (unsigned char *)$a_data;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct tftp_packet);"
		end

end
