class
	PD_USERDEFINED

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	err: CE_POINTER [SD_IO_FILE] assign set_err
		do
			create Result.make_shared (c_err (c_pointer))
		end

	debugdata: CE_POINTER [ANY] assign set_debugdata
		do
			create Result.make_shared (c_debugdata (c_pointer))
		end

	errorbuffer: CE_POINTER [INTEGER_8] assign set_errorbuffer
		do
			create Result.make_shared (c_errorbuffer (c_pointer))
		end

	proxyport: INTEGER_32 assign set_proxyport
		do
			Result := c_proxyport (c_pointer)
		end

	out2: CE_POINTER [ANY] assign set_out2
		do
			create Result.make_shared (c_out2 (c_pointer))
		end

	in: CE_POINTER [ANY] assign set_in
		do
			create Result.make_shared (c_in (c_pointer))
		end

	writeheader: CE_POINTER [ANY] assign set_writeheader
		do
			create Result.make_shared (c_writeheader (c_pointer))
		end

	rtp_out: CE_POINTER [ANY] assign set_rtp_out
		do
			create Result.make_shared (c_rtp_out (c_pointer))
		end

	use_port: INTEGER_32 assign set_use_port
		do
			Result := c_use_port (c_pointer)
		end

	httpauth: INTEGER_32 assign set_httpauth
		do
			Result := c_httpauth (c_pointer)
		end

	proxyauth: INTEGER_32 assign set_proxyauth
		do
			Result := c_proxyauth (c_pointer)
		end

	followlocation: INTEGER_32 assign set_followlocation
		do
			Result := c_followlocation (c_pointer)
		end

	maxredirs: INTEGER_32 assign set_maxredirs
		do
			Result := c_maxredirs (c_pointer)
		end

	post301: BOOLEAN assign set_post301
		do
			Result := c_post301 (c_pointer)
		end

	post302: BOOLEAN assign set_post302
		do
			Result := c_post302 (c_pointer)
		end

	free_referer: BOOLEAN assign set_free_referer
		do
			Result := c_free_referer (c_pointer)
		end

	postfields: CE_POINTER [ANY] assign set_postfields
		do
			create Result.make_shared (c_postfields (c_pointer))
		end

	seek_func: CE_ROUTINE assign set_seek_func
		do
			create Result.make_shared (c_seek_func (c_pointer))
		end

	postfieldsize: INTEGER_64 assign set_postfieldsize
		do
			Result := c_postfieldsize (c_pointer)
		end

	localport: NATURAL_16 assign set_localport
		do
			Result := c_localport (c_pointer)
		end

	localportrange: INTEGER_32 assign set_localportrange
		do
			Result := c_localportrange (c_pointer)
		end

	fwrite_func: CE_ROUTINE assign set_fwrite_func
		do
			create Result.make_shared (c_fwrite_func (c_pointer))
		end

	fwrite_header: CE_ROUTINE assign set_fwrite_header
		do
			create Result.make_shared (c_fwrite_header (c_pointer))
		end

	fwrite_rtp: CE_ROUTINE assign set_fwrite_rtp
		do
			create Result.make_shared (c_fwrite_rtp (c_pointer))
		end

	fread_func: CE_ROUTINE assign set_fread_func
		do
			create Result.make_shared (c_fread_func (c_pointer))
		end

	is_fread_set: INTEGER_32 assign set_is_fread_set
		do
			Result := c_is_fread_set (c_pointer)
		end

	is_fwrite_set: INTEGER_32 assign set_is_fwrite_set
		do
			Result := c_is_fwrite_set (c_pointer)
		end

	fprogress: CE_ROUTINE assign set_fprogress
		do
			create Result.make_shared (c_fprogress (c_pointer))
		end

	fdebug: CE_ROUTINE assign set_fdebug
		do
			create Result.make_shared (c_fdebug (c_pointer))
		end

	ioctl_func: CE_ROUTINE assign set_ioctl_func
		do
			create Result.make_shared (c_ioctl_func (c_pointer))
		end

	fsockopt: CE_ROUTINE assign set_fsockopt
		do
			create Result.make_shared (c_fsockopt (c_pointer))
		end

	sockopt_client: CE_POINTER [ANY] assign set_sockopt_client
		do
			create Result.make_shared (c_sockopt_client (c_pointer))
		end

	fopensocket: CE_ROUTINE assign set_fopensocket
		do
			create Result.make_shared (c_fopensocket (c_pointer))
		end

	opensocket_client: CE_POINTER [ANY] assign set_opensocket_client
		do
			create Result.make_shared (c_opensocket_client (c_pointer))
		end

	seek_client: CE_POINTER [ANY] assign set_seek_client
		do
			create Result.make_shared (c_seek_client (c_pointer))
		end

	convfromnetwork: CE_ROUTINE assign set_convfromnetwork
		do
			create Result.make_shared (c_convfromnetwork (c_pointer))
		end

	convtonetwork: CE_ROUTINE assign set_convtonetwork
		do
			create Result.make_shared (c_convtonetwork (c_pointer))
		end

	convfromutf8: CE_ROUTINE assign set_convfromutf8
		do
			create Result.make_shared (c_convfromutf8 (c_pointer))
		end

	progress_client: CE_POINTER [ANY] assign set_progress_client
		do
			create Result.make_shared (c_progress_client (c_pointer))
		end

	ioctl_client: CE_POINTER [ANY] assign set_ioctl_client
		do
			create Result.make_shared (c_ioctl_client (c_pointer))
		end

	timeout: INTEGER_32 assign set_timeout
		do
			Result := c_timeout (c_pointer)
		end

	connecttimeout: INTEGER_32 assign set_connecttimeout
		do
			Result := c_connecttimeout (c_pointer)
		end

	server_response_timeout: INTEGER_32 assign set_server_response_timeout
		do
			Result := c_server_response_timeout (c_pointer)
		end

	tftp_blksize: INTEGER_32 assign set_tftp_blksize
		do
			Result := c_tftp_blksize (c_pointer)
		end

	infilesize: INTEGER_64 assign set_infilesize
		do
			Result := c_infilesize (c_pointer)
		end

	low_speed_limit: INTEGER_32 assign set_low_speed_limit
		do
			Result := c_low_speed_limit (c_pointer)
		end

	low_speed_time: INTEGER_32 assign set_low_speed_time
		do
			Result := c_low_speed_time (c_pointer)
		end

	max_send_speed: INTEGER_64 assign set_max_send_speed
		do
			Result := c_max_send_speed (c_pointer)
		end

	max_recv_speed: INTEGER_64 assign set_max_recv_speed
		do
			Result := c_max_recv_speed (c_pointer)
		end

	set_resume_from: INTEGER_64 assign set_set_resume_from
		do
			Result := c_set_resume_from (c_pointer)
		end

	headers: CE_POINTER [PD_CURL_SLIST] assign set_headers
		do
			create Result.make_shared (c_headers (c_pointer))
		end

	httppost: CE_POINTER [PD_CURL_HTTPPOST] assign set_httppost
		do
			create Result.make_shared (c_httppost (c_pointer))
		end

	cookiesession: BOOLEAN assign set_cookiesession
		do
			Result := c_cookiesession (c_pointer)
		end

	crlf: BOOLEAN assign set_crlf
		do
			Result := c_crlf (c_pointer)
		end

	quote: CE_POINTER [PD_CURL_SLIST] assign set_quote
		do
			create Result.make_shared (c_quote (c_pointer))
		end

	postquote: CE_POINTER [PD_CURL_SLIST] assign set_postquote
		do
			create Result.make_shared (c_postquote (c_pointer))
		end

	prequote: CE_POINTER [PD_CURL_SLIST] assign set_prequote
		do
			create Result.make_shared (c_prequote (c_pointer))
		end

	source_quote: CE_POINTER [PD_CURL_SLIST] assign set_source_quote
		do
			create Result.make_shared (c_source_quote (c_pointer))
		end

	source_prequote: CE_POINTER [PD_CURL_SLIST] assign set_source_prequote
		do
			create Result.make_shared (c_source_prequote (c_pointer))
		end

	source_postquote: CE_POINTER [PD_CURL_SLIST] assign set_source_postquote
		do
			create Result.make_shared (c_source_postquote (c_pointer))
		end

	telnet_options: CE_POINTER [PD_CURL_SLIST] assign set_telnet_options
		do
			create Result.make_shared (c_telnet_options (c_pointer))
		end

	timecondition: INTEGER_32 assign set_timecondition
		do
			Result := c_timecondition (c_pointer)
		end

	timevalue: INTEGER_32 assign set_timevalue
		do
			Result := c_timevalue (c_pointer)
		end

	timevalue_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct UserDefined, timevalue);"
		end

	httpreq: INTEGER_32 assign set_httpreq
		do
			Result := c_httpreq (c_pointer)
		end

	httpversion: INTEGER_32 assign set_httpversion
		do
			Result := c_httpversion (c_pointer)
		end

	ssl: PD_SSL_CONFIG_DATA assign set_ssl
		do
			create Result.make_shared (c_ssl (c_pointer))
		end

	ssl_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct UserDefined, ssl);"
		end

	proxytype: INTEGER_32 assign set_proxytype
		do
			Result := c_proxytype (c_pointer)
		end

	dns_cache_timeout: INTEGER_32 assign set_dns_cache_timeout
		do
			Result := c_dns_cache_timeout (c_pointer)
		end

	buffer_size: INTEGER_32 assign set_buffer_size
		do
			Result := c_buffer_size (c_pointer)
		end

	private_data: CE_POINTER [ANY] assign set_private_data
		do
			create Result.make_shared (c_private_data (c_pointer))
		end

	one_easy: CE_POINTER [PD_CURL_ONE_EASY] assign set_one_easy
		do
			create Result.make_shared (c_one_easy (c_pointer))
		end

	http200aliases: CE_POINTER [PD_CURL_SLIST] assign set_http200aliases
		do
			create Result.make_shared (c_http200aliases (c_pointer))
		end

	ip_version: INTEGER_32 assign set_ip_version
		do
			Result := c_ip_version (c_pointer)
		end

	max_filesize: INTEGER_64 assign set_max_filesize
		do
			Result := c_max_filesize (c_pointer)
		end

	ftp_filemethod: INTEGER_32 assign set_ftp_filemethod
		do
			Result := c_ftp_filemethod (c_pointer)
		end

	ftp_create_missing_dirs: INTEGER_32 assign set_ftp_create_missing_dirs
		do
			Result := c_ftp_create_missing_dirs (c_pointer)
		end

	ssh_keyfunc: CE_ROUTINE assign set_ssh_keyfunc
		do
			create Result.make_shared (c_ssh_keyfunc (c_pointer))
		end

	ssh_keyfunc_userp: CE_POINTER [ANY] assign set_ssh_keyfunc_userp
		do
			create Result.make_shared (c_ssh_keyfunc_userp (c_pointer))
		end

	printhost: BOOLEAN assign set_printhost
		do
			Result := c_printhost (c_pointer)
		end

	get_filetime: BOOLEAN assign set_get_filetime
		do
			Result := c_get_filetime (c_pointer)
		end

	tunnel_thru_httpproxy: BOOLEAN assign set_tunnel_thru_httpproxy
		do
			Result := c_tunnel_thru_httpproxy (c_pointer)
		end

	prefer_ascii: BOOLEAN assign set_prefer_ascii
		do
			Result := c_prefer_ascii (c_pointer)
		end

	ftp_append: BOOLEAN assign set_ftp_append
		do
			Result := c_ftp_append (c_pointer)
		end

	ftp_list_only: BOOLEAN assign set_ftp_list_only
		do
			Result := c_ftp_list_only (c_pointer)
		end

	ftp_use_port: BOOLEAN assign set_ftp_use_port
		do
			Result := c_ftp_use_port (c_pointer)
		end

	hide_progress: BOOLEAN assign set_hide_progress
		do
			Result := c_hide_progress (c_pointer)
		end

	http_fail_on_error: BOOLEAN assign set_http_fail_on_error
		do
			Result := c_http_fail_on_error (c_pointer)
		end

	http_follow_location: BOOLEAN assign set_http_follow_location
		do
			Result := c_http_follow_location (c_pointer)
		end

	http_disable_hostname_check_before_authentication: BOOLEAN assign set_http_disable_hostname_check_before_authentication
		do
			Result := c_http_disable_hostname_check_before_authentication (c_pointer)
		end

	include_header: BOOLEAN assign set_include_header
		do
			Result := c_include_header (c_pointer)
		end

	http_set_referer: BOOLEAN assign set_http_set_referer
		do
			Result := c_http_set_referer (c_pointer)
		end

	http_auto_referer: BOOLEAN assign set_http_auto_referer
		do
			Result := c_http_auto_referer (c_pointer)
		end

	opt_no_body: BOOLEAN assign set_opt_no_body
		do
			Result := c_opt_no_body (c_pointer)
		end

	set_port: BOOLEAN assign set_set_port
		do
			Result := c_set_port (c_pointer)
		end

	upload: BOOLEAN assign set_upload
		do
			Result := c_upload (c_pointer)
		end

	use_netrc: INTEGER_32 assign set_use_netrc
		do
			Result := c_use_netrc (c_pointer)
		end

	verbose: BOOLEAN assign set_verbose
		do
			Result := c_verbose (c_pointer)
		end

	krb: BOOLEAN assign set_krb
		do
			Result := c_krb (c_pointer)
		end

	reuse_forbid: BOOLEAN assign set_reuse_forbid
		do
			Result := c_reuse_forbid (c_pointer)
		end

	reuse_fresh: BOOLEAN assign set_reuse_fresh
		do
			Result := c_reuse_fresh (c_pointer)
		end

	ftp_use_epsv: BOOLEAN assign set_ftp_use_epsv
		do
			Result := c_ftp_use_epsv (c_pointer)
		end

	ftp_use_eprt: BOOLEAN assign set_ftp_use_eprt
		do
			Result := c_ftp_use_eprt (c_pointer)
		end

	ftp_use_pret: BOOLEAN assign set_ftp_use_pret
		do
			Result := c_ftp_use_pret (c_pointer)
		end

	ftp_ssl: INTEGER_32 assign set_ftp_ssl
		do
			Result := c_ftp_ssl (c_pointer)
		end

	ftpsslauth: INTEGER_32 assign set_ftpsslauth
		do
			Result := c_ftpsslauth (c_pointer)
		end

	ftp_ccc: INTEGER_32 assign set_ftp_ccc
		do
			Result := c_ftp_ccc (c_pointer)
		end

	no_signal: BOOLEAN assign set_no_signal
		do
			Result := c_no_signal (c_pointer)
		end

	global_dns_cache: BOOLEAN assign set_global_dns_cache
		do
			Result := c_global_dns_cache (c_pointer)
		end

	tcp_nodelay: BOOLEAN assign set_tcp_nodelay
		do
			Result := c_tcp_nodelay (c_pointer)
		end

	ignorecl: BOOLEAN assign set_ignorecl
		do
			Result := c_ignorecl (c_pointer)
		end

	ftp_skip_ip: BOOLEAN assign set_ftp_skip_ip
		do
			Result := c_ftp_skip_ip (c_pointer)
		end

	connect_only: BOOLEAN assign set_connect_only
		do
			Result := c_connect_only (c_pointer)
		end

	ssh_auth_types: INTEGER_32 assign set_ssh_auth_types
		do
			Result := c_ssh_auth_types (c_pointer)
		end

	http_te_skip: BOOLEAN assign set_http_te_skip
		do
			Result := c_http_te_skip (c_pointer)
		end

	http_ce_skip: BOOLEAN assign set_http_ce_skip
		do
			Result := c_http_ce_skip (c_pointer)
		end

	new_file_perms: INTEGER_32 assign set_new_file_perms
		do
			Result := c_new_file_perms (c_pointer)
		end

	new_directory_perms: INTEGER_32 assign set_new_directory_perms
		do
			Result := c_new_directory_perms (c_pointer)
		end

	proxy_transfer_mode: BOOLEAN assign set_proxy_transfer_mode
		do
			Result := c_proxy_transfer_mode (c_pointer)
		end

	str: CE_ARRAY [CE_POINTER [INTEGER_8]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_str (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	scope: NATURAL_32 assign set_scope
		do
			Result := c_scope (c_pointer)
		end

	allowed_protocols: INTEGER_32 assign set_allowed_protocols
		do
			Result := c_allowed_protocols (c_pointer)
		end

	redir_protocols: INTEGER_32 assign set_redir_protocols
		do
			Result := c_redir_protocols (c_pointer)
		end

	mail_rcpt: CE_POINTER [PD_CURL_SLIST] assign set_mail_rcpt
		do
			create Result.make_shared (c_mail_rcpt (c_pointer))
		end

	rtspreq: INTEGER_32 assign set_rtspreq
		do
			Result := c_rtspreq (c_pointer)
		end

	rtspversion: INTEGER_32 assign set_rtspversion
		do
			Result := c_rtspversion (c_pointer)
		end

	wildcardmatch: BOOLEAN assign set_wildcardmatch
		do
			Result := c_wildcardmatch (c_pointer)
		end

	chunk_bgn: CE_ROUTINE assign set_chunk_bgn
		do
			create Result.make_shared (c_chunk_bgn (c_pointer))
		end

	chunk_end: CE_ROUTINE assign set_chunk_end
		do
			create Result.make_shared (c_chunk_end (c_pointer))
		end

	fnmatch: CE_ROUTINE assign set_fnmatch
		do
			create Result.make_shared (c_fnmatch (c_pointer))
		end

	fnmatch_data: CE_POINTER [ANY] assign set_fnmatch_data
		do
			create Result.make_shared (c_fnmatch_data (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_err (a_err: CE_POINTER [SD_IO_FILE])
		do
			c_set_err (c_pointer, a_err.c_pointer)
		end

	set_debugdata (a_debugdata: CE_POINTER [ANY])
		do
			c_set_debugdata (c_pointer, a_debugdata.c_pointer)
		end

	set_errorbuffer (a_errorbuffer: CE_POINTER [INTEGER_8])
		do
			c_set_errorbuffer (c_pointer, a_errorbuffer.c_pointer)
		end

	set_proxyport (a_proxyport: INTEGER_32)
		do
			c_set_proxyport (c_pointer, a_proxyport)
		end

	set_out2 (a_out2: CE_POINTER [ANY])
		do
			c_set_out2 (c_pointer, a_out2.c_pointer)
		end

	set_in (a_in: CE_POINTER [ANY])
		do
			c_set_in (c_pointer, a_in.c_pointer)
		end

	set_writeheader (a_writeheader: CE_POINTER [ANY])
		do
			c_set_writeheader (c_pointer, a_writeheader.c_pointer)
		end

	set_rtp_out (a_rtp_out: CE_POINTER [ANY])
		do
			c_set_rtp_out (c_pointer, a_rtp_out.c_pointer)
		end

	set_use_port (a_use_port: INTEGER_32)
		do
			c_set_use_port (c_pointer, a_use_port)
		end

	set_httpauth (a_httpauth: INTEGER_32)
		do
			c_set_httpauth (c_pointer, a_httpauth)
		end

	set_proxyauth (a_proxyauth: INTEGER_32)
		do
			c_set_proxyauth (c_pointer, a_proxyauth)
		end

	set_followlocation (a_followlocation: INTEGER_32)
		do
			c_set_followlocation (c_pointer, a_followlocation)
		end

	set_maxredirs (a_maxredirs: INTEGER_32)
		do
			c_set_maxredirs (c_pointer, a_maxredirs)
		end

	set_post301 (a_post301: BOOLEAN)
		do
			c_set_post301 (c_pointer, a_post301)
		end

	set_post302 (a_post302: BOOLEAN)
		do
			c_set_post302 (c_pointer, a_post302)
		end

	set_free_referer (a_free_referer: BOOLEAN)
		do
			c_set_free_referer (c_pointer, a_free_referer)
		end

	set_postfields (a_postfields: CE_POINTER [ANY])
		do
			c_set_postfields (c_pointer, a_postfields.c_pointer)
		end

	set_seek_func (a_seek_func: CE_ROUTINE)
		do
			c_set_seek_func (c_pointer, a_seek_func.c_pointer)
		end

	set_postfieldsize (a_postfieldsize: INTEGER_64)
		do
			c_set_postfieldsize (c_pointer, a_postfieldsize)
		end

	set_localport (a_localport: NATURAL_16)
		do
			c_set_localport (c_pointer, a_localport)
		end

	set_localportrange (a_localportrange: INTEGER_32)
		do
			c_set_localportrange (c_pointer, a_localportrange)
		end

	set_fwrite_func (a_fwrite_func: CE_ROUTINE)
		do
			c_set_fwrite_func (c_pointer, a_fwrite_func.c_pointer)
		end

	set_fwrite_header (a_fwrite_header: CE_ROUTINE)
		do
			c_set_fwrite_header (c_pointer, a_fwrite_header.c_pointer)
		end

	set_fwrite_rtp (a_fwrite_rtp: CE_ROUTINE)
		do
			c_set_fwrite_rtp (c_pointer, a_fwrite_rtp.c_pointer)
		end

	set_fread_func (a_fread_func: CE_ROUTINE)
		do
			c_set_fread_func (c_pointer, a_fread_func.c_pointer)
		end

	set_is_fread_set (a_is_fread_set: INTEGER_32)
		do
			c_set_is_fread_set (c_pointer, a_is_fread_set)
		end

	set_is_fwrite_set (a_is_fwrite_set: INTEGER_32)
		do
			c_set_is_fwrite_set (c_pointer, a_is_fwrite_set)
		end

	set_fprogress (a_fprogress: CE_ROUTINE)
		do
			c_set_fprogress (c_pointer, a_fprogress.c_pointer)
		end

	set_fdebug (a_fdebug: CE_ROUTINE)
		do
			c_set_fdebug (c_pointer, a_fdebug.c_pointer)
		end

	set_ioctl_func (a_ioctl_func: CE_ROUTINE)
		do
			c_set_ioctl_func (c_pointer, a_ioctl_func.c_pointer)
		end

	set_fsockopt (a_fsockopt: CE_ROUTINE)
		do
			c_set_fsockopt (c_pointer, a_fsockopt.c_pointer)
		end

	set_sockopt_client (a_sockopt_client: CE_POINTER [ANY])
		do
			c_set_sockopt_client (c_pointer, a_sockopt_client.c_pointer)
		end

	set_fopensocket (a_fopensocket: CE_ROUTINE)
		do
			c_set_fopensocket (c_pointer, a_fopensocket.c_pointer)
		end

	set_opensocket_client (a_opensocket_client: CE_POINTER [ANY])
		do
			c_set_opensocket_client (c_pointer, a_opensocket_client.c_pointer)
		end

	set_seek_client (a_seek_client: CE_POINTER [ANY])
		do
			c_set_seek_client (c_pointer, a_seek_client.c_pointer)
		end

	set_convfromnetwork (a_convfromnetwork: CE_ROUTINE)
		do
			c_set_convfromnetwork (c_pointer, a_convfromnetwork.c_pointer)
		end

	set_convtonetwork (a_convtonetwork: CE_ROUTINE)
		do
			c_set_convtonetwork (c_pointer, a_convtonetwork.c_pointer)
		end

	set_convfromutf8 (a_convfromutf8: CE_ROUTINE)
		do
			c_set_convfromutf8 (c_pointer, a_convfromutf8.c_pointer)
		end

	set_progress_client (a_progress_client: CE_POINTER [ANY])
		do
			c_set_progress_client (c_pointer, a_progress_client.c_pointer)
		end

	set_ioctl_client (a_ioctl_client: CE_POINTER [ANY])
		do
			c_set_ioctl_client (c_pointer, a_ioctl_client.c_pointer)
		end

	set_timeout (a_timeout: INTEGER_32)
		do
			c_set_timeout (c_pointer, a_timeout)
		end

	set_connecttimeout (a_connecttimeout: INTEGER_32)
		do
			c_set_connecttimeout (c_pointer, a_connecttimeout)
		end

	set_server_response_timeout (a_server_response_timeout: INTEGER_32)
		do
			c_set_server_response_timeout (c_pointer, a_server_response_timeout)
		end

	set_tftp_blksize (a_tftp_blksize: INTEGER_32)
		do
			c_set_tftp_blksize (c_pointer, a_tftp_blksize)
		end

	set_infilesize (a_infilesize: INTEGER_64)
		do
			c_set_infilesize (c_pointer, a_infilesize)
		end

	set_low_speed_limit (a_low_speed_limit: INTEGER_32)
		do
			c_set_low_speed_limit (c_pointer, a_low_speed_limit)
		end

	set_low_speed_time (a_low_speed_time: INTEGER_32)
		do
			c_set_low_speed_time (c_pointer, a_low_speed_time)
		end

	set_max_send_speed (a_max_send_speed: INTEGER_64)
		do
			c_set_max_send_speed (c_pointer, a_max_send_speed)
		end

	set_max_recv_speed (a_max_recv_speed: INTEGER_64)
		do
			c_set_max_recv_speed (c_pointer, a_max_recv_speed)
		end

	set_set_resume_from (a_set_resume_from: INTEGER_64)
		do
			c_set_set_resume_from (c_pointer, a_set_resume_from)
		end

	set_headers (a_headers: CE_POINTER [PD_CURL_SLIST])
		do
			c_set_headers (c_pointer, a_headers.c_pointer)
		end

	set_httppost (a_httppost: CE_POINTER [PD_CURL_HTTPPOST])
		do
			c_set_httppost (c_pointer, a_httppost.c_pointer)
		end

	set_cookiesession (a_cookiesession: BOOLEAN)
		do
			c_set_cookiesession (c_pointer, a_cookiesession)
		end

	set_crlf (a_crlf: BOOLEAN)
		do
			c_set_crlf (c_pointer, a_crlf)
		end

	set_quote (a_quote: CE_POINTER [PD_CURL_SLIST])
		do
			c_set_quote (c_pointer, a_quote.c_pointer)
		end

	set_postquote (a_postquote: CE_POINTER [PD_CURL_SLIST])
		do
			c_set_postquote (c_pointer, a_postquote.c_pointer)
		end

	set_prequote (a_prequote: CE_POINTER [PD_CURL_SLIST])
		do
			c_set_prequote (c_pointer, a_prequote.c_pointer)
		end

	set_source_quote (a_source_quote: CE_POINTER [PD_CURL_SLIST])
		do
			c_set_source_quote (c_pointer, a_source_quote.c_pointer)
		end

	set_source_prequote (a_source_prequote: CE_POINTER [PD_CURL_SLIST])
		do
			c_set_source_prequote (c_pointer, a_source_prequote.c_pointer)
		end

	set_source_postquote (a_source_postquote: CE_POINTER [PD_CURL_SLIST])
		do
			c_set_source_postquote (c_pointer, a_source_postquote.c_pointer)
		end

	set_telnet_options (a_telnet_options: CE_POINTER [PD_CURL_SLIST])
		do
			c_set_telnet_options (c_pointer, a_telnet_options.c_pointer)
		end

	set_timecondition (a_timecondition: INTEGER_32)
		do
			c_set_timecondition (c_pointer, a_timecondition)
		end

	set_timevalue (a_timevalue: INTEGER_32)
		do
			c_set_timevalue (c_pointer, a_timevalue)
		end

	set_httpreq (a_httpreq: INTEGER_32)
		do
			c_set_httpreq (c_pointer, a_httpreq)
		end

	set_httpversion (a_httpversion: INTEGER_32)
		do
			c_set_httpversion (c_pointer, a_httpversion)
		end

	set_ssl (a_ssl: PD_SSL_CONFIG_DATA)
		do
			ssl.ce_gets (a_ssl)
		end

	set_proxytype (a_proxytype: INTEGER_32)
		do
			c_set_proxytype (c_pointer, a_proxytype)
		end

	set_dns_cache_timeout (a_dns_cache_timeout: INTEGER_32)
		do
			c_set_dns_cache_timeout (c_pointer, a_dns_cache_timeout)
		end

	set_buffer_size (a_buffer_size: INTEGER_32)
		do
			c_set_buffer_size (c_pointer, a_buffer_size)
		end

	set_private_data (a_private_data: CE_POINTER [ANY])
		do
			c_set_private_data (c_pointer, a_private_data.c_pointer)
		end

	set_one_easy (a_one_easy: CE_POINTER [PD_CURL_ONE_EASY])
		do
			c_set_one_easy (c_pointer, a_one_easy.c_pointer)
		end

	set_http200aliases (a_http200aliases: CE_POINTER [PD_CURL_SLIST])
		do
			c_set_http200aliases (c_pointer, a_http200aliases.c_pointer)
		end

	set_ip_version (a_ip_version: INTEGER_32)
		do
			c_set_ip_version (c_pointer, a_ip_version)
		end

	set_max_filesize (a_max_filesize: INTEGER_64)
		do
			c_set_max_filesize (c_pointer, a_max_filesize)
		end

	set_ftp_filemethod (a_ftp_filemethod: INTEGER_32)
		do
			c_set_ftp_filemethod (c_pointer, a_ftp_filemethod)
		end

	set_ftp_create_missing_dirs (a_ftp_create_missing_dirs: INTEGER_32)
		do
			c_set_ftp_create_missing_dirs (c_pointer, a_ftp_create_missing_dirs)
		end

	set_ssh_keyfunc (a_ssh_keyfunc: CE_ROUTINE)
		do
			c_set_ssh_keyfunc (c_pointer, a_ssh_keyfunc.c_pointer)
		end

	set_ssh_keyfunc_userp (a_ssh_keyfunc_userp: CE_POINTER [ANY])
		do
			c_set_ssh_keyfunc_userp (c_pointer, a_ssh_keyfunc_userp.c_pointer)
		end

	set_printhost (a_printhost: BOOLEAN)
		do
			c_set_printhost (c_pointer, a_printhost)
		end

	set_get_filetime (a_get_filetime: BOOLEAN)
		do
			c_set_get_filetime (c_pointer, a_get_filetime)
		end

	set_tunnel_thru_httpproxy (a_tunnel_thru_httpproxy: BOOLEAN)
		do
			c_set_tunnel_thru_httpproxy (c_pointer, a_tunnel_thru_httpproxy)
		end

	set_prefer_ascii (a_prefer_ascii: BOOLEAN)
		do
			c_set_prefer_ascii (c_pointer, a_prefer_ascii)
		end

	set_ftp_append (a_ftp_append: BOOLEAN)
		do
			c_set_ftp_append (c_pointer, a_ftp_append)
		end

	set_ftp_list_only (a_ftp_list_only: BOOLEAN)
		do
			c_set_ftp_list_only (c_pointer, a_ftp_list_only)
		end

	set_ftp_use_port (a_ftp_use_port: BOOLEAN)
		do
			c_set_ftp_use_port (c_pointer, a_ftp_use_port)
		end

	set_hide_progress (a_hide_progress: BOOLEAN)
		do
			c_set_hide_progress (c_pointer, a_hide_progress)
		end

	set_http_fail_on_error (a_http_fail_on_error: BOOLEAN)
		do
			c_set_http_fail_on_error (c_pointer, a_http_fail_on_error)
		end

	set_http_follow_location (a_http_follow_location: BOOLEAN)
		do
			c_set_http_follow_location (c_pointer, a_http_follow_location)
		end

	set_http_disable_hostname_check_before_authentication (a_http_disable_hostname_check_before_authentication: BOOLEAN)
		do
			c_set_http_disable_hostname_check_before_authentication (c_pointer, a_http_disable_hostname_check_before_authentication)
		end

	set_include_header (a_include_header: BOOLEAN)
		do
			c_set_include_header (c_pointer, a_include_header)
		end

	set_http_set_referer (a_http_set_referer: BOOLEAN)
		do
			c_set_http_set_referer (c_pointer, a_http_set_referer)
		end

	set_http_auto_referer (a_http_auto_referer: BOOLEAN)
		do
			c_set_http_auto_referer (c_pointer, a_http_auto_referer)
		end

	set_opt_no_body (a_opt_no_body: BOOLEAN)
		do
			c_set_opt_no_body (c_pointer, a_opt_no_body)
		end

	set_set_port (a_set_port: BOOLEAN)
		do
			c_set_set_port (c_pointer, a_set_port)
		end

	set_upload (a_upload: BOOLEAN)
		do
			c_set_upload (c_pointer, a_upload)
		end

	set_use_netrc (a_use_netrc: INTEGER_32)
		do
			c_set_use_netrc (c_pointer, a_use_netrc)
		end

	set_verbose (a_verbose: BOOLEAN)
		do
			c_set_verbose (c_pointer, a_verbose)
		end

	set_krb (a_krb: BOOLEAN)
		do
			c_set_krb (c_pointer, a_krb)
		end

	set_reuse_forbid (a_reuse_forbid: BOOLEAN)
		do
			c_set_reuse_forbid (c_pointer, a_reuse_forbid)
		end

	set_reuse_fresh (a_reuse_fresh: BOOLEAN)
		do
			c_set_reuse_fresh (c_pointer, a_reuse_fresh)
		end

	set_ftp_use_epsv (a_ftp_use_epsv: BOOLEAN)
		do
			c_set_ftp_use_epsv (c_pointer, a_ftp_use_epsv)
		end

	set_ftp_use_eprt (a_ftp_use_eprt: BOOLEAN)
		do
			c_set_ftp_use_eprt (c_pointer, a_ftp_use_eprt)
		end

	set_ftp_use_pret (a_ftp_use_pret: BOOLEAN)
		do
			c_set_ftp_use_pret (c_pointer, a_ftp_use_pret)
		end

	set_ftp_ssl (a_ftp_ssl: INTEGER_32)
		do
			c_set_ftp_ssl (c_pointer, a_ftp_ssl)
		end

	set_ftpsslauth (a_ftpsslauth: INTEGER_32)
		do
			c_set_ftpsslauth (c_pointer, a_ftpsslauth)
		end

	set_ftp_ccc (a_ftp_ccc: INTEGER_32)
		do
			c_set_ftp_ccc (c_pointer, a_ftp_ccc)
		end

	set_no_signal (a_no_signal: BOOLEAN)
		do
			c_set_no_signal (c_pointer, a_no_signal)
		end

	set_global_dns_cache (a_global_dns_cache: BOOLEAN)
		do
			c_set_global_dns_cache (c_pointer, a_global_dns_cache)
		end

	set_tcp_nodelay (a_tcp_nodelay: BOOLEAN)
		do
			c_set_tcp_nodelay (c_pointer, a_tcp_nodelay)
		end

	set_ignorecl (a_ignorecl: BOOLEAN)
		do
			c_set_ignorecl (c_pointer, a_ignorecl)
		end

	set_ftp_skip_ip (a_ftp_skip_ip: BOOLEAN)
		do
			c_set_ftp_skip_ip (c_pointer, a_ftp_skip_ip)
		end

	set_connect_only (a_connect_only: BOOLEAN)
		do
			c_set_connect_only (c_pointer, a_connect_only)
		end

	set_ssh_auth_types (a_ssh_auth_types: INTEGER_32)
		do
			c_set_ssh_auth_types (c_pointer, a_ssh_auth_types)
		end

	set_http_te_skip (a_http_te_skip: BOOLEAN)
		do
			c_set_http_te_skip (c_pointer, a_http_te_skip)
		end

	set_http_ce_skip (a_http_ce_skip: BOOLEAN)
		do
			c_set_http_ce_skip (c_pointer, a_http_ce_skip)
		end

	set_new_file_perms (a_new_file_perms: INTEGER_32)
		do
			c_set_new_file_perms (c_pointer, a_new_file_perms)
		end

	set_new_directory_perms (a_new_directory_perms: INTEGER_32)
		do
			c_set_new_directory_perms (c_pointer, a_new_directory_perms)
		end

	set_proxy_transfer_mode (a_proxy_transfer_mode: BOOLEAN)
		do
			c_set_proxy_transfer_mode (c_pointer, a_proxy_transfer_mode)
		end

	set_scope (a_scope: NATURAL_32)
		do
			c_set_scope (c_pointer, a_scope)
		end

	set_allowed_protocols (a_allowed_protocols: INTEGER_32)
		do
			c_set_allowed_protocols (c_pointer, a_allowed_protocols)
		end

	set_redir_protocols (a_redir_protocols: INTEGER_32)
		do
			c_set_redir_protocols (c_pointer, a_redir_protocols)
		end

	set_mail_rcpt (a_mail_rcpt: CE_POINTER [PD_CURL_SLIST])
		do
			c_set_mail_rcpt (c_pointer, a_mail_rcpt.c_pointer)
		end

	set_rtspreq (a_rtspreq: INTEGER_32)
		do
			c_set_rtspreq (c_pointer, a_rtspreq)
		end

	set_rtspversion (a_rtspversion: INTEGER_32)
		do
			c_set_rtspversion (c_pointer, a_rtspversion)
		end

	set_wildcardmatch (a_wildcardmatch: BOOLEAN)
		do
			c_set_wildcardmatch (c_pointer, a_wildcardmatch)
		end

	set_chunk_bgn (a_chunk_bgn: CE_ROUTINE)
		do
			c_set_chunk_bgn (c_pointer, a_chunk_bgn.c_pointer)
		end

	set_chunk_end (a_chunk_end: CE_ROUTINE)
		do
			c_set_chunk_end (c_pointer, a_chunk_end.c_pointer)
		end

	set_fnmatch (a_fnmatch: CE_ROUTINE)
		do
			c_set_fnmatch (c_pointer, a_fnmatch.c_pointer)
		end

	set_fnmatch_data (a_fnmatch_data: CE_POINTER [ANY])
		do
			c_set_fnmatch_data (c_pointer, a_fnmatch_data.c_pointer)
		end

feature {NONE} -- C getters

	c_err (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _IO_FILE *)((struct UserDefined *)$tmp)->err;"
		end

	c_debugdata (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct UserDefined *)$tmp)->debugdata;"
		end

	c_errorbuffer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct UserDefined *)$tmp)->errorbuffer;"
		end

	c_proxyport (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UserDefined *)$tmp)->proxyport;"
		end

	c_out2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct UserDefined *)$tmp)->out;"
		end

	c_in (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct UserDefined *)$tmp)->in;"
		end

	c_writeheader (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct UserDefined *)$tmp)->writeheader;"
		end

	c_rtp_out (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct UserDefined *)$tmp)->rtp_out;"
		end

	c_use_port (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UserDefined *)$tmp)->use_port;"
		end

	c_httpauth (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UserDefined *)$tmp)->httpauth;"
		end

	c_proxyauth (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UserDefined *)$tmp)->proxyauth;"
		end

	c_followlocation (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UserDefined *)$tmp)->followlocation;"
		end

	c_maxredirs (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UserDefined *)$tmp)->maxredirs;"
		end

	c_post301 (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->post301;"
		end

	c_post302 (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->post302;"
		end

	c_free_referer (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->free_referer;"
		end

	c_postfields (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct UserDefined *)$tmp)->postfields;"
		end

	c_seek_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void * instream, long long offset, int origin))((struct UserDefined *)$tmp)->seek_func;"
		end

	c_postfieldsize (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct UserDefined *)$tmp)->postfieldsize;"
		end

	c_localport (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct UserDefined *)$tmp)->localport;"
		end

	c_localportrange (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct UserDefined *)$tmp)->localportrange;"
		end

	c_fwrite_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned int( *)(char * buffer, unsigned int size, unsigned int nitems, void * outstream))((struct UserDefined *)$tmp)->fwrite_func;"
		end

	c_fwrite_header (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned int( *)(char * buffer, unsigned int size, unsigned int nitems, void * outstream))((struct UserDefined *)$tmp)->fwrite_header;"
		end

	c_fwrite_rtp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned int( *)(char * buffer, unsigned int size, unsigned int nitems, void * outstream))((struct UserDefined *)$tmp)->fwrite_rtp;"
		end

	c_fread_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned int( *)(char * buffer, unsigned int size, unsigned int nitems, void * instream))((struct UserDefined *)$tmp)->fread_func;"
		end

	c_is_fread_set (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct UserDefined *)$tmp)->is_fread_set;"
		end

	c_is_fwrite_set (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct UserDefined *)$tmp)->is_fwrite_set;"
		end

	c_fprogress (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void * clientp, double dltotal, double dlnow, double ultotal, double ulnow))((struct UserDefined *)$tmp)->fprogress;"
		end

	c_fdebug (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void * handle, int type, char * data, unsigned int size, void * userptr))((struct UserDefined *)$tmp)->fdebug;"
		end

	c_ioctl_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void * handle, int cmd, void * clientp))((struct UserDefined *)$tmp)->ioctl_func;"
		end

	c_fsockopt (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void * clientp, int curlfd, int purpose))((struct UserDefined *)$tmp)->fsockopt;"
		end

	c_sockopt_client (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct UserDefined *)$tmp)->sockopt_client;"
		end

	c_fopensocket (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void * clientp, int purpose, struct curl_sockaddr * address))((struct UserDefined *)$tmp)->fopensocket;"
		end

	c_opensocket_client (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct UserDefined *)$tmp)->opensocket_client;"
		end

	c_seek_client (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct UserDefined *)$tmp)->seek_client;"
		end

	c_convfromnetwork (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(char * buffer, unsigned int length))((struct UserDefined *)$tmp)->convfromnetwork;"
		end

	c_convtonetwork (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(char * buffer, unsigned int length))((struct UserDefined *)$tmp)->convtonetwork;"
		end

	c_convfromutf8 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(char * buffer, unsigned int length))((struct UserDefined *)$tmp)->convfromutf8;"
		end

	c_progress_client (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct UserDefined *)$tmp)->progress_client;"
		end

	c_ioctl_client (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct UserDefined *)$tmp)->ioctl_client;"
		end

	c_timeout (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UserDefined *)$tmp)->timeout;"
		end

	c_connecttimeout (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UserDefined *)$tmp)->connecttimeout;"
		end

	c_server_response_timeout (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UserDefined *)$tmp)->server_response_timeout;"
		end

	c_tftp_blksize (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UserDefined *)$tmp)->tftp_blksize;"
		end

	c_infilesize (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct UserDefined *)$tmp)->infilesize;"
		end

	c_low_speed_limit (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UserDefined *)$tmp)->low_speed_limit;"
		end

	c_low_speed_time (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UserDefined *)$tmp)->low_speed_time;"
		end

	c_max_send_speed (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct UserDefined *)$tmp)->max_send_speed;"
		end

	c_max_recv_speed (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct UserDefined *)$tmp)->max_recv_speed;"
		end

	c_set_resume_from (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct UserDefined *)$tmp)->set_resume_from;"
		end

	c_headers (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_slist *)((struct UserDefined *)$tmp)->headers;"
		end

	c_httppost (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_httppost *)((struct UserDefined *)$tmp)->httppost;"
		end

	c_cookiesession (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->cookiesession;"
		end

	c_crlf (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->crlf;"
		end

	c_quote (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_slist *)((struct UserDefined *)$tmp)->quote;"
		end

	c_postquote (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_slist *)((struct UserDefined *)$tmp)->postquote;"
		end

	c_prequote (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_slist *)((struct UserDefined *)$tmp)->prequote;"
		end

	c_source_quote (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_slist *)((struct UserDefined *)$tmp)->source_quote;"
		end

	c_source_prequote (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_slist *)((struct UserDefined *)$tmp)->source_prequote;"
		end

	c_source_postquote (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_slist *)((struct UserDefined *)$tmp)->source_postquote;"
		end

	c_telnet_options (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_slist *)((struct UserDefined *)$tmp)->telnet_options;"
		end

	c_timecondition (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct UserDefined *)$tmp)->timecondition;"
		end

	c_timevalue (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UserDefined *)$tmp)->timevalue;"
		end

	c_httpreq (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct UserDefined *)$tmp)->httpreq;"
		end

	c_httpversion (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UserDefined *)$tmp)->httpversion;"
		end

	c_ssl (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct ssl_config_data *)&((struct UserDefined *)$tmp)->ssl;"
		end

	c_proxytype (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct UserDefined *)$tmp)->proxytype;"
		end

	c_dns_cache_timeout (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UserDefined *)$tmp)->dns_cache_timeout;"
		end

	c_buffer_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UserDefined *)$tmp)->buffer_size;"
		end

	c_private_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct UserDefined *)$tmp)->private_data;"
		end

	c_one_easy (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Curl_one_easy *)((struct UserDefined *)$tmp)->one_easy;"
		end

	c_http200aliases (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_slist *)((struct UserDefined *)$tmp)->http200aliases;"
		end

	c_ip_version (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UserDefined *)$tmp)->ip_version;"
		end

	c_max_filesize (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct UserDefined *)$tmp)->max_filesize;"
		end

	c_ftp_filemethod (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct UserDefined *)$tmp)->ftp_filemethod;"
		end

	c_ftp_create_missing_dirs (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct UserDefined *)$tmp)->ftp_create_missing_dirs;"
		end

	c_ssh_keyfunc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void * easy, struct curl_khkey * knownkey, struct curl_khkey * foundkey, int, void * clientp))((struct UserDefined *)$tmp)->ssh_keyfunc;"
		end

	c_ssh_keyfunc_userp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct UserDefined *)$tmp)->ssh_keyfunc_userp;"
		end

	c_printhost (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->printhost;"
		end

	c_get_filetime (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->get_filetime;"
		end

	c_tunnel_thru_httpproxy (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->tunnel_thru_httpproxy;"
		end

	c_prefer_ascii (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->prefer_ascii;"
		end

	c_ftp_append (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->ftp_append;"
		end

	c_ftp_list_only (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->ftp_list_only;"
		end

	c_ftp_use_port (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->ftp_use_port;"
		end

	c_hide_progress (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->hide_progress;"
		end

	c_http_fail_on_error (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->http_fail_on_error;"
		end

	c_http_follow_location (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->http_follow_location;"
		end

	c_http_disable_hostname_check_before_authentication (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->http_disable_hostname_check_before_authentication;"
		end

	c_include_header (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->include_header;"
		end

	c_http_set_referer (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->http_set_referer;"
		end

	c_http_auto_referer (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->http_auto_referer;"
		end

	c_opt_no_body (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->opt_no_body;"
		end

	c_set_port (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->set_port;"
		end

	c_upload (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->upload;"
		end

	c_use_netrc (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct UserDefined *)$tmp)->use_netrc;"
		end

	c_verbose (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->verbose;"
		end

	c_krb (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->krb;"
		end

	c_reuse_forbid (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->reuse_forbid;"
		end

	c_reuse_fresh (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->reuse_fresh;"
		end

	c_ftp_use_epsv (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->ftp_use_epsv;"
		end

	c_ftp_use_eprt (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->ftp_use_eprt;"
		end

	c_ftp_use_pret (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->ftp_use_pret;"
		end

	c_ftp_ssl (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct UserDefined *)$tmp)->ftp_ssl;"
		end

	c_ftpsslauth (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct UserDefined *)$tmp)->ftpsslauth;"
		end

	c_ftp_ccc (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct UserDefined *)$tmp)->ftp_ccc;"
		end

	c_no_signal (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->no_signal;"
		end

	c_global_dns_cache (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->global_dns_cache;"
		end

	c_tcp_nodelay (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->tcp_nodelay;"
		end

	c_ignorecl (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->ignorecl;"
		end

	c_ftp_skip_ip (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->ftp_skip_ip;"
		end

	c_connect_only (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->connect_only;"
		end

	c_ssh_auth_types (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UserDefined *)$tmp)->ssh_auth_types;"
		end

	c_http_te_skip (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->http_te_skip;"
		end

	c_http_ce_skip (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->http_ce_skip;"
		end

	c_new_file_perms (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UserDefined *)$tmp)->new_file_perms;"
		end

	c_new_directory_perms (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UserDefined *)$tmp)->new_directory_perms;"
		end

	c_proxy_transfer_mode (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->proxy_transfer_mode;"
		end

	c_str (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct UserDefined *tmp = (struct UserDefined *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->str) / sizeof(tmp->str[0]);
				return tmp->str;
			]"
		end

	c_scope (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct UserDefined *)$tmp)->scope;"
		end

	c_allowed_protocols (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UserDefined *)$tmp)->allowed_protocols;"
		end

	c_redir_protocols (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UserDefined *)$tmp)->redir_protocols;"
		end

	c_mail_rcpt (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_slist *)((struct UserDefined *)$tmp)->mail_rcpt;"
		end

	c_rtspreq (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct UserDefined *)$tmp)->rtspreq;"
		end

	c_rtspversion (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct UserDefined *)$tmp)->rtspversion;"
		end

	c_wildcardmatch (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct UserDefined *)$tmp)->wildcardmatch;"
		end

	c_chunk_bgn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (long( *)(void * transfer_info, void * ptr, int remains))((struct UserDefined *)$tmp)->chunk_bgn;"
		end

	c_chunk_end (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (long( *)(void * ptr))((struct UserDefined *)$tmp)->chunk_end;"
		end

	c_fnmatch (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void * ptr, char * pattern, char * string))((struct UserDefined *)$tmp)->fnmatch;"
		end

	c_fnmatch_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct UserDefined *)$tmp)->fnmatch_data;"
		end

feature {NONE} -- C setters

	c_set_err (tmp: POINTER; a_err: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->err = (struct _IO_FILE *)$a_err;"
		end

	c_set_debugdata (tmp: POINTER; a_debugdata: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->debugdata = (void *)$a_debugdata;"
		end

	c_set_errorbuffer (tmp: POINTER; a_errorbuffer: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->errorbuffer = (char *)$a_errorbuffer;"
		end

	c_set_proxyport (tmp: POINTER; a_proxyport: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->proxyport = $a_proxyport;"
		end

	c_set_out2 (tmp: POINTER; a_out2: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->out = (void *)$a_out2;"
		end

	c_set_in (tmp: POINTER; a_in: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->in = (void *)$a_in;"
		end

	c_set_writeheader (tmp: POINTER; a_writeheader: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->writeheader = (void *)$a_writeheader;"
		end

	c_set_rtp_out (tmp: POINTER; a_rtp_out: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->rtp_out = (void *)$a_rtp_out;"
		end

	c_set_use_port (tmp: POINTER; a_use_port: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->use_port = $a_use_port;"
		end

	c_set_httpauth (tmp: POINTER; a_httpauth: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->httpauth = $a_httpauth;"
		end

	c_set_proxyauth (tmp: POINTER; a_proxyauth: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->proxyauth = $a_proxyauth;"
		end

	c_set_followlocation (tmp: POINTER; a_followlocation: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->followlocation = $a_followlocation;"
		end

	c_set_maxredirs (tmp: POINTER; a_maxredirs: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->maxredirs = $a_maxredirs;"
		end

	c_set_post301 (tmp: POINTER; a_post301: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->post301 = $a_post301;"
		end

	c_set_post302 (tmp: POINTER; a_post302: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->post302 = $a_post302;"
		end

	c_set_free_referer (tmp: POINTER; a_free_referer: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->free_referer = $a_free_referer;"
		end

	c_set_postfields (tmp: POINTER; a_postfields: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->postfields = (void *)$a_postfields;"
		end

	c_set_seek_func (tmp: POINTER; a_seek_func: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->seek_func = (int( *)(void * instream, long long offset, int origin))$a_seek_func;"
		end

	c_set_postfieldsize (tmp: POINTER; a_postfieldsize: INTEGER_64)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->postfieldsize = $a_postfieldsize;"
		end

	c_set_localport (tmp: POINTER; a_localport: NATURAL_16)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->localport = $a_localport;"
		end

	c_set_localportrange (tmp: POINTER; a_localportrange: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->localportrange = $a_localportrange;"
		end

	c_set_fwrite_func (tmp: POINTER; a_fwrite_func: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->fwrite_func = (unsigned int( *)(char * buffer, unsigned int size, unsigned int nitems, void * outstream))$a_fwrite_func;"
		end

	c_set_fwrite_header (tmp: POINTER; a_fwrite_header: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->fwrite_header = (unsigned int( *)(char * buffer, unsigned int size, unsigned int nitems, void * outstream))$a_fwrite_header;"
		end

	c_set_fwrite_rtp (tmp: POINTER; a_fwrite_rtp: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->fwrite_rtp = (unsigned int( *)(char * buffer, unsigned int size, unsigned int nitems, void * outstream))$a_fwrite_rtp;"
		end

	c_set_fread_func (tmp: POINTER; a_fread_func: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->fread_func = (unsigned int( *)(char * buffer, unsigned int size, unsigned int nitems, void * instream))$a_fread_func;"
		end

	c_set_is_fread_set (tmp: POINTER; a_is_fread_set: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->is_fread_set = $a_is_fread_set;"
		end

	c_set_is_fwrite_set (tmp: POINTER; a_is_fwrite_set: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->is_fwrite_set = $a_is_fwrite_set;"
		end

	c_set_fprogress (tmp: POINTER; a_fprogress: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->fprogress = (int( *)(void * clientp, double dltotal, double dlnow, double ultotal, double ulnow))$a_fprogress;"
		end

	c_set_fdebug (tmp: POINTER; a_fdebug: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->fdebug = (int( *)(void * handle, int type, char * data, unsigned int size, void * userptr))$a_fdebug;"
		end

	c_set_ioctl_func (tmp: POINTER; a_ioctl_func: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->ioctl_func = (int( *)(void * handle, int cmd, void * clientp))$a_ioctl_func;"
		end

	c_set_fsockopt (tmp: POINTER; a_fsockopt: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->fsockopt = (int( *)(void * clientp, int curlfd, int purpose))$a_fsockopt;"
		end

	c_set_sockopt_client (tmp: POINTER; a_sockopt_client: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->sockopt_client = (void *)$a_sockopt_client;"
		end

	c_set_fopensocket (tmp: POINTER; a_fopensocket: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->fopensocket = (int( *)(void * clientp, int purpose, struct curl_sockaddr * address))$a_fopensocket;"
		end

	c_set_opensocket_client (tmp: POINTER; a_opensocket_client: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->opensocket_client = (void *)$a_opensocket_client;"
		end

	c_set_seek_client (tmp: POINTER; a_seek_client: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->seek_client = (void *)$a_seek_client;"
		end

	c_set_convfromnetwork (tmp: POINTER; a_convfromnetwork: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->convfromnetwork = (int( *)(char * buffer, unsigned int length))$a_convfromnetwork;"
		end

	c_set_convtonetwork (tmp: POINTER; a_convtonetwork: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->convtonetwork = (int( *)(char * buffer, unsigned int length))$a_convtonetwork;"
		end

	c_set_convfromutf8 (tmp: POINTER; a_convfromutf8: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->convfromutf8 = (int( *)(char * buffer, unsigned int length))$a_convfromutf8;"
		end

	c_set_progress_client (tmp: POINTER; a_progress_client: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->progress_client = (void *)$a_progress_client;"
		end

	c_set_ioctl_client (tmp: POINTER; a_ioctl_client: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->ioctl_client = (void *)$a_ioctl_client;"
		end

	c_set_timeout (tmp: POINTER; a_timeout: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->timeout = $a_timeout;"
		end

	c_set_connecttimeout (tmp: POINTER; a_connecttimeout: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->connecttimeout = $a_connecttimeout;"
		end

	c_set_server_response_timeout (tmp: POINTER; a_server_response_timeout: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->server_response_timeout = $a_server_response_timeout;"
		end

	c_set_tftp_blksize (tmp: POINTER; a_tftp_blksize: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->tftp_blksize = $a_tftp_blksize;"
		end

	c_set_infilesize (tmp: POINTER; a_infilesize: INTEGER_64)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->infilesize = $a_infilesize;"
		end

	c_set_low_speed_limit (tmp: POINTER; a_low_speed_limit: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->low_speed_limit = $a_low_speed_limit;"
		end

	c_set_low_speed_time (tmp: POINTER; a_low_speed_time: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->low_speed_time = $a_low_speed_time;"
		end

	c_set_max_send_speed (tmp: POINTER; a_max_send_speed: INTEGER_64)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->max_send_speed = $a_max_send_speed;"
		end

	c_set_max_recv_speed (tmp: POINTER; a_max_recv_speed: INTEGER_64)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->max_recv_speed = $a_max_recv_speed;"
		end

	c_set_set_resume_from (tmp: POINTER; a_set_resume_from: INTEGER_64)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->set_resume_from = $a_set_resume_from;"
		end

	c_set_headers (tmp: POINTER; a_headers: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->headers = (struct curl_slist *)$a_headers;"
		end

	c_set_httppost (tmp: POINTER; a_httppost: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->httppost = (struct curl_httppost *)$a_httppost;"
		end

	c_set_cookiesession (tmp: POINTER; a_cookiesession: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->cookiesession = $a_cookiesession;"
		end

	c_set_crlf (tmp: POINTER; a_crlf: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->crlf = $a_crlf;"
		end

	c_set_quote (tmp: POINTER; a_quote: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->quote = (struct curl_slist *)$a_quote;"
		end

	c_set_postquote (tmp: POINTER; a_postquote: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->postquote = (struct curl_slist *)$a_postquote;"
		end

	c_set_prequote (tmp: POINTER; a_prequote: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->prequote = (struct curl_slist *)$a_prequote;"
		end

	c_set_source_quote (tmp: POINTER; a_source_quote: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->source_quote = (struct curl_slist *)$a_source_quote;"
		end

	c_set_source_prequote (tmp: POINTER; a_source_prequote: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->source_prequote = (struct curl_slist *)$a_source_prequote;"
		end

	c_set_source_postquote (tmp: POINTER; a_source_postquote: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->source_postquote = (struct curl_slist *)$a_source_postquote;"
		end

	c_set_telnet_options (tmp: POINTER; a_telnet_options: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->telnet_options = (struct curl_slist *)$a_telnet_options;"
		end

	c_set_timecondition (tmp: POINTER; a_timecondition: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->timecondition = $a_timecondition;"
		end

	c_set_timevalue (tmp: POINTER; a_timevalue: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->timevalue = $a_timevalue;"
		end

	c_set_httpreq (tmp: POINTER; a_httpreq: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->httpreq = $a_httpreq;"
		end

	c_set_httpversion (tmp: POINTER; a_httpversion: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->httpversion = $a_httpversion;"
		end

	c_set_proxytype (tmp: POINTER; a_proxytype: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->proxytype = $a_proxytype;"
		end

	c_set_dns_cache_timeout (tmp: POINTER; a_dns_cache_timeout: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->dns_cache_timeout = $a_dns_cache_timeout;"
		end

	c_set_buffer_size (tmp: POINTER; a_buffer_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->buffer_size = $a_buffer_size;"
		end

	c_set_private_data (tmp: POINTER; a_private_data: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->private_data = (void *)$a_private_data;"
		end

	c_set_one_easy (tmp: POINTER; a_one_easy: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->one_easy = (struct Curl_one_easy *)$a_one_easy;"
		end

	c_set_http200aliases (tmp: POINTER; a_http200aliases: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->http200aliases = (struct curl_slist *)$a_http200aliases;"
		end

	c_set_ip_version (tmp: POINTER; a_ip_version: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->ip_version = $a_ip_version;"
		end

	c_set_max_filesize (tmp: POINTER; a_max_filesize: INTEGER_64)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->max_filesize = $a_max_filesize;"
		end

	c_set_ftp_filemethod (tmp: POINTER; a_ftp_filemethod: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->ftp_filemethod = $a_ftp_filemethod;"
		end

	c_set_ftp_create_missing_dirs (tmp: POINTER; a_ftp_create_missing_dirs: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->ftp_create_missing_dirs = $a_ftp_create_missing_dirs;"
		end

	c_set_ssh_keyfunc (tmp: POINTER; a_ssh_keyfunc: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->ssh_keyfunc = (int( *)(void * easy, struct curl_khkey const * knownkey, struct curl_khkey const * foundkey, int, void * clientp))$a_ssh_keyfunc;"
		end

	c_set_ssh_keyfunc_userp (tmp: POINTER; a_ssh_keyfunc_userp: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->ssh_keyfunc_userp = (void *)$a_ssh_keyfunc_userp;"
		end

	c_set_printhost (tmp: POINTER; a_printhost: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->printhost = $a_printhost;"
		end

	c_set_get_filetime (tmp: POINTER; a_get_filetime: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->get_filetime = $a_get_filetime;"
		end

	c_set_tunnel_thru_httpproxy (tmp: POINTER; a_tunnel_thru_httpproxy: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->tunnel_thru_httpproxy = $a_tunnel_thru_httpproxy;"
		end

	c_set_prefer_ascii (tmp: POINTER; a_prefer_ascii: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->prefer_ascii = $a_prefer_ascii;"
		end

	c_set_ftp_append (tmp: POINTER; a_ftp_append: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->ftp_append = $a_ftp_append;"
		end

	c_set_ftp_list_only (tmp: POINTER; a_ftp_list_only: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->ftp_list_only = $a_ftp_list_only;"
		end

	c_set_ftp_use_port (tmp: POINTER; a_ftp_use_port: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->ftp_use_port = $a_ftp_use_port;"
		end

	c_set_hide_progress (tmp: POINTER; a_hide_progress: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->hide_progress = $a_hide_progress;"
		end

	c_set_http_fail_on_error (tmp: POINTER; a_http_fail_on_error: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->http_fail_on_error = $a_http_fail_on_error;"
		end

	c_set_http_follow_location (tmp: POINTER; a_http_follow_location: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->http_follow_location = $a_http_follow_location;"
		end

	c_set_http_disable_hostname_check_before_authentication (tmp: POINTER; a_http_disable_hostname_check_before_authentication: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->http_disable_hostname_check_before_authentication = $a_http_disable_hostname_check_before_authentication;"
		end

	c_set_include_header (tmp: POINTER; a_include_header: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->include_header = $a_include_header;"
		end

	c_set_http_set_referer (tmp: POINTER; a_http_set_referer: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->http_set_referer = $a_http_set_referer;"
		end

	c_set_http_auto_referer (tmp: POINTER; a_http_auto_referer: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->http_auto_referer = $a_http_auto_referer;"
		end

	c_set_opt_no_body (tmp: POINTER; a_opt_no_body: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->opt_no_body = $a_opt_no_body;"
		end

	c_set_set_port (tmp: POINTER; a_set_port: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->set_port = $a_set_port;"
		end

	c_set_upload (tmp: POINTER; a_upload: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->upload = $a_upload;"
		end

	c_set_use_netrc (tmp: POINTER; a_use_netrc: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->use_netrc = $a_use_netrc;"
		end

	c_set_verbose (tmp: POINTER; a_verbose: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->verbose = $a_verbose;"
		end

	c_set_krb (tmp: POINTER; a_krb: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->krb = $a_krb;"
		end

	c_set_reuse_forbid (tmp: POINTER; a_reuse_forbid: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->reuse_forbid = $a_reuse_forbid;"
		end

	c_set_reuse_fresh (tmp: POINTER; a_reuse_fresh: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->reuse_fresh = $a_reuse_fresh;"
		end

	c_set_ftp_use_epsv (tmp: POINTER; a_ftp_use_epsv: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->ftp_use_epsv = $a_ftp_use_epsv;"
		end

	c_set_ftp_use_eprt (tmp: POINTER; a_ftp_use_eprt: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->ftp_use_eprt = $a_ftp_use_eprt;"
		end

	c_set_ftp_use_pret (tmp: POINTER; a_ftp_use_pret: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->ftp_use_pret = $a_ftp_use_pret;"
		end

	c_set_ftp_ssl (tmp: POINTER; a_ftp_ssl: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->ftp_ssl = $a_ftp_ssl;"
		end

	c_set_ftpsslauth (tmp: POINTER; a_ftpsslauth: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->ftpsslauth = $a_ftpsslauth;"
		end

	c_set_ftp_ccc (tmp: POINTER; a_ftp_ccc: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->ftp_ccc = $a_ftp_ccc;"
		end

	c_set_no_signal (tmp: POINTER; a_no_signal: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->no_signal = $a_no_signal;"
		end

	c_set_global_dns_cache (tmp: POINTER; a_global_dns_cache: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->global_dns_cache = $a_global_dns_cache;"
		end

	c_set_tcp_nodelay (tmp: POINTER; a_tcp_nodelay: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->tcp_nodelay = $a_tcp_nodelay;"
		end

	c_set_ignorecl (tmp: POINTER; a_ignorecl: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->ignorecl = $a_ignorecl;"
		end

	c_set_ftp_skip_ip (tmp: POINTER; a_ftp_skip_ip: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->ftp_skip_ip = $a_ftp_skip_ip;"
		end

	c_set_connect_only (tmp: POINTER; a_connect_only: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->connect_only = $a_connect_only;"
		end

	c_set_ssh_auth_types (tmp: POINTER; a_ssh_auth_types: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->ssh_auth_types = $a_ssh_auth_types;"
		end

	c_set_http_te_skip (tmp: POINTER; a_http_te_skip: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->http_te_skip = $a_http_te_skip;"
		end

	c_set_http_ce_skip (tmp: POINTER; a_http_ce_skip: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->http_ce_skip = $a_http_ce_skip;"
		end

	c_set_new_file_perms (tmp: POINTER; a_new_file_perms: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->new_file_perms = $a_new_file_perms;"
		end

	c_set_new_directory_perms (tmp: POINTER; a_new_directory_perms: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->new_directory_perms = $a_new_directory_perms;"
		end

	c_set_proxy_transfer_mode (tmp: POINTER; a_proxy_transfer_mode: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->proxy_transfer_mode = $a_proxy_transfer_mode;"
		end

	c_set_scope (tmp: POINTER; a_scope: NATURAL_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->scope = $a_scope;"
		end

	c_set_allowed_protocols (tmp: POINTER; a_allowed_protocols: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->allowed_protocols = $a_allowed_protocols;"
		end

	c_set_redir_protocols (tmp: POINTER; a_redir_protocols: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->redir_protocols = $a_redir_protocols;"
		end

	c_set_mail_rcpt (tmp: POINTER; a_mail_rcpt: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->mail_rcpt = (struct curl_slist *)$a_mail_rcpt;"
		end

	c_set_rtspreq (tmp: POINTER; a_rtspreq: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->rtspreq = $a_rtspreq;"
		end

	c_set_rtspversion (tmp: POINTER; a_rtspversion: INTEGER_32)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->rtspversion = $a_rtspversion;"
		end

	c_set_wildcardmatch (tmp: POINTER; a_wildcardmatch: BOOLEAN)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->wildcardmatch = $a_wildcardmatch;"
		end

	c_set_chunk_bgn (tmp: POINTER; a_chunk_bgn: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->chunk_bgn = (long( *)(void const * transfer_info, void * ptr, int remains))$a_chunk_bgn;"
		end

	c_set_chunk_end (tmp: POINTER; a_chunk_end: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->chunk_end = (long( *)(void * ptr))$a_chunk_end;"
		end

	c_set_fnmatch (tmp: POINTER; a_fnmatch: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->fnmatch = (int( *)(void * ptr, char const * pattern, char const * string))$a_fnmatch;"
		end

	c_set_fnmatch_data (tmp: POINTER; a_fnmatch_data: POINTER)
		external
			"C inline"
		alias
			"((struct UserDefined *)$tmp)->fnmatch_data = (void *)$a_fnmatch_data;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct UserDefined);"
		end

end
