class
	PD_VA_STACK_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	flags: INTEGER_32 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

	width: INTEGER_32 assign set_width
		do
			Result := c_width (c_pointer)
		end

	precision: INTEGER_32 assign set_precision
		do
			Result := c_precision (c_pointer)
		end

	data: PD_DATA assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_flags (a_flags: INTEGER_32)
		do
			c_set_flags (c_pointer, a_flags)
		end

	set_width (a_width: INTEGER_32)
		do
			c_set_width (c_pointer, a_width)
		end

	set_precision (a_precision: INTEGER_32)
		do
			c_set_precision (c_pointer, a_precision)
		end

	set_data (a_data: PD_DATA)
		do
			data.ce_gets (a_data)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_va_stack_t_68 *)$tmp)->type;"
		end

	c_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_va_stack_t_68 *)$tmp)->flags;"
		end

	c_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_va_stack_t_68 *)$tmp)->width;"
		end

	c_precision (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_va_stack_t_68 *)$tmp)->precision;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_data_69 *)&((struct __anonstruct_va_stack_t_68 *)$tmp)->data;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_va_stack_t_68 *)$tmp)->type = $a_type;"
		end

	c_set_flags (tmp: POINTER; a_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_va_stack_t_68 *)$tmp)->flags = $a_flags;"
		end

	c_set_width (tmp: POINTER; a_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_va_stack_t_68 *)$tmp)->width = $a_width;"
		end

	c_set_precision (tmp: POINTER; a_precision: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_va_stack_t_68 *)$tmp)->precision = $a_precision;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct __anonstruct_va_stack_t_68);"
		end

end
