frozen class
	LIBCURL_INITIALIZER_SLICE2

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {LIBCURL_INITIALIZER}

	initialize
		do
			imap_inst.Curl_handler_imap.do_it := imap_inst.imap_do_address
			imap_inst.Curl_handler_imap.done := imap_inst.imap_done_address
			imap_inst.Curl_handler_imap.do_more := create {CE_ROUTINE}.make_shared (default_pointer)
			imap_inst.Curl_handler_imap.connect_it := imap_inst.imap_connect_address
			imap_inst.Curl_handler_imap.connecting := imap_inst.imap_multi_statemach_address
			imap_inst.Curl_handler_imap.doing := imap_inst.imap_doing_address
			imap_inst.Curl_handler_imap.proto_getsock := imap_inst.imap_getsock_address
			imap_inst.Curl_handler_imap.doing_getsock := imap_inst.imap_getsock_address
			imap_inst.Curl_handler_imap.perform_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			imap_inst.Curl_handler_imap.disconnect := imap_inst.imap_disconnect_address
			imap_inst.Curl_handler_imap.defport := 143
			imap_inst.Curl_handler_imap.protocol := ((1).bit_shift_left (12)).to_integer_32
			imap_inst.Curl_handler_imap_proxy.scheme := ce_string ("IMAP")
			imap_inst.Curl_handler_imap_proxy.setup_connection := create {CE_ROUTINE}.make_shared (default_pointer)
			imap_inst.Curl_handler_imap_proxy.do_it := http_inst.Curl_http_address
			imap_inst.Curl_handler_imap_proxy.done := http_inst.Curl_http_done_address
			imap_inst.Curl_handler_imap_proxy.do_more := create {CE_ROUTINE}.make_shared (default_pointer)
			imap_inst.Curl_handler_imap_proxy.connect_it := create {CE_ROUTINE}.make_shared (default_pointer)
			imap_inst.Curl_handler_imap_proxy.connecting := create {CE_ROUTINE}.make_shared (default_pointer)
			imap_inst.Curl_handler_imap_proxy.doing := create {CE_ROUTINE}.make_shared (default_pointer)
			imap_inst.Curl_handler_imap_proxy.proto_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			imap_inst.Curl_handler_imap_proxy.doing_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			imap_inst.Curl_handler_imap_proxy.perform_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			imap_inst.Curl_handler_imap_proxy.disconnect := create {CE_ROUTINE}.make_shared (default_pointer)
			imap_inst.Curl_handler_imap_proxy.defport := 143
			imap_inst.Curl_handler_imap_proxy.protocol := 1
			imap_inst.ids[0] := ce_string ("A")
			imap_inst.ids[1] := ce_string ("B")
			imap_inst.ids[2] := ce_string ("C")
			imap_inst.ids[3] := ce_string ("D")
			pop3_inst.Curl_handler_pop3.scheme := ce_string ("POP3")
			pop3_inst.Curl_handler_pop3.setup_connection := pop3_inst.pop3_setup_connection_address
			pop3_inst.Curl_handler_pop3.do_it := pop3_inst.pop3_do_address
			pop3_inst.Curl_handler_pop3.done := pop3_inst.pop3_done_address
			pop3_inst.Curl_handler_pop3.do_more := create {CE_ROUTINE}.make_shared (default_pointer)
			pop3_inst.Curl_handler_pop3.connect_it := pop3_inst.pop3_connect_address
			pop3_inst.Curl_handler_pop3.connecting := pop3_inst.pop3_multi_statemach_address
			pop3_inst.Curl_handler_pop3.doing := pop3_inst.pop3_doing_address
			pop3_inst.Curl_handler_pop3.proto_getsock := pop3_inst.pop3_getsock_address
			pop3_inst.Curl_handler_pop3.doing_getsock := pop3_inst.pop3_getsock_address
			pop3_inst.Curl_handler_pop3.perform_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			pop3_inst.Curl_handler_pop3.disconnect := pop3_inst.pop3_disconnect_address
			pop3_inst.Curl_handler_pop3.defport := 110
			pop3_inst.Curl_handler_pop3.protocol := ((1).bit_shift_left (14)).to_integer_32
			pop3_inst.Curl_handler_pop3_proxy.scheme := ce_string ("POP3")
			pop3_inst.Curl_handler_pop3_proxy.setup_connection := create {CE_ROUTINE}.make_shared (default_pointer)
			pop3_inst.Curl_handler_pop3_proxy.do_it := http_inst.Curl_http_address
			pop3_inst.Curl_handler_pop3_proxy.done := http_inst.Curl_http_done_address
			pop3_inst.Curl_handler_pop3_proxy.do_more := create {CE_ROUTINE}.make_shared (default_pointer)
			pop3_inst.Curl_handler_pop3_proxy.connect_it := create {CE_ROUTINE}.make_shared (default_pointer)
			pop3_inst.Curl_handler_pop3_proxy.connecting := create {CE_ROUTINE}.make_shared (default_pointer)
			pop3_inst.Curl_handler_pop3_proxy.doing := create {CE_ROUTINE}.make_shared (default_pointer)
			pop3_inst.Curl_handler_pop3_proxy.proto_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			pop3_inst.Curl_handler_pop3_proxy.doing_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			pop3_inst.Curl_handler_pop3_proxy.perform_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			pop3_inst.Curl_handler_pop3_proxy.disconnect := create {CE_ROUTINE}.make_shared (default_pointer)
			pop3_inst.Curl_handler_pop3_proxy.defport := 110
			pop3_inst.Curl_handler_pop3_proxy.protocol := 1
			smtp_inst.Curl_handler_smtp.scheme := ce_string ("SMTP")
			smtp_inst.Curl_handler_smtp.setup_connection := smtp_inst.smtp_setup_connection_address
			smtp_inst.Curl_handler_smtp.do_it := smtp_inst.smtp_do_address
			smtp_inst.Curl_handler_smtp.done := smtp_inst.smtp_done_address
			smtp_inst.Curl_handler_smtp.do_more := create {CE_ROUTINE}.make_shared (default_pointer)
			smtp_inst.Curl_handler_smtp.connect_it := smtp_inst.smtp_connect_address
			smtp_inst.Curl_handler_smtp.connecting := smtp_inst.smtp_multi_statemach_address
			smtp_inst.Curl_handler_smtp.doing := smtp_inst.smtp_doing_address
			smtp_inst.Curl_handler_smtp.proto_getsock := smtp_inst.smtp_getsock_address
			smtp_inst.Curl_handler_smtp.doing_getsock := smtp_inst.smtp_getsock_address
			smtp_inst.Curl_handler_smtp.perform_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			smtp_inst.Curl_handler_smtp.disconnect := smtp_inst.smtp_disconnect_address
			smtp_inst.Curl_handler_smtp.defport := 25
			smtp_inst.Curl_handler_smtp.protocol := ((1).bit_shift_left (16)).to_integer_32
			smtp_inst.Curl_handler_smtp_proxy.scheme := ce_string ("SMTP")
			smtp_inst.Curl_handler_smtp_proxy.setup_connection := create {CE_ROUTINE}.make_shared (default_pointer)
			smtp_inst.Curl_handler_smtp_proxy.do_it := http_inst.Curl_http_address
			smtp_inst.Curl_handler_smtp_proxy.done := http_inst.Curl_http_done_address
			smtp_inst.Curl_handler_smtp_proxy.do_more := create {CE_ROUTINE}.make_shared (default_pointer)
			smtp_inst.Curl_handler_smtp_proxy.connect_it := create {CE_ROUTINE}.make_shared (default_pointer)
			smtp_inst.Curl_handler_smtp_proxy.connecting := create {CE_ROUTINE}.make_shared (default_pointer)
			smtp_inst.Curl_handler_smtp_proxy.doing := create {CE_ROUTINE}.make_shared (default_pointer)
			smtp_inst.Curl_handler_smtp_proxy.proto_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			smtp_inst.Curl_handler_smtp_proxy.doing_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			smtp_inst.Curl_handler_smtp_proxy.perform_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			smtp_inst.Curl_handler_smtp_proxy.disconnect := create {CE_ROUTINE}.make_shared (default_pointer)
			smtp_inst.Curl_handler_smtp_proxy.defport := 25
			smtp_inst.Curl_handler_smtp_proxy.protocol := 1
			rtsp_inst.Curl_handler_rtsp.scheme := ce_string ("RTSP")
			rtsp_inst.Curl_handler_rtsp.setup_connection := create {CE_ROUTINE}.make_shared (default_pointer)
			rtsp_inst.Curl_handler_rtsp.do_it := rtsp_inst.Curl_rtsp_address
			rtsp_inst.Curl_handler_rtsp.done := rtsp_inst.Curl_rtsp_done_address
			rtsp_inst.Curl_handler_rtsp.do_more := create {CE_ROUTINE}.make_shared (default_pointer)
			rtsp_inst.Curl_handler_rtsp.connect_it := rtsp_inst.Curl_rtsp_connect_address
			rtsp_inst.Curl_handler_rtsp.connecting := create {CE_ROUTINE}.make_shared (default_pointer)
			rtsp_inst.Curl_handler_rtsp.doing := create {CE_ROUTINE}.make_shared (default_pointer)
			rtsp_inst.Curl_handler_rtsp.proto_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			rtsp_inst.Curl_handler_rtsp.doing_getsock := rtsp_inst.rtsp_getsock_do_address
			rtsp_inst.Curl_handler_rtsp.perform_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			rtsp_inst.Curl_handler_rtsp.disconnect := rtsp_inst.Curl_rtsp_disconnect_address
			rtsp_inst.Curl_handler_rtsp.defport := 554
			rtsp_inst.Curl_handler_rtsp.protocol := ((1).bit_shift_left (18)).to_integer_32
			hmac_inst.hmac_ipad := (54).to_natural_8
			hmac_inst.hmac_opad := (92).to_natural_8
			gopher_inst.Curl_handler_gopher.scheme := ce_string ("GOPHER")
			gopher_inst.Curl_handler_gopher.setup_connection := create {CE_ROUTINE}.make_shared (default_pointer)
			gopher_inst.Curl_handler_gopher.do_it := gopher_inst.gopher_do_address
			gopher_inst.Curl_handler_gopher.done := create {CE_ROUTINE}.make_shared (default_pointer)
			gopher_inst.Curl_handler_gopher.do_more := create {CE_ROUTINE}.make_shared (default_pointer)
			gopher_inst.Curl_handler_gopher.connect_it := create {CE_ROUTINE}.make_shared (default_pointer)
			gopher_inst.Curl_handler_gopher.connecting := create {CE_ROUTINE}.make_shared (default_pointer)
			gopher_inst.Curl_handler_gopher.doing := create {CE_ROUTINE}.make_shared (default_pointer)
			gopher_inst.Curl_handler_gopher.proto_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			gopher_inst.Curl_handler_gopher.doing_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			gopher_inst.Curl_handler_gopher.perform_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			gopher_inst.Curl_handler_gopher.disconnect := create {CE_ROUTINE}.make_shared (default_pointer)
			gopher_inst.Curl_handler_gopher.defport := 70
			gopher_inst.Curl_handler_gopher.protocol := ((1).bit_shift_left (25)).to_integer_32
		end

end
