class
	P_CURL_RAND

inherit
	LIBCURL_DATA
		redefine
			default_create
		end
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
		end

feature {ANY} -- attributes

	randseed: NATURAL_32 assign set_randseed

	set_randseed (a_randseed: NATURAL_32)
		do
			randseed := a_randseed
		end

feature {ANY} -- routines

	Curl_rand: NATURAL_32
		local
			l_r: NATURAL_32
		do
			randseed := randseed * {NATURAL_32} 1103515245 + {NATURAL_32} 12345
			l_r := randseed
			Result := ((((l_r).bit_shift_left (16))).bit_or (((((l_r).bit_shift_right (16))).bit_and ({NATURAL_32} 65535))))
		end

	Curl_srand
		do
			randseed := (time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))).to_natural_32
			Curl_rand.do_nothing
			Curl_rand.do_nothing
			Curl_rand.do_nothing
		end

end
