class
	P_DICT

inherit
	LIBCURL_DATA
		redefine
			default_create
		end
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create Curl_handler_dict.make
		end

feature {ANY} -- attributes

	Curl_handler_dict: PD_CURL_HANDLER

feature {ANY} -- routines

	unescape_word (a_data: CE_POINTER [PD_SESSIONHANDLE]; a_inputbuff: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_newp: CE_POINTER [INTEGER_8]
			l_dictp: CE_POINTER [INTEGER_8]
			l_ptr: CE_POINTER [INTEGER_8]
			l_len: INTEGER_32
			l_byte: INTEGER_8
			l_olen: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_newp.make
			create l_dictp.make
			create l_ptr.make

			l_olen := 0
			l_newp.ce_gets (escape_inst.curl_easy_unescape (create {CE_POINTER [ANY]}.make_cast (a_data), a_inputbuff, 0, create {CE_POINTER [INTEGER_32]}.make_shared ($l_len)))
			if (l_newp).c_pointer = default_pointer then
				Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_dictp.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((malloc (l_len.to_natural_32 * {NATURAL_32} 2 + {NATURAL_32} 1))))
				if ((l_dictp).c_pointer /= default_pointer) then
					l_ptr.ce_gets (l_newp)
					from
					until
						js.loop_left
					loop
						js.reset
						l_byte := l_ptr[0]
						if l_byte.to_integer_32 = 0 then
							js.break
						end
						if not js.loop_jumped then
							if l_byte.to_integer_32 <= 32 then
								l_tmp___0 := l_olen
								l_olen := l_olen + 1
								l_dictp[l_tmp___0] := (('\').code).to_integer_8
							elseif l_byte.to_integer_32 = 127 then
								l_tmp___0 := l_olen
								l_olen := l_olen + 1
								l_dictp[l_tmp___0] := (('\').code).to_integer_8
							elseif l_byte.to_integer_32 = 39 then
								l_tmp___0 := l_olen
								l_olen := l_olen + 1
								l_dictp[l_tmp___0] := (('\').code).to_integer_8
							elseif l_byte.to_integer_32 = 34 then
								l_tmp___0 := l_olen
								l_olen := l_olen + 1
								l_dictp[l_tmp___0] := (('\').code).to_integer_8
							elseif l_byte.to_integer_32 = 92 then
								l_tmp___0 := l_olen
								l_olen := l_olen + 1
								l_dictp[l_tmp___0] := (('\').code).to_integer_8
							end
							l_tmp___1 := l_olen
							l_olen := l_olen + 1
							l_dictp[l_tmp___1] := l_byte
							l_ptr.ce_gets (l_ptr + 1)
						end
					end
					js.reset
					l_dictp[l_olen] := (0).to_integer_8
					free (create {CE_POINTER [ANY]}.make_cast (l_newp))
				end
				Result := l_dictp
			end
		end

	dict_do (a_conn: CE_POINTER [PD_CONNECTDATA]; a_done: CE_POINTER [BOOLEAN]): INTEGER_32
		local
			l_word: CE_POINTER [INTEGER_8]
			l_eword: CE_POINTER [INTEGER_8]
			l_ppath: CE_POINTER [INTEGER_8]
			l_database: CE_POINTER [INTEGER_8]
			l_strategy: CE_POINTER [INTEGER_8]
			l_nthdef: CE_POINTER [INTEGER_8]
			l_result: INTEGER_32
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_sockfd: INTEGER_32
			l_path: CE_POINTER [INTEGER_8]
			l_bytecount: CE_POINTER [INTEGER_64]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_i: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_word.make
			create l_eword.make
			create l_ppath.make
			create l_database.make
			create l_strategy.make
			create l_nthdef.make
			create l_data.make
			create l_path.make
			create l_bytecount.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_database.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					l_strategy.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					l_nthdef.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					l_result := {PC_CURLCODE}.CURLE_OK
					l_data.ce_gets (a_conn.item.data)
					l_sockfd := a_conn.item.sock[0]
					l_path.ce_gets (l_data.item.state.path)
					l_bytecount.ce_gets (create {CE_POINTER [INTEGER_64]}.make_shared (l_data.c_pointer + {PD_SESSIONHANDLE}.req_offset + {PD_SINGLEREQUEST}.bytecount_offset))
					a_done.item := (1).to_boolean
					if not ((rawstr_inst.Curl_raw_nequal (l_path, ce_string ("/MATCH:"), (("/MATCH:").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 3 then -- else:
						if not ((rawstr_inst.Curl_raw_nequal (l_path, ce_string ("/M:"), (("/M:").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 6 then -- else:
						if not ((rawstr_inst.Curl_raw_nequal (l_path, ce_string ("/FIND:"), (("/FIND:").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___0:
						l_word.ce_gets (strchr (l_path, (':').code))
						if ((l_word).c_pointer /= default_pointer) then
							l_word.ce_gets (l_word + 1)
							l_database.ce_gets (strchr (l_word, (':').code))
							if ((l_database).c_pointer /= default_pointer) then
								l_tmp.ce_gets (l_database)
								l_database.ce_gets (l_database + 1)
								l_tmp[0] := (0).to_integer_8
								l_strategy.ce_gets (strchr (l_database, (':').code))
								if ((l_strategy).c_pointer /= default_pointer) then
									l_tmp___0.ce_gets (l_strategy)
									l_strategy.ce_gets (l_strategy + 1)
									l_tmp___0[0] := (0).to_integer_8
									l_nthdef.ce_gets (strchr (l_strategy, (':').code))
									if ((l_nthdef).c_pointer /= default_pointer) then
										l_nthdef[0] := (0).to_integer_8
									end
								end
							end
						end
						if (l_word.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							sendf_inst.Curl_infof ([l_data, ce_string ("lookup word is missing")])
							l_word.ce_gets (ce_string ("default"))
						elseif (l_word[0]).to_integer_32 = 0 then
							sendf_inst.Curl_infof ([l_data, ce_string ("lookup word is missing")])
							l_word.ce_gets (ce_string ("default"))
						end
						if (l_database.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_database.ce_gets (ce_string ("!"))
						elseif (l_database[0]).to_integer_32 = 0 then
							l_database.ce_gets (ce_string ("!"))
						end
						if (l_strategy.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_strategy.ce_gets (ce_string ("."))
						elseif (l_strategy[0]).to_integer_32 = 0 then
							l_strategy.ce_gets (ce_string ("."))
						end
						l_eword.ce_gets (unescape_word (l_data, l_word))
						if (l_eword).c_pointer = default_pointer then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						end
						if not js.return_called then
							l_result := sendf_inst.Curl_sendf ([l_sockfd, a_conn, ce_string ("CLIENT libcurl 7.21.2%R%NMATCH %%s %%s %%s%R%NQUIT%R%N"), l_database, l_strategy, l_eword])
							free (create {CE_POINTER [ANY]}.make_cast (l_eword))
							if l_result.to_boolean then
								sendf_inst.Curl_failf ([l_data, ce_string ("Failed sending DICT request")])
								Result := l_result
								js.return
							end
						end
						if not js.return_called then
							transfer_inst.Curl_setup_transfer (a_conn, 0, (-1).to_integer_64, (0).to_boolean, l_bytecount, -1, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer))
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 9 then -- else:
						if not ((rawstr_inst.Curl_raw_nequal (l_path, ce_string ("/DEFINE:"), (("/DEFINE:").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 12 then -- else:
						if not ((rawstr_inst.Curl_raw_nequal (l_path, ce_string ("/D:"), (("/D:").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 15 then -- else:
						if not ((rawstr_inst.Curl_raw_nequal (l_path, ce_string ("/LOOKUP:"), (("/LOOKUP:").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if: | _L:
						l_word.ce_gets (strchr (l_path, (':').code))
						if ((l_word).c_pointer /= default_pointer) then
							l_word.ce_gets (l_word + 1)
							l_database.ce_gets (strchr (l_word, (':').code))
							if ((l_database).c_pointer /= default_pointer) then
								l_tmp___1.ce_gets (l_database)
								l_database.ce_gets (l_database + 1)
								l_tmp___1[0] := (0).to_integer_8
								l_nthdef.ce_gets (strchr (l_database, (':').code))
								if ((l_nthdef).c_pointer /= default_pointer) then
									l_nthdef[0] := (0).to_integer_8
								end
							end
						end
						if (l_word.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							sendf_inst.Curl_infof ([l_data, ce_string ("lookup word is missing")])
							l_word.ce_gets (ce_string ("default"))
						elseif (l_word[0]).to_integer_32 = 0 then
							sendf_inst.Curl_infof ([l_data, ce_string ("lookup word is missing")])
							l_word.ce_gets (ce_string ("default"))
						end
						if (l_database.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_database.ce_gets (ce_string ("!"))
						elseif (l_database[0]).to_integer_32 = 0 then
							l_database.ce_gets (ce_string ("!"))
						end
						l_eword.ce_gets (unescape_word (l_data, l_word))
						if (l_eword).c_pointer = default_pointer then
							Result := ({PC_CURLCODE}.CURLE_OUT_OF_MEMORY)
							js.return
						end
						if not js.return_called then
							l_result := sendf_inst.Curl_sendf ([l_sockfd, a_conn, ce_string ("CLIENT libcurl 7.21.2%R%NDEFINE %%s %%s%R%NQUIT%R%N"), l_database, l_eword])
							free (create {CE_POINTER [ANY]}.make_cast (l_eword))
							if l_result.to_boolean then
								sendf_inst.Curl_failf ([l_data, ce_string ("Failed sending DICT request")])
								Result := l_result
								js.return
							end
						end
						if not js.return_called then
							transfer_inst.Curl_setup_transfer (a_conn, 0, (-1).to_integer_64, (0).to_boolean, l_bytecount, -1, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer))
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						l_ppath.ce_gets (strchr (l_path, ('/').code))
						if ((l_ppath).c_pointer /= default_pointer) then
							l_ppath.ce_gets (l_ppath + 1)
							l_i := 0
							from
							until
								not ((l_ppath[l_i]).to_boolean)
							loop
								if (l_ppath[l_i]).to_integer_32 = 58 then
									l_ppath[l_i] := ((' ').code).to_integer_8
								end
								l_i := l_i + 1
							end
							l_result := sendf_inst.Curl_sendf ([l_sockfd, a_conn, ce_string ("CLIENT libcurl 7.21.2%R%N%%s%R%NQUIT%R%N"), l_ppath])
							if l_result.to_boolean then
								sendf_inst.Curl_failf ([l_data, ce_string ("Failed sending DICT request")])
								Result := l_result
								js.return
							end
							if not js.return_called then
								transfer_inst.Curl_setup_transfer (a_conn, 0, (-1).to_integer_64, (0).to_boolean, l_bytecount, -1, create {CE_POINTER [INTEGER_64]}.make_shared (default_pointer))
							end
						end
				when 19 then -- if done | if done | if done | if done | if done
						if not js.return_called then
							Result := ({PC_CURLCODE}.CURLE_OK)
						end
				when 20 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	dict_do_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dict_do)
		end

end
