class
	P_STRERROR

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	curl_easy_strerror (a_error: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_error -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					when 3 then l_pos := -1 + 4
					when 5 then l_pos := -1 + 5
					when 6 then l_pos := -1 + 6
					when 7 then l_pos := -1 + 7
					when 8 then l_pos := -1 + 8
					when 9 then l_pos := -1 + 9
					when 84 then l_pos := -1 + 10
					when 11 then l_pos := -1 + 11
					when 13 then l_pos := -1 + 12
					when 14 then l_pos := -1 + 13
					when 15 then l_pos := -1 + 14
					when 17 then l_pos := -1 + 15
					when 18 then l_pos := -1 + 16
					when 19 then l_pos := -1 + 17
					when 21 then l_pos := -1 + 18
					when 22 then l_pos := -1 + 19
					when 23 then l_pos := -1 + 20
					when 25 then l_pos := -1 + 21
					when 26 then l_pos := -1 + 22
					when 27 then l_pos := -1 + 23
					when 28 then l_pos := -1 + 24
					when 30 then l_pos := -1 + 25
					when 31 then l_pos := -1 + 26
					when 33 then l_pos := -1 + 27
					when 34 then l_pos := -1 + 28
					when 35 then l_pos := -1 + 29
					when 36 then l_pos := -1 + 30
					when 37 then l_pos := -1 + 31
					when 38 then l_pos := -1 + 32
					when 39 then l_pos := -1 + 33
					when 41 then l_pos := -1 + 34
					when 42 then l_pos := -1 + 35
					when 43 then l_pos := -1 + 36
					when 45 then l_pos := -1 + 37
					when 47 then l_pos := -1 + 38
					when 48 then l_pos := -1 + 39
					when 49 then l_pos := -1 + 40
					when 51 then l_pos := -1 + 41
					when 52 then l_pos := -1 + 42
					when 53 then l_pos := -1 + 43
					when 54 then l_pos := -1 + 44
					when 66 then l_pos := -1 + 45
					when 55 then l_pos := -1 + 46
					when 56 then l_pos := -1 + 47
					when 58 then l_pos := -1 + 48
					when 59 then l_pos := -1 + 49
					when 60 then l_pos := -1 + 50
					when 77 then l_pos := -1 + 51
					when 61 then l_pos := -1 + 52
					when 62 then l_pos := -1 + 53
					when 63 then l_pos := -1 + 54
					when 64 then l_pos := -1 + 55
					when 80 then l_pos := -1 + 56
					when 82 then l_pos := -1 + 57
					when 83 then l_pos := -1 + 58
					when 65 then l_pos := -1 + 59
					when 67 then l_pos := -1 + 60
					when 68 then l_pos := -1 + 61
					when 69 then l_pos := -1 + 62
					when 70 then l_pos := -1 + 63
					when 71 then l_pos := -1 + 64
					when 72 then l_pos := -1 + 65
					when 73 then l_pos := -1 + 66
					when 74 then l_pos := -1 + 67
					when 75 then l_pos := -1 + 68
					when 76 then l_pos := -1 + 69
					when 78 then l_pos := -1 + 70
					when 79 then l_pos := -1 + 71
					when 81 then l_pos := -1 + 72
					when 85 then l_pos := -1 + 73
					when 86 then l_pos := -1 + 74
					when 87 then l_pos := -1 + 75
					when 88 then l_pos := -1 + 76
					when 4 then l_pos := -1 + 77
					when 10 then l_pos := -1 + 77
					when 12 then l_pos := -1 + 77
					when 16 then l_pos := -1 + 77
					when 20 then l_pos := -1 + 77
					when 24 then l_pos := -1 + 77
					when 29 then l_pos := -1 + 77
					when 32 then l_pos := -1 + 77
					when 40 then l_pos := -1 + 77
					when 44 then l_pos := -1 + 77
					when 46 then l_pos := -1 + 77
					when 50 then l_pos := -1 + 77
					when 57 then l_pos := -1 + 77
					when 89 then l_pos := -1 + 77
					else l_pos := -1 + 78
					end
				when 1 then -- switch 1, case 0
					Result := (ce_string ("No error"))
					js.return
				when 2 then -- switch 1, case 1
					if not js.return_called then
						Result := (ce_string ("Unsupported protocol"))
						js.return
					end
				when 3 then -- switch 1, case 2
					if not js.return_called then
						Result := (ce_string ("Failed initialization"))
						js.return
					end
				when 4 then -- switch 1, case 3
					if not js.return_called then
						Result := (ce_string ("URL using bad/illegal format or missing URL"))
						js.return
					end
				when 5 then -- switch 1, case 5
					if not js.return_called then
						Result := (ce_string ("Couldn%'t resolve proxy name"))
						js.return
					end
				when 6 then -- switch 1, case 6
					if not js.return_called then
						Result := (ce_string ("Couldn%'t resolve host name"))
						js.return
					end
				when 7 then -- switch 1, case 7
					if not js.return_called then
						Result := (ce_string ("Couldn%'t connect to server"))
						js.return
					end
				when 8 then -- switch 1, case 8
					if not js.return_called then
						Result := (ce_string ("FTP: weird server reply"))
						js.return
					end
				when 9 then -- switch 1, case 9
					if not js.return_called then
						Result := (ce_string ("Access denied to remote resource"))
						js.return
					end
				when 10 then -- switch 1, case 84
					if not js.return_called then
						Result := (ce_string ("FTP: The server did not accept the PRET command."))
						js.return
					end
				when 11 then -- switch 1, case 11
					if not js.return_called then
						Result := (ce_string ("FTP: unknown PASS reply"))
						js.return
					end
				when 12 then -- switch 1, case 13
					if not js.return_called then
						Result := (ce_string ("FTP: unknown PASV reply"))
						js.return
					end
				when 13 then -- switch 1, case 14
					if not js.return_called then
						Result := (ce_string ("FTP: unknown 227 response format"))
						js.return
					end
				when 14 then -- switch 1, case 15
					if not js.return_called then
						Result := (ce_string ("FTP: can%'t figure out the host in the PASV response"))
						js.return
					end
				when 15 then -- switch 1, case 17
					if not js.return_called then
						Result := (ce_string ("FTP: couldn%'t set file type"))
						js.return
					end
				when 16 then -- switch 1, case 18
					if not js.return_called then
						Result := (ce_string ("Transferred a partial file"))
						js.return
					end
				when 17 then -- switch 1, case 19
					if not js.return_called then
						Result := (ce_string ("FTP: couldn%'t retrieve (RETR failed) the specified file"))
						js.return
					end
				when 18 then -- switch 1, case 21
					if not js.return_called then
						Result := (ce_string ("Quote command returned error"))
						js.return
					end
				when 19 then -- switch 1, case 22
					if not js.return_called then
						Result := (ce_string ("HTTP response code said error"))
						js.return
					end
				when 20 then -- switch 1, case 23
					if not js.return_called then
						Result := (ce_string ("Failed writing received data to disk/application"))
						js.return
					end
				when 21 then -- switch 1, case 25
					if not js.return_called then
						Result := (ce_string ("Upload failed (at start/before it took off)"))
						js.return
					end
				when 22 then -- switch 1, case 26
					if not js.return_called then
						Result := (ce_string ("Failed to open/read local data from file/application"))
						js.return
					end
				when 23 then -- switch 1, case 27
					if not js.return_called then
						Result := (ce_string ("Out of memory"))
						js.return
					end
				when 24 then -- switch 1, case 28
					if not js.return_called then
						Result := (ce_string ("Timeout was reached"))
						js.return
					end
				when 25 then -- switch 1, case 30
					if not js.return_called then
						Result := (ce_string ("FTP: command PORT failed"))
						js.return
					end
				when 26 then -- switch 1, case 31
					if not js.return_called then
						Result := (ce_string ("FTP: command REST failed"))
						js.return
					end
				when 27 then -- switch 1, case 33
					if not js.return_called then
						Result := (ce_string ("Requested range was not delivered by the server"))
						js.return
					end
				when 28 then -- switch 1, case 34
					if not js.return_called then
						Result := (ce_string ("Internal problem setting up the POST"))
						js.return
					end
				when 29 then -- switch 1, case 35
					if not js.return_called then
						Result := (ce_string ("SSL connect error"))
						js.return
					end
				when 30 then -- switch 1, case 36
					if not js.return_called then
						Result := (ce_string ("Couldn%'t resume download"))
						js.return
					end
				when 31 then -- switch 1, case 37
					if not js.return_called then
						Result := (ce_string ("Couldn%'t read a file:// file"))
						js.return
					end
				when 32 then -- switch 1, case 38
					if not js.return_called then
						Result := (ce_string ("LDAP: cannot bind"))
						js.return
					end
				when 33 then -- switch 1, case 39
					if not js.return_called then
						Result := (ce_string ("LDAP: search failed"))
						js.return
					end
				when 34 then -- switch 1, case 41
					if not js.return_called then
						Result := (ce_string ("A required function in the library was not found"))
						js.return
					end
				when 35 then -- switch 1, case 42
					if not js.return_called then
						Result := (ce_string ("Operation was aborted by an application callback"))
						js.return
					end
				when 36 then -- switch 1, case 43
					if not js.return_called then
						Result := (ce_string ("A libcurl function was given a bad argument"))
						js.return
					end
				when 37 then -- switch 1, case 45
					if not js.return_called then
						Result := (ce_string ("Failed binding local connection end"))
						js.return
					end
				when 38 then -- switch 1, case 47
					if not js.return_called then
						Result := (ce_string ("Number of redirects hit maximum amount"))
						js.return
					end
				when 39 then -- switch 1, case 48
					if not js.return_called then
						Result := (ce_string ("User specified an unknown telnet option"))
						js.return
					end
				when 40 then -- switch 1, case 49
					if not js.return_called then
						Result := (ce_string ("Malformed telnet option"))
						js.return
					end
				when 41 then -- switch 1, case 51
					if not js.return_called then
						Result := (ce_string ("SSL peer certificate or SSH remote key was not OK"))
						js.return
					end
				when 42 then -- switch 1, case 52
					if not js.return_called then
						Result := (ce_string ("Server returned nothing (no headers, no data)"))
						js.return
					end
				when 43 then -- switch 1, case 53
					if not js.return_called then
						Result := (ce_string ("SSL crypto engine not found"))
						js.return
					end
				when 44 then -- switch 1, case 54
					if not js.return_called then
						Result := (ce_string ("Can not set SSL crypto engine as default"))
						js.return
					end
				when 45 then -- switch 1, case 66
					if not js.return_called then
						Result := (ce_string ("Failed to initialise SSL crypto engine"))
						js.return
					end
				when 46 then -- switch 1, case 55
					if not js.return_called then
						Result := (ce_string ("Failed sending data to the peer"))
						js.return
					end
				when 47 then -- switch 1, case 56
					if not js.return_called then
						Result := (ce_string ("Failure when receiving data from the peer"))
						js.return
					end
				when 48 then -- switch 1, case 58
					if not js.return_called then
						Result := (ce_string ("Problem with the local SSL certificate"))
						js.return
					end
				when 49 then -- switch 1, case 59
					if not js.return_called then
						Result := (ce_string ("Couldn%'t use specified SSL cipher"))
						js.return
					end
				when 50 then -- switch 1, case 60
					if not js.return_called then
						Result := (ce_string ("Peer certificate cannot be authenticated with known CA certificates"))
						js.return
					end
				when 51 then -- switch 1, case 77
					if not js.return_called then
						Result := (ce_string ("Problem with the SSL CA cert (path? access rights?)"))
						js.return
					end
				when 52 then -- switch 1, case 61
					if not js.return_called then
						Result := (ce_string ("Unrecognized HTTP Content-Encoding"))
						js.return
					end
				when 53 then -- switch 1, case 62
					if not js.return_called then
						Result := (ce_string ("Invalid LDAP URL"))
						js.return
					end
				when 54 then -- switch 1, case 63
					if not js.return_called then
						Result := (ce_string ("Maximum file size exceeded"))
						js.return
					end
				when 55 then -- switch 1, case 64
					if not js.return_called then
						Result := (ce_string ("Requested SSL level failed"))
						js.return
					end
				when 56 then -- switch 1, case 80
					if not js.return_called then
						Result := (ce_string ("Failed to shut down the SSL connection"))
						js.return
					end
				when 57 then -- switch 1, case 82
					if not js.return_called then
						Result := (ce_string ("Failed to load CRL file (path? access rights?, format?)"))
						js.return
					end
				when 58 then -- switch 1, case 83
					if not js.return_called then
						Result := (ce_string ("Issuer check against peer certificate failed"))
						js.return
					end
				when 59 then -- switch 1, case 65
					if not js.return_called then
						Result := (ce_string ("Send failed since rewinding of the data stream failed"))
						js.return
					end
				when 60 then -- switch 1, case 67
					if not js.return_called then
						Result := (ce_string ("Login denied"))
						js.return
					end
				when 61 then -- switch 1, case 68
					if not js.return_called then
						Result := (ce_string ("TFTP: File Not Found"))
						js.return
					end
				when 62 then -- switch 1, case 69
					if not js.return_called then
						Result := (ce_string ("TFTP: Access Violation"))
						js.return
					end
				when 63 then -- switch 1, case 70
					if not js.return_called then
						Result := (ce_string ("Disk full or allocation exceeded"))
						js.return
					end
				when 64 then -- switch 1, case 71
					if not js.return_called then
						Result := (ce_string ("TFTP: Illegal operation"))
						js.return
					end
				when 65 then -- switch 1, case 72
					if not js.return_called then
						Result := (ce_string ("TFTP: Unknown transfer ID"))
						js.return
					end
				when 66 then -- switch 1, case 73
					if not js.return_called then
						Result := (ce_string ("Remote file already exists"))
						js.return
					end
				when 67 then -- switch 1, case 74
					if not js.return_called then
						Result := (ce_string ("TFTP: No such user"))
						js.return
					end
				when 68 then -- switch 1, case 75
					if not js.return_called then
						Result := (ce_string ("Conversion failed"))
						js.return
					end
				when 69 then -- switch 1, case 76
					if not js.return_called then
						Result := (ce_string ("Caller must register CURLOPT_CONV_ callback options"))
						js.return
					end
				when 70 then -- switch 1, case 78
					if not js.return_called then
						Result := (ce_string ("Remote file not found"))
						js.return
					end
				when 71 then -- switch 1, case 79
					if not js.return_called then
						Result := (ce_string ("Error in the SSH layer"))
						js.return
					end
				when 72 then -- switch 1, case 81
					if not js.return_called then
						Result := (ce_string ("Socket not ready for send/recv"))
						js.return
					end
				when 73 then -- switch 1, case 85
					if not js.return_called then
						Result := (ce_string ("RTSP CSeq mismatch or invalid CSeq"))
						js.return
					end
				when 74 then -- switch 1, case 86
					if not js.return_called then
						Result := (ce_string ("RTSP session error"))
						js.return
					end
				when 75 then -- switch 1, case 87
					if not js.return_called then
						Result := (ce_string ("Unable to parse FTP file list"))
						js.return
					end
				when 76 then -- switch 1, case 88
					if not js.return_called then
						Result := (ce_string ("Chunk callback failed"))
						js.return
					end
				when 77 then -- switch 1, case 4 | switch 1, case 10 | switch 1, case 12 | switch 1, case 16 | switch 1, case 20 | switch 1, case 24 | switch 1, case 29 | switch 1, case 32 | switch 1, case 40 | switch 1, case 44 | switch 1, case 46 | switch 1, case 50 | switch 1, case 57 | switch 1, case 89
					l_pos := -1 + 78 -- switch 1; break
				when 78 then -- switch 1, done:
					if not js.return_called then
						Result := (ce_string ("Unknown error"))
					end
				when 79 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	curl_multi_strerror (a_error: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_error -- switch 1 head
					when -1 then l_pos := -1 + 1
					when 0 then l_pos := -1 + 2
					when 1 then l_pos := -1 + 3
					when 2 then l_pos := -1 + 4
					when 3 then l_pos := -1 + 5
					when 4 then l_pos := -1 + 6
					when 5 then l_pos := -1 + 7
					when 6 then l_pos := -1 + 8
					when 7 then l_pos := -1 + 9
					else l_pos := -1 + 10
					end
				when 1 then -- switch 1, case -1
					Result := (ce_string ("Please call curl_multi_perform() soon"))
					js.return
				when 2 then -- switch 1, case 0
					if not js.return_called then
						Result := (ce_string ("No error"))
						js.return
					end
				when 3 then -- switch 1, case 1
					if not js.return_called then
						Result := (ce_string ("Invalid multi handle"))
						js.return
					end
				when 4 then -- switch 1, case 2
					if not js.return_called then
						Result := (ce_string ("Invalid easy handle"))
						js.return
					end
				when 5 then -- switch 1, case 3
					if not js.return_called then
						Result := (ce_string ("Out of memory"))
						js.return
					end
				when 6 then -- switch 1, case 4
					if not js.return_called then
						Result := (ce_string ("Internal error"))
						js.return
					end
				when 7 then -- switch 1, case 5
					if not js.return_called then
						Result := (ce_string ("Invalid socket argument"))
						js.return
					end
				when 8 then -- switch 1, case 6
					if not js.return_called then
						Result := (ce_string ("Unknown option"))
						js.return
					end
				when 9 then -- switch 1, case 7
					l_pos := -1 + 10 -- switch 1; break
				when 10 then -- switch 1, done:
					if not js.return_called then
						Result := (ce_string ("Unknown error"))
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	curl_share_strerror (a_error: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_error -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					when 3 then l_pos := -1 + 4
					when 4 then l_pos := -1 + 5
					when 5 then l_pos := -1 + 6
					else l_pos := -1 + 7
					end
				when 1 then -- switch 1, case 0
					Result := (ce_string ("No error"))
					js.return
				when 2 then -- switch 1, case 1
					if not js.return_called then
						Result := (ce_string ("Unknown share option"))
						js.return
					end
				when 3 then -- switch 1, case 2
					if not js.return_called then
						Result := (ce_string ("Share currently in use"))
						js.return
					end
				when 4 then -- switch 1, case 3
					if not js.return_called then
						Result := (ce_string ("Invalid share handle"))
						js.return
					end
				when 5 then -- switch 1, case 4
					if not js.return_called then
						Result := (ce_string ("Out of memory"))
						js.return
					end
				when 6 then -- switch 1, case 5
					l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done:
					if not js.return_called then
						Result := (ce_string ("CURLSHcode unknown"))
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_strerror (a_conn: CE_POINTER [PD_CONNECTDATA]; a_err: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_buf: CE_POINTER [INTEGER_8]
			l_p: CE_POINTER [INTEGER_8]
			l_max: NATURAL_32
			l_old_errno: INTEGER_32
		do
			create l_buf.make
			create l_p.make

			l_old_errno := (errno_location).item
			l_buf.ce_gets (a_conn.item.syserr_buf)
			l_max := (Integer_8_bytes.to_natural_32 * (256).to_natural_32) - {NATURAL_32} 1
			l_buf[0] := (('%/0/').code).to_integer_8
			if (0).to_natural_32 /= ((strerror_r (a_err, l_buf, l_max)).c_pointer.to_integer_32).to_natural_32 then
				if 0 = (l_buf[0]).to_integer_32 then
					mprintf_inst.curl_msnprintf ([l_buf, l_max, ce_string ("Unknown error %%d"), a_err]).do_nothing
				end
			end
			l_buf[l_max.to_integer_32] := (('%/0/').code).to_integer_8
			l_p.ce_gets (strrchr (l_buf, ('%N').code))
			if (l_p.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if l_p.distance (l_buf) >= 2 then
					l_p[0] := (('%/0/').code).to_integer_8
				end
			end
			l_p.ce_gets (strrchr (l_buf, ('%R').code))
			if (l_p.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if l_p.distance (l_buf) >= 1 then
					l_p[0] := (('%/0/').code).to_integer_8
				end
			end
			if l_old_errno /= (errno_location).item then
				(errno_location).item := l_old_errno
			end
			Result := l_buf
		end

end
