class
	P_WARNLESS

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	curlx_ultous (a_ulnum: NATURAL_32): NATURAL_16
		do
			Result := ((a_ulnum).bit_and ({NATURAL_32} 65535)).to_natural_16
		end

	curlx_ultouc (a_ulnum: NATURAL_32): NATURAL_8
		do
			Result := ((a_ulnum).bit_and ({NATURAL_32} 255)).to_natural_8
		end

	curlx_uztosi (a_uznum: NATURAL_32): INTEGER_32
		do
			Result := ((a_uznum).bit_and ({NATURAL_32} 2147483647)).to_integer_32
		end

end
