class
	SD_FD_SET

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	fds_bits: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_fds_bits (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {NONE} -- C getters

	c_fds_bits (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_fd_set_3 *tmp = (struct __anonstruct_fd_set_3 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->fds_bits) / sizeof(tmp->fds_bits[0]);
				return tmp->fds_bits;
			]"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct __anonstruct_fd_set_3);"
		end

end
