class
	SD_RT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	si_pid: INTEGER_32 assign set_si_pid
		do
			Result := c_si_pid (c_pointer)
		end

	si_uid: NATURAL_32 assign set_si_uid
		do
			Result := c_si_uid (c_pointer)
		end

	si_sigval: SD_SIGVAL assign set_si_sigval
		do
			create Result.make_shared (c_si_sigval (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_si_pid (a_si_pid: INTEGER_32)
		do
			c_set_si_pid (c_pointer, a_si_pid)
		end

	set_si_uid (a_si_uid: NATURAL_32)
		do
			c_set_si_uid (c_pointer, a_si_uid)
		end

	set_si_sigval (a_si_sigval: SD_SIGVAL)
		do
			si_sigval.ce_gets (a_si_sigval)
		end

feature {NONE} -- C getters

	c_si_pid (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct__rt_46 *)$tmp)->si_pid;"
		end

	c_si_uid (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct__rt_46 *)$tmp)->si_uid;"
		end

	c_si_sigval (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union sigval *)&((struct __anonstruct__rt_46 *)$tmp)->si_sigval;"
		end

feature {NONE} -- C setters

	c_set_si_pid (tmp: POINTER; a_si_pid: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__rt_46 *)$tmp)->si_pid = $a_si_pid;"
		end

	c_set_si_uid (tmp: POINTER; a_si_uid: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__rt_46 *)$tmp)->si_uid = $a_si_uid;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct __anonstruct__rt_46);"
		end

end
