class
	SD_SIGPOLL

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	si_band: INTEGER_32 assign set_si_band
		do
			Result := c_si_band (c_pointer)
		end

	si_fd: INTEGER_32 assign set_si_fd
		do
			Result := c_si_fd (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_si_band (a_si_band: INTEGER_32)
		do
			c_set_si_band (c_pointer, a_si_band)
		end

	set_si_fd (a_si_fd: INTEGER_32)
		do
			c_set_si_fd (c_pointer, a_si_fd)
		end

feature {NONE} -- C getters

	c_si_band (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct__sigpoll_49 *)$tmp)->si_band;"
		end

	c_si_fd (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct__sigpoll_49 *)$tmp)->si_fd;"
		end

feature {NONE} -- C setters

	c_set_si_band (tmp: POINTER; a_si_band: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__sigpoll_49 *)$tmp)->si_band = $a_si_band;"
		end

	c_set_si_fd (tmp: POINTER; a_si_fd: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__sigpoll_49 *)$tmp)->si_fd = $a_si_fd;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct __anonstruct__sigpoll_49);"
		end

end
