class
	SD_TIMER

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	si_tid: INTEGER_32 assign set_si_tid
		do
			Result := c_si_tid (c_pointer)
		end

	si_overrun: INTEGER_32 assign set_si_overrun
		do
			Result := c_si_overrun (c_pointer)
		end

	si_sigval: SD_SIGVAL assign set_si_sigval
		do
			create Result.make_shared (c_si_sigval (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_si_tid (a_si_tid: INTEGER_32)
		do
			c_set_si_tid (c_pointer, a_si_tid)
		end

	set_si_overrun (a_si_overrun: INTEGER_32)
		do
			c_set_si_overrun (c_pointer, a_si_overrun)
		end

	set_si_sigval (a_si_sigval: SD_SIGVAL)
		do
			si_sigval.ce_gets (a_si_sigval)
		end

feature {NONE} -- C getters

	c_si_tid (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct__timer_45 *)$tmp)->si_tid;"
		end

	c_si_overrun (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct__timer_45 *)$tmp)->si_overrun;"
		end

	c_si_sigval (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union sigval *)&((struct __anonstruct__timer_45 *)$tmp)->si_sigval;"
		end

feature {NONE} -- C setters

	c_set_si_tid (tmp: POINTER; a_si_tid: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__timer_45 *)$tmp)->si_tid = $a_si_tid;"
		end

	c_set_si_overrun (tmp: POINTER; a_si_overrun: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__timer_45 *)$tmp)->si_overrun = $a_si_overrun;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct __anonstruct__timer_45);"
		end

end
