class
	PD_DOPRNT_PARAMS_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	base: INTEGER_32 assign set_base
		do
			Result := c_base (c_pointer)
		end

	conv: INTEGER_32 assign set_conv
		do
			Result := c_conv (c_pointer)
		end

	expfmt: CE_POINTER [INTEGER_8] assign set_expfmt
		do
			create Result.make_shared (c_expfmt (c_pointer))
		end

	exptimes4: INTEGER_32 assign set_exptimes4
		do
			Result := c_exptimes4 (c_pointer)
		end

	fill: INTEGER_8 assign set_fill
		do
			Result := c_fill (c_pointer)
		end

	justify: INTEGER_32 assign set_justify
		do
			Result := c_justify (c_pointer)
		end

	prec: INTEGER_32 assign set_prec
		do
			Result := c_prec (c_pointer)
		end

	prec_offset: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return (int)offsetof(struct doprnt_params_t, prec);"
		end

	showbase: INTEGER_32 assign set_showbase
		do
			Result := c_showbase (c_pointer)
		end

	showpoint: INTEGER_32 assign set_showpoint
		do
			Result := c_showpoint (c_pointer)
		end

	showtrailing: INTEGER_32 assign set_showtrailing
		do
			Result := c_showtrailing (c_pointer)
		end

	sign: INTEGER_8 assign set_sign
		do
			Result := c_sign (c_pointer)
		end

	width: INTEGER_32 assign set_width
		do
			Result := c_width (c_pointer)
		end

	width_offset: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return (int)offsetof(struct doprnt_params_t, width);"
		end

feature {ANY} -- Eiffel setters

	set_base (a_base: INTEGER_32)
		do
			c_set_base (c_pointer, a_base)
		end

	set_conv (a_conv: INTEGER_32)
		do
			c_set_conv (c_pointer, a_conv)
		end

	set_expfmt (a_expfmt: CE_POINTER [INTEGER_8])
		do
			c_set_expfmt (c_pointer, a_expfmt.c_pointer)
		end

	set_exptimes4 (a_exptimes4: INTEGER_32)
		do
			c_set_exptimes4 (c_pointer, a_exptimes4)
		end

	set_fill (a_fill: INTEGER_8)
		do
			c_set_fill (c_pointer, a_fill)
		end

	set_justify (a_justify: INTEGER_32)
		do
			c_set_justify (c_pointer, a_justify)
		end

	set_prec (a_prec: INTEGER_32)
		do
			c_set_prec (c_pointer, a_prec)
		end

	set_showbase (a_showbase: INTEGER_32)
		do
			c_set_showbase (c_pointer, a_showbase)
		end

	set_showpoint (a_showpoint: INTEGER_32)
		do
			c_set_showpoint (c_pointer, a_showpoint)
		end

	set_showtrailing (a_showtrailing: INTEGER_32)
		do
			c_set_showtrailing (c_pointer, a_showtrailing)
		end

	set_sign (a_sign: INTEGER_8)
		do
			c_set_sign (c_pointer, a_sign)
		end

	set_width (a_width: INTEGER_32)
		do
			c_set_width (c_pointer, a_width)
		end

feature {NONE} -- C getters

	c_base (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct doprnt_params_t *)$tmp)->base;"
		end

	c_conv (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct doprnt_params_t *)$tmp)->conv;"
		end

	c_expfmt (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct doprnt_params_t *)$tmp)->expfmt;"
		end

	c_exptimes4 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct doprnt_params_t *)$tmp)->exptimes4;"
		end

	c_fill (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct doprnt_params_t *)$tmp)->fill;"
		end

	c_justify (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct doprnt_params_t *)$tmp)->justify;"
		end

	c_prec (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct doprnt_params_t *)$tmp)->prec;"
		end

	c_showbase (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct doprnt_params_t *)$tmp)->showbase;"
		end

	c_showpoint (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct doprnt_params_t *)$tmp)->showpoint;"
		end

	c_showtrailing (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct doprnt_params_t *)$tmp)->showtrailing;"
		end

	c_sign (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct doprnt_params_t *)$tmp)->sign;"
		end

	c_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct doprnt_params_t *)$tmp)->width;"
		end

feature {NONE} -- C setters

	c_set_base (tmp: POINTER; a_base: INTEGER_32)
		external
			"C inline"
		alias
			"((struct doprnt_params_t *)$tmp)->base = $a_base;"
		end

	c_set_conv (tmp: POINTER; a_conv: INTEGER_32)
		external
			"C inline"
		alias
			"((struct doprnt_params_t *)$tmp)->conv = $a_conv;"
		end

	c_set_expfmt (tmp: POINTER; a_expfmt: POINTER)
		external
			"C inline"
		alias
			"((struct doprnt_params_t *)$tmp)->expfmt = (char const *)$a_expfmt;"
		end

	c_set_exptimes4 (tmp: POINTER; a_exptimes4: INTEGER_32)
		external
			"C inline"
		alias
			"((struct doprnt_params_t *)$tmp)->exptimes4 = $a_exptimes4;"
		end

	c_set_fill (tmp: POINTER; a_fill: INTEGER_8)
		external
			"C inline"
		alias
			"((struct doprnt_params_t *)$tmp)->fill = $a_fill;"
		end

	c_set_justify (tmp: POINTER; a_justify: INTEGER_32)
		external
			"C inline"
		alias
			"((struct doprnt_params_t *)$tmp)->justify = $a_justify;"
		end

	c_set_prec (tmp: POINTER; a_prec: INTEGER_32)
		external
			"C inline"
		alias
			"((struct doprnt_params_t *)$tmp)->prec = $a_prec;"
		end

	c_set_showbase (tmp: POINTER; a_showbase: INTEGER_32)
		external
			"C inline"
		alias
			"((struct doprnt_params_t *)$tmp)->showbase = $a_showbase;"
		end

	c_set_showpoint (tmp: POINTER; a_showpoint: INTEGER_32)
		external
			"C inline"
		alias
			"((struct doprnt_params_t *)$tmp)->showpoint = $a_showpoint;"
		end

	c_set_showtrailing (tmp: POINTER; a_showtrailing: INTEGER_32)
		external
			"C inline"
		alias
			"((struct doprnt_params_t *)$tmp)->showtrailing = $a_showtrailing;"
		end

	c_set_sign (tmp: POINTER; a_sign: INTEGER_8)
		external
			"C inline"
		alias
			"((struct doprnt_params_t *)$tmp)->sign = $a_sign;"
		end

	c_set_width (tmp: POINTER; a_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct doprnt_params_t *)$tmp)->width = $a_width;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(struct doprnt_params_t);"
		end

end
