class
	PD_FFT_TABLE_NK

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	n: NATURAL_32 assign set_n
		do
			Result := c_n (c_pointer)
		end

	k: NATURAL_32 assign set_k
		do
			Result := c_k (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_n (a_n: NATURAL_32)
		do
			c_set_n (c_pointer, a_n)
		end

	set_k (a_k: NATURAL_32)
		do
			c_set_k (c_pointer, a_k)
		end

feature {NONE} -- C getters

	c_n (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct fft_table_nk *)$tmp)->n;"
		end

	c_k (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct fft_table_nk *)$tmp)->k;"
		end

feature {NONE} -- C setters

	c_set_n (tmp: POINTER; a_n: NATURAL_32)
		external
			"C inline"
		alias
			"((struct fft_table_nk *)$tmp)->n = $a_n;"
		end

	c_set_k (tmp: POINTER; a_k: NATURAL_32)
		external
			"C inline"
		alias
			"((struct fft_table_nk *)$tmp)->k = $a_k;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(struct fft_table_nk);"
		end

end
