class
	PD_GMP_ASPRINTF_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	result2: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_result2
		do
			create Result.make_shared (c_result2 (c_pointer))
		end

	buf: CE_POINTER [INTEGER_8] assign set_buf
		do
			create Result.make_shared (c_buf (c_pointer))
		end

	size: NATURAL_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	alloc: NATURAL_32 assign set_alloc
		do
			Result := c_alloc (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_result2 (a_result2: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			c_set_result2 (c_pointer, a_result2.c_pointer)
		end

	set_buf (a_buf: CE_POINTER [INTEGER_8])
		do
			c_set_buf (c_pointer, a_buf.c_pointer)
		end

	set_size (a_size: NATURAL_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_alloc (a_alloc: NATURAL_32)
		do
			c_set_alloc (c_pointer, a_alloc)
		end

feature {NONE} -- C getters

	c_result2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char * *)((struct gmp_asprintf_t *)$tmp)->result;"
		end

	c_buf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct gmp_asprintf_t *)$tmp)->buf;"
		end

	c_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct gmp_asprintf_t *)$tmp)->size;"
		end

	c_alloc (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct gmp_asprintf_t *)$tmp)->alloc;"
		end

feature {NONE} -- C setters

	c_set_result2 (tmp: POINTER; a_result2: POINTER)
		external
			"C inline"
		alias
			"((struct gmp_asprintf_t *)$tmp)->result = (char * *)$a_result2;"
		end

	c_set_buf (tmp: POINTER; a_buf: POINTER)
		external
			"C inline"
		alias
			"((struct gmp_asprintf_t *)$tmp)->buf = (char *)$a_buf;"
		end

	c_set_size (tmp: POINTER; a_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct gmp_asprintf_t *)$tmp)->size = $a_size;"
		end

	c_set_alloc (tmp: POINTER; a_alloc: NATURAL_32)
		external
			"C inline"
		alias
			"((struct gmp_asprintf_t *)$tmp)->alloc = $a_alloc;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(struct gmp_asprintf_t);"
		end

end
