class
	PD_GMP_DOSCAN_PARAMS_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	base: INTEGER_32 assign set_base
		do
			Result := c_base (c_pointer)
		end

	ignore: INTEGER_32 assign set_ignore
		do
			Result := c_ignore (c_pointer)
		end

	type: INTEGER_8 assign set_type
		do
			Result := c_type (c_pointer)
		end

	width: INTEGER_32 assign set_width
		do
			Result := c_width (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_base (a_base: INTEGER_32)
		do
			c_set_base (c_pointer, a_base)
		end

	set_ignore (a_ignore: INTEGER_32)
		do
			c_set_ignore (c_pointer, a_ignore)
		end

	set_type (a_type: INTEGER_8)
		do
			c_set_type (c_pointer, a_type)
		end

	set_width (a_width: INTEGER_32)
		do
			c_set_width (c_pointer, a_width)
		end

feature {NONE} -- C getters

	c_base (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct gmp_doscan_params_t *)$tmp)->base;"
		end

	c_ignore (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct gmp_doscan_params_t *)$tmp)->ignore;"
		end

	c_type (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct gmp_doscan_params_t *)$tmp)->type;"
		end

	c_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct gmp_doscan_params_t *)$tmp)->width;"
		end

feature {NONE} -- C setters

	c_set_base (tmp: POINTER; a_base: INTEGER_32)
		external
			"C inline"
		alias
			"((struct gmp_doscan_params_t *)$tmp)->base = $a_base;"
		end

	c_set_ignore (tmp: POINTER; a_ignore: INTEGER_32)
		external
			"C inline"
		alias
			"((struct gmp_doscan_params_t *)$tmp)->ignore = $a_ignore;"
		end

	c_set_type (tmp: POINTER; a_type: INTEGER_8)
		external
			"C inline"
		alias
			"((struct gmp_doscan_params_t *)$tmp)->type = $a_type;"
		end

	c_set_width (tmp: POINTER; a_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct gmp_doscan_params_t *)$tmp)->width = $a_width;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(struct gmp_doscan_params_t);"
		end

end
