class
	PD_GMP_PI1_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	inv32: NATURAL_32 assign set_inv32
		do
			Result := c_inv32 (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_inv32 (a_inv32: NATURAL_32)
		do
			c_set_inv32 (c_pointer, a_inv32)
		end

feature {NONE} -- C getters

	c_inv32 (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_gmp_pi1_t_9 *)$tmp)->inv32;"
		end

feature {NONE} -- C setters

	c_set_inv32 (tmp: POINTER; a_inv32: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gmp_pi1_t_9 *)$tmp)->inv32 = $a_inv32;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(struct __anonstruct_gmp_pi1_t_9);"
		end

end
