class
	PD_GMP_PRIMES_DTAB

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	binv: NATURAL_32 assign set_binv
		do
			Result := c_binv (c_pointer)
		end

	lim: NATURAL_32 assign set_lim
		do
			Result := c_lim (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_binv (a_binv: NATURAL_32)
		do
			c_set_binv (c_pointer, a_binv)
		end

	set_lim (a_lim: NATURAL_32)
		do
			c_set_lim (c_pointer, a_lim)
		end

feature {NONE} -- C getters

	c_binv (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct gmp_primes_dtab *)$tmp)->binv;"
		end

	c_lim (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct gmp_primes_dtab *)$tmp)->lim;"
		end

feature {NONE} -- C setters

	c_set_binv (tmp: POINTER; a_binv: NATURAL_32)
		external
			"C inline"
		alias
			"((struct gmp_primes_dtab *)$tmp)->binv = $a_binv;"
		end

	c_set_lim (tmp: POINTER; a_lim: NATURAL_32)
		external
			"C inline"
		alias
			"((struct gmp_primes_dtab *)$tmp)->lim = $a_lim;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(struct gmp_primes_dtab);"
		end

end
