class
	PD_IEEE_DOUBLE_EXTRACT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	s: PD_S assign set_s
		do
			create Result.make_shared (c_s (c_pointer))
		end

	d: REAL_64 assign set_d
		do
			Result := c_d (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_s (a_s: PD_S)
		do
			s.ce_gets (a_s)
		end

	set_d (a_d: REAL_64)
		do
			c_set_d (c_pointer, a_d)
		end

feature {NONE} -- C getters

	c_s (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct __anonstruct_s_13 *)&((union ieee_double_extract *)$tmp)->s;"
		end

	c_d (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((union ieee_double_extract *)$tmp)->d;"
		end

feature {NONE} -- C setters

	c_set_d (tmp: POINTER; a_d: REAL_64)
		external
			"C inline"
		alias
			"((union ieee_double_extract *)$tmp)->d = $a_d;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(union ieee_double_extract);"
		end

end
