class
	PD_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	manl: NATURAL_32 assign set_manl
		do
			Result := c_manl (c_pointer)
		end

	manh: NATURAL_32 assign set_manh
		do
			Result := c_manh (c_pointer)
		end

	exp: NATURAL_32 assign set_exp
		do
			Result := c_exp (c_pointer)
		end

	sig: NATURAL_32 assign set_sig
		do
			Result := c_sig (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_manl (a_manl: NATURAL_32)
		do
			c_set_manl (c_pointer, a_manl)
		end

	set_manh (a_manh: NATURAL_32)
		do
			c_set_manh (c_pointer, a_manh)
		end

	set_exp (a_exp: NATURAL_32)
		do
			c_set_exp (c_pointer, a_exp)
		end

	set_sig (a_sig: NATURAL_32)
		do
			c_set_sig (c_pointer, a_sig)
		end

feature {NONE} -- C getters

	c_manl (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_s_13 *)$tmp)->manl;"
		end

	c_manh (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_s_13 *)$tmp)->manh;"
		end

	c_exp (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_s_13 *)$tmp)->exp;"
		end

	c_sig (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_s_13 *)$tmp)->sig;"
		end

feature {NONE} -- C setters

	c_set_manl (tmp: POINTER; a_manl: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_s_13 *)$tmp)->manl = $a_manl;"
		end

	c_set_manh (tmp: POINTER; a_manh: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_s_13 *)$tmp)->manh = $a_manh;"
		end

	c_set_exp (tmp: POINTER; a_exp: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_s_13 *)$tmp)->exp = $a_exp;"
		end

	c_set_sig (tmp: POINTER; a_sig: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_s_13 *)$tmp)->sig = $a_sig;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(struct __anonstruct_s_13);"
		end

end
