class
	PD_TMP_ALIGN_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	l: NATURAL_32 assign set_l
		do
			Result := c_l (c_pointer)
		end

	p: CE_POINTER [INTEGER_8] assign set_p
		do
			create Result.make_shared (c_p (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_l (a_l: NATURAL_32)
		do
			c_set_l (c_pointer, a_l)
		end

	set_p (a_p: CE_POINTER [INTEGER_8])
		do
			c_set_p (c_pointer, a_p.c_pointer)
		end

feature {NONE} -- C getters

	c_l (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((union tmp_align_t *)$tmp)->l;"
		end

	c_p (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((union tmp_align_t *)$tmp)->p;"
		end

feature {NONE} -- C setters

	c_set_l (tmp: POINTER; a_l: NATURAL_32)
		external
			"C inline"
		alias
			"((union tmp_align_t *)$tmp)->l = $a_l;"
		end

	c_set_p (tmp: POINTER; a_p: POINTER)
		external
			"C inline"
		alias
			"((union tmp_align_t *)$tmp)->p = (char *)$a_p;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(union tmp_align_t);"
		end

end
