deferred class
	LIBGMP_DATA

inherit
	CE_UTILITIES
	LIBGMP_ASSEMBLER
	PLATFORM

feature {NONE}

	gmp_inst: P_GMP
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	assert_inst: P_ASSERT
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	gmp_impl_inst: P_GMP_IMPL
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	compat_inst: P_COMPAT
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	errno_inst: P_ERRNO
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	extract_dbl_inst: P_EXTRACT_DBL
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	invalid_inst: P_INVALID
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	memory_inst: P_MEMORY
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	mp_bpl_inst: P_MP_BPL
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	mp_dv_tab_inst: P_MP_DV_TAB
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	mp_get_fns_inst: P_MP_GET_FNS
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	mp_set_fns_inst: P_MP_SET_FNS
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	rand_inst: P_RAND
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	randclr_inst: P_RANDCLR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	randdef_inst: P_RANDDEF
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	randiset_inst: P_RANDISET
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	randlc2s_inst: P_RANDLC2S
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	randlc2x_inst: P_RANDLC2X
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	randmt_inst: P_RANDMT
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	randmts_inst: P_RANDMTS
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	rands_inst: P_RANDS
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	randsd_inst: P_RANDSD
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	randsdui_inst: P_RANDSDUI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	randbui_inst: P_RANDBUI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	randmui_inst: P_RANDMUI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	version_inst: P_VERSION
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	nextprime_inst: P_NEXTPRIME
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	tal_reent_inst: P_TAL_REENT
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	init_inst: P_INIT
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	init2_inst: P_INIT2
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	inits_inst: P_INITS
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	set_inst: P_SET
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	set_ui_inst: P_SET_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	set_si_inst: P_SET_SI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	set_str_inst: P_SET_STR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	set_d_inst: P_SET_D
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	set_z_inst: P_SET_Z
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	iset_inst: P_ISET
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	iset_ui_inst: P_ISET_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	iset_si_inst: P_ISET_SI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	iset_str_inst: P_ISET_STR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	iset_d_inst: P_ISET_D
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	clear_inst: P_CLEAR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	clears_inst: P_CLEARS
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	get_str_inst: P_GET_STR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	dump_inst: P_DUMP
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	size_inst: P_SIZE
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	eq_inst: P_EQ
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	reldiff_inst: P_RELDIFF
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	sqrt_inst: P_SQRT
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	random2_inst: P_RANDOM2
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	inp_str_inst: P_INP_STR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	out_str_inst: P_OUT_STR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	add_inst: P_ADD
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	add_ui_inst: P_ADD_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	sub_inst: P_SUB
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	sub_ui_inst: P_SUB_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	ui_sub_inst: P_UI_SUB
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	mul_inst: P_MUL
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	mul_ui_inst: P_MUL_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	div_inst: P_DIV
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	div_ui_inst: P_DIV_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	cmp_inst: P_CMP
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	cmp_d_inst: P_CMP_D
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	cmp_ui_inst: P_CMP_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	cmp_si_inst: P_CMP_SI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	mul_2exp_inst: P_MUL_2EXP
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	div_2exp_inst: P_DIV_2EXP
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	abs_inst: P_ABS
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	neg_inst: P_NEG
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	set_q_inst: P_SET_Q
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	get_d_inst: P_GET_D
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	get_d_2exp_inst: P_GET_D_2EXP
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	set_dfl_prec_inst: P_SET_DFL_PREC
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	set_prc_inst: P_SET_PRC
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	set_prc_raw_inst: P_SET_PRC_RAW
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	get_dfl_prec_inst: P_GET_DFL_PREC
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	get_prc_inst: P_GET_PRC
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	ui_div_inst: P_UI_DIV
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	sqrt_ui_inst: P_SQRT_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	ceilfloor_inst: P_CEILFLOOR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	trunc_inst: P_TRUNC
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	pow_ui_inst: P_POW_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	urandomb_inst: P_URANDOMB
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	swap_inst: P_SWAP
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	fits_s_inst: P_FITS_S
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	fits_u_inst: P_FITS_U
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	get_si_inst: P_GET_SI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	get_ui_inst: P_GET_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	int_p_inst: P_INT_P
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	aors_inst: P_AORS
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	aors_ui_inst: P_AORS_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	aorsmul_inst: P_AORSMUL
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	aorsmul_i_inst: P_AORSMUL_I
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	and_inst: P_AND
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	array_init_inst: P_ARRAY_INIT
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	bin_ui_inst: P_BIN_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	bin_uiui_inst: P_BIN_UIUI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	cdiv_q_inst: P_CDIV_Q
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	cdiv_q_ui_inst: P_CDIV_Q_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	cdiv_qr_inst: P_CDIV_QR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	cdiv_qr_ui_inst: P_CDIV_QR_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	cdiv_r_inst: P_CDIV_R
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	cdiv_r_ui_inst: P_CDIV_R_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	cdiv_ui_inst: P_CDIV_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	cfdiv_q_2exp_inst: P_CFDIV_Q_2EXP
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	cfdiv_r_2exp_inst: P_CFDIV_R_2EXP
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	clrbit_inst: P_CLRBIT
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	cmpabs_inst: P_CMPABS
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	cmpabs_d_inst: P_CMPABS_D
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	cmpabs_ui_inst: P_CMPABS_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	com_inst: P_COM
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	combit_inst: P_COMBIT
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	cong_inst: P_CONG
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	cong_2exp_inst: P_CONG_2EXP
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	cong_ui_inst: P_CONG_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	divexact_inst: P_DIVEXACT
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	divegcd_inst: P_DIVEGCD
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	dive_ui_inst: P_DIVE_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	divis_inst: P_DIVIS
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	divis_ui_inst: P_DIVIS_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	divis_2exp_inst: P_DIVIS_2EXP
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	export_inst: P_EXPORT
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	fac_ui_inst: P_FAC_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	fdiv_q_inst: P_FDIV_Q
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	fdiv_q_ui_inst: P_FDIV_Q_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	fdiv_qr_inst: P_FDIV_QR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	fdiv_qr_ui_inst: P_FDIV_QR_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	fdiv_r_inst: P_FDIV_R
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	fdiv_r_ui_inst: P_FDIV_R_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	fdiv_ui_inst: P_FDIV_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	fib_ui_inst: P_FIB_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	fib2_ui_inst: P_FIB2_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	gcd_inst: P_GCD
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	gcd_ui_inst: P_GCD_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	gcdext_inst: P_GCDEXT
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	hamdist_inst: P_HAMDIST
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	import_inst: P_IMPORT
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	inp_raw_inst: P_INP_RAW
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	invert_inst: P_INVERT
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	ior_inst: P_IOR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	jacobi_inst: P_JACOBI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	kronsz_inst: P_KRONSZ
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	kronuz_inst: P_KRONUZ
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	kronzs_inst: P_KRONZS
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	kronzu_inst: P_KRONZU
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	lcm_inst: P_LCM
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	lcm_ui_inst: P_LCM_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	lucnum_ui_inst: P_LUCNUM_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	lucnum2_ui_inst: P_LUCNUM2_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	millerrabin_inst: P_MILLERRABIN
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	mod_inst: P_MOD
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	mul_i_inst: P_MUL_I
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	n_pow_ui_inst: P_N_POW_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	out_raw_inst: P_OUT_RAW
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	perfpow_inst: P_PERFPOW
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	powm_inst: P_POWM
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	powm_sec_inst: P_POWM_SEC
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	powm_ui_inst: P_POWM_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	pprime_p_inst: P_PPRIME_P
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	random_inst: P_RANDOM
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	realloc_inst: P_REALLOC
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	realloc2_inst: P_REALLOC2
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	remove_inst: P_REMOVE
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	root_inst: P_ROOT
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	rootrem_inst: P_ROOTREM
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	rrandomb_inst: P_RRANDOMB
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	scan0_inst: P_SCAN0
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	scan1_inst: P_SCAN1
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	set_f_inst: P_SET_F
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	setbit_inst: P_SETBIT
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	sizeinbase_inst: P_SIZEINBASE
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	sqrtrem_inst: P_SQRTREM
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	tdiv_ui_inst: P_TDIV_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	tdiv_q_inst: P_TDIV_Q
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	tdiv_q_2exp_inst: P_TDIV_Q_2EXP
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	tdiv_q_ui_inst: P_TDIV_Q_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	tdiv_qr_inst: P_TDIV_QR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	tdiv_qr_ui_inst: P_TDIV_QR_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	tdiv_r_inst: P_TDIV_R
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	tdiv_r_2exp_inst: P_TDIV_R_2EXP
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	tdiv_r_ui_inst: P_TDIV_R_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	tstbit_inst: P_TSTBIT
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	ui_pow_ui_inst: P_UI_POW_UI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	urandomm_inst: P_URANDOMM
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	xor_inst: P_XOR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	canonicalize_inst: P_CANONICALIZE
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	get_den_inst: P_GET_DEN
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	get_num_inst: P_GET_NUM
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	inv_inst: P_INV
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	md_2exp_inst: P_MD_2EXP
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	set_den_inst: P_SET_DEN
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	set_num_inst: P_SET_NUM
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	equal_inst: P_EQUAL
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	fib_table_inst: P_FIB_TABLE
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	mp_bases_inst: P_MP_BASES
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	diveby3_inst: P_DIVEBY3
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	divrem_inst: P_DIVREM
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	mod_1_inst: P_MOD_1
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	pre_mod_1_inst: P_PRE_MOD_1
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	mod_1_1_inst: P_MOD_1_1
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	mod_1_2_inst: P_MOD_1_2
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	mod_1_3_inst: P_MOD_1_3
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	lshiftc_inst: P_LSHIFTC
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	mul_fft_inst: P_MUL_FFT
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	mul_n_inst: P_MUL_N
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	sqr_inst: P_SQR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	nussbaumer_mul_inst: P_NUSSBAUMER_MUL
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	pow_1_inst: P_POW_1
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	perfsqr_inst: P_PERFSQR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	gcd_1_inst: P_GCD_1
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	gcdext_1_inst: P_GCDEXT_1
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	gcd_lehmer_inst: P_GCD_LEHMER
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	gcd_subdiv_step_inst: P_GCD_SUBDIV_STEP
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	gcdext_lehmer_inst: P_GCDEXT_LEHMER
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	gcdext_subdiv_step_inst: P_GCDEXT_SUBDIV_STEP
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	div_q_inst: P_DIV_Q
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	jacbase_inst: P_JACBASE
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	matrix22_mul_inst: P_MATRIX22_MUL
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	hgcd2_inst: P_HGCD2
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	hgcd_inst: P_HGCD
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	mullo_n_inst: P_MULLO_N
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	mullo_basecase_inst: P_MULLO_BASECASE
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom22_mul_inst: P_TOOM22_MUL
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom32_mul_inst: P_TOOM32_MUL
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom42_mul_inst: P_TOOM42_MUL
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom52_mul_inst: P_TOOM52_MUL
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom62_mul_inst: P_TOOM62_MUL
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom33_mul_inst: P_TOOM33_MUL
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom43_mul_inst: P_TOOM43_MUL
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom53_mul_inst: P_TOOM53_MUL
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom63_mul_inst: P_TOOM63_MUL
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom44_mul_inst: P_TOOM44_MUL
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom6h_mul_inst: P_TOOM6H_MUL
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom6_sqr_inst: P_TOOM6_SQR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom8h_mul_inst: P_TOOM8H_MUL
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom8_sqr_inst: P_TOOM8_SQR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom_couple_handling_inst: P_TOOM_COUPLE_HANDLING
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom2_sqr_inst: P_TOOM2_SQR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom3_sqr_inst: P_TOOM3_SQR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom4_sqr_inst: P_TOOM4_SQR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom_eval_dgr3_pm1_inst: P_TOOM_EVAL_DGR3_PM1
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom_eval_dgr3_pm2_inst: P_TOOM_EVAL_DGR3_PM2
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom_eval_pm1_inst: P_TOOM_EVAL_PM1
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom_eval_pm2_inst: P_TOOM_EVAL_PM2
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom_eval_pm2exp_inst: P_TOOM_EVAL_PM2EXP
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom_eval_pm2rexp_inst: P_TOOM_EVAL_PM2REXP
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom_interpolate_5pts_inst: P_TOOM_INTERPOLATE_5PTS
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom_interpolate_6pts_inst: P_TOOM_INTERPOLATE_6PTS
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom_interpolate_7pts_inst: P_TOOM_INTERPOLATE_7PTS
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom_interpolate_8pts_inst: P_TOOM_INTERPOLATE_8PTS
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom_interpolate_12pts_inst: P_TOOM_INTERPOLATE_12PTS
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	toom_interpolate_16pts_inst: P_TOOM_INTERPOLATE_16PTS
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	invertappr_inst: P_INVERTAPPR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	binvert_inst: P_BINVERT
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	mulmod_bnm1_inst: P_MULMOD_BNM1
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	sqrmod_bnm1_inst: P_SQRMOD_BNM1
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	sbpi1_div_q_inst: P_SBPI1_DIV_Q
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	sbpi1_div_qr_inst: P_SBPI1_DIV_QR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	sbpi1_divappr_q_inst: P_SBPI1_DIVAPPR_Q
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	dcpi1_div_q_inst: P_DCPI1_DIV_Q
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	dcpi1_div_qr_inst: P_DCPI1_DIV_QR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	dcpi1_divappr_q_inst: P_DCPI1_DIVAPPR_Q
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	mu_div_qr_inst: P_MU_DIV_QR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	mu_divappr_q_inst: P_MU_DIVAPPR_Q
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	mu_div_q_inst: P_MU_DIV_Q
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	bdiv_q_1_inst: P_BDIV_Q_1
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	sbpi1_bdiv_q_inst: P_SBPI1_BDIV_Q
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	sbpi1_bdiv_qr_inst: P_SBPI1_BDIV_QR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	dcpi1_bdiv_q_inst: P_DCPI1_BDIV_Q
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	dcpi1_bdiv_qr_inst: P_DCPI1_BDIV_QR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	mu_bdiv_q_inst: P_MU_BDIV_Q
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	mu_bdiv_qr_inst: P_MU_BDIV_QR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	bdiv_q_inst: P_BDIV_Q
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	bdiv_qr_inst: P_BDIV_QR
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	redc_1_inst: P_REDC_1
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	redc_2_inst: P_REDC_2
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	redc_n_inst: P_REDC_N
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	powlo_inst: P_POWLO
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	subcnd_n_inst: P_SUBCND_N
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	redc_1_sec_inst: P_REDC_1_SEC
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	trialdivtab_inst: P_TRIALDIVTAB
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	trialdiv_inst: P_TRIALDIV
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	and_n_inst: P_AND_N
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	andn_n_inst: P_ANDN_N
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	nand_n_inst: P_NAND_N
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	ior_n_inst: P_IOR_N
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	iorn_n_inst: P_IORN_N
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	nior_n_inst: P_NIOR_N
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	xor_n_inst: P_XOR_N
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	xnor_n_inst: P_XNOR_N
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	zero_inst: P_ZERO
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	asprintf_inst: P_ASPRINTF
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	asprntffuns_inst: P_ASPRNTFFUNS
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	doprnt_inst: P_DOPRNT
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	doprntf_inst: P_DOPRNTF
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	doprnti_inst: P_DOPRNTI
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	fprintf_inst: P_FPRINTF
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	obprintf_inst: P_OBPRINTF
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	obvprintf_inst: P_OBVPRINTF
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	obprntffuns_inst: P_OBPRNTFFUNS
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	printf_inst: P_PRINTF
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	printffuns_inst: P_PRINTFFUNS
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	snprintf_inst: P_SNPRINTF
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	snprntffuns_inst: P_SNPRNTFFUNS
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	sprintf_inst: P_SPRINTF
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	sprintffuns_inst: P_SPRINTFFUNS
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	vasprintf_inst: P_VASPRINTF
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	vfprintf_inst: P_VFPRINTF
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	vprintf_inst: P_VPRINTF
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	vsnprintf_inst: P_VSNPRINTF
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	vsprintf_inst: P_VSPRINTF
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	doscan_inst: P_DOSCAN
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	fscanf_inst: P_FSCANF
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	fscanffuns_inst: P_FSCANFFUNS
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	scanf_inst: P_SCANF
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	sscanf_inst: P_SSCANF
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	sscanffuns_inst: P_SSCANFFUNS
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	vfscanf_inst: P_VFSCANF
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	vscanf_inst: P_VSCANF
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

	vsscanf_inst: P_VSSCANF
		once ("PROCESS")
			create Result 
			libgmp_data_initialize
		end

feature {NONE}

	libgmp_data_initialize
		once ("PROCESS")
			gmp_inst.do_nothing
			assert_inst.do_nothing
			gmp_impl_inst.do_nothing
			compat_inst.do_nothing
			errno_inst.do_nothing
			extract_dbl_inst.do_nothing
			invalid_inst.do_nothing
			memory_inst.do_nothing
			mp_bpl_inst.do_nothing
			mp_dv_tab_inst.do_nothing
			mp_get_fns_inst.do_nothing
			mp_set_fns_inst.do_nothing
			rand_inst.do_nothing
			randclr_inst.do_nothing
			randdef_inst.do_nothing
			randiset_inst.do_nothing
			randlc2s_inst.do_nothing
			randlc2x_inst.do_nothing
			randmt_inst.do_nothing
			randmts_inst.do_nothing
			rands_inst.do_nothing
			randsd_inst.do_nothing
			randsdui_inst.do_nothing
			randbui_inst.do_nothing
			randmui_inst.do_nothing
			version_inst.do_nothing
			nextprime_inst.do_nothing
			tal_reent_inst.do_nothing
			init_inst.do_nothing
			init2_inst.do_nothing
			inits_inst.do_nothing
			set_inst.do_nothing
			set_ui_inst.do_nothing
			set_si_inst.do_nothing
			set_str_inst.do_nothing
			set_d_inst.do_nothing
			set_z_inst.do_nothing
			iset_inst.do_nothing
			iset_ui_inst.do_nothing
			iset_si_inst.do_nothing
			iset_str_inst.do_nothing
			iset_d_inst.do_nothing
			clear_inst.do_nothing
			clears_inst.do_nothing
			get_str_inst.do_nothing
			dump_inst.do_nothing
			size_inst.do_nothing
			eq_inst.do_nothing
			reldiff_inst.do_nothing
			sqrt_inst.do_nothing
			random2_inst.do_nothing
			inp_str_inst.do_nothing
			out_str_inst.do_nothing
			add_inst.do_nothing
			add_ui_inst.do_nothing
			sub_inst.do_nothing
			sub_ui_inst.do_nothing
			ui_sub_inst.do_nothing
			mul_inst.do_nothing
			mul_ui_inst.do_nothing
			div_inst.do_nothing
			div_ui_inst.do_nothing
			cmp_inst.do_nothing
			cmp_d_inst.do_nothing
			cmp_ui_inst.do_nothing
			cmp_si_inst.do_nothing
			mul_2exp_inst.do_nothing
			div_2exp_inst.do_nothing
			abs_inst.do_nothing
			neg_inst.do_nothing
			set_q_inst.do_nothing
			get_d_inst.do_nothing
			get_d_2exp_inst.do_nothing
			set_dfl_prec_inst.do_nothing
			set_prc_inst.do_nothing
			set_prc_raw_inst.do_nothing
			get_dfl_prec_inst.do_nothing
			get_prc_inst.do_nothing
			ui_div_inst.do_nothing
			sqrt_ui_inst.do_nothing
			ceilfloor_inst.do_nothing
			trunc_inst.do_nothing
			pow_ui_inst.do_nothing
			urandomb_inst.do_nothing
			swap_inst.do_nothing
			fits_s_inst.do_nothing
			fits_u_inst.do_nothing
			get_si_inst.do_nothing
			get_ui_inst.do_nothing
			int_p_inst.do_nothing
			aors_inst.do_nothing
			aors_ui_inst.do_nothing
			aorsmul_inst.do_nothing
			aorsmul_i_inst.do_nothing
			and_inst.do_nothing
			array_init_inst.do_nothing
			bin_ui_inst.do_nothing
			bin_uiui_inst.do_nothing
			cdiv_q_inst.do_nothing
			cdiv_q_ui_inst.do_nothing
			cdiv_qr_inst.do_nothing
			cdiv_qr_ui_inst.do_nothing
			cdiv_r_inst.do_nothing
			cdiv_r_ui_inst.do_nothing
			cdiv_ui_inst.do_nothing
			cfdiv_q_2exp_inst.do_nothing
			cfdiv_r_2exp_inst.do_nothing
			clrbit_inst.do_nothing
			cmpabs_inst.do_nothing
			cmpabs_d_inst.do_nothing
			cmpabs_ui_inst.do_nothing
			com_inst.do_nothing
			combit_inst.do_nothing
			cong_inst.do_nothing
			cong_2exp_inst.do_nothing
			cong_ui_inst.do_nothing
			divexact_inst.do_nothing
			divegcd_inst.do_nothing
			dive_ui_inst.do_nothing
			divis_inst.do_nothing
			divis_ui_inst.do_nothing
			divis_2exp_inst.do_nothing
			export_inst.do_nothing
			fac_ui_inst.do_nothing
			fdiv_q_inst.do_nothing
			fdiv_q_ui_inst.do_nothing
			fdiv_qr_inst.do_nothing
			fdiv_qr_ui_inst.do_nothing
			fdiv_r_inst.do_nothing
			fdiv_r_ui_inst.do_nothing
			fdiv_ui_inst.do_nothing
			fib_ui_inst.do_nothing
			fib2_ui_inst.do_nothing
			gcd_inst.do_nothing
			gcd_ui_inst.do_nothing
			gcdext_inst.do_nothing
			hamdist_inst.do_nothing
			import_inst.do_nothing
			inp_raw_inst.do_nothing
			invert_inst.do_nothing
			ior_inst.do_nothing
			jacobi_inst.do_nothing
			kronsz_inst.do_nothing
			kronuz_inst.do_nothing
			kronzs_inst.do_nothing
			kronzu_inst.do_nothing
			lcm_inst.do_nothing
			lcm_ui_inst.do_nothing
			lucnum_ui_inst.do_nothing
			lucnum2_ui_inst.do_nothing
			millerrabin_inst.do_nothing
			mod_inst.do_nothing
			mul_i_inst.do_nothing
			n_pow_ui_inst.do_nothing
			out_raw_inst.do_nothing
			perfpow_inst.do_nothing
			powm_inst.do_nothing
			powm_sec_inst.do_nothing
			powm_ui_inst.do_nothing
			pprime_p_inst.do_nothing
			random_inst.do_nothing
			realloc_inst.do_nothing
			realloc2_inst.do_nothing
			remove_inst.do_nothing
			root_inst.do_nothing
			rootrem_inst.do_nothing
			rrandomb_inst.do_nothing
			scan0_inst.do_nothing
			scan1_inst.do_nothing
			set_f_inst.do_nothing
			setbit_inst.do_nothing
			sizeinbase_inst.do_nothing
			sqrtrem_inst.do_nothing
			tdiv_ui_inst.do_nothing
			tdiv_q_inst.do_nothing
			tdiv_q_2exp_inst.do_nothing
			tdiv_q_ui_inst.do_nothing
			tdiv_qr_inst.do_nothing
			tdiv_qr_ui_inst.do_nothing
			tdiv_r_inst.do_nothing
			tdiv_r_2exp_inst.do_nothing
			tdiv_r_ui_inst.do_nothing
			tstbit_inst.do_nothing
			ui_pow_ui_inst.do_nothing
			urandomm_inst.do_nothing
			xor_inst.do_nothing
			canonicalize_inst.do_nothing
			get_den_inst.do_nothing
			get_num_inst.do_nothing
			inv_inst.do_nothing
			md_2exp_inst.do_nothing
			set_den_inst.do_nothing
			set_num_inst.do_nothing
			equal_inst.do_nothing
			fib_table_inst.do_nothing
			mp_bases_inst.do_nothing
			diveby3_inst.do_nothing
			divrem_inst.do_nothing
			mod_1_inst.do_nothing
			pre_mod_1_inst.do_nothing
			mod_1_1_inst.do_nothing
			mod_1_2_inst.do_nothing
			mod_1_3_inst.do_nothing
			lshiftc_inst.do_nothing
			mul_fft_inst.do_nothing
			mul_n_inst.do_nothing
			sqr_inst.do_nothing
			nussbaumer_mul_inst.do_nothing
			pow_1_inst.do_nothing
			perfsqr_inst.do_nothing
			gcd_1_inst.do_nothing
			gcdext_1_inst.do_nothing
			gcd_lehmer_inst.do_nothing
			gcd_subdiv_step_inst.do_nothing
			gcdext_lehmer_inst.do_nothing
			gcdext_subdiv_step_inst.do_nothing
			div_q_inst.do_nothing
			jacbase_inst.do_nothing
			matrix22_mul_inst.do_nothing
			hgcd2_inst.do_nothing
			hgcd_inst.do_nothing
			mullo_n_inst.do_nothing
			mullo_basecase_inst.do_nothing
			toom22_mul_inst.do_nothing
			toom32_mul_inst.do_nothing
			toom42_mul_inst.do_nothing
			toom52_mul_inst.do_nothing
			toom62_mul_inst.do_nothing
			toom33_mul_inst.do_nothing
			toom43_mul_inst.do_nothing
			toom53_mul_inst.do_nothing
			toom63_mul_inst.do_nothing
			toom44_mul_inst.do_nothing
			toom6h_mul_inst.do_nothing
			toom6_sqr_inst.do_nothing
			toom8h_mul_inst.do_nothing
			toom8_sqr_inst.do_nothing
			toom_couple_handling_inst.do_nothing
			toom2_sqr_inst.do_nothing
			toom3_sqr_inst.do_nothing
			toom4_sqr_inst.do_nothing
			toom_eval_dgr3_pm1_inst.do_nothing
			toom_eval_dgr3_pm2_inst.do_nothing
			toom_eval_pm1_inst.do_nothing
			toom_eval_pm2_inst.do_nothing
			toom_eval_pm2exp_inst.do_nothing
			toom_eval_pm2rexp_inst.do_nothing
			toom_interpolate_5pts_inst.do_nothing
			toom_interpolate_6pts_inst.do_nothing
			toom_interpolate_7pts_inst.do_nothing
			toom_interpolate_8pts_inst.do_nothing
			toom_interpolate_12pts_inst.do_nothing
			toom_interpolate_16pts_inst.do_nothing
			invertappr_inst.do_nothing
			binvert_inst.do_nothing
			mulmod_bnm1_inst.do_nothing
			sqrmod_bnm1_inst.do_nothing
			sbpi1_div_q_inst.do_nothing
			sbpi1_div_qr_inst.do_nothing
			sbpi1_divappr_q_inst.do_nothing
			dcpi1_div_q_inst.do_nothing
			dcpi1_div_qr_inst.do_nothing
			dcpi1_divappr_q_inst.do_nothing
			mu_div_qr_inst.do_nothing
			mu_divappr_q_inst.do_nothing
			mu_div_q_inst.do_nothing
			bdiv_q_1_inst.do_nothing
			sbpi1_bdiv_q_inst.do_nothing
			sbpi1_bdiv_qr_inst.do_nothing
			dcpi1_bdiv_q_inst.do_nothing
			dcpi1_bdiv_qr_inst.do_nothing
			mu_bdiv_q_inst.do_nothing
			mu_bdiv_qr_inst.do_nothing
			bdiv_q_inst.do_nothing
			bdiv_qr_inst.do_nothing
			redc_1_inst.do_nothing
			redc_2_inst.do_nothing
			redc_n_inst.do_nothing
			powlo_inst.do_nothing
			subcnd_n_inst.do_nothing
			redc_1_sec_inst.do_nothing
			trialdivtab_inst.do_nothing
			trialdiv_inst.do_nothing
			and_n_inst.do_nothing
			andn_n_inst.do_nothing
			nand_n_inst.do_nothing
			ior_n_inst.do_nothing
			iorn_n_inst.do_nothing
			nior_n_inst.do_nothing
			xor_n_inst.do_nothing
			xnor_n_inst.do_nothing
			zero_inst.do_nothing
			asprintf_inst.do_nothing
			asprntffuns_inst.do_nothing
			doprnt_inst.do_nothing
			doprntf_inst.do_nothing
			doprnti_inst.do_nothing
			fprintf_inst.do_nothing
			obprintf_inst.do_nothing
			obvprintf_inst.do_nothing
			obprntffuns_inst.do_nothing
			printf_inst.do_nothing
			printffuns_inst.do_nothing
			snprintf_inst.do_nothing
			snprntffuns_inst.do_nothing
			sprintf_inst.do_nothing
			sprintffuns_inst.do_nothing
			vasprintf_inst.do_nothing
			vfprintf_inst.do_nothing
			vprintf_inst.do_nothing
			vsnprintf_inst.do_nothing
			vsprintf_inst.do_nothing
			doscan_inst.do_nothing
			fscanf_inst.do_nothing
			fscanffuns_inst.do_nothing
			scanf_inst.do_nothing
			sscanf_inst.do_nothing
			sscanffuns_inst.do_nothing
			vfscanf_inst.do_nothing
			vscanf_inst.do_nothing
			vsscanf_inst.do_nothing;
			(create {LIBGMP_INITIALIZER}).initialize
		end

end
