class
	P_ADD_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_add_ui (a_sum: CE_POINTER [PD_MPF_STRUCT]; a_u: CE_POINTER [PD_MPF_STRUCT]; a_v: NATURAL_32)
		local
			l_up: CE_POINTER [NATURAL_32]
			l_sump: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_sumsize: INTEGER_32
			l_prec: INTEGER_32
			l_uexp: INTEGER_32
			l_u_negated: PD_MPF_STRUCT
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_32]
			l_cy_limb: NATURAL_32
			l_dst___0: CE_POINTER [NATURAL_32]
			l_n___0: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_up.make
			create l_sump.make
			create l_u_negated.make
			create l_dst.make
			create l_tmp.make
			create l_dst___0.make
			create l_tmp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_up.ce_gets (a_u.item.mp_d)
					l_sump.ce_gets (a_sum.item.mp_d)
					l_prec := (a_sum.item.mp_prec).to_integer_32
					l_uexp := a_u.item.mp_exp
					l_usize := (a_u.item.mp_size).to_integer_32
					if l_usize <= 0 then
						if l_usize = 0 then
							set_ui_inst.gmpf_set_ui (a_sum, a_v)
							js.return
						else
							l_u_negated.mp_size := (-l_usize).to_integer_32
							l_u_negated.mp_exp := a_u.item.mp_exp
							l_u_negated.mp_d := a_u.item.mp_d
							sub_ui_inst.gmpf_sub_ui (a_sum, (l_u_negated.address), a_v)
							a_sum.item.mp_size := -a_sum.item.mp_size
							js.return
						end
					end
					if not (not js.return_called and then (a_v = {NATURAL_32} 0)) then
						l_pos := -1 + 2 -- skip if block
					end
				when 1 then -- if: | sum_is_u:
						if (a_u.c_pointer.to_integer_32).to_natural_32 /= (a_sum.c_pointer.to_integer_32).to_natural_32 then
							if l_usize < l_prec + 1 then
								l_sumsize := l_usize
							else
								l_sumsize := l_prec + 1
							end
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (a_sum.item.mp_d, (l_up + l_usize) - l_sumsize, l_sumsize)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
							a_sum.item.mp_size := l_sumsize.to_integer_32
							a_sum.item.mp_exp := a_u.item.mp_exp
						end
						js.return
				when 2 then -- if done
					if not js.return_called then
						if l_uexp > 0 then
							if l_uexp > l_prec then
								l_pos := -1 + 1 -- goto sum_is_u
							elseif l_uexp > l_usize then
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyd ((l_sump + l_uexp) - l_usize, l_up, l_usize)
									js.break
								end
								js.reset
								l_sump[0] := a_v
								from
								until
									js.loop_left
								loop
									js.reset
									if (l_uexp - l_usize) - 1 /= 0 then
										l_dst.ce_gets (l_sump + 1)
										l_n := (l_uexp - l_usize) - 1
										from
										until
											js.loop_left
										loop
											js.reset
											l_tmp.ce_gets (l_dst)
											l_dst.ce_gets (l_dst + 1)
											l_tmp.item := (0).to_natural_32
											l_n := l_n - 1
											if not l_n.to_boolean then
												js.break
											end
										end
										js.reset
									end
									js.break
								end
								js.reset
								a_sum.item.mp_size := l_uexp.to_integer_32
								a_sum.item.mp_exp := l_uexp
							else
								if l_usize > l_prec then
									l_up.ce_gets (l_up + (l_usize - l_prec))
									l_usize := l_usize - (l_usize - l_prec)
								end
								if (l_sump.c_pointer.to_integer_32).to_natural_32 /= (l_up.c_pointer.to_integer_32).to_natural_32 then
									from
									until
										js.loop_left
									loop
										js.reset
										gmp_inst.gmpn_copyi (l_sump, l_up, l_usize - l_uexp)
										js.break
									end
									js.reset
								end
								l_cy_limb := gmp_inst.gmpn_add_1 ((l_sump + l_usize) - l_uexp, (l_up + l_usize) - l_uexp, l_uexp, a_v)
								l_sump[l_usize] := l_cy_limb
								a_sum.item.mp_size := (l_usize.to_natural_32 + l_cy_limb).to_integer_32
								a_sum.item.mp_exp := (l_uexp.to_natural_32 + l_cy_limb).to_integer_32
							end
						elseif -l_uexp >= l_prec then
							l_sump[0] := a_v
							a_sum.item.mp_size := 1
							a_sum.item.mp_exp := (1).to_integer_32
						else
							if (l_usize + -l_uexp) + 1 > l_prec then
								l_up.ce_gets (l_up + (((l_usize + -l_uexp) + 1) - l_prec))
								l_usize := l_usize - (((l_usize + -l_uexp) + 1) - l_prec)
							end
							if (l_sump.c_pointer.to_integer_32).to_natural_32 /= (l_up.c_pointer.to_integer_32).to_natural_32 then
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (l_sump, l_up, l_usize)
									js.break
								end
								js.reset
							end
							from
							until
								js.loop_left
							loop
								js.reset
								if -l_uexp /= 0 then
									l_dst___0.ce_gets (l_sump + l_usize)
									l_n___0 := -l_uexp
									from
									until
										js.loop_left
									loop
										js.reset
										l_tmp___0.ce_gets (l_dst___0)
										l_dst___0.ce_gets (l_dst___0 + 1)
										l_tmp___0.item := (0).to_natural_32
										l_n___0 := l_n___0 - 1
										if not l_n___0.to_boolean then
											js.break
										end
									end
									js.reset
								end
								js.break
							end
							js.reset
							l_sump[(l_usize + -l_uexp)] := a_v
							a_sum.item.mp_size := ((l_usize + -l_uexp) + 1).to_integer_32
							a_sum.item.mp_exp := (1).to_integer_32
						end
					end
				when 3 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
