class
	P_ANDN_N

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_andn_n (a_rp: CE_POINTER [NATURAL_32]; a_up: CE_POINTER [NATURAL_32]; a_vp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32)
		local
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_a: NATURAL_32
			l_b: NATURAL_32
			js: JUMP_STATE
		do
			create l_up.make
			create l_vp.make
			create l_rp.make

			from
			until
				js.loop_left
			loop
				js.reset
				l_up.ce_gets (a_up)
				l_vp.ce_gets (a_vp)
				l_rp.ce_gets (a_rp)
				l_n := a_n
				l_up.ce_gets (l_up + l_n)
				l_vp.ce_gets (l_vp + l_n)
				l_rp.ce_gets (l_rp + l_n)
				l_n := -l_n
				from
				until
					js.loop_left
				loop
					js.reset
					l_a := l_up[l_n]
					l_b := l_vp[l_n]
					l_rp[l_n] := (l_a).bit_and ((l_b).bit_not)
					l_n := l_n + 1
					if not l_n.to_boolean then
						js.break
					end
				end
				js.reset
				js.break
			end
			js.reset
		end

end
