class
	P_ASPRNTFFUNS

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmp_asprintf_memory (a_d: CE_POINTER [PD_GMP_ASPRINTF_T]; a_str: CE_POINTER [INTEGER_8]; a_len: NATURAL_32): INTEGER_32
		local
			l_alloc: NATURAL_32
			l_newsize: NATURAL_32
			l_newalloc: NATURAL_32
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				l_alloc := a_d.item.alloc
				l_newsize := a_d.item.size + a_len
				if l_alloc <= l_newsize then
					l_newalloc := {NATURAL_32} 2 * l_newsize
					a_d.item.alloc := l_newalloc
					a_d.item.buf := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_reallocate_func.pointer_item ([create {CE_POINTER [ANY]}.make_cast (a_d.item.buf), l_alloc * Integer_8_bytes.to_natural_32, l_newalloc * Integer_8_bytes.to_natural_32]))))
				end
				js.break
			end
			js.reset
			memcpy (create {CE_POINTER [ANY]}.make_cast ((a_d.item.buf + (a_d.item.size).to_integer_32)), create {CE_POINTER [ANY]}.make_cast (a_str), a_len).do_nothing
			a_d.item.size := a_d.item.size + a_len
			Result := a_len.to_integer_32
		end

	gmp_asprintf_memory_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gmp_asprintf_memory)
		end

	gmp_asprintf_reps (a_d: CE_POINTER [PD_GMP_ASPRINTF_T]; a_c: INTEGER_32; a_reps: INTEGER_32): INTEGER_32
		local
			l_alloc: NATURAL_32
			l_newsize: NATURAL_32
			l_newalloc: NATURAL_32
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				l_alloc := a_d.item.alloc
				l_newsize := a_d.item.size + a_reps.to_natural_32
				if l_alloc <= l_newsize then
					l_newalloc := {NATURAL_32} 2 * l_newsize
					a_d.item.alloc := l_newalloc
					a_d.item.buf := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_reallocate_func.pointer_item ([create {CE_POINTER [ANY]}.make_cast (a_d.item.buf), l_alloc * Integer_8_bytes.to_natural_32, l_newalloc * Integer_8_bytes.to_natural_32]))))
				end
				js.break
			end
			js.reset
			memset (create {CE_POINTER [ANY]}.make_cast ((a_d.item.buf + (a_d.item.size).to_integer_32)), a_c, a_reps.to_natural_32).do_nothing
			a_d.item.size := a_d.item.size + a_reps.to_natural_32
			Result := a_reps
		end

	gmp_asprintf_reps_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gmp_asprintf_reps)
		end

	gmp_asprintf_final (a_d: CE_POINTER [PD_GMP_ASPRINTF_T]): INTEGER_32
		local
			l_buf: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_buf.make

			l_buf.ce_gets (a_d.item.buf)
			l_buf[(a_d.item.size).to_integer_32] := (('%/0/').code).to_integer_8
			from
			until
				js.loop_left
			loop
				js.reset
				if a_d.item.alloc /= a_d.item.size + {NATURAL_32} 1 then
					l_buf.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_reallocate_func.pointer_item ([create {CE_POINTER [ANY]}.make_cast (l_buf), a_d.item.alloc * Integer_8_bytes.to_natural_32, (a_d.item.size + {NATURAL_32} 1) * Integer_8_bytes.to_natural_32])))))
				end
				js.break
			end
			js.reset;
			(a_d.item.result2).item := l_buf
			Result := 0
		end

	gmp_asprintf_final_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gmp_asprintf_final)
		end

end
