class
	P_BDIV_Q_1

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_pi1_bdiv_q_1 (a_rp: CE_POINTER [NATURAL_32]; a_up: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_d: NATURAL_32; a_di: NATURAL_32; a_shift: INTEGER_32): NATURAL_32
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_d: NATURAL_32
			l_i: INTEGER_32
			l_c: NATURAL_32
			l_h: NATURAL_32
			l_l: NATURAL_32
			l_u: NATURAL_32
			l_u_next: NATURAL_32
			l_dummy: NATURAL_32
			l_x: NATURAL_32
			l_y: NATURAL_32
			l_w: NATURAL_32
			l_x___0: NATURAL_32
			l_y___0: NATURAL_32
			l_w___0: NATURAL_32
			js: JUMP_STATE
		do
			create l_rp.make

			l_rp.ce_gets (a_rp)
			l_d := a_d
			l_d := l_d
			if a_shift /= 0 then
				l_c := (0).to_natural_32
				l_u := a_up[0]
				l_rp.ce_gets (l_rp - 1)
				l_i := (1).to_integer_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_u_next := a_up[l_i]
					l_u := (((((l_u).bit_shift_right (a_shift))).bit_or (((l_u_next).bit_shift_left ((32 - a_shift)))))).bit_and ({NATURAL_32} 4294967295)
					from
					until
						js.loop_left
					loop
						js.reset
						l_x := l_u
						l_y := l_c
						l_w := l_x - l_y
						l_l := l_w
						l_c := (l_w > l_x).to_integer.to_natural_32
						js.break
					end
					js.reset
					l_l := (l_l * a_di).bit_and ({NATURAL_32} 4294967295)
					l_rp[l_i] := l_l
					asm320 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_dummy), create {CE_POINTER [NATURAL_32]}.make_shared ($l_h), create {CE_POINTER [NATURAL_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d))
					l_c := l_c + l_h
					l_u := l_u_next
					l_i := l_i + 1
				end
				l_u := (l_u).bit_shift_right (a_shift)
				l_l := l_u - l_c
				l_l := (l_l * a_di).bit_and ({NATURAL_32} 4294967295)
				l_rp[l_i] := l_l
			else
				l_u := a_up[0]
				l_l := (l_u * a_di).bit_and ({NATURAL_32} 4294967295)
				l_rp[0] := l_l
				l_c := (0).to_natural_32
				l_i := (1).to_integer_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					asm321 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_dummy), create {CE_POINTER [NATURAL_32]}.make_shared ($l_h), create {CE_POINTER [NATURAL_32]}.make_shared ($l_l), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d))
					l_c := l_c + l_h
					l_u := a_up[l_i]
					from
					until
						js.loop_left
					loop
						js.reset
						l_x___0 := l_u
						l_y___0 := l_c
						l_w___0 := l_x___0 - l_y___0
						l_l := l_w___0
						l_c := (l_w___0 > l_x___0).to_integer.to_natural_32
						js.break
					end
					js.reset
					l_l := (l_l * a_di).bit_and ({NATURAL_32} 4294967295)
					l_rp[l_i] := l_l
					l_i := l_i + 1
				end
			end
			Result := l_c
		end

	gmpn_bdiv_q_1 (a_rp: CE_POINTER [NATURAL_32]; a_up: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_d: NATURAL_32): NATURAL_32
		local
			l_d: NATURAL_32
			l_di: NATURAL_32
			l_shift: INTEGER_32
			l_n: NATURAL_32
			l_inv: NATURAL_32
			js: JUMP_STATE
		do
			l_d := a_d
			if ((l_d).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					l_shift := builtin_ctzl (l_d)
					js.break
				end
				js.reset
				l_d := (l_d).bit_shift_right (l_shift)
			else
				l_shift := 0
			end
			from
			until
				js.loop_left
			loop
				js.reset
				l_n := l_d
				l_inv := (gmp_impl_inst.gmp_binvert_limb_table[((l_n // {NATURAL_32} 2).bit_and ({NATURAL_32} 127)).to_integer_32]).to_natural_32
				l_inv := {NATURAL_32} 2 * l_inv - (l_inv * l_inv) * l_n
				l_inv := {NATURAL_32} 2 * l_inv - (l_inv * l_inv) * l_n
				l_di := (l_inv).bit_and ({NATURAL_32} 4294967295)
				js.break
			end
			js.reset
			Result := (gmpn_pi1_bdiv_q_1 (a_rp, a_up, a_n, l_d, l_di, l_shift))
		end

end
