class
	P_DIVREM

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_divrem (a_qp: CE_POINTER [NATURAL_32]; a_qxn: INTEGER_32; a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32): NATURAL_32
		local
			l_ret: NATURAL_32
			l_q2p: CE_POINTER [NATURAL_32]
			l_qn: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp___2: CE_POINTER [ANY]
			l_rp: CE_POINTER [NATURAL_32]
			l_q2p___0: CE_POINTER [NATURAL_32]
			l_qhl: NATURAL_32
			l_qn___0: INTEGER_32
			l_tmp_marker___0: CE_POINTER [PD_TMP_REENTRANT_T]
			l_n2p: CE_POINTER [NATURAL_32]
			l_tmp___9: CE_POINTER [ANY]
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp___11: CE_POINTER [NATURAL_32]
			l_tmp___15: CE_POINTER [ANY]
			l_tmp___20: CE_POINTER [ANY]
			l_tmp___25: CE_POINTER [ANY]
			l_tmp___30: CE_POINTER [ANY]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_q2p.make
			create l_tmp_marker.make
			create l_tmp___2.make
			create l_rp.make
			create l_q2p___0.make
			create l_tmp_marker___0.make
			create l_n2p.make
			create l_tmp___9.make
			create l_dst.make
			create l_tmp___11.make
			create l_tmp___15.make
			create l_tmp___20.make
			create l_tmp___25.make
			create l_tmp___30.make

			if a_dn = 1 then
				l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
				if (builtin_expect (((a_nn + a_qxn).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
					l_tmp___2.ce_gets ((l_aaf.new (((a_nn + a_qxn).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				else
					l_tmp___2.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((a_nn + a_qxn).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				end
				l_q2p.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2))
				a_np[0] := gmp_inst.gmpn_divrem_1 (l_q2p, a_qxn, a_np, a_nn, a_dp[0])
				l_qn := (a_nn + a_qxn) - 1
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						gmp_inst.gmpn_copyi (a_qp, l_q2p, l_qn)
						js.break
					end
					js.reset
					js.break
				end
				js.reset
				l_ret := l_q2p[l_qn]
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
					end
					js.break
				end
				js.reset
				Result := l_ret
			elseif a_dn = 2 then
				Result := (gmp_inst.gmpn_divrem_2 (a_qp, a_qxn, a_np, a_nn, a_dp))
			else
				l_tmp_marker___0.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
				if (builtin_expect ((a_qxn /= 0).to_integer, 0)).to_boolean then
					if (builtin_expect (((a_nn + a_qxn).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___9.ce_gets ((l_aaf.new (((a_nn + a_qxn).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___9.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker___0.address, ((a_nn + a_qxn).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_n2p.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___9))
					from
					until
						js.loop_left
					loop
						js.reset
						if a_qxn /= 0 then
							l_dst.ce_gets (l_n2p)
							l_n := a_qxn
							from
							until
								js.loop_left
							loop
								js.reset
								l_tmp___11.ce_gets (l_dst)
								l_dst.ce_gets (l_dst + 1)
								l_tmp___11.item := (0).to_natural_32
								l_n := l_n - 1
								if not l_n.to_boolean then
									js.break
								end
							end
							js.reset
						end
						js.break
					end
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (l_n2p + a_qxn, a_np, a_nn)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
					if (builtin_expect (((((a_nn - a_dn) + a_qxn) + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___15.ce_gets ((l_aaf.new (((((a_nn - a_dn) + a_qxn) + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___15.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker___0.address, ((((a_nn - a_dn) + a_qxn) + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_q2p___0.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___15))
					if (builtin_expect ((a_dn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___20.ce_gets ((l_aaf.new ((a_dn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___20.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker___0.address, (a_dn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_rp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___20))
					tdiv_qr_inst.gmpn_tdiv_qr (l_q2p___0, l_rp, 0, l_n2p, a_nn + a_qxn, a_dp, a_dn)
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (a_np, l_rp, a_dn)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
					l_qn___0 := (a_nn - a_dn) + a_qxn
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (a_qp, l_q2p___0, l_qn___0)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
					l_qhl := l_q2p___0[l_qn___0]
				else
					if (builtin_expect ((((a_nn - a_dn) + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___25.ce_gets ((l_aaf.new ((((a_nn - a_dn) + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___25.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker___0.address, (((a_nn - a_dn) + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_q2p___0.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___25))
					if (builtin_expect ((a_dn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___30.ce_gets ((l_aaf.new ((a_dn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___30.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker___0.address, (a_dn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_rp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___30))
					tdiv_qr_inst.gmpn_tdiv_qr (l_q2p___0, l_rp, 0, a_np, a_nn, a_dp, a_dn)
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (a_np, l_rp, a_dn)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
					l_qn___0 := a_nn - a_dn
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (a_qp, l_q2p___0, l_qn___0)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
					l_qhl := l_q2p___0[l_qn___0]
				end
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect (((l_tmp_marker___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker___0)
					end
					js.break
				end
				js.reset
				Result := l_qhl
			end
		end

end
