class
	P_EXTRACT_DBL

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmp_extract_double (a_rp: CE_POINTER [NATURAL_32]; a_d: REAL_64): INTEGER_32
		local
			l_exp: INTEGER_32
			l_sc: NATURAL_32
			l_manh: NATURAL_32
			l_manl: NATURAL_32
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_32]
			l_x___2: PD_IEEE_DOUBLE_EXTRACT
			js: JUMP_STATE
		do
			create l_dst.make
			create l_tmp.make
			create l_x___2.make

			if a_d = 0.0 then
				from
				until
					js.loop_left
				loop
					js.reset
					l_dst.ce_gets (a_rp)
					l_n := (3).to_integer_32
					from
					until
						js.loop_left
					loop
						js.reset
						l_tmp.ce_gets (l_dst)
						l_dst.ce_gets (l_dst + 1)
						l_tmp.item := (0).to_natural_32
						l_n := l_n - 1
						if not l_n.to_boolean then
							js.break
						end
					end
					js.reset
					js.break
				end
				js.reset
				Result := 0
				js.return
			end
			if not js.return_called then
				l_x___2.d := a_d
				l_exp := (l_x___2.s.exp).to_integer_32
				l_manh := ((((({NATURAL_32} 1).bit_shift_left (31))).bit_or (((l_x___2.s.manh).bit_shift_left (11)).to_natural_32))).bit_or (((l_x___2.s.manl).bit_shift_right (21)).to_natural_32)
				l_manl := ((l_x___2.s.manl).bit_shift_left (11)).to_natural_32
				if l_exp = 0 then
					l_exp := 1
					from
					until
						js.loop_left
					loop
						js.reset
						l_manh := (((l_manh).bit_shift_left (1))).bit_or (((l_manl).bit_shift_right (31)))
						l_manl := (l_manl).bit_shift_left ((1))
						l_exp := l_exp - 1
						if ((l_manh).bit_and ((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))))) /= {NATURAL_32} 0 then
							js.break
						end
					end
					js.reset
				end
				l_exp := l_exp - (1022)
				l_sc := (l_exp + 2048).to_natural_32 \\ {NATURAL_32} 32
				l_exp := ((l_exp + 2048) // 32 - 64) + 1
				if l_sc /= {NATURAL_32} 0 then
					a_rp[2] := (l_manh).bit_shift_right (({NATURAL_32} 32 - l_sc).to_integer_32)
					a_rp[1] := (((l_manh).bit_shift_left (l_sc.to_integer_32))).bit_or (((l_manl).bit_shift_right (({NATURAL_32} 32 - l_sc).to_integer_32)))
					a_rp[0] := (l_manl).bit_shift_left (l_sc.to_integer_32)
				else
					a_rp[2] := l_manh
					a_rp[1] := l_manl
					a_rp[0] := (0).to_natural_32
					l_exp := l_exp - 1
				end
				Result := l_exp.to_integer_32
			end
		end

end
