class
	P_FAC_UI

inherit
	LIBGMP_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {NONE} -- Initialization

	default_create
		do
			create table.make (<<13>>)
		end

feature {ANY} -- attributes

	table: CE_ARRAY [NATURAL_32]

feature {ANY} -- routines

	gmpz_fac_ui (a_x___2: CE_POINTER [PD_MPZ_STRUCT]; a_n: NATURAL_32)
		local
			l_z: NATURAL_32
			l_stt: NATURAL_32
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_t1: CE_ARRAY [PD_MPZ_STRUCT]
			l_st: CE_ARRAY [CE_ARRAY [PD_MPZ_STRUCT]]
			l_d: CE_ARRAY [NATURAL_32]
			l_z2: CE_POINTER [PD_MPZ_STRUCT]
			l_z___0: CE_POINTER [PD_MPZ_STRUCT]
			l_x: NATURAL_32
			js: JUMP_STATE
		do
			create l_t1.make (<<1>>)
			create l_st.make (<<(({NATURAL_32} 8 * Natural_32_bytes.to_natural_32 + {NATURAL_32} 1) - {NATURAL_32} 5).to_integer_32, 1>>)
			create l_d.make (<<4>>)
			create l_z2.make
			create l_z___0.make

			if a_n < ((Natural_32_bytes.to_natural_32 * (13).to_natural_32) // Natural_32_bytes.to_natural_32).to_natural_32 then
				from
				until
					js.loop_left
				loop
					js.reset
					l_z2.ce_gets (a_x___2)
					l_z2.item.mp_d[0] := table[a_n.to_integer_32]
					l_z2.item.mp_size := 1
					js.break
				end
				js.reset
				js.return
			end
			if not js.return_called then
				asm12 (l_d.address, create {CE_POINTER [NATURAL_32]}.make_shared ($a_n))
				from
				until
					js.loop_left
				loop
					js.reset
					l_z := (builtin_clzl (l_d[1])).to_natural_32
					js.break
				end
				js.reset
				l_z := ({NATURAL_32} 32 - l_z) - {NATURAL_32} 1
				asm13 (l_d.address, create {CE_POINTER [NATURAL_32]}.make_shared ($a_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_z))
				l_d[0] := (((l_d[0]).bit_shift_right (2))).bit_or (((l_d[1]).bit_shift_left (30)))
				l_d[1] := (l_d[1]).bit_shift_right ((2))
				l_z := l_d[0] + {NATURAL_32} 1
				if a_n <= ({NATURAL_32} 1).bit_shift_left (5) then
					realloc2_inst.gmpz_realloc2 (a_x___2, {NATURAL_32} 4 * l_z)
					ap_product_small (a_x___2, (2).to_natural_32, (1).to_natural_32, a_n - {NATURAL_32} 1, {NATURAL_32} 4)
					js.return
				end
			end
			if not js.return_called and then (a_n <= ({NATURAL_32} 1).bit_shift_left (6)) then
				init2_inst.gmpz_init2 (l_t1, {NATURAL_32} 2 * l_z)
				realloc2_inst.gmpz_realloc2 (a_x___2, {NATURAL_32} 4 * l_z)
				ap_product_small (a_x___2, (2).to_natural_32, (1).to_natural_32, a_n // {NATURAL_32} 2 - {NATURAL_32} 1, {NATURAL_32} 4)
				ap_product_small (create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t1), (3).to_natural_32, (2).to_natural_32, (a_n - {NATURAL_32} 1) // {NATURAL_32} 2, {NATURAL_32} 4)
				mul_inst.gmpz_mul (a_x___2, a_x___2, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t1))
				clear_inst.gmpz_clear (l_t1)
				mul_2exp_inst.gmpz_mul_2exp (a_x___2, a_x___2, a_n // {NATURAL_32} 2)
				js.return
			end
			if not js.return_called and then (a_n <= ({NATURAL_32} 1).bit_shift_left (7)) then
				init2_inst.gmpz_init2 (l_t1, {NATURAL_32} 2 * l_z)
				realloc2_inst.gmpz_realloc2 (a_x___2, {NATURAL_32} 4 * l_z)
				l_i := 0
				from
				until
					not (l_i < 4)
				loop
					init2_inst.gmpz_init2 (l_st[l_i], l_z)
					l_z := (l_z).bit_shift_right ((1))
					l_i := l_i + 1
				end
				odd_product ({NATURAL_32} 1, a_n // {NATURAL_32} 2, l_st)
				set_inst.gmpz_set (a_x___2, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast ((l_st[0])))
				odd_product (a_n // {NATURAL_32} 2, a_n, l_st)
				mul_inst.gmpz_mul (a_x___2, a_x___2, a_x___2)
				ap_product_small (create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t1), (2).to_natural_32, (1).to_natural_32, a_n // {NATURAL_32} 4 - {NATURAL_32} 1, {NATURAL_32} 4)
				mul_inst.gmpz_mul (l_t1, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t1), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast ((l_st[0])))
				l_i := 0
				from
				until
					not (l_i < 4)
				loop
					clear_inst.gmpz_clear (l_st[l_i])
					l_i := l_i + 1
				end
				mul_inst.gmpz_mul (a_x___2, a_x___2, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t1))
				clear_inst.gmpz_clear (l_t1)
				mul_2exp_inst.gmpz_mul_2exp (a_x___2, a_x___2, a_n // {NATURAL_32} 2 + a_n // {NATURAL_32} 4)
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					l_stt := (builtin_clzl (a_n)).to_natural_32
					js.break
				end
				js.reset
				l_stt := (({NATURAL_32} 32 - l_stt) + {NATURAL_32} 1) - {NATURAL_32} 5
				l_i := 0
				from
				until
					not (l_i.to_integer_32 < l_stt.to_integer_32)
				loop
					init2_inst.gmpz_init2 (l_st[l_i], l_z)
					l_z := (l_z).bit_shift_right ((1))
					l_i := l_i + 1
				end
				from
				until
					js.loop_left
				loop
					js.reset
					l_z := (builtin_clzl (a_n // {NATURAL_32} 3)).to_natural_32
					js.break
				end
				js.reset
				l_z := {NATURAL_32} 32 - l_z
				iset_ui_inst.gmpz_init_set_ui (l_t1, {NATURAL_32} 1)
				l_j := (({NATURAL_32} 8 * Natural_32_bytes.to_natural_32) // {NATURAL_32} 2).to_integer_32
				from
				until
					not (not js.loop_left and then (l_j /= 0))
				loop
					from
					until
						js.loop_left
					loop
						js.reset
						l_z___0.ce_gets (a_x___2)
						l_z___0.item.mp_d[0] := (1).to_natural_32
						l_z___0.item.mp_size := 1
						js.break
					end
					js.reset
					l_i := ({NATURAL_32} 8 * Natural_32_bytes.to_natural_32 - l_j.to_natural_32).to_integer_32
					from
					until
						not (l_i >= l_j)
					loop
						if l_z.to_integer_32 >= l_i.to_integer_32 then
							odd_product ((a_n).bit_shift_right (l_i), (a_n).bit_shift_right ((l_i - 1)), l_st)
							if l_i /= l_j then
								pow_ui_inst.gmpz_pow_ui (l_st[0], create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast ((l_st[0])), (l_i // l_j).to_natural_32)
							end
							mul_inst.gmpz_mul (a_x___2, a_x___2, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast ((l_st[0])))
						end
						l_i := l_i - (2 * l_j)
					end
					if l_z.to_integer_32 >= l_j.to_integer_32 then
						if l_j /= 1 then
							mul_inst.gmpz_mul (l_t1, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t1), a_x___2)
							mul_inst.gmpz_mul (l_t1, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t1), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t1))
						end
					end
					l_j := (l_j).bit_shift_right ((1))
				end
				l_i := 0
				from
				until
					not (l_i.to_integer_32 < l_stt.to_integer_32)
				loop
					clear_inst.gmpz_clear (l_st[l_i])
					l_i := l_i + 1
				end
				mul_inst.gmpz_mul (a_x___2, a_x___2, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t1))
				clear_inst.gmpz_clear (l_t1)
				from
				until
					js.loop_left
				loop
					js.reset
					l_x := a_n
					l_x := l_x - ((((l_x).bit_shift_right (1))).bit_and ({NATURAL_32} 1431655765))
					l_x := ((((l_x).bit_shift_right (2))).bit_and ({NATURAL_32} 858993459)) + ((l_x).bit_and ({NATURAL_32} 858993459))
					l_x := ((((l_x).bit_shift_right (4)) + l_x)).bit_and ({NATURAL_32} 252645135)
					l_x := ((l_x).bit_shift_right (8)) + l_x
					l_x := ((l_x).bit_shift_right (16)) + l_x
					l_i := ((l_x).bit_and ({NATURAL_32} 255)).to_integer_32
					js.break
				end
				js.reset
				mul_2exp_inst.gmpz_mul_2exp (a_x___2, a_x___2, a_n - l_i.to_natural_32)
			end
		end

	ap_product_small (a_ret: CE_POINTER [PD_MPZ_STRUCT]; a_start: NATURAL_32; a_step___1: NATURAL_32; a_count: NATURAL_32; a_nm: NATURAL_32)
		local
			l_a: NATURAL_32
			l_b: NATURAL_32
			l_z: CE_POINTER [PD_MPZ_STRUCT]
			l_z___0: CE_POINTER [PD_MPZ_STRUCT]
			l_z___1: CE_POINTER [PD_MPZ_STRUCT]
			l_dst: CE_POINTER [PD_MPZ_STRUCT]
			l_src: CE_POINTER [PD_MPZ_STRUCT]
			l_size: INTEGER_32
			l_dst_p: CE_POINTER [NATURAL_32]
			l_c: NATURAL_32
			l_z___2: CE_POINTER [PD_MPZ_STRUCT]
			l_dst___0: CE_POINTER [PD_MPZ_STRUCT]
			l_src___0: CE_POINTER [PD_MPZ_STRUCT]
			l_size___0: INTEGER_32
			l_dst_p___0: CE_POINTER [NATURAL_32]
			l_c___0: NATURAL_32
			l_dst___1: CE_POINTER [PD_MPZ_STRUCT]
			l_src___1: CE_POINTER [PD_MPZ_STRUCT]
			l_size___1: INTEGER_32
			l_dst_p___1: CE_POINTER [NATURAL_32]
			l_c___1: NATURAL_32
			l_z___3: CE_POINTER [PD_MPZ_STRUCT]
			l_z___4: CE_POINTER [PD_MPZ_STRUCT]
			l_dst___2: CE_POINTER [PD_MPZ_STRUCT]
			l_src___2: CE_POINTER [PD_MPZ_STRUCT]
			l_size___2: INTEGER_32
			l_dst_p___2: CE_POINTER [NATURAL_32]
			l_c___2: NATURAL_32
			l_dst___3: CE_POINTER [PD_MPZ_STRUCT]
			l_src___3: CE_POINTER [PD_MPZ_STRUCT]
			l_size___3: INTEGER_32
			l_dst_p___3: CE_POINTER [NATURAL_32]
			l_c___3: NATURAL_32
			l_z___5: CE_POINTER [PD_MPZ_STRUCT]
			l_z___6: CE_POINTER [PD_MPZ_STRUCT]
			l_z___7: CE_POINTER [PD_MPZ_STRUCT]
			l_dst___4: CE_POINTER [PD_MPZ_STRUCT]
			l_src___4: CE_POINTER [PD_MPZ_STRUCT]
			l_size___4: INTEGER_32
			l_dst_p___4: CE_POINTER [NATURAL_32]
			l_c___4: NATURAL_32
			l_dst___5: CE_POINTER [PD_MPZ_STRUCT]
			l_src___5: CE_POINTER [PD_MPZ_STRUCT]
			l_size___5: INTEGER_32
			l_dst_p___5: CE_POINTER [NATURAL_32]
			l_c___5: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_z.make
			create l_z___0.make
			create l_z___1.make
			create l_dst.make
			create l_src.make
			create l_dst_p.make
			create l_z___2.make
			create l_dst___0.make
			create l_src___0.make
			create l_dst_p___0.make
			create l_dst___1.make
			create l_src___1.make
			create l_dst_p___1.make
			create l_z___3.make
			create l_z___4.make
			create l_dst___2.make
			create l_src___2.make
			create l_dst_p___2.make
			create l_dst___3.make
			create l_src___3.make
			create l_dst_p___3.make
			create l_z___5.make
			create l_z___6.make
			create l_z___7.make
			create l_dst___4.make
			create l_src___4.make
			create l_dst_p___4.make
			create l_dst___5.make
			create l_src___5.make
			create l_dst_p___5.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_count = {NATURAL_32} 0 then
						from
						until
							js.loop_left
						loop
							js.reset
							l_z.ce_gets (a_ret)
							l_z.item.mp_d[0] := (1).to_natural_32
							l_z.item.mp_size := 1
							js.break
						end
						js.reset
						js.return
					end
					if not js.return_called and then (a_count = {NATURAL_32} 1) then
						from
						until
							js.loop_left
						loop
							js.reset
							l_z___0.ce_gets (a_ret)
							l_z___0.item.mp_d[0] := a_start
							l_z___0.item.mp_size := 1
							js.break
						end
						js.reset
						js.return
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						inspect a_nm.to_integer_32 -- switch 1 head
						when 1 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 3
						when 3 then l_pos := -1 + 4
						else l_pos := -1 + 5
						end
				when 2 then -- switch 1, case 1
						from
						until
							js.loop_left
						loop
							js.reset
							l_z___1.ce_gets (a_ret)
							l_z___1.item.mp_d[0] := a_start
							l_z___1.item.mp_size := 1
							js.break
						end
						js.reset
						l_b := a_start + a_step___1
						l_a := {NATURAL_32} 0
						from
						until
							not (not js.loop_left and then (l_a < a_count - {NATURAL_32} 1))
						loop
							from
							until
								js.loop_left
							loop
								js.reset
								l_dst.ce_gets (a_ret)
								l_src.ce_gets (a_ret)
								l_size := (l_src.item.mp_size).to_integer_32
								if (builtin_expect ((l_size + 1 > (l_dst.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
									realloc_inst.gmpz_realloc (l_dst, l_size + 1).do_nothing
								end
								l_dst_p.ce_gets (l_dst.item.mp_d)
								l_c := gmp_inst.gmpn_mul_1 (l_dst_p, l_src.item.mp_d, l_size, l_b)
								l_dst_p[l_size] := l_c
								l_dst.item.mp_size := (l_size + (l_c /= {NATURAL_32} 0).to_integer).to_integer_32
								js.break
							end
							js.reset
							l_b := l_b + a_step___1
							l_a := l_a + 1
						end
						js.return
				when 3 then -- switch 1, case 2
						if not js.return_called then
							from
							until
								js.loop_left
							loop
								js.reset
								l_z___2.ce_gets (a_ret)
								l_z___2.item.mp_d[0] := a_start * (a_start + a_step___1)
								l_z___2.item.mp_size := 1
								js.break
							end
							js.reset
							if a_count = {NATURAL_32} 2 then
								js.return
							end
						end
						if not js.return_called then
							l_b := a_start + {NATURAL_32} 2 * a_step___1
							l_a := a_count // {NATURAL_32} 2 - {NATURAL_32} 1
							from
							until
								not (not js.loop_left and then (l_a /= {NATURAL_32} 0))
							loop
								from
								until
									js.loop_left
								loop
									js.reset
									l_dst___0.ce_gets (a_ret)
									l_src___0.ce_gets (a_ret)
									l_size___0 := (l_src___0.item.mp_size).to_integer_32
									if (builtin_expect ((l_size___0 + 1 > (l_dst___0.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
										realloc_inst.gmpz_realloc (l_dst___0, l_size___0 + 1).do_nothing
									end
									l_dst_p___0.ce_gets (l_dst___0.item.mp_d)
									l_c___0 := gmp_inst.gmpn_mul_1 (l_dst_p___0, l_src___0.item.mp_d, l_size___0, l_b * (l_b + a_step___1))
									l_dst_p___0[l_size___0] := l_c___0
									l_dst___0.item.mp_size := (l_size___0 + (l_c___0 /= {NATURAL_32} 0).to_integer).to_integer_32
									js.break
								end
								js.reset
								l_a := l_a - 1
								l_b := l_b + ({NATURAL_32} 2 * a_step___1)
							end
							if a_count \\ {NATURAL_32} 2 = {NATURAL_32} 1 then
								from
								until
									js.loop_left
								loop
									js.reset
									l_dst___1.ce_gets (a_ret)
									l_src___1.ce_gets (a_ret)
									l_size___1 := (l_src___1.item.mp_size).to_integer_32
									if (builtin_expect ((l_size___1 + 1 > (l_dst___1.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
										realloc_inst.gmpz_realloc (l_dst___1, l_size___1 + 1).do_nothing
									end
									l_dst_p___1.ce_gets (l_dst___1.item.mp_d)
									l_c___1 := gmp_inst.gmpn_mul_1 (l_dst_p___1, l_src___1.item.mp_d, l_size___1, l_b)
									l_dst_p___1[l_size___1] := l_c___1
									l_dst___1.item.mp_size := (l_size___1 + (l_c___1 /= {NATURAL_32} 0).to_integer).to_integer_32
									js.break
								end
								js.reset
							end
							js.return
						end
				when 4 then -- switch 1, case 3
						if not js.return_called and then (a_count = {NATURAL_32} 2) then
							from
							until
								js.loop_left
							loop
								js.reset
								l_z___3.ce_gets (a_ret)
								l_z___3.item.mp_d[0] := a_start * (a_start + a_step___1)
								l_z___3.item.mp_size := 1
								js.break
							end
							js.reset
							js.return
						end
						if not js.return_called then
							from
							until
								js.loop_left
							loop
								js.reset
								l_z___4.ce_gets (a_ret)
								l_z___4.item.mp_d[0] := (a_start * (a_start + a_step___1)) * (a_start + {NATURAL_32} 2 * a_step___1)
								l_z___4.item.mp_size := 1
								js.break
							end
							js.reset
							if a_count = {NATURAL_32} 3 then
								js.return
							end
						end
						if not js.return_called then
							l_b := a_start + {NATURAL_32} 3 * a_step___1
							l_a := a_count // {NATURAL_32} 3 - {NATURAL_32} 1
							from
							until
								not (not js.loop_left and then (l_a /= {NATURAL_32} 0))
							loop
								from
								until
									js.loop_left
								loop
									js.reset
									l_dst___2.ce_gets (a_ret)
									l_src___2.ce_gets (a_ret)
									l_size___2 := (l_src___2.item.mp_size).to_integer_32
									if (builtin_expect ((l_size___2 + 1 > (l_dst___2.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
										realloc_inst.gmpz_realloc (l_dst___2, l_size___2 + 1).do_nothing
									end
									l_dst_p___2.ce_gets (l_dst___2.item.mp_d)
									l_c___2 := gmp_inst.gmpn_mul_1 (l_dst_p___2, l_src___2.item.mp_d, l_size___2, (l_b * (l_b + a_step___1)) * (l_b + {NATURAL_32} 2 * a_step___1))
									l_dst_p___2[l_size___2] := l_c___2
									l_dst___2.item.mp_size := (l_size___2 + (l_c___2 /= {NATURAL_32} 0).to_integer).to_integer_32
									js.break
								end
								js.reset
								l_a := l_a - 1
								l_b := l_b + ({NATURAL_32} 3 * a_step___1)
							end
							if a_count \\ {NATURAL_32} 3 = {NATURAL_32} 2 then
								l_b := l_b * (l_b + a_step___1)
							end
							if a_count \\ {NATURAL_32} 3 /= {NATURAL_32} 0 then
								from
								until
									js.loop_left
								loop
									js.reset
									l_dst___3.ce_gets (a_ret)
									l_src___3.ce_gets (a_ret)
									l_size___3 := (l_src___3.item.mp_size).to_integer_32
									if (builtin_expect ((l_size___3 + 1 > (l_dst___3.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
										realloc_inst.gmpz_realloc (l_dst___3, l_size___3 + 1).do_nothing
									end
									l_dst_p___3.ce_gets (l_dst___3.item.mp_d)
									l_c___3 := gmp_inst.gmpn_mul_1 (l_dst_p___3, l_src___3.item.mp_d, l_size___3, l_b)
									l_dst_p___3[l_size___3] := l_c___3
									l_dst___3.item.mp_size := (l_size___3 + (l_c___3 /= {NATURAL_32} 0).to_integer).to_integer_32
									js.break
								end
								js.reset
							end
							js.return
						end
				when 5 then -- switch 1, default:
						if not js.return_called and then (a_count = {NATURAL_32} 2) then
							from
							until
								js.loop_left
							loop
								js.reset
								l_z___5.ce_gets (a_ret)
								l_z___5.item.mp_d[0] := a_start * (a_start + a_step___1)
								l_z___5.item.mp_size := 1
								js.break
							end
							js.reset
							js.return
						end
						if not js.return_called and then (a_count = {NATURAL_32} 3) then
							from
							until
								js.loop_left
							loop
								js.reset
								l_z___6.ce_gets (a_ret)
								l_z___6.item.mp_d[0] := (a_start * (a_start + a_step___1)) * (a_start + {NATURAL_32} 2 * a_step___1)
								l_z___6.item.mp_size := 1
								js.break
							end
							js.reset
							js.return
						end
						if not js.return_called then
							from
							until
								js.loop_left
							loop
								js.reset
								l_z___7.ce_gets (a_ret)
								l_z___7.item.mp_d[0] := ((a_start * (a_start + a_step___1)) * (a_start + {NATURAL_32} 2 * a_step___1)) * (a_start + {NATURAL_32} 3 * a_step___1)
								l_z___7.item.mp_size := 1
								js.break
							end
							js.reset
							if a_count = {NATURAL_32} 4 then
								js.return
							end
						end
						if not js.return_called then
							l_b := a_start + {NATURAL_32} 4 * a_step___1
							l_a := a_count // {NATURAL_32} 4 - {NATURAL_32} 1
							from
							until
								not (not js.loop_left and then (l_a /= {NATURAL_32} 0))
							loop
								from
								until
									js.loop_left
								loop
									js.reset
									l_dst___4.ce_gets (a_ret)
									l_src___4.ce_gets (a_ret)
									l_size___4 := (l_src___4.item.mp_size).to_integer_32
									if (builtin_expect ((l_size___4 + 1 > (l_dst___4.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
										realloc_inst.gmpz_realloc (l_dst___4, l_size___4 + 1).do_nothing
									end
									l_dst_p___4.ce_gets (l_dst___4.item.mp_d)
									l_c___4 := gmp_inst.gmpn_mul_1 (l_dst_p___4, l_src___4.item.mp_d, l_size___4, ((l_b * (l_b + a_step___1)) * (l_b + {NATURAL_32} 2 * a_step___1)) * (l_b + {NATURAL_32} 3 * a_step___1))
									l_dst_p___4[l_size___4] := l_c___4
									l_dst___4.item.mp_size := (l_size___4 + (l_c___4 /= {NATURAL_32} 0).to_integer).to_integer_32
									js.break
								end
								js.reset
								l_a := l_a - 1
								l_b := l_b + ({NATURAL_32} 4 * a_step___1)
							end
							if a_count \\ {NATURAL_32} 4 = {NATURAL_32} 2 then
								l_b := l_b * (l_b + a_step___1)
							end
							if a_count \\ {NATURAL_32} 4 = {NATURAL_32} 3 then
								l_b := (l_b * (l_b + a_step___1)) * (l_b + {NATURAL_32} 2 * a_step___1)
							end
							if a_count \\ {NATURAL_32} 4 /= {NATURAL_32} 0 then
								from
								until
									js.loop_left
								loop
									js.reset
									l_dst___5.ce_gets (a_ret)
									l_src___5.ce_gets (a_ret)
									l_size___5 := (l_src___5.item.mp_size).to_integer_32
									if (builtin_expect ((l_size___5 + 1 > (l_dst___5.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
										realloc_inst.gmpz_realloc (l_dst___5, l_size___5 + 1).do_nothing
									end
									l_dst_p___5.ce_gets (l_dst___5.item.mp_d)
									l_c___5 := gmp_inst.gmpn_mul_1 (l_dst_p___5, l_src___5.item.mp_d, l_size___5, l_b)
									l_dst_p___5[l_size___5] := l_c___5
									l_dst___5.item.mp_size := (l_size___5 + (l_c___5 /= {NATURAL_32} 0).to_integer).to_integer_32
									js.break
								end
								js.reset
							end
						end
				when 6 then -- switch 1, done:
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	odd_product (a_low: NATURAL_32; a_high: NATURAL_32; a_st: CE_POINTER [CE_ARRAY [PD_MPZ_STRUCT]])
		local
			l_low: NATURAL_32
			l_high: NATURAL_32
			l_stc: NATURAL_32
			l_stn: NATURAL_32
			l_n: NATURAL_32
			l_y: NATURAL_32
			l_mask: NATURAL_32
			l_a: NATURAL_32
			l_nm: NATURAL_32
			l_z: INTEGER_32
			l_z2: CE_POINTER [PD_MPZ_STRUCT]
			l_z___0: CE_POINTER [PD_MPZ_STRUCT]
			l_dst: NATURAL_32
			l_tmp___0: NATURAL_32
			js: JUMP_STATE
		do
			create l_z2.make
			create l_z___0.make

			l_low := a_low
			l_high := a_high
			l_stc := {NATURAL_32} 1
			l_stn := {NATURAL_32} 0
			l_nm := {NATURAL_32} 1
			l_low := l_low + 1
			if l_low \\ {NATURAL_32} 2 = {NATURAL_32} 0 then
				l_low := l_low + 1
			end
			if l_high = {NATURAL_32} 0 then
				l_high := {NATURAL_32} 1
			end
			if l_high \\ {NATURAL_32} 2 = {NATURAL_32} 0 then
				l_high := l_high - 1
			end
			if l_high < l_low then
				from
				until
					js.loop_left
				loop
					js.reset
					l_z2.ce_gets (a_st[0])
					l_z2.item.mp_d[0] := (1).to_natural_32
					l_z2.item.mp_size := 1
					js.break
				end
				js.reset
				js.return
			end
			if not js.return_called and then (l_high = l_low) then
				from
				until
					js.loop_left
				loop
					js.reset
					l_z___0.ce_gets (a_st[0])
					l_z___0.item.mp_d[0] := l_low
					l_z___0.item.mp_size := 1
					js.break
				end
				js.reset
				js.return
			end
			if not js.return_called then
				if l_high <= {NATURAL_32} 65537 then
					l_nm := {NATURAL_32} 2
					if l_high <= {NATURAL_32} 1627 then
						l_nm := {NATURAL_32} 3
						if l_high <= {NATURAL_32} 259 then
							l_nm := {NATURAL_32} 4
						end
					end
				end
				l_high := (l_high - l_low) // {NATURAL_32} 2 + {NATURAL_32} 1
				if l_high <= ({NATURAL_32} 1).bit_shift_left (5) then
					ap_product_small (create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast ((a_st[0])), l_low, (2).to_natural_32, l_high, l_nm)
					js.return
				end
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					l_n := (builtin_clzl (l_high)).to_natural_32
					js.break
				end
				js.reset
				l_n := ({NATURAL_32} 32 - l_n) - {NATURAL_32} 5
				l_mask := ({NATURAL_32} 1).bit_shift_left (l_n.to_integer_32)
				l_a := (l_mask).bit_shift_left (1)
				l_mask := l_mask - 1
				l_z := l_mask.to_integer_32
				from
				until
					not (not js.loop_left and then (l_z >= 0))
				loop
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							asm14 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_dst), create {CE_POINTER [INTEGER_32]}.make_shared ($l_z))
							js.break
						end
						js.reset
						l_dst := (((((l_dst).bit_shift_right (4))).bit_and ({NATURAL_32} 252645135))).bit_or (((((l_dst).bit_shift_left (4))).bit_and ({NATURAL_32} 4042322160)))
						l_dst := (((((l_dst).bit_shift_right (2))).bit_and ({NATURAL_32} 858993459))).bit_or (((((l_dst).bit_shift_left (2))).bit_and ({NATURAL_32} 3435973836)))
						l_dst := (((((l_dst).bit_shift_right (1))).bit_and ({NATURAL_32} 1431655765))).bit_or (((((l_dst).bit_shift_left (1))).bit_and ({NATURAL_32} 2863311530)))
						l_y := l_dst
						js.break
					end
					js.reset
					l_y := (l_y).bit_shift_right (({NATURAL_32} 32 - l_n).to_integer_32)
					ap_product_small (create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast ((a_st[l_stn.to_integer_32])), l_low + {NATURAL_32} 2 * (((l_y).bit_not).bit_and (l_mask)), l_a, ((l_high + l_y)).bit_shift_right (l_n.to_integer_32), l_nm)
					l_stn := l_stn + 1
					l_tmp___0 := l_stc
					l_stc := l_stc + 1
					l_y := l_tmp___0
					from
					until
						((l_y).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0
					loop
						mul_inst.gmpz_mul (a_st[(l_stn - {NATURAL_32} 2).to_integer_32], create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast ((a_st[(l_stn - {NATURAL_32} 2).to_integer_32])), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast ((a_st[(l_stn - {NATURAL_32} 1).to_integer_32])))
						l_stn := l_stn - 1
						l_y := (l_y).bit_shift_right ((1))
					end
					l_z := l_z - 1
				end
			end
		end

end
