class
	P_FITS_U

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_fits_uint_p (a_f: CE_POINTER [PD_MPF_STRUCT]): INTEGER_32
		local
			l_fn: INTEGER_32
			l_fp: CE_POINTER [NATURAL_32]
			l_exp: INTEGER_32
			l_fl: NATURAL_32
			js: JUMP_STATE
		do
			create l_fp.make

			l_fn := (a_f.item.mp_size).to_integer_32
			if l_fn <= 0 then
				Result := (l_fn = 0).to_integer
				js.return
			end
			if not js.return_called then
				l_exp := a_f.item.mp_exp
				if l_exp < 1 then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				l_fp.ce_gets (a_f.item.mp_d)
				if l_exp = 1 then
					l_fl := l_fp[(l_fn - 1)]
				else
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := (l_fl <= {NATURAL_32} 4294967295).to_integer
			end
		end

	gmpf_fits_ulong_p (a_f: CE_POINTER [PD_MPF_STRUCT]): INTEGER_32
		local
			l_fn: INTEGER_32
			l_fp: CE_POINTER [NATURAL_32]
			l_exp: INTEGER_32
			l_fl: NATURAL_32
			js: JUMP_STATE
		do
			create l_fp.make

			l_fn := (a_f.item.mp_size).to_integer_32
			if l_fn <= 0 then
				Result := (l_fn = 0).to_integer
				js.return
			end
			if not js.return_called then
				l_exp := a_f.item.mp_exp
				if l_exp < 1 then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				l_fp.ce_gets (a_f.item.mp_d)
				if l_exp = 1 then
					l_fl := l_fp[(l_fn - 1)]
				else
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := (l_fl <= {NATURAL_32} 4294967295).to_integer
			end
		end

	gmpf_fits_ushort_p (a_f: CE_POINTER [PD_MPF_STRUCT]): INTEGER_32
		local
			l_fn: INTEGER_32
			l_fp: CE_POINTER [NATURAL_32]
			l_exp: INTEGER_32
			l_fl: NATURAL_32
			js: JUMP_STATE
		do
			create l_fp.make

			l_fn := (a_f.item.mp_size).to_integer_32
			if l_fn <= 0 then
				Result := (l_fn = 0).to_integer
				js.return
			end
			if not js.return_called then
				l_exp := a_f.item.mp_exp
				if l_exp < 1 then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				l_fp.ce_gets (a_f.item.mp_d)
				if l_exp = 1 then
					l_fl := l_fp[(l_fn - 1)]
				else
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				Result := (l_fl <= {NATURAL_32} 65535).to_integer
			end
		end

end
