class
	P_INIT2

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_init2 (a_r: CE_POINTER [PD_MPF_STRUCT]; a_prec_in_bits: NATURAL_32)
		local
			l_prec: INTEGER_32
			l_tmp: NATURAL_32
		do
			if {NATURAL_32} 53 > a_prec_in_bits then
				l_tmp := (53).to_natural_32
			else
				l_tmp := a_prec_in_bits
			end
			l_prec := (((l_tmp + {NATURAL_32} 64) - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32
			a_r.item.mp_size := 0
			a_r.item.mp_exp := (0).to_integer_32
			a_r.item.mp_prec := l_prec.to_integer_32
			a_r.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([((l_prec + 1) * 4).to_natural_32]))))
		end

	gmpz_init2 (a_x___2: CE_POINTER [PD_MPZ_STRUCT]; a_bits: NATURAL_32)
		local
			l_bits: NATURAL_32
			l_new_alloc: INTEGER_32
		do
			l_bits := a_bits
			l_bits := l_bits - (l_bits /= {NATURAL_32} 0).to_integer.to_natural_32
			l_new_alloc := ({NATURAL_32} 1 + l_bits // {NATURAL_32} 32).to_integer_32
			if Natural_32_bytes.to_natural_32 > Integer_32_bytes.to_natural_32 then
				if (builtin_expect ((l_new_alloc > (-((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1)).to_integer_32).to_integer, 0)).to_boolean then
					Io.error.put_string ("gmp: overflow in mpz type%N")
					abort
				end
			end
			a_x___2.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([(l_new_alloc.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32]))))
			a_x___2.item.mp_alloc := l_new_alloc.to_integer_32
			a_x___2.item.mp_size := 0
		end

end
