class
	P_INT_P

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_integer_p (a_f: CE_POINTER [PD_MPF_STRUCT]): INTEGER_32
		local
			l_ptr: CE_POINTER [NATURAL_32]
			l_exp: INTEGER_32
			l_size: INTEGER_32
			l_frac: INTEGER_32
			l_i: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_ptr.make

			l_size := (a_f.item.mp_size).to_integer_32
			if l_size = 0 then
				Result := 1
				js.return
			end
			if not js.return_called then
				l_exp := a_f.item.mp_exp
				if l_exp <= 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if l_size >= 0 then
					l_tmp := l_size
				else
					l_tmp := -l_size
				end
				l_frac := l_tmp - l_exp
				l_ptr.ce_gets (a_f.item.mp_d)
				l_i := (0).to_integer_32
				from
				until
					not (not js.loop_left and then (l_i < l_frac))
				loop
					if l_ptr[l_i] /= {NATURAL_32} 0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

end
