class
	P_IOR

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_ior (a_res: CE_POINTER [PD_MPZ_STRUCT]; a_op1: CE_POINTER [PD_MPZ_STRUCT]; a_op2: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_op1: CE_POINTER [PD_MPZ_STRUCT]
			l_op2: CE_POINTER [PD_MPZ_STRUCT]
			l_op1_ptr: CE_POINTER [NATURAL_32]
			l_op2_ptr: CE_POINTER [NATURAL_32]
			l_op1_size: INTEGER_32
			l_op2_size: INTEGER_32
			l_res_ptr: CE_POINTER [NATURAL_32]
			l_res_size: INTEGER_32
			l_i: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_opx: CE_POINTER [NATURAL_32]
			l_cy: NATURAL_32
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___7: CE_POINTER [ANY]
			l_mpz_srcptr_swap__tmp: CE_POINTER [PD_MPZ_STRUCT]
			l_mp_srcptr_swap__tmp: CE_POINTER [NATURAL_32]
			l_mp_size_t_swap__tmp: INTEGER_32
			l_opx___0: CE_POINTER [NATURAL_32]
			l_cy___0: NATURAL_32
			l_res_alloc: INTEGER_32
			l_count: INTEGER_32
			l_tmp___13: CE_POINTER [ANY]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_op1.make
			create l_op2.make
			create l_op1_ptr.make
			create l_op2_ptr.make
			create l_res_ptr.make
			create l_tmp_marker.make
			create l_opx.make
			create l_tmp___2.make
			create l_tmp___7.make
			create l_mpz_srcptr_swap__tmp.make
			create l_mp_srcptr_swap__tmp.make
			create l_opx___0.make
			create l_tmp___13.make

			l_op1.ce_gets (a_op1)
			l_op2.ce_gets (a_op2)
			l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
			l_op1_size := (l_op1.item.mp_size).to_integer_32
			l_op2_size := (l_op2.item.mp_size).to_integer_32
			l_op1_ptr.ce_gets (l_op1.item.mp_d)
			l_op2_ptr.ce_gets (l_op2.item.mp_d)
			l_res_ptr.ce_gets (a_res.item.mp_d)
			if l_op1_size >= 0 then
				if l_op2_size >= 0 then
					if l_op1_size >= l_op2_size then
						if (a_res.item.mp_alloc).to_integer_32 < l_op1_size then
							realloc_inst.gmpz_realloc (a_res, l_op1_size).do_nothing
							l_op2_ptr.ce_gets (l_op2.item.mp_d)
							l_res_ptr.ce_gets (a_res.item.mp_d)
						end
						if (l_res_ptr.c_pointer.to_integer_32).to_natural_32 /= (l_op1_ptr.c_pointer.to_integer_32).to_natural_32 then
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (l_res_ptr + l_op2_size, l_op1_ptr + l_op2_size, l_op1_size - l_op2_size)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
						end
						l_i := l_op2_size - 1
						from
						until
							not (l_i >= 0)
						loop
							l_res_ptr[l_i] := ((l_op1_ptr[l_i]).bit_or (l_op2_ptr[l_i]))
							l_i := l_i - 1
						end
						l_res_size := l_op1_size
					else
						if (a_res.item.mp_alloc).to_integer_32 < l_op2_size then
							realloc_inst.gmpz_realloc (a_res, l_op2_size).do_nothing
							l_op1_ptr.ce_gets (l_op1.item.mp_d)
							l_res_ptr.ce_gets (a_res.item.mp_d)
						end
						if (l_res_ptr.c_pointer.to_integer_32).to_natural_32 /= (l_op2_ptr.c_pointer.to_integer_32).to_natural_32 then
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (l_res_ptr + l_op1_size, l_op2_ptr + l_op1_size, l_op2_size - l_op1_size)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
						end
						l_i := l_op1_size - 1
						from
						until
							not (l_i >= 0)
						loop
							l_res_ptr[l_i] := ((l_op1_ptr[l_i]).bit_or (l_op2_ptr[l_i]))
							l_i := l_i - 1
						end
						l_res_size := l_op2_size
					end
					a_res.item.mp_size := l_res_size.to_integer_32
					js.return
				end
			elseif l_op2_size < 0 then
				l_op1_size := -l_op1_size
				l_op2_size := -l_op2_size
				if l_op1_size < l_op2_size then
					l_res_size := l_op1_size
				else
					l_res_size := l_op2_size
				end
				if (builtin_expect ((l_res_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
					l_tmp___2.ce_gets ((l_aaf.new ((l_res_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				else
					l_tmp___2.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_res_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				end
				l_opx.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2))
				gmp_inst.gmpn_sub_1 (l_opx, l_op1_ptr, l_res_size, (1).to_natural_32).do_nothing
				l_op1_ptr.ce_gets (l_opx)
				if (builtin_expect ((l_res_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
					l_tmp___7.ce_gets ((l_aaf.new ((l_res_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				else
					l_tmp___7.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_res_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				end
				l_opx.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___7))
				gmp_inst.gmpn_sub_1 (l_opx, l_op2_ptr, l_res_size, (1).to_natural_32).do_nothing
				l_op2_ptr.ce_gets (l_opx)
				if (a_res.item.mp_alloc).to_integer_32 < l_res_size then
					realloc_inst.gmpz_realloc (a_res, l_res_size).do_nothing
					l_res_ptr.ce_gets (a_res.item.mp_d)
				end
				l_i := l_res_size - 1
				from
				until
					not (not js.loop_left and then (l_i >= 0))
				loop
					js.reset
					if ((l_op1_ptr[l_i]).bit_and (l_op2_ptr[l_i])) /= {NATURAL_32} 0 then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i - 1
					end
				end
				js.reset
				l_res_size := l_i + 1
				if l_res_size /= 0 then
					l_i := l_res_size - 1
					from
					until
						not (l_i >= 0)
					loop
						l_res_ptr[l_i] := ((l_op1_ptr[l_i]).bit_and (l_op2_ptr[l_i]))
						l_i := l_i - 1
					end
					l_cy := gmp_inst.gmpn_add_1 (l_res_ptr, l_res_ptr, l_res_size, (1).to_natural_32)
					if l_cy.to_boolean then
						l_res_ptr[l_res_size] := l_cy
						l_res_size := l_res_size + 1
					end
				else
					l_res_ptr[0] := (1).to_natural_32
					l_res_size := (1).to_integer_32
				end
				a_res.item.mp_size := (-l_res_size).to_integer_32
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
					end
					js.break
				end
				js.reset
				js.return
			else
				from
				until
					js.loop_left
				loop
					js.reset
					l_mpz_srcptr_swap__tmp.ce_gets (l_op1)
					l_op1.ce_gets (l_op2)
					l_op2.ce_gets (l_mpz_srcptr_swap__tmp)
					js.break
				end
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						l_mp_srcptr_swap__tmp.ce_gets (l_op1_ptr)
						l_op1_ptr.ce_gets (l_op2_ptr)
						l_op2_ptr.ce_gets (l_mp_srcptr_swap__tmp)
						js.break
					end
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						l_mp_size_t_swap__tmp := l_op1_size
						l_op1_size := l_op2_size
						l_op2_size := l_mp_size_t_swap__tmp
						js.break
					end
					js.reset
					js.break
				end
				js.reset
			end
			if not js.return_called then
				l_op2_size := -l_op2_size
				l_res_alloc := l_op2_size
				if (builtin_expect ((l_op2_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
					l_tmp___13.ce_gets ((l_aaf.new ((l_op2_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				else
					l_tmp___13.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_op2_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				end
				l_opx___0.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___13))
				gmp_inst.gmpn_sub_1 (l_opx___0, l_op2_ptr, l_op2_size, (1).to_natural_32).do_nothing
				l_op2_ptr.ce_gets (l_opx___0)
				l_op2_size := l_op2_size - (l_op2_ptr[(l_op2_size - 1)] = {NATURAL_32} 0).to_integer
				if (a_res.item.mp_alloc).to_integer_32 < l_res_alloc then
					realloc_inst.gmpz_realloc (a_res, l_res_alloc).do_nothing
					l_op1_ptr.ce_gets (l_op1.item.mp_d)
					l_res_ptr.ce_gets (a_res.item.mp_d)
				end
				if l_op1_size >= l_op2_size then
					l_i := l_op2_size - 1
					from
					until
						not (not js.loop_left and then (l_i >= 0))
					loop
						js.reset
						if (((l_op1_ptr[l_i]).bit_not).bit_and (l_op2_ptr[l_i])) /= {NATURAL_32} 0 then
							js.break
						end
						if not js.loop_jumped then
							l_i := l_i - 1
						end
					end
					js.reset
					l_res_size := l_i + 1
					l_count := l_res_size
				else
					l_res_size := l_op2_size
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (l_res_ptr + l_op1_size, l_op2_ptr + l_op1_size, l_op2_size - l_op1_size)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
					l_count := l_op1_size
				end
				if l_res_size /= 0 then
					l_i := l_count - 1
					from
					until
						not (l_i >= 0)
					loop
						l_res_ptr[l_i] := (((l_op1_ptr[l_i]).bit_not).bit_and (l_op2_ptr[l_i]))
						l_i := l_i - 1
					end
					l_cy___0 := gmp_inst.gmpn_add_1 (l_res_ptr, l_res_ptr, l_res_size, (1).to_natural_32)
					if l_cy___0.to_boolean then
						l_res_ptr[l_res_size] := l_cy___0
						l_res_size := l_res_size + 1
					end
				else
					l_res_ptr[0] := (1).to_natural_32
					l_res_size := (1).to_integer_32
				end
				a_res.item.mp_size := (-l_res_size).to_integer_32
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
					end
					js.break
				end
				js.reset
			end
		end

end
