class
	P_MOD_1_2

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_mod_1s_2p_cps (a_cps: CE_POINTER [NATURAL_32]; a_b: NATURAL_32)
		local
			l_b: NATURAL_32
			l_bi: NATURAL_32
			l_B1modb: NATURAL_32
			l_B2modb: NATURAL_32
			l_B3modb: NATURAL_32
			l_cnt: INTEGER_32
			l_qh: NATURAL_32
			l_ql: NATURAL_32
			l_r: NATURAL_32
			l_qh___0: NATURAL_32
			l_ql___0: NATURAL_32
			l_r___0: NATURAL_32
			js: JUMP_STATE
		do
			l_b := a_b
			from
			until
				js.loop_left
			loop
				js.reset
				l_cnt := builtin_clzl (l_b)
				js.break
			end
			js.reset
			l_b := (l_b).bit_shift_left (l_cnt)
			from
			until
				js.loop_left
			loop
				js.reset
				l_bi := gmp_impl_inst.gmpn_invert_limb (l_b)
				js.break
			end
			js.reset
			l_B1modb := (-l_b.to_integer_32).to_natural_32 * ((((l_bi).bit_shift_right ((32 - l_cnt)))).bit_or ((({NATURAL_32} 1).bit_shift_left (l_cnt))))
			from
			until
				js.loop_left
			loop
				js.reset
				asm46 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_ql), create {CE_POINTER [NATURAL_32]}.make_shared ($l_qh), create {CE_POINTER [NATURAL_32]}.make_shared ($l_B1modb), create {CE_POINTER [NATURAL_32]}.make_shared ($l_bi))
				l_qh := l_qh + (l_B1modb + {NATURAL_32} 1)
				l_r := (-l_qh.to_integer_32).to_natural_32 * l_b
				if l_r > l_ql then
					l_r := l_r + l_b
				end
				l_B2modb := l_r
				js.break
			end
			js.reset
			from
			until
				js.loop_left
			loop
				js.reset
				asm47 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_ql___0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_qh___0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_B2modb), create {CE_POINTER [NATURAL_32]}.make_shared ($l_bi))
				l_qh___0 := l_qh___0 + (l_B2modb + {NATURAL_32} 1)
				l_r___0 := (-l_qh___0.to_integer_32).to_natural_32 * l_b
				if l_r___0 > l_ql___0 then
					l_r___0 := l_r___0 + l_b
				end
				l_B3modb := l_r___0
				js.break
			end
			js.reset
			a_cps[0] := l_bi
			a_cps[1] := l_cnt.to_natural_32
			a_cps[2] := (l_B1modb).bit_shift_right (l_cnt)
			a_cps[3] := (l_B2modb).bit_shift_right (l_cnt)
			a_cps[4] := (l_B3modb).bit_shift_right (l_cnt)
		end

	gmpn_mod_1s_2p (a_ap: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_b: NATURAL_32; a_cps: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_n: INTEGER_32
			l_rh: NATURAL_32
			l_rl: NATURAL_32
			l_bi: NATURAL_32
			l_q: NATURAL_32
			l_ph: NATURAL_32
			l_pl: NATURAL_32
			l_ch: NATURAL_32
			l_cl: NATURAL_32
			l_r: NATURAL_32
			l_B1modb: NATURAL_32
			l_B2modb: NATURAL_32
			l_B3modb: NATURAL_32
			l_i: INTEGER_32
			l_cnt: INTEGER_32
			l_qh: NATURAL_32
			l_ql: NATURAL_32
			l_r2: NATURAL_32
			l_qh___0: NATURAL_32
			l_ql___0: NATURAL_32
			l_r___0: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_n
			l_B1modb := a_cps[2]
			l_B2modb := a_cps[3]
			l_B3modb := a_cps[4]
			if ((l_n).bit_and (1)) /= 0 then
				if l_n = 1 then
					l_rl := a_ap[(l_n - 1)]
					l_bi := a_cps[0]
					l_cnt := (a_cps[1]).to_integer_32
					from
					until
						js.loop_left
					loop
						js.reset
						asm48 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_ql), create {CE_POINTER [NATURAL_32]}.make_shared ($l_qh), create {CE_POINTER [NATURAL_32]}.make_shared ($l_rl), create {CE_POINTER [INTEGER_32]}.make_shared ($l_cnt), create {CE_POINTER [NATURAL_32]}.make_shared ($l_bi))
						asm49 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_qh), create {CE_POINTER [NATURAL_32]}.make_shared ($l_ql), create {CE_POINTER [NATURAL_32]}.make_shared ($l_rl), create {CE_POINTER [INTEGER_32]}.make_shared ($l_cnt))
						l_r2 := ((l_rl).bit_shift_left (l_cnt)) - l_qh * a_b
						if l_r2 > l_ql then
							l_r2 := l_r2 + a_b
							l_qh := l_qh - 1
						end
						if (builtin_expect ((l_r2 >= a_b).to_integer, 0)).to_boolean then
							l_r2 := l_r2 - a_b
							l_qh := l_qh + 1
						end
						l_r := l_r2
						l_q := l_qh
						js.break
					end
					js.reset
					Result := ((l_r).bit_shift_right (l_cnt))
					js.return
				end
				if not js.return_called then
					asm50 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_pl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_ph), a_ap.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_B1modb))
					asm51 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_ph), create {CE_POINTER [NATURAL_32]}.make_shared ($l_pl), a_ap.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n))
					asm52 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_rl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_rh), a_ap.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_B2modb))
					asm53 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_rh), create {CE_POINTER [NATURAL_32]}.make_shared ($l_rl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_ph), create {CE_POINTER [NATURAL_32]}.make_shared ($l_pl))
					l_n := l_n - 1
				end
			else
				asm54 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_rl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_rh), a_ap.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_B1modb))
				asm55 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_rh), create {CE_POINTER [NATURAL_32]}.make_shared ($l_rl), a_ap.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n))
			end
			if not js.return_called then
				l_i := l_n - 4
				from
				until
					not (l_i >= 0)
				loop
					asm56 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_pl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_ph), a_ap.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_i), create {CE_POINTER [NATURAL_32]}.make_shared ($l_B1modb))
					asm57 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_ph), create {CE_POINTER [NATURAL_32]}.make_shared ($l_pl), a_ap.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_i))
					asm58 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_cl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_ch), create {CE_POINTER [NATURAL_32]}.make_shared ($l_rl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_B2modb))
					asm59 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_ph), create {CE_POINTER [NATURAL_32]}.make_shared ($l_pl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_ch), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cl))
					asm60 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_rl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_rh), create {CE_POINTER [NATURAL_32]}.make_shared ($l_B3modb))
					asm61 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_rh), create {CE_POINTER [NATURAL_32]}.make_shared ($l_rl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_ph), create {CE_POINTER [NATURAL_32]}.make_shared ($l_pl))
					l_i := l_i - (2)
				end
				l_bi := a_cps[0]
				l_cnt := (a_cps[1]).to_integer_32
				asm62 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_cl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_rh), create {CE_POINTER [NATURAL_32]}.make_shared ($l_B1modb))
				asm63 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_rh), create {CE_POINTER [NATURAL_32]}.make_shared ($l_rl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cl))
				l_r := (((l_rh).bit_shift_left (l_cnt))).bit_or (((l_rl).bit_shift_right ((32 - l_cnt))))
				from
				until
					js.loop_left
				loop
					js.reset
					asm64 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_ql___0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_qh___0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_r), create {CE_POINTER [NATURAL_32]}.make_shared ($l_bi))
					asm65 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_qh___0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_ql___0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_r), create {CE_POINTER [NATURAL_32]}.make_shared ($l_rl), create {CE_POINTER [INTEGER_32]}.make_shared ($l_cnt))
					l_r___0 := ((l_rl).bit_shift_left (l_cnt)) - l_qh___0 * a_b
					if l_r___0 > l_ql___0 then
						l_r___0 := l_r___0 + a_b
						l_qh___0 := l_qh___0 - 1
					end
					if (builtin_expect ((l_r___0 >= a_b).to_integer, 0)).to_boolean then
						l_r___0 := l_r___0 - a_b
						l_qh___0 := l_qh___0 + 1
					end
					l_r := l_r___0
					l_q := l_qh___0
					js.break
				end
				js.reset
				Result := ((l_r).bit_shift_right (l_cnt))
			end
		end

end
