class
	P_MU_BDIV_QR

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_mu_bdiv_qr (a_qp: CE_POINTER [NATURAL_32]; a_rp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_qp: CE_POINTER [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_qn: INTEGER_32
			l_in: INTEGER_32
			l_cy: NATURAL_32
			l_c0: NATURAL_32
			l_tn: INTEGER_32
			l_wn: INTEGER_32
			l_b: INTEGER_32
			l_ptr_dummy: CE_POINTER [NATURAL_32]
			l_ptr_dummy___0: CE_POINTER [NATURAL_32]
			l_ptr_dummy___1: CE_POINTER [NATURAL_32]
			l_ptr_dummy___2: CE_POINTER [NATURAL_32]
			l_ptr_dummy___3: CE_POINTER [NATURAL_32]
			l_ptr_dummy___4: CE_POINTER [NATURAL_32]
			l_ptr_dummy___5: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_qp.make
			create l_np.make
			create l_ptr_dummy.make
			create l_ptr_dummy___0.make
			create l_ptr_dummy___1.make
			create l_ptr_dummy___2.make
			create l_ptr_dummy___3.make
			create l_ptr_dummy___4.make
			create l_ptr_dummy___5.make

			l_qp.ce_gets (a_qp)
			l_np.ce_gets (a_np)
			l_qn := a_nn - a_dn
			if l_qn > a_dn then
				l_b := (l_qn - 1) // a_dn + 1
				l_in := (l_qn - 1) // l_b + 1
				binvert_inst.gmpn_binvert (a_scratch, a_dp, l_in, a_scratch + l_in)
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						gmp_inst.gmpn_copyi (a_rp, l_np, a_dn)
						js.break
					end
					js.reset
					js.break
				end
				js.reset
				l_np.ce_gets (l_np + a_dn)
				l_cy := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_qn > l_in))
				loop
					mullo_n_inst.gmpn_mullo_n (l_qp, a_rp, a_scratch, l_in)
					if 58 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
						if l_in >= 58 then
							l_tn := mulmod_bnm1_inst.gmpn_mulmod_bnm1_next_size (a_dn)
							mulmod_bnm1_inst.gmpn_mulmod_bnm1 (a_scratch + l_in, l_tn, a_dp, a_dn, l_qp, l_in, (a_scratch + l_in) + l_tn)
							l_wn := (a_dn + l_in) - l_tn
							if l_wn > 0 then
								l_c0 := gmp_inst.gmpn_sub_n ((a_scratch + l_in) + l_tn, (a_scratch + l_in), a_rp, l_wn)
								from
								until
									js.loop_left
								loop
									js.reset
									asm332 (l_ptr_dummy.address, a_scratch.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_in), create {CE_POINTER [INTEGER_32]}.make_shared ($l_wn), create {CE_POINTER [NATURAL_32]}.make_shared ($l_c0))
									js.break
								end
								js.reset
							end
						else
							mul_inst.gmpn_mul (a_scratch + l_in, a_dp, a_dn, l_qp, l_in).do_nothing
						end
					else
						mul_inst.gmpn_mul (a_scratch + l_in, a_dp, a_dn, l_qp, l_in).do_nothing
					end
					l_qp.ce_gets (l_qp + l_in)
					l_qn := l_qn - l_in
					if a_dn /= l_in then
						l_cy := l_cy + (gmp_inst.gmpn_sub_n (a_rp, (a_rp + l_in), ((a_scratch + l_in) + l_in), a_dn - l_in))
						if l_cy = {NATURAL_32} 2 then
							from
							until
								js.loop_left
							loop
								js.reset
								asm333 (l_ptr_dummy___0.address, a_scratch.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_in), create {CE_POINTER [INTEGER_32]}.make_shared ($a_dn))
								js.break
							end
							js.reset
							l_cy := (1).to_natural_32
						end
					end
					l_cy := gmp_impl_inst.gmpn_sub_nc ((a_rp + a_dn) - l_in, l_np, ((a_scratch + l_in) + a_dn), l_in, l_cy)
					l_np.ce_gets (l_np + l_in)
				end
				mullo_n_inst.gmpn_mullo_n (l_qp, a_rp, a_scratch, l_qn)
				if 58 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_qn >= 58 then
						l_tn := mulmod_bnm1_inst.gmpn_mulmod_bnm1_next_size (a_dn)
						mulmod_bnm1_inst.gmpn_mulmod_bnm1 (a_scratch + l_in, l_tn, a_dp, a_dn, l_qp, l_qn, (a_scratch + l_in) + l_tn)
						l_wn := (a_dn + l_qn) - l_tn
						if l_wn > 0 then
							l_c0 := gmp_inst.gmpn_sub_n ((a_scratch + l_in) + l_tn, (a_scratch + l_in), a_rp, l_wn)
							from
							until
								js.loop_left
							loop
								js.reset
								asm334 (l_ptr_dummy___1.address, a_scratch.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_in), create {CE_POINTER [INTEGER_32]}.make_shared ($l_wn), create {CE_POINTER [NATURAL_32]}.make_shared ($l_c0))
								js.break
							end
							js.reset
						end
					else
						mul_inst.gmpn_mul (a_scratch + l_in, a_dp, a_dn, l_qp, l_qn).do_nothing
					end
				else
					mul_inst.gmpn_mul (a_scratch + l_in, a_dp, a_dn, l_qp, l_qn).do_nothing
				end
				if a_dn /= l_qn then
					l_cy := l_cy + (gmp_inst.gmpn_sub_n (a_rp, (a_rp + l_qn), ((a_scratch + l_in) + l_qn), a_dn - l_qn))
					if l_cy = {NATURAL_32} 2 then
						from
						until
							js.loop_left
						loop
							js.reset
							asm335 (l_ptr_dummy___2.address, a_scratch.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_in), create {CE_POINTER [INTEGER_32]}.make_shared ($a_dn))
							js.break
						end
						js.reset
						l_cy := (1).to_natural_32
					end
				end
				Result := (gmp_impl_inst.gmpn_sub_nc ((a_rp + a_dn) - l_qn, l_np, ((a_scratch + l_in) + a_dn), l_qn, l_cy))
			else
				l_in := l_qn - ((l_qn).bit_shift_right (1))
				binvert_inst.gmpn_binvert (a_scratch, a_dp, l_in, a_scratch + l_in)
				mullo_n_inst.gmpn_mullo_n (l_qp, l_np, a_scratch, l_in)
				if 58 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_in >= 58 then
						l_tn := mulmod_bnm1_inst.gmpn_mulmod_bnm1_next_size (a_dn)
						mulmod_bnm1_inst.gmpn_mulmod_bnm1 (a_scratch + l_in, l_tn, a_dp, a_dn, l_qp, l_in, (a_scratch + l_in) + l_tn)
						l_wn := (a_dn + l_in) - l_tn
						if l_wn > 0 then
							l_c0 := gmp_inst.gmpn_sub_n ((a_scratch + l_in) + l_tn, (a_scratch + l_in), l_np, l_wn)
							from
							until
								js.loop_left
							loop
								js.reset
								asm336 (l_ptr_dummy___3.address, a_scratch.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_in), create {CE_POINTER [INTEGER_32]}.make_shared ($l_wn), create {CE_POINTER [NATURAL_32]}.make_shared ($l_c0))
								js.break
							end
							js.reset
						end
					else
						mul_inst.gmpn_mul (a_scratch + l_in, a_dp, a_dn, l_qp, l_in).do_nothing
					end
				else
					mul_inst.gmpn_mul (a_scratch + l_in, a_dp, a_dn, l_qp, l_in).do_nothing
				end
				l_qp.ce_gets (l_qp + l_in)
				l_qn := l_qn - l_in
				l_cy := gmp_inst.gmpn_sub_n (a_rp, l_np + l_in, ((a_scratch + l_in) + l_in), a_dn)
				mullo_n_inst.gmpn_mullo_n (l_qp, a_rp, a_scratch, l_qn)
				if 58 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_qn >= 58 then
						l_tn := mulmod_bnm1_inst.gmpn_mulmod_bnm1_next_size (a_dn)
						mulmod_bnm1_inst.gmpn_mulmod_bnm1 (a_scratch + l_in, l_tn, a_dp, a_dn, l_qp, l_qn, (a_scratch + l_in) + l_tn)
						l_wn := (a_dn + l_qn) - l_tn
						if l_wn > 0 then
							l_c0 := gmp_inst.gmpn_sub_n ((a_scratch + l_in) + l_tn, (a_scratch + l_in), a_rp, l_wn)
							from
							until
								js.loop_left
							loop
								js.reset
								asm337 (l_ptr_dummy___4.address, a_scratch.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_in), create {CE_POINTER [INTEGER_32]}.make_shared ($l_wn), create {CE_POINTER [NATURAL_32]}.make_shared ($l_c0))
								js.break
							end
							js.reset
						end
					else
						mul_inst.gmpn_mul (a_scratch + l_in, a_dp, a_dn, l_qp, l_qn).do_nothing
					end
				else
					mul_inst.gmpn_mul (a_scratch + l_in, a_dp, a_dn, l_qp, l_qn).do_nothing
				end
				l_cy := l_cy + (gmp_inst.gmpn_sub_n (a_rp, (a_rp + l_qn), ((a_scratch + l_in) + l_qn), a_dn - l_qn))
				if l_cy = {NATURAL_32} 2 then
					from
					until
						js.loop_left
					loop
						js.reset
						asm338 (l_ptr_dummy___5.address, a_scratch.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_in), create {CE_POINTER [INTEGER_32]}.make_shared ($a_dn))
						js.break
					end
					js.reset
					l_cy := (1).to_natural_32
				end
				Result := (gmp_impl_inst.gmpn_sub_nc ((a_rp + a_dn) - l_qn, (l_np + a_dn) + l_in, ((a_scratch + l_in) + a_dn), l_qn, l_cy))
			end
		end

	gmpn_mu_bdiv_qr_itch (a_nn: INTEGER_32; a_dn: INTEGER_32): INTEGER_32
		local
			l_qn: INTEGER_32
			l_in: INTEGER_32
			l_tn: INTEGER_32
			l_itch_binvert: INTEGER_32
			l_itch_out: INTEGER_32
			l_itches: INTEGER_32
			l_b: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			l_qn := a_nn - a_dn
			if l_qn > a_dn then
				l_b := (l_qn - 1) // a_dn + 1
				l_in := (l_qn - 1) // l_b + 1
				if 58 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_in >= 58 then
						l_tn := mulmod_bnm1_inst.gmpn_mulmod_bnm1_next_size (a_dn)
						l_itch_out := gmp_impl_inst.mpn_mulmod_bnm1_itch (l_tn, a_dn, l_in)
					else
						l_tn := a_dn + l_in
						l_itch_out := (0).to_integer_32
					end
				else
					l_tn := a_dn + l_in
					l_itch_out := (0).to_integer_32
				end
				l_itch_binvert := binvert_inst.gmpn_binvert_itch (l_in)
				l_itches := l_tn + l_itch_out
				if l_itches > l_itch_binvert then
					l_tmp := l_itches
				else
					l_tmp := l_itch_binvert
				end
				Result := (l_in + l_tmp)
				js.return
			else
				l_in := l_qn - ((l_qn).bit_shift_right (1))
				if 58 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_in >= 58 then
						l_tn := mulmod_bnm1_inst.gmpn_mulmod_bnm1_next_size (a_dn)
						l_itch_out := gmp_impl_inst.mpn_mulmod_bnm1_itch (l_tn, a_dn, l_in)
					else
						l_tn := a_dn + l_in
						l_itch_out := (0).to_integer_32
					end
				else
					l_tn := a_dn + l_in
					l_itch_out := (0).to_integer_32
				end
			end
			if not js.return_called then
				l_itch_binvert := binvert_inst.gmpn_binvert_itch (l_in)
				l_itches := l_tn + l_itch_out
				if l_itches > l_itch_binvert then
					l_tmp___0 := l_itches
				else
					l_tmp___0 := l_itch_binvert
				end
				Result := (l_in + l_tmp___0)
			end
		end

end
