class
	P_MU_DIV_Q

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_mu_div_q (a_qp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_tp: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_ip: CE_POINTER [NATURAL_32]
			l_this_ip: CE_POINTER [NATURAL_32]
			l_qn: INTEGER_32
			l_in: INTEGER_32
			l_this_in: INTEGER_32
			l_cy: NATURAL_32
			l_qh: NATURAL_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_in1: INTEGER_32
			l_in2: INTEGER_32
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_32]
			l_i: INTEGER_32
			l_cy___0: NATURAL_32
			l_pp: CE_POINTER [NATURAL_32]
			l_tmp___7: NATURAL_32
			l_cy___1: NATURAL_32
			l_tmp___11: NATURAL_32
			js: JUMP_STATE
		do
			create l_tp.make
			create l_rp.make
			create l_ip.make
			create l_this_ip.make
			create l_tmp_marker.make
			create l_dst.make
			create l_tmp___1.make
			create l_pp.make

			l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
			l_qn := a_nn - a_dn
			l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_qn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
			if l_qn >= a_dn then
				if a_dn /= l_qn then
					l_in1 := mu_div_qr_inst.gmpn_mu_div_qr_choose_in (l_qn - a_dn, a_dn, 0)
					l_in2 := mu_divappr_q_inst.gmpn_mu_divappr_q_choose_in (a_dn + 1, a_dn, 0)
					if l_in1 > l_in2 then
						l_in := l_in1
					else
						l_in := l_in2
					end
				else
					l_in := mu_divappr_q_inst.gmpn_mu_divappr_q_choose_in (a_dn + 1, a_dn, 0)
				end
				l_ip.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_in + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
				if a_dn = l_in then
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (a_scratch + 1, a_dp, l_in)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
					a_scratch[0] := (1).to_natural_32
					invertappr_inst.gmpn_invertappr (l_ip, a_scratch, l_in + 1, create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)).do_nothing
					from
					until
						js.loop_left
					loop
						js.reset
						gmp_inst.gmpn_copyi (l_ip, (l_ip + 1), l_in)
						js.break
					end
					js.reset
				else
					l_cy := gmp_inst.gmpn_add_1 (a_scratch, (a_dp + a_dn) - (l_in + 1), l_in + 1, (1).to_natural_32)
					if (builtin_expect ((l_cy /= {NATURAL_32} 0).to_integer, 0)).to_boolean then
						from
						until
							js.loop_left
						loop
							js.reset
							if l_in /= 0 then
								l_dst.ce_gets (l_ip)
								l_n := l_in
								from
								until
									js.loop_left
								loop
									js.reset
									l_tmp___1.ce_gets (l_dst)
									l_dst.ce_gets (l_dst + 1)
									l_tmp___1.item := (0).to_natural_32
									l_n := l_n - 1
									if not l_n.to_boolean then
										js.break
									end
								end
								js.reset
							end
							js.break
						end
						js.reset
					else
						invertappr_inst.gmpn_invertappr (l_ip, a_scratch, l_in + 1, create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)).do_nothing
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (l_ip, (l_ip + 1), l_in)
							js.break
						end
						js.reset
					end
				end
				l_rp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((2 * a_dn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
				l_this_in := mu_div_qr_inst.gmpn_mu_div_qr_choose_in (l_qn - a_dn, a_dn, 0)
				l_this_ip.ce_gets ((l_ip + l_in) - l_this_in)
				l_qh := mu_div_qr_inst.gmpn_preinv_mu_div_qr ((l_tp + a_dn) + 1, (l_rp + a_dn) + 1, a_np + a_dn, l_qn, a_dp, a_dn, l_this_ip, l_this_in, a_scratch)
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						gmp_inst.gmpn_copyi (l_rp + 1, a_np, a_dn)
						js.break
					end
					js.reset
					js.break
				end
				js.reset
				l_rp[0] := (0).to_natural_32
				l_this_in := mu_divappr_q_inst.gmpn_mu_divappr_q_choose_in (a_dn + 1, a_dn, 0)
				l_this_ip.ce_gets ((l_ip + l_in) - l_this_in)
				l_cy := mu_divappr_q_inst.gmpn_preinv_mu_divappr_q (l_tp, l_rp, 2 * a_dn + 1, a_dp, a_dn, l_this_ip, l_this_in, a_scratch)
				if (builtin_expect ((l_cy /= {NATURAL_32} 0).to_integer, 0)).to_boolean then
					l_i := (0).to_integer_32
					from
					until
						not (l_i < a_dn + 1)
					loop
						l_tp[l_i] := {NATURAL_32} 4294967295
						l_i := l_i + 1
					end
				end
				if l_tp[0] > {NATURAL_32} 4 then
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (a_qp, (l_tp + 1), l_qn)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
				else
					l_pp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (a_nn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
					mul_inst.gmpn_mul (l_pp, (l_tp + 1), l_qn, a_dp, a_dn).do_nothing
					if l_qh /= {NATURAL_32} 0 then
						l_cy___0 := (gmp_inst.gmpn_add_n (l_pp + l_qn, (l_pp + l_qn), a_dp, a_dn))
					else
						l_cy___0 := (0).to_natural_32
					end
					if l_cy___0.to_boolean then
						l_tmp___7 := gmp_inst.gmpn_sub_1 (a_qp, (l_tp + 1), l_qn, (1).to_natural_32)
						l_qh := l_qh - l_tmp___7
					elseif (gmp_inst.gmpn_cmp (l_pp, a_np, a_nn)) > 0 then
						l_tmp___7 := gmp_inst.gmpn_sub_1 (a_qp, (l_tp + 1), l_qn, (1).to_natural_32)
						l_qh := l_qh - l_tmp___7
					else
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (a_qp, (l_tp + 1), l_qn)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
					end
				end
			else
				l_qh := mu_divappr_q_inst.gmpn_mu_divappr_q (l_tp, (a_np + a_nn) - (2 * l_qn + 2), 2 * l_qn + 2, (a_dp + a_dn) - (l_qn + 1), l_qn + 1, a_scratch)
				if l_tp[0] > {NATURAL_32} 6 then
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (a_qp, (l_tp + 1), l_qn)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
				else
					l_rp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (a_nn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
					mul_inst.gmpn_mul (l_rp, a_dp, a_dn, (l_tp + 1), l_qn).do_nothing
					if l_qh /= {NATURAL_32} 0 then
						l_cy___1 := (gmp_inst.gmpn_add_n (l_rp + l_qn, (l_rp + l_qn), a_dp, a_dn))
					else
						l_cy___1 := (0).to_natural_32
					end
					if l_cy___1.to_boolean then
						l_tmp___11 := gmp_inst.gmpn_sub_1 (a_qp, (l_tp + 1), l_qn, (1).to_natural_32)
						l_qh := l_qh - l_tmp___11
					elseif (gmp_inst.gmpn_cmp (l_rp, a_np, a_nn)) > 0 then
						l_tmp___11 := gmp_inst.gmpn_sub_1 (a_qp, (l_tp + 1), l_qn, (1).to_natural_32)
						l_qh := l_qh - l_tmp___11
					else
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (a_qp, (l_tp + 1), l_qn)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
					end
				end
			end
			from
			until
				js.loop_left
			loop
				js.reset
				if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
					tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
				end
				js.break
			end
			js.reset
			Result := l_qh
		end

	gmpn_mu_div_q_itch (a_nn: INTEGER_32; a_dn: INTEGER_32; a_mua_k: INTEGER_32): INTEGER_32
		local
			l_qn: INTEGER_32
			l_itch1: INTEGER_32
			l_itch2: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_qn := a_nn - a_dn
			if l_qn >= a_dn then
				l_itch1 := mu_div_qr_inst.gmpn_mu_div_qr_itch (l_qn, a_dn, a_mua_k)
				l_itch2 := mu_divappr_q_inst.gmpn_mu_divappr_q_itch (2 * a_dn + 1, a_dn, a_mua_k)
				if l_itch1 > l_itch2 then
					l_tmp := l_itch1
				else
					l_tmp := l_itch2
				end
				Result := l_tmp
			else
				l_itch1 := mu_divappr_q_inst.gmpn_mu_divappr_q_itch (2 * l_qn + 2, l_qn + 1, a_mua_k)
				Result := l_itch1
			end
		end

end
