class
	P_MULLO_N

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	mpn_mullo_n_itch (a_n: INTEGER_32): INTEGER_32
		do
			Result := (2 * a_n)
		end

	mpn_dc_mullo_n (a_rp: CE_POINTER [NATURAL_32]; a_xp: CE_POINTER [NATURAL_32]; a_yp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		local
			l_n2: INTEGER_32
			l_n1: INTEGER_32
			js: JUMP_STATE
		do
			if 110 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
				if a_n >= 110 then
					if 234 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
						if a_n >= 234 then
							if 423 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
								if a_n >= 423 then
									l_n1 := (a_n.to_natural_32 // {NATURAL_32} 10).to_integer_32
								else
									l_n1 := ((a_n * 7).to_natural_32 // {NATURAL_32} 39).to_integer_32
								end
							else
								l_n1 := ((a_n * 7).to_natural_32 // {NATURAL_32} 39).to_integer_32
							end
						else
							l_n1 := ((a_n * 9).to_natural_32 // {NATURAL_32} 40).to_integer_32
						end
					else
						l_n1 := ((a_n * 9).to_natural_32 // {NATURAL_32} 40).to_integer_32
					end
				else
					l_n1 := ((a_n * 11).to_natural_32 // {NATURAL_32} 36).to_integer_32
				end
			else
				l_n1 := ((a_n * 11).to_natural_32 // {NATURAL_32} 36).to_integer_32
			end
			l_n2 := a_n - l_n1
			mul_n_inst.gmpn_mul_n (a_tp, a_xp, a_yp, l_n2)
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					gmp_inst.gmpn_copyi (a_rp, a_tp, l_n2)
					js.break
				end
				js.reset
				js.break
			end
			js.reset
			if 34 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
				if l_n1 >= 34 then
					mpn_dc_mullo_n (a_tp + a_n, a_xp + l_n2, a_yp, l_n1, a_tp + a_n)
				else
					mullo_basecase_inst.gmpn_mullo_basecase (a_tp + a_n, a_xp + l_n2, a_yp, l_n1)
				end
			else
				mullo_basecase_inst.gmpn_mullo_basecase (a_tp + a_n, a_xp + l_n2, a_yp, l_n1)
			end
			gmp_inst.gmpn_add_n (a_rp + l_n2, (a_tp + l_n2), (a_tp + a_n), l_n1).do_nothing
			if 34 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
				if l_n1 >= 34 then
					mpn_dc_mullo_n (a_tp + a_n, a_xp, a_yp + l_n2, l_n1, a_tp + a_n)
				else
					mullo_basecase_inst.gmpn_mullo_basecase (a_tp + a_n, a_xp, a_yp + l_n2, l_n1)
				end
			else
				mullo_basecase_inst.gmpn_mullo_basecase (a_tp + a_n, a_xp, a_yp + l_n2, l_n1)
			end
			gmp_inst.gmpn_add_n (a_rp + l_n2, (a_rp + l_n2), (a_tp + a_n), l_n1).do_nothing
		end

	gmpn_mullo_n (a_rp: CE_POINTER [NATURAL_32]; a_xp: CE_POINTER [NATURAL_32]; a_yp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32)
		local
			l_tp___0: CE_POINTER [NATURAL_32]
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp___5: CE_POINTER [ANY]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_tp___0.make
			create l_tmp_marker.make
			create l_tmp___5.make

			if 34 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
				if a_n >= 34 then
					l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
					if (builtin_expect (((mpn_mullo_n_itch (a_n)).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___5.ce_gets ((l_aaf.new (((mpn_mullo_n_itch (a_n)).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___5.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((mpn_mullo_n_itch (a_n)).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_tp___0.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___5))
					if 8907 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
						if a_n >= 8907 then
							nussbaumer_mul_inst.gmpn_nussbaumer_mul (l_tp___0, a_xp, a_n, a_yp, a_n)
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (a_rp, l_tp___0, a_n)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
						else
							mpn_dc_mullo_n (a_rp, a_xp, a_yp, a_n, l_tp___0)
						end
					else
						mpn_dc_mullo_n (a_rp, a_xp, a_yp, a_n, l_tp___0)
					end
					from
					until
						js.loop_left
					loop
						js.reset
						if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
							tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
						end
						js.break
					end
					js.reset
				else
					mullo_basecase_inst.gmpn_mullo_basecase (a_rp, a_xp, a_yp, a_n)
				end
			else
				mullo_basecase_inst.gmpn_mullo_basecase (a_rp, a_xp, a_yp, a_n)
			end
		end

end
