class
	P_NUSSBAUMER_MUL

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_nussbaumer_mul (a_pp: CE_POINTER [NATURAL_32]; a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32)
		local
			l_rn: INTEGER_32
			l_tp: CE_POINTER [NATURAL_32]
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp___5: CE_POINTER [ANY]
			l_tmp___14: CE_POINTER [ANY]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_tp.make
			create l_tmp_marker.make
			create l_tmp___5.make
			create l_tmp___14.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
					if (a_ap.c_pointer.to_integer_32).to_natural_32 /= (a_bp.c_pointer.to_integer_32).to_natural_32 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_an = a_bn then
							l_rn := sqrmod_bnm1_inst.gmpn_sqrmod_bnm1_next_size (2 * a_an)
							if (builtin_expect (((gmp_impl_inst.mpn_sqrmod_bnm1_itch (l_rn, a_an)).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
								l_tmp___5.ce_gets ((l_aaf.new (((gmp_impl_inst.mpn_sqrmod_bnm1_itch (l_rn, a_an)).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							else
								l_tmp___5.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((gmp_impl_inst.mpn_sqrmod_bnm1_itch (l_rn, a_an)).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___5))
							sqrmod_bnm1_inst.gmpn_sqrmod_bnm1 (a_pp, l_rn, a_ap, a_an, l_tp)
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						l_rn := mulmod_bnm1_inst.gmpn_mulmod_bnm1_next_size (a_an + a_bn)
						if (builtin_expect (((gmp_impl_inst.mpn_mulmod_bnm1_itch (l_rn, a_an, a_bn)).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___14.ce_gets ((l_aaf.new (((gmp_impl_inst.mpn_mulmod_bnm1_itch (l_rn, a_an, a_bn)).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___14.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((gmp_impl_inst.mpn_mulmod_bnm1_itch (l_rn, a_an, a_bn)).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___14))
						mulmod_bnm1_inst.gmpn_mulmod_bnm1 (a_pp, l_rn, a_ap, a_an, a_bp, a_bn, l_tp)
				when 4 then
					from
					until
						js.loop_left
					loop
						js.reset
						if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
							tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
						end
						js.break
					end
					js.reset
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
