class
	P_OUT_RAW

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_out_raw (a_fp: CE_POINTER [SD_IO_FILE]; a_x___2: CE_POINTER [PD_MPZ_STRUCT]): NATURAL_32
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			l_xsize: INTEGER_32
			l_abs_xsize: INTEGER_32
			l_bytes: INTEGER_32
			l_i: INTEGER_32
			l_xp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [INTEGER_8]
			l_bp: CE_POINTER [INTEGER_8]
			l_xlimb: NATURAL_32
			l_zeros: INTEGER_32
			l_tsize: NATURAL_32
			l_ssize: NATURAL_32
			js: JUMP_STATE
		do
			create l_fp.make
			create l_xp.make
			create l_tp.make
			create l_bp.make

			l_fp.ce_gets (a_fp)
			l_xsize := (a_x___2.item.mp_size).to_integer_32
			if l_xsize >= 0 then
				l_abs_xsize := l_xsize
			else
				l_abs_xsize := -l_xsize
			end
			l_bytes := (l_abs_xsize * 32 + 7) // 8
			l_tsize := ({NATURAL_32} 4 + l_bytes.to_natural_32).to_natural_32
			l_tp.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([l_tsize * Integer_8_bytes.to_natural_32])))))
			l_bp.ce_gets (l_tp + ({NATURAL_32} 4).to_integer_32)
			if l_bytes /= 0 then
				l_bp.ce_gets (l_bp + l_bytes)
				l_xp.ce_gets (a_x___2.item.mp_d)
				l_i := l_abs_xsize
				from
				until
					js.loop_left
				loop
					js.reset
					l_bp.ce_gets (l_bp - (4))
					l_xlimb := l_xp.item
					from
					until
						js.loop_left
					loop
						js.reset
						asm23 (l_bp.address, create {CE_POINTER [NATURAL_32]}.make_shared ($l_xlimb))
						js.break
					end
					js.reset
					l_xp.ce_gets (l_xp + 1)
					l_i := l_i - 1
					if not (l_i > 0) then
						js.break
					end
				end
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					l_zeros := builtin_clzl (l_xlimb)
					js.break
				end
				js.reset
				l_zeros := l_zeros // (8)
				l_bp.ce_gets (l_bp + l_zeros)
				l_bytes := l_bytes - l_zeros.to_integer_32
			end
			l_ssize := (4 + l_bytes).to_natural_32
			if l_xsize >= 0 then
				l_bytes := l_bytes
			else
				l_bytes := -l_bytes
			end
			from
			until
				js.loop_left
			loop
				js.reset
				if not (Integer_32_bytes.to_natural_32 >= {NATURAL_32} 4) then
					assert_inst.gmp_assert_fail (ce_string ("out_raw.c"), 147, ce_string ("sizeof (bytes) >= 4"))
				end
				js.break
			end
			js.reset
			l_bp[-4] := ((l_bytes).bit_shift_right (24)).to_integer_8
			l_bp[-3] := ((l_bytes).bit_shift_right (16)).to_integer_8
			l_bp[-2] := ((l_bytes).bit_shift_right (8)).to_integer_8
			l_bp[-1] := l_bytes.to_integer_8
			l_bp.ce_gets (l_bp - (4))
			if (l_fp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_fp.ce_gets ((create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer)))
			end
			if (fwrite (create {CE_POINTER [ANY]}.make_cast (l_bp), l_ssize, (1).to_natural_32, l_fp)) /= {NATURAL_32} 1 then
				l_ssize := (0).to_natural_32
			end
			memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (l_tp), l_tsize])
			Result := l_ssize
		end

end
