class
	P_PRE_MOD_1

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_preinv_mod_1 (a_up: CE_POINTER [NATURAL_32]; a_un: INTEGER_32; a_d: NATURAL_32; a_dinv: NATURAL_32): NATURAL_32
		local
			l_i: INTEGER_32
			l_n0: NATURAL_32
			l_r: NATURAL_32
			l_dummy: NATURAL_32
			l_qh: NATURAL_32
			l_ql: NATURAL_32
			l_r2: NATURAL_32
			js: JUMP_STATE
		do
			l_r := a_up[(a_un - 1)]
			if l_r >= a_d then
				l_r := l_r - a_d
			end
			l_i := a_un - 2
			from
			until
				not (not js.loop_left and then (l_i >= 0))
			loop
				l_n0 := a_up[l_i]
				from
				until
					js.loop_left
				loop
					js.reset
					asm35 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_ql), create {CE_POINTER [NATURAL_32]}.make_shared ($l_qh), create {CE_POINTER [NATURAL_32]}.make_shared ($l_r), create {CE_POINTER [NATURAL_32]}.make_shared ($a_dinv))
					asm36 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_qh), create {CE_POINTER [NATURAL_32]}.make_shared ($l_ql), create {CE_POINTER [NATURAL_32]}.make_shared ($l_r), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0))
					l_r2 := l_n0 - l_qh * a_d
					if l_r2 > l_ql then
						l_r2 := l_r2 + a_d
						l_qh := l_qh - 1
					end
					if (builtin_expect ((l_r2 >= a_d).to_integer, 0)).to_boolean then
						l_r2 := l_r2 - a_d
						l_qh := l_qh + 1
					end
					l_r := l_r2
					l_dummy := l_qh
					js.break
				end
				js.reset
				l_i := l_i - 1
			end
			Result := l_r
		end

end
