class
	P_REALLOC2

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_realloc2 (a_m: CE_POINTER [PD_MPZ_STRUCT]; a_bits: NATURAL_32)
		local
			l_bits: NATURAL_32
			l_new_alloc: INTEGER_32
			l_tmp___1: INTEGER_32
		do
			l_bits := a_bits
			l_bits := l_bits - (l_bits /= {NATURAL_32} 0).to_integer.to_natural_32
			l_new_alloc := ({NATURAL_32} 1 + l_bits // {NATURAL_32} 32).to_integer_32
			if Natural_32_bytes.to_natural_32 > Integer_32_bytes.to_natural_32 then
				if (builtin_expect ((l_new_alloc > (-((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1)).to_integer_32).to_integer, 0)).to_boolean then
					Io.error.put_string ("gmp: overflow in mpz type%N")
					abort
				end
			end
			a_m.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_reallocate_func.pointer_item ([create {CE_POINTER [ANY]}.make_cast (a_m.item.mp_d), (a_m.item.mp_alloc).to_natural_32 * Natural_32_bytes.to_natural_32, (l_new_alloc.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32]))))
			a_m.item.mp_alloc := l_new_alloc.to_integer_32
			if a_m.item.mp_size >= 0 then
				l_tmp___1 := a_m.item.mp_size
			else
				l_tmp___1 := -a_m.item.mp_size
			end
			if l_tmp___1.to_integer_32 > l_new_alloc then
				a_m.item.mp_size := 0
			end
		end

end
