class
	P_REDC_N

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_redc_n (a_rp: CE_POINTER [NATURAL_32]; a_up: CE_POINTER [NATURAL_32]; a_mp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_ip: CE_POINTER [NATURAL_32])
		local
			l_xp: CE_POINTER [NATURAL_32]
			l_yp: CE_POINTER [NATURAL_32]
			l_scratch: CE_POINTER [NATURAL_32]
			l_cy: NATURAL_32
			l_rn: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp___5: CE_POINTER [ANY]
			l_ptr_dummy: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_xp.make
			create l_yp.make
			create l_scratch.make
			create l_tmp_marker.make
			create l_tmp___5.make
			create l_ptr_dummy.make

			l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
			l_rn := mulmod_bnm1_inst.gmpn_mulmod_bnm1_next_size (a_n)
			if (builtin_expect ((((a_n + l_rn) + (gmp_impl_inst.mpn_mulmod_bnm1_itch (l_rn, a_n, a_n))).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
				l_tmp___5.ce_gets ((l_aaf.new ((((a_n + l_rn) + (gmp_impl_inst.mpn_mulmod_bnm1_itch (l_rn, a_n, a_n))).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			else
				l_tmp___5.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (((a_n + l_rn) + (gmp_impl_inst.mpn_mulmod_bnm1_itch (l_rn, a_n, a_n))).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			end
			l_scratch.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___5))
			l_xp.ce_gets (l_scratch)
			mullo_n_inst.gmpn_mullo_n (l_xp, a_up, a_ip, a_n)
			l_yp.ce_gets (l_scratch + a_n)
			mulmod_bnm1_inst.gmpn_mulmod_bnm1 (l_yp, l_rn, l_xp, a_n, a_mp, a_n, (l_scratch + a_n) + l_rn)
			from
			until
				js.loop_left
			loop
				js.reset
				if not (2 * a_n > l_rn) then
					assert_inst.gmp_assert_fail (ce_string ("redc_n.c"), 56, ce_string ("2 * n > rn"))
				end
				js.break
			end
			js.reset
			l_cy := gmp_inst.gmpn_sub_n (l_yp + l_rn, l_yp, a_up, 2 * a_n - l_rn)
			from
			until
				js.loop_left
			loop
				js.reset
				asm340 (l_ptr_dummy.address, l_yp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), create {CE_POINTER [INTEGER_32]}.make_shared ($l_rn), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
				js.break
			end
			js.reset
			l_cy := gmp_inst.gmpn_sub_n (a_rp, (a_up + a_n), (l_yp + a_n), a_n)
			if l_cy /= {NATURAL_32} 0 then
				gmp_inst.gmpn_add_n (a_rp, a_rp, a_mp, a_n).do_nothing
			end
			from
			until
				js.loop_left
			loop
				js.reset
				if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
					tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
				end
				js.break
			end
			js.reset
		end

end
