class
	P_SBPI1_BDIV_Q

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_sbpi1_bdiv_q (a_qp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_dinv: NATURAL_32)
		local
			l_qp: CE_POINTER [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_i: INTEGER_32
			l_cy: NATURAL_32
			l_q: NATURAL_32
			js: JUMP_STATE
		do
			create l_qp.make
			create l_np.make

			l_qp.ce_gets (a_qp)
			l_np.ce_gets (a_np)
			l_i := a_nn - a_dn
			from
			until
				not (not js.loop_left and then (l_i > 0))
			loop
				l_q := a_dinv * l_np[0]
				l_qp[0] := (l_q).bit_not
				l_qp.ce_gets (l_qp + 1)
				l_cy := gmp_inst.gmpn_addmul_1 (l_np, a_dp, a_dn, l_q)
				gmp_inst.gmpn_add_1 (l_np + a_dn, (l_np + a_dn), l_i, l_cy).do_nothing
				l_np.ce_gets (l_np + 1)
				l_i := l_i - 1
			end
			l_i := a_dn
			from
			until
				not (not js.loop_left and then (l_i > 1))
			loop
				l_q := a_dinv * l_np[0]
				l_qp[0] := (l_q).bit_not
				l_qp.ce_gets (l_qp + 1)
				gmp_inst.gmpn_addmul_1 (l_np, a_dp, l_i, l_q).do_nothing
				l_np.ce_gets (l_np + 1)
				l_i := l_i - 1
			end
			l_q := a_dinv * l_np[0]
			l_qp[0] := (l_q).bit_not
			gmp_inst.gmpn_add_1 ((l_qp - a_nn) + 1, ((l_qp - a_nn) + 1), a_nn, (1).to_natural_32).do_nothing
		end

end
