class
	P_SET_DFL_PREC

inherit
	LIBGMP_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {NONE} -- Initialization

	default_create
		do
		end

feature {ANY} -- attributes

	gmp_default_fp_limb_precision: INTEGER_32 assign set_gmp_default_fp_limb_precision

	set_gmp_default_fp_limb_precision (a_gmp_default_fp_limb_precision: INTEGER_32)
		do
			gmp_default_fp_limb_precision := a_gmp_default_fp_limb_precision
		end

feature {ANY} -- routines

	gmpf_set_default_prec (a_prec_in_bits: NATURAL_32)
		local
			l_tmp: NATURAL_32
		do
			if {NATURAL_32} 53 > a_prec_in_bits then
				l_tmp := (53).to_natural_32
			else
				l_tmp := a_prec_in_bits
			end
			gmp_default_fp_limb_precision := (((l_tmp + {NATURAL_32} 64) - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32
		end

end
