class
	P_SET_PRC

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_set_prec (a_x___2: CE_POINTER [PD_MPF_STRUCT]; a_new_prec_in_bits: NATURAL_32)
		local
			l_old_prec: INTEGER_32
			l_new_prec: INTEGER_32
			l_new_prec_plus1: INTEGER_32
			l_size: INTEGER_32
			l_sign: INTEGER_32
			l_xp: CE_POINTER [NATURAL_32]
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			create l_xp.make

			if {NATURAL_32} 53 > a_new_prec_in_bits then
				l_tmp := (53).to_natural_32
			else
				l_tmp := a_new_prec_in_bits
			end
			l_new_prec := (((l_tmp + {NATURAL_32} 64) - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32
			l_old_prec := (a_x___2.item.mp_prec).to_integer_32
			if l_new_prec = l_old_prec then
				js.return
			end
			if not js.return_called then
				a_x___2.item.mp_prec := l_new_prec.to_integer_32
				l_new_prec_plus1 := l_new_prec + 1
				l_sign := (a_x___2.item.mp_size).to_integer_32
				if l_sign >= 0 then
					l_size := l_sign
				else
					l_size := -l_sign
				end
				l_xp.ce_gets (a_x___2.item.mp_d)
				if l_size > l_new_prec_plus1 then
					if l_sign >= 0 then
						a_x___2.item.mp_size := l_new_prec_plus1.to_integer_32
					else
						a_x___2.item.mp_size := (-l_new_prec_plus1).to_integer_32
					end
					from
					until
						js.loop_left
					loop
						js.reset
						gmp_inst.gmpn_copyi (l_xp, ((l_xp + l_size) - l_new_prec_plus1), l_new_prec_plus1)
						js.break
					end
					js.reset
				end
				a_x___2.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_reallocate_func.pointer_item ([create {CE_POINTER [ANY]}.make_cast (l_xp), ((l_old_prec + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32, (l_new_prec_plus1.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32]))))
			end
		end

end
