class
	P_SET_STR

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	mpn_pow_1_highpart (a_rp: CE_POINTER [NATURAL_32]; a_ignp: CE_POINTER [INTEGER_32]; a_base: NATURAL_32; a_exp: INTEGER_32; a_prec: INTEGER_32; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_ign: INTEGER_32
			l_off: INTEGER_32
			l_passed_rp: CE_POINTER [NATURAL_32]
			l_rn: INTEGER_32
			l_cnt: INTEGER_32
			l_i: INTEGER_32
			l_mp_ptr_swap__tmp: CE_POINTER [NATURAL_32]
			l_cy: NATURAL_32
			js: JUMP_STATE
		do
			create l_rp.make
			create l_tp.make
			create l_passed_rp.make
			create l_mp_ptr_swap__tmp.make

			l_rp.ce_gets (a_rp)
			l_tp.ce_gets (a_tp)
			l_passed_rp.ce_gets (l_rp)
			l_rp[0] := a_base
			l_rn := (1).to_integer_32
			l_off := (0).to_integer_32
			l_ign := (0).to_integer_32
			from
			until
				js.loop_left
			loop
				js.reset
				l_cnt := builtin_clzl (a_exp.to_natural_32)
				js.break
			end
			js.reset
			l_i := (32 - l_cnt) - 2
			from
			until
				not (not js.loop_left and then (l_i >= 0))
			loop
				sqr_inst.gmpn_sqr (l_tp, (l_rp + l_off), l_rn)
				l_rn := 2 * l_rn
				l_rn := l_rn - (l_tp[(l_rn - 1)] = {NATURAL_32} 0).to_integer
				l_ign := (l_ign).bit_shift_left ((1))
				l_off := (0).to_integer_32
				if l_rn > a_prec then
					l_ign := l_ign + (l_rn - a_prec)
					l_off := l_rn - a_prec
					l_rn := a_prec
				end
				from
				until
					js.loop_left
				loop
					js.reset
					l_mp_ptr_swap__tmp.ce_gets (l_rp)
					l_rp.ce_gets (l_tp)
					l_tp.ce_gets (l_mp_ptr_swap__tmp)
					js.break
				end
				js.reset
				if ((((a_exp).bit_shift_right (l_i))).bit_and (1)) /= 0 then
					l_cy := gmp_inst.gmpn_mul_1 (l_rp, (l_rp + l_off), l_rn, a_base)
					l_rp[l_rn] := l_cy
					l_rn := l_rn + (l_cy /= {NATURAL_32} 0).to_integer
					l_off := (0).to_integer_32
				end
				l_i := l_i - 1
			end
			if l_rn > a_prec then
				l_ign := l_ign + (l_rn - a_prec)
				l_rp.ce_gets (l_rp + (l_rn - a_prec))
				l_rn := a_prec
			end
			from
			until
				js.loop_left
			loop
				js.reset
				gmp_inst.gmpn_copyi (l_passed_rp, (l_rp + l_off), l_rn)
				js.break
			end
			js.reset
			a_ignp.item := l_ign
			Result := l_rn
		end

	gmpf_set_str (a_x___2: CE_POINTER [PD_MPF_STRUCT]; a_str: CE_POINTER [INTEGER_8]; a_base: INTEGER_32): INTEGER_32
		local
			l_str: CE_POINTER [INTEGER_8]
			l_base: INTEGER_32
			l_str_size: NATURAL_32
			l_s: CE_POINTER [INTEGER_8]
			l_begs: CE_POINTER [INTEGER_8]
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_c: INTEGER_32
			l_negative: INTEGER_32
			l_dotpos: CE_POINTER [INTEGER_8]
			l_expptr: CE_POINTER [INTEGER_8]
			l_exp_base: INTEGER_32
			l_point: CE_POINTER [INTEGER_8]
			l_pointlen: NATURAL_32
			l_digit_value: CE_POINTER [NATURAL_8]
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___7: CE_POINTER [ANY]
			l_dig: INTEGER_32
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_exp_in_base: INTEGER_32
			l_ra: INTEGER_32
			l_ma: INTEGER_32
			l_rn: INTEGER_32
			l_mn: INTEGER_32
			l_cnt: INTEGER_32
			l_mp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_exp_in_limbs: INTEGER_32
			l_prec: INTEGER_32
			l_divflag: INTEGER_32
			l_madj: INTEGER_32
			l_radj: INTEGER_32
			l_tmp___16: CE_POINTER [ANY]
			l_dig___0: INTEGER_32
			l_minus: INTEGER_32
			l_plusminus: INTEGER_32
			l_tmp___19: CE_POINTER [INTEGER_8]
			l_tmp___21: CE_POINTER [INTEGER_8]
			l_tmp___22: CE_POINTER [INTEGER_8]
			l_tmp___27: CE_POINTER [ANY]
			l_tmp___32: CE_POINTER [ANY]
			l_qp: CE_POINTER [NATURAL_32]
			l_qlimb: NATURAL_32
			l_tmp___34: CE_POINTER [NATURAL_32]
			l_tmp___38: CE_POINTER [ANY]
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp___40: CE_POINTER [NATURAL_32]
			l_cy: NATURAL_32
			l_tmp___41: INTEGER_32
			l_tmp___45: CE_POINTER [ANY]
			l_tmp___50: CE_POINTER [ANY]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_str.make
			create l_s.make
			create l_begs.make
			create l_dotpos.make
			create l_expptr.make
			create l_point.make
			create l_digit_value.make
			create l_tmp_marker.make
			create l_tmp___7.make
			create l_tmp___11.make
			create l_mp.make
			create l_tp.make
			create l_rp.make
			create l_tmp___16.make
			create l_tmp___19.make
			create l_tmp___21.make
			create l_tmp___22.make
			create l_tmp___27.make
			create l_tmp___32.make
			create l_qp.make
			create l_tmp___34.make
			create l_tmp___38.make
			create l_dst.make
			create l_tmp___40.make
			create l_tmp___45.make
			create l_tmp___50.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_str.ce_gets (a_str)
					l_base := a_base
					l_dotpos.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					l_point.ce_gets ((nl_langinfo (65536)))
					l_pointlen := (strlen (l_point))
					l_c := ((l_str[0]).to_natural_8).to_integer_32
					from
					until
						js.loop_left
					loop
						js.reset
						if not ((((ctype_b_loc).item[l_c]).to_integer_32).bit_and (8192)).to_boolean then
							js.break
						end
						if not js.loop_jumped then
							l_str.ce_gets (l_str + 1)
							l_c := ((l_str[0]).to_natural_8).to_integer_32
						end
					end
					js.reset
					l_negative := 0
					if l_c = 45 then
						l_negative := 1
						l_str.ce_gets (l_str + 1)
						l_c := ((l_str[0]).to_natural_8).to_integer_32
					end
					if l_base = 0 then
						l_base := 10
					end
					l_exp_base := l_base
					if l_base < 0 then
						l_exp_base := 10
						l_base := -l_base
					end
					l_digit_value.ce_gets (mp_dv_tab_inst.gmp_digit_value_tab)
					if l_base > 36 then
						l_digit_value.ce_gets (l_digit_value + (224))
						if l_base > 62 then
							Result := (-1)
							js.return
						end
					end
					if not js.return_called then
						if l_base = 0 then
							l_tmp___3 := 10
						else
							l_tmp___3 := l_base
						end
						if (l_digit_value[l_c]).to_integer_32 >= l_tmp___3 then
							l_i := (0).to_natural_32
							from
							until
								not (not js.loop_left and then (l_i < l_pointlen))
							loop
								if (l_str[l_i.to_integer_32]).to_integer_32 /= (l_point[l_i.to_integer_32]).to_integer_32 then
									Result := (-1)
									js.return
								end
								if not js.return_called then
									l_i := l_i + 1
								end
							end
							if not js.return_called then
								if l_base = 0 then
									l_tmp___2 := 10
								else
									l_tmp___2 := l_base
								end
								if (l_digit_value[((l_str[l_pointlen.to_integer_32]).to_natural_8).to_integer_32]).to_integer_32 >= l_tmp___2 then
									Result := (-1)
									js.return
								end
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						l_expptr.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
						l_str_size := strlen (l_str)
						l_i := l_str_size - {NATURAL_32} 1
						from
						until
							not (not js.loop_left and then (l_i > {NATURAL_32} 0))
						loop
							js.reset
							l_c := ((l_str[l_i.to_integer_32]).to_natural_8).to_integer_32
							if l_c = 64 then
								l_expptr.ce_gets ((l_str + l_i.to_integer_32) + 1)
								l_str_size := l_i
								js.break
							elseif l_base <= 10 then
								if l_c = 101 then
									l_expptr.ce_gets ((l_str + l_i.to_integer_32) + 1)
									l_str_size := l_i
									js.break
								elseif l_c = 69 then
									l_expptr.ce_gets ((l_str + l_i.to_integer_32) + 1)
									l_str_size := l_i
									js.break
								end
							end
							if not js.loop_jumped then
								l_i := l_i - 1
							end
						end
						js.reset
						l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
						if (builtin_expect ((l_str_size + {NATURAL_32} 1 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___7.ce_gets ((l_aaf.new (l_str_size + {NATURAL_32} 1)))
						else
							l_tmp___7.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, l_str_size + {NATURAL_32} 1)))
						end
						l_begs.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp___7))
						l_s.ce_gets (l_begs)
						l_i := (0).to_natural_32
				when 2 then -- loop condition:
						if not (not js.loop_left and then (l_i < l_str_size)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 3 then -- loop body:
						l_c := ((l_str[0]).to_natural_8).to_integer_32
						if ((((ctype_b_loc).item[l_c]).to_integer_32).bit_and (8192)).to_boolean then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						l_j := (0).to_natural_32
				when 5 then -- loop condition:
						if not (l_j < l_pointlen) then
							l_pos := -1 + 8 -- skip loop
						end
				when 6 then -- loop body:
						if (l_str[l_j.to_integer_32]).to_integer_32 /= (l_point[l_j.to_integer_32]).to_integer_32 then
							l_pos := -1 + 11 -- goto not_point
						end
				when 7 then
						l_j := l_j + 1
						l_pos := -1 + 5 -- back to loop condition
				when 8 then -- loop done
						if False then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if (l_dotpos.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							from
							until
								js.loop_left
							loop
								js.reset
								if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
									tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
								end
								js.break
							end
							js.reset
							Result := (-1)
							js.return
						end
						if not js.return_called then
							l_dotpos.ce_gets (l_s)
							l_str.ce_gets (l_str + (l_pointlen - {NATURAL_32} 1).to_integer_32)
							l_i := l_i + (l_pointlen - {NATURAL_32} 1)
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | not_point:
						l_dig := (l_digit_value[l_c]).to_integer_32
						if l_dig >= l_base then
							from
							until
								js.loop_left
							loop
								js.reset
								if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
									tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
								end
								js.break
							end
							js.reset
							Result := (-1)
							js.return
						end
						if not js.return_called then
							l_tmp___11.ce_gets (l_s)
							l_s.ce_gets (l_s + 1)
							l_tmp___11[0] := l_dig.to_integer_8
						end
				when 12 then -- if done | if done
						if not js.return_called then
							l_str.ce_gets (l_str + 1)
							l_c := ((l_str[0]).to_natural_8).to_integer_32
							l_i := l_i + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 13 then -- loop done | if done
						if not js.return_called then
							l_str_size := (l_s.distance (l_begs)).to_natural_32
							l_prec := (a_x___2.item.mp_prec + 1).to_integer_32
							l_ma := 2 + (l_str_size.to_real_64 / ((32).to_double * mp_bases_inst.gmpn_bases[l_base].chars_per_bit_exactly)).truncated_to_integer
							if (builtin_expect ((l_ma.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
								l_tmp___16.ce_gets ((l_aaf.new ((l_ma.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							else
								l_tmp___16.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_ma.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							l_mp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___16))
							l_mn := gmpn_set_str (l_mp, create {CE_POINTER [NATURAL_8]}.make_cast (l_begs), l_str_size, l_base)
							if l_mn = 0 then
								a_x___2.item.mp_size := 0
								a_x___2.item.mp_exp := (0).to_integer_32
								from
								until
									js.loop_left
								loop
									js.reset
									if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
										tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
									end
									js.break
								end
								js.reset
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							l_madj := (0).to_integer_32
							if l_mn > l_prec then
								l_madj := l_mn - l_prec
								l_mp.ce_gets (l_mp + (l_mn - l_prec))
								l_mn := l_prec
							end
							if (l_expptr.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_c := ((l_expptr[0]).to_natural_8).to_integer_32
								l_minus := -(l_c = 45).to_integer
								l_plusminus := (l_minus).bit_or (-(l_c = 43).to_integer)
								l_expptr.ce_gets (l_expptr - l_plusminus)
								l_tmp___19.ce_gets (l_expptr)
								l_expptr.ce_gets (l_expptr + 1)
								l_c := ((l_tmp___19[0]).to_natural_8).to_integer_32
								l_dig___0 := (l_digit_value[l_c]).to_integer_32
								if l_dig___0 >= l_exp_base.to_integer_32 then
									from
									until
										js.loop_left
									loop
										js.reset
										if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
											tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
										end
										js.break
									end
									js.reset
									Result := (-1)
									js.return
								end
								if not js.return_called then
									l_exp_in_base := l_dig___0
									l_tmp___21.ce_gets (l_expptr)
									l_expptr.ce_gets (l_expptr + 1)
									l_c := ((l_tmp___21[0]).to_natural_8).to_integer_32
									l_dig___0 := (l_digit_value[l_c]).to_integer_32
									from
									until
										not (l_dig___0 < l_exp_base.to_integer_32)
									loop
										l_exp_in_base := l_exp_in_base * l_exp_base.to_integer_32
										l_exp_in_base := l_exp_in_base + l_dig___0
										l_tmp___22.ce_gets (l_expptr)
										l_expptr.ce_gets (l_expptr + 1)
										l_c := ((l_tmp___22[0]).to_natural_8).to_integer_32
										l_dig___0 := (l_digit_value[l_c]).to_integer_32
									end
									l_exp_in_base := ((l_exp_in_base).bit_xor (l_minus)) - l_minus
								end
							else
								l_exp_in_base := 0
							end
						end
						if not js.return_called then
							if (l_dotpos.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								l_exp_in_base := l_exp_in_base - (l_s.distance (l_dotpos)).to_integer_32
							end
							l_divflag := (l_exp_in_base < 0).to_integer
							if l_exp_in_base >= 0 then
								l_exp_in_base := l_exp_in_base
							else
								l_exp_in_base := -l_exp_in_base
							end
							if l_exp_in_base = 0 then
								from
								until
									js.loop_left
								loop
									js.reset
									from
									until
										js.loop_left
									loop
										js.reset
										gmp_inst.gmpn_copyi (a_x___2.item.mp_d, l_mp, l_mn)
										js.break
									end
									js.reset
									js.break
								end
								js.reset
								if l_negative.to_boolean then
									a_x___2.item.mp_size := (-l_mn).to_integer_32
								else
									a_x___2.item.mp_size := l_mn.to_integer_32
								end
								a_x___2.item.mp_exp := l_mn + l_madj
								from
								until
									js.loop_left
								loop
									js.reset
									if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
										tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
									end
									js.break
								end
								js.reset
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							l_ra := 2 * (l_prec + 1)
							if (builtin_expect ((l_ra.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
								l_tmp___27.ce_gets ((l_aaf.new ((l_ra.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							else
								l_tmp___27.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_ra.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							l_rp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___27))
							if (builtin_expect ((l_ra.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
								l_tmp___32.ce_gets ((l_aaf.new ((l_ra.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							else
								l_tmp___32.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_ra.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___32))
							l_rn := mpn_pow_1_highpart (l_rp, create {CE_POINTER [INTEGER_32]}.make_shared ($l_radj), l_base.to_natural_32, l_exp_in_base, l_prec, l_tp)
							if l_divflag.to_boolean then
								if l_mn < l_rn then
									if (builtin_expect (((l_rn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
										l_tmp___38.ce_gets ((l_aaf.new (((l_rn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
									else
										l_tmp___38.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_rn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
									end
									l_tmp___34.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___38))
									from
									until
										js.loop_left
									loop
										js.reset
										if l_rn - l_mn /= 0 then
											l_dst.ce_gets (l_tmp___34)
											l_n := l_rn - l_mn
											from
											until
												js.loop_left
											loop
												js.reset
												l_tmp___40.ce_gets (l_dst)
												l_dst.ce_gets (l_dst + 1)
												l_tmp___40.item := (0).to_natural_32
												l_n := l_n - 1
												if not l_n.to_boolean then
													js.break
												end
											end
											js.reset
										end
										js.break
									end
									js.reset
									from
									until
										js.loop_left
									loop
										js.reset
										from
										until
											js.loop_left
										loop
											js.reset
											gmp_inst.gmpn_copyi ((l_tmp___34 + l_rn) - l_mn, l_mp, l_mn)
											js.break
										end
										js.reset
										js.break
									end
									js.reset
									l_mp.ce_gets (l_tmp___34)
									l_madj := l_madj - (l_rn - l_mn)
									l_mn := l_rn
								end
								if ((l_rp[(l_rn - 1)]).bit_and ((({NATURAL_32} 1).bit_shift_left (31)))) = {NATURAL_32} 0 then
									from
									until
										js.loop_left
									loop
										js.reset
										l_cnt := builtin_clzl (l_rp[(l_rn - 1)])
										js.break
									end
									js.reset
									l_cnt := l_cnt
									gmp_inst.gmpn_lshift (l_rp, l_rp, l_rn, l_cnt.to_natural_32).do_nothing
									l_cy := gmp_inst.gmpn_lshift (l_mp, l_mp, l_mn, l_cnt.to_natural_32)
									if l_cy.to_boolean then
										l_tmp___41 := l_mn
										l_mn := l_mn + 1
										l_mp[l_tmp___41] := l_cy
									end
								end
								if (builtin_expect (((l_prec + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
									l_tmp___45.ce_gets ((l_aaf.new (((l_prec + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
								else
									l_tmp___45.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_prec + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
								end
								l_qp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___45))
								l_qlimb := divrem_inst.gmpn_divrem (l_qp, l_prec - (l_mn - l_rn), l_mp, l_mn, l_rp, l_rn)
								l_tp.ce_gets (l_qp)
								l_exp_in_limbs := ((l_qlimb + (l_mn - l_rn).to_natural_32) + (l_madj - l_radj).to_natural_32).to_integer_32
								l_rn := l_prec
								if l_qlimb /= {NATURAL_32} 0 then
									l_tp[l_prec] := l_qlimb
									l_tp.ce_gets (l_tp + 1)
								end
							else
								if (builtin_expect (((l_rn + l_mn).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
									l_tmp___50.ce_gets ((l_aaf.new (((l_rn + l_mn).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
								else
									l_tmp___50.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_rn + l_mn).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
								end
								l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___50))
								if l_rn > l_mn then
									mul_inst.gmpn_mul (l_tp, l_rp, l_rn, l_mp, l_mn).do_nothing
								else
									mul_inst.gmpn_mul (l_tp, l_mp, l_mn, l_rp, l_rn).do_nothing
								end
								l_rn := l_rn + l_mn
								l_rn := l_rn - (l_tp[(l_rn - 1)] = {NATURAL_32} 0).to_integer
								l_exp_in_limbs := (l_rn + l_madj) + l_radj
								if l_rn > l_prec then
									l_tp.ce_gets (l_tp + (l_rn - l_prec))
									l_rn := l_prec
									l_exp_in_limbs := l_exp_in_limbs
								end
							end
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (a_x___2.item.mp_d, l_tp, l_rn)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
							if l_negative.to_boolean then
								a_x___2.item.mp_size := (-l_rn).to_integer_32
							else
								a_x___2.item.mp_size := l_rn.to_integer_32
							end
							a_x___2.item.mp_exp := l_exp_in_limbs
							from
							until
								js.loop_left
							loop
								js.reset
								if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
									tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
								end
								js.break
							end
							js.reset
							Result := 0
						end
				when 14 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gmpz_set_str (a_x___2: CE_POINTER [PD_MPZ_STRUCT]; a_str: CE_POINTER [INTEGER_8]; a_base: INTEGER_32): INTEGER_32
		local
			l_str: CE_POINTER [INTEGER_8]
			l_base: INTEGER_32
			l_str_size: NATURAL_32
			l_s: CE_POINTER [INTEGER_8]
			l_begs: CE_POINTER [INTEGER_8]
			l_i: NATURAL_32
			l_xsize: INTEGER_32
			l_c: INTEGER_32
			l_negative: INTEGER_32
			l_digit_value: CE_POINTER [NATURAL_8]
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: INTEGER_32
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [ANY]
			l_dig: INTEGER_32
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___16: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_str.make
			create l_s.make
			create l_begs.make
			create l_digit_value.make
			create l_tmp_marker.make
			create l_tmp.make
			create l_tmp___1.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___11.make
			create l_tmp___14.make
			create l_tmp___16.make

			l_str.ce_gets (a_str)
			l_base := a_base
			l_digit_value.ce_gets (mp_dv_tab_inst.gmp_digit_value_tab)
			if l_base > 36 then
				l_digit_value.ce_gets (l_digit_value + (224))
				if l_base > 62 then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					l_tmp.ce_gets (l_str)
					l_str.ce_gets (l_str + 1)
					l_c := ((l_tmp[0]).to_natural_8).to_integer_32
					if not ((((ctype_b_loc).item[l_c]).to_integer_32).bit_and (8192)).to_boolean then
						js.break
					end
				end
				js.reset
				l_negative := 0
				if l_c = 45 then
					l_negative := 1
					l_tmp___1.ce_gets (l_str)
					l_str.ce_gets (l_str + 1)
					l_c := ((l_tmp___1[0]).to_natural_8).to_integer_32
				end
				if l_base = 0 then
					l_tmp___2 := 10
				else
					l_tmp___2 := l_base
				end
				if (l_digit_value[l_c]).to_integer_32 >= l_tmp___2 then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				if l_base = 0 then
					l_base := 10
					if l_c = 48 then
						l_base := 8
						l_tmp___3.ce_gets (l_str)
						l_str.ce_gets (l_str + 1)
						l_c := ((l_tmp___3[0]).to_natural_8).to_integer_32
						if l_c = 120 then
							l_base := 16
							l_tmp___4.ce_gets (l_str)
							l_str.ce_gets (l_str + 1)
							l_c := ((l_tmp___4[0]).to_natural_8).to_integer_32
						elseif l_c = 88 then
							l_base := 16
							l_tmp___4.ce_gets (l_str)
							l_str.ce_gets (l_str + 1)
							l_c := ((l_tmp___4[0]).to_natural_8).to_integer_32
						elseif l_c = 98 then
							l_base := 2
							l_tmp___5.ce_gets (l_str)
							l_str.ce_gets (l_str + 1)
							l_c := ((l_tmp___5[0]).to_natural_8).to_integer_32
						elseif l_c = 66 then
							l_base := 2
							l_tmp___5.ce_gets (l_str)
							l_str.ce_gets (l_str + 1)
							l_c := ((l_tmp___5[0]).to_natural_8).to_integer_32
						end
					end
				end
				from
				until
					js.loop_left
				loop
					js.reset
					if l_c /= 48 then
						if not ((((ctype_b_loc).item[l_c]).to_integer_32).bit_and (8192)).to_boolean then
							js.break
						end
					end
					if not js.loop_jumped then
						l_tmp___6.ce_gets (l_str)
						l_str.ce_gets (l_str + 1)
						l_c := ((l_tmp___6[0]).to_natural_8).to_integer_32
					end
				end
				js.reset
				if l_c = 0 then
					a_x___2.item.mp_size := 0
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
				l_str_size := strlen (l_str - 1)
				if (builtin_expect ((l_str_size + {NATURAL_32} 1 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
					l_tmp___11.ce_gets ((l_aaf.new (l_str_size + {NATURAL_32} 1)))
				else
					l_tmp___11.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, l_str_size + {NATURAL_32} 1)))
				end
				l_begs.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp___11))
				l_s.ce_gets (l_begs)
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < l_str_size))
				loop
					if not ((((ctype_b_loc).item[l_c]).to_integer_32).bit_and (8192)).to_boolean then
						l_dig := (l_digit_value[l_c]).to_integer_32
						if l_dig >= l_base then
							from
							until
								js.loop_left
							loop
								js.reset
								if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
									tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
								end
								js.break
							end
							js.reset
							Result := (-1)
							js.return
						end
						if not js.return_called then
							l_tmp___14.ce_gets (l_s)
							l_s.ce_gets (l_s + 1)
							l_tmp___14[0] := l_dig.to_integer_8
						end
					end
					if not js.return_called then
						l_tmp___16.ce_gets (l_str)
						l_str.ce_gets (l_str + 1)
						l_c := ((l_tmp___16[0]).to_natural_8).to_integer_32
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				l_str_size := (l_s.distance (l_begs)).to_natural_32
				l_xsize := 2 + (l_str_size.to_real_64 / ((32).to_double * mp_bases_inst.gmpn_bases[l_base].chars_per_bit_exactly)).truncated_to_integer
				if (builtin_expect ((l_xsize > (a_x___2.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					realloc_inst.gmpz_realloc (a_x___2, l_xsize).do_nothing
				end
				l_xsize := gmpn_set_str (a_x___2.item.mp_d, create {CE_POINTER [NATURAL_8]}.make_cast (l_begs), l_str_size, l_base)
				if l_negative.to_boolean then
					a_x___2.item.mp_size := (-l_xsize).to_integer_32
				else
					a_x___2.item.mp_size := l_xsize.to_integer_32
				end
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
					end
					js.break
				end
				js.reset
				Result := 0
			end
		end

	gmpq_set_str (a_q: CE_POINTER [PD_MPQ_STRUCT]; a_str: CE_POINTER [INTEGER_8]; a_base: INTEGER_32): INTEGER_32
		local
			l_slash: CE_POINTER [INTEGER_8]
			l_num: CE_POINTER [INTEGER_8]
			l_numlen: NATURAL_32
			l_ret: INTEGER_32
			js: JUMP_STATE
		do
			create l_slash.make
			create l_num.make

			l_slash.ce_gets ((strchr (a_str, ('/').code)))
			if (l_slash.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				a_q.item.mp_den.mp_size := 1
				a_q.item.mp_den.mp_d[0] := (1).to_natural_32
				Result := (gmpz_set_str (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_q.c_pointer + {PD_MPQ_STRUCT}.mp_num_offset), a_str, a_base))
				js.return
			end
			if not js.return_called then
				l_numlen := (l_slash.distance (a_str)).to_natural_32
				l_num.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([(l_numlen + {NATURAL_32} 1) * Integer_8_bytes.to_natural_32])))))
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_num), create {CE_POINTER [ANY]}.make_cast (a_str), l_numlen).do_nothing
				l_num[l_numlen.to_integer_32] := (('%/0/').code).to_integer_8
				l_ret := gmpz_set_str (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_q.c_pointer + {PD_MPQ_STRUCT}.mp_num_offset), l_num, a_base)
				memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (l_num), l_numlen + {NATURAL_32} 1])
				if l_ret /= 0 then
					Result := l_ret
					js.return
				end
			end
			if not js.return_called then
				Result := (gmpz_set_str (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_q.c_pointer + {PD_MPQ_STRUCT}.mp_den_offset), l_slash + 1, a_base))
			end
		end

	gmpn_set_str (a_rp: CE_POINTER [NATURAL_32]; a_str: CE_POINTER [NATURAL_8]; a_str_len: NATURAL_32; a_base: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_next_bitpos: INTEGER_32
			l_res_digit: NATURAL_32
			l_size: INTEGER_32
			l_bits_per_indigit: INTEGER_32
			l_inp_digit: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_powtab_mem: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_powtab: CE_ARRAY [PD_POWERS]
			l_chars_per_limb: INTEGER_32
			l_size___0: INTEGER_32
			l_un: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			js: JUMP_STATE
		do
			create l_s.make
			create l_powtab_mem.make
			create l_tp.make
			create l_powtab.make (<<32>>)
			create l_tmp_marker.make

			if ((a_base).bit_and ((a_base - 1))) = 0 then
				l_bits_per_indigit := (mp_bases_inst.gmpn_bases[a_base].big_base).to_integer_32
				l_size := (0).to_integer_32
				l_res_digit := (0).to_natural_32
				l_next_bitpos := 0
				l_s.ce_gets ((a_str + a_str_len.to_integer_32) - 1)
				from
				until
					not ((l_s.c_pointer.to_integer_32).to_natural_32 >= (a_str.c_pointer.to_integer_32).to_natural_32)
				loop
					l_inp_digit := (l_s.item).to_integer_32
					l_res_digit := (l_res_digit).bit_or (((((l_inp_digit.to_natural_32).bit_shift_left (l_next_bitpos))).bit_and ({NATURAL_32} 4294967295)))
					l_next_bitpos := l_next_bitpos + l_bits_per_indigit
					if l_next_bitpos >= 32 then
						l_tmp := l_size
						l_size := l_size + 1
						a_rp[l_tmp] := l_res_digit
						l_next_bitpos := l_next_bitpos - (32)
						l_res_digit := ((l_inp_digit).bit_shift_right ((l_bits_per_indigit - l_next_bitpos))).to_natural_32
					end
					l_s.ce_gets (l_s - 1)
				end
				if l_res_digit /= {NATURAL_32} 0 then
					l_tmp___0 := l_size
					l_size := l_size + 1
					a_rp[l_tmp___0] := l_res_digit
				end
				Result := l_size
				js.return
			end
			if not js.return_called then
				if 983 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if a_str_len >= {NATURAL_32} 983 then
						l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
						l_chars_per_limb := mp_bases_inst.gmpn_bases[a_base].chars_per_limb
						l_un := (a_str_len // l_chars_per_limb.to_natural_32 + {NATURAL_32} 1).to_integer_32
						l_powtab_mem.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_un + 32).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
						gmpn_set_str_compute_powtab (l_powtab, l_powtab_mem, l_un, a_base)
						l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_un + 32).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
						l_size___0 := gmpn_dc_set_str (a_rp, a_str, a_str_len, create {CE_POINTER [PD_POWERS]}.make_cast (l_powtab), l_tp)
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
							end
							js.break
						end
						js.reset
						Result := l_size___0
					else
						l_tmp___1 := gmpn_bc_set_str (a_rp, a_str, a_str_len, a_base)
						Result := l_tmp___1
					end
				else
					l_tmp___1 := gmpn_bc_set_str (a_rp, a_str, a_str_len, a_base)
					Result := l_tmp___1
				end
			end
		end

	gmpn_set_str_compute_powtab (a_powtab: CE_POINTER [PD_POWERS]; a_powtab_mem: CE_POINTER [NATURAL_32]; a_un: INTEGER_32; a_base: INTEGER_32)
		local
			l_powtab_mem_ptr: CE_POINTER [NATURAL_32]
			l_i: INTEGER_32
			l_pi: INTEGER_32
			l_n: INTEGER_32
			l_p: CE_POINTER [NATURAL_32]
			l_t: CE_POINTER [NATURAL_32]
			l_normalization_steps: NATURAL_32
			l_big_base: NATURAL_32
			l_big_base_inverted: NATURAL_32
			l_chars_per_limb: INTEGER_32
			l_digits_in_base: NATURAL_32
			l_shift: INTEGER_32
			js: JUMP_STATE
		do
			create l_powtab_mem_ptr.make
			create l_p.make
			create l_t.make

			l_powtab_mem_ptr.ce_gets (a_powtab_mem)
			l_chars_per_limb := mp_bases_inst.gmpn_bases[a_base].chars_per_limb
			l_big_base := mp_bases_inst.gmpn_bases[a_base].big_base
			l_big_base_inverted := mp_bases_inst.gmpn_bases[a_base].big_base_inverted
			from
			until
				js.loop_left
			loop
				js.reset
				l_normalization_steps := (builtin_clzl (l_big_base)).to_natural_32
				js.break
			end
			js.reset
			l_p.ce_gets (l_powtab_mem_ptr)
			l_powtab_mem_ptr.ce_gets (l_powtab_mem_ptr + 1)
			l_digits_in_base := l_chars_per_limb.to_natural_32
			l_p[0] := l_big_base
			l_n := (1).to_integer_32
			from
			until
				js.loop_left
			loop
				js.reset
				l_i := (builtin_clzl ((a_un - 1).to_natural_32)).to_integer_32
				js.break
			end
			js.reset
			l_i := 31 - l_i;
			(a_powtab + l_i).item.p := l_p;
			(a_powtab + l_i).item.n := l_n;
			(a_powtab + l_i).item.digits_in_base := l_digits_in_base;
			(a_powtab + l_i).item.base := a_base;
			(a_powtab + l_i).item.shift := (0).to_integer_32
			l_shift := (0).to_integer_32
			l_pi := l_i - 1
			from
			until
				not (not js.loop_left and then (l_pi >= 0))
			loop
				l_t.ce_gets (l_powtab_mem_ptr)
				l_powtab_mem_ptr.ce_gets (l_powtab_mem_ptr + (2 * l_n))
				from
				until
					js.loop_left
				loop
					js.reset
					if not ((l_powtab_mem_ptr.c_pointer.to_integer_32).to_natural_32 < ((a_powtab_mem + (a_un + 32)).c_pointer.to_integer_32).to_natural_32) then
						assert_inst.gmp_assert_fail (ce_string ("set_str.c"), 170, ce_string ("powtab_mem_ptr < powtab_mem + ((un) + 32)"))
					end
					js.break
				end
				js.reset
				sqr_inst.gmpn_sqr (l_t, l_p, l_n)
				l_n := 2 * l_n - 1
				l_n := l_n + (l_t[l_n] /= {NATURAL_32} 0).to_integer
				l_digits_in_base := l_digits_in_base * ({NATURAL_32} 2)
				if (((((a_un - 1)).bit_shift_right (l_pi))).bit_and (2)) = 0 then
					gmp_impl_inst.gmpn_divexact_1 (l_t, l_t, l_n, l_big_base)
					l_n := l_n - (l_t[(l_n - 1)] = {NATURAL_32} 0).to_integer
					l_digits_in_base := l_digits_in_base - l_chars_per_limb.to_natural_32
				end
				l_shift := l_shift * (2)
				from
				until
					js.loop_left
				loop
					js.reset
					if l_t[0] = {NATURAL_32} 0 then
						if ((l_t[1]).bit_and ((((l_big_base).bit_and ((-l_big_base.to_integer_32).to_natural_32)) - {NATURAL_32} 1))) /= {NATURAL_32} 0 then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_t.ce_gets (l_t + 1)
						l_n := l_n - 1
						l_shift := l_shift + 1
					end
				end
				js.reset
				l_p.ce_gets (l_t);
				(a_powtab + l_pi).item.p := l_p;
				(a_powtab + l_pi).item.n := l_n;
				(a_powtab + l_pi).item.digits_in_base := l_digits_in_base;
				(a_powtab + l_pi).item.base := a_base;
				(a_powtab + l_pi).item.shift := l_shift
				l_pi := l_pi - 1
			end
		end

	gmpn_dc_set_str (a_rp: CE_POINTER [NATURAL_32]; a_str: CE_POINTER [NATURAL_8]; a_str_len: NATURAL_32; a_powtab: CE_POINTER [PD_POWERS]; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_str: CE_POINTER [NATURAL_8]
			l_len_lo: NATURAL_32
			l_len_hi: NATURAL_32
			l_cy: NATURAL_32
			l_ln: INTEGER_32
			l_hn: INTEGER_32
			l_n: INTEGER_32
			l_sn: INTEGER_32
			l_tmp: INTEGER_32
			l_dst: CE_POINTER [NATURAL_32]
			l_n2: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_32]
			l_dst___0: CE_POINTER [NATURAL_32]
			l_n___0: INTEGER_32
			l_tmp___2: CE_POINTER [NATURAL_32]
			l_ptr_dummy: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_str.make
			create l_dst.make
			create l_tmp___1.make
			create l_dst___0.make
			create l_tmp___2.make
			create l_ptr_dummy.make

			l_str.ce_gets (a_str)
			l_len_lo := a_powtab.item.digits_in_base
			if a_str_len <= l_len_lo then
				if 587 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if a_str_len >= {NATURAL_32} 587 then
						Result := (gmpn_dc_set_str (a_rp, l_str, a_str_len, a_powtab + 1, a_tp))
						js.return
					else
						l_tmp := gmpn_bc_set_str (a_rp, l_str, a_str_len, a_powtab.item.base)
						Result := l_tmp
						js.return
					end
				else
					l_tmp := gmpn_bc_set_str (a_rp, l_str, a_str_len, a_powtab.item.base)
					Result := l_tmp
					js.return
				end
			end
			if not js.return_called then
				l_len_hi := a_str_len - l_len_lo
				if 587 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_len_hi >= {NATURAL_32} 587 then
						l_hn := gmpn_dc_set_str (a_tp, l_str, l_len_hi, a_powtab + 1, a_rp)
					else
						l_hn := gmpn_bc_set_str (a_tp, l_str, l_len_hi, a_powtab.item.base)
					end
				else
					l_hn := gmpn_bc_set_str (a_tp, l_str, l_len_hi, a_powtab.item.base)
				end
				l_sn := a_powtab.item.shift
				if l_hn = 0 then
					from
					until
						js.loop_left
					loop
						js.reset
						if a_powtab.item.n + l_sn /= 0 then
							l_dst.ce_gets (a_rp)
							l_n2 := (a_powtab.item.n + l_sn)
							from
							until
								js.loop_left
							loop
								js.reset
								l_tmp___1.ce_gets (l_dst)
								l_dst.ce_gets (l_dst + 1)
								l_tmp___1.item := (0).to_natural_32
								l_n2 := l_n2 - 1
								if not l_n2.to_boolean then
									js.break
								end
							end
							js.reset
						end
						js.break
					end
					js.reset
				else
					if a_powtab.item.n > l_hn then
						mul_inst.gmpn_mul (a_rp + l_sn, a_powtab.item.p, a_powtab.item.n, a_tp, l_hn).do_nothing
					else
						mul_inst.gmpn_mul (a_rp + l_sn, a_tp, l_hn, a_powtab.item.p, a_powtab.item.n).do_nothing
					end
					from
					until
						js.loop_left
					loop
						js.reset
						if l_sn /= 0 then
							l_dst___0.ce_gets (a_rp)
							l_n___0 := l_sn
							from
							until
								js.loop_left
							loop
								js.reset
								l_tmp___2.ce_gets (l_dst___0)
								l_dst___0.ce_gets (l_dst___0 + 1)
								l_tmp___2.item := (0).to_natural_32
								l_n___0 := l_n___0 - 1
								if not l_n___0.to_boolean then
									js.break
								end
							end
							js.reset
						end
						js.break
					end
					js.reset
				end
				l_str.ce_gets ((l_str + a_str_len.to_integer_32) - l_len_lo.to_integer_32)
				if 587 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_len_lo >= {NATURAL_32} 587 then
						l_ln := gmpn_dc_set_str (a_tp, l_str, l_len_lo, a_powtab + 1, ((a_tp + a_powtab.item.n) + l_sn) + 1)
					else
						l_ln := gmpn_bc_set_str (a_tp, l_str, l_len_lo, a_powtab.item.base)
					end
				else
					l_ln := gmpn_bc_set_str (a_tp, l_str, l_len_lo, a_powtab.item.base)
				end
				if l_ln /= 0 then
					l_cy := gmp_inst.gmpn_add_n (a_rp, a_rp, a_tp, l_ln)
					from
					until
						js.loop_left
					loop
						js.reset
						asm105 (l_ptr_dummy.address, a_rp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_ln), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
						js.break
					end
					js.reset
				end
				l_n := (l_hn + a_powtab.item.n) + l_sn
				Result := (l_n - (a_rp[(l_n - 1)] = {NATURAL_32} 0).to_integer)
			end
		end

	gmpn_bc_set_str (a_rp: CE_POINTER [NATURAL_32]; a_str: CE_POINTER [NATURAL_8]; a_str_len: NATURAL_32; a_base: INTEGER_32): INTEGER_32
		local
			l_str: CE_POINTER [NATURAL_8]
			l_size: INTEGER_32
			l_i: NATURAL_32
			l_j: INTEGER_32
			l_cy_limb: NATURAL_32
			l_big_base: NATURAL_32
			l_chars_per_limb: INTEGER_32
			l_res_digit: NATURAL_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___3: INTEGER_32
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___8: INTEGER_32
			js: JUMP_STATE
		do
			create l_str.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make

			l_str.ce_gets (a_str)
			l_big_base := mp_bases_inst.gmpn_bases[a_base].big_base
			l_chars_per_limb := mp_bases_inst.gmpn_bases[a_base].chars_per_limb
			l_size := (0).to_integer_32
			l_i := l_chars_per_limb.to_natural_32
			from
			until
				not (not js.loop_left and then (l_i < a_str_len))
			loop
				l_tmp.ce_gets (l_str)
				l_str.ce_gets (l_str + 1)
				l_res_digit := (l_tmp.item).to_natural_32
				if a_base = 10 then
					l_j := 8
					from
					until
						l_j = 0
					loop
						l_tmp___0.ce_gets (l_str)
						l_str.ce_gets (l_str + 1)
						l_res_digit := l_res_digit * {NATURAL_32} 10 + (l_tmp___0.item).to_natural_32
						l_j := l_j - 1
					end
				else
					l_j := (l_chars_per_limb - 1).to_integer_32
					from
					until
						l_j = 0
					loop
						l_tmp___1.ce_gets (l_str)
						l_str.ce_gets (l_str + 1)
						l_res_digit := l_res_digit * a_base.to_natural_32 + (l_tmp___1.item).to_natural_32
						l_j := l_j - 1
					end
				end
				if l_size = 0 then
					if l_res_digit /= {NATURAL_32} 0 then
						a_rp[0] := l_res_digit
						l_size := (1).to_integer_32
					end
				else
					l_cy_limb := gmp_inst.gmpn_mul_1 (a_rp, a_rp, l_size, l_big_base)
					l_cy_limb := l_cy_limb + (gmp_inst.gmpn_add_1 (a_rp, a_rp, l_size, l_res_digit))
					if l_cy_limb /= {NATURAL_32} 0 then
						l_tmp___3 := l_size
						l_size := l_size + 1
						a_rp[l_tmp___3] := l_cy_limb
					end
				end
				l_i := l_i + l_chars_per_limb.to_natural_32
			end
			l_big_base := a_base.to_natural_32
			l_tmp___4.ce_gets (l_str)
			l_str.ce_gets (l_str + 1)
			l_res_digit := (l_tmp___4.item).to_natural_32
			if a_base = 10 then
				l_j := ((a_str_len - (l_i - {NATURAL_32} 9)) - {NATURAL_32} 1).to_integer_32
				from
				until
					not (l_j > 0)
				loop
					l_tmp___5.ce_gets (l_str)
					l_str.ce_gets (l_str + 1)
					l_res_digit := l_res_digit * {NATURAL_32} 10 + (l_tmp___5.item).to_natural_32
					l_big_base := l_big_base * ({NATURAL_32} 10)
					l_j := l_j - 1
				end
			else
				l_j := ((a_str_len - (l_i - l_chars_per_limb.to_natural_32)) - {NATURAL_32} 1).to_integer_32
				from
				until
					not (l_j > 0)
				loop
					l_tmp___6.ce_gets (l_str)
					l_str.ce_gets (l_str + 1)
					l_res_digit := l_res_digit * a_base.to_natural_32 + (l_tmp___6.item).to_natural_32
					l_big_base := l_big_base * a_base.to_natural_32
					l_j := l_j - 1
				end
			end
			if l_size = 0 then
				if l_res_digit /= {NATURAL_32} 0 then
					a_rp[0] := l_res_digit
					l_size := (1).to_integer_32
				end
			else
				l_cy_limb := gmp_inst.gmpn_mul_1 (a_rp, a_rp, l_size, l_big_base)
				l_cy_limb := l_cy_limb + (gmp_inst.gmpn_add_1 (a_rp, a_rp, l_size, l_res_digit))
				if l_cy_limb /= {NATURAL_32} 0 then
					l_tmp___8 := l_size
					l_size := l_size + 1
					a_rp[l_tmp___8] := l_cy_limb
				end
			end
			Result := l_size
		end

end
