class
	P_SIZEINBASE

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_sizeinbase (a_x___2: CE_POINTER [PD_MPZ_STRUCT]; a_base: INTEGER_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_lb_base: INTEGER_32
			l_cnt: INTEGER_32
			l_totbits: NATURAL_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				if a_x___2.item.mp_size >= 0 then
					l_tmp___1 := a_x___2.item.mp_size
				else
					l_tmp___1 := -a_x___2.item.mp_size
				end
				if l_tmp___1 = 0 then
					l_result := (1).to_natural_32
				else
					from
					until
						js.loop_left
					loop
						js.reset
						if a_x___2.item.mp_size >= 0 then
							l_tmp := a_x___2.item.mp_size
						else
							l_tmp := -a_x___2.item.mp_size
						end
						l_cnt := builtin_clzl (a_x___2.item.mp_d[(l_tmp - 1)])
						js.break
					end
					js.reset
					if a_x___2.item.mp_size >= 0 then
						l_tmp___0 := a_x___2.item.mp_size
					else
						l_tmp___0 := -a_x___2.item.mp_size
					end
					l_totbits := l_tmp___0.to_natural_32 * {NATURAL_32} 32 - l_cnt.to_natural_32
					if ((a_base).bit_and ((a_base - 1))) = 0 then
						l_lb_base := (mp_bases_inst.gmpn_bases[a_base].big_base).to_integer_32
						l_result := ((l_totbits + l_lb_base.to_natural_32) - {NATURAL_32} 1) // l_lb_base.to_natural_32
					else
						l_result := (l_totbits.to_real_64 * mp_bases_inst.gmpn_bases[a_base].chars_per_bit_exactly).truncated_to_integer_64.to_natural_32 + {NATURAL_32} 1
					end
				end
				js.break
			end
			js.reset
			Result := l_result
		end

end
