class
	P_TOOM4_SQR

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_toom4_sqr (a_pp: CE_POINTER [NATURAL_32]; a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		local
			l_n: INTEGER_32
			l_s: INTEGER_32
			l_cy: NATURAL_32
			js: JUMP_STATE
		do
			l_n := ((a_an + 3)).bit_shift_right (2)
			l_s := a_an - 3 * l_n
			toom_eval_dgr3_pm2_inst.gmpn_toom_eval_dgr3_pm2 (a_pp, (a_pp + 4 * l_n) + 2, a_ap, l_n, l_s, (a_scratch + 8 * l_n) + 5).do_nothing
			from
			until
				js.loop_left
			loop
				js.reset
				if 101 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n + 1 >= 101 then
						if 154 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 154 then
								gmpn_toom4_sqr (a_scratch, a_pp, l_n + 1, (a_scratch + 8 * l_n) + 5)
							else
								toom3_sqr_inst.gmpn_toom3_sqr (a_scratch, a_pp, l_n + 1, (a_scratch + 8 * l_n) + 5)
							end
						else
							toom3_sqr_inst.gmpn_toom3_sqr (a_scratch, a_pp, l_n + 1, (a_scratch + 8 * l_n) + 5)
						end
					else
						toom2_sqr_inst.gmpn_toom2_sqr (a_scratch, a_pp, l_n + 1, (a_scratch + 8 * l_n) + 5)
					end
				else
					toom2_sqr_inst.gmpn_toom2_sqr (a_scratch, a_pp, l_n + 1, (a_scratch + 8 * l_n) + 5)
				end
				js.break
			end
			js.reset
			from
			until
				js.loop_left
			loop
				js.reset
				if 101 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n + 1 >= 101 then
						if 154 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 154 then
								gmpn_toom4_sqr ((a_scratch + 2 * l_n) + 1, ((a_pp + 4 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
							else
								toom3_sqr_inst.gmpn_toom3_sqr ((a_scratch + 2 * l_n) + 1, ((a_pp + 4 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
							end
						else
							toom3_sqr_inst.gmpn_toom3_sqr ((a_scratch + 2 * l_n) + 1, ((a_pp + 4 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
						end
					else
						toom2_sqr_inst.gmpn_toom2_sqr ((a_scratch + 2 * l_n) + 1, ((a_pp + 4 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
					end
				else
					toom2_sqr_inst.gmpn_toom2_sqr ((a_scratch + 2 * l_n) + 1, ((a_pp + 4 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
				end
				js.break
			end
			js.reset
			l_cy := gmp_inst.gmpn_lshift (a_pp, a_ap, l_n, {NATURAL_32} 1)
			l_cy := l_cy + (gmp_inst.gmpn_add_n (a_pp, a_pp, a_ap + l_n, l_n))
			l_cy := {NATURAL_32} 2 * l_cy + (gmp_inst.gmpn_lshift (a_pp, a_pp, l_n, {NATURAL_32} 1))
			l_cy := l_cy + (gmp_inst.gmpn_add_n (a_pp, a_pp, a_ap + 2 * l_n, l_n))
			l_cy := {NATURAL_32} 2 * l_cy + (gmp_inst.gmpn_lshift (a_pp, a_pp, l_n, {NATURAL_32} 1))
			a_pp[l_n] := l_cy + (gmp_inst.gmpn_add (a_pp, a_pp, l_n, a_ap + 3 * l_n, l_s))
			from
			until
				js.loop_left
			loop
				js.reset
				if 101 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n + 1 >= 101 then
						if 154 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 154 then
								gmpn_toom4_sqr ((a_scratch + 4 * l_n) + 2, a_pp, l_n + 1, (a_scratch + 8 * l_n) + 5)
							else
								toom3_sqr_inst.gmpn_toom3_sqr ((a_scratch + 4 * l_n) + 2, a_pp, l_n + 1, (a_scratch + 8 * l_n) + 5)
							end
						else
							toom3_sqr_inst.gmpn_toom3_sqr ((a_scratch + 4 * l_n) + 2, a_pp, l_n + 1, (a_scratch + 8 * l_n) + 5)
						end
					else
						toom2_sqr_inst.gmpn_toom2_sqr ((a_scratch + 4 * l_n) + 2, a_pp, l_n + 1, (a_scratch + 8 * l_n) + 5)
					end
				else
					toom2_sqr_inst.gmpn_toom2_sqr ((a_scratch + 4 * l_n) + 2, a_pp, l_n + 1, (a_scratch + 8 * l_n) + 5)
				end
				js.break
			end
			js.reset
			toom_eval_dgr3_pm1_inst.gmpn_toom_eval_dgr3_pm1 (a_pp, (a_pp + 4 * l_n) + 2, a_ap, l_n, l_s, (a_scratch + 8 * l_n) + 5).do_nothing
			from
			until
				js.loop_left
			loop
				js.reset
				if 101 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n + 1 >= 101 then
						if 154 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 154 then
								gmpn_toom4_sqr (a_pp + 2 * l_n, a_pp, l_n + 1, (a_scratch + 8 * l_n) + 5)
							else
								toom3_sqr_inst.gmpn_toom3_sqr (a_pp + 2 * l_n, a_pp, l_n + 1, (a_scratch + 8 * l_n) + 5)
							end
						else
							toom3_sqr_inst.gmpn_toom3_sqr (a_pp + 2 * l_n, a_pp, l_n + 1, (a_scratch + 8 * l_n) + 5)
						end
					else
						toom2_sqr_inst.gmpn_toom2_sqr (a_pp + 2 * l_n, a_pp, l_n + 1, (a_scratch + 8 * l_n) + 5)
					end
				else
					toom2_sqr_inst.gmpn_toom2_sqr (a_pp + 2 * l_n, a_pp, l_n + 1, (a_scratch + 8 * l_n) + 5)
				end
				js.break
			end
			js.reset
			from
			until
				js.loop_left
			loop
				js.reset
				if 101 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n + 1 >= 101 then
						if 154 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 154 then
								gmpn_toom4_sqr ((a_scratch + 6 * l_n) + 3, ((a_pp + 4 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
							else
								toom3_sqr_inst.gmpn_toom3_sqr ((a_scratch + 6 * l_n) + 3, ((a_pp + 4 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
							end
						else
							toom3_sqr_inst.gmpn_toom3_sqr ((a_scratch + 6 * l_n) + 3, ((a_pp + 4 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
						end
					else
						toom2_sqr_inst.gmpn_toom2_sqr ((a_scratch + 6 * l_n) + 3, ((a_pp + 4 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
					end
				else
					toom2_sqr_inst.gmpn_toom2_sqr ((a_scratch + 6 * l_n) + 3, ((a_pp + 4 * l_n) + 2), l_n + 1, (a_scratch + 8 * l_n) + 5)
				end
				js.break
			end
			js.reset
			from
			until
				js.loop_left
			loop
				js.reset
				if 101 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n >= 101 then
						if 154 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n >= 154 then
								gmpn_toom4_sqr (a_pp, a_ap, l_n, (a_scratch + 8 * l_n) + 5)
							else
								toom3_sqr_inst.gmpn_toom3_sqr (a_pp, a_ap, l_n, (a_scratch + 8 * l_n) + 5)
							end
						else
							toom3_sqr_inst.gmpn_toom3_sqr (a_pp, a_ap, l_n, (a_scratch + 8 * l_n) + 5)
						end
					else
						toom2_sqr_inst.gmpn_toom2_sqr (a_pp, a_ap, l_n, (a_scratch + 8 * l_n) + 5)
					end
				else
					toom2_sqr_inst.gmpn_toom2_sqr (a_pp, a_ap, l_n, (a_scratch + 8 * l_n) + 5)
				end
				js.break
			end
			js.reset
			from
			until
				js.loop_left
			loop
				js.reset
				if 101 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_s >= 101 then
						if 154 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_s >= 154 then
								gmpn_toom4_sqr (a_pp + 6 * l_n, a_ap + 3 * l_n, l_s, (a_scratch + 8 * l_n) + 5)
							else
								toom3_sqr_inst.gmpn_toom3_sqr (a_pp + 6 * l_n, a_ap + 3 * l_n, l_s, (a_scratch + 8 * l_n) + 5)
							end
						else
							toom3_sqr_inst.gmpn_toom3_sqr (a_pp + 6 * l_n, a_ap + 3 * l_n, l_s, (a_scratch + 8 * l_n) + 5)
						end
					else
						toom2_sqr_inst.gmpn_toom2_sqr (a_pp + 6 * l_n, a_ap + 3 * l_n, l_s, (a_scratch + 8 * l_n) + 5)
					end
				else
					toom2_sqr_inst.gmpn_toom2_sqr (a_pp + 6 * l_n, a_ap + 3 * l_n, l_s, (a_scratch + 8 * l_n) + 5)
				end
				js.break
			end
			js.reset
			toom_interpolate_7pts_inst.gmpn_toom_interpolate_7pts (a_pp, l_n, 0, (a_scratch + 2 * l_n) + 1, (a_scratch + 6 * l_n) + 3, a_scratch, (a_scratch + 4 * l_n) + 2, 2 * l_s, (a_scratch + 8 * l_n) + 5)
		end

end
