class
	P_TOOM6_SQR

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_toom6_sqr (a_pp: CE_POINTER [NATURAL_32]; a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		local
			l_n: INTEGER_32
			l_s: INTEGER_32
			js: JUMP_STATE
		do
			l_n := ({NATURAL_32} 1 + (a_an - 1).to_natural_32 // {NATURAL_32} 6).to_integer_32
			l_s := a_an - 5 * l_n
			toom_eval_pm2rexp_inst.gmpn_toom_eval_pm2rexp ((a_pp + 9 * l_n) + 2, a_pp + 7 * l_n, {NATURAL_32} 5, a_ap, l_n, l_s, {NATURAL_32} 1, a_pp).do_nothing
			from
			until
				js.loop_left
			loop
				js.reset
				toom2_sqr_inst.gmpn_toom2_sqr (a_pp, (a_pp + 7 * l_n), l_n + 1, (a_scratch + 9 * l_n) + 3)
				js.break
			end
			js.reset
			from
			until
				js.loop_left
			loop
				js.reset
				toom2_sqr_inst.gmpn_toom2_sqr (a_scratch, ((a_pp + 9 * l_n) + 2), l_n + 1, (a_scratch + 9 * l_n) + 3)
				js.break
			end
			js.reset
			toom_couple_handling_inst.gmpn_toom_couple_handling (a_scratch, 2 * l_n + 1, a_pp, 0, l_n, 1, 0)
			toom_eval_pm1_inst.gmpn_toom_eval_pm1 ((a_pp + 9 * l_n) + 2, a_pp + 7 * l_n, {NATURAL_32} 5, a_ap, l_n, l_s, a_pp).do_nothing
			from
			until
				js.loop_left
			loop
				js.reset
				toom2_sqr_inst.gmpn_toom2_sqr (a_pp, (a_pp + 7 * l_n), l_n + 1, (a_scratch + 9 * l_n) + 3)
				js.break
			end
			js.reset
			from
			until
				js.loop_left
			loop
				js.reset
				toom2_sqr_inst.gmpn_toom2_sqr ((a_scratch + 3 * l_n) + 1, ((a_pp + 9 * l_n) + 2), l_n + 1, (a_scratch + 9 * l_n) + 3)
				js.break
			end
			js.reset
			toom_couple_handling_inst.gmpn_toom_couple_handling ((a_scratch + 3 * l_n) + 1, 2 * l_n + 1, a_pp, 0, l_n, 0, 0)
			toom_eval_pm2exp_inst.gmpn_toom_eval_pm2exp ((a_pp + 9 * l_n) + 2, a_pp + 7 * l_n, {NATURAL_32} 5, a_ap, l_n, l_s, {NATURAL_32} 2, a_pp).do_nothing
			from
			until
				js.loop_left
			loop
				js.reset
				toom2_sqr_inst.gmpn_toom2_sqr (a_pp, (a_pp + 7 * l_n), l_n + 1, (a_scratch + 9 * l_n) + 3)
				js.break
			end
			js.reset
			from
			until
				js.loop_left
			loop
				js.reset
				toom2_sqr_inst.gmpn_toom2_sqr ((a_scratch + 6 * l_n) + 2, ((a_pp + 9 * l_n) + 2), l_n + 1, (a_scratch + 9 * l_n) + 3)
				js.break
			end
			js.reset
			toom_couple_handling_inst.gmpn_toom_couple_handling ((a_scratch + 6 * l_n) + 2, 2 * l_n + 1, a_pp, 0, l_n, 2, 4)
			toom_eval_pm2rexp_inst.gmpn_toom_eval_pm2rexp ((a_pp + 9 * l_n) + 2, a_pp + 7 * l_n, {NATURAL_32} 5, a_ap, l_n, l_s, {NATURAL_32} 2, a_pp).do_nothing
			from
			until
				js.loop_left
			loop
				js.reset
				toom2_sqr_inst.gmpn_toom2_sqr (a_pp, (a_pp + 7 * l_n), l_n + 1, (a_scratch + 9 * l_n) + 3)
				js.break
			end
			js.reset
			from
			until
				js.loop_left
			loop
				js.reset
				toom2_sqr_inst.gmpn_toom2_sqr (a_pp + 3 * l_n, ((a_pp + 9 * l_n) + 2), l_n + 1, (a_scratch + 9 * l_n) + 3)
				js.break
			end
			js.reset
			toom_couple_handling_inst.gmpn_toom_couple_handling (a_pp + 3 * l_n, 2 * l_n + 1, a_pp, 0, l_n, 2, 0)
			toom_eval_pm2_inst.gmpn_toom_eval_pm2 ((a_pp + 9 * l_n) + 2, a_pp + 7 * l_n, {NATURAL_32} 5, a_ap, l_n, l_s, a_pp).do_nothing
			from
			until
				js.loop_left
			loop
				js.reset
				toom2_sqr_inst.gmpn_toom2_sqr (a_pp, (a_pp + 7 * l_n), l_n + 1, (a_scratch + 9 * l_n) + 3)
				js.break
			end
			js.reset
			from
			until
				js.loop_left
			loop
				js.reset
				toom2_sqr_inst.gmpn_toom2_sqr (a_pp + 7 * l_n, ((a_pp + 9 * l_n) + 2), l_n + 1, (a_scratch + 9 * l_n) + 3)
				js.break
			end
			js.reset
			toom_couple_handling_inst.gmpn_toom_couple_handling (a_pp + 7 * l_n, 2 * l_n + 1, a_pp, 0, l_n, 1, 2)
			from
			until
				js.loop_left
			loop
				js.reset
				toom2_sqr_inst.gmpn_toom2_sqr (a_pp, a_ap, l_n, (a_scratch + 9 * l_n) + 3)
				js.break
			end
			js.reset
			toom_interpolate_12pts_inst.gmpn_toom_interpolate_12pts (a_pp, (a_scratch + 6 * l_n) + 2, (a_scratch + 3 * l_n) + 1, a_scratch, l_n, 2 * l_s, 0, (a_scratch + 9 * l_n) + 3)
		end

end
