class
	P_TOOM_INTERPOLATE_6PTS

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_toom_interpolate_6pts (a_pp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_flags: INTEGER_32; a_w4: CE_POINTER [NATURAL_32]; a_w2: CE_POINTER [NATURAL_32]; a_w1: CE_POINTER [NATURAL_32]; a_w0n: INTEGER_32)
		local
			l_cy: NATURAL_32
			l_cy4: NATURAL_32
			l_cy6: NATURAL_32
			l_embankment: NATURAL_32
			l_tmp___0: NATURAL_32
			l_tmp___2: NATURAL_32
			l_ptr_dummy: CE_POINTER [NATURAL_32]
			l_ptr_dummy___0: CE_POINTER [NATURAL_32]
			l_ptr_dummy___1: CE_POINTER [NATURAL_32]
			l_ptr_dummy___2: CE_POINTER [NATURAL_32]
			l_ptr_dummy___3: CE_POINTER [NATURAL_32]
			l_ptr_dummy___4: CE_POINTER [NATURAL_32]
			l_ptr_dummy___5: CE_POINTER [NATURAL_32]
			l_ptr_dummy___6: CE_POINTER [NATURAL_32]
			l_ptr_dummy___7: CE_POINTER [NATURAL_32]
			l_ptr_dummy___8: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_ptr_dummy.make
			create l_ptr_dummy___0.make
			create l_ptr_dummy___1.make
			create l_ptr_dummy___2.make
			create l_ptr_dummy___3.make
			create l_ptr_dummy___4.make
			create l_ptr_dummy___5.make
			create l_ptr_dummy___6.make
			create l_ptr_dummy___7.make
			create l_ptr_dummy___8.make

			if ((a_flags.to_natural_32).bit_and ({NATURAL_32} 2)).to_boolean then
				gmp_inst.gmpn_add_n (a_w2, a_w1, a_w2, 2 * a_n + 1).do_nothing
			else
				gmp_inst.gmpn_sub_n (a_w2, a_w1, a_w2, 2 * a_n + 1).do_nothing
			end
			gmp_inst.gmpn_rshift (a_w2, a_w2, 2 * a_n + 1, {NATURAL_32} 2).do_nothing
			a_w1[2 * a_n] := a_w1[2 * a_n] - (gmp_inst.gmpn_sub_n (a_w1, a_w1, a_pp, 2 * a_n))
			gmp_inst.gmpn_rshift (a_w1, a_w1, 2 * a_n + 1, {NATURAL_32} 1).do_nothing
			gmp_inst.gmpn_sub_n (a_w1, a_w1, a_w2, 2 * a_n + 1).do_nothing
			gmp_inst.gmpn_rshift (a_w1, a_w1, 2 * a_n + 1, {NATURAL_32} 1).do_nothing
			if ((a_flags.to_natural_32).bit_and ({NATURAL_32} 1)).to_boolean then
				gmp_inst.gmpn_add_n (a_w4, (a_pp + 2 * a_n), a_w4, 2 * a_n + 1).do_nothing
				gmp_inst.gmpn_rshift (a_w4, a_w4, 2 * a_n + 1, {NATURAL_32} 1).do_nothing
			else
				gmp_inst.gmpn_sub_n (a_w4, (a_pp + 2 * a_n), a_w4, 2 * a_n + 1).do_nothing
				gmp_inst.gmpn_rshift (a_w4, a_w4, 2 * a_n + 1, {NATURAL_32} 1).do_nothing
			end
			gmp_inst.gmpn_sub_n (a_w2, a_w2, a_w4, 2 * a_n + 1).do_nothing
			l_tmp___0 := gmp_impl_inst.gmpn_bdiv_dbm1c (a_w2, a_w2, 2 * a_n + 1, {NATURAL_32} 1431655765, (0).to_natural_32)
			gmp_inst.gmpn_sub_n (a_pp + 2 * a_n, (a_pp + 2 * a_n), a_w4, 2 * a_n + 1).do_nothing;
			(a_pp + 2 * a_n)[2 * a_n] := (a_pp + 2 * a_n)[2 * a_n] - (gmp_inst.gmpn_sub_n (a_pp + 2 * a_n, (a_pp + 2 * a_n), a_pp, 2 * a_n))
			gmp_inst.gmpn_sub_n (a_w1, a_w1, (a_pp + 2 * a_n), 2 * a_n + 1).do_nothing
			l_tmp___2 := gmp_impl_inst.gmpn_bdiv_dbm1c (a_w1, a_w1, 2 * a_n + 1, {NATURAL_32} 1431655765, (0).to_natural_32)
			l_cy := gmp_inst.gmpn_add_n (a_pp + a_n, (a_pp + a_n), a_w4, 2 * a_n + 1)
			from
			until
				js.loop_left
			loop
				js.reset
				asm149 (l_ptr_dummy.address, a_pp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
				js.break
			end
			js.reset
			l_cy := gmp_inst.gmpn_lshift (a_w4, (a_pp + 5 * a_n), a_w0n, {NATURAL_32} 2)
			l_cy := l_cy + (gmp_inst.gmpn_sub_n (a_w2, a_w2, a_w4, a_w0n))
			from
			until
				js.loop_left
			loop
				js.reset
				asm150 (l_ptr_dummy___0.address, a_w2.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_w0n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
				js.break
			end
			js.reset
			l_cy := gmp_inst.gmpn_sub_n (a_pp + a_n, (a_pp + a_n), a_w2, a_n)
			from
			until
				js.loop_left
			loop
				js.reset
				asm151 (l_ptr_dummy___1.address, a_pp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
				js.break
			end
			js.reset
			l_cy4 := (a_pp + 2 * a_n)[2 * a_n] + (gmp_inst.gmpn_add_n (a_pp + 3 * a_n, (a_pp + 3 * a_n), a_w2, a_n))
			l_cy := a_w2[2 * a_n] + (gmp_inst.gmpn_add_n (a_pp + 4 * a_n, a_w1, (a_w2 + a_n), a_n))
			from
			until
				js.loop_left
			loop
				js.reset
				asm152 (l_ptr_dummy___2.address, a_w1.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
				js.break
			end
			js.reset
			if (builtin_expect ((a_w0n > a_n).to_integer, 1)).to_boolean then
				l_cy6 := a_w1[2 * a_n] + (gmp_inst.gmpn_add_n (a_pp + 5 * a_n, (a_pp + 5 * a_n), (a_w1 + a_n), a_n))
			else
				l_cy6 := gmp_inst.gmpn_add_n (a_pp + 5 * a_n, (a_pp + 5 * a_n), (a_w1 + a_n), a_w0n)
			end
			l_cy := gmp_inst.gmpn_sub_n (a_pp + 2 * a_n, (a_pp + 2 * a_n), (a_pp + 4 * a_n), a_n + a_w0n)
			l_embankment := (a_pp + 5 * a_n)[(a_w0n - 1)] - {NATURAL_32} 1;
			(a_pp + 5 * a_n)[(a_w0n - 1)] := (1).to_natural_32
			if (builtin_expect ((a_w0n > a_n).to_integer, 1)).to_boolean then
				if (builtin_expect ((l_cy4 > l_cy6).to_integer, 1)).to_boolean then
					from
					until
						js.loop_left
					loop
						js.reset
						asm153 (l_ptr_dummy___3.address, a_pp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy4), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy6))
						js.break
					end
					js.reset
				else
					from
					until
						js.loop_left
					loop
						js.reset
						asm154 (l_ptr_dummy___4.address, a_pp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy6), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy4))
						js.break
					end
					js.reset
				end
				from
				until
					js.loop_left
				loop
					js.reset
					asm155 (l_ptr_dummy___5.address, a_pp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), create {CE_POINTER [INTEGER_32]}.make_shared ($a_w0n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
					js.break
				end
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					asm156 (l_ptr_dummy___6.address, a_pp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy6))
					js.break
				end
				js.reset
			else
				from
				until
					js.loop_left
				loop
					js.reset
					asm157 (l_ptr_dummy___7.address, a_pp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy4))
					js.break
				end
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					asm158 (l_ptr_dummy___8.address, a_pp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), create {CE_POINTER [INTEGER_32]}.make_shared ($a_w0n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy6))
					js.break
				end
				js.reset
			end
			(a_pp + 5 * a_n)[(a_w0n - 1)] := (a_pp + 5 * a_n)[(a_w0n - 1)] + l_embankment
		end

end
