class
	P_TOOM_INTERPOLATE_8PTS

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	DO_mpn_sublsh_n (a_dst: CE_POINTER [NATURAL_32]; a_src: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_s: NATURAL_32; a_ws: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_cy: NATURAL_32
		do
			l_cy := gmp_inst.gmpn_lshift (a_ws, a_src, a_n, a_s)
			Result := (l_cy + (gmp_inst.gmpn_sub_n (a_dst, a_dst, a_ws, a_n)))
		end

	gmpn_toom_interpolate_8pts (a_pp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_r3: CE_POINTER [NATURAL_32]; a_r7: CE_POINTER [NATURAL_32]; a_spt: INTEGER_32; a_ws: CE_POINTER [NATURAL_32])
		local
			l_cy: INTEGER_32
			l_r5: CE_POINTER [NATURAL_32]
			l_r1: CE_POINTER [NATURAL_32]
			l_cy2: NATURAL_32
			l_ptr_dummy: CE_POINTER [NATURAL_32]
			l_ptr_dummy___0: CE_POINTER [NATURAL_32]
			l_ptr_dummy___1: CE_POINTER [NATURAL_32]
			l_cy___0: NATURAL_32
			l_ptr_dummy___2: CE_POINTER [NATURAL_32]
			l_ptr_dummy___3: CE_POINTER [NATURAL_32]
			l_ptr_dummy___4: CE_POINTER [NATURAL_32]
			l_ptr_dummy___5: CE_POINTER [NATURAL_32]
			l_tmp___3: NATURAL_32
			l_ptr_dummy___6: CE_POINTER [NATURAL_32]
			l_ptr_dummy___7: CE_POINTER [NATURAL_32]
			l_ptr_dummy___8: CE_POINTER [NATURAL_32]
			l_ptr_dummy___9: CE_POINTER [NATURAL_32]
			l_ptr_dummy___10: CE_POINTER [NATURAL_32]
			l_ptr_dummy___11: CE_POINTER [NATURAL_32]
			l_ptr_dummy___12: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_r5.make
			create l_r1.make
			create l_ptr_dummy.make
			create l_ptr_dummy___0.make
			create l_ptr_dummy___1.make
			create l_ptr_dummy___2.make
			create l_ptr_dummy___3.make
			create l_ptr_dummy___4.make
			create l_ptr_dummy___5.make
			create l_ptr_dummy___6.make
			create l_ptr_dummy___7.make
			create l_ptr_dummy___8.make
			create l_ptr_dummy___9.make
			create l_ptr_dummy___10.make
			create l_ptr_dummy___11.make
			create l_ptr_dummy___12.make

			l_r5.ce_gets (a_pp + 3 * a_n)
			l_r1.ce_gets (a_pp + 7 * a_n)
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					asm163 (l_ptr_dummy.address, a_r3.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), a_pp.address)
					js.break
				end
				js.reset
				l_cy2 := DO_mpn_sublsh_n (a_r3 + a_n, (a_pp + 1), 2 * a_n - 1, {NATURAL_32} 28, a_ws)
				from
				until
					js.loop_left
				loop
					js.reset
					asm164 (l_ptr_dummy___0.address, a_r3.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy2))
					js.break
				end
				js.reset
				js.break
			end
			js.reset
			l_cy := (DO_mpn_sublsh_n (a_r3, l_r1, a_spt, {NATURAL_32} 12, a_ws)).to_integer_32
			from
			until
				js.loop_left
			loop
				js.reset
				asm165 (l_ptr_dummy___1.address, a_r3.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_spt), create {CE_POINTER [INTEGER_32]}.make_shared ($l_cy))
				js.break
			end
			js.reset
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					asm166 (l_ptr_dummy___2.address, l_r5.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), a_pp.address)
					js.break
				end
				js.reset
				l_cy___0 := DO_mpn_sublsh_n (l_r5 + a_n, (a_pp + 1), 2 * a_n - 1, {NATURAL_32} 30, a_ws)
				from
				until
					js.loop_left
				loop
					js.reset
					asm167 (l_ptr_dummy___3.address, l_r5.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy___0))
					js.break
				end
				js.reset
				js.break
			end
			js.reset
			l_cy := (DO_mpn_sublsh_n (l_r5, l_r1, a_spt, {NATURAL_32} 6, a_ws)).to_integer_32
			from
			until
				js.loop_left
			loop
				js.reset
				asm168 (l_ptr_dummy___4.address, l_r5.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_spt), create {CE_POINTER [INTEGER_32]}.make_shared ($l_cy))
				js.break
			end
			js.reset
			a_r7[3 * a_n] := a_r7[3 * a_n] - (gmp_inst.gmpn_sub_n (a_r7 + a_n, (a_r7 + a_n), a_pp, 2 * a_n))
			l_cy := (gmp_inst.gmpn_sub_n (a_r7, a_r7, l_r1, a_spt)).to_integer_32
			from
			until
				js.loop_left
			loop
				js.reset
				asm169 (l_ptr_dummy___5.address, a_r7.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_spt), create {CE_POINTER [INTEGER_32]}.make_shared ($l_cy))
				js.break
			end
			js.reset
			gmp_inst.gmpn_sub_n (a_r3, a_r3, l_r5, 3 * a_n + 1).do_nothing
			gmp_inst.gmpn_rshift (a_r3, a_r3, 3 * a_n + 1, {NATURAL_32} 2).do_nothing
			gmp_inst.gmpn_sub_n (l_r5, l_r5, a_r7, 3 * a_n + 1).do_nothing
			gmp_inst.gmpn_sub_n (a_r3, a_r3, l_r5, 3 * a_n + 1).do_nothing
			gmp_impl_inst.gmpn_divexact_1 (a_r3, a_r3, 3 * a_n + 1, (45).to_natural_32)
			l_tmp___3 := gmp_impl_inst.gmpn_bdiv_dbm1c (l_r5, l_r5, 3 * a_n + 1, {NATURAL_32} 1431655765, (0).to_natural_32)
			DO_mpn_sublsh_n (l_r5, a_r3, 3 * a_n + 1, {NATURAL_32} 2, a_ws).do_nothing
			l_cy := (gmp_inst.gmpn_add_n (a_pp + a_n, (a_pp + a_n), a_r7, a_n)).to_integer_32
			l_cy := (l_cy.to_natural_32 - (gmp_inst.gmpn_sub_n (a_pp + a_n, (a_pp + a_n), l_r5, a_n))).to_integer_32
			if 0 > l_cy then
				from
				until
					js.loop_left
				loop
					js.reset
					asm170 (l_ptr_dummy___6.address, a_r7.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n))
					js.break
				end
				js.reset
			else
				from
				until
					js.loop_left
				loop
					js.reset
					asm171 (l_ptr_dummy___7.address, a_r7.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), create {CE_POINTER [INTEGER_32]}.make_shared ($l_cy))
					js.break
				end
				js.reset
			end
			l_cy := (gmp_inst.gmpn_sub_n (a_pp + 2 * a_n, (a_r7 + a_n), (l_r5 + a_n), a_n)).to_integer_32
			from
			until
				js.loop_left
			loop
				js.reset
				asm172 (l_ptr_dummy___8.address, a_r7.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), create {CE_POINTER [INTEGER_32]}.make_shared ($l_cy))
				js.break
			end
			js.reset
			l_cy := (gmp_inst.gmpn_add_n (a_pp + 3 * a_n, l_r5, (a_r7 + 2 * a_n), a_n + 1)).to_integer_32
			l_r5[3 * a_n] := l_r5[3 * a_n] + (gmp_inst.gmpn_add_n (l_r5 + 2 * a_n, (l_r5 + 2 * a_n), a_r3, a_n))
			l_cy := (l_cy.to_natural_32 - (gmp_inst.gmpn_sub_n (a_pp + 3 * a_n, (a_pp + 3 * a_n), (l_r5 + 2 * a_n), a_n + 1))).to_integer_32
			if (builtin_expect ((0 > l_cy).to_integer, 0)).to_boolean then
				from
				until
					js.loop_left
				loop
					js.reset
					asm173 (l_ptr_dummy___9.address, l_r5.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n))
					js.break
				end
				js.reset
			else
				from
				until
					js.loop_left
				loop
					js.reset
					asm174 (l_ptr_dummy___10.address, l_r5.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), create {CE_POINTER [INTEGER_32]}.make_shared ($l_cy))
					js.break
				end
				js.reset
			end
			gmp_inst.gmpn_sub_n (a_pp + 4 * a_n, (l_r5 + a_n), (a_r3 + a_n), 2 * a_n + 1).do_nothing
			l_cy := (gmp_inst.gmpn_add_1 (a_pp + 6 * a_n, (a_r3 + a_n), a_n, a_pp[6 * a_n])).to_integer_32
			from
			until
				js.loop_left
			loop
				js.reset
				asm175 (l_ptr_dummy___11.address, a_r3.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), create {CE_POINTER [INTEGER_32]}.make_shared ($l_cy))
				js.break
			end
			js.reset
			l_cy := (a_r3[3 * a_n] + (gmp_inst.gmpn_add_n (a_pp + 7 * a_n, (a_pp + 7 * a_n), (a_r3 + 2 * a_n), a_n))).to_integer_32
			from
			until
				js.loop_left
			loop
				js.reset
				asm176 (l_ptr_dummy___12.address, a_pp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), create {CE_POINTER [INTEGER_32]}.make_shared ($l_cy))
				js.break
			end
			js.reset
		end

end
