class
	P_UI_DIV

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_ui_div (a_r: CE_POINTER [PD_MPF_STRUCT]; a_u: NATURAL_32; a_v: CE_POINTER [PD_MPF_STRUCT])
		local
			l_vp: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_remp: CE_POINTER [NATURAL_32]
			l_new_vp: CE_POINTER [NATURAL_32]
			l_vsize: INTEGER_32
			l_rsize: INTEGER_32
			l_prospective_rsize: INTEGER_32
			l_zeros: INTEGER_32
			l_tsize: INTEGER_32
			l_high_zero: INTEGER_32
			l_sign_quotient: INTEGER_32
			l_prec: INTEGER_32
			l_rexp: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_size: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___20: CE_POINTER [ANY]
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp___22: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_vp.make
			create l_rp.make
			create l_tp.make
			create l_remp.make
			create l_new_vp.make
			create l_tmp_marker.make
			create l_tmp___20.make
			create l_dst.make
			create l_tmp___22.make

			l_vsize := (a_v.item.mp_size).to_integer_32
			l_sign_quotient := l_vsize
			if l_vsize >= 0 then
				l_vsize := l_vsize
			else
				l_vsize := -l_vsize
			end
			l_prec := (a_r.item.mp_prec).to_integer_32
			if (builtin_expect ((l_vsize = 0).to_integer, 0)).to_boolean then
				errno_inst.gmp_divide_by_zero
			end
			if (builtin_expect ((a_u = {NATURAL_32} 0).to_integer, 0)).to_boolean then
				a_r.item.mp_size := 0
				a_r.item.mp_exp := (0).to_integer_32
				js.return
			end
			if not js.return_called then
				l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
				l_rexp := ((1 - a_v.item.mp_exp) + 1)
				l_rp.ce_gets (a_r.item.mp_d)
				l_vp.ce_gets (a_v.item.mp_d)
				l_prospective_rsize := (1 - l_vsize) + 1
				l_rsize := l_prec + 1
				l_zeros := l_rsize - l_prospective_rsize
				l_tsize := 1 + l_zeros
				if (l_rp.c_pointer.to_integer_32).to_natural_32 = (l_vp.c_pointer.to_integer_32).to_natural_32 then
					l_tmp___16 := l_vsize
				else
					l_tmp___16 := (0).to_integer_32
				end
				l_size := (l_vsize + l_tsize) + l_tmp___16
				if (builtin_expect ((l_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
					l_tmp___20.ce_gets ((l_aaf.new ((l_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				else
					l_tmp___20.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				end
				l_remp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___20))
				l_tp.ce_gets (l_remp + l_vsize)
				l_new_vp.ce_gets (l_tp + l_tsize)
				if (l_rp.c_pointer.to_integer_32).to_natural_32 = (l_vp.c_pointer.to_integer_32).to_natural_32 then
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (l_new_vp, l_vp, l_vsize)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
					l_vp.ce_gets (l_new_vp)
				end
				from
				until
					js.loop_left
				loop
					js.reset
					if l_tsize - 1 /= 0 then
						l_dst.ce_gets (l_tp)
						l_n := l_tsize - 1
						from
						until
							js.loop_left
						loop
							js.reset
							l_tmp___22.ce_gets (l_dst)
							l_dst.ce_gets (l_dst + 1)
							l_tmp___22.item := (0).to_natural_32
							l_n := l_n - 1
							if not l_n.to_boolean then
								js.break
							end
						end
						js.reset
					end
					js.break
				end
				js.reset
				l_tp[(l_tsize - 1)] := (a_u).bit_and ({NATURAL_32} 4294967295)
				tdiv_qr_inst.gmpn_tdiv_qr (l_rp, l_remp, (0).to_integer_32, l_tp, l_tsize, l_vp, l_vsize)
				l_high_zero := (l_rp[(l_rsize - 1)] = {NATURAL_32} 0).to_integer
				l_rsize := l_rsize - l_high_zero
				l_rexp := l_rexp - l_high_zero
				if l_sign_quotient >= 0 then
					a_r.item.mp_size := l_rsize.to_integer_32
				else
					a_r.item.mp_size := (-l_rsize).to_integer_32
				end
				a_r.item.mp_exp := l_rexp
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
					end
					js.break
				end
				js.reset
			end
		end

end
