class
	SD_TEMP

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	tempint: INTEGER_32 assign set_tempint
		do
			Result := c_tempint (c_pointer)
		end

	tempptr: CE_POINTER [ANY] assign set_tempptr
		do
			create Result.make_shared (c_tempptr (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_tempint (a_tempint: INTEGER_32)
		do
			c_set_tempint (c_pointer, a_tempint)
		end

	set_tempptr (a_tempptr: CE_POINTER [ANY])
		do
			c_set_tempptr (c_pointer, a_tempptr.c_pointer)
		end

feature {NONE} -- C getters

	c_tempint (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((union __anonunion_temp_1 *)$tmp)->tempint;"
		end

	c_tempptr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((union __anonunion_temp_1 *)$tmp)->tempptr;"
		end

feature {NONE} -- C setters

	c_set_tempint (tmp: POINTER; a_tempint: INTEGER_32)
		external
			"C inline"
		alias
			"((union __anonunion_temp_1 *)$tmp)->tempint = $a_tempint;"
		end

	c_set_tempptr (tmp: POINTER; a_tempptr: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_temp_1 *)$tmp)->tempptr = (void *)$a_tempptr;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(union __anonunion_temp_1);"
		end

end
