class
	PD_AKIMA_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	b: CE_POINTER [REAL_64] assign set_b
		do
			create Result.make_shared (c_b (c_pointer))
		end

	c: CE_POINTER [REAL_64] assign set_c
		do
			create Result.make_shared (c_c (c_pointer))
		end

	d: CE_POINTER [REAL_64] assign set_d
		do
			create Result.make_shared (c_d (c_pointer))
		end

	m: CE_POINTER [REAL_64] assign set_m
		do
			create Result.make_shared (c_m (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_b (a_b: CE_POINTER [REAL_64])
		do
			c_set_b (c_pointer, a_b.c_pointer)
		end

	set_c (a_c: CE_POINTER [REAL_64])
		do
			c_set_c (c_pointer, a_c.c_pointer)
		end

	set_d (a_d: CE_POINTER [REAL_64])
		do
			c_set_d (c_pointer, a_d.c_pointer)
		end

	set_m (a_m: CE_POINTER [REAL_64])
		do
			c_set_m (c_pointer, a_m.c_pointer)
		end

feature {NONE} -- C getters

	c_b (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_akima_state_t_29 *)$tmp)->b;"
		end

	c_c (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_akima_state_t_29 *)$tmp)->c;"
		end

	c_d (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_akima_state_t_29 *)$tmp)->d;"
		end

	c_m (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_akima_state_t_29 *)$tmp)->_m;"
		end

feature {NONE} -- C setters

	c_set_b (tmp: POINTER; a_b: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_akima_state_t_29 *)$tmp)->b = (double *)$a_b;"
		end

	c_set_c (tmp: POINTER; a_c: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_akima_state_t_29 *)$tmp)->c = (double *)$a_c;"
		end

	c_set_d (tmp: POINTER; a_d: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_akima_state_t_29 *)$tmp)->d = (double *)$a_d;"
		end

	c_set_m (tmp: POINTER; a_m: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_akima_state_t_29 *)$tmp)->_m = (double *)$a_m;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_akima_state_t_29);"
		end

end
