class
	PD_BRENT_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	d: REAL_64 assign set_d
		do
			Result := c_d (c_pointer)
		end

	e: REAL_64 assign set_e
		do
			Result := c_e (c_pointer)
		end

	v: REAL_64 assign set_v
		do
			Result := c_v (c_pointer)
		end

	w: REAL_64 assign set_w
		do
			Result := c_w (c_pointer)
		end

	f_v: REAL_64 assign set_f_v
		do
			Result := c_f_v (c_pointer)
		end

	f_w: REAL_64 assign set_f_w
		do
			Result := c_f_w (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_d (a_d: REAL_64)
		do
			c_set_d (c_pointer, a_d)
		end

	set_e (a_e: REAL_64)
		do
			c_set_e (c_pointer, a_e)
		end

	set_v (a_v: REAL_64)
		do
			c_set_v (c_pointer, a_v)
		end

	set_w (a_w: REAL_64)
		do
			c_set_w (c_pointer, a_w)
		end

	set_f_v (a_f_v: REAL_64)
		do
			c_set_f_v (c_pointer, a_f_v)
		end

	set_f_w (a_f_w: REAL_64)
		do
			c_set_f_w (c_pointer, a_f_w)
		end

feature {NONE} -- C getters

	c_d (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_brent_state_t_28 *)$tmp)->d;"
		end

	c_e (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_brent_state_t_28 *)$tmp)->e;"
		end

	c_v (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_brent_state_t_28 *)$tmp)->v;"
		end

	c_w (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_brent_state_t_28 *)$tmp)->w;"
		end

	c_f_v (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_brent_state_t_28 *)$tmp)->f_v;"
		end

	c_f_w (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_brent_state_t_28 *)$tmp)->f_w;"
		end

feature {NONE} -- C setters

	c_set_d (tmp: POINTER; a_d: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_brent_state_t_28 *)$tmp)->d = $a_d;"
		end

	c_set_e (tmp: POINTER; a_e: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_brent_state_t_28 *)$tmp)->e = $a_e;"
		end

	c_set_v (tmp: POINTER; a_v: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_brent_state_t_28 *)$tmp)->v = $a_v;"
		end

	c_set_w (tmp: POINTER; a_w: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_brent_state_t_28 *)$tmp)->w = $a_w;"
		end

	c_set_f_v (tmp: POINTER; a_f_v: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_brent_state_t_28 *)$tmp)->f_v = $a_f_v;"
		end

	c_set_f_w (tmp: POINTER; a_f_w: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_brent_state_t_28 *)$tmp)->f_w = $a_f_w;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_brent_state_t_28);"
		end

end
