class
	PD_BRENT_STATE_T2

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	a: REAL_64 assign set_a
		do
			Result := c_a (c_pointer)
		end

	b: REAL_64 assign set_b
		do
			Result := c_b (c_pointer)
		end

	c: REAL_64 assign set_c
		do
			Result := c_c (c_pointer)
		end

	d: REAL_64 assign set_d
		do
			Result := c_d (c_pointer)
		end

	e: REAL_64 assign set_e
		do
			Result := c_e (c_pointer)
		end

	fa: REAL_64 assign set_fa
		do
			Result := c_fa (c_pointer)
		end

	fb: REAL_64 assign set_fb
		do
			Result := c_fb (c_pointer)
		end

	fc: REAL_64 assign set_fc
		do
			Result := c_fc (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_a (a_a: REAL_64)
		do
			c_set_a (c_pointer, a_a)
		end

	set_b (a_b: REAL_64)
		do
			c_set_b (c_pointer, a_b)
		end

	set_c (a_c: REAL_64)
		do
			c_set_c (c_pointer, a_c)
		end

	set_d (a_d: REAL_64)
		do
			c_set_d (c_pointer, a_d)
		end

	set_e (a_e: REAL_64)
		do
			c_set_e (c_pointer, a_e)
		end

	set_fa (a_fa: REAL_64)
		do
			c_set_fa (c_pointer, a_fa)
		end

	set_fb (a_fb: REAL_64)
		do
			c_set_fb (c_pointer, a_fb)
		end

	set_fc (a_fc: REAL_64)
		do
			c_set_fc (c_pointer, a_fc)
		end

feature {NONE} -- C getters

	c_a (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_brent_state_t_30 *)$tmp)->a;"
		end

	c_b (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_brent_state_t_30 *)$tmp)->b;"
		end

	c_c (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_brent_state_t_30 *)$tmp)->c;"
		end

	c_d (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_brent_state_t_30 *)$tmp)->d;"
		end

	c_e (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_brent_state_t_30 *)$tmp)->e;"
		end

	c_fa (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_brent_state_t_30 *)$tmp)->fa;"
		end

	c_fb (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_brent_state_t_30 *)$tmp)->fb;"
		end

	c_fc (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_brent_state_t_30 *)$tmp)->fc;"
		end

feature {NONE} -- C setters

	c_set_a (tmp: POINTER; a_a: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_brent_state_t_30 *)$tmp)->a = $a_a;"
		end

	c_set_b (tmp: POINTER; a_b: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_brent_state_t_30 *)$tmp)->b = $a_b;"
		end

	c_set_c (tmp: POINTER; a_c: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_brent_state_t_30 *)$tmp)->c = $a_c;"
		end

	c_set_d (tmp: POINTER; a_d: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_brent_state_t_30 *)$tmp)->d = $a_d;"
		end

	c_set_e (tmp: POINTER; a_e: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_brent_state_t_30 *)$tmp)->e = $a_e;"
		end

	c_set_fa (tmp: POINTER; a_fa: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_brent_state_t_30 *)$tmp)->fa = $a_fa;"
		end

	c_set_fb (tmp: POINTER; a_fb: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_brent_state_t_30 *)$tmp)->fb = $a_fb;"
		end

	c_set_fc (tmp: POINTER; a_fc: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_brent_state_t_30 *)$tmp)->fc = $a_fc;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_brent_state_t_30);"
		end

end
