class
	PD_FACT_TABLE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	n: INTEGER_32 assign set_n
		do
			Result := c_n (c_pointer)
		end

	f: REAL_64 assign set_f
		do
			Result := c_f (c_pointer)
		end

	i: INTEGER_32 assign set_i
		do
			Result := c_i (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_n (a_n: INTEGER_32)
		do
			c_set_n (c_pointer, a_n)
		end

	set_f (a_f: REAL_64)
		do
			c_set_f (c_pointer, a_f)
		end

	set_i (a_i: INTEGER_32)
		do
			c_set_i (c_pointer, a_i)
		end

feature {NONE} -- C getters

	c_n (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_fact_table_9 *)$tmp)->n;"
		end

	c_f (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_fact_table_9 *)$tmp)->f;"
		end

	c_i (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_fact_table_9 *)$tmp)->i;"
		end

feature {NONE} -- C setters

	c_set_n (tmp: POINTER; a_n: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_fact_table_9 *)$tmp)->n = $a_n;"
		end

	c_set_f (tmp: POINTER; a_f: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_fact_table_9 *)$tmp)->f = $a_f;"
		end

	c_set_i (tmp: POINTER; a_i: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_fact_table_9 *)$tmp)->i = $a_i;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_fact_table_9);"
		end

end
