class
	PD_GNEWTON_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	phi: REAL_64 assign set_phi
		do
			Result := c_phi (c_pointer)
		end

	x_trial: CE_POINTER [PD_GSL_VECTOR] assign set_x_trial
		do
			create Result.make_shared (c_x_trial (c_pointer))
		end

	d: CE_POINTER [PD_GSL_VECTOR] assign set_d
		do
			create Result.make_shared (c_d (c_pointer))
		end

	lu: CE_POINTER [PD_GSL_MATRIX] assign set_lu
		do
			create Result.make_shared (c_lu (c_pointer))
		end

	permutation: CE_POINTER [PD_GSL_PERMUTATION_STRUCT] assign set_permutation
		do
			create Result.make_shared (c_permutation (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_phi (a_phi: REAL_64)
		do
			c_set_phi (c_pointer, a_phi)
		end

	set_x_trial (a_x_trial: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_x_trial (c_pointer, a_x_trial.c_pointer)
		end

	set_d (a_d: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_d (c_pointer, a_d.c_pointer)
		end

	set_lu (a_lu: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_lu (c_pointer, a_lu.c_pointer)
		end

	set_permutation (a_permutation: CE_POINTER [PD_GSL_PERMUTATION_STRUCT])
		do
			c_set_permutation (c_pointer, a_permutation.c_pointer)
		end

feature {NONE} -- C getters

	c_phi (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gnewton_state_t_118 *)$tmp)->phi;"
		end

	c_x_trial (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gnewton_state_t_118 *)$tmp)->x_trial;"
		end

	c_d (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gnewton_state_t_118 *)$tmp)->d;"
		end

	c_lu (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_gnewton_state_t_118 *)$tmp)->lu;"
		end

	c_permutation (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct gsl_permutation_struct *)((struct __anonstruct_gnewton_state_t_118 *)$tmp)->permutation;"
		end

feature {NONE} -- C setters

	c_set_phi (tmp: POINTER; a_phi: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gnewton_state_t_118 *)$tmp)->phi = $a_phi;"
		end

	c_set_x_trial (tmp: POINTER; a_x_trial: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gnewton_state_t_118 *)$tmp)->x_trial = (gsl_vector *)$a_x_trial;"
		end

	c_set_d (tmp: POINTER; a_d: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gnewton_state_t_118 *)$tmp)->d = (gsl_vector *)$a_d;"
		end

	c_set_lu (tmp: POINTER; a_lu: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gnewton_state_t_118 *)$tmp)->lu = (gsl_matrix *)$a_lu;"
		end

	c_set_permutation (tmp: POINTER; a_permutation: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gnewton_state_t_118 *)$tmp)->permutation = (struct gsl_permutation_struct *)$a_permutation;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gnewton_state_t_118);"
		end

end
