class
	PD_GSL_BLOCK_USHORT_STRUCT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	size: NATURAL_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	data: CE_POINTER [NATURAL_16] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_size (a_size: NATURAL_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_data (a_data: CE_POINTER [NATURAL_16])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

feature {NONE} -- C getters

	c_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct gsl_block_ushort_struct *)$tmp)->size;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned short *)((struct gsl_block_ushort_struct *)$tmp)->data;"
		end

feature {NONE} -- C setters

	c_set_size (tmp: POINTER; a_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct gsl_block_ushort_struct *)$tmp)->size = $a_size;"
		end

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct gsl_block_ushort_struct *)$tmp)->data = (unsigned short *)$a_data;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct gsl_block_ushort_struct);"
		end

end
