class
	PD_GSL_INTEGRATION_WORKSPACE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	limit: NATURAL_32 assign set_limit
		do
			Result := c_limit (c_pointer)
		end

	size: NATURAL_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	nrmax: NATURAL_32 assign set_nrmax
		do
			Result := c_nrmax (c_pointer)
		end

	i: NATURAL_32 assign set_i
		do
			Result := c_i (c_pointer)
		end

	maximum_level: NATURAL_32 assign set_maximum_level
		do
			Result := c_maximum_level (c_pointer)
		end

	alist: CE_POINTER [REAL_64] assign set_alist
		do
			create Result.make_shared (c_alist (c_pointer))
		end

	blist: CE_POINTER [REAL_64] assign set_blist
		do
			create Result.make_shared (c_blist (c_pointer))
		end

	rlist: CE_POINTER [REAL_64] assign set_rlist
		do
			create Result.make_shared (c_rlist (c_pointer))
		end

	elist: CE_POINTER [REAL_64] assign set_elist
		do
			create Result.make_shared (c_elist (c_pointer))
		end

	order: CE_POINTER [NATURAL_32] assign set_order
		do
			create Result.make_shared (c_order (c_pointer))
		end

	level: CE_POINTER [NATURAL_32] assign set_level
		do
			create Result.make_shared (c_level (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_limit (a_limit: NATURAL_32)
		do
			c_set_limit (c_pointer, a_limit)
		end

	set_size (a_size: NATURAL_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_nrmax (a_nrmax: NATURAL_32)
		do
			c_set_nrmax (c_pointer, a_nrmax)
		end

	set_i (a_i: NATURAL_32)
		do
			c_set_i (c_pointer, a_i)
		end

	set_maximum_level (a_maximum_level: NATURAL_32)
		do
			c_set_maximum_level (c_pointer, a_maximum_level)
		end

	set_alist (a_alist: CE_POINTER [REAL_64])
		do
			c_set_alist (c_pointer, a_alist.c_pointer)
		end

	set_blist (a_blist: CE_POINTER [REAL_64])
		do
			c_set_blist (c_pointer, a_blist.c_pointer)
		end

	set_rlist (a_rlist: CE_POINTER [REAL_64])
		do
			c_set_rlist (c_pointer, a_rlist.c_pointer)
		end

	set_elist (a_elist: CE_POINTER [REAL_64])
		do
			c_set_elist (c_pointer, a_elist.c_pointer)
		end

	set_order (a_order: CE_POINTER [NATURAL_32])
		do
			c_set_order (c_pointer, a_order.c_pointer)
		end

	set_level (a_level: CE_POINTER [NATURAL_32])
		do
			c_set_level (c_pointer, a_level.c_pointer)
		end

feature {NONE} -- C getters

	c_limit (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_integration_workspace_26 *)$tmp)->limit;"
		end

	c_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_integration_workspace_26 *)$tmp)->size;"
		end

	c_nrmax (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_integration_workspace_26 *)$tmp)->nrmax;"
		end

	c_i (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_integration_workspace_26 *)$tmp)->i;"
		end

	c_maximum_level (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_integration_workspace_26 *)$tmp)->maximum_level;"
		end

	c_alist (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_integration_workspace_26 *)$tmp)->alist;"
		end

	c_blist (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_integration_workspace_26 *)$tmp)->blist;"
		end

	c_rlist (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_integration_workspace_26 *)$tmp)->rlist;"
		end

	c_elist (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_integration_workspace_26 *)$tmp)->elist;"
		end

	c_order (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned int *)((struct __anonstruct_gsl_integration_workspace_26 *)$tmp)->order;"
		end

	c_level (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned int *)((struct __anonstruct_gsl_integration_workspace_26 *)$tmp)->level;"
		end

feature {NONE} -- C setters

	c_set_limit (tmp: POINTER; a_limit: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_integration_workspace_26 *)$tmp)->limit = $a_limit;"
		end

	c_set_size (tmp: POINTER; a_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_integration_workspace_26 *)$tmp)->size = $a_size;"
		end

	c_set_nrmax (tmp: POINTER; a_nrmax: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_integration_workspace_26 *)$tmp)->nrmax = $a_nrmax;"
		end

	c_set_i (tmp: POINTER; a_i: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_integration_workspace_26 *)$tmp)->i = $a_i;"
		end

	c_set_maximum_level (tmp: POINTER; a_maximum_level: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_integration_workspace_26 *)$tmp)->maximum_level = $a_maximum_level;"
		end

	c_set_alist (tmp: POINTER; a_alist: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_integration_workspace_26 *)$tmp)->alist = (double *)$a_alist;"
		end

	c_set_blist (tmp: POINTER; a_blist: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_integration_workspace_26 *)$tmp)->blist = (double *)$a_blist;"
		end

	c_set_rlist (tmp: POINTER; a_rlist: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_integration_workspace_26 *)$tmp)->rlist = (double *)$a_rlist;"
		end

	c_set_elist (tmp: POINTER; a_elist: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_integration_workspace_26 *)$tmp)->elist = (double *)$a_elist;"
		end

	c_set_order (tmp: POINTER; a_order: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_integration_workspace_26 *)$tmp)->order = (unsigned int *)$a_order;"
		end

	c_set_level (tmp: POINTER; a_level: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_integration_workspace_26 *)$tmp)->level = (unsigned int *)$a_level;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_integration_workspace_26);"
		end

end
