class
	PD_GSL_MATRIX_VIEW

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	matrix: PD_GSL_MATRIX assign set_matrix
		do
			create Result.make_shared (c_matrix (c_pointer))
		end

	matrix_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(struct __anonstruct__gsl_matrix_view_84, matrix);"
		end

feature {ANY} -- Eiffel setters

	set_matrix (a_matrix: PD_GSL_MATRIX)
		do
			matrix.ce_gets (a_matrix)
		end

feature {NONE} -- C getters

	c_matrix (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)&((struct __anonstruct__gsl_matrix_view_84 *)$tmp)->matrix;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct__gsl_matrix_view_84);"
		end

end
