class
	PD_GSL_MIN_FMINIMIZER

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: CE_POINTER [PD_GSL_MIN_FMINIMIZER_TYPE] assign set_type
		do
			create Result.make_shared (c_type (c_pointer))
		end

	function: CE_POINTER [PD_GSL_FUNCTION_STRUCT] assign set_function
		do
			create Result.make_shared (c_function (c_pointer))
		end

	x_minimum: REAL_64 assign set_x_minimum
		do
			Result := c_x_minimum (c_pointer)
		end

	x_minimum_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(struct __anonstruct_gsl_min_fminimizer_27, x_minimum);"
		end

	x_lower: REAL_64 assign set_x_lower
		do
			Result := c_x_lower (c_pointer)
		end

	x_lower_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(struct __anonstruct_gsl_min_fminimizer_27, x_lower);"
		end

	x_upper: REAL_64 assign set_x_upper
		do
			Result := c_x_upper (c_pointer)
		end

	x_upper_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(struct __anonstruct_gsl_min_fminimizer_27, x_upper);"
		end

	f_minimum: REAL_64 assign set_f_minimum
		do
			Result := c_f_minimum (c_pointer)
		end

	f_minimum_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(struct __anonstruct_gsl_min_fminimizer_27, f_minimum);"
		end

	f_lower: REAL_64 assign set_f_lower
		do
			Result := c_f_lower (c_pointer)
		end

	f_lower_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(struct __anonstruct_gsl_min_fminimizer_27, f_lower);"
		end

	f_upper: REAL_64 assign set_f_upper
		do
			Result := c_f_upper (c_pointer)
		end

	f_upper_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(struct __anonstruct_gsl_min_fminimizer_27, f_upper);"
		end

	state: CE_POINTER [ANY] assign set_state
		do
			create Result.make_shared (c_state (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: CE_POINTER [PD_GSL_MIN_FMINIMIZER_TYPE])
		do
			c_set_type (c_pointer, a_type.c_pointer)
		end

	set_function (a_function: CE_POINTER [PD_GSL_FUNCTION_STRUCT])
		do
			c_set_function (c_pointer, a_function.c_pointer)
		end

	set_x_minimum (a_x_minimum: REAL_64)
		do
			c_set_x_minimum (c_pointer, a_x_minimum)
		end

	set_x_lower (a_x_lower: REAL_64)
		do
			c_set_x_lower (c_pointer, a_x_lower)
		end

	set_x_upper (a_x_upper: REAL_64)
		do
			c_set_x_upper (c_pointer, a_x_upper)
		end

	set_f_minimum (a_f_minimum: REAL_64)
		do
			c_set_f_minimum (c_pointer, a_f_minimum)
		end

	set_f_lower (a_f_lower: REAL_64)
		do
			c_set_f_lower (c_pointer, a_f_lower)
		end

	set_f_upper (a_f_upper: REAL_64)
		do
			c_set_f_upper (c_pointer, a_f_upper)
		end

	set_state (a_state: CE_POINTER [ANY])
		do
			c_set_state (c_pointer, a_state.c_pointer)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_min_fminimizer_type *)((struct __anonstruct_gsl_min_fminimizer_27 *)$tmp)->type;"
		end

	c_function (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct gsl_function_struct *)((struct __anonstruct_gsl_min_fminimizer_27 *)$tmp)->function;"
		end

	c_x_minimum (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_min_fminimizer_27 *)$tmp)->x_minimum;"
		end

	c_x_lower (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_min_fminimizer_27 *)$tmp)->x_lower;"
		end

	c_x_upper (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_min_fminimizer_27 *)$tmp)->x_upper;"
		end

	c_f_minimum (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_min_fminimizer_27 *)$tmp)->f_minimum;"
		end

	c_f_lower (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_min_fminimizer_27 *)$tmp)->f_lower;"
		end

	c_f_upper (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_min_fminimizer_27 *)$tmp)->f_upper;"
		end

	c_state (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_gsl_min_fminimizer_27 *)$tmp)->state;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_min_fminimizer_27 *)$tmp)->type = (gsl_min_fminimizer_type *)$a_type;"
		end

	c_set_function (tmp: POINTER; a_function: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_min_fminimizer_27 *)$tmp)->function = (struct gsl_function_struct *)$a_function;"
		end

	c_set_x_minimum (tmp: POINTER; a_x_minimum: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_min_fminimizer_27 *)$tmp)->x_minimum = $a_x_minimum;"
		end

	c_set_x_lower (tmp: POINTER; a_x_lower: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_min_fminimizer_27 *)$tmp)->x_lower = $a_x_lower;"
		end

	c_set_x_upper (tmp: POINTER; a_x_upper: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_min_fminimizer_27 *)$tmp)->x_upper = $a_x_upper;"
		end

	c_set_f_minimum (tmp: POINTER; a_f_minimum: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_min_fminimizer_27 *)$tmp)->f_minimum = $a_f_minimum;"
		end

	c_set_f_lower (tmp: POINTER; a_f_lower: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_min_fminimizer_27 *)$tmp)->f_lower = $a_f_lower;"
		end

	c_set_f_upper (tmp: POINTER; a_f_upper: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_min_fminimizer_27 *)$tmp)->f_upper = $a_f_upper;"
		end

	c_set_state (tmp: POINTER; a_state: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_min_fminimizer_27 *)$tmp)->state = (void *)$a_state;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_min_fminimizer_27);"
		end

end
