class
	PD_GSL_MONTE_PLAIN_STATE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	dim: NATURAL_32 assign set_dim
		do
			Result := c_dim (c_pointer)
		end

	x: CE_POINTER [REAL_64] assign set_x
		do
			create Result.make_shared (c_x (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_dim (a_dim: NATURAL_32)
		do
			c_set_dim (c_pointer, a_dim)
		end

	set_x (a_x: CE_POINTER [REAL_64])
		do
			c_set_x (c_pointer, a_x.c_pointer)
		end

feature {NONE} -- C getters

	c_dim (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_monte_plain_state_28 *)$tmp)->dim;"
		end

	c_x (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_monte_plain_state_28 *)$tmp)->x;"
		end

feature {NONE} -- C setters

	c_set_dim (tmp: POINTER; a_dim: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_plain_state_28 *)$tmp)->dim = $a_dim;"
		end

	c_set_x (tmp: POINTER; a_x: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_plain_state_28 *)$tmp)->x = (double *)$a_x;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_monte_plain_state_28);"
		end

end
