class
	PD_GSL_MULTIFIT_FSOLVER

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: CE_POINTER [PD_GSL_MULTIFIT_FSOLVER_TYPE] assign set_type
		do
			create Result.make_shared (c_type (c_pointer))
		end

	function: CE_POINTER [PD_GSL_MULTIFIT_FUNCTION_STRUCT] assign set_function
		do
			create Result.make_shared (c_function (c_pointer))
		end

	x: CE_POINTER [PD_GSL_VECTOR] assign set_x
		do
			create Result.make_shared (c_x (c_pointer))
		end

	f: CE_POINTER [PD_GSL_VECTOR] assign set_f
		do
			create Result.make_shared (c_f (c_pointer))
		end

	dx: CE_POINTER [PD_GSL_VECTOR] assign set_dx
		do
			create Result.make_shared (c_dx (c_pointer))
		end

	state: CE_POINTER [ANY] assign set_state
		do
			create Result.make_shared (c_state (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: CE_POINTER [PD_GSL_MULTIFIT_FSOLVER_TYPE])
		do
			c_set_type (c_pointer, a_type.c_pointer)
		end

	set_function (a_function: CE_POINTER [PD_GSL_MULTIFIT_FUNCTION_STRUCT])
		do
			c_set_function (c_pointer, a_function.c_pointer)
		end

	set_x (a_x: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_x (c_pointer, a_x.c_pointer)
		end

	set_f (a_f: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_f (c_pointer, a_f.c_pointer)
		end

	set_dx (a_dx: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_dx (c_pointer, a_dx.c_pointer)
		end

	set_state (a_state: CE_POINTER [ANY])
		do
			c_set_state (c_pointer, a_state.c_pointer)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_multifit_fsolver_type *)((struct __anonstruct_gsl_multifit_fsolver_114 *)$tmp)->type;"
		end

	c_function (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct gsl_multifit_function_struct *)((struct __anonstruct_gsl_multifit_fsolver_114 *)$tmp)->function;"
		end

	c_x (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_multifit_fsolver_114 *)$tmp)->x;"
		end

	c_f (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_multifit_fsolver_114 *)$tmp)->f;"
		end

	c_dx (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_multifit_fsolver_114 *)$tmp)->dx;"
		end

	c_state (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_gsl_multifit_fsolver_114 *)$tmp)->state;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multifit_fsolver_114 *)$tmp)->type = (gsl_multifit_fsolver_type *)$a_type;"
		end

	c_set_function (tmp: POINTER; a_function: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multifit_fsolver_114 *)$tmp)->function = (struct gsl_multifit_function_struct *)$a_function;"
		end

	c_set_x (tmp: POINTER; a_x: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multifit_fsolver_114 *)$tmp)->x = (gsl_vector *)$a_x;"
		end

	c_set_f (tmp: POINTER; a_f: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multifit_fsolver_114 *)$tmp)->f = (gsl_vector *)$a_f;"
		end

	c_set_dx (tmp: POINTER; a_dx: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multifit_fsolver_114 *)$tmp)->dx = (gsl_vector *)$a_dx;"
		end

	c_set_state (tmp: POINTER; a_state: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multifit_fsolver_114 *)$tmp)->state = (void *)$a_state;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_multifit_fsolver_114);"
		end

end
