class
	PD_GSL_MULTIMIN_FDFMINIMIZER

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER_TYPE] assign set_type
		do
			create Result.make_shared (c_type (c_pointer))
		end

	fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT] assign set_fdf
		do
			create Result.make_shared (c_fdf (c_pointer))
		end

	f: REAL_64 assign set_f
		do
			Result := c_f (c_pointer)
		end

	f_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(struct __anonstruct_gsl_multimin_fdfminimizer_118, f);"
		end

	x: CE_POINTER [PD_GSL_VECTOR] assign set_x
		do
			create Result.make_shared (c_x (c_pointer))
		end

	gradient: CE_POINTER [PD_GSL_VECTOR] assign set_gradient
		do
			create Result.make_shared (c_gradient (c_pointer))
		end

	dx: CE_POINTER [PD_GSL_VECTOR] assign set_dx
		do
			create Result.make_shared (c_dx (c_pointer))
		end

	state: CE_POINTER [ANY] assign set_state
		do
			create Result.make_shared (c_state (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER_TYPE])
		do
			c_set_type (c_pointer, a_type.c_pointer)
		end

	set_fdf (a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT])
		do
			c_set_fdf (c_pointer, a_fdf.c_pointer)
		end

	set_f (a_f: REAL_64)
		do
			c_set_f (c_pointer, a_f)
		end

	set_x (a_x: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_x (c_pointer, a_x.c_pointer)
		end

	set_gradient (a_gradient: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_gradient (c_pointer, a_gradient.c_pointer)
		end

	set_dx (a_dx: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_dx (c_pointer, a_dx.c_pointer)
		end

	set_state (a_state: CE_POINTER [ANY])
		do
			c_set_state (c_pointer, a_state.c_pointer)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_multimin_fdfminimizer_type *)((struct __anonstruct_gsl_multimin_fdfminimizer_118 *)$tmp)->type;"
		end

	c_fdf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct gsl_multimin_function_fdf_struct *)((struct __anonstruct_gsl_multimin_fdfminimizer_118 *)$tmp)->fdf;"
		end

	c_f (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_multimin_fdfminimizer_118 *)$tmp)->f;"
		end

	c_x (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_multimin_fdfminimizer_118 *)$tmp)->x;"
		end

	c_gradient (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_multimin_fdfminimizer_118 *)$tmp)->gradient;"
		end

	c_dx (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_multimin_fdfminimizer_118 *)$tmp)->dx;"
		end

	c_state (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_gsl_multimin_fdfminimizer_118 *)$tmp)->state;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multimin_fdfminimizer_118 *)$tmp)->type = (gsl_multimin_fdfminimizer_type *)$a_type;"
		end

	c_set_fdf (tmp: POINTER; a_fdf: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multimin_fdfminimizer_118 *)$tmp)->fdf = (struct gsl_multimin_function_fdf_struct *)$a_fdf;"
		end

	c_set_f (tmp: POINTER; a_f: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multimin_fdfminimizer_118 *)$tmp)->f = $a_f;"
		end

	c_set_x (tmp: POINTER; a_x: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multimin_fdfminimizer_118 *)$tmp)->x = (gsl_vector *)$a_x;"
		end

	c_set_gradient (tmp: POINTER; a_gradient: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multimin_fdfminimizer_118 *)$tmp)->gradient = (gsl_vector *)$a_gradient;"
		end

	c_set_dx (tmp: POINTER; a_dx: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multimin_fdfminimizer_118 *)$tmp)->dx = (gsl_vector *)$a_dx;"
		end

	c_set_state (tmp: POINTER; a_state: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multimin_fdfminimizer_118 *)$tmp)->state = (void *)$a_state;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_multimin_fdfminimizer_118);"
		end

end
