class
	PD_GSL_MULTIMIN_FMINIMIZER

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: CE_POINTER [PD_GSL_MULTIMIN_FMINIMIZER_TYPE] assign set_type
		do
			create Result.make_shared (c_type (c_pointer))
		end

	f: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_STRUCT] assign set_f
		do
			create Result.make_shared (c_f (c_pointer))
		end

	fval: REAL_64 assign set_fval
		do
			Result := c_fval (c_pointer)
		end

	fval_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(struct __anonstruct_gsl_multimin_fminimizer_116, fval);"
		end

	x: CE_POINTER [PD_GSL_VECTOR] assign set_x
		do
			create Result.make_shared (c_x (c_pointer))
		end

	size: REAL_64 assign set_size
		do
			Result := c_size (c_pointer)
		end

	size_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(struct __anonstruct_gsl_multimin_fminimizer_116, size);"
		end

	state: CE_POINTER [ANY] assign set_state
		do
			create Result.make_shared (c_state (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: CE_POINTER [PD_GSL_MULTIMIN_FMINIMIZER_TYPE])
		do
			c_set_type (c_pointer, a_type.c_pointer)
		end

	set_f (a_f: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_STRUCT])
		do
			c_set_f (c_pointer, a_f.c_pointer)
		end

	set_fval (a_fval: REAL_64)
		do
			c_set_fval (c_pointer, a_fval)
		end

	set_x (a_x: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_x (c_pointer, a_x.c_pointer)
		end

	set_size (a_size: REAL_64)
		do
			c_set_size (c_pointer, a_size)
		end

	set_state (a_state: CE_POINTER [ANY])
		do
			c_set_state (c_pointer, a_state.c_pointer)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_multimin_fminimizer_type *)((struct __anonstruct_gsl_multimin_fminimizer_116 *)$tmp)->type;"
		end

	c_f (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct gsl_multimin_function_struct *)((struct __anonstruct_gsl_multimin_fminimizer_116 *)$tmp)->f;"
		end

	c_fval (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_multimin_fminimizer_116 *)$tmp)->fval;"
		end

	c_x (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_multimin_fminimizer_116 *)$tmp)->x;"
		end

	c_size (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_multimin_fminimizer_116 *)$tmp)->size;"
		end

	c_state (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_gsl_multimin_fminimizer_116 *)$tmp)->state;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multimin_fminimizer_116 *)$tmp)->type = (gsl_multimin_fminimizer_type *)$a_type;"
		end

	c_set_f (tmp: POINTER; a_f: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multimin_fminimizer_116 *)$tmp)->f = (struct gsl_multimin_function_struct *)$a_f;"
		end

	c_set_fval (tmp: POINTER; a_fval: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multimin_fminimizer_116 *)$tmp)->fval = $a_fval;"
		end

	c_set_x (tmp: POINTER; a_x: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multimin_fminimizer_116 *)$tmp)->x = (gsl_vector *)$a_x;"
		end

	c_set_size (tmp: POINTER; a_size: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multimin_fminimizer_116 *)$tmp)->size = $a_size;"
		end

	c_set_state (tmp: POINTER; a_state: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multimin_fminimizer_116 *)$tmp)->state = (void *)$a_state;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_multimin_fminimizer_116);"
		end

end
