class
	PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	f: CE_ROUTINE assign set_f
		do
			create Result.make_shared (c_f (c_pointer))
		end

	df: CE_ROUTINE assign set_df
		do
			create Result.make_shared (c_df (c_pointer))
		end

	fdf: CE_ROUTINE assign set_fdf
		do
			create Result.make_shared (c_fdf (c_pointer))
		end

	n: NATURAL_32 assign set_n
		do
			Result := c_n (c_pointer)
		end

	params: CE_POINTER [ANY] assign set_params
		do
			create Result.make_shared (c_params (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_f (a_f: CE_ROUTINE)
		do
			c_set_f (c_pointer, a_f.c_pointer)
		end

	set_df (a_df: CE_ROUTINE)
		do
			c_set_df (c_pointer, a_df.c_pointer)
		end

	set_fdf (a_fdf: CE_ROUTINE)
		do
			c_set_fdf (c_pointer, a_fdf.c_pointer)
		end

	set_n (a_n: NATURAL_32)
		do
			c_set_n (c_pointer, a_n)
		end

	set_params (a_params: CE_POINTER [ANY])
		do
			c_set_params (c_pointer, a_params.c_pointer)
		end

feature {NONE} -- C getters

	c_f (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(gsl_vector * x, void * params, gsl_vector * f))((struct gsl_multiroot_function_fdf_struct *)$tmp)->f;"
		end

	c_df (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(gsl_vector * x, void * params, gsl_matrix * df))((struct gsl_multiroot_function_fdf_struct *)$tmp)->df;"
		end

	c_fdf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(gsl_vector * x, void * params, gsl_vector * f, gsl_matrix * df))((struct gsl_multiroot_function_fdf_struct *)$tmp)->fdf;"
		end

	c_n (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct gsl_multiroot_function_fdf_struct *)$tmp)->n;"
		end

	c_params (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct gsl_multiroot_function_fdf_struct *)$tmp)->params;"
		end

feature {NONE} -- C setters

	c_set_f (tmp: POINTER; a_f: POINTER)
		external
			"C inline"
		alias
			"((struct gsl_multiroot_function_fdf_struct *)$tmp)->f = (int( *)(gsl_vector * x, void * params, gsl_vector * f))$a_f;"
		end

	c_set_df (tmp: POINTER; a_df: POINTER)
		external
			"C inline"
		alias
			"((struct gsl_multiroot_function_fdf_struct *)$tmp)->df = (int( *)(gsl_vector * x, void * params, gsl_matrix * df))$a_df;"
		end

	c_set_fdf (tmp: POINTER; a_fdf: POINTER)
		external
			"C inline"
		alias
			"((struct gsl_multiroot_function_fdf_struct *)$tmp)->fdf = (int( *)(gsl_vector * x, void * params, gsl_vector * f, gsl_matrix * df))$a_fdf;"
		end

	c_set_n (tmp: POINTER; a_n: NATURAL_32)
		external
			"C inline"
		alias
			"((struct gsl_multiroot_function_fdf_struct *)$tmp)->n = $a_n;"
		end

	c_set_params (tmp: POINTER; a_params: POINTER)
		external
			"C inline"
		alias
			"((struct gsl_multiroot_function_fdf_struct *)$tmp)->params = (void *)$a_params;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct gsl_multiroot_function_fdf_struct);"
		end

end
