class
	PD_GSL_NTUPLE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	file: CE_POINTER [SD_IO_FILE] assign set_file
		do
			create Result.make_shared (c_file (c_pointer))
		end

	ntuple_data: CE_POINTER [ANY] assign set_ntuple_data
		do
			create Result.make_shared (c_ntuple_data (c_pointer))
		end

	size: NATURAL_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_file (a_file: CE_POINTER [SD_IO_FILE])
		do
			c_set_file (c_pointer, a_file.c_pointer)
		end

	set_ntuple_data (a_ntuple_data: CE_POINTER [ANY])
		do
			c_set_ntuple_data (c_pointer, a_ntuple_data.c_pointer)
		end

	set_size (a_size: NATURAL_32)
		do
			c_set_size (c_pointer, a_size)
		end

feature {NONE} -- C getters

	c_file (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _IO_FILE *)((struct __anonstruct_gsl_ntuple_26 *)$tmp)->file;"
		end

	c_ntuple_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_gsl_ntuple_26 *)$tmp)->ntuple_data;"
		end

	c_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_ntuple_26 *)$tmp)->size;"
		end

feature {NONE} -- C setters

	c_set_file (tmp: POINTER; a_file: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_ntuple_26 *)$tmp)->file = (struct _IO_FILE *)$a_file;"
		end

	c_set_ntuple_data (tmp: POINTER; a_ntuple_data: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_ntuple_26 *)$tmp)->ntuple_data = (void *)$a_ntuple_data;"
		end

	c_set_size (tmp: POINTER; a_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_ntuple_26 *)$tmp)->size = $a_size;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_ntuple_26);"
		end

end
