class
	PD_GSL_POLY_COMPLEX_WORKSPACE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	nc: NATURAL_32 assign set_nc
		do
			Result := c_nc (c_pointer)
		end

	matrix: CE_POINTER [REAL_64] assign set_matrix
		do
			create Result.make_shared (c_matrix (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_nc (a_nc: NATURAL_32)
		do
			c_set_nc (c_pointer, a_nc)
		end

	set_matrix (a_matrix: CE_POINTER [REAL_64])
		do
			c_set_matrix (c_pointer, a_matrix.c_pointer)
		end

feature {NONE} -- C getters

	c_nc (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_poly_complex_workspace_24 *)$tmp)->nc;"
		end

	c_matrix (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_poly_complex_workspace_24 *)$tmp)->matrix;"
		end

feature {NONE} -- C setters

	c_set_nc (tmp: POINTER; a_nc: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_poly_complex_workspace_24 *)$tmp)->nc = $a_nc;"
		end

	c_set_matrix (tmp: POINTER; a_matrix: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_poly_complex_workspace_24 *)$tmp)->matrix = (double *)$a_matrix;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_poly_complex_workspace_24);"
		end

end
