class
	PD_GSL_SF_RESULT_E10_STRUCT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	val: REAL_64 assign set_val
		do
			Result := c_val (c_pointer)
		end

	err: REAL_64 assign set_err
		do
			Result := c_err (c_pointer)
		end

	e10: INTEGER_32 assign set_e10
		do
			Result := c_e10 (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_val (a_val: REAL_64)
		do
			c_set_val (c_pointer, a_val)
		end

	set_err (a_err: REAL_64)
		do
			c_set_err (c_pointer, a_err)
		end

	set_e10 (a_e10: INTEGER_32)
		do
			c_set_e10 (c_pointer, a_e10)
		end

feature {NONE} -- C getters

	c_val (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct gsl_sf_result_e10_struct *)$tmp)->val;"
		end

	c_err (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct gsl_sf_result_e10_struct *)$tmp)->err;"
		end

	c_e10 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct gsl_sf_result_e10_struct *)$tmp)->e10;"
		end

feature {NONE} -- C setters

	c_set_val (tmp: POINTER; a_val: REAL_64)
		external
			"C inline"
		alias
			"((struct gsl_sf_result_e10_struct *)$tmp)->val = $a_val;"
		end

	c_set_err (tmp: POINTER; a_err: REAL_64)
		external
			"C inline"
		alias
			"((struct gsl_sf_result_e10_struct *)$tmp)->err = $a_err;"
		end

	c_set_e10 (tmp: POINTER; a_e10: INTEGER_32)
		external
			"C inline"
		alias
			"((struct gsl_sf_result_e10_struct *)$tmp)->e10 = $a_e10;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct gsl_sf_result_e10_struct);"
		end

end
