class
	PD_GSL_SF_RESULT_STRUCT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	val: REAL_64 assign set_val
		do
			Result := c_val (c_pointer)
		end

	val_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(struct gsl_sf_result_struct, val);"
		end

	err: REAL_64 assign set_err
		do
			Result := c_err (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_val (a_val: REAL_64)
		do
			c_set_val (c_pointer, a_val)
		end

	set_err (a_err: REAL_64)
		do
			c_set_err (c_pointer, a_err)
		end

feature {NONE} -- C getters

	c_val (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct gsl_sf_result_struct *)$tmp)->val;"
		end

	c_err (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct gsl_sf_result_struct *)$tmp)->err;"
		end

feature {NONE} -- C setters

	c_set_val (tmp: POINTER; a_val: REAL_64)
		external
			"C inline"
		alias
			"((struct gsl_sf_result_struct *)$tmp)->val = $a_val;"
		end

	c_set_err (tmp: POINTER; a_err: REAL_64)
		external
			"C inline"
		alias
			"((struct gsl_sf_result_struct *)$tmp)->err = $a_err;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct gsl_sf_result_struct);"
		end

end
