class
	PD_GSL_SIMAN_PARAMS_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	n_tries: INTEGER_32 assign set_n_tries
		do
			Result := c_n_tries (c_pointer)
		end

	iters_fixed_T: INTEGER_32 assign set_iters_fixed_T
		do
			Result := c_iters_fixed_T (c_pointer)
		end

	step_size: REAL_64 assign set_step_size
		do
			Result := c_step_size (c_pointer)
		end

	k: REAL_64 assign set_k
		do
			Result := c_k (c_pointer)
		end

	t_initial: REAL_64 assign set_t_initial
		do
			Result := c_t_initial (c_pointer)
		end

	mu_t: REAL_64 assign set_mu_t
		do
			Result := c_mu_t (c_pointer)
		end

	t_min: REAL_64 assign set_t_min
		do
			Result := c_t_min (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_n_tries (a_n_tries: INTEGER_32)
		do
			c_set_n_tries (c_pointer, a_n_tries)
		end

	set_iters_fixed_T (a_iters_fixed_T: INTEGER_32)
		do
			c_set_iters_fixed_T (c_pointer, a_iters_fixed_T)
		end

	set_step_size (a_step_size: REAL_64)
		do
			c_set_step_size (c_pointer, a_step_size)
		end

	set_k (a_k: REAL_64)
		do
			c_set_k (c_pointer, a_k)
		end

	set_t_initial (a_t_initial: REAL_64)
		do
			c_set_t_initial (c_pointer, a_t_initial)
		end

	set_mu_t (a_mu_t: REAL_64)
		do
			c_set_mu_t (c_pointer, a_mu_t)
		end

	set_t_min (a_t_min: REAL_64)
		do
			c_set_t_min (c_pointer, a_t_min)
		end

feature {NONE} -- C getters

	c_n_tries (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_siman_params_t_28 *)$tmp)->n_tries;"
		end

	c_iters_fixed_T (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_siman_params_t_28 *)$tmp)->iters_fixed_T;"
		end

	c_step_size (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_siman_params_t_28 *)$tmp)->step_size;"
		end

	c_k (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_siman_params_t_28 *)$tmp)->k;"
		end

	c_t_initial (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_siman_params_t_28 *)$tmp)->t_initial;"
		end

	c_mu_t (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_siman_params_t_28 *)$tmp)->mu_t;"
		end

	c_t_min (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_siman_params_t_28 *)$tmp)->t_min;"
		end

feature {NONE} -- C setters

	c_set_n_tries (tmp: POINTER; a_n_tries: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_siman_params_t_28 *)$tmp)->n_tries = $a_n_tries;"
		end

	c_set_iters_fixed_T (tmp: POINTER; a_iters_fixed_T: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_siman_params_t_28 *)$tmp)->iters_fixed_T = $a_iters_fixed_t;"
		end

	c_set_step_size (tmp: POINTER; a_step_size: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_siman_params_t_28 *)$tmp)->step_size = $a_step_size;"
		end

	c_set_k (tmp: POINTER; a_k: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_siman_params_t_28 *)$tmp)->k = $a_k;"
		end

	c_set_t_initial (tmp: POINTER; a_t_initial: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_siman_params_t_28 *)$tmp)->t_initial = $a_t_initial;"
		end

	c_set_mu_t (tmp: POINTER; a_mu_t: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_siman_params_t_28 *)$tmp)->mu_t = $a_mu_t;"
		end

	c_set_t_min (tmp: POINTER; a_t_min: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_siman_params_t_28 *)$tmp)->t_min = $a_t_min;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_siman_params_t_28);"
		end

end
