class
	PD_GSL_STACK_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	N: NATURAL_32 assign set_N
		do
			Result := c_N (c_pointer)
		end

	v: CE_POINTER [NATURAL_32] assign set_v
		do
			create Result.make_shared (c_v (c_pointer))
		end

	i: NATURAL_32 assign set_i
		do
			Result := c_i (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_N (a_N: NATURAL_32)
		do
			c_set_N (c_pointer, a_N)
		end

	set_v (a_v: CE_POINTER [NATURAL_32])
		do
			c_set_v (c_pointer, a_v.c_pointer)
		end

	set_i (a_i: NATURAL_32)
		do
			c_set_i (c_pointer, a_i)
		end

feature {NONE} -- C getters

	c_N (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_stack_t_29 *)$tmp)->N;"
		end

	c_v (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned int *)((struct __anonstruct_gsl_stack_t_29 *)$tmp)->v;"
		end

	c_i (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_stack_t_29 *)$tmp)->i;"
		end

feature {NONE} -- C setters

	c_set_N (tmp: POINTER; a_N: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_stack_t_29 *)$tmp)->N = $a_n;"
		end

	c_set_v (tmp: POINTER; a_v: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_stack_t_29 *)$tmp)->v = (unsigned int *)$a_v;"
		end

	c_set_i (tmp: POINTER; a_i: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_stack_t_29 *)$tmp)->i = $a_i;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_stack_t_29);"
		end

end
