class
	PD_GSL_WAVELET

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: CE_POINTER [PD_GSL_WAVELET_TYPE] assign set_type
		do
			create Result.make_shared (c_type (c_pointer))
		end

	h1: CE_POINTER [REAL_64] assign set_h1
		do
			create Result.make_shared (c_h1 (c_pointer))
		end

	h1_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(struct __anonstruct_gsl_wavelet_26, h1);"
		end

	g1: CE_POINTER [REAL_64] assign set_g1
		do
			create Result.make_shared (c_g1 (c_pointer))
		end

	g1_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(struct __anonstruct_gsl_wavelet_26, g1);"
		end

	h2: CE_POINTER [REAL_64] assign set_h2
		do
			create Result.make_shared (c_h2 (c_pointer))
		end

	h2_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(struct __anonstruct_gsl_wavelet_26, h2);"
		end

	g2: CE_POINTER [REAL_64] assign set_g2
		do
			create Result.make_shared (c_g2 (c_pointer))
		end

	g2_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(struct __anonstruct_gsl_wavelet_26, g2);"
		end

	nc: NATURAL_32 assign set_nc
		do
			Result := c_nc (c_pointer)
		end

	nc_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(struct __anonstruct_gsl_wavelet_26, nc);"
		end

	offset: NATURAL_32 assign set_offset
		do
			Result := c_offset (c_pointer)
		end

	offset_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(struct __anonstruct_gsl_wavelet_26, offset);"
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: CE_POINTER [PD_GSL_WAVELET_TYPE])
		do
			c_set_type (c_pointer, a_type.c_pointer)
		end

	set_h1 (a_h1: CE_POINTER [REAL_64])
		do
			c_set_h1 (c_pointer, a_h1.c_pointer)
		end

	set_g1 (a_g1: CE_POINTER [REAL_64])
		do
			c_set_g1 (c_pointer, a_g1.c_pointer)
		end

	set_h2 (a_h2: CE_POINTER [REAL_64])
		do
			c_set_h2 (c_pointer, a_h2.c_pointer)
		end

	set_g2 (a_g2: CE_POINTER [REAL_64])
		do
			c_set_g2 (c_pointer, a_g2.c_pointer)
		end

	set_nc (a_nc: NATURAL_32)
		do
			c_set_nc (c_pointer, a_nc)
		end

	set_offset (a_offset: NATURAL_32)
		do
			c_set_offset (c_pointer, a_offset)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_wavelet_type *)((struct __anonstruct_gsl_wavelet_26 *)$tmp)->type;"
		end

	c_h1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_wavelet_26 *)$tmp)->h1;"
		end

	c_g1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_wavelet_26 *)$tmp)->g1;"
		end

	c_h2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_wavelet_26 *)$tmp)->h2;"
		end

	c_g2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_wavelet_26 *)$tmp)->g2;"
		end

	c_nc (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_wavelet_26 *)$tmp)->nc;"
		end

	c_offset (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_wavelet_26 *)$tmp)->offset;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_wavelet_26 *)$tmp)->type = (gsl_wavelet_type *)$a_type;"
		end

	c_set_h1 (tmp: POINTER; a_h1: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_wavelet_26 *)$tmp)->h1 = (double const *)$a_h1;"
		end

	c_set_g1 (tmp: POINTER; a_g1: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_wavelet_26 *)$tmp)->g1 = (double const *)$a_g1;"
		end

	c_set_h2 (tmp: POINTER; a_h2: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_wavelet_26 *)$tmp)->h2 = (double const *)$a_h2;"
		end

	c_set_g2 (tmp: POINTER; a_g2: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_wavelet_26 *)$tmp)->g2 = (double const *)$a_g2;"
		end

	c_set_nc (tmp: POINTER; a_nc: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_wavelet_26 *)$tmp)->nc = $a_nc;"
		end

	c_set_offset (tmp: POINTER; a_offset: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_wavelet_26 *)$tmp)->offset = $a_offset;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_wavelet_26);"
		end

end
