class
	PD_GSL_WAVELET_TYPE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	init: CE_ROUTINE assign set_init
		do
			create Result.make_shared (c_init (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_init (a_init: CE_ROUTINE)
		do
			c_set_init (c_pointer, a_init.c_pointer)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_gsl_wavelet_type_27 *)$tmp)->name;"
		end

	c_init (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(double * * h1, double * * g1, double * * h2, double * * g2, unsigned int * nc, unsigned int * offset, unsigned int member))((struct __anonstruct_gsl_wavelet_type_27 *)$tmp)->init;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_wavelet_type_27 *)$tmp)->name = (char const *)$a_name;"
		end

	c_set_init (tmp: POINTER; a_init: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_wavelet_type_27 *)$tmp)->init = (int( *)(double const * * h1, double const * * g1, double const * * h2, double const * * g2, unsigned int * nc, unsigned int * offset, unsigned int member))$a_init;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_wavelet_type_27);"
		end

end
