class
	PD_GSL_WAVELET_WORKSPACE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	scratch: CE_POINTER [REAL_64] assign set_scratch
		do
			create Result.make_shared (c_scratch (c_pointer))
		end

	n: NATURAL_32 assign set_n
		do
			Result := c_n (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_scratch (a_scratch: CE_POINTER [REAL_64])
		do
			c_set_scratch (c_pointer, a_scratch.c_pointer)
		end

	set_n (a_n: NATURAL_32)
		do
			c_set_n (c_pointer, a_n)
		end

feature {NONE} -- C getters

	c_scratch (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_wavelet_workspace_27 *)$tmp)->scratch;"
		end

	c_n (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_wavelet_workspace_27 *)$tmp)->n;"
		end

feature {NONE} -- C setters

	c_set_scratch (tmp: POINTER; a_scratch: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_wavelet_workspace_27 *)$tmp)->scratch = (double *)$a_scratch;"
		end

	c_set_n (tmp: POINTER; a_n: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_wavelet_workspace_27 *)$tmp)->n = $a_n;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_wavelet_workspace_27);"
		end

end
