class
	PD_NEWTON_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	lu: CE_POINTER [PD_GSL_MATRIX] assign set_lu
		do
			create Result.make_shared (c_lu (c_pointer))
		end

	permutation: CE_POINTER [PD_GSL_PERMUTATION_STRUCT] assign set_permutation
		do
			create Result.make_shared (c_permutation (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_lu (a_lu: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_lu (c_pointer, a_lu.c_pointer)
		end

	set_permutation (a_permutation: CE_POINTER [PD_GSL_PERMUTATION_STRUCT])
		do
			c_set_permutation (c_pointer, a_permutation.c_pointer)
		end

feature {NONE} -- C getters

	c_lu (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_newton_state_t_118 *)$tmp)->lu;"
		end

	c_permutation (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct gsl_permutation_struct *)((struct __anonstruct_newton_state_t_118 *)$tmp)->permutation;"
		end

feature {NONE} -- C setters

	c_set_lu (tmp: POINTER; a_lu: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_newton_state_t_118 *)$tmp)->lu = (gsl_matrix *)$a_lu;"
		end

	c_set_permutation (tmp: POINTER; a_permutation: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_newton_state_t_118 *)$tmp)->permutation = (struct gsl_permutation_struct *)$a_permutation;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_newton_state_t_118);"
		end

end
