class
	PD_NIED2_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sequence_count: NATURAL_32 assign set_sequence_count
		do
			Result := c_sequence_count (c_pointer)
		end

	cj: CE_ARRAY [CE_ARRAY [INTEGER_32]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 2)
			create Result.make_shared (c_cj (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	nextq: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_nextq (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_sequence_count (a_sequence_count: NATURAL_32)
		do
			c_set_sequence_count (c_pointer, a_sequence_count)
		end

feature {NONE} -- C getters

	c_sequence_count (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_nied2_state_t_26 *)$tmp)->sequence_count;"
		end

	c_cj (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_nied2_state_t_26 *tmp = (struct __anonstruct_nied2_state_t_26 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->cj) / sizeof(tmp->cj[0]);
				((int *)$tmp_dimensions)[1] = sizeof(tmp->cj[0]) / sizeof(tmp->cj[0][0]);
				return tmp->cj;
			]"
		end

	c_nextq (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_nied2_state_t_26 *tmp = (struct __anonstruct_nied2_state_t_26 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->nextq) / sizeof(tmp->nextq[0]);
				return tmp->nextq;
			]"
		end

feature {NONE} -- C setters

	c_set_sequence_count (tmp: POINTER; a_sequence_count: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_nied2_state_t_26 *)$tmp)->sequence_count = $a_sequence_count;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_nied2_state_t_26);"
		end

end
