class
	PD_POLYNOMIAL_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	d: CE_POINTER [REAL_64] assign set_d
		do
			create Result.make_shared (c_d (c_pointer))
		end

	coeff: CE_POINTER [REAL_64] assign set_coeff
		do
			create Result.make_shared (c_coeff (c_pointer))
		end

	work: CE_POINTER [REAL_64] assign set_work
		do
			create Result.make_shared (c_work (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_d (a_d: CE_POINTER [REAL_64])
		do
			c_set_d (c_pointer, a_d.c_pointer)
		end

	set_coeff (a_coeff: CE_POINTER [REAL_64])
		do
			c_set_coeff (c_pointer, a_coeff.c_pointer)
		end

	set_work (a_work: CE_POINTER [REAL_64])
		do
			c_set_work (c_pointer, a_work.c_pointer)
		end

feature {NONE} -- C getters

	c_d (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_polynomial_state_t_33 *)$tmp)->d;"
		end

	c_coeff (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_polynomial_state_t_33 *)$tmp)->coeff;"
		end

	c_work (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_polynomial_state_t_33 *)$tmp)->work;"
		end

feature {NONE} -- C setters

	c_set_d (tmp: POINTER; a_d: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_polynomial_state_t_33 *)$tmp)->d = (double *)$a_d;"
		end

	c_set_coeff (tmp: POINTER; a_coeff: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_polynomial_state_t_33 *)$tmp)->coeff = (double *)$a_coeff;"
		end

	c_set_work (tmp: POINTER; a_work: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_polynomial_state_t_33 *)$tmp)->work = (double *)$a_work;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_polynomial_state_t_33);"
		end

end
