class
	PD_QUAD_GOLDEN_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	step_size: REAL_64 assign set_step_size
		do
			Result := c_step_size (c_pointer)
		end

	stored_step: REAL_64 assign set_stored_step
		do
			Result := c_stored_step (c_pointer)
		end

	prev_stored_step: REAL_64 assign set_prev_stored_step
		do
			Result := c_prev_stored_step (c_pointer)
		end

	x_prev_small: REAL_64 assign set_x_prev_small
		do
			Result := c_x_prev_small (c_pointer)
		end

	f_prev_small: REAL_64 assign set_f_prev_small
		do
			Result := c_f_prev_small (c_pointer)
		end

	x_small: REAL_64 assign set_x_small
		do
			Result := c_x_small (c_pointer)
		end

	f_small: REAL_64 assign set_f_small
		do
			Result := c_f_small (c_pointer)
		end

	num_iter: NATURAL_32 assign set_num_iter
		do
			Result := c_num_iter (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_step_size (a_step_size: REAL_64)
		do
			c_set_step_size (c_pointer, a_step_size)
		end

	set_stored_step (a_stored_step: REAL_64)
		do
			c_set_stored_step (c_pointer, a_stored_step)
		end

	set_prev_stored_step (a_prev_stored_step: REAL_64)
		do
			c_set_prev_stored_step (c_pointer, a_prev_stored_step)
		end

	set_x_prev_small (a_x_prev_small: REAL_64)
		do
			c_set_x_prev_small (c_pointer, a_x_prev_small)
		end

	set_f_prev_small (a_f_prev_small: REAL_64)
		do
			c_set_f_prev_small (c_pointer, a_f_prev_small)
		end

	set_x_small (a_x_small: REAL_64)
		do
			c_set_x_small (c_pointer, a_x_small)
		end

	set_f_small (a_f_small: REAL_64)
		do
			c_set_f_small (c_pointer, a_f_small)
		end

	set_num_iter (a_num_iter: NATURAL_32)
		do
			c_set_num_iter (c_pointer, a_num_iter)
		end

feature {NONE} -- C getters

	c_step_size (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_quad_golden_state_t_28 *)$tmp)->step_size;"
		end

	c_stored_step (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_quad_golden_state_t_28 *)$tmp)->stored_step;"
		end

	c_prev_stored_step (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_quad_golden_state_t_28 *)$tmp)->prev_stored_step;"
		end

	c_x_prev_small (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_quad_golden_state_t_28 *)$tmp)->x_prev_small;"
		end

	c_f_prev_small (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_quad_golden_state_t_28 *)$tmp)->f_prev_small;"
		end

	c_x_small (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_quad_golden_state_t_28 *)$tmp)->x_small;"
		end

	c_f_small (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_quad_golden_state_t_28 *)$tmp)->f_small;"
		end

	c_num_iter (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_quad_golden_state_t_28 *)$tmp)->num_iter;"
		end

feature {NONE} -- C setters

	c_set_step_size (tmp: POINTER; a_step_size: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_quad_golden_state_t_28 *)$tmp)->step_size = $a_step_size;"
		end

	c_set_stored_step (tmp: POINTER; a_stored_step: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_quad_golden_state_t_28 *)$tmp)->stored_step = $a_stored_step;"
		end

	c_set_prev_stored_step (tmp: POINTER; a_prev_stored_step: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_quad_golden_state_t_28 *)$tmp)->prev_stored_step = $a_prev_stored_step;"
		end

	c_set_x_prev_small (tmp: POINTER; a_x_prev_small: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_quad_golden_state_t_28 *)$tmp)->x_prev_small = $a_x_prev_small;"
		end

	c_set_f_prev_small (tmp: POINTER; a_f_prev_small: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_quad_golden_state_t_28 *)$tmp)->f_prev_small = $a_f_prev_small;"
		end

	c_set_x_small (tmp: POINTER; a_x_small: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_quad_golden_state_t_28 *)$tmp)->x_small = $a_x_small;"
		end

	c_set_f_small (tmp: POINTER; a_f_small: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_quad_golden_state_t_28 *)$tmp)->f_small = $a_f_small;"
		end

	c_set_num_iter (tmp: POINTER; a_num_iter: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_quad_golden_state_t_28 *)$tmp)->num_iter = $a_num_iter;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_quad_golden_state_t_28);"
		end

end
