class
	PD_RAN3_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	x: NATURAL_32 assign set_x
		do
			Result := c_x (c_pointer)
		end

	y: NATURAL_32 assign set_y
		do
			Result := c_y (c_pointer)
		end

	buffer: CE_ARRAY [NATURAL_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_buffer (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_x (a_x: NATURAL_32)
		do
			c_set_x (c_pointer, a_x)
		end

	set_y (a_y: NATURAL_32)
		do
			c_set_y (c_pointer, a_y)
		end

feature {NONE} -- C getters

	c_x (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_ran3_state_t_26 *)$tmp)->x;"
		end

	c_y (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_ran3_state_t_26 *)$tmp)->y;"
		end

	c_buffer (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_ran3_state_t_26 *tmp = (struct __anonstruct_ran3_state_t_26 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->buffer) / sizeof(tmp->buffer[0]);
				return tmp->buffer;
			]"
		end

feature {NONE} -- C setters

	c_set_x (tmp: POINTER; a_x: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_ran3_state_t_26 *)$tmp)->x = $a_x;"
		end

	c_set_y (tmp: POINTER; a_y: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_ran3_state_t_26 *)$tmp)->y = $a_y;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_ran3_state_t_26);"
		end

end
