class
	PD_RAN_STATE_T_26__4

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	i: NATURAL_32 assign set_i
		do
			Result := c_i (c_pointer)
		end

	aa: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_aa (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	ran_x: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_ran_x (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_i (a_i: NATURAL_32)
		do
			c_set_i (c_pointer, a_i)
		end

feature {NONE} -- C getters

	c_i (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_ran_state_t_26___3 *)$tmp)->i;"
		end

	c_aa (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_ran_state_t_26___3 *tmp = (struct __anonstruct_ran_state_t_26___3 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->aa) / sizeof(tmp->aa[0]);
				return tmp->aa;
			]"
		end

	c_ran_x (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_ran_state_t_26___3 *tmp = (struct __anonstruct_ran_state_t_26___3 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->ran_x) / sizeof(tmp->ran_x[0]);
				return tmp->ran_x;
			]"
		end

feature {NONE} -- C setters

	c_set_i (tmp: POINTER; a_i: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_ran_state_t_26___3 *)$tmp)->i = $a_i;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_ran_state_t_26___3);"
		end

end
