class
	PD_RK2SIMP_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	Y1: CE_POINTER [REAL_64] assign set_Y1
		do
			create Result.make_shared (c_Y1 (c_pointer))
		end

	y0: CE_POINTER [REAL_64] assign set_y0
		do
			create Result.make_shared (c_y0 (c_pointer))
		end

	y0_orig: CE_POINTER [REAL_64] assign set_y0_orig
		do
			create Result.make_shared (c_y0_orig (c_pointer))
		end

	ytmp: CE_POINTER [REAL_64] assign set_ytmp
		do
			create Result.make_shared (c_ytmp (c_pointer))
		end

	dfdy: CE_POINTER [REAL_64] assign set_dfdy
		do
			create Result.make_shared (c_dfdy (c_pointer))
		end

	dfdt: CE_POINTER [REAL_64] assign set_dfdt
		do
			create Result.make_shared (c_dfdt (c_pointer))
		end

	y_onestep: CE_POINTER [REAL_64] assign set_y_onestep
		do
			create Result.make_shared (c_y_onestep (c_pointer))
		end

	p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT] assign set_p
		do
			create Result.make_shared (c_p (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_Y1 (a_Y1: CE_POINTER [REAL_64])
		do
			c_set_Y1 (c_pointer, a_Y1.c_pointer)
		end

	set_y0 (a_y0: CE_POINTER [REAL_64])
		do
			c_set_y0 (c_pointer, a_y0.c_pointer)
		end

	set_y0_orig (a_y0_orig: CE_POINTER [REAL_64])
		do
			c_set_y0_orig (c_pointer, a_y0_orig.c_pointer)
		end

	set_ytmp (a_ytmp: CE_POINTER [REAL_64])
		do
			c_set_ytmp (c_pointer, a_ytmp.c_pointer)
		end

	set_dfdy (a_dfdy: CE_POINTER [REAL_64])
		do
			c_set_dfdy (c_pointer, a_dfdy.c_pointer)
		end

	set_dfdt (a_dfdt: CE_POINTER [REAL_64])
		do
			c_set_dfdt (c_pointer, a_dfdt.c_pointer)
		end

	set_y_onestep (a_y_onestep: CE_POINTER [REAL_64])
		do
			c_set_y_onestep (c_pointer, a_y_onestep.c_pointer)
		end

	set_p (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT])
		do
			c_set_p (c_pointer, a_p.c_pointer)
		end

feature {NONE} -- C getters

	c_Y1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rk2simp_state_t_120 *)$tmp)->Y1;"
		end

	c_y0 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rk2simp_state_t_120 *)$tmp)->y0;"
		end

	c_y0_orig (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rk2simp_state_t_120 *)$tmp)->y0_orig;"
		end

	c_ytmp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rk2simp_state_t_120 *)$tmp)->ytmp;"
		end

	c_dfdy (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rk2simp_state_t_120 *)$tmp)->dfdy;"
		end

	c_dfdt (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rk2simp_state_t_120 *)$tmp)->dfdt;"
		end

	c_y_onestep (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rk2simp_state_t_120 *)$tmp)->y_onestep;"
		end

	c_p (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct gsl_permutation_struct *)((struct __anonstruct_rk2simp_state_t_120 *)$tmp)->p;"
		end

feature {NONE} -- C setters

	c_set_Y1 (tmp: POINTER; a_Y1: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rk2simp_state_t_120 *)$tmp)->Y1 = (double *)$a_y1;"
		end

	c_set_y0 (tmp: POINTER; a_y0: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rk2simp_state_t_120 *)$tmp)->y0 = (double *)$a_y0;"
		end

	c_set_y0_orig (tmp: POINTER; a_y0_orig: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rk2simp_state_t_120 *)$tmp)->y0_orig = (double *)$a_y0_orig;"
		end

	c_set_ytmp (tmp: POINTER; a_ytmp: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rk2simp_state_t_120 *)$tmp)->ytmp = (double *)$a_ytmp;"
		end

	c_set_dfdy (tmp: POINTER; a_dfdy: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rk2simp_state_t_120 *)$tmp)->dfdy = (double *)$a_dfdy;"
		end

	c_set_dfdt (tmp: POINTER; a_dfdt: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rk2simp_state_t_120 *)$tmp)->dfdt = (double *)$a_dfdt;"
		end

	c_set_y_onestep (tmp: POINTER; a_y_onestep: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rk2simp_state_t_120 *)$tmp)->y_onestep = (double *)$a_y_onestep;"
		end

	c_set_p (tmp: POINTER; a_p: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rk2simp_state_t_120 *)$tmp)->p = (struct gsl_permutation_struct *)$a_p;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_rk2simp_state_t_120);"
		end

end
