class
	PD_RK4_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	k: CE_POINTER [REAL_64] assign set_k
		do
			create Result.make_shared (c_k (c_pointer))
		end

	k1: CE_POINTER [REAL_64] assign set_k1
		do
			create Result.make_shared (c_k1 (c_pointer))
		end

	y0: CE_POINTER [REAL_64] assign set_y0
		do
			create Result.make_shared (c_y0 (c_pointer))
		end

	ytmp: CE_POINTER [REAL_64] assign set_ytmp
		do
			create Result.make_shared (c_ytmp (c_pointer))
		end

	y_onestep: CE_POINTER [REAL_64] assign set_y_onestep
		do
			create Result.make_shared (c_y_onestep (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_k (a_k: CE_POINTER [REAL_64])
		do
			c_set_k (c_pointer, a_k.c_pointer)
		end

	set_k1 (a_k1: CE_POINTER [REAL_64])
		do
			c_set_k1 (c_pointer, a_k1.c_pointer)
		end

	set_y0 (a_y0: CE_POINTER [REAL_64])
		do
			c_set_y0 (c_pointer, a_y0.c_pointer)
		end

	set_ytmp (a_ytmp: CE_POINTER [REAL_64])
		do
			c_set_ytmp (c_pointer, a_ytmp.c_pointer)
		end

	set_y_onestep (a_y_onestep: CE_POINTER [REAL_64])
		do
			c_set_y_onestep (c_pointer, a_y_onestep.c_pointer)
		end

feature {NONE} -- C getters

	c_k (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rk4_state_t_30 *)$tmp)->k;"
		end

	c_k1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rk4_state_t_30 *)$tmp)->k1;"
		end

	c_y0 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rk4_state_t_30 *)$tmp)->y0;"
		end

	c_ytmp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rk4_state_t_30 *)$tmp)->ytmp;"
		end

	c_y_onestep (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rk4_state_t_30 *)$tmp)->y_onestep;"
		end

feature {NONE} -- C setters

	c_set_k (tmp: POINTER; a_k: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rk4_state_t_30 *)$tmp)->k = (double *)$a_k;"
		end

	c_set_k1 (tmp: POINTER; a_k1: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rk4_state_t_30 *)$tmp)->k1 = (double *)$a_k1;"
		end

	c_set_y0 (tmp: POINTER; a_y0: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rk4_state_t_30 *)$tmp)->y0 = (double *)$a_y0;"
		end

	c_set_ytmp (tmp: POINTER; a_ytmp: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rk4_state_t_30 *)$tmp)->ytmp = (double *)$a_ytmp;"
		end

	c_set_y_onestep (tmp: POINTER; a_y_onestep: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rk4_state_t_30 *)$tmp)->y_onestep = (double *)$a_y_onestep;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_rk4_state_t_30);"
		end

end
