class
	PD_RKF45_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	k1: CE_POINTER [REAL_64] assign set_k1
		do
			create Result.make_shared (c_k1 (c_pointer))
		end

	k2: CE_POINTER [REAL_64] assign set_k2
		do
			create Result.make_shared (c_k2 (c_pointer))
		end

	k3: CE_POINTER [REAL_64] assign set_k3
		do
			create Result.make_shared (c_k3 (c_pointer))
		end

	k4: CE_POINTER [REAL_64] assign set_k4
		do
			create Result.make_shared (c_k4 (c_pointer))
		end

	k5: CE_POINTER [REAL_64] assign set_k5
		do
			create Result.make_shared (c_k5 (c_pointer))
		end

	k6: CE_POINTER [REAL_64] assign set_k6
		do
			create Result.make_shared (c_k6 (c_pointer))
		end

	y0: CE_POINTER [REAL_64] assign set_y0
		do
			create Result.make_shared (c_y0 (c_pointer))
		end

	ytmp: CE_POINTER [REAL_64] assign set_ytmp
		do
			create Result.make_shared (c_ytmp (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_k1 (a_k1: CE_POINTER [REAL_64])
		do
			c_set_k1 (c_pointer, a_k1.c_pointer)
		end

	set_k2 (a_k2: CE_POINTER [REAL_64])
		do
			c_set_k2 (c_pointer, a_k2.c_pointer)
		end

	set_k3 (a_k3: CE_POINTER [REAL_64])
		do
			c_set_k3 (c_pointer, a_k3.c_pointer)
		end

	set_k4 (a_k4: CE_POINTER [REAL_64])
		do
			c_set_k4 (c_pointer, a_k4.c_pointer)
		end

	set_k5 (a_k5: CE_POINTER [REAL_64])
		do
			c_set_k5 (c_pointer, a_k5.c_pointer)
		end

	set_k6 (a_k6: CE_POINTER [REAL_64])
		do
			c_set_k6 (c_pointer, a_k6.c_pointer)
		end

	set_y0 (a_y0: CE_POINTER [REAL_64])
		do
			c_set_y0 (c_pointer, a_y0.c_pointer)
		end

	set_ytmp (a_ytmp: CE_POINTER [REAL_64])
		do
			c_set_ytmp (c_pointer, a_ytmp.c_pointer)
		end

feature {NONE} -- C getters

	c_k1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rkf45_state_t_30 *)$tmp)->k1;"
		end

	c_k2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rkf45_state_t_30 *)$tmp)->k2;"
		end

	c_k3 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rkf45_state_t_30 *)$tmp)->k3;"
		end

	c_k4 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rkf45_state_t_30 *)$tmp)->k4;"
		end

	c_k5 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rkf45_state_t_30 *)$tmp)->k5;"
		end

	c_k6 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rkf45_state_t_30 *)$tmp)->k6;"
		end

	c_y0 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rkf45_state_t_30 *)$tmp)->y0;"
		end

	c_ytmp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rkf45_state_t_30 *)$tmp)->ytmp;"
		end

feature {NONE} -- C setters

	c_set_k1 (tmp: POINTER; a_k1: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rkf45_state_t_30 *)$tmp)->k1 = (double *)$a_k1;"
		end

	c_set_k2 (tmp: POINTER; a_k2: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rkf45_state_t_30 *)$tmp)->k2 = (double *)$a_k2;"
		end

	c_set_k3 (tmp: POINTER; a_k3: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rkf45_state_t_30 *)$tmp)->k3 = (double *)$a_k3;"
		end

	c_set_k4 (tmp: POINTER; a_k4: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rkf45_state_t_30 *)$tmp)->k4 = (double *)$a_k4;"
		end

	c_set_k5 (tmp: POINTER; a_k5: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rkf45_state_t_30 *)$tmp)->k5 = (double *)$a_k5;"
		end

	c_set_k6 (tmp: POINTER; a_k6: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rkf45_state_t_30 *)$tmp)->k6 = (double *)$a_k6;"
		end

	c_set_y0 (tmp: POINTER; a_y0: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rkf45_state_t_30 *)$tmp)->y0 = (double *)$a_y0;"
		end

	c_set_ytmp (tmp: POINTER; a_ytmp: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rkf45_state_t_30 *)$tmp)->ytmp = (double *)$a_ytmp;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_rkf45_state_t_30);"
		end

end
