class
	PD_SC_CONTROL_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	eps_abs: REAL_64 assign set_eps_abs
		do
			Result := c_eps_abs (c_pointer)
		end

	eps_rel: REAL_64 assign set_eps_rel
		do
			Result := c_eps_rel (c_pointer)
		end

	a_y: REAL_64 assign set_a_y
		do
			Result := c_a_y (c_pointer)
		end

	a_dydt: REAL_64 assign set_a_dydt
		do
			Result := c_a_dydt (c_pointer)
		end

	scale_abs: CE_POINTER [REAL_64] assign set_scale_abs
		do
			create Result.make_shared (c_scale_abs (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_eps_abs (a_eps_abs: REAL_64)
		do
			c_set_eps_abs (c_pointer, a_eps_abs)
		end

	set_eps_rel (a_eps_rel: REAL_64)
		do
			c_set_eps_rel (c_pointer, a_eps_rel)
		end

	set_a_y (a_a_y: REAL_64)
		do
			c_set_a_y (c_pointer, a_a_y)
		end

	set_a_dydt (a_a_dydt: REAL_64)
		do
			c_set_a_dydt (c_pointer, a_a_dydt)
		end

	set_scale_abs (a_scale_abs: CE_POINTER [REAL_64])
		do
			c_set_scale_abs (c_pointer, a_scale_abs.c_pointer)
		end

feature {NONE} -- C getters

	c_eps_abs (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_sc_control_state_t_32 *)$tmp)->eps_abs;"
		end

	c_eps_rel (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_sc_control_state_t_32 *)$tmp)->eps_rel;"
		end

	c_a_y (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_sc_control_state_t_32 *)$tmp)->a_y;"
		end

	c_a_dydt (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_sc_control_state_t_32 *)$tmp)->a_dydt;"
		end

	c_scale_abs (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_sc_control_state_t_32 *)$tmp)->scale_abs;"
		end

feature {NONE} -- C setters

	c_set_eps_abs (tmp: POINTER; a_eps_abs: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_sc_control_state_t_32 *)$tmp)->eps_abs = $a_eps_abs;"
		end

	c_set_eps_rel (tmp: POINTER; a_eps_rel: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_sc_control_state_t_32 *)$tmp)->eps_rel = $a_eps_rel;"
		end

	c_set_a_y (tmp: POINTER; a_a_y: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_sc_control_state_t_32 *)$tmp)->a_y = $a_a_y;"
		end

	c_set_a_dydt (tmp: POINTER; a_a_dydt: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_sc_control_state_t_32 *)$tmp)->a_dydt = $a_a_dydt;"
		end

	c_set_scale_abs (tmp: POINTER; a_scale_abs: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_sc_control_state_t_32 *)$tmp)->scale_abs = (double *)$a_scale_abs;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_sc_control_state_t_32);"
		end

end
