class
	PD_TT_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	n: INTEGER_32 assign set_n
		do
			Result := c_n (c_pointer)
		end

	x: CE_ARRAY [NATURAL_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_x (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_n (a_n: INTEGER_32)
		do
			c_set_n (c_pointer, a_n)
		end

feature {NONE} -- C getters

	c_n (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_tt_state_t_26 *)$tmp)->n;"
		end

	c_x (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_tt_state_t_26 *tmp = (struct __anonstruct_tt_state_t_26 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->x) / sizeof(tmp->x[0]);
				return tmp->x;
			]"
		end

feature {NONE} -- C setters

	c_set_n (tmp: POINTER; a_n: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_tt_state_t_26 *)$tmp)->n = $a_n;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_tt_state_t_26);"
		end

end
