class
	PD_U

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	l: INTEGER_32 assign set_l
		do
			Result := c_l (c_pointer)
		end

	c: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_c (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_l (a_l: INTEGER_32)
		do
			c_set_l (c_pointer, a_l)
		end

feature {NONE} -- C getters

	c_l (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((union __anonunion_u_29 *)$tmp)->l;"
		end

	c_c (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				union __anonunion_u_29 *tmp = (union __anonunion_u_29 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->c) / sizeof(tmp->c[0]);
				return tmp->c;
			]"
		end

feature {NONE} -- C setters

	c_set_l (tmp: POINTER; a_l: INTEGER_32)
		external
			"C inline"
		alias
			"((union __anonunion_u_29 *)$tmp)->l = $a_l;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(union __anonunion_u_29);"
		end

end
