class
	PD_U3

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	d: REAL_64 assign set_d
		do
			Result := c_d (c_pointer)
		end

	b: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_b (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_d (a_d: REAL_64)
		do
			c_set_d (c_pointer, a_d)
		end

feature {NONE} -- C getters

	c_d (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((union __anonunion_u_31 *)$tmp)->d;"
		end

	c_b (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				union __anonunion_u_31 *tmp = (union __anonunion_u_31 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->b) / sizeof(tmp->b[0]);
				return tmp->b;
			]"
		end

feature {NONE} -- C setters

	c_set_d (tmp: POINTER; a_d: REAL_64)
		external
			"C inline"
		alias
			"((union __anonunion_u_31 *)$tmp)->d = $a_d;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(union __anonunion_u_31);"
		end

end
