frozen class
	LIBGSL_INITIALIZER_SLICE10

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {LIBGSL_INITIALIZER}

	initialize
		do
			rkf45_inst.rkf45_type.free := rkf45_inst.rkf45_free_address
			rkf45_inst.gsl_odeiv_step_rkf45.ce_gets (rkf45_inst.rkf45_type.address)
			rk4_inst.rk4_type.name := ce_string ("rk4")
			rk4_inst.rk4_type.can_use_dydt_in := 1
			rk4_inst.rk4_type.gives_exact_dydt_out := 1
			rk4_inst.rk4_type.alloc := rk4_inst.rk4_alloc_address
			rk4_inst.rk4_type.apply := rk4_inst.rk4_apply_address
			rk4_inst.rk4_type.reset := rk4_inst.rk4_reset_address
			rk4_inst.rk4_type.order := rk4_inst.rk4_order_address
			rk4_inst.rk4_type.free := rk4_inst.rk4_free_address
			rk4_inst.gsl_odeiv_step_rk4.ce_gets (rk4_inst.rk4_type.address)
			bsimp_inst.bd_sequence[0] := 2
			bsimp_inst.bd_sequence[1] := 6
			bsimp_inst.bd_sequence[2] := 10
			bsimp_inst.bd_sequence[3] := 14
			bsimp_inst.bd_sequence[4] := 22
			bsimp_inst.bd_sequence[5] := 34
			bsimp_inst.bd_sequence[6] := 50
			bsimp_inst.bd_sequence[7] := 70
			bsimp_inst.bsimp_type.name := ce_string ("bsimp")
			bsimp_inst.bsimp_type.can_use_dydt_in := 1
			bsimp_inst.bsimp_type.gives_exact_dydt_out := 1
			bsimp_inst.bsimp_type.alloc := bsimp_inst.bsimp_alloc_address
			bsimp_inst.bsimp_type.apply := bsimp_inst.bsimp_apply_address
			bsimp_inst.bsimp_type.reset := bsimp_inst.bsimp_reset_address
			bsimp_inst.bsimp_type.order := bsimp_inst.bsimp_order_address
			bsimp_inst.bsimp_type.free := bsimp_inst.bsimp_free_address
			bsimp_inst.gsl_odeiv_step_bsimp.ce_gets (bsimp_inst.bsimp_type.address)
			reversehalton_inst.reversehalton_type.name := ce_string ("reversehalton")
			reversehalton_inst.reversehalton_type.max_dimension := {NATURAL_32} 1229
			reversehalton_inst.reversehalton_type.state_size := reversehalton_inst.reversehalton_state_size_address
			reversehalton_inst.reversehalton_type.init_state := reversehalton_inst.reversehalton_init_address
			reversehalton_inst.reversehalton_type.get := reversehalton_inst.reversehalton_get_address
			reversehalton_inst.gsl_qrng_reversehalton.ce_gets (reversehalton_inst.reversehalton_type.address)
			reversehalton_inst.prime_numbers[0] := 2
			reversehalton_inst.prime_numbers[1] := 3
			reversehalton_inst.prime_numbers[2] := 5
			reversehalton_inst.prime_numbers[3] := 7
			reversehalton_inst.prime_numbers[4] := 11
			reversehalton_inst.prime_numbers[5] := 13
			reversehalton_inst.prime_numbers[6] := 17
			reversehalton_inst.prime_numbers[7] := 19
			reversehalton_inst.prime_numbers[8] := 23
			reversehalton_inst.prime_numbers[9] := 29
			reversehalton_inst.prime_numbers[10] := 31
			reversehalton_inst.prime_numbers[11] := 37
			reversehalton_inst.prime_numbers[12] := 41
			reversehalton_inst.prime_numbers[13] := 43
			reversehalton_inst.prime_numbers[14] := 47
			reversehalton_inst.prime_numbers[15] := 53
			reversehalton_inst.prime_numbers[16] := 59
			reversehalton_inst.prime_numbers[17] := 61
			reversehalton_inst.prime_numbers[18] := 67
			reversehalton_inst.prime_numbers[19] := 71
			reversehalton_inst.prime_numbers[20] := 73
			reversehalton_inst.prime_numbers[21] := 79
			reversehalton_inst.prime_numbers[22] := 83
			reversehalton_inst.prime_numbers[23] := 89
			reversehalton_inst.prime_numbers[24] := 97
			reversehalton_inst.prime_numbers[25] := 101
			reversehalton_inst.prime_numbers[26] := 103
			reversehalton_inst.prime_numbers[27] := 107
			reversehalton_inst.prime_numbers[28] := 109
			reversehalton_inst.prime_numbers[29] := 113
			reversehalton_inst.prime_numbers[30] := 127
			reversehalton_inst.prime_numbers[31] := 131
			reversehalton_inst.prime_numbers[32] := 137
			reversehalton_inst.prime_numbers[33] := 139
			reversehalton_inst.prime_numbers[34] := 149
			reversehalton_inst.prime_numbers[35] := 151
			reversehalton_inst.prime_numbers[36] := 157
			reversehalton_inst.prime_numbers[37] := 163
			reversehalton_inst.prime_numbers[38] := 167
			reversehalton_inst.prime_numbers[39] := 173
			reversehalton_inst.prime_numbers[40] := 179
			reversehalton_inst.prime_numbers[41] := 181
			reversehalton_inst.prime_numbers[42] := 191
			reversehalton_inst.prime_numbers[43] := 193
			reversehalton_inst.prime_numbers[44] := 197
			reversehalton_inst.prime_numbers[45] := 199
			reversehalton_inst.prime_numbers[46] := 211
			reversehalton_inst.prime_numbers[47] := 223
			reversehalton_inst.prime_numbers[48] := 227
			reversehalton_inst.prime_numbers[49] := 229
			reversehalton_inst.prime_numbers[50] := 233
			reversehalton_inst.prime_numbers[51] := 239
			reversehalton_inst.prime_numbers[52] := 241
			reversehalton_inst.prime_numbers[53] := 251
			reversehalton_inst.prime_numbers[54] := 257
			reversehalton_inst.prime_numbers[55] := 263
			reversehalton_inst.prime_numbers[56] := 269
			reversehalton_inst.prime_numbers[57] := 271
			reversehalton_inst.prime_numbers[58] := 277
			reversehalton_inst.prime_numbers[59] := 281
			reversehalton_inst.prime_numbers[60] := 283
			reversehalton_inst.prime_numbers[61] := 293
			reversehalton_inst.prime_numbers[62] := 307
			reversehalton_inst.prime_numbers[63] := 311
			reversehalton_inst.prime_numbers[64] := 313
			reversehalton_inst.prime_numbers[65] := 317
			reversehalton_inst.prime_numbers[66] := 331
			reversehalton_inst.prime_numbers[67] := 337
			reversehalton_inst.prime_numbers[68] := 347
			reversehalton_inst.prime_numbers[69] := 349
			reversehalton_inst.prime_numbers[70] := 353
			reversehalton_inst.prime_numbers[71] := 359
			reversehalton_inst.prime_numbers[72] := 367
			reversehalton_inst.prime_numbers[73] := 373
			reversehalton_inst.prime_numbers[74] := 379
			reversehalton_inst.prime_numbers[75] := 383
			reversehalton_inst.prime_numbers[76] := 389
			reversehalton_inst.prime_numbers[77] := 397
			reversehalton_inst.prime_numbers[78] := 401
			reversehalton_inst.prime_numbers[79] := 409
			reversehalton_inst.prime_numbers[80] := 419
			reversehalton_inst.prime_numbers[81] := 421
			reversehalton_inst.prime_numbers[82] := 431
			reversehalton_inst.prime_numbers[83] := 433
			reversehalton_inst.prime_numbers[84] := 439
			reversehalton_inst.prime_numbers[85] := 443
			reversehalton_inst.prime_numbers[86] := 449
			reversehalton_inst.prime_numbers[87] := 457
			reversehalton_inst.prime_numbers[88] := 461
			reversehalton_inst.prime_numbers[89] := 463
			reversehalton_inst.prime_numbers[90] := 467
			reversehalton_inst.prime_numbers[91] := 479
			reversehalton_inst.prime_numbers[92] := 487
			reversehalton_inst.prime_numbers[93] := 491
			reversehalton_inst.prime_numbers[94] := 499
			reversehalton_inst.prime_numbers[95] := 503
			reversehalton_inst.prime_numbers[96] := 509
			reversehalton_inst.prime_numbers[97] := 521
			reversehalton_inst.prime_numbers[98] := 523
			reversehalton_inst.prime_numbers[99] := 541
			reversehalton_inst.prime_numbers[100] := 547
			reversehalton_inst.prime_numbers[101] := 557
			reversehalton_inst.prime_numbers[102] := 563
			reversehalton_inst.prime_numbers[103] := 569
			reversehalton_inst.prime_numbers[104] := 571
			reversehalton_inst.prime_numbers[105] := 577
			reversehalton_inst.prime_numbers[106] := 587
			reversehalton_inst.prime_numbers[107] := 593
			reversehalton_inst.prime_numbers[108] := 599
			reversehalton_inst.prime_numbers[109] := 601
			reversehalton_inst.prime_numbers[110] := 607
			reversehalton_inst.prime_numbers[111] := 613
			reversehalton_inst.prime_numbers[112] := 617
			reversehalton_inst.prime_numbers[113] := 619
			reversehalton_inst.prime_numbers[114] := 631
			reversehalton_inst.prime_numbers[115] := 641
			reversehalton_inst.prime_numbers[116] := 643
			reversehalton_inst.prime_numbers[117] := 647
			reversehalton_inst.prime_numbers[118] := 653
			reversehalton_inst.prime_numbers[119] := 659
			reversehalton_inst.prime_numbers[120] := 661
			reversehalton_inst.prime_numbers[121] := 673
			reversehalton_inst.prime_numbers[122] := 677
			reversehalton_inst.prime_numbers[123] := 683
			reversehalton_inst.prime_numbers[124] := 691
			reversehalton_inst.prime_numbers[125] := 701
			reversehalton_inst.prime_numbers[126] := 709
			reversehalton_inst.prime_numbers[127] := 719
			reversehalton_inst.prime_numbers[128] := 727
			reversehalton_inst.prime_numbers[129] := 733
			reversehalton_inst.prime_numbers[130] := 739
			reversehalton_inst.prime_numbers[131] := 743
			reversehalton_inst.prime_numbers[132] := 751
			reversehalton_inst.prime_numbers[133] := 757
			reversehalton_inst.prime_numbers[134] := 761
			reversehalton_inst.prime_numbers[135] := 769
			reversehalton_inst.prime_numbers[136] := 773
			reversehalton_inst.prime_numbers[137] := 787
			reversehalton_inst.prime_numbers[138] := 797
			reversehalton_inst.prime_numbers[139] := 809
			reversehalton_inst.prime_numbers[140] := 811
			reversehalton_inst.prime_numbers[141] := 821
			reversehalton_inst.prime_numbers[142] := 823
			reversehalton_inst.prime_numbers[143] := 827
			reversehalton_inst.prime_numbers[144] := 829
			reversehalton_inst.prime_numbers[145] := 839
			reversehalton_inst.prime_numbers[146] := 853
			reversehalton_inst.prime_numbers[147] := 857
			reversehalton_inst.prime_numbers[148] := 859
			reversehalton_inst.prime_numbers[149] := 863
			reversehalton_inst.prime_numbers[150] := 877
			reversehalton_inst.prime_numbers[151] := 881
			reversehalton_inst.prime_numbers[152] := 883
			reversehalton_inst.prime_numbers[153] := 887
			reversehalton_inst.prime_numbers[154] := 907
			reversehalton_inst.prime_numbers[155] := 911
			reversehalton_inst.prime_numbers[156] := 919
			reversehalton_inst.prime_numbers[157] := 929
			reversehalton_inst.prime_numbers[158] := 937
			reversehalton_inst.prime_numbers[159] := 941
			reversehalton_inst.prime_numbers[160] := 947
			reversehalton_inst.prime_numbers[161] := 953
			reversehalton_inst.prime_numbers[162] := 967
			reversehalton_inst.prime_numbers[163] := 971
			reversehalton_inst.prime_numbers[164] := 977
			reversehalton_inst.prime_numbers[165] := 983
			reversehalton_inst.prime_numbers[166] := 991
			reversehalton_inst.prime_numbers[167] := 997
			reversehalton_inst.prime_numbers[168] := 1009
			reversehalton_inst.prime_numbers[169] := 1013
			reversehalton_inst.prime_numbers[170] := 1019
			reversehalton_inst.prime_numbers[171] := 1021
			reversehalton_inst.prime_numbers[172] := 1031
			reversehalton_inst.prime_numbers[173] := 1033
			reversehalton_inst.prime_numbers[174] := 1039
			reversehalton_inst.prime_numbers[175] := 1049
			reversehalton_inst.prime_numbers[176] := 1051
			reversehalton_inst.prime_numbers[177] := 1061
			reversehalton_inst.prime_numbers[178] := 1063
			reversehalton_inst.prime_numbers[179] := 1069
			reversehalton_inst.prime_numbers[180] := 1087
			reversehalton_inst.prime_numbers[181] := 1091
			reversehalton_inst.prime_numbers[182] := 1093
			reversehalton_inst.prime_numbers[183] := 1097
			reversehalton_inst.prime_numbers[184] := 1103
			reversehalton_inst.prime_numbers[185] := 1109
			reversehalton_inst.prime_numbers[186] := 1117
			reversehalton_inst.prime_numbers[187] := 1123
			reversehalton_inst.prime_numbers[188] := 1129
			reversehalton_inst.prime_numbers[189] := 1151
			reversehalton_inst.prime_numbers[190] := 1153
			reversehalton_inst.prime_numbers[191] := 1163
			reversehalton_inst.prime_numbers[192] := 1171
			reversehalton_inst.prime_numbers[193] := 1181
			reversehalton_inst.prime_numbers[194] := 1187
			reversehalton_inst.prime_numbers[195] := 1193
			reversehalton_inst.prime_numbers[196] := 1201
			reversehalton_inst.prime_numbers[197] := 1213
			reversehalton_inst.prime_numbers[198] := 1217
			reversehalton_inst.prime_numbers[199] := 1223
			reversehalton_inst.prime_numbers[200] := 1229
			reversehalton_inst.prime_numbers[201] := 1231
			reversehalton_inst.prime_numbers[202] := 1237
			reversehalton_inst.prime_numbers[203] := 1249
			reversehalton_inst.prime_numbers[204] := 1259
			reversehalton_inst.prime_numbers[205] := 1277
			reversehalton_inst.prime_numbers[206] := 1279
			reversehalton_inst.prime_numbers[207] := 1283
			reversehalton_inst.prime_numbers[208] := 1289
			reversehalton_inst.prime_numbers[209] := 1291
			reversehalton_inst.prime_numbers[210] := 1297
			reversehalton_inst.prime_numbers[211] := 1301
			reversehalton_inst.prime_numbers[212] := 1303
			reversehalton_inst.prime_numbers[213] := 1307
			reversehalton_inst.prime_numbers[214] := 1319
			reversehalton_inst.prime_numbers[215] := 1321
			reversehalton_inst.prime_numbers[216] := 1327
			reversehalton_inst.prime_numbers[217] := 1361
			reversehalton_inst.prime_numbers[218] := 1367
			reversehalton_inst.prime_numbers[219] := 1373
			reversehalton_inst.prime_numbers[220] := 1381
			reversehalton_inst.prime_numbers[221] := 1399
			reversehalton_inst.prime_numbers[222] := 1409
			reversehalton_inst.prime_numbers[223] := 1423
			reversehalton_inst.prime_numbers[224] := 1427
			reversehalton_inst.prime_numbers[225] := 1429
			reversehalton_inst.prime_numbers[226] := 1433
			reversehalton_inst.prime_numbers[227] := 1439
			reversehalton_inst.prime_numbers[228] := 1447
			reversehalton_inst.prime_numbers[229] := 1451
			reversehalton_inst.prime_numbers[230] := 1453
			reversehalton_inst.prime_numbers[231] := 1459
			reversehalton_inst.prime_numbers[232] := 1471
			reversehalton_inst.prime_numbers[233] := 1481
			reversehalton_inst.prime_numbers[234] := 1483
			reversehalton_inst.prime_numbers[235] := 1487
			reversehalton_inst.prime_numbers[236] := 1489
			reversehalton_inst.prime_numbers[237] := 1493
			reversehalton_inst.prime_numbers[238] := 1499
			reversehalton_inst.prime_numbers[239] := 1511
			reversehalton_inst.prime_numbers[240] := 1523
			reversehalton_inst.prime_numbers[241] := 1531
			reversehalton_inst.prime_numbers[242] := 1543
			reversehalton_inst.prime_numbers[243] := 1549
			reversehalton_inst.prime_numbers[244] := 1553
			reversehalton_inst.prime_numbers[245] := 1559
			reversehalton_inst.prime_numbers[246] := 1567
			reversehalton_inst.prime_numbers[247] := 1571
			reversehalton_inst.prime_numbers[248] := 1579
			reversehalton_inst.prime_numbers[249] := 1583
			reversehalton_inst.prime_numbers[250] := 1597
			reversehalton_inst.prime_numbers[251] := 1601
			reversehalton_inst.prime_numbers[252] := 1607
			reversehalton_inst.prime_numbers[253] := 1609
			reversehalton_inst.prime_numbers[254] := 1613
			reversehalton_inst.prime_numbers[255] := 1619
			reversehalton_inst.prime_numbers[256] := 1621
			reversehalton_inst.prime_numbers[257] := 1627
			reversehalton_inst.prime_numbers[258] := 1637
			reversehalton_inst.prime_numbers[259] := 1657
			reversehalton_inst.prime_numbers[260] := 1663
			reversehalton_inst.prime_numbers[261] := 1667
			reversehalton_inst.prime_numbers[262] := 1669
			reversehalton_inst.prime_numbers[263] := 1693
			reversehalton_inst.prime_numbers[264] := 1697
			reversehalton_inst.prime_numbers[265] := 1699
			reversehalton_inst.prime_numbers[266] := 1709
			reversehalton_inst.prime_numbers[267] := 1721
			reversehalton_inst.prime_numbers[268] := 1723
			reversehalton_inst.prime_numbers[269] := 1733
			reversehalton_inst.prime_numbers[270] := 1741
			reversehalton_inst.prime_numbers[271] := 1747
			reversehalton_inst.prime_numbers[272] := 1753
			reversehalton_inst.prime_numbers[273] := 1759
			reversehalton_inst.prime_numbers[274] := 1777
			reversehalton_inst.prime_numbers[275] := 1783
			reversehalton_inst.prime_numbers[276] := 1787
			reversehalton_inst.prime_numbers[277] := 1789
			reversehalton_inst.prime_numbers[278] := 1801
			reversehalton_inst.prime_numbers[279] := 1811
			reversehalton_inst.prime_numbers[280] := 1823
			reversehalton_inst.prime_numbers[281] := 1831
			reversehalton_inst.prime_numbers[282] := 1847
			reversehalton_inst.prime_numbers[283] := 1861
			reversehalton_inst.prime_numbers[284] := 1867
			reversehalton_inst.prime_numbers[285] := 1871
			reversehalton_inst.prime_numbers[286] := 1873
			reversehalton_inst.prime_numbers[287] := 1877
			reversehalton_inst.prime_numbers[288] := 1879
			reversehalton_inst.prime_numbers[289] := 1889
			reversehalton_inst.prime_numbers[290] := 1901
			reversehalton_inst.prime_numbers[291] := 1907
			reversehalton_inst.prime_numbers[292] := 1913
			reversehalton_inst.prime_numbers[293] := 1931
			reversehalton_inst.prime_numbers[294] := 1933
			reversehalton_inst.prime_numbers[295] := 1949
			reversehalton_inst.prime_numbers[296] := 1951
			reversehalton_inst.prime_numbers[297] := 1973
			reversehalton_inst.prime_numbers[298] := 1979
			reversehalton_inst.prime_numbers[299] := 1987
			reversehalton_inst.prime_numbers[300] := 1993
			reversehalton_inst.prime_numbers[301] := 1997
			reversehalton_inst.prime_numbers[302] := 1999
			reversehalton_inst.prime_numbers[303] := 2003
			reversehalton_inst.prime_numbers[304] := 2011
			reversehalton_inst.prime_numbers[305] := 2017
			reversehalton_inst.prime_numbers[306] := 2027
			reversehalton_inst.prime_numbers[307] := 2029
			reversehalton_inst.prime_numbers[308] := 2039
			reversehalton_inst.prime_numbers[309] := 2053
			reversehalton_inst.prime_numbers[310] := 2063
			reversehalton_inst.prime_numbers[311] := 2069
			reversehalton_inst.prime_numbers[312] := 2081
			reversehalton_inst.prime_numbers[313] := 2083
			reversehalton_inst.prime_numbers[314] := 2087
			reversehalton_inst.prime_numbers[315] := 2089
			reversehalton_inst.prime_numbers[316] := 2099
			reversehalton_inst.prime_numbers[317] := 2111
			reversehalton_inst.prime_numbers[318] := 2113
			reversehalton_inst.prime_numbers[319] := 2129
			reversehalton_inst.prime_numbers[320] := 2131
			reversehalton_inst.prime_numbers[321] := 2137
			reversehalton_inst.prime_numbers[322] := 2141
			reversehalton_inst.prime_numbers[323] := 2143
			reversehalton_inst.prime_numbers[324] := 2153
			reversehalton_inst.prime_numbers[325] := 2161
			reversehalton_inst.prime_numbers[326] := 2179
			reversehalton_inst.prime_numbers[327] := 2203
			reversehalton_inst.prime_numbers[328] := 2207
			reversehalton_inst.prime_numbers[329] := 2213
			reversehalton_inst.prime_numbers[330] := 2221
			reversehalton_inst.prime_numbers[331] := 2237
			reversehalton_inst.prime_numbers[332] := 2239
			reversehalton_inst.prime_numbers[333] := 2243
			reversehalton_inst.prime_numbers[334] := 2251
			reversehalton_inst.prime_numbers[335] := 2267
			reversehalton_inst.prime_numbers[336] := 2269
			reversehalton_inst.prime_numbers[337] := 2273
			reversehalton_inst.prime_numbers[338] := 2281
			reversehalton_inst.prime_numbers[339] := 2287
			reversehalton_inst.prime_numbers[340] := 2293
			reversehalton_inst.prime_numbers[341] := 2297
			reversehalton_inst.prime_numbers[342] := 2309
			reversehalton_inst.prime_numbers[343] := 2311
			reversehalton_inst.prime_numbers[344] := 2333
			reversehalton_inst.prime_numbers[345] := 2339
			reversehalton_inst.prime_numbers[346] := 2341
			reversehalton_inst.prime_numbers[347] := 2347
			reversehalton_inst.prime_numbers[348] := 2351
			reversehalton_inst.prime_numbers[349] := 2357
			reversehalton_inst.prime_numbers[350] := 2371
			reversehalton_inst.prime_numbers[351] := 2377
			reversehalton_inst.prime_numbers[352] := 2381
			reversehalton_inst.prime_numbers[353] := 2383
			reversehalton_inst.prime_numbers[354] := 2389
			reversehalton_inst.prime_numbers[355] := 2393
			reversehalton_inst.prime_numbers[356] := 2399
			reversehalton_inst.prime_numbers[357] := 2411
			reversehalton_inst.prime_numbers[358] := 2417
			reversehalton_inst.prime_numbers[359] := 2423
			reversehalton_inst.prime_numbers[360] := 2437
			reversehalton_inst.prime_numbers[361] := 2441
			reversehalton_inst.prime_numbers[362] := 2447
			reversehalton_inst.prime_numbers[363] := 2459
			reversehalton_inst.prime_numbers[364] := 2467
			reversehalton_inst.prime_numbers[365] := 2473
			reversehalton_inst.prime_numbers[366] := 2477
			reversehalton_inst.prime_numbers[367] := 2503
			reversehalton_inst.prime_numbers[368] := 2521
			reversehalton_inst.prime_numbers[369] := 2531
			reversehalton_inst.prime_numbers[370] := 2539
			reversehalton_inst.prime_numbers[371] := 2543
			reversehalton_inst.prime_numbers[372] := 2549
			reversehalton_inst.prime_numbers[373] := 2551
			reversehalton_inst.prime_numbers[374] := 2557
			reversehalton_inst.prime_numbers[375] := 2579
			reversehalton_inst.prime_numbers[376] := 2591
			reversehalton_inst.prime_numbers[377] := 2593
			reversehalton_inst.prime_numbers[378] := 2609
			reversehalton_inst.prime_numbers[379] := 2617
			reversehalton_inst.prime_numbers[380] := 2621
			reversehalton_inst.prime_numbers[381] := 2633
			reversehalton_inst.prime_numbers[382] := 2647
			reversehalton_inst.prime_numbers[383] := 2657
			reversehalton_inst.prime_numbers[384] := 2659
			reversehalton_inst.prime_numbers[385] := 2663
			reversehalton_inst.prime_numbers[386] := 2671
			reversehalton_inst.prime_numbers[387] := 2677
			reversehalton_inst.prime_numbers[388] := 2683
			reversehalton_inst.prime_numbers[389] := 2687
			reversehalton_inst.prime_numbers[390] := 2689
			reversehalton_inst.prime_numbers[391] := 2693
			reversehalton_inst.prime_numbers[392] := 2699
			reversehalton_inst.prime_numbers[393] := 2707
			reversehalton_inst.prime_numbers[394] := 2711
			reversehalton_inst.prime_numbers[395] := 2713
			reversehalton_inst.prime_numbers[396] := 2719
			reversehalton_inst.prime_numbers[397] := 2729
			reversehalton_inst.prime_numbers[398] := 2731
			reversehalton_inst.prime_numbers[399] := 2741
			reversehalton_inst.prime_numbers[400] := 2749
			reversehalton_inst.prime_numbers[401] := 2753
			reversehalton_inst.prime_numbers[402] := 2767
			reversehalton_inst.prime_numbers[403] := 2777
			reversehalton_inst.prime_numbers[404] := 2789
			reversehalton_inst.prime_numbers[405] := 2791
			reversehalton_inst.prime_numbers[406] := 2797
			reversehalton_inst.prime_numbers[407] := 2801
			reversehalton_inst.prime_numbers[408] := 2803
			reversehalton_inst.prime_numbers[409] := 2819
			reversehalton_inst.prime_numbers[410] := 2833
			reversehalton_inst.prime_numbers[411] := 2837
			reversehalton_inst.prime_numbers[412] := 2843
			reversehalton_inst.prime_numbers[413] := 2851
			reversehalton_inst.prime_numbers[414] := 2857
			reversehalton_inst.prime_numbers[415] := 2861
			reversehalton_inst.prime_numbers[416] := 2879
			reversehalton_inst.prime_numbers[417] := 2887
			reversehalton_inst.prime_numbers[418] := 2897
			reversehalton_inst.prime_numbers[419] := 2903
			reversehalton_inst.prime_numbers[420] := 2909
			reversehalton_inst.prime_numbers[421] := 2917
			reversehalton_inst.prime_numbers[422] := 2927
			reversehalton_inst.prime_numbers[423] := 2939
			reversehalton_inst.prime_numbers[424] := 2953
			reversehalton_inst.prime_numbers[425] := 2957
			reversehalton_inst.prime_numbers[426] := 2963
			reversehalton_inst.prime_numbers[427] := 2969
			reversehalton_inst.prime_numbers[428] := 2971
			reversehalton_inst.prime_numbers[429] := 2999
			reversehalton_inst.prime_numbers[430] := 3001
			reversehalton_inst.prime_numbers[431] := 3011
			reversehalton_inst.prime_numbers[432] := 3019
			reversehalton_inst.prime_numbers[433] := 3023
			reversehalton_inst.prime_numbers[434] := 3037
			reversehalton_inst.prime_numbers[435] := 3041
			reversehalton_inst.prime_numbers[436] := 3049
			reversehalton_inst.prime_numbers[437] := 3061
			reversehalton_inst.prime_numbers[438] := 3067
			reversehalton_inst.prime_numbers[439] := 3079
			reversehalton_inst.prime_numbers[440] := 3083
			reversehalton_inst.prime_numbers[441] := 3089
			reversehalton_inst.prime_numbers[442] := 3109
			reversehalton_inst.prime_numbers[443] := 3119
			reversehalton_inst.prime_numbers[444] := 3121
			reversehalton_inst.prime_numbers[445] := 3137
			reversehalton_inst.prime_numbers[446] := 3163
			reversehalton_inst.prime_numbers[447] := 3167
			reversehalton_inst.prime_numbers[448] := 3169
			reversehalton_inst.prime_numbers[449] := 3181
			reversehalton_inst.prime_numbers[450] := 3187
			reversehalton_inst.prime_numbers[451] := 3191
			reversehalton_inst.prime_numbers[452] := 3203
			reversehalton_inst.prime_numbers[453] := 3209
			reversehalton_inst.prime_numbers[454] := 3217
			reversehalton_inst.prime_numbers[455] := 3221
			reversehalton_inst.prime_numbers[456] := 3229
			reversehalton_inst.prime_numbers[457] := 3251
			reversehalton_inst.prime_numbers[458] := 3253
			reversehalton_inst.prime_numbers[459] := 3257
			reversehalton_inst.prime_numbers[460] := 3259
			reversehalton_inst.prime_numbers[461] := 3271
			reversehalton_inst.prime_numbers[462] := 3299
			reversehalton_inst.prime_numbers[463] := 3301
			reversehalton_inst.prime_numbers[464] := 3307
			reversehalton_inst.prime_numbers[465] := 3313
		end

end
