frozen class
	LIBGSL_INITIALIZER_SLICE21

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {LIBGSL_INITIALIZER}

	initialize
		do
			fermi_dirac_inst.fd_2_c_data[17] := 6.447e-14
			fermi_dirac_inst.fd_2_c_data[18] := -7.39e-15
			fermi_dirac_inst.fd_2_c_data[19] := 4.3e-16
			fermi_dirac_inst.fd_2_c_cs.c := fermi_dirac_inst.fd_2_c_data
			fermi_dirac_inst.fd_2_c_cs.order := 19
			fermi_dirac_inst.fd_2_c_cs.a := (-1).to_double
			fermi_dirac_inst.fd_2_c_cs.b := (1).to_double
			fermi_dirac_inst.fd_2_c_cs.order_sp := 12
			fermi_dirac_inst.fd_2_d_data[0] := 0.3459960518965277589
			fermi_dirac_inst.fd_2_d_data[1] := -0.00633136397691958024
			fermi_dirac_inst.fd_2_d_data[2] := 0.00248382959047594408
			fermi_dirac_inst.fd_2_d_data[3] := -0.00087651191884005114
			fermi_dirac_inst.fd_2_d_data[4] := 0.00029139255351719932
			fermi_dirac_inst.fd_2_d_data[5] := -0.00009322746111846199
			fermi_dirac_inst.fd_2_d_data[6] := 0.00002904021914564786
			fermi_dirac_inst.fd_2_d_data[7] := -8.86962264810663e-6
			fermi_dirac_inst.fd_2_d_data[8] := 2.66844972574613e-6
			fermi_dirac_inst.fd_2_d_data[9] := -7.9331564996004e-7
			fermi_dirac_inst.fd_2_d_data[10] := 2.3359868615516e-7
			fermi_dirac_inst.fd_2_d_data[11] := -6.824790880436e-8
			fermi_dirac_inst.fd_2_d_data[12] := 1.981036528154e-8
			fermi_dirac_inst.fd_2_d_data[13] := -5.71940426300e-9
			fermi_dirac_inst.fd_2_d_data[14] := 1.64379426579e-9
			fermi_dirac_inst.fd_2_d_data[15] := -4.7064937566e-10
			fermi_dirac_inst.fd_2_d_data[16] := 1.3432614122e-10
			fermi_dirac_inst.fd_2_d_data[17] := -3.823400534e-11
			fermi_dirac_inst.fd_2_d_data[18] := 1.085771994e-11
			fermi_dirac_inst.fd_2_d_data[19] := -3.07727465e-12
			fermi_dirac_inst.fd_2_d_data[20] := 8.7064848e-13
			fermi_dirac_inst.fd_2_d_data[21] := -2.4595431e-13
			fermi_dirac_inst.fd_2_d_data[22] := 6.938531e-14
			fermi_dirac_inst.fd_2_d_data[23] := -1.954939e-14
			fermi_dirac_inst.fd_2_d_data[24] := 5.50162e-15
			fermi_dirac_inst.fd_2_d_data[25] := -1.54657e-15
			fermi_dirac_inst.fd_2_d_data[26] := 4.3429e-16
			fermi_dirac_inst.fd_2_d_data[27] := -1.2178e-16
			fermi_dirac_inst.fd_2_d_data[28] := 3.394e-17
			fermi_dirac_inst.fd_2_d_data[29] := -8.81e-18
			fermi_dirac_inst.fd_2_d_cs.c := fermi_dirac_inst.fd_2_d_data
			fermi_dirac_inst.fd_2_d_cs.order := 29
			fermi_dirac_inst.fd_2_d_cs.a := (-1).to_double
			fermi_dirac_inst.fd_2_d_cs.b := (1).to_double
			fermi_dirac_inst.fd_2_d_cs.order_sp := 14
			fermi_dirac_inst.fd_2_e_data[0] := 0.3347041117223735227
			fermi_dirac_inst.fd_2_e_data[1] := 0.00091385225936012645
			fermi_dirac_inst.fd_2_e_data[2] := 0.00022846306484003205
			fermi_dirac_inst.fd_2_e_data[3] := 5.2e-19
			fermi_dirac_inst.fd_2_e_cs.c := fermi_dirac_inst.fd_2_e_data
			fermi_dirac_inst.fd_2_e_cs.order := 3
			fermi_dirac_inst.fd_2_e_cs.a := (-1).to_double
			fermi_dirac_inst.fd_2_e_cs.b := (1).to_double
			fermi_dirac_inst.fd_2_e_cs.order_sp := 3
			fermi_dirac_inst.fd_mhalf_a_data[0] := 1.2663290042859741974
			fermi_dirac_inst.fd_mhalf_a_data[1] := 0.3697876251911153071
			fermi_dirac_inst.fd_mhalf_a_data[2] := 0.0278131011214405055
			fermi_dirac_inst.fd_mhalf_a_data[3] := -0.0033332848565672007
			fermi_dirac_inst.fd_mhalf_a_data[4] := -0.0004438108265412038
			fermi_dirac_inst.fd_mhalf_a_data[5] := 0.0000616495177243839
			fermi_dirac_inst.fd_mhalf_a_data[6] := 8.7589611449897e-6
			fermi_dirac_inst.fd_mhalf_a_data[7] := -1.2622936986172e-6
			fermi_dirac_inst.fd_mhalf_a_data[8] := -1.837464037221e-7
			fermi_dirac_inst.fd_mhalf_a_data[9] := 2.69495091400e-8
			fermi_dirac_inst.fd_mhalf_a_data[10] := 3.9760866257e-9
			fermi_dirac_inst.fd_mhalf_a_data[11] := -5.894468795e-10
			fermi_dirac_inst.fd_mhalf_a_data[12] := -8.77321638e-11
			fermi_dirac_inst.fd_mhalf_a_data[13] := 1.31016571e-11
			fermi_dirac_inst.fd_mhalf_a_data[14] := 1.9621619e-12
			fermi_dirac_inst.fd_mhalf_a_data[15] := -2.945887e-13
			fermi_dirac_inst.fd_mhalf_a_data[16] := -4.43234e-14
			fermi_dirac_inst.fd_mhalf_a_data[17] := 6.6816e-15
			fermi_dirac_inst.fd_mhalf_a_data[18] := 1.0084e-15
			fermi_dirac_inst.fd_mhalf_a_data[19] := -1.561e-16
			fermi_dirac_inst.fd_mhalf_a_cs.c := fermi_dirac_inst.fd_mhalf_a_data
			fermi_dirac_inst.fd_mhalf_a_cs.order := 19
			fermi_dirac_inst.fd_mhalf_a_cs.a := (-1).to_double
			fermi_dirac_inst.fd_mhalf_a_cs.b := (1).to_double
			fermi_dirac_inst.fd_mhalf_a_cs.order_sp := 12
			fermi_dirac_inst.fd_mhalf_b_data[0] := 3.270796131942071484
			fermi_dirac_inst.fd_mhalf_b_data[1] := 0.5809004935853417887
			fermi_dirac_inst.fd_mhalf_b_data[2] := -0.0299313438794694987
			fermi_dirac_inst.fd_mhalf_b_data[3] := -0.0013287935412612198
			fermi_dirac_inst.fd_mhalf_b_data[4] := 0.0009910221228704198
			fermi_dirac_inst.fd_mhalf_b_data[5] := -0.0001690954939688554
			fermi_dirac_inst.fd_mhalf_b_data[6] := 6.5955849946915e-6
			fermi_dirac_inst.fd_mhalf_b_data[7] := 3.5953966033618e-6
			fermi_dirac_inst.fd_mhalf_b_data[8] := -9.430672023181e-7
			fermi_dirac_inst.fd_mhalf_b_data[9] := 8.75773958291e-8
			fermi_dirac_inst.fd_mhalf_b_data[10] := 1.06247652607e-8
			fermi_dirac_inst.fd_mhalf_b_data[11] := -4.9587006215e-9
			fermi_dirac_inst.fd_mhalf_b_data[12] := 7.160432795e-10
			fermi_dirac_inst.fd_mhalf_b_data[13] := 4.5072219e-12
			fermi_dirac_inst.fd_mhalf_b_data[14] := -2.3695425e-11
			fermi_dirac_inst.fd_mhalf_b_data[15] := 4.9122208e-12
			fermi_dirac_inst.fd_mhalf_b_data[16] := -2.905277e-13
			fermi_dirac_inst.fd_mhalf_b_data[17] := -9.59291e-14
			fermi_dirac_inst.fd_mhalf_b_data[18] := 3.00028e-14
			fermi_dirac_inst.fd_mhalf_b_data[19] := -3.4970e-15
			fermi_dirac_inst.fd_mhalf_b_cs.c := fermi_dirac_inst.fd_mhalf_b_data
			fermi_dirac_inst.fd_mhalf_b_cs.order := 19
			fermi_dirac_inst.fd_mhalf_b_cs.a := (-1).to_double
			fermi_dirac_inst.fd_mhalf_b_cs.b := (1).to_double
			fermi_dirac_inst.fd_mhalf_b_cs.order_sp := 12
			fermi_dirac_inst.fd_mhalf_c_data[0] := 5.828283273430595507
			fermi_dirac_inst.fd_mhalf_c_data[1] := 0.677521118293264655
			fermi_dirac_inst.fd_mhalf_c_data[2] := -0.043946248736481554
			fermi_dirac_inst.fd_mhalf_c_data[3] := 0.005825595781828244
			fermi_dirac_inst.fd_mhalf_c_data[4] := -0.000864858907380668
			fermi_dirac_inst.fd_mhalf_c_data[5] := 0.000110017890076539
			fermi_dirac_inst.fd_mhalf_c_data[6] := -6.973305225404e-6
			fermi_dirac_inst.fd_mhalf_c_data[7] := -1.716267414672e-6
			fermi_dirac_inst.fd_mhalf_c_data[8] := 8.59811582041e-7
			fermi_dirac_inst.fd_mhalf_c_data[9] := -2.33066786976e-7
			fermi_dirac_inst.fd_mhalf_c_data[10] := 4.8503191159e-8
			fermi_dirac_inst.fd_mhalf_c_data[11] := -8.130620247e-9
			fermi_dirac_inst.fd_mhalf_c_data[12] := 1.021068250e-9
			fermi_dirac_inst.fd_mhalf_c_data[13] := -5.3188423e-11
			fermi_dirac_inst.fd_mhalf_c_data[14] := -1.9430559e-11
			fermi_dirac_inst.fd_mhalf_c_data[15] := 8.750506e-12
			fermi_dirac_inst.fd_mhalf_c_data[16] := -2.324897e-12
			fermi_dirac_inst.fd_mhalf_c_data[17] := 4.83102e-13
			fermi_dirac_inst.fd_mhalf_c_data[18] := -8.1207e-14
			fermi_dirac_inst.fd_mhalf_c_data[19] := 1.0132e-14
			fermi_dirac_inst.fd_mhalf_c_data[20] := -4.64e-16
			fermi_dirac_inst.fd_mhalf_c_data[21] := -2.24e-16
			fermi_dirac_inst.fd_mhalf_c_data[22] := 9.7e-17
			fermi_dirac_inst.fd_mhalf_c_data[23] := -2.6e-17
			fermi_dirac_inst.fd_mhalf_c_data[24] := 5.e-18
			fermi_dirac_inst.fd_mhalf_c_cs.c := fermi_dirac_inst.fd_mhalf_c_data
			fermi_dirac_inst.fd_mhalf_c_cs.order := 24
			fermi_dirac_inst.fd_mhalf_c_cs.a := (-1).to_double
			fermi_dirac_inst.fd_mhalf_c_cs.b := (1).to_double
			fermi_dirac_inst.fd_mhalf_c_cs.order_sp := 13
			fermi_dirac_inst.fd_mhalf_d_data[0] := 2.2530744202862438709
			fermi_dirac_inst.fd_mhalf_d_data[1] := 0.0018745152720114692
			fermi_dirac_inst.fd_mhalf_d_data[2] := -0.0007550198497498903
			fermi_dirac_inst.fd_mhalf_d_data[3] := 0.0002759818676644382
			fermi_dirac_inst.fd_mhalf_d_data[4] := -0.0000959406283465913
			fermi_dirac_inst.fd_mhalf_d_data[5] := 0.0000324056855537065
			fermi_dirac_inst.fd_mhalf_d_data[6] := -0.0000107462396145761
			fermi_dirac_inst.fd_mhalf_d_data[7] := 3.5126865219224e-6
			fermi_dirac_inst.fd_mhalf_d_data[8] := -1.1313072730092e-6
			fermi_dirac_inst.fd_mhalf_d_data[9] := 3.577454162766e-7
			fermi_dirac_inst.fd_mhalf_d_data[10] := -1.104926666238e-7
			fermi_dirac_inst.fd_mhalf_d_data[11] := 3.31304165692e-8
			fermi_dirac_inst.fd_mhalf_d_data[12] := -9.5837381008e-9
			fermi_dirac_inst.fd_mhalf_d_data[13] := 2.6575790141e-9
			fermi_dirac_inst.fd_mhalf_d_data[14] := -7.015201447e-10
			fermi_dirac_inst.fd_mhalf_d_data[15] := 1.747111336e-10
			fermi_dirac_inst.fd_mhalf_d_data[16] := -4.04909605e-11
			fermi_dirac_inst.fd_mhalf_d_data[17] := 8.5104999e-12
			fermi_dirac_inst.fd_mhalf_d_data[18] := -1.5261885e-12
			fermi_dirac_inst.fd_mhalf_d_data[19] := 1.876851e-13
			fermi_dirac_inst.fd_mhalf_d_data[20] := 1.00574e-14
			fermi_dirac_inst.fd_mhalf_d_data[21] := -1.82002e-14
			fermi_dirac_inst.fd_mhalf_d_data[22] := 8.6634e-15
			fermi_dirac_inst.fd_mhalf_d_data[23] := -3.2058e-15
			fermi_dirac_inst.fd_mhalf_d_data[24] := 1.0572e-15
			fermi_dirac_inst.fd_mhalf_d_data[25] := -3.259e-16
			fermi_dirac_inst.fd_mhalf_d_data[26] := 9.60e-17
			fermi_dirac_inst.fd_mhalf_d_data[27] := -2.74e-17
			fermi_dirac_inst.fd_mhalf_d_data[28] := 7.6e-18
			fermi_dirac_inst.fd_mhalf_d_data[29] := -1.9e-18
			fermi_dirac_inst.fd_mhalf_d_cs.c := fermi_dirac_inst.fd_mhalf_d_data
			fermi_dirac_inst.fd_mhalf_d_cs.order := 29
			fermi_dirac_inst.fd_mhalf_d_cs.a := (-1).to_double
			fermi_dirac_inst.fd_mhalf_d_cs.b := (1).to_double
			fermi_dirac_inst.fd_mhalf_d_cs.order_sp := 15
			fermi_dirac_inst.fd_half_a_data[0] := 1.7177138871306189157
			fermi_dirac_inst.fd_half_a_data[1] := 0.6192579515822668460
			fermi_dirac_inst.fd_half_a_data[2] := 0.0932802275119206269
			fermi_dirac_inst.fd_half_a_data[3] := 0.0047094853246636182
			fermi_dirac_inst.fd_half_a_data[4] := -0.0004243667967864481
			fermi_dirac_inst.fd_half_a_data[5] := -0.0000452569787686193
			fermi_dirac_inst.fd_half_a_data[6] := 5.2426509519168e-6
			fermi_dirac_inst.fd_half_a_data[7] := 6.387648249080e-7
			fermi_dirac_inst.fd_half_a_data[8] := -8.05777004848e-8
			fermi_dirac_inst.fd_half_a_data[9] := -1.04290272415e-8
			fermi_dirac_inst.fd_half_a_data[10] := 1.3769478010e-9
			fermi_dirac_inst.fd_half_a_data[11] := 1.847190359e-10
			fermi_dirac_inst.fd_half_a_data[12] := -2.51061890e-11
			fermi_dirac_inst.fd_half_a_data[13] := -3.4497818e-12
			fermi_dirac_inst.fd_half_a_data[14] := 4.784373e-13
			fermi_dirac_inst.fd_half_a_data[15] := 6.68828e-14
			fermi_dirac_inst.fd_half_a_data[16] := -9.4147e-15
			fermi_dirac_inst.fd_half_a_data[17] := -1.3333e-15
			fermi_dirac_inst.fd_half_a_data[18] := 1.898e-16
			fermi_dirac_inst.fd_half_a_data[19] := 2.72e-17
			fermi_dirac_inst.fd_half_a_data[20] := -3.9e-18
			fermi_dirac_inst.fd_half_a_data[21] := -6.e-19
			fermi_dirac_inst.fd_half_a_data[22] := 1.e-19
			fermi_dirac_inst.fd_half_a_cs.c := fermi_dirac_inst.fd_half_a_data
			fermi_dirac_inst.fd_half_a_cs.order := 22
			fermi_dirac_inst.fd_half_a_cs.a := (-1).to_double
			fermi_dirac_inst.fd_half_a_cs.b := (1).to_double
			fermi_dirac_inst.fd_half_a_cs.order_sp := 11
			fermi_dirac_inst.fd_half_b_data[0] := 7.651013792074984027
			fermi_dirac_inst.fd_half_b_data[1] := 2.475545606866155737
			fermi_dirac_inst.fd_half_b_data[2] := 0.218335982672476128
			fermi_dirac_inst.fd_half_b_data[3] := -0.007730591500584980
			fermi_dirac_inst.fd_half_b_data[4] := -0.000217443383867318
			fermi_dirac_inst.fd_half_b_data[5] := 0.000147663980681359
			fermi_dirac_inst.fd_half_b_data[6] := -0.000021586361321527
			fermi_dirac_inst.fd_half_b_data[7] := 8.07712735394e-7
			fermi_dirac_inst.fd_half_b_data[8] := 3.28858050706e-7
			fermi_dirac_inst.fd_half_b_data[9] := -7.9474330632e-8
			fermi_dirac_inst.fd_half_b_data[10] := 6.940207234e-9
			fermi_dirac_inst.fd_half_b_data[11] := 6.75594681e-10
			fermi_dirac_inst.fd_half_b_data[12] := -3.10200490e-10
			fermi_dirac_inst.fd_half_b_data[13] := 4.2677233e-11
			fermi_dirac_inst.fd_half_b_data[14] := -2.1696e-14
			fermi_dirac_inst.fd_half_b_data[15] := -1.170245e-12
			fermi_dirac_inst.fd_half_b_data[16] := 2.34757e-13
			fermi_dirac_inst.fd_half_b_data[17] := -1.4139e-14
			fermi_dirac_inst.fd_half_b_data[18] := -3.864e-15
			fermi_dirac_inst.fd_half_b_data[19] := 1.202e-15
			fermi_dirac_inst.fd_half_b_cs.c := fermi_dirac_inst.fd_half_b_data
			fermi_dirac_inst.fd_half_b_cs.order := 19
			fermi_dirac_inst.fd_half_b_cs.a := (-1).to_double
			fermi_dirac_inst.fd_half_b_cs.b := (1).to_double
			fermi_dirac_inst.fd_half_b_cs.order_sp := 12
			fermi_dirac_inst.fd_half_c_data[0] := 29.584339348839816528
			fermi_dirac_inst.fd_half_c_data[1] := 8.808344283250615592
			fermi_dirac_inst.fd_half_c_data[2] := 0.503771641883577308
			fermi_dirac_inst.fd_half_c_data[3] := -0.021540694914550443
			fermi_dirac_inst.fd_half_c_data[4] := 0.002143341709406890
			fermi_dirac_inst.fd_half_c_data[5] := -0.000257365680646579
			fermi_dirac_inst.fd_half_c_data[6] := 0.000027933539372803
			fermi_dirac_inst.fd_half_c_data[7] := -1.678525030167e-6
			fermi_dirac_inst.fd_half_c_data[8] := -2.78100117693e-7
			fermi_dirac_inst.fd_half_c_data[9] := 1.35218065147e-7
			fermi_dirac_inst.fd_half_c_data[10] := -3.3740425009e-8
			fermi_dirac_inst.fd_half_c_data[11] := 6.474834942e-9
			fermi_dirac_inst.fd_half_c_data[12] := -1.009678978e-9
			fermi_dirac_inst.fd_half_c_data[13] := 1.20057555e-10
			fermi_dirac_inst.fd_half_c_data[14] := -6.636314e-12
			fermi_dirac_inst.fd_half_c_data[15] := -1.710566e-12
			fermi_dirac_inst.fd_half_c_data[16] := 7.75069e-13
			fermi_dirac_inst.fd_half_c_data[17] := -1.97973e-13
			fermi_dirac_inst.fd_half_c_data[18] := 3.9414e-14
			fermi_dirac_inst.fd_half_c_data[19] := -6.374e-15
			fermi_dirac_inst.fd_half_c_data[20] := 7.77e-16
			fermi_dirac_inst.fd_half_c_data[21] := -4.0e-17
			fermi_dirac_inst.fd_half_c_data[22] := -1.4e-17
			fermi_dirac_inst.fd_half_c_cs.c := fermi_dirac_inst.fd_half_c_data
			fermi_dirac_inst.fd_half_c_cs.order := 22
			fermi_dirac_inst.fd_half_c_cs.a := (-1).to_double
			fermi_dirac_inst.fd_half_c_cs.b := (1).to_double
			fermi_dirac_inst.fd_half_c_cs.order_sp := 13
			fermi_dirac_inst.fd_half_d_data[0] := 1.5116909434145508537
			fermi_dirac_inst.fd_half_d_data[1] := -0.0036043405371630468
			fermi_dirac_inst.fd_half_d_data[2] := 0.0014207743256393359
			fermi_dirac_inst.fd_half_d_data[3] := -0.0005045399052400260
			fermi_dirac_inst.fd_half_d_data[4] := 0.0001690758006957347
			fermi_dirac_inst.fd_half_d_data[5] := -0.0000546305872688307
			fermi_dirac_inst.fd_half_d_data[6] := 0.0000172223228484571
			fermi_dirac_inst.fd_half_d_data[7] := -5.3352603788706e-6
			fermi_dirac_inst.fd_half_d_data[8] := 1.6315287543662e-6
			fermi_dirac_inst.fd_half_d_data[9] := -4.939021084898e-7
			fermi_dirac_inst.fd_half_d_data[10] := 1.482515450316e-7
			fermi_dirac_inst.fd_half_d_data[11] := -4.41552276226e-8
			fermi_dirac_inst.fd_half_d_data[12] := 1.30503160961e-8
			fermi_dirac_inst.fd_half_d_data[13] := -3.8262599802e-9
			fermi_dirac_inst.fd_half_d_data[14] := 1.1123226976e-9
			fermi_dirac_inst.fd_half_d_data[15] := -3.204765534e-10
			fermi_dirac_inst.fd_half_d_data[16] := 9.14870489e-11
			fermi_dirac_inst.fd_half_d_data[17] := -2.58778946e-11
			fermi_dirac_inst.fd_half_d_data[18] := 7.2550731e-12
			fermi_dirac_inst.fd_half_d_data[19] := -2.0172226e-12
			fermi_dirac_inst.fd_half_d_data[20] := 5.566891e-13
			fermi_dirac_inst.fd_half_d_data[21] := -1.526247e-13
			fermi_dirac_inst.fd_half_d_data[22] := 4.16121e-14
			fermi_dirac_inst.fd_half_d_data[23] := -1.12933e-14
			fermi_dirac_inst.fd_half_d_data[24] := 3.0537e-15
			fermi_dirac_inst.fd_half_d_data[25] := -8.234e-16
			fermi_dirac_inst.fd_half_d_data[26] := 2.215e-16
			fermi_dirac_inst.fd_half_d_data[27] := -5.95e-17
			fermi_dirac_inst.fd_half_d_data[28] := 1.59e-17
			fermi_dirac_inst.fd_half_d_data[29] := -4.0e-18
			fermi_dirac_inst.fd_half_d_cs.c := fermi_dirac_inst.fd_half_d_data
			fermi_dirac_inst.fd_half_d_cs.order := 29
			fermi_dirac_inst.fd_half_d_cs.a := (-1).to_double
			fermi_dirac_inst.fd_half_d_cs.b := (1).to_double
			fermi_dirac_inst.fd_half_d_cs.order_sp := 15
			fermi_dirac_inst.fd_3half_a_data[0] := 2.0404775940601704976
			fermi_dirac_inst.fd_3half_a_data[1] := 0.8122168298093491444
			fermi_dirac_inst.fd_3half_a_data[2] := 0.1536371165644008069
			fermi_dirac_inst.fd_3half_a_data[3] := 0.0156174323847845125
			fermi_dirac_inst.fd_3half_a_data[4] := 0.0005943427879290297
			fermi_dirac_inst.fd_3half_a_data[5] := -0.0000429609447738365
			fermi_dirac_inst.fd_3half_a_data[6] := -3.8246452994606e-6
			fermi_dirac_inst.fd_3half_a_data[7] := 3.802306180287e-7
			fermi_dirac_inst.fd_3half_a_data[8] := 4.05746157593e-8
			fermi_dirac_inst.fd_3half_a_data[9] := -4.5530360159e-9
			fermi_dirac_inst.fd_3half_a_data[10] := -5.306873139e-10
			fermi_dirac_inst.fd_3half_a_data[11] := 6.37297268e-11
			fermi_dirac_inst.fd_3half_a_data[12] := 7.8403674e-12
			fermi_dirac_inst.fd_3half_a_data[13] := -9.840241e-13
			fermi_dirac_inst.fd_3half_a_data[14] := -1.255952e-13
			fermi_dirac_inst.fd_3half_a_data[15] := 1.62617e-14
			fermi_dirac_inst.fd_3half_a_data[16] := 2.1318e-15
			fermi_dirac_inst.fd_3half_a_data[17] := -2.825e-16
			fermi_dirac_inst.fd_3half_a_data[18] := -3.78e-17
			fermi_dirac_inst.fd_3half_a_data[19] := 5.1e-18
			fermi_dirac_inst.fd_3half_a_cs.c := fermi_dirac_inst.fd_3half_a_data
			fermi_dirac_inst.fd_3half_a_cs.order := 19
			fermi_dirac_inst.fd_3half_a_cs.a := (-1).to_double
			fermi_dirac_inst.fd_3half_a_cs.b := (1).to_double
			fermi_dirac_inst.fd_3half_a_cs.order_sp := 11
			fermi_dirac_inst.fd_3half_b_data[0] := 13.403206654624176674
			fermi_dirac_inst.fd_3half_b_data[1] := 5.574508357051880924
			fermi_dirac_inst.fd_3half_b_data[2] := 0.931228574387527769
			fermi_dirac_inst.fd_3half_b_data[3] := 0.054638356514085862
			fermi_dirac_inst.fd_3half_b_data[4] := -0.001477172902737439
			fermi_dirac_inst.fd_3half_b_data[5] := -0.000029378553381869
			fermi_dirac_inst.fd_3half_b_data[6] := 0.000018357033493246
			fermi_dirac_inst.fd_3half_b_data[7] := -2.348059218454e-6
			fermi_dirac_inst.fd_3half_b_data[8] := 8.3173787440e-8
			fermi_dirac_inst.fd_3half_b_data[9] := 2.6826486956e-8
			fermi_dirac_inst.fd_3half_b_data[10] := -6.011244398e-9
			fermi_dirac_inst.fd_3half_b_data[11] := 4.94345981e-10
			fermi_dirac_inst.fd_3half_b_data[12] := 3.9557340e-11
			fermi_dirac_inst.fd_3half_b_data[13] := -1.7894930e-11
			fermi_dirac_inst.fd_3half_b_data[14] := 2.348972e-12
			fermi_dirac_inst.fd_3half_b_data[15] := -1.2823e-14
			fermi_dirac_inst.fd_3half_b_data[16] := -5.4192e-14
			fermi_dirac_inst.fd_3half_b_data[17] := 1.0527e-14
			fermi_dirac_inst.fd_3half_b_data[18] := -6.39e-16
			fermi_dirac_inst.fd_3half_b_data[19] := -1.47e-16
			fermi_dirac_inst.fd_3half_b_data[20] := 4.5e-17
			fermi_dirac_inst.fd_3half_b_data[21] := -5.e-18
			fermi_dirac_inst.fd_3half_b_cs.c := fermi_dirac_inst.fd_3half_b_data
			fermi_dirac_inst.fd_3half_b_cs.order := 21
			fermi_dirac_inst.fd_3half_b_cs.a := (-1).to_double
			fermi_dirac_inst.fd_3half_b_cs.b := (1).to_double
			fermi_dirac_inst.fd_3half_b_cs.order_sp := 12
			fermi_dirac_inst.fd_3half_c_data[0] := 101.03685253378877642
			fermi_dirac_inst.fd_3half_c_data[1] := 43.62085156043435883
			fermi_dirac_inst.fd_3half_c_data[2] := 6.62241373362387453
			fermi_dirac_inst.fd_3half_c_data[3] := 0.25081415008708521
			fermi_dirac_inst.fd_3half_c_data[4] := -0.00798124846271395
			fermi_dirac_inst.fd_3half_c_data[5] := 0.00063462245101023
			fermi_dirac_inst.fd_3half_c_data[6] := -0.00006392178890410
			fermi_dirac_inst.fd_3half_c_data[7] := 6.04535131939e-6
			fermi_dirac_inst.fd_3half_c_data[8] := -3.4007683037e-7
			fermi_dirac_inst.fd_3half_c_data[9] := -4.072661545e-8
			fermi_dirac_inst.fd_3half_c_data[10] := 1.931148453e-8
			fermi_dirac_inst.fd_3half_c_data[11] := -4.46328355e-9
			fermi_dirac_inst.fd_3half_c_data[12] := 7.9434717e-10
			fermi_dirac_inst.fd_3half_c_data[13] := -1.1573569e-10
			fermi_dirac_inst.fd_3half_c_data[14] := 1.304658e-11
			fermi_dirac_inst.fd_3half_c_data[15] := -7.4114e-13
			fermi_dirac_inst.fd_3half_c_data[16] := -1.4181e-13
			fermi_dirac_inst.fd_3half_c_data[17] := 6.491e-14
			fermi_dirac_inst.fd_3half_c_data[18] := -1.597e-14
			fermi_dirac_inst.fd_3half_c_data[19] := 3.05e-15
			fermi_dirac_inst.fd_3half_c_data[20] := -4.8e-16
			fermi_dirac_inst.fd_3half_c_cs.c := fermi_dirac_inst.fd_3half_c_data
			fermi_dirac_inst.fd_3half_c_cs.order := 20
			fermi_dirac_inst.fd_3half_c_cs.a := (-1).to_double
			fermi_dirac_inst.fd_3half_c_cs.b := (1).to_double
			fermi_dirac_inst.fd_3half_c_cs.order_sp := 12
			fermi_dirac_inst.fd_3half_d_data[0] := 0.6160645215171852381
			fermi_dirac_inst.fd_3half_d_data[1] := -0.0071239478492671463
			fermi_dirac_inst.fd_3half_d_data[2] := 0.0027906866139659846
			fermi_dirac_inst.fd_3half_d_data[3] := -0.0009829521424317718
			fermi_dirac_inst.fd_3half_d_data[4] := 0.0003260229808519545
			fermi_dirac_inst.fd_3half_d_data[5] := -0.0001040160912910890
			fermi_dirac_inst.fd_3half_d_data[6] := 0.0000322931223232439
			fermi_dirac_inst.fd_3half_d_data[7] := -9.8243506588102e-6
			fermi_dirac_inst.fd_3half_d_data[8] := 2.9420132351277e-6
			fermi_dirac_inst.fd_3half_d_data[9] := -8.699154670418e-7
			fermi_dirac_inst.fd_3half_d_data[10] := 2.545460071999e-7
			fermi_dirac_inst.fd_3half_d_data[11] := -7.38305056331e-8
			fermi_dirac_inst.fd_3half_d_data[12] := 2.12545670310e-8
			fermi_dirac_inst.fd_3half_d_data[13] := -6.0796532462e-9
			fermi_dirac_inst.fd_3half_d_data[14] := 1.7294556741e-9
			fermi_dirac_inst.fd_3half_d_data[15] := -4.896540687e-10
			fermi_dirac_inst.fd_3half_d_data[16] := 1.380786037e-10
			fermi_dirac_inst.fd_3half_d_data[17] := -3.88057305e-11
			fermi_dirac_inst.fd_3half_d_data[18] := 1.08753212e-11
			fermi_dirac_inst.fd_3half_d_data[19] := -3.0407308e-12
			fermi_dirac_inst.fd_3half_d_data[20] := 8.485626e-13
			fermi_dirac_inst.fd_3half_d_data[21] := -2.364275e-13
			fermi_dirac_inst.fd_3half_d_data[22] := 6.57636e-14
			fermi_dirac_inst.fd_3half_d_data[23] := -1.81807e-14
			fermi_dirac_inst.fd_3half_d_data[24] := 4.6884e-15
			fermi_dirac_inst.fd_3half_d_cs.c := fermi_dirac_inst.fd_3half_d_data
			fermi_dirac_inst.fd_3half_d_cs.order := 24
			fermi_dirac_inst.fd_3half_d_cs.a := (-1).to_double
			fermi_dirac_inst.fd_3half_d_cs.b := (1).to_double
			fermi_dirac_inst.fd_3half_d_cs.order_sp := 16
			airy_zero_inst.zero_Ai[0] := (0).to_double
			airy_zero_inst.zero_Ai[1] := (-2.338107410459767039)
			airy_zero_inst.zero_Ai[2] := (-4.087949444130970617)
			airy_zero_inst.zero_Ai[3] := (-5.520559828095551059)
			airy_zero_inst.zero_Ai[4] := (-6.786708090071758999)
			airy_zero_inst.zero_Ai[5] := (-7.944133587120853123)
			airy_zero_inst.zero_Ai[6] := (-9.022650853340980380)
			airy_zero_inst.zero_Ai[7] := (-10.04017434155808593)
			airy_zero_inst.zero_Ai[8] := (-11.00852430373326289)
			airy_zero_inst.zero_Ai[9] := (-11.93601556323626252)
			airy_zero_inst.zero_Ai[10] := (-12.82877675286575720)
			airy_zero_inst.zero_Ai[11] := (-13.69148903521071793)
			airy_zero_inst.zero_Ai[12] := (-14.52782995177533498)
			airy_zero_inst.zero_Ai[13] := (-15.34075513597799686)
			airy_zero_inst.zero_Ai[14] := (-16.13268515694577144)
			airy_zero_inst.zero_Ai[15] := (-16.90563399742994263)
			airy_zero_inst.zero_Ai[16] := (-17.661300105697057509)
			airy_zero_inst.zero_Ai[17] := (-18.401132599207115416)
			airy_zero_inst.zero_Ai[18] := (-19.126380474246952144)
			airy_zero_inst.zero_Ai[19] := (-19.838129891721499701)
			airy_zero_inst.zero_Ai[20] := (-20.537332907677566360)
			airy_zero_inst.zero_Ai[21] := (-21.224829943642096955)
			airy_zero_inst.zero_Ai[22] := (-21.901367595585130707)
			airy_zero_inst.zero_Ai[23] := (-22.567612917496502831)
			airy_zero_inst.zero_Ai[24] := (-23.224165001121681061)
			airy_zero_inst.zero_Ai[25] := (-23.871564455535918567)
			airy_zero_inst.zero_Ai[26] := (-24.510301236589677490)
			airy_zero_inst.zero_Ai[27] := (-25.140821166148963748)
			airy_zero_inst.zero_Ai[28] := (-25.763531400982756459)
			airy_zero_inst.zero_Ai[29] := (-26.378805052137232374)
			airy_zero_inst.zero_Ai[30] := (-26.986985111606367686)
			airy_zero_inst.zero_Ai[31] := (-27.588387809882444812)
			airy_zero_inst.zero_Ai[32] := (-28.183305502632644923)
			airy_zero_inst.zero_Ai[33] := (-28.772009165237435382)
			airy_zero_inst.zero_Ai[34] := (-29.354750558766287963)
			airy_zero_inst.zero_Ai[35] := (-29.931764119086555913)
			airy_zero_inst.zero_Ai[36] := (-30.503268611418505287)
			airy_zero_inst.zero_Ai[37] := (-31.069468585183755604)
			airy_zero_inst.zero_Ai[38] := (-31.63055565801265934)
			airy_zero_inst.zero_Ai[39] := (-32.18670965295205069)
			airy_zero_inst.zero_Ai[40] := (-32.73809960900026913)
			airy_zero_inst.zero_Ai[41] := (-33.28488468190140188)
			airy_zero_inst.zero_Ai[42] := (-33.82721494950865194)
			airy_zero_inst.zero_Ai[43] := (-34.36523213386365906)
			airy_zero_inst.zero_Ai[44] := (-34.89907025034531210)
			airy_zero_inst.zero_Ai[45] := (-35.42885619274788846)
			airy_zero_inst.zero_Ai[46] := (-35.95471026189862926)
			airy_zero_inst.zero_Ai[47] := (-36.47674664437480896)
			airy_zero_inst.zero_Ai[48] := (-36.99507384699450161)
			airy_zero_inst.zero_Ai[49] := (-37.50979509200501613)
			airy_zero_inst.zero_Ai[50] := (-38.02100867725525443)
			airy_zero_inst.zero_Ai[51] := (-38.52880830509424882)
			airy_zero_inst.zero_Ai[52] := (-39.03328338327251391)
			airy_zero_inst.zero_Ai[53] := (-39.53451930072301805)
			airy_zero_inst.zero_Ai[54] := (-40.03259768075417603)
			airy_zero_inst.zero_Ai[55] := (-40.52759661388971821)
			airy_zero_inst.zero_Ai[56] := (-41.01959087233248966)
			airy_zero_inst.zero_Ai[57] := (-41.50865210780525018)
			airy_zero_inst.zero_Ai[58] := (-41.99484903432643004)
			airy_zero_inst.zero_Ai[59] := (-42.47824759730839188)
			airy_zero_inst.zero_Ai[60] := (-42.95891113021656009)
			airy_zero_inst.zero_Ai[61] := (-43.43690049989685412)
			airy_zero_inst.zero_Ai[62] := (-43.91227424156370168)
			airy_zero_inst.zero_Ai[63] := (-44.38508868433939023)
			airy_zero_inst.zero_Ai[64] := (-44.85539806814583243)
			airy_zero_inst.zero_Ai[65] := (-45.32325465267043011)
			airy_zero_inst.zero_Ai[66] := (-45.78870881905730086)
			airy_zero_inst.zero_Ai[67] := (-46.25180916491254629)
			airy_zero_inst.zero_Ai[68] := (-46.71260259315651633)
			airy_zero_inst.zero_Ai[69] := (-47.17113439520631705)
			airy_zero_inst.zero_Ai[70] := (-47.62744832892739292)
			airy_zero_inst.zero_Ai[71] := (-48.08158669175325711)
			airy_zero_inst.zero_Ai[72] := (-48.53359038933679845)
			airy_zero_inst.zero_Ai[73] := (-48.98349900006458366)
			airy_zero_inst.zero_Ai[74] := (-49.43135083573678341)
			airy_zero_inst.zero_Ai[75] := (-49.87718299868941729)
			airy_zero_inst.zero_Ai[76] := (-50.32103143561221860)
			airy_zero_inst.zero_Ai[77] := (-50.76293098829428522)
			airy_zero_inst.zero_Ai[78] := (-51.20291544151056412)
			airy_zero_inst.zero_Ai[79] := (-51.64101756824489758)
			airy_zero_inst.zero_Ai[80] := (-52.07726917242964943)
			airy_zero_inst.zero_Ai[81] := (-52.51170112936766183)
			airy_zero_inst.zero_Ai[82] := (-52.94434342398931824)
			airy_zero_inst.zero_Ai[83] := (-53.37522518708567514)
			airy_zero_inst.zero_Ai[84] := (-53.80437472964785717)
			airy_zero_inst.zero_Ai[85] := (-54.23181957543308298)
			airy_zero_inst.zero_Ai[86] := (-54.65758649186871111)
			airy_zero_inst.zero_Ai[87] := (-55.08170151939748312)
			airy_zero_inst.zero_Ai[88] := (-55.50418999935962251)
			airy_zero_inst.zero_Ai[89] := (-55.92507660050055598)
			airy_zero_inst.zero_Ai[90] := (-56.34438534418670066)
			airy_zero_inst.zero_Ai[91] := (-56.76213962840595327)
			airy_zero_inst.zero_Ai[92] := (-57.17836225062417808)
			airy_zero_inst.zero_Ai[93] := (-57.59307542956407782)
			airy_zero_inst.zero_Ai[94] := (-58.00630082596830627)
			airy_zero_inst.zero_Ai[95] := (-58.41805956240450934)
			airy_zero_inst.zero_Ai[96] := (-58.82837224216613231)
			airy_zero_inst.zero_Ai[97] := (-59.23725896731927534)
			airy_zero_inst.zero_Ai[98] := (-59.64473935594259360)
			airy_zero_inst.zero_Ai[99] := (-60.05083255860419805)
			airy_zero_inst.zero_Ai[100] := (-60.45555727411669871)
			airy_zero_inst.size_zero_Ai := ((Real_64_bytes.to_natural_32 * (101).to_natural_32) // Real_64_bytes.to_natural_32)
			airy_zero_inst.zero_Bi[0] := (0).to_double
			airy_zero_inst.zero_Bi[1] := (-1.173713222709127925)
			airy_zero_inst.zero_Bi[2] := (-3.271093302836352716)
			airy_zero_inst.zero_Bi[3] := (-4.830737841662015933)
			airy_zero_inst.zero_Bi[4] := (-6.169852128310251260)
			airy_zero_inst.zero_Bi[5] := (-7.376762079367763714)
			airy_zero_inst.zero_Bi[6] := (-8.491948846509388013)
		end

end
