class
	P_CTBSV

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_ctbsv (a_order: INTEGER_32; a_Uplo: INTEGER_32; a_TransA: INTEGER_32; a_Diag: INTEGER_32; a_N: INTEGER_32; a_K: INTEGER_32; a_A___0: CE_POINTER [ANY]; a_lda: INTEGER_32; a_X: CE_POINTER [ANY]; a_incX: INTEGER_32)
		local
			l_conj: INTEGER_32
			l_tmp: INTEGER_32
			l_Trans: INTEGER_32
			l_tmp___0: NATURAL_32
			l_nonunit: INTEGER_32
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_ix: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp_real: REAL_32
			l_tmp_imag: REAL_32
			l_j_min: INTEGER_32
			l_j_max: INTEGER_32
			l_tmp___2: INTEGER_32
			l_jx: INTEGER_32
			l_tmp___3: INTEGER_32
			l_Aij_real: REAL_32
			l_Aij_imag: REAL_32
			l_x_real: REAL_32
			l_x_imag: REAL_32
			l_a_real: REAL_32
			l_a_imag: REAL_32
			l_s: REAL_32
			l_b_real: REAL_32
			l_b_imag: REAL_32
			l_tmp___5: INTEGER_32
			l_ix___0: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp_real___0: REAL_32
			l_tmp_imag___0: REAL_32
			l_j_min___0: INTEGER_32
			l_tmp___7: INTEGER_32
			l_j_max___0: INTEGER_32
			l_jx___0: INTEGER_32
			l_tmp___8: INTEGER_32
			l_Aij_real___0: REAL_32
			l_Aij_imag___0: REAL_32
			l_x_real___0: REAL_32
			l_x_imag___0: REAL_32
			l_a_real___0: REAL_32
			l_a_imag___0: REAL_32
			l_s___0: REAL_32
			l_b_real___0: REAL_32
			l_b_imag___0: REAL_32
			l_ix___1: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp_real___1: REAL_32
			l_tmp_imag___1: REAL_32
			l_j_min___1: INTEGER_32
			l_tmp___11: INTEGER_32
			l_j_max___1: INTEGER_32
			l_jx___1: INTEGER_32
			l_tmp___12: INTEGER_32
			l_Aij_real___1: REAL_32
			l_Aij_imag___1: REAL_32
			l_x_real___1: REAL_32
			l_x_imag___1: REAL_32
			l_a_real___1: REAL_32
			l_a_imag___1: REAL_32
			l_s___1: REAL_32
			l_b_real___1: REAL_32
			l_b_imag___1: REAL_32
			l_ix___2: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp_real___2: REAL_32
			l_tmp_imag___2: REAL_32
			l_j_min___2: INTEGER_32
			l_j_max___2: INTEGER_32
			l_tmp___15: INTEGER_32
			l_jx___2: INTEGER_32
			l_tmp___16: INTEGER_32
			l_Aij_real___2: REAL_32
			l_Aij_imag___2: REAL_32
			l_x_real___2: REAL_32
			l_x_imag___2: REAL_32
			l_a_real___2: REAL_32
			l_a_imag___2: REAL_32
			l_s___2: REAL_32
			l_b_real___2: REAL_32
			l_b_imag___2: REAL_32
			l_tmp___18: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_TransA.to_natural_32 = {NATURAL_32} 113 then
						l_tmp := -1
					else
						l_tmp := 1
					end
					l_conj := l_tmp
					if a_TransA.to_natural_32 /= {NATURAL_32} 113 then
						l_tmp___0 := a_TransA.to_natural_32
					else
						l_tmp___0 := {NATURAL_32} 112
					end
					l_Trans := l_tmp___0.to_integer_32
					l_nonunit := (a_Diag.to_natural_32 = {NATURAL_32} 131).to_integer
					if a_N = 0 then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 50 -- skip if block
					end
				when 1 then -- if:
						if a_order.to_natural_32 /= {NATURAL_32} 101 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_Trans = 111 then
							if a_Uplo.to_natural_32 = {NATURAL_32} 121 then
								l_pos := -1 + 7 -- goto _L___12
							else
								l_pos := -1 + 4 -- goto _L___16
							end
						else
							l_pos := -1 + 4 -- goto _L___16
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 4 then -- else: | _L___16:
						if a_order.to_natural_32 /= {NATURAL_32} 102 then
							l_pos := -1 + 13 -- skip if block
						end
				when 5 then -- if:
						if l_Trans /= 112 then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if:
						if a_Uplo.to_natural_32 /= {NATURAL_32} 122 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___12:
						if a_incX > 0 then
							l_tmp___1 := 0
						else
							l_tmp___1 := (a_N - 1) * -a_incX
						end
						l_ix := l_tmp___1 + a_incX * (a_N - 1)
						l_i := a_N
						from
						until
							js.loop_left
						loop
							js.reset
							if l_i > 0 then
								l_tmp___5 := l_i
								l_i := l_i - 1
								if not l_tmp___5.to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_tmp_real := create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix]
								l_tmp_imag := create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix + 1)]
								l_j_min := l_i + 1
								if a_N < (l_i + a_K) + 1 then
									l_tmp___2 := a_N
								else
									l_tmp___2 := (l_i + a_K) + 1
								end
								l_j_max := l_tmp___2
								if a_incX > 0 then
									l_tmp___3 := 0
								else
									l_tmp___3 := (a_N - 1) * -a_incX
								end
								l_jx := l_tmp___3 + l_j_min * a_incX
								l_j := l_j_min
								from
								until
									not (l_j < l_j_max)
								loop
									l_Aij_real := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (a_lda * l_i + (l_j - l_i))]
									l_Aij_imag := (l_conj.to_real * create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (a_lda * l_i + (l_j - l_i)) + 1)])
									l_x_real := create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_jx]
									l_x_imag := create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_jx + 1)]
									l_tmp_real := l_tmp_real - (l_Aij_real * l_x_real - l_Aij_imag * l_x_imag)
									l_tmp_imag := l_tmp_imag - (l_Aij_real * l_x_imag + l_Aij_imag * l_x_real)
									l_jx := l_jx + a_incX
									l_j := l_j + 1
								end
								if l_nonunit.to_boolean then
									l_a_real := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (a_lda * l_i)]
									l_a_imag := (l_conj.to_real * create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (a_lda * l_i) + 1)])
									l_s := (hypot_inst.xhypot (l_a_real.to_double, l_a_imag.to_double)).truncated_to_real
									l_b_real := l_a_real / l_s
									l_b_imag := l_a_imag / l_s
									create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix] := (l_tmp_real * l_b_real + l_tmp_imag * l_b_imag) / l_s
									create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix + 1)] := (l_tmp_imag * l_b_real - l_tmp_real * l_b_imag) / l_s
								else
									create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix] := l_tmp_real
									create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix + 1)] := l_tmp_imag
								end
								l_ix := l_ix - a_incX
							end
						end
						js.reset
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_pos := -1 + 13 -- goto _L___14
				when 10 then -- if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_pos := -1 + 13 -- goto _L___14
				when 12 then -- if done | if block done, skip else block:
						l_pos := -1 + 50
				when 13 then -- else: | _L___14:
						if a_order.to_natural_32 /= {NATURAL_32} 101 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if l_Trans = 111 then
							if a_Uplo.to_natural_32 = {NATURAL_32} 122 then
								l_pos := -1 + 19 -- goto _L___7
							else
								l_pos := -1 + 16 -- goto _L___11
							end
						else
							l_pos := -1 + 16 -- goto _L___11
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 16 then -- else: | _L___11:
						if a_order.to_natural_32 /= {NATURAL_32} 102 then
							l_pos := -1 + 25 -- skip if block
						end
				when 17 then -- if:
						if l_Trans /= 112 then
							l_pos := -1 + 23 -- skip if block
						end
				when 18 then -- if:
						if a_Uplo.to_natural_32 /= {NATURAL_32} 121 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if: | _L___7:
						if a_incX > 0 then
							l_tmp___6 := 0
						else
							l_tmp___6 := (a_N - 1) * -a_incX
						end
						l_ix___0 := l_tmp___6
						l_i := 0
						from
						until
							not (not js.loop_left and then (l_i < a_N))
						loop
							l_tmp_real___0 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix___0]
							l_tmp_imag___0 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix___0 + 1)]
							if a_K > l_i then
								l_tmp___7 := 0
							else
								l_tmp___7 := l_i - a_K
							end
							l_j_min___0 := l_tmp___7
							l_j_max___0 := l_i
							if a_incX > 0 then
								l_tmp___8 := 0
							else
								l_tmp___8 := (a_N - 1) * -a_incX
							end
							l_jx___0 := l_tmp___8 + l_j_min___0 * a_incX
							l_j := l_j_min___0
							from
							until
								not (l_j < l_j_max___0)
							loop
								l_Aij_real___0 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (a_lda * l_i + ((a_K + l_j) - l_i))]
								l_Aij_imag___0 := (l_conj.to_real * create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (a_lda * l_i + ((a_K + l_j) - l_i)) + 1)])
								l_x_real___0 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_jx___0]
								l_x_imag___0 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_jx___0 + 1)]
								l_tmp_real___0 := l_tmp_real___0 - (l_Aij_real___0 * l_x_real___0 - l_Aij_imag___0 * l_x_imag___0)
								l_tmp_imag___0 := l_tmp_imag___0 - (l_Aij_real___0 * l_x_imag___0 + l_Aij_imag___0 * l_x_real___0)
								l_jx___0 := l_jx___0 + a_incX
								l_j := l_j + 1
							end
							if l_nonunit.to_boolean then
								l_a_real___0 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (a_lda * l_i + a_K)]
								l_a_imag___0 := (l_conj.to_real * create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (a_lda * l_i + a_K) + 1)])
								l_s___0 := (hypot_inst.xhypot (l_a_real___0.to_double, l_a_imag___0.to_double)).truncated_to_real
								l_b_real___0 := l_a_real___0 / l_s___0
								l_b_imag___0 := l_a_imag___0 / l_s___0
								create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix___0] := (l_tmp_real___0 * l_b_real___0 + l_tmp_imag___0 * l_b_imag___0) / l_s___0
								create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix___0 + 1)] := (l_tmp_imag___0 * l_b_real___0 - l_tmp_real___0 * l_b_imag___0) / l_s___0
							else
								create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix___0] := l_tmp_real___0
								create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix___0 + 1)] := l_tmp_imag___0
							end
							l_ix___0 := l_ix___0 + a_incX
							l_i := l_i + 1
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else:
						l_pos := -1 + 25 -- goto _L___9
				when 22 then -- if done | if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else:
						l_pos := -1 + 25 -- goto _L___9
				when 24 then -- if done | if block done, skip else block:
						l_pos := -1 + 50
				when 25 then -- else: | _L___9:
						if a_order.to_natural_32 /= {NATURAL_32} 101 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						if l_Trans = 112 then
							if a_Uplo.to_natural_32 = {NATURAL_32} 121 then
								l_pos := -1 + 31 -- goto _L___2
							else
								l_pos := -1 + 28 -- goto _L___6
							end
						else
							l_pos := -1 + 28 -- goto _L___6
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 28 then -- else: | _L___6:
						if a_order.to_natural_32 /= {NATURAL_32} 102 then
							l_pos := -1 + 37 -- skip if block
						end
				when 29 then -- if:
						if l_Trans /= 111 then
							l_pos := -1 + 35 -- skip if block
						end
				when 30 then -- if:
						if a_Uplo.to_natural_32 /= {NATURAL_32} 122 then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if: | _L___2:
						if a_incX > 0 then
							l_tmp___10 := 0
						else
							l_tmp___10 := (a_N - 1) * -a_incX
						end
						l_ix___1 := l_tmp___10
						l_i := 0
						from
						until
							not (not js.loop_left and then (l_i < a_N))
						loop
							l_tmp_real___1 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix___1]
							l_tmp_imag___1 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix___1 + 1)]
							if a_K > l_i then
								l_tmp___11 := 0
							else
								l_tmp___11 := l_i - a_K
							end
							l_j_min___1 := l_tmp___11
							l_j_max___1 := l_i
							if a_incX > 0 then
								l_tmp___12 := 0
							else
								l_tmp___12 := (a_N - 1) * -a_incX
							end
							l_jx___1 := l_tmp___12 + l_j_min___1 * a_incX
							l_j := l_j_min___1
							from
							until
								not (l_j < l_j_max___1)
							loop
								l_Aij_real___1 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * ((l_i - l_j) + a_lda * l_j)]
								l_Aij_imag___1 := (l_conj.to_real * create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * ((l_i - l_j) + a_lda * l_j) + 1)])
								l_x_real___1 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_jx___1]
								l_x_imag___1 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_jx___1 + 1)]
								l_tmp_real___1 := l_tmp_real___1 - (l_Aij_real___1 * l_x_real___1 - l_Aij_imag___1 * l_x_imag___1)
								l_tmp_imag___1 := l_tmp_imag___1 - (l_Aij_real___1 * l_x_imag___1 + l_Aij_imag___1 * l_x_real___1)
								l_jx___1 := l_jx___1 + a_incX
								l_j := l_j + 1
							end
							if l_nonunit.to_boolean then
								l_a_real___1 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (a_lda * l_i)]
								l_a_imag___1 := (l_conj.to_real * create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (a_lda * l_i) + 1)])
								l_s___1 := (hypot_inst.xhypot (l_a_real___1.to_double, l_a_imag___1.to_double)).truncated_to_real
								l_b_real___1 := l_a_real___1 / l_s___1
								l_b_imag___1 := l_a_imag___1 / l_s___1
								create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix___1] := (l_tmp_real___1 * l_b_real___1 + l_tmp_imag___1 * l_b_imag___1) / l_s___1
								create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix___1 + 1)] := (l_tmp_imag___1 * l_b_real___1 - l_tmp_real___1 * l_b_imag___1) / l_s___1
							else
								create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix___1] := l_tmp_real___1
								create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix___1 + 1)] := l_tmp_imag___1
							end
							l_ix___1 := l_ix___1 + a_incX
							l_i := l_i + 1
						end
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 33 then -- else:
						l_pos := -1 + 37 -- goto _L___4
				when 34 then -- if done | if block done, skip else block:
						l_pos := -1 + 36
				when 35 then -- else:
						l_pos := -1 + 37 -- goto _L___4
				when 36 then -- if done | if block done, skip else block:
						l_pos := -1 + 50
				when 37 then -- else: | _L___4:
						if a_order.to_natural_32 /= {NATURAL_32} 101 then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						if l_Trans = 112 then
							if a_Uplo.to_natural_32 = {NATURAL_32} 122 then
								l_pos := -1 + 43 -- goto _L
							else
								l_pos := -1 + 40 -- goto _L___1
							end
						else
							l_pos := -1 + 40 -- goto _L___1
						end
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 40 then -- else: | _L___1:
						if a_order.to_natural_32 /= {NATURAL_32} 102 then
							l_pos := -1 + 49 -- skip if block
						end
				when 41 then -- if:
						if l_Trans /= 111 then
							l_pos := -1 + 47 -- skip if block
						end
				when 42 then -- if:
						if a_Uplo.to_natural_32 /= {NATURAL_32} 121 then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if: | _L:
						if a_incX > 0 then
							l_tmp___14 := 0
						else
							l_tmp___14 := (a_N - 1) * -a_incX
						end
						l_ix___2 := l_tmp___14 + a_incX * (a_N - 1)
						l_i := a_N
						from
						until
							js.loop_left
						loop
							js.reset
							if l_i > 0 then
								l_tmp___18 := l_i
								l_i := l_i - 1
								if not l_tmp___18.to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_tmp_real___2 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix___2]
								l_tmp_imag___2 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix___2 + 1)]
								l_j_min___2 := l_i + 1
								if a_N < (l_i + a_K) + 1 then
									l_tmp___15 := a_N
								else
									l_tmp___15 := (l_i + a_K) + 1
								end
								l_j_max___2 := l_tmp___15
								if a_incX > 0 then
									l_tmp___16 := 0
								else
									l_tmp___16 := (a_N - 1) * -a_incX
								end
								l_jx___2 := l_tmp___16 + l_j_min___2 * a_incX
								l_j := l_j_min___2
								from
								until
									not (l_j < l_j_max___2)
								loop
									l_Aij_real___2 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (((a_K + l_i) - l_j) + a_lda * l_j)]
									l_Aij_imag___2 := (l_conj.to_real * create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (((a_K + l_i) - l_j) + a_lda * l_j) + 1)])
									l_x_real___2 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_jx___2]
									l_x_imag___2 := create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_jx___2 + 1)]
									l_tmp_real___2 := l_tmp_real___2 - (l_Aij_real___2 * l_x_real___2 - l_Aij_imag___2 * l_x_imag___2)
									l_tmp_imag___2 := l_tmp_imag___2 - (l_Aij_real___2 * l_x_imag___2 + l_Aij_imag___2 * l_x_real___2)
									l_jx___2 := l_jx___2 + a_incX
									l_j := l_j + 1
								end
								if l_nonunit.to_boolean then
									l_a_real___2 := create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[2 * (a_K + a_lda * l_i)]
									l_a_imag___2 := (l_conj.to_real * create {CE_POINTER [REAL_32]}.make_cast (a_A___0)[(2 * (a_K + a_lda * l_i) + 1)])
									l_s___2 := (hypot_inst.xhypot (l_a_real___2.to_double, l_a_imag___2.to_double)).truncated_to_real
									l_b_real___2 := l_a_real___2 / l_s___2
									l_b_imag___2 := l_a_imag___2 / l_s___2
									create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix___2] := (l_tmp_real___2 * l_b_real___2 + l_tmp_imag___2 * l_b_imag___2) / l_s___2
									create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix___2 + 1)] := (l_tmp_imag___2 * l_b_real___2 - l_tmp_real___2 * l_b_imag___2) / l_s___2
								else
									create {CE_POINTER [REAL_32]}.make_cast (a_X)[2 * l_ix___2] := l_tmp_real___2
									create {CE_POINTER [REAL_32]}.make_cast (a_X)[(2 * l_ix___2 + 1)] := l_tmp_imag___2
								end
								l_ix___2 := l_ix___2 - a_incX
							end
						end
						js.reset
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 45 then -- else:
						xerbla_inst.cblas_xerbla ([0, ce_string ("source_tbsv_c.h"), ce_string ("unrecognized operation")])
				when 46 then -- if done | if block done, skip else block:
						l_pos := -1 + 48
				when 47 then -- else:
						xerbla_inst.cblas_xerbla ([0, ce_string ("source_tbsv_c.h"), ce_string ("unrecognized operation")])
				when 48 then -- if done | if block done, skip else block:
						l_pos := -1 + 50
				when 49 then -- else:
						xerbla_inst.cblas_xerbla ([0, ce_string ("source_tbsv_c.h"), ce_string ("unrecognized operation")])
				when 50 then -- if done | if done | if done | if done | if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
