class
	P_DSCAL

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_dscal (a_N: INTEGER_32; a_alpha: REAL_64; a_X: CE_POINTER [REAL_64]; a_incX: INTEGER_32)
		local
			l_i: INTEGER_32
			l_ix: INTEGER_32
			js: JUMP_STATE
		do
			l_ix := 0
			if a_incX <= 0 then
				js.return
			end
			if not js.return_called then
				l_i := 0
				from
				until
					not (l_i < a_N)
				loop
					a_X[l_ix] := a_X[l_ix] * a_alpha
					l_ix := l_ix + a_incX
					l_i := l_i + 1
				end
			end
		end

end
