class
	P_DTRMM

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_dtrmm (a_Order: INTEGER_32; a_Side: INTEGER_32; a_Uplo: INTEGER_32; a_TransA: INTEGER_32; a_Diag: INTEGER_32; a_M: INTEGER_32; a_N: INTEGER_32; a_alpha: REAL_64; a_A___0: CE_POINTER [REAL_64]; a_lda: INTEGER_32; a_B: CE_POINTER [REAL_64]; a_ldb: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_n1: INTEGER_32
			l_n2: INTEGER_32
			l_nonunit: INTEGER_32
			l_side: INTEGER_32
			l_uplo: INTEGER_32
			l_trans: INTEGER_32
			l_temp: REAL_64
			l_temp___0: REAL_64
			l_tmp: INTEGER_32
			l_temp___1: REAL_64
			l_tmp___0: INTEGER_32
			l_temp___2: REAL_64
			l_temp___3: REAL_64
			l_tmp___1: INTEGER_32
			l_temp___4: REAL_64
			l_temp___5: REAL_64
			l_temp___6: REAL_64
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_nonunit := (a_Diag.to_natural_32 = {NATURAL_32} 131).to_integer
					if a_Order.to_natural_32 = {NATURAL_32} 101 then
						l_n1 := a_M
						l_n2 := a_N
						l_side := a_Side
						l_uplo := a_Uplo
						if a_TransA.to_natural_32 = {NATURAL_32} 113 then
							l_trans := 112
						else
							l_trans := a_TransA
						end
					else
						l_n1 := a_N
						l_n2 := a_M
						if a_Side.to_natural_32 = {NATURAL_32} 141 then
							l_side := 142
						else
							l_side := 141
						end
						if a_Uplo.to_natural_32 = {NATURAL_32} 121 then
							l_uplo := 122
						else
							l_uplo := 121
						end
						if a_TransA.to_natural_32 = {NATURAL_32} 113 then
							l_trans := 112
						else
							l_trans := a_TransA
						end
					end
					if l_side /= 141 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_uplo = 121 then
							if l_trans = 111 then
								l_i := 0
								from
								until
									not (not js.loop_left and then (l_i < l_n1))
								loop
									l_j := 0
									from
									until
										not (not js.loop_left and then (l_j < l_n2))
									loop
										l_temp := 0.0
										if l_nonunit.to_boolean then
											l_temp := (a_A___0[(l_i * a_lda + l_i)] * a_B[(l_i * a_ldb + l_j)])
										else
											l_temp := a_B[(l_i * a_ldb + l_j)]
										end
										l_k := l_i + 1
										from
										until
											not (l_k < l_n1)
										loop
											l_temp := l_temp + (a_A___0[(a_lda * l_i + l_k)] * a_B[(l_k * a_ldb + l_j)])
											l_k := l_k + 1
										end
										a_B[(a_ldb * l_i + l_j)] := a_alpha * l_temp
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								l_pos := -1 + 3 -- goto _L___12
							end
						else
							l_pos := -1 + 3 -- goto _L___12
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 3 then -- else: | _L___12:
						if l_side /= 141 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_uplo = 121 then
							if l_trans = 112 then
								l_i := l_n1
								from
								until
									js.loop_left
								loop
									js.reset
									if l_i > 0 then
										l_tmp := l_i
										l_i := l_i - 1
										if not l_tmp.to_boolean then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_j := 0
										from
										until
											not (not js.loop_left and then (l_j < l_n2))
										loop
											l_temp___0 := 0.0
											l_k := 0
											from
											until
												not (l_k < l_i)
											loop
												l_temp___0 := l_temp___0 + (a_A___0[(a_lda * l_k + l_i)] * a_B[(l_k * a_ldb + l_j)])
												l_k := l_k + 1
											end
											if l_nonunit.to_boolean then
												l_temp___0 := l_temp___0 + (a_A___0[(l_i * a_lda + l_i)] * a_B[(l_i * a_ldb + l_j)])
											else
												l_temp___0 := l_temp___0 + (a_B[(l_i * a_ldb + l_j)])
											end
											a_B[(a_ldb * l_i + l_j)] := a_alpha * l_temp___0
											l_j := l_j + 1
										end
									end
								end
								js.reset
							else
								l_pos := -1 + 6 -- goto _L___10
							end
						else
							l_pos := -1 + 6 -- goto _L___10
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 6 then -- else: | _L___10:
						if l_side /= 141 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_uplo = 122 then
							if l_trans = 111 then
								l_i := l_n1
								from
								until
									js.loop_left
								loop
									js.reset
									if l_i > 0 then
										l_tmp___0 := l_i
										l_i := l_i - 1
										if not l_tmp___0.to_boolean then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_j := 0
										from
										until
											not (not js.loop_left and then (l_j < l_n2))
										loop
											l_temp___1 := 0.0
											l_k := 0
											from
											until
												not (l_k < l_i)
											loop
												l_temp___1 := l_temp___1 + (a_A___0[(a_lda * l_i + l_k)] * a_B[(l_k * a_ldb + l_j)])
												l_k := l_k + 1
											end
											if l_nonunit.to_boolean then
												l_temp___1 := l_temp___1 + (a_A___0[(l_i * a_lda + l_i)] * a_B[(l_i * a_ldb + l_j)])
											else
												l_temp___1 := l_temp___1 + (a_B[(l_i * a_ldb + l_j)])
											end
											a_B[(a_ldb * l_i + l_j)] := a_alpha * l_temp___1
											l_j := l_j + 1
										end
									end
								end
								js.reset
							else
								l_pos := -1 + 9 -- goto _L___8
							end
						else
							l_pos := -1 + 9 -- goto _L___8
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 9 then -- else: | _L___8:
						if l_side /= 141 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if l_uplo = 122 then
							if l_trans = 112 then
								l_i := 0
								from
								until
									not (not js.loop_left and then (l_i < l_n1))
								loop
									l_j := 0
									from
									until
										not (not js.loop_left and then (l_j < l_n2))
									loop
										l_temp___2 := 0.0
										if l_nonunit.to_boolean then
											l_temp___2 := (a_A___0[(l_i * a_lda + l_i)] * a_B[(l_i * a_ldb + l_j)])
										else
											l_temp___2 := a_B[(l_i * a_ldb + l_j)]
										end
										l_k := l_i + 1
										from
										until
											not (l_k < l_n1)
										loop
											l_temp___2 := l_temp___2 + (a_A___0[(a_lda * l_k + l_i)] * a_B[(l_k * a_ldb + l_j)])
											l_k := l_k + 1
										end
										a_B[(a_ldb * l_i + l_j)] := a_alpha * l_temp___2
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								l_pos := -1 + 12 -- goto _L___6
							end
						else
							l_pos := -1 + 12 -- goto _L___6
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 12 then -- else: | _L___6:
						if l_side /= 142 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if l_uplo = 121 then
							if l_trans = 111 then
								l_i := 0
								from
								until
									not (not js.loop_left and then (l_i < l_n1))
								loop
									l_j := l_n2
									from
									until
										js.loop_left
									loop
										js.reset
										if l_j > 0 then
											l_tmp___1 := l_j
											l_j := l_j - 1
											if not l_tmp___1.to_boolean then
												js.break
											end
										else
											js.break
										end
										if not js.loop_jumped then
											l_temp___3 := 0.0
											l_k := 0
											from
											until
												not (l_k < l_j)
											loop
												l_temp___3 := l_temp___3 + (a_A___0[(a_lda * l_k + l_j)] * a_B[(l_i * a_ldb + l_k)])
												l_k := l_k + 1
											end
											if l_nonunit.to_boolean then
												l_temp___3 := l_temp___3 + (a_A___0[(l_j * a_lda + l_j)] * a_B[(l_i * a_ldb + l_j)])
											else
												l_temp___3 := l_temp___3 + (a_B[(l_i * a_ldb + l_j)])
											end
											a_B[(a_ldb * l_i + l_j)] := a_alpha * l_temp___3
										end
									end
									js.reset
									l_i := l_i + 1
								end
							else
								l_pos := -1 + 15 -- goto _L___4
							end
						else
							l_pos := -1 + 15 -- goto _L___4
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 15 then -- else: | _L___4:
						if l_side /= 142 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if l_uplo = 121 then
							if l_trans = 112 then
								l_i := 0
								from
								until
									not (not js.loop_left and then (l_i < l_n1))
								loop
									l_j := 0
									from
									until
										not (not js.loop_left and then (l_j < l_n2))
									loop
										l_temp___4 := 0.0
										if l_nonunit.to_boolean then
											l_temp___4 := (a_A___0[(l_j * a_lda + l_j)] * a_B[(l_i * a_ldb + l_j)])
										else
											l_temp___4 := a_B[(l_i * a_ldb + l_j)]
										end
										l_k := l_j + 1
										from
										until
											not (l_k < l_n2)
										loop
											l_temp___4 := l_temp___4 + (a_A___0[(a_lda * l_j + l_k)] * a_B[(l_i * a_ldb + l_k)])
											l_k := l_k + 1
										end
										a_B[(a_ldb * l_i + l_j)] := a_alpha * l_temp___4
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								l_pos := -1 + 18 -- goto _L___2
							end
						else
							l_pos := -1 + 18 -- goto _L___2
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 18 then -- else: | _L___2:
						if l_side /= 142 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if l_uplo = 122 then
							if l_trans = 111 then
								l_i := 0
								from
								until
									not (not js.loop_left and then (l_i < l_n1))
								loop
									l_j := 0
									from
									until
										not (not js.loop_left and then (l_j < l_n2))
									loop
										l_temp___5 := 0.0
										if l_nonunit.to_boolean then
											l_temp___5 := (a_A___0[(l_j * a_lda + l_j)] * a_B[(l_i * a_ldb + l_j)])
										else
											l_temp___5 := a_B[(l_i * a_ldb + l_j)]
										end
										l_k := l_j + 1
										from
										until
											not (l_k < l_n2)
										loop
											l_temp___5 := l_temp___5 + (a_A___0[(a_lda * l_k + l_j)] * a_B[(l_i * a_ldb + l_k)])
											l_k := l_k + 1
										end
										a_B[(a_ldb * l_i + l_j)] := a_alpha * l_temp___5
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								l_pos := -1 + 21 -- goto _L___0
							end
						else
							l_pos := -1 + 21 -- goto _L___0
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else: | _L___0:
						if l_side = 142 then
							if l_uplo = 122 then
								if l_trans = 112 then
									l_i := 0
									from
									until
										not (not js.loop_left and then (l_i < l_n1))
									loop
										l_j := l_n2
										from
										until
											js.loop_left
										loop
											js.reset
											if l_j > 0 then
												l_tmp___2 := l_j
												l_j := l_j - 1
												if not l_tmp___2.to_boolean then
													js.break
												end
											else
												js.break
											end
											if not js.loop_jumped then
												l_temp___6 := 0.0
												l_k := 0
												from
												until
													not (l_k < l_j)
												loop
													l_temp___6 := l_temp___6 + (a_A___0[(a_lda * l_j + l_k)] * a_B[(l_i * a_ldb + l_k)])
													l_k := l_k + 1
												end
												if l_nonunit.to_boolean then
													l_temp___6 := l_temp___6 + (a_A___0[(l_j * a_lda + l_j)] * a_B[(l_i * a_ldb + l_j)])
												else
													l_temp___6 := l_temp___6 + (a_B[(l_i * a_ldb + l_j)])
												end
												a_B[(a_ldb * l_i + l_j)] := a_alpha * l_temp___6
											end
										end
										js.reset
										l_i := l_i + 1
									end
								else
									xerbla_inst.cblas_xerbla ([0, ce_string ("source_trmm_r.h"), ce_string ("unrecognized operation")])
								end
							else
								xerbla_inst.cblas_xerbla ([0, ce_string ("source_trmm_r.h"), ce_string ("unrecognized operation")])
							end
						else
							xerbla_inst.cblas_xerbla ([0, ce_string ("source_trmm_r.h"), ce_string ("unrecognized operation")])
						end
				when 22 then -- if done | if done | if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
