class
	P_ERR

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	rescale_error (a_err: REAL_64; a_result_abs: REAL_64; a_result_asc: REAL_64): REAL_64
		local
			l_err: REAL_64
			l_scale: REAL_64
			l_min_err: REAL_64
		do
			l_err := a_err
			l_err := fabs (l_err)
			if a_result_asc /= (0).to_double then
				if l_err /= (0).to_double then
					l_scale := (pow (((200).to_double * l_err) / a_result_asc, 1.5))
					if l_scale < (1).to_double then
						l_err := a_result_asc * l_scale
					else
						l_err := a_result_asc
					end
				end
			end
			if a_result_abs > 2.2250738585072014e-308 / ((50).to_double * 2.2204460492503131e-16) then
				l_min_err := ((50).to_double * 2.2204460492503131e-16) * a_result_abs
				if l_min_err > l_err then
					l_err := l_min_err
				end
			end
			Result := l_err
		end

	rescale_error___0 (a_err: REAL_64; a_result_abs: REAL_64; a_result_asc: REAL_64): REAL_64
		local
			l_err: REAL_64
			l_scale: REAL_64
			l_min_err: REAL_64
		do
			l_err := a_err
			l_err := fabs (l_err)
			if a_result_asc /= (0).to_double then
				if l_err /= (0).to_double then
					l_scale := (pow (((200).to_double * l_err) / a_result_asc, 1.5))
					if l_scale < (1).to_double then
						l_err := a_result_asc * l_scale
					else
						l_err := a_result_asc
					end
				end
			end
			if a_result_abs > 2.2250738585072014e-308 / ((50).to_double * 2.2204460492503131e-16) then
				l_min_err := ((50).to_double * 2.2204460492503131e-16) * a_result_abs
				if l_min_err > l_err then
					l_err := l_min_err
				end
			end
			Result := l_err
		end

end
