class
	P_FDFMINIMIZER

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_multimin_fdfminimizer_alloc (a_T: CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER_TYPE]; a_n: NATURAL_32): CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER]
		local
			l_status: INTEGER_32
			l_s: CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER]
			js: JUMP_STATE
		do
			create l_s.make

			l_s.ce_gets (create {CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER]}.make_cast ((malloc ({PD_GSL_MULTIMIN_FDFMINIMIZER}.sizeof.to_natural_32))))
			if (l_s.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("failed to allocate space for minimizer struct"), ce_string ("fdfminimizer.c"), 36, 8)
					Result := (create {CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.item.type := a_T
				l_s.item.x := init_source_inst.gsl_vector_calloc (a_n)
				if ((l_s.item.x).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for x"), ce_string ("fdfminimizer.c"), 46, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_s.item.gradient := init_source_inst.gsl_vector_calloc (a_n)
				if ((l_s.item.gradient).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_vector_free (l_s.item.x)
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for gradient"), ce_string ("fdfminimizer.c"), 55, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_s.item.dx := init_source_inst.gsl_vector_calloc (a_n)
				if ((l_s.item.dx).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_vector_free (l_s.item.x)
					init_source_inst.gsl_vector_free (l_s.item.gradient)
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for dx"), ce_string ("fdfminimizer.c"), 65, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_s.item.state := malloc (a_T.item.size)
				if ((l_s.item.state).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_vector_free (l_s.item.x)
					init_source_inst.gsl_vector_free (l_s.item.gradient)
					init_source_inst.gsl_vector_free (l_s.item.dx)
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for minimizer state"), ce_string ("fdfminimizer.c"), 77, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_status := (a_T.item.alloc).integer_32_item ([l_s.item.state, a_n])
				if l_status /= 0 then
					free (l_s.item.state)
					init_source_inst.gsl_vector_free (l_s.item.x)
					init_source_inst.gsl_vector_free (l_s.item.gradient)
					init_source_inst.gsl_vector_free (l_s.item.dx)
					free (create {CE_POINTER [ANY]}.make_cast (l_s))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to initialize minimizer state"), ce_string ("fdfminimizer.c"), 90, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				Result := l_s
			end
		end

	gsl_multimin_fdfminimizer_set (a_s: CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER]; a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_step_size: REAL_64; a_tol: REAL_64): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (a_s.item.x).item.size /= a_fdf.item.n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("function incompatible with solver size"), ce_string ("fdfminimizer.c"), 104, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called and then (a_x.item.size /= a_fdf.item.n) then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("vector length not compatible with function"), ce_string ("fdfminimizer.c"), 109, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				a_s.item.fdf := a_fdf
				copy_source_inst.gsl_vector_memcpy (a_s.item.x, a_x).do_nothing
				init_source_inst.gsl_vector_set_zero (a_s.item.dx)
				Result := (((a_s.item.type).item.set).integer_32_item ([a_s.item.state, a_s.item.fdf, a_s.item.x, create {CE_POINTER [REAL_64]}.make_shared (a_s.c_pointer + {PD_GSL_MULTIMIN_FDFMINIMIZER}.f_offset), a_s.item.gradient, a_step_size, a_tol]))
			end
		end

	gsl_multimin_fdfminimizer_free (a_s: CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER])
		local
			js: JUMP_STATE
		do
			if (a_s).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				((a_s.item.type).item.free).call ([a_s.item.state])
				free (a_s.item.state)
				init_source_inst.gsl_vector_free (a_s.item.dx)
				init_source_inst.gsl_vector_free (a_s.item.gradient)
				init_source_inst.gsl_vector_free (a_s.item.x)
				free (create {CE_POINTER [ANY]}.make_cast (a_s))
			end
		end

	gsl_multimin_fdfminimizer_iterate (a_s: CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER]): INTEGER_32
		do
			Result := (((a_s.item.type).item.iterate).integer_32_item ([a_s.item.state, a_s.item.fdf, a_s.item.x, create {CE_POINTER [REAL_64]}.make_shared (a_s.c_pointer + {PD_GSL_MULTIMIN_FDFMINIMIZER}.f_offset), a_s.item.gradient, a_s.item.dx]))
		end

	gsl_multimin_fdfminimizer_restart (a_s: CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER]): INTEGER_32
		do
			Result := (((a_s.item.type).item.restart).integer_32_item ([a_s.item.state]))
		end

	gsl_multimin_fdfminimizer_name (a_s: CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER]): CE_POINTER [INTEGER_8]
		do
			Result := ((a_s.item.type).item.name)
		end

	gsl_multimin_fdfminimizer_x (a_s: CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER]): CE_POINTER [PD_GSL_VECTOR]
		do
			Result := (a_s.item.x)
		end

	gsl_multimin_fdfminimizer_dx (a_s: CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER]): CE_POINTER [PD_GSL_VECTOR]
		do
			Result := (a_s.item.dx)
		end

	gsl_multimin_fdfminimizer_gradient (a_s: CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER]): CE_POINTER [PD_GSL_VECTOR]
		do
			Result := (a_s.item.gradient)
		end

	gsl_multimin_fdfminimizer_minimum (a_s: CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER]): REAL_64
		do
			Result := (a_s.item.f)
		end

end
