class
	P_GSL_GSL_MATRIX_UINT

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_matrix_uint_get (a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]; a_i: NATURAL_32; a_j: NATURAL_32): NATURAL_32
		do
			Result := (a_m___4.item.data[(a_i * a_m___4.item.tda + a_j).to_integer_32])
		end

	gsl_matrix_uint_set (a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]; a_i: NATURAL_32; a_j: NATURAL_32; a_x: NATURAL_32)
		do
			a_m___4.item.data[(a_i * a_m___4.item.tda + a_j).to_integer_32] := a_x
		end

	gsl_matrix_uint_ptr (a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]; a_i: NATURAL_32; a_j: NATURAL_32): CE_POINTER [NATURAL_32]
		do
			Result := (a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32)
		end

	gsl_matrix_uint_const_ptr (a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]; a_i: NATURAL_32; a_j: NATURAL_32): CE_POINTER [NATURAL_32]
		do
			Result := (a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32)
		end

end
