class
	P_GSL_GSL_POW_INT

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_pow_2 (a_x: REAL_64): REAL_64
		do
			Result := (a_x * a_x)
		end

	gsl_pow_3 (a_x: REAL_64): REAL_64
		do
			Result := ((a_x * a_x) * a_x)
		end

	gsl_pow_4 (a_x: REAL_64): REAL_64
		local
			l_x2___1: REAL_64
		do
			l_x2___1 := a_x * a_x
			Result := (l_x2___1 * l_x2___1)
		end

	gsl_pow_5 (a_x: REAL_64): REAL_64
		local
			l_x2___1: REAL_64
		do
			l_x2___1 := a_x * a_x
			Result := ((l_x2___1 * l_x2___1) * a_x)
		end

	gsl_pow_6 (a_x: REAL_64): REAL_64
		local
			l_x2___1: REAL_64
		do
			l_x2___1 := a_x * a_x
			Result := ((l_x2___1 * l_x2___1) * l_x2___1)
		end

	gsl_pow_7 (a_x: REAL_64): REAL_64
		local
			l_x3___1: REAL_64
		do
			l_x3___1 := (a_x * a_x) * a_x
			Result := ((l_x3___1 * l_x3___1) * a_x)
		end

	gsl_pow_8 (a_x: REAL_64): REAL_64
		local
			l_x2___1: REAL_64
			l_x4___1: REAL_64
		do
			l_x2___1 := a_x * a_x
			l_x4___1 := l_x2___1 * l_x2___1
			Result := (l_x4___1 * l_x4___1)
		end

	gsl_pow_9 (a_x: REAL_64): REAL_64
		local
			l_x3___1: REAL_64
		do
			l_x3___1 := (a_x * a_x) * a_x
			Result := ((l_x3___1 * l_x3___1) * l_x3___1)
		end

end
