class
	P_GSL_GSL_VECTOR_ULONG

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_vector_ulong_get (a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]; a_i: NATURAL_32): NATURAL_32
		do
			Result := (a_v.item.data[(a_i * a_v.item.stride).to_integer_32])
		end

	gsl_vector_ulong_set (a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]; a_i: NATURAL_32; a_x: NATURAL_32)
		do
			a_v.item.data[(a_i * a_v.item.stride).to_integer_32] := a_x
		end

	gsl_vector_ulong_ptr (a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]; a_i: NATURAL_32): CE_POINTER [NATURAL_32]
		do
			Result := (a_v.item.data + (a_i * a_v.item.stride).to_integer_32)
		end

	gsl_vector_ulong_const_ptr (a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]; a_i: NATURAL_32): CE_POINTER [NATURAL_32]
		do
			Result := (a_v.item.data + (a_i * a_v.item.stride).to_integer_32)
		end

end
