class
	P_KNUTHRAN

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create ran_type___3.make
			create gsl_rng_knuthran.make
		end

feature {ANY} -- attributes

	ran_type___3: PD_GSL_RNG_TYPE

	gsl_rng_knuthran: CE_POINTER [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	ran_array (a_aa: CE_POINTER [NATURAL_32]; a_n: NATURAL_32; a_ran_x: CE_POINTER [NATURAL_32])
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
		do
			l_j := {NATURAL_32} 0
			from
			until
				not (l_j < {NATURAL_32} 100)
			loop
				a_aa[l_j.to_integer_32] := a_ran_x[l_j.to_integer_32]
				l_j := l_j + 1
			end
			from
			until
				not (l_j < a_n)
			loop
				a_aa[l_j.to_integer_32] := ((a_aa[(l_j - {NATURAL_32} 100).to_integer_32] - a_aa[(l_j - {NATURAL_32} 37).to_integer_32])).bit_and ((((1).bit_shift_left (30)) - 1).to_natural_32)
				l_j := l_j + 1
			end
			l_i := {NATURAL_32} 0
			from
			until
				not (l_i < {NATURAL_32} 37)
			loop
				a_ran_x[l_i.to_integer_32] := ((a_aa[(l_j - {NATURAL_32} 100).to_integer_32] - a_aa[(l_j - {NATURAL_32} 37).to_integer_32])).bit_and ((((1).bit_shift_left (30)) - 1).to_natural_32)
				l_i := l_i + 1
				l_j := l_j + 1
			end
			from
			until
				not (l_i < {NATURAL_32} 100)
			loop
				a_ran_x[l_i.to_integer_32] := ((a_aa[(l_j - {NATURAL_32} 100).to_integer_32] - a_ran_x[(l_i - {NATURAL_32} 37).to_integer_32])).bit_and ((((1).bit_shift_left (30)) - 1).to_natural_32)
				l_i := l_i + 1
				l_j := l_j + 1
			end
		end

	ran_get___3 (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RAN_STATE_T_26__3]
			l_i: NATURAL_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RAN_STATE_T_26__3]}.make_cast (a_vstate))
			l_i := l_state.item.i
			if l_i = {NATURAL_32} 0 then
				ran_array (l_state.item.aa, {NATURAL_32} 2009, l_state.item.ran_x)
			end
			l_state.item.i := (l_i + {NATURAL_32} 1) \\ {NATURAL_32} 2009
			Result := (l_state.item.aa[l_i.to_integer_32])
		end

	ran_get___3_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran_get___3)
		end

	ran_get_double___3 (a_vstate: CE_POINTER [ANY]): REAL_64
		local
			l_state: CE_POINTER [PD_RAN_STATE_T_26__3]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RAN_STATE_T_26__3]}.make_cast (a_vstate))
			Result := ((ran_get___3 (create {CE_POINTER [ANY]}.make_cast (l_state))).to_real_64 / 1073741824.0)
		end

	ran_get_double___3_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran_get_double___3)
		end

	ran_set___3 (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_RAN_STATE_T_26__3]
			l_x: CE_ARRAY [INTEGER_32]
			l_j: INTEGER_32
			l_t: INTEGER_32
			l_ss: INTEGER_32
			js: JUMP_STATE
		do
			create l_state.make
			create l_x.make (<<199>>)

			l_state.ce_gets (create {CE_POINTER [PD_RAN_STATE_T_26__3]}.make_cast (a_vstate))
			l_ss := (((a_s + {NATURAL_32} 2)).bit_and ((((1).bit_shift_left (30)) - 2).to_natural_32)).to_integer_32
			l_j := 0
			from
			until
				not (l_j < 100)
			loop
				l_x[l_j] := l_ss
				l_ss := (l_ss).bit_shift_left ((1))
				if l_ss >= (1).bit_shift_left (30) then
					l_ss := l_ss - (((1).bit_shift_left (30)) - 2)
				end
				l_j := l_j + 1
			end
			from
			until
				not (l_j < 199)
			loop
				l_x[l_j] := 0
				l_j := l_j + 1
			end
			l_x[1] := (l_x[1]) + 1
			l_ss := ((a_s).bit_and ((((1).bit_shift_left (30)) - 1).to_natural_32)).to_integer_32
			l_t := 69
			from
			until
				not (not js.loop_left and then (l_t.to_boolean))
			loop
				l_j := 99
				from
				until
					not (l_j > 0)
				loop
					l_x[l_j + l_j] := l_x[l_j]
					l_j := l_j - 1
				end
				l_j := 198
				from
				until
					not (l_j > 63)
				loop
					l_x[199 - l_j] := (l_x[l_j]).bit_and ((((1).bit_shift_left (30)) - 2))
					l_j := l_j - (2)
				end
				l_j := 198
				from
				until
					not (l_j >= 100)
				loop
					if ((l_x[l_j]).bit_and (1)).to_boolean then
						l_x[l_j - 63] := ((l_x[l_j - 63] - l_x[l_j])).bit_and ((((1).bit_shift_left (30)) - 1))
						l_x[l_j - 100] := ((l_x[l_j - 100] - l_x[l_j])).bit_and ((((1).bit_shift_left (30)) - 1))
					end
					l_j := l_j - 1
				end
				if ((l_ss).bit_and (1)).to_boolean then
					l_j := 100
					from
					until
						not (l_j > 0)
					loop
						l_x[l_j] := l_x[l_j - 1]
						l_j := l_j - 1
					end
					l_x[0] := l_x[100]
					if ((l_x[100]).bit_and (1)).to_boolean then
						l_x[37] := ((l_x[37] - l_x[100])).bit_and ((((1).bit_shift_left (30)) - 1))
					end
				end
				if l_ss.to_boolean then
					l_ss := (l_ss).bit_shift_right ((1))
				else
					l_t := l_t - 1
				end
			end
			l_state.item.i := {NATURAL_32} 0
			l_j := 0
			from
			until
				not (l_j < 37)
			loop
				l_state.item.ran_x[(l_j + 100) - 37] := (l_x[l_j]).to_natural_32
				l_j := l_j + 1
			end
			from
			until
				not (l_j < 100)
			loop
				l_state.item.ran_x[l_j - 37] := (l_x[l_j]).to_natural_32
				l_j := l_j + 1
			end
		end

	ran_set___3_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran_set___3)
		end

end
