class
	P_QPSRT2

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	increase_nrmax (a_workspace: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]): INTEGER_32
		local
			l_k: INTEGER_32
			l_id: INTEGER_32
			l_jupbnd: INTEGER_32
			l_level: CE_POINTER [NATURAL_32]
			l_order: CE_POINTER [NATURAL_32]
			l_limit: NATURAL_32
			l_last: NATURAL_32
			l_i_max: NATURAL_32
			js: JUMP_STATE
		do
			create l_level.make
			create l_order.make

			l_id := (a_workspace.item.nrmax).to_integer_32
			l_level.ce_gets (a_workspace.item.level)
			l_order.ce_gets (a_workspace.item.order)
			l_limit := a_workspace.item.limit
			l_last := a_workspace.item.size - {NATURAL_32} 1
			if l_last > {NATURAL_32} 1 + l_limit // {NATURAL_32} 2 then
				l_jupbnd := ((l_limit + {NATURAL_32} 1) - l_last).to_integer_32
			else
				l_jupbnd := l_last.to_integer_32
			end
			l_k := l_id
			from
			until
				not (not js.loop_left and then (l_k <= l_jupbnd))
			loop
				l_i_max := l_order[(a_workspace.item.nrmax).to_integer_32]
				a_workspace.item.i := l_i_max
				if l_level[l_i_max.to_integer_32] < a_workspace.item.maximum_level then
					Result := 1
					js.return
				end
				if not js.return_called then
					a_workspace.item.nrmax := (a_workspace.item.nrmax) + 1
					l_k := l_k + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	large_interval (a_workspace: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]): INTEGER_32
		local
			l_i: NATURAL_32
			l_level: CE_POINTER [NATURAL_32]
		do
			create l_level.make

			l_i := a_workspace.item.i
			l_level.ce_gets (a_workspace.item.level)
			if l_level[l_i.to_integer_32] < a_workspace.item.maximum_level then
				Result := 1
			else
				Result := 0
			end
		end

	increase_nrmax___0 (a_workspace: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]): INTEGER_32
		local
			l_k: INTEGER_32
			l_id: INTEGER_32
			l_jupbnd: INTEGER_32
			l_level: CE_POINTER [NATURAL_32]
			l_order: CE_POINTER [NATURAL_32]
			l_limit: NATURAL_32
			l_last: NATURAL_32
			l_i_max: NATURAL_32
			js: JUMP_STATE
		do
			create l_level.make
			create l_order.make

			l_id := (a_workspace.item.nrmax).to_integer_32
			l_level.ce_gets (a_workspace.item.level)
			l_order.ce_gets (a_workspace.item.order)
			l_limit := a_workspace.item.limit
			l_last := a_workspace.item.size - {NATURAL_32} 1
			if l_last > {NATURAL_32} 1 + l_limit // {NATURAL_32} 2 then
				l_jupbnd := ((l_limit + {NATURAL_32} 1) - l_last).to_integer_32
			else
				l_jupbnd := l_last.to_integer_32
			end
			l_k := l_id
			from
			until
				not (not js.loop_left and then (l_k <= l_jupbnd))
			loop
				l_i_max := l_order[(a_workspace.item.nrmax).to_integer_32]
				a_workspace.item.i := l_i_max
				if l_level[l_i_max.to_integer_32] < a_workspace.item.maximum_level then
					Result := 1
					js.return
				end
				if not js.return_called then
					a_workspace.item.nrmax := (a_workspace.item.nrmax) + 1
					l_k := l_k + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	large_interval___0 (a_workspace: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]): INTEGER_32
		local
			l_i: NATURAL_32
			l_level: CE_POINTER [NATURAL_32]
		do
			create l_level.make

			l_i := a_workspace.item.i
			l_level.ce_gets (a_workspace.item.level)
			if l_level[l_i.to_integer_32] < a_workspace.item.maximum_level then
				Result := 1
			else
				Result := 0
			end
		end

	increase_nrmax___1 (a_workspace: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]): INTEGER_32
		local
			l_k: INTEGER_32
			l_id: INTEGER_32
			l_jupbnd: INTEGER_32
			l_level: CE_POINTER [NATURAL_32]
			l_order: CE_POINTER [NATURAL_32]
			l_limit: NATURAL_32
			l_last: NATURAL_32
			l_i_max: NATURAL_32
			js: JUMP_STATE
		do
			create l_level.make
			create l_order.make

			l_id := (a_workspace.item.nrmax).to_integer_32
			l_level.ce_gets (a_workspace.item.level)
			l_order.ce_gets (a_workspace.item.order)
			l_limit := a_workspace.item.limit
			l_last := a_workspace.item.size - {NATURAL_32} 1
			if l_last > {NATURAL_32} 1 + l_limit // {NATURAL_32} 2 then
				l_jupbnd := ((l_limit + {NATURAL_32} 1) - l_last).to_integer_32
			else
				l_jupbnd := l_last.to_integer_32
			end
			l_k := l_id
			from
			until
				not (not js.loop_left and then (l_k <= l_jupbnd))
			loop
				l_i_max := l_order[(a_workspace.item.nrmax).to_integer_32]
				a_workspace.item.i := l_i_max
				if l_level[l_i_max.to_integer_32] < a_workspace.item.maximum_level then
					Result := 1
					js.return
				end
				if not js.return_called then
					a_workspace.item.nrmax := (a_workspace.item.nrmax) + 1
					l_k := l_k + 1
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	large_interval___1 (a_workspace: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]): INTEGER_32
		local
			l_i: NATURAL_32
			l_level: CE_POINTER [NATURAL_32]
		do
			create l_level.make

			l_i := a_workspace.item.i
			l_level.ce_gets (a_workspace.item.level)
			if l_level[l_i.to_integer_32] < a_workspace.item.maximum_level then
				Result := 1
			else
				Result := 0
			end
		end

end
