class
	P_SORTIND

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	downheap (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [ANY]; a_size: NATURAL_32; a_N: NATURAL_32; a_k: NATURAL_32; a_compare: CE_ROUTINE)
		local
			l_k: NATURAL_32
			l_pki: NATURAL_32
			l_j: NATURAL_32
			js: JUMP_STATE
		do
			l_k := a_k
			l_pki := a_p[l_k.to_integer_32]
			from
			until
				not (not js.loop_left and then (l_k <= a_N // {NATURAL_32} 2))
			loop
				js.reset
				l_j := {NATURAL_32} 2 * l_k
				if l_j < a_N then
					if (a_compare.integer_32_item ([create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (a_data) + (a_size * a_p[l_j.to_integer_32]).to_integer_32)), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (a_data) + (a_size * a_p[(l_j + {NATURAL_32} 1).to_integer_32]).to_integer_32))])) < 0 then
						l_j := l_j + 1
					end
				end
				if (a_compare.integer_32_item ([create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (a_data) + (a_size * l_pki).to_integer_32)), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_8]}.make_cast (a_data) + (a_size * a_p[l_j.to_integer_32]).to_integer_32))])) >= 0 then
					js.break
				end
				if not js.loop_jumped then
					a_p[l_k.to_integer_32] := a_p[l_j.to_integer_32]
					l_k := l_j
				end
			end
			js.reset
			a_p[l_k.to_integer_32] := l_pki
		end

	gsl_heapsort_index (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [ANY]; a_count: NATURAL_32; a_size: NATURAL_32; a_compare: CE_ROUTINE): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_N: NATURAL_32
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			if a_count = {NATURAL_32} 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_count)
				loop
					a_p[l_i.to_integer_32] := l_i
					l_i := l_i + 1
				end
				l_N := a_count - {NATURAL_32} 1
				l_k := l_N // {NATURAL_32} 2
				l_k := l_k + 1
				from
				until
					js.loop_left
				loop
					js.reset
					l_k := l_k - 1
					downheap (a_p, a_data, a_size, l_N, l_k, a_compare)
					if not (l_k > {NATURAL_32} 0) then
						js.break
					end
				end
				js.reset
				from
				until
					not (l_N > {NATURAL_32} 0)
				loop
					l_tmp := a_p[0]
					a_p[0] := a_p[l_N.to_integer_32]
					a_p[l_N.to_integer_32] := l_tmp
					l_N := l_N - 1
					downheap (a_p, a_data, a_size, l_N, (0).to_natural_32, a_compare)
				end
				Result := 0
			end
		end

end
