class
	P_SUBMATRIX_SOURCE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_matrix_complex_long_double_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_VIEW
			l_s: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_m___4.item.data + ({NATURAL_32} 2 * (a_i * a_m___4.item.tda + a_j)).to_integer_32
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_complex_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_VIEW
			l_s: PD_GSL_MATRIX_COMPLEX
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_m___4.item.data + ({NATURAL_32} 2 * (a_i * a_m___4.item.tda + a_j)).to_integer_32
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_complex_float_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_FLOAT_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_FLOAT_VIEW
			l_s: PD_GSL_MATRIX_COMPLEX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_m___4.item.data + ({NATURAL_32} 2 * (a_i * a_m___4.item.tda + a_j)).to_integer_32
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_long_double_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_LONG_DOUBLE_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_DOUBLE_VIEW
			l_s: PD_GSL_MATRIX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_VIEW
		local
			l_view: PD_GSL_MATRIX_VIEW
			l_s: PD_GSL_MATRIX
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_float_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_FLOAT_VIEW
		local
			l_view: PD_GSL_MATRIX_FLOAT_VIEW
			l_s: PD_GSL_MATRIX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_ulong_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_ULONG]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_ULONG_VIEW
		local
			l_view: PD_GSL_MATRIX_ULONG_VIEW
			l_s: PD_GSL_MATRIX_ULONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_long_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_LONG_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_VIEW
			l_s: PD_GSL_MATRIX_LONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_uint_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_UINT_VIEW
		local
			l_view: PD_GSL_MATRIX_UINT_VIEW
			l_s: PD_GSL_MATRIX_UINT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_int_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_INT]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_INT_VIEW
		local
			l_view: PD_GSL_MATRIX_INT_VIEW
			l_s: PD_GSL_MATRIX_INT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_ushort_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_USHORT]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_USHORT_VIEW
		local
			l_view: PD_GSL_MATRIX_USHORT_VIEW
			l_s: PD_GSL_MATRIX_USHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_short_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_SHORT_VIEW
		local
			l_view: PD_GSL_MATRIX_SHORT_VIEW
			l_s: PD_GSL_MATRIX_SHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_uchar_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_UCHAR]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_UCHAR_VIEW
		local
			l_view: PD_GSL_MATRIX_UCHAR_VIEW
			l_s: PD_GSL_MATRIX_UCHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_char_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_CHAR]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_CHAR_VIEW
		local
			l_view: PD_GSL_MATRIX_CHAR_VIEW
			l_s: PD_GSL_MATRIX_CHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_complex_long_double_const_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_CONST_VIEW
			l_s: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_m___4.item.data + ({NATURAL_32} 2 * (a_i * a_m___4.item.tda + a_j)).to_integer_32)
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_complex_const_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_CONST_VIEW
			l_s: PD_GSL_MATRIX_COMPLEX
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_m___4.item.data + ({NATURAL_32} 2 * (a_i * a_m___4.item.tda + a_j)).to_integer_32)
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_complex_float_const_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_FLOAT_CONST_VIEW
			l_s: PD_GSL_MATRIX_COMPLEX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_m___4.item.data + ({NATURAL_32} 2 * (a_i * a_m___4.item.tda + a_j)).to_integer_32)
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_long_double_const_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_LONG_DOUBLE_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_DOUBLE_CONST_VIEW
			l_s: PD_GSL_MATRIX_LONG_DOUBLE
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_96]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32)
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_const_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_CONST_VIEW
			l_s: PD_GSL_MATRIX
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_64]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32)
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_float_const_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_FLOAT_CONST_VIEW
			l_s: PD_GSL_MATRIX_FLOAT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [REAL_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32)
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_ulong_const_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_ULONG]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_ULONG_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_ULONG_CONST_VIEW
			l_s: PD_GSL_MATRIX_ULONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32)
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_long_const_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_LONG_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_CONST_VIEW
			l_s: PD_GSL_MATRIX_LONG
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32)
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_uint_const_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_UINT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_UINT_CONST_VIEW
			l_s: PD_GSL_MATRIX_UINT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32)
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_int_const_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_INT]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_INT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_INT_CONST_VIEW
			l_s: PD_GSL_MATRIX_INT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32)
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_ushort_const_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_USHORT]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_USHORT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_USHORT_CONST_VIEW
			l_s: PD_GSL_MATRIX_USHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32)
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_short_const_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_SHORT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_SHORT_CONST_VIEW
			l_s: PD_GSL_MATRIX_SHORT
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32)
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_uchar_const_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_UCHAR]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_UCHAR_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_UCHAR_CONST_VIEW
			l_s: PD_GSL_MATRIX_UCHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32)
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

	gsl_matrix_char_const_submatrix (a_m___4: CE_POINTER [PD_GSL_MATRIX_CHAR]; a_i: NATURAL_32; a_j: NATURAL_32; a_n1: NATURAL_32; a_n2: NATURAL_32): PD_GSL_MATRIX_CHAR_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_CHAR_CONST_VIEW
			l_s: PD_GSL_MATRIX_CHAR
			js: JUMP_STATE
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_i >= a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j >= a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_i + a_n1 > a_m___4.item.size1 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			elseif a_j + a_n2 > a_m___4.item.size2 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					Result := l_view
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_s.size1 := (0).to_natural_32
				l_s.size2 := (0).to_natural_32
				l_s.tda := (0).to_natural_32
				l_s.data := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				l_s.block := create {CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_s.owner := 0
				l_s.data := (a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32)
				l_s.size1 := a_n1
				l_s.size2 := a_n2
				l_s.tda := a_m___4.item.tda
				l_s.block := a_m___4.item.block
				l_s.owner := 0
				l_view.matrix := l_s
				Result := l_view
			end
		end

end
