class
	P_TAUS113

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create taus113_type.make
			create gsl_rng_taus113.make
		end

feature {ANY} -- attributes

	taus113_type: PD_GSL_RNG_TYPE

	gsl_rng_taus113: CE_POINTER [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	taus113_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_TAUS113_STATE_T]
			l_b1___0: NATURAL_32
			l_b2: NATURAL_32
			l_b3___3: NATURAL_32
			l_b4___2: NATURAL_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_TAUS113_STATE_T]}.make_cast (a_vstate))
			l_b1___0 := (((((((l_state.item.z1).bit_shift_left (({NATURAL_32} 6).to_integer_32))).bit_and ({NATURAL_32} 4294967295))).bit_xor (l_state.item.z1))).bit_shift_right (({NATURAL_32} 13).to_integer_32)
			l_state.item.z1 := (((((((l_state.item.z1).bit_and ({NATURAL_32} 4294967294))).bit_shift_left (({NATURAL_32} 18).to_integer_32))).bit_and ({NATURAL_32} 4294967295))).bit_xor (l_b1___0)
			l_b2 := (((((((l_state.item.z2).bit_shift_left (({NATURAL_32} 2).to_integer_32))).bit_and ({NATURAL_32} 4294967295))).bit_xor (l_state.item.z2))).bit_shift_right (({NATURAL_32} 27).to_integer_32)
			l_state.item.z2 := (((((((l_state.item.z2).bit_and ({NATURAL_32} 4294967288))).bit_shift_left (({NATURAL_32} 2).to_integer_32))).bit_and ({NATURAL_32} 4294967295))).bit_xor (l_b2)
			l_b3___3 := (((((((l_state.item.z3).bit_shift_left (({NATURAL_32} 13).to_integer_32))).bit_and ({NATURAL_32} 4294967295))).bit_xor (l_state.item.z3))).bit_shift_right (({NATURAL_32} 21).to_integer_32)
			l_state.item.z3 := (((((((l_state.item.z3).bit_and ({NATURAL_32} 4294967280))).bit_shift_left (({NATURAL_32} 7).to_integer_32))).bit_and ({NATURAL_32} 4294967295))).bit_xor (l_b3___3)
			l_b4___2 := (((((((l_state.item.z4).bit_shift_left (({NATURAL_32} 3).to_integer_32))).bit_and ({NATURAL_32} 4294967295))).bit_xor (l_state.item.z4))).bit_shift_right (({NATURAL_32} 12).to_integer_32)
			l_state.item.z4 := (((((((l_state.item.z4).bit_and ({NATURAL_32} 4294967168))).bit_shift_left (({NATURAL_32} 13).to_integer_32))).bit_and ({NATURAL_32} 4294967295))).bit_xor (l_b4___2)
			Result := ((((((l_state.item.z1).bit_xor (l_state.item.z2))).bit_xor (l_state.item.z3))).bit_xor (l_state.item.z4))
		end

	taus113_get_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent taus113_get)
		end

	taus113_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((taus113_get (a_vstate)).to_real_64 / 4294967296.0)
		end

	taus113_get_double_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent taus113_get_double)
		end

	taus113_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_TAUS113_STATE_T]
		do
			create l_state.make

			l_s := a_s
			l_state.ce_gets (create {CE_POINTER [PD_TAUS113_STATE_T]}.make_cast (a_vstate))
			if not l_s.to_boolean then
				l_s := {NATURAL_32} 1
			end
			l_state.item.z1 := ({NATURAL_32} 69069 * l_s).bit_and ({NATURAL_32} 4294967295)
			if l_state.item.z1 < {NATURAL_32} 2 then
				l_state.item.z1 := l_state.item.z1 + ({NATURAL_32} 2)
			end
			l_state.item.z2 := ({NATURAL_32} 69069 * l_state.item.z1).bit_and ({NATURAL_32} 4294967295)
			if l_state.item.z2 < {NATURAL_32} 8 then
				l_state.item.z2 := l_state.item.z2 + ({NATURAL_32} 8)
			end
			l_state.item.z3 := ({NATURAL_32} 69069 * l_state.item.z2).bit_and ({NATURAL_32} 4294967295)
			if l_state.item.z3 < {NATURAL_32} 16 then
				l_state.item.z3 := l_state.item.z3 + ({NATURAL_32} 16)
			end
			l_state.item.z4 := ({NATURAL_32} 69069 * l_state.item.z3).bit_and ({NATURAL_32} 4294967295)
			if l_state.item.z4 < {NATURAL_32} 128 then
				l_state.item.z4 := l_state.item.z4 + ({NATURAL_32} 128)
			end
			taus113_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			taus113_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			taus113_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			taus113_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			taus113_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			taus113_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			taus113_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			taus113_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			taus113_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
			taus113_get (create {CE_POINTER [ANY]}.make_cast (l_state)).do_nothing
		end

	taus113_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent taus113_set)
		end

end
