class
	P_WORK

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_multifit_linear_alloc (a_n: NATURAL_32; a_p: NATURAL_32): CE_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]
		local
			l_w: CE_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]
			js: JUMP_STATE
		do
			create l_w.make

			l_w.ce_gets (create {CE_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]}.make_cast ((malloc ({PD_GSL_MULTIFIT_LINEAR_WORKSPACE}.sizeof.to_natural_32))))
			if (l_w.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("failed to allocate space for multifit_linear struct"), ce_string ("work.c"), 35, 8)
					Result := (create {CE_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_w.item.n := a_n
				l_w.item.p := a_p
				l_w.item.A := init_source_inst.gsl_matrix_alloc (a_n, a_p)
				if ((l_w.item.A).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_w))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for A"), ce_string ("work.c"), 46, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_w.item.Q := init_source_inst.gsl_matrix_alloc (a_p, a_p)
				if ((l_w.item.Q).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_matrix_free (l_w.item.A)
					free (create {CE_POINTER [ANY]}.make_cast (l_w))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for Q"), ce_string ("work.c"), 55, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_w.item.QSI := init_source_inst.gsl_matrix_alloc (a_p, a_p)
				if ((l_w.item.QSI).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_matrix_free (l_w.item.Q)
					init_source_inst.gsl_matrix_free (l_w.item.A)
					free (create {CE_POINTER [ANY]}.make_cast (l_w))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for QSI"), ce_string ("work.c"), 65, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_w.item.S := init_source_inst.gsl_vector_alloc (a_p)
				if ((l_w.item.S).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_matrix_free (l_w.item.QSI)
					init_source_inst.gsl_matrix_free (l_w.item.Q)
					init_source_inst.gsl_matrix_free (l_w.item.A)
					free (create {CE_POINTER [ANY]}.make_cast (l_w))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for S"), ce_string ("work.c"), 76, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_w.item.t := init_source_inst.gsl_vector_alloc (a_n)
				if ((l_w.item.t).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_vector_free (l_w.item.S)
					init_source_inst.gsl_matrix_free (l_w.item.QSI)
					init_source_inst.gsl_matrix_free (l_w.item.Q)
					init_source_inst.gsl_matrix_free (l_w.item.A)
					free (create {CE_POINTER [ANY]}.make_cast (l_w))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for t"), ce_string ("work.c"), 88, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_w.item.xt := init_source_inst.gsl_vector_calloc (a_p)
				if ((l_w.item.xt).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_vector_free (l_w.item.t)
					init_source_inst.gsl_vector_free (l_w.item.S)
					init_source_inst.gsl_matrix_free (l_w.item.QSI)
					init_source_inst.gsl_matrix_free (l_w.item.Q)
					init_source_inst.gsl_matrix_free (l_w.item.A)
					free (create {CE_POINTER [ANY]}.make_cast (l_w))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for xt"), ce_string ("work.c"), 101, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_w.item.D := init_source_inst.gsl_vector_calloc (a_p)
				if ((l_w.item.D).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_vector_free (l_w.item.D)
					init_source_inst.gsl_vector_free (l_w.item.t)
					init_source_inst.gsl_vector_free (l_w.item.S)
					init_source_inst.gsl_matrix_free (l_w.item.QSI)
					init_source_inst.gsl_matrix_free (l_w.item.Q)
					init_source_inst.gsl_matrix_free (l_w.item.A)
					free (create {CE_POINTER [ANY]}.make_cast (l_w))
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for xt"), ce_string ("work.c"), 115, 8)
						Result := (create {CE_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				Result := l_w
			end
		end

	gsl_multifit_linear_free (a_work: CE_POINTER [PD_GSL_MULTIFIT_LINEAR_WORKSPACE])
		local
			js: JUMP_STATE
		do
			if (a_work).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				init_source_inst.gsl_matrix_free (a_work.item.A)
				init_source_inst.gsl_matrix_free (a_work.item.Q)
				init_source_inst.gsl_matrix_free (a_work.item.QSI)
				init_source_inst.gsl_vector_free (a_work.item.S)
				init_source_inst.gsl_vector_free (a_work.item.t)
				init_source_inst.gsl_vector_free (a_work.item.xt)
				init_source_inst.gsl_vector_free (a_work.item.D)
				free (create {CE_POINTER [ANY]}.make_cast (a_work))
			end
		end

end
