class
	PD_EYESCLASSREC

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	core_class: SD_CORECLASSPART assign set_core_class
		do
			create Result.make_shared (c_core_class (c_pointer))
		end

	eyes_class: PD_EYESCLASSPART assign set_eyes_class
		do
			create Result.make_shared (c_eyes_class (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_core_class (a_core_class: SD_CORECLASSPART)
		do
			core_class.ce_gets (a_core_class)
		end

	set_eyes_class (a_eyes_class: PD_EYESCLASSPART)
		do
			eyes_class.ce_gets (a_eyes_class)
		end

feature {NONE} -- C getters

	c_core_class (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _CoreClassPart *)&((struct _EyesClassRec *)$tmp)->core_class;"
		end

	c_eyes_class (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (EyesClassPart *)&((struct _EyesClassRec *)$tmp)->eyes_class;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return sizeof(struct _EyesClassRec);"
		end

end
