class
	PD_EYESPART

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	puppixel: NATURAL_32 assign set_puppixel
		do
			Result := c_puppixel (c_pointer)
		end

	puppixel_offset: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return (int)offsetof(struct __anonstruct_EyesPart_138, puppixel);"
		end

	outline: NATURAL_32 assign set_outline
		do
			Result := c_outline (c_pointer)
		end

	outline_offset: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return (int)offsetof(struct __anonstruct_EyesPart_138, outline);"
		end

	center: NATURAL_32 assign set_center
		do
			Result := c_center (c_pointer)
		end

	center_offset: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return (int)offsetof(struct __anonstruct_EyesPart_138, center);"
		end

	outGC: CE_POINTER [ANY] assign set_outGC
		do
			create Result.make_shared (c_outGC (c_pointer))
		end

	pupGC: CE_POINTER [ANY] assign set_pupGC
		do
			create Result.make_shared (c_pupGC (c_pointer))
		end

	centerGC: CE_POINTER [ANY] assign set_centerGC
		do
			create Result.make_shared (c_centerGC (c_pointer))
		end

	shapeGC: CE_POINTER [ANY] assign set_shapeGC
		do
			create Result.make_shared (c_shapeGC (c_pointer))
		end

	backing_store: INTEGER_32 assign set_backing_store
		do
			Result := c_backing_store (c_pointer)
		end

	backing_store_offset: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return (int)offsetof(struct __anonstruct_EyesPart_138, backing_store);"
		end

	reverse_video: INTEGER_8 assign set_reverse_video
		do
			Result := c_reverse_video (c_pointer)
		end

	reverse_video_offset: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return (int)offsetof(struct __anonstruct_EyesPart_138, reverse_video);"
		end

	shape_window: INTEGER_8 assign set_shape_window
		do
			Result := c_shape_window (c_pointer)
		end

	shape_window_offset: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return (int)offsetof(struct __anonstruct_EyesPart_138, shape_window);"
		end

	update: INTEGER_32 assign set_update
		do
			Result := c_update (c_pointer)
		end

	mouse: PD_TPOINT assign set_mouse
		do
			create Result.make_shared (c_mouse (c_pointer))
		end

	pupil: CE_ARRAY [PD_TPOINT]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_pupil (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	t: PD_TRANSFORM assign set_t
		do
			create Result.make_shared (c_t (c_pointer))
		end

	t_offset: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return (int)offsetof(struct __anonstruct_EyesPart_138, t);"
		end

	maskt: PD_TRANSFORM assign set_maskt
		do
			create Result.make_shared (c_maskt (c_pointer))
		end

	interval_id: NATURAL_32 assign set_interval_id
		do
			Result := c_interval_id (c_pointer)
		end

	shape_mask: NATURAL_32 assign set_shape_mask
		do
			Result := c_shape_mask (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_puppixel (a_puppixel: NATURAL_32)
		do
			c_set_puppixel (c_pointer, a_puppixel)
		end

	set_outline (a_outline: NATURAL_32)
		do
			c_set_outline (c_pointer, a_outline)
		end

	set_center (a_center: NATURAL_32)
		do
			c_set_center (c_pointer, a_center)
		end

	set_outGC (a_outGC: CE_POINTER [ANY])
		do
			c_set_outGC (c_pointer, a_outGC.c_pointer)
		end

	set_pupGC (a_pupGC: CE_POINTER [ANY])
		do
			c_set_pupGC (c_pointer, a_pupGC.c_pointer)
		end

	set_centerGC (a_centerGC: CE_POINTER [ANY])
		do
			c_set_centerGC (c_pointer, a_centerGC.c_pointer)
		end

	set_shapeGC (a_shapeGC: CE_POINTER [ANY])
		do
			c_set_shapeGC (c_pointer, a_shapeGC.c_pointer)
		end

	set_backing_store (a_backing_store: INTEGER_32)
		do
			c_set_backing_store (c_pointer, a_backing_store)
		end

	set_reverse_video (a_reverse_video: INTEGER_8)
		do
			c_set_reverse_video (c_pointer, a_reverse_video)
		end

	set_shape_window (a_shape_window: INTEGER_8)
		do
			c_set_shape_window (c_pointer, a_shape_window)
		end

	set_update (a_update: INTEGER_32)
		do
			c_set_update (c_pointer, a_update)
		end

	set_mouse (a_mouse: PD_TPOINT)
		do
			mouse.ce_gets (a_mouse)
		end

	set_t (a_t: PD_TRANSFORM)
		do
			t.ce_gets (a_t)
		end

	set_maskt (a_maskt: PD_TRANSFORM)
		do
			maskt.ce_gets (a_maskt)
		end

	set_interval_id (a_interval_id: NATURAL_32)
		do
			c_set_interval_id (c_pointer, a_interval_id)
		end

	set_shape_mask (a_shape_mask: NATURAL_32)
		do
			c_set_shape_mask (c_pointer, a_shape_mask)
		end

feature {NONE} -- C getters

	c_puppixel (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_EyesPart_138 *)$tmp)->puppixel;"
		end

	c_outline (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_EyesPart_138 *)$tmp)->outline;"
		end

	c_center (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_EyesPart_138 *)$tmp)->center;"
		end

	c_outGC (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_EyesPart_138 *)$tmp)->outGC;"
		end

	c_pupGC (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_EyesPart_138 *)$tmp)->pupGC;"
		end

	c_centerGC (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_EyesPart_138 *)$tmp)->centerGC;"
		end

	c_shapeGC (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_EyesPart_138 *)$tmp)->shapeGC;"
		end

	c_backing_store (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_EyesPart_138 *)$tmp)->backing_store;"
		end

	c_reverse_video (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct __anonstruct_EyesPart_138 *)$tmp)->reverse_video;"
		end

	c_shape_window (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct __anonstruct_EyesPart_138 *)$tmp)->shape_window;"
		end

	c_update (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_EyesPart_138 *)$tmp)->update;"
		end

	c_mouse (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _TPoint *)&((struct __anonstruct_EyesPart_138 *)$tmp)->mouse;"
		end

	c_pupil (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_EyesPart_138 *tmp = (struct __anonstruct_EyesPart_138 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->pupil) / sizeof(tmp->pupil[0]);
				return tmp->pupil;
			]"
		end

	c_t (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _transform *)&((struct __anonstruct_EyesPart_138 *)$tmp)->t;"
		end

	c_maskt (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _transform *)&((struct __anonstruct_EyesPart_138 *)$tmp)->maskt;"
		end

	c_interval_id (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_EyesPart_138 *)$tmp)->interval_id;"
		end

	c_shape_mask (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_EyesPart_138 *)$tmp)->shape_mask;"
		end

feature {NONE} -- C setters

	c_set_puppixel (tmp: POINTER; a_puppixel: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_EyesPart_138 *)$tmp)->puppixel = $a_puppixel;"
		end

	c_set_outline (tmp: POINTER; a_outline: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_EyesPart_138 *)$tmp)->outline = $a_outline;"
		end

	c_set_center (tmp: POINTER; a_center: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_EyesPart_138 *)$tmp)->center = $a_center;"
		end

	c_set_outGC (tmp: POINTER; a_outGC: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_EyesPart_138 *)$tmp)->outGC = (void *)$a_outgc;"
		end

	c_set_pupGC (tmp: POINTER; a_pupGC: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_EyesPart_138 *)$tmp)->pupGC = (void *)$a_pupgc;"
		end

	c_set_centerGC (tmp: POINTER; a_centerGC: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_EyesPart_138 *)$tmp)->centerGC = (void *)$a_centergc;"
		end

	c_set_shapeGC (tmp: POINTER; a_shapeGC: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_EyesPart_138 *)$tmp)->shapeGC = (void *)$a_shapegc;"
		end

	c_set_backing_store (tmp: POINTER; a_backing_store: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_EyesPart_138 *)$tmp)->backing_store = $a_backing_store;"
		end

	c_set_reverse_video (tmp: POINTER; a_reverse_video: INTEGER_8)
		external
			"C inline"
		alias
			"((struct __anonstruct_EyesPart_138 *)$tmp)->reverse_video = $a_reverse_video;"
		end

	c_set_shape_window (tmp: POINTER; a_shape_window: INTEGER_8)
		external
			"C inline"
		alias
			"((struct __anonstruct_EyesPart_138 *)$tmp)->shape_window = $a_shape_window;"
		end

	c_set_update (tmp: POINTER; a_update: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_EyesPart_138 *)$tmp)->update = $a_update;"
		end

	c_set_interval_id (tmp: POINTER; a_interval_id: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_EyesPart_138 *)$tmp)->interval_id = $a_interval_id;"
		end

	c_set_shape_mask (tmp: POINTER; a_shape_mask: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_EyesPart_138 *)$tmp)->shape_mask = $a_shape_mask;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return sizeof(struct __anonstruct_EyesPart_138);"
		end

end
