class
	PD_EYESREC

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	core: SD_COREPART assign set_core
		do
			create Result.make_shared (c_core (c_pointer))
		end

	eyes: PD_EYESPART assign set_eyes
		do
			create Result.make_shared (c_eyes (c_pointer))
		end

	eyes_offset: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return (int)offsetof(struct _EyesRec, eyes);"
		end

feature {ANY} -- Eiffel setters

	set_core (a_core: SD_COREPART)
		do
			core.ce_gets (a_core)
		end

	set_eyes (a_eyes: PD_EYESPART)
		do
			eyes.ce_gets (a_eyes)
		end

feature {NONE} -- C getters

	c_core (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _CorePart *)&((struct _EyesRec *)$tmp)->core;"
		end

	c_eyes (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (EyesPart *)&((struct _EyesRec *)$tmp)->eyes;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return sizeof(struct _EyesRec);"
		end

end
