class
	P_TRANSFORM

inherit
	XEYES_DATA
	S_X11_XLIB
	S_X11_INTRINSIC
	S_X11_COREP
	S_X11_INTRINSICP
	S_X11_STRINGDEFS
	S_X11_XMU_CONVERTERS
	S_MATH
	S_X11_EXTENSIONS_SHAPE
	S_X11_SHELL
	S_STDLIB

feature {ANY} -- routines

	TFillArc (a_dpy: CE_POINTER [ANY]; a_d: NATURAL_32; a_gc: CE_POINTER [ANY]; a_t: CE_POINTER [PD_TRANSFORM]; a_x: REAL_64; a_y: REAL_64; a_width: REAL_64; a_height: REAL_64; a_angle1: INTEGER_32; a_angle2: INTEGER_32)
		local
			l_xx: INTEGER_32
			l_xy: INTEGER_32
			l_xw: INTEGER_32
			l_xh: INTEGER_32
		do
			l_xx := ((a_t.item.mx * a_x + a_t.item.bx) + 0.5).truncated_to_integer
			l_xy := ((a_t.item.my * a_y + a_t.item.by) + 0.5).truncated_to_integer
			l_xw := (a_t.item.mx * a_width + 0.5).truncated_to_integer
			l_xh := (a_t.item.my * a_height + 0.5).truncated_to_integer
			if l_xw < 0 then
				l_xx := l_xx + l_xw
				l_xw := -l_xw
			end
			if l_xh < 0 then
				l_xy := l_xy + l_xh
				l_xh := -l_xh
			end
			XFillArc (a_dpy, a_d, a_gc, l_xx, l_xy, l_xw.to_natural_32, l_xh.to_natural_32, a_angle1, a_angle2).do_nothing
		end

	SetTransform (a_t: CE_POINTER [PD_TRANSFORM]; a_xx1: INTEGER_32; a_xx2: INTEGER_32; a_xy1: INTEGER_32; a_xy2: INTEGER_32; a_tx1: REAL_64; a_tx2: REAL_64; a_ty1: REAL_64; a_ty2: REAL_64)
		do
			a_t.item.mx := (a_xx2.to_double - a_xx1.to_double) / (a_tx2 - a_tx1)
			a_t.item.bx := a_xx1.to_double - a_t.item.mx * a_tx1
			a_t.item.my := (a_xy2.to_double - a_xy1.to_double) / (a_ty2 - a_ty1)
			a_t.item.by := a_xy1.to_double - a_t.item.my * a_ty1
		end

end
