class
	SD_ARG

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	value: INTEGER_32 assign set_value
		do
			Result := c_value (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_value (a_value: INTEGER_32)
		do
			c_set_value (c_pointer, a_value)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_Arg_119 *)$tmp)->name;"
		end

	c_value (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_Arg_119 *)$tmp)->value;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_Arg_119 *)$tmp)->name = (char *)$a_name;"
		end

	c_set_value (tmp: POINTER; a_value: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_Arg_119 *)$tmp)->value = $a_value;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return sizeof(struct __anonstruct_Arg_119);"
		end

end
