class
	SD_COREPART

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	self: CE_POINTER [SD_WIDGETREC] assign set_self
		do
			create Result.make_shared (c_self (c_pointer))
		end

	widget_class: CE_POINTER [SD_WIDGETCLASSREC] assign set_widget_class
		do
			create Result.make_shared (c_widget_class (c_pointer))
		end

	parent: CE_POINTER [SD_WIDGETREC] assign set_parent
		do
			create Result.make_shared (c_parent (c_pointer))
		end

	xrm_name: INTEGER_32 assign set_xrm_name
		do
			Result := c_xrm_name (c_pointer)
		end

	being_destroyed: INTEGER_8 assign set_being_destroyed
		do
			Result := c_being_destroyed (c_pointer)
		end

	destroy_callbacks: CE_POINTER [SD_XTCALLBACKREC] assign set_destroy_callbacks
		do
			create Result.make_shared (c_destroy_callbacks (c_pointer))
		end

	constraints: CE_POINTER [ANY] assign set_constraints
		do
			create Result.make_shared (c_constraints (c_pointer))
		end

	x: INTEGER_16 assign set_x
		do
			Result := c_x (c_pointer)
		end

	y: INTEGER_16 assign set_y
		do
			Result := c_y (c_pointer)
		end

	width: NATURAL_16 assign set_width
		do
			Result := c_width (c_pointer)
		end

	width_offset: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return (int)offsetof(struct _CorePart, width);"
		end

	height: NATURAL_16 assign set_height
		do
			Result := c_height (c_pointer)
		end

	height_offset: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return (int)offsetof(struct _CorePart, height);"
		end

	border_width: NATURAL_16 assign set_border_width
		do
			Result := c_border_width (c_pointer)
		end

	managed: INTEGER_8 assign set_managed
		do
			Result := c_managed (c_pointer)
		end

	sensitive: INTEGER_8 assign set_sensitive
		do
			Result := c_sensitive (c_pointer)
		end

	ancestor_sensitive: INTEGER_8 assign set_ancestor_sensitive
		do
			Result := c_ancestor_sensitive (c_pointer)
		end

	event_table: CE_POINTER [ANY] assign set_event_table
		do
			create Result.make_shared (c_event_table (c_pointer))
		end

	tm: SD_XTTMREC assign set_tm
		do
			create Result.make_shared (c_tm (c_pointer))
		end

	accelerators: CE_POINTER [ANY] assign set_accelerators
		do
			create Result.make_shared (c_accelerators (c_pointer))
		end

	border_pixel: NATURAL_32 assign set_border_pixel
		do
			Result := c_border_pixel (c_pointer)
		end

	border_pixmap: NATURAL_32 assign set_border_pixmap
		do
			Result := c_border_pixmap (c_pointer)
		end

	popup_list: CE_POINTER [CE_POINTER [SD_WIDGETREC]] assign set_popup_list
		do
			create Result.make_shared (c_popup_list (c_pointer))
		end

	num_popups: NATURAL_32 assign set_num_popups
		do
			Result := c_num_popups (c_pointer)
		end

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	screen: CE_POINTER [SD_SCREEN] assign set_screen
		do
			create Result.make_shared (c_screen (c_pointer))
		end

	colormap: NATURAL_32 assign set_colormap
		do
			Result := c_colormap (c_pointer)
		end

	window: NATURAL_32 assign set_window
		do
			Result := c_window (c_pointer)
		end

	depth: NATURAL_32 assign set_depth
		do
			Result := c_depth (c_pointer)
		end

	background_pixel: NATURAL_32 assign set_background_pixel
		do
			Result := c_background_pixel (c_pointer)
		end

	background_pixmap: NATURAL_32 assign set_background_pixmap
		do
			Result := c_background_pixmap (c_pointer)
		end

	visible: INTEGER_8 assign set_visible
		do
			Result := c_visible (c_pointer)
		end

	mapped_when_managed: INTEGER_8 assign set_mapped_when_managed
		do
			Result := c_mapped_when_managed (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_self (a_self: CE_POINTER [SD_WIDGETREC])
		do
			c_set_self (c_pointer, a_self.c_pointer)
		end

	set_widget_class (a_widget_class: CE_POINTER [SD_WIDGETCLASSREC])
		do
			c_set_widget_class (c_pointer, a_widget_class.c_pointer)
		end

	set_parent (a_parent: CE_POINTER [SD_WIDGETREC])
		do
			c_set_parent (c_pointer, a_parent.c_pointer)
		end

	set_xrm_name (a_xrm_name: INTEGER_32)
		do
			c_set_xrm_name (c_pointer, a_xrm_name)
		end

	set_being_destroyed (a_being_destroyed: INTEGER_8)
		do
			c_set_being_destroyed (c_pointer, a_being_destroyed)
		end

	set_destroy_callbacks (a_destroy_callbacks: CE_POINTER [SD_XTCALLBACKREC])
		do
			c_set_destroy_callbacks (c_pointer, a_destroy_callbacks.c_pointer)
		end

	set_constraints (a_constraints: CE_POINTER [ANY])
		do
			c_set_constraints (c_pointer, a_constraints.c_pointer)
		end

	set_x (a_x: INTEGER_16)
		do
			c_set_x (c_pointer, a_x)
		end

	set_y (a_y: INTEGER_16)
		do
			c_set_y (c_pointer, a_y)
		end

	set_width (a_width: NATURAL_16)
		do
			c_set_width (c_pointer, a_width)
		end

	set_height (a_height: NATURAL_16)
		do
			c_set_height (c_pointer, a_height)
		end

	set_border_width (a_border_width: NATURAL_16)
		do
			c_set_border_width (c_pointer, a_border_width)
		end

	set_managed (a_managed: INTEGER_8)
		do
			c_set_managed (c_pointer, a_managed)
		end

	set_sensitive (a_sensitive: INTEGER_8)
		do
			c_set_sensitive (c_pointer, a_sensitive)
		end

	set_ancestor_sensitive (a_ancestor_sensitive: INTEGER_8)
		do
			c_set_ancestor_sensitive (c_pointer, a_ancestor_sensitive)
		end

	set_event_table (a_event_table: CE_POINTER [ANY])
		do
			c_set_event_table (c_pointer, a_event_table.c_pointer)
		end

	set_tm (a_tm: SD_XTTMREC)
		do
			tm.ce_gets (a_tm)
		end

	set_accelerators (a_accelerators: CE_POINTER [ANY])
		do
			c_set_accelerators (c_pointer, a_accelerators.c_pointer)
		end

	set_border_pixel (a_border_pixel: NATURAL_32)
		do
			c_set_border_pixel (c_pointer, a_border_pixel)
		end

	set_border_pixmap (a_border_pixmap: NATURAL_32)
		do
			c_set_border_pixmap (c_pointer, a_border_pixmap)
		end

	set_popup_list (a_popup_list: CE_POINTER [CE_POINTER [SD_WIDGETREC]])
		do
			c_set_popup_list (c_pointer, a_popup_list.c_pointer)
		end

	set_num_popups (a_num_popups: NATURAL_32)
		do
			c_set_num_popups (c_pointer, a_num_popups)
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_screen (a_screen: CE_POINTER [SD_SCREEN])
		do
			c_set_screen (c_pointer, a_screen.c_pointer)
		end

	set_colormap (a_colormap: NATURAL_32)
		do
			c_set_colormap (c_pointer, a_colormap)
		end

	set_window (a_window: NATURAL_32)
		do
			c_set_window (c_pointer, a_window)
		end

	set_depth (a_depth: NATURAL_32)
		do
			c_set_depth (c_pointer, a_depth)
		end

	set_background_pixel (a_background_pixel: NATURAL_32)
		do
			c_set_background_pixel (c_pointer, a_background_pixel)
		end

	set_background_pixmap (a_background_pixmap: NATURAL_32)
		do
			c_set_background_pixmap (c_pointer, a_background_pixmap)
		end

	set_visible (a_visible: INTEGER_8)
		do
			c_set_visible (c_pointer, a_visible)
		end

	set_mapped_when_managed (a_mapped_when_managed: INTEGER_8)
		do
			c_set_mapped_when_managed (c_pointer, a_mapped_when_managed)
		end

feature {NONE} -- C getters

	c_self (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _WidgetRec *)((struct _CorePart *)$tmp)->self;"
		end

	c_widget_class (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _WidgetClassRec *)((struct _CorePart *)$tmp)->widget_class;"
		end

	c_parent (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _WidgetRec *)((struct _CorePart *)$tmp)->parent;"
		end

	c_xrm_name (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _CorePart *)$tmp)->xrm_name;"
		end

	c_being_destroyed (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct _CorePart *)$tmp)->being_destroyed;"
		end

	c_destroy_callbacks (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _XtCallbackRec *)((struct _CorePart *)$tmp)->destroy_callbacks;"
		end

	c_constraints (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _CorePart *)$tmp)->constraints;"
		end

	c_x (tmp: POINTER): INTEGER_16
		external
			"C inline"
		alias
			"return (short)((struct _CorePart *)$tmp)->x;"
		end

	c_y (tmp: POINTER): INTEGER_16
		external
			"C inline"
		alias
			"return (short)((struct _CorePart *)$tmp)->y;"
		end

	c_width (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _CorePart *)$tmp)->width;"
		end

	c_height (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _CorePart *)$tmp)->height;"
		end

	c_border_width (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _CorePart *)$tmp)->border_width;"
		end

	c_managed (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct _CorePart *)$tmp)->managed;"
		end

	c_sensitive (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct _CorePart *)$tmp)->sensitive;"
		end

	c_ancestor_sensitive (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct _CorePart *)$tmp)->ancestor_sensitive;"
		end

	c_event_table (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _CorePart *)$tmp)->event_table;"
		end

	c_tm (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _XtTMRec *)&((struct _CorePart *)$tmp)->tm;"
		end

	c_accelerators (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _CorePart *)$tmp)->accelerators;"
		end

	c_border_pixel (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct _CorePart *)$tmp)->border_pixel;"
		end

	c_border_pixmap (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct _CorePart *)$tmp)->border_pixmap;"
		end

	c_popup_list (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _WidgetRec * *)((struct _CorePart *)$tmp)->popup_list;"
		end

	c_num_popups (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _CorePart *)$tmp)->num_popups;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _CorePart *)$tmp)->name;"
		end

	c_screen (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (Screen *)((struct _CorePart *)$tmp)->screen;"
		end

	c_colormap (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct _CorePart *)$tmp)->colormap;"
		end

	c_window (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct _CorePart *)$tmp)->window;"
		end

	c_depth (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _CorePart *)$tmp)->depth;"
		end

	c_background_pixel (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct _CorePart *)$tmp)->background_pixel;"
		end

	c_background_pixmap (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct _CorePart *)$tmp)->background_pixmap;"
		end

	c_visible (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct _CorePart *)$tmp)->visible;"
		end

	c_mapped_when_managed (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct _CorePart *)$tmp)->mapped_when_managed;"
		end

feature {NONE} -- C setters

	c_set_self (tmp: POINTER; a_self: POINTER)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->self = (struct _WidgetRec *)$a_self;"
		end

	c_set_widget_class (tmp: POINTER; a_widget_class: POINTER)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->widget_class = (struct _WidgetClassRec *)$a_widget_class;"
		end

	c_set_parent (tmp: POINTER; a_parent: POINTER)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->parent = (struct _WidgetRec *)$a_parent;"
		end

	c_set_xrm_name (tmp: POINTER; a_xrm_name: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->xrm_name = $a_xrm_name;"
		end

	c_set_being_destroyed (tmp: POINTER; a_being_destroyed: INTEGER_8)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->being_destroyed = $a_being_destroyed;"
		end

	c_set_destroy_callbacks (tmp: POINTER; a_destroy_callbacks: POINTER)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->destroy_callbacks = (struct _XtCallbackRec *)$a_destroy_callbacks;"
		end

	c_set_constraints (tmp: POINTER; a_constraints: POINTER)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->constraints = (void *)$a_constraints;"
		end

	c_set_x (tmp: POINTER; a_x: INTEGER_16)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->x = $a_x;"
		end

	c_set_y (tmp: POINTER; a_y: INTEGER_16)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->y = $a_y;"
		end

	c_set_width (tmp: POINTER; a_width: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->width = $a_width;"
		end

	c_set_height (tmp: POINTER; a_height: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->height = $a_height;"
		end

	c_set_border_width (tmp: POINTER; a_border_width: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->border_width = $a_border_width;"
		end

	c_set_managed (tmp: POINTER; a_managed: INTEGER_8)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->managed = $a_managed;"
		end

	c_set_sensitive (tmp: POINTER; a_sensitive: INTEGER_8)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->sensitive = $a_sensitive;"
		end

	c_set_ancestor_sensitive (tmp: POINTER; a_ancestor_sensitive: INTEGER_8)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->ancestor_sensitive = $a_ancestor_sensitive;"
		end

	c_set_event_table (tmp: POINTER; a_event_table: POINTER)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->event_table = (void *)$a_event_table;"
		end

	c_set_accelerators (tmp: POINTER; a_accelerators: POINTER)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->accelerators = (void *)$a_accelerators;"
		end

	c_set_border_pixel (tmp: POINTER; a_border_pixel: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->border_pixel = $a_border_pixel;"
		end

	c_set_border_pixmap (tmp: POINTER; a_border_pixmap: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->border_pixmap = $a_border_pixmap;"
		end

	c_set_popup_list (tmp: POINTER; a_popup_list: POINTER)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->popup_list = (struct _WidgetRec * *)$a_popup_list;"
		end

	c_set_num_popups (tmp: POINTER; a_num_popups: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->num_popups = $a_num_popups;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->name = (char *)$a_name;"
		end

	c_set_screen (tmp: POINTER; a_screen: POINTER)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->screen = (Screen *)$a_screen;"
		end

	c_set_colormap (tmp: POINTER; a_colormap: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->colormap = $a_colormap;"
		end

	c_set_window (tmp: POINTER; a_window: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->window = $a_window;"
		end

	c_set_depth (tmp: POINTER; a_depth: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->depth = $a_depth;"
		end

	c_set_background_pixel (tmp: POINTER; a_background_pixel: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->background_pixel = $a_background_pixel;"
		end

	c_set_background_pixmap (tmp: POINTER; a_background_pixmap: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->background_pixmap = $a_background_pixmap;"
		end

	c_set_visible (tmp: POINTER; a_visible: INTEGER_8)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->visible = $a_visible;"
		end

	c_set_mapped_when_managed (tmp: POINTER; a_mapped_when_managed: INTEGER_8)
		external
			"C inline"
		alias
			"((struct _CorePart *)$tmp)->mapped_when_managed = $a_mapped_when_managed;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return sizeof(struct _CorePart);"
		end

end
