class
	SD_SCREEN

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ext_data: CE_POINTER [SD_XEXTDATA] assign set_ext_data
		do
			create Result.make_shared (c_ext_data (c_pointer))
		end

	display: CE_POINTER [ANY] assign set_display
		do
			create Result.make_shared (c_display (c_pointer))
		end

	root: NATURAL_32 assign set_root
		do
			Result := c_root (c_pointer)
		end

	width: INTEGER_32 assign set_width
		do
			Result := c_width (c_pointer)
		end

	height: INTEGER_32 assign set_height
		do
			Result := c_height (c_pointer)
		end

	mwidth: INTEGER_32 assign set_mwidth
		do
			Result := c_mwidth (c_pointer)
		end

	mheight: INTEGER_32 assign set_mheight
		do
			Result := c_mheight (c_pointer)
		end

	ndepths: INTEGER_32 assign set_ndepths
		do
			Result := c_ndepths (c_pointer)
		end

	depths: CE_POINTER [SD_DEPTH] assign set_depths
		do
			create Result.make_shared (c_depths (c_pointer))
		end

	root_depth: INTEGER_32 assign set_root_depth
		do
			Result := c_root_depth (c_pointer)
		end

	root_visual: CE_POINTER [SD_VISUAL] assign set_root_visual
		do
			create Result.make_shared (c_root_visual (c_pointer))
		end

	default_gc: CE_POINTER [ANY] assign set_default_gc
		do
			create Result.make_shared (c_default_gc (c_pointer))
		end

	cmap: NATURAL_32 assign set_cmap
		do
			Result := c_cmap (c_pointer)
		end

	white_pixel: NATURAL_32 assign set_white_pixel
		do
			Result := c_white_pixel (c_pointer)
		end

	black_pixel: NATURAL_32 assign set_black_pixel
		do
			Result := c_black_pixel (c_pointer)
		end

	max_maps: INTEGER_32 assign set_max_maps
		do
			Result := c_max_maps (c_pointer)
		end

	min_maps: INTEGER_32 assign set_min_maps
		do
			Result := c_min_maps (c_pointer)
		end

	backing_store: INTEGER_32 assign set_backing_store
		do
			Result := c_backing_store (c_pointer)
		end

	save_unders: INTEGER_32 assign set_save_unders
		do
			Result := c_save_unders (c_pointer)
		end

	root_input_mask: INTEGER_32 assign set_root_input_mask
		do
			Result := c_root_input_mask (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_ext_data (a_ext_data: CE_POINTER [SD_XEXTDATA])
		do
			c_set_ext_data (c_pointer, a_ext_data.c_pointer)
		end

	set_display (a_display: CE_POINTER [ANY])
		do
			c_set_display (c_pointer, a_display.c_pointer)
		end

	set_root (a_root: NATURAL_32)
		do
			c_set_root (c_pointer, a_root)
		end

	set_width (a_width: INTEGER_32)
		do
			c_set_width (c_pointer, a_width)
		end

	set_height (a_height: INTEGER_32)
		do
			c_set_height (c_pointer, a_height)
		end

	set_mwidth (a_mwidth: INTEGER_32)
		do
			c_set_mwidth (c_pointer, a_mwidth)
		end

	set_mheight (a_mheight: INTEGER_32)
		do
			c_set_mheight (c_pointer, a_mheight)
		end

	set_ndepths (a_ndepths: INTEGER_32)
		do
			c_set_ndepths (c_pointer, a_ndepths)
		end

	set_depths (a_depths: CE_POINTER [SD_DEPTH])
		do
			c_set_depths (c_pointer, a_depths.c_pointer)
		end

	set_root_depth (a_root_depth: INTEGER_32)
		do
			c_set_root_depth (c_pointer, a_root_depth)
		end

	set_root_visual (a_root_visual: CE_POINTER [SD_VISUAL])
		do
			c_set_root_visual (c_pointer, a_root_visual.c_pointer)
		end

	set_default_gc (a_default_gc: CE_POINTER [ANY])
		do
			c_set_default_gc (c_pointer, a_default_gc.c_pointer)
		end

	set_cmap (a_cmap: NATURAL_32)
		do
			c_set_cmap (c_pointer, a_cmap)
		end

	set_white_pixel (a_white_pixel: NATURAL_32)
		do
			c_set_white_pixel (c_pointer, a_white_pixel)
		end

	set_black_pixel (a_black_pixel: NATURAL_32)
		do
			c_set_black_pixel (c_pointer, a_black_pixel)
		end

	set_max_maps (a_max_maps: INTEGER_32)
		do
			c_set_max_maps (c_pointer, a_max_maps)
		end

	set_min_maps (a_min_maps: INTEGER_32)
		do
			c_set_min_maps (c_pointer, a_min_maps)
		end

	set_backing_store (a_backing_store: INTEGER_32)
		do
			c_set_backing_store (c_pointer, a_backing_store)
		end

	set_save_unders (a_save_unders: INTEGER_32)
		do
			c_set_save_unders (c_pointer, a_save_unders)
		end

	set_root_input_mask (a_root_input_mask: INTEGER_32)
		do
			c_set_root_input_mask (c_pointer, a_root_input_mask)
		end

feature {NONE} -- C getters

	c_ext_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _XExtData *)((struct __anonstruct_Screen_28 *)$tmp)->ext_data;"
		end

	c_display (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_Screen_28 *)$tmp)->display;"
		end

	c_root (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_Screen_28 *)$tmp)->root;"
		end

	c_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_Screen_28 *)$tmp)->width;"
		end

	c_height (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_Screen_28 *)$tmp)->height;"
		end

	c_mwidth (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_Screen_28 *)$tmp)->mwidth;"
		end

	c_mheight (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_Screen_28 *)$tmp)->mheight;"
		end

	c_ndepths (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_Screen_28 *)$tmp)->ndepths;"
		end

	c_depths (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (Depth *)((struct __anonstruct_Screen_28 *)$tmp)->depths;"
		end

	c_root_depth (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_Screen_28 *)$tmp)->root_depth;"
		end

	c_root_visual (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (Visual *)((struct __anonstruct_Screen_28 *)$tmp)->root_visual;"
		end

	c_default_gc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_Screen_28 *)$tmp)->default_gc;"
		end

	c_cmap (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_Screen_28 *)$tmp)->cmap;"
		end

	c_white_pixel (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_Screen_28 *)$tmp)->white_pixel;"
		end

	c_black_pixel (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_Screen_28 *)$tmp)->black_pixel;"
		end

	c_max_maps (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_Screen_28 *)$tmp)->max_maps;"
		end

	c_min_maps (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_Screen_28 *)$tmp)->min_maps;"
		end

	c_backing_store (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_Screen_28 *)$tmp)->backing_store;"
		end

	c_save_unders (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_Screen_28 *)$tmp)->save_unders;"
		end

	c_root_input_mask (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_Screen_28 *)$tmp)->root_input_mask;"
		end

feature {NONE} -- C setters

	c_set_ext_data (tmp: POINTER; a_ext_data: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_Screen_28 *)$tmp)->ext_data = (struct _XExtData *)$a_ext_data;"
		end

	c_set_display (tmp: POINTER; a_display: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_Screen_28 *)$tmp)->display = (void *)$a_display;"
		end

	c_set_root (tmp: POINTER; a_root: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_Screen_28 *)$tmp)->root = $a_root;"
		end

	c_set_width (tmp: POINTER; a_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_Screen_28 *)$tmp)->width = $a_width;"
		end

	c_set_height (tmp: POINTER; a_height: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_Screen_28 *)$tmp)->height = $a_height;"
		end

	c_set_mwidth (tmp: POINTER; a_mwidth: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_Screen_28 *)$tmp)->mwidth = $a_mwidth;"
		end

	c_set_mheight (tmp: POINTER; a_mheight: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_Screen_28 *)$tmp)->mheight = $a_mheight;"
		end

	c_set_ndepths (tmp: POINTER; a_ndepths: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_Screen_28 *)$tmp)->ndepths = $a_ndepths;"
		end

	c_set_depths (tmp: POINTER; a_depths: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_Screen_28 *)$tmp)->depths = (Depth *)$a_depths;"
		end

	c_set_root_depth (tmp: POINTER; a_root_depth: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_Screen_28 *)$tmp)->root_depth = $a_root_depth;"
		end

	c_set_root_visual (tmp: POINTER; a_root_visual: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_Screen_28 *)$tmp)->root_visual = (Visual *)$a_root_visual;"
		end

	c_set_default_gc (tmp: POINTER; a_default_gc: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_Screen_28 *)$tmp)->default_gc = (void *)$a_default_gc;"
		end

	c_set_cmap (tmp: POINTER; a_cmap: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_Screen_28 *)$tmp)->cmap = $a_cmap;"
		end

	c_set_white_pixel (tmp: POINTER; a_white_pixel: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_Screen_28 *)$tmp)->white_pixel = $a_white_pixel;"
		end

	c_set_black_pixel (tmp: POINTER; a_black_pixel: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_Screen_28 *)$tmp)->black_pixel = $a_black_pixel;"
		end

	c_set_max_maps (tmp: POINTER; a_max_maps: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_Screen_28 *)$tmp)->max_maps = $a_max_maps;"
		end

	c_set_min_maps (tmp: POINTER; a_min_maps: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_Screen_28 *)$tmp)->min_maps = $a_min_maps;"
		end

	c_set_backing_store (tmp: POINTER; a_backing_store: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_Screen_28 *)$tmp)->backing_store = $a_backing_store;"
		end

	c_set_save_unders (tmp: POINTER; a_save_unders: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_Screen_28 *)$tmp)->save_unders = $a_save_unders;"
		end

	c_set_root_input_mask (tmp: POINTER; a_root_input_mask: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_Screen_28 *)$tmp)->root_input_mask = $a_root_input_mask;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return sizeof(struct __anonstruct_Screen_28);"
		end

end
