class
	SD_XSETWINDOWATTRIBUTES

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	background_pixmap: NATURAL_32 assign set_background_pixmap
		do
			Result := c_background_pixmap (c_pointer)
		end

	background_pixel: NATURAL_32 assign set_background_pixel
		do
			Result := c_background_pixel (c_pointer)
		end

	border_pixmap: NATURAL_32 assign set_border_pixmap
		do
			Result := c_border_pixmap (c_pointer)
		end

	border_pixel: NATURAL_32 assign set_border_pixel
		do
			Result := c_border_pixel (c_pointer)
		end

	bit_gravity: INTEGER_32 assign set_bit_gravity
		do
			Result := c_bit_gravity (c_pointer)
		end

	win_gravity: INTEGER_32 assign set_win_gravity
		do
			Result := c_win_gravity (c_pointer)
		end

	backing_store: INTEGER_32 assign set_backing_store
		do
			Result := c_backing_store (c_pointer)
		end

	backing_planes: NATURAL_32 assign set_backing_planes
		do
			Result := c_backing_planes (c_pointer)
		end

	backing_pixel: NATURAL_32 assign set_backing_pixel
		do
			Result := c_backing_pixel (c_pointer)
		end

	save_under: INTEGER_32 assign set_save_under
		do
			Result := c_save_under (c_pointer)
		end

	event_mask: INTEGER_32 assign set_event_mask
		do
			Result := c_event_mask (c_pointer)
		end

	do_not_propagate_mask: INTEGER_32 assign set_do_not_propagate_mask
		do
			Result := c_do_not_propagate_mask (c_pointer)
		end

	override_redirect: INTEGER_32 assign set_override_redirect
		do
			Result := c_override_redirect (c_pointer)
		end

	colormap: NATURAL_32 assign set_colormap
		do
			Result := c_colormap (c_pointer)
		end

	cursor: NATURAL_32 assign set_cursor
		do
			Result := c_cursor (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_background_pixmap (a_background_pixmap: NATURAL_32)
		do
			c_set_background_pixmap (c_pointer, a_background_pixmap)
		end

	set_background_pixel (a_background_pixel: NATURAL_32)
		do
			c_set_background_pixel (c_pointer, a_background_pixel)
		end

	set_border_pixmap (a_border_pixmap: NATURAL_32)
		do
			c_set_border_pixmap (c_pointer, a_border_pixmap)
		end

	set_border_pixel (a_border_pixel: NATURAL_32)
		do
			c_set_border_pixel (c_pointer, a_border_pixel)
		end

	set_bit_gravity (a_bit_gravity: INTEGER_32)
		do
			c_set_bit_gravity (c_pointer, a_bit_gravity)
		end

	set_win_gravity (a_win_gravity: INTEGER_32)
		do
			c_set_win_gravity (c_pointer, a_win_gravity)
		end

	set_backing_store (a_backing_store: INTEGER_32)
		do
			c_set_backing_store (c_pointer, a_backing_store)
		end

	set_backing_planes (a_backing_planes: NATURAL_32)
		do
			c_set_backing_planes (c_pointer, a_backing_planes)
		end

	set_backing_pixel (a_backing_pixel: NATURAL_32)
		do
			c_set_backing_pixel (c_pointer, a_backing_pixel)
		end

	set_save_under (a_save_under: INTEGER_32)
		do
			c_set_save_under (c_pointer, a_save_under)
		end

	set_event_mask (a_event_mask: INTEGER_32)
		do
			c_set_event_mask (c_pointer, a_event_mask)
		end

	set_do_not_propagate_mask (a_do_not_propagate_mask: INTEGER_32)
		do
			c_set_do_not_propagate_mask (c_pointer, a_do_not_propagate_mask)
		end

	set_override_redirect (a_override_redirect: INTEGER_32)
		do
			c_set_override_redirect (c_pointer, a_override_redirect)
		end

	set_colormap (a_colormap: NATURAL_32)
		do
			c_set_colormap (c_pointer, a_colormap)
		end

	set_cursor (a_cursor: NATURAL_32)
		do
			c_set_cursor (c_pointer, a_cursor)
		end

feature {NONE} -- C getters

	c_background_pixmap (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->background_pixmap;"
		end

	c_background_pixel (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->background_pixel;"
		end

	c_border_pixmap (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->border_pixmap;"
		end

	c_border_pixel (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->border_pixel;"
		end

	c_bit_gravity (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->bit_gravity;"
		end

	c_win_gravity (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->win_gravity;"
		end

	c_backing_store (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->backing_store;"
		end

	c_backing_planes (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->backing_planes;"
		end

	c_backing_pixel (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->backing_pixel;"
		end

	c_save_under (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->save_under;"
		end

	c_event_mask (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->event_mask;"
		end

	c_do_not_propagate_mask (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->do_not_propagate_mask;"
		end

	c_override_redirect (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->override_redirect;"
		end

	c_colormap (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->colormap;"
		end

	c_cursor (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->cursor;"
		end

feature {NONE} -- C setters

	c_set_background_pixmap (tmp: POINTER; a_background_pixmap: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->background_pixmap = $a_background_pixmap;"
		end

	c_set_background_pixel (tmp: POINTER; a_background_pixel: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->background_pixel = $a_background_pixel;"
		end

	c_set_border_pixmap (tmp: POINTER; a_border_pixmap: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->border_pixmap = $a_border_pixmap;"
		end

	c_set_border_pixel (tmp: POINTER; a_border_pixel: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->border_pixel = $a_border_pixel;"
		end

	c_set_bit_gravity (tmp: POINTER; a_bit_gravity: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->bit_gravity = $a_bit_gravity;"
		end

	c_set_win_gravity (tmp: POINTER; a_win_gravity: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->win_gravity = $a_win_gravity;"
		end

	c_set_backing_store (tmp: POINTER; a_backing_store: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->backing_store = $a_backing_store;"
		end

	c_set_backing_planes (tmp: POINTER; a_backing_planes: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->backing_planes = $a_backing_planes;"
		end

	c_set_backing_pixel (tmp: POINTER; a_backing_pixel: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->backing_pixel = $a_backing_pixel;"
		end

	c_set_save_under (tmp: POINTER; a_save_under: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->save_under = $a_save_under;"
		end

	c_set_event_mask (tmp: POINTER; a_event_mask: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->event_mask = $a_event_mask;"
		end

	c_set_do_not_propagate_mask (tmp: POINTER; a_do_not_propagate_mask: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->do_not_propagate_mask = $a_do_not_propagate_mask;"
		end

	c_set_override_redirect (tmp: POINTER; a_override_redirect: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->override_redirect = $a_override_redirect;"
		end

	c_set_colormap (tmp: POINTER; a_colormap: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->colormap = $a_colormap;"
		end

	c_set_cursor (tmp: POINTER; a_cursor: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSetWindowAttributes_30 *)$tmp)->cursor = $a_cursor;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return sizeof(struct __anonstruct_XSetWindowAttributes_30);"
		end

end
