class
	SD_XTCONVERTARGREC

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	address_mode: INTEGER_32 assign set_address_mode
		do
			Result := c_address_mode (c_pointer)
		end

	address_id: CE_POINTER [ANY] assign set_address_id
		do
			create Result.make_shared (c_address_id (c_pointer))
		end

	size: NATURAL_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_address_mode (a_address_mode: INTEGER_32)
		do
			c_set_address_mode (c_pointer, a_address_mode)
		end

	set_address_id (a_address_id: CE_POINTER [ANY])
		do
			c_set_address_id (c_pointer, a_address_id.c_pointer)
		end

	set_size (a_size: NATURAL_32)
		do
			c_set_size (c_pointer, a_size)
		end

feature {NONE} -- C getters

	c_address_mode (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XtConvertArgRec_116 *)$tmp)->address_mode;"
		end

	c_address_id (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_XtConvertArgRec_116 *)$tmp)->address_id;"
		end

	c_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_XtConvertArgRec_116 *)$tmp)->size;"
		end

feature {NONE} -- C setters

	c_set_address_mode (tmp: POINTER; a_address_mode: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XtConvertArgRec_116 *)$tmp)->address_mode = $a_address_mode;"
		end

	c_set_address_id (tmp: POINTER; a_address_id: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_XtConvertArgRec_116 *)$tmp)->address_id = (void *)$a_address_id;"
		end

	c_set_size (tmp: POINTER; a_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XtConvertArgRec_116 *)$tmp)->size = $a_size;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return sizeof(struct __anonstruct_XtConvertArgRec_116);"
		end

end
