class
	SD_XTWIDGETGEOMETRY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	request_mode: NATURAL_32 assign set_request_mode
		do
			Result := c_request_mode (c_pointer)
		end

	x: INTEGER_16 assign set_x
		do
			Result := c_x (c_pointer)
		end

	y: INTEGER_16 assign set_y
		do
			Result := c_y (c_pointer)
		end

	width: NATURAL_16 assign set_width
		do
			Result := c_width (c_pointer)
		end

	height: NATURAL_16 assign set_height
		do
			Result := c_height (c_pointer)
		end

	border_width: NATURAL_16 assign set_border_width
		do
			Result := c_border_width (c_pointer)
		end

	sibling: CE_POINTER [SD_WIDGETREC] assign set_sibling
		do
			create Result.make_shared (c_sibling (c_pointer))
		end

	stack_mode: INTEGER_32 assign set_stack_mode
		do
			Result := c_stack_mode (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_request_mode (a_request_mode: NATURAL_32)
		do
			c_set_request_mode (c_pointer, a_request_mode)
		end

	set_x (a_x: INTEGER_16)
		do
			c_set_x (c_pointer, a_x)
		end

	set_y (a_y: INTEGER_16)
		do
			c_set_y (c_pointer, a_y)
		end

	set_width (a_width: NATURAL_16)
		do
			c_set_width (c_pointer, a_width)
		end

	set_height (a_height: NATURAL_16)
		do
			c_set_height (c_pointer, a_height)
		end

	set_border_width (a_border_width: NATURAL_16)
		do
			c_set_border_width (c_pointer, a_border_width)
		end

	set_sibling (a_sibling: CE_POINTER [SD_WIDGETREC])
		do
			c_set_sibling (c_pointer, a_sibling.c_pointer)
		end

	set_stack_mode (a_stack_mode: INTEGER_32)
		do
			c_set_stack_mode (c_pointer, a_stack_mode)
		end

feature {NONE} -- C getters

	c_request_mode (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_XtWidgetGeometry_117 *)$tmp)->request_mode;"
		end

	c_x (tmp: POINTER): INTEGER_16
		external
			"C inline"
		alias
			"return (short)((struct __anonstruct_XtWidgetGeometry_117 *)$tmp)->x;"
		end

	c_y (tmp: POINTER): INTEGER_16
		external
			"C inline"
		alias
			"return (short)((struct __anonstruct_XtWidgetGeometry_117 *)$tmp)->y;"
		end

	c_width (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct __anonstruct_XtWidgetGeometry_117 *)$tmp)->width;"
		end

	c_height (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct __anonstruct_XtWidgetGeometry_117 *)$tmp)->height;"
		end

	c_border_width (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct __anonstruct_XtWidgetGeometry_117 *)$tmp)->border_width;"
		end

	c_sibling (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _WidgetRec *)((struct __anonstruct_XtWidgetGeometry_117 *)$tmp)->sibling;"
		end

	c_stack_mode (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XtWidgetGeometry_117 *)$tmp)->stack_mode;"
		end

feature {NONE} -- C setters

	c_set_request_mode (tmp: POINTER; a_request_mode: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XtWidgetGeometry_117 *)$tmp)->request_mode = $a_request_mode;"
		end

	c_set_x (tmp: POINTER; a_x: INTEGER_16)
		external
			"C inline"
		alias
			"((struct __anonstruct_XtWidgetGeometry_117 *)$tmp)->x = $a_x;"
		end

	c_set_y (tmp: POINTER; a_y: INTEGER_16)
		external
			"C inline"
		alias
			"((struct __anonstruct_XtWidgetGeometry_117 *)$tmp)->y = $a_y;"
		end

	c_set_width (tmp: POINTER; a_width: NATURAL_16)
		external
			"C inline"
		alias
			"((struct __anonstruct_XtWidgetGeometry_117 *)$tmp)->width = $a_width;"
		end

	c_set_height (tmp: POINTER; a_height: NATURAL_16)
		external
			"C inline"
		alias
			"((struct __anonstruct_XtWidgetGeometry_117 *)$tmp)->height = $a_height;"
		end

	c_set_border_width (tmp: POINTER; a_border_width: NATURAL_16)
		external
			"C inline"
		alias
			"((struct __anonstruct_XtWidgetGeometry_117 *)$tmp)->border_width = $a_border_width;"
		end

	c_set_sibling (tmp: POINTER; a_sibling: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_XtWidgetGeometry_117 *)$tmp)->sibling = (struct _WidgetRec *)$a_sibling;"
		end

	c_set_stack_mode (tmp: POINTER; a_stack_mode: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XtWidgetGeometry_117 *)$tmp)->stack_mode = $a_stack_mode;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return sizeof(struct __anonstruct_XtWidgetGeometry_117);"
		end

end
