class
	PD_CS_ALIAS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	oname: CE_POINTER [INTEGER_8] assign set_oname
		do
			create Result.make_shared (c_oname (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_oname (a_oname: CE_POINTER [INTEGER_8])
		do
			c_set_oname (c_pointer, a_oname.c_pointer)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct cs_alias *)$tmp)->name;"
		end

	c_oname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct cs_alias *)$tmp)->oname;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct cs_alias *)$tmp)->name = (char *)$a_name;"
		end

	c_set_oname (tmp: POINTER; a_oname: POINTER)
		external
			"C inline"
		alias
			"((struct cs_alias *)$tmp)->oname = (char *)$a_oname;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return sizeof(struct cs_alias);"
		end

end
