class
	PD_LINENUM_INFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_LINENUM_INFO] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_LINENUM_INFO] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	pos: INTEGER_32 assign set_pos
		do
			Result := c_pos (c_pointer)
		end

	gap: INTEGER_32 assign set_gap
		do
			Result := c_gap (c_pointer)
		end

	line: INTEGER_32 assign set_line
		do
			Result := c_line (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_LINENUM_INFO])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_LINENUM_INFO])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_pos (a_pos: INTEGER_32)
		do
			c_set_pos (c_pointer, a_pos)
		end

	set_gap (a_gap: INTEGER_32)
		do
			c_set_gap (c_pointer, a_gap)
		end

	set_line (a_line: INTEGER_32)
		do
			c_set_line (c_pointer, a_line)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct linenum_info *)((struct linenum_info *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct linenum_info *)((struct linenum_info *)$tmp)->prev;"
		end

	c_pos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct linenum_info *)$tmp)->pos;"
		end

	c_gap (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct linenum_info *)$tmp)->gap;"
		end

	c_line (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct linenum_info *)$tmp)->line;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct linenum_info *)$tmp)->next = (struct linenum_info *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct linenum_info *)$tmp)->prev = (struct linenum_info *)$a_prev;"
		end

	c_set_pos (tmp: POINTER; a_pos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct linenum_info *)$tmp)->pos = $a_pos;"
		end

	c_set_gap (tmp: POINTER; a_gap: INTEGER_32)
		external
			"C inline"
		alias
			"((struct linenum_info *)$tmp)->gap = $a_gap;"
		end

	c_set_line (tmp: POINTER; a_line: INTEGER_32)
		external
			"C inline"
		alias
			"((struct linenum_info *)$tmp)->line = $a_line;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return sizeof(struct linenum_info);"
		end

end
