class
	PD_MARK

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	m_ifile: CE_POINTER [ANY] assign set_m_ifile
		do
			create Result.make_shared (c_m_ifile (c_pointer))
		end

	m_scrpos: PD_SCRPOS assign set_m_scrpos
		do
			create Result.make_shared (c_m_scrpos (c_pointer))
		end

	m_scrpos_offset: INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return (int)offsetof(struct mark, m_scrpos);"
		end

feature {ANY} -- Eiffel setters

	set_m_ifile (a_m_ifile: CE_POINTER [ANY])
		do
			c_set_m_ifile (c_pointer, a_m_ifile.c_pointer)
		end

	set_m_scrpos (a_m_scrpos: PD_SCRPOS)
		do
			m_scrpos.ce_gets (a_m_scrpos)
		end

feature {NONE} -- C getters

	c_m_ifile (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct mark *)$tmp)->m_ifile;"
		end

	c_m_scrpos (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct scrpos *)&((struct mark *)$tmp)->m_scrpos;"
		end

feature {NONE} -- C setters

	c_set_m_ifile (tmp: POINTER; a_m_ifile: POINTER)
		external
			"C inline"
		alias
			"((struct mark *)$tmp)->m_ifile = (void *)$a_m_ifile;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return sizeof(struct mark);"
		end

end
