class
	PD_PARG

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	p_string: CE_POINTER [INTEGER_8] assign set_p_string
		do
			create Result.make_shared (c_p_string (c_pointer))
		end

	p_int: INTEGER_32 assign set_p_int
		do
			Result := c_p_int (c_pointer)
		end

	p_linenum: INTEGER_32 assign set_p_linenum
		do
			Result := c_p_linenum (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_p_string (a_p_string: CE_POINTER [INTEGER_8])
		do
			c_set_p_string (c_pointer, a_p_string.c_pointer)
		end

	set_p_int (a_p_int: INTEGER_32)
		do
			c_set_p_int (c_pointer, a_p_int)
		end

	set_p_linenum (a_p_linenum: INTEGER_32)
		do
			c_set_p_linenum (c_pointer, a_p_linenum)
		end

feature {NONE} -- C getters

	c_p_string (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((union parg *)$tmp)->p_string;"
		end

	c_p_int (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((union parg *)$tmp)->p_int;"
		end

	c_p_linenum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((union parg *)$tmp)->p_linenum;"
		end

feature {NONE} -- C setters

	c_set_p_string (tmp: POINTER; a_p_string: POINTER)
		external
			"C inline"
		alias
			"((union parg *)$tmp)->p_string = (char *)$a_p_string;"
		end

	c_set_p_int (tmp: POINTER; a_p_int: INTEGER_32)
		external
			"C inline"
		alias
			"((union parg *)$tmp)->p_int = $a_p_int;"
		end

	c_set_p_linenum (tmp: POINTER; a_p_linenum: INTEGER_32)
		external
			"C inline"
		alias
			"((union parg *)$tmp)->p_linenum = $a_p_linenum;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return sizeof(union parg);"
		end

end
