class
	PD_SCRPOS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	pos: INTEGER_32 assign set_pos
		do
			Result := c_pos (c_pointer)
		end

	ln: INTEGER_32 assign set_ln
		do
			Result := c_ln (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_pos (a_pos: INTEGER_32)
		do
			c_set_pos (c_pointer, a_pos)
		end

	set_ln (a_ln: INTEGER_32)
		do
			c_set_ln (c_pointer, a_ln)
		end

feature {NONE} -- C getters

	c_pos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct scrpos *)$tmp)->pos;"
		end

	c_ln (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct scrpos *)$tmp)->ln;"
		end

feature {NONE} -- C setters

	c_set_pos (tmp: POINTER; a_pos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct scrpos *)$tmp)->pos = $a_pos;"
		end

	c_set_ln (tmp: POINTER; a_ln: INTEGER_32)
		external
			"C inline"
		alias
			"((struct scrpos *)$tmp)->ln = $a_ln;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return sizeof(struct scrpos);"
		end

end
