class
	PD_TAGLIST

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	tl_first: CE_POINTER [PD_TAG] assign set_tl_first
		do
			create Result.make_shared (c_tl_first (c_pointer))
		end

	tl_last: CE_POINTER [PD_TAG] assign set_tl_last
		do
			create Result.make_shared (c_tl_last (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_tl_first (a_tl_first: CE_POINTER [PD_TAG])
		do
			c_set_tl_first (c_pointer, a_tl_first.c_pointer)
		end

	set_tl_last (a_tl_last: CE_POINTER [PD_TAG])
		do
			c_set_tl_last (c_pointer, a_tl_last.c_pointer)
		end

feature {NONE} -- C getters

	c_tl_first (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct tag *)((struct taglist *)$tmp)->tl_first;"
		end

	c_tl_last (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct tag *)((struct taglist *)$tmp)->tl_last;"
		end

feature {NONE} -- C setters

	c_set_tl_first (tmp: POINTER; a_tl_first: POINTER)
		external
			"C inline"
		alias
			"((struct taglist *)$tmp)->tl_first = (struct tag *)$a_tl_first;"
		end

	c_set_tl_last (tmp: POINTER; a_tl_last: POINTER)
		external
			"C inline"
		alias
			"((struct taglist *)$tmp)->tl_last = (struct tag *)$a_tl_last;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return sizeof(struct taglist);"
		end

end
