class
	P_DECODE

inherit
	LESS_DATA
		redefine
			default_create
		end
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {NONE} -- Initialization

	default_create
		do
			create cmdtable.make (<<442>>)
			create edittable.make (<<198>>)
			create list_fcmd_tables.make
			create list_ecmd_tables.make
			create list_var_tables.make
			create list_sysvar_tables.make
		end

feature {ANY} -- attributes

	cmdtable: CE_ARRAY [NATURAL_8]

	edittable: CE_ARRAY [NATURAL_8]

	list_fcmd_tables: CE_POINTER [PD_TABLELIST]

	list_ecmd_tables: CE_POINTER [PD_TABLELIST]

	list_var_tables: CE_POINTER [PD_TABLELIST]

	list_sysvar_tables: CE_POINTER [PD_TABLELIST]

feature {ANY} -- routines

	expand_special_keys (a_table___0: CE_POINTER [INTEGER_8]; a_len: INTEGER_32)
		local
			l_fm: CE_POINTER [INTEGER_8]
			l_to: CE_POINTER [INTEGER_8]
			l_a: INTEGER_32
			l_repl: CE_POINTER [INTEGER_8]
			l_klen: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_fm.make
			create l_to.make
			create l_repl.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___7.make

			l_fm.ce_gets (a_table___0)
			from
			until
				not (not js.loop_left and then ((l_fm.c_pointer.to_integer_32).to_natural_32 < ((a_table___0 + a_len).c_pointer.to_integer_32).to_natural_32))
			loop
				l_to.ce_gets (l_fm)
				from
				until
					not (not js.loop_left and then ((l_fm[0]).to_integer_32 /= 0))
				loop
					js.reset
					if (l_fm[0]).to_integer_32 /= 11 then
						l_tmp.ce_gets (l_to)
						l_to.ce_gets (l_to + 1)
						l_tmp___0.ce_gets (l_fm)
						l_fm.ce_gets (l_fm + 1)
						l_tmp[0] := l_tmp___0[0]
						js.continue
					end
					if not js.loop_jumped then
						l_repl.ce_gets (screen_inst.special_key_str ((l_fm[1]).to_integer_32))
						l_klen := ((l_fm[2]).to_integer_32).bit_and (255)
						l_fm.ce_gets (l_fm + l_klen)
						if (l_repl.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_repl.ce_gets (ce_string ("%/255/"))
						elseif (strlen (l_repl)).to_integer_32 > l_klen then
							l_repl.ce_gets (ce_string ("%/255/"))
						end
						from
						until
							(l_repl[0]).to_integer_32 = 0
						loop
							l_tmp___2.ce_gets (l_to)
							l_to.ce_gets (l_to + 1)
							l_tmp___3.ce_gets (l_repl)
							l_repl.ce_gets (l_repl + 1)
							l_tmp___2[0] := l_tmp___3[0]
						end
					end
					if not js.loop_left then
						
					end
				end
				l_tmp___4.ce_gets (l_to)
				l_to.ce_gets (l_to + 1)
				l_tmp___4[0] := (('%/0/').code).to_integer_8
				from
				until
					not ((l_to.c_pointer.to_integer_32).to_natural_32 <= (l_fm.c_pointer.to_integer_32).to_natural_32)
				loop
					l_tmp___5.ce_gets (l_to)
					l_to.ce_gets (l_to + 1)
					l_tmp___5[0] := (127).to_integer_8
				end
				l_fm.ce_gets (l_fm + 1)
				l_tmp___6.ce_gets (l_fm)
				l_fm.ce_gets (l_fm + 1)
				l_a := ((l_tmp___6[0]).to_integer_32).bit_and (255)
				if ((l_a).bit_and (128)).to_boolean then
					from
					until
						js.loop_left
					loop
						js.reset
						l_tmp___7.ce_gets (l_fm)
						l_fm.ce_gets (l_fm + 1)
						if (l_tmp___7[0]).to_integer_32 = 0 then
							js.break
						end
						if not js.loop_jumped then
							js.continue
						end
					end
					js.reset
				end
			end
		end

	init_cmds
		do
			add_fcmd_table (create {CE_POINTER [INTEGER_8]}.make_cast (cmdtable), (Natural_8_bytes.to_natural_32 * (442).to_natural_32).to_integer_32)
			add_ecmd_table (create {CE_POINTER [INTEGER_8]}.make_cast (edittable), (Natural_8_bytes.to_natural_32 * (198).to_natural_32).to_integer_32)
			add_hometable (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("/usr/local/bin/.sysless"), 1)
			add_hometable (ce_string ("LESSKEY_SYSTEM"), ce_string ("/usr/local/etc/sysless"), 1)
			add_hometable (ce_string ("LESSKEY"), ce_string (".less"), 0)
		end

	add_cmd_table (a_tlist: CE_POINTER [CE_POINTER [PD_TABLELIST]]; a_buf___1: CE_POINTER [INTEGER_8]; a_len: INTEGER_32): INTEGER_32
		local
			l_t: CE_POINTER [PD_TABLELIST]
			js: JUMP_STATE
		do
			create l_t.make

			if a_len = 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_t.ce_gets (create {CE_POINTER [PD_TABLELIST]}.make_cast ((calloc ((1).to_natural_32, {PD_TABLELIST}.sizeof.to_natural_32))))
				if (l_t.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				expand_special_keys (a_buf___1, a_len)
				l_t.item.t_start := a_buf___1
				l_t.item.t_end := a_buf___1 + a_len
				l_t.item.t_next := a_tlist.item
				a_tlist.item := l_t
				Result := 0
			end
		end

	add_fcmd_table (a_buf___1: CE_POINTER [INTEGER_8]; a_len: INTEGER_32)
		do
			if (add_cmd_table (list_fcmd_tables.address, a_buf___1, a_len)) < 0 then
				output_inst.error (ce_string ("Warning: some commands disabled"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
			end
		end

	add_ecmd_table (a_buf___1: CE_POINTER [INTEGER_8]; a_len: INTEGER_32)
		do
			if (add_cmd_table (list_ecmd_tables.address, a_buf___1, a_len)) < 0 then
				output_inst.error (ce_string ("Warning: some edit commands disabled"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
			end
		end

	add_var_table (a_tlist: CE_POINTER [CE_POINTER [PD_TABLELIST]]; a_buf___1: CE_POINTER [INTEGER_8]; a_len: INTEGER_32)
		do
			if (add_cmd_table (a_tlist, a_buf___1, a_len)) < 0 then
				output_inst.error (ce_string ("Warning: environment variables from lesskey file unavailable"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
			end
		end

	cmd_search (a_cmd: CE_POINTER [INTEGER_8]; a_table___0: CE_POINTER [INTEGER_8]; a_endtable: CE_POINTER [INTEGER_8]; a_sp: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_p: CE_POINTER [INTEGER_8]
			l_q: CE_POINTER [INTEGER_8]
			l_a: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_p.make
			create l_q.make
			create l_tmp.make

			a_sp.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			l_p.ce_gets (a_table___0)
			l_q.ce_gets (a_cmd)
			from
			until
				not (not js.loop_left and then ((l_p.c_pointer.to_integer_32).to_natural_32 < (a_endtable.c_pointer.to_integer_32).to_natural_32))
			loop
				if (l_p[0]).to_integer_32 = (l_q[0]).to_integer_32 then
					if (l_p[0]).to_integer_32 = 0 then
						l_p.ce_gets (l_p + 1)
						l_a := ((l_p[0]).to_integer_32).bit_and (255)
						from
						until
							l_a /= 127
						loop
							l_p.ce_gets (l_p + 1)
							l_a := ((l_p[0]).to_integer_32).bit_and (255)
						end
						if l_a = 103 then
							Result := 102
							js.return
						end
						if not js.return_called then
							if ((l_a).bit_and (128)).to_boolean then
								l_p.ce_gets (l_p + 1)
								a_sp.item := l_p
								l_a := (l_a).bit_and ((-129))
							end
							Result := l_a
							js.return
						end
					end
				elseif (l_q[0]).to_integer_32 = 0 then
					Result := 22
					js.return
				else
					if (l_p[0]).to_integer_32 = 0 then
						if (l_p[1]).to_integer_32 = 103 then
							Result := 102
							js.return
						end
					end
					if not js.return_called then
						from
						until
							js.loop_left
						loop
							js.reset
							l_tmp.ce_gets (l_p)
							l_p.ce_gets (l_p + 1)
							if (l_tmp[0]).to_integer_32 = 0 then
								js.break
							end
							if not js.loop_jumped then
								js.continue
							end
						end
						js.reset
						from
						until
							(l_p[0]).to_integer_32 /= 127
						loop
							l_p.ce_gets (l_p + 1)
						end
						if (((l_p[0]).to_integer_32).bit_and (128)).to_boolean then
							from
							until
								js.loop_left
							loop
								js.reset
								l_p.ce_gets (l_p + 1)
								if (l_p[0]).to_integer_32 = 0 then
									js.break
								end
								if not js.loop_jumped then
									js.continue
								end
							end
							js.reset
						end
						l_q.ce_gets (a_cmd - 1)
					end
				end
				if not js.return_called then
					l_p.ce_gets (l_p + 1)
					l_q.ce_gets (l_q + 1)
				end
			end
			if not js.return_called then
				Result := 100
			end
		end

	cmd_decode (a_tlist: CE_POINTER [PD_TABLELIST]; a_cmd: CE_POINTER [INTEGER_8]; a_sp: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_t: CE_POINTER [PD_TABLELIST]
			l_action: INTEGER_32
			js: JUMP_STATE
		do
			create l_t.make

			l_action := 100
			l_t.ce_gets (a_tlist)
			from
			until
				not (not js.loop_left and then ((l_t.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
			loop
				js.reset
				l_action := cmd_search (a_cmd, l_t.item.t_start, l_t.item.t_end, a_sp)
				if l_action /= 100 then
					js.break
				end
				if not js.loop_jumped then
					l_t.ce_gets (l_t.item.t_next)
				end
			end
			js.reset
			if l_action = 102 then
				l_action := 100
			end
			Result := l_action
		end

	fcmd_decode (a_cmd: CE_POINTER [INTEGER_8]; a_sp: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (cmd_decode (list_fcmd_tables, a_cmd, a_sp))
		end

	ecmd_decode (a_cmd: CE_POINTER [INTEGER_8]; a_sp: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (cmd_decode (list_ecmd_tables, a_cmd, a_sp))
		end

	lgetenv (a_var: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_a: INTEGER_32
			l_s: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_s.make

			l_a := cmd_decode (list_var_tables, a_var, l_s.address)
			if l_a = 1 then
				Result := l_s
				js.return
			end
			if not js.return_called then
				l_s.ce_gets (getenv (a_var))
				if (l_s.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					if (l_s[0]).to_integer_32 /= 0 then
						Result := l_s
						js.return
					end
				end
			end
			if not js.return_called then
				l_a := cmd_decode (list_sysvar_tables, a_var, l_s.address)
				if l_a = 1 then
					Result := l_s
					js.return
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
			end
		end

	gint (a_sp: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_n: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
		do
			create l_tmp.make
			create l_tmp___0.make

			l_tmp.ce_gets (a_sp.item)
			a_sp.item := (a_sp.item) + 1
			l_n := (l_tmp[0]).to_integer_32
			l_tmp___0.ce_gets (a_sp.item)
			a_sp.item := (a_sp.item) + 1
			l_n := l_n + ((l_tmp___0[0]).to_integer_32 * 64)
			Result := l_n
		end

	old_lesskey (a_buf___1: CE_POINTER [INTEGER_8]; a_len: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (a_buf___1[(a_len - 1)]).to_integer_32 /= 0 then
				if (a_buf___1[(a_len - 2)]).to_integer_32 /= 0 then
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				add_fcmd_table (a_buf___1, a_len)
				Result := 0
			end
		end

	new_lesskey (a_buf___1: CE_POINTER [INTEGER_8]; a_len: INTEGER_32; a_sysvar: INTEGER_32): INTEGER_32
		local
			l_p: CE_POINTER [INTEGER_8]
			l_c: INTEGER_32
			l_n: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [CE_POINTER [PD_TABLELIST]]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p.make
			create l_tmp.make
			create l_tmp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_buf___1[(a_len - 3)]).to_integer_32 /= 69 then
						Result := (-1)
						js.return
					elseif (a_buf___1[(a_len - 2)]).to_integer_32 /= 110 then
						Result := (-1)
						js.return
					elseif (a_buf___1[(a_len - 1)]).to_integer_32 /= 100 then
						Result := (-1)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						l_p.ce_gets (a_buf___1 + 4)
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						l_tmp.ce_gets (l_p)
						l_p.ce_gets (l_p + 1)
						l_c := (l_tmp[0]).to_integer_32
						inspect l_c -- switch 1 head
						when 99 then l_pos := -1 + 4
						when 101 then l_pos := -1 + 5
						when 118 then l_pos := -1 + 6
						when 120 then l_pos := -1 + 7
						else l_pos := -1 + 8
						end
				when 4 then -- switch 1, case 99
						l_n := gint (l_p.address)
						add_fcmd_table (l_p, l_n)
						l_p.ce_gets (l_p + l_n)
						l_pos := -1 + 9 -- switch 1; break
				when 5 then -- switch 1, case 101
						l_n := gint (l_p.address)
						add_ecmd_table (l_p, l_n)
						l_p.ce_gets (l_p + l_n)
						l_pos := -1 + 9 -- switch 1; break
				when 6 then -- switch 1, case 118
						l_n := gint (l_p.address)
						if a_sysvar.to_boolean then
							l_tmp___0.ce_gets (list_sysvar_tables.address)
						else
							l_tmp___0.ce_gets (list_var_tables.address)
						end
						add_var_table (l_tmp___0, l_p, l_n)
						l_p.ce_gets (l_p + l_n)
						l_pos := -1 + 9 -- switch 1; break
				when 7 then -- switch 1, case 120
						Result := 0
						js.return
				when 8 then -- switch 1, default:
						if not js.return_called then
							Result := (-1)
							js.return
						end
				when 9 then -- switch 1, done:
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	lesskey (a_filename: CE_POINTER [INTEGER_8]; a_sysvar: INTEGER_32): INTEGER_32
		local
			l_filename: CE_POINTER [INTEGER_8]
			l_buf___1: CE_POINTER [INTEGER_8]
			l_len: INTEGER_32
			l_n: INTEGER_32
			l_f: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_filename.make
			create l_buf___1.make

			l_filename.ce_gets (a_filename)
			if main_inst.secure.to_boolean then
				Result := 1
				js.return
			end
			if not js.return_called then
				l_filename.ce_gets (filename_inst.shell_unquote (l_filename))
				l_f := open ([l_filename, 0])
				free (create {CE_POINTER [ANY]}.make_cast (l_filename))
				if l_f < 0 then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				l_len := filename_inst.filesize (l_f)
				if l_len = -1 then
					close (l_f).do_nothing
					Result := (-1)
					js.return
				elseif l_len < 3 then
					close (l_f).do_nothing
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				l_buf___1.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((calloc (l_len.to_natural_32, Integer_8_bytes.to_natural_32))))
				if (l_buf___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					close (l_f).do_nothing
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				if (lseek (l_f, (0).to_integer_32, 0)) = -1 then
					free (create {CE_POINTER [ANY]}.make_cast (l_buf___1))
					close (l_f).do_nothing
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				l_n := (read (l_f, create {CE_POINTER [ANY]}.make_cast (l_buf___1), l_len.to_natural_32)).to_integer_32
				close (l_f).do_nothing
				if l_n /= l_len then
					free (create {CE_POINTER [ANY]}.make_cast (l_buf___1))
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				if (l_buf___1[0]).to_integer_32 /= 0 then
					l_tmp___2 := old_lesskey (l_buf___1, l_len.to_integer_32)
					Result := l_tmp___2
					js.return
				elseif (l_buf___1[1]).to_integer_32 /= 77 then
					l_tmp___2 := old_lesskey (l_buf___1, l_len.to_integer_32)
					Result := l_tmp___2
					js.return
				elseif (l_buf___1[2]).to_integer_32 /= 43 then
					l_tmp___2 := old_lesskey (l_buf___1, l_len.to_integer_32)
					Result := l_tmp___2
					js.return
				elseif (l_buf___1[3]).to_integer_32 /= 71 then
					l_tmp___2 := old_lesskey (l_buf___1, l_len.to_integer_32)
					Result := l_tmp___2
					js.return
				end
			end
			if not js.return_called then
				Result := (new_lesskey (l_buf___1, l_len.to_integer_32, a_sysvar))
			end
		end

	add_hometable (a_envname: CE_POINTER [INTEGER_8]; a_def_filename: CE_POINTER [INTEGER_8]; a_sysvar: INTEGER_32)
		local
			l_filename: CE_POINTER [INTEGER_8]
			l_parg: PD_PARG
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_filename.make
			create l_parg.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_envname.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_filename.ce_gets (lgetenv (a_envname))
						if (l_filename.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_filename.ce_gets (main_inst.save (l_filename))
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if a_sysvar.to_boolean then
							l_filename.ce_gets (main_inst.save (a_def_filename))
						else
							l_filename.ce_gets (filename_inst.homefile (a_def_filename))
						end
				when 4 then
					if (l_filename.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						js.return
					end
					if not js.return_called then
						if (lesskey (l_filename, a_sysvar)) < 0 then
							l_parg.p_string := l_filename
							output_inst.error (ce_string ("Cannot use lesskey file %"%%s%""), l_parg.address)
						end
						free (create {CE_POINTER [ANY]}.make_cast (l_filename))
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	editchar (a_c: INTEGER_32; a_flags: INTEGER_32): INTEGER_32
		local
			l_c: INTEGER_32
			l_action: INTEGER_32
			l_nch: INTEGER_32
			l_s: CE_POINTER [INTEGER_8]
			l_usercmd: CE_ARRAY [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_usercmd.make (<<17>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := a_c
					if l_c = screen_inst.erase_char then
						Result := 1
						js.return
					end
					if not js.return_called and then (l_c = screen_inst.kill_char) then
						Result := 2
						js.return
					end
					if js.return_called then
						l_pos := -1 + 18 -- skip if block
					end
				when 1 then -- if:
						l_nch := 0
						from
						until
							js.loop_left
						loop
							js.reset
							if l_nch > 0 then
								l_c := command_inst.getcc
							end
							l_usercmd[l_nch] := l_c.to_integer_8
							l_usercmd[l_nch + 1] := (('%/0/').code).to_integer_8
							l_nch := l_nch + 1
							l_action := ecmd_decode (l_usercmd, l_s.address)
							if l_action /= 22 then
								js.break
							end
						end
						js.reset
						if not (((a_flags).bit_and (8)).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						inspect l_action -- switch 1 head
						when 3 then l_pos := -1 + 3
						when 4 then l_pos := -1 + 3
						else l_pos := -1 + 4
						end
				when 3 then -- switch 1, case 3 | switch 1, case 4
						l_action := 100
						l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done: | if done
						if not (((a_flags).bit_and (2)).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						inspect l_action -- switch 2 head
						when 13 then l_pos := -1 + 6
						when 14 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 6 then -- switch 2, case 13 | switch 2, case 14
						l_action := 100
						l_pos := -1 + 7 -- switch 2; break
				when 7 then -- switch 2, done: | if done
						if not (((a_flags).bit_and (4)).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						inspect l_action -- switch 3 head
						when 17 then l_pos := -1 + 9
						when 18 then l_pos := -1 + 9
						when 15 then l_pos := -1 + 9
						else l_pos := -1 + 10
						end
				when 9 then -- switch 3, case 17 | switch 3, case 18 | switch 3, case 15
						l_action := 100
						l_pos := -1 + 10 -- switch 3; break
				when 10 then -- switch 3, done: | if done
						if not (((a_flags).bit_and (1)).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 13 then -- else:
						if l_action /= 100 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if: | _L:
						from
						until
							not (l_nch > 1)
						loop
							l_nch := l_nch - 1
							command_inst.ungetcc ((l_usercmd[l_nch]).to_integer_32)
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						if (l_s.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							command_inst.ungetsc (l_s)
						end
				when 17 then -- if done
						Result := l_action
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
