class
	P_TTYIN

inherit
	LESS_DATA
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {ANY} -- routines

	open_getchr
		do
			screen_inst.tty := open ([ce_string ("/dev/tty"), 0])
			if screen_inst.tty < 0 then
				screen_inst.tty := 2
			end
		end

	close_getchr
		do
		end

	getchr: INTEGER_32
		local
			l_c: INTEGER_8
			l_result: INTEGER_32
			js: JUMP_STATE
		do
			from
			until
				js.loop_left
			loop
				js.reset
				l_result := os_inst.iread (screen_inst.tty, create {CE_POINTER [INTEGER_8]}.make_shared ($l_c), Integer_8_bytes.to_natural_32)
				if l_result = -2 then
					Result := (-2)
					js.return
				end
				if not js.return_called then
					if l_result < 0 then
						main_inst.quit (1)
					end
					if l_c.to_integer_32 = 0 then
						l_c := (('%/224/').code).to_integer_8
					end
					if l_result = 1 then
						js.break
					end
				end
			end
			js.reset
			if not js.return_called then
				Result := ((l_c.to_integer_32).bit_and (255))
			end
		end

end
