class
	SD_RE_PATTERN_BUFFER

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	buffer: CE_POINTER [NATURAL_8] assign set_buffer
		do
			create Result.make_shared (c_buffer (c_pointer))
		end

	allocated: NATURAL_32 assign set_allocated
		do
			Result := c_allocated (c_pointer)
		end

	used: NATURAL_32 assign set_used
		do
			Result := c_used (c_pointer)
		end

	syntax: NATURAL_32 assign set_syntax
		do
			Result := c_syntax (c_pointer)
		end

	fastmap: CE_POINTER [INTEGER_8] assign set_fastmap
		do
			create Result.make_shared (c_fastmap (c_pointer))
		end

	translate: CE_POINTER [NATURAL_8] assign set_translate
		do
			create Result.make_shared (c_translate (c_pointer))
		end

	re_nsub: NATURAL_32 assign set_re_nsub
		do
			Result := c_re_nsub (c_pointer)
		end

	can_be_null: NATURAL_32 assign set_can_be_null
		do
			Result := c_can_be_null (c_pointer)
		end

	regs_allocated: NATURAL_32 assign set_regs_allocated
		do
			Result := c_regs_allocated (c_pointer)
		end

	fastmap_accurate: NATURAL_32 assign set_fastmap_accurate
		do
			Result := c_fastmap_accurate (c_pointer)
		end

	no_sub: NATURAL_32 assign set_no_sub
		do
			Result := c_no_sub (c_pointer)
		end

	not_bol: NATURAL_32 assign set_not_bol
		do
			Result := c_not_bol (c_pointer)
		end

	not_eol: NATURAL_32 assign set_not_eol
		do
			Result := c_not_eol (c_pointer)
		end

	newline_anchor: NATURAL_32 assign set_newline_anchor
		do
			Result := c_newline_anchor (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_buffer (a_buffer: CE_POINTER [NATURAL_8])
		do
			c_set_buffer (c_pointer, a_buffer.c_pointer)
		end

	set_allocated (a_allocated: NATURAL_32)
		do
			c_set_allocated (c_pointer, a_allocated)
		end

	set_used (a_used: NATURAL_32)
		do
			c_set_used (c_pointer, a_used)
		end

	set_syntax (a_syntax: NATURAL_32)
		do
			c_set_syntax (c_pointer, a_syntax)
		end

	set_fastmap (a_fastmap: CE_POINTER [INTEGER_8])
		do
			c_set_fastmap (c_pointer, a_fastmap.c_pointer)
		end

	set_translate (a_translate: CE_POINTER [NATURAL_8])
		do
			c_set_translate (c_pointer, a_translate.c_pointer)
		end

	set_re_nsub (a_re_nsub: NATURAL_32)
		do
			c_set_re_nsub (c_pointer, a_re_nsub)
		end

	set_can_be_null (a_can_be_null: NATURAL_32)
		do
			c_set_can_be_null (c_pointer, a_can_be_null)
		end

	set_regs_allocated (a_regs_allocated: NATURAL_32)
		do
			c_set_regs_allocated (c_pointer, a_regs_allocated)
		end

	set_fastmap_accurate (a_fastmap_accurate: NATURAL_32)
		do
			c_set_fastmap_accurate (c_pointer, a_fastmap_accurate)
		end

	set_no_sub (a_no_sub: NATURAL_32)
		do
			c_set_no_sub (c_pointer, a_no_sub)
		end

	set_not_bol (a_not_bol: NATURAL_32)
		do
			c_set_not_bol (c_pointer, a_not_bol)
		end

	set_not_eol (a_not_eol: NATURAL_32)
		do
			c_set_not_eol (c_pointer, a_not_eol)
		end

	set_newline_anchor (a_newline_anchor: NATURAL_32)
		do
			c_set_newline_anchor (c_pointer, a_newline_anchor)
		end

feature {NONE} -- C getters

	c_buffer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct re_pattern_buffer *)$tmp)->buffer;"
		end

	c_allocated (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct re_pattern_buffer *)$tmp)->allocated;"
		end

	c_used (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct re_pattern_buffer *)$tmp)->used;"
		end

	c_syntax (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct re_pattern_buffer *)$tmp)->syntax;"
		end

	c_fastmap (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct re_pattern_buffer *)$tmp)->fastmap;"
		end

	c_translate (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct re_pattern_buffer *)$tmp)->translate;"
		end

	c_re_nsub (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct re_pattern_buffer *)$tmp)->re_nsub;"
		end

	c_can_be_null (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct re_pattern_buffer *)$tmp)->can_be_null;"
		end

	c_regs_allocated (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct re_pattern_buffer *)$tmp)->regs_allocated;"
		end

	c_fastmap_accurate (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct re_pattern_buffer *)$tmp)->fastmap_accurate;"
		end

	c_no_sub (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct re_pattern_buffer *)$tmp)->no_sub;"
		end

	c_not_bol (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct re_pattern_buffer *)$tmp)->not_bol;"
		end

	c_not_eol (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct re_pattern_buffer *)$tmp)->not_eol;"
		end

	c_newline_anchor (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct re_pattern_buffer *)$tmp)->newline_anchor;"
		end

feature {NONE} -- C setters

	c_set_buffer (tmp: POINTER; a_buffer: POINTER)
		external
			"C inline"
		alias
			"((struct re_pattern_buffer *)$tmp)->buffer = (unsigned char *)$a_buffer;"
		end

	c_set_allocated (tmp: POINTER; a_allocated: NATURAL_32)
		external
			"C inline"
		alias
			"((struct re_pattern_buffer *)$tmp)->allocated = $a_allocated;"
		end

	c_set_used (tmp: POINTER; a_used: NATURAL_32)
		external
			"C inline"
		alias
			"((struct re_pattern_buffer *)$tmp)->used = $a_used;"
		end

	c_set_syntax (tmp: POINTER; a_syntax: NATURAL_32)
		external
			"C inline"
		alias
			"((struct re_pattern_buffer *)$tmp)->syntax = $a_syntax;"
		end

	c_set_fastmap (tmp: POINTER; a_fastmap: POINTER)
		external
			"C inline"
		alias
			"((struct re_pattern_buffer *)$tmp)->fastmap = (char *)$a_fastmap;"
		end

	c_set_translate (tmp: POINTER; a_translate: POINTER)
		external
			"C inline"
		alias
			"((struct re_pattern_buffer *)$tmp)->translate = (unsigned char *)$a_translate;"
		end

	c_set_re_nsub (tmp: POINTER; a_re_nsub: NATURAL_32)
		external
			"C inline"
		alias
			"((struct re_pattern_buffer *)$tmp)->re_nsub = $a_re_nsub;"
		end

	c_set_can_be_null (tmp: POINTER; a_can_be_null: NATURAL_32)
		external
			"C inline"
		alias
			"((struct re_pattern_buffer *)$tmp)->can_be_null = $a_can_be_null;"
		end

	c_set_regs_allocated (tmp: POINTER; a_regs_allocated: NATURAL_32)
		external
			"C inline"
		alias
			"((struct re_pattern_buffer *)$tmp)->regs_allocated = $a_regs_allocated;"
		end

	c_set_fastmap_accurate (tmp: POINTER; a_fastmap_accurate: NATURAL_32)
		external
			"C inline"
		alias
			"((struct re_pattern_buffer *)$tmp)->fastmap_accurate = $a_fastmap_accurate;"
		end

	c_set_no_sub (tmp: POINTER; a_no_sub: NATURAL_32)
		external
			"C inline"
		alias
			"((struct re_pattern_buffer *)$tmp)->no_sub = $a_no_sub;"
		end

	c_set_not_bol (tmp: POINTER; a_not_bol: NATURAL_32)
		external
			"C inline"
		alias
			"((struct re_pattern_buffer *)$tmp)->not_bol = $a_not_bol;"
		end

	c_set_not_eol (tmp: POINTER; a_not_eol: NATURAL_32)
		external
			"C inline"
		alias
			"((struct re_pattern_buffer *)$tmp)->not_eol = $a_not_eol;"
		end

	c_set_newline_anchor (tmp: POINTER; a_newline_anchor: NATURAL_32)
		external
			"C inline"
		alias
			"((struct re_pattern_buffer *)$tmp)->newline_anchor = $a_newline_anchor;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return sizeof(struct re_pattern_buffer);"
		end

end
