deferred class
	S_FCNTL

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	open (a_args: TUPLE [a_file: CE_POINTER [INTEGER_8]; a_oflag: INTEGER_32]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_open)).integer_32_item (a_args)
		end

	c_open: POINTER
		external
			"C inline use <less.h>"
		alias
			"return &open;"
		end

	creat (a_file: CE_POINTER [INTEGER_8]; a_mode: NATURAL_32): INTEGER_32
		do
			Result := c_creat (a_file.c_pointer, a_mode)
		end

	c_creat (a_file: POINTER; a_mode: NATURAL_32): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return creat($a_file, $a_mode);"
		end

end
