deferred class
	S_TERMIOS

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	cfgetospeed (a_termios_p: CE_POINTER [SD_TERMIOS]): NATURAL_32
		do
			Result := c_cfgetospeed (a_termios_p.c_pointer)
		end

	c_cfgetospeed (a_termios_p: POINTER): NATURAL_32
		external
			"C inline use <less.h>"
		alias
			"return cfgetospeed($a_termios_p);"
		end

	tcgetattr (a_fd: INTEGER_32; a_termios_p: CE_POINTER [SD_TERMIOS]): INTEGER_32
		do
			Result := c_tcgetattr (a_fd, a_termios_p.c_pointer)
		end

	c_tcgetattr (a_fd: INTEGER_32; a_termios_p: POINTER): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return tcgetattr($a_fd, $a_termios_p);"
		end

	tcsetattr (a_fd: INTEGER_32; a_optional_actions: INTEGER_32; a_termios_p: CE_POINTER [SD_TERMIOS]): INTEGER_32
		do
			Result := c_tcsetattr (a_fd, a_optional_actions, a_termios_p.c_pointer)
		end

	c_tcsetattr (a_fd: INTEGER_32; a_optional_actions: INTEGER_32; a_termios_p: POINTER): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return tcsetattr($a_fd, $a_optional_actions, $a_termios_p);"
		end

end
