class
	PD_ACC_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	host: CE_POINTER [INTEGER_8] assign set_host
		do
			create Result.make_shared (c_host (c_pointer))
		end

	acc: CE_POINTER [INTEGER_8] assign set_acc
		do
			create Result.make_shared (c_acc (c_pointer))
		end

	passwd: CE_POINTER [INTEGER_8] assign set_passwd
		do
			create Result.make_shared (c_passwd (c_pointer))
		end

	next: CE_POINTER [PD_ACC_T] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_host (a_host: CE_POINTER [INTEGER_8])
		do
			c_set_host (c_pointer, a_host.c_pointer)
		end

	set_acc (a_acc: CE_POINTER [INTEGER_8])
		do
			c_set_acc (c_pointer, a_acc.c_pointer)
		end

	set_passwd (a_passwd: CE_POINTER [INTEGER_8])
		do
			c_set_passwd (c_pointer, a_passwd.c_pointer)
		end

	set_next (a_next: CE_POINTER [PD_ACC_T])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

feature {NONE} -- C getters

	c_host (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _acc_t *)$tmp)->host;"
		end

	c_acc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _acc_t *)$tmp)->acc;"
		end

	c_passwd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _acc_t *)$tmp)->passwd;"
		end

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _acc_t *)((struct _acc_t *)$tmp)->next;"
		end

feature {NONE} -- C setters

	c_set_host (tmp: POINTER; a_host: POINTER)
		external
			"C inline"
		alias
			"((struct _acc_t *)$tmp)->host = (char *)$a_host;"
		end

	c_set_acc (tmp: POINTER; a_acc: POINTER)
		external
			"C inline"
		alias
			"((struct _acc_t *)$tmp)->acc = (char *)$a_acc;"
		end

	c_set_passwd (tmp: POINTER; a_passwd: POINTER)
		external
			"C inline"
		alias
			"((struct _acc_t *)$tmp)->passwd = (char *)$a_passwd;"
		end

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct _acc_t *)$tmp)->next = (struct _acc_t *)$a_next;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct _acc_t);"
		end

end
