class
	PD_CLOCKS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	id: INTEGER_32 assign set_id
		do
			Result := c_id (c_pointer)
		end

	sysconf_name: INTEGER_32 assign set_sysconf_name
		do
			Result := c_sysconf_name (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_id (a_id: INTEGER_32)
		do
			c_set_id (c_pointer, a_id)
		end

	set_sysconf_name (a_sysconf_name: INTEGER_32)
		do
			c_set_sysconf_name (c_pointer, a_sysconf_name)
		end

feature {NONE} -- C getters

	c_id (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_clocks_37 *)$tmp)->id;"
		end

	c_sysconf_name (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_clocks_37 *)$tmp)->sysconf_name;"
		end

feature {NONE} -- C setters

	c_set_id (tmp: POINTER; a_id: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_clocks_37 *)$tmp)->id = $a_id;"
		end

	c_set_sysconf_name (tmp: POINTER; a_sysconf_name: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_clocks_37 *)$tmp)->sysconf_name = $a_sysconf_name;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct __anonstruct_clocks_37);"
		end

end
