class
	PD_HASH_TABLE_ITERATOR

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	key: CE_POINTER [ANY] assign set_key
		do
			create Result.make_shared (c_key (c_pointer))
		end

	value: CE_POINTER [ANY] assign set_value
		do
			create Result.make_shared (c_value (c_pointer))
		end

	pos: CE_POINTER [ANY] assign set_pos
		do
			create Result.make_shared (c_pos (c_pointer))
		end

	end2: CE_POINTER [ANY] assign set_end2
		do
			create Result.make_shared (c_end2 (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_key (a_key: CE_POINTER [ANY])
		do
			c_set_key (c_pointer, a_key.c_pointer)
		end

	set_value (a_value: CE_POINTER [ANY])
		do
			c_set_value (c_pointer, a_value.c_pointer)
		end

	set_pos (a_pos: CE_POINTER [ANY])
		do
			c_set_pos (c_pointer, a_pos.c_pointer)
		end

	set_end2 (a_end2: CE_POINTER [ANY])
		do
			c_set_end2 (c_pointer, a_end2.c_pointer)
		end

feature {NONE} -- C getters

	c_key (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_hash_table_iterator_38 *)$tmp)->key;"
		end

	c_value (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_hash_table_iterator_38 *)$tmp)->value;"
		end

	c_pos (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_hash_table_iterator_38 *)$tmp)->pos;"
		end

	c_end2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_hash_table_iterator_38 *)$tmp)->end;"
		end

feature {NONE} -- C setters

	c_set_key (tmp: POINTER; a_key: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_hash_table_iterator_38 *)$tmp)->key = (void *)$a_key;"
		end

	c_set_value (tmp: POINTER; a_value: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_hash_table_iterator_38 *)$tmp)->value = (void *)$a_value;"
		end

	c_set_pos (tmp: POINTER; a_pos: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_hash_table_iterator_38 *)$tmp)->pos = (void *)$a_pos;"
		end

	c_set_end2 (tmp: POINTER; a_end2: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_hash_table_iterator_38 *)$tmp)->end = (void *)$a_end2;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct __anonstruct_hash_table_iterator_38);"
		end

end
