class
	PD_IP_ADDRESS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	family: INTEGER_32 assign set_family
		do
			Result := c_family (c_pointer)
		end

	data: PD_DATA assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	data_offset: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return (int)offsetof(struct __anonstruct_ip_address_48, data);"
		end

	ipv6_scope: INTEGER_32 assign set_ipv6_scope
		do
			Result := c_ipv6_scope (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_family (a_family: INTEGER_32)
		do
			c_set_family (c_pointer, a_family)
		end

	set_data (a_data: PD_DATA)
		do
			data.ce_gets (a_data)
		end

	set_ipv6_scope (a_ipv6_scope: INTEGER_32)
		do
			c_set_ipv6_scope (c_pointer, a_ipv6_scope)
		end

feature {NONE} -- C getters

	c_family (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_ip_address_48 *)$tmp)->family;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_data_49 *)&((struct __anonstruct_ip_address_48 *)$tmp)->data;"
		end

	c_ipv6_scope (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_ip_address_48 *)$tmp)->ipv6_scope;"
		end

feature {NONE} -- C setters

	c_set_family (tmp: POINTER; a_family: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_ip_address_48 *)$tmp)->family = $a_family;"
		end

	c_set_ipv6_scope (tmp: POINTER; a_ipv6_scope: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_ip_address_48 *)$tmp)->ipv6_scope = $a_ipv6_scope;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct __anonstruct_ip_address_48);"
		end

end
