class
	PD_LIMIT_DATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	chunk_bytes: INTEGER_64 assign set_chunk_bytes
		do
			Result := c_chunk_bytes (c_pointer)
		end

	chunk_start: REAL_64 assign set_chunk_start
		do
			Result := c_chunk_start (c_pointer)
		end

	sleep_adjust: REAL_64 assign set_sleep_adjust
		do
			Result := c_sleep_adjust (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_chunk_bytes (a_chunk_bytes: INTEGER_64)
		do
			c_set_chunk_bytes (c_pointer, a_chunk_bytes)
		end

	set_chunk_start (a_chunk_start: REAL_64)
		do
			c_set_chunk_start (c_pointer, a_chunk_start)
		end

	set_sleep_adjust (a_sleep_adjust: REAL_64)
		do
			c_set_sleep_adjust (c_pointer, a_sleep_adjust)
		end

feature {NONE} -- C getters

	c_chunk_bytes (tmp: POINTER): INTEGER_64
		external
			"C inline"
		alias
			"return (long long)((struct __anonstruct_limit_data_59 *)$tmp)->chunk_bytes;"
		end

	c_chunk_start (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_limit_data_59 *)$tmp)->chunk_start;"
		end

	c_sleep_adjust (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_limit_data_59 *)$tmp)->sleep_adjust;"
		end

feature {NONE} -- C setters

	c_set_chunk_bytes (tmp: POINTER; a_chunk_bytes: INTEGER_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_limit_data_59 *)$tmp)->chunk_bytes = $a_chunk_bytes;"
		end

	c_set_chunk_start (tmp: POINTER; a_chunk_start: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_limit_data_59 *)$tmp)->chunk_start = $a_chunk_start;"
		end

	c_set_sleep_adjust (tmp: POINTER; a_sleep_adjust: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_limit_data_59 *)$tmp)->sleep_adjust = $a_sleep_adjust;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct __anonstruct_limit_data_59);"
		end

end
