class
	PD_TAG_URL_ATTRIBUTES

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	tagid: INTEGER_32 assign set_tagid
		do
			Result := c_tagid (c_pointer)
		end

	attr_name: CE_POINTER [INTEGER_8] assign set_attr_name
		do
			create Result.make_shared (c_attr_name (c_pointer))
		end

	flags: INTEGER_32 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_tagid (a_tagid: INTEGER_32)
		do
			c_set_tagid (c_pointer, a_tagid)
		end

	set_attr_name (a_attr_name: CE_POINTER [INTEGER_8])
		do
			c_set_attr_name (c_pointer, a_attr_name.c_pointer)
		end

	set_flags (a_flags: INTEGER_32)
		do
			c_set_flags (c_pointer, a_flags)
		end

feature {NONE} -- C getters

	c_tagid (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_tag_url_attributes_37 *)$tmp)->tagid;"
		end

	c_attr_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_tag_url_attributes_37 *)$tmp)->attr_name;"
		end

	c_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_tag_url_attributes_37 *)$tmp)->flags;"
		end

feature {NONE} -- C setters

	c_set_tagid (tmp: POINTER; a_tagid: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_tag_url_attributes_37 *)$tmp)->tagid = $a_tagid;"
		end

	c_set_attr_name (tmp: POINTER; a_attr_name: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_tag_url_attributes_37 *)$tmp)->attr_name = (char const *)$a_attr_name;"
		end

	c_set_flags (tmp: POINTER; a_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_tag_url_attributes_37 *)$tmp)->flags = $a_flags;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct __anonstruct_tag_url_attributes_37);"
		end

end
