class
	PD_TAGSTACK_ITEM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	tagname_begin: CE_POINTER [INTEGER_8] assign set_tagname_begin
		do
			create Result.make_shared (c_tagname_begin (c_pointer))
		end

	tagname_end: CE_POINTER [INTEGER_8] assign set_tagname_end
		do
			create Result.make_shared (c_tagname_end (c_pointer))
		end

	contents_begin: CE_POINTER [INTEGER_8] assign set_contents_begin
		do
			create Result.make_shared (c_contents_begin (c_pointer))
		end

	prev: CE_POINTER [PD_TAGSTACK_ITEM] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	next: CE_POINTER [PD_TAGSTACK_ITEM] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_tagname_begin (a_tagname_begin: CE_POINTER [INTEGER_8])
		do
			c_set_tagname_begin (c_pointer, a_tagname_begin.c_pointer)
		end

	set_tagname_end (a_tagname_end: CE_POINTER [INTEGER_8])
		do
			c_set_tagname_end (c_pointer, a_tagname_end.c_pointer)
		end

	set_contents_begin (a_contents_begin: CE_POINTER [INTEGER_8])
		do
			c_set_contents_begin (c_pointer, a_contents_begin.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_TAGSTACK_ITEM])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_next (a_next: CE_POINTER [PD_TAGSTACK_ITEM])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

feature {NONE} -- C getters

	c_tagname_begin (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct tagstack_item *)$tmp)->tagname_begin;"
		end

	c_tagname_end (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct tagstack_item *)$tmp)->tagname_end;"
		end

	c_contents_begin (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct tagstack_item *)$tmp)->contents_begin;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct tagstack_item *)((struct tagstack_item *)$tmp)->prev;"
		end

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct tagstack_item *)((struct tagstack_item *)$tmp)->next;"
		end

feature {NONE} -- C setters

	c_set_tagname_begin (tmp: POINTER; a_tagname_begin: POINTER)
		external
			"C inline"
		alias
			"((struct tagstack_item *)$tmp)->tagname_begin = (char const *)$a_tagname_begin;"
		end

	c_set_tagname_end (tmp: POINTER; a_tagname_end: POINTER)
		external
			"C inline"
		alias
			"((struct tagstack_item *)$tmp)->tagname_end = (char const *)$a_tagname_end;"
		end

	c_set_contents_begin (tmp: POINTER; a_contents_begin: POINTER)
		external
			"C inline"
		alias
			"((struct tagstack_item *)$tmp)->contents_begin = (char const *)$a_contents_begin;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct tagstack_item *)$tmp)->prev = (struct tagstack_item *)$a_prev;"
		end

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct tagstack_item *)$tmp)->next = (struct tagstack_item *)$a_next;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct tagstack_item);"
		end

end
