frozen class
	WGET_INITIALIZER_SLICE80

inherit
	WGET_DATA
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {WGET_INITIALIZER}

	initialize
		do
			main_inst.option_data[10].long_name := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			main_inst.option_data[10].short_name := (0).to_integer_8
			main_inst.option_data[10].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[10].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("cacertificate"))
			main_inst.option_data[10].argtype := -1
			main_inst.option_data[11].long_name := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			main_inst.option_data[11].short_name := (0).to_integer_8
			main_inst.option_data[11].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[11].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("cadirectory"))
			main_inst.option_data[11].argtype := -1
			main_inst.option_data[12].long_name := ce_string ("cache")
			main_inst.option_data[12].short_name := (0).to_integer_8
			main_inst.option_data[12].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[12].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("cache"))
			main_inst.option_data[12].argtype := -1
			main_inst.option_data[13].long_name := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			main_inst.option_data[13].short_name := (0).to_integer_8
			main_inst.option_data[13].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[13].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("certificate"))
			main_inst.option_data[13].argtype := -1
			main_inst.option_data[14].long_name := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			main_inst.option_data[14].short_name := (0).to_integer_8
			main_inst.option_data[14].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[14].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("certificatetype"))
			main_inst.option_data[14].argtype := -1
			main_inst.option_data[15].long_name := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			main_inst.option_data[15].short_name := (0).to_integer_8
			main_inst.option_data[15].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[15].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("checkcertificate"))
			main_inst.option_data[15].argtype := -1
			main_inst.option_data[16].long_name := ce_string ("clobber")
			main_inst.option_data[16].short_name := (0).to_integer_8
			main_inst.option_data[16].type := {PC_TYPE}.OPT__CLOBBER
			main_inst.option_data[16].data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			main_inst.option_data[16].argtype := 2
			main_inst.option_data[17].long_name := ce_string ("connect-timeout")
			main_inst.option_data[17].short_name := (0).to_integer_8
			main_inst.option_data[17].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[17].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("connecttimeout"))
			main_inst.option_data[17].argtype := -1
			main_inst.option_data[18].long_name := ce_string ("continue")
			main_inst.option_data[18].short_name := (('c').code).to_integer_8
			main_inst.option_data[18].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[18].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("continue"))
			main_inst.option_data[18].argtype := -1
			main_inst.option_data[19].long_name := ce_string ("convert-links")
			main_inst.option_data[19].short_name := (('k').code).to_integer_8
			main_inst.option_data[19].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[19].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("convertlinks"))
			main_inst.option_data[19].argtype := -1
			main_inst.option_data[20].long_name := ce_string ("content-disposition")
			main_inst.option_data[20].short_name := (0).to_integer_8
			main_inst.option_data[20].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[20].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("contentdisposition"))
			main_inst.option_data[20].argtype := -1
			main_inst.option_data[21].long_name := ce_string ("cookies")
			main_inst.option_data[21].short_name := (0).to_integer_8
			main_inst.option_data[21].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[21].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("cookies"))
			main_inst.option_data[21].argtype := -1
			main_inst.option_data[22].long_name := ce_string ("cut-dirs")
			main_inst.option_data[22].short_name := (0).to_integer_8
			main_inst.option_data[22].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[22].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("cutdirs"))
			main_inst.option_data[22].argtype := -1
			main_inst.option_data[23].long_name := ce_string ("debug")
			main_inst.option_data[23].short_name := (('d').code).to_integer_8
			main_inst.option_data[23].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[23].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("debug"))
			main_inst.option_data[23].argtype := -1
			main_inst.option_data[24].long_name := ce_string ("default-page")
			main_inst.option_data[24].short_name := (0).to_integer_8
			main_inst.option_data[24].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[24].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("defaultpage"))
			main_inst.option_data[24].argtype := -1
			main_inst.option_data[25].long_name := ce_string ("delete-after")
			main_inst.option_data[25].short_name := (0).to_integer_8
			main_inst.option_data[25].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[25].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("deleteafter"))
			main_inst.option_data[25].argtype := -1
			main_inst.option_data[26].long_name := ce_string ("directories")
			main_inst.option_data[26].short_name := (0).to_integer_8
			main_inst.option_data[26].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[26].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("dirstruct"))
			main_inst.option_data[26].argtype := -1
			main_inst.option_data[27].long_name := ce_string ("directory-prefix")
			main_inst.option_data[27].short_name := (('P').code).to_integer_8
			main_inst.option_data[27].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[27].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("dirprefix"))
			main_inst.option_data[27].argtype := -1
			main_inst.option_data[28].long_name := ce_string ("dns-cache")
			main_inst.option_data[28].short_name := (0).to_integer_8
			main_inst.option_data[28].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[28].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("dnscache"))
			main_inst.option_data[28].argtype := -1
			main_inst.option_data[29].long_name := ce_string ("dns-timeout")
			main_inst.option_data[29].short_name := (0).to_integer_8
			main_inst.option_data[29].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[29].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("dnstimeout"))
			main_inst.option_data[29].argtype := -1
			main_inst.option_data[30].long_name := ce_string ("domains")
			main_inst.option_data[30].short_name := (('D').code).to_integer_8
			main_inst.option_data[30].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[30].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("domains"))
			main_inst.option_data[30].argtype := -1
			main_inst.option_data[31].long_name := ce_string ("dont-remove-listing")
			main_inst.option_data[31].short_name := (0).to_integer_8
			main_inst.option_data[31].type := {PC_TYPE}.OPT__DONT_REMOVE_LISTING
			main_inst.option_data[31].data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			main_inst.option_data[31].argtype := 0
			main_inst.option_data[32].long_name := ce_string ("dot-style")
			main_inst.option_data[32].short_name := (0).to_integer_8
			main_inst.option_data[32].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[32].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("dotstyle"))
			main_inst.option_data[32].argtype := -1
			main_inst.option_data[33].long_name := ce_string ("egd-file")
			main_inst.option_data[33].short_name := (0).to_integer_8
			main_inst.option_data[33].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[33].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("egdfile"))
			main_inst.option_data[33].argtype := -1
			main_inst.option_data[34].long_name := ce_string ("exclude-directories")
			main_inst.option_data[34].short_name := (('X').code).to_integer_8
			main_inst.option_data[34].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[34].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("excludedirectories"))
			main_inst.option_data[34].argtype := -1
			main_inst.option_data[35].long_name := ce_string ("exclude-domains")
			main_inst.option_data[35].short_name := (0).to_integer_8
			main_inst.option_data[35].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[35].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("excludedomains"))
			main_inst.option_data[35].argtype := -1
			main_inst.option_data[36].long_name := ce_string ("execute")
			main_inst.option_data[36].short_name := (('e').code).to_integer_8
			main_inst.option_data[36].type := {PC_TYPE}.OPT__EXECUTE
			main_inst.option_data[36].data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			main_inst.option_data[36].argtype := 1
			main_inst.option_data[37].long_name := ce_string ("follow-ftp")
			main_inst.option_data[37].short_name := (0).to_integer_8
			main_inst.option_data[37].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[37].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("followftp"))
			main_inst.option_data[37].argtype := -1
			main_inst.option_data[38].long_name := ce_string ("follow-tags")
			main_inst.option_data[38].short_name := (0).to_integer_8
			main_inst.option_data[38].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[38].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("followtags"))
			main_inst.option_data[38].argtype := -1
			main_inst.option_data[39].long_name := ce_string ("force-directories")
			main_inst.option_data[39].short_name := (('x').code).to_integer_8
			main_inst.option_data[39].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[39].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("dirstruct"))
			main_inst.option_data[39].argtype := -1
			main_inst.option_data[40].long_name := ce_string ("force-html")
			main_inst.option_data[40].short_name := (('F').code).to_integer_8
			main_inst.option_data[40].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[40].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("forcehtml"))
			main_inst.option_data[40].argtype := -1
			main_inst.option_data[41].long_name := ce_string ("ftp-password")
			main_inst.option_data[41].short_name := (0).to_integer_8
			main_inst.option_data[41].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[41].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("ftppassword"))
			main_inst.option_data[41].argtype := -1
			main_inst.option_data[42].long_name := ce_string ("ftp-user")
			main_inst.option_data[42].short_name := (0).to_integer_8
			main_inst.option_data[42].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[42].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("ftpuser"))
			main_inst.option_data[42].argtype := -1
			main_inst.option_data[43].long_name := ce_string ("glob")
			main_inst.option_data[43].short_name := (0).to_integer_8
			main_inst.option_data[43].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[43].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("glob"))
			main_inst.option_data[43].argtype := -1
			main_inst.option_data[44].long_name := ce_string ("header")
			main_inst.option_data[44].short_name := (0).to_integer_8
			main_inst.option_data[44].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[44].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("header"))
			main_inst.option_data[44].argtype := -1
			main_inst.option_data[45].long_name := ce_string ("help")
			main_inst.option_data[45].short_name := (('h').code).to_integer_8
			main_inst.option_data[45].type := {PC_TYPE}.OPT_FUNCALL
			main_inst.option_data[45].data := create {CE_POINTER [ANY]}.make_cast ((main_inst.print_help_address))
			main_inst.option_data[45].argtype := 0
			main_inst.option_data[46].long_name := ce_string ("host-directories")
			main_inst.option_data[46].short_name := (0).to_integer_8
			main_inst.option_data[46].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[46].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("addhostdir"))
			main_inst.option_data[46].argtype := -1
			main_inst.option_data[47].long_name := ce_string ("html-extension")
			main_inst.option_data[47].short_name := (('E').code).to_integer_8
			main_inst.option_data[47].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[47].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("adjustextension"))
			main_inst.option_data[47].argtype := -1
			main_inst.option_data[48].long_name := ce_string ("htmlify")
			main_inst.option_data[48].short_name := (0).to_integer_8
			main_inst.option_data[48].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[48].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("htmlify"))
			main_inst.option_data[48].argtype := -1
			main_inst.option_data[49].long_name := ce_string ("http-keep-alive")
			main_inst.option_data[49].short_name := (0).to_integer_8
			main_inst.option_data[49].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[49].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("httpkeepalive"))
			main_inst.option_data[49].argtype := -1
			main_inst.option_data[50].long_name := ce_string ("http-passwd")
			main_inst.option_data[50].short_name := (0).to_integer_8
			main_inst.option_data[50].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[50].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("httppassword"))
			main_inst.option_data[50].argtype := -1
			main_inst.option_data[51].long_name := ce_string ("http-password")
			main_inst.option_data[51].short_name := (0).to_integer_8
			main_inst.option_data[51].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[51].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("httppassword"))
			main_inst.option_data[51].argtype := -1
			main_inst.option_data[52].long_name := ce_string ("http-user")
			main_inst.option_data[52].short_name := (0).to_integer_8
			main_inst.option_data[52].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[52].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("httpuser"))
			main_inst.option_data[52].argtype := -1
			main_inst.option_data[53].long_name := ce_string ("ignore-case")
			main_inst.option_data[53].short_name := (0).to_integer_8
			main_inst.option_data[53].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[53].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("ignorecase"))
			main_inst.option_data[53].argtype := -1
			main_inst.option_data[54].long_name := ce_string ("ignore-length")
			main_inst.option_data[54].short_name := (0).to_integer_8
			main_inst.option_data[54].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[54].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("ignorelength"))
			main_inst.option_data[54].argtype := -1
			main_inst.option_data[55].long_name := ce_string ("ignore-tags")
			main_inst.option_data[55].short_name := (0).to_integer_8
			main_inst.option_data[55].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[55].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("ignoretags"))
			main_inst.option_data[55].argtype := -1
			main_inst.option_data[56].long_name := ce_string ("include-directories")
			main_inst.option_data[56].short_name := (('I').code).to_integer_8
			main_inst.option_data[56].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[56].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("includedirectories"))
			main_inst.option_data[56].argtype := -1
			main_inst.option_data[57].long_name := ce_string ("inet4-only")
			main_inst.option_data[57].short_name := (('4').code).to_integer_8
			main_inst.option_data[57].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[57].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("inet4only"))
			main_inst.option_data[57].argtype := -1
			main_inst.option_data[58].long_name := ce_string ("inet6-only")
			main_inst.option_data[58].short_name := (('6').code).to_integer_8
			main_inst.option_data[58].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[58].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("inet6only"))
			main_inst.option_data[58].argtype := -1
			main_inst.option_data[59].long_name := ce_string ("input-file")
			main_inst.option_data[59].short_name := (('i').code).to_integer_8
			main_inst.option_data[59].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[59].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("input"))
			main_inst.option_data[59].argtype := -1
			main_inst.option_data[60].long_name := ce_string ("iri")
			main_inst.option_data[60].short_name := (0).to_integer_8
			main_inst.option_data[60].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[60].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("iri"))
			main_inst.option_data[60].argtype := -1
			main_inst.option_data[61].long_name := ce_string ("keep-session-cookies")
			main_inst.option_data[61].short_name := (0).to_integer_8
			main_inst.option_data[61].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[61].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("keepsessioncookies"))
			main_inst.option_data[61].argtype := -1
			main_inst.option_data[62].long_name := ce_string ("level")
			main_inst.option_data[62].short_name := (('l').code).to_integer_8
			main_inst.option_data[62].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[62].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("reclevel"))
			main_inst.option_data[62].argtype := -1
			main_inst.option_data[63].long_name := ce_string ("limit-rate")
			main_inst.option_data[63].short_name := (0).to_integer_8
			main_inst.option_data[63].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[63].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("limitrate"))
			main_inst.option_data[63].argtype := -1
			main_inst.option_data[64].long_name := ce_string ("load-cookies")
			main_inst.option_data[64].short_name := (0).to_integer_8
			main_inst.option_data[64].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[64].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("loadcookies"))
			main_inst.option_data[64].argtype := -1
			main_inst.option_data[65].long_name := ce_string ("local-encoding")
			main_inst.option_data[65].short_name := (0).to_integer_8
			main_inst.option_data[65].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[65].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("localencoding"))
			main_inst.option_data[65].argtype := -1
			main_inst.option_data[66].long_name := ce_string ("max-redirect")
			main_inst.option_data[66].short_name := (0).to_integer_8
			main_inst.option_data[66].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[66].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("maxredirect"))
			main_inst.option_data[66].argtype := -1
			main_inst.option_data[67].long_name := ce_string ("mirror")
			main_inst.option_data[67].short_name := (('m').code).to_integer_8
			main_inst.option_data[67].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[67].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("mirror"))
			main_inst.option_data[67].argtype := -1
			main_inst.option_data[68].long_name := ce_string ("no")
			main_inst.option_data[68].short_name := (('n').code).to_integer_8
			main_inst.option_data[68].type := {PC_TYPE}.OPT__NO
			main_inst.option_data[68].data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			main_inst.option_data[68].argtype := 1
			main_inst.option_data[69].long_name := ce_string ("no-clobber")
			main_inst.option_data[69].short_name := (0).to_integer_8
			main_inst.option_data[69].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[69].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("noclobber"))
			main_inst.option_data[69].argtype := -1
			main_inst.option_data[70].long_name := ce_string ("no-parent")
			main_inst.option_data[70].short_name := (0).to_integer_8
			main_inst.option_data[70].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[70].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("noparent"))
			main_inst.option_data[70].argtype := -1
			main_inst.option_data[71].long_name := ce_string ("output-document")
			main_inst.option_data[71].short_name := (('O').code).to_integer_8
			main_inst.option_data[71].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[71].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("outputdocument"))
			main_inst.option_data[71].argtype := -1
			main_inst.option_data[72].long_name := ce_string ("output-file")
			main_inst.option_data[72].short_name := (('o').code).to_integer_8
			main_inst.option_data[72].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[72].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("logfile"))
			main_inst.option_data[72].argtype := -1
			main_inst.option_data[73].long_name := ce_string ("page-requisites")
			main_inst.option_data[73].short_name := (('p').code).to_integer_8
			main_inst.option_data[73].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[73].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("pagerequisites"))
			main_inst.option_data[73].argtype := -1
			main_inst.option_data[74].long_name := ce_string ("parent")
			main_inst.option_data[74].short_name := (0).to_integer_8
			main_inst.option_data[74].type := {PC_TYPE}.OPT__PARENT
			main_inst.option_data[74].data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			main_inst.option_data[74].argtype := 2
			main_inst.option_data[75].long_name := ce_string ("passive-ftp")
			main_inst.option_data[75].short_name := (0).to_integer_8
			main_inst.option_data[75].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[75].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("passiveftp"))
			main_inst.option_data[75].argtype := -1
			main_inst.option_data[76].long_name := ce_string ("password")
			main_inst.option_data[76].short_name := (0).to_integer_8
			main_inst.option_data[76].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[76].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("password"))
			main_inst.option_data[76].argtype := -1
			main_inst.option_data[77].long_name := ce_string ("post-data")
			main_inst.option_data[77].short_name := (0).to_integer_8
			main_inst.option_data[77].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[77].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("postdata"))
			main_inst.option_data[77].argtype := -1
			main_inst.option_data[78].long_name := ce_string ("post-file")
			main_inst.option_data[78].short_name := (0).to_integer_8
			main_inst.option_data[78].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[78].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("postfile"))
			main_inst.option_data[78].argtype := -1
			main_inst.option_data[79].long_name := ce_string ("prefer-family")
			main_inst.option_data[79].short_name := (0).to_integer_8
			main_inst.option_data[79].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[79].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("preferfamily"))
			main_inst.option_data[79].argtype := -1
			main_inst.option_data[80].long_name := ce_string ("preserve-permissions")
			main_inst.option_data[80].short_name := (0).to_integer_8
			main_inst.option_data[80].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[80].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("preservepermissions"))
			main_inst.option_data[80].argtype := -1
			main_inst.option_data[81].long_name := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			main_inst.option_data[81].short_name := (0).to_integer_8
			main_inst.option_data[81].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[81].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("privatekey"))
			main_inst.option_data[81].argtype := -1
			main_inst.option_data[82].long_name := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			main_inst.option_data[82].short_name := (0).to_integer_8
			main_inst.option_data[82].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[82].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("privatekeytype"))
			main_inst.option_data[82].argtype := -1
			main_inst.option_data[83].long_name := ce_string ("progress")
			main_inst.option_data[83].short_name := (0).to_integer_8
			main_inst.option_data[83].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[83].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("progress"))
			main_inst.option_data[83].argtype := -1
			main_inst.option_data[84].long_name := ce_string ("protocol-directories")
			main_inst.option_data[84].short_name := (0).to_integer_8
			main_inst.option_data[84].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[84].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("protocoldirectories"))
			main_inst.option_data[84].argtype := -1
			main_inst.option_data[85].long_name := ce_string ("proxy")
			main_inst.option_data[85].short_name := (0).to_integer_8
			main_inst.option_data[85].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[85].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("useproxy"))
			main_inst.option_data[85].argtype := -1
			main_inst.option_data[86].long_name := ce_string ("proxy__compat")
			main_inst.option_data[86].short_name := (('Y').code).to_integer_8
			main_inst.option_data[86].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[86].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("useproxy"))
			main_inst.option_data[86].argtype := -1
			main_inst.option_data[87].long_name := ce_string ("proxy-passwd")
			main_inst.option_data[87].short_name := (0).to_integer_8
			main_inst.option_data[87].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[87].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("proxypassword"))
			main_inst.option_data[87].argtype := -1
			main_inst.option_data[88].long_name := ce_string ("proxy-password")
			main_inst.option_data[88].short_name := (0).to_integer_8
			main_inst.option_data[88].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[88].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("proxypassword"))
			main_inst.option_data[88].argtype := -1
			main_inst.option_data[89].long_name := ce_string ("proxy-user")
			main_inst.option_data[89].short_name := (0).to_integer_8
			main_inst.option_data[89].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[89].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("proxyuser"))
			main_inst.option_data[89].argtype := -1
			main_inst.option_data[90].long_name := ce_string ("quiet")
			main_inst.option_data[90].short_name := (('q').code).to_integer_8
			main_inst.option_data[90].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[90].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("quiet"))
			main_inst.option_data[90].argtype := -1
			main_inst.option_data[91].long_name := ce_string ("quota")
			main_inst.option_data[91].short_name := (('Q').code).to_integer_8
			main_inst.option_data[91].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[91].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("quota"))
			main_inst.option_data[91].argtype := -1
			main_inst.option_data[92].long_name := ce_string ("random-file")
			main_inst.option_data[92].short_name := (0).to_integer_8
			main_inst.option_data[92].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[92].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("randomfile"))
			main_inst.option_data[92].argtype := -1
			main_inst.option_data[93].long_name := ce_string ("random-wait")
			main_inst.option_data[93].short_name := (0).to_integer_8
			main_inst.option_data[93].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[93].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("randomwait"))
			main_inst.option_data[93].argtype := -1
			main_inst.option_data[94].long_name := ce_string ("read-timeout")
			main_inst.option_data[94].short_name := (0).to_integer_8
			main_inst.option_data[94].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[94].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("readtimeout"))
			main_inst.option_data[94].argtype := -1
			main_inst.option_data[95].long_name := ce_string ("recursive")
			main_inst.option_data[95].short_name := (('r').code).to_integer_8
			main_inst.option_data[95].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[95].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("recursive"))
			main_inst.option_data[95].argtype := -1
			main_inst.option_data[96].long_name := ce_string ("referer")
			main_inst.option_data[96].short_name := (0).to_integer_8
			main_inst.option_data[96].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[96].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("referer"))
			main_inst.option_data[96].argtype := -1
			main_inst.option_data[97].long_name := ce_string ("reject")
			main_inst.option_data[97].short_name := (('R').code).to_integer_8
			main_inst.option_data[97].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[97].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("reject"))
			main_inst.option_data[97].argtype := -1
			main_inst.option_data[98].long_name := ce_string ("relative")
			main_inst.option_data[98].short_name := (('L').code).to_integer_8
			main_inst.option_data[98].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[98].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("relativeonly"))
			main_inst.option_data[98].argtype := -1
			main_inst.option_data[99].long_name := ce_string ("remote-encoding")
			main_inst.option_data[99].short_name := (0).to_integer_8
			main_inst.option_data[99].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[99].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("remoteencoding"))
			main_inst.option_data[99].argtype := -1
			main_inst.option_data[100].long_name := ce_string ("remove-listing")
			main_inst.option_data[100].short_name := (0).to_integer_8
			main_inst.option_data[100].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[100].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("removelisting"))
			main_inst.option_data[100].argtype := -1
			main_inst.option_data[101].long_name := ce_string ("restrict-file-names")
			main_inst.option_data[101].short_name := (0).to_integer_8
			main_inst.option_data[101].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[101].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("restrictfilenames"))
			main_inst.option_data[101].argtype := -1
			main_inst.option_data[102].long_name := ce_string ("retr-symlinks")
			main_inst.option_data[102].short_name := (0).to_integer_8
			main_inst.option_data[102].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[102].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("retrsymlinks"))
			main_inst.option_data[102].argtype := -1
			main_inst.option_data[103].long_name := ce_string ("retry-connrefused")
			main_inst.option_data[103].short_name := (0).to_integer_8
			main_inst.option_data[103].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[103].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("retryconnrefused"))
			main_inst.option_data[103].argtype := -1
			main_inst.option_data[104].long_name := ce_string ("save-cookies")
			main_inst.option_data[104].short_name := (0).to_integer_8
			main_inst.option_data[104].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[104].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("savecookies"))
			main_inst.option_data[104].argtype := -1
			main_inst.option_data[105].long_name := ce_string ("save-headers")
			main_inst.option_data[105].short_name := (0).to_integer_8
			main_inst.option_data[105].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[105].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("saveheaders"))
			main_inst.option_data[105].argtype := -1
			main_inst.option_data[106].long_name := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			main_inst.option_data[106].short_name := (0).to_integer_8
			main_inst.option_data[106].type := {PC_TYPE}.OPT_VALUE
			main_inst.option_data[106].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("secureprotocol"))
			main_inst.option_data[106].argtype := -1
			main_inst.option_data[107].long_name := ce_string ("server-response")
			main_inst.option_data[107].short_name := (('S').code).to_integer_8
			main_inst.option_data[107].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[107].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("serverresponse"))
			main_inst.option_data[107].argtype := -1
			main_inst.option_data[108].long_name := ce_string ("span-hosts")
			main_inst.option_data[108].short_name := (('H').code).to_integer_8
			main_inst.option_data[108].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[108].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("spanhosts"))
			main_inst.option_data[108].argtype := -1
			main_inst.option_data[109].long_name := ce_string ("spider")
			main_inst.option_data[109].short_name := (0).to_integer_8
			main_inst.option_data[109].type := {PC_TYPE}.OPT_BOOLEAN
			main_inst.option_data[109].data := create {CE_POINTER [ANY]}.make_cast (ce_string ("spider"))
			main_inst.option_data[109].argtype := -1
		end

end
