class
	P_FTP_BASIC

inherit
	WGET_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {NONE} -- Initialization

	default_create
		do
			create skey_head.make (<<2>>)
		end

feature {ANY} -- attributes

	skey_head: CE_ARRAY [CE_POINTER [INTEGER_8]]

feature {ANY} -- routines

	ftp_response (a_fd: INTEGER_32; a_ret_line: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_line: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_line.make

			from
			until
				js.loop_left
			loop
				l_line.ce_gets ((retr_inst.fd_read_line (a_fd)))
				if (l_line).c_pointer = default_pointer then
					Result := ({PC_UERR_T}.FTPRERR)
					js.return
				end
				if not js.return_called then
					l_p___0.ce_gets (strchr (l_line, ('%/0/').code))
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_line.c_pointer.to_integer_32).to_natural_32 then
						if (l_p___0[-1]).to_integer_32 = 10 then
							l_p___0.ce_gets (l_p___0 - 1)
							l_p___0[0] := (('%/0/').code).to_integer_8
						end
					end
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_line.c_pointer.to_integer_32).to_natural_32 then
						if (l_p___0[-1]).to_integer_32 = 13 then
							l_p___0.ce_gets (l_p___0 - 1)
							l_p___0[0] := (('%/0/').code).to_integer_8
						end
					end
					if options_inst.opt.server_response then
						log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s%N"), (quotearg_inst.quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_line))])
					else
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("%%s%N"), (quotearg_inst.quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_line))])
							end
							js.break
						end
						js.reset
					end
					if (c_ctype_inst.c2_isdigit ((l_line[0]).to_integer_32)) then
						if (c_ctype_inst.c2_isdigit ((l_line[1]).to_integer_32)) then
							if (c_ctype_inst.c2_isdigit ((l_line[2]).to_integer_32)) then
								if (l_line[3]).to_integer_32 = 32 then
									strncpy (ftp_inst.ftp_last_respline, l_line, (Integer_8_bytes.to_natural_32 * (128).to_natural_32)).do_nothing
									ftp_inst.ftp_last_respline[((Integer_8_bytes.to_natural_32 * (128).to_natural_32) - {NATURAL_32} 1).to_integer_32] := (('%/0/').code).to_integer_8
									a_ret_line.item := l_line
									Result := ({PC_UERR_T}.FTPOK)
									js.return
								end
							end
						end
					end
				end
				if not js.return_called then
					free (create {CE_POINTER [ANY]}.make_cast (l_line))
				end
			end
		end

	ftp_request (a_command: CE_POINTER [INTEGER_8]; a_value: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_value: CE_POINTER [INTEGER_8]
			l_res___0: CE_POINTER [INTEGER_8]
			l_defanged: CE_POINTER [INTEGER_8]
			l_p___0: CE_POINTER [INTEGER_8]
			l_SA_dest: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_SA_src: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_value.make
			create l_res___0.make
			create l_defanged.make
			create l_p___0.make
			create l_SA_dest.make
			create l_SA_src.make
			create l_tmp___1.make

			l_value.ce_gets (a_value)
			if ((l_value).c_pointer /= default_pointer) then
				if (((strpbrk (l_value, ce_string ("%R%N")))).c_pointer /= default_pointer) then
					from
					until
						js.loop_left
					loop
						js.reset
						l_SA_dest.ce_gets (l_defanged.address)
						l_SA_src.ce_gets (l_value)
						l_SA_dest.item := create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new ((strlen (l_SA_src)) + {NATURAL_32} 1)))
						strcpy (l_SA_dest.item, l_SA_src).do_nothing
						js.break
					end
					js.reset
					l_p___0.ce_gets (l_defanged)
					from
					until
						not ((l_p___0[0]).to_boolean)
					loop
						if (l_p___0[0]).to_integer_32 = 13 then
							l_p___0[0] := ((' ').code).to_integer_8
						elseif (l_p___0[0]).to_integer_32 = 10 then
							l_p___0[0] := ((' ').code).to_integer_8
						end
						l_p___0.ce_gets (l_p___0 + 1)
					end
					from
					until
						js.loop_left
					loop
						js.reset
						if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
							l_tmp___1.ce_gets (quotearg_inst.quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_defanged))
							log_inst.debug_logprintf ([ce_string ("%NDetected newlines in %%s %"%%s%"; changing to %%s %"%%s%"%N"), a_command, (quotearg_inst.quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_value)), a_command, l_tmp___1])
						end
						js.break
					end
					js.reset
					l_value.ce_gets (l_defanged)
				end
				l_res___0.ce_gets (utils_inst.concat_strings ([a_command, ce_string (" "), l_value, ce_string ("%R%N"), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)]))
			else
				l_res___0.ce_gets (utils_inst.concat_strings ([a_command, ce_string ("%R%N"), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)]))
			end
			if options_inst.opt.server_response then
				if (strncmp (l_res___0, ce_string ("PASS"), (4).to_natural_32)) /= 0 then
					log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_ALWAYS, ce_string ("--> %%s%N"), l_res___0])
				else
					log_inst.logputs ({PC_LOG_OPTIONS}.LOG_ALWAYS, ce_string ("--> PASS Turtle Power!%N%N"))
				end
			else
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
						log_inst.debug_logprintf ([ce_string ("%N--> %%s%N"), l_res___0])
					end
					js.break
				end
				js.reset
			end
			Result := l_res___0
		end

	ftp_login (a_csock: INTEGER_32; a_acc: CE_POINTER [INTEGER_8]; a_pass: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_pass: CE_POINTER [INTEGER_8]
			l_err: INTEGER_32
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_POINTER [INTEGER_8]
			l_nwritten: INTEGER_32
			l_i: NATURAL_32
			l_seed: CE_POINTER [INTEGER_8]
			l_l: INTEGER_32
			l_skey_sequence: INTEGER_32
			js: JUMP_STATE
		do
			create l_pass.make
			create l_request.make
			create l_respline.make
			create l_seed.make

			l_pass.ce_gets (a_pass)
			l_err := ftp_response (a_csock, l_respline.address)
			if l_err.to_natural_32 /= {NATURAL_32} 10 then
				Result := l_err
				js.return
			end
			if not js.return_called and then ((l_respline[0]).to_integer_32 /= 50) then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				Result := ({PC_UERR_T}.FTPSRVERR)
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				l_request.ce_gets (ftp_request (ce_string ("USER"), a_acc))
				l_nwritten := connect_inst.fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
				if l_nwritten < 0 then
					free (create {CE_POINTER [ANY]}.make_cast (l_request))
					Result := ({PC_UERR_T}.WRITEFAILED)
					js.return
				end
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (l_request))
				l_err := ftp_response (a_csock, l_respline.address)
				if l_err.to_natural_32 /= {NATURAL_32} 10 then
					Result := l_err
					js.return
				end
			end
			if not js.return_called and then ((l_respline[0]).to_integer_32 = 50) then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				Result := ({PC_UERR_T}.FTPOK)
				js.return
			end
			if not js.return_called and then ((l_respline[0]).to_integer_32 /= 51) then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				Result := ({PC_UERR_T}.FTPLOGREFUSED)
				js.return
			end
			if not js.return_called then
				l_seed.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < (Pointer_bytes.to_natural_32 * (2).to_natural_32) // Pointer_bytes.to_natural_32))
				loop
					js.reset
					l_l := (strlen (skey_head[l_i.to_integer_32])).to_integer_32
					if 0 = (strncasecmp (skey_head[l_i.to_integer_32], l_respline, l_l.to_natural_32)) then
						l_seed.ce_gets ((l_respline + l_l))
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
				js.reset
				if ((l_seed).c_pointer /= default_pointer) then
					l_skey_sequence := 0
					from
					until
						js.loop_left
					loop
						js.reset
						if not (c_ctype_inst.c2_isdigit ((l_seed[0]).to_integer_32)) then
							js.break
						end
						if not js.loop_jumped then
							l_skey_sequence := (10 * l_skey_sequence + (l_seed[0]).to_integer_32) - 48
							l_seed.ce_gets (l_seed + 1)
						end
					end
					js.reset
					if (l_seed[0]).to_integer_32 = 32 then
						l_seed.ce_gets (l_seed + 1)
					else
						free (create {CE_POINTER [ANY]}.make_cast (l_respline))
						Result := ({PC_UERR_T}.FTPLOGREFUSED)
						js.return
					end
					if not js.return_called then
						l_pass.ce_gets (ftp_opie_inst.skey_response (l_skey_sequence, l_seed, l_pass))
					end
				end
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				l_request.ce_gets (ftp_request (ce_string ("PASS"), l_pass))
				l_nwritten := connect_inst.fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
				if l_nwritten < 0 then
					free (create {CE_POINTER [ANY]}.make_cast (l_request))
					Result := ({PC_UERR_T}.WRITEFAILED)
					js.return
				end
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (l_request))
				l_err := ftp_response (a_csock, l_respline.address)
				if l_err.to_natural_32 /= {NATURAL_32} 10 then
					Result := l_err
					js.return
				end
			end
			if not js.return_called and then ((l_respline[0]).to_integer_32 /= 50) then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				Result := ({PC_UERR_T}.FTPLOGINC)
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				Result := ({PC_UERR_T}.FTPOK)
			end
		end

	ip_address_to_port_repr (a_addr: CE_POINTER [PD_IP_ADDRESS]; a_port: INTEGER_32; a_buf___6: CE_POINTER [INTEGER_8]; a_buflen: NATURAL_32)
		local
			l_ptr: CE_POINTER [NATURAL_8]
		do
			create l_ptr.make

			if a_addr.item.family /= 2 then
				assert_fail (ce_string ("addr->family == 2"), ce_string ("ftp-basic.c"), {NATURAL_32} 254, ce_string ("ip_address_to_port_repr"))
			end
			if not (a_buflen >= {NATURAL_32} 24) then
				assert_fail (ce_string ("buflen >= 6 * 4"), ce_string ("ftp-basic.c"), {NATURAL_32} 256, ce_string ("ip_address_to_port_repr"))
			end
			l_ptr.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [PD_DATA]}.make_shared (a_addr.c_pointer + {PD_IP_ADDRESS}.data_offset))))
			snprintf ([a_buf___6, a_buflen, ce_string ("%%d,%%d,%%d,%%d,%%d,%%d"), (l_ptr[0]).to_integer_32, (l_ptr[1]).to_integer_32, (l_ptr[2]).to_integer_32, (l_ptr[3]).to_integer_32, (((a_port).bit_and (65280))).bit_shift_right (8), (a_port).bit_and (255)]).do_nothing
			a_buf___6[(a_buflen - {NATURAL_32} 1).to_integer_32] := (('%/0/').code).to_integer_8
		end

	ftp_port (a_csock: INTEGER_32; a_local_sock: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_err: INTEGER_32
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_POINTER [INTEGER_8]
			l_addr: PD_IP_ADDRESS
			l_nwritten: INTEGER_32
			l_port: INTEGER_32
			l_bytes: CE_ARRAY [INTEGER_8]
			js: JUMP_STATE
		do
			create l_request.make
			create l_respline.make
			create l_addr.make
			create l_bytes.make (<<25>>)

			if not (connect_inst.socket_ip_address (a_csock, l_addr.address, 0)) then
				Result := ({PC_UERR_T}.FTPSYSERR)
				js.return
			end
			if not js.return_called then
				if l_addr.family /= 2 then
					assert_fail (ce_string ("addr.family == 2"), ce_string ("ftp-basic.c"), {NATURAL_32} 282, ce_string ("ftp_port"))
				end
				l_port := 0
				a_local_sock.item := connect_inst.bind_local ((l_addr.address), create {CE_POINTER [INTEGER_32]}.make_shared ($l_port))
				if a_local_sock.item < 0 then
					Result := ({PC_UERR_T}.FTPSYSERR)
					js.return
				end
			end
			if not js.return_called then
				ip_address_to_port_repr ((l_addr.address), l_port, l_bytes, (Integer_8_bytes.to_natural_32 * (25).to_natural_32))
				l_request.ce_gets (ftp_request (ce_string ("PORT"), l_bytes))
				l_nwritten := connect_inst.fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
				if l_nwritten < 0 then
					free (create {CE_POINTER [ANY]}.make_cast (l_request))
					connect_inst.fd_close (a_local_sock.item)
					Result := ({PC_UERR_T}.WRITEFAILED)
					js.return
				end
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (l_request))
				l_err := ftp_response (a_csock, l_respline.address)
				if l_err.to_natural_32 /= {NATURAL_32} 10 then
					connect_inst.fd_close (a_local_sock.item)
					Result := l_err
					js.return
				end
			end
			if not js.return_called and then ((l_respline[0]).to_integer_32 /= 50) then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				connect_inst.fd_close (a_local_sock.item)
				Result := ({PC_UERR_T}.FTPPORTERR)
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				Result := ({PC_UERR_T}.FTPOK)
			end
		end

	ip_address_to_lprt_repr (a_addr: CE_POINTER [PD_IP_ADDRESS]; a_port: INTEGER_32; a_buf___6: CE_POINTER [INTEGER_8]; a_buflen: NATURAL_32)
		local
			l_ptr: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_ptr.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ptr.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [PD_DATA]}.make_shared (a_addr.c_pointer + {PD_IP_ADDRESS}.data_offset))))
					if not (a_buflen >= {NATURAL_32} 84) then
						assert_fail (ce_string ("buflen >= 21 * 4"), ce_string ("ftp-basic.c"), {NATURAL_32} 331, ce_string ("ip_address_to_lprt_repr"))
					end
					inspect a_addr.item.family -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 10 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 2
					snprintf ([a_buf___6, a_buflen, ce_string ("%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d"), 4, 4, (l_ptr[0]).to_integer_32, (l_ptr[1]).to_integer_32, (l_ptr[2]).to_integer_32, (l_ptr[3]).to_integer_32, 2, (((a_port).bit_and (65280))).bit_shift_right (8), (a_port).bit_and (255)]).do_nothing
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 10
					snprintf ([a_buf___6, a_buflen, ce_string ("%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d,%%d"), 6, 16, (l_ptr[0]).to_integer_32, (l_ptr[1]).to_integer_32, (l_ptr[2]).to_integer_32, (l_ptr[3]).to_integer_32, (l_ptr[4]).to_integer_32, (l_ptr[5]).to_integer_32, (l_ptr[6]).to_integer_32, (l_ptr[7]).to_integer_32, (l_ptr[8]).to_integer_32, (l_ptr[9]).to_integer_32, (l_ptr[10]).to_integer_32, (l_ptr[11]).to_integer_32, (l_ptr[12]).to_integer_32, (l_ptr[13]).to_integer_32, (l_ptr[14]).to_integer_32, (l_ptr[15]).to_integer_32, 2, (((a_port).bit_and (65280))).bit_shift_right (8), (a_port).bit_and (255)]).do_nothing
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
					abort
				when 4 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_lprt (a_csock: INTEGER_32; a_local_sock: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_err: INTEGER_32
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_POINTER [INTEGER_8]
			l_addr: PD_IP_ADDRESS
			l_nwritten: INTEGER_32
			l_port: INTEGER_32
			l_bytes: CE_ARRAY [INTEGER_8]
			js: JUMP_STATE
		do
			create l_request.make
			create l_respline.make
			create l_addr.make
			create l_bytes.make (<<85>>)

			if not (connect_inst.socket_ip_address (a_csock, l_addr.address, 0)) then
				Result := ({PC_UERR_T}.FTPSYSERR)
				js.return
			end
			if not js.return_called then
				if l_addr.family /= 2 then
					if l_addr.family /= 10 then
						assert_fail (ce_string ("addr.family == 2 || addr.family == 10"), ce_string ("ftp-basic.c"), {NATURAL_32} 372, ce_string ("ftp_lprt"))
					end
				end
				l_port := 0
				a_local_sock.item := connect_inst.bind_local ((l_addr.address), create {CE_POINTER [INTEGER_32]}.make_shared ($l_port))
				if a_local_sock.item < 0 then
					Result := ({PC_UERR_T}.FTPSYSERR)
					js.return
				end
			end
			if not js.return_called then
				ip_address_to_lprt_repr ((l_addr.address), l_port, l_bytes, (Integer_8_bytes.to_natural_32 * (85).to_natural_32))
				l_request.ce_gets (ftp_request (ce_string ("LPRT"), l_bytes))
				l_nwritten := connect_inst.fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
				if l_nwritten < 0 then
					free (create {CE_POINTER [ANY]}.make_cast (l_request))
					connect_inst.fd_close (a_local_sock.item)
					Result := ({PC_UERR_T}.WRITEFAILED)
					js.return
				end
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (l_request))
				l_err := ftp_response (a_csock, l_respline.address)
				if l_err.to_natural_32 /= {NATURAL_32} 10 then
					connect_inst.fd_close (a_local_sock.item)
					Result := l_err
					js.return
				end
			end
			if not js.return_called and then ((l_respline[0]).to_integer_32 /= 50) then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				connect_inst.fd_close (a_local_sock.item)
				Result := ({PC_UERR_T}.FTPPORTERR)
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				Result := ({PC_UERR_T}.FTPOK)
			end
		end

	ip_address_to_eprt_repr (a_addr: CE_POINTER [PD_IP_ADDRESS]; a_port: INTEGER_32; a_buf___6: CE_POINTER [INTEGER_8]; a_buflen: NATURAL_32)
		local
			l_afnum: INTEGER_32
		do
			if not (a_buflen >= {NATURAL_32} 56) then
				assert_fail (ce_string ("buflen >= 4 + 46 + 1 + 5"), ce_string ("ftp-basic.c"), {NATURAL_32} 421, ce_string ("ip_address_to_eprt_repr"))
			end
			if a_addr.item.family = 2 then
				l_afnum := 1
			else
				l_afnum := 2
			end
			snprintf ([a_buf___6, a_buflen, ce_string ("|%%d|%%s|%%d|"), l_afnum, (host_inst.print_address (a_addr)), a_port]).do_nothing
			a_buf___6[(a_buflen - {NATURAL_32} 1).to_integer_32] := (('%/0/').code).to_integer_8
		end

	ftp_eprt (a_csock: INTEGER_32; a_local_sock: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_err: INTEGER_32
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_POINTER [INTEGER_8]
			l_addr: PD_IP_ADDRESS
			l_nwritten: INTEGER_32
			l_port: INTEGER_32
			l_bytes: CE_ARRAY [INTEGER_8]
			js: JUMP_STATE
		do
			create l_request.make
			create l_respline.make
			create l_addr.make
			create l_bytes.make (<<57>>)

			if not (connect_inst.socket_ip_address (a_csock, l_addr.address, 0)) then
				Result := ({PC_UERR_T}.FTPSYSERR)
				js.return
			end
			if not js.return_called then
				l_port := 0
				a_local_sock.item := connect_inst.bind_local ((l_addr.address), create {CE_POINTER [INTEGER_32]}.make_shared ($l_port))
				if a_local_sock.item < 0 then
					Result := ({PC_UERR_T}.FTPSYSERR)
					js.return
				end
			end
			if not js.return_called then
				ip_address_to_eprt_repr ((l_addr.address), l_port, l_bytes, (Integer_8_bytes.to_natural_32 * (57).to_natural_32))
				l_request.ce_gets (ftp_request (ce_string ("EPRT"), l_bytes))
				l_nwritten := connect_inst.fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
				if l_nwritten < 0 then
					free (create {CE_POINTER [ANY]}.make_cast (l_request))
					connect_inst.fd_close (a_local_sock.item)
					Result := ({PC_UERR_T}.WRITEFAILED)
					js.return
				end
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (l_request))
				l_err := ftp_response (a_csock, l_respline.address)
				if l_err.to_natural_32 /= {NATURAL_32} 10 then
					connect_inst.fd_close (a_local_sock.item)
					Result := l_err
					js.return
				end
			end
			if not js.return_called and then ((l_respline[0]).to_integer_32 /= 50) then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				connect_inst.fd_close (a_local_sock.item)
				Result := ({PC_UERR_T}.FTPPORTERR)
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				Result := ({PC_UERR_T}.FTPOK)
			end
		end

	ftp_pasv (a_csock: INTEGER_32; a_addr: CE_POINTER [PD_IP_ADDRESS]; a_port: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_POINTER [INTEGER_8]
			l_s: CE_POINTER [INTEGER_8]
			l_nwritten: INTEGER_32
			l_i: INTEGER_32
			l_err: INTEGER_32
			l_tmp: CE_ARRAY [NATURAL_8]
			js: JUMP_STATE
		do
			create l_request.make
			create l_respline.make
			create l_s.make
			create l_tmp.make (<<6>>)

			if (a_addr.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				assert_fail (ce_string ("addr != ((void *)0)"), ce_string ("ftp-basic.c"), {NATURAL_32} 499, ce_string ("ftp_pasv"))
			end
			if (a_port.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				assert_fail (ce_string ("port != ((void *)0)"), ce_string ("ftp-basic.c"), {NATURAL_32} 500, ce_string ("ftp_pasv"))
			end
			memset (create {CE_POINTER [ANY]}.make_cast (a_addr), ('%/0/').code, {PD_IP_ADDRESS}.sizeof.to_natural_32).do_nothing
			l_request.ce_gets (ftp_request (ce_string ("PASV"), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)))
			l_nwritten := connect_inst.fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
			if l_nwritten < 0 then
				free (create {CE_POINTER [ANY]}.make_cast (l_request))
				Result := ({PC_UERR_T}.WRITEFAILED)
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (l_request))
				l_err := ftp_response (a_csock, l_respline.address)
				if l_err.to_natural_32 /= {NATURAL_32} 10 then
					Result := l_err
					js.return
				end
			end
			if not js.return_called and then ((l_respline[0]).to_integer_32 /= 50) then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				Result := ({PC_UERR_T}.FTPNOPASV)
				js.return
			end
			if not js.return_called then
				l_s.ce_gets (l_respline)
				l_s.ce_gets (l_s + (4))
				from
				until
					js.loop_left
				loop
					js.reset
					if (l_s[0]).to_boolean then
						if (c_ctype_inst.c2_isdigit ((l_s[0]).to_integer_32)) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_s.ce_gets (l_s + 1)
					end
				end
				js.reset
				if not (l_s[0]).to_boolean then
					Result := ({PC_UERR_T}.FTPINVPASV)
					js.return
				end
			end
			if not js.return_called then
				l_i := 0
				from
				until
					not (not js.loop_left and then (l_i < 6))
				loop
					l_tmp[l_i] := (0).to_natural_8
					from
					until
						js.loop_left
					loop
						js.reset
						if not (c_ctype_inst.c2_isdigit ((l_s[0]).to_integer_32)) then
							js.break
						end
						if not js.loop_jumped then
							l_tmp[l_i] := (((l_s[0]).to_integer_32 - 48) + 10 * (l_tmp[l_i]).to_integer_32).to_natural_8
							l_s.ce_gets (l_s + 1)
						end
					end
					js.reset
					if (l_s[0]).to_integer_32 = 44 then
						l_s.ce_gets (l_s + 1)
					elseif l_i < 5 then
						free (create {CE_POINTER [ANY]}.make_cast (l_respline))
						Result := ({PC_UERR_T}.FTPINVPASV)
						js.return
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				a_addr.item.family := 2
				memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_DATA]}.make_shared (a_addr.c_pointer + {PD_IP_ADDRESS}.data_offset))), create {CE_POINTER [ANY]}.make_cast (l_tmp), (4).to_natural_32).do_nothing
				a_port.item := (((((l_tmp[4]).to_integer_32).bit_shift_left (8))).bit_and (65280)) + (l_tmp[5]).to_integer_32
				Result := ({PC_UERR_T}.FTPOK)
			end
		end

	ftp_lpsv (a_csock: INTEGER_32; a_addr: CE_POINTER [PD_IP_ADDRESS]; a_port: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_POINTER [INTEGER_8]
			l_s: CE_POINTER [INTEGER_8]
			l_nwritten: INTEGER_32
			l_i: INTEGER_32
			l_af: INTEGER_32
			l_addrlen: INTEGER_32
			l_portlen: INTEGER_32
			l_err: INTEGER_32
			l_tmp: CE_ARRAY [NATURAL_8]
			l_tmpprt: CE_ARRAY [NATURAL_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_request.make
			create l_respline.make
			create l_s.make
			create l_tmp.make (<<16>>)
			create l_tmpprt.make (<<2>>)
			create l_tmp___3.make
			create l_tmp___5.make
			create l_tmp___8.make
			create l_tmp___10.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_addr.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						assert_fail (ce_string ("addr != ((void *)0)"), ce_string ("ftp-basic.c"), {NATURAL_32} 565, ce_string ("ftp_lpsv"))
					end
					if (a_port.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						assert_fail (ce_string ("port != ((void *)0)"), ce_string ("ftp-basic.c"), {NATURAL_32} 566, ce_string ("ftp_lpsv"))
					end
					memset (create {CE_POINTER [ANY]}.make_cast (a_addr), ('%/0/').code, {PD_IP_ADDRESS}.sizeof.to_natural_32).do_nothing
					l_request.ce_gets (ftp_request (ce_string ("LPSV"), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)))
					l_nwritten := connect_inst.fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
					if l_nwritten < 0 then
						free (create {CE_POINTER [ANY]}.make_cast (l_request))
						Result := ({PC_UERR_T}.WRITEFAILED)
						js.return
					end
					if not js.return_called then
						free (create {CE_POINTER [ANY]}.make_cast (l_request))
						l_err := ftp_response (a_csock, l_respline.address)
						if l_err.to_natural_32 /= {NATURAL_32} 10 then
							Result := l_err
							js.return
						end
					end
					if not js.return_called and then ((l_respline[0]).to_integer_32 /= 50) then
						free (create {CE_POINTER [ANY]}.make_cast (l_respline))
						Result := ({PC_UERR_T}.FTPNOPASV)
						js.return
					end
					if not js.return_called then
						l_s.ce_gets (l_respline)
						l_s.ce_gets (l_s + (4))
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_s[0]).to_boolean then
								if (c_ctype_inst.c2_isdigit ((l_s[0]).to_integer_32)) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_s.ce_gets (l_s + 1)
							end
						end
						js.reset
						if not (l_s[0]).to_boolean then
							Result := ({PC_UERR_T}.FTPINVPASV)
							js.return
						end
					end
					if not js.return_called then
						l_af := 0
						from
						until
							js.loop_left
						loop
							js.reset
							if not (c_ctype_inst.c2_isdigit ((l_s[0]).to_integer_32)) then
								js.break
							end
							if not js.loop_jumped then
								l_af := ((l_s[0]).to_integer_32 - 48) + 10 * l_af
								l_s.ce_gets (l_s + 1)
							end
						end
						js.reset
						if l_af /= 4 then
							if l_af /= 6 then
								free (create {CE_POINTER [ANY]}.make_cast (l_respline))
								Result := ({PC_UERR_T}.FTPINVPASV)
								js.return
							end
						end
					end
					if not js.return_called then
						if not (l_s[0]).to_boolean then
							free (create {CE_POINTER [ANY]}.make_cast (l_respline))
							Result := ({PC_UERR_T}.FTPINVPASV)
							js.return
						else
							l_tmp___3.ce_gets (l_s)
							l_s.ce_gets (l_s + 1)
							if (l_tmp___3[0]).to_integer_32 /= 44 then
								free (create {CE_POINTER [ANY]}.make_cast (l_respline))
								Result := ({PC_UERR_T}.FTPINVPASV)
								js.return
							end
						end
					end
					if not js.return_called then
						l_addrlen := 0
						from
						until
							js.loop_left
						loop
							js.reset
							if not (c_ctype_inst.c2_isdigit ((l_s[0]).to_integer_32)) then
								js.break
							end
							if not js.loop_jumped then
								l_addrlen := ((l_s[0]).to_integer_32 - 48) + 10 * l_addrlen
								l_s.ce_gets (l_s + 1)
							end
						end
						js.reset
						if not (l_s[0]).to_boolean then
							free (create {CE_POINTER [ANY]}.make_cast (l_respline))
							Result := ({PC_UERR_T}.FTPINVPASV)
							js.return
						else
							l_tmp___5.ce_gets (l_s)
							l_s.ce_gets (l_s + 1)
							if (l_tmp___5[0]).to_integer_32 /= 44 then
								free (create {CE_POINTER [ANY]}.make_cast (l_respline))
								Result := ({PC_UERR_T}.FTPINVPASV)
								js.return
							end
						end
					end
					if not js.return_called and then (l_addrlen > 16) then
						free (create {CE_POINTER [ANY]}.make_cast (l_respline))
						Result := ({PC_UERR_T}.FTPINVPASV)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if l_af /= 4 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_addrlen /= 4 then
							free (create {CE_POINTER [ANY]}.make_cast (l_respline))
							Result := ({PC_UERR_T}.FTPINVPASV)
							js.return
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if l_af = 6 then
							if l_addrlen /= 16 then
								free (create {CE_POINTER [ANY]}.make_cast (l_respline))
								Result := ({PC_UERR_T}.FTPINVPASV)
								js.return
							end
						end
				when 5 then -- if done
						if not js.return_called then
							l_i := 0
							from
							until
								not (not js.loop_left and then (l_i < l_addrlen))
							loop
								l_tmp[l_i] := (0).to_natural_8
								from
								until
									js.loop_left
								loop
									js.reset
									if not (c_ctype_inst.c2_isdigit ((l_s[0]).to_integer_32)) then
										js.break
									end
									if not js.loop_jumped then
										l_tmp[l_i] := (((l_s[0]).to_integer_32 - 48) + 10 * (l_tmp[l_i]).to_integer_32).to_natural_8
										l_s.ce_gets (l_s + 1)
									end
								end
								js.reset
								if (l_s[0]).to_integer_32 = 44 then
									l_s.ce_gets (l_s + 1)
								else
									free (create {CE_POINTER [ANY]}.make_cast (l_respline))
									Result := ({PC_UERR_T}.FTPINVPASV)
									js.return
								end
								if not js.return_called then
									l_i := l_i + 1
								end
							end
						end
						if not js.return_called then
							l_portlen := 0
							from
							until
								js.loop_left
							loop
								js.reset
								if not (c_ctype_inst.c2_isdigit ((l_s[0]).to_integer_32)) then
									js.break
								end
								if not js.loop_jumped then
									l_portlen := ((l_s[0]).to_integer_32 - 48) + 10 * l_portlen
									l_s.ce_gets (l_s + 1)
								end
							end
							js.reset
							if not (l_s[0]).to_boolean then
								free (create {CE_POINTER [ANY]}.make_cast (l_respline))
								Result := ({PC_UERR_T}.FTPINVPASV)
								js.return
							else
								l_tmp___8.ce_gets (l_s)
								l_s.ce_gets (l_s + 1)
								if (l_tmp___8[0]).to_integer_32 /= 44 then
									free (create {CE_POINTER [ANY]}.make_cast (l_respline))
									Result := ({PC_UERR_T}.FTPINVPASV)
									js.return
								end
							end
						end
						if not js.return_called and then (l_portlen > 2) then
							free (create {CE_POINTER [ANY]}.make_cast (l_respline))
							Result := ({PC_UERR_T}.FTPINVPASV)
							js.return
						end
						if not js.return_called then
							l_tmpprt[0] := (0).to_natural_8
							from
							until
								js.loop_left
							loop
								js.reset
								if not (c_ctype_inst.c2_isdigit ((l_s[0]).to_integer_32)) then
									js.break
								end
								if not js.loop_jumped then
									l_tmpprt[0] := (((l_s[0]).to_integer_32 - 48) + 10 * (l_tmpprt[0]).to_integer_32).to_natural_8
									l_s.ce_gets (l_s + 1)
								end
							end
							js.reset
							if not (l_s[0]).to_boolean then
								free (create {CE_POINTER [ANY]}.make_cast (l_respline))
								Result := ({PC_UERR_T}.FTPINVPASV)
								js.return
							else
								l_tmp___10.ce_gets (l_s)
								l_s.ce_gets (l_s + 1)
								if (l_tmp___10[0]).to_integer_32 /= 44 then
									free (create {CE_POINTER [ANY]}.make_cast (l_respline))
									Result := ({PC_UERR_T}.FTPINVPASV)
									js.return
								end
							end
						end
						if not js.return_called then
							l_tmpprt[1] := (0).to_natural_8
							from
							until
								js.loop_left
							loop
								js.reset
								if not (c_ctype_inst.c2_isdigit ((l_s[0]).to_integer_32)) then
									js.break
								end
								if not js.loop_jumped then
									l_tmpprt[1] := (((l_s[0]).to_integer_32 - 48) + 10 * (l_tmpprt[1]).to_integer_32).to_natural_8
									l_s.ce_gets (l_s + 1)
								end
							end
							js.reset
							if (l_s.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								assert_fail (ce_string ("s != ((void *)0)"), ce_string ("ftp-basic.c"), {NATURAL_32} 687, ce_string ("ftp_lpsv"))
							end
							if l_af = 4 then
								a_addr.item.family := 2
								memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_DATA]}.make_shared (a_addr.c_pointer + {PD_IP_ADDRESS}.data_offset))), create {CE_POINTER [ANY]}.make_cast (l_tmp), (4).to_natural_32).do_nothing
								a_port.item := (((((l_tmpprt[0]).to_integer_32).bit_shift_left (8))).bit_and (65280)) + (l_tmpprt[1]).to_integer_32
								from
								until
									js.loop_left
								loop
									js.reset
									if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
										log_inst.debug_logprintf ([ce_string ("lpsv addr is: %%s%N"), (host_inst.print_address (a_addr))])
									end
									js.break
								end
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
										log_inst.debug_logprintf ([ce_string ("tmpprt[0] is: %%d%N"), (l_tmpprt[0]).to_integer_32])
									end
									js.break
								end
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
										log_inst.debug_logprintf ([ce_string ("tmpprt[1] is: %%d%N"), (l_tmpprt[1]).to_integer_32])
									end
									js.break
								end
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
										log_inst.debug_logprintf ([ce_string ("*port is: %%d%N"), a_port.item])
									end
									js.break
								end
								js.reset
							else
								if l_af /= 6 then
									assert_fail (ce_string ("af == 6"), ce_string ("ftp-basic.c"), {NATURAL_32} 701, ce_string ("ftp_lpsv"))
								end
								a_addr.item.family := 10
								memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_DATA]}.make_shared (a_addr.c_pointer + {PD_IP_ADDRESS}.data_offset))), create {CE_POINTER [ANY]}.make_cast (l_tmp), (16).to_natural_32).do_nothing
								a_port.item := (((((l_tmpprt[0]).to_integer_32).bit_shift_left (8))).bit_and (65280)) + (l_tmpprt[1]).to_integer_32
								from
								until
									js.loop_left
								loop
									js.reset
									if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
										log_inst.debug_logprintf ([ce_string ("lpsv addr is: %%s%N"), (host_inst.print_address (a_addr))])
									end
									js.break
								end
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
										log_inst.debug_logprintf ([ce_string ("tmpprt[0] is: %%d%N"), (l_tmpprt[0]).to_integer_32])
									end
									js.break
								end
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
										log_inst.debug_logprintf ([ce_string ("tmpprt[1] is: %%d%N"), (l_tmpprt[1]).to_integer_32])
									end
									js.break
								end
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
										log_inst.debug_logprintf ([ce_string ("*port is: %%d%N"), a_port.item])
									end
									js.break
								end
								js.reset
							end
							free (create {CE_POINTER [ANY]}.make_cast (l_respline))
							Result := ({PC_UERR_T}.FTPOK)
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	ftp_epsv (a_csock: INTEGER_32; a_ip___0: CE_POINTER [PD_IP_ADDRESS]; a_port: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_POINTER [INTEGER_8]
			l_start: CE_POINTER [INTEGER_8]
			l_delim: INTEGER_8
			l_s: CE_POINTER [INTEGER_8]
			l_nwritten: INTEGER_32
			l_i: INTEGER_32
			l_err: INTEGER_32
			l_tport: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_request.make
			create l_respline.make
			create l_start.make
			create l_s.make
			create l_tmp.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___5.make
			create l_tmp___6.make

			if (a_ip___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				assert_fail (ce_string ("ip != ((void *)0)"), ce_string ("ftp-basic.c"), {NATURAL_32} 726, ce_string ("ftp_epsv"))
			end
			if (a_port.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				assert_fail (ce_string ("port != ((void *)0)"), ce_string ("ftp-basic.c"), {NATURAL_32} 727, ce_string ("ftp_epsv"))
			end
			if a_ip___0.item.family = 2 then
				l_tmp.ce_gets (ce_string ("1"))
			else
				l_tmp.ce_gets (ce_string ("2"))
			end
			l_request.ce_gets (ftp_request (ce_string ("EPSV"), l_tmp))
			l_nwritten := connect_inst.fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
			if l_nwritten < 0 then
				free (create {CE_POINTER [ANY]}.make_cast (l_request))
				Result := ({PC_UERR_T}.WRITEFAILED)
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (l_request))
				l_err := ftp_response (a_csock, l_respline.address)
				if l_err.to_natural_32 /= {NATURAL_32} 10 then
					Result := l_err
					js.return
				end
			end
			if not js.return_called and then ((l_respline[0]).to_integer_32 /= 50) then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				Result := ({PC_UERR_T}.FTPNOPASV)
				js.return
			end
			if not js.return_called then
				if (l_respline.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					assert_fail (ce_string ("respline != ((void *)0)"), ce_string ("ftp-basic.c"), {NATURAL_32} 755, ce_string ("ftp_epsv"))
				end
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect ((options_inst.opt.debug2).to_integer, 0)).to_boolean then
						log_inst.debug_logprintf ([ce_string ("respline is %%s%N"), l_respline])
					end
					js.break
				end
				js.reset
				l_s.ce_gets (l_respline)
				l_start.ce_gets (strchr (l_respline, ('(').code))
				if (l_start.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_respline))
					Result := ({PC_UERR_T}.FTPINVPASV)
					js.return
				end
			end
			if not js.return_called then
				l_s.ce_gets (l_start + 1)
				l_tmp___2.ce_gets (l_s)
				l_s.ce_gets (l_s + 1)
				l_delim := l_tmp___2[0]
				if l_delim.to_integer_32 < 33 then
					free (create {CE_POINTER [ANY]}.make_cast (l_respline))
					Result := ({PC_UERR_T}.FTPINVPASV)
					js.return
				elseif l_delim.to_integer_32 > 126 then
					free (create {CE_POINTER [ANY]}.make_cast (l_respline))
					Result := ({PC_UERR_T}.FTPINVPASV)
					js.return
				end
			end
			if not js.return_called then
				l_i := 0
				from
				until
					not (not js.loop_left and then (l_i < 2))
				loop
					l_tmp___3.ce_gets (l_s)
					l_s.ce_gets (l_s + 1)
					if (l_tmp___3[0]).to_integer_32 /= l_delim.to_integer_32 then
						free (create {CE_POINTER [ANY]}.make_cast (l_respline))
						Result := ({PC_UERR_T}.FTPINVPASV)
						js.return
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				l_tport := 0
				l_i := 1
				from
				until
					js.loop_left
				loop
					js.reset
					if not (c_ctype_inst.c2_isdigit ((l_s[0]).to_integer_32)) then
						js.break
					end
					if not js.loop_jumped then
						if l_i > 5 then
							free (create {CE_POINTER [ANY]}.make_cast (l_respline))
							Result := ({PC_UERR_T}.FTPINVPASV)
							js.return
						end
						if not js.return_called then
							l_tport := ((l_s[0]).to_integer_32 - 48) + 10 * l_tport
							l_s.ce_gets (l_s + 1)
						end
					end
				end
				js.reset
			end
			if not js.return_called then
				l_tmp___5.ce_gets (l_s)
				l_s.ce_gets (l_s + 1)
				if (l_tmp___5[0]).to_integer_32 /= l_delim.to_integer_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_respline))
					Result := ({PC_UERR_T}.FTPINVPASV)
					js.return
				end
			end
			if not js.return_called then
				l_tmp___6.ce_gets (l_s)
				l_s.ce_gets (l_s + 1)
				if (l_tmp___6[0]).to_integer_32 /= 41 then
					free (create {CE_POINTER [ANY]}.make_cast (l_respline))
					Result := ({PC_UERR_T}.FTPINVPASV)
					js.return
				end
			end
			if not js.return_called then
				a_port.item := l_tport
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				Result := ({PC_UERR_T}.FTPOK)
			end
		end

	ftp_type (a_csock: INTEGER_32; a_type: INTEGER_32): INTEGER_32
		local
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_POINTER [INTEGER_8]
			l_nwritten: INTEGER_32
			l_err: INTEGER_32
			l_stype: CE_ARRAY [INTEGER_8]
			js: JUMP_STATE
		do
			create l_request.make
			create l_respline.make
			create l_stype.make (<<2>>)

			l_stype[0] := a_type.to_integer_8
			l_stype[1] := (0).to_integer_8
			l_request.ce_gets (ftp_request (ce_string ("TYPE"), l_stype))
			l_nwritten := connect_inst.fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
			if l_nwritten < 0 then
				free (create {CE_POINTER [ANY]}.make_cast (l_request))
				Result := ({PC_UERR_T}.WRITEFAILED)
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (l_request))
				l_err := ftp_response (a_csock, l_respline.address)
				if l_err.to_natural_32 /= {NATURAL_32} 10 then
					Result := l_err
					js.return
				end
			end
			if not js.return_called and then ((l_respline[0]).to_integer_32 /= 50) then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				Result := ({PC_UERR_T}.FTPUNKNOWNTYPE)
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				Result := ({PC_UERR_T}.FTPOK)
			end
		end

	ftp_cwd (a_csock: INTEGER_32; a_dir: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_POINTER [INTEGER_8]
			l_nwritten: INTEGER_32
			l_err: INTEGER_32
			js: JUMP_STATE
		do
			create l_request.make
			create l_respline.make

			l_request.ce_gets (ftp_request (ce_string ("CWD"), a_dir))
			l_nwritten := connect_inst.fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
			if l_nwritten < 0 then
				free (create {CE_POINTER [ANY]}.make_cast (l_request))
				Result := ({PC_UERR_T}.WRITEFAILED)
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (l_request))
				l_err := ftp_response (a_csock, l_respline.address)
				if l_err.to_natural_32 /= {NATURAL_32} 10 then
					Result := l_err
					js.return
				end
			end
			if not js.return_called and then ((l_respline[0]).to_integer_32 = 53) then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				Result := ({PC_UERR_T}.FTPNSFOD)
				js.return
			end
			if not js.return_called and then ((l_respline[0]).to_integer_32 /= 50) then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				Result := ({PC_UERR_T}.FTPRERR)
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				Result := ({PC_UERR_T}.FTPOK)
			end
		end

	ftp_rest (a_csock: INTEGER_32; a_offset: INTEGER_64): INTEGER_32
		local
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_POINTER [INTEGER_8]
			l_nwritten: INTEGER_32
			l_err: INTEGER_32
			js: JUMP_STATE
		do
			create l_request.make
			create l_respline.make

			l_request.ce_gets (ftp_request (ce_string ("REST"), (utils_inst.number_to_static_string (a_offset))))
			l_nwritten := connect_inst.fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
			if l_nwritten < 0 then
				free (create {CE_POINTER [ANY]}.make_cast (l_request))
				Result := ({PC_UERR_T}.WRITEFAILED)
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (l_request))
				l_err := ftp_response (a_csock, l_respline.address)
				if l_err.to_natural_32 /= {NATURAL_32} 10 then
					Result := l_err
					js.return
				end
			end
			if not js.return_called and then ((l_respline[0]).to_integer_32 /= 51) then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				Result := ({PC_UERR_T}.FTPRESTFAIL)
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				Result := ({PC_UERR_T}.FTPOK)
			end
		end

	ftp_retr (a_csock: INTEGER_32; a_file: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_POINTER [INTEGER_8]
			l_nwritten: INTEGER_32
			l_err: INTEGER_32
			js: JUMP_STATE
		do
			create l_request.make
			create l_respline.make

			l_request.ce_gets (ftp_request (ce_string ("RETR"), a_file))
			l_nwritten := connect_inst.fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
			if l_nwritten < 0 then
				free (create {CE_POINTER [ANY]}.make_cast (l_request))
				Result := ({PC_UERR_T}.WRITEFAILED)
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (l_request))
				l_err := ftp_response (a_csock, l_respline.address)
				if l_err.to_natural_32 /= {NATURAL_32} 10 then
					Result := l_err
					js.return
				end
			end
			if not js.return_called and then ((l_respline[0]).to_integer_32 = 53) then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				Result := ({PC_UERR_T}.FTPNSFOD)
				js.return
			end
			if not js.return_called and then ((l_respline[0]).to_integer_32 /= 49) then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				Result := ({PC_UERR_T}.FTPRERR)
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				Result := ({PC_UERR_T}.FTPOK)
			end
		end

	ftp_list (a_csock: INTEGER_32; a_file: CE_POINTER [INTEGER_8]; a_rs: INTEGER_32): INTEGER_32
		local
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_POINTER [INTEGER_8]
			l_nwritten: INTEGER_32
			l_err: INTEGER_32
			l_ok: BOOLEAN
			l_i: NATURAL_32
			l_list_commands: CE_ARRAY [CE_POINTER [INTEGER_8]]
			js: JUMP_STATE
		do
			create l_request.make
			create l_respline.make
			create l_list_commands.make (<<2>>)

			l_ok := (0).to_boolean
			l_i := (0).to_natural_32
			l_list_commands[0] := ce_string ("LIST -a")
			l_list_commands[1] := ce_string ("LIST")
			if a_rs.to_natural_32 = {NATURAL_32} 1 then
				l_i := (Pointer_bytes.to_natural_32 * (2).to_natural_32) // Pointer_bytes.to_natural_32 - {NATURAL_32} 1
			end
			from
			until
				js.loop_left
			loop
				js.reset
				l_request.ce_gets (ftp_request (l_list_commands[l_i.to_integer_32], a_file))
				l_nwritten := connect_inst.fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
				if l_nwritten < 0 then
					free (create {CE_POINTER [ANY]}.make_cast (l_request))
					Result := ({PC_UERR_T}.WRITEFAILED)
					js.return
				end
				if not js.return_called then
					free (create {CE_POINTER [ANY]}.make_cast (l_request))
					l_err := ftp_response (a_csock, l_respline.address)
					if l_err.to_natural_32 = {NATURAL_32} 10 then
						if (l_respline[0]).to_integer_32 = 53 then
							l_err := {PC_UERR_T}.FTPNSFOD
						elseif (l_respline[0]).to_integer_32 = 49 then
							l_err := {PC_UERR_T}.FTPOK
							l_ok := (1).to_boolean
						else
							l_err := {PC_UERR_T}.FTPRERR
						end
						free (create {CE_POINTER [ANY]}.make_cast (l_respline))
					end
					l_i := l_i + 1
					if l_i < (Pointer_bytes.to_natural_32 * (2).to_natural_32) // Pointer_bytes.to_natural_32 then
						if l_ok then
							js.break
						end
					else
						js.break
					end
				end
			end
			js.reset
			if not js.return_called then
				Result := l_err
			end
		end

	ftp_syst (a_csock: INTEGER_32; a_server_type: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_POINTER [INTEGER_8]
			l_nwritten: INTEGER_32
			l_err: INTEGER_32
			js: JUMP_STATE
		do
			create l_request.make
			create l_respline.make

			l_request.ce_gets (ftp_request (ce_string ("SYST"), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)))
			l_nwritten := connect_inst.fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
			if l_nwritten < 0 then
				free (create {CE_POINTER [ANY]}.make_cast (l_request))
				Result := ({PC_UERR_T}.WRITEFAILED)
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (l_request))
				l_err := ftp_response (a_csock, l_respline.address)
				if l_err.to_natural_32 /= {NATURAL_32} 10 then
					Result := l_err
					js.return
				end
			end
			if not js.return_called and then ((l_respline[0]).to_integer_32 = 53) then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				Result := ({PC_UERR_T}.FTPSRVERR)
				js.return
			end
			if not js.return_called then
				strtok (l_respline, ce_string (" ")).do_nothing
				l_request.ce_gets (strtok (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string (" ")))
				if (l_request.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					a_server_type.item := {PC_STYPE}.ST_OTHER
				elseif (strcasecmp (l_request, ce_string ("VMS"))).to_boolean then
					if (strcasecmp (l_request, ce_string ("UNIX"))).to_boolean then
						if (strcasecmp (l_request, ce_string ("WINDOWS_NT"))).to_boolean then
							if (strcasecmp (l_request, ce_string ("WINDOWS2000"))).to_boolean then
								if (strcasecmp (l_request, ce_string ("MACOS"))).to_boolean then
									if (strcasecmp (l_request, ce_string ("OS/400"))).to_boolean then
										a_server_type.item := {PC_STYPE}.ST_OTHER
									else
										a_server_type.item := {PC_STYPE}.ST_OS400
									end
								else
									a_server_type.item := {PC_STYPE}.ST_MACOS
								end
							else
								a_server_type.item := {PC_STYPE}.ST_WINNT
							end
						else
							a_server_type.item := {PC_STYPE}.ST_WINNT
						end
					else
						a_server_type.item := {PC_STYPE}.ST_UNIX
					end
				else
					a_server_type.item := {PC_STYPE}.ST_VMS
				end
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				Result := ({PC_UERR_T}.FTPOK)
			end
		end

	ftp_pwd (a_csock: INTEGER_32; a_pwd: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_POINTER [INTEGER_8]
			l_nwritten: INTEGER_32
			l_err: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_request.make
			create l_respline.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_request.ce_gets (ftp_request (ce_string ("PWD"), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)))
					l_nwritten := connect_inst.fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
					if l_nwritten < 0 then
						free (create {CE_POINTER [ANY]}.make_cast (l_request))
						Result := ({PC_UERR_T}.WRITEFAILED)
						js.return
					end
					if not js.return_called then
						free (create {CE_POINTER [ANY]}.make_cast (l_request))
						l_err := ftp_response (a_csock, l_respline.address)
						if l_err.to_natural_32 /= {NATURAL_32} 10 then
							Result := l_err
							js.return
						end
					end
					if not (not js.return_called and then ((l_respline[0]).to_integer_32 = 53)) then
						l_pos := -1 + 2 -- skip if block
					end
				when 1 then -- if: | err:
						free (create {CE_POINTER [ANY]}.make_cast (l_respline))
						Result := ({PC_UERR_T}.FTPSRVERR)
						js.return
				when 2 then -- if done
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 3 then -- if:
						strtok (l_respline, ce_string ("%"")).do_nothing
						l_request.ce_gets (strtok (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("%"")))
						if (l_request).c_pointer = default_pointer then
							l_pos := -1 + 1 -- goto err
						end
				when 4 then
						if ((a_pwd.item).c_pointer /= default_pointer) then
							free (create {CE_POINTER [ANY]}.make_cast (a_pwd.item))
						end
						a_pwd.item := xmalloc_inst.xstrdup (l_request)
						free (create {CE_POINTER [ANY]}.make_cast (l_respline))
						Result := ({PC_UERR_T}.FTPOK)
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_size (a_csock: INTEGER_32; a_file: CE_POINTER [INTEGER_8]; a_size: CE_POINTER [INTEGER_64]): INTEGER_32
		local
			l_request: CE_POINTER [INTEGER_8]
			l_respline: CE_POINTER [INTEGER_8]
			l_nwritten: INTEGER_32
			l_err: INTEGER_32
			js: JUMP_STATE
		do
			create l_request.make
			create l_respline.make

			l_request.ce_gets (ftp_request (ce_string ("SIZE"), a_file))
			l_nwritten := connect_inst.fd_write (a_csock, l_request, (strlen (l_request)).to_integer_32, (-1).to_double)
			if l_nwritten < 0 then
				free (create {CE_POINTER [ANY]}.make_cast (l_request))
				a_size.item := (0).to_integer_64
				Result := ({PC_UERR_T}.WRITEFAILED)
				js.return
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (l_request))
				l_err := ftp_response (a_csock, l_respline.address)
				if l_err.to_natural_32 /= {NATURAL_32} 10 then
					a_size.item := (0).to_integer_64
					Result := l_err
					js.return
				end
			end
			if not js.return_called and then ((l_respline[0]).to_integer_32 = 53) then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				a_size.item := (0).to_integer_64
				Result := ({PC_UERR_T}.FTPOK)
				js.return
			end
			if not js.return_called then
				(errno_location).item := 0
				a_size.item := strtoll ((l_respline + 4), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), 10)
				if ((errno_location).item).to_boolean then
					free (create {CE_POINTER [ANY]}.make_cast (l_respline))
					a_size.item := (0).to_integer_64
					Result := ({PC_UERR_T}.FTPOK)
					js.return
				end
			end
			if not js.return_called then
				free (create {CE_POINTER [ANY]}.make_cast (l_respline))
				Result := ({PC_UERR_T}.FTPOK)
			end
		end

	ftp_process_type (a_params: CE_POINTER [INTEGER_8]): INTEGER_8
		do
			if ((a_params).c_pointer /= default_pointer) then
				if 0 = (strncasecmp (a_params, ce_string ("type="), (5).to_natural_32)) then
					if (a_params[5]).to_integer_32 /= 0 then
						Result := (c_ctype_inst.c2_toupper ((a_params[5]).to_integer_32)).to_integer_8
					else
						Result := (('I').code).to_integer_8
					end
				else
					Result := (('I').code).to_integer_8
				end
			else
				Result := (('I').code).to_integer_8
			end
		end

end
