class
	P_HTML_PARSE

inherit
	WGET_DATA
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {ANY} -- routines

	tagstack_push (a_head: CE_POINTER [CE_POINTER [PD_TAGSTACK_ITEM]]; a_tail: CE_POINTER [CE_POINTER [PD_TAGSTACK_ITEM]]): CE_POINTER [PD_TAGSTACK_ITEM]
		local
			l_ts: CE_POINTER [PD_TAGSTACK_ITEM]
			l_tmp___0: CE_POINTER [PD_TAGSTACK_ITEM]
			l_tmp___1: CE_POINTER [PD_TAGSTACK_ITEM]
		do
			create l_ts.make
			create l_tmp___0.make
			create l_tmp___1.make

			l_ts.ce_gets (create {CE_POINTER [PD_TAGSTACK_ITEM]}.make_cast ((xmalloc_inst.xmalloc ({PD_TAGSTACK_ITEM}.sizeof.to_natural_32))))
			if ((a_head.item).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_tmp___0.ce_gets (l_ts)
				a_tail.item := l_tmp___0
				a_head.item := l_tmp___0
				l_tmp___1.ce_gets (create {CE_POINTER [PD_TAGSTACK_ITEM]}.make_shared (default_pointer))
				l_ts.item.next := l_tmp___1
				l_ts.item.prev := l_tmp___1
			else
				(a_tail.item).item.next := l_ts
				l_ts.item.prev := a_tail.item
				a_tail.item := l_ts
				l_ts.item.next := create {CE_POINTER [PD_TAGSTACK_ITEM]}.make_shared (default_pointer)
			end
			Result := l_ts
		end

	tagstack_pop (a_head: CE_POINTER [CE_POINTER [PD_TAGSTACK_ITEM]]; a_tail: CE_POINTER [CE_POINTER [PD_TAGSTACK_ITEM]]; a_ts: CE_POINTER [PD_TAGSTACK_ITEM])
		local
			l_ts: CE_POINTER [PD_TAGSTACK_ITEM]
			l_tmp: CE_POINTER [PD_TAGSTACK_ITEM]
			l_p___0: CE_POINTER [PD_TAGSTACK_ITEM]
			js: JUMP_STATE
		do
			create l_ts.make
			create l_tmp.make
			create l_p___0.make

			l_ts.ce_gets (a_ts)
			if ((a_head.item).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				if (l_ts.c_pointer.to_integer_32).to_natural_32 = ((a_tail.item).c_pointer.to_integer_32).to_natural_32 then
					if (l_ts.c_pointer.to_integer_32).to_natural_32 = ((a_head.item).c_pointer.to_integer_32).to_natural_32 then
						free (create {CE_POINTER [ANY]}.make_cast (l_ts))
						l_tmp.ce_gets (create {CE_POINTER [PD_TAGSTACK_ITEM]}.make_shared (default_pointer))
						a_tail.item := l_tmp
						a_head.item := l_tmp
					else
						(l_ts.item.prev).item.next := create {CE_POINTER [PD_TAGSTACK_ITEM]}.make_shared (default_pointer)
						a_tail.item := l_ts.item.prev
						free (create {CE_POINTER [ANY]}.make_cast (l_ts))
					end
				else
					if (l_ts.c_pointer.to_integer_32).to_natural_32 = ((a_head.item).c_pointer.to_integer_32).to_natural_32 then
						a_head.item := create {CE_POINTER [PD_TAGSTACK_ITEM]}.make_shared (default_pointer)
					end
					a_tail.item := l_ts.item.prev
					if ((l_ts.item.prev).c_pointer /= default_pointer) then
						(l_ts.item.prev).item.next := create {CE_POINTER [PD_TAGSTACK_ITEM]}.make_shared (default_pointer)
					end
					from
					until
						(l_ts).c_pointer = default_pointer
					loop
						l_p___0.ce_gets (l_ts.item.next)
						free (create {CE_POINTER [ANY]}.make_cast (l_ts))
						l_ts.ce_gets (l_p___0)
					end
				end
			end
		end

	tagstack_find (a_tail: CE_POINTER [PD_TAGSTACK_ITEM]; a_tagname_begin: CE_POINTER [INTEGER_8]; a_tagname_end: CE_POINTER [INTEGER_8]): CE_POINTER [PD_TAGSTACK_ITEM]
		local
			l_tail: CE_POINTER [PD_TAGSTACK_ITEM]
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			create l_tail.make

			l_tail.ce_gets (a_tail)
			l_len := a_tagname_end.distance (a_tagname_begin)
			from
			until
				not (not js.loop_left and then ((l_tail).c_pointer /= default_pointer))
			loop
				if l_len = (l_tail.item.tagname_end).distance ((l_tail.item.tagname_begin)) then
					if 0 = (strncasecmp (l_tail.item.tagname_begin, a_tagname_begin, l_len.to_natural_32)) then
						Result := l_tail
						js.return
					end
				end
				if not js.return_called then
					l_tail.ce_gets (l_tail.item.prev)
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [PD_TAGSTACK_ITEM]}.make_shared (default_pointer))
			end
		end

	decode_entity (a_ptr: CE_POINTER [CE_POINTER [INTEGER_8]]; a_end: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_value: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_digits: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_tmp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (a_ptr.item)
					l_value := -1
					l_p___0.ce_gets (l_p___0 + 1)
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (a_end.c_pointer.to_integer_32).to_natural_32 then
						Result := (-1)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 41 -- skip if block
					end
				when 1 then -- if:
						l_tmp.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						inspect (l_tmp[0]).to_integer_32 -- switch 1 head
						when 35 then l_pos := -1 + 2
						when 103 then l_pos := -1 + 3
						when 108 then l_pos := -1 + 11
						when 97 then l_pos := -1 + 18
						when 113 then l_pos := -1 + 34
						else l_pos := -1 + 41
						end
				when 2 then -- switch 1, case 35
						l_digits := 0
						l_value := 0
						if (l_p___0[0]).to_integer_32 = 120 then
							l_p___0.ce_gets (l_p___0 + 1)
							from
							until
								js.loop_left
							loop
								js.reset
								if l_value < 256 then
									if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32 then
										if not (c_ctype_inst.c2_isxdigit ((l_p___0[0]).to_integer_32)) then
											js.break
										end
									else
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									if (l_p___0[0]).to_integer_32 < 65 then
										l_tmp___1 := (l_p___0[0]).to_integer_32 - 48
									else
										l_tmp___1 := (((c_ctype_inst.c2_toupper ((l_p___0[0]).to_integer_32)) - 65) + 10)
									end
									l_value := ((l_value).bit_shift_left (4)) + l_tmp___1
									l_p___0.ce_gets (l_p___0 + 1)
									l_digits := l_digits + 1
								end
							end
							js.reset
						else
							from
							until
								js.loop_left
							loop
								js.reset
								if l_value < 256 then
									if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32 then
										if not (c_ctype_inst.c2_isdigit ((l_p___0[0]).to_integer_32)) then
											js.break
										end
									else
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_value := l_value * 10 + ((l_p___0[0]).to_integer_32 - 48)
									l_p___0.ce_gets (l_p___0 + 1)
									l_digits := l_digits + 1
								end
							end
							js.reset
						end
						if not l_digits.to_boolean then
							Result := (-1)
							js.return
						end
						if not js.return_called then
							if not l_value.to_boolean then
								Result := (-1)
								js.return
							elseif ((l_value).bit_and (-128)).to_boolean then
								Result := (-1)
								js.return
							end
						end
						if not js.return_called then
							l_p___0.ce_gets (l_p___0 + (0))
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32 then
								if (l_p___0[0]).to_integer_32 = 59 then
									l_p___0.ce_gets (l_p___0 + 1)
									a_ptr.item := l_p___0
								else
									a_ptr.item := l_p___0
								end
							else
								a_ptr.item := l_p___0
							end
							Result := l_value
							js.return
						end
				when 3 then -- switch 1, case 103
						if js.return_called then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if:
						if ((l_p___0 + 1).c_pointer.to_integer_32).to_natural_32 /= (a_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 7 then -- else:
						if not (((l_p___0 + 1).c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if (c_ctype_inst.c2_isalnum ((l_p___0[1]).to_integer_32)) then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						if (l_p___0[0]).to_integer_32 = 116 then
							l_value := ('>').code
							l_p___0.ce_gets (l_p___0 + 1)
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32 then
								if (l_p___0[0]).to_integer_32 = 59 then
									l_p___0.ce_gets (l_p___0 + 1)
									a_ptr.item := l_p___0
								else
									a_ptr.item := l_p___0
								end
							else
								a_ptr.item := l_p___0
							end
						end
				when 10 then -- if done | if done | if done
						l_pos := -1 + 41 -- switch 1; break
				when 11 then -- switch 1, case 108
						if ((l_p___0 + 1).c_pointer.to_integer_32).to_natural_32 /= (a_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 16 -- goto _L___0
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 14 then -- else:
						if not (((l_p___0 + 1).c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if (c_ctype_inst.c2_isalnum ((l_p___0[1]).to_integer_32)) then
							l_pos := -1 + 17 -- skip if block
						end
				when 16 then -- if: | _L___0:
						if (l_p___0[0]).to_integer_32 = 116 then
							l_value := ('<').code
							l_p___0.ce_gets (l_p___0 + 1)
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32 then
								if (l_p___0[0]).to_integer_32 = 59 then
									l_p___0.ce_gets (l_p___0 + 1)
									a_ptr.item := l_p___0
								else
									a_ptr.item := l_p___0
								end
							else
								a_ptr.item := l_p___0
							end
						end
				when 17 then -- if done | if done
						l_pos := -1 + 41 -- switch 1; break
				when 18 then -- switch 1, case 97
						if ((l_p___0 + 2).c_pointer.to_integer_32).to_natural_32 /= (a_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 25 -- goto _L___4
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 21 then -- else:
						if not (((l_p___0 + 2).c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 27 -- skip if block
						end
				when 22 then -- if:
						if not (c_ctype_inst.c2_isalnum ((l_p___0[2]).to_integer_32)) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 27 -- goto _L___5
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else: | _L___4:
						if (l_p___0[0]).to_integer_32 = 109 then
							if (l_p___0[1]).to_integer_32 = 112 then
								l_value := ('&').code
								l_p___0.ce_gets (l_p___0 + (2))
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32 then
									if (l_p___0[0]).to_integer_32 = 59 then
										l_p___0.ce_gets (l_p___0 + 1)
										a_ptr.item := l_p___0
									else
										a_ptr.item := l_p___0
									end
								else
									a_ptr.item := l_p___0
								end
							else
								l_pos := -1 + 27 -- goto _L___5
							end
						else
							l_pos := -1 + 27 -- goto _L___5
						end
				when 26 then -- if done | if block done, skip else block:
						l_pos := -1 + 33
				when 27 then -- else: | _L___5:
						if ((l_p___0 + 3).c_pointer.to_integer_32).to_natural_32 /= (a_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						l_pos := -1 + 32 -- goto _L___1
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 30 then -- else:
						if not (((l_p___0 + 3).c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						if (c_ctype_inst.c2_isalnum ((l_p___0[3]).to_integer_32)) then
							l_pos := -1 + 33 -- skip if block
						end
				when 32 then -- if: | _L___1:
						if (l_p___0[0]).to_integer_32 = 112 then
							if (l_p___0[1]).to_integer_32 = 111 then
								if (l_p___0[2]).to_integer_32 = 115 then
									l_value := ('%'').code
									l_p___0.ce_gets (l_p___0 + (3))
									if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32 then
										if (l_p___0[0]).to_integer_32 = 59 then
											l_p___0.ce_gets (l_p___0 + 1)
											a_ptr.item := l_p___0
										else
											a_ptr.item := l_p___0
										end
									else
										a_ptr.item := l_p___0
									end
								end
							end
						end
				when 33 then -- if done | if done | if done | if done
						l_pos := -1 + 41 -- switch 1; break
				when 34 then -- switch 1, case 113
						if ((l_p___0 + 3).c_pointer.to_integer_32).to_natural_32 /= (a_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						l_pos := -1 + 39 -- goto _L___6
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 40
				when 37 then -- else:
						if not (((l_p___0 + 3).c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						if (c_ctype_inst.c2_isalnum ((l_p___0[3]).to_integer_32)) then
							l_pos := -1 + 40 -- skip if block
						end
				when 39 then -- if: | _L___6:
						if (l_p___0[0]).to_integer_32 = 117 then
							if (l_p___0[1]).to_integer_32 = 111 then
								if (l_p___0[2]).to_integer_32 = 116 then
									l_value := ('%"').code
									l_p___0.ce_gets (l_p___0 + (3))
									if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32 then
										if (l_p___0[0]).to_integer_32 = 59 then
											l_p___0.ce_gets (l_p___0 + 1)
											a_ptr.item := l_p___0
										else
											a_ptr.item := l_p___0
										end
									else
										a_ptr.item := l_p___0
									end
								end
							end
						end
				when 40 then -- if done | if done
						l_pos := -1 + 41 -- switch 1; break
				when 41 then -- switch 1, done: | if done
						if not js.return_called then
							Result := l_value
						end
				when 42 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	convert_and_copy (a_pool: CE_POINTER [PD_POOL]; a_beg: CE_POINTER [INTEGER_8]; a_end: CE_POINTER [INTEGER_8]; a_flags: INTEGER_32)
		local
			l_beg: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
			l_old_tail: INTEGER_32
			l_from: CE_POINTER [INTEGER_8]
			l_to: CE_POINTER [INTEGER_8]
			l_squash_newlines: BOOLEAN
			l_ga_needed_size: INTEGER_32
			l_ga_newsize: INTEGER_32
			l_ga_new: CE_POINTER [ANY]
			l_entity: INTEGER_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_PAC_char: INTEGER_8
			l_ga_needed_size___0: INTEGER_32
			l_ga_newsize___0: INTEGER_32
			l_ga_new___0: CE_POINTER [ANY]
			l_tmp___11: INTEGER_32
			l_PA_beg: CE_POINTER [INTEGER_8]
			l_PA_size: INTEGER_32
			l_ga_needed_size___1: INTEGER_32
			l_ga_newsize___1: INTEGER_32
			l_ga_new___1: CE_POINTER [ANY]
			l_PAC_char___0: INTEGER_8
			l_ga_needed_size___2: INTEGER_32
			l_ga_newsize___2: INTEGER_32
			l_ga_new___2: CE_POINTER [ANY]
			l_tmp___16: INTEGER_32
			l_p___0: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_beg.make
			create l_end.make
			create l_from.make
			create l_to.make
			create l_ga_new.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___7.make
			create l_tmp___8.make
			create l_ga_new___0.make
			create l_PA_beg.make
			create l_ga_new___1.make
			create l_ga_new___2.make
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_beg.ce_gets (a_beg)
					l_end.ce_gets (a_end)
					l_old_tail := a_pool.item.tail
					if ((a_flags).bit_and (4)).to_boolean then
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_beg.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
								if not (c_ctype_inst.c2_isspace ((l_beg[0]).to_integer_32)) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_beg.ce_gets (l_beg + 1)
							end
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							if (l_end.c_pointer.to_integer_32).to_natural_32 > (l_beg.c_pointer.to_integer_32).to_natural_32 then
								if not (c_ctype_inst.c2_isspace ((l_end[-1]).to_integer_32)) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_end.ce_gets (l_end - 1)
							end
						end
						js.reset
					end
					if not (((a_flags).bit_and (2)).to_boolean) then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:
						l_from.ce_gets (l_beg)
						l_squash_newlines := (((a_flags).bit_and (4)).to_boolean)
						from
						until
							js.loop_left
						loop
							js.reset
							l_ga_needed_size := (a_pool.item.tail + (l_end.distance (l_beg))).to_integer_32
							l_ga_newsize := (a_pool.item.size).to_integer_32
							from
							until
								not (l_ga_newsize < l_ga_needed_size)
							loop
								l_ga_newsize := (l_ga_newsize).bit_shift_left ((1))
							end
							if l_ga_newsize /= (a_pool.item.size).to_integer_32 then
								if a_pool.item.resized then
									a_pool.item.contents := create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (a_pool.item.contents), (l_ga_newsize.to_natural_32 * (Integer_8_bytes.to_natural_32).to_natural_32).to_natural_32)))
								else
									l_ga_new.ce_gets ((xmalloc_inst.xmalloc ((l_ga_newsize.to_natural_32 * (Integer_8_bytes.to_natural_32).to_natural_32).to_natural_32)))
									memcpy (l_ga_new, create {CE_POINTER [ANY]}.make_cast (a_pool.item.contents), (a_pool.item.size).to_natural_32 * Integer_8_bytes.to_natural_32).do_nothing
									a_pool.item.contents := create {CE_POINTER [INTEGER_8]}.make_cast (l_ga_new)
									a_pool.item.resized := (1).to_boolean
								end
								a_pool.item.size := l_ga_newsize.to_integer_32
							end
							js.break
						end
						js.reset
						l_to.ce_gets (a_pool.item.contents + a_pool.item.tail)
				when 2 then -- loop condition:
						if not ((l_from.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 14 -- skip loop
						end
				when 3 then -- loop body:
						if (l_from[0]).to_integer_32 /= 38 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_entity := (decode_entity (l_from.address, l_end))
						if l_entity /= -1 then
							l_tmp___4.ce_gets (l_to)
							l_to.ce_gets (l_to + 1)
							l_tmp___4[0] := l_entity.to_integer_8
						else
							l_tmp___5.ce_gets (l_to)
							l_to.ce_gets (l_to + 1)
							l_tmp___6.ce_gets (l_from)
							l_from.ce_gets (l_from + 1)
							l_tmp___5[0] := l_tmp___6[0]
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if (l_from[0]).to_integer_32 /= 10 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if (l_from[0]).to_integer_32 /= 13 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L:
						if l_squash_newlines then
							l_from.ce_gets (l_from + 1)
						else
							l_tmp___7.ce_gets (l_to)
							l_to.ce_gets (l_to + 1)
							l_tmp___8.ce_gets (l_from)
							l_from.ce_gets (l_from + 1)
							l_tmp___7[0] := l_tmp___8[0]
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						l_tmp___7.ce_gets (l_to)
						l_to.ce_gets (l_to + 1)
						l_tmp___8.ce_gets (l_from)
						l_from.ce_gets (l_from + 1)
						l_tmp___7[0] := l_tmp___8[0]
				when 13 then -- if done | if done
						l_pos := -1 + 2 -- back to loop condition
				when 14 then -- loop done
						if not (l_to.distance ((a_pool.item.contents + a_pool.item.tail)) <= l_end.distance (l_beg)) then
							assert_fail (ce_string ("to - (pool->contents + pool->tail) <= end - beg"), ce_string ("html-parse.c"), {NATURAL_32} 499, ce_string ("convert_and_copy"))
						end
						a_pool.item.tail := l_to.distance ((a_pool.item.contents))
						from
						until
							js.loop_left
						loop
							js.reset
							l_PAC_char := (('%/0/').code).to_integer_8
							from
							until
								js.loop_left
							loop
								js.reset
								l_ga_needed_size___0 := (a_pool.item.tail + 1).to_integer_32
								l_ga_newsize___0 := (a_pool.item.size).to_integer_32
								from
								until
									not (l_ga_newsize___0 < l_ga_needed_size___0)
								loop
									l_ga_newsize___0 := (l_ga_newsize___0).bit_shift_left ((1))
								end
								if l_ga_newsize___0 /= (a_pool.item.size).to_integer_32 then
									if a_pool.item.resized then
										a_pool.item.contents := create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (a_pool.item.contents), (l_ga_newsize___0.to_natural_32 * (Integer_8_bytes.to_natural_32).to_natural_32).to_natural_32)))
									else
										l_ga_new___0.ce_gets ((xmalloc_inst.xmalloc ((l_ga_newsize___0.to_natural_32 * (Integer_8_bytes.to_natural_32).to_natural_32).to_natural_32)))
										memcpy (l_ga_new___0, create {CE_POINTER [ANY]}.make_cast (a_pool.item.contents), (a_pool.item.size).to_natural_32 * Integer_8_bytes.to_natural_32).do_nothing
										a_pool.item.contents := create {CE_POINTER [INTEGER_8]}.make_cast (l_ga_new___0)
										a_pool.item.resized := (1).to_boolean
									end
									a_pool.item.size := l_ga_newsize___0.to_integer_32
								end
								js.break
							end
							js.reset
							l_tmp___11 := a_pool.item.tail
							a_pool.item.tail := (a_pool.item.tail) + 1
							a_pool.item.contents[l_tmp___11] := l_PAC_char
							js.break
						end
						js.reset
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						from
						until
							js.loop_left
						loop
							js.reset
							l_PA_beg.ce_gets (l_beg)
							l_PA_size := l_end.distance (l_PA_beg)
							from
							until
								js.loop_left
							loop
								js.reset
								l_ga_needed_size___1 := (a_pool.item.tail + l_PA_size).to_integer_32
								l_ga_newsize___1 := (a_pool.item.size).to_integer_32
								from
								until
									not (l_ga_newsize___1 < l_ga_needed_size___1)
								loop
									l_ga_newsize___1 := (l_ga_newsize___1).bit_shift_left ((1))
								end
								if l_ga_newsize___1 /= (a_pool.item.size).to_integer_32 then
									if a_pool.item.resized then
										a_pool.item.contents := create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (a_pool.item.contents), (l_ga_newsize___1.to_natural_32 * (Integer_8_bytes.to_natural_32).to_natural_32).to_natural_32)))
									else
										l_ga_new___1.ce_gets ((xmalloc_inst.xmalloc ((l_ga_newsize___1.to_natural_32 * (Integer_8_bytes.to_natural_32).to_natural_32).to_natural_32)))
										memcpy (l_ga_new___1, create {CE_POINTER [ANY]}.make_cast (a_pool.item.contents), (a_pool.item.size).to_natural_32 * Integer_8_bytes.to_natural_32).do_nothing
										a_pool.item.contents := create {CE_POINTER [INTEGER_8]}.make_cast (l_ga_new___1)
										a_pool.item.resized := (1).to_boolean
									end
									a_pool.item.size := l_ga_newsize___1.to_integer_32
								end
								js.break
							end
							js.reset
							memcpy (create {CE_POINTER [ANY]}.make_cast ((a_pool.item.contents + a_pool.item.tail)), create {CE_POINTER [ANY]}.make_cast (l_PA_beg), l_PA_size.to_natural_32).do_nothing
							a_pool.item.tail := a_pool.item.tail + l_PA_size
							js.break
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							l_PAC_char___0 := (('%/0/').code).to_integer_8
							from
							until
								js.loop_left
							loop
								js.reset
								l_ga_needed_size___2 := (a_pool.item.tail + 1).to_integer_32
								l_ga_newsize___2 := (a_pool.item.size).to_integer_32
								from
								until
									not (l_ga_newsize___2 < l_ga_needed_size___2)
								loop
									l_ga_newsize___2 := (l_ga_newsize___2).bit_shift_left ((1))
								end
								if l_ga_newsize___2 /= (a_pool.item.size).to_integer_32 then
									if a_pool.item.resized then
										a_pool.item.contents := create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (a_pool.item.contents), (l_ga_newsize___2.to_natural_32 * (Integer_8_bytes.to_natural_32).to_natural_32).to_natural_32)))
									else
										l_ga_new___2.ce_gets ((xmalloc_inst.xmalloc ((l_ga_newsize___2.to_natural_32 * (Integer_8_bytes.to_natural_32).to_natural_32).to_natural_32)))
										memcpy (l_ga_new___2, create {CE_POINTER [ANY]}.make_cast (a_pool.item.contents), (a_pool.item.size).to_natural_32 * Integer_8_bytes.to_natural_32).do_nothing
										a_pool.item.contents := create {CE_POINTER [INTEGER_8]}.make_cast (l_ga_new___2)
										a_pool.item.resized := (1).to_boolean
									end
									a_pool.item.size := l_ga_newsize___2.to_integer_32
								end
								js.break
							end
							js.reset
							l_tmp___16 := a_pool.item.tail
							a_pool.item.tail := (a_pool.item.tail) + 1
							a_pool.item.contents[l_tmp___16] := l_PAC_char___0
							js.break
						end
						js.reset
				when 17 then -- if done
					if ((a_flags).bit_and (1)).to_boolean then
						l_p___0.ce_gets (a_pool.item.contents + l_old_tail)
						from
						until
							not ((l_p___0[0]).to_boolean)
						loop
							l_p___0[0] := (c_ctype_inst.c2_tolower ((l_p___0[0]).to_integer_32)).to_integer_8
							l_p___0.ce_gets (l_p___0 + 1)
						end
					end
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	advance_declaration (a_beg: CE_POINTER [INTEGER_8]; a_end: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_quote_char: INTEGER_8
			l_ch: INTEGER_8
			l_state: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___7.make
			create l_tmp___8.make
			create l_tmp___9.make
			create l_tmp___10.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (a_beg)
					l_quote_char := (('%/0/').code).to_integer_8
					l_state := {PC_STATE}.AC_S_BANG
					if (a_beg.c_pointer.to_integer_32).to_natural_32 = (a_end.c_pointer.to_integer_32).to_natural_32 then
						Result := a_beg
						js.return
					end
					if js.return_called then
						l_pos := -1 + 34 -- skip if block
					end
				when 1 then -- if:
						l_tmp.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_ch := l_tmp[0]
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 33 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if l_state.to_natural_32 /= {NATURAL_32} 0 then
							if l_state.to_natural_32 = {NATURAL_32} 1 then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 32 -- skip if block
						end
				when 4 then -- if:
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (a_end.c_pointer.to_integer_32).to_natural_32 then
							l_state := {PC_STATE}.AC_S_BACKOUT
						end
						inspect l_state -- switch 1 head
						when 0 then l_pos := -1 + 5
						when 1 then l_pos := -1 + 5
						when 2 then l_pos := -1 + 6
						when 3 then l_pos := -1 + 7
						when 4 then l_pos := -1 + 14
						when 10 then l_pos := -1 + 15
						when 11 then l_pos := -1 + 16
						when 12 then l_pos := -1 + 17
						when 5 then l_pos := -1 + 18
						when 6 then l_pos := -1 + 19
						when 7 then l_pos := -1 + 23
						when 8 then l_pos := -1 + 27
						when 9 then l_pos := -1 + 28
						else l_pos := -1 + 32
						end
				when 5 then -- switch 1, case 0 | switch 1, case 1
						l_pos := -1 + 32 -- switch 1; break
				when 6 then -- switch 1, case 2
						if l_ch.to_integer_32 = 33 then
							l_tmp___0.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_ch := l_tmp___0[0]
							l_state := {PC_STATE}.AC_S_DEFAULT
						else
							l_state := {PC_STATE}.AC_S_BACKOUT
						end
						l_pos := -1 + 32 -- switch 1; break
				when 7 then -- switch 1, case 3
						inspect l_ch.to_integer_32 -- switch 2 head
						when 45 then l_pos := -1 + 8
						when 32 then l_pos := -1 + 9
						when 9 then l_pos := -1 + 9
						when 13 then l_pos := -1 + 9
						when 10 then l_pos := -1 + 9
						when 62 then l_pos := -1 + 10
						when 39 then l_pos := -1 + 11
						when 34 then l_pos := -1 + 11
						else l_pos := -1 + 12
						end
				when 8 then -- switch 2, case 45
						l_state := {PC_STATE}.AC_S_DASH1
						l_pos := -1 + 13 -- switch 2; break
				when 9 then -- switch 2, case 32 | switch 2, case 9 | switch 2, case 13 | switch 2, case 10
						l_tmp___1.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_ch := l_tmp___1[0]
						l_pos := -1 + 13 -- switch 2; break
				when 10 then -- switch 2, case 62
						l_state := {PC_STATE}.AC_S_DONE
						l_pos := -1 + 13 -- switch 2; break
				when 11 then -- switch 2, case 39 | switch 2, case 34
						l_state := {PC_STATE}.AC_S_QUOTE1
						l_pos := -1 + 13 -- switch 2; break
				when 12 then -- switch 2, default:
						if l_ch.to_integer_32 > 32 then
							if l_ch.to_integer_32 < 127 then
								if l_ch.to_integer_32 /= 61 then
									if l_ch.to_integer_32 /= 62 then
										if l_ch.to_integer_32 /= 47 then
											l_state := {PC_STATE}.AC_S_DCLNAME
										else
											l_state := {PC_STATE}.AC_S_BACKOUT
										end
									else
										l_state := {PC_STATE}.AC_S_BACKOUT
									end
								else
									l_state := {PC_STATE}.AC_S_BACKOUT
								end
							else
								l_state := {PC_STATE}.AC_S_BACKOUT
							end
						else
							l_state := {PC_STATE}.AC_S_BACKOUT
						end
						l_pos := -1 + 13 -- switch 2; break
				when 13 then -- switch 2, done:
						l_pos := -1 + 32 -- switch 1; break
				when 14 then -- switch 1, case 4
						if l_ch.to_integer_32 = 45 then
							l_state := {PC_STATE}.AC_S_DASH1
						elseif l_ch.to_integer_32 > 32 then
							if l_ch.to_integer_32 < 127 then
								if l_ch.to_integer_32 /= 61 then
									if l_ch.to_integer_32 /= 62 then
										if l_ch.to_integer_32 /= 47 then
											l_tmp___2.ce_gets (l_p___0)
											l_p___0.ce_gets (l_p___0 + 1)
											l_ch := l_tmp___2[0]
										else
											l_state := {PC_STATE}.AC_S_DEFAULT
										end
									else
										l_state := {PC_STATE}.AC_S_DEFAULT
									end
								else
									l_state := {PC_STATE}.AC_S_DEFAULT
								end
							else
								l_state := {PC_STATE}.AC_S_DEFAULT
							end
						else
							l_state := {PC_STATE}.AC_S_DEFAULT
						end
						l_pos := -1 + 32 -- switch 1; break
				when 15 then -- switch 1, case 10
						if l_ch.to_integer_32 /= 39 then
							if l_ch.to_integer_32 /= 34 then
								assert_fail (ce_string ("ch == %'\%'%' || ch == 0x22"), ce_string ("html-parse.c"), {NATURAL_32} 648, ce_string ("advance_declaration"))
							end
						end
						l_quote_char := l_ch
						l_tmp___3.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_ch := l_tmp___3[0]
						l_state := {PC_STATE}.AC_S_IN_QUOTE
						l_pos := -1 + 32 -- switch 1; break
				when 16 then -- switch 1, case 11
						if l_ch.to_integer_32 = l_quote_char.to_integer_32 then
							l_state := {PC_STATE}.AC_S_QUOTE2
						else
							l_tmp___4.ce_gets (l_p___0)
							l_p___0.ce_gets (l_p___0 + 1)
							l_ch := l_tmp___4[0]
						end
						l_pos := -1 + 32 -- switch 1; break
				when 17 then -- switch 1, case 12
						if l_ch.to_integer_32 /= l_quote_char.to_integer_32 then
							assert_fail (ce_string ("ch == quote_char"), ce_string ("html-parse.c"), {NATURAL_32} 662, ce_string ("advance_declaration"))
						end
						l_tmp___5.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_ch := l_tmp___5[0]
						l_state := {PC_STATE}.AC_S_DEFAULT
						l_pos := -1 + 32 -- switch 1; break
				when 18 then -- switch 1, case 5
						if l_ch.to_integer_32 /= 45 then
							assert_fail (ce_string ("ch == %'-%'"), ce_string ("html-parse.c"), {NATURAL_32} 667, ce_string ("advance_declaration"))
						end
						l_tmp___6.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_ch := l_tmp___6[0]
						l_state := {PC_STATE}.AC_S_DASH2
						l_pos := -1 + 32 -- switch 1; break
				when 19 then -- switch 1, case 6
						inspect l_ch.to_integer_32 -- switch 3 head
						when 45 then l_pos := -1 + 20
						else l_pos := -1 + 21
						end
				when 20 then -- switch 3, case 45
						l_tmp___7.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_ch := l_tmp___7[0]
						l_state := {PC_STATE}.AC_S_COMMENT
						l_pos := -1 + 22 -- switch 3; break
				when 21 then -- switch 3, default:
						l_state := {PC_STATE}.AC_S_BACKOUT
				when 22 then -- switch 3, done:
						l_pos := -1 + 32 -- switch 1; break
				when 23 then -- switch 1, case 7
						inspect l_ch.to_integer_32 -- switch 4 head
						when 45 then l_pos := -1 + 24
						else l_pos := -1 + 25
						end
				when 24 then -- switch 4, case 45
						l_state := {PC_STATE}.AC_S_DASH3
						l_pos := -1 + 26 -- switch 4; break
				when 25 then -- switch 4, default:
						l_tmp___8.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_ch := l_tmp___8[0]
						l_pos := -1 + 26 -- switch 4; break
				when 26 then -- switch 4, done:
						l_pos := -1 + 32 -- switch 1; break
				when 27 then -- switch 1, case 8
						if l_ch.to_integer_32 /= 45 then
							assert_fail (ce_string ("ch == %'-%'"), ce_string ("html-parse.c"), {NATURAL_32} 694, ce_string ("advance_declaration"))
						end
						l_tmp___9.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_ch := l_tmp___9[0]
						l_state := {PC_STATE}.AC_S_DASH4
						l_pos := -1 + 32 -- switch 1; break
				when 28 then -- switch 1, case 9
						inspect l_ch.to_integer_32 -- switch 5 head
						when 45 then l_pos := -1 + 29
						else l_pos := -1 + 30
						end
				when 29 then -- switch 5, case 45
						l_tmp___10.ce_gets (l_p___0)
						l_p___0.ce_gets (l_p___0 + 1)
						l_ch := l_tmp___10[0]
						l_state := {PC_STATE}.AC_S_DEFAULT
						l_pos := -1 + 31 -- switch 5; break
				when 30 then -- switch 5, default:
						l_state := {PC_STATE}.AC_S_COMMENT
						l_pos := -1 + 31 -- switch 5; break
				when 31 then -- switch 5, done:
						l_pos := -1 + 32 -- switch 1; break
				when 32 then -- switch 1, done: | if done
						l_pos := -1 + 2 -- back to loop condition
				when 33 then -- loop done
						js.reset
						if l_state.to_natural_32 = {NATURAL_32} 1 then
							Result := (a_beg + 1)
							js.return
						end
				when 34 then -- if done
					if not js.return_called then
						Result := l_p___0
					end
				when 35 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	find_comment_end (a_beg: CE_POINTER [INTEGER_8]; a_end: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_p___0: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (a_beg - 1)
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 16 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_p___0.ce_gets (l_p___0 + (3))
						if not ((l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32) then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 15 -- skip if block
						end
				when 3 then -- if:
						inspect (l_p___0[0]).to_integer_32 -- switch 1 head
						when 62 then l_pos := -1 + 4
						when 45 then l_pos := -1 + 5
						else l_pos := -1 + 15
						end
				when 4 then -- switch 1, case 62
						if (l_p___0[-1]).to_integer_32 = 45 then
							if (l_p___0[-2]).to_integer_32 = 45 then
								Result := (l_p___0 + 1)
								js.return
							end
						end
						l_pos := -1 + 15 -- switch 1; break
				when 5 then -- at_dash: | switch 1, case 45
						if (l_p___0[-1]).to_integer_32 /= 45 then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if: | at_dash_dash:
						l_p___0.ce_gets (l_p___0 + 1)
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (a_end.c_pointer.to_integer_32).to_natural_32 then
							Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							js.return
						end
						if js.return_called then
							l_pos := -1 + 10 -- skip if block
						end
				when 7 then -- if:
						inspect (l_p___0[0]).to_integer_32 -- switch 2 head
						when 62 then l_pos := -1 + 8
						when 45 then l_pos := -1 + 9
						else l_pos := -1 + 10
						end
				when 8 then -- switch 2, case 62
						Result := (l_p___0 + 1)
						js.return
				when 9 then -- switch 2, case 45
						if not js.return_called then
							l_pos := -1 + 6 -- goto at_dash_dash
						end
				when 10 then -- switch 2, done: | if done | if block done, skip else block:
						l_pos := -1 + 15
				when 11 then -- else:
						l_p___0.ce_gets (l_p___0 + (2))
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (a_end.c_pointer.to_integer_32).to_natural_32 then
							Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
							js.return
						end
						if js.return_called then
							l_pos := -1 + 15 -- skip if block
						end
				when 12 then -- if:
						inspect (l_p___0[0]).to_integer_32 -- switch 3 head
						when 62 then l_pos := -1 + 13
						when 45 then l_pos := -1 + 14
						else l_pos := -1 + 15
						end
				when 13 then -- switch 3, case 62
						if (l_p___0[-1]).to_integer_32 = 45 then
							Result := (l_p___0 + 1)
							js.return
						end
						l_pos := -1 + 15 -- switch 3; break
				when 14 then -- switch 3, case 45
						l_pos := -1 + 5 -- goto at_dash
				when 15 then -- switch 3, done: | if done | switch 1, done: | if done
						l_pos := -1 + 1 -- back to loop condition
				when 16 then -- loop done
					js.reset
					if not js.return_called then
						Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					end
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	name_allowed (a_ht: CE_POINTER [PD_HASH_TABLE]; a_b: CE_POINTER [INTEGER_8]; a_e: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_copy: CE_POINTER [INTEGER_8]
			l_BTA_beg: CE_POINTER [INTEGER_8]
			l_BTA_len: INTEGER_32
			l_BTA_dest: CE_POINTER [CE_POINTER [INTEGER_8]]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_copy.make
			create l_BTA_beg.make
			create l_BTA_dest.make

			if (a_ht).c_pointer = default_pointer then
				Result := (1).to_boolean
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					l_BTA_beg.ce_gets (a_b)
					l_BTA_len := a_e.distance (l_BTA_beg)
					l_BTA_dest.ce_gets (l_copy.address)
					l_BTA_dest.item := create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new ((l_BTA_len + 1).to_natural_32)))
					memcpy (create {CE_POINTER [ANY]}.make_cast (l_BTA_dest.item), create {CE_POINTER [ANY]}.make_cast (l_BTA_beg), l_BTA_len.to_natural_32).do_nothing
					l_BTA_dest.item[l_BTA_len] := (('%/0/').code).to_integer_8
					js.break
				end
				js.reset
				Result := (((hash_inst.hash_table_get (a_ht, create {CE_POINTER [ANY]}.make_cast (l_copy))).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32)
			end
		end

	map_html_tags (a_text: CE_POINTER [INTEGER_8]; a_size: INTEGER_32; a_mapfun: CE_ROUTINE; a_maparg: CE_POINTER [ANY]; a_flags: INTEGER_32; a_allowed_tags: CE_POINTER [PD_HASH_TABLE]; a_allowed_attributes: CE_POINTER [PD_HASH_TABLE])
		local
			l_pool_initial_storage: CE_ARRAY [INTEGER_8]
			l_pool: PD_POOL
			l_p___0: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
			l_attr_pair_initial_storage: CE_ARRAY [PD_ATTR_PAIR]
			l_attr_pair_size: INTEGER_32
			l_attr_pair_resized: BOOLEAN
			l_pairs: CE_POINTER [PD_ATTR_PAIR]
			l_head: CE_POINTER [PD_TAGSTACK_ITEM]
			l_tail: CE_POINTER [PD_TAGSTACK_ITEM]
			l_P: CE_POINTER [PD_POOL]
			l_nattrs: INTEGER_32
			l_end_tag: INTEGER_32
			l_tag_name_begin: CE_POINTER [INTEGER_8]
			l_tag_name_end: CE_POINTER [INTEGER_8]
			l_tag_start_position: CE_POINTER [INTEGER_8]
			l_uninteresting_tag: BOOLEAN
			l_comment_end: CE_POINTER [INTEGER_8]
			l_ts: CE_POINTER [PD_TAGSTACK_ITEM]
			l_attr_name_begin: CE_POINTER [INTEGER_8]
			l_attr_name_end: CE_POINTER [INTEGER_8]
			l_attr_value_begin: CE_POINTER [INTEGER_8]
			l_attr_value_end: CE_POINTER [INTEGER_8]
			l_attr_raw_value_begin: CE_POINTER [INTEGER_8]
			l_attr_raw_value_end: CE_POINTER [INTEGER_8]
			l_operation: INTEGER_32
			l_newline_seen: BOOLEAN
			l_quote_char: INTEGER_8
			l_ga_needed_size: INTEGER_32
			l_ga_newsize: INTEGER_32
			l_ga_new: CE_POINTER [ANY]
			l_i: INTEGER_32
			l_taginfo: PD_TAGINFO
			l_ts___0: CE_POINTER [PD_TAGSTACK_ITEM]
			l_P___02: CE_POINTER [PD_POOL]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_pool_initial_storage.make (<<256>>)
			create l_pool.make
			create l_p___0.make
			create l_end.make
			create l_attr_pair_initial_storage.make (<<8>>)
			create l_pairs.make
			create l_head.make
			create l_tail.make
			create l_P.make
			create l_tag_name_begin.make
			create l_tag_name_end.make
			create l_tag_start_position.make
			create l_comment_end.make
			create l_ts.make
			create l_attr_name_begin.make
			create l_attr_name_end.make
			create l_attr_value_begin.make
			create l_attr_value_end.make
			create l_attr_raw_value_begin.make
			create l_attr_raw_value_end.make
			create l_ga_new.make
			create l_taginfo.make
			create l_ts___0.make
			create l_P___02.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (a_text)
					l_end.ce_gets (a_text + a_size)
					l_attr_pair_size := (({PD_ATTR_PAIR}.sizeof.to_natural_32 * (8).to_natural_32) // {PD_ATTR_PAIR}.sizeof.to_natural_32).to_integer_32
					l_attr_pair_resized := (0).to_boolean
					l_pairs.ce_gets (l_attr_pair_initial_storage)
					l_head.ce_gets (create {CE_POINTER [PD_TAGSTACK_ITEM]}.make_shared (default_pointer))
					l_tail.ce_gets (create {CE_POINTER [PD_TAGSTACK_ITEM]}.make_shared (default_pointer))
					if not a_size.to_boolean then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 166 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							l_P.ce_gets (l_pool.address)
							l_P.item.contents := l_pool_initial_storage
							l_P.item.size := ((Integer_8_bytes.to_natural_32 * (256).to_natural_32) // Integer_8_bytes.to_natural_32).to_integer_32
							l_P.item.tail := 0
							l_P.item.resized := (0).to_boolean
							l_P.item.orig_contents := l_P.item.contents
							l_P.item.orig_size := l_P.item.size
							js.break
						end
						js.reset
				when 2 then -- look_for_tag:
						l_pool.tail := 0
						l_nattrs := 0
						l_end_tag := 0
						l_p___0.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((memchr (create {CE_POINTER [ANY]}.make_cast (l_p___0), ('<').code, (l_end.distance (l_p___0)).to_natural_32))))
						if (l_p___0).c_pointer = default_pointer then
							l_pos := -1 + 165 -- goto finish
						end
				when 3 then
						l_tag_start_position.ce_gets (l_p___0)
				when 4 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 7 -- skip loop
						end
				when 5 then -- loop body:
						js.reset
						l_p___0.ce_gets (l_p___0 + 1)
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 6 then
						js.break
						l_pos := -1 + 4 -- back to loop condition
				when 7 then -- loop done
						js.reset
						if (l_p___0[0]).to_integer_32 /= 33 then
							l_pos := -1 + 11 -- skip if block
						end
				when 8 then -- if:
						if not ((a_flags).bit_and (1)).to_boolean then
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 < ((l_end + 3).c_pointer.to_integer_32).to_natural_32 then
								if (l_p___0[1]).to_integer_32 = 45 then
									if (l_p___0[2]).to_integer_32 = 45 then
										l_comment_end.ce_gets ((find_comment_end (l_p___0 + 3, l_end)))
										if ((l_comment_end).c_pointer /= default_pointer) then
											l_p___0.ce_gets (l_comment_end)
										end
									else
										l_p___0.ce_gets (advance_declaration (l_p___0, l_end))
									end
								else
									l_p___0.ce_gets (advance_declaration (l_p___0, l_end))
								end
							else
								l_p___0.ce_gets (advance_declaration (l_p___0, l_end))
							end
						else
							l_p___0.ce_gets (advance_declaration (l_p___0, l_end))
						end
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 9 then
						l_pos := -1 + 2 -- goto look_for_tag
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 11 then -- else:
						if (l_p___0[0]).to_integer_32 /= 47 then
							l_pos := -1 + 17 -- skip if block
						end
				when 12 then -- if:
						l_end_tag := 1
				when 13 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 16 -- skip loop
						end
				when 14 then -- loop body:
						js.reset
						l_p___0.ce_gets (l_p___0 + 1)
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 15 then
						js.break
						l_pos := -1 + 13 -- back to loop condition
				when 16 then -- loop done
						js.reset
				when 17 then -- if done
						l_tag_name_begin.ce_gets (l_p___0)
				when 18 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 25 -- skip loop
						end
				when 19 then -- loop body:
						js.reset
						if (l_p___0[0]).to_integer_32 > 32 then
							if (l_p___0[0]).to_integer_32 < 127 then
								if (l_p___0[0]).to_integer_32 /= 61 then
									if (l_p___0[0]).to_integer_32 /= 62 then
										if (l_p___0[0]).to_integer_32 = 47 then
											js.break
										end
									else
										js.break
									end
								else
									js.break
								end
							else
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 24 -- skip if block
						end
				when 20 then -- if: | loop condition:
						if js.loop_left then
							l_pos := -1 + 23 -- skip loop
						end
				when 21 then -- loop body:
						js.reset
						l_p___0.ce_gets (l_p___0 + 1)
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 22 then
						js.break
						l_pos := -1 + 20 -- back to loop condition
				when 23 then -- loop done
						js.reset
				when 24 then -- if done
						l_pos := -1 + 18 -- back to loop condition
				when 25 then -- loop done
						js.reset
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (l_tag_name_begin.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 2 -- goto look_for_tag
						end
				when 26 then
						l_tag_name_end.ce_gets (l_p___0)
				when 27 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 37 -- skip loop
						end
				when 28 then -- loop body:
						js.reset
				when 29 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 36 -- skip loop
						end
				when 30 then -- loop body:
						js.reset
						if not (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 35 -- skip if block
						end
				when 31 then -- if: | loop condition:
						if js.loop_left then
							l_pos := -1 + 34 -- skip loop
						end
				when 32 then -- loop body:
						js.reset
						l_p___0.ce_gets (l_p___0 + 1)
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 33 then
						js.break
						l_pos := -1 + 31 -- back to loop condition
				when 34 then -- loop done
						js.reset
				when 35 then -- if done
						l_pos := -1 + 29 -- back to loop condition
				when 36 then -- loop done
						js.reset
						js.break
						l_pos := -1 + 27 -- back to loop condition
				when 37 then -- loop done
						js.reset
						if not l_end_tag.to_boolean then
							l_ts.ce_gets ((tagstack_push (l_head.address, l_tail.address)))
							if ((l_ts).c_pointer /= default_pointer) then
								l_ts.item.tagname_begin := l_tag_name_begin
								l_ts.item.tagname_end := l_tag_name_end
								l_ts.item.contents_begin := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
							end
						end
						if l_end_tag.to_boolean then
							if (l_p___0[0]).to_integer_32 /= 62 then
								l_pos := -1 + 164 -- goto backout_tag
							end
						end
				when 38 then
						if (name_allowed (a_allowed_tags, l_tag_name_begin, l_tag_name_end)) then
							l_uninteresting_tag := (0).to_boolean
							convert_and_copy (l_pool.address, l_tag_name_begin, l_tag_name_end, 1)
						else
							l_uninteresting_tag := (1).to_boolean
						end
				when 39 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 154 -- skip loop
						end
				when 40 then -- loop body:
						js.reset
						l_operation := 1
				when 41 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 51 -- skip loop
						end
				when 42 then -- loop body:
						js.reset
				when 43 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 50 -- skip loop
						end
				when 44 then -- loop body:
						js.reset
						if not (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 49 -- skip if block
						end
				when 45 then -- if: | loop condition:
						if js.loop_left then
							l_pos := -1 + 48 -- skip loop
						end
				when 46 then -- loop body:
						js.reset
						l_p___0.ce_gets (l_p___0 + 1)
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 47 then
						js.break
						l_pos := -1 + 45 -- back to loop condition
				when 48 then -- loop done
						js.reset
				when 49 then -- if done
						l_pos := -1 + 43 -- back to loop condition
				when 50 then -- loop done
						js.reset
						js.break
						l_pos := -1 + 41 -- back to loop condition
				when 51 then -- loop done
						js.reset
						if (l_p___0[0]).to_integer_32 /= 47 then
							l_pos := -1 + 67 -- skip if block
						end
				when 52 then -- if: | loop condition:
						if js.loop_left then
							l_pos := -1 + 55 -- skip loop
						end
				when 53 then -- loop body:
						js.reset
						l_p___0.ce_gets (l_p___0 + 1)
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 54 then
						js.break
						l_pos := -1 + 52 -- back to loop condition
				when 55 then -- loop done
						js.reset
				when 56 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 66 -- skip loop
						end
				when 57 then -- loop body:
						js.reset
				when 58 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 65 -- skip loop
						end
				when 59 then -- loop body:
						js.reset
						if not (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 64 -- skip if block
						end
				when 60 then -- if: | loop condition:
						if js.loop_left then
							l_pos := -1 + 63 -- skip loop
						end
				when 61 then -- loop body:
						js.reset
						l_p___0.ce_gets (l_p___0 + 1)
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 62 then
						js.break
						l_pos := -1 + 60 -- back to loop condition
				when 63 then -- loop done
						js.reset
				when 64 then -- if done
						l_pos := -1 + 58 -- back to loop condition
				when 65 then -- loop done
						js.reset
						js.break
						l_pos := -1 + 56 -- back to loop condition
				when 66 then -- loop done
						js.reset
						if (l_p___0[0]).to_integer_32 /= 62 then
							l_pos := -1 + 164 -- goto backout_tag
						end
				when 67 then
						if (l_p___0[0]).to_integer_32 = 62 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 153 -- skip if block
						end
				when 68 then -- if:
						l_attr_name_begin.ce_gets (l_p___0)
				when 69 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 76 -- skip loop
						end
				when 70 then -- loop body:
						js.reset
						if (l_p___0[0]).to_integer_32 > 32 then
							if (l_p___0[0]).to_integer_32 < 127 then
								if (l_p___0[0]).to_integer_32 /= 61 then
									if (l_p___0[0]).to_integer_32 /= 62 then
										if (l_p___0[0]).to_integer_32 = 47 then
											js.break
										end
									else
										js.break
									end
								else
									js.break
								end
							else
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 75 -- skip if block
						end
				when 71 then -- if: | loop condition:
						if js.loop_left then
							l_pos := -1 + 74 -- skip loop
						end
				when 72 then -- loop body:
						js.reset
						l_p___0.ce_gets (l_p___0 + 1)
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 73 then
						js.break
						l_pos := -1 + 71 -- back to loop condition
				when 74 then -- loop done
						js.reset
				when 75 then -- if done
						l_pos := -1 + 69 -- back to loop condition
				when 76 then -- loop done
						js.reset
						l_attr_name_end.ce_gets (l_p___0)
						if (l_attr_name_begin.c_pointer.to_integer_32).to_natural_32 = (l_attr_name_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 164 -- goto backout_tag
						end
				when 77 then
						if js.loop_left then
							l_pos := -1 + 87 -- skip loop
						end
				when 78 then -- loop body:
						js.reset
				when 79 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 86 -- skip loop
						end
				when 80 then -- loop body:
						js.reset
						if not (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 85 -- skip if block
						end
				when 81 then -- if: | loop condition:
						if js.loop_left then
							l_pos := -1 + 84 -- skip loop
						end
				when 82 then -- loop body:
						js.reset
						l_p___0.ce_gets (l_p___0 + 1)
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 83 then
						js.break
						l_pos := -1 + 81 -- back to loop condition
				when 84 then -- loop done
						js.reset
				when 85 then -- if done
						l_pos := -1 + 79 -- back to loop condition
				when 86 then -- loop done
						js.reset
						js.break
						l_pos := -1 + 77 -- back to loop condition
				when 87 then -- loop done
						js.reset
						if not ((l_p___0[0]).to_integer_32 > 32) then
							l_pos := -1 + 90 -- skip if block
						end
				when 88 then -- if:
						if (l_p___0[0]).to_integer_32 < 127 then
							if (l_p___0[0]).to_integer_32 /= 61 then
								if (l_p___0[0]).to_integer_32 /= 62 then
									if (l_p___0[0]).to_integer_32 /= 47 then
										l_attr_value_begin.ce_gets (l_attr_name_begin)
										l_attr_raw_value_begin.ce_gets (l_attr_value_begin)
										l_attr_value_end.ce_gets (l_attr_name_end)
										l_attr_raw_value_end.ce_gets (l_attr_value_end)
									else
										l_pos := -1 + 90 -- goto _L___4
									end
								else
									l_pos := -1 + 90 -- goto _L___4
								end
							else
								l_pos := -1 + 90 -- goto _L___4
							end
						else
							l_pos := -1 + 90 -- goto _L___4
						end
				when 89 then -- if block done, skip else block:
						l_pos := -1 + 152
				when 90 then -- else: | _L___4:
						if (l_p___0[0]).to_integer_32 /= 47 then
							l_pos := -1 + 93 -- skip if block
						end
				when 91 then -- if:
						l_attr_value_begin.ce_gets (l_attr_name_begin)
						l_attr_raw_value_begin.ce_gets (l_attr_value_begin)
						l_attr_value_end.ce_gets (l_attr_name_end)
						l_attr_raw_value_end.ce_gets (l_attr_value_end)
				when 92 then -- if block done, skip else block:
						l_pos := -1 + 152
				when 93 then -- else:
						if (l_p___0[0]).to_integer_32 /= 62 then
							l_pos := -1 + 96 -- skip if block
						end
				when 94 then -- if:
						l_attr_value_begin.ce_gets (l_attr_name_begin)
						l_attr_raw_value_begin.ce_gets (l_attr_value_begin)
						l_attr_value_end.ce_gets (l_attr_name_end)
						l_attr_raw_value_end.ce_gets (l_attr_value_end)
				when 95 then -- if block done, skip else block:
						l_pos := -1 + 152
				when 96 then -- else:
						if (l_p___0[0]).to_integer_32 /= 61 then
							l_pos := -1 + 151 -- skip if block
						end
				when 97 then -- if: | loop condition:
						if js.loop_left then
							l_pos := -1 + 100 -- skip loop
						end
				when 98 then -- loop body:
						js.reset
						l_p___0.ce_gets (l_p___0 + 1)
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 99 then
						js.break
						l_pos := -1 + 97 -- back to loop condition
				when 100 then -- loop done
						js.reset
				when 101 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 111 -- skip loop
						end
				when 102 then -- loop body:
						js.reset
				when 103 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 110 -- skip loop
						end
				when 104 then -- loop body:
						js.reset
						if not (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 109 -- skip if block
						end
				when 105 then -- if: | loop condition:
						if js.loop_left then
							l_pos := -1 + 108 -- skip loop
						end
				when 106 then -- loop body:
						js.reset
						l_p___0.ce_gets (l_p___0 + 1)
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 107 then
						js.break
						l_pos := -1 + 105 -- back to loop condition
				when 108 then -- loop done
						js.reset
				when 109 then -- if done
						l_pos := -1 + 103 -- back to loop condition
				when 110 then -- loop done
						js.reset
						js.break
						l_pos := -1 + 101 -- back to loop condition
				when 111 then -- loop done
						js.reset
						if (l_p___0[0]).to_integer_32 /= 34 then
							l_pos := -1 + 114 -- skip if block
						end
				when 112 then -- if:
						l_pos := -1 + 115 -- goto _L___0
				when 113 then -- if block done, skip else block:
						l_pos := -1 + 150
				when 114 then -- else:
						if (l_p___0[0]).to_integer_32 /= 39 then
							l_pos := -1 + 140 -- skip if block
						end
				when 115 then -- if: | _L___0:
						l_newline_seen := (0).to_boolean
						l_quote_char := l_p___0[0]
						l_attr_raw_value_begin.ce_gets (l_p___0)
				when 116 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 119 -- skip loop
						end
				when 117 then -- loop body:
						js.reset
						l_p___0.ce_gets (l_p___0 + 1)
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 118 then
						js.break
						l_pos := -1 + 116 -- back to loop condition
				when 119 then -- loop done
						js.reset
						l_attr_value_begin.ce_gets (l_p___0)
				when 120 then -- loop condition:
						if not (not js.loop_left and then ((l_p___0[0]).to_integer_32 /= l_quote_char.to_integer_32)) then
							l_pos := -1 + 131 -- skip loop
						end
				when 121 then -- loop body:
						js.reset
						if l_newline_seen then
							l_pos := -1 + 124 -- skip if block
						end
				when 122 then -- if:
						if (l_p___0[0]).to_integer_32 = 10 then
							l_p___0.ce_gets (l_attr_value_begin)
							l_newline_seen := (1).to_boolean
							js.continue
						else
							l_pos := -1 + 124 -- goto _L
						end
				when 123 then -- if block done, skip else block:
						l_pos := -1 + 125
				when 124 then -- else: | _L:
						if l_newline_seen then
							if (l_p___0[0]).to_integer_32 = 62 then
								js.break
							end
						end
				when 125 then
						if js.loop_jumped then
							l_pos := -1 + 130 -- skip if block
						end
				when 126 then -- if: | loop condition:
						if js.loop_left then
							l_pos := -1 + 129 -- skip loop
						end
				when 127 then -- loop body:
						js.reset
						l_p___0.ce_gets (l_p___0 + 1)
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 128 then
						js.break
						l_pos := -1 + 126 -- back to loop condition
				when 129 then -- loop done
						js.reset
				when 130 then -- if done
						l_pos := -1 + 120 -- back to loop condition
				when 131 then -- loop done
						js.reset
						l_attr_value_end.ce_gets (l_p___0)
						if (l_p___0[0]).to_integer_32 /= l_quote_char.to_integer_32 then
							l_pos := -1 + 137 -- skip if block
						end
				when 132 then -- if: | loop condition:
						if js.loop_left then
							l_pos := -1 + 135 -- skip loop
						end
				when 133 then -- loop body:
						js.reset
						l_p___0.ce_gets (l_p___0 + 1)
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 134 then
						js.break
						l_pos := -1 + 132 -- back to loop condition
				when 135 then -- loop done
						js.reset
				when 136 then -- if block done, skip else block:
						l_pos := -1 + 138
				when 137 then -- else:
						l_pos := -1 + 2 -- goto look_for_tag
				when 138 then
						l_attr_raw_value_end.ce_gets (l_p___0)
						l_operation := 2
						if ((a_flags).bit_and (2)).to_boolean then
							l_operation := (l_operation).bit_or ((4))
						end
				when 139 then -- if block done, skip else block:
						l_pos := -1 + 150
				when 140 then -- else:
						l_attr_value_begin.ce_gets (l_p___0)
				when 141 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 148 -- skip loop
						end
				when 142 then -- loop body:
						js.reset
						if (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
							js.break
						elseif (l_p___0[0]).to_integer_32 = 62 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 147 -- skip if block
						end
				when 143 then -- if: | loop condition:
						if js.loop_left then
							l_pos := -1 + 146 -- skip loop
						end
				when 144 then -- loop body:
						js.reset
						l_p___0.ce_gets (l_p___0 + 1)
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 145 then
						js.break
						l_pos := -1 + 143 -- back to loop condition
				when 146 then -- loop done
						js.reset
				when 147 then -- if done
						l_pos := -1 + 141 -- back to loop condition
				when 148 then -- loop done
						js.reset
						l_attr_value_end.ce_gets (l_p___0)
						if (l_attr_value_begin.c_pointer.to_integer_32).to_natural_32 = (l_attr_value_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 164 -- goto backout_tag
						end
				when 149 then
						l_attr_raw_value_begin.ce_gets (l_attr_value_begin)
						l_attr_raw_value_end.ce_gets (l_attr_value_end)
						l_operation := 2
				when 150 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 152
				when 151 then -- else:
						l_pos := -1 + 164 -- goto backout_tag
				when 152 then -- if done | if done | if done
						if l_uninteresting_tag then
							js.continue
						end
				when 153 then -- if done
						if not js.loop_jumped then
							if not (name_allowed (a_allowed_attributes, l_attr_name_begin, l_attr_name_end)) then
								js.continue
							end
						end
						if not js.loop_jumped then
							from
							until
								js.loop_left
							loop
								js.reset
								l_ga_needed_size := (l_nattrs + 1).to_integer_32
								l_ga_newsize := l_attr_pair_size.to_integer_32
								from
								until
									not (l_ga_newsize < l_ga_needed_size)
								loop
									l_ga_newsize := (l_ga_newsize).bit_shift_left ((1))
								end
								if l_ga_newsize /= l_attr_pair_size.to_integer_32 then
									if l_attr_pair_resized then
										l_pairs.ce_gets (create {CE_POINTER [PD_ATTR_PAIR]}.make_cast ((xmalloc_inst.xrealloc (create {CE_POINTER [ANY]}.make_cast (l_pairs), (l_ga_newsize.to_natural_32 * ({PD_ATTR_PAIR}.sizeof.to_natural_32).to_natural_32).to_natural_32))))
									else
										l_ga_new.ce_gets ((xmalloc_inst.xmalloc ((l_ga_newsize.to_natural_32 * ({PD_ATTR_PAIR}.sizeof.to_natural_32).to_natural_32).to_natural_32)))
										memcpy (l_ga_new, create {CE_POINTER [ANY]}.make_cast (l_pairs), l_attr_pair_size.to_natural_32 * {PD_ATTR_PAIR}.sizeof.to_natural_32).do_nothing
										l_pairs.ce_gets (create {CE_POINTER [PD_ATTR_PAIR]}.make_cast (l_ga_new))
										l_attr_pair_resized := (1).to_boolean
									end
									l_attr_pair_size := l_ga_newsize.to_integer_32
								end
								js.break
							end
							js.reset;
							(l_pairs + l_nattrs).item.name_pool_index := l_pool.tail
							convert_and_copy (l_pool.address, l_attr_name_begin, l_attr_name_end, 1);
							(l_pairs + l_nattrs).item.value_pool_index := l_pool.tail
							convert_and_copy (l_pool.address, l_attr_value_begin, l_attr_value_end, l_operation);
							(l_pairs + l_nattrs).item.value_raw_beginning := l_attr_raw_value_begin;
							(l_pairs + l_nattrs).item.value_raw_size := l_attr_raw_value_end.distance (l_attr_raw_value_begin)
							l_nattrs := l_nattrs + 1
						end
						l_pos := -1 + 39 -- back to loop condition
				when 154 then -- loop done
						js.reset
						if not l_end_tag.to_boolean then
							if ((l_tail).c_pointer /= default_pointer) then
								if ((l_tail.item.tagname_begin).c_pointer.to_integer_32).to_natural_32 = (l_tag_name_begin.c_pointer.to_integer_32).to_natural_32 then
									l_tail.item.contents_begin := l_p___0 + 1
								end
							end
						end
						if not l_uninteresting_tag then
							l_pos := -1 + 159 -- skip if block
						end
				when 155 then -- if: | loop condition:
						if js.loop_left then
							l_pos := -1 + 158 -- skip loop
						end
				when 156 then -- loop body:
						js.reset
						l_p___0.ce_gets (l_p___0 + 1)
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 157 then
						js.break
						l_pos := -1 + 155 -- back to loop condition
				when 158 then -- loop done
						js.reset
						l_pos := -1 + 2 -- goto look_for_tag
				when 159 then
						l_ts___0.ce_gets (create {CE_POINTER [PD_TAGSTACK_ITEM]}.make_shared (default_pointer))
						l_taginfo.name := l_pool.contents
						l_taginfo.end_tag_p := l_end_tag
						l_taginfo.nattrs := l_nattrs
						l_i := 0
						from
						until
							not (l_i < l_nattrs)
						loop
							(l_pairs + l_i).item.name := l_pool.contents + (l_pairs + l_i).item.name_pool_index;
							(l_pairs + l_i).item.value := l_pool.contents + (l_pairs + l_i).item.value_pool_index
							l_i := l_i + 1
						end
						l_taginfo.attrs := l_pairs
						l_taginfo.start_position := l_tag_start_position
						l_taginfo.end_position := l_p___0 + 1
						l_taginfo.contents_begin := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						l_taginfo.contents_end := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						if l_end_tag.to_boolean then
							l_ts___0.ce_gets (tagstack_find (l_tail, l_tag_name_begin, l_tag_name_end))
							if ((l_ts___0).c_pointer /= default_pointer) then
								if ((l_ts___0.item.contents_begin).c_pointer /= default_pointer) then
									l_taginfo.contents_begin := l_ts___0.item.contents_begin
									l_taginfo.contents_end := l_tag_start_position
								end
								tagstack_pop (l_head.address, l_tail.address, l_ts___0)
							end
						end
						a_mapfun.call ([l_taginfo.address, a_maparg])
				when 160 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 163 -- skip loop
						end
				when 161 then -- loop body:
						js.reset
						l_p___0.ce_gets (l_p___0 + 1)
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_end.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 165 -- goto finish
						end
				when 162 then
						js.break
						l_pos := -1 + 160 -- back to loop condition
				when 163 then -- loop done
						js.reset
						l_pos := -1 + 2 -- goto look_for_tag
				when 164 then -- backout_tag:
						l_p___0.ce_gets (l_tag_start_position + 1)
						l_pos := -1 + 2 -- goto look_for_tag
				when 165 then -- finish:
						from
						until
							js.loop_left
						loop
							js.reset
							l_P___02.ce_gets (l_pool.address)
							if l_P___02.item.resized then
								free (create {CE_POINTER [ANY]}.make_cast (l_P___02.item.contents))
							end
							l_P___02.item.contents := l_P___02.item.orig_contents
							l_P___02.item.size := l_P___02.item.orig_size
							l_P___02.item.tail := 0
							l_P___02.item.resized := (0).to_boolean
							js.break
						end
						js.reset
						if l_attr_pair_resized then
							free (create {CE_POINTER [ANY]}.make_cast (l_pairs))
						end
						tagstack_pop (l_head.address, l_tail.address, l_head)
				when 166 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
