class
	P_LOCALCHARSET

inherit
	WGET_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {NONE} -- Initialization

	default_create
		do
			create charset_aliases.make
		end

feature {ANY} -- attributes

	charset_aliases: CE_POINTER [INTEGER_8]

feature {ANY} -- routines

	get_charset_aliases: CE_POINTER [INTEGER_8]
		local
			l_cp: CE_POINTER [INTEGER_8]
			l_fp: CE_POINTER [SD_IO_FILE]
			l_dir: CE_POINTER [INTEGER_8]
			l_base: CE_POINTER [INTEGER_8]
			l_file_name: CE_POINTER [INTEGER_8]
			l_dir_len: NATURAL_32
			l_base_len: NATURAL_32
			l_add_slash: INTEGER_32
			l_tmp___2: INTEGER_32
			l_res_ptr: CE_POINTER [INTEGER_8]
			l_res_size: NATURAL_32
			l_c: INTEGER_32
			l_buf1: CE_ARRAY [INTEGER_8]
			l_buf2: CE_ARRAY [INTEGER_8]
			l_l1: NATURAL_32
			l_l2: NATURAL_32
			l_old_res_ptr: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_cp.make
			create l_fp.make
			create l_dir.make
			create l_base.make
			create l_file_name.make
			create l_res_ptr.make
			create l_buf1.make (<<51>>)
			create l_buf2.make (<<51>>)
			create l_old_res_ptr.make

			l_cp.ce_gets (charset_aliases)
			if (l_cp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_base.ce_gets (ce_string ("charset.alias"))
				l_dir.ce_gets ((getenv (ce_string ("CHARSETALIASDIR"))))
				if (l_dir.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					l_dir.ce_gets (ce_string ("/usr/local/lib"))
				elseif (l_dir[0]).to_integer_32 = 0 then
					l_dir.ce_gets (ce_string ("/usr/local/lib"))
				end
				l_dir_len := (strlen (l_dir))
				l_base_len := (strlen (l_base))
				if l_dir_len > {NATURAL_32} 0 then
					if (l_dir[(l_dir_len - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 47 then
						l_tmp___2 := 1
					else
						l_tmp___2 := 0
					end
				else
					l_tmp___2 := 0
				end
				l_add_slash := l_tmp___2
				l_file_name.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((malloc (((l_dir_len + l_add_slash.to_natural_32) + l_base_len) + {NATURAL_32} 1))))
				if (l_file_name.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					memcpy (create {CE_POINTER [ANY]}.make_cast (l_file_name), create {CE_POINTER [ANY]}.make_cast (l_dir), l_dir_len).do_nothing
					if l_add_slash.to_boolean then
						l_file_name[l_dir_len.to_integer_32] := (('/').code).to_integer_8
					end
					memcpy (create {CE_POINTER [ANY]}.make_cast (((l_file_name + l_dir_len.to_integer_32) + l_add_slash)), create {CE_POINTER [ANY]}.make_cast (l_base), l_base_len + {NATURAL_32} 1).do_nothing
				end
				if (l_file_name.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					l_cp.ce_gets (ce_string (""))
				else
					l_fp.ce_gets (fopen (l_file_name, ce_string ("r")))
					if (l_fp.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_cp.ce_gets (ce_string (""))
					else
						l_res_ptr.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
						l_res_size := (0).to_natural_32
						from
						until
							js.loop_left
						loop
							js.reset
							l_c := getc_unlocked (l_fp)
							if l_c = -1 then
								js.break
							end
							if not js.loop_jumped then
								if l_c = 10 then
									js.continue
								elseif l_c = 32 then
									js.continue
								elseif l_c = 9 then
									js.continue
								end
							end
							if not js.loop_jumped and then (l_c = 35) then
								from
								until
									js.loop_left
								loop
									js.reset
									l_c := getc_unlocked (l_fp)
									if l_c = -1 then
										js.break
									elseif l_c = 10 then
										js.break
									end
								end
								js.reset
								if l_c = -1 then
									js.break
								end
								if not js.loop_jumped then
									js.continue
								end
							end
							if not js.loop_jumped then
								ungetc (l_c, l_fp).do_nothing
								if (fscanf ([l_fp, ce_string ("%%50s %%50s"), l_buf1, l_buf2])) < 2 then
									js.break
								end
							end
							if not js.loop_jumped then
								l_l1 := strlen (l_buf1)
								l_l2 := strlen (l_buf2)
								l_old_res_ptr.ce_gets (l_res_ptr)
								if l_res_size = {NATURAL_32} 0 then
									l_res_size := ((l_l1 + {NATURAL_32} 1) + l_l2) + {NATURAL_32} 1
									l_res_ptr.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((malloc (l_res_size + {NATURAL_32} 1))))
								else
									l_res_size := l_res_size + (((l_l1 + {NATURAL_32} 1) + l_l2) + {NATURAL_32} 1)
									l_res_ptr.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((realloc (create {CE_POINTER [ANY]}.make_cast (l_res_ptr), l_res_size + {NATURAL_32} 1))))
								end
								if (l_res_ptr.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_res_size := (0).to_natural_32
									if (l_old_res_ptr.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										free (create {CE_POINTER [ANY]}.make_cast (l_old_res_ptr))
									end
									js.break
								end
							end
							if not js.loop_jumped then
								strcpy ((((l_res_ptr + l_res_size.to_integer_32) - (l_l2 + {NATURAL_32} 1).to_integer_32) - (l_l1 + {NATURAL_32} 1).to_integer_32), l_buf1).do_nothing
								strcpy (((l_res_ptr + l_res_size.to_integer_32) - (l_l2 + {NATURAL_32} 1).to_integer_32), l_buf2).do_nothing
							end
							if not js.loop_left then
								
							end
						end
						js.reset
						fclose (l_fp).do_nothing
						if l_res_size = {NATURAL_32} 0 then
							l_cp.ce_gets (ce_string (""))
						else
							l_res_ptr[l_res_size.to_integer_32] := (('%/0/').code).to_integer_8
							l_cp.ce_gets (l_res_ptr)
						end
					end
				end
				if (l_file_name.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					free (create {CE_POINTER [ANY]}.make_cast (l_file_name))
				end
				charset_aliases.ce_gets (l_cp)
			end
			Result := l_cp
		end

	locale_charset: CE_POINTER [INTEGER_8]
		local
			l_codeset: CE_POINTER [INTEGER_8]
			l_aliases: CE_POINTER [INTEGER_8]
			l_tmp___2: NATURAL_32
			js: JUMP_STATE
		do
			create l_codeset.make
			create l_aliases.make

			l_codeset.ce_gets ((nl_langinfo (14)))
			if (l_codeset.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_codeset.ce_gets (ce_string (""))
			end
			l_aliases.ce_gets (get_charset_aliases)
			from
			until
				not (not js.loop_left and then ((l_aliases[0]).to_integer_32 /= 0))
			loop
				js.reset
				if (strcmp (l_codeset, l_aliases)) = 0 then
					l_tmp___2 := strlen (l_aliases)
					l_codeset.ce_gets ((l_aliases + l_tmp___2.to_integer_32) + 1)
					js.break
				elseif (l_aliases[0]).to_integer_32 = 42 then
					if (l_aliases[1]).to_integer_32 = 0 then
						l_tmp___2 := strlen (l_aliases)
						l_codeset.ce_gets ((l_aliases + l_tmp___2.to_integer_32) + 1)
						js.break
					end
				end
				if not js.loop_jumped then
					l_aliases.ce_gets (l_aliases + ((strlen (l_aliases)) + {NATURAL_32} 1).to_integer_32)
					l_aliases.ce_gets (l_aliases + ((strlen (l_aliases)) + {NATURAL_32} 1).to_integer_32)
				end
			end
			js.reset
			if (l_codeset[0]).to_integer_32 = 0 then
				l_codeset.ce_gets (ce_string ("ASCII"))
			end
			Result := l_codeset
		end

end
