class
	P_XMALLOC

inherit
	WGET_DATA
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {ANY} -- routines

	xmalloc (a_n: NATURAL_32): CE_POINTER [ANY]
		local
			l_p___0: CE_POINTER [ANY]
		do
			create l_p___0.make

			l_p___0.ce_gets ((malloc (a_n)))
			if (l_p___0).c_pointer = default_pointer then
				if a_n /= {NATURAL_32} 0 then
					xalloc_die_inst.xalloc_die
				end
			end
			Result := l_p___0
		end

	xrealloc (a_p___0: CE_POINTER [ANY]; a_n: NATURAL_32): CE_POINTER [ANY]
		local
			l_p___0: CE_POINTER [ANY]
		do
			create l_p___0.make

			l_p___0.ce_gets (a_p___0)
			l_p___0.ce_gets (realloc (l_p___0, a_n))
			if (l_p___0).c_pointer = default_pointer then
				if a_n /= {NATURAL_32} 0 then
					xalloc_die_inst.xalloc_die
				end
			end
			Result := l_p___0
		end

	x2realloc (a_p___0: CE_POINTER [ANY]; a_pn: CE_POINTER [NATURAL_32]): CE_POINTER [ANY]
		do
			Result := (xalloc_inst.x2nrealloc (a_p___0, a_pn, (1).to_natural_32))
		end

	xzalloc (a_s: NATURAL_32): CE_POINTER [ANY]
		do
			Result := (memset ((xmalloc (a_s)), 0, a_s))
		end

	xcalloc (a_n: NATURAL_32; a_s: NATURAL_32): CE_POINTER [ANY]
		local
			l_p___0: CE_POINTER [ANY]
		do
			create l_p___0.make

			l_p___0.ce_gets (calloc (a_n, a_s))
			if (l_p___0).c_pointer = default_pointer then
				xalloc_die_inst.xalloc_die
			end
			Result := l_p___0
		end

	xmemdup (a_p___0: CE_POINTER [ANY]; a_s: NATURAL_32): CE_POINTER [ANY]
		do
			Result := (memcpy ((xmalloc (a_s)), a_p___0, a_s))
		end

	xstrdup (a_string: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			Result := (create {CE_POINTER [INTEGER_8]}.make_cast ((xmemdup (create {CE_POINTER [ANY]}.make_cast (a_string), (strlen (a_string)) + {NATURAL_32} 1))))
		end

end
