class
	SD_VALUE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	wch: NATURAL_32 assign set_wch
		do
			Result := c_wch (c_pointer)
		end

	wchb: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_wchb (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_wch (a_wch: NATURAL_32)
		do
			c_set_wch (c_pointer, a_wch)
		end

feature {NONE} -- C getters

	c_wch (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((union __anonunion___value_25 *)$tmp)->__wch;"
		end

	c_wchb (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				union __anonunion___value_25 *tmp = (union __anonunion___value_25 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->__wchb) / sizeof(tmp->__wchb[0]);
				return tmp->__wchb;
			]"
		end

feature {NONE} -- C setters

	c_set_wch (tmp: POINTER; a_wch: NATURAL_32)
		external
			"C inline"
		alias
			"((union __anonunion___value_25 *)$tmp)->__wch = $a_wch;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(union __anonunion___value_25);"
		end

end
