class
	SD_WINSIZE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ws_row: NATURAL_16 assign set_ws_row
		do
			Result := c_ws_row (c_pointer)
		end

	ws_col: NATURAL_16 assign set_ws_col
		do
			Result := c_ws_col (c_pointer)
		end

	ws_xpixel: NATURAL_16 assign set_ws_xpixel
		do
			Result := c_ws_xpixel (c_pointer)
		end

	ws_ypixel: NATURAL_16 assign set_ws_ypixel
		do
			Result := c_ws_ypixel (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_ws_row (a_ws_row: NATURAL_16)
		do
			c_set_ws_row (c_pointer, a_ws_row)
		end

	set_ws_col (a_ws_col: NATURAL_16)
		do
			c_set_ws_col (c_pointer, a_ws_col)
		end

	set_ws_xpixel (a_ws_xpixel: NATURAL_16)
		do
			c_set_ws_xpixel (c_pointer, a_ws_xpixel)
		end

	set_ws_ypixel (a_ws_ypixel: NATURAL_16)
		do
			c_set_ws_ypixel (c_pointer, a_ws_ypixel)
		end

feature {NONE} -- C getters

	c_ws_row (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct winsize *)$tmp)->ws_row;"
		end

	c_ws_col (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct winsize *)$tmp)->ws_col;"
		end

	c_ws_xpixel (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct winsize *)$tmp)->ws_xpixel;"
		end

	c_ws_ypixel (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct winsize *)$tmp)->ws_ypixel;"
		end

feature {NONE} -- C setters

	c_set_ws_row (tmp: POINTER; a_ws_row: NATURAL_16)
		external
			"C inline"
		alias
			"((struct winsize *)$tmp)->ws_row = $a_ws_row;"
		end

	c_set_ws_col (tmp: POINTER; a_ws_col: NATURAL_16)
		external
			"C inline"
		alias
			"((struct winsize *)$tmp)->ws_col = $a_ws_col;"
		end

	c_set_ws_xpixel (tmp: POINTER; a_ws_xpixel: NATURAL_16)
		external
			"C inline"
		alias
			"((struct winsize *)$tmp)->ws_xpixel = $a_ws_xpixel;"
		end

	c_set_ws_ypixel (tmp: POINTER; a_ws_ypixel: NATURAL_16)
		external
			"C inline"
		alias
			"((struct winsize *)$tmp)->ws_ypixel = $a_ws_ypixel;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sizeof(struct winsize);"
		end

end
