class
	PD_BUGGY_SERVERS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [NATURAL_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	bugs: INTEGER_32 assign set_bugs
		do
			Result := c_bugs (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_bugs (a_bugs: INTEGER_32)
		do
			c_set_bugs (c_pointer, a_bugs)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_buggy_servers_67 *)$tmp)->name;"
		end

	c_bugs (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_buggy_servers_67 *)$tmp)->bugs;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_buggy_servers_67 *)$tmp)->name = (unsigned char *)$a_name;"
		end

	c_set_bugs (tmp: POINTER; a_bugs: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_buggy_servers_67 *)$tmp)->bugs = $a_bugs;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct __anonstruct_buggy_servers_67);"
		end

end
