class
	PD_CODEPAGE_DESC

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [NATURAL_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	aliases: CE_POINTER [CE_POINTER [NATURAL_8]] assign set_aliases
		do
			create Result.make_shared (c_aliases (c_pointer))
		end

	table_dirty_workaround_for_name_clash_with_libraries_on_macos: CE_POINTER [PD_TABLE_ENTRY] assign set_table_dirty_workaround_for_name_clash_with_libraries_on_macos
		do
			create Result.make_shared (c_table_dirty_workaround_for_name_clash_with_libraries_on_macos (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_aliases (a_aliases: CE_POINTER [CE_POINTER [NATURAL_8]])
		do
			c_set_aliases (c_pointer, a_aliases.c_pointer)
		end

	set_table_dirty_workaround_for_name_clash_with_libraries_on_macos (a_table_dirty_workaround_for_name_clash_with_libraries_on_macos: CE_POINTER [PD_TABLE_ENTRY])
		do
			c_set_table_dirty_workaround_for_name_clash_with_libraries_on_macos (c_pointer, a_table_dirty_workaround_for_name_clash_with_libraries_on_macos.c_pointer)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct codepage_desc *)$tmp)->name;"
		end

	c_aliases (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char * *)((struct codepage_desc *)$tmp)->aliases;"
		end

	c_table_dirty_workaround_for_name_clash_with_libraries_on_macos (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct table_entry *)((struct codepage_desc *)$tmp)->table_dirty_workaround_for_name_clash_with_libraries_on_macos;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct codepage_desc *)$tmp)->name = (unsigned char *)$a_name;"
		end

	c_set_aliases (tmp: POINTER; a_aliases: POINTER)
		external
			"C inline"
		alias
			"((struct codepage_desc *)$tmp)->aliases = (unsigned char * *)$a_aliases;"
		end

	c_set_table_dirty_workaround_for_name_clash_with_libraries_on_macos (tmp: POINTER; a_table_dirty_workaround_for_name_clash_with_libraries_on_macos: POINTER)
		external
			"C inline"
		alias
			"((struct codepage_desc *)$tmp)->table_dirty_workaround_for_name_clash_with_libraries_on_macos = (struct table_entry *)$a_table_dirty_workaround_for_name_clash_with_libraries_on_macos;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct codepage_desc);"
		end

end
