class
	PD_COLOR_SPEC

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	rgb: INTEGER_32 assign set_rgb
		do
			Result := c_rgb (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_rgb (a_rgb: INTEGER_32)
		do
			c_set_rgb (c_pointer, a_rgb)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct color_spec *)$tmp)->name;"
		end

	c_rgb (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct color_spec *)$tmp)->rgb;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct color_spec *)$tmp)->name = (char *)$a_name;"
		end

	c_set_rgb (tmp: POINTER; a_rgb: INTEGER_32)
		external
			"C inline"
		alias
			"((struct color_spec *)$tmp)->rgb = $a_rgb;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct color_spec);"
		end

end
