class
	PD_CONV_TABLE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	t: INTEGER_32 assign set_t
		do
			Result := c_t (c_pointer)
		end

	u: PD_U assign set_u
		do
			create Result.make_shared (c_u (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_t (a_t: INTEGER_32)
		do
			c_set_t (c_pointer, a_t)
		end

	set_u (a_u: PD_U)
		do
			u.ce_gets (a_u)
		end

feature {NONE} -- C getters

	c_t (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct conv_table *)$tmp)->t;"
		end

	c_u (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_u_65 *)&((struct conv_table *)$tmp)->u;"
		end

feature {NONE} -- C setters

	c_set_t (tmp: POINTER; a_t: INTEGER_32)
		external
			"C inline"
		alias
			"((struct conv_table *)$tmp)->t = $a_t;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct conv_table);"
		end

end
