class
	PD_DIRS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	s: CE_POINTER [NATURAL_8] assign set_s
		do
			create Result.make_shared (c_s (c_pointer))
		end

	s_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct dirs, s);"
		end

	f: CE_POINTER [NATURAL_8] assign set_f
		do
			create Result.make_shared (c_f (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_s (a_s: CE_POINTER [NATURAL_8])
		do
			c_set_s (c_pointer, a_s.c_pointer)
		end

	set_f (a_f: CE_POINTER [NATURAL_8])
		do
			c_set_f (c_pointer, a_f.c_pointer)
		end

feature {NONE} -- C getters

	c_s (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct dirs *)$tmp)->s;"
		end

	c_f (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct dirs *)$tmp)->f;"
		end

feature {NONE} -- C setters

	c_set_s (tmp: POINTER; a_s: POINTER)
		external
			"C inline"
		alias
			"((struct dirs *)$tmp)->s = (unsigned char *)$a_s;"
		end

	c_set_f (tmp: POINTER; a_f: POINTER)
		external
			"C inline"
		alias
			"((struct dirs *)$tmp)->f = (unsigned char *)$a_f;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct dirs);"
		end

end
