class
	PD_DLG_DATA_ITEM_DATA_BOX

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sel: INTEGER_32 assign set_sel
		do
			Result := c_sel (c_pointer)
		end

	box_top: INTEGER_32 assign set_box_top
		do
			Result := c_box_top (c_pointer)
		end

	items: PD_LIST_HEAD assign set_items
		do
			create Result.make_shared (c_items (c_pointer))
		end

	items_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct dlg_data_item_data_box, items);"
		end

	list_len: INTEGER_32 assign set_list_len
		do
			Result := c_list_len (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_sel (a_sel: INTEGER_32)
		do
			c_set_sel (c_pointer, a_sel)
		end

	set_box_top (a_box_top: INTEGER_32)
		do
			c_set_box_top (c_pointer, a_box_top)
		end

	set_items (a_items: PD_LIST_HEAD)
		do
			items.ce_gets (a_items)
		end

	set_list_len (a_list_len: INTEGER_32)
		do
			c_set_list_len (c_pointer, a_list_len)
		end

feature {NONE} -- C getters

	c_sel (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dlg_data_item_data_box *)$tmp)->sel;"
		end

	c_box_top (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dlg_data_item_data_box *)$tmp)->box_top;"
		end

	c_items (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct list_head *)&((struct dlg_data_item_data_box *)$tmp)->items;"
		end

	c_list_len (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct dlg_data_item_data_box *)$tmp)->list_len;"
		end

feature {NONE} -- C setters

	c_set_sel (tmp: POINTER; a_sel: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dlg_data_item_data_box *)$tmp)->sel = $a_sel;"
		end

	c_set_box_top (tmp: POINTER; a_box_top: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dlg_data_item_data_box *)$tmp)->box_top = $a_box_top;"
		end

	c_set_list_len (tmp: POINTER; a_list_len: INTEGER_32)
		external
			"C inline"
		alias
			"((struct dlg_data_item_data_box *)$tmp)->list_len = $a_list_len;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct dlg_data_item_data_box);"
		end

end
