class
	PD_DOCUMENT_OPTIONS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	xw: INTEGER_32 assign set_xw
		do
			Result := c_xw (c_pointer)
		end

	yw: INTEGER_32 assign set_yw
		do
			Result := c_yw (c_pointer)
		end

	xp: INTEGER_32 assign set_xp
		do
			Result := c_xp (c_pointer)
		end

	yp: INTEGER_32 assign set_yp
		do
			Result := c_yp (c_pointer)
		end

	col: INTEGER_32 assign set_col
		do
			Result := c_col (c_pointer)
		end

	cp: INTEGER_32 assign set_cp
		do
			Result := c_cp (c_pointer)
		end

	assume_cp: INTEGER_32 assign set_assume_cp
		do
			Result := c_assume_cp (c_pointer)
		end

	hard_assume: INTEGER_32 assign set_hard_assume
		do
			Result := c_hard_assume (c_pointer)
		end

	tables: INTEGER_32 assign set_tables
		do
			Result := c_tables (c_pointer)
		end

	frames: INTEGER_32 assign set_frames
		do
			Result := c_frames (c_pointer)
		end

	images: INTEGER_32 assign set_images
		do
			Result := c_images (c_pointer)
		end

	margin: INTEGER_32 assign set_margin
		do
			Result := c_margin (c_pointer)
		end

	plain: INTEGER_32 assign set_plain
		do
			Result := c_plain (c_pointer)
		end

	num_links: INTEGER_32 assign set_num_links
		do
			Result := c_num_links (c_pointer)
		end

	table_order: INTEGER_32 assign set_table_order
		do
			Result := c_table_order (c_pointer)
		end

	default_fg: PD_RGB assign set_default_fg
		do
			create Result.make_shared (c_default_fg (c_pointer))
		end

	default_fg_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct document_options, default_fg);"
		end

	default_bg: PD_RGB assign set_default_bg
		do
			create Result.make_shared (c_default_bg (c_pointer))
		end

	default_bg_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct document_options, default_bg);"
		end

	default_link: PD_RGB assign set_default_link
		do
			create Result.make_shared (c_default_link (c_pointer))
		end

	default_link_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct document_options, default_link);"
		end

	default_vlink: PD_RGB assign set_default_vlink
		do
			create Result.make_shared (c_default_vlink (c_pointer))
		end

	default_vlink_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct document_options, default_vlink);"
		end

	framename: CE_POINTER [NATURAL_8] assign set_framename
		do
			create Result.make_shared (c_framename (c_pointer))
		end

	real_cp: INTEGER_32 assign set_real_cp
		do
			Result := c_real_cp (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_xw (a_xw: INTEGER_32)
		do
			c_set_xw (c_pointer, a_xw)
		end

	set_yw (a_yw: INTEGER_32)
		do
			c_set_yw (c_pointer, a_yw)
		end

	set_xp (a_xp: INTEGER_32)
		do
			c_set_xp (c_pointer, a_xp)
		end

	set_yp (a_yp: INTEGER_32)
		do
			c_set_yp (c_pointer, a_yp)
		end

	set_col (a_col: INTEGER_32)
		do
			c_set_col (c_pointer, a_col)
		end

	set_cp (a_cp: INTEGER_32)
		do
			c_set_cp (c_pointer, a_cp)
		end

	set_assume_cp (a_assume_cp: INTEGER_32)
		do
			c_set_assume_cp (c_pointer, a_assume_cp)
		end

	set_hard_assume (a_hard_assume: INTEGER_32)
		do
			c_set_hard_assume (c_pointer, a_hard_assume)
		end

	set_tables (a_tables: INTEGER_32)
		do
			c_set_tables (c_pointer, a_tables)
		end

	set_frames (a_frames: INTEGER_32)
		do
			c_set_frames (c_pointer, a_frames)
		end

	set_images (a_images: INTEGER_32)
		do
			c_set_images (c_pointer, a_images)
		end

	set_margin (a_margin: INTEGER_32)
		do
			c_set_margin (c_pointer, a_margin)
		end

	set_plain (a_plain: INTEGER_32)
		do
			c_set_plain (c_pointer, a_plain)
		end

	set_num_links (a_num_links: INTEGER_32)
		do
			c_set_num_links (c_pointer, a_num_links)
		end

	set_table_order (a_table_order: INTEGER_32)
		do
			c_set_table_order (c_pointer, a_table_order)
		end

	set_default_fg (a_default_fg: PD_RGB)
		do
			default_fg.ce_gets (a_default_fg)
		end

	set_default_bg (a_default_bg: PD_RGB)
		do
			default_bg.ce_gets (a_default_bg)
		end

	set_default_link (a_default_link: PD_RGB)
		do
			default_link.ce_gets (a_default_link)
		end

	set_default_vlink (a_default_vlink: PD_RGB)
		do
			default_vlink.ce_gets (a_default_vlink)
		end

	set_framename (a_framename: CE_POINTER [NATURAL_8])
		do
			c_set_framename (c_pointer, a_framename.c_pointer)
		end

	set_real_cp (a_real_cp: INTEGER_32)
		do
			c_set_real_cp (c_pointer, a_real_cp)
		end

feature {NONE} -- C getters

	c_xw (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct document_options *)$tmp)->xw;"
		end

	c_yw (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct document_options *)$tmp)->yw;"
		end

	c_xp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct document_options *)$tmp)->xp;"
		end

	c_yp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct document_options *)$tmp)->yp;"
		end

	c_col (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct document_options *)$tmp)->col;"
		end

	c_cp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct document_options *)$tmp)->cp;"
		end

	c_assume_cp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct document_options *)$tmp)->assume_cp;"
		end

	c_hard_assume (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct document_options *)$tmp)->hard_assume;"
		end

	c_tables (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct document_options *)$tmp)->tables;"
		end

	c_frames (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct document_options *)$tmp)->frames;"
		end

	c_images (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct document_options *)$tmp)->images;"
		end

	c_margin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct document_options *)$tmp)->margin;"
		end

	c_plain (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct document_options *)$tmp)->plain;"
		end

	c_num_links (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct document_options *)$tmp)->num_links;"
		end

	c_table_order (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct document_options *)$tmp)->table_order;"
		end

	c_default_fg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct rgb *)&((struct document_options *)$tmp)->default_fg;"
		end

	c_default_bg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct rgb *)&((struct document_options *)$tmp)->default_bg;"
		end

	c_default_link (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct rgb *)&((struct document_options *)$tmp)->default_link;"
		end

	c_default_vlink (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct rgb *)&((struct document_options *)$tmp)->default_vlink;"
		end

	c_framename (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct document_options *)$tmp)->framename;"
		end

	c_real_cp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct document_options *)$tmp)->real_cp;"
		end

feature {NONE} -- C setters

	c_set_xw (tmp: POINTER; a_xw: INTEGER_32)
		external
			"C inline"
		alias
			"((struct document_options *)$tmp)->xw = $a_xw;"
		end

	c_set_yw (tmp: POINTER; a_yw: INTEGER_32)
		external
			"C inline"
		alias
			"((struct document_options *)$tmp)->yw = $a_yw;"
		end

	c_set_xp (tmp: POINTER; a_xp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct document_options *)$tmp)->xp = $a_xp;"
		end

	c_set_yp (tmp: POINTER; a_yp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct document_options *)$tmp)->yp = $a_yp;"
		end

	c_set_col (tmp: POINTER; a_col: INTEGER_32)
		external
			"C inline"
		alias
			"((struct document_options *)$tmp)->col = $a_col;"
		end

	c_set_cp (tmp: POINTER; a_cp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct document_options *)$tmp)->cp = $a_cp;"
		end

	c_set_assume_cp (tmp: POINTER; a_assume_cp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct document_options *)$tmp)->assume_cp = $a_assume_cp;"
		end

	c_set_hard_assume (tmp: POINTER; a_hard_assume: INTEGER_32)
		external
			"C inline"
		alias
			"((struct document_options *)$tmp)->hard_assume = $a_hard_assume;"
		end

	c_set_tables (tmp: POINTER; a_tables: INTEGER_32)
		external
			"C inline"
		alias
			"((struct document_options *)$tmp)->tables = $a_tables;"
		end

	c_set_frames (tmp: POINTER; a_frames: INTEGER_32)
		external
			"C inline"
		alias
			"((struct document_options *)$tmp)->frames = $a_frames;"
		end

	c_set_images (tmp: POINTER; a_images: INTEGER_32)
		external
			"C inline"
		alias
			"((struct document_options *)$tmp)->images = $a_images;"
		end

	c_set_margin (tmp: POINTER; a_margin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct document_options *)$tmp)->margin = $a_margin;"
		end

	c_set_plain (tmp: POINTER; a_plain: INTEGER_32)
		external
			"C inline"
		alias
			"((struct document_options *)$tmp)->plain = $a_plain;"
		end

	c_set_num_links (tmp: POINTER; a_num_links: INTEGER_32)
		external
			"C inline"
		alias
			"((struct document_options *)$tmp)->num_links = $a_num_links;"
		end

	c_set_table_order (tmp: POINTER; a_table_order: INTEGER_32)
		external
			"C inline"
		alias
			"((struct document_options *)$tmp)->table_order = $a_table_order;"
		end

	c_set_framename (tmp: POINTER; a_framename: POINTER)
		external
			"C inline"
		alias
			"((struct document_options *)$tmp)->framename = (unsigned char *)$a_framename;"
		end

	c_set_real_cp (tmp: POINTER; a_real_cp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct document_options *)$tmp)->real_cp = $a_real_cp;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct document_options);"
		end

end
