class
	PD_DOCUMENT_SETUP

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	assume_cp: INTEGER_32 assign set_assume_cp
		do
			Result := c_assume_cp (c_pointer)
		end

	assume_cp_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct document_setup, assume_cp);"
		end

	hard_assume: INTEGER_32 assign set_hard_assume
		do
			Result := c_hard_assume (c_pointer)
		end

	hard_assume_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct document_setup, hard_assume);"
		end

	tables: INTEGER_32 assign set_tables
		do
			Result := c_tables (c_pointer)
		end

	tables_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct document_setup, tables);"
		end

	frames: INTEGER_32 assign set_frames
		do
			Result := c_frames (c_pointer)
		end

	frames_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct document_setup, frames);"
		end

	images: INTEGER_32 assign set_images
		do
			Result := c_images (c_pointer)
		end

	images_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct document_setup, images);"
		end

	margin: INTEGER_32 assign set_margin
		do
			Result := c_margin (c_pointer)
		end

	margin_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct document_setup, margin);"
		end

	num_links: INTEGER_32 assign set_num_links
		do
			Result := c_num_links (c_pointer)
		end

	num_links_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct document_setup, num_links);"
		end

	table_order: INTEGER_32 assign set_table_order
		do
			Result := c_table_order (c_pointer)
		end

	table_order_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct document_setup, table_order);"
		end

feature {ANY} -- Eiffel setters

	set_assume_cp (a_assume_cp: INTEGER_32)
		do
			c_set_assume_cp (c_pointer, a_assume_cp)
		end

	set_hard_assume (a_hard_assume: INTEGER_32)
		do
			c_set_hard_assume (c_pointer, a_hard_assume)
		end

	set_tables (a_tables: INTEGER_32)
		do
			c_set_tables (c_pointer, a_tables)
		end

	set_frames (a_frames: INTEGER_32)
		do
			c_set_frames (c_pointer, a_frames)
		end

	set_images (a_images: INTEGER_32)
		do
			c_set_images (c_pointer, a_images)
		end

	set_margin (a_margin: INTEGER_32)
		do
			c_set_margin (c_pointer, a_margin)
		end

	set_num_links (a_num_links: INTEGER_32)
		do
			c_set_num_links (c_pointer, a_num_links)
		end

	set_table_order (a_table_order: INTEGER_32)
		do
			c_set_table_order (c_pointer, a_table_order)
		end

feature {NONE} -- C getters

	c_assume_cp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct document_setup *)$tmp)->assume_cp;"
		end

	c_hard_assume (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct document_setup *)$tmp)->hard_assume;"
		end

	c_tables (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct document_setup *)$tmp)->tables;"
		end

	c_frames (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct document_setup *)$tmp)->frames;"
		end

	c_images (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct document_setup *)$tmp)->images;"
		end

	c_margin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct document_setup *)$tmp)->margin;"
		end

	c_num_links (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct document_setup *)$tmp)->num_links;"
		end

	c_table_order (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct document_setup *)$tmp)->table_order;"
		end

feature {NONE} -- C setters

	c_set_assume_cp (tmp: POINTER; a_assume_cp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct document_setup *)$tmp)->assume_cp = $a_assume_cp;"
		end

	c_set_hard_assume (tmp: POINTER; a_hard_assume: INTEGER_32)
		external
			"C inline"
		alias
			"((struct document_setup *)$tmp)->hard_assume = $a_hard_assume;"
		end

	c_set_tables (tmp: POINTER; a_tables: INTEGER_32)
		external
			"C inline"
		alias
			"((struct document_setup *)$tmp)->tables = $a_tables;"
		end

	c_set_frames (tmp: POINTER; a_frames: INTEGER_32)
		external
			"C inline"
		alias
			"((struct document_setup *)$tmp)->frames = $a_frames;"
		end

	c_set_images (tmp: POINTER; a_images: INTEGER_32)
		external
			"C inline"
		alias
			"((struct document_setup *)$tmp)->images = $a_images;"
		end

	c_set_margin (tmp: POINTER; a_margin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct document_setup *)$tmp)->margin = $a_margin;"
		end

	c_set_num_links (tmp: POINTER; a_num_links: INTEGER_32)
		external
			"C inline"
		alias
			"((struct document_setup *)$tmp)->num_links = $a_num_links;"
		end

	c_set_table_order (tmp: POINTER; a_table_order: INTEGER_32)
		external
			"C inline"
		alias
			"((struct document_setup *)$tmp)->table_order = $a_table_order;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct document_setup);"
		end

end
