class
	PD_ENTITIES

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	s: CE_POINTER [INTEGER_8] assign set_s
		do
			create Result.make_shared (c_s (c_pointer))
		end

	c: INTEGER_32 assign set_c
		do
			Result := c_c (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_s (a_s: CE_POINTER [INTEGER_8])
		do
			c_set_s (c_pointer, a_s.c_pointer)
		end

	set_c (a_c: INTEGER_32)
		do
			c_set_c (c_pointer, a_c)
		end

feature {NONE} -- C getters

	c_s (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_entities_68 *)$tmp)->s;"
		end

	c_c (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_entities_68 *)$tmp)->c;"
		end

feature {NONE} -- C setters

	c_set_s (tmp: POINTER; a_s: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_entities_68 *)$tmp)->s = (char *)$a_s;"
		end

	c_set_c (tmp: POINTER; a_c: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_entities_68 *)$tmp)->c = $a_c;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct __anonstruct_entities_68);"
		end

end
