class
	PD_F_DATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_F_DATA] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_F_DATA] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	refcount: INTEGER_32 assign set_refcount
		do
			Result := c_refcount (c_pointer)
		end

	url: CE_POINTER [NATURAL_8] assign set_url
		do
			create Result.make_shared (c_url (c_pointer))
		end

	opt: PD_DOCUMENT_OPTIONS assign set_opt
		do
			create Result.make_shared (c_opt (c_pointer))
		end

	opt_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct f_data, opt);"
		end

	title: CE_POINTER [NATURAL_8] assign set_title
		do
			create Result.make_shared (c_title (c_pointer))
		end

	cp: INTEGER_32 assign set_cp
		do
			Result := c_cp (c_pointer)
		end

	cp_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct f_data, cp);"
		end

	ass: INTEGER_32 assign set_ass
		do
			Result := c_ass (c_pointer)
		end

	ass_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct f_data, ass);"
		end

	x: INTEGER_32 assign set_x
		do
			Result := c_x (c_pointer)
		end

	y: INTEGER_32 assign set_y
		do
			Result := c_y (c_pointer)
		end

	time_to_get: INTEGER_32 assign set_time_to_get
		do
			Result := c_time_to_get (c_pointer)
		end

	use_tag: NATURAL_32 assign set_use_tag
		do
			Result := c_use_tag (c_pointer)
		end

	frame: INTEGER_32 assign set_frame
		do
			Result := c_frame (c_pointer)
		end

	frame_desc: CE_POINTER [PD_FRAMESET_DESC] assign set_frame_desc
		do
			create Result.make_shared (c_frame_desc (c_pointer))
		end

	bg: INTEGER_32 assign set_bg
		do
			Result := c_bg (c_pointer)
		end

	data: CE_POINTER [PD_LINE] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	links: CE_POINTER [PD_LINK] assign set_links
		do
			create Result.make_shared (c_links (c_pointer))
		end

	nlinks: INTEGER_32 assign set_nlinks
		do
			Result := c_nlinks (c_pointer)
		end

	lines1: CE_POINTER [CE_POINTER [PD_LINK]] assign set_lines1
		do
			create Result.make_shared (c_lines1 (c_pointer))
		end

	lines2: CE_POINTER [CE_POINTER [PD_LINK]] assign set_lines2
		do
			create Result.make_shared (c_lines2 (c_pointer))
		end

	forms: PD_LIST_HEAD assign set_forms
		do
			create Result.make_shared (c_forms (c_pointer))
		end

	forms_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct f_data, forms);"
		end

	tags: PD_LIST_HEAD assign set_tags
		do
			create Result.make_shared (c_tags (c_pointer))
		end

	tags_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct f_data, tags);"
		end

	nodes: PD_LIST_HEAD assign set_nodes
		do
			create Result.make_shared (c_nodes (c_pointer))
		end

	nodes_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct f_data, nodes);"
		end

	search: CE_POINTER [PD_SEARCH] assign set_search
		do
			create Result.make_shared (c_search (c_pointer))
		end

	nsearch: INTEGER_32 assign set_nsearch
		do
			Result := c_nsearch (c_pointer)
		end

	slines1: CE_POINTER [CE_POINTER [PD_SEARCH]] assign set_slines1
		do
			create Result.make_shared (c_slines1 (c_pointer))
		end

	slines2: CE_POINTER [CE_POINTER [PD_SEARCH]] assign set_slines2
		do
			create Result.make_shared (c_slines2 (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_F_DATA])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_F_DATA])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_refcount (a_refcount: INTEGER_32)
		do
			c_set_refcount (c_pointer, a_refcount)
		end

	set_url (a_url: CE_POINTER [NATURAL_8])
		do
			c_set_url (c_pointer, a_url.c_pointer)
		end

	set_opt (a_opt: PD_DOCUMENT_OPTIONS)
		do
			opt.ce_gets (a_opt)
		end

	set_title (a_title: CE_POINTER [NATURAL_8])
		do
			c_set_title (c_pointer, a_title.c_pointer)
		end

	set_cp (a_cp: INTEGER_32)
		do
			c_set_cp (c_pointer, a_cp)
		end

	set_ass (a_ass: INTEGER_32)
		do
			c_set_ass (c_pointer, a_ass)
		end

	set_x (a_x: INTEGER_32)
		do
			c_set_x (c_pointer, a_x)
		end

	set_y (a_y: INTEGER_32)
		do
			c_set_y (c_pointer, a_y)
		end

	set_time_to_get (a_time_to_get: INTEGER_32)
		do
			c_set_time_to_get (c_pointer, a_time_to_get)
		end

	set_use_tag (a_use_tag: NATURAL_32)
		do
			c_set_use_tag (c_pointer, a_use_tag)
		end

	set_frame (a_frame: INTEGER_32)
		do
			c_set_frame (c_pointer, a_frame)
		end

	set_frame_desc (a_frame_desc: CE_POINTER [PD_FRAMESET_DESC])
		do
			c_set_frame_desc (c_pointer, a_frame_desc.c_pointer)
		end

	set_bg (a_bg: INTEGER_32)
		do
			c_set_bg (c_pointer, a_bg)
		end

	set_data (a_data: CE_POINTER [PD_LINE])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

	set_links (a_links: CE_POINTER [PD_LINK])
		do
			c_set_links (c_pointer, a_links.c_pointer)
		end

	set_nlinks (a_nlinks: INTEGER_32)
		do
			c_set_nlinks (c_pointer, a_nlinks)
		end

	set_lines1 (a_lines1: CE_POINTER [CE_POINTER [PD_LINK]])
		do
			c_set_lines1 (c_pointer, a_lines1.c_pointer)
		end

	set_lines2 (a_lines2: CE_POINTER [CE_POINTER [PD_LINK]])
		do
			c_set_lines2 (c_pointer, a_lines2.c_pointer)
		end

	set_forms (a_forms: PD_LIST_HEAD)
		do
			forms.ce_gets (a_forms)
		end

	set_tags (a_tags: PD_LIST_HEAD)
		do
			tags.ce_gets (a_tags)
		end

	set_nodes (a_nodes: PD_LIST_HEAD)
		do
			nodes.ce_gets (a_nodes)
		end

	set_search (a_search: CE_POINTER [PD_SEARCH])
		do
			c_set_search (c_pointer, a_search.c_pointer)
		end

	set_nsearch (a_nsearch: INTEGER_32)
		do
			c_set_nsearch (c_pointer, a_nsearch)
		end

	set_slines1 (a_slines1: CE_POINTER [CE_POINTER [PD_SEARCH]])
		do
			c_set_slines1 (c_pointer, a_slines1.c_pointer)
		end

	set_slines2 (a_slines2: CE_POINTER [CE_POINTER [PD_SEARCH]])
		do
			c_set_slines2 (c_pointer, a_slines2.c_pointer)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct f_data *)((struct f_data *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct f_data *)((struct f_data *)$tmp)->prev;"
		end

	c_refcount (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct f_data *)$tmp)->refcount;"
		end

	c_url (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct f_data *)$tmp)->url;"
		end

	c_opt (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct document_options *)&((struct f_data *)$tmp)->opt;"
		end

	c_title (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct f_data *)$tmp)->title;"
		end

	c_cp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct f_data *)$tmp)->cp;"
		end

	c_ass (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct f_data *)$tmp)->ass;"
		end

	c_x (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct f_data *)$tmp)->x;"
		end

	c_y (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct f_data *)$tmp)->y;"
		end

	c_time_to_get (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct f_data *)$tmp)->time_to_get;"
		end

	c_use_tag (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct f_data *)$tmp)->use_tag;"
		end

	c_frame (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct f_data *)$tmp)->frame;"
		end

	c_frame_desc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct frameset_desc *)((struct f_data *)$tmp)->frame_desc;"
		end

	c_bg (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct f_data *)$tmp)->bg;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct line *)((struct f_data *)$tmp)->data;"
		end

	c_links (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct link *)((struct f_data *)$tmp)->links;"
		end

	c_nlinks (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct f_data *)$tmp)->nlinks;"
		end

	c_lines1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct link * *)((struct f_data *)$tmp)->lines1;"
		end

	c_lines2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct link * *)((struct f_data *)$tmp)->lines2;"
		end

	c_forms (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct list_head *)&((struct f_data *)$tmp)->forms;"
		end

	c_tags (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct list_head *)&((struct f_data *)$tmp)->tags;"
		end

	c_nodes (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct list_head *)&((struct f_data *)$tmp)->nodes;"
		end

	c_search (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct search *)((struct f_data *)$tmp)->search;"
		end

	c_nsearch (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct f_data *)$tmp)->nsearch;"
		end

	c_slines1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct search * *)((struct f_data *)$tmp)->slines1;"
		end

	c_slines2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct search * *)((struct f_data *)$tmp)->slines2;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct f_data *)$tmp)->next = (struct f_data *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct f_data *)$tmp)->prev = (struct f_data *)$a_prev;"
		end

	c_set_refcount (tmp: POINTER; a_refcount: INTEGER_32)
		external
			"C inline"
		alias
			"((struct f_data *)$tmp)->refcount = $a_refcount;"
		end

	c_set_url (tmp: POINTER; a_url: POINTER)
		external
			"C inline"
		alias
			"((struct f_data *)$tmp)->url = (unsigned char *)$a_url;"
		end

	c_set_title (tmp: POINTER; a_title: POINTER)
		external
			"C inline"
		alias
			"((struct f_data *)$tmp)->title = (unsigned char *)$a_title;"
		end

	c_set_cp (tmp: POINTER; a_cp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct f_data *)$tmp)->cp = $a_cp;"
		end

	c_set_ass (tmp: POINTER; a_ass: INTEGER_32)
		external
			"C inline"
		alias
			"((struct f_data *)$tmp)->ass = $a_ass;"
		end

	c_set_x (tmp: POINTER; a_x: INTEGER_32)
		external
			"C inline"
		alias
			"((struct f_data *)$tmp)->x = $a_x;"
		end

	c_set_y (tmp: POINTER; a_y: INTEGER_32)
		external
			"C inline"
		alias
			"((struct f_data *)$tmp)->y = $a_y;"
		end

	c_set_time_to_get (tmp: POINTER; a_time_to_get: INTEGER_32)
		external
			"C inline"
		alias
			"((struct f_data *)$tmp)->time_to_get = $a_time_to_get;"
		end

	c_set_use_tag (tmp: POINTER; a_use_tag: NATURAL_32)
		external
			"C inline"
		alias
			"((struct f_data *)$tmp)->use_tag = $a_use_tag;"
		end

	c_set_frame (tmp: POINTER; a_frame: INTEGER_32)
		external
			"C inline"
		alias
			"((struct f_data *)$tmp)->frame = $a_frame;"
		end

	c_set_frame_desc (tmp: POINTER; a_frame_desc: POINTER)
		external
			"C inline"
		alias
			"((struct f_data *)$tmp)->frame_desc = (struct frameset_desc *)$a_frame_desc;"
		end

	c_set_bg (tmp: POINTER; a_bg: INTEGER_32)
		external
			"C inline"
		alias
			"((struct f_data *)$tmp)->bg = $a_bg;"
		end

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct f_data *)$tmp)->data = (struct line *)$a_data;"
		end

	c_set_links (tmp: POINTER; a_links: POINTER)
		external
			"C inline"
		alias
			"((struct f_data *)$tmp)->links = (struct link *)$a_links;"
		end

	c_set_nlinks (tmp: POINTER; a_nlinks: INTEGER_32)
		external
			"C inline"
		alias
			"((struct f_data *)$tmp)->nlinks = $a_nlinks;"
		end

	c_set_lines1 (tmp: POINTER; a_lines1: POINTER)
		external
			"C inline"
		alias
			"((struct f_data *)$tmp)->lines1 = (struct link * *)$a_lines1;"
		end

	c_set_lines2 (tmp: POINTER; a_lines2: POINTER)
		external
			"C inline"
		alias
			"((struct f_data *)$tmp)->lines2 = (struct link * *)$a_lines2;"
		end

	c_set_search (tmp: POINTER; a_search: POINTER)
		external
			"C inline"
		alias
			"((struct f_data *)$tmp)->search = (struct search *)$a_search;"
		end

	c_set_nsearch (tmp: POINTER; a_nsearch: INTEGER_32)
		external
			"C inline"
		alias
			"((struct f_data *)$tmp)->nsearch = $a_nsearch;"
		end

	c_set_slines1 (tmp: POINTER; a_slines1: POINTER)
		external
			"C inline"
		alias
			"((struct f_data *)$tmp)->slines1 = (struct search * *)$a_slines1;"
		end

	c_set_slines2 (tmp: POINTER; a_slines2: POINTER)
		external
			"C inline"
		alias
			"((struct f_data *)$tmp)->slines2 = (struct search * *)$a_slines2;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct f_data);"
		end

end
