class
	PD_F_DATA_C

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_F_DATA_C] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_F_DATA_C] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	used: INTEGER_32 assign set_used
		do
			Result := c_used (c_pointer)
		end

	name: CE_POINTER [NATURAL_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	f_data: CE_POINTER [PD_F_DATA] assign set_f_data
		do
			create Result.make_shared (c_f_data (c_pointer))
		end

	xw: INTEGER_32 assign set_xw
		do
			Result := c_xw (c_pointer)
		end

	yw: INTEGER_32 assign set_yw
		do
			Result := c_yw (c_pointer)
		end

	xp: INTEGER_32 assign set_xp
		do
			Result := c_xp (c_pointer)
		end

	yp: INTEGER_32 assign set_yp
		do
			Result := c_yp (c_pointer)
		end

	xl: INTEGER_32 assign set_xl
		do
			Result := c_xl (c_pointer)
		end

	yl: INTEGER_32 assign set_yl
		do
			Result := c_yl (c_pointer)
		end

	link_bg: CE_POINTER [PD_LINK_BG] assign set_link_bg
		do
			create Result.make_shared (c_link_bg (c_pointer))
		end

	link_bg_n: INTEGER_32 assign set_link_bg_n
		do
			Result := c_link_bg_n (c_pointer)
		end

	search_word: CE_POINTER [CE_POINTER [NATURAL_8]] assign set_search_word
		do
			create Result.make_shared (c_search_word (c_pointer))
		end

	vs: CE_POINTER [PD_VIEW_STATE] assign set_vs
		do
			create Result.make_shared (c_vs (c_pointer))
		end

	depth: INTEGER_32 assign set_depth
		do
			Result := c_depth (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_F_DATA_C])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_F_DATA_C])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_used (a_used: INTEGER_32)
		do
			c_set_used (c_pointer, a_used)
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_f_data (a_f_data: CE_POINTER [PD_F_DATA])
		do
			c_set_f_data (c_pointer, a_f_data.c_pointer)
		end

	set_xw (a_xw: INTEGER_32)
		do
			c_set_xw (c_pointer, a_xw)
		end

	set_yw (a_yw: INTEGER_32)
		do
			c_set_yw (c_pointer, a_yw)
		end

	set_xp (a_xp: INTEGER_32)
		do
			c_set_xp (c_pointer, a_xp)
		end

	set_yp (a_yp: INTEGER_32)
		do
			c_set_yp (c_pointer, a_yp)
		end

	set_xl (a_xl: INTEGER_32)
		do
			c_set_xl (c_pointer, a_xl)
		end

	set_yl (a_yl: INTEGER_32)
		do
			c_set_yl (c_pointer, a_yl)
		end

	set_link_bg (a_link_bg: CE_POINTER [PD_LINK_BG])
		do
			c_set_link_bg (c_pointer, a_link_bg.c_pointer)
		end

	set_link_bg_n (a_link_bg_n: INTEGER_32)
		do
			c_set_link_bg_n (c_pointer, a_link_bg_n)
		end

	set_search_word (a_search_word: CE_POINTER [CE_POINTER [NATURAL_8]])
		do
			c_set_search_word (c_pointer, a_search_word.c_pointer)
		end

	set_vs (a_vs: CE_POINTER [PD_VIEW_STATE])
		do
			c_set_vs (c_pointer, a_vs.c_pointer)
		end

	set_depth (a_depth: INTEGER_32)
		do
			c_set_depth (c_pointer, a_depth)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct f_data_c *)((struct f_data_c *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct f_data_c *)((struct f_data_c *)$tmp)->prev;"
		end

	c_used (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct f_data_c *)$tmp)->used;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct f_data_c *)$tmp)->name;"
		end

	c_f_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct f_data *)((struct f_data_c *)$tmp)->f_data;"
		end

	c_xw (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct f_data_c *)$tmp)->xw;"
		end

	c_yw (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct f_data_c *)$tmp)->yw;"
		end

	c_xp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct f_data_c *)$tmp)->xp;"
		end

	c_yp (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct f_data_c *)$tmp)->yp;"
		end

	c_xl (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct f_data_c *)$tmp)->xl;"
		end

	c_yl (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct f_data_c *)$tmp)->yl;"
		end

	c_link_bg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct link_bg *)((struct f_data_c *)$tmp)->link_bg;"
		end

	c_link_bg_n (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct f_data_c *)$tmp)->link_bg_n;"
		end

	c_search_word (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char * *)((struct f_data_c *)$tmp)->search_word;"
		end

	c_vs (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct view_state *)((struct f_data_c *)$tmp)->vs;"
		end

	c_depth (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct f_data_c *)$tmp)->depth;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct f_data_c *)$tmp)->next = (struct f_data_c *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct f_data_c *)$tmp)->prev = (struct f_data_c *)$a_prev;"
		end

	c_set_used (tmp: POINTER; a_used: INTEGER_32)
		external
			"C inline"
		alias
			"((struct f_data_c *)$tmp)->used = $a_used;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct f_data_c *)$tmp)->name = (unsigned char *)$a_name;"
		end

	c_set_f_data (tmp: POINTER; a_f_data: POINTER)
		external
			"C inline"
		alias
			"((struct f_data_c *)$tmp)->f_data = (struct f_data *)$a_f_data;"
		end

	c_set_xw (tmp: POINTER; a_xw: INTEGER_32)
		external
			"C inline"
		alias
			"((struct f_data_c *)$tmp)->xw = $a_xw;"
		end

	c_set_yw (tmp: POINTER; a_yw: INTEGER_32)
		external
			"C inline"
		alias
			"((struct f_data_c *)$tmp)->yw = $a_yw;"
		end

	c_set_xp (tmp: POINTER; a_xp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct f_data_c *)$tmp)->xp = $a_xp;"
		end

	c_set_yp (tmp: POINTER; a_yp: INTEGER_32)
		external
			"C inline"
		alias
			"((struct f_data_c *)$tmp)->yp = $a_yp;"
		end

	c_set_xl (tmp: POINTER; a_xl: INTEGER_32)
		external
			"C inline"
		alias
			"((struct f_data_c *)$tmp)->xl = $a_xl;"
		end

	c_set_yl (tmp: POINTER; a_yl: INTEGER_32)
		external
			"C inline"
		alias
			"((struct f_data_c *)$tmp)->yl = $a_yl;"
		end

	c_set_link_bg (tmp: POINTER; a_link_bg: POINTER)
		external
			"C inline"
		alias
			"((struct f_data_c *)$tmp)->link_bg = (struct link_bg *)$a_link_bg;"
		end

	c_set_link_bg_n (tmp: POINTER; a_link_bg_n: INTEGER_32)
		external
			"C inline"
		alias
			"((struct f_data_c *)$tmp)->link_bg_n = $a_link_bg_n;"
		end

	c_set_search_word (tmp: POINTER; a_search_word: POINTER)
		external
			"C inline"
		alias
			"((struct f_data_c *)$tmp)->search_word = (unsigned char * *)$a_search_word;"
		end

	c_set_vs (tmp: POINTER; a_vs: POINTER)
		external
			"C inline"
		alias
			"((struct f_data_c *)$tmp)->vs = (struct view_state *)$a_vs;"
		end

	c_set_depth (tmp: POINTER; a_depth: INTEGER_32)
		external
			"C inline"
		alias
			"((struct f_data_c *)$tmp)->depth = $a_depth;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct f_data_c);"
		end

end
