class
	PD_FORM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	action: CE_POINTER [NATURAL_8] assign set_action
		do
			create Result.make_shared (c_action (c_pointer))
		end

	target: CE_POINTER [NATURAL_8] assign set_target
		do
			create Result.make_shared (c_target (c_pointer))
		end

	method: INTEGER_32 assign set_method
		do
			Result := c_method (c_pointer)
		end

	num: INTEGER_32 assign set_num
		do
			Result := c_num (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_action (a_action: CE_POINTER [NATURAL_8])
		do
			c_set_action (c_pointer, a_action.c_pointer)
		end

	set_target (a_target: CE_POINTER [NATURAL_8])
		do
			c_set_target (c_pointer, a_target.c_pointer)
		end

	set_method (a_method: INTEGER_32)
		do
			c_set_method (c_pointer, a_method)
		end

	set_num (a_num: INTEGER_32)
		do
			c_set_num (c_pointer, a_num)
		end

feature {NONE} -- C getters

	c_action (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct form *)$tmp)->action;"
		end

	c_target (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct form *)$tmp)->target;"
		end

	c_method (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct form *)$tmp)->method;"
		end

	c_num (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct form *)$tmp)->num;"
		end

feature {NONE} -- C setters

	c_set_action (tmp: POINTER; a_action: POINTER)
		external
			"C inline"
		alias
			"((struct form *)$tmp)->action = (unsigned char *)$a_action;"
		end

	c_set_target (tmp: POINTER; a_target: POINTER)
		external
			"C inline"
		alias
			"((struct form *)$tmp)->target = (unsigned char *)$a_target;"
		end

	c_set_method (tmp: POINTER; a_method: INTEGER_32)
		external
			"C inline"
		alias
			"((struct form *)$tmp)->method = $a_method;"
		end

	c_set_num (tmp: POINTER; a_num: INTEGER_32)
		external
			"C inline"
		alias
			"((struct form *)$tmp)->num = $a_num;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct form);"
		end

end
