class
	PD_FORM_STATE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	form_num: INTEGER_32 assign set_form_num
		do
			Result := c_form_num (c_pointer)
		end

	ctrl_num: INTEGER_32 assign set_ctrl_num
		do
			Result := c_ctrl_num (c_pointer)
		end

	g_ctrl_num: INTEGER_32 assign set_g_ctrl_num
		do
			Result := c_g_ctrl_num (c_pointer)
		end

	position: INTEGER_32 assign set_position
		do
			Result := c_position (c_pointer)
		end

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	value: CE_POINTER [NATURAL_8] assign set_value
		do
			create Result.make_shared (c_value (c_pointer))
		end

	state: INTEGER_32 assign set_state
		do
			Result := c_state (c_pointer)
		end

	vpos: INTEGER_32 assign set_vpos
		do
			Result := c_vpos (c_pointer)
		end

	vypos: INTEGER_32 assign set_vypos
		do
			Result := c_vypos (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_form_num (a_form_num: INTEGER_32)
		do
			c_set_form_num (c_pointer, a_form_num)
		end

	set_ctrl_num (a_ctrl_num: INTEGER_32)
		do
			c_set_ctrl_num (c_pointer, a_ctrl_num)
		end

	set_g_ctrl_num (a_g_ctrl_num: INTEGER_32)
		do
			c_set_g_ctrl_num (c_pointer, a_g_ctrl_num)
		end

	set_position (a_position: INTEGER_32)
		do
			c_set_position (c_pointer, a_position)
		end

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_value (a_value: CE_POINTER [NATURAL_8])
		do
			c_set_value (c_pointer, a_value.c_pointer)
		end

	set_state (a_state: INTEGER_32)
		do
			c_set_state (c_pointer, a_state)
		end

	set_vpos (a_vpos: INTEGER_32)
		do
			c_set_vpos (c_pointer, a_vpos)
		end

	set_vypos (a_vypos: INTEGER_32)
		do
			c_set_vypos (c_pointer, a_vypos)
		end

feature {NONE} -- C getters

	c_form_num (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct form_state *)$tmp)->form_num;"
		end

	c_ctrl_num (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct form_state *)$tmp)->ctrl_num;"
		end

	c_g_ctrl_num (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct form_state *)$tmp)->g_ctrl_num;"
		end

	c_position (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct form_state *)$tmp)->position;"
		end

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct form_state *)$tmp)->type;"
		end

	c_value (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct form_state *)$tmp)->value;"
		end

	c_state (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct form_state *)$tmp)->state;"
		end

	c_vpos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct form_state *)$tmp)->vpos;"
		end

	c_vypos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct form_state *)$tmp)->vypos;"
		end

feature {NONE} -- C setters

	c_set_form_num (tmp: POINTER; a_form_num: INTEGER_32)
		external
			"C inline"
		alias
			"((struct form_state *)$tmp)->form_num = $a_form_num;"
		end

	c_set_ctrl_num (tmp: POINTER; a_ctrl_num: INTEGER_32)
		external
			"C inline"
		alias
			"((struct form_state *)$tmp)->ctrl_num = $a_ctrl_num;"
		end

	c_set_g_ctrl_num (tmp: POINTER; a_g_ctrl_num: INTEGER_32)
		external
			"C inline"
		alias
			"((struct form_state *)$tmp)->g_ctrl_num = $a_g_ctrl_num;"
		end

	c_set_position (tmp: POINTER; a_position: INTEGER_32)
		external
			"C inline"
		alias
			"((struct form_state *)$tmp)->position = $a_position;"
		end

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct form_state *)$tmp)->type = $a_type;"
		end

	c_set_value (tmp: POINTER; a_value: POINTER)
		external
			"C inline"
		alias
			"((struct form_state *)$tmp)->value = (unsigned char *)$a_value;"
		end

	c_set_state (tmp: POINTER; a_state: INTEGER_32)
		external
			"C inline"
		alias
			"((struct form_state *)$tmp)->state = $a_state;"
		end

	c_set_vpos (tmp: POINTER; a_vpos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct form_state *)$tmp)->vpos = $a_vpos;"
		end

	c_set_vypos (tmp: POINTER; a_vypos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct form_state *)$tmp)->vypos = $a_vypos;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct form_state);"
		end

end
