class
	PD_FRAME_DESC

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	subframe: CE_POINTER [PD_FRAMESET_DESC] assign set_subframe
		do
			create Result.make_shared (c_subframe (c_pointer))
		end

	name: CE_POINTER [NATURAL_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	url: CE_POINTER [NATURAL_8] assign set_url
		do
			create Result.make_shared (c_url (c_pointer))
		end

	line: INTEGER_32 assign set_line
		do
			Result := c_line (c_pointer)
		end

	xw: INTEGER_32 assign set_xw
		do
			Result := c_xw (c_pointer)
		end

	yw: INTEGER_32 assign set_yw
		do
			Result := c_yw (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_subframe (a_subframe: CE_POINTER [PD_FRAMESET_DESC])
		do
			c_set_subframe (c_pointer, a_subframe.c_pointer)
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_url (a_url: CE_POINTER [NATURAL_8])
		do
			c_set_url (c_pointer, a_url.c_pointer)
		end

	set_line (a_line: INTEGER_32)
		do
			c_set_line (c_pointer, a_line)
		end

	set_xw (a_xw: INTEGER_32)
		do
			c_set_xw (c_pointer, a_xw)
		end

	set_yw (a_yw: INTEGER_32)
		do
			c_set_yw (c_pointer, a_yw)
		end

feature {NONE} -- C getters

	c_subframe (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct frameset_desc *)((struct frame_desc *)$tmp)->subframe;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct frame_desc *)$tmp)->name;"
		end

	c_url (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct frame_desc *)$tmp)->url;"
		end

	c_line (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct frame_desc *)$tmp)->line;"
		end

	c_xw (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct frame_desc *)$tmp)->xw;"
		end

	c_yw (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct frame_desc *)$tmp)->yw;"
		end

feature {NONE} -- C setters

	c_set_subframe (tmp: POINTER; a_subframe: POINTER)
		external
			"C inline"
		alias
			"((struct frame_desc *)$tmp)->subframe = (struct frameset_desc *)$a_subframe;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct frame_desc *)$tmp)->name = (unsigned char *)$a_name;"
		end

	c_set_url (tmp: POINTER; a_url: POINTER)
		external
			"C inline"
		alias
			"((struct frame_desc *)$tmp)->url = (unsigned char *)$a_url;"
		end

	c_set_line (tmp: POINTER; a_line: INTEGER_32)
		external
			"C inline"
		alias
			"((struct frame_desc *)$tmp)->line = $a_line;"
		end

	c_set_xw (tmp: POINTER; a_xw: INTEGER_32)
		external
			"C inline"
		alias
			"((struct frame_desc *)$tmp)->xw = $a_xw;"
		end

	c_set_yw (tmp: POINTER; a_yw: INTEGER_32)
		external
			"C inline"
		alias
			"((struct frame_desc *)$tmp)->yw = $a_yw;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct frame_desc);"
		end

end
