class
	PD_FRAME_PARAM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	parent: CE_POINTER [PD_FRAMESET_DESC] assign set_parent
		do
			create Result.make_shared (c_parent (c_pointer))
		end

	name: CE_POINTER [NATURAL_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	url: CE_POINTER [NATURAL_8] assign set_url
		do
			create Result.make_shared (c_url (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_parent (a_parent: CE_POINTER [PD_FRAMESET_DESC])
		do
			c_set_parent (c_pointer, a_parent.c_pointer)
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_url (a_url: CE_POINTER [NATURAL_8])
		do
			c_set_url (c_pointer, a_url.c_pointer)
		end

feature {NONE} -- C getters

	c_parent (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct frameset_desc *)((struct frame_param *)$tmp)->parent;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct frame_param *)$tmp)->name;"
		end

	c_url (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct frame_param *)$tmp)->url;"
		end

feature {NONE} -- C setters

	c_set_parent (tmp: POINTER; a_parent: POINTER)
		external
			"C inline"
		alias
			"((struct frame_param *)$tmp)->parent = (struct frameset_desc *)$a_parent;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct frame_param *)$tmp)->name = (unsigned char *)$a_name;"
		end

	c_set_url (tmp: POINTER; a_url: POINTER)
		external
			"C inline"
		alias
			"((struct frame_param *)$tmp)->url = (unsigned char *)$a_url;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct frame_param);"
		end

end
