class
	PD_HTTP_BUGS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	http10: INTEGER_32 assign set_http10
		do
			Result := c_http10 (c_pointer)
		end

	http10_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct http_bugs, http10);"
		end

	allow_blacklist: INTEGER_32 assign set_allow_blacklist
		do
			Result := c_allow_blacklist (c_pointer)
		end

	allow_blacklist_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct http_bugs, allow_blacklist);"
		end

	bug_302_redirect: INTEGER_32 assign set_bug_302_redirect
		do
			Result := c_bug_302_redirect (c_pointer)
		end

	bug_302_redirect_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct http_bugs, bug_302_redirect);"
		end

	bug_post_no_keepalive: INTEGER_32 assign set_bug_post_no_keepalive
		do
			Result := c_bug_post_no_keepalive (c_pointer)
		end

	bug_post_no_keepalive_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct http_bugs, bug_post_no_keepalive);"
		end

	no_accept_charset: INTEGER_32 assign set_no_accept_charset
		do
			Result := c_no_accept_charset (c_pointer)
		end

	no_accept_charset_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct http_bugs, no_accept_charset);"
		end

feature {ANY} -- Eiffel setters

	set_http10 (a_http10: INTEGER_32)
		do
			c_set_http10 (c_pointer, a_http10)
		end

	set_allow_blacklist (a_allow_blacklist: INTEGER_32)
		do
			c_set_allow_blacklist (c_pointer, a_allow_blacklist)
		end

	set_bug_302_redirect (a_bug_302_redirect: INTEGER_32)
		do
			c_set_bug_302_redirect (c_pointer, a_bug_302_redirect)
		end

	set_bug_post_no_keepalive (a_bug_post_no_keepalive: INTEGER_32)
		do
			c_set_bug_post_no_keepalive (c_pointer, a_bug_post_no_keepalive)
		end

	set_no_accept_charset (a_no_accept_charset: INTEGER_32)
		do
			c_set_no_accept_charset (c_pointer, a_no_accept_charset)
		end

feature {NONE} -- C getters

	c_http10 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct http_bugs *)$tmp)->http10;"
		end

	c_allow_blacklist (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct http_bugs *)$tmp)->allow_blacklist;"
		end

	c_bug_302_redirect (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct http_bugs *)$tmp)->bug_302_redirect;"
		end

	c_bug_post_no_keepalive (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct http_bugs *)$tmp)->bug_post_no_keepalive;"
		end

	c_no_accept_charset (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct http_bugs *)$tmp)->no_accept_charset;"
		end

feature {NONE} -- C setters

	c_set_http10 (tmp: POINTER; a_http10: INTEGER_32)
		external
			"C inline"
		alias
			"((struct http_bugs *)$tmp)->http10 = $a_http10;"
		end

	c_set_allow_blacklist (tmp: POINTER; a_allow_blacklist: INTEGER_32)
		external
			"C inline"
		alias
			"((struct http_bugs *)$tmp)->allow_blacklist = $a_allow_blacklist;"
		end

	c_set_bug_302_redirect (tmp: POINTER; a_bug_302_redirect: INTEGER_32)
		external
			"C inline"
		alias
			"((struct http_bugs *)$tmp)->bug_302_redirect = $a_bug_302_redirect;"
		end

	c_set_bug_post_no_keepalive (tmp: POINTER; a_bug_post_no_keepalive: INTEGER_32)
		external
			"C inline"
		alias
			"((struct http_bugs *)$tmp)->bug_post_no_keepalive = $a_bug_post_no_keepalive;"
		end

	c_set_no_accept_charset (tmp: POINTER; a_no_accept_charset: INTEGER_32)
		external
			"C inline"
		alias
			"((struct http_bugs *)$tmp)->no_accept_charset = $a_no_accept_charset;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct http_bugs);"
		end

end
