class
	PD_LINE_INFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	st: CE_POINTER [NATURAL_8] assign set_st
		do
			create Result.make_shared (c_st (c_pointer))
		end

	en: CE_POINTER [NATURAL_8] assign set_en
		do
			create Result.make_shared (c_en (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_st (a_st: CE_POINTER [NATURAL_8])
		do
			c_set_st (c_pointer, a_st.c_pointer)
		end

	set_en (a_en: CE_POINTER [NATURAL_8])
		do
			c_set_en (c_pointer, a_en.c_pointer)
		end

feature {NONE} -- C getters

	c_st (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct line_info *)$tmp)->st;"
		end

	c_en (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct line_info *)$tmp)->en;"
		end

feature {NONE} -- C setters

	c_set_st (tmp: POINTER; a_st: POINTER)
		external
			"C inline"
		alias
			"((struct line_info *)$tmp)->st = (unsigned char *)$a_st;"
		end

	c_set_en (tmp: POINTER; a_en: POINTER)
		external
			"C inline"
		alias
			"((struct line_info *)$tmp)->en = (unsigned char *)$a_en;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct line_info);"
		end

end
