class
	PD_LINK_BG

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	x: INTEGER_32 assign set_x
		do
			Result := c_x (c_pointer)
		end

	y: INTEGER_32 assign set_y
		do
			Result := c_y (c_pointer)
		end

	c: NATURAL_32 assign set_c
		do
			Result := c_c (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_x (a_x: INTEGER_32)
		do
			c_set_x (c_pointer, a_x)
		end

	set_y (a_y: INTEGER_32)
		do
			c_set_y (c_pointer, a_y)
		end

	set_c (a_c: NATURAL_32)
		do
			c_set_c (c_pointer, a_c)
		end

feature {NONE} -- C getters

	c_x (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct link_bg *)$tmp)->x;"
		end

	c_y (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct link_bg *)$tmp)->y;"
		end

	c_c (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct link_bg *)$tmp)->c;"
		end

feature {NONE} -- C setters

	c_set_x (tmp: POINTER; a_x: INTEGER_32)
		external
			"C inline"
		alias
			"((struct link_bg *)$tmp)->x = $a_x;"
		end

	c_set_y (tmp: POINTER; a_y: INTEGER_32)
		external
			"C inline"
		alias
			"((struct link_bg *)$tmp)->y = $a_y;"
		end

	c_set_c (tmp: POINTER; a_c: NATURAL_32)
		external
			"C inline"
		alias
			"((struct link_bg *)$tmp)->c = $a_c;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct link_bg);"
		end

end
