class
	PD_OINW

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	env: INTEGER_32 assign set_env
		do
			Result := c_env (c_pointer)
		end

	fn: CE_ROUTINE assign set_fn
		do
			create Result.make_shared (c_fn (c_pointer))
		end

	text: CE_POINTER [NATURAL_8] assign set_text
		do
			create Result.make_shared (c_text (c_pointer))
		end

	hk: CE_POINTER [NATURAL_8] assign set_hk
		do
			create Result.make_shared (c_hk (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_env (a_env: INTEGER_32)
		do
			c_set_env (c_pointer, a_env)
		end

	set_fn (a_fn: CE_ROUTINE)
		do
			c_set_fn (c_pointer, a_fn.c_pointer)
		end

	set_text (a_text: CE_POINTER [NATURAL_8])
		do
			c_set_text (c_pointer, a_text.c_pointer)
		end

	set_hk (a_hk: CE_POINTER [NATURAL_8])
		do
			c_set_hk (c_pointer, a_hk.c_pointer)
		end

feature {NONE} -- C getters

	c_env (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_oinw_67 *)$tmp)->env;"
		end

	c_fn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct terminal * term, unsigned char *, unsigned char *))((struct __anonstruct_oinw_67 *)$tmp)->fn;"
		end

	c_text (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_oinw_67 *)$tmp)->text;"
		end

	c_hk (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_oinw_67 *)$tmp)->hk;"
		end

feature {NONE} -- C setters

	c_set_env (tmp: POINTER; a_env: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_oinw_67 *)$tmp)->env = $a_env;"
		end

	c_set_fn (tmp: POINTER; a_fn: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_oinw_67 *)$tmp)->fn = (void( *)(struct terminal * term, unsigned char *, unsigned char *))$a_fn;"
		end

	c_set_text (tmp: POINTER; a_text: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_oinw_67 *)$tmp)->text = (unsigned char *)$a_text;"
		end

	c_set_hk (tmp: POINTER; a_hk: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_oinw_67 *)$tmp)->hk = (unsigned char *)$a_hk;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct __anonstruct_oinw_67);"
		end

end
