class
	PD_OPTION_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_INCLUDE_ON_CYGWIN

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	p: INTEGER_32 assign set_p
		do
			Result := c_p (c_pointer)
		end

	rd_cmd: CE_ROUTINE assign set_rd_cmd
		do
			create Result.make_shared (c_rd_cmd (c_pointer))
		end

	rd_cfg: CE_ROUTINE assign set_rd_cfg
		do
			create Result.make_shared (c_rd_cfg (c_pointer))
		end

	wr_cfg: CE_ROUTINE assign set_wr_cfg
		do
			create Result.make_shared (c_wr_cfg (c_pointer))
		end

	min: INTEGER_32 assign set_min
		do
			Result := c_min (c_pointer)
		end

	max: INTEGER_32 assign set_max
		do
			Result := c_max (c_pointer)
		end

	ptr: CE_POINTER [ANY] assign set_ptr
		do
			create Result.make_shared (c_ptr (c_pointer))
		end

	cfg_name: CE_POINTER [NATURAL_8] assign set_cfg_name
		do
			create Result.make_shared (c_cfg_name (c_pointer))
		end

	cmd_name: CE_POINTER [NATURAL_8] assign set_cmd_name
		do
			create Result.make_shared (c_cmd_name (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_p (a_p: INTEGER_32)
		do
			c_set_p (c_pointer, a_p)
		end

	set_rd_cmd (a_rd_cmd: CE_ROUTINE)
		do
			c_set_rd_cmd (c_pointer, a_rd_cmd.c_pointer)
		end

	set_rd_cfg (a_rd_cfg: CE_ROUTINE)
		do
			c_set_rd_cfg (c_pointer, a_rd_cfg.c_pointer)
		end

	set_wr_cfg (a_wr_cfg: CE_ROUTINE)
		do
			c_set_wr_cfg (c_pointer, a_wr_cfg.c_pointer)
		end

	set_min (a_min: INTEGER_32)
		do
			c_set_min (c_pointer, a_min)
		end

	set_max (a_max: INTEGER_32)
		do
			c_set_max (c_pointer, a_max)
		end

	set_ptr (a_ptr: CE_POINTER [ANY])
		do
			c_set_ptr (c_pointer, a_ptr.c_pointer)
		end

	set_cfg_name (a_cfg_name: CE_POINTER [NATURAL_8])
		do
			c_set_cfg_name (c_pointer, a_cfg_name.c_pointer)
		end

	set_cmd_name (a_cmd_name: CE_POINTER [NATURAL_8])
		do
			c_set_cmd_name (c_pointer, a_cmd_name.c_pointer)
		end

feature {NONE} -- C getters

	c_p (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *)$tmp)->p;"
		end

	c_rd_cmd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *( *)(struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *, unsigned char * * *, int *))((struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *)$tmp)->rd_cmd;"
		end

	c_rd_cfg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *( *)(struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *, unsigned char *))((struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *)$tmp)->rd_cfg;"
		end

	c_wr_cfg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *, unsigned char * *, int *))((struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *)$tmp)->wr_cfg;"
		end

	c_min (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *)$tmp)->min;"
		end

	c_max (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *)$tmp)->max;"
		end

	c_ptr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *)$tmp)->ptr;"
		end

	c_cfg_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *)$tmp)->cfg_name;"
		end

	c_cmd_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *)$tmp)->cmd_name;"
		end

feature {NONE} -- C setters

	c_set_p (tmp: POINTER; a_p: INTEGER_32)
		external
			"C inline"
		alias
			"((struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *)$tmp)->p = $a_p;"
		end

	c_set_rd_cmd (tmp: POINTER; a_rd_cmd: POINTER)
		external
			"C inline"
		alias
			"((struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *)$tmp)->rd_cmd = (unsigned char *( *)(struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *, unsigned char * * *, int *))$a_rd_cmd;"
		end

	c_set_rd_cfg (tmp: POINTER; a_rd_cfg: POINTER)
		external
			"C inline"
		alias
			"((struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *)$tmp)->rd_cfg = (unsigned char *( *)(struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *, unsigned char *))$a_rd_cfg;"
		end

	c_set_wr_cfg (tmp: POINTER; a_wr_cfg: POINTER)
		external
			"C inline"
		alias
			"((struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *)$tmp)->wr_cfg = (void( *)(struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *, unsigned char * *, int *))$a_wr_cfg;"
		end

	c_set_min (tmp: POINTER; a_min: INTEGER_32)
		external
			"C inline"
		alias
			"((struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *)$tmp)->min = $a_min;"
		end

	c_set_max (tmp: POINTER; a_max: INTEGER_32)
		external
			"C inline"
		alias
			"((struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *)$tmp)->max = $a_max;"
		end

	c_set_ptr (tmp: POINTER; a_ptr: POINTER)
		external
			"C inline"
		alias
			"((struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *)$tmp)->ptr = (void *)$a_ptr;"
		end

	c_set_cfg_name (tmp: POINTER; a_cfg_name: POINTER)
		external
			"C inline"
		alias
			"((struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *)$tmp)->cfg_name = (unsigned char *)$a_cfg_name;"
		end

	c_set_cmd_name (tmp: POINTER; a_cmd_name: POINTER)
		external
			"C inline"
		alias
			"((struct option_dirty_workaround_for_name_clash_with_include_on_cygwin *)$tmp)->cmd_name = (unsigned char *)$a_cmd_name;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct option_dirty_workaround_for_name_clash_with_include_on_cygwin);"
		end

end
