class
	PD_PAR_ATTRIB

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	align: INTEGER_32 assign set_align
		do
			Result := c_align (c_pointer)
		end

	leftmargin: INTEGER_32 assign set_leftmargin
		do
			Result := c_leftmargin (c_pointer)
		end

	rightmargin: INTEGER_32 assign set_rightmargin
		do
			Result := c_rightmargin (c_pointer)
		end

	width: INTEGER_32 assign set_width
		do
			Result := c_width (c_pointer)
		end

	list_level: INTEGER_32 assign set_list_level
		do
			Result := c_list_level (c_pointer)
		end

	list_number: NATURAL_32 assign set_list_number
		do
			Result := c_list_number (c_pointer)
		end

	dd_margin: INTEGER_32 assign set_dd_margin
		do
			Result := c_dd_margin (c_pointer)
		end

	flags: INTEGER_32 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

	bgcolor: PD_RGB assign set_bgcolor
		do
			create Result.make_shared (c_bgcolor (c_pointer))
		end

	bgcolor_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct par_attrib, bgcolor);"
		end

feature {ANY} -- Eiffel setters

	set_align (a_align: INTEGER_32)
		do
			c_set_align (c_pointer, a_align)
		end

	set_leftmargin (a_leftmargin: INTEGER_32)
		do
			c_set_leftmargin (c_pointer, a_leftmargin)
		end

	set_rightmargin (a_rightmargin: INTEGER_32)
		do
			c_set_rightmargin (c_pointer, a_rightmargin)
		end

	set_width (a_width: INTEGER_32)
		do
			c_set_width (c_pointer, a_width)
		end

	set_list_level (a_list_level: INTEGER_32)
		do
			c_set_list_level (c_pointer, a_list_level)
		end

	set_list_number (a_list_number: NATURAL_32)
		do
			c_set_list_number (c_pointer, a_list_number)
		end

	set_dd_margin (a_dd_margin: INTEGER_32)
		do
			c_set_dd_margin (c_pointer, a_dd_margin)
		end

	set_flags (a_flags: INTEGER_32)
		do
			c_set_flags (c_pointer, a_flags)
		end

	set_bgcolor (a_bgcolor: PD_RGB)
		do
			bgcolor.ce_gets (a_bgcolor)
		end

feature {NONE} -- C getters

	c_align (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct par_attrib *)$tmp)->align;"
		end

	c_leftmargin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct par_attrib *)$tmp)->leftmargin;"
		end

	c_rightmargin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct par_attrib *)$tmp)->rightmargin;"
		end

	c_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct par_attrib *)$tmp)->width;"
		end

	c_list_level (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct par_attrib *)$tmp)->list_level;"
		end

	c_list_number (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct par_attrib *)$tmp)->list_number;"
		end

	c_dd_margin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct par_attrib *)$tmp)->dd_margin;"
		end

	c_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct par_attrib *)$tmp)->flags;"
		end

	c_bgcolor (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct rgb *)&((struct par_attrib *)$tmp)->bgcolor;"
		end

feature {NONE} -- C setters

	c_set_align (tmp: POINTER; a_align: INTEGER_32)
		external
			"C inline"
		alias
			"((struct par_attrib *)$tmp)->align = $a_align;"
		end

	c_set_leftmargin (tmp: POINTER; a_leftmargin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct par_attrib *)$tmp)->leftmargin = $a_leftmargin;"
		end

	c_set_rightmargin (tmp: POINTER; a_rightmargin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct par_attrib *)$tmp)->rightmargin = $a_rightmargin;"
		end

	c_set_width (tmp: POINTER; a_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct par_attrib *)$tmp)->width = $a_width;"
		end

	c_set_list_level (tmp: POINTER; a_list_level: INTEGER_32)
		external
			"C inline"
		alias
			"((struct par_attrib *)$tmp)->list_level = $a_list_level;"
		end

	c_set_list_number (tmp: POINTER; a_list_number: NATURAL_32)
		external
			"C inline"
		alias
			"((struct par_attrib *)$tmp)->list_number = $a_list_number;"
		end

	c_set_dd_margin (tmp: POINTER; a_dd_margin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct par_attrib *)$tmp)->dd_margin = $a_dd_margin;"
		end

	c_set_flags (tmp: POINTER; a_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct par_attrib *)$tmp)->flags = $a_flags;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct par_attrib);"
		end

end
