class
	PD_ROMAN_TBL

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	n: NATURAL_16 assign set_n
		do
			Result := c_n (c_pointer)
		end

	s: CE_POINTER [INTEGER_8] assign set_s
		do
			create Result.make_shared (c_s (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_n (a_n: NATURAL_16)
		do
			c_set_n (c_pointer, a_n)
		end

	set_s (a_s: CE_POINTER [INTEGER_8])
		do
			c_set_s (c_pointer, a_s.c_pointer)
		end

feature {NONE} -- C getters

	c_n (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct __anonstruct_roman_tbl_67 *)$tmp)->n;"
		end

	c_s (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_roman_tbl_67 *)$tmp)->s;"
		end

feature {NONE} -- C setters

	c_set_n (tmp: POINTER; a_n: NATURAL_16)
		external
			"C inline"
		alias
			"((struct __anonstruct_roman_tbl_67 *)$tmp)->n = $a_n;"
		end

	c_set_s (tmp: POINTER; a_s: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_roman_tbl_67 *)$tmp)->s = (char *)$a_s;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct __anonstruct_roman_tbl_67);"
		end

end
