class
	PD_S_MSG_DSC

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	n: INTEGER_32 assign set_n
		do
			Result := c_n (c_pointer)
		end

	msg: CE_POINTER [NATURAL_8] assign set_msg
		do
			create Result.make_shared (c_msg (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_n (a_n: INTEGER_32)
		do
			c_set_n (c_pointer, a_n)
		end

	set_msg (a_msg: CE_POINTER [NATURAL_8])
		do
			c_set_msg (c_pointer, a_msg.c_pointer)
		end

feature {NONE} -- C getters

	c_n (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct s_msg_dsc *)$tmp)->n;"
		end

	c_msg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct s_msg_dsc *)$tmp)->msg;"
		end

feature {NONE} -- C setters

	c_set_n (tmp: POINTER; a_n: INTEGER_32)
		external
			"C inline"
		alias
			"((struct s_msg_dsc *)$tmp)->n = $a_n;"
		end

	c_set_msg (tmp: POINTER; a_msg: POINTER)
		external
			"C inline"
		alias
			"((struct s_msg_dsc *)$tmp)->msg = (unsigned char *)$a_msg;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct s_msg_dsc);"
		end

end
