class
	PD_SUBMITTED_VALUE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_SUBMITTED_VALUE] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	prev: CE_POINTER [PD_SUBMITTED_VALUE] assign set_prev
		do
			create Result.make_shared (c_prev (c_pointer))
		end

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	name: CE_POINTER [NATURAL_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	name_offset: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return (int)offsetof(struct submitted_value, name);"
		end

	value: CE_POINTER [NATURAL_8] assign set_value
		do
			create Result.make_shared (c_value (c_pointer))
		end

	file_content: CE_POINTER [ANY] assign set_file_content
		do
			create Result.make_shared (c_file_content (c_pointer))
		end

	fc_len: INTEGER_32 assign set_fc_len
		do
			Result := c_fc_len (c_pointer)
		end

	position: INTEGER_32 assign set_position
		do
			Result := c_position (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_SUBMITTED_VALUE])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_prev (a_prev: CE_POINTER [PD_SUBMITTED_VALUE])
		do
			c_set_prev (c_pointer, a_prev.c_pointer)
		end

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_value (a_value: CE_POINTER [NATURAL_8])
		do
			c_set_value (c_pointer, a_value.c_pointer)
		end

	set_file_content (a_file_content: CE_POINTER [ANY])
		do
			c_set_file_content (c_pointer, a_file_content.c_pointer)
		end

	set_fc_len (a_fc_len: INTEGER_32)
		do
			c_set_fc_len (c_pointer, a_fc_len)
		end

	set_position (a_position: INTEGER_32)
		do
			c_set_position (c_pointer, a_position)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct submitted_value *)((struct submitted_value *)$tmp)->next;"
		end

	c_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct submitted_value *)((struct submitted_value *)$tmp)->prev;"
		end

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct submitted_value *)$tmp)->type;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct submitted_value *)$tmp)->name;"
		end

	c_value (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct submitted_value *)$tmp)->value;"
		end

	c_file_content (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct submitted_value *)$tmp)->file_content;"
		end

	c_fc_len (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct submitted_value *)$tmp)->fc_len;"
		end

	c_position (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct submitted_value *)$tmp)->position;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct submitted_value *)$tmp)->next = (struct submitted_value *)$a_next;"
		end

	c_set_prev (tmp: POINTER; a_prev: POINTER)
		external
			"C inline"
		alias
			"((struct submitted_value *)$tmp)->prev = (struct submitted_value *)$a_prev;"
		end

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct submitted_value *)$tmp)->type = $a_type;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct submitted_value *)$tmp)->name = (unsigned char *)$a_name;"
		end

	c_set_value (tmp: POINTER; a_value: POINTER)
		external
			"C inline"
		alias
			"((struct submitted_value *)$tmp)->value = (unsigned char *)$a_value;"
		end

	c_set_file_content (tmp: POINTER; a_file_content: POINTER)
		external
			"C inline"
		alias
			"((struct submitted_value *)$tmp)->file_content = (void *)$a_file_content;"
		end

	c_set_fc_len (tmp: POINTER; a_fc_len: INTEGER_32)
		external
			"C inline"
		alias
			"((struct submitted_value *)$tmp)->fc_len = $a_fc_len;"
		end

	c_set_position (tmp: POINTER; a_position: INTEGER_32)
		external
			"C inline"
		alias
			"((struct submitted_value *)$tmp)->position = $a_position;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct submitted_value);"
		end

end
