class
	PD_TABLE_ENTRY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	c: NATURAL_8 assign set_c
		do
			Result := c_c (c_pointer)
		end

	u: INTEGER_32 assign set_u
		do
			Result := c_u (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_c (a_c: NATURAL_8)
		do
			c_set_c (c_pointer, a_c)
		end

	set_u (a_u: INTEGER_32)
		do
			c_set_u (c_pointer, a_u)
		end

feature {NONE} -- C getters

	c_c (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct table_entry *)$tmp)->c;"
		end

	c_u (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct table_entry *)$tmp)->u;"
		end

feature {NONE} -- C setters

	c_set_c (tmp: POINTER; a_c: NATURAL_8)
		external
			"C inline"
		alias
			"((struct table_entry *)$tmp)->c = $a_c;"
		end

	c_set_u (tmp: POINTER; a_u: INTEGER_32)
		external
			"C inline"
		alias
			"((struct table_entry *)$tmp)->u = $a_u;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct table_entry);"
		end

end
