class
	PD_U

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	str: CE_POINTER [NATURAL_8] assign set_str
		do
			create Result.make_shared (c_str (c_pointer))
		end

	tbl: CE_POINTER [PD_CONV_TABLE] assign set_tbl
		do
			create Result.make_shared (c_tbl (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_str (a_str: CE_POINTER [NATURAL_8])
		do
			c_set_str (c_pointer, a_str.c_pointer)
		end

	set_tbl (a_tbl: CE_POINTER [PD_CONV_TABLE])
		do
			c_set_tbl (c_pointer, a_tbl.c_pointer)
		end

feature {NONE} -- C getters

	c_str (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((union __anonunion_u_65 *)$tmp)->str;"
		end

	c_tbl (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct conv_table *)((union __anonunion_u_65 *)$tmp)->tbl;"
		end

feature {NONE} -- C setters

	c_set_str (tmp: POINTER; a_str: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_u_65 *)$tmp)->str = (unsigned char *)$a_str;"
		end

	c_set_tbl (tmp: POINTER; a_tbl: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_u_65 *)$tmp)->tbl = (struct conv_table *)$a_tbl;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(union __anonunion_u_65);"
		end

end
