class
	PD_UNICODE_7B

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	x: INTEGER_32 assign set_x
		do
			Result := c_x (c_pointer)
		end

	s: CE_POINTER [NATURAL_8] assign set_s
		do
			create Result.make_shared (c_s (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_x (a_x: INTEGER_32)
		do
			c_set_x (c_pointer, a_x)
		end

	set_s (a_s: CE_POINTER [NATURAL_8])
		do
			c_set_s (c_pointer, a_s.c_pointer)
		end

feature {NONE} -- C getters

	c_x (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_unicode_7b_67 *)$tmp)->x;"
		end

	c_s (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_unicode_7b_67 *)$tmp)->s;"
		end

feature {NONE} -- C setters

	c_set_x (tmp: POINTER; a_x: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_unicode_7b_67 *)$tmp)->x = $a_x;"
		end

	c_set_s (tmp: POINTER; a_s: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_unicode_7b_67 *)$tmp)->s = (unsigned char *)$a_s;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct __anonstruct_unicode_7b_67);"
		end

end
