class
	PD_UNICODE_UPCASE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	lo: INTEGER_32 assign set_lo
		do
			Result := c_lo (c_pointer)
		end

	up: INTEGER_32 assign set_up
		do
			Result := c_up (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_lo (a_lo: INTEGER_32)
		do
			c_set_lo (c_pointer, a_lo)
		end

	set_up (a_up: INTEGER_32)
		do
			c_set_up (c_pointer, a_up)
		end

feature {NONE} -- C getters

	c_lo (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_unicode_upcase_69 *)$tmp)->lo;"
		end

	c_up (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_unicode_upcase_69 *)$tmp)->up;"
		end

feature {NONE} -- C setters

	c_set_lo (tmp: POINTER; a_lo: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_unicode_upcase_69 *)$tmp)->lo = $a_lo;"
		end

	c_set_up (tmp: POINTER; a_up: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_unicode_upcase_69 *)$tmp)->up = $a_up;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sizeof(struct __anonstruct_unicode_upcase_69);"
		end

end
