frozen class
	LINKS_INITIALIZER_SLICE35

inherit
	LINKS_DATA
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {LINKS_INITIALIZER}

	initialize
		do
			language_inst.translation_english[23].code := 23
			language_inst.translation_english[23].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("connections"))
			language_inst.translation_english[24].code := 24
			language_inst.translation_english[24].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("connecting"))
			language_inst.translation_english[25].code := 25
			language_inst.translation_english[25].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("transferring"))
			language_inst.translation_english[26].code := 26
			language_inst.translation_english[26].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("keepalive"))
			language_inst.translation_english[27].code := 27
			language_inst.translation_english[27].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Memory cache"))
			language_inst.translation_english[28].code := 28
			language_inst.translation_english[28].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bytes"))
			language_inst.translation_english[29].code := 29
			language_inst.translation_english[29].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("files"))
			language_inst.translation_english[30].code := 30
			language_inst.translation_english[30].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("locked"))
			language_inst.translation_english[31].code := 31
			language_inst.translation_english[31].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("loading"))
			language_inst.translation_english[32].code := 32
			language_inst.translation_english[32].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Formatted document cache"))
			language_inst.translation_english[33].code := 33
			language_inst.translation_english[33].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("documents"))
			language_inst.translation_english[34].code := 34
			language_inst.translation_english[34].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Cache info"))
			language_inst.translation_english[35].code := 35
			language_inst.translation_english[35].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Cache content"))
			language_inst.translation_english[36].code := 36
			language_inst.translation_english[36].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bytes of memory allocated"))
			language_inst.translation_english[37].code := 37
			language_inst.translation_english[37].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("last"))
			language_inst.translation_english[38].code := 38
			language_inst.translation_english[38].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("difference"))
			language_inst.translation_english[39].code := 39
			language_inst.translation_english[39].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Differences"))
			language_inst.translation_english[40].code := 40
			language_inst.translation_english[40].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("No differences"))
			language_inst.translation_english[41].code := 41
			language_inst.translation_english[41].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("New addresses"))
			language_inst.translation_english[42].code := 42
			language_inst.translation_english[42].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("No new addresses"))
			language_inst.translation_english[43].code := 43
			language_inst.translation_english[43].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Memory info"))
			language_inst.translation_english[44].code := 44
			language_inst.translation_english[44].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Mark"))
			language_inst.translation_english[45].code := 45
			language_inst.translation_english[45].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("No history"))
			language_inst.translation_english[46].code := 46
			language_inst.translation_english[46].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("No downloads"))
			language_inst.translation_english[47].code := 47
			language_inst.translation_english[47].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("No frames"))
			language_inst.translation_english[48].code := 48
			language_inst.translation_english[48].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("VT 100 frames"))
			language_inst.translation_english[49].code := 49
			language_inst.translation_english[49].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Linux or OS/2 frames"))
			language_inst.translation_english[50].code := 50
			language_inst.translation_english[50].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("KOI8-R frames"))
			language_inst.translation_english[51].code := 51
			language_inst.translation_english[51].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("FreeBSD frames"))
			language_inst.translation_english[52].code := 52
			language_inst.translation_english[52].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Use ^[[11m"))
			language_inst.translation_english[53].code := 53
			language_inst.translation_english[53].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Restrict frames in cp850/852"))
			language_inst.translation_english[54].code := 54
			language_inst.translation_english[54].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Block cursor"))
			language_inst.translation_english[55].code := 55
			language_inst.translation_english[55].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Color"))
			language_inst.translation_english[56].code := 56
			language_inst.translation_english[56].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Terminal options"))
			language_inst.translation_english[57].code := 57
			language_inst.translation_english[57].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("HTTP proxy (host:port)"))
			language_inst.translation_english[58].code := 58
			language_inst.translation_english[58].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("FTP proxy (host:port)"))
			language_inst.translation_english[59].code := 59
			language_inst.translation_english[59].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Direct access (w/o proxy) domains (comma separated)"))
			language_inst.translation_english[60].code := 60
			language_inst.translation_english[60].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Max connections"))
			language_inst.translation_english[61].code := 61
			language_inst.translation_english[61].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Max connections to one host"))
			language_inst.translation_english[62].code := 62
			language_inst.translation_english[62].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Retries (0 - unlimited)"))
			language_inst.translation_english[63].code := 63
			language_inst.translation_english[63].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Receive timeout (sec)"))
			language_inst.translation_english[64].code := 64
			language_inst.translation_english[64].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Timeout when unrestartable"))
			language_inst.translation_english[65].code := 65
			language_inst.translation_english[65].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Async DNS lookup"))
			language_inst.translation_english[66].code := 66
			language_inst.translation_english[66].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Set time of downloaded files"))
			language_inst.translation_english[67].code := 67
			language_inst.translation_english[67].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Network options"))
			language_inst.translation_english[68].code := 68
			language_inst.translation_english[68].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Memory cache size (kB)"))
			language_inst.translation_english[69].code := 69
			language_inst.translation_english[69].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Number of formatted documents"))
			language_inst.translation_english[70].code := 70
			language_inst.translation_english[70].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Cache options"))
			language_inst.translation_english[71].code := 71
			language_inst.translation_english[71].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Display tables"))
			language_inst.translation_english[72].code := 72
			language_inst.translation_english[72].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Display frames"))
			language_inst.translation_english[73].code := 73
			language_inst.translation_english[73].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Display links to images"))
			language_inst.translation_english[74].code := 74
			language_inst.translation_english[74].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Move by columns in table"))
			language_inst.translation_english[75].code := 75
			language_inst.translation_english[75].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Links are numbered"))
			language_inst.translation_english[76].code := 76
			language_inst.translation_english[76].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Text margin"))
			language_inst.translation_english[77].code := 77
			language_inst.translation_english[77].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ignore charset info sent by server"))
			language_inst.translation_english[78].code := 78
			language_inst.translation_english[78].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Html options"))
			language_inst.translation_english[79].code := 79
			language_inst.translation_english[79].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Default codepage"))
			language_inst.translation_english[80].code := 80
			language_inst.translation_english[80].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Go to URL"))
			language_inst.translation_english[81].code := 81
			language_inst.translation_english[81].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Go back"))
			language_inst.translation_english[82].code := 82
			language_inst.translation_english[82].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("History"))
			language_inst.translation_english[83].code := 83
			language_inst.translation_english[83].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Reload"))
			language_inst.translation_english[84].code := 84
			language_inst.translation_english[84].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Save as"))
			language_inst.translation_english[85].code := 85
			language_inst.translation_english[85].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Save URL as"))
			language_inst.translation_english[86].code := 86
			language_inst.translation_english[86].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Save formatted document"))
			language_inst.translation_english[87].code := 87
			language_inst.translation_english[87].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Kill background connections"))
			language_inst.translation_english[88].code := 88
			language_inst.translation_english[88].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Flush all caches"))
			language_inst.translation_english[89].code := 89
			language_inst.translation_english[89].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Resource info"))
			language_inst.translation_english[90].code := 90
			language_inst.translation_english[90].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("OS shell"))
			language_inst.translation_english[91].code := 91
			language_inst.translation_english[91].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Exit"))
			language_inst.translation_english[92].code := 92
			language_inst.translation_english[92].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Search"))
			language_inst.translation_english[93].code := 93
			language_inst.translation_english[93].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Search backward"))
			language_inst.translation_english[94].code := 94
			language_inst.translation_english[94].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Find next"))
			language_inst.translation_english[95].code := 95
			language_inst.translation_english[95].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Find previous"))
			language_inst.translation_english[96].code := 96
			language_inst.translation_english[96].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Toggle html/plain"))
			language_inst.translation_english[97].code := 97
			language_inst.translation_english[97].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Document info"))
			language_inst.translation_english[98].code := 98
			language_inst.translation_english[98].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Frame at full-screen"))
			language_inst.translation_english[99].code := 99
			language_inst.translation_english[99].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Save html options"))
			language_inst.translation_english[100].code := 100
			language_inst.translation_english[100].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Add"))
			language_inst.translation_english[101].code := 101
			language_inst.translation_english[101].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Modify"))
			language_inst.translation_english[102].code := 102
			language_inst.translation_english[102].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Delete"))
			language_inst.translation_english[103].code := 103
			language_inst.translation_english[103].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Character set"))
			language_inst.translation_english[104].code := 104
			language_inst.translation_english[104].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Cache"))
			language_inst.translation_english[105].code := 105
			language_inst.translation_english[105].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Mail and telnet"))
			language_inst.translation_english[106].code := 106
			language_inst.translation_english[106].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Associations"))
			language_inst.translation_english[107].code := 107
			language_inst.translation_english[107].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("File extensions"))
			language_inst.translation_english[108].code := 108
			language_inst.translation_english[108].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Save options"))
			language_inst.translation_english[109].code := 109
			language_inst.translation_english[109].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("File"))
			language_inst.translation_english[110].code := 110
			language_inst.translation_english[110].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("View"))
			language_inst.translation_english[111].code := 111
			language_inst.translation_english[111].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Link"))
			language_inst.translation_english[112].code := 112
			language_inst.translation_english[112].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Downloads"))
			language_inst.translation_english[113].code := 113
			language_inst.translation_english[113].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Setup"))
			language_inst.translation_english[114].code := 114
			language_inst.translation_english[114].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Help"))
			language_inst.translation_english[115].code := 115
			language_inst.translation_english[115].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Enter URL"))
			language_inst.translation_english[116].code := 116
			language_inst.translation_english[116].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Save URL"))
			language_inst.translation_english[117].code := 117
			language_inst.translation_english[117].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Download"))
			language_inst.translation_english[118].code := 118
			language_inst.translation_english[118].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Save to file"))
			language_inst.translation_english[119].code := 119
			language_inst.translation_english[119].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Search for text"))
			language_inst.translation_english[120].code := 120
			language_inst.translation_english[120].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Waiting in queue"))
			language_inst.translation_english[121].code := 121
			language_inst.translation_english[121].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Looking up host"))
			language_inst.translation_english[122].code := 122
			language_inst.translation_english[122].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Making connection"))
			language_inst.translation_english[123].code := 123
			language_inst.translation_english[123].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("SSL negotiation"))
			language_inst.translation_english[124].code := 124
			language_inst.translation_english[124].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Request sent"))
			language_inst.translation_english[125].code := 125
			language_inst.translation_english[125].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Logging in"))
			language_inst.translation_english[126].code := 126
			language_inst.translation_english[126].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Getting headers"))
			language_inst.translation_english[127].code := 127
			language_inst.translation_english[127].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Server is processing request"))
			language_inst.translation_english[128].code := 128
			language_inst.translation_english[128].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Transferring"))
			language_inst.translation_english[129].code := 129
			language_inst.translation_english[129].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Waiting for redirect confirmation"))
			language_inst.translation_english[130].code := 130
			language_inst.translation_english[130].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Interrupted"))
			language_inst.translation_english[131].code := 131
			language_inst.translation_english[131].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Socket exception"))
			language_inst.translation_english[132].code := 132
			language_inst.translation_english[132].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Internal error"))
			language_inst.translation_english[133].code := 133
			language_inst.translation_english[133].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Out of memory"))
			language_inst.translation_english[134].code := 134
			language_inst.translation_english[134].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Host not found"))
			language_inst.translation_english[135].code := 135
			language_inst.translation_english[135].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Error writing to socket"))
			language_inst.translation_english[136].code := 136
			language_inst.translation_english[136].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Error reading from socket"))
			language_inst.translation_english[137].code := 137
			language_inst.translation_english[137].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Data modified"))
			language_inst.translation_english[138].code := 138
			language_inst.translation_english[138].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Bad URL syntax"))
			language_inst.translation_english[139].code := 139
			language_inst.translation_english[139].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Receive timeout"))
			language_inst.translation_english[140].code := 140
			language_inst.translation_english[140].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Request must be restarted"))
			language_inst.translation_english[141].code := 141
			language_inst.translation_english[141].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Can%'t get socket state"))
			language_inst.translation_english[142].code := 142
			language_inst.translation_english[142].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Too large file"))
			language_inst.translation_english[143].code := 143
			language_inst.translation_english[143].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Bad HTTP response"))
			language_inst.translation_english[144].code := 144
			language_inst.translation_english[144].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("HTTP 100 (???)"))
			language_inst.translation_english[145].code := 145
			language_inst.translation_english[145].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("No content"))
			language_inst.translation_english[146].code := 146
			language_inst.translation_english[146].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Unknown file type"))
			language_inst.translation_english[147].code := 147
			language_inst.translation_english[147].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Error opening file"))
			language_inst.translation_english[148].code := 148
			language_inst.translation_english[148].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Bad FTP response"))
			language_inst.translation_english[149].code := 149
			language_inst.translation_english[149].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("FTP service unavailable"))
			language_inst.translation_english[150].code := 150
			language_inst.translation_english[150].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Bad FTP login"))
			language_inst.translation_english[151].code := 151
			language_inst.translation_english[151].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("FTP PORT command failed"))
			language_inst.translation_english[152].code := 152
			language_inst.translation_english[152].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("File not found"))
			language_inst.translation_english[153].code := 153
			language_inst.translation_english[153].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("FTP file error"))
			language_inst.translation_english[154].code := 154
			language_inst.translation_english[154].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Unknown error"))
			language_inst.translation_english[155].code := 155
			language_inst.translation_english[155].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Received"))
			language_inst.translation_english[156].code := 156
			language_inst.translation_english[156].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("of"))
			language_inst.translation_english[157].code := 157
			language_inst.translation_english[157].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("avg"))
			language_inst.translation_english[158].code := 158
			language_inst.translation_english[158].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cur"))
			language_inst.translation_english[159].code := 159
			language_inst.translation_english[159].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Average speed"))
			language_inst.translation_english[160].code := 160
			language_inst.translation_english[160].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Speed"))
			language_inst.translation_english[161].code := 161
			language_inst.translation_english[161].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("current speed"))
			language_inst.translation_english[162].code := 162
			language_inst.translation_english[162].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Elapsed time"))
			language_inst.translation_english[163].code := 163
			language_inst.translation_english[163].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("estimated time"))
			language_inst.translation_english[164].code := 164
			language_inst.translation_english[164].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Background"))
			language_inst.translation_english[165].code := 165
			language_inst.translation_english[165].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Abort"))
			language_inst.translation_english[166].code := 166
			language_inst.translation_english[166].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Yes"))
			language_inst.translation_english[167].code := 167
			language_inst.translation_english[167].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("No"))
			language_inst.translation_english[168].code := 168
			language_inst.translation_english[168].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Download error"))
			language_inst.translation_english[169].code := 169
			language_inst.translation_english[169].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Could not create file"))
			language_inst.translation_english[170].code := 170
			language_inst.translation_english[170].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Error downloading"))
			language_inst.translation_english[171].code := 171
			language_inst.translation_english[171].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Could not create file"))
			language_inst.translation_english[172].code := 172
			language_inst.translation_english[172].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Could not create temporary file"))
			language_inst.translation_english[173].code := 173
			language_inst.translation_english[173].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Unknown type"))
			language_inst.translation_english[174].code := 174
			language_inst.translation_english[174].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Content type is"))
			language_inst.translation_english[175].code := 175
			language_inst.translation_english[175].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Do you want to save or display this file?"))
			language_inst.translation_english[176].code := 176
			language_inst.translation_english[176].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Save"))
			language_inst.translation_english[177].code := 177
			language_inst.translation_english[177].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Display"))
			language_inst.translation_english[178].code := 178
			language_inst.translation_english[178].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("What to do?"))
			language_inst.translation_english[179].code := 179
			language_inst.translation_english[179].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Do you want to open file with"))
			language_inst.translation_english[180].code := 180
			language_inst.translation_english[180].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("save it or display it?"))
			language_inst.translation_english[181].code := 181
			language_inst.translation_english[181].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Open"))
			language_inst.translation_english[182].code := 182
			language_inst.translation_english[182].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Do you want to follow redirect and post form data to url"))
			language_inst.translation_english[183].code := 183
			language_inst.translation_english[183].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Do you want to post form data to url"))
			language_inst.translation_english[184].code := 184
			language_inst.translation_english[184].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Do you want to repost form data to url"))
			language_inst.translation_english[185].code := 185
			language_inst.translation_english[185].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Warning"))
			language_inst.translation_english[186].code := 186
			language_inst.translation_english[186].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Error"))
			language_inst.translation_english[187].code := 187
			language_inst.translation_english[187].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Welcome"))
			language_inst.translation_english[188].code := 188
			language_inst.translation_english[188].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Welcome to links!"))
			language_inst.translation_english[189].code := 189
			language_inst.translation_english[189].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Press ESC for menu. Select Help->Manual in menu for user%'s manual."))
			language_inst.translation_english[190].code := 190
			language_inst.translation_english[190].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Label"))
			language_inst.translation_english[191].code := 191
			language_inst.translation_english[191].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Content-Type(s)"))
			language_inst.translation_english[192].code := 192
			language_inst.translation_english[192].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Program (%'%%%' is replaced with file name)"))
			language_inst.translation_english[193].code := 193
			language_inst.translation_english[193].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Block terminal while program running"))
			language_inst.translation_english[194].code := 194
			language_inst.translation_english[194].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Run on terminal"))
			language_inst.translation_english[195].code := 195
			language_inst.translation_english[195].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Run in X-Window"))
			language_inst.translation_english[196].code := 196
			language_inst.translation_english[196].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ask before opening"))
			language_inst.translation_english[197].code := 197
			language_inst.translation_english[197].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Delete association"))
			language_inst.translation_english[198].code := 198
			language_inst.translation_english[198].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Association"))
			language_inst.translation_english[199].code := 199
			language_inst.translation_english[199].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Extension(s)"))
			language_inst.translation_english[200].code := 200
			language_inst.translation_english[200].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Content-Type"))
			language_inst.translation_english[201].code := 201
			language_inst.translation_english[201].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("No associations"))
			language_inst.translation_english[202].code := 202
			language_inst.translation_english[202].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Delete extension"))
			language_inst.translation_english[203].code := 203
			language_inst.translation_english[203].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Extension"))
			language_inst.translation_english[204].code := 204
			language_inst.translation_english[204].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("No extensions"))
			language_inst.translation_english[205].code := 205
			language_inst.translation_english[205].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Error while posting form"))
			language_inst.translation_english[206].code := 206
			language_inst.translation_english[206].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Could not get file"))
			language_inst.translation_english[207].code := 207
			language_inst.translation_english[207].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("No previous search"))
			language_inst.translation_english[208].code := 208
			language_inst.translation_english[208].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Search string not found"))
			language_inst.translation_english[209].code := 209
			language_inst.translation_english[209].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Save error"))
			language_inst.translation_english[210].code := 210
			language_inst.translation_english[210].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Error writing to file"))
			language_inst.translation_english[211].code := 211
			language_inst.translation_english[211].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Display usemap"))
			language_inst.translation_english[212].code := 212
			language_inst.translation_english[212].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Follow link"))
			language_inst.translation_english[213].code := 213
			language_inst.translation_english[213].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Open in new window"))
			language_inst.translation_english[214].code := 214
			language_inst.translation_english[214].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Download link"))
			language_inst.translation_english[215].code := 215
			language_inst.translation_english[215].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Reset form"))
			language_inst.translation_english[216].code := 216
			language_inst.translation_english[216].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Submit form"))
			language_inst.translation_english[217].code := 217
			language_inst.translation_english[217].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Submit form and open in new window"))
			language_inst.translation_english[218].code := 218
			language_inst.translation_english[218].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Submit form and download"))
			language_inst.translation_english[219].code := 219
			language_inst.translation_english[219].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("View image"))
			language_inst.translation_english[220].code := 220
			language_inst.translation_english[220].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Download image"))
			language_inst.translation_english[221].code := 221
			language_inst.translation_english[221].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("No link selected"))
			language_inst.translation_english[222].code := 222
			language_inst.translation_english[222].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Image"))
			language_inst.translation_english[223].code := 223
			language_inst.translation_english[223].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Usemap"))
			language_inst.translation_english[224].code := 224
			language_inst.translation_english[224].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Submit form to"))
			language_inst.translation_english[225].code := 225
			language_inst.translation_english[225].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Post form to"))
			language_inst.translation_english[226].code := 226
			language_inst.translation_english[226].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Radio button"))
			language_inst.translation_english[227].code := 227
			language_inst.translation_english[227].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Checkbox"))
			language_inst.translation_english[228].code := 228
			language_inst.translation_english[228].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Select field"))
			language_inst.translation_english[229].code := 229
			language_inst.translation_english[229].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Text field"))
			language_inst.translation_english[230].code := 230
			language_inst.translation_english[230].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Text area"))
			language_inst.translation_english[231].code := 231
			language_inst.translation_english[231].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("File upload"))
			language_inst.translation_english[232].code := 232
			language_inst.translation_english[232].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Password field"))
			language_inst.translation_english[233].code := 233
			language_inst.translation_english[233].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("name"))
			language_inst.translation_english[234].code := 234
			language_inst.translation_english[234].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("value"))
			language_inst.translation_english[235].code := 235
			language_inst.translation_english[235].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("hit ENTER to"))
			language_inst.translation_english[236].code := 236
			language_inst.translation_english[236].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("submit to"))
			language_inst.translation_english[237].code := 237
			language_inst.translation_english[237].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("post to"))
			language_inst.translation_english[238].code := 238
			language_inst.translation_english[238].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Info"))
			language_inst.translation_english[239].code := 239
			language_inst.translation_english[239].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Header info"))
			language_inst.translation_english[240].code := 240
			language_inst.translation_english[240].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("You are nowhere!"))
			language_inst.translation_english[241].code := 241
			language_inst.translation_english[241].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("URL"))
			language_inst.translation_english[242].code := 242
			language_inst.translation_english[242].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Size"))
			language_inst.translation_english[243].code := 243
			language_inst.translation_english[243].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("incomplete"))
			language_inst.translation_english[244].code := 244
			language_inst.translation_english[244].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Codepage"))
			language_inst.translation_english[245].code := 245
			language_inst.translation_english[245].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("assumed"))
			language_inst.translation_english[246].code := 246
			language_inst.translation_english[246].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ignoring server setting"))
			language_inst.translation_english[247].code := 247
			language_inst.translation_english[247].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Server"))
			language_inst.translation_english[248].code := 248
			language_inst.translation_english[248].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Date"))
			language_inst.translation_english[249].code := 249
			language_inst.translation_english[249].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Last modified"))
			language_inst.translation_english[250].code := 250
			language_inst.translation_english[250].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Language"))
			language_inst.translation_english[251].code := 251
			language_inst.translation_english[251].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Xterm"))
			language_inst.translation_english[252].code := 252
			language_inst.translation_english[252].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Twterm"))
			language_inst.translation_english[253].code := 253
			language_inst.translation_english[253].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Screen"))
			language_inst.translation_english[254].code := 254
			language_inst.translation_english[254].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Window"))
			language_inst.translation_english[255].code := 255
			language_inst.translation_english[255].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Full screen"))
			language_inst.translation_english[256].code := 256
			language_inst.translation_english[256].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("BeOS terminal"))
			language_inst.translation_english[257].code := 257
			language_inst.translation_english[257].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("New window"))
			language_inst.translation_english[258].code := 258
			language_inst.translation_english[258].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Go to link"))
			language_inst.translation_english[259].code := 259
			language_inst.translation_english[259].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Enter link number"))
			language_inst.translation_english[260].code := 260
			language_inst.translation_english[260].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Resize terminal"))
			language_inst.translation_english[261].code := 261
			language_inst.translation_english[261].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Columns"))
			language_inst.translation_english[262].code := 262
			language_inst.translation_english[262].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Rows"))
			language_inst.translation_english[263].code := 263
			language_inst.translation_english[263].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Bookmarks"))
			language_inst.translation_english[264].code := 264
			language_inst.translation_english[264].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Add bookmark"))
			language_inst.translation_english[265].code := 265
			language_inst.translation_english[265].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Goto"))
			language_inst.translation_english[266].code := 266
			language_inst.translation_english[266].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Edit"))
			language_inst.translation_english[267].code := 267
			language_inst.translation_english[267].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Close"))
			language_inst.translation_english[268].code := 268
			language_inst.translation_english[268].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Bookmark title"))
			language_inst.translation_english[269].code := 269
			language_inst.translation_english[269].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Edit bookmark"))
			language_inst.translation_english[270].code := 270
			language_inst.translation_english[270].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Delete bookmark"))
			language_inst.translation_english[271].code := 271
			language_inst.translation_english[271].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Bookmark manager"))
			language_inst.translation_english[272].code := 272
			language_inst.translation_english[272].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url"))
		end

end
