frozen class
	LINKS_INITIALIZER_SLICE36

inherit
	LINKS_DATA
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {LINKS_INITIALIZER}

	initialize
		do
			language_inst.translation_english[273].code := 273
			language_inst.translation_english[273].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Name"))
			language_inst.translation_english[274].code := 274
			language_inst.translation_english[274].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Exit Links"))
			language_inst.translation_english[275].code := 275
			language_inst.translation_english[275].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Do you really want to exit Links?"))
			language_inst.translation_english[276].code := 276
			language_inst.translation_english[276].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Do you really want to exit Links (and terminate all downloads)?"))
			language_inst.translation_english[277].code := 277
			language_inst.translation_english[277].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("HTTP options"))
			language_inst.translation_english[278].code := 278
			language_inst.translation_english[278].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("FTP options"))
			language_inst.translation_english[279].code := 279
			language_inst.translation_english[279].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("HTTP bug workarounds"))
			language_inst.translation_english[280].code := 280
			language_inst.translation_english[280].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Use HTTP/1.0"))
			language_inst.translation_english[281].code := 281
			language_inst.translation_english[281].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Allow blacklist of buggy servers"))
			language_inst.translation_english[282].code := 282
			language_inst.translation_english[282].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Broken redirect 302 (it violates RFC, but it%'s compatible with Netscape)"))
			language_inst.translation_english[283].code := 283
			language_inst.translation_english[283].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("No keepalive connection after POST request (some buggy PHP databases need it)"))
			language_inst.translation_english[284].code := 284
			language_inst.translation_english[284].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Do not send Accept-Charset"))
			language_inst.translation_english[285].code := 285
			language_inst.translation_english[285].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Password for anonymous login"))
			language_inst.translation_english[286].code := 286
			language_inst.translation_english[286].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Use passive FTP"))
			language_inst.translation_english[287].code := 287
			language_inst.translation_english[287].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Use fast (but RFC-incompatible) FTP"))
			language_inst.translation_english[288].code := 288
			language_inst.translation_english[288].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Set IP Type Of Service"))
			language_inst.translation_english[289].code := 289
			language_inst.translation_english[289].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("User%'s manual"))
			language_inst.translation_english[290].code := 290
			language_inst.translation_english[290].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Mail program (%% is replaced with address)"))
			language_inst.translation_english[291].code := 291
			language_inst.translation_english[291].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Telnet program (%% is replaced with %"host%" or %"host port%")"))
			language_inst.translation_english[292].code := 292
			language_inst.translation_english[292].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Tn3270 program (%% is replaced with %"host%" or %"host port%")"))
			language_inst.translation_english[293].code := 293
			language_inst.translation_english[293].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("MMS program (%% is replaced with URL)"))
			language_inst.translation_english[294].code := 294
			language_inst.translation_english[294].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Mail and telnet programs"))
			language_inst.translation_english[295].code := 295
			language_inst.translation_english[295].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("No program"))
			language_inst.translation_english[296].code := 296
			language_inst.translation_english[296].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("No program specified for"))
			language_inst.translation_english[297].code := 297
			language_inst.translation_english[297].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mail"))
			language_inst.translation_english[298].code := 298
			language_inst.translation_english[298].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("telnet"))
			language_inst.translation_english[299].code := 299
			language_inst.translation_english[299].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("tn3270"))
			language_inst.translation_english[300].code := 300
			language_inst.translation_english[300].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mms"))
			language_inst.translation_english[301].code := 301
			language_inst.translation_english[301].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Bad mailto url"))
			language_inst.translation_english[302].code := 302
			language_inst.translation_english[302].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Bad telnet url"))
			language_inst.translation_english[303].code := 303
			language_inst.translation_english[303].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Bad tn3270 url"))
			language_inst.translation_english[304].code := 304
			language_inst.translation_english[304].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("MMS url contains inacceptable characters"))
			language_inst.translation_english[305].code := 305
			language_inst.translation_english[305].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("User ID"))
			language_inst.translation_english[306].code := 306
			language_inst.translation_english[306].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Password"))
			language_inst.translation_english[307].code := 307
			language_inst.translation_english[307].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Enter username for "))
			language_inst.translation_english[308].code := 308
			language_inst.translation_english[308].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" at "))
			language_inst.translation_english[309].code := 309
			language_inst.translation_english[309].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("SSL error"))
			language_inst.translation_english[310].code := 310
			language_inst.translation_english[310].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("This version of Links does not contain SSL/TLS support"))
			language_inst.translation_english[311].code := 311
			language_inst.translation_english[311].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("No smb client program installed (supported is smbclient or smbc)"))
			language_inst.translation_english[312].code := 312
			language_inst.translation_english[312].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("A"))
			language_inst.translation_english[313].code := 313
			language_inst.translation_english[313].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S"))
			language_inst.translation_english[314].code := 314
			language_inst.translation_english[314].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("G"))
			language_inst.translation_english[315].code := 315
			language_inst.translation_english[315].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("B"))
			language_inst.translation_english[316].code := 316
			language_inst.translation_english[316].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("H"))
			language_inst.translation_english[317].code := 317
			language_inst.translation_english[317].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("R"))
			language_inst.translation_english[318].code := 318
			language_inst.translation_english[318].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("V"))
			language_inst.translation_english[319].code := 319
			language_inst.translation_english[319].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("U"))
			language_inst.translation_english[320].code := 320
			language_inst.translation_english[320].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("D"))
			language_inst.translation_english[321].code := 321
			language_inst.translation_english[321].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("K"))
			language_inst.translation_english[322].code := 322
			language_inst.translation_english[322].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F"))
			language_inst.translation_english[323].code := 323
			language_inst.translation_english[323].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("I"))
			language_inst.translation_english[324].code := 324
			language_inst.translation_english[324].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("C"))
			language_inst.translation_english[325].code := 325
			language_inst.translation_english[325].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("M"))
			language_inst.translation_english[326].code := 326
			language_inst.translation_english[326].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("M"))
			language_inst.translation_english[327].code := 327
			language_inst.translation_english[327].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("O"))
			language_inst.translation_english[328].code := 328
			language_inst.translation_english[328].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("T"))
			language_inst.translation_english[329].code := 329
			language_inst.translation_english[329].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("X"))
			language_inst.translation_english[330].code := 330
			language_inst.translation_english[330].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S"))
			language_inst.translation_english[331].code := 331
			language_inst.translation_english[331].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("B"))
			language_inst.translation_english[332].code := 332
			language_inst.translation_english[332].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("N"))
			language_inst.translation_english[333].code := 333
			language_inst.translation_english[333].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("P"))
			language_inst.translation_english[334].code := 334
			language_inst.translation_english[334].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("H"))
			language_inst.translation_english[335].code := 335
			language_inst.translation_english[335].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("I"))
			language_inst.translation_english[336].code := 336
			language_inst.translation_english[336].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E"))
			language_inst.translation_english[337].code := 337
			language_inst.translation_english[337].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F"))
			language_inst.translation_english[338].code := 338
			language_inst.translation_english[338].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("O"))
			language_inst.translation_english[339].code := 339
			language_inst.translation_english[339].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("A"))
			language_inst.translation_english[340].code := 340
			language_inst.translation_english[340].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("A"))
			language_inst.translation_english[341].code := 341
			language_inst.translation_english[341].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("K"))
			language_inst.translation_english[342].code := 342
			language_inst.translation_english[342].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("C"))
			language_inst.translation_english[343].code := 343
			language_inst.translation_english[343].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("M"))
			language_inst.translation_english[344].code := 344
			language_inst.translation_english[344].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("A"))
			language_inst.translation_english[345].code := 345
			language_inst.translation_english[345].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("M"))
			language_inst.translation_english[346].code := 346
			language_inst.translation_english[346].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("D"))
			language_inst.translation_english[347].code := 347
			language_inst.translation_english[347].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("L"))
			language_inst.translation_english[348].code := 348
			language_inst.translation_english[348].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("H"))
			language_inst.translation_english[349].code := 349
			language_inst.translation_english[349].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("T"))
			language_inst.translation_english[350].code := 350
			language_inst.translation_english[350].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("N"))
			language_inst.translation_english[351].code := 351
			language_inst.translation_english[351].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("C"))
			language_inst.translation_english[352].code := 352
			language_inst.translation_english[352].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("A"))
			language_inst.translation_english[353].code := 353
			language_inst.translation_english[353].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E"))
			language_inst.translation_english[354].code := 354
			language_inst.translation_english[354].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S"))
			language_inst.translation_english[355].code := 355
			language_inst.translation_english[355].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F"))
			language_inst.translation_english[356].code := 356
			language_inst.translation_english[356].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("V"))
			language_inst.translation_english[357].code := 357
			language_inst.translation_english[357].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("L"))
			language_inst.translation_english[358].code := 358
			language_inst.translation_english[358].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("D"))
			language_inst.translation_english[359].code := 359
			language_inst.translation_english[359].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S"))
			language_inst.translation_english[360].code := 360
			language_inst.translation_english[360].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("H"))
			language_inst.translation_english[361].code := 361
			language_inst.translation_english[361].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("U"))
			language_inst.translation_english[362].code := 362
			language_inst.translation_english[362].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F"))
			language_inst.translation_english[363].code := 363
			language_inst.translation_english[363].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("W"))
			language_inst.translation_english[364].code := 364
			language_inst.translation_english[364].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("D"))
			language_inst.translation_english[365].code := 365
			language_inst.translation_english[365].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("R"))
			language_inst.translation_english[366].code := 366
			language_inst.translation_english[366].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S"))
			language_inst.translation_english[367].code := 367
			language_inst.translation_english[367].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("W"))
			language_inst.translation_english[368].code := 368
			language_inst.translation_english[368].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("D"))
			language_inst.translation_english[369].code := 369
			language_inst.translation_english[369].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("I"))
			language_inst.translation_english[370].code := 370
			language_inst.translation_english[370].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("G"))
			language_inst.translation_english[371].code := 371
			language_inst.translation_english[371].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("X"))
			language_inst.translation_english[372].code := 372
			language_inst.translation_english[372].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("T"))
			language_inst.translation_english[373].code := 373
			language_inst.translation_english[373].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S"))
			language_inst.translation_english[374].code := 374
			language_inst.translation_english[374].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("W"))
			language_inst.translation_english[375].code := 375
			language_inst.translation_english[375].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F"))
			language_inst.translation_english[376].code := 376
			language_inst.translation_english[376].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("B"))
			language_inst.translation_english[377].code := 377
			language_inst.translation_english[377].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("N"))
			language_inst.translation_english[378].code := 0
			language_inst.translation_english[378].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_belarusian[0].code := 0
			language_inst.translation_belarusian[0].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_belarusian[1].code := 1
			language_inst.translation_belarusian[1].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("koi8-ru"))
			language_inst.translation_belarusian[2].code := 2
			language_inst.translation_belarusian[2].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Belarusian"))
			language_inst.translation_belarusian[3].code := 3
			language_inst.translation_belarusian[3].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("be"))
			language_inst.translation_belarusian[4].code := 4
			language_inst.translation_belarusian[4].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/238/%/209/%/208/%/210/%/193/%/215/%/166/%/204/%/216/%/206/%/217/ %/204/%/166/%/203/"))
			language_inst.translation_belarusian[5].code := 5
			language_inst.translation_belarusian[5].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/245/ %/208/%/207/%/204/%/166/ %/208/%/193/%/215/%/166/%/206/%/197/%/206/ %/194/%/217/%/195/%/216/ %/204/%/166/%/203/"))
			language_inst.translation_belarusian[6].code := 6
			language_inst.translation_belarusian[6].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/225/%/196/%/205/%/197/%/206/%/193/"))
			language_inst.translation_belarusian[7].code := 7
			language_inst.translation_belarusian[7].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/236/%/166/%/203/ %/206/%/197/ %/206/%/193/%/204/%/197/%/214/%/217/%/195/%/216/ %/196/%/193/%/218/%/215/%/207/%/204/%/197/%/206/%/193/%/205/%/213/ %/196/%/217/%/209/%/208/%/193/%/218/%/207/%/206/%/213/"))
			language_inst.translation_belarusian[8].code := 8
			language_inst.translation_belarusian[8].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/238/%/209/%/208/%/210/%/193/%/215/%/166/%/204/%/216/%/206/%/217/ %/210/%/193/%/196/%/207/%/203/"))
			language_inst.translation_belarusian[9].code := 9
			language_inst.translation_belarusian[9].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/240/%/213/%/211/%/212/%/217/%/209/ %/210/%/193/%/196/%/203/%/166/ %/206/%/197/ %/196/%/193/%/218/%/215/%/193/%/204/%/209/%/192/%/195/%/195/%/193/"))
			language_inst.translation_belarusian[10].code := 10
			language_inst.translation_belarusian[10].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/240/%/193/%/205/%/217/%/204/%/203/%/193/ %/206/%/193/%/211/%/212/%/210/%/207/%/202/%/203/%/166/"))
			language_inst.translation_belarusian[11].code := 11
			language_inst.translation_belarusian[11].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/238/%/197/%/205/%/193/%/199/%/222/%/217/%/205/%/193/ %/218/%/193/%/208/%/166/%/211/%/193/%/195/%/216/ %/213/ %/198/%/193/%/202/%/204/ %/206/%/193/%/211/%/212/%/210/%/207/%/197/%/203/"))
			language_inst.translation_belarusian[12].code := 12
			language_inst.translation_belarusian[12].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/240/%/210/%/193/ %/208/%/210/%/193/%/199/%/210/%/193/%/205/%/213/"))
			language_inst.translation_belarusian[13].code := 13
			language_inst.translation_belarusian[13].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Links %/215/%/197/%/210/%/211/%/166/%/166/ 1.00%N%N Lynx-%/208/%/193/%/196/%/207/%/194/%/206/%/217/ %/212/%/220/%/203/%/211/%/212/%/193/%/215/%/217/ %/215/%/220/%/194/-%/194/%/210/%/193/%/174/%/218/%/220/%/210/"))
			language_inst.translation_belarusian[14].code := 14
			language_inst.translation_belarusian[14].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/239/%/235/"))
			language_inst.translation_belarusian[15].code := 15
			language_inst.translation_belarusian[15].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/235/%/204/%/193/%/215/%/166/%/219/%/217/"))
			language_inst.translation_belarusian[16].code := 16
			language_inst.translation_belarusian[16].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ESC      %/205/%/197/%/206/%/192/%N^C, q    %/215/%/217/%/200/%/193/%/196/%N^P, ^N   %/208/%/210/%/193/%/203/%/210/%/213/%/212/%/203/%/193/ %/174/%/215/%/197/%/210/%/200/-%/213/%/206/%/166/%/218/%N[, ]     %/208/%/210/%/193/%/203/%/210/%/213/%/212/%/203/%/193/ %/174/%/204/%/197/%/215/%/193/-%/174/%/208/%/210/%/193/%/215/%/193/%Nup, down %/215/%/217/%/194/%/193/%/210/ %/211/%/208/%/193/%/211/%/217/%/204/%/203/%/166/%N->       %/208/%/197/%/210/%/193/%/200/%/207/%/196/ %/208/%/207/ %/211/%/208/%/193/%/211/%/217/%/204/%/195/%/217/%N<-       %/206/%/193/%/218/%/193/%/196/%Ng        %/208/%/197/%/210/%/193/%/202/%/195/%/166/ %/196/%/193/ %/206/%/207/%/215/%/193/%/199/%/193/ URL%NG        %/208/%/197/%/210/%/193/%/202/%/195/%/166/ %/196/%/193/ URL, %/218/%/193/%/211/%/206/%/193/%/215/%/193/%/206/%/193/%/205/%/213/ %/206/%/193/ %/195/%/209/%/203/%/213/%/222/%/217/%/205/%N/        %/208/%/207/%/219/%/213/%/203/%N?       %/218/%/215/%/193/%/210/%/207/%/212/%/206/%/217/  %/208/%/207/%/219/%/213/%/203/%Nn        %/219/%/213/%/203/%/193/%/195/%/216/ %/196/%/193/%/204/%/197/%/202/%NN        %/219/%/213/%/203/%/193/%/195/%/216/ %/213/%/215/%/197/%/210/%/200/%N=        %/166/%/206/%/198/%/193/%/210/%/205/%/193/%/195/%/217/%/209/ %/208/%/210/%/193/ %/196/%/193/%/203/%/213/%/205/%/197/%/206/%/212/%N|        %/166/%/206/%/198/%/193/%/210/%/205/%/193/%/195/%/217/%/209/ %/208/%/210/%/193/ %/218/%/193/%/199/%/193/%/204/%/207/%/215/%/193/%/203/%N\        %/208/%/193/%/203/%/193/%/218/%/193/%/195/%/216/ %/203/%/207/%/196/ HTML%Nd        %/218/%/193/%/203/%/193/%/222/%/193/%/195/%/216/"))
			language_inst.translation_belarusian[17].code := 17
			language_inst.translation_belarusian[17].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/240/%/210/%/193/%/215/%/217/"))
			language_inst.translation_belarusian[18].code := 18
			language_inst.translation_belarusian[18].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/231/%/220/%/212/%/193/ %/208/%/210/%/193/%/199/%/210/%/193/%/205/%/193/ %/218/%'%/209/%/174/%/204/%/209/%/197/%/195/%/195/%/193/ %/211/%/215/%/193/%/194/%/207/%/196/%/206/%/217/%/205/ %/240/%/250/; %/215/%/217/ %/205/%/207/%/214/%/193/%/195/%/197/ %/210/%/193/%/211/%/208/%/193/%/174/%/211/%/192/%/196/%/214/%/215/%/193/%/195/%/216/ %/166//%/195/%/166/ %/205/%/193/%/196/%/217/%/198/%/166/%/203/%/193/%/215/%/193/%/195/%/216/ %/209/%/197/ %/218/%/199/%/207/%/196/%/206/%/193/ %/218/ %/204/%/166/%/195/%/220/%/206/%/218/%/166/%/209/%/202/ GNU, %/209/%/203/%/193/%/209/ %/193/%/208/%/213/%/194/%/204/%/166/%/203/%/193/%/215/%/193/%/206/%/193/ %"%/230/%/207/%/206/%/196/%/193/%/205/ %/211/%/215/%/193/%/194/%/207/%/196/%/206/%/193/%/199/%/193/ %/208/%/210/%/193/%/199/%/210/%/193/%/205/%/206/%/193/%/199/%/193/ %/218/%/193/%/194/%/197/%/211/%/208/%/209/%/222/%/220/%/206/%/206/%/209/%" (FSF); %/215/%/197/%/210/%/211/%/166/%/166/ 2 %/236/%/166/%/195/%/220/%/206/%/218/%/166/%/166/, %/195/%/166/ (%/208/%/193/ %/215/%/193/%/219/%/193/%/205/%/213/ %/214/%/193/%/196/%/193/%/206/%/206/%/192/) %/194/%/207/%/204/%/216/%/219/ %/208/%/207/%/218/%/206/%/209/%/202/ %/215/%/197/%/210/%/211/%/166/%/166/"))
			language_inst.translation_belarusian[19].code := 19
			language_inst.translation_belarusian[19].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/242/%/220/%/211/%/213/%/210/%/211/%/217/"))
			language_inst.translation_belarusian[20].code := 20
			language_inst.translation_belarusian[20].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/200/%/220/%/206/%/196/%/204/%/193/%/174/"))
			language_inst.translation_belarusian[21].code := 21
			language_inst.translation_belarusian[21].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/212/%/193/%/202/%/205/%/197/%/210/%/193/%/174/"))
			language_inst.translation_belarusian[22].code := 22
			language_inst.translation_belarusian[22].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/250/%/204/%/213/%/222/%/220/%/206/%/206/%/209/%/174/"))
			language_inst.translation_belarusian[23].code := 23
			language_inst.translation_belarusian[23].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/218/%/204/%/213/%/222/%/220/%/206/%/206/%/209/%/174/"))
			language_inst.translation_belarusian[24].code := 24
			language_inst.translation_belarusian[24].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/218/%/204/%/213/%/222/%/220/%/206/%/206/%/197/"))
			language_inst.translation_belarusian[25].code := 25
			language_inst.translation_belarusian[25].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/208/%/197/%/210/%/193/%/196/%/193/%/222/%/193/"))
			language_inst.translation_belarusian[26].code := 26
			language_inst.translation_belarusian[26].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/218/%/193/%/200/%/193/%/215/%/193/%/206/%/206/%/197/ %/218/%/204/%/213/%/222/%/220/%/206/%/206/%/209/"))
			language_inst.translation_belarusian[27].code := 27
			language_inst.translation_belarusian[27].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/235/%/220/%/219/ %/208/%/193/%/205/%/209/%/195/%/166/"))
			language_inst.translation_belarusian[28].code := 28
			language_inst.translation_belarusian[28].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/194/%/193/%/202/%/212/"))
			language_inst.translation_belarusian[29].code := 29
			language_inst.translation_belarusian[29].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/198/%/193/%/202/%/204/%/193/%/174/"))
			language_inst.translation_belarusian[30].code := 30
			language_inst.translation_belarusian[30].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/218/%/193/%/194/%/204/%/193/%/203/%/166/%/210/%/193/%/215/%/193/%/206/%/193/"))
			language_inst.translation_belarusian[31].code := 31
			language_inst.translation_belarusian[31].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/218/%/193/%/199/%/210/%/213/%/214/%/193/%/197/%/195/%/195/%/193/"))
			language_inst.translation_belarusian[32].code := 32
			language_inst.translation_belarusian[32].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/235/%/220/%/219/ %/198/%/193/%/210/%/205/%/193/%/195/%/166/%/210/%/193/%/215/%/193/%/206/%/217/%/200/ %/196/%/193/%/203/%/213/%/205/%/197/%/206/%/212/%/193/%/174/"))
			language_inst.translation_belarusian[33].code := 33
			language_inst.translation_belarusian[33].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/196/%/193/%/203/%/213/%/205/%/197/%/206/%/212/%/193/%/174/"))
			language_inst.translation_belarusian[34].code := 34
			language_inst.translation_belarusian[34].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/182/%/206/%/198/%/193/%/210/%/205/%/193/%/195/%/217/%/209/ %/208/%/210/%/193/ %/203/%/220/%/219/"))
			language_inst.translation_belarusian[35].code := 35
			language_inst.translation_belarusian[35].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/250/%/205/%/197/%/211/%/212/ %/203/%/220/%/219/%/193/"))
			language_inst.translation_belarusian[36].code := 36
			language_inst.translation_belarusian[36].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/194/%/193/%/202/%/212/%/193/%/174/ %/215/%/217/%/196/%/218/%/209/%/204/%/197/%/206/%/193/"))
			language_inst.translation_belarusian[37].code := 37
			language_inst.translation_belarusian[37].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/193/%/208/%/207/%/219/%/206/%/166/(%/209/%/209/,%/209/%/197/)"))
			language_inst.translation_belarusian[38].code := 38
			language_inst.translation_belarusian[38].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/193/%/196/%/210/%/207/%/218/%/206/%/197/%/206/%/206/%/197/"))
			language_inst.translation_belarusian[39].code := 39
			language_inst.translation_belarusian[39].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/225/%/196/%/210/%/207/%/218/%/206/%/197/%/206/%/206/%/209/"))
			language_inst.translation_belarusian[40].code := 40
			language_inst.translation_belarusian[40].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/238/%/209/%/205/%/193/ %/193/%/196/%/210/%/207/%/218/%/206/%/197/%/206/%/206/%/209/%/174/"))
			language_inst.translation_belarusian[41].code := 41
			language_inst.translation_belarusian[41].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/238/%/207/%/215/%/217/%/209/ %/193/%/196/%/210/%/193/%/211/%/217/"))
			language_inst.translation_belarusian[42].code := 42
			language_inst.translation_belarusian[42].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/238/%/209/%/205/%/193/ %/206/%/207/%/215/%/217/%/200/ %/193/%/196/%/210/%/193/%/211/%/207/%/174/"))
			language_inst.translation_belarusian[43].code := 43
			language_inst.translation_belarusian[43].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/182/%/206/%/198/%/193/%/210/%/205/%/193/%/195/%/217/%/209/ %/208/%/210/%/193/ %/208/%/193/%/205/%/209/%/195/%/216/"))
			language_inst.translation_belarusian[44].code := 44
			language_inst.translation_belarusian[44].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/225/%/196/%/218/%/206/%/193/%/222/%/217/%/195/%/216/"))
			language_inst.translation_belarusian[45].code := 45
			language_inst.translation_belarusian[45].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/246/%/213/%/210/%/206/%/193/%/204/ %/208/%/213/%/211/%/212/%/217/"))
			language_inst.translation_belarusian[46].code := 46
			language_inst.translation_belarusian[46].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/238/%/209/%/205/%/193/ %/218/%/193/%/203/%/193/%/222/%/193/%/203/"))
			language_inst.translation_belarusian[47].code := 47
			language_inst.translation_belarusian[47].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/238/%/209/%/205/%/193/ %/210/%/193/%/205/%/193/%/203/"))
			language_inst.translation_belarusian[48].code := 48
			language_inst.translation_belarusian[48].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/242/%/193/%/205/%/203/%/166/ VT 100"))
			language_inst.translation_belarusian[49].code := 49
			language_inst.translation_belarusian[49].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/242/%/193/%/205/%/203/%/166/ Linux %/195/%/166/ OS/2"))
			language_inst.translation_belarusian[50].code := 50
			language_inst.translation_belarusian[50].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/242/%/193/%/205/%/203/%/166/ KOI8-R"))
			language_inst.translation_belarusian[51].code := 51
			language_inst.translation_belarusian[51].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_belarusian[52].code := 52
			language_inst.translation_belarusian[52].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/247/%/217/%/203/%/193/%/210/%/217/%/211/%/212/%/207/%/174/%/215/%/193/%/195/%/216/ ^[[11m"))
			language_inst.translation_belarusian[53].code := 53
			language_inst.translation_belarusian[53].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/238/%/197/%/203/%/193/%/212/%/207/%/210/%/217/%/209/ %/210/%/193/%/205/%/203/%/166/ %/218/ cp850/852"))
			language_inst.translation_belarusian[54].code := 54
			language_inst.translation_belarusian[54].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/235/%/213/%/210/%/211/%/193/%/210/ %/208/%/210/%/193/%/205/%/193/%/215/%/213/%/199/%/207/%/204/%/216/%/206/%/166/%/203/%/193/%/205/"))
			language_inst.translation_belarusian[55].code := 55
			language_inst.translation_belarusian[55].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/235/%/207/%/204/%/197/%/210/"))
			language_inst.translation_belarusian[56].code := 56
			language_inst.translation_belarusian[56].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/238/%/193/%/211/%/212/%/210/%/207/%/202/%/203/%/166/ %/212/%/220/%/210/%/205/%/166/%/206/%/193/%/204/%/193/"))
			language_inst.translation_belarusian[57].code := 57
			language_inst.translation_belarusian[57].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("HTTP %/208/%/210/%/207/%/203/%/211/%/166/ (%/211/%/197/%/210/%/215/%/197/%/210/:%/208/%/207/%/210/%/212/)"))
			language_inst.translation_belarusian[58].code := 58
			language_inst.translation_belarusian[58].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("FTP %/208/%/210/%/207/%/203/%/211/%/166/ (%/211/%/197/%/210/%/215/%/197/%/210/:%/208/%/207/%/210/%/212/)"))
			language_inst.translation_belarusian[59].code := 59
			language_inst.translation_belarusian[59].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/243/%/208/%/166/%/211/ (%/208/%/210/%/193/%/218/ %/203/%/207/%/211/%/203/%/213/) %/196/%/193/%/205/%/197/%/206/%/193/%/174/ %/218/ %/196/%/207/%/211/%/212/%/213/%/208/%/193/%/205/ %/194/%/197/%/218/ %/208/%/210/%/207/%/203/%/211/%/166/"))
			language_inst.translation_belarusian[60].code := 60
			language_inst.translation_belarusian[60].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/237/%/193/%/203/%/211/. %/203/%/207/%/204/%/216/%/203/%/193/%/211/%/195/%/216/ %/218/%/204/%/213/%/222/%/220/%/206/%/206/%/209/%/174/"))
			language_inst.translation_belarusian[61].code := 61
			language_inst.translation_belarusian[61].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/237/%/193/%/203/%/211/. %/203/%/207/%/204/%/216/%/203/%/193/%/211/%/195/%/216/ %/218/%/204/%/213/%/222/%/220/%/206/%/206/%/209/%/174/ %/196/%/193/ %/193/%/196/%/206/%/193/%/199/%/207/ %/211/%/197/%/210/%/215/%/197/%/210/%/193/"))
			language_inst.translation_belarusian[62].code := 62
			language_inst.translation_belarusian[62].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/243/%/208/%/210/%/207/%/194/"))
			language_inst.translation_belarusian[63].code := 63
			language_inst.translation_belarusian[63].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/244/%/193/%/202/%/205/%/193/%/213/%/212/ %/206/%/193/ %/208/%/210/%/217/%/163/%/205/ (%/211/%/197/%/203/.)"))
			language_inst.translation_belarusian[64].code := 64
			language_inst.translation_belarusian[64].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/244/%/193/%/202/%/205/%/193/%/213/%/212/ %/208/%/210/%/217/ %/193/%/196/%/211/%/213/%/212/%/206/%/193/%/211/%/195/%/166/ %/196/%/193/%/203/%/193/%/222/%/203/%/166/"))
			language_inst.translation_belarusian[65].code := 65
			language_inst.translation_belarusian[65].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/225/%/211/%/166/%/206/%/200/%/210/%/207/%/206/%/206/%/217/ %/218/%/215/%/193/%/210/%/207/%/212/ %/196/%/193/ DNS"))
			language_inst.translation_belarusian[66].code := 66
			language_inst.translation_belarusian[66].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/245/%/211/%/212/%/193/%/206/%/207/%/174/%/203/%/193/ %/222/%/193/%/211/%/213/ %/196/%/204/%/209/ %/218/%/193/%/203/%/193/%/222/%/193/%/206/%/217/%/200/ %/198/%/193/%/202/%/204/%/193/%/174/"))
			language_inst.translation_belarusian[67].code := 67
			language_inst.translation_belarusian[67].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/238/%/193/%/211/%/212/%/210/%/207/%/202/%/203/%/166/ %/211/%/197/%/212/%/203/%/166/"))
			language_inst.translation_belarusian[68].code := 68
			language_inst.translation_belarusian[68].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/240/%/193/%/205/%/197/%/210/%/217/ %/203/%/220/%/219/%/193/ %/208/%/193/%/205/%/209/%/195/%/166/ (%/235/%/226/)"))
			language_inst.translation_belarusian[69].code := 69
			language_inst.translation_belarusian[69].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/235/%/207/%/204/%/216/%/203/%/193/%/211/%/195/%/216/ %/198/%/193/%/210/%/205/%/193/%/195/%/166/%/210/%/193/%/215/%/193/%/206/%/217/%/200/ %/196/%/193/%/203/%/213/%/205/%/197/%/206/%/212/%/193/%/174/"))
			language_inst.translation_belarusian[70].code := 70
			language_inst.translation_belarusian[70].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/238/%/193/%/211/%/212/%/210/%/207/%/202/%/203/%/166/ %/203/%/220/%/219/%/193/"))
			language_inst.translation_belarusian[71].code := 71
			language_inst.translation_belarusian[71].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/244/%/193/%/194/%/204/%/166/%/195/%/217/"))
			language_inst.translation_belarusian[72].code := 72
			language_inst.translation_belarusian[72].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/230/%/210/%/220/%/202/%/205/%/217/"))
			language_inst.translation_belarusian[73].code := 73
			language_inst.translation_belarusian[73].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/243/%/208/%/193/%/211/%/217/%/204/%/203/%/166/ %/206/%/193/ %/215/%/166/%/196/%/193/%/210/%/217/%/211/%/217/"))
			language_inst.translation_belarusian[74].code := 74
			language_inst.translation_belarusian[74].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/242/%/213/%/200/%/193/%/195/%/195/%/193/ %/208/%/193/ %/211/%/204/%/213/%/208/%/203/%/193/%/200/ %/212/%/193/%/194/%/204/%/166/%/195/"))
			language_inst.translation_belarusian[75].code := 75
			language_inst.translation_belarusian[75].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/238/%/213/%/205/%/197/%/210/%/193/%/215/%/193/%/195/%/216/ %/211/%/208/%/193/%/211/%/217/%/204/%/203/%/166/"))
			language_inst.translation_belarusian[76].code := 76
			language_inst.translation_belarusian[76].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/247/%/207/%/196/%/211/%/212/%/213/%/208/"))
			language_inst.translation_belarusian[77].code := 77
			language_inst.translation_belarusian[77].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/182/%/199/%/206/%/193/%/210/%/193/%/215/%/193/%/195/%/216/ %/203/%/193/%/196/%/218/%/166/%/210/%/207/%/174/%/203/%/213/, %/196/%/193/%/196/%/218/%/197/%/206/%/213/%/192/ %/211/%/197/%/210/%/215/%/197/%/210/%/193/%/205/"))
			language_inst.translation_belarusian[78].code := 78
			language_inst.translation_belarusian[78].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/238/%/193/%/211/%/212/%/210/%/207/%/202/%/203/%/166/ HTML"))
			language_inst.translation_belarusian[79].code := 79
			language_inst.translation_belarusian[79].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/235/%/193/%/196/%/218/%/166/%/210/%/207/%/174/%/203/%/193/ %/208/%/193/ %/218/%/193/%/205/%/207/%/174/%/222/%/215/%/193/%/206/%/206/%/166/"))
			language_inst.translation_belarusian[80].code := 80
			language_inst.translation_belarusian[80].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/240/%/197/%/210/%/193/%/202/%/195/%/166/ %/196/%/193/ %/206/%/207/%/215/%/193/%/199/%/193/ URL"))
			language_inst.translation_belarusian[81].code := 81
			language_inst.translation_belarusian[81].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/240/%/197/%/210/%/193/%/202/%/195/%/166/ %/206/%/193/%/218/%/193/%/196/"))
			language_inst.translation_belarusian[82].code := 82
			language_inst.translation_belarusian[82].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/246/%/213/%/210/%/206/%/193/%/204/"))
			language_inst.translation_belarusian[83].code := 83
			language_inst.translation_belarusian[83].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/225/%/196/%/206/%/193/%/215/%/166/%/195/%/216/"))
			language_inst.translation_belarusian[84].code := 84
			language_inst.translation_belarusian[84].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/250/%/193/%/200/%/193/%/215/%/193/%/195/%/216/ %/209/%/203/"))
			language_inst.translation_belarusian[85].code := 85
			language_inst.translation_belarusian[85].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/250/%/193/%/200/%/193/%/215/%/193/%/195/%/216/ URL %/209/%/203/"))
			language_inst.translation_belarusian[86].code := 86
			language_inst.translation_belarusian[86].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/250/%/193/%/200/%/193/%/215/%/193/%/195/%/216/ %/198/%/193/%/210/%/205/%/193/%/195/%/166/%/210/%/193/%/215/%/193/%/206/%/217/ %/196/%/193/%/203/%/213/%/205/%/197/%/206/%/212/"))
			language_inst.translation_belarusian[87].code := 87
			language_inst.translation_belarusian[87].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/242/%/193/%/218/%/193/%/210/%/215/%/193/%/195/%/216/ %/198/%/207/%/206/%/193/%/215/%/217/%/209/ %/218/%/204/%/213/%/222/%/220/%/206/%/206/%/166/"))
			language_inst.translation_belarusian[88].code := 88
			language_inst.translation_belarusian[88].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/225/%/222/%/217/%/211/%/195/%/166/%/195/%/216/ %/213/%/211/%/197/ %/215/%/166/%/196/%/217/ %/203/%/220/%/219/%/193/"))
			language_inst.translation_belarusian[89].code := 89
			language_inst.translation_belarusian[89].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/182/%/206/%/198/%/193/%/210/%/205/%/193/%/195/%/217/%/209/ %/208/%/210/%/193/ %/210/%/220/%/211/%/213/%/210/%/211/%/217/"))
			language_inst.translation_belarusian[90].code := 90
			language_inst.translation_belarusian[90].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/235/%/193/%/205/%/193/%/206/%/196/%/206/%/217/ %/210/%/193/%/196/%/207/%/203/"))
			language_inst.translation_belarusian[91].code := 91
			language_inst.translation_belarusian[91].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/247/%/217/%/200/%/193/%/196/"))
			language_inst.translation_belarusian[92].code := 92
			language_inst.translation_belarusian[92].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/240/%/207/%/219/%/213/%/203/"))
			language_inst.translation_belarusian[93].code := 93
			language_inst.translation_belarusian[93].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/250/%/215/%/193/%/210/%/207/%/212/%/206/%/217/ %/208/%/207/%/219/%/213/%/203/"))
			language_inst.translation_belarusian[94].code := 94
			language_inst.translation_belarusian[94].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/251/%/213/%/203/%/193/%/195/%/216/ %/196/%/193/%/204/%/197/%/202/"))
			language_inst.translation_belarusian[95].code := 95
			language_inst.translation_belarusian[95].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/251/%/213/%/203/%/193/%/195/%/216/ %/206/%/193/%/218/%/193/%/196/"))
			language_inst.translation_belarusian[96].code := 96
			language_inst.translation_belarusian[96].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/240/%/197/%/210/%/193/%/203/%/204/%/192/%/222/%/217/%/195/%/216/ HTML/%/212/%/220/%/203/%/211/%/212/"))
			language_inst.translation_belarusian[97].code := 97
			language_inst.translation_belarusian[97].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/182/%/206/%/198/%/193/%/210/%/205/%/193/%/195/%/217/%/209/ %/208/%/210/%/193/ %/196/%/193/%/203/%/213/%/205/%/197/%/206/%/212/"))
			language_inst.translation_belarusian[98].code := 98
			language_inst.translation_belarusian[98].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/230/%/210/%/220/%/202/%/205/ %/206/%/193/ %/208/%/207/%/174/%/206/%/217/ %/220/%/203/%/210/%/193/%/206/"))
			language_inst.translation_belarusian[99].code := 99
			language_inst.translation_belarusian[99].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/250/%/193/%/200/%/193/%/215/%/193/%/195/%/216/ %/206/%/193/%/211/%/212/%/210/%/207/%/202/%/203/%/166/ HTML"))
			language_inst.translation_belarusian[100].code := 100
			language_inst.translation_belarusian[100].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/228/%/193/%/196/%/193/%/195/%/216/"))
			language_inst.translation_belarusian[101].code := 101
			language_inst.translation_belarusian[101].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/250/%/205/%/209/%/206/%/166/%/195/%/216/"))
			language_inst.translation_belarusian[102].code := 102
			language_inst.translation_belarusian[102].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/247/%/217/%/196/%/193/%/204/%/166/%/195/%/216/"))
			language_inst.translation_belarusian[103].code := 103
			language_inst.translation_belarusian[103].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/235/%/193/%/196/%/218/%/166/%/210/%/207/%/174/%/203/%/193/"))
			language_inst.translation_belarusian[104].code := 104
			language_inst.translation_belarusian[104].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/235/%/220/%/219/"))
			language_inst.translation_belarusian[105].code := 105
			language_inst.translation_belarusian[105].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/240/%/207/%/219/%/212/%/193/ %/166/ telnet"))
			language_inst.translation_belarusian[106].code := 106
			language_inst.translation_belarusian[106].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/243/%/213/%/208/%/193/%/211/%/212/%/193/%/174/%/204/%/197/%/206/%/206/%/166/"))
			language_inst.translation_belarusian[107].code := 107
			language_inst.translation_belarusian[107].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/242/%/193/%/211/%/219/%/217/%/210/%/220/%/206/%/206/%/166/ %/198/%/193/%/202/%/204/%/193/%/174/"))
			language_inst.translation_belarusian[108].code := 108
			language_inst.translation_belarusian[108].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/250/%/193/%/200/%/193/%/215/%/193/%/195/%/216/ %/206/%/193/%/211/%/212/%/210/%/207/%/202/%/203/%/166/"))
			language_inst.translation_belarusian[109].code := 109
			language_inst.translation_belarusian[109].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/230/%/193/%/202/%/204/"))
			language_inst.translation_belarusian[110].code := 110
			language_inst.translation_belarusian[110].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/247/%/166/%/196/"))
			language_inst.translation_belarusian[111].code := 111
			language_inst.translation_belarusian[111].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/243/%/208/%/193/%/211/%/217/%/204/%/203/%/166/"))
			language_inst.translation_belarusian[112].code := 112
			language_inst.translation_belarusian[112].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/250/%/193/%/203/%/193/%/222/%/203/%/166/"))
			language_inst.translation_belarusian[113].code := 113
			language_inst.translation_belarusian[113].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/238/%/193/%/211/%/212/%/210/%/207/%/202/%/203/%/193/"))
			language_inst.translation_belarusian[114].code := 114
			language_inst.translation_belarusian[114].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/228/%/193/%/215/%/197/%/196/%/203/%/193/"))
			language_inst.translation_belarusian[115].code := 115
			language_inst.translation_belarusian[115].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/245/%/215/%/209/%/196/%/218/%/166/%/195/%/197/ URL"))
			language_inst.translation_belarusian[116].code := 116
			language_inst.translation_belarusian[116].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/250/%/193/%/200/%/193/%/215/%/193/%/195/%/216/ URL"))
			language_inst.translation_belarusian[117].code := 117
			language_inst.translation_belarusian[117].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/250/%/193/%/203/%/193/%/222/%/203/%/193/"))
			language_inst.translation_belarusian[118].code := 118
			language_inst.translation_belarusian[118].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/250/%/193/%/200/%/193/%/215/%/193/%/195/%/216/ %/213/ %/198/%/193/%/202/%/204/"))
			language_inst.translation_belarusian[119].code := 119
			language_inst.translation_belarusian[119].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/240/%/207/%/219/%/213/%/203/ %/212/%/220/%/203/%/211/%/212/%/213/"))
			language_inst.translation_belarusian[120].code := 120
			language_inst.translation_belarusian[120].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/254/%/193/%/203/%/193/%/206/%/206/%/197/ %/174/ %/222/%/193/%/210/%/218/%/197/"))
			language_inst.translation_belarusian[121].code := 121
			language_inst.translation_belarusian[121].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/240/%/207/%/219/%/213/%/203/ %/211/%/197/%/210/%/215/%/197/%/210/%/193/"))
			language_inst.translation_belarusian[122].code := 122
			language_inst.translation_belarusian[122].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/250/%/204/%/213/%/222/%/220/%/206/%/206/%/197/"))
			language_inst.translation_belarusian[123].code := 123
			language_inst.translation_belarusian[123].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/240/%/210/%/193/%/212/%/193/%/203/%/207/%/204/ SSL"))
			language_inst.translation_belarusian[124].code := 124
			language_inst.translation_belarusian[124].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/250/%/193/%/208/%/217/%/212/ %/208/%/193/%/211/%/204/%/193/%/206/%/217/"))
			language_inst.translation_belarusian[125].code := 125
			language_inst.translation_belarusian[125].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_belarusian[126].code := 126
			language_inst.translation_belarusian[126].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/225/%/212/%/210/%/217/%/205/%/193/%/206/%/206/%/197/ %/218/%/193/%/199/%/193/%/204/%/207/%/174/%/203/%/193/%/174/"))
			language_inst.translation_belarusian[127].code := 127
			language_inst.translation_belarusian[127].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/243/%/197/%/210/%/215/%/197/%/210/ %/193/%/208/%/210/%/193/%/195/%/207/%/174/%/215/%/193/%/197/ %/218/%/193/%/208/%/217/%/212/"))
			language_inst.translation_belarusian[128].code := 128
			language_inst.translation_belarusian[128].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/240/%/197/%/210/%/193/%/211/%/217/%/204/%/203/%/193/"))
			language_inst.translation_belarusian[129].code := 129
			language_inst.translation_belarusian[129].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/254/%/193/%/203/%/193/%/206/%/206/%/197/ %/208/%/193/%/195/%/215/%/197/%/210/%/196/%/214/%/193/%/206/%/206/%/209/ %/208/%/197/%/210/%/193/%/206/%/193/%/203/%/166/%/210/%/193/%/215/%/193/%/206/%/206/%/209/"))
			language_inst.translation_belarusian[130].code := 130
			language_inst.translation_belarusian[130].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/240/%/197/%/210/%/193/%/208/%/217/%/206/%/197/%/206/%/193/"))
			language_inst.translation_belarusian[131].code := 131
			language_inst.translation_belarusian[131].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/247/%/217/%/203/%/204/%/192/%/222/%/220/%/206/%/206/%/197/ %/174/ %/211/%/207/%/203/%/197/%/195/%/197/"))
			language_inst.translation_belarusian[132].code := 132
			language_inst.translation_belarusian[132].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/245/%/206/%/213/%/212/%/210/%/193/%/206/%/193/%/209/ %/208/%/193/%/205/%/217/%/204/%/203/%/193/"))
			language_inst.translation_belarusian[133].code := 133
			language_inst.translation_belarusian[133].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/237/%/193/%/204/%/193/ %/208/%/193/%/205/%/209/%/195/%/166/"))
			language_inst.translation_belarusian[134].code := 134
			language_inst.translation_belarusian[134].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/243/%/197/%/210/%/215/%/197/%/210/ %/206/%/197/ %/218/%/206/%/193/%/202/%/196/%/218/%/197/%/206/%/217/"))
			language_inst.translation_belarusian[135].code := 135
			language_inst.translation_belarusian[135].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/240/%/193/%/205/%/217/%/204/%/203/%/193/ %/218/%/193/%/208/%/166/%/211/%/213/ %/174/ %/211/%/207/%/203/%/197/%/212/"))
			language_inst.translation_belarusian[136].code := 136
			language_inst.translation_belarusian[136].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/240/%/193/%/205/%/217/%/204/%/203/%/193/ %/222/%/217/%/212/%/193/%/206/%/206/%/209/ %/218/ %/211/%/207/%/203/%/197/%/212/%/193/"))
			language_inst.translation_belarusian[137].code := 137
			language_inst.translation_belarusian[137].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/228/%/193/%/212/%/193/ %/218/%/205/%/197/%/206/%/197/%/206/%/193/"))
			language_inst.translation_belarusian[138].code := 138
			language_inst.translation_belarusian[138].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/238/%/209/%/208/%/210/%/193/%/215/%/166/%/204/%/216/%/206/%/217/ %/211/%/166/%/206/%/212/%/193/%/203/%/211/%/166/%/211/ URL"))
			language_inst.translation_belarusian[139].code := 139
			language_inst.translation_belarusian[139].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/244/%/193/%/202/%/205/%/193/%/174/%/212/ %/208/%/210/%/217/ %/222/%/217/%/212/%/193/%/206/%/206/%/166/"))
			language_inst.translation_belarusian[140].code := 140
			language_inst.translation_belarusian[140].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/250/%/193/%/208/%/217/%/212/ %/208/%/193/%/215/%/166/%/206/%/197/%/206/ %/194/%/217/%/195/%/216/ %/208/%/193/%/174/%/212/%/207/%/210/%/193/%/206/%/217/"))
			language_inst.translation_belarusian[141].code := 141
			language_inst.translation_belarusian[141].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/238/%/197/%/204/%/216/%/199/%/193/ %/193/%/212/%/210/%/217/%/205/%/193/%/195/%/216/ %/211/%/212/%/193/%/206/ %/211/%/207/%/203/%/197/%/212/%/193/"))
			language_inst.translation_belarusian[142].code := 142
			language_inst.translation_belarusian[142].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_belarusian[143].code := 143
			language_inst.translation_belarusian[143].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/238/%/209/%/208/%/210/%/193/%/215/%/166/%/204/%/216/%/206/%/217/ %/193/%/196/%/203/%/193/%/218/ HTTP"))
		end

end
