deferred class
	S_NETDB

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	herror (a_str: CE_POINTER [INTEGER_8])
		do
			c_herror (a_str.c_pointer)
		end

	c_herror (a_str: POINTER)
		external
			"C inline use <links.h>"
		alias
			"herror($a_str);"
		end

	gethostbyaddr (a_addr: CE_POINTER [ANY]; a_len: NATURAL_32; a_type: INTEGER_32): CE_POINTER [SD_HOSTENT]
		do
			create Result.make_shared (c_gethostbyaddr (a_addr.c_pointer, a_len, a_type))
		end

	c_gethostbyaddr (a_addr: POINTER; a_len: NATURAL_32; a_type: INTEGER_32): POINTER
		external
			"C inline use <links.h>"
		alias
			"return gethostbyaddr($a_addr, $a_len, $a_type);"
		end

	gethostbyname (a_name: CE_POINTER [INTEGER_8]): CE_POINTER [SD_HOSTENT]
		do
			create Result.make_shared (c_gethostbyname (a_name.c_pointer))
		end

	c_gethostbyname (a_name: POINTER): POINTER
		external
			"C inline use <links.h>"
		alias
			"return gethostbyname($a_name);"
		end

end
