deferred class
	S_TIME

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	time (a_timer: CE_POINTER [INTEGER_32]): INTEGER_32
		do
			Result := c_time (a_timer.c_pointer)
		end

	c_time (a_timer: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return time($a_timer);"
		end

	strftime (a_s: CE_POINTER [INTEGER_8]; a_maxsize: NATURAL_32; a_format: CE_POINTER [INTEGER_8]; a_tp: CE_POINTER [SD_TM]): NATURAL_32
		do
			Result := c_strftime (a_s.c_pointer, a_maxsize, a_format.c_pointer, a_tp.c_pointer)
		end

	c_strftime (a_s: POINTER; a_maxsize: NATURAL_32; a_format: POINTER; a_tp: POINTER): NATURAL_32
		external
			"C inline use <links.h>"
		alias
			"return strftime($a_s, $a_maxsize, $a_format, $a_tp);"
		end

	localtime (a_timer: CE_POINTER [INTEGER_32]): CE_POINTER [SD_TM]
		do
			create Result.make_shared (c_localtime (a_timer.c_pointer))
		end

	c_localtime (a_timer: POINTER): POINTER
		external
			"C inline use <links.h>"
		alias
			"return localtime($a_timer);"
		end

	mktime (a_tp: CE_POINTER [SD_TM]): INTEGER_32
		do
			Result := c_mktime (a_tp.c_pointer)
		end

	c_mktime (a_tp: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return mktime($a_tp);"
		end

end
