class
	PD_ACO_SAVE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	save_curbuf: CE_POINTER [PD_FILE_BUFFER] assign set_save_curbuf
		do
			create Result.make_shared (c_save_curbuf (c_pointer))
		end

	use_aucmd_win: INTEGER_32 assign set_use_aucmd_win
		do
			Result := c_use_aucmd_win (c_pointer)
		end

	save_curwin: CE_POINTER [PD_WINDOW_S] assign set_save_curwin
		do
			create Result.make_shared (c_save_curwin (c_pointer))
		end

	new_curwin: CE_POINTER [PD_WINDOW_S] assign set_new_curwin
		do
			create Result.make_shared (c_new_curwin (c_pointer))
		end

	new_curbuf: CE_POINTER [PD_FILE_BUFFER] assign set_new_curbuf
		do
			create Result.make_shared (c_new_curbuf (c_pointer))
		end

	globaldir: CE_POINTER [NATURAL_8] assign set_globaldir
		do
			create Result.make_shared (c_globaldir (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_save_curbuf (a_save_curbuf: CE_POINTER [PD_FILE_BUFFER])
		do
			c_set_save_curbuf (c_pointer, a_save_curbuf.c_pointer)
		end

	set_use_aucmd_win (a_use_aucmd_win: INTEGER_32)
		do
			c_set_use_aucmd_win (c_pointer, a_use_aucmd_win)
		end

	set_save_curwin (a_save_curwin: CE_POINTER [PD_WINDOW_S])
		do
			c_set_save_curwin (c_pointer, a_save_curwin.c_pointer)
		end

	set_new_curwin (a_new_curwin: CE_POINTER [PD_WINDOW_S])
		do
			c_set_new_curwin (c_pointer, a_new_curwin.c_pointer)
		end

	set_new_curbuf (a_new_curbuf: CE_POINTER [PD_FILE_BUFFER])
		do
			c_set_new_curbuf (c_pointer, a_new_curbuf.c_pointer)
		end

	set_globaldir (a_globaldir: CE_POINTER [NATURAL_8])
		do
			c_set_globaldir (c_pointer, a_globaldir.c_pointer)
		end

feature {NONE} -- C getters

	c_save_curbuf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct file_buffer *)((struct __anonstruct_aco_save_T_536 *)$tmp)->save_curbuf;"
		end

	c_use_aucmd_win (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_aco_save_T_536 *)$tmp)->use_aucmd_win;"
		end

	c_save_curwin (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct window_S *)((struct __anonstruct_aco_save_T_536 *)$tmp)->save_curwin;"
		end

	c_new_curwin (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct window_S *)((struct __anonstruct_aco_save_T_536 *)$tmp)->new_curwin;"
		end

	c_new_curbuf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct file_buffer *)((struct __anonstruct_aco_save_T_536 *)$tmp)->new_curbuf;"
		end

	c_globaldir (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_aco_save_T_536 *)$tmp)->globaldir;"
		end

feature {NONE} -- C setters

	c_set_save_curbuf (tmp: POINTER; a_save_curbuf: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_aco_save_T_536 *)$tmp)->save_curbuf = (struct file_buffer *)$a_save_curbuf;"
		end

	c_set_use_aucmd_win (tmp: POINTER; a_use_aucmd_win: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_aco_save_T_536 *)$tmp)->use_aucmd_win = $a_use_aucmd_win;"
		end

	c_set_save_curwin (tmp: POINTER; a_save_curwin: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_aco_save_T_536 *)$tmp)->save_curwin = (struct window_S *)$a_save_curwin;"
		end

	c_set_new_curwin (tmp: POINTER; a_new_curwin: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_aco_save_T_536 *)$tmp)->new_curwin = (struct window_S *)$a_new_curwin;"
		end

	c_set_new_curbuf (tmp: POINTER; a_new_curbuf: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_aco_save_T_536 *)$tmp)->new_curbuf = (struct file_buffer *)$a_new_curbuf;"
		end

	c_set_globaldir (tmp: POINTER; a_globaldir: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_aco_save_T_536 *)$tmp)->globaldir = (unsigned char *)$a_globaldir;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_aco_save_T_536);"
		end

end
