class
	PD_ARGENTRY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ae_fname: CE_POINTER [NATURAL_8] assign set_ae_fname
		do
			create Result.make_shared (c_ae_fname (c_pointer))
		end

	ae_fnum: INTEGER_32 assign set_ae_fnum
		do
			Result := c_ae_fnum (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_ae_fname (a_ae_fname: CE_POINTER [NATURAL_8])
		do
			c_set_ae_fname (c_pointer, a_ae_fname.c_pointer)
		end

	set_ae_fnum (a_ae_fnum: INTEGER_32)
		do
			c_set_ae_fnum (c_pointer, a_ae_fnum)
		end

feature {NONE} -- C getters

	c_ae_fname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct argentry *)$tmp)->ae_fname;"
		end

	c_ae_fnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct argentry *)$tmp)->ae_fnum;"
		end

feature {NONE} -- C setters

	c_set_ae_fname (tmp: POINTER; a_ae_fname: POINTER)
		external
			"C inline"
		alias
			"((struct argentry *)$tmp)->ae_fname = (unsigned char *)$a_ae_fname;"
		end

	c_set_ae_fnum (tmp: POINTER; a_ae_fnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct argentry *)$tmp)->ae_fnum = $a_ae_fnum;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct argentry);"
		end

end
