class
	PD_ARGLIST

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	al_ga: PD_GROWARRAY assign set_al_ga
		do
			create Result.make_shared (c_al_ga (c_pointer))
		end

	al_ga_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct arglist, al_ga);"
		end

	al_refcount: INTEGER_32 assign set_al_refcount
		do
			Result := c_al_refcount (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_al_ga (a_al_ga: PD_GROWARRAY)
		do
			al_ga.ce_gets (a_al_ga)
		end

	set_al_refcount (a_al_refcount: INTEGER_32)
		do
			c_set_al_refcount (c_pointer, a_al_refcount)
		end

feature {NONE} -- C getters

	c_al_ga (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct growarray *)&((struct arglist *)$tmp)->al_ga;"
		end

	c_al_refcount (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct arglist *)$tmp)->al_refcount;"
		end

feature {NONE} -- C setters

	c_set_al_refcount (tmp: POINTER; a_al_refcount: INTEGER_32)
		external
			"C inline"
		alias
			"((struct arglist *)$tmp)->al_refcount = $a_al_refcount;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct arglist);"
		end

end
