class
	PD_BACKPOS_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	bp_scan: CE_POINTER [NATURAL_8] assign set_bp_scan
		do
			create Result.make_shared (c_bp_scan (c_pointer))
		end

	bp_pos: PD_REGSAVE_T assign set_bp_pos
		do
			create Result.make_shared (c_bp_pos (c_pointer))
		end

	bp_pos_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct backpos_S, bp_pos);"
		end

feature {ANY} -- Eiffel setters

	set_bp_scan (a_bp_scan: CE_POINTER [NATURAL_8])
		do
			c_set_bp_scan (c_pointer, a_bp_scan.c_pointer)
		end

	set_bp_pos (a_bp_pos: PD_REGSAVE_T)
		do
			bp_pos.ce_gets (a_bp_pos)
		end

feature {NONE} -- C getters

	c_bp_scan (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct backpos_S *)$tmp)->bp_scan;"
		end

	c_bp_pos (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (regsave_T *)&((struct backpos_S *)$tmp)->bp_pos;"
		end

feature {NONE} -- C setters

	c_set_bp_scan (tmp: POINTER; a_bp_scan: POINTER)
		external
			"C inline"
		alias
			"((struct backpos_S *)$tmp)->bp_scan = (unsigned char *)$a_bp_scan;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct backpos_S);"
		end

end
