class
	PD_BLOCK0

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	b0_id: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_b0_id (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	b0_version: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_b0_version (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	b0_page_size: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_b0_page_size (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	b0_mtime: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_b0_mtime (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	b0_ino: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_b0_ino (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	b0_pid: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_b0_pid (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	b0_uname: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_b0_uname (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	b0_hname: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_b0_hname (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	b0_fname: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_b0_fname (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	b0_magic_long: INTEGER_32 assign set_b0_magic_long
		do
			Result := c_b0_magic_long (c_pointer)
		end

	b0_magic_int: INTEGER_32 assign set_b0_magic_int
		do
			Result := c_b0_magic_int (c_pointer)
		end

	b0_magic_short: INTEGER_16 assign set_b0_magic_short
		do
			Result := c_b0_magic_short (c_pointer)
		end

	b0_magic_char: NATURAL_8 assign set_b0_magic_char
		do
			Result := c_b0_magic_char (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_b0_magic_long (a_b0_magic_long: INTEGER_32)
		do
			c_set_b0_magic_long (c_pointer, a_b0_magic_long)
		end

	set_b0_magic_int (a_b0_magic_int: INTEGER_32)
		do
			c_set_b0_magic_int (c_pointer, a_b0_magic_int)
		end

	set_b0_magic_short (a_b0_magic_short: INTEGER_16)
		do
			c_set_b0_magic_short (c_pointer, a_b0_magic_short)
		end

	set_b0_magic_char (a_b0_magic_char: NATURAL_8)
		do
			c_set_b0_magic_char (c_pointer, a_b0_magic_char)
		end

feature {NONE} -- C getters

	c_b0_id (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct block0 *tmp = (struct block0 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->b0_id) / sizeof(tmp->b0_id[0]);
				return tmp->b0_id;
			]"
		end

	c_b0_version (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct block0 *tmp = (struct block0 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->b0_version) / sizeof(tmp->b0_version[0]);
				return tmp->b0_version;
			]"
		end

	c_b0_page_size (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct block0 *tmp = (struct block0 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->b0_page_size) / sizeof(tmp->b0_page_size[0]);
				return tmp->b0_page_size;
			]"
		end

	c_b0_mtime (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct block0 *tmp = (struct block0 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->b0_mtime) / sizeof(tmp->b0_mtime[0]);
				return tmp->b0_mtime;
			]"
		end

	c_b0_ino (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct block0 *tmp = (struct block0 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->b0_ino) / sizeof(tmp->b0_ino[0]);
				return tmp->b0_ino;
			]"
		end

	c_b0_pid (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct block0 *tmp = (struct block0 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->b0_pid) / sizeof(tmp->b0_pid[0]);
				return tmp->b0_pid;
			]"
		end

	c_b0_uname (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct block0 *tmp = (struct block0 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->b0_uname) / sizeof(tmp->b0_uname[0]);
				return tmp->b0_uname;
			]"
		end

	c_b0_hname (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct block0 *tmp = (struct block0 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->b0_hname) / sizeof(tmp->b0_hname[0]);
				return tmp->b0_hname;
			]"
		end

	c_b0_fname (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct block0 *tmp = (struct block0 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->b0_fname) / sizeof(tmp->b0_fname[0]);
				return tmp->b0_fname;
			]"
		end

	c_b0_magic_long (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct block0 *)$tmp)->b0_magic_long;"
		end

	c_b0_magic_int (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct block0 *)$tmp)->b0_magic_int;"
		end

	c_b0_magic_short (tmp: POINTER): INTEGER_16
		external
			"C inline"
		alias
			"return (short)((struct block0 *)$tmp)->b0_magic_short;"
		end

	c_b0_magic_char (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct block0 *)$tmp)->b0_magic_char;"
		end

feature {NONE} -- C setters

	c_set_b0_magic_long (tmp: POINTER; a_b0_magic_long: INTEGER_32)
		external
			"C inline"
		alias
			"((struct block0 *)$tmp)->b0_magic_long = $a_b0_magic_long;"
		end

	c_set_b0_magic_int (tmp: POINTER; a_b0_magic_int: INTEGER_32)
		external
			"C inline"
		alias
			"((struct block0 *)$tmp)->b0_magic_int = $a_b0_magic_int;"
		end

	c_set_b0_magic_short (tmp: POINTER; a_b0_magic_short: INTEGER_16)
		external
			"C inline"
		alias
			"((struct block0 *)$tmp)->b0_magic_short = $a_b0_magic_short;"
		end

	c_set_b0_magic_char (tmp: POINTER; a_b0_magic_char: NATURAL_8)
		external
			"C inline"
		alias
			"((struct block0 *)$tmp)->b0_magic_char = $a_b0_magic_char;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct block0);"
		end

end
