class
	PD_BUFFHEADER

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	bh_first: PD_BUFFBLOCK assign set_bh_first
		do
			create Result.make_shared (c_bh_first (c_pointer))
		end

	bh_first_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct buffheader, bh_first);"
		end

	bh_curr: CE_POINTER [PD_BUFFBLOCK] assign set_bh_curr
		do
			create Result.make_shared (c_bh_curr (c_pointer))
		end

	bh_index: INTEGER_32 assign set_bh_index
		do
			Result := c_bh_index (c_pointer)
		end

	bh_space: INTEGER_32 assign set_bh_space
		do
			Result := c_bh_space (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_bh_first (a_bh_first: PD_BUFFBLOCK)
		do
			bh_first.ce_gets (a_bh_first)
		end

	set_bh_curr (a_bh_curr: CE_POINTER [PD_BUFFBLOCK])
		do
			c_set_bh_curr (c_pointer, a_bh_curr.c_pointer)
		end

	set_bh_index (a_bh_index: INTEGER_32)
		do
			c_set_bh_index (c_pointer, a_bh_index)
		end

	set_bh_space (a_bh_space: INTEGER_32)
		do
			c_set_bh_space (c_pointer, a_bh_space)
		end

feature {NONE} -- C getters

	c_bh_first (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct buffblock *)&((struct buffheader *)$tmp)->bh_first;"
		end

	c_bh_curr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct buffblock *)((struct buffheader *)$tmp)->bh_curr;"
		end

	c_bh_index (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct buffheader *)$tmp)->bh_index;"
		end

	c_bh_space (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct buffheader *)$tmp)->bh_space;"
		end

feature {NONE} -- C setters

	c_set_bh_curr (tmp: POINTER; a_bh_curr: POINTER)
		external
			"C inline"
		alias
			"((struct buffheader *)$tmp)->bh_curr = (struct buffblock *)$a_bh_curr;"
		end

	c_set_bh_index (tmp: POINTER; a_bh_index: INTEGER_32)
		external
			"C inline"
		alias
			"((struct buffheader *)$tmp)->bh_index = $a_bh_index;"
		end

	c_set_bh_space (tmp: POINTER; a_bh_space: INTEGER_32)
		external
			"C inline"
		alias
			"((struct buffheader *)$tmp)->bh_space = $a_bh_space;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct buffheader);"
		end

end
