class
	PD_CHARSTAB

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	cp: CE_POINTER [INTEGER_32] assign set_cp
		do
			create Result.make_shared (c_cp (c_pointer))
		end

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_cp (a_cp: CE_POINTER [INTEGER_32])
		do
			c_set_cp (c_pointer, a_cp.c_pointer)
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

feature {NONE} -- C getters

	c_cp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int *)((struct charstab *)$tmp)->cp;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct charstab *)$tmp)->name;"
		end

feature {NONE} -- C setters

	c_set_cp (tmp: POINTER; a_cp: POINTER)
		external
			"C inline"
		alias
			"((struct charstab *)$tmp)->cp = (int *)$a_cp;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct charstab *)$tmp)->name = (char *)$a_name;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct charstab);"
		end

end
