class
	PD_CLINTERVAL

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	first: NATURAL_16 assign set_first
		do
			Result := c_first (c_pointer)
		end

	last: NATURAL_16 assign set_last
		do
			Result := c_last (c_pointer)
		end

	class2: NATURAL_16 assign set_class2
		do
			Result := c_class2 (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_first (a_first: NATURAL_16)
		do
			c_set_first (c_pointer, a_first)
		end

	set_last (a_last: NATURAL_16)
		do
			c_set_last (c_pointer, a_last)
		end

	set_class2 (a_class2: NATURAL_16)
		do
			c_set_class2 (c_pointer, a_class2)
		end

feature {NONE} -- C getters

	c_first (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct clinterval *)$tmp)->first;"
		end

	c_last (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct clinterval *)$tmp)->last;"
		end

	c_class2 (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct clinterval *)$tmp)->class;"
		end

feature {NONE} -- C setters

	c_set_first (tmp: POINTER; a_first: NATURAL_16)
		external
			"C inline"
		alias
			"((struct clinterval *)$tmp)->first = $a_first;"
		end

	c_set_last (tmp: POINTER; a_last: NATURAL_16)
		external
			"C inline"
		alias
			"((struct clinterval *)$tmp)->last = $a_last;"
		end

	c_set_class2 (tmp: POINTER; a_class2: NATURAL_16)
		external
			"C inline"
		alias
			"((struct clinterval *)$tmp)->class = $a_class2;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct clinterval);"
		end

end
