class
	PD_CMDARG_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	oap: CE_POINTER [PD_OPARG_S] assign set_oap
		do
			create Result.make_shared (c_oap (c_pointer))
		end

	prechar: INTEGER_32 assign set_prechar
		do
			Result := c_prechar (c_pointer)
		end

	cmdchar: INTEGER_32 assign set_cmdchar
		do
			Result := c_cmdchar (c_pointer)
		end

	nchar: INTEGER_32 assign set_nchar
		do
			Result := c_nchar (c_pointer)
		end

	nchar_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct cmdarg_S, nchar);"
		end

	ncharC1: INTEGER_32 assign set_ncharC1
		do
			Result := c_ncharC1 (c_pointer)
		end

	ncharC2: INTEGER_32 assign set_ncharC2
		do
			Result := c_ncharC2 (c_pointer)
		end

	extra_char: INTEGER_32 assign set_extra_char
		do
			Result := c_extra_char (c_pointer)
		end

	extra_char_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct cmdarg_S, extra_char);"
		end

	opcount: INTEGER_32 assign set_opcount
		do
			Result := c_opcount (c_pointer)
		end

	count0: INTEGER_32 assign set_count0
		do
			Result := c_count0 (c_pointer)
		end

	count1: INTEGER_32 assign set_count1
		do
			Result := c_count1 (c_pointer)
		end

	arg: INTEGER_32 assign set_arg
		do
			Result := c_arg (c_pointer)
		end

	retval: INTEGER_32 assign set_retval
		do
			Result := c_retval (c_pointer)
		end

	searchbuf: CE_POINTER [NATURAL_8] assign set_searchbuf
		do
			create Result.make_shared (c_searchbuf (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_oap (a_oap: CE_POINTER [PD_OPARG_S])
		do
			c_set_oap (c_pointer, a_oap.c_pointer)
		end

	set_prechar (a_prechar: INTEGER_32)
		do
			c_set_prechar (c_pointer, a_prechar)
		end

	set_cmdchar (a_cmdchar: INTEGER_32)
		do
			c_set_cmdchar (c_pointer, a_cmdchar)
		end

	set_nchar (a_nchar: INTEGER_32)
		do
			c_set_nchar (c_pointer, a_nchar)
		end

	set_ncharC1 (a_ncharC1: INTEGER_32)
		do
			c_set_ncharC1 (c_pointer, a_ncharC1)
		end

	set_ncharC2 (a_ncharC2: INTEGER_32)
		do
			c_set_ncharC2 (c_pointer, a_ncharC2)
		end

	set_extra_char (a_extra_char: INTEGER_32)
		do
			c_set_extra_char (c_pointer, a_extra_char)
		end

	set_opcount (a_opcount: INTEGER_32)
		do
			c_set_opcount (c_pointer, a_opcount)
		end

	set_count0 (a_count0: INTEGER_32)
		do
			c_set_count0 (c_pointer, a_count0)
		end

	set_count1 (a_count1: INTEGER_32)
		do
			c_set_count1 (c_pointer, a_count1)
		end

	set_arg (a_arg: INTEGER_32)
		do
			c_set_arg (c_pointer, a_arg)
		end

	set_retval (a_retval: INTEGER_32)
		do
			c_set_retval (c_pointer, a_retval)
		end

	set_searchbuf (a_searchbuf: CE_POINTER [NATURAL_8])
		do
			c_set_searchbuf (c_pointer, a_searchbuf.c_pointer)
		end

feature {NONE} -- C getters

	c_oap (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct oparg_S *)((struct cmdarg_S *)$tmp)->oap;"
		end

	c_prechar (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cmdarg_S *)$tmp)->prechar;"
		end

	c_cmdchar (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cmdarg_S *)$tmp)->cmdchar;"
		end

	c_nchar (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cmdarg_S *)$tmp)->nchar;"
		end

	c_ncharC1 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cmdarg_S *)$tmp)->ncharC1;"
		end

	c_ncharC2 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cmdarg_S *)$tmp)->ncharC2;"
		end

	c_extra_char (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cmdarg_S *)$tmp)->extra_char;"
		end

	c_opcount (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct cmdarg_S *)$tmp)->opcount;"
		end

	c_count0 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct cmdarg_S *)$tmp)->count0;"
		end

	c_count1 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct cmdarg_S *)$tmp)->count1;"
		end

	c_arg (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cmdarg_S *)$tmp)->arg;"
		end

	c_retval (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cmdarg_S *)$tmp)->retval;"
		end

	c_searchbuf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct cmdarg_S *)$tmp)->searchbuf;"
		end

feature {NONE} -- C setters

	c_set_oap (tmp: POINTER; a_oap: POINTER)
		external
			"C inline"
		alias
			"((struct cmdarg_S *)$tmp)->oap = (struct oparg_S *)$a_oap;"
		end

	c_set_prechar (tmp: POINTER; a_prechar: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cmdarg_S *)$tmp)->prechar = $a_prechar;"
		end

	c_set_cmdchar (tmp: POINTER; a_cmdchar: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cmdarg_S *)$tmp)->cmdchar = $a_cmdchar;"
		end

	c_set_nchar (tmp: POINTER; a_nchar: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cmdarg_S *)$tmp)->nchar = $a_nchar;"
		end

	c_set_ncharC1 (tmp: POINTER; a_ncharC1: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cmdarg_S *)$tmp)->ncharC1 = $a_ncharc1;"
		end

	c_set_ncharC2 (tmp: POINTER; a_ncharC2: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cmdarg_S *)$tmp)->ncharC2 = $a_ncharc2;"
		end

	c_set_extra_char (tmp: POINTER; a_extra_char: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cmdarg_S *)$tmp)->extra_char = $a_extra_char;"
		end

	c_set_opcount (tmp: POINTER; a_opcount: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cmdarg_S *)$tmp)->opcount = $a_opcount;"
		end

	c_set_count0 (tmp: POINTER; a_count0: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cmdarg_S *)$tmp)->count0 = $a_count0;"
		end

	c_set_count1 (tmp: POINTER; a_count1: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cmdarg_S *)$tmp)->count1 = $a_count1;"
		end

	c_set_arg (tmp: POINTER; a_arg: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cmdarg_S *)$tmp)->arg = $a_arg;"
		end

	c_set_retval (tmp: POINTER; a_retval: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cmdarg_S *)$tmp)->retval = $a_retval;"
		end

	c_set_searchbuf (tmp: POINTER; a_searchbuf: POINTER)
		external
			"C inline"
		alias
			"((struct cmdarg_S *)$tmp)->searchbuf = (unsigned char *)$a_searchbuf;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct cmdarg_S);"
		end

end
