class
	PD_CMDMOD_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	hide: INTEGER_32 assign set_hide
		do
			Result := c_hide (c_pointer)
		end

	browse: INTEGER_32 assign set_browse
		do
			Result := c_browse (c_pointer)
		end

	split: INTEGER_32 assign set_split
		do
			Result := c_split (c_pointer)
		end

	tab: INTEGER_32 assign set_tab
		do
			Result := c_tab (c_pointer)
		end

	confirm: INTEGER_32 assign set_confirm
		do
			Result := c_confirm (c_pointer)
		end

	keepalt: INTEGER_32 assign set_keepalt
		do
			Result := c_keepalt (c_pointer)
		end

	keepmarks: INTEGER_32 assign set_keepmarks
		do
			Result := c_keepmarks (c_pointer)
		end

	keepjumps: INTEGER_32 assign set_keepjumps
		do
			Result := c_keepjumps (c_pointer)
		end

	lockmarks: INTEGER_32 assign set_lockmarks
		do
			Result := c_lockmarks (c_pointer)
		end

	save_ei: CE_POINTER [NATURAL_8] assign set_save_ei
		do
			create Result.make_shared (c_save_ei (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_hide (a_hide: INTEGER_32)
		do
			c_set_hide (c_pointer, a_hide)
		end

	set_browse (a_browse: INTEGER_32)
		do
			c_set_browse (c_pointer, a_browse)
		end

	set_split (a_split: INTEGER_32)
		do
			c_set_split (c_pointer, a_split)
		end

	set_tab (a_tab: INTEGER_32)
		do
			c_set_tab (c_pointer, a_tab)
		end

	set_confirm (a_confirm: INTEGER_32)
		do
			c_set_confirm (c_pointer, a_confirm)
		end

	set_keepalt (a_keepalt: INTEGER_32)
		do
			c_set_keepalt (c_pointer, a_keepalt)
		end

	set_keepmarks (a_keepmarks: INTEGER_32)
		do
			c_set_keepmarks (c_pointer, a_keepmarks)
		end

	set_keepjumps (a_keepjumps: INTEGER_32)
		do
			c_set_keepjumps (c_pointer, a_keepjumps)
		end

	set_lockmarks (a_lockmarks: INTEGER_32)
		do
			c_set_lockmarks (c_pointer, a_lockmarks)
		end

	set_save_ei (a_save_ei: CE_POINTER [NATURAL_8])
		do
			c_set_save_ei (c_pointer, a_save_ei.c_pointer)
		end

feature {NONE} -- C getters

	c_hide (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_cmdmod_T_521 *)$tmp)->hide;"
		end

	c_browse (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_cmdmod_T_521 *)$tmp)->browse;"
		end

	c_split (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_cmdmod_T_521 *)$tmp)->split;"
		end

	c_tab (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_cmdmod_T_521 *)$tmp)->tab;"
		end

	c_confirm (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_cmdmod_T_521 *)$tmp)->confirm;"
		end

	c_keepalt (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_cmdmod_T_521 *)$tmp)->keepalt;"
		end

	c_keepmarks (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_cmdmod_T_521 *)$tmp)->keepmarks;"
		end

	c_keepjumps (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_cmdmod_T_521 *)$tmp)->keepjumps;"
		end

	c_lockmarks (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_cmdmod_T_521 *)$tmp)->lockmarks;"
		end

	c_save_ei (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_cmdmod_T_521 *)$tmp)->save_ei;"
		end

feature {NONE} -- C setters

	c_set_hide (tmp: POINTER; a_hide: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_cmdmod_T_521 *)$tmp)->hide = $a_hide;"
		end

	c_set_browse (tmp: POINTER; a_browse: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_cmdmod_T_521 *)$tmp)->browse = $a_browse;"
		end

	c_set_split (tmp: POINTER; a_split: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_cmdmod_T_521 *)$tmp)->split = $a_split;"
		end

	c_set_tab (tmp: POINTER; a_tab: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_cmdmod_T_521 *)$tmp)->tab = $a_tab;"
		end

	c_set_confirm (tmp: POINTER; a_confirm: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_cmdmod_T_521 *)$tmp)->confirm = $a_confirm;"
		end

	c_set_keepalt (tmp: POINTER; a_keepalt: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_cmdmod_T_521 *)$tmp)->keepalt = $a_keepalt;"
		end

	c_set_keepmarks (tmp: POINTER; a_keepmarks: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_cmdmod_T_521 *)$tmp)->keepmarks = $a_keepmarks;"
		end

	c_set_keepjumps (tmp: POINTER; a_keepjumps: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_cmdmod_T_521 *)$tmp)->keepjumps = $a_keepjumps;"
		end

	c_set_lockmarks (tmp: POINTER; a_lockmarks: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_cmdmod_T_521 *)$tmp)->lockmarks = $a_lockmarks;"
		end

	c_set_save_ei (tmp: POINTER; a_save_ei: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_cmdmod_T_521 *)$tmp)->save_ei = (unsigned char *)$a_save_ei;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_cmdmod_T_521);"
		end

end
