class
	PD_CMDNAME

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	cmd_name: CE_POINTER [NATURAL_8] assign set_cmd_name
		do
			create Result.make_shared (c_cmd_name (c_pointer))
		end

	cmd_func: CE_ROUTINE assign set_cmd_func
		do
			create Result.make_shared (c_cmd_func (c_pointer))
		end

	cmd_argt: NATURAL_32 assign set_cmd_argt
		do
			Result := c_cmd_argt (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_cmd_name (a_cmd_name: CE_POINTER [NATURAL_8])
		do
			c_set_cmd_name (c_pointer, a_cmd_name.c_pointer)
		end

	set_cmd_func (a_cmd_func: CE_ROUTINE)
		do
			c_set_cmd_func (c_pointer, a_cmd_func.c_pointer)
		end

	set_cmd_argt (a_cmd_argt: NATURAL_32)
		do
			c_set_cmd_argt (c_pointer, a_cmd_argt)
		end

feature {NONE} -- C getters

	c_cmd_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct cmdname *)$tmp)->cmd_name;"
		end

	c_cmd_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct exarg * eap))((struct cmdname *)$tmp)->cmd_func;"
		end

	c_cmd_argt (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct cmdname *)$tmp)->cmd_argt;"
		end

feature {NONE} -- C setters

	c_set_cmd_name (tmp: POINTER; a_cmd_name: POINTER)
		external
			"C inline"
		alias
			"((struct cmdname *)$tmp)->cmd_name = (unsigned char *)$a_cmd_name;"
		end

	c_set_cmd_func (tmp: POINTER; a_cmd_func: POINTER)
		external
			"C inline"
		alias
			"((struct cmdname *)$tmp)->cmd_func = (void( *)(struct exarg * eap))$a_cmd_func;"
		end

	c_set_cmd_argt (tmp: POINTER; a_cmd_argt: NATURAL_32)
		external
			"C inline"
		alias
			"((struct cmdname *)$tmp)->cmd_argt = $a_cmd_argt;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct cmdname);"
		end

end
