class
	PD_CONVERTSTRUCT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	rangeStart: INTEGER_32 assign set_rangeStart
		do
			Result := c_rangeStart (c_pointer)
		end

	rangeEnd: INTEGER_32 assign set_rangeEnd
		do
			Result := c_rangeEnd (c_pointer)
		end

	step: INTEGER_32 assign set_step
		do
			Result := c_step (c_pointer)
		end

	offset: INTEGER_32 assign set_offset
		do
			Result := c_offset (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_rangeStart (a_rangeStart: INTEGER_32)
		do
			c_set_rangeStart (c_pointer, a_rangeStart)
		end

	set_rangeEnd (a_rangeEnd: INTEGER_32)
		do
			c_set_rangeEnd (c_pointer, a_rangeEnd)
		end

	set_step (a_step: INTEGER_32)
		do
			c_set_step (c_pointer, a_step)
		end

	set_offset (a_offset: INTEGER_32)
		do
			c_set_offset (c_pointer, a_offset)
		end

feature {NONE} -- C getters

	c_rangeStart (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_convertStruct_545 *)$tmp)->rangeStart;"
		end

	c_rangeEnd (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_convertStruct_545 *)$tmp)->rangeEnd;"
		end

	c_step (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_convertStruct_545 *)$tmp)->step;"
		end

	c_offset (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_convertStruct_545 *)$tmp)->offset;"
		end

feature {NONE} -- C setters

	c_set_rangeStart (tmp: POINTER; a_rangeStart: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_convertStruct_545 *)$tmp)->rangeStart = $a_rangestart;"
		end

	c_set_rangeEnd (tmp: POINTER; a_rangeEnd: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_convertStruct_545 *)$tmp)->rangeEnd = $a_rangeend;"
		end

	c_set_step (tmp: POINTER; a_step: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_convertStruct_545 *)$tmp)->step = $a_step;"
		end

	c_set_offset (tmp: POINTER; a_offset: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_convertStruct_545 *)$tmp)->offset = $a_offset;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_convertStruct_545);"
		end

end
