class
	PD_CURSOR_ENTRY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	shape: INTEGER_32 assign set_shape
		do
			Result := c_shape (c_pointer)
		end

	mshape: INTEGER_32 assign set_mshape
		do
			Result := c_mshape (c_pointer)
		end

	percentage: INTEGER_32 assign set_percentage
		do
			Result := c_percentage (c_pointer)
		end

	blinkwait: INTEGER_32 assign set_blinkwait
		do
			Result := c_blinkwait (c_pointer)
		end

	blinkon: INTEGER_32 assign set_blinkon
		do
			Result := c_blinkon (c_pointer)
		end

	blinkoff: INTEGER_32 assign set_blinkoff
		do
			Result := c_blinkoff (c_pointer)
		end

	id: INTEGER_32 assign set_id
		do
			Result := c_id (c_pointer)
		end

	id_lm: INTEGER_32 assign set_id_lm
		do
			Result := c_id_lm (c_pointer)
		end

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	used_for: INTEGER_8 assign set_used_for
		do
			Result := c_used_for (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_shape (a_shape: INTEGER_32)
		do
			c_set_shape (c_pointer, a_shape)
		end

	set_mshape (a_mshape: INTEGER_32)
		do
			c_set_mshape (c_pointer, a_mshape)
		end

	set_percentage (a_percentage: INTEGER_32)
		do
			c_set_percentage (c_pointer, a_percentage)
		end

	set_blinkwait (a_blinkwait: INTEGER_32)
		do
			c_set_blinkwait (c_pointer, a_blinkwait)
		end

	set_blinkon (a_blinkon: INTEGER_32)
		do
			c_set_blinkon (c_pointer, a_blinkon)
		end

	set_blinkoff (a_blinkoff: INTEGER_32)
		do
			c_set_blinkoff (c_pointer, a_blinkoff)
		end

	set_id (a_id: INTEGER_32)
		do
			c_set_id (c_pointer, a_id)
		end

	set_id_lm (a_id_lm: INTEGER_32)
		do
			c_set_id_lm (c_pointer, a_id_lm)
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_used_for (a_used_for: INTEGER_8)
		do
			c_set_used_for (c_pointer, a_used_for)
		end

feature {NONE} -- C getters

	c_shape (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cursor_entry *)$tmp)->shape;"
		end

	c_mshape (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cursor_entry *)$tmp)->mshape;"
		end

	c_percentage (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cursor_entry *)$tmp)->percentage;"
		end

	c_blinkwait (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct cursor_entry *)$tmp)->blinkwait;"
		end

	c_blinkon (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct cursor_entry *)$tmp)->blinkon;"
		end

	c_blinkoff (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct cursor_entry *)$tmp)->blinkoff;"
		end

	c_id (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cursor_entry *)$tmp)->id;"
		end

	c_id_lm (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct cursor_entry *)$tmp)->id_lm;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct cursor_entry *)$tmp)->name;"
		end

	c_used_for (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct cursor_entry *)$tmp)->used_for;"
		end

feature {NONE} -- C setters

	c_set_shape (tmp: POINTER; a_shape: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cursor_entry *)$tmp)->shape = $a_shape;"
		end

	c_set_mshape (tmp: POINTER; a_mshape: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cursor_entry *)$tmp)->mshape = $a_mshape;"
		end

	c_set_percentage (tmp: POINTER; a_percentage: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cursor_entry *)$tmp)->percentage = $a_percentage;"
		end

	c_set_blinkwait (tmp: POINTER; a_blinkwait: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cursor_entry *)$tmp)->blinkwait = $a_blinkwait;"
		end

	c_set_blinkon (tmp: POINTER; a_blinkon: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cursor_entry *)$tmp)->blinkon = $a_blinkon;"
		end

	c_set_blinkoff (tmp: POINTER; a_blinkoff: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cursor_entry *)$tmp)->blinkoff = $a_blinkoff;"
		end

	c_set_id (tmp: POINTER; a_id: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cursor_entry *)$tmp)->id = $a_id;"
		end

	c_set_id_lm (tmp: POINTER; a_id_lm: INTEGER_32)
		external
			"C inline"
		alias
			"((struct cursor_entry *)$tmp)->id_lm = $a_id_lm;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct cursor_entry *)$tmp)->name = (char *)$a_name;"
		end

	c_set_used_for (tmp: POINTER; a_used_for: INTEGER_8)
		external
			"C inline"
		alias
			"((struct cursor_entry *)$tmp)->used_for = $a_used_for;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct cursor_entry);"
		end

end
