class
	PD_DECOMP_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	a: INTEGER_32 assign set_a
		do
			Result := c_a (c_pointer)
		end

	b: INTEGER_32 assign set_b
		do
			Result := c_b (c_pointer)
		end

	c: INTEGER_32 assign set_c
		do
			Result := c_c (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_a (a_a: INTEGER_32)
		do
			c_set_a (c_pointer, a_a)
		end

	set_b (a_b: INTEGER_32)
		do
			c_set_b (c_pointer, a_b)
		end

	set_c (a_c: INTEGER_32)
		do
			c_set_c (c_pointer, a_c)
		end

feature {NONE} -- C getters

	c_a (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_decomp_T_548 *)$tmp)->a;"
		end

	c_b (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_decomp_T_548 *)$tmp)->b;"
		end

	c_c (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_decomp_T_548 *)$tmp)->c;"
		end

feature {NONE} -- C setters

	c_set_a (tmp: POINTER; a_a: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_decomp_T_548 *)$tmp)->a = $a_a;"
		end

	c_set_b (tmp: POINTER; a_b: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_decomp_T_548 *)$tmp)->b = $a_b;"
		end

	c_set_c (tmp: POINTER; a_c: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_decomp_T_548 *)$tmp)->c = $a_c;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_decomp_T_548);"
		end

end
