class
	PD_DIALOGINFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ignore_enter: INTEGER_32 assign set_ignore_enter
		do
			Result := c_ignore_enter (c_pointer)
		end

	noalt: INTEGER_32 assign set_noalt
		do
			Result := c_noalt (c_pointer)
		end

	dialog: CE_POINTER [SD_GTKDIALOG] assign set_dialog
		do
			create Result.make_shared (c_dialog (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_ignore_enter (a_ignore_enter: INTEGER_32)
		do
			c_set_ignore_enter (c_pointer, a_ignore_enter)
		end

	set_noalt (a_noalt: INTEGER_32)
		do
			c_set_noalt (c_pointer, a_noalt)
		end

	set_dialog (a_dialog: CE_POINTER [SD_GTKDIALOG])
		do
			c_set_dialog (c_pointer, a_dialog.c_pointer)
		end

feature {NONE} -- C getters

	c_ignore_enter (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _DialogInfo *)$tmp)->ignore_enter;"
		end

	c_noalt (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _DialogInfo *)$tmp)->noalt;"
		end

	c_dialog (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkDialog *)((struct _DialogInfo *)$tmp)->dialog;"
		end

feature {NONE} -- C setters

	c_set_ignore_enter (tmp: POINTER; a_ignore_enter: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _DialogInfo *)$tmp)->ignore_enter = $a_ignore_enter;"
		end

	c_set_noalt (tmp: POINTER; a_noalt: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _DialogInfo *)$tmp)->noalt = $a_noalt;"
		end

	c_set_dialog (tmp: POINTER; a_dialog: POINTER)
		external
			"C inline"
		alias
			"((struct _DialogInfo *)$tmp)->dialog = (struct _GtkDialog *)$a_dialog;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _DialogInfo);"
		end

end
