class
	PD_DIR_STACK_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_DIR_STACK_T] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	dirname: CE_POINTER [NATURAL_8] assign set_dirname
		do
			create Result.make_shared (c_dirname (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_DIR_STACK_T])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_dirname (a_dirname: CE_POINTER [NATURAL_8])
		do
			c_set_dirname (c_pointer, a_dirname.c_pointer)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dir_stack_T *)((struct dir_stack_T *)$tmp)->next;"
		end

	c_dirname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct dir_stack_T *)$tmp)->dirname;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct dir_stack_T *)$tmp)->next = (struct dir_stack_T *)$a_next;"
		end

	c_set_dirname (tmp: POINTER; a_dirname: POINTER)
		external
			"C inline"
		alias
			"((struct dir_stack_T *)$tmp)->dirname = (unsigned char *)$a_dirname;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct dir_stack_T);"
		end

end
