class
	PD_ENC_ALIAS_TABLE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	canon: INTEGER_32 assign set_canon
		do
			Result := c_canon (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_canon (a_canon: INTEGER_32)
		do
			c_set_canon (c_pointer, a_canon)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_enc_alias_table_544 *)$tmp)->name;"
		end

	c_canon (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_enc_alias_table_544 *)$tmp)->canon;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_enc_alias_table_544 *)$tmp)->name = (char *)$a_name;"
		end

	c_set_canon (tmp: POINTER; a_canon: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_enc_alias_table_544 *)$tmp)->canon = $a_canon;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_enc_alias_table_544);"
		end

end
