class
	PD_ESLIST_ELEM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	saved_emsg_silent: INTEGER_32 assign set_saved_emsg_silent
		do
			Result := c_saved_emsg_silent (c_pointer)
		end

	next: CE_POINTER [PD_ESLIST_ELEM] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_saved_emsg_silent (a_saved_emsg_silent: INTEGER_32)
		do
			c_set_saved_emsg_silent (c_pointer, a_saved_emsg_silent)
		end

	set_next (a_next: CE_POINTER [PD_ESLIST_ELEM])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

feature {NONE} -- C getters

	c_saved_emsg_silent (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct eslist_elem *)$tmp)->saved_emsg_silent;"
		end

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct eslist_elem *)((struct eslist_elem *)$tmp)->next;"
		end

feature {NONE} -- C setters

	c_set_saved_emsg_silent (tmp: POINTER; a_saved_emsg_silent: INTEGER_32)
		external
			"C inline"
		alias
			"((struct eslist_elem *)$tmp)->saved_emsg_silent = $a_saved_emsg_silent;"
		end

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct eslist_elem *)$tmp)->next = (struct eslist_elem *)$a_next;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct eslist_elem);"
		end

end
