class
	PD_EVENT_NAME

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	event: INTEGER_32 assign set_event
		do
			Result := c_event (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_event (a_event: INTEGER_32)
		do
			c_set_event (c_pointer, a_event)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct event_name *)$tmp)->name;"
		end

	c_event (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct event_name *)$tmp)->event;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct event_name *)$tmp)->name = (char *)$a_name;"
		end

	c_set_event (tmp: POINTER; a_event: INTEGER_32)
		external
			"C inline"
		alias
			"((struct event_name *)$tmp)->event = $a_event;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct event_name);"
		end

end
