class
	PD_EXARG

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	arg: CE_POINTER [NATURAL_8] assign set_arg
		do
			create Result.make_shared (c_arg (c_pointer))
		end

	arg_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct exarg, arg);"
		end

	nextcmd: CE_POINTER [NATURAL_8] assign set_nextcmd
		do
			create Result.make_shared (c_nextcmd (c_pointer))
		end

	nextcmd_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct exarg, nextcmd);"
		end

	cmd: CE_POINTER [NATURAL_8] assign set_cmd
		do
			create Result.make_shared (c_cmd (c_pointer))
		end

	cmd_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct exarg, cmd);"
		end

	cmdlinep: CE_POINTER [CE_POINTER [NATURAL_8]] assign set_cmdlinep
		do
			create Result.make_shared (c_cmdlinep (c_pointer))
		end

	cmdidx: INTEGER_32 assign set_cmdidx
		do
			Result := c_cmdidx (c_pointer)
		end

	argt: INTEGER_32 assign set_argt
		do
			Result := c_argt (c_pointer)
		end

	skip: INTEGER_32 assign set_skip
		do
			Result := c_skip (c_pointer)
		end

	forceit: INTEGER_32 assign set_forceit
		do
			Result := c_forceit (c_pointer)
		end

	forceit_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct exarg, forceit);"
		end

	addr_count: INTEGER_32 assign set_addr_count
		do
			Result := c_addr_count (c_pointer)
		end

	line1: INTEGER_32 assign set_line1
		do
			Result := c_line1 (c_pointer)
		end

	line1_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct exarg, line1);"
		end

	line2: INTEGER_32 assign set_line2
		do
			Result := c_line2 (c_pointer)
		end

	line2_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct exarg, line2);"
		end

	flags: INTEGER_32 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

	do_ecmd_cmd: CE_POINTER [NATURAL_8] assign set_do_ecmd_cmd
		do
			create Result.make_shared (c_do_ecmd_cmd (c_pointer))
		end

	do_ecmd_lnum: INTEGER_32 assign set_do_ecmd_lnum
		do
			Result := c_do_ecmd_lnum (c_pointer)
		end

	do_ecmd_lnum_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct exarg, do_ecmd_lnum);"
		end

	append: INTEGER_32 assign set_append
		do
			Result := c_append (c_pointer)
		end

	usefilter: INTEGER_32 assign set_usefilter
		do
			Result := c_usefilter (c_pointer)
		end

	amount: INTEGER_32 assign set_amount
		do
			Result := c_amount (c_pointer)
		end

	regname: INTEGER_32 assign set_regname
		do
			Result := c_regname (c_pointer)
		end

	force_bin: INTEGER_32 assign set_force_bin
		do
			Result := c_force_bin (c_pointer)
		end

	read_edit: INTEGER_32 assign set_read_edit
		do
			Result := c_read_edit (c_pointer)
		end

	force_ff: INTEGER_32 assign set_force_ff
		do
			Result := c_force_ff (c_pointer)
		end

	force_ff_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct exarg, force_ff);"
		end

	force_enc: INTEGER_32 assign set_force_enc
		do
			Result := c_force_enc (c_pointer)
		end

	force_enc_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct exarg, force_enc);"
		end

	bad_char: INTEGER_32 assign set_bad_char
		do
			Result := c_bad_char (c_pointer)
		end

	useridx: INTEGER_32 assign set_useridx
		do
			Result := c_useridx (c_pointer)
		end

	errmsg: CE_POINTER [NATURAL_8] assign set_errmsg
		do
			create Result.make_shared (c_errmsg (c_pointer))
		end

	getline: CE_ROUTINE assign set_getline
		do
			create Result.make_shared (c_getline (c_pointer))
		end

	cookie: CE_POINTER [ANY] assign set_cookie
		do
			create Result.make_shared (c_cookie (c_pointer))
		end

	cstack: CE_POINTER [PD_CONDSTACK] assign set_cstack
		do
			create Result.make_shared (c_cstack (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_arg (a_arg: CE_POINTER [NATURAL_8])
		do
			c_set_arg (c_pointer, a_arg.c_pointer)
		end

	set_nextcmd (a_nextcmd: CE_POINTER [NATURAL_8])
		do
			c_set_nextcmd (c_pointer, a_nextcmd.c_pointer)
		end

	set_cmd (a_cmd: CE_POINTER [NATURAL_8])
		do
			c_set_cmd (c_pointer, a_cmd.c_pointer)
		end

	set_cmdlinep (a_cmdlinep: CE_POINTER [CE_POINTER [NATURAL_8]])
		do
			c_set_cmdlinep (c_pointer, a_cmdlinep.c_pointer)
		end

	set_cmdidx (a_cmdidx: INTEGER_32)
		do
			c_set_cmdidx (c_pointer, a_cmdidx)
		end

	set_argt (a_argt: INTEGER_32)
		do
			c_set_argt (c_pointer, a_argt)
		end

	set_skip (a_skip: INTEGER_32)
		do
			c_set_skip (c_pointer, a_skip)
		end

	set_forceit (a_forceit: INTEGER_32)
		do
			c_set_forceit (c_pointer, a_forceit)
		end

	set_addr_count (a_addr_count: INTEGER_32)
		do
			c_set_addr_count (c_pointer, a_addr_count)
		end

	set_line1 (a_line1: INTEGER_32)
		do
			c_set_line1 (c_pointer, a_line1)
		end

	set_line2 (a_line2: INTEGER_32)
		do
			c_set_line2 (c_pointer, a_line2)
		end

	set_flags (a_flags: INTEGER_32)
		do
			c_set_flags (c_pointer, a_flags)
		end

	set_do_ecmd_cmd (a_do_ecmd_cmd: CE_POINTER [NATURAL_8])
		do
			c_set_do_ecmd_cmd (c_pointer, a_do_ecmd_cmd.c_pointer)
		end

	set_do_ecmd_lnum (a_do_ecmd_lnum: INTEGER_32)
		do
			c_set_do_ecmd_lnum (c_pointer, a_do_ecmd_lnum)
		end

	set_append (a_append: INTEGER_32)
		do
			c_set_append (c_pointer, a_append)
		end

	set_usefilter (a_usefilter: INTEGER_32)
		do
			c_set_usefilter (c_pointer, a_usefilter)
		end

	set_amount (a_amount: INTEGER_32)
		do
			c_set_amount (c_pointer, a_amount)
		end

	set_regname (a_regname: INTEGER_32)
		do
			c_set_regname (c_pointer, a_regname)
		end

	set_force_bin (a_force_bin: INTEGER_32)
		do
			c_set_force_bin (c_pointer, a_force_bin)
		end

	set_read_edit (a_read_edit: INTEGER_32)
		do
			c_set_read_edit (c_pointer, a_read_edit)
		end

	set_force_ff (a_force_ff: INTEGER_32)
		do
			c_set_force_ff (c_pointer, a_force_ff)
		end

	set_force_enc (a_force_enc: INTEGER_32)
		do
			c_set_force_enc (c_pointer, a_force_enc)
		end

	set_bad_char (a_bad_char: INTEGER_32)
		do
			c_set_bad_char (c_pointer, a_bad_char)
		end

	set_useridx (a_useridx: INTEGER_32)
		do
			c_set_useridx (c_pointer, a_useridx)
		end

	set_errmsg (a_errmsg: CE_POINTER [NATURAL_8])
		do
			c_set_errmsg (c_pointer, a_errmsg.c_pointer)
		end

	set_getline (a_getline: CE_ROUTINE)
		do
			c_set_getline (c_pointer, a_getline.c_pointer)
		end

	set_cookie (a_cookie: CE_POINTER [ANY])
		do
			c_set_cookie (c_pointer, a_cookie.c_pointer)
		end

	set_cstack (a_cstack: CE_POINTER [PD_CONDSTACK])
		do
			c_set_cstack (c_pointer, a_cstack.c_pointer)
		end

feature {NONE} -- C getters

	c_arg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct exarg *)$tmp)->arg;"
		end

	c_nextcmd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct exarg *)$tmp)->nextcmd;"
		end

	c_cmd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct exarg *)$tmp)->cmd;"
		end

	c_cmdlinep (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char * *)((struct exarg *)$tmp)->cmdlinep;"
		end

	c_cmdidx (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct exarg *)$tmp)->cmdidx;"
		end

	c_argt (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct exarg *)$tmp)->argt;"
		end

	c_skip (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct exarg *)$tmp)->skip;"
		end

	c_forceit (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct exarg *)$tmp)->forceit;"
		end

	c_addr_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct exarg *)$tmp)->addr_count;"
		end

	c_line1 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct exarg *)$tmp)->line1;"
		end

	c_line2 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct exarg *)$tmp)->line2;"
		end

	c_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct exarg *)$tmp)->flags;"
		end

	c_do_ecmd_cmd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct exarg *)$tmp)->do_ecmd_cmd;"
		end

	c_do_ecmd_lnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct exarg *)$tmp)->do_ecmd_lnum;"
		end

	c_append (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct exarg *)$tmp)->append;"
		end

	c_usefilter (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct exarg *)$tmp)->usefilter;"
		end

	c_amount (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct exarg *)$tmp)->amount;"
		end

	c_regname (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct exarg *)$tmp)->regname;"
		end

	c_force_bin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct exarg *)$tmp)->force_bin;"
		end

	c_read_edit (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct exarg *)$tmp)->read_edit;"
		end

	c_force_ff (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct exarg *)$tmp)->force_ff;"
		end

	c_force_enc (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct exarg *)$tmp)->force_enc;"
		end

	c_bad_char (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct exarg *)$tmp)->bad_char;"
		end

	c_useridx (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct exarg *)$tmp)->useridx;"
		end

	c_errmsg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct exarg *)$tmp)->errmsg;"
		end

	c_getline (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *( *)(int, void *, int))((struct exarg *)$tmp)->getline;"
		end

	c_cookie (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct exarg *)$tmp)->cookie;"
		end

	c_cstack (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct condstack *)((struct exarg *)$tmp)->cstack;"
		end

feature {NONE} -- C setters

	c_set_arg (tmp: POINTER; a_arg: POINTER)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->arg = (unsigned char *)$a_arg;"
		end

	c_set_nextcmd (tmp: POINTER; a_nextcmd: POINTER)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->nextcmd = (unsigned char *)$a_nextcmd;"
		end

	c_set_cmd (tmp: POINTER; a_cmd: POINTER)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->cmd = (unsigned char *)$a_cmd;"
		end

	c_set_cmdlinep (tmp: POINTER; a_cmdlinep: POINTER)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->cmdlinep = (unsigned char * *)$a_cmdlinep;"
		end

	c_set_cmdidx (tmp: POINTER; a_cmdidx: INTEGER_32)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->cmdidx = $a_cmdidx;"
		end

	c_set_argt (tmp: POINTER; a_argt: INTEGER_32)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->argt = $a_argt;"
		end

	c_set_skip (tmp: POINTER; a_skip: INTEGER_32)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->skip = $a_skip;"
		end

	c_set_forceit (tmp: POINTER; a_forceit: INTEGER_32)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->forceit = $a_forceit;"
		end

	c_set_addr_count (tmp: POINTER; a_addr_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->addr_count = $a_addr_count;"
		end

	c_set_line1 (tmp: POINTER; a_line1: INTEGER_32)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->line1 = $a_line1;"
		end

	c_set_line2 (tmp: POINTER; a_line2: INTEGER_32)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->line2 = $a_line2;"
		end

	c_set_flags (tmp: POINTER; a_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->flags = $a_flags;"
		end

	c_set_do_ecmd_cmd (tmp: POINTER; a_do_ecmd_cmd: POINTER)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->do_ecmd_cmd = (unsigned char *)$a_do_ecmd_cmd;"
		end

	c_set_do_ecmd_lnum (tmp: POINTER; a_do_ecmd_lnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->do_ecmd_lnum = $a_do_ecmd_lnum;"
		end

	c_set_append (tmp: POINTER; a_append: INTEGER_32)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->append = $a_append;"
		end

	c_set_usefilter (tmp: POINTER; a_usefilter: INTEGER_32)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->usefilter = $a_usefilter;"
		end

	c_set_amount (tmp: POINTER; a_amount: INTEGER_32)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->amount = $a_amount;"
		end

	c_set_regname (tmp: POINTER; a_regname: INTEGER_32)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->regname = $a_regname;"
		end

	c_set_force_bin (tmp: POINTER; a_force_bin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->force_bin = $a_force_bin;"
		end

	c_set_read_edit (tmp: POINTER; a_read_edit: INTEGER_32)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->read_edit = $a_read_edit;"
		end

	c_set_force_ff (tmp: POINTER; a_force_ff: INTEGER_32)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->force_ff = $a_force_ff;"
		end

	c_set_force_enc (tmp: POINTER; a_force_enc: INTEGER_32)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->force_enc = $a_force_enc;"
		end

	c_set_bad_char (tmp: POINTER; a_bad_char: INTEGER_32)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->bad_char = $a_bad_char;"
		end

	c_set_useridx (tmp: POINTER; a_useridx: INTEGER_32)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->useridx = $a_useridx;"
		end

	c_set_errmsg (tmp: POINTER; a_errmsg: POINTER)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->errmsg = (unsigned char *)$a_errmsg;"
		end

	c_set_getline (tmp: POINTER; a_getline: POINTER)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->getline = (unsigned char *( *)(int, void *, int))$a_getline;"
		end

	c_set_cookie (tmp: POINTER; a_cookie: POINTER)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->cookie = (void *)$a_cookie;"
		end

	c_set_cstack (tmp: POINTER; a_cstack: POINTER)
		external
			"C inline"
		alias
			"((struct exarg *)$tmp)->cstack = (struct condstack *)$a_cstack;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct exarg);"
		end

end
