class
	PD_FF_VISITED_LIST_HDR

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ffvl_next: CE_POINTER [PD_FF_VISITED_LIST_HDR] assign set_ffvl_next
		do
			create Result.make_shared (c_ffvl_next (c_pointer))
		end

	ffvl_filename: CE_POINTER [NATURAL_8] assign set_ffvl_filename
		do
			create Result.make_shared (c_ffvl_filename (c_pointer))
		end

	ffvl_visited_list: CE_POINTER [PD_FF_VISITED] assign set_ffvl_visited_list
		do
			create Result.make_shared (c_ffvl_visited_list (c_pointer))
		end

	ffvl_visited_list_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct ff_visited_list_hdr, ffvl_visited_list);"
		end

feature {ANY} -- Eiffel setters

	set_ffvl_next (a_ffvl_next: CE_POINTER [PD_FF_VISITED_LIST_HDR])
		do
			c_set_ffvl_next (c_pointer, a_ffvl_next.c_pointer)
		end

	set_ffvl_filename (a_ffvl_filename: CE_POINTER [NATURAL_8])
		do
			c_set_ffvl_filename (c_pointer, a_ffvl_filename.c_pointer)
		end

	set_ffvl_visited_list (a_ffvl_visited_list: CE_POINTER [PD_FF_VISITED])
		do
			c_set_ffvl_visited_list (c_pointer, a_ffvl_visited_list.c_pointer)
		end

feature {NONE} -- C getters

	c_ffvl_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct ff_visited_list_hdr *)((struct ff_visited_list_hdr *)$tmp)->ffvl_next;"
		end

	c_ffvl_filename (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct ff_visited_list_hdr *)$tmp)->ffvl_filename;"
		end

	c_ffvl_visited_list (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct ff_visited *)((struct ff_visited_list_hdr *)$tmp)->ffvl_visited_list;"
		end

feature {NONE} -- C setters

	c_set_ffvl_next (tmp: POINTER; a_ffvl_next: POINTER)
		external
			"C inline"
		alias
			"((struct ff_visited_list_hdr *)$tmp)->ffvl_next = (struct ff_visited_list_hdr *)$a_ffvl_next;"
		end

	c_set_ffvl_filename (tmp: POINTER; a_ffvl_filename: POINTER)
		external
			"C inline"
		alias
			"((struct ff_visited_list_hdr *)$tmp)->ffvl_filename = (unsigned char *)$a_ffvl_filename;"
		end

	c_set_ffvl_visited_list (tmp: POINTER; a_ffvl_visited_list: POINTER)
		external
			"C inline"
		alias
			"((struct ff_visited_list_hdr *)$tmp)->ffvl_visited_list = (struct ff_visited *)$a_ffvl_visited_list;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct ff_visited_list_hdr);"
		end

end
