class
	PD_FILEMARK

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	mark: PD_POS_T assign set_mark
		do
			create Result.make_shared (c_mark (c_pointer))
		end

	mark_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct filemark, mark);"
		end

	fnum: INTEGER_32 assign set_fnum
		do
			Result := c_fnum (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_mark (a_mark: PD_POS_T)
		do
			mark.ce_gets (a_mark)
		end

	set_fnum (a_fnum: INTEGER_32)
		do
			c_set_fnum (c_pointer, a_fnum)
		end

feature {NONE} -- C getters

	c_mark (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (pos_T *)&((struct filemark *)$tmp)->mark;"
		end

	c_fnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct filemark *)$tmp)->fnum;"
		end

feature {NONE} -- C setters

	c_set_fnum (tmp: POINTER; a_fnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct filemark *)$tmp)->fnum = $a_fnum;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct filemark);"
		end

end
