class
	PD_FIXVAR

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	var: PD_DICTITEM_S assign set_var
		do
			create Result.make_shared (c_var (c_pointer))
		end

	var_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_fixvar_546, var);"
		end

	room: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_room (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_var (a_var: PD_DICTITEM_S)
		do
			var.ce_gets (a_var)
		end

feature {NONE} -- C getters

	c_var (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dictitem_S *)&((struct __anonstruct_fixvar_546 *)$tmp)->var;"
		end

	c_room (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_fixvar_546 *tmp = (struct __anonstruct_fixvar_546 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->room) / sizeof(tmp->room[0]);
				return tmp->room;
			]"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_fixvar_546);"
		end

end
