class
	PD_FLINE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	wp: CE_POINTER [PD_WINDOW_S] assign set_wp
		do
			create Result.make_shared (c_wp (c_pointer))
		end

	lnum: INTEGER_32 assign set_lnum
		do
			Result := c_lnum (c_pointer)
		end

	off: INTEGER_32 assign set_off
		do
			Result := c_off (c_pointer)
		end

	lnum_save: INTEGER_32 assign set_lnum_save
		do
			Result := c_lnum_save (c_pointer)
		end

	lvl: INTEGER_32 assign set_lvl
		do
			Result := c_lvl (c_pointer)
		end

	lvl_next: INTEGER_32 assign set_lvl_next
		do
			Result := c_lvl_next (c_pointer)
		end

	start: INTEGER_32 assign set_start
		do
			Result := c_start (c_pointer)
		end

	end2: INTEGER_32 assign set_end2
		do
			Result := c_end2 (c_pointer)
		end

	had_end: INTEGER_32 assign set_had_end
		do
			Result := c_had_end (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_wp (a_wp: CE_POINTER [PD_WINDOW_S])
		do
			c_set_wp (c_pointer, a_wp.c_pointer)
		end

	set_lnum (a_lnum: INTEGER_32)
		do
			c_set_lnum (c_pointer, a_lnum)
		end

	set_off (a_off: INTEGER_32)
		do
			c_set_off (c_pointer, a_off)
		end

	set_lnum_save (a_lnum_save: INTEGER_32)
		do
			c_set_lnum_save (c_pointer, a_lnum_save)
		end

	set_lvl (a_lvl: INTEGER_32)
		do
			c_set_lvl (c_pointer, a_lvl)
		end

	set_lvl_next (a_lvl_next: INTEGER_32)
		do
			c_set_lvl_next (c_pointer, a_lvl_next)
		end

	set_start (a_start: INTEGER_32)
		do
			c_set_start (c_pointer, a_start)
		end

	set_end2 (a_end2: INTEGER_32)
		do
			c_set_end2 (c_pointer, a_end2)
		end

	set_had_end (a_had_end: INTEGER_32)
		do
			c_set_had_end (c_pointer, a_had_end)
		end

feature {NONE} -- C getters

	c_wp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct window_S *)((struct __anonstruct_fline_T_544 *)$tmp)->wp;"
		end

	c_lnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_fline_T_544 *)$tmp)->lnum;"
		end

	c_off (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_fline_T_544 *)$tmp)->off;"
		end

	c_lnum_save (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_fline_T_544 *)$tmp)->lnum_save;"
		end

	c_lvl (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_fline_T_544 *)$tmp)->lvl;"
		end

	c_lvl_next (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_fline_T_544 *)$tmp)->lvl_next;"
		end

	c_start (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_fline_T_544 *)$tmp)->start;"
		end

	c_end2 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_fline_T_544 *)$tmp)->end;"
		end

	c_had_end (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_fline_T_544 *)$tmp)->had_end;"
		end

feature {NONE} -- C setters

	c_set_wp (tmp: POINTER; a_wp: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_fline_T_544 *)$tmp)->wp = (struct window_S *)$a_wp;"
		end

	c_set_lnum (tmp: POINTER; a_lnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_fline_T_544 *)$tmp)->lnum = $a_lnum;"
		end

	c_set_off (tmp: POINTER; a_off: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_fline_T_544 *)$tmp)->off = $a_off;"
		end

	c_set_lnum_save (tmp: POINTER; a_lnum_save: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_fline_T_544 *)$tmp)->lnum_save = $a_lnum_save;"
		end

	c_set_lvl (tmp: POINTER; a_lvl: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_fline_T_544 *)$tmp)->lvl = $a_lvl;"
		end

	c_set_lvl_next (tmp: POINTER; a_lvl_next: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_fline_T_544 *)$tmp)->lvl_next = $a_lvl_next;"
		end

	c_set_start (tmp: POINTER; a_start: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_fline_T_544 *)$tmp)->start = $a_start;"
		end

	c_set_end2 (tmp: POINTER; a_end2: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_fline_T_544 *)$tmp)->end = $a_end2;"
		end

	c_set_had_end (tmp: POINTER; a_had_end: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_fline_T_544 *)$tmp)->had_end = $a_had_end;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_fline_T_544);"
		end

end
