class
	PD_FMTPATTERN

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	convchar: NATURAL_8 assign set_convchar
		do
			Result := c_convchar (c_pointer)
		end

	pattern: CE_POINTER [INTEGER_8] assign set_pattern
		do
			create Result.make_shared (c_pattern (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_convchar (a_convchar: NATURAL_8)
		do
			c_set_convchar (c_pointer, a_convchar)
		end

	set_pattern (a_pattern: CE_POINTER [INTEGER_8])
		do
			c_set_pattern (c_pointer, a_pattern.c_pointer)
		end

feature {NONE} -- C getters

	c_convchar (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct fmtpattern *)$tmp)->convchar;"
		end

	c_pattern (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct fmtpattern *)$tmp)->pattern;"
		end

feature {NONE} -- C setters

	c_set_convchar (tmp: POINTER; a_convchar: NATURAL_8)
		external
			"C inline"
		alias
			"((struct fmtpattern *)$tmp)->convchar = $a_convchar;"
		end

	c_set_pattern (tmp: POINTER; a_pattern: POINTER)
		external
			"C inline"
		alias
			"((struct fmtpattern *)$tmp)->pattern = (char *)$a_pattern;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct fmtpattern);"
		end

end
