class
	PD_FOLDINFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	fi_level: INTEGER_32 assign set_fi_level
		do
			Result := c_fi_level (c_pointer)
		end

	fi_lnum: INTEGER_32 assign set_fi_lnum
		do
			Result := c_fi_lnum (c_pointer)
		end

	fi_low_level: INTEGER_32 assign set_fi_low_level
		do
			Result := c_fi_low_level (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_fi_level (a_fi_level: INTEGER_32)
		do
			c_set_fi_level (c_pointer, a_fi_level)
		end

	set_fi_lnum (a_fi_lnum: INTEGER_32)
		do
			c_set_fi_lnum (c_pointer, a_fi_lnum)
		end

	set_fi_low_level (a_fi_low_level: INTEGER_32)
		do
			c_set_fi_low_level (c_pointer, a_fi_low_level)
		end

feature {NONE} -- C getters

	c_fi_level (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct foldinfo *)$tmp)->fi_level;"
		end

	c_fi_lnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct foldinfo *)$tmp)->fi_lnum;"
		end

	c_fi_low_level (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct foldinfo *)$tmp)->fi_low_level;"
		end

feature {NONE} -- C setters

	c_set_fi_level (tmp: POINTER; a_fi_level: INTEGER_32)
		external
			"C inline"
		alias
			"((struct foldinfo *)$tmp)->fi_level = $a_fi_level;"
		end

	c_set_fi_lnum (tmp: POINTER; a_fi_lnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct foldinfo *)$tmp)->fi_lnum = $a_fi_lnum;"
		end

	c_set_fi_low_level (tmp: POINTER; a_fi_low_level: INTEGER_32)
		external
			"C inline"
		alias
			"((struct foldinfo *)$tmp)->fi_low_level = $a_fi_low_level;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct foldinfo);"
		end

end
