class
	PD_FROMTO_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ft_from: CE_POINTER [NATURAL_8] assign set_ft_from
		do
			create Result.make_shared (c_ft_from (c_pointer))
		end

	ft_to: CE_POINTER [NATURAL_8] assign set_ft_to
		do
			create Result.make_shared (c_ft_to (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_ft_from (a_ft_from: CE_POINTER [NATURAL_8])
		do
			c_set_ft_from (c_pointer, a_ft_from.c_pointer)
		end

	set_ft_to (a_ft_to: CE_POINTER [NATURAL_8])
		do
			c_set_ft_to (c_pointer, a_ft_to.c_pointer)
		end

feature {NONE} -- C getters

	c_ft_from (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct fromto_S *)$tmp)->ft_from;"
		end

	c_ft_to (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct fromto_S *)$tmp)->ft_to;"
		end

feature {NONE} -- C setters

	c_set_ft_from (tmp: POINTER; a_ft_from: POINTER)
		external
			"C inline"
		alias
			"((struct fromto_S *)$tmp)->ft_from = (unsigned char *)$a_ft_from;"
		end

	c_set_ft_to (tmp: POINTER; a_ft_to: POINTER)
		external
			"C inline"
		alias
			"((struct fromto_S *)$tmp)->ft_to = (unsigned char *)$a_ft_to;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct fromto_S);"
		end

end
