class
	PD_LISTVAR_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	lv_first: CE_POINTER [PD_LISTITEM_S] assign set_lv_first
		do
			create Result.make_shared (c_lv_first (c_pointer))
		end

	lv_last: CE_POINTER [PD_LISTITEM_S] assign set_lv_last
		do
			create Result.make_shared (c_lv_last (c_pointer))
		end

	lv_refcount: INTEGER_32 assign set_lv_refcount
		do
			Result := c_lv_refcount (c_pointer)
		end

	lv_len: INTEGER_32 assign set_lv_len
		do
			Result := c_lv_len (c_pointer)
		end

	lv_watch: CE_POINTER [PD_LISTWATCH_S] assign set_lv_watch
		do
			create Result.make_shared (c_lv_watch (c_pointer))
		end

	lv_watch_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct listvar_S, lv_watch);"
		end

	lv_idx: INTEGER_32 assign set_lv_idx
		do
			Result := c_lv_idx (c_pointer)
		end

	lv_idx_item: CE_POINTER [PD_LISTITEM_S] assign set_lv_idx_item
		do
			create Result.make_shared (c_lv_idx_item (c_pointer))
		end

	lv_copyID: INTEGER_32 assign set_lv_copyID
		do
			Result := c_lv_copyID (c_pointer)
		end

	lv_copylist: CE_POINTER [PD_LISTVAR_S] assign set_lv_copylist
		do
			create Result.make_shared (c_lv_copylist (c_pointer))
		end

	lv_lock: INTEGER_8 assign set_lv_lock
		do
			Result := c_lv_lock (c_pointer)
		end

	lv_used_next: CE_POINTER [PD_LISTVAR_S] assign set_lv_used_next
		do
			create Result.make_shared (c_lv_used_next (c_pointer))
		end

	lv_used_prev: CE_POINTER [PD_LISTVAR_S] assign set_lv_used_prev
		do
			create Result.make_shared (c_lv_used_prev (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_lv_first (a_lv_first: CE_POINTER [PD_LISTITEM_S])
		do
			c_set_lv_first (c_pointer, a_lv_first.c_pointer)
		end

	set_lv_last (a_lv_last: CE_POINTER [PD_LISTITEM_S])
		do
			c_set_lv_last (c_pointer, a_lv_last.c_pointer)
		end

	set_lv_refcount (a_lv_refcount: INTEGER_32)
		do
			c_set_lv_refcount (c_pointer, a_lv_refcount)
		end

	set_lv_len (a_lv_len: INTEGER_32)
		do
			c_set_lv_len (c_pointer, a_lv_len)
		end

	set_lv_watch (a_lv_watch: CE_POINTER [PD_LISTWATCH_S])
		do
			c_set_lv_watch (c_pointer, a_lv_watch.c_pointer)
		end

	set_lv_idx (a_lv_idx: INTEGER_32)
		do
			c_set_lv_idx (c_pointer, a_lv_idx)
		end

	set_lv_idx_item (a_lv_idx_item: CE_POINTER [PD_LISTITEM_S])
		do
			c_set_lv_idx_item (c_pointer, a_lv_idx_item.c_pointer)
		end

	set_lv_copyID (a_lv_copyID: INTEGER_32)
		do
			c_set_lv_copyID (c_pointer, a_lv_copyID)
		end

	set_lv_copylist (a_lv_copylist: CE_POINTER [PD_LISTVAR_S])
		do
			c_set_lv_copylist (c_pointer, a_lv_copylist.c_pointer)
		end

	set_lv_lock (a_lv_lock: INTEGER_8)
		do
			c_set_lv_lock (c_pointer, a_lv_lock)
		end

	set_lv_used_next (a_lv_used_next: CE_POINTER [PD_LISTVAR_S])
		do
			c_set_lv_used_next (c_pointer, a_lv_used_next.c_pointer)
		end

	set_lv_used_prev (a_lv_used_prev: CE_POINTER [PD_LISTVAR_S])
		do
			c_set_lv_used_prev (c_pointer, a_lv_used_prev.c_pointer)
		end

feature {NONE} -- C getters

	c_lv_first (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct listitem_S *)((struct listvar_S *)$tmp)->lv_first;"
		end

	c_lv_last (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct listitem_S *)((struct listvar_S *)$tmp)->lv_last;"
		end

	c_lv_refcount (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct listvar_S *)$tmp)->lv_refcount;"
		end

	c_lv_len (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct listvar_S *)$tmp)->lv_len;"
		end

	c_lv_watch (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct listwatch_S *)((struct listvar_S *)$tmp)->lv_watch;"
		end

	c_lv_idx (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct listvar_S *)$tmp)->lv_idx;"
		end

	c_lv_idx_item (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct listitem_S *)((struct listvar_S *)$tmp)->lv_idx_item;"
		end

	c_lv_copyID (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct listvar_S *)$tmp)->lv_copyID;"
		end

	c_lv_copylist (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct listvar_S *)((struct listvar_S *)$tmp)->lv_copylist;"
		end

	c_lv_lock (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct listvar_S *)$tmp)->lv_lock;"
		end

	c_lv_used_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct listvar_S *)((struct listvar_S *)$tmp)->lv_used_next;"
		end

	c_lv_used_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct listvar_S *)((struct listvar_S *)$tmp)->lv_used_prev;"
		end

feature {NONE} -- C setters

	c_set_lv_first (tmp: POINTER; a_lv_first: POINTER)
		external
			"C inline"
		alias
			"((struct listvar_S *)$tmp)->lv_first = (struct listitem_S *)$a_lv_first;"
		end

	c_set_lv_last (tmp: POINTER; a_lv_last: POINTER)
		external
			"C inline"
		alias
			"((struct listvar_S *)$tmp)->lv_last = (struct listitem_S *)$a_lv_last;"
		end

	c_set_lv_refcount (tmp: POINTER; a_lv_refcount: INTEGER_32)
		external
			"C inline"
		alias
			"((struct listvar_S *)$tmp)->lv_refcount = $a_lv_refcount;"
		end

	c_set_lv_len (tmp: POINTER; a_lv_len: INTEGER_32)
		external
			"C inline"
		alias
			"((struct listvar_S *)$tmp)->lv_len = $a_lv_len;"
		end

	c_set_lv_watch (tmp: POINTER; a_lv_watch: POINTER)
		external
			"C inline"
		alias
			"((struct listvar_S *)$tmp)->lv_watch = (struct listwatch_S *)$a_lv_watch;"
		end

	c_set_lv_idx (tmp: POINTER; a_lv_idx: INTEGER_32)
		external
			"C inline"
		alias
			"((struct listvar_S *)$tmp)->lv_idx = $a_lv_idx;"
		end

	c_set_lv_idx_item (tmp: POINTER; a_lv_idx_item: POINTER)
		external
			"C inline"
		alias
			"((struct listvar_S *)$tmp)->lv_idx_item = (struct listitem_S *)$a_lv_idx_item;"
		end

	c_set_lv_copyID (tmp: POINTER; a_lv_copyID: INTEGER_32)
		external
			"C inline"
		alias
			"((struct listvar_S *)$tmp)->lv_copyID = $a_lv_copyid;"
		end

	c_set_lv_copylist (tmp: POINTER; a_lv_copylist: POINTER)
		external
			"C inline"
		alias
			"((struct listvar_S *)$tmp)->lv_copylist = (struct listvar_S *)$a_lv_copylist;"
		end

	c_set_lv_lock (tmp: POINTER; a_lv_lock: INTEGER_8)
		external
			"C inline"
		alias
			"((struct listvar_S *)$tmp)->lv_lock = $a_lv_lock;"
		end

	c_set_lv_used_next (tmp: POINTER; a_lv_used_next: POINTER)
		external
			"C inline"
		alias
			"((struct listvar_S *)$tmp)->lv_used_next = (struct listvar_S *)$a_lv_used_next;"
		end

	c_set_lv_used_prev (tmp: POINTER; a_lv_used_prev: POINTER)
		external
			"C inline"
		alias
			"((struct listvar_S *)$tmp)->lv_used_prev = (struct listvar_S *)$a_lv_used_prev;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct listvar_S);"
		end

end
