class
	PD_NBBUF_STRUCT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	bufp: CE_POINTER [PD_FILE_BUFFER] assign set_bufp
		do
			create Result.make_shared (c_bufp (c_pointer))
		end

	fireChanges: NATURAL_32 assign set_fireChanges
		do
			Result := c_fireChanges (c_pointer)
		end

	initDone: NATURAL_32 assign set_initDone
		do
			Result := c_initDone (c_pointer)
		end

	insertDone: NATURAL_32 assign set_insertDone
		do
			Result := c_insertDone (c_pointer)
		end

	modified: NATURAL_32 assign set_modified
		do
			Result := c_modified (c_pointer)
		end

	nbbuf_number: INTEGER_32 assign set_nbbuf_number
		do
			Result := c_nbbuf_number (c_pointer)
		end

	displayname: CE_POINTER [INTEGER_8] assign set_displayname
		do
			create Result.make_shared (c_displayname (c_pointer))
		end

	signmap: CE_POINTER [INTEGER_32] assign set_signmap
		do
			create Result.make_shared (c_signmap (c_pointer))
		end

	signmaplen: NATURAL_16 assign set_signmaplen
		do
			Result := c_signmaplen (c_pointer)
		end

	signmapused: NATURAL_16 assign set_signmapused
		do
			Result := c_signmapused (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_bufp (a_bufp: CE_POINTER [PD_FILE_BUFFER])
		do
			c_set_bufp (c_pointer, a_bufp.c_pointer)
		end

	set_fireChanges (a_fireChanges: NATURAL_32)
		do
			c_set_fireChanges (c_pointer, a_fireChanges)
		end

	set_initDone (a_initDone: NATURAL_32)
		do
			c_set_initDone (c_pointer, a_initDone)
		end

	set_insertDone (a_insertDone: NATURAL_32)
		do
			c_set_insertDone (c_pointer, a_insertDone)
		end

	set_modified (a_modified: NATURAL_32)
		do
			c_set_modified (c_pointer, a_modified)
		end

	set_nbbuf_number (a_nbbuf_number: INTEGER_32)
		do
			c_set_nbbuf_number (c_pointer, a_nbbuf_number)
		end

	set_displayname (a_displayname: CE_POINTER [INTEGER_8])
		do
			c_set_displayname (c_pointer, a_displayname.c_pointer)
		end

	set_signmap (a_signmap: CE_POINTER [INTEGER_32])
		do
			c_set_signmap (c_pointer, a_signmap.c_pointer)
		end

	set_signmaplen (a_signmaplen: NATURAL_16)
		do
			c_set_signmaplen (c_pointer, a_signmaplen)
		end

	set_signmapused (a_signmapused: NATURAL_16)
		do
			c_set_signmapused (c_pointer, a_signmapused)
		end

feature {NONE} -- C getters

	c_bufp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct file_buffer *)((struct nbbuf_struct *)$tmp)->bufp;"
		end

	c_fireChanges (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct nbbuf_struct *)$tmp)->fireChanges;"
		end

	c_initDone (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct nbbuf_struct *)$tmp)->initDone;"
		end

	c_insertDone (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct nbbuf_struct *)$tmp)->insertDone;"
		end

	c_modified (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct nbbuf_struct *)$tmp)->modified;"
		end

	c_nbbuf_number (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct nbbuf_struct *)$tmp)->nbbuf_number;"
		end

	c_displayname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct nbbuf_struct *)$tmp)->displayname;"
		end

	c_signmap (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int *)((struct nbbuf_struct *)$tmp)->signmap;"
		end

	c_signmaplen (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct nbbuf_struct *)$tmp)->signmaplen;"
		end

	c_signmapused (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct nbbuf_struct *)$tmp)->signmapused;"
		end

feature {NONE} -- C setters

	c_set_bufp (tmp: POINTER; a_bufp: POINTER)
		external
			"C inline"
		alias
			"((struct nbbuf_struct *)$tmp)->bufp = (struct file_buffer *)$a_bufp;"
		end

	c_set_fireChanges (tmp: POINTER; a_fireChanges: NATURAL_32)
		external
			"C inline"
		alias
			"((struct nbbuf_struct *)$tmp)->fireChanges = $a_firechanges;"
		end

	c_set_initDone (tmp: POINTER; a_initDone: NATURAL_32)
		external
			"C inline"
		alias
			"((struct nbbuf_struct *)$tmp)->initDone = $a_initdone;"
		end

	c_set_insertDone (tmp: POINTER; a_insertDone: NATURAL_32)
		external
			"C inline"
		alias
			"((struct nbbuf_struct *)$tmp)->insertDone = $a_insertdone;"
		end

	c_set_modified (tmp: POINTER; a_modified: NATURAL_32)
		external
			"C inline"
		alias
			"((struct nbbuf_struct *)$tmp)->modified = $a_modified;"
		end

	c_set_nbbuf_number (tmp: POINTER; a_nbbuf_number: INTEGER_32)
		external
			"C inline"
		alias
			"((struct nbbuf_struct *)$tmp)->nbbuf_number = $a_nbbuf_number;"
		end

	c_set_displayname (tmp: POINTER; a_displayname: POINTER)
		external
			"C inline"
		alias
			"((struct nbbuf_struct *)$tmp)->displayname = (char *)$a_displayname;"
		end

	c_set_signmap (tmp: POINTER; a_signmap: POINTER)
		external
			"C inline"
		alias
			"((struct nbbuf_struct *)$tmp)->signmap = (int *)$a_signmap;"
		end

	c_set_signmaplen (tmp: POINTER; a_signmaplen: NATURAL_16)
		external
			"C inline"
		alias
			"((struct nbbuf_struct *)$tmp)->signmaplen = $a_signmaplen;"
		end

	c_set_signmapused (tmp: POINTER; a_signmapused: NATURAL_16)
		external
			"C inline"
		alias
			"((struct nbbuf_struct *)$tmp)->signmapused = $a_signmapused;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct nbbuf_struct);"
		end

end
