class
	PD_NR_TRANS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	nt_next: CE_POINTER [PD_NR_TRANS] assign set_nt_next
		do
			create Result.make_shared (c_nt_next (c_pointer))
		end

	nt_prev: CE_POINTER [PD_NR_TRANS] assign set_nt_prev
		do
			create Result.make_shared (c_nt_prev (c_pointer))
		end

	nt_old_bnum: INTEGER_32 assign set_nt_old_bnum
		do
			Result := c_nt_old_bnum (c_pointer)
		end

	nt_new_bnum: INTEGER_32 assign set_nt_new_bnum
		do
			Result := c_nt_new_bnum (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_nt_next (a_nt_next: CE_POINTER [PD_NR_TRANS])
		do
			c_set_nt_next (c_pointer, a_nt_next.c_pointer)
		end

	set_nt_prev (a_nt_prev: CE_POINTER [PD_NR_TRANS])
		do
			c_set_nt_prev (c_pointer, a_nt_prev.c_pointer)
		end

	set_nt_old_bnum (a_nt_old_bnum: INTEGER_32)
		do
			c_set_nt_old_bnum (c_pointer, a_nt_old_bnum)
		end

	set_nt_new_bnum (a_nt_new_bnum: INTEGER_32)
		do
			c_set_nt_new_bnum (c_pointer, a_nt_new_bnum)
		end

feature {NONE} -- C getters

	c_nt_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct nr_trans *)((struct nr_trans *)$tmp)->nt_next;"
		end

	c_nt_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct nr_trans *)((struct nr_trans *)$tmp)->nt_prev;"
		end

	c_nt_old_bnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct nr_trans *)$tmp)->nt_old_bnum;"
		end

	c_nt_new_bnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct nr_trans *)$tmp)->nt_new_bnum;"
		end

feature {NONE} -- C setters

	c_set_nt_next (tmp: POINTER; a_nt_next: POINTER)
		external
			"C inline"
		alias
			"((struct nr_trans *)$tmp)->nt_next = (struct nr_trans *)$a_nt_next;"
		end

	c_set_nt_prev (tmp: POINTER; a_nt_prev: POINTER)
		external
			"C inline"
		alias
			"((struct nr_trans *)$tmp)->nt_prev = (struct nr_trans *)$a_nt_prev;"
		end

	c_set_nt_old_bnum (tmp: POINTER; a_nt_old_bnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct nr_trans *)$tmp)->nt_old_bnum = $a_nt_old_bnum;"
		end

	c_set_nt_new_bnum (tmp: POINTER; a_nt_new_bnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct nr_trans *)$tmp)->nt_new_bnum = $a_nt_new_bnum;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct nr_trans);"
		end

end
