class
	PD_NV_CMD

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	cmd_char: INTEGER_32 assign set_cmd_char
		do
			Result := c_cmd_char (c_pointer)
		end

	cmd_func: CE_ROUTINE assign set_cmd_func
		do
			create Result.make_shared (c_cmd_func (c_pointer))
		end

	cmd_flags: NATURAL_16 assign set_cmd_flags
		do
			Result := c_cmd_flags (c_pointer)
		end

	cmd_arg: INTEGER_16 assign set_cmd_arg
		do
			Result := c_cmd_arg (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_cmd_char (a_cmd_char: INTEGER_32)
		do
			c_set_cmd_char (c_pointer, a_cmd_char)
		end

	set_cmd_func (a_cmd_func: CE_ROUTINE)
		do
			c_set_cmd_func (c_pointer, a_cmd_func.c_pointer)
		end

	set_cmd_flags (a_cmd_flags: NATURAL_16)
		do
			c_set_cmd_flags (c_pointer, a_cmd_flags)
		end

	set_cmd_arg (a_cmd_arg: INTEGER_16)
		do
			c_set_cmd_arg (c_pointer, a_cmd_arg)
		end

feature {NONE} -- C getters

	c_cmd_char (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct nv_cmd *)$tmp)->cmd_char;"
		end

	c_cmd_func (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct cmdarg_S * cap))((struct nv_cmd *)$tmp)->cmd_func;"
		end

	c_cmd_flags (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct nv_cmd *)$tmp)->cmd_flags;"
		end

	c_cmd_arg (tmp: POINTER): INTEGER_16
		external
			"C inline"
		alias
			"return (short)((struct nv_cmd *)$tmp)->cmd_arg;"
		end

feature {NONE} -- C setters

	c_set_cmd_char (tmp: POINTER; a_cmd_char: INTEGER_32)
		external
			"C inline"
		alias
			"((struct nv_cmd *)$tmp)->cmd_char = $a_cmd_char;"
		end

	c_set_cmd_func (tmp: POINTER; a_cmd_func: POINTER)
		external
			"C inline"
		alias
			"((struct nv_cmd *)$tmp)->cmd_func = (void( *)(struct cmdarg_S * cap))$a_cmd_func;"
		end

	c_set_cmd_flags (tmp: POINTER; a_cmd_flags: NATURAL_16)
		external
			"C inline"
		alias
			"((struct nv_cmd *)$tmp)->cmd_flags = $a_cmd_flags;"
		end

	c_set_cmd_arg (tmp: POINTER; a_cmd_arg: INTEGER_16)
		external
			"C inline"
		alias
			"((struct nv_cmd *)$tmp)->cmd_arg = $a_cmd_arg;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct nv_cmd);"
		end

end
