class
	PD_OPARG_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	op_type: INTEGER_32 assign set_op_type
		do
			Result := c_op_type (c_pointer)
		end

	regname: INTEGER_32 assign set_regname
		do
			Result := c_regname (c_pointer)
		end

	regname_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct oparg_S, regname);"
		end

	motion_type: INTEGER_32 assign set_motion_type
		do
			Result := c_motion_type (c_pointer)
		end

	motion_force: INTEGER_32 assign set_motion_force
		do
			Result := c_motion_force (c_pointer)
		end

	use_reg_one: INTEGER_32 assign set_use_reg_one
		do
			Result := c_use_reg_one (c_pointer)
		end

	inclusive: INTEGER_32 assign set_inclusive
		do
			Result := c_inclusive (c_pointer)
		end

	inclusive_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct oparg_S, inclusive);"
		end

	end_adjusted: INTEGER_32 assign set_end_adjusted
		do
			Result := c_end_adjusted (c_pointer)
		end

	start: PD_POS_T assign set_start
		do
			create Result.make_shared (c_start (c_pointer))
		end

	start_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct oparg_S, start);"
		end

	end2: PD_POS_T assign set_end2
		do
			create Result.make_shared (c_end2 (c_pointer))
		end

	end2_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct oparg_S, end);"
		end

	cursor_start: PD_POS_T assign set_cursor_start
		do
			create Result.make_shared (c_cursor_start (c_pointer))
		end

	line_count: INTEGER_32 assign set_line_count
		do
			Result := c_line_count (c_pointer)
		end

	empty: INTEGER_32 assign set_empty
		do
			Result := c_empty (c_pointer)
		end

	is_VIsual: INTEGER_32 assign set_is_VIsual
		do
			Result := c_is_VIsual (c_pointer)
		end

	block_mode: INTEGER_32 assign set_block_mode
		do
			Result := c_block_mode (c_pointer)
		end

	start_vcol: INTEGER_32 assign set_start_vcol
		do
			Result := c_start_vcol (c_pointer)
		end

	start_vcol_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct oparg_S, start_vcol);"
		end

	end_vcol: INTEGER_32 assign set_end_vcol
		do
			Result := c_end_vcol (c_pointer)
		end

	end_vcol_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct oparg_S, end_vcol);"
		end

	prev_opcount: INTEGER_32 assign set_prev_opcount
		do
			Result := c_prev_opcount (c_pointer)
		end

	prev_count0: INTEGER_32 assign set_prev_count0
		do
			Result := c_prev_count0 (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_op_type (a_op_type: INTEGER_32)
		do
			c_set_op_type (c_pointer, a_op_type)
		end

	set_regname (a_regname: INTEGER_32)
		do
			c_set_regname (c_pointer, a_regname)
		end

	set_motion_type (a_motion_type: INTEGER_32)
		do
			c_set_motion_type (c_pointer, a_motion_type)
		end

	set_motion_force (a_motion_force: INTEGER_32)
		do
			c_set_motion_force (c_pointer, a_motion_force)
		end

	set_use_reg_one (a_use_reg_one: INTEGER_32)
		do
			c_set_use_reg_one (c_pointer, a_use_reg_one)
		end

	set_inclusive (a_inclusive: INTEGER_32)
		do
			c_set_inclusive (c_pointer, a_inclusive)
		end

	set_end_adjusted (a_end_adjusted: INTEGER_32)
		do
			c_set_end_adjusted (c_pointer, a_end_adjusted)
		end

	set_start (a_start: PD_POS_T)
		do
			start.ce_gets (a_start)
		end

	set_end2 (a_end2: PD_POS_T)
		do
			end2.ce_gets (a_end2)
		end

	set_cursor_start (a_cursor_start: PD_POS_T)
		do
			cursor_start.ce_gets (a_cursor_start)
		end

	set_line_count (a_line_count: INTEGER_32)
		do
			c_set_line_count (c_pointer, a_line_count)
		end

	set_empty (a_empty: INTEGER_32)
		do
			c_set_empty (c_pointer, a_empty)
		end

	set_is_VIsual (a_is_VIsual: INTEGER_32)
		do
			c_set_is_VIsual (c_pointer, a_is_VIsual)
		end

	set_block_mode (a_block_mode: INTEGER_32)
		do
			c_set_block_mode (c_pointer, a_block_mode)
		end

	set_start_vcol (a_start_vcol: INTEGER_32)
		do
			c_set_start_vcol (c_pointer, a_start_vcol)
		end

	set_end_vcol (a_end_vcol: INTEGER_32)
		do
			c_set_end_vcol (c_pointer, a_end_vcol)
		end

	set_prev_opcount (a_prev_opcount: INTEGER_32)
		do
			c_set_prev_opcount (c_pointer, a_prev_opcount)
		end

	set_prev_count0 (a_prev_count0: INTEGER_32)
		do
			c_set_prev_count0 (c_pointer, a_prev_count0)
		end

feature {NONE} -- C getters

	c_op_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct oparg_S *)$tmp)->op_type;"
		end

	c_regname (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct oparg_S *)$tmp)->regname;"
		end

	c_motion_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct oparg_S *)$tmp)->motion_type;"
		end

	c_motion_force (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct oparg_S *)$tmp)->motion_force;"
		end

	c_use_reg_one (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct oparg_S *)$tmp)->use_reg_one;"
		end

	c_inclusive (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct oparg_S *)$tmp)->inclusive;"
		end

	c_end_adjusted (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct oparg_S *)$tmp)->end_adjusted;"
		end

	c_start (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (pos_T *)&((struct oparg_S *)$tmp)->start;"
		end

	c_end2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (pos_T *)&((struct oparg_S *)$tmp)->end;"
		end

	c_cursor_start (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (pos_T *)&((struct oparg_S *)$tmp)->cursor_start;"
		end

	c_line_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct oparg_S *)$tmp)->line_count;"
		end

	c_empty (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct oparg_S *)$tmp)->empty;"
		end

	c_is_VIsual (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct oparg_S *)$tmp)->is_VIsual;"
		end

	c_block_mode (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct oparg_S *)$tmp)->block_mode;"
		end

	c_start_vcol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct oparg_S *)$tmp)->start_vcol;"
		end

	c_end_vcol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct oparg_S *)$tmp)->end_vcol;"
		end

	c_prev_opcount (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct oparg_S *)$tmp)->prev_opcount;"
		end

	c_prev_count0 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct oparg_S *)$tmp)->prev_count0;"
		end

feature {NONE} -- C setters

	c_set_op_type (tmp: POINTER; a_op_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct oparg_S *)$tmp)->op_type = $a_op_type;"
		end

	c_set_regname (tmp: POINTER; a_regname: INTEGER_32)
		external
			"C inline"
		alias
			"((struct oparg_S *)$tmp)->regname = $a_regname;"
		end

	c_set_motion_type (tmp: POINTER; a_motion_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct oparg_S *)$tmp)->motion_type = $a_motion_type;"
		end

	c_set_motion_force (tmp: POINTER; a_motion_force: INTEGER_32)
		external
			"C inline"
		alias
			"((struct oparg_S *)$tmp)->motion_force = $a_motion_force;"
		end

	c_set_use_reg_one (tmp: POINTER; a_use_reg_one: INTEGER_32)
		external
			"C inline"
		alias
			"((struct oparg_S *)$tmp)->use_reg_one = $a_use_reg_one;"
		end

	c_set_inclusive (tmp: POINTER; a_inclusive: INTEGER_32)
		external
			"C inline"
		alias
			"((struct oparg_S *)$tmp)->inclusive = $a_inclusive;"
		end

	c_set_end_adjusted (tmp: POINTER; a_end_adjusted: INTEGER_32)
		external
			"C inline"
		alias
			"((struct oparg_S *)$tmp)->end_adjusted = $a_end_adjusted;"
		end

	c_set_line_count (tmp: POINTER; a_line_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct oparg_S *)$tmp)->line_count = $a_line_count;"
		end

	c_set_empty (tmp: POINTER; a_empty: INTEGER_32)
		external
			"C inline"
		alias
			"((struct oparg_S *)$tmp)->empty = $a_empty;"
		end

	c_set_is_VIsual (tmp: POINTER; a_is_VIsual: INTEGER_32)
		external
			"C inline"
		alias
			"((struct oparg_S *)$tmp)->is_VIsual = $a_is_visual;"
		end

	c_set_block_mode (tmp: POINTER; a_block_mode: INTEGER_32)
		external
			"C inline"
		alias
			"((struct oparg_S *)$tmp)->block_mode = $a_block_mode;"
		end

	c_set_start_vcol (tmp: POINTER; a_start_vcol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct oparg_S *)$tmp)->start_vcol = $a_start_vcol;"
		end

	c_set_end_vcol (tmp: POINTER; a_end_vcol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct oparg_S *)$tmp)->end_vcol = $a_end_vcol;"
		end

	c_set_prev_opcount (tmp: POINTER; a_prev_opcount: INTEGER_32)
		external
			"C inline"
		alias
			"((struct oparg_S *)$tmp)->prev_opcount = $a_prev_opcount;"
		end

	c_set_prev_count0 (tmp: POINTER; a_prev_count0: INTEGER_32)
		external
			"C inline"
		alias
			"((struct oparg_S *)$tmp)->prev_count0 = $a_prev_count0;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct oparg_S);"
		end

end
