class
	PD_OPTION_TABLE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	hasnum: INTEGER_32 assign set_hasnum
		do
			Result := c_hasnum (c_pointer)
		end

	number: INTEGER_32 assign set_number
		do
			Result := c_number (c_pointer)
		end

	string: CE_POINTER [NATURAL_8] assign set_string
		do
			create Result.make_shared (c_string (c_pointer))
		end

	strlen: INTEGER_32 assign set_strlen
		do
			Result := c_strlen (c_pointer)
		end

	present: INTEGER_32 assign set_present
		do
			Result := c_present (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_hasnum (a_hasnum: INTEGER_32)
		do
			c_set_hasnum (c_pointer, a_hasnum)
		end

	set_number (a_number: INTEGER_32)
		do
			c_set_number (c_pointer, a_number)
		end

	set_string (a_string: CE_POINTER [NATURAL_8])
		do
			c_set_string (c_pointer, a_string.c_pointer)
		end

	set_strlen (a_strlen: INTEGER_32)
		do
			c_set_strlen (c_pointer, a_strlen)
		end

	set_present (a_present: INTEGER_32)
		do
			c_set_present (c_pointer, a_present)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_option_table_T_537 *)$tmp)->name;"
		end

	c_hasnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_option_table_T_537 *)$tmp)->hasnum;"
		end

	c_number (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_option_table_T_537 *)$tmp)->number;"
		end

	c_string (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_option_table_T_537 *)$tmp)->string;"
		end

	c_strlen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_option_table_T_537 *)$tmp)->strlen;"
		end

	c_present (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_option_table_T_537 *)$tmp)->present;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_option_table_T_537 *)$tmp)->name = (char const *)$a_name;"
		end

	c_set_hasnum (tmp: POINTER; a_hasnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_option_table_T_537 *)$tmp)->hasnum = $a_hasnum;"
		end

	c_set_number (tmp: POINTER; a_number: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_option_table_T_537 *)$tmp)->number = $a_number;"
		end

	c_set_string (tmp: POINTER; a_string: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_option_table_T_537 *)$tmp)->string = (unsigned char *)$a_string;"
		end

	c_set_strlen (tmp: POINTER; a_strlen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_option_table_T_537 *)$tmp)->strlen = $a_strlen;"
		end

	c_set_present (tmp: POINTER; a_present: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_option_table_T_537 *)$tmp)->present = $a_present;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_option_table_T_537);"
		end

end
