class
	PD_PAT_PTR

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	pp_synp: CE_POINTER [PD_SYN_PATTERN] assign set_pp_synp
		do
			create Result.make_shared (c_pp_synp (c_pointer))
		end

	pp_matchgroup_id: INTEGER_32 assign set_pp_matchgroup_id
		do
			Result := c_pp_matchgroup_id (c_pointer)
		end

	pp_next: CE_POINTER [PD_PAT_PTR] assign set_pp_next
		do
			create Result.make_shared (c_pp_next (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_pp_synp (a_pp_synp: CE_POINTER [PD_SYN_PATTERN])
		do
			c_set_pp_synp (c_pointer, a_pp_synp.c_pointer)
		end

	set_pp_matchgroup_id (a_pp_matchgroup_id: INTEGER_32)
		do
			c_set_pp_matchgroup_id (c_pointer, a_pp_matchgroup_id)
		end

	set_pp_next (a_pp_next: CE_POINTER [PD_PAT_PTR])
		do
			c_set_pp_next (c_pointer, a_pp_next.c_pointer)
		end

feature {NONE} -- C getters

	c_pp_synp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct syn_pattern *)((struct pat_ptr *)$tmp)->pp_synp;"
		end

	c_pp_matchgroup_id (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct pat_ptr *)$tmp)->pp_matchgroup_id;"
		end

	c_pp_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct pat_ptr *)((struct pat_ptr *)$tmp)->pp_next;"
		end

feature {NONE} -- C setters

	c_set_pp_synp (tmp: POINTER; a_pp_synp: POINTER)
		external
			"C inline"
		alias
			"((struct pat_ptr *)$tmp)->pp_synp = (struct syn_pattern *)$a_pp_synp;"
		end

	c_set_pp_matchgroup_id (tmp: POINTER; a_pp_matchgroup_id: INTEGER_32)
		external
			"C inline"
		alias
			"((struct pat_ptr *)$tmp)->pp_matchgroup_id = $a_pp_matchgroup_id;"
		end

	c_set_pp_next (tmp: POINTER; a_pp_next: POINTER)
		external
			"C inline"
		alias
			"((struct pat_ptr *)$tmp)->pp_next = (struct pat_ptr *)$a_pp_next;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct pat_ptr);"
		end

end
