class
	PD_PAT_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	pat: CE_POINTER [NATURAL_8] assign set_pat
		do
			create Result.make_shared (c_pat (c_pointer))
		end

	len: INTEGER_32 assign set_len
		do
			Result := c_len (c_pointer)
		end

	head: CE_POINTER [NATURAL_8] assign set_head
		do
			create Result.make_shared (c_head (c_pointer))
		end

	headlen: INTEGER_32 assign set_headlen
		do
			Result := c_headlen (c_pointer)
		end

	regmatch: PD_REGMATCH_T assign set_regmatch
		do
			create Result.make_shared (c_regmatch (c_pointer))
		end

	regmatch_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_pat_T_543, regmatch);"
		end

feature {ANY} -- Eiffel setters

	set_pat (a_pat: CE_POINTER [NATURAL_8])
		do
			c_set_pat (c_pointer, a_pat.c_pointer)
		end

	set_len (a_len: INTEGER_32)
		do
			c_set_len (c_pointer, a_len)
		end

	set_head (a_head: CE_POINTER [NATURAL_8])
		do
			c_set_head (c_pointer, a_head.c_pointer)
		end

	set_headlen (a_headlen: INTEGER_32)
		do
			c_set_headlen (c_pointer, a_headlen)
		end

	set_regmatch (a_regmatch: PD_REGMATCH_T)
		do
			regmatch.ce_gets (a_regmatch)
		end

feature {NONE} -- C getters

	c_pat (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_pat_T_543 *)$tmp)->pat;"
		end

	c_len (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_pat_T_543 *)$tmp)->len;"
		end

	c_head (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_pat_T_543 *)$tmp)->head;"
		end

	c_headlen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_pat_T_543 *)$tmp)->headlen;"
		end

	c_regmatch (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (regmatch_T *)&((struct __anonstruct_pat_T_543 *)$tmp)->regmatch;"
		end

feature {NONE} -- C setters

	c_set_pat (tmp: POINTER; a_pat: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_pat_T_543 *)$tmp)->pat = (unsigned char *)$a_pat;"
		end

	c_set_len (tmp: POINTER; a_len: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_pat_T_543 *)$tmp)->len = $a_len;"
		end

	c_set_head (tmp: POINTER; a_head: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_pat_T_543 *)$tmp)->head = (unsigned char *)$a_head;"
		end

	c_set_headlen (tmp: POINTER; a_headlen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_pat_T_543 *)$tmp)->headlen = $a_headlen;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_pat_T_543);"
		end

end
