class
	PD_POINTER_ENTRY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	pe_bnum: INTEGER_32 assign set_pe_bnum
		do
			Result := c_pe_bnum (c_pointer)
		end

	pe_line_count: INTEGER_32 assign set_pe_line_count
		do
			Result := c_pe_line_count (c_pointer)
		end

	pe_old_lnum: INTEGER_32 assign set_pe_old_lnum
		do
			Result := c_pe_old_lnum (c_pointer)
		end

	pe_page_count: INTEGER_32 assign set_pe_page_count
		do
			Result := c_pe_page_count (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_pe_bnum (a_pe_bnum: INTEGER_32)
		do
			c_set_pe_bnum (c_pointer, a_pe_bnum)
		end

	set_pe_line_count (a_pe_line_count: INTEGER_32)
		do
			c_set_pe_line_count (c_pointer, a_pe_line_count)
		end

	set_pe_old_lnum (a_pe_old_lnum: INTEGER_32)
		do
			c_set_pe_old_lnum (c_pointer, a_pe_old_lnum)
		end

	set_pe_page_count (a_pe_page_count: INTEGER_32)
		do
			c_set_pe_page_count (c_pointer, a_pe_page_count)
		end

feature {NONE} -- C getters

	c_pe_bnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct pointer_entry *)$tmp)->pe_bnum;"
		end

	c_pe_line_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct pointer_entry *)$tmp)->pe_line_count;"
		end

	c_pe_old_lnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct pointer_entry *)$tmp)->pe_old_lnum;"
		end

	c_pe_page_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct pointer_entry *)$tmp)->pe_page_count;"
		end

feature {NONE} -- C setters

	c_set_pe_bnum (tmp: POINTER; a_pe_bnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct pointer_entry *)$tmp)->pe_bnum = $a_pe_bnum;"
		end

	c_set_pe_line_count (tmp: POINTER; a_pe_line_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct pointer_entry *)$tmp)->pe_line_count = $a_pe_line_count;"
		end

	c_set_pe_old_lnum (tmp: POINTER; a_pe_old_lnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct pointer_entry *)$tmp)->pe_old_lnum = $a_pe_old_lnum;"
		end

	c_set_pe_page_count (tmp: POINTER; a_pe_page_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct pointer_entry *)$tmp)->pe_page_count = $a_pe_page_count;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct pointer_entry);"
		end

end
