class
	PD_POS_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	lnum: INTEGER_32 assign set_lnum
		do
			Result := c_lnum (c_pointer)
		end

	lnum_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_pos_T_63, lnum);"
		end

	col: INTEGER_32 assign set_col
		do
			Result := c_col (c_pointer)
		end

	col_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_pos_T_63, col);"
		end

	coladd: INTEGER_32 assign set_coladd
		do
			Result := c_coladd (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_lnum (a_lnum: INTEGER_32)
		do
			c_set_lnum (c_pointer, a_lnum)
		end

	set_col (a_col: INTEGER_32)
		do
			c_set_col (c_pointer, a_col)
		end

	set_coladd (a_coladd: INTEGER_32)
		do
			c_set_coladd (c_pointer, a_coladd)
		end

feature {NONE} -- C getters

	c_lnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_pos_T_63 *)$tmp)->lnum;"
		end

	c_col (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_pos_T_63 *)$tmp)->col;"
		end

	c_coladd (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_pos_T_63 *)$tmp)->coladd;"
		end

feature {NONE} -- C setters

	c_set_lnum (tmp: POINTER; a_lnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_pos_T_63 *)$tmp)->lnum = $a_lnum;"
		end

	c_set_col (tmp: POINTER; a_col: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_pos_T_63 *)$tmp)->col = $a_col;"
		end

	c_set_coladd (tmp: POINTER; a_coladd: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_pos_T_63 *)$tmp)->coladd = $a_coladd;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_pos_T_63);"
		end

end
