class
	PD_PRT_MEDIASIZE_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	width: REAL_32 assign set_width
		do
			Result := c_width (c_pointer)
		end

	height: REAL_32 assign set_height
		do
			Result := c_height (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_width (a_width: REAL_32)
		do
			c_set_width (c_pointer, a_width)
		end

	set_height (a_height: REAL_32)
		do
			c_set_height (c_pointer, a_height)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct prt_mediasize_S *)$tmp)->name;"
		end

	c_width (tmp: POINTER): REAL_32
		external
			"C inline"
		alias
			"return (float)((struct prt_mediasize_S *)$tmp)->width;"
		end

	c_height (tmp: POINTER): REAL_32
		external
			"C inline"
		alias
			"return (float)((struct prt_mediasize_S *)$tmp)->height;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct prt_mediasize_S *)$tmp)->name = (char *)$a_name;"
		end

	c_set_width (tmp: POINTER; a_width: REAL_32)
		external
			"C inline"
		alias
			"((struct prt_mediasize_S *)$tmp)->width = $a_width;"
		end

	c_set_height (tmp: POINTER; a_height: REAL_32)
		external
			"C inline"
		alias
			"((struct prt_mediasize_S *)$tmp)->height = $a_height;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct prt_mediasize_S);"
		end

end
