class
	PD_PRT_PS_ENCODING_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	encoding: CE_POINTER [INTEGER_8] assign set_encoding
		do
			create Result.make_shared (c_encoding (c_pointer))
		end

	cmap_encoding: CE_POINTER [INTEGER_8] assign set_cmap_encoding
		do
			create Result.make_shared (c_cmap_encoding (c_pointer))
		end

	needs_charset: INTEGER_32 assign set_needs_charset
		do
			Result := c_needs_charset (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_encoding (a_encoding: CE_POINTER [INTEGER_8])
		do
			c_set_encoding (c_pointer, a_encoding.c_pointer)
		end

	set_cmap_encoding (a_cmap_encoding: CE_POINTER [INTEGER_8])
		do
			c_set_cmap_encoding (c_pointer, a_cmap_encoding.c_pointer)
		end

	set_needs_charset (a_needs_charset: INTEGER_32)
		do
			c_set_needs_charset (c_pointer, a_needs_charset)
		end

feature {NONE} -- C getters

	c_encoding (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct prt_ps_encoding_S *)$tmp)->encoding;"
		end

	c_cmap_encoding (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct prt_ps_encoding_S *)$tmp)->cmap_encoding;"
		end

	c_needs_charset (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct prt_ps_encoding_S *)$tmp)->needs_charset;"
		end

feature {NONE} -- C setters

	c_set_encoding (tmp: POINTER; a_encoding: POINTER)
		external
			"C inline"
		alias
			"((struct prt_ps_encoding_S *)$tmp)->encoding = (char *)$a_encoding;"
		end

	c_set_cmap_encoding (tmp: POINTER; a_cmap_encoding: POINTER)
		external
			"C inline"
		alias
			"((struct prt_ps_encoding_S *)$tmp)->cmap_encoding = (char *)$a_cmap_encoding;"
		end

	c_set_needs_charset (tmp: POINTER; a_needs_charset: INTEGER_32)
		external
			"C inline"
		alias
			"((struct prt_ps_encoding_S *)$tmp)->needs_charset = $a_needs_charset;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct prt_ps_encoding_S);"
		end

end
