class
	PD_PRT_PS_RESOURCE_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_name (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	filename: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_filename (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	title: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_title (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	version: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_version (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

feature {NONE} -- C getters

	c_name (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct prt_ps_resource_S *tmp = (struct prt_ps_resource_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->name) / sizeof(tmp->name[0]);
				return tmp->name;
			]"
		end

	c_filename (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct prt_ps_resource_S *tmp = (struct prt_ps_resource_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->filename) / sizeof(tmp->filename[0]);
				return tmp->filename;
			]"
		end

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct prt_ps_resource_S *)$tmp)->type;"
		end

	c_title (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct prt_ps_resource_S *tmp = (struct prt_ps_resource_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->title) / sizeof(tmp->title[0]);
				return tmp->title;
			]"
		end

	c_version (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct prt_ps_resource_S *tmp = (struct prt_ps_resource_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->version) / sizeof(tmp->version[0]);
				return tmp->version;
			]"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct prt_ps_resource_S *)$tmp)->type = $a_type;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct prt_ps_resource_S);"
		end

end
