class
	PD_PRT_TEXT_ATTR_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	fg_color: NATURAL_32 assign set_fg_color
		do
			Result := c_fg_color (c_pointer)
		end

	bg_color: NATURAL_32 assign set_bg_color
		do
			Result := c_bg_color (c_pointer)
		end

	bold: INTEGER_32 assign set_bold
		do
			Result := c_bold (c_pointer)
		end

	italic: INTEGER_32 assign set_italic
		do
			Result := c_italic (c_pointer)
		end

	underline: INTEGER_32 assign set_underline
		do
			Result := c_underline (c_pointer)
		end

	undercurl: INTEGER_32 assign set_undercurl
		do
			Result := c_undercurl (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_fg_color (a_fg_color: NATURAL_32)
		do
			c_set_fg_color (c_pointer, a_fg_color)
		end

	set_bg_color (a_bg_color: NATURAL_32)
		do
			c_set_bg_color (c_pointer, a_bg_color)
		end

	set_bold (a_bold: INTEGER_32)
		do
			c_set_bold (c_pointer, a_bold)
		end

	set_italic (a_italic: INTEGER_32)
		do
			c_set_italic (c_pointer, a_italic)
		end

	set_underline (a_underline: INTEGER_32)
		do
			c_set_underline (c_pointer, a_underline)
		end

	set_undercurl (a_undercurl: INTEGER_32)
		do
			c_set_undercurl (c_pointer, a_undercurl)
		end

feature {NONE} -- C getters

	c_fg_color (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_prt_text_attr_T_538 *)$tmp)->fg_color;"
		end

	c_bg_color (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_prt_text_attr_T_538 *)$tmp)->bg_color;"
		end

	c_bold (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_prt_text_attr_T_538 *)$tmp)->bold;"
		end

	c_italic (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_prt_text_attr_T_538 *)$tmp)->italic;"
		end

	c_underline (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_prt_text_attr_T_538 *)$tmp)->underline;"
		end

	c_undercurl (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_prt_text_attr_T_538 *)$tmp)->undercurl;"
		end

feature {NONE} -- C setters

	c_set_fg_color (tmp: POINTER; a_fg_color: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_prt_text_attr_T_538 *)$tmp)->fg_color = $a_fg_color;"
		end

	c_set_bg_color (tmp: POINTER; a_bg_color: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_prt_text_attr_T_538 *)$tmp)->bg_color = $a_bg_color;"
		end

	c_set_bold (tmp: POINTER; a_bold: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_prt_text_attr_T_538 *)$tmp)->bold = $a_bold;"
		end

	c_set_italic (tmp: POINTER; a_italic: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_prt_text_attr_T_538 *)$tmp)->italic = $a_italic;"
		end

	c_set_underline (tmp: POINTER; a_underline: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_prt_text_attr_T_538 *)$tmp)->underline = $a_underline;"
		end

	c_set_undercurl (tmp: POINTER; a_undercurl: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_prt_text_attr_T_538 *)$tmp)->undercurl = $a_undercurl;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_prt_text_attr_T_538);"
		end

end
