class
	PD_REGSAVE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	rs_u: PD_RS_U assign set_rs_u
		do
			create Result.make_shared (c_rs_u (c_pointer))
		end

	rs_len: INTEGER_32 assign set_rs_len
		do
			Result := c_rs_len (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_rs_u (a_rs_u: PD_RS_U)
		do
			rs_u.ce_gets (a_rs_u)
		end

	set_rs_len (a_rs_len: INTEGER_32)
		do
			c_set_rs_len (c_pointer, a_rs_len)
		end

feature {NONE} -- C getters

	c_rs_u (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_rs_u_544 *)&((struct __anonstruct_regsave_T_543 *)$tmp)->rs_u;"
		end

	c_rs_len (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_regsave_T_543 *)$tmp)->rs_len;"
		end

feature {NONE} -- C setters

	c_set_rs_len (tmp: POINTER; a_rs_len: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_regsave_T_543 *)$tmp)->rs_len = $a_rs_len;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_regsave_T_543);"
		end

end
