class
	PD_REGSTAR_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	nextb: INTEGER_32 assign set_nextb
		do
			Result := c_nextb (c_pointer)
		end

	nextb_ic: INTEGER_32 assign set_nextb_ic
		do
			Result := c_nextb_ic (c_pointer)
		end

	count: INTEGER_32 assign set_count
		do
			Result := c_count (c_pointer)
		end

	minval: INTEGER_32 assign set_minval
		do
			Result := c_minval (c_pointer)
		end

	maxval: INTEGER_32 assign set_maxval
		do
			Result := c_maxval (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_nextb (a_nextb: INTEGER_32)
		do
			c_set_nextb (c_pointer, a_nextb)
		end

	set_nextb_ic (a_nextb_ic: INTEGER_32)
		do
			c_set_nextb_ic (c_pointer, a_nextb_ic)
		end

	set_count (a_count: INTEGER_32)
		do
			c_set_count (c_pointer, a_count)
		end

	set_minval (a_minval: INTEGER_32)
		do
			c_set_minval (c_pointer, a_minval)
		end

	set_maxval (a_maxval: INTEGER_32)
		do
			c_set_maxval (c_pointer, a_maxval)
		end

feature {NONE} -- C getters

	c_nextb (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct regstar_S *)$tmp)->nextb;"
		end

	c_nextb_ic (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct regstar_S *)$tmp)->nextb_ic;"
		end

	c_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct regstar_S *)$tmp)->count;"
		end

	c_minval (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct regstar_S *)$tmp)->minval;"
		end

	c_maxval (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct regstar_S *)$tmp)->maxval;"
		end

feature {NONE} -- C setters

	c_set_nextb (tmp: POINTER; a_nextb: INTEGER_32)
		external
			"C inline"
		alias
			"((struct regstar_S *)$tmp)->nextb = $a_nextb;"
		end

	c_set_nextb_ic (tmp: POINTER; a_nextb_ic: INTEGER_32)
		external
			"C inline"
		alias
			"((struct regstar_S *)$tmp)->nextb_ic = $a_nextb_ic;"
		end

	c_set_count (tmp: POINTER; a_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct regstar_S *)$tmp)->count = $a_count;"
		end

	c_set_minval (tmp: POINTER; a_minval: INTEGER_32)
		external
			"C inline"
		alias
			"((struct regstar_S *)$tmp)->minval = $a_minval;"
		end

	c_set_maxval (tmp: POINTER; a_maxval: INTEGER_32)
		external
			"C inline"
		alias
			"((struct regstar_S *)$tmp)->maxval = $a_maxval;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct regstar_S);"
		end

end
