class
	PD_SCRIPTVAR_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sv_var: PD_DICTITEM_S assign set_sv_var
		do
			create Result.make_shared (c_sv_var (c_pointer))
		end

	sv_var_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_scriptvar_T_545, sv_var);"
		end

	sv_dict: PD_DICTVAR_S assign set_sv_dict
		do
			create Result.make_shared (c_sv_dict (c_pointer))
		end

	sv_dict_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_scriptvar_T_545, sv_dict);"
		end

feature {ANY} -- Eiffel setters

	set_sv_var (a_sv_var: PD_DICTITEM_S)
		do
			sv_var.ce_gets (a_sv_var)
		end

	set_sv_dict (a_sv_dict: PD_DICTVAR_S)
		do
			sv_dict.ce_gets (a_sv_dict)
		end

feature {NONE} -- C getters

	c_sv_var (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dictitem_S *)&((struct __anonstruct_scriptvar_T_545 *)$tmp)->sv_var;"
		end

	c_sv_dict (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dictvar_S *)&((struct __anonstruct_scriptvar_T_545 *)$tmp)->sv_dict;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_scriptvar_T_545);"
		end

end
