class
	PD_SIGN

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sn_next: CE_POINTER [PD_SIGN] assign set_sn_next
		do
			create Result.make_shared (c_sn_next (c_pointer))
		end

	sn_typenr: INTEGER_32 assign set_sn_typenr
		do
			Result := c_sn_typenr (c_pointer)
		end

	sn_name: CE_POINTER [NATURAL_8] assign set_sn_name
		do
			create Result.make_shared (c_sn_name (c_pointer))
		end

	sn_icon: CE_POINTER [NATURAL_8] assign set_sn_icon
		do
			create Result.make_shared (c_sn_icon (c_pointer))
		end

	sn_image: CE_POINTER [ANY] assign set_sn_image
		do
			create Result.make_shared (c_sn_image (c_pointer))
		end

	sn_text: CE_POINTER [NATURAL_8] assign set_sn_text
		do
			create Result.make_shared (c_sn_text (c_pointer))
		end

	sn_line_hl: INTEGER_32 assign set_sn_line_hl
		do
			Result := c_sn_line_hl (c_pointer)
		end

	sn_text_hl: INTEGER_32 assign set_sn_text_hl
		do
			Result := c_sn_text_hl (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_sn_next (a_sn_next: CE_POINTER [PD_SIGN])
		do
			c_set_sn_next (c_pointer, a_sn_next.c_pointer)
		end

	set_sn_typenr (a_sn_typenr: INTEGER_32)
		do
			c_set_sn_typenr (c_pointer, a_sn_typenr)
		end

	set_sn_name (a_sn_name: CE_POINTER [NATURAL_8])
		do
			c_set_sn_name (c_pointer, a_sn_name.c_pointer)
		end

	set_sn_icon (a_sn_icon: CE_POINTER [NATURAL_8])
		do
			c_set_sn_icon (c_pointer, a_sn_icon.c_pointer)
		end

	set_sn_image (a_sn_image: CE_POINTER [ANY])
		do
			c_set_sn_image (c_pointer, a_sn_image.c_pointer)
		end

	set_sn_text (a_sn_text: CE_POINTER [NATURAL_8])
		do
			c_set_sn_text (c_pointer, a_sn_text.c_pointer)
		end

	set_sn_line_hl (a_sn_line_hl: INTEGER_32)
		do
			c_set_sn_line_hl (c_pointer, a_sn_line_hl)
		end

	set_sn_text_hl (a_sn_text_hl: INTEGER_32)
		do
			c_set_sn_text_hl (c_pointer, a_sn_text_hl)
		end

feature {NONE} -- C getters

	c_sn_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct sign *)((struct sign *)$tmp)->sn_next;"
		end

	c_sn_typenr (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct sign *)$tmp)->sn_typenr;"
		end

	c_sn_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct sign *)$tmp)->sn_name;"
		end

	c_sn_icon (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct sign *)$tmp)->sn_icon;"
		end

	c_sn_image (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct sign *)$tmp)->sn_image;"
		end

	c_sn_text (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct sign *)$tmp)->sn_text;"
		end

	c_sn_line_hl (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct sign *)$tmp)->sn_line_hl;"
		end

	c_sn_text_hl (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct sign *)$tmp)->sn_text_hl;"
		end

feature {NONE} -- C setters

	c_set_sn_next (tmp: POINTER; a_sn_next: POINTER)
		external
			"C inline"
		alias
			"((struct sign *)$tmp)->sn_next = (struct sign *)$a_sn_next;"
		end

	c_set_sn_typenr (tmp: POINTER; a_sn_typenr: INTEGER_32)
		external
			"C inline"
		alias
			"((struct sign *)$tmp)->sn_typenr = $a_sn_typenr;"
		end

	c_set_sn_name (tmp: POINTER; a_sn_name: POINTER)
		external
			"C inline"
		alias
			"((struct sign *)$tmp)->sn_name = (unsigned char *)$a_sn_name;"
		end

	c_set_sn_icon (tmp: POINTER; a_sn_icon: POINTER)
		external
			"C inline"
		alias
			"((struct sign *)$tmp)->sn_icon = (unsigned char *)$a_sn_icon;"
		end

	c_set_sn_image (tmp: POINTER; a_sn_image: POINTER)
		external
			"C inline"
		alias
			"((struct sign *)$tmp)->sn_image = (void *)$a_sn_image;"
		end

	c_set_sn_text (tmp: POINTER; a_sn_text: POINTER)
		external
			"C inline"
		alias
			"((struct sign *)$tmp)->sn_text = (unsigned char *)$a_sn_text;"
		end

	c_set_sn_line_hl (tmp: POINTER; a_sn_line_hl: INTEGER_32)
		external
			"C inline"
		alias
			"((struct sign *)$tmp)->sn_line_hl = $a_sn_line_hl;"
		end

	c_set_sn_text_hl (tmp: POINTER; a_sn_text_hl: INTEGER_32)
		external
			"C inline"
		alias
			"((struct sign *)$tmp)->sn_text_hl = $a_sn_text_hl;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct sign);"
		end

end
