class
	PD_SOFFSET

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	dir: INTEGER_32 assign set_dir
		do
			Result := c_dir (c_pointer)
		end

	line: INTEGER_32 assign set_line
		do
			Result := c_line (c_pointer)
		end

	end2: INTEGER_32 assign set_end2
		do
			Result := c_end2 (c_pointer)
		end

	off: INTEGER_32 assign set_off
		do
			Result := c_off (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_dir (a_dir: INTEGER_32)
		do
			c_set_dir (c_pointer, a_dir)
		end

	set_line (a_line: INTEGER_32)
		do
			c_set_line (c_pointer, a_line)
		end

	set_end2 (a_end2: INTEGER_32)
		do
			c_set_end2 (c_pointer, a_end2)
		end

	set_off (a_off: INTEGER_32)
		do
			c_set_off (c_pointer, a_off)
		end

feature {NONE} -- C getters

	c_dir (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct soffset *)$tmp)->dir;"
		end

	c_line (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct soffset *)$tmp)->line;"
		end

	c_end2 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct soffset *)$tmp)->end;"
		end

	c_off (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct soffset *)$tmp)->off;"
		end

feature {NONE} -- C setters

	c_set_dir (tmp: POINTER; a_dir: INTEGER_32)
		external
			"C inline"
		alias
			"((struct soffset *)$tmp)->dir = $a_dir;"
		end

	c_set_line (tmp: POINTER; a_line: INTEGER_32)
		external
			"C inline"
		alias
			"((struct soffset *)$tmp)->line = $a_line;"
		end

	c_set_end2 (tmp: POINTER; a_end2: INTEGER_32)
		external
			"C inline"
		alias
			"((struct soffset *)$tmp)->end = $a_end2;"
		end

	c_set_off (tmp: POINTER; a_off: INTEGER_32)
		external
			"C inline"
		alias
			"((struct soffset *)$tmp)->off = $a_off;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct soffset);"
		end

end
