class
	PD_SPELLINFO_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	si_foldroot: CE_POINTER [PD_WORDNODE_S] assign set_si_foldroot
		do
			create Result.make_shared (c_si_foldroot (c_pointer))
		end

	si_foldwcount: INTEGER_32 assign set_si_foldwcount
		do
			Result := c_si_foldwcount (c_pointer)
		end

	si_keeproot: CE_POINTER [PD_WORDNODE_S] assign set_si_keeproot
		do
			create Result.make_shared (c_si_keeproot (c_pointer))
		end

	si_keepwcount: INTEGER_32 assign set_si_keepwcount
		do
			Result := c_si_keepwcount (c_pointer)
		end

	si_prefroot: CE_POINTER [PD_WORDNODE_S] assign set_si_prefroot
		do
			create Result.make_shared (c_si_prefroot (c_pointer))
		end

	si_sugtree: INTEGER_32 assign set_si_sugtree
		do
			Result := c_si_sugtree (c_pointer)
		end

	si_blocks: CE_POINTER [PD_SBLOCK_S] assign set_si_blocks
		do
			create Result.make_shared (c_si_blocks (c_pointer))
		end

	si_blocks_cnt: INTEGER_32 assign set_si_blocks_cnt
		do
			Result := c_si_blocks_cnt (c_pointer)
		end

	si_compress_cnt: INTEGER_32 assign set_si_compress_cnt
		do
			Result := c_si_compress_cnt (c_pointer)
		end

	si_first_free: CE_POINTER [PD_WORDNODE_S] assign set_si_first_free
		do
			create Result.make_shared (c_si_first_free (c_pointer))
		end

	si_free_count: INTEGER_32 assign set_si_free_count
		do
			Result := c_si_free_count (c_pointer)
		end

	si_spellbuf: CE_POINTER [PD_FILE_BUFFER] assign set_si_spellbuf
		do
			create Result.make_shared (c_si_spellbuf (c_pointer))
		end

	si_ascii: INTEGER_32 assign set_si_ascii
		do
			Result := c_si_ascii (c_pointer)
		end

	si_add: INTEGER_32 assign set_si_add
		do
			Result := c_si_add (c_pointer)
		end

	si_clear_chartab: INTEGER_32 assign set_si_clear_chartab
		do
			Result := c_si_clear_chartab (c_pointer)
		end

	si_region: INTEGER_32 assign set_si_region
		do
			Result := c_si_region (c_pointer)
		end

	si_conv: PD_VIMCONV_T assign set_si_conv
		do
			create Result.make_shared (c_si_conv (c_pointer))
		end

	si_conv_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct spellinfo_S, si_conv);"
		end

	si_memtot: INTEGER_32 assign set_si_memtot
		do
			Result := c_si_memtot (c_pointer)
		end

	si_verbose: INTEGER_32 assign set_si_verbose
		do
			Result := c_si_verbose (c_pointer)
		end

	si_msg_count: INTEGER_32 assign set_si_msg_count
		do
			Result := c_si_msg_count (c_pointer)
		end

	si_info: CE_POINTER [NATURAL_8] assign set_si_info
		do
			create Result.make_shared (c_si_info (c_pointer))
		end

	si_region_count: INTEGER_32 assign set_si_region_count
		do
			Result := c_si_region_count (c_pointer)
		end

	si_region_name: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_si_region_name (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	si_rep: PD_GROWARRAY assign set_si_rep
		do
			create Result.make_shared (c_si_rep (c_pointer))
		end

	si_rep_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct spellinfo_S, si_rep);"
		end

	si_repsal: PD_GROWARRAY assign set_si_repsal
		do
			create Result.make_shared (c_si_repsal (c_pointer))
		end

	si_repsal_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct spellinfo_S, si_repsal);"
		end

	si_sal: PD_GROWARRAY assign set_si_sal
		do
			create Result.make_shared (c_si_sal (c_pointer))
		end

	si_sal_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct spellinfo_S, si_sal);"
		end

	si_sofofr: CE_POINTER [NATURAL_8] assign set_si_sofofr
		do
			create Result.make_shared (c_si_sofofr (c_pointer))
		end

	si_sofoto: CE_POINTER [NATURAL_8] assign set_si_sofoto
		do
			create Result.make_shared (c_si_sofoto (c_pointer))
		end

	si_nosugfile: INTEGER_32 assign set_si_nosugfile
		do
			Result := c_si_nosugfile (c_pointer)
		end

	si_nosplitsugs: INTEGER_32 assign set_si_nosplitsugs
		do
			Result := c_si_nosplitsugs (c_pointer)
		end

	si_followup: INTEGER_32 assign set_si_followup
		do
			Result := c_si_followup (c_pointer)
		end

	si_collapse: INTEGER_32 assign set_si_collapse
		do
			Result := c_si_collapse (c_pointer)
		end

	si_commonwords: PD_HASHTABLE_S assign set_si_commonwords
		do
			create Result.make_shared (c_si_commonwords (c_pointer))
		end

	si_commonwords_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct spellinfo_S, si_commonwords);"
		end

	si_sugtime: INTEGER_32 assign set_si_sugtime
		do
			Result := c_si_sugtime (c_pointer)
		end

	si_rem_accents: INTEGER_32 assign set_si_rem_accents
		do
			Result := c_si_rem_accents (c_pointer)
		end

	si_map: PD_GROWARRAY assign set_si_map
		do
			create Result.make_shared (c_si_map (c_pointer))
		end

	si_map_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct spellinfo_S, si_map);"
		end

	si_midword: CE_POINTER [NATURAL_8] assign set_si_midword
		do
			create Result.make_shared (c_si_midword (c_pointer))
		end

	si_compmax: INTEGER_32 assign set_si_compmax
		do
			Result := c_si_compmax (c_pointer)
		end

	si_compminlen: INTEGER_32 assign set_si_compminlen
		do
			Result := c_si_compminlen (c_pointer)
		end

	si_compsylmax: INTEGER_32 assign set_si_compsylmax
		do
			Result := c_si_compsylmax (c_pointer)
		end

	si_compoptions: INTEGER_32 assign set_si_compoptions
		do
			Result := c_si_compoptions (c_pointer)
		end

	si_comppat: PD_GROWARRAY assign set_si_comppat
		do
			create Result.make_shared (c_si_comppat (c_pointer))
		end

	si_comppat_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct spellinfo_S, si_comppat);"
		end

	si_compflags: CE_POINTER [NATURAL_8] assign set_si_compflags
		do
			create Result.make_shared (c_si_compflags (c_pointer))
		end

	si_nobreak: NATURAL_8 assign set_si_nobreak
		do
			Result := c_si_nobreak (c_pointer)
		end

	si_syllable: CE_POINTER [NATURAL_8] assign set_si_syllable
		do
			create Result.make_shared (c_si_syllable (c_pointer))
		end

	si_prefcond: PD_GROWARRAY assign set_si_prefcond
		do
			create Result.make_shared (c_si_prefcond (c_pointer))
		end

	si_prefcond_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct spellinfo_S, si_prefcond);"
		end

	si_newprefID: INTEGER_32 assign set_si_newprefID
		do
			Result := c_si_newprefID (c_pointer)
		end

	si_newcompID: INTEGER_32 assign set_si_newcompID
		do
			Result := c_si_newcompID (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_si_foldroot (a_si_foldroot: CE_POINTER [PD_WORDNODE_S])
		do
			c_set_si_foldroot (c_pointer, a_si_foldroot.c_pointer)
		end

	set_si_foldwcount (a_si_foldwcount: INTEGER_32)
		do
			c_set_si_foldwcount (c_pointer, a_si_foldwcount)
		end

	set_si_keeproot (a_si_keeproot: CE_POINTER [PD_WORDNODE_S])
		do
			c_set_si_keeproot (c_pointer, a_si_keeproot.c_pointer)
		end

	set_si_keepwcount (a_si_keepwcount: INTEGER_32)
		do
			c_set_si_keepwcount (c_pointer, a_si_keepwcount)
		end

	set_si_prefroot (a_si_prefroot: CE_POINTER [PD_WORDNODE_S])
		do
			c_set_si_prefroot (c_pointer, a_si_prefroot.c_pointer)
		end

	set_si_sugtree (a_si_sugtree: INTEGER_32)
		do
			c_set_si_sugtree (c_pointer, a_si_sugtree)
		end

	set_si_blocks (a_si_blocks: CE_POINTER [PD_SBLOCK_S])
		do
			c_set_si_blocks (c_pointer, a_si_blocks.c_pointer)
		end

	set_si_blocks_cnt (a_si_blocks_cnt: INTEGER_32)
		do
			c_set_si_blocks_cnt (c_pointer, a_si_blocks_cnt)
		end

	set_si_compress_cnt (a_si_compress_cnt: INTEGER_32)
		do
			c_set_si_compress_cnt (c_pointer, a_si_compress_cnt)
		end

	set_si_first_free (a_si_first_free: CE_POINTER [PD_WORDNODE_S])
		do
			c_set_si_first_free (c_pointer, a_si_first_free.c_pointer)
		end

	set_si_free_count (a_si_free_count: INTEGER_32)
		do
			c_set_si_free_count (c_pointer, a_si_free_count)
		end

	set_si_spellbuf (a_si_spellbuf: CE_POINTER [PD_FILE_BUFFER])
		do
			c_set_si_spellbuf (c_pointer, a_si_spellbuf.c_pointer)
		end

	set_si_ascii (a_si_ascii: INTEGER_32)
		do
			c_set_si_ascii (c_pointer, a_si_ascii)
		end

	set_si_add (a_si_add: INTEGER_32)
		do
			c_set_si_add (c_pointer, a_si_add)
		end

	set_si_clear_chartab (a_si_clear_chartab: INTEGER_32)
		do
			c_set_si_clear_chartab (c_pointer, a_si_clear_chartab)
		end

	set_si_region (a_si_region: INTEGER_32)
		do
			c_set_si_region (c_pointer, a_si_region)
		end

	set_si_conv (a_si_conv: PD_VIMCONV_T)
		do
			si_conv.ce_gets (a_si_conv)
		end

	set_si_memtot (a_si_memtot: INTEGER_32)
		do
			c_set_si_memtot (c_pointer, a_si_memtot)
		end

	set_si_verbose (a_si_verbose: INTEGER_32)
		do
			c_set_si_verbose (c_pointer, a_si_verbose)
		end

	set_si_msg_count (a_si_msg_count: INTEGER_32)
		do
			c_set_si_msg_count (c_pointer, a_si_msg_count)
		end

	set_si_info (a_si_info: CE_POINTER [NATURAL_8])
		do
			c_set_si_info (c_pointer, a_si_info.c_pointer)
		end

	set_si_region_count (a_si_region_count: INTEGER_32)
		do
			c_set_si_region_count (c_pointer, a_si_region_count)
		end

	set_si_rep (a_si_rep: PD_GROWARRAY)
		do
			si_rep.ce_gets (a_si_rep)
		end

	set_si_repsal (a_si_repsal: PD_GROWARRAY)
		do
			si_repsal.ce_gets (a_si_repsal)
		end

	set_si_sal (a_si_sal: PD_GROWARRAY)
		do
			si_sal.ce_gets (a_si_sal)
		end

	set_si_sofofr (a_si_sofofr: CE_POINTER [NATURAL_8])
		do
			c_set_si_sofofr (c_pointer, a_si_sofofr.c_pointer)
		end

	set_si_sofoto (a_si_sofoto: CE_POINTER [NATURAL_8])
		do
			c_set_si_sofoto (c_pointer, a_si_sofoto.c_pointer)
		end

	set_si_nosugfile (a_si_nosugfile: INTEGER_32)
		do
			c_set_si_nosugfile (c_pointer, a_si_nosugfile)
		end

	set_si_nosplitsugs (a_si_nosplitsugs: INTEGER_32)
		do
			c_set_si_nosplitsugs (c_pointer, a_si_nosplitsugs)
		end

	set_si_followup (a_si_followup: INTEGER_32)
		do
			c_set_si_followup (c_pointer, a_si_followup)
		end

	set_si_collapse (a_si_collapse: INTEGER_32)
		do
			c_set_si_collapse (c_pointer, a_si_collapse)
		end

	set_si_commonwords (a_si_commonwords: PD_HASHTABLE_S)
		do
			si_commonwords.ce_gets (a_si_commonwords)
		end

	set_si_sugtime (a_si_sugtime: INTEGER_32)
		do
			c_set_si_sugtime (c_pointer, a_si_sugtime)
		end

	set_si_rem_accents (a_si_rem_accents: INTEGER_32)
		do
			c_set_si_rem_accents (c_pointer, a_si_rem_accents)
		end

	set_si_map (a_si_map: PD_GROWARRAY)
		do
			si_map.ce_gets (a_si_map)
		end

	set_si_midword (a_si_midword: CE_POINTER [NATURAL_8])
		do
			c_set_si_midword (c_pointer, a_si_midword.c_pointer)
		end

	set_si_compmax (a_si_compmax: INTEGER_32)
		do
			c_set_si_compmax (c_pointer, a_si_compmax)
		end

	set_si_compminlen (a_si_compminlen: INTEGER_32)
		do
			c_set_si_compminlen (c_pointer, a_si_compminlen)
		end

	set_si_compsylmax (a_si_compsylmax: INTEGER_32)
		do
			c_set_si_compsylmax (c_pointer, a_si_compsylmax)
		end

	set_si_compoptions (a_si_compoptions: INTEGER_32)
		do
			c_set_si_compoptions (c_pointer, a_si_compoptions)
		end

	set_si_comppat (a_si_comppat: PD_GROWARRAY)
		do
			si_comppat.ce_gets (a_si_comppat)
		end

	set_si_compflags (a_si_compflags: CE_POINTER [NATURAL_8])
		do
			c_set_si_compflags (c_pointer, a_si_compflags.c_pointer)
		end

	set_si_nobreak (a_si_nobreak: NATURAL_8)
		do
			c_set_si_nobreak (c_pointer, a_si_nobreak)
		end

	set_si_syllable (a_si_syllable: CE_POINTER [NATURAL_8])
		do
			c_set_si_syllable (c_pointer, a_si_syllable.c_pointer)
		end

	set_si_prefcond (a_si_prefcond: PD_GROWARRAY)
		do
			si_prefcond.ce_gets (a_si_prefcond)
		end

	set_si_newprefID (a_si_newprefID: INTEGER_32)
		do
			c_set_si_newprefID (c_pointer, a_si_newprefID)
		end

	set_si_newcompID (a_si_newcompID: INTEGER_32)
		do
			c_set_si_newcompID (c_pointer, a_si_newcompID)
		end

feature {NONE} -- C getters

	c_si_foldroot (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct wordnode_S *)((struct spellinfo_S *)$tmp)->si_foldroot;"
		end

	c_si_foldwcount (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct spellinfo_S *)$tmp)->si_foldwcount;"
		end

	c_si_keeproot (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct wordnode_S *)((struct spellinfo_S *)$tmp)->si_keeproot;"
		end

	c_si_keepwcount (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct spellinfo_S *)$tmp)->si_keepwcount;"
		end

	c_si_prefroot (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct wordnode_S *)((struct spellinfo_S *)$tmp)->si_prefroot;"
		end

	c_si_sugtree (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct spellinfo_S *)$tmp)->si_sugtree;"
		end

	c_si_blocks (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct sblock_S *)((struct spellinfo_S *)$tmp)->si_blocks;"
		end

	c_si_blocks_cnt (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct spellinfo_S *)$tmp)->si_blocks_cnt;"
		end

	c_si_compress_cnt (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct spellinfo_S *)$tmp)->si_compress_cnt;"
		end

	c_si_first_free (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct wordnode_S *)((struct spellinfo_S *)$tmp)->si_first_free;"
		end

	c_si_free_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct spellinfo_S *)$tmp)->si_free_count;"
		end

	c_si_spellbuf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct file_buffer *)((struct spellinfo_S *)$tmp)->si_spellbuf;"
		end

	c_si_ascii (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct spellinfo_S *)$tmp)->si_ascii;"
		end

	c_si_add (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct spellinfo_S *)$tmp)->si_add;"
		end

	c_si_clear_chartab (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct spellinfo_S *)$tmp)->si_clear_chartab;"
		end

	c_si_region (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct spellinfo_S *)$tmp)->si_region;"
		end

	c_si_conv (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (vimconv_T *)&((struct spellinfo_S *)$tmp)->si_conv;"
		end

	c_si_memtot (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct spellinfo_S *)$tmp)->si_memtot;"
		end

	c_si_verbose (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct spellinfo_S *)$tmp)->si_verbose;"
		end

	c_si_msg_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct spellinfo_S *)$tmp)->si_msg_count;"
		end

	c_si_info (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct spellinfo_S *)$tmp)->si_info;"
		end

	c_si_region_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct spellinfo_S *)$tmp)->si_region_count;"
		end

	c_si_region_name (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct spellinfo_S *tmp = (struct spellinfo_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->si_region_name) / sizeof(tmp->si_region_name[0]);
				return tmp->si_region_name;
			]"
		end

	c_si_rep (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct growarray *)&((struct spellinfo_S *)$tmp)->si_rep;"
		end

	c_si_repsal (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct growarray *)&((struct spellinfo_S *)$tmp)->si_repsal;"
		end

	c_si_sal (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct growarray *)&((struct spellinfo_S *)$tmp)->si_sal;"
		end

	c_si_sofofr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct spellinfo_S *)$tmp)->si_sofofr;"
		end

	c_si_sofoto (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct spellinfo_S *)$tmp)->si_sofoto;"
		end

	c_si_nosugfile (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct spellinfo_S *)$tmp)->si_nosugfile;"
		end

	c_si_nosplitsugs (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct spellinfo_S *)$tmp)->si_nosplitsugs;"
		end

	c_si_followup (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct spellinfo_S *)$tmp)->si_followup;"
		end

	c_si_collapse (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct spellinfo_S *)$tmp)->si_collapse;"
		end

	c_si_commonwords (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct hashtable_S *)&((struct spellinfo_S *)$tmp)->si_commonwords;"
		end

	c_si_sugtime (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct spellinfo_S *)$tmp)->si_sugtime;"
		end

	c_si_rem_accents (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct spellinfo_S *)$tmp)->si_rem_accents;"
		end

	c_si_map (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct growarray *)&((struct spellinfo_S *)$tmp)->si_map;"
		end

	c_si_midword (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct spellinfo_S *)$tmp)->si_midword;"
		end

	c_si_compmax (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct spellinfo_S *)$tmp)->si_compmax;"
		end

	c_si_compminlen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct spellinfo_S *)$tmp)->si_compminlen;"
		end

	c_si_compsylmax (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct spellinfo_S *)$tmp)->si_compsylmax;"
		end

	c_si_compoptions (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct spellinfo_S *)$tmp)->si_compoptions;"
		end

	c_si_comppat (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct growarray *)&((struct spellinfo_S *)$tmp)->si_comppat;"
		end

	c_si_compflags (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct spellinfo_S *)$tmp)->si_compflags;"
		end

	c_si_nobreak (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct spellinfo_S *)$tmp)->si_nobreak;"
		end

	c_si_syllable (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct spellinfo_S *)$tmp)->si_syllable;"
		end

	c_si_prefcond (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct growarray *)&((struct spellinfo_S *)$tmp)->si_prefcond;"
		end

	c_si_newprefID (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct spellinfo_S *)$tmp)->si_newprefID;"
		end

	c_si_newcompID (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct spellinfo_S *)$tmp)->si_newcompID;"
		end

feature {NONE} -- C setters

	c_set_si_foldroot (tmp: POINTER; a_si_foldroot: POINTER)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_foldroot = (struct wordnode_S *)$a_si_foldroot;"
		end

	c_set_si_foldwcount (tmp: POINTER; a_si_foldwcount: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_foldwcount = $a_si_foldwcount;"
		end

	c_set_si_keeproot (tmp: POINTER; a_si_keeproot: POINTER)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_keeproot = (struct wordnode_S *)$a_si_keeproot;"
		end

	c_set_si_keepwcount (tmp: POINTER; a_si_keepwcount: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_keepwcount = $a_si_keepwcount;"
		end

	c_set_si_prefroot (tmp: POINTER; a_si_prefroot: POINTER)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_prefroot = (struct wordnode_S *)$a_si_prefroot;"
		end

	c_set_si_sugtree (tmp: POINTER; a_si_sugtree: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_sugtree = $a_si_sugtree;"
		end

	c_set_si_blocks (tmp: POINTER; a_si_blocks: POINTER)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_blocks = (struct sblock_S *)$a_si_blocks;"
		end

	c_set_si_blocks_cnt (tmp: POINTER; a_si_blocks_cnt: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_blocks_cnt = $a_si_blocks_cnt;"
		end

	c_set_si_compress_cnt (tmp: POINTER; a_si_compress_cnt: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_compress_cnt = $a_si_compress_cnt;"
		end

	c_set_si_first_free (tmp: POINTER; a_si_first_free: POINTER)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_first_free = (struct wordnode_S *)$a_si_first_free;"
		end

	c_set_si_free_count (tmp: POINTER; a_si_free_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_free_count = $a_si_free_count;"
		end

	c_set_si_spellbuf (tmp: POINTER; a_si_spellbuf: POINTER)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_spellbuf = (struct file_buffer *)$a_si_spellbuf;"
		end

	c_set_si_ascii (tmp: POINTER; a_si_ascii: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_ascii = $a_si_ascii;"
		end

	c_set_si_add (tmp: POINTER; a_si_add: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_add = $a_si_add;"
		end

	c_set_si_clear_chartab (tmp: POINTER; a_si_clear_chartab: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_clear_chartab = $a_si_clear_chartab;"
		end

	c_set_si_region (tmp: POINTER; a_si_region: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_region = $a_si_region;"
		end

	c_set_si_memtot (tmp: POINTER; a_si_memtot: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_memtot = $a_si_memtot;"
		end

	c_set_si_verbose (tmp: POINTER; a_si_verbose: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_verbose = $a_si_verbose;"
		end

	c_set_si_msg_count (tmp: POINTER; a_si_msg_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_msg_count = $a_si_msg_count;"
		end

	c_set_si_info (tmp: POINTER; a_si_info: POINTER)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_info = (unsigned char *)$a_si_info;"
		end

	c_set_si_region_count (tmp: POINTER; a_si_region_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_region_count = $a_si_region_count;"
		end

	c_set_si_sofofr (tmp: POINTER; a_si_sofofr: POINTER)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_sofofr = (unsigned char *)$a_si_sofofr;"
		end

	c_set_si_sofoto (tmp: POINTER; a_si_sofoto: POINTER)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_sofoto = (unsigned char *)$a_si_sofoto;"
		end

	c_set_si_nosugfile (tmp: POINTER; a_si_nosugfile: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_nosugfile = $a_si_nosugfile;"
		end

	c_set_si_nosplitsugs (tmp: POINTER; a_si_nosplitsugs: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_nosplitsugs = $a_si_nosplitsugs;"
		end

	c_set_si_followup (tmp: POINTER; a_si_followup: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_followup = $a_si_followup;"
		end

	c_set_si_collapse (tmp: POINTER; a_si_collapse: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_collapse = $a_si_collapse;"
		end

	c_set_si_sugtime (tmp: POINTER; a_si_sugtime: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_sugtime = $a_si_sugtime;"
		end

	c_set_si_rem_accents (tmp: POINTER; a_si_rem_accents: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_rem_accents = $a_si_rem_accents;"
		end

	c_set_si_midword (tmp: POINTER; a_si_midword: POINTER)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_midword = (unsigned char *)$a_si_midword;"
		end

	c_set_si_compmax (tmp: POINTER; a_si_compmax: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_compmax = $a_si_compmax;"
		end

	c_set_si_compminlen (tmp: POINTER; a_si_compminlen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_compminlen = $a_si_compminlen;"
		end

	c_set_si_compsylmax (tmp: POINTER; a_si_compsylmax: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_compsylmax = $a_si_compsylmax;"
		end

	c_set_si_compoptions (tmp: POINTER; a_si_compoptions: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_compoptions = $a_si_compoptions;"
		end

	c_set_si_compflags (tmp: POINTER; a_si_compflags: POINTER)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_compflags = (unsigned char *)$a_si_compflags;"
		end

	c_set_si_nobreak (tmp: POINTER; a_si_nobreak: NATURAL_8)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_nobreak = $a_si_nobreak;"
		end

	c_set_si_syllable (tmp: POINTER; a_si_syllable: POINTER)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_syllable = (unsigned char *)$a_si_syllable;"
		end

	c_set_si_newprefID (tmp: POINTER; a_si_newprefID: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_newprefID = $a_si_newprefid;"
		end

	c_set_si_newcompID (tmp: POINTER; a_si_newcompID: INTEGER_32)
		external
			"C inline"
		alias
			"((struct spellinfo_S *)$tmp)->si_newcompID = $a_si_newcompid;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct spellinfo_S);"
		end

end
