class
	PD_STL_ITEM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	start: CE_POINTER [NATURAL_8] assign set_start
		do
			create Result.make_shared (c_start (c_pointer))
		end

	minwid: INTEGER_32 assign set_minwid
		do
			Result := c_minwid (c_pointer)
		end

	maxwid: INTEGER_32 assign set_maxwid
		do
			Result := c_maxwid (c_pointer)
		end

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_start (a_start: CE_POINTER [NATURAL_8])
		do
			c_set_start (c_pointer, a_start.c_pointer)
		end

	set_minwid (a_minwid: INTEGER_32)
		do
			c_set_minwid (c_pointer, a_minwid)
		end

	set_maxwid (a_maxwid: INTEGER_32)
		do
			c_set_maxwid (c_pointer, a_maxwid)
		end

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

feature {NONE} -- C getters

	c_start (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct stl_item *)$tmp)->start;"
		end

	c_minwid (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct stl_item *)$tmp)->minwid;"
		end

	c_maxwid (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct stl_item *)$tmp)->maxwid;"
		end

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct stl_item *)$tmp)->type;"
		end

feature {NONE} -- C setters

	c_set_start (tmp: POINTER; a_start: POINTER)
		external
			"C inline"
		alias
			"((struct stl_item *)$tmp)->start = (unsigned char *)$a_start;"
		end

	c_set_minwid (tmp: POINTER; a_minwid: INTEGER_32)
		external
			"C inline"
		alias
			"((struct stl_item *)$tmp)->minwid = $a_minwid;"
		end

	c_set_maxwid (tmp: POINTER; a_maxwid: INTEGER_32)
		external
			"C inline"
		alias
			"((struct stl_item *)$tmp)->maxwid = $a_maxwid;"
		end

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct stl_item *)$tmp)->type = $a_type;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct stl_item);"
		end

end
