class
	PD_STRING_NAMES

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	dest: INTEGER_32 assign set_dest
		do
			Result := c_dest (c_pointer)
		end

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_dest (a_dest: INTEGER_32)
		do
			c_set_dest (c_pointer, a_dest)
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

feature {NONE} -- C getters

	c_dest (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_string_names_543 *)$tmp)->dest;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_string_names_543 *)$tmp)->name;"
		end

feature {NONE} -- C setters

	c_set_dest (tmp: POINTER; a_dest: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_string_names_543 *)$tmp)->dest = $a_dest;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_string_names_543 *)$tmp)->name = (char *)$a_name;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_string_names_543);"
		end

end
