class
	PD_SYN_CLUSTER_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	scl_name: CE_POINTER [NATURAL_8] assign set_scl_name
		do
			create Result.make_shared (c_scl_name (c_pointer))
		end

	scl_name_u: CE_POINTER [NATURAL_8] assign set_scl_name_u
		do
			create Result.make_shared (c_scl_name_u (c_pointer))
		end

	scl_list: CE_POINTER [INTEGER_16] assign set_scl_list
		do
			create Result.make_shared (c_scl_list (c_pointer))
		end

	scl_list_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct syn_cluster_S, scl_list);"
		end

feature {ANY} -- Eiffel setters

	set_scl_name (a_scl_name: CE_POINTER [NATURAL_8])
		do
			c_set_scl_name (c_pointer, a_scl_name.c_pointer)
		end

	set_scl_name_u (a_scl_name_u: CE_POINTER [NATURAL_8])
		do
			c_set_scl_name_u (c_pointer, a_scl_name_u.c_pointer)
		end

	set_scl_list (a_scl_list: CE_POINTER [INTEGER_16])
		do
			c_set_scl_list (c_pointer, a_scl_list.c_pointer)
		end

feature {NONE} -- C getters

	c_scl_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct syn_cluster_S *)$tmp)->scl_name;"
		end

	c_scl_name_u (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct syn_cluster_S *)$tmp)->scl_name_u;"
		end

	c_scl_list (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (short *)((struct syn_cluster_S *)$tmp)->scl_list;"
		end

feature {NONE} -- C setters

	c_set_scl_name (tmp: POINTER; a_scl_name: POINTER)
		external
			"C inline"
		alias
			"((struct syn_cluster_S *)$tmp)->scl_name = (unsigned char *)$a_scl_name;"
		end

	c_set_scl_name_u (tmp: POINTER; a_scl_name_u: POINTER)
		external
			"C inline"
		alias
			"((struct syn_cluster_S *)$tmp)->scl_name_u = (unsigned char *)$a_scl_name_u;"
		end

	c_set_scl_list (tmp: POINTER; a_scl_list: POINTER)
		external
			"C inline"
		alias
			"((struct syn_cluster_S *)$tmp)->scl_list = (short *)$a_scl_list;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct syn_cluster_S);"
		end

end
