class
	PD_TAGNAME_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	tn_tags: CE_POINTER [NATURAL_8] assign set_tn_tags
		do
			create Result.make_shared (c_tn_tags (c_pointer))
		end

	tn_np: CE_POINTER [NATURAL_8] assign set_tn_np
		do
			create Result.make_shared (c_tn_np (c_pointer))
		end

	tn_np_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_tagname_T_541, tn_np);"
		end

	tn_did_filefind_init: INTEGER_32 assign set_tn_did_filefind_init
		do
			Result := c_tn_did_filefind_init (c_pointer)
		end

	tn_hf_idx: INTEGER_32 assign set_tn_hf_idx
		do
			Result := c_tn_hf_idx (c_pointer)
		end

	tn_search_ctx: CE_POINTER [ANY] assign set_tn_search_ctx
		do
			create Result.make_shared (c_tn_search_ctx (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_tn_tags (a_tn_tags: CE_POINTER [NATURAL_8])
		do
			c_set_tn_tags (c_pointer, a_tn_tags.c_pointer)
		end

	set_tn_np (a_tn_np: CE_POINTER [NATURAL_8])
		do
			c_set_tn_np (c_pointer, a_tn_np.c_pointer)
		end

	set_tn_did_filefind_init (a_tn_did_filefind_init: INTEGER_32)
		do
			c_set_tn_did_filefind_init (c_pointer, a_tn_did_filefind_init)
		end

	set_tn_hf_idx (a_tn_hf_idx: INTEGER_32)
		do
			c_set_tn_hf_idx (c_pointer, a_tn_hf_idx)
		end

	set_tn_search_ctx (a_tn_search_ctx: CE_POINTER [ANY])
		do
			c_set_tn_search_ctx (c_pointer, a_tn_search_ctx.c_pointer)
		end

feature {NONE} -- C getters

	c_tn_tags (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_tagname_T_541 *)$tmp)->tn_tags;"
		end

	c_tn_np (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_tagname_T_541 *)$tmp)->tn_np;"
		end

	c_tn_did_filefind_init (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_tagname_T_541 *)$tmp)->tn_did_filefind_init;"
		end

	c_tn_hf_idx (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_tagname_T_541 *)$tmp)->tn_hf_idx;"
		end

	c_tn_search_ctx (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_tagname_T_541 *)$tmp)->tn_search_ctx;"
		end

feature {NONE} -- C setters

	c_set_tn_tags (tmp: POINTER; a_tn_tags: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_tagname_T_541 *)$tmp)->tn_tags = (unsigned char *)$a_tn_tags;"
		end

	c_set_tn_np (tmp: POINTER; a_tn_np: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_tagname_T_541 *)$tmp)->tn_np = (unsigned char *)$a_tn_np;"
		end

	c_set_tn_did_filefind_init (tmp: POINTER; a_tn_did_filefind_init: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_tagname_T_541 *)$tmp)->tn_did_filefind_init = $a_tn_did_filefind_init;"
		end

	c_set_tn_hf_idx (tmp: POINTER; a_tn_hf_idx: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_tagname_T_541 *)$tmp)->tn_hf_idx = $a_tn_hf_idx;"
		end

	c_set_tn_search_ctx (tmp: POINTER; a_tn_search_ctx: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_tagname_T_541 *)$tmp)->tn_search_ctx = (void *)$a_tn_search_ctx;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_tagname_T_541);"
		end

end
