class
	PD_TERM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	start: CE_POINTER [NATURAL_8] assign set_start
		do
			create Result.make_shared (c_start (c_pointer))
		end

	stop: CE_POINTER [NATURAL_8] assign set_stop
		do
			create Result.make_shared (c_stop (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_start (a_start: CE_POINTER [NATURAL_8])
		do
			c_set_start (c_pointer, a_start.c_pointer)
		end

	set_stop (a_stop: CE_POINTER [NATURAL_8])
		do
			c_set_stop (c_pointer, a_stop.c_pointer)
		end

feature {NONE} -- C getters

	c_start (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_term_525 *)$tmp)->start;"
		end

	c_stop (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_term_525 *)$tmp)->stop;"
		end

feature {NONE} -- C setters

	c_set_start (tmp: POINTER; a_start: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_term_525 *)$tmp)->start = (unsigned char *)$a_start;"
		end

	c_set_stop (tmp: POINTER; a_stop: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_term_525 *)$tmp)->stop = (unsigned char *)$a_stop;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_term_525);"
		end

end
