class
	PD_TRYSTATE_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ts_state: INTEGER_32 assign set_ts_state
		do
			Result := c_ts_state (c_pointer)
		end

	ts_score: INTEGER_32 assign set_ts_score
		do
			Result := c_ts_score (c_pointer)
		end

	ts_arridx: INTEGER_32 assign set_ts_arridx
		do
			Result := c_ts_arridx (c_pointer)
		end

	ts_curi: INTEGER_16 assign set_ts_curi
		do
			Result := c_ts_curi (c_pointer)
		end

	ts_fidx: NATURAL_8 assign set_ts_fidx
		do
			Result := c_ts_fidx (c_pointer)
		end

	ts_fidxtry: NATURAL_8 assign set_ts_fidxtry
		do
			Result := c_ts_fidxtry (c_pointer)
		end

	ts_twordlen: NATURAL_8 assign set_ts_twordlen
		do
			Result := c_ts_twordlen (c_pointer)
		end

	ts_prefixdepth: NATURAL_8 assign set_ts_prefixdepth
		do
			Result := c_ts_prefixdepth (c_pointer)
		end

	ts_flags: NATURAL_8 assign set_ts_flags
		do
			Result := c_ts_flags (c_pointer)
		end

	ts_tcharlen: NATURAL_8 assign set_ts_tcharlen
		do
			Result := c_ts_tcharlen (c_pointer)
		end

	ts_tcharidx: NATURAL_8 assign set_ts_tcharidx
		do
			Result := c_ts_tcharidx (c_pointer)
		end

	ts_isdiff: NATURAL_8 assign set_ts_isdiff
		do
			Result := c_ts_isdiff (c_pointer)
		end

	ts_fcharstart: NATURAL_8 assign set_ts_fcharstart
		do
			Result := c_ts_fcharstart (c_pointer)
		end

	ts_prewordlen: NATURAL_8 assign set_ts_prewordlen
		do
			Result := c_ts_prewordlen (c_pointer)
		end

	ts_splitoff: NATURAL_8 assign set_ts_splitoff
		do
			Result := c_ts_splitoff (c_pointer)
		end

	ts_splitfidx: NATURAL_8 assign set_ts_splitfidx
		do
			Result := c_ts_splitfidx (c_pointer)
		end

	ts_complen: NATURAL_8 assign set_ts_complen
		do
			Result := c_ts_complen (c_pointer)
		end

	ts_compsplit: NATURAL_8 assign set_ts_compsplit
		do
			Result := c_ts_compsplit (c_pointer)
		end

	ts_save_badflags: NATURAL_8 assign set_ts_save_badflags
		do
			Result := c_ts_save_badflags (c_pointer)
		end

	ts_delidx: NATURAL_8 assign set_ts_delidx
		do
			Result := c_ts_delidx (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_ts_state (a_ts_state: INTEGER_32)
		do
			c_set_ts_state (c_pointer, a_ts_state)
		end

	set_ts_score (a_ts_score: INTEGER_32)
		do
			c_set_ts_score (c_pointer, a_ts_score)
		end

	set_ts_arridx (a_ts_arridx: INTEGER_32)
		do
			c_set_ts_arridx (c_pointer, a_ts_arridx)
		end

	set_ts_curi (a_ts_curi: INTEGER_16)
		do
			c_set_ts_curi (c_pointer, a_ts_curi)
		end

	set_ts_fidx (a_ts_fidx: NATURAL_8)
		do
			c_set_ts_fidx (c_pointer, a_ts_fidx)
		end

	set_ts_fidxtry (a_ts_fidxtry: NATURAL_8)
		do
			c_set_ts_fidxtry (c_pointer, a_ts_fidxtry)
		end

	set_ts_twordlen (a_ts_twordlen: NATURAL_8)
		do
			c_set_ts_twordlen (c_pointer, a_ts_twordlen)
		end

	set_ts_prefixdepth (a_ts_prefixdepth: NATURAL_8)
		do
			c_set_ts_prefixdepth (c_pointer, a_ts_prefixdepth)
		end

	set_ts_flags (a_ts_flags: NATURAL_8)
		do
			c_set_ts_flags (c_pointer, a_ts_flags)
		end

	set_ts_tcharlen (a_ts_tcharlen: NATURAL_8)
		do
			c_set_ts_tcharlen (c_pointer, a_ts_tcharlen)
		end

	set_ts_tcharidx (a_ts_tcharidx: NATURAL_8)
		do
			c_set_ts_tcharidx (c_pointer, a_ts_tcharidx)
		end

	set_ts_isdiff (a_ts_isdiff: NATURAL_8)
		do
			c_set_ts_isdiff (c_pointer, a_ts_isdiff)
		end

	set_ts_fcharstart (a_ts_fcharstart: NATURAL_8)
		do
			c_set_ts_fcharstart (c_pointer, a_ts_fcharstart)
		end

	set_ts_prewordlen (a_ts_prewordlen: NATURAL_8)
		do
			c_set_ts_prewordlen (c_pointer, a_ts_prewordlen)
		end

	set_ts_splitoff (a_ts_splitoff: NATURAL_8)
		do
			c_set_ts_splitoff (c_pointer, a_ts_splitoff)
		end

	set_ts_splitfidx (a_ts_splitfidx: NATURAL_8)
		do
			c_set_ts_splitfidx (c_pointer, a_ts_splitfidx)
		end

	set_ts_complen (a_ts_complen: NATURAL_8)
		do
			c_set_ts_complen (c_pointer, a_ts_complen)
		end

	set_ts_compsplit (a_ts_compsplit: NATURAL_8)
		do
			c_set_ts_compsplit (c_pointer, a_ts_compsplit)
		end

	set_ts_save_badflags (a_ts_save_badflags: NATURAL_8)
		do
			c_set_ts_save_badflags (c_pointer, a_ts_save_badflags)
		end

	set_ts_delidx (a_ts_delidx: NATURAL_8)
		do
			c_set_ts_delidx (c_pointer, a_ts_delidx)
		end

feature {NONE} -- C getters

	c_ts_state (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct trystate_S *)$tmp)->ts_state;"
		end

	c_ts_score (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct trystate_S *)$tmp)->ts_score;"
		end

	c_ts_arridx (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct trystate_S *)$tmp)->ts_arridx;"
		end

	c_ts_curi (tmp: POINTER): INTEGER_16
		external
			"C inline"
		alias
			"return (short)((struct trystate_S *)$tmp)->ts_curi;"
		end

	c_ts_fidx (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct trystate_S *)$tmp)->ts_fidx;"
		end

	c_ts_fidxtry (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct trystate_S *)$tmp)->ts_fidxtry;"
		end

	c_ts_twordlen (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct trystate_S *)$tmp)->ts_twordlen;"
		end

	c_ts_prefixdepth (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct trystate_S *)$tmp)->ts_prefixdepth;"
		end

	c_ts_flags (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct trystate_S *)$tmp)->ts_flags;"
		end

	c_ts_tcharlen (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct trystate_S *)$tmp)->ts_tcharlen;"
		end

	c_ts_tcharidx (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct trystate_S *)$tmp)->ts_tcharidx;"
		end

	c_ts_isdiff (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct trystate_S *)$tmp)->ts_isdiff;"
		end

	c_ts_fcharstart (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct trystate_S *)$tmp)->ts_fcharstart;"
		end

	c_ts_prewordlen (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct trystate_S *)$tmp)->ts_prewordlen;"
		end

	c_ts_splitoff (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct trystate_S *)$tmp)->ts_splitoff;"
		end

	c_ts_splitfidx (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct trystate_S *)$tmp)->ts_splitfidx;"
		end

	c_ts_complen (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct trystate_S *)$tmp)->ts_complen;"
		end

	c_ts_compsplit (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct trystate_S *)$tmp)->ts_compsplit;"
		end

	c_ts_save_badflags (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct trystate_S *)$tmp)->ts_save_badflags;"
		end

	c_ts_delidx (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct trystate_S *)$tmp)->ts_delidx;"
		end

feature {NONE} -- C setters

	c_set_ts_state (tmp: POINTER; a_ts_state: INTEGER_32)
		external
			"C inline"
		alias
			"((struct trystate_S *)$tmp)->ts_state = $a_ts_state;"
		end

	c_set_ts_score (tmp: POINTER; a_ts_score: INTEGER_32)
		external
			"C inline"
		alias
			"((struct trystate_S *)$tmp)->ts_score = $a_ts_score;"
		end

	c_set_ts_arridx (tmp: POINTER; a_ts_arridx: INTEGER_32)
		external
			"C inline"
		alias
			"((struct trystate_S *)$tmp)->ts_arridx = $a_ts_arridx;"
		end

	c_set_ts_curi (tmp: POINTER; a_ts_curi: INTEGER_16)
		external
			"C inline"
		alias
			"((struct trystate_S *)$tmp)->ts_curi = $a_ts_curi;"
		end

	c_set_ts_fidx (tmp: POINTER; a_ts_fidx: NATURAL_8)
		external
			"C inline"
		alias
			"((struct trystate_S *)$tmp)->ts_fidx = $a_ts_fidx;"
		end

	c_set_ts_fidxtry (tmp: POINTER; a_ts_fidxtry: NATURAL_8)
		external
			"C inline"
		alias
			"((struct trystate_S *)$tmp)->ts_fidxtry = $a_ts_fidxtry;"
		end

	c_set_ts_twordlen (tmp: POINTER; a_ts_twordlen: NATURAL_8)
		external
			"C inline"
		alias
			"((struct trystate_S *)$tmp)->ts_twordlen = $a_ts_twordlen;"
		end

	c_set_ts_prefixdepth (tmp: POINTER; a_ts_prefixdepth: NATURAL_8)
		external
			"C inline"
		alias
			"((struct trystate_S *)$tmp)->ts_prefixdepth = $a_ts_prefixdepth;"
		end

	c_set_ts_flags (tmp: POINTER; a_ts_flags: NATURAL_8)
		external
			"C inline"
		alias
			"((struct trystate_S *)$tmp)->ts_flags = $a_ts_flags;"
		end

	c_set_ts_tcharlen (tmp: POINTER; a_ts_tcharlen: NATURAL_8)
		external
			"C inline"
		alias
			"((struct trystate_S *)$tmp)->ts_tcharlen = $a_ts_tcharlen;"
		end

	c_set_ts_tcharidx (tmp: POINTER; a_ts_tcharidx: NATURAL_8)
		external
			"C inline"
		alias
			"((struct trystate_S *)$tmp)->ts_tcharidx = $a_ts_tcharidx;"
		end

	c_set_ts_isdiff (tmp: POINTER; a_ts_isdiff: NATURAL_8)
		external
			"C inline"
		alias
			"((struct trystate_S *)$tmp)->ts_isdiff = $a_ts_isdiff;"
		end

	c_set_ts_fcharstart (tmp: POINTER; a_ts_fcharstart: NATURAL_8)
		external
			"C inline"
		alias
			"((struct trystate_S *)$tmp)->ts_fcharstart = $a_ts_fcharstart;"
		end

	c_set_ts_prewordlen (tmp: POINTER; a_ts_prewordlen: NATURAL_8)
		external
			"C inline"
		alias
			"((struct trystate_S *)$tmp)->ts_prewordlen = $a_ts_prewordlen;"
		end

	c_set_ts_splitoff (tmp: POINTER; a_ts_splitoff: NATURAL_8)
		external
			"C inline"
		alias
			"((struct trystate_S *)$tmp)->ts_splitoff = $a_ts_splitoff;"
		end

	c_set_ts_splitfidx (tmp: POINTER; a_ts_splitfidx: NATURAL_8)
		external
			"C inline"
		alias
			"((struct trystate_S *)$tmp)->ts_splitfidx = $a_ts_splitfidx;"
		end

	c_set_ts_complen (tmp: POINTER; a_ts_complen: NATURAL_8)
		external
			"C inline"
		alias
			"((struct trystate_S *)$tmp)->ts_complen = $a_ts_complen;"
		end

	c_set_ts_compsplit (tmp: POINTER; a_ts_compsplit: NATURAL_8)
		external
			"C inline"
		alias
			"((struct trystate_S *)$tmp)->ts_compsplit = $a_ts_compsplit;"
		end

	c_set_ts_save_badflags (tmp: POINTER; a_ts_save_badflags: NATURAL_8)
		external
			"C inline"
		alias
			"((struct trystate_S *)$tmp)->ts_save_badflags = $a_ts_save_badflags;"
		end

	c_set_ts_delidx (tmp: POINTER; a_ts_delidx: NATURAL_8)
		external
			"C inline"
		alias
			"((struct trystate_S *)$tmp)->ts_delidx = $a_ts_delidx;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct trystate_S);"
		end

end
