class
	PD_TYPEBUF_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	tb_buf: CE_POINTER [NATURAL_8] assign set_tb_buf
		do
			create Result.make_shared (c_tb_buf (c_pointer))
		end

	tb_noremap: CE_POINTER [NATURAL_8] assign set_tb_noremap
		do
			create Result.make_shared (c_tb_noremap (c_pointer))
		end

	tb_buflen: INTEGER_32 assign set_tb_buflen
		do
			Result := c_tb_buflen (c_pointer)
		end

	tb_off: INTEGER_32 assign set_tb_off
		do
			Result := c_tb_off (c_pointer)
		end

	tb_len: INTEGER_32 assign set_tb_len
		do
			Result := c_tb_len (c_pointer)
		end

	tb_maplen: INTEGER_32 assign set_tb_maplen
		do
			Result := c_tb_maplen (c_pointer)
		end

	tb_silent: INTEGER_32 assign set_tb_silent
		do
			Result := c_tb_silent (c_pointer)
		end

	tb_no_abbr_cnt: INTEGER_32 assign set_tb_no_abbr_cnt
		do
			Result := c_tb_no_abbr_cnt (c_pointer)
		end

	tb_change_cnt: INTEGER_32 assign set_tb_change_cnt
		do
			Result := c_tb_change_cnt (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_tb_buf (a_tb_buf: CE_POINTER [NATURAL_8])
		do
			c_set_tb_buf (c_pointer, a_tb_buf.c_pointer)
		end

	set_tb_noremap (a_tb_noremap: CE_POINTER [NATURAL_8])
		do
			c_set_tb_noremap (c_pointer, a_tb_noremap.c_pointer)
		end

	set_tb_buflen (a_tb_buflen: INTEGER_32)
		do
			c_set_tb_buflen (c_pointer, a_tb_buflen)
		end

	set_tb_off (a_tb_off: INTEGER_32)
		do
			c_set_tb_off (c_pointer, a_tb_off)
		end

	set_tb_len (a_tb_len: INTEGER_32)
		do
			c_set_tb_len (c_pointer, a_tb_len)
		end

	set_tb_maplen (a_tb_maplen: INTEGER_32)
		do
			c_set_tb_maplen (c_pointer, a_tb_maplen)
		end

	set_tb_silent (a_tb_silent: INTEGER_32)
		do
			c_set_tb_silent (c_pointer, a_tb_silent)
		end

	set_tb_no_abbr_cnt (a_tb_no_abbr_cnt: INTEGER_32)
		do
			c_set_tb_no_abbr_cnt (c_pointer, a_tb_no_abbr_cnt)
		end

	set_tb_change_cnt (a_tb_change_cnt: INTEGER_32)
		do
			c_set_tb_change_cnt (c_pointer, a_tb_change_cnt)
		end

feature {NONE} -- C getters

	c_tb_buf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_typebuf_T_528 *)$tmp)->tb_buf;"
		end

	c_tb_noremap (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_typebuf_T_528 *)$tmp)->tb_noremap;"
		end

	c_tb_buflen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_typebuf_T_528 *)$tmp)->tb_buflen;"
		end

	c_tb_off (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_typebuf_T_528 *)$tmp)->tb_off;"
		end

	c_tb_len (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_typebuf_T_528 *)$tmp)->tb_len;"
		end

	c_tb_maplen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_typebuf_T_528 *)$tmp)->tb_maplen;"
		end

	c_tb_silent (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_typebuf_T_528 *)$tmp)->tb_silent;"
		end

	c_tb_no_abbr_cnt (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_typebuf_T_528 *)$tmp)->tb_no_abbr_cnt;"
		end

	c_tb_change_cnt (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_typebuf_T_528 *)$tmp)->tb_change_cnt;"
		end

feature {NONE} -- C setters

	c_set_tb_buf (tmp: POINTER; a_tb_buf: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_typebuf_T_528 *)$tmp)->tb_buf = (unsigned char *)$a_tb_buf;"
		end

	c_set_tb_noremap (tmp: POINTER; a_tb_noremap: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_typebuf_T_528 *)$tmp)->tb_noremap = (unsigned char *)$a_tb_noremap;"
		end

	c_set_tb_buflen (tmp: POINTER; a_tb_buflen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_typebuf_T_528 *)$tmp)->tb_buflen = $a_tb_buflen;"
		end

	c_set_tb_off (tmp: POINTER; a_tb_off: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_typebuf_T_528 *)$tmp)->tb_off = $a_tb_off;"
		end

	c_set_tb_len (tmp: POINTER; a_tb_len: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_typebuf_T_528 *)$tmp)->tb_len = $a_tb_len;"
		end

	c_set_tb_maplen (tmp: POINTER; a_tb_maplen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_typebuf_T_528 *)$tmp)->tb_maplen = $a_tb_maplen;"
		end

	c_set_tb_silent (tmp: POINTER; a_tb_silent: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_typebuf_T_528 *)$tmp)->tb_silent = $a_tb_silent;"
		end

	c_set_tb_no_abbr_cnt (tmp: POINTER; a_tb_no_abbr_cnt: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_typebuf_T_528 *)$tmp)->tb_no_abbr_cnt = $a_tb_no_abbr_cnt;"
		end

	c_set_tb_change_cnt (tmp: POINTER; a_tb_change_cnt: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_typebuf_T_528 *)$tmp)->tb_change_cnt = $a_tb_change_cnt;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_typebuf_T_528);"
		end

end
