class
	PD_VISUALINFO_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	vi_start: PD_POS_T assign set_vi_start
		do
			create Result.make_shared (c_vi_start (c_pointer))
		end

	vi_start_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_visualinfo_T_516, vi_start);"
		end

	vi_end: PD_POS_T assign set_vi_end
		do
			create Result.make_shared (c_vi_end (c_pointer))
		end

	vi_end_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_visualinfo_T_516, vi_end);"
		end

	vi_mode: INTEGER_32 assign set_vi_mode
		do
			Result := c_vi_mode (c_pointer)
		end

	vi_curswant: INTEGER_32 assign set_vi_curswant
		do
			Result := c_vi_curswant (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_vi_start (a_vi_start: PD_POS_T)
		do
			vi_start.ce_gets (a_vi_start)
		end

	set_vi_end (a_vi_end: PD_POS_T)
		do
			vi_end.ce_gets (a_vi_end)
		end

	set_vi_mode (a_vi_mode: INTEGER_32)
		do
			c_set_vi_mode (c_pointer, a_vi_mode)
		end

	set_vi_curswant (a_vi_curswant: INTEGER_32)
		do
			c_set_vi_curswant (c_pointer, a_vi_curswant)
		end

feature {NONE} -- C getters

	c_vi_start (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (pos_T *)&((struct __anonstruct_visualinfo_T_516 *)$tmp)->vi_start;"
		end

	c_vi_end (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (pos_T *)&((struct __anonstruct_visualinfo_T_516 *)$tmp)->vi_end;"
		end

	c_vi_mode (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_visualinfo_T_516 *)$tmp)->vi_mode;"
		end

	c_vi_curswant (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_visualinfo_T_516 *)$tmp)->vi_curswant;"
		end

feature {NONE} -- C setters

	c_set_vi_mode (tmp: POINTER; a_vi_mode: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_visualinfo_T_516 *)$tmp)->vi_mode = $a_vi_mode;"
		end

	c_set_vi_curswant (tmp: POINTER; a_vi_curswant: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_visualinfo_T_516 *)$tmp)->vi_curswant = $a_vi_curswant;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_visualinfo_T_516);"
		end

end
