class
	PD_WINDOW_S

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	w_buffer: CE_POINTER [PD_FILE_BUFFER] assign set_w_buffer
		do
			create Result.make_shared (c_w_buffer (c_pointer))
		end

	w_s: CE_POINTER [PD_SYNBLOCK_T] assign set_w_s
		do
			create Result.make_shared (c_w_s (c_pointer))
		end

	w_prev: CE_POINTER [PD_WINDOW_S] assign set_w_prev
		do
			create Result.make_shared (c_w_prev (c_pointer))
		end

	w_next: CE_POINTER [PD_WINDOW_S] assign set_w_next
		do
			create Result.make_shared (c_w_next (c_pointer))
		end

	w_frame: CE_POINTER [PD_FRAME_S] assign set_w_frame
		do
			create Result.make_shared (c_w_frame (c_pointer))
		end

	w_cursor: PD_POS_T assign set_w_cursor
		do
			create Result.make_shared (c_w_cursor (c_pointer))
		end

	w_cursor_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct window_S, w_cursor);"
		end

	w_curswant: INTEGER_32 assign set_w_curswant
		do
			Result := c_w_curswant (c_pointer)
		end

	w_set_curswant: INTEGER_32 assign set_w_set_curswant
		do
			Result := c_w_set_curswant (c_pointer)
		end

	w_old_visual_mode: INTEGER_8 assign set_w_old_visual_mode
		do
			Result := c_w_old_visual_mode (c_pointer)
		end

	w_old_cursor_lnum: INTEGER_32 assign set_w_old_cursor_lnum
		do
			Result := c_w_old_cursor_lnum (c_pointer)
		end

	w_old_cursor_lnum_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct window_S, w_old_cursor_lnum);"
		end

	w_old_cursor_fcol: INTEGER_32 assign set_w_old_cursor_fcol
		do
			Result := c_w_old_cursor_fcol (c_pointer)
		end

	w_old_cursor_lcol: INTEGER_32 assign set_w_old_cursor_lcol
		do
			Result := c_w_old_cursor_lcol (c_pointer)
		end

	w_old_visual_lnum: INTEGER_32 assign set_w_old_visual_lnum
		do
			Result := c_w_old_visual_lnum (c_pointer)
		end

	w_old_visual_lnum_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct window_S, w_old_visual_lnum);"
		end

	w_old_visual_col: INTEGER_32 assign set_w_old_visual_col
		do
			Result := c_w_old_visual_col (c_pointer)
		end

	w_old_curswant: INTEGER_32 assign set_w_old_curswant
		do
			Result := c_w_old_curswant (c_pointer)
		end

	w_topline: INTEGER_32 assign set_w_topline
		do
			Result := c_w_topline (c_pointer)
		end

	w_topline_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct window_S, w_topline);"
		end

	w_topline_was_set: INTEGER_8 assign set_w_topline_was_set
		do
			Result := c_w_topline_was_set (c_pointer)
		end

	w_topfill: INTEGER_32 assign set_w_topfill
		do
			Result := c_w_topfill (c_pointer)
		end

	w_old_topfill: INTEGER_32 assign set_w_old_topfill
		do
			Result := c_w_old_topfill (c_pointer)
		end

	w_botfill: INTEGER_32 assign set_w_botfill
		do
			Result := c_w_botfill (c_pointer)
		end

	w_old_botfill: INTEGER_32 assign set_w_old_botfill
		do
			Result := c_w_old_botfill (c_pointer)
		end

	w_leftcol: INTEGER_32 assign set_w_leftcol
		do
			Result := c_w_leftcol (c_pointer)
		end

	w_skipcol: INTEGER_32 assign set_w_skipcol
		do
			Result := c_w_skipcol (c_pointer)
		end

	w_winrow: INTEGER_32 assign set_w_winrow
		do
			Result := c_w_winrow (c_pointer)
		end

	w_height: INTEGER_32 assign set_w_height
		do
			Result := c_w_height (c_pointer)
		end

	w_status_height: INTEGER_32 assign set_w_status_height
		do
			Result := c_w_status_height (c_pointer)
		end

	w_wincol: INTEGER_32 assign set_w_wincol
		do
			Result := c_w_wincol (c_pointer)
		end

	w_width: INTEGER_32 assign set_w_width
		do
			Result := c_w_width (c_pointer)
		end

	w_vsep_width: INTEGER_32 assign set_w_vsep_width
		do
			Result := c_w_vsep_width (c_pointer)
		end

	w_valid: INTEGER_32 assign set_w_valid
		do
			Result := c_w_valid (c_pointer)
		end

	w_valid_cursor: PD_POS_T assign set_w_valid_cursor
		do
			create Result.make_shared (c_w_valid_cursor (c_pointer))
		end

	w_valid_leftcol: INTEGER_32 assign set_w_valid_leftcol
		do
			Result := c_w_valid_leftcol (c_pointer)
		end

	w_cline_height: INTEGER_32 assign set_w_cline_height
		do
			Result := c_w_cline_height (c_pointer)
		end

	w_cline_folded: INTEGER_32 assign set_w_cline_folded
		do
			Result := c_w_cline_folded (c_pointer)
		end

	w_cline_row: INTEGER_32 assign set_w_cline_row
		do
			Result := c_w_cline_row (c_pointer)
		end

	w_virtcol: INTEGER_32 assign set_w_virtcol
		do
			Result := c_w_virtcol (c_pointer)
		end

	w_virtcol_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct window_S, w_virtcol);"
		end

	w_wrow: INTEGER_32 assign set_w_wrow
		do
			Result := c_w_wrow (c_pointer)
		end

	w_wcol: INTEGER_32 assign set_w_wcol
		do
			Result := c_w_wcol (c_pointer)
		end

	w_botline: INTEGER_32 assign set_w_botline
		do
			Result := c_w_botline (c_pointer)
		end

	w_botline_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct window_S, w_botline);"
		end

	w_empty_rows: INTEGER_32 assign set_w_empty_rows
		do
			Result := c_w_empty_rows (c_pointer)
		end

	w_filler_rows: INTEGER_32 assign set_w_filler_rows
		do
			Result := c_w_filler_rows (c_pointer)
		end

	w_lines_valid: INTEGER_32 assign set_w_lines_valid
		do
			Result := c_w_lines_valid (c_pointer)
		end

	w_lines: CE_POINTER [PD_W_LINE] assign set_w_lines
		do
			create Result.make_shared (c_w_lines (c_pointer))
		end

	w_folds: PD_GROWARRAY assign set_w_folds
		do
			create Result.make_shared (c_w_folds (c_pointer))
		end

	w_folds_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct window_S, w_folds);"
		end

	w_fold_manual: INTEGER_8 assign set_w_fold_manual
		do
			Result := c_w_fold_manual (c_pointer)
		end

	w_foldinvalid: INTEGER_8 assign set_w_foldinvalid
		do
			Result := c_w_foldinvalid (c_pointer)
		end

	w_nrwidth: INTEGER_32 assign set_w_nrwidth
		do
			Result := c_w_nrwidth (c_pointer)
		end

	w_redr_type: INTEGER_32 assign set_w_redr_type
		do
			Result := c_w_redr_type (c_pointer)
		end

	w_upd_rows: INTEGER_32 assign set_w_upd_rows
		do
			Result := c_w_upd_rows (c_pointer)
		end

	w_redraw_top: INTEGER_32 assign set_w_redraw_top
		do
			Result := c_w_redraw_top (c_pointer)
		end

	w_redraw_bot: INTEGER_32 assign set_w_redraw_bot
		do
			Result := c_w_redraw_bot (c_pointer)
		end

	w_redr_status: INTEGER_32 assign set_w_redr_status
		do
			Result := c_w_redr_status (c_pointer)
		end

	w_ru_cursor: PD_POS_T assign set_w_ru_cursor
		do
			create Result.make_shared (c_w_ru_cursor (c_pointer))
		end

	w_ru_virtcol: INTEGER_32 assign set_w_ru_virtcol
		do
			Result := c_w_ru_virtcol (c_pointer)
		end

	w_ru_topline: INTEGER_32 assign set_w_ru_topline
		do
			Result := c_w_ru_topline (c_pointer)
		end

	w_ru_line_count: INTEGER_32 assign set_w_ru_line_count
		do
			Result := c_w_ru_line_count (c_pointer)
		end

	w_ru_topfill: INTEGER_32 assign set_w_ru_topfill
		do
			Result := c_w_ru_topfill (c_pointer)
		end

	w_ru_empty: INTEGER_8 assign set_w_ru_empty
		do
			Result := c_w_ru_empty (c_pointer)
		end

	w_alt_fnum: INTEGER_32 assign set_w_alt_fnum
		do
			Result := c_w_alt_fnum (c_pointer)
		end

	w_alist: CE_POINTER [PD_ARGLIST] assign set_w_alist
		do
			create Result.make_shared (c_w_alist (c_pointer))
		end

	w_arg_idx: INTEGER_32 assign set_w_arg_idx
		do
			Result := c_w_arg_idx (c_pointer)
		end

	w_arg_idx_invalid: INTEGER_32 assign set_w_arg_idx_invalid
		do
			Result := c_w_arg_idx_invalid (c_pointer)
		end

	w_localdir: CE_POINTER [NATURAL_8] assign set_w_localdir
		do
			create Result.make_shared (c_w_localdir (c_pointer))
		end

	w_onebuf_opt: PD_WINOPT_T assign set_w_onebuf_opt
		do
			create Result.make_shared (c_w_onebuf_opt (c_pointer))
		end

	w_onebuf_opt_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct window_S, w_onebuf_opt);"
		end

	w_allbuf_opt: PD_WINOPT_T assign set_w_allbuf_opt
		do
			create Result.make_shared (c_w_allbuf_opt (c_pointer))
		end

	w_allbuf_opt_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct window_S, w_allbuf_opt);"
		end

	w_p_stl_flags: NATURAL_32 assign set_w_p_stl_flags
		do
			Result := c_w_p_stl_flags (c_pointer)
		end

	w_p_stl_flags_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct window_S, w_p_stl_flags);"
		end

	w_p_fde_flags: NATURAL_32 assign set_w_p_fde_flags
		do
			Result := c_w_p_fde_flags (c_pointer)
		end

	w_p_fde_flags_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct window_S, w_p_fde_flags);"
		end

	w_p_fdt_flags: NATURAL_32 assign set_w_p_fdt_flags
		do
			Result := c_w_p_fdt_flags (c_pointer)
		end

	w_p_fdt_flags_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct window_S, w_p_fdt_flags);"
		end

	w_p_cc_cols: CE_POINTER [INTEGER_32] assign set_w_p_cc_cols
		do
			create Result.make_shared (c_w_p_cc_cols (c_pointer))
		end

	w_scbind_pos: INTEGER_32 assign set_w_scbind_pos
		do
			Result := c_w_scbind_pos (c_pointer)
		end

	w_winvar: PD_DICTITEM_S assign set_w_winvar
		do
			create Result.make_shared (c_w_winvar (c_pointer))
		end

	w_winvar_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct window_S, w_winvar);"
		end

	w_vars: PD_DICTVAR_S assign set_w_vars
		do
			create Result.make_shared (c_w_vars (c_pointer))
		end

	w_vars_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct window_S, w_vars);"
		end

	w_pcmark: PD_POS_T assign set_w_pcmark
		do
			create Result.make_shared (c_w_pcmark (c_pointer))
		end

	w_pcmark_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct window_S, w_pcmark);"
		end

	w_prev_pcmark: PD_POS_T assign set_w_prev_pcmark
		do
			create Result.make_shared (c_w_prev_pcmark (c_pointer))
		end

	w_prev_pcmark_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct window_S, w_prev_pcmark);"
		end

	w_jumplist: CE_ARRAY [PD_XFILEMARK]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_w_jumplist (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	w_jumplist_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct window_S, w_jumplist);"
		end

	w_jumplistlen: INTEGER_32 assign set_w_jumplistlen
		do
			Result := c_w_jumplistlen (c_pointer)
		end

	w_jumplistidx: INTEGER_32 assign set_w_jumplistidx
		do
			Result := c_w_jumplistidx (c_pointer)
		end

	w_changelistidx: INTEGER_32 assign set_w_changelistidx
		do
			Result := c_w_changelistidx (c_pointer)
		end

	w_match_head: CE_POINTER [PD_MATCHITEM] assign set_w_match_head
		do
			create Result.make_shared (c_w_match_head (c_pointer))
		end

	w_next_match_id: INTEGER_32 assign set_w_next_match_id
		do
			Result := c_w_next_match_id (c_pointer)
		end

	w_tagstack: CE_ARRAY [PD_TAGGY]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_w_tagstack (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	w_tagstack_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct window_S, w_tagstack);"
		end

	w_tagstackidx: INTEGER_32 assign set_w_tagstackidx
		do
			Result := c_w_tagstackidx (c_pointer)
		end

	w_tagstacklen: INTEGER_32 assign set_w_tagstacklen
		do
			Result := c_w_tagstacklen (c_pointer)
		end

	w_fraction: INTEGER_32 assign set_w_fraction
		do
			Result := c_w_fraction (c_pointer)
		end

	w_prev_fraction_row: INTEGER_32 assign set_w_prev_fraction_row
		do
			Result := c_w_prev_fraction_row (c_pointer)
		end

	w_scrollbars: CE_ARRAY [PD_GUISCROLLBAR]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_w_scrollbars (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	w_nrwidth_line_count: INTEGER_32 assign set_w_nrwidth_line_count
		do
			Result := c_w_nrwidth_line_count (c_pointer)
		end

	w_nrwidth_width: INTEGER_32 assign set_w_nrwidth_width
		do
			Result := c_w_nrwidth_width (c_pointer)
		end

	w_llist: CE_POINTER [PD_QF_INFO_S] assign set_w_llist
		do
			create Result.make_shared (c_w_llist (c_pointer))
		end

	w_llist_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct window_S, w_llist);"
		end

	w_llist_ref: CE_POINTER [PD_QF_INFO_S] assign set_w_llist_ref
		do
			create Result.make_shared (c_w_llist_ref (c_pointer))
		end

	w_llist_ref_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct window_S, w_llist_ref);"
		end

feature {ANY} -- Eiffel setters

	set_w_buffer (a_w_buffer: CE_POINTER [PD_FILE_BUFFER])
		do
			c_set_w_buffer (c_pointer, a_w_buffer.c_pointer)
		end

	set_w_s (a_w_s: CE_POINTER [PD_SYNBLOCK_T])
		do
			c_set_w_s (c_pointer, a_w_s.c_pointer)
		end

	set_w_prev (a_w_prev: CE_POINTER [PD_WINDOW_S])
		do
			c_set_w_prev (c_pointer, a_w_prev.c_pointer)
		end

	set_w_next (a_w_next: CE_POINTER [PD_WINDOW_S])
		do
			c_set_w_next (c_pointer, a_w_next.c_pointer)
		end

	set_w_frame (a_w_frame: CE_POINTER [PD_FRAME_S])
		do
			c_set_w_frame (c_pointer, a_w_frame.c_pointer)
		end

	set_w_cursor (a_w_cursor: PD_POS_T)
		do
			w_cursor.ce_gets (a_w_cursor)
		end

	set_w_curswant (a_w_curswant: INTEGER_32)
		do
			c_set_w_curswant (c_pointer, a_w_curswant)
		end

	set_w_set_curswant (a_w_set_curswant: INTEGER_32)
		do
			c_set_w_set_curswant (c_pointer, a_w_set_curswant)
		end

	set_w_old_visual_mode (a_w_old_visual_mode: INTEGER_8)
		do
			c_set_w_old_visual_mode (c_pointer, a_w_old_visual_mode)
		end

	set_w_old_cursor_lnum (a_w_old_cursor_lnum: INTEGER_32)
		do
			c_set_w_old_cursor_lnum (c_pointer, a_w_old_cursor_lnum)
		end

	set_w_old_cursor_fcol (a_w_old_cursor_fcol: INTEGER_32)
		do
			c_set_w_old_cursor_fcol (c_pointer, a_w_old_cursor_fcol)
		end

	set_w_old_cursor_lcol (a_w_old_cursor_lcol: INTEGER_32)
		do
			c_set_w_old_cursor_lcol (c_pointer, a_w_old_cursor_lcol)
		end

	set_w_old_visual_lnum (a_w_old_visual_lnum: INTEGER_32)
		do
			c_set_w_old_visual_lnum (c_pointer, a_w_old_visual_lnum)
		end

	set_w_old_visual_col (a_w_old_visual_col: INTEGER_32)
		do
			c_set_w_old_visual_col (c_pointer, a_w_old_visual_col)
		end

	set_w_old_curswant (a_w_old_curswant: INTEGER_32)
		do
			c_set_w_old_curswant (c_pointer, a_w_old_curswant)
		end

	set_w_topline (a_w_topline: INTEGER_32)
		do
			c_set_w_topline (c_pointer, a_w_topline)
		end

	set_w_topline_was_set (a_w_topline_was_set: INTEGER_8)
		do
			c_set_w_topline_was_set (c_pointer, a_w_topline_was_set)
		end

	set_w_topfill (a_w_topfill: INTEGER_32)
		do
			c_set_w_topfill (c_pointer, a_w_topfill)
		end

	set_w_old_topfill (a_w_old_topfill: INTEGER_32)
		do
			c_set_w_old_topfill (c_pointer, a_w_old_topfill)
		end

	set_w_botfill (a_w_botfill: INTEGER_32)
		do
			c_set_w_botfill (c_pointer, a_w_botfill)
		end

	set_w_old_botfill (a_w_old_botfill: INTEGER_32)
		do
			c_set_w_old_botfill (c_pointer, a_w_old_botfill)
		end

	set_w_leftcol (a_w_leftcol: INTEGER_32)
		do
			c_set_w_leftcol (c_pointer, a_w_leftcol)
		end

	set_w_skipcol (a_w_skipcol: INTEGER_32)
		do
			c_set_w_skipcol (c_pointer, a_w_skipcol)
		end

	set_w_winrow (a_w_winrow: INTEGER_32)
		do
			c_set_w_winrow (c_pointer, a_w_winrow)
		end

	set_w_height (a_w_height: INTEGER_32)
		do
			c_set_w_height (c_pointer, a_w_height)
		end

	set_w_status_height (a_w_status_height: INTEGER_32)
		do
			c_set_w_status_height (c_pointer, a_w_status_height)
		end

	set_w_wincol (a_w_wincol: INTEGER_32)
		do
			c_set_w_wincol (c_pointer, a_w_wincol)
		end

	set_w_width (a_w_width: INTEGER_32)
		do
			c_set_w_width (c_pointer, a_w_width)
		end

	set_w_vsep_width (a_w_vsep_width: INTEGER_32)
		do
			c_set_w_vsep_width (c_pointer, a_w_vsep_width)
		end

	set_w_valid (a_w_valid: INTEGER_32)
		do
			c_set_w_valid (c_pointer, a_w_valid)
		end

	set_w_valid_cursor (a_w_valid_cursor: PD_POS_T)
		do
			w_valid_cursor.ce_gets (a_w_valid_cursor)
		end

	set_w_valid_leftcol (a_w_valid_leftcol: INTEGER_32)
		do
			c_set_w_valid_leftcol (c_pointer, a_w_valid_leftcol)
		end

	set_w_cline_height (a_w_cline_height: INTEGER_32)
		do
			c_set_w_cline_height (c_pointer, a_w_cline_height)
		end

	set_w_cline_folded (a_w_cline_folded: INTEGER_32)
		do
			c_set_w_cline_folded (c_pointer, a_w_cline_folded)
		end

	set_w_cline_row (a_w_cline_row: INTEGER_32)
		do
			c_set_w_cline_row (c_pointer, a_w_cline_row)
		end

	set_w_virtcol (a_w_virtcol: INTEGER_32)
		do
			c_set_w_virtcol (c_pointer, a_w_virtcol)
		end

	set_w_wrow (a_w_wrow: INTEGER_32)
		do
			c_set_w_wrow (c_pointer, a_w_wrow)
		end

	set_w_wcol (a_w_wcol: INTEGER_32)
		do
			c_set_w_wcol (c_pointer, a_w_wcol)
		end

	set_w_botline (a_w_botline: INTEGER_32)
		do
			c_set_w_botline (c_pointer, a_w_botline)
		end

	set_w_empty_rows (a_w_empty_rows: INTEGER_32)
		do
			c_set_w_empty_rows (c_pointer, a_w_empty_rows)
		end

	set_w_filler_rows (a_w_filler_rows: INTEGER_32)
		do
			c_set_w_filler_rows (c_pointer, a_w_filler_rows)
		end

	set_w_lines_valid (a_w_lines_valid: INTEGER_32)
		do
			c_set_w_lines_valid (c_pointer, a_w_lines_valid)
		end

	set_w_lines (a_w_lines: CE_POINTER [PD_W_LINE])
		do
			c_set_w_lines (c_pointer, a_w_lines.c_pointer)
		end

	set_w_folds (a_w_folds: PD_GROWARRAY)
		do
			w_folds.ce_gets (a_w_folds)
		end

	set_w_fold_manual (a_w_fold_manual: INTEGER_8)
		do
			c_set_w_fold_manual (c_pointer, a_w_fold_manual)
		end

	set_w_foldinvalid (a_w_foldinvalid: INTEGER_8)
		do
			c_set_w_foldinvalid (c_pointer, a_w_foldinvalid)
		end

	set_w_nrwidth (a_w_nrwidth: INTEGER_32)
		do
			c_set_w_nrwidth (c_pointer, a_w_nrwidth)
		end

	set_w_redr_type (a_w_redr_type: INTEGER_32)
		do
			c_set_w_redr_type (c_pointer, a_w_redr_type)
		end

	set_w_upd_rows (a_w_upd_rows: INTEGER_32)
		do
			c_set_w_upd_rows (c_pointer, a_w_upd_rows)
		end

	set_w_redraw_top (a_w_redraw_top: INTEGER_32)
		do
			c_set_w_redraw_top (c_pointer, a_w_redraw_top)
		end

	set_w_redraw_bot (a_w_redraw_bot: INTEGER_32)
		do
			c_set_w_redraw_bot (c_pointer, a_w_redraw_bot)
		end

	set_w_redr_status (a_w_redr_status: INTEGER_32)
		do
			c_set_w_redr_status (c_pointer, a_w_redr_status)
		end

	set_w_ru_cursor (a_w_ru_cursor: PD_POS_T)
		do
			w_ru_cursor.ce_gets (a_w_ru_cursor)
		end

	set_w_ru_virtcol (a_w_ru_virtcol: INTEGER_32)
		do
			c_set_w_ru_virtcol (c_pointer, a_w_ru_virtcol)
		end

	set_w_ru_topline (a_w_ru_topline: INTEGER_32)
		do
			c_set_w_ru_topline (c_pointer, a_w_ru_topline)
		end

	set_w_ru_line_count (a_w_ru_line_count: INTEGER_32)
		do
			c_set_w_ru_line_count (c_pointer, a_w_ru_line_count)
		end

	set_w_ru_topfill (a_w_ru_topfill: INTEGER_32)
		do
			c_set_w_ru_topfill (c_pointer, a_w_ru_topfill)
		end

	set_w_ru_empty (a_w_ru_empty: INTEGER_8)
		do
			c_set_w_ru_empty (c_pointer, a_w_ru_empty)
		end

	set_w_alt_fnum (a_w_alt_fnum: INTEGER_32)
		do
			c_set_w_alt_fnum (c_pointer, a_w_alt_fnum)
		end

	set_w_alist (a_w_alist: CE_POINTER [PD_ARGLIST])
		do
			c_set_w_alist (c_pointer, a_w_alist.c_pointer)
		end

	set_w_arg_idx (a_w_arg_idx: INTEGER_32)
		do
			c_set_w_arg_idx (c_pointer, a_w_arg_idx)
		end

	set_w_arg_idx_invalid (a_w_arg_idx_invalid: INTEGER_32)
		do
			c_set_w_arg_idx_invalid (c_pointer, a_w_arg_idx_invalid)
		end

	set_w_localdir (a_w_localdir: CE_POINTER [NATURAL_8])
		do
			c_set_w_localdir (c_pointer, a_w_localdir.c_pointer)
		end

	set_w_onebuf_opt (a_w_onebuf_opt: PD_WINOPT_T)
		do
			w_onebuf_opt.ce_gets (a_w_onebuf_opt)
		end

	set_w_allbuf_opt (a_w_allbuf_opt: PD_WINOPT_T)
		do
			w_allbuf_opt.ce_gets (a_w_allbuf_opt)
		end

	set_w_p_stl_flags (a_w_p_stl_flags: NATURAL_32)
		do
			c_set_w_p_stl_flags (c_pointer, a_w_p_stl_flags)
		end

	set_w_p_fde_flags (a_w_p_fde_flags: NATURAL_32)
		do
			c_set_w_p_fde_flags (c_pointer, a_w_p_fde_flags)
		end

	set_w_p_fdt_flags (a_w_p_fdt_flags: NATURAL_32)
		do
			c_set_w_p_fdt_flags (c_pointer, a_w_p_fdt_flags)
		end

	set_w_p_cc_cols (a_w_p_cc_cols: CE_POINTER [INTEGER_32])
		do
			c_set_w_p_cc_cols (c_pointer, a_w_p_cc_cols.c_pointer)
		end

	set_w_scbind_pos (a_w_scbind_pos: INTEGER_32)
		do
			c_set_w_scbind_pos (c_pointer, a_w_scbind_pos)
		end

	set_w_winvar (a_w_winvar: PD_DICTITEM_S)
		do
			w_winvar.ce_gets (a_w_winvar)
		end

	set_w_vars (a_w_vars: PD_DICTVAR_S)
		do
			w_vars.ce_gets (a_w_vars)
		end

	set_w_pcmark (a_w_pcmark: PD_POS_T)
		do
			w_pcmark.ce_gets (a_w_pcmark)
		end

	set_w_prev_pcmark (a_w_prev_pcmark: PD_POS_T)
		do
			w_prev_pcmark.ce_gets (a_w_prev_pcmark)
		end

	set_w_jumplistlen (a_w_jumplistlen: INTEGER_32)
		do
			c_set_w_jumplistlen (c_pointer, a_w_jumplistlen)
		end

	set_w_jumplistidx (a_w_jumplistidx: INTEGER_32)
		do
			c_set_w_jumplistidx (c_pointer, a_w_jumplistidx)
		end

	set_w_changelistidx (a_w_changelistidx: INTEGER_32)
		do
			c_set_w_changelistidx (c_pointer, a_w_changelistidx)
		end

	set_w_match_head (a_w_match_head: CE_POINTER [PD_MATCHITEM])
		do
			c_set_w_match_head (c_pointer, a_w_match_head.c_pointer)
		end

	set_w_next_match_id (a_w_next_match_id: INTEGER_32)
		do
			c_set_w_next_match_id (c_pointer, a_w_next_match_id)
		end

	set_w_tagstackidx (a_w_tagstackidx: INTEGER_32)
		do
			c_set_w_tagstackidx (c_pointer, a_w_tagstackidx)
		end

	set_w_tagstacklen (a_w_tagstacklen: INTEGER_32)
		do
			c_set_w_tagstacklen (c_pointer, a_w_tagstacklen)
		end

	set_w_fraction (a_w_fraction: INTEGER_32)
		do
			c_set_w_fraction (c_pointer, a_w_fraction)
		end

	set_w_prev_fraction_row (a_w_prev_fraction_row: INTEGER_32)
		do
			c_set_w_prev_fraction_row (c_pointer, a_w_prev_fraction_row)
		end

	set_w_nrwidth_line_count (a_w_nrwidth_line_count: INTEGER_32)
		do
			c_set_w_nrwidth_line_count (c_pointer, a_w_nrwidth_line_count)
		end

	set_w_nrwidth_width (a_w_nrwidth_width: INTEGER_32)
		do
			c_set_w_nrwidth_width (c_pointer, a_w_nrwidth_width)
		end

	set_w_llist (a_w_llist: CE_POINTER [PD_QF_INFO_S])
		do
			c_set_w_llist (c_pointer, a_w_llist.c_pointer)
		end

	set_w_llist_ref (a_w_llist_ref: CE_POINTER [PD_QF_INFO_S])
		do
			c_set_w_llist_ref (c_pointer, a_w_llist_ref.c_pointer)
		end

feature {NONE} -- C getters

	c_w_buffer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct file_buffer *)((struct window_S *)$tmp)->w_buffer;"
		end

	c_w_s (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (synblock_T *)((struct window_S *)$tmp)->w_s;"
		end

	c_w_prev (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct window_S *)((struct window_S *)$tmp)->w_prev;"
		end

	c_w_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct window_S *)((struct window_S *)$tmp)->w_next;"
		end

	c_w_frame (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct frame_S *)((struct window_S *)$tmp)->w_frame;"
		end

	c_w_cursor (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (pos_T *)&((struct window_S *)$tmp)->w_cursor;"
		end

	c_w_curswant (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_curswant;"
		end

	c_w_set_curswant (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_set_curswant;"
		end

	c_w_old_visual_mode (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct window_S *)$tmp)->w_old_visual_mode;"
		end

	c_w_old_cursor_lnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct window_S *)$tmp)->w_old_cursor_lnum;"
		end

	c_w_old_cursor_fcol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_old_cursor_fcol;"
		end

	c_w_old_cursor_lcol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_old_cursor_lcol;"
		end

	c_w_old_visual_lnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct window_S *)$tmp)->w_old_visual_lnum;"
		end

	c_w_old_visual_col (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_old_visual_col;"
		end

	c_w_old_curswant (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_old_curswant;"
		end

	c_w_topline (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct window_S *)$tmp)->w_topline;"
		end

	c_w_topline_was_set (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct window_S *)$tmp)->w_topline_was_set;"
		end

	c_w_topfill (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_topfill;"
		end

	c_w_old_topfill (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_old_topfill;"
		end

	c_w_botfill (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_botfill;"
		end

	c_w_old_botfill (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_old_botfill;"
		end

	c_w_leftcol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_leftcol;"
		end

	c_w_skipcol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_skipcol;"
		end

	c_w_winrow (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_winrow;"
		end

	c_w_height (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_height;"
		end

	c_w_status_height (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_status_height;"
		end

	c_w_wincol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_wincol;"
		end

	c_w_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_width;"
		end

	c_w_vsep_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_vsep_width;"
		end

	c_w_valid (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_valid;"
		end

	c_w_valid_cursor (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (pos_T *)&((struct window_S *)$tmp)->w_valid_cursor;"
		end

	c_w_valid_leftcol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_valid_leftcol;"
		end

	c_w_cline_height (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_cline_height;"
		end

	c_w_cline_folded (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_cline_folded;"
		end

	c_w_cline_row (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_cline_row;"
		end

	c_w_virtcol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_virtcol;"
		end

	c_w_wrow (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_wrow;"
		end

	c_w_wcol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_wcol;"
		end

	c_w_botline (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct window_S *)$tmp)->w_botline;"
		end

	c_w_empty_rows (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_empty_rows;"
		end

	c_w_filler_rows (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_filler_rows;"
		end

	c_w_lines_valid (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_lines_valid;"
		end

	c_w_lines (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct w_line *)((struct window_S *)$tmp)->w_lines;"
		end

	c_w_folds (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct growarray *)&((struct window_S *)$tmp)->w_folds;"
		end

	c_w_fold_manual (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct window_S *)$tmp)->w_fold_manual;"
		end

	c_w_foldinvalid (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct window_S *)$tmp)->w_foldinvalid;"
		end

	c_w_nrwidth (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_nrwidth;"
		end

	c_w_redr_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_redr_type;"
		end

	c_w_upd_rows (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_upd_rows;"
		end

	c_w_redraw_top (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct window_S *)$tmp)->w_redraw_top;"
		end

	c_w_redraw_bot (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct window_S *)$tmp)->w_redraw_bot;"
		end

	c_w_redr_status (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_redr_status;"
		end

	c_w_ru_cursor (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (pos_T *)&((struct window_S *)$tmp)->w_ru_cursor;"
		end

	c_w_ru_virtcol (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_ru_virtcol;"
		end

	c_w_ru_topline (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct window_S *)$tmp)->w_ru_topline;"
		end

	c_w_ru_line_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct window_S *)$tmp)->w_ru_line_count;"
		end

	c_w_ru_topfill (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_ru_topfill;"
		end

	c_w_ru_empty (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct window_S *)$tmp)->w_ru_empty;"
		end

	c_w_alt_fnum (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_alt_fnum;"
		end

	c_w_alist (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct arglist *)((struct window_S *)$tmp)->w_alist;"
		end

	c_w_arg_idx (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_arg_idx;"
		end

	c_w_arg_idx_invalid (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_arg_idx_invalid;"
		end

	c_w_localdir (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct window_S *)$tmp)->w_localdir;"
		end

	c_w_onebuf_opt (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (winopt_T *)&((struct window_S *)$tmp)->w_onebuf_opt;"
		end

	c_w_allbuf_opt (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (winopt_T *)&((struct window_S *)$tmp)->w_allbuf_opt;"
		end

	c_w_p_stl_flags (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct window_S *)$tmp)->w_p_stl_flags;"
		end

	c_w_p_fde_flags (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct window_S *)$tmp)->w_p_fde_flags;"
		end

	c_w_p_fdt_flags (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct window_S *)$tmp)->w_p_fdt_flags;"
		end

	c_w_p_cc_cols (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int *)((struct window_S *)$tmp)->w_p_cc_cols;"
		end

	c_w_scbind_pos (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct window_S *)$tmp)->w_scbind_pos;"
		end

	c_w_winvar (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dictitem_S *)&((struct window_S *)$tmp)->w_winvar;"
		end

	c_w_vars (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct dictvar_S *)&((struct window_S *)$tmp)->w_vars;"
		end

	c_w_pcmark (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (pos_T *)&((struct window_S *)$tmp)->w_pcmark;"
		end

	c_w_prev_pcmark (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (pos_T *)&((struct window_S *)$tmp)->w_prev_pcmark;"
		end

	c_w_jumplist (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct window_S *tmp = (struct window_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->w_jumplist) / sizeof(tmp->w_jumplist[0]);
				return tmp->w_jumplist;
			]"
		end

	c_w_jumplistlen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_jumplistlen;"
		end

	c_w_jumplistidx (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_jumplistidx;"
		end

	c_w_changelistidx (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_changelistidx;"
		end

	c_w_match_head (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct matchitem *)((struct window_S *)$tmp)->w_match_head;"
		end

	c_w_next_match_id (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_next_match_id;"
		end

	c_w_tagstack (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct window_S *tmp = (struct window_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->w_tagstack) / sizeof(tmp->w_tagstack[0]);
				return tmp->w_tagstack;
			]"
		end

	c_w_tagstackidx (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_tagstackidx;"
		end

	c_w_tagstacklen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_tagstacklen;"
		end

	c_w_fraction (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_fraction;"
		end

	c_w_prev_fraction_row (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_prev_fraction_row;"
		end

	c_w_scrollbars (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct window_S *tmp = (struct window_S *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->w_scrollbars) / sizeof(tmp->w_scrollbars[0]);
				return tmp->w_scrollbars;
			]"
		end

	c_w_nrwidth_line_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct window_S *)$tmp)->w_nrwidth_line_count;"
		end

	c_w_nrwidth_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct window_S *)$tmp)->w_nrwidth_width;"
		end

	c_w_llist (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct qf_info_S *)((struct window_S *)$tmp)->w_llist;"
		end

	c_w_llist_ref (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct qf_info_S *)((struct window_S *)$tmp)->w_llist_ref;"
		end

feature {NONE} -- C setters

	c_set_w_buffer (tmp: POINTER; a_w_buffer: POINTER)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_buffer = (struct file_buffer *)$a_w_buffer;"
		end

	c_set_w_s (tmp: POINTER; a_w_s: POINTER)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_s = (synblock_T *)$a_w_s;"
		end

	c_set_w_prev (tmp: POINTER; a_w_prev: POINTER)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_prev = (struct window_S *)$a_w_prev;"
		end

	c_set_w_next (tmp: POINTER; a_w_next: POINTER)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_next = (struct window_S *)$a_w_next;"
		end

	c_set_w_frame (tmp: POINTER; a_w_frame: POINTER)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_frame = (struct frame_S *)$a_w_frame;"
		end

	c_set_w_curswant (tmp: POINTER; a_w_curswant: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_curswant = $a_w_curswant;"
		end

	c_set_w_set_curswant (tmp: POINTER; a_w_set_curswant: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_set_curswant = $a_w_set_curswant;"
		end

	c_set_w_old_visual_mode (tmp: POINTER; a_w_old_visual_mode: INTEGER_8)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_old_visual_mode = $a_w_old_visual_mode;"
		end

	c_set_w_old_cursor_lnum (tmp: POINTER; a_w_old_cursor_lnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_old_cursor_lnum = $a_w_old_cursor_lnum;"
		end

	c_set_w_old_cursor_fcol (tmp: POINTER; a_w_old_cursor_fcol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_old_cursor_fcol = $a_w_old_cursor_fcol;"
		end

	c_set_w_old_cursor_lcol (tmp: POINTER; a_w_old_cursor_lcol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_old_cursor_lcol = $a_w_old_cursor_lcol;"
		end

	c_set_w_old_visual_lnum (tmp: POINTER; a_w_old_visual_lnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_old_visual_lnum = $a_w_old_visual_lnum;"
		end

	c_set_w_old_visual_col (tmp: POINTER; a_w_old_visual_col: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_old_visual_col = $a_w_old_visual_col;"
		end

	c_set_w_old_curswant (tmp: POINTER; a_w_old_curswant: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_old_curswant = $a_w_old_curswant;"
		end

	c_set_w_topline (tmp: POINTER; a_w_topline: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_topline = $a_w_topline;"
		end

	c_set_w_topline_was_set (tmp: POINTER; a_w_topline_was_set: INTEGER_8)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_topline_was_set = $a_w_topline_was_set;"
		end

	c_set_w_topfill (tmp: POINTER; a_w_topfill: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_topfill = $a_w_topfill;"
		end

	c_set_w_old_topfill (tmp: POINTER; a_w_old_topfill: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_old_topfill = $a_w_old_topfill;"
		end

	c_set_w_botfill (tmp: POINTER; a_w_botfill: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_botfill = $a_w_botfill;"
		end

	c_set_w_old_botfill (tmp: POINTER; a_w_old_botfill: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_old_botfill = $a_w_old_botfill;"
		end

	c_set_w_leftcol (tmp: POINTER; a_w_leftcol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_leftcol = $a_w_leftcol;"
		end

	c_set_w_skipcol (tmp: POINTER; a_w_skipcol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_skipcol = $a_w_skipcol;"
		end

	c_set_w_winrow (tmp: POINTER; a_w_winrow: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_winrow = $a_w_winrow;"
		end

	c_set_w_height (tmp: POINTER; a_w_height: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_height = $a_w_height;"
		end

	c_set_w_status_height (tmp: POINTER; a_w_status_height: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_status_height = $a_w_status_height;"
		end

	c_set_w_wincol (tmp: POINTER; a_w_wincol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_wincol = $a_w_wincol;"
		end

	c_set_w_width (tmp: POINTER; a_w_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_width = $a_w_width;"
		end

	c_set_w_vsep_width (tmp: POINTER; a_w_vsep_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_vsep_width = $a_w_vsep_width;"
		end

	c_set_w_valid (tmp: POINTER; a_w_valid: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_valid = $a_w_valid;"
		end

	c_set_w_valid_leftcol (tmp: POINTER; a_w_valid_leftcol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_valid_leftcol = $a_w_valid_leftcol;"
		end

	c_set_w_cline_height (tmp: POINTER; a_w_cline_height: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_cline_height = $a_w_cline_height;"
		end

	c_set_w_cline_folded (tmp: POINTER; a_w_cline_folded: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_cline_folded = $a_w_cline_folded;"
		end

	c_set_w_cline_row (tmp: POINTER; a_w_cline_row: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_cline_row = $a_w_cline_row;"
		end

	c_set_w_virtcol (tmp: POINTER; a_w_virtcol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_virtcol = $a_w_virtcol;"
		end

	c_set_w_wrow (tmp: POINTER; a_w_wrow: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_wrow = $a_w_wrow;"
		end

	c_set_w_wcol (tmp: POINTER; a_w_wcol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_wcol = $a_w_wcol;"
		end

	c_set_w_botline (tmp: POINTER; a_w_botline: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_botline = $a_w_botline;"
		end

	c_set_w_empty_rows (tmp: POINTER; a_w_empty_rows: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_empty_rows = $a_w_empty_rows;"
		end

	c_set_w_filler_rows (tmp: POINTER; a_w_filler_rows: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_filler_rows = $a_w_filler_rows;"
		end

	c_set_w_lines_valid (tmp: POINTER; a_w_lines_valid: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_lines_valid = $a_w_lines_valid;"
		end

	c_set_w_lines (tmp: POINTER; a_w_lines: POINTER)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_lines = (struct w_line *)$a_w_lines;"
		end

	c_set_w_fold_manual (tmp: POINTER; a_w_fold_manual: INTEGER_8)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_fold_manual = $a_w_fold_manual;"
		end

	c_set_w_foldinvalid (tmp: POINTER; a_w_foldinvalid: INTEGER_8)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_foldinvalid = $a_w_foldinvalid;"
		end

	c_set_w_nrwidth (tmp: POINTER; a_w_nrwidth: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_nrwidth = $a_w_nrwidth;"
		end

	c_set_w_redr_type (tmp: POINTER; a_w_redr_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_redr_type = $a_w_redr_type;"
		end

	c_set_w_upd_rows (tmp: POINTER; a_w_upd_rows: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_upd_rows = $a_w_upd_rows;"
		end

	c_set_w_redraw_top (tmp: POINTER; a_w_redraw_top: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_redraw_top = $a_w_redraw_top;"
		end

	c_set_w_redraw_bot (tmp: POINTER; a_w_redraw_bot: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_redraw_bot = $a_w_redraw_bot;"
		end

	c_set_w_redr_status (tmp: POINTER; a_w_redr_status: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_redr_status = $a_w_redr_status;"
		end

	c_set_w_ru_virtcol (tmp: POINTER; a_w_ru_virtcol: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_ru_virtcol = $a_w_ru_virtcol;"
		end

	c_set_w_ru_topline (tmp: POINTER; a_w_ru_topline: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_ru_topline = $a_w_ru_topline;"
		end

	c_set_w_ru_line_count (tmp: POINTER; a_w_ru_line_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_ru_line_count = $a_w_ru_line_count;"
		end

	c_set_w_ru_topfill (tmp: POINTER; a_w_ru_topfill: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_ru_topfill = $a_w_ru_topfill;"
		end

	c_set_w_ru_empty (tmp: POINTER; a_w_ru_empty: INTEGER_8)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_ru_empty = $a_w_ru_empty;"
		end

	c_set_w_alt_fnum (tmp: POINTER; a_w_alt_fnum: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_alt_fnum = $a_w_alt_fnum;"
		end

	c_set_w_alist (tmp: POINTER; a_w_alist: POINTER)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_alist = (struct arglist *)$a_w_alist;"
		end

	c_set_w_arg_idx (tmp: POINTER; a_w_arg_idx: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_arg_idx = $a_w_arg_idx;"
		end

	c_set_w_arg_idx_invalid (tmp: POINTER; a_w_arg_idx_invalid: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_arg_idx_invalid = $a_w_arg_idx_invalid;"
		end

	c_set_w_localdir (tmp: POINTER; a_w_localdir: POINTER)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_localdir = (unsigned char *)$a_w_localdir;"
		end

	c_set_w_p_stl_flags (tmp: POINTER; a_w_p_stl_flags: NATURAL_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_p_stl_flags = $a_w_p_stl_flags;"
		end

	c_set_w_p_fde_flags (tmp: POINTER; a_w_p_fde_flags: NATURAL_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_p_fde_flags = $a_w_p_fde_flags;"
		end

	c_set_w_p_fdt_flags (tmp: POINTER; a_w_p_fdt_flags: NATURAL_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_p_fdt_flags = $a_w_p_fdt_flags;"
		end

	c_set_w_p_cc_cols (tmp: POINTER; a_w_p_cc_cols: POINTER)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_p_cc_cols = (int *)$a_w_p_cc_cols;"
		end

	c_set_w_scbind_pos (tmp: POINTER; a_w_scbind_pos: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_scbind_pos = $a_w_scbind_pos;"
		end

	c_set_w_jumplistlen (tmp: POINTER; a_w_jumplistlen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_jumplistlen = $a_w_jumplistlen;"
		end

	c_set_w_jumplistidx (tmp: POINTER; a_w_jumplistidx: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_jumplistidx = $a_w_jumplistidx;"
		end

	c_set_w_changelistidx (tmp: POINTER; a_w_changelistidx: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_changelistidx = $a_w_changelistidx;"
		end

	c_set_w_match_head (tmp: POINTER; a_w_match_head: POINTER)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_match_head = (struct matchitem *)$a_w_match_head;"
		end

	c_set_w_next_match_id (tmp: POINTER; a_w_next_match_id: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_next_match_id = $a_w_next_match_id;"
		end

	c_set_w_tagstackidx (tmp: POINTER; a_w_tagstackidx: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_tagstackidx = $a_w_tagstackidx;"
		end

	c_set_w_tagstacklen (tmp: POINTER; a_w_tagstacklen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_tagstacklen = $a_w_tagstacklen;"
		end

	c_set_w_fraction (tmp: POINTER; a_w_fraction: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_fraction = $a_w_fraction;"
		end

	c_set_w_prev_fraction_row (tmp: POINTER; a_w_prev_fraction_row: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_prev_fraction_row = $a_w_prev_fraction_row;"
		end

	c_set_w_nrwidth_line_count (tmp: POINTER; a_w_nrwidth_line_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_nrwidth_line_count = $a_w_nrwidth_line_count;"
		end

	c_set_w_nrwidth_width (tmp: POINTER; a_w_nrwidth_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_nrwidth_width = $a_w_nrwidth_width;"
		end

	c_set_w_llist (tmp: POINTER; a_w_llist: POINTER)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_llist = (struct qf_info_S *)$a_w_llist;"
		end

	c_set_w_llist_ref (tmp: POINTER; a_w_llist_ref: POINTER)
		external
			"C inline"
		alias
			"((struct window_S *)$tmp)->w_llist_ref = (struct qf_info_S *)$a_w_llist_ref;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct window_S);"
		end

end
