class
	PD_WINOPT_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	wo_diff: INTEGER_32 assign set_wo_diff
		do
			Result := c_wo_diff (c_pointer)
		end

	wo_diff_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_diff);"
		end

	wo_fdc: INTEGER_32 assign set_wo_fdc
		do
			Result := c_wo_fdc (c_pointer)
		end

	wo_fdc_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_fdc);"
		end

	wo_fen: INTEGER_32 assign set_wo_fen
		do
			Result := c_wo_fen (c_pointer)
		end

	wo_fen_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_fen);"
		end

	wo_fdi: CE_POINTER [NATURAL_8] assign set_wo_fdi
		do
			create Result.make_shared (c_wo_fdi (c_pointer))
		end

	wo_fdi_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_fdi);"
		end

	wo_fdl: INTEGER_32 assign set_wo_fdl
		do
			Result := c_wo_fdl (c_pointer)
		end

	wo_fdl_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_fdl);"
		end

	wo_fdm: CE_POINTER [NATURAL_8] assign set_wo_fdm
		do
			create Result.make_shared (c_wo_fdm (c_pointer))
		end

	wo_fdm_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_fdm);"
		end

	wo_fml: INTEGER_32 assign set_wo_fml
		do
			Result := c_wo_fml (c_pointer)
		end

	wo_fml_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_fml);"
		end

	wo_fdn: INTEGER_32 assign set_wo_fdn
		do
			Result := c_wo_fdn (c_pointer)
		end

	wo_fdn_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_fdn);"
		end

	wo_fde: CE_POINTER [NATURAL_8] assign set_wo_fde
		do
			create Result.make_shared (c_wo_fde (c_pointer))
		end

	wo_fde_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_fde);"
		end

	wo_fdt: CE_POINTER [NATURAL_8] assign set_wo_fdt
		do
			create Result.make_shared (c_wo_fdt (c_pointer))
		end

	wo_fdt_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_fdt);"
		end

	wo_fmr: CE_POINTER [NATURAL_8] assign set_wo_fmr
		do
			create Result.make_shared (c_wo_fmr (c_pointer))
		end

	wo_fmr_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_fmr);"
		end

	wo_lbr: INTEGER_32 assign set_wo_lbr
		do
			Result := c_wo_lbr (c_pointer)
		end

	wo_lbr_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_lbr);"
		end

	wo_list: INTEGER_32 assign set_wo_list
		do
			Result := c_wo_list (c_pointer)
		end

	wo_list_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_list);"
		end

	wo_nu: INTEGER_32 assign set_wo_nu
		do
			Result := c_wo_nu (c_pointer)
		end

	wo_nu_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_nu);"
		end

	wo_rnu: INTEGER_32 assign set_wo_rnu
		do
			Result := c_wo_rnu (c_pointer)
		end

	wo_rnu_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_rnu);"
		end

	wo_nuw: INTEGER_32 assign set_wo_nuw
		do
			Result := c_wo_nuw (c_pointer)
		end

	wo_nuw_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_nuw);"
		end

	wo_wfh: INTEGER_32 assign set_wo_wfh
		do
			Result := c_wo_wfh (c_pointer)
		end

	wo_wfh_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_wfh);"
		end

	wo_wfw: INTEGER_32 assign set_wo_wfw
		do
			Result := c_wo_wfw (c_pointer)
		end

	wo_wfw_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_wfw);"
		end

	wo_pvw: INTEGER_32 assign set_wo_pvw
		do
			Result := c_wo_pvw (c_pointer)
		end

	wo_pvw_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_pvw);"
		end

	wo_scr: INTEGER_32 assign set_wo_scr
		do
			Result := c_wo_scr (c_pointer)
		end

	wo_scr_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_scr);"
		end

	wo_spell: INTEGER_32 assign set_wo_spell
		do
			Result := c_wo_spell (c_pointer)
		end

	wo_spell_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_spell);"
		end

	wo_cuc: INTEGER_32 assign set_wo_cuc
		do
			Result := c_wo_cuc (c_pointer)
		end

	wo_cuc_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_cuc);"
		end

	wo_cul: INTEGER_32 assign set_wo_cul
		do
			Result := c_wo_cul (c_pointer)
		end

	wo_cul_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_cul);"
		end

	wo_cc: CE_POINTER [NATURAL_8] assign set_wo_cc
		do
			create Result.make_shared (c_wo_cc (c_pointer))
		end

	wo_cc_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_cc);"
		end

	wo_stl: CE_POINTER [NATURAL_8] assign set_wo_stl
		do
			create Result.make_shared (c_wo_stl (c_pointer))
		end

	wo_stl_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_stl);"
		end

	wo_scb: INTEGER_32 assign set_wo_scb
		do
			Result := c_wo_scb (c_pointer)
		end

	wo_scb_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_scb);"
		end

	wo_wrap: INTEGER_32 assign set_wo_wrap
		do
			Result := c_wo_wrap (c_pointer)
		end

	wo_wrap_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_wrap);"
		end

	wo_crb: INTEGER_32 assign set_wo_crb
		do
			Result := c_wo_crb (c_pointer)
		end

	wo_crb_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct __anonstruct_winopt_T_515, wo_crb);"
		end

	wo_scriptID: CE_ARRAY [INTEGER_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_wo_scriptID (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_wo_diff (a_wo_diff: INTEGER_32)
		do
			c_set_wo_diff (c_pointer, a_wo_diff)
		end

	set_wo_fdc (a_wo_fdc: INTEGER_32)
		do
			c_set_wo_fdc (c_pointer, a_wo_fdc)
		end

	set_wo_fen (a_wo_fen: INTEGER_32)
		do
			c_set_wo_fen (c_pointer, a_wo_fen)
		end

	set_wo_fdi (a_wo_fdi: CE_POINTER [NATURAL_8])
		do
			c_set_wo_fdi (c_pointer, a_wo_fdi.c_pointer)
		end

	set_wo_fdl (a_wo_fdl: INTEGER_32)
		do
			c_set_wo_fdl (c_pointer, a_wo_fdl)
		end

	set_wo_fdm (a_wo_fdm: CE_POINTER [NATURAL_8])
		do
			c_set_wo_fdm (c_pointer, a_wo_fdm.c_pointer)
		end

	set_wo_fml (a_wo_fml: INTEGER_32)
		do
			c_set_wo_fml (c_pointer, a_wo_fml)
		end

	set_wo_fdn (a_wo_fdn: INTEGER_32)
		do
			c_set_wo_fdn (c_pointer, a_wo_fdn)
		end

	set_wo_fde (a_wo_fde: CE_POINTER [NATURAL_8])
		do
			c_set_wo_fde (c_pointer, a_wo_fde.c_pointer)
		end

	set_wo_fdt (a_wo_fdt: CE_POINTER [NATURAL_8])
		do
			c_set_wo_fdt (c_pointer, a_wo_fdt.c_pointer)
		end

	set_wo_fmr (a_wo_fmr: CE_POINTER [NATURAL_8])
		do
			c_set_wo_fmr (c_pointer, a_wo_fmr.c_pointer)
		end

	set_wo_lbr (a_wo_lbr: INTEGER_32)
		do
			c_set_wo_lbr (c_pointer, a_wo_lbr)
		end

	set_wo_list (a_wo_list: INTEGER_32)
		do
			c_set_wo_list (c_pointer, a_wo_list)
		end

	set_wo_nu (a_wo_nu: INTEGER_32)
		do
			c_set_wo_nu (c_pointer, a_wo_nu)
		end

	set_wo_rnu (a_wo_rnu: INTEGER_32)
		do
			c_set_wo_rnu (c_pointer, a_wo_rnu)
		end

	set_wo_nuw (a_wo_nuw: INTEGER_32)
		do
			c_set_wo_nuw (c_pointer, a_wo_nuw)
		end

	set_wo_wfh (a_wo_wfh: INTEGER_32)
		do
			c_set_wo_wfh (c_pointer, a_wo_wfh)
		end

	set_wo_wfw (a_wo_wfw: INTEGER_32)
		do
			c_set_wo_wfw (c_pointer, a_wo_wfw)
		end

	set_wo_pvw (a_wo_pvw: INTEGER_32)
		do
			c_set_wo_pvw (c_pointer, a_wo_pvw)
		end

	set_wo_scr (a_wo_scr: INTEGER_32)
		do
			c_set_wo_scr (c_pointer, a_wo_scr)
		end

	set_wo_spell (a_wo_spell: INTEGER_32)
		do
			c_set_wo_spell (c_pointer, a_wo_spell)
		end

	set_wo_cuc (a_wo_cuc: INTEGER_32)
		do
			c_set_wo_cuc (c_pointer, a_wo_cuc)
		end

	set_wo_cul (a_wo_cul: INTEGER_32)
		do
			c_set_wo_cul (c_pointer, a_wo_cul)
		end

	set_wo_cc (a_wo_cc: CE_POINTER [NATURAL_8])
		do
			c_set_wo_cc (c_pointer, a_wo_cc.c_pointer)
		end

	set_wo_stl (a_wo_stl: CE_POINTER [NATURAL_8])
		do
			c_set_wo_stl (c_pointer, a_wo_stl.c_pointer)
		end

	set_wo_scb (a_wo_scb: INTEGER_32)
		do
			c_set_wo_scb (c_pointer, a_wo_scb)
		end

	set_wo_wrap (a_wo_wrap: INTEGER_32)
		do
			c_set_wo_wrap (c_pointer, a_wo_wrap)
		end

	set_wo_crb (a_wo_crb: INTEGER_32)
		do
			c_set_wo_crb (c_pointer, a_wo_crb)
		end

feature {NONE} -- C getters

	c_wo_diff (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_diff;"
		end

	c_wo_fdc (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_fdc;"
		end

	c_wo_fen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_fen;"
		end

	c_wo_fdi (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_fdi;"
		end

	c_wo_fdl (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_fdl;"
		end

	c_wo_fdm (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_fdm;"
		end

	c_wo_fml (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_fml;"
		end

	c_wo_fdn (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_fdn;"
		end

	c_wo_fde (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_fde;"
		end

	c_wo_fdt (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_fdt;"
		end

	c_wo_fmr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_fmr;"
		end

	c_wo_lbr (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_lbr;"
		end

	c_wo_list (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_list;"
		end

	c_wo_nu (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_nu;"
		end

	c_wo_rnu (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_rnu;"
		end

	c_wo_nuw (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_nuw;"
		end

	c_wo_wfh (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_wfh;"
		end

	c_wo_wfw (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_wfw;"
		end

	c_wo_pvw (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_pvw;"
		end

	c_wo_scr (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_scr;"
		end

	c_wo_spell (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_spell;"
		end

	c_wo_cuc (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_cuc;"
		end

	c_wo_cul (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_cul;"
		end

	c_wo_cc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_cc;"
		end

	c_wo_stl (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_stl;"
		end

	c_wo_scb (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_scb;"
		end

	c_wo_wrap (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_wrap;"
		end

	c_wo_crb (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_winopt_T_515 *)$tmp)->wo_crb;"
		end

	c_wo_scriptID (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_winopt_T_515 *tmp = (struct __anonstruct_winopt_T_515 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->wo_scriptID) / sizeof(tmp->wo_scriptID[0]);
				return tmp->wo_scriptID;
			]"
		end

feature {NONE} -- C setters

	c_set_wo_diff (tmp: POINTER; a_wo_diff: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_diff = $a_wo_diff;"
		end

	c_set_wo_fdc (tmp: POINTER; a_wo_fdc: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_fdc = $a_wo_fdc;"
		end

	c_set_wo_fen (tmp: POINTER; a_wo_fen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_fen = $a_wo_fen;"
		end

	c_set_wo_fdi (tmp: POINTER; a_wo_fdi: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_fdi = (unsigned char *)$a_wo_fdi;"
		end

	c_set_wo_fdl (tmp: POINTER; a_wo_fdl: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_fdl = $a_wo_fdl;"
		end

	c_set_wo_fdm (tmp: POINTER; a_wo_fdm: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_fdm = (unsigned char *)$a_wo_fdm;"
		end

	c_set_wo_fml (tmp: POINTER; a_wo_fml: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_fml = $a_wo_fml;"
		end

	c_set_wo_fdn (tmp: POINTER; a_wo_fdn: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_fdn = $a_wo_fdn;"
		end

	c_set_wo_fde (tmp: POINTER; a_wo_fde: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_fde = (unsigned char *)$a_wo_fde;"
		end

	c_set_wo_fdt (tmp: POINTER; a_wo_fdt: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_fdt = (unsigned char *)$a_wo_fdt;"
		end

	c_set_wo_fmr (tmp: POINTER; a_wo_fmr: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_fmr = (unsigned char *)$a_wo_fmr;"
		end

	c_set_wo_lbr (tmp: POINTER; a_wo_lbr: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_lbr = $a_wo_lbr;"
		end

	c_set_wo_list (tmp: POINTER; a_wo_list: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_list = $a_wo_list;"
		end

	c_set_wo_nu (tmp: POINTER; a_wo_nu: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_nu = $a_wo_nu;"
		end

	c_set_wo_rnu (tmp: POINTER; a_wo_rnu: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_rnu = $a_wo_rnu;"
		end

	c_set_wo_nuw (tmp: POINTER; a_wo_nuw: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_nuw = $a_wo_nuw;"
		end

	c_set_wo_wfh (tmp: POINTER; a_wo_wfh: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_wfh = $a_wo_wfh;"
		end

	c_set_wo_wfw (tmp: POINTER; a_wo_wfw: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_wfw = $a_wo_wfw;"
		end

	c_set_wo_pvw (tmp: POINTER; a_wo_pvw: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_pvw = $a_wo_pvw;"
		end

	c_set_wo_scr (tmp: POINTER; a_wo_scr: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_scr = $a_wo_scr;"
		end

	c_set_wo_spell (tmp: POINTER; a_wo_spell: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_spell = $a_wo_spell;"
		end

	c_set_wo_cuc (tmp: POINTER; a_wo_cuc: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_cuc = $a_wo_cuc;"
		end

	c_set_wo_cul (tmp: POINTER; a_wo_cul: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_cul = $a_wo_cul;"
		end

	c_set_wo_cc (tmp: POINTER; a_wo_cc: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_cc = (unsigned char *)$a_wo_cc;"
		end

	c_set_wo_stl (tmp: POINTER; a_wo_stl: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_stl = (unsigned char *)$a_wo_stl;"
		end

	c_set_wo_scb (tmp: POINTER; a_wo_scb: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_scb = $a_wo_scb;"
		end

	c_set_wo_wrap (tmp: POINTER; a_wo_wrap: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_wrap = $a_wo_wrap;"
		end

	c_set_wo_crb (tmp: POINTER; a_wo_crb: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_winopt_T_515 *)$tmp)->wo_crb = $a_wo_crb;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_winopt_T_515);"
		end

end
