class
	PD_WN_U1

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	hashkey: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_hashkey (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	index: INTEGER_32 assign set_index
		do
			Result := c_index (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_index (a_index: INTEGER_32)
		do
			c_set_index (c_pointer, a_index)
		end

feature {NONE} -- C getters

	c_hashkey (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				union __anonunion_wn_u1_544 *tmp = (union __anonunion_wn_u1_544 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->hashkey) / sizeof(tmp->hashkey[0]);
				return tmp->hashkey;
			]"
		end

	c_index (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((union __anonunion_wn_u1_544 *)$tmp)->index;"
		end

feature {NONE} -- C setters

	c_set_index (tmp: POINTER; a_index: INTEGER_32)
		external
			"C inline"
		alias
			"((union __anonunion_wn_u1_544 *)$tmp)->index = $a_index;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(union __anonunion_wn_u1_544);"
		end

end
