class
	PD_WN_U2

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	next: CE_POINTER [PD_WORDNODE_S] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

	wnode: CE_POINTER [PD_WORDNODE_S] assign set_wnode
		do
			create Result.make_shared (c_wnode (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_next (a_next: CE_POINTER [PD_WORDNODE_S])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

	set_wnode (a_wnode: CE_POINTER [PD_WORDNODE_S])
		do
			c_set_wnode (c_pointer, a_wnode.c_pointer)
		end

feature {NONE} -- C getters

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct wordnode_S *)((union __anonunion_wn_u2_545 *)$tmp)->next;"
		end

	c_wnode (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct wordnode_S *)((union __anonunion_wn_u2_545 *)$tmp)->wnode;"
		end

feature {NONE} -- C setters

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_wn_u2_545 *)$tmp)->next = (struct wordnode_S *)$a_next;"
		end

	c_set_wnode (tmp: POINTER; a_wnode: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_wn_u2_545 *)$tmp)->wnode = (struct wordnode_S *)$a_wnode;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(union __anonunion_wn_u2_545);"
		end

end
