class
	PD_XFILEMARK

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	fmark: PD_FILEMARK assign set_fmark
		do
			create Result.make_shared (c_fmark (c_pointer))
		end

	fmark_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct xfilemark, fmark);"
		end

	fname: CE_POINTER [NATURAL_8] assign set_fname
		do
			create Result.make_shared (c_fname (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_fmark (a_fmark: PD_FILEMARK)
		do
			fmark.ce_gets (a_fmark)
		end

	set_fname (a_fname: CE_POINTER [NATURAL_8])
		do
			c_set_fname (c_pointer, a_fname.c_pointer)
		end

feature {NONE} -- C getters

	c_fmark (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct filemark *)&((struct xfilemark *)$tmp)->fmark;"
		end

	c_fname (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char *)((struct xfilemark *)$tmp)->fname;"
		end

feature {NONE} -- C setters

	c_set_fname (tmp: POINTER; a_fname: POINTER)
		external
			"C inline"
		alias
			"((struct xfilemark *)$tmp)->fname = (unsigned char *)$a_fname;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct xfilemark);"
		end

end
