class
	PD_YANKREG

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	y_array: CE_POINTER [CE_POINTER [NATURAL_8]] assign set_y_array
		do
			create Result.make_shared (c_y_array (c_pointer))
		end

	y_size: INTEGER_32 assign set_y_size
		do
			Result := c_y_size (c_pointer)
		end

	y_type: NATURAL_8 assign set_y_type
		do
			Result := c_y_type (c_pointer)
		end

	y_width: INTEGER_32 assign set_y_width
		do
			Result := c_y_width (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_y_array (a_y_array: CE_POINTER [CE_POINTER [NATURAL_8]])
		do
			c_set_y_array (c_pointer, a_y_array.c_pointer)
		end

	set_y_size (a_y_size: INTEGER_32)
		do
			c_set_y_size (c_pointer, a_y_size)
		end

	set_y_type (a_y_type: NATURAL_8)
		do
			c_set_y_type (c_pointer, a_y_type)
		end

	set_y_width (a_y_width: INTEGER_32)
		do
			c_set_y_width (c_pointer, a_y_width)
		end

feature {NONE} -- C getters

	c_y_array (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned char * *)((struct yankreg *)$tmp)->y_array;"
		end

	c_y_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct yankreg *)$tmp)->y_size;"
		end

	c_y_type (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct yankreg *)$tmp)->y_type;"
		end

	c_y_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct yankreg *)$tmp)->y_width;"
		end

feature {NONE} -- C setters

	c_set_y_array (tmp: POINTER; a_y_array: POINTER)
		external
			"C inline"
		alias
			"((struct yankreg *)$tmp)->y_array = (unsigned char * *)$a_y_array;"
		end

	c_set_y_size (tmp: POINTER; a_y_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct yankreg *)$tmp)->y_size = $a_y_size;"
		end

	c_set_y_type (tmp: POINTER; a_y_type: NATURAL_8)
		external
			"C inline"
		alias
			"((struct yankreg *)$tmp)->y_type = $a_y_type;"
		end

	c_set_y_width (tmp: POINTER; a_y_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct yankreg *)$tmp)->y_width = $a_y_width;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct yankreg);"
		end

end
