frozen class
	VIM_INITIALIZER_SLICE38

inherit
	VIM_DATA
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {VIM_INITIALIZER}

	initialize
		do
			normal_inst.nv_cmds[25].cmd_func := normal_inst.nv_window_address
			normal_inst.nv_cmds[25].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[25].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[26].cmd_char := 24
			normal_inst.nv_cmds[26].cmd_func := normal_inst.nv_addsub_address
			normal_inst.nv_cmds[26].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[26].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[27].cmd_char := 25
			normal_inst.nv_cmds[27].cmd_func := normal_inst.nv_scroll_line_address
			normal_inst.nv_cmds[27].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[27].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[28].cmd_char := 26
			normal_inst.nv_cmds[28].cmd_func := normal_inst.nv_suspend_address
			normal_inst.nv_cmds[28].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[28].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[29].cmd_char := ('%/27/').code
			normal_inst.nv_cmds[29].cmd_func := normal_inst.nv_esc_address
			normal_inst.nv_cmds[29].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[29].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[30].cmd_char := 28
			normal_inst.nv_cmds[30].cmd_func := normal_inst.nv_normal_address
			normal_inst.nv_cmds[30].cmd_flags := (5).to_natural_16
			normal_inst.nv_cmds[30].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[31].cmd_char := 29
			normal_inst.nv_cmds[31].cmd_func := normal_inst.nv_ident_address
			normal_inst.nv_cmds[31].cmd_flags := (512).to_natural_16
			normal_inst.nv_cmds[31].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[32].cmd_char := 30
			normal_inst.nv_cmds[32].cmd_func := normal_inst.nv_hat_address
			normal_inst.nv_cmds[32].cmd_flags := (512).to_natural_16
			normal_inst.nv_cmds[32].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[33].cmd_char := 31
			normal_inst.nv_cmds[33].cmd_func := normal_inst.nv_error_address
			normal_inst.nv_cmds[33].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[33].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[34].cmd_char := (' ').code
			normal_inst.nv_cmds[34].cmd_func := normal_inst.nv_right_address
			normal_inst.nv_cmds[34].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[34].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[35].cmd_char := ('!').code
			normal_inst.nv_cmds[35].cmd_func := normal_inst.nv_operator_address
			normal_inst.nv_cmds[35].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[35].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[36].cmd_char := ('%"').code
			normal_inst.nv_cmds[36].cmd_func := normal_inst.nv_regname_address
			normal_inst.nv_cmds[36].cmd_flags := (259).to_natural_16
			normal_inst.nv_cmds[36].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[37].cmd_char := ('#').code
			normal_inst.nv_cmds[37].cmd_func := normal_inst.nv_ident_address
			normal_inst.nv_cmds[37].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[37].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[38].cmd_char := ('$').code
			normal_inst.nv_cmds[38].cmd_func := normal_inst.nv_dollar_address
			normal_inst.nv_cmds[38].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[38].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[39].cmd_char := ('%%').code
			normal_inst.nv_cmds[39].cmd_func := normal_inst.nv_percent_address
			normal_inst.nv_cmds[39].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[39].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[40].cmd_char := ('&').code
			normal_inst.nv_cmds[40].cmd_func := normal_inst.nv_optrans_address
			normal_inst.nv_cmds[40].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[40].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[41].cmd_char := ('%'').code
			normal_inst.nv_cmds[41].cmd_func := normal_inst.nv_gomark_address
			normal_inst.nv_cmds[41].cmd_flags := (5).to_natural_16
			normal_inst.nv_cmds[41].cmd_arg := (1).to_integer_16
			normal_inst.nv_cmds[42].cmd_char := ('(').code
			normal_inst.nv_cmds[42].cmd_func := normal_inst.nv_brace_address
			normal_inst.nv_cmds[42].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[42].cmd_arg := (-1).to_integer_16
			normal_inst.nv_cmds[43].cmd_char := (')').code
			normal_inst.nv_cmds[43].cmd_func := normal_inst.nv_brace_address
			normal_inst.nv_cmds[43].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[43].cmd_arg := (1).to_integer_16
			normal_inst.nv_cmds[44].cmd_char := ('*').code
			normal_inst.nv_cmds[44].cmd_func := normal_inst.nv_ident_address
			normal_inst.nv_cmds[44].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[44].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[45].cmd_char := ('+').code
			normal_inst.nv_cmds[45].cmd_func := normal_inst.nv_down_address
			normal_inst.nv_cmds[45].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[45].cmd_arg := (1).to_integer_16
			normal_inst.nv_cmds[46].cmd_char := (',').code
			normal_inst.nv_cmds[46].cmd_func := normal_inst.nv_csearch_address
			normal_inst.nv_cmds[46].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[46].cmd_arg := (1).to_integer_16
			normal_inst.nv_cmds[47].cmd_char := ('-').code
			normal_inst.nv_cmds[47].cmd_func := normal_inst.nv_up_address
			normal_inst.nv_cmds[47].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[47].cmd_arg := (1).to_integer_16
			normal_inst.nv_cmds[48].cmd_char := ('.').code
			normal_inst.nv_cmds[48].cmd_func := normal_inst.nv_dot_address
			normal_inst.nv_cmds[48].cmd_flags := (256).to_natural_16
			normal_inst.nv_cmds[48].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[49].cmd_char := ('/').code
			normal_inst.nv_cmds[49].cmd_func := normal_inst.nv_search_address
			normal_inst.nv_cmds[49].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[49].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[50].cmd_char := ('0').code
			normal_inst.nv_cmds[50].cmd_func := normal_inst.nv_beginline_address
			normal_inst.nv_cmds[50].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[50].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[51].cmd_char := ('1').code
			normal_inst.nv_cmds[51].cmd_func := normal_inst.nv_ignore_address
			normal_inst.nv_cmds[51].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[51].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[52].cmd_char := ('2').code
			normal_inst.nv_cmds[52].cmd_func := normal_inst.nv_ignore_address
			normal_inst.nv_cmds[52].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[52].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[53].cmd_char := ('3').code
			normal_inst.nv_cmds[53].cmd_func := normal_inst.nv_ignore_address
			normal_inst.nv_cmds[53].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[53].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[54].cmd_char := ('4').code
			normal_inst.nv_cmds[54].cmd_func := normal_inst.nv_ignore_address
			normal_inst.nv_cmds[54].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[54].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[55].cmd_char := ('5').code
			normal_inst.nv_cmds[55].cmd_func := normal_inst.nv_ignore_address
			normal_inst.nv_cmds[55].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[55].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[56].cmd_char := ('6').code
			normal_inst.nv_cmds[56].cmd_func := normal_inst.nv_ignore_address
			normal_inst.nv_cmds[56].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[56].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[57].cmd_char := ('7').code
			normal_inst.nv_cmds[57].cmd_func := normal_inst.nv_ignore_address
			normal_inst.nv_cmds[57].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[57].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[58].cmd_char := ('8').code
			normal_inst.nv_cmds[58].cmd_func := normal_inst.nv_ignore_address
			normal_inst.nv_cmds[58].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[58].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[59].cmd_char := ('9').code
			normal_inst.nv_cmds[59].cmd_func := normal_inst.nv_ignore_address
			normal_inst.nv_cmds[59].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[59].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[60].cmd_char := (':').code
			normal_inst.nv_cmds[60].cmd_func := normal_inst.nv_colon_address
			normal_inst.nv_cmds[60].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[60].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[61].cmd_char := (';').code
			normal_inst.nv_cmds[61].cmd_func := normal_inst.nv_csearch_address
			normal_inst.nv_cmds[61].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[61].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[62].cmd_char := ('<').code
			normal_inst.nv_cmds[62].cmd_func := normal_inst.nv_operator_address
			normal_inst.nv_cmds[62].cmd_flags := (128).to_natural_16
			normal_inst.nv_cmds[62].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[63].cmd_char := ('=').code
			normal_inst.nv_cmds[63].cmd_func := normal_inst.nv_operator_address
			normal_inst.nv_cmds[63].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[63].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[64].cmd_char := ('>').code
			normal_inst.nv_cmds[64].cmd_func := normal_inst.nv_operator_address
			normal_inst.nv_cmds[64].cmd_flags := (128).to_natural_16
			normal_inst.nv_cmds[64].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[65].cmd_char := ('?').code
			normal_inst.nv_cmds[65].cmd_func := normal_inst.nv_search_address
			normal_inst.nv_cmds[65].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[65].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[66].cmd_char := ('@').code
			normal_inst.nv_cmds[66].cmd_func := normal_inst.nv_at_address
			normal_inst.nv_cmds[66].cmd_flags := (3).to_natural_16
			normal_inst.nv_cmds[66].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[67].cmd_char := ('A').code
			normal_inst.nv_cmds[67].cmd_func := normal_inst.nv_edit_address
			normal_inst.nv_cmds[67].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[67].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[68].cmd_char := ('B').code
			normal_inst.nv_cmds[68].cmd_func := normal_inst.nv_bck_word_address
			normal_inst.nv_cmds[68].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[68].cmd_arg := (1).to_integer_16
			normal_inst.nv_cmds[69].cmd_char := ('C').code
			normal_inst.nv_cmds[69].cmd_func := normal_inst.nv_abbrev_address
			normal_inst.nv_cmds[69].cmd_flags := (256).to_natural_16
			normal_inst.nv_cmds[69].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[70].cmd_char := ('D').code
			normal_inst.nv_cmds[70].cmd_func := normal_inst.nv_abbrev_address
			normal_inst.nv_cmds[70].cmd_flags := (256).to_natural_16
			normal_inst.nv_cmds[70].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[71].cmd_char := ('E').code
			normal_inst.nv_cmds[71].cmd_func := normal_inst.nv_wordcmd_address
			normal_inst.nv_cmds[71].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[71].cmd_arg := (1).to_integer_16
			normal_inst.nv_cmds[72].cmd_char := ('F').code
			normal_inst.nv_cmds[72].cmd_func := normal_inst.nv_csearch_address
			normal_inst.nv_cmds[72].cmd_flags := (13).to_natural_16
			normal_inst.nv_cmds[72].cmd_arg := (-1).to_integer_16
			normal_inst.nv_cmds[73].cmd_char := ('G').code
			normal_inst.nv_cmds[73].cmd_func := normal_inst.nv_goto_address
			normal_inst.nv_cmds[73].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[73].cmd_arg := (1).to_integer_16
			normal_inst.nv_cmds[74].cmd_char := ('H').code
			normal_inst.nv_cmds[74].cmd_func := normal_inst.nv_scroll_address
			normal_inst.nv_cmds[74].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[74].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[75].cmd_char := ('I').code
			normal_inst.nv_cmds[75].cmd_func := normal_inst.nv_edit_address
			normal_inst.nv_cmds[75].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[75].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[76].cmd_char := ('J').code
			normal_inst.nv_cmds[76].cmd_func := normal_inst.nv_join_address
			normal_inst.nv_cmds[76].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[76].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[77].cmd_char := ('K').code
			normal_inst.nv_cmds[77].cmd_func := normal_inst.nv_ident_address
			normal_inst.nv_cmds[77].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[77].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[78].cmd_char := ('L').code
			normal_inst.nv_cmds[78].cmd_func := normal_inst.nv_scroll_address
			normal_inst.nv_cmds[78].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[78].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[79].cmd_char := ('M').code
			normal_inst.nv_cmds[79].cmd_func := normal_inst.nv_scroll_address
			normal_inst.nv_cmds[79].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[79].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[80].cmd_char := ('N').code
			normal_inst.nv_cmds[80].cmd_func := normal_inst.nv_next_address
			normal_inst.nv_cmds[80].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[80].cmd_arg := (1).to_integer_16
			normal_inst.nv_cmds[81].cmd_char := ('O').code
			normal_inst.nv_cmds[81].cmd_func := normal_inst.nv_open_address
			normal_inst.nv_cmds[81].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[81].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[82].cmd_char := ('P').code
			normal_inst.nv_cmds[82].cmd_func := normal_inst.nv_put_address
			normal_inst.nv_cmds[82].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[82].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[83].cmd_char := ('Q').code
			normal_inst.nv_cmds[83].cmd_func := normal_inst.nv_exmode_address
			normal_inst.nv_cmds[83].cmd_flags := (512).to_natural_16
			normal_inst.nv_cmds[83].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[84].cmd_char := ('R').code
			normal_inst.nv_cmds[84].cmd_func := normal_inst.nv_Replace2_address
			normal_inst.nv_cmds[84].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[84].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[85].cmd_char := ('S').code
			normal_inst.nv_cmds[85].cmd_func := normal_inst.nv_subst_address
			normal_inst.nv_cmds[85].cmd_flags := (256).to_natural_16
			normal_inst.nv_cmds[85].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[86].cmd_char := ('T').code
			normal_inst.nv_cmds[86].cmd_func := normal_inst.nv_csearch_address
			normal_inst.nv_cmds[86].cmd_flags := (13).to_natural_16
			normal_inst.nv_cmds[86].cmd_arg := (-1).to_integer_16
			normal_inst.nv_cmds[87].cmd_char := ('U').code
			normal_inst.nv_cmds[87].cmd_func := normal_inst.nv_Undo2_address
			normal_inst.nv_cmds[87].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[87].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[88].cmd_char := ('W').code
			normal_inst.nv_cmds[88].cmd_func := normal_inst.nv_wordcmd_address
			normal_inst.nv_cmds[88].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[88].cmd_arg := (1).to_integer_16
			normal_inst.nv_cmds[89].cmd_char := ('X').code
			normal_inst.nv_cmds[89].cmd_func := normal_inst.nv_abbrev_address
			normal_inst.nv_cmds[89].cmd_flags := (256).to_natural_16
			normal_inst.nv_cmds[89].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[90].cmd_char := ('Y').code
			normal_inst.nv_cmds[90].cmd_func := normal_inst.nv_abbrev_address
			normal_inst.nv_cmds[90].cmd_flags := (256).to_natural_16
			normal_inst.nv_cmds[90].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[91].cmd_char := ('Z').code
			normal_inst.nv_cmds[91].cmd_func := normal_inst.nv_Zet2_address
			normal_inst.nv_cmds[91].cmd_flags := (515).to_natural_16
			normal_inst.nv_cmds[91].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[92].cmd_char := ('[').code
			normal_inst.nv_cmds[92].cmd_func := normal_inst.nv_brackets_address
			normal_inst.nv_cmds[92].cmd_flags := (5).to_natural_16
			normal_inst.nv_cmds[92].cmd_arg := (-1).to_integer_16
			normal_inst.nv_cmds[93].cmd_char := ('\').code
			normal_inst.nv_cmds[93].cmd_func := normal_inst.nv_error_address
			normal_inst.nv_cmds[93].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[93].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[94].cmd_char := (']').code
			normal_inst.nv_cmds[94].cmd_func := normal_inst.nv_brackets_address
			normal_inst.nv_cmds[94].cmd_flags := (5).to_natural_16
			normal_inst.nv_cmds[94].cmd_arg := (1).to_integer_16
			normal_inst.nv_cmds[95].cmd_char := ('^').code
			normal_inst.nv_cmds[95].cmd_func := normal_inst.nv_beginline_address
			normal_inst.nv_cmds[95].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[95].cmd_arg := (5).to_integer_16
			normal_inst.nv_cmds[96].cmd_char := ('_').code
			normal_inst.nv_cmds[96].cmd_func := normal_inst.nv_lineop_address
			normal_inst.nv_cmds[96].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[96].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[97].cmd_char := ('`').code
			normal_inst.nv_cmds[97].cmd_func := normal_inst.nv_gomark_address
			normal_inst.nv_cmds[97].cmd_flags := (5).to_natural_16
			normal_inst.nv_cmds[97].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[98].cmd_char := ('a').code
			normal_inst.nv_cmds[98].cmd_func := normal_inst.nv_edit_address
			normal_inst.nv_cmds[98].cmd_flags := (1).to_natural_16
			normal_inst.nv_cmds[98].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[99].cmd_char := ('b').code
			normal_inst.nv_cmds[99].cmd_func := normal_inst.nv_bck_word_address
			normal_inst.nv_cmds[99].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[99].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[100].cmd_char := ('c').code
			normal_inst.nv_cmds[100].cmd_func := normal_inst.nv_operator_address
			normal_inst.nv_cmds[100].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[100].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[101].cmd_char := ('d').code
			normal_inst.nv_cmds[101].cmd_func := normal_inst.nv_operator_address
			normal_inst.nv_cmds[101].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[101].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[102].cmd_char := ('e').code
			normal_inst.nv_cmds[102].cmd_func := normal_inst.nv_wordcmd_address
			normal_inst.nv_cmds[102].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[102].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[103].cmd_char := ('f').code
			normal_inst.nv_cmds[103].cmd_func := normal_inst.nv_csearch_address
			normal_inst.nv_cmds[103].cmd_flags := (13).to_natural_16
			normal_inst.nv_cmds[103].cmd_arg := (1).to_integer_16
			normal_inst.nv_cmds[104].cmd_char := ('g').code
			normal_inst.nv_cmds[104].cmd_func := normal_inst.nv_g_cmd_address
			normal_inst.nv_cmds[104].cmd_flags := (5).to_natural_16
			normal_inst.nv_cmds[104].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[105].cmd_char := ('h').code
			normal_inst.nv_cmds[105].cmd_func := normal_inst.nv_left_address
			normal_inst.nv_cmds[105].cmd_flags := (128).to_natural_16
			normal_inst.nv_cmds[105].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[106].cmd_char := ('i').code
			normal_inst.nv_cmds[106].cmd_func := normal_inst.nv_edit_address
			normal_inst.nv_cmds[106].cmd_flags := (1).to_natural_16
			normal_inst.nv_cmds[106].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[107].cmd_char := ('j').code
			normal_inst.nv_cmds[107].cmd_func := normal_inst.nv_down_address
			normal_inst.nv_cmds[107].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[107].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[108].cmd_char := ('k').code
			normal_inst.nv_cmds[108].cmd_func := normal_inst.nv_up_address
			normal_inst.nv_cmds[108].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[108].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[109].cmd_char := ('l').code
			normal_inst.nv_cmds[109].cmd_func := normal_inst.nv_right_address
			normal_inst.nv_cmds[109].cmd_flags := (128).to_natural_16
			normal_inst.nv_cmds[109].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[110].cmd_char := ('m').code
			normal_inst.nv_cmds[110].cmd_func := normal_inst.nv_mark_address
			normal_inst.nv_cmds[110].cmd_flags := (3).to_natural_16
			normal_inst.nv_cmds[110].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[111].cmd_char := ('n').code
			normal_inst.nv_cmds[111].cmd_func := normal_inst.nv_next_address
			normal_inst.nv_cmds[111].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[111].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[112].cmd_char := ('o').code
			normal_inst.nv_cmds[112].cmd_func := normal_inst.nv_open_address
			normal_inst.nv_cmds[112].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[112].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[113].cmd_char := ('p').code
			normal_inst.nv_cmds[113].cmd_func := normal_inst.nv_put_address
			normal_inst.nv_cmds[113].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[113].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[114].cmd_char := ('q').code
			normal_inst.nv_cmds[114].cmd_func := normal_inst.nv_record_address
			normal_inst.nv_cmds[114].cmd_flags := (1).to_natural_16
			normal_inst.nv_cmds[114].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[115].cmd_char := ('r').code
			normal_inst.nv_cmds[115].cmd_func := normal_inst.nv_replace_address
			normal_inst.nv_cmds[115].cmd_flags := (11).to_natural_16
			normal_inst.nv_cmds[115].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[116].cmd_char := ('s').code
			normal_inst.nv_cmds[116].cmd_func := normal_inst.nv_subst_address
			normal_inst.nv_cmds[116].cmd_flags := (256).to_natural_16
			normal_inst.nv_cmds[116].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[117].cmd_char := ('t').code
			normal_inst.nv_cmds[117].cmd_func := normal_inst.nv_csearch_address
			normal_inst.nv_cmds[117].cmd_flags := (13).to_natural_16
			normal_inst.nv_cmds[117].cmd_arg := (1).to_integer_16
			normal_inst.nv_cmds[118].cmd_char := ('u').code
			normal_inst.nv_cmds[118].cmd_func := normal_inst.nv_undo_address
			normal_inst.nv_cmds[118].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[118].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[119].cmd_char := ('w').code
			normal_inst.nv_cmds[119].cmd_func := normal_inst.nv_wordcmd_address
			normal_inst.nv_cmds[119].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[119].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[120].cmd_char := ('x').code
			normal_inst.nv_cmds[120].cmd_func := normal_inst.nv_abbrev_address
			normal_inst.nv_cmds[120].cmd_flags := (256).to_natural_16
			normal_inst.nv_cmds[120].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[121].cmd_char := ('y').code
			normal_inst.nv_cmds[121].cmd_func := normal_inst.nv_operator_address
			normal_inst.nv_cmds[121].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[121].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[122].cmd_char := ('z').code
			normal_inst.nv_cmds[122].cmd_func := normal_inst.nv_zet_address
			normal_inst.nv_cmds[122].cmd_flags := (5).to_natural_16
			normal_inst.nv_cmds[122].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[123].cmd_char := ('{').code
			normal_inst.nv_cmds[123].cmd_func := normal_inst.nv_findpar_address
			normal_inst.nv_cmds[123].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[123].cmd_arg := (-1).to_integer_16
			normal_inst.nv_cmds[124].cmd_char := ('|').code
			normal_inst.nv_cmds[124].cmd_func := normal_inst.nv_pipe_address
			normal_inst.nv_cmds[124].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[124].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[125].cmd_char := ('}').code
			normal_inst.nv_cmds[125].cmd_func := normal_inst.nv_findpar_address
			normal_inst.nv_cmds[125].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[125].cmd_arg := (1).to_integer_16
			normal_inst.nv_cmds[126].cmd_char := ('~').code
			normal_inst.nv_cmds[126].cmd_func := normal_inst.nv_tilde_address
			normal_inst.nv_cmds[126].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[126].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[127].cmd_char := 163
			normal_inst.nv_cmds[127].cmd_func := normal_inst.nv_ident_address
			normal_inst.nv_cmds[127].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[127].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[128].cmd_char := -(253 + ((76).bit_shift_left (8)))
			normal_inst.nv_cmds[128].cmd_func := normal_inst.nv_mousescroll_address
			normal_inst.nv_cmds[128].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[128].cmd_arg := (1).to_integer_16
			normal_inst.nv_cmds[129].cmd_char := -(253 + ((75).bit_shift_left (8)))
			normal_inst.nv_cmds[129].cmd_func := normal_inst.nv_mousescroll_address
			normal_inst.nv_cmds[129].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[129].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[130].cmd_char := -(253 + ((77).bit_shift_left (8)))
			normal_inst.nv_cmds[130].cmd_func := normal_inst.nv_mousescroll_address
			normal_inst.nv_cmds[130].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[130].cmd_arg := (-1).to_integer_16
			normal_inst.nv_cmds[131].cmd_char := -(253 + ((78).bit_shift_left (8)))
			normal_inst.nv_cmds[131].cmd_func := normal_inst.nv_mousescroll_address
			normal_inst.nv_cmds[131].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[131].cmd_arg := (-2).to_integer_16
			normal_inst.nv_cmds[132].cmd_char := -(253 + ((44).bit_shift_left (8)))
			normal_inst.nv_cmds[132].cmd_func := normal_inst.nv_mouse_address
			normal_inst.nv_cmds[132].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[132].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[133].cmd_char := -(253 + ((69).bit_shift_left (8)))
			normal_inst.nv_cmds[133].cmd_func := normal_inst.nv_mouse_address
			normal_inst.nv_cmds[133].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[133].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[134].cmd_char := -(253 + ((45).bit_shift_left (8)))
			normal_inst.nv_cmds[134].cmd_func := normal_inst.nv_mouse_address
			normal_inst.nv_cmds[134].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[134].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[135].cmd_char := -(253 + ((46).bit_shift_left (8)))
			normal_inst.nv_cmds[135].cmd_func := normal_inst.nv_mouse_address
			normal_inst.nv_cmds[135].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[135].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[136].cmd_char := -(253 + ((70).bit_shift_left (8)))
			normal_inst.nv_cmds[136].cmd_func := normal_inst.nv_mouse_address
			normal_inst.nv_cmds[136].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[136].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[137].cmd_char := -(253 + ((47).bit_shift_left (8)))
			normal_inst.nv_cmds[137].cmd_func := normal_inst.nv_mouse_address
			normal_inst.nv_cmds[137].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[137].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[138].cmd_char := -(253 + ((48).bit_shift_left (8)))
			normal_inst.nv_cmds[138].cmd_func := normal_inst.nv_mouse_address
			normal_inst.nv_cmds[138].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[138].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[139].cmd_char := -(253 + ((49).bit_shift_left (8)))
			normal_inst.nv_cmds[139].cmd_func := normal_inst.nv_mouse_address
			normal_inst.nv_cmds[139].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[139].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[140].cmd_char := -(253 + ((50).bit_shift_left (8)))
			normal_inst.nv_cmds[140].cmd_func := normal_inst.nv_mouse_address
			normal_inst.nv_cmds[140].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[140].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[141].cmd_char := -(253 + ((51).bit_shift_left (8)))
			normal_inst.nv_cmds[141].cmd_func := normal_inst.nv_mouse_address
			normal_inst.nv_cmds[141].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[141].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[142].cmd_char := -(253 + ((52).bit_shift_left (8)))
			normal_inst.nv_cmds[142].cmd_func := normal_inst.nv_mouse_address
			normal_inst.nv_cmds[142].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[142].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[143].cmd_char := -(253 + ((89).bit_shift_left (8)))
			normal_inst.nv_cmds[143].cmd_func := normal_inst.nv_mouse_address
			normal_inst.nv_cmds[143].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[143].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[144].cmd_char := -(253 + ((90).bit_shift_left (8)))
			normal_inst.nv_cmds[144].cmd_func := normal_inst.nv_mouse_address
			normal_inst.nv_cmds[144].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[144].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[145].cmd_char := -(253 + ((91).bit_shift_left (8)))
			normal_inst.nv_cmds[145].cmd_func := normal_inst.nv_mouse_address
			normal_inst.nv_cmds[145].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[145].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[146].cmd_char := -(253 + ((92).bit_shift_left (8)))
			normal_inst.nv_cmds[146].cmd_func := normal_inst.nv_mouse_address
			normal_inst.nv_cmds[146].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[146].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[147].cmd_char := -(253 + ((93).bit_shift_left (8)))
			normal_inst.nv_cmds[147].cmd_func := normal_inst.nv_mouse_address
			normal_inst.nv_cmds[147].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[147].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[148].cmd_char := -(253 + ((94).bit_shift_left (8)))
			normal_inst.nv_cmds[148].cmd_func := normal_inst.nv_mouse_address
			normal_inst.nv_cmds[148].cmd_flags := (0).to_natural_16
			normal_inst.nv_cmds[148].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[149].cmd_char := -(253 + ((53).bit_shift_left (8)))
			normal_inst.nv_cmds[149].cmd_func := normal_inst.nv_ignore_address
			normal_inst.nv_cmds[149].cmd_flags := (256).to_natural_16
			normal_inst.nv_cmds[149].cmd_arg := (0).to_integer_16
			normal_inst.nv_cmds[150].cmd_char := -(253 + ((97).bit_shift_left (8)))
		end

end
