frozen class
	VIM_INITIALIZER_SLICE40

inherit
	VIM_DATA
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {VIM_INITIALIZER}

	initialize
		do
			option_inst.options[17].scriptID := 0
			option_inst.options[18].fullname := ce_string ("backupext")
			option_inst.options[18].shortname := ce_string ("bex")
			option_inst.options[18].flags := (2098180).to_natural_32
			option_inst.options[18].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_bex.address))
			option_inst.options[18].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[18].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("~"))
			option_inst.options[18].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[18].scriptID := 0
			option_inst.options[19].fullname := ce_string ("backupskip")
			option_inst.options[19].shortname := ce_string ("bsk")
			option_inst.options[19].flags := (33796).to_natural_32
			option_inst.options[19].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_bsk.address))
			option_inst.options[19].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[19].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[19].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[19].scriptID := 0
			option_inst.options[20].fullname := ce_string ("balloondelay")
			option_inst.options[20].shortname := ce_string ("bdlay")
			option_inst.options[20].flags := (1026).to_natural_32
			option_inst.options[20].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_bdlay_address))
			option_inst.options[20].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[20].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 600)
			option_inst.options[20].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[20].scriptID := 0
			option_inst.options[21].fullname := ce_string ("ballooneval")
			option_inst.options[21].shortname := ce_string ("beval")
			option_inst.options[21].flags := (1537).to_natural_32
			option_inst.options[21].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_beval_address))
			option_inst.options[21].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[21].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[21].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[21].scriptID := 0
			option_inst.options[22].fullname := ce_string ("balloonexpr")
			option_inst.options[22].shortname := ce_string ("bexpr")
			option_inst.options[22].flags := (3084).to_natural_32
			option_inst.options[22].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_bexpr.address))
			option_inst.options[22].indir := 20508
			option_inst.options[22].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[22].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[22].scriptID := 0
			option_inst.options[23].fullname := ce_string ("beautify")
			option_inst.options[23].shortname := ce_string ("bf")
			option_inst.options[23].flags := (1025).to_natural_32
			option_inst.options[23].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[23].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[23].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[23].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[23].scriptID := 0
			option_inst.options[24].fullname := ce_string ("binary")
			option_inst.options[24].shortname := ce_string ("bin")
			option_inst.options[24].flags := (5121).to_natural_32
			option_inst.options[24].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_bin_address))
			option_inst.options[24].indir := 16391
			option_inst.options[24].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[24].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[24].scriptID := 0
			option_inst.options[25].fullname := ce_string ("bioskey")
			option_inst.options[25].shortname := ce_string ("biosk")
			option_inst.options[25].flags := (1025).to_natural_32
			option_inst.options[25].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[25].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[25].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 1)
			option_inst.options[25].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[25].scriptID := 0
			option_inst.options[26].fullname := ce_string ("bomb")
			option_inst.options[26].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[26].flags := (5633).to_natural_32
			option_inst.options[26].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_bomb_address))
			option_inst.options[26].indir := 16393
			option_inst.options[26].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[26].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[26].scriptID := 0
			option_inst.options[27].fullname := ce_string ("breakat")
			option_inst.options[27].shortname := ce_string ("brk")
			option_inst.options[27].flags := (156676).to_natural_32
			option_inst.options[27].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_breakat.address))
			option_inst.options[27].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[27].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" %T!@*-+;:,./?"))
			option_inst.options[27].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[27].scriptID := 0
			option_inst.options[28].fullname := ce_string ("browsedir")
			option_inst.options[28].shortname := ce_string ("bsdir")
			option_inst.options[28].flags := (1028).to_natural_32
			option_inst.options[28].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_bsdir.address))
			option_inst.options[28].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[28].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("last"))
			option_inst.options[28].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[28].scriptID := 0
			option_inst.options[29].fullname := ce_string ("bufhidden")
			option_inst.options[29].shortname := ce_string ("bh")
			option_inst.options[29].flags := (1049612).to_natural_32
			option_inst.options[29].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_bh.address))
			option_inst.options[29].indir := 16386
			option_inst.options[29].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[29].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[29].scriptID := 0
			option_inst.options[30].fullname := ce_string ("buflisted")
			option_inst.options[30].shortname := ce_string ("bl")
			option_inst.options[30].flags := (1049601).to_natural_32
			option_inst.options[30].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_bl_address))
			option_inst.options[30].indir := 16392
			option_inst.options[30].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 1)
			option_inst.options[30].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[30].scriptID := 0
			option_inst.options[31].fullname := ce_string ("buftype")
			option_inst.options[31].shortname := ce_string ("bt")
			option_inst.options[31].flags := (1049612).to_natural_32
			option_inst.options[31].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_bt.address))
			option_inst.options[31].indir := 16387
			option_inst.options[31].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[31].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[31].scriptID := 0
			option_inst.options[32].fullname := ce_string ("casemap")
			option_inst.options[32].shortname := ce_string ("cmp")
			option_inst.options[32].flags := (99332).to_natural_32
			option_inst.options[32].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_cmp.address))
			option_inst.options[32].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[32].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("internal,keepascii"))
			option_inst.options[32].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[32].scriptID := 0
			option_inst.options[33].fullname := ce_string ("cdpath")
			option_inst.options[33].shortname := ce_string ("cd")
			option_inst.options[33].flags := (99348).to_natural_32
			option_inst.options[33].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_cdpath.address))
			option_inst.options[33].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[33].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (",,"))
			option_inst.options[33].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[33].scriptID := 0
			option_inst.options[34].fullname := ce_string ("cedit")
			option_inst.options[34].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[34].flags := (4).to_natural_32
			option_inst.options[34].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_cedit.address))
			option_inst.options[34].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[34].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[34].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/6/"))
			option_inst.options[34].scriptID := 0
			option_inst.options[35].fullname := ce_string ("charconvert")
			option_inst.options[35].shortname := ce_string ("ccv")
			option_inst.options[35].flags := (263172).to_natural_32
			option_inst.options[35].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_ccv.address))
			option_inst.options[35].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[35].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[35].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[35].scriptID := 0
			option_inst.options[36].fullname := ce_string ("cindent")
			option_inst.options[36].shortname := ce_string ("cin")
			option_inst.options[36].flags := (3073).to_natural_32
			option_inst.options[36].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_cin_address))
			option_inst.options[36].indir := 16395
			option_inst.options[36].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[36].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[36].scriptID := 0
			option_inst.options[37].fullname := ce_string ("cinkeys")
			option_inst.options[37].shortname := ce_string ("cink")
			option_inst.options[37].flags := (99340).to_natural_32
			option_inst.options[37].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_cink.address))
			option_inst.options[37].indir := 16396
			option_inst.options[37].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("0{,0},0),:,0#,!^F,o,O,e"))
			option_inst.options[37].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[37].scriptID := 0
			option_inst.options[38].fullname := ce_string ("cinoptions")
			option_inst.options[38].shortname := ce_string ("cino")
			option_inst.options[38].flags := (99340).to_natural_32
			option_inst.options[38].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_cino.address))
			option_inst.options[38].indir := 16397
			option_inst.options[38].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[38].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[38].scriptID := 0
			option_inst.options[39].fullname := ce_string ("cinwords")
			option_inst.options[39].shortname := ce_string ("cinw")
			option_inst.options[39].flags := (99340).to_natural_32
			option_inst.options[39].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_cinw.address))
			option_inst.options[39].indir := 16398
			option_inst.options[39].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("if,else,while,do,for,switch"))
			option_inst.options[39].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[39].scriptID := 0
			option_inst.options[40].fullname := ce_string ("clipboard")
			option_inst.options[40].shortname := ce_string ("cb")
			option_inst.options[40].flags := (99332).to_natural_32
			option_inst.options[40].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_cb.address))
			option_inst.options[40].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[40].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("autoselect,exclude:cons\|linux"))
			option_inst.options[40].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[40].scriptID := 0
			option_inst.options[41].fullname := ce_string ("cmdheight")
			option_inst.options[41].shortname := ce_string ("ch")
			option_inst.options[41].flags := (25602).to_natural_32
			option_inst.options[41].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_ch_address))
			option_inst.options[41].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[41].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 1)
			option_inst.options[41].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[41].scriptID := 0
			option_inst.options[42].fullname := ce_string ("cmdwinheight")
			option_inst.options[42].shortname := ce_string ("cwh")
			option_inst.options[42].flags := (1026).to_natural_32
			option_inst.options[42].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_cwh_address))
			option_inst.options[42].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[42].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 7)
			option_inst.options[42].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[42].scriptID := 0
			option_inst.options[43].fullname := ce_string ("colorcolumn")
			option_inst.options[43].shortname := ce_string ("cc")
			option_inst.options[43].flags := (107524).to_natural_32
			option_inst.options[43].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + -1)
			option_inst.options[43].indir := 8215
			option_inst.options[43].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[43].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[43].scriptID := 0
			option_inst.options[44].fullname := ce_string ("columns")
			option_inst.options[44].shortname := ce_string ("co")
			option_inst.options[44].flags := (30274).to_natural_32
			option_inst.options[44].var := create {CE_POINTER [NATURAL_8]}.make_cast ((globals_inst.Columns_address))
			option_inst.options[44].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[44].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 80)
			option_inst.options[44].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[44].scriptID := 0
			option_inst.options[45].fullname := ce_string ("comments")
			option_inst.options[45].shortname := ce_string ("com")
			option_inst.options[45].flags := (99340).to_natural_32
			option_inst.options[45].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_com.address))
			option_inst.options[45].indir := 16401
			option_inst.options[45].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("s1:/*,mb:*,ex:*/,://,b:#,:%%,:XCOMM,n:>,fb:-"))
			option_inst.options[45].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[45].scriptID := 0
			option_inst.options[46].fullname := ce_string ("commentstring")
			option_inst.options[46].shortname := ce_string ("cms")
			option_inst.options[46].flags := (1036).to_natural_32
			option_inst.options[46].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_cms.address))
			option_inst.options[46].indir := 16400
			option_inst.options[46].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/*%%s*/"))
			option_inst.options[46].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[46].scriptID := 0
			option_inst.options[47].fullname := ce_string ("compatible")
			option_inst.options[47].shortname := ce_string ("cp")
			option_inst.options[47].flags := (24577).to_natural_32
			option_inst.options[47].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_cp_address))
			option_inst.options[47].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[47].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 1)
			option_inst.options[47].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[47].scriptID := 0
			option_inst.options[48].fullname := ce_string ("complete")
			option_inst.options[48].shortname := ce_string ("cpt")
			option_inst.options[48].flags := (99340).to_natural_32
			option_inst.options[48].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_cpt.address))
			option_inst.options[48].indir := 16402
			option_inst.options[48].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".,w,b,u,t,i"))
			option_inst.options[48].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[48].scriptID := 0
			option_inst.options[49].fullname := ce_string ("concealcursor")
			option_inst.options[49].shortname := ce_string ("cocu")
			option_inst.options[49].flags := (9228).to_natural_32
			option_inst.options[49].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[49].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[49].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[49].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[49].scriptID := 0
			option_inst.options[50].fullname := ce_string ("conceallevel")
			option_inst.options[50].shortname := ce_string ("cole")
			option_inst.options[50].flags := (9218).to_natural_32
			option_inst.options[50].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[50].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[50].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[50].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[50].scriptID := 0
			option_inst.options[51].fullname := ce_string ("completefunc")
			option_inst.options[51].shortname := ce_string ("cfu")
			option_inst.options[51].flags := (263180).to_natural_32
			option_inst.options[51].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_cfu.address))
			option_inst.options[51].indir := 16405
			option_inst.options[51].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[51].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[51].scriptID := 0
			option_inst.options[52].fullname := ce_string ("completeopt")
			option_inst.options[52].shortname := ce_string ("cot")
			option_inst.options[52].flags := (99332).to_natural_32
			option_inst.options[52].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_cot.address))
			option_inst.options[52].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[52].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu,preview"))
			option_inst.options[52].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[52].scriptID := 0
			option_inst.options[53].fullname := ce_string ("confirm")
			option_inst.options[53].shortname := ce_string ("cf")
			option_inst.options[53].flags := (1025).to_natural_32
			option_inst.options[53].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_confirm_address))
			option_inst.options[53].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[53].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[53].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[53].scriptID := 0
			option_inst.options[54].fullname := ce_string ("conskey")
			option_inst.options[54].shortname := ce_string ("consk")
			option_inst.options[54].flags := (1025).to_natural_32
			option_inst.options[54].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[54].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[54].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[54].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[54].scriptID := 0
			option_inst.options[55].fullname := ce_string ("copyindent")
			option_inst.options[55].shortname := ce_string ("ci")
			option_inst.options[55].flags := (3073).to_natural_32
			option_inst.options[55].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_ci_address))
			option_inst.options[55].indir := 16394
			option_inst.options[55].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[55].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[55].scriptID := 0
			option_inst.options[56].fullname := ce_string ("cpoptions")
			option_inst.options[56].shortname := ce_string ("cpo")
			option_inst.options[56].flags := (157700).to_natural_32
			option_inst.options[56].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_cpo.address))
			option_inst.options[56].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[56].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("aAbBcCdDeEfFgHiIjJkKlLmMnoOpPqrRsStuvwWxXyZ$!%%*-+<>"))
			option_inst.options[56].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("aABceFs"))
			option_inst.options[56].scriptID := 0
			option_inst.options[57].fullname := ce_string ("cryptmethod")
			option_inst.options[57].shortname := ce_string ("cm")
			option_inst.options[57].flags := (1036).to_natural_32
			option_inst.options[57].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_cm.address))
			option_inst.options[57].indir := 20495
			option_inst.options[57].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("zip"))
			option_inst.options[57].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[57].scriptID := 0
			option_inst.options[58].fullname := ce_string ("cscopepathcomp")
			option_inst.options[58].shortname := ce_string ("cspc")
			option_inst.options[58].flags := (3074).to_natural_32
			option_inst.options[58].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[58].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[58].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[58].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[58].scriptID := 0
			option_inst.options[59].fullname := ce_string ("cscopeprg")
			option_inst.options[59].shortname := ce_string ("csprg")
			option_inst.options[59].flags := (263188).to_natural_32
			option_inst.options[59].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[59].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[59].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[59].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[59].scriptID := 0
			option_inst.options[60].fullname := ce_string ("cscopequickfix")
			option_inst.options[60].shortname := ce_string ("csqf")
			option_inst.options[60].flags := (99332).to_natural_32
			option_inst.options[60].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[60].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[60].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[60].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[60].scriptID := 0
			option_inst.options[61].fullname := ce_string ("cscopetag")
			option_inst.options[61].shortname := ce_string ("cst")
			option_inst.options[61].flags := (3073).to_natural_32
			option_inst.options[61].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[61].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[61].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[61].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[61].scriptID := 0
			option_inst.options[62].fullname := ce_string ("cscopetagorder")
			option_inst.options[62].shortname := ce_string ("csto")
			option_inst.options[62].flags := (3074).to_natural_32
			option_inst.options[62].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[62].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[62].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[62].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[62].scriptID := 0
			option_inst.options[63].fullname := ce_string ("cscopeverbose")
			option_inst.options[63].shortname := ce_string ("csverb")
			option_inst.options[63].flags := (3073).to_natural_32
			option_inst.options[63].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[63].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[63].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[63].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[63].scriptID := 0
			option_inst.options[64].fullname := ce_string ("cursorbind")
			option_inst.options[64].shortname := ce_string ("crb")
			option_inst.options[64].flags := (1025).to_natural_32
			option_inst.options[64].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + -1)
			option_inst.options[64].indir := 8193
			option_inst.options[64].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[64].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[64].scriptID := 0
			option_inst.options[65].fullname := ce_string ("cursorcolumn")
			option_inst.options[65].shortname := ce_string ("cuc")
			option_inst.options[65].flags := (9217).to_natural_32
			option_inst.options[65].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + -1)
			option_inst.options[65].indir := 8213
			option_inst.options[65].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[65].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[65].scriptID := 0
			option_inst.options[66].fullname := ce_string ("cursorline")
			option_inst.options[66].shortname := ce_string ("cul")
			option_inst.options[66].flags := (9217).to_natural_32
			option_inst.options[66].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + -1)
			option_inst.options[66].indir := 8214
			option_inst.options[66].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[66].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[66].scriptID := 0
			option_inst.options[67].fullname := ce_string ("debug")
			option_inst.options[67].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[67].flags := (1028).to_natural_32
			option_inst.options[67].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_debug.address))
			option_inst.options[67].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[67].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[67].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[67].scriptID := 0
			option_inst.options[68].fullname := ce_string ("define")
			option_inst.options[68].shortname := ce_string ("def")
			option_inst.options[68].flags := (1036).to_natural_32
			option_inst.options[68].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_def.address))
			option_inst.options[68].indir := 20502
			option_inst.options[68].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("^\s*#\s*define"))
			option_inst.options[68].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[68].scriptID := 0
			option_inst.options[69].fullname := ce_string ("delcombine")
			option_inst.options[69].shortname := ce_string ("deco")
			option_inst.options[69].flags := (3073).to_natural_32
			option_inst.options[69].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_deco_address))
			option_inst.options[69].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[69].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[69].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[69].scriptID := 0
			option_inst.options[70].fullname := ce_string ("dictionary")
			option_inst.options[70].shortname := ce_string ("dict")
			option_inst.options[70].flags := (99348).to_natural_32
			option_inst.options[70].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_dict.address))
			option_inst.options[70].indir := 20499
			option_inst.options[70].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[70].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[70].scriptID := 0
			option_inst.options[71].fullname := ce_string ("diff")
			option_inst.options[71].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[71].flags := (1057793).to_natural_32
			option_inst.options[71].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + -1)
			option_inst.options[71].indir := 8194
			option_inst.options[71].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[71].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[71].scriptID := 0
			option_inst.options[72].fullname := ce_string ("diffexpr")
			option_inst.options[72].shortname := ce_string ("dex")
			option_inst.options[72].flags := (263172).to_natural_32
			option_inst.options[72].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_dex.address))
			option_inst.options[72].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[72].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[72].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[72].scriptID := 0
			option_inst.options[73].fullname := ce_string ("diffopt")
			option_inst.options[73].shortname := ce_string ("dip")
			option_inst.options[73].flags := (107532).to_natural_32
			option_inst.options[73].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_dip.address))
			option_inst.options[73].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[73].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("filler"))
			option_inst.options[73].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[73].scriptID := 0
			option_inst.options[74].fullname := ce_string ("digraph")
			option_inst.options[74].shortname := ce_string ("dg")
			option_inst.options[74].flags := (3073).to_natural_32
			option_inst.options[74].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_dg_address))
			option_inst.options[74].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[74].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[74].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[74].scriptID := 0
			option_inst.options[75].fullname := ce_string ("directory")
			option_inst.options[75].shortname := ce_string ("dir")
			option_inst.options[75].flags := (361492).to_natural_32
			option_inst.options[75].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_dir.address))
			option_inst.options[75].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[75].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".,~/tmp,/var/tmp,/tmp"))
			option_inst.options[75].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[75].scriptID := 0
			option_inst.options[76].fullname := ce_string ("display")
			option_inst.options[76].shortname := ce_string ("dy")
			option_inst.options[76].flags := (123908).to_natural_32
			option_inst.options[76].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_dy.address))
			option_inst.options[76].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[76].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[76].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[76].scriptID := 0
			option_inst.options[77].fullname := ce_string ("eadirection")
			option_inst.options[77].shortname := ce_string ("ead")
			option_inst.options[77].flags := (1028).to_natural_32
			option_inst.options[77].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_ead.address))
			option_inst.options[77].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[77].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("both"))
			option_inst.options[77].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[77].scriptID := 0
			option_inst.options[78].fullname := ce_string ("edcompatible")
			option_inst.options[78].shortname := ce_string ("ed")
			option_inst.options[78].flags := (1025).to_natural_32
			option_inst.options[78].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_ed_address))
			option_inst.options[78].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[78].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[78].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[78].scriptID := 0
			option_inst.options[79].fullname := ce_string ("encoding")
			option_inst.options[79].shortname := ce_string ("enc")
			option_inst.options[79].flags := (16806916).to_natural_32
			option_inst.options[79].var := create {CE_POINTER [NATURAL_8]}.make_cast ((option_inst.p_enc.address))
			option_inst.options[79].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[79].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("latin1"))
			option_inst.options[79].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[79].scriptID := 0
			option_inst.options[80].fullname := ce_string ("endofline")
			option_inst.options[80].shortname := ce_string ("eol")
			option_inst.options[80].flags := (5633).to_natural_32
		end

end
