class
	P_MOVE

inherit
	VIM_DATA
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {ANY} -- routines

	comp_botline (a_wp___0: CE_POINTER [PD_WINDOW_S])
		local
			l_n: INTEGER_32
			l_lnum: INTEGER_32
			l_done___2: INTEGER_32
			l_last: INTEGER_32
			l_folded: INTEGER_32
			js: JUMP_STATE
		do
			check_cursor_moved (a_wp___0)
			if ((a_wp___0.item.w_valid).bit_and (16)).to_boolean then
				l_lnum := a_wp___0.item.w_cursor.lnum
				l_done___2 := a_wp___0.item.w_cline_row
			else
				l_lnum := a_wp___0.item.w_topline
				l_done___2 := 0
			end
			from
			until
				not (not js.loop_left and then (l_lnum <= (a_wp___0.item.w_buffer).item.b_ml.ml_line_count))
			loop
				js.reset
				l_last := l_lnum
				l_folded := 0
				if (fold_inst.hasFoldingWin (a_wp___0, l_lnum, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_last), 1, create {CE_POINTER [PD_FOLDINFO]}.make_shared (default_pointer))).to_boolean then
					l_n := 1
					l_folded := 1
				elseif l_lnum = a_wp___0.item.w_topline then
					l_n := (misc1_inst.plines_win_nofill (a_wp___0, l_lnum, 1)) + a_wp___0.item.w_topfill
				else
					l_n := misc1_inst.plines_win (a_wp___0, l_lnum, 1)
				end
				if l_lnum <= a_wp___0.item.w_cursor.lnum then
					if l_last >= a_wp___0.item.w_cursor.lnum then
						a_wp___0.item.w_cline_row := l_done___2
						a_wp___0.item.w_cline_height := l_n
						a_wp___0.item.w_cline_folded := l_folded
						a_wp___0.item.w_valid := (a_wp___0.item.w_valid).bit_or ((24))
					end
				end
				if l_done___2 + l_n > a_wp___0.item.w_height then
					js.break
				end
				if not js.loop_jumped then
					l_done___2 := l_done___2 + l_n
					l_lnum := l_last
					l_lnum := l_lnum + 1
				end
			end
			js.reset
			a_wp___0.item.w_botline := l_lnum
			a_wp___0.item.w_valid := (a_wp___0.item.w_valid).bit_or ((96))
			set_empty_rows (a_wp___0, l_done___2)
		end

	update_topline_redraw
		do
			update_topline
			if globals_inst.must_redraw.to_boolean then
				screen_inst.update_screen (0)
			end
		end

	update_topline
		local
			l_line_count: INTEGER_32
			l_halfheight: INTEGER_32
			l_n: INTEGER_32
			l_old_topline___0: INTEGER_32
			l_old_topfill___0: INTEGER_32
			l_lnum: INTEGER_32
			l_check_topline: INTEGER_32
			l_check_botline: INTEGER_32
			l_save_so: INTEGER_32
			l_loff: PD_LINEOFF_T
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_loff.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_check_topline := 0
					l_check_botline := 0
					l_save_so := option_inst.p_so.to_integer_32
					if not (screen_inst.screen_valid (1)).to_boolean then
						js.return
					end
					if not js.return_called then
						check_cursor_moved (globals_inst.curwin)
						if ((globals_inst.curwin.item.w_valid).bit_and (128)).to_boolean then
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 22 -- skip if block
					end
				when 1 then -- if:
						if globals_inst.mouse_dragging > 0 then
							option_inst.p_so := (globals_inst.mouse_dragging - 1).to_integer_32
						end
						l_old_topline___0 := globals_inst.curwin.item.w_topline
						l_old_topfill___0 := globals_inst.curwin.item.w_topfill
						if globals_inst.curbuf.item.b_ml.ml_line_count /= 1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if ((memline_inst.ml_get ((1).to_integer_32)).item).to_integer_32 = 0 then
							if globals_inst.curwin.item.w_topline /= 1 then
								screen_inst.redraw_later (40)
							end
							globals_inst.curwin.item.w_topline := (1).to_integer_32
							globals_inst.curwin.item.w_botline := (2).to_integer_32
							globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_or ((96))
							globals_inst.curwin.item.w_scbind_pos := 1
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if globals_inst.curwin.item.w_topline > 1 then
							if globals_inst.curwin.item.w_cursor.lnum < globals_inst.curwin.item.w_topline then
								l_check_topline := 1
							elseif (check_top_offset).to_boolean then
								l_check_topline := 1
							end
						end
						if not l_check_topline.to_boolean then
							if globals_inst.curwin.item.w_topfill > (diff_inst.diff_check_fill (globals_inst.curwin, globals_inst.curwin.item.w_topline)) then
								l_check_topline := 1
							end
						end
						if l_check_topline.to_boolean then
							l_halfheight := globals_inst.curwin.item.w_height // 2 - 1
							if l_halfheight < 2 then
								l_halfheight := 2
							end
							if (fold_inst.hasAnyFolding (globals_inst.curwin)).to_boolean then
								l_n := 0
								l_lnum := globals_inst.curwin.item.w_cursor.lnum
								from
								until
									not (not js.loop_left and then (l_lnum < globals_inst.curwin.item.w_topline + option_inst.p_so))
								loop
									js.reset
									l_n := l_n + 1
									if l_lnum >= globals_inst.curbuf.item.b_ml.ml_line_count then
										js.break
									elseif l_n >= l_halfheight then
										js.break
									end
									if not js.loop_jumped then
										fold_inst.hasFolding (l_lnum, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_lnum)).do_nothing
										l_lnum := l_lnum + 1
									end
								end
								js.reset
							else
								l_n := ((globals_inst.curwin.item.w_topline + option_inst.p_so) - globals_inst.curwin.item.w_cursor.lnum).to_integer_32
							end
							if l_n >= l_halfheight then
								scroll_cursor_halfway (0)
							else
								scroll_cursor_top ((scrolljump_value), 0)
								l_check_botline := 1
							end
						else
							fold_inst.hasFolding (globals_inst.curwin.item.w_topline, create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_topline_offset), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)).do_nothing
							l_check_botline := 1
						end
				when 5 then
						if not (l_check_botline.to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 6 then -- if:
						if not ((globals_inst.curwin.item.w_valid).bit_and (64)).to_boolean then
							validate_botline
						end
						if not (globals_inst.curwin.item.w_botline <= globals_inst.curbuf.item.b_ml.ml_line_count) then
							l_pos := -1 + 16 -- skip if block
						end
				when 7 then -- if:
						if not (globals_inst.curwin.item.w_cursor.lnum < globals_inst.curwin.item.w_botline) then
							l_pos := -1 + 15 -- skip if block
						end
				when 8 then -- if:
						if not (globals_inst.curwin.item.w_cursor.lnum >= globals_inst.curwin.item.w_botline - option_inst.p_so) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L___0
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 11 then -- else:
						if not ((fold_inst.hasAnyFolding (globals_inst.curwin)).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if: | _L___0:
						l_n := globals_inst.curwin.item.w_empty_rows
						l_loff.lnum := globals_inst.curwin.item.w_cursor.lnum
						fold_inst.hasFolding (l_loff.lnum, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (l_loff.c_pointer + {PD_LINEOFF_T}.lnum_offset)).do_nothing
						l_loff.fill := 0
						l_n := l_n + (globals_inst.curwin.item.w_filler_rows)
						l_loff.height := 0
						from
						until
							js.loop_left
						loop
							js.reset
							if l_loff.lnum < globals_inst.curwin.item.w_botline then
								if not (l_loff.lnum + 1 < globals_inst.curwin.item.w_botline) then
									if l_loff.fill /= 0 then
										js.break
									end
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_n := l_n + (l_loff.height)
								if l_n.to_integer_32 >= option_inst.p_so then
									js.break
								end
							end
							if not js.loop_jumped then
								botline_forw (l_loff.address)
							end
						end
						js.reset
						if l_n.to_integer_32 >= option_inst.p_so then
							l_check_botline := 0
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else:
						l_check_botline := 0
				when 15 then -- if done | if done
						if l_check_botline.to_boolean then
							if (fold_inst.hasAnyFolding (globals_inst.curwin)).to_boolean then
								l_line_count := 0
								l_lnum := globals_inst.curwin.item.w_cursor.lnum
								from
								until
									not (not js.loop_left and then (l_lnum >= globals_inst.curwin.item.w_botline - option_inst.p_so))
								loop
									js.reset
									l_line_count := l_line_count + 1
									if l_lnum <= 0 then
										js.break
									elseif l_line_count > (globals_inst.curwin.item.w_height + 1).to_integer_32 then
										js.break
									end
									if not js.loop_jumped then
										fold_inst.hasFolding (l_lnum, create {CE_POINTER [INTEGER_32]}.make_shared ($l_lnum), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)).do_nothing
										l_lnum := l_lnum - 1
									end
								end
								js.reset
							else
								l_line_count := ((globals_inst.curwin.item.w_cursor.lnum - globals_inst.curwin.item.w_botline) + 1) + option_inst.p_so
							end
							if l_line_count <= (globals_inst.curwin.item.w_height + 1).to_integer_32 then
								scroll_cursor_bot ((scrolljump_value), 0)
							else
								scroll_cursor_halfway (0)
							end
						end
				when 16 then -- if done | if done
						globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_or ((128))
						if globals_inst.curwin.item.w_topline = l_old_topline___0 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 20 -- goto _L___1
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 19 then -- else:
						if globals_inst.curwin.item.w_topfill = l_old_topfill___0 then
							l_pos := -1 + 21 -- skip if block
						end
				when 20 then -- if: | _L___1:
						globals_inst.dollar_vcol := 0
						if globals_inst.curwin.item.w_skipcol /= 0 then
							globals_inst.curwin.item.w_skipcol := 0
							screen_inst.redraw_later (40)
						else
							screen_inst.redraw_later (10)
						end
						if globals_inst.curwin.item.w_cursor.lnum = globals_inst.curwin.item.w_topline then
							validate_cursor
						end
				when 21 then -- if done
						option_inst.p_so := l_save_so.to_integer_32
				when 22 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	scrolljump_value: INTEGER_32
		local
			js: JUMP_STATE
		do
			if option_inst.p_sj >= 0 then
				Result := option_inst.p_sj.to_integer_32
				js.return
			end
			if not js.return_called then
				Result := (((globals_inst.curwin.item.w_height).to_integer_32 * -option_inst.p_sj) // 100).to_integer_32
			end
		end

	check_top_offset: INTEGER_32
		local
			l_loff: PD_LINEOFF_T
			l_n: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_loff.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (globals_inst.curwin.item.w_cursor.lnum < globals_inst.curwin.item.w_topline + option_inst.p_so) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((fold_inst.hasAnyFolding (globals_inst.curwin)).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						l_loff.lnum := globals_inst.curwin.item.w_cursor.lnum
						l_loff.fill := 0
						l_n := globals_inst.curwin.item.w_topfill
						from
						until
							not (not js.loop_left and then (l_n.to_integer_32 < option_inst.p_so))
						loop
							js.reset
							topline_back (l_loff.address)
							if l_loff.lnum < globals_inst.curwin.item.w_topline then
								js.break
							elseif l_loff.lnum = globals_inst.curwin.item.w_topline then
								if l_loff.fill > 0 then
									js.break
								end
							end
							if not js.loop_jumped then
								l_n := l_n + (l_loff.height)
							end
						end
						js.reset
						if l_n.to_integer_32 < option_inst.p_so then
							Result := 1
							js.return
						end
				when 5 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	update_curswant
		do
			if (globals_inst.curwin.item.w_set_curswant).to_boolean then
				validate_virtcol
				globals_inst.curwin.item.w_curswant := globals_inst.curwin.item.w_virtcol
				globals_inst.curwin.item.w_set_curswant := 0
			end
		end

	check_cursor_moved (a_wp___0: CE_POINTER [PD_WINDOW_S])
		do
			if a_wp___0.item.w_cursor.lnum /= a_wp___0.item.w_valid_cursor.lnum then
				a_wp___0.item.w_valid := (a_wp___0.item.w_valid).bit_and ((-160))
				a_wp___0.item.w_valid_cursor := a_wp___0.item.w_cursor
				a_wp___0.item.w_valid_leftcol := a_wp___0.item.w_leftcol
			elseif a_wp___0.item.w_cursor.col /= a_wp___0.item.w_valid_cursor.col then
				a_wp___0.item.w_valid := (a_wp___0.item.w_valid).bit_and ((-8))
				a_wp___0.item.w_valid_cursor.col := a_wp___0.item.w_cursor.col
				a_wp___0.item.w_valid_leftcol := a_wp___0.item.w_leftcol
				a_wp___0.item.w_valid_cursor.coladd := a_wp___0.item.w_cursor.coladd
			elseif a_wp___0.item.w_leftcol /= a_wp___0.item.w_valid_leftcol then
				a_wp___0.item.w_valid := (a_wp___0.item.w_valid).bit_and ((-8))
				a_wp___0.item.w_valid_cursor.col := a_wp___0.item.w_cursor.col
				a_wp___0.item.w_valid_leftcol := a_wp___0.item.w_leftcol
				a_wp___0.item.w_valid_cursor.coladd := a_wp___0.item.w_cursor.coladd
			elseif a_wp___0.item.w_cursor.coladd /= a_wp___0.item.w_valid_cursor.coladd then
				a_wp___0.item.w_valid := (a_wp___0.item.w_valid).bit_and ((-8))
				a_wp___0.item.w_valid_cursor.col := a_wp___0.item.w_cursor.col
				a_wp___0.item.w_valid_leftcol := a_wp___0.item.w_leftcol
				a_wp___0.item.w_valid_cursor.coladd := a_wp___0.item.w_cursor.coladd
			end
		end

	changed_window_setting
		do
			changed_window_setting_win (globals_inst.curwin)
		end

	changed_window_setting_win (a_wp___0: CE_POINTER [PD_WINDOW_S])
		do
			a_wp___0.item.w_lines_valid := 0
			changed_line_abv_curs_win (a_wp___0)
			a_wp___0.item.w_valid := (a_wp___0.item.w_valid).bit_and ((-225))
			screen_inst.redraw_win_later (a_wp___0, 40)
		end

	set_topline (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_lnum: INTEGER_32)
		local
			l_lnum: INTEGER_32
		do
			l_lnum := a_lnum
			fold_inst.hasFoldingWin (a_wp___0, l_lnum, create {CE_POINTER [INTEGER_32]}.make_shared ($l_lnum), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 1, create {CE_POINTER [PD_FOLDINFO]}.make_shared (default_pointer)).do_nothing
			a_wp___0.item.w_botline := a_wp___0.item.w_botline + (l_lnum - a_wp___0.item.w_topline)
			a_wp___0.item.w_topline := l_lnum
			a_wp___0.item.w_topline_was_set := (1).to_integer_8
			a_wp___0.item.w_topfill := 0
			a_wp___0.item.w_valid := (a_wp___0.item.w_valid).bit_and ((-178))
			screen_inst.redraw_later (10)
		end

	changed_cline_bef_curs
		do
			globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-144))
		end

	changed_cline_bef_curs_win (a_wp___0: CE_POINTER [PD_WINDOW_S])
		do
			a_wp___0.item.w_valid := (a_wp___0.item.w_valid).bit_and ((-144))
		end

	changed_line_abv_curs
		do
			globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-160))
		end

	changed_line_abv_curs_win (a_wp___0: CE_POINTER [PD_WINDOW_S])
		do
			a_wp___0.item.w_valid := (a_wp___0.item.w_valid).bit_and ((-160))
		end

	validate_botline
		do
			if not ((globals_inst.curwin.item.w_valid).bit_and (32)).to_boolean then
				comp_botline (globals_inst.curwin)
			end
		end

	validate_botline_win (a_wp___0: CE_POINTER [PD_WINDOW_S])
		do
			if not ((a_wp___0.item.w_valid).bit_and (32)).to_boolean then
				comp_botline (a_wp___0)
			end
		end

	invalidate_botline
		do
			globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-97))
		end

	invalidate_botline_win (a_wp___0: CE_POINTER [PD_WINDOW_S])
		do
			a_wp___0.item.w_valid := (a_wp___0.item.w_valid).bit_and ((-97))
		end

	approximate_botline_win (a_wp___0: CE_POINTER [PD_WINDOW_S])
		do
			a_wp___0.item.w_valid := (a_wp___0.item.w_valid).bit_and ((-33))
		end

	cursor_valid: INTEGER_32
		do
			check_cursor_moved (globals_inst.curwin)
			Result := (((globals_inst.curwin.item.w_valid).bit_and (3)) = 3).to_integer
		end

	validate_cursor
		do
			check_cursor_moved (globals_inst.curwin)
			if ((globals_inst.curwin.item.w_valid).bit_and (3)) /= 3 then
				curs_columns (1)
			end
		end

	validate_cline_row
		do
			update_topline
			check_cursor_moved (globals_inst.curwin)
			if not ((globals_inst.curwin.item.w_valid).bit_and (16)).to_boolean then
				curs_rows (globals_inst.curwin, 0)
			end
		end

	curs_rows (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_do_botline: INTEGER_32)
		local
			l_lnum: INTEGER_32
			l_i___0: INTEGER_32
			l_all_invalid: INTEGER_32
			l_valid: INTEGER_32
			l_fold_count: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (screen_inst.redrawing).to_boolean then
						if a_wp___0.item.w_lines_valid = 0 then
							l_tmp___0 := 1
						elseif (a_wp___0.item.w_lines + 0).item.wl_lnum > a_wp___0.item.w_topline then
							l_tmp___0 := 1
						else
							l_tmp___0 := 0
						end
					else
						l_tmp___0 := 1
					end
					l_all_invalid := l_tmp___0
					l_i___0 := 0
					a_wp___0.item.w_cline_row := 0
					l_lnum := a_wp___0.item.w_topline
				when 1 then -- loop condition:
					if not (not js.loop_left and then (l_lnum < a_wp___0.item.w_cursor.lnum)) then
						l_pos := -1 + 14 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_valid := 0
						if not l_all_invalid.to_boolean then
							if l_i___0 < a_wp___0.item.w_lines_valid then
								if (a_wp___0.item.w_lines + l_i___0).item.wl_lnum < l_lnum then
									js.continue
								elseif not ((a_wp___0.item.w_lines + l_i___0).item.wl_valid).to_boolean then
									js.continue
								end
								if not js.loop_jumped then
									if (a_wp___0.item.w_lines + l_i___0).item.wl_lnum = l_lnum then
										if not ((a_wp___0.item.w_buffer).item.b_mod_set).to_boolean then
											l_valid := 1
										elseif (a_wp___0.item.w_lines + l_i___0).item.wl_lastlnum < a_wp___0.item.w_cursor.lnum then
											l_valid := 1
										elseif (a_wp___0.item.w_buffer).item.b_mod_top > (a_wp___0.item.w_lines + l_i___0).item.wl_lastlnum + 1 then
											l_valid := 1
										end
									elseif (a_wp___0.item.w_lines + l_i___0).item.wl_lnum > l_lnum then
										l_i___0 := l_i___0 - 1
									end
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 13 -- skip if block
						end
				when 3 then -- if:
						if not (l_valid.to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if l_lnum = a_wp___0.item.w_topline then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L___0
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if (a_wp___0.item.w_onebuf_opt.wo_diff).to_boolean then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L___0:
						l_lnum := (a_wp___0.item.w_lines + l_i___0).item.wl_lastlnum + 1
						if l_lnum > a_wp___0.item.w_cursor.lnum then
							js.break
						end
						if not js.loop_jumped then
							a_wp___0.item.w_cline_row := a_wp___0.item.w_cline_row + ((a_wp___0.item.w_lines + l_i___0).item.wl_size).to_integer_32
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_pos := -1 + 12 -- goto _L
				when 11 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						l_fold_count := fold_inst.foldedCount (a_wp___0, l_lnum, create {CE_POINTER [PD_FOLDINFO]}.make_shared (default_pointer))
						if l_fold_count.to_boolean then
							l_lnum := l_lnum + l_fold_count
							if l_lnum > a_wp___0.item.w_cursor.lnum then
								js.break
							end
							if not js.loop_jumped then
								a_wp___0.item.w_cline_row := (a_wp___0.item.w_cline_row) + 1
							end
						elseif l_lnum = a_wp___0.item.w_topline then
							l_tmp___1 := l_lnum
							l_lnum := l_lnum + 1
							a_wp___0.item.w_cline_row := a_wp___0.item.w_cline_row + ((misc1_inst.plines_win_nofill (a_wp___0, l_tmp___1, 1)) + a_wp___0.item.w_topfill)
						else
							l_tmp___3 := l_lnum
							l_lnum := l_lnum + 1
							a_wp___0.item.w_cline_row := a_wp___0.item.w_cline_row + (misc1_inst.plines_win (a_wp___0, l_tmp___3, 1))
						end
				when 13 then -- if done
						if not js.loop_left then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 14 then -- loop done
					js.reset
					check_cursor_moved (a_wp___0)
					if ((a_wp___0.item.w_valid).bit_and (8)).to_boolean then
						l_pos := -1 + 31 -- skip if block
					end
				when 15 then -- if:
						if not (l_all_invalid.to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 26 -- goto _L___3
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 18 then -- else:
						if l_i___0 /= a_wp___0.item.w_lines_valid then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 26 -- goto _L___3
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 21 then -- else:
						if not (l_i___0 < a_wp___0.item.w_lines_valid) then
							l_pos := -1 + 30 -- skip if block
						end
				when 22 then -- if:
						if ((a_wp___0.item.w_lines + l_i___0).item.wl_valid).to_boolean then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 26 -- goto _L___3
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 25 then -- else:
						if (a_wp___0.item.w_lines + l_i___0).item.wl_lnum = a_wp___0.item.w_cursor.lnum then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if: | _L___3:
						if a_wp___0.item.w_cursor.lnum = a_wp___0.item.w_topline then
							a_wp___0.item.w_cline_height := (misc1_inst.plines_win_nofill (a_wp___0, a_wp___0.item.w_cursor.lnum, 1)) + a_wp___0.item.w_topfill
						else
							a_wp___0.item.w_cline_height := misc1_inst.plines_win (a_wp___0, a_wp___0.item.w_cursor.lnum, 1)
						end
						a_wp___0.item.w_cline_folded := fold_inst.hasFoldingWin (a_wp___0, a_wp___0.item.w_cursor.lnum, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 1, create {CE_POINTER [PD_FOLDINFO]}.make_shared (default_pointer))
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else:
						l_pos := -1 + 30 -- goto _L___2
				when 29 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else: | _L___2:
						if l_i___0 > a_wp___0.item.w_lines_valid then
							a_wp___0.item.w_cline_height := 0
							a_wp___0.item.w_cline_folded := fold_inst.hasFoldingWin (a_wp___0, a_wp___0.item.w_cursor.lnum, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 1, create {CE_POINTER [PD_FOLDINFO]}.make_shared (default_pointer))
						else
							a_wp___0.item.w_cline_height := ((a_wp___0.item.w_lines + l_i___0).item.wl_size).to_integer_32
							a_wp___0.item.w_cline_folded := ((a_wp___0.item.w_lines + l_i___0).item.wl_folded).to_integer_32
						end
				when 31 then -- if done | if done | if done
						a_wp___0.item.w_valid := (a_wp___0.item.w_valid).bit_or ((24))
						if a_do_botline.to_boolean then
							if l_all_invalid.to_boolean then
								validate_botline_win (a_wp___0)
							end
						end
				when 32 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	validate_virtcol
		do
			validate_virtcol_win (globals_inst.curwin)
		end

	validate_virtcol_win (a_wp___0: CE_POINTER [PD_WINDOW_S])
		do
			check_cursor_moved (a_wp___0)
			if not ((a_wp___0.item.w_valid).bit_and (4)).to_boolean then
				charset_inst.getvvcol (a_wp___0, create {CE_POINTER [PD_POS_T]}.make_shared (a_wp___0.c_pointer + {PD_WINDOW_S}.w_cursor_offset), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (a_wp___0.c_pointer + {PD_WINDOW_S}.w_virtcol_offset), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
				a_wp___0.item.w_valid := (a_wp___0.item.w_valid).bit_or ((4))
				if (a_wp___0.item.w_onebuf_opt.wo_cuc).to_boolean then
					if not (popupmnu_inst.pum_visible).to_boolean then
						screen_inst.redraw_win_later (a_wp___0, 35)
					end
				end
			end
		end

	validate_cheight
		do
			check_cursor_moved (globals_inst.curwin)
			if not ((globals_inst.curwin.item.w_valid).bit_and (8)).to_boolean then
				if globals_inst.curwin.item.w_cursor.lnum = globals_inst.curwin.item.w_topline then
					globals_inst.curwin.item.w_cline_height := (misc1_inst.plines_nofill (globals_inst.curwin.item.w_cursor.lnum)) + globals_inst.curwin.item.w_topfill
				else
					globals_inst.curwin.item.w_cline_height := misc1_inst.plines (globals_inst.curwin.item.w_cursor.lnum)
				end
				globals_inst.curwin.item.w_cline_folded := fold_inst.hasFolding (globals_inst.curwin.item.w_cursor.lnum, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
				globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_or ((8))
			end
		end

	validate_cursor_col
		local
			l_off___0: INTEGER_32
			l_col: INTEGER_32
			l_width: INTEGER_32
		do
			validate_virtcol
			if not ((globals_inst.curwin.item.w_valid).bit_and (2)).to_boolean then
				l_col := globals_inst.curwin.item.w_virtcol
				l_off___0 := curwin_col_off
				l_col := l_col + l_off___0
				l_width := (globals_inst.curwin.item.w_width - l_off___0) + (curwin_col_off2)
				if (globals_inst.curwin.item.w_onebuf_opt.wo_wrap).to_boolean then
					if l_col >= globals_inst.curwin.item.w_width then
						if l_width > 0 then
							l_col := l_col - (((l_col - globals_inst.curwin.item.w_width) // l_width + 1) * l_width)
						end
					end
				end
				if l_col > globals_inst.curwin.item.w_leftcol then
					l_col := l_col - (globals_inst.curwin.item.w_leftcol)
				else
					l_col := 0
				end
				globals_inst.curwin.item.w_wcol := l_col
				globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_or ((2))
			end
		end

	win_col_off (a_wp___0: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
		do
			if (a_wp___0.item.w_onebuf_opt.wo_nu).to_boolean then
				l_tmp := screen_inst.number_width (a_wp___0)
				l_tmp___0 := l_tmp + 1
			elseif (a_wp___0.item.w_onebuf_opt.wo_rnu).to_boolean then
				l_tmp := screen_inst.number_width (a_wp___0)
				l_tmp___0 := l_tmp + 1
			else
				l_tmp___0 := 0
			end
			if globals_inst.cmdwin_type = 0 then
				l_tmp___1 := 0
			elseif (a_wp___0.c_pointer.to_integer_32).to_natural_32 /= (globals_inst.curwin.c_pointer.to_integer_32).to_natural_32 then
				l_tmp___1 := 0
			else
				l_tmp___1 := 1
			end
			if (netbeans_inst.netbeans_active).to_boolean then
				l_tmp___3 := 2
			elseif (((a_wp___0.item.w_buffer).item.b_signlist).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_tmp___3 := 2
			else
				l_tmp___3 := 0
			end
			Result := (((l_tmp___0 + l_tmp___1).to_integer_32 + a_wp___0.item.w_onebuf_opt.wo_fdc) + l_tmp___3.to_integer_32).to_integer_32
		end

	curwin_col_off: INTEGER_32
		do
			Result := (win_col_off (globals_inst.curwin))
		end

	win_col_off2 (a_wp___0: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((a_wp___0.item.w_onebuf_opt.wo_nu).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((a_wp___0.item.w_onebuf_opt.wo_rnu).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('n').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							Result := ((screen_inst.number_width (a_wp___0)) + 1)
							js.return
						end
				when 5 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	curwin_col_off2: INTEGER_32
		do
			Result := (win_col_off2 (globals_inst.curwin))
		end

	curs_columns (a_scroll: INTEGER_32)
		local
			l_diff: INTEGER_32
			l_extra: INTEGER_32
			l_off_left: INTEGER_32
			l_off_right: INTEGER_32
			l_n: INTEGER_32
			l_p_lines: INTEGER_32
			l_width: INTEGER_32
			l_textwidth: INTEGER_32
			l_new_leftcol: INTEGER_32
			l_startcol: INTEGER_32
			l_endcol: INTEGER_32
			l_prev_skipcol: INTEGER_32
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_width := 0
					update_topline
					if not ((globals_inst.curwin.item.w_valid).bit_and (16)).to_boolean then
						curs_rows (globals_inst.curwin, 0)
					end
					if (globals_inst.curwin.item.w_cline_folded).to_boolean then
						l_endcol := globals_inst.curwin.item.w_leftcol
						l_tmp := l_endcol
						globals_inst.curwin.item.w_virtcol := l_tmp
						l_startcol := l_tmp
					else
						charset_inst.getvvcol (globals_inst.curwin, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset), create {CE_POINTER [INTEGER_32]}.make_shared ($l_startcol), create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_virtcol_offset), create {CE_POINTER [INTEGER_32]}.make_shared ($l_endcol))
					end
					if l_startcol > globals_inst.dollar_vcol then
						globals_inst.dollar_vcol := 0
					end
					l_extra := curwin_col_off
					globals_inst.curwin.item.w_wcol := globals_inst.curwin.item.w_virtcol + l_extra
					l_endcol := l_endcol + l_extra
					globals_inst.curwin.item.w_wrow := globals_inst.curwin.item.w_cline_row
					l_textwidth := globals_inst.curwin.item.w_width - l_extra
					if not (l_textwidth <= 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						globals_inst.curwin.item.w_wcol := globals_inst.curwin.item.w_width - 1
						globals_inst.curwin.item.w_wrow := globals_inst.curwin.item.w_height - 1
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 3 then -- else:
						if not ((globals_inst.curwin.item.w_onebuf_opt.wo_wrap).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if globals_inst.curwin.item.w_width /= 0 then
							l_width := l_textwidth + (curwin_col_off2)
							if globals_inst.curwin.item.w_wcol >= globals_inst.curwin.item.w_width then
								l_n := (globals_inst.curwin.item.w_wcol - globals_inst.curwin.item.w_width) // l_width + 1
								globals_inst.curwin.item.w_wcol := globals_inst.curwin.item.w_wcol - (l_n * l_width)
								globals_inst.curwin.item.w_wrow := globals_inst.curwin.item.w_wrow + l_n
								if (option_inst.p_sbr.item).to_boolean then
									if ((memline_inst.ml_get_cursor).item).to_integer_32 = 0 then
										if globals_inst.curwin.item.w_wcol = (charset_inst.vim_strsize (option_inst.p_sbr)) then
											globals_inst.curwin.item.w_wcol := 0
										end
									end
								end
							end
						else
							l_pos := -1 + 6 -- goto _L___1
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 6 then -- else: | _L___1:
						if not (a_scroll.to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 7 then -- if:
						if (globals_inst.curwin.item.w_cline_folded).to_boolean then
							l_pos := -1 + 15 -- skip if block
						end
				when 8 then -- if:
						l_off_left := ((l_startcol - globals_inst.curwin.item.w_leftcol).to_integer_32 - option_inst.p_siso).to_integer_32
						l_off_right := (l_endcol - ((globals_inst.curwin.item.w_leftcol + globals_inst.curwin.item.w_width).to_integer_32 - option_inst.p_siso).to_integer_32) + 1
						if not (l_off_left < 0) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if not (l_off_right > 0) then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L:
						if l_off_left < 0 then
							l_diff := -l_off_left
						else
							l_diff := l_off_right
						end
						if option_inst.p_ss = 0 then
							l_new_leftcol := (globals_inst.curwin.item.w_wcol - l_extra) - l_textwidth // 2
						elseif l_diff >= l_textwidth // 2 then
							l_new_leftcol := (globals_inst.curwin.item.w_wcol - l_extra) - l_textwidth // 2
						elseif l_off_right >= l_off_left then
							l_new_leftcol := (globals_inst.curwin.item.w_wcol - l_extra) - l_textwidth // 2
						else
							if l_diff.to_integer_32 < option_inst.p_ss then
								l_diff := option_inst.p_ss.to_integer_32
							end
							if l_off_left < 0 then
								l_new_leftcol := globals_inst.curwin.item.w_leftcol - l_diff
							else
								l_new_leftcol := globals_inst.curwin.item.w_leftcol + l_diff
							end
						end
						if l_new_leftcol < 0 then
							l_new_leftcol := 0
						end
						if l_new_leftcol /= globals_inst.curwin.item.w_leftcol then
							globals_inst.curwin.item.w_leftcol := l_new_leftcol
							screen_inst.redraw_later (40)
						end
				when 13 then -- if done
						globals_inst.curwin.item.w_wcol := globals_inst.curwin.item.w_wcol - (globals_inst.curwin.item.w_leftcol)
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						l_pos := -1 + 17 -- goto _L___0
				when 16 then -- if done | if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else: | _L___0:
						if globals_inst.curwin.item.w_wcol > globals_inst.curwin.item.w_leftcol then
							globals_inst.curwin.item.w_wcol := globals_inst.curwin.item.w_wcol - (globals_inst.curwin.item.w_leftcol)
						else
							globals_inst.curwin.item.w_wcol := 0
						end
				when 18 then -- if done | if done
						if globals_inst.curwin.item.w_cursor.lnum = globals_inst.curwin.item.w_topline then
							globals_inst.curwin.item.w_wrow := globals_inst.curwin.item.w_wrow + (globals_inst.curwin.item.w_topfill)
						else
							globals_inst.curwin.item.w_wrow := globals_inst.curwin.item.w_wrow + (diff_inst.diff_check_fill (globals_inst.curwin, globals_inst.curwin.item.w_cursor.lnum))
						end
						l_prev_skipcol := globals_inst.curwin.item.w_skipcol
						l_p_lines := 0
						if not (globals_inst.curwin.item.w_wrow >= globals_inst.curwin.item.w_height) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
							l_pos := -1 + 26 -- goto _L___3
				when 20 then -- if block done, skip else block:
							l_pos := -1 + 50
				when 21 then -- else:
							if not (l_prev_skipcol > 0) then
								l_pos := -1 + 24 -- skip if block
							end
				when 22 then -- if:
							l_pos := -1 + 25 -- goto _L___4
				when 23 then -- if block done, skip else block:
							l_pos := -1 + 50
				when 24 then -- else:
							if not ((globals_inst.curwin.item.w_wrow).to_integer_32 + option_inst.p_so >= (globals_inst.curwin.item.w_height).to_integer_32) then
								l_pos := -1 + 49 -- skip if block
							end
				when 25 then -- if: | _L___4:
							l_p_lines := misc1_inst.plines_win_nofill (globals_inst.curwin, globals_inst.curwin.item.w_cursor.lnum, 0)
							if not (l_p_lines - 1 >= globals_inst.curwin.item.w_height) then
								l_pos := -1 + 47 -- skip if block
							end
				when 26 then -- if: | _L___3:
							if globals_inst.curwin.item.w_height = 0 then
								l_pos := -1 + 45 -- skip if block
							end
				when 27 then -- if:
							if globals_inst.curwin.item.w_cursor.lnum /= globals_inst.curwin.item.w_topline then
								l_pos := -1 + 43 -- skip if block
							end
				when 28 then -- if:
							if not (l_width > 0) then
								l_pos := -1 + 41 -- skip if block
							end
				when 29 then -- if:
							if globals_inst.curwin.item.w_width = 0 then
								l_pos := -1 + 39 -- skip if block
							end
				when 30 then -- if:
							l_extra := 0
							if (globals_inst.curwin.item.w_skipcol).to_integer_32 + option_inst.p_so * l_width.to_integer_32 > (globals_inst.curwin.item.w_virtcol).to_integer_32 then
								l_extra := 1
							end
							if l_p_lines = 0 then
								l_p_lines := misc1_inst.plines_win (globals_inst.curwin, globals_inst.curwin.item.w_cursor.lnum, 0)
							end
							l_p_lines := l_p_lines - 1
							if l_p_lines.to_integer_32 > (globals_inst.curwin.item.w_wrow).to_integer_32 + option_inst.p_so then
								l_n := ((globals_inst.curwin.item.w_wrow).to_integer_32 + option_inst.p_so).to_integer_32
							else
								l_n := l_p_lines
							end
							if l_n >= globals_inst.curwin.item.w_height + globals_inst.curwin.item.w_skipcol // l_width then
								l_extra := l_extra + (2)
							end
							if l_extra /= 3 then
								l_pos := -1 + 33 -- skip if block
							end
				when 31 then -- if:
							l_pos := -1 + 34 -- goto _L___2
				when 32 then -- if block done, skip else block:
							l_pos := -1 + 37
				when 33 then -- else:
							if not (l_p_lines.to_integer_32 < option_inst.p_so * 2) then
								l_pos := -1 + 36 -- skip if block
							end
				when 34 then -- if: | _L___2:
							l_n := globals_inst.curwin.item.w_virtcol // l_width
							if l_n > globals_inst.curwin.item.w_height // 2 then
								l_n := l_n - (globals_inst.curwin.item.w_height // 2)
							else
								l_n := 0
							end
							if l_n > (l_p_lines - globals_inst.curwin.item.w_height) + 1 then
								l_n := (l_p_lines - globals_inst.curwin.item.w_height) + 1
							end
							globals_inst.curwin.item.w_skipcol := l_n * l_width
				when 35 then -- if block done, skip else block:
							l_pos := -1 + 37
				when 36 then -- else:
							if l_extra = 1 then
								l_extra := ((((((globals_inst.curwin.item.w_skipcol).to_integer_32 + option_inst.p_so * l_width.to_integer_32) - (globals_inst.curwin.item.w_virtcol).to_integer_32) + l_width.to_integer_32) - 1) // l_width.to_integer_32).to_integer_32
								if l_extra > 0 then
									if l_extra * l_width > globals_inst.curwin.item.w_skipcol then
										l_extra := globals_inst.curwin.item.w_skipcol // l_width
									end
									globals_inst.curwin.item.w_skipcol := globals_inst.curwin.item.w_skipcol - (l_extra * l_width)
								end
							elseif l_extra = 2 then
								l_endcol := ((l_n - globals_inst.curwin.item.w_height) + 1) * l_width
								from
								until
									not (l_endcol > globals_inst.curwin.item.w_virtcol)
								loop
									l_endcol := l_endcol - l_width
								end
								if l_endcol > globals_inst.curwin.item.w_skipcol then
									globals_inst.curwin.item.w_skipcol := l_endcol
								end
							end
				when 37 then -- if done
							globals_inst.curwin.item.w_wrow := globals_inst.curwin.item.w_wrow - (globals_inst.curwin.item.w_skipcol // l_width)
							if globals_inst.curwin.item.w_wrow >= globals_inst.curwin.item.w_height then
								l_extra := (globals_inst.curwin.item.w_wrow - globals_inst.curwin.item.w_height) + 1
								globals_inst.curwin.item.w_skipcol := globals_inst.curwin.item.w_skipcol + (l_extra * l_width)
								globals_inst.curwin.item.w_wrow := globals_inst.curwin.item.w_wrow - l_extra
							end
							l_extra := (l_prev_skipcol - globals_inst.curwin.item.w_skipcol) // l_width
							if l_extra > 0 then
								screen_inst.win_ins_lines (globals_inst.curwin, 0, l_extra, 0, 0).do_nothing
							elseif l_extra < 0 then
								screen_inst.win_del_lines (globals_inst.curwin, 0, -l_extra, 0, 0).do_nothing
							end
				when 38 then -- if block done, skip else block:
							l_pos := -1 + 40
				when 39 then -- else:
							globals_inst.curwin.item.w_skipcol := 0
				when 40 then -- if done | if block done, skip else block:
							l_pos := -1 + 42
				when 41 then -- else:
							globals_inst.curwin.item.w_skipcol := 0
				when 42 then -- if done | if block done, skip else block:
							l_pos := -1 + 44
				when 43 then -- else:
							globals_inst.curwin.item.w_skipcol := 0
				when 44 then -- if done | if block done, skip else block:
							l_pos := -1 + 46
				when 45 then -- else:
							globals_inst.curwin.item.w_skipcol := 0
				when 46 then -- if done | if block done, skip else block:
							l_pos := -1 + 48
				when 47 then -- else:
							globals_inst.curwin.item.w_skipcol := 0
				when 48 then -- if done | if block done, skip else block:
							l_pos := -1 + 50
				when 49 then -- else:
							globals_inst.curwin.item.w_skipcol := 0
				when 50 then -- if done | if done
							if l_prev_skipcol /= globals_inst.curwin.item.w_skipcol then
								screen_inst.redraw_later (40)
							end
							if ((globals_inst.curwin.item.w_valid).bit_and (1)) /= 0 then
								l_pos := -1 + 53 -- skip if block
							end
				when 51 then -- if:
								if (globals_inst.curwin.item.w_onebuf_opt.wo_rnu).to_boolean then
									l_pos := -1 + 55 -- goto _L___5
								elseif (globals_inst.curwin.item.w_onebuf_opt.wo_cul).to_boolean then
									l_pos := -1 + 55 -- goto _L___5
								else
									l_pos := -1 + 53 -- goto _L___6
								end
				when 52 then -- if block done, skip else block:
								l_pos := -1 + 56
				when 53 then -- else: | _L___6:
								if not ((globals_inst.curwin.item.w_onebuf_opt.wo_cuc).to_boolean) then
									l_pos := -1 + 56 -- skip if block
								end
				when 54 then -- if:
								if ((globals_inst.curwin.item.w_valid).bit_and (4)) /= 0 then
									l_pos := -1 + 56 -- skip if block
								end
				when 55 then -- if: | _L___5:
								if not (popupmnu_inst.pum_visible).to_boolean then
									screen_inst.redraw_later (35)
								end
				when 56 then -- if done | if done
								globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_or ((7))
				when 57 then
								l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
					end

	scrolldown (a_line_count: INTEGER_32; a_byfold: INTEGER_32)
		local
			l_line_count: INTEGER_32
			l_done___2: INTEGER_32
			l_wrow: INTEGER_32
			l_moved: INTEGER_32
			l_first___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_line_count := a_line_count
					l_done___2 := 0
					l_moved := 0
					fold_inst.hasFolding (globals_inst.curwin.item.w_topline, create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_topline_offset), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)).do_nothing
					validate_cursor
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 8 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_tmp___2 := l_line_count
						l_line_count := l_line_count - 1
						if not (l_tmp___2 > 0) then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 7 -- skip if block
						end
				when 3 then -- if:
						if not (globals_inst.curwin.item.w_topfill < (diff_inst.diff_check (globals_inst.curwin, globals_inst.curwin.item.w_topline))) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if globals_inst.curwin.item.w_topfill < globals_inst.curwin.item.w_height - 1 then
							globals_inst.curwin.item.w_topfill := (globals_inst.curwin.item.w_topfill) + 1
							l_done___2 := l_done___2 + 1
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if globals_inst.curwin.item.w_topline = 1 then
							js.break
						end
						if not js.loop_jumped then
							globals_inst.curwin.item.w_topline := (globals_inst.curwin.item.w_topline) - 1
							globals_inst.curwin.item.w_topfill := 0
							if (fold_inst.hasFolding (globals_inst.curwin.item.w_topline, create {CE_POINTER [INTEGER_32]}.make_shared ($l_first___0), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))).to_boolean then
								l_done___2 := l_done___2 + 1
								if not a_byfold.to_boolean then
									l_line_count := l_line_count - ((globals_inst.curwin.item.w_topline - l_first___0) - 1)
								end
								globals_inst.curwin.item.w_botline := globals_inst.curwin.item.w_botline - (globals_inst.curwin.item.w_topline - l_first___0)
								globals_inst.curwin.item.w_topline := l_first___0
							else
								l_done___2 := l_done___2 + (misc1_inst.plines_nofill (globals_inst.curwin.item.w_topline)).to_integer_32
							end
						end
				when 7 then -- if done
						if not js.loop_jumped then
							globals_inst.curwin.item.w_botline := (globals_inst.curwin.item.w_botline) - 1
							invalidate_botline
						end
						l_pos := -1 + 1 -- back to loop condition
				when 8 then -- loop done
					js.reset
					globals_inst.curwin.item.w_wrow := ((globals_inst.curwin.item.w_wrow).to_integer_32 + l_done___2).to_integer_32
					globals_inst.curwin.item.w_cline_row := ((globals_inst.curwin.item.w_cline_row).to_integer_32 + l_done___2).to_integer_32
					if globals_inst.curwin.item.w_cursor.lnum = globals_inst.curwin.item.w_topline then
						globals_inst.curwin.item.w_cline_row := 0
					end
					check_topfill (globals_inst.curwin, 1)
					l_wrow := globals_inst.curwin.item.w_wrow
					if (globals_inst.curwin.item.w_onebuf_opt.wo_wrap).to_boolean then
						if globals_inst.curwin.item.w_width /= 0 then
							validate_virtcol
							validate_cheight
							l_wrow := l_wrow + ((globals_inst.curwin.item.w_cline_height - 1) - globals_inst.curwin.item.w_virtcol // globals_inst.curwin.item.w_width)
						end
					end
					from
					until
						js.loop_left
					loop
						js.reset
						if l_wrow >= globals_inst.curwin.item.w_height then
							if not (globals_inst.curwin.item.w_cursor.lnum > 1) then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							if (fold_inst.hasFolding (globals_inst.curwin.item.w_cursor.lnum, create {CE_POINTER [INTEGER_32]}.make_shared ($l_first___0), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))).to_boolean then
								l_wrow := l_wrow - 1
								if l_first___0 = 1 then
									globals_inst.curwin.item.w_cursor.lnum := (1).to_integer_32
								else
									globals_inst.curwin.item.w_cursor.lnum := l_first___0 - 1
								end
							else
								l_tmp___3 := globals_inst.curwin.item.w_cursor.lnum
								globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) - 1
								l_wrow := l_wrow - (misc1_inst.plines (l_tmp___3))
							end
							globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-32))
							l_moved := 1
						end
					end
					js.reset
					if l_moved.to_boolean then
						fold_inst.foldAdjustCursor
						misc2_inst.coladvance (globals_inst.curwin.item.w_curswant).do_nothing
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	scrollup (a_line_count: INTEGER_32; a_byfold: INTEGER_32)
		local
			l_line_count: INTEGER_32
			l_lnum: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_line_count := a_line_count
					if not (a_byfold.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (fold_inst.hasAnyFolding (globals_inst.curwin)).to_boolean then
							l_pos := -1 + 4 -- goto _L
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else: | _L___0:
						if not ((globals_inst.curwin.item.w_onebuf_opt.wo_diff).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						l_lnum := globals_inst.curwin.item.w_topline
						from
						until
							js.loop_left
						loop
							js.reset
							l_tmp := l_line_count
							l_line_count := l_line_count - 1
							if not l_tmp.to_boolean then
								js.break
							end
							if not js.loop_jumped then
								if globals_inst.curwin.item.w_topfill > 0 then
									globals_inst.curwin.item.w_topfill := (globals_inst.curwin.item.w_topfill) - 1
								else
									if a_byfold.to_boolean then
										fold_inst.hasFolding (l_lnum, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_lnum)).do_nothing
									end
									if l_lnum >= globals_inst.curbuf.item.b_ml.ml_line_count then
										js.break
									end
									if not js.loop_jumped then
										l_lnum := l_lnum + 1
										globals_inst.curwin.item.w_topfill := diff_inst.diff_check_fill (globals_inst.curwin, l_lnum)
									end
								end
							end
						end
						js.reset
						globals_inst.curwin.item.w_botline := globals_inst.curwin.item.w_botline + (l_lnum - globals_inst.curwin.item.w_topline)
						globals_inst.curwin.item.w_topline := l_lnum
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						globals_inst.curwin.item.w_topline := globals_inst.curwin.item.w_topline + l_line_count
						globals_inst.curwin.item.w_botline := globals_inst.curwin.item.w_botline + l_line_count
				when 7 then -- if done
						if globals_inst.curwin.item.w_topline > globals_inst.curbuf.item.b_ml.ml_line_count then
							globals_inst.curwin.item.w_topline := globals_inst.curbuf.item.b_ml.ml_line_count
						end
						if globals_inst.curwin.item.w_botline > globals_inst.curbuf.item.b_ml.ml_line_count + 1 then
							globals_inst.curwin.item.w_botline := globals_inst.curbuf.item.b_ml.ml_line_count + 1
						end
						check_topfill (globals_inst.curwin, 0)
						if (fold_inst.hasAnyFolding (globals_inst.curwin)).to_boolean then
							fold_inst.hasFolding (globals_inst.curwin.item.w_topline, create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_topline_offset), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)).do_nothing
						end
						globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-50))
						if globals_inst.curwin.item.w_cursor.lnum < globals_inst.curwin.item.w_topline then
							globals_inst.curwin.item.w_cursor.lnum := globals_inst.curwin.item.w_topline
							globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-32))
							misc2_inst.coladvance (globals_inst.curwin.item.w_curswant).do_nothing
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	check_topfill (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_down: INTEGER_32)
		local
			l_n: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_wp___0.item.w_topfill > 0) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_n := misc1_inst.plines_win_nofill (a_wp___0, a_wp___0.item.w_topline, 1)
						if not (a_wp___0.item.w_topfill + l_n > a_wp___0.item.w_height) then
							l_pos := -1 + 6 -- skip if block
						end
				when 2 then -- if:
						if not (a_down.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if a_wp___0.item.w_topline > 1 then
							a_wp___0.item.w_topline := (a_wp___0.item.w_topline) - 1
							a_wp___0.item.w_topfill := 0
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						a_wp___0.item.w_topfill := a_wp___0.item.w_height - l_n
						if a_wp___0.item.w_topfill < 0 then
							a_wp___0.item.w_topfill := 0
						end
				when 6 then -- if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	max_topfill
		local
			l_n: INTEGER_32
		do
			l_n := misc1_inst.plines_nofill (globals_inst.curwin.item.w_topline)
			if l_n >= globals_inst.curwin.item.w_height then
				globals_inst.curwin.item.w_topfill := 0
			else
				globals_inst.curwin.item.w_topfill := diff_inst.diff_check_fill (globals_inst.curwin, globals_inst.curwin.item.w_topline)
				if globals_inst.curwin.item.w_topfill + l_n > globals_inst.curwin.item.w_height then
					globals_inst.curwin.item.w_topfill := globals_inst.curwin.item.w_height - l_n
				end
			end
		end

	scrolldown_clamp
		local
			l_end_row: INTEGER_32
			l_can_fill: INTEGER_32
			js: JUMP_STATE
		do
			l_can_fill := (globals_inst.curwin.item.w_topfill < (diff_inst.diff_check_fill (globals_inst.curwin, globals_inst.curwin.item.w_topline))).to_integer
			if globals_inst.curwin.item.w_topline <= 1 then
				if not l_can_fill.to_boolean then
					js.return
				end
			end
			if not js.return_called then
				validate_cursor
				l_end_row := globals_inst.curwin.item.w_wrow
				if l_can_fill.to_boolean then
					l_end_row := l_end_row + 1
				else
					l_end_row := l_end_row + (misc1_inst.plines_nofill (globals_inst.curwin.item.w_topline - 1))
				end
				if (globals_inst.curwin.item.w_onebuf_opt.wo_wrap).to_boolean then
					if globals_inst.curwin.item.w_width /= 0 then
						validate_cheight
						validate_virtcol
						l_end_row := l_end_row + ((globals_inst.curwin.item.w_cline_height - 1) - globals_inst.curwin.item.w_virtcol // globals_inst.curwin.item.w_width)
					end
				end
				if l_end_row.to_integer_32 < (globals_inst.curwin.item.w_height).to_integer_32 - option_inst.p_so then
					if l_can_fill.to_boolean then
						globals_inst.curwin.item.w_topfill := (globals_inst.curwin.item.w_topfill) + 1
						check_topfill (globals_inst.curwin, 1)
					else
						globals_inst.curwin.item.w_topline := (globals_inst.curwin.item.w_topline) - 1
						globals_inst.curwin.item.w_topfill := 0
					end
					fold_inst.hasFolding (globals_inst.curwin.item.w_topline, create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_topline_offset), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)).do_nothing
					globals_inst.curwin.item.w_botline := (globals_inst.curwin.item.w_botline) - 1
					globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-50))
				end
			end
		end

	scrollup_clamp
		local
			l_start_row: INTEGER_32
			js: JUMP_STATE
		do
			if globals_inst.curwin.item.w_topline = globals_inst.curbuf.item.b_ml.ml_line_count then
				if globals_inst.curwin.item.w_topfill = 0 then
					js.return
				end
			end
			if not js.return_called then
				validate_cursor
				l_start_row := (globals_inst.curwin.item.w_wrow - (misc1_inst.plines_nofill (globals_inst.curwin.item.w_topline))) - globals_inst.curwin.item.w_topfill
				if (globals_inst.curwin.item.w_onebuf_opt.wo_wrap).to_boolean then
					if globals_inst.curwin.item.w_width /= 0 then
						validate_virtcol
						l_start_row := l_start_row - (globals_inst.curwin.item.w_virtcol // globals_inst.curwin.item.w_width)
					end
				end
				if l_start_row.to_integer_32 >= option_inst.p_so then
					if globals_inst.curwin.item.w_topfill > 0 then
						globals_inst.curwin.item.w_topfill := (globals_inst.curwin.item.w_topfill) - 1
					else
						fold_inst.hasFolding (globals_inst.curwin.item.w_topline, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_topline_offset)).do_nothing
						globals_inst.curwin.item.w_topline := (globals_inst.curwin.item.w_topline) + 1
					end
					globals_inst.curwin.item.w_botline := (globals_inst.curwin.item.w_botline) + 1
					globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-50))
				end
			end
		end

	topline_back (a_lp: CE_POINTER [PD_LINEOFF_T])
		do
			if a_lp.item.fill < (diff_inst.diff_check_fill (globals_inst.curwin, a_lp.item.lnum)) then
				a_lp.item.fill := (a_lp.item.fill) + 1
				a_lp.item.height := 1
			else
				a_lp.item.lnum := (a_lp.item.lnum) - 1
				a_lp.item.fill := 0
				if a_lp.item.lnum < 1 then
					a_lp.item.height := 2147483647
				elseif (fold_inst.hasFolding (a_lp.item.lnum, create {CE_POINTER [INTEGER_32]}.make_shared (a_lp.c_pointer + {PD_LINEOFF_T}.lnum_offset), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))).to_boolean then
					a_lp.item.height := 1
				else
					a_lp.item.height := misc1_inst.plines_nofill (a_lp.item.lnum)
				end
			end
		end

	botline_forw (a_lp: CE_POINTER [PD_LINEOFF_T])
		do
			if a_lp.item.fill < (diff_inst.diff_check_fill (globals_inst.curwin, a_lp.item.lnum + 1)) then
				a_lp.item.fill := (a_lp.item.fill) + 1
				a_lp.item.height := 1
			else
				a_lp.item.lnum := (a_lp.item.lnum) + 1
				a_lp.item.fill := 0
				if a_lp.item.lnum > globals_inst.curbuf.item.b_ml.ml_line_count then
					a_lp.item.height := 2147483647
				elseif (fold_inst.hasFolding (a_lp.item.lnum, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (a_lp.c_pointer + {PD_LINEOFF_T}.lnum_offset))).to_boolean then
					a_lp.item.height := 1
				else
					a_lp.item.height := misc1_inst.plines_nofill (a_lp.item.lnum)
				end
			end
		end

	botline_topline (a_lp: CE_POINTER [PD_LINEOFF_T])
		do
			if a_lp.item.fill > 0 then
				a_lp.item.lnum := (a_lp.item.lnum) + 1
				a_lp.item.fill := ((diff_inst.diff_check_fill (globals_inst.curwin, a_lp.item.lnum)) - a_lp.item.fill) + 1
			end
		end

	topline_botline (a_lp: CE_POINTER [PD_LINEOFF_T])
		do
			if a_lp.item.fill > 0 then
				a_lp.item.fill := ((diff_inst.diff_check_fill (globals_inst.curwin, a_lp.item.lnum)) - a_lp.item.fill) + 1
				a_lp.item.lnum := (a_lp.item.lnum) - 1
			end
		end

	scroll_cursor_top (a_min_scroll: INTEGER_32; a_always: INTEGER_32)
		local
			l_scrolled: INTEGER_32
			l_extra: INTEGER_32
			l_used: INTEGER_32
			l_i___0: INTEGER_32
			l_top: INTEGER_32
			l_bot: INTEGER_32
			l_old_topline___0: INTEGER_32
			l_old_topfill___0: INTEGER_32
			l_new_topline: INTEGER_32
			l_off___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_scrolled := 0
					l_extra := 0
					l_old_topline___0 := globals_inst.curwin.item.w_topline
					l_old_topfill___0 := (globals_inst.curwin.item.w_topfill).to_integer_32
					l_off___0 := option_inst.p_so.to_integer_32
					if globals_inst.mouse_dragging > 0 then
						l_off___0 := globals_inst.mouse_dragging - 1
					end
					validate_cheight
					l_used := globals_inst.curwin.item.w_cline_height
					if globals_inst.curwin.item.w_cursor.lnum < globals_inst.curwin.item.w_topline then
						l_scrolled := l_used
					end
					if (fold_inst.hasFolding (globals_inst.curwin.item.w_cursor.lnum, create {CE_POINTER [INTEGER_32]}.make_shared ($l_top), create {CE_POINTER [INTEGER_32]}.make_shared ($l_bot))).to_boolean then
						l_top := l_top - 1
						l_bot := l_bot + 1
					else
						l_top := globals_inst.curwin.item.w_cursor.lnum - 1
						l_bot := globals_inst.curwin.item.w_cursor.lnum + 1
					end
					l_new_topline := l_top + 1
					l_i___0 := diff_inst.diff_check_fill (globals_inst.curwin, globals_inst.curwin.item.w_cursor.lnum)
					l_used := l_used + l_i___0
					l_extra := l_extra + l_i___0
				when 1 then -- loop condition:
					if not (not js.loop_left and then (l_top > 0)) then
						l_pos := -1 + 9 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if (fold_inst.hasFolding (l_top, create {CE_POINTER [INTEGER_32]}.make_shared ($l_top), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))).to_boolean then
							l_i___0 := 1
						else
							l_i___0 := misc1_inst.plines (l_top)
						end
						l_used := l_used + l_i___0
						if l_extra + l_i___0 <= l_off___0 then
							if l_bot < globals_inst.curbuf.item.b_ml.ml_line_count then
								if (fold_inst.hasFolding (l_bot, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_bot))).to_boolean then
									l_used := l_used + 1
								else
									l_used := l_used + (misc1_inst.plines (l_bot))
								end
							end
						end
						if l_used > globals_inst.curwin.item.w_height then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						if l_top < globals_inst.curwin.item.w_topline then
							l_scrolled := l_scrolled + l_i___0
						end
						if not (l_new_topline >= globals_inst.curwin.item.w_topline) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if not (l_scrolled > a_min_scroll) then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						if l_extra >= l_off___0 then
							js.break
						end
				when 8 then -- if done | if done
						if not js.loop_jumped then
							l_extra := l_extra + l_i___0
							l_new_topline := l_top
							l_top := l_top - 1
							l_bot := l_bot + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 9 then -- loop done
					js.reset
					if l_used > globals_inst.curwin.item.w_height then
						scroll_cursor_halfway (0)
					else
						if l_new_topline < globals_inst.curwin.item.w_topline then
							globals_inst.curwin.item.w_topline := l_new_topline
						elseif a_always.to_boolean then
							globals_inst.curwin.item.w_topline := l_new_topline
						end
						if globals_inst.curwin.item.w_topline > globals_inst.curwin.item.w_cursor.lnum then
							globals_inst.curwin.item.w_topline := globals_inst.curwin.item.w_cursor.lnum
						end
						globals_inst.curwin.item.w_topfill := diff_inst.diff_check_fill (globals_inst.curwin, globals_inst.curwin.item.w_topline)
						if globals_inst.curwin.item.w_topfill > 0 then
							if l_extra > l_off___0 then
								globals_inst.curwin.item.w_topfill := globals_inst.curwin.item.w_topfill - (l_extra - l_off___0)
								if globals_inst.curwin.item.w_topfill < 0 then
									globals_inst.curwin.item.w_topfill := 0
								end
							end
						end
						check_topfill (globals_inst.curwin, 0)
						if globals_inst.curwin.item.w_topline /= l_old_topline___0 then
							globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-114))
						elseif (globals_inst.curwin.item.w_topfill).to_integer_32 /= l_old_topfill___0 then
							globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-114))
						end
						globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_or ((128))
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_empty_rows (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_used: INTEGER_32)
		do
			a_wp___0.item.w_filler_rows := 0
			if a_used = 0 then
				a_wp___0.item.w_empty_rows := 0
			else
				a_wp___0.item.w_empty_rows := a_wp___0.item.w_height - a_used
				if a_wp___0.item.w_botline <= (a_wp___0.item.w_buffer).item.b_ml.ml_line_count then
					a_wp___0.item.w_filler_rows := diff_inst.diff_check_fill (a_wp___0, a_wp___0.item.w_botline)
					if a_wp___0.item.w_empty_rows > a_wp___0.item.w_filler_rows then
						a_wp___0.item.w_empty_rows := a_wp___0.item.w_empty_rows - (a_wp___0.item.w_filler_rows)
					else
						a_wp___0.item.w_filler_rows := a_wp___0.item.w_empty_rows
						a_wp___0.item.w_empty_rows := 0
					end
				end
			end
		end

	scroll_cursor_bot (a_min_scroll: INTEGER_32; a_set_topbot: INTEGER_32)
		local
			l_used: INTEGER_32
			l_scrolled: INTEGER_32
			l_extra: INTEGER_32
			l_i___0: INTEGER_32
			l_line_count: INTEGER_32
			l_old_topline___0: INTEGER_32
			l_loff: PD_LINEOFF_T
			l_boff: PD_LINEOFF_T
			l_old_topfill___0: INTEGER_32
			l_fill_below_window: INTEGER_32
			l_old_botline: INTEGER_32
			l_old_valid: INTEGER_32
			l_old_empty_rows: INTEGER_32
			l_cln: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_loff.make
			create l_boff.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_scrolled := 0
					l_extra := 0
					l_old_topline___0 := globals_inst.curwin.item.w_topline
					l_old_topfill___0 := globals_inst.curwin.item.w_topfill
					l_old_botline := globals_inst.curwin.item.w_botline
					l_old_valid := (globals_inst.curwin.item.w_valid).to_integer_32
					l_old_empty_rows := globals_inst.curwin.item.w_empty_rows
					l_cln := globals_inst.curwin.item.w_cursor.lnum
					if a_set_topbot.to_boolean then
						l_used := 0
						globals_inst.curwin.item.w_botline := l_cln + 1
						l_loff.fill := 0
						globals_inst.curwin.item.w_topline := globals_inst.curwin.item.w_botline
						from
						until
							not (not js.loop_left and then (globals_inst.curwin.item.w_topline > 1))
						loop
							js.reset
							l_loff.lnum := globals_inst.curwin.item.w_topline
							topline_back (l_loff.address)
							if (l_loff.height).to_integer_32 = 2147483647 then
								js.break
							elseif l_used + l_loff.height > globals_inst.curwin.item.w_height then
								js.break
							end
							if not js.loop_jumped then
								l_used := l_used + (l_loff.height)
								globals_inst.curwin.item.w_topfill := l_loff.fill
								globals_inst.curwin.item.w_topline := l_loff.lnum
							end
						end
						js.reset
						set_empty_rows (globals_inst.curwin, l_used)
						globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_or ((96))
						if globals_inst.curwin.item.w_topline /= l_old_topline___0 then
							globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-18))
						elseif globals_inst.curwin.item.w_topfill /= l_old_topfill___0 then
							globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-18))
						end
					else
						validate_botline
					end
					l_used := misc1_inst.plines_nofill (l_cln)
					if l_cln >= globals_inst.curwin.item.w_botline then
						l_scrolled := l_used
						if l_cln = globals_inst.curwin.item.w_botline then
							l_scrolled := l_scrolled - (globals_inst.curwin.item.w_empty_rows)
						end
					end
					if not (fold_inst.hasFolding (globals_inst.curwin.item.w_cursor.lnum, create {CE_POINTER [INTEGER_32]}.make_shared (l_loff.c_pointer + {PD_LINEOFF_T}.lnum_offset), create {CE_POINTER [INTEGER_32]}.make_shared (l_boff.c_pointer + {PD_LINEOFF_T}.lnum_offset))).to_boolean then
						l_loff.lnum := l_cln
						l_boff.lnum := l_cln
					end
					l_loff.fill := 0
					l_boff.fill := 0
					l_fill_below_window := (diff_inst.diff_check_fill (globals_inst.curwin, globals_inst.curwin.item.w_botline)) - globals_inst.curwin.item.w_filler_rows
				when 1 then -- loop condition:
					if not (not js.loop_left and then (l_loff.lnum > 1)) then
						l_pos := -1 + 30 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if not (l_scrolled <= 0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L___1
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 5 then -- else:
						if not (l_scrolled >= a_min_scroll) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L___1:
						if globals_inst.mouse_dragging > 0 then
							l_tmp___1 := (globals_inst.mouse_dragging - 1).to_integer_32
						else
							l_tmp___1 := option_inst.p_so
						end
						if l_extra.to_integer_32 >= l_tmp___1 then
							l_pos := -1 + 9 -- goto _L
						else
							l_pos := -1 + 8 -- goto _L___0
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else: | _L___0:
						if not (l_boff.lnum + 1 > globals_inst.curbuf.item.b_ml.ml_line_count) then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						if l_loff.lnum <= globals_inst.curwin.item.w_botline then
							if l_loff.lnum < globals_inst.curwin.item.w_botline then
								js.break
							elseif l_loff.fill >= l_fill_below_window then
								js.break
							end
						end
				when 10 then -- if done | if done
						if not js.loop_jumped then
							topline_back (l_loff.address)
							if (l_loff.height).to_integer_32 = 2147483647 then
								l_used := 2147483647
							else
								l_used := l_used + (l_loff.height)
							end
							if l_used > globals_inst.curwin.item.w_height then
								js.break
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 29 -- skip if block
						end
				when 11 then -- if:
						if not (l_loff.lnum >= globals_inst.curwin.item.w_botline) then
							l_pos := -1 + 17 -- skip if block
						end
				when 12 then -- if:
						if not (l_loff.lnum > globals_inst.curwin.item.w_botline) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L___2
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 15 then -- else:
						if not (l_loff.fill <= l_fill_below_window) then
							l_pos := -1 + 17 -- skip if block
						end
				when 16 then -- if: | _L___2:
						l_scrolled := l_scrolled + (l_loff.height)
						if l_loff.lnum = globals_inst.curwin.item.w_botline then
							if l_boff.fill = 0 then
								l_scrolled := l_scrolled - (globals_inst.curwin.item.w_empty_rows)
							end
						end
				when 17 then -- if done | if done
						if not (l_boff.lnum < globals_inst.curbuf.item.b_ml.ml_line_count) then
							l_pos := -1 + 29 -- skip if block
						end
				when 18 then -- if:
						botline_forw (l_boff.address)
						l_used := l_used + (l_boff.height)
						if l_used > globals_inst.curwin.item.w_height then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 29 -- skip if block
						end
				when 19 then -- if:
						if globals_inst.mouse_dragging > 0 then
							l_tmp___2 := (globals_inst.mouse_dragging - 1).to_integer_32
						else
							l_tmp___2 := option_inst.p_so
						end
						if not (l_extra.to_integer_32 < l_tmp___2) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 23 -- goto _L___4
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 22 then -- else:
						if not (l_scrolled < a_min_scroll) then
							l_pos := -1 + 29 -- skip if block
						end
				when 23 then -- if: | _L___4:
						l_extra := l_extra + (l_boff.height)
						if not (l_boff.lnum >= globals_inst.curwin.item.w_botline) then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						l_pos := -1 + 28 -- goto _L___3
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 26 then -- else:
						if l_boff.lnum + 1 /= globals_inst.curwin.item.w_botline then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						if not (l_boff.fill > globals_inst.curwin.item.w_filler_rows) then
							l_pos := -1 + 29 -- skip if block
						end
				when 28 then -- if: | _L___3:
						l_scrolled := l_scrolled + (l_boff.height)
						if l_boff.lnum = globals_inst.curwin.item.w_botline then
							if l_boff.fill = 0 then
								l_scrolled := l_scrolled - (globals_inst.curwin.item.w_empty_rows)
							end
						end
				when 29 then -- if done | if done | if done | if done | if done | if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 30 then -- loop done
					js.reset
					if l_scrolled <= 0 then
						l_line_count := (0).to_integer_32
					elseif l_used > globals_inst.curwin.item.w_height then
						l_line_count := l_used.to_integer_32
					else
						l_line_count := (0).to_integer_32
						l_boff.fill := globals_inst.curwin.item.w_topfill
						l_boff.lnum := globals_inst.curwin.item.w_topline - 1
						l_i___0 := 0
						from
						until
							js.loop_left
						loop
							js.reset
							if l_i___0 < l_scrolled then
								if not (l_boff.lnum < globals_inst.curwin.item.w_botline) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								botline_forw (l_boff.address)
								l_i___0 := l_i___0 + (l_boff.height)
								l_line_count := l_line_count + 1
							end
						end
						js.reset
						if l_i___0 < l_scrolled then
							l_line_count := (9999).to_integer_32
						end
					end
					if l_line_count >= (globals_inst.curwin.item.w_height).to_integer_32 then
						if l_line_count > a_min_scroll.to_integer_32 then
							scroll_cursor_halfway (0)
						else
							scrollup (l_line_count, 1)
						end
					else
						scrollup (l_line_count, 1)
					end
					if globals_inst.curwin.item.w_topline = l_old_topline___0 then
						if a_set_topbot.to_boolean then
							globals_inst.curwin.item.w_botline := l_old_botline
							globals_inst.curwin.item.w_empty_rows := l_old_empty_rows
							globals_inst.curwin.item.w_valid := l_old_valid.to_integer_32
						end
					end
					globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_or ((128))
				when 31 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	scroll_cursor_halfway (a_atend: INTEGER_32)
		local
			l_above: INTEGER_32
			l_topline: INTEGER_32
			l_topfill: INTEGER_32
			l_below: INTEGER_32
			l_used: INTEGER_32
			l_loff: PD_LINEOFF_T
			l_boff: PD_LINEOFF_T
			js: JUMP_STATE
		do
			create l_loff.make
			create l_boff.make

			l_above := 0
			l_topfill := 0
			l_below := 0
			l_boff.lnum := globals_inst.curwin.item.w_cursor.lnum
			l_loff.lnum := l_boff.lnum
			fold_inst.hasFolding (l_loff.lnum, create {CE_POINTER [INTEGER_32]}.make_shared (l_loff.c_pointer + {PD_LINEOFF_T}.lnum_offset), create {CE_POINTER [INTEGER_32]}.make_shared (l_boff.c_pointer + {PD_LINEOFF_T}.lnum_offset)).do_nothing
			l_used := misc1_inst.plines_nofill (l_loff.lnum)
			l_loff.fill := 0
			l_boff.fill := 0
			l_topline := l_loff.lnum
			from
			until
				not (not js.loop_left and then (l_topline > 1))
			loop
				js.reset
				if l_below <= l_above then
					if l_boff.lnum < globals_inst.curbuf.item.b_ml.ml_line_count then
						botline_forw (l_boff.address)
						l_used := l_used + (l_boff.height)
						if l_used > globals_inst.curwin.item.w_height then
							js.break
						end
						if not js.loop_jumped then
							l_below := l_below + (l_boff.height)
						end
					else
						l_below := l_below + 1
						if a_atend.to_boolean then
							l_used := l_used + 1
						end
					end
				end
				if not js.loop_jumped and then (l_below > l_above) then
					topline_back (l_loff.address)
					if (l_loff.height).to_integer_32 = 2147483647 then
						l_used := 2147483647
					else
						l_used := l_used + (l_loff.height)
					end
					if l_used > globals_inst.curwin.item.w_height then
						js.break
					end
					if not js.loop_jumped then
						l_above := l_above + (l_loff.height)
						l_topline := l_loff.lnum
						l_topfill := l_loff.fill
					end
				end
			end
			js.reset
			if not (fold_inst.hasFolding (l_topline, create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_topline_offset), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))).to_boolean then
				globals_inst.curwin.item.w_topline := l_topline
			end
			globals_inst.curwin.item.w_topfill := l_topfill
			check_topfill (globals_inst.curwin, 0)
			globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-114))
			globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_or ((128))
		end

	cursor_correct
		local
			l_above: INTEGER_32
			l_topline: INTEGER_32
			l_below: INTEGER_32
			l_botline: INTEGER_32
			l_above_wanted: INTEGER_32
			l_below_wanted: INTEGER_32
			l_cln: INTEGER_32
			l_max_off: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_above := 0
					l_below := 0
					l_above_wanted := option_inst.p_so.to_integer_32
					l_below_wanted := option_inst.p_so.to_integer_32
					if globals_inst.mouse_dragging > 0 then
						l_above_wanted := globals_inst.mouse_dragging - 1
						l_below_wanted := globals_inst.mouse_dragging - 1
					end
					if globals_inst.curwin.item.w_topline = 1 then
						l_above_wanted := 0
						l_max_off := globals_inst.curwin.item.w_height // 2
						if l_below_wanted > l_max_off then
							l_below_wanted := l_max_off
						end
					end
					validate_botline
					if globals_inst.curwin.item.w_botline = globals_inst.curbuf.item.b_ml.ml_line_count + 1 then
						if globals_inst.mouse_dragging = 0 then
							l_below_wanted := 0
							l_max_off := (globals_inst.curwin.item.w_height - 1) // 2
							if l_above_wanted > l_max_off then
								l_above_wanted := l_max_off
							end
						end
					end
					l_cln := globals_inst.curwin.item.w_cursor.lnum
					if l_cln >= globals_inst.curwin.item.w_topline + l_above_wanted.to_integer_32 then
						if l_cln < globals_inst.curwin.item.w_botline - l_below_wanted.to_integer_32 then
							if not (fold_inst.hasAnyFolding (globals_inst.curwin)).to_boolean then
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 25 -- skip if block
					end
				when 1 then -- if:
						l_topline := globals_inst.curwin.item.w_topline
						l_botline := globals_inst.curwin.item.w_botline - 1
						l_above := globals_inst.curwin.item.w_topfill
						l_below := globals_inst.curwin.item.w_filler_rows
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 24 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if not (l_above < l_above_wanted) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___1
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if not (l_below < l_below_wanted) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___1:
						if not (l_topline < l_botline) then
							js.break
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						js.break
				when 10 then -- if done
						if js.loop_jumped then
							l_pos := -1 + 23 -- skip if block
						end
				when 11 then -- if:
						if not (l_below < l_below_wanted) then
							l_pos := -1 + 17 -- skip if block
						end
				when 12 then -- if:
						if not (l_below <= l_above) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 15 then -- else:
						if not (l_above >= l_above_wanted) then
							l_pos := -1 + 17 -- skip if block
						end
				when 16 then -- if: | _L:
						if (fold_inst.hasFolding (l_botline, create {CE_POINTER [INTEGER_32]}.make_shared ($l_botline), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))).to_boolean then
							l_below := l_below + 1
						else
							l_below := l_below + (misc1_inst.plines (l_botline))
						end
						l_botline := l_botline - 1
				when 17 then -- if done | if done
						if not (l_above < l_above_wanted) then
							l_pos := -1 + 23 -- skip if block
						end
				when 18 then -- if:
						if not (l_above < l_below) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 22 -- goto _L___0
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 21 then -- else:
						if not (l_below >= l_below_wanted) then
							l_pos := -1 + 23 -- skip if block
						end
				when 22 then -- if: | _L___0:
						if (fold_inst.hasFolding (l_topline, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared ($l_topline))).to_boolean then
							l_above := l_above + 1
						else
							l_above := l_above + (misc1_inst.plines_nofill (l_topline))
						end
						if l_topline < l_botline then
							l_above := l_above + (diff_inst.diff_check_fill (globals_inst.curwin, l_topline + 1))
						end
						l_topline := l_topline + 1
				when 23 then -- if done | if done | if done
						l_pos := -1 + 2 -- back to loop condition
				when 24 then -- loop done
						js.reset
						if l_topline = l_botline then
							globals_inst.curwin.item.w_cursor.lnum := l_topline
						elseif l_botline = 0 then
							globals_inst.curwin.item.w_cursor.lnum := l_topline
						elseif l_topline > l_botline then
							globals_inst.curwin.item.w_cursor.lnum := l_botline
						else
							if l_cln < l_topline then
								if globals_inst.curwin.item.w_topline > 1 then
									globals_inst.curwin.item.w_cursor.lnum := l_topline
									globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-28))
								end
							end
							if l_cln > l_botline then
								if globals_inst.curwin.item.w_botline <= globals_inst.curbuf.item.b_ml.ml_line_count then
									globals_inst.curwin.item.w_cursor.lnum := l_botline
									globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-28))
								end
							end
						end
						globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_or ((128))
				when 25 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	onepage (a_dir___0: INTEGER_32; a_count___2: INTEGER_32): INTEGER_32
		local
			l_count___2: INTEGER_32
			l_n: INTEGER_32
			l_retval: INTEGER_32
			l_loff: PD_LINEOFF_T
			l_old_topline___0: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_loff.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_count___2 := a_count___2
					l_retval := 1
					l_old_topline___0 := globals_inst.curwin.item.w_topline
					if globals_inst.curbuf.item.b_ml.ml_line_count = 1 then
						misc1_inst.beep_flush
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 25 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if not (not js.loop_left and then (l_count___2 > 0)) then
							l_pos := -1 + 24 -- skip loop
						end
				when 2 then -- loop body:
						js.reset
						validate_botline
						if a_dir___0 = 1 then
							if globals_inst.curwin.item.w_topline >= globals_inst.curbuf.item.b_ml.ml_line_count - option_inst.p_so then
								if globals_inst.curwin.item.w_botline > globals_inst.curbuf.item.b_ml.ml_line_count then
									l_tmp := 1
								else
									l_tmp := 0
								end
							else
								l_tmp := 0
							end
							l_tmp___2 := l_tmp
						else
							if globals_inst.curwin.item.w_topline = 1 then
								if globals_inst.curwin.item.w_topfill = (diff_inst.diff_check_fill (globals_inst.curwin, globals_inst.curwin.item.w_topline)) then
									l_tmp___1 := 1
								else
									l_tmp___1 := 0
								end
							else
								l_tmp___1 := 0
							end
							l_tmp___2 := l_tmp___1
						end
						if l_tmp___2.to_boolean then
							misc1_inst.beep_flush
							l_retval := 0
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 23 -- skip if block
						end
				when 3 then -- if:
						l_loff.fill := 0
						if a_dir___0 /= 1 then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if (globals_inst.firstwin.c_pointer.to_integer_32).to_natural_32 /= (globals_inst.lastwin.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if option_inst.p_window > 0 then
							if option_inst.p_window < globals_inst.Rows - 1 then
								if option_inst.p_window <= 2 then
									globals_inst.curwin.item.w_topline := (globals_inst.curwin.item.w_topline) + 1
								else
									globals_inst.curwin.item.w_topline := globals_inst.curwin.item.w_topline + (option_inst.p_window - 2)
								end
								if globals_inst.curwin.item.w_topline > globals_inst.curbuf.item.b_ml.ml_line_count then
									globals_inst.curwin.item.w_topline := globals_inst.curbuf.item.b_ml.ml_line_count
								end
								globals_inst.curwin.item.w_cursor.lnum := globals_inst.curwin.item.w_topline
							else
								l_pos := -1 + 7 -- goto _L___0
							end
						else
							l_pos := -1 + 7 -- goto _L___0
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L___0:
						if globals_inst.curwin.item.w_botline > globals_inst.curbuf.item.b_ml.ml_line_count then
							globals_inst.curwin.item.w_topline := globals_inst.curbuf.item.b_ml.ml_line_count
							globals_inst.curwin.item.w_topfill := 0
							globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-18))
						else
							l_loff.lnum := globals_inst.curwin.item.w_botline
							l_loff.fill := (diff_inst.diff_check_fill (globals_inst.curwin, l_loff.lnum)) - globals_inst.curwin.item.w_filler_rows
							get_scroll_overlap (l_loff.address, -1)
							globals_inst.curwin.item.w_topline := l_loff.lnum
							globals_inst.curwin.item.w_topfill := l_loff.fill
							check_topfill (globals_inst.curwin, 0)
							globals_inst.curwin.item.w_cursor.lnum := globals_inst.curwin.item.w_topline
							globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-124))
						end
				when 8 then -- if done | if block done, skip else block:
						l_pos := -1 + 23
				when 9 then -- else:
						if globals_inst.curwin.item.w_topline = 1 then
							max_topfill
							js.continue
						end
						if not js.loop_jumped and then ((globals_inst.firstwin.c_pointer.to_integer_32).to_natural_32 = (globals_inst.lastwin.c_pointer.to_integer_32).to_natural_32) then
							if option_inst.p_window > 0 then
								if option_inst.p_window < globals_inst.Rows - 1 then
									if option_inst.p_window <= 2 then
										globals_inst.curwin.item.w_topline := (globals_inst.curwin.item.w_topline) - 1
									else
										globals_inst.curwin.item.w_topline := globals_inst.curwin.item.w_topline - (option_inst.p_window - 2)
									end
									if globals_inst.curwin.item.w_topline < 1 then
										globals_inst.curwin.item.w_topline := (1).to_integer_32
									end
									globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_topline + option_inst.p_window) - 1
									if globals_inst.curwin.item.w_cursor.lnum > globals_inst.curbuf.item.b_ml.ml_line_count then
										globals_inst.curwin.item.w_cursor.lnum := globals_inst.curbuf.item.b_ml.ml_line_count
									end
									js.continue
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 23 -- skip if block
						end
				when 10 then -- if:
						l_loff.lnum := globals_inst.curwin.item.w_topline - 1
						l_loff.fill := (diff_inst.diff_check_fill (globals_inst.curwin, l_loff.lnum + 1)) - globals_inst.curwin.item.w_topfill
						get_scroll_overlap (l_loff.address, 1)
						if l_loff.lnum >= globals_inst.curbuf.item.b_ml.ml_line_count then
							l_loff.lnum := globals_inst.curbuf.item.b_ml.ml_line_count
							l_loff.fill := 0
						else
							botline_topline (l_loff.address)
						end
						globals_inst.curwin.item.w_cursor.lnum := l_loff.lnum
						l_n := 0
						from
						until
							js.loop_left
						loop
							js.reset
							if l_n <= (globals_inst.curwin.item.w_height).to_integer_32 then
								if not (l_loff.lnum >= 1) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								topline_back (l_loff.address)
								if (l_loff.height).to_integer_32 = 2147483647 then
									l_n := 2147483647
								else
									l_n := l_n + (l_loff.height).to_integer_32
								end
							end
						end
						js.reset
						if not (l_loff.lnum < 1) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						globals_inst.curwin.item.w_topline := (1).to_integer_32
						max_topfill
						globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-50))
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 13 then -- else:
						topline_botline (l_loff.address)
						botline_forw (l_loff.address)
						botline_forw (l_loff.address)
						botline_topline (l_loff.address)
						fold_inst.hasFolding (l_loff.lnum, create {CE_POINTER [INTEGER_32]}.make_shared (l_loff.c_pointer + {PD_LINEOFF_T}.lnum_offset), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)).do_nothing
						if not (l_loff.lnum >= globals_inst.curwin.item.w_topline) then
							l_pos := -1 + 22 -- skip if block
						end
				when 14 then -- if:
						if not (l_loff.lnum > globals_inst.curwin.item.w_topline) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 18 -- goto _L___1
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 17 then -- else:
						if not (l_loff.fill >= globals_inst.curwin.item.w_topfill) then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if: | _L___1:
						l_loff.fill := globals_inst.curwin.item.w_topfill
						if globals_inst.curwin.item.w_topfill < (diff_inst.diff_check_fill (globals_inst.curwin, globals_inst.curwin.item.w_topline)) then
							max_topfill
						end
						if globals_inst.curwin.item.w_topfill = l_loff.fill then
							globals_inst.curwin.item.w_topline := (globals_inst.curwin.item.w_topline) - 1
							globals_inst.curwin.item.w_topfill := 0
						end
						comp_botline (globals_inst.curwin)
						globals_inst.curwin.item.w_cursor.lnum := globals_inst.curwin.item.w_botline - 1
						globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-28))
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else:
						globals_inst.curwin.item.w_topline := l_loff.lnum
						globals_inst.curwin.item.w_topfill := l_loff.fill
						check_topfill (globals_inst.curwin, 0)
						globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-50))
				when 21 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else:
						globals_inst.curwin.item.w_topline := l_loff.lnum
						globals_inst.curwin.item.w_topfill := l_loff.fill
						check_topfill (globals_inst.curwin, 0)
						globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-50))
				when 23 then -- if done | if done | if done | if done
						if not js.loop_left then
							l_count___2 := l_count___2 - 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 24 then -- loop done
						js.reset
						fold_inst.foldAdjustCursor
						cursor_correct
						if l_retval = 1 then
							edit_inst.beginline (6)
						end
						globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-8))
						if l_retval = 1 then
							if a_dir___0 = 1 then
								if (check_top_offset).to_boolean then
									scroll_cursor_top (1, 0)
									if globals_inst.curwin.item.w_topline <= l_old_topline___0 then
										if l_old_topline___0 < globals_inst.curbuf.item.b_ml.ml_line_count then
											globals_inst.curwin.item.w_topline := l_old_topline___0 + 1
											fold_inst.hasFolding (globals_inst.curwin.item.w_topline, create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_topline_offset), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)).do_nothing
										end
									end
								end
							end
						end
						screen_inst.redraw_later (10)
						Result := l_retval
				when 25 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_scroll_overlap (a_lp: CE_POINTER [PD_LINEOFF_T]; a_dir___0: INTEGER_32)
		local
			l_h1: INTEGER_32
			l_h2: INTEGER_32
			l_h3: INTEGER_32
			l_h4: INTEGER_32
			l_min_height: INTEGER_32
			l_loff0: PD_LINEOFF_T
			l_loff1: PD_LINEOFF_T
			l_loff2: PD_LINEOFF_T
			js: JUMP_STATE
		do
			create l_loff0.make
			create l_loff1.make
			create l_loff2.make

			l_min_height := globals_inst.curwin.item.w_height - 2
			if a_lp.item.fill > 0 then
				a_lp.item.height := 1
			else
				a_lp.item.height := misc1_inst.plines_nofill (a_lp.item.lnum)
			end
			l_h1 := a_lp.item.height
			if l_h1 > l_min_height then
				js.return
			end
			if not js.return_called then
				l_loff0.ce_gets (a_lp.item)
				if a_dir___0 > 0 then
					botline_forw (a_lp)
				else
					topline_back (a_lp)
				end
				l_h2 := a_lp.item.height
				if l_h2 + l_h1 > l_min_height then
					a_lp.item := l_loff0
					js.return
				end
			end
			if not js.return_called then
				l_loff1.ce_gets (a_lp.item)
				if a_dir___0 > 0 then
					botline_forw (a_lp)
				else
					topline_back (a_lp)
				end
				l_h3 := a_lp.item.height
				if l_h3 + l_h2 > l_min_height then
					a_lp.item := l_loff0
					js.return
				end
			end
			if not js.return_called then
				l_loff2.ce_gets (a_lp.item)
				if a_dir___0 > 0 then
					botline_forw (a_lp)
				else
					topline_back (a_lp)
				end
				l_h4 := a_lp.item.height
				if (l_h4 + l_h3) + l_h2 > l_min_height then
					a_lp.item := l_loff1
				elseif (l_h3 + l_h2) + l_h1 > l_min_height then
					a_lp.item := l_loff1
				else
					a_lp.item := l_loff2
				end
			end
		end

	halfpage (a_flag: INTEGER_32; a_Prenum: INTEGER_32)
		local
			l_scrolled: INTEGER_32
			l_i___0: INTEGER_32
			l_n: INTEGER_32
			l_room: INTEGER_32
			js: JUMP_STATE
		do
			l_scrolled := 0
			if a_Prenum.to_boolean then
				if a_Prenum > (globals_inst.curwin.item.w_height).to_integer_32 then
					globals_inst.curwin.item.w_onebuf_opt.wo_scr := (globals_inst.curwin.item.w_height).to_integer_32
				else
					globals_inst.curwin.item.w_onebuf_opt.wo_scr := a_Prenum
				end
			end
			if globals_inst.curwin.item.w_onebuf_opt.wo_scr <= (globals_inst.curwin.item.w_height).to_integer_32 then
				l_n := (globals_inst.curwin.item.w_onebuf_opt.wo_scr).to_integer_32
			else
				l_n := globals_inst.curwin.item.w_height
			end
			validate_botline
			l_room := globals_inst.curwin.item.w_empty_rows
			l_room := l_room + (globals_inst.curwin.item.w_filler_rows)
			if a_flag.to_boolean then
				from
				until
					js.loop_left
				loop
					js.reset
					if l_n > 0 then
						if not (globals_inst.curwin.item.w_botline <= globals_inst.curbuf.item.b_ml.ml_line_count) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						if globals_inst.curwin.item.w_topfill > 0 then
							l_i___0 := 1
							l_n := l_n - 1
							if l_n < 0 then
								if l_scrolled > 0 then
									js.break
								end
							end
							if not js.loop_jumped then
								globals_inst.curwin.item.w_topfill := (globals_inst.curwin.item.w_topfill) - 1
							end
						else
							l_i___0 := misc1_inst.plines_nofill (globals_inst.curwin.item.w_topline)
							l_n := l_n - l_i___0
							if l_n < 0 then
								if l_scrolled > 0 then
									js.break
								end
							end
							if not js.loop_jumped then
								fold_inst.hasFolding (globals_inst.curwin.item.w_topline, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_topline_offset)).do_nothing
								globals_inst.curwin.item.w_topline := (globals_inst.curwin.item.w_topline) + 1
								globals_inst.curwin.item.w_topfill := diff_inst.diff_check_fill (globals_inst.curwin, globals_inst.curwin.item.w_topline)
								if globals_inst.curwin.item.w_cursor.lnum < globals_inst.curbuf.item.b_ml.ml_line_count then
									globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) + 1
									globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-15))
								end
							end
						end
					end
					if not js.loop_jumped then
						globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-18))
						l_scrolled := l_scrolled + l_i___0.to_integer_32
						if (globals_inst.curwin.item.w_onebuf_opt.wo_diff).to_boolean then
							globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-97))
						else
							l_room := l_room + l_i___0
							from
							until
								js.loop_left
							loop
								js.reset
								l_i___0 := misc1_inst.plines (globals_inst.curwin.item.w_botline)
								if l_i___0 > l_room then
									js.break
								end
								if not js.loop_jumped then
									fold_inst.hasFolding (globals_inst.curwin.item.w_botline, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_botline_offset)).do_nothing
									globals_inst.curwin.item.w_botline := (globals_inst.curwin.item.w_botline) + 1
									l_room := l_room - l_i___0
									if not (globals_inst.curwin.item.w_botline <= globals_inst.curbuf.item.b_ml.ml_line_count) then
										js.break
									end
								end
							end
							js.reset
						end
					end
				end
				js.reset
				if l_n > 0 then
					if (fold_inst.hasAnyFolding (globals_inst.curwin)).to_boolean then
						from
						until
							js.loop_left
						loop
							js.reset
							l_n := l_n - 1
							if l_n >= 0 then
								if not (globals_inst.curwin.item.w_cursor.lnum < globals_inst.curbuf.item.b_ml.ml_line_count) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								fold_inst.hasFolding (globals_inst.curwin.item.w_cursor.lnum, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset + {PD_POS_T}.lnum_offset)).do_nothing
								globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) + 1
							end
						end
						js.reset
					else
						globals_inst.curwin.item.w_cursor.lnum := globals_inst.curwin.item.w_cursor.lnum + l_n.to_integer_32
					end
					misc2_inst.check_cursor_lnum
				end
			else
				from
				until
					js.loop_left
				loop
					js.reset
					if l_n > 0 then
						if not (globals_inst.curwin.item.w_topline > 1) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						if globals_inst.curwin.item.w_topfill < (diff_inst.diff_check_fill (globals_inst.curwin, globals_inst.curwin.item.w_topline)) then
							l_i___0 := 1
							l_n := l_n - 1
							if l_n < 0 then
								if l_scrolled > 0 then
									js.break
								end
							end
							if not js.loop_jumped then
								globals_inst.curwin.item.w_topfill := (globals_inst.curwin.item.w_topfill) + 1
							end
						else
							l_i___0 := misc1_inst.plines_nofill (globals_inst.curwin.item.w_topline - 1)
							l_n := l_n - l_i___0
							if l_n < 0 then
								if l_scrolled > 0 then
									js.break
								end
							end
							if not js.loop_jumped then
								globals_inst.curwin.item.w_topline := (globals_inst.curwin.item.w_topline) - 1
								fold_inst.hasFolding (globals_inst.curwin.item.w_topline, create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_topline_offset), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)).do_nothing
								globals_inst.curwin.item.w_topfill := 0
							end
						end
					end
					if not js.loop_jumped then
						globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-114))
						l_scrolled := l_scrolled + l_i___0.to_integer_32
						if globals_inst.curwin.item.w_cursor.lnum > 1 then
							globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) - 1
							globals_inst.curwin.item.w_valid := (globals_inst.curwin.item.w_valid).bit_and ((-15))
						end
					end
				end
				js.reset
				if l_n > 0 then
					if globals_inst.curwin.item.w_cursor.lnum <= l_n.to_integer_32 then
						globals_inst.curwin.item.w_cursor.lnum := (1).to_integer_32
					elseif (fold_inst.hasAnyFolding (globals_inst.curwin)).to_boolean then
						from
						until
							js.loop_left
						loop
							js.reset
							l_n := l_n - 1
							if l_n >= 0 then
								if not (globals_inst.curwin.item.w_cursor.lnum > 1) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								globals_inst.curwin.item.w_cursor.lnum := (globals_inst.curwin.item.w_cursor.lnum) - 1
								fold_inst.hasFolding (globals_inst.curwin.item.w_cursor.lnum, create {CE_POINTER [INTEGER_32]}.make_shared (globals_inst.curwin.c_pointer + {PD_WINDOW_S}.w_cursor_offset + {PD_POS_T}.lnum_offset), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)).do_nothing
							end
						end
						js.reset
					else
						globals_inst.curwin.item.w_cursor.lnum := globals_inst.curwin.item.w_cursor.lnum - l_n.to_integer_32
					end
				end
			end
			fold_inst.foldAdjustCursor
			check_topfill (globals_inst.curwin, (not a_flag.to_boolean).to_integer)
			cursor_correct
			edit_inst.beginline (6)
			screen_inst.redraw_later (10)
		end

	do_check_cursorbind
		local
			l_line: INTEGER_32
			l_col: INTEGER_32
			l_old_curwin___1: CE_POINTER [PD_WINDOW_S]
			l_old_curbuf: CE_POINTER [PD_FILE_BUFFER]
			l_old_VIsual_select: INTEGER_32
			l_old_VIsual_active: INTEGER_32
		do
			create l_old_curwin___1.make
			create l_old_curbuf.make

			l_line := globals_inst.curwin.item.w_cursor.lnum
			l_col := globals_inst.curwin.item.w_cursor.col
			l_old_curwin___1.ce_gets (globals_inst.curwin)
			l_old_curbuf.ce_gets (globals_inst.curbuf)
			l_old_VIsual_select := globals_inst.VIsual_select
			l_old_VIsual_active := globals_inst.VIsual_active
			globals_inst.VIsual_active := 0
			globals_inst.VIsual_select := globals_inst.VIsual_active
			globals_inst.curwin.ce_gets (globals_inst.firstwin)
			from
			until
				(globals_inst.curwin).c_pointer = default_pointer
			loop
				globals_inst.curbuf.ce_gets (globals_inst.curwin.item.w_buffer)
				if (globals_inst.curwin.c_pointer.to_integer_32).to_natural_32 /= (l_old_curwin___1.c_pointer.to_integer_32).to_natural_32 then
					if (globals_inst.curwin.item.w_onebuf_opt.wo_crb).to_boolean then
						if (globals_inst.curwin.item.w_onebuf_opt.wo_diff).to_boolean then
							globals_inst.curwin.item.w_cursor.lnum := diff_inst.diff_get_corresponding_line (l_old_curbuf, l_line, globals_inst.curbuf, globals_inst.curwin.item.w_cursor.lnum)
						else
							globals_inst.curwin.item.w_cursor.lnum := l_line
						end
						globals_inst.curwin.item.w_cursor.col := l_col
						misc2_inst.check_cursor
						if globals_inst.has_mbyte.to_boolean then
							mbyte_inst.mb_adjust_cursor
						end
						screen_inst.redraw_later (10)
						update_topline
						globals_inst.curwin.item.w_redr_status := 1
					end
				end
				globals_inst.curwin.ce_gets (globals_inst.curwin.item.w_next)
			end
			globals_inst.VIsual_select := l_old_VIsual_select
			globals_inst.VIsual_active := l_old_VIsual_active
			globals_inst.curwin.ce_gets (l_old_curwin___1)
			globals_inst.curbuf.ce_gets (l_old_curbuf)
		end

end
