class
	P_TERM

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create term_strings.make (<<57>>)
			create builtin_termcaps.make (<<218>>)
			create termleader.make (<<257>>)
			create key_names.make (<<36>>)
			create tstrbuf.make (<<2048>>)
			create string_names.make (<<49>>)
			create out_buf.make (<<2048>>)
			create termcodes.make
			create orig_mouse_time.make
		end

feature {ANY} -- attributes

	term_strings: CE_ARRAY [CE_POINTER [NATURAL_8]]

	crv_status: INTEGER_32 assign set_crv_status

	set_crv_status (a_crv_status: INTEGER_32)
		do
			crv_status := a_crv_status
		end

	detected_8bit: INTEGER_32 assign set_detected_8bit

	set_detected_8bit (a_detected_8bit: INTEGER_32)
		do
			detected_8bit := a_detected_8bit
		end

	builtin_termcaps: CE_ARRAY [PD_BUILTIN_TERM]

	need_gather: INTEGER_32 assign set_need_gather

	set_need_gather (a_need_gather: INTEGER_32)
		do
			need_gather := a_need_gather
		end

	termleader: CE_ARRAY [NATURAL_8]

	check_for_codes: INTEGER_32 assign set_check_for_codes

	set_check_for_codes (a_check_for_codes: INTEGER_32)
		do
			check_for_codes := a_check_for_codes
		end

	key_names: CE_ARRAY [CE_POINTER [INTEGER_8]]

	tstrbuf: CE_ARRAY [NATURAL_8]

	string_names: CE_ARRAY [PD_STRING_NAMES]

	has_mouse_termcode: INTEGER_32 assign set_has_mouse_termcode

	set_has_mouse_termcode (a_has_mouse_termcode: INTEGER_32)
		do
			has_mouse_termcode := a_has_mouse_termcode
		end

	out_buf: CE_ARRAY [NATURAL_8]

	out_pos: INTEGER_32 assign set_out_pos

	set_out_pos (a_out_pos: INTEGER_32)
		do
			out_pos := a_out_pos
		end

	old_Rows: INTEGER_32 assign set_old_Rows

	set_old_Rows (a_old_Rows: INTEGER_32)
		do
			old_Rows := a_old_Rows
		end

	old_Columns: INTEGER_32 assign set_old_Columns

	set_old_Columns (a_old_Columns: INTEGER_32)
		do
			old_Columns := a_old_Columns
		end

	busy___2: INTEGER_32 assign set_busy___2

	set_busy___2 (a_busy___2: INTEGER_32)
		do
			busy___2 := a_busy___2
		end

	cursor_is_off: INTEGER_32 assign set_cursor_is_off

	set_cursor_is_off (a_cursor_is_off: INTEGER_32)
		do
			cursor_is_off := a_cursor_is_off
		end

	showing_insert_mode: INTEGER_32 assign set_showing_insert_mode

	set_showing_insert_mode (a_showing_insert_mode: INTEGER_32)
		do
			showing_insert_mode := a_showing_insert_mode
		end

	termcodes: CE_POINTER [PD_TERMCODE]

	tc_max_len: INTEGER_32 assign set_tc_max_len

	set_tc_max_len (a_tc_max_len: INTEGER_32)
		do
			tc_max_len := a_tc_max_len
		end

	tc_len: INTEGER_32 assign set_tc_len

	set_tc_len (a_tc_len: INTEGER_32)
		do
			tc_len := a_tc_len
		end

	orig_topline: INTEGER_32 assign set_orig_topline

	set_orig_topline (a_orig_topline: INTEGER_32)
		do
			orig_topline := a_orig_topline
		end

	orig_topfill: INTEGER_32 assign set_orig_topfill

	set_orig_topfill (a_orig_topfill: INTEGER_32)
		do
			orig_topfill := a_orig_topfill
		end

	held_button: INTEGER_32 assign set_held_button

	set_held_button (a_held_button: INTEGER_32)
		do
			held_button := a_held_button
		end

	orig_num_clicks: INTEGER_32 assign set_orig_num_clicks

	set_orig_num_clicks (a_orig_num_clicks: INTEGER_32)
		do
			orig_num_clicks := a_orig_num_clicks
		end

	orig_mouse_code: INTEGER_32 assign set_orig_mouse_code

	set_orig_mouse_code (a_orig_mouse_code: INTEGER_32)
		do
			orig_mouse_code := a_orig_mouse_code
		end

	orig_mouse_col: INTEGER_32 assign set_orig_mouse_col

	set_orig_mouse_col (a_orig_mouse_col: INTEGER_32)
		do
			orig_mouse_col := a_orig_mouse_col
		end

	orig_mouse_row: INTEGER_32 assign set_orig_mouse_row

	set_orig_mouse_row (a_orig_mouse_row: INTEGER_32)
		do
			orig_mouse_row := a_orig_mouse_row
		end

	orig_mouse_time: SD_TIMEVAL

	xt_index_in: INTEGER_32 assign set_xt_index_in

	set_xt_index_in (a_xt_index_in: INTEGER_32)
		do
			xt_index_in := a_xt_index_in
		end

	xt_index_out: INTEGER_32 assign set_xt_index_out

	set_xt_index_out (a_xt_index_out: INTEGER_32)
		do
			xt_index_out := a_xt_index_out
		end

feature {ANY} -- routines

	find_builtin_term (a_term: CE_POINTER [NATURAL_8]): CE_POINTER [PD_BUILTIN_TERM]
		local
			l_p___0: CE_POINTER [PD_BUILTIN_TERM]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (builtin_termcaps)
				when 1 then -- loop condition:
					if not (not js.loop_left and then (((l_p___0.item.bt_string).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32)) then
						l_pos := -1 + 11 -- skip loop
					end
				when 2 then -- loop body:
						if l_p___0.item.bt_entry /= 0 then
							l_pos := -1 + 10 -- skip if block
						end
				when 3 then -- if:
						if (strcmp (l_p___0.item.bt_string, ce_string ("iris-ansi"))) /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (os_unix_inst.vim_is_iris (a_term)).to_boolean then
							Result := l_p___0
							js.return
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else: | _L___0:
						if (strcmp (l_p___0.item.bt_string, ce_string ("xterm"))) /= 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if (os_unix_inst.vim_is_xterm (a_term)).to_boolean then
							Result := l_p___0
							js.return
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_term), l_p___0.item.bt_string)) = 0 then
							Result := l_p___0
							js.return
						end
				when 10 then -- if done | if done
						if not js.return_called then
							l_p___0.ce_gets (l_p___0 + 1)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 11 then -- loop done
					if not js.return_called then
						Result := l_p___0
					end
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	parse_builtin_tcap (a_term: CE_POINTER [NATURAL_8])
		local
			l_p___0: CE_POINTER [PD_BUILTIN_TERM]
			l_name___1: CE_ARRAY [NATURAL_8]
			l_term_8bit: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_t: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_name___1.make (<<2>>)
			create l_s.make
			create l_t.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (find_builtin_term (a_term))
					l_term_8bit := term_is_8bit (a_term)
					if ((l_p___0.item.bt_string).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 15 -- skip if block
					end
				when 1 then -- if:
						l_p___0.ce_gets (l_p___0 + 1)
				when 2 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 14 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if l_p___0.item.bt_entry /= 0 then
							if l_p___0.item.bt_entry = 257 then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 13 -- skip if block
						end
				when 4 then -- if:
						if not (l_p___0.item.bt_entry >= 0) then
							l_pos := -1 + 11 -- skip if block
						end
				when 5 then -- if:
						if ((term_strings[l_p___0.item.bt_entry]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if ((term_strings[l_p___0.item.bt_entry]).c_pointer.to_integer_32).to_natural_32 /= (globals_inst.empty_option.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						if l_term_8bit.to_boolean then
							if (term_7to8bit (create {CE_POINTER [NATURAL_8]}.make_cast (l_p___0.item.bt_string))) /= 0 then
								l_s.ce_gets (misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (l_p___0.item.bt_string)))
								if (l_s.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									l_t.ce_gets (l_s)
									from
									until
										not ((l_t.item).to_boolean)
									loop
										if (term_7to8bit (l_t)).to_boolean then
											l_t.item := (term_7to8bit (l_t)).to_natural_8
											strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_t + 1)), create {CE_POINTER [INTEGER_8]}.make_cast ((l_t + 2))).do_nothing
										end
										l_t.ce_gets (l_t + 1)
									end
									term_strings[l_p___0.item.bt_entry] := l_s
									option_inst.set_term_option_alloced (term_strings + l_p___0.item.bt_entry)
								end
							else
								term_strings[l_p___0.item.bt_entry] := create {CE_POINTER [NATURAL_8]}.make_cast (l_p___0.item.bt_string)
							end
						else
							term_strings[l_p___0.item.bt_entry] := create {CE_POINTER [NATURAL_8]}.make_cast (l_p___0.item.bt_string)
						end
				when 10 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_name___1[0] := ((-l_p___0.item.bt_entry).bit_and (255)).to_natural_8
						l_name___1[1] := (((((-l_p___0.item.bt_entry).to_natural_32).bit_shift_right (8))).bit_and ({NATURAL_32} 255)).to_natural_8
						if ((find_termcode (l_name___1)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							add_termcode (l_name___1, create {CE_POINTER [NATURAL_8]}.make_cast (l_p___0.item.bt_string), l_term_8bit)
						end
				when 12 then
						l_p___0.ce_gets (l_p___0 + 1)
				when 13 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 14 then -- loop done
						js.reset
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_color_count (a_nr: INTEGER_32)
		local
			l_nr_colors: CE_ARRAY [NATURAL_8]
		do
			create l_nr_colors.make (<<20>>)

			globals_inst.t_colors := a_nr
			if globals_inst.t_colors > 1 then
				sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_nr_colors), ce_string ("%%d"), globals_inst.t_colors]).do_nothing
			else
				l_nr_colors[0] := (('%/0/').code).to_natural_8
			end
			option_inst.set_string_option_direct (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("t_Co")), -1, l_nr_colors, 1, 0)
		end

	set_termname (a_term: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_term: CE_POINTER [NATURAL_8]
			l_termp: CE_POINTER [PD_BUILTIN_TERM]
			l_builtin_first: INTEGER_32
			l_try: INTEGER_32
			l_termcap_cleared: INTEGER_32
			l_width: INTEGER_32
			l_height: INTEGER_32
			l_error_msg: CE_POINTER [NATURAL_8]
			l_bs_p: CE_POINTER [NATURAL_8]
			l_del_p: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_tbuf: CE_ARRAY [NATURAL_8]
			l_tp: CE_POINTER [NATURAL_8]
			l_tmp___6: INTEGER_32
			l_p___1: CE_POINTER [NATURAL_8]
			l_old_curbuf: CE_POINTER [PD_FILE_BUFFER]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_term.make
			create l_termp.make
			create l_error_msg.make
			create l_bs_p.make
			create l_del_p.make
			create l_p___0.make
			create l_tbuf.make (<<2048>>)
			create l_tp.make
			create l_p___1.make
			create l_old_curbuf.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_term.ce_gets (a_term)
					l_builtin_first := option_inst.p_tbi
					l_termcap_cleared := 0
					l_width := 0
					l_height := 0
					l_error_msg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					if globals_inst.silent_mode.to_boolean then
						Result := 1
						js.return
					end
					if js.return_called then
						l_pos := -1 + 35 -- skip if block
					end
				when 1 then -- if:
						detected_8bit := 0
						if (term_is_builtin (l_term)).to_boolean then
							l_term.ce_gets (l_term + (8))
							l_builtin_first := 1
						end
						if l_builtin_first.to_boolean then
							l_try := 0
						else
							l_try := 1
						end
				when 2 then -- loop condition:
						if not (not js.loop_left and then (l_try < 3)) then
							l_pos := -1 + 34 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if l_try /= 1 then
							l_pos := -1 + 32 -- skip if block
						end
				when 4 then -- if:
						l_error_msg.ce_gets (tgetent_error (l_tbuf, l_term))
						if (l_error_msg.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 31 -- skip if block
						end
				when 5 then -- if:
						l_tp.ce_gets (tstrbuf)
						if not l_termcap_cleared.to_boolean then
							option_inst.clear_termoptions
							l_termcap_cleared := 1
						end
						l_i___0 := 0
						from
						until
							((string_names[l_i___0].name).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
						loop
							if ((term_strings[string_names[l_i___0].dest]).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								term_strings[string_names[l_i___0].dest] := vim_tgetstr (string_names[l_i___0].name, l_tp.address)
							elseif ((term_strings[string_names[l_i___0].dest]).c_pointer.to_integer_32).to_natural_32 = (globals_inst.empty_option.c_pointer.to_integer_32).to_natural_32 then
								term_strings[string_names[l_i___0].dest] := vim_tgetstr (string_names[l_i___0].name, l_tp.address)
							end
							l_i___0 := l_i___0 + 1
						end
						if ((term_strings[26]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if ((term_strings[26]).c_pointer.to_integer_32).to_natural_32 /= (globals_inst.empty_option.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						if (tgetflag (ce_string ("ms"))) > 0 then
							term_strings[26] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("y"))
						end
				when 10 then -- if done
						if ((term_strings[40]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L___0
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 13 then -- else:
						if ((term_strings[40]).c_pointer.to_integer_32).to_natural_32 /= (globals_inst.empty_option.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 15 -- skip if block
						end
				when 14 then -- if: | _L___0:
						if (tgetflag (ce_string ("xs"))) > 0 then
							term_strings[40] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("y"))
						end
				when 15 then -- if done
						if ((term_strings[11]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 19 -- goto _L___1
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 18 then -- else:
						if ((term_strings[11]).c_pointer.to_integer_32).to_natural_32 /= (globals_inst.empty_option.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 20 -- skip if block
						end
				when 19 then -- if: | _L___1:
						if (tgetflag (ce_string ("db"))) > 0 then
							term_strings[11] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("y"))
						end
				when 20 then -- if done
						if ((term_strings[10]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 24 -- goto _L___2
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 23 then -- else:
						if ((term_strings[10]).c_pointer.to_integer_32).to_natural_32 /= (globals_inst.empty_option.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 25 -- skip if block
						end
				when 24 then -- if: | _L___2:
						if (tgetflag (ce_string ("da"))) > 0 then
							term_strings[10] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("y"))
						end
				when 25 then -- if done
						if ((term_strings[9]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						l_pos := -1 + 29 -- goto _L___3
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 28 then -- else:
						if ((term_strings[9]).c_pointer.to_integer_32).to_natural_32 /= (globals_inst.empty_option.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 30 -- skip if block
						end
				when 29 then -- if: | _L___3:
						if (tgetflag (ce_string ("ut"))) > 0 then
							term_strings[9] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("y"))
						end
				when 30 then -- if done
						l_i___0 := 0
						from
						until
							((key_names[l_i___0]).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
						loop
							if ((find_termcode (create {CE_POINTER [NATURAL_8]}.make_cast (key_names[l_i___0]))).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								l_p___0.ce_gets (vim_tgetstr (key_names[l_i___0], l_tp.address))
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									if (l_p___0.item).to_integer_32 /= 8 then
										add_termcode (create {CE_POINTER [NATURAL_8]}.make_cast (key_names[l_i___0]), l_p___0, 0)
									elseif ((key_names[l_i___0])[0]).to_integer_32 /= 107 then
										add_termcode (create {CE_POINTER [NATURAL_8]}.make_cast (key_names[l_i___0]), l_p___0, 0)
									elseif ((key_names[l_i___0])[1]).to_integer_32 /= 108 then
										add_termcode (create {CE_POINTER [NATURAL_8]}.make_cast (key_names[l_i___0]), l_p___0, 0)
									end
								end
							end
							l_i___0 := l_i___0 + 1
						end
						if l_height = 0 then
							l_height := tgetnum (ce_string ("li"))
						end
						if l_width = 0 then
							l_width := tgetnum (ce_string ("co"))
						end
						if ((term_strings[37]).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_tmp___6 := tgetnum (ce_string ("Co"))
							set_color_count (l_tmp___6)
						elseif ((term_strings[37]).c_pointer.to_integer_32).to_natural_32 = (globals_inst.empty_option.c_pointer.to_integer_32).to_natural_32 then
							l_tmp___6 := tgetnum (ce_string ("Co"))
							set_color_count (l_tmp___6)
						end
						Current.BC := create {CE_POINTER [INTEGER_8]}.make_cast ((vim_tgetstr (ce_string ("bc"), l_tp.address)))
						Current.UP := create {CE_POINTER [INTEGER_8]}.make_cast ((vim_tgetstr (ce_string ("up"), l_tp.address)))
						l_p___0.ce_gets (vim_tgetstr (ce_string ("pc"), l_tp.address))
						if ((l_p___0).c_pointer /= default_pointer) then
							Current.PC := (l_p___0.item).to_integer_8
						end
				when 31 then -- if done | if block done, skip else block:
						l_pos := -1 + 33
				when 32 then -- else:
						if l_try = 2 then
							if l_builtin_first.to_boolean then
								if l_termcap_cleared.to_boolean then
									js.break
								end
							end
						end
						if not js.loop_jumped then
							l_termp.ce_gets (find_builtin_term (l_term))
							if ((l_termp.item.bt_string).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								if l_try = 0 then
									js.continue
								end
								if not js.loop_jumped and then (l_termcap_cleared.to_boolean) then
									js.break
								end
								if not js.loop_jumped then
									message_inst.mch_errmsg (ce_string ("%R%N"))
									if (l_error_msg.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
										message_inst.mch_errmsg (create {CE_POINTER [INTEGER_8]}.make_cast (l_error_msg))
										message_inst.mch_errmsg (ce_string ("%R%N"))
									end
									message_inst.mch_errmsg (ce_string ("%'"))
									message_inst.mch_errmsg (create {CE_POINTER [INTEGER_8]}.make_cast (l_term))
									message_inst.mch_errmsg ((gettext (ce_string ("%' not known. Available builtin terminals are:"))))
									message_inst.mch_errmsg (ce_string ("%R%N"))
									l_termp.ce_gets (builtin_termcaps + 0)
									from
									until
										((l_termp.item.bt_string).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
									loop
										if l_termp.item.bt_entry = 0 then
											message_inst.mch_errmsg (ce_string ("    builtin_"))
											message_inst.mch_errmsg (l_termp.item.bt_string)
											message_inst.mch_errmsg (ce_string ("%R%N"))
										end
										l_termp.ce_gets (l_termp + 1)
									end
									if globals_inst.starting /= 2 then
										screen_inst.screen_start
										message_inst.wait_return (1)
										Result := 0
										js.return
									end
									if not js.return_called then
										l_term.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ansi")))
										message_inst.mch_errmsg ((gettext (ce_string ("defaulting to %'"))))
										message_inst.mch_errmsg (create {CE_POINTER [INTEGER_8]}.make_cast (l_term))
										message_inst.mch_errmsg (ce_string ("%'%R%N"))
										if globals_inst.emsg_silent = 0 then
											screen_inst.screen_start
											out_flush
											ui_inst.ui_delay (2000, 1)
										end
										option_inst.set_string_option_direct (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("term")), -1, l_term, 1, 0)
										gui_inst.display_errors
									end
								end
							end
						end
						if not js.loop_jumped then
							out_flush
							if not l_termcap_cleared.to_boolean then
								option_inst.clear_termoptions
								l_termcap_cleared := 1
							end
							parse_builtin_tcap (l_term)
							if (term_is_gui (l_term)).to_boolean then
								out_flush
								gui_inst.gui_init
								if not (gui_inst.gui.in_use).to_boolean then
									Result := 0
									js.return
								end
								if not js.return_called then
									js.break
								end
							end
						end
				when 33 then -- if done
						if not js.loop_left then
							l_try := l_try + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 34 then -- loop done
						js.reset
				when 35 then -- if done
					if js.return_called then
						l_pos := -1 + 43 -- skip if block
					end
				when 36 then -- if:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_term), ce_string ("pcterm"))) = 0 then
							term_strings[36] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("yes"))
						else
							term_strings[36] := globals_inst.empty_option
						end
						if not (gui_inst.gui.in_use).to_boolean then
							os_unix_inst.get_stty
						end
						if (gui_inst.gui.in_use).to_boolean then
							l_pos := -1 + 42 -- skip if block
						end
				when 37 then -- if:
						l_bs_p.ce_gets (find_termcode (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kb"))))
						l_del_p.ce_gets (find_termcode (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kD"))))
						if (l_bs_p.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_bs_p.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%B")))
							add_termcode (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kb")), l_bs_p, 0)
						elseif (l_bs_p.item).to_integer_32 = 0 then
							l_bs_p.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%B")))
							add_termcode (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kb")), l_bs_p, 0)
						end
						if (l_del_p.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						l_pos := -1 + 41 -- goto _L___4
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 40 then -- else:
						if (l_del_p.item).to_integer_32 /= 0 then
							l_pos := -1 + 42 -- skip if block
						end
				when 41 then -- if: | _L___4:
						if (l_bs_p.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							add_termcode (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kD")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/127/")), 0)
						elseif (l_bs_p.item).to_integer_32 /= 127 then
							add_termcode (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kD")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/127/")), 0)
						end
				when 42 then -- if done | if done
						globals_inst.term_is_xterm := os_unix_inst.vim_is_xterm (l_term)
						l_p___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
						if not (gui_inst.gui.in_use).to_boolean then
							ui_inst.clip_init (0)
						end
						if (os_unix_inst.use_xterm_like_mouse (l_term)).to_boolean then
							if (os_unix_inst.use_xterm_mouse).to_boolean then
								l_p___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							else
								l_p___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("xterm")))
							end
						end
						if (l_p___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ttym")), 0, l_p___1, 0)
						end
						if (l_p___1.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							os_unix_inst.check_mouse_termcode
						elseif (gui_inst.gui.in_use).to_boolean then
							os_unix_inst.check_mouse_termcode
						end
						if (os_unix_inst.vim_is_fastterm (l_term)).to_boolean then
							option_inst.p_tf := 1
						end
						ttest (1)
						globals_inst.full_screen := 1
						option_inst.set_term_defaults
						crv_status := 1
						if globals_inst.starting /= 2 then
							starttermcap
							setmouse
							buffer_inst.maketitle
						end
						if l_width <= 0 then
							l_width := 80
							l_height := 24
						elseif l_height <= 0 then
							l_width := 80
							l_height := 24
						end
						set_shellsize (l_width, l_height, 0)
						if globals_inst.starting /= 2 then
							if globals_inst.scroll_region.to_boolean then
								scroll_region_reset
							end
							getchar_inst.check_map_keycodes
							l_old_curbuf.ce_gets (globals_inst.curbuf)
							globals_inst.curbuf.ce_gets (globals_inst.firstbuf)
							from
							until
								(globals_inst.curbuf.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32
							loop
								if ((globals_inst.curbuf.item.b_ml.ml_mfp).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
									fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_TERMCHANGED, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf).do_nothing
								end
								globals_inst.curbuf.ce_gets (globals_inst.curbuf.item.b_next)
							end
							if (buffer_inst.buf_valid (l_old_curbuf)).to_boolean then
								globals_inst.curbuf.ce_gets (l_old_curbuf)
							end
						end
						may_req_termresponse
						Result := 1
				when 43 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_mouse_termcode (a_n: INTEGER_32; a_s: CE_POINTER [NATURAL_8])
		local
			l_name___1: CE_ARRAY [NATURAL_8]
		do
			create l_name___1.make (<<2>>)

			l_name___1[0] := a_n.to_natural_8
			l_name___1[1] := (('X').code).to_natural_8
			add_termcode (l_name___1, a_s, 0)
			has_mouse_termcode := (has_mouse_termcode).bit_or ((1))
		end

	del_mouse_termcode (a_n: INTEGER_32)
		local
			l_name___1: CE_ARRAY [NATURAL_8]
		do
			create l_name___1.make (<<2>>)

			l_name___1[0] := a_n.to_natural_8
			l_name___1[1] := (('X').code).to_natural_8
			del_termcode (l_name___1)
			has_mouse_termcode := (has_mouse_termcode).bit_and ((-2))
		end

	tgetent_error (a_tbuf: CE_POINTER [NATURAL_8]; a_term: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_i___0 := tgetent (create {CE_POINTER [INTEGER_8]}.make_cast (a_tbuf), create {CE_POINTER [INTEGER_8]}.make_cast (a_term))
					if not (l_i___0 < 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_i___0 /= 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						tgetent (create {CE_POINTER [INTEGER_8]}.make_cast (a_tbuf), ce_string ("dumb")).do_nothing
						if l_i___0 < 0 then
							Result := (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E557: Cannot open termcap file")))))
							js.return
						end
						if not js.return_called and then (l_i___0 = 0) then
							Result := (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E558: Terminal entry not found in terminfo")))))
							js.return
						end
				when 5 then -- if done
						if not js.return_called then
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	vim_tgetstr (a_s: CE_POINTER [INTEGER_8]; a_pp: CE_POINTER [CE_POINTER [NATURAL_8]]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [INTEGER_8]
		do
			create l_p___0.make

			l_p___0.ce_gets (tgetstr (a_s, create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast (a_pp)))
			if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (-1).to_natural_32 then
				l_p___0.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
			end
			Result := (create {CE_POINTER [NATURAL_8]}.make_cast (l_p___0))
		end

	getlinecol (a_cp: CE_POINTER [INTEGER_32]; a_rp: CE_POINTER [INTEGER_32])
		local
			l_tbuf: CE_ARRAY [NATURAL_8]
		do
			create l_tbuf.make (<<2048>>)

			if ((term_strings[0]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if ((term_strings[0]).item).to_integer_32 /= 0 then
					if ((tgetent_error (l_tbuf, term_strings[0])).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						if a_cp.item = 0 then
							a_cp.item := (tgetnum (ce_string ("co"))).to_integer_32
						end
						if a_rp.item = 0 then
							a_rp.item := (tgetnum (ce_string ("li"))).to_integer_32
						end
					end
				end
			end
		end

	add_termcap_entry (a_name___1: CE_POINTER [NATURAL_8]; a_force: INTEGER_32): INTEGER_32
		local
			l_term: CE_POINTER [NATURAL_8]
			l_key: INTEGER_32
			l_termp: CE_POINTER [PD_BUILTIN_TERM]
			l_string___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_builtin_first: INTEGER_32
			l_tbuf: CE_ARRAY [NATURAL_8]
			l_tstrbuf___0: CE_ARRAY [NATURAL_8]
			l_tp: CE_POINTER [NATURAL_8]
			l_error_msg: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_term.make
			create l_termp.make
			create l_string___0.make
			create l_tbuf.make (<<2048>>)
			create l_tstrbuf___0.make (<<2048>>)
			create l_tp.make
			create l_error_msg.make

			l_tp.ce_gets (l_tstrbuf___0)
			l_error_msg.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			if (gui_inst.gui.in_use).to_boolean then
				l_tmp := gui_gtk_x11_inst.gui_mch_haskey (a_name___1)
				Result := l_tmp
				js.return
			elseif (gui_inst.gui.starting).to_boolean then
				l_tmp := gui_gtk_x11_inst.gui_mch_haskey (a_name___1)
				Result := l_tmp
				js.return
			end
			if not js.return_called and then (not a_force.to_boolean) then
				if ((find_termcode (a_name___1)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				l_term.ce_gets (term_strings[0])
				if (l_term.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					Result := 0
					js.return
				elseif (l_term.item).to_integer_32 = 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if (term_is_builtin (l_term)).to_boolean then
					l_term.ce_gets (l_term + (8))
					l_builtin_first := 1
				else
					l_builtin_first := option_inst.p_tbi
				end
				l_i___0 := 0
				from
				until
					not (not js.loop_left and then (l_i___0 < 2))
				loop
					if not l_builtin_first.to_boolean = l_i___0.to_boolean then
						l_termp.ce_gets (find_builtin_term (l_term))
						if ((l_termp.item.bt_string).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_key := -((a_name___1[0]).to_integer_32 + (((a_name___1[1]).to_integer_32).bit_shift_left (8)))
							from
							until
								not (not js.loop_left and then (l_termp.item.bt_entry /= 0))
							loop
								if l_termp.item.bt_entry = l_key then
									add_termcode (a_name___1, create {CE_POINTER [NATURAL_8]}.make_cast (l_termp.item.bt_string), (term_is_8bit (l_term)))
									Result := 1
									js.return
								end
								if not js.return_called then
									l_termp.ce_gets (l_termp + 1)
								end
							end
						end
					else
						l_error_msg.ce_gets (tgetent_error (l_tbuf, l_term))
						if (l_error_msg.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_string___0.ce_gets (vim_tgetstr (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), l_tp.address))
							if (l_string___0.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
								if (l_string___0.item).to_integer_32 /= 0 then
									add_termcode (a_name___1, l_string___0, 0)
									Result := 1
									js.return
								end
							end
						end
					end
					if not js.return_called then
						l_i___0 := l_i___0 + 1
					end
				end
			end
			if not js.return_called then
				if (globals_inst.sourcing_name.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					if (l_error_msg.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						message_inst.emsg (l_error_msg).do_nothing
					else
						message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E436: No %"%%s%" entry in termcap")))), a_name___1).do_nothing
					end
				end
				Result := 0
			end
		end

	term_is_builtin (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := ((strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("builtin_"), (8).to_natural_32)) = 0).to_integer
		end

	term_is_8bit (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if detected_8bit.to_boolean then
				l_tmp___0 := 1
			elseif ((strstr (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("8bit"))).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_tmp___0 := 1
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	term_7to8bit (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if (a_p___0.item).to_integer_32 = 27 then
				if (a_p___0[1]).to_integer_32 = 91 then
					Result := 155
					js.return
				end
				if not js.return_called and then ((a_p___0[1]).to_integer_32 = 93) then
					Result := 157
					js.return
				end
				if not js.return_called and then ((a_p___0[1]).to_integer_32 = 79) then
					Result := 143
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	term_is_gui (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___1: INTEGER_32
		do
			if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("builtin_gui"))) = 0 then
				l_tmp___1 := 1
			elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_name___1), ce_string ("gui"))) = 0 then
				l_tmp___1 := 1
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	termcapinit (a_name___1: CE_POINTER [NATURAL_8])
		local
			l_name___1: CE_POINTER [NATURAL_8]
			l_term: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
		do
			create l_name___1.make
			create l_term.make
			create l_tmp___0.make

			l_name___1.ce_gets (a_name___1)
			if (l_name___1.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (l_name___1.item).to_integer_32 = 0 then
					l_name___1.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				end
			end
			l_term.ce_gets (l_name___1)
			if (l_term.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_term.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast ((getenv (ce_string ("TERM")))))
			end
			if (l_term.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_term.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ansi")))
			elseif (l_term.item).to_integer_32 = 0 then
				l_term.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ansi")))
			end
			option_inst.set_string_option_direct (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("term")), -1, l_term, 1, 0)
			option_inst.set_string_default (ce_string ("term"), l_term)
			option_inst.set_string_default (ce_string ("ttytype"), l_term)
			if ((term_strings[0]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				l_tmp___0.ce_gets (term_strings[0])
			else
				l_tmp___0.ce_gets (l_term)
			end
			set_termname (l_tmp___0).do_nothing
		end

	out_flush
		local
			l_len: INTEGER_32
		do
			if out_pos /= 0 then
				l_len := out_pos
				out_pos := 0
				ui_inst.ui_write (out_buf, l_len)
			end
		end

	out_flush_check
		do
			if globals_inst.enc_dbcs /= 0 then
				if out_pos >= 2026 then
					out_flush
				end
			end
		end

	out_trash
		do
			out_pos := 0
		end

	out_char (a_c: NATURAL_32)
		local
			l_tmp: INTEGER_32
		do
			if a_c = {NATURAL_32} 10 then
				out_char ((('%R').code).to_natural_32)
			end
			l_tmp := out_pos
			out_pos := out_pos + 1
			out_buf[l_tmp] := a_c.to_natural_8
			if out_pos >= 2047 then
				out_flush
			elseif option_inst.p_wd.to_boolean then
				out_flush
			end
		end

	out_char_nf (a_c: NATURAL_32)
		local
			l_tmp: INTEGER_32
		do
			if a_c = {NATURAL_32} 10 then
				out_char_nf ((('%R').code).to_natural_32)
			end
			l_tmp := out_pos
			out_pos := out_pos + 1
			out_buf[l_tmp] := a_c.to_natural_8
			if out_pos >= 2047 then
				out_flush
			end
		end

	out_char_nf_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent out_char_nf)
		end

	out_str_nf (a_s: CE_POINTER [NATURAL_8])
		local
			l_s: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
		do
			create l_s.make
			create l_tmp.make

			l_s.ce_gets (a_s)
			if out_pos > 2027 then
				out_flush
			end
			from
			until
				not ((l_s.item).to_boolean)
			loop
				l_tmp.ce_gets (l_s)
				l_s.ce_gets (l_s + 1)
				out_char_nf ((l_tmp.item).to_natural_32)
			end
			if option_inst.p_wd.to_boolean then
				out_flush
			end
		end

	out_str (a_s: CE_POINTER [NATURAL_8])
		local
			js: JUMP_STATE
		do
			if (a_s.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				if (a_s.item).to_boolean then
					if (gui_inst.gui.in_use).to_boolean then
						out_str_nf (a_s)
						js.return
					end
					if not js.return_called then
						if out_pos > 2027 then
							out_flush
						end
						tputs (create {CE_POINTER [INTEGER_8]}.make_cast (a_s), 1, (out_char_nf_address)).do_nothing
						if option_inst.p_wd.to_boolean then
							out_flush
						end
					end
				end
			end
			if not js.return_called then
			end
		end

	term_windgoto (a_row: INTEGER_32; a_col: INTEGER_32)
		do
			out_str (create {CE_POINTER [NATURAL_8]}.make_cast ((tgoto (create {CE_POINTER [INTEGER_8]}.make_cast (term_strings[27]), a_col, a_row))))
		end

	term_cursor_right (a_i___0: INTEGER_32)
		do
			out_str (create {CE_POINTER [NATURAL_8]}.make_cast ((tgoto (create {CE_POINTER [INTEGER_8]}.make_cast (term_strings[29]), 0, a_i___0))))
		end

	term_append_lines (a_line_count: INTEGER_32)
		do
			out_str (create {CE_POINTER [NATURAL_8]}.make_cast ((tgoto (create {CE_POINTER [INTEGER_8]}.make_cast (term_strings[3]), 0, a_line_count))))
		end

	term_delete_lines (a_line_count: INTEGER_32)
		do
			out_str (create {CE_POINTER [NATURAL_8]}.make_cast ((tgoto (create {CE_POINTER [INTEGER_8]}.make_cast (term_strings[5]), 0, a_line_count))))
		end

	term_set_winpos (a_x___0: INTEGER_32; a_y: INTEGER_32)
		local
			l_x___0: INTEGER_32
			l_y: INTEGER_32
		do
			l_x___0 := a_x___0
			l_y := a_y
			if l_x___0 < 0 then
				l_x___0 := 0
			end
			if l_y < 0 then
				l_y := 0
			end
			out_str (create {CE_POINTER [NATURAL_8]}.make_cast ((tgoto (create {CE_POINTER [INTEGER_8]}.make_cast (term_strings[50]), l_y, l_x___0))))
		end

	term_set_winsize (a_width: INTEGER_32; a_height: INTEGER_32)
		do
			out_str (create {CE_POINTER [NATURAL_8]}.make_cast ((tgoto (create {CE_POINTER [INTEGER_8]}.make_cast (term_strings[51]), a_height, a_width))))
		end

	term_fg_color (a_n: INTEGER_32)
		do
			if ((term_strings[42]).item).to_boolean then
				term_color (term_strings[42], a_n)
			elseif ((term_strings[38]).item).to_boolean then
				term_color (term_strings[38], a_n)
			end
		end

	term_bg_color (a_n: INTEGER_32)
		do
			if ((term_strings[43]).item).to_boolean then
				term_color (term_strings[43], a_n)
			elseif ((term_strings[39]).item).to_boolean then
				term_color (term_strings[39], a_n)
			end
		end

	term_color (a_s: CE_POINTER [NATURAL_8]; a_n: INTEGER_32)
		local
			l_buf___6: CE_ARRAY [INTEGER_8]
			l_i___0: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: INTEGER_32
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_pos: INTEGER_32
		do
			create l_buf___6.make (<<20>>)
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___5.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_i___0 := 2
					if not (a_n >= 8) then
						l_pos := -1 + 30 -- skip if block
					end
				when 1 then -- if:
						if not (globals_inst.t_colors >= 16) then
							l_pos := -1 + 28 -- skip if block
						end
				when 2 then -- if:
						if (a_s[0]).to_integer_32 /= 27 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (a_s[1]).to_integer_32 = 91 then
							l_pos := -1 + 7 -- goto _L___1
						else
							l_pos := -1 + 5 -- goto _L___2
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 5 then -- else: | _L___2:
						if (a_s[0]).to_integer_32 /= 155 then
							l_pos := -1 + 26 -- skip if block
						end
				when 6 then -- if:
						l_i___0 := 1
						if l_i___0 /= 1 then
							l_pos := -1 + 24 -- skip if block
						end
				when 7 then -- if: | _L___1:
						if (a_s[l_i___0]).to_integer_32 = 0 then
							l_pos := -1 + 22 -- skip if block
						end
				when 8 then -- if:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (((a_s + l_i___0) + 1)), ce_string ("%%p1%%dm"))) /= 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L___0
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 11 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (((a_s + l_i___0) + 1)), ce_string ("%%dm"))) /= 0 then
							l_pos := -1 + 20 -- skip if block
						end
				when 12 then -- if: | _L___0:
						if (a_s[l_i___0]).to_integer_32 /= 51 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 15 then -- else:
						if (a_s[l_i___0]).to_integer_32 /= 52 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if: | _L:
						if (a_s[l_i___0]).to_integer_32 = 51 then
							if a_n >= 16 then
								l_tmp.ce_gets (ce_string ("38;5;"))
							else
								l_tmp.ce_gets (ce_string ("9"))
							end
							l_tmp___1.ce_gets (l_tmp)
						else
							if a_n >= 16 then
								l_tmp___0.ce_gets (ce_string ("48;5;"))
							else
								l_tmp___0.ce_gets (ce_string ("10"))
							end
							l_tmp___1.ce_gets (l_tmp___0)
						end
						if l_i___0 = 2 then
							l_tmp___2.ce_gets (ce_string ("%/27/["))
						else
							l_tmp___2.ce_gets (ce_string ("%/155/"))
						end
						sprintf ([l_buf___6, ce_string ("%%s%%s%%%%p1%%%%dm"), l_tmp___2, l_tmp___1]).do_nothing
						if a_n >= 16 then
							l_tmp___3 := a_n
						else
							l_tmp___3 := a_n - 8
						end
						out_str (create {CE_POINTER [NATURAL_8]}.make_cast ((tgoto (l_buf___6, 0, l_tmp___3))))
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						l_tmp___5.ce_gets (tgoto (create {CE_POINTER [INTEGER_8]}.make_cast (a_s), 0, a_n))
						out_str (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___5))
				when 19 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else:
						l_tmp___5.ce_gets (tgoto (create {CE_POINTER [INTEGER_8]}.make_cast (a_s), 0, a_n))
						out_str (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___5))
				when 21 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else:
						l_tmp___5.ce_gets (tgoto (create {CE_POINTER [INTEGER_8]}.make_cast (a_s), 0, a_n))
						out_str (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___5))
				when 23 then -- if done | if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else:
						l_tmp___5.ce_gets (tgoto (create {CE_POINTER [INTEGER_8]}.make_cast (a_s), 0, a_n))
						out_str (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___5))
				when 25 then -- if done | if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:
						l_tmp___5.ce_gets (tgoto (create {CE_POINTER [INTEGER_8]}.make_cast (a_s), 0, a_n))
						out_str (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___5))
				when 27 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else:
						l_tmp___5.ce_gets (tgoto (create {CE_POINTER [INTEGER_8]}.make_cast (a_s), 0, a_n))
						out_str (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___5))
				when 29 then -- if done | if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else:
						l_tmp___5.ce_gets (tgoto (create {CE_POINTER [INTEGER_8]}.make_cast (a_s), 0, a_n))
						out_str (create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___5))
				when 31 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	term_settitle (a_title: CE_POINTER [NATURAL_8])
		do
			out_str (create {CE_POINTER [NATURAL_8]}.make_cast ((tgoto (create {CE_POINTER [INTEGER_8]}.make_cast (term_strings[48]), 0, 0))))
			out_str_nf (a_title)
			out_str (term_strings[49])
			out_flush
		end

	ttest (a_pairs: INTEGER_32)
		do
			option_inst.check_options
			if ((term_strings[27]).item).to_integer_32 = 0 then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E437: terminal capability %"cm%" required"))))).do_nothing
			end
			if ((term_strings[6]).item).to_integer_32 /= 0 then
				globals_inst.scroll_region := 1
			else
				globals_inst.scroll_region := 0
			end
			if a_pairs.to_boolean then
				if ((term_strings[15]).item).to_integer_32 = 0 then
					term_strings[41] := globals_inst.empty_option
					term_strings[17] := term_strings[41]
					term_strings[16] := term_strings[17]
					term_strings[15] := term_strings[16]
				end
				if ((term_strings[19]).item).to_integer_32 = 0 then
					term_strings[18] := globals_inst.empty_option
					term_strings[19] := term_strings[18]
				elseif ((term_strings[18]).item).to_integer_32 = 0 then
					term_strings[18] := globals_inst.empty_option
					term_strings[19] := term_strings[18]
				end
				if ((term_strings[23]).item).to_integer_32 = 0 then
					term_strings[22] := globals_inst.empty_option
					term_strings[23] := term_strings[22]
				elseif ((term_strings[22]).item).to_integer_32 = 0 then
					term_strings[22] := globals_inst.empty_option
					term_strings[23] := term_strings[22]
				end
				if ((term_strings[20]).item).to_integer_32 = 0 then
					term_strings[21] := globals_inst.empty_option
					term_strings[20] := term_strings[21]
				elseif ((term_strings[21]).item).to_integer_32 = 0 then
					term_strings[21] := globals_inst.empty_option
					term_strings[20] := term_strings[21]
				end
				if ((term_strings[13]).item).to_integer_32 = 0 then
					term_strings[12] := globals_inst.empty_option
				end
				if ((term_strings[15]).item).to_integer_32 = 0 then
					term_strings[15] := term_strings[18]
					term_strings[16] := term_strings[19]
					term_strings[17] := term_strings[19]
				end
				if ((term_strings[19]).item).to_integer_32 = 0 then
					term_strings[18] := term_strings[15]
					if ((term_strings[16]).item).to_integer_32 = 0 then
						term_strings[19] := term_strings[17]
					else
						term_strings[19] := term_strings[16]
					end
				end
				if ((term_strings[20]).item).to_integer_32 = 0 then
					term_strings[21] := term_strings[15]
					if ((term_strings[16]).item).to_integer_32 = 0 then
						term_strings[20] := term_strings[17]
					else
						term_strings[20] := term_strings[16]
					end
				end
				if ((term_strings[39]).item).to_integer_32 = 0 then
					term_strings[39] := globals_inst.empty_option
					term_strings[38] := globals_inst.empty_option
				elseif ((term_strings[38]).item).to_integer_32 = 0 then
					term_strings[39] := globals_inst.empty_option
					term_strings[38] := globals_inst.empty_option
				end
				if ((term_strings[43]).item).to_integer_32 = 0 then
					term_strings[43] := globals_inst.empty_option
					term_strings[42] := globals_inst.empty_option
				elseif ((term_strings[42]).item).to_integer_32 = 0 then
					term_strings[43] := globals_inst.empty_option
					term_strings[42] := globals_inst.empty_option
				end
				if ((term_strings[39]).item).to_integer_32 = 0 then
					if ((term_strings[43]).item).to_integer_32 = 0 then
						option_inst.free_one_termoption (term_strings[37])
					end
				end
				option_inst.p_wiv := (((term_strings[40]).item).to_integer_32 /= 0).to_integer
			end
			need_gather := 1
			globals_inst.t_colors := atoi (create {CE_POINTER [INTEGER_8]}.make_cast (term_strings[37]))
		end

	add_long_to_buf (a_val___0: NATURAL_32; a_dst: CE_POINTER [NATURAL_8])
		local
			l_i___0: INTEGER_32
			l_shift: INTEGER_32
		do
			l_i___0 := 1
			from
			until
				not (l_i___0 <= (Natural_32_bytes.to_natural_32).to_integer_32)
			loop
				l_shift := ({NATURAL_32} 8 * (Natural_32_bytes.to_natural_32 - l_i___0.to_natural_32)).to_integer_32
				a_dst[(l_i___0 - 1)] := ((((a_val___0).bit_shift_right (l_shift))).bit_and ({NATURAL_32} 255)).to_natural_8
				l_i___0 := l_i___0 + 1
			end
		end

	get_long_from_buf (a_buf___6: CE_POINTER [NATURAL_8]; a_val___0: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_len: INTEGER_32
			l_bytes___0: CE_ARRAY [NATURAL_8]
			l_i___0: INTEGER_32
			l_shift: INTEGER_32
		do
			create l_bytes___0.make (<<(Natural_32_bytes.to_natural_32).to_integer_32>>)

			a_val___0.item := (0).to_natural_32
			l_len := get_bytes_from_buf (a_buf___6, l_bytes___0, (Natural_32_bytes.to_natural_32).to_integer_32)
			if l_len /= -1 then
				l_i___0 := 0
				from
				until
					not (l_i___0 < (Natural_32_bytes.to_natural_32).to_integer_32)
				loop
					l_shift := ({NATURAL_32} 8 * ((Natural_32_bytes.to_natural_32 - {NATURAL_32} 1) - l_i___0.to_natural_32)).to_integer_32
					a_val___0.item := a_val___0.item + (((l_bytes___0[l_i___0]).to_natural_32).bit_shift_left (l_shift))
					l_i___0 := l_i___0 + 1
				end
			end
			Result := l_len
		end

	get_bytes_from_buf (a_buf___6: CE_POINTER [NATURAL_8]; a_bytes___0: CE_POINTER [NATURAL_8]; a_num_bytes: INTEGER_32): INTEGER_32
		local
			l_len: INTEGER_32
			l_i___0: INTEGER_32
			l_c: NATURAL_8
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			l_len := 0
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (l_i___0 < a_num_bytes))
			loop
				l_tmp := l_len
				l_len := l_len + 1
				l_c := a_buf___6[l_tmp]
				if l_c.to_integer_32 = 0 then
					Result := (-1)
					js.return
				end
				if not js.return_called then
					if l_c.to_integer_32 = 128 then
						if (a_buf___6[l_len]).to_integer_32 = 0 then
							Result := (-1)
							js.return
						elseif (a_buf___6[(l_len + 1)]).to_integer_32 = 0 then
							Result := (-1)
							js.return
						end
						if not js.return_called then
							l_tmp___0 := l_len
							l_len := l_len + 1
							if (a_buf___6[l_tmp___0]).to_integer_32 = 255 then
								l_c := (('%/0/').code).to_natural_8
							end
							l_len := l_len + 1
						end
					elseif l_c.to_integer_32 = 155 then
						if (a_buf___6[l_len]).to_integer_32 = 253 then
							if (a_buf___6[(l_len + 1)]).to_integer_32 = 81 then
								l_len := l_len + (2)
							end
						end
					end
				end
				if not js.return_called then
					a_bytes___0[l_i___0] := l_c
					l_i___0 := l_i___0 + 1
				end
			end
			if not js.return_called then
				Result := l_len
			end
		end

	check_shellsize
		do
			if globals_inst.Columns < 12 then
				globals_inst.Columns := 12
			end
			if globals_inst.Rows < (window_inst.min_rows).to_integer_32 then
				globals_inst.Rows := (window_inst.min_rows).to_integer_32
			end
		end

	win_new_shellsize
		do
			if old_Rows.to_integer_32 /= globals_inst.Rows then
				ui_inst.ui_new_shellsize
			elseif old_Columns.to_integer_32 /= globals_inst.Columns then
				ui_inst.ui_new_shellsize
			end
			if old_Rows.to_integer_32 /= globals_inst.Rows then
				if option_inst.p_window = (old_Rows - 1).to_integer_32 then
					option_inst.p_window := globals_inst.Rows - 1
				elseif old_Rows = 0 then
					option_inst.p_window := globals_inst.Rows - 1
				end
				old_Rows := globals_inst.Rows.to_integer_32
				window_inst.shell_new_rows
			end
			if old_Columns.to_integer_32 /= globals_inst.Columns then
				old_Columns := globals_inst.Columns.to_integer_32
				window_inst.shell_new_columns
			end
		end

	shell_resized
		do
			set_shellsize (0, 0, 0)
		end

	shell_resized_check
		local
			l_old_Rows___0: INTEGER_32
			l_old_Columns___0: INTEGER_32
		do
			l_old_Rows___0 := globals_inst.Rows.to_integer_32
			l_old_Columns___0 := globals_inst.Columns.to_integer_32
			ui_inst.ui_get_shellsize.do_nothing
			check_shellsize
			if l_old_Rows___0.to_integer_32 /= globals_inst.Rows then
				shell_resized
			elseif l_old_Columns___0.to_integer_32 /= globals_inst.Columns then
				shell_resized
			end
		end

	set_shellsize (a_width: INTEGER_32; a_height: INTEGER_32; a_mustset: INTEGER_32)
		local
			js: JUMP_STATE
		do
			if busy___2.to_boolean then
				js.return
			end
			if not js.return_called then
				if a_width < 0 then
					js.return
				elseif a_height < 0 then
					js.return
				end
			end
			if not js.return_called then
				if globals_inst.State = 513 then
					globals_inst.State := 1024
					js.return
				elseif globals_inst.State = 1024 then
					globals_inst.State := 1024
					js.return
				end
			end
			if not js.return_called then
				busy___2 := busy___2 + 1
				if a_mustset.to_boolean then
					globals_inst.Rows := a_height.to_integer_32
					globals_inst.Columns := a_width.to_integer_32
					check_shellsize
					ui_inst.ui_set_shellsize (a_mustset)
				elseif (ui_inst.ui_get_shellsize) = 0 then
					if a_height /= 0 then
						globals_inst.Rows := a_height.to_integer_32
						globals_inst.Columns := a_width.to_integer_32
						check_shellsize
						ui_inst.ui_set_shellsize (a_mustset)
					else
						check_shellsize
					end
				else
					check_shellsize
				end
				if globals_inst.State /= 768 then
					if globals_inst.State /= 1536 then
						if globals_inst.State /= 2048 then
							screen_inst.screenclear
						else
							screen_inst.screen_start
						end
					else
						screen_inst.screen_start
					end
				else
					screen_inst.screen_start
				end
				if globals_inst.starting /= 2 then
					buffer_inst.maketitle
					move_inst.changed_line_abv_curs
					move_inst.invalidate_botline
					if globals_inst.State = 768 then
						screen_inst.screenalloc (0)
						message_inst.repeat_message
					elseif globals_inst.State = 1536 then
						screen_inst.screenalloc (0)
						message_inst.repeat_message
					elseif globals_inst.State = 2048 then
						screen_inst.screenalloc (0)
						message_inst.repeat_message
					elseif globals_inst.exmode_active.to_boolean then
						screen_inst.screenalloc (0)
						message_inst.repeat_message
					else
						if (globals_inst.curwin.item.w_onebuf_opt.wo_scb).to_boolean then
							normal_inst.do_check_scrollbind (1)
						end
						if ((globals_inst.State).bit_and (8)).to_boolean then
							screen_inst.update_screen (40)
							ex_getln_inst.redrawcmdline
						else
							move_inst.update_topline
							if (popupmnu_inst.pum_visible).to_boolean then
								screen_inst.redraw_later (40)
								edit_inst.ins_compl_show_pum
							else
								screen_inst.update_screen (40)
							end
							if (screen_inst.redrawing).to_boolean then
								screen_inst.setcursor
							end
						end
					end
					cursor_on
				end
				out_flush
				busy___2 := busy___2 - 1
			end
		end

	settmode (a_tmode: INTEGER_32)
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (gui_inst.gui.in_use).to_boolean then
						js.return
					end
					if not (not js.return_called and then (globals_inst.full_screen.to_boolean)) then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if a_tmode = 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if globals_inst.cur_tmode = 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if not (gui_inst.gui.in_use).to_boolean then
							if not (gui_inst.gui.starting).to_boolean then
								if a_tmode /= 2 then
									if crv_status = 2 then
										getchar_inst.vpeekc_nomap.do_nothing
									end
								end
								check_for_codes_from_term
							end
						end
						if a_tmode /= 2 then
							os_unix_inst.mch_setmouse (0)
						end
						out_flush
						os_unix_inst.mch_settmode (a_tmode)
						globals_inst.cur_tmode := a_tmode
						if a_tmode = 2 then
							setmouse
						end
						out_flush
				when 6 then -- if done
						may_req_termresponse
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	starttermcap
		do
			if globals_inst.full_screen.to_boolean then
				if not globals_inst.termcap_active.to_boolean then
					out_str (term_strings[33])
					out_str (term_strings[31])
					out_flush
					globals_inst.termcap_active := 1
					screen_inst.screen_start
					if not (gui_inst.gui.in_use).to_boolean then
						if not (gui_inst.gui.starting).to_boolean then
							may_req_termresponse
							if crv_status /= 1 then
								check_for_codes_from_term
							end
						end
					end
				end
			end
		end

	stoptermcap
		do
			screen_inst.screen_stop_highlight
			screen_inst.reset_cterm_colors
			if globals_inst.termcap_active.to_boolean then
				if not (gui_inst.gui.in_use).to_boolean then
					if not (gui_inst.gui.starting).to_boolean then
						if crv_status = 2 then
							getchar_inst.vpeekc_nomap.do_nothing
						end
						check_for_codes_from_term
					end
				end
				out_str (term_strings[32])
				out_flush
				globals_inst.termcap_active := 0
				cursor_on
				out_str (term_strings[34])
				screen_inst.screen_start
				out_flush
			end
		end

	may_req_termresponse
		do
			if crv_status = 1 then
				if globals_inst.cur_tmode = 2 then
					if globals_inst.starting = 0 then
						if globals_inst.termcap_active.to_boolean then
							if option_inst.p_ek.to_boolean then
								if (isatty (1)).to_boolean then
									if (isatty (globals_inst.read_cmd_fd)).to_boolean then
										if ((term_strings[52]).item).to_integer_32 /= 0 then
											out_str (term_strings[52])
											crv_status := 2
											out_flush
											getchar_inst.vpeekc_nomap.do_nothing
										end
									end
								end
							end
						end
					end
				end
			end
		end

	swapping_screen: INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if globals_inst.full_screen.to_boolean then
				if ((term_strings[33]).item).to_integer_32 /= 0 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	setmouse
		local
			l_checkfor: INTEGER_32
			js: JUMP_STATE
		do
			misc2_inst.update_mouseshape (-1)
			if (gui_inst.gui.in_use).to_boolean then
				js.return
			end
			if not js.return_called then
				if (option_inst.p_mouse.item).to_integer_32 = 0 then
					js.return
				elseif has_mouse_termcode = 0 then
					js.return
				end
			end
			if not js.return_called and then (globals_inst.cur_tmode /= 2) then
				os_unix_inst.mch_setmouse (0)
				js.return
			end
			if not js.return_called then
				if globals_inst.VIsual_active.to_boolean then
					l_checkfor := ('v').code
				elseif globals_inst.State = 513 then
					l_checkfor := ('r').code
				elseif globals_inst.State = 768 then
					l_checkfor := ('r').code
				elseif globals_inst.State = 1024 then
					l_checkfor := ('r').code
				elseif ((globals_inst.State).bit_and (16)).to_boolean then
					l_checkfor := ('i').code
				elseif ((globals_inst.State).bit_and (8)).to_boolean then
					l_checkfor := ('c').code
				elseif globals_inst.State = 2048 then
					l_checkfor := (' ').code
				elseif globals_inst.State = 1536 then
					l_checkfor := (' ').code
				else
					l_checkfor := ('n').code
				end
				if (mouse_has (l_checkfor)).to_boolean then
					os_unix_inst.mch_setmouse (1)
				else
					os_unix_inst.mch_setmouse (0)
				end
			end
		end

	mouse_has (a_c: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0.ce_gets (option_inst.p_mouse)
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_p___0.item).to_boolean)) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						inspect (l_p___0.item).to_integer_32 -- switch 1 head
						when 97 then l_pos := -1 + 3
						when 104 then l_pos := -1 + 4
						else l_pos := -1 + 5
						end
				when 3 then -- switch 1, case 97
						if ((misc2_inst.vim_strchr (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("nvich")), a_c)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							Result := 1
							js.return
						end
						l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 104
						if a_c /= 114 then
							if (globals_inst.curbuf.item.b_help).to_boolean then
								Result := 1
								js.return
							end
						end
						l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, default:
						if a_c = (l_p___0.item).to_integer_32 then
							Result := 1
							js.return
						end
						l_pos := -1 + 6 -- switch 1; break
				when 6 then -- switch 1, done:
						if not js.return_called then
							l_p___0.ce_gets (l_p___0 + 1)
						end
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					if not js.return_called then
						Result := 0
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mouse_model_popup: INTEGER_32
		do
			Result := ((option_inst.p_mousem[0]).to_integer_32 = 112).to_integer
		end

	scroll_start
		do
			if ((term_strings[14]).item).to_integer_32 /= 0 then
				out_str (term_strings[14])
				out_str (term_strings[13])
				screen_inst.screen_start
			end
		end

	cursor_on
		do
			if cursor_is_off.to_boolean then
				out_str (term_strings[13])
				cursor_is_off := 0
			end
		end

	cursor_off
		do
			if globals_inst.full_screen.to_boolean then
				if not cursor_is_off.to_boolean then
					out_str (term_strings[12])
				end
				cursor_is_off := 1
			end
		end

	term_cursor_shape
		local
			js: JUMP_STATE
		do
			if not globals_inst.full_screen.to_boolean then
				js.return
			elseif ((term_strings[53]).item).to_integer_32 = 0 then
				js.return
			elseif ((term_strings[54]).item).to_integer_32 = 0 then
				js.return
			end
			if not js.return_called then
				if ((globals_inst.State).bit_and (16)).to_boolean then
					if showing_insert_mode /= 1 then
						out_str (term_strings[53])
					end
					showing_insert_mode := 1
				else
					if showing_insert_mode /= 0 then
						out_str (term_strings[54])
					end
					showing_insert_mode := 0
				end
			end
		end

	scroll_region_set (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_off___0: INTEGER_32)
		do
			out_str (create {CE_POINTER [NATURAL_8]}.make_cast ((tgoto (create {CE_POINTER [INTEGER_8]}.make_cast (term_strings[6]), (a_wp___0.item.w_winrow + a_wp___0.item.w_height) - 1, a_wp___0.item.w_winrow + a_off___0))))
			if ((term_strings[55]).item).to_integer_32 /= 0 then
				if (a_wp___0.item.w_width).to_integer_32 /= globals_inst.Columns then
					out_str (create {CE_POINTER [NATURAL_8]}.make_cast ((tgoto (create {CE_POINTER [INTEGER_8]}.make_cast (term_strings[55]), (a_wp___0.item.w_wincol + a_wp___0.item.w_width) - 1, a_wp___0.item.w_wincol))))
				end
			end
			screen_inst.screen_start
		end

	scroll_region_reset
		do
			out_str (create {CE_POINTER [NATURAL_8]}.make_cast ((tgoto (create {CE_POINTER [INTEGER_8]}.make_cast (term_strings[6]), globals_inst.Rows.to_integer_32 - 1, 0))))
			if ((term_strings[55]).item).to_integer_32 /= 0 then
				out_str (create {CE_POINTER [NATURAL_8]}.make_cast ((tgoto (create {CE_POINTER [INTEGER_8]}.make_cast (term_strings[55]), globals_inst.Columns.to_integer_32 - 1, 0))))
			end
			screen_inst.screen_start
		end

	clear_termcodes
		do
			from
			until
				not (tc_len > 0)
			loop
				tc_len := tc_len - 1
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((termcodes + tc_len).item.code))
			end
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (termcodes))
			termcodes.ce_gets (create {CE_POINTER [PD_TERMCODE]}.make_shared (default_pointer))
			tc_max_len := 0
			Current.BC := create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.empty_option)
			Current.UP := create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.empty_option)
			Current.PC := (('%/0/').code).to_integer_8
			Current.ospeed := (0).to_natural_32
			need_gather := 1
		end

	add_termcode (a_name___1: CE_POINTER [NATURAL_8]; a_string___0: CE_POINTER [NATURAL_8]; a_flags___0: INTEGER_32)
		local
			l_new_tc: CE_POINTER [PD_TERMCODE]
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			create l_new_tc.make
			create l_s.make

			if (a_string___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				del_termcode (a_name___1)
				js.return
			elseif (a_string___0.item).to_integer_32 = 0 then
				del_termcode (a_name___1)
				js.return
			end
			if not js.return_called then
				l_s.ce_gets (misc2_inst.vim_strsave (a_string___0))
				if (l_s.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					js.return
				end
			end
			if not js.return_called then
				if a_flags___0 /= 0 then
					if a_flags___0 /= 55 then
						if (term_7to8bit (a_string___0)) /= 0 then
							memmove (create {CE_POINTER [ANY]}.make_cast (l_s), create {CE_POINTER [ANY]}.make_cast ((l_s + 1)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_s + 1)))) + {NATURAL_32} 1).do_nothing
							l_s[0] := (term_7to8bit (a_string___0)).to_natural_8
						end
					end
				end
				l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s))).to_integer_32
				need_gather := 1
				if tc_len = tc_max_len then
					tc_max_len := tc_max_len + (20)
					l_new_tc.ce_gets (create {CE_POINTER [PD_TERMCODE]}.make_cast ((misc2_inst.alloc (tc_max_len.to_natural_32 * {PD_TERMCODE}.sizeof.to_natural_32))))
					if (l_new_tc.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						tc_max_len := tc_max_len - (20)
						js.return
					end
					if not js.return_called then
						l_i___0 := 0
						from
						until
							not (l_i___0 < tc_len)
						loop
							l_new_tc[l_i___0] := termcodes[l_i___0]
							l_i___0 := l_i___0 + 1
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (termcodes))
						termcodes.ce_gets (l_new_tc)
					end
				end
			end
			if not js.return_called then
				l_i___0 := 0
				from
				until
					not (not js.loop_left and then (l_i___0 < tc_len))
				loop
					js.reset
					if ((termcodes + l_i___0).item.name[0]).to_integer_32 < (a_name___1[0]).to_integer_32 then
						js.continue
					end
					if not js.loop_jumped and then (((termcodes + l_i___0).item.name[0]).to_integer_32 = (a_name___1[0]).to_integer_32) then
						if ((termcodes + l_i___0).item.name[1]).to_integer_32 < (a_name___1[1]).to_integer_32 then
							js.continue
						end
						if not js.loop_jumped and then (((termcodes + l_i___0).item.name[1]).to_integer_32 = (a_name___1[1]).to_integer_32) then
							if a_flags___0 = 55 then
								l_j := termcode_star ((termcodes + l_i___0).item.code, (termcodes + l_i___0).item.len)
								if l_j > 0 then
									if l_len = (termcodes + l_i___0).item.len - l_j then
										if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_s), create {CE_POINTER [INTEGER_8]}.make_cast ((termcodes + l_i___0).item.code), (l_len - 1).to_natural_32)) = 0 then
											if (l_s[(l_len - 1)]).to_integer_32 = ((termcodes + l_i___0).item.code[((termcodes + l_i___0).item.len - 1)]).to_integer_32 then
												misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_s))
												js.return
											end
										end
									end
								else
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((termcodes + l_i___0).item.code))
									tc_len := tc_len - 1
									js.break
								end
							else
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((termcodes + l_i___0).item.code))
								tc_len := tc_len - 1
								js.break
							end
						end
					end
					if not js.loop_jumped then
						l_j := tc_len
						from
						until
							not (l_j > l_i___0)
						loop
							termcodes[l_j] := termcodes[(l_j - 1)]
							l_j := l_j - 1
						end
						js.break
					end
					if not js.loop_left then
						l_i___0 := l_i___0 + 1
					end
				end
				js.reset
			end
			if not js.return_called then
				(termcodes + l_i___0).item.name[0] := a_name___1[0];
				(termcodes + l_i___0).item.name[1] := a_name___1[1];
				(termcodes + l_i___0).item.code := l_s;
				(termcodes + l_i___0).item.len := l_len;
				(termcodes + l_i___0).item.modlen := 0
				l_j := termcode_star (l_s, l_len)
				if l_j > 0 then
					(termcodes + l_i___0).item.modlen := (l_len - 1) - l_j
				end
				tc_len := tc_len + 1
			end
		end

	termcode_star (a_code: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): INTEGER_32
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_len >= 3) then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if (a_code[(a_len - 2)]).to_integer_32 /= 42 then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if a_len >= 5 then
							if (a_code[(a_len - 3)]).to_integer_32 = 59 then
								Result := 2
								js.return
							end
						end
						if js.return_called then
							l_pos := -1 + 7 -- skip if block
						end
				when 3 then -- if:
						if not (a_len >= 4) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (a_code[(a_len - 3)]).to_integer_32 = 79 then
							Result := 1
							js.return
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if (a_code[(a_len - 3)]).to_integer_32 = 207 then
							Result := 1
							js.return
						end
				when 7 then -- if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	find_termcode (a_name___1: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (l_i___0 < tc_len))
			loop
				if ((termcodes + l_i___0).item.name[0]).to_integer_32 = (a_name___1[0]).to_integer_32 then
					if ((termcodes + l_i___0).item.name[1]).to_integer_32 = (a_name___1[1]).to_integer_32 then
						Result := ((termcodes + l_i___0).item.code)
						js.return
					end
				end
				if not js.return_called then
					l_i___0 := l_i___0 + 1
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
			end
		end

	get_termcode (a_i___0: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			js: JUMP_STATE
		do
			if a_i___0 >= tc_len then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				Result := ((termcodes + a_i___0).item.name + 0)
			end
		end

	del_termcode (a_name___1: CE_POINTER [NATURAL_8])
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			if (termcodes.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				js.return
			end
			if not js.return_called then
				need_gather := 1
				l_i___0 := 0
				from
				until
					not (not js.loop_left and then (l_i___0 < tc_len))
				loop
					if ((termcodes + l_i___0).item.name[0]).to_integer_32 = (a_name___1[0]).to_integer_32 then
						if ((termcodes + l_i___0).item.name[1]).to_integer_32 = (a_name___1[1]).to_integer_32 then
							del_termcode_idx (l_i___0)
							js.return
						end
					end
					if not js.return_called then
						l_i___0 := l_i___0 + 1
					end
				end
			end
			if not js.return_called then
			end
		end

	del_termcode_idx (a_idx: INTEGER_32)
		local
			l_i___0: INTEGER_32
		do
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((termcodes + a_idx).item.code))
			tc_len := tc_len - 1
			l_i___0 := a_idx
			from
			until
				not (l_i___0 < tc_len)
			loop
				termcodes[l_i___0] := termcodes[(l_i___0 + 1)]
				l_i___0 := l_i___0 + 1
			end
		end

	switch_to_8bit
		local
			l_i___0: INTEGER_32
			l_c: INTEGER_32
		do
			if not (term_is_8bit (term_strings[0])).to_boolean then
				l_i___0 := 0
				from
				until
					not (l_i___0 < tc_len)
				loop
					l_c := term_7to8bit ((termcodes + l_i___0).item.code)
					if l_c /= 0 then
						memmove (create {CE_POINTER [ANY]}.make_cast (((termcodes + l_i___0).item.code + 1)), create {CE_POINTER [ANY]}.make_cast (((termcodes + l_i___0).item.code + 2)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (((termcodes + l_i___0).item.code + 2)))) + {NATURAL_32} 1).do_nothing;
						(termcodes + l_i___0).item.code[0] := l_c.to_natural_8
					end
					l_i___0 := l_i___0 + 1
				end
				need_gather := 1
			end
			detected_8bit := 1
		end

	set_mouse_topline (a_wp___0: CE_POINTER [PD_WINDOW_S])
		do
			orig_topline := a_wp___0.item.w_topline
			orig_topfill := a_wp___0.item.w_topfill
		end

	check_termcode (a_max_offset: INTEGER_32; a_buf___6: CE_POINTER [NATURAL_8]; a_buflen: INTEGER_32): INTEGER_32
		local
			l_tp: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_slen: INTEGER_32
			l_modslen: INTEGER_32
			l_len: INTEGER_32
			l_offset: INTEGER_32
			l_key_name: CE_ARRAY [NATURAL_8]
			l_modifiers: INTEGER_32
			l_key: INTEGER_32
			l_new_slen: INTEGER_32
			l_extra: INTEGER_32
			l_string___0: CE_ARRAY [NATURAL_8]
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_idx: INTEGER_32
			l_bytes___0: CE_ARRAY [NATURAL_8]
			l_num_bytes: INTEGER_32
			l_mouse_code___0: INTEGER_32
			l_is_click: INTEGER_32
			l_is_drag: INTEGER_32
			l_wheel_code: INTEGER_32
			l_current_button: INTEGER_32
			l_mouse_time: SD_TIMEVAL
			l_timediff: INTEGER_32
			l_cpo_koffset: INTEGER_32
			l_tmp___1: INTEGER_32
			l_n: INTEGER_32
			l_tmp___5: INTEGER_32
			l_val___0: NATURAL_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_tmp___19: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_tp.make
			create l_p___0.make
			create l_key_name.make (<<2>>)
			create l_string___0.make (<<7>>)
			create l_bytes___0.make (<<6>>)
			create l_mouse_time.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_slen := 0
					l_idx := 0
					l_mouse_code___0 := 0
					l_wheel_code := 0
					l_cpo_koffset := (((misc2_inst.vim_strchr (option_inst.p_cpo, ('K').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
					if need_gather.to_boolean then
						gather_termleader
					end
					l_offset := 0
				when 1 then -- loop condition:
					if not (not js.loop_left and then (l_offset < a_max_offset)) then
						l_pos := -1 + 129 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						if (a_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if l_offset >= globals_inst.typebuf.tb_len then
								js.break
							end
							if not js.loop_jumped then
								l_tp.ce_gets ((globals_inst.typebuf.tb_buf + globals_inst.typebuf.tb_off) + l_offset)
								l_len := globals_inst.typebuf.tb_len - l_offset
							end
						else
							if l_offset >= a_buflen then
								js.break
							end
							if not js.loop_jumped then
								l_tp.ce_gets (a_buf___6 + l_offset)
								l_len := a_buflen - l_offset
							end
						end
						if not js.loop_jumped and then ((l_tp.item).to_integer_32 = 128) then
							l_offset := l_offset + (2)
							js.continue
						end
						if not js.loop_jumped then
							l_i___0 := (l_tp.item).to_integer_32
							l_p___0.ce_gets (termleader)
							from
							until
								js.loop_left
							loop
								js.reset
								if (l_p___0.item).to_boolean then
									if (l_p___0.item).to_integer_32 = l_i___0 then
										js.break
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_p___0.ce_gets (l_p___0 + 1)
								end
							end
							js.reset
							if (l_p___0.item).to_integer_32 = 0 then
								js.continue
							end
						end
						if not js.loop_jumped and then ((l_tp.item).to_integer_32 = 27) then
							if not option_inst.p_ek.to_boolean then
								if ((globals_inst.State).bit_and (16)).to_boolean then
									js.continue
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 128 -- skip if block
						end
				when 3 then -- if:
						l_key_name[0] := (('%/0/').code).to_natural_8
						l_key_name[1] := (('%/0/').code).to_natural_8
						l_modifiers := 0
						if not ((gui_inst.gui.in_use).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (l_tp.item).to_integer_32 = 155 then
							if l_len < 3 then
								Result := (-1)
								js.return
							end
							if not js.return_called then
								l_slen := 3
								l_key_name[0] := l_tp[1]
								l_key_name[1] := l_tp[2]
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 6 then -- else:
						l_idx := 0
				when 7 then -- loop condition:
						if not (not js.loop_left and then (l_idx < tc_len)) then
							l_pos := -1 + 21 -- skip loop
						end
				when 8 then -- loop body:
						js.reset
						l_slen := (termcodes + l_idx).item.len
						if l_cpo_koffset.to_boolean then
							if l_offset.to_boolean then
								if l_len < l_slen then
									js.continue
								end
							end
						end
						if not js.loop_jumped then
							if l_slen > l_len then
								l_tmp___1 := l_len
							else
								l_tmp___1 := l_slen
							end
							if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast ((termcodes + l_idx).item.code), create {CE_POINTER [INTEGER_8]}.make_cast (l_tp), l_tmp___1.to_natural_32)) = 0 then
								if l_len < l_slen then
									Result := (-1)
									js.return
								end
								if not js.return_called then
									if ((termcodes + l_idx).item.name[0]).to_integer_32 = 75 then
										if ((termcodes + l_idx).item.name[1]).to_integer_32 >= 48 then
											if ((termcodes + l_idx).item.name[1]).to_integer_32 <= 57 then
												l_j := l_idx + 1
												from
												until
													not (not js.loop_left and then (l_j < tc_len))
												loop
													js.reset
													if (termcodes + l_j).item.len = l_slen then
														if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast ((termcodes + l_idx).item.code), create {CE_POINTER [INTEGER_8]}.make_cast ((termcodes + l_j).item.code), l_slen.to_natural_32)) = 0 then
															l_idx := l_j
															js.break
														end
													end
													if not js.loop_jumped then
														l_j := l_j + 1
													end
												end
												js.reset
											end
										end
									end
									l_key_name[0] := (termcodes + l_idx).item.name[0]
									l_key_name[1] := (termcodes + l_idx).item.name[1]
									js.break
								end
							end
						end
						if not (not js.loop_jumped and then ((termcodes + l_idx).item.modlen > 0)) then
							l_pos := -1 + 20 -- skip if block
						end
				when 9 then -- if:
						l_modslen := (termcodes + l_idx).item.modlen
						if l_cpo_koffset.to_boolean then
							if l_offset.to_boolean then
								if l_len < l_modslen then
									js.continue
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 20 -- skip if block
						end
				when 10 then -- if:
						if l_modslen > l_len then
							l_tmp___5 := l_len
						else
							l_tmp___5 := l_modslen
						end
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast ((termcodes + l_idx).item.code), create {CE_POINTER [INTEGER_8]}.make_cast (l_tp), l_tmp___5.to_natural_32)) /= 0 then
							l_pos := -1 + 20 -- skip if block
						end
				when 11 then -- if:
						if l_len <= l_modslen then
							Result := (-1)
							js.return
						end
						if js.return_called then
							l_pos := -1 + 20 -- skip if block
						end
				when 12 then -- if:
						if (l_tp[l_modslen]).to_integer_32 /= ((termcodes + l_idx).item.code[(l_slen - 1)]).to_integer_32 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_slen := l_modslen + 1
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 15 then -- else:
						if (l_tp[l_modslen]).to_integer_32 = 59 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if l_modslen = l_slen - 3 then
							js.continue
						else
							l_pos := -1 + 18 -- goto _L
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | _L:
						l_j := l_slen - 2
						from
						until
							js.loop_left
						loop
							js.reset
							if l_j < l_len then
								if not ((((ctype_b_loc).item[(l_tp[l_j]).to_integer_32]).to_integer_32).bit_and (2048)).to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_j := l_j + 1
							end
						end
						js.reset
						l_j := l_j + 1
						if l_len < l_j then
							Result := (-1)
							js.return
						end
						if not js.return_called then
							if (l_tp[(l_j - 1)]).to_integer_32 /= ((termcodes + l_idx).item.code[(l_slen - 1)]).to_integer_32 then
								js.continue
							end
							if not js.loop_jumped then
								l_n := (atoi (((create {CE_POINTER [INTEGER_8]}.make_cast (l_tp) + l_slen) - 2))) - 1
								if ((l_n).bit_and (1)).to_boolean then
									l_modifiers := (l_modifiers).bit_or ((2))
								end
								if ((l_n).bit_and (2)).to_boolean then
									l_modifiers := (l_modifiers).bit_or ((8))
								end
								if ((l_n).bit_and (4)).to_boolean then
									l_modifiers := (l_modifiers).bit_or ((4))
								end
								if ((l_n).bit_and (8)).to_boolean then
									l_modifiers := (l_modifiers).bit_or ((16))
								end
								l_slen := l_j
							end
						end
				when 19 then -- if done
						if not js.loop_jumped then
							l_key_name[0] := (termcodes + l_idx).item.name[0]
							l_key_name[1] := (termcodes + l_idx).item.name[1]
							js.break
						end
				when 20 then -- if done | if done | if done | if done
						if not js.loop_left then
							l_idx := l_idx + 1
						end
						l_pos := -1 + 7 -- back to loop condition
				when 21 then -- loop done
						js.reset
				when 22 then -- if done
						if not (not js.return_called and then ((l_key_name[0]).to_integer_32 = 0)) then
							l_pos := -1 + 59 -- skip if block
						end
				when 23 then -- if:
						if ((term_strings[52]).item).to_integer_32 = 0 then
							l_pos := -1 + 45 -- skip if block
						end
				when 24 then -- if:
						if (l_tp[0]).to_integer_32 /= 27 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						if (l_tp[1]).to_integer_32 = 91 then
							if l_len >= 3 then
								l_pos := -1 + 29 -- goto _L___8
							else
								l_pos := -1 + 27 -- goto _L___10
							end
						else
							l_pos := -1 + 27 -- goto _L___10
						end
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 27 then -- else: | _L___10:
						if (l_tp[0]).to_integer_32 /= 155 then
							l_pos := -1 + 43 -- skip if block
						end
				when 28 then -- if:
						if not (l_len >= 2) then
							l_pos := -1 + 41 -- skip if block
						end
				when 29 then -- if: | _L___8:
						l_j := 0
						l_extra := 0
						l_i___0 := 2 + ((l_tp[0]).to_integer_32 /= 155).to_integer
				when 30 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 39 -- skip loop
						end
				when 31 then -- loop body:
						js.reset
						if not (l_i___0 < l_len) then
							l_pos := -1 + 37 -- skip if block
						end
				when 32 then -- if:
						if not ((l_tp[l_i___0]).to_integer_32 >= 123) then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						if (l_tp[l_i___0]).to_integer_32 <= 126 then
							js.break
						else
							l_pos := -1 + 35 -- goto _L___0
						end
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 35 then -- else: | _L___0:
						if (l_tp[l_i___0]).to_integer_32 < 127 then
							if ((((ctype_b_loc).item[(l_tp[l_i___0]).to_integer_32]).to_integer_32).bit_and (1024)).to_boolean then
								js.break
							end
						end
				when 36 then -- if done | if block done, skip else block:
						l_pos := -1 + 38
				when 37 then -- else:
						js.break
				when 38 then
						if not js.loop_jumped then
							if (l_tp[l_i___0]).to_integer_32 = 59 then
								l_j := l_j + 1
								if l_j = 1 then
									l_extra := atoi (((create {CE_POINTER [INTEGER_8]}.make_cast (l_tp) + l_i___0) + 1))
								end
							end
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 30 -- back to loop condition
				when 39 then -- loop done
						js.reset
						if l_i___0 = l_len then
							Result := (-1)
							js.return
						end
						if not js.return_called and then (l_i___0 > 2 + ((l_tp[0]).to_integer_32 /= 155).to_integer) then
							if (l_tp[l_i___0]).to_integer_32 = 99 then
								crv_status := 3
								if (l_tp[0]).to_integer_32 = 155 then
									switch_to_8bit
								end
								if l_extra > 20000 then
									l_extra := 0
								end
								if (l_tp[(1 + ((l_tp[0]).to_integer_32 /= 155).to_integer)]).to_integer_32 = 62 then
									if l_j = 2 then
										if l_extra >= 95 then
											option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ttym")), 0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("xterm2")), 0)
										end
										if l_extra >= 141 then
											check_for_codes := 1
											need_gather := 1
											req_codes_from_term
										end
									end
								end
								eval_inst.set_vim_var_string (10, l_tp, l_i___0 + 1)
								fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_TERMRESPONSE, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf).do_nothing
								l_key_name[0] := (253).to_natural_8
								l_key_name[1] := (53).to_natural_8
								l_slen := l_i___0 + 1
							end
						end
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else:
						l_pos := -1 + 45 -- goto _L___7
				when 42 then -- if done | if block done, skip else block:
						l_pos := -1 + 44
				when 43 then -- else:
						l_pos := -1 + 45 -- goto _L___7
				when 44 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 59
				when 45 then -- else: | _L___7:
						if not (check_for_codes.to_boolean) then
							l_pos := -1 + 59 -- skip if block
						end
				when 46 then -- if:
						if (l_tp[0]).to_integer_32 /= 27 then
							l_pos := -1 + 49 -- skip if block
						end
				when 47 then -- if:
						if (l_tp[1]).to_integer_32 = 80 then
							if l_len >= 2 then
								l_pos := -1 + 50 -- goto _L___4
							else
								l_pos := -1 + 49 -- goto _L___6
							end
						else
							l_pos := -1 + 49 -- goto _L___6
						end
				when 48 then -- if block done, skip else block:
						l_pos := -1 + 59
				when 49 then -- else: | _L___6:
						if (l_tp[0]).to_integer_32 /= 144 then
							l_pos := -1 + 59 -- skip if block
						end
				when 50 then -- if: | _L___4:
						l_j := 1 + ((l_tp[0]).to_integer_32 /= 144).to_integer
						l_i___0 := l_j
				when 51 then -- loop condition:
						if not (not js.loop_left and then (l_i___0 < l_len)) then
							l_pos := -1 + 58 -- skip loop
						end
				when 52 then -- loop body:
						js.reset
						if (l_tp[l_i___0]).to_integer_32 /= 27 then
							l_pos := -1 + 55 -- skip if block
						end
				when 53 then -- if:
						if (l_tp[(l_i___0 + 1)]).to_integer_32 = 92 then
							if l_i___0 + 1 < l_len then
								l_pos := -1 + 56 -- goto _L___1
							else
								l_pos := -1 + 55 -- goto _L___3
							end
						else
							l_pos := -1 + 55 -- goto _L___3
						end
				when 54 then -- if block done, skip else block:
						l_pos := -1 + 57
				when 55 then -- else: | _L___3:
						if (l_tp[l_i___0]).to_integer_32 /= 156 then
							l_pos := -1 + 57 -- skip if block
						end
				when 56 then -- if: | _L___1:
						if l_i___0 - l_j >= 3 then
							if (l_tp[(l_j + 1)]).to_integer_32 = 43 then
								if (l_tp[(l_j + 2)]).to_integer_32 = 114 then
									got_code_from_term (l_tp + l_j, l_i___0)
								end
							end
						end
						l_key_name[0] := (253).to_natural_8
						l_key_name[1] := (53).to_natural_8
						l_slen := (l_i___0 + 1) + ((l_tp[l_i___0]).to_integer_32 = 27).to_integer
						js.break
				when 57 then -- if done
						if not js.loop_jumped then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 51 -- back to loop condition
				when 58 then -- loop done
						js.reset
						if l_i___0 = l_len then
							Result := (-1)
							js.return
						end
				when 59 then -- if done | if done | if done | if done
						if js.return_called then
							l_pos := -1 + 128 -- skip if block
						end
				when 60 then -- if:
						if (l_key_name[0]).to_integer_32 = 0 then
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 128 -- skip if block
						end
				when 61 then -- if:
						if not ((gui_inst.gui.in_use).to_boolean) then
							l_pos := -1 + 85 -- skip if block
						end
				when 62 then -- if:
						if (l_key_name[0]).to_integer_32 /= 253 then
							l_pos := -1 + 83 -- skip if block
						end
				when 63 then -- if:
						if (l_key_name[1]).to_integer_32 /= 89 then
							l_pos := -1 + 66 -- skip if block
						end
				when 64 then -- if:
						l_pos := -1 + 79 -- goto _L___17
				when 65 then -- if block done, skip else block:
						l_pos := -1 + 82
				when 66 then -- else:
						if (l_key_name[1]).to_integer_32 /= 92 then
							l_pos := -1 + 69 -- skip if block
						end
				when 67 then -- if:
						l_pos := -1 + 79 -- goto _L___17
				when 68 then -- if block done, skip else block:
						l_pos := -1 + 82
				when 69 then -- else:
						if (l_key_name[1]).to_integer_32 /= 77 then
							l_pos := -1 + 72 -- skip if block
						end
				when 70 then -- if:
						l_pos := -1 + 79 -- goto _L___17
				when 71 then -- if block done, skip else block:
						l_pos := -1 + 82
				when 72 then -- else:
						if (l_key_name[1]).to_integer_32 /= 78 then
							l_pos := -1 + 75 -- skip if block
						end
				when 73 then -- if:
						l_pos := -1 + 79 -- goto _L___17
				when 74 then -- if block done, skip else block:
						l_pos := -1 + 82
				when 75 then -- else:
						if (l_key_name[1]).to_integer_32 /= 75 then
							l_pos := -1 + 78 -- skip if block
						end
				when 76 then -- if:
						l_pos := -1 + 79 -- goto _L___17
				when 77 then -- if block done, skip else block:
						l_pos := -1 + 82
				when 78 then -- else:
						if (l_key_name[1]).to_integer_32 /= 76 then
							l_pos := -1 + 81 -- skip if block
						end
				when 79 then -- if: | _L___17:
						l_num_bytes := get_bytes_from_buf (l_tp + l_slen, l_bytes___0, 4)
						if l_num_bytes = -1 then
							Result := (-1)
							js.return
						end
						if not js.return_called then
							globals_inst.mouse_col := ((128 * (((l_bytes___0[0]).to_integer_32 - 32) - 1) + (l_bytes___0[1]).to_integer_32) - 32) - 1
							globals_inst.mouse_row := ((128 * (((l_bytes___0[2]).to_integer_32 - 32) - 1) + (l_bytes___0[3]).to_integer_32) - 32) - 1
							l_slen := l_slen + l_num_bytes
						end
				when 80 then -- if block done, skip else block:
						l_pos := -1 + 82
				when 81 then -- else:
						l_pos := -1 + 85 -- goto _L___18
				when 82 then -- if done | if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 84
				when 83 then -- else:
						l_pos := -1 + 85 -- goto _L___18
				when 84 then -- if done | if block done, skip else block:
						l_pos := -1 + 127
				when 85 then -- else: | _L___18:
						if (l_key_name[0]).to_integer_32 /= 251 then
							l_pos := -1 + 126 -- skip if block
						end
				when 86 then -- if:
						l_is_drag := 0
						l_is_click := l_is_drag
						if (l_key_name[0]).to_integer_32 /= 251 then
							l_pos := -1 + 95 -- skip if block
						end
				when 87 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							if (gui_inst.gui.in_use).to_boolean then
								l_num_bytes := get_bytes_from_buf (l_tp + l_slen, l_bytes___0, 5)
								if l_num_bytes = -1 then
									Result := (-1)
									js.return
								end
								if not js.return_called then
									l_mouse_code___0 := (l_bytes___0[0]).to_integer_32
									globals_inst.mouse_col := ((128 * (((l_bytes___0[1]).to_integer_32 - 32) - 1) + (l_bytes___0[2]).to_integer_32) - 32) - 1
									globals_inst.mouse_row := ((128 * (((l_bytes___0[3]).to_integer_32 - 32) - 1) + (l_bytes___0[4]).to_integer_32) - 32) - 1
								end
							else
								l_num_bytes := get_bytes_from_buf (l_tp + l_slen, l_bytes___0, 3)
								if l_num_bytes = -1 then
									Result := (-1)
									js.return
								end
								if not js.return_called then
									l_mouse_code___0 := (l_bytes___0[0]).to_integer_32
									globals_inst.mouse_col := ((l_bytes___0[1]).to_integer_32 - 32) - 1
									globals_inst.mouse_row := ((l_bytes___0[2]).to_integer_32 - 32) - 1
								end
							end
							if not js.return_called then
								l_slen := l_slen + l_num_bytes
								if (gui_inst.gui.in_use).to_boolean then
									l_j := 3
								else
									l_j := (termcodes + l_idx).item.len
								end
								if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_tp), create {CE_POINTER [INTEGER_8]}.make_cast ((l_tp + l_slen)), l_j.to_natural_32)) = 0 then
									if (l_tp[(l_slen + l_j)]).to_integer_32 = l_mouse_code___0 then
										if (l_tp[((l_slen + l_j) + 1)]).to_integer_32 /= 0 then
											if (l_tp[((l_slen + l_j) + 2)]).to_integer_32 /= 0 then
												if not (gui_inst.gui.in_use).to_boolean then
													l_slen := l_slen + l_j
												elseif (l_tp[((l_slen + l_j) + 3)]).to_integer_32 /= 0 then
													if (l_tp[((l_slen + l_j) + 4)]).to_integer_32 /= 0 then
														l_slen := l_slen + l_j
													else
														js.break
													end
												else
													js.break
												end
											else
												js.break
											end
										else
											js.break
										end
									else
										js.break
									end
								else
									js.break
								end
							end
						end
						js.reset
						if js.return_called then
							l_pos := -1 + 95 -- skip if block
						end
				when 88 then -- if:
						if not (l_mouse_code___0 >= 96) then
							l_pos := -1 + 91 -- skip if block
						end
				when 89 then -- if:
						if not (gui_inst.gui.in_use).to_boolean then
							l_wheel_code := l_mouse_code___0
						else
							l_pos := -1 + 91 -- goto _L___13
						end
				when 90 then -- if block done, skip else block:
						l_pos := -1 + 95
				when 91 then -- else: | _L___13:
						if held_button /= 3 then
							l_pos := -1 + 94 -- skip if block
						end
				when 92 then -- if:
						if not (gui_inst.gui.in_use).to_boolean then
							if l_mouse_code___0 = 35 then
								l_wheel_code := (l_mouse_code___0 - 35) + 96
							elseif l_mouse_code___0 = 36 then
								l_wheel_code := (l_mouse_code___0 - 35) + 96
							else
								l_pos := -1 + 94 -- goto _L___12
							end
						else
							l_pos := -1 + 94 -- goto _L___12
						end
				when 93 then -- if block done, skip else block:
						l_pos := -1 + 95
				when 94 then -- else: | _L___12:
						if (os_unix_inst.use_xterm_mouse) > 1 then
							if ((l_mouse_code___0).bit_and (64)).to_boolean then
								l_mouse_code___0 := (l_mouse_code___0).bit_or ((67))
							end
						elseif not ((((l_mouse_code___0).bit_and (67))).bit_and (-4)).to_boolean then
							if ((l_mouse_code___0).bit_and (3)) = 3 then
								os_unix_inst.stop_xterm_trace
							else
								os_unix_inst.start_xterm_trace (l_mouse_code___0)
							end
						end
				when 95 then -- if done | if done | if done
						if js.return_called then
							l_pos := -1 + 125 -- skip if block
						end
				when 96 then -- if:
						l_current_button := (l_mouse_code___0).bit_and (3)
						if l_current_button /= 3 then
							l_pos := -1 + 99 -- skip if block
						end
				when 97 then -- if:
						if l_wheel_code = 0 then
							if ((l_mouse_code___0).bit_and (67)) = 67 then
								l_is_drag := 1
							end
							l_current_button := held_button
						else
							l_pos := -1 + 99 -- goto _L___15
						end
				when 98 then -- if block done, skip else block:
						l_pos := -1 + 124
				when 99 then -- else: | _L___15:
						if l_wheel_code /= 0 then
							l_pos := -1 + 124 -- skip if block
						end
				when 100 then -- if:
						if (gui_inst.gui.in_use).to_boolean then
							l_pos := -1 + 122 -- skip if block
						end
				when 101 then -- if:
						gettimeofday ((l_mouse_time.address), create {CE_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
						l_timediff := (l_mouse_time.tv_usec - orig_mouse_time.tv_usec) // 1000
						if l_timediff < 0 then
							orig_mouse_time.tv_sec := (orig_mouse_time.tv_sec) - 1
						end
						l_timediff := l_timediff + ((l_mouse_time.tv_sec - orig_mouse_time.tv_sec) * 1000)
						orig_mouse_time.ce_gets (l_mouse_time)
						if l_mouse_code___0 /= orig_mouse_code then
							l_pos := -1 + 119 -- skip if block
						end
				when 102 then -- if:
						if not (l_timediff < option_inst.p_mouset) then
							l_pos := -1 + 117 -- skip if block
						end
				when 103 then -- if:
						if orig_num_clicks = 4 then
							l_pos := -1 + 115 -- skip if block
						end
				when 104 then -- if:
						if orig_mouse_col /= globals_inst.mouse_col then
							l_pos := -1 + 113 -- skip if block
						end
				when 105 then -- if:
						if orig_mouse_row /= globals_inst.mouse_row then
							l_pos := -1 + 111 -- skip if block
						end
				when 106 then -- if:
						if orig_topline /= globals_inst.curwin.item.w_topline then
							l_pos := -1 + 109 -- skip if block
						end
				when 107 then -- if:
						if orig_topfill = globals_inst.curwin.item.w_topfill then
							orig_num_clicks := orig_num_clicks + 1
						else
							l_pos := -1 + 109 -- goto _L___14
						end
				when 108 then -- if block done, skip else block:
						l_pos := -1 + 110
				when 109 then -- else: | _L___14:
						if globals_inst.mouse_row = 0 then
							if globals_inst.firstwin.item.w_winrow > 0 then
								orig_num_clicks := orig_num_clicks + 1
							else
								orig_num_clicks := 1
							end
						else
							orig_num_clicks := 1
						end
				when 110 then -- if done | if block done, skip else block:
						l_pos := -1 + 112
				when 111 then -- else:
						orig_num_clicks := 1
				when 112 then -- if done | if block done, skip else block:
						l_pos := -1 + 114
				when 113 then -- else:
						orig_num_clicks := 1
				when 114 then -- if done | if block done, skip else block:
						l_pos := -1 + 116
				when 115 then -- else:
						orig_num_clicks := 1
				when 116 then -- if done | if block done, skip else block:
						l_pos := -1 + 118
				when 117 then -- else:
						orig_num_clicks := 1
				when 118 then -- if done | if block done, skip else block:
						l_pos := -1 + 120
				when 119 then -- else:
						orig_num_clicks := 1
				when 120 then
						orig_mouse_col := globals_inst.mouse_col
						orig_mouse_row := globals_inst.mouse_row
						orig_topline := globals_inst.curwin.item.w_topline
						orig_topfill := globals_inst.curwin.item.w_topfill
				when 121 then -- if block done, skip else block:
						l_pos := -1 + 123
				when 122 then -- else:
						orig_num_clicks := (((((l_mouse_code___0).bit_and (192)).to_natural_32).bit_shift_right (6)) + {NATURAL_32} 1).to_integer_32
				when 123 then -- if done
						l_is_click := 1
						orig_mouse_code := l_mouse_code___0
				when 124 then -- if done
						if not l_is_drag.to_boolean then
							held_button := (l_mouse_code___0).bit_and (3)
						end
						if ((orig_mouse_code).bit_and (4)).to_boolean then
							l_modifiers := (l_modifiers).bit_or ((2))
						end
						if ((orig_mouse_code).bit_and (16)).to_boolean then
							l_modifiers := (l_modifiers).bit_or ((4))
						end
						if ((orig_mouse_code).bit_and (8)).to_boolean then
							l_modifiers := (l_modifiers).bit_or ((8))
						end
						if orig_num_clicks = 2 then
							l_modifiers := (l_modifiers).bit_or ((32))
						elseif orig_num_clicks = 3 then
							l_modifiers := (l_modifiers).bit_or ((64))
						elseif orig_num_clicks = 4 then
							l_modifiers := (l_modifiers).bit_or ((96))
						end
						l_key_name[0] := (253).to_natural_8
						if l_wheel_code /= 0 then
							if ((l_wheel_code).bit_and (16)).to_boolean then
								l_modifiers := (l_modifiers).bit_or ((4))
							end
							if ((l_wheel_code).bit_and (8)).to_boolean then
								l_modifiers := (l_modifiers).bit_or ((8))
							end
							if ((l_wheel_code).bit_and (1)).to_boolean then
								l_key_name[1] := (76).to_natural_8
							else
								l_key_name[1] := (75).to_natural_8
							end
						else
							l_key_name[1] := (misc2_inst.get_pseudo_mouse_code (l_current_button, l_is_click, l_is_drag)).to_natural_8
						end
				when 125 then -- if done | if block done, skip else block:
						l_pos := -1 + 127
				when 126 then -- else:
						if (l_key_name[0]).to_integer_32 = 250 then
							l_num_bytes := get_long_from_buf (l_tp + l_slen, create {CE_POINTER [NATURAL_32]}.make_shared ($l_val___0))
							if l_num_bytes = -1 then
								Result := (-1)
								js.return
							end
							if not js.return_called then
								globals_inst.current_menu.ce_gets (create {CE_POINTER [PD_VIMMENU]}.make_shared (default_pointer + l_val___0.to_integer_32))
								l_slen := l_slen + l_num_bytes
								if (menu_inst.check_menu_pointer (globals_inst.root_menu, globals_inst.current_menu)) = 0 then
									l_key_name[0] := (253).to_natural_8
									l_key_name[1] := (53).to_natural_8
								end
							end
						elseif (l_key_name[0]).to_integer_32 = 240 then
							l_num_bytes := get_bytes_from_buf (l_tp + l_slen, l_bytes___0, 1)
							if l_num_bytes = -1 then
								Result := (-1)
								js.return
							end
							if not js.return_called then
								globals_inst.current_tab := (l_bytes___0[0]).to_integer_32
								if globals_inst.current_tab = 255 then
									globals_inst.current_tab := -1
								end
								l_slen := l_slen + l_num_bytes
							end
						elseif (l_key_name[0]).to_integer_32 = 239 then
							l_num_bytes := get_bytes_from_buf (l_tp + l_slen, l_bytes___0, 2)
							if l_num_bytes = -1 then
								Result := (-1)
								js.return
							end
							if not js.return_called then
								globals_inst.current_tab := (l_bytes___0[0]).to_integer_32
								globals_inst.current_tabmenu := (l_bytes___0[1]).to_integer_32
								l_slen := l_slen + l_num_bytes
							end
						end
				when 127 then -- if done
						if not js.return_called then
							l_key := misc2_inst.handle_x_keys (-((l_key_name[0]).to_integer_32 + (((l_key_name[1]).to_integer_32).bit_shift_left (8))))
							l_new_slen := 0
							if l_modifiers /= 0 then
								l_key := misc2_inst.simplify_key (l_key, create {CE_POINTER [INTEGER_32]}.make_shared ($l_modifiers))
								if l_modifiers /= 0 then
									l_tmp___12 := l_new_slen
									l_new_slen := l_new_slen + 1
									l_string___0[l_tmp___12] := (128).to_natural_8
									l_tmp___13 := l_new_slen
									l_new_slen := l_new_slen + 1
									l_string___0[l_tmp___13] := (252).to_natural_8
									l_tmp___14 := l_new_slen
									l_new_slen := l_new_slen + 1
									l_string___0[l_tmp___14] := l_modifiers.to_natural_8
								end
							end
							l_key_name[0] := ((-l_key).bit_and (255)).to_natural_8
							l_key_name[1] := (((((-l_key).to_natural_32).bit_shift_right (8))).bit_and ({NATURAL_32} 255)).to_natural_8
							if (l_key_name[0]).to_integer_32 = 242 then
								if globals_inst.has_mbyte.to_boolean then
									l_new_slen := l_new_slen + (globals_inst.mb_char2bytes.integer_32_item ([(l_key_name[1]).to_integer_32, l_string___0 + l_new_slen]))
								else
									l_tmp___16 := l_new_slen
									l_new_slen := l_new_slen + 1
									l_string___0[l_tmp___16] := l_key_name[1]
								end
							else
								l_tmp___17 := l_new_slen
								l_new_slen := l_new_slen + 1
								l_string___0[l_tmp___17] := (128).to_natural_8
								l_tmp___18 := l_new_slen
								l_new_slen := l_new_slen + 1
								l_string___0[l_tmp___18] := l_key_name[0]
								l_tmp___19 := l_new_slen
								l_new_slen := l_new_slen + 1
								l_string___0[l_tmp___19] := l_key_name[1]
							end
							l_string___0[l_new_slen] := (('%/0/').code).to_natural_8
							l_extra := l_new_slen - l_slen
							if (a_buf___6.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
								if l_extra < 0 then
									getchar_inst.del_typebuf (-l_extra, l_offset)
								elseif l_extra > 0 then
									getchar_inst.ins_typebuf (l_string___0 + l_slen, 0, l_offset, 0, 0).do_nothing
								end
								memmove (create {CE_POINTER [ANY]}.make_cast (((globals_inst.typebuf.tb_buf + globals_inst.typebuf.tb_off) + l_offset)), create {CE_POINTER [ANY]}.make_cast (l_string___0), l_new_slen.to_natural_32).do_nothing
							else
								if l_extra < 0 then
									memmove (create {CE_POINTER [ANY]}.make_cast ((a_buf___6 + l_offset)), create {CE_POINTER [ANY]}.make_cast (((a_buf___6 + l_offset) - l_extra)), ((a_buflen + l_offset) + l_extra).to_natural_32).do_nothing
								elseif l_extra > 0 then
									memmove (create {CE_POINTER [ANY]}.make_cast (((a_buf___6 + l_offset) + l_extra)), create {CE_POINTER [ANY]}.make_cast ((a_buf___6 + l_offset)), (a_buflen - l_offset).to_natural_32).do_nothing
								end
								memmove (create {CE_POINTER [ANY]}.make_cast ((a_buf___6 + l_offset)), create {CE_POINTER [ANY]}.make_cast (l_string___0), l_new_slen.to_natural_32).do_nothing
							end
							Result := ((l_len + l_extra) + l_offset)
							js.return
						end
				when 128 then -- if done | if done | if done
						if not js.loop_left then
							l_offset := l_offset + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 129 then -- loop done
					js.reset
					if not js.return_called then
						Result := 0
					end
				when 130 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	replace_termcodes (a_from: CE_POINTER [NATURAL_8]; a_bufp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_from_part: INTEGER_32; a_do_lt: INTEGER_32; a_special: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_from: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_slen: INTEGER_32
			l_key: INTEGER_32
			l_dlen: INTEGER_32
			l_src: CE_POINTER [NATURAL_8]
			l_do_backslash: INTEGER_32
			l_do_special: INTEGER_32
			l_do_key_code: INTEGER_32
			l_result___2: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_len: NATURAL_8
			l_tmp___22: INTEGER_32
			l_tmp___23: CE_POINTER [NATURAL_8]
			l_tmp___24: INTEGER_32
			l_tmp___25: INTEGER_32
			l_tmp___26: INTEGER_32
			l_tmp___27: INTEGER_32
			l_tmp___28: INTEGER_32
			l_tmp___29: INTEGER_32
			l_tmp___30: INTEGER_32
			l_tmp___31: INTEGER_32
			l_tmp___32: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_from.make
			create l_src.make
			create l_result___2.make
			create l_p___0.make
			create l_s.make
			create l_tmp___23.make
			create l_tmp___32.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_from.ce_gets (a_from)
					l_dlen := 0
					l_do_backslash := (((misc2_inst.vim_strchr (option_inst.p_cpo, ('B').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32).to_integer
					if ((misc2_inst.vim_strchr (option_inst.p_cpo, ('<').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						l_tmp___1 := 1
					elseif a_special.to_boolean then
						l_tmp___1 := 1
					else
						l_tmp___1 := 0
					end
					l_do_special := l_tmp___1
					l_do_key_code := (((misc2_inst.vim_strchr (option_inst.p_cpo, ('k').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32).to_integer
					l_result___2.ce_gets (misc2_inst.alloc ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_from))) * {NATURAL_32} 6 + {NATURAL_32} 1))
					if (l_result___2.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						a_bufp.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						Result := l_from
						js.return
					end
					if js.return_called then
						l_pos := -1 + 18 -- skip if block
					end
				when 1 then -- if:
						l_src.ce_gets (l_from)
						if a_from_part.to_boolean then
							if (l_src[0]).to_integer_32 = 35 then
								if (l_src[1]).to_integer_32 >= 48 then
									if (l_src[1]).to_integer_32 <= 57 then
										l_tmp___4 := l_dlen
										l_dlen := l_dlen + 1
										l_result___2[l_tmp___4] := (128).to_natural_8
										l_tmp___5 := l_dlen
										l_dlen := l_dlen + 1
										l_result___2[l_tmp___5] := (('k').code).to_natural_8
										if (l_src[1]).to_integer_32 = 48 then
											l_tmp___6 := l_dlen
											l_dlen := l_dlen + 1
											l_result___2[l_tmp___6] := ((';').code).to_natural_8
										else
											l_tmp___7 := l_dlen
											l_dlen := l_dlen + 1
											l_result___2[l_tmp___7] := l_src[1]
										end
										l_src.ce_gets (l_src + (2))
									end
								end
							end
						end
				when 2 then -- loop condition:
						if not (not js.loop_left and then ((l_src.item).to_integer_32 /= 0)) then
							l_pos := -1 + 17 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						if not (l_do_special.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if not (a_do_lt.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_src), ce_string ("<lt>"), (4).to_natural_32)) = 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_src), ce_string ("<SID>"), (5).to_natural_32)) = 0 then
							if globals_inst.current_SID <= 0 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_usingsid))))).do_nothing
							else
								l_src.ce_gets (l_src + (5))
								l_tmp___9 := l_dlen
								l_dlen := l_dlen + 1
								l_result___2[l_tmp___9] := (128).to_natural_8
								l_tmp___10 := l_dlen
								l_dlen := l_dlen + 1
								l_result___2[l_tmp___10] := (253).to_natural_8
								l_tmp___11 := l_dlen
								l_dlen := l_dlen + 1
								l_result___2[l_tmp___11] := (82).to_natural_8
								sprintf ([(create {CE_POINTER [INTEGER_8]}.make_cast (l_result___2) + l_dlen), ce_string ("%%ld"), globals_inst.current_SID.to_integer_32]).do_nothing
								l_dlen := l_dlen + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_result___2 + l_dlen)))).to_integer_32
								l_tmp___13 := l_dlen
								l_dlen := l_dlen + 1
								l_result___2[l_tmp___13] := (('_').code).to_natural_8
								js.continue
							end
						end
						if not js.loop_jumped then
							l_slen := misc2_inst.trans_special (l_src.address, l_result___2 + l_dlen, 1)
							if l_slen.to_boolean then
								l_dlen := l_dlen + l_slen
								js.continue
							end
						end
				when 9 then -- if done | if done
						if not js.loop_jumped and then (l_do_key_code.to_boolean) then
							l_i___0 := find_term_bykeys (l_src)
							if l_i___0 >= 0 then
								l_tmp___16 := l_dlen
								l_dlen := l_dlen + 1
								l_result___2[l_tmp___16] := (128).to_natural_8
								l_tmp___17 := l_dlen
								l_dlen := l_dlen + 1
								l_result___2[l_tmp___17] := (termcodes + l_i___0).item.name[0]
								l_tmp___18 := l_dlen
								l_dlen := l_dlen + 1
								l_result___2[l_tmp___18] := (termcodes + l_i___0).item.name[1]
								l_src.ce_gets (l_src + ((termcodes + l_i___0).item.len))
								js.continue
							end
						end
						if not js.loop_jumped and then (l_do_special.to_boolean) then
							if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_src), ce_string ("<Leader>"), (8).to_natural_32)) = 0 then
								l_len := (8).to_natural_8
								l_p___0.ce_gets (eval_inst.get_var_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("g:mapleader"))))
							elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_src), ce_string ("<LocalLeader>"), (13).to_natural_32)) = 0 then
								l_len := (13).to_natural_8
								l_p___0.ce_gets (eval_inst.get_var_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("g:maplocalleader"))))
							else
								l_len := (0).to_natural_8
								l_p___0.ce_gets (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							end
							if l_len.to_integer_32 /= 0 then
								if (l_p___0.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
									l_s.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("\")))
								elseif (l_p___0.item).to_integer_32 = 0 then
									l_s.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("\")))
								elseif (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))) > {NATURAL_32} 48 then
									l_s.ce_gets (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("\")))
								else
									l_s.ce_gets (l_p___0)
								end
								from
								until
									(l_s.item).to_integer_32 = 0
								loop
									l_tmp___22 := l_dlen
									l_dlen := l_dlen + 1
									l_tmp___23.ce_gets (l_s)
									l_s.ce_gets (l_s + 1)
									l_result___2[l_tmp___22] := l_tmp___23.item
								end
								l_src.ce_gets (l_src + l_len.to_integer_32)
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 16 -- skip if block
						end
				when 10 then -- if:
						l_key := (l_src.item).to_integer_32
						if l_key /= 22 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 15 -- goto _L___0
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 13 then -- else:
						if not (l_do_backslash.to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if l_key /= 92 then
							l_pos := -1 + 16 -- skip if block
						end
				when 15 then -- if: | _L___0:
						l_src.ce_gets (l_src + 1)
						if (l_src.item).to_integer_32 = 0 then
							if a_from_part.to_boolean then
								l_tmp___24 := l_dlen
								l_dlen := l_dlen + 1
								l_result___2[l_tmp___24] := l_key.to_natural_8
							end
							js.break
						end
				when 16 then -- if done | if done | if done
						if not js.loop_jumped then
							l_i___0 := globals_inst.mb_ptr2len.integer_32_item ([l_src])
							from
							until
								not (l_i___0 > 0)
							loop
								if (l_src.item).to_integer_32 = 128 then
									l_tmp___25 := l_dlen
									l_dlen := l_dlen + 1
									l_result___2[l_tmp___25] := (128).to_natural_8
									l_tmp___26 := l_dlen
									l_dlen := l_dlen + 1
									l_result___2[l_tmp___26] := (254).to_natural_8
									l_tmp___27 := l_dlen
									l_dlen := l_dlen + 1
									l_result___2[l_tmp___27] := (('X').code).to_natural_8
								elseif (l_src.item).to_integer_32 = 155 then
									l_tmp___28 := l_dlen
									l_dlen := l_dlen + 1
									l_result___2[l_tmp___28] := (128).to_natural_8
									l_tmp___29 := l_dlen
									l_dlen := l_dlen + 1
									l_result___2[l_tmp___29] := (253).to_natural_8
									l_tmp___30 := l_dlen
									l_dlen := l_dlen + 1
									l_result___2[l_tmp___30] := (81).to_natural_8
								else
									l_tmp___31 := l_dlen
									l_dlen := l_dlen + 1
									l_result___2[l_tmp___31] := l_src.item
								end
								l_src.ce_gets (l_src + 1)
								l_i___0 := l_i___0 - 1
							end
						end
						l_pos := -1 + 2 -- back to loop condition
				when 17 then -- loop done
						js.reset
						l_result___2[l_dlen] := (('%/0/').code).to_natural_8
						l_tmp___32.ce_gets (misc2_inst.vim_strsave (l_result___2))
						a_bufp.item := l_tmp___32
						if (l_tmp___32.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
							l_from.ce_gets (a_bufp.item)
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_result___2))
						Result := l_from
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	find_term_bykeys (a_src: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_slen: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := 0
			from
			until
				not (not js.loop_left and then (l_i___0 < tc_len))
			loop
				l_slen := (termcodes + l_i___0).item.len
				if l_slen > 1 then
					if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast ((termcodes + l_i___0).item.code), create {CE_POINTER [INTEGER_8]}.make_cast (a_src), l_slen.to_natural_32)) = 0 then
						Result := l_i___0
						js.return
					end
				end
				if not js.return_called then
					l_i___0 := l_i___0 + 1
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	gather_termleader
		local
			l_i___0: INTEGER_32
			l_len: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
		do
			l_len := 0
			if (gui_inst.gui.in_use).to_boolean then
				l_tmp := l_len
				l_len := l_len + 1
				termleader[l_tmp] := (155).to_natural_8
			end
			if check_for_codes.to_boolean then
				l_tmp___0 := l_len
				l_len := l_len + 1
				termleader[l_tmp___0] := (144).to_natural_8
			end
			termleader[l_len] := (('%/0/').code).to_natural_8
			l_i___0 := 0
			from
			until
				not (l_i___0 < tc_len)
			loop
				if ((misc2_inst.vim_strchr (termleader, ((termcodes + l_i___0).item.code[0]).to_integer_32)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					l_tmp___1 := l_len
					l_len := l_len + 1
					termleader[l_tmp___1] := (termcodes + l_i___0).item.code[0]
					termleader[l_len] := (('%/0/').code).to_natural_8
				end
				l_i___0 := l_i___0 + 1
			end
			need_gather := 0
		end

	show_termcodes
		local
			l_col: INTEGER_32
			l_items: CE_POINTER [INTEGER_32]
			l_item_count: INTEGER_32
			l_run: INTEGER_32
			l_row: INTEGER_32
			l_rows: INTEGER_32
			l_cols: INTEGER_32
			l_i___0: INTEGER_32
			l_len: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
		do
			create l_items.make

			if tc_len = 0 then
				js.return
			end
			if not js.return_called then
				l_items.ce_gets (create {CE_POINTER [INTEGER_32]}.make_cast ((misc2_inst.alloc (Integer_32_bytes.to_natural_32 * tc_len.to_natural_32))))
				if (l_items.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					js.return
				end
			end
			if not js.return_called then
				message_inst.msg_puts_title (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("%N--- Terminal keys ---")))))
				l_run := 1
				from
				until
					js.loop_left
				loop
					js.reset
					if l_run <= 3 then
						if globals_inst.got_int.to_boolean then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_item_count := 0
						l_i___0 := 0
						from
						until
							not (l_i___0 < tc_len)
						loop
							l_len := show_one_termcode ((termcodes + l_i___0).item.name, (termcodes + l_i___0).item.code, 0)
							if l_len <= 25 then
								l_tmp___3 := (l_run = 1).to_integer
							else
								if l_len <= 38 then
									l_tmp___2 := (l_run = 2).to_integer
								else
									l_tmp___2 := (l_run = 3).to_integer
								end
								l_tmp___3 := l_tmp___2
							end
							if l_tmp___3.to_boolean then
								l_tmp___1 := l_item_count
								l_item_count := l_item_count + 1
								l_items[l_tmp___1] := l_i___0
							end
							l_i___0 := l_i___0 + 1
						end
						if l_run <= 2 then
							if l_run = 1 then
								l_tmp___4 := 27
							else
								l_tmp___4 := 40
							end
							l_cols := ((globals_inst.Columns + 2) // l_tmp___4.to_integer_32).to_integer_32
							if l_cols = 0 then
								l_cols := 1
							end
							l_rows := ((l_item_count + l_cols) - 1) // l_cols
						else
							l_rows := l_item_count
						end
						l_row := 0
						from
						until
							js.loop_left
						loop
							js.reset
							if l_row < l_rows then
								if globals_inst.got_int.to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								message_inst.msg_putchar (('%N').code)
								if globals_inst.got_int.to_boolean then
									js.break
								end
							end
							if not js.loop_jumped then
								l_col := 0
								l_i___0 := l_row
								from
								until
									not (l_i___0 < l_item_count)
								loop
									globals_inst.msg_col := l_col
									show_one_termcode ((termcodes + l_items[l_i___0]).item.name, (termcodes + l_items[l_i___0]).item.code, 1).do_nothing
									if l_run = 2 then
										l_col := l_col + (40)
									else
										l_col := l_col + (27)
									end
									l_i___0 := l_i___0 + l_rows
								end
								out_flush
								ui_inst.ui_breakcheck
								l_row := l_row + 1
							end
						end
						js.reset
						l_run := l_run + 1
					end
				end
				js.reset
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_items))
			end
		end

	show_one_termcode (a_name___1: CE_POINTER [NATURAL_8]; a_code: CE_POINTER [NATURAL_8]; a_printit: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make

			if (a_name___1[0]).to_integer_32 > 126 then
				globals_inst.IObuff[0] := ((' ').code).to_natural_8
				globals_inst.IObuff[1] := ((' ').code).to_natural_8
				globals_inst.IObuff[2] := ((' ').code).to_natural_8
				globals_inst.IObuff[3] := ((' ').code).to_natural_8
			else
				globals_inst.IObuff[0] := (('t').code).to_natural_8
				globals_inst.IObuff[1] := (('_').code).to_natural_8
				globals_inst.IObuff[2] := a_name___1[0]
				globals_inst.IObuff[3] := a_name___1[1]
			end
			globals_inst.IObuff[4] := ((' ').code).to_natural_8
			l_p___0.ce_gets (misc2_inst.get_special_key_name (-((a_name___1[0]).to_integer_32 + (((a_name___1[1]).to_integer_32).bit_shift_left (8))), 0))
			if (l_p___0[1]).to_integer_32 /= 116 then
				strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((globals_inst.IObuff + 5)), create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0)).do_nothing
			else
				globals_inst.IObuff[5] := (('%/0/').code).to_natural_8
			end
			l_len := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff))).to_integer_32
			from
			until
				js.loop_left
			loop
				js.reset
				l_tmp___0 := l_len
				l_len := l_len + 1
				globals_inst.IObuff[l_tmp___0] := ((' ').code).to_natural_8
				if not (l_len < 17) then
					js.break
				end
			end
			js.reset
			globals_inst.IObuff[l_len] := (('%/0/').code).to_natural_8
			if (a_code.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				l_len := l_len + (4)
			else
				l_len := l_len + (charset_inst.vim_strsize (a_code))
			end
			if a_printit.to_boolean then
				message_inst.msg_puts (globals_inst.IObuff)
				if (a_code.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					message_inst.msg_puts (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("NULL")))
				else
					message_inst.msg_outtrans (a_code).do_nothing
				end
			end
			Result := l_len
		end

	req_codes_from_term
		do
			xt_index_out := 0
			xt_index_in := 0
			req_more_codes_from_term
		end

	req_more_codes_from_term
		local
			l_buf___6: CE_ARRAY [INTEGER_8]
			l_old_idx: INTEGER_32
			js: JUMP_STATE
		do
			create l_buf___6.make (<<11>>)

			l_old_idx := xt_index_out
			if globals_inst.exiting.to_boolean then
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_left
				loop
					js.reset
					if xt_index_out < xt_index_in + 10 then
						if ((key_names[xt_index_out]).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						sprintf ([l_buf___6, ce_string ("%/27/P+q%%02x%%02x%/27/\"), ((key_names[xt_index_out])[0]).to_integer_32, ((key_names[xt_index_out])[1]).to_integer_32]).do_nothing
						out_str_nf (create {CE_POINTER [NATURAL_8]}.make_cast (l_buf___6))
						xt_index_out := xt_index_out + 1
					end
				end
				js.reset
				if xt_index_out /= l_old_idx then
					out_flush
				end
			end
		end

	got_code_from_term (a_code: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_name___1: CE_ARRAY [NATURAL_8]
			l_str___1: CE_ARRAY [NATURAL_8]
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_c: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_name___1.make (<<3>>)
			create l_str___1.make (<<100>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_j := 0
					if (a_code[0]).to_integer_32 /= 49 then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if (a_code[7]).to_integer_32 /= 61 then
							l_pos := -1 + 8 -- skip if block
						end
				when 2 then -- if:
						if not (a_len // 2 < 100) then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						l_name___1[0] := (charset_inst.hexhex2nr (a_code + 3)).to_natural_8
						l_name___1[1] := (charset_inst.hexhex2nr (a_code + 5)).to_natural_8
						l_name___1[2] := (('%/0/').code).to_natural_8
						l_i___0 := 0
						from
						until
							not (not js.loop_left and then (((key_names[l_i___0]).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32))
						loop
							js.reset
							if (strcmp (key_names[l_i___0], create {CE_POINTER [INTEGER_8]}.make_cast (l_name___1))) = 0 then
								xt_index_in := l_i___0
								js.break
							end
							if not js.loop_jumped then
								l_i___0 := l_i___0 + 1
							end
						end
						js.reset
						if ((key_names[l_i___0]).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_pos := -1 + 8 -- skip if block
						end
				when 4 then -- if:
						l_i___0 := 8
						from
						until
							js.loop_left
						loop
							js.reset
							l_c := charset_inst.hexhex2nr (a_code + l_i___0)
							if not (l_c >= 0) then
								js.break
							end
							if not js.loop_jumped then
								l_tmp___2 := l_j
								l_j := l_j + 1
								l_str___1[l_tmp___2] := l_c.to_natural_8
								l_i___0 := l_i___0 + (2)
							end
						end
						js.reset
						l_str___1[l_j] := (('%/0/').code).to_natural_8
						if (l_name___1[0]).to_integer_32 /= 67 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (l_name___1[1]).to_integer_32 = 111 then
							l_i___0 := atoi (create {CE_POINTER [INTEGER_8]}.make_cast (l_str___1))
							if l_i___0 /= globals_inst.t_colors then
								message_inst.set_keep_msg_from_hist
								set_color_count (l_i___0)
								syntax_inst.init_highlight (1, 0)
								screen_inst.redraw_later (50)
							end
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						l_i___0 := find_term_bykeys (l_str___1)
						if l_i___0 >= 0 then
							del_termcode_idx (l_i___0)
						end
						add_termcode (l_name___1, l_str___1, 55)
				when 8 then -- if done | if done | if done | if done
						xt_index_in := xt_index_in + 1
						req_more_codes_from_term
				when 9 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	check_for_codes_from_term
		local
			l_c: INTEGER_32
			js: JUMP_STATE
		do
			if xt_index_out = 0 then
				js.return
			elseif xt_index_out = xt_index_in then
				js.return
			end
			if not js.return_called then
				globals_inst.no_mapping := globals_inst.no_mapping + 1
				globals_inst.allow_keys := globals_inst.allow_keys + 1
				from
				until
					js.loop_left
				loop
					js.reset
					l_c := getchar_inst.vpeekc
					if l_c = 0 then
						js.break
					end
					if not js.loop_jumped and then (l_c /= 128) then
						if l_c /= -(253 + ((53).bit_shift_left (8))) then
							js.break
						end
					end
					if not js.loop_jumped then
						l_c := getchar_inst.vgetc
						if l_c /= -(253 + ((53).bit_shift_left (8))) then
							getchar_inst.vungetc (l_c)
							js.break
						end
					end
				end
				js.reset
				globals_inst.no_mapping := globals_inst.no_mapping - 1
				globals_inst.allow_keys := globals_inst.allow_keys - 1
			end
		end

	translate_mapping (a_str___1: CE_POINTER [NATURAL_8]; a_expmap: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_str___1: CE_POINTER [NATURAL_8]
			l_ga: PD_GROWARRAY
			l_c: INTEGER_32
			l_modifiers: INTEGER_32
			l_cpo_bslash: INTEGER_32
			l_cpo_special: INTEGER_32
			l_cpo_keycode: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_str___1.make
			create l_ga.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_str___1.ce_gets (a_str___1)
					misc2_inst.ga_init (l_ga.address)
					l_ga.ga_itemsize := 1
					l_ga.ga_growsize := 40
					l_cpo_bslash := (((misc2_inst.vim_strchr (option_inst.p_cpo, ('B').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
					l_cpo_special := (((misc2_inst.vim_strchr (option_inst.p_cpo, ('<').code)).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer
					l_cpo_keycode := (((misc2_inst.vim_strchr (option_inst.p_cpo, ('k').code)).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32).to_integer
				when 1 then -- loop condition:
					if not (not js.loop_left and then ((l_str___1.item).to_boolean)) then
						l_pos := -1 + 35 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_c := (l_str___1.item).to_integer_32
						if l_c /= 128 then
							l_pos := -1 + 12 -- skip if block
						end
				when 3 then -- if:
						if (l_str___1[1]).to_integer_32 = 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if (l_str___1[2]).to_integer_32 = 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 5 then -- if:
						l_modifiers := 0
						if (l_str___1[1]).to_integer_32 = 252 then
							l_str___1.ce_gets (l_str___1 + 1)
							l_str___1.ce_gets (l_str___1 + 1)
							l_modifiers := (l_str___1.item).to_integer_32
							l_str___1.ce_gets (l_str___1 + 1)
							l_c := (l_str___1.item).to_integer_32
						end
						if l_cpo_special.to_boolean then
							if l_cpo_keycode.to_boolean then
								if l_c = 128 then
									if not l_modifiers.to_boolean then
										l_i___0 := 0
										from
										until
											not (not js.loop_left and then (l_i___0 < tc_len))
										loop
											js.reset
											if ((termcodes + l_i___0).item.name[0]).to_integer_32 = (l_str___1[1]).to_integer_32 then
												if ((termcodes + l_i___0).item.name[1]).to_integer_32 = (l_str___1[2]).to_integer_32 then
													js.break
												end
											end
											if not js.loop_jumped then
												l_i___0 := l_i___0 + 1
											end
										end
										js.reset
										if l_i___0 < tc_len then
											misc2_inst.ga_concat (l_ga.address, (termcodes + l_i___0).item.code)
											l_str___1.ce_gets (l_str___1 + (2))
											js.continue
										end
									end
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 12 -- skip if block
						end
				when 6 then -- if:
						if l_c = 128 then
							if (l_str___1[1]).to_integer_32 /= 0 then
								if (l_str___1[2]).to_integer_32 /= 0 then
									if a_expmap.to_boolean then
										if l_cpo_special.to_boolean then
											misc2_inst.ga_clear (l_ga.address)
											Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
											js.return
										end
									end
									if not js.return_called then
										if (l_str___1[1]).to_integer_32 = 254 then
											l_c := 128
										else
											if (l_str___1[1]).to_integer_32 = 255 then
												l_tmp___2 := -(255 + ((88).bit_shift_left (8)))
											else
												l_tmp___2 := -((l_str___1[1]).to_integer_32 + (((l_str___1[2]).to_integer_32).bit_shift_left (8)))
											end
											l_c := l_tmp___2
										end
										if l_c = -(255 + ((88).bit_shift_left (8))) then
											l_c := ('%/0/').code
										end
										l_str___1.ce_gets (l_str___1 + (2))
									end
								end
							end
						end
						if js.return_called then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
						if not (l_c < 0) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 10 then -- else:
						if not (l_modifiers.to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | _L:
						if a_expmap.to_boolean then
							if l_cpo_special.to_boolean then
								misc2_inst.ga_clear (l_ga.address)
								Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								js.return
							end
						end
						if not js.return_called then
							misc2_inst.ga_concat (l_ga.address, (misc2_inst.get_special_key_name (l_c, l_modifiers)))
							js.continue
						end
				when 12 then -- if done | if done | if done | if done | if done | if done
						if js.return_called then
							l_pos := -1 + 34 -- skip if block
						end
				when 13 then -- if:
						if js.loop_jumped then
							l_pos := -1 + 33 -- skip if block
						end
				when 14 then -- if:
						if l_c /= 32 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 31 -- goto _L___0
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 17 then -- else:
						if l_c /= 9 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 31 -- goto _L___0
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 20 then -- else:
						if l_c /= 10 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 31 -- goto _L___0
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 23 then -- else:
						if l_c /= 22 then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						l_pos := -1 + 31 -- goto _L___0
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 26 then -- else:
						if l_c /= 60 then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						if not l_cpo_special.to_boolean then
							l_pos := -1 + 31 -- goto _L___0
						else
							l_pos := -1 + 29 -- goto _L___1
						end
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 29 then -- else: | _L___1:
						if l_c /= 92 then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						if l_cpo_bslash.to_boolean then
							l_pos := -1 + 32 -- skip if block
						end
				when 31 then -- if: | _L___0:
						if l_cpo_bslash.to_boolean then
							l_tmp___4 := 22
						else
							l_tmp___4 := ('\').code
						end
						misc2_inst.ga_append (l_ga.address, l_tmp___4)
				when 32 then -- if done | if done | if done | if done | if done | if done
						if l_c.to_boolean then
							misc2_inst.ga_append (l_ga.address, l_c)
						end
				when 33 then -- if done
						if not js.loop_left then
							l_str___1.ce_gets (l_str___1 + 1)
						end
				when 34 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 35 then -- loop done
					if not js.return_called then
						misc2_inst.ga_append (l_ga.address, ('%/0/').code)
						Result := (create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.ga_data))
					end
				when 36 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
