class
	SD_GCLOSURENOTIFYDATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	data: CE_POINTER [ANY] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	notify: CE_ROUTINE assign set_notify
		do
			create Result.make_shared (c_notify (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_data (a_data: CE_POINTER [ANY])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

	set_notify (a_notify: CE_ROUTINE)
		do
			c_set_notify (c_pointer, a_notify.c_pointer)
		end

feature {NONE} -- C getters

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GClosureNotifyData *)$tmp)->data;"
		end

	c_notify (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void * data, struct _GClosure * closure))((struct _GClosureNotifyData *)$tmp)->notify;"
		end

feature {NONE} -- C setters

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct _GClosureNotifyData *)$tmp)->data = (void *)$a_data;"
		end

	c_set_notify (tmp: POINTER; a_notify: POINTER)
		external
			"C inline"
		alias
			"((struct _GClosureNotifyData *)$tmp)->notify = (void( *)(void * data, struct _GClosure * closure))$a_notify;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GClosureNotifyData);"
		end

end
