class
	SD_GDKDEVICE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	parent_instance: SD_GOBJECT assign set_parent_instance
		do
			create Result.make_shared (c_parent_instance (c_pointer))
		end

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	source: INTEGER_32 assign set_source
		do
			Result := c_source (c_pointer)
		end

	mode: INTEGER_32 assign set_mode
		do
			Result := c_mode (c_pointer)
		end

	has_cursor: INTEGER_32 assign set_has_cursor
		do
			Result := c_has_cursor (c_pointer)
		end

	num_axes: INTEGER_32 assign set_num_axes
		do
			Result := c_num_axes (c_pointer)
		end

	axes: CE_POINTER [SD_GDKDEVICEAXIS] assign set_axes
		do
			create Result.make_shared (c_axes (c_pointer))
		end

	num_keys: INTEGER_32 assign set_num_keys
		do
			Result := c_num_keys (c_pointer)
		end

	keys: CE_POINTER [SD_GDKDEVICEKEY] assign set_keys
		do
			create Result.make_shared (c_keys (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_parent_instance (a_parent_instance: SD_GOBJECT)
		do
			parent_instance.ce_gets (a_parent_instance)
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_source (a_source: INTEGER_32)
		do
			c_set_source (c_pointer, a_source)
		end

	set_mode (a_mode: INTEGER_32)
		do
			c_set_mode (c_pointer, a_mode)
		end

	set_has_cursor (a_has_cursor: INTEGER_32)
		do
			c_set_has_cursor (c_pointer, a_has_cursor)
		end

	set_num_axes (a_num_axes: INTEGER_32)
		do
			c_set_num_axes (c_pointer, a_num_axes)
		end

	set_axes (a_axes: CE_POINTER [SD_GDKDEVICEAXIS])
		do
			c_set_axes (c_pointer, a_axes.c_pointer)
		end

	set_num_keys (a_num_keys: INTEGER_32)
		do
			c_set_num_keys (c_pointer, a_num_keys)
		end

	set_keys (a_keys: CE_POINTER [SD_GDKDEVICEKEY])
		do
			c_set_keys (c_pointer, a_keys.c_pointer)
		end

feature {NONE} -- C getters

	c_parent_instance (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GObject *)&((struct _GdkDevice *)$tmp)->parent_instance;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GdkDevice *)$tmp)->name;"
		end

	c_source (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkDevice *)$tmp)->source;"
		end

	c_mode (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkDevice *)$tmp)->mode;"
		end

	c_has_cursor (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkDevice *)$tmp)->has_cursor;"
		end

	c_num_axes (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkDevice *)$tmp)->num_axes;"
		end

	c_axes (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDeviceAxis *)((struct _GdkDevice *)$tmp)->axes;"
		end

	c_num_keys (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkDevice *)$tmp)->num_keys;"
		end

	c_keys (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDeviceKey *)((struct _GdkDevice *)$tmp)->keys;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkDevice *)$tmp)->name = (char *)$a_name;"
		end

	c_set_source (tmp: POINTER; a_source: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkDevice *)$tmp)->source = $a_source;"
		end

	c_set_mode (tmp: POINTER; a_mode: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkDevice *)$tmp)->mode = $a_mode;"
		end

	c_set_has_cursor (tmp: POINTER; a_has_cursor: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkDevice *)$tmp)->has_cursor = $a_has_cursor;"
		end

	c_set_num_axes (tmp: POINTER; a_num_axes: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkDevice *)$tmp)->num_axes = $a_num_axes;"
		end

	c_set_axes (tmp: POINTER; a_axes: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkDevice *)$tmp)->axes = (struct _GdkDeviceAxis *)$a_axes;"
		end

	c_set_num_keys (tmp: POINTER; a_num_keys: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkDevice *)$tmp)->num_keys = $a_num_keys;"
		end

	c_set_keys (tmp: POINTER; a_keys: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkDevice *)$tmp)->keys = (struct _GdkDeviceKey *)$a_keys;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkDevice);"
		end

end
