class
	SD_GDKDEVICEAXIS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	use: INTEGER_32 assign set_use
		do
			Result := c_use (c_pointer)
		end

	min: REAL_64 assign set_min
		do
			Result := c_min (c_pointer)
		end

	max: REAL_64 assign set_max
		do
			Result := c_max (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_use (a_use: INTEGER_32)
		do
			c_set_use (c_pointer, a_use)
		end

	set_min (a_min: REAL_64)
		do
			c_set_min (c_pointer, a_min)
		end

	set_max (a_max: REAL_64)
		do
			c_set_max (c_pointer, a_max)
		end

feature {NONE} -- C getters

	c_use (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkDeviceAxis *)$tmp)->use;"
		end

	c_min (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct _GdkDeviceAxis *)$tmp)->min;"
		end

	c_max (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct _GdkDeviceAxis *)$tmp)->max;"
		end

feature {NONE} -- C setters

	c_set_use (tmp: POINTER; a_use: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkDeviceAxis *)$tmp)->use = $a_use;"
		end

	c_set_min (tmp: POINTER; a_min: REAL_64)
		external
			"C inline"
		alias
			"((struct _GdkDeviceAxis *)$tmp)->min = $a_min;"
		end

	c_set_max (tmp: POINTER; a_max: REAL_64)
		external
			"C inline"
		alias
			"((struct _GdkDeviceAxis *)$tmp)->max = $a_max;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkDeviceAxis);"
		end

end
