class
	SD_GDKEVENTCROSSING

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window
		do
			create Result.make_shared (c_window (c_pointer))
		end

	send_event: INTEGER_8 assign set_send_event
		do
			Result := c_send_event (c_pointer)
		end

	subwindow: CE_POINTER [SD_GDKDRAWABLE] assign set_subwindow
		do
			create Result.make_shared (c_subwindow (c_pointer))
		end

	time: NATURAL_32 assign set_time
		do
			Result := c_time (c_pointer)
		end

	x: REAL_64 assign set_x
		do
			Result := c_x (c_pointer)
		end

	y: REAL_64 assign set_y
		do
			Result := c_y (c_pointer)
		end

	x_root: REAL_64 assign set_x_root
		do
			Result := c_x_root (c_pointer)
		end

	y_root: REAL_64 assign set_y_root
		do
			Result := c_y_root (c_pointer)
		end

	mode: INTEGER_32 assign set_mode
		do
			Result := c_mode (c_pointer)
		end

	detail: INTEGER_32 assign set_detail
		do
			Result := c_detail (c_pointer)
		end

	focus: INTEGER_32 assign set_focus
		do
			Result := c_focus (c_pointer)
		end

	state: NATURAL_32 assign set_state
		do
			Result := c_state (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_window (c_pointer, a_window.c_pointer)
		end

	set_send_event (a_send_event: INTEGER_8)
		do
			c_set_send_event (c_pointer, a_send_event)
		end

	set_subwindow (a_subwindow: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_subwindow (c_pointer, a_subwindow.c_pointer)
		end

	set_time (a_time: NATURAL_32)
		do
			c_set_time (c_pointer, a_time)
		end

	set_x (a_x: REAL_64)
		do
			c_set_x (c_pointer, a_x)
		end

	set_y (a_y: REAL_64)
		do
			c_set_y (c_pointer, a_y)
		end

	set_x_root (a_x_root: REAL_64)
		do
			c_set_x_root (c_pointer, a_x_root)
		end

	set_y_root (a_y_root: REAL_64)
		do
			c_set_y_root (c_pointer, a_y_root)
		end

	set_mode (a_mode: INTEGER_32)
		do
			c_set_mode (c_pointer, a_mode)
		end

	set_detail (a_detail: INTEGER_32)
		do
			c_set_detail (c_pointer, a_detail)
		end

	set_focus (a_focus: INTEGER_32)
		do
			c_set_focus (c_pointer, a_focus)
		end

	set_state (a_state: NATURAL_32)
		do
			c_set_state (c_pointer, a_state)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkEventCrossing *)$tmp)->type;"
		end

	c_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GdkEventCrossing *)$tmp)->window;"
		end

	c_send_event (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct _GdkEventCrossing *)$tmp)->send_event;"
		end

	c_subwindow (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GdkEventCrossing *)$tmp)->subwindow;"
		end

	c_time (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkEventCrossing *)$tmp)->time;"
		end

	c_x (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct _GdkEventCrossing *)$tmp)->x;"
		end

	c_y (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct _GdkEventCrossing *)$tmp)->y;"
		end

	c_x_root (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct _GdkEventCrossing *)$tmp)->x_root;"
		end

	c_y_root (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct _GdkEventCrossing *)$tmp)->y_root;"
		end

	c_mode (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkEventCrossing *)$tmp)->mode;"
		end

	c_detail (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkEventCrossing *)$tmp)->detail;"
		end

	c_focus (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkEventCrossing *)$tmp)->focus;"
		end

	c_state (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkEventCrossing *)$tmp)->state;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkEventCrossing *)$tmp)->type = $a_type;"
		end

	c_set_window (tmp: POINTER; a_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkEventCrossing *)$tmp)->window = (struct _GdkDrawable *)$a_window;"
		end

	c_set_send_event (tmp: POINTER; a_send_event: INTEGER_8)
		external
			"C inline"
		alias
			"((struct _GdkEventCrossing *)$tmp)->send_event = $a_send_event;"
		end

	c_set_subwindow (tmp: POINTER; a_subwindow: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkEventCrossing *)$tmp)->subwindow = (struct _GdkDrawable *)$a_subwindow;"
		end

	c_set_time (tmp: POINTER; a_time: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkEventCrossing *)$tmp)->time = $a_time;"
		end

	c_set_x (tmp: POINTER; a_x: REAL_64)
		external
			"C inline"
		alias
			"((struct _GdkEventCrossing *)$tmp)->x = $a_x;"
		end

	c_set_y (tmp: POINTER; a_y: REAL_64)
		external
			"C inline"
		alias
			"((struct _GdkEventCrossing *)$tmp)->y = $a_y;"
		end

	c_set_x_root (tmp: POINTER; a_x_root: REAL_64)
		external
			"C inline"
		alias
			"((struct _GdkEventCrossing *)$tmp)->x_root = $a_x_root;"
		end

	c_set_y_root (tmp: POINTER; a_y_root: REAL_64)
		external
			"C inline"
		alias
			"((struct _GdkEventCrossing *)$tmp)->y_root = $a_y_root;"
		end

	c_set_mode (tmp: POINTER; a_mode: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkEventCrossing *)$tmp)->mode = $a_mode;"
		end

	c_set_detail (tmp: POINTER; a_detail: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkEventCrossing *)$tmp)->detail = $a_detail;"
		end

	c_set_focus (tmp: POINTER; a_focus: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkEventCrossing *)$tmp)->focus = $a_focus;"
		end

	c_set_state (tmp: POINTER; a_state: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkEventCrossing *)$tmp)->state = $a_state;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkEventCrossing);"
		end

end
