class
	SD_GDKEVENTDND

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window
		do
			create Result.make_shared (c_window (c_pointer))
		end

	send_event: INTEGER_8 assign set_send_event
		do
			Result := c_send_event (c_pointer)
		end

	context: CE_POINTER [SD_GDKDRAGCONTEXT] assign set_context
		do
			create Result.make_shared (c_context (c_pointer))
		end

	time: NATURAL_32 assign set_time
		do
			Result := c_time (c_pointer)
		end

	x_root: INTEGER_16 assign set_x_root
		do
			Result := c_x_root (c_pointer)
		end

	y_root: INTEGER_16 assign set_y_root
		do
			Result := c_y_root (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_window (c_pointer, a_window.c_pointer)
		end

	set_send_event (a_send_event: INTEGER_8)
		do
			c_set_send_event (c_pointer, a_send_event)
		end

	set_context (a_context: CE_POINTER [SD_GDKDRAGCONTEXT])
		do
			c_set_context (c_pointer, a_context.c_pointer)
		end

	set_time (a_time: NATURAL_32)
		do
			c_set_time (c_pointer, a_time)
		end

	set_x_root (a_x_root: INTEGER_16)
		do
			c_set_x_root (c_pointer, a_x_root)
		end

	set_y_root (a_y_root: INTEGER_16)
		do
			c_set_y_root (c_pointer, a_y_root)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkEventDND *)$tmp)->type;"
		end

	c_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GdkEventDND *)$tmp)->window;"
		end

	c_send_event (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct _GdkEventDND *)$tmp)->send_event;"
		end

	c_context (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDragContext *)((struct _GdkEventDND *)$tmp)->context;"
		end

	c_time (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkEventDND *)$tmp)->time;"
		end

	c_x_root (tmp: POINTER): INTEGER_16
		external
			"C inline"
		alias
			"return (short)((struct _GdkEventDND *)$tmp)->x_root;"
		end

	c_y_root (tmp: POINTER): INTEGER_16
		external
			"C inline"
		alias
			"return (short)((struct _GdkEventDND *)$tmp)->y_root;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkEventDND *)$tmp)->type = $a_type;"
		end

	c_set_window (tmp: POINTER; a_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkEventDND *)$tmp)->window = (struct _GdkDrawable *)$a_window;"
		end

	c_set_send_event (tmp: POINTER; a_send_event: INTEGER_8)
		external
			"C inline"
		alias
			"((struct _GdkEventDND *)$tmp)->send_event = $a_send_event;"
		end

	c_set_context (tmp: POINTER; a_context: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkEventDND *)$tmp)->context = (struct _GdkDragContext *)$a_context;"
		end

	c_set_time (tmp: POINTER; a_time: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkEventDND *)$tmp)->time = $a_time;"
		end

	c_set_x_root (tmp: POINTER; a_x_root: INTEGER_16)
		external
			"C inline"
		alias
			"((struct _GdkEventDND *)$tmp)->x_root = $a_x_root;"
		end

	c_set_y_root (tmp: POINTER; a_y_root: INTEGER_16)
		external
			"C inline"
		alias
			"((struct _GdkEventDND *)$tmp)->y_root = $a_y_root;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkEventDND);"
		end

end
