class
	SD_GDKEVENTKEY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window
		do
			create Result.make_shared (c_window (c_pointer))
		end

	send_event: INTEGER_8 assign set_send_event
		do
			Result := c_send_event (c_pointer)
		end

	time: NATURAL_32 assign set_time
		do
			Result := c_time (c_pointer)
		end

	state: NATURAL_32 assign set_state
		do
			Result := c_state (c_pointer)
		end

	keyval: NATURAL_32 assign set_keyval
		do
			Result := c_keyval (c_pointer)
		end

	length: INTEGER_32 assign set_length
		do
			Result := c_length (c_pointer)
		end

	string: CE_POINTER [INTEGER_8] assign set_string
		do
			create Result.make_shared (c_string (c_pointer))
		end

	hardware_keycode: NATURAL_16 assign set_hardware_keycode
		do
			Result := c_hardware_keycode (c_pointer)
		end

	group: NATURAL_8 assign set_group
		do
			Result := c_group (c_pointer)
		end

	is_modifier: NATURAL_32 assign set_is_modifier
		do
			Result := c_is_modifier (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_window (c_pointer, a_window.c_pointer)
		end

	set_send_event (a_send_event: INTEGER_8)
		do
			c_set_send_event (c_pointer, a_send_event)
		end

	set_time (a_time: NATURAL_32)
		do
			c_set_time (c_pointer, a_time)
		end

	set_state (a_state: NATURAL_32)
		do
			c_set_state (c_pointer, a_state)
		end

	set_keyval (a_keyval: NATURAL_32)
		do
			c_set_keyval (c_pointer, a_keyval)
		end

	set_length (a_length: INTEGER_32)
		do
			c_set_length (c_pointer, a_length)
		end

	set_string (a_string: CE_POINTER [INTEGER_8])
		do
			c_set_string (c_pointer, a_string.c_pointer)
		end

	set_hardware_keycode (a_hardware_keycode: NATURAL_16)
		do
			c_set_hardware_keycode (c_pointer, a_hardware_keycode)
		end

	set_group (a_group: NATURAL_8)
		do
			c_set_group (c_pointer, a_group)
		end

	set_is_modifier (a_is_modifier: NATURAL_32)
		do
			c_set_is_modifier (c_pointer, a_is_modifier)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkEventKey *)$tmp)->type;"
		end

	c_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GdkEventKey *)$tmp)->window;"
		end

	c_send_event (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct _GdkEventKey *)$tmp)->send_event;"
		end

	c_time (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkEventKey *)$tmp)->time;"
		end

	c_state (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkEventKey *)$tmp)->state;"
		end

	c_keyval (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkEventKey *)$tmp)->keyval;"
		end

	c_length (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkEventKey *)$tmp)->length;"
		end

	c_string (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GdkEventKey *)$tmp)->string;"
		end

	c_hardware_keycode (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GdkEventKey *)$tmp)->hardware_keycode;"
		end

	c_group (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct _GdkEventKey *)$tmp)->group;"
		end

	c_is_modifier (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkEventKey *)$tmp)->is_modifier;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkEventKey *)$tmp)->type = $a_type;"
		end

	c_set_window (tmp: POINTER; a_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkEventKey *)$tmp)->window = (struct _GdkDrawable *)$a_window;"
		end

	c_set_send_event (tmp: POINTER; a_send_event: INTEGER_8)
		external
			"C inline"
		alias
			"((struct _GdkEventKey *)$tmp)->send_event = $a_send_event;"
		end

	c_set_time (tmp: POINTER; a_time: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkEventKey *)$tmp)->time = $a_time;"
		end

	c_set_state (tmp: POINTER; a_state: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkEventKey *)$tmp)->state = $a_state;"
		end

	c_set_keyval (tmp: POINTER; a_keyval: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkEventKey *)$tmp)->keyval = $a_keyval;"
		end

	c_set_length (tmp: POINTER; a_length: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkEventKey *)$tmp)->length = $a_length;"
		end

	c_set_string (tmp: POINTER; a_string: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkEventKey *)$tmp)->string = (char *)$a_string;"
		end

	c_set_hardware_keycode (tmp: POINTER; a_hardware_keycode: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GdkEventKey *)$tmp)->hardware_keycode = $a_hardware_keycode;"
		end

	c_set_group (tmp: POINTER; a_group: NATURAL_8)
		external
			"C inline"
		alias
			"((struct _GdkEventKey *)$tmp)->group = $a_group;"
		end

	c_set_is_modifier (tmp: POINTER; a_is_modifier: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkEventKey *)$tmp)->is_modifier = $a_is_modifier;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkEventKey);"
		end

end
