class
	SD_GDKEVENTOWNERCHANGE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window
		do
			create Result.make_shared (c_window (c_pointer))
		end

	send_event: INTEGER_8 assign set_send_event
		do
			Result := c_send_event (c_pointer)
		end

	owner: NATURAL_32 assign set_owner
		do
			Result := c_owner (c_pointer)
		end

	reason: INTEGER_32 assign set_reason
		do
			Result := c_reason (c_pointer)
		end

	selection: CE_POINTER [ANY] assign set_selection
		do
			create Result.make_shared (c_selection (c_pointer))
		end

	time: NATURAL_32 assign set_time
		do
			Result := c_time (c_pointer)
		end

	selection_time: NATURAL_32 assign set_selection_time
		do
			Result := c_selection_time (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_window (c_pointer, a_window.c_pointer)
		end

	set_send_event (a_send_event: INTEGER_8)
		do
			c_set_send_event (c_pointer, a_send_event)
		end

	set_owner (a_owner: NATURAL_32)
		do
			c_set_owner (c_pointer, a_owner)
		end

	set_reason (a_reason: INTEGER_32)
		do
			c_set_reason (c_pointer, a_reason)
		end

	set_selection (a_selection: CE_POINTER [ANY])
		do
			c_set_selection (c_pointer, a_selection.c_pointer)
		end

	set_time (a_time: NATURAL_32)
		do
			c_set_time (c_pointer, a_time)
		end

	set_selection_time (a_selection_time: NATURAL_32)
		do
			c_set_selection_time (c_pointer, a_selection_time)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkEventOwnerChange *)$tmp)->type;"
		end

	c_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GdkEventOwnerChange *)$tmp)->window;"
		end

	c_send_event (tmp: POINTER): INTEGER_8
		external
			"C inline"
		alias
			"return (char)((struct _GdkEventOwnerChange *)$tmp)->send_event;"
		end

	c_owner (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkEventOwnerChange *)$tmp)->owner;"
		end

	c_reason (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkEventOwnerChange *)$tmp)->reason;"
		end

	c_selection (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GdkEventOwnerChange *)$tmp)->selection;"
		end

	c_time (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkEventOwnerChange *)$tmp)->time;"
		end

	c_selection_time (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkEventOwnerChange *)$tmp)->selection_time;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkEventOwnerChange *)$tmp)->type = $a_type;"
		end

	c_set_window (tmp: POINTER; a_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkEventOwnerChange *)$tmp)->window = (struct _GdkDrawable *)$a_window;"
		end

	c_set_send_event (tmp: POINTER; a_send_event: INTEGER_8)
		external
			"C inline"
		alias
			"((struct _GdkEventOwnerChange *)$tmp)->send_event = $a_send_event;"
		end

	c_set_owner (tmp: POINTER; a_owner: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkEventOwnerChange *)$tmp)->owner = $a_owner;"
		end

	c_set_reason (tmp: POINTER; a_reason: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkEventOwnerChange *)$tmp)->reason = $a_reason;"
		end

	c_set_selection (tmp: POINTER; a_selection: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkEventOwnerChange *)$tmp)->selection = (void *)$a_selection;"
		end

	c_set_time (tmp: POINTER; a_time: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkEventOwnerChange *)$tmp)->time = $a_time;"
		end

	c_set_selection_time (tmp: POINTER; a_selection_time: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkEventOwnerChange *)$tmp)->selection_time = $a_selection_time;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkEventOwnerChange);"
		end

end
