class
	SD_GDKFONT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	ascent: INTEGER_32 assign set_ascent
		do
			Result := c_ascent (c_pointer)
		end

	descent: INTEGER_32 assign set_descent
		do
			Result := c_descent (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_ascent (a_ascent: INTEGER_32)
		do
			c_set_ascent (c_pointer, a_ascent)
		end

	set_descent (a_descent: INTEGER_32)
		do
			c_set_descent (c_pointer, a_descent)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkFont *)$tmp)->type;"
		end

	c_ascent (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkFont *)$tmp)->ascent;"
		end

	c_descent (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkFont *)$tmp)->descent;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkFont *)$tmp)->type = $a_type;"
		end

	c_set_ascent (tmp: POINTER; a_ascent: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkFont *)$tmp)->ascent = $a_ascent;"
		end

	c_set_descent (tmp: POINTER; a_descent: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkFont *)$tmp)->descent = $a_descent;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkFont);"
		end

end
