class
	SD_GDKGC

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	parent_instance: SD_GOBJECT assign set_parent_instance
		do
			create Result.make_shared (c_parent_instance (c_pointer))
		end

	clip_x_origin: INTEGER_32 assign set_clip_x_origin
		do
			Result := c_clip_x_origin (c_pointer)
		end

	clip_y_origin: INTEGER_32 assign set_clip_y_origin
		do
			Result := c_clip_y_origin (c_pointer)
		end

	ts_x_origin: INTEGER_32 assign set_ts_x_origin
		do
			Result := c_ts_x_origin (c_pointer)
		end

	ts_y_origin: INTEGER_32 assign set_ts_y_origin
		do
			Result := c_ts_y_origin (c_pointer)
		end

	colormap: CE_POINTER [SD_GDKCOLORMAP] assign set_colormap
		do
			create Result.make_shared (c_colormap (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_parent_instance (a_parent_instance: SD_GOBJECT)
		do
			parent_instance.ce_gets (a_parent_instance)
		end

	set_clip_x_origin (a_clip_x_origin: INTEGER_32)
		do
			c_set_clip_x_origin (c_pointer, a_clip_x_origin)
		end

	set_clip_y_origin (a_clip_y_origin: INTEGER_32)
		do
			c_set_clip_y_origin (c_pointer, a_clip_y_origin)
		end

	set_ts_x_origin (a_ts_x_origin: INTEGER_32)
		do
			c_set_ts_x_origin (c_pointer, a_ts_x_origin)
		end

	set_ts_y_origin (a_ts_y_origin: INTEGER_32)
		do
			c_set_ts_y_origin (c_pointer, a_ts_y_origin)
		end

	set_colormap (a_colormap: CE_POINTER [SD_GDKCOLORMAP])
		do
			c_set_colormap (c_pointer, a_colormap.c_pointer)
		end

feature {NONE} -- C getters

	c_parent_instance (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GObject *)&((struct _GdkGC *)$tmp)->parent_instance;"
		end

	c_clip_x_origin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkGC *)$tmp)->clip_x_origin;"
		end

	c_clip_y_origin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkGC *)$tmp)->clip_y_origin;"
		end

	c_ts_x_origin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkGC *)$tmp)->ts_x_origin;"
		end

	c_ts_y_origin (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkGC *)$tmp)->ts_y_origin;"
		end

	c_colormap (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkColormap *)((struct _GdkGC *)$tmp)->colormap;"
		end

feature {NONE} -- C setters

	c_set_clip_x_origin (tmp: POINTER; a_clip_x_origin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkGC *)$tmp)->clip_x_origin = $a_clip_x_origin;"
		end

	c_set_clip_y_origin (tmp: POINTER; a_clip_y_origin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkGC *)$tmp)->clip_y_origin = $a_clip_y_origin;"
		end

	c_set_ts_x_origin (tmp: POINTER; a_ts_x_origin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkGC *)$tmp)->ts_x_origin = $a_ts_x_origin;"
		end

	c_set_ts_y_origin (tmp: POINTER; a_ts_y_origin: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkGC *)$tmp)->ts_y_origin = $a_ts_y_origin;"
		end

	c_set_colormap (tmp: POINTER; a_colormap: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkGC *)$tmp)->colormap = (struct _GdkColormap *)$a_colormap;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkGC);"
		end

end
