class
	SD_GDKGEOMETRY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	min_width: INTEGER_32 assign set_min_width
		do
			Result := c_min_width (c_pointer)
		end

	min_height: INTEGER_32 assign set_min_height
		do
			Result := c_min_height (c_pointer)
		end

	max_width: INTEGER_32 assign set_max_width
		do
			Result := c_max_width (c_pointer)
		end

	max_height: INTEGER_32 assign set_max_height
		do
			Result := c_max_height (c_pointer)
		end

	base_width: INTEGER_32 assign set_base_width
		do
			Result := c_base_width (c_pointer)
		end

	base_height: INTEGER_32 assign set_base_height
		do
			Result := c_base_height (c_pointer)
		end

	width_inc: INTEGER_32 assign set_width_inc
		do
			Result := c_width_inc (c_pointer)
		end

	height_inc: INTEGER_32 assign set_height_inc
		do
			Result := c_height_inc (c_pointer)
		end

	min_aspect: REAL_64 assign set_min_aspect
		do
			Result := c_min_aspect (c_pointer)
		end

	max_aspect: REAL_64 assign set_max_aspect
		do
			Result := c_max_aspect (c_pointer)
		end

	win_gravity: INTEGER_32 assign set_win_gravity
		do
			Result := c_win_gravity (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_min_width (a_min_width: INTEGER_32)
		do
			c_set_min_width (c_pointer, a_min_width)
		end

	set_min_height (a_min_height: INTEGER_32)
		do
			c_set_min_height (c_pointer, a_min_height)
		end

	set_max_width (a_max_width: INTEGER_32)
		do
			c_set_max_width (c_pointer, a_max_width)
		end

	set_max_height (a_max_height: INTEGER_32)
		do
			c_set_max_height (c_pointer, a_max_height)
		end

	set_base_width (a_base_width: INTEGER_32)
		do
			c_set_base_width (c_pointer, a_base_width)
		end

	set_base_height (a_base_height: INTEGER_32)
		do
			c_set_base_height (c_pointer, a_base_height)
		end

	set_width_inc (a_width_inc: INTEGER_32)
		do
			c_set_width_inc (c_pointer, a_width_inc)
		end

	set_height_inc (a_height_inc: INTEGER_32)
		do
			c_set_height_inc (c_pointer, a_height_inc)
		end

	set_min_aspect (a_min_aspect: REAL_64)
		do
			c_set_min_aspect (c_pointer, a_min_aspect)
		end

	set_max_aspect (a_max_aspect: REAL_64)
		do
			c_set_max_aspect (c_pointer, a_max_aspect)
		end

	set_win_gravity (a_win_gravity: INTEGER_32)
		do
			c_set_win_gravity (c_pointer, a_win_gravity)
		end

feature {NONE} -- C getters

	c_min_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkGeometry *)$tmp)->min_width;"
		end

	c_min_height (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkGeometry *)$tmp)->min_height;"
		end

	c_max_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkGeometry *)$tmp)->max_width;"
		end

	c_max_height (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkGeometry *)$tmp)->max_height;"
		end

	c_base_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkGeometry *)$tmp)->base_width;"
		end

	c_base_height (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkGeometry *)$tmp)->base_height;"
		end

	c_width_inc (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkGeometry *)$tmp)->width_inc;"
		end

	c_height_inc (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkGeometry *)$tmp)->height_inc;"
		end

	c_min_aspect (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct _GdkGeometry *)$tmp)->min_aspect;"
		end

	c_max_aspect (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct _GdkGeometry *)$tmp)->max_aspect;"
		end

	c_win_gravity (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkGeometry *)$tmp)->win_gravity;"
		end

feature {NONE} -- C setters

	c_set_min_width (tmp: POINTER; a_min_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkGeometry *)$tmp)->min_width = $a_min_width;"
		end

	c_set_min_height (tmp: POINTER; a_min_height: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkGeometry *)$tmp)->min_height = $a_min_height;"
		end

	c_set_max_width (tmp: POINTER; a_max_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkGeometry *)$tmp)->max_width = $a_max_width;"
		end

	c_set_max_height (tmp: POINTER; a_max_height: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkGeometry *)$tmp)->max_height = $a_max_height;"
		end

	c_set_base_width (tmp: POINTER; a_base_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkGeometry *)$tmp)->base_width = $a_base_width;"
		end

	c_set_base_height (tmp: POINTER; a_base_height: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkGeometry *)$tmp)->base_height = $a_base_height;"
		end

	c_set_width_inc (tmp: POINTER; a_width_inc: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkGeometry *)$tmp)->width_inc = $a_width_inc;"
		end

	c_set_height_inc (tmp: POINTER; a_height_inc: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkGeometry *)$tmp)->height_inc = $a_height_inc;"
		end

	c_set_min_aspect (tmp: POINTER; a_min_aspect: REAL_64)
		external
			"C inline"
		alias
			"((struct _GdkGeometry *)$tmp)->min_aspect = $a_min_aspect;"
		end

	c_set_max_aspect (tmp: POINTER; a_max_aspect: REAL_64)
		external
			"C inline"
		alias
			"((struct _GdkGeometry *)$tmp)->max_aspect = $a_max_aspect;"
		end

	c_set_win_gravity (tmp: POINTER; a_win_gravity: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkGeometry *)$tmp)->win_gravity = $a_win_gravity;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkGeometry);"
		end

end
