class
	SD_GDKIMAGE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	parent_instance: SD_GOBJECT assign set_parent_instance
		do
			create Result.make_shared (c_parent_instance (c_pointer))
		end

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	visual: CE_POINTER [SD_GDKVISUAL] assign set_visual
		do
			create Result.make_shared (c_visual (c_pointer))
		end

	byte_order: INTEGER_32 assign set_byte_order
		do
			Result := c_byte_order (c_pointer)
		end

	width: INTEGER_32 assign set_width
		do
			Result := c_width (c_pointer)
		end

	height: INTEGER_32 assign set_height
		do
			Result := c_height (c_pointer)
		end

	depth: NATURAL_16 assign set_depth
		do
			Result := c_depth (c_pointer)
		end

	bpp: NATURAL_16 assign set_bpp
		do
			Result := c_bpp (c_pointer)
		end

	bpl: NATURAL_16 assign set_bpl
		do
			Result := c_bpl (c_pointer)
		end

	bits_per_pixel: NATURAL_16 assign set_bits_per_pixel
		do
			Result := c_bits_per_pixel (c_pointer)
		end

	mem: CE_POINTER [ANY] assign set_mem
		do
			create Result.make_shared (c_mem (c_pointer))
		end

	colormap: CE_POINTER [SD_GDKCOLORMAP] assign set_colormap
		do
			create Result.make_shared (c_colormap (c_pointer))
		end

	windowing_data: CE_POINTER [ANY] assign set_windowing_data
		do
			create Result.make_shared (c_windowing_data (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_parent_instance (a_parent_instance: SD_GOBJECT)
		do
			parent_instance.ce_gets (a_parent_instance)
		end

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_visual (a_visual: CE_POINTER [SD_GDKVISUAL])
		do
			c_set_visual (c_pointer, a_visual.c_pointer)
		end

	set_byte_order (a_byte_order: INTEGER_32)
		do
			c_set_byte_order (c_pointer, a_byte_order)
		end

	set_width (a_width: INTEGER_32)
		do
			c_set_width (c_pointer, a_width)
		end

	set_height (a_height: INTEGER_32)
		do
			c_set_height (c_pointer, a_height)
		end

	set_depth (a_depth: NATURAL_16)
		do
			c_set_depth (c_pointer, a_depth)
		end

	set_bpp (a_bpp: NATURAL_16)
		do
			c_set_bpp (c_pointer, a_bpp)
		end

	set_bpl (a_bpl: NATURAL_16)
		do
			c_set_bpl (c_pointer, a_bpl)
		end

	set_bits_per_pixel (a_bits_per_pixel: NATURAL_16)
		do
			c_set_bits_per_pixel (c_pointer, a_bits_per_pixel)
		end

	set_mem (a_mem: CE_POINTER [ANY])
		do
			c_set_mem (c_pointer, a_mem.c_pointer)
		end

	set_colormap (a_colormap: CE_POINTER [SD_GDKCOLORMAP])
		do
			c_set_colormap (c_pointer, a_colormap.c_pointer)
		end

	set_windowing_data (a_windowing_data: CE_POINTER [ANY])
		do
			c_set_windowing_data (c_pointer, a_windowing_data.c_pointer)
		end

feature {NONE} -- C getters

	c_parent_instance (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GObject *)&((struct _GdkImage *)$tmp)->parent_instance;"
		end

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkImage *)$tmp)->type;"
		end

	c_visual (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkVisual *)((struct _GdkImage *)$tmp)->visual;"
		end

	c_byte_order (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkImage *)$tmp)->byte_order;"
		end

	c_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkImage *)$tmp)->width;"
		end

	c_height (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkImage *)$tmp)->height;"
		end

	c_depth (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GdkImage *)$tmp)->depth;"
		end

	c_bpp (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GdkImage *)$tmp)->bpp;"
		end

	c_bpl (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GdkImage *)$tmp)->bpl;"
		end

	c_bits_per_pixel (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GdkImage *)$tmp)->bits_per_pixel;"
		end

	c_mem (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GdkImage *)$tmp)->mem;"
		end

	c_colormap (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkColormap *)((struct _GdkImage *)$tmp)->colormap;"
		end

	c_windowing_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GdkImage *)$tmp)->windowing_data;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkImage *)$tmp)->type = $a_type;"
		end

	c_set_visual (tmp: POINTER; a_visual: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkImage *)$tmp)->visual = (struct _GdkVisual *)$a_visual;"
		end

	c_set_byte_order (tmp: POINTER; a_byte_order: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkImage *)$tmp)->byte_order = $a_byte_order;"
		end

	c_set_width (tmp: POINTER; a_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkImage *)$tmp)->width = $a_width;"
		end

	c_set_height (tmp: POINTER; a_height: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkImage *)$tmp)->height = $a_height;"
		end

	c_set_depth (tmp: POINTER; a_depth: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GdkImage *)$tmp)->depth = $a_depth;"
		end

	c_set_bpp (tmp: POINTER; a_bpp: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GdkImage *)$tmp)->bpp = $a_bpp;"
		end

	c_set_bpl (tmp: POINTER; a_bpl: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GdkImage *)$tmp)->bpl = $a_bpl;"
		end

	c_set_bits_per_pixel (tmp: POINTER; a_bits_per_pixel: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GdkImage *)$tmp)->bits_per_pixel = $a_bits_per_pixel;"
		end

	c_set_mem (tmp: POINTER; a_mem: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkImage *)$tmp)->mem = (void *)$a_mem;"
		end

	c_set_colormap (tmp: POINTER; a_colormap: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkImage *)$tmp)->colormap = (struct _GdkColormap *)$a_colormap;"
		end

	c_set_windowing_data (tmp: POINTER; a_windowing_data: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkImage *)$tmp)->windowing_data = (void *)$a_windowing_data;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkImage);"
		end

end
