class
	SD_GDKKEYBOARDGRABINFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window
		do
			create Result.make_shared (c_window (c_pointer))
		end

	native_window: CE_POINTER [SD_GDKDRAWABLE] assign set_native_window
		do
			create Result.make_shared (c_native_window (c_pointer))
		end

	serial: NATURAL_32 assign set_serial
		do
			Result := c_serial (c_pointer)
		end

	owner_events: INTEGER_32 assign set_owner_events
		do
			Result := c_owner_events (c_pointer)
		end

	time: NATURAL_32 assign set_time
		do
			Result := c_time (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_window (c_pointer, a_window.c_pointer)
		end

	set_native_window (a_native_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_native_window (c_pointer, a_native_window.c_pointer)
		end

	set_serial (a_serial: NATURAL_32)
		do
			c_set_serial (c_pointer, a_serial)
		end

	set_owner_events (a_owner_events: INTEGER_32)
		do
			c_set_owner_events (c_pointer, a_owner_events)
		end

	set_time (a_time: NATURAL_32)
		do
			c_set_time (c_pointer, a_time)
		end

feature {NONE} -- C getters

	c_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct __anonstruct_GdkKeyboardGrabInfo_238 *)$tmp)->window;"
		end

	c_native_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct __anonstruct_GdkKeyboardGrabInfo_238 *)$tmp)->native_window;"
		end

	c_serial (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_GdkKeyboardGrabInfo_238 *)$tmp)->serial;"
		end

	c_owner_events (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_GdkKeyboardGrabInfo_238 *)$tmp)->owner_events;"
		end

	c_time (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_GdkKeyboardGrabInfo_238 *)$tmp)->time;"
		end

feature {NONE} -- C setters

	c_set_window (tmp: POINTER; a_window: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_GdkKeyboardGrabInfo_238 *)$tmp)->window = (struct _GdkDrawable *)$a_window;"
		end

	c_set_native_window (tmp: POINTER; a_native_window: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_GdkKeyboardGrabInfo_238 *)$tmp)->native_window = (struct _GdkDrawable *)$a_native_window;"
		end

	c_set_serial (tmp: POINTER; a_serial: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_GdkKeyboardGrabInfo_238 *)$tmp)->serial = $a_serial;"
		end

	c_set_owner_events (tmp: POINTER; a_owner_events: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_GdkKeyboardGrabInfo_238 *)$tmp)->owner_events = $a_owner_events;"
		end

	c_set_time (tmp: POINTER; a_time: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_GdkKeyboardGrabInfo_238 *)$tmp)->time = $a_time;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_GdkKeyboardGrabInfo_238);"
		end

end
