class
	SD_GDKPOINTERWINDOWINFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	toplevel_under_pointer: CE_POINTER [SD_GDKDRAWABLE] assign set_toplevel_under_pointer
		do
			create Result.make_shared (c_toplevel_under_pointer (c_pointer))
		end

	window_under_pointer: CE_POINTER [SD_GDKDRAWABLE] assign set_window_under_pointer
		do
			create Result.make_shared (c_window_under_pointer (c_pointer))
		end

	toplevel_x: REAL_64 assign set_toplevel_x
		do
			Result := c_toplevel_x (c_pointer)
		end

	toplevel_y: REAL_64 assign set_toplevel_y
		do
			Result := c_toplevel_y (c_pointer)
		end

	state: NATURAL_32 assign set_state
		do
			Result := c_state (c_pointer)
		end

	button: NATURAL_32 assign set_button
		do
			Result := c_button (c_pointer)
		end

	motion_hint_serial: NATURAL_32 assign set_motion_hint_serial
		do
			Result := c_motion_hint_serial (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_toplevel_under_pointer (a_toplevel_under_pointer: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_toplevel_under_pointer (c_pointer, a_toplevel_under_pointer.c_pointer)
		end

	set_window_under_pointer (a_window_under_pointer: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_window_under_pointer (c_pointer, a_window_under_pointer.c_pointer)
		end

	set_toplevel_x (a_toplevel_x: REAL_64)
		do
			c_set_toplevel_x (c_pointer, a_toplevel_x)
		end

	set_toplevel_y (a_toplevel_y: REAL_64)
		do
			c_set_toplevel_y (c_pointer, a_toplevel_y)
		end

	set_state (a_state: NATURAL_32)
		do
			c_set_state (c_pointer, a_state)
		end

	set_button (a_button: NATURAL_32)
		do
			c_set_button (c_pointer, a_button)
		end

	set_motion_hint_serial (a_motion_hint_serial: NATURAL_32)
		do
			c_set_motion_hint_serial (c_pointer, a_motion_hint_serial)
		end

feature {NONE} -- C getters

	c_toplevel_under_pointer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct __anonstruct_GdkPointerWindowInfo_239 *)$tmp)->toplevel_under_pointer;"
		end

	c_window_under_pointer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct __anonstruct_GdkPointerWindowInfo_239 *)$tmp)->window_under_pointer;"
		end

	c_toplevel_x (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_GdkPointerWindowInfo_239 *)$tmp)->toplevel_x;"
		end

	c_toplevel_y (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_GdkPointerWindowInfo_239 *)$tmp)->toplevel_y;"
		end

	c_state (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_GdkPointerWindowInfo_239 *)$tmp)->state;"
		end

	c_button (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_GdkPointerWindowInfo_239 *)$tmp)->button;"
		end

	c_motion_hint_serial (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_GdkPointerWindowInfo_239 *)$tmp)->motion_hint_serial;"
		end

feature {NONE} -- C setters

	c_set_toplevel_under_pointer (tmp: POINTER; a_toplevel_under_pointer: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_GdkPointerWindowInfo_239 *)$tmp)->toplevel_under_pointer = (struct _GdkDrawable *)$a_toplevel_under_pointer;"
		end

	c_set_window_under_pointer (tmp: POINTER; a_window_under_pointer: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_GdkPointerWindowInfo_239 *)$tmp)->window_under_pointer = (struct _GdkDrawable *)$a_window_under_pointer;"
		end

	c_set_toplevel_x (tmp: POINTER; a_toplevel_x: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_GdkPointerWindowInfo_239 *)$tmp)->toplevel_x = $a_toplevel_x;"
		end

	c_set_toplevel_y (tmp: POINTER; a_toplevel_y: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_GdkPointerWindowInfo_239 *)$tmp)->toplevel_y = $a_toplevel_y;"
		end

	c_set_state (tmp: POINTER; a_state: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_GdkPointerWindowInfo_239 *)$tmp)->state = $a_state;"
		end

	c_set_button (tmp: POINTER; a_button: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_GdkPointerWindowInfo_239 *)$tmp)->button = $a_button;"
		end

	c_set_motion_hint_serial (tmp: POINTER; a_motion_hint_serial: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_GdkPointerWindowInfo_239 *)$tmp)->motion_hint_serial = $a_motion_hint_serial;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_GdkPointerWindowInfo_239);"
		end

end
