class
	SD_GDKVISUAL

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	parent_instance: SD_GOBJECT assign set_parent_instance
		do
			create Result.make_shared (c_parent_instance (c_pointer))
		end

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	depth: INTEGER_32 assign set_depth
		do
			Result := c_depth (c_pointer)
		end

	byte_order: INTEGER_32 assign set_byte_order
		do
			Result := c_byte_order (c_pointer)
		end

	colormap_size: INTEGER_32 assign set_colormap_size
		do
			Result := c_colormap_size (c_pointer)
		end

	bits_per_rgb: INTEGER_32 assign set_bits_per_rgb
		do
			Result := c_bits_per_rgb (c_pointer)
		end

	red_mask: NATURAL_32 assign set_red_mask
		do
			Result := c_red_mask (c_pointer)
		end

	red_shift: INTEGER_32 assign set_red_shift
		do
			Result := c_red_shift (c_pointer)
		end

	red_prec: INTEGER_32 assign set_red_prec
		do
			Result := c_red_prec (c_pointer)
		end

	green_mask: NATURAL_32 assign set_green_mask
		do
			Result := c_green_mask (c_pointer)
		end

	green_shift: INTEGER_32 assign set_green_shift
		do
			Result := c_green_shift (c_pointer)
		end

	green_prec: INTEGER_32 assign set_green_prec
		do
			Result := c_green_prec (c_pointer)
		end

	blue_mask: NATURAL_32 assign set_blue_mask
		do
			Result := c_blue_mask (c_pointer)
		end

	blue_shift: INTEGER_32 assign set_blue_shift
		do
			Result := c_blue_shift (c_pointer)
		end

	blue_prec: INTEGER_32 assign set_blue_prec
		do
			Result := c_blue_prec (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_parent_instance (a_parent_instance: SD_GOBJECT)
		do
			parent_instance.ce_gets (a_parent_instance)
		end

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_depth (a_depth: INTEGER_32)
		do
			c_set_depth (c_pointer, a_depth)
		end

	set_byte_order (a_byte_order: INTEGER_32)
		do
			c_set_byte_order (c_pointer, a_byte_order)
		end

	set_colormap_size (a_colormap_size: INTEGER_32)
		do
			c_set_colormap_size (c_pointer, a_colormap_size)
		end

	set_bits_per_rgb (a_bits_per_rgb: INTEGER_32)
		do
			c_set_bits_per_rgb (c_pointer, a_bits_per_rgb)
		end

	set_red_mask (a_red_mask: NATURAL_32)
		do
			c_set_red_mask (c_pointer, a_red_mask)
		end

	set_red_shift (a_red_shift: INTEGER_32)
		do
			c_set_red_shift (c_pointer, a_red_shift)
		end

	set_red_prec (a_red_prec: INTEGER_32)
		do
			c_set_red_prec (c_pointer, a_red_prec)
		end

	set_green_mask (a_green_mask: NATURAL_32)
		do
			c_set_green_mask (c_pointer, a_green_mask)
		end

	set_green_shift (a_green_shift: INTEGER_32)
		do
			c_set_green_shift (c_pointer, a_green_shift)
		end

	set_green_prec (a_green_prec: INTEGER_32)
		do
			c_set_green_prec (c_pointer, a_green_prec)
		end

	set_blue_mask (a_blue_mask: NATURAL_32)
		do
			c_set_blue_mask (c_pointer, a_blue_mask)
		end

	set_blue_shift (a_blue_shift: INTEGER_32)
		do
			c_set_blue_shift (c_pointer, a_blue_shift)
		end

	set_blue_prec (a_blue_prec: INTEGER_32)
		do
			c_set_blue_prec (c_pointer, a_blue_prec)
		end

feature {NONE} -- C getters

	c_parent_instance (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GObject *)&((struct _GdkVisual *)$tmp)->parent_instance;"
		end

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkVisual *)$tmp)->type;"
		end

	c_depth (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkVisual *)$tmp)->depth;"
		end

	c_byte_order (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkVisual *)$tmp)->byte_order;"
		end

	c_colormap_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkVisual *)$tmp)->colormap_size;"
		end

	c_bits_per_rgb (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkVisual *)$tmp)->bits_per_rgb;"
		end

	c_red_mask (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkVisual *)$tmp)->red_mask;"
		end

	c_red_shift (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkVisual *)$tmp)->red_shift;"
		end

	c_red_prec (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkVisual *)$tmp)->red_prec;"
		end

	c_green_mask (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkVisual *)$tmp)->green_mask;"
		end

	c_green_shift (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkVisual *)$tmp)->green_shift;"
		end

	c_green_prec (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkVisual *)$tmp)->green_prec;"
		end

	c_blue_mask (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GdkVisual *)$tmp)->blue_mask;"
		end

	c_blue_shift (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkVisual *)$tmp)->blue_shift;"
		end

	c_blue_prec (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkVisual *)$tmp)->blue_prec;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkVisual *)$tmp)->type = $a_type;"
		end

	c_set_depth (tmp: POINTER; a_depth: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkVisual *)$tmp)->depth = $a_depth;"
		end

	c_set_byte_order (tmp: POINTER; a_byte_order: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkVisual *)$tmp)->byte_order = $a_byte_order;"
		end

	c_set_colormap_size (tmp: POINTER; a_colormap_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkVisual *)$tmp)->colormap_size = $a_colormap_size;"
		end

	c_set_bits_per_rgb (tmp: POINTER; a_bits_per_rgb: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkVisual *)$tmp)->bits_per_rgb = $a_bits_per_rgb;"
		end

	c_set_red_mask (tmp: POINTER; a_red_mask: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkVisual *)$tmp)->red_mask = $a_red_mask;"
		end

	c_set_red_shift (tmp: POINTER; a_red_shift: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkVisual *)$tmp)->red_shift = $a_red_shift;"
		end

	c_set_red_prec (tmp: POINTER; a_red_prec: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkVisual *)$tmp)->red_prec = $a_red_prec;"
		end

	c_set_green_mask (tmp: POINTER; a_green_mask: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkVisual *)$tmp)->green_mask = $a_green_mask;"
		end

	c_set_green_shift (tmp: POINTER; a_green_shift: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkVisual *)$tmp)->green_shift = $a_green_shift;"
		end

	c_set_green_prec (tmp: POINTER; a_green_prec: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkVisual *)$tmp)->green_prec = $a_green_prec;"
		end

	c_set_blue_mask (tmp: POINTER; a_blue_mask: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GdkVisual *)$tmp)->blue_mask = $a_blue_mask;"
		end

	c_set_blue_shift (tmp: POINTER; a_blue_shift: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkVisual *)$tmp)->blue_shift = $a_blue_shift;"
		end

	c_set_blue_prec (tmp: POINTER; a_blue_prec: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkVisual *)$tmp)->blue_prec = $a_blue_prec;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkVisual);"
		end

end
