class
	SD_GDKWINDOWATTR

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	title: CE_POINTER [INTEGER_8] assign set_title
		do
			create Result.make_shared (c_title (c_pointer))
		end

	event_mask: INTEGER_32 assign set_event_mask
		do
			Result := c_event_mask (c_pointer)
		end

	x: INTEGER_32 assign set_x
		do
			Result := c_x (c_pointer)
		end

	y: INTEGER_32 assign set_y
		do
			Result := c_y (c_pointer)
		end

	width: INTEGER_32 assign set_width
		do
			Result := c_width (c_pointer)
		end

	height: INTEGER_32 assign set_height
		do
			Result := c_height (c_pointer)
		end

	wclass: INTEGER_32 assign set_wclass
		do
			Result := c_wclass (c_pointer)
		end

	visual: CE_POINTER [SD_GDKVISUAL] assign set_visual
		do
			create Result.make_shared (c_visual (c_pointer))
		end

	colormap: CE_POINTER [SD_GDKCOLORMAP] assign set_colormap
		do
			create Result.make_shared (c_colormap (c_pointer))
		end

	window_type: INTEGER_32 assign set_window_type
		do
			Result := c_window_type (c_pointer)
		end

	cursor: CE_POINTER [SD_GDKCURSOR] assign set_cursor
		do
			create Result.make_shared (c_cursor (c_pointer))
		end

	wmclass_name: CE_POINTER [INTEGER_8] assign set_wmclass_name
		do
			create Result.make_shared (c_wmclass_name (c_pointer))
		end

	wmclass_class: CE_POINTER [INTEGER_8] assign set_wmclass_class
		do
			create Result.make_shared (c_wmclass_class (c_pointer))
		end

	override_redirect: INTEGER_32 assign set_override_redirect
		do
			Result := c_override_redirect (c_pointer)
		end

	type_hint: INTEGER_32 assign set_type_hint
		do
			Result := c_type_hint (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_title (a_title: CE_POINTER [INTEGER_8])
		do
			c_set_title (c_pointer, a_title.c_pointer)
		end

	set_event_mask (a_event_mask: INTEGER_32)
		do
			c_set_event_mask (c_pointer, a_event_mask)
		end

	set_x (a_x: INTEGER_32)
		do
			c_set_x (c_pointer, a_x)
		end

	set_y (a_y: INTEGER_32)
		do
			c_set_y (c_pointer, a_y)
		end

	set_width (a_width: INTEGER_32)
		do
			c_set_width (c_pointer, a_width)
		end

	set_height (a_height: INTEGER_32)
		do
			c_set_height (c_pointer, a_height)
		end

	set_wclass (a_wclass: INTEGER_32)
		do
			c_set_wclass (c_pointer, a_wclass)
		end

	set_visual (a_visual: CE_POINTER [SD_GDKVISUAL])
		do
			c_set_visual (c_pointer, a_visual.c_pointer)
		end

	set_colormap (a_colormap: CE_POINTER [SD_GDKCOLORMAP])
		do
			c_set_colormap (c_pointer, a_colormap.c_pointer)
		end

	set_window_type (a_window_type: INTEGER_32)
		do
			c_set_window_type (c_pointer, a_window_type)
		end

	set_cursor (a_cursor: CE_POINTER [SD_GDKCURSOR])
		do
			c_set_cursor (c_pointer, a_cursor.c_pointer)
		end

	set_wmclass_name (a_wmclass_name: CE_POINTER [INTEGER_8])
		do
			c_set_wmclass_name (c_pointer, a_wmclass_name.c_pointer)
		end

	set_wmclass_class (a_wmclass_class: CE_POINTER [INTEGER_8])
		do
			c_set_wmclass_class (c_pointer, a_wmclass_class.c_pointer)
		end

	set_override_redirect (a_override_redirect: INTEGER_32)
		do
			c_set_override_redirect (c_pointer, a_override_redirect)
		end

	set_type_hint (a_type_hint: INTEGER_32)
		do
			c_set_type_hint (c_pointer, a_type_hint)
		end

feature {NONE} -- C getters

	c_title (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GdkWindowAttr *)$tmp)->title;"
		end

	c_event_mask (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkWindowAttr *)$tmp)->event_mask;"
		end

	c_x (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkWindowAttr *)$tmp)->x;"
		end

	c_y (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkWindowAttr *)$tmp)->y;"
		end

	c_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkWindowAttr *)$tmp)->width;"
		end

	c_height (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkWindowAttr *)$tmp)->height;"
		end

	c_wclass (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkWindowAttr *)$tmp)->wclass;"
		end

	c_visual (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkVisual *)((struct _GdkWindowAttr *)$tmp)->visual;"
		end

	c_colormap (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkColormap *)((struct _GdkWindowAttr *)$tmp)->colormap;"
		end

	c_window_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkWindowAttr *)$tmp)->window_type;"
		end

	c_cursor (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkCursor *)((struct _GdkWindowAttr *)$tmp)->cursor;"
		end

	c_wmclass_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GdkWindowAttr *)$tmp)->wmclass_name;"
		end

	c_wmclass_class (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GdkWindowAttr *)$tmp)->wmclass_class;"
		end

	c_override_redirect (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkWindowAttr *)$tmp)->override_redirect;"
		end

	c_type_hint (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GdkWindowAttr *)$tmp)->type_hint;"
		end

feature {NONE} -- C setters

	c_set_title (tmp: POINTER; a_title: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkWindowAttr *)$tmp)->title = (char *)$a_title;"
		end

	c_set_event_mask (tmp: POINTER; a_event_mask: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkWindowAttr *)$tmp)->event_mask = $a_event_mask;"
		end

	c_set_x (tmp: POINTER; a_x: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkWindowAttr *)$tmp)->x = $a_x;"
		end

	c_set_y (tmp: POINTER; a_y: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkWindowAttr *)$tmp)->y = $a_y;"
		end

	c_set_width (tmp: POINTER; a_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkWindowAttr *)$tmp)->width = $a_width;"
		end

	c_set_height (tmp: POINTER; a_height: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkWindowAttr *)$tmp)->height = $a_height;"
		end

	c_set_wclass (tmp: POINTER; a_wclass: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkWindowAttr *)$tmp)->wclass = $a_wclass;"
		end

	c_set_visual (tmp: POINTER; a_visual: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkWindowAttr *)$tmp)->visual = (struct _GdkVisual *)$a_visual;"
		end

	c_set_colormap (tmp: POINTER; a_colormap: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkWindowAttr *)$tmp)->colormap = (struct _GdkColormap *)$a_colormap;"
		end

	c_set_window_type (tmp: POINTER; a_window_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkWindowAttr *)$tmp)->window_type = $a_window_type;"
		end

	c_set_cursor (tmp: POINTER; a_cursor: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkWindowAttr *)$tmp)->cursor = (struct _GdkCursor *)$a_cursor;"
		end

	c_set_wmclass_name (tmp: POINTER; a_wmclass_name: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkWindowAttr *)$tmp)->wmclass_name = (char *)$a_wmclass_name;"
		end

	c_set_wmclass_class (tmp: POINTER; a_wmclass_class: POINTER)
		external
			"C inline"
		alias
			"((struct _GdkWindowAttr *)$tmp)->wmclass_class = (char *)$a_wmclass_class;"
		end

	c_set_override_redirect (tmp: POINTER; a_override_redirect: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkWindowAttr *)$tmp)->override_redirect = $a_override_redirect;"
		end

	c_set_type_hint (tmp: POINTER; a_type_hint: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GdkWindowAttr *)$tmp)->type_hint = $a_type_hint;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GdkWindowAttr);"
		end

end
