class
	SD_GOBJECT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	g_type_instance: SD_GTYPEINSTANCE assign set_g_type_instance
		do
			create Result.make_shared (c_g_type_instance (c_pointer))
		end

	ref_count: NATURAL_32 assign set_ref_count
		do
			Result := c_ref_count (c_pointer)
		end

	qdata: CE_POINTER [ANY] assign set_qdata
		do
			create Result.make_shared (c_qdata (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_g_type_instance (a_g_type_instance: SD_GTYPEINSTANCE)
		do
			g_type_instance.ce_gets (a_g_type_instance)
		end

	set_ref_count (a_ref_count: NATURAL_32)
		do
			c_set_ref_count (c_pointer, a_ref_count)
		end

	set_qdata (a_qdata: CE_POINTER [ANY])
		do
			c_set_qdata (c_pointer, a_qdata.c_pointer)
		end

feature {NONE} -- C getters

	c_g_type_instance (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GTypeInstance *)&((struct _GObject *)$tmp)->g_type_instance;"
		end

	c_ref_count (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GObject *)$tmp)->ref_count;"
		end

	c_qdata (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GObject *)$tmp)->qdata;"
		end

feature {NONE} -- C setters

	c_set_ref_count (tmp: POINTER; a_ref_count: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GObject *)$tmp)->ref_count = $a_ref_count;"
		end

	c_set_qdata (tmp: POINTER; a_qdata: POINTER)
		external
			"C inline"
		alias
			"((struct _GObject *)$tmp)->qdata = (void *)$a_qdata;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GObject);"
		end

end
