class
	SD_GPARAMSPEC

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	g_type_instance: SD_GTYPEINSTANCE assign set_g_type_instance
		do
			create Result.make_shared (c_g_type_instance (c_pointer))
		end

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	flags: INTEGER_32 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

	value_type: NATURAL_32 assign set_value_type
		do
			Result := c_value_type (c_pointer)
		end

	owner_type: NATURAL_32 assign set_owner_type
		do
			Result := c_owner_type (c_pointer)
		end

	nick: CE_POINTER [INTEGER_8] assign set_nick
		do
			create Result.make_shared (c_nick (c_pointer))
		end

	blurb: CE_POINTER [INTEGER_8] assign set_blurb
		do
			create Result.make_shared (c_blurb (c_pointer))
		end

	qdata: CE_POINTER [ANY] assign set_qdata
		do
			create Result.make_shared (c_qdata (c_pointer))
		end

	ref_count: NATURAL_32 assign set_ref_count
		do
			Result := c_ref_count (c_pointer)
		end

	param_id: NATURAL_32 assign set_param_id
		do
			Result := c_param_id (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_g_type_instance (a_g_type_instance: SD_GTYPEINSTANCE)
		do
			g_type_instance.ce_gets (a_g_type_instance)
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_flags (a_flags: INTEGER_32)
		do
			c_set_flags (c_pointer, a_flags)
		end

	set_value_type (a_value_type: NATURAL_32)
		do
			c_set_value_type (c_pointer, a_value_type)
		end

	set_owner_type (a_owner_type: NATURAL_32)
		do
			c_set_owner_type (c_pointer, a_owner_type)
		end

	set_nick (a_nick: CE_POINTER [INTEGER_8])
		do
			c_set_nick (c_pointer, a_nick.c_pointer)
		end

	set_blurb (a_blurb: CE_POINTER [INTEGER_8])
		do
			c_set_blurb (c_pointer, a_blurb.c_pointer)
		end

	set_qdata (a_qdata: CE_POINTER [ANY])
		do
			c_set_qdata (c_pointer, a_qdata.c_pointer)
		end

	set_ref_count (a_ref_count: NATURAL_32)
		do
			c_set_ref_count (c_pointer, a_ref_count)
		end

	set_param_id (a_param_id: NATURAL_32)
		do
			c_set_param_id (c_pointer, a_param_id)
		end

feature {NONE} -- C getters

	c_g_type_instance (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GTypeInstance *)&((struct _GParamSpec *)$tmp)->g_type_instance;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GParamSpec *)$tmp)->name;"
		end

	c_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GParamSpec *)$tmp)->flags;"
		end

	c_value_type (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GParamSpec *)$tmp)->value_type;"
		end

	c_owner_type (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GParamSpec *)$tmp)->owner_type;"
		end

	c_nick (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GParamSpec *)$tmp)->_nick;"
		end

	c_blurb (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GParamSpec *)$tmp)->_blurb;"
		end

	c_qdata (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GParamSpec *)$tmp)->qdata;"
		end

	c_ref_count (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GParamSpec *)$tmp)->ref_count;"
		end

	c_param_id (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GParamSpec *)$tmp)->param_id;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct _GParamSpec *)$tmp)->name = (char *)$a_name;"
		end

	c_set_flags (tmp: POINTER; a_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GParamSpec *)$tmp)->flags = $a_flags;"
		end

	c_set_value_type (tmp: POINTER; a_value_type: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GParamSpec *)$tmp)->value_type = $a_value_type;"
		end

	c_set_owner_type (tmp: POINTER; a_owner_type: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GParamSpec *)$tmp)->owner_type = $a_owner_type;"
		end

	c_set_nick (tmp: POINTER; a_nick: POINTER)
		external
			"C inline"
		alias
			"((struct _GParamSpec *)$tmp)->_nick = (char *)$a_nick;"
		end

	c_set_blurb (tmp: POINTER; a_blurb: POINTER)
		external
			"C inline"
		alias
			"((struct _GParamSpec *)$tmp)->_blurb = (char *)$a_blurb;"
		end

	c_set_qdata (tmp: POINTER; a_qdata: POINTER)
		external
			"C inline"
		alias
			"((struct _GParamSpec *)$tmp)->qdata = (void *)$a_qdata;"
		end

	c_set_ref_count (tmp: POINTER; a_ref_count: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GParamSpec *)$tmp)->ref_count = $a_ref_count;"
		end

	c_set_param_id (tmp: POINTER; a_param_id: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GParamSpec *)$tmp)->param_id = $a_param_id;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GParamSpec);"
		end

end
