class
	SD_GTKACCELKEY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	accel_key: NATURAL_32 assign set_accel_key
		do
			Result := c_accel_key (c_pointer)
		end

	accel_mods: INTEGER_32 assign set_accel_mods
		do
			Result := c_accel_mods (c_pointer)
		end

	accel_flags: NATURAL_32 assign set_accel_flags
		do
			Result := c_accel_flags (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_accel_key (a_accel_key: NATURAL_32)
		do
			c_set_accel_key (c_pointer, a_accel_key)
		end

	set_accel_mods (a_accel_mods: INTEGER_32)
		do
			c_set_accel_mods (c_pointer, a_accel_mods)
		end

	set_accel_flags (a_accel_flags: NATURAL_32)
		do
			c_set_accel_flags (c_pointer, a_accel_flags)
		end

feature {NONE} -- C getters

	c_accel_key (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkAccelKey *)$tmp)->accel_key;"
		end

	c_accel_mods (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkAccelKey *)$tmp)->accel_mods;"
		end

	c_accel_flags (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkAccelKey *)$tmp)->accel_flags;"
		end

feature {NONE} -- C setters

	c_set_accel_key (tmp: POINTER; a_accel_key: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkAccelKey *)$tmp)->accel_key = $a_accel_key;"
		end

	c_set_accel_mods (tmp: POINTER; a_accel_mods: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkAccelKey *)$tmp)->accel_mods = $a_accel_mods;"
		end

	c_set_accel_flags (tmp: POINTER; a_accel_flags: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkAccelKey *)$tmp)->accel_flags = $a_accel_flags;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkAccelKey);"
		end

end
