class
	SD_GTKARG

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: NATURAL_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	d: SD_D assign set_d
		do
			create Result.make_shared (c_d (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: NATURAL_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_d (a_d: SD_D)
		do
			d.ce_gets (a_d)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkArg *)$tmp)->type;"
		end

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GtkArg *)$tmp)->name;"
		end

	c_d (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (union __anonunion_d_306 *)&((struct _GtkArg *)$tmp)->d;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkArg *)$tmp)->type = $a_type;"
		end

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkArg *)$tmp)->name = (char *)$a_name;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkArg);"
		end

end
