class
	SD_GTKBIN

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	container: SD_GTKCONTAINER assign set_container
		do
			create Result.make_shared (c_container (c_pointer))
		end

	child: CE_POINTER [SD_GTKWIDGET] assign set_child
		do
			create Result.make_shared (c_child (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_container (a_container: SD_GTKCONTAINER)
		do
			container.ce_gets (a_container)
		end

	set_child (a_child: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_child (c_pointer, a_child.c_pointer)
		end

feature {NONE} -- C getters

	c_container (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkContainer *)&((struct _GtkBin *)$tmp)->container;"
		end

	c_child (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkBin *)$tmp)->child;"
		end

feature {NONE} -- C setters

	c_set_child (tmp: POINTER; a_child: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkBin *)$tmp)->child = (struct _GtkWidget *)$a_child;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkBin);"
		end

end
