class
	SD_GTKFONTSELECTIONDIALOG

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	parent_instance: SD_GTKDIALOG assign set_parent_instance
		do
			create Result.make_shared (c_parent_instance (c_pointer))
		end

	fontsel: CE_POINTER [SD_GTKWIDGET] assign set_fontsel
		do
			create Result.make_shared (c_fontsel (c_pointer))
		end

	main_vbox: CE_POINTER [SD_GTKWIDGET] assign set_main_vbox
		do
			create Result.make_shared (c_main_vbox (c_pointer))
		end

	action_area: CE_POINTER [SD_GTKWIDGET] assign set_action_area
		do
			create Result.make_shared (c_action_area (c_pointer))
		end

	ok_button: CE_POINTER [SD_GTKWIDGET] assign set_ok_button
		do
			create Result.make_shared (c_ok_button (c_pointer))
		end

	apply_button: CE_POINTER [SD_GTKWIDGET] assign set_apply_button
		do
			create Result.make_shared (c_apply_button (c_pointer))
		end

	cancel_button: CE_POINTER [SD_GTKWIDGET] assign set_cancel_button
		do
			create Result.make_shared (c_cancel_button (c_pointer))
		end

	dialog_width: INTEGER_32 assign set_dialog_width
		do
			Result := c_dialog_width (c_pointer)
		end

	auto_resize: INTEGER_32 assign set_auto_resize
		do
			Result := c_auto_resize (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_parent_instance (a_parent_instance: SD_GTKDIALOG)
		do
			parent_instance.ce_gets (a_parent_instance)
		end

	set_fontsel (a_fontsel: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_fontsel (c_pointer, a_fontsel.c_pointer)
		end

	set_main_vbox (a_main_vbox: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_main_vbox (c_pointer, a_main_vbox.c_pointer)
		end

	set_action_area (a_action_area: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_action_area (c_pointer, a_action_area.c_pointer)
		end

	set_ok_button (a_ok_button: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_ok_button (c_pointer, a_ok_button.c_pointer)
		end

	set_apply_button (a_apply_button: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_apply_button (c_pointer, a_apply_button.c_pointer)
		end

	set_cancel_button (a_cancel_button: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_cancel_button (c_pointer, a_cancel_button.c_pointer)
		end

	set_dialog_width (a_dialog_width: INTEGER_32)
		do
			c_set_dialog_width (c_pointer, a_dialog_width)
		end

	set_auto_resize (a_auto_resize: INTEGER_32)
		do
			c_set_auto_resize (c_pointer, a_auto_resize)
		end

feature {NONE} -- C getters

	c_parent_instance (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkDialog *)&((struct _GtkFontSelectionDialog *)$tmp)->parent_instance;"
		end

	c_fontsel (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkFontSelectionDialog *)$tmp)->fontsel;"
		end

	c_main_vbox (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkFontSelectionDialog *)$tmp)->main_vbox;"
		end

	c_action_area (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkFontSelectionDialog *)$tmp)->action_area;"
		end

	c_ok_button (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkFontSelectionDialog *)$tmp)->ok_button;"
		end

	c_apply_button (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkFontSelectionDialog *)$tmp)->apply_button;"
		end

	c_cancel_button (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkFontSelectionDialog *)$tmp)->cancel_button;"
		end

	c_dialog_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkFontSelectionDialog *)$tmp)->dialog_width;"
		end

	c_auto_resize (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkFontSelectionDialog *)$tmp)->auto_resize;"
		end

feature {NONE} -- C setters

	c_set_fontsel (tmp: POINTER; a_fontsel: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkFontSelectionDialog *)$tmp)->fontsel = (struct _GtkWidget *)$a_fontsel;"
		end

	c_set_main_vbox (tmp: POINTER; a_main_vbox: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkFontSelectionDialog *)$tmp)->main_vbox = (struct _GtkWidget *)$a_main_vbox;"
		end

	c_set_action_area (tmp: POINTER; a_action_area: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkFontSelectionDialog *)$tmp)->action_area = (struct _GtkWidget *)$a_action_area;"
		end

	c_set_ok_button (tmp: POINTER; a_ok_button: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkFontSelectionDialog *)$tmp)->ok_button = (struct _GtkWidget *)$a_ok_button;"
		end

	c_set_apply_button (tmp: POINTER; a_apply_button: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkFontSelectionDialog *)$tmp)->apply_button = (struct _GtkWidget *)$a_apply_button;"
		end

	c_set_cancel_button (tmp: POINTER; a_cancel_button: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkFontSelectionDialog *)$tmp)->cancel_button = (struct _GtkWidget *)$a_cancel_button;"
		end

	c_set_dialog_width (tmp: POINTER; a_dialog_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkFontSelectionDialog *)$tmp)->dialog_width = $a_dialog_width;"
		end

	c_set_auto_resize (tmp: POINTER; a_auto_resize: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkFontSelectionDialog *)$tmp)->auto_resize = $a_auto_resize;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkFontSelectionDialog);"
		end

end
