class
	SD_GTKICONFACTORY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	parent_instance: SD_GOBJECT assign set_parent_instance
		do
			create Result.make_shared (c_parent_instance (c_pointer))
		end

	icons: CE_POINTER [ANY] assign set_icons
		do
			create Result.make_shared (c_icons (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_parent_instance (a_parent_instance: SD_GOBJECT)
		do
			parent_instance.ce_gets (a_parent_instance)
		end

	set_icons (a_icons: CE_POINTER [ANY])
		do
			c_set_icons (c_pointer, a_icons.c_pointer)
		end

feature {NONE} -- C getters

	c_parent_instance (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GObject *)&((struct _GtkIconFactory *)$tmp)->parent_instance;"
		end

	c_icons (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkIconFactory *)$tmp)->icons;"
		end

feature {NONE} -- C setters

	c_set_icons (tmp: POINTER; a_icons: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkIconFactory *)$tmp)->icons = (void *)$a_icons;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkIconFactory);"
		end

end
