class
	SD_GTKIMAGEICONSETDATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	icon_set: CE_POINTER [ANY] assign set_icon_set
		do
			create Result.make_shared (c_icon_set (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_icon_set (a_icon_set: CE_POINTER [ANY])
		do
			c_set_icon_set (c_pointer, a_icon_set.c_pointer)
		end

feature {NONE} -- C getters

	c_icon_set (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkImageIconSetData *)$tmp)->icon_set;"
		end

feature {NONE} -- C setters

	c_set_icon_set (tmp: POINTER; a_icon_set: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkImageIconSetData *)$tmp)->icon_set = (void *)$a_icon_set;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkImageIconSetData);"
		end

end
