class
	SD_GTKIMAGEIMAGEDATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	image: CE_POINTER [SD_GDKIMAGE] assign set_image
		do
			create Result.make_shared (c_image (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_image (a_image: CE_POINTER [SD_GDKIMAGE])
		do
			c_set_image (c_pointer, a_image.c_pointer)
		end

feature {NONE} -- C getters

	c_image (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkImage *)((struct _GtkImageImageData *)$tmp)->image;"
		end

feature {NONE} -- C setters

	c_set_image (tmp: POINTER; a_image: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkImageImageData *)$tmp)->image = (struct _GdkImage *)$a_image;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkImageImageData);"
		end

end
