class
	SD_GTKIMAGEPIXMAPDATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	pixmap: CE_POINTER [SD_GDKDRAWABLE] assign set_pixmap
		do
			create Result.make_shared (c_pixmap (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_pixmap (a_pixmap: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_pixmap (c_pointer, a_pixmap.c_pointer)
		end

feature {NONE} -- C getters

	c_pixmap (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GtkImagePixmapData *)$tmp)->pixmap;"
		end

feature {NONE} -- C setters

	c_set_pixmap (tmp: POINTER; a_pixmap: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkImagePixmapData *)$tmp)->pixmap = (struct _GdkDrawable *)$a_pixmap;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkImagePixmapData);"
		end

end
