class
	SD_GTKLABEL

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	misc: SD_GTKMISC assign set_misc
		do
			create Result.make_shared (c_misc (c_pointer))
		end

	label: CE_POINTER [INTEGER_8] assign set_label
		do
			create Result.make_shared (c_label (c_pointer))
		end

	jtype: NATURAL_32 assign set_jtype
		do
			Result := c_jtype (c_pointer)
		end

	wrap: NATURAL_32 assign set_wrap
		do
			Result := c_wrap (c_pointer)
		end

	use_underline: NATURAL_32 assign set_use_underline
		do
			Result := c_use_underline (c_pointer)
		end

	use_markup: NATURAL_32 assign set_use_markup
		do
			Result := c_use_markup (c_pointer)
		end

	ellipsize: NATURAL_32 assign set_ellipsize
		do
			Result := c_ellipsize (c_pointer)
		end

	single_line_mode: NATURAL_32 assign set_single_line_mode
		do
			Result := c_single_line_mode (c_pointer)
		end

	have_transform: NATURAL_32 assign set_have_transform
		do
			Result := c_have_transform (c_pointer)
		end

	in_click: NATURAL_32 assign set_in_click
		do
			Result := c_in_click (c_pointer)
		end

	wrap_mode: NATURAL_32 assign set_wrap_mode
		do
			Result := c_wrap_mode (c_pointer)
		end

	pattern_set: NATURAL_32 assign set_pattern_set
		do
			Result := c_pattern_set (c_pointer)
		end

	track_links: NATURAL_32 assign set_track_links
		do
			Result := c_track_links (c_pointer)
		end

	mnemonic_keyval: NATURAL_32 assign set_mnemonic_keyval
		do
			Result := c_mnemonic_keyval (c_pointer)
		end

	text: CE_POINTER [INTEGER_8] assign set_text
		do
			create Result.make_shared (c_text (c_pointer))
		end

	attrs: CE_POINTER [ANY] assign set_attrs
		do
			create Result.make_shared (c_attrs (c_pointer))
		end

	effective_attrs: CE_POINTER [ANY] assign set_effective_attrs
		do
			create Result.make_shared (c_effective_attrs (c_pointer))
		end

	layout: CE_POINTER [ANY] assign set_layout
		do
			create Result.make_shared (c_layout (c_pointer))
		end

	mnemonic_widget: CE_POINTER [SD_GTKWIDGET] assign set_mnemonic_widget
		do
			create Result.make_shared (c_mnemonic_widget (c_pointer))
		end

	mnemonic_window: CE_POINTER [SD_GTKWINDOW] assign set_mnemonic_window
		do
			create Result.make_shared (c_mnemonic_window (c_pointer))
		end

	select_info: CE_POINTER [ANY] assign set_select_info
		do
			create Result.make_shared (c_select_info (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_misc (a_misc: SD_GTKMISC)
		do
			misc.ce_gets (a_misc)
		end

	set_label (a_label: CE_POINTER [INTEGER_8])
		do
			c_set_label (c_pointer, a_label.c_pointer)
		end

	set_jtype (a_jtype: NATURAL_32)
		do
			c_set_jtype (c_pointer, a_jtype)
		end

	set_wrap (a_wrap: NATURAL_32)
		do
			c_set_wrap (c_pointer, a_wrap)
		end

	set_use_underline (a_use_underline: NATURAL_32)
		do
			c_set_use_underline (c_pointer, a_use_underline)
		end

	set_use_markup (a_use_markup: NATURAL_32)
		do
			c_set_use_markup (c_pointer, a_use_markup)
		end

	set_ellipsize (a_ellipsize: NATURAL_32)
		do
			c_set_ellipsize (c_pointer, a_ellipsize)
		end

	set_single_line_mode (a_single_line_mode: NATURAL_32)
		do
			c_set_single_line_mode (c_pointer, a_single_line_mode)
		end

	set_have_transform (a_have_transform: NATURAL_32)
		do
			c_set_have_transform (c_pointer, a_have_transform)
		end

	set_in_click (a_in_click: NATURAL_32)
		do
			c_set_in_click (c_pointer, a_in_click)
		end

	set_wrap_mode (a_wrap_mode: NATURAL_32)
		do
			c_set_wrap_mode (c_pointer, a_wrap_mode)
		end

	set_pattern_set (a_pattern_set: NATURAL_32)
		do
			c_set_pattern_set (c_pointer, a_pattern_set)
		end

	set_track_links (a_track_links: NATURAL_32)
		do
			c_set_track_links (c_pointer, a_track_links)
		end

	set_mnemonic_keyval (a_mnemonic_keyval: NATURAL_32)
		do
			c_set_mnemonic_keyval (c_pointer, a_mnemonic_keyval)
		end

	set_text (a_text: CE_POINTER [INTEGER_8])
		do
			c_set_text (c_pointer, a_text.c_pointer)
		end

	set_attrs (a_attrs: CE_POINTER [ANY])
		do
			c_set_attrs (c_pointer, a_attrs.c_pointer)
		end

	set_effective_attrs (a_effective_attrs: CE_POINTER [ANY])
		do
			c_set_effective_attrs (c_pointer, a_effective_attrs.c_pointer)
		end

	set_layout (a_layout: CE_POINTER [ANY])
		do
			c_set_layout (c_pointer, a_layout.c_pointer)
		end

	set_mnemonic_widget (a_mnemonic_widget: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_mnemonic_widget (c_pointer, a_mnemonic_widget.c_pointer)
		end

	set_mnemonic_window (a_mnemonic_window: CE_POINTER [SD_GTKWINDOW])
		do
			c_set_mnemonic_window (c_pointer, a_mnemonic_window.c_pointer)
		end

	set_select_info (a_select_info: CE_POINTER [ANY])
		do
			c_set_select_info (c_pointer, a_select_info.c_pointer)
		end

feature {NONE} -- C getters

	c_misc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkMisc *)&((struct _GtkLabel *)$tmp)->misc;"
		end

	c_label (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GtkLabel *)$tmp)->label;"
		end

	c_jtype (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkLabel *)$tmp)->jtype;"
		end

	c_wrap (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkLabel *)$tmp)->wrap;"
		end

	c_use_underline (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkLabel *)$tmp)->use_underline;"
		end

	c_use_markup (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkLabel *)$tmp)->use_markup;"
		end

	c_ellipsize (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkLabel *)$tmp)->ellipsize;"
		end

	c_single_line_mode (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkLabel *)$tmp)->single_line_mode;"
		end

	c_have_transform (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkLabel *)$tmp)->have_transform;"
		end

	c_in_click (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkLabel *)$tmp)->in_click;"
		end

	c_wrap_mode (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkLabel *)$tmp)->wrap_mode;"
		end

	c_pattern_set (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkLabel *)$tmp)->pattern_set;"
		end

	c_track_links (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkLabel *)$tmp)->track_links;"
		end

	c_mnemonic_keyval (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkLabel *)$tmp)->mnemonic_keyval;"
		end

	c_text (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct _GtkLabel *)$tmp)->text;"
		end

	c_attrs (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkLabel *)$tmp)->attrs;"
		end

	c_effective_attrs (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkLabel *)$tmp)->effective_attrs;"
		end

	c_layout (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkLabel *)$tmp)->layout;"
		end

	c_mnemonic_widget (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkLabel *)$tmp)->mnemonic_widget;"
		end

	c_mnemonic_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWindow *)((struct _GtkLabel *)$tmp)->mnemonic_window;"
		end

	c_select_info (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkLabel *)$tmp)->select_info;"
		end

feature {NONE} -- C setters

	c_set_label (tmp: POINTER; a_label: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkLabel *)$tmp)->label = (char *)$a_label;"
		end

	c_set_jtype (tmp: POINTER; a_jtype: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkLabel *)$tmp)->jtype = $a_jtype;"
		end

	c_set_wrap (tmp: POINTER; a_wrap: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkLabel *)$tmp)->wrap = $a_wrap;"
		end

	c_set_use_underline (tmp: POINTER; a_use_underline: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkLabel *)$tmp)->use_underline = $a_use_underline;"
		end

	c_set_use_markup (tmp: POINTER; a_use_markup: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkLabel *)$tmp)->use_markup = $a_use_markup;"
		end

	c_set_ellipsize (tmp: POINTER; a_ellipsize: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkLabel *)$tmp)->ellipsize = $a_ellipsize;"
		end

	c_set_single_line_mode (tmp: POINTER; a_single_line_mode: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkLabel *)$tmp)->single_line_mode = $a_single_line_mode;"
		end

	c_set_have_transform (tmp: POINTER; a_have_transform: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkLabel *)$tmp)->have_transform = $a_have_transform;"
		end

	c_set_in_click (tmp: POINTER; a_in_click: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkLabel *)$tmp)->in_click = $a_in_click;"
		end

	c_set_wrap_mode (tmp: POINTER; a_wrap_mode: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkLabel *)$tmp)->wrap_mode = $a_wrap_mode;"
		end

	c_set_pattern_set (tmp: POINTER; a_pattern_set: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkLabel *)$tmp)->pattern_set = $a_pattern_set;"
		end

	c_set_track_links (tmp: POINTER; a_track_links: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkLabel *)$tmp)->track_links = $a_track_links;"
		end

	c_set_mnemonic_keyval (tmp: POINTER; a_mnemonic_keyval: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkLabel *)$tmp)->mnemonic_keyval = $a_mnemonic_keyval;"
		end

	c_set_text (tmp: POINTER; a_text: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkLabel *)$tmp)->text = (char *)$a_text;"
		end

	c_set_attrs (tmp: POINTER; a_attrs: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkLabel *)$tmp)->attrs = (void *)$a_attrs;"
		end

	c_set_effective_attrs (tmp: POINTER; a_effective_attrs: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkLabel *)$tmp)->effective_attrs = (void *)$a_effective_attrs;"
		end

	c_set_layout (tmp: POINTER; a_layout: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkLabel *)$tmp)->layout = (void *)$a_layout;"
		end

	c_set_mnemonic_widget (tmp: POINTER; a_mnemonic_widget: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkLabel *)$tmp)->mnemonic_widget = (struct _GtkWidget *)$a_mnemonic_widget;"
		end

	c_set_mnemonic_window (tmp: POINTER; a_mnemonic_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkLabel *)$tmp)->mnemonic_window = (struct _GtkWindow *)$a_mnemonic_window;"
		end

	c_set_select_info (tmp: POINTER; a_select_info: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkLabel *)$tmp)->select_info = (void *)$a_select_info;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkLabel);"
		end

end
