class
	SD_GTKMISC

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	widget: SD_GTKWIDGET assign set_widget
		do
			create Result.make_shared (c_widget (c_pointer))
		end

	xalign: REAL_32 assign set_xalign
		do
			Result := c_xalign (c_pointer)
		end

	yalign: REAL_32 assign set_yalign
		do
			Result := c_yalign (c_pointer)
		end

	xpad: NATURAL_16 assign set_xpad
		do
			Result := c_xpad (c_pointer)
		end

	ypad: NATURAL_16 assign set_ypad
		do
			Result := c_ypad (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_widget (a_widget: SD_GTKWIDGET)
		do
			widget.ce_gets (a_widget)
		end

	set_xalign (a_xalign: REAL_32)
		do
			c_set_xalign (c_pointer, a_xalign)
		end

	set_yalign (a_yalign: REAL_32)
		do
			c_set_yalign (c_pointer, a_yalign)
		end

	set_xpad (a_xpad: NATURAL_16)
		do
			c_set_xpad (c_pointer, a_xpad)
		end

	set_ypad (a_ypad: NATURAL_16)
		do
			c_set_ypad (c_pointer, a_ypad)
		end

feature {NONE} -- C getters

	c_widget (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)&((struct _GtkMisc *)$tmp)->widget;"
		end

	c_xalign (tmp: POINTER): REAL_32
		external
			"C inline"
		alias
			"return (float)((struct _GtkMisc *)$tmp)->xalign;"
		end

	c_yalign (tmp: POINTER): REAL_32
		external
			"C inline"
		alias
			"return (float)((struct _GtkMisc *)$tmp)->yalign;"
		end

	c_xpad (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GtkMisc *)$tmp)->xpad;"
		end

	c_ypad (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GtkMisc *)$tmp)->ypad;"
		end

feature {NONE} -- C setters

	c_set_xalign (tmp: POINTER; a_xalign: REAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMisc *)$tmp)->xalign = $a_xalign;"
		end

	c_set_yalign (tmp: POINTER; a_yalign: REAL_32)
		external
			"C inline"
		alias
			"((struct _GtkMisc *)$tmp)->yalign = $a_yalign;"
		end

	c_set_xpad (tmp: POINTER; a_xpad: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GtkMisc *)$tmp)->xpad = $a_xpad;"
		end

	c_set_ypad (tmp: POINTER; a_ypad: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GtkMisc *)$tmp)->ypad = $a_ypad;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkMisc);"
		end

end
