class
	SD_GTKNOTEBOOK

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	container: SD_GTKCONTAINER assign set_container
		do
			create Result.make_shared (c_container (c_pointer))
		end

	cur_page: CE_POINTER [ANY] assign set_cur_page
		do
			create Result.make_shared (c_cur_page (c_pointer))
		end

	children: CE_POINTER [SD_GLIST] assign set_children
		do
			create Result.make_shared (c_children (c_pointer))
		end

	first_tab: CE_POINTER [SD_GLIST] assign set_first_tab
		do
			create Result.make_shared (c_first_tab (c_pointer))
		end

	focus_tab: CE_POINTER [SD_GLIST] assign set_focus_tab
		do
			create Result.make_shared (c_focus_tab (c_pointer))
		end

	menu: CE_POINTER [SD_GTKWIDGET] assign set_menu
		do
			create Result.make_shared (c_menu (c_pointer))
		end

	event_window: CE_POINTER [SD_GDKDRAWABLE] assign set_event_window
		do
			create Result.make_shared (c_event_window (c_pointer))
		end

	timer: NATURAL_32 assign set_timer
		do
			Result := c_timer (c_pointer)
		end

	tab_hborder: NATURAL_16 assign set_tab_hborder
		do
			Result := c_tab_hborder (c_pointer)
		end

	tab_vborder: NATURAL_16 assign set_tab_vborder
		do
			Result := c_tab_vborder (c_pointer)
		end

	show_tabs: NATURAL_32 assign set_show_tabs
		do
			Result := c_show_tabs (c_pointer)
		end

	homogeneous: NATURAL_32 assign set_homogeneous
		do
			Result := c_homogeneous (c_pointer)
		end

	show_border: NATURAL_32 assign set_show_border
		do
			Result := c_show_border (c_pointer)
		end

	tab_pos: NATURAL_32 assign set_tab_pos
		do
			Result := c_tab_pos (c_pointer)
		end

	scrollable: NATURAL_32 assign set_scrollable
		do
			Result := c_scrollable (c_pointer)
		end

	in_child: NATURAL_32 assign set_in_child
		do
			Result := c_in_child (c_pointer)
		end

	click_child: NATURAL_32 assign set_click_child
		do
			Result := c_click_child (c_pointer)
		end

	button: NATURAL_32 assign set_button
		do
			Result := c_button (c_pointer)
		end

	need_timer: NATURAL_32 assign set_need_timer
		do
			Result := c_need_timer (c_pointer)
		end

	child_has_focus: NATURAL_32 assign set_child_has_focus
		do
			Result := c_child_has_focus (c_pointer)
		end

	have_visible_child: NATURAL_32 assign set_have_visible_child
		do
			Result := c_have_visible_child (c_pointer)
		end

	focus_out: NATURAL_32 assign set_focus_out
		do
			Result := c_focus_out (c_pointer)
		end

	has_before_previous: NATURAL_32 assign set_has_before_previous
		do
			Result := c_has_before_previous (c_pointer)
		end

	has_before_next: NATURAL_32 assign set_has_before_next
		do
			Result := c_has_before_next (c_pointer)
		end

	has_after_previous: NATURAL_32 assign set_has_after_previous
		do
			Result := c_has_after_previous (c_pointer)
		end

	has_after_next: NATURAL_32 assign set_has_after_next
		do
			Result := c_has_after_next (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_container (a_container: SD_GTKCONTAINER)
		do
			container.ce_gets (a_container)
		end

	set_cur_page (a_cur_page: CE_POINTER [ANY])
		do
			c_set_cur_page (c_pointer, a_cur_page.c_pointer)
		end

	set_children (a_children: CE_POINTER [SD_GLIST])
		do
			c_set_children (c_pointer, a_children.c_pointer)
		end

	set_first_tab (a_first_tab: CE_POINTER [SD_GLIST])
		do
			c_set_first_tab (c_pointer, a_first_tab.c_pointer)
		end

	set_focus_tab (a_focus_tab: CE_POINTER [SD_GLIST])
		do
			c_set_focus_tab (c_pointer, a_focus_tab.c_pointer)
		end

	set_menu (a_menu: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_menu (c_pointer, a_menu.c_pointer)
		end

	set_event_window (a_event_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_event_window (c_pointer, a_event_window.c_pointer)
		end

	set_timer (a_timer: NATURAL_32)
		do
			c_set_timer (c_pointer, a_timer)
		end

	set_tab_hborder (a_tab_hborder: NATURAL_16)
		do
			c_set_tab_hborder (c_pointer, a_tab_hborder)
		end

	set_tab_vborder (a_tab_vborder: NATURAL_16)
		do
			c_set_tab_vborder (c_pointer, a_tab_vborder)
		end

	set_show_tabs (a_show_tabs: NATURAL_32)
		do
			c_set_show_tabs (c_pointer, a_show_tabs)
		end

	set_homogeneous (a_homogeneous: NATURAL_32)
		do
			c_set_homogeneous (c_pointer, a_homogeneous)
		end

	set_show_border (a_show_border: NATURAL_32)
		do
			c_set_show_border (c_pointer, a_show_border)
		end

	set_tab_pos (a_tab_pos: NATURAL_32)
		do
			c_set_tab_pos (c_pointer, a_tab_pos)
		end

	set_scrollable (a_scrollable: NATURAL_32)
		do
			c_set_scrollable (c_pointer, a_scrollable)
		end

	set_in_child (a_in_child: NATURAL_32)
		do
			c_set_in_child (c_pointer, a_in_child)
		end

	set_click_child (a_click_child: NATURAL_32)
		do
			c_set_click_child (c_pointer, a_click_child)
		end

	set_button (a_button: NATURAL_32)
		do
			c_set_button (c_pointer, a_button)
		end

	set_need_timer (a_need_timer: NATURAL_32)
		do
			c_set_need_timer (c_pointer, a_need_timer)
		end

	set_child_has_focus (a_child_has_focus: NATURAL_32)
		do
			c_set_child_has_focus (c_pointer, a_child_has_focus)
		end

	set_have_visible_child (a_have_visible_child: NATURAL_32)
		do
			c_set_have_visible_child (c_pointer, a_have_visible_child)
		end

	set_focus_out (a_focus_out: NATURAL_32)
		do
			c_set_focus_out (c_pointer, a_focus_out)
		end

	set_has_before_previous (a_has_before_previous: NATURAL_32)
		do
			c_set_has_before_previous (c_pointer, a_has_before_previous)
		end

	set_has_before_next (a_has_before_next: NATURAL_32)
		do
			c_set_has_before_next (c_pointer, a_has_before_next)
		end

	set_has_after_previous (a_has_after_previous: NATURAL_32)
		do
			c_set_has_after_previous (c_pointer, a_has_after_previous)
		end

	set_has_after_next (a_has_after_next: NATURAL_32)
		do
			c_set_has_after_next (c_pointer, a_has_after_next)
		end

feature {NONE} -- C getters

	c_container (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkContainer *)&((struct _GtkNotebook *)$tmp)->container;"
		end

	c_cur_page (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkNotebook *)$tmp)->cur_page;"
		end

	c_children (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GList *)((struct _GtkNotebook *)$tmp)->children;"
		end

	c_first_tab (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GList *)((struct _GtkNotebook *)$tmp)->first_tab;"
		end

	c_focus_tab (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GList *)((struct _GtkNotebook *)$tmp)->focus_tab;"
		end

	c_menu (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkNotebook *)$tmp)->menu;"
		end

	c_event_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GtkNotebook *)$tmp)->event_window;"
		end

	c_timer (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkNotebook *)$tmp)->timer;"
		end

	c_tab_hborder (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GtkNotebook *)$tmp)->tab_hborder;"
		end

	c_tab_vborder (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct _GtkNotebook *)$tmp)->tab_vborder;"
		end

	c_show_tabs (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkNotebook *)$tmp)->show_tabs;"
		end

	c_homogeneous (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkNotebook *)$tmp)->homogeneous;"
		end

	c_show_border (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkNotebook *)$tmp)->show_border;"
		end

	c_tab_pos (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkNotebook *)$tmp)->tab_pos;"
		end

	c_scrollable (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkNotebook *)$tmp)->scrollable;"
		end

	c_in_child (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkNotebook *)$tmp)->in_child;"
		end

	c_click_child (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkNotebook *)$tmp)->click_child;"
		end

	c_button (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkNotebook *)$tmp)->button;"
		end

	c_need_timer (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkNotebook *)$tmp)->need_timer;"
		end

	c_child_has_focus (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkNotebook *)$tmp)->child_has_focus;"
		end

	c_have_visible_child (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkNotebook *)$tmp)->have_visible_child;"
		end

	c_focus_out (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkNotebook *)$tmp)->focus_out;"
		end

	c_has_before_previous (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkNotebook *)$tmp)->has_before_previous;"
		end

	c_has_before_next (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkNotebook *)$tmp)->has_before_next;"
		end

	c_has_after_previous (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkNotebook *)$tmp)->has_after_previous;"
		end

	c_has_after_next (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkNotebook *)$tmp)->has_after_next;"
		end

feature {NONE} -- C setters

	c_set_cur_page (tmp: POINTER; a_cur_page: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkNotebook *)$tmp)->cur_page = (void *)$a_cur_page;"
		end

	c_set_children (tmp: POINTER; a_children: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkNotebook *)$tmp)->children = (struct _GList *)$a_children;"
		end

	c_set_first_tab (tmp: POINTER; a_first_tab: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkNotebook *)$tmp)->first_tab = (struct _GList *)$a_first_tab;"
		end

	c_set_focus_tab (tmp: POINTER; a_focus_tab: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkNotebook *)$tmp)->focus_tab = (struct _GList *)$a_focus_tab;"
		end

	c_set_menu (tmp: POINTER; a_menu: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkNotebook *)$tmp)->menu = (struct _GtkWidget *)$a_menu;"
		end

	c_set_event_window (tmp: POINTER; a_event_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkNotebook *)$tmp)->event_window = (struct _GdkDrawable *)$a_event_window;"
		end

	c_set_timer (tmp: POINTER; a_timer: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkNotebook *)$tmp)->timer = $a_timer;"
		end

	c_set_tab_hborder (tmp: POINTER; a_tab_hborder: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GtkNotebook *)$tmp)->tab_hborder = $a_tab_hborder;"
		end

	c_set_tab_vborder (tmp: POINTER; a_tab_vborder: NATURAL_16)
		external
			"C inline"
		alias
			"((struct _GtkNotebook *)$tmp)->tab_vborder = $a_tab_vborder;"
		end

	c_set_show_tabs (tmp: POINTER; a_show_tabs: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkNotebook *)$tmp)->show_tabs = $a_show_tabs;"
		end

	c_set_homogeneous (tmp: POINTER; a_homogeneous: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkNotebook *)$tmp)->homogeneous = $a_homogeneous;"
		end

	c_set_show_border (tmp: POINTER; a_show_border: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkNotebook *)$tmp)->show_border = $a_show_border;"
		end

	c_set_tab_pos (tmp: POINTER; a_tab_pos: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkNotebook *)$tmp)->tab_pos = $a_tab_pos;"
		end

	c_set_scrollable (tmp: POINTER; a_scrollable: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkNotebook *)$tmp)->scrollable = $a_scrollable;"
		end

	c_set_in_child (tmp: POINTER; a_in_child: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkNotebook *)$tmp)->in_child = $a_in_child;"
		end

	c_set_click_child (tmp: POINTER; a_click_child: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkNotebook *)$tmp)->click_child = $a_click_child;"
		end

	c_set_button (tmp: POINTER; a_button: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkNotebook *)$tmp)->button = $a_button;"
		end

	c_set_need_timer (tmp: POINTER; a_need_timer: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkNotebook *)$tmp)->need_timer = $a_need_timer;"
		end

	c_set_child_has_focus (tmp: POINTER; a_child_has_focus: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkNotebook *)$tmp)->child_has_focus = $a_child_has_focus;"
		end

	c_set_have_visible_child (tmp: POINTER; a_have_visible_child: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkNotebook *)$tmp)->have_visible_child = $a_have_visible_child;"
		end

	c_set_focus_out (tmp: POINTER; a_focus_out: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkNotebook *)$tmp)->focus_out = $a_focus_out;"
		end

	c_set_has_before_previous (tmp: POINTER; a_has_before_previous: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkNotebook *)$tmp)->has_before_previous = $a_has_before_previous;"
		end

	c_set_has_before_next (tmp: POINTER; a_has_before_next: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkNotebook *)$tmp)->has_before_next = $a_has_before_next;"
		end

	c_set_has_after_previous (tmp: POINTER; a_has_after_previous: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkNotebook *)$tmp)->has_after_previous = $a_has_after_previous;"
		end

	c_set_has_after_next (tmp: POINTER; a_has_after_next: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkNotebook *)$tmp)->has_after_next = $a_has_after_next;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkNotebook);"
		end

end
