class
	SD_GTKRANGE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	widget: SD_GTKWIDGET assign set_widget
		do
			create Result.make_shared (c_widget (c_pointer))
		end

	adjustment: CE_POINTER [SD_GTKADJUSTMENT] assign set_adjustment
		do
			create Result.make_shared (c_adjustment (c_pointer))
		end

	update_policy: INTEGER_32 assign set_update_policy
		do
			Result := c_update_policy (c_pointer)
		end

	inverted: NATURAL_32 assign set_inverted
		do
			Result := c_inverted (c_pointer)
		end

	flippable: NATURAL_32 assign set_flippable
		do
			Result := c_flippable (c_pointer)
		end

	has_stepper_a: NATURAL_32 assign set_has_stepper_a
		do
			Result := c_has_stepper_a (c_pointer)
		end

	has_stepper_b: NATURAL_32 assign set_has_stepper_b
		do
			Result := c_has_stepper_b (c_pointer)
		end

	has_stepper_c: NATURAL_32 assign set_has_stepper_c
		do
			Result := c_has_stepper_c (c_pointer)
		end

	has_stepper_d: NATURAL_32 assign set_has_stepper_d
		do
			Result := c_has_stepper_d (c_pointer)
		end

	need_recalc: NATURAL_32 assign set_need_recalc
		do
			Result := c_need_recalc (c_pointer)
		end

	slider_size_fixed: NATURAL_32 assign set_slider_size_fixed
		do
			Result := c_slider_size_fixed (c_pointer)
		end

	min_slider_size: INTEGER_32 assign set_min_slider_size
		do
			Result := c_min_slider_size (c_pointer)
		end

	orientation: INTEGER_32 assign set_orientation
		do
			Result := c_orientation (c_pointer)
		end

	range_rect: SD_GDKRECTANGLE assign set_range_rect
		do
			create Result.make_shared (c_range_rect (c_pointer))
		end

	slider_start: INTEGER_32 assign set_slider_start
		do
			Result := c_slider_start (c_pointer)
		end

	slider_end: INTEGER_32 assign set_slider_end
		do
			Result := c_slider_end (c_pointer)
		end

	round_digits: INTEGER_32 assign set_round_digits
		do
			Result := c_round_digits (c_pointer)
		end

	trough_click_forward: NATURAL_32 assign set_trough_click_forward
		do
			Result := c_trough_click_forward (c_pointer)
		end

	update_pending: NATURAL_32 assign set_update_pending
		do
			Result := c_update_pending (c_pointer)
		end

	layout: CE_POINTER [ANY] assign set_layout
		do
			create Result.make_shared (c_layout (c_pointer))
		end

	timer: CE_POINTER [ANY] assign set_timer
		do
			create Result.make_shared (c_timer (c_pointer))
		end

	slide_initial_slider_position: INTEGER_32 assign set_slide_initial_slider_position
		do
			Result := c_slide_initial_slider_position (c_pointer)
		end

	slide_initial_coordinate: INTEGER_32 assign set_slide_initial_coordinate
		do
			Result := c_slide_initial_coordinate (c_pointer)
		end

	update_timeout_id: NATURAL_32 assign set_update_timeout_id
		do
			Result := c_update_timeout_id (c_pointer)
		end

	event_window: CE_POINTER [SD_GDKDRAWABLE] assign set_event_window
		do
			create Result.make_shared (c_event_window (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_widget (a_widget: SD_GTKWIDGET)
		do
			widget.ce_gets (a_widget)
		end

	set_adjustment (a_adjustment: CE_POINTER [SD_GTKADJUSTMENT])
		do
			c_set_adjustment (c_pointer, a_adjustment.c_pointer)
		end

	set_update_policy (a_update_policy: INTEGER_32)
		do
			c_set_update_policy (c_pointer, a_update_policy)
		end

	set_inverted (a_inverted: NATURAL_32)
		do
			c_set_inverted (c_pointer, a_inverted)
		end

	set_flippable (a_flippable: NATURAL_32)
		do
			c_set_flippable (c_pointer, a_flippable)
		end

	set_has_stepper_a (a_has_stepper_a: NATURAL_32)
		do
			c_set_has_stepper_a (c_pointer, a_has_stepper_a)
		end

	set_has_stepper_b (a_has_stepper_b: NATURAL_32)
		do
			c_set_has_stepper_b (c_pointer, a_has_stepper_b)
		end

	set_has_stepper_c (a_has_stepper_c: NATURAL_32)
		do
			c_set_has_stepper_c (c_pointer, a_has_stepper_c)
		end

	set_has_stepper_d (a_has_stepper_d: NATURAL_32)
		do
			c_set_has_stepper_d (c_pointer, a_has_stepper_d)
		end

	set_need_recalc (a_need_recalc: NATURAL_32)
		do
			c_set_need_recalc (c_pointer, a_need_recalc)
		end

	set_slider_size_fixed (a_slider_size_fixed: NATURAL_32)
		do
			c_set_slider_size_fixed (c_pointer, a_slider_size_fixed)
		end

	set_min_slider_size (a_min_slider_size: INTEGER_32)
		do
			c_set_min_slider_size (c_pointer, a_min_slider_size)
		end

	set_orientation (a_orientation: INTEGER_32)
		do
			c_set_orientation (c_pointer, a_orientation)
		end

	set_range_rect (a_range_rect: SD_GDKRECTANGLE)
		do
			range_rect.ce_gets (a_range_rect)
		end

	set_slider_start (a_slider_start: INTEGER_32)
		do
			c_set_slider_start (c_pointer, a_slider_start)
		end

	set_slider_end (a_slider_end: INTEGER_32)
		do
			c_set_slider_end (c_pointer, a_slider_end)
		end

	set_round_digits (a_round_digits: INTEGER_32)
		do
			c_set_round_digits (c_pointer, a_round_digits)
		end

	set_trough_click_forward (a_trough_click_forward: NATURAL_32)
		do
			c_set_trough_click_forward (c_pointer, a_trough_click_forward)
		end

	set_update_pending (a_update_pending: NATURAL_32)
		do
			c_set_update_pending (c_pointer, a_update_pending)
		end

	set_layout (a_layout: CE_POINTER [ANY])
		do
			c_set_layout (c_pointer, a_layout.c_pointer)
		end

	set_timer (a_timer: CE_POINTER [ANY])
		do
			c_set_timer (c_pointer, a_timer.c_pointer)
		end

	set_slide_initial_slider_position (a_slide_initial_slider_position: INTEGER_32)
		do
			c_set_slide_initial_slider_position (c_pointer, a_slide_initial_slider_position)
		end

	set_slide_initial_coordinate (a_slide_initial_coordinate: INTEGER_32)
		do
			c_set_slide_initial_coordinate (c_pointer, a_slide_initial_coordinate)
		end

	set_update_timeout_id (a_update_timeout_id: NATURAL_32)
		do
			c_set_update_timeout_id (c_pointer, a_update_timeout_id)
		end

	set_event_window (a_event_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_set_event_window (c_pointer, a_event_window.c_pointer)
		end

feature {NONE} -- C getters

	c_widget (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)&((struct _GtkRange *)$tmp)->widget;"
		end

	c_adjustment (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkAdjustment *)((struct _GtkRange *)$tmp)->adjustment;"
		end

	c_update_policy (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkRange *)$tmp)->update_policy;"
		end

	c_inverted (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkRange *)$tmp)->inverted;"
		end

	c_flippable (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkRange *)$tmp)->flippable;"
		end

	c_has_stepper_a (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkRange *)$tmp)->has_stepper_a;"
		end

	c_has_stepper_b (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkRange *)$tmp)->has_stepper_b;"
		end

	c_has_stepper_c (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkRange *)$tmp)->has_stepper_c;"
		end

	c_has_stepper_d (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkRange *)$tmp)->has_stepper_d;"
		end

	c_need_recalc (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkRange *)$tmp)->need_recalc;"
		end

	c_slider_size_fixed (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkRange *)$tmp)->slider_size_fixed;"
		end

	c_min_slider_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkRange *)$tmp)->min_slider_size;"
		end

	c_orientation (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkRange *)$tmp)->orientation;"
		end

	c_range_rect (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkRectangle *)&((struct _GtkRange *)$tmp)->range_rect;"
		end

	c_slider_start (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkRange *)$tmp)->slider_start;"
		end

	c_slider_end (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkRange *)$tmp)->slider_end;"
		end

	c_round_digits (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkRange *)$tmp)->round_digits;"
		end

	c_trough_click_forward (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkRange *)$tmp)->trough_click_forward;"
		end

	c_update_pending (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkRange *)$tmp)->update_pending;"
		end

	c_layout (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkRange *)$tmp)->layout;"
		end

	c_timer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct _GtkRange *)$tmp)->timer;"
		end

	c_slide_initial_slider_position (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkRange *)$tmp)->slide_initial_slider_position;"
		end

	c_slide_initial_coordinate (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkRange *)$tmp)->slide_initial_coordinate;"
		end

	c_update_timeout_id (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkRange *)$tmp)->update_timeout_id;"
		end

	c_event_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GdkDrawable *)((struct _GtkRange *)$tmp)->event_window;"
		end

feature {NONE} -- C setters

	c_set_adjustment (tmp: POINTER; a_adjustment: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkRange *)$tmp)->adjustment = (struct _GtkAdjustment *)$a_adjustment;"
		end

	c_set_update_policy (tmp: POINTER; a_update_policy: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkRange *)$tmp)->update_policy = $a_update_policy;"
		end

	c_set_inverted (tmp: POINTER; a_inverted: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkRange *)$tmp)->inverted = $a_inverted;"
		end

	c_set_flippable (tmp: POINTER; a_flippable: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkRange *)$tmp)->flippable = $a_flippable;"
		end

	c_set_has_stepper_a (tmp: POINTER; a_has_stepper_a: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkRange *)$tmp)->has_stepper_a = $a_has_stepper_a;"
		end

	c_set_has_stepper_b (tmp: POINTER; a_has_stepper_b: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkRange *)$tmp)->has_stepper_b = $a_has_stepper_b;"
		end

	c_set_has_stepper_c (tmp: POINTER; a_has_stepper_c: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkRange *)$tmp)->has_stepper_c = $a_has_stepper_c;"
		end

	c_set_has_stepper_d (tmp: POINTER; a_has_stepper_d: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkRange *)$tmp)->has_stepper_d = $a_has_stepper_d;"
		end

	c_set_need_recalc (tmp: POINTER; a_need_recalc: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkRange *)$tmp)->need_recalc = $a_need_recalc;"
		end

	c_set_slider_size_fixed (tmp: POINTER; a_slider_size_fixed: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkRange *)$tmp)->slider_size_fixed = $a_slider_size_fixed;"
		end

	c_set_min_slider_size (tmp: POINTER; a_min_slider_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkRange *)$tmp)->min_slider_size = $a_min_slider_size;"
		end

	c_set_orientation (tmp: POINTER; a_orientation: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkRange *)$tmp)->orientation = $a_orientation;"
		end

	c_set_slider_start (tmp: POINTER; a_slider_start: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkRange *)$tmp)->slider_start = $a_slider_start;"
		end

	c_set_slider_end (tmp: POINTER; a_slider_end: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkRange *)$tmp)->slider_end = $a_slider_end;"
		end

	c_set_round_digits (tmp: POINTER; a_round_digits: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkRange *)$tmp)->round_digits = $a_round_digits;"
		end

	c_set_trough_click_forward (tmp: POINTER; a_trough_click_forward: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkRange *)$tmp)->trough_click_forward = $a_trough_click_forward;"
		end

	c_set_update_pending (tmp: POINTER; a_update_pending: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkRange *)$tmp)->update_pending = $a_update_pending;"
		end

	c_set_layout (tmp: POINTER; a_layout: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkRange *)$tmp)->layout = (void *)$a_layout;"
		end

	c_set_timer (tmp: POINTER; a_timer: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkRange *)$tmp)->timer = (void *)$a_timer;"
		end

	c_set_slide_initial_slider_position (tmp: POINTER; a_slide_initial_slider_position: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkRange *)$tmp)->slide_initial_slider_position = $a_slide_initial_slider_position;"
		end

	c_set_slide_initial_coordinate (tmp: POINTER; a_slide_initial_coordinate: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkRange *)$tmp)->slide_initial_coordinate = $a_slide_initial_coordinate;"
		end

	c_set_update_timeout_id (tmp: POINTER; a_update_timeout_id: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkRange *)$tmp)->update_timeout_id = $a_update_timeout_id;"
		end

	c_set_event_window (tmp: POINTER; a_event_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkRange *)$tmp)->event_window = (struct _GdkDrawable *)$a_event_window;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkRange);"
		end

end
