class
	SD_GTKTOOLTIPS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	parent_instance: SD_GTKOBJECT assign set_parent_instance
		do
			create Result.make_shared (c_parent_instance (c_pointer))
		end

	tip_window: CE_POINTER [SD_GTKWIDGET] assign set_tip_window
		do
			create Result.make_shared (c_tip_window (c_pointer))
		end

	tip_label: CE_POINTER [SD_GTKWIDGET] assign set_tip_label
		do
			create Result.make_shared (c_tip_label (c_pointer))
		end

	active_tips_data: CE_POINTER [SD_GTKTOOLTIPSDATA] assign set_active_tips_data
		do
			create Result.make_shared (c_active_tips_data (c_pointer))
		end

	tips_data_list: CE_POINTER [SD_GLIST] assign set_tips_data_list
		do
			create Result.make_shared (c_tips_data_list (c_pointer))
		end

	delay: NATURAL_32 assign set_delay
		do
			Result := c_delay (c_pointer)
		end

	enabled: NATURAL_32 assign set_enabled
		do
			Result := c_enabled (c_pointer)
		end

	have_grab: NATURAL_32 assign set_have_grab
		do
			Result := c_have_grab (c_pointer)
		end

	use_sticky_delay: NATURAL_32 assign set_use_sticky_delay
		do
			Result := c_use_sticky_delay (c_pointer)
		end

	timer_tag: INTEGER_32 assign set_timer_tag
		do
			Result := c_timer_tag (c_pointer)
		end

	last_popdown: SD_GTIMEVAL assign set_last_popdown
		do
			create Result.make_shared (c_last_popdown (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_parent_instance (a_parent_instance: SD_GTKOBJECT)
		do
			parent_instance.ce_gets (a_parent_instance)
		end

	set_tip_window (a_tip_window: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_tip_window (c_pointer, a_tip_window.c_pointer)
		end

	set_tip_label (a_tip_label: CE_POINTER [SD_GTKWIDGET])
		do
			c_set_tip_label (c_pointer, a_tip_label.c_pointer)
		end

	set_active_tips_data (a_active_tips_data: CE_POINTER [SD_GTKTOOLTIPSDATA])
		do
			c_set_active_tips_data (c_pointer, a_active_tips_data.c_pointer)
		end

	set_tips_data_list (a_tips_data_list: CE_POINTER [SD_GLIST])
		do
			c_set_tips_data_list (c_pointer, a_tips_data_list.c_pointer)
		end

	set_delay (a_delay: NATURAL_32)
		do
			c_set_delay (c_pointer, a_delay)
		end

	set_enabled (a_enabled: NATURAL_32)
		do
			c_set_enabled (c_pointer, a_enabled)
		end

	set_have_grab (a_have_grab: NATURAL_32)
		do
			c_set_have_grab (c_pointer, a_have_grab)
		end

	set_use_sticky_delay (a_use_sticky_delay: NATURAL_32)
		do
			c_set_use_sticky_delay (c_pointer, a_use_sticky_delay)
		end

	set_timer_tag (a_timer_tag: INTEGER_32)
		do
			c_set_timer_tag (c_pointer, a_timer_tag)
		end

	set_last_popdown (a_last_popdown: SD_GTIMEVAL)
		do
			last_popdown.ce_gets (a_last_popdown)
		end

feature {NONE} -- C getters

	c_parent_instance (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkObject *)&((struct _GtkTooltips *)$tmp)->parent_instance;"
		end

	c_tip_window (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkTooltips *)$tmp)->tip_window;"
		end

	c_tip_label (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkWidget *)((struct _GtkTooltips *)$tmp)->tip_label;"
		end

	c_active_tips_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GtkTooltipsData *)((struct _GtkTooltips *)$tmp)->active_tips_data;"
		end

	c_tips_data_list (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GList *)((struct _GtkTooltips *)$tmp)->tips_data_list;"
		end

	c_delay (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkTooltips *)$tmp)->delay;"
		end

	c_enabled (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkTooltips *)$tmp)->enabled;"
		end

	c_have_grab (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkTooltips *)$tmp)->have_grab;"
		end

	c_use_sticky_delay (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _GtkTooltips *)$tmp)->use_sticky_delay;"
		end

	c_timer_tag (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _GtkTooltips *)$tmp)->timer_tag;"
		end

	c_last_popdown (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _GTimeVal *)&((struct _GtkTooltips *)$tmp)->last_popdown;"
		end

feature {NONE} -- C setters

	c_set_tip_window (tmp: POINTER; a_tip_window: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkTooltips *)$tmp)->tip_window = (struct _GtkWidget *)$a_tip_window;"
		end

	c_set_tip_label (tmp: POINTER; a_tip_label: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkTooltips *)$tmp)->tip_label = (struct _GtkWidget *)$a_tip_label;"
		end

	c_set_active_tips_data (tmp: POINTER; a_active_tips_data: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkTooltips *)$tmp)->active_tips_data = (struct _GtkTooltipsData *)$a_active_tips_data;"
		end

	c_set_tips_data_list (tmp: POINTER; a_tips_data_list: POINTER)
		external
			"C inline"
		alias
			"((struct _GtkTooltips *)$tmp)->tips_data_list = (struct _GList *)$a_tips_data_list;"
		end

	c_set_delay (tmp: POINTER; a_delay: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkTooltips *)$tmp)->delay = $a_delay;"
		end

	c_set_enabled (tmp: POINTER; a_enabled: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkTooltips *)$tmp)->enabled = $a_enabled;"
		end

	c_set_have_grab (tmp: POINTER; a_have_grab: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkTooltips *)$tmp)->have_grab = $a_have_grab;"
		end

	c_set_use_sticky_delay (tmp: POINTER; a_use_sticky_delay: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _GtkTooltips *)$tmp)->use_sticky_delay = $a_use_sticky_delay;"
		end

	c_set_timer_tag (tmp: POINTER; a_timer_tag: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _GtkTooltips *)$tmp)->timer_tag = $a_timer_tag;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _GtkTooltips);"
		end

end
