class
	SD_PANGOATTRCLASS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	copy2: CE_ROUTINE assign set_copy2
		do
			create Result.make_shared (c_copy2 (c_pointer))
		end

	destroy: CE_ROUTINE assign set_destroy
		do
			create Result.make_shared (c_destroy (c_pointer))
		end

	equal2: CE_ROUTINE assign set_equal2
		do
			create Result.make_shared (c_equal2 (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_copy2 (a_copy2: CE_ROUTINE)
		do
			c_set_copy2 (c_pointer, a_copy2.c_pointer)
		end

	set_destroy (a_destroy: CE_ROUTINE)
		do
			c_set_destroy (c_pointer, a_destroy.c_pointer)
		end

	set_equal2 (a_equal2: CE_ROUTINE)
		do
			c_set_equal2 (c_pointer, a_equal2.c_pointer)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _PangoAttrClass *)$tmp)->type;"
		end

	c_copy2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _PangoAttribute *( *)(struct _PangoAttribute * attr))((struct _PangoAttrClass *)$tmp)->copy;"
		end

	c_destroy (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(struct _PangoAttribute * attr))((struct _PangoAttrClass *)$tmp)->destroy;"
		end

	c_equal2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(struct _PangoAttribute * attr1, struct _PangoAttribute * attr2))((struct _PangoAttrClass *)$tmp)->equal;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _PangoAttrClass *)$tmp)->type = $a_type;"
		end

	c_set_copy2 (tmp: POINTER; a_copy2: POINTER)
		external
			"C inline"
		alias
			"((struct _PangoAttrClass *)$tmp)->copy = (struct _PangoAttribute *( *)(struct _PangoAttribute * attr))$a_copy2;"
		end

	c_set_destroy (tmp: POINTER; a_destroy: POINTER)
		external
			"C inline"
		alias
			"((struct _PangoAttrClass *)$tmp)->destroy = (void( *)(struct _PangoAttribute * attr))$a_destroy;"
		end

	c_set_equal2 (tmp: POINTER; a_equal2: POINTER)
		external
			"C inline"
		alias
			"((struct _PangoAttrClass *)$tmp)->equal = (int( *)(struct _PangoAttribute * attr1, struct _PangoAttribute * attr2))$a_equal2;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _PangoAttrClass);"
		end

end
