class
	SD_PANGOATTRCOLOR

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	attr: SD_PANGOATTRIBUTE assign set_attr
		do
			create Result.make_shared (c_attr (c_pointer))
		end

	color: SD_PANGOCOLOR assign set_color
		do
			create Result.make_shared (c_color (c_pointer))
		end

	color_offset: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return (int)offsetof(struct _PangoAttrColor, color);"
		end

feature {ANY} -- Eiffel setters

	set_attr (a_attr: SD_PANGOATTRIBUTE)
		do
			attr.ce_gets (a_attr)
		end

	set_color (a_color: SD_PANGOCOLOR)
		do
			color.ce_gets (a_color)
		end

feature {NONE} -- C getters

	c_attr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _PangoAttribute *)&((struct _PangoAttrColor *)$tmp)->attr;"
		end

	c_color (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _PangoColor *)&((struct _PangoAttrColor *)$tmp)->color;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _PangoAttrColor);"
		end

end
