class
	SD_PANGOATTRIBUTE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	klass: CE_POINTER [SD_PANGOATTRCLASS] assign set_klass
		do
			create Result.make_shared (c_klass (c_pointer))
		end

	start_index: NATURAL_32 assign set_start_index
		do
			Result := c_start_index (c_pointer)
		end

	end_index: NATURAL_32 assign set_end_index
		do
			Result := c_end_index (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_klass (a_klass: CE_POINTER [SD_PANGOATTRCLASS])
		do
			c_set_klass (c_pointer, a_klass.c_pointer)
		end

	set_start_index (a_start_index: NATURAL_32)
		do
			c_set_start_index (c_pointer, a_start_index)
		end

	set_end_index (a_end_index: NATURAL_32)
		do
			c_set_end_index (c_pointer, a_end_index)
		end

feature {NONE} -- C getters

	c_klass (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _PangoAttrClass *)((struct _PangoAttribute *)$tmp)->klass;"
		end

	c_start_index (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _PangoAttribute *)$tmp)->start_index;"
		end

	c_end_index (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct _PangoAttribute *)$tmp)->end_index;"
		end

feature {NONE} -- C setters

	c_set_klass (tmp: POINTER; a_klass: POINTER)
		external
			"C inline"
		alias
			"((struct _PangoAttribute *)$tmp)->klass = (struct _PangoAttrClass *)$a_klass;"
		end

	c_set_start_index (tmp: POINTER; a_start_index: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _PangoAttribute *)$tmp)->start_index = $a_start_index;"
		end

	c_set_end_index (tmp: POINTER; a_end_index: NATURAL_32)
		external
			"C inline"
		alias
			"((struct _PangoAttribute *)$tmp)->end_index = $a_end_index;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _PangoAttribute);"
		end

end
