class
	SD_PANGOGLYPHGEOMETRY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	width: INTEGER_32 assign set_width
		do
			Result := c_width (c_pointer)
		end

	x_offset: INTEGER_32 assign set_x_offset
		do
			Result := c_x_offset (c_pointer)
		end

	y_offset: INTEGER_32 assign set_y_offset
		do
			Result := c_y_offset (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_width (a_width: INTEGER_32)
		do
			c_set_width (c_pointer, a_width)
		end

	set_x_offset (a_x_offset: INTEGER_32)
		do
			c_set_x_offset (c_pointer, a_x_offset)
		end

	set_y_offset (a_y_offset: INTEGER_32)
		do
			c_set_y_offset (c_pointer, a_y_offset)
		end

feature {NONE} -- C getters

	c_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _PangoGlyphGeometry *)$tmp)->width;"
		end

	c_x_offset (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _PangoGlyphGeometry *)$tmp)->x_offset;"
		end

	c_y_offset (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct _PangoGlyphGeometry *)$tmp)->y_offset;"
		end

feature {NONE} -- C setters

	c_set_width (tmp: POINTER; a_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _PangoGlyphGeometry *)$tmp)->width = $a_width;"
		end

	c_set_x_offset (tmp: POINTER; a_x_offset: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _PangoGlyphGeometry *)$tmp)->x_offset = $a_x_offset;"
		end

	c_set_y_offset (tmp: POINTER; a_y_offset: INTEGER_32)
		external
			"C inline"
		alias
			"((struct _PangoGlyphGeometry *)$tmp)->y_offset = $a_y_offset;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct _PangoGlyphGeometry);"
		end

end
