class
	SD_UTSNAME

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sysname: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_sysname (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	nodename: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_nodename (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	release: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_release (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	version: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_version (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	machine: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_machine (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	domainname: CE_ARRAY [INTEGER_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_domainname (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {NONE} -- C getters

	c_sysname (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct utsname *tmp = (struct utsname *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->sysname) / sizeof(tmp->sysname[0]);
				return tmp->sysname;
			]"
		end

	c_nodename (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct utsname *tmp = (struct utsname *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->nodename) / sizeof(tmp->nodename[0]);
				return tmp->nodename;
			]"
		end

	c_release (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct utsname *tmp = (struct utsname *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->release) / sizeof(tmp->release[0]);
				return tmp->release;
			]"
		end

	c_version (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct utsname *tmp = (struct utsname *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->version) / sizeof(tmp->version[0]);
				return tmp->version;
			]"
		end

	c_machine (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct utsname *tmp = (struct utsname *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->machine) / sizeof(tmp->machine[0]);
				return tmp->machine;
			]"
		end

	c_domainname (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct utsname *tmp = (struct utsname *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->domainname) / sizeof(tmp->domainname[0]);
				return tmp->domainname;
			]"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct utsname);"
		end

end
