class
	SD_VISUAL

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ext_data: CE_POINTER [SD_XEXTDATA] assign set_ext_data
		do
			create Result.make_shared (c_ext_data (c_pointer))
		end

	visualid: NATURAL_32 assign set_visualid
		do
			Result := c_visualid (c_pointer)
		end

	class2: INTEGER_32 assign set_class2
		do
			Result := c_class2 (c_pointer)
		end

	red_mask: NATURAL_32 assign set_red_mask
		do
			Result := c_red_mask (c_pointer)
		end

	green_mask: NATURAL_32 assign set_green_mask
		do
			Result := c_green_mask (c_pointer)
		end

	blue_mask: NATURAL_32 assign set_blue_mask
		do
			Result := c_blue_mask (c_pointer)
		end

	bits_per_rgb: INTEGER_32 assign set_bits_per_rgb
		do
			Result := c_bits_per_rgb (c_pointer)
		end

	map_entries: INTEGER_32 assign set_map_entries
		do
			Result := c_map_entries (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_ext_data (a_ext_data: CE_POINTER [SD_XEXTDATA])
		do
			c_set_ext_data (c_pointer, a_ext_data.c_pointer)
		end

	set_visualid (a_visualid: NATURAL_32)
		do
			c_set_visualid (c_pointer, a_visualid)
		end

	set_class2 (a_class2: INTEGER_32)
		do
			c_set_class2 (c_pointer, a_class2)
		end

	set_red_mask (a_red_mask: NATURAL_32)
		do
			c_set_red_mask (c_pointer, a_red_mask)
		end

	set_green_mask (a_green_mask: NATURAL_32)
		do
			c_set_green_mask (c_pointer, a_green_mask)
		end

	set_blue_mask (a_blue_mask: NATURAL_32)
		do
			c_set_blue_mask (c_pointer, a_blue_mask)
		end

	set_bits_per_rgb (a_bits_per_rgb: INTEGER_32)
		do
			c_set_bits_per_rgb (c_pointer, a_bits_per_rgb)
		end

	set_map_entries (a_map_entries: INTEGER_32)
		do
			c_set_map_entries (c_pointer, a_map_entries)
		end

feature {NONE} -- C getters

	c_ext_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _XExtData *)((struct __anonstruct_Visual_349 *)$tmp)->ext_data;"
		end

	c_visualid (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_Visual_349 *)$tmp)->visualid;"
		end

	c_class2 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_Visual_349 *)$tmp)->class;"
		end

	c_red_mask (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_Visual_349 *)$tmp)->red_mask;"
		end

	c_green_mask (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_Visual_349 *)$tmp)->green_mask;"
		end

	c_blue_mask (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_Visual_349 *)$tmp)->blue_mask;"
		end

	c_bits_per_rgb (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_Visual_349 *)$tmp)->bits_per_rgb;"
		end

	c_map_entries (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_Visual_349 *)$tmp)->map_entries;"
		end

feature {NONE} -- C setters

	c_set_ext_data (tmp: POINTER; a_ext_data: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_Visual_349 *)$tmp)->ext_data = (struct _XExtData *)$a_ext_data;"
		end

	c_set_visualid (tmp: POINTER; a_visualid: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_Visual_349 *)$tmp)->visualid = $a_visualid;"
		end

	c_set_class2 (tmp: POINTER; a_class2: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_Visual_349 *)$tmp)->class = $a_class2;"
		end

	c_set_red_mask (tmp: POINTER; a_red_mask: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_Visual_349 *)$tmp)->red_mask = $a_red_mask;"
		end

	c_set_green_mask (tmp: POINTER; a_green_mask: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_Visual_349 *)$tmp)->green_mask = $a_green_mask;"
		end

	c_set_blue_mask (tmp: POINTER; a_blue_mask: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_Visual_349 *)$tmp)->blue_mask = $a_blue_mask;"
		end

	c_set_bits_per_rgb (tmp: POINTER; a_bits_per_rgb: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_Visual_349 *)$tmp)->bits_per_rgb = $a_bits_per_rgb;"
		end

	c_set_map_entries (tmp: POINTER; a_map_entries: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_Visual_349 *)$tmp)->map_entries = $a_map_entries;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_Visual_349);"
		end

end
