class
	SD_WAIT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	w_status: INTEGER_32 assign set_w_status
		do
			Result := c_w_status (c_pointer)
		end

	wait_terminated: SD_WAIT_TERMINATED assign set_wait_terminated
		do
			create Result.make_shared (c_wait_terminated (c_pointer))
		end

	wait_stopped: SD_WAIT_STOPPED assign set_wait_stopped
		do
			create Result.make_shared (c_wait_stopped (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_w_status (a_w_status: INTEGER_32)
		do
			c_set_w_status (c_pointer, a_w_status)
		end

	set_wait_terminated (a_wait_terminated: SD_WAIT_TERMINATED)
		do
			wait_terminated.ce_gets (a_wait_terminated)
		end

	set_wait_stopped (a_wait_stopped: SD_WAIT_STOPPED)
		do
			wait_stopped.ce_gets (a_wait_stopped)
		end

feature {NONE} -- C getters

	c_w_status (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((union wait *)$tmp)->w_status;"
		end

	c_wait_terminated (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct __anonstruct___wait_terminated_22 *)&((union wait *)$tmp)->__wait_terminated;"
		end

	c_wait_stopped (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct __anonstruct___wait_stopped_23 *)&((union wait *)$tmp)->__wait_stopped;"
		end

feature {NONE} -- C setters

	c_set_w_status (tmp: POINTER; a_w_status: INTEGER_32)
		external
			"C inline"
		alias
			"((union wait *)$tmp)->w_status = $a_w_status;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(union wait);"
		end

end
