class
	SD_WAIT_TERMINATED

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	w_termsig: NATURAL_32 assign set_w_termsig
		do
			Result := c_w_termsig (c_pointer)
		end

	w_coredump: NATURAL_32 assign set_w_coredump
		do
			Result := c_w_coredump (c_pointer)
		end

	w_retcode: NATURAL_32 assign set_w_retcode
		do
			Result := c_w_retcode (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_w_termsig (a_w_termsig: NATURAL_32)
		do
			c_set_w_termsig (c_pointer, a_w_termsig)
		end

	set_w_coredump (a_w_coredump: NATURAL_32)
		do
			c_set_w_coredump (c_pointer, a_w_coredump)
		end

	set_w_retcode (a_w_retcode: NATURAL_32)
		do
			c_set_w_retcode (c_pointer, a_w_retcode)
		end

feature {NONE} -- C getters

	c_w_termsig (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct___wait_terminated_22 *)$tmp)->__w_termsig;"
		end

	c_w_coredump (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct___wait_terminated_22 *)$tmp)->__w_coredump;"
		end

	c_w_retcode (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct___wait_terminated_22 *)$tmp)->__w_retcode;"
		end

feature {NONE} -- C setters

	c_set_w_termsig (tmp: POINTER; a_w_termsig: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct___wait_terminated_22 *)$tmp)->__w_termsig = $a_w_termsig;"
		end

	c_set_w_coredump (tmp: POINTER; a_w_coredump: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct___wait_terminated_22 *)$tmp)->__w_coredump = $a_w_coredump;"
		end

	c_set_w_retcode (tmp: POINTER; a_w_retcode: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct___wait_terminated_22 *)$tmp)->__w_retcode = $a_w_retcode;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct___wait_terminated_22);"
		end

end
