class
	SD_XCLASSHINT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	res_name: CE_POINTER [INTEGER_8] assign set_res_name
		do
			create Result.make_shared (c_res_name (c_pointer))
		end

	res_class: CE_POINTER [INTEGER_8] assign set_res_class
		do
			create Result.make_shared (c_res_class (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_res_name (a_res_name: CE_POINTER [INTEGER_8])
		do
			c_set_res_name (c_pointer, a_res_name.c_pointer)
		end

	set_res_class (a_res_class: CE_POINTER [INTEGER_8])
		do
			c_set_res_class (c_pointer, a_res_class.c_pointer)
		end

feature {NONE} -- C getters

	c_res_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_XClassHint_432 *)$tmp)->res_name;"
		end

	c_res_class (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_XClassHint_432 *)$tmp)->res_class;"
		end

feature {NONE} -- C setters

	c_set_res_name (tmp: POINTER; a_res_name: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_XClassHint_432 *)$tmp)->res_name = (char *)$a_res_name;"
		end

	c_set_res_class (tmp: POINTER; a_res_class: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_XClassHint_432 *)$tmp)->res_class = (char *)$a_res_class;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_XClassHint_432);"
		end

end
