class
	SD_XERROREVENT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: INTEGER_32 assign set_type
		do
			Result := c_type (c_pointer)
		end

	display: CE_POINTER [ANY] assign set_display
		do
			create Result.make_shared (c_display (c_pointer))
		end

	resourceid: NATURAL_32 assign set_resourceid
		do
			Result := c_resourceid (c_pointer)
		end

	serial: NATURAL_32 assign set_serial
		do
			Result := c_serial (c_pointer)
		end

	error_code: NATURAL_8 assign set_error_code
		do
			Result := c_error_code (c_pointer)
		end

	request_code: NATURAL_8 assign set_request_code
		do
			Result := c_request_code (c_pointer)
		end

	minor_code: NATURAL_8 assign set_minor_code
		do
			Result := c_minor_code (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: INTEGER_32)
		do
			c_set_type (c_pointer, a_type)
		end

	set_display (a_display: CE_POINTER [ANY])
		do
			c_set_display (c_pointer, a_display.c_pointer)
		end

	set_resourceid (a_resourceid: NATURAL_32)
		do
			c_set_resourceid (c_pointer, a_resourceid)
		end

	set_serial (a_serial: NATURAL_32)
		do
			c_set_serial (c_pointer, a_serial)
		end

	set_error_code (a_error_code: NATURAL_8)
		do
			c_set_error_code (c_pointer, a_error_code)
		end

	set_request_code (a_request_code: NATURAL_8)
		do
			c_set_request_code (c_pointer, a_request_code)
		end

	set_minor_code (a_minor_code: NATURAL_8)
		do
			c_set_minor_code (c_pointer, a_minor_code)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XErrorEvent_398 *)$tmp)->type;"
		end

	c_display (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_XErrorEvent_398 *)$tmp)->display;"
		end

	c_resourceid (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XErrorEvent_398 *)$tmp)->resourceid;"
		end

	c_serial (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_XErrorEvent_398 *)$tmp)->serial;"
		end

	c_error_code (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct __anonstruct_XErrorEvent_398 *)$tmp)->error_code;"
		end

	c_request_code (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct __anonstruct_XErrorEvent_398 *)$tmp)->request_code;"
		end

	c_minor_code (tmp: POINTER): NATURAL_8
		external
			"C inline"
		alias
			"return (unsigned char)((struct __anonstruct_XErrorEvent_398 *)$tmp)->minor_code;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XErrorEvent_398 *)$tmp)->type = $a_type;"
		end

	c_set_display (tmp: POINTER; a_display: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_XErrorEvent_398 *)$tmp)->display = (void *)$a_display;"
		end

	c_set_resourceid (tmp: POINTER; a_resourceid: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XErrorEvent_398 *)$tmp)->resourceid = $a_resourceid;"
		end

	c_set_serial (tmp: POINTER; a_serial: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XErrorEvent_398 *)$tmp)->serial = $a_serial;"
		end

	c_set_error_code (tmp: POINTER; a_error_code: NATURAL_8)
		external
			"C inline"
		alias
			"((struct __anonstruct_XErrorEvent_398 *)$tmp)->error_code = $a_error_code;"
		end

	c_set_request_code (tmp: POINTER; a_request_code: NATURAL_8)
		external
			"C inline"
		alias
			"((struct __anonstruct_XErrorEvent_398 *)$tmp)->request_code = $a_request_code;"
		end

	c_set_minor_code (tmp: POINTER; a_minor_code: NATURAL_8)
		external
			"C inline"
		alias
			"((struct __anonstruct_XErrorEvent_398 *)$tmp)->minor_code = $a_minor_code;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_XErrorEvent_398);"
		end

end
