class
	SD_XPRIVDISPLAY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ext_data: CE_POINTER [SD_XEXTDATA] assign set_ext_data
		do
			create Result.make_shared (c_ext_data (c_pointer))
		end

	private1: CE_POINTER [ANY] assign set_private1
		do
			create Result.make_shared (c_private1 (c_pointer))
		end

	fd: INTEGER_32 assign set_fd
		do
			Result := c_fd (c_pointer)
		end

	private2: INTEGER_32 assign set_private2
		do
			Result := c_private2 (c_pointer)
		end

	proto_major_version: INTEGER_32 assign set_proto_major_version
		do
			Result := c_proto_major_version (c_pointer)
		end

	proto_minor_version: INTEGER_32 assign set_proto_minor_version
		do
			Result := c_proto_minor_version (c_pointer)
		end

	vendor: CE_POINTER [INTEGER_8] assign set_vendor
		do
			create Result.make_shared (c_vendor (c_pointer))
		end

	private3: NATURAL_32 assign set_private3
		do
			Result := c_private3 (c_pointer)
		end

	private4: NATURAL_32 assign set_private4
		do
			Result := c_private4 (c_pointer)
		end

	private5: NATURAL_32 assign set_private5
		do
			Result := c_private5 (c_pointer)
		end

	private6: INTEGER_32 assign set_private6
		do
			Result := c_private6 (c_pointer)
		end

	resource_alloc: CE_ROUTINE assign set_resource_alloc
		do
			create Result.make_shared (c_resource_alloc (c_pointer))
		end

	byte_order: INTEGER_32 assign set_byte_order
		do
			Result := c_byte_order (c_pointer)
		end

	bitmap_unit: INTEGER_32 assign set_bitmap_unit
		do
			Result := c_bitmap_unit (c_pointer)
		end

	bitmap_pad: INTEGER_32 assign set_bitmap_pad
		do
			Result := c_bitmap_pad (c_pointer)
		end

	bitmap_bit_order: INTEGER_32 assign set_bitmap_bit_order
		do
			Result := c_bitmap_bit_order (c_pointer)
		end

	nformats: INTEGER_32 assign set_nformats
		do
			Result := c_nformats (c_pointer)
		end

	pixmap_format: CE_POINTER [SD_SCREENFORMAT] assign set_pixmap_format
		do
			create Result.make_shared (c_pixmap_format (c_pointer))
		end

	private8: INTEGER_32 assign set_private8
		do
			Result := c_private8 (c_pointer)
		end

	release: INTEGER_32 assign set_release
		do
			Result := c_release (c_pointer)
		end

	private9: CE_POINTER [ANY] assign set_private9
		do
			create Result.make_shared (c_private9 (c_pointer))
		end

	private10: CE_POINTER [ANY] assign set_private10
		do
			create Result.make_shared (c_private10 (c_pointer))
		end

	qlen: INTEGER_32 assign set_qlen
		do
			Result := c_qlen (c_pointer)
		end

	last_request_read: NATURAL_32 assign set_last_request_read
		do
			Result := c_last_request_read (c_pointer)
		end

	request: NATURAL_32 assign set_request
		do
			Result := c_request (c_pointer)
		end

	private11: CE_POINTER [INTEGER_8] assign set_private11
		do
			create Result.make_shared (c_private11 (c_pointer))
		end

	private12: CE_POINTER [INTEGER_8] assign set_private12
		do
			create Result.make_shared (c_private12 (c_pointer))
		end

	private13: CE_POINTER [INTEGER_8] assign set_private13
		do
			create Result.make_shared (c_private13 (c_pointer))
		end

	private14: CE_POINTER [INTEGER_8] assign set_private14
		do
			create Result.make_shared (c_private14 (c_pointer))
		end

	max_request_size: NATURAL_32 assign set_max_request_size
		do
			Result := c_max_request_size (c_pointer)
		end

	db: CE_POINTER [ANY] assign set_db
		do
			create Result.make_shared (c_db (c_pointer))
		end

	private15: CE_ROUTINE assign set_private15
		do
			create Result.make_shared (c_private15 (c_pointer))
		end

	display_name: CE_POINTER [INTEGER_8] assign set_display_name
		do
			create Result.make_shared (c_display_name (c_pointer))
		end

	default_screen: INTEGER_32 assign set_default_screen
		do
			Result := c_default_screen (c_pointer)
		end

	nscreens: INTEGER_32 assign set_nscreens
		do
			Result := c_nscreens (c_pointer)
		end

	screens: CE_POINTER [SD_SCREEN] assign set_screens
		do
			create Result.make_shared (c_screens (c_pointer))
		end

	motion_buffer: NATURAL_32 assign set_motion_buffer
		do
			Result := c_motion_buffer (c_pointer)
		end

	private16: NATURAL_32 assign set_private16
		do
			Result := c_private16 (c_pointer)
		end

	min_keycode: INTEGER_32 assign set_min_keycode
		do
			Result := c_min_keycode (c_pointer)
		end

	max_keycode: INTEGER_32 assign set_max_keycode
		do
			Result := c_max_keycode (c_pointer)
		end

	private17: CE_POINTER [INTEGER_8] assign set_private17
		do
			create Result.make_shared (c_private17 (c_pointer))
		end

	private18: CE_POINTER [INTEGER_8] assign set_private18
		do
			create Result.make_shared (c_private18 (c_pointer))
		end

	private19: INTEGER_32 assign set_private19
		do
			Result := c_private19 (c_pointer)
		end

	xdefaults: CE_POINTER [INTEGER_8] assign set_xdefaults
		do
			create Result.make_shared (c_xdefaults (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_ext_data (a_ext_data: CE_POINTER [SD_XEXTDATA])
		do
			c_set_ext_data (c_pointer, a_ext_data.c_pointer)
		end

	set_private1 (a_private1: CE_POINTER [ANY])
		do
			c_set_private1 (c_pointer, a_private1.c_pointer)
		end

	set_fd (a_fd: INTEGER_32)
		do
			c_set_fd (c_pointer, a_fd)
		end

	set_private2 (a_private2: INTEGER_32)
		do
			c_set_private2 (c_pointer, a_private2)
		end

	set_proto_major_version (a_proto_major_version: INTEGER_32)
		do
			c_set_proto_major_version (c_pointer, a_proto_major_version)
		end

	set_proto_minor_version (a_proto_minor_version: INTEGER_32)
		do
			c_set_proto_minor_version (c_pointer, a_proto_minor_version)
		end

	set_vendor (a_vendor: CE_POINTER [INTEGER_8])
		do
			c_set_vendor (c_pointer, a_vendor.c_pointer)
		end

	set_private3 (a_private3: NATURAL_32)
		do
			c_set_private3 (c_pointer, a_private3)
		end

	set_private4 (a_private4: NATURAL_32)
		do
			c_set_private4 (c_pointer, a_private4)
		end

	set_private5 (a_private5: NATURAL_32)
		do
			c_set_private5 (c_pointer, a_private5)
		end

	set_private6 (a_private6: INTEGER_32)
		do
			c_set_private6 (c_pointer, a_private6)
		end

	set_resource_alloc (a_resource_alloc: CE_ROUTINE)
		do
			c_set_resource_alloc (c_pointer, a_resource_alloc.c_pointer)
		end

	set_byte_order (a_byte_order: INTEGER_32)
		do
			c_set_byte_order (c_pointer, a_byte_order)
		end

	set_bitmap_unit (a_bitmap_unit: INTEGER_32)
		do
			c_set_bitmap_unit (c_pointer, a_bitmap_unit)
		end

	set_bitmap_pad (a_bitmap_pad: INTEGER_32)
		do
			c_set_bitmap_pad (c_pointer, a_bitmap_pad)
		end

	set_bitmap_bit_order (a_bitmap_bit_order: INTEGER_32)
		do
			c_set_bitmap_bit_order (c_pointer, a_bitmap_bit_order)
		end

	set_nformats (a_nformats: INTEGER_32)
		do
			c_set_nformats (c_pointer, a_nformats)
		end

	set_pixmap_format (a_pixmap_format: CE_POINTER [SD_SCREENFORMAT])
		do
			c_set_pixmap_format (c_pointer, a_pixmap_format.c_pointer)
		end

	set_private8 (a_private8: INTEGER_32)
		do
			c_set_private8 (c_pointer, a_private8)
		end

	set_release (a_release: INTEGER_32)
		do
			c_set_release (c_pointer, a_release)
		end

	set_private9 (a_private9: CE_POINTER [ANY])
		do
			c_set_private9 (c_pointer, a_private9.c_pointer)
		end

	set_private10 (a_private10: CE_POINTER [ANY])
		do
			c_set_private10 (c_pointer, a_private10.c_pointer)
		end

	set_qlen (a_qlen: INTEGER_32)
		do
			c_set_qlen (c_pointer, a_qlen)
		end

	set_last_request_read (a_last_request_read: NATURAL_32)
		do
			c_set_last_request_read (c_pointer, a_last_request_read)
		end

	set_request (a_request: NATURAL_32)
		do
			c_set_request (c_pointer, a_request)
		end

	set_private11 (a_private11: CE_POINTER [INTEGER_8])
		do
			c_set_private11 (c_pointer, a_private11.c_pointer)
		end

	set_private12 (a_private12: CE_POINTER [INTEGER_8])
		do
			c_set_private12 (c_pointer, a_private12.c_pointer)
		end

	set_private13 (a_private13: CE_POINTER [INTEGER_8])
		do
			c_set_private13 (c_pointer, a_private13.c_pointer)
		end

	set_private14 (a_private14: CE_POINTER [INTEGER_8])
		do
			c_set_private14 (c_pointer, a_private14.c_pointer)
		end

	set_max_request_size (a_max_request_size: NATURAL_32)
		do
			c_set_max_request_size (c_pointer, a_max_request_size)
		end

	set_db (a_db: CE_POINTER [ANY])
		do
			c_set_db (c_pointer, a_db.c_pointer)
		end

	set_private15 (a_private15: CE_ROUTINE)
		do
			c_set_private15 (c_pointer, a_private15.c_pointer)
		end

	set_display_name (a_display_name: CE_POINTER [INTEGER_8])
		do
			c_set_display_name (c_pointer, a_display_name.c_pointer)
		end

	set_default_screen (a_default_screen: INTEGER_32)
		do
			c_set_default_screen (c_pointer, a_default_screen)
		end

	set_nscreens (a_nscreens: INTEGER_32)
		do
			c_set_nscreens (c_pointer, a_nscreens)
		end

	set_screens (a_screens: CE_POINTER [SD_SCREEN])
		do
			c_set_screens (c_pointer, a_screens.c_pointer)
		end

	set_motion_buffer (a_motion_buffer: NATURAL_32)
		do
			c_set_motion_buffer (c_pointer, a_motion_buffer)
		end

	set_private16 (a_private16: NATURAL_32)
		do
			c_set_private16 (c_pointer, a_private16)
		end

	set_min_keycode (a_min_keycode: INTEGER_32)
		do
			c_set_min_keycode (c_pointer, a_min_keycode)
		end

	set_max_keycode (a_max_keycode: INTEGER_32)
		do
			c_set_max_keycode (c_pointer, a_max_keycode)
		end

	set_private17 (a_private17: CE_POINTER [INTEGER_8])
		do
			c_set_private17 (c_pointer, a_private17.c_pointer)
		end

	set_private18 (a_private18: CE_POINTER [INTEGER_8])
		do
			c_set_private18 (c_pointer, a_private18.c_pointer)
		end

	set_private19 (a_private19: INTEGER_32)
		do
			c_set_private19 (c_pointer, a_private19)
		end

	set_xdefaults (a_xdefaults: CE_POINTER [INTEGER_8])
		do
			c_set_xdefaults (c_pointer, a_xdefaults.c_pointer)
		end

feature {NONE} -- C getters

	c_ext_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _XExtData *)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->ext_data;"
		end

	c_private1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private1;"
		end

	c_fd (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->fd;"
		end

	c_private2 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private2;"
		end

	c_proto_major_version (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->proto_major_version;"
		end

	c_proto_minor_version (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->proto_minor_version;"
		end

	c_vendor (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->vendor;"
		end

	c_private3 (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private3;"
		end

	c_private4 (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private4;"
		end

	c_private5 (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private5;"
		end

	c_private6 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private6;"
		end

	c_resource_alloc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned long( *)(void *))((struct __anonstruct__XPrivDisplay_367 *)$tmp)->resource_alloc;"
		end

	c_byte_order (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->byte_order;"
		end

	c_bitmap_unit (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->bitmap_unit;"
		end

	c_bitmap_pad (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->bitmap_pad;"
		end

	c_bitmap_bit_order (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->bitmap_bit_order;"
		end

	c_nformats (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->nformats;"
		end

	c_pixmap_format (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (ScreenFormat *)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->pixmap_format;"
		end

	c_private8 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private8;"
		end

	c_release (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->release;"
		end

	c_private9 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private9;"
		end

	c_private10 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private10;"
		end

	c_qlen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->qlen;"
		end

	c_last_request_read (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->last_request_read;"
		end

	c_request (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->request;"
		end

	c_private11 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private11;"
		end

	c_private12 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private12;"
		end

	c_private13 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private13;"
		end

	c_private14 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private14;"
		end

	c_max_request_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->max_request_size;"
		end

	c_db (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->db;"
		end

	c_private15 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void *))((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private15;"
		end

	c_display_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->display_name;"
		end

	c_default_screen (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->default_screen;"
		end

	c_nscreens (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->nscreens;"
		end

	c_screens (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (Screen *)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->screens;"
		end

	c_motion_buffer (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->motion_buffer;"
		end

	c_private16 (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private16;"
		end

	c_min_keycode (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->min_keycode;"
		end

	c_max_keycode (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->max_keycode;"
		end

	c_private17 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private17;"
		end

	c_private18 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private18;"
		end

	c_private19 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private19;"
		end

	c_xdefaults (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct__XPrivDisplay_367 *)$tmp)->xdefaults;"
		end

feature {NONE} -- C setters

	c_set_ext_data (tmp: POINTER; a_ext_data: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->ext_data = (struct _XExtData *)$a_ext_data;"
		end

	c_set_private1 (tmp: POINTER; a_private1: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private1 = (void *)$a_private1;"
		end

	c_set_fd (tmp: POINTER; a_fd: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->fd = $a_fd;"
		end

	c_set_private2 (tmp: POINTER; a_private2: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private2 = $a_private2;"
		end

	c_set_proto_major_version (tmp: POINTER; a_proto_major_version: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->proto_major_version = $a_proto_major_version;"
		end

	c_set_proto_minor_version (tmp: POINTER; a_proto_minor_version: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->proto_minor_version = $a_proto_minor_version;"
		end

	c_set_vendor (tmp: POINTER; a_vendor: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->vendor = (char *)$a_vendor;"
		end

	c_set_private3 (tmp: POINTER; a_private3: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private3 = $a_private3;"
		end

	c_set_private4 (tmp: POINTER; a_private4: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private4 = $a_private4;"
		end

	c_set_private5 (tmp: POINTER; a_private5: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private5 = $a_private5;"
		end

	c_set_private6 (tmp: POINTER; a_private6: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private6 = $a_private6;"
		end

	c_set_resource_alloc (tmp: POINTER; a_resource_alloc: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->resource_alloc = (unsigned long( *)(void *))$a_resource_alloc;"
		end

	c_set_byte_order (tmp: POINTER; a_byte_order: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->byte_order = $a_byte_order;"
		end

	c_set_bitmap_unit (tmp: POINTER; a_bitmap_unit: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->bitmap_unit = $a_bitmap_unit;"
		end

	c_set_bitmap_pad (tmp: POINTER; a_bitmap_pad: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->bitmap_pad = $a_bitmap_pad;"
		end

	c_set_bitmap_bit_order (tmp: POINTER; a_bitmap_bit_order: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->bitmap_bit_order = $a_bitmap_bit_order;"
		end

	c_set_nformats (tmp: POINTER; a_nformats: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->nformats = $a_nformats;"
		end

	c_set_pixmap_format (tmp: POINTER; a_pixmap_format: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->pixmap_format = (ScreenFormat *)$a_pixmap_format;"
		end

	c_set_private8 (tmp: POINTER; a_private8: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private8 = $a_private8;"
		end

	c_set_release (tmp: POINTER; a_release: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->release = $a_release;"
		end

	c_set_private9 (tmp: POINTER; a_private9: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private9 = (void *)$a_private9;"
		end

	c_set_private10 (tmp: POINTER; a_private10: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private10 = (void *)$a_private10;"
		end

	c_set_qlen (tmp: POINTER; a_qlen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->qlen = $a_qlen;"
		end

	c_set_last_request_read (tmp: POINTER; a_last_request_read: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->last_request_read = $a_last_request_read;"
		end

	c_set_request (tmp: POINTER; a_request: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->request = $a_request;"
		end

	c_set_private11 (tmp: POINTER; a_private11: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private11 = (char *)$a_private11;"
		end

	c_set_private12 (tmp: POINTER; a_private12: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private12 = (char *)$a_private12;"
		end

	c_set_private13 (tmp: POINTER; a_private13: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private13 = (char *)$a_private13;"
		end

	c_set_private14 (tmp: POINTER; a_private14: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private14 = (char *)$a_private14;"
		end

	c_set_max_request_size (tmp: POINTER; a_max_request_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->max_request_size = $a_max_request_size;"
		end

	c_set_db (tmp: POINTER; a_db: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->db = (void *)$a_db;"
		end

	c_set_private15 (tmp: POINTER; a_private15: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private15 = (int( *)(void *))$a_private15;"
		end

	c_set_display_name (tmp: POINTER; a_display_name: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->display_name = (char *)$a_display_name;"
		end

	c_set_default_screen (tmp: POINTER; a_default_screen: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->default_screen = $a_default_screen;"
		end

	c_set_nscreens (tmp: POINTER; a_nscreens: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->nscreens = $a_nscreens;"
		end

	c_set_screens (tmp: POINTER; a_screens: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->screens = (Screen *)$a_screens;"
		end

	c_set_motion_buffer (tmp: POINTER; a_motion_buffer: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->motion_buffer = $a_motion_buffer;"
		end

	c_set_private16 (tmp: POINTER; a_private16: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private16 = $a_private16;"
		end

	c_set_min_keycode (tmp: POINTER; a_min_keycode: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->min_keycode = $a_min_keycode;"
		end

	c_set_max_keycode (tmp: POINTER; a_max_keycode: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->max_keycode = $a_max_keycode;"
		end

	c_set_private17 (tmp: POINTER; a_private17: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private17 = (char *)$a_private17;"
		end

	c_set_private18 (tmp: POINTER; a_private18: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private18 = (char *)$a_private18;"
		end

	c_set_private19 (tmp: POINTER; a_private19: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->private19 = $a_private19;"
		end

	c_set_xdefaults (tmp: POINTER; a_xdefaults: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct__XPrivDisplay_367 *)$tmp)->xdefaults = (char *)$a_xdefaults;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct__XPrivDisplay_367);"
		end

end
