class
	SD_XSIZEHINTS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	flags: INTEGER_32 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

	x: INTEGER_32 assign set_x
		do
			Result := c_x (c_pointer)
		end

	y: INTEGER_32 assign set_y
		do
			Result := c_y (c_pointer)
		end

	width: INTEGER_32 assign set_width
		do
			Result := c_width (c_pointer)
		end

	height: INTEGER_32 assign set_height
		do
			Result := c_height (c_pointer)
		end

	min_width: INTEGER_32 assign set_min_width
		do
			Result := c_min_width (c_pointer)
		end

	min_height: INTEGER_32 assign set_min_height
		do
			Result := c_min_height (c_pointer)
		end

	max_width: INTEGER_32 assign set_max_width
		do
			Result := c_max_width (c_pointer)
		end

	max_height: INTEGER_32 assign set_max_height
		do
			Result := c_max_height (c_pointer)
		end

	width_inc: INTEGER_32 assign set_width_inc
		do
			Result := c_width_inc (c_pointer)
		end

	height_inc: INTEGER_32 assign set_height_inc
		do
			Result := c_height_inc (c_pointer)
		end

	min_aspect: SD_MIN_ASPECT assign set_min_aspect
		do
			create Result.make_shared (c_min_aspect (c_pointer))
		end

	max_aspect: SD_MIN_ASPECT assign set_max_aspect
		do
			create Result.make_shared (c_max_aspect (c_pointer))
		end

	base_width: INTEGER_32 assign set_base_width
		do
			Result := c_base_width (c_pointer)
		end

	base_height: INTEGER_32 assign set_base_height
		do
			Result := c_base_height (c_pointer)
		end

	win_gravity: INTEGER_32 assign set_win_gravity
		do
			Result := c_win_gravity (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_flags (a_flags: INTEGER_32)
		do
			c_set_flags (c_pointer, a_flags)
		end

	set_x (a_x: INTEGER_32)
		do
			c_set_x (c_pointer, a_x)
		end

	set_y (a_y: INTEGER_32)
		do
			c_set_y (c_pointer, a_y)
		end

	set_width (a_width: INTEGER_32)
		do
			c_set_width (c_pointer, a_width)
		end

	set_height (a_height: INTEGER_32)
		do
			c_set_height (c_pointer, a_height)
		end

	set_min_width (a_min_width: INTEGER_32)
		do
			c_set_min_width (c_pointer, a_min_width)
		end

	set_min_height (a_min_height: INTEGER_32)
		do
			c_set_min_height (c_pointer, a_min_height)
		end

	set_max_width (a_max_width: INTEGER_32)
		do
			c_set_max_width (c_pointer, a_max_width)
		end

	set_max_height (a_max_height: INTEGER_32)
		do
			c_set_max_height (c_pointer, a_max_height)
		end

	set_width_inc (a_width_inc: INTEGER_32)
		do
			c_set_width_inc (c_pointer, a_width_inc)
		end

	set_height_inc (a_height_inc: INTEGER_32)
		do
			c_set_height_inc (c_pointer, a_height_inc)
		end

	set_min_aspect (a_min_aspect: SD_MIN_ASPECT)
		do
			min_aspect.ce_gets (a_min_aspect)
		end

	set_max_aspect (a_max_aspect: SD_MIN_ASPECT)
		do
			max_aspect.ce_gets (a_max_aspect)
		end

	set_base_width (a_base_width: INTEGER_32)
		do
			c_set_base_width (c_pointer, a_base_width)
		end

	set_base_height (a_base_height: INTEGER_32)
		do
			c_set_base_height (c_pointer, a_base_height)
		end

	set_win_gravity (a_win_gravity: INTEGER_32)
		do
			c_set_win_gravity (c_pointer, a_win_gravity)
		end

feature {NONE} -- C getters

	c_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_XSizeHints_426 *)$tmp)->flags;"
		end

	c_x (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XSizeHints_426 *)$tmp)->x;"
		end

	c_y (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XSizeHints_426 *)$tmp)->y;"
		end

	c_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XSizeHints_426 *)$tmp)->width;"
		end

	c_height (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XSizeHints_426 *)$tmp)->height;"
		end

	c_min_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XSizeHints_426 *)$tmp)->min_width;"
		end

	c_min_height (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XSizeHints_426 *)$tmp)->min_height;"
		end

	c_max_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XSizeHints_426 *)$tmp)->max_width;"
		end

	c_max_height (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XSizeHints_426 *)$tmp)->max_height;"
		end

	c_width_inc (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XSizeHints_426 *)$tmp)->width_inc;"
		end

	c_height_inc (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XSizeHints_426 *)$tmp)->height_inc;"
		end

	c_min_aspect (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct __anonstruct_min_aspect_427 *)&((struct __anonstruct_XSizeHints_426 *)$tmp)->min_aspect;"
		end

	c_max_aspect (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct __anonstruct_min_aspect_427 *)&((struct __anonstruct_XSizeHints_426 *)$tmp)->max_aspect;"
		end

	c_base_width (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XSizeHints_426 *)$tmp)->base_width;"
		end

	c_base_height (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XSizeHints_426 *)$tmp)->base_height;"
		end

	c_win_gravity (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_XSizeHints_426 *)$tmp)->win_gravity;"
		end

feature {NONE} -- C setters

	c_set_flags (tmp: POINTER; a_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSizeHints_426 *)$tmp)->flags = $a_flags;"
		end

	c_set_x (tmp: POINTER; a_x: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSizeHints_426 *)$tmp)->x = $a_x;"
		end

	c_set_y (tmp: POINTER; a_y: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSizeHints_426 *)$tmp)->y = $a_y;"
		end

	c_set_width (tmp: POINTER; a_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSizeHints_426 *)$tmp)->width = $a_width;"
		end

	c_set_height (tmp: POINTER; a_height: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSizeHints_426 *)$tmp)->height = $a_height;"
		end

	c_set_min_width (tmp: POINTER; a_min_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSizeHints_426 *)$tmp)->min_width = $a_min_width;"
		end

	c_set_min_height (tmp: POINTER; a_min_height: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSizeHints_426 *)$tmp)->min_height = $a_min_height;"
		end

	c_set_max_width (tmp: POINTER; a_max_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSizeHints_426 *)$tmp)->max_width = $a_max_width;"
		end

	c_set_max_height (tmp: POINTER; a_max_height: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSizeHints_426 *)$tmp)->max_height = $a_max_height;"
		end

	c_set_width_inc (tmp: POINTER; a_width_inc: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSizeHints_426 *)$tmp)->width_inc = $a_width_inc;"
		end

	c_set_height_inc (tmp: POINTER; a_height_inc: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSizeHints_426 *)$tmp)->height_inc = $a_height_inc;"
		end

	c_set_base_width (tmp: POINTER; a_base_width: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSizeHints_426 *)$tmp)->base_width = $a_base_width;"
		end

	c_set_base_height (tmp: POINTER; a_base_height: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSizeHints_426 *)$tmp)->base_height = $a_base_height;"
		end

	c_set_win_gravity (tmp: POINTER; a_win_gravity: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_XSizeHints_426 *)$tmp)->win_gravity = $a_win_gravity;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sizeof(struct __anonstruct_XSizeHints_426);"
		end

end
