deferred class
	S_DLFCN

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	dlopen (a_file: CE_POINTER [INTEGER_8]; a_mode: INTEGER_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_dlopen (a_file.c_pointer, a_mode))
		end

	c_dlopen (a_file: POINTER; a_mode: INTEGER_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return dlopen($a_file, $a_mode);"
		end

	dlclose (a_handle: CE_POINTER [ANY]): INTEGER_32
		do
			Result := c_dlclose (a_handle.c_pointer)
		end

	c_dlclose (a_handle: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return dlclose($a_handle);"
		end

	dlsym (a_handle: CE_POINTER [ANY]; a_name: CE_POINTER [INTEGER_8]): CE_POINTER [ANY]
		do
			create Result.make_shared (c_dlsym (a_handle.c_pointer, a_name.c_pointer))
		end

	c_dlsym (a_handle: POINTER; a_name: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return dlsym($a_handle, $a_name);"
		end

	dlerror: CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_dlerror)
		end

	c_dlerror: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return dlerror();"
		end

end
