deferred class
	S_FCNTL

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	open (a_args: TUPLE [a_file: CE_POINTER [INTEGER_8]; a_oflag: INTEGER_32]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_open)).integer_32_item (a_args)
		end

	c_open: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return &open;"
		end

	fcntl (a_args: TUPLE [a_fd: INTEGER_32; a_cmd: INTEGER_32]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_fcntl)).integer_32_item (a_args)
		end

	c_fcntl: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return &fcntl;"
		end

end
