deferred class
	S_LIBINTL

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	gettext (a_msgid: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_gettext (a_msgid.c_pointer))
		end

	c_gettext (a_msgid: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return gettext($a_msgid);"
		end

	textdomain (a_domainname: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_textdomain (a_domainname.c_pointer))
		end

	c_textdomain (a_domainname: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return textdomain($a_domainname);"
		end

	bindtextdomain (a_domainname: CE_POINTER [INTEGER_8]; a_dirname: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_bindtextdomain (a_domainname.c_pointer, a_dirname.c_pointer))
		end

	c_bindtextdomain (a_domainname: POINTER; a_dirname: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return bindtextdomain($a_domainname, $a_dirname);"
		end

	bind_textdomain_codeset (a_domainname: CE_POINTER [INTEGER_8]; a_codeset: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_bind_textdomain_codeset (a_domainname.c_pointer, a_codeset.c_pointer))
		end

	c_bind_textdomain_codeset (a_domainname: POINTER; a_codeset: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return bind_textdomain_codeset($a_domainname, $a_codeset);"
		end

end
