deferred class
	S_LIBIO

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	IO_putc (a_c: INTEGER_32; a_fp: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_IO_putc (a_c, a_fp.c_pointer)
		end

	c_IO_putc (a_c: INTEGER_32; a_fp: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return _IO_putc($a_c, $a_fp);"
		end

	IO_getc (a_fp: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_IO_getc (a_fp.c_pointer)
		end

	c_IO_getc (a_fp: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return _IO_getc($a_fp);"
		end

end
