deferred class
	S_PANGO_PANGO

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	pango_attr_list_unref (a_list: CE_POINTER [ANY])
		do
			c_pango_attr_list_unref (a_list.c_pointer)
		end

	c_pango_attr_list_unref (a_list: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"pango_attr_list_unref($a_list);"
		end

	pango_attr_list_get_iterator (a_list: CE_POINTER [ANY]): CE_POINTER [ANY]
		do
			create Result.make_shared (c_pango_attr_list_get_iterator (a_list.c_pointer))
		end

	c_pango_attr_list_get_iterator (a_list: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return pango_attr_list_get_iterator($a_list);"
		end

	pango_attr_iterator_range (a_iterator: CE_POINTER [ANY]; a_start: CE_POINTER [INTEGER_32]; a_end: CE_POINTER [INTEGER_32])
		do
			c_pango_attr_iterator_range (a_iterator.c_pointer, a_start.c_pointer, a_end.c_pointer)
		end

	c_pango_attr_iterator_range (a_iterator: POINTER; a_start: POINTER; a_end: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"pango_attr_iterator_range($a_iterator, $a_start, $a_end);"
		end

	pango_attr_iterator_next (a_iterator: CE_POINTER [ANY]): INTEGER_32
		do
			Result := c_pango_attr_iterator_next (a_iterator.c_pointer)
		end

	c_pango_attr_iterator_next (a_iterator: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return pango_attr_iterator_next($a_iterator);"
		end

	pango_attr_iterator_destroy (a_iterator: CE_POINTER [ANY])
		do
			c_pango_attr_iterator_destroy (a_iterator.c_pointer)
		end

	c_pango_attr_iterator_destroy (a_iterator: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"pango_attr_iterator_destroy($a_iterator);"
		end

	pango_attr_iterator_get (a_iterator: CE_POINTER [ANY]; a_type: INTEGER_32): CE_POINTER [SD_PANGOATTRIBUTE]
		do
			create Result.make_shared (c_pango_attr_iterator_get (a_iterator.c_pointer, a_type))
		end

	c_pango_attr_iterator_get (a_iterator: POINTER; a_type: INTEGER_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return pango_attr_iterator_get($a_iterator, $a_type);"
		end

	pango_font_description_equal (a_desc1: CE_POINTER [ANY]; a_desc2: CE_POINTER [ANY]): INTEGER_32
		do
			Result := c_pango_font_description_equal (a_desc1.c_pointer, a_desc2.c_pointer)
		end

	c_pango_font_description_equal (a_desc1: POINTER; a_desc2: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return pango_font_description_equal($a_desc1, $a_desc2);"
		end

	pango_coverage_unref (a_coverage: CE_POINTER [ANY])
		do
			c_pango_coverage_unref (a_coverage.c_pointer)
		end

	c_pango_coverage_unref (a_coverage: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"pango_coverage_unref($a_coverage);"
		end

	pango_coverage_get (a_coverage: CE_POINTER [ANY]; a_index_: INTEGER_32): INTEGER_32
		do
			Result := c_pango_coverage_get (a_coverage.c_pointer, a_index_)
		end

	c_pango_coverage_get (a_coverage: POINTER; a_index_: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return pango_coverage_get($a_coverage, $a_index_);"
		end

	pango_language_from_string (a_language: CE_POINTER [INTEGER_8]): CE_POINTER [ANY]
		do
			create Result.make_shared (c_pango_language_from_string (a_language.c_pointer))
		end

	c_pango_language_from_string (a_language: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return pango_language_from_string($a_language);"
		end

	pango_font_description_copy_static (a_desc: CE_POINTER [ANY]): CE_POINTER [ANY]
		do
			create Result.make_shared (c_pango_font_description_copy_static (a_desc.c_pointer))
		end

	c_pango_font_description_copy_static (a_desc: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return pango_font_description_copy_static($a_desc);"
		end

	pango_font_description_free (a_desc: CE_POINTER [ANY])
		do
			c_pango_font_description_free (a_desc.c_pointer)
		end

	c_pango_font_description_free (a_desc: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"pango_font_description_free($a_desc);"
		end

	pango_font_description_set_weight (a_desc: CE_POINTER [ANY]; a_weight: INTEGER_32)
		do
			c_pango_font_description_set_weight (a_desc.c_pointer, a_weight)
		end

	c_pango_font_description_set_weight (a_desc: POINTER; a_weight: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"pango_font_description_set_weight($a_desc, $a_weight);"
		end

	pango_font_description_set_size (a_desc: CE_POINTER [ANY]; a_size: INTEGER_32)
		do
			c_pango_font_description_set_size (a_desc.c_pointer, a_size)
		end

	c_pango_font_description_set_size (a_desc: POINTER; a_size: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"pango_font_description_set_size($a_desc, $a_size);"
		end

	pango_font_description_get_size (a_desc: CE_POINTER [ANY]): INTEGER_32
		do
			Result := c_pango_font_description_get_size (a_desc.c_pointer)
		end

	c_pango_font_description_get_size (a_desc: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return pango_font_description_get_size($a_desc);"
		end

	pango_font_description_from_string (a_str: CE_POINTER [INTEGER_8]): CE_POINTER [ANY]
		do
			create Result.make_shared (c_pango_font_description_from_string (a_str.c_pointer))
		end

	c_pango_font_description_from_string (a_str: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return pango_font_description_from_string($a_str);"
		end

	pango_font_description_to_string (a_desc: CE_POINTER [ANY]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_pango_font_description_to_string (a_desc.c_pointer))
		end

	c_pango_font_description_to_string (a_desc: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return pango_font_description_to_string($a_desc);"
		end

	pango_font_metrics_unref (a_metrics: CE_POINTER [ANY])
		do
			c_pango_font_metrics_unref (a_metrics.c_pointer)
		end

	c_pango_font_metrics_unref (a_metrics: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"pango_font_metrics_unref($a_metrics);"
		end

	pango_font_metrics_get_ascent (a_metrics: CE_POINTER [ANY]): INTEGER_32
		do
			Result := c_pango_font_metrics_get_ascent (a_metrics.c_pointer)
		end

	c_pango_font_metrics_get_ascent (a_metrics: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return pango_font_metrics_get_ascent($a_metrics);"
		end

	pango_font_metrics_get_descent (a_metrics: CE_POINTER [ANY]): INTEGER_32
		do
			Result := c_pango_font_metrics_get_descent (a_metrics.c_pointer)
		end

	c_pango_font_metrics_get_descent (a_metrics: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return pango_font_metrics_get_descent($a_metrics);"
		end

	pango_font_get_coverage (a_font: CE_POINTER [ANY]; a_language: CE_POINTER [ANY]): CE_POINTER [ANY]
		do
			create Result.make_shared (c_pango_font_get_coverage (a_font.c_pointer, a_language.c_pointer))
		end

	c_pango_font_get_coverage (a_font: POINTER; a_language: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return pango_font_get_coverage($a_font, $a_language);"
		end

	pango_font_get_glyph_extents (a_font: CE_POINTER [ANY]; a_glyph: NATURAL_32; a_ink_rect: CE_POINTER [SD_PANGORECTANGLE]; a_logical_rect: CE_POINTER [SD_PANGORECTANGLE])
		do
			c_pango_font_get_glyph_extents (a_font.c_pointer, a_glyph, a_ink_rect.c_pointer, a_logical_rect.c_pointer)
		end

	c_pango_font_get_glyph_extents (a_font: POINTER; a_glyph: NATURAL_32; a_ink_rect: POINTER; a_logical_rect: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"pango_font_get_glyph_extents($a_font, $a_glyph, $a_ink_rect, $a_logical_rect);"
		end

	pango_attr_style_new (a_style: INTEGER_32): CE_POINTER [SD_PANGOATTRIBUTE]
		do
			create Result.make_shared (c_pango_attr_style_new (a_style))
		end

	c_pango_attr_style_new (a_style: INTEGER_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return pango_attr_style_new($a_style);"
		end

	pango_attr_weight_new (a_weight: INTEGER_32): CE_POINTER [SD_PANGOATTRIBUTE]
		do
			create Result.make_shared (c_pango_attr_weight_new (a_weight))
		end

	c_pango_attr_weight_new (a_weight: INTEGER_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return pango_attr_weight_new($a_weight);"
		end

	pango_attr_font_desc_new (a_desc: CE_POINTER [ANY]): CE_POINTER [SD_PANGOATTRIBUTE]
		do
			create Result.make_shared (c_pango_attr_font_desc_new (a_desc.c_pointer))
		end

	c_pango_attr_font_desc_new (a_desc: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return pango_attr_font_desc_new($a_desc);"
		end

	pango_attr_list_new: CE_POINTER [ANY]
		do
			create Result.make_shared (c_pango_attr_list_new)
		end

	c_pango_attr_list_new: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return pango_attr_list_new();"
		end

	pango_attr_list_insert (a_list: CE_POINTER [ANY]; a_attr: CE_POINTER [SD_PANGOATTRIBUTE])
		do
			c_pango_attr_list_insert (a_list.c_pointer, a_attr.c_pointer)
		end

	c_pango_attr_list_insert (a_list: POINTER; a_attr: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"pango_attr_list_insert($a_list, $a_attr);"
		end

	pango_item_free (a_item: CE_POINTER [SD_PANGOITEM])
		do
			c_pango_item_free (a_item.c_pointer)
		end

	c_pango_item_free (a_item: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"pango_item_free($a_item);"
		end

	pango_item_free_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent pango_item_free)
		end

	pango_context_load_font (a_context: CE_POINTER [ANY]; a_desc: CE_POINTER [ANY]): CE_POINTER [ANY]
		do
			create Result.make_shared (c_pango_context_load_font (a_context.c_pointer, a_desc.c_pointer))
		end

	c_pango_context_load_font (a_context: POINTER; a_desc: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return pango_context_load_font($a_context, $a_desc);"
		end

	pango_context_get_metrics (a_context: CE_POINTER [ANY]; a_desc: CE_POINTER [ANY]; a_language: CE_POINTER [ANY]): CE_POINTER [ANY]
		do
			create Result.make_shared (c_pango_context_get_metrics (a_context.c_pointer, a_desc.c_pointer, a_language.c_pointer))
		end

	c_pango_context_get_metrics (a_context: POINTER; a_desc: POINTER; a_language: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return pango_context_get_metrics($a_context, $a_desc, $a_language);"
		end

	pango_context_set_font_description (a_context: CE_POINTER [ANY]; a_desc: CE_POINTER [ANY])
		do
			c_pango_context_set_font_description (a_context.c_pointer, a_desc.c_pointer)
		end

	c_pango_context_set_font_description (a_context: POINTER; a_desc: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"pango_context_set_font_description($a_context, $a_desc);"
		end

	pango_context_get_language (a_context: CE_POINTER [ANY]): CE_POINTER [ANY]
		do
			create Result.make_shared (c_pango_context_get_language (a_context.c_pointer))
		end

	c_pango_context_get_language (a_context: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return pango_context_get_language($a_context);"
		end

	pango_context_set_base_dir (a_context: CE_POINTER [ANY]; a_direction: INTEGER_32)
		do
			c_pango_context_set_base_dir (a_context.c_pointer, a_direction)
		end

	c_pango_context_set_base_dir (a_context: POINTER; a_direction: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"pango_context_set_base_dir($a_context, $a_direction);"
		end

	pango_itemize (a_context: CE_POINTER [ANY]; a_text: CE_POINTER [INTEGER_8]; a_start_index: INTEGER_32; a_length: INTEGER_32; a_attrs: CE_POINTER [ANY]; a_cached_iter: CE_POINTER [ANY]): CE_POINTER [SD_GLIST]
		do
			create Result.make_shared (c_pango_itemize (a_context.c_pointer, a_text.c_pointer, a_start_index, a_length, a_attrs.c_pointer, a_cached_iter.c_pointer))
		end

	c_pango_itemize (a_context: POINTER; a_text: POINTER; a_start_index: INTEGER_32; a_length: INTEGER_32; a_attrs: POINTER; a_cached_iter: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return pango_itemize($a_context, $a_text, $a_start_index, $a_length, $a_attrs, $a_cached_iter);"
		end

	pango_glyph_string_new: CE_POINTER [SD_PANGOGLYPHSTRING]
		do
			create Result.make_shared (c_pango_glyph_string_new)
		end

	c_pango_glyph_string_new: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return pango_glyph_string_new();"
		end

	pango_glyph_string_set_size (a_string: CE_POINTER [SD_PANGOGLYPHSTRING]; a_new_len: INTEGER_32)
		do
			c_pango_glyph_string_set_size (a_string.c_pointer, a_new_len)
		end

	c_pango_glyph_string_set_size (a_string: POINTER; a_new_len: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"pango_glyph_string_set_size($a_string, $a_new_len);"
		end

	pango_glyph_string_free (a_string: CE_POINTER [SD_PANGOGLYPHSTRING])
		do
			c_pango_glyph_string_free (a_string.c_pointer)
		end

	c_pango_glyph_string_free (a_string: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"pango_glyph_string_free($a_string);"
		end

	pango_shape (a_text: CE_POINTER [INTEGER_8]; a_length: INTEGER_32; a_analysis: CE_POINTER [SD_PANGOANALYSIS]; a_glyphs: CE_POINTER [SD_PANGOGLYPHSTRING])
		do
			c_pango_shape (a_text.c_pointer, a_length, a_analysis.c_pointer, a_glyphs.c_pointer)
		end

	c_pango_shape (a_text: POINTER; a_length: INTEGER_32; a_analysis: POINTER; a_glyphs: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"pango_shape($a_text, $a_length, $a_analysis, $a_glyphs);"
		end

	pango_layout_new (a_context: CE_POINTER [ANY]): CE_POINTER [ANY]
		do
			create Result.make_shared (c_pango_layout_new (a_context.c_pointer))
		end

	c_pango_layout_new (a_context: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return pango_layout_new($a_context);"
		end

	pango_layout_set_text (a_layout: CE_POINTER [ANY]; a_text: CE_POINTER [INTEGER_8]; a_length: INTEGER_32)
		do
			c_pango_layout_set_text (a_layout.c_pointer, a_text.c_pointer, a_length)
		end

	c_pango_layout_set_text (a_layout: POINTER; a_text: POINTER; a_length: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"pango_layout_set_text($a_layout, $a_text, $a_length);"
		end

	pango_layout_get_size (a_layout: CE_POINTER [ANY]; a_width: CE_POINTER [INTEGER_32]; a_height: CE_POINTER [INTEGER_32])
		do
			c_pango_layout_get_size (a_layout.c_pointer, a_width.c_pointer, a_height.c_pointer)
		end

	c_pango_layout_get_size (a_layout: POINTER; a_width: POINTER; a_height: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"pango_layout_get_size($a_layout, $a_width, $a_height);"
		end

	pango_attr_foreground_new (a_red: NATURAL_16; a_green: NATURAL_16; a_blue: NATURAL_16): CE_POINTER [SD_PANGOATTRIBUTE]
		do
			create Result.make_shared (c_pango_attr_foreground_new (a_red, a_green, a_blue))
		end

	c_pango_attr_foreground_new (a_red: NATURAL_16; a_green: NATURAL_16; a_blue: NATURAL_16): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return pango_attr_foreground_new($a_red, $a_green, $a_blue);"
		end

	pango_layout_set_width (a_layout: CE_POINTER [ANY]; a_width: INTEGER_32)
		do
			c_pango_layout_set_width (a_layout.c_pointer, a_width)
		end

	c_pango_layout_set_width (a_layout: POINTER; a_width: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"pango_layout_set_width($a_layout, $a_width);"
		end

	pango_layout_set_wrap (a_layout: CE_POINTER [ANY]; a_wrap: INTEGER_32)
		do
			c_pango_layout_set_wrap (a_layout.c_pointer, a_wrap)
		end

	c_pango_layout_set_wrap (a_layout: POINTER; a_wrap: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"pango_layout_set_wrap($a_layout, $a_wrap);"
		end

end
