deferred class
	S_SYS_WAIT

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	wait (a_stat_loc: CE_POINTER [SD_WAIT]): INTEGER_32
		do
			Result := c_wait (a_stat_loc.c_pointer)
		end

	c_wait (a_stat_loc: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return wait($a_stat_loc);"
		end

	waitpid (a_pid: INTEGER_32; a_stat_loc: CE_POINTER [INTEGER_32]; a_options: INTEGER_32): INTEGER_32
		do
			Result := c_waitpid (a_pid, a_stat_loc.c_pointer, a_options)
		end

	c_waitpid (a_pid: INTEGER_32; a_stat_loc: POINTER; a_options: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return waitpid($a_pid, $a_stat_loc, $a_options);"
		end

end
