class
	PD_ADDRENTRY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	ina4: SD_IN_ADDR assign set_ina4
		do
			create Result.make_shared (c_ina4 (c_pointer))
		end

	ina4_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(union __anonunion_addrentry_72, ina4);"
		end

	ina6: SD_IN6_ADDR assign set_ina6
		do
			create Result.make_shared (c_ina6 (c_pointer))
		end

	ina6_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(union __anonunion_addrentry_72, ina6);"
		end

feature {ANY} -- Eiffel setters

	set_ina4 (a_ina4: SD_IN_ADDR)
		do
			ina4.ce_gets (a_ina4)
		end

	set_ina6 (a_ina6: SD_IN6_ADDR)
		do
			ina6.ce_gets (a_ina6)
		end

feature {NONE} -- C getters

	c_ina4 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct in_addr *)&((union __anonunion_addrentry_72 *)$tmp)->ina4;"
		end

	c_ina6 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct in6_addr *)&((union __anonunion_addrentry_72 *)$tmp)->ina6;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(union __anonunion_addrentry_72);"
		end

end
