class
	PD_AUTH

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	want: INTEGER_32 assign set_want
		do
			Result := c_want (c_pointer)
		end

	picked: INTEGER_32 assign set_picked
		do
			Result := c_picked (c_pointer)
		end

	avail: INTEGER_32 assign set_avail
		do
			Result := c_avail (c_pointer)
		end

	done: BOOLEAN assign set_done
		do
			Result := c_done (c_pointer)
		end

	multi: BOOLEAN assign set_multi
		do
			Result := c_multi (c_pointer)
		end

	iestyle: BOOLEAN assign set_iestyle
		do
			Result := c_iestyle (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_want (a_want: INTEGER_32)
		do
			c_set_want (c_pointer, a_want)
		end

	set_picked (a_picked: INTEGER_32)
		do
			c_set_picked (c_pointer, a_picked)
		end

	set_avail (a_avail: INTEGER_32)
		do
			c_set_avail (c_pointer, a_avail)
		end

	set_done (a_done: BOOLEAN)
		do
			c_set_done (c_pointer, a_done)
		end

	set_multi (a_multi: BOOLEAN)
		do
			c_set_multi (c_pointer, a_multi)
		end

	set_iestyle (a_iestyle: BOOLEAN)
		do
			c_set_iestyle (c_pointer, a_iestyle)
		end

feature {NONE} -- C getters

	c_want (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct auth *)$tmp)->want;"
		end

	c_picked (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct auth *)$tmp)->picked;"
		end

	c_avail (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct auth *)$tmp)->avail;"
		end

	c_done (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct auth *)$tmp)->done;"
		end

	c_multi (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct auth *)$tmp)->multi;"
		end

	c_iestyle (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct auth *)$tmp)->iestyle;"
		end

feature {NONE} -- C setters

	c_set_want (tmp: POINTER; a_want: INTEGER_32)
		external
			"C inline"
		alias
			"((struct auth *)$tmp)->want = $a_want;"
		end

	c_set_picked (tmp: POINTER; a_picked: INTEGER_32)
		external
			"C inline"
		alias
			"((struct auth *)$tmp)->picked = $a_picked;"
		end

	c_set_avail (tmp: POINTER; a_avail: INTEGER_32)
		external
			"C inline"
		alias
			"((struct auth *)$tmp)->avail = $a_avail;"
		end

	c_set_done (tmp: POINTER; a_done: BOOLEAN)
		external
			"C inline"
		alias
			"((struct auth *)$tmp)->done = $a_done;"
		end

	c_set_multi (tmp: POINTER; a_multi: BOOLEAN)
		external
			"C inline"
		alias
			"((struct auth *)$tmp)->multi = $a_multi;"
		end

	c_set_iestyle (tmp: POINTER; a_iestyle: BOOLEAN)
		external
			"C inline"
		alias
			"((struct auth *)$tmp)->iestyle = $a_iestyle;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct auth);"
		end

end
