class
	PD_CURL_CERTINFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	num_of_certs: INTEGER_32 assign set_num_of_certs
		do
			Result := c_num_of_certs (c_pointer)
		end

	certinfo: CE_POINTER [CE_POINTER [PD_CURL_SLIST]] assign set_certinfo
		do
			create Result.make_shared (c_certinfo (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_num_of_certs (a_num_of_certs: INTEGER_32)
		do
			c_set_num_of_certs (c_pointer, a_num_of_certs)
		end

	set_certinfo (a_certinfo: CE_POINTER [CE_POINTER [PD_CURL_SLIST]])
		do
			c_set_certinfo (c_pointer, a_certinfo.c_pointer)
		end

feature {NONE} -- C getters

	c_num_of_certs (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct curl_certinfo *)$tmp)->num_of_certs;"
		end

	c_certinfo (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_slist * *)((struct curl_certinfo *)$tmp)->certinfo;"
		end

feature {NONE} -- C setters

	c_set_num_of_certs (tmp: POINTER; a_num_of_certs: INTEGER_32)
		external
			"C inline"
		alias
			"((struct curl_certinfo *)$tmp)->num_of_certs = $a_num_of_certs;"
		end

	c_set_certinfo (tmp: POINTER; a_certinfo: POINTER)
		external
			"C inline"
		alias
			"((struct curl_certinfo *)$tmp)->certinfo = (struct curl_slist * *)$a_certinfo;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct curl_certinfo);"
		end

end
