class
	PD_CURL_KHKEY

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	key: CE_POINTER [INTEGER_8] assign set_key
		do
			create Result.make_shared (c_key (c_pointer))
		end

	len: NATURAL_32 assign set_len
		do
			Result := c_len (c_pointer)
		end

	keytype: INTEGER_32 assign set_keytype
		do
			Result := c_keytype (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_key (a_key: CE_POINTER [INTEGER_8])
		do
			c_set_key (c_pointer, a_key.c_pointer)
		end

	set_len (a_len: NATURAL_32)
		do
			c_set_len (c_pointer, a_len)
		end

	set_keytype (a_keytype: INTEGER_32)
		do
			c_set_keytype (c_pointer, a_keytype)
		end

feature {NONE} -- C getters

	c_key (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct curl_khkey *)$tmp)->key;"
		end

	c_len (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct curl_khkey *)$tmp)->len;"
		end

	c_keytype (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct curl_khkey *)$tmp)->keytype;"
		end

feature {NONE} -- C setters

	c_set_key (tmp: POINTER; a_key: POINTER)
		external
			"C inline"
		alias
			"((struct curl_khkey *)$tmp)->key = (char const *)$a_key;"
		end

	c_set_len (tmp: POINTER; a_len: NATURAL_32)
		external
			"C inline"
		alias
			"((struct curl_khkey *)$tmp)->len = $a_len;"
		end

	c_set_keytype (tmp: POINTER; a_keytype: INTEGER_32)
		external
			"C inline"
		alias
			"((struct curl_khkey *)$tmp)->keytype = $a_keytype;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct curl_khkey);"
		end

end
