class
	PD_CURL_MESSAGE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	extmsg: PD_CURLMSG assign set_extmsg
		do
			create Result.make_shared (c_extmsg (c_pointer))
		end

	extmsg_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct Curl_message, extmsg);"
		end

feature {ANY} -- Eiffel setters

	set_extmsg (a_extmsg: PD_CURLMSG)
		do
			extmsg.ce_gets (a_extmsg)
		end

feature {NONE} -- C getters

	c_extmsg (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct CURLMsg *)&((struct Curl_message *)$tmp)->extmsg;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct Curl_message);"
		end

end
