class
	PD_CURL_SLIST

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	data: CE_POINTER [INTEGER_8] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	next: CE_POINTER [PD_CURL_SLIST] assign set_next
		do
			create Result.make_shared (c_next (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_data (a_data: CE_POINTER [INTEGER_8])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

	set_next (a_next: CE_POINTER [PD_CURL_SLIST])
		do
			c_set_next (c_pointer, a_next.c_pointer)
		end

feature {NONE} -- C getters

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct curl_slist *)$tmp)->data;"
		end

	c_next (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_slist *)((struct curl_slist *)$tmp)->next;"
		end

feature {NONE} -- C setters

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct curl_slist *)$tmp)->data = (char *)$a_data;"
		end

	c_set_next (tmp: POINTER; a_next: POINTER)
		external
			"C inline"
		alias
			"((struct curl_slist *)$tmp)->next = (struct curl_slist *)$a_next;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct curl_slist);"
		end

end
