class
	PD_CURL_VERSION_INFO_DATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	age: INTEGER_32 assign set_age
		do
			Result := c_age (c_pointer)
		end

	version: CE_POINTER [INTEGER_8] assign set_version
		do
			create Result.make_shared (c_version (c_pointer))
		end

	version_num: NATURAL_32 assign set_version_num
		do
			Result := c_version_num (c_pointer)
		end

	host: CE_POINTER [INTEGER_8] assign set_host
		do
			create Result.make_shared (c_host (c_pointer))
		end

	features: INTEGER_32 assign set_features
		do
			Result := c_features (c_pointer)
		end

	ssl_version: CE_POINTER [INTEGER_8] assign set_ssl_version
		do
			create Result.make_shared (c_ssl_version (c_pointer))
		end

	ssl_version_num: INTEGER_32 assign set_ssl_version_num
		do
			Result := c_ssl_version_num (c_pointer)
		end

	libz_version: CE_POINTER [INTEGER_8] assign set_libz_version
		do
			create Result.make_shared (c_libz_version (c_pointer))
		end

	protocols: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_protocols
		do
			create Result.make_shared (c_protocols (c_pointer))
		end

	ares: CE_POINTER [INTEGER_8] assign set_ares
		do
			create Result.make_shared (c_ares (c_pointer))
		end

	ares_num: INTEGER_32 assign set_ares_num
		do
			Result := c_ares_num (c_pointer)
		end

	libidn: CE_POINTER [INTEGER_8] assign set_libidn
		do
			create Result.make_shared (c_libidn (c_pointer))
		end

	iconv_ver_num: INTEGER_32 assign set_iconv_ver_num
		do
			Result := c_iconv_ver_num (c_pointer)
		end

	libssh_version: CE_POINTER [INTEGER_8] assign set_libssh_version
		do
			create Result.make_shared (c_libssh_version (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_age (a_age: INTEGER_32)
		do
			c_set_age (c_pointer, a_age)
		end

	set_version (a_version: CE_POINTER [INTEGER_8])
		do
			c_set_version (c_pointer, a_version.c_pointer)
		end

	set_version_num (a_version_num: NATURAL_32)
		do
			c_set_version_num (c_pointer, a_version_num)
		end

	set_host (a_host: CE_POINTER [INTEGER_8])
		do
			c_set_host (c_pointer, a_host.c_pointer)
		end

	set_features (a_features: INTEGER_32)
		do
			c_set_features (c_pointer, a_features)
		end

	set_ssl_version (a_ssl_version: CE_POINTER [INTEGER_8])
		do
			c_set_ssl_version (c_pointer, a_ssl_version.c_pointer)
		end

	set_ssl_version_num (a_ssl_version_num: INTEGER_32)
		do
			c_set_ssl_version_num (c_pointer, a_ssl_version_num)
		end

	set_libz_version (a_libz_version: CE_POINTER [INTEGER_8])
		do
			c_set_libz_version (c_pointer, a_libz_version.c_pointer)
		end

	set_protocols (a_protocols: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			c_set_protocols (c_pointer, a_protocols.c_pointer)
		end

	set_ares (a_ares: CE_POINTER [INTEGER_8])
		do
			c_set_ares (c_pointer, a_ares.c_pointer)
		end

	set_ares_num (a_ares_num: INTEGER_32)
		do
			c_set_ares_num (c_pointer, a_ares_num)
		end

	set_libidn (a_libidn: CE_POINTER [INTEGER_8])
		do
			c_set_libidn (c_pointer, a_libidn.c_pointer)
		end

	set_iconv_ver_num (a_iconv_ver_num: INTEGER_32)
		do
			c_set_iconv_ver_num (c_pointer, a_iconv_ver_num)
		end

	set_libssh_version (a_libssh_version: CE_POINTER [INTEGER_8])
		do
			c_set_libssh_version (c_pointer, a_libssh_version.c_pointer)
		end

feature {NONE} -- C getters

	c_age (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_curl_version_info_data_61 *)$tmp)->age;"
		end

	c_version (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_curl_version_info_data_61 *)$tmp)->version;"
		end

	c_version_num (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_curl_version_info_data_61 *)$tmp)->version_num;"
		end

	c_host (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_curl_version_info_data_61 *)$tmp)->host;"
		end

	c_features (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_curl_version_info_data_61 *)$tmp)->features;"
		end

	c_ssl_version (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_curl_version_info_data_61 *)$tmp)->ssl_version;"
		end

	c_ssl_version_num (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_curl_version_info_data_61 *)$tmp)->ssl_version_num;"
		end

	c_libz_version (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_curl_version_info_data_61 *)$tmp)->libz_version;"
		end

	c_protocols (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char * *)((struct __anonstruct_curl_version_info_data_61 *)$tmp)->protocols;"
		end

	c_ares (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_curl_version_info_data_61 *)$tmp)->ares;"
		end

	c_ares_num (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_curl_version_info_data_61 *)$tmp)->ares_num;"
		end

	c_libidn (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_curl_version_info_data_61 *)$tmp)->libidn;"
		end

	c_iconv_ver_num (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_curl_version_info_data_61 *)$tmp)->iconv_ver_num;"
		end

	c_libssh_version (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_curl_version_info_data_61 *)$tmp)->libssh_version;"
		end

feature {NONE} -- C setters

	c_set_age (tmp: POINTER; a_age: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_curl_version_info_data_61 *)$tmp)->age = $a_age;"
		end

	c_set_version (tmp: POINTER; a_version: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_curl_version_info_data_61 *)$tmp)->version = (char const *)$a_version;"
		end

	c_set_version_num (tmp: POINTER; a_version_num: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_curl_version_info_data_61 *)$tmp)->version_num = $a_version_num;"
		end

	c_set_host (tmp: POINTER; a_host: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_curl_version_info_data_61 *)$tmp)->host = (char const *)$a_host;"
		end

	c_set_features (tmp: POINTER; a_features: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_curl_version_info_data_61 *)$tmp)->features = $a_features;"
		end

	c_set_ssl_version (tmp: POINTER; a_ssl_version: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_curl_version_info_data_61 *)$tmp)->ssl_version = (char const *)$a_ssl_version;"
		end

	c_set_ssl_version_num (tmp: POINTER; a_ssl_version_num: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_curl_version_info_data_61 *)$tmp)->ssl_version_num = $a_ssl_version_num;"
		end

	c_set_libz_version (tmp: POINTER; a_libz_version: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_curl_version_info_data_61 *)$tmp)->libz_version = (char const *)$a_libz_version;"
		end

	c_set_protocols (tmp: POINTER; a_protocols: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_curl_version_info_data_61 *)$tmp)->protocols = (char const * const *)$a_protocols;"
		end

	c_set_ares (tmp: POINTER; a_ares: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_curl_version_info_data_61 *)$tmp)->ares = (char const *)$a_ares;"
		end

	c_set_ares_num (tmp: POINTER; a_ares_num: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_curl_version_info_data_61 *)$tmp)->ares_num = $a_ares_num;"
		end

	c_set_libidn (tmp: POINTER; a_libidn: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_curl_version_info_data_61 *)$tmp)->libidn = (char const *)$a_libidn;"
		end

	c_set_iconv_ver_num (tmp: POINTER; a_iconv_ver_num: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_curl_version_info_data_61 *)$tmp)->iconv_ver_num = $a_iconv_ver_num;"
		end

	c_set_libssh_version (tmp: POINTER; a_libssh_version: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_curl_version_info_data_61 *)$tmp)->libssh_version = (char const *)$a_libssh_version;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct __anonstruct_curl_version_info_data_61);"
		end

end
