class
	PD_DLEN

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	sig: INTEGER_32 assign set_sig
		do
			Result := c_sig (c_pointer)
		end

	uns: NATURAL_32 assign set_uns
		do
			Result := c_uns (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_sig (a_sig: INTEGER_32)
		do
			c_set_sig (c_pointer, a_sig)
		end

	set_uns (a_uns: NATURAL_32)
		do
			c_set_uns (c_pointer, a_uns)
		end

feature {NONE} -- C getters

	c_sig (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((union __anonunion_dlen_66 *)$tmp)->sig;"
		end

	c_uns (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((union __anonunion_dlen_66 *)$tmp)->uns;"
		end

feature {NONE} -- C setters

	c_set_sig (tmp: POINTER; a_sig: INTEGER_32)
		external
			"C inline"
		alias
			"((union __anonunion_dlen_66 *)$tmp)->sig = $a_sig;"
		end

	c_set_uns (tmp: POINTER; a_uns: NATURAL_32)
		external
			"C inline"
		alias
			"((union __anonunion_dlen_66 *)$tmp)->uns = $a_uns;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(union __anonunion_dlen_66);"
		end

end
