class
	PD_DYNAMICALLY_ALLOCATED_DATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	proxyuserpwd: CE_POINTER [INTEGER_8] assign set_proxyuserpwd
		do
			create Result.make_shared (c_proxyuserpwd (c_pointer))
		end

	proxyuserpwd_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct dynamically_allocated_data, proxyuserpwd);"
		end

	uagent: CE_POINTER [INTEGER_8] assign set_uagent
		do
			create Result.make_shared (c_uagent (c_pointer))
		end

	accept_encoding: CE_POINTER [INTEGER_8] assign set_accept_encoding
		do
			create Result.make_shared (c_accept_encoding (c_pointer))
		end

	userpwd: CE_POINTER [INTEGER_8] assign set_userpwd
		do
			create Result.make_shared (c_userpwd (c_pointer))
		end

	userpwd_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(struct dynamically_allocated_data, userpwd);"
		end

	rangeline: CE_POINTER [INTEGER_8] assign set_rangeline
		do
			create Result.make_shared (c_rangeline (c_pointer))
		end

	ref: CE_POINTER [INTEGER_8] assign set_ref
		do
			create Result.make_shared (c_ref (c_pointer))
		end

	host: CE_POINTER [INTEGER_8] assign set_host
		do
			create Result.make_shared (c_host (c_pointer))
		end

	cookiehost: CE_POINTER [INTEGER_8] assign set_cookiehost
		do
			create Result.make_shared (c_cookiehost (c_pointer))
		end

	rtsp_transport: CE_POINTER [INTEGER_8] assign set_rtsp_transport
		do
			create Result.make_shared (c_rtsp_transport (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_proxyuserpwd (a_proxyuserpwd: CE_POINTER [INTEGER_8])
		do
			c_set_proxyuserpwd (c_pointer, a_proxyuserpwd.c_pointer)
		end

	set_uagent (a_uagent: CE_POINTER [INTEGER_8])
		do
			c_set_uagent (c_pointer, a_uagent.c_pointer)
		end

	set_accept_encoding (a_accept_encoding: CE_POINTER [INTEGER_8])
		do
			c_set_accept_encoding (c_pointer, a_accept_encoding.c_pointer)
		end

	set_userpwd (a_userpwd: CE_POINTER [INTEGER_8])
		do
			c_set_userpwd (c_pointer, a_userpwd.c_pointer)
		end

	set_rangeline (a_rangeline: CE_POINTER [INTEGER_8])
		do
			c_set_rangeline (c_pointer, a_rangeline.c_pointer)
		end

	set_ref (a_ref: CE_POINTER [INTEGER_8])
		do
			c_set_ref (c_pointer, a_ref.c_pointer)
		end

	set_host (a_host: CE_POINTER [INTEGER_8])
		do
			c_set_host (c_pointer, a_host.c_pointer)
		end

	set_cookiehost (a_cookiehost: CE_POINTER [INTEGER_8])
		do
			c_set_cookiehost (c_pointer, a_cookiehost.c_pointer)
		end

	set_rtsp_transport (a_rtsp_transport: CE_POINTER [INTEGER_8])
		do
			c_set_rtsp_transport (c_pointer, a_rtsp_transport.c_pointer)
		end

feature {NONE} -- C getters

	c_proxyuserpwd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct dynamically_allocated_data *)$tmp)->proxyuserpwd;"
		end

	c_uagent (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct dynamically_allocated_data *)$tmp)->uagent;"
		end

	c_accept_encoding (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct dynamically_allocated_data *)$tmp)->accept_encoding;"
		end

	c_userpwd (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct dynamically_allocated_data *)$tmp)->userpwd;"
		end

	c_rangeline (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct dynamically_allocated_data *)$tmp)->rangeline;"
		end

	c_ref (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct dynamically_allocated_data *)$tmp)->ref;"
		end

	c_host (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct dynamically_allocated_data *)$tmp)->host;"
		end

	c_cookiehost (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct dynamically_allocated_data *)$tmp)->cookiehost;"
		end

	c_rtsp_transport (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct dynamically_allocated_data *)$tmp)->rtsp_transport;"
		end

feature {NONE} -- C setters

	c_set_proxyuserpwd (tmp: POINTER; a_proxyuserpwd: POINTER)
		external
			"C inline"
		alias
			"((struct dynamically_allocated_data *)$tmp)->proxyuserpwd = (char *)$a_proxyuserpwd;"
		end

	c_set_uagent (tmp: POINTER; a_uagent: POINTER)
		external
			"C inline"
		alias
			"((struct dynamically_allocated_data *)$tmp)->uagent = (char *)$a_uagent;"
		end

	c_set_accept_encoding (tmp: POINTER; a_accept_encoding: POINTER)
		external
			"C inline"
		alias
			"((struct dynamically_allocated_data *)$tmp)->accept_encoding = (char *)$a_accept_encoding;"
		end

	c_set_userpwd (tmp: POINTER; a_userpwd: POINTER)
		external
			"C inline"
		alias
			"((struct dynamically_allocated_data *)$tmp)->userpwd = (char *)$a_userpwd;"
		end

	c_set_rangeline (tmp: POINTER; a_rangeline: POINTER)
		external
			"C inline"
		alias
			"((struct dynamically_allocated_data *)$tmp)->rangeline = (char *)$a_rangeline;"
		end

	c_set_ref (tmp: POINTER; a_ref: POINTER)
		external
			"C inline"
		alias
			"((struct dynamically_allocated_data *)$tmp)->ref = (char *)$a_ref;"
		end

	c_set_host (tmp: POINTER; a_host: POINTER)
		external
			"C inline"
		alias
			"((struct dynamically_allocated_data *)$tmp)->host = (char *)$a_host;"
		end

	c_set_cookiehost (tmp: POINTER; a_cookiehost: POINTER)
		external
			"C inline"
		alias
			"((struct dynamically_allocated_data *)$tmp)->cookiehost = (char *)$a_cookiehost;"
		end

	c_set_rtsp_transport (tmp: POINTER; a_rtsp_transport: POINTER)
		external
			"C inline"
		alias
			"((struct dynamically_allocated_data *)$tmp)->rtsp_transport = (char *)$a_rtsp_transport;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct dynamically_allocated_data);"
		end

end
