class
	PD_FORMINFO

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	name_alloc: BOOLEAN assign set_name_alloc
		do
			Result := c_name_alloc (c_pointer)
		end

	namelength: NATURAL_32 assign set_namelength
		do
			Result := c_namelength (c_pointer)
		end

	value: CE_POINTER [INTEGER_8] assign set_value
		do
			create Result.make_shared (c_value (c_pointer))
		end

	value_alloc: BOOLEAN assign set_value_alloc
		do
			Result := c_value_alloc (c_pointer)
		end

	contentslength: NATURAL_32 assign set_contentslength
		do
			Result := c_contentslength (c_pointer)
		end

	contenttype: CE_POINTER [INTEGER_8] assign set_contenttype
		do
			create Result.make_shared (c_contenttype (c_pointer))
		end

	contenttype_alloc: BOOLEAN assign set_contenttype_alloc
		do
			Result := c_contenttype_alloc (c_pointer)
		end

	flags: INTEGER_32 assign set_flags
		do
			Result := c_flags (c_pointer)
		end

	buffer: CE_POINTER [INTEGER_8] assign set_buffer
		do
			create Result.make_shared (c_buffer (c_pointer))
		end

	bufferlength: NATURAL_32 assign set_bufferlength
		do
			Result := c_bufferlength (c_pointer)
		end

	showfilename: CE_POINTER [INTEGER_8] assign set_showfilename
		do
			create Result.make_shared (c_showfilename (c_pointer))
		end

	showfilename_alloc: BOOLEAN assign set_showfilename_alloc
		do
			Result := c_showfilename_alloc (c_pointer)
		end

	userp: CE_POINTER [INTEGER_8] assign set_userp
		do
			create Result.make_shared (c_userp (c_pointer))
		end

	contentheader: CE_POINTER [PD_CURL_SLIST] assign set_contentheader
		do
			create Result.make_shared (c_contentheader (c_pointer))
		end

	more: CE_POINTER [PD_FORMINFO] assign set_more
		do
			create Result.make_shared (c_more (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_name_alloc (a_name_alloc: BOOLEAN)
		do
			c_set_name_alloc (c_pointer, a_name_alloc)
		end

	set_namelength (a_namelength: NATURAL_32)
		do
			c_set_namelength (c_pointer, a_namelength)
		end

	set_value (a_value: CE_POINTER [INTEGER_8])
		do
			c_set_value (c_pointer, a_value.c_pointer)
		end

	set_value_alloc (a_value_alloc: BOOLEAN)
		do
			c_set_value_alloc (c_pointer, a_value_alloc)
		end

	set_contentslength (a_contentslength: NATURAL_32)
		do
			c_set_contentslength (c_pointer, a_contentslength)
		end

	set_contenttype (a_contenttype: CE_POINTER [INTEGER_8])
		do
			c_set_contenttype (c_pointer, a_contenttype.c_pointer)
		end

	set_contenttype_alloc (a_contenttype_alloc: BOOLEAN)
		do
			c_set_contenttype_alloc (c_pointer, a_contenttype_alloc)
		end

	set_flags (a_flags: INTEGER_32)
		do
			c_set_flags (c_pointer, a_flags)
		end

	set_buffer (a_buffer: CE_POINTER [INTEGER_8])
		do
			c_set_buffer (c_pointer, a_buffer.c_pointer)
		end

	set_bufferlength (a_bufferlength: NATURAL_32)
		do
			c_set_bufferlength (c_pointer, a_bufferlength)
		end

	set_showfilename (a_showfilename: CE_POINTER [INTEGER_8])
		do
			c_set_showfilename (c_pointer, a_showfilename.c_pointer)
		end

	set_showfilename_alloc (a_showfilename_alloc: BOOLEAN)
		do
			c_set_showfilename_alloc (c_pointer, a_showfilename_alloc)
		end

	set_userp (a_userp: CE_POINTER [INTEGER_8])
		do
			c_set_userp (c_pointer, a_userp.c_pointer)
		end

	set_contentheader (a_contentheader: CE_POINTER [PD_CURL_SLIST])
		do
			c_set_contentheader (c_pointer, a_contentheader.c_pointer)
		end

	set_more (a_more: CE_POINTER [PD_FORMINFO])
		do
			c_set_more (c_pointer, a_more.c_pointer)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct FormInfo *)$tmp)->name;"
		end

	c_name_alloc (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct FormInfo *)$tmp)->name_alloc;"
		end

	c_namelength (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct FormInfo *)$tmp)->namelength;"
		end

	c_value (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct FormInfo *)$tmp)->value;"
		end

	c_value_alloc (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct FormInfo *)$tmp)->value_alloc;"
		end

	c_contentslength (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct FormInfo *)$tmp)->contentslength;"
		end

	c_contenttype (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct FormInfo *)$tmp)->contenttype;"
		end

	c_contenttype_alloc (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct FormInfo *)$tmp)->contenttype_alloc;"
		end

	c_flags (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct FormInfo *)$tmp)->flags;"
		end

	c_buffer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct FormInfo *)$tmp)->buffer;"
		end

	c_bufferlength (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct FormInfo *)$tmp)->bufferlength;"
		end

	c_showfilename (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct FormInfo *)$tmp)->showfilename;"
		end

	c_showfilename_alloc (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct FormInfo *)$tmp)->showfilename_alloc;"
		end

	c_userp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct FormInfo *)$tmp)->userp;"
		end

	c_contentheader (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_slist *)((struct FormInfo *)$tmp)->contentheader;"
		end

	c_more (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct FormInfo *)((struct FormInfo *)$tmp)->more;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct FormInfo *)$tmp)->name = (char *)$a_name;"
		end

	c_set_name_alloc (tmp: POINTER; a_name_alloc: BOOLEAN)
		external
			"C inline"
		alias
			"((struct FormInfo *)$tmp)->name_alloc = $a_name_alloc;"
		end

	c_set_namelength (tmp: POINTER; a_namelength: NATURAL_32)
		external
			"C inline"
		alias
			"((struct FormInfo *)$tmp)->namelength = $a_namelength;"
		end

	c_set_value (tmp: POINTER; a_value: POINTER)
		external
			"C inline"
		alias
			"((struct FormInfo *)$tmp)->value = (char *)$a_value;"
		end

	c_set_value_alloc (tmp: POINTER; a_value_alloc: BOOLEAN)
		external
			"C inline"
		alias
			"((struct FormInfo *)$tmp)->value_alloc = $a_value_alloc;"
		end

	c_set_contentslength (tmp: POINTER; a_contentslength: NATURAL_32)
		external
			"C inline"
		alias
			"((struct FormInfo *)$tmp)->contentslength = $a_contentslength;"
		end

	c_set_contenttype (tmp: POINTER; a_contenttype: POINTER)
		external
			"C inline"
		alias
			"((struct FormInfo *)$tmp)->contenttype = (char *)$a_contenttype;"
		end

	c_set_contenttype_alloc (tmp: POINTER; a_contenttype_alloc: BOOLEAN)
		external
			"C inline"
		alias
			"((struct FormInfo *)$tmp)->contenttype_alloc = $a_contenttype_alloc;"
		end

	c_set_flags (tmp: POINTER; a_flags: INTEGER_32)
		external
			"C inline"
		alias
			"((struct FormInfo *)$tmp)->flags = $a_flags;"
		end

	c_set_buffer (tmp: POINTER; a_buffer: POINTER)
		external
			"C inline"
		alias
			"((struct FormInfo *)$tmp)->buffer = (char *)$a_buffer;"
		end

	c_set_bufferlength (tmp: POINTER; a_bufferlength: NATURAL_32)
		external
			"C inline"
		alias
			"((struct FormInfo *)$tmp)->bufferlength = $a_bufferlength;"
		end

	c_set_showfilename (tmp: POINTER; a_showfilename: POINTER)
		external
			"C inline"
		alias
			"((struct FormInfo *)$tmp)->showfilename = (char *)$a_showfilename;"
		end

	c_set_showfilename_alloc (tmp: POINTER; a_showfilename_alloc: BOOLEAN)
		external
			"C inline"
		alias
			"((struct FormInfo *)$tmp)->showfilename_alloc = $a_showfilename_alloc;"
		end

	c_set_userp (tmp: POINTER; a_userp: POINTER)
		external
			"C inline"
		alias
			"((struct FormInfo *)$tmp)->userp = (char *)$a_userp;"
		end

	c_set_contentheader (tmp: POINTER; a_contentheader: POINTER)
		external
			"C inline"
		alias
			"((struct FormInfo *)$tmp)->contentheader = (struct curl_slist *)$a_contentheader;"
		end

	c_set_more (tmp: POINTER; a_more: POINTER)
		external
			"C inline"
		alias
			"((struct FormInfo *)$tmp)->more = (struct FormInfo *)$a_more;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct FormInfo);"
		end

end
