class
	PD_HMAC_CONTEXT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	hmac_hash: CE_POINTER [PD_HMAC_PARAMS] assign set_hmac_hash
		do
			create Result.make_shared (c_hmac_hash (c_pointer))
		end

	hmac_hashctxt1: CE_POINTER [ANY] assign set_hmac_hashctxt1
		do
			create Result.make_shared (c_hmac_hashctxt1 (c_pointer))
		end

	hmac_hashctxt2: CE_POINTER [ANY] assign set_hmac_hashctxt2
		do
			create Result.make_shared (c_hmac_hashctxt2 (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_hmac_hash (a_hmac_hash: CE_POINTER [PD_HMAC_PARAMS])
		do
			c_set_hmac_hash (c_pointer, a_hmac_hash.c_pointer)
		end

	set_hmac_hashctxt1 (a_hmac_hashctxt1: CE_POINTER [ANY])
		do
			c_set_hmac_hashctxt1 (c_pointer, a_hmac_hashctxt1.c_pointer)
		end

	set_hmac_hashctxt2 (a_hmac_hashctxt2: CE_POINTER [ANY])
		do
			c_set_hmac_hashctxt2 (c_pointer, a_hmac_hashctxt2.c_pointer)
		end

feature {NONE} -- C getters

	c_hmac_hash (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (HMAC_params *)((struct __anonstruct_HMAC_context_101 *)$tmp)->hmac_hash;"
		end

	c_hmac_hashctxt1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_HMAC_context_101 *)$tmp)->hmac_hashctxt1;"
		end

	c_hmac_hashctxt2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_HMAC_context_101 *)$tmp)->hmac_hashctxt2;"
		end

feature {NONE} -- C setters

	c_set_hmac_hash (tmp: POINTER; a_hmac_hash: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_HMAC_context_101 *)$tmp)->hmac_hash = (HMAC_params *)$a_hmac_hash;"
		end

	c_set_hmac_hashctxt1 (tmp: POINTER; a_hmac_hashctxt1: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_HMAC_context_101 *)$tmp)->hmac_hashctxt1 = (void *)$a_hmac_hashctxt1;"
		end

	c_set_hmac_hashctxt2 (tmp: POINTER; a_hmac_hashctxt2: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_HMAC_context_101 *)$tmp)->hmac_hashctxt2 = (void *)$a_hmac_hashctxt2;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct __anonstruct_HMAC_context_101);"
		end

end
