class
	PD_PL_UNIX_SUBSTATE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	total_dirsize: INTEGER_32 assign set_total_dirsize
		do
			Result := c_total_dirsize (c_pointer)
		end

	hlinks: INTEGER_32 assign set_hlinks
		do
			Result := c_hlinks (c_pointer)
		end

	user: INTEGER_32 assign set_user
		do
			Result := c_user (c_pointer)
		end

	group: INTEGER_32 assign set_group
		do
			Result := c_group (c_pointer)
		end

	size: INTEGER_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	time: INTEGER_32 assign set_time
		do
			Result := c_time (c_pointer)
		end

	filename: INTEGER_32 assign set_filename
		do
			Result := c_filename (c_pointer)
		end

	symlink: INTEGER_32 assign set_symlink
		do
			Result := c_symlink (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_total_dirsize (a_total_dirsize: INTEGER_32)
		do
			c_set_total_dirsize (c_pointer, a_total_dirsize)
		end

	set_hlinks (a_hlinks: INTEGER_32)
		do
			c_set_hlinks (c_pointer, a_hlinks)
		end

	set_user (a_user: INTEGER_32)
		do
			c_set_user (c_pointer, a_user)
		end

	set_group (a_group: INTEGER_32)
		do
			c_set_group (c_pointer, a_group)
		end

	set_size (a_size: INTEGER_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_time (a_time: INTEGER_32)
		do
			c_set_time (c_pointer, a_time)
		end

	set_filename (a_filename: INTEGER_32)
		do
			c_set_filename (c_pointer, a_filename)
		end

	set_symlink (a_symlink: INTEGER_32)
		do
			c_set_symlink (c_pointer, a_symlink)
		end

feature {NONE} -- C getters

	c_total_dirsize (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((union __anonunion_pl_unix_substate_96 *)$tmp)->total_dirsize;"
		end

	c_hlinks (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((union __anonunion_pl_unix_substate_96 *)$tmp)->hlinks;"
		end

	c_user (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((union __anonunion_pl_unix_substate_96 *)$tmp)->user;"
		end

	c_group (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((union __anonunion_pl_unix_substate_96 *)$tmp)->group;"
		end

	c_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((union __anonunion_pl_unix_substate_96 *)$tmp)->size;"
		end

	c_time (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((union __anonunion_pl_unix_substate_96 *)$tmp)->time;"
		end

	c_filename (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((union __anonunion_pl_unix_substate_96 *)$tmp)->filename;"
		end

	c_symlink (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((union __anonunion_pl_unix_substate_96 *)$tmp)->symlink;"
		end

feature {NONE} -- C setters

	c_set_total_dirsize (tmp: POINTER; a_total_dirsize: INTEGER_32)
		external
			"C inline"
		alias
			"((union __anonunion_pl_unix_substate_96 *)$tmp)->total_dirsize = $a_total_dirsize;"
		end

	c_set_hlinks (tmp: POINTER; a_hlinks: INTEGER_32)
		external
			"C inline"
		alias
			"((union __anonunion_pl_unix_substate_96 *)$tmp)->hlinks = $a_hlinks;"
		end

	c_set_user (tmp: POINTER; a_user: INTEGER_32)
		external
			"C inline"
		alias
			"((union __anonunion_pl_unix_substate_96 *)$tmp)->user = $a_user;"
		end

	c_set_group (tmp: POINTER; a_group: INTEGER_32)
		external
			"C inline"
		alias
			"((union __anonunion_pl_unix_substate_96 *)$tmp)->group = $a_group;"
		end

	c_set_size (tmp: POINTER; a_size: INTEGER_32)
		external
			"C inline"
		alias
			"((union __anonunion_pl_unix_substate_96 *)$tmp)->size = $a_size;"
		end

	c_set_time (tmp: POINTER; a_time: INTEGER_32)
		external
			"C inline"
		alias
			"((union __anonunion_pl_unix_substate_96 *)$tmp)->time = $a_time;"
		end

	c_set_filename (tmp: POINTER; a_filename: INTEGER_32)
		external
			"C inline"
		alias
			"((union __anonunion_pl_unix_substate_96 *)$tmp)->filename = $a_filename;"
		end

	c_set_symlink (tmp: POINTER; a_symlink: INTEGER_32)
		external
			"C inline"
		alias
			"((union __anonunion_pl_unix_substate_96 *)$tmp)->symlink = $a_symlink;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(union __anonunion_pl_unix_substate_96);"
		end

end
