class
	PD_PL_WINNT_SUBSTATE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	time: INTEGER_32 assign set_time
		do
			Result := c_time (c_pointer)
		end

	dirorsize: INTEGER_32 assign set_dirorsize
		do
			Result := c_dirorsize (c_pointer)
		end

	filename: INTEGER_32 assign set_filename
		do
			Result := c_filename (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_time (a_time: INTEGER_32)
		do
			c_set_time (c_pointer, a_time)
		end

	set_dirorsize (a_dirorsize: INTEGER_32)
		do
			c_set_dirorsize (c_pointer, a_dirorsize)
		end

	set_filename (a_filename: INTEGER_32)
		do
			c_set_filename (c_pointer, a_filename)
		end

feature {NONE} -- C getters

	c_time (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((union __anonunion_pl_winNT_substate_106 *)$tmp)->time;"
		end

	c_dirorsize (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((union __anonunion_pl_winNT_substate_106 *)$tmp)->dirorsize;"
		end

	c_filename (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((union __anonunion_pl_winNT_substate_106 *)$tmp)->filename;"
		end

feature {NONE} -- C setters

	c_set_time (tmp: POINTER; a_time: INTEGER_32)
		external
			"C inline"
		alias
			"((union __anonunion_pl_winNT_substate_106 *)$tmp)->time = $a_time;"
		end

	c_set_dirorsize (tmp: POINTER; a_dirorsize: INTEGER_32)
		external
			"C inline"
		alias
			"((union __anonunion_pl_winNT_substate_106 *)$tmp)->dirorsize = $a_dirorsize;"
		end

	c_set_filename (tmp: POINTER; a_filename: INTEGER_32)
		external
			"C inline"
		alias
			"((union __anonunion_pl_winNT_substate_106 *)$tmp)->filename = $a_filename;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(union __anonunion_pl_winNT_substate_106);"
		end

end
