class
	PD_PTR

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	to_certinfo: CE_POINTER [PD_CURL_CERTINFO] assign set_to_certinfo
		do
			create Result.make_shared (c_to_certinfo (c_pointer))
		end

	to_slist: CE_POINTER [PD_CURL_SLIST] assign set_to_slist
		do
			create Result.make_shared (c_to_slist (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_to_certinfo (a_to_certinfo: CE_POINTER [PD_CURL_CERTINFO])
		do
			c_set_to_certinfo (c_pointer, a_to_certinfo.c_pointer)
		end

	set_to_slist (a_to_slist: CE_POINTER [PD_CURL_SLIST])
		do
			c_set_to_slist (c_pointer, a_to_slist.c_pointer)
		end

feature {NONE} -- C getters

	c_to_certinfo (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_certinfo *)((union __anonunion_ptr_96 *)$tmp)->to_certinfo;"
		end

	c_to_slist (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct curl_slist *)((union __anonunion_ptr_96 *)$tmp)->to_slist;"
		end

feature {NONE} -- C setters

	c_set_to_certinfo (tmp: POINTER; a_to_certinfo: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_ptr_96 *)$tmp)->to_certinfo = (struct curl_certinfo *)$a_to_certinfo;"
		end

	c_set_to_slist (tmp: POINTER; a_to_slist: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion_ptr_96 *)$tmp)->to_slist = (struct curl_slist *)$a_to_slist;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(union __anonunion_ptr_96);"
		end

end
