class
	PD_SA_EX_U

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	addr: SD_SOCKADDR assign set_addr
		do
			create Result.make_shared (c_addr (c_pointer))
		end

	addr_offset: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return (int)offsetof(union __anonunion__sa_ex_u_100, addr);"
		end

	buff: PD_CURL_SOCKADDR_STORAGE assign set_buff
		do
			create Result.make_shared (c_buff (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_addr (a_addr: SD_SOCKADDR)
		do
			addr.ce_gets (a_addr)
		end

	set_buff (a_buff: PD_CURL_SOCKADDR_STORAGE)
		do
			buff.ce_gets (a_buff)
		end

feature {NONE} -- C getters

	c_addr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct sockaddr *)&((union __anonunion__sa_ex_u_100 *)$tmp)->addr;"
		end

	c_buff (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct Curl_sockaddr_storage *)&((union __anonunion__sa_ex_u_100 *)$tmp)->buff;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(union __anonunion__sa_ex_u_100);"
		end

end
