class
	PD_SSH_CONN

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	authlist: CE_POINTER [INTEGER_8] assign set_authlist
		do
			create Result.make_shared (c_authlist (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_authlist (a_authlist: CE_POINTER [INTEGER_8])
		do
			c_set_authlist (c_pointer, a_authlist.c_pointer)
		end

feature {NONE} -- C getters

	c_authlist (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct ssh_conn *)$tmp)->authlist;"
		end

feature {NONE} -- C setters

	c_set_authlist (tmp: POINTER; a_authlist: POINTER)
		external
			"C inline"
		alias
			"((struct ssh_conn *)$tmp)->authlist = (char const *)$a_authlist;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct ssh_conn);"
		end

end
