class
	PD_SSL_CONNECT_DATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	use: BOOLEAN assign set_use
		do
			Result := c_use (c_pointer)
		end

	state: INTEGER_32 assign set_state
		do
			Result := c_state (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_use (a_use: BOOLEAN)
		do
			c_set_use (c_pointer, a_use)
		end

	set_state (a_state: INTEGER_32)
		do
			c_set_state (c_pointer, a_state)
		end

feature {NONE} -- C getters

	c_use (tmp: POINTER): BOOLEAN
		external
			"C inline"
		alias
			"return (_Bool)((struct ssl_connect_data *)$tmp)->use;"
		end

	c_state (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct ssl_connect_data *)$tmp)->state;"
		end

feature {NONE} -- C setters

	c_set_use (tmp: POINTER; a_use: BOOLEAN)
		external
			"C inline"
		alias
			"((struct ssl_connect_data *)$tmp)->use = $a_use;"
		end

	c_set_state (tmp: POINTER; a_state: INTEGER_32)
		external
			"C inline"
		alias
			"((struct ssl_connect_data *)$tmp)->state = $a_state;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct ssl_connect_data);"
		end

end
