class
	PD_STRINGS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	time: CE_POINTER [INTEGER_8] assign set_time
		do
			create Result.make_shared (c_time (c_pointer))
		end

	perm: CE_POINTER [INTEGER_8] assign set_perm
		do
			create Result.make_shared (c_perm (c_pointer))
		end

	user: CE_POINTER [INTEGER_8] assign set_user
		do
			create Result.make_shared (c_user (c_pointer))
		end

	group: CE_POINTER [INTEGER_8] assign set_group
		do
			create Result.make_shared (c_group (c_pointer))
		end

	target: CE_POINTER [INTEGER_8] assign set_target
		do
			create Result.make_shared (c_target (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_time (a_time: CE_POINTER [INTEGER_8])
		do
			c_set_time (c_pointer, a_time.c_pointer)
		end

	set_perm (a_perm: CE_POINTER [INTEGER_8])
		do
			c_set_perm (c_pointer, a_perm.c_pointer)
		end

	set_user (a_user: CE_POINTER [INTEGER_8])
		do
			c_set_user (c_pointer, a_user.c_pointer)
		end

	set_group (a_group: CE_POINTER [INTEGER_8])
		do
			c_set_group (c_pointer, a_group.c_pointer)
		end

	set_target (a_target: CE_POINTER [INTEGER_8])
		do
			c_set_target (c_pointer, a_target.c_pointer)
		end

feature {NONE} -- C getters

	c_time (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_strings_44 *)$tmp)->time;"
		end

	c_perm (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_strings_44 *)$tmp)->perm;"
		end

	c_user (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_strings_44 *)$tmp)->user;"
		end

	c_group (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_strings_44 *)$tmp)->group;"
		end

	c_target (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_strings_44 *)$tmp)->target;"
		end

feature {NONE} -- C setters

	c_set_time (tmp: POINTER; a_time: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_strings_44 *)$tmp)->time = (char *)$a_time;"
		end

	c_set_perm (tmp: POINTER; a_perm: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_strings_44 *)$tmp)->perm = (char *)$a_perm;"
		end

	c_set_user (tmp: POINTER; a_user: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_strings_44 *)$tmp)->user = (char *)$a_user;"
		end

	c_set_group (tmp: POINTER; a_group: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_strings_44 *)$tmp)->group = (char *)$a_group;"
		end

	c_set_target (tmp: POINTER; a_target: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_strings_44 *)$tmp)->target = (char *)$a_target;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct __anonstruct_strings_44);"
		end

end
