class
	PD_UNIX

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	main: INTEGER_32 assign set_main
		do
			Result := c_main (c_pointer)
		end

	sub: PD_PL_UNIX_SUBSTATE assign set_sub
		do
			create Result.make_shared (c_sub (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_main (a_main: INTEGER_32)
		do
			c_set_main (c_pointer, a_main)
		end

	set_sub (a_sub: PD_PL_UNIX_SUBSTATE)
		do
			sub.ce_gets (a_sub)
		end

feature {NONE} -- C getters

	c_main (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_UNIX_112 *)$tmp)->main;"
		end

	c_sub (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (pl_unix_substate *)&((struct __anonstruct_UNIX_112 *)$tmp)->sub;"
		end

feature {NONE} -- C setters

	c_set_main (tmp: POINTER; a_main: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_UNIX_112 *)$tmp)->main = $a_main;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct __anonstruct_UNIX_112);"
		end

end
