class
	LIBCURL_ASSEMBLER

feature {NONE}

	asm1 (op1: CE_POINTER [CE_POINTER [SD_FD_SET]]; op2: CE_POINTER [CE_ARRAY [INTEGER_32]]; op3: CE_POINTER [INTEGER_32])
		do
			c_asm1 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm1 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libcurl.h>"
		alias
			"[
				fd_set * read_fd_set = *(fd_set * *)$op1;
				int * sockbunch = (int *)$op2;
				int i = *(int *)$op3;

				__asm__ volatile ("btsl %1,%0"
						: "=m" (read_fd_set->fds_bits[sockbunch[i] / (8 * (int)sizeof(long))])
						: "r" (sockbunch[i] % (8 * (int)sizeof(long)))
						: "cc", "memory"
					);

				*(fd_set * *)$op1 = read_fd_set;
				*(int *)$op3 = i;
			]"
		end

	asm2 (op1: CE_POINTER [CE_POINTER [SD_FD_SET]]; op2: CE_POINTER [CE_ARRAY [INTEGER_32]]; op3: CE_POINTER [INTEGER_32])
		do
			c_asm2 (op1.c_pointer, op2.c_pointer, op3.c_pointer)
		end

	c_asm2 (op1: POINTER; op2: POINTER; op3: POINTER)
		external
			"C inline use <libcurl.h>"
		alias
			"[
				fd_set * write_fd_set = *(fd_set * *)$op1;
				int * sockbunch = (int *)$op2;
				int i = *(int *)$op3;

				__asm__ volatile ("btsl %1,%0"
						: "=m" (write_fd_set->fds_bits[sockbunch[i] / (8 * (int)sizeof(long))])
						: "r" (sockbunch[i] % (8 * (int)sizeof(long)))
						: "cc", "memory"
					);

				*(fd_set * *)$op1 = write_fd_set;
				*(int *)$op3 = i;
			]"
		end

end
