class
	P_FILEINFO

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	Curl_fileinfo_alloc: CE_POINTER [PD_CURL_FILEINFO]
		local
			l_tmp: CE_POINTER [PD_CURL_FILEINFO]
			js: JUMP_STATE
		do
			create l_tmp.make

			l_tmp.ce_gets (create {CE_POINTER [PD_CURL_FILEINFO]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([{PD_CURL_FILEINFO}.sizeof.to_natural_32])))))
			if (l_tmp).c_pointer = default_pointer then
				Result := (create {CE_POINTER [PD_CURL_FILEINFO]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				memset (create {CE_POINTER [ANY]}.make_cast (l_tmp), 0, {PD_CURL_FILEINFO}.sizeof.to_natural_32).do_nothing
				Result := l_tmp
			end
		end

	Curl_fileinfo_dtor (a_user: CE_POINTER [ANY]; a_element: CE_POINTER [ANY])
		local
			l_finfo: CE_POINTER [PD_CURL_FILEINFO]
			js: JUMP_STATE
		do
			create l_finfo.make

			l_finfo.ce_gets (create {CE_POINTER [PD_CURL_FILEINFO]}.make_cast (a_element))
			if (l_finfo).c_pointer = default_pointer then
				js.return
			end
			if not js.return_called then
				if ((l_finfo.item.b_data).c_pointer /= default_pointer) then
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_finfo.item.b_data)])
				end
				easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_finfo)])
			end
		end

	Curl_fileinfo_dtor_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent Curl_fileinfo_dtor)
		end

	Curl_fileinfo_dup (a_src: CE_POINTER [PD_CURL_FILEINFO]): CE_POINTER [PD_CURL_FILEINFO]
		local
			l_ptr: CE_POINTER [PD_CURL_FILEINFO]
			js: JUMP_STATE
		do
			create l_ptr.make

			l_ptr.ce_gets (create {CE_POINTER [PD_CURL_FILEINFO]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([{PD_CURL_FILEINFO}.sizeof.to_natural_32])))))
			if (l_ptr).c_pointer = default_pointer then
				Result := (create {CE_POINTER [PD_CURL_FILEINFO]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_ptr.item := a_src.item
				l_ptr.item.b_data := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (easy_inst.Curl_cmalloc.pointer_item ([a_src.item.b_size]))))
				if (l_ptr.item.b_data).c_pointer = default_pointer then
					easy_inst.Curl_cfree.call ([create {CE_POINTER [ANY]}.make_cast (l_ptr)])
					Result := (create {CE_POINTER [PD_CURL_FILEINFO]}.make_shared (default_pointer))
				else
					memcpy (create {CE_POINTER [ANY]}.make_cast (l_ptr.item.b_data), create {CE_POINTER [ANY]}.make_cast (a_src.item.b_data), a_src.item.b_size).do_nothing
					Result := l_ptr
				end
			end
		end

end
