class
	SD_IN6_U

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	u6_addr8: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_u6_addr8 (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	u6_addr16: CE_ARRAY [NATURAL_16]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_u6_addr16 (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	u6_addr32: CE_ARRAY [NATURAL_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_u6_addr32 (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {NONE} -- C getters

	c_u6_addr8 (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				union __anonunion___in6_u_36 *tmp = (union __anonunion___in6_u_36 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->__u6_addr8) / sizeof(tmp->__u6_addr8[0]);
				return tmp->__u6_addr8;
			]"
		end

	c_u6_addr16 (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				union __anonunion___in6_u_36 *tmp = (union __anonunion___in6_u_36 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->__u6_addr16) / sizeof(tmp->__u6_addr16[0]);
				return tmp->__u6_addr16;
			]"
		end

	c_u6_addr32 (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				union __anonunion___in6_u_36 *tmp = (union __anonunion___in6_u_36 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->__u6_addr32) / sizeof(tmp->__u6_addr32[0]);
				return tmp->__u6_addr32;
			]"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(union __anonunion___in6_u_36);"
		end

end
