class
	SD_STAT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	st_dev: NATURAL_64 assign set_st_dev
		do
			Result := c_st_dev (c_pointer)
		end

	pad1: NATURAL_16 assign set_pad1
		do
			Result := c_pad1 (c_pointer)
		end

	st_ino: NATURAL_32 assign set_st_ino
		do
			Result := c_st_ino (c_pointer)
		end

	st_mode: NATURAL_32 assign set_st_mode
		do
			Result := c_st_mode (c_pointer)
		end

	st_nlink: NATURAL_32 assign set_st_nlink
		do
			Result := c_st_nlink (c_pointer)
		end

	st_uid: NATURAL_32 assign set_st_uid
		do
			Result := c_st_uid (c_pointer)
		end

	st_gid: NATURAL_32 assign set_st_gid
		do
			Result := c_st_gid (c_pointer)
		end

	st_rdev: NATURAL_64 assign set_st_rdev
		do
			Result := c_st_rdev (c_pointer)
		end

	pad2: NATURAL_16 assign set_pad2
		do
			Result := c_pad2 (c_pointer)
		end

	st_size: INTEGER_32 assign set_st_size
		do
			Result := c_st_size (c_pointer)
		end

	st_blksize: INTEGER_32 assign set_st_blksize
		do
			Result := c_st_blksize (c_pointer)
		end

	st_blocks: INTEGER_32 assign set_st_blocks
		do
			Result := c_st_blocks (c_pointer)
		end

	st_atim: SD_TIMESPEC assign set_st_atim
		do
			create Result.make_shared (c_st_atim (c_pointer))
		end

	st_mtim: SD_TIMESPEC assign set_st_mtim
		do
			create Result.make_shared (c_st_mtim (c_pointer))
		end

	st_ctim: SD_TIMESPEC assign set_st_ctim
		do
			create Result.make_shared (c_st_ctim (c_pointer))
		end

	unused4: NATURAL_32 assign set_unused4
		do
			Result := c_unused4 (c_pointer)
		end

	unused5: NATURAL_32 assign set_unused5
		do
			Result := c_unused5 (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_st_dev (a_st_dev: NATURAL_64)
		do
			c_set_st_dev (c_pointer, a_st_dev)
		end

	set_pad1 (a_pad1: NATURAL_16)
		do
			c_set_pad1 (c_pointer, a_pad1)
		end

	set_st_ino (a_st_ino: NATURAL_32)
		do
			c_set_st_ino (c_pointer, a_st_ino)
		end

	set_st_mode (a_st_mode: NATURAL_32)
		do
			c_set_st_mode (c_pointer, a_st_mode)
		end

	set_st_nlink (a_st_nlink: NATURAL_32)
		do
			c_set_st_nlink (c_pointer, a_st_nlink)
		end

	set_st_uid (a_st_uid: NATURAL_32)
		do
			c_set_st_uid (c_pointer, a_st_uid)
		end

	set_st_gid (a_st_gid: NATURAL_32)
		do
			c_set_st_gid (c_pointer, a_st_gid)
		end

	set_st_rdev (a_st_rdev: NATURAL_64)
		do
			c_set_st_rdev (c_pointer, a_st_rdev)
		end

	set_pad2 (a_pad2: NATURAL_16)
		do
			c_set_pad2 (c_pointer, a_pad2)
		end

	set_st_size (a_st_size: INTEGER_32)
		do
			c_set_st_size (c_pointer, a_st_size)
		end

	set_st_blksize (a_st_blksize: INTEGER_32)
		do
			c_set_st_blksize (c_pointer, a_st_blksize)
		end

	set_st_blocks (a_st_blocks: INTEGER_32)
		do
			c_set_st_blocks (c_pointer, a_st_blocks)
		end

	set_st_atim (a_st_atim: SD_TIMESPEC)
		do
			st_atim.ce_gets (a_st_atim)
		end

	set_st_mtim (a_st_mtim: SD_TIMESPEC)
		do
			st_mtim.ce_gets (a_st_mtim)
		end

	set_st_ctim (a_st_ctim: SD_TIMESPEC)
		do
			st_ctim.ce_gets (a_st_ctim)
		end

	set_unused4 (a_unused4: NATURAL_32)
		do
			c_set_unused4 (c_pointer, a_unused4)
		end

	set_unused5 (a_unused5: NATURAL_32)
		do
			c_set_unused5 (c_pointer, a_unused5)
		end

feature {NONE} -- C getters

	c_st_dev (tmp: POINTER): NATURAL_64
		external
			"C inline"
		alias
			"return (unsigned long long)((struct stat *)$tmp)->st_dev;"
		end

	c_pad1 (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct stat *)$tmp)->__pad1;"
		end

	c_st_ino (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct stat *)$tmp)->st_ino;"
		end

	c_st_mode (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct stat *)$tmp)->st_mode;"
		end

	c_st_nlink (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct stat *)$tmp)->st_nlink;"
		end

	c_st_uid (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct stat *)$tmp)->st_uid;"
		end

	c_st_gid (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct stat *)$tmp)->st_gid;"
		end

	c_st_rdev (tmp: POINTER): NATURAL_64
		external
			"C inline"
		alias
			"return (unsigned long long)((struct stat *)$tmp)->st_rdev;"
		end

	c_pad2 (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct stat *)$tmp)->__pad2;"
		end

	c_st_size (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct stat *)$tmp)->st_size;"
		end

	c_st_blksize (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct stat *)$tmp)->st_blksize;"
		end

	c_st_blocks (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct stat *)$tmp)->st_blocks;"
		end

	c_st_atim (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct timespec *)&((struct stat *)$tmp)->st_atim;"
		end

	c_st_mtim (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct timespec *)&((struct stat *)$tmp)->st_mtim;"
		end

	c_st_ctim (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct timespec *)&((struct stat *)$tmp)->st_ctim;"
		end

	c_unused4 (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct stat *)$tmp)->__unused4;"
		end

	c_unused5 (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct stat *)$tmp)->__unused5;"
		end

feature {NONE} -- C setters

	c_set_st_dev (tmp: POINTER; a_st_dev: NATURAL_64)
		external
			"C inline"
		alias
			"((struct stat *)$tmp)->st_dev = $a_st_dev;"
		end

	c_set_pad1 (tmp: POINTER; a_pad1: NATURAL_16)
		external
			"C inline"
		alias
			"((struct stat *)$tmp)->__pad1 = $a_pad1;"
		end

	c_set_st_ino (tmp: POINTER; a_st_ino: NATURAL_32)
		external
			"C inline"
		alias
			"((struct stat *)$tmp)->st_ino = $a_st_ino;"
		end

	c_set_st_mode (tmp: POINTER; a_st_mode: NATURAL_32)
		external
			"C inline"
		alias
			"((struct stat *)$tmp)->st_mode = $a_st_mode;"
		end

	c_set_st_nlink (tmp: POINTER; a_st_nlink: NATURAL_32)
		external
			"C inline"
		alias
			"((struct stat *)$tmp)->st_nlink = $a_st_nlink;"
		end

	c_set_st_uid (tmp: POINTER; a_st_uid: NATURAL_32)
		external
			"C inline"
		alias
			"((struct stat *)$tmp)->st_uid = $a_st_uid;"
		end

	c_set_st_gid (tmp: POINTER; a_st_gid: NATURAL_32)
		external
			"C inline"
		alias
			"((struct stat *)$tmp)->st_gid = $a_st_gid;"
		end

	c_set_st_rdev (tmp: POINTER; a_st_rdev: NATURAL_64)
		external
			"C inline"
		alias
			"((struct stat *)$tmp)->st_rdev = $a_st_rdev;"
		end

	c_set_pad2 (tmp: POINTER; a_pad2: NATURAL_16)
		external
			"C inline"
		alias
			"((struct stat *)$tmp)->__pad2 = $a_pad2;"
		end

	c_set_st_size (tmp: POINTER; a_st_size: INTEGER_32)
		external
			"C inline"
		alias
			"((struct stat *)$tmp)->st_size = $a_st_size;"
		end

	c_set_st_blksize (tmp: POINTER; a_st_blksize: INTEGER_32)
		external
			"C inline"
		alias
			"((struct stat *)$tmp)->st_blksize = $a_st_blksize;"
		end

	c_set_st_blocks (tmp: POINTER; a_st_blocks: INTEGER_32)
		external
			"C inline"
		alias
			"((struct stat *)$tmp)->st_blocks = $a_st_blocks;"
		end

	c_set_unused4 (tmp: POINTER; a_unused4: NATURAL_32)
		external
			"C inline"
		alias
			"((struct stat *)$tmp)->__unused4 = $a_unused4;"
		end

	c_set_unused5 (tmp: POINTER; a_unused5: NATURAL_32)
		external
			"C inline"
		alias
			"((struct stat *)$tmp)->__unused5 = $a_unused5;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return sizeof(struct stat);"
		end

end
