deferred class
	S_IFADDRS

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	getifaddrs (a_ifap: CE_POINTER [CE_POINTER [SD_IFADDRS]]): INTEGER_32
		do
			Result := c_getifaddrs (a_ifap.c_pointer)
		end

	c_getifaddrs (a_ifap: POINTER): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return getifaddrs($a_ifap);"
		end

	freeifaddrs (a_ifa: CE_POINTER [SD_IFADDRS])
		do
			c_freeifaddrs (a_ifa.c_pointer)
		end

	c_freeifaddrs (a_ifa: POINTER)
		external
			"C inline use <libcurl.h>"
		alias
			"freeifaddrs($a_ifa);"
		end

end
