deferred class
	S_TIME

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	gmtime_r (a_timer: CE_POINTER [INTEGER_32]; a_tp: CE_POINTER [SD_TM]): CE_POINTER [SD_TM]
		do
			create Result.make_shared (c_gmtime_r (a_timer.c_pointer, a_tp.c_pointer))
		end

	c_gmtime_r (a_timer: POINTER; a_tp: POINTER): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return gmtime_r($a_timer, $a_tp);"
		end

	clock_gettime (a_clock_id: INTEGER_32; a_tp: CE_POINTER [SD_TIMESPEC]): INTEGER_32
		do
			Result := c_clock_gettime (a_clock_id, a_tp.c_pointer)
		end

	c_clock_gettime (a_clock_id: INTEGER_32; a_tp: POINTER): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return clock_gettime($a_clock_id, $a_tp);"
		end

	time (a_timer: CE_POINTER [INTEGER_32]): INTEGER_32
		do
			Result := c_time (a_timer.c_pointer)
		end

	c_time (a_timer: POINTER): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return time($a_timer);"
		end

end
