class
	PD_DOPRNT_FUNS_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	format: CE_ROUTINE assign set_format
		do
			create Result.make_shared (c_format (c_pointer))
		end

	memory: CE_ROUTINE assign set_memory
		do
			create Result.make_shared (c_memory (c_pointer))
		end

	reps: CE_ROUTINE assign set_reps
		do
			create Result.make_shared (c_reps (c_pointer))
		end

	final: CE_ROUTINE assign set_final
		do
			create Result.make_shared (c_final (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_format (a_format: CE_ROUTINE)
		do
			c_set_format (c_pointer, a_format.c_pointer)
		end

	set_memory (a_memory: CE_ROUTINE)
		do
			c_set_memory (c_pointer, a_memory.c_pointer)
		end

	set_reps (a_reps: CE_ROUTINE)
		do
			c_set_reps (c_pointer, a_reps.c_pointer)
		end

	set_final (a_final: CE_ROUTINE)
		do
			c_set_final (c_pointer, a_final.c_pointer)
		end

feature {NONE} -- C getters

	c_format (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void *, char *, __builtin_va_list))((struct doprnt_funs_t *)$tmp)->format;"
		end

	c_memory (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void *, char *, unsigned int))((struct doprnt_funs_t *)$tmp)->memory;"
		end

	c_reps (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void *, int, int))((struct doprnt_funs_t *)$tmp)->reps;"
		end

	c_final (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void *))((struct doprnt_funs_t *)$tmp)->final;"
		end

feature {NONE} -- C setters

	c_set_format (tmp: POINTER; a_format: POINTER)
		external
			"C inline"
		alias
			"((struct doprnt_funs_t *)$tmp)->format = (int( *)(void *, char const *, __builtin_va_list))$a_format;"
		end

	c_set_memory (tmp: POINTER; a_memory: POINTER)
		external
			"C inline"
		alias
			"((struct doprnt_funs_t *)$tmp)->memory = (int( *)(void *, char const *, unsigned int))$a_memory;"
		end

	c_set_reps (tmp: POINTER; a_reps: POINTER)
		external
			"C inline"
		alias
			"((struct doprnt_funs_t *)$tmp)->reps = (int( *)(void *, int, int))$a_reps;"
		end

	c_set_final (tmp: POINTER; a_final: POINTER)
		external
			"C inline"
		alias
			"((struct doprnt_funs_t *)$tmp)->final = (int( *)(void *))$a_final;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(struct doprnt_funs_t);"
		end

end
