class
	PD_GMP_RAND_LC_SCHEME_STRUCT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	m2exp: NATURAL_32 assign set_m2exp
		do
			Result := c_m2exp (c_pointer)
		end

	astr: CE_POINTER [INTEGER_8] assign set_astr
		do
			create Result.make_shared (c_astr (c_pointer))
		end

	c: NATURAL_32 assign set_c
		do
			Result := c_c (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_m2exp (a_m2exp: NATURAL_32)
		do
			c_set_m2exp (c_pointer, a_m2exp)
		end

	set_astr (a_astr: CE_POINTER [INTEGER_8])
		do
			c_set_astr (c_pointer, a_astr.c_pointer)
		end

	set_c (a_c: NATURAL_32)
		do
			c_set_c (c_pointer, a_c)
		end

feature {NONE} -- C getters

	c_m2exp (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __gmp_rand_lc_scheme_struct *)$tmp)->m2exp;"
		end

	c_astr (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __gmp_rand_lc_scheme_struct *)$tmp)->astr;"
		end

	c_c (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __gmp_rand_lc_scheme_struct *)$tmp)->c;"
		end

feature {NONE} -- C setters

	c_set_m2exp (tmp: POINTER; a_m2exp: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __gmp_rand_lc_scheme_struct *)$tmp)->m2exp = $a_m2exp;"
		end

	c_set_astr (tmp: POINTER; a_astr: POINTER)
		external
			"C inline"
		alias
			"((struct __gmp_rand_lc_scheme_struct *)$tmp)->astr = (char const *)$a_astr;"
		end

	c_set_c (tmp: POINTER; a_c: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __gmp_rand_lc_scheme_struct *)$tmp)->c = $a_c;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(struct __gmp_rand_lc_scheme_struct);"
		end

end
