class
	PD_HGCD_MATRIX1

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	u: CE_ARRAY [CE_ARRAY [NATURAL_32]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 2)
			create Result.make_shared (c_u (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {NONE} -- C getters

	c_u (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct hgcd_matrix1 *tmp = (struct hgcd_matrix1 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->u) / sizeof(tmp->u[0]);
				((int *)$tmp_dimensions)[1] = sizeof(tmp->u[0]) / sizeof(tmp->u[0][0]);
				return tmp->u;
			]"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(struct hgcd_matrix1);"
		end

end
