class
	PD_MP_ALGDATA

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	mp_lc: CE_POINTER [ANY] assign set_mp_lc
		do
			create Result.make_shared (c_mp_lc (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_mp_lc (a_mp_lc: CE_POINTER [ANY])
		do
			c_set_mp_lc (c_pointer, a_mp_lc.c_pointer)
		end

feature {NONE} -- C getters

	c_mp_lc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((union __anonunion__mp_algdata_11 *)$tmp)->_mp_lc;"
		end

feature {NONE} -- C setters

	c_set_mp_lc (tmp: POINTER; a_mp_lc: POINTER)
		external
			"C inline"
		alias
			"((union __anonunion__mp_algdata_11 *)$tmp)->_mp_lc = (void *)$a_mp_lc;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(union __anonunion__mp_algdata_11);"
		end

end
