class
	PD_MPQ_STRUCT

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	mp_num: PD_MPZ_STRUCT assign set_mp_num
		do
			create Result.make_shared (c_mp_num (c_pointer))
		end

	mp_num_offset: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return (int)offsetof(struct __anonstruct___mpq_struct_24, _mp_num);"
		end

	mp_den: PD_MPZ_STRUCT assign set_mp_den
		do
			create Result.make_shared (c_mp_den (c_pointer))
		end

	mp_den_offset: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return (int)offsetof(struct __anonstruct___mpq_struct_24, _mp_den);"
		end

feature {ANY} -- Eiffel setters

	set_mp_num (a_mp_num: PD_MPZ_STRUCT)
		do
			mp_num.ce_gets (a_mp_num)
		end

	set_mp_den (a_mp_den: PD_MPZ_STRUCT)
		do
			mp_den.ce_gets (a_mp_den)
		end

feature {NONE} -- C getters

	c_mp_num (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (__mpz_struct *)&((struct __anonstruct___mpq_struct_24 *)$tmp)->_mp_num;"
		end

	c_mp_den (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (__mpz_struct *)&((struct __anonstruct___mpq_struct_24 *)$tmp)->_mp_den;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return sizeof(struct __anonstruct___mpq_struct_24);"
		end

end
