frozen class
	LIBGMP_INITIALIZER_SLICE4

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {LIBGMP_INITIALIZER}

	initialize
		do
			mp_bases_inst.gmpn_bases[11].chars_per_limb := 9
			mp_bases_inst.gmpn_bases[11].chars_per_bit_exactly := 0.2890648263178878
			mp_bases_inst.gmpn_bases[11].big_base := {NATURAL_32} 2357947691
			mp_bases_inst.gmpn_bases[11].big_base_inverted := {NATURAL_32} 3528252932
			mp_bases_inst.gmpn_bases[12].chars_per_limb := 8
			mp_bases_inst.gmpn_bases[12].chars_per_bit_exactly := 0.2789429456511298
			mp_bases_inst.gmpn_bases[12].big_base := (429981696).to_natural_32
			mp_bases_inst.gmpn_bases[12].big_base_inverted := (1067686581).to_natural_32
			mp_bases_inst.gmpn_bases[13].chars_per_limb := 8
			mp_bases_inst.gmpn_bases[13].chars_per_bit_exactly := 0.2702381544273197
			mp_bases_inst.gmpn_bases[13].big_base := (815730721).to_natural_32
			mp_bases_inst.gmpn_bases[13].big_base_inverted := (1358474335).to_natural_32
			mp_bases_inst.gmpn_bases[14].chars_per_limb := 8
			mp_bases_inst.gmpn_bases[14].chars_per_bit_exactly := 0.2626495350371936
			mp_bases_inst.gmpn_bases[14].big_base := (1475789056).to_natural_32
			mp_bases_inst.gmpn_bases[14].big_base_inverted := (1954822942).to_natural_32
			mp_bases_inst.gmpn_bases[15].chars_per_limb := 8
			mp_bases_inst.gmpn_bases[15].chars_per_bit_exactly := 0.2559580248098155
			mp_bases_inst.gmpn_bases[15].big_base := {NATURAL_32} 2562890625
			mp_bases_inst.gmpn_bases[15].big_base_inverted := {NATURAL_32} 2902664898
			mp_bases_inst.gmpn_bases[16].chars_per_limb := 8
			mp_bases_inst.gmpn_bases[16].chars_per_bit_exactly := 0.2500000000000000
			mp_bases_inst.gmpn_bases[16].big_base := (4).to_natural_32
			mp_bases_inst.gmpn_bases[16].big_base_inverted := {NATURAL_32} 0
			mp_bases_inst.gmpn_bases[17].chars_per_limb := 7
			mp_bases_inst.gmpn_bases[17].chars_per_bit_exactly := 0.2446505421182260
			mp_bases_inst.gmpn_bases[17].big_base := (410338673).to_natural_32
			mp_bases_inst.gmpn_bases[17].big_base_inverted := (1324398269).to_natural_32
			mp_bases_inst.gmpn_bases[18].chars_per_limb := 7
			mp_bases_inst.gmpn_bases[18].chars_per_bit_exactly := 0.2398124665681315
			mp_bases_inst.gmpn_bases[18].big_base := (612220032).to_natural_32
			mp_bases_inst.gmpn_bases[18].big_base_inverted := {NATURAL_32} 3237759137
			mp_bases_inst.gmpn_bases[19].chars_per_limb := 7
			mp_bases_inst.gmpn_bases[19].chars_per_bit_exactly := 0.2354089133666382
			mp_bases_inst.gmpn_bases[19].big_base := (893871739).to_natural_32
			mp_bases_inst.gmpn_bases[19].big_base_inverted := (864258370).to_natural_32
			mp_bases_inst.gmpn_bases[20].chars_per_limb := 7
			mp_bases_inst.gmpn_bases[20].chars_per_bit_exactly := 0.2313782131597592
			mp_bases_inst.gmpn_bases[20].big_base := (1280000000).to_natural_32
			mp_bases_inst.gmpn_bases[20].big_base_inverted := {NATURAL_32} 2910792107
			mp_bases_inst.gmpn_bases[21].chars_per_limb := 7
			mp_bases_inst.gmpn_bases[21].chars_per_bit_exactly := 0.2276702486969530
			mp_bases_inst.gmpn_bases[21].big_base := (1801088541).to_natural_32
			mp_bases_inst.gmpn_bases[21].big_base_inverted := (826031381).to_natural_32
			mp_bases_inst.gmpn_bases[22].chars_per_limb := 7
			mp_bases_inst.gmpn_bases[22].chars_per_bit_exactly := 0.2242438242175754
			mp_bases_inst.gmpn_bases[22].big_base := {NATURAL_32} 2494357888
			mp_bases_inst.gmpn_bases[22].big_base_inverted := {NATURAL_32} 3100420576
			mp_bases_inst.gmpn_bases[23].chars_per_limb := 7
			mp_bases_inst.gmpn_bases[23].chars_per_bit_exactly := 0.2210647294575037
			mp_bases_inst.gmpn_bases[23].big_base := {NATURAL_32} 3404825447
			mp_bases_inst.gmpn_bases[23].big_base_inverted := (1122856425).to_natural_32
			mp_bases_inst.gmpn_bases[24].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[24].chars_per_bit_exactly := 0.2181042919855316
			mp_bases_inst.gmpn_bases[24].big_base := (191102976).to_natural_32
			mp_bases_inst.gmpn_bases[24].big_base_inverted := (1738018315).to_natural_32
			mp_bases_inst.gmpn_bases[25].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[25].chars_per_bit_exactly := 0.2153382790366965
			mp_bases_inst.gmpn_bases[25].big_base := (244140625).to_natural_32
			mp_bases_inst.gmpn_bases[25].big_base_inverted := (427399186).to_natural_32
			mp_bases_inst.gmpn_bases[26].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[26].chars_per_bit_exactly := 0.2127460535533632
			mp_bases_inst.gmpn_bases[26].big_base := (308915776).to_natural_32
			mp_bases_inst.gmpn_bases[26].big_base_inverted := {NATURAL_32} 3169342358
			mp_bases_inst.gmpn_bases[27].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[27].chars_per_bit_exactly := 0.2103099178571525
			mp_bases_inst.gmpn_bases[27].big_base := (387420489).to_natural_32
			mp_bases_inst.gmpn_bases[27].big_base_inverted := (1656816553).to_natural_32
			mp_bases_inst.gmpn_bases[28].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[28].chars_per_bit_exactly := 0.2080145976765095
			mp_bases_inst.gmpn_bases[28].big_base := (481890304).to_natural_32
			mp_bases_inst.gmpn_bases[28].big_base_inverted := (490028355).to_natural_32
			mp_bases_inst.gmpn_bases[29].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[29].chars_per_bit_exactly := 0.2058468324604344
			mp_bases_inst.gmpn_bases[29].big_base := (594823321).to_natural_32
			mp_bases_inst.gmpn_bases[29].big_base_inverted := {NATURAL_32} 3458067690
			mp_bases_inst.gmpn_bases[30].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[30].chars_per_bit_exactly := 0.2037950470905062
			mp_bases_inst.gmpn_bases[30].big_base := (729000000).to_natural_32
			mp_bases_inst.gmpn_bases[30].big_base_inverted := (2031076625).to_natural_32
			mp_bases_inst.gmpn_bases[31].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[31].chars_per_bit_exactly := 0.2018490865820999
			mp_bases_inst.gmpn_bases[31].big_base := (887503681).to_natural_32
			mp_bases_inst.gmpn_bases[31].big_base_inverted := (901277088).to_natural_32
			mp_bases_inst.gmpn_bases[32].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[32].chars_per_bit_exactly := 0.2000000000000000
			mp_bases_inst.gmpn_bases[32].big_base := (5).to_natural_32
			mp_bases_inst.gmpn_bases[32].big_base_inverted := {NATURAL_32} 0
			mp_bases_inst.gmpn_bases[33].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[33].chars_per_bit_exactly := 0.1982398631705605
			mp_bases_inst.gmpn_bases[33].big_base := (1291467969).to_natural_32
			mp_bases_inst.gmpn_bases[33].big_base_inverted := {NATURAL_32} 2846806451
			mp_bases_inst.gmpn_bases[34].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[34].chars_per_bit_exactly := 0.1965616322328226
			mp_bases_inst.gmpn_bases[34].big_base := (1544804416).to_natural_32
			mp_bases_inst.gmpn_bases[34].big_base_inverted := (1675608617).to_natural_32
			mp_bases_inst.gmpn_bases[35].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[35].chars_per_bit_exactly := 0.1949590218937863
			mp_bases_inst.gmpn_bases[35].big_base := (1838265625).to_natural_32
			mp_bases_inst.gmpn_bases[35].big_base_inverted := (722464304).to_natural_32
			mp_bases_inst.gmpn_bases[36].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[36].chars_per_bit_exactly := 0.1934264036172708
			mp_bases_inst.gmpn_bases[36].big_base := {NATURAL_32} 2176782336
			mp_bases_inst.gmpn_bases[36].big_base_inverted := {NATURAL_32} 4179349942
			mp_bases_inst.gmpn_bases[37].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[37].chars_per_bit_exactly := 0.1919587200065601
			mp_bases_inst.gmpn_bases[37].big_base := {NATURAL_32} 2565726409
			mp_bases_inst.gmpn_bases[37].big_base_inverted := {NATURAL_32} 2894709673
			mp_bases_inst.gmpn_bases[38].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[38].chars_per_bit_exactly := 0.1905514124267734
			mp_bases_inst.gmpn_bases[38].big_base := {NATURAL_32} 3010936384
			mp_bases_inst.gmpn_bases[38].big_base_inverted := (1831613182).to_natural_32
			mp_bases_inst.gmpn_bases[39].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[39].chars_per_bit_exactly := 0.1892003595168700
			mp_bases_inst.gmpn_bases[39].big_base := {NATURAL_32} 3518743761
			mp_bases_inst.gmpn_bases[39].big_base_inverted := (947455945).to_natural_32
			mp_bases_inst.gmpn_bases[40].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[40].chars_per_bit_exactly := 0.1879018247091076
			mp_bases_inst.gmpn_bases[40].big_base := {NATURAL_32} 4096000000
			mp_bases_inst.gmpn_bases[40].big_base_inverted := (208632331).to_natural_32
			mp_bases_inst.gmpn_bases[41].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[41].chars_per_bit_exactly := 0.1866524112389434
			mp_bases_inst.gmpn_bases[41].big_base := (115856201).to_natural_32
			mp_bases_inst.gmpn_bases[41].big_base_inverted := (680690004).to_natural_32
			mp_bases_inst.gmpn_bases[42].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[42].chars_per_bit_exactly := 0.1854490234153689
			mp_bases_inst.gmpn_bases[42].big_base := (130691232).to_natural_32
			mp_bases_inst.gmpn_bases[42].big_base_inverted := (115892893).to_natural_32
			mp_bases_inst.gmpn_bases[43].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[43].chars_per_bit_exactly := 0.1842888331487062
			mp_bases_inst.gmpn_bases[43].big_base := (147008443).to_natural_32
			mp_bases_inst.gmpn_bases[43].big_base_inverted := {NATURAL_32} 3547585696
			mp_bases_inst.gmpn_bases[44].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[44].chars_per_bit_exactly := 0.1831692509136336
			mp_bases_inst.gmpn_bases[44].big_base := (164916224).to_natural_32
			mp_bases_inst.gmpn_bases[44].big_base_inverted := {NATURAL_32} 2695985301
			mp_bases_inst.gmpn_bases[45].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[45].chars_per_bit_exactly := 0.1820879004699383
			mp_bases_inst.gmpn_bases[45].big_base := (184528125).to_natural_32
			mp_bases_inst.gmpn_bases[45].big_base_inverted := (1952977317).to_natural_32
			mp_bases_inst.gmpn_bases[46].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[46].chars_per_bit_exactly := 0.1810425967800402
			mp_bases_inst.gmpn_bases[46].big_base := (205962976).to_natural_32
			mp_bases_inst.gmpn_bases[46].big_base_inverted := (1302745103).to_natural_32
			mp_bases_inst.gmpn_bases[47].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[47].chars_per_bit_exactly := 0.1800313266566926
			mp_bases_inst.gmpn_bases[47].big_base := (229345007).to_natural_32
			mp_bases_inst.gmpn_bases[47].big_base_inverted := (732050818).to_natural_32
			mp_bases_inst.gmpn_bases[48].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[48].chars_per_bit_exactly := 0.1790522317510413
			mp_bases_inst.gmpn_bases[48].big_base := (254803968).to_natural_32
			mp_bases_inst.gmpn_bases[48].big_base_inverted := (229771912).to_natural_32
			mp_bases_inst.gmpn_bases[49].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[49].chars_per_bit_exactly := 0.1781035935540111
			mp_bases_inst.gmpn_bases[49].big_base := (282475249).to_natural_32
			mp_bases_inst.gmpn_bases[49].big_base_inverted := {NATURAL_32} 3868024036
			mp_bases_inst.gmpn_bases[50].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[50].chars_per_bit_exactly := 0.1771838201355579
			mp_bases_inst.gmpn_bases[50].big_base := (312500000).to_natural_32
			mp_bases_inst.gmpn_bases[50].big_base_inverted := {NATURAL_32} 3083730333
			mp_bases_inst.gmpn_bases[51].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[51].chars_per_bit_exactly := 0.1762914343888821
			mp_bases_inst.gmpn_bases[51].big_base := (345025251).to_natural_32
			mp_bases_inst.gmpn_bases[51].big_base_inverted := {NATURAL_32} 2388146483
			mp_bases_inst.gmpn_bases[52].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[52].chars_per_bit_exactly := 0.1754250635819545
			mp_bases_inst.gmpn_bases[52].big_base := (380204032).to_natural_32
			mp_bases_inst.gmpn_bases[52].big_base_inverted := (1769784298).to_natural_32
			mp_bases_inst.gmpn_bases[53].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[53].chars_per_bit_exactly := 0.1745834300480449
			mp_bases_inst.gmpn_bases[53].big_base := (418195493).to_natural_32
			mp_bases_inst.gmpn_bases[53].big_base_inverted := (1218824812).to_natural_32
			mp_bases_inst.gmpn_bases[54].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[54].chars_per_bit_exactly := 0.1737653428714400
			mp_bases_inst.gmpn_bases[54].big_base := (459165024).to_natural_32
			mp_bases_inst.gmpn_bases[54].big_base_inverted := (726850326).to_natural_32
			mp_bases_inst.gmpn_bases[55].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[55].chars_per_bit_exactly := 0.1729696904450771
			mp_bases_inst.gmpn_bases[55].big_base := (503284375).to_natural_32
			mp_bases_inst.gmpn_bases[55].big_base_inverted := (286623398).to_natural_32
			mp_bases_inst.gmpn_bases[56].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[56].chars_per_bit_exactly := 0.1721954337940981
			mp_bases_inst.gmpn_bases[56].big_base := (550731776).to_natural_32
			mp_bases_inst.gmpn_bases[56].big_base_inverted := {NATURAL_32} 4078775094
			mp_bases_inst.gmpn_bases[57].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[57].chars_per_bit_exactly := 0.1714416005739134
			mp_bases_inst.gmpn_bases[57].big_base := (601692057).to_natural_32
			mp_bases_inst.gmpn_bases[57].big_base_inverted := {NATURAL_32} 3369561369
			mp_bases_inst.gmpn_bases[58].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[58].chars_per_bit_exactly := 0.1707072796637201
			mp_bases_inst.gmpn_bases[58].big_base := (656356768).to_natural_32
			mp_bases_inst.gmpn_bases[58].big_base_inverted := {NATURAL_32} 2731220660
			mp_bases_inst.gmpn_bases[59].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[59].chars_per_bit_exactly := 0.1699916162869140
			mp_bases_inst.gmpn_bases[59].big_base := (714924299).to_natural_32
			mp_bases_inst.gmpn_bases[59].big_base_inverted := {NATURAL_32} 2155626179
			mp_bases_inst.gmpn_bases[60].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[60].chars_per_bit_exactly := 0.1692938075987814
			mp_bases_inst.gmpn_bases[60].big_base := (777600000).to_natural_32
			mp_bases_inst.gmpn_bases[60].big_base_inverted := (1635698879).to_natural_32
			mp_bases_inst.gmpn_bases[61].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[61].chars_per_bit_exactly := 0.1686130986895011
			mp_bases_inst.gmpn_bases[61].big_base := (844596301).to_natural_32
			mp_bases_inst.gmpn_bases[61].big_base_inverted := (1165257918).to_natural_32
			mp_bases_inst.gmpn_bases[62].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[62].chars_per_bit_exactly := 0.1679487789570419
			mp_bases_inst.gmpn_bases[62].big_base := (916132832).to_natural_32
			mp_bases_inst.gmpn_bases[62].big_base_inverted := (738894451).to_natural_32
			mp_bases_inst.gmpn_bases[63].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[63].chars_per_bit_exactly := 0.1673001788101741
			mp_bases_inst.gmpn_bases[63].big_base := (992436543).to_natural_32
			mp_bases_inst.gmpn_bases[63].big_base_inverted := (351864837).to_natural_32
			mp_bases_inst.gmpn_bases[64].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[64].chars_per_bit_exactly := 0.1666666666666667
			mp_bases_inst.gmpn_bases[64].big_base := (6).to_natural_32
			mp_bases_inst.gmpn_bases[64].big_base_inverted := {NATURAL_32} 0
			mp_bases_inst.gmpn_bases[65].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[65].chars_per_bit_exactly := 0.1660476462159378
			mp_bases_inst.gmpn_bases[65].big_base := (1160290625).to_natural_32
			mp_bases_inst.gmpn_bases[65].big_base_inverted := {NATURAL_32} 3654223913
			mp_bases_inst.gmpn_bases[66].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[66].chars_per_bit_exactly := 0.1654425539190583
			mp_bases_inst.gmpn_bases[66].big_base := (1252332576).to_natural_32
			mp_bases_inst.gmpn_bases[66].big_base_inverted := {NATURAL_32} 3069986881
			mp_bases_inst.gmpn_bases[67].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[67].chars_per_bit_exactly := 0.1648508567221604
			mp_bases_inst.gmpn_bases[67].big_base := (1350125107).to_natural_32
			mp_bases_inst.gmpn_bases[67].big_base_inverted := {NATURAL_32} 2536527051
			mp_bases_inst.gmpn_bases[68].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[68].chars_per_bit_exactly := 0.1642720499620502
			mp_bases_inst.gmpn_bases[68].big_base := (1453933568).to_natural_32
			mp_bases_inst.gmpn_bases[68].big_base_inverted := (2048769611).to_natural_32
			mp_bases_inst.gmpn_bases[69].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[69].chars_per_bit_exactly := 0.1637056554452156
			mp_bases_inst.gmpn_bases[69].big_base := (1564031349).to_natural_32
			mp_bases_inst.gmpn_bases[69].big_base_inverted := (1602211199).to_natural_32
			mp_bases_inst.gmpn_bases[70].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[70].chars_per_bit_exactly := 0.1631512196835108
			mp_bases_inst.gmpn_bases[70].big_base := (1680700000).to_natural_32
			mp_bases_inst.gmpn_bases[70].big_base_inverted := (1192848516).to_natural_32
			mp_bases_inst.gmpn_bases[71].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[71].chars_per_bit_exactly := 0.1626083122716341
			mp_bases_inst.gmpn_bases[71].big_base := (1804229351).to_natural_32
			mp_bases_inst.gmpn_bases[71].big_base_inverted := (817116725).to_natural_32
			mp_bases_inst.gmpn_bases[72].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[72].chars_per_bit_exactly := 0.1620765243931223
			mp_bases_inst.gmpn_bases[72].big_base := (1934917632).to_natural_32
			mp_bases_inst.gmpn_bases[72].big_base_inverted := (471836150).to_natural_32
			mp_bases_inst.gmpn_bases[73].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[73].chars_per_bit_exactly := 0.1615554674429964
			mp_bases_inst.gmpn_bases[73].big_base := (2073071593).to_natural_32
			mp_bases_inst.gmpn_bases[73].big_base_inverted := (154166090).to_natural_32
			mp_bases_inst.gmpn_bases[74].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[74].chars_per_bit_exactly := 0.1610447717564444
			mp_bases_inst.gmpn_bases[74].big_base := {NATURAL_32} 2219006624
			mp_bases_inst.gmpn_bases[74].big_base_inverted := {NATURAL_32} 4018096700
			mp_bases_inst.gmpn_bases[75].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[75].chars_per_bit_exactly := 0.1605440854340214
			mp_bases_inst.gmpn_bases[75].big_base := {NATURAL_32} 2373046875
			mp_bases_inst.gmpn_bases[75].big_base_inverted := {NATURAL_32} 3478475474
			mp_bases_inst.gmpn_bases[76].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[76].chars_per_bit_exactly := 0.1600530732548213
			mp_bases_inst.gmpn_bases[76].big_base := {NATURAL_32} 2535525376
			mp_bases_inst.gmpn_bases[76].big_base_inverted := {NATURAL_32} 2980347022
			mp_bases_inst.gmpn_bases[77].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[77].chars_per_bit_exactly := 0.1595714156699382
			mp_bases_inst.gmpn_bases[77].big_base := {NATURAL_32} 2706784157
			mp_bases_inst.gmpn_bases[77].big_base_inverted := {NATURAL_32} 2520036414
			mp_bases_inst.gmpn_bases[78].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[78].chars_per_bit_exactly := 0.1590988078692941
			mp_bases_inst.gmpn_bases[78].big_base := {NATURAL_32} 2887174368
			mp_bases_inst.gmpn_bases[78].big_base_inverted := (2094236029).to_natural_32
			mp_bases_inst.gmpn_bases[79].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[79].chars_per_bit_exactly := 0.1586349589155960
			mp_bases_inst.gmpn_bases[79].big_base := {NATURAL_32} 3077056399
			mp_bases_inst.gmpn_bases[79].big_base_inverted := (1699964769).to_natural_32
			mp_bases_inst.gmpn_bases[80].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[80].chars_per_bit_exactly := 0.1581795909397823
			mp_bases_inst.gmpn_bases[80].big_base := {NATURAL_32} 3276800000
			mp_bases_inst.gmpn_bases[80].big_base_inverted := (1334532238).to_natural_32
			mp_bases_inst.gmpn_bases[81].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[81].chars_per_bit_exactly := 0.1577324383928644
			mp_bases_inst.gmpn_bases[81].big_base := {NATURAL_32} 3486784401
			mp_bases_inst.gmpn_bases[81].big_base_inverted := (995507236).to_natural_32
			mp_bases_inst.gmpn_bases[82].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[82].chars_per_bit_exactly := 0.1572932473495469
			mp_bases_inst.gmpn_bases[82].big_base := {NATURAL_32} 3707398432
			mp_bases_inst.gmpn_bases[82].big_base_inverted := (680690004).to_natural_32
			mp_bases_inst.gmpn_bases[83].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[83].chars_per_bit_exactly := 0.1568617748594410
			mp_bases_inst.gmpn_bases[83].big_base := {NATURAL_32} 3939040643
			mp_bases_inst.gmpn_bases[83].big_base_inverted := (388087728).to_natural_32
			mp_bases_inst.gmpn_bases[84].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[84].chars_per_bit_exactly := 0.1564377883420716
			mp_bases_inst.gmpn_bases[84].big_base := {NATURAL_32} 4182119424
			mp_bases_inst.gmpn_bases[84].big_base_inverted := (115892893).to_natural_32
			mp_bases_inst.gmpn_bases[85].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[85].chars_per_bit_exactly := 0.1560210650222250
			mp_bases_inst.gmpn_bases[85].big_base := (52200625).to_natural_32
			mp_bases_inst.gmpn_bases[85].big_base_inverted := (1226621308).to_natural_32
			mp_bases_inst.gmpn_bases[86].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[86].chars_per_bit_exactly := 0.1556113914024940
			mp_bases_inst.gmpn_bases[86].big_base := (54700816).to_natural_32
			mp_bases_inst.gmpn_bases[86].big_base_inverted := (974247995).to_natural_32
			mp_bases_inst.gmpn_bases[87].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[87].chars_per_bit_exactly := 0.1552085627701551
			mp_bases_inst.gmpn_bases[87].big_base := (57289761).to_natural_32
			mp_bases_inst.gmpn_bases[87].big_base_inverted := (736130253).to_natural_32
			mp_bases_inst.gmpn_bases[88].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[88].chars_per_bit_exactly := 0.1548123827357682
			mp_bases_inst.gmpn_bases[88].big_base := (59969536).to_natural_32
			mp_bases_inst.gmpn_bases[88].big_base_inverted := (511312615).to_natural_32
			mp_bases_inst.gmpn_bases[89].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[89].chars_per_bit_exactly := 0.1544226628011101
			mp_bases_inst.gmpn_bases[89].big_base := (62742241).to_natural_32
			mp_bases_inst.gmpn_bases[89].big_base_inverted := (298913501).to_natural_32
			mp_bases_inst.gmpn_bases[90].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[90].chars_per_bit_exactly := 0.1540392219542636
			mp_bases_inst.gmpn_bases[90].big_base := (65610000).to_natural_32
			mp_bases_inst.gmpn_bases[90].big_base_inverted := (98118760).to_natural_32
			mp_bases_inst.gmpn_bases[91].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[91].chars_per_bit_exactly := 0.1536618862898642
			mp_bases_inst.gmpn_bases[91].big_base := (68574961).to_natural_32
			mp_bases_inst.gmpn_bases[91].big_base_inverted := {NATURAL_32} 4111318962
			mp_bases_inst.gmpn_bases[92].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[92].chars_per_bit_exactly := 0.1532904886526781
			mp_bases_inst.gmpn_bases[92].big_base := (71639296).to_natural_32
			mp_bases_inst.gmpn_bases[92].big_base_inverted := {NATURAL_32} 3751744278
			mp_bases_inst.gmpn_bases[93].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[93].chars_per_bit_exactly := 0.1529248683028321
			mp_bases_inst.gmpn_bases[93].big_base := (74805201).to_natural_32
			mp_bases_inst.gmpn_bases[93].big_base_inverted := {NATURAL_32} 3411191428
			mp_bases_inst.gmpn_bases[94].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[94].chars_per_bit_exactly := 0.1525648706011593
			mp_bases_inst.gmpn_bases[94].big_base := (78074896).to_natural_32
			mp_bases_inst.gmpn_bases[94].big_base_inverted := {NATURAL_32} 3088465559
			mp_bases_inst.gmpn_bases[95].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[95].chars_per_bit_exactly := 0.1522103467132434
			mp_bases_inst.gmpn_bases[95].big_base := (81450625).to_natural_32
			mp_bases_inst.gmpn_bases[95].big_base_inverted := {NATURAL_32} 2782458473
			mp_bases_inst.gmpn_bases[96].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[96].chars_per_bit_exactly := 0.1518611533308632
			mp_bases_inst.gmpn_bases[96].big_base := (84934656).to_natural_32
			mp_bases_inst.gmpn_bases[96].big_base_inverted := {NATURAL_32} 2492141517
			mp_bases_inst.gmpn_bases[97].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[97].chars_per_bit_exactly := 0.1515171524096389
			mp_bases_inst.gmpn_bases[97].big_base := (88529281).to_natural_32
			mp_bases_inst.gmpn_bases[97].big_base_inverted := {NATURAL_32} 2216559125
			mp_bases_inst.gmpn_bases[98].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[98].chars_per_bit_exactly := 0.1511782109217764
			mp_bases_inst.gmpn_bases[98].big_base := (92236816).to_natural_32
			mp_bases_inst.gmpn_bases[98].big_base_inverted := (1954822942).to_natural_32
			mp_bases_inst.gmpn_bases[99].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[99].chars_per_bit_exactly := 0.1508442006228941
			mp_bases_inst.gmpn_bases[99].big_base := (96059601).to_natural_32
			mp_bases_inst.gmpn_bases[99].big_base_inverted := (1706106478).to_natural_32
			mp_bases_inst.gmpn_bases[100].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[100].chars_per_bit_exactly := 0.1505149978319906
			mp_bases_inst.gmpn_bases[100].big_base := (100000000).to_natural_32
			mp_bases_inst.gmpn_bases[100].big_base_inverted := (1469640227).to_natural_32
			mp_bases_inst.gmpn_bases[101].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[101].chars_per_bit_exactly := 0.1501904832236879
			mp_bases_inst.gmpn_bases[101].big_base := (104060401).to_natural_32
			mp_bases_inst.gmpn_bases[101].big_base_inverted := (1244707227).to_natural_32
			mp_bases_inst.gmpn_bases[102].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[102].chars_per_bit_exactly := 0.1498705416319474
			mp_bases_inst.gmpn_bases[102].big_base := (108243216).to_natural_32
			mp_bases_inst.gmpn_bases[102].big_base_inverted := (1030638996).to_natural_32
			mp_bases_inst.gmpn_bases[103].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[103].chars_per_bit_exactly := 0.1495550618645152
			mp_bases_inst.gmpn_bases[103].big_base := (112550881).to_natural_32
			mp_bases_inst.gmpn_bases[103].big_base_inverted := (826811824).to_natural_32
			mp_bases_inst.gmpn_bases[104].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[104].chars_per_bit_exactly := 0.1492439365274121
			mp_bases_inst.gmpn_bases[104].big_base := (116985856).to_natural_32
			mp_bases_inst.gmpn_bases[104].big_base_inverted := (632643374).to_natural_32
			mp_bases_inst.gmpn_bases[105].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[105].chars_per_bit_exactly := 0.1489370618588283
			mp_bases_inst.gmpn_bases[105].big_base := (121550625).to_natural_32
			mp_bases_inst.gmpn_bases[105].big_base_inverted := (447589579).to_natural_32
			mp_bases_inst.gmpn_bases[106].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[106].chars_per_bit_exactly := 0.1486343375718350
			mp_bases_inst.gmpn_bases[106].big_base := (126247696).to_natural_32
			mp_bases_inst.gmpn_bases[106].big_base_inverted := (271141794).to_natural_32
			mp_bases_inst.gmpn_bases[107].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[107].chars_per_bit_exactly := 0.1483356667053617
			mp_bases_inst.gmpn_bases[107].big_base := (131079601).to_natural_32
			mp_bases_inst.gmpn_bases[107].big_base_inverted := (102824182).to_natural_32
			mp_bases_inst.gmpn_bases[108].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[108].chars_per_bit_exactly := 0.1480409554829326
			mp_bases_inst.gmpn_bases[108].big_base := (136048896).to_natural_32
			mp_bases_inst.gmpn_bases[108].big_base_inverted := {NATURAL_32} 4179349942
			mp_bases_inst.gmpn_bases[109].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[109].chars_per_bit_exactly := 0.1477501131786861
			mp_bases_inst.gmpn_bases[109].big_base := (141158161).to_natural_32
			mp_bases_inst.gmpn_bases[109].big_base_inverted := {NATURAL_32} 3872619306
			mp_bases_inst.gmpn_bases[110].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[110].chars_per_bit_exactly := 0.1474630519902391
			mp_bases_inst.gmpn_bases[110].big_base := (146410000).to_natural_32
			mp_bases_inst.gmpn_bases[110].big_base_inverted := {NATURAL_32} 3579641710
			mp_bases_inst.gmpn_bases[111].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[111].chars_per_bit_exactly := 0.1471796869179852
			mp_bases_inst.gmpn_bases[111].big_base := (151807041).to_natural_32
			mp_bases_inst.gmpn_bases[111].big_base_inverted := {NATURAL_32} 3299683762
			mp_bases_inst.gmpn_bases[112].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[112].chars_per_bit_exactly := 0.1468999356504447
			mp_bases_inst.gmpn_bases[112].big_base := (157351936).to_natural_32
			mp_bases_inst.gmpn_bases[112].big_base_inverted := {NATURAL_32} 3032057295
			mp_bases_inst.gmpn_bases[113].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[113].chars_per_bit_exactly := 0.1466237184553111
			mp_bases_inst.gmpn_bases[113].big_base := (163047361).to_natural_32
			mp_bases_inst.gmpn_bases[113].big_base_inverted := {NATURAL_32} 2776116207
			mp_bases_inst.gmpn_bases[114].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[114].chars_per_bit_exactly := 0.1463509580758620
			mp_bases_inst.gmpn_bases[114].big_base := (168896016).to_natural_32
			mp_bases_inst.gmpn_bases[114].big_base_inverted := {NATURAL_32} 2531253546
			mp_bases_inst.gmpn_bases[115].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[115].chars_per_bit_exactly := 0.1460815796324244
			mp_bases_inst.gmpn_bases[115].big_base := (174900625).to_natural_32
			mp_bases_inst.gmpn_bases[115].big_base_inverted := {NATURAL_32} 2296898825
			mp_bases_inst.gmpn_bases[116].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[116].chars_per_bit_exactly := 0.1458155105286054
			mp_bases_inst.gmpn_bases[116].big_base := (181063936).to_natural_32
			mp_bases_inst.gmpn_bases[116].big_base_inverted := (2072515539).to_natural_32
			mp_bases_inst.gmpn_bases[117].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[117].chars_per_bit_exactly := 0.1455526803620167
			mp_bases_inst.gmpn_bases[117].big_base := (187388721).to_natural_32
			mp_bases_inst.gmpn_bases[117].big_base_inverted := (1857598869).to_natural_32
			mp_bases_inst.gmpn_bases[118].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[118].chars_per_bit_exactly := 0.1452930208392428
			mp_bases_inst.gmpn_bases[118].big_base := (193877776).to_natural_32
			mp_bases_inst.gmpn_bases[118].big_base_inverted := (1651673563).to_natural_32
			mp_bases_inst.gmpn_bases[119].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[119].chars_per_bit_exactly := 0.1450364656948130
			mp_bases_inst.gmpn_bases[119].big_base := (200533921).to_natural_32
			mp_bases_inst.gmpn_bases[119].big_base_inverted := (1454291975).to_natural_32
			mp_bases_inst.gmpn_bases[120].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[120].chars_per_bit_exactly := 0.1447829506139581
			mp_bases_inst.gmpn_bases[120].big_base := (207360000).to_natural_32
			mp_bases_inst.gmpn_bases[120].big_base_inverted := (1265032243).to_natural_32
			mp_bases_inst.gmpn_bases[121].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[121].chars_per_bit_exactly := 0.1445324131589439
			mp_bases_inst.gmpn_bases[121].big_base := (214358881).to_natural_32
			mp_bases_inst.gmpn_bases[121].big_base_inverted := (1083496611).to_natural_32
			mp_bases_inst.gmpn_bases[122].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[122].chars_per_bit_exactly := 0.1442847926987864
			mp_bases_inst.gmpn_bases[122].big_base := (221533456).to_natural_32
			mp_bases_inst.gmpn_bases[122].big_base_inverted := (909309861).to_natural_32
			mp_bases_inst.gmpn_bases[123].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[123].chars_per_bit_exactly := 0.1440400303421672
			mp_bases_inst.gmpn_bases[123].big_base := (228886641).to_natural_32
			mp_bases_inst.gmpn_bases[123].big_base_inverted := (742117872).to_natural_32
			mp_bases_inst.gmpn_bases[124].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[124].chars_per_bit_exactly := 0.1437980688733775
			mp_bases_inst.gmpn_bases[124].big_base := (236421376).to_natural_32
			mp_bases_inst.gmpn_bases[124].big_base_inverted := (581586271).to_natural_32
			mp_bases_inst.gmpn_bases[125].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[125].chars_per_bit_exactly := 0.1435588526911310
			mp_bases_inst.gmpn_bases[125].big_base := (244140625).to_natural_32
			mp_bases_inst.gmpn_bases[125].big_base_inverted := (427399186).to_natural_32
			mp_bases_inst.gmpn_bases[126].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[126].chars_per_bit_exactly := 0.1433223277500932
			mp_bases_inst.gmpn_bases[126].big_base := (252047376).to_natural_32
			mp_bases_inst.gmpn_bases[126].big_base_inverted := (279258085).to_natural_32
			mp_bases_inst.gmpn_bases[127].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[127].chars_per_bit_exactly := 0.1430884415049874
			mp_bases_inst.gmpn_bases[127].big_base := (260144641).to_natural_32
			mp_bases_inst.gmpn_bases[127].big_base_inverted := (136880695).to_natural_32
			mp_bases_inst.gmpn_bases[128].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[128].chars_per_bit_exactly := 0.1428571428571428
			mp_bases_inst.gmpn_bases[128].big_base := (7).to_natural_32
			mp_bases_inst.gmpn_bases[128].big_base_inverted := {NATURAL_32} 0
			mp_bases_inst.gmpn_bases[129].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[129].chars_per_bit_exactly := 0.1426283821033600
			mp_bases_inst.gmpn_bases[129].big_base := (276922881).to_natural_32
			mp_bases_inst.gmpn_bases[129].big_base_inverted := {NATURAL_32} 4031693906
			mp_bases_inst.gmpn_bases[130].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[130].chars_per_bit_exactly := 0.1424021108869747
			mp_bases_inst.gmpn_bases[130].big_base := (285610000).to_natural_32
			mp_bases_inst.gmpn_bases[130].big_base_inverted := {NATURAL_32} 3778430026
			mp_bases_inst.gmpn_bases[131].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[131].chars_per_bit_exactly := 0.1421782821510107
			mp_bases_inst.gmpn_bases[131].big_base := (294499921).to_natural_32
			mp_bases_inst.gmpn_bases[131].big_base_inverted := {NATURAL_32} 3534722441
			mp_bases_inst.gmpn_bases[132].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[132].chars_per_bit_exactly := 0.1419568500933153
			mp_bases_inst.gmpn_bases[132].big_base := (303595776).to_natural_32
			mp_bases_inst.gmpn_bases[132].big_base_inverted := {NATURAL_32} 3300141699
			mp_bases_inst.gmpn_bases[133].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[133].chars_per_bit_exactly := 0.1417377701235801
			mp_bases_inst.gmpn_bases[133].big_base := (312900721).to_natural_32
			mp_bases_inst.gmpn_bases[133].big_base_inverted := {NATURAL_32} 3074280693
			mp_bases_inst.gmpn_bases[134].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[134].chars_per_bit_exactly := 0.1415209988221527
			mp_bases_inst.gmpn_bases[134].big_base := (322417936).to_natural_32
			mp_bases_inst.gmpn_bases[134].big_base_inverted := {NATURAL_32} 2856753349
			mp_bases_inst.gmpn_bases[135].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[135].chars_per_bit_exactly := 0.1413064939005528
			mp_bases_inst.gmpn_bases[135].big_base := (332150625).to_natural_32
			mp_bases_inst.gmpn_bases[135].big_base_inverted := {NATURAL_32} 2647193385
		end

end
