frozen class
	LIBGMP_INITIALIZER_SLICE5

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {LIBGMP_INITIALIZER}

	initialize
		do
			mp_bases_inst.gmpn_bases[136].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[136].chars_per_bit_exactly := 0.1410942141636095
			mp_bases_inst.gmpn_bases[136].big_base := (342102016).to_natural_32
			mp_bases_inst.gmpn_bases[136].big_base_inverted := {NATURAL_32} 2445253168
			mp_bases_inst.gmpn_bases[137].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[137].chars_per_bit_exactly := 0.1408841194731412
			mp_bases_inst.gmpn_bases[137].big_base := (352275361).to_natural_32
			mp_bases_inst.gmpn_bases[137].big_base_inverted := {NATURAL_32} 2250602631
			mp_bases_inst.gmpn_bases[138].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[138].chars_per_bit_exactly := 0.1406761707131039
			mp_bases_inst.gmpn_bases[138].big_base := (362673936).to_natural_32
			mp_bases_inst.gmpn_bases[138].big_base_inverted := (2062928268).to_natural_32
			mp_bases_inst.gmpn_bases[139].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[139].chars_per_bit_exactly := 0.1404703297561400
			mp_bases_inst.gmpn_bases[139].big_base := (373301041).to_natural_32
			mp_bases_inst.gmpn_bases[139].big_base_inverted := (1881932192).to_natural_32
			mp_bases_inst.gmpn_bases[140].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[140].chars_per_bit_exactly := 0.1402665594314587
			mp_bases_inst.gmpn_bases[140].big_base := (384160000).to_natural_32
			mp_bases_inst.gmpn_bases[140].big_base_inverted := (1707331249).to_natural_32
			mp_bases_inst.gmpn_bases[141].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[141].chars_per_bit_exactly := 0.1400648234939879
			mp_bases_inst.gmpn_bases[141].big_base := (395254161).to_natural_32
			mp_bases_inst.gmpn_bases[141].big_base_inverted := (1538856194).to_natural_32
			mp_bases_inst.gmpn_bases[142].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[142].chars_per_bit_exactly := 0.1398650865947379
			mp_bases_inst.gmpn_bases[142].big_base := (406586896).to_natural_32
			mp_bases_inst.gmpn_bases[142].big_base_inverted := (1376250915).to_natural_32
			mp_bases_inst.gmpn_bases[143].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[143].chars_per_bit_exactly := 0.1396673142523192
			mp_bases_inst.gmpn_bases[143].big_base := (418161601).to_natural_32
			mp_bases_inst.gmpn_bases[143].big_base_inverted := (1219271705).to_natural_32
			mp_bases_inst.gmpn_bases[144].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[144].chars_per_bit_exactly := 0.1394714728255649
			mp_bases_inst.gmpn_bases[144].big_base := (429981696).to_natural_32
			mp_bases_inst.gmpn_bases[144].big_base_inverted := (1067686581).to_natural_32
			mp_bases_inst.gmpn_bases[145].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[145].chars_per_bit_exactly := 0.1392775294872041
			mp_bases_inst.gmpn_bases[145].big_base := (442050625).to_natural_32
			mp_bases_inst.gmpn_bases[145].big_base_inverted := (921274642).to_natural_32
			mp_bases_inst.gmpn_bases[146].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[146].chars_per_bit_exactly := 0.1390854521985406
			mp_bases_inst.gmpn_bases[146].big_base := (454371856).to_natural_32
			mp_bases_inst.gmpn_bases[146].big_base_inverted := (779825472).to_natural_32
			mp_bases_inst.gmpn_bases[147].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[147].chars_per_bit_exactly := 0.1388952096850913
			mp_bases_inst.gmpn_bases[147].big_base := (466948881).to_natural_32
			mp_bases_inst.gmpn_bases[147].big_base_inverted := (643138571).to_natural_32
			mp_bases_inst.gmpn_bases[148].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[148].chars_per_bit_exactly := 0.1387067714131417
			mp_bases_inst.gmpn_bases[148].big_base := (479785216).to_natural_32
			mp_bases_inst.gmpn_bases[148].big_base_inverted := (511022826).to_natural_32
			mp_bases_inst.gmpn_bases[149].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[149].chars_per_bit_exactly := 0.1385201075671774
			mp_bases_inst.gmpn_bases[149].big_base := (492884401).to_natural_32
			mp_bases_inst.gmpn_bases[149].big_base_inverted := (383296013).to_natural_32
			mp_bases_inst.gmpn_bases[150].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[150].chars_per_bit_exactly := 0.1383351890281539
			mp_bases_inst.gmpn_bases[150].big_base := (506250000).to_natural_32
			mp_bases_inst.gmpn_bases[150].big_base_inverted := (259784327).to_natural_32
			mp_bases_inst.gmpn_bases[151].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[151].chars_per_bit_exactly := 0.1381519873525671
			mp_bases_inst.gmpn_bases[151].big_base := (519885601).to_natural_32
			mp_bases_inst.gmpn_bases[151].big_base_inverted := (140321938).to_natural_32
			mp_bases_inst.gmpn_bases[152].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[152].chars_per_bit_exactly := 0.1379704747522905
			mp_bases_inst.gmpn_bases[152].big_base := (533794816).to_natural_32
			mp_bases_inst.gmpn_bases[152].big_base_inverted := (24750580).to_natural_32
			mp_bases_inst.gmpn_bases[153].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[153].chars_per_bit_exactly := 0.1377906240751463
			mp_bases_inst.gmpn_bases[153].big_base := (547981281).to_natural_32
			mp_bases_inst.gmpn_bases[153].big_base_inverted := {NATURAL_32} 4120805611
			mp_bases_inst.gmpn_bases[154].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[154].chars_per_bit_exactly := 0.1376124087861776
			mp_bases_inst.gmpn_bases[154].big_base := (562448656).to_natural_32
			mp_bases_inst.gmpn_bases[154].big_base_inverted := {NATURAL_32} 3904334043
			mp_bases_inst.gmpn_bases[155].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[155].chars_per_bit_exactly := 0.1374358029495937
			mp_bases_inst.gmpn_bases[155].big_base := (577200625).to_natural_32
			mp_bases_inst.gmpn_bases[155].big_base_inverted := {NATURAL_32} 3694778069
			mp_bases_inst.gmpn_bases[156].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[156].chars_per_bit_exactly := 0.1372607812113589
			mp_bases_inst.gmpn_bases[156].big_base := (592240896).to_natural_32
			mp_bases_inst.gmpn_bases[156].big_base_inverted := {NATURAL_32} 3491874257
			mp_bases_inst.gmpn_bases[157].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[157].chars_per_bit_exactly := 0.1370873187823978
			mp_bases_inst.gmpn_bases[157].big_base := (607573201).to_natural_32
			mp_bases_inst.gmpn_bases[157].big_base_inverted := {NATURAL_32} 3295370807
			mp_bases_inst.gmpn_bases[158].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[158].chars_per_bit_exactly := 0.1369153914223921
			mp_bases_inst.gmpn_bases[158].big_base := (623201296).to_natural_32
			mp_bases_inst.gmpn_bases[158].big_base_inverted := {NATURAL_32} 3105026972
			mp_bases_inst.gmpn_bases[159].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[159].chars_per_bit_exactly := 0.1367449754241439
			mp_bases_inst.gmpn_bases[159].big_base := (639128961).to_natural_32
			mp_bases_inst.gmpn_bases[159].big_base_inverted := {NATURAL_32} 2920612500
			mp_bases_inst.gmpn_bases[160].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[160].chars_per_bit_exactly := 0.1365760475984821
			mp_bases_inst.gmpn_bases[160].big_base := (655360000).to_natural_32
			mp_bases_inst.gmpn_bases[160].big_base_inverted := {NATURAL_32} 2741907121
			mp_bases_inst.gmpn_bases[161].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[161].chars_per_bit_exactly := 0.1364085852596902
			mp_bases_inst.gmpn_bases[161].big_base := (671898241).to_natural_32
			mp_bases_inst.gmpn_bases[161].big_base_inverted := {NATURAL_32} 2568700052
			mp_bases_inst.gmpn_bases[162].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[162].chars_per_bit_exactly := 0.1362425662114337
			mp_bases_inst.gmpn_bases[162].big_base := (688747536).to_natural_32
			mp_bases_inst.gmpn_bases[162].big_base_inverted := {NATURAL_32} 2400789534
			mp_bases_inst.gmpn_bases[163].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[163].chars_per_bit_exactly := 0.1360779687331669
			mp_bases_inst.gmpn_bases[163].big_base := (705911761).to_natural_32
			mp_bases_inst.gmpn_bases[163].big_base_inverted := {NATURAL_32} 2237982391
			mp_bases_inst.gmpn_bases[164].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[164].chars_per_bit_exactly := 0.1359147715670014
			mp_bases_inst.gmpn_bases[164].big_base := (723394816).to_natural_32
			mp_bases_inst.gmpn_bases[164].big_base_inverted := (2080093620).to_natural_32
			mp_bases_inst.gmpn_bases[165].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[165].chars_per_bit_exactly := 0.1357529539050150
			mp_bases_inst.gmpn_bases[165].big_base := (741200625).to_natural_32
			mp_bases_inst.gmpn_bases[165].big_base_inverted := (1926945992).to_natural_32
			mp_bases_inst.gmpn_bases[166].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[166].chars_per_bit_exactly := 0.1355924953769863
			mp_bases_inst.gmpn_bases[166].big_base := (759333136).to_natural_32
			mp_bases_inst.gmpn_bases[166].big_base_inverted := (1778369688).to_natural_32
			mp_bases_inst.gmpn_bases[167].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[167].chars_per_bit_exactly := 0.1354333760385373
			mp_bases_inst.gmpn_bases[167].big_base := (777796321).to_natural_32
			mp_bases_inst.gmpn_bases[167].big_base_inverted := (1634201940).to_natural_32
			mp_bases_inst.gmpn_bases[168].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[168].chars_per_bit_exactly := 0.1352755763596663
			mp_bases_inst.gmpn_bases[168].big_base := (796594176).to_natural_32
			mp_bases_inst.gmpn_bases[168].big_base_inverted := (1494286702).to_natural_32
			mp_bases_inst.gmpn_bases[169].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[169].chars_per_bit_exactly := 0.1351190772136599
			mp_bases_inst.gmpn_bases[169].big_base := (815730721).to_natural_32
			mp_bases_inst.gmpn_bases[169].big_base_inverted := (1358474335).to_natural_32
			mp_bases_inst.gmpn_bases[170].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[170].chars_per_bit_exactly := 0.1349638598663645
			mp_bases_inst.gmpn_bases[170].big_base := (835210000).to_natural_32
			mp_bases_inst.gmpn_bases[170].big_base_inverted := (1226621308).to_natural_32
			mp_bases_inst.gmpn_bases[171].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[171].chars_per_bit_exactly := 0.1348099059658079
			mp_bases_inst.gmpn_bases[171].big_base := (855036081).to_natural_32
			mp_bases_inst.gmpn_bases[171].big_base_inverted := (1098589912).to_natural_32
			mp_bases_inst.gmpn_bases[172].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[172].chars_per_bit_exactly := 0.1346571975321549
			mp_bases_inst.gmpn_bases[172].big_base := (875213056).to_natural_32
			mp_bases_inst.gmpn_bases[172].big_base_inverted := (974247995).to_natural_32
			mp_bases_inst.gmpn_bases[173].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[173].chars_per_bit_exactly := 0.1345057169479844
			mp_bases_inst.gmpn_bases[173].big_base := (895745041).to_natural_32
			mp_bases_inst.gmpn_bases[173].big_base_inverted := (853468706).to_natural_32
			mp_bases_inst.gmpn_bases[174].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[174].chars_per_bit_exactly := 0.1343554469488779
			mp_bases_inst.gmpn_bases[174].big_base := (916636176).to_natural_32
			mp_bases_inst.gmpn_bases[174].big_base_inverted := (736130253).to_natural_32
			mp_bases_inst.gmpn_bases[175].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[175].chars_per_bit_exactly := 0.1342063706143054
			mp_bases_inst.gmpn_bases[175].big_base := (937890625).to_natural_32
			mp_bases_inst.gmpn_bases[175].big_base_inverted := (622115672).to_natural_32
			mp_bases_inst.gmpn_bases[176].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[176].chars_per_bit_exactly := 0.1340584713587980
			mp_bases_inst.gmpn_bases[176].big_base := (959512576).to_natural_32
			mp_bases_inst.gmpn_bases[176].big_base_inverted := (511312615).to_natural_32
			mp_bases_inst.gmpn_bases[177].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[177].chars_per_bit_exactly := 0.1339117329233981
			mp_bases_inst.gmpn_bases[177].big_base := (981506241).to_natural_32
			mp_bases_inst.gmpn_bases[177].big_base_inverted := (403613136).to_natural_32
			mp_bases_inst.gmpn_bases[178].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[178].chars_per_bit_exactly := 0.1337661393673756
			mp_bases_inst.gmpn_bases[178].big_base := (1003875856).to_natural_32
			mp_bases_inst.gmpn_bases[178].big_base_inverted := (298913501).to_natural_32
			mp_bases_inst.gmpn_bases[179].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[179].chars_per_bit_exactly := 0.1336216750601996
			mp_bases_inst.gmpn_bases[179].big_base := (1026625681).to_natural_32
			mp_bases_inst.gmpn_bases[179].big_base_inverted := (197113998).to_natural_32
			mp_bases_inst.gmpn_bases[180].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[180].chars_per_bit_exactly := 0.1334783246737591
			mp_bases_inst.gmpn_bases[180].big_base := (1049760000).to_natural_32
			mp_bases_inst.gmpn_bases[180].big_base_inverted := (98118760).to_natural_32
			mp_bases_inst.gmpn_bases[181].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[181].chars_per_bit_exactly := 0.1333360731748201
			mp_bases_inst.gmpn_bases[181].big_base := (1073283121).to_natural_32
			mp_bases_inst.gmpn_bases[181].big_base_inverted := (1835596).to_natural_32
			mp_bases_inst.gmpn_bases[182].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[182].chars_per_bit_exactly := 0.1331949058177136
			mp_bases_inst.gmpn_bases[182].big_base := (1097199376).to_natural_32
			mp_bases_inst.gmpn_bases[182].big_base_inverted := {NATURAL_32} 4111318962
			mp_bases_inst.gmpn_bases[183].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[183].chars_per_bit_exactly := 0.1330548081372441
			mp_bases_inst.gmpn_bases[183].big_base := (1121513121).to_natural_32
			mp_bases_inst.gmpn_bases[183].big_base_inverted := {NATURAL_32} 3929075619
			mp_bases_inst.gmpn_bases[184].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[184].chars_per_bit_exactly := 0.1329157659418126
			mp_bases_inst.gmpn_bases[184].big_base := (1146228736).to_natural_32
			mp_bases_inst.gmpn_bases[184].big_base_inverted := {NATURAL_32} 3751744278
			mp_bases_inst.gmpn_bases[185].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[185].chars_per_bit_exactly := 0.1327777653067443
			mp_bases_inst.gmpn_bases[185].big_base := (1171350625).to_natural_32
			mp_bases_inst.gmpn_bases[185].big_base_inverted := {NATURAL_32} 3579166921
			mp_bases_inst.gmpn_bases[186].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[186].chars_per_bit_exactly := 0.1326407925678156
			mp_bases_inst.gmpn_bases[186].big_base := (1196883216).to_natural_32
			mp_bases_inst.gmpn_bases[186].big_base_inverted := {NATURAL_32} 3411191428
			mp_bases_inst.gmpn_bases[187].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[187].chars_per_bit_exactly := 0.1325048343149731
			mp_bases_inst.gmpn_bases[187].big_base := (1222830961).to_natural_32
			mp_bases_inst.gmpn_bases[187].big_base_inverted := {NATURAL_32} 3247671327
			mp_bases_inst.gmpn_bases[188].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[188].chars_per_bit_exactly := 0.1323698773862368
			mp_bases_inst.gmpn_bases[188].big_base := (1249198336).to_natural_32
			mp_bases_inst.gmpn_bases[188].big_base_inverted := {NATURAL_32} 3088465559
			mp_bases_inst.gmpn_bases[189].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[189].chars_per_bit_exactly := 0.1322359088617821
			mp_bases_inst.gmpn_bases[189].big_base := (1275989841).to_natural_32
			mp_bases_inst.gmpn_bases[189].big_base_inverted := {NATURAL_32} 2933438244
			mp_bases_inst.gmpn_bases[190].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[190].chars_per_bit_exactly := 0.1321029160581950
			mp_bases_inst.gmpn_bases[190].big_base := (1303210000).to_natural_32
			mp_bases_inst.gmpn_bases[190].big_base_inverted := {NATURAL_32} 2782458473
			mp_bases_inst.gmpn_bases[191].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[191].chars_per_bit_exactly := 0.1319708865228925
			mp_bases_inst.gmpn_bases[191].big_base := (1330863361).to_natural_32
			mp_bases_inst.gmpn_bases[191].big_base_inverted := {NATURAL_32} 2635400093
			mp_bases_inst.gmpn_bases[192].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[192].chars_per_bit_exactly := 0.1318398080287045
			mp_bases_inst.gmpn_bases[192].big_base := (1358954496).to_natural_32
			mp_bases_inst.gmpn_bases[192].big_base_inverted := {NATURAL_32} 2492141517
			mp_bases_inst.gmpn_bases[193].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[193].chars_per_bit_exactly := 0.1317096685686114
			mp_bases_inst.gmpn_bases[193].big_base := (1387488001).to_natural_32
			mp_bases_inst.gmpn_bases[193].big_base_inverted := {NATURAL_32} 2352565533
			mp_bases_inst.gmpn_bases[194].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[194].chars_per_bit_exactly := 0.1315804563506306
			mp_bases_inst.gmpn_bases[194].big_base := (1416468496).to_natural_32
			mp_bases_inst.gmpn_bases[194].big_base_inverted := {NATURAL_32} 2216559125
			mp_bases_inst.gmpn_bases[195].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[195].chars_per_bit_exactly := 0.1314521597928493
			mp_bases_inst.gmpn_bases[195].big_base := (1445900625).to_natural_32
			mp_bases_inst.gmpn_bases[195].big_base_inverted := (2084013304).to_natural_32
			mp_bases_inst.gmpn_bases[196].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[196].chars_per_bit_exactly := 0.1313247675185968
			mp_bases_inst.gmpn_bases[196].big_base := (1475789056).to_natural_32
			mp_bases_inst.gmpn_bases[196].big_base_inverted := (1954822942).to_natural_32
			mp_bases_inst.gmpn_bases[197].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[197].chars_per_bit_exactly := 0.1311982683517524
			mp_bases_inst.gmpn_bases[197].big_base := (1506138481).to_natural_32
			mp_bases_inst.gmpn_bases[197].big_base_inverted := (1828886621).to_natural_32
			mp_bases_inst.gmpn_bases[198].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[198].chars_per_bit_exactly := 0.1310726513121843
			mp_bases_inst.gmpn_bases[198].big_base := (1536953616).to_natural_32
			mp_bases_inst.gmpn_bases[198].big_base_inverted := (1706106478).to_natural_32
			mp_bases_inst.gmpn_bases[199].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[199].chars_per_bit_exactly := 0.1309479056113158
			mp_bases_inst.gmpn_bases[199].big_base := (1568239201).to_natural_32
			mp_bases_inst.gmpn_bases[199].big_base_inverted := (1586388068).to_natural_32
			mp_bases_inst.gmpn_bases[200].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[200].chars_per_bit_exactly := 0.1308240206478128
			mp_bases_inst.gmpn_bases[200].big_base := (1600000000).to_natural_32
			mp_bases_inst.gmpn_bases[200].big_base_inverted := (1469640227).to_natural_32
			mp_bases_inst.gmpn_bases[201].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[201].chars_per_bit_exactly := 0.1307009860033912
			mp_bases_inst.gmpn_bases[201].big_base := (1632240801).to_natural_32
			mp_bases_inst.gmpn_bases[201].big_base_inverted := (1355774942).to_natural_32
			mp_bases_inst.gmpn_bases[202].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[202].chars_per_bit_exactly := 0.1305787914387386
			mp_bases_inst.gmpn_bases[202].big_base := (1664966416).to_natural_32
			mp_bases_inst.gmpn_bases[202].big_base_inverted := (1244707227).to_natural_32
			mp_bases_inst.gmpn_bases[203].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[203].chars_per_bit_exactly := 0.1304574268895465
			mp_bases_inst.gmpn_bases[203].big_base := (1698181681).to_natural_32
			mp_bases_inst.gmpn_bases[203].big_base_inverted := (1136355005).to_natural_32
			mp_bases_inst.gmpn_bases[204].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[204].chars_per_bit_exactly := 0.1303368824626505
			mp_bases_inst.gmpn_bases[204].big_base := (1731891456).to_natural_32
			mp_bases_inst.gmpn_bases[204].big_base_inverted := (1030638996).to_natural_32
			mp_bases_inst.gmpn_bases[205].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[205].chars_per_bit_exactly := 0.1302171484322746
			mp_bases_inst.gmpn_bases[205].big_base := (1766100625).to_natural_32
			mp_bases_inst.gmpn_bases[205].big_base_inverted := (927482606).to_natural_32
			mp_bases_inst.gmpn_bases[206].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[206].chars_per_bit_exactly := 0.1300982152363760
			mp_bases_inst.gmpn_bases[206].big_base := (1800814096).to_natural_32
			mp_bases_inst.gmpn_bases[206].big_base_inverted := (826811824).to_natural_32
			mp_bases_inst.gmpn_bases[207].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[207].chars_per_bit_exactly := 0.1299800734730872
			mp_bases_inst.gmpn_bases[207].big_base := (1836036801).to_natural_32
			mp_bases_inst.gmpn_bases[207].big_base_inverted := (728555125).to_natural_32
			mp_bases_inst.gmpn_bases[208].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[208].chars_per_bit_exactly := 0.1298627138972530
			mp_bases_inst.gmpn_bases[208].big_base := (1871773696).to_natural_32
			mp_bases_inst.gmpn_bases[208].big_base_inverted := (632643374).to_natural_32
			mp_bases_inst.gmpn_bases[209].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[209].chars_per_bit_exactly := 0.1297461274170591
			mp_bases_inst.gmpn_bases[209].big_base := (1908029761).to_natural_32
			mp_bases_inst.gmpn_bases[209].big_base_inverted := (539009733).to_natural_32
			mp_bases_inst.gmpn_bases[210].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[210].chars_per_bit_exactly := 0.1296303050907487
			mp_bases_inst.gmpn_bases[210].big_base := (1944810000).to_natural_32
			mp_bases_inst.gmpn_bases[210].big_base_inverted := (447589579).to_natural_32
			mp_bases_inst.gmpn_bases[211].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[211].chars_per_bit_exactly := 0.1295152381234257
			mp_bases_inst.gmpn_bases[211].big_base := (1982119441).to_natural_32
			mp_bases_inst.gmpn_bases[211].big_base_inverted := (358320415).to_natural_32
			mp_bases_inst.gmpn_bases[212].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[212].chars_per_bit_exactly := 0.1294009178639407
			mp_bases_inst.gmpn_bases[212].big_base := (2019963136).to_natural_32
			mp_bases_inst.gmpn_bases[212].big_base_inverted := (271141794).to_natural_32
			mp_bases_inst.gmpn_bases[213].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[213].chars_per_bit_exactly := 0.1292873358018581
			mp_bases_inst.gmpn_bases[213].big_base := (2058346161).to_natural_32
			mp_bases_inst.gmpn_bases[213].big_base_inverted := (185995241).to_natural_32
			mp_bases_inst.gmpn_bases[214].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[214].chars_per_bit_exactly := 0.1291744835645007
			mp_bases_inst.gmpn_bases[214].big_base := (2097273616).to_natural_32
			mp_bases_inst.gmpn_bases[214].big_base_inverted := (102824182).to_natural_32
			mp_bases_inst.gmpn_bases[215].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[215].chars_per_bit_exactly := 0.1290623529140715
			mp_bases_inst.gmpn_bases[215].big_base := (2136750625).to_natural_32
			mp_bases_inst.gmpn_bases[215].big_base_inverted := (21573871).to_natural_32
			mp_bases_inst.gmpn_bases[216].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[216].chars_per_bit_exactly := 0.1289509357448472
			mp_bases_inst.gmpn_bases[216].big_base := {NATURAL_32} 2176782336
			mp_bases_inst.gmpn_bases[216].big_base_inverted := {NATURAL_32} 4179349942
			mp_bases_inst.gmpn_bases[217].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[217].chars_per_bit_exactly := 0.1288402240804449
			mp_bases_inst.gmpn_bases[217].big_base := {NATURAL_32} 2217373921
			mp_bases_inst.gmpn_bases[217].big_base_inverted := {NATURAL_32} 4024217799
			mp_bases_inst.gmpn_bases[218].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[218].chars_per_bit_exactly := 0.1287302100711567
			mp_bases_inst.gmpn_bases[218].big_base := {NATURAL_32} 2258530576
			mp_bases_inst.gmpn_bases[218].big_base_inverted := {NATURAL_32} 3872619306
			mp_bases_inst.gmpn_bases[219].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[219].chars_per_bit_exactly := 0.1286208859913518
			mp_bases_inst.gmpn_bases[219].big_base := {NATURAL_32} 2300257521
			mp_bases_inst.gmpn_bases[219].big_base_inverted := {NATURAL_32} 3724458314
			mp_bases_inst.gmpn_bases[220].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[220].chars_per_bit_exactly := 0.1285122442369443
			mp_bases_inst.gmpn_bases[220].big_base := {NATURAL_32} 2342560000
			mp_bases_inst.gmpn_bases[220].big_base_inverted := {NATURAL_32} 3579641710
			mp_bases_inst.gmpn_bases[221].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[221].chars_per_bit_exactly := 0.1284042773229231
			mp_bases_inst.gmpn_bases[221].big_base := {NATURAL_32} 2385443281
			mp_bases_inst.gmpn_bases[221].big_base_inverted := {NATURAL_32} 3438079312
			mp_bases_inst.gmpn_bases[222].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[222].chars_per_bit_exactly := 0.1282969778809442
			mp_bases_inst.gmpn_bases[222].big_base := {NATURAL_32} 2428912656
			mp_bases_inst.gmpn_bases[222].big_base_inverted := {NATURAL_32} 3299683762
			mp_bases_inst.gmpn_bases[223].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[223].chars_per_bit_exactly := 0.1281903386569819
			mp_bases_inst.gmpn_bases[223].big_base := {NATURAL_32} 2472973441
			mp_bases_inst.gmpn_bases[223].big_base_inverted := {NATURAL_32} 3164370425
			mp_bases_inst.gmpn_bases[224].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[224].chars_per_bit_exactly := 0.1280843525090381
			mp_bases_inst.gmpn_bases[224].big_base := {NATURAL_32} 2517630976
			mp_bases_inst.gmpn_bases[224].big_base_inverted := {NATURAL_32} 3032057295
			mp_bases_inst.gmpn_bases[225].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[225].chars_per_bit_exactly := 0.1279790124049077
			mp_bases_inst.gmpn_bases[225].big_base := {NATURAL_32} 2562890625
			mp_bases_inst.gmpn_bases[225].big_base_inverted := {NATURAL_32} 2902664898
			mp_bases_inst.gmpn_bases[226].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[226].chars_per_bit_exactly := 0.1278743114199984
			mp_bases_inst.gmpn_bases[226].big_base := {NATURAL_32} 2608757776
			mp_bases_inst.gmpn_bases[226].big_base_inverted := {NATURAL_32} 2776116207
			mp_bases_inst.gmpn_bases[227].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[227].chars_per_bit_exactly := 0.1277702427352035
			mp_bases_inst.gmpn_bases[227].big_base := {NATURAL_32} 2655237841
			mp_bases_inst.gmpn_bases[227].big_base_inverted := {NATURAL_32} 2652336553
			mp_bases_inst.gmpn_bases[228].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[228].chars_per_bit_exactly := 0.1276667996348261
			mp_bases_inst.gmpn_bases[228].big_base := {NATURAL_32} 2702336256
			mp_bases_inst.gmpn_bases[228].big_base_inverted := {NATURAL_32} 2531253546
			mp_bases_inst.gmpn_bases[229].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[229].chars_per_bit_exactly := 0.1275639755045533
			mp_bases_inst.gmpn_bases[229].big_base := {NATURAL_32} 2750058481
			mp_bases_inst.gmpn_bases[229].big_base_inverted := {NATURAL_32} 2412796993
			mp_bases_inst.gmpn_bases[230].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[230].chars_per_bit_exactly := 0.1274617638294791
			mp_bases_inst.gmpn_bases[230].big_base := {NATURAL_32} 2798410000
			mp_bases_inst.gmpn_bases[230].big_base_inverted := {NATURAL_32} 2296898825
			mp_bases_inst.gmpn_bases[231].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[231].chars_per_bit_exactly := 0.1273601581921741
			mp_bases_inst.gmpn_bases[231].big_base := {NATURAL_32} 2847396321
			mp_bases_inst.gmpn_bases[231].big_base_inverted := {NATURAL_32} 2183493021
			mp_bases_inst.gmpn_bases[232].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[232].chars_per_bit_exactly := 0.1272591522708010
			mp_bases_inst.gmpn_bases[232].big_base := {NATURAL_32} 2897022976
			mp_bases_inst.gmpn_bases[232].big_base_inverted := (2072515539).to_natural_32
			mp_bases_inst.gmpn_bases[233].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[233].chars_per_bit_exactly := 0.1271587398372755
			mp_bases_inst.gmpn_bases[233].big_base := {NATURAL_32} 2947295521
			mp_bases_inst.gmpn_bases[233].big_base_inverted := (1963904249).to_natural_32
			mp_bases_inst.gmpn_bases[234].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[234].chars_per_bit_exactly := 0.1270589147554692
			mp_bases_inst.gmpn_bases[234].big_base := {NATURAL_32} 2998219536
			mp_bases_inst.gmpn_bases[234].big_base_inverted := (1857598869).to_natural_32
			mp_bases_inst.gmpn_bases[235].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[235].chars_per_bit_exactly := 0.1269596709794558
			mp_bases_inst.gmpn_bases[235].big_base := {NATURAL_32} 3049800625
			mp_bases_inst.gmpn_bases[235].big_base_inverted := (1753540899).to_natural_32
			mp_bases_inst.gmpn_bases[236].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[236].chars_per_bit_exactly := 0.1268610025517973
			mp_bases_inst.gmpn_bases[236].big_base := {NATURAL_32} 3102044416
			mp_bases_inst.gmpn_bases[236].big_base_inverted := (1651673563).to_natural_32
			mp_bases_inst.gmpn_bases[237].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[237].chars_per_bit_exactly := 0.1267629036018709
			mp_bases_inst.gmpn_bases[237].big_base := {NATURAL_32} 3154956561
			mp_bases_inst.gmpn_bases[237].big_base_inverted := (1551941755).to_natural_32
			mp_bases_inst.gmpn_bases[238].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[238].chars_per_bit_exactly := 0.1266653683442337
			mp_bases_inst.gmpn_bases[238].big_base := {NATURAL_32} 3208542736
			mp_bases_inst.gmpn_bases[238].big_base_inverted := (1454291975).to_natural_32
			mp_bases_inst.gmpn_bases[239].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[239].chars_per_bit_exactly := 0.1265683910770258
			mp_bases_inst.gmpn_bases[239].big_base := {NATURAL_32} 3262808641
			mp_bases_inst.gmpn_bases[239].big_base_inverted := (1358672283).to_natural_32
			mp_bases_inst.gmpn_bases[240].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[240].chars_per_bit_exactly := 0.1264719661804097
			mp_bases_inst.gmpn_bases[240].big_base := {NATURAL_32} 3317760000
			mp_bases_inst.gmpn_bases[240].big_base_inverted := (1265032243).to_natural_32
			mp_bases_inst.gmpn_bases[241].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[241].chars_per_bit_exactly := 0.1263760881150453
			mp_bases_inst.gmpn_bases[241].big_base := {NATURAL_32} 3373402561
			mp_bases_inst.gmpn_bases[241].big_base_inverted := (1173322876).to_natural_32
			mp_bases_inst.gmpn_bases[242].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[242].chars_per_bit_exactly := 0.1262807514205999
			mp_bases_inst.gmpn_bases[242].big_base := {NATURAL_32} 3429742096
			mp_bases_inst.gmpn_bases[242].big_base_inverted := (1083496611).to_natural_32
			mp_bases_inst.gmpn_bases[243].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[243].chars_per_bit_exactly := 0.1261859507142915
			mp_bases_inst.gmpn_bases[243].big_base := {NATURAL_32} 3486784401
			mp_bases_inst.gmpn_bases[243].big_base_inverted := (995507236).to_natural_32
			mp_bases_inst.gmpn_bases[244].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[244].chars_per_bit_exactly := 0.1260916806894653
			mp_bases_inst.gmpn_bases[244].big_base := {NATURAL_32} 3544535296
			mp_bases_inst.gmpn_bases[244].big_base_inverted := (909309861).to_natural_32
			mp_bases_inst.gmpn_bases[245].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[245].chars_per_bit_exactly := 0.1259979361142023
			mp_bases_inst.gmpn_bases[245].big_base := {NATURAL_32} 3603000625
			mp_bases_inst.gmpn_bases[245].big_base_inverted := (824860867).to_natural_32
			mp_bases_inst.gmpn_bases[246].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[246].chars_per_bit_exactly := 0.1259047118299582
			mp_bases_inst.gmpn_bases[246].big_base := {NATURAL_32} 3662186256
			mp_bases_inst.gmpn_bases[246].big_base_inverted := (742117872).to_natural_32
			mp_bases_inst.gmpn_bases[247].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[247].chars_per_bit_exactly := 0.1258120027502338
			mp_bases_inst.gmpn_bases[247].big_base := {NATURAL_32} 3722098081
			mp_bases_inst.gmpn_bases[247].big_base_inverted := (661039685).to_natural_32
			mp_bases_inst.gmpn_bases[248].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[248].chars_per_bit_exactly := 0.1257198038592741
			mp_bases_inst.gmpn_bases[248].big_base := {NATURAL_32} 3782742016
			mp_bases_inst.gmpn_bases[248].big_base_inverted := (581586271).to_natural_32
			mp_bases_inst.gmpn_bases[249].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[249].chars_per_bit_exactly := 0.1256281102107963
			mp_bases_inst.gmpn_bases[249].big_base := {NATURAL_32} 3844124001
			mp_bases_inst.gmpn_bases[249].big_base_inverted := (503718716).to_natural_32
			mp_bases_inst.gmpn_bases[250].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[250].chars_per_bit_exactly := 0.1255369169267456
			mp_bases_inst.gmpn_bases[250].big_base := {NATURAL_32} 3906250000
			mp_bases_inst.gmpn_bases[250].big_base_inverted := (427399186).to_natural_32
			mp_bases_inst.gmpn_bases[251].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[251].chars_per_bit_exactly := 0.1254462191960791
			mp_bases_inst.gmpn_bases[251].big_base := {NATURAL_32} 3969126001
			mp_bases_inst.gmpn_bases[251].big_base_inverted := (352590899).to_natural_32
			mp_bases_inst.gmpn_bases[252].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[252].chars_per_bit_exactly := 0.1253560122735751
			mp_bases_inst.gmpn_bases[252].big_base := {NATURAL_32} 4032758016
			mp_bases_inst.gmpn_bases[252].big_base_inverted := (279258085).to_natural_32
			mp_bases_inst.gmpn_bases[253].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[253].chars_per_bit_exactly := 0.1252662914786691
			mp_bases_inst.gmpn_bases[253].big_base := {NATURAL_32} 4097152081
			mp_bases_inst.gmpn_bases[253].big_base_inverted := (207365961).to_natural_32
			mp_bases_inst.gmpn_bases[254].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[254].chars_per_bit_exactly := 0.1251770521943144
			mp_bases_inst.gmpn_bases[254].big_base := {NATURAL_32} 4162314256
			mp_bases_inst.gmpn_bases[254].big_base_inverted := (136880695).to_natural_32
			mp_bases_inst.gmpn_bases[255].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[255].chars_per_bit_exactly := 0.1250882898658681
			mp_bases_inst.gmpn_bases[255].big_base := {NATURAL_32} 4228250625
			mp_bases_inst.gmpn_bases[255].big_base_inverted := (67769379).to_natural_32
			mp_bases_inst.gmpn_bases[256].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[256].chars_per_bit_exactly := 0.1250000000000000
			mp_bases_inst.gmpn_bases[256].big_base := (8).to_natural_32
			mp_bases_inst.gmpn_bases[256].big_base_inverted := {NATURAL_32} 0;
			(mul_fft_inst.mpn_fft_table3[0])[0].n := {NATURAL_32} 565;
			(mul_fft_inst.mpn_fft_table3[0])[0].k := {NATURAL_32} 5;
			(mul_fft_inst.mpn_fft_table3[0])[1].n := {NATURAL_32} 25;
			(mul_fft_inst.mpn_fft_table3[0])[1].k := {NATURAL_32} 6;
			(mul_fft_inst.mpn_fft_table3[0])[2].n := {NATURAL_32} 13;
			(mul_fft_inst.mpn_fft_table3[0])[2].k := {NATURAL_32} 5;
			(mul_fft_inst.mpn_fft_table3[0])[3].n := {NATURAL_32} 27;
			(mul_fft_inst.mpn_fft_table3[0])[3].k := {NATURAL_32} 6;
			(mul_fft_inst.mpn_fft_table3[0])[4].n := {NATURAL_32} 25;
			(mul_fft_inst.mpn_fft_table3[0])[4].k := {NATURAL_32} 7;
			(mul_fft_inst.mpn_fft_table3[0])[5].n := {NATURAL_32} 13;
			(mul_fft_inst.mpn_fft_table3[0])[5].k := {NATURAL_32} 6;
			(mul_fft_inst.mpn_fft_table3[0])[6].n := {NATURAL_32} 28;
			(mul_fft_inst.mpn_fft_table3[0])[6].k := {NATURAL_32} 7;
			(mul_fft_inst.mpn_fft_table3[0])[7].n := {NATURAL_32} 15;
			(mul_fft_inst.mpn_fft_table3[0])[7].k := {NATURAL_32} 6
		end

end
