frozen class
	LIBGMP_INITIALIZER_SLICE7

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {LIBGMP_INITIALIZER}

	initialize
		do
			(mul_fft_inst.mpn_fft_table3[1])[112].n := {NATURAL_32} 1087;
			(mul_fft_inst.mpn_fft_table3[1])[112].k := {NATURAL_32} 12;
			(mul_fft_inst.mpn_fft_table3[1])[113].n := {NATURAL_32} 575;
			(mul_fft_inst.mpn_fft_table3[1])[113].k := {NATURAL_32} 11;
			(mul_fft_inst.mpn_fft_table3[1])[114].n := {NATURAL_32} 1215;
			(mul_fft_inst.mpn_fft_table3[1])[114].k := {NATURAL_32} 12;
			(mul_fft_inst.mpn_fft_table3[1])[115].n := {NATURAL_32} 639;
			(mul_fft_inst.mpn_fft_table3[1])[115].k := {NATURAL_32} 11;
			(mul_fft_inst.mpn_fft_table3[1])[116].n := {NATURAL_32} 1343;
			(mul_fft_inst.mpn_fft_table3[1])[116].k := {NATURAL_32} 12;
			(mul_fft_inst.mpn_fft_table3[1])[117].n := {NATURAL_32} 703;
			(mul_fft_inst.mpn_fft_table3[1])[117].k := {NATURAL_32} 11;
			(mul_fft_inst.mpn_fft_table3[1])[118].n := {NATURAL_32} 1471;
			(mul_fft_inst.mpn_fft_table3[1])[118].k := {NATURAL_32} 13;
			(mul_fft_inst.mpn_fft_table3[1])[119].n := {NATURAL_32} 383;
			(mul_fft_inst.mpn_fft_table3[1])[119].k := {NATURAL_32} 12;
			(mul_fft_inst.mpn_fft_table3[1])[120].n := {NATURAL_32} 767;
			(mul_fft_inst.mpn_fft_table3[1])[120].k := {NATURAL_32} 11;
			(mul_fft_inst.mpn_fft_table3[1])[121].n := {NATURAL_32} 1599;
			(mul_fft_inst.mpn_fft_table3[1])[121].k := {NATURAL_32} 12;
			(mul_fft_inst.mpn_fft_table3[1])[122].n := {NATURAL_32} 831;
			(mul_fft_inst.mpn_fft_table3[1])[122].k := {NATURAL_32} 11;
			(mul_fft_inst.mpn_fft_table3[1])[123].n := {NATURAL_32} 1727;
			(mul_fft_inst.mpn_fft_table3[1])[123].k := {NATURAL_32} 12;
			(mul_fft_inst.mpn_fft_table3[1])[124].n := {NATURAL_32} 959;
			(mul_fft_inst.mpn_fft_table3[1])[124].k := {NATURAL_32} 14;
			(mul_fft_inst.mpn_fft_table3[1])[125].n := {NATURAL_32} 255;
			(mul_fft_inst.mpn_fft_table3[1])[125].k := {NATURAL_32} 13;
			(mul_fft_inst.mpn_fft_table3[1])[126].n := {NATURAL_32} 511;
			(mul_fft_inst.mpn_fft_table3[1])[126].k := {NATURAL_32} 12;
			(mul_fft_inst.mpn_fft_table3[1])[127].n := {NATURAL_32} 1215;
			(mul_fft_inst.mpn_fft_table3[1])[127].k := {NATURAL_32} 13;
			(mul_fft_inst.mpn_fft_table3[1])[128].n := {NATURAL_32} 639;
			(mul_fft_inst.mpn_fft_table3[1])[128].k := {NATURAL_32} 12;
			(mul_fft_inst.mpn_fft_table3[1])[129].n := {NATURAL_32} 1471;
			(mul_fft_inst.mpn_fft_table3[1])[129].k := {NATURAL_32} 13;
			(mul_fft_inst.mpn_fft_table3[1])[130].n := {NATURAL_32} 767;
			(mul_fft_inst.mpn_fft_table3[1])[130].k := {NATURAL_32} 12;
			(mul_fft_inst.mpn_fft_table3[1])[131].n := {NATURAL_32} 1727;
			(mul_fft_inst.mpn_fft_table3[1])[131].k := {NATURAL_32} 13;
			(mul_fft_inst.mpn_fft_table3[1])[132].n := {NATURAL_32} 895;
			(mul_fft_inst.mpn_fft_table3[1])[132].k := {NATURAL_32} 12;
			(mul_fft_inst.mpn_fft_table3[1])[133].n := {NATURAL_32} 1919;
			(mul_fft_inst.mpn_fft_table3[1])[133].k := {NATURAL_32} 14;
			(mul_fft_inst.mpn_fft_table3[1])[134].n := {NATURAL_32} 511;
			(mul_fft_inst.mpn_fft_table3[1])[134].k := {NATURAL_32} 13;
			(mul_fft_inst.mpn_fft_table3[1])[135].n := {NATURAL_32} 1023;
			(mul_fft_inst.mpn_fft_table3[1])[135].k := {NATURAL_32} 12;
			(mul_fft_inst.mpn_fft_table3[1])[136].n := {NATURAL_32} 2111;
			(mul_fft_inst.mpn_fft_table3[1])[136].k := {NATURAL_32} 13;
			(mul_fft_inst.mpn_fft_table3[1])[137].n := {NATURAL_32} 1151;
			(mul_fft_inst.mpn_fft_table3[1])[137].k := {NATURAL_32} 12;
			(mul_fft_inst.mpn_fft_table3[1])[138].n := {NATURAL_32} 2431;
			(mul_fft_inst.mpn_fft_table3[1])[138].k := {NATURAL_32} 13;
			(mul_fft_inst.mpn_fft_table3[1])[139].n := {NATURAL_32} 1407;
			(mul_fft_inst.mpn_fft_table3[1])[139].k := {NATURAL_32} 14;
			(mul_fft_inst.mpn_fft_table3[1])[140].n := {NATURAL_32} 767;
			(mul_fft_inst.mpn_fft_table3[1])[140].k := {NATURAL_32} 13;
			(mul_fft_inst.mpn_fft_table3[1])[141].n := {NATURAL_32} 1663;
			(mul_fft_inst.mpn_fft_table3[1])[141].k := {NATURAL_32} 12;
			(mul_fft_inst.mpn_fft_table3[1])[142].n := {NATURAL_32} 3455;
			(mul_fft_inst.mpn_fft_table3[1])[142].k := {NATURAL_32} 13;
			(mul_fft_inst.mpn_fft_table3[1])[143].n := {NATURAL_32} 8192;
			(mul_fft_inst.mpn_fft_table3[1])[143].k := {NATURAL_32} 14;
			(mul_fft_inst.mpn_fft_table3[1])[144].n := {NATURAL_32} 16384;
			(mul_fft_inst.mpn_fft_table3[1])[144].k := {NATURAL_32} 15;
			(mul_fft_inst.mpn_fft_table3[1])[145].n := {NATURAL_32} 32768;
			(mul_fft_inst.mpn_fft_table3[1])[145].k := {NATURAL_32} 16
			sqrtrem_inst.invsqrttab[0] := (511).to_natural_16
			sqrtrem_inst.invsqrttab[1] := (509).to_natural_16
			sqrtrem_inst.invsqrttab[2] := (507).to_natural_16
			sqrtrem_inst.invsqrttab[3] := (505).to_natural_16
			sqrtrem_inst.invsqrttab[4] := (503).to_natural_16
			sqrtrem_inst.invsqrttab[5] := (501).to_natural_16
			sqrtrem_inst.invsqrttab[6] := (499).to_natural_16
			sqrtrem_inst.invsqrttab[7] := (498).to_natural_16
			sqrtrem_inst.invsqrttab[8] := (496).to_natural_16
			sqrtrem_inst.invsqrttab[9] := (494).to_natural_16
			sqrtrem_inst.invsqrttab[10] := (492).to_natural_16
			sqrtrem_inst.invsqrttab[11] := (490).to_natural_16
			sqrtrem_inst.invsqrttab[12] := (489).to_natural_16
			sqrtrem_inst.invsqrttab[13] := (487).to_natural_16
			sqrtrem_inst.invsqrttab[14] := (485).to_natural_16
			sqrtrem_inst.invsqrttab[15] := (484).to_natural_16
			sqrtrem_inst.invsqrttab[16] := (482).to_natural_16
			sqrtrem_inst.invsqrttab[17] := (480).to_natural_16
			sqrtrem_inst.invsqrttab[18] := (479).to_natural_16
			sqrtrem_inst.invsqrttab[19] := (477).to_natural_16
			sqrtrem_inst.invsqrttab[20] := (475).to_natural_16
			sqrtrem_inst.invsqrttab[21] := (474).to_natural_16
			sqrtrem_inst.invsqrttab[22] := (472).to_natural_16
			sqrtrem_inst.invsqrttab[23] := (471).to_natural_16
			sqrtrem_inst.invsqrttab[24] := (469).to_natural_16
			sqrtrem_inst.invsqrttab[25] := (468).to_natural_16
			sqrtrem_inst.invsqrttab[26] := (466).to_natural_16
			sqrtrem_inst.invsqrttab[27] := (465).to_natural_16
			sqrtrem_inst.invsqrttab[28] := (463).to_natural_16
			sqrtrem_inst.invsqrttab[29] := (462).to_natural_16
			sqrtrem_inst.invsqrttab[30] := (460).to_natural_16
			sqrtrem_inst.invsqrttab[31] := (459).to_natural_16
			sqrtrem_inst.invsqrttab[32] := (457).to_natural_16
			sqrtrem_inst.invsqrttab[33] := (456).to_natural_16
			sqrtrem_inst.invsqrttab[34] := (454).to_natural_16
			sqrtrem_inst.invsqrttab[35] := (453).to_natural_16
			sqrtrem_inst.invsqrttab[36] := (452).to_natural_16
			sqrtrem_inst.invsqrttab[37] := (450).to_natural_16
			sqrtrem_inst.invsqrttab[38] := (449).to_natural_16
			sqrtrem_inst.invsqrttab[39] := (448).to_natural_16
			sqrtrem_inst.invsqrttab[40] := (446).to_natural_16
			sqrtrem_inst.invsqrttab[41] := (445).to_natural_16
			sqrtrem_inst.invsqrttab[42] := (444).to_natural_16
			sqrtrem_inst.invsqrttab[43] := (442).to_natural_16
			sqrtrem_inst.invsqrttab[44] := (441).to_natural_16
			sqrtrem_inst.invsqrttab[45] := (440).to_natural_16
			sqrtrem_inst.invsqrttab[46] := (439).to_natural_16
			sqrtrem_inst.invsqrttab[47] := (437).to_natural_16
			sqrtrem_inst.invsqrttab[48] := (436).to_natural_16
			sqrtrem_inst.invsqrttab[49] := (435).to_natural_16
			sqrtrem_inst.invsqrttab[50] := (434).to_natural_16
			sqrtrem_inst.invsqrttab[51] := (432).to_natural_16
			sqrtrem_inst.invsqrttab[52] := (431).to_natural_16
			sqrtrem_inst.invsqrttab[53] := (430).to_natural_16
			sqrtrem_inst.invsqrttab[54] := (429).to_natural_16
			sqrtrem_inst.invsqrttab[55] := (428).to_natural_16
			sqrtrem_inst.invsqrttab[56] := (426).to_natural_16
			sqrtrem_inst.invsqrttab[57] := (425).to_natural_16
			sqrtrem_inst.invsqrttab[58] := (424).to_natural_16
			sqrtrem_inst.invsqrttab[59] := (423).to_natural_16
			sqrtrem_inst.invsqrttab[60] := (422).to_natural_16
			sqrtrem_inst.invsqrttab[61] := (421).to_natural_16
			sqrtrem_inst.invsqrttab[62] := (420).to_natural_16
			sqrtrem_inst.invsqrttab[63] := (419).to_natural_16
			sqrtrem_inst.invsqrttab[64] := (418).to_natural_16
			sqrtrem_inst.invsqrttab[65] := (416).to_natural_16
			sqrtrem_inst.invsqrttab[66] := (415).to_natural_16
			sqrtrem_inst.invsqrttab[67] := (414).to_natural_16
			sqrtrem_inst.invsqrttab[68] := (413).to_natural_16
			sqrtrem_inst.invsqrttab[69] := (412).to_natural_16
			sqrtrem_inst.invsqrttab[70] := (411).to_natural_16
			sqrtrem_inst.invsqrttab[71] := (410).to_natural_16
			sqrtrem_inst.invsqrttab[72] := (409).to_natural_16
			sqrtrem_inst.invsqrttab[73] := (408).to_natural_16
			sqrtrem_inst.invsqrttab[74] := (407).to_natural_16
			sqrtrem_inst.invsqrttab[75] := (406).to_natural_16
			sqrtrem_inst.invsqrttab[76] := (405).to_natural_16
			sqrtrem_inst.invsqrttab[77] := (404).to_natural_16
			sqrtrem_inst.invsqrttab[78] := (403).to_natural_16
			sqrtrem_inst.invsqrttab[79] := (402).to_natural_16
			sqrtrem_inst.invsqrttab[80] := (401).to_natural_16
			sqrtrem_inst.invsqrttab[81] := (400).to_natural_16
			sqrtrem_inst.invsqrttab[82] := (399).to_natural_16
			sqrtrem_inst.invsqrttab[83] := (398).to_natural_16
			sqrtrem_inst.invsqrttab[84] := (397).to_natural_16
			sqrtrem_inst.invsqrttab[85] := (396).to_natural_16
			sqrtrem_inst.invsqrttab[86] := (396).to_natural_16
			sqrtrem_inst.invsqrttab[87] := (395).to_natural_16
			sqrtrem_inst.invsqrttab[88] := (394).to_natural_16
			sqrtrem_inst.invsqrttab[89] := (393).to_natural_16
			sqrtrem_inst.invsqrttab[90] := (392).to_natural_16
			sqrtrem_inst.invsqrttab[91] := (391).to_natural_16
			sqrtrem_inst.invsqrttab[92] := (390).to_natural_16
			sqrtrem_inst.invsqrttab[93] := (389).to_natural_16
			sqrtrem_inst.invsqrttab[94] := (388).to_natural_16
			sqrtrem_inst.invsqrttab[95] := (387).to_natural_16
			sqrtrem_inst.invsqrttab[96] := (387).to_natural_16
			sqrtrem_inst.invsqrttab[97] := (386).to_natural_16
			sqrtrem_inst.invsqrttab[98] := (385).to_natural_16
			sqrtrem_inst.invsqrttab[99] := (384).to_natural_16
			sqrtrem_inst.invsqrttab[100] := (383).to_natural_16
			sqrtrem_inst.invsqrttab[101] := (382).to_natural_16
			sqrtrem_inst.invsqrttab[102] := (382).to_natural_16
			sqrtrem_inst.invsqrttab[103] := (381).to_natural_16
			sqrtrem_inst.invsqrttab[104] := (380).to_natural_16
			sqrtrem_inst.invsqrttab[105] := (379).to_natural_16
			sqrtrem_inst.invsqrttab[106] := (378).to_natural_16
			sqrtrem_inst.invsqrttab[107] := (377).to_natural_16
			sqrtrem_inst.invsqrttab[108] := (377).to_natural_16
			sqrtrem_inst.invsqrttab[109] := (376).to_natural_16
			sqrtrem_inst.invsqrttab[110] := (375).to_natural_16
			sqrtrem_inst.invsqrttab[111] := (374).to_natural_16
			sqrtrem_inst.invsqrttab[112] := (374).to_natural_16
			sqrtrem_inst.invsqrttab[113] := (373).to_natural_16
			sqrtrem_inst.invsqrttab[114] := (372).to_natural_16
			sqrtrem_inst.invsqrttab[115] := (371).to_natural_16
			sqrtrem_inst.invsqrttab[116] := (370).to_natural_16
			sqrtrem_inst.invsqrttab[117] := (370).to_natural_16
			sqrtrem_inst.invsqrttab[118] := (369).to_natural_16
			sqrtrem_inst.invsqrttab[119] := (368).to_natural_16
			sqrtrem_inst.invsqrttab[120] := (367).to_natural_16
			sqrtrem_inst.invsqrttab[121] := (367).to_natural_16
			sqrtrem_inst.invsqrttab[122] := (366).to_natural_16
			sqrtrem_inst.invsqrttab[123] := (365).to_natural_16
			sqrtrem_inst.invsqrttab[124] := (365).to_natural_16
			sqrtrem_inst.invsqrttab[125] := (364).to_natural_16
			sqrtrem_inst.invsqrttab[126] := (363).to_natural_16
			sqrtrem_inst.invsqrttab[127] := (362).to_natural_16
			sqrtrem_inst.invsqrttab[128] := (362).to_natural_16
			sqrtrem_inst.invsqrttab[129] := (361).to_natural_16
			sqrtrem_inst.invsqrttab[130] := (360).to_natural_16
			sqrtrem_inst.invsqrttab[131] := (360).to_natural_16
			sqrtrem_inst.invsqrttab[132] := (359).to_natural_16
			sqrtrem_inst.invsqrttab[133] := (358).to_natural_16
			sqrtrem_inst.invsqrttab[134] := (358).to_natural_16
			sqrtrem_inst.invsqrttab[135] := (357).to_natural_16
			sqrtrem_inst.invsqrttab[136] := (356).to_natural_16
			sqrtrem_inst.invsqrttab[137] := (356).to_natural_16
			sqrtrem_inst.invsqrttab[138] := (355).to_natural_16
			sqrtrem_inst.invsqrttab[139] := (354).to_natural_16
			sqrtrem_inst.invsqrttab[140] := (354).to_natural_16
			sqrtrem_inst.invsqrttab[141] := (353).to_natural_16
			sqrtrem_inst.invsqrttab[142] := (352).to_natural_16
			sqrtrem_inst.invsqrttab[143] := (352).to_natural_16
			sqrtrem_inst.invsqrttab[144] := (351).to_natural_16
			sqrtrem_inst.invsqrttab[145] := (350).to_natural_16
			sqrtrem_inst.invsqrttab[146] := (350).to_natural_16
			sqrtrem_inst.invsqrttab[147] := (349).to_natural_16
			sqrtrem_inst.invsqrttab[148] := (348).to_natural_16
			sqrtrem_inst.invsqrttab[149] := (348).to_natural_16
			sqrtrem_inst.invsqrttab[150] := (347).to_natural_16
			sqrtrem_inst.invsqrttab[151] := (346).to_natural_16
			sqrtrem_inst.invsqrttab[152] := (346).to_natural_16
			sqrtrem_inst.invsqrttab[153] := (345).to_natural_16
			sqrtrem_inst.invsqrttab[154] := (345).to_natural_16
			sqrtrem_inst.invsqrttab[155] := (344).to_natural_16
			sqrtrem_inst.invsqrttab[156] := (343).to_natural_16
			sqrtrem_inst.invsqrttab[157] := (343).to_natural_16
			sqrtrem_inst.invsqrttab[158] := (342).to_natural_16
			sqrtrem_inst.invsqrttab[159] := (342).to_natural_16
			sqrtrem_inst.invsqrttab[160] := (341).to_natural_16
			sqrtrem_inst.invsqrttab[161] := (340).to_natural_16
			sqrtrem_inst.invsqrttab[162] := (340).to_natural_16
			sqrtrem_inst.invsqrttab[163] := (339).to_natural_16
			sqrtrem_inst.invsqrttab[164] := (339).to_natural_16
			sqrtrem_inst.invsqrttab[165] := (338).to_natural_16
			sqrtrem_inst.invsqrttab[166] := (338).to_natural_16
			sqrtrem_inst.invsqrttab[167] := (337).to_natural_16
			sqrtrem_inst.invsqrttab[168] := (336).to_natural_16
			sqrtrem_inst.invsqrttab[169] := (336).to_natural_16
			sqrtrem_inst.invsqrttab[170] := (335).to_natural_16
			sqrtrem_inst.invsqrttab[171] := (335).to_natural_16
			sqrtrem_inst.invsqrttab[172] := (334).to_natural_16
			sqrtrem_inst.invsqrttab[173] := (334).to_natural_16
			sqrtrem_inst.invsqrttab[174] := (333).to_natural_16
			sqrtrem_inst.invsqrttab[175] := (333).to_natural_16
			sqrtrem_inst.invsqrttab[176] := (332).to_natural_16
			sqrtrem_inst.invsqrttab[177] := (331).to_natural_16
			sqrtrem_inst.invsqrttab[178] := (331).to_natural_16
			sqrtrem_inst.invsqrttab[179] := (330).to_natural_16
			sqrtrem_inst.invsqrttab[180] := (330).to_natural_16
			sqrtrem_inst.invsqrttab[181] := (329).to_natural_16
			sqrtrem_inst.invsqrttab[182] := (329).to_natural_16
			sqrtrem_inst.invsqrttab[183] := (328).to_natural_16
			sqrtrem_inst.invsqrttab[184] := (328).to_natural_16
			sqrtrem_inst.invsqrttab[185] := (327).to_natural_16
			sqrtrem_inst.invsqrttab[186] := (327).to_natural_16
			sqrtrem_inst.invsqrttab[187] := (326).to_natural_16
			sqrtrem_inst.invsqrttab[188] := (326).to_natural_16
			sqrtrem_inst.invsqrttab[189] := (325).to_natural_16
			sqrtrem_inst.invsqrttab[190] := (325).to_natural_16
			sqrtrem_inst.invsqrttab[191] := (324).to_natural_16
			sqrtrem_inst.invsqrttab[192] := (324).to_natural_16
			sqrtrem_inst.invsqrttab[193] := (323).to_natural_16
			sqrtrem_inst.invsqrttab[194] := (323).to_natural_16
			sqrtrem_inst.invsqrttab[195] := (322).to_natural_16
			sqrtrem_inst.invsqrttab[196] := (322).to_natural_16
			sqrtrem_inst.invsqrttab[197] := (321).to_natural_16
			sqrtrem_inst.invsqrttab[198] := (321).to_natural_16
			sqrtrem_inst.invsqrttab[199] := (320).to_natural_16
			sqrtrem_inst.invsqrttab[200] := (320).to_natural_16
			sqrtrem_inst.invsqrttab[201] := (319).to_natural_16
			sqrtrem_inst.invsqrttab[202] := (319).to_natural_16
			sqrtrem_inst.invsqrttab[203] := (318).to_natural_16
			sqrtrem_inst.invsqrttab[204] := (318).to_natural_16
			sqrtrem_inst.invsqrttab[205] := (317).to_natural_16
			sqrtrem_inst.invsqrttab[206] := (317).to_natural_16
			sqrtrem_inst.invsqrttab[207] := (316).to_natural_16
			sqrtrem_inst.invsqrttab[208] := (316).to_natural_16
			sqrtrem_inst.invsqrttab[209] := (315).to_natural_16
			sqrtrem_inst.invsqrttab[210] := (315).to_natural_16
			sqrtrem_inst.invsqrttab[211] := (314).to_natural_16
			sqrtrem_inst.invsqrttab[212] := (314).to_natural_16
			sqrtrem_inst.invsqrttab[213] := (313).to_natural_16
			sqrtrem_inst.invsqrttab[214] := (313).to_natural_16
			sqrtrem_inst.invsqrttab[215] := (313).to_natural_16
			sqrtrem_inst.invsqrttab[216] := (312).to_natural_16
			sqrtrem_inst.invsqrttab[217] := (312).to_natural_16
			sqrtrem_inst.invsqrttab[218] := (311).to_natural_16
			sqrtrem_inst.invsqrttab[219] := (311).to_natural_16
			sqrtrem_inst.invsqrttab[220] := (310).to_natural_16
			sqrtrem_inst.invsqrttab[221] := (310).to_natural_16
			sqrtrem_inst.invsqrttab[222] := (309).to_natural_16
			sqrtrem_inst.invsqrttab[223] := (309).to_natural_16
			sqrtrem_inst.invsqrttab[224] := (309).to_natural_16
			sqrtrem_inst.invsqrttab[225] := (308).to_natural_16
			sqrtrem_inst.invsqrttab[226] := (308).to_natural_16
			sqrtrem_inst.invsqrttab[227] := (307).to_natural_16
			sqrtrem_inst.invsqrttab[228] := (307).to_natural_16
			sqrtrem_inst.invsqrttab[229] := (306).to_natural_16
			sqrtrem_inst.invsqrttab[230] := (306).to_natural_16
			sqrtrem_inst.invsqrttab[231] := (306).to_natural_16
			sqrtrem_inst.invsqrttab[232] := (305).to_natural_16
			sqrtrem_inst.invsqrttab[233] := (305).to_natural_16
			sqrtrem_inst.invsqrttab[234] := (304).to_natural_16
			sqrtrem_inst.invsqrttab[235] := (304).to_natural_16
			sqrtrem_inst.invsqrttab[236] := (303).to_natural_16
			sqrtrem_inst.invsqrttab[237] := (303).to_natural_16
			sqrtrem_inst.invsqrttab[238] := (303).to_natural_16
			sqrtrem_inst.invsqrttab[239] := (302).to_natural_16
			sqrtrem_inst.invsqrttab[240] := (302).to_natural_16
			sqrtrem_inst.invsqrttab[241] := (301).to_natural_16
			sqrtrem_inst.invsqrttab[242] := (301).to_natural_16
			sqrtrem_inst.invsqrttab[243] := (301).to_natural_16
			sqrtrem_inst.invsqrttab[244] := (300).to_natural_16
			sqrtrem_inst.invsqrttab[245] := (300).to_natural_16
			sqrtrem_inst.invsqrttab[246] := (299).to_natural_16
			sqrtrem_inst.invsqrttab[247] := (299).to_natural_16
			sqrtrem_inst.invsqrttab[248] := (299).to_natural_16
			sqrtrem_inst.invsqrttab[249] := (298).to_natural_16
			sqrtrem_inst.invsqrttab[250] := (298).to_natural_16
			sqrtrem_inst.invsqrttab[251] := (297).to_natural_16
			sqrtrem_inst.invsqrttab[252] := (297).to_natural_16
			sqrtrem_inst.invsqrttab[253] := (297).to_natural_16
			sqrtrem_inst.invsqrttab[254] := (296).to_natural_16
			sqrtrem_inst.invsqrttab[255] := (296).to_natural_16
			sqrtrem_inst.invsqrttab[256] := (295).to_natural_16
			sqrtrem_inst.invsqrttab[257] := (295).to_natural_16
			sqrtrem_inst.invsqrttab[258] := (295).to_natural_16
			sqrtrem_inst.invsqrttab[259] := (294).to_natural_16
			sqrtrem_inst.invsqrttab[260] := (294).to_natural_16
			sqrtrem_inst.invsqrttab[261] := (294).to_natural_16
			sqrtrem_inst.invsqrttab[262] := (293).to_natural_16
			sqrtrem_inst.invsqrttab[263] := (293).to_natural_16
			sqrtrem_inst.invsqrttab[264] := (292).to_natural_16
			sqrtrem_inst.invsqrttab[265] := (292).to_natural_16
			sqrtrem_inst.invsqrttab[266] := (292).to_natural_16
			sqrtrem_inst.invsqrttab[267] := (291).to_natural_16
			sqrtrem_inst.invsqrttab[268] := (291).to_natural_16
			sqrtrem_inst.invsqrttab[269] := (291).to_natural_16
			sqrtrem_inst.invsqrttab[270] := (290).to_natural_16
			sqrtrem_inst.invsqrttab[271] := (290).to_natural_16
			sqrtrem_inst.invsqrttab[272] := (289).to_natural_16
			sqrtrem_inst.invsqrttab[273] := (289).to_natural_16
			sqrtrem_inst.invsqrttab[274] := (289).to_natural_16
			sqrtrem_inst.invsqrttab[275] := (288).to_natural_16
			sqrtrem_inst.invsqrttab[276] := (288).to_natural_16
			sqrtrem_inst.invsqrttab[277] := (288).to_natural_16
			sqrtrem_inst.invsqrttab[278] := (287).to_natural_16
			sqrtrem_inst.invsqrttab[279] := (287).to_natural_16
			sqrtrem_inst.invsqrttab[280] := (287).to_natural_16
			sqrtrem_inst.invsqrttab[281] := (286).to_natural_16
			sqrtrem_inst.invsqrttab[282] := (286).to_natural_16
			sqrtrem_inst.invsqrttab[283] := (286).to_natural_16
			sqrtrem_inst.invsqrttab[284] := (285).to_natural_16
			sqrtrem_inst.invsqrttab[285] := (285).to_natural_16
			sqrtrem_inst.invsqrttab[286] := (285).to_natural_16
			sqrtrem_inst.invsqrttab[287] := (284).to_natural_16
			sqrtrem_inst.invsqrttab[288] := (284).to_natural_16
			sqrtrem_inst.invsqrttab[289] := (283).to_natural_16
			sqrtrem_inst.invsqrttab[290] := (283).to_natural_16
			sqrtrem_inst.invsqrttab[291] := (283).to_natural_16
			sqrtrem_inst.invsqrttab[292] := (282).to_natural_16
			sqrtrem_inst.invsqrttab[293] := (282).to_natural_16
			sqrtrem_inst.invsqrttab[294] := (282).to_natural_16
			sqrtrem_inst.invsqrttab[295] := (281).to_natural_16
			sqrtrem_inst.invsqrttab[296] := (281).to_natural_16
			sqrtrem_inst.invsqrttab[297] := (281).to_natural_16
			sqrtrem_inst.invsqrttab[298] := (280).to_natural_16
			sqrtrem_inst.invsqrttab[299] := (280).to_natural_16
			sqrtrem_inst.invsqrttab[300] := (280).to_natural_16
			sqrtrem_inst.invsqrttab[301] := (280).to_natural_16
			sqrtrem_inst.invsqrttab[302] := (279).to_natural_16
			sqrtrem_inst.invsqrttab[303] := (279).to_natural_16
			sqrtrem_inst.invsqrttab[304] := (279).to_natural_16
			sqrtrem_inst.invsqrttab[305] := (278).to_natural_16
			sqrtrem_inst.invsqrttab[306] := (278).to_natural_16
			sqrtrem_inst.invsqrttab[307] := (278).to_natural_16
			sqrtrem_inst.invsqrttab[308] := (277).to_natural_16
			sqrtrem_inst.invsqrttab[309] := (277).to_natural_16
			sqrtrem_inst.invsqrttab[310] := (277).to_natural_16
			sqrtrem_inst.invsqrttab[311] := (276).to_natural_16
			sqrtrem_inst.invsqrttab[312] := (276).to_natural_16
			sqrtrem_inst.invsqrttab[313] := (276).to_natural_16
			sqrtrem_inst.invsqrttab[314] := (275).to_natural_16
			sqrtrem_inst.invsqrttab[315] := (275).to_natural_16
			sqrtrem_inst.invsqrttab[316] := (275).to_natural_16
			sqrtrem_inst.invsqrttab[317] := (274).to_natural_16
			sqrtrem_inst.invsqrttab[318] := (274).to_natural_16
			sqrtrem_inst.invsqrttab[319] := (274).to_natural_16
			sqrtrem_inst.invsqrttab[320] := (274).to_natural_16
			sqrtrem_inst.invsqrttab[321] := (273).to_natural_16
			sqrtrem_inst.invsqrttab[322] := (273).to_natural_16
			sqrtrem_inst.invsqrttab[323] := (273).to_natural_16
			sqrtrem_inst.invsqrttab[324] := (272).to_natural_16
			sqrtrem_inst.invsqrttab[325] := (272).to_natural_16
			sqrtrem_inst.invsqrttab[326] := (272).to_natural_16
			sqrtrem_inst.invsqrttab[327] := (271).to_natural_16
			sqrtrem_inst.invsqrttab[328] := (271).to_natural_16
			sqrtrem_inst.invsqrttab[329] := (271).to_natural_16
			sqrtrem_inst.invsqrttab[330] := (271).to_natural_16
			sqrtrem_inst.invsqrttab[331] := (270).to_natural_16
			sqrtrem_inst.invsqrttab[332] := (270).to_natural_16
			sqrtrem_inst.invsqrttab[333] := (270).to_natural_16
			sqrtrem_inst.invsqrttab[334] := (269).to_natural_16
			sqrtrem_inst.invsqrttab[335] := (269).to_natural_16
			sqrtrem_inst.invsqrttab[336] := (269).to_natural_16
			sqrtrem_inst.invsqrttab[337] := (268).to_natural_16
			sqrtrem_inst.invsqrttab[338] := (268).to_natural_16
			sqrtrem_inst.invsqrttab[339] := (268).to_natural_16
			sqrtrem_inst.invsqrttab[340] := (268).to_natural_16
			sqrtrem_inst.invsqrttab[341] := (267).to_natural_16
			sqrtrem_inst.invsqrttab[342] := (267).to_natural_16
			sqrtrem_inst.invsqrttab[343] := (267).to_natural_16
			sqrtrem_inst.invsqrttab[344] := (266).to_natural_16
			sqrtrem_inst.invsqrttab[345] := (266).to_natural_16
			sqrtrem_inst.invsqrttab[346] := (266).to_natural_16
			sqrtrem_inst.invsqrttab[347] := (266).to_natural_16
			sqrtrem_inst.invsqrttab[348] := (265).to_natural_16
			sqrtrem_inst.invsqrttab[349] := (265).to_natural_16
			sqrtrem_inst.invsqrttab[350] := (265).to_natural_16
			sqrtrem_inst.invsqrttab[351] := (265).to_natural_16
			sqrtrem_inst.invsqrttab[352] := (264).to_natural_16
			sqrtrem_inst.invsqrttab[353] := (264).to_natural_16
			sqrtrem_inst.invsqrttab[354] := (264).to_natural_16
			sqrtrem_inst.invsqrttab[355] := (263).to_natural_16
			sqrtrem_inst.invsqrttab[356] := (263).to_natural_16
			sqrtrem_inst.invsqrttab[357] := (263).to_natural_16
			sqrtrem_inst.invsqrttab[358] := (263).to_natural_16
			sqrtrem_inst.invsqrttab[359] := (262).to_natural_16
			sqrtrem_inst.invsqrttab[360] := (262).to_natural_16
			sqrtrem_inst.invsqrttab[361] := (262).to_natural_16
			sqrtrem_inst.invsqrttab[362] := (262).to_natural_16
			sqrtrem_inst.invsqrttab[363] := (261).to_natural_16
			sqrtrem_inst.invsqrttab[364] := (261).to_natural_16
			sqrtrem_inst.invsqrttab[365] := (261).to_natural_16
			sqrtrem_inst.invsqrttab[366] := (260).to_natural_16
			sqrtrem_inst.invsqrttab[367] := (260).to_natural_16
			sqrtrem_inst.invsqrttab[368] := (260).to_natural_16
			sqrtrem_inst.invsqrttab[369] := (260).to_natural_16
			sqrtrem_inst.invsqrttab[370] := (259).to_natural_16
			sqrtrem_inst.invsqrttab[371] := (259).to_natural_16
			sqrtrem_inst.invsqrttab[372] := (259).to_natural_16
			sqrtrem_inst.invsqrttab[373] := (259).to_natural_16
			sqrtrem_inst.invsqrttab[374] := (258).to_natural_16
			sqrtrem_inst.invsqrttab[375] := (258).to_natural_16
			sqrtrem_inst.invsqrttab[376] := (258).to_natural_16
			sqrtrem_inst.invsqrttab[377] := (258).to_natural_16
			sqrtrem_inst.invsqrttab[378] := (257).to_natural_16
			sqrtrem_inst.invsqrttab[379] := (257).to_natural_16
			sqrtrem_inst.invsqrttab[380] := (257).to_natural_16
			sqrtrem_inst.invsqrttab[381] := (257).to_natural_16
			sqrtrem_inst.invsqrttab[382] := (256).to_natural_16
			sqrtrem_inst.invsqrttab[383] := (256).to_natural_16
			perfsqr_inst.sq_res_0x100[0] := (33751571).to_natural_32
			perfsqr_inst.sq_res_0x100[1] := (33686034).to_natural_32
			perfsqr_inst.sq_res_0x100[2] := (33686035).to_natural_32
			perfsqr_inst.sq_res_0x100[3] := (33686034).to_natural_32
			perfsqr_inst.sq_res_0x100[4] := (33751570).to_natural_32
			perfsqr_inst.sq_res_0x100[5] := (33686034).to_natural_32
			perfsqr_inst.sq_res_0x100[6] := (33686034).to_natural_32
			perfsqr_inst.sq_res_0x100[7] := (33686034).to_natural_32
			perfpow_inst.nrtrial[0] := (100).to_natural_16
			perfpow_inst.nrtrial[1] := (500).to_natural_16
			perfpow_inst.nrtrial[2] := (1000).to_natural_16
			perfpow_inst.logs[0] := 0.1099457228193620
			perfpow_inst.logs[1] := 0.0847016403115322
			perfpow_inst.logs[2] := 0.0772048195144415
			powm_inst.x[0] := (0).to_natural_32
			powm_inst.x[1] := (7).to_natural_32
			powm_inst.x[2] := (25).to_natural_32
			powm_inst.x[3] := (81).to_natural_32
			powm_inst.x[4] := (241).to_natural_32
			powm_inst.x[5] := (673).to_natural_32
			powm_inst.x[6] := (1793).to_natural_32
			powm_inst.x[7] := (4609).to_natural_32
			powm_inst.x[8] := (11521).to_natural_32
			powm_inst.x[9] := (28161).to_natural_32
			powm_inst.x[10] := ((0).to_natural_32).bit_not
			powlo_inst.x___0[0] := (1).to_natural_32
			powlo_inst.x___0[1] := (7).to_natural_32
			powlo_inst.x___0[2] := (25).to_natural_32
			powlo_inst.x___0[3] := (81).to_natural_32
			powlo_inst.x___0[4] := (241).to_natural_32
			powlo_inst.x___0[5] := (673).to_natural_32
			powlo_inst.x___0[6] := (1793).to_natural_32
			powlo_inst.x___0[7] := (4609).to_natural_32
			powlo_inst.x___0[8] := (11521).to_natural_32
			powlo_inst.x___0[9] := (28161).to_natural_32
			powlo_inst.x___0[10] := ((0).to_natural_32).bit_not
			powm_sec_inst.x___1[0] := (0).to_natural_32
			powm_sec_inst.x___1[1] := (4).to_natural_32
			powm_sec_inst.x___1[2] := (27).to_natural_32
			powm_sec_inst.x___1[3] := (100).to_natural_32
			powm_sec_inst.x___1[4] := (325).to_natural_32
			powm_sec_inst.x___1[5] := (1026).to_natural_32
			powm_sec_inst.x___1[6] := (2905).to_natural_32
			powm_sec_inst.x___1[7] := (7848).to_natural_32
			powm_sec_inst.x___1[8] := (20457).to_natural_32
			powm_sec_inst.x___1[9] := (51670).to_natural_32
			powm_sec_inst.x___1[10] := ((0).to_natural_32).bit_not
			trialdivtab_inst.gmp_primes_dtab[0].binv := {NATURAL_32} 2863311531
		end

end
