class
	P_ARRAY_INIT

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_array_init (a_arr: CE_POINTER [PD_MPZ_STRUCT]; a_arr_size: INTEGER_32; a_nbits: INTEGER_32)
		local
			l_p: CE_POINTER [NATURAL_32]
			l_i: INTEGER_32
			l_nlimbs: INTEGER_32
		do
			create l_p.make

			l_nlimbs := ((a_nbits + 32) - 1) // 32
			l_p.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([((a_arr_size * l_nlimbs) * 4).to_natural_32])))))
			l_i := (0).to_integer_32
			from
			until
				not (l_i < a_arr_size)
			loop
				(a_arr + l_i).item.mp_alloc := (l_nlimbs + 1).to_integer_32;
				(a_arr + l_i).item.mp_size := 0;
				(a_arr + l_i).item.mp_d := l_p + l_i * l_nlimbs
				l_i := l_i + 1
			end
		end

end
