class
	P_BDIV_Q

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_bdiv_q (a_qp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		local
			l_di: NATURAL_32
			l_n: NATURAL_32
			l_inv: NATURAL_32
			l_n___0: NATURAL_32
			l_inv___0: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if 132 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if not (a_dn >= 132) then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if 1470 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if a_dn >= 1470 then
							mu_bdiv_q_inst.gmpn_mu_bdiv_q (a_qp, a_np, a_nn, a_dp, a_dn, a_tp)
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (a_tp, a_np, a_nn)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							l_n___0 := a_dp[0]
							l_inv___0 := (gmp_impl_inst.gmp_binvert_limb_table[((l_n___0 // {NATURAL_32} 2).bit_and ({NATURAL_32} 127)).to_integer_32]).to_natural_32
							l_inv___0 := {NATURAL_32} 2 * l_inv___0 - (l_inv___0 * l_inv___0) * l_n___0
							l_inv___0 := {NATURAL_32} 2 * l_inv___0 - (l_inv___0 * l_inv___0) * l_n___0
							l_di := (l_inv___0).bit_and ({NATURAL_32} 4294967295)
							js.break
						end
						js.reset
						l_di := (-l_di.to_integer_32).to_natural_32
						dcpi1_bdiv_q_inst.gmpn_dcpi1_bdiv_q (a_qp, a_tp, a_nn, a_dp, a_dn, l_di)
				when 6 then -- if done | if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_pos := -1 + 9 -- goto _L___0
				when 8 then -- if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L___0:
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (a_tp, a_np, a_nn)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							l_n := a_dp[0]
							l_inv := (gmp_impl_inst.gmp_binvert_limb_table[((l_n // {NATURAL_32} 2).bit_and ({NATURAL_32} 127)).to_integer_32]).to_natural_32
							l_inv := {NATURAL_32} 2 * l_inv - (l_inv * l_inv) * l_n
							l_inv := {NATURAL_32} 2 * l_inv - (l_inv * l_inv) * l_n
							l_di := (l_inv).bit_and ({NATURAL_32} 4294967295)
							js.break
						end
						js.reset
						l_di := (-l_di.to_integer_32).to_natural_32
						sbpi1_bdiv_q_inst.gmpn_sbpi1_bdiv_q (a_qp, a_tp, a_nn, a_dp, a_dn, l_di)
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_bdiv_q_itch (a_nn: INTEGER_32; a_dn: INTEGER_32): INTEGER_32
		do
			if 1470 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
				if a_dn >= 1470 then
					Result := (mu_bdiv_q_inst.gmpn_mu_bdiv_q_itch (a_nn, a_dn))
				else
					Result := a_nn
				end
			else
				Result := a_nn
			end
		end

end
