class
	P_CONG

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_congruent_p (a_a: CE_POINTER [PD_MPZ_STRUCT]; a_c: CE_POINTER [PD_MPZ_STRUCT]; a_d: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_a: CE_POINTER [PD_MPZ_STRUCT]
			l_c: CE_POINTER [PD_MPZ_STRUCT]
			l_asize: INTEGER_32
			l_csize: INTEGER_32
			l_dsize: INTEGER_32
			l_sign: INTEGER_32
			l_ap: CE_POINTER [NATURAL_32]
			l_cp: CE_POINTER [NATURAL_32]
			l_dp: CE_POINTER [NATURAL_32]
			l_xp: CE_POINTER [NATURAL_32]
			l_alow: NATURAL_32
			l_clow: NATURAL_32
			l_dlow: NATURAL_32
			l_dmask: NATURAL_32
			l_r: NATURAL_32
			l_result: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_mpz_srcptr_swap__tmp: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_twos: NATURAL_32
			l_dnorm: NATURAL_32
			l_tmp___5: NATURAL_32
			l_twos2: NATURAL_32
			l_tmp___7: INTEGER_32
			l_dsecond: NATURAL_32
			l_twos___0: NATURAL_32
			l_tmp___12: CE_POINTER [ANY]
			l_carry: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_a.make
			create l_c.make
			create l_ap.make
			create l_cp.make
			create l_dp.make
			create l_xp.make
			create l_tmp_marker.make
			create l_mpz_srcptr_swap__tmp.make
			create l_tmp___12.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_a.ce_gets (a_a)
					l_c.ce_gets (a_c)
					l_dsize := (a_d.item.mp_size).to_integer_32
					if (builtin_expect ((l_dsize = 0).to_integer, 0)).to_boolean then
						Result := ((cmp_inst.gmpz_cmp (l_a, l_c)) = 0).to_integer
						js.return
					end
					if not js.return_called then
						if l_dsize >= 0 then
							l_dsize := l_dsize
						else
							l_dsize := -l_dsize
						end
						l_dp.ce_gets (a_d.item.mp_d)
						if l_a.item.mp_size >= 0 then
							l_tmp___1 := l_a.item.mp_size
						else
							l_tmp___1 := -l_a.item.mp_size
						end
						if l_c.item.mp_size >= 0 then
							l_tmp___2 := l_c.item.mp_size
						else
							l_tmp___2 := -l_c.item.mp_size
						end
						if l_tmp___1 < l_tmp___2 then
							from
							until
								js.loop_left
							loop
								js.reset
								l_mpz_srcptr_swap__tmp.ce_gets (l_a)
								l_a.ce_gets (l_c)
								l_c.ce_gets (l_mpz_srcptr_swap__tmp)
								js.break
							end
							js.reset
						end
						l_asize := (l_a.item.mp_size).to_integer_32
						l_csize := (l_c.item.mp_size).to_integer_32
						l_sign := (l_asize).bit_xor (l_csize)
						if l_asize >= 0 then
							l_asize := l_asize
						else
							l_asize := -l_asize
						end
						l_ap.ce_gets (l_a.item.mp_d)
						if l_csize = 0 then
							Result := (divis_inst.gmpn_divisible_p (l_ap, l_asize, l_dp, l_dsize))
							js.return
						end
					end
					if not js.return_called then
						if l_csize >= 0 then
							l_csize := l_csize
						else
							l_csize := -l_csize
						end
						l_cp.ce_gets (l_c.item.mp_d)
						l_alow := l_ap[0]
						l_clow := l_cp[0]
						l_dlow := l_dp[0]
						l_dmask := ((((l_dlow).bit_and ((-l_dlow.to_integer_32).to_natural_32)) - {NATURAL_32} 1)).bit_and ({NATURAL_32} 4294967295)
						if l_sign >= 0 then
							l_alow := l_alow
						else
							l_alow := (-l_alow.to_integer_32).to_natural_32
						end
						if (((l_alow - l_clow)).bit_and (l_dmask)) /= {NATURAL_32} 0 then
							Result := 0
							js.return
						end
					end
					if not (not js.return_called and then (l_csize = 1)) then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						if l_dsize /= 1 then
							l_pos := -1 + 3 -- skip if block
						end
				when 2 then -- if: | cong_1:
						if l_sign < 0 then
							from
							until
								js.loop_left
							loop
								js.reset
								if l_clow <= l_dlow then
									l_clow := l_dlow - l_clow
								else
									from
									until
										js.loop_left
									loop
										js.reset
										l_twos := (builtin_clzl (l_dlow)).to_natural_32
										js.break
									end
									js.reset
									l_twos := l_twos
									l_dnorm := (l_dlow).bit_shift_left (l_twos.to_integer_32)
									if l_clow <= l_dnorm then
										l_tmp___5 := l_dnorm
									else
										l_tmp___5 := {NATURAL_32} 2 * l_dnorm
									end
									l_clow := l_tmp___5 - l_clow
								end
								js.break
							end
							js.reset
						end
						if 22 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_asize >= 22 then
								l_r := mod_1_inst.gmpn_mod_1 (l_ap, l_asize, l_dlow)
								if l_clow < l_dlow then
									Result := (l_r = l_clow).to_integer
									js.return
								else
									Result := (l_r = l_clow \\ l_dlow).to_integer
									js.return
								end
							end
						end
						if not js.return_called then
							if ((l_dlow).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
								from
								until
									js.loop_left
								loop
									js.reset
									l_twos2 := (builtin_ctzl (l_dlow)).to_natural_32
									js.break
								end
								js.reset
								l_dlow := (l_dlow).bit_shift_right (l_twos2.to_integer_32)
							end
							l_r := gmp_impl_inst.gmpn_modexact_1c_odd (l_ap, l_asize, l_dlow, l_clow)
							if l_r = {NATURAL_32} 0 then
								l_tmp___7 := 1
							elseif l_r = l_dlow then
								l_tmp___7 := 1
							else
								l_tmp___7 := 0
							end
							Result := l_tmp___7
							js.return
						end
				when 3 then -- if done
						if not js.return_called and then (l_dsize = 2) then
							if l_dlow /= {NATURAL_32} 0 then
								l_dsecond := l_dp[1]
								if l_dsecond <= l_dmask then
									from
									until
										js.loop_left
									loop
										js.reset
										l_twos___0 := (builtin_ctzl (l_dlow)).to_natural_32
										js.break
									end
									js.reset
									l_dlow := (((l_dlow).bit_shift_right (l_twos___0.to_integer_32))).bit_or (((l_dsecond).bit_shift_left (({NATURAL_32} 32 - l_twos___0).to_integer_32)))
									l_pos := -1 + 2 -- goto cong_1
								end
							end
						end
				when 4 then
					if not js.return_called then
						l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
						if (builtin_expect (((l_asize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___12.ce_gets ((l_aaf.new (((l_asize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___12.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_asize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_xp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___12))
						if l_sign >= 0 then
							if l_asize > l_csize then
								gmp_inst.gmpn_sub (l_xp, l_ap, l_asize, l_cp, l_csize).do_nothing
							elseif (gmp_inst.gmpn_cmp (l_ap, l_cp, l_asize)) >= 0 then
								gmp_inst.gmpn_sub (l_xp, l_ap, l_asize, l_cp, l_csize).do_nothing
							else
								gmp_inst.gmpn_sub_n (l_xp, l_cp, l_ap, l_asize).do_nothing
							end
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									not (not js.loop_left and then (l_asize > 0))
								loop
									js.reset
									if l_xp[(l_asize - 1)] /= {NATURAL_32} 0 then
										js.break
									end
									if not js.loop_jumped then
										l_asize := l_asize - 1
									end
								end
								js.reset
								js.break
							end
							js.reset
						else
							l_carry := gmp_inst.gmpn_add (l_xp, l_ap, l_asize, l_cp, l_csize)
							l_xp[l_asize] := l_carry
							l_asize := l_asize + (l_carry /= {NATURAL_32} 0).to_integer
						end
						l_result := divis_inst.gmpn_divisible_p (l_xp, l_asize, l_dp, l_dsize)
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
							end
							js.break
						end
						js.reset
						Result := l_result
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
