class
	P_CONG_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_congruent_ui_p (a_a: CE_POINTER [PD_MPZ_STRUCT]; a_cu: NATURAL_32; a_du: NATURAL_32): INTEGER_32
		local
			l_ap: CE_POINTER [NATURAL_32]
			l_asize: INTEGER_32
			l_c: NATURAL_32
			l_d: NATURAL_32
			l_r: NATURAL_32
			l_climbs: CE_ARRAY [NATURAL_32]
			l_dlimbs: CE_ARRAY [NATURAL_32]
			l_cz: CE_ARRAY [PD_MPZ_STRUCT]
			l_dz: CE_ARRAY [PD_MPZ_STRUCT]
			l_twos: NATURAL_32
			l_dnorm: NATURAL_32
			l_tmp___4: NATURAL_32
			l_twos2: NATURAL_32
			l_tmp___6: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ap.make
			create l_climbs.make (<<2>>)
			create l_dlimbs.make (<<2>>)
			create l_cz.make (<<1>>)
			create l_dz.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (builtin_expect ((a_du = {NATURAL_32} 0).to_integer, 0)).to_boolean then
						Result := ((cmp_ui_inst.gmpz_cmp_ui (a_a, a_cu)) = 0).to_integer
						js.return
					end
					if not js.return_called then
						l_asize := (a_a.item.mp_size).to_integer_32
						if l_asize = 0 then
							if a_cu < a_du then
								Result := (a_cu = {NATURAL_32} 0).to_integer
								js.return
							else
								Result := (a_cu \\ a_du = {NATURAL_32} 0).to_integer
								js.return
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (a_du > {NATURAL_32} 4294967295) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (a_cu > {NATURAL_32} 4294967295) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						l_cz[0].mp_alloc := 2
						l_cz[0].mp_d := l_climbs
						l_dz[0].mp_alloc := 2
						l_dz[0].mp_d := l_dlimbs
						set_ui_inst.gmpz_set_ui (l_cz, a_cu)
						set_ui_inst.gmpz_set_ui (l_dz, a_du)
						Result := (cong_inst.gmpz_congruent_p (a_a, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_cz), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_dz)))
						js.return
				when 6 then -- if done | if done
						if not js.return_called then
							l_c := a_cu
							l_d := a_du
							if l_asize < 0 then
								l_asize := -l_asize
								from
								until
									js.loop_left
								loop
									js.reset
									if l_c <= l_d then
										l_c := l_d - l_c
									else
										from
										until
											js.loop_left
										loop
											js.reset
											l_twos := (builtin_clzl (l_d)).to_natural_32
											js.break
										end
										js.reset
										l_twos := l_twos
										l_dnorm := (l_d).bit_shift_left (l_twos.to_integer_32)
										if l_c <= l_dnorm then
											l_tmp___4 := l_dnorm
										else
											l_tmp___4 := {NATURAL_32} 2 * l_dnorm
										end
										l_c := l_tmp___4 - l_c
									end
									js.break
								end
								js.reset
							end
							l_ap.ce_gets (a_a.item.mp_d)
							if 22 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
								if l_asize >= 22 then
									l_r := mod_1_inst.gmpn_mod_1 (l_ap, l_asize, l_d)
									if l_c < l_d then
										Result := (l_r = l_c).to_integer
										js.return
									else
										Result := (l_r = l_c \\ l_d).to_integer
										js.return
									end
								end
							end
						end
						if not js.return_called and then (((l_d).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0) then
							if (((l_ap[0] - l_c)).bit_and ((((l_d).bit_and ((-l_d.to_integer_32).to_natural_32)) - {NATURAL_32} 1))).to_boolean then
								Result := 0
								js.return
							end
							if not js.return_called then
								from
								until
									js.loop_left
								loop
									js.reset
									l_twos2 := (builtin_ctzl (l_d)).to_natural_32
									js.break
								end
								js.reset
								l_d := (l_d).bit_shift_right (l_twos2.to_integer_32)
							end
						end
						if not js.return_called then
							l_r := gmp_impl_inst.gmpn_modexact_1c_odd (l_ap, l_asize, l_d, l_c)
							if l_r = {NATURAL_32} 0 then
								l_tmp___6 := 1
							elseif l_r = l_d then
								l_tmp___6 := 1
							else
								l_tmp___6 := 0
							end
							Result := l_tmp___6
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
