class
	P_DCPI1_BDIV_Q

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_dcpi1_bdiv_q_n_itch (a_n: INTEGER_32): INTEGER_32
		do
			Result := a_n
		end

	gmpn_dcpi1_bdiv_q_n (a_qp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_dp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_dinv: NATURAL_32; a_tp: CE_POINTER [NATURAL_32])
		local
			l_qp: CE_POINTER [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_lo: INTEGER_32
			l_hi: INTEGER_32
			l_cy: NATURAL_32
			js: JUMP_STATE
		do
			create l_qp.make
			create l_np.make

			l_qp.ce_gets (a_qp)
			l_np.ce_gets (a_np)
			l_n := a_n
			from
			until
				js.loop_left
			loop
				js.reset
				if 132 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if not (l_n >= 132) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_lo := (l_n).bit_shift_right (1)
					l_hi := l_n - l_lo
					l_cy := dcpi1_bdiv_qr_inst.gmpn_dcpi1_bdiv_qr_n (l_qp, l_np, a_dp, l_lo, a_dinv, a_tp)
					mullo_n_inst.gmpn_mullo_n (a_tp, l_qp, a_dp + l_hi, l_lo)
					gmp_inst.gmpn_sub_n (l_np + l_hi, (l_np + l_hi), a_tp, l_lo).do_nothing
					if l_lo < l_hi then
						l_cy := l_cy + (gmp_inst.gmpn_submul_1 (l_np + l_lo, l_qp, l_lo, a_dp[l_lo]))
						l_np[(l_n - 1)] := l_np[(l_n - 1)] - l_cy
					end
					l_qp.ce_gets (l_qp + l_lo)
					l_np.ce_gets (l_np + l_lo)
					l_n := l_n - l_lo
				end
			end
			js.reset
			sbpi1_bdiv_q_inst.gmpn_sbpi1_bdiv_q (l_qp, l_np, l_n, a_dp, l_n, a_dinv)
		end

	gmpn_dcpi1_bdiv_q (a_qp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_dinv: NATURAL_32)
		local
			l_qp: CE_POINTER [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_qn: INTEGER_32
			l_cy: NATURAL_32
			l_tp: CE_POINTER [NATURAL_32]
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_ptr_dummy: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_qp.make
			create l_np.make
			create l_tp.make
			create l_tmp_marker.make
			create l_ptr_dummy.make

			l_qp.ce_gets (a_qp)
			l_np.ce_gets (a_np)
			l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
			l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new ((a_dn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
			l_qn := a_nn
			if l_qn > a_dn then
				from
				until
					js.loop_left
				loop
					js.reset
					l_qn := l_qn - a_dn
					if not (l_qn > a_dn) then
						js.break
					end
				end
				js.reset
				if 60 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_qn >= 60 then
						l_cy := dcpi1_bdiv_qr_inst.gmpn_dcpi1_bdiv_qr_n (l_qp, l_np, a_dp, l_qn, a_dinv, l_tp)
					else
						l_cy := sbpi1_bdiv_qr_inst.gmpn_sbpi1_bdiv_qr (l_qp, l_np, 2 * l_qn, a_dp, l_qn, a_dinv)
					end
				else
					l_cy := sbpi1_bdiv_qr_inst.gmpn_sbpi1_bdiv_qr (l_qp, l_np, 2 * l_qn, a_dp, l_qn, a_dinv)
				end
				if l_qn /= a_dn then
					if l_qn > a_dn - l_qn then
						mul_inst.gmpn_mul (l_tp, l_qp, l_qn, a_dp + l_qn, a_dn - l_qn).do_nothing
					else
						mul_inst.gmpn_mul (l_tp, a_dp + l_qn, a_dn - l_qn, l_qp, l_qn).do_nothing
					end
					from
					until
						js.loop_left
					loop
						js.reset
						asm322 (l_ptr_dummy.address, l_tp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_qn), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
						js.break
					end
					js.reset
					gmp_inst.gmpn_sub (l_np + l_qn, (l_np + l_qn), a_nn - l_qn, l_tp, a_dn).do_nothing
					l_cy := (0).to_natural_32
				end
				l_np.ce_gets (l_np + l_qn)
				l_qp.ce_gets (l_qp + l_qn)
				l_qn := a_nn - l_qn
				from
				until
					not (l_qn > a_dn)
				loop
					gmp_inst.gmpn_sub_1 (l_np + a_dn, (l_np + a_dn), l_qn, l_cy).do_nothing
					l_cy := dcpi1_bdiv_qr_inst.gmpn_dcpi1_bdiv_qr_n (l_qp, l_np, a_dp, a_dn, a_dinv, l_tp)
					l_qp.ce_gets (l_qp + a_dn)
					l_np.ce_gets (l_np + a_dn)
					l_qn := l_qn - a_dn
				end
				gmpn_dcpi1_bdiv_q_n (l_qp, l_np, a_dp, a_dn, a_dinv, l_tp)
			elseif 132 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
				if l_qn >= 132 then
					gmpn_dcpi1_bdiv_q_n (l_qp, l_np, a_dp, l_qn, a_dinv, l_tp)
				else
					sbpi1_bdiv_q_inst.gmpn_sbpi1_bdiv_q (l_qp, l_np, l_qn, a_dp, l_qn, a_dinv)
				end
			else
				sbpi1_bdiv_q_inst.gmpn_sbpi1_bdiv_q (l_qp, l_np, l_qn, a_dp, l_qn, a_dinv)
			end
			from
			until
				js.loop_left
			loop
				js.reset
				if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
					tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
				end
				js.break
			end
			js.reset
		end

end
