class
	P_DCPI1_DIV_Q

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_dcpi1_div_q (a_qp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_dinv: CE_POINTER [PD_GMP_PI1_T]): NATURAL_32
		local
			l_tp: CE_POINTER [NATURAL_32]
			l_wp: CE_POINTER [NATURAL_32]
			l_qh: NATURAL_32
			l_qn: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_cy: NATURAL_32
			l_tmp___2: NATURAL_32
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_tp.make
			create l_wp.make
			create l_tmp_marker.make

			l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
			l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new (((a_nn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					gmp_inst.gmpn_copyi (l_tp + 1, a_np, a_nn)
					js.break
				end
				js.reset
				js.break
			end
			js.reset
			l_tp[0] := (0).to_natural_32
			l_qn := a_nn - a_dn
			l_wp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new (((l_qn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))))
			l_qh := dcpi1_divappr_q_inst.gmpn_dcpi1_divappr_q (l_wp, l_tp, a_nn + 1, a_dp, a_dn, a_dinv)
			if l_wp[0] = {NATURAL_32} 0 then
				if l_qn > a_dn then
					mul_inst.gmpn_mul (l_tp, (l_wp + 1), l_qn, a_dp, a_dn).do_nothing
				else
					mul_inst.gmpn_mul (l_tp, a_dp, a_dn, (l_wp + 1), l_qn).do_nothing
				end
				if l_qh /= {NATURAL_32} 0 then
					l_cy := (gmp_inst.gmpn_add_n (l_tp + l_qn, (l_tp + l_qn), a_dp, a_dn))
				else
					l_cy := (0).to_natural_32
				end
				if l_cy.to_boolean then
					l_tmp___2 := gmp_inst.gmpn_sub_1 (a_qp, (l_wp + 1), l_qn, (1).to_natural_32)
					l_qh := l_qh - l_tmp___2
				elseif (gmp_inst.gmpn_cmp (l_tp, a_np, a_nn)) > 0 then
					l_tmp___2 := gmp_inst.gmpn_sub_1 (a_qp, (l_wp + 1), l_qn, (1).to_natural_32)
					l_qh := l_qh - l_tmp___2
				else
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (a_qp, (l_wp + 1), l_qn)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
				end
			else
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						gmp_inst.gmpn_copyi (a_qp, (l_wp + 1), l_qn)
						js.break
					end
					js.reset
					js.break
				end
				js.reset
			end
			from
			until
				js.loop_left
			loop
				js.reset
				if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
					tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
				end
				js.break
			end
			js.reset
			Result := l_qh
		end

end
