class
	P_DIV_Q

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_div_q (a_qp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		local
			l_new_dp: CE_POINTER [NATURAL_32]
			l_new_np: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_cy: NATURAL_32
			l_dh: NATURAL_32
			l_qh: NATURAL_32
			l_new_nn: INTEGER_32
			l_qn: INTEGER_32
			l_dinv: PD_GMP_PI1_T
			l_cnt: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp___2: CE_POINTER [ANY]
			l_v: NATURAL_32
			l_p: NATURAL_32
			l_t1: NATURAL_32
			l_t0: NATURAL_32
			l_mask: NATURAL_32
			l_v___0: NATURAL_32
			l_p___0: NATURAL_32
			l_t1___0: NATURAL_32
			l_t0___0: NATURAL_32
			l_mask___0: NATURAL_32
			l_itch: INTEGER_32
			l_scratch___0: CE_POINTER [NATURAL_32]
			l_tmp___10: CE_POINTER [ANY]
			l_i: INTEGER_32
			l_n: INTEGER_32
			l_v___1: NATURAL_32
			l_p___1: NATURAL_32
			l_t1___1: NATURAL_32
			l_t0___1: NATURAL_32
			l_mask___1: NATURAL_32
			l_v___2: NATURAL_32
			l_p___2: NATURAL_32
			l_t1___2: NATURAL_32
			l_t0___2: NATURAL_32
			l_mask___2: NATURAL_32
			l_itch___0: INTEGER_32
			l_scratch___1: CE_POINTER [NATURAL_32]
			l_tmp___19: CE_POINTER [ANY]
			l_tmp___25: CE_POINTER [ANY]
			l_tmp___30: CE_POINTER [ANY]
			l_tmp___35: CE_POINTER [ANY]
			l_v___3: NATURAL_32
			l_p___3: NATURAL_32
			l_t1___3: NATURAL_32
			l_t0___3: NATURAL_32
			l_mask___3: NATURAL_32
			l_v___4: NATURAL_32
			l_p___4: NATURAL_32
			l_t1___4: NATURAL_32
			l_t0___4: NATURAL_32
			l_mask___4: NATURAL_32
			l_itch___1: INTEGER_32
			l_scratch___2: CE_POINTER [NATURAL_32]
			l_tmp___43: CE_POINTER [ANY]
			l_i___0: INTEGER_32
			l_n___0: INTEGER_32
			l_v___5: NATURAL_32
			l_p___5: NATURAL_32
			l_t1___5: NATURAL_32
			l_t0___5: NATURAL_32
			l_mask___5: NATURAL_32
			l_v___6: NATURAL_32
			l_p___6: NATURAL_32
			l_t1___6: NATURAL_32
			l_t0___6: NATURAL_32
			l_mask___6: NATURAL_32
			l_itch___2: INTEGER_32
			l_scratch___3: CE_POINTER [NATURAL_32]
			l_tmp___52: CE_POINTER [ANY]
			l_rn: INTEGER_32
			l_tmp___58: CE_POINTER [ANY]
			l_ptr_dummy: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_new_dp.make
			create l_new_np.make
			create l_tp.make
			create l_rp.make
			create l_dinv.make
			create l_tmp_marker.make
			create l_tmp___2.make
			create l_scratch___0.make
			create l_tmp___10.make
			create l_scratch___1.make
			create l_tmp___19.make
			create l_tmp___25.make
			create l_tmp___30.make
			create l_tmp___35.make
			create l_scratch___2.make
			create l_tmp___43.make
			create l_scratch___3.make
			create l_tmp___52.make
			create l_tmp___58.make
			create l_ptr_dummy.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
					if a_dn = 1 then
						gmp_inst.gmpn_divrem_1 (a_qp, 0, a_np, a_nn, a_dp[(a_dn - 1)]).do_nothing
						js.return
					end
					if js.return_called then
						l_pos := -1 + 106 -- skip if block
					end
				when 1 then -- if:
						l_qn := (a_nn - a_dn) + 1
						if not (l_qn + 5 >= a_dn) then
							l_pos := -1 + 69 -- skip if block
						end
				when 2 then -- if:
						l_new_np.ce_gets (a_scratch)
						l_dh := a_dp[(a_dn - 1)]
						if not ((builtin_expect ((((l_dh).bit_and ((({NATURAL_32} 1).bit_shift_left (31)))) = {NATURAL_32} 0).to_integer, 1)).to_boolean) then
							l_pos := -1 + 36 -- skip if block
						end
				when 3 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							l_cnt := builtin_clzl (l_dh)
							js.break
						end
						js.reset
						l_cy := gmp_inst.gmpn_lshift (l_new_np, a_np, a_nn, l_cnt.to_natural_32)
						l_new_np[a_nn] := l_cy
						l_new_nn := a_nn + (l_cy /= {NATURAL_32} 0).to_integer
						if (builtin_expect ((a_dn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___2.ce_gets ((l_aaf.new ((a_dn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___2.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (a_dn.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_new_dp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2))
						gmp_inst.gmpn_lshift (l_new_dp, a_dp, a_dn, l_cnt.to_natural_32).do_nothing
						if a_dn /= 2 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_qh := gmp_inst.gmpn_divrem_2 (a_qp, 0, l_new_np, l_new_nn, l_new_dp)
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 6 then -- else:
						if 56 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 33 -- skip if block
						end
				when 7 then -- if:
						if not (a_dn >= 56) then
							l_pos := -1 + 31 -- skip if block
						end
				when 8 then -- if:
						if 56 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 29 -- skip if block
						end
				when 9 then -- if:
						if not (l_new_nn - a_dn >= 56) then
							l_pos := -1 + 27 -- skip if block
						end
				when 10 then -- if:
						if 62 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 25 -- skip if block
						end
				when 11 then -- if:
						if not (a_dn >= 62) then
							l_pos := -1 + 23 -- skip if block
						end
				when 12 then -- if:
						if 1996 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 21 -- skip if block
						end
				when 13 then -- if:
						if not (a_nn >= 1996) then
							l_pos := -1 + 19 -- skip if block
						end
				when 14 then -- if:
						if not ((1872).to_double * a_dn.to_double + (62).to_double * a_nn.to_double > a_dn.to_double * a_nn.to_double) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								l_v___0 := gmp_impl_inst.gmpn_invert_limb (l_new_dp[(a_dn - 1)])
								js.break
							end
							js.reset
							l_p___0 := l_new_dp[(a_dn - 1)] * l_v___0
							l_p___0 := l_p___0 + (l_new_dp[(a_dn - 2)])
							if l_p___0 < l_new_dp[(a_dn - 2)] then
								l_v___0 := l_v___0 - 1
								l_mask___0 := (-(l_p___0 >= l_new_dp[(a_dn - 1)]).to_integer).to_integer.to_natural_32
								l_p___0 := l_p___0 - (l_new_dp[(a_dn - 1)])
								l_v___0 := l_v___0 + l_mask___0
								l_p___0 := l_p___0 - ((l_mask___0).bit_and (l_new_dp[(a_dn - 1)]))
							end
							asm107 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_t0___0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t1___0), l_new_dp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_dn), create {CE_POINTER [NATURAL_32]}.make_shared ($l_v___0))
							l_p___0 := l_p___0 + l_t1___0
							if l_p___0 < l_t1___0 then
								l_v___0 := l_v___0 - 1
								if (builtin_expect ((l_p___0 >= l_new_dp[(a_dn - 1)]).to_integer, 0)).to_boolean then
									if l_p___0 > l_new_dp[(a_dn - 1)] then
										l_v___0 := l_v___0 - 1
									elseif l_t0___0 >= l_new_dp[(a_dn - 2)] then
										l_v___0 := l_v___0 - 1
									end
								end
							end
							l_dinv.inv32 := l_v___0
							js.break
						end
						js.reset
						l_qh := dcpi1_div_q_inst.gmpn_dcpi1_div_q (a_qp, l_new_np, l_new_nn, l_new_dp, a_dn, l_dinv.address)
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:
						l_itch := (mu_div_q_inst.gmpn_mu_div_q_itch (l_new_nn, a_dn, 0))
						if (builtin_expect ((l_itch.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___10.ce_gets ((l_aaf.new ((l_itch.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___10.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_itch.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_scratch___0.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___10))
						l_qh := mu_div_q_inst.gmpn_mu_div_q (a_qp, l_new_np, l_new_nn, l_new_dp, a_dn, l_scratch___0)
				when 18 then -- if done | if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:
						l_pos := -1 + 15 -- goto _L
				when 20 then -- if done | if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else:
						l_pos := -1 + 15 -- goto _L
				when 22 then -- if done | if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else:
						l_pos := -1 + 15 -- goto _L
				when 24 then -- if done | if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else:
						l_pos := -1 + 15 -- goto _L
				when 26 then -- if done | if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else:
						l_pos := -1 + 29 -- goto _L___1
				when 28 then -- if done | if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else: | _L___1:
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								l_v := gmp_impl_inst.gmpn_invert_limb (l_new_dp[(a_dn - 1)])
								js.break
							end
							js.reset
							l_p := l_new_dp[(a_dn - 1)] * l_v
							l_p := l_p + (l_new_dp[(a_dn - 2)])
							if l_p < l_new_dp[(a_dn - 2)] then
								l_v := l_v - 1
								l_mask := (-(l_p >= l_new_dp[(a_dn - 1)]).to_integer).to_integer.to_natural_32
								l_p := l_p - (l_new_dp[(a_dn - 1)])
								l_v := l_v + l_mask
								l_p := l_p - ((l_mask).bit_and (l_new_dp[(a_dn - 1)]))
							end
							asm108 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_t0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t1), l_new_dp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_dn), create {CE_POINTER [NATURAL_32]}.make_shared ($l_v))
							l_p := l_p + l_t1
							if l_p < l_t1 then
								l_v := l_v - 1
								if (builtin_expect ((l_p >= l_new_dp[(a_dn - 1)]).to_integer, 0)).to_boolean then
									if l_p > l_new_dp[(a_dn - 1)] then
										l_v := l_v - 1
									elseif l_t0 >= l_new_dp[(a_dn - 2)] then
										l_v := l_v - 1
									end
								end
							end
							l_dinv.inv32 := l_v
							js.break
						end
						js.reset
						l_qh := sbpi1_div_q_inst.gmpn_sbpi1_div_q (a_qp, l_new_np, l_new_nn, l_new_dp, a_dn, l_dinv.inv32)
				when 30 then -- if done | if block done, skip else block:
						l_pos := -1 + 32
				when 31 then -- else:
						l_pos := -1 + 29 -- goto _L___1
				when 32 then -- if done | if block done, skip else block:
						l_pos := -1 + 34
				when 33 then -- else:
						l_pos := -1 + 29 -- goto _L___1
				when 34 then -- if done
						if l_cy = {NATURAL_32} 0 then
							a_qp[(l_qn - 1)] := l_qh
						elseif (builtin_expect ((l_qh /= {NATURAL_32} 0).to_integer, 0)).to_boolean then
							l_n := l_new_nn - a_dn
							l_i := (0).to_integer_32
							from
							until
								not (l_i < l_n)
							loop
								a_qp[l_i] := {NATURAL_32} 4294967295
								l_i := l_i + 1
							end
							l_qh := (0).to_natural_32
						end
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 68
				when 36 then -- else:
						if (l_new_np.c_pointer.to_integer_32).to_natural_32 /= (a_np.c_pointer.to_integer_32).to_natural_32 then
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (l_new_np, a_np, a_nn)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
						end
						if a_dn /= 2 then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						l_qh := gmp_inst.gmpn_divrem_2 (a_qp, 0, l_new_np, a_nn, a_dp)
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 39 then -- else:
						if 56 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 66 -- skip if block
						end
				when 40 then -- if:
						if not (a_dn >= 56) then
							l_pos := -1 + 64 -- skip if block
						end
				when 41 then -- if:
						if 56 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 62 -- skip if block
						end
				when 42 then -- if:
						if not (a_nn - a_dn >= 56) then
							l_pos := -1 + 60 -- skip if block
						end
				when 43 then -- if:
						if 62 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 58 -- skip if block
						end
				when 44 then -- if:
						if not (a_dn >= 62) then
							l_pos := -1 + 56 -- skip if block
						end
				when 45 then -- if:
						if 1996 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 54 -- skip if block
						end
				when 46 then -- if:
						if not (a_nn >= 1996) then
							l_pos := -1 + 52 -- skip if block
						end
				when 47 then -- if:
						if not ((1872).to_double * a_dn.to_double + (62).to_double * a_nn.to_double > a_dn.to_double * a_nn.to_double) then
							l_pos := -1 + 50 -- skip if block
						end
				when 48 then -- if: | _L___2:
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								l_v___2 := gmp_impl_inst.gmpn_invert_limb (l_dh)
								js.break
							end
							js.reset
							l_p___2 := l_dh * l_v___2
							l_p___2 := l_p___2 + (a_dp[(a_dn - 2)])
							if l_p___2 < a_dp[(a_dn - 2)] then
								l_v___2 := l_v___2 - 1
								l_mask___2 := (-(l_p___2 >= l_dh).to_integer).to_integer.to_natural_32
								l_p___2 := l_p___2 - l_dh
								l_v___2 := l_v___2 + l_mask___2
								l_p___2 := l_p___2 - ((l_mask___2).bit_and (l_dh))
							end
							asm109 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_t0___2), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t1___2), a_dp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_dn), create {CE_POINTER [NATURAL_32]}.make_shared ($l_v___2))
							l_p___2 := l_p___2 + l_t1___2
							if l_p___2 < l_t1___2 then
								l_v___2 := l_v___2 - 1
								if (builtin_expect ((l_p___2 >= l_dh).to_integer, 0)).to_boolean then
									if l_p___2 > l_dh then
										l_v___2 := l_v___2 - 1
									elseif l_t0___2 >= a_dp[(a_dn - 2)] then
										l_v___2 := l_v___2 - 1
									end
								end
							end
							l_dinv.inv32 := l_v___2
							js.break
						end
						js.reset
						l_qh := dcpi1_div_q_inst.gmpn_dcpi1_div_q (a_qp, l_new_np, a_nn, a_dp, a_dn, l_dinv.address)
				when 49 then -- if block done, skip else block:
						l_pos := -1 + 51
				when 50 then -- else:
						l_itch___0 := (mu_div_q_inst.gmpn_mu_div_q_itch (a_nn, a_dn, 0))
						if (builtin_expect ((l_itch___0.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___19.ce_gets ((l_aaf.new ((l_itch___0.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___19.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_itch___0.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_scratch___1.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___19))
						l_qh := mu_div_q_inst.gmpn_mu_div_q (a_qp, a_np, a_nn, a_dp, a_dn, l_scratch___1)
				when 51 then -- if done | if block done, skip else block:
						l_pos := -1 + 53
				when 52 then -- else:
						l_pos := -1 + 48 -- goto _L___2
				when 53 then -- if done | if block done, skip else block:
						l_pos := -1 + 55
				when 54 then -- else:
						l_pos := -1 + 48 -- goto _L___2
				when 55 then -- if done | if block done, skip else block:
						l_pos := -1 + 57
				when 56 then -- else:
						l_pos := -1 + 48 -- goto _L___2
				when 57 then -- if done | if block done, skip else block:
						l_pos := -1 + 59
				when 58 then -- else:
						l_pos := -1 + 48 -- goto _L___2
				when 59 then -- if done | if block done, skip else block:
						l_pos := -1 + 61
				when 60 then -- else:
						l_pos := -1 + 62 -- goto _L___4
				when 61 then -- if done | if block done, skip else block:
						l_pos := -1 + 63
				when 62 then -- else: | _L___4:
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								l_v___1 := gmp_impl_inst.gmpn_invert_limb (l_dh)
								js.break
							end
							js.reset
							l_p___1 := l_dh * l_v___1
							l_p___1 := l_p___1 + (a_dp[(a_dn - 2)])
							if l_p___1 < a_dp[(a_dn - 2)] then
								l_v___1 := l_v___1 - 1
								l_mask___1 := (-(l_p___1 >= l_dh).to_integer).to_integer.to_natural_32
								l_p___1 := l_p___1 - l_dh
								l_v___1 := l_v___1 + l_mask___1
								l_p___1 := l_p___1 - ((l_mask___1).bit_and (l_dh))
							end
							asm110 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_t0___1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t1___1), a_dp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_dn), create {CE_POINTER [NATURAL_32]}.make_shared ($l_v___1))
							l_p___1 := l_p___1 + l_t1___1
							if l_p___1 < l_t1___1 then
								l_v___1 := l_v___1 - 1
								if (builtin_expect ((l_p___1 >= l_dh).to_integer, 0)).to_boolean then
									if l_p___1 > l_dh then
										l_v___1 := l_v___1 - 1
									elseif l_t0___1 >= a_dp[(a_dn - 2)] then
										l_v___1 := l_v___1 - 1
									end
								end
							end
							l_dinv.inv32 := l_v___1
							js.break
						end
						js.reset
						l_qh := sbpi1_div_q_inst.gmpn_sbpi1_div_q (a_qp, l_new_np, a_nn, a_dp, a_dn, l_dinv.inv32)
				when 63 then -- if done | if block done, skip else block:
						l_pos := -1 + 65
				when 64 then -- else:
						l_pos := -1 + 62 -- goto _L___4
				when 65 then -- if done | if block done, skip else block:
						l_pos := -1 + 67
				when 66 then -- else:
						l_pos := -1 + 62 -- goto _L___4
				when 67 then -- if done
						a_qp[(a_nn - a_dn)] := l_qh
				when 68 then -- if done | if block done, skip else block:
						l_pos := -1 + 105
				when 69 then -- else:
						if (builtin_expect (((l_qn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___25.ce_gets ((l_aaf.new (((l_qn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___25.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_qn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___25))
						l_new_np.ce_gets (a_scratch)
						l_new_nn := 2 * l_qn + 1
						if (l_new_np.c_pointer.to_integer_32).to_natural_32 = (a_np.c_pointer.to_integer_32).to_natural_32 then
							if (builtin_expect (((l_new_nn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
								l_tmp___30.ce_gets ((l_aaf.new (((l_new_nn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							else
								l_tmp___30.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_new_nn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							l_new_np.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___30))
						end
						l_dh := a_dp[(a_dn - 1)]
						if not ((builtin_expect ((((l_dh).bit_and ((({NATURAL_32} 1).bit_shift_left (31)))) = {NATURAL_32} 0).to_integer, 1)).to_boolean) then
							l_pos := -1 + 85 -- skip if block
						end
				when 70 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							l_cnt := builtin_clzl (l_dh)
							js.break
						end
						js.reset
						l_cy := gmp_inst.gmpn_lshift (l_new_np, (a_np + a_nn) - l_new_nn, l_new_nn, l_cnt.to_natural_32)
						l_new_np[l_new_nn] := l_cy
						l_new_nn := l_new_nn + (l_cy /= {NATURAL_32} 0).to_integer
						if (builtin_expect (((l_qn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___35.ce_gets ((l_aaf.new (((l_qn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___35.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_qn + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_new_dp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___35))
						gmp_inst.gmpn_lshift (l_new_dp, (a_dp + a_dn) - (l_qn + 1), l_qn + 1, l_cnt.to_natural_32).do_nothing
						l_new_dp[0] := (l_new_dp[0]).bit_or (((a_dp[((a_dn - (l_qn + 1)) - 1)]).bit_shift_right ((32 - l_cnt))))
						if l_qn + 1 /= 2 then
							l_pos := -1 + 73 -- skip if block
						end
				when 71 then -- if:
						l_qh := gmp_inst.gmpn_divrem_2 (l_tp, 0, l_new_np, l_new_nn, l_new_dp)
				when 72 then -- if block done, skip else block:
						l_pos := -1 + 83
				when 73 then -- else:
						if 55 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 82 -- skip if block
						end
				when 74 then -- if:
						if not (l_qn >= 55) then
							l_pos := -1 + 80 -- skip if block
						end
				when 75 then -- if:
						if 997 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 78 -- skip if block
						end
				when 76 then -- if:
						if l_qn >= 997 then
							l_itch___1 := (mu_divappr_q_inst.gmpn_mu_divappr_q_itch (l_new_nn, l_qn + 1, 0))
							if (builtin_expect ((l_itch___1.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
								l_tmp___43.ce_gets ((l_aaf.new ((l_itch___1.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							else
								l_tmp___43.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_itch___1.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							l_scratch___2.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___43))
							l_qh := mu_divappr_q_inst.gmpn_mu_divappr_q (l_tp, l_new_np, l_new_nn, l_new_dp, l_qn + 1, l_scratch___2)
						else
							l_pos := -1 + 78 -- goto _L___5
						end
				when 77 then -- if block done, skip else block:
						l_pos := -1 + 79
				when 78 then -- else: | _L___5:
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								l_v___4 := gmp_impl_inst.gmpn_invert_limb (l_new_dp[l_qn])
								js.break
							end
							js.reset
							l_p___4 := l_new_dp[l_qn] * l_v___4
							l_p___4 := l_p___4 + (l_new_dp[(l_qn - 1)])
							if l_p___4 < l_new_dp[(l_qn - 1)] then
								l_v___4 := l_v___4 - 1
								l_mask___4 := (-(l_p___4 >= l_new_dp[l_qn]).to_integer).to_integer.to_natural_32
								l_p___4 := l_p___4 - (l_new_dp[l_qn])
								l_v___4 := l_v___4 + l_mask___4
								l_p___4 := l_p___4 - ((l_mask___4).bit_and (l_new_dp[l_qn]))
							end
							asm111 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_t0___4), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t1___4), l_new_dp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_qn), create {CE_POINTER [NATURAL_32]}.make_shared ($l_v___4))
							l_p___4 := l_p___4 + l_t1___4
							if l_p___4 < l_t1___4 then
								l_v___4 := l_v___4 - 1
								if (builtin_expect ((l_p___4 >= l_new_dp[l_qn]).to_integer, 0)).to_boolean then
									if l_p___4 > l_new_dp[l_qn] then
										l_v___4 := l_v___4 - 1
									elseif l_t0___4 >= l_new_dp[(l_qn - 1)] then
										l_v___4 := l_v___4 - 1
									end
								end
							end
							l_dinv.inv32 := l_v___4
							js.break
						end
						js.reset
						l_qh := dcpi1_divappr_q_inst.gmpn_dcpi1_divappr_q (l_tp, l_new_np, l_new_nn, l_new_dp, l_qn + 1, l_dinv.address)
				when 79 then -- if done | if block done, skip else block:
						l_pos := -1 + 81
				when 80 then -- else:
						l_pos := -1 + 82 -- goto _L___6
				when 81 then -- if done | if block done, skip else block:
						l_pos := -1 + 83
				when 82 then -- else: | _L___6:
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								l_v___3 := gmp_impl_inst.gmpn_invert_limb (l_new_dp[l_qn])
								js.break
							end
							js.reset
							l_p___3 := l_new_dp[l_qn] * l_v___3
							l_p___3 := l_p___3 + (l_new_dp[(l_qn - 1)])
							if l_p___3 < l_new_dp[(l_qn - 1)] then
								l_v___3 := l_v___3 - 1
								l_mask___3 := (-(l_p___3 >= l_new_dp[l_qn]).to_integer).to_integer.to_natural_32
								l_p___3 := l_p___3 - (l_new_dp[l_qn])
								l_v___3 := l_v___3 + l_mask___3
								l_p___3 := l_p___3 - ((l_mask___3).bit_and (l_new_dp[l_qn]))
							end
							asm112 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_t0___3), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t1___3), l_new_dp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_qn), create {CE_POINTER [NATURAL_32]}.make_shared ($l_v___3))
							l_p___3 := l_p___3 + l_t1___3
							if l_p___3 < l_t1___3 then
								l_v___3 := l_v___3 - 1
								if (builtin_expect ((l_p___3 >= l_new_dp[l_qn]).to_integer, 0)).to_boolean then
									if l_p___3 > l_new_dp[l_qn] then
										l_v___3 := l_v___3 - 1
									elseif l_t0___3 >= l_new_dp[(l_qn - 1)] then
										l_v___3 := l_v___3 - 1
									end
								end
							end
							l_dinv.inv32 := l_v___3
							js.break
						end
						js.reset
						l_qh := sbpi1_divappr_q_inst.gmpn_sbpi1_divappr_q (l_tp, l_new_np, l_new_nn, l_new_dp, l_qn + 1, l_dinv.inv32)
				when 83 then -- if done
						if l_cy = {NATURAL_32} 0 then
							l_tp[l_qn] := l_qh
						elseif (builtin_expect ((l_qh /= {NATURAL_32} 0).to_integer, 0)).to_boolean then
							l_n___0 := l_new_nn - (l_qn + 1)
							l_i___0 := (0).to_integer_32
							from
							until
								not (l_i___0 < l_n___0)
							loop
								l_tp[l_i___0] := {NATURAL_32} 4294967295
								l_i___0 := l_i___0 + 1
							end
							l_qh := (0).to_natural_32
						end
				when 84 then -- if block done, skip else block:
						l_pos := -1 + 99
				when 85 then -- else:
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (l_new_np, (a_np + a_nn) - l_new_nn, l_new_nn)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
						l_new_dp.ce_gets ((a_dp + a_dn) - (l_qn + 1))
						if l_qn /= 1 then
							l_pos := -1 + 88 -- skip if block
						end
				when 86 then -- if:
						l_qh := gmp_inst.gmpn_divrem_2 (l_tp, 0, l_new_np, l_new_nn, l_new_dp)
				when 87 then -- if block done, skip else block:
						l_pos := -1 + 98
				when 88 then -- else:
						if 55 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 97 -- skip if block
						end
				when 89 then -- if:
						if not (l_qn >= 55) then
							l_pos := -1 + 95 -- skip if block
						end
				when 90 then -- if:
						if 997 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 93 -- skip if block
						end
				when 91 then -- if:
						if l_qn >= 997 then
							l_itch___2 := (mu_divappr_q_inst.gmpn_mu_divappr_q_itch (l_new_nn, l_qn + 1, 0))
							if (builtin_expect ((l_itch___2.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
								l_tmp___52.ce_gets ((l_aaf.new ((l_itch___2.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							else
								l_tmp___52.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_itch___2.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							l_scratch___3.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___52))
							l_qh := mu_divappr_q_inst.gmpn_mu_divappr_q (l_tp, l_new_np, l_new_nn, l_new_dp, l_qn + 1, l_scratch___3)
						else
							l_pos := -1 + 93 -- goto _L___7
						end
				when 92 then -- if block done, skip else block:
						l_pos := -1 + 94
				when 93 then -- else: | _L___7:
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								l_v___6 := gmp_impl_inst.gmpn_invert_limb (l_dh)
								js.break
							end
							js.reset
							l_p___6 := l_dh * l_v___6
							l_p___6 := l_p___6 + (l_new_dp[(l_qn - 1)])
							if l_p___6 < l_new_dp[(l_qn - 1)] then
								l_v___6 := l_v___6 - 1
								l_mask___6 := (-(l_p___6 >= l_dh).to_integer).to_integer.to_natural_32
								l_p___6 := l_p___6 - l_dh
								l_v___6 := l_v___6 + l_mask___6
								l_p___6 := l_p___6 - ((l_mask___6).bit_and (l_dh))
							end
							asm113 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_t0___6), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t1___6), l_new_dp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_qn), create {CE_POINTER [NATURAL_32]}.make_shared ($l_v___6))
							l_p___6 := l_p___6 + l_t1___6
							if l_p___6 < l_t1___6 then
								l_v___6 := l_v___6 - 1
								if (builtin_expect ((l_p___6 >= l_dh).to_integer, 0)).to_boolean then
									if l_p___6 > l_dh then
										l_v___6 := l_v___6 - 1
									elseif l_t0___6 >= l_new_dp[(l_qn - 1)] then
										l_v___6 := l_v___6 - 1
									end
								end
							end
							l_dinv.inv32 := l_v___6
							js.break
						end
						js.reset
						l_qh := dcpi1_divappr_q_inst.gmpn_dcpi1_divappr_q (l_tp, l_new_np, l_new_nn, l_new_dp, l_qn + 1, l_dinv.address)
				when 94 then -- if done | if block done, skip else block:
						l_pos := -1 + 96
				when 95 then -- else:
						l_pos := -1 + 97 -- goto _L___8
				when 96 then -- if done | if block done, skip else block:
						l_pos := -1 + 98
				when 97 then -- else: | _L___8:
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								l_v___5 := gmp_impl_inst.gmpn_invert_limb (l_dh)
								js.break
							end
							js.reset
							l_p___5 := l_dh * l_v___5
							l_p___5 := l_p___5 + (l_new_dp[(l_qn - 1)])
							if l_p___5 < l_new_dp[(l_qn - 1)] then
								l_v___5 := l_v___5 - 1
								l_mask___5 := (-(l_p___5 >= l_dh).to_integer).to_integer.to_natural_32
								l_p___5 := l_p___5 - l_dh
								l_v___5 := l_v___5 + l_mask___5
								l_p___5 := l_p___5 - ((l_mask___5).bit_and (l_dh))
							end
							asm114 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_t0___5), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t1___5), l_new_dp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_qn), create {CE_POINTER [NATURAL_32]}.make_shared ($l_v___5))
							l_p___5 := l_p___5 + l_t1___5
							if l_p___5 < l_t1___5 then
								l_v___5 := l_v___5 - 1
								if (builtin_expect ((l_p___5 >= l_dh).to_integer, 0)).to_boolean then
									if l_p___5 > l_dh then
										l_v___5 := l_v___5 - 1
									elseif l_t0___5 >= l_new_dp[(l_qn - 1)] then
										l_v___5 := l_v___5 - 1
									end
								end
							end
							l_dinv.inv32 := l_v___5
							js.break
						end
						js.reset
						l_qh := sbpi1_divappr_q_inst.gmpn_sbpi1_divappr_q (l_tp, l_new_np, l_new_nn, l_new_dp, l_qn + 1, l_dinv.inv32)
				when 98 then -- if done
						l_tp[l_qn] := l_qh
				when 99 then -- if done
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (a_qp, (l_tp + 1), l_qn)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
						if not (l_tp[0] <= {NATURAL_32} 4) then
							l_pos := -1 + 105 -- skip if block
						end
				when 100 then -- if:
						if (builtin_expect (((a_dn + l_qn).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___58.ce_gets ((l_aaf.new (((a_dn + l_qn).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___58.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((a_dn + l_qn).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_rp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___58))
						mul_inst.gmpn_mul (l_rp, a_dp, a_dn, (l_tp + 1), l_qn).do_nothing
						l_rn := a_dn + l_qn
						l_rn := l_rn - (l_rp[(l_rn - 1)] = {NATURAL_32} 0).to_integer
						if not (l_rn > a_nn) then
							l_pos := -1 + 103 -- skip if block
						end
				when 101 then -- if:
						l_pos := -1 + 104 -- goto _L___9
				when 102 then -- if block done, skip else block:
						l_pos := -1 + 105
				when 103 then -- else:
						if not ((gmp_inst.gmpn_cmp (a_np, l_rp, a_nn)) < 0) then
							l_pos := -1 + 105 -- skip if block
						end
				when 104 then -- if: | _L___9:
						from
						until
							js.loop_left
						loop
							js.reset
							asm115 (l_ptr_dummy.address, a_qp.address)
							js.break
						end
						js.reset
				when 105 then -- if done | if done | if done
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
							end
							js.break
						end
						js.reset
				when 106 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
