class
	P_DIV_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_div_ui (a_r: CE_POINTER [PD_MPF_STRUCT]; a_u: CE_POINTER [PD_MPF_STRUCT]; a_v: NATURAL_32)
		local
			l_up: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_rtp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_rsize: INTEGER_32
			l_tsize: INTEGER_32
			l_sign_quotient: INTEGER_32
			l_prec: INTEGER_32
			l_q_limb: NATURAL_32
			l_rexp: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp___2: CE_POINTER [ANY]
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp___4: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_up.make
			create l_rp.make
			create l_tp.make
			create l_rtp.make
			create l_tmp_marker.make
			create l_tmp___2.make
			create l_dst.make
			create l_tmp___4.make

			l_usize := (a_u.item.mp_size).to_integer_32
			l_sign_quotient := l_usize
			if l_usize >= 0 then
				l_usize := l_usize
			else
				l_usize := -l_usize
			end
			l_prec := (a_r.item.mp_prec).to_integer_32
			if a_v = {NATURAL_32} 0 then
				errno_inst.gmp_divide_by_zero
			end
			if l_usize = 0 then
				a_r.item.mp_size := 0
				a_r.item.mp_exp := (0).to_integer_32
				js.return
			end
			if not js.return_called then
				l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
				l_rp.ce_gets (a_r.item.mp_d)
				l_up.ce_gets (a_u.item.mp_d)
				l_tsize := 1 + l_prec
				if (builtin_expect (((l_tsize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
					l_tmp___2.ce_gets ((l_aaf.new (((l_tsize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				else
					l_tmp___2.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((l_tsize + 1).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				end
				l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2))
				if l_usize > l_tsize then
					l_up.ce_gets (l_up + (l_usize - l_tsize))
					l_usize := l_tsize
					l_rtp.ce_gets (l_tp)
				else
					from
					until
						js.loop_left
					loop
						js.reset
						if l_tsize - l_usize /= 0 then
							l_dst.ce_gets (l_tp)
							l_n := l_tsize - l_usize
							from
							until
								js.loop_left
							loop
								js.reset
								l_tmp___4.ce_gets (l_dst)
								l_dst.ce_gets (l_dst + 1)
								l_tmp___4.item := (0).to_natural_32
								l_n := l_n - 1
								if not l_n.to_boolean then
									js.break
								end
							end
							js.reset
						end
						js.break
					end
					js.reset
					l_rtp.ce_gets (l_tp + (l_tsize - l_usize))
				end
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						gmp_inst.gmpn_copyi (l_rtp, l_up, l_usize)
						js.break
					end
					js.reset
					js.break
				end
				js.reset
				gmp_inst.gmpn_divrem_1 (l_rp, (0).to_integer_32, l_tp, l_tsize, a_v).do_nothing
				l_q_limb := l_rp[(l_tsize - 1)]
				l_rsize := l_tsize - (l_q_limb = {NATURAL_32} 0).to_integer
				l_rexp := (a_u.item.mp_exp - (l_q_limb = {NATURAL_32} 0).to_integer)
				if l_sign_quotient >= 0 then
					a_r.item.mp_size := l_rsize.to_integer_32
				else
					a_r.item.mp_size := (-l_rsize).to_integer_32
				end
				a_r.item.mp_exp := l_rexp
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
					end
					js.break
				end
				js.reset
			end
		end

end
