class
	P_DOPRNT

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmp_doprnt (a_funs: CE_POINTER [PD_DOPRNT_FUNS_T]; a_data: CE_POINTER [ANY]; a_orig_fmt: CE_POINTER [INTEGER_8]; a_orig_ap: CE_VA_LIST): INTEGER_32
		local
			l_orig_ap: CE_VA_LIST
			l_ap: CE_VA_LIST
			l_this_ap: CE_VA_LIST
			l_last_ap: CE_VA_LIST
			l_alloc_fmt_size: NATURAL_32
			l_fmt: CE_POINTER [INTEGER_8]
			l_alloc_fmt: CE_POINTER [INTEGER_8]
			l_last_fmt: CE_POINTER [INTEGER_8]
			l_this_fmt: CE_POINTER [INTEGER_8]
			l_gmp_str: CE_POINTER [INTEGER_8]
			l_retval: INTEGER_32
			l_type: INTEGER_32
			l_fchar: INTEGER_32
			l_value: CE_POINTER [INTEGER_32]
			l_seen_precision: INTEGER_32
			l_param: PD_DOPRNT_PARAMS_T
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_64
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_64
			l_xp: CE_POINTER [NATURAL_32]
			l_xsize: INTEGER_32
			l_abs_xsize: INTEGER_32
			l_z: CE_ARRAY [PD_MPZ_STRUCT]
			l_ret: INTEGER_32
			l_tmp___7: INTEGER_64
			l_ret___0: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: NATURAL_32
			l_ret2: INTEGER_32
			l_ret___1: INTEGER_32
			l_ret___2: INTEGER_32
			l_tmp___13: INTEGER_32
			l_ret___3: INTEGER_32
			l_ret___4: INTEGER_32
			l_tmp___14: CE_POINTER [PD_MPF_STRUCT]
			l_tmp___16: REAL_96
			l_tmp___17: REAL_64
			l_p: CE_POINTER [ANY]
			l_ret___5: INTEGER_32
			l_n: INTEGER_32
			l_dst: CE_POINTER [NATURAL_32]
			l_n2: INTEGER_32
			l_tmp___18: CE_POINTER [NATURAL_32]
			l_tmp___19: CE_POINTER [ANY]
			l_n___0: INTEGER_32
			l_n___1: INTEGER_32
			l_tmp___21: CE_POINTER [INTEGER_8]
			l_ret___6: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fmt.make
			create l_alloc_fmt.make
			create l_last_fmt.make
			create l_this_fmt.make
			create l_gmp_str.make
			create l_value.make
			create l_param.make
			create l_tmp___1.make
			create l_xp.make
			create l_z.make (<<1>>)
			create l_tmp___14.make
			create l_p.make
			create l_dst.make
			create l_tmp___18.make
			create l_tmp___19.make
			create l_tmp___21.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					create l_orig_ap.make_copy (a_orig_ap)
					l_retval := 0
					create l_ap.make_copy (l_orig_ap)
					l_alloc_fmt_size := (strlen (a_orig_fmt)) + {NATURAL_32} 1
					l_alloc_fmt.ce_gets (create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([l_alloc_fmt_size * Integer_8_bytes.to_natural_32])))))
					l_fmt.ce_gets (l_alloc_fmt)
					strcpy (l_fmt, a_orig_fmt).do_nothing
					l_last_fmt.ce_gets (l_fmt)
					create l_last_ap.make_copy (l_ap)
				when 1 then -- loop condition:
					if js.loop_left then
						l_pos := -1 + 143 -- skip loop
					end
				when 2 then -- loop body:
						js.reset
						l_fmt.ce_gets (strchr (l_fmt, ('%%').code))
						if (l_fmt.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 142 -- skip if block
						end
				when 3 then -- if:
						l_this_fmt.ce_gets (l_fmt)
						create l_this_ap.make_copy (l_ap)
						l_fmt.ce_gets (l_fmt + 1)
						l_type := ('%/0/').code
						l_value.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared (l_param.c_pointer + {PD_DOPRNT_PARAMS_T}.width_offset))
						l_param.base := 10
						l_param.conv := 0
						l_param.expfmt := ce_string ("e%%c%%02ld")
						l_param.exptimes4 := 0
						l_param.fill := ((' ').code).to_integer_8
						l_param.justify := 2
						l_param.prec := 6
						l_param.showbase := 2
						l_param.showpoint := 0
						l_param.showtrailing := 1
						l_param.sign := (('%/0/').code).to_integer_8
						l_param.width := 0
						l_seen_precision := 0
				when 4 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 140 -- skip loop
						end
				when 5 then -- loop body:
						js.reset
						l_tmp___1.ce_gets (l_fmt)
						l_fmt.ce_gets (l_fmt + 1)
						l_fchar := (l_tmp___1[0]).to_integer_32
						if l_fchar = 0 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 139 -- skip if block
						end
				when 6 then -- if:
						inspect l_fchar -- switch 1 head
						when 97 then l_pos := -1 + 7
						when 65 then l_pos := -1 + 8
						when 99 then l_pos := -1 + 10
						when 100 then l_pos := -1 + 11
						when 105 then l_pos := -1 + 11
						when 117 then l_pos := -1 + 11
						when 69 then l_pos := -1 + 64
						when 101 then l_pos := -1 + 65
						when 102 then l_pos := -1 + 88
						when 70 then l_pos := -1 + 89
						when 106 then l_pos := -1 + 89
						when 76 then l_pos := -1 + 89
						when 78 then l_pos := -1 + 89
						when 113 then l_pos := -1 + 89
						when 81 then l_pos := -1 + 89
						when 116 then l_pos := -1 + 89
						when 122 then l_pos := -1 + 89
						when 90 then l_pos := -1 + 89
						when 71 then l_pos := -1 + 90
						when 103 then l_pos := -1 + 91
						when 104 then l_pos := -1 + 92
						when 108 then l_pos := -1 + 94
						when 109 then l_pos := -1 + 96
						when 77 then l_pos := -1 + 97
						when 110 then l_pos := -1 + 98
						when 111 then l_pos := -1 + 125
						when 112 then l_pos := -1 + 126
						when 115 then l_pos := -1 + 126
						when 120 then l_pos := -1 + 127
						when 88 then l_pos := -1 + 128
						when 37 then l_pos := -1 + 129
						when 35 then l_pos := -1 + 130
						when 39 then l_pos := -1 + 131
						when 43 then l_pos := -1 + 132
						when 32 then l_pos := -1 + 132
						when 45 then l_pos := -1 + 133
						when 46 then l_pos := -1 + 134
						when 42 then l_pos := -1 + 135
						when 48 then l_pos := -1 + 136
						when 49 then l_pos := -1 + 137
						when 50 then l_pos := -1 + 137
						when 51 then l_pos := -1 + 137
						when 52 then l_pos := -1 + 137
						when 53 then l_pos := -1 + 137
						when 54 then l_pos := -1 + 137
						when 55 then l_pos := -1 + 137
						when 56 then l_pos := -1 + 137
						when 57 then l_pos := -1 + 137
						else l_pos := -1 + 138
						end
				when 7 then -- switch 1, case 97
						l_param.base := 16
						l_param.expfmt := ce_string ("p%%c%%ld")
						l_pos := -1 + 9 -- goto conv_a
				when 8 then -- switch 1, case 65
						l_param.base := -16
						l_param.expfmt := ce_string ("P%%c%%ld")
				when 9 then -- conv_a:
						l_param.conv := 2
						l_param.exptimes4 := 1
						if not l_seen_precision.to_boolean then
							l_param.prec := -1
						end
						l_param.showbase := 1
						l_param.showtrailing := 1
						l_pos := -1 + 67 -- goto floating_a
				when 10 then -- switch 1, case 99
						l_tmp___2 := l_ap.integer_32_item
						l_pos := -1 + 141 -- goto next
				when 11 then -- integer: | switch 1, case 100 | switch 1, case 105 | switch 1, case 117
						
						if not l_seen_precision.to_boolean then
							l_param.prec := -1
						end
						inspect l_type -- switch 2 head
						when 106 then l_pos := -1 + 12
						when 108 then l_pos := -1 + 13
						when 76 then l_pos := -1 + 14
						when 78 then l_pos := -1 + 15
						when 113 then l_pos := -1 + 28
						when 81 then l_pos := -1 + 29
						when 116 then l_pos := -1 + 42
						when 122 then l_pos := -1 + 43
						when 90 then l_pos := -1 + 44
						else l_pos := -1 + 62
						end
				when 12 then -- switch 2, case 106
						l_tmp___3 := l_ap.integer_64_item
						l_pos := -1 + 63 -- switch 2; break
				when 13 then -- switch 2, case 108
						l_tmp___4 := l_ap.integer_32_item
						l_pos := -1 + 63 -- switch 2; break
				when 14 then -- switch 2, case 76
						l_tmp___5 := l_ap.integer_64_item
						l_pos := -1 + 63 -- switch 2; break
				when 15 then -- switch 2, case 78
						if js.loop_left then
							l_pos := -1 + 27 -- skip loop
						end
				when 16 then -- loop body:
						js.reset
						if (l_this_fmt.c_pointer.to_integer_32).to_natural_32 /= (l_last_fmt.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | if block done, skip else block:
						l_pos := -1 + 26
				when 18 then -- else:
						l_this_fmt[0] := (('%/0/').code).to_integer_8
				when 19 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 25 -- skip loop
						end
				when 20 then -- loop body:
						js.reset
				when 21 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 24 -- skip loop
						end
				when 22 then -- loop body:
						js.reset
						l_ret := (a_funs.item.format).integer_32_item ([a_data, l_last_fmt, l_last_ap])
						if l_ret = -1 then
							l_pos := -1 + 153 -- goto error
						end
				when 23 then
						l_retval := l_retval + l_ret
						js.break
						l_pos := -1 + 21 -- back to loop condition
				when 24 then -- loop done
						js.reset
						js.break
						l_pos := -1 + 19 -- back to loop condition
				when 25 then -- loop done
						js.reset
				when 26 then -- if done
						js.break
						l_pos := -1 + 15 -- back to loop condition
				when 27 then -- loop done
						js.reset
						l_xp.ce_gets ((create {CE_POINTER [NATURAL_32]}.make_cast (l_ap.pointer_item)))
						l_z[0].mp_d := l_xp
						l_xsize := (l_ap.integer_32_item)
						if l_xsize >= 0 then
							l_abs_xsize := l_xsize
						else
							l_abs_xsize := -l_xsize
						end
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								not (not js.loop_left and then (l_abs_xsize > 0))
							loop
								js.reset
								if l_xp[(l_abs_xsize - 1)] /= {NATURAL_32} 0 then
									js.break
								end
								if not js.loop_jumped then
									l_abs_xsize := l_abs_xsize - 1
								end
							end
							js.reset
							js.break
						end
						js.reset
						if l_xsize >= 0 then
							l_z[0].mp_size := l_abs_xsize.to_integer_32
						else
							l_z[0].mp_size := (-l_abs_xsize).to_integer_32
						end
						l_gmp_str.ce_gets (get_str_inst.gmpz_get_str (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), l_param.base, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_z)))
						l_pos := -1 + 57 -- goto gmp_integer
				when 28 then -- switch 2, case 113
						l_tmp___7 := l_ap.integer_64_item
						l_pos := -1 + 63 -- switch 2; break
				when 29 then -- switch 2, case 81
						if js.loop_left then
							l_pos := -1 + 41 -- skip loop
						end
				when 30 then -- loop body:
						js.reset
						if (l_this_fmt.c_pointer.to_integer_32).to_natural_32 /= (l_last_fmt.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 32 -- skip if block
						end
				when 31 then -- if: | if block done, skip else block:
						l_pos := -1 + 40
				when 32 then -- else:
						l_this_fmt[0] := (('%/0/').code).to_integer_8
				when 33 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 39 -- skip loop
						end
				when 34 then -- loop body:
						js.reset
				when 35 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 38 -- skip loop
						end
				when 36 then -- loop body:
						js.reset
						l_ret___0 := (a_funs.item.format).integer_32_item ([a_data, l_last_fmt, l_last_ap])
						if l_ret___0 = -1 then
							l_pos := -1 + 153 -- goto error
						end
				when 37 then
						l_retval := l_retval + l_ret___0
						js.break
						l_pos := -1 + 35 -- back to loop condition
				when 38 then -- loop done
						js.reset
						js.break
						l_pos := -1 + 33 -- back to loop condition
				when 39 then -- loop done
						js.reset
				when 40 then -- if done
						js.break
						l_pos := -1 + 29 -- back to loop condition
				when 41 then -- loop done
						js.reset
						l_gmp_str.ce_gets (get_str_inst.gmpq_get_str (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), l_param.base, (create {CE_POINTER [PD_MPQ_STRUCT]}.make_cast (l_ap.pointer_item))))
						l_pos := -1 + 57 -- goto gmp_integer
				when 42 then -- switch 2, case 116
						l_tmp___9 := l_ap.integer_32_item
						l_pos := -1 + 63 -- switch 2; break
				when 43 then -- switch 2, case 122
						l_tmp___10 := l_ap.natural_32_item
						l_pos := -1 + 63 -- switch 2; break
				when 44 then -- switch 2, case 90
						if js.loop_left then
							l_pos := -1 + 56 -- skip loop
						end
				when 45 then -- loop body:
						js.reset
						if (l_this_fmt.c_pointer.to_integer_32).to_natural_32 /= (l_last_fmt.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 47 -- skip if block
						end
				when 46 then -- if: | if block done, skip else block:
						l_pos := -1 + 55
				when 47 then -- else:
						l_this_fmt[0] := (('%/0/').code).to_integer_8
				when 48 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 54 -- skip loop
						end
				when 49 then -- loop body:
						js.reset
				when 50 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 53 -- skip loop
						end
				when 51 then -- loop body:
						js.reset
						l_ret___1 := (a_funs.item.format).integer_32_item ([a_data, l_last_fmt, l_last_ap])
						if l_ret___1 = -1 then
							l_pos := -1 + 153 -- goto error
						end
				when 52 then
						l_retval := l_retval + l_ret___1
						js.break
						l_pos := -1 + 50 -- back to loop condition
				when 53 then -- loop done
						js.reset
						js.break
						l_pos := -1 + 48 -- back to loop condition
				when 54 then -- loop done
						js.reset
				when 55 then -- if done
						js.break
						l_pos := -1 + 44 -- back to loop condition
				when 56 then -- loop done
						js.reset
						l_gmp_str.ce_gets (get_str_inst.gmpz_get_str (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), l_param.base, (create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_ap.pointer_item))))
				when 57 then -- gmp_integer:
						l_ret2 := doprnti_inst.gmp_doprnt_integer (a_funs, a_data, (l_param.address), l_gmp_str)
						memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (l_gmp_str), (strlen (l_gmp_str)) + {NATURAL_32} 1])
				when 58 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 61 -- skip loop
						end
				when 59 then -- loop body:
						js.reset
						l_ret___2 := l_ret2
						if l_ret___2 = -1 then
							l_pos := -1 + 153 -- goto error
						end
				when 60 then
						l_retval := l_retval + l_ret___2
						js.break
						l_pos := -1 + 58 -- back to loop condition
				when 61 then -- loop done
						js.reset
						create l_last_ap.make_copy (l_ap)
						l_last_fmt.ce_gets (l_fmt)
						l_pos := -1 + 63 -- switch 2; break
				when 62 then -- switch 2, default:
						l_tmp___13 := l_ap.integer_32_item
						l_pos := -1 + 63 -- switch 2; break
				when 63 then -- switch 2, done:
						l_pos := -1 + 141 -- goto next
				when 64 then -- switch 1, case 69
						l_param.base := -10
						l_param.expfmt := ce_string ("E%%c%%02ld")
				when 65 then -- switch 1, case 101
						l_param.conv := 2
				when 66 then -- floating:
						if l_param.showbase = 3 then
							l_param.showpoint := 1
							l_param.showtrailing := 1
						end
				when 67 then -- floating_a:
						inspect l_type -- switch 3 head
						when 70 then l_pos := -1 + 68
						when 76 then l_pos := -1 + 85
						else l_pos := -1 + 86
						end
				when 68 then -- switch 3, case 70
						if js.loop_left then
							l_pos := -1 + 80 -- skip loop
						end
				when 69 then -- loop body:
						js.reset
						if (l_this_fmt.c_pointer.to_integer_32).to_natural_32 /= (l_last_fmt.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 71 -- skip if block
						end
				when 70 then -- if: | if block done, skip else block:
						l_pos := -1 + 79
				when 71 then -- else:
						l_this_fmt[0] := (('%/0/').code).to_integer_8
				when 72 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 78 -- skip loop
						end
				when 73 then -- loop body:
						js.reset
				when 74 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 77 -- skip loop
						end
				when 75 then -- loop body:
						js.reset
						l_ret___3 := (a_funs.item.format).integer_32_item ([a_data, l_last_fmt, l_last_ap])
						if l_ret___3 = -1 then
							l_pos := -1 + 153 -- goto error
						end
				when 76 then
						l_retval := l_retval + l_ret___3
						js.break
						l_pos := -1 + 74 -- back to loop condition
				when 77 then -- loop done
						js.reset
						js.break
						l_pos := -1 + 72 -- back to loop condition
				when 78 then -- loop done
						js.reset
				when 79 then -- if done
						js.break
						l_pos := -1 + 68 -- back to loop condition
				when 80 then -- loop done
						js.reset
				when 81 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 84 -- skip loop
						end
				when 82 then -- loop body:
						js.reset
						l_tmp___14.ce_gets ((create {CE_POINTER [PD_MPF_STRUCT]}.make_cast (l_ap.pointer_item)))
						l_ret___4 := doprntf_inst.gmp_doprnt_mpf2 (a_funs, a_data, (l_param.address), (nl_langinfo (65536)), l_tmp___14)
						if l_ret___4 = -1 then
							l_pos := -1 + 153 -- goto error
						end
				when 83 then
						l_retval := l_retval + l_ret___4
						js.break
						l_pos := -1 + 81 -- back to loop condition
				when 84 then -- loop done
						js.reset
						create l_last_ap.make_copy (l_ap)
						l_last_fmt.ce_gets (l_fmt)
						l_pos := -1 + 87 -- switch 3; break
				when 85 then -- switch 3, case 76
						l_tmp___16 := l_ap.real_96_item
						l_pos := -1 + 87 -- switch 3; break
				when 86 then -- switch 3, default:
						l_tmp___17 := l_ap.real_64_item
						l_pos := -1 + 87 -- switch 3; break
				when 87 then -- switch 3, done:
						l_pos := -1 + 141 -- goto next
				when 88 then -- switch 1, case 102
						l_param.conv := 1
						l_pos := -1 + 66 -- goto floating
				when 89 then -- set_type: | switch 1, case 70 | switch 1, case 106 | switch 1, case 76 | switch 1, case 78 | switch 1, case 113 | switch 1, case 81 | switch 1, case 116 | switch 1, case 122 | switch 1, case 90
						l_type := l_fchar
						l_pos := -1 + 139 -- switch 1; break
				when 90 then -- switch 1, case 71
						l_param.base := -10
						l_param.expfmt := ce_string ("E%%c%%02ld")
				when 91 then -- switch 1, case 103
						l_param.conv := 3
						l_param.showtrailing := 0
						l_pos := -1 + 66 -- goto floating
				when 92 then -- switch 1, case 104
						if l_type /= 104 then
							l_pos := -1 + 89 -- goto set_type
						end
				when 93 then
						l_type := ('H').code
						l_pos := -1 + 139 -- switch 1; break
				when 94 then -- switch 1, case 108
						if l_type /= 108 then
							l_pos := -1 + 89 -- goto set_type
						end
				when 95 then
						l_type := ('L').code
						l_pos := -1 + 139 -- switch 1; break
				when 96 then -- switch 1, case 109
						l_pos := -1 + 141 -- goto next
				when 97 then -- switch 1, case 77
						l_fmt[-1] := (('l').code).to_integer_8
						l_type := ('l').code
						l_pos := -1 + 139 -- switch 1; break
				when 98 then -- switch 1, case 110
						if js.loop_left then
							l_pos := -1 + 110 -- skip loop
						end
				when 99 then -- loop body:
						js.reset
						if (l_this_fmt.c_pointer.to_integer_32).to_natural_32 /= (l_last_fmt.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 101 -- skip if block
						end
				when 100 then -- if: | if block done, skip else block:
						l_pos := -1 + 109
				when 101 then -- else:
						l_this_fmt[0] := (('%/0/').code).to_integer_8
				when 102 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 108 -- skip loop
						end
				when 103 then -- loop body:
						js.reset
				when 104 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 107 -- skip loop
						end
				when 105 then -- loop body:
						js.reset
						l_ret___5 := (a_funs.item.format).integer_32_item ([a_data, l_last_fmt, l_last_ap])
						if l_ret___5 = -1 then
							l_pos := -1 + 153 -- goto error
						end
				when 106 then
						l_retval := l_retval + l_ret___5
						js.break
						l_pos := -1 + 104 -- back to loop condition
				when 107 then -- loop done
						js.reset
						js.break
						l_pos := -1 + 102 -- back to loop condition
				when 108 then -- loop done
						js.reset
				when 109 then -- if done
						js.break
						l_pos := -1 + 98 -- back to loop condition
				when 110 then -- loop done
						js.reset
						l_p.ce_gets ((create {CE_POINTER [ANY]}.make_cast (l_ap.pointer_item)))
						inspect l_type -- switch 4 head
						when 0 then l_pos := -1 + 111
						when 70 then l_pos := -1 + 112
						when 72 then l_pos := -1 + 113
						when 104 then l_pos := -1 + 114
						when 106 then l_pos := -1 + 115
						when 108 then l_pos := -1 + 116
						when 113 then l_pos := -1 + 117
						when 76 then l_pos := -1 + 118
						when 78 then l_pos := -1 + 119
						when 81 then l_pos := -1 + 120
						when 116 then l_pos := -1 + 121
						when 122 then l_pos := -1 + 122
						when 90 then l_pos := -1 + 123
						else l_pos := -1 + 124
						end
				when 111 then -- switch 4, case 0;
						(create {CE_POINTER [INTEGER_32]}.make_cast (l_p)).item := l_retval
						l_pos := -1 + 124 -- switch 4; break
				when 112 then -- switch 4, case 70
						set_si_inst.gmpf_set_si (create {CE_POINTER [PD_MPF_STRUCT]}.make_cast (l_p), l_retval.to_integer_32)
						l_pos := -1 + 124 -- switch 4; break
				when 113 then -- switch 4, case 72;
						(create {CE_POINTER [INTEGER_8]}.make_cast (l_p)).item := l_retval.to_integer_8
						l_pos := -1 + 124 -- switch 4; break
				when 114 then -- switch 4, case 104;
						(create {CE_POINTER [INTEGER_16]}.make_cast (l_p)).item := l_retval.to_integer_16
						l_pos := -1 + 124 -- switch 4; break
				when 115 then -- switch 4, case 106;
						(create {CE_POINTER [INTEGER_64]}.make_cast (l_p)).item := l_retval.to_integer_64
						l_pos := -1 + 124 -- switch 4; break
				when 116 then -- switch 4, case 108;
						(create {CE_POINTER [INTEGER_32]}.make_cast (l_p)).item := l_retval.to_integer_32
						l_pos := -1 + 124 -- switch 4; break
				when 117 then -- switch 4, case 113
						from
						until
							js.loop_left
						loop
							js.reset
							if Integer_64_bytes.to_natural_32 /= Integer_64_bytes.to_natural_32 then
								assert_inst.gmp_assert_fail (ce_string ("doprnt.c"), 461, ce_string ("sizeof (quad_t) == sizeof (long long)"))
							end
							js.break
						end
						js.reset
				when 118 then -- switch 4, case 76;
						(create {CE_POINTER [INTEGER_64]}.make_cast (l_p)).item := l_retval.to_integer_64
						l_pos := -1 + 124 -- switch 4; break
				when 119 then -- switch 4, case 78
						l_n := l_ap.integer_32_item
						if l_n >= 0 then
							l_n := l_n
						else
							l_n := -l_n
						end
						if l_n /= 0 then
							(create {CE_POINTER [NATURAL_32]}.make_cast (l_p)).item := l_retval.to_natural_32
							from
							until
								js.loop_left
							loop
								js.reset
								if l_n - 1 /= 0 then
									l_dst.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_p) + 1)
									l_n2 := l_n - 1
									from
									until
										js.loop_left
									loop
										js.reset
										l_tmp___18.ce_gets (l_dst)
										l_dst.ce_gets (l_dst + 1)
										l_tmp___18.item := (0).to_natural_32
										l_n2 := l_n2 - 1
										if not l_n2.to_boolean then
											js.break
										end
									end
									js.reset
								end
								js.break
							end
							js.reset
						end
						l_pos := -1 + 124 -- switch 4; break
				when 120 then -- switch 4, case 81
						set_si_inst.gmpq_set_si (create {CE_POINTER [PD_MPQ_STRUCT]}.make_cast (l_p), l_retval.to_integer_32, {NATURAL_32} 1)
						l_pos := -1 + 124 -- switch 4; break
				when 121 then -- switch 4, case 116;
						(create {CE_POINTER [INTEGER_32]}.make_cast (l_p)).item := l_retval
						l_pos := -1 + 124 -- switch 4; break
				when 122 then -- switch 4, case 122;
						(create {CE_POINTER [NATURAL_32]}.make_cast (l_p)).item := l_retval.to_natural_32
						l_pos := -1 + 124 -- switch 4; break
				when 123 then -- switch 4, case 90
						set_si_inst.gmpz_set_si (create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_p), l_retval.to_integer_32)
						l_pos := -1 + 124 -- switch 4; break
				when 124 then -- switch 4, done:
						create l_last_ap.make_copy (l_ap)
						l_last_fmt.ce_gets (l_fmt)
						l_pos := -1 + 141 -- goto next
				when 125 then -- switch 1, case 111
						l_param.base := 8
						l_pos := -1 + 11 -- goto integer
				when 126 then -- switch 1, case 112 | switch 1, case 115
						l_tmp___19.ce_gets ((create {CE_POINTER [ANY]}.make_cast (l_ap.pointer_item)))
						l_pos := -1 + 141 -- goto next
				when 127 then -- switch 1, case 120
						l_param.base := 16
						l_pos := -1 + 11 -- goto integer
				when 128 then -- switch 1, case 88
						l_param.base := -16
						l_pos := -1 + 11 -- goto integer
				when 129 then -- switch 1, case 37
						l_pos := -1 + 141 -- goto next
				when 130 then -- switch 1, case 35
						l_param.showbase := 3
						l_pos := -1 + 139 -- switch 1; break
				when 131 then -- switch 1, case 39
						l_pos := -1 + 139 -- switch 1; break
				when 132 then -- switch 1, case 43 | switch 1, case 32
						l_param.sign := l_fchar.to_integer_8
						l_pos := -1 + 139 -- switch 1; break
				when 133 then -- switch 1, case 45
						l_param.justify := 1
						l_pos := -1 + 139 -- switch 1; break
				when 134 then -- switch 1, case 46
						l_seen_precision := 1
						l_param.prec := -1
						l_value.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared (l_param.c_pointer + {PD_DOPRNT_PARAMS_T}.prec_offset))
						l_pos := -1 + 139 -- switch 1; break
				when 135 then -- switch 1, case 42
						l_n___0 := (l_ap.integer_32_item)
						if (l_value.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [INTEGER_32]}.make_shared (l_param.c_pointer + {PD_DOPRNT_PARAMS_T}.width_offset)).c_pointer.to_integer_32).to_natural_32 then
							if l_n___0 < 0 then
								l_param.justify := 1
								l_n___0 := -l_n___0
							end
							l_param.width := l_n___0
						elseif 0 > l_n___0 then
							l_param.prec := 0
						else
							l_param.prec := l_n___0
						end
						l_pos := -1 + 139 -- switch 1; break
				when 136 then -- switch 1, case 48
						if (l_value.c_pointer.to_integer_32).to_natural_32 = ((create {CE_POINTER [INTEGER_32]}.make_shared (l_param.c_pointer + {PD_DOPRNT_PARAMS_T}.width_offset)).c_pointer.to_integer_32).to_natural_32 then
							l_param.fill := (('0').code).to_integer_8
							if l_param.justify = 2 then
								l_param.justify := 3
							end
						else
							l_value.item := 0
						end
						l_pos := -1 + 139 -- switch 1; break
				when 137 then -- switch 1, case 49 | switch 1, case 50 | switch 1, case 51 | switch 1, case 52 | switch 1, case 53 | switch 1, case 54 | switch 1, case 55 | switch 1, case 56 | switch 1, case 57
						l_n___1 := 0
						from
						until
							js.loop_left
						loop
							js.reset
							l_n___1 := l_n___1 * 10 + (l_fchar - 48)
							l_tmp___21.ce_gets (l_fmt)
							l_fmt.ce_gets (l_fmt + 1)
							l_fchar := (l_tmp___21[0]).to_integer_32
							if ((l_fchar).bit_and (-128)) = 0 then
								if not ((((ctype_b_loc).item[l_fchar]).to_integer_32).bit_and (2048)).to_boolean then
									js.break
								end
							else
								js.break
							end
						end
						js.reset
						l_fmt.ce_gets (l_fmt - 1)
						l_value.item := l_n___1
						l_pos := -1 + 139 -- switch 1; break
				when 138 then -- switch 1, default:
						l_pos := -1 + 141 -- goto next
				when 139 then -- switch 1, done: | if done
						l_pos := -1 + 4 -- back to loop condition
				when 140 then -- loop done
						js.reset
				when 141 then -- next:
						
				when 142 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 143 then -- loop done
					js.reset
					if (l_last_fmt[0]).to_integer_32 = 0 then
						l_pos := -1 + 151 -- skip if block
					end
				when 144 then -- if: | loop condition:
						if js.loop_left then
							l_pos := -1 + 150 -- skip loop
						end
				when 145 then -- loop body:
						js.reset
				when 146 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 149 -- skip loop
						end
				when 147 then -- loop body:
						js.reset
						l_ret___6 := (a_funs.item.format).integer_32_item ([a_data, l_last_fmt, l_last_ap])
						if l_ret___6 = -1 then
							l_pos := -1 + 153 -- goto error
						end
				when 148 then
						l_retval := l_retval + l_ret___6
						js.break
						l_pos := -1 + 146 -- back to loop condition
				when 149 then -- loop done
						js.reset
						js.break
						l_pos := -1 + 144 -- back to loop condition
				when 150 then -- loop done
						js.reset
				when 151 then -- if done
					if ((a_funs.item.final).c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
						if ((a_funs.item.final).integer_32_item ([a_data])) = -1 then
							l_pos := -1 + 153 -- goto error
						end
					end
				when 152 then -- done:
					memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (l_alloc_fmt), l_alloc_fmt_size])
					Result := l_retval
					js.return
					if js.return_called then
						l_pos := -1 + 154 -- skip if block
					end
				when 153 then -- if: | error:
						l_retval := -1
						l_pos := -1 + 152 -- goto done
				when 154 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
