class
	P_DOPRNTI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmp_doprnt_integer (a_funs: CE_POINTER [PD_DOPRNT_FUNS_T]; a_data: CE_POINTER [ANY]; a_p: CE_POINTER [PD_DOPRNT_PARAMS_T]; a_s: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_s: CE_POINTER [INTEGER_8]
			l_retval: INTEGER_32
			l_slen: INTEGER_32
			l_justlen: INTEGER_32
			l_showbaselen: INTEGER_32
			l_sign: INTEGER_32
			l_signlen: INTEGER_32
			l_slashlen: INTEGER_32
			l_zeros: INTEGER_32
			l_justify: INTEGER_32
			l_den_showbaselen: INTEGER_32
			l_slash: CE_POINTER [INTEGER_8]
			l_showbase: CE_POINTER [INTEGER_8]
			l_ret: INTEGER_32
			l_ret___0: INTEGER_32
			l_ret___1: INTEGER_32
			l_ret___2: INTEGER_32
			l_ret___3: INTEGER_32
			l_ret___4: INTEGER_32
			l_ret___5: INTEGER_32
			l_ret___6: INTEGER_32
			l_ret___7: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_slash.make
			create l_showbase.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s.ce_gets (a_s)
					l_retval := 0
					l_sign := (a_p.item.sign).to_integer_32
					if (l_s[0]).to_integer_32 = 45 then
						l_sign := (l_s[0]).to_integer_32
						l_s.ce_gets (l_s + 1)
					end
					l_signlen := (l_sign /= 0).to_integer
					if (l_s[0]).to_integer_32 = 48 then
						if a_p.item.prec = 0 then
							l_s.ce_gets (l_s + 1)
						end
					end
					l_slen := (strlen (l_s)).to_integer_32
					l_slash.ce_gets ((strchr (l_s, ('/').code)))
					l_showbase.ce_gets (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					l_showbaselen := 0
					if a_p.item.showbase = 2 then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						inspect a_p.item.base -- switch 1 head
						when 16 then l_pos := -1 + 2
						when -16 then l_pos := -1 + 3
						when 8 then l_pos := -1 + 4
						else l_pos := -1 + 5
						end
				when 2 then -- switch 1, case 16
						l_showbase.ce_gets (ce_string ("0x"))
						l_showbaselen := 2
						l_pos := -1 + 5 -- switch 1; break
				when 3 then -- switch 1, case -16
						l_showbase.ce_gets (ce_string ("0X"))
						l_showbaselen := 2
						l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, case 8
						l_showbase.ce_gets (ce_string ("0"))
						l_showbaselen := 1
						l_pos := -1 + 5 -- switch 1; break
				when 5 then -- switch 1, done: | if done
						l_den_showbaselen := l_showbaselen
						if (l_slash.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							l_den_showbaselen := 0
						elseif a_p.item.showbase = 3 then
							if (l_slash[1]).to_integer_32 = 48 then
								l_den_showbaselen := 0
							end
						end
						if a_p.item.showbase = 3 then
							if (l_s[0]).to_integer_32 = 48 then
								l_showbaselen := 0
							end
						end
						if 0 > (a_p.item.prec - l_slen) then
							l_zeros := 0
						else
							l_zeros := (a_p.item.prec - l_slen)
						end
						l_justlen := ((a_p.item.width).to_natural_32 - (((((strlen (l_s)) + l_signlen.to_natural_32) + l_showbaselen.to_natural_32) + l_den_showbaselen.to_natural_32) + l_zeros.to_natural_32)).to_integer_32
						l_justify := a_p.item.justify
						if l_justlen <= 0 then
							l_justify := 0
						end
						if l_justify /= 2 then
							l_pos := -1 + 13 -- skip if block
						end
				when 6 then -- if: | loop condition:
							if js.loop_left then
								l_pos := -1 + 12 -- skip loop
							end
				when 7 then -- loop body:
							js.reset
				when 8 then -- loop condition:
							if js.loop_left then
								l_pos := -1 + 11 -- skip loop
							end
				when 9 then -- loop body:
							js.reset
							l_ret := (a_funs.item.reps).integer_32_item ([a_data, (a_p.item.fill).to_integer_32, l_justlen])
							if l_ret = -1 then
								l_pos := -1 + 84 -- goto error
							end
				when 10 then
							l_retval := l_retval + l_ret
							js.break
							l_pos := -1 + 8 -- back to loop condition
				when 11 then -- loop done
							js.reset
							js.break
							l_pos := -1 + 6 -- back to loop condition
				when 12 then -- loop done
							js.reset
				when 13 then -- if done
						if js.loop_left then
							l_pos := -1 + 23 -- skip loop
						end
				when 14 then -- loop body:
							js.reset
							if l_signlen = 0 then
								l_pos := -1 + 22 -- skip if block
							end
				when 15 then -- if: | loop condition:
							if js.loop_left then
								l_pos := -1 + 21 -- skip loop
							end
				when 16 then -- loop body:
							js.reset
				when 17 then -- loop condition:
							if js.loop_left then
								l_pos := -1 + 20 -- skip loop
							end
				when 18 then -- loop body:
							js.reset
							l_ret___0 := (a_funs.item.reps).integer_32_item ([a_data, l_sign, l_signlen])
							if l_ret___0 = -1 then
								l_pos := -1 + 84 -- goto error
							end
				when 19 then
							l_retval := l_retval + l_ret___0
							js.break
							l_pos := -1 + 17 -- back to loop condition
				when 20 then -- loop done
							js.reset
							js.break
							l_pos := -1 + 15 -- back to loop condition
				when 21 then -- loop done
							js.reset
				when 22 then -- if done
							js.break
							l_pos := -1 + 13 -- back to loop condition
				when 23 then -- loop done
						js.reset
				when 24 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 34 -- skip loop
						end
				when 25 then -- loop body:
							js.reset
							if l_showbaselen = 0 then
								l_pos := -1 + 33 -- skip if block
							end
				when 26 then -- if: | loop condition:
							if js.loop_left then
								l_pos := -1 + 32 -- skip loop
							end
				when 27 then -- loop body:
							js.reset
				when 28 then -- loop condition:
							if js.loop_left then
								l_pos := -1 + 31 -- skip loop
							end
				when 29 then -- loop body:
							js.reset
							l_ret___1 := (a_funs.item.memory).integer_32_item ([a_data, l_showbase, l_showbaselen.to_natural_32])
							if l_ret___1 = -1 then
								l_pos := -1 + 84 -- goto error
							end
				when 30 then
							l_retval := l_retval + l_ret___1
							js.break
							l_pos := -1 + 28 -- back to loop condition
				when 31 then -- loop done
							js.reset
							js.break
							l_pos := -1 + 26 -- back to loop condition
				when 32 then -- loop done
							js.reset
				when 33 then -- if done
							js.break
							l_pos := -1 + 24 -- back to loop condition
				when 34 then -- loop done
						js.reset
				when 35 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 45 -- skip loop
						end
				when 36 then -- loop body:
							js.reset
							if l_zeros = 0 then
								l_pos := -1 + 44 -- skip if block
							end
				when 37 then -- if: | loop condition:
							if js.loop_left then
								l_pos := -1 + 43 -- skip loop
							end
				when 38 then -- loop body:
							js.reset
				when 39 then -- loop condition:
							if js.loop_left then
								l_pos := -1 + 42 -- skip loop
							end
				when 40 then -- loop body:
							js.reset
							l_ret___2 := (a_funs.item.reps).integer_32_item ([a_data, ('0').code, l_zeros])
							if l_ret___2 = -1 then
								l_pos := -1 + 84 -- goto error
							end
				when 41 then
							l_retval := l_retval + l_ret___2
							js.break
							l_pos := -1 + 39 -- back to loop condition
				when 42 then -- loop done
							js.reset
							js.break
							l_pos := -1 + 37 -- back to loop condition
				when 43 then -- loop done
							js.reset
				when 44 then -- if done
							js.break
							l_pos := -1 + 35 -- back to loop condition
				when 45 then -- loop done
						js.reset
						if l_justify /= 3 then
							l_pos := -1 + 53 -- skip if block
						end
				when 46 then -- if: | loop condition:
							if js.loop_left then
								l_pos := -1 + 52 -- skip loop
							end
				when 47 then -- loop body:
							js.reset
				when 48 then -- loop condition:
							if js.loop_left then
								l_pos := -1 + 51 -- skip loop
							end
				when 49 then -- loop body:
							js.reset
							l_ret___3 := (a_funs.item.reps).integer_32_item ([a_data, (a_p.item.fill).to_integer_32, l_justlen])
							if l_ret___3 = -1 then
								l_pos := -1 + 84 -- goto error
							end
				when 50 then
							l_retval := l_retval + l_ret___3
							js.break
							l_pos := -1 + 48 -- back to loop condition
				when 51 then -- loop done
							js.reset
							js.break
							l_pos := -1 + 46 -- back to loop condition
				when 52 then -- loop done
							js.reset
				when 53 then -- if done
						if l_den_showbaselen = 0 then
							l_pos := -1 + 69 -- skip if block
						end
				when 54 then -- if:
							l_slashlen := (l_slash + 1).distance (l_s)
				when 55 then -- loop condition:
							if js.loop_left then
								l_pos := -1 + 61 -- skip loop
							end
				when 56 then -- loop body:
							js.reset
				when 57 then -- loop condition:
							if js.loop_left then
								l_pos := -1 + 60 -- skip loop
							end
				when 58 then -- loop body:
							js.reset
							l_ret___4 := (a_funs.item.memory).integer_32_item ([a_data, l_s, l_slashlen.to_natural_32])
							if l_ret___4 = -1 then
								l_pos := -1 + 84 -- goto error
							end
				when 59 then
							l_retval := l_retval + l_ret___4
							js.break
							l_pos := -1 + 57 -- back to loop condition
				when 60 then -- loop done
							js.reset
							js.break
							l_pos := -1 + 55 -- back to loop condition
				when 61 then -- loop done
							js.reset
							l_slen := l_slen - l_slashlen
							l_s.ce_gets (l_s + l_slashlen)
				when 62 then -- loop condition:
							if js.loop_left then
								l_pos := -1 + 68 -- skip loop
							end
				when 63 then -- loop body:
							js.reset
				when 64 then -- loop condition:
							if js.loop_left then
								l_pos := -1 + 67 -- skip loop
							end
				when 65 then -- loop body:
							js.reset
							l_ret___5 := (a_funs.item.memory).integer_32_item ([a_data, l_showbase, l_den_showbaselen.to_natural_32])
							if l_ret___5 = -1 then
								l_pos := -1 + 84 -- goto error
							end
				when 66 then
							l_retval := l_retval + l_ret___5
							js.break
							l_pos := -1 + 64 -- back to loop condition
				when 67 then -- loop done
							js.reset
							js.break
							l_pos := -1 + 62 -- back to loop condition
				when 68 then -- loop done
							js.reset
				when 69 then -- if done
						if js.loop_left then
							l_pos := -1 + 75 -- skip loop
						end
				when 70 then -- loop body:
							js.reset
				when 71 then -- loop condition:
							if js.loop_left then
								l_pos := -1 + 74 -- skip loop
							end
				when 72 then -- loop body:
							js.reset
							l_ret___6 := (a_funs.item.memory).integer_32_item ([a_data, l_s, l_slen.to_natural_32])
							if l_ret___6 = -1 then
								l_pos := -1 + 84 -- goto error
							end
				when 73 then
							l_retval := l_retval + l_ret___6
							js.break
							l_pos := -1 + 71 -- back to loop condition
				when 74 then -- loop done
							js.reset
							js.break
							l_pos := -1 + 69 -- back to loop condition
				when 75 then -- loop done
						js.reset
						if l_justify /= 1 then
							l_pos := -1 + 83 -- skip if block
						end
				when 76 then -- if: | loop condition:
							if js.loop_left then
								l_pos := -1 + 82 -- skip loop
							end
				when 77 then -- loop body:
							js.reset
				when 78 then -- loop condition:
							if js.loop_left then
								l_pos := -1 + 81 -- skip loop
							end
				when 79 then -- loop body:
							js.reset
							l_ret___7 := (a_funs.item.reps).integer_32_item ([a_data, (a_p.item.fill).to_integer_32, l_justlen])
							if l_ret___7 = -1 then
								l_pos := -1 + 84 -- goto error
							end
				when 80 then
							l_retval := l_retval + l_ret___7
							js.break
							l_pos := -1 + 78 -- back to loop condition
				when 81 then -- loop done
							js.reset
							js.break
							l_pos := -1 + 76 -- back to loop condition
				when 82 then -- loop done
							js.reset
				when 83 then -- done:
						Result := l_retval
						js.return
						if js.return_called then
							l_pos := -1 + 85 -- skip if block
						end
				when 84 then -- if: | error:
							l_retval := -1
							l_pos := -1 + 83 -- goto done
				when 85 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
