class
	P_ERRNO

inherit
	LIBGMP_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {NONE} -- Initialization

	default_create
		do
		end

feature {ANY} -- attributes

	gmp_errno: INTEGER_32 assign set_gmp_errno

	set_gmp_errno (a_gmp_errno: INTEGER_32)
		do
			gmp_errno := a_gmp_errno
		end

feature {ANY} -- routines

	gmp_exception (a_error_bit: INTEGER_32)
		do
			gmp_errno := (gmp_errno).bit_or (a_error_bit)
			gmp_impl_inst.gmp_junk := 10 // mp_bpl_inst.gmp_0
			abort
		end

	gmp_sqrt_of_negative
		do
			gmp_exception (4)
		end

	gmp_divide_by_zero
		do
			gmp_exception (2)
		end

end
