class
	P_FDIV_QR

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_fdiv_qr (a_quot: CE_POINTER [PD_MPZ_STRUCT]; a_rem: CE_POINTER [PD_MPZ_STRUCT]; a_dividend: CE_POINTER [PD_MPZ_STRUCT]; a_divisor: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_divisor: CE_POINTER [PD_MPZ_STRUCT]
			l_divisor_size: INTEGER_32
			l_xsize: INTEGER_32
			l_temp_divisor: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___5: CE_POINTER [ANY]
			l_tmp___6: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_divisor.make
			create l_temp_divisor.make (<<1>>)
			create l_tmp_marker.make
			create l_x.make
			create l_tmp___5.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_divisor.ce_gets (a_divisor)
					l_divisor_size := (l_divisor.item.mp_size).to_integer_32
					l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
					if (a_quot.c_pointer.to_integer_32).to_natural_32 /= (l_divisor.c_pointer.to_integer_32).to_natural_32 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if (a_rem.c_pointer.to_integer_32).to_natural_32 /= (l_divisor.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							l_x.ce_gets (l_temp_divisor)
							if l_divisor_size >= 0 then
								l_x.item.mp_alloc := l_divisor_size.to_integer_32
							else
								l_x.item.mp_alloc := (-l_divisor_size).to_integer_32
							end
							if l_divisor_size >= 0 then
								l_tmp___6 := l_divisor_size
							else
								l_tmp___6 := -l_divisor_size
							end
							if (builtin_expect ((l_tmp___6.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
								if l_divisor_size >= 0 then
									l_tmp___1 := l_divisor_size
								else
									l_tmp___1 := -l_divisor_size
								end
								l_tmp___5.ce_gets ((l_aaf.new ((l_tmp___1.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							else
								if l_divisor_size >= 0 then
									l_tmp___3 := l_divisor_size
								else
									l_tmp___3 := -l_divisor_size
								end
								l_tmp___5.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_tmp___3.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							l_x.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___5)
							js.break
						end
						js.reset
						set_inst.gmpz_set (l_temp_divisor, l_divisor)
						l_divisor.ce_gets (create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_temp_divisor))
				when 5 then -- if done
						l_xsize := ((a_dividend.item.mp_size).to_integer_32).bit_xor (l_divisor_size)
						tdiv_qr_inst.gmpz_tdiv_qr (a_quot, a_rem, a_dividend, l_divisor)
						if l_xsize < 0 then
							if a_rem.item.mp_size /= 0 then
								aors_ui_inst.gmpz_sub_ui (a_quot, a_quot, {NATURAL_32} 1)
								aors_inst.gmpz_add (a_rem, a_rem, l_divisor)
							end
						end
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
							end
							js.break
						end
						js.reset
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
