class
	P_GCD_1

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_gcd_1 (a_up: CE_POINTER [NATURAL_32]; a_size: INTEGER_32; a_vlimb: NATURAL_32): NATURAL_32
		local
			l_vlimb: NATURAL_32
			l_ulimb: NATURAL_32
			l_zero_bits: NATURAL_32
			l_u_low_zero_bits: NATURAL_32
			l_tmp___1: NATURAL_32
			l_mp_limb_t_swap__tmp: NATURAL_32
			l_c: INTEGER_32
			l_t: NATURAL_32
			l_vgtu: NATURAL_32
			l_tmp___4: NATURAL_32
			l_tmp___5: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_vlimb := a_vlimb
					l_ulimb := a_up[0]
					from
					until
						js.loop_left
					loop
						js.reset
						l_zero_bits := (builtin_ctzl (l_vlimb)).to_natural_32
						js.break
					end
					js.reset
					l_vlimb := (l_vlimb).bit_shift_right (l_zero_bits.to_integer_32)
					if not (a_size > 1) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_ulimb /= {NATURAL_32} 0 then
							from
							until
								js.loop_left
							loop
								js.reset
								l_u_low_zero_bits := (builtin_ctzl (l_ulimb)).to_natural_32
								js.break
							end
							js.reset
							if l_zero_bits < l_u_low_zero_bits then
								l_zero_bits := l_zero_bits
							else
								l_zero_bits := l_u_low_zero_bits
							end
						end
						if 22 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							if a_size >= 22 then
								l_ulimb := (mod_1_inst.gmpn_mod_1 (a_up, a_size, l_vlimb))
							else
								l_tmp___1 := gmp_impl_inst.gmpn_modexact_1_odd (a_up, a_size, l_vlimb)
								l_ulimb := l_tmp___1
							end
						else
							l_tmp___1 := gmp_impl_inst.gmpn_modexact_1_odd (a_up, a_size, l_vlimb)
							l_ulimb := l_tmp___1
						end
						if l_ulimb = {NATURAL_32} 0 then
							l_pos := -1 + 12 -- goto done
						end
				when 2 then
						l_pos := -1 + 9 -- goto strip_u_maybe
				when 3 then
					from
					until
						js.loop_left
					loop
						js.reset
						l_u_low_zero_bits := (builtin_ctzl (l_ulimb)).to_natural_32
						js.break
					end
					js.reset
					l_ulimb := (l_ulimb).bit_shift_right (l_u_low_zero_bits.to_integer_32)
					if l_zero_bits < l_u_low_zero_bits then
						l_zero_bits := l_zero_bits
					else
						l_zero_bits := l_u_low_zero_bits
					end
					if l_vlimb > l_ulimb then
						from
						until
							js.loop_left
						loop
							js.reset
							l_mp_limb_t_swap__tmp := l_ulimb
							l_ulimb := l_vlimb
							l_vlimb := l_mp_limb_t_swap__tmp
							js.break
						end
						js.reset
					end
					if not ((l_ulimb).bit_shift_right (16) > l_vlimb) then
						l_pos := -1 + 6 -- skip if block
					end
				when 4 then -- if:
						l_ulimb := l_ulimb \\ l_vlimb
						if l_ulimb = {NATURAL_32} 0 then
							l_pos := -1 + 12 -- goto done
						end
				when 5 then
						l_pos := -1 + 9 -- goto strip_u_maybe
				when 6 then
					l_ulimb := (l_ulimb).bit_shift_right ((1))
					l_vlimb := (l_vlimb).bit_shift_right ((1))
				when 7 then -- loop condition:
					if not (not js.loop_left and then (l_ulimb /= l_vlimb)) then
						l_pos := -1 + 11 -- skip loop
					end
				when 8 then -- loop body:
						l_t := l_ulimb - l_vlimb
						if (-1).bit_shift_right (1) < 0 then
							l_tmp___5 := ((l_t.to_integer_32).bit_shift_right (31)).to_natural_32
						else
							if ((l_t).bit_and ((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))))).to_boolean then
								l_tmp___4 := ((0).to_natural_32).bit_not
							else
								l_tmp___4 := (0).to_natural_32
							end
							l_tmp___5 := l_tmp___4
						end
						l_vgtu := l_tmp___5
						l_vlimb := l_vlimb + ((l_vgtu).bit_and (l_t))
						l_ulimb := ((l_t).bit_xor (l_vgtu)) - l_vgtu
						if True then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | strip_u_maybe:
						l_vlimb := (l_vlimb).bit_shift_right ((1))
						l_t := l_ulimb
				when 10 then -- if done
						from
						until
							js.loop_left
						loop
							js.reset
							l_c := builtin_ctzl (l_t)
							js.break
						end
						js.reset
						l_ulimb := (l_ulimb).bit_shift_right ((l_c + 1))
						l_pos := -1 + 7 -- back to loop condition
				when 11 then -- loop done
					l_vlimb := (((l_vlimb).bit_shift_left (1))).bit_or ({NATURAL_32} 1)
				when 12 then -- done:
					Result := ((l_vlimb).bit_shift_left (l_zero_bits.to_integer_32))
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
