class
	P_GET_DEN

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpq_get_den (a_den: CE_POINTER [PD_MPZ_STRUCT]; a_src: CE_POINTER [PD_MPQ_STRUCT])
		local
			l_size: INTEGER_32
			js: JUMP_STATE
		do
			l_size := (a_src.item.mp_den.mp_size).to_integer_32
			if (a_den.item.mp_alloc).to_integer_32 < l_size then
				realloc_inst.gmpz_realloc (a_den, l_size).do_nothing
			end
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					gmp_inst.gmpn_copyi (a_den.item.mp_d, a_src.item.mp_den.mp_d, l_size)
					js.break
				end
				js.reset
				js.break
			end
			js.reset
			a_den.item.mp_size := l_size.to_integer_32
		end

end
