class
	P_GET_SI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_get_si (a_f: CE_POINTER [PD_MPF_STRUCT]): INTEGER_32
		local
			l_exp: INTEGER_32
			l_size: INTEGER_32
			l_abs_size: INTEGER_32
			l_fp: CE_POINTER [NATURAL_32]
			l_fl: NATURAL_32
			js: JUMP_STATE
		do
			create l_fp.make

			l_exp := a_f.item.mp_exp
			l_size := (a_f.item.mp_size).to_integer_32
			l_fp.ce_gets (a_f.item.mp_d)
			if l_exp <= 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_fl := (0).to_natural_32
				if l_size >= 0 then
					l_abs_size := l_size
				else
					l_abs_size := -l_size
				end
				if l_abs_size >= l_exp then
					l_fl := l_fp[(l_abs_size - l_exp)]
				end
				if l_size > 0 then
					Result := ((l_fl).bit_and ((-((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1)).to_natural_32)).to_integer_32
				else
					Result := (((((l_fl - {NATURAL_32} 1)).bit_and ((-((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1)).to_natural_32))).bit_not).to_integer_32
				end
			end
		end

	gmpz_get_si (a_z: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_zp: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_zl: NATURAL_32
		do
			create l_zp.make

			l_zp.ce_gets (a_z.item.mp_d)
			l_size := (a_z.item.mp_size).to_integer_32
			l_zl := l_zp[0]
			if l_size > 0 then
				Result := ((l_zl.to_integer_32).bit_and (-((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1)))
			elseif l_size < 0 then
				Result := (((((l_zl.to_integer_32 - 1)).bit_and (-((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1)))).bit_not)
			else
				Result := 0
			end
		end

end
