class
	P_INVERT

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_invert (a_inverse: CE_POINTER [PD_MPZ_STRUCT]; a_x___2: CE_POINTER [PD_MPZ_STRUCT]; a_n: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_gcd: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp: CE_ARRAY [PD_MPZ_STRUCT]
			l_xsize: INTEGER_32
			l_nsize: INTEGER_32
			l_size: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp___0: INTEGER_32
			l_x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___4: CE_POINTER [ANY]
			l_x___0: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___9: CE_POINTER [ANY]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_gcd.make (<<1>>)
			create l_tmp.make (<<1>>)
			create l_tmp_marker.make
			create l_x.make
			create l_tmp___4.make
			create l_x___0.make
			create l_tmp___9.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_xsize := (a_x___2.item.mp_size).to_integer_32
					l_nsize := (a_n.item.mp_size).to_integer_32
					if l_xsize >= 0 then
						l_xsize := l_xsize
					else
						l_xsize := -l_xsize
					end
					if l_nsize >= 0 then
						l_nsize := l_nsize
					else
						l_nsize := -l_nsize
					end
					if l_xsize > l_nsize then
						l_tmp___0 := l_xsize
					else
						l_tmp___0 := l_nsize
					end
					l_size := l_tmp___0 + 1
					if l_xsize = 0 then
						Result := 0
						js.return
					elseif l_nsize = 1 then
						if a_n.item.mp_d[0] = {NATURAL_32} 1 then
							Result := 0
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
						from
						until
							js.loop_left
						loop
							js.reset
							l_x.ce_gets (l_gcd)
							l_x.item.mp_alloc := l_size.to_integer_32
							if (builtin_expect ((l_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
								l_tmp___4.ce_gets ((l_aaf.new ((l_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							else
								l_tmp___4.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							l_x.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___4)
							js.break
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							l_x___0.ce_gets (l_tmp)
							l_x___0.item.mp_alloc := l_size.to_integer_32
							if (builtin_expect ((l_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
								l_tmp___9.ce_gets ((l_aaf.new ((l_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							else
								l_tmp___9.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_size.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							l_x___0.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___9)
							js.break
						end
						js.reset
						gcdext_inst.gmpz_gcdext (l_gcd, l_tmp, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (default_pointer), a_x___2, a_n)
						if l_gcd[0].mp_size = 1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if l_gcd[0].mp_d[0] = {NATURAL_32} 1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
							end
							js.break
						end
						js.reset
						Result := 0
						js.return
				when 6 then -- if done | if done
						if not js.return_called then
							if l_tmp[0].mp_size < 0 then
								if a_n.item.mp_size < 0 then
									aors_inst.gmpz_sub (a_inverse, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp), a_n)
								else
									aors_inst.gmpz_add (a_inverse, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp), a_n)
								end
							else
								set_inst.gmpz_set (a_inverse, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp))
							end
							from
							until
								js.loop_left
							loop
								js.reset
								if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
									tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
								end
								js.break
							end
							js.reset
							Result := 1
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gmpn_invert (a_ip: CE_POINTER [NATURAL_32]; a_dp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		local
			l_scratch: CE_POINTER [NATURAL_32]
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp___2: CE_POINTER [ANY]
			l_i: INTEGER_32
			l_xp: CE_POINTER [NATURAL_32]
			l_d: CE_POINTER [NATURAL_32]
			l_s: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp___4: CE_POINTER [NATURAL_32]
			l_tmp___5: CE_POINTER [NATURAL_32]
			l_inv: PD_GMP_PI1_T
			l_v: NATURAL_32
			l_p: NATURAL_32
			l_t1: NATURAL_32
			l_t0: NATURAL_32
			l_mask: NATURAL_32
			l_e: NATURAL_32
			l_ptr_dummy: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_scratch.make
			create l_tmp_marker.make
			create l_tmp___2.make
			create l_xp.make
			create l_d.make
			create l_s.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_inv.make
			create l_ptr_dummy.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_scratch.ce_gets (a_scratch)
					if a_n /= 1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_left
						loop
							js.reset
							a_ip.item := gmp_impl_inst.gmpn_invert_limb (a_dp.item)
							js.break
						end
						js.reset
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
						if (l_scratch.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							if (builtin_expect (((3 * a_n + 2).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
								l_tmp___2.ce_gets ((l_aaf.new (((3 * a_n + 2).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							else
								l_tmp___2.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((3 * a_n + 2).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
							end
							l_scratch.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2))
						end
						if 61 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_n >= 61 then
							l_e := invertappr_inst.gmpn_ni_invertappr (a_ip, a_dp, a_n, l_scratch)
							if l_e.to_boolean then
								mul_n_inst.gmpn_mul_n (l_scratch, a_ip, a_dp, a_n)
								gmp_inst.gmpn_add_n (l_scratch + a_n, (l_scratch + a_n), a_dp, a_n).do_nothing
								if not (gmp_inst.gmpn_add (l_scratch, l_scratch, 2 * a_n, a_dp, a_n)).to_boolean then
									from
									until
										js.loop_left
									loop
										js.reset
										asm220 (l_ptr_dummy.address, a_ip.address)
										js.break
									end
									js.reset
								end
							end
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						l_xp.ce_gets (l_scratch)
						l_i := a_n - 1
						from
						until
							not (l_i >= 0)
						loop
							l_xp[l_i] := {NATURAL_32} 4294967295
							l_i := l_i - 1
						end
						from
						until
							js.loop_left
						loop
							js.reset
							l_d.ce_gets (l_xp + a_n)
							l_s.ce_gets (a_dp)
							l_n := a_n
							from
							until
								js.loop_left
							loop
								js.reset
								l_tmp___4.ce_gets (l_d)
								l_d.ce_gets (l_d + 1)
								l_tmp___5.ce_gets (l_s)
								l_s.ce_gets (l_s + 1)
								l_tmp___4.item := (((l_tmp___5.item).bit_not).bit_and ({NATURAL_32} 4294967295))
								l_n := l_n - 1
								if not l_n.to_boolean then
									js.break
								end
							end
							js.reset
							js.break
						end
						js.reset
						if a_n = 2 then
							gmp_inst.gmpn_divrem_2 (a_ip, (0).to_integer_32, l_xp, (4).to_integer_32, a_dp).do_nothing
						else
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									l_v := gmp_impl_inst.gmpn_invert_limb (a_dp[(a_n - 1)])
									js.break
								end
								js.reset
								l_p := (a_dp[(a_n - 1)] * l_v)
								l_p := l_p + (a_dp[(a_n - 2)])
								if l_p < a_dp[(a_n - 2)] then
									l_v := l_v - 1
									l_mask := (-(l_p >= a_dp[(a_n - 1)]).to_integer).to_integer.to_natural_32
									l_p := l_p - (a_dp[(a_n - 1)])
									l_v := l_v + l_mask
									l_p := l_p - ((l_mask).bit_and (a_dp[(a_n - 1)]))
								end
								asm221 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_t0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t1), a_dp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_v))
								l_p := l_p + l_t1
								if l_p < l_t1 then
									l_v := l_v - 1
									if (builtin_expect ((l_p >= a_dp[(a_n - 1)]).to_integer, 0)).to_boolean then
										if l_p > a_dp[(a_n - 1)] then
											l_v := l_v - 1
										elseif l_t0 >= a_dp[(a_n - 2)] then
											l_v := l_v - 1
										end
									end
								end
								l_inv.inv32 := l_v
								js.break
							end
							js.reset
							sbpi1_div_q_inst.gmpn_sbpi1_div_q (a_ip, l_xp, 2 * a_n, a_dp, a_n, l_inv.inv32).do_nothing
						end
				when 7 then
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
							end
							js.break
						end
						js.reset
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
