class
	P_INVERTAPPR

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	mpn_bc_invertappr (a_ip: CE_POINTER [NATURAL_32]; a_dp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_tp: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_xp: CE_POINTER [NATURAL_32]
			l_i: INTEGER_32
			l_d: CE_POINTER [NATURAL_32]
			l_s: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_32]
			l_tmp___0: CE_POINTER [NATURAL_32]
			l_inv: PD_GMP_PI1_T
			l_v: NATURAL_32
			l_p: NATURAL_32
			l_t1: NATURAL_32
			l_t0: NATURAL_32
			l_mask: NATURAL_32
			l_ptr_dummy: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_xp.make
			create l_d.make
			create l_s.make
			create l_tmp.make
			create l_tmp___0.make
			create l_inv.make
			create l_ptr_dummy.make

			if a_n = 1 then
				from
				until
					js.loop_left
				loop
					js.reset
					a_ip.item := gmp_impl_inst.gmpn_invert_limb (a_dp.item)
					js.break
				end
				js.reset
			else
				l_xp.ce_gets ((a_tp + a_n) + 2)
				l_i := a_n - 1
				from
				until
					not (l_i >= 0)
				loop
					l_xp[l_i] := {NATURAL_32} 4294967295
					l_i := l_i - 1
				end
				from
				until
					js.loop_left
				loop
					js.reset
					l_d.ce_gets (l_xp + a_n)
					l_s.ce_gets (a_dp)
					l_n := a_n
					from
					until
						js.loop_left
					loop
						js.reset
						l_tmp.ce_gets (l_d)
						l_d.ce_gets (l_d + 1)
						l_tmp___0.ce_gets (l_s)
						l_s.ce_gets (l_s + 1)
						l_tmp.item := (((l_tmp___0.item).bit_not).bit_and ({NATURAL_32} 4294967295))
						l_n := l_n - 1
						if not l_n.to_boolean then
							js.break
						end
					end
					js.reset
					js.break
				end
				js.reset
				if a_n = 2 then
					gmp_inst.gmpn_divrem_2 (a_ip, (0).to_integer_32, l_xp, (4).to_integer_32, a_dp).do_nothing
				else
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							l_v := gmp_impl_inst.gmpn_invert_limb (a_dp[(a_n - 1)])
							js.break
						end
						js.reset
						l_p := (a_dp[(a_n - 1)] * l_v)
						l_p := l_p + (a_dp[(a_n - 2)])
						if l_p < a_dp[(a_n - 2)] then
							l_v := l_v - 1
							l_mask := (-(l_p >= a_dp[(a_n - 1)]).to_integer).to_integer.to_natural_32
							l_p := l_p - (a_dp[(a_n - 1)])
							l_v := l_v + l_mask
							l_p := l_p - ((l_mask).bit_and (a_dp[(a_n - 1)]))
						end
						asm210 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_t0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t1), a_dp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_v))
						l_p := l_p + l_t1
						if l_p < l_t1 then
							l_v := l_v - 1
							if (builtin_expect ((l_p >= a_dp[(a_n - 1)]).to_integer, 0)).to_boolean then
								if l_p > a_dp[(a_n - 1)] then
									l_v := l_v - 1
								elseif l_t0 >= a_dp[(a_n - 2)] then
									l_v := l_v - 1
								end
							end
						end
						l_inv.inv32 := l_v
						js.break
					end
					js.reset
					sbpi1_divappr_q_inst.gmpn_sbpi1_divappr_q (a_ip, l_xp, 2 * a_n, a_dp, a_n, l_inv.inv32).do_nothing
					from
					until
						js.loop_left
					loop
						js.reset
						asm211 (l_ptr_dummy.address, a_ip.address)
						js.break
					end
					js.reset
					Result := (1).to_natural_32
					js.return
				end
			end
			if not js.return_called then
				Result := (0).to_natural_32
			end
		end

	gmpn_ni_invertappr (a_ip: CE_POINTER [NATURAL_32]; a_dp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_ip: CE_POINTER [NATURAL_32]
			l_dp: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_cy: NATURAL_32
			l_xp: CE_POINTER [NATURAL_32]
			l_rn: INTEGER_32
			l_mn: INTEGER_32
			l_sizes: CE_ARRAY [INTEGER_32]
			l_sizp: CE_POINTER [INTEGER_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp___5: CE_POINTER [ANY]
			l_method: NATURAL_32
			l_ptr_dummy: CE_POINTER [NATURAL_32]
			l_ptr_dummy___0: CE_POINTER [NATURAL_32]
			l_ptr_dummy___1: CE_POINTER [NATURAL_32]
			l_ptr_dummy___2: CE_POINTER [NATURAL_32]
			l_ptr_dummy___3: CE_POINTER [NATURAL_32]
			l_d: CE_POINTER [NATURAL_32]
			l_s: CE_POINTER [NATURAL_32]
			l_n2: INTEGER_32
			l_tmp___11: CE_POINTER [NATURAL_32]
			l_tmp___12: CE_POINTER [NATURAL_32]
			l_ptr_dummy___4: CE_POINTER [NATURAL_32]
			l_ptr_dummy___5: CE_POINTER [NATURAL_32]
			l_ptr_dummy___6: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_ip.make
			create l_dp.make
			create l_xp.make
			create l_sizes.make (<<({NATURAL_32} 8 * Integer_32_bytes.to_natural_32 - {NATURAL_32} 7).to_integer_32>>)
			create l_sizp.make
			create l_tp.make
			create l_tmp_marker.make
			create l_tmp___5.make
			create l_ptr_dummy.make
			create l_ptr_dummy___0.make
			create l_ptr_dummy___1.make
			create l_ptr_dummy___2.make
			create l_ptr_dummy___3.make
			create l_d.make
			create l_s.make
			create l_tmp___11.make
			create l_tmp___12.make
			create l_ptr_dummy___4.make
			create l_ptr_dummy___5.make
			create l_ptr_dummy___6.make

			l_ip.ce_gets (a_ip)
			l_dp.ce_gets (a_dp)
			l_n := a_n
			l_sizp.ce_gets (l_sizes)
			l_rn := l_n
			from
			until
				js.loop_left
			loop
				js.reset
				l_sizp.item := l_rn
				l_rn := ((l_rn).bit_shift_right (1)) + 1
				l_sizp.ce_gets (l_sizp + 1)
				if 81 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if not (l_rn >= 81) then
						js.break
					end
				else
					js.break
				end
			end
			js.reset
			l_dp.ce_gets (l_dp + l_n)
			l_ip.ce_gets (l_ip + l_n)
			mpn_bc_invertappr (l_ip - l_rn, l_dp - l_rn, l_rn, a_scratch).do_nothing
			l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
			if 117 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
				if l_n >= 117 then
					l_mn := mulmod_bnm1_inst.gmpn_mulmod_bnm1_next_size (l_n + 1)
					if (builtin_expect (((gmp_impl_inst.mpn_mulmod_bnm1_itch (l_mn, l_n, ((l_n).bit_shift_right (1)) + 1)).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___5.ce_gets ((l_aaf.new (((gmp_impl_inst.mpn_mulmod_bnm1_itch (l_mn, l_n, ((l_n).bit_shift_right (1)) + 1)).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___5.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((gmp_impl_inst.mpn_mulmod_bnm1_itch (l_mn, l_n, ((l_n).bit_shift_right (1)) + 1)).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___5))
				end
			end
			l_xp.ce_gets ((a_scratch + l_n) + 3)
			from
			until
				js.loop_left
			loop
				js.reset
				l_sizp.ce_gets (l_sizp - 1)
				l_n := l_sizp.item
				if 117 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n >= 117 then
						l_mn := mulmod_bnm1_inst.gmpn_mulmod_bnm1_next_size (l_n + 1)
						if l_mn > l_n + l_rn then
							mul_inst.gmpn_mul (l_xp, l_dp - l_n, l_n, (l_ip - l_rn), l_rn).do_nothing
							gmp_inst.gmpn_add_n (l_xp + l_rn, (l_xp + l_rn), l_dp - l_n, (l_n - l_rn) + 1).do_nothing
							l_method := (1).to_natural_32
						else
							mulmod_bnm1_inst.gmpn_mulmod_bnm1 (l_xp, l_mn, l_dp - l_n, l_n, (l_ip - l_rn), l_rn, l_tp)
							l_xp[l_mn] := {NATURAL_32} 1 + (gmp_inst.gmpn_add_n (l_xp + l_rn, (l_xp + l_rn), l_dp - l_n, l_mn - l_rn))
							l_cy := gmp_inst.gmpn_add_n (l_xp, l_xp, l_dp - (l_n - (l_mn - l_rn)), l_n - (l_mn - l_rn))
							from
							until
								js.loop_left
							loop
								js.reset
								asm212 (l_ptr_dummy.address, l_xp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n), create {CE_POINTER [INTEGER_32]}.make_shared ($l_mn), create {CE_POINTER [INTEGER_32]}.make_shared ($l_rn), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
								js.break
							end
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								asm213 (l_ptr_dummy___0.address, l_xp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rn), create {CE_POINTER [INTEGER_32]}.make_shared ($l_n), create {CE_POINTER [INTEGER_32]}.make_shared ($l_mn))
								js.break
							end
							js.reset
							if (l_xp[l_mn]).to_boolean then
								from
								until
									js.loop_left
								loop
									js.reset
									asm214 (l_ptr_dummy___1.address, l_xp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_mn))
									js.break
								end
								js.reset
							else
								from
								until
									js.loop_left
								loop
									js.reset
									asm215 (l_ptr_dummy___2.address, l_xp.address)
									js.break
								end
								js.reset
							end
							l_method := (0).to_natural_32
						end
					else
						mul_inst.gmpn_mul (l_xp, l_dp - l_n, l_n, (l_ip - l_rn), l_rn).do_nothing
						gmp_inst.gmpn_add_n (l_xp + l_rn, (l_xp + l_rn), l_dp - l_n, (l_n - l_rn) + 1).do_nothing
						l_method := (1).to_natural_32
					end
				else
					mul_inst.gmpn_mul (l_xp, l_dp - l_n, l_n, (l_ip - l_rn), l_rn).do_nothing
					gmp_inst.gmpn_add_n (l_xp + l_rn, (l_xp + l_rn), l_dp - l_n, (l_n - l_rn) + 1).do_nothing
					l_method := (1).to_natural_32
				end
				if l_xp[l_n] < {NATURAL_32} 2 then
					l_cy := (1).to_natural_32
					from
					until
						js.loop_left
					loop
						js.reset
						if not (l_xp[l_n]).to_boolean then
							if not ((gmp_inst.gmpn_cmp (l_xp, l_dp - l_n, l_n)) > 0) then
								js.break
							end
						end
						if not js.loop_jumped then
							l_xp[l_n] := l_xp[l_n] - (gmp_inst.gmpn_sub_n (l_xp, l_xp, l_dp - l_n, l_n))
							l_cy := l_cy + 1
						end
					end
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						asm216 (l_ptr_dummy___3.address, l_ip.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rn), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
						js.break
					end
					js.reset
					gmp_inst.gmpn_sub_n (l_xp, l_dp - l_n, l_xp, l_n).do_nothing
				else
					from
					until
						js.loop_left
					loop
						js.reset
						l_d.ce_gets (l_xp)
						l_s.ce_gets (l_xp)
						l_n2 := l_n + 1
						from
						until
							js.loop_left
						loop
							js.reset
							l_tmp___11.ce_gets (l_d)
							l_d.ce_gets (l_d + 1)
							l_tmp___12.ce_gets (l_s)
							l_s.ce_gets (l_s + 1)
							l_tmp___11.item := (((l_tmp___12.item).bit_not).bit_and ({NATURAL_32} 4294967295))
							l_n2 := l_n2 - 1
							if not l_n2.to_boolean then
								js.break
							end
						end
						js.reset
						js.break
					end
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						asm217 (l_ptr_dummy___4.address, l_xp.address, create {CE_POINTER [NATURAL_32]}.make_shared ($l_method))
						js.break
					end
					js.reset
					if (l_xp[l_n]).to_boolean then
						from
						until
							js.loop_left
						loop
							js.reset
							asm218 (l_ptr_dummy___5.address, l_ip.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rn))
							js.break
						end
						js.reset
						gmp_inst.gmpn_sub_n (l_xp, l_xp, l_dp - l_n, l_n).do_nothing
					end
				end
				mul_n_inst.gmpn_mul_n (a_scratch, ((l_xp + l_n) - l_rn), (l_ip - l_rn), l_rn)
				l_cy := gmp_inst.gmpn_add_n (a_scratch + l_rn, (a_scratch + l_rn), ((l_xp + l_n) - l_rn), 2 * l_rn - l_n)
				l_cy := gmp_impl_inst.gmpn_add_nc (l_ip - l_n, ((a_scratch + 3 * l_rn) - l_n), (l_xp + l_rn), l_n - l_rn, l_cy)
				from
				until
					js.loop_left
				loop
					js.reset
					asm219 (l_ptr_dummy___6.address, l_ip.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_rn), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
					js.break
				end
				js.reset
				if (l_sizp.c_pointer.to_integer_32).to_natural_32 = (l_sizes.c_pointer.to_integer_32).to_natural_32 then
					l_cy := (a_scratch[((3 * l_rn - l_n) - 1)] > {NATURAL_32} 4294967288).to_integer.to_natural_32
					js.break
				end
				if not js.loop_jumped then
					l_rn := l_n
				end
			end
			js.reset
			from
			until
				js.loop_left
			loop
				js.reset
				if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
					tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
				end
				js.break
			end
			js.reset
			Result := l_cy
		end

	gmpn_invertappr (a_ip: CE_POINTER [NATURAL_32]; a_dp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_scratch: CE_POINTER [NATURAL_32]
			l_res: NATURAL_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp___2: CE_POINTER [ANY]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_scratch.make
			create l_tmp_marker.make
			create l_tmp___2.make

			l_scratch.ce_gets (a_scratch)
			l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
			if (l_scratch.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				if (builtin_expect (((3 * a_n + 2).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
					l_tmp___2.ce_gets ((l_aaf.new (((3 * a_n + 2).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				else
					l_tmp___2.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((3 * a_n + 2).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				end
				l_scratch.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2))
			end
			if 81 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
				if a_n >= 81 then
					l_res := gmpn_ni_invertappr (a_ip, a_dp, a_n, l_scratch)
				else
					l_res := mpn_bc_invertappr (a_ip, a_dp, a_n, l_scratch)
				end
			else
				l_res := mpn_bc_invertappr (a_ip, a_dp, a_n, l_scratch)
			end
			from
			until
				js.loop_left
			loop
				js.reset
				if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
					tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
				end
				js.break
			end
			js.reset
			Result := l_res
		end

end
