class
	P_LSHIFTC

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_lshiftc (a_rp: CE_POINTER [NATURAL_32]; a_up: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_cnt: NATURAL_32): NATURAL_32
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_high_limb: NATURAL_32
			l_low_limb: NATURAL_32
			l_tnc: NATURAL_32
			l_i: INTEGER_32
			l_retval: NATURAL_32
		do
			create l_rp.make
			create l_up.make

			l_rp.ce_gets (a_rp)
			l_up.ce_gets (a_up)
			l_up.ce_gets (l_up + a_n)
			l_rp.ce_gets (l_rp + a_n)
			l_tnc := {NATURAL_32} 32 - a_cnt
			l_up.ce_gets (l_up - 1)
			l_low_limb := l_up.item
			l_retval := (l_low_limb).bit_shift_right (l_tnc.to_integer_32)
			l_high_limb := (l_low_limb).bit_shift_left (a_cnt.to_integer_32)
			l_i := a_n - 1
			from
			until
				l_i = 0
			loop
				l_up.ce_gets (l_up - 1)
				l_low_limb := l_up.item
				l_rp.ce_gets (l_rp - 1)
				l_rp.item := ((((l_high_limb).bit_or (((l_low_limb).bit_shift_right (l_tnc.to_integer_32))))).bit_not).bit_and ({NATURAL_32} 4294967295)
				l_high_limb := (l_low_limb).bit_shift_left (a_cnt.to_integer_32)
				l_i := l_i - 1
			end
			l_rp.ce_gets (l_rp - 1)
			l_rp.item := ((l_high_limb).bit_not).bit_and ({NATURAL_32} 4294967295)
			Result := l_retval
		end

end
