class
	P_MOD_1

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	mpn_mod_1_unnorm (a_up: CE_POINTER [NATURAL_32]; a_un: INTEGER_32; a_d: NATURAL_32): NATURAL_32
		local
			l_un: INTEGER_32
			l_d: NATURAL_32
			l_i: INTEGER_32
			l_n1: NATURAL_32
			l_n0: NATURAL_32
			l_r: NATURAL_32
			l_dummy: NATURAL_32
			l_cnt: INTEGER_32
			l_inv: NATURAL_32
			l_qh: NATURAL_32
			l_ql: NATURAL_32
			l_r2: NATURAL_32
			l_qh___0: NATURAL_32
			l_ql___0: NATURAL_32
			l_r___0: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_un := a_un
					l_d := a_d
					l_d := l_d
					l_r := a_up[(l_un - 1)]
					if l_r < l_d then
						l_r := l_r
						l_un := l_un - 1
						if l_un = 0 then
							Result := l_r
							js.return
						end
					else
						l_r := (0).to_natural_32
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if 5 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if not (l_un >= 5) then
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						l_i := l_un - 1
						from
						until
							not (l_i >= 0)
						loop
							l_n0 := a_up[l_i]
							asm27 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_dummy), create {CE_POINTER [NATURAL_32]}.make_shared ($l_r), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d))
							l_r := l_r
							l_i := l_i - 1
						end
						Result := l_r
						js.return
				when 5 then -- if done
						if not js.return_called then
							from
							until
								js.loop_left
							loop
								js.reset
								l_cnt := builtin_clzl (l_d)
								js.break
							end
							js.reset
							l_d := (l_d).bit_shift_left (l_cnt)
							l_n1 := a_up[(l_un - 1)]
							l_r := (((l_r).bit_shift_left (l_cnt))).bit_or (((l_n1).bit_shift_right ((32 - l_cnt))))
							from
							until
								js.loop_left
							loop
								js.reset
								l_inv := gmp_impl_inst.gmpn_invert_limb (l_d)
								js.break
							end
							js.reset
							l_i := l_un - 2
							from
							until
								not (not js.loop_left and then (l_i >= 0))
							loop
								l_n0 := a_up[l_i]
								from
								until
									js.loop_left
								loop
									js.reset
									asm28 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_ql), create {CE_POINTER [NATURAL_32]}.make_shared ($l_qh), create {CE_POINTER [NATURAL_32]}.make_shared ($l_r), create {CE_POINTER [NATURAL_32]}.make_shared ($l_inv))
									asm29 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_qh), create {CE_POINTER [NATURAL_32]}.make_shared ($l_ql), create {CE_POINTER [NATURAL_32]}.make_shared ($l_r), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [INTEGER_32]}.make_shared ($l_cnt), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0))
									l_r2 := ((((l_n1).bit_shift_left (l_cnt))).bit_or (((l_n0).bit_shift_right ((32 - l_cnt))))) - l_qh * l_d
									if l_r2 > l_ql then
										l_r2 := l_r2 + l_d
										l_qh := l_qh - 1
									end
									if (builtin_expect ((l_r2 >= l_d).to_integer, 0)).to_boolean then
										l_r2 := l_r2 - l_d
										l_qh := l_qh + 1
									end
									l_r := l_r2
									l_dummy := l_qh
									js.break
								end
								js.reset
								l_r := l_r
								l_n1 := l_n0
								l_i := l_i - 1
							end
							from
							until
								js.loop_left
							loop
								js.reset
								asm30 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_ql___0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_qh___0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_r), create {CE_POINTER [NATURAL_32]}.make_shared ($l_inv))
								asm31 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_qh___0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_ql___0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_r), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [INTEGER_32]}.make_shared ($l_cnt))
								l_r___0 := ((l_n1).bit_shift_left (l_cnt)) - l_qh___0 * l_d
								if l_r___0 > l_ql___0 then
									l_r___0 := l_r___0 + l_d
									l_qh___0 := l_qh___0 - 1
								end
								if (builtin_expect ((l_r___0 >= l_d).to_integer, 0)).to_boolean then
									l_r___0 := l_r___0 - l_d
									l_qh___0 := l_qh___0 + 1
								end
								l_r := l_r___0
								l_dummy := l_qh___0
								js.break
							end
							js.reset
							l_r := l_r
							Result := ((l_r).bit_shift_right (l_cnt))
						end
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	mpn_mod_1_norm (a_up: CE_POINTER [NATURAL_32]; a_un: INTEGER_32; a_d: NATURAL_32): NATURAL_32
		local
			l_un: INTEGER_32
			l_d: NATURAL_32
			l_i: INTEGER_32
			l_n0: NATURAL_32
			l_r: NATURAL_32
			l_dummy: NATURAL_32
			l_inv: NATURAL_32
			l_qh: NATURAL_32
			l_ql: NATURAL_32
			l_r2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_un := a_un
					l_d := a_d
					l_d := l_d
					l_r := a_up[(l_un - 1)]
					if l_r >= l_d then
						l_r := l_r - l_d
					end
					l_r := l_r
					l_un := l_un - 1
					if l_un = 0 then
						Result := l_r
						js.return
					end
					if js.return_called then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if 3 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_un >= 3 then
							from
							until
								js.loop_left
							loop
								js.reset
								l_inv := gmp_impl_inst.gmpn_invert_limb (l_d)
								js.break
							end
							js.reset
							l_i := l_un - 1
							from
							until
								not (not js.loop_left and then (l_i >= 0))
							loop
								l_n0 := a_up[l_i]
								from
								until
									js.loop_left
								loop
									js.reset
									asm32 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_ql), create {CE_POINTER [NATURAL_32]}.make_shared ($l_qh), create {CE_POINTER [NATURAL_32]}.make_shared ($l_r), create {CE_POINTER [NATURAL_32]}.make_shared ($l_inv))
									asm33 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_qh), create {CE_POINTER [NATURAL_32]}.make_shared ($l_ql), create {CE_POINTER [NATURAL_32]}.make_shared ($l_r), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0))
									l_r2 := l_n0 - l_qh * l_d
									if l_r2 > l_ql then
										l_r2 := l_r2 + l_d
										l_qh := l_qh - 1
									end
									if (builtin_expect ((l_r2 >= l_d).to_integer, 0)).to_boolean then
										l_r2 := l_r2 - l_d
										l_qh := l_qh + 1
									end
									l_r := l_r2
									l_dummy := l_qh
									js.break
								end
								js.reset
								l_r := l_r
								l_i := l_i - 1
							end
							Result := l_r
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						l_i := l_un - 1
						from
						until
							not (l_i >= 0)
						loop
							l_n0 := a_up[l_i]
							asm34 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_dummy), create {CE_POINTER [NATURAL_32]}.make_shared ($l_r), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d))
							l_r := l_r
							l_i := l_i - 1
						end
						Result := l_r
				when 5 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gmpn_mod_1 (a_ap: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_b: NATURAL_32): NATURAL_32
		local
			l_tmp: NATURAL_32
			l_pre: CE_ARRAY [NATURAL_32]
			l_tmp___1: NATURAL_32
			l_pre___0: CE_ARRAY [NATURAL_32]
			l_tmp___2: NATURAL_32
			l_pre___1: CE_ARRAY [NATURAL_32]
			l_pre___2: CE_ARRAY [NATURAL_32]
			js: JUMP_STATE
		do
			create l_pre.make (<<4>>)
			create l_pre___0.make (<<4>>)
			create l_pre___1.make (<<5>>)
			create l_pre___2.make (<<7>>)

			if a_n = 0 then
				Result := (0).to_natural_32
				js.return
			end
			if not js.return_called then
				if (builtin_expect ((((a_b).bit_and ((({NATURAL_32} 1).bit_shift_left (31)))) /= {NATURAL_32} 0).to_integer, 0)).to_boolean then
					if 10 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
						if a_n >= 10 then
							mod_1_1_inst.gmpn_mod_1_1p_cps (create {CE_POINTER [NATURAL_32]}.make_cast (l_pre), a_b)
							Result := (mod_1_1_inst.gmpn_mod_1_1p (a_ap, a_n, a_b, create {CE_POINTER [NATURAL_32]}.make_cast (l_pre)))
						else
							l_tmp := mpn_mod_1_norm (a_ap, a_n, a_b)
							Result := l_tmp
						end
					else
						l_tmp := mpn_mod_1_norm (a_ap, a_n, a_b)
						Result := l_tmp
					end
				elseif 5 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if a_n >= 5 then
						if 6 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							if a_n >= 6 then
								if (builtin_expect ((a_b > {NATURAL_32} 1073741823).to_integer, 0)).to_boolean then
									mod_1_2_inst.gmpn_mod_1s_2p_cps (create {CE_POINTER [NATURAL_32]}.make_cast (l_pre___1), a_b)
									Result := (mod_1_2_inst.gmpn_mod_1s_2p (a_ap, a_n, (a_b).bit_shift_left ((l_pre___1[1]).to_integer_32), create {CE_POINTER [NATURAL_32]}.make_cast (l_pre___1)))
								else
									gmp_impl_inst.gmpn_mod_1s_4p_cps (create {CE_POINTER [NATURAL_32]}.make_cast (l_pre___2), a_b)
									Result := (gmp_impl_inst.gmpn_mod_1s_4p (a_ap, a_n, (a_b).bit_shift_left ((l_pre___2[1]).to_integer_32), create {CE_POINTER [NATURAL_32]}.make_cast (l_pre___2)))
								end
							else
								mod_1_1_inst.gmpn_mod_1_1p_cps (create {CE_POINTER [NATURAL_32]}.make_cast (l_pre___0), a_b)
								l_tmp___2 := mod_1_1_inst.gmpn_mod_1_1p (a_ap, a_n, (a_b).bit_shift_left ((l_pre___0[1]).to_integer_32), create {CE_POINTER [NATURAL_32]}.make_cast (l_pre___0))
								Result := l_tmp___2
							end
						else
							mod_1_1_inst.gmpn_mod_1_1p_cps (create {CE_POINTER [NATURAL_32]}.make_cast (l_pre___0), a_b)
							l_tmp___2 := mod_1_1_inst.gmpn_mod_1_1p (a_ap, a_n, (a_b).bit_shift_left ((l_pre___0[1]).to_integer_32), create {CE_POINTER [NATURAL_32]}.make_cast (l_pre___0))
							Result := l_tmp___2
						end
					else
						l_tmp___1 := mpn_mod_1_unnorm (a_ap, a_n, a_b)
						Result := l_tmp___1
					end
				else
					l_tmp___1 := mpn_mod_1_unnorm (a_ap, a_n, a_b)
					Result := l_tmp___1
				end
			end
		end

end
