class
	P_MOD_1_3

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_mod_1s_3p_cps (a_cps: CE_POINTER [NATURAL_32]; a_b: NATURAL_32)
		local
			l_b: NATURAL_32
			l_bi: NATURAL_32
			l_B1modb: NATURAL_32
			l_B2modb: NATURAL_32
			l_B3modb: NATURAL_32
			l_B4modb: NATURAL_32
			l_cnt: INTEGER_32
			l_qh: NATURAL_32
			l_ql: NATURAL_32
			l_r: NATURAL_32
			l_qh___0: NATURAL_32
			l_ql___0: NATURAL_32
			l_r___0: NATURAL_32
			l_qh___1: NATURAL_32
			l_ql___1: NATURAL_32
			l_r___1: NATURAL_32
			js: JUMP_STATE
		do
			l_b := a_b
			from
			until
				js.loop_left
			loop
				js.reset
				l_cnt := builtin_clzl (l_b)
				js.break
			end
			js.reset
			l_b := (l_b).bit_shift_left (l_cnt)
			from
			until
				js.loop_left
			loop
				js.reset
				l_bi := gmp_impl_inst.gmpn_invert_limb (l_b)
				js.break
			end
			js.reset
			l_B1modb := (-l_b.to_integer_32).to_natural_32 * ((((l_bi).bit_shift_right ((32 - l_cnt)))).bit_or ((({NATURAL_32} 1).bit_shift_left (l_cnt))))
			from
			until
				js.loop_left
			loop
				js.reset
				asm66 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_ql), create {CE_POINTER [NATURAL_32]}.make_shared ($l_qh), create {CE_POINTER [NATURAL_32]}.make_shared ($l_B1modb), create {CE_POINTER [NATURAL_32]}.make_shared ($l_bi))
				l_qh := l_qh + (l_B1modb + {NATURAL_32} 1)
				l_r := (-l_qh.to_integer_32).to_natural_32 * l_b
				if l_r > l_ql then
					l_r := l_r + l_b
				end
				l_B2modb := l_r
				js.break
			end
			js.reset
			from
			until
				js.loop_left
			loop
				js.reset
				asm67 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_ql___0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_qh___0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_B2modb), create {CE_POINTER [NATURAL_32]}.make_shared ($l_bi))
				l_qh___0 := l_qh___0 + (l_B2modb + {NATURAL_32} 1)
				l_r___0 := (-l_qh___0.to_integer_32).to_natural_32 * l_b
				if l_r___0 > l_ql___0 then
					l_r___0 := l_r___0 + l_b
				end
				l_B3modb := l_r___0
				js.break
			end
			js.reset
			from
			until
				js.loop_left
			loop
				js.reset
				asm68 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_ql___1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_qh___1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_B3modb), create {CE_POINTER [NATURAL_32]}.make_shared ($l_bi))
				l_qh___1 := l_qh___1 + (l_B3modb + {NATURAL_32} 1)
				l_r___1 := (-l_qh___1.to_integer_32).to_natural_32 * l_b
				if l_r___1 > l_ql___1 then
					l_r___1 := l_r___1 + l_b
				end
				l_B4modb := l_r___1
				js.break
			end
			js.reset
			a_cps[0] := l_bi
			a_cps[1] := l_cnt.to_natural_32
			a_cps[2] := (l_B1modb).bit_shift_right (l_cnt)
			a_cps[3] := (l_B2modb).bit_shift_right (l_cnt)
			a_cps[4] := (l_B3modb).bit_shift_right (l_cnt)
			a_cps[5] := (l_B4modb).bit_shift_right (l_cnt)
		end

	gmpn_mod_1s_3p (a_ap: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_b: NATURAL_32; a_cps: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_n: INTEGER_32
			l_rh: NATURAL_32
			l_rl: NATURAL_32
			l_bi: NATURAL_32
			l_q: NATURAL_32
			l_ph: NATURAL_32
			l_pl: NATURAL_32
			l_ch: NATURAL_32
			l_cl: NATURAL_32
			l_r: NATURAL_32
			l_B1modb: NATURAL_32
			l_B2modb: NATURAL_32
			l_B3modb: NATURAL_32
			l_B4modb: NATURAL_32
			l_i: INTEGER_32
			l_cnt: INTEGER_32
			l_qh: NATURAL_32
			l_ql: NATURAL_32
			l_r2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_n := a_n
					l_B1modb := a_cps[2]
					l_B2modb := a_cps[3]
					l_B3modb := a_cps[4]
					l_B4modb := a_cps[5]
					inspect ((l_n.to_natural_32 * {NATURAL_32} 2863311531).bit_shift_right (30)).to_integer_32 -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 1 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 0
					asm69 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_pl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_ph), a_ap.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_B1modb))
					asm70 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_ph), create {CE_POINTER [NATURAL_32]}.make_shared ($l_pl), a_ap.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n))
					asm71 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_rl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_rh), a_ap.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_B2modb))
					asm72 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_rh), create {CE_POINTER [NATURAL_32]}.make_shared ($l_rl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_ph), create {CE_POINTER [NATURAL_32]}.make_shared ($l_pl))
					l_n := l_n - (3)
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 2
					l_rh := (0).to_natural_32
					l_rl := a_ap[(l_n - 1)]
					l_n := l_n - 1
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, case 1
					asm73 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_pl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_ph), a_ap.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_B1modb))
					asm74 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_rh), create {CE_POINTER [NATURAL_32]}.make_shared ($l_rl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_ph), create {CE_POINTER [NATURAL_32]}.make_shared ($l_pl), a_ap.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n))
					l_n := l_n - (2)
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					l_i := l_n - 3
					from
					until
						not (l_i >= 0)
					loop
						asm75 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_pl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_ph), a_ap.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_i), create {CE_POINTER [NATURAL_32]}.make_shared ($l_B1modb))
						asm76 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_ph), create {CE_POINTER [NATURAL_32]}.make_shared ($l_pl), a_ap.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_i))
						asm77 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_cl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_ch), a_ap.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_i), create {CE_POINTER [NATURAL_32]}.make_shared ($l_B2modb))
						asm78 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_ph), create {CE_POINTER [NATURAL_32]}.make_shared ($l_pl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_ch), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cl))
						asm79 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_cl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_ch), create {CE_POINTER [NATURAL_32]}.make_shared ($l_rl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_B3modb))
						asm80 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_ph), create {CE_POINTER [NATURAL_32]}.make_shared ($l_pl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_ch), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cl))
						asm81 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_rl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_rh), create {CE_POINTER [NATURAL_32]}.make_shared ($l_B4modb))
						asm82 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_rh), create {CE_POINTER [NATURAL_32]}.make_shared ($l_rl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_ph), create {CE_POINTER [NATURAL_32]}.make_shared ($l_pl))
						l_i := l_i - (3)
					end
					l_bi := a_cps[0]
					l_cnt := (a_cps[1]).to_integer_32
					asm83 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_cl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_rh), create {CE_POINTER [NATURAL_32]}.make_shared ($l_B1modb))
					asm84 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_rh), create {CE_POINTER [NATURAL_32]}.make_shared ($l_rl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cl))
					l_r := (((l_rh).bit_shift_left (l_cnt))).bit_or (((l_rl).bit_shift_right ((32 - l_cnt))))
					from
					until
						js.loop_left
					loop
						js.reset
						asm85 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_ql), create {CE_POINTER [NATURAL_32]}.make_shared ($l_qh), create {CE_POINTER [NATURAL_32]}.make_shared ($l_r), create {CE_POINTER [NATURAL_32]}.make_shared ($l_bi))
						asm86 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_qh), create {CE_POINTER [NATURAL_32]}.make_shared ($l_ql), create {CE_POINTER [NATURAL_32]}.make_shared ($l_r), create {CE_POINTER [NATURAL_32]}.make_shared ($l_rl), create {CE_POINTER [INTEGER_32]}.make_shared ($l_cnt))
						l_r2 := ((l_rl).bit_shift_left (l_cnt)) - l_qh * a_b
						if l_r2 > l_ql then
							l_r2 := l_r2 + a_b
							l_qh := l_qh - 1
						end
						if (builtin_expect ((l_r2 >= a_b).to_integer, 0)).to_boolean then
							l_r2 := l_r2 - a_b
							l_qh := l_qh + 1
						end
						l_r := l_r2
						l_q := l_qh
						js.break
					end
					js.reset
					Result := ((l_r).bit_shift_right (l_cnt))
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
