class
	P_MP_GET_FNS

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmp_get_memory_functions (a_alloc_func: CE_POINTER [CE_ROUTINE]; a_realloc_func: CE_POINTER [CE_ROUTINE]; a_free_func: CE_POINTER [CE_ROUTINE])
		do
			if (a_alloc_func.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				a_alloc_func.item := memory_inst.gmp_allocate_func
			end
			if (a_realloc_func.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				a_realloc_func.item := memory_inst.gmp_reallocate_func
			end
			if (a_free_func.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32 then
				a_free_func.item := memory_inst.gmp_free_func
			end
		end

end
