class
	P_MUL_N

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_mul_n (a_p: CE_POINTER [NATURAL_32]; a_a: CE_POINTER [NATURAL_32]; a_b: CE_POINTER [NATURAL_32]; a_n: INTEGER_32)
		local
			l_ws: CE_ARRAY [NATURAL_32]
			l_ws___0: CE_POINTER [NATURAL_32]
			l_tmp: CE_POINTER [ANY]
			l_ws___1: CE_POINTER [NATURAL_32]
			l_tmp___0: CE_POINTER [ANY]
			l_ws___2: CE_POINTER [NATURAL_32]
			l_tmp___1: CE_POINTER [ANY]
			l_ws___3: CE_POINTER [NATURAL_32]
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp___4: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___8: CE_POINTER [ANY]
			l_tmp___9: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_ws.make (<<216>>)
			create l_ws___0.make
			create l_tmp.make
			create l_ws___1.make
			create l_tmp___0.make
			create l_ws___2.make
			create l_tmp___1.make
			create l_ws___3.make
			create l_tmp_marker.make
			create l_tmp___8.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if 20 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
						l_pos := -1 + 33 -- skip if block
					end
				when 1 then -- if:
						if not (a_n >= 20) then
							l_pos := -1 + 31 -- skip if block
						end
				when 2 then -- if:
						if 77 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 29 -- skip if block
						end
				when 3 then -- if:
						if not (a_n >= 77) then
							l_pos := -1 + 27 -- skip if block
						end
				when 4 then -- if:
						if 182 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 25 -- skip if block
						end
				when 5 then -- if:
						if not (a_n >= 182) then
							l_pos := -1 + 23 -- skip if block
						end
				when 6 then -- if:
						if 252 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 21 -- skip if block
						end
				when 7 then -- if:
						if not (a_n >= 252) then
							l_pos := -1 + 19 -- skip if block
						end
				when 8 then -- if:
						if 381 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 17 -- skip if block
						end
				when 9 then -- if:
						if not (a_n >= 381) then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if:
						if 6784 = -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if a_n >= 6784 then
							nussbaumer_mul_inst.gmpn_nussbaumer_mul (a_p, a_a, a_n, a_b, a_n)
						else
							l_pos := -1 + 13 -- goto _L
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L:
						l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
						if ((5715).bit_shift_right (3)) + 192 > 1046 then
							l_tmp___9 := ((5715).bit_shift_right (3)) + 192
						else
							l_tmp___9 := 1046
						end
						if (builtin_expect ((((((a_n * 15).bit_shift_right (3)) - ((5715).bit_shift_right (3)).to_integer_32) + l_tmp___9.to_integer_32).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							if ((5715).bit_shift_right (3)) + 192 > 1046 then
								l_tmp___4 := ((5715).bit_shift_right (3)) + 192
							else
								l_tmp___4 := 1046
							end
							l_tmp___8.ce_gets ((l_aaf.new ((((((a_n * 15).bit_shift_right (3)) - ((5715).bit_shift_right (3)).to_integer_32) + l_tmp___4.to_integer_32).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							if ((5715).bit_shift_right (3)) + 192 > 1046 then
								l_tmp___6 := ((5715).bit_shift_right (3)) + 192
							else
								l_tmp___6 := 1046
							end
							l_tmp___8.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (((((a_n * 15).bit_shift_right (3)) - ((5715).bit_shift_right (3)).to_integer_32) + l_tmp___6.to_integer_32).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_ws___3.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___8))
						toom8h_mul_inst.gmpn_toom8h_mul (a_p, a_a, a_n, a_b, a_n, l_ws___3)
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
							end
							js.break
						end
						js.reset
				when 14 then -- if done | if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						l_tmp___1.ce_gets (l_aaf.new ((((a_n - 252) * 2 + 788).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						l_ws___2.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___1))
						toom6h_mul_inst.gmpn_toom6h_mul (a_p, a_a, a_n, a_b, a_n, l_ws___2)
				when 16 then -- if done | if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:
						l_tmp___1.ce_gets (l_aaf.new ((((a_n - 252) * 2 + 788).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						l_ws___2.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___1))
						toom6h_mul_inst.gmpn_toom6h_mul (a_p, a_a, a_n, a_b, a_n, l_ws___2)
				when 18 then -- if done | if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:
						l_tmp___0.ce_gets (l_aaf.new (((3 * a_n + 32).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						l_ws___1.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___0))
						toom44_mul_inst.gmpn_toom44_mul (a_p, a_a, a_n, a_b, a_n, l_ws___1)
				when 20 then -- if done | if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else:
						l_tmp___0.ce_gets (l_aaf.new (((3 * a_n + 32).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						l_ws___1.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___0))
						toom44_mul_inst.gmpn_toom44_mul (a_p, a_a, a_n, a_b, a_n, l_ws___1)
				when 22 then -- if done | if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else:
						l_tmp.ce_gets (l_aaf.new (((((5 * a_n).bit_shift_right (1)) + 32).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						l_ws___0.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp))
						toom33_mul_inst.gmpn_toom33_mul (a_p, a_a, a_n, a_b, a_n, l_ws___0)
				when 24 then -- if done | if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else:
						l_tmp.ce_gets (l_aaf.new (((((5 * a_n).bit_shift_right (1)) + 32).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						l_ws___0.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp))
						toom33_mul_inst.gmpn_toom33_mul (a_p, a_a, a_n, a_b, a_n, l_ws___0)
				when 26 then -- if done | if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else:
						l_pos := -1 + 29 -- goto _L___0
				when 28 then -- if done | if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else: | _L___0:
						
						toom22_mul_inst.gmpn_toom22_mul (a_p, a_a, a_n, a_b, a_n, l_ws)
				when 30 then -- if done | if block done, skip else block:
						l_pos := -1 + 32
				when 31 then -- else:
						gmp_impl_inst.gmpn_mul_basecase (a_p, a_a, a_n, a_b, a_n)
				when 32 then -- if done | if block done, skip else block:
						l_pos := -1 + 34
				when 33 then -- else:
						gmp_impl_inst.gmpn_mul_basecase (a_p, a_a, a_n, a_b, a_n)
				when 34 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
