class
	P_MULLO_BASECASE

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_mullo_basecase (a_rp: CE_POINTER [NATURAL_32]; a_up: CE_POINTER [NATURAL_32]; a_vp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32)
		local
			l_i: INTEGER_32
		do
			gmp_inst.gmpn_mul_1 (a_rp, a_up, a_n, a_vp[0]).do_nothing
			l_i := (1).to_integer_32
			from
			until
				not (l_i < a_n)
			loop
				gmp_inst.gmpn_addmul_1 (a_rp + l_i, a_up, a_n - l_i, a_vp[l_i]).do_nothing
				l_i := l_i + 1
			end
		end

end
