class
	P_POWLO

inherit
	LIBGMP_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {NONE} -- Initialization

	default_create
		do
			create x___0.make (<<11>>)
		end

feature {ANY} -- attributes

	x___0: CE_ARRAY [NATURAL_32]

feature {ANY} -- routines

	win_size___0 (a_eb: NATURAL_32): INTEGER_32
		local
			l_k: INTEGER_32
		do
			l_k := 0
			from
			until
				not (a_eb > x___0[l_k])
			loop
				l_k := l_k + 1
			end
			Result := l_k
		end

	gmpn_powlo (a_rp: CE_POINTER [NATURAL_32]; a_bp: CE_POINTER [NATURAL_32]; a_ep: CE_POINTER [NATURAL_32]; a_en: INTEGER_32; a_n: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		local
			l_cnt: INTEGER_32
			l_ebi: NATURAL_32
			l_windowsize: INTEGER_32
			l_this_windowsize: INTEGER_32
			l_expbits: NATURAL_32
			l_pp: CE_POINTER [NATURAL_32]
			l_this_pp: CE_POINTER [NATURAL_32]
			l_last_pp: CE_POINTER [NATURAL_32]
			l_b2p: CE_POINTER [NATURAL_32]
			l_i: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp___2: CE_POINTER [ANY]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_pp.make
			create l_this_pp.make
			create l_last_pp.make
			create l_b2p.make
			create l_tmp_marker.make
			create l_tmp___2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
					from
					until
						js.loop_left
					loop
						js.reset
						l_cnt := builtin_clzl (a_ep[(a_en - 1)])
						js.break
					end
					js.reset
					l_ebi := a_en.to_natural_32 * {NATURAL_32} 32 - l_cnt.to_natural_32
					l_windowsize := win_size___0 (l_ebi)
					if (builtin_expect (((((a_n).bit_shift_left ((l_windowsize - 1))) + a_n).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
						l_tmp___2.ce_gets ((l_aaf.new (((((a_n).bit_shift_left ((l_windowsize - 1))) + a_n).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					else
						l_tmp___2.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, ((((a_n).bit_shift_left ((l_windowsize - 1))) + a_n).to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
					end
					l_pp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2))
					l_this_pp.ce_gets (l_pp)
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (l_this_pp, a_bp, a_n)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
					l_b2p.ce_gets (a_tp + 2 * a_n)
					sqr_inst.gmpn_sqr (a_tp, a_bp, a_n)
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (l_b2p, a_tp, a_n)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
					l_i := (((1).bit_shift_left ((l_windowsize - 1))) - 1).to_integer_32
					from
					until
						not (l_i > 0)
					loop
						l_last_pp.ce_gets (l_this_pp)
						l_this_pp.ce_gets (l_this_pp + a_n)
						mullo_n_inst.gmpn_mullo_n (l_this_pp, l_last_pp, l_b2p, a_n)
						l_i := l_i - 1
					end
					l_expbits := powm_inst.getbits (a_ep, l_ebi, l_windowsize)
					if l_ebi < l_windowsize.to_natural_32 then
						l_ebi := (0).to_natural_32
					else
						l_ebi := l_ebi - l_windowsize.to_natural_32
					end
					from
					until
						js.loop_left
					loop
						js.reset
						l_cnt := builtin_ctzl (l_expbits)
						js.break
					end
					js.reset
					l_ebi := l_ebi + l_cnt.to_natural_32
					l_expbits := (l_expbits).bit_shift_right (l_cnt)
					from
					until
						js.loop_left
					loop
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							gmp_inst.gmpn_copyi (a_rp, (l_pp + (a_n.to_natural_32 * ((l_expbits).bit_shift_right (1))).to_integer_32), a_n)
							js.break
						end
						js.reset
						js.break
					end
					js.reset
				when 1 then -- loop condition:
					if not (not js.loop_left and then (l_ebi /= {NATURAL_32} 0)) then
						l_pos := -1 + 6 -- skip loop
					end
				when 2 then -- loop body: | loop condition:
						if not (not js.loop_left and then (((((a_ep[((l_ebi - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32]).bit_shift_right (((l_ebi - {NATURAL_32} 1) \\ {NATURAL_32} 32).to_integer_32))).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0)) then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						sqr_inst.gmpn_sqr (a_tp, a_rp, a_n)
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (a_rp, a_tp, a_n)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
						l_ebi := l_ebi - 1
						if l_ebi = {NATURAL_32} 0 then
							l_pos := -1 + 6 -- goto done
						end
				when 4 then
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
						l_expbits := powm_inst.getbits (a_ep, l_ebi, l_windowsize)
						l_this_windowsize := l_windowsize
						if l_ebi < l_windowsize.to_natural_32 then
							l_this_windowsize := (l_this_windowsize.to_natural_32 - (l_windowsize.to_natural_32 - l_ebi)).to_integer_32
							l_ebi := (0).to_natural_32
						else
							l_ebi := l_ebi - l_windowsize.to_natural_32
						end
						from
						until
							js.loop_left
						loop
							js.reset
							l_cnt := builtin_ctzl (l_expbits)
							js.break
						end
						js.reset
						l_this_windowsize := l_this_windowsize - l_cnt
						l_ebi := l_ebi + l_cnt.to_natural_32
						l_expbits := (l_expbits).bit_shift_right (l_cnt)
						from
						until
							js.loop_left
						loop
							js.reset
							sqr_inst.gmpn_sqr (a_tp, a_rp, a_n)
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (a_rp, a_tp, a_n)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
							l_this_windowsize := l_this_windowsize - 1
							if l_this_windowsize = 0 then
								js.break
							end
						end
						js.reset
						mullo_n_inst.gmpn_mullo_n (a_tp, a_rp, (l_pp + (a_n.to_natural_32 * ((l_expbits).bit_shift_right (1))).to_integer_32), a_n)
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (a_rp, a_tp, a_n)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
						l_pos := -1 + 1 -- back to loop condition
				when 6 then -- done:
					from
					until
						js.loop_left
					loop
						js.reset
						if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
							tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
						end
						js.break
					end
					js.reset
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
