class
	P_RANDBUI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmp_urandomb_ui (a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_bits: NATURAL_32): NATURAL_32
		local
			l_a: CE_ARRAY [NATURAL_32]
			l_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l_tmp: NATURAL_32
			js: JUMP_STATE
		do
			create l_a.make (<<1>>)
			create l_rstate.make

			l_a[0] := (0).to_natural_32
			from
			until
				js.loop_left
			loop
				js.reset
				l_rstate.ce_gets (a_rstate)
				if a_bits < {NATURAL_32} 32 then
					l_tmp := a_bits
				else
					l_tmp := {NATURAL_32} 32
				end
				((create {CE_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l_rstate.item.mp_algdata.mp_lc)).item.randget_fn).call ([l_rstate, l_a, l_tmp])
				js.break
			end
			js.reset
			Result := (l_a[0])
		end

end
