class
	P_RANDMT

inherit
	LIBGMP_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {NONE} -- Initialization

	default_create
		do
			create default_state.make (<<624>>)
			create Mersenne_Twister_Generator_Noseed.make
		end

feature {ANY} -- attributes

	default_state: CE_ARRAY [NATURAL_32]

	Mersenne_Twister_Generator_Noseed: PD_GMP_RANDFNPTR_T2

feature {ANY} -- routines

	gmp_mt_recalc_buffer (a_mt: CE_POINTER [NATURAL_32])
		local
			l_y: NATURAL_32
			l_kk: INTEGER_32
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
			l_tmp___1: NATURAL_32
		do
			l_kk := 0
			from
			until
				not (l_kk < 227)
			loop
				l_y := (((a_mt[l_kk]).bit_and ({NATURAL_32} 2147483648))).bit_or (((a_mt[(l_kk + 1)]).bit_and ({NATURAL_32} 2147483647)))
				if ((l_y).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
					l_tmp := {NATURAL_32} 2567483615
				else
					l_tmp := {NATURAL_32} 0
				end
				a_mt[l_kk] := (((a_mt[(l_kk + 397)]).bit_xor (((l_y).bit_shift_right (1))))).bit_xor (l_tmp)
				l_kk := l_kk + 1
			end
			from
			until
				not (l_kk < 623)
			loop
				l_y := (((a_mt[l_kk]).bit_and ({NATURAL_32} 2147483648))).bit_or (((a_mt[(l_kk + 1)]).bit_and ({NATURAL_32} 2147483647)))
				if ((l_y).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
					l_tmp___0 := {NATURAL_32} 2567483615
				else
					l_tmp___0 := {NATURAL_32} 0
				end
				a_mt[l_kk] := (((a_mt[(l_kk - 227)]).bit_xor (((l_y).bit_shift_right (1))))).bit_xor (l_tmp___0)
				l_kk := l_kk + 1
			end
			l_y := (((a_mt[623]).bit_and ({NATURAL_32} 2147483648))).bit_or (((a_mt[0]).bit_and ({NATURAL_32} 2147483647)))
			if ((l_y).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
				l_tmp___1 := {NATURAL_32} 2567483615
			else
				l_tmp___1 := {NATURAL_32} 0
			end
			a_mt[623] := (((a_mt[396]).bit_xor (((l_y).bit_shift_right (1))))).bit_xor (l_tmp___1)
		end

	gmp_randget_mt (a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_dest: CE_POINTER [NATURAL_32]; a_nbits: NATURAL_32)
		local
			l_y: NATURAL_32
			l_rbits: INTEGER_32
			l_i: INTEGER_32
			l_nlimbs: INTEGER_32
			l_pmti: CE_POINTER [INTEGER_32]
			l_mt: CE_POINTER [NATURAL_32]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_pmti.make
			create l_mt.make

			l_pmti.ce_gets (create {CE_POINTER [INTEGER_32]}.make_shared ((create {CE_POINTER [PD_GMP_RAND_MT_STRUCT]}.make_cast (a_rstate.item.mp_seed[0].mp_d)).c_pointer + {PD_GMP_RAND_MT_STRUCT}.mti_offset))
			l_mt.ce_gets ((create {CE_POINTER [PD_GMP_RAND_MT_STRUCT]}.make_cast (a_rstate.item.mp_seed[0].mp_d)).item.mt)
			l_nlimbs := (a_nbits // {NATURAL_32} 32).to_integer_32
			l_rbits := (a_nbits \\ {NATURAL_32} 32).to_integer_32
			l_i := (0).to_integer_32
			from
			until
				not (not js.loop_left and then (l_i < l_nlimbs))
			loop
				from
				until
					js.loop_left
				loop
					js.reset
					if l_pmti.item >= 624 then
						gmp_mt_recalc_buffer (l_mt)
						l_pmti.item := 0
					end
					l_tmp := l_pmti.item
					l_pmti.item := (l_pmti.item) + 1
					l_y := l_mt[l_tmp]
					l_y := (l_y).bit_xor (((l_y).bit_shift_right (11)))
					l_y := (l_y).bit_xor (((((l_y).bit_shift_left (7))).bit_and ({NATURAL_32} 2636928640)))
					l_y := (l_y).bit_xor (((((l_y).bit_shift_left (15))).bit_and ({NATURAL_32} 4022730752)))
					l_y := (l_y).bit_xor (((l_y).bit_shift_right (18)))
					js.break
				end
				js.reset
				a_dest[l_i] := l_y.to_natural_32
				l_i := l_i + 1
			end
			if l_rbits.to_boolean then
				from
				until
					js.loop_left
				loop
					js.reset
					if l_pmti.item >= 624 then
						gmp_mt_recalc_buffer (l_mt)
						l_pmti.item := 0
					end
					l_tmp___0 := l_pmti.item
					l_pmti.item := (l_pmti.item) + 1
					l_y := l_mt[l_tmp___0]
					l_y := (l_y).bit_xor (((l_y).bit_shift_right (11)))
					l_y := (l_y).bit_xor (((((l_y).bit_shift_left (7))).bit_and ({NATURAL_32} 2636928640)))
					l_y := (l_y).bit_xor (((((l_y).bit_shift_left (15))).bit_and ({NATURAL_32} 4022730752)))
					l_y := (l_y).bit_xor (((l_y).bit_shift_right (18)))
					js.break
				end
				js.reset
				a_dest[l_nlimbs] := (l_y.to_natural_32).bit_and (((({NATURAL_32} 4294967295).bit_shift_left (l_rbits))).bit_not)
			end
		end

	gmp_randget_mt_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gmp_randget_mt)
		end

	gmp_randclear_mt (a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT])
		do
			memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (a_rstate.item.mp_seed[0].mp_d), (a_rstate.item.mp_seed[0].mp_alloc * 4).to_natural_32])
		end

	gmp_randclear_mt_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gmp_randclear_mt)
		end

	gmp_randiset_mt (a_dst: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_src: CE_POINTER [PD_GMP_RANDSTATE_STRUCT])
		local
			l_sz: INTEGER_32
			l_dstp: CE_POINTER [PD_GMP_RAND_MT_STRUCT]
			l_srcp: CE_POINTER [PD_GMP_RAND_MT_STRUCT]
			l_i: INTEGER_32
		do
			create l_dstp.make
			create l_srcp.make

			l_sz := (({PD_GMP_RAND_MT_STRUCT}.sizeof.to_natural_32 - {NATURAL_32} 1) // {NATURAL_32} 4 + {NATURAL_32} 1).to_integer_32
			a_dst.item.mp_algdata.mp_lc := create {CE_POINTER [ANY]}.make_cast ((Mersenne_Twister_Generator_Noseed.address))
			l_dstp.ce_gets (create {CE_POINTER [PD_GMP_RAND_MT_STRUCT]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([(l_sz.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32])))))
			a_dst.item.mp_seed[0].mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_dstp)
			a_dst.item.mp_seed[0].mp_alloc := l_sz.to_integer_32
			l_srcp.ce_gets (create {CE_POINTER [PD_GMP_RAND_MT_STRUCT]}.make_cast (a_src.item.mp_seed[0].mp_d))
			l_i := (0).to_integer_32
			from
			until
				not (l_i < 624)
			loop
				l_dstp.item.mt[l_i] := l_srcp.item.mt[l_i]
				l_i := l_i + 1
			end
			l_dstp.item.mti := l_srcp.item.mti
		end

	gmp_randiset_mt_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gmp_randiset_mt)
		end

	gmp_randinit_mt_noseed (a_dst: CE_POINTER [PD_GMP_RANDSTATE_STRUCT])
		local
			l_sz: INTEGER_32
			l_dstp: CE_POINTER [PD_GMP_RAND_MT_STRUCT]
			l_i: INTEGER_32
		do
			create l_dstp.make

			l_sz := (({PD_GMP_RAND_MT_STRUCT}.sizeof.to_natural_32 - {NATURAL_32} 1) // {NATURAL_32} 4 + {NATURAL_32} 1).to_integer_32
			a_dst.item.mp_algdata.mp_lc := create {CE_POINTER [ANY]}.make_cast ((Mersenne_Twister_Generator_Noseed.address))
			l_dstp.ce_gets (create {CE_POINTER [PD_GMP_RAND_MT_STRUCT]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([(l_sz.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32])))))
			a_dst.item.mp_seed[0].mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_dstp)
			a_dst.item.mp_seed[0].mp_alloc := l_sz.to_integer_32
			l_i := (0).to_integer_32
			from
			until
				not (l_i < 624)
			loop
				l_dstp.item.mt[l_i] := default_state[l_i]
				l_i := l_i + 1
			end
			l_dstp.item.mti := 128
		end

end
