class
	P_RANDMUI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmp_urandomm_ui (a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_n: NATURAL_32): NATURAL_32
		local
			l_a: CE_ARRAY [NATURAL_32]
			l_ret: NATURAL_32
			l_bits: NATURAL_32
			l_leading: NATURAL_32
			l_i: INTEGER_32
			l_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_a.make (<<1>>)
			create l_rstate.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (builtin_expect ((a_n = {NATURAL_32} 0).to_integer, 0)).to_boolean then
						errno_inst.gmp_divide_by_zero
					end
					l_a[0] := (0).to_natural_32
					from
					until
						js.loop_left
					loop
						js.reset
						l_leading := (builtin_clzl (a_n)).to_natural_32
						js.break
					end
					js.reset
					l_bits := ({NATURAL_32} 32 - l_leading) - (((a_n).bit_and ((a_n - {NATURAL_32} 1))) = {NATURAL_32} 0).to_integer.to_natural_32
					l_i := 0
				when 1 then -- loop condition:
					if not (not js.loop_left and then (l_i < 80)) then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						from
						until
							js.loop_left
						loop
							js.reset
							l_rstate.ce_gets (a_rstate);
							((create {CE_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l_rstate.item.mp_algdata.mp_lc)).item.randget_fn).call ([l_rstate, l_a, l_bits])
							js.break
						end
						js.reset
						l_ret := l_a[0]
						if (builtin_expect ((l_ret < a_n).to_integer, 1)).to_boolean then
							l_pos := -1 + 5 -- goto done
						end
				when 3 then
						l_i := l_i + 1
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					l_ret := l_ret - a_n
				when 5 then -- done:
					Result := l_ret
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
