class
	P_RANDOM

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_random (a_x___2: CE_POINTER [PD_MPZ_STRUCT]; a_size: INTEGER_32)
		local
			l_tmp: INTEGER_32
		do
			if a_size >= 0 then
				l_tmp := a_size
			else
				l_tmp := -a_size
			end
			if not rands_inst.gmp_rands_initialized.to_boolean then
				rands_inst.gmp_rands_initialized := (1).to_integer_8
				randmt_inst.gmp_randinit_mt_noseed (create {CE_POINTER [PD_GMP_RANDSTATE_STRUCT]}.make_cast (gmp_impl_inst.gmp_rands))
			end
			urandomb_inst.gmpz_urandomb (a_x___2, create {CE_POINTER [PD_GMP_RANDSTATE_STRUCT]}.make_cast (gmp_impl_inst.gmp_rands), (l_tmp * 32).to_natural_32)
			if a_size < 0 then
				a_x___2.item.mp_size := -a_x___2.item.mp_size
			end
		end

	gmpn_random (a_ptr: CE_POINTER [NATURAL_32]; a_size: INTEGER_32)
		local
			l_rands: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l_rstate___0: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			js: JUMP_STATE
		do
			create l_rands.make
			create l_rstate.make
			create l_rstate___0.make

			if a_size = 0 then
				js.return
			end
			if not js.return_called then
				if not rands_inst.gmp_rands_initialized.to_boolean then
					rands_inst.gmp_rands_initialized := (1).to_integer_8
					randmt_inst.gmp_randinit_mt_noseed (create {CE_POINTER [PD_GMP_RANDSTATE_STRUCT]}.make_cast (gmp_impl_inst.gmp_rands))
				end
				l_rands.ce_gets (gmp_impl_inst.gmp_rands)
				from
				until
					js.loop_left
				loop
					js.reset
					l_rstate.ce_gets (l_rands);
					((create {CE_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l_rstate.item.mp_algdata.mp_lc)).item.randget_fn).call ([l_rstate, a_ptr, (a_size * 32).to_natural_32])
					js.break
				end
				js.reset
				from
				until
					not (not js.loop_left and then (a_ptr[(a_size - 1)] = {NATURAL_32} 0))
				loop
					from
					until
						js.loop_left
					loop
						js.reset
						l_rstate___0.ce_gets (l_rands);
						((create {CE_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l_rstate___0.item.mp_algdata.mp_lc)).item.randget_fn).call ([l_rstate___0, a_ptr + (a_size - 1), {NATURAL_32} 32])
						js.break
					end
					js.reset
				end
			end
		end

end
