class
	P_REDC_2

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_addmul_2 (a_rp: CE_POINTER [NATURAL_32]; a_up: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_vp: CE_POINTER [NATURAL_32]): NATURAL_32
		do
			a_rp[a_n] := gmp_inst.gmpn_addmul_1 (a_rp, a_up, a_n, a_vp[0])
			Result := (gmp_inst.gmpn_addmul_1 (a_rp + 1, a_up, a_n, a_vp[1]))
		end

	gmpn_redc_2 (a_rp: CE_POINTER [NATURAL_32]; a_up: CE_POINTER [NATURAL_32]; a_mp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_mip: CE_POINTER [NATURAL_32])
		local
			l_up: CE_POINTER [NATURAL_32]
			l_q: CE_ARRAY [NATURAL_32]
			l_j: INTEGER_32
			l_upn: NATURAL_32
			l_cy: NATURAL_32
			l_ph: NATURAL_32
			l_pl: NATURAL_32
			js: JUMP_STATE
		do
			create l_up.make
			create l_q.make (<<2>>)

			l_up.ce_gets (a_up)
			if ((a_n).bit_and (1)) /= 0 then
				l_up[0] := gmp_inst.gmpn_addmul_1 (l_up, a_mp, a_n, (l_up[0] * a_mip[0]).bit_and ({NATURAL_32} 4294967295))
				l_up.ce_gets (l_up + 1)
			end
			l_j := a_n - 2
			from
			until
				not (not js.loop_left and then (l_j >= 0))
			loop
				from
				until
					js.loop_left
				loop
					js.reset
					asm339 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_pl), create {CE_POINTER [NATURAL_32]}.make_shared ($l_ph), a_mip.address, l_up.address)
					l_q[1] := (l_ph + (a_mip[0] * l_up[1])) + (a_mip[1] * l_up[0])
					l_q[0] := l_pl
					js.break
				end
				js.reset
				l_upn := l_up[a_n]
				l_up[1] := gmpn_addmul_2 (l_up, a_mp, a_n, create {CE_POINTER [NATURAL_32]}.make_cast (l_q))
				l_up[0] := l_up[a_n]
				l_up[a_n] := l_upn
				l_up.ce_gets (l_up + (2))
				l_j := l_j - (2)
			end
			l_cy := gmp_inst.gmpn_add_n (a_rp, l_up, (l_up - a_n), a_n)
			if l_cy /= {NATURAL_32} 0 then
				gmp_inst.gmpn_sub_n (a_rp, a_rp, a_mp, a_n).do_nothing
			end
		end

end
