class
	P_RRANDOMB

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_rrandomb (a_x___2: CE_POINTER [PD_MPZ_STRUCT]; a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_nbits: NATURAL_32)
		local
			l_nl: INTEGER_32
		do
			l_nl := (((a_nbits + {NATURAL_32} 32) - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32
			if a_nbits /= {NATURAL_32} 0 then
				if (builtin_expect ((l_nl > (a_x___2.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					realloc_inst.gmpz_realloc (a_x___2, l_nl).do_nothing
				end
				gmp_rrandomb (a_x___2.item.mp_d, a_rstate, a_nbits)
			end
			a_x___2.item.mp_size := l_nl.to_integer_32
		end

	gmp_rrandomb (a_rp: CE_POINTER [NATURAL_32]; a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_nbits: NATURAL_32)
		local
			l_bi: NATURAL_32
			l_ranm: NATURAL_32
			l_cap_chunksize: NATURAL_32
			l_chunksize: NATURAL_32
			l_i: INTEGER_32
			l_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l_rstate___0: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l_rstate___1: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l_ptr_dummy: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_rstate.make
			create l_rstate___0.make
			create l_rstate___1.make
			create l_ptr_dummy.make

			l_i := (((a_nbits + {NATURAL_32} 32) - {NATURAL_32} 1) // {NATURAL_32} 32 - {NATURAL_32} 1).to_integer_32
			a_rp[l_i] := ({NATURAL_32} 4294967295).bit_shift_right ((({NATURAL_32} 32 - a_nbits \\ {NATURAL_32} 32) \\ {NATURAL_32} 32).to_integer_32)
			l_i := l_i - 1
			from
			until
				not (l_i >= 0)
			loop
				a_rp[l_i] := {NATURAL_32} 4294967295
				l_i := l_i - 1
			end
			from
			until
				js.loop_left
			loop
				js.reset
				l_rstate.ce_gets (a_rstate);
				((create {CE_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l_rstate.item.mp_algdata.mp_lc)).item.randget_fn).call ([l_rstate, create {CE_POINTER [NATURAL_32]}.make_shared ($l_ranm), {NATURAL_32} 32])
				js.break
			end
			js.reset
			l_cap_chunksize := (a_nbits // (l_ranm \\ {NATURAL_32} 4 + {NATURAL_32} 1)).to_natural_32
			l_cap_chunksize := l_cap_chunksize + (l_cap_chunksize = {NATURAL_32} 0).to_integer.to_natural_32
			l_bi := a_nbits
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					l_rstate___0.ce_gets (a_rstate);
					((create {CE_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l_rstate___0.item.mp_algdata.mp_lc)).item.randget_fn).call ([l_rstate___0, create {CE_POINTER [NATURAL_32]}.make_shared ($l_ranm), {NATURAL_32} 32])
					js.break
				end
				js.reset
				l_chunksize := ({NATURAL_32} 1 + l_ranm \\ l_cap_chunksize.to_natural_32).to_natural_32
				if l_bi < l_chunksize.to_natural_32 then
					l_bi := (0).to_natural_32
				else
					l_bi := l_bi - l_chunksize.to_natural_32
				end
				if l_bi = {NATURAL_32} 0 then
					js.break
				end
				if not js.loop_jumped then
					a_rp[(l_bi // {NATURAL_32} 32).to_integer_32] := (a_rp[(l_bi // {NATURAL_32} 32).to_integer_32]).bit_xor ((({NATURAL_32} 1).bit_shift_left ((l_bi \\ {NATURAL_32} 32).to_integer_32)))
					from
					until
						js.loop_left
					loop
						js.reset
						l_rstate___1.ce_gets (a_rstate);
						((create {CE_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l_rstate___1.item.mp_algdata.mp_lc)).item.randget_fn).call ([l_rstate___1, create {CE_POINTER [NATURAL_32]}.make_shared ($l_ranm), {NATURAL_32} 32])
						js.break
					end
					js.reset
					l_chunksize := ({NATURAL_32} 1 + l_ranm \\ l_cap_chunksize.to_natural_32).to_natural_32
					if l_bi < l_chunksize.to_natural_32 then
						l_bi := (0).to_natural_32
					else
						l_bi := l_bi - l_chunksize.to_natural_32
					end
					from
					until
						js.loop_left
					loop
						js.reset
						asm25 (l_ptr_dummy.address, a_rp.address, create {CE_POINTER [NATURAL_32]}.make_shared ($l_bi))
						js.break
					end
					js.reset
					if l_bi = {NATURAL_32} 0 then
						js.break
					end
				end
			end
			js.reset
		end

end
