class
	P_SBPI1_DIV_Q

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_sbpi1_div_q (a_qp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_dinv: NATURAL_32): NATURAL_32
		local
			l_qp: CE_POINTER [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_dp: CE_POINTER [NATURAL_32]
			l_dn: INTEGER_32
			l_qh: NATURAL_32
			l_qn: INTEGER_32
			l_i: INTEGER_32
			l_n1: NATURAL_32
			l_n0: NATURAL_32
			l_d1: NATURAL_32
			l_d0: NATURAL_32
			l_cy: NATURAL_32
			l_cy1: NATURAL_32
			l_q: NATURAL_32
			l_flag: NATURAL_32
			l_dn_orig: INTEGER_32
			l_dp_orig: CE_POINTER [NATURAL_32]
			l_np_orig: CE_POINTER [NATURAL_32]
			l_q0: NATURAL_32
			l_t1: NATURAL_32
			l_t0: NATURAL_32
			l_mask: NATURAL_32
			l_q0___0: NATURAL_32
			l_t1___0: NATURAL_32
			l_t0___0: NATURAL_32
			l_mask___0: NATURAL_32
			l_q0___1: NATURAL_32
			l_t1___1: NATURAL_32
			l_t0___1: NATURAL_32
			l_mask___1: NATURAL_32
			l_q___0: NATURAL_32
			l_x___2: NATURAL_32
			l_y: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_qp.make
			create l_np.make
			create l_dp.make
			create l_dp_orig.make
			create l_np_orig.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_qp.ce_gets (a_qp)
					l_np.ce_gets (a_np)
					l_dp.ce_gets (a_dp)
					l_dn := a_dn
					l_dn_orig := l_dn
					l_dp_orig.ce_gets (l_dp)
					l_np_orig.ce_gets (l_np)
					l_np.ce_gets (l_np + a_nn)
					l_qn := a_nn - l_dn
					if l_qn + 1 < l_dn then
						l_dp.ce_gets (l_dp + (l_dn - (l_qn + 1)))
						l_dn := l_qn + 1
					end
					l_qh := ((gmp_inst.gmpn_cmp ((l_np - l_dn), l_dp, l_dn)) >= 0).to_integer.to_natural_32
					if l_qh /= {NATURAL_32} 0 then
						gmp_inst.gmpn_sub_n (l_np - l_dn, (l_np - l_dn), l_dp, l_dn).do_nothing
					end
					l_qp.ce_gets (l_qp + l_qn)
					l_dn := l_dn - (2)
					l_d1 := l_dp[(l_dn + 1)]
					l_d0 := l_dp[l_dn]
					l_np.ce_gets (l_np - (2))
					l_n1 := l_np[1]
					l_i := l_qn - (l_dn + 2)
				when 1 then -- loop condition:
					if not (not js.loop_left and then (l_i >= 0)) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						l_np.ce_gets (l_np - 1)
						if not ((builtin_expect ((l_n1 = l_d1).to_integer, 0)).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if l_np[1] = l_d0 then
							l_q := {NATURAL_32} 4294967295
							gmp_inst.gmpn_submul_1 (l_np - l_dn, l_dp, l_dn + 2, l_q).do_nothing
							l_n1 := l_np[1]
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							asm240 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_q0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_q), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($a_dinv))
							asm241 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_q), create {CE_POINTER [NATURAL_32]}.make_shared ($l_q0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), l_np.address)
							l_n1 := l_np[1] - l_d1 * l_q
							l_n0 := l_np[0]
							asm242 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d0))
							asm243 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_t0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_q))
							asm244 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t0))
							l_q := l_q + 1
							l_mask := (-(l_n1 >= l_q0).to_integer).to_natural_32
							l_q := l_q + l_mask
							asm245 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_mask), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d0))
							if (builtin_expect ((l_n1 >= l_d1).to_integer, 0)).to_boolean then
								if l_n1 > l_d1 then
									l_q := l_q + 1
									asm246 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d0))
								elseif l_n0 >= l_d0 then
									l_q := l_q + 1
									asm247 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d0))
								end
							end
							js.break
						end
						js.reset
						l_cy := gmp_inst.gmpn_submul_1 (l_np - l_dn, l_dp, l_dn, l_q)
						l_cy1 := (l_n0 < l_cy).to_integer.to_natural_32
						l_n0 := ((l_n0 - l_cy)).bit_and ({NATURAL_32} 4294967295)
						l_cy := (l_n1 < l_cy1).to_integer.to_natural_32
						l_n1 := l_n1 - l_cy1
						l_np[0] := l_n0
						if (builtin_expect ((l_cy /= {NATURAL_32} 0).to_integer, 0)).to_boolean then
							l_n1 := l_n1 + (l_d1 + (gmp_inst.gmpn_add_n (l_np - l_dn, (l_np - l_dn), l_dp, l_dn + 1)))
							l_q := l_q - 1
						end
				when 6 then
						l_qp.ce_gets (l_qp - 1)
						l_qp.item := l_q
						l_i := l_i - 1
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					l_flag := ((0).to_natural_32).bit_not
					if l_dn >= 0 then
						l_i := l_dn
						from
						until
							not (not js.loop_left and then (l_i > 0))
						loop
							l_np.ce_gets (l_np - 1)
							if (builtin_expect ((l_n1 >= ((l_d1).bit_and (l_flag))).to_integer, 0)).to_boolean then
								l_q := {NATURAL_32} 4294967295
								l_cy := gmp_inst.gmpn_submul_1 (l_np - l_dn, l_dp, l_dn + 2, l_q)
								if (builtin_expect ((l_n1 /= l_cy).to_integer, 0)).to_boolean then
									if l_n1 < ((l_cy).bit_and (l_flag)) then
										l_q := l_q - 1
										gmp_inst.gmpn_add_n (l_np - l_dn, (l_np - l_dn), l_dp, l_dn + 2).do_nothing
									else
										l_flag := (0).to_natural_32
									end
								end
								l_n1 := l_np[1]
							else
								from
								until
									js.loop_left
								loop
									js.reset
									asm248 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_q0___0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_q), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($a_dinv))
									asm249 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_q), create {CE_POINTER [NATURAL_32]}.make_shared ($l_q0___0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), l_np.address)
									l_n1 := l_np[1] - l_d1 * l_q
									l_n0 := l_np[0]
									asm250 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d0))
									asm251 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_t0___0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t1___0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_q))
									asm252 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t1___0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t0___0))
									l_q := l_q + 1
									l_mask___0 := (-(l_n1 >= l_q0___0).to_integer).to_natural_32
									l_q := l_q + l_mask___0
									asm253 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_mask___0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d0))
									if (builtin_expect ((l_n1 >= l_d1).to_integer, 0)).to_boolean then
										if l_n1 > l_d1 then
											l_q := l_q + 1
											asm254 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d0))
										elseif l_n0 >= l_d0 then
											l_q := l_q + 1
											asm255 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d0))
										end
									end
									js.break
								end
								js.reset
								l_cy := gmp_inst.gmpn_submul_1 (l_np - l_dn, l_dp, l_dn, l_q)
								l_cy1 := (l_n0 < l_cy).to_integer.to_natural_32
								l_n0 := ((l_n0 - l_cy)).bit_and ({NATURAL_32} 4294967295)
								l_cy := (l_n1 < l_cy1).to_integer.to_natural_32
								l_n1 := l_n1 - l_cy1
								l_np[0] := l_n0
								if (builtin_expect ((l_cy /= {NATURAL_32} 0).to_integer, 0)).to_boolean then
									l_n1 := l_n1 + (l_d1 + (gmp_inst.gmpn_add_n (l_np - l_dn, (l_np - l_dn), l_dp, l_dn + 1)))
									l_q := l_q - 1
								end
							end
							l_qp.ce_gets (l_qp - 1)
							l_qp.item := l_q
							l_dn := l_dn - 1
							l_dp.ce_gets (l_dp + 1)
							l_i := l_i - 1
						end
						l_np.ce_gets (l_np - 1)
						if (builtin_expect ((l_n1 >= ((l_d1).bit_and (l_flag))).to_integer, 0)).to_boolean then
							l_q := {NATURAL_32} 4294967295
							l_cy := gmp_inst.gmpn_submul_1 (l_np, l_dp, (2).to_integer_32, l_q)
							if (builtin_expect ((l_n1 /= l_cy).to_integer, 0)).to_boolean then
								if l_n1 < ((l_cy).bit_and (l_flag)) then
									l_q := l_q - 1
									asm256 (l_np.address, l_dp.address)
								else
									l_flag := (0).to_natural_32
								end
							end
							l_n1 := l_np[1]
						else
							from
							until
								js.loop_left
							loop
								js.reset
								asm257 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_q0___1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_q), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($a_dinv))
								asm258 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_q), create {CE_POINTER [NATURAL_32]}.make_shared ($l_q0___1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), l_np.address)
								l_n1 := l_np[1] - l_d1 * l_q
								l_n0 := l_np[0]
								asm259 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d0))
								asm260 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_t0___1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t1___1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_q))
								asm261 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t1___1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t0___1))
								l_q := l_q + 1
								l_mask___1 := (-(l_n1 >= l_q0___1).to_integer).to_natural_32
								l_q := l_q + l_mask___1
								asm262 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_mask___1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d0))
								if (builtin_expect ((l_n1 >= l_d1).to_integer, 0)).to_boolean then
									if l_n1 > l_d1 then
										l_q := l_q + 1
										asm263 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d0))
									elseif l_n0 >= l_d0 then
										l_q := l_q + 1
										asm264 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d0))
									end
								end
								js.break
							end
							js.reset
							l_np[0] := l_n0
							l_np[1] := l_n1
						end
						l_qp.ce_gets (l_qp - 1)
						l_qp.item := l_q
					end
					from
					until
						js.loop_left
					loop
						js.reset
						if l_np[1] /= l_n1 then
							assert_inst.gmp_assert_fail (ce_string ("sbpi1_div_q.c"), 187, ce_string ("np[1] == n1"))
						end
						js.break
					end
					js.reset
					l_np.ce_gets (l_np + (2))
					l_dn := l_dn_orig
					if (builtin_expect ((l_n1 < ((l_dn.to_natural_32).bit_and (l_flag))).to_integer, 0)).to_boolean then
						l_x___2 := l_n1
						if l_dn > 2 then
							l_dp.ce_gets (l_dp_orig)
							if l_qn + 1 < l_dn then
								l_dp.ce_gets (l_dp + (l_dn - (l_qn + 1)))
								l_dn := l_qn + 1
							end
							l_y := l_np[-2]
							l_i := l_dn - 3
							from
							until
								not (not js.loop_left and then (l_i >= 0))
							loop
								l_q___0 := l_qp[l_i]
								l_cy := gmp_inst.gmpn_submul_1 (l_np - (l_dn - l_i), l_dp, (l_dn - l_i) - 2, l_q___0)
								if l_y < l_cy then
									if l_x___2 = {NATURAL_32} 0 then
										l_cy := gmp_inst.gmpn_sub_1 (l_qp, l_qp, l_qn, (1).to_natural_32)
										from
										until
											js.loop_left
										loop
											js.reset
											if l_cy /= {NATURAL_32} 0 then
												assert_inst.gmp_assert_fail (ce_string ("sbpi1_div_q.c"), 238, ce_string ("cy == 0"))
											end
											js.break
										end
										js.reset
										Result := (l_qh - l_cy)
										js.return
									end
									if not js.return_called then
										l_x___2 := l_x___2 - 1
									end
								end
								if not js.return_called then
									l_y := l_y - l_cy
									l_i := l_i - 1
								end
							end
							if not js.return_called then
								l_np[-2] := l_y
							end
						end
						if not js.return_called then
							l_dn := l_dn_orig
							if l_qn + 1 < l_dn then
								l_dp.ce_gets (l_dp_orig)
								l_np.ce_gets (l_np_orig)
								if l_qh /= {NATURAL_32} 0 then
									l_cy := gmp_inst.gmpn_sub_n (l_np + l_qn, (l_np + l_qn), l_dp, l_dn - (l_qn + 1))
									if l_cy /= {NATURAL_32} 0 then
										if l_x___2 = {NATURAL_32} 0 then
											if l_qn /= 0 then
												l_cy := gmp_inst.gmpn_sub_1 (l_qp, l_qp, l_qn, (1).to_natural_32)
											end
											Result := (l_qh - l_cy)
											js.return
										end
										if not js.return_called then
											l_x___2 := l_x___2 - 1
										end
									end
								end
								if not js.return_called and then (l_qn = 0) then
									Result := l_qh
									js.return
								end
								if not js.return_called then
									l_i := (l_dn - l_qn) - 2
									from
									until
										not (not js.loop_left and then (l_i >= 0))
									loop
										l_cy := gmp_inst.gmpn_submul_1 (l_np + l_i, l_qp, l_qn, l_dp[l_i])
										l_cy := gmp_inst.gmpn_sub_1 ((l_np + l_qn) + l_i, ((l_np + l_qn) + l_i), ((l_dn - l_qn) - l_i) - 1, l_cy)
										if l_cy /= {NATURAL_32} 0 then
											if l_x___2 = {NATURAL_32} 0 then
												l_cy := gmp_inst.gmpn_sub_1 (l_qp, l_qp, l_qn, (1).to_natural_32)
												Result := l_qh
												js.return
											end
											if not js.return_called then
												l_x___2 := l_x___2 - 1
											end
										end
										if not js.return_called then
											l_i := l_i - 1
										end
									end
								end
							end
						end
					end
					if not js.return_called then
						Result := l_qh
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
