class
	P_SBPI1_DIV_QR

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_sbpi1_div_qr (a_qp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_dinv: NATURAL_32): NATURAL_32
		local
			l_qp: CE_POINTER [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_dn: INTEGER_32
			l_qh: NATURAL_32
			l_i: INTEGER_32
			l_n1: NATURAL_32
			l_n0: NATURAL_32
			l_d1: NATURAL_32
			l_d0: NATURAL_32
			l_cy: NATURAL_32
			l_cy1: NATURAL_32
			l_q: NATURAL_32
			l_q0: NATURAL_32
			l_t1: NATURAL_32
			l_t0: NATURAL_32
			l_mask: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_qp.make
			create l_np.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_qp.ce_gets (a_qp)
					l_np.ce_gets (a_np)
					l_dn := a_dn
					l_np.ce_gets (l_np + a_nn)
					l_qh := ((gmp_inst.gmpn_cmp ((l_np - l_dn), a_dp, l_dn)) >= 0).to_integer.to_natural_32
					if l_qh /= {NATURAL_32} 0 then
						gmp_inst.gmpn_sub_n (l_np - l_dn, (l_np - l_dn), a_dp, l_dn).do_nothing
					end
					l_qp.ce_gets (l_qp + (a_nn - l_dn))
					l_dn := l_dn - (2)
					l_d1 := a_dp[(l_dn + 1)]
					l_d0 := a_dp[l_dn]
					l_np.ce_gets (l_np - (2))
					l_n1 := l_np[1]
					l_i := a_nn - (l_dn + 2)
				when 1 then -- loop condition:
					if not (not js.loop_left and then (l_i > 0)) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						l_np.ce_gets (l_np - 1)
						if not ((builtin_expect ((l_n1 = l_d1).to_integer, 0)).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if l_np[1] = l_d0 then
							l_q := {NATURAL_32} 4294967295
							gmp_inst.gmpn_submul_1 (l_np - l_dn, a_dp, l_dn + 2, l_q).do_nothing
							l_n1 := l_np[1]
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						from
						until
							js.loop_left
						loop
							js.reset
							asm265 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_q0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_q), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($a_dinv))
							asm266 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_q), create {CE_POINTER [NATURAL_32]}.make_shared ($l_q0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), l_np.address)
							l_n1 := l_np[1] - l_d1 * l_q
							l_n0 := l_np[0]
							asm267 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d0))
							asm268 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_t0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_q))
							asm269 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_t0))
							l_q := l_q + 1
							l_mask := (-(l_n1 >= l_q0).to_integer).to_natural_32
							l_q := l_q + l_mask
							asm270 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_mask), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d0))
							if (builtin_expect ((l_n1 >= l_d1).to_integer, 0)).to_boolean then
								if l_n1 > l_d1 then
									l_q := l_q + 1
									asm271 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d0))
								elseif l_n0 >= l_d0 then
									l_q := l_q + 1
									asm272 (create {CE_POINTER [NATURAL_32]}.make_shared ($l_n1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_n0), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_d0))
								end
							end
							js.break
						end
						js.reset
						l_cy := gmp_inst.gmpn_submul_1 (l_np - l_dn, a_dp, l_dn, l_q)
						l_cy1 := (l_n0 < l_cy).to_integer.to_natural_32
						l_n0 := ((l_n0 - l_cy)).bit_and ({NATURAL_32} 4294967295)
						l_cy := (l_n1 < l_cy1).to_integer.to_natural_32
						l_n1 := ((l_n1 - l_cy1)).bit_and ({NATURAL_32} 4294967295)
						l_np[0] := l_n0
						if (builtin_expect ((l_cy /= {NATURAL_32} 0).to_integer, 0)).to_boolean then
							l_n1 := l_n1 + (l_d1 + (gmp_inst.gmpn_add_n (l_np - l_dn, (l_np - l_dn), a_dp, l_dn + 1)))
							l_q := l_q - 1
						end
				when 6 then
						l_qp.ce_gets (l_qp - 1)
						l_qp.item := l_q
						l_i := l_i - 1
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					l_np[1] := l_n1
					Result := l_qh
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
