class
	P_SQRT_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_sqrt_ui (a_r: CE_POINTER [PD_MPF_STRUCT]; a_u: NATURAL_32)
		local
			l_rsize: INTEGER_32
			l_zeros: INTEGER_32
			l_tp: CE_POINTER [NATURAL_32]
			l_prec: INTEGER_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_tmp___3: CE_POINTER [ANY]
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp___5: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_tp.make
			create l_tmp_marker.make
			create l_tmp___3.make
			create l_dst.make
			create l_tmp___5.make

			if (builtin_expect ((a_u = {NATURAL_32} 0).to_integer, 0)).to_boolean then
				a_r.item.mp_size := 0
				a_r.item.mp_exp := (0).to_integer_32
				js.return
			end
			if not js.return_called then
				l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
				l_prec := (a_r.item.mp_prec).to_integer_32
				l_zeros := 2 * l_prec - 2
				l_rsize := l_zeros + 1
				if (builtin_expect ((l_rsize.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
					l_tmp___3.ce_gets ((l_aaf.new ((l_rsize.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				else
					l_tmp___3.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_rsize.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				end
				l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___3))
				from
				until
					js.loop_left
				loop
					js.reset
					if l_zeros /= 0 then
						l_dst.ce_gets (l_tp)
						l_n := l_zeros
						from
						until
							js.loop_left
						loop
							js.reset
							l_tmp___5.ce_gets (l_dst)
							l_dst.ce_gets (l_dst + 1)
							l_tmp___5.item := (0).to_natural_32
							l_n := l_n - 1
							if not l_n.to_boolean then
								js.break
							end
						end
						js.reset
					end
					js.break
				end
				js.reset
				l_tp[l_zeros] := (a_u).bit_and ({NATURAL_32} 4294967295)
				sqrtrem_inst.gmpn_sqrtrem (a_r.item.mp_d, create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer), l_tp, l_rsize).do_nothing
				a_r.item.mp_size := l_prec.to_integer_32
				a_r.item.mp_exp := (1).to_integer_32
				from
				until
					js.loop_left
				loop
					js.reset
					if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
					end
					js.break
				end
				js.reset
			end
		end

end
