class
	P_SUB_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_sub_ui (a_sum: CE_POINTER [PD_MPF_STRUCT]; a_u: CE_POINTER [PD_MPF_STRUCT]; a_v: NATURAL_32)
		local
			l_vv: PD_MPF_STRUCT
			l_vl: NATURAL_32
			js: JUMP_STATE
		do
			create l_vv.make

			if a_v = {NATURAL_32} 0 then
				set_inst.gmpf_set (a_sum, a_u)
				js.return
			end
			if not js.return_called then
				l_vl := a_v
				l_vv.mp_size := 1
				l_vv.mp_d := create {CE_POINTER [NATURAL_32]}.make_shared ($l_vl)
				l_vv.mp_exp := (1).to_integer_32
				sub_inst.gmpf_sub (a_sum, a_u, (l_vv.address))
			end
		end

end
