class
	P_SUBCND_N

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_subcnd_n (a_rp: CE_POINTER [NATURAL_32]; a_up: CE_POINTER [NATURAL_32]; a_vp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_cnd: NATURAL_32): NATURAL_32
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_ul: NATURAL_32
			l_vl: NATURAL_32
			l_sl: NATURAL_32
			l_rl: NATURAL_32
			l_cy: NATURAL_32
			l_cy1: NATURAL_32
			l_cy2: NATURAL_32
			l_mask: NATURAL_32
			l_tmp: CE_POINTER [NATURAL_32]
			l_tmp___0: CE_POINTER [NATURAL_32]
			l_tmp___1: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_rp.make
			create l_up.make
			create l_vp.make
			create l_tmp.make
			create l_tmp___0.make
			create l_tmp___1.make

			l_rp.ce_gets (a_rp)
			l_up.ce_gets (a_up)
			l_vp.ce_gets (a_vp)
			l_n := a_n
			l_mask := (-(a_cnd /= {NATURAL_32} 0).to_integer).to_natural_32
			l_cy := (0).to_natural_32
			from
			until
				js.loop_left
			loop
				js.reset
				l_tmp.ce_gets (l_up)
				l_up.ce_gets (l_up + 1)
				l_ul := l_tmp.item
				l_tmp___0.ce_gets (l_vp)
				l_vp.ce_gets (l_vp + 1)
				l_vl := ((l_tmp___0.item).bit_and (l_mask))
				l_sl := l_ul - l_vl
				l_cy1 := (l_sl > l_ul).to_integer.to_natural_32
				l_rl := l_sl - l_cy
				l_cy2 := (l_rl > l_sl).to_integer.to_natural_32
				l_cy := (l_cy1).bit_or (l_cy2)
				l_tmp___1.ce_gets (l_rp)
				l_rp.ce_gets (l_rp + 1)
				l_tmp___1.item := l_rl
				l_n := l_n - 1
				if l_n = 0 then
					js.break
				end
			end
			js.reset
			Result := l_cy
		end

end
