class
	P_TOOM2_SQR

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_toom2_sqr (a_pp: CE_POINTER [NATURAL_32]; a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		local
			l_n: INTEGER_32
			l_s: INTEGER_32
			l_cy: NATURAL_32
			l_cy2: NATURAL_32
			l_asm1: CE_POINTER [NATURAL_32]
			l_dst: CE_POINTER [NATURAL_32]
			l_n2: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_32]
			l_ptr_dummy: CE_POINTER [NATURAL_32]
			l_ptr_dummy___0: CE_POINTER [NATURAL_32]
			l_ptr_dummy___1: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_asm1.make
			create l_dst.make
			create l_tmp___0.make
			create l_ptr_dummy.make
			create l_ptr_dummy___0.make
			create l_ptr_dummy___1.make

			l_s := (a_an).bit_shift_right (1)
			l_n := a_an - l_s
			l_asm1.ce_gets (a_pp)
			if l_s = l_n then
				if (gmp_inst.gmpn_cmp (a_ap, a_ap + l_n, l_n)) < 0 then
					gmp_inst.gmpn_sub_n (l_asm1, a_ap + l_n, a_ap, l_n).do_nothing
				else
					gmp_inst.gmpn_sub_n (l_asm1, a_ap, a_ap + l_n, l_n).do_nothing
				end
			elseif (gmp_impl_inst.mpn_zero_p (a_ap + l_s, l_n - l_s)).to_boolean then
				if (gmp_inst.gmpn_cmp (a_ap, a_ap + l_n, l_s)) < 0 then
					gmp_inst.gmpn_sub_n (l_asm1, a_ap + l_n, a_ap, l_s).do_nothing
					from
					until
						js.loop_left
					loop
						js.reset
						if l_n - l_s /= 0 then
							l_dst.ce_gets (l_asm1 + l_s)
							l_n2 := l_n - l_s
							from
							until
								js.loop_left
							loop
								js.reset
								l_tmp___0.ce_gets (l_dst)
								l_dst.ce_gets (l_dst + 1)
								l_tmp___0.item := (0).to_natural_32
								l_n2 := l_n2 - 1
								if not l_n2.to_boolean then
									js.break
								end
							end
							js.reset
						end
						js.break
					end
					js.reset
				else
					gmp_inst.gmpn_sub (l_asm1, a_ap, l_n, a_ap + l_n, l_s).do_nothing
				end
			else
				gmp_inst.gmpn_sub (l_asm1, a_ap, l_n, a_ap + l_n, l_s).do_nothing
			end
			from
			until
				js.loop_left
			loop
				js.reset
				if 30 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n >= 30 then
						gmpn_toom2_sqr (a_scratch, l_asm1, l_n, a_scratch + 2 * l_n)
					else
						gmp_impl_inst.gmpn_sqr_basecase (a_scratch, l_asm1, l_n)
					end
				else
					gmp_impl_inst.gmpn_sqr_basecase (a_scratch, l_asm1, l_n)
				end
				js.break
			end
			js.reset
			from
			until
				js.loop_left
			loop
				js.reset
				if 30 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_s >= 30 then
						gmpn_toom2_sqr (a_pp + 2 * l_n, a_ap + l_n, l_s, a_scratch + 2 * l_n)
					else
						gmp_impl_inst.gmpn_sqr_basecase (a_pp + 2 * l_n, a_ap + l_n, l_s)
					end
				else
					gmp_impl_inst.gmpn_sqr_basecase (a_pp + 2 * l_n, a_ap + l_n, l_s)
				end
				js.break
			end
			js.reset
			from
			until
				js.loop_left
			loop
				js.reset
				if 30 /= -((({NATURAL_32} 4294967295).bit_xor ((({NATURAL_32} 4294967295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n >= 30 then
						gmpn_toom2_sqr (a_pp, a_ap, l_n, a_scratch + 2 * l_n)
					else
						gmp_impl_inst.gmpn_sqr_basecase (a_pp, a_ap, l_n)
					end
				else
					gmp_impl_inst.gmpn_sqr_basecase (a_pp, a_ap, l_n)
				end
				js.break
			end
			js.reset
			l_cy := gmp_inst.gmpn_add_n (a_pp + 2 * l_n, (a_pp + l_n), (a_pp + 2 * l_n), l_n)
			l_cy2 := l_cy + (gmp_inst.gmpn_add_n (a_pp + l_n, (a_pp + 2 * l_n), a_pp, l_n))
			l_cy := l_cy + (gmp_inst.gmpn_add (a_pp + 2 * l_n, (a_pp + 2 * l_n), l_n, ((a_pp + 2 * l_n) + l_n), (l_s + l_s) - l_n))
			l_cy := l_cy - (gmp_inst.gmpn_sub_n (a_pp + l_n, (a_pp + l_n), a_scratch, 2 * l_n))
			from
			until
				js.loop_left
			loop
				js.reset
				asm140 (l_ptr_dummy.address, a_pp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy2))
				js.break
			end
			js.reset
			if (builtin_expect ((l_cy <= {NATURAL_32} 2).to_integer, 1)).to_boolean then
				from
				until
					js.loop_left
				loop
					js.reset
					asm141 (l_ptr_dummy___0.address, a_pp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
					js.break
				end
				js.reset
			else
				from
				until
					js.loop_left
				loop
					js.reset
					asm142 (l_ptr_dummy___1.address, a_pp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n))
					js.break
				end
				js.reset
			end
		end

end
