class
	P_TOOM_EVAL_PM2

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_toom_eval_pm2 (a_xp2: CE_POINTER [NATURAL_32]; a_xm2: CE_POINTER [NATURAL_32]; a_k: NATURAL_32; a_xp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_hn: INTEGER_32; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_k: NATURAL_32
			l_i: INTEGER_32
			l_neg: INTEGER_32
			l_cy: NATURAL_32
			js: JUMP_STATE
		do
			l_k := a_k
			l_cy := (0).to_natural_32
			from
			until
				js.loop_left
			loop
				js.reset
				l_cy := (l_cy).bit_shift_left ((2))
				l_cy := l_cy + (gmp_inst.gmpn_lshift (a_xp2, a_xp + (l_k.to_natural_32 * a_n.to_natural_32).to_integer_32, a_hn, {NATURAL_32} 2))
				l_cy := l_cy + (gmp_inst.gmpn_add_n (a_xp2, a_xp2, a_xp + ((l_k - {NATURAL_32} 2).to_natural_32 * a_n.to_natural_32).to_integer_32, a_hn))
				js.break
			end
			js.reset
			if a_hn /= a_n then
				l_cy := gmp_inst.gmpn_add_1 (a_xp2 + a_hn, (a_xp + ((l_k - {NATURAL_32} 2).to_natural_32 * a_n.to_natural_32).to_integer_32) + a_hn, a_n - a_hn, l_cy)
			end
			l_i := (l_k - {NATURAL_32} 4).to_integer_32
			from
			until
				not (not js.loop_left and then (l_i >= 0))
			loop
				from
				until
					js.loop_left
				loop
					js.reset
					l_cy := (l_cy).bit_shift_left ((2))
					l_cy := l_cy + (gmp_inst.gmpn_lshift (a_xp2, a_xp2, a_n, {NATURAL_32} 2))
					l_cy := l_cy + (gmp_inst.gmpn_add_n (a_xp2, a_xp2, a_xp + l_i.to_integer_32 * a_n, a_n))
					js.break
				end
				js.reset
				l_i := l_i - (2)
			end
			a_xp2[a_n] := l_cy
			l_k := l_k - 1
			l_cy := (0).to_natural_32
			from
			until
				js.loop_left
			loop
				js.reset
				l_cy := (l_cy).bit_shift_left ((2))
				l_cy := l_cy + (gmp_inst.gmpn_lshift (a_tp, a_xp + (l_k.to_natural_32 * a_n.to_natural_32).to_integer_32, a_n, {NATURAL_32} 2))
				l_cy := l_cy + (gmp_inst.gmpn_add_n (a_tp, a_tp, a_xp + ((l_k - {NATURAL_32} 2).to_natural_32 * a_n.to_natural_32).to_integer_32, a_n))
				js.break
			end
			js.reset
			l_i := (l_k - {NATURAL_32} 4).to_integer_32
			from
			until
				not (not js.loop_left and then (l_i >= 0))
			loop
				from
				until
					js.loop_left
				loop
					js.reset
					l_cy := (l_cy).bit_shift_left ((2))
					l_cy := l_cy + (gmp_inst.gmpn_lshift (a_tp, a_tp, a_n, {NATURAL_32} 2))
					l_cy := l_cy + (gmp_inst.gmpn_add_n (a_tp, a_tp, a_xp + l_i.to_integer_32 * a_n, a_n))
					js.break
				end
				js.reset
				l_i := l_i - (2)
			end
			a_tp[a_n] := l_cy
			if ((l_k).bit_and ({NATURAL_32} 1)).to_boolean then
				gmp_inst.gmpn_lshift (a_tp, a_tp, a_n + 1, {NATURAL_32} 1).do_nothing
			else
				gmp_inst.gmpn_lshift (a_xp2, a_xp2, a_n + 1, {NATURAL_32} 1).do_nothing
			end
			if (gmp_inst.gmpn_cmp (a_xp2, a_tp, a_n + 1)) < 0 then
				l_neg := (0).bit_not
			else
				l_neg := 0
			end
			if l_neg.to_boolean then
				gmp_inst.gmpn_sub_n (a_xm2, a_tp, a_xp2, a_n + 1).do_nothing
			else
				gmp_inst.gmpn_sub_n (a_xm2, a_xp2, a_tp, a_n + 1).do_nothing
			end
			gmp_inst.gmpn_add_n (a_xp2, a_xp2, a_tp, a_n + 1).do_nothing
			l_neg := ((l_neg.to_natural_32).bit_xor ((((l_k).bit_and ({NATURAL_32} 1)) - {NATURAL_32} 1))).to_integer_32
			Result := l_neg
		end

end
