class
	P_TOOM_INTERPOLATE_12PTS

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	DO_mpn_sublsh_n___0 (a_dst: CE_POINTER [NATURAL_32]; a_src: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_s: NATURAL_32; a_ws: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_cy: NATURAL_32
		do
			l_cy := gmp_inst.gmpn_lshift (a_ws, a_src, a_n, a_s)
			Result := (l_cy + (gmp_inst.gmpn_sub_n (a_dst, a_dst, a_ws, a_n)))
		end

	gmpn_toom_interpolate_12pts (a_pp: CE_POINTER [NATURAL_32]; a_r1: CE_POINTER [NATURAL_32]; a_r3: CE_POINTER [NATURAL_32]; a_r5: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_spt: INTEGER_32; a_half: INTEGER_32; a_wsi: CE_POINTER [NATURAL_32])
		local
			l_r1: CE_POINTER [NATURAL_32]
			l_r5: CE_POINTER [NATURAL_32]
			l_wsi: CE_POINTER [NATURAL_32]
			l_cy: NATURAL_32
			l_n3: INTEGER_32
			l_n3p1: INTEGER_32
			l_ptr_dummy: CE_POINTER [NATURAL_32]
			l_ptr_dummy___0: CE_POINTER [NATURAL_32]
			l_cy2: NATURAL_32
			l_ptr_dummy___1: CE_POINTER [NATURAL_32]
			l_ptr_dummy___2: CE_POINTER [NATURAL_32]
			l_ptr_dummy___3: CE_POINTER [NATURAL_32]
			l_cy___0: NATURAL_32
			l_ptr_dummy___4: CE_POINTER [NATURAL_32]
			l_ptr_dummy___5: CE_POINTER [NATURAL_32]
			l_cy___1: NATURAL_32
			l_ptr_dummy___6: CE_POINTER [NATURAL_32]
			l_ptr_dummy___7: CE_POINTER [NATURAL_32]
			l_mp_ptr_swap__tmp: CE_POINTER [NATURAL_32]
			l_cy___2: NATURAL_32
			l_ptr_dummy___8: CE_POINTER [NATURAL_32]
			l_ptr_dummy___9: CE_POINTER [NATURAL_32]
			l_mp_ptr_swap__tmp___0: CE_POINTER [NATURAL_32]
			l_tmp___2: NATURAL_32
			l_ptr_dummy___10: CE_POINTER [NATURAL_32]
			l_ptr_dummy___11: CE_POINTER [NATURAL_32]
			l_ptr_dummy___12: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_r1.make
			create l_r5.make
			create l_wsi.make
			create l_ptr_dummy.make
			create l_ptr_dummy___0.make
			create l_ptr_dummy___1.make
			create l_ptr_dummy___2.make
			create l_ptr_dummy___3.make
			create l_ptr_dummy___4.make
			create l_ptr_dummy___5.make
			create l_ptr_dummy___6.make
			create l_ptr_dummy___7.make
			create l_mp_ptr_swap__tmp.make
			create l_ptr_dummy___8.make
			create l_ptr_dummy___9.make
			create l_mp_ptr_swap__tmp___0.make
			create l_ptr_dummy___10.make
			create l_ptr_dummy___11.make
			create l_ptr_dummy___12.make

			l_r1.ce_gets (a_r1)
			l_r5.ce_gets (a_r5)
			l_wsi.ce_gets (a_wsi)
			l_n3 := 3 * a_n
			l_n3p1 := l_n3 + 1
			if a_half /= 0 then
				l_cy := gmp_inst.gmpn_sub_n (a_r3, a_r3, (a_pp + 11 * a_n), a_spt)
				from
				until
					js.loop_left
				loop
					js.reset
					asm177 (l_ptr_dummy.address, a_r3.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_spt), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
					js.break
				end
				js.reset
				l_cy := DO_mpn_sublsh_n___0 (a_pp + 7 * a_n, (a_pp + 11 * a_n), a_spt, {NATURAL_32} 10, l_wsi)
				from
				until
					js.loop_left
				loop
					js.reset
					asm178 (l_ptr_dummy___0.address, a_pp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), create {CE_POINTER [INTEGER_32]}.make_shared ($a_spt), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
					js.break
				end
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						asm179 (l_ptr_dummy___1.address, l_r5.address, a_pp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n))
						js.break
					end
					js.reset
					l_cy2 := DO_mpn_sublsh_n___0 (l_r5, ((a_pp + 11 * a_n) + 1), a_spt - 1, {NATURAL_32} 30, l_wsi)
					from
					until
						js.loop_left
					loop
						js.reset
						asm180 (l_ptr_dummy___2.address, l_r5.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_spt), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy2))
						js.break
					end
					js.reset
					js.break
				end
				js.reset
				l_cy := DO_mpn_sublsh_n___0 (l_r1, (a_pp + 11 * a_n), a_spt, {NATURAL_32} 20, l_wsi)
				from
				until
					js.loop_left
				loop
					js.reset
					asm181 (l_ptr_dummy___3.address, l_r1.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_spt), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
					js.break
				end
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					from
					until
						js.loop_left
					loop
						js.reset
						asm182 (l_ptr_dummy___4.address, a_pp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n3), create {CE_POINTER [INTEGER_32]}.make_shared ($a_n))
						js.break
					end
					js.reset
					l_cy___0 := DO_mpn_sublsh_n___0 (a_pp + l_n3, ((a_pp + 11 * a_n) + 1), a_spt - 1, {NATURAL_32} 28, l_wsi)
					from
					until
						js.loop_left
					loop
						js.reset
						asm183 (l_ptr_dummy___5.address, a_pp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n3), create {CE_POINTER [INTEGER_32]}.make_shared ($a_spt), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy___0))
						js.break
					end
					js.reset
					js.break
				end
				js.reset
			end
			(a_pp + l_n3)[l_n3] := (a_pp + l_n3)[l_n3] - (DO_mpn_sublsh_n___0 ((a_pp + l_n3) + a_n, a_pp, 2 * a_n, {NATURAL_32} 20, l_wsi))
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					asm184 (l_ptr_dummy___6.address, l_r1.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), a_pp.address)
					js.break
				end
				js.reset
				l_cy___1 := DO_mpn_sublsh_n___0 (l_r1 + a_n, (a_pp + 1), 2 * a_n - 1, {NATURAL_32} 28, l_wsi)
				from
				until
					js.loop_left
				loop
					js.reset
					asm185 (l_ptr_dummy___7.address, l_r1.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy___1))
					js.break
				end
				js.reset
				js.break
			end
			js.reset
			gmp_inst.gmpn_add_n (l_wsi, l_r1, (a_pp + l_n3), l_n3p1).do_nothing
			gmp_inst.gmpn_sub_n (a_pp + l_n3, (a_pp + l_n3), l_r1, l_n3p1).do_nothing
			from
			until
				js.loop_left
			loop
				js.reset
				l_mp_ptr_swap__tmp.ce_gets (l_r1)
				l_r1.ce_gets (l_wsi)
				l_wsi.ce_gets (l_mp_ptr_swap__tmp)
				js.break
			end
			js.reset
			l_r5[l_n3] := l_r5[l_n3] - (DO_mpn_sublsh_n___0 (l_r5 + a_n, a_pp, 2 * a_n, {NATURAL_32} 10, l_wsi))
			from
			until
				js.loop_left
			loop
				js.reset
				from
				until
					js.loop_left
				loop
					js.reset
					asm186 (l_ptr_dummy___8.address, a_pp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n))
					js.break
				end
				js.reset
				l_cy___2 := DO_mpn_sublsh_n___0 ((a_pp + 7 * a_n) + a_n, (a_pp + 1), 2 * a_n - 1, {NATURAL_32} 30, l_wsi)
				from
				until
					js.loop_left
				loop
					js.reset
					asm187 (l_ptr_dummy___9.address, a_pp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy___2))
					js.break
				end
				js.reset
				js.break
			end
			js.reset
			gmp_inst.gmpn_sub_n (l_wsi, l_r5, (a_pp + 7 * a_n), l_n3p1).do_nothing
			gmp_inst.gmpn_add_n (a_pp + 7 * a_n, (a_pp + 7 * a_n), l_r5, l_n3p1).do_nothing
			from
			until
				js.loop_left
			loop
				js.reset
				l_mp_ptr_swap__tmp___0.ce_gets (l_r5)
				l_r5.ce_gets (l_wsi)
				l_wsi.ce_gets (l_mp_ptr_swap__tmp___0)
				js.break
			end
			js.reset
			a_r3[l_n3] := a_r3[l_n3] - (gmp_inst.gmpn_sub_n (a_r3 + a_n, (a_r3 + a_n), a_pp, 2 * a_n))
			gmp_inst.gmpn_submul_1 (a_pp + l_n3, l_r5, l_n3p1, (257).to_natural_32).do_nothing
			gmp_impl_inst.gmpn_divexact_1 (a_pp + l_n3, (a_pp + l_n3), l_n3p1, ({NATURAL_32} 2835).bit_shift_left (2))
			if (((a_pp + l_n3)[l_n3]).bit_and ((({NATURAL_32} 4294967295).bit_shift_left (29)))) /= {NATURAL_32} 0 then
				(a_pp + l_n3)[l_n3] := ((a_pp + l_n3)[l_n3]).bit_or ((({NATURAL_32} 4294967295).bit_shift_left (30)))
			end
			gmp_inst.gmpn_addmul_1 (l_r5, (a_pp + l_n3), l_n3p1, (60).to_natural_32).do_nothing
			l_tmp___2 := gmp_impl_inst.gmpn_bdiv_dbm1c (l_r5, l_r5, l_n3p1, {NATURAL_32} 16843009, (0).to_natural_32)
			DO_mpn_sublsh_n___0 (a_pp + 7 * a_n, a_r3, l_n3p1, {NATURAL_32} 5, l_wsi).do_nothing
			gmp_inst.gmpn_submul_1 (l_r1, (a_pp + 7 * a_n), l_n3p1, (100).to_natural_32).do_nothing
			DO_mpn_sublsh_n___0 (l_r1, a_r3, l_n3p1, {NATURAL_32} 9, l_wsi).do_nothing
			gmp_impl_inst.gmpn_divexact_1 (l_r1, l_r1, l_n3p1, (42525).to_natural_32)
			gmp_inst.gmpn_submul_1 (a_pp + 7 * a_n, l_r1, l_n3p1, (225).to_natural_32).do_nothing
			gmp_impl_inst.gmpn_divexact_1 (a_pp + 7 * a_n, (a_pp + 7 * a_n), l_n3p1, ({NATURAL_32} 9).bit_shift_left (2))
			gmp_inst.gmpn_sub_n (a_r3, a_r3, (a_pp + 7 * a_n), l_n3p1).do_nothing
			gmp_inst.gmpn_sub_n (a_pp + l_n3, (a_pp + 7 * a_n), (a_pp + l_n3), l_n3p1).do_nothing
			gmp_inst.gmpn_rshift (a_pp + l_n3, (a_pp + l_n3), l_n3p1, {NATURAL_32} 1).do_nothing
			gmp_inst.gmpn_sub_n (a_pp + 7 * a_n, (a_pp + 7 * a_n), (a_pp + l_n3), l_n3p1).do_nothing
			gmp_inst.gmpn_add_n (l_r5, l_r5, l_r1, l_n3p1).do_nothing
			gmp_inst.gmpn_rshift (l_r5, l_r5, l_n3p1, {NATURAL_32} 1).do_nothing
			gmp_inst.gmpn_sub_n (a_r3, a_r3, l_r1, l_n3p1).do_nothing
			gmp_inst.gmpn_sub_n (l_r1, l_r1, l_r5, l_n3p1).do_nothing
			l_cy := gmp_inst.gmpn_add_n (a_pp + a_n, (a_pp + a_n), l_r5, a_n)
			l_cy := gmp_inst.gmpn_add_1 (a_pp + 2 * a_n, (l_r5 + a_n), a_n, l_cy)
			l_cy := l_r5[l_n3] + (gmp_impl_inst.gmpn_add_nc (a_pp + l_n3, (a_pp + l_n3), (l_r5 + 2 * a_n), a_n, l_cy))
			from
			until
				js.loop_left
			loop
				js.reset
				asm188 (l_ptr_dummy___10.address, a_pp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n3), create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
				js.break
			end
			js.reset
			a_pp[2 * l_n3] := a_pp[2 * l_n3] + (gmp_inst.gmpn_add_n (a_pp + 5 * a_n, (a_pp + 5 * a_n), a_r3, a_n))
			l_cy := gmp_inst.gmpn_add_1 (a_pp + 2 * l_n3, (a_r3 + a_n), a_n, a_pp[2 * l_n3])
			l_cy := a_r3[l_n3] + (gmp_impl_inst.gmpn_add_nc (a_pp + 7 * a_n, (a_pp + 7 * a_n), (a_r3 + 2 * a_n), a_n, l_cy))
			from
			until
				js.loop_left
			loop
				js.reset
				asm189 (l_ptr_dummy___11.address, a_pp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
				js.break
			end
			js.reset
			a_pp[10 * a_n] := a_pp[10 * a_n] + (gmp_inst.gmpn_add_n (a_pp + 9 * a_n, (a_pp + 9 * a_n), l_r1, a_n))
			if a_half.to_boolean then
				l_cy := gmp_inst.gmpn_add_1 (a_pp + 10 * a_n, (l_r1 + a_n), a_n, a_pp[10 * a_n])
				if (builtin_expect ((a_spt > a_n).to_integer, 1)).to_boolean then
					l_cy := l_r1[l_n3] + (gmp_impl_inst.gmpn_add_nc (a_pp + 11 * a_n, (a_pp + 11 * a_n), (l_r1 + 2 * a_n), a_n, l_cy))
					from
					until
						js.loop_left
					loop
						js.reset
						asm190 (l_ptr_dummy___12.address, a_pp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_n3), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
						js.break
					end
					js.reset
				else
					gmp_impl_inst.gmpn_add_nc (a_pp + 11 * a_n, (a_pp + 11 * a_n), (l_r1 + 2 * a_n), a_spt, l_cy).do_nothing
				end
			else
				gmp_inst.gmpn_add_1 (a_pp + 10 * a_n, (l_r1 + a_n), a_spt, a_pp[10 * a_n]).do_nothing
			end
		end

end
