class
	P_TOOM_INTERPOLATE_5PTS

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_toom_interpolate_5pts (a_c: CE_POINTER [NATURAL_32]; a_v2: CE_POINTER [NATURAL_32]; a_vm1: CE_POINTER [NATURAL_32]; a_k: INTEGER_32; a_twor: INTEGER_32; a_sa: INTEGER_32; a_vinf0: NATURAL_32)
		local
			l_vinf0: NATURAL_32
			l_cy: NATURAL_32
			l_saved: NATURAL_32
			l_twok: INTEGER_32
			l_kk1: INTEGER_32
			l_c1: CE_POINTER [NATURAL_32]
			l_v1: CE_POINTER [NATURAL_32]
			l_c3: CE_POINTER [NATURAL_32]
			l_vinf: CE_POINTER [NATURAL_32]
			l_tmp: NATURAL_32
			l_ptr_dummy: CE_POINTER [NATURAL_32]
			l_ptr_dummy___0: CE_POINTER [NATURAL_32]
			l_ptr_dummy___1: CE_POINTER [NATURAL_32]
			l_ptr_dummy___2: CE_POINTER [NATURAL_32]
			l_ptr_dummy___3: CE_POINTER [NATURAL_32]
			l_ptr_dummy___4: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_c1.make
			create l_v1.make
			create l_c3.make
			create l_vinf.make
			create l_ptr_dummy.make
			create l_ptr_dummy___0.make
			create l_ptr_dummy___1.make
			create l_ptr_dummy___2.make
			create l_ptr_dummy___3.make
			create l_ptr_dummy___4.make

			l_vinf0 := a_vinf0
			l_twok := a_k + a_k
			l_kk1 := l_twok + 1
			l_c1.ce_gets (a_c + a_k)
			l_v1.ce_gets (l_c1 + a_k)
			l_c3.ce_gets (l_v1 + a_k)
			l_vinf.ce_gets (l_c3 + a_k)
			if a_sa.to_boolean then
				gmp_inst.gmpn_add_n (a_v2, a_v2, a_vm1, l_kk1).do_nothing
			else
				gmp_inst.gmpn_sub_n (a_v2, a_v2, a_vm1, l_kk1).do_nothing
			end
			l_tmp := gmp_impl_inst.gmpn_bdiv_dbm1c (a_v2, a_v2, l_kk1, {NATURAL_32} 1431655765, (0).to_natural_32)
			if a_sa.to_boolean then
				gmp_inst.gmpn_add_n (a_vm1, l_v1, a_vm1, l_kk1).do_nothing
				gmp_inst.gmpn_rshift (a_vm1, a_vm1, l_kk1, {NATURAL_32} 1).do_nothing
			else
				gmp_inst.gmpn_sub_n (a_vm1, l_v1, a_vm1, l_kk1).do_nothing
				gmp_inst.gmpn_rshift (a_vm1, a_vm1, l_kk1, {NATURAL_32} 1).do_nothing
			end
			l_vinf[0] := l_vinf[0] - (gmp_inst.gmpn_sub_n (l_v1, l_v1, a_c, l_twok))
			gmp_inst.gmpn_sub_n (a_v2, a_v2, l_v1, l_kk1).do_nothing
			gmp_inst.gmpn_rshift (a_v2, a_v2, l_kk1, {NATURAL_32} 1).do_nothing
			gmp_inst.gmpn_sub_n (l_v1, l_v1, a_vm1, l_kk1).do_nothing
			l_cy := gmp_inst.gmpn_add_n (l_c1, l_c1, a_vm1, l_kk1)
			from
			until
				js.loop_left
			loop
				js.reset
				asm143 (l_ptr_dummy.address, l_c3.address, create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
				js.break
			end
			js.reset
			l_saved := l_vinf[0]
			l_vinf[0] := l_vinf0
			l_cy := gmp_inst.gmpn_lshift (a_vm1, l_vinf, a_twor, {NATURAL_32} 1)
			l_cy := l_cy + (gmp_inst.gmpn_sub_n (a_v2, a_v2, a_vm1, a_twor))
			from
			until
				js.loop_left
			loop
				js.reset
				asm144 (l_ptr_dummy___0.address, a_v2.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_twor), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
				js.break
			end
			js.reset
			if (builtin_expect ((a_twor > a_k + 1).to_integer, 1)).to_boolean then
				l_cy := gmp_inst.gmpn_add_n (l_vinf, l_vinf, (a_v2 + a_k), a_k + 1)
				from
				until
					js.loop_left
				loop
					js.reset
					asm145 (l_ptr_dummy___1.address, l_c3.address, create {CE_POINTER [INTEGER_32]}.make_shared ($l_kk1), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
					js.break
				end
				js.reset
			else
				gmp_inst.gmpn_add_n (l_vinf, l_vinf, (a_v2 + a_k), a_twor).do_nothing
			end
			l_cy := gmp_inst.gmpn_sub_n (l_v1, l_v1, l_vinf, a_twor)
			l_vinf0 := l_vinf[0]
			l_vinf[0] := l_saved
			from
			until
				js.loop_left
			loop
				js.reset
				asm146 (l_ptr_dummy___2.address, l_v1.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_twor), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
				js.break
			end
			js.reset
			l_cy := gmp_inst.gmpn_sub_n (l_c1, l_c1, a_v2, a_k)
			from
			until
				js.loop_left
			loop
				js.reset
				asm147 (l_ptr_dummy___3.address, l_v1.address, create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
				js.break
			end
			js.reset
			l_cy := gmp_inst.gmpn_add_n (l_c3, l_c3, a_v2, a_k)
			l_vinf[0] := l_vinf[0] + l_cy
			from
			until
				js.loop_left
			loop
				js.reset
				asm148 (l_ptr_dummy___4.address, l_vinf.address, create {CE_POINTER [NATURAL_32]}.make_shared ($l_vinf0))
				js.break
			end
			js.reset
		end

end
