class
	P_TOOM_INTERPOLATE_7PTS

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_toom_interpolate_7pts (a_rp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_flags: INTEGER_32; a_w1: CE_POINTER [NATURAL_32]; a_w3: CE_POINTER [NATURAL_32]; a_w4: CE_POINTER [NATURAL_32]; a_w5: CE_POINTER [NATURAL_32]; a_w6n: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		local
			l_m: INTEGER_32
			l_cy: NATURAL_32
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
			l_ptr_dummy: CE_POINTER [NATURAL_32]
			l_ptr_dummy___0: CE_POINTER [NATURAL_32]
			l_ptr_dummy___1: CE_POINTER [NATURAL_32]
			l_ptr_dummy___2: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_ptr_dummy.make
			create l_ptr_dummy___0.make
			create l_ptr_dummy___1.make
			create l_ptr_dummy___2.make

			l_m := 2 * a_n + 1
			gmp_inst.gmpn_add_n (a_w5, a_w5, a_w4, l_m).do_nothing
			if ((a_flags.to_natural_32).bit_and ({NATURAL_32} 1)).to_boolean then
				gmp_inst.gmpn_add_n (a_w1, a_w1, a_w4, l_m).do_nothing
				gmp_inst.gmpn_rshift (a_w1, a_w1, l_m, {NATURAL_32} 1).do_nothing
			else
				gmp_inst.gmpn_sub_n (a_w1, a_w4, a_w1, l_m).do_nothing
				gmp_inst.gmpn_rshift (a_w1, a_w1, l_m, {NATURAL_32} 1).do_nothing
			end
			gmp_inst.gmpn_sub (a_w4, a_w4, l_m, a_rp, 2 * a_n).do_nothing
			gmp_inst.gmpn_sub_n (a_w4, a_w4, a_w1, l_m).do_nothing
			gmp_inst.gmpn_rshift (a_w4, a_w4, l_m, {NATURAL_32} 2).do_nothing
			a_tp[a_w6n] := gmp_inst.gmpn_lshift (a_tp, (a_rp + 6 * a_n), a_w6n, {NATURAL_32} 4)
			gmp_inst.gmpn_sub (a_w4, a_w4, l_m, a_tp, a_w6n + 1).do_nothing
			if ((a_flags.to_natural_32).bit_and ({NATURAL_32} 2)).to_boolean then
				gmp_inst.gmpn_add_n (a_w3, a_w3, (a_rp + 2 * a_n), l_m).do_nothing
				gmp_inst.gmpn_rshift (a_w3, a_w3, l_m, {NATURAL_32} 1).do_nothing
			else
				gmp_inst.gmpn_sub_n (a_w3, (a_rp + 2 * a_n), a_w3, l_m).do_nothing
				gmp_inst.gmpn_rshift (a_w3, a_w3, l_m, {NATURAL_32} 1).do_nothing
			end
			gmp_inst.gmpn_sub_n (a_rp + 2 * a_n, (a_rp + 2 * a_n), a_w3, l_m).do_nothing
			gmp_inst.gmpn_submul_1 (a_w5, (a_rp + 2 * a_n), l_m, (65).to_natural_32).do_nothing
			gmp_inst.gmpn_sub (a_rp + 2 * a_n, (a_rp + 2 * a_n), l_m, (a_rp + 6 * a_n), a_w6n).do_nothing
			gmp_inst.gmpn_sub (a_rp + 2 * a_n, (a_rp + 2 * a_n), l_m, a_rp, 2 * a_n).do_nothing
			gmp_inst.gmpn_addmul_1 (a_w5, (a_rp + 2 * a_n), l_m, (45).to_natural_32).do_nothing
			gmp_inst.gmpn_rshift (a_w5, a_w5, l_m, {NATURAL_32} 1).do_nothing
			gmp_inst.gmpn_sub_n (a_w4, a_w4, (a_rp + 2 * a_n), l_m).do_nothing
			l_tmp := gmp_impl_inst.gmpn_bdiv_dbm1c (a_w4, a_w4, l_m, {NATURAL_32} 1431655765, (0).to_natural_32)
			gmp_inst.gmpn_sub_n (a_rp + 2 * a_n, (a_rp + 2 * a_n), a_w4, l_m).do_nothing
			gmp_inst.gmpn_sub_n (a_w1, a_w5, a_w1, l_m).do_nothing
			gmp_inst.gmpn_lshift (a_tp, a_w3, l_m, {NATURAL_32} 3).do_nothing
			gmp_inst.gmpn_sub_n (a_w5, a_w5, a_tp, l_m).do_nothing
			gmp_impl_inst.gmpn_divexact_1 (a_w5, a_w5, l_m, (9).to_natural_32)
			gmp_inst.gmpn_sub_n (a_w3, a_w3, a_w5, l_m).do_nothing
			l_tmp___0 := gmp_impl_inst.gmpn_bdiv_dbm1c (a_w1, a_w1, l_m, {NATURAL_32} 286331153, (0).to_natural_32)
			gmp_inst.gmpn_add_n (a_w1, a_w1, a_w5, l_m).do_nothing
			gmp_inst.gmpn_rshift (a_w1, a_w1, l_m, {NATURAL_32} 1).do_nothing
			gmp_inst.gmpn_sub_n (a_w5, a_w5, a_w1, l_m).do_nothing
			l_cy := gmp_inst.gmpn_add_n (a_rp + a_n, (a_rp + a_n), a_w1, l_m)
			from
			until
				js.loop_left
			loop
				js.reset
				asm159 (l_ptr_dummy.address, a_rp.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
				js.break
			end
			js.reset
			l_cy := gmp_inst.gmpn_add_n (a_rp + 3 * a_n, (a_rp + 3 * a_n), a_w3, a_n)
			from
			until
				js.loop_left
			loop
				js.reset
				asm160 (l_ptr_dummy___0.address, a_w3.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), a_rp.address, create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
				js.break
			end
			js.reset
			l_cy := gmp_inst.gmpn_add_n (a_rp + 4 * a_n, (a_w3 + a_n), a_w4, a_n)
			from
			until
				js.loop_left
			loop
				js.reset
				asm161 (l_ptr_dummy___1.address, a_w4.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), a_w3.address, create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
				js.break
			end
			js.reset
			l_cy := gmp_inst.gmpn_add_n (a_rp + 5 * a_n, (a_w4 + a_n), a_w5, a_n)
			from
			until
				js.loop_left
			loop
				js.reset
				asm162 (l_ptr_dummy___2.address, a_w5.address, create {CE_POINTER [INTEGER_32]}.make_shared ($a_n), a_w4.address, create {CE_POINTER [NATURAL_32]}.make_shared ($l_cy))
				js.break
			end
			js.reset
			if a_w6n > a_n + 1 then
				gmp_inst.gmpn_add (a_rp + 6 * a_n, (a_rp + 6 * a_n), a_w6n, (a_w5 + a_n), a_n + 1).do_nothing
			else
				gmp_inst.gmpn_add_n (a_rp + 6 * a_n, (a_rp + 6 * a_n), (a_w5 + a_n), a_w6n).do_nothing
			end
		end

end
