class
	P_UI_SUB

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_ui_sub (a_r: CE_POINTER [PD_MPF_STRUCT]; a_u: NATURAL_32; a_v: CE_POINTER [PD_MPF_STRUCT])
		local
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_rsize: INTEGER_32
			l_prec: INTEGER_32
			l_uexp: INTEGER_32
			l_ediff: INTEGER_32
			l_negate: INTEGER_32
			l_ulimb: NATURAL_32
			l_tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l_v_negated: PD_MPF_STRUCT
			l_tmp___2: CE_POINTER [ANY]
			l_cmp: INTEGER_32
			l_size: INTEGER_32
			l_size___0: INTEGER_32
			l_i: INTEGER_32
			l_cmp___0: INTEGER_32
			l_size___1: INTEGER_32
			l_i___0: INTEGER_32
			l_size___2: INTEGER_32
			l_cmp___1: INTEGER_32
			l_size___3: INTEGER_32
			l_size___4: INTEGER_32
			l_i___1: INTEGER_32
			l_size___5: INTEGER_32
			l_i___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_up.make
			create l_vp.make
			create l_rp.make
			create l_tp.make
			create l_tmp_marker.make
			create l_v_negated.make
			create l_tmp___2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_vsize := (a_v.item.mp_size).to_integer_32
					if a_u = {NATURAL_32} 0 then
						neg_inst.gmpf_neg (a_r, a_v)
						js.return
					end
					if not js.return_called and then (l_vsize = 0) then
						set_ui_inst.gmpf_set_ui (a_r, a_u)
						js.return
					end
					if not js.return_called and then (l_vsize < 0) then
						l_v_negated.mp_size := (-l_vsize).to_integer_32
						l_v_negated.mp_exp := a_v.item.mp_exp
						l_v_negated.mp_d := a_v.item.mp_d
						add_ui_inst.gmpf_add_ui (a_r, (l_v_negated.address), a_u)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 23 -- skip if block
					end
				when 1 then -- if:
						l_tmp_marker.ce_gets (create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer))
						l_ulimb := a_u
						if 1 < a_v.item.mp_exp then
							l_negate := 1
							if l_vsize >= 0 then
								l_usize := l_vsize
							else
								l_usize := -l_vsize
							end
							l_vsize := (1).to_integer_32
							l_up.ce_gets (a_v.item.mp_d)
							l_vp.ce_gets ((create {CE_POINTER [NATURAL_32]}.make_shared ($l_ulimb)))
							l_rp.ce_gets (a_r.item.mp_d)
							l_prec := (a_r.item.mp_prec + 1).to_integer_32
							l_uexp := a_v.item.mp_exp
							l_ediff := l_uexp - 1
						else
							l_negate := 0
							l_usize := (1).to_integer_32
							if l_vsize >= 0 then
								l_vsize := l_vsize
							else
								l_vsize := -l_vsize
							end
							l_up.ce_gets ((create {CE_POINTER [NATURAL_32]}.make_shared ($l_ulimb)))
							l_vp.ce_gets (a_v.item.mp_d)
							l_rp.ce_gets (a_r.item.mp_d)
							l_prec := (a_r.item.mp_prec).to_integer_32
							l_uexp := (1).to_integer_32
							l_ediff := (1 - a_v.item.mp_exp)
						end
						if l_ediff /= 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 2 then -- if: | loop condition:
						if js.loop_left then
							l_pos := -1 + 7 -- skip loop
						end
				when 3 then -- loop body:
						js.reset
						l_usize := l_usize - 1
						l_vsize := l_vsize - 1
						if l_up[l_usize] /= l_vp[l_vsize] then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_uexp := l_uexp - 1
						if l_usize = 0 then
							l_pos := -1 + 10 -- goto Lu0
						end
				when 5 then
						if l_vsize = 0 then
							l_pos := -1 + 8 -- goto Lv0
						end
				when 6 then
						l_pos := -1 + 2 -- back to loop condition
				when 7 then -- loop done
						js.reset
						l_usize := l_usize + 1
						l_vsize := l_vsize + 1
						if l_vsize /= 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | Lv0:
						from
						until
							js.loop_left
						loop
							js.reset
							if l_usize /= 0 then
								if l_up[(l_usize - 1)] /= {NATURAL_32} 0 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_usize := l_usize - 1
								l_uexp := l_uexp - 1
							end
						end
						js.reset
				when 9 then -- if done
						if l_usize /= 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | Lu0:
						from
						until
							js.loop_left
						loop
							js.reset
							if l_vsize /= 0 then
								if l_vp[(l_vsize - 1)] /= {NATURAL_32} 0 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_vsize := l_vsize - 1
								l_uexp := l_uexp - 1
							end
						end
						js.reset
				when 11 then -- if done | if done
						if l_usize > l_prec then
							l_up.ce_gets (l_up + (l_usize - l_prec))
							l_usize := l_prec
						end
						if l_vsize + l_ediff > l_prec then
							l_vp.ce_gets (l_vp + ((l_vsize + l_ediff) - l_prec))
							l_vsize := l_prec - l_ediff
						end
						if (builtin_expect ((l_prec.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65536).to_integer, 1)).to_boolean then
							l_tmp___2.ce_gets ((l_aaf.new ((l_prec.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						else
							l_tmp___2.ce_gets ((tal_reent_inst.gmp_tmp_reentrant_alloc (l_tmp_marker.address, (l_prec.to_natural_32 * (Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
						end
						l_tp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2))
						if not (l_ediff >= l_prec) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if (l_tp.c_pointer.to_integer_32).to_natural_32 /= (l_up.c_pointer.to_integer_32).to_natural_32 then
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (l_rp, l_up, l_usize)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
						end
						l_rsize := l_usize
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 14 then -- else: | loop condition:
						if js.loop_left then
							l_pos := -1 + 17 -- skip loop
						end
				when 15 then -- loop body:
						js.reset
						if l_vsize = 0 then
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (l_rp, l_up, l_usize)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
							l_rsize := l_usize
							l_pos := -1 + 22 -- goto done
						end
				when 16 then
						if l_vp[0] /= {NATURAL_32} 0 then
							js.break
						end
						if not js.loop_jumped then
							l_vp.ce_gets (l_vp + 1)
							l_vsize := l_vsize - 1
						end
						l_pos := -1 + 14 -- back to loop condition
				when 17 then -- loop done
						js.reset
				when 18 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 21 -- skip loop
						end
				when 19 then -- loop body:
						js.reset
						if l_usize = 0 then
							from
							until
								js.loop_left
							loop
								js.reset
								from
								until
									js.loop_left
								loop
									js.reset
									gmp_inst.gmpn_copyi (l_rp, l_vp, l_vsize)
									js.break
								end
								js.reset
								js.break
							end
							js.reset
							l_rsize := l_vsize
							l_negate := (l_negate).bit_xor ((1))
							l_pos := -1 + 22 -- goto done
						end
				when 20 then
						if l_up[0] /= {NATURAL_32} 0 then
							js.break
						end
						if not js.loop_jumped then
							l_up.ce_gets (l_up + 1)
							l_usize := l_usize - 1
						end
						l_pos := -1 + 18 -- back to loop condition
				when 21 then -- loop done
						js.reset
						if l_usize > l_ediff then
							if l_ediff = 0 then
								if l_usize > l_vsize then
									l_cmp := gmp_inst.gmpn_cmp ((l_up + l_usize) - l_vsize, l_vp, l_vsize)
									if l_cmp >= 0 then
										l_size := l_usize - l_vsize
										from
										until
											js.loop_left
										loop
											js.reset
											from
											until
												js.loop_left
											loop
												js.reset
												gmp_inst.gmpn_copyi (l_tp, l_up, l_size)
												js.break
											end
											js.reset
											js.break
										end
										js.reset
										gmp_inst.gmpn_sub_n (l_tp + l_size, l_up + l_size, l_vp, l_vsize).do_nothing
										l_rsize := l_usize
									else
										l_size___0 := l_usize - l_vsize
										l_tp[0] := (((-(l_up[0]).to_integer_32).to_natural_32).bit_and ({NATURAL_32} 4294967295))
										l_i := (1).to_integer_32
										from
										until
											not (l_i < l_size___0)
										loop
											l_tp[l_i] := (((l_up[l_i]).bit_not).bit_and ({NATURAL_32} 4294967295))
											l_i := l_i + 1
										end
										gmp_inst.gmpn_sub_n (l_tp + l_size___0, l_vp, l_up + l_size___0, l_vsize).do_nothing
										gmp_inst.gmpn_sub_1 (l_tp + l_size___0, (l_tp + l_size___0), l_vsize, (1).to_natural_32).do_nothing
										l_negate := (l_negate).bit_xor ((1))
										l_rsize := l_usize
									end
								elseif l_usize < l_vsize then
									l_cmp___0 := gmp_inst.gmpn_cmp (l_up, (l_vp + l_vsize) - l_usize, l_usize)
									if l_cmp___0 > 0 then
										l_size___1 := l_vsize - l_usize
										l_tp[0] := (((-(l_vp[0]).to_integer_32).to_natural_32).bit_and ({NATURAL_32} 4294967295))
										l_i___0 := (1).to_integer_32
										from
										until
											not (l_i___0 < l_size___1)
										loop
											l_tp[l_i___0] := (((l_vp[l_i___0]).bit_not).bit_and ({NATURAL_32} 4294967295))
											l_i___0 := l_i___0 + 1
										end
										gmp_inst.gmpn_sub_n (l_tp + l_size___1, l_up, l_vp + l_size___1, l_usize).do_nothing
										gmp_inst.gmpn_sub_1 (l_tp + l_size___1, (l_tp + l_size___1), l_usize, (1).to_natural_32).do_nothing
										l_rsize := l_vsize
									else
										l_size___2 := l_vsize - l_usize
										from
										until
											js.loop_left
										loop
											js.reset
											from
											until
												js.loop_left
											loop
												js.reset
												gmp_inst.gmpn_copyi (l_tp, l_vp, l_size___2)
												js.break
											end
											js.reset
											js.break
										end
										js.reset
										gmp_inst.gmpn_sub_n (l_tp + l_size___2, l_vp + l_size___2, l_up, l_usize).do_nothing
										l_negate := (l_negate).bit_xor ((1))
										l_rsize := l_vsize
									end
								else
									l_cmp___1 := gmp_inst.gmpn_cmp (l_up, (l_vp + l_vsize) - l_usize, l_usize)
									if l_cmp___1 > 0 then
										gmp_inst.gmpn_sub_n (l_tp, l_up, l_vp, l_usize).do_nothing
										l_rsize := l_usize
									else
										gmp_inst.gmpn_sub_n (l_tp, l_vp, l_up, l_usize).do_nothing
										l_negate := (l_negate).bit_xor ((1))
										l_rsize := l_usize
									end
								end
							elseif l_vsize + l_ediff <= l_usize then
								l_size___3 := (l_usize - l_ediff) - l_vsize
								from
								until
									js.loop_left
								loop
									js.reset
									from
									until
										js.loop_left
									loop
										js.reset
										gmp_inst.gmpn_copyi (l_tp, l_up, l_size___3)
										js.break
									end
									js.reset
									js.break
								end
								js.reset
								gmp_inst.gmpn_sub (l_tp + l_size___3, l_up + l_size___3, l_usize - l_size___3, l_vp, l_vsize).do_nothing
								l_rsize := l_usize
							else
								l_size___4 := (l_vsize + l_ediff) - l_usize
								l_tp[0] := (((-(l_vp[0]).to_integer_32).to_natural_32).bit_and ({NATURAL_32} 4294967295))
								l_i___1 := (1).to_integer_32
								from
								until
									not (l_i___1 < l_size___4)
								loop
									l_tp[l_i___1] := (((l_vp[l_i___1]).bit_not).bit_and ({NATURAL_32} 4294967295))
									l_i___1 := l_i___1 + 1
								end
								gmp_inst.gmpn_sub (l_tp + l_size___4, l_up, l_usize, l_vp + l_size___4, l_usize - l_ediff).do_nothing
								gmp_inst.gmpn_sub_1 (l_tp + l_size___4, (l_tp + l_size___4), l_usize, (1).to_natural_32).do_nothing
								l_rsize := l_vsize + l_ediff
							end
						else
							l_size___5 := (l_vsize + l_ediff) - l_usize
							l_tp[0] := (((-(l_vp[0]).to_integer_32).to_natural_32).bit_and ({NATURAL_32} 4294967295))
							l_i___2 := (1).to_integer_32
							from
							until
								not (l_i___2 < l_vsize)
							loop
								l_tp[l_i___2] := (((l_vp[l_i___2]).bit_not).bit_and ({NATURAL_32} 4294967295))
								l_i___2 := l_i___2 + 1
							end
							l_i___2 := l_vsize
							from
							until
								not (l_i___2 < l_size___5)
							loop
								l_tp[l_i___2] := {NATURAL_32} 4294967295
								l_i___2 := l_i___2 + 1
							end
							gmp_inst.gmpn_sub_1 (l_tp + l_size___5, l_up, l_usize, (1).to_natural_32).do_nothing
							l_rsize := l_size___5 + l_usize
						end
						from
						until
							js.loop_left
						loop
							js.reset
							if l_rsize /= 0 then
								if l_tp[(l_rsize - 1)] /= {NATURAL_32} 0 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_rsize := l_rsize - 1
								l_uexp := l_uexp - 1
							end
						end
						js.reset
						from
						until
							js.loop_left
						loop
							js.reset
							from
							until
								js.loop_left
							loop
								js.reset
								gmp_inst.gmpn_copyi (l_rp, l_tp, l_rsize)
								js.break
							end
							js.reset
							js.break
						end
						js.reset
				when 22 then -- done:
						if l_negate.to_boolean then
							a_r.item.mp_size := (-l_rsize).to_integer_32
						else
							a_r.item.mp_size := l_rsize.to_integer_32
						end
						a_r.item.mp_exp := l_uexp
						from
						until
							js.loop_left
						loop
							js.reset
							if (builtin_expect (((l_tmp_marker.c_pointer.to_integer_32).to_natural_32 /= (0).to_natural_32).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l_tmp_marker)
							end
							js.break
						end
						js.reset
				when 23 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpz_ui_sub (a_w: CE_POINTER [PD_MPZ_STRUCT]; a_uval: NATURAL_32; a_v: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_vp: CE_POINTER [NATURAL_32]
			l_wp: CE_POINTER [NATURAL_32]
			l_vn: INTEGER_32
			l_wn: INTEGER_32
			l_cy: NATURAL_32
		do
			create l_vp.make
			create l_wp.make

			l_vp.ce_gets (a_v.item.mp_d)
			l_vn := (a_v.item.mp_size).to_integer_32
			l_wp.ce_gets (a_w.item.mp_d)
			if l_vn > 1 then
				if (builtin_expect ((l_vn > (a_w.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					l_wp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((realloc_inst.gmpz_realloc (a_w, l_vn))))
				else
					l_wp.ce_gets (a_w.item.mp_d)
				end
				l_vp.ce_gets (a_v.item.mp_d)
				gmp_inst.gmpn_sub_1 (l_wp, l_vp, l_vn, a_uval).do_nothing
				l_wn := -(l_vn - (l_wp[(l_vn - 1)] = {NATURAL_32} 0).to_integer)
			elseif l_vn = 1 then
				if a_uval >= l_vp[0] then
					l_wp[0] := a_uval - l_vp[0]
					l_wn := (l_wp[0] /= {NATURAL_32} 0).to_integer
				else
					l_wp[0] := l_vp[0] - a_uval
					l_wn := (-1).to_integer_32
				end
			elseif l_vn = 0 then
				l_wp[0] := a_uval
				l_wn := (a_uval /= {NATURAL_32} 0).to_integer
			else
				l_vn := -l_vn
				if (builtin_expect ((l_vn + 1 > (a_w.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					l_wp.ce_gets (create {CE_POINTER [NATURAL_32]}.make_cast ((realloc_inst.gmpz_realloc (a_w, l_vn + 1))))
				else
					l_wp.ce_gets (a_w.item.mp_d)
				end
				l_vp.ce_gets (a_v.item.mp_d)
				l_cy := gmp_inst.gmpn_add_1 (l_wp, l_vp, l_vn, a_uval)
				l_wp[l_vn] := l_cy
				l_wn := l_vn + (l_cy /= {NATURAL_32} 0).to_integer
			end
			a_w.item.mp_size := l_wn.to_integer_32
		end

end
