deferred class
	S_STRING

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	memset (a_s: CE_POINTER [ANY]; a_c: INTEGER_32; a_n: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_memset (a_s.c_pointer, a_c, a_n))
		end

	c_memset (a_s: POINTER; a_c: INTEGER_32; a_n: NATURAL_32): POINTER
		external
			"C inline use <libgmp.h>"
		alias
			"return memset($a_s, $a_c, $a_n);"
		end

	strlen (a_s: CE_POINTER [INTEGER_8]): NATURAL_32
		do
			Result := c_strlen (a_s.c_pointer)
		end

	c_strlen (a_s: POINTER): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return strlen($a_s);"
		end

	memcpy (a_dest: CE_POINTER [ANY]; a_src: CE_POINTER [ANY]; a_n: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_memcpy (a_dest.c_pointer, a_src.c_pointer, a_n))
		end

	c_memcpy (a_dest: POINTER; a_src: POINTER; a_n: NATURAL_32): POINTER
		external
			"C inline use <libgmp.h>"
		alias
			"return memcpy($a_dest, $a_src, $a_n);"
		end

	strchr (a_s: CE_POINTER [INTEGER_8]; a_c: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strchr (a_s.c_pointer, a_c))
		end

	c_strchr (a_s: POINTER; a_c: INTEGER_32): POINTER
		external
			"C inline use <libgmp.h>"
		alias
			"return strchr($a_s, $a_c);"
		end

	strcpy (a_dest: CE_POINTER [INTEGER_8]; a_src: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strcpy (a_dest.c_pointer, a_src.c_pointer))
		end

	c_strcpy (a_dest: POINTER; a_src: POINTER): POINTER
		external
			"C inline use <libgmp.h>"
		alias
			"return strcpy($a_dest, $a_src);"
		end

end
