class
	PD_BISECTION_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	f_lower: REAL_64 assign set_f_lower
		do
			Result := c_f_lower (c_pointer)
		end

	f_upper: REAL_64 assign set_f_upper
		do
			Result := c_f_upper (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_f_lower (a_f_lower: REAL_64)
		do
			c_set_f_lower (c_pointer, a_f_lower)
		end

	set_f_upper (a_f_upper: REAL_64)
		do
			c_set_f_upper (c_pointer, a_f_upper)
		end

feature {NONE} -- C getters

	c_f_lower (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_bisection_state_t_30 *)$tmp)->f_lower;"
		end

	c_f_upper (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_bisection_state_t_30 *)$tmp)->f_upper;"
		end

feature {NONE} -- C setters

	c_set_f_lower (tmp: POINTER; a_f_lower: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_bisection_state_t_30 *)$tmp)->f_lower = $a_f_lower;"
		end

	c_set_f_upper (tmp: POINTER; a_f_upper: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_bisection_state_t_30 *)$tmp)->f_upper = $a_f_upper;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_bisection_state_t_30);"
		end

end
