class
	PD_CSPLINE_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	c: CE_POINTER [REAL_64] assign set_c
		do
			create Result.make_shared (c_c (c_pointer))
		end

	g: CE_POINTER [REAL_64] assign set_g
		do
			create Result.make_shared (c_g (c_pointer))
		end

	diag: CE_POINTER [REAL_64] assign set_diag
		do
			create Result.make_shared (c_diag (c_pointer))
		end

	offdiag: CE_POINTER [REAL_64] assign set_offdiag
		do
			create Result.make_shared (c_offdiag (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_c (a_c: CE_POINTER [REAL_64])
		do
			c_set_c (c_pointer, a_c.c_pointer)
		end

	set_g (a_g: CE_POINTER [REAL_64])
		do
			c_set_g (c_pointer, a_g.c_pointer)
		end

	set_diag (a_diag: CE_POINTER [REAL_64])
		do
			c_set_diag (c_pointer, a_diag.c_pointer)
		end

	set_offdiag (a_offdiag: CE_POINTER [REAL_64])
		do
			c_set_offdiag (c_pointer, a_offdiag.c_pointer)
		end

feature {NONE} -- C getters

	c_c (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_cspline_state_t_115 *)$tmp)->c;"
		end

	c_g (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_cspline_state_t_115 *)$tmp)->g;"
		end

	c_diag (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_cspline_state_t_115 *)$tmp)->diag;"
		end

	c_offdiag (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_cspline_state_t_115 *)$tmp)->offdiag;"
		end

feature {NONE} -- C setters

	c_set_c (tmp: POINTER; a_c: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_cspline_state_t_115 *)$tmp)->c = (double *)$a_c;"
		end

	c_set_g (tmp: POINTER; a_g: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_cspline_state_t_115 *)$tmp)->g = (double *)$a_g;"
		end

	c_set_diag (tmp: POINTER; a_diag: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_cspline_state_t_115 *)$tmp)->diag = (double *)$a_diag;"
		end

	c_set_offdiag (tmp: POINTER; a_offdiag: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_cspline_state_t_115 *)$tmp)->offdiag = (double *)$a_offdiag;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_cspline_state_t_115);"
		end

end
