class
	PD_FN_QAWS_PARAMS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	function: CE_POINTER [PD_GSL_FUNCTION_STRUCT] assign set_function
		do
			create Result.make_shared (c_function (c_pointer))
		end

	a: REAL_64 assign set_a
		do
			Result := c_a (c_pointer)
		end

	b: REAL_64 assign set_b
		do
			Result := c_b (c_pointer)
		end

	table: CE_POINTER [PD_GSL_INTEGRATION_QAWS_TABLE] assign set_table
		do
			create Result.make_shared (c_table (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_function (a_function: CE_POINTER [PD_GSL_FUNCTION_STRUCT])
		do
			c_set_function (c_pointer, a_function.c_pointer)
		end

	set_a (a_a: REAL_64)
		do
			c_set_a (c_pointer, a_a)
		end

	set_b (a_b: REAL_64)
		do
			c_set_b (c_pointer, a_b)
		end

	set_table (a_table: CE_POINTER [PD_GSL_INTEGRATION_QAWS_TABLE])
		do
			c_set_table (c_pointer, a_table.c_pointer)
		end

feature {NONE} -- C getters

	c_function (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct gsl_function_struct *)((struct fn_qaws_params *)$tmp)->function;"
		end

	c_a (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct fn_qaws_params *)$tmp)->a;"
		end

	c_b (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct fn_qaws_params *)$tmp)->b;"
		end

	c_table (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_integration_qaws_table *)((struct fn_qaws_params *)$tmp)->table;"
		end

feature {NONE} -- C setters

	c_set_function (tmp: POINTER; a_function: POINTER)
		external
			"C inline"
		alias
			"((struct fn_qaws_params *)$tmp)->function = (struct gsl_function_struct *)$a_function;"
		end

	c_set_a (tmp: POINTER; a_a: REAL_64)
		external
			"C inline"
		alias
			"((struct fn_qaws_params *)$tmp)->a = $a_a;"
		end

	c_set_b (tmp: POINTER; a_b: REAL_64)
		external
			"C inline"
		alias
			"((struct fn_qaws_params *)$tmp)->b = $a_b;"
		end

	c_set_table (tmp: POINTER; a_table: POINTER)
		external
			"C inline"
		alias
			"((struct fn_qaws_params *)$tmp)->table = (gsl_integration_qaws_table *)$a_table;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct fn_qaws_params);"
		end

end
