class
	PD_GEAR2_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	primed: INTEGER_32 assign set_primed
		do
			Result := c_primed (c_pointer)
		end

	t_primed: REAL_64 assign set_t_primed
		do
			Result := c_t_primed (c_pointer)
		end

	last_h: REAL_64 assign set_last_h
		do
			Result := c_last_h (c_pointer)
		end

	primer: CE_POINTER [PD_GSL_ODEIV_STEP] assign set_primer
		do
			create Result.make_shared (c_primer (c_pointer))
		end

	yim1: CE_POINTER [REAL_64] assign set_yim1
		do
			create Result.make_shared (c_yim1 (c_pointer))
		end

	k: CE_POINTER [REAL_64] assign set_k
		do
			create Result.make_shared (c_k (c_pointer))
		end

	y0: CE_POINTER [REAL_64] assign set_y0
		do
			create Result.make_shared (c_y0 (c_pointer))
		end

	y0_orig: CE_POINTER [REAL_64] assign set_y0_orig
		do
			create Result.make_shared (c_y0_orig (c_pointer))
		end

	y_onestep: CE_POINTER [REAL_64] assign set_y_onestep
		do
			create Result.make_shared (c_y_onestep (c_pointer))
		end

	stutter: INTEGER_32 assign set_stutter
		do
			Result := c_stutter (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_primed (a_primed: INTEGER_32)
		do
			c_set_primed (c_pointer, a_primed)
		end

	set_t_primed (a_t_primed: REAL_64)
		do
			c_set_t_primed (c_pointer, a_t_primed)
		end

	set_last_h (a_last_h: REAL_64)
		do
			c_set_last_h (c_pointer, a_last_h)
		end

	set_primer (a_primer: CE_POINTER [PD_GSL_ODEIV_STEP])
		do
			c_set_primer (c_pointer, a_primer.c_pointer)
		end

	set_yim1 (a_yim1: CE_POINTER [REAL_64])
		do
			c_set_yim1 (c_pointer, a_yim1.c_pointer)
		end

	set_k (a_k: CE_POINTER [REAL_64])
		do
			c_set_k (c_pointer, a_k.c_pointer)
		end

	set_y0 (a_y0: CE_POINTER [REAL_64])
		do
			c_set_y0 (c_pointer, a_y0.c_pointer)
		end

	set_y0_orig (a_y0_orig: CE_POINTER [REAL_64])
		do
			c_set_y0_orig (c_pointer, a_y0_orig.c_pointer)
		end

	set_y_onestep (a_y_onestep: CE_POINTER [REAL_64])
		do
			c_set_y_onestep (c_pointer, a_y_onestep.c_pointer)
		end

	set_stutter (a_stutter: INTEGER_32)
		do
			c_set_stutter (c_pointer, a_stutter)
		end

feature {NONE} -- C getters

	c_primed (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gear2_state_t_32 *)$tmp)->primed;"
		end

	c_t_primed (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gear2_state_t_32 *)$tmp)->t_primed;"
		end

	c_last_h (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gear2_state_t_32 *)$tmp)->last_h;"
		end

	c_primer (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_odeiv_step *)((struct __anonstruct_gear2_state_t_32 *)$tmp)->primer;"
		end

	c_yim1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gear2_state_t_32 *)$tmp)->yim1;"
		end

	c_k (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gear2_state_t_32 *)$tmp)->k;"
		end

	c_y0 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gear2_state_t_32 *)$tmp)->y0;"
		end

	c_y0_orig (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gear2_state_t_32 *)$tmp)->y0_orig;"
		end

	c_y_onestep (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gear2_state_t_32 *)$tmp)->y_onestep;"
		end

	c_stutter (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gear2_state_t_32 *)$tmp)->stutter;"
		end

feature {NONE} -- C setters

	c_set_primed (tmp: POINTER; a_primed: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gear2_state_t_32 *)$tmp)->primed = $a_primed;"
		end

	c_set_t_primed (tmp: POINTER; a_t_primed: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gear2_state_t_32 *)$tmp)->t_primed = $a_t_primed;"
		end

	c_set_last_h (tmp: POINTER; a_last_h: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gear2_state_t_32 *)$tmp)->last_h = $a_last_h;"
		end

	c_set_primer (tmp: POINTER; a_primer: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gear2_state_t_32 *)$tmp)->primer = (gsl_odeiv_step *)$a_primer;"
		end

	c_set_yim1 (tmp: POINTER; a_yim1: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gear2_state_t_32 *)$tmp)->yim1 = (double *)$a_yim1;"
		end

	c_set_k (tmp: POINTER; a_k: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gear2_state_t_32 *)$tmp)->k = (double *)$a_k;"
		end

	c_set_y0 (tmp: POINTER; a_y0: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gear2_state_t_32 *)$tmp)->y0 = (double *)$a_y0;"
		end

	c_set_y0_orig (tmp: POINTER; a_y0_orig: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gear2_state_t_32 *)$tmp)->y0_orig = (double *)$a_y0_orig;"
		end

	c_set_y_onestep (tmp: POINTER; a_y_onestep: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gear2_state_t_32 *)$tmp)->y_onestep = (double *)$a_y_onestep;"
		end

	c_set_stutter (tmp: POINTER; a_stutter: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gear2_state_t_32 *)$tmp)->stutter = $a_stutter;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gear2_state_t_32);"
		end

end
