class
	PD_GFSR4_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	nd: INTEGER_32 assign set_nd
		do
			Result := c_nd (c_pointer)
		end

	ra: CE_ARRAY [NATURAL_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_ra (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_nd (a_nd: INTEGER_32)
		do
			c_set_nd (c_pointer, a_nd)
		end

feature {NONE} -- C getters

	c_nd (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gfsr4_state_t_26 *)$tmp)->nd;"
		end

	c_ra (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_gfsr4_state_t_26 *tmp = (struct __anonstruct_gfsr4_state_t_26 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->ra) / sizeof(tmp->ra[0]);
				return tmp->ra;
			]"
		end

feature {NONE} -- C setters

	c_set_nd (tmp: POINTER; a_nd: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gfsr4_state_t_26 *)$tmp)->nd = $a_nd;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gfsr4_state_t_26);"
		end

end
