class
	PD_GSL_BSPLINE_DERIV_WORKSPACE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	k: NATURAL_32 assign set_k
		do
			Result := c_k (c_pointer)
		end

	A: CE_POINTER [PD_GSL_MATRIX] assign set_A
		do
			create Result.make_shared (c_A (c_pointer))
		end

	dB: CE_POINTER [PD_GSL_MATRIX] assign set_dB
		do
			create Result.make_shared (c_dB (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_k (a_k: NATURAL_32)
		do
			c_set_k (c_pointer, a_k)
		end

	set_A (a_A: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_A (c_pointer, a_A.c_pointer)
		end

	set_dB (a_dB: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_dB (c_pointer, a_dB.c_pointer)
		end

feature {NONE} -- C getters

	c_k (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_bspline_deriv_workspace_114 *)$tmp)->k;"
		end

	c_A (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_gsl_bspline_deriv_workspace_114 *)$tmp)->A;"
		end

	c_dB (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_gsl_bspline_deriv_workspace_114 *)$tmp)->dB;"
		end

feature {NONE} -- C setters

	c_set_k (tmp: POINTER; a_k: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_bspline_deriv_workspace_114 *)$tmp)->k = $a_k;"
		end

	c_set_A (tmp: POINTER; a_A: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_bspline_deriv_workspace_114 *)$tmp)->A = (gsl_matrix *)$a_a;"
		end

	c_set_dB (tmp: POINTER; a_dB: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_bspline_deriv_workspace_114 *)$tmp)->dB = (gsl_matrix *)$a_db;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_bspline_deriv_workspace_114);"
		end

end
