class
	PD_GSL_COMPLEX

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	dat: CE_ARRAY [REAL_64]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_dat (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {NONE} -- C getters

	c_dat (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_gsl_complex_27 *tmp = (struct __anonstruct_gsl_complex_27 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->dat) / sizeof(tmp->dat[0]);
				return tmp->dat;
			]"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_complex_27);"
		end

end
