class
	PD_GSL_EIGEN_GENHERM_WORKSPACE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	size: NATURAL_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	herm_workspace_p: CE_POINTER [PD_GSL_EIGEN_HERM_WORKSPACE] assign set_herm_workspace_p
		do
			create Result.make_shared (c_herm_workspace_p (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_size (a_size: NATURAL_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_herm_workspace_p (a_herm_workspace_p: CE_POINTER [PD_GSL_EIGEN_HERM_WORKSPACE])
		do
			c_set_herm_workspace_p (c_pointer, a_herm_workspace_p.c_pointer)
		end

feature {NONE} -- C getters

	c_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_eigen_genherm_workspace_120 *)$tmp)->size;"
		end

	c_herm_workspace_p (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_eigen_herm_workspace *)((struct __anonstruct_gsl_eigen_genherm_workspace_120 *)$tmp)->herm_workspace_p;"
		end

feature {NONE} -- C setters

	c_set_size (tmp: POINTER; a_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_genherm_workspace_120 *)$tmp)->size = $a_size;"
		end

	c_set_herm_workspace_p (tmp: POINTER; a_herm_workspace_p: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_eigen_genherm_workspace_120 *)$tmp)->herm_workspace_p = (gsl_eigen_herm_workspace *)$a_herm_workspace_p;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_eigen_genherm_workspace_120);"
		end

end
