class
	PD_GSL_HISTOGRAM

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	n: NATURAL_32 assign set_n
		do
			Result := c_n (c_pointer)
		end

	range: CE_POINTER [REAL_64] assign set_range
		do
			create Result.make_shared (c_range (c_pointer))
		end

	bin: CE_POINTER [REAL_64] assign set_bin
		do
			create Result.make_shared (c_bin (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_n (a_n: NATURAL_32)
		do
			c_set_n (c_pointer, a_n)
		end

	set_range (a_range: CE_POINTER [REAL_64])
		do
			c_set_range (c_pointer, a_range.c_pointer)
		end

	set_bin (a_bin: CE_POINTER [REAL_64])
		do
			c_set_bin (c_pointer, a_bin.c_pointer)
		end

feature {NONE} -- C getters

	c_n (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_histogram_24 *)$tmp)->n;"
		end

	c_range (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_histogram_24 *)$tmp)->range;"
		end

	c_bin (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_histogram_24 *)$tmp)->bin;"
		end

feature {NONE} -- C setters

	c_set_n (tmp: POINTER; a_n: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_histogram_24 *)$tmp)->n = $a_n;"
		end

	c_set_range (tmp: POINTER; a_range: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_histogram_24 *)$tmp)->range = (double *)$a_range;"
		end

	c_set_bin (tmp: POINTER; a_bin: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_histogram_24 *)$tmp)->bin = (double *)$a_bin;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_histogram_24);"
		end

end
