class
	PD_GSL_HISTOGRAM_PDF

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	n: NATURAL_32 assign set_n
		do
			Result := c_n (c_pointer)
		end

	range: CE_POINTER [REAL_64] assign set_range
		do
			create Result.make_shared (c_range (c_pointer))
		end

	sum: CE_POINTER [REAL_64] assign set_sum
		do
			create Result.make_shared (c_sum (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_n (a_n: NATURAL_32)
		do
			c_set_n (c_pointer, a_n)
		end

	set_range (a_range: CE_POINTER [REAL_64])
		do
			c_set_range (c_pointer, a_range.c_pointer)
		end

	set_sum (a_sum: CE_POINTER [REAL_64])
		do
			c_set_sum (c_pointer, a_sum.c_pointer)
		end

feature {NONE} -- C getters

	c_n (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_histogram_pdf_25 *)$tmp)->n;"
		end

	c_range (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_histogram_pdf_25 *)$tmp)->range;"
		end

	c_sum (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_histogram_pdf_25 *)$tmp)->sum;"
		end

feature {NONE} -- C setters

	c_set_n (tmp: POINTER; a_n: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_histogram_pdf_25 *)$tmp)->n = $a_n;"
		end

	c_set_range (tmp: POINTER; a_range: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_histogram_pdf_25 *)$tmp)->range = (double *)$a_range;"
		end

	c_set_sum (tmp: POINTER; a_sum: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_histogram_pdf_25 *)$tmp)->sum = (double *)$a_sum;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_histogram_pdf_25);"
		end

end
