class
	PD_GSL_INTEGRATION_GLFIXED_TABLE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	n: NATURAL_32 assign set_n
		do
			Result := c_n (c_pointer)
		end

	x: CE_POINTER [REAL_64] assign set_x
		do
			create Result.make_shared (c_x (c_pointer))
		end

	w: CE_POINTER [REAL_64] assign set_w
		do
			create Result.make_shared (c_w (c_pointer))
		end

	precomputed: INTEGER_32 assign set_precomputed
		do
			Result := c_precomputed (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_n (a_n: NATURAL_32)
		do
			c_set_n (c_pointer, a_n)
		end

	set_x (a_x: CE_POINTER [REAL_64])
		do
			c_set_x (c_pointer, a_x.c_pointer)
		end

	set_w (a_w: CE_POINTER [REAL_64])
		do
			c_set_w (c_pointer, a_w.c_pointer)
		end

	set_precomputed (a_precomputed: INTEGER_32)
		do
			c_set_precomputed (c_pointer, a_precomputed)
		end

feature {NONE} -- C getters

	c_n (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_integration_glfixed_table_30 *)$tmp)->n;"
		end

	c_x (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_integration_glfixed_table_30 *)$tmp)->x;"
		end

	c_w (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_integration_glfixed_table_30 *)$tmp)->w;"
		end

	c_precomputed (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_integration_glfixed_table_30 *)$tmp)->precomputed;"
		end

feature {NONE} -- C setters

	c_set_n (tmp: POINTER; a_n: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_integration_glfixed_table_30 *)$tmp)->n = $a_n;"
		end

	c_set_x (tmp: POINTER; a_x: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_integration_glfixed_table_30 *)$tmp)->x = (double *)$a_x;"
		end

	c_set_w (tmp: POINTER; a_w: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_integration_glfixed_table_30 *)$tmp)->w = (double *)$a_w;"
		end

	c_set_precomputed (tmp: POINTER; a_precomputed: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_integration_glfixed_table_30 *)$tmp)->precomputed = $a_precomputed;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_integration_glfixed_table_30);"
		end

end
