class
	PD_GSL_INTEGRATION_QAWO_TABLE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	n: NATURAL_32 assign set_n
		do
			Result := c_n (c_pointer)
		end

	omega: REAL_64 assign set_omega
		do
			Result := c_omega (c_pointer)
		end

	L: REAL_64 assign set_L
		do
			Result := c_L (c_pointer)
		end

	par: REAL_64 assign set_par
		do
			Result := c_par (c_pointer)
		end

	sine: INTEGER_32 assign set_sine
		do
			Result := c_sine (c_pointer)
		end

	chebmo: CE_POINTER [REAL_64] assign set_chebmo
		do
			create Result.make_shared (c_chebmo (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_n (a_n: NATURAL_32)
		do
			c_set_n (c_pointer, a_n)
		end

	set_omega (a_omega: REAL_64)
		do
			c_set_omega (c_pointer, a_omega)
		end

	set_L (a_L: REAL_64)
		do
			c_set_L (c_pointer, a_L)
		end

	set_par (a_par: REAL_64)
		do
			c_set_par (c_pointer, a_par)
		end

	set_sine (a_sine: INTEGER_32)
		do
			c_set_sine (c_pointer, a_sine)
		end

	set_chebmo (a_chebmo: CE_POINTER [REAL_64])
		do
			c_set_chebmo (c_pointer, a_chebmo.c_pointer)
		end

feature {NONE} -- C getters

	c_n (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_integration_qawo_table_23 *)$tmp)->n;"
		end

	c_omega (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_integration_qawo_table_23 *)$tmp)->omega;"
		end

	c_L (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_integration_qawo_table_23 *)$tmp)->L;"
		end

	c_par (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_integration_qawo_table_23 *)$tmp)->par;"
		end

	c_sine (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_integration_qawo_table_23 *)$tmp)->sine;"
		end

	c_chebmo (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_integration_qawo_table_23 *)$tmp)->chebmo;"
		end

feature {NONE} -- C setters

	c_set_n (tmp: POINTER; a_n: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_integration_qawo_table_23 *)$tmp)->n = $a_n;"
		end

	c_set_omega (tmp: POINTER; a_omega: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_integration_qawo_table_23 *)$tmp)->omega = $a_omega;"
		end

	c_set_L (tmp: POINTER; a_L: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_integration_qawo_table_23 *)$tmp)->L = $a_l;"
		end

	c_set_par (tmp: POINTER; a_par: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_integration_qawo_table_23 *)$tmp)->par = $a_par;"
		end

	c_set_sine (tmp: POINTER; a_sine: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_integration_qawo_table_23 *)$tmp)->sine = $a_sine;"
		end

	c_set_chebmo (tmp: POINTER; a_chebmo: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_integration_qawo_table_23 *)$tmp)->chebmo = (double *)$a_chebmo;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_integration_qawo_table_23);"
		end

end
