class
	PD_GSL_INTERP

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: CE_POINTER [PD_GSL_INTERP_TYPE] assign set_type
		do
			create Result.make_shared (c_type (c_pointer))
		end

	xmin: REAL_64 assign set_xmin
		do
			Result := c_xmin (c_pointer)
		end

	xmax: REAL_64 assign set_xmax
		do
			Result := c_xmax (c_pointer)
		end

	size: NATURAL_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	state: CE_POINTER [ANY] assign set_state
		do
			create Result.make_shared (c_state (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: CE_POINTER [PD_GSL_INTERP_TYPE])
		do
			c_set_type (c_pointer, a_type.c_pointer)
		end

	set_xmin (a_xmin: REAL_64)
		do
			c_set_xmin (c_pointer, a_xmin)
		end

	set_xmax (a_xmax: REAL_64)
		do
			c_set_xmax (c_pointer, a_xmax)
		end

	set_size (a_size: NATURAL_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_state (a_state: CE_POINTER [ANY])
		do
			c_set_state (c_pointer, a_state.c_pointer)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_interp_type *)((struct __anonstruct_gsl_interp_28 *)$tmp)->type;"
		end

	c_xmin (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_interp_28 *)$tmp)->xmin;"
		end

	c_xmax (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_interp_28 *)$tmp)->xmax;"
		end

	c_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_interp_28 *)$tmp)->size;"
		end

	c_state (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_gsl_interp_28 *)$tmp)->state;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_interp_28 *)$tmp)->type = (gsl_interp_type *)$a_type;"
		end

	c_set_xmin (tmp: POINTER; a_xmin: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_interp_28 *)$tmp)->xmin = $a_xmin;"
		end

	c_set_xmax (tmp: POINTER; a_xmax: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_interp_28 *)$tmp)->xmax = $a_xmax;"
		end

	c_set_size (tmp: POINTER; a_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_interp_28 *)$tmp)->size = $a_size;"
		end

	c_set_state (tmp: POINTER; a_state: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_interp_28 *)$tmp)->state = (void *)$a_state;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_interp_28);"
		end

end
