class
	PD_GSL_INTERP_ACCEL

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	cache: NATURAL_32 assign set_cache
		do
			Result := c_cache (c_pointer)
		end

	miss_count: NATURAL_32 assign set_miss_count
		do
			Result := c_miss_count (c_pointer)
		end

	hit_count: NATURAL_32 assign set_hit_count
		do
			Result := c_hit_count (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_cache (a_cache: NATURAL_32)
		do
			c_set_cache (c_pointer, a_cache)
		end

	set_miss_count (a_miss_count: NATURAL_32)
		do
			c_set_miss_count (c_pointer, a_miss_count)
		end

	set_hit_count (a_hit_count: NATURAL_32)
		do
			c_set_hit_count (c_pointer, a_hit_count)
		end

feature {NONE} -- C getters

	c_cache (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_interp_accel_112 *)$tmp)->cache;"
		end

	c_miss_count (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_interp_accel_112 *)$tmp)->miss_count;"
		end

	c_hit_count (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_interp_accel_112 *)$tmp)->hit_count;"
		end

feature {NONE} -- C setters

	c_set_cache (tmp: POINTER; a_cache: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_interp_accel_112 *)$tmp)->cache = $a_cache;"
		end

	c_set_miss_count (tmp: POINTER; a_miss_count: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_interp_accel_112 *)$tmp)->miss_count = $a_miss_count;"
		end

	c_set_hit_count (tmp: POINTER; a_hit_count: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_interp_accel_112 *)$tmp)->hit_count = $a_hit_count;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_interp_accel_112);"
		end

end
