class
	PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	size1: NATURAL_32 assign set_size1
		do
			Result := c_size1 (c_pointer)
		end

	size2: NATURAL_32 assign set_size2
		do
			Result := c_size2 (c_pointer)
		end

	tda: NATURAL_32 assign set_tda
		do
			Result := c_tda (c_pointer)
		end

	data: CE_POINTER [REAL_96] assign set_data
		do
			create Result.make_shared (c_data (c_pointer))
		end

	block: CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT] assign set_block
		do
			create Result.make_shared (c_block (c_pointer))
		end

	owner: INTEGER_32 assign set_owner
		do
			Result := c_owner (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_size1 (a_size1: NATURAL_32)
		do
			c_set_size1 (c_pointer, a_size1)
		end

	set_size2 (a_size2: NATURAL_32)
		do
			c_set_size2 (c_pointer, a_size2)
		end

	set_tda (a_tda: NATURAL_32)
		do
			c_set_tda (c_pointer, a_tda)
		end

	set_data (a_data: CE_POINTER [REAL_96])
		do
			c_set_data (c_pointer, a_data.c_pointer)
		end

	set_block (a_block: CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT])
		do
			c_set_block (c_pointer, a_block.c_pointer)
		end

	set_owner (a_owner: INTEGER_32)
		do
			c_set_owner (c_pointer, a_owner)
		end

feature {NONE} -- C getters

	c_size1 (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_matrix_complex_long_double_71 *)$tmp)->size1;"
		end

	c_size2 (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_matrix_complex_long_double_71 *)$tmp)->size2;"
		end

	c_tda (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_matrix_complex_long_double_71 *)$tmp)->tda;"
		end

	c_data (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (long double *)((struct __anonstruct_gsl_matrix_complex_long_double_71 *)$tmp)->data;"
		end

	c_block (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct gsl_block_complex_long_double_struct *)((struct __anonstruct_gsl_matrix_complex_long_double_71 *)$tmp)->block;"
		end

	c_owner (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_matrix_complex_long_double_71 *)$tmp)->owner;"
		end

feature {NONE} -- C setters

	c_set_size1 (tmp: POINTER; a_size1: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_matrix_complex_long_double_71 *)$tmp)->size1 = $a_size1;"
		end

	c_set_size2 (tmp: POINTER; a_size2: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_matrix_complex_long_double_71 *)$tmp)->size2 = $a_size2;"
		end

	c_set_tda (tmp: POINTER; a_tda: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_matrix_complex_long_double_71 *)$tmp)->tda = $a_tda;"
		end

	c_set_data (tmp: POINTER; a_data: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_matrix_complex_long_double_71 *)$tmp)->data = (long double *)$a_data;"
		end

	c_set_block (tmp: POINTER; a_block: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_matrix_complex_long_double_71 *)$tmp)->block = (struct gsl_block_complex_long_double_struct *)$a_block;"
		end

	c_set_owner (tmp: POINTER; a_owner: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_matrix_complex_long_double_71 *)$tmp)->owner = $a_owner;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_matrix_complex_long_double_71);"
		end

end
