class
	PD_GSL_MATRIX_INT_VIEW

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	matrix: PD_GSL_MATRIX_INT assign set_matrix
		do
			create Result.make_shared (c_matrix (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_matrix (a_matrix: PD_GSL_MATRIX_INT)
		do
			matrix.ce_gets (a_matrix)
		end

feature {NONE} -- C getters

	c_matrix (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix_int *)&((struct __anonstruct__gsl_matrix_int_view_85 *)$tmp)->matrix;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct__gsl_matrix_int_view_85);"
		end

end
