class
	PD_GSL_MIN_FMINIMIZER_TYPE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	size: NATURAL_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	set: CE_ROUTINE assign set_set
		do
			create Result.make_shared (c_set (c_pointer))
		end

	iterate: CE_ROUTINE assign set_iterate
		do
			create Result.make_shared (c_iterate (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_size (a_size: NATURAL_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_set (a_set: CE_ROUTINE)
		do
			c_set_set (c_pointer, a_set.c_pointer)
		end

	set_iterate (a_iterate: CE_ROUTINE)
		do
			c_set_iterate (c_pointer, a_iterate.c_pointer)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_gsl_min_fminimizer_type_26 *)$tmp)->name;"
		end

	c_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_min_fminimizer_type_26 *)$tmp)->size;"
		end

	c_set (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void * state, struct gsl_function_struct * f, double x_minimum, double f_minimum, double x_lower, double f_lower, double x_upper, double f_upper))((struct __anonstruct_gsl_min_fminimizer_type_26 *)$tmp)->set;"
		end

	c_iterate (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void * state, struct gsl_function_struct * f, double * x_minimum, double * f_minimum, double * x_lower, double * f_lower, double * x_upper, double * f_upper))((struct __anonstruct_gsl_min_fminimizer_type_26 *)$tmp)->iterate;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_min_fminimizer_type_26 *)$tmp)->name = (char const *)$a_name;"
		end

	c_set_size (tmp: POINTER; a_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_min_fminimizer_type_26 *)$tmp)->size = $a_size;"
		end

	c_set_set (tmp: POINTER; a_set: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_min_fminimizer_type_26 *)$tmp)->set = (int( *)(void * state, struct gsl_function_struct * f, double x_minimum, double f_minimum, double x_lower, double f_lower, double x_upper, double f_upper))$a_set;"
		end

	c_set_iterate (tmp: POINTER; a_iterate: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_min_fminimizer_type_26 *)$tmp)->iterate = (int( *)(void * state, struct gsl_function_struct * f, double * x_minimum, double * f_minimum, double * x_lower, double * f_lower, double * x_upper, double * f_upper))$a_iterate;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_min_fminimizer_type_26);"
		end

end
