class
	PD_GSL_MONTE_VEGAS_PARAMS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	alpha: REAL_64 assign set_alpha
		do
			Result := c_alpha (c_pointer)
		end

	iterations: NATURAL_32 assign set_iterations
		do
			Result := c_iterations (c_pointer)
		end

	stage: INTEGER_32 assign set_stage
		do
			Result := c_stage (c_pointer)
		end

	mode: INTEGER_32 assign set_mode
		do
			Result := c_mode (c_pointer)
		end

	verbose: INTEGER_32 assign set_verbose
		do
			Result := c_verbose (c_pointer)
		end

	ostream: CE_POINTER [SD_IO_FILE] assign set_ostream
		do
			create Result.make_shared (c_ostream (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_alpha (a_alpha: REAL_64)
		do
			c_set_alpha (c_pointer, a_alpha)
		end

	set_iterations (a_iterations: NATURAL_32)
		do
			c_set_iterations (c_pointer, a_iterations)
		end

	set_stage (a_stage: INTEGER_32)
		do
			c_set_stage (c_pointer, a_stage)
		end

	set_mode (a_mode: INTEGER_32)
		do
			c_set_mode (c_pointer, a_mode)
		end

	set_verbose (a_verbose: INTEGER_32)
		do
			c_set_verbose (c_pointer, a_verbose)
		end

	set_ostream (a_ostream: CE_POINTER [SD_IO_FILE])
		do
			c_set_ostream (c_pointer, a_ostream.c_pointer)
		end

feature {NONE} -- C getters

	c_alpha (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_monte_vegas_params_30 *)$tmp)->alpha;"
		end

	c_iterations (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_monte_vegas_params_30 *)$tmp)->iterations;"
		end

	c_stage (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_monte_vegas_params_30 *)$tmp)->stage;"
		end

	c_mode (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_monte_vegas_params_30 *)$tmp)->mode;"
		end

	c_verbose (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_monte_vegas_params_30 *)$tmp)->verbose;"
		end

	c_ostream (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _IO_FILE *)((struct __anonstruct_gsl_monte_vegas_params_30 *)$tmp)->ostream;"
		end

feature {NONE} -- C setters

	c_set_alpha (tmp: POINTER; a_alpha: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_params_30 *)$tmp)->alpha = $a_alpha;"
		end

	c_set_iterations (tmp: POINTER; a_iterations: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_params_30 *)$tmp)->iterations = $a_iterations;"
		end

	c_set_stage (tmp: POINTER; a_stage: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_params_30 *)$tmp)->stage = $a_stage;"
		end

	c_set_mode (tmp: POINTER; a_mode: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_params_30 *)$tmp)->mode = $a_mode;"
		end

	c_set_verbose (tmp: POINTER; a_verbose: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_params_30 *)$tmp)->verbose = $a_verbose;"
		end

	c_set_ostream (tmp: POINTER; a_ostream: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_params_30 *)$tmp)->ostream = (struct _IO_FILE *)$a_ostream;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_monte_vegas_params_30);"
		end

end
