class
	PD_GSL_MONTE_VEGAS_STATE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	dim: NATURAL_32 assign set_dim
		do
			Result := c_dim (c_pointer)
		end

	bins_max: NATURAL_32 assign set_bins_max
		do
			Result := c_bins_max (c_pointer)
		end

	bins: NATURAL_32 assign set_bins
		do
			Result := c_bins (c_pointer)
		end

	boxes: NATURAL_32 assign set_boxes
		do
			Result := c_boxes (c_pointer)
		end

	xi: CE_POINTER [REAL_64] assign set_xi
		do
			create Result.make_shared (c_xi (c_pointer))
		end

	xin: CE_POINTER [REAL_64] assign set_xin
		do
			create Result.make_shared (c_xin (c_pointer))
		end

	delx: CE_POINTER [REAL_64] assign set_delx
		do
			create Result.make_shared (c_delx (c_pointer))
		end

	weight: CE_POINTER [REAL_64] assign set_weight
		do
			create Result.make_shared (c_weight (c_pointer))
		end

	vol: REAL_64 assign set_vol
		do
			Result := c_vol (c_pointer)
		end

	x: CE_POINTER [REAL_64] assign set_x
		do
			create Result.make_shared (c_x (c_pointer))
		end

	bin: CE_POINTER [INTEGER_32] assign set_bin
		do
			create Result.make_shared (c_bin (c_pointer))
		end

	box: CE_POINTER [INTEGER_32] assign set_box
		do
			create Result.make_shared (c_box (c_pointer))
		end

	d: CE_POINTER [REAL_64] assign set_d
		do
			create Result.make_shared (c_d (c_pointer))
		end

	alpha: REAL_64 assign set_alpha
		do
			Result := c_alpha (c_pointer)
		end

	mode: INTEGER_32 assign set_mode
		do
			Result := c_mode (c_pointer)
		end

	verbose: INTEGER_32 assign set_verbose
		do
			Result := c_verbose (c_pointer)
		end

	iterations: NATURAL_32 assign set_iterations
		do
			Result := c_iterations (c_pointer)
		end

	stage: INTEGER_32 assign set_stage
		do
			Result := c_stage (c_pointer)
		end

	jac: REAL_64 assign set_jac
		do
			Result := c_jac (c_pointer)
		end

	wtd_int_sum: REAL_64 assign set_wtd_int_sum
		do
			Result := c_wtd_int_sum (c_pointer)
		end

	sum_wgts: REAL_64 assign set_sum_wgts
		do
			Result := c_sum_wgts (c_pointer)
		end

	chi_sum: REAL_64 assign set_chi_sum
		do
			Result := c_chi_sum (c_pointer)
		end

	chisq: REAL_64 assign set_chisq
		do
			Result := c_chisq (c_pointer)
		end

	result2: REAL_64 assign set_result2
		do
			Result := c_result2 (c_pointer)
		end

	sigma: REAL_64 assign set_sigma
		do
			Result := c_sigma (c_pointer)
		end

	it_start: NATURAL_32 assign set_it_start
		do
			Result := c_it_start (c_pointer)
		end

	it_num: NATURAL_32 assign set_it_num
		do
			Result := c_it_num (c_pointer)
		end

	samples: NATURAL_32 assign set_samples
		do
			Result := c_samples (c_pointer)
		end

	calls_per_box: NATURAL_32 assign set_calls_per_box
		do
			Result := c_calls_per_box (c_pointer)
		end

	ostream: CE_POINTER [SD_IO_FILE] assign set_ostream
		do
			create Result.make_shared (c_ostream (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_dim (a_dim: NATURAL_32)
		do
			c_set_dim (c_pointer, a_dim)
		end

	set_bins_max (a_bins_max: NATURAL_32)
		do
			c_set_bins_max (c_pointer, a_bins_max)
		end

	set_bins (a_bins: NATURAL_32)
		do
			c_set_bins (c_pointer, a_bins)
		end

	set_boxes (a_boxes: NATURAL_32)
		do
			c_set_boxes (c_pointer, a_boxes)
		end

	set_xi (a_xi: CE_POINTER [REAL_64])
		do
			c_set_xi (c_pointer, a_xi.c_pointer)
		end

	set_xin (a_xin: CE_POINTER [REAL_64])
		do
			c_set_xin (c_pointer, a_xin.c_pointer)
		end

	set_delx (a_delx: CE_POINTER [REAL_64])
		do
			c_set_delx (c_pointer, a_delx.c_pointer)
		end

	set_weight (a_weight: CE_POINTER [REAL_64])
		do
			c_set_weight (c_pointer, a_weight.c_pointer)
		end

	set_vol (a_vol: REAL_64)
		do
			c_set_vol (c_pointer, a_vol)
		end

	set_x (a_x: CE_POINTER [REAL_64])
		do
			c_set_x (c_pointer, a_x.c_pointer)
		end

	set_bin (a_bin: CE_POINTER [INTEGER_32])
		do
			c_set_bin (c_pointer, a_bin.c_pointer)
		end

	set_box (a_box: CE_POINTER [INTEGER_32])
		do
			c_set_box (c_pointer, a_box.c_pointer)
		end

	set_d (a_d: CE_POINTER [REAL_64])
		do
			c_set_d (c_pointer, a_d.c_pointer)
		end

	set_alpha (a_alpha: REAL_64)
		do
			c_set_alpha (c_pointer, a_alpha)
		end

	set_mode (a_mode: INTEGER_32)
		do
			c_set_mode (c_pointer, a_mode)
		end

	set_verbose (a_verbose: INTEGER_32)
		do
			c_set_verbose (c_pointer, a_verbose)
		end

	set_iterations (a_iterations: NATURAL_32)
		do
			c_set_iterations (c_pointer, a_iterations)
		end

	set_stage (a_stage: INTEGER_32)
		do
			c_set_stage (c_pointer, a_stage)
		end

	set_jac (a_jac: REAL_64)
		do
			c_set_jac (c_pointer, a_jac)
		end

	set_wtd_int_sum (a_wtd_int_sum: REAL_64)
		do
			c_set_wtd_int_sum (c_pointer, a_wtd_int_sum)
		end

	set_sum_wgts (a_sum_wgts: REAL_64)
		do
			c_set_sum_wgts (c_pointer, a_sum_wgts)
		end

	set_chi_sum (a_chi_sum: REAL_64)
		do
			c_set_chi_sum (c_pointer, a_chi_sum)
		end

	set_chisq (a_chisq: REAL_64)
		do
			c_set_chisq (c_pointer, a_chisq)
		end

	set_result2 (a_result2: REAL_64)
		do
			c_set_result2 (c_pointer, a_result2)
		end

	set_sigma (a_sigma: REAL_64)
		do
			c_set_sigma (c_pointer, a_sigma)
		end

	set_it_start (a_it_start: NATURAL_32)
		do
			c_set_it_start (c_pointer, a_it_start)
		end

	set_it_num (a_it_num: NATURAL_32)
		do
			c_set_it_num (c_pointer, a_it_num)
		end

	set_samples (a_samples: NATURAL_32)
		do
			c_set_samples (c_pointer, a_samples)
		end

	set_calls_per_box (a_calls_per_box: NATURAL_32)
		do
			c_set_calls_per_box (c_pointer, a_calls_per_box)
		end

	set_ostream (a_ostream: CE_POINTER [SD_IO_FILE])
		do
			c_set_ostream (c_pointer, a_ostream.c_pointer)
		end

feature {NONE} -- C getters

	c_dim (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->dim;"
		end

	c_bins_max (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->bins_max;"
		end

	c_bins (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->bins;"
		end

	c_boxes (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->boxes;"
		end

	c_xi (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->xi;"
		end

	c_xin (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->xin;"
		end

	c_delx (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->delx;"
		end

	c_weight (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->weight;"
		end

	c_vol (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->vol;"
		end

	c_x (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->x;"
		end

	c_bin (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int *)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->bin;"
		end

	c_box (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int *)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->box;"
		end

	c_d (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->d;"
		end

	c_alpha (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->alpha;"
		end

	c_mode (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->mode;"
		end

	c_verbose (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->verbose;"
		end

	c_iterations (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->iterations;"
		end

	c_stage (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->stage;"
		end

	c_jac (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->jac;"
		end

	c_wtd_int_sum (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->wtd_int_sum;"
		end

	c_sum_wgts (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->sum_wgts;"
		end

	c_chi_sum (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->chi_sum;"
		end

	c_chisq (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->chisq;"
		end

	c_result2 (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->result;"
		end

	c_sigma (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->sigma;"
		end

	c_it_start (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->it_start;"
		end

	c_it_num (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->it_num;"
		end

	c_samples (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->samples;"
		end

	c_calls_per_box (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->calls_per_box;"
		end

	c_ostream (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct _IO_FILE *)((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->ostream;"
		end

feature {NONE} -- C setters

	c_set_dim (tmp: POINTER; a_dim: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->dim = $a_dim;"
		end

	c_set_bins_max (tmp: POINTER; a_bins_max: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->bins_max = $a_bins_max;"
		end

	c_set_bins (tmp: POINTER; a_bins: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->bins = $a_bins;"
		end

	c_set_boxes (tmp: POINTER; a_boxes: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->boxes = $a_boxes;"
		end

	c_set_xi (tmp: POINTER; a_xi: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->xi = (double *)$a_xi;"
		end

	c_set_xin (tmp: POINTER; a_xin: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->xin = (double *)$a_xin;"
		end

	c_set_delx (tmp: POINTER; a_delx: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->delx = (double *)$a_delx;"
		end

	c_set_weight (tmp: POINTER; a_weight: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->weight = (double *)$a_weight;"
		end

	c_set_vol (tmp: POINTER; a_vol: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->vol = $a_vol;"
		end

	c_set_x (tmp: POINTER; a_x: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->x = (double *)$a_x;"
		end

	c_set_bin (tmp: POINTER; a_bin: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->bin = (int *)$a_bin;"
		end

	c_set_box (tmp: POINTER; a_box: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->box = (int *)$a_box;"
		end

	c_set_d (tmp: POINTER; a_d: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->d = (double *)$a_d;"
		end

	c_set_alpha (tmp: POINTER; a_alpha: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->alpha = $a_alpha;"
		end

	c_set_mode (tmp: POINTER; a_mode: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->mode = $a_mode;"
		end

	c_set_verbose (tmp: POINTER; a_verbose: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->verbose = $a_verbose;"
		end

	c_set_iterations (tmp: POINTER; a_iterations: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->iterations = $a_iterations;"
		end

	c_set_stage (tmp: POINTER; a_stage: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->stage = $a_stage;"
		end

	c_set_jac (tmp: POINTER; a_jac: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->jac = $a_jac;"
		end

	c_set_wtd_int_sum (tmp: POINTER; a_wtd_int_sum: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->wtd_int_sum = $a_wtd_int_sum;"
		end

	c_set_sum_wgts (tmp: POINTER; a_sum_wgts: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->sum_wgts = $a_sum_wgts;"
		end

	c_set_chi_sum (tmp: POINTER; a_chi_sum: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->chi_sum = $a_chi_sum;"
		end

	c_set_chisq (tmp: POINTER; a_chisq: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->chisq = $a_chisq;"
		end

	c_set_result2 (tmp: POINTER; a_result2: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->result = $a_result2;"
		end

	c_set_sigma (tmp: POINTER; a_sigma: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->sigma = $a_sigma;"
		end

	c_set_it_start (tmp: POINTER; a_it_start: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->it_start = $a_it_start;"
		end

	c_set_it_num (tmp: POINTER; a_it_num: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->it_num = $a_it_num;"
		end

	c_set_samples (tmp: POINTER; a_samples: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->samples = $a_samples;"
		end

	c_set_calls_per_box (tmp: POINTER; a_calls_per_box: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->calls_per_box = $a_calls_per_box;"
		end

	c_set_ostream (tmp: POINTER; a_ostream: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_monte_vegas_state_29 *)$tmp)->ostream = (struct _IO_FILE *)$a_ostream;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_monte_vegas_state_29);"
		end

end
