class
	PD_GSL_MULTIFIT_FSOLVER_TYPE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	size: NATURAL_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	alloc: CE_ROUTINE assign set_alloc
		do
			create Result.make_shared (c_alloc (c_pointer))
		end

	set: CE_ROUTINE assign set_set
		do
			create Result.make_shared (c_set (c_pointer))
		end

	iterate: CE_ROUTINE assign set_iterate
		do
			create Result.make_shared (c_iterate (c_pointer))
		end

	free: CE_ROUTINE assign set_free
		do
			create Result.make_shared (c_free (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_size (a_size: NATURAL_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_alloc (a_alloc: CE_ROUTINE)
		do
			c_set_alloc (c_pointer, a_alloc.c_pointer)
		end

	set_set (a_set: CE_ROUTINE)
		do
			c_set_set (c_pointer, a_set.c_pointer)
		end

	set_iterate (a_iterate: CE_ROUTINE)
		do
			c_set_iterate (c_pointer, a_iterate.c_pointer)
		end

	set_free (a_free: CE_ROUTINE)
		do
			c_set_free (c_pointer, a_free.c_pointer)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_gsl_multifit_fsolver_type_113 *)$tmp)->name;"
		end

	c_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_multifit_fsolver_type_113 *)$tmp)->size;"
		end

	c_alloc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void * state, unsigned int n, unsigned int p))((struct __anonstruct_gsl_multifit_fsolver_type_113 *)$tmp)->alloc;"
		end

	c_set (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void * state, struct gsl_multifit_function_struct * function, gsl_vector * x, gsl_vector * f, gsl_vector * dx))((struct __anonstruct_gsl_multifit_fsolver_type_113 *)$tmp)->set;"
		end

	c_iterate (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void * state, struct gsl_multifit_function_struct * function, gsl_vector * x, gsl_vector * f, gsl_vector * dx))((struct __anonstruct_gsl_multifit_fsolver_type_113 *)$tmp)->iterate;"
		end

	c_free (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void * state))((struct __anonstruct_gsl_multifit_fsolver_type_113 *)$tmp)->free;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multifit_fsolver_type_113 *)$tmp)->name = (char const *)$a_name;"
		end

	c_set_size (tmp: POINTER; a_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multifit_fsolver_type_113 *)$tmp)->size = $a_size;"
		end

	c_set_alloc (tmp: POINTER; a_alloc: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multifit_fsolver_type_113 *)$tmp)->alloc = (int( *)(void * state, unsigned int n, unsigned int p))$a_alloc;"
		end

	c_set_set (tmp: POINTER; a_set: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multifit_fsolver_type_113 *)$tmp)->set = (int( *)(void * state, struct gsl_multifit_function_struct * function, gsl_vector * x, gsl_vector * f, gsl_vector * dx))$a_set;"
		end

	c_set_iterate (tmp: POINTER; a_iterate: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multifit_fsolver_type_113 *)$tmp)->iterate = (int( *)(void * state, struct gsl_multifit_function_struct * function, gsl_vector * x, gsl_vector * f, gsl_vector * dx))$a_iterate;"
		end

	c_set_free (tmp: POINTER; a_free: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multifit_fsolver_type_113 *)$tmp)->free = (void( *)(void * state))$a_free;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_multifit_fsolver_type_113);"
		end

end
