class
	PD_GSL_MULTIFIT_LINEAR_WORKSPACE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	n: NATURAL_32 assign set_n
		do
			Result := c_n (c_pointer)
		end

	p: NATURAL_32 assign set_p
		do
			Result := c_p (c_pointer)
		end

	A: CE_POINTER [PD_GSL_MATRIX] assign set_A
		do
			create Result.make_shared (c_A (c_pointer))
		end

	Q: CE_POINTER [PD_GSL_MATRIX] assign set_Q
		do
			create Result.make_shared (c_Q (c_pointer))
		end

	QSI: CE_POINTER [PD_GSL_MATRIX] assign set_QSI
		do
			create Result.make_shared (c_QSI (c_pointer))
		end

	S: CE_POINTER [PD_GSL_VECTOR] assign set_S
		do
			create Result.make_shared (c_S (c_pointer))
		end

	t: CE_POINTER [PD_GSL_VECTOR] assign set_t
		do
			create Result.make_shared (c_t (c_pointer))
		end

	xt: CE_POINTER [PD_GSL_VECTOR] assign set_xt
		do
			create Result.make_shared (c_xt (c_pointer))
		end

	D: CE_POINTER [PD_GSL_VECTOR] assign set_D
		do
			create Result.make_shared (c_D (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_n (a_n: NATURAL_32)
		do
			c_set_n (c_pointer, a_n)
		end

	set_p (a_p: NATURAL_32)
		do
			c_set_p (c_pointer, a_p)
		end

	set_A (a_A: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_A (c_pointer, a_A.c_pointer)
		end

	set_Q (a_Q: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_Q (c_pointer, a_Q.c_pointer)
		end

	set_QSI (a_QSI: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_QSI (c_pointer, a_QSI.c_pointer)
		end

	set_S (a_S: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_S (c_pointer, a_S.c_pointer)
		end

	set_t (a_t: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_t (c_pointer, a_t.c_pointer)
		end

	set_xt (a_xt: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_xt (c_pointer, a_xt.c_pointer)
		end

	set_D (a_D: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_D (c_pointer, a_D.c_pointer)
		end

feature {NONE} -- C getters

	c_n (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_multifit_linear_workspace_113 *)$tmp)->n;"
		end

	c_p (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_multifit_linear_workspace_113 *)$tmp)->p;"
		end

	c_A (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_gsl_multifit_linear_workspace_113 *)$tmp)->A;"
		end

	c_Q (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_gsl_multifit_linear_workspace_113 *)$tmp)->Q;"
		end

	c_QSI (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_gsl_multifit_linear_workspace_113 *)$tmp)->QSI;"
		end

	c_S (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_multifit_linear_workspace_113 *)$tmp)->S;"
		end

	c_t (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_multifit_linear_workspace_113 *)$tmp)->t;"
		end

	c_xt (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_multifit_linear_workspace_113 *)$tmp)->xt;"
		end

	c_D (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_multifit_linear_workspace_113 *)$tmp)->D;"
		end

feature {NONE} -- C setters

	c_set_n (tmp: POINTER; a_n: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multifit_linear_workspace_113 *)$tmp)->n = $a_n;"
		end

	c_set_p (tmp: POINTER; a_p: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multifit_linear_workspace_113 *)$tmp)->p = $a_p;"
		end

	c_set_A (tmp: POINTER; a_A: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multifit_linear_workspace_113 *)$tmp)->A = (gsl_matrix *)$a_a;"
		end

	c_set_Q (tmp: POINTER; a_Q: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multifit_linear_workspace_113 *)$tmp)->Q = (gsl_matrix *)$a_q;"
		end

	c_set_QSI (tmp: POINTER; a_QSI: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multifit_linear_workspace_113 *)$tmp)->QSI = (gsl_matrix *)$a_qsi;"
		end

	c_set_S (tmp: POINTER; a_S: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multifit_linear_workspace_113 *)$tmp)->S = (gsl_vector *)$a_s;"
		end

	c_set_t (tmp: POINTER; a_t: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multifit_linear_workspace_113 *)$tmp)->t = (gsl_vector *)$a_t;"
		end

	c_set_xt (tmp: POINTER; a_xt: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multifit_linear_workspace_113 *)$tmp)->xt = (gsl_vector *)$a_xt;"
		end

	c_set_D (tmp: POINTER; a_D: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multifit_linear_workspace_113 *)$tmp)->D = (gsl_vector *)$a_d;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_multifit_linear_workspace_113);"
		end

end
