class
	PD_GSL_MULTIROOT_FDFSOLVER

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER_TYPE] assign set_type
		do
			create Result.make_shared (c_type (c_pointer))
		end

	fdf: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT] assign set_fdf
		do
			create Result.make_shared (c_fdf (c_pointer))
		end

	x: CE_POINTER [PD_GSL_VECTOR] assign set_x
		do
			create Result.make_shared (c_x (c_pointer))
		end

	f: CE_POINTER [PD_GSL_VECTOR] assign set_f
		do
			create Result.make_shared (c_f (c_pointer))
		end

	J: CE_POINTER [PD_GSL_MATRIX] assign set_J
		do
			create Result.make_shared (c_J (c_pointer))
		end

	dx: CE_POINTER [PD_GSL_VECTOR] assign set_dx
		do
			create Result.make_shared (c_dx (c_pointer))
		end

	state: CE_POINTER [ANY] assign set_state
		do
			create Result.make_shared (c_state (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER_TYPE])
		do
			c_set_type (c_pointer, a_type.c_pointer)
		end

	set_fdf (a_fdf: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT])
		do
			c_set_fdf (c_pointer, a_fdf.c_pointer)
		end

	set_x (a_x: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_x (c_pointer, a_x.c_pointer)
		end

	set_f (a_f: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_f (c_pointer, a_f.c_pointer)
		end

	set_J (a_J: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_J (c_pointer, a_J.c_pointer)
		end

	set_dx (a_dx: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_dx (c_pointer, a_dx.c_pointer)
		end

	set_state (a_state: CE_POINTER [ANY])
		do
			c_set_state (c_pointer, a_state.c_pointer)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_multiroot_fdfsolver_type *)((struct __anonstruct_gsl_multiroot_fdfsolver_116 *)$tmp)->type;"
		end

	c_fdf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct gsl_multiroot_function_fdf_struct *)((struct __anonstruct_gsl_multiroot_fdfsolver_116 *)$tmp)->fdf;"
		end

	c_x (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_multiroot_fdfsolver_116 *)$tmp)->x;"
		end

	c_f (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_multiroot_fdfsolver_116 *)$tmp)->f;"
		end

	c_J (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_gsl_multiroot_fdfsolver_116 *)$tmp)->J;"
		end

	c_dx (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_gsl_multiroot_fdfsolver_116 *)$tmp)->dx;"
		end

	c_state (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_gsl_multiroot_fdfsolver_116 *)$tmp)->state;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multiroot_fdfsolver_116 *)$tmp)->type = (gsl_multiroot_fdfsolver_type *)$a_type;"
		end

	c_set_fdf (tmp: POINTER; a_fdf: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multiroot_fdfsolver_116 *)$tmp)->fdf = (struct gsl_multiroot_function_fdf_struct *)$a_fdf;"
		end

	c_set_x (tmp: POINTER; a_x: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multiroot_fdfsolver_116 *)$tmp)->x = (gsl_vector *)$a_x;"
		end

	c_set_f (tmp: POINTER; a_f: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multiroot_fdfsolver_116 *)$tmp)->f = (gsl_vector *)$a_f;"
		end

	c_set_J (tmp: POINTER; a_J: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multiroot_fdfsolver_116 *)$tmp)->J = (gsl_matrix *)$a_j;"
		end

	c_set_dx (tmp: POINTER; a_dx: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multiroot_fdfsolver_116 *)$tmp)->dx = (gsl_vector *)$a_dx;"
		end

	c_set_state (tmp: POINTER; a_state: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_multiroot_fdfsolver_116 *)$tmp)->state = (void *)$a_state;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_multiroot_fdfsolver_116);"
		end

end
