class
	PD_GSL_ODEIV_CONTROL_TYPE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	alloc: CE_ROUTINE assign set_alloc
		do
			create Result.make_shared (c_alloc (c_pointer))
		end

	init: CE_ROUTINE assign set_init
		do
			create Result.make_shared (c_init (c_pointer))
		end

	hadjust: CE_ROUTINE assign set_hadjust
		do
			create Result.make_shared (c_hadjust (c_pointer))
		end

	free: CE_ROUTINE assign set_free
		do
			create Result.make_shared (c_free (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_alloc (a_alloc: CE_ROUTINE)
		do
			c_set_alloc (c_pointer, a_alloc.c_pointer)
		end

	set_init (a_init: CE_ROUTINE)
		do
			c_set_init (c_pointer, a_init.c_pointer)
		end

	set_hadjust (a_hadjust: CE_ROUTINE)
		do
			c_set_hadjust (c_pointer, a_hadjust.c_pointer)
		end

	set_free (a_free: CE_ROUTINE)
		do
			c_set_free (c_pointer, a_free.c_pointer)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_gsl_odeiv_control_type_29 *)$tmp)->name;"
		end

	c_alloc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *( *)())((struct __anonstruct_gsl_odeiv_control_type_29 *)$tmp)->alloc;"
		end

	c_init (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void * state, double eps_abs, double eps_rel, double a_y, double a_dydt))((struct __anonstruct_gsl_odeiv_control_type_29 *)$tmp)->init;"
		end

	c_hadjust (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void * state, unsigned int dim, unsigned int ord, double * y, double * yerr, double * yp, double * h))((struct __anonstruct_gsl_odeiv_control_type_29 *)$tmp)->hadjust;"
		end

	c_free (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void * state))((struct __anonstruct_gsl_odeiv_control_type_29 *)$tmp)->free;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_odeiv_control_type_29 *)$tmp)->name = (char const *)$a_name;"
		end

	c_set_alloc (tmp: POINTER; a_alloc: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_odeiv_control_type_29 *)$tmp)->alloc = (void *( *)())$a_alloc;"
		end

	c_set_init (tmp: POINTER; a_init: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_odeiv_control_type_29 *)$tmp)->init = (int( *)(void * state, double eps_abs, double eps_rel, double a_y, double a_dydt))$a_init;"
		end

	c_set_hadjust (tmp: POINTER; a_hadjust: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_odeiv_control_type_29 *)$tmp)->hadjust = (int( *)(void * state, unsigned int dim, unsigned int ord, double const * y, double const * yerr, double const * yp, double * h))$a_hadjust;"
		end

	c_set_free (tmp: POINTER; a_free: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_odeiv_control_type_29 *)$tmp)->free = (void( *)(void * state))$a_free;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_odeiv_control_type_29);"
		end

end
