class
	PD_GSL_ODEIV_STEP_TYPE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	can_use_dydt_in: INTEGER_32 assign set_can_use_dydt_in
		do
			Result := c_can_use_dydt_in (c_pointer)
		end

	gives_exact_dydt_out: INTEGER_32 assign set_gives_exact_dydt_out
		do
			Result := c_gives_exact_dydt_out (c_pointer)
		end

	alloc: CE_ROUTINE assign set_alloc
		do
			create Result.make_shared (c_alloc (c_pointer))
		end

	apply: CE_ROUTINE assign set_apply
		do
			create Result.make_shared (c_apply (c_pointer))
		end

	reset: CE_ROUTINE assign set_reset
		do
			create Result.make_shared (c_reset (c_pointer))
		end

	order: CE_ROUTINE assign set_order
		do
			create Result.make_shared (c_order (c_pointer))
		end

	free: CE_ROUTINE assign set_free
		do
			create Result.make_shared (c_free (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_can_use_dydt_in (a_can_use_dydt_in: INTEGER_32)
		do
			c_set_can_use_dydt_in (c_pointer, a_can_use_dydt_in)
		end

	set_gives_exact_dydt_out (a_gives_exact_dydt_out: INTEGER_32)
		do
			c_set_gives_exact_dydt_out (c_pointer, a_gives_exact_dydt_out)
		end

	set_alloc (a_alloc: CE_ROUTINE)
		do
			c_set_alloc (c_pointer, a_alloc.c_pointer)
		end

	set_apply (a_apply: CE_ROUTINE)
		do
			c_set_apply (c_pointer, a_apply.c_pointer)
		end

	set_reset (a_reset: CE_ROUTINE)
		do
			c_set_reset (c_pointer, a_reset.c_pointer)
		end

	set_order (a_order: CE_ROUTINE)
		do
			c_set_order (c_pointer, a_order.c_pointer)
		end

	set_free (a_free: CE_ROUTINE)
		do
			c_set_free (c_pointer, a_free.c_pointer)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_gsl_odeiv_step_type_25 *)$tmp)->name;"
		end

	c_can_use_dydt_in (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_odeiv_step_type_25 *)$tmp)->can_use_dydt_in;"
		end

	c_gives_exact_dydt_out (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_gsl_odeiv_step_type_25 *)$tmp)->gives_exact_dydt_out;"
		end

	c_alloc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *( *)(unsigned int dim))((struct __anonstruct_gsl_odeiv_step_type_25 *)$tmp)->alloc;"
		end

	c_apply (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void * state, unsigned int dim, double t, double h, double * y, double * yerr, double * dydt_in, double * dydt_out, gsl_odeiv_system * dydt))((struct __anonstruct_gsl_odeiv_step_type_25 *)$tmp)->apply;"
		end

	c_reset (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void * state, unsigned int dim))((struct __anonstruct_gsl_odeiv_step_type_25 *)$tmp)->reset;"
		end

	c_order (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned int( *)(void * state))((struct __anonstruct_gsl_odeiv_step_type_25 *)$tmp)->order;"
		end

	c_free (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void * state))((struct __anonstruct_gsl_odeiv_step_type_25 *)$tmp)->free;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_odeiv_step_type_25 *)$tmp)->name = (char const *)$a_name;"
		end

	c_set_can_use_dydt_in (tmp: POINTER; a_can_use_dydt_in: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_odeiv_step_type_25 *)$tmp)->can_use_dydt_in = $a_can_use_dydt_in;"
		end

	c_set_gives_exact_dydt_out (tmp: POINTER; a_gives_exact_dydt_out: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_odeiv_step_type_25 *)$tmp)->gives_exact_dydt_out = $a_gives_exact_dydt_out;"
		end

	c_set_alloc (tmp: POINTER; a_alloc: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_odeiv_step_type_25 *)$tmp)->alloc = (void *( *)(unsigned int dim))$a_alloc;"
		end

	c_set_apply (tmp: POINTER; a_apply: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_odeiv_step_type_25 *)$tmp)->apply = (int( *)(void * state, unsigned int dim, double t, double h, double * y, double * yerr, double const * dydt_in, double * dydt_out, gsl_odeiv_system * dydt))$a_apply;"
		end

	c_set_reset (tmp: POINTER; a_reset: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_odeiv_step_type_25 *)$tmp)->reset = (int( *)(void * state, unsigned int dim))$a_reset;"
		end

	c_set_order (tmp: POINTER; a_order: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_odeiv_step_type_25 *)$tmp)->order = (unsigned int( *)(void * state))$a_order;"
		end

	c_set_free (tmp: POINTER; a_free: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_odeiv_step_type_25 *)$tmp)->free = (void( *)(void * state))$a_free;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_odeiv_step_type_25);"
		end

end
