class
	PD_GSL_QRNG

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: CE_POINTER [PD_GSL_QRNG_TYPE] assign set_type
		do
			create Result.make_shared (c_type (c_pointer))
		end

	dimension: NATURAL_32 assign set_dimension
		do
			Result := c_dimension (c_pointer)
		end

	state_size: NATURAL_32 assign set_state_size
		do
			Result := c_state_size (c_pointer)
		end

	state: CE_POINTER [ANY] assign set_state
		do
			create Result.make_shared (c_state (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: CE_POINTER [PD_GSL_QRNG_TYPE])
		do
			c_set_type (c_pointer, a_type.c_pointer)
		end

	set_dimension (a_dimension: NATURAL_32)
		do
			c_set_dimension (c_pointer, a_dimension)
		end

	set_state_size (a_state_size: NATURAL_32)
		do
			c_set_state_size (c_pointer, a_state_size)
		end

	set_state (a_state: CE_POINTER [ANY])
		do
			c_set_state (c_pointer, a_state.c_pointer)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_qrng_type *)((struct __anonstruct_gsl_qrng_25 *)$tmp)->type;"
		end

	c_dimension (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_qrng_25 *)$tmp)->dimension;"
		end

	c_state_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_qrng_25 *)$tmp)->state_size;"
		end

	c_state (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_gsl_qrng_25 *)$tmp)->state;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_qrng_25 *)$tmp)->type = (gsl_qrng_type *)$a_type;"
		end

	c_set_dimension (tmp: POINTER; a_dimension: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_qrng_25 *)$tmp)->dimension = $a_dimension;"
		end

	c_set_state_size (tmp: POINTER; a_state_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_qrng_25 *)$tmp)->state_size = $a_state_size;"
		end

	c_set_state (tmp: POINTER; a_state: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_qrng_25 *)$tmp)->state = (void *)$a_state;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_qrng_25);"
		end

end
