class
	PD_GSL_QRNG_TYPE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	max_dimension: NATURAL_32 assign set_max_dimension
		do
			Result := c_max_dimension (c_pointer)
		end

	state_size: CE_ROUTINE assign set_state_size
		do
			create Result.make_shared (c_state_size (c_pointer))
		end

	init_state: CE_ROUTINE assign set_init_state
		do
			create Result.make_shared (c_init_state (c_pointer))
		end

	get: CE_ROUTINE assign set_get
		do
			create Result.make_shared (c_get (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_max_dimension (a_max_dimension: NATURAL_32)
		do
			c_set_max_dimension (c_pointer, a_max_dimension)
		end

	set_state_size (a_state_size: CE_ROUTINE)
		do
			c_set_state_size (c_pointer, a_state_size.c_pointer)
		end

	set_init_state (a_init_state: CE_ROUTINE)
		do
			c_set_init_state (c_pointer, a_init_state.c_pointer)
		end

	set_get (a_get: CE_ROUTINE)
		do
			c_set_get (c_pointer, a_get.c_pointer)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_gsl_qrng_type_24 *)$tmp)->name;"
		end

	c_max_dimension (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_qrng_type_24 *)$tmp)->max_dimension;"
		end

	c_state_size (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned int( *)(unsigned int dimension))((struct __anonstruct_gsl_qrng_type_24 *)$tmp)->state_size;"
		end

	c_init_state (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void * state, unsigned int dimension))((struct __anonstruct_gsl_qrng_type_24 *)$tmp)->init_state;"
		end

	c_get (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (int( *)(void * state, unsigned int dimension, double * x))((struct __anonstruct_gsl_qrng_type_24 *)$tmp)->get;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_qrng_type_24 *)$tmp)->name = (char const *)$a_name;"
		end

	c_set_max_dimension (tmp: POINTER; a_max_dimension: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_qrng_type_24 *)$tmp)->max_dimension = $a_max_dimension;"
		end

	c_set_state_size (tmp: POINTER; a_state_size: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_qrng_type_24 *)$tmp)->state_size = (unsigned int( *)(unsigned int dimension))$a_state_size;"
		end

	c_set_init_state (tmp: POINTER; a_init_state: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_qrng_type_24 *)$tmp)->init_state = (int( *)(void * state, unsigned int dimension))$a_init_state;"
		end

	c_set_get (tmp: POINTER; a_get: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_qrng_type_24 *)$tmp)->get = (int( *)(void * state, unsigned int dimension, double * x))$a_get;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_qrng_type_24);"
		end

end
