class
	PD_GSL_RAN_DISCRETE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	K: NATURAL_32 assign set_K
		do
			Result := c_K (c_pointer)
		end

	A: CE_POINTER [NATURAL_32] assign set_A
		do
			create Result.make_shared (c_A (c_pointer))
		end

	F: CE_POINTER [REAL_64] assign set_F
		do
			create Result.make_shared (c_F (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_K (a_K: NATURAL_32)
		do
			c_set_K (c_pointer, a_K)
		end

	set_A (a_A: CE_POINTER [NATURAL_32])
		do
			c_set_A (c_pointer, a_A.c_pointer)
		end

	set_F (a_F: CE_POINTER [REAL_64])
		do
			c_set_F (c_pointer, a_F.c_pointer)
		end

feature {NONE} -- C getters

	c_K (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_ran_discrete_t_28 *)$tmp)->K;"
		end

	c_A (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned int *)((struct __anonstruct_gsl_ran_discrete_t_28 *)$tmp)->A;"
		end

	c_F (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_ran_discrete_t_28 *)$tmp)->F;"
		end

feature {NONE} -- C setters

	c_set_K (tmp: POINTER; a_K: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_ran_discrete_t_28 *)$tmp)->K = $a_k;"
		end

	c_set_A (tmp: POINTER; a_A: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_ran_discrete_t_28 *)$tmp)->A = (unsigned int *)$a_a;"
		end

	c_set_F (tmp: POINTER; a_F: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_ran_discrete_t_28 *)$tmp)->F = (double *)$a_f;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_ran_discrete_t_28);"
		end

end
