class
	PD_GSL_RNG_TYPE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	name: CE_POINTER [INTEGER_8] assign set_name
		do
			create Result.make_shared (c_name (c_pointer))
		end

	max: NATURAL_32 assign set_max
		do
			Result := c_max (c_pointer)
		end

	min: NATURAL_32 assign set_min
		do
			Result := c_min (c_pointer)
		end

	size: NATURAL_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	set: CE_ROUTINE assign set_set
		do
			create Result.make_shared (c_set (c_pointer))
		end

	get: CE_ROUTINE assign set_get
		do
			create Result.make_shared (c_get (c_pointer))
		end

	get_double: CE_ROUTINE assign set_get_double
		do
			create Result.make_shared (c_get_double (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			c_set_name (c_pointer, a_name.c_pointer)
		end

	set_max (a_max: NATURAL_32)
		do
			c_set_max (c_pointer, a_max)
		end

	set_min (a_min: NATURAL_32)
		do
			c_set_min (c_pointer, a_min)
		end

	set_size (a_size: NATURAL_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_set (a_set: CE_ROUTINE)
		do
			c_set_set (c_pointer, a_set.c_pointer)
		end

	set_get (a_get: CE_ROUTINE)
		do
			c_set_get (c_pointer, a_get.c_pointer)
		end

	set_get_double (a_get_double: CE_ROUTINE)
		do
			c_set_get_double (c_pointer, a_get_double.c_pointer)
		end

feature {NONE} -- C getters

	c_name (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (char *)((struct __anonstruct_gsl_rng_type_26 *)$tmp)->name;"
		end

	c_max (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_gsl_rng_type_26 *)$tmp)->max;"
		end

	c_min (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_gsl_rng_type_26 *)$tmp)->min;"
		end

	c_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_rng_type_26 *)$tmp)->size;"
		end

	c_set (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void( *)(void * state, unsigned long seed))((struct __anonstruct_gsl_rng_type_26 *)$tmp)->set;"
		end

	c_get (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (unsigned long( *)(void * state))((struct __anonstruct_gsl_rng_type_26 *)$tmp)->get;"
		end

	c_get_double (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double( *)(void * state))((struct __anonstruct_gsl_rng_type_26 *)$tmp)->get_double;"
		end

feature {NONE} -- C setters

	c_set_name (tmp: POINTER; a_name: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_rng_type_26 *)$tmp)->name = (char const *)$a_name;"
		end

	c_set_max (tmp: POINTER; a_max: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_rng_type_26 *)$tmp)->max = $a_max;"
		end

	c_set_min (tmp: POINTER; a_min: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_rng_type_26 *)$tmp)->min = $a_min;"
		end

	c_set_size (tmp: POINTER; a_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_rng_type_26 *)$tmp)->size = $a_size;"
		end

	c_set_set (tmp: POINTER; a_set: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_rng_type_26 *)$tmp)->set = (void( *)(void * state, unsigned long seed))$a_set;"
		end

	c_set_get (tmp: POINTER; a_get: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_rng_type_26 *)$tmp)->get = (unsigned long( *)(void * state))$a_get;"
		end

	c_set_get_double (tmp: POINTER; a_get_double: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_rng_type_26 *)$tmp)->get_double = (double( *)(void * state))$a_get_double;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_rng_type_26);"
		end

end
