class
	PD_GSL_ROOT_FDFSOLVER

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	type: CE_POINTER [PD_GSL_ROOT_FDFSOLVER_TYPE] assign set_type
		do
			create Result.make_shared (c_type (c_pointer))
		end

	fdf: CE_POINTER [PD_GSL_FUNCTION_FDF_STRUCT] assign set_fdf
		do
			create Result.make_shared (c_fdf (c_pointer))
		end

	root: REAL_64 assign set_root
		do
			Result := c_root (c_pointer)
		end

	root_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(struct __anonstruct_gsl_root_fdfsolver_29, root);"
		end

	state: CE_POINTER [ANY] assign set_state
		do
			create Result.make_shared (c_state (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_type (a_type: CE_POINTER [PD_GSL_ROOT_FDFSOLVER_TYPE])
		do
			c_set_type (c_pointer, a_type.c_pointer)
		end

	set_fdf (a_fdf: CE_POINTER [PD_GSL_FUNCTION_FDF_STRUCT])
		do
			c_set_fdf (c_pointer, a_fdf.c_pointer)
		end

	set_root (a_root: REAL_64)
		do
			c_set_root (c_pointer, a_root)
		end

	set_state (a_state: CE_POINTER [ANY])
		do
			c_set_state (c_pointer, a_state.c_pointer)
		end

feature {NONE} -- C getters

	c_type (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_root_fdfsolver_type *)((struct __anonstruct_gsl_root_fdfsolver_29 *)$tmp)->type;"
		end

	c_fdf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct gsl_function_fdf_struct *)((struct __anonstruct_gsl_root_fdfsolver_29 *)$tmp)->fdf;"
		end

	c_root (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_root_fdfsolver_29 *)$tmp)->root;"
		end

	c_state (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (void *)((struct __anonstruct_gsl_root_fdfsolver_29 *)$tmp)->state;"
		end

feature {NONE} -- C setters

	c_set_type (tmp: POINTER; a_type: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_root_fdfsolver_29 *)$tmp)->type = (gsl_root_fdfsolver_type *)$a_type;"
		end

	c_set_fdf (tmp: POINTER; a_fdf: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_root_fdfsolver_29 *)$tmp)->fdf = (struct gsl_function_fdf_struct *)$a_fdf;"
		end

	c_set_root (tmp: POINTER; a_root: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_root_fdfsolver_29 *)$tmp)->root = $a_root;"
		end

	c_set_state (tmp: POINTER; a_state: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_root_fdfsolver_29 *)$tmp)->state = (void *)$a_state;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_root_fdfsolver_29);"
		end

end
