class
	PD_GSL_SUM_LEVIN_U_WORKSPACE

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	size: NATURAL_32 assign set_size
		do
			Result := c_size (c_pointer)
		end

	i: NATURAL_32 assign set_i
		do
			Result := c_i (c_pointer)
		end

	terms_used: NATURAL_32 assign set_terms_used
		do
			Result := c_terms_used (c_pointer)
		end

	sum_plain: REAL_64 assign set_sum_plain
		do
			Result := c_sum_plain (c_pointer)
		end

	q_num: CE_POINTER [REAL_64] assign set_q_num
		do
			create Result.make_shared (c_q_num (c_pointer))
		end

	q_den: CE_POINTER [REAL_64] assign set_q_den
		do
			create Result.make_shared (c_q_den (c_pointer))
		end

	dq_num: CE_POINTER [REAL_64] assign set_dq_num
		do
			create Result.make_shared (c_dq_num (c_pointer))
		end

	dq_den: CE_POINTER [REAL_64] assign set_dq_den
		do
			create Result.make_shared (c_dq_den (c_pointer))
		end

	dsum: CE_POINTER [REAL_64] assign set_dsum
		do
			create Result.make_shared (c_dsum (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_size (a_size: NATURAL_32)
		do
			c_set_size (c_pointer, a_size)
		end

	set_i (a_i: NATURAL_32)
		do
			c_set_i (c_pointer, a_i)
		end

	set_terms_used (a_terms_used: NATURAL_32)
		do
			c_set_terms_used (c_pointer, a_terms_used)
		end

	set_sum_plain (a_sum_plain: REAL_64)
		do
			c_set_sum_plain (c_pointer, a_sum_plain)
		end

	set_q_num (a_q_num: CE_POINTER [REAL_64])
		do
			c_set_q_num (c_pointer, a_q_num.c_pointer)
		end

	set_q_den (a_q_den: CE_POINTER [REAL_64])
		do
			c_set_q_den (c_pointer, a_q_den.c_pointer)
		end

	set_dq_num (a_dq_num: CE_POINTER [REAL_64])
		do
			c_set_dq_num (c_pointer, a_dq_num.c_pointer)
		end

	set_dq_den (a_dq_den: CE_POINTER [REAL_64])
		do
			c_set_dq_den (c_pointer, a_dq_den.c_pointer)
		end

	set_dsum (a_dsum: CE_POINTER [REAL_64])
		do
			c_set_dsum (c_pointer, a_dsum.c_pointer)
		end

feature {NONE} -- C getters

	c_size (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_sum_levin_u_workspace_26 *)$tmp)->size;"
		end

	c_i (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_sum_levin_u_workspace_26 *)$tmp)->i;"
		end

	c_terms_used (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned int)((struct __anonstruct_gsl_sum_levin_u_workspace_26 *)$tmp)->terms_used;"
		end

	c_sum_plain (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_gsl_sum_levin_u_workspace_26 *)$tmp)->sum_plain;"
		end

	c_q_num (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_sum_levin_u_workspace_26 *)$tmp)->q_num;"
		end

	c_q_den (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_sum_levin_u_workspace_26 *)$tmp)->q_den;"
		end

	c_dq_num (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_sum_levin_u_workspace_26 *)$tmp)->dq_num;"
		end

	c_dq_den (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_sum_levin_u_workspace_26 *)$tmp)->dq_den;"
		end

	c_dsum (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_gsl_sum_levin_u_workspace_26 *)$tmp)->dsum;"
		end

feature {NONE} -- C setters

	c_set_size (tmp: POINTER; a_size: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_sum_levin_u_workspace_26 *)$tmp)->size = $a_size;"
		end

	c_set_i (tmp: POINTER; a_i: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_sum_levin_u_workspace_26 *)$tmp)->i = $a_i;"
		end

	c_set_terms_used (tmp: POINTER; a_terms_used: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_sum_levin_u_workspace_26 *)$tmp)->terms_used = $a_terms_used;"
		end

	c_set_sum_plain (tmp: POINTER; a_sum_plain: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_sum_levin_u_workspace_26 *)$tmp)->sum_plain = $a_sum_plain;"
		end

	c_set_q_num (tmp: POINTER; a_q_num: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_sum_levin_u_workspace_26 *)$tmp)->q_num = (double *)$a_q_num;"
		end

	c_set_q_den (tmp: POINTER; a_q_den: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_sum_levin_u_workspace_26 *)$tmp)->q_den = (double *)$a_q_den;"
		end

	c_set_dq_num (tmp: POINTER; a_dq_num: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_sum_levin_u_workspace_26 *)$tmp)->dq_num = (double *)$a_dq_num;"
		end

	c_set_dq_den (tmp: POINTER; a_dq_den: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_sum_levin_u_workspace_26 *)$tmp)->dq_den = (double *)$a_dq_den;"
		end

	c_set_dsum (tmp: POINTER; a_dsum: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_gsl_sum_levin_u_workspace_26 *)$tmp)->dsum = (double *)$a_dsum;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_gsl_sum_levin_u_workspace_26);"
		end

end
