class
	PD_GSL_VECTOR_VIEW

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	vector: PD_GSL_VECTOR assign set_vector
		do
			create Result.make_shared (c_vector (c_pointer))
		end

	vector_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(struct __anonstruct__gsl_vector_view_36, vector);"
		end

feature {ANY} -- Eiffel setters

	set_vector (a_vector: PD_GSL_VECTOR)
		do
			vector.ce_gets (a_vector)
		end

feature {NONE} -- C getters

	c_vector (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)&((struct __anonstruct__gsl_vector_view_36 *)$tmp)->vector;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct__gsl_vector_view_36);"
		end

end
