class
	PD_IL_PARAMS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	b: REAL_64 assign set_b
		do
			Result := c_b (c_pointer)
		end

	f: CE_POINTER [PD_GSL_FUNCTION_STRUCT] assign set_f
		do
			create Result.make_shared (c_f (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_b (a_b: REAL_64)
		do
			c_set_b (c_pointer, a_b)
		end

	set_f (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT])
		do
			c_set_f (c_pointer, a_f.c_pointer)
		end

feature {NONE} -- C getters

	c_b (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct il_params *)$tmp)->b;"
		end

	c_f (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct gsl_function_struct *)((struct il_params *)$tmp)->f;"
		end

feature {NONE} -- C setters

	c_set_b (tmp: POINTER; a_b: REAL_64)
		external
			"C inline"
		alias
			"((struct il_params *)$tmp)->b = $a_b;"
		end

	c_set_f (tmp: POINTER; a_f: POINTER)
		external
			"C inline"
		alias
			"((struct il_params *)$tmp)->f = (struct gsl_function_struct *)$a_f;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct il_params);"
		end

end
