class
	PD_IU_PARAMS

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	a: REAL_64 assign set_a
		do
			Result := c_a (c_pointer)
		end

	f: CE_POINTER [PD_GSL_FUNCTION_STRUCT] assign set_f
		do
			create Result.make_shared (c_f (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_a (a_a: REAL_64)
		do
			c_set_a (c_pointer, a_a)
		end

	set_f (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT])
		do
			c_set_f (c_pointer, a_f.c_pointer)
		end

feature {NONE} -- C getters

	c_a (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct iu_params *)$tmp)->a;"
		end

	c_f (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct gsl_function_struct *)((struct iu_params *)$tmp)->f;"
		end

feature {NONE} -- C setters

	c_set_a (tmp: POINTER; a_a: REAL_64)
		external
			"C inline"
		alias
			"((struct iu_params *)$tmp)->a = $a_a;"
		end

	c_set_f (tmp: POINTER; a_f: POINTER)
		external
			"C inline"
		alias
			"((struct iu_params *)$tmp)->f = (struct gsl_function_struct *)$a_f;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct iu_params);"
		end

end
