class
	PD_MT_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	mt: CE_ARRAY [NATURAL_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_mt (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	mti: INTEGER_32 assign set_mti
		do
			Result := c_mti (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_mti (a_mti: INTEGER_32)
		do
			c_set_mti (c_pointer, a_mti)
		end

feature {NONE} -- C getters

	c_mt (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_mt_state_t_26 *tmp = (struct __anonstruct_mt_state_t_26 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->mt) / sizeof(tmp->mt[0]);
				return tmp->mt;
			]"
		end

	c_mti (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_mt_state_t_26 *)$tmp)->mti;"
		end

feature {NONE} -- C setters

	c_set_mti (tmp: POINTER; a_mti: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_mt_state_t_26 *)$tmp)->mti = $a_mti;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_mt_state_t_26);"
		end

end
