class
	PD_NEWTON_STATE_T2

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	f: REAL_64 assign set_f
		do
			Result := c_f (c_pointer)
		end

	df: REAL_64 assign set_df
		do
			Result := c_df (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_f (a_f: REAL_64)
		do
			c_set_f (c_pointer, a_f)
		end

	set_df (a_df: REAL_64)
		do
			c_set_df (c_pointer, a_df)
		end

feature {NONE} -- C getters

	c_f (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_newton_state_t_30 *)$tmp)->f;"
		end

	c_df (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_newton_state_t_30 *)$tmp)->df;"
		end

feature {NONE} -- C setters

	c_set_f (tmp: POINTER; a_f: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_newton_state_t_30 *)$tmp)->f = $a_f;"
		end

	c_set_df (tmp: POINTER; a_df: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_newton_state_t_30 *)$tmp)->df = $a_df;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_newton_state_t_30);"
		end

end
