class
	PD_NMSIMPLEX_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	x1: CE_POINTER [PD_GSL_MATRIX] assign set_x1
		do
			create Result.make_shared (c_x1 (c_pointer))
		end

	y1: CE_POINTER [PD_GSL_VECTOR] assign set_y1
		do
			create Result.make_shared (c_y1 (c_pointer))
		end

	ws1: CE_POINTER [PD_GSL_VECTOR] assign set_ws1
		do
			create Result.make_shared (c_ws1 (c_pointer))
		end

	ws2: CE_POINTER [PD_GSL_VECTOR] assign set_ws2
		do
			create Result.make_shared (c_ws2 (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_x1 (a_x1: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_x1 (c_pointer, a_x1.c_pointer)
		end

	set_y1 (a_y1: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_y1 (c_pointer, a_y1.c_pointer)
		end

	set_ws1 (a_ws1: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_ws1 (c_pointer, a_ws1.c_pointer)
		end

	set_ws2 (a_ws2: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_ws2 (c_pointer, a_ws2.c_pointer)
		end

feature {NONE} -- C getters

	c_x1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_nmsimplex_state_t_119 *)$tmp)->x1;"
		end

	c_y1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_nmsimplex_state_t_119 *)$tmp)->y1;"
		end

	c_ws1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_nmsimplex_state_t_119 *)$tmp)->ws1;"
		end

	c_ws2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_nmsimplex_state_t_119 *)$tmp)->ws2;"
		end

feature {NONE} -- C setters

	c_set_x1 (tmp: POINTER; a_x1: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_nmsimplex_state_t_119 *)$tmp)->x1 = (gsl_matrix *)$a_x1;"
		end

	c_set_y1 (tmp: POINTER; a_y1: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_nmsimplex_state_t_119 *)$tmp)->y1 = (gsl_vector *)$a_y1;"
		end

	c_set_ws1 (tmp: POINTER; a_ws1: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_nmsimplex_state_t_119 *)$tmp)->ws1 = (gsl_vector *)$a_ws1;"
		end

	c_set_ws2 (tmp: POINTER; a_ws2: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_nmsimplex_state_t_119 *)$tmp)->ws2 = (gsl_vector *)$a_ws2;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_nmsimplex_state_t_119);"
		end

end
