class
	PD_NMSIMPLEX_STATE_T_119__

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	x1: CE_POINTER [PD_GSL_MATRIX] assign set_x1
		do
			create Result.make_shared (c_x1 (c_pointer))
		end

	y1: CE_POINTER [PD_GSL_VECTOR] assign set_y1
		do
			create Result.make_shared (c_y1 (c_pointer))
		end

	ws1: CE_POINTER [PD_GSL_VECTOR] assign set_ws1
		do
			create Result.make_shared (c_ws1 (c_pointer))
		end

	ws2: CE_POINTER [PD_GSL_VECTOR] assign set_ws2
		do
			create Result.make_shared (c_ws2 (c_pointer))
		end

	center: CE_POINTER [PD_GSL_VECTOR] assign set_center
		do
			create Result.make_shared (c_center (c_pointer))
		end

	delta: CE_POINTER [PD_GSL_VECTOR] assign set_delta
		do
			create Result.make_shared (c_delta (c_pointer))
		end

	xmc: CE_POINTER [PD_GSL_VECTOR] assign set_xmc
		do
			create Result.make_shared (c_xmc (c_pointer))
		end

	S2: REAL_64 assign set_S2
		do
			Result := c_S2 (c_pointer)
		end

	count: NATURAL_32 assign set_count
		do
			Result := c_count (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_x1 (a_x1: CE_POINTER [PD_GSL_MATRIX])
		do
			c_set_x1 (c_pointer, a_x1.c_pointer)
		end

	set_y1 (a_y1: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_y1 (c_pointer, a_y1.c_pointer)
		end

	set_ws1 (a_ws1: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_ws1 (c_pointer, a_ws1.c_pointer)
		end

	set_ws2 (a_ws2: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_ws2 (c_pointer, a_ws2.c_pointer)
		end

	set_center (a_center: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_center (c_pointer, a_center.c_pointer)
		end

	set_delta (a_delta: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_delta (c_pointer, a_delta.c_pointer)
		end

	set_xmc (a_xmc: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_xmc (c_pointer, a_xmc.c_pointer)
		end

	set_S2 (a_S2: REAL_64)
		do
			c_set_S2 (c_pointer, a_S2)
		end

	set_count (a_count: NATURAL_32)
		do
			c_set_count (c_pointer, a_count)
		end

feature {NONE} -- C getters

	c_x1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_matrix *)((struct __anonstruct_nmsimplex_state_t_119___0 *)$tmp)->x1;"
		end

	c_y1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_nmsimplex_state_t_119___0 *)$tmp)->y1;"
		end

	c_ws1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_nmsimplex_state_t_119___0 *)$tmp)->ws1;"
		end

	c_ws2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_nmsimplex_state_t_119___0 *)$tmp)->ws2;"
		end

	c_center (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_nmsimplex_state_t_119___0 *)$tmp)->center;"
		end

	c_delta (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_nmsimplex_state_t_119___0 *)$tmp)->delta;"
		end

	c_xmc (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_nmsimplex_state_t_119___0 *)$tmp)->xmc;"
		end

	c_S2 (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_nmsimplex_state_t_119___0 *)$tmp)->S2;"
		end

	c_count (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_nmsimplex_state_t_119___0 *)$tmp)->count;"
		end

feature {NONE} -- C setters

	c_set_x1 (tmp: POINTER; a_x1: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_nmsimplex_state_t_119___0 *)$tmp)->x1 = (gsl_matrix *)$a_x1;"
		end

	c_set_y1 (tmp: POINTER; a_y1: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_nmsimplex_state_t_119___0 *)$tmp)->y1 = (gsl_vector *)$a_y1;"
		end

	c_set_ws1 (tmp: POINTER; a_ws1: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_nmsimplex_state_t_119___0 *)$tmp)->ws1 = (gsl_vector *)$a_ws1;"
		end

	c_set_ws2 (tmp: POINTER; a_ws2: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_nmsimplex_state_t_119___0 *)$tmp)->ws2 = (gsl_vector *)$a_ws2;"
		end

	c_set_center (tmp: POINTER; a_center: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_nmsimplex_state_t_119___0 *)$tmp)->center = (gsl_vector *)$a_center;"
		end

	c_set_delta (tmp: POINTER; a_delta: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_nmsimplex_state_t_119___0 *)$tmp)->delta = (gsl_vector *)$a_delta;"
		end

	c_set_xmc (tmp: POINTER; a_xmc: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_nmsimplex_state_t_119___0 *)$tmp)->xmc = (gsl_vector *)$a_xmc;"
		end

	c_set_S2 (tmp: POINTER; a_S2: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_nmsimplex_state_t_119___0 *)$tmp)->S2 = $a_s2;"
		end

	c_set_count (tmp: POINTER; a_count: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_nmsimplex_state_t_119___0 *)$tmp)->count = $a_count;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_nmsimplex_state_t_119___0);"
		end

end
