class
	PD_RAND48_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	x0: NATURAL_16 assign set_x0
		do
			Result := c_x0 (c_pointer)
		end

	x1: NATURAL_16 assign set_x1
		do
			Result := c_x1 (c_pointer)
		end

	x2: NATURAL_16 assign set_x2
		do
			Result := c_x2 (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_x0 (a_x0: NATURAL_16)
		do
			c_set_x0 (c_pointer, a_x0)
		end

	set_x1 (a_x1: NATURAL_16)
		do
			c_set_x1 (c_pointer, a_x1)
		end

	set_x2 (a_x2: NATURAL_16)
		do
			c_set_x2 (c_pointer, a_x2)
		end

feature {NONE} -- C getters

	c_x0 (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct __anonstruct_rand48_state_t_28 *)$tmp)->x0;"
		end

	c_x1 (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct __anonstruct_rand48_state_t_28 *)$tmp)->x1;"
		end

	c_x2 (tmp: POINTER): NATURAL_16
		external
			"C inline"
		alias
			"return (unsigned short)((struct __anonstruct_rand48_state_t_28 *)$tmp)->x2;"
		end

feature {NONE} -- C setters

	c_set_x0 (tmp: POINTER; a_x0: NATURAL_16)
		external
			"C inline"
		alias
			"((struct __anonstruct_rand48_state_t_28 *)$tmp)->x0 = $a_x0;"
		end

	c_set_x1 (tmp: POINTER; a_x1: NATURAL_16)
		external
			"C inline"
		alias
			"((struct __anonstruct_rand48_state_t_28 *)$tmp)->x1 = $a_x1;"
		end

	c_set_x2 (tmp: POINTER; a_x2: NATURAL_16)
		external
			"C inline"
		alias
			"((struct __anonstruct_rand48_state_t_28 *)$tmp)->x2 = $a_x2;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_rand48_state_t_28);"
		end

end
