class
	PD_RAND_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	x: NATURAL_32 assign set_x
		do
			Result := c_x (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_x (a_x: NATURAL_32)
		do
			c_set_x (c_pointer, a_x)
		end

feature {NONE} -- C getters

	c_x (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_rand_state_t_26 *)$tmp)->x;"
		end

feature {NONE} -- C setters

	c_set_x (tmp: POINTER; a_x: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_rand_state_t_26 *)$tmp)->x = $a_x;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_rand_state_t_26);"
		end

end
