class
	PD_RK2_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	k1: CE_POINTER [REAL_64] assign set_k1
		do
			create Result.make_shared (c_k1 (c_pointer))
		end

	k2: CE_POINTER [REAL_64] assign set_k2
		do
			create Result.make_shared (c_k2 (c_pointer))
		end

	k3: CE_POINTER [REAL_64] assign set_k3
		do
			create Result.make_shared (c_k3 (c_pointer))
		end

	ytmp: CE_POINTER [REAL_64] assign set_ytmp
		do
			create Result.make_shared (c_ytmp (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_k1 (a_k1: CE_POINTER [REAL_64])
		do
			c_set_k1 (c_pointer, a_k1.c_pointer)
		end

	set_k2 (a_k2: CE_POINTER [REAL_64])
		do
			c_set_k2 (c_pointer, a_k2.c_pointer)
		end

	set_k3 (a_k3: CE_POINTER [REAL_64])
		do
			c_set_k3 (c_pointer, a_k3.c_pointer)
		end

	set_ytmp (a_ytmp: CE_POINTER [REAL_64])
		do
			c_set_ytmp (c_pointer, a_ytmp.c_pointer)
		end

feature {NONE} -- C getters

	c_k1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rk2_state_t_30 *)$tmp)->k1;"
		end

	c_k2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rk2_state_t_30 *)$tmp)->k2;"
		end

	c_k3 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rk2_state_t_30 *)$tmp)->k3;"
		end

	c_ytmp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rk2_state_t_30 *)$tmp)->ytmp;"
		end

feature {NONE} -- C setters

	c_set_k1 (tmp: POINTER; a_k1: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rk2_state_t_30 *)$tmp)->k1 = (double *)$a_k1;"
		end

	c_set_k2 (tmp: POINTER; a_k2: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rk2_state_t_30 *)$tmp)->k2 = (double *)$a_k2;"
		end

	c_set_k3 (tmp: POINTER; a_k3: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rk2_state_t_30 *)$tmp)->k3 = (double *)$a_k3;"
		end

	c_set_ytmp (tmp: POINTER; a_ytmp: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rk2_state_t_30 *)$tmp)->ytmp = (double *)$a_ytmp;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_rk2_state_t_30);"
		end

end
