class
	PD_RK4IMP_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	k1nu: CE_POINTER [REAL_64] assign set_k1nu
		do
			create Result.make_shared (c_k1nu (c_pointer))
		end

	k2nu: CE_POINTER [REAL_64] assign set_k2nu
		do
			create Result.make_shared (c_k2nu (c_pointer))
		end

	ytmp1: CE_POINTER [REAL_64] assign set_ytmp1
		do
			create Result.make_shared (c_ytmp1 (c_pointer))
		end

	ytmp2: CE_POINTER [REAL_64] assign set_ytmp2
		do
			create Result.make_shared (c_ytmp2 (c_pointer))
		end

	y0: CE_POINTER [REAL_64] assign set_y0
		do
			create Result.make_shared (c_y0 (c_pointer))
		end

	y0_orig: CE_POINTER [REAL_64] assign set_y0_orig
		do
			create Result.make_shared (c_y0_orig (c_pointer))
		end

	y_onestep: CE_POINTER [REAL_64] assign set_y_onestep
		do
			create Result.make_shared (c_y_onestep (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_k1nu (a_k1nu: CE_POINTER [REAL_64])
		do
			c_set_k1nu (c_pointer, a_k1nu.c_pointer)
		end

	set_k2nu (a_k2nu: CE_POINTER [REAL_64])
		do
			c_set_k2nu (c_pointer, a_k2nu.c_pointer)
		end

	set_ytmp1 (a_ytmp1: CE_POINTER [REAL_64])
		do
			c_set_ytmp1 (c_pointer, a_ytmp1.c_pointer)
		end

	set_ytmp2 (a_ytmp2: CE_POINTER [REAL_64])
		do
			c_set_ytmp2 (c_pointer, a_ytmp2.c_pointer)
		end

	set_y0 (a_y0: CE_POINTER [REAL_64])
		do
			c_set_y0 (c_pointer, a_y0.c_pointer)
		end

	set_y0_orig (a_y0_orig: CE_POINTER [REAL_64])
		do
			c_set_y0_orig (c_pointer, a_y0_orig.c_pointer)
		end

	set_y_onestep (a_y_onestep: CE_POINTER [REAL_64])
		do
			c_set_y_onestep (c_pointer, a_y_onestep.c_pointer)
		end

feature {NONE} -- C getters

	c_k1nu (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rk4imp_state_t_32 *)$tmp)->k1nu;"
		end

	c_k2nu (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rk4imp_state_t_32 *)$tmp)->k2nu;"
		end

	c_ytmp1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rk4imp_state_t_32 *)$tmp)->ytmp1;"
		end

	c_ytmp2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rk4imp_state_t_32 *)$tmp)->ytmp2;"
		end

	c_y0 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rk4imp_state_t_32 *)$tmp)->y0;"
		end

	c_y0_orig (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rk4imp_state_t_32 *)$tmp)->y0_orig;"
		end

	c_y_onestep (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rk4imp_state_t_32 *)$tmp)->y_onestep;"
		end

feature {NONE} -- C setters

	c_set_k1nu (tmp: POINTER; a_k1nu: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rk4imp_state_t_32 *)$tmp)->k1nu = (double *)$a_k1nu;"
		end

	c_set_k2nu (tmp: POINTER; a_k2nu: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rk4imp_state_t_32 *)$tmp)->k2nu = (double *)$a_k2nu;"
		end

	c_set_ytmp1 (tmp: POINTER; a_ytmp1: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rk4imp_state_t_32 *)$tmp)->ytmp1 = (double *)$a_ytmp1;"
		end

	c_set_ytmp2 (tmp: POINTER; a_ytmp2: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rk4imp_state_t_32 *)$tmp)->ytmp2 = (double *)$a_ytmp2;"
		end

	c_set_y0 (tmp: POINTER; a_y0: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rk4imp_state_t_32 *)$tmp)->y0 = (double *)$a_y0;"
		end

	c_set_y0_orig (tmp: POINTER; a_y0_orig: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rk4imp_state_t_32 *)$tmp)->y0_orig = (double *)$a_y0_orig;"
		end

	c_set_y_onestep (tmp: POINTER; a_y_onestep: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rk4imp_state_t_32 *)$tmp)->y_onestep = (double *)$a_y_onestep;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_rk4imp_state_t_32);"
		end

end
