class
	PD_RK8PD_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	k: CE_ARRAY [CE_POINTER [REAL_64]]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_k (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

	ytmp: CE_POINTER [REAL_64] assign set_ytmp
		do
			create Result.make_shared (c_ytmp (c_pointer))
		end

	y0: CE_POINTER [REAL_64] assign set_y0
		do
			create Result.make_shared (c_y0 (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_ytmp (a_ytmp: CE_POINTER [REAL_64])
		do
			c_set_ytmp (c_pointer, a_ytmp.c_pointer)
		end

	set_y0 (a_y0: CE_POINTER [REAL_64])
		do
			c_set_y0 (c_pointer, a_y0.c_pointer)
		end

feature {NONE} -- C getters

	c_k (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_rk8pd_state_t_30 *tmp = (struct __anonstruct_rk8pd_state_t_30 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->k) / sizeof(tmp->k[0]);
				return tmp->k;
			]"
		end

	c_ytmp (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rk8pd_state_t_30 *)$tmp)->ytmp;"
		end

	c_y0 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (double *)((struct __anonstruct_rk8pd_state_t_30 *)$tmp)->y0;"
		end

feature {NONE} -- C setters

	c_set_ytmp (tmp: POINTER; a_ytmp: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rk8pd_state_t_30 *)$tmp)->ytmp = (double *)$a_ytmp;"
		end

	c_set_y0 (tmp: POINTER; a_y0: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_rk8pd_state_t_30 *)$tmp)->y0 = (double *)$a_y0;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_rk8pd_state_t_30);"
		end

end
