class
	PD_SLATEC_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	x0: INTEGER_32 assign set_x0
		do
			Result := c_x0 (c_pointer)
		end

	x1: INTEGER_32 assign set_x1
		do
			Result := c_x1 (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_x0 (a_x0: INTEGER_32)
		do
			c_set_x0 (c_pointer, a_x0)
		end

	set_x1 (a_x1: INTEGER_32)
		do
			c_set_x1 (c_pointer, a_x1)
		end

feature {NONE} -- C getters

	c_x0 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_slatec_state_t_26 *)$tmp)->x0;"
		end

	c_x1 (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (long)((struct __anonstruct_slatec_state_t_26 *)$tmp)->x1;"
		end

feature {NONE} -- C setters

	c_set_x0 (tmp: POINTER; a_x0: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_slatec_state_t_26 *)$tmp)->x0 = $a_x0;"
		end

	c_set_x1 (tmp: POINTER; a_x1: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_slatec_state_t_26 *)$tmp)->x1 = $a_x1;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_slatec_state_t_26);"
		end

end
