class
	PD_STEFFENSON_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	f: REAL_64 assign set_f
		do
			Result := c_f (c_pointer)
		end

	df: REAL_64 assign set_df
		do
			Result := c_df (c_pointer)
		end

	x: REAL_64 assign set_x
		do
			Result := c_x (c_pointer)
		end

	x_1: REAL_64 assign set_x_1
		do
			Result := c_x_1 (c_pointer)
		end

	x_2: REAL_64 assign set_x_2
		do
			Result := c_x_2 (c_pointer)
		end

	count: INTEGER_32 assign set_count
		do
			Result := c_count (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_f (a_f: REAL_64)
		do
			c_set_f (c_pointer, a_f)
		end

	set_df (a_df: REAL_64)
		do
			c_set_df (c_pointer, a_df)
		end

	set_x (a_x: REAL_64)
		do
			c_set_x (c_pointer, a_x)
		end

	set_x_1 (a_x_1: REAL_64)
		do
			c_set_x_1 (c_pointer, a_x_1)
		end

	set_x_2 (a_x_2: REAL_64)
		do
			c_set_x_2 (c_pointer, a_x_2)
		end

	set_count (a_count: INTEGER_32)
		do
			c_set_count (c_pointer, a_count)
		end

feature {NONE} -- C getters

	c_f (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_steffenson_state_t_30 *)$tmp)->f;"
		end

	c_df (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_steffenson_state_t_30 *)$tmp)->df;"
		end

	c_x (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_steffenson_state_t_30 *)$tmp)->x;"
		end

	c_x_1 (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_steffenson_state_t_30 *)$tmp)->x_1;"
		end

	c_x_2 (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_steffenson_state_t_30 *)$tmp)->x_2;"
		end

	c_count (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_steffenson_state_t_30 *)$tmp)->count;"
		end

feature {NONE} -- C setters

	c_set_f (tmp: POINTER; a_f: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_steffenson_state_t_30 *)$tmp)->f = $a_f;"
		end

	c_set_df (tmp: POINTER; a_df: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_steffenson_state_t_30 *)$tmp)->df = $a_df;"
		end

	c_set_x (tmp: POINTER; a_x: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_steffenson_state_t_30 *)$tmp)->x = $a_x;"
		end

	c_set_x_1 (tmp: POINTER; a_x_1: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_steffenson_state_t_30 *)$tmp)->x_1 = $a_x_1;"
		end

	c_set_x_2 (tmp: POINTER; a_x_2: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_steffenson_state_t_30 *)$tmp)->x_2 = $a_x_2;"
		end

	c_set_count (tmp: POINTER; a_count: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_steffenson_state_t_30 *)$tmp)->count = $a_count;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_steffenson_state_t_30);"
		end

end
