class
	PD_TAUS_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	s1: NATURAL_32 assign set_s1
		do
			Result := c_s1 (c_pointer)
		end

	s2: NATURAL_32 assign set_s2
		do
			Result := c_s2 (c_pointer)
		end

	s3: NATURAL_32 assign set_s3
		do
			Result := c_s3 (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_s1 (a_s1: NATURAL_32)
		do
			c_set_s1 (c_pointer, a_s1)
		end

	set_s2 (a_s2: NATURAL_32)
		do
			c_set_s2 (c_pointer, a_s2)
		end

	set_s3 (a_s3: NATURAL_32)
		do
			c_set_s3 (c_pointer, a_s3)
		end

feature {NONE} -- C getters

	c_s1 (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_taus_state_t_26 *)$tmp)->s1;"
		end

	c_s2 (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_taus_state_t_26 *)$tmp)->s2;"
		end

	c_s3 (tmp: POINTER): NATURAL_32
		external
			"C inline"
		alias
			"return (unsigned long)((struct __anonstruct_taus_state_t_26 *)$tmp)->s3;"
		end

feature {NONE} -- C setters

	c_set_s1 (tmp: POINTER; a_s1: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_taus_state_t_26 *)$tmp)->s1 = $a_s1;"
		end

	c_set_s2 (tmp: POINTER; a_s2: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_taus_state_t_26 *)$tmp)->s2 = $a_s2;"
		end

	c_set_s3 (tmp: POINTER; a_s3: NATURAL_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_taus_state_t_26 *)$tmp)->s3 = $a_s3;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_taus_state_t_26);"
		end

end
