class
	PD_U2

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	f: REAL_32 assign set_f
		do
			Result := c_f (c_pointer)
		end

	b: CE_ARRAY [NATURAL_8]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_b (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_f (a_f: REAL_32)
		do
			c_set_f (c_pointer, a_f)
		end

feature {NONE} -- C getters

	c_f (tmp: POINTER): REAL_32
		external
			"C inline"
		alias
			"return (float)((union __anonunion_u_30 *)$tmp)->f;"
		end

	c_b (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				union __anonunion_u_30 *tmp = (union __anonunion_u_30 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->b) / sizeof(tmp->b[0]);
				return tmp->b;
			]"
		end

feature {NONE} -- C setters

	c_set_f (tmp: POINTER; a_f: REAL_32)
		external
			"C inline"
		alias
			"((union __anonunion_u_30 *)$tmp)->f = $a_f;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(union __anonunion_u_30);"
		end

end
