class
	PD_U4

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	f: REAL_32 assign set_f
		do
			Result := c_f (c_pointer)
		end

	f_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(union __anonunion_u_32, f);"
		end

	ieee: PD_IEEE assign set_ieee
		do
			create Result.make_shared (c_ieee (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_f (a_f: REAL_32)
		do
			c_set_f (c_pointer, a_f)
		end

	set_ieee (a_ieee: PD_IEEE)
		do
			ieee.ce_gets (a_ieee)
		end

feature {NONE} -- C getters

	c_f (tmp: POINTER): REAL_32
		external
			"C inline"
		alias
			"return (float)((union __anonunion_u_32 *)$tmp)->f;"
		end

	c_ieee (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct __anonstruct_ieee_33 *)&((union __anonunion_u_32 *)$tmp)->ieee;"
		end

feature {NONE} -- C setters

	c_set_f (tmp: POINTER; a_f: REAL_32)
		external
			"C inline"
		alias
			"((union __anonunion_u_32 *)$tmp)->f = $a_f;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(union __anonunion_u_32);"
		end

end
