class
	PD_U5

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	d: REAL_64 assign set_d
		do
			Result := c_d (c_pointer)
		end

	d_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(union __anonunion_u_34, d);"
		end

	ieee: PD_IEEE2 assign set_ieee
		do
			create Result.make_shared (c_ieee (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_d (a_d: REAL_64)
		do
			c_set_d (c_pointer, a_d)
		end

	set_ieee (a_ieee: PD_IEEE2)
		do
			ieee.ce_gets (a_ieee)
		end

feature {NONE} -- C getters

	c_d (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((union __anonunion_u_34 *)$tmp)->d;"
		end

	c_ieee (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct __anonstruct_ieee_35 *)&((union __anonunion_u_34 *)$tmp)->ieee;"
		end

feature {NONE} -- C setters

	c_set_d (tmp: POINTER; a_d: REAL_64)
		external
			"C inline"
		alias
			"((union __anonunion_u_34 *)$tmp)->d = $a_d;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(union __anonunion_u_34);"
		end

end
