class
	PD_UNI32_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	i: INTEGER_32 assign set_i
		do
			Result := c_i (c_pointer)
		end

	j: INTEGER_32 assign set_j
		do
			Result := c_j (c_pointer)
		end

	m: CE_ARRAY [NATURAL_32]
		local
			tmp_dimensions: ARRAY [INTEGER_32]
		do
			create tmp_dimensions.make_filled (0, 1, 1)
			create Result.make_shared (c_m (c_pointer, tmp_dimensions.area.base_address), tmp_dimensions)
		end

feature {ANY} -- Eiffel setters

	set_i (a_i: INTEGER_32)
		do
			c_set_i (c_pointer, a_i)
		end

	set_j (a_j: INTEGER_32)
		do
			c_set_j (c_pointer, a_j)
		end

feature {NONE} -- C getters

	c_i (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_uni32_state_t_26 *)$tmp)->i;"
		end

	c_j (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_uni32_state_t_26 *)$tmp)->j;"
		end

	c_m (tmp, tmp_dimensions: POINTER): POINTER
		external
			"C inline"
		alias
			"[
				struct __anonstruct_uni32_state_t_26 *tmp = (struct __anonstruct_uni32_state_t_26 *)$tmp;
				((int *)$tmp_dimensions)[0] = sizeof(tmp->m) / sizeof(tmp->m[0]);
				return tmp->m;
			]"
		end

feature {NONE} -- C setters

	c_set_i (tmp: POINTER; a_i: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_uni32_state_t_26 *)$tmp)->i = $a_i;"
		end

	c_set_j (tmp: POINTER; a_j: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_uni32_state_t_26 *)$tmp)->j = $a_j;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_uni32_state_t_26);"
		end

end
