class
	PD_VECTOR_BFGS_STATE_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	iter: INTEGER_32 assign set_iter
		do
			Result := c_iter (c_pointer)
		end

	step: REAL_64 assign set_step
		do
			Result := c_step (c_pointer)
		end

	step_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(struct __anonstruct_vector_bfgs_state_t_119, step);"
		end

	max_step: REAL_64 assign set_max_step
		do
			Result := c_max_step (c_pointer)
		end

	tol: REAL_64 assign set_tol
		do
			Result := c_tol (c_pointer)
		end

	x1: CE_POINTER [PD_GSL_VECTOR] assign set_x1
		do
			create Result.make_shared (c_x1 (c_pointer))
		end

	dx1: CE_POINTER [PD_GSL_VECTOR] assign set_dx1
		do
			create Result.make_shared (c_dx1 (c_pointer))
		end

	x2: CE_POINTER [PD_GSL_VECTOR] assign set_x2
		do
			create Result.make_shared (c_x2 (c_pointer))
		end

	g0norm: REAL_64 assign set_g0norm
		do
			Result := c_g0norm (c_pointer)
		end

	pnorm: REAL_64 assign set_pnorm
		do
			Result := c_pnorm (c_pointer)
		end

	p: CE_POINTER [PD_GSL_VECTOR] assign set_p
		do
			create Result.make_shared (c_p (c_pointer))
		end

	x0: CE_POINTER [PD_GSL_VECTOR] assign set_x0
		do
			create Result.make_shared (c_x0 (c_pointer))
		end

	g0: CE_POINTER [PD_GSL_VECTOR] assign set_g0
		do
			create Result.make_shared (c_g0 (c_pointer))
		end

	dx0: CE_POINTER [PD_GSL_VECTOR] assign set_dx0
		do
			create Result.make_shared (c_dx0 (c_pointer))
		end

	dg0: CE_POINTER [PD_GSL_VECTOR] assign set_dg0
		do
			create Result.make_shared (c_dg0 (c_pointer))
		end

feature {ANY} -- Eiffel setters

	set_iter (a_iter: INTEGER_32)
		do
			c_set_iter (c_pointer, a_iter)
		end

	set_step (a_step: REAL_64)
		do
			c_set_step (c_pointer, a_step)
		end

	set_max_step (a_max_step: REAL_64)
		do
			c_set_max_step (c_pointer, a_max_step)
		end

	set_tol (a_tol: REAL_64)
		do
			c_set_tol (c_pointer, a_tol)
		end

	set_x1 (a_x1: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_x1 (c_pointer, a_x1.c_pointer)
		end

	set_dx1 (a_dx1: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_dx1 (c_pointer, a_dx1.c_pointer)
		end

	set_x2 (a_x2: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_x2 (c_pointer, a_x2.c_pointer)
		end

	set_g0norm (a_g0norm: REAL_64)
		do
			c_set_g0norm (c_pointer, a_g0norm)
		end

	set_pnorm (a_pnorm: REAL_64)
		do
			c_set_pnorm (c_pointer, a_pnorm)
		end

	set_p (a_p: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_p (c_pointer, a_p.c_pointer)
		end

	set_x0 (a_x0: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_x0 (c_pointer, a_x0.c_pointer)
		end

	set_g0 (a_g0: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_g0 (c_pointer, a_g0.c_pointer)
		end

	set_dx0 (a_dx0: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_dx0 (c_pointer, a_dx0.c_pointer)
		end

	set_dg0 (a_dg0: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_dg0 (c_pointer, a_dg0.c_pointer)
		end

feature {NONE} -- C getters

	c_iter (tmp: POINTER): INTEGER_32
		external
			"C inline"
		alias
			"return (int)((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->iter;"
		end

	c_step (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->step;"
		end

	c_max_step (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->max_step;"
		end

	c_tol (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->tol;"
		end

	c_x1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->x1;"
		end

	c_dx1 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->dx1;"
		end

	c_x2 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->x2;"
		end

	c_g0norm (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->g0norm;"
		end

	c_pnorm (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->pnorm;"
		end

	c_p (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->p;"
		end

	c_x0 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->x0;"
		end

	c_g0 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->g0;"
		end

	c_dx0 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->dx0;"
		end

	c_dg0 (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->dg0;"
		end

feature {NONE} -- C setters

	c_set_iter (tmp: POINTER; a_iter: INTEGER_32)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->iter = $a_iter;"
		end

	c_set_step (tmp: POINTER; a_step: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->step = $a_step;"
		end

	c_set_max_step (tmp: POINTER; a_max_step: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->max_step = $a_max_step;"
		end

	c_set_tol (tmp: POINTER; a_tol: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->tol = $a_tol;"
		end

	c_set_x1 (tmp: POINTER; a_x1: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->x1 = (gsl_vector *)$a_x1;"
		end

	c_set_dx1 (tmp: POINTER; a_dx1: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->dx1 = (gsl_vector *)$a_dx1;"
		end

	c_set_x2 (tmp: POINTER; a_x2: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->x2 = (gsl_vector *)$a_x2;"
		end

	c_set_g0norm (tmp: POINTER; a_g0norm: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->g0norm = $a_g0norm;"
		end

	c_set_pnorm (tmp: POINTER; a_pnorm: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->pnorm = $a_pnorm;"
		end

	c_set_p (tmp: POINTER; a_p: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->p = (gsl_vector *)$a_p;"
		end

	c_set_x0 (tmp: POINTER; a_x0: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->x0 = (gsl_vector *)$a_x0;"
		end

	c_set_g0 (tmp: POINTER; a_g0: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->g0 = (gsl_vector *)$a_g0;"
		end

	c_set_dx0 (tmp: POINTER; a_dx0: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->dx0 = (gsl_vector *)$a_dx0;"
		end

	c_set_dg0 (tmp: POINTER; a_dg0: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_vector_bfgs_state_t_119 *)$tmp)->dg0 = (gsl_vector *)$a_dg0;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_vector_bfgs_state_t_119);"
		end

end
