class
	PD_WRAPPER_T

inherit
	CE_CLASS

create
	make,
	make_shared

feature {ANY} -- Eiffel getters

	fdf_linear: PD_GSL_FUNCTION_FDF_STRUCT assign set_fdf_linear
		do
			create Result.make_shared (c_fdf_linear (c_pointer))
		end

	fdf_linear_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(struct __anonstruct_wrapper_t_120, fdf_linear);"
		end

	fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT] assign set_fdf
		do
			create Result.make_shared (c_fdf (c_pointer))
		end

	x: CE_POINTER [PD_GSL_VECTOR] assign set_x
		do
			create Result.make_shared (c_x (c_pointer))
		end

	g: CE_POINTER [PD_GSL_VECTOR] assign set_g
		do
			create Result.make_shared (c_g (c_pointer))
		end

	p: CE_POINTER [PD_GSL_VECTOR] assign set_p
		do
			create Result.make_shared (c_p (c_pointer))
		end

	f_alpha: REAL_64 assign set_f_alpha
		do
			Result := c_f_alpha (c_pointer)
		end

	f_alpha_offset: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return (int)offsetof(struct __anonstruct_wrapper_t_120, f_alpha);"
		end

	df_alpha: REAL_64 assign set_df_alpha
		do
			Result := c_df_alpha (c_pointer)
		end

	x_alpha: CE_POINTER [PD_GSL_VECTOR] assign set_x_alpha
		do
			create Result.make_shared (c_x_alpha (c_pointer))
		end

	g_alpha: CE_POINTER [PD_GSL_VECTOR] assign set_g_alpha
		do
			create Result.make_shared (c_g_alpha (c_pointer))
		end

	f_cache_key: REAL_64 assign set_f_cache_key
		do
			Result := c_f_cache_key (c_pointer)
		end

	df_cache_key: REAL_64 assign set_df_cache_key
		do
			Result := c_df_cache_key (c_pointer)
		end

	x_cache_key: REAL_64 assign set_x_cache_key
		do
			Result := c_x_cache_key (c_pointer)
		end

	g_cache_key: REAL_64 assign set_g_cache_key
		do
			Result := c_g_cache_key (c_pointer)
		end

feature {ANY} -- Eiffel setters

	set_fdf_linear (a_fdf_linear: PD_GSL_FUNCTION_FDF_STRUCT)
		do
			fdf_linear.ce_gets (a_fdf_linear)
		end

	set_fdf (a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT])
		do
			c_set_fdf (c_pointer, a_fdf.c_pointer)
		end

	set_x (a_x: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_x (c_pointer, a_x.c_pointer)
		end

	set_g (a_g: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_g (c_pointer, a_g.c_pointer)
		end

	set_p (a_p: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_p (c_pointer, a_p.c_pointer)
		end

	set_f_alpha (a_f_alpha: REAL_64)
		do
			c_set_f_alpha (c_pointer, a_f_alpha)
		end

	set_df_alpha (a_df_alpha: REAL_64)
		do
			c_set_df_alpha (c_pointer, a_df_alpha)
		end

	set_x_alpha (a_x_alpha: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_x_alpha (c_pointer, a_x_alpha.c_pointer)
		end

	set_g_alpha (a_g_alpha: CE_POINTER [PD_GSL_VECTOR])
		do
			c_set_g_alpha (c_pointer, a_g_alpha.c_pointer)
		end

	set_f_cache_key (a_f_cache_key: REAL_64)
		do
			c_set_f_cache_key (c_pointer, a_f_cache_key)
		end

	set_df_cache_key (a_df_cache_key: REAL_64)
		do
			c_set_df_cache_key (c_pointer, a_df_cache_key)
		end

	set_x_cache_key (a_x_cache_key: REAL_64)
		do
			c_set_x_cache_key (c_pointer, a_x_cache_key)
		end

	set_g_cache_key (a_g_cache_key: REAL_64)
		do
			c_set_g_cache_key (c_pointer, a_g_cache_key)
		end

feature {NONE} -- C getters

	c_fdf_linear (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct gsl_function_fdf_struct *)&((struct __anonstruct_wrapper_t_120 *)$tmp)->fdf_linear;"
		end

	c_fdf (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (struct gsl_multimin_function_fdf_struct *)((struct __anonstruct_wrapper_t_120 *)$tmp)->fdf;"
		end

	c_x (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_wrapper_t_120 *)$tmp)->x;"
		end

	c_g (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_wrapper_t_120 *)$tmp)->g;"
		end

	c_p (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_wrapper_t_120 *)$tmp)->p;"
		end

	c_f_alpha (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_wrapper_t_120 *)$tmp)->f_alpha;"
		end

	c_df_alpha (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_wrapper_t_120 *)$tmp)->df_alpha;"
		end

	c_x_alpha (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_wrapper_t_120 *)$tmp)->x_alpha;"
		end

	c_g_alpha (tmp: POINTER): POINTER
		external
			"C inline"
		alias
			"return (gsl_vector *)((struct __anonstruct_wrapper_t_120 *)$tmp)->g_alpha;"
		end

	c_f_cache_key (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_wrapper_t_120 *)$tmp)->f_cache_key;"
		end

	c_df_cache_key (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_wrapper_t_120 *)$tmp)->df_cache_key;"
		end

	c_x_cache_key (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_wrapper_t_120 *)$tmp)->x_cache_key;"
		end

	c_g_cache_key (tmp: POINTER): REAL_64
		external
			"C inline"
		alias
			"return (double)((struct __anonstruct_wrapper_t_120 *)$tmp)->g_cache_key;"
		end

feature {NONE} -- C setters

	c_set_fdf (tmp: POINTER; a_fdf: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_wrapper_t_120 *)$tmp)->fdf = (struct gsl_multimin_function_fdf_struct *)$a_fdf;"
		end

	c_set_x (tmp: POINTER; a_x: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_wrapper_t_120 *)$tmp)->x = (gsl_vector *)$a_x;"
		end

	c_set_g (tmp: POINTER; a_g: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_wrapper_t_120 *)$tmp)->g = (gsl_vector *)$a_g;"
		end

	c_set_p (tmp: POINTER; a_p: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_wrapper_t_120 *)$tmp)->p = (gsl_vector *)$a_p;"
		end

	c_set_f_alpha (tmp: POINTER; a_f_alpha: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_wrapper_t_120 *)$tmp)->f_alpha = $a_f_alpha;"
		end

	c_set_df_alpha (tmp: POINTER; a_df_alpha: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_wrapper_t_120 *)$tmp)->df_alpha = $a_df_alpha;"
		end

	c_set_x_alpha (tmp: POINTER; a_x_alpha: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_wrapper_t_120 *)$tmp)->x_alpha = (gsl_vector *)$a_x_alpha;"
		end

	c_set_g_alpha (tmp: POINTER; a_g_alpha: POINTER)
		external
			"C inline"
		alias
			"((struct __anonstruct_wrapper_t_120 *)$tmp)->g_alpha = (gsl_vector *)$a_g_alpha;"
		end

	c_set_f_cache_key (tmp: POINTER; a_f_cache_key: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_wrapper_t_120 *)$tmp)->f_cache_key = $a_f_cache_key;"
		end

	c_set_df_cache_key (tmp: POINTER; a_df_cache_key: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_wrapper_t_120 *)$tmp)->df_cache_key = $a_df_cache_key;"
		end

	c_set_x_cache_key (tmp: POINTER; a_x_cache_key: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_wrapper_t_120 *)$tmp)->x_cache_key = $a_x_cache_key;"
		end

	c_set_g_cache_key (tmp: POINTER; a_g_cache_key: REAL_64)
		external
			"C inline"
		alias
			"((struct __anonstruct_wrapper_t_120 *)$tmp)->g_cache_key = $a_g_cache_key;"
		end

feature {ANY}

	sizeof: INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return sizeof(struct __anonstruct_wrapper_t_120);"
		end

end
