frozen class
	LIBGSL_INITIALIZER_SLICE19

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {LIBGSL_INITIALIZER}

	initialize
		do
			ranlxs_inst.ranlxs1_type.min := {NATURAL_32} 0
			ranlxs_inst.ranlxs1_type.size := {PD_RANLXS_STATE_T}.sizeof.to_natural_32
			ranlxs_inst.ranlxs1_type.set := ranlxs_inst.ranlxs1_set_address
			ranlxs_inst.ranlxs1_type.get := ranlxs_inst.ranlxs_get_address
			ranlxs_inst.ranlxs1_type.get_double := ranlxs_inst.ranlxs_get_double_address
			ranlxs_inst.ranlxs2_type.name := ce_string ("ranlxs2")
			ranlxs_inst.ranlxs2_type.max := {NATURAL_32} 16777215
			ranlxs_inst.ranlxs2_type.min := {NATURAL_32} 0
			ranlxs_inst.ranlxs2_type.size := {PD_RANLXS_STATE_T}.sizeof.to_natural_32
			ranlxs_inst.ranlxs2_type.set := ranlxs_inst.ranlxs2_set_address
			ranlxs_inst.ranlxs2_type.get := ranlxs_inst.ranlxs_get_address
			ranlxs_inst.ranlxs2_type.get_double := ranlxs_inst.ranlxs_get_double_address
			ranlxs_inst.gsl_rng_ranlxs0.ce_gets (ranlxs_inst.ranlxs0_type.address)
			ranlxs_inst.gsl_rng_ranlxs1.ce_gets (ranlxs_inst.ranlxs1_type.address)
			ranlxs_inst.gsl_rng_ranlxs2.ce_gets (ranlxs_inst.ranlxs2_type.address)
			randu_inst.a3 := (65539).to_integer_32
			randu_inst.randu_type.name := ce_string ("randu")
			randu_inst.randu_type.max := {NATURAL_32} 2147483647
			randu_inst.randu_type.min := {NATURAL_32} 1
			randu_inst.randu_type.size := {PD_RANDU_STATE_T}.sizeof.to_natural_32
			randu_inst.randu_type.set := randu_inst.randu_set_address
			randu_inst.randu_type.get := randu_inst.randu_get_address
			randu_inst.randu_type.get_double := randu_inst.randu_get_double_address
			randu_inst.gsl_rng_randu.ce_gets (randu_inst.randu_type.address)
			uni32_inst.m1 := (2147483647).to_natural_32
			uni32_inst.m2 := (65536).to_natural_32
			uni32_inst.uni32_type.name := ce_string ("uni32")
			uni32_inst.uni32_type.max := {NATURAL_32} 2147483646
			uni32_inst.uni32_type.min := {NATURAL_32} 0
			uni32_inst.uni32_type.size := {PD_UNI32_STATE_T}.sizeof.to_natural_32
			uni32_inst.uni32_type.set := uni32_inst.uni32_set_address
			uni32_inst.uni32_type.get := uni32_inst.uni32_get_address
			uni32_inst.uni32_type.get_double := uni32_inst.uni32_get_double_address
			uni32_inst.gsl_rng_uni32.ce_gets (uni32_inst.uni32_type.address)
			ran1_inst.m := (2147483647).to_integer_32
			ran1_inst.a___0 := (16807).to_integer_32
			ran1_inst.q := (127773).to_integer_32
			ran1_inst.r := (2836).to_integer_32
			ran1_inst.ran1_type.name := ce_string ("ran1")
			ran1_inst.ran1_type.max := {NATURAL_32} 2147483646
			ran1_inst.ran1_type.min := {NATURAL_32} 1
			ran1_inst.ran1_type.size := {PD_RAN1_STATE_T}.sizeof.to_natural_32
			ran1_inst.ran1_type.set := ran1_inst.ran1_set_address
			ran1_inst.ran1_type.get := ran1_inst.ran1_get_address
			ran1_inst.ran1_type.get_double := ran1_inst.ran1_get_double_address
			ran1_inst.gsl_rng_ran1.ce_gets (ran1_inst.ran1_type.address)
			borosh13_inst.ran_type___0.name := ce_string ("borosh13")
			borosh13_inst.ran_type___0.max := {NATURAL_32} 4294967295
			borosh13_inst.ran_type___0.min := {NATURAL_32} 1
			borosh13_inst.ran_type___0.size := {PD_RAN_STATE_T}.sizeof.to_natural_32
			borosh13_inst.ran_type___0.set := borosh13_inst.ran_set___0_address
			borosh13_inst.ran_type___0.get := borosh13_inst.ran_get___0_address
			borosh13_inst.ran_type___0.get_double := borosh13_inst.ran_get_double___0_address
			borosh13_inst.gsl_rng_borosh13.ce_gets (borosh13_inst.ran_type___0.address)
			ran2_inst.m1___0 := (2147483563).to_integer_32
			ran2_inst.a12 := (40014).to_integer_32
			ran2_inst.q12 := (53668).to_integer_32
			ran2_inst.r1 := (12211).to_integer_32
			ran2_inst.m2___0 := (2147483399).to_integer_32
			ran2_inst.a22 := (40692).to_integer_32
			ran2_inst.q22 := (52774).to_integer_32
			ran2_inst.r2 := (3791).to_integer_32
			ran2_inst.ran2_type.name := ce_string ("ran2")
			ran2_inst.ran2_type.max := {NATURAL_32} 2147483562
			ran2_inst.ran2_type.min := {NATURAL_32} 1
			ran2_inst.ran2_type.size := {PD_RAN2_STATE_T}.sizeof.to_natural_32
			ran2_inst.ran2_type.set := ran2_inst.ran2_set_address
			ran2_inst.ran2_type.get := ran2_inst.ran2_get_address
			ran2_inst.ran2_type.get_double := ran2_inst.ran2_get_double_address
			ran2_inst.gsl_rng_ran2.ce_gets (ran2_inst.ran2_type.address)
			ran0_inst.m___0 := (2147483647).to_integer_32
			ran0_inst.a___1 := (16807).to_integer_32
			ran0_inst.q___0 := (127773).to_integer_32
			ran0_inst.r___0 := (2836).to_integer_32
			ran0_inst.mask := (123459876).to_natural_32
			ran0_inst.ran0_type.name := ce_string ("ran0")
			ran0_inst.ran0_type.max := {NATURAL_32} 2147483646
			ran0_inst.ran0_type.min := {NATURAL_32} 1
			ran0_inst.ran0_type.size := {PD_RAN0_STATE_T}.sizeof.to_natural_32
			ran0_inst.ran0_type.set := ran0_inst.ran0_set_address
			ran0_inst.ran0_type.get := ran0_inst.ran0_get_address
			ran0_inst.ran0_type.get_double := ran0_inst.ran0_get_double_address
			ran0_inst.gsl_rng_ran0.ce_gets (ran0_inst.ran0_type.address)
			knuthran2_inst.ran_type___1.name := ce_string ("knuthran2")
			knuthran2_inst.ran_type___1.max := {NATURAL_32} 2147483646
			knuthran2_inst.ran_type___1.min := {NATURAL_32} 0
			knuthran2_inst.ran_type___1.size := {PD_RAN_STATE_T_26__}.sizeof.to_natural_32
			knuthran2_inst.ran_type___1.set := knuthran2_inst.ran_set___1_address
			knuthran2_inst.ran_type___1.get := knuthran2_inst.ran_get___1_address
			knuthran2_inst.ran_type___1.get_double := knuthran2_inst.ran_get_double___1_address
			knuthran2_inst.gsl_rng_knuthran2.ce_gets (knuthran2_inst.ran_type___1.address)
			tt_inst.tt_type.name := ce_string ("tt800")
			tt_inst.tt_type.max := {NATURAL_32} 4294967295
			tt_inst.tt_type.min := {NATURAL_32} 0
			tt_inst.tt_type.size := {PD_TT_STATE_T}.sizeof.to_natural_32
			tt_inst.tt_type.set := tt_inst.tt_set_address
			tt_inst.tt_type.get := tt_inst.tt_get_address
			tt_inst.tt_type.get_double := tt_inst.tt_get_double_address
			tt_inst.gsl_rng_tt800.ce_gets (tt_inst.tt_type.address)
			vax_inst.vax_type.name := ce_string ("vax")
			vax_inst.vax_type.max := {NATURAL_32} 4294967295
			vax_inst.vax_type.min := {NATURAL_32} 0
			vax_inst.vax_type.size := {PD_VAX_STATE_T}.sizeof.to_natural_32
			vax_inst.vax_type.set := vax_inst.vax_set_address
			vax_inst.vax_type.get := vax_inst.vax_get_address
			vax_inst.vax_type.get_double := vax_inst.vax_get_double_address
			vax_inst.gsl_rng_vax.ce_gets (vax_inst.vax_type.address)
			ranmar_inst.two24 := (16777216).to_natural_32
			ranmar_inst.ranmar_type.name := ce_string ("ranmar")
			ranmar_inst.ranmar_type.max := {NATURAL_32} 16777215
			ranmar_inst.ranmar_type.min := {NATURAL_32} 0
			ranmar_inst.ranmar_type.size := {PD_RANMAR_STATE_T}.sizeof.to_natural_32
			ranmar_inst.ranmar_type.set := ranmar_inst.ranmar_set_address
			ranmar_inst.ranmar_type.get := ranmar_inst.ranmar_get_address
			ranmar_inst.ranmar_type.get_double := ranmar_inst.ranmar_get_double_address
			ranmar_inst.gsl_rng_ranmar.ce_gets (ranmar_inst.ranmar_type.address)
			fishman2x_inst.ran_type___2.name := ce_string ("fishman2x")
			fishman2x_inst.ran_type___2.max := {NATURAL_32} 2147483646
			fishman2x_inst.ran_type___2.min := {NATURAL_32} 0
			fishman2x_inst.ran_type___2.size := {PD_RAN_STATE_T_26__2}.sizeof.to_natural_32
			fishman2x_inst.ran_type___2.set := fishman2x_inst.ran_set___2_address
			fishman2x_inst.ran_type___2.get := fishman2x_inst.ran_get___2_address
			fishman2x_inst.ran_type___2.get_double := fishman2x_inst.ran_get_double___2_address
			fishman2x_inst.gsl_rng_fishman2x.ce_gets (fishman2x_inst.ran_type___2.address)
			ranf_inst.a0 := (45429).to_natural_16
			ranf_inst.a1___0 := (41703).to_natural_16
			ranf_inst.a2___0 := (10357).to_natural_16
			ranf_inst.ranf_type.name := ce_string ("ranf")
			ranf_inst.ranf_type.max := {NATURAL_32} 4294967295
			ranf_inst.ranf_type.min := {NATURAL_32} 0
			ranf_inst.ranf_type.size := {PD_RANF_STATE_T}.sizeof.to_natural_32
			ranf_inst.ranf_type.set := ranf_inst.ranf_set_address
			ranf_inst.ranf_type.get := ranf_inst.ranf_get_address
			ranf_inst.ranf_type.get_double := ranf_inst.ranf_get_double_address
			ranf_inst.gsl_rng_ranf.ce_gets (ranf_inst.ranf_type.address)
			knuthran_inst.ran_type___3.name := ce_string ("knuthran")
			knuthran_inst.ran_type___3.max := {NATURAL_32} 1073741823
			knuthran_inst.ran_type___3.min := {NATURAL_32} 0
			knuthran_inst.ran_type___3.size := {PD_RAN_STATE_T_26__3}.sizeof.to_natural_32
			knuthran_inst.ran_type___3.set := knuthran_inst.ran_set___3_address
			knuthran_inst.ran_type___3.get := knuthran_inst.ran_get___3_address
			knuthran_inst.ran_type___3.get_double := knuthran_inst.ran_get_double___3_address
			knuthran_inst.gsl_rng_knuthran.ce_gets (knuthran_inst.ran_type___3.address)
			lecuyer21_inst.ran_type___4.name := ce_string ("lecuyer21")
			lecuyer21_inst.ran_type___4.max := {NATURAL_32} 2147483398
			lecuyer21_inst.ran_type___4.min := {NATURAL_32} 1
			lecuyer21_inst.ran_type___4.size := {PD_RAN_STATE_T}.sizeof.to_natural_32
			lecuyer21_inst.ran_type___4.set := lecuyer21_inst.ran_set___4_address
			lecuyer21_inst.ran_type___4.get := lecuyer21_inst.ran_get___4_address
			lecuyer21_inst.ran_type___4.get_double := lecuyer21_inst.ran_get_double___4_address
			lecuyer21_inst.gsl_rng_lecuyer21.ce_gets (lecuyer21_inst.ran_type___4.address)
			ranlxd_inst.next___0[0] := 1
			ranlxd_inst.next___0[1] := 2
			ranlxd_inst.next___0[2] := 3
			ranlxd_inst.next___0[3] := 4
			ranlxd_inst.next___0[4] := 5
			ranlxd_inst.next___0[5] := 6
			ranlxd_inst.next___0[6] := 7
			ranlxd_inst.next___0[7] := 8
			ranlxd_inst.next___0[8] := 9
			ranlxd_inst.next___0[9] := 10
			ranlxd_inst.next___0[10] := 11
			ranlxd_inst.next___0[11] := 0
			ranlxd_inst.one_bit___0 := (1.0 / 281474976710656.0)
			ranlxd_inst.ranlxd1_type.name := ce_string ("ranlxd1")
			ranlxd_inst.ranlxd1_type.max := {NATURAL_32} 4294967295
			ranlxd_inst.ranlxd1_type.min := {NATURAL_32} 0
			ranlxd_inst.ranlxd1_type.size := {PD_RANLXD_STATE_T}.sizeof.to_natural_32
			ranlxd_inst.ranlxd1_type.set := ranlxd_inst.ranlxd1_set_address
			ranlxd_inst.ranlxd1_type.get := ranlxd_inst.ranlxd_get_address
			ranlxd_inst.ranlxd1_type.get_double := ranlxd_inst.ranlxd_get_double_address
			ranlxd_inst.ranlxd2_type.name := ce_string ("ranlxd2")
			ranlxd_inst.ranlxd2_type.max := {NATURAL_32} 4294967295
			ranlxd_inst.ranlxd2_type.min := {NATURAL_32} 0
			ranlxd_inst.ranlxd2_type.size := {PD_RANLXD_STATE_T}.sizeof.to_natural_32
			ranlxd_inst.ranlxd2_type.set := ranlxd_inst.ranlxd2_set_address
			ranlxd_inst.ranlxd2_type.get := ranlxd_inst.ranlxd_get_address
			ranlxd_inst.ranlxd2_type.get_double := ranlxd_inst.ranlxd_get_double_address
			ranlxd_inst.gsl_rng_ranlxd1.ce_gets (ranlxd_inst.ranlxd1_type.address)
			ranlxd_inst.gsl_rng_ranlxd2.ce_gets (ranlxd_inst.ranlxd2_type.address)
			slatec_inst.P := (4194304).to_integer_32
			slatec_inst.a1___1 := (1536).to_integer_32
			slatec_inst.a0___0 := (1029).to_integer_32
			slatec_inst.a1ma0 := (507).to_integer_32
			slatec_inst.c := (1731).to_integer_32
			slatec_inst.slatec_type.name := ce_string ("slatec")
			slatec_inst.slatec_type.max := {NATURAL_32} 4194303
			slatec_inst.slatec_type.min := {NATURAL_32} 0
			slatec_inst.slatec_type.size := {PD_SLATEC_STATE_T}.sizeof.to_natural_32
			slatec_inst.slatec_type.set := slatec_inst.slatec_set_address
			slatec_inst.slatec_type.get := slatec_inst.slatec_get_address
			slatec_inst.slatec_type.get_double := slatec_inst.slatec_get_double_address
			slatec_inst.gsl_rng_slatec.ce_gets (slatec_inst.slatec_type.address)
			transputer_inst.transputer_type.name := ce_string ("transputer")
			transputer_inst.transputer_type.max := {NATURAL_32} 4294967295
			transputer_inst.transputer_type.min := {NATURAL_32} 1
			transputer_inst.transputer_type.size := {PD_TRANSPUTER_STATE_T}.sizeof.to_natural_32
			transputer_inst.transputer_type.set := transputer_inst.transputer_set_address
			transputer_inst.transputer_type.get := transputer_inst.transputer_get_address
			transputer_inst.transputer_type.get_double := transputer_inst.transputer_get_double_address
			transputer_inst.gsl_rng_transputer.ce_gets (transputer_inst.transputer_type.address)
			uni_inst.m1___1 := (32767).to_natural_32
			uni_inst.m2___1 := (256).to_natural_32
			uni_inst.uni_type.name := ce_string ("uni")
			uni_inst.uni_type.max := {NATURAL_32} 32766
			uni_inst.uni_type.min := {NATURAL_32} 0
			uni_inst.uni_type.size := {PD_UNI_STATE_T}.sizeof.to_natural_32
			uni_inst.uni_type.set := uni_inst.uni_set_address
			uni_inst.uni_type.get := uni_inst.uni_get_address
			uni_inst.uni_type.get_double := uni_inst.uni_get_double_address
			uni_inst.gsl_rng_uni.ce_gets (uni_inst.uni_type.address)
			waterman14_inst.ran_type___5.name := ce_string ("waterman14")
			waterman14_inst.ran_type___5.max := {NATURAL_32} 4294967295
			waterman14_inst.ran_type___5.min := {NATURAL_32} 1
			waterman14_inst.ran_type___5.size := {PD_RAN_STATE_T}.sizeof.to_natural_32
			waterman14_inst.ran_type___5.set := waterman14_inst.ran_set___5_address
			waterman14_inst.ran_type___5.get := waterman14_inst.ran_get___5_address
			waterman14_inst.ran_type___5.get_double := waterman14_inst.ran_get_double___5_address
			waterman14_inst.gsl_rng_waterman14.ce_gets (waterman14_inst.ran_type___5.address)
			taus_inst.taus_type.name := ce_string ("taus")
			taus_inst.taus_type.max := {NATURAL_32} 4294967295
			taus_inst.taus_type.min := {NATURAL_32} 0
			taus_inst.taus_type.size := {PD_TAUS_STATE_T}.sizeof.to_natural_32
			taus_inst.taus_type.set := taus_inst.taus_set_address
			taus_inst.taus_type.get := taus_inst.taus_get_address
			taus_inst.taus_type.get_double := taus_inst.taus_get_double_address
			taus_inst.gsl_rng_taus.ce_gets (taus_inst.taus_type.address)
			taus_inst.taus2_type.name := ce_string ("taus2")
			taus_inst.taus2_type.max := {NATURAL_32} 4294967295
			taus_inst.taus2_type.min := {NATURAL_32} 0
			taus_inst.taus2_type.size := {PD_TAUS_STATE_T}.sizeof.to_natural_32
			taus_inst.taus2_type.set := taus_inst.taus2_set_address
			taus_inst.taus2_type.get := taus_inst.taus_get_address
			taus_inst.taus2_type.get_double := taus_inst.taus_get_double_address
			taus_inst.gsl_rng_taus2.ce_gets (taus_inst.taus2_type.address)
			knuthran2002_inst.ran_type___6.name := ce_string ("knuthran2002")
			knuthran2002_inst.ran_type___6.max := {NATURAL_32} 1073741823
			knuthran2002_inst.ran_type___6.min := {NATURAL_32} 0
			knuthran2002_inst.ran_type___6.size := {PD_RAN_STATE_T_26__4}.sizeof.to_natural_32
			knuthran2002_inst.ran_type___6.set := knuthran2002_inst.ran_set___6_address
			knuthran2002_inst.ran_type___6.get := knuthran2002_inst.ran_get___6_address
			knuthran2002_inst.ran_type___6.get_double := knuthran2002_inst.ran_get_double___6_address
			knuthran2002_inst.gsl_rng_knuthran2002.ce_gets (knuthran2002_inst.ran_type___6.address)
			taus113_inst.taus113_type.name := ce_string ("taus113")
			taus113_inst.taus113_type.max := {NATURAL_32} 4294967295
			taus113_inst.taus113_type.min := {NATURAL_32} 0
			taus113_inst.taus113_type.size := {PD_TAUS113_STATE_T}.sizeof.to_natural_32
			taus113_inst.taus113_type.set := taus113_inst.taus113_set_address
			taus113_inst.taus113_type.get := taus113_inst.taus113_get_address
			taus113_inst.taus113_type.get_double := taus113_inst.taus113_get_double_address
			taus113_inst.gsl_rng_taus113.ce_gets (taus113_inst.taus113_type.address)
			rand_inst.rand_type.name := ce_string ("rand")
			rand_inst.rand_type.max := {NATURAL_32} 2147483647
			rand_inst.rand_type.min := {NATURAL_32} 0
			rand_inst.rand_type.size := {PD_RAND_STATE_T}.sizeof.to_natural_32
			rand_inst.rand_type.set := rand_inst.rand_set_address
			rand_inst.rand_type.get := rand_inst.rand_get_address
			rand_inst.rand_type.get_double := rand_inst.rand_get_double_address
			rand_inst.gsl_rng_rand.ce_gets (rand_inst.rand_type.address)
			ranlux_inst.mask_lo := {NATURAL_32} 16777215
			ranlux_inst.mask_hi := (({NATURAL_32} 16777215).bit_not)
			ranlux_inst.two24___0 := (16777216).to_natural_32
			ranlux_inst.ranlux_type.name := ce_string ("ranlux")
			ranlux_inst.ranlux_type.max := {NATURAL_32} 16777215
			ranlux_inst.ranlux_type.min := {NATURAL_32} 0
			ranlux_inst.ranlux_type.size := {PD_RANLUX_STATE_T}.sizeof.to_natural_32
			ranlux_inst.ranlux_type.set := ranlux_inst.ranlux_set_address
			ranlux_inst.ranlux_type.get := ranlux_inst.ranlux_get_address
			ranlux_inst.ranlux_type.get_double := ranlux_inst.ranlux_get_double_address
			ranlux_inst.ranlux389_type.name := ce_string ("ranlux389")
			ranlux_inst.ranlux389_type.max := {NATURAL_32} 16777215
			ranlux_inst.ranlux389_type.min := {NATURAL_32} 0
			ranlux_inst.ranlux389_type.size := {PD_RANLUX_STATE_T}.sizeof.to_natural_32
			ranlux_inst.ranlux389_type.set := ranlux_inst.ranlux389_set_address
			ranlux_inst.ranlux389_type.get := ranlux_inst.ranlux_get_address
			ranlux_inst.ranlux389_type.get_double := ranlux_inst.ranlux_get_double_address
			ranlux_inst.gsl_rng_ranlux.ce_gets (ranlux_inst.ranlux_type.address)
			ranlux_inst.gsl_rng_ranlux389.ce_gets (ranlux_inst.ranlux389_type.address)
			fishman20_inst.m___1 := (2147483647).to_integer_32
			fishman20_inst.a___2 := (48271).to_integer_32
			fishman20_inst.q___1 := (44488).to_integer_32
			fishman20_inst.r___1 := (3399).to_integer_32
			fishman20_inst.ran_type___7.name := ce_string ("fishman20")
			fishman20_inst.ran_type___7.max := {NATURAL_32} 2147483646
			fishman20_inst.ran_type___7.min := {NATURAL_32} 1
			fishman20_inst.ran_type___7.size := {PD_RAN_STATE_T}.sizeof.to_natural_32
			fishman20_inst.ran_type___7.set := fishman20_inst.ran_set___7_address
			fishman20_inst.ran_type___7.get := fishman20_inst.ran_get___7_address
			fishman20_inst.ran_type___7.get_double := fishman20_inst.ran_get_double___7_address
			fishman20_inst.gsl_rng_fishman20.ce_gets (fishman20_inst.ran_type___7.address)
			rand48_inst.a0___1 := (58989).to_natural_16
			rand48_inst.a1___2 := (57068).to_natural_16
			rand48_inst.a2___1 := (5).to_natural_16
			rand48_inst.c0 := (11).to_natural_16
			rand48_inst.rand48_type.name := ce_string ("rand48")
			rand48_inst.rand48_type.max := {NATURAL_32} 4294967295
			rand48_inst.rand48_type.min := {NATURAL_32} 0
			rand48_inst.rand48_type.size := {PD_RAND48_STATE_T}.sizeof.to_natural_32
			rand48_inst.rand48_type.set := rand48_inst.rand48_set_address
			rand48_inst.rand48_type.get := rand48_inst.rand48_get_address
			rand48_inst.rand48_type.get_double := rand48_inst.rand48_get_double_address
			rand48_inst.gsl_rng_rand48.ce_gets (rand48_inst.rand48_type.address)
			r250_inst.r250_type.name := ce_string ("r250")
			r250_inst.r250_type.max := {NATURAL_32} 4294967295
			r250_inst.r250_type.min := {NATURAL_32} 0
			r250_inst.r250_type.size := {PD_R250_STATE_T}.sizeof.to_natural_32
			r250_inst.r250_type.set := r250_inst.r250_set_address
			r250_inst.r250_type.get := r250_inst.r250_get_address
			r250_inst.r250_type.get_double := r250_inst.r250_get_double_address
			r250_inst.gsl_rng_r250.ce_gets (r250_inst.r250_type.address)
			ran3_inst.ran3_type.name := ce_string ("ran3")
			ran3_inst.ran3_type.max := {NATURAL_32} 1000000000
			ran3_inst.ran3_type.min := {NATURAL_32} 0
			ran3_inst.ran3_type.size := {PD_RAN3_STATE_T}.sizeof.to_natural_32
			ran3_inst.ran3_type.set := ran3_inst.ran3_set_address
			ran3_inst.ran3_type.get := ran3_inst.ran3_get_address
			ran3_inst.ran3_type.get_double := ran3_inst.ran3_get_double_address
			ran3_inst.gsl_rng_ran3.ce_gets (ran3_inst.ran3_type.address)
			minstd_inst.m___2 := (2147483647).to_integer_32
			minstd_inst.a___3 := (16807).to_integer_32
			minstd_inst.q___2 := (127773).to_integer_32
			minstd_inst.r___2 := (2836).to_integer_32
			minstd_inst.minstd_type.name := ce_string ("minstd")
			minstd_inst.minstd_type.max := {NATURAL_32} 2147483646
			minstd_inst.minstd_type.min := {NATURAL_32} 1
			minstd_inst.minstd_type.size := {PD_MINSTD_STATE_T}.sizeof.to_natural_32
			minstd_inst.minstd_type.set := minstd_inst.minstd_set_address
			minstd_inst.minstd_type.get := minstd_inst.minstd_get_address
			minstd_inst.minstd_type.get_double := minstd_inst.minstd_get_double_address
			minstd_inst.gsl_rng_minstd.ce_gets (minstd_inst.minstd_type.address)
			gfsr4_inst.gfsr4_type.name := ce_string ("gfsr4")
			gfsr4_inst.gfsr4_type.max := {NATURAL_32} 4294967295
			gfsr4_inst.gfsr4_type.min := {NATURAL_32} 0
			gfsr4_inst.gfsr4_type.size := {PD_GFSR4_STATE_T}.sizeof.to_natural_32
			gfsr4_inst.gfsr4_type.set := gfsr4_inst.gfsr4_set_address
			gfsr4_inst.gfsr4_type.get := gfsr4_inst.gfsr4_get_address
			gfsr4_inst.gfsr4_type.get_double := gfsr4_inst.gfsr4_get_double_address
			gfsr4_inst.gsl_rng_gfsr4.ce_gets (gfsr4_inst.gfsr4_type.address)
			mrg_inst.m___3 := (2147483647).to_integer_32
			mrg_inst.a1___3 := (107374182).to_integer_32
			mrg_inst.q1___0 := (20).to_integer_32
			mrg_inst.r1___0 := (7).to_integer_32
			mrg_inst.a5 := (104480).to_integer_32
			mrg_inst.q52 := (20554).to_integer_32
			mrg_inst.r5 := (1727).to_integer_32
			mrg_inst.mrg_type.name := ce_string ("mrg")
			mrg_inst.mrg_type.max := {NATURAL_32} 2147483646
			mrg_inst.mrg_type.min := {NATURAL_32} 0
			mrg_inst.mrg_type.size := {PD_MRG_STATE_T}.sizeof.to_natural_32
			mrg_inst.mrg_type.set := mrg_inst.mrg_set_address
			mrg_inst.mrg_type.get := mrg_inst.mrg_get_address
			mrg_inst.mrg_type.get_double := mrg_inst.mrg_get_double_address
			mrg_inst.gsl_rng_mrg.ce_gets (mrg_inst.mrg_type.address)
			random_inst.random_glibc2_type.name := ce_string ("random-glibc2")
			random_inst.random_glibc2_type.max := {NATURAL_32} 2147483647
			random_inst.random_glibc2_type.min := {NATURAL_32} 0
			random_inst.random_glibc2_type.size := {PD_RANDOM128_STATE_T}.sizeof.to_natural_32
			random_inst.random_glibc2_type.set := random_inst.random128_glibc2_set_address
			random_inst.random_glibc2_type.get := random_inst.random128_get_address
			random_inst.random_glibc2_type.get_double := random_inst.random128_get_double_address
			random_inst.random8_glibc2_type.name := ce_string ("random8-glibc2")
			random_inst.random8_glibc2_type.max := {NATURAL_32} 2147483647
			random_inst.random8_glibc2_type.min := {NATURAL_32} 0
			random_inst.random8_glibc2_type.size := {PD_RANDOM8_STATE_T}.sizeof.to_natural_32
			random_inst.random8_glibc2_type.set := random_inst.random8_glibc2_set_address
			random_inst.random8_glibc2_type.get := random_inst.random8_get_address
			random_inst.random8_glibc2_type.get_double := random_inst.random8_get_double_address
			random_inst.random32_glibc2_type.name := ce_string ("random32-glibc2")
			random_inst.random32_glibc2_type.max := {NATURAL_32} 2147483647
			random_inst.random32_glibc2_type.min := {NATURAL_32} 0
			random_inst.random32_glibc2_type.size := {PD_RANDOM32_STATE_T}.sizeof.to_natural_32
			random_inst.random32_glibc2_type.set := random_inst.random32_glibc2_set_address
			random_inst.random32_glibc2_type.get := random_inst.random32_get_address
			random_inst.random32_glibc2_type.get_double := random_inst.random32_get_double_address
			random_inst.random64_glibc2_type.name := ce_string ("random64-glibc2")
			random_inst.random64_glibc2_type.max := {NATURAL_32} 2147483647
			random_inst.random64_glibc2_type.min := {NATURAL_32} 0
			random_inst.random64_glibc2_type.size := {PD_RANDOM64_STATE_T}.sizeof.to_natural_32
			random_inst.random64_glibc2_type.set := random_inst.random64_glibc2_set_address
			random_inst.random64_glibc2_type.get := random_inst.random64_get_address
			random_inst.random64_glibc2_type.get_double := random_inst.random64_get_double_address
			random_inst.random128_glibc2_type.name := ce_string ("random128-glibc2")
			random_inst.random128_glibc2_type.max := {NATURAL_32} 2147483647
			random_inst.random128_glibc2_type.min := {NATURAL_32} 0
			random_inst.random128_glibc2_type.size := {PD_RANDOM128_STATE_T}.sizeof.to_natural_32
			random_inst.random128_glibc2_type.set := random_inst.random128_glibc2_set_address
			random_inst.random128_glibc2_type.get := random_inst.random128_get_address
			random_inst.random128_glibc2_type.get_double := random_inst.random128_get_double_address
			random_inst.random256_glibc2_type.name := ce_string ("random256-glibc2")
			random_inst.random256_glibc2_type.max := {NATURAL_32} 2147483647
			random_inst.random256_glibc2_type.min := {NATURAL_32} 0
			random_inst.random256_glibc2_type.size := {PD_RANDOM256_STATE_T}.sizeof.to_natural_32
			random_inst.random256_glibc2_type.set := random_inst.random256_glibc2_set_address
			random_inst.random256_glibc2_type.get := random_inst.random256_get_address
			random_inst.random256_glibc2_type.get_double := random_inst.random256_get_double_address
			random_inst.random_libc5_type.name := ce_string ("random-libc5")
			random_inst.random_libc5_type.max := {NATURAL_32} 2147483647
			random_inst.random_libc5_type.min := {NATURAL_32} 0
			random_inst.random_libc5_type.size := {PD_RANDOM128_STATE_T}.sizeof.to_natural_32
			random_inst.random_libc5_type.set := random_inst.random128_libc5_set_address
			random_inst.random_libc5_type.get := random_inst.random128_get_address
			random_inst.random_libc5_type.get_double := random_inst.random128_get_double_address
			random_inst.random8_libc5_type.name := ce_string ("random8-libc5")
			random_inst.random8_libc5_type.max := {NATURAL_32} 2147483647
			random_inst.random8_libc5_type.min := {NATURAL_32} 0
			random_inst.random8_libc5_type.size := {PD_RANDOM8_STATE_T}.sizeof.to_natural_32
			random_inst.random8_libc5_type.set := random_inst.random8_libc5_set_address
			random_inst.random8_libc5_type.get := random_inst.random8_get_address
			random_inst.random8_libc5_type.get_double := random_inst.random8_get_double_address
			random_inst.random32_libc5_type.name := ce_string ("random32-libc5")
			random_inst.random32_libc5_type.max := {NATURAL_32} 2147483647
			random_inst.random32_libc5_type.min := {NATURAL_32} 0
			random_inst.random32_libc5_type.size := {PD_RANDOM32_STATE_T}.sizeof.to_natural_32
			random_inst.random32_libc5_type.set := random_inst.random32_libc5_set_address
			random_inst.random32_libc5_type.get := random_inst.random32_get_address
			random_inst.random32_libc5_type.get_double := random_inst.random32_get_double_address
			random_inst.random64_libc5_type.name := ce_string ("random64-libc5")
			random_inst.random64_libc5_type.max := {NATURAL_32} 2147483647
			random_inst.random64_libc5_type.min := {NATURAL_32} 0
			random_inst.random64_libc5_type.size := {PD_RANDOM64_STATE_T}.sizeof.to_natural_32
			random_inst.random64_libc5_type.set := random_inst.random64_libc5_set_address
			random_inst.random64_libc5_type.get := random_inst.random64_get_address
			random_inst.random64_libc5_type.get_double := random_inst.random64_get_double_address
			random_inst.random128_libc5_type.name := ce_string ("random128-libc5")
			random_inst.random128_libc5_type.max := {NATURAL_32} 2147483647
			random_inst.random128_libc5_type.min := {NATURAL_32} 0
			random_inst.random128_libc5_type.size := {PD_RANDOM128_STATE_T}.sizeof.to_natural_32
			random_inst.random128_libc5_type.set := random_inst.random128_libc5_set_address
			random_inst.random128_libc5_type.get := random_inst.random128_get_address
			random_inst.random128_libc5_type.get_double := random_inst.random128_get_double_address
			random_inst.random256_libc5_type.name := ce_string ("random256-libc5")
			random_inst.random256_libc5_type.max := {NATURAL_32} 2147483647
			random_inst.random256_libc5_type.min := {NATURAL_32} 0
			random_inst.random256_libc5_type.size := {PD_RANDOM256_STATE_T}.sizeof.to_natural_32
			random_inst.random256_libc5_type.set := random_inst.random256_libc5_set_address
			random_inst.random256_libc5_type.get := random_inst.random256_get_address
			random_inst.random256_libc5_type.get_double := random_inst.random256_get_double_address
			random_inst.random_bsd_type.name := ce_string ("random-bsd")
			random_inst.random_bsd_type.max := {NATURAL_32} 2147483647
			random_inst.random_bsd_type.min := {NATURAL_32} 0
			random_inst.random_bsd_type.size := {PD_RANDOM128_STATE_T}.sizeof.to_natural_32
			random_inst.random_bsd_type.set := random_inst.random128_bsd_set_address
			random_inst.random_bsd_type.get := random_inst.random128_get_address
			random_inst.random_bsd_type.get_double := random_inst.random128_get_double_address
			random_inst.random8_bsd_type.name := ce_string ("random8-bsd")
			random_inst.random8_bsd_type.max := {NATURAL_32} 2147483647
			random_inst.random8_bsd_type.min := {NATURAL_32} 0
			random_inst.random8_bsd_type.size := {PD_RANDOM8_STATE_T}.sizeof.to_natural_32
			random_inst.random8_bsd_type.set := random_inst.random8_bsd_set_address
			random_inst.random8_bsd_type.get := random_inst.random8_get_address
			random_inst.random8_bsd_type.get_double := random_inst.random8_get_double_address
			random_inst.random32_bsd_type.name := ce_string ("random32-bsd")
			random_inst.random32_bsd_type.max := {NATURAL_32} 2147483647
			random_inst.random32_bsd_type.min := {NATURAL_32} 0
			random_inst.random32_bsd_type.size := {PD_RANDOM32_STATE_T}.sizeof.to_natural_32
			random_inst.random32_bsd_type.set := random_inst.random32_bsd_set_address
			random_inst.random32_bsd_type.get := random_inst.random32_get_address
			random_inst.random32_bsd_type.get_double := random_inst.random32_get_double_address
			random_inst.random64_bsd_type.name := ce_string ("random64-bsd")
			random_inst.random64_bsd_type.max := {NATURAL_32} 2147483647
			random_inst.random64_bsd_type.min := {NATURAL_32} 0
			random_inst.random64_bsd_type.size := {PD_RANDOM64_STATE_T}.sizeof.to_natural_32
			random_inst.random64_bsd_type.set := random_inst.random64_bsd_set_address
			random_inst.random64_bsd_type.get := random_inst.random64_get_address
			random_inst.random64_bsd_type.get_double := random_inst.random64_get_double_address
			random_inst.random128_bsd_type.name := ce_string ("random128-bsd")
			random_inst.random128_bsd_type.max := {NATURAL_32} 2147483647
			random_inst.random128_bsd_type.min := {NATURAL_32} 0
			random_inst.random128_bsd_type.size := {PD_RANDOM128_STATE_T}.sizeof.to_natural_32
			random_inst.random128_bsd_type.set := random_inst.random128_bsd_set_address
			random_inst.random128_bsd_type.get := random_inst.random128_get_address
			random_inst.random128_bsd_type.get_double := random_inst.random128_get_double_address
			random_inst.random256_bsd_type.name := ce_string ("random256-bsd")
			random_inst.random256_bsd_type.max := {NATURAL_32} 2147483647
			random_inst.random256_bsd_type.min := {NATURAL_32} 0
			random_inst.random256_bsd_type.size := {PD_RANDOM256_STATE_T}.sizeof.to_natural_32
			random_inst.random256_bsd_type.set := random_inst.random256_bsd_set_address
			random_inst.random256_bsd_type.get := random_inst.random256_get_address
			random_inst.random256_bsd_type.get_double := random_inst.random256_get_double_address
			random_inst.gsl_rng_random_libc5.ce_gets (random_inst.random_libc5_type.address)
			random_inst.gsl_rng_random8_libc5.ce_gets (random_inst.random8_libc5_type.address)
			random_inst.gsl_rng_random32_libc5.ce_gets (random_inst.random32_libc5_type.address)
			random_inst.gsl_rng_random64_libc5.ce_gets (random_inst.random64_libc5_type.address)
			random_inst.gsl_rng_random128_libc5.ce_gets (random_inst.random128_libc5_type.address)
			random_inst.gsl_rng_random256_libc5.ce_gets (random_inst.random256_libc5_type.address)
			random_inst.gsl_rng_random_glibc2.ce_gets (random_inst.random_glibc2_type.address)
			random_inst.gsl_rng_random8_glibc2.ce_gets (random_inst.random8_glibc2_type.address)
			random_inst.gsl_rng_random32_glibc2.ce_gets (random_inst.random32_glibc2_type.address)
			random_inst.gsl_rng_random64_glibc2.ce_gets (random_inst.random64_glibc2_type.address)
			random_inst.gsl_rng_random128_glibc2.ce_gets (random_inst.random128_glibc2_type.address)
			random_inst.gsl_rng_random256_glibc2.ce_gets (random_inst.random256_glibc2_type.address)
			random_inst.gsl_rng_random_bsd.ce_gets (random_inst.random_bsd_type.address)
			random_inst.gsl_rng_random8_bsd.ce_gets (random_inst.random8_bsd_type.address)
			random_inst.gsl_rng_random32_bsd.ce_gets (random_inst.random32_bsd_type.address)
			random_inst.gsl_rng_random64_bsd.ce_gets (random_inst.random64_bsd_type.address)
			random_inst.gsl_rng_random128_bsd.ce_gets (random_inst.random128_bsd_type.address)
			random_inst.gsl_rng_random256_bsd.ce_gets (random_inst.random256_bsd_type.address)
			coveyou_inst.ran_type___8.name := ce_string ("coveyou")
			coveyou_inst.ran_type___8.max := {NATURAL_32} 4294967294
			coveyou_inst.ran_type___8.min := {NATURAL_32} 2
		end

end
