frozen class
	LIBGSL_INITIALIZER_SLICE9

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {LIBGSL_INITIALIZER}

	initialize
		do
			cspline_inst.cspline_type.free := cspline_inst.cspline_free_address
			cspline_inst.gsl_interp_cspline.ce_gets (cspline_inst.cspline_type.address)
			cspline_inst.cspline_periodic_type.name := ce_string ("cspline-periodic")
			cspline_inst.cspline_periodic_type.min_size := {NATURAL_32} 2
			cspline_inst.cspline_periodic_type.alloc := cspline_inst.cspline_alloc_address
			cspline_inst.cspline_periodic_type.init := cspline_inst.cspline_init_periodic_address
			cspline_inst.cspline_periodic_type.eval := cspline_inst.cspline_eval_address
			cspline_inst.cspline_periodic_type.eval_deriv := cspline_inst.cspline_eval_deriv_address
			cspline_inst.cspline_periodic_type.eval_deriv2 := cspline_inst.cspline_eval_deriv2_address
			cspline_inst.cspline_periodic_type.eval_integ := cspline_inst.cspline_eval_integ_address
			cspline_inst.cspline_periodic_type.free := cspline_inst.cspline_free_address
			cspline_inst.gsl_interp_cspline_periodic.ce_gets (cspline_inst.cspline_periodic_type.address)
			linear_inst.linear_type.name := ce_string ("linear")
			linear_inst.linear_type.min_size := {NATURAL_32} 2
			linear_inst.linear_type.alloc := create {CE_ROUTINE}.make_shared (default_pointer)
			linear_inst.linear_type.init := linear_inst.linear_init_address
			linear_inst.linear_type.eval := linear_inst.linear_eval_address
			linear_inst.linear_type.eval_deriv := linear_inst.linear_eval_deriv_address
			linear_inst.linear_type.eval_deriv2 := linear_inst.linear_eval_deriv2_address
			linear_inst.linear_type.eval_integ := linear_inst.linear_eval_integ_address
			linear_inst.linear_type.free := create {CE_ROUTINE}.make_shared (default_pointer)
			linear_inst.gsl_interp_linear.ce_gets (linear_inst.linear_type.address)
			poly_inst.polynomial_type.name := ce_string ("polynomial")
			poly_inst.polynomial_type.min_size := {NATURAL_32} 3
			poly_inst.polynomial_type.alloc := poly_inst.polynomial_alloc_address
			poly_inst.polynomial_type.init := poly_inst.polynomial_init_address
			poly_inst.polynomial_type.eval := poly_inst.polynomial_eval_address
			poly_inst.polynomial_type.eval_deriv := poly_inst.polynomial_deriv_address
			poly_inst.polynomial_type.eval_deriv2 := poly_inst.polynomial_deriv2_address
			poly_inst.polynomial_type.eval_integ := poly_inst.polynomial_integ_address
			poly_inst.polynomial_type.free := poly_inst.polynomial_free_address
			poly_inst.gsl_interp_polynomial.ce_gets (poly_inst.polynomial_type.address)
			akima_inst.akima_type.name := ce_string ("akima")
			akima_inst.akima_type.min_size := {NATURAL_32} 5
			akima_inst.akima_type.alloc := akima_inst.akima_alloc_address
			akima_inst.akima_type.init := akima_inst.akima_init_address
			akima_inst.akima_type.eval := akima_inst.akima_eval_address
			akima_inst.akima_type.eval_deriv := akima_inst.akima_eval_deriv_address
			akima_inst.akima_type.eval_deriv2 := akima_inst.akima_eval_deriv2_address
			akima_inst.akima_type.eval_integ := akima_inst.akima_eval_integ_address
			akima_inst.akima_type.free := akima_inst.akima_free_address
			akima_inst.gsl_interp_akima.ce_gets (akima_inst.akima_type.address)
			akima_inst.akima_periodic_type.name := ce_string ("akima-periodic")
			akima_inst.akima_periodic_type.min_size := {NATURAL_32} 5
			akima_inst.akima_periodic_type.alloc := akima_inst.akima_alloc_address
			akima_inst.akima_periodic_type.init := akima_inst.akima_init_periodic_address
			akima_inst.akima_periodic_type.eval := akima_inst.akima_eval_address
			akima_inst.akima_periodic_type.eval_deriv := akima_inst.akima_eval_deriv_address
			akima_inst.akima_periodic_type.eval_deriv2 := akima_inst.akima_eval_deriv2_address
			akima_inst.akima_periodic_type.eval_integ := akima_inst.akima_eval_integ_address
			akima_inst.akima_periodic_type.free := akima_inst.akima_free_address
			akima_inst.gsl_interp_akima_periodic.ce_gets (akima_inst.akima_periodic_type.address);
			(exponential_inst.mvl_tab[0])[0].k := 5;
			(exponential_inst.mvl_tab[0])[0].j := 1;
			(exponential_inst.mvl_tab[0])[1].k := 5;
			(exponential_inst.mvl_tab[0])[1].j := 4;
			(exponential_inst.mvl_tab[0])[2].k := 7;
			(exponential_inst.mvl_tab[0])[2].j := 5;
			(exponential_inst.mvl_tab[0])[3].k := 9;
			(exponential_inst.mvl_tab[0])[3].j := 7;
			(exponential_inst.mvl_tab[0])[4].k := 10;
			(exponential_inst.mvl_tab[0])[4].j := 10;
			(exponential_inst.mvl_tab[0])[5].k := 8;
			(exponential_inst.mvl_tab[0])[5].j := 14;
			(exponential_inst.mvl_tab[1])[0].k := 2;
			(exponential_inst.mvl_tab[1])[0].j := 1;
			(exponential_inst.mvl_tab[1])[1].k := 4;
			(exponential_inst.mvl_tab[1])[1].j := 0;
			(exponential_inst.mvl_tab[1])[2].k := 7;
			(exponential_inst.mvl_tab[1])[2].j := 1;
			(exponential_inst.mvl_tab[1])[3].k := 6;
			(exponential_inst.mvl_tab[1])[3].j := 5;
			(exponential_inst.mvl_tab[1])[4].k := 5;
			(exponential_inst.mvl_tab[1])[4].j := 9;
			(exponential_inst.mvl_tab[1])[5].k := 7;
			(exponential_inst.mvl_tab[1])[5].j := 11;
			(exponential_inst.mvl_tab[2])[0].k := 1;
			(exponential_inst.mvl_tab[2])[0].j := 0;
			(exponential_inst.mvl_tab[2])[1].k := 3;
			(exponential_inst.mvl_tab[2])[1].j := 0;
			(exponential_inst.mvl_tab[2])[2].k := 5;
			(exponential_inst.mvl_tab[2])[2].j := 1;
			(exponential_inst.mvl_tab[2])[3].k := 4;
			(exponential_inst.mvl_tab[2])[3].j := 5;
			(exponential_inst.mvl_tab[2])[4].k := 4;
			(exponential_inst.mvl_tab[2])[4].j := 8;
			(exponential_inst.mvl_tab[2])[5].k := 2;
			(exponential_inst.mvl_tab[2])[5].j := 11
			quad_golden_inst.quad_golden_type.name := ce_string ("quad-golden")
			quad_golden_inst.quad_golden_type.size := {PD_QUAD_GOLDEN_STATE_T}.sizeof.to_natural_32
			quad_golden_inst.quad_golden_type.set := quad_golden_inst.quad_golden_init_address
			quad_golden_inst.quad_golden_type.iterate := quad_golden_inst.quad_golden_iterate_address
			quad_golden_inst.gsl_min_fminimizer_quad_golden.ce_gets (quad_golden_inst.quad_golden_type.address)
			golden_inst.goldensection_type.name := ce_string ("goldensection")
			golden_inst.goldensection_type.size := {PD_GOLDENSECTION_STATE_T}.sizeof.to_natural_32
			golden_inst.goldensection_type.set := golden_inst.goldensection_init_address
			golden_inst.goldensection_type.iterate := golden_inst.goldensection_iterate_address
			golden_inst.gsl_min_fminimizer_goldensection.ce_gets (golden_inst.goldensection_type.address)
			brent_inst.brent_type.name := ce_string ("brent")
			brent_inst.brent_type.size := {PD_BRENT_STATE_T}.sizeof.to_natural_32
			brent_inst.brent_type.set := brent_inst.brent_init_address
			brent_inst.brent_type.iterate := brent_inst.brent_iterate_address
			brent_inst.gsl_min_fminimizer_brent.ce_gets (brent_inst.brent_type.address)
			lmder_inst.lmder_type.name := ce_string ("lmder")
			lmder_inst.lmder_type.size := {PD_LMDER_STATE_T}.sizeof.to_natural_32
			lmder_inst.lmder_type.alloc := lmder_inst.lmder_alloc_address
			lmder_inst.lmder_type.set := lmder_inst.lmder_set_address
			lmder_inst.lmder_type.iterate := lmder_inst.lmder_iterate_address
			lmder_inst.lmder_type.free := lmder_inst.lmder_free_address
			lmder_inst.lmsder_type.name := ce_string ("lmsder")
			lmder_inst.lmsder_type.size := {PD_LMDER_STATE_T}.sizeof.to_natural_32
			lmder_inst.lmsder_type.alloc := lmder_inst.lmder_alloc_address
			lmder_inst.lmsder_type.set := lmder_inst.lmsder_set_address
			lmder_inst.lmsder_type.iterate := lmder_inst.lmsder_iterate_address
			lmder_inst.lmsder_type.free := lmder_inst.lmder_free_address
			lmder_inst.gsl_multifit_fdfsolver_lmder.ce_gets (lmder_inst.lmder_type.address)
			lmder_inst.gsl_multifit_fdfsolver_lmsder.ce_gets (lmder_inst.lmsder_type.address)
			simplex_inst.nmsimplex_type.name := ce_string ("nmsimplex")
			simplex_inst.nmsimplex_type.size := {PD_NMSIMPLEX_STATE_T}.sizeof.to_natural_32
			simplex_inst.nmsimplex_type.alloc := simplex_inst.nmsimplex_alloc_address
			simplex_inst.nmsimplex_type.set := simplex_inst.nmsimplex_set_address
			simplex_inst.nmsimplex_type.iterate := simplex_inst.nmsimplex_iterate_address
			simplex_inst.nmsimplex_type.free := simplex_inst.nmsimplex_free_address
			simplex_inst.gsl_multimin_fminimizer_nmsimplex.ce_gets (simplex_inst.nmsimplex_type.address)
			vector_bfgs_inst.vector_bfgs_type.name := ce_string ("vector_bfgs")
			vector_bfgs_inst.vector_bfgs_type.size := {PD_VECTOR_BFGS_STATE_T}.sizeof.to_natural_32
			vector_bfgs_inst.vector_bfgs_type.alloc := vector_bfgs_inst.vector_bfgs_alloc_address
			vector_bfgs_inst.vector_bfgs_type.set := vector_bfgs_inst.vector_bfgs_set_address
			vector_bfgs_inst.vector_bfgs_type.iterate := vector_bfgs_inst.vector_bfgs_iterate_address
			vector_bfgs_inst.vector_bfgs_type.restart := vector_bfgs_inst.vector_bfgs_restart_address
			vector_bfgs_inst.vector_bfgs_type.free := vector_bfgs_inst.vector_bfgs_free_address
			vector_bfgs_inst.gsl_multimin_fdfminimizer_vector_bfgs.ce_gets (vector_bfgs_inst.vector_bfgs_type.address)
			conjugate_pr_inst.conjugate_pr_type.name := ce_string ("conjugate_pr")
			conjugate_pr_inst.conjugate_pr_type.size := {PD_CONJUGATE_PR_STATE_T}.sizeof.to_natural_32
			conjugate_pr_inst.conjugate_pr_type.alloc := conjugate_pr_inst.conjugate_pr_alloc_address
			conjugate_pr_inst.conjugate_pr_type.set := conjugate_pr_inst.conjugate_pr_set_address
			conjugate_pr_inst.conjugate_pr_type.iterate := conjugate_pr_inst.conjugate_pr_iterate_address
			conjugate_pr_inst.conjugate_pr_type.restart := conjugate_pr_inst.conjugate_pr_restart_address
			conjugate_pr_inst.conjugate_pr_type.free := conjugate_pr_inst.conjugate_pr_free_address
			conjugate_pr_inst.gsl_multimin_fdfminimizer_conjugate_pr.ce_gets (conjugate_pr_inst.conjugate_pr_type.address)
			steepest_descent_inst.steepest_descent_type.name := ce_string ("steepest_descent")
			steepest_descent_inst.steepest_descent_type.size := {PD_STEEPEST_DESCENT_STATE_T}.sizeof.to_natural_32
			steepest_descent_inst.steepest_descent_type.alloc := steepest_descent_inst.steepest_descent_alloc_address
			steepest_descent_inst.steepest_descent_type.set := steepest_descent_inst.steepest_descent_set_address
			steepest_descent_inst.steepest_descent_type.iterate := steepest_descent_inst.steepest_descent_iterate_address
			steepest_descent_inst.steepest_descent_type.restart := steepest_descent_inst.steepest_descent_restart_address
			steepest_descent_inst.steepest_descent_type.free := steepest_descent_inst.steepest_descent_free_address
			steepest_descent_inst.gsl_multimin_fdfminimizer_steepest_descent.ce_gets (steepest_descent_inst.steepest_descent_type.address)
			conjugate_fr_inst.conjugate_fr_type.name := ce_string ("conjugate_fr")
			conjugate_fr_inst.conjugate_fr_type.size := {PD_CONJUGATE_FR_STATE_T}.sizeof.to_natural_32
			conjugate_fr_inst.conjugate_fr_type.alloc := conjugate_fr_inst.conjugate_fr_alloc_address
			conjugate_fr_inst.conjugate_fr_type.set := conjugate_fr_inst.conjugate_fr_set_address
			conjugate_fr_inst.conjugate_fr_type.iterate := conjugate_fr_inst.conjugate_fr_iterate_address
			conjugate_fr_inst.conjugate_fr_type.restart := conjugate_fr_inst.conjugate_fr_restart_address
			conjugate_fr_inst.conjugate_fr_type.free := conjugate_fr_inst.conjugate_fr_free_address
			conjugate_fr_inst.gsl_multimin_fdfminimizer_conjugate_fr.ce_gets (conjugate_fr_inst.conjugate_fr_type.address)
			vector_bfgs2_inst.vector_bfgs2_type.name := ce_string ("vector_bfgs2")
			vector_bfgs2_inst.vector_bfgs2_type.size := {PD_VECTOR_BFGS2_STATE_T}.sizeof.to_natural_32
			vector_bfgs2_inst.vector_bfgs2_type.alloc := vector_bfgs2_inst.vector_bfgs2_alloc_address
			vector_bfgs2_inst.vector_bfgs2_type.set := vector_bfgs2_inst.vector_bfgs2_set_address
			vector_bfgs2_inst.vector_bfgs2_type.iterate := vector_bfgs2_inst.vector_bfgs2_iterate_address
			vector_bfgs2_inst.vector_bfgs2_type.restart := vector_bfgs2_inst.vector_bfgs2_restart_address
			vector_bfgs2_inst.vector_bfgs2_type.free := vector_bfgs2_inst.vector_bfgs2_free_address
			vector_bfgs2_inst.gsl_multimin_fdfminimizer_vector_bfgs2.ce_gets (vector_bfgs2_inst.vector_bfgs2_type.address)
			simplex2_inst.nmsimplex_type___0.name := ce_string ("nmsimplex2")
			simplex2_inst.nmsimplex_type___0.size := {PD_NMSIMPLEX_STATE_T_119__}.sizeof.to_natural_32
			simplex2_inst.nmsimplex_type___0.alloc := simplex2_inst.nmsimplex_alloc___0_address
			simplex2_inst.nmsimplex_type___0.set := simplex2_inst.nmsimplex_set___0_address
			simplex2_inst.nmsimplex_type___0.iterate := simplex2_inst.nmsimplex_iterate___0_address
			simplex2_inst.nmsimplex_type___0.free := simplex2_inst.nmsimplex_free___0_address
			simplex2_inst.gsl_multimin_fminimizer_nmsimplex2.ce_gets (simplex2_inst.nmsimplex_type___0.address)
			simplex2_inst.nmsimplex2rand_type.name := ce_string ("nmsimplex2rand")
			simplex2_inst.nmsimplex2rand_type.size := {PD_NMSIMPLEX_STATE_T_119__}.sizeof.to_natural_32
			simplex2_inst.nmsimplex2rand_type.alloc := simplex2_inst.nmsimplex_alloc___0_address
			simplex2_inst.nmsimplex2rand_type.set := simplex2_inst.nmsimplex_set_rand_address
			simplex2_inst.nmsimplex2rand_type.iterate := simplex2_inst.nmsimplex_iterate___0_address
			simplex2_inst.nmsimplex2rand_type.free := simplex2_inst.nmsimplex_free___0_address
			simplex2_inst.gsl_multimin_fminimizer_nmsimplex2rand.ce_gets (simplex2_inst.nmsimplex2rand_type.address)
			newton_inst.newton_type.name := ce_string ("newton")
			newton_inst.newton_type.size := {PD_NEWTON_STATE_T}.sizeof.to_natural_32
			newton_inst.newton_type.alloc := newton_inst.newton_alloc_address
			newton_inst.newton_type.set := newton_inst.newton_set_address
			newton_inst.newton_type.iterate := newton_inst.newton_iterate_address
			newton_inst.newton_type.free := newton_inst.newton_free_address
			newton_inst.gsl_multiroot_fdfsolver_newton.ce_gets (newton_inst.newton_type.address)
			gnewton_inst.gnewton_type.name := ce_string ("gnewton")
			gnewton_inst.gnewton_type.size := {PD_GNEWTON_STATE_T}.sizeof.to_natural_32
			gnewton_inst.gnewton_type.alloc := gnewton_inst.gnewton_alloc_address
			gnewton_inst.gnewton_type.set := gnewton_inst.gnewton_set_address
			gnewton_inst.gnewton_type.iterate := gnewton_inst.gnewton_iterate_address
			gnewton_inst.gnewton_type.free := gnewton_inst.gnewton_free_address
			gnewton_inst.gsl_multiroot_fdfsolver_gnewton.ce_gets (gnewton_inst.gnewton_type.address)
			hybridj_inst.hybridj_type.name := ce_string ("hybridj")
			hybridj_inst.hybridj_type.size := {PD_HYBRIDJ_STATE_T}.sizeof.to_natural_32
			hybridj_inst.hybridj_type.alloc := hybridj_inst.hybridj_alloc_address
			hybridj_inst.hybridj_type.set := hybridj_inst.hybridj_set_address
			hybridj_inst.hybridj_type.iterate := hybridj_inst.hybridj_iterate_address
			hybridj_inst.hybridj_type.free := hybridj_inst.hybridj_free_address
			hybridj_inst.hybridsj_type.name := ce_string ("hybridsj")
			hybridj_inst.hybridsj_type.size := {PD_HYBRIDJ_STATE_T}.sizeof.to_natural_32
			hybridj_inst.hybridsj_type.alloc := hybridj_inst.hybridj_alloc_address
			hybridj_inst.hybridsj_type.set := hybridj_inst.hybridsj_set_address
			hybridj_inst.hybridsj_type.iterate := hybridj_inst.hybridsj_iterate_address
			hybridj_inst.hybridsj_type.free := hybridj_inst.hybridj_free_address
			hybridj_inst.gsl_multiroot_fdfsolver_hybridj.ce_gets (hybridj_inst.hybridj_type.address)
			hybridj_inst.gsl_multiroot_fdfsolver_hybridsj.ce_gets (hybridj_inst.hybridsj_type.address)
			hybrid_inst.hybrid_type.name := ce_string ("hybrid")
			hybrid_inst.hybrid_type.size := {PD_HYBRID_STATE_T}.sizeof.to_natural_32
			hybrid_inst.hybrid_type.alloc := hybrid_inst.hybrid_alloc_address
			hybrid_inst.hybrid_type.set := hybrid_inst.hybrid_set_address
			hybrid_inst.hybrid_type.iterate := hybrid_inst.hybrid_iterate_address
			hybrid_inst.hybrid_type.free := hybrid_inst.hybrid_free_address
			hybrid_inst.hybrids_type.name := ce_string ("hybrids")
			hybrid_inst.hybrids_type.size := {PD_HYBRID_STATE_T}.sizeof.to_natural_32
			hybrid_inst.hybrids_type.alloc := hybrid_inst.hybrid_alloc_address
			hybrid_inst.hybrids_type.set := hybrid_inst.hybrids_set_address
			hybrid_inst.hybrids_type.iterate := hybrid_inst.hybrids_iterate_address
			hybrid_inst.hybrids_type.free := hybrid_inst.hybrid_free_address
			hybrid_inst.gsl_multiroot_fsolver_hybrid.ce_gets (hybrid_inst.hybrid_type.address)
			hybrid_inst.gsl_multiroot_fsolver_hybrids.ce_gets (hybrid_inst.hybrids_type.address)
			dnewton_inst.dnewton_type.name := ce_string ("dnewton")
			dnewton_inst.dnewton_type.size := {PD_DNEWTON_STATE_T}.sizeof.to_natural_32
			dnewton_inst.dnewton_type.alloc := dnewton_inst.dnewton_alloc_address
			dnewton_inst.dnewton_type.set := dnewton_inst.dnewton_set_address
			dnewton_inst.dnewton_type.iterate := dnewton_inst.dnewton_iterate_address
			dnewton_inst.dnewton_type.free := dnewton_inst.dnewton_free_address
			dnewton_inst.gsl_multiroot_fsolver_dnewton.ce_gets (dnewton_inst.dnewton_type.address)
			broyden_inst.broyden_type.name := ce_string ("broyden")
			broyden_inst.broyden_type.size := {PD_BROYDEN_STATE_T}.sizeof.to_natural_32
			broyden_inst.broyden_type.alloc := broyden_inst.broyden_alloc_address
			broyden_inst.broyden_type.set := broyden_inst.broyden_set_address
			broyden_inst.broyden_type.iterate := broyden_inst.broyden_iterate_address
			broyden_inst.broyden_type.free := broyden_inst.broyden_free_address
			broyden_inst.gsl_multiroot_fsolver_broyden.ce_gets (broyden_inst.broyden_type.address)
			rk8pd_inst.Abar[0] := (14005451.0 / 335480064.0)
			rk8pd_inst.Abar[1] := 0.0
			rk8pd_inst.Abar[2] := 0.0
			rk8pd_inst.Abar[3] := 0.0
			rk8pd_inst.Abar[4] := 0.0
			rk8pd_inst.Abar[5] := (-59238493.0 / 1068277825.0)
			rk8pd_inst.Abar[6] := (181606767.0 / 758867731.0)
			rk8pd_inst.Abar[7] := (561292985.0 / 797845732.0)
			rk8pd_inst.Abar[8] := (-1041891430.0 / 1371343529.0)
			rk8pd_inst.Abar[9] := (760417239.0 / 1151165299.0)
			rk8pd_inst.Abar[10] := (118820643.0 / 751138087.0)
			rk8pd_inst.Abar[11] := (-528747749.0 / 2220607170.0)
			rk8pd_inst.Abar[12] := (1.0 / 4.0)
			rk8pd_inst.A[0] := (13451932.0 / 455176623.0)
			rk8pd_inst.A[1] := 0.0
			rk8pd_inst.A[2] := 0.0
			rk8pd_inst.A[3] := 0.0
			rk8pd_inst.A[4] := 0.0
			rk8pd_inst.A[5] := (-808719846.0 / 976000145.0)
			rk8pd_inst.A[6] := (1757004468.0 / 5645159321.0)
			rk8pd_inst.A[7] := (656045339.0 / 265891186.0)
			rk8pd_inst.A[8] := (-3867574721.0 / 1518517206.0)
			rk8pd_inst.A[9] := (465885868.0 / 322736535.0)
			rk8pd_inst.A[10] := (53011238.0 / 667516719.0)
			rk8pd_inst.A[11] := (2.0 / 45.0)
			rk8pd_inst.ah[0] := (1.0 / 18.0)
			rk8pd_inst.ah[1] := (1.0 / 12.0)
			rk8pd_inst.ah[2] := (1.0 / 8.0)
			rk8pd_inst.ah[3] := (5.0 / 16.0)
			rk8pd_inst.ah[4] := (3.0 / 8.0)
			rk8pd_inst.ah[5] := (59.0 / 400.0)
			rk8pd_inst.ah[6] := (93.0 / 200.0)
			rk8pd_inst.ah[7] := (5490023248.0 / 9719169821.0)
			rk8pd_inst.ah[8] := (13.0 / 20.0)
			rk8pd_inst.ah[9] := (1201146811.0 / 1299019798.0)
			rk8pd_inst.b21 := (1.0 / 18.0)
			rk8pd_inst.b3[0] := (1.0 / 48.0)
			rk8pd_inst.b3[1] := (1.0 / 16.0)
			rk8pd_inst.b4[0] := (1.0 / 32.0)
			rk8pd_inst.b4[1] := 0.0
			rk8pd_inst.b4[2] := (3.0 / 32.0)
			rk8pd_inst.b5[0] := (5.0 / 16.0)
			rk8pd_inst.b5[1] := 0.0
			rk8pd_inst.b5[2] := (-75.0 / 64.0)
			rk8pd_inst.b5[3] := (75.0 / 64.0)
			rk8pd_inst.b6[0] := (3.0 / 80.0)
			rk8pd_inst.b6[1] := 0.0
			rk8pd_inst.b6[2] := 0.0
			rk8pd_inst.b6[3] := (3.0 / 16.0)
			rk8pd_inst.b6[4] := (3.0 / 20.0)
			rk8pd_inst.b7[0] := (29443841.0 / 614563906.0)
			rk8pd_inst.b7[1] := 0.0
			rk8pd_inst.b7[2] := 0.0
			rk8pd_inst.b7[3] := (77736538.0 / 692538347.0)
			rk8pd_inst.b7[4] := (-28693883.0 / 1125000000.0)
			rk8pd_inst.b7[5] := (23124283.0 / 1800000000.0)
			rk8pd_inst.b8[0] := (16016141.0 / 946692911.0)
			rk8pd_inst.b8[1] := 0.0
			rk8pd_inst.b8[2] := 0.0
			rk8pd_inst.b8[3] := (61564180.0 / 158732637.0)
			rk8pd_inst.b8[4] := (22789713.0 / 633445777.0)
			rk8pd_inst.b8[5] := (545815736.0 / 2771057229.0)
			rk8pd_inst.b8[6] := (-180193667.0 / 1043307555.0)
			rk8pd_inst.b9[0] := (39632708.0 / 573591083.0)
			rk8pd_inst.b9[1] := 0.0
			rk8pd_inst.b9[2] := 0.0
			rk8pd_inst.b9[3] := (-433636366.0 / 683701615.0)
			rk8pd_inst.b9[4] := (-421739975.0 / 2616292301.0)
			rk8pd_inst.b9[5] := (100302831.0 / 723423059.0)
			rk8pd_inst.b9[6] := (790204164.0 / 839813087.0)
			rk8pd_inst.b9[7] := (800635310.0 / 3783071287.0)
			rk8pd_inst.b10[0] := (246121993.0 / 1340847787.0)
			rk8pd_inst.b10[1] := 0.0
			rk8pd_inst.b10[2] := 0.0
			rk8pd_inst.b10[3] := (-37695042795.0 / 15268766246.0)
			rk8pd_inst.b10[4] := (-309121744.0 / 1061227803.0)
			rk8pd_inst.b10[5] := (-12992083.0 / 490766935.0)
			rk8pd_inst.b10[6] := (6005943493.0 / 2108947869.0)
			rk8pd_inst.b10[7] := (393006217.0 / 1396673457.0)
			rk8pd_inst.b10[8] := (123872331.0 / 1001029789.0)
			rk8pd_inst.b11[0] := (-1028468189.0 / 846180014.0)
			rk8pd_inst.b11[1] := 0.0
			rk8pd_inst.b11[2] := 0.0
			rk8pd_inst.b11[3] := (8478235783.0 / 508512852.0)
			rk8pd_inst.b11[4] := (1311729495.0 / 1432422823.0)
			rk8pd_inst.b11[5] := (-10304129995.0 / 1701304382.0)
			rk8pd_inst.b11[6] := (-48777925059.0 / 3047939560.0)
			rk8pd_inst.b11[7] := (15336726248.0 / 1032824649.0)
			rk8pd_inst.b11[8] := (-45442868181.0 / 3398467696.0)
			rk8pd_inst.b11[9] := (3065993473.0 / 597172653.0)
			rk8pd_inst.b12[0] := (185892177.0 / 718116043.0)
			rk8pd_inst.b12[1] := 0.0
			rk8pd_inst.b12[2] := 0.0
			rk8pd_inst.b12[3] := (-3185094517.0 / 667107341.0)
			rk8pd_inst.b12[4] := (-477755414.0 / 1098053517.0)
			rk8pd_inst.b12[5] := (-703635378.0 / 230739211.0)
			rk8pd_inst.b12[6] := (5731566787.0 / 1027545527.0)
			rk8pd_inst.b12[7] := (5232866602.0 / 850066563.0)
			rk8pd_inst.b12[8] := (-4093664535.0 / 808688257.0)
			rk8pd_inst.b12[9] := (3962137247.0 / 1805957418.0)
			rk8pd_inst.b12[10] := (65686358.0 / 487910083.0)
			rk8pd_inst.b13[0] := (403863854.0 / 491063109.0)
			rk8pd_inst.b13[1] := 0.0
			rk8pd_inst.b13[2] := 0.0
			rk8pd_inst.b13[3] := (-5068492393.0 / 434740067.0)
			rk8pd_inst.b13[4] := (-411421997.0 / 543043805.0)
			rk8pd_inst.b13[5] := (652783627.0 / 914296604.0)
			rk8pd_inst.b13[6] := (11173962825.0 / 925320556.0)
			rk8pd_inst.b13[7] := (-13158990841.0 / 6184727034.0)
			rk8pd_inst.b13[8] := (3936647629.0 / 1978049680.0)
			rk8pd_inst.b13[9] := (-160528059.0 / 685178525.0)
			rk8pd_inst.b13[10] := (248638103.0 / 1413531060.0)
			rk8pd_inst.b13[11] := 0.0
			rk8pd_inst.rk8pd_type.name := ce_string ("rk8pd")
			rk8pd_inst.rk8pd_type.can_use_dydt_in := 1
			rk8pd_inst.rk8pd_type.gives_exact_dydt_out := 1
			rk8pd_inst.rk8pd_type.alloc := rk8pd_inst.rk8pd_alloc_address
			rk8pd_inst.rk8pd_type.apply := rk8pd_inst.rk8pd_apply_address
			rk8pd_inst.rk8pd_type.reset := rk8pd_inst.rk8pd_reset_address
			rk8pd_inst.rk8pd_type.order := rk8pd_inst.rk8pd_order_address
			rk8pd_inst.rk8pd_type.free := rk8pd_inst.rk8pd_free_address
			rk8pd_inst.gsl_odeiv_step_rk8pd.ce_gets (rk8pd_inst.rk8pd_type.address)
			rkck_inst.ah___0[0] := (1.0 / 5.0)
			rkck_inst.ah___0[1] := 0.3
			rkck_inst.ah___0[2] := (3.0 / 5.0)
			rkck_inst.ah___0[3] := 1.0
			rkck_inst.ah___0[4] := (7.0 / 8.0)
			rkck_inst.b21___0 := (1.0 / 5.0)
			rkck_inst.b3___0[0] := (3.0 / 40.0)
			rkck_inst.b3___0[1] := (9.0 / 40.0)
			rkck_inst.b4___0[0] := 0.3
			rkck_inst.b4___0[1] := (-0.9)
			rkck_inst.b4___0[2] := 1.2
			rkck_inst.b5___0[0] := (-11.0 / 54.0)
			rkck_inst.b5___0[1] := 2.5
			rkck_inst.b5___0[2] := (-70.0 / 27.0)
			rkck_inst.b5___0[3] := (35.0 / 27.0)
			rkck_inst.b6___0[0] := (1631.0 / 55296.0)
			rkck_inst.b6___0[1] := (175.0 / 512.0)
			rkck_inst.b6___0[2] := (575.0 / 13824.0)
			rkck_inst.b6___0[3] := (44275.0 / 110592.0)
			rkck_inst.b6___0[4] := (253.0 / 4096.0)
			rkck_inst.c1 := (37.0 / 378.0)
			rkck_inst.c3 := (250.0 / 621.0)
			rkck_inst.c4 := (125.0 / 594.0)
			rkck_inst.c6 := (512.0 / 1771.0)
			rkck_inst.ec[0] := 0.0
			rkck_inst.ec[1] := (37.0 / 378.0 - 2825.0 / 27648.0)
			rkck_inst.ec[2] := 0.0
			rkck_inst.ec[3] := (250.0 / 621.0 - 18575.0 / 48384.0)
			rkck_inst.ec[4] := (125.0 / 594.0 - 13525.0 / 55296.0)
			rkck_inst.ec[5] := (-277.0 / 14336.0)
			rkck_inst.ec[6] := (512.0 / 1771.0 - 0.25)
			rkck_inst.rkck_type.name := ce_string ("rkck")
			rkck_inst.rkck_type.can_use_dydt_in := 1
			rkck_inst.rkck_type.gives_exact_dydt_out := 1
			rkck_inst.rkck_type.alloc := rkck_inst.rkck_alloc_address
			rkck_inst.rkck_type.apply := rkck_inst.rkck_apply_address
			rkck_inst.rkck_type.reset := rkck_inst.rkck_reset_address
			rkck_inst.rkck_type.order := rkck_inst.rkck_order_address
			rkck_inst.rkck_type.free := rkck_inst.rkck_free_address
			rkck_inst.gsl_odeiv_step_rkck.ce_gets (rkck_inst.rkck_type.address)
			rk2imp_inst.rk2imp_type.name := ce_string ("rk2imp")
			rk2imp_inst.rk2imp_type.can_use_dydt_in := 1
			rk2imp_inst.rk2imp_type.gives_exact_dydt_out := 1
			rk2imp_inst.rk2imp_type.alloc := rk2imp_inst.rk2imp_alloc_address
			rk2imp_inst.rk2imp_type.apply := rk2imp_inst.rk2imp_apply_address
			rk2imp_inst.rk2imp_type.reset := rk2imp_inst.rk2imp_reset_address
			rk2imp_inst.rk2imp_type.order := rk2imp_inst.rk2imp_order_address
			rk2imp_inst.rk2imp_type.free := rk2imp_inst.rk2imp_free_address
			rk2imp_inst.gsl_odeiv_step_rk2imp.ce_gets (rk2imp_inst.rk2imp_type.address)
			cstd_inst.std_control_type.name := ce_string ("standard")
			cstd_inst.std_control_type.alloc := cstd_inst.std_control_alloc_address
			cstd_inst.std_control_type.init := cstd_inst.std_control_init_address
			cstd_inst.std_control_type.hadjust := cstd_inst.std_control_hadjust_address
			cstd_inst.std_control_type.free := cstd_inst.std_control_free_address
			cstd_inst.gsl_odeiv_control_standard.ce_gets (cstd_inst.std_control_type.address)
			rk2_inst.rk2_type.name := ce_string ("rk2")
			rk2_inst.rk2_type.can_use_dydt_in := 1
			rk2_inst.rk2_type.gives_exact_dydt_out := 1
			rk2_inst.rk2_type.alloc := rk2_inst.rk2_alloc_address
			rk2_inst.rk2_type.apply := rk2_inst.rk2_apply_address
			rk2_inst.rk2_type.reset := rk2_inst.rk2_reset_address
			rk2_inst.rk2_type.order := rk2_inst.rk2_order_address
			rk2_inst.rk2_type.free := rk2_inst.rk2_free_address
			rk2_inst.gsl_odeiv_step_rk2.ce_gets (rk2_inst.rk2_type.address)
			gear1_inst.gear1_type.name := ce_string ("gear1")
			gear1_inst.gear1_type.can_use_dydt_in := 0
			gear1_inst.gear1_type.gives_exact_dydt_out := 1
			gear1_inst.gear1_type.alloc := gear1_inst.gear1_alloc_address
			gear1_inst.gear1_type.apply := gear1_inst.gear1_apply_address
			gear1_inst.gear1_type.reset := gear1_inst.gear1_reset_address
			gear1_inst.gear1_type.order := gear1_inst.gear1_order_address
			gear1_inst.gear1_type.free := gear1_inst.gear1_free_address
			gear1_inst.gsl_odeiv_step_gear1.ce_gets (gear1_inst.gear1_type.address)
			rk2simp_inst.rk2simp_type.name := ce_string ("rk2simp")
			rk2simp_inst.rk2simp_type.can_use_dydt_in := 0
			rk2simp_inst.rk2simp_type.gives_exact_dydt_out := 1
			rk2simp_inst.rk2simp_type.alloc := rk2simp_inst.rk2simp_alloc_address
			rk2simp_inst.rk2simp_type.apply := rk2simp_inst.rk2simp_apply_address
			rk2simp_inst.rk2simp_type.reset := rk2simp_inst.rk2simp_reset_address
			rk2simp_inst.rk2simp_type.order := rk2simp_inst.rk2simp_order_address
			rk2simp_inst.rk2simp_type.free := rk2simp_inst.rk2simp_free_address
			rk2simp_inst.gsl_odeiv_step_rk2simp.ce_gets (rk2simp_inst.rk2simp_type.address)
			cscal_inst.sc_control_type.name := ce_string ("scaled")
			cscal_inst.sc_control_type.alloc := cscal_inst.sc_control_alloc_address
			cscal_inst.sc_control_type.init := cscal_inst.sc_control_init_address
			cscal_inst.sc_control_type.hadjust := cscal_inst.sc_control_hadjust_address
			cscal_inst.sc_control_type.free := cscal_inst.sc_control_free_address
			cscal_inst.gsl_odeiv_control_scaled.ce_gets (cscal_inst.sc_control_type.address)
			rk4imp_inst.rk4imp_type.name := ce_string ("rk4imp")
			rk4imp_inst.rk4imp_type.can_use_dydt_in := 1
			rk4imp_inst.rk4imp_type.gives_exact_dydt_out := 1
			rk4imp_inst.rk4imp_type.alloc := rk4imp_inst.rk4imp_alloc_address
			rk4imp_inst.rk4imp_type.apply := rk4imp_inst.rk4imp_apply_address
			rk4imp_inst.rk4imp_type.reset := rk4imp_inst.rk4imp_reset_address
			rk4imp_inst.rk4imp_type.order := rk4imp_inst.rk4imp_order_address
			rk4imp_inst.rk4imp_type.free := rk4imp_inst.rk4imp_free_address
			rk4imp_inst.gsl_odeiv_step_rk4imp.ce_gets (rk4imp_inst.rk4imp_type.address)
			gear2_inst.gear2_type.name := ce_string ("gear2")
			gear2_inst.gear2_type.can_use_dydt_in := 1
			gear2_inst.gear2_type.gives_exact_dydt_out := 0
			gear2_inst.gear2_type.alloc := gear2_inst.gear2_alloc_address
			gear2_inst.gear2_type.apply := gear2_inst.gear2_apply_address
			gear2_inst.gear2_type.reset := gear2_inst.gear2_reset_address
			gear2_inst.gear2_type.order := gear2_inst.gear2_order_address
			gear2_inst.gear2_type.free := gear2_inst.gear2_free_address
			gear2_inst.gsl_odeiv_step_gear2.ce_gets (gear2_inst.gear2_type.address)
			rkf45_inst.ah___1[0] := (1.0 / 4.0)
			rkf45_inst.ah___1[1] := (3.0 / 8.0)
			rkf45_inst.ah___1[2] := (12.0 / 13.0)
			rkf45_inst.ah___1[3] := 1.0
			rkf45_inst.ah___1[4] := (1.0 / 2.0)
			rkf45_inst.b3___1[0] := (3.0 / 32.0)
			rkf45_inst.b3___1[1] := (9.0 / 32.0)
			rkf45_inst.b4___1[0] := (1932.0 / 2197.0)
			rkf45_inst.b4___1[1] := (-7200.0 / 2197.0)
			rkf45_inst.b4___1[2] := (7296.0 / 2197.0)
			rkf45_inst.b5___1[0] := (8341.0 / 4104.0)
			rkf45_inst.b5___1[1] := (-32832.0 / 4104.0)
			rkf45_inst.b5___1[2] := (29440.0 / 4104.0)
			rkf45_inst.b5___1[3] := (-845.0 / 4104.0)
			rkf45_inst.b6___1[0] := (-6080.0 / 20520.0)
			rkf45_inst.b6___1[1] := (41040.0 / 20520.0)
			rkf45_inst.b6___1[2] := (-28352.0 / 20520.0)
			rkf45_inst.b6___1[3] := (9295.0 / 20520.0)
			rkf45_inst.b6___1[4] := (-5643.0 / 20520.0)
			rkf45_inst.c1___0 := (902880.0 / 7618050.0)
			rkf45_inst.c3___0 := (3953664.0 / 7618050.0)
			rkf45_inst.c4___0 := (3855735.0 / 7618050.0)
			rkf45_inst.c5 := (-1371249.0 / 7618050.0)
			rkf45_inst.c6___0 := (277020.0 / 7618050.0)
			rkf45_inst.ec___0[0] := 0.0
			rkf45_inst.ec___0[1] := (1.0 / 360.0)
			rkf45_inst.ec___0[2] := 0.0
			rkf45_inst.ec___0[3] := (-128.0 / 4275.0)
			rkf45_inst.ec___0[4] := (-2197.0 / 75240.0)
			rkf45_inst.ec___0[5] := (1.0 / 50.0)
			rkf45_inst.ec___0[6] := (2.0 / 55.0)
			rkf45_inst.rkf45_type.name := ce_string ("rkf45")
			rkf45_inst.rkf45_type.can_use_dydt_in := 1
			rkf45_inst.rkf45_type.gives_exact_dydt_out := 0
			rkf45_inst.rkf45_type.alloc := rkf45_inst.rkf45_alloc_address
			rkf45_inst.rkf45_type.apply := rkf45_inst.rkf45_apply_address
			rkf45_inst.rkf45_type.reset := rkf45_inst.rkf45_reset_address
			rkf45_inst.rkf45_type.order := rkf45_inst.rkf45_order_address
		end

end
