class
	LIBGSL_ASSEMBLER

feature {NONE}

	asm1 (op1: CE_POINTER [NATURAL_16])
		do
			c_asm1 (op1.c_pointer)
		end

	c_asm1 (op1: POINTER)
		external
			"C inline use <libgsl.h>"
		alias
			"[
				unsigned short mode = *(unsigned short *)$op1;

				__asm__ volatile ("fldcw %0"
						: 
						: "m" (mode)
					);

				*(unsigned short *)$op1 = mode;
			]"
		end

	asm2 (op1: CE_POINTER [NATURAL_32])
		do
			c_asm2 (op1.c_pointer)
		end

	c_asm2 (op1: POINTER)
		external
			"C inline use <libgsl.h>"
		alias
			"[
				unsigned int mode_sse = *(unsigned int *)$op1;

				__asm__ volatile ("ldmxcsr %0"
						: 
						: "m" (mode_sse)
					);

				*(unsigned int *)$op1 = mode_sse;
			]"
		end

end
