class
	P_CHISQINV

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_cdf_chisq_Pinv (a_P___2: REAL_64; a_nu: REAL_64): REAL_64
		do
			Result := (gammainv_inst.gsl_cdf_gamma_Pinv (a_P___2, a_nu / (2).to_double, 2.0))
		end

	gsl_cdf_chisq_Qinv (a_Q___1: REAL_64; a_nu: REAL_64): REAL_64
		do
			Result := (gammainv_inst.gsl_cdf_gamma_Qinv (a_Q___1, a_nu / (2).to_double, 2.0))
		end

end
