class
	P_COMPANION

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	set_companion_matrix (a_a___5: CE_POINTER [REAL_64]; a_nc: NATURAL_32; a_m___4: CE_POINTER [REAL_64])
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			js: JUMP_STATE
		do
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_left and then (l_i < a_nc))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < a_nc)
				loop
					a_m___4[(l_i * a_nc + l_j).to_integer_32] := 0.0
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
			l_i := (1).to_natural_32
			from
			until
				not (l_i < a_nc)
			loop
				a_m___4[(l_i * a_nc + (l_i - {NATURAL_32} 1)).to_integer_32] := 1.0
				l_i := l_i + 1
			end
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_nc)
			loop
				a_m___4[(l_i * a_nc + (a_nc - {NATURAL_32} 1)).to_integer_32] := (-a_a___5[l_i.to_integer_32] / a_a___5[a_nc.to_integer_32])
				l_i := l_i + 1
			end
		end

end
