class
	P_COVEYOU

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create ran_type___8.make
			create gsl_rng_coveyou.make
		end

feature {ANY} -- attributes

	ran_type___8: PD_GSL_RNG_TYPE

	gsl_rng_coveyou: CE_POINTER [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	ran_get___8 (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RAN_STATE_T]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate))
			l_state.item.x := (l_state.item.x * (l_state.item.x + {NATURAL_32} 1)).bit_and ({NATURAL_32} 4294967295)
			Result := (l_state.item.x)
		end

	ran_get___8_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran_get___8)
		end

	ran_get_double___8 (a_vstate: CE_POINTER [ANY]): REAL_64
		local
			l_state: CE_POINTER [PD_RAN_STATE_T]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate))
			Result := ((ran_get___8 (create {CE_POINTER [ANY]}.make_cast (l_state))).to_real_64 / 4294967296.0)
		end

	ran_get_double___8_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran_get_double___8)
		end

	ran_set___8 (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_RAN_STATE_T]
			l_diff: NATURAL_32
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate))
			l_diff := (a_s \\ {NATURAL_32} 4 - {NATURAL_32} 2) \\ {NATURAL_32} 4294967295
			if l_diff.to_boolean then
				l_state.item.x := ((a_s - l_diff)).bit_and ({NATURAL_32} 4294967295)
			else
				l_state.item.x := (a_s).bit_and ({NATURAL_32} 4294967295)
			end
		end

	ran_set___8_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran_set___8)
		end

end
