class
	P_DZASUM

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_dzasum (a_N: INTEGER_32; a_X: CE_POINTER [ANY]; a_incX: INTEGER_32): REAL_64
		local
			l_r___3: REAL_64
			l_i: INTEGER_32
			l_ix: INTEGER_32
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			l_r___3 := 0.0
			l_ix := 0
			if a_incX <= 0 then
				Result := (0).to_double
				js.return
			end
			if not js.return_called then
				l_i := 0
				from
				until
					not (l_i < a_N)
				loop
					l_tmp := fabs (create {CE_POINTER [REAL_64]}.make_cast (a_X)[2 * l_ix])
					l_r___3 := l_r___3 + (l_tmp + (fabs (create {CE_POINTER [REAL_64]}.make_cast (a_X)[(2 * l_ix + 1)])))
					l_ix := l_ix + a_incX
					l_i := l_i + 1
				end
				Result := l_r___3
			end
		end

end
