class
	P_ERLANG

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_ran_erlang (a_r___3: CE_POINTER [PD_GSL_RNG]; a_a___5: REAL_64; a_n: REAL_64): REAL_64
		do
			Result := (gamma_inst.gsl_ran_gamma (a_r___3, a_n, a_a___5))
		end

	gsl_ran_erlang_pdf (a_x: REAL_64; a_a___5: REAL_64; a_n: REAL_64): REAL_64
		local
			l_p: REAL_64
			l_lngamma: REAL_64
		do
			if a_x <= (0).to_double then
				Result := (0).to_double
			else
				l_lngamma := (gamma_inst.gsl_sf_lngamma (a_n))
				l_p := (exp (((a_n - (1).to_double) * (log (a_x / a_a___5)) - a_x / a_a___5) - l_lngamma)) / a_a___5
				Result := l_p
			end
		end

end
