class
	P_FWRITE_SOURCE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_block_complex_long_double_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_96]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fread (create {CE_POINTER [ANY]}.make_cast (l_data), {NATURAL_32} 2 * Real_96_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 31, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_complex_long_double_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_96]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (l_data), {NATURAL_32} 2 * Real_96_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 48, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_complex_long_double_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_96]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_POINTER [ANY]}.make_cast (a_data), {NATURAL_32} 2 * Real_96_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_POINTER [ANY]}.make_cast ((a_data + (({NATURAL_32} 2 * l_i) * a_stride).to_integer_32)), {NATURAL_32} 2 * Real_96_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_complex_long_double_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_96]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (a_data), {NATURAL_32} 2 * Real_96_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_POINTER [ANY]}.make_cast ((a_data + (({NATURAL_32} 2 * l_i) * a_stride).to_integer_32)), {NATURAL_32} 2 * Real_96_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_complex_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_64]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fread (create {CE_POINTER [ANY]}.make_cast (l_data), {NATURAL_32} 2 * Real_64_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 31, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_complex_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_64]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (l_data), {NATURAL_32} 2 * Real_64_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 48, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_complex_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_64]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_POINTER [ANY]}.make_cast (a_data), {NATURAL_32} 2 * Real_64_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_POINTER [ANY]}.make_cast ((a_data + (({NATURAL_32} 2 * l_i) * a_stride).to_integer_32)), {NATURAL_32} 2 * Real_64_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_complex_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_64]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (a_data), {NATURAL_32} 2 * Real_64_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_POINTER [ANY]}.make_cast ((a_data + (({NATURAL_32} 2 * l_i) * a_stride).to_integer_32)), {NATURAL_32} 2 * Real_64_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_complex_float_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_32]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fread (create {CE_POINTER [ANY]}.make_cast (l_data), {NATURAL_32} 2 * Real_32_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 31, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_complex_float_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_32]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (l_data), {NATURAL_32} 2 * Real_32_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 48, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_complex_float_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_32]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_POINTER [ANY]}.make_cast (a_data), {NATURAL_32} 2 * Real_32_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_POINTER [ANY]}.make_cast ((a_data + (({NATURAL_32} 2 * l_i) * a_stride).to_integer_32)), {NATURAL_32} 2 * Real_32_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_complex_float_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_32]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (a_data), {NATURAL_32} 2 * Real_32_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_POINTER [ANY]}.make_cast ((a_data + (({NATURAL_32} 2 * l_i) * a_stride).to_integer_32)), {NATURAL_32} 2 * Real_32_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_long_double_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_96]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fread (create {CE_POINTER [ANY]}.make_cast (l_data), Real_96_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 31, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_long_double_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_96]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (l_data), Real_96_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 48, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_long_double_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_96]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_POINTER [ANY]}.make_cast (a_data), Real_96_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_POINTER [ANY]}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), Real_96_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_long_double_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_96]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (a_data), Real_96_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_POINTER [ANY]}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), Real_96_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_64]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fread (create {CE_POINTER [ANY]}.make_cast (l_data), Real_64_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 31, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_64]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (l_data), Real_64_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 48, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_64]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_POINTER [ANY]}.make_cast (a_data), Real_64_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_POINTER [ANY]}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), Real_64_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_64]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (a_data), Real_64_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_POINTER [ANY]}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), Real_64_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_float_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_32]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fread (create {CE_POINTER [ANY]}.make_cast (l_data), Real_32_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 31, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_float_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_32]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (l_data), Real_32_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 48, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_float_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_32]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_POINTER [ANY]}.make_cast (a_data), Real_32_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_POINTER [ANY]}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), Real_32_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_float_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [REAL_32]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (a_data), Real_32_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_POINTER [ANY]}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), Real_32_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_ulong_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [NATURAL_32]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fread (create {CE_POINTER [ANY]}.make_cast (l_data), Natural_32_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 31, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_ulong_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [NATURAL_32]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (l_data), Natural_32_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 48, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_ulong_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_32]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_POINTER [ANY]}.make_cast (a_data), Natural_32_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_POINTER [ANY]}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), Natural_32_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_ulong_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_32]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (a_data), Natural_32_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_POINTER [ANY]}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), Natural_32_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_long_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [INTEGER_32]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fread (create {CE_POINTER [ANY]}.make_cast (l_data), Integer_32_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 31, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_long_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_LONG_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [INTEGER_32]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (l_data), Integer_32_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 48, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_long_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_32]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_POINTER [ANY]}.make_cast (a_data), Integer_32_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_POINTER [ANY]}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), Integer_32_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_long_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_32]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (a_data), Integer_32_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_POINTER [ANY]}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), Integer_32_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_uint_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [NATURAL_32]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fread (create {CE_POINTER [ANY]}.make_cast (l_data), Natural_32_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 31, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_uint_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_UINT_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [NATURAL_32]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (l_data), Natural_32_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 48, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_uint_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_32]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_POINTER [ANY]}.make_cast (a_data), Natural_32_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_POINTER [ANY]}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), Natural_32_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_uint_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_32]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (a_data), Natural_32_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_POINTER [ANY]}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), Natural_32_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_int_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [INTEGER_32]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fread (create {CE_POINTER [ANY]}.make_cast (l_data), Integer_32_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 31, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_int_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_INT_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [INTEGER_32]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (l_data), Integer_32_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 48, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_int_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_32]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_POINTER [ANY]}.make_cast (a_data), Integer_32_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_POINTER [ANY]}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), Integer_32_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_int_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_32]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (a_data), Integer_32_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_POINTER [ANY]}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), Integer_32_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_ushort_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [NATURAL_16]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fread (create {CE_POINTER [ANY]}.make_cast (l_data), Natural_16_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 31, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_ushort_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [NATURAL_16]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (l_data), Natural_16_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 48, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_ushort_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_16]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_POINTER [ANY]}.make_cast (a_data), Natural_16_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_POINTER [ANY]}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), Natural_16_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_ushort_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_16]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (a_data), Natural_16_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_POINTER [ANY]}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), Natural_16_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_short_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [INTEGER_16]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fread (create {CE_POINTER [ANY]}.make_cast (l_data), Integer_16_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 31, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_short_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [INTEGER_16]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (l_data), Integer_16_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 48, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_short_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_16]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_POINTER [ANY]}.make_cast (a_data), Integer_16_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_POINTER [ANY]}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), Integer_16_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_short_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_16]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (a_data), Integer_16_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_POINTER [ANY]}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), Integer_16_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_uchar_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [NATURAL_8]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fread (create {CE_POINTER [ANY]}.make_cast (l_data), Natural_8_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 31, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_uchar_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [NATURAL_8]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (l_data), Natural_8_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 48, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_uchar_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_8]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_POINTER [ANY]}.make_cast (a_data), Natural_8_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_POINTER [ANY]}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), Natural_8_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_uchar_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [NATURAL_8]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (a_data), Natural_8_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_POINTER [ANY]}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), Natural_8_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_char_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [INTEGER_8]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fread (create {CE_POINTER [ANY]}.make_cast (l_data), Integer_8_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 31, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_char_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_b___0: CE_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [INTEGER_8]
			l_items: NATURAL_32
			js: JUMP_STATE
		do
			create l_data.make

			l_n := a_b___0.item.size
			l_data.ce_gets (a_b___0.item.data)
			l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (l_data), Integer_8_bytes.to_natural_32, l_n, a_stream))
			if l_items /= l_n then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 48, 5)
					Result := 5
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_char_raw_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_8]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fread (create {CE_POINTER [ANY]}.make_cast (a_data), Integer_8_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 64, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fread (create {CE_POINTER [ANY]}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), Integer_8_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 77, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_block_char_raw_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_data: CE_POINTER [INTEGER_8]; a_n: NATURAL_32; a_stride: NATURAL_32): INTEGER_32
		local
			l_items: NATURAL_32
			l_i: NATURAL_32
			l_item: NATURAL_32
			js: JUMP_STATE
		do
			if a_stride = {NATURAL_32} 1 then
				l_items := (fwrite (create {CE_POINTER [ANY]}.make_cast (a_data), Integer_8_bytes.to_natural_32, a_n, a_stream))
				if l_items /= a_n then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 96, 5)
						Result := 5
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_left and then (l_i < a_n))
				loop
					l_item := (fwrite (create {CE_POINTER [ANY]}.make_cast ((a_data + (l_i * a_stride).to_integer_32)), Integer_8_bytes.to_natural_32, (1).to_natural_32, a_stream))
					if l_item /= {NATURAL_32} 1 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 110, 5)
							Result := 5
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_i := l_i + 1
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

end
