class
	P_GLFIXED

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create x2___0.make (<<1>>)
			create w2.make (<<1>>)
			create x4___0.make (<<2>>)
			create w4.make (<<2>>)
			create x6.make (<<3>>)
			create w6.make (<<3>>)
			create x8.make (<<4>>)
			create w8.make (<<4>>)
			create x10.make (<<5>>)
			create w10___0.make (<<5>>)
			create x12.make (<<6>>)
			create w12.make (<<6>>)
			create x14.make (<<7>>)
			create w14.make (<<7>>)
			create x16.make (<<8>>)
			create w16.make (<<8>>)
			create x18.make (<<9>>)
			create w18.make (<<9>>)
			create x20.make (<<10>>)
			create w20.make (<<10>>)
			create x32.make (<<16>>)
			create w32.make (<<16>>)
			create x64.make (<<32>>)
			create w64.make (<<32>>)
			create x96.make (<<48>>)
			create w96.make (<<48>>)
			create x100.make (<<50>>)
			create w100.make (<<50>>)
			create x128.make (<<64>>)
			create w128.make (<<64>>)
			create x256.make (<<128>>)
			create w256.make (<<128>>)
			create x512.make (<<256>>)
			create w512.make (<<256>>)
			create x1024.make (<<512>>)
			create w1024.make (<<512>>)
			create x3___0.make (<<2>>)
			create w3.make (<<2>>)
			create x5.make (<<3>>)
			create w5.make (<<3>>)
			create x7.make (<<4>>)
			create w7.make (<<4>>)
			create x9.make (<<5>>)
			create w9.make (<<5>>)
			create x11.make (<<6>>)
			create w11.make (<<6>>)
			create x13.make (<<7>>)
			create w13.make (<<7>>)
			create x15.make (<<8>>)
			create w15.make (<<8>>)
			create x17.make (<<9>>)
			create w17.make (<<9>>)
			create x19.make (<<10>>)
			create w19.make (<<10>>)
			create glaw.make (<<27>>)
			create ltbl.make (<<1024>>)
		end

feature {ANY} -- attributes

	x2___0: CE_ARRAY [REAL_64]

	w2: CE_ARRAY [REAL_64]

	x4___0: CE_ARRAY [REAL_64]

	w4: CE_ARRAY [REAL_64]

	x6: CE_ARRAY [REAL_64]

	w6: CE_ARRAY [REAL_64]

	x8: CE_ARRAY [REAL_64]

	w8: CE_ARRAY [REAL_64]

	x10: CE_ARRAY [REAL_64]

	w10___0: CE_ARRAY [REAL_64]

	x12: CE_ARRAY [REAL_64]

	w12: CE_ARRAY [REAL_64]

	x14: CE_ARRAY [REAL_64]

	w14: CE_ARRAY [REAL_64]

	x16: CE_ARRAY [REAL_64]

	w16: CE_ARRAY [REAL_64]

	x18: CE_ARRAY [REAL_64]

	w18: CE_ARRAY [REAL_64]

	x20: CE_ARRAY [REAL_64]

	w20: CE_ARRAY [REAL_64]

	x32: CE_ARRAY [REAL_64]

	w32: CE_ARRAY [REAL_64]

	x64: CE_ARRAY [REAL_64]

	w64: CE_ARRAY [REAL_64]

	x96: CE_ARRAY [REAL_64]

	w96: CE_ARRAY [REAL_64]

	x100: CE_ARRAY [REAL_64]

	w100: CE_ARRAY [REAL_64]

	x128: CE_ARRAY [REAL_64]

	w128: CE_ARRAY [REAL_64]

	x256: CE_ARRAY [REAL_64]

	w256: CE_ARRAY [REAL_64]

	x512: CE_ARRAY [REAL_64]

	w512: CE_ARRAY [REAL_64]

	x1024: CE_ARRAY [REAL_64]

	w1024: CE_ARRAY [REAL_64]

	x3___0: CE_ARRAY [REAL_64]

	w3: CE_ARRAY [REAL_64]

	x5: CE_ARRAY [REAL_64]

	w5: CE_ARRAY [REAL_64]

	x7: CE_ARRAY [REAL_64]

	w7: CE_ARRAY [REAL_64]

	x9: CE_ARRAY [REAL_64]

	w9: CE_ARRAY [REAL_64]

	x11: CE_ARRAY [REAL_64]

	w11: CE_ARRAY [REAL_64]

	x13: CE_ARRAY [REAL_64]

	w13: CE_ARRAY [REAL_64]

	x15: CE_ARRAY [REAL_64]

	w15: CE_ARRAY [REAL_64]

	x17: CE_ARRAY [REAL_64]

	w17: CE_ARRAY [REAL_64]

	x19: CE_ARRAY [REAL_64]

	w19: CE_ARRAY [REAL_64]

	glaw: CE_ARRAY [PD_GSL_INTEGRATION_GLFIXED_TABLE]

	GLAWSIZE: NATURAL_32 assign set_GLAWSIZE

	set_GLAWSIZE (a_GLAWSIZE: NATURAL_32)
		do
			GLAWSIZE := a_GLAWSIZE
		end

	ltbl: CE_ARRAY [REAL_64]

feature {ANY} -- routines

	gsl_integration_glfixed_table_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_INTEGRATION_GLFIXED_TABLE]
		local
			l_i: INTEGER_32
			l_x: CE_POINTER [REAL_64]
			l_w: CE_POINTER [REAL_64]
			l_retval: CE_POINTER [PD_GSL_INTEGRATION_GLFIXED_TABLE]
			l_m___4: INTEGER_32
			js: JUMP_STATE
		do
			create l_x.make
			create l_w.make
			create l_retval.make

			l_x.ce_gets (create {CE_POINTER [REAL_64]}.make_shared (default_pointer))
			l_w.ce_gets (create {CE_POINTER [REAL_64]}.make_shared (default_pointer))
			l_retval.ce_gets (create {CE_POINTER [PD_GSL_INTEGRATION_GLFIXED_TABLE]}.make_shared (default_pointer))
			if a_n > {NATURAL_32} 2147483647 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("Requested n is too large"), ce_string ("glfixed.c"), 193, 4)
					Result := (create {CE_POINTER [PD_GSL_INTEGRATION_GLFIXED_TABLE]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_i := 0
				from
				until
					not (not js.loop_left and then (l_i.to_natural_32 < GLAWSIZE))
				loop
					js.reset
					if a_n = glaw[l_i].n then
						l_retval.ce_gets (glaw + l_i)
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
				js.reset
				if (l_retval.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					l_m___4 := (((a_n + {NATURAL_32} 1)).bit_shift_right (1)).to_integer_32
					l_x.ce_gets (create {CE_POINTER [REAL_64]}.make_cast ((malloc (l_m___4.to_natural_32 * Real_64_bytes.to_natural_32))))
					if (l_x.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
						from
						until
							js.loop_left
						loop
							js.reset
							error_inst.gsl_error (ce_string ("failed to allocate space for abscissae"), ce_string ("glfixed.c"), 215, 8)
							Result := (create {CE_POINTER [PD_GSL_INTEGRATION_GLFIXED_TABLE]}.make_shared (default_pointer))
							js.return
							if not js.return_called then
								js.break
							end
						end
						js.reset
					end
					if not js.return_called then
						l_w.ce_gets (create {CE_POINTER [REAL_64]}.make_cast ((malloc (l_m___4.to_natural_32 * Real_64_bytes.to_natural_32))))
						if (l_w.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							free (create {CE_POINTER [ANY]}.make_cast (l_x))
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("failed to allocate space for weights"), ce_string ("glfixed.c"), 223, 8)
								Result := (create {CE_POINTER [PD_GSL_INTEGRATION_GLFIXED_TABLE]}.make_shared (default_pointer))
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
					end
					if not js.return_called then
						l_retval.ce_gets (create {CE_POINTER [PD_GSL_INTEGRATION_GLFIXED_TABLE]}.make_cast ((malloc ({PD_GSL_INTEGRATION_GLFIXED_TABLE}.sizeof.to_natural_32))))
						if (l_retval.c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
							free (create {CE_POINTER [ANY]}.make_cast (l_x))
							free (create {CE_POINTER [ANY]}.make_cast (l_w))
							from
							until
								js.loop_left
							loop
								js.reset
								error_inst.gsl_error (ce_string ("failed to allocate space for table struct"), ce_string ("glfixed.c"), 232, 8)
								Result := (create {CE_POINTER [PD_GSL_INTEGRATION_GLFIXED_TABLE]}.make_shared (default_pointer))
								js.return
								if not js.return_called then
									js.break
								end
							end
							js.reset
						end
					end
					if not js.return_called then
						gauss_legendre_tbl (a_n.to_integer_32, l_x, l_w, 1.e-10)
						l_retval.item.n := a_n
						l_retval.item.x := l_x
						l_retval.item.w := l_w
						l_retval.item.precomputed := 0
					end
				end
			end
			if not js.return_called then
				Result := l_retval
			end
		end

	gsl_integration_glfixed_table_free (a_t: CE_POINTER [PD_GSL_INTEGRATION_GLFIXED_TABLE])
		do
			if not (a_t.item.precomputed).to_boolean then
				free (create {CE_POINTER [ANY]}.make_cast (a_t.item.x))
				free (create {CE_POINTER [ANY]}.make_cast (a_t.item.w))
				free (create {CE_POINTER [ANY]}.make_cast (a_t))
			end
		end

	gsl_integration_glfixed (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_a___5: REAL_64; a_b___0: REAL_64; a_t: CE_POINTER [PD_GSL_INTEGRATION_GLFIXED_TABLE]): REAL_64
		local
			l_x: CE_POINTER [REAL_64]
			l_w: CE_POINTER [REAL_64]
			l_n: INTEGER_32
			l_A___0: REAL_64
			l_B: REAL_64
			l_Ax: REAL_64
			l_s: REAL_64
			l_i: INTEGER_32
			l_m___4: INTEGER_32
			l_tmp___0: REAL_64
			l_tmp___2: REAL_64
		do
			create l_x.make
			create l_w.make

			l_x.ce_gets (a_t.item.x)
			l_w.ce_gets (a_t.item.w)
			l_n := (a_t.item.n).to_integer_32
			l_m___4 := ((l_n + 1)).bit_shift_right (1)
			l_A___0 := 0.5 * (a_b___0 - a_a___5)
			l_B := 0.5 * (a_b___0 + a_a___5)
			if ((l_n).bit_and (1)).to_boolean then
				l_s := (l_w[0] * ((a_f.item.function).real_64_item ([l_B, a_f.item.params])))
				l_i := 1
				from
				until
					not (l_i < l_m___4)
				loop
					l_Ax := l_A___0 * l_x[l_i]
					l_tmp___0 := (a_f.item.function).real_64_item ([l_B + l_Ax, a_f.item.params])
					l_s := l_s + (l_w[l_i] * (l_tmp___0 + ((a_f.item.function).real_64_item ([l_B - l_Ax, a_f.item.params]))))
					l_i := l_i + 1
				end
			else
				l_s := 0.0
				l_i := 0
				from
				until
					not (l_i < l_m___4)
				loop
					l_Ax := l_A___0 * l_x[l_i]
					l_tmp___2 := (a_f.item.function).real_64_item ([l_B + l_Ax, a_f.item.params])
					l_s := l_s + (l_w[l_i] * (l_tmp___2 + ((a_f.item.function).real_64_item ([l_B - l_Ax, a_f.item.params]))))
					l_i := l_i + 1
				end
			end
			Result := (l_A___0 * l_s)
		end

	gauss_legendre_tbl (a_n: INTEGER_32; a_x: CE_POINTER [REAL_64]; a_w: CE_POINTER [REAL_64]; a_eps: REAL_64)
		local
			l_x0: REAL_64
			l_x1___0: REAL_64
			l_dx: REAL_64
			l_w0: REAL_64
			l_w1: REAL_64
			l_dw: REAL_64
			l_P0: REAL_64
			l_P_1: REAL_64
			l_P_2: REAL_64
			l_dpdx: REAL_64
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_m___4: INTEGER_32
			l_t0: REAL_64
			l_t1: REAL_64
			l_t2: REAL_64
			l_t3: REAL_64
			l_pi_to_many_places: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_m___4 := ((a_n + 1)).bit_shift_right (1)
					l_t0 := 1.0 - (1.0 - 1.0 / a_n.to_double) / ((8.0 * a_n.to_double) * a_n.to_double)
					l_t1 := 1.0 / (4.0 * a_n.to_double + 2.0)
					l_i := 1
				when 1 then -- loop condition:
					if not (not js.loop_left and then (l_i <= l_m___4)) then
						l_pos := -1 + 13 -- skip loop
					end
				when 2 then -- loop body:
						l_pi_to_many_places := 3.1415926535897932384626433832795028841971693993751
						l_x0 := (cos ((l_pi_to_many_places * (((l_i).bit_shift_left (2)) - 1).to_double) * l_t1)) * l_t0
						l_j := 0
						l_dw := (real_96_from_real_64 (1.79769313486231570815e+308)).truncated_to_real_64
						l_dx := l_dw
				when 3 then -- loop condition:
						if js.loop_left then
							l_pos := -1 + 12 -- skip loop
						end
				when 4 then -- loop body:
						js.reset
						l_P_1 := 1.0
						l_P0 := l_x0
						if a_n < 1024 then
							l_k := 2
							from
							until
								not (l_k <= a_n)
							loop
								l_P_2 := l_P_1
								l_P_1 := l_P0
								l_t2 := l_x0 * l_P_1
								l_P0 := l_t2 + ltbl[l_k] * (l_t2 - l_P_2)
								l_k := l_k + 1
							end
						else
							l_k := 2
							from
							until
								not (l_k < 1024)
							loop
								l_P_2 := l_P_1
								l_P_1 := l_P0
								l_t2 := l_x0 * l_P_1
								l_P0 := l_t2 + ltbl[l_k] * (l_t2 - l_P_2)
								l_k := l_k + 1
							end
							l_k := 1024
							from
							until
								not (l_k <= a_n)
							loop
								l_P_2 := l_P_1
								l_P_1 := l_P0
								l_t2 := l_x0 * l_P_1
								l_t3 := (l_k - 1).to_double / l_k.to_double
								l_P0 := l_t2 + l_t3 * (l_t2 - l_P_2)
								l_k := l_k + 1
							end
						end
						l_dpdx := ((l_x0 * l_P0 - l_P_1) * a_n.to_double) / (l_x0 * l_x0 - 1.0)
						l_x1___0 := l_x0 - l_P0 / l_dpdx
						l_w1 := 2.0 / (((1.0 - l_x1___0 * l_x1___0) * l_dpdx) * l_dpdx)
						if l_j = 0 then
							l_w0 := 2.0 / (((1.0 - l_x0 * l_x0) * l_dpdx) * l_dpdx)
						end
						l_dx := l_x0 - l_x1___0
						l_dw := l_w0 - l_w1
						l_x0 := l_x1___0
						l_w0 := l_w1
						l_j := l_j + 1
						if not ((fabs (l_dx)) > a_eps) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if not ((fabs (l_dw)) > a_eps) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L:
						if not (l_j < 100) then
							js.break
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						js.break
				when 11 then -- if done
						l_pos := -1 + 3 -- back to loop condition
				when 12 then -- loop done
						js.reset
						a_x[((l_m___4 - 1) - (l_i - 1))] := l_x1___0
						a_w[((l_m___4 - 1) - (l_i - 1))] := l_w1
						l_i := l_i + 1
						l_pos := -1 + 1 -- back to loop condition
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
