class
	P_GSL_GSL_MATRIX_DOUBLE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_matrix_get (a_m___4: CE_POINTER [PD_GSL_MATRIX]; a_i: NATURAL_32; a_j: NATURAL_32): REAL_64
		do
			Result := (a_m___4.item.data[(a_i * a_m___4.item.tda + a_j).to_integer_32])
		end

	gsl_matrix_set (a_m___4: CE_POINTER [PD_GSL_MATRIX]; a_i: NATURAL_32; a_j: NATURAL_32; a_x: REAL_64)
		do
			a_m___4.item.data[(a_i * a_m___4.item.tda + a_j).to_integer_32] := a_x
		end

	gsl_matrix_ptr (a_m___4: CE_POINTER [PD_GSL_MATRIX]; a_i: NATURAL_32; a_j: NATURAL_32): CE_POINTER [REAL_64]
		do
			Result := (a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32)
		end

	gsl_matrix_const_ptr (a_m___4: CE_POINTER [PD_GSL_MATRIX]; a_i: NATURAL_32; a_j: NATURAL_32): CE_POINTER [REAL_64]
		do
			Result := (a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32)
		end

end
