class
	P_GSL_GSL_MATRIX_SHORT

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_matrix_short_get (a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]; a_i: NATURAL_32; a_j: NATURAL_32): INTEGER_16
		do
			Result := (a_m___4.item.data[(a_i * a_m___4.item.tda + a_j).to_integer_32])
		end

	gsl_matrix_short_set (a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]; a_i: NATURAL_32; a_j: NATURAL_32; a_x: INTEGER_16)
		do
			a_m___4.item.data[(a_i * a_m___4.item.tda + a_j).to_integer_32] := a_x
		end

	gsl_matrix_short_ptr (a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]; a_i: NATURAL_32; a_j: NATURAL_32): CE_POINTER [INTEGER_16]
		do
			Result := (a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32)
		end

	gsl_matrix_short_const_ptr (a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]; a_i: NATURAL_32; a_j: NATURAL_32): CE_POINTER [INTEGER_16]
		do
			Result := (a_m___4.item.data + (a_i * a_m___4.item.tda + a_j).to_integer_32)
		end

end
