class
	P_GSL_GSL_MULTISET

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_multiset_get (a_c___1: CE_POINTER [PD_GSL_MULTISET_STRUCT]; a_i: NATURAL_32): NATURAL_32
		local
			js: JUMP_STATE
		do
			if vector_inst.gsl_check_range.to_boolean then
				if a_i >= a_c___1.item.k then
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("index out of range"), ce_string ("../gsl/gsl_multiset.h"), 83, 4)
						Result := (0).to_natural_32
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				Result := (a_c___1.item.data[a_i.to_integer_32])
			end
		end

end
