class
	P_INTEG_EVAL

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	integ_eval (a_ai: REAL_64; a_bi: REAL_64; a_ci: REAL_64; a_di: REAL_64; a_xi: REAL_64; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_r1___1: REAL_64
			l_r2___0: REAL_64
			l_r12: REAL_64
			l_bterm: REAL_64
			l_cterm: REAL_64
			l_dterm: REAL_64
		do
			l_r1___1 := a_a___5 - a_xi
			l_r2___0 := a_b___0 - a_xi
			l_r12 := l_r1___1 + l_r2___0
			l_bterm := (0.5 * a_bi) * l_r12
			l_cterm := ((1.0 / 3.0) * a_ci) * ((l_r1___1 * l_r1___1 + l_r2___0 * l_r2___0) + l_r1___1 * l_r2___0)
			l_dterm := ((0.25 * a_di) * l_r12) * (l_r1___1 * l_r1___1 + l_r2___0 * l_r2___0)
			Result := ((a_b___0 - a_a___5) * (((a_ai + l_bterm) + l_cterm) + l_dterm))
		end

end
