class
	P_PARAMS

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_histogram_max (a_h: CE_POINTER [PD_GSL_HISTOGRAM]): REAL_64
		local
			l_n: INTEGER_32
		do
			l_n := (a_h.item.n).to_integer_32
			Result := (a_h.item.range[l_n])
		end

	gsl_histogram_min (a_h: CE_POINTER [PD_GSL_HISTOGRAM]): REAL_64
		do
			Result := (a_h.item.range[0])
		end

	gsl_histogram_bins (a_h: CE_POINTER [PD_GSL_HISTOGRAM]): NATURAL_32
		do
			Result := (a_h.item.n)
		end

end
