class
	P_PASCAL

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_ran_pascal (a_r___3: CE_POINTER [PD_GSL_RNG]; a_p: REAL_64; a_n: NATURAL_32): NATURAL_32
		local
			l_k: NATURAL_32
		do
			l_k := (nbinomial_inst.gsl_ran_negative_binomial (a_r___3, a_p, a_n.to_real_64))
			Result := l_k
		end

	gsl_ran_pascal_pdf (a_k: NATURAL_32; a_p: REAL_64; a_n: NATURAL_32): REAL_64
		local
			l_P___2: REAL_64
		do
			l_P___2 := (nbinomial_inst.gsl_ran_negative_binomial_pdf (a_k, a_p, a_n.to_real_64))
			Result := l_P___2
		end

	gsl_cdf_pascal_P (a_k: NATURAL_32; a_p: REAL_64; a_n: NATURAL_32): REAL_64
		local
			l_P___2: REAL_64
		do
			l_P___2 := (nbinomial_inst.gsl_cdf_negative_binomial_P (a_k, a_p, a_n.to_real_64))
			Result := l_P___2
		end

	gsl_cdf_pascal_Q (a_k: NATURAL_32; a_p: REAL_64; a_n: NATURAL_32): REAL_64
		local
			l_Q___1: REAL_64
		do
			l_Q___1 := (nbinomial_inst.gsl_cdf_negative_binomial_Q (a_k, a_p, a_n.to_real_64))
			Result := l_Q___1
		end

end
