class
	P_QRSOLV

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	qrsolv (a_r___3: CE_POINTER [PD_GSL_MATRIX]; a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_lambda: REAL_64; a_diag: CE_POINTER [PD_GSL_VECTOR]; a_qtb: CE_POINTER [PD_GSL_VECTOR]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_sdiag: CE_POINTER [PD_GSL_VECTOR]; a_wa: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_n: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_nsing: NATURAL_32
			l_rjj: REAL_64
			l_qtbj: REAL_64
			l_rji: REAL_64
			l_qtbpj: REAL_64
			l_pj: NATURAL_32
			l_diagpj: REAL_64
			l_sine: REAL_64
			l_cosine: REAL_64
			l_wak: REAL_64
			l_rkk: REAL_64
			l_sdiagk: REAL_64
			l_cotangent: REAL_64
			l_tangent: REAL_64
			l_tmp___9: REAL_64
			l_new_rkk: REAL_64
			l_new_wak: REAL_64
			l_rik: REAL_64
			l_sdiagi: REAL_64
			l_new_rik: REAL_64
			l_new_sdiagi: REAL_64
			l_rjj___0: REAL_64
			l_xj: REAL_64
			l_sdiagj: REAL_64
			l_sum: REAL_64
			l_tmp___16: REAL_64
			l_waj: REAL_64
			l_sdiagj___0: REAL_64
			l_pj___0: NATURAL_32
			l_waj___0: REAL_64
			js: JUMP_STATE
		do
			l_n := a_r___3.item.size2
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_left and then (l_j < l_n))
			loop
				l_rjj := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_r___3, l_j, l_j))
				l_qtbj := (gsl_gsl_vector_double_inst.gsl_vector_get (a_qtb, l_j))
				l_i := l_j + {NATURAL_32} 1
				from
				until
					not (l_i < l_n)
				loop
					l_rji := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_r___3, l_j, l_i))
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_r___3, l_i, l_j, l_rji)
					l_i := l_i + 1
				end
				gsl_gsl_vector_double_inst.gsl_vector_set (a_x, l_j, l_rjj)
				gsl_gsl_vector_double_inst.gsl_vector_set (a_wa, l_j, l_qtbj)
				l_j := l_j + 1
			end
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_left and then (l_j < l_n))
			loop
				js.reset
				l_pj := (gsl_gsl_permutation_inst.gsl_permutation_get (a_p, l_j))
				l_diagpj := a_lambda * (gsl_gsl_vector_double_inst.gsl_vector_get (a_diag, l_pj))
				if l_diagpj = (0).to_double then
					js.continue
				end
				if not js.loop_jumped then
					gsl_gsl_vector_double_inst.gsl_vector_set (a_sdiag, l_j, l_diagpj)
					l_k := l_j + {NATURAL_32} 1
					from
					until
						not (l_k < l_n)
					loop
						gsl_gsl_vector_double_inst.gsl_vector_set (a_sdiag, l_k, 0.0)
						l_k := l_k + 1
					end
					l_qtbpj := (0).to_double
					l_k := l_j
					from
					until
						not (not js.loop_left and then (l_k < l_n))
					loop
						js.reset
						l_wak := (gsl_gsl_vector_double_inst.gsl_vector_get (a_wa, l_k))
						l_rkk := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_r___3, l_k, l_k))
						l_sdiagk := (gsl_gsl_vector_double_inst.gsl_vector_get (a_sdiag, l_k))
						if l_sdiagk = (0).to_double then
							js.continue
						end
						if not js.loop_jumped then
							l_tmp___9 := fabs (l_rkk)
							if l_tmp___9 < (fabs (l_sdiagk)) then
								l_cotangent := l_rkk / l_sdiagk
								l_sine := 0.5 / (sqrt (0.25 + (0.25 * l_cotangent) * l_cotangent))
								l_cosine := l_sine * l_cotangent
							else
								l_tangent := l_sdiagk / l_rkk
								l_cosine := 0.5 / (sqrt (0.25 + (0.25 * l_tangent) * l_tangent))
								l_sine := l_cosine * l_tangent
							end
							l_new_rkk := l_cosine * l_rkk + l_sine * l_sdiagk
							l_new_wak := l_cosine * l_wak + l_sine * l_qtbpj
							l_qtbpj := -l_sine * l_wak + l_cosine * l_qtbpj
							gsl_gsl_matrix_double_inst.gsl_matrix_set (a_r___3, l_k, l_k, l_new_rkk)
							gsl_gsl_vector_double_inst.gsl_vector_set (a_wa, l_k, l_new_wak)
							l_i := l_k + {NATURAL_32} 1
							from
							until
								not (l_i < l_n)
							loop
								l_rik := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_r___3, l_i, l_k))
								l_sdiagi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_sdiag, l_i))
								l_new_rik := l_cosine * l_rik + l_sine * l_sdiagi
								l_new_sdiagi := -l_sine * l_rik + l_cosine * l_sdiagi
								gsl_gsl_matrix_double_inst.gsl_matrix_set (a_r___3, l_i, l_k, l_new_rik)
								gsl_gsl_vector_double_inst.gsl_vector_set (a_sdiag, l_i, l_new_sdiagi)
								l_i := l_i + 1
							end
						end
						if not js.loop_left then
							l_k := l_k + 1
						end
					end
					l_rjj___0 := (gsl_gsl_matrix_double_inst.gsl_matrix_get (a_r___3, l_j, l_j))
					l_xj := (gsl_gsl_vector_double_inst.gsl_vector_get (a_x, l_j))
					gsl_gsl_vector_double_inst.gsl_vector_set (a_sdiag, l_j, l_rjj___0)
					gsl_gsl_matrix_double_inst.gsl_matrix_set (a_r___3, l_j, l_j, l_xj)
				end
				if not js.loop_left then
					l_j := l_j + 1
				end
			end
			l_nsing := l_n
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_left and then (l_j < l_n))
			loop
				js.reset
				l_sdiagj := (gsl_gsl_vector_double_inst.gsl_vector_get (a_sdiag, l_j))
				if l_sdiagj = (0).to_double then
					l_nsing := l_j
					js.break
				end
				if not js.loop_jumped then
					l_j := l_j + 1
				end
			end
			js.reset
			l_j := l_nsing
			from
			until
				not (l_j < l_n)
			loop
				gsl_gsl_vector_double_inst.gsl_vector_set (a_wa, l_j, 0.0)
				l_j := l_j + 1
			end
			l_k := (0).to_natural_32
			from
			until
				not (not js.loop_left and then (l_k < l_nsing))
			loop
				l_sum := (0).to_double
				l_j := (l_nsing - {NATURAL_32} 1) - l_k
				l_i := l_j + {NATURAL_32} 1
				from
				until
					not (l_i < l_nsing)
				loop
					l_tmp___16 := gsl_gsl_matrix_double_inst.gsl_matrix_get (a_r___3, l_i, l_j)
					l_sum := l_sum + (l_tmp___16 * (gsl_gsl_vector_double_inst.gsl_vector_get (a_wa, l_i)))
					l_i := l_i + 1
				end
				l_waj := (gsl_gsl_vector_double_inst.gsl_vector_get (a_wa, l_j))
				l_sdiagj___0 := (gsl_gsl_vector_double_inst.gsl_vector_get (a_sdiag, l_j))
				gsl_gsl_vector_double_inst.gsl_vector_set (a_wa, l_j, (l_waj - l_sum) / l_sdiagj___0)
				l_k := l_k + 1
			end
			l_j := (0).to_natural_32
			from
			until
				not (l_j < l_n)
			loop
				l_pj___0 := (gsl_gsl_permutation_inst.gsl_permutation_get (a_p, l_j))
				l_waj___0 := (gsl_gsl_vector_double_inst.gsl_vector_get (a_wa, l_j))
				gsl_gsl_vector_double_inst.gsl_vector_set (a_x, l_pj___0, l_waj___0)
				l_j := l_j + 1
			end
			Result := 0
		end

end
