class
	P_RESET

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_histogram_reset (a_h: CE_POINTER [PD_GSL_HISTOGRAM])
		local
			l_i: NATURAL_32
			l_n: NATURAL_32
		do
			l_n := a_h.item.n
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				a_h.item.bin[l_i.to_integer_32] := (0).to_double
				l_i := l_i + 1
			end
		end

	reset_nrmax (a_workspace: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE])
		do
			a_workspace.item.nrmax := (0).to_natural_32
			a_workspace.item.i := a_workspace.item.order[0]
		end

end
