class
	P_STRERROR

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_strerror (a_gsl_errno: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_gsl_errno -- switch 1 head
					when 0 then l_pos := -1 + 1
					when -1 then l_pos := -1 + 2
					when -2 then l_pos := -1 + 3
					when 1 then l_pos := -1 + 4
					when 2 then l_pos := -1 + 5
					when 3 then l_pos := -1 + 6
					when 4 then l_pos := -1 + 7
					when 5 then l_pos := -1 + 8
					when 6 then l_pos := -1 + 9
					when 7 then l_pos := -1 + 10
					when 8 then l_pos := -1 + 11
					when 9 then l_pos := -1 + 12
					when 10 then l_pos := -1 + 13
					when 11 then l_pos := -1 + 14
					when 12 then l_pos := -1 + 15
					when 13 then l_pos := -1 + 16
					when 14 then l_pos := -1 + 17
					when 15 then l_pos := -1 + 18
					when 16 then l_pos := -1 + 19
					when 17 then l_pos := -1 + 20
					when 18 then l_pos := -1 + 21
					when 19 then l_pos := -1 + 22
					when 20 then l_pos := -1 + 23
					when 21 then l_pos := -1 + 24
					when 22 then l_pos := -1 + 25
					when 23 then l_pos := -1 + 26
					when 24 then l_pos := -1 + 27
					when 25 then l_pos := -1 + 28
					when 26 then l_pos := -1 + 29
					when 27 then l_pos := -1 + 30
					when 28 then l_pos := -1 + 31
					when 29 then l_pos := -1 + 32
					when 30 then l_pos := -1 + 33
					when 31 then l_pos := -1 + 34
					when 32 then l_pos := -1 + 35
					else l_pos := -1 + 36
					end
				when 1 then -- switch 1, case 0
					Result := (ce_string ("success"))
					js.return
				when 2 then -- switch 1, case -1
					if not js.return_called then
						Result := (ce_string ("failure"))
						js.return
					end
				when 3 then -- switch 1, case -2
					if not js.return_called then
						Result := (ce_string ("the iteration has not converged yet"))
						js.return
					end
				when 4 then -- switch 1, case 1
					if not js.return_called then
						Result := (ce_string ("input domain error"))
						js.return
					end
				when 5 then -- switch 1, case 2
					if not js.return_called then
						Result := (ce_string ("output range error"))
						js.return
					end
				when 6 then -- switch 1, case 3
					if not js.return_called then
						Result := (ce_string ("invalid pointer"))
						js.return
					end
				when 7 then -- switch 1, case 4
					if not js.return_called then
						Result := (ce_string ("invalid argument supplied by user"))
						js.return
					end
				when 8 then -- switch 1, case 5
					if not js.return_called then
						Result := (ce_string ("generic failure"))
						js.return
					end
				when 9 then -- switch 1, case 6
					if not js.return_called then
						Result := (ce_string ("factorization failed"))
						js.return
					end
				when 10 then -- switch 1, case 7
					if not js.return_called then
						Result := (ce_string ("sanity check failed - shouldn%'t happen"))
						js.return
					end
				when 11 then -- switch 1, case 8
					if not js.return_called then
						Result := (ce_string ("malloc failed"))
						js.return
					end
				when 12 then -- switch 1, case 9
					if not js.return_called then
						Result := (ce_string ("problem with user-supplied function"))
						js.return
					end
				when 13 then -- switch 1, case 10
					if not js.return_called then
						Result := (ce_string ("iterative process is out of control"))
						js.return
					end
				when 14 then -- switch 1, case 11
					if not js.return_called then
						Result := (ce_string ("exceeded max number of iterations"))
						js.return
					end
				when 15 then -- switch 1, case 12
					if not js.return_called then
						Result := (ce_string ("tried to divide by zero"))
						js.return
					end
				when 16 then -- switch 1, case 13
					if not js.return_called then
						Result := (ce_string ("specified tolerance is invalid or theoretically unattainable"))
						js.return
					end
				when 17 then -- switch 1, case 14
					if not js.return_called then
						Result := (ce_string ("failed to reach the specified tolerance"))
						js.return
					end
				when 18 then -- switch 1, case 15
					if not js.return_called then
						Result := (ce_string ("underflow"))
						js.return
					end
				when 19 then -- switch 1, case 16
					if not js.return_called then
						Result := (ce_string ("overflow"))
						js.return
					end
				when 20 then -- switch 1, case 17
					if not js.return_called then
						Result := (ce_string ("loss of accuracy"))
						js.return
					end
				when 21 then -- switch 1, case 18
					if not js.return_called then
						Result := (ce_string ("roundoff error"))
						js.return
					end
				when 22 then -- switch 1, case 19
					if not js.return_called then
						Result := (ce_string ("matrix/vector sizes are not conformant"))
						js.return
					end
				when 23 then -- switch 1, case 20
					if not js.return_called then
						Result := (ce_string ("matrix not square"))
						js.return
					end
				when 24 then -- switch 1, case 21
					if not js.return_called then
						Result := (ce_string ("singularity or extremely bad function behavior detected"))
						js.return
					end
				when 25 then -- switch 1, case 22
					if not js.return_called then
						Result := (ce_string ("integral or series is divergent"))
						js.return
					end
				when 26 then -- switch 1, case 23
					if not js.return_called then
						Result := (ce_string ("the required feature is not supported by this hardware platform"))
						js.return
					end
				when 27 then -- switch 1, case 24
					if not js.return_called then
						Result := (ce_string ("the requested feature is not (yet) implemented"))
						js.return
					end
				when 28 then -- switch 1, case 25
					if not js.return_called then
						Result := (ce_string ("cache limit exceeded"))
						js.return
					end
				when 29 then -- switch 1, case 26
					if not js.return_called then
						Result := (ce_string ("table limit exceeded"))
						js.return
					end
				when 30 then -- switch 1, case 27
					if not js.return_called then
						Result := (ce_string ("iteration is not making progress towards solution"))
						js.return
					end
				when 31 then -- switch 1, case 28
					if not js.return_called then
						Result := (ce_string ("jacobian evaluations are not improving the solution"))
						js.return
					end
				when 32 then -- switch 1, case 29
					if not js.return_called then
						Result := (ce_string ("cannot reach the specified tolerance in F"))
						js.return
					end
				when 33 then -- switch 1, case 30
					if not js.return_called then
						Result := (ce_string ("cannot reach the specified tolerance in X"))
						js.return
					end
				when 34 then -- switch 1, case 31
					if not js.return_called then
						Result := (ce_string ("cannot reach the specified tolerance in gradient"))
						js.return
					end
				when 35 then -- switch 1, case 32
					if not js.return_called then
						Result := (ce_string ("end of file"))
						js.return
					end
				when 36 then -- switch 1, default:
					if not js.return_called then
						Result := (ce_string ("unknown error code"))
					end
				when 37 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
