class
	P_VECTOR_BFGS2

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create vector_bfgs2_type.make
			create gsl_multimin_fdfminimizer_vector_bfgs2.make
		end

feature {ANY} -- attributes

	vector_bfgs2_type: PD_GSL_MULTIMIN_FDFMINIMIZER_TYPE

	gsl_multimin_fdfminimizer_vector_bfgs2: CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER_TYPE]

feature {ANY} -- routines

	vector_bfgs2_alloc (a_vstate: CE_POINTER [ANY]; a_n: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_VECTOR_BFGS2_STATE_T]
			js: JUMP_STATE
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_VECTOR_BFGS2_STATE_T]}.make_cast (a_vstate))
			l_state.item.p := init_source_inst.gsl_vector_calloc (a_n)
			if ((l_state.item.p).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
				from
				until
					js.loop_left
				loop
					js.reset
					error_inst.gsl_error (ce_string ("failed to allocate space for p"), ce_string ("vector_bfgs2.c"), 73, 8)
					Result := 8
					js.return
					if not js.return_called then
						js.break
					end
				end
				js.reset
			end
			if not js.return_called then
				l_state.item.x0 := init_source_inst.gsl_vector_calloc (a_n)
				if ((l_state.item.x0).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_vector_free (l_state.item.p)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for g0"), ce_string ("vector_bfgs2.c"), 81, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.g0 := init_source_inst.gsl_vector_calloc (a_n)
				if ((l_state.item.g0).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_vector_free (l_state.item.x0)
					init_source_inst.gsl_vector_free (l_state.item.p)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for g0"), ce_string ("vector_bfgs2.c"), 90, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.dx0 := init_source_inst.gsl_vector_calloc (a_n)
				if ((l_state.item.dx0).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_vector_free (l_state.item.g0)
					init_source_inst.gsl_vector_free (l_state.item.x0)
					init_source_inst.gsl_vector_free (l_state.item.p)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for g0"), ce_string ("vector_bfgs2.c"), 100, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.dg0 := init_source_inst.gsl_vector_calloc (a_n)
				if ((l_state.item.dg0).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_vector_free (l_state.item.dx0)
					init_source_inst.gsl_vector_free (l_state.item.g0)
					init_source_inst.gsl_vector_free (l_state.item.x0)
					init_source_inst.gsl_vector_free (l_state.item.p)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for g0"), ce_string ("vector_bfgs2.c"), 111, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.x_alpha := init_source_inst.gsl_vector_calloc (a_n)
				if ((l_state.item.x_alpha).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_vector_free (l_state.item.dg0)
					init_source_inst.gsl_vector_free (l_state.item.dx0)
					init_source_inst.gsl_vector_free (l_state.item.g0)
					init_source_inst.gsl_vector_free (l_state.item.x0)
					init_source_inst.gsl_vector_free (l_state.item.p)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for g0"), ce_string ("vector_bfgs2.c"), 123, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				l_state.item.g_alpha := init_source_inst.gsl_vector_calloc (a_n)
				if ((l_state.item.g_alpha).c_pointer.to_integer_32).to_natural_32 = (0).to_natural_32 then
					init_source_inst.gsl_vector_free (l_state.item.x_alpha)
					init_source_inst.gsl_vector_free (l_state.item.dg0)
					init_source_inst.gsl_vector_free (l_state.item.dx0)
					init_source_inst.gsl_vector_free (l_state.item.g0)
					init_source_inst.gsl_vector_free (l_state.item.x0)
					init_source_inst.gsl_vector_free (l_state.item.p)
					from
					until
						js.loop_left
					loop
						js.reset
						error_inst.gsl_error (ce_string ("failed to allocate space for g0"), ce_string ("vector_bfgs2.c"), 136, 8)
						Result := 8
						js.return
						if not js.return_called then
							js.break
						end
					end
					js.reset
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	vector_bfgs2_alloc_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent vector_bfgs2_alloc)
		end

	vector_bfgs2_set (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [REAL_64]; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_step_size: REAL_64; a_tol: REAL_64): INTEGER_32
		local
			l_state: CE_POINTER [PD_VECTOR_BFGS2_STATE_T]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_VECTOR_BFGS2_STATE_T]}.make_cast (a_vstate))
			l_state.item.iter := 0
			l_state.item.step := a_step_size
			l_state.item.delta_f := (0).to_double;
			(a_fdf.item.fdf).call ([a_x, a_fdf.item.params, a_f, a_gradient])
			copy_source_inst.gsl_vector_memcpy (l_state.item.x0, a_x).do_nothing
			copy_source_inst.gsl_vector_memcpy (l_state.item.g0, a_gradient).do_nothing
			l_state.item.g0norm := blas_inst.gsl_blas_dnrm2 (l_state.item.g0)
			copy_source_inst.gsl_vector_memcpy (l_state.item.p, a_gradient).do_nothing
			blas_inst.gsl_blas_dscal ((-1).to_double / l_state.item.g0norm, l_state.item.p)
			l_state.item.pnorm := blas_inst.gsl_blas_dnrm2 (l_state.item.p)
			l_state.item.fp0 := -l_state.item.g0norm
			linear_wrapper_inst.prepare_wrapper (create {CE_POINTER [PD_WRAPPER_T]}.make_shared (l_state.c_pointer + {PD_VECTOR_BFGS2_STATE_T}.wrap_offset), a_fdf, l_state.item.x0, a_f.item, l_state.item.g0, l_state.item.p, l_state.item.x_alpha, l_state.item.g_alpha)
			l_state.item.rho := 0.01
			l_state.item.sigma := a_tol
			l_state.item.tau1 := (9).to_double
			l_state.item.tau2 := 0.05
			l_state.item.tau3 := 0.5
			l_state.item.order := 3
			Result := 0
		end

	vector_bfgs2_set_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent vector_bfgs2_set)
		end

	vector_bfgs2_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_VECTOR_BFGS2_STATE_T]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_VECTOR_BFGS2_STATE_T]}.make_cast (a_vstate))
			init_source_inst.gsl_vector_free (l_state.item.x_alpha)
			init_source_inst.gsl_vector_free (l_state.item.g_alpha)
			init_source_inst.gsl_vector_free (l_state.item.dg0)
			init_source_inst.gsl_vector_free (l_state.item.dx0)
			init_source_inst.gsl_vector_free (l_state.item.g0)
			init_source_inst.gsl_vector_free (l_state.item.x0)
			init_source_inst.gsl_vector_free (l_state.item.p)
		end

	vector_bfgs2_free_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent vector_bfgs2_free)
		end

	vector_bfgs2_restart (a_vstate: CE_POINTER [ANY]): INTEGER_32
		local
			l_state: CE_POINTER [PD_VECTOR_BFGS2_STATE_T]
		do
			create l_state.make

			l_state.ce_gets (create {CE_POINTER [PD_VECTOR_BFGS2_STATE_T]}.make_cast (a_vstate))
			l_state.item.iter := 0
			Result := 0
		end

	vector_bfgs2_restart_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent vector_bfgs2_restart)
		end

	vector_bfgs2_iterate (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [REAL_64]; a_gradient: CE_POINTER [PD_GSL_VECTOR]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_state: CE_POINTER [PD_VECTOR_BFGS2_STATE_T]
			l_alpha: REAL_64
			l_alpha1: REAL_64
			l_x0: CE_POINTER [PD_GSL_VECTOR]
			l_g0: CE_POINTER [PD_GSL_VECTOR]
			l_p: CE_POINTER [PD_GSL_VECTOR]
			l_g0norm: REAL_64
			l_pnorm: REAL_64
			l_delta_f: REAL_64
			l_pg: REAL_64
			l_dir: REAL_64
			l_status: INTEGER_32
			l_f0: REAL_64
			l_del: REAL_64
			l_dx0: CE_POINTER [PD_GSL_VECTOR]
			l_dg0: CE_POINTER [PD_GSL_VECTOR]
			l_dxg: REAL_64
			l_dgg: REAL_64
			l_dxdg: REAL_64
			l_dgnorm: REAL_64
			l_A___0: REAL_64
			l_B: REAL_64
			js: JUMP_STATE
		do
			create l_state.make
			create l_x0.make
			create l_g0.make
			create l_p.make
			create l_dx0.make
			create l_dg0.make

			l_state.ce_gets (create {CE_POINTER [PD_VECTOR_BFGS2_STATE_T]}.make_cast (a_vstate))
			l_alpha := 0.0
			l_x0.ce_gets (l_state.item.x0)
			l_g0.ce_gets (l_state.item.g0)
			l_p.ce_gets (l_state.item.p)
			l_g0norm := l_state.item.g0norm
			l_pnorm := l_state.item.pnorm
			l_delta_f := l_state.item.delta_f
			l_f0 := a_f.item
			if l_pnorm = 0.0 then
				init_source_inst.gsl_vector_set_zero (a_dx)
				Result := 27
				js.return
			elseif l_g0norm = 0.0 then
				init_source_inst.gsl_vector_set_zero (a_dx)
				Result := 27
				js.return
			elseif l_state.item.fp0 = (0).to_double then
				init_source_inst.gsl_vector_set_zero (a_dx)
				Result := 27
				js.return
			end
			if not js.return_called then
				if l_delta_f < (0).to_double then
					l_del := (gsl_gsl_minmax_inst.GSL_MAX_DBL (-l_delta_f, ((10).to_double * 2.2204460492503131e-16) * (fabs (l_f0))))
					l_alpha1 := gsl_gsl_minmax_inst.GSL_MIN_DBL (1.0, (2.0 * l_del) / -l_state.item.fp0)
				else
					l_alpha1 := fabs (l_state.item.step)
				end
				l_status := linear_minimize_inst.minimize___2 (create {CE_POINTER [PD_GSL_FUNCTION_FDF_STRUCT]}.make_shared (l_state.c_pointer + {PD_VECTOR_BFGS2_STATE_T}.wrap_offset + {PD_WRAPPER_T}.fdf_linear_offset), l_state.item.rho, l_state.item.sigma, l_state.item.tau1, l_state.item.tau2, l_state.item.tau3, l_state.item.order, l_alpha1, create {CE_POINTER [REAL_64]}.make_shared ($l_alpha))
				if l_status /= 0 then
					Result := l_status
					js.return
				end
			end
			if not js.return_called then
				linear_wrapper_inst.update_position (create {CE_POINTER [PD_WRAPPER_T]}.make_shared (l_state.c_pointer + {PD_VECTOR_BFGS2_STATE_T}.wrap_offset), l_alpha, a_x, a_f, a_gradient)
				l_state.item.delta_f := a_f.item - l_f0
				l_dx0.ce_gets (l_state.item.dx0)
				l_dg0.ce_gets (l_state.item.dg0)
				copy_source_inst.gsl_vector_memcpy (l_dx0, a_x).do_nothing
				blas_inst.gsl_blas_daxpy (-1.0, l_x0, l_dx0).do_nothing
				copy_source_inst.gsl_vector_memcpy (a_dx, l_dx0).do_nothing
				copy_source_inst.gsl_vector_memcpy (l_dg0, a_gradient).do_nothing
				blas_inst.gsl_blas_daxpy (-1.0, l_g0, l_dg0).do_nothing
				blas_inst.gsl_blas_ddot (l_dx0, a_gradient, create {CE_POINTER [REAL_64]}.make_shared ($l_dxg)).do_nothing
				blas_inst.gsl_blas_ddot (l_dg0, a_gradient, create {CE_POINTER [REAL_64]}.make_shared ($l_dgg)).do_nothing
				blas_inst.gsl_blas_ddot (l_dx0, l_dg0, create {CE_POINTER [REAL_64]}.make_shared ($l_dxdg)).do_nothing
				l_dgnorm := blas_inst.gsl_blas_dnrm2 (l_dg0)
				if l_dxdg /= (0).to_double then
					l_B := l_dxg / l_dxdg
					l_A___0 := -(1.0 + (l_dgnorm * l_dgnorm) / l_dxdg) * l_B + l_dgg / l_dxdg
				else
					l_B := (0).to_double
					l_A___0 := (0).to_double
				end
				copy_source_inst.gsl_vector_memcpy (l_p, a_gradient).do_nothing
				blas_inst.gsl_blas_daxpy (-l_A___0, l_dx0, l_p).do_nothing
				blas_inst.gsl_blas_daxpy (-l_B, l_dg0, l_p).do_nothing
				copy_source_inst.gsl_vector_memcpy (l_g0, a_gradient).do_nothing
				copy_source_inst.gsl_vector_memcpy (l_x0, a_x).do_nothing
				l_state.item.g0norm := blas_inst.gsl_blas_dnrm2 (l_g0)
				l_state.item.pnorm := blas_inst.gsl_blas_dnrm2 (l_p)
				blas_inst.gsl_blas_ddot (l_p, a_gradient, create {CE_POINTER [REAL_64]}.make_shared ($l_pg)).do_nothing
				if l_pg >= 0.0 then
					l_dir := -1.0
				else
					l_dir := 1.0
				end
				blas_inst.gsl_blas_dscal (l_dir / l_state.item.pnorm, l_p)
				l_state.item.pnorm := blas_inst.gsl_blas_dnrm2 (l_p)
				blas_inst.gsl_blas_ddot (l_p, l_g0, create {CE_POINTER [REAL_64]}.make_shared (l_state.c_pointer + {PD_VECTOR_BFGS2_STATE_T}.fp0_offset)).do_nothing
				linear_wrapper_inst.change_direction (create {CE_POINTER [PD_WRAPPER_T]}.make_shared (l_state.c_pointer + {PD_VECTOR_BFGS2_STATE_T}.wrap_offset))
				Result := 0
			end
		end

	vector_bfgs2_iterate_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent vector_bfgs2_iterate)
		end

end
