class
	P_ZGERC

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_zgerc (a_order: INTEGER_32; a_M: INTEGER_32; a_N: INTEGER_32; a_alpha: CE_POINTER [ANY]; a_X: CE_POINTER [ANY]; a_incX: INTEGER_32; a_Y: CE_POINTER [ANY]; a_incY: INTEGER_32; a_A___0: CE_POINTER [ANY]; a_lda: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_alpha_real: REAL_64
			l_alpha_imag: REAL_64
			l_ix: INTEGER_32
			l_tmp: INTEGER_32
			l_X_real: REAL_64
			l_X_imag: REAL_64
			l_tmp_real: REAL_64
			l_tmp_imag: REAL_64
			l_jy: INTEGER_32
			l_tmp___0: INTEGER_32
			l_Y_real: REAL_64
			l_Y_imag: REAL_64
			l_jy___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_Y_real___0: REAL_64
			l_Y_imag___0: REAL_64
			l_tmp_real___0: REAL_64
			l_tmp_imag___0: REAL_64
			l_ix___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_X_real___0: REAL_64
			l_X_imag___0: REAL_64
			js: JUMP_STATE
		do
			l_alpha_real := create {CE_POINTER [REAL_64]}.make_cast (a_alpha)[0]
			l_alpha_imag := create {CE_POINTER [REAL_64]}.make_cast (a_alpha)[1]
			if a_order.to_natural_32 = {NATURAL_32} 101 then
				if a_incX > 0 then
					l_tmp := 0
				else
					l_tmp := (a_M - 1) * -a_incX
				end
				l_ix := l_tmp
				l_i := 0
				from
				until
					not (not js.loop_left and then (l_i < a_M))
				loop
					l_X_real := create {CE_POINTER [REAL_64]}.make_cast (a_X)[2 * l_ix]
					l_X_imag := create {CE_POINTER [REAL_64]}.make_cast (a_X)[(2 * l_ix + 1)]
					l_tmp_real := l_alpha_real * l_X_real - l_alpha_imag * l_X_imag
					l_tmp_imag := l_alpha_imag * l_X_real + l_alpha_real * l_X_imag
					if a_incY > 0 then
						l_tmp___0 := 0
					else
						l_tmp___0 := (a_N - 1) * -a_incY
					end
					l_jy := l_tmp___0
					l_j := 0
					from
					until
						not (l_j < a_N)
					loop
						l_Y_real := create {CE_POINTER [REAL_64]}.make_cast (a_Y)[2 * l_jy]
						l_Y_imag := (-create {CE_POINTER [REAL_64]}.make_cast (a_Y)[(2 * l_jy + 1)])
						create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (a_lda * l_i + l_j)] := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (a_lda * l_i + l_j)] + (l_Y_real * l_tmp_real - l_Y_imag * l_tmp_imag)
						create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_j) + 1)] := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_j) + 1)] + (l_Y_imag * l_tmp_real + l_Y_real * l_tmp_imag)
						l_jy := l_jy + a_incY
						l_j := l_j + 1
					end
					l_ix := l_ix + a_incX
					l_i := l_i + 1
				end
			elseif a_order.to_natural_32 = {NATURAL_32} 102 then
				if a_incY > 0 then
					l_tmp___1 := 0
				else
					l_tmp___1 := (a_N - 1) * -a_incY
				end
				l_jy___0 := l_tmp___1
				l_j := 0
				from
				until
					not (not js.loop_left and then (l_j < a_N))
				loop
					l_Y_real___0 := create {CE_POINTER [REAL_64]}.make_cast (a_Y)[2 * l_jy___0]
					l_Y_imag___0 := (-create {CE_POINTER [REAL_64]}.make_cast (a_Y)[(2 * l_jy___0 + 1)])
					l_tmp_real___0 := l_alpha_real * l_Y_real___0 - l_alpha_imag * l_Y_imag___0
					l_tmp_imag___0 := l_alpha_imag * l_Y_real___0 + l_alpha_real * l_Y_imag___0
					if a_incX > 0 then
						l_tmp___2 := 0
					else
						l_tmp___2 := (a_M - 1) * -a_incX
					end
					l_ix___0 := l_tmp___2
					l_i := 0
					from
					until
						not (l_i < a_M)
					loop
						l_X_real___0 := create {CE_POINTER [REAL_64]}.make_cast (a_X)[2 * l_ix___0]
						l_X_imag___0 := create {CE_POINTER [REAL_64]}.make_cast (a_X)[(2 * l_ix___0 + 1)]
						create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (l_i + a_lda * l_j)] := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[2 * (l_i + a_lda * l_j)] + (l_X_real___0 * l_tmp_real___0 - l_X_imag___0 * l_tmp_imag___0)
						create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[(2 * (l_i + a_lda * l_j) + 1)] := create {CE_POINTER [REAL_64]}.make_cast (a_A___0)[(2 * (l_i + a_lda * l_j) + 1)] + (l_X_imag___0 * l_tmp_real___0 + l_X_real___0 * l_tmp_imag___0)
						l_ix___0 := l_ix___0 + a_incX
						l_i := l_i + 1
					end
					l_jy___0 := l_jy___0 + a_incY
					l_j := l_j + 1
				end
			else
				xerbla_inst.cblas_xerbla ([0, ce_string ("source_gerc.h"), ce_string ("unrecognized operation")])
			end
		end

end
